--# -path=.:../finnish/stemmed:../finnish:../abstract:../common:../finnish/kotus:../api
---- checked by AR till beginning_N in the BNC order
concrete DictionaryFin of Dictionary = CatFin ** open ParadigmsFin,
  (S = StructuralFin),
  (Syntax = SyntaxFin),
  (L = LexiconFin),
  (R = ResFin),
  MorphoFin, ParadigmsFin, (E = ExtraFin), Kotus, WNKotus, StemFin, Prelude in {

flags coding=utf8 ; 

oper tehda_V = mkV (lin VK {s = c71 "tehdä"}) ; 
oper nahda_V = mkV (lin VK {s = c71 "nähdä"}) ; 
oper optProDrop : Pron -> Pron = \p -> p | E.ProDrop p ;
oper luokse_Prep : Prep = mkPrep "luokse" ; -- to enable (luo|luokse)-luokseni
oper adjAdv : A -> Adv = \a -> Syntax.mkAdv a ;

  mika_NForms : R.NForm => Str =
    let
      mi  = snoun2nounBind (mkN "mi")
    in
    table {
       NCase Sg Nom  => "mikä" ;
       NCase Pl Nom  => "mitkä" ;
       NCase _ Gen   => "minkä" ;
       NCase _ Part  => "mitä" ;
       NCase _ Illat => "mihin" ;
       c => mi.s ! c
       } ;
 
  year_alt_N = mkN "vuosi" "vuoden" "vuotta" "vuonna" "vuoteen" "vuosien" "vuosia" "vuosina" "vuosissa" "vuosiin" ; --alternative form of essive


lin a_fortiori_Adv = mkWAdv "suuremmalla" "syyllä" ; --UNCHK
lin a_la_carte_Adv = mkWAdv "a" "la" "carte" ; --UNCHK
lin a_la_mode_Adv = mkWAdv (k99 "kera") "jäätelön" ; --UNCHK
lin a_level_N = mkWN (compoundN "päättö" (k1A "tutkinto")) "lukion" ; --UNCHK
lin a_posteriori_A = mkWA (compoundA "posteri" (k48 "ori")) "a" ; --UNCHK
lin a_posteriori_Adv = mkWAdv (compoundAdv "posteri" (k48 "ori")) "a" ; --UNCHK
lin a_priori_A = mkWA (k38 "apriorinen") ; --UNCHK
lin a_priori_Adv = mkWAdv (k99 "ennalta") ; --UNCHK
lin aa_N = mkWN "AA" ; --UNCHK
lin aachen_PN = foreignPN "Aachen" ;
lin aalii_N = mkWN "aalii" ; --UNCHK
lin aardvark_N = mkWN (compoundN "muurahais" (k1 "karhu")) ; --UNCHK
lin aardwolf_N = mkWN (compoundN "maa" (k27 "susi")) ; --UNCHK
lin ab_initio_Adv = mkWAdv (k99 "aluksi") ; --UNCHK
lin aba_N = mkWN (k41A "vuohenvillakangas") ; --UNCHK
lin abaca_N = mkWN (k13 "manila") ; --UNCHK
lin aback_Adv = mkWAdv (compoundAdv "ällisty" (k99 "nyt")) ; --UNCHK
lin abactinal_A = mkWA (compoundA "abaktina" (k38 "alinen")) ; --UNCHK
lin abacus_N = mkWN (compoundN "helmi" (k1 "taulu")) ; --UNCHK
lin abaft_Adv = mkWAdv (k99 "taakse") ; --UNCHK
lin abalone_N = mkWN (compoundN "punameri" (k10 "korva")) ; --UNCHK
lin abandon_N = mkWN (k40 "estottomuus") ; --UNCHK
lin abandon_V2 = mkWV2 (k73A "hylätä") ; --f62
lin abandonment_N = mkWN "hylkääminen" ; --UNCHK
lin abarticulation_N = mkWN (compoundN "sijoiltaan" (k1 "meno")) ; --UNCHK
lin abase_V2 = mkWV2 (k54A "alentaa") ; --UNCHK
lin abasement_N = mkWN (k39 "nöyryytys") ; --UNCHK
lin abash_V2 = mkWV2 (k56A "saattaa") "häpeilemään" ; --UNCHK
lin abashment_N = mkWN (k40 "ujous") ; --UNCHK
lin abasia_N = mkWN (compoundN "kävely" (k40 "kyvyttömyys")) ; --UNCHK
lin abasic_A = mkWA (compoundA "kävely" (k34A "kyvytön")) ; --UNCHK
lin abatable_A = mkWA (k10 "oleva") "poistettavissa" ; --UNCHK
lin abate_V = mkWV (k52A "vähentyä") ;
lin abate_V2 = mkWV2 (k52A "vähentyä") ; --UNCHK
lin abatement_N = mkWN (compoundN "ale" (k38 "ntaminen")) ; --UNCHK
lin abator_N = mkWN "pienentäjä" ; --UNCHK
lin abattis_N = mkWN (k39 "murros") ; --UNCHK
lin abattoir_N = mkWN (k2 "teurastamo") ; --UNCHK
lin abaxial_A = mkWA (compoundA "selän" (k38 "puoleinen")) ; --UNCHK
lin abaya_N = mkWN "abaya" ; --UNCHK
lin abbacy_N = mkWN (compoundN "tuomio" (k9A "valta")) "apotin" ; --UNCHK
lin abbatial_A = mkWA "luostarin" ; --UNCHK
lin abbe_N = mkWN (k5A "pappi") ; --UNCHK
lin abbess_N = mkWN (k9 "abbedissa") ; --UNCHK
lin abbey_N = mkWN (k6 "luostari") ; --UNCHK
lin abbot_N = mkWN (k9A "arkkimandriitta") ; --UNCHK
lin abbreviate_V2 = mkWV2 (k54A "lyhentää") ; --UNCHK
lin abbreviation_N = mkWN "lyhentäminen" ; --UNCHK
lin abc_N = mkWN (k5A "rudimentti") ; --UNCHK
lin abcoulomb_N = mkWN "abcoulombi" ; --UNCHK
lin abdicable_A = mkWA (k10 "oleva") "luovutettavissa" ; --UNCHK
lin abdicate_V = mkWV (k52A "luopua") ; --UNCHK
lin abdicate_V2 = mkWV2 (k52A "luopua") ; --UNCHK
lin abdication_N = mkWN (compoundN "luo" (k38 "puminen")) ; --UNCHK
lin abdicator_N = mkWN "luopuja" ; --UNCHK
lin abdomen_N = mkWN (k9 "maha") ; --UNCHK
lin abdominal_A = mkWA (compoundA "abdomina" (k38 "alinen")) ; --UNCHK
lin abdominal_N = mkWN (compoundN "vatsa" (k39 "lihas")) ; --UNCHK
lin abdominocentesis_N = mkWN (compoundN "parasen" (k5 "teesi")) ; --UNCHK
lin abdominoplasty_N = mkWN (compoundN "muotoilu" (k39 "leikkaus")) "vatsan" ; --UNCHK
lin abdominous_A = mkWA (k41A "vatsakas") ; --UNCHK
lin abdominousness_N = mkWN (k40 "vatsakkuus") ; --UNCHK
lin abdominovesical_A = mkWA (compoundA "abdominaalivesika" (k38 "alinen")) ; --UNCHK
lin abducent_A = mkWA "loitontava" ; --UNCHK
lin abducent_N = mkWN (compoundN "aivo" (k1 "hermo")) "kuudes" ; --UNCHK
lin abduct_V2 = mkWV2 (k54A "loitontaa") ; --UNCHK
lin abduction_N = mkWN (k39 "loitonnus") ; --UNCHK
lin abeam_Adv = mkWAdv (k99 "kyljittäin") ; --UNCHK
lin abecedarian_A = mkWA (k38 "aakkosellinen") ; --UNCHK
lin abecedarian_N = mkWN (compoundN "ana" (k5 "baptisti")) ; --UNCHK
lin abecedarius_N = mkWN (compoundN "aakkos" (k1 "runo")) ; --UNCHK
lin abed_Adv = mkWAdv (k9 "vuoteenomana") ; --UNCHK
lin abelia_N = mkWN "abelia" ; --UNCHK
lin abelmosk_N = mkWN (compoundN "myski" (k9 "malva")) ; --UNCHK
lin abercarn_PN = foreignPN "Abercarn" ;
lin aberdare_PN = foreignPN "Aberdare" ;
lin aberdeen_PN = foreignPN "Aberdeen" ;
lin abergavenny_PN = foreignPN "Abergavenny" ;
lin abergele_PN = foreignPN "Abergele" ;
lin aberrance_N = mkWN (k48 "virhe") ; --UNCHK
lin aberrant_A = mkWA (k10 "poikkeava") ; --UNCHK
lin aberrant_N = mkWN (k10 "poikkeava") ; --UNCHK
lin aberration_N = mkWN (k10 "poikkeama") "optinen" ; --UNCHK
lin abertillery_PN = foreignPN "Abertillery" ;
lin aberystwyth_PN = foreignPN "Aberystwyth" ;
lin abet_V = mkWV (k53 "avustaa") ; --UNCHK
lin abet_V2 = mkWV2 (k53 "avustaa") ; --UNCHK
lin abetalipoproteinemia_N = mkWN "abeetalipoproteinemia" ; --UNCHK
lin abetment_N = mkWN (k39 "yllytys") ; --UNCHK
lin abettor_N = mkWN (k10 "yllyttäjä") ; --UNCHK
lin abeyance_N = mkWN (k39 "jäädytys") ; --UNCHK
lin abeyant_A = mkWA (compoundA "nuk" (k10 "kuva")) ; --UNCHK
lin abfarad_N = mkWN "abfaradi" ; --UNCHK
lin abhenry_N = mkWN "abhenry" ; --UNCHK
lin abhor_V2 = mkWV2 (k73 "vihata") ; --UNCHK
lin abhorrence_N = mkWN (k39 "iljetys") ; --UNCHK
lin abhorrent_A = mkWA (k10 "luotaantyöntävä") ; --UNCHK
lin abhorrer_N = mkWN "inhoaja" ; --UNCHK
lin abidance_N = mkWN "kestäminen" ; --UNCHK
lin abide_V = mkWV (k69 "suvaita") ; --UNCHK
lin abide_V2 = mkWV2 (k69 "suvaita") ; --UNCHK
lin abide_by_V2 = mkWV2 (k53A "kunnioittaa") ; --UNCHK
lin abience_N = mkWN "abienssi" ; --UNCHK
lin abient_A = mkWA (compoundA "abi" (k38 "enttinen")) ; --UNCHK
lin ability_N = mkN "kyky" ;
lin abingdon_PN = foreignPN "Abingdon" ;
lin abiogenesis_N = mkWN (compoundN "alku" (k1A "synty")) ; --UNCHK
lin abiogenetic_A = mkWA (compoundA "abio" (k38 "geneettinen")) ; --UNCHK
lin abiogenist_N = mkWN (k10 "uskova") "alkusyntyyn" ; --UNCHK
lin abiotrophy_N = mkWN "abiotrofia" ; --UNCHK
lin abject_A = mkWA (compoundA "nöyriste" (k10 "levä")) ; --UNCHK
lin abjection_N = mkWN (k3 "rappio") ; --UNCHK
lin abjuration_N = mkWN (compoundN "per" (k38 "uminen")) ; --UNCHK
lin abjure_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin abjurer_N = mkWN (k10 "kieltäjä") ; --UNCHK
lin ablactation_N = mkWN (k39 "vieroitus") ; --UNCHK
lin ablated_A = mkWA (compoundA "sula" (k47 "nut")) ; --UNCHK
lin ablation_N = mkWN (compoundN "pois" (k38 "leikkaaminen")) ; --UNCHK
lin ablative_A = mkWA (compoundA "ablatiivi" (k38 "nen")) ; --UNCHK
lin ablative_N = mkWN (k5 "ablatiivi") ; --UNCHK
lin ablaut_N = mkWN "äänteenmukaus" ; --UNCHK
lin ablaze_A = mkWA (compoundA "heh" (k10 "kuva")) ; --UNCHK
lin able_A = mkA "kykenevä" ;
lin ableism_N = mkWN (k9A "syrjintä") "vammaisten" ; --UNCHK
lin ablepharia_N = mkWN (compoundN "puu" (k38 "ttuminen")) "silmäluomien" "synnynnäinen" ; --UNCHK
lin abloom_A = mkWA (compoundA "kuk" (k9 "kiva")) ; --UNCHK
lin ablution_N = mkWN "peseytyminen" ; --UNCHK
lin ablutionary_A = mkWA "puhdistautumis-" ; --UNCHK
lin abnegation_N = mkWN (k39 "kieltäymys") ; --UNCHK
lin abnegator_N = mkWN (k10 "luovuttaja") ; --UNCHK
lin abnormal_A = mkWA (k10 "poikkeava") ; --UNCHK
lin abnormality_N = mkWN (k40 "poikkeavuus") ; --UNCHK
lin abo_N = mkWN (k5 "aboriginaali") "Australian" ; --UNCHK
lin aboard_Adv = mkWAdv (k10 "pesässä") ; --UNCHK
lin aboard_Prep = mkPrep "kannella" ;
lin abocclusion_N = mkWN "abokkluusio" ; --UNCHK
lin abode_N = mkWN (k1A "asunto") ; --UNCHK
lin abohm_N = mkWN "abohmi" ; --UNCHK
lin abolish_V2 = mkWV2 (k53A "lopettaa") ; --UNCHK
lin abolishable_A = mkWA (k10 "oleva") "poistettavissa" ; --UNCHK
lin abolition_N = mkWN (compoundN "lakka" (k38 "uttaminen")) "orjuuden" ; --UNCHK
lin abolitionary_A = mkWA "lakkautus-" ; --UNCHK
lin abolitionism_N = mkWN (compoundN "abolition" (k5 "ismi")) ; --UNCHK
lin abolitionist_N = mkWN (k10 "kannattaja") "emansipaation" ; --UNCHK
lin abomasal_A = mkWA "juoksutusmahan" ; --UNCHK
lin abomasum_N = mkWN (k9 "vatsa") "neljäs" ; --UNCHK
lin abominable_A = mkWA (k38 "tuskallinen") ; --UNCHK
lin abominate_V2 = mkWV2 (k73 "vihata") ; --UNCHK
lin abomination_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin abominator_N = mkWN (k10 "vihaaja") ; --UNCHK
lin aborad_Adv = mkWAdv "aboradisesti" ; --UNCHK
lin aboral_A = mkWA (compoundA "abora" (k38 "alinen")) ; --UNCHK
lin aboriginal_A = mkWA (k5 "aboriginaali") ; --UNCHK
lin aborigine_N = mkWN (compoundN "alku" (k41A "asukas")) ; --UNCHK
lin abort_N = mkWN (k39 "keskeytys") ; --UNCHK
lin abort_V = mkWV (k71 "tehdä") "abortti" ; --UNCHK
lin abort_V2 = mkWV2 (k71 "tehdä") "abortti" ; --UNCHK
lin aborticide_N = mkWN (compoundN "raskauden" (k39 "keskeytys")) ; --UNCHK
lin abortifacient_A = mkWA "keskenmenon" "aiheuttava" ; --UNCHK
lin abortifacient_N = mkWN (k48 "aine") "keskenmenon" "aiheuttava" ; --UNCHK
lin abortion_N = mkWN (k5A "abortti") ;
lin abortionistFem_N = mkWN "sikiönlähdettäjä" ; --UNCHK
lin abortionistMasc_N = mkWN "sikiönlähdettäjä" ; --UNCHK
lin abortive_A = mkWA (k10 "turha") ; --UNCHK
lin abortus_N = mkWN (k3 "sikiö") "abortoitu" ; --UNCHK
lin abound_V = caseV partitive (mkV vOlla "runsaasti") ;
lin about_AdN = mkAdN "noin" ;
lin about_Adv = mkAdv "suunnilleen" ;
lin about_Prep = casePrep elative ;
lin above_A = mkWA (compoundA "main" (k1 "ittu")) "edellä" ; --UNCHK
lin above_Adv = mkAdv "yläpuolella" ;
lin above_N = mkWN (compoundN "main" (k1 "ittu")) "yllä" ; --UNCHK
lin above_Prep = S.above_Prep ;
lin above_board_A = mkA "avoin" ;
lin aboveboard_A = mkWA (k34A "vilpitön") ; --UNCHK
lin aboveground_A = mkWA (k99 "päällä") "maan" ; --UNCHK
lin abracadabra_N = mkWN (compoundN "hölyn" (k1 "pöly")) ; --UNCHK
lin abrachia_N = mkWN "abrakia" ; --UNCHK
lin abrade_V2 = mkWV2 (k73A "hangata") ; --UNCHK
lin abrader_N = mkWN (compoundN "hioma-" (k48 "aine")) ; --UNCHK
lin abranchiate_A = mkWA "kidukseton" ; --UNCHK
lin abrasion_N = mkWN (compoundN "han" (k38 "kautuminen")) ; --UNCHK
lin abrasive_A = mkWA (k1 "tyly") ; --UNCHK
lin abrasive_N = mkWN (compoundN "hankaus" (k48 "aine")) ; --UNCHK
lin abrasiveness_N = mkWN (k40 "ikävyys") ; --UNCHK
lin abreast_Adv = mkWAdv (k99 "vierekkäin") ; --UNCHK
lin abridge_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin abridgement_N = mkWN (k10 "lyhennelmä") ; --UNCHK
lin abridger_N = mkWN "lyhentäjä" ; --UNCHK
lin abroach_A = mkWA (k10 "oleva") "avattuna" ; --UNCHK
lin abroad_A = mkWA (k38 "ulkomainen") ; --UNCHK
lin abroad_Adv = mkWAdv "ulkomailla" ; --f56
lin abrocome_N = mkWN (compoundN "rotta" (k9 "chinchilla")) ; --UNCHK
lin abrogate_V2 = mkWV2 (k53A "lopettaa") ; --UNCHK
lin abrogation_N = mkWN (compoundN "pois" (k38 "taminen")) ; --UNCHK
lin abrogator_N = mkWN "poistaja" ; --UNCHK
lin abrupt_A = mkWA (k15 "karkea") ; --UNCHK
lin abruptness_N = mkWN (k40 "karkeus") ; --UNCHK
lin abscess_N = mkWN (k39 "ajos") ; --UNCHK
lin abscessed_A = mkWA "märkivä" ; --UNCHK
lin abscissa_N = mkWN (k9 "abskissa") ; --UNCHK
lin abscission_N = mkWN (compoundN "lei" (k38 "kkaaminen")) "irti" ; --UNCHK
lin abscond_V = mkWV (k60A "lähteä") "tiehensä" ; --UNCHK
lin absconder_N = mkWN (k38 "karkulainen") ; --UNCHK
lin abscondment_N = mkWN (k1A "pako") ; --UNCHK
lin abseiler_N = mkWN "laskeutuja" ; --UNCHK
lin absence_N = mkN "poissaolo" ; --WN (compoundN "jää" (k38 "minen")) "saapumatta" ;
lin absent_A = mkWA (compoundA "poissa" (k10 "oleva")) ; --UNCHK
lin absent_Prep = mkPrep "poissa" elative ;
lin absent_V2 = mkWV2 (k60A "lähteä") ; --UNCHK
lin absentee_N = mkWN (compoundN "poissa" (k12 "olija")) ; --UNCHK
lin absenteeism_N = mkWN (compoundN "poissa" (k1 "olo")) "toistuva" ; --UNCHK
lin absentmindedness_N = mkWN (compoundN "hajamiel" (k40 "isyys")) ; --UNCHK
lin absinthe_N = mkWN (k5A "absintti") ; --UNCHK
lin absolute_A = mkA "ehdoton" | mkA "absoluuttinen" ;
lin absolute_N = mkWN (k5A "absoluutti") ; --UNCHK
lin absoluteness_N = mkWN (k40 "ehdottomuus") ; --UNCHK
lin absolution_N = mkWN (compoundN "anteeksi" (k1A "anto")) "synnin" ; --UNCHK
lin absolutism_N = mkWN (k5 "absolutismi") ; --UNCHK
lin absolutist_A = mkWA (compoundA "yksin" (k38 "valtainen")) ; --UNCHK
lin absolutist_N = mkWN (k5 "absolutisti") ; --UNCHK
lin absolve_V2 = mkWV2 (k53 "päästää") "vapaaksi" ; --UNCHK
lin absolver_N = mkWN (k10 "antaja") "synninpäästön" ; --UNCHK
lin absolvitory_A = mkWA (k10 "anteeksiantava") ; --UNCHK
lin absorb_V2 = mkV2 "imeä" ;
lin absorbable_A = mkWA (k10 "oleva") "imeytettävissä" ; --UNCHK
lin absorbefacient_A = mkWA "sorptiota" "edistävä" ; --UNCHK
lin absorbency_N = mkWN (compoundN "imu" (k1A "kyky")) ; --UNCHK
lin absorbent_A = mkWA (compoundA "absorptioky" (k38 "kyinen")) ; --UNCHK
lin absorbent_N = mkWN (k48 "aine") "absorboiva" ; --UNCHK
lin absorbing_A = mkWA (k10 "mukaansatempaava") ; --UNCHK
lin absorption_N = mkWN (compoundN "päähän" (k10 "piintymä")) ; --UNCHK
lin absorptivity_N = mkWN (k33A "absorptiokerroin") ; --UNCHK
lin abstain_V = mkWV (k52A "pidättäytyä") ; --UNCHK
lin abstainer_N = mkWN (k38 "ihminen") "raitis" ; --UNCHK
lin abstemious_A = mkWA (k10 "pidättyvä") ; --UNCHK
lin abstemiousness_N = mkWN (k40 "kohtuullisuus") ; --UNCHK
lin abstention_N = mkWN (k40 "pidättyvyys") ; --UNCHK
lin abstinence_N = mkWN (k40 "pidättyvyys") ; --UNCHK
lin abstinent_A = mkWA (k10 "pidättyvä") ; --UNCHK
lin abstract_A = mkWA (k38 "käsitteellinen") ; --UNCHK
lin abstract_N = mkWN (k3 "abstraktio") ; --UNCHK
lin abstract_V2 = mkWV2 (k62 "abstrahoida") ; --UNCHK
lin abstractedness_N = mkWN (compoundN "keskittyne" (k40 "isyys")) ; --UNCHK
lin abstraction_N = mkWN (k5A "entiteetti") "abstrakti" ; --UNCHK
lin abstractionism_N = mkWN (k48A "taide") "abstrakti" ; --UNCHK
lin abstractionist_N = mkWN (k12 "taiteilija") "abstrakti" ; --UNCHK
lin abstractive_A = mkWA (compoundA "abstr" (k38 "aktiivinen")) ; --UNCHK
lin abstractness_N = mkWN (k40 "abstraktius") ; --UNCHK
lin abstractor_N = mkWN (k12 "laatija") "abstraktin" ; --UNCHK
lin abstruse_A = mkWA (k38 "vaikeaselkoinen") ; --UNCHK
lin abstruseness_N = mkWN (compoundN "vaikea" (k40 "tajuisuus")) ; --UNCHK
lin absurd_A = mkWA (k34A "mahdoton") ; --UNCHK
lin absurd_N = mkWN (k40 "absurdius") ; --UNCHK
lin absurdity_N = mkWN (k40 "mielettömyys") ; --UNCHK
lin abulia_N = mkWN (compoundN "tahdon" (k40 "heikkous")) ; --UNCHK
lin abulic_A = mkWA (k34A "tahdoton") ; --UNCHK
lin abundance_N = mkWN (k40 "paljous") ; --UNCHK
lin abundant_A = mkWA (k41 "runsas") ;
lin abuse_N = mkN "väärinkäyttö" ; --C "hyväksikäyttö" ;
lin abuse_V2 = mkWV2 (k53A "käyttää") "väärin" ; ---ARB --mkV2 "solvata" partitive ; --mkV2 (mkV (mkV "käyttää") "hyväkseen") partitive ;
lin abuser_N = mkWN (k12 "pahoinpitelijä") ; --UNCHK
lin abusive_A = mkWA "pahoin" "kohteleva" ; --UNCHK
lin abut_V = mkWV (k52A "liittyä") "päittäin" ; --UNCHK
lin abutment_N = mkWN (compoundN "tuki" (k10 "pohja")) ; --UNCHK
lin abutter_N = mkWN (compoundN "raja" (k6 "naapuri")) ; --UNCHK
lin abuzz_A = mkWA "suriseva" ; --UNCHK
lin abvolt_N = mkWN "abvoltti" ; --UNCHK
lin abwatt_N = mkWN "abwatti" ; --UNCHK
lin abysm_N = mkWN (k1 "kuilu") ; --UNCHK
lin abysmal_A = mkWA (k34A "mittaamaton") ; --UNCHK
lin abyss_N = mkWN (k1 "kuilu") ; --UNCHK
lin abyssal_A = mkWA (compoundA "abyssa" (k38 "alinen")) ; --UNCHK
lin acacia_N = mkWN (k12 "akasia") ; --UNCHK
lin academia_N = mkWN (k13 "maailma") "akateeminen" ; --UNCHK
lin academic_A = mkA (lin AK {s = d38 "akateeminen"}) ;
lin academic_N = mkN (mkN "akateeminen") (mkN "henkilö") ;
lin academicianFem_N = mkWN (k32 "jäsen") "tiedekunnan" ; --UNCHK
lin academicianMasc_N = mkWN (k32 "jäsen") "tiedekunnan" ; --UNCHK
lin academicianship_N = mkWN "kunniatohtorius" ; --UNCHK
lin academy_N = mkWN (k50 "korkeakoulu") ; --UNCHK
lin acanthion_N = mkWN "akantion" ; --UNCHK
lin acanthocephalan_N = mkWN (compoundN "väkä" (k1A "mato")) ; --UNCHK
lin acanthocyte_N = mkWN "akantosyytti" ; --UNCHK
lin acanthocytosis_N = mkWN "akantosytoosi" ; --UNCHK
lin acanthoid_A = mkWA (compoundA "oka" (k38 "mainen")) ; --UNCHK
lin acantholysis_N = mkWN (compoundN "akantoly" (k5 "ysi")) ; --UNCHK
lin acanthoma_N = mkWN (compoundN "iho" (k33 "kasvain")) ; --UNCHK
lin acanthosis_N = mkWN "akantoosi" ; --UNCHK
lin acanthotic_A = mkWA "akantoottinen" ; --UNCHK
lin acanthus_N = mkWN (k5A "akantti") ; --UNCHK
lin acapnic_A = mkWA "akapnoottinen" ; --UNCHK
lin acardia_N = mkWN (compoundN "akar" (k9 "dia")) ; --UNCHK
lin acariasis_N = mkWN (compoundN "punkki" (k5A "tauti")) ; --UNCHK
lin acaricide_N = mkWN (compoundN "punkkientorjunta-" (k48 "aine")) ; --UNCHK
lin acarid_N = mkWN "akaridi" ; --UNCHK
lin acarine_N = mkWN (kH1 "punkki") ; --UNCHK
lin acarophobia_N = mkWN (compoundN "akaro" (k12 "fobia")) ; --UNCHK
lin acarpelous_A = mkWA "emitön" ; --UNCHK
lin acarpous_A = mkWA (k34A "hedelmätön") ; --UNCHK
lin acarus_N = mkWN (kH1 "punkki") ; --UNCHK
lin acatalectic_A = mkWA "akatalektinen" ; --UNCHK
lin acatalectic_N = mkWN "akatalekti" ; --UNCHK
lin acathexia_N = mkWN "akateksia" ; --UNCHK
lin acathexis_N = mkWN "akateksis" ; --UNCHK
lin acaudate_A = mkWA (compoundA "akauda" (k38 "alinen")) ; --UNCHK
lin acaulescent_A = mkWA "varreton" ; --UNCHK
lin accede_V = mkWV (k52 "suostua") ; --UNCHK
lin accelerando_A = mkWA "nopeutuvatempoinen" ; --UNCHK
lin accelerando_Adv = mkWAdv "nopeutuvassa" "tempossa" ; --UNCHK
lin accelerando_N = mkWN (k1 "tempo") "nopeutuva" ; --UNCHK
lin accelerate_V = mkWV (k73 "lisätä") "vauhtia" ; --UNCHK
lin accelerate_V2 = mkV2 "kiihdyttää" ;
lin acceleration_N = mkWN (k39 "kiihdytys") ;
lin accelerative_A = mkWA "nopeuttava" ; --UNCHK
lin accelerator_N = mkWN (k6 "venttiili") "kaasuttimen" ; --UNCHK
lin accelerometer_N = mkWN (compoundN "mittaus" (k48A "laite")) "kiihtyvyyden" ; --UNCHK
lin accent_N = mkWN (k5A "aksentti") ; --UNCHK
lin accent_V2 = mkWV2 (k53A "painottaa") ; --UNCHK
lin accentor_N = mkWN (k38 "rautiainen") ; --UNCHK
lin accentual_A = mkWA "painotusta" "koskeva" ; --UNCHK
lin accentuate_V2 = mkWV2 (k53A "painottaa") ; --UNCHK
lin accentuation_N = mkWN (compoundN "tähde" (k38 "ntäminen")) ; --UNCHK
lin accept_V = mkV "hyväksyä" ;
lin accept_V2 = mkV2 "hyväksyä" ;
lin accept_VS = mkVS (mkV "hyväksyä") ;
lin acceptability_N = mkWN (k40 "hyväksyttävyys") ; --UNCHK
lin acceptable_A = mkWA (k10 "tyydyttävä") ; --UNCHK
lin acceptance_N = mkWN (compoundN "vastaan" (k1A "otto")) ; --UNCHK
lin acceptation_N = mkWN (k10A "hyväksyntä") ; --UNCHK
lin acceptive_A = mkWA (compoundA "hyväk" (k10 "syvä")) ; --UNCHK
lin acceptor_N = mkWN (k10 "tunnustaja") "vekselin" ; --UNCHK
lin access_N = mkWN (k1 "pääsy") ;
lin access_V2 = mkV2 (mkV "päästä") (casePrep illative) ;
lin accessary_A = mkWA (k38 "osallinen") ; --UNCHK
lin accessary_N = mkWN (k38 "osallinen") "rikokseen" ; --UNCHK
lin accessibility_N = mkWN (k40 "saavutettavuus") ; --UNCHK
lin accessible_A = mkWA "päästävä" ; --UNCHK
lin accession_N = mkWN (k1 "nousu") "valtaistuimelle" ; --UNCHK
lin accessional_A = mkWA "virkaanastumis-" ; --UNCHK
lin accessorial_A = mkWA "oheis-" ; --UNCHK
lin accessory_A = mkWA (k10 "kuuluva") ; --UNCHK
lin accessory_N = mkWN (k48 "varuste") ; --UNCHK
lin accidence_N = mkWN (compoundN "taivutus" (k5A "oppi")) ; --UNCHK
lin accident_N = mkN "onnettomuus" | mkN "sattuma" ; ---- split
lin accidental_A = mkWA (k34A "tahaton") ; --UNCHK
lin accidental_N = mkWN (compoundN "etu" (k5A "merkki")) "tilapäinen" ; --UNCHK
lin accipitrine_A = mkWA (compoundA "haukka" (k38 "mainen")) ; --UNCHK
lin acclaim_N = mkWN (k39 "menestys") "suuri" ; --UNCHK
lin acclaim_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin acclamation_N = mkWN (k39 "menestys") "suuri" ; --UNCHK
lin acclimate_V = mkWV (k52A "tottua") "ilmastoon" ; --UNCHK
lin acclimate_V2 = mkWV2 (k52A "tottua") "ilmastoon" ; --UNCHK
lin acclimation_N = mkWN (k3 "akklimatisaatio") ; --UNCHK
lin acclimatization_N = mkWN (k3 "akklimatisaatio") ; --UNCHK
lin acclimatize_V = mkWV (k52A "tottua") "ilmastoon" ; --UNCHK
lin acclimatize_V2 = mkWV2 (k52A "tottua") "ilmastoon" ; --UNCHK
lin acclivitous_A = mkWA "ylöspäin" "viettävä" ; --UNCHK
lin acclivity_N = mkWN (k1 "nousu") ; --UNCHK
lin accolade_N = mkWN (k1A "palkinto") ; --UNCHK
lin accommodate_V = mkWV (k54A "soveltaa") ; --UNCHK
lin accommodate_V2 = mkWV2 (k54A "soveltaa") ; --UNCHK
lin accommodation_N = mkWN (k3 "akkommodaatio") ; --UNCHK
lin accommodational_A = mkWA "mukautumis-" ; --UNCHK
lin accommodative_A = mkWA (k41 "avulias") ; --UNCHK
lin accompaniment_N = mkWN "saattaminen" ; --UNCHK
lin accompanist_N = mkWN (k10 "säestäjä") ; --UNCHK
lin accompany_V2 = mkWV2 (k73 "seurata") ;
lin accomplice_N = mkWN (k38 "osallinen") ; --UNCHK
lin accomplish_V2 = mkWV2 (k56A "saattaa") "voimaan" ; --UNCHK
lin accomplishable_A = mkWA (k10 "oleva") "toteutettavissa" ; --UNCHK
lin accomplishment_N = mkN "saavutus" ; --mkWN (k1A "teko") ;
lin accord_N = mkWN (k12 "harmonia") ; --f65
lin accord_V = mkWV (k73 "määrätä") ; --UNCHK
lin accordance_N = mkWN (compoundN "suo" (k38 "minen")) ; --UNCHK
lin accordant_A = mkWA (k10 "vastaava") ; --UNCHK
lin according_to_Prep = postPrep genitive "mukaan" ;
lin accordingly_Adv = mkWAdv (k99 "asianmukaisesti") ;
lin accordion_N = mkWN (k1A "kurttu") ; --UNCHK
lin accordionist_N = mkWN (k5 "hanuristi") ; --UNCHK
lin accost_V2 = mkWV2 (k67 "ahdistella") ; --UNCHK
lin accouchement_N = mkWN (k39 "synnytys") ; --UNCHK
lin account_N = mkN "selvitys" ;
lin account_V = mkWV (k73 "vastata") ; --f163
lin account_V2 = mkWV2 (k73 "vastata") ; --UNCHK
lin account_for_V2 = mkWV2 (k53A "selittää") ; --UNCHK
lin accountability_N = mkWN (k17 "vastuu") ; --UNCHK
lin accountable_A = mkWA (k10 "oleva") "vastuussa" ; --UNCHK
lin accountancy_N = mkWN (compoundN "laskenta" (k25 "toimi")) ; --UNCHK
lin accountant_N = mkWN (k10 "valvoja") "varainhoidon" ; --UNCHK
lin accountantship_N = mkWN (k10 "asema") "kirjanpitäjän" ; --UNCHK
lin accounting_A = variants {} ; --
lin accounting_N = mkWN (compoundN "laskenta" (k25 "toimi")) ; --UNCHK
lin accoutered_A = mkWA (compoundA "varus" (k1 "tettu")) ; --UNCHK
lin accra_PN = foreignPN "Accra" ;
lin accredit_V2 = mkWV2 (k56A "antaa") "tunnustus" ; --UNCHK
lin accreditation_N = mkWN (k39 "valtuutus") ; --UNCHK
lin accretion_N = mkWN "akresenssi" ; --UNCHK
lin accretionary_A = mkWA "vesijättö-" ; --UNCHK
lin accretive_A = mkWA "yhteen" "kasvava" ; --UNCHK
lin accrington_PN = foreignPN "Accrington" ;
lin accrue_V = mkWV (k56 "kasvaa") ; --UNCHK
lin accrue_V2 = mkWV2 (k56 "kasvaa") ; --UNCHK
lin acculturation_N = mkWN (k3 "sosialisaatio") ; --UNCHK
lin acculturational_A = mkWA (compoundA "akku" (k38 "lturatiivinen")) ; --UNCHK
lin accumbent_A = mkWA (compoundA "mak" (k9 "aava")) ; --UNCHK
lin accumulate_V = mkWV (k52A "kertyä") ; --UNCHK
lin accumulate_V2 = mkV2 "kerryttää" partitive ;
lin accumulation_N = mkN "kertyminen" ;
lin accumulative_A = mkWA "kasautumis-" ; --UNCHK
lin accumulator_N = mkWN (k6 "rekisteri") ; --UNCHK
lin accuracy_N = mkWN (k40 "totuus") ; --UNCHK
lin accurate_A = mkWA (k34A "virheetön") ; --UNCHK
lin accursed_A = mkWA (k10 "mokoma") ; --UNCHK
lin accurst_A = mkWA (k10 "mokoma") ; --UNCHK
lin accusation_N = mkWN (k39 "syytös") ; --UNCHK
lin accusative_A = mkWA "akkusatiivi-" ; --UNCHK
lin accusative_N = mkWN (k9 "sija") "objektin" ; --UNCHK
lin accusatorial_A = mkWA (compoundA "syy" (k38 "tepohjainen")) ; --UNCHK
lin accuse_V2 = mkWV2 (k53A "syyttää") "rikoksesta" ; --f79
lin accused_A = mkA "syytetty" ;
lin accused_N = mkWN (k10 "vastaaja") ; --UNCHK
lin accuserFem_N = mkWN (k10 "syyttäjä") ; --UNCHK
lin accuserMasc_N = mkWN (k10 "syyttäjä") ; --UNCHK
lin accusingly_Adv = mkWAdv "syyttävästi" ; --UNCHK
lin accustom_V2 = mkWV2 (k53A "sopeuttaa") ; --UNCHK
lin ace_A = mkWA (k38 "erinomainen") ; --UNCHK
lin ace_N = mkWN (compoundN "läpi" (k1A "syöttö")) ; --UNCHK
lin acebutolol_N = mkWN "Sectral" ; --UNCHK
lin acentric_A = mkWA (compoundA "ase" (k38 "ntrinen")) ; --UNCHK
lin acephalia_N = mkWN "akefalia" ; --UNCHK
lin acephalous_A = mkWA (compoundA "akefa" (k38 "alinen")) ; --UNCHK
lin acerate_A = mkWA (compoundA "neulas" (k38 "mainen")) ; --UNCHK
lin acerb_A = mkWA (k38 "sarkastinen") ; --UNCHK
lin acerbity_N = mkWN (k40 "piikikkyys") ; --UNCHK
lin acerola_N = mkWN (compoundN "acerola" (k14A "kirsikka")) ; --UNCHK
lin acervate_A = mkWA "ryppäinä" "kasvava" ; --UNCHK
lin acervulus_N = mkWN "acervulus" ; --UNCHK
lin acetabulum_N = mkWN (compoundN "nivel" (k10A "kuoppa")) ; --UNCHK
lin acetaldol_N = mkWN "asetaldoli" ; --UNCHK
lin acetamide_N = mkWN (k5 "etaaniamidi") ; --UNCHK
lin acetaminophen_N = mkWN "parasetamoli" ; --UNCHK
lin acetanilide_N = mkWN (k5 "fenyyliasetamidi") ; --UNCHK
lin acetate_N = mkWN (k5A "asetaatti") ;
lin acetic_A = mkWA "etikkahappo-" ; --UNCHK
lin acetin_N = mkWN "asetiini" ; --UNCHK
lin acetone_N = mkWN (k5 "asetoni") ; --UNCHK
lin acetonic_A = mkWA "asetoni-" ; --UNCHK
lin acetophenetidin_N = mkWN "fenasetiini" ; --UNCHK
lin acetose_A = mkWA (compoundA "etikan" (k38 "hajuinen")) ; --UNCHK
lin acetum_N = mkWN (k14A "etikka") ; --UNCHK
lin acetyl_N = mkWN (compoundN "ase" (k5 "tyyli")) ; --UNCHK
lin acetylation_N = mkWN "asetylaatio" ; --UNCHK
lin acetylcholine_N = mkWN "asetyylikoliini" ; --UNCHK
lin acetylene_N = mkWN (k5 "asetyleeni") ; --UNCHK
lin acetylenic_A = mkWA "asetyleeni-" ; --UNCHK
lin acetylic_A = mkWA "asetyyli-" ; --UNCHK
lin ache_N = mkWN (k1A "särky") ; --UNCHK
lin ache_V = mkWV (k52A "riutua") "ikävästä" ; --UNCHK
lin achene_N = mkWN (k12 "pähkylä") ; --UNCHK
lin achenial_A = mkWA "pähkylä-" ; --UNCHK
lin achievability_N = mkWN (k40 "saavutettavuus") ; --UNCHK
lin achievable_A = mkWA (k10 "oleva") "toteutettavissa" ; --UNCHK
lin achieve_V2 = mkV2 "saavuttaa" ;
lin achievement_N = mkWN (k1A "teko") ; --UNCHK
lin achiever_N = mkWN "menestyjä" ; --UNCHK
lin achillea_N = mkWN (k2 "kärsämö") ; --UNCHK
lin achimenes_N = mkWN (k9A "hilkka") ; --UNCHK
lin achira_N = mkWN (k26 "nuolijuuri") ; --UNCHK
lin achlamydeous_A = mkWA "kehätön" ; --UNCHK
lin achlorhydria_N = mkWN "hapottomuus" ; --UNCHK
lin achlorhydric_A = mkWA "hapoton" ; --UNCHK
lin achondrite_N = mkWN (compoundN "akond" (k5A "riitti")) ; --UNCHK
lin achondritic_A = mkWA "akondriittinen" ; --UNCHK
lin achondroplasia_N = mkWN (compoundN "osteo" (k5 "skleroosi")) "synnynnäinen" ; --UNCHK
lin achondroplastic_A = mkWA (compoundA "akondrop" (k38 "lasinen")) ; --UNCHK
lin achromatic_A = mkWA (k6 "neutraali") ; --UNCHK
lin achromatin_N = mkWN "akromatiini" ; --UNCHK
lin achromatinic_A = mkWA "akromatiininen" ; --UNCHK
lin achromatous_A = mkWA "akromaattinen" ; --UNCHK
lin achromia_N = mkWN (k40 "värittömyys") ; --UNCHK
lin achromic_A = mkWA (k34A "väritön") ; --UNCHK
lin achylia_N = mkWN "mahanesteen" "hapottomuus" ; --UNCHK
lin acicula_N = mkWN (k38 "neulanen") ; --UNCHK
lin aciculate_A = mkWA "neulas-" ; --UNCHK
lin acid_A = mkWA (k33A "hapan") ; --UNCHK
lin acid_N = mkWN (k1A "happo") ;
lin acidemia_N = mkWN (compoundN "hapan" (k40 "verisyys")) ; --UNCHK
lin acidic_A = mkWA (k33A "hapan") ; --UNCHK
lin acidification_N = mkWN "asidifikaatio" ; --UNCHK
lin acidify_V = mkWV (k52A "happamoitua") ; --UNCHK
lin acidify_V2 = mkWV2 (k52A "happamoitua") ; --UNCHK
lin acidimetric_A = mkWA (compoundA "asidi" (k38 "metrinen")) ; --UNCHK
lin acidimetry_N = mkWN "happopitoisuuden" "määrittäminen" ; --UNCHK
lin acidity_N = mkWN (k40 "happamuus") ; --UNCHK
lin acidophil_N = mkWN "asidofiili" ; --UNCHK
lin acidophilic_A = mkWA "asidofiilinen" ; --UNCHK
lin acidophilus_N = mkWN "Lactobacillus" "acidophilus" ; --UNCHK
lin acidosis_N = mkWN (compoundN "happo" (k39 "myrkytys")) ; --UNCHK
lin acidotic_A = mkWA "asidoottinen" ; --UNCHK
lin acidulous_A = mkWA (k41A "hapokas") ; --UNCHK
lin acinar_A = mkWA "asinoosinen" ; --UNCHK
lin acinus_N = mkWN (compoundN "rauhas" (k12 "rakkula")) ; --UNCHK
lin ackee_N = mkWN (compoundN "aki" (k1 "luumu")) ; --UNCHK
lin acknowledge_V2 = mkWV2 (k54A "myöntää") ; --UNCHK
lin acknowledge_VS = mkWVS (k54A "myöntää") ;
lin acknowledgeable_A = mkWA (k10 "oleva") "tunnustettavissa" ; --UNCHK
lin acknowledgement_N = mkWN (k5A "merkki") "tunnistamisen" ; --UNCHK
lin acme_N = mkWN (k1A "huippu") ; --UNCHK
lin acne_N = mkWN (k8 "akne") ; --UNCHK
lin acned_A = mkWA (k38 "näppyläinen") ; --UNCHK
lin acneiform_A = mkWA (k38 "kaltainen") "aknen" ; --UNCHK
lin acold_A = mkWA "paleleva" ; --UNCHK
lin acolyte_N = mkWN (k5A "pappi") "avustava" ; --UNCHK
lin aconite_N = mkWN "aitoukonhattu" ; --UNCHK
lin acorea_N = mkWN "akorea" ; --UNCHK
lin acorn_N = mkWN (compoundN "tammen" (k1 "terho")) ; --UNCHK
lin acorn_cup_N = mkWN (k1A "kehto") "tammenterhon" ; --UNCHK
lin acoustic_A = mkWA (k38 "akustinen") ; --UNCHK
lin acoustic_N = mkWN (compoundN "kuulo" (k48A "laite")) ; --UNCHK
lin acoustician_N = mkWN "akustikko" ; --UNCHK
lin acoustics_N = mkWN (k9A "akustiikka") ; --UNCHK
lin acquaint_V2 = mkWV2 (k53A "tiedottaa") ; --UNCHK
lin acquaintance_N = mkWN (k40 "perehtyneisyys") ; --UNCHK
lin acquaintanceship_N = mkWN (k40 "tuttavuus") ; --UNCHK
lin acquiesce_V = mkWV (k52 "suostua") ; --UNCHK
lin acquiescence_N = mkWN (k40 "myöntyväisyys") ; --UNCHK
lin acquiescent_A = mkWA (k38 "tottelevainen") ; --UNCHK
lin acquirable_A = mkWA (k10 "oleva") "hankittavissa" ; --UNCHK
lin acquire_V2 = mkV2 "hankkia" ;
lin acquirement_N = mkWN (k39 "saavutus") ; --UNCHK
lin acquirer_N = mkWN (compoundN "yritys" (k5A "pankki")) ; --UNCHK
lin acquiring_N = mkWN (k38 "saaminen") ; --UNCHK
lin acquisition_N = mkN "hankinta" ;
lin acquisitive_A = mkWA (k10 "tekevä") "hankintoja" ; --UNCHK
lin acquisitiveness_N = mkWN (compoundN "omistus" (k1 "halu")) ; --UNCHK
lin acquit_V2 = mkWV2 (k53A "vapauttaa") ;
lin acquittal_N = mkWN (k3 "tuomio") "vapauttava" ; --UNCHK
lin acquittance_N = mkWN (k39 "vapautus") ; --UNCHK
lin acre_N = mkN "eekkeri" ;
lin acreage_N = mkWN (compoundN "pinta-" (k9 "ala")) ; --UNCHK
lin acrid_A = mkWA (k38 "sarkastinen") ; --UNCHK
lin acridity_N = mkWN (k40 "purevuus") ; --UNCHK
lin acrimonious_A = mkWA (k10 "katkera") ; --UNCHK
lin acrimony_N = mkWN (k40 "piikikkyys") ; --UNCHK
lin acritical_A = mkWA (compoundA "epä" (k38 "kriittinen")) ; --UNCHK
lin acroanesthesia_N = mkWN (compoundN "akro" (k12 "anestesia")) ; --UNCHK
lin acrobatFem_N = mkWN (k5A "akrobaatti") ; --UNCHK
lin acrobatMasc_N = mkWN (k5A "akrobaatti") ; --UNCHK
lin acrobatic_A = mkWA (k38 "urheilullinen") ; --UNCHK
lin acrobatics_N = mkWN (k38 "tekeminen") "temppujen" ; --UNCHK
lin acrocarp_N = mkWN (compoundN "akrokarppi" (k49 "sammal")) ; --UNCHK
lin acrocarpous_A = mkWA (compoundA "pesä" (k38 "kekärkinen")) ; --UNCHK
lin acrocentric_A = mkWA "akrosentrinen" ; --UNCHK
lin acrocyanosis_N = mkWN (compoundN "oire" (k10 "yhtymä")) "Raynaud'n" ; --UNCHK
lin acrodont_N = mkWN "akrodontti" ; --UNCHK
lin acrogen_N = mkWN (compoundN "akro" (k5 "geeni")) ; --UNCHK
lin acrogenic_A = mkWA "akrogeeninen" ; --UNCHK
lin acromegalic_A = mkWA (compoundA "akromega" (k38 "alinen")) ; --UNCHK
lin acromegaly_N = mkWN "kärkikasvuisuus" ; --UNCHK
lin acromicria_N = mkWN "akromikria" ; --UNCHK
lin acromion_N = mkWN (k5 "prosessi") "akromiaalinen" ; --UNCHK
lin acromphalus_N = mkWN (compoundN "akromf" (k39 "alus")) ; --UNCHK
lin acromyotonia_N = mkWN "akromyotonia" ; --UNCHK
lin acronym_N = mkWN (k48A "lyhenne") ; --UNCHK
lin acronymic_A = mkWA (compoundA "akronyymi" (k38 "nen")) ; --UNCHK
lin acropetal_A = mkWA (compoundA "kärki" (k38 "hakuinen")) ; --UNCHK
lin acrophobia_N = mkWN (k1 "kammo") "korkean" "paikan" ; --UNCHK
lin acrophobic_A = mkWA (compoundA "korkeanpaikank" (k38 "ammoinen")) ; --UNCHK
lin acrophony_N = mkWN "akrofonia" ; --UNCHK
lin acropolis_N = mkWN (k26 "linnavuori") ; --UNCHK
lin acroscopic_A = mkWA "akroskooppinen" ; --UNCHK
lin acrosome_N = mkWN "akrosomi" ; --UNCHK
lin across_Adv = mkWAdv (k99 "ristiin") ; --UNCHK
lin across_Prep = mkPrep "poikki" ;
lin acrostic_N = mkWN "akrostikon" ; --UNCHK
lin acrylamide_N = mkWN (k5 "akryyliamidi") ; --UNCHK
lin act_N = mkWN (k25 "toimi") | mkN "näytös" ; ---- split
lin act_V = mkV "toimia" ;
lin act_V2 = mkV2 "näytellä" partitive ;
lin act_on_V2 = mkWV2 (k62 "reagoida") ; --UNCHK
lin act_out_V2 = mkWV2 (k67A "näytellä") ; --UNCHK
lin act_up_V = mkWV (k67A "oikutella") ; --UNCHK
lin act_upon_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin actable_A = mkWA (k10 "oleva") "näyteltävissä" ; --UNCHK
lin actin_N = mkWN "aktiini" ; --UNCHK
lin actinal_A = mkWA (compoundA "aktina" (k38 "alinen")) ; --UNCHK
lin acting_A = mkA (mkN "virkaa" (mkN "tekevä")) ;
lin acting_N = mkWN (compoundN "näyttelijän" (k19 "työ")) ; --UNCHK
lin actinia_N = mkWN (compoundN "meri" (k1A "vuokko")) ; --UNCHK
lin actinic_A = mkWA (compoundA "valo" (k38 "kemiallinen")) ; --UNCHK
lin actinism_N = mkWN (compoundN "aktin" (k5 "ismi")) ; --UNCHK
lin actinoid_A = mkWA (compoundA "akti" (k38 "noidinen")) ; --UNCHK
lin actinoid_N = mkWN "aktinidi" ; --UNCHK
lin actinolite_N = mkWN "aktinoliitti" ; --UNCHK
lin actinometer_N = mkWN (compoundN "aktino" (k5 "metri")) ; --UNCHK
lin actinometric_A = mkWA (compoundA "aktino" (k38 "metrinen")) ; --UNCHK
lin actinometry_N = mkWN "aktinometria" ; --UNCHK
lin actinomorphic_A = mkWA (compoundA "akti" (k38 "nomorfinen")) ; --UNCHK
lin actinomyces_N = mkWN (compoundN "säde" (k26 "sieni")) ; --UNCHK
lin actinomycetal_A = mkWA (compoundA "aktinomys" (k38 "eettinen")) ; --UNCHK
lin actinomycete_N = mkWN (compoundN "säde" (k26 "sieni")) ; --UNCHK
lin actinomycin_N = mkWN "aktinomysiini" ; --UNCHK
lin actinomycosis_N = mkWN (compoundN "sädesieni" (k5A "tauti")) ; --UNCHK
lin actinomycotic_A = mkWA (compoundA "akti" (k38 "nomykoottinen")) ; --UNCHK
lin actinomyxidian_N = mkWN "actinomyxidian" ; --UNCHK
lin actinopod_N = mkWN "aktinopodi" ; --UNCHK
lin action_N = mkN "toiminta" ;
lin actionable_A = mkWA (compoundA "haku" (k38 "kelpoinen")) ; --UNCHK
lin activate_V2 = mkWV2 (k53A "ottaa") "käyttöön" ; --UNCHK
lin activation_N = mkWN (k5A "aktivointi") ; --UNCHK
lin active_A = mkA "aktiivinen" ;
lin active_N = mkWN (k5 "aktiivi") ; --UNCHK
lin activeness_N = mkWN (k5A "aktiviteetti") ; --UNCHK
lin activism_N = mkWN (k5 "aktivismi") ; --UNCHK
lin activistFem_N = mkWN (k5 "aktivisti") ;
lin activistMasc_N = variants {} ; --
lin activist_A = mkWA (compoundA "akti" (k38 "vistinen")) ; --UNCHK
lin activity_N = mkWN (k9A "toiminta") ;
lin actomyosin_N = mkWN "aktomyosiini" ; --UNCHK
lin actor_1_N = mkWN (k12 "näyttelijä") ;
lin actor_2_N = mkWN (k12 "näyttelijä") ;
lin actor_N = mkWN (k12 "näyttelijä") ;
lin actress_N = mkWN (k32A "näyttelijätär") ;
lin actual_A = mkA "nykyinen" ;
lin actuality_N = mkWN (k40 "todellisuus") ; --UNCHK
lin actually_Adv = mkAdv "itse asiassa" | adjAdv actual_A ; -- derived
lin actuarial_A = mkWA (compoundA "vakuutus" (k38 "matemaattinen")) ; --UNCHK
lin actuary_N = mkWN (compoundN "tilasto" (k4A "matemaatikko")) ; --UNCHK
lin actuate_V2 = mkWV2 (k53A "aiheuttaa") ; --UNCHK
lin actuator_N = mkWN (compoundN "käyttö" (k48A "laite")) ; --UNCHK
lin acuate_A = mkWA (k1A "suippo") ; --UNCHK
lin acuity_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin aculea_N = mkWN "akulea" ; --UNCHK
lin aculeate_A = mkWA "pistimellinen" ; --UNCHK
lin aculeus_N = mkWN (k33 "pistin") ; --UNCHK
lin acumen_N = mkWN (k1 "äly") ; --UNCHK
lin acuminate_A = mkWA (compoundA "suippo" (k38 "kärkinen")) ; --UNCHK
lin acupressure_N = mkWN (compoundN "shiatsu-" (k9A "hieronta")) ; --UNCHK
lin acupuncture_N = mkWN (k6 "akupunktuuri") ; --UNCHK
lin acute_A = mkWA (k38 "äkillinen") ; --UNCHK
lin acuteness_N = mkWN (k40 "terävyys") ; --UNCHK
lin acyclic_A = mkWA (compoundA "avo" (k38 "ketjuinen")) ; --UNCHK
lin acyclovir_N = mkWN (compoundN "asyklo" (k5 "viiri")) ; --UNCHK
lin acyl_N = mkWN (compoundN "asyyli" (k10 "ryhmä")) ; --UNCHK
lin acylation_N = mkWN "asylaatio" ; --UNCHK
lin ad_N = mkN "mainos" ;
lin ad_hoc_A = mkWA (k99 "vasten") "varta" ; --UNCHK
lin ad_hoc_Adv = mkWAdv (k99 "varten") "tätä" "tarkoitusta" ; --UNCHK
lin ad_infinitum_Adv = mkWAdv (k99 "ikuisesti") ; --UNCHK
lin ad_interim_Adv = mkWAdv "sillä" "aikaa" ; --UNCHK
lin ad_lib_Adv = mkWAdv (k99 "spontaanisti") ; --UNCHK
lin ad_libitum_Adv = mkWAdv (k99 "spontaanisti") ; --UNCHK
lin ad_nauseam_Adv = mkWAdv (k99 "asti") "pahoinvointiin" ; --UNCHK
lin ad_valorem_Adv = mkWAdv (k99 "mukaan") "arvon" ; --UNCHK
lin ada_PN = foreignPN "Ada" ;
lin adactylia_N = mkWN "adaktylia" ; --UNCHK
lin adactylous_A = mkWA (compoundA "adak" (k38 "tyylinen")) ; --UNCHK
lin adage_N = mkWN (k9A "sanonta") ; --UNCHK
lin adagio_A = mkWA (k99 "hitaasti") "kohtalaisen" ; --UNCHK
lin adagio_Adv = mkWAdv (k99 "hitaasti") "kohtalaisen" ; --UNCHK
lin adagio_N = mkWN "adagio" ; --UNCHK
lin adamance_N = mkWN (k40 "taipumattomuus") ; --UNCHK
lin adamant_A = mkWA (k34A "peräänantamaton") ; --UNCHK
lin adamant_N = mkWN (k5A "timantti") ; --UNCHK
lin adamantine_A = mkWA (compoundA "timantin" (k10 "kova")) ; --UNCHK
lin adapt_V = mkWV (k52A "tottua") ;
lin adapt_V2 = mkV2 "mukauttaa" ; --mkWV2 (k52A "tottua") ;
lin adaptability_N = mkWN (k40 "sopeutuvuus") ; --UNCHK
lin adaptable_A = mkWA (k10 "mukautuva") ; --UNCHK
lin adaptation_N = mkWN (k3 "adaptaatio") ; --UNCHK
lin adaptational_A = mkWA "sopeutumiseen" "liittyvä" ; --UNCHK
lin adapter_N = mkWN (k33A "liitin") ; --UNCHK
lin adaptive_A = mkWA (k10 "sopeutuva") ; --UNCHK
lin adaptor_N = mkWN (k33A "liitin") ; --UNCHK
lin adaxial_A = mkWA (compoundA "ventra" (k38 "alinen")) ; --UNCHK
lin add_V = mkV "lisätä" ;
lin add_V2 = mkV2 "lisätä" ;
lin add_V3 = L.add_V3 ;
lin add_VS = mkVS (mkV "lisätä") ;
lin add_in_V = advV OP_add_V OP_in_Adv ; -- guess-p-verb
lin add_on_to_V2 = mkWV2 (k71 "tehdä") "lisäys" ; --UNCHK
lin add_up_V = mkWV (k73 "ynnätä") ; --UNCHK
lin add_up_V2 = mkWV2 (k73 "ynnätä") ; --UNCHK
lin add_up_to_V2 = prepV2 (advV OP_add_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin addable_A = mkWA (k10 "oleva") "lisättävissä" ; --UNCHK
lin addax_N = mkWN (compoundN "saharan" (k5A "antilooppi")) ; --UNCHK
lin added_A = variants {} ; --
lin addend_N = mkWN "yhteenlaskettava" ; --UNCHK
lin addendum_N = mkWN (k48A "liite") ; --UNCHK
lin adder_N = mkWN (k18 "kyy") ; --UNCHK
lin addict_N = mkWN (k5 "narkomaani") ; --UNCHK
lin addict_V2 = mkWV2 (k71 "tehdä") "riippuvaiseksi" ; --UNCHK
lin addiction_N = mkWN (k2 "ratkaisu") ; --UNCHK
lin addictive_A = mkWA (compoundA "addikt" (k10 "oiva")) ; --UNCHK
lin adding_machine_N = mkWN (k33 "laskin") ; --UNCHK
lin addis_ababa_PN = foreignPN "Addis Abeba" ;
lin addition_N = mkWN (k39 "lisäys") ;
lin additional_A = mkA "lisätty" ;
lin additionally_Adv = adjAdv additional_A ; -- derived
lin additive_A = mkWA "lisäävä" ; --UNCHK
lin additive_N = mkWN (compoundN "lisä" (k48 "aine")) ; --UNCHK
lin addle_V = mkWV (k52A "pilaantua") ; --UNCHK
lin addle_V2 = mkWV2 (k52A "pilaantua") ; --UNCHK
lin address_N = mkN "osoite" ;
lin address_V2 = mkV2 (mkV (mkV "kohdistaa") "huomio") ;
lin addressable_A = mkWA (k10 "oleva") "osoitettavissa" ; --UNCHK
lin addressee_N = mkWN (compoundN "vastaan" (k10 "ottaja")) ; --UNCHK
lin addressograph_N = mkWN (compoundN "osoite" (k48 "kone")) ; --UNCHK
lin adduce_V2 = mkWV2 (k73 "siteerata") ; --UNCHK
lin adducent_A = mkWA "adduktiivinen" ; --UNCHK
lin adducer_N = mkWN (k10 "esittäjä") ; --UNCHK
lin adducing_N = mkWN (k38 "tuominen") "esiin" ; --UNCHK
lin adduct_N = mkWN (compoundN "additio" (k48A "tuote")) ; --UNCHK
lin adduction_N = mkWN "lähentäminen" ; --UNCHK
lin adductor_N = mkWN (k10 "lähentäjä") ; --UNCHK
lin adelaide_PN = foreignPN "Adelaide" ;
lin adelgid_N = mkWN "adelgid" ; --UNCHK
lin adenine_N = mkWN (compoundN "ade" (k26 "niini")) ; --UNCHK
lin adenitis_N = mkWN (compoundN "ade" (k5A "niitti")) ; --UNCHK
lin adenocarcinoma_N = mkWN (compoundN "rauhas" (k10A "syöpä")) ; --UNCHK
lin adenocarcinomatous_A = mkWA "adenokarsinoomaan" "liittyvä" ; --UNCHK
lin adenoidal_A = mkWA "kitarisaan" "liittyvä" ; --UNCHK
lin adenoidectomy_N = mkWN (compoundN "poisto" (k39 "leikkaus")) "kitarisan" ; --UNCHK
lin adenoma_N = mkWN (k10 "adenooma") ; --UNCHK
lin adenomegaly_N = mkWN "adenomegalia" ; --UNCHK
lin adenopathy_N = mkWN "adenopatia" ; --UNCHK
lin adenosine_N = mkWN "adenosiini" ; --UNCHK
lin adenovirus_N = mkWN (compoundN "adeno" (k39 "virus")) ; --UNCHK
lin adept_A = mkWA (k41A "taidokas") ; --UNCHK
lin adept_N = mkWN (k5A "ekspertti") ; --UNCHK
lin adeptness_N = mkWN (k40 "nopeus") ; --UNCHK
lin adequacy_N = mkWN (k40 "soveltuvuus") ; --UNCHK
lin adequate_A = mkA "tarkoituksenmukainen" ;
lin adesite_N = mkWN "adesiitti" ; --UNCHK
lin adhere_V = mkWV (k53A "pitää") "kiinni" ; --UNCHK
lin adherence_N = mkWN (compoundN "kii" (k38 "nnipysyminen")) ; --UNCHK
lin adherent_A = mkWA "tarttuva" ; --UNCHK
lin adherent_N = mkWN (k10 "kannattaja") ; --UNCHK
lin adhesion_N = mkWN (compoundN "kii" (k38 "nnipysyminen")) ; --UNCHK
lin adhesive_A = mkWA (k15 "tahmea") ; --UNCHK
lin adhesive_N = mkWN (k6 "liisteri") ; --UNCHK
lin adhesiveness_N = mkWN (k39 "sidos") ; --UNCHK
lin adhocracy_N = mkWN "adhokratia" ; --UNCHK
lin adiabatic_A = mkWA (compoundA "samalämpö" (k38 "määräinen")) ; --UNCHK
lin adience_N = mkWN "adienssi" ; --UNCHK
lin adient_A = mkWA "adientti" ; --UNCHK
lin adipose_A = mkWA (k38 "öljyinen") ; --UNCHK
lin adiposity_N = mkWN (k40 "rasvaisuus") ; --UNCHK
lin adit_N = mkWN (k6 "tunneli") ; --UNCHK
lin adjacency_N = mkWN (k40 "vierekkäisyys") ; --UNCHK
lin adjacent_A = mkWA (k38 "viereinen") ;
lin adjective_N = mkWN (k5 "adjektiivi") ;
lin adjoin_V = mkWV (k73 "lisätä") ; --UNCHK
lin adjoin_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin adjourn_V = mkWV (k53A "päättää") ; --UNCHK
lin adjourn_V2 = mkWV2 (k53A "päättää") ; --UNCHK
lin adjournment_N = mkWN (k1A "siirto") ; --UNCHK
lin adjudge_V2 = mkWV2 (k52 "katsoa") ; --UNCHK
lin adjudicate_V = mkWV (k69 "tuomita") ; --UNCHK
lin adjudicate_V2 = mkWV2 (k69 "tuomita") ; --UNCHK
lin adjudication_N = mkWN (k3 "tuomio") ; --UNCHK
lin adjudicative_A = mkWA "tuomioon" "liittyvä" ; --UNCHK
lin adjudicator_N = mkWN (k10 "välittäjä") ; --UNCHK
lin adjunct_A = mkWA (k38 "apulainen") ; --UNCHK
lin adjunct_N = mkWN (k48 "määre") ; --UNCHK
lin adjunctive_A = mkWA "yhdistävä" ; --UNCHK
lin adjuration_N = mkWN (compoundN "valan" (k1A "teko")) ; --UNCHK
lin adjuratory_A = mkWA "vala-" ; --UNCHK
lin adjure_V2 = mkWV2 (k53A "velvoittaa") "valalla" ; --UNCHK
lin adjust_V = mkWV (k52A "tottua") ;
lin adjust_V2 = mkV2 "tottua" illative ;
lin adjustable_A = mkWA (k10 "oleva") "säädettävissä" ; --UNCHK
lin adjuster_N = mkWN (k10 "tarkastaja") ;
lin adjustive_A = mkWA "oikaiseva" ; --UNCHK
lin adjustment_N = mkN "säätö" ;
lin adjutant_N = mkWN (k5A "adjutantti") ; --UNCHK
lin adjuvant_A = mkWA "tehostava" ; --UNCHK
lin adjuvant_N = mkWN (compoundN "lisä" (k48 "aine")) ; --UNCHK
lin admass_N = mkWN (k2 "yleisö") "suuri" ; --UNCHK
lin administer_V = mkWV (k56A "jakaa") ; --UNCHK
lin administer_V2 = mkV2 "hallinnoida" partitive ; --mkWV2 (k56A "jakaa") ;
lin administrable_A = mkWA (k10 "oleva") "hallittavissa" ; --UNCHK
lin administration_N = mkN "hallinto" ;
lin administrative_A = mkWA (k38 "hallinnollinen") ;
lin administratorFem_N = mkN "administraattori" ;
lin administratorMasc_N = mkN "administraattori" ;
lin admirability_N = mkN "ihailtavuus" ;
lin admirable_A = mkA "ihailtava" ; 
lin admiral_N = mkWN (k5 "amiraali") ; 
lin admiration_N = mkN "ihailu" ;
lin admire_V2 = mkV2 (mkV "ihailla") partitive ;
lin admirer_N = mkN "ihailija" "ihailijoita" ;
lin admiringly_Adv = mkWAdv "ihaillen" ; --UNCHK
lin admissibility_N = mkWN (k40 "luvallisuus") ; --UNCHK
lin admissible_A = mkA "luvallinen" ;
lin admission_N = mkN "pääsy" ;
lin admissive_A = mkA "salliva" ;
lin admit_V = mkV "myöntää" | mkWV (k53 "tunnustaa") ;
lin admit_V2 = mkV2 "myöntää" | mkV2 "tunnustaa" ;
lin admit_VS = mkVS "myöntää" | mkWVS (k53 "tunnustaa") ;
lin admittance_N = mkN "pääsy" ;
lin admittedly_Adv = mkWAdv (k99 "tosiaan") ; --UNCHK
lin admix_V = mkV "sekoittaa" ;
lin admix_V2 = mkWV2 (k53A "sekoittaa") "joukkoon" ; --UNCHK
lin admixture_N = mkWN (k39 "seos") ; --UNCHK
lin admonish_V2 = mkWV2 (k61A "moittia") ; --UNCHK
lin admonisher_N = mkWN (k10 "neuvoja") ; --UNCHK
lin admonition_N = mkWN (k39 "kehotus") ; --UNCHK
lin admonitory_A = mkWA (k10 "arvosteleva") ; --UNCHK
lin adnate_A = mkWA (compoundA "yhteen" (k47 "kasvanut")) ; --UNCHK
lin adnexal_A = mkWA "sivuelin-" ; --UNCHK
lin adnoun_N = mkWN (k5 "adjektiivi") "substantiivisesti" "käytetty" ; --UNCHK
lin ado_N = mkWN (k39 "touhotus") ; --UNCHK
lin adobe_N = mkWN (compoundN "savi" (k23 "tiili")) ; --UNCHK
lin adobo_N = mkWN "adobo" ; --UNCHK
lin adolescence_N = mkWN (compoundN "nuoruus" (k10A "ikä")) ; --UNCHK
lin adolescent_A = mkWA (k26 "nuori") ; --UNCHK
lin adolescent_N = mkWN (k38 "nuorukainen") ; --UNCHK
lin adonis_N = mkWN "Adonis" ; --UNCHK
lin adopt_V2 = mkV2 "omaksua" ;
lin adoptable_A = mkWA (compoundA "adoptio" (k38 "kelpoinen")) ; --UNCHK
lin adoptee_N = mkWN (compoundN "otto" (k29 "lapsi")) ; --UNCHK
lin adoption_N = mkWN (compoundN "oma" (k38 "ksuminen")) ; ---ARB --mkN "adoptio" ;
lin adoptive_A = mkWA (compoundA "omak" (k1A "suttu")) ; --UNCHK
lin adorability_N = mkWN (k40 "ihanuus") ; --UNCHK
lin adorable_A = mkWA (k10 "hurmaava") ; --UNCHK
lin adoration_N = mkWN (k9A "palvonta") ; --UNCHK
lin adore_V2 = mkWV2 (k53 "rakastaa") ; --UNCHK
lin adorer_N = mkWN (k10 "palvoja") ; --UNCHK
lin adoring_A = mkWA (compoundA "juma" (k10 "loiva")) ; --UNCHK
lin adorn_V2 = mkWV2 (k53 "komistaa") ; --UNCHK
lin adornment_N = mkWN (compoundN "kori" (k38 "stautuminen")) ; --UNCHK
lin adoxography_N = mkWN "adoksografia" ; --UNCHK
lin adrenal_A = mkWA "lisämunuais-" ; --UNCHK
lin adrenalin_N = mkWN (k5 "adrenaliini") ; --UNCHK
lin adrenarche_N = mkWN "adrenarke" ; --UNCHK
lin adrenergic_A = mkWA (compoundA "sympatomim" (k38 "eettinen")) ; --UNCHK
lin adrenergic_N = mkWN (k48A "lääke") "adrenerginen" ; --UNCHK
lin adrenocortical_A = mkWA (compoundA "adrenokortika" (k38 "alinen")) ; --UNCHK
lin adrenocorticotropic_A = mkWA (compoundA "adrenokortiko" (k38 "trooppinen")) ; --UNCHK
lin adrenosterone_N = mkWN "adrenosteroni" ; --UNCHK
lin adrian_PN = foreignPN "Adrian" ;
lin adrift_A = mkWA (k99 "tuuliajolla") ; --UNCHK
lin adrift_Adv = mkWAdv (k99 "tuuliajolla") ; --UNCHK
lin adroit_A = mkWA (k10 "taitava") ; --UNCHK
lin adroitness_N = mkWN (k40 "nopeus") ; --UNCHK
lin adscititious_A = mkWA "täydentävä" ; --UNCHK
lin adscript_A = mkWA (k10 "seuraava") ; --UNCHK
lin adsorbable_A = mkWA "adsorboitunut" ; --UNCHK
lin adsorbate_N = mkWN (k48 "aine") "adsorboituva" ; --UNCHK
lin adsorbent_A = mkWA (compoundA "adsorb" (k10 "oiva")) ; --UNCHK
lin adsorbent_N = mkWN (k48 "aine") "absorboiva" ; --UNCHK
lin adsorption_N = mkWN (k3 "adsorptio") ; --UNCHK
lin adulation_N = mkWN (k2 "mielistely") ; --UNCHK
lin adulatory_A = mkWA (compoundA "mieliste" (k10 "levä")) ; --UNCHK
lin adult_A = mkWA (kH1 "iso") ; --UNCHK
lin adult_N = mkN "aikuinen" ;
lin adulterant_N = mkWN (k10 "väärentäjä") ; --UNCHK
lin adulterate_A = mkWA (compoundA "jat" (k1A "kettu")) ; --UNCHK
lin adulterate_V2 = mkWV2 (k53A "vesittää") ; --UNCHK
lin adulterating_A = mkWA "laimentava" ; --UNCHK
lin adulteration_N = mkWN (compoundN "huono" (k38 "ntaminen")) ; --UNCHK
lin adulterator_N = mkWN (k10 "väärentäjä") ; --UNCHK
lin adulterer_N = mkWN (k10 "harjoittaja") "haureuden" ; --UNCHK
lin adulteress_N = mkWN (k1A "narttu") ; --UNCHK
lin adulterine_A = mkWA (k34A "avioton") ; --UNCHK
lin adulterous_A = mkWA "pettävä" ; --UNCHK
lin adultery_N = mkWN (k40 "haureus") ; --UNCHK
lin adulthood_N = mkWN (k40 "aikuisuus") ; --UNCHK
lin adumbrate_V2 = mkWV2 (k67 "vihjailla") ; --UNCHK
lin adumbration_N = mkWN (k2 "luonnostelu") ; --UNCHK
lin adumbrative_A = mkWA (k38 "enteellinen") ; --UNCHK
lin advance_N = mkWN (compoundN "eteenpäin" (k1 "meno")) ; --f75
lin advance_V = mkV "edetä" ;
lin advance_V2 = mkV2 "edistää" ;
lin advanced_A = mkA "edistynyt" ;
lin advancement_N = mkWN (k39 "kehitys") ; --UNCHK
lin advancer_N = mkWN (k12 "etenijä") ; --UNCHK
lin advantage_N = mkN "etu" ;
lin advantage_V2 = mkWV2 (k61 "suosia") ; --UNCHK
lin advantageous_A = mkWA (k38 "hyödyllinen") ; --UNCHK
lin advection_N = mkWN "advektio" ; --UNCHK
lin advective_A = mkWA "advektiivinen" ; --UNCHK
lin advent_N = mkWN "saapuminen" ; --UNCHK
lin adventistFem_N = mkWN (k5 "adventisti") ; --UNCHK
lin adventistMasc_N = mkWN (k5 "adventisti") ; --UNCHK
lin adventitial_A = mkWA "ulkokerrokseen" "liittyvä" ; --UNCHK
lin adventitious_A = mkWA (k38 "tilapäinen") ; --UNCHK
lin adventive_A = mkWA "adventiivinen" ; --UNCHK
lin adventure_N = mkWN (k39 "yritys") "vaarallinen" ; --UNCHK
lin adventure_V2 = mkWV2 (k53A "ottaa") "riski" ; --UNCHK
lin adventurer_N = mkWN (k1A "uskalikko") ; --UNCHK
lin adventuresome_A = mkWA (k41 "uskalias") ; --UNCHK
lin adventuress_N = mkWN (k32A "seikkailijatar") ; --UNCHK
lin adventurism_N = mkWN (compoundN "seikkailun" (k1 "halu")) "poliittinen" ; --UNCHK
lin adventuristic_A = mkWA (compoundA "seikkailun" (k38 "haluinen")) ; --UNCHK
lin adventurous_A = mkWA (k41 "uskalias") ; --UNCHK
lin adventurousness_N = mkWN (k40 "uskaliaisuus") ; --UNCHK
lin adverb_N = mkWN (k5 "adverbi") ; --UNCHK
lin adverbial_A = mkWA (k38 "adverbiaalinen") ; --UNCHK
lin adverbial_N = mkWN (k5 "adverbiaali") ; --UNCHK
lin adversary_N = mkWN (k38 "vihollinen") ;
lin adversative_A = mkWA (k38 "adversatiivinen") ; --UNCHK
lin adverse_A = mkWA (k38 "vastakkainen") ;
lin adversity_N = mkWN (k40 "onnettomuus") ; --UNCHK
lin advert_N = mkWN (k39 "mainostus") ; --UNCHK
lin advert_V = mkWV (k75 "nimetä") ; --UNCHK
lin advertence_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin advertent_A = mkWA (k38 "huolellinen") ; --UNCHK
lin advertise_V = mkWV (k53 "julkistaa") ; --UNCHK
lin advertise_V2 = mkWV2 (k53 "julkistaa") ; --UNCHK
lin advertisement_N = mkN "mainos" ; --WN (k39 "mainostus") ;
lin advertiser_N = mkN (lin NK {s = d10 "mainostaja"}) ;
lin advertising_N = mkWN (k9A "mainonta") ; --f170
lin advertorial_N = mkWN (k5 "puffi") ; --UNCHK
lin advice_N = mkWN (k1 "neuvo") ;
lin advisability_N = mkWN (k40 "viisaus") ; --UNCHK
lin advisable_A = mkWA (k10 "suotava") ; --UNCHK
lin advise_V = mkV "neuvoa" ;
lin advise_V2 = mkV2 "neuvoa" partitive ;
lin advise_VS = mkVS "neuvoa" ; --mkWVS (k73 "ohjata") ;
lin advisee_N = mkWN (k10 "ohjattava") ; --UNCHK
lin adviserFem_N = mkN "neuvonantaja" ;
lin adviserMasc_N = variants {} ; --
lin advisory_A = mkWA (k10 "neuvoa-antava") ; --UNCHK
lin advisory_N = mkWN (k39 "varoitus") ; --UNCHK
lin advocacy_N = mkWN (k39 "kannatus") ; --UNCHK
lin advocateFem_N = mkN "puolustaja" ;
lin advocateMasc_N = variants {} ; --
lin advocate_V2 = mkWV2 (k53A "kannattaa") ; --UNCHK
lin advocate_VS = mkWVS (k53A "kannattaa") ; --UNCHK
lin advowson_N = mkWN (compoundN "patronaatti" (k40 "oikeus")) ; --UNCHK
lin adynamia_N = mkWN (k40 "voimattomuus") ; --UNCHK
lin adynamic_A = mkWA (k34A "voimaton") ; --UNCHK
lin adz_N = mkWN (compoundN "talso" (k41 "kirves")) ; --UNCHK
lin adze_N = mkWN (compoundN "talso" (k41 "kirves")) ; --UNCHK
lin aecial_A = mkWA "itiövaiheeseen" "liittyvä" ; --UNCHK
lin aeciospore_N = mkWN (compoundN "helmi-" (k3 "itiö")) ; --UNCHK
lin aecium_N = mkWN (compoundN "itiö" (k48 "vaihe")) ; --UNCHK
lin aegis_N = mkWN (kH1 "suoja") ; --UNCHK
lin aeolotropic_A = mkWA (compoundA "eolo" (k38 "trooppinen")) ; --UNCHK
lin aeon_N = mkWN (k40 "iäisyys") ; --UNCHK
lin aerate_V2 = mkWV2 (k53A "tuulettaa") ; --UNCHK
lin aeration_N = mkWN (compoundN "hiilihap" (k39 "otus")) ; --UNCHK
lin aerator_N = mkWN (compoundN "ilmastus" (k48A "laite")) ; --UNCHK
lin aerial_A = mkWA (k10 "elävä") "ilmassa" ; --UNCHK
lin aerialist_N = mkWN (compoundN "trapetsi" (k12 "taiteilija")) ; --UNCHK
lin aerides_N = mkWN "aerides" ; --UNCHK
lin aerie_N = mkWN (k1A "asunto") "korkealla" "sijaitseva" ; --UNCHK
lin aeriferous_A = mkWA (k10 "johtava") "ilmaa" ; --UNCHK
lin aeriform_A = mkWA (k38 "eteerinen") ; --UNCHK
lin aerobatics_N = mkWN (k38 "tekeminen") "temppujen" ; --UNCHK
lin aerobe_N = mkWN "aerobi" ; --UNCHK
lin aerobic_A = mkWA (k38 "aerobinen") ; --UNCHK
lin aerobics_N = mkWN (k5 "aerobic") ; --UNCHK
lin aerobiosis_N = mkWN "aerobioosi" ; --UNCHK
lin aerobiotic_A = mkWA "aerobioottinen" ; --UNCHK
lin aerodontalgia_N = mkWN "aerodontalgia" ; --UNCHK
lin aerodrome_N = mkWN (compoundN "lento" (k10A "kenttä")) ; --UNCHK
lin aerodynamic_A = mkWA (k38 "aerodynaaminen") ; --UNCHK
lin aerodynamics_N = mkWN (k9A "aerodynamiikka") ; --UNCHK
lin aerolite_N = mkWN (k5A "meteoriitti") ; --UNCHK
lin aerolitic_A = mkWA (compoundA "meteori" (k38 "ittinen")) ; --UNCHK
lin aerological_A = mkWA "aerologinen" ; --UNCHK
lin aerology_N = mkWN "aerologia" ; --UNCHK
lin aeromechanic_A = mkWA (compoundA "aero" (k38 "mekaaninen")) ; --UNCHK
lin aeromechanics_N = mkWN (k9A "aerodynamiikka") ; --UNCHK
lin aeromedical_A = mkWA "ilmailulääketieteellinen" ; --UNCHK
lin aeromedicine_N = mkWN "avaruuslääketiede" ; --UNCHK
lin aeronaut_N = mkWN (k5A "pilotti") ; --UNCHK
lin aeronautical_A = mkWA "lentämiseen" "liittyvä" ; --UNCHK
lin aeronautics_N = mkWN (k9A "astronautiikka") ; --UNCHK
lin aerophagia_N = mkWN (compoundN "ilma" (k38 "nnieleminen")) ; --UNCHK
lin aerophilatelic_A = mkWA "lentopostimerkkeilyyn" "liittyvä" ; --UNCHK
lin aerophilately_N = mkWN (compoundN "lento" (k2 "postimerkkeily")) ; --UNCHK
lin aerophile_N = mkWN (k10 "harrastaja") "ilmailun" ; --UNCHK
lin aeroplane_N = mkWN (compoundN "lento" (k48 "kone")) ; --UNCHK
lin aerosol_N = mkWN (k5 "aerosoli") ; --UNCHK
lin aerosolized_A = mkWA (k10 "oleva") "aerosolimuodossa" ; --UNCHK
lin aerospace_A = mkA "ilmailullinen" ;
lin aerospace_N = mkWN (k40 "avaruus") "ilmakehä" "ja" ;
lin aertex_N = mkWN "Aertex" ; --UNCHK
lin aery_N = mkWN (k1A "asunto") "korkealla" "sijaitseva" ; --UNCHK
lin aesculapian_A = mkWA (k38 "lääkinnällinen") ; --UNCHK
lin aestheteFem_N = mkWN (k4A "esteetikko") ; --UNCHK
lin aestheteMasc_N = mkWN (k4A "esteetikko") ; --UNCHK
lin aesthetic_A = mkA "esteettinen" ;
lin aesthetic_N = mkWN (k14A "estetiikka") ; --UNCHK
lin aesthetical_A = mkWA (k38 "esteettinen") ; --UNCHK
lin aesthetics_N = mkWN (k14A "estetiikka") ; --UNCHK
lin aestival_A = mkWA (k38 "kesäinen") ; --UNCHK
lin aether_N = mkWN (k6 "eetteri") ; --UNCHK
lin aetiology_N = mkWN (k12 "etiologia") ; --UNCHK
lin afar_Adv = mkWAdv (k99 "kaukana") ; --UNCHK
lin afebrile_A = mkWA "afebriili" ; --UNCHK
lin affability_N = mkWN (k40 "sydämellisyys") ; --UNCHK
lin affable_A = mkWA (k10 "mukava") ; --UNCHK
lin affair_N = mkN "liiketoimi" | mkWN (k1A "juttu") ; --- split
lin affect_N = mkWN (k5 "affekti") ; --UNCHK
lin affect_V2 = mkV2 "vaikuttaa" illative ;
lin affectation_N = mkWN (k40 "teennäisyys") ; --UNCHK
lin affected_A = mkA "vaikutettu" ;
lin affectedness_N = mkWN (k40 "teennäisyys") ; --UNCHK
lin affecting_A = mkWA (k10 "liikuttava") ; --UNCHK
lin affection_N = mkWN (k1A "lämpö") ; --UNCHK
lin affectional_A = mkWA (compoundA "tunnepi" (k38 "toinen")) ; --UNCHK
lin affectionate_A = mkWA (k35A "lämmin") ; --UNCHK
lin affectionateness_N = mkWN (k1A "lämpö") ; --UNCHK
lin affenpinscher_N = mkWN (compoundN "apina" (k6 "pinseri")) ; --UNCHK
lin afferent_A = mkWA "tuova" ; --UNCHK
lin affiance_V2 = mkWV2 (k52A "kihlautua") ; --UNCHK
lin affiant_N = mkWN (k10 "antaja") "valallisen" "todistuksen" ; --UNCHK
lin affidavit_N = mkN (mkN "valaehtoinen") (mkN "todistus") ; ----sanaliitto
lin affiliate_N = mkWN (compoundN "tytär" (k3 "yhtiö")) ; --UNCHK
lin affiliate_V = mkWV (k52 "yhdistyä") ; --UNCHK
lin affiliate_V2 = mkV2 "yhdistää" ; --mkWV2 (k52 "yhdistyä") ;
lin affiliation_N = mkWN "yhtyminen" ; --UNCHK
lin affinal_A = mkWA (k10 "oleva") "lankoussuhteessa" ; --UNCHK
lin affine_A = mkWA "affiininen" ; --UNCHK
lin affine_N = mkWN (k40 "lankous") ; --UNCHK
lin affined_A = mkWA (compoundA "lähi" (k38 "sukuinen")) ; --UNCHK
lin affinity_N = mkWN (k39 "viehtymys") ; --UNCHK
lin affirm_V = mkWV (k53 "vahvistaa") ; --UNCHK
lin affirm_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin affirm_VS = mkWVS (k53 "vahvistaa") ; --UNCHK
lin affirmable_A = mkWA (k10 "oleva") "vakuutettavissa" ; --UNCHK
lin affirmation_N = mkWN "vahvistaminen" ; --UNCHK
lin affirmative_A = mkWA "vahvistava" ; --UNCHK
lin affirmative_N = mkWN (k39 "vastaus") "myönteinen" ; --UNCHK
lin affirmativeness_N = mkWN (k40 "positiivisuus") ; --UNCHK
lin affix_N = mkWN (k48A "liite") ; --UNCHK
lin affix_V2 = mkWV2 (compoundV "affik" (k62 "soida")) ; --UNCHK
lin affixal_A = mkWA "liitteeseen" "liittyvä" ; --UNCHK
lin affixation_N = mkWN (k48A "liite") ; --UNCHK
lin afflatus_N = mkWN (k3 "inspiraatio") ; --UNCHK
lin afflict_V2 = mkWV2 (k73 "vaivata") ; --UNCHK
lin affliction_N = mkWN (k39 "koettelemus") ; --UNCHK
lin afflictive_A = mkWA (k41 "työläs") ; --UNCHK
lin affluence_N = mkWN (k40 "rikkaus") ; --UNCHK
lin affluent_A = mkWA (k41A "rikas") ; --UNCHK
lin affluent_N = mkWN (compoundN "sivu" (k7A "joki")) ; --UNCHK
lin afford_V2 = mkV2 (caseV adessive (mkV olla_V "varaa")) illative ;
lin afford_V2V = mkWV2V (k67 "olla") "varaa" ; --UNCHK
lin afforest_V2 = mkWV2 (k53A "metsittää") ; --UNCHK
lin afforestation_N = mkWN "muuttaminen" "metsämaaksi" ; --UNCHK
lin affranchise_V2 = mkWV2 (k56A "antaa") "äänioikeus" ; --UNCHK
lin affray_N = mkWN (k9A "riita") ; --UNCHK
lin affricate_N = mkWN "affrikaatta" ; --UNCHK
lin affrication_N = mkWN "affrikaatio" ; --UNCHK
lin affront_N = mkWN (k39 "solvaus") ; --UNCHK
lin affront_V2 = mkWV2 (k73 "parjata") ; --UNCHK
lin affusion_N = mkWN (k2 "valelu") "pään" ; --UNCHK
lin afghanFem_N = mkWN (k5 "afgaani") ; --UNCHK
lin afghanMasc_N = mkWN (k5 "afgaani") ; --UNCHK
lin afghan_A = mkWA (compoundA "afganistani" (k38 "lainen")) ;
lin afghani_N = mkWN (k5 "afgaani") ; --UNCHK
lin afghanistan_PN = foreignPN "Afganistan" ;
lin afghanistaniFem_N = mkWN (k3 "valtio") "Afganistaninen" "islamilainen" ; --UNCHK
lin afghanistaniMasc_N = mkWN (k3 "valtio") "Afganistaninen" "islamilainen" ; --UNCHK
lin afghanistani_A = mkWA (compoundA "afganistani" (k38 "lainen")) ; --UNCHK
lin afibrinogenemia_N = mkWN "afibrinogenemia" ; --UNCHK
lin aficionado_N = mkWN (k10 "harrastaja") "innokas" ; --UNCHK
lin afield_Adv = mkWAdv "kaukana" "aiheesta" ; --UNCHK
lin afire_A = mkWA (k10 "oleva") "liekeissä" ; --UNCHK
lin aflame_A = mkWA (k10 "oleva") "liekeissä" ; --UNCHK
lin aflare_A = mkWA (k10 "oleva") "liekeissä" ; --UNCHK
lin aflatoxin_N = mkWN (compoundN "afla" (k5 "toksiini")) ; --UNCHK
lin afloat_A = mkWA (k99 "varassa") "veden" ; --UNCHK
lin aflutter_A = mkWA (k47 "hermostunut") ; --UNCHK
lin afoot_A = mkWA (k99 "meneillään") ; --UNCHK
lin afoot_Adv = mkWAdv (k99 "jalkaisin") ; --UNCHK
lin aforesaid_A = mkWA (k10 "oleva") "kyseessä" ; --UNCHK
lin afraid_A = mkWA (k10 "oleva") "peloissaan" ; --UNCHK
lin afresh_Adv = mkWAdv (k99 "uudelleen") ; --UNCHK
lin africanFem_N = mkWN "Afrikka" ; --UNCHK
lin africanMasc_N = mkWN "Afrikka" ; --UNCHK
lin african_A = mkWA (k38 "afrikkalainen") ; --UNCHK
lin afrikanerFem_N = mkWN (k5 "buuri") ; --UNCHK
lin afrikanerMasc_N = mkWN (k5 "buuri") ; --UNCHK
lin afrikaner_A = mkWA (compoundA "buuri" (k38 "lainen")) ; --UNCHK
lin afro_americanFem_N = variants {} ; ---- sense to be split
lin afro_americanMasc_N = variants {} ; ---- sense to be split
lin aft_Adv = mkWAdv (k99 "taakse") ; --UNCHK
lin after_A = mkWA (k99 "takana") ; --UNCHK
lin after_Adv = mkWAdv (k99 "sittemmin") ; --UNCHK
lin after_Prep = S.after_Prep ;
lin after_Subj = lin Subj (ss "sen jälkeen kun") ;
lin afterburner_N = mkWN (compoundN "jälki" (k33A "poltin")) ; --UNCHK
lin aftercare_N = mkWN (compoundN "jälki" (k1A "hoito")) ; --UNCHK
lin afterdamp_N = mkWN (compoundN "kaivos" (k1 "kaasu")) ; --UNCHK
lin afterdeck_N = mkWN (compoundN "perä" (k28 "kansi")) ; --UNCHK
lin aftereffect_N = mkWN (k39 "seuraus") ; --UNCHK
lin afterglow_N = mkWN (compoundN "jälki" (k48 "loiste")) ; --UNCHK
lin afterimage_N = mkWN (compoundN "jälki" (k10 "kuva")) ; --UNCHK
lin afterlife_N = mkWN (k10 "elämä") "kuolemanjälkeinen" ; --UNCHK
lin aftermath_N = mkWN (k39 "seuraus") ; --UNCHK
lin aftermost_A = mkWA (k38 "takimmainen") ; --UNCHK
lin afternoon_N = mkN "ilta" (mkN "päivä") ;
lin afterpiece_N = mkWN (compoundN "jälki" (k39 "näytös")) ; --UNCHK
lin aftershaft_N = mkWN (compoundN "jälki" (k1A "ruoto")) ; --UNCHK
lin aftershafted_A = mkWA (compoundA "jälki" (k38 "ruotoinen")) ; --UNCHK
lin aftershock_N = mkWN (compoundN "jälki" (k39 "järistys")) ; --UNCHK
lin aftertaste_N = mkWN (compoundN "jälki" (k1A "maku")) ; --UNCHK
lin afterthought_N = mkWN (k10 "lisä") "myöhempi" ; --UNCHK
lin afterwards_Adv = mkWAdv (k99 "sittemmin") ; --UNCHK
lin afterworld_N = mkWN (k10 "elämä") "tuonpuoleinen" ; --UNCHK
lin again_Adv = mkAdv "taas" | mkAdv "uudelleen" ;
lin against_Prep = postPrep partitive "vastaan" ;
lin agal_N = mkWN "agal" ; --UNCHK
lin agalactia_N = mkWN (compoundN "puu" (k38 "ttuminen")) "maidonerityksen" ; --UNCHK
lin agama_N = mkWN (k1 "agamalisko") ; --UNCHK
lin agamete_N = mkWN "agameetti" ; --UNCHK
lin agamic_A = mkWA (k38 "partenogeneettinen") ; --UNCHK
lin agamid_N = mkWN (k1 "agamid-lisko") ; --UNCHK
lin agammaglobulinemia_N = mkWN "agammaglobulinemia" ; --UNCHK
lin agapanthus_N = mkWN (compoundN "sini" (k9 "sarja")) ; --UNCHK
lin agape_A = mkWA (k99 "ammollaan") ; --UNCHK
lin agape_N = mkWN (compoundN "rakkauden" (k12 "ateria")) ; --UNCHK
lin agar_N = mkWN (k6 "agar-agar") ; --UNCHK
lin agaric_N = mkWN (compoundN "heltta" (k26 "sieni")) ; --UNCHK
lin agate_N = mkWN (k5A "akaatti") ; --UNCHK
lin agateware_N = mkWN (compoundN "akaatti" (k9A "keramiikka")) ; --UNCHK
lin agave_N = mkWN (k8 "agaave") ; --UNCHK
lin agaze_A = mkWA (compoundA "tuij" (k10 "ottava")) ; --UNCHK
lin age_N = mkN "ikä" "iän" "ikää" "ikänä" "ikään" "ikien" "ikiä" "ikinä" "i'issä" "ikiin" ;
lin age_V = mkWV (k52A "vanhentua") ; --UNCHK
lin age_bracket_N = mkWN (k5A "kohortti") ; --UNCHK
lin age_group_N = mkWN (k5A "kohortti") ; --UNCHK
lin aged_Prep = variants {} ; --
lin agedness_N = mkWN (k40 "vanhuus") ; --UNCHK
lin ageing_N = mkWN (compoundN "ikä" (k38 "äntyminen")) ; --UNCHK
lin ageism_N = mkWN (compoundN "ikä" (k9A "syrjintä")) ; --UNCHK
lin ageless_A = mkWA (k34A "loputon") ; --UNCHK
lin agelessness_N = mkWN "iättömyys" ; --UNCHK
lin age_long_A = mkWA (compoundA "elin" (k38 "aikainen")) ; --UNCHK
lin agency_N = mkN "virasto" ;
lin agenda_N = mkN (lin NK {s = d10 "suunnitelma"}) ;
lin agenesis_N = mkWN "ageneesi" ; --UNCHK
lin agentFem_N = mkWN (k5A "agentti") ;
lin agentMasc_N = mkN "agentti" | mkN "edustaja" ;
lin agent_provocateur_N = mkWN (k6 "provokaattori") ;
lin agential_A = mkWA "agentuurin" ; --UNCHK
lin agerasia_N = mkWN (k40 "nuorekkuus") ; --UNCHK
lin ageratum_N = mkWN (compoundN "sini" (k38 "tähtönen")) ; --UNCHK
lin agglomerate_A = mkWA (compoundA "kas" (k47 "aantunut")) ; --UNCHK
lin agglomerate_N = mkWN (k1A "keko") ; --UNCHK
lin agglomerate_V = mkWV (k52A "kasaantua") "yhteen" ; --UNCHK
lin agglomerate_V2 = mkWV2 (k52A "kasaantua") "yhteen" ; --UNCHK
lin agglomeration_N = mkWN (compoundN "kas" (k38 "autuminen")) ; --UNCHK
lin agglutinate_A = mkWA (k15 "tahmea") ; --UNCHK
lin agglutinate_V2 = mkWV2 (k52A "liimautua") "yhteen" ; --UNCHK
lin agglutination_N = mkWN "agglutinaatio" ; --UNCHK
lin agglutinative_A = mkWA (k15 "tahmea") ; --UNCHK
lin agglutinin_N = mkWN (compoundN "aggluti" (k26 "niini")) ; --UNCHK
lin agglutinogen_N = mkWN (compoundN "agglutino" (k5 "geeni")) ; --UNCHK
lin aggrandize_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin aggrandizement_N = mkWN (compoundN "lisä" (k38 "äminen")) ; --UNCHK
lin aggravate_V2 = mkV2 "pahentaa" partitive ;
lin aggravating_A = mkWA (k10 "raskauttava") ; --UNCHK
lin aggravation_N = mkWN (compoundN "pahe" (k38 "neminen")) ; --UNCHK
lin aggravator_N = mkWN (k2 "henkilö") "ärsyttävä" ; --UNCHK
lin aggregate_A = mkWA "massa-" ; --UNCHK
lin aggregate_N = mkWN (k40 "kokonaisuus") ;
lin aggregate_V = mkWV (k74A "koota") ; --UNCHK
lin aggregate_V2 = mkWV2 (k74A "koota") ; --UNCHK
lin aggregation_N = mkWN (k2 "keräily") ; --UNCHK
lin aggression_N = mkWN (k39 "hyökkäys") ; --UNCHK
lin aggressive_A = mkA "aggressiivinen" ; --f86
lin aggressiveness_N = mkWN (k40 "sotaisuus") ; --UNCHK
lin aggressorFem_N = mkWN (k10 "alkaja") "riidan" ; --UNCHK
lin aggressorMasc_N = mkWN (k10 "alkaja") "riidan" ; --UNCHK
lin aggrieve_V2 = mkWV2 (k52 "pahastua") ; --UNCHK
lin aghast_A = mkWA (k10 "oleva") "shokissa" ; --UNCHK
lin agile_A = mkWA (k10 "sukkela") ; --UNCHK
lin agility_N = mkWN (k40 "vikkelyys") ; --UNCHK
lin aging_N = mkWN (compoundN "ikä" (k38 "äntyminen")) ; --UNCHK
lin agio_N = mkWN (k3 "preemio") ; --UNCHK
lin agitate_V = mkWV (k53A "muuttaa") ; --UNCHK
lin agitate_V2 = mkWV2 (k53A "muuttaa") ; --UNCHK
lin agitation_N = mkWN (k48A "liike") "raju" ; --UNCHK
lin agitative_A = mkWA (k34A "sietämätön") ; --UNCHK
lin agitator_N = mkWN (k10 "lietsoja") ; --UNCHK
lin agitprop_N = mkWN (compoundN "kiihotus" (k9 "propaganda")) ; --UNCHK
lin agleam_A = mkWA (k41A "kirkas") ; --UNCHK
lin aglet_N = mkWN (compoundN "yleisesikunta" (k39 "punos")) ; --UNCHK
lin aglow_A = mkWA (k10 "loistava") ; --UNCHK
lin agnail_N = mkWN (compoundN "kynsi" (k5 "valli")) ; --UNCHK
lin agnate_A = mkWA (compoundA "isän" (k38 "puoleinen")) ; --UNCHK
lin agnate_N = mkWN (k40 "sukulaisuus") "isänpuoleinen" ; --UNCHK
lin agnomen_N = mkWN (compoundN "lisä" (k7 "nimi")) ; --UNCHK
lin agnosia_N = mkWN "tajuamattomuus" ; --UNCHK
lin agnostic_A = mkWA (k38 "agnostinen") ; --UNCHK
lin agnostic_N = mkWN (k4A "agnostikko") ; --UNCHK
lin agnosticism_N = mkWN (k40 "epäileväisyys") ; --UNCHK
lin ago_A = mkWA (k99 "sitten") ; --UNCHK
lin ago_Adv = mkAdv "sitten" ;
lin ago_Prep = postPrep nominative "sitten" ;
lin agog_A = mkWA (k41A "innokas") ; --UNCHK
lin agon_N = mkWN "agon" ; --UNCHK
lin agonadal_A = mkWA (compoundA "agonada" (k38 "alinen")) ; --UNCHK
lin agonal_A = mkWA (compoundA "agona" (k38 "alinen")) ; --UNCHK
lin agonist_N = mkWN (compoundN "ago" (k5 "nisti")) ; --UNCHK
lin agonistic_A = mkWA "agonistinen" ; --UNCHK
lin agonize_V = mkWV (k67 "olla") "kuolemantuskassa" ; --UNCHK
lin agonized_A = mkWA (k38 "tuskainen") ; --UNCHK
lin agonizingly_Adv = mkWAdv (compoundAdv "piinaav" (k99 "asti")) ; --UNCHK
lin agony_N = mkWN (k39 "kidutus") ; --UNCHK
lin agora_N = mkWN (k5 "tori") ; --UNCHK
lin agoraphobia_N = mkWN (k1A "pelko") "julkisten" "paikkojen" ; --UNCHK
lin agouti_N = mkWN "aguti" ; --UNCHK
lin agra_PN = foreignPN "Agra" ;
lin agranulocytic_A = mkWA (compoundA "jyväsoluka" (k38 "toinen")) ; --UNCHK
lin agranulocytosis_N = mkWN (compoundN "jyvässolu" (k1A "kato")) ; --UNCHK
lin agraphia_N = mkWN (compoundN "kirjoitus" (k40 "kyvyttömyys")) ; --UNCHK
lin agraphic_A = mkWA (compoundA "kirjoittamis" (k34A "kyvytön")) ; --UNCHK
lin agrarian_A = mkWA (k38 "agraarinen") ; --UNCHK
lin agree_V = mkV olla_V "samaa mieltä" ;
lin agree_VS = mkVS (mkV "sopia") ;
lin agree_VV = mkVV (mkV "suostua") infIllat ;
lin agree_on_V = advV OP_agree_V OP_on_Adv ; -- guess-p-verb
lin agree_with_V2 = prepV2 OP_agree_V OP_with_Prep ; -- guess-p-verb
lin agreeable_A = mkWA (k10 "rakastettava") ; --UNCHK
lin agreeableness_N = mkWN (k40 "miellyttävyys") ; --UNCHK
lin agreed_A = variants {} ; --
lin agreement_N = mkN "sopimus" ;
lin agrestic_A = mkWA (k15 "karkea") ; --UNCHK
lin agribusiness_N = mkWN (compoundN "maa" (k40 "talous")) ; --UNCHK
lin agricultural_A = mkA (mkN "maan" (mkN "viljelyllinen")) ;
lin agriculture_N = mkWN (compoundN "maa" (k40 "talous")) ;
lin agriculturist_N = mkWN (k10 "tuottaja") ; --UNCHK
lin agrimonia_N = mkWN (compoundN "maarian" (k26 "verijuuri")) ; --UNCHK
lin agrobiologic_A = mkWA (compoundA "agro" (k38 "biologinen")) ; --UNCHK
lin agrobiology_N = mkWN (compoundN "maatalous" (k12 "biologia")) ; --UNCHK
lin agrologic_A = mkWA (compoundA "agrologi" (k38 "nen")) ; --UNCHK
lin agrology_N = mkWN "agrologia" ; --UNCHK
lin agromania_N = mkWN (compoundN "yksi" (k1 "nolo")) ; --UNCHK
lin agronomic_A = mkWA (compoundA "agronomi" (k38 "nen")) ; --UNCHK
lin agronomist_N = mkWN (k5 "agronomi") ; --UNCHK
lin agronomy_N = mkWN (k12 "agronomia") ; --UNCHK
lin aground_A = mkWA (k10 "oleva") "karilla" ; --UNCHK
lin aground_Adv = mkWAdv "karille" ; --UNCHK
lin agrypnia_N = mkWN (k12 "vigilia") ; --UNCHK
lin agrypnotic_A = mkWA "vigiliaan" "liittyvä" ; --UNCHK
lin agua_N = mkWN (compoundN "aga" (k10 "konna")) ; --UNCHK
lin ague_N = mkWN (k5A "akuutti") ; --UNCHK
lin agueweed_N = mkWN (compoundN "amerikanvalko" (k9 "latva")) ; --UNCHK
lin aguish_A = mkWA (compoundA "vilu" (k38 "tautinen")) ; --UNCHK
lin ah_Interj = mkInterj "aah" ;
lin ahead_Adv = mkWAdv (k99 "edellä") ;
lin ahead_of_Prep = mkPrep "edellä" ;
lin ahimsa_N = mkWN "ahimsa" ; --UNCHK
lin ahistorical_A = mkWA (compoundA "epä" (k38 "historiallinen")) ; --UNCHK
lin ahmedabad_PN = foreignPN "Ahmedabad" ;
lin aid_N = mkN (lin NK {s = d01A "apu"}) ;
lin aid_V = mkV vOlla "avuksi" ;
lin aid_V2 = mkWV2 (k67 "olla") "avuksi" ; --UNCHK
lin aide_N = mkWN (k10 "avustaja") ; --UNCHK
lin aids_N = mkWN (k5 "AIDS") ; --UNCHK
lin aigret_N = mkWN (compoundN "töyhtö" (k48 "koriste")) ; --UNCHK
lin aigrette_N = mkWN (compoundN "töyhtö" (k48 "koriste")) ; --UNCHK
lin aikido_N = mkWN (k2 "aikido") ; --UNCHK
lin ail_V = mkV "sairastaa" ;
lin ail_V2 = mkWV2 (k53A "satuttaa") ; --UNCHK
lin ailanthus_N = mkWN (compoundN "jumalten" (k18 "puu")) ; --UNCHK
lin aileron_N = mkWN (k48A "siiveke") ; --UNCHK
lin ailment_N = mkWN (k9 "vaiva") ;
lin ailurophobia_N = mkWN (compoundN "kissa" (k1 "kammo")) ; --UNCHK
lin aim_N = mkWN (k33 "tähtäin") ; --UNCHK
lin aim_V = mkV "tähdätä" ;
lin aim_V2 = mkV2 (mkV "tähdätä") (casePrep illative) ; --f71
lin aim_VV = mkVV (mkV "aikoa") ;
lin aim_at_V2 = prepV2 OP_aim_V OP_at_Prep ; -- guess-p-verb
lin aimless_A = mkWA (k34A "päämäärätön") ; --UNCHK
lin aioli_N = mkWN (compoundN "valkosipuli" (k48A "kastike")) ; --UNCHK
lin air_N = mkN "ilma" ;
lin air_V = mkV "tuulettua" ; --mkWV (k53A "tuulettaa") ;
lin air_V2 = mkWV2 (k53A "tuulettaa") partitive ;
lin air_bladder_N = mkWN (compoundN "uima" (k1A "rakko")) ; --UNCHK
lin air_conditioned_A = mkA "ilmastoitu" ;
lin air_conditioning_N = mkWN (k5A "ilmastointi") ; --UNCHK
lin air_pump_N = mkWN (compoundN "tyhjiö" (k1A "pumppu")) ; --UNCHK
lin air_raid_N = mkWN (compoundN "ilma" (k39 "hyökkäys")) ; --UNCHK
lin air_shaft_N = mkWN (compoundN "ilmanvaihto" (k1 "kuilu")) ; --UNCHK
lin air_sick_A = mkWA (compoundA "meri" (k41 "sairas")) ; --UNCHK
lin air_sickness_N = mkWN (compoundN "ilma" (k40 "sairaus")) ; --UNCHK
lin airborne_A = mkWA (k10 "oleva") "ilmassa" ; --UNCHK
lin airbrake_N = mkWN (compoundN "ilma" (k1 "jarru")) ; --UNCHK
lin airbrush_N = mkWN (compoundN "retussi" (k1 "ruisku")) ; --UNCHK
lin airburst_N = mkWN (compoundN "ilma" (k39 "räjähdys")) ; --UNCHK
lin airbus_N = mkWN (compoundN "lento" (k5 "bussi")) ; --UNCHK
lin aircraft_N = mkWN (compoundN "lento" (k48 "kone")) ; --f85
lin aircraftman_N = mkWN "lentosotamies" ; --UNCHK
lin aircraftsman_N = mkWN "lentosotamies" ; --UNCHK
lin aircrew_N = mkWN (k2 "miehistö") "lentokoneen" ; --UNCHK
lin aircrewman_N = mkWN (k32 "jäsen") "lentokoneen" "miehistön" ; --UNCHK
lin airdock_N = mkWN (k5 "lentokonehalli") ; --UNCHK
lin airdrie_PN = foreignPN "Airdrie" ;
lin airdrop_N = mkWN (compoundN "laskuvarjo" (k39 "pudotus")) ; --UNCHK
lin airedale_N = mkWN (compoundN "airedalen" (k5 "terrieri")) ; --UNCHK
lin airfare_N = mkWN (k9A "hinta") "lentolipun" ; --UNCHK
lin airfield_N = mkWN (k10A "kenttä") ; --UNCHK
lin airflow_N = mkWN (k39 "virtaus") "ilman" ; --UNCHK
lin airfoil_N = mkWN (k9A "pinta") ; --UNCHK
lin airframe_N = mkWN (k1A "runko") ; --UNCHK
lin airhead_N = mkWN "ilmasillanpää" ; --UNCHK
lin airheaded_A = mkWA (k10 "tyhmä") ; --UNCHK
lin airiness_N = mkWN (k40 "herkkyys") ; --UNCHK
lin airing_N = mkWN (k39 "tuuletus") ; --UNCHK
lin airing_cupboard_N = mkWN (compoundN "kuivaus" (k5A "kaappi")) ; --UNCHK
lin airless_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin airlift_N = mkWN (compoundN "ilma" (k39 "kuljetus")) ; --UNCHK
lin airline_N = mkN "lento" (mkN "yhtiö" "yhtiöitä") ;
lin airliner_N = mkWN "matkustajalentokone" ; --UNCHK
lin airlock_N = mkWN (compoundN "ilma" (k1A "lukko")) ; --UNCHK
lin airmail_N = mkWN (k5 "lentoposti") ; --UNCHK
lin airmailer_N = mkWN "lentopostittaja" ; --UNCHK
lin airman_N = mkWN (k5A "pilotti") ; --UNCHK
lin airplane_N = L.airplane_N ;
lin airport_N = mkWN (compoundN "lento" (k10A "kenttä")) ;
lin airs_N = mkWN (k2 "tärkeily") ; --UNCHK
lin airscrew_N = mkWN (k6 "potkuri") ; --UNCHK
lin airship_N = mkWN (compoundN "ilma-" (k39 "alus")) ; --UNCHK
lin airspace_N = mkWN (compoundN "ilma" (k9 "tila")) ; --UNCHK
lin airspeed_N = mkWN (compoundN "lento" (k40 "nopeus")) ; --UNCHK
lin airstream_N = mkWN (k9A "virta") "voimakas" ; --UNCHK
lin airstrip_N = mkWN (compoundN "kiito" (k19 "tie")) ; --UNCHK
lin airtight_A = mkWA (k10 "pitävä") ; --UNCHK
lin airway_N = mkWN (k10 "harjoittaja") "lentoliikenteen" ; --UNCHK
lin airwoman_N = mkWN (compoundN "nais" (k10 "lentäjä")) ; --UNCHK
lin airworthiness_N = mkWN (compoundN "lento" (k40 "kelpoisuus")) ; --UNCHK
lin airworthy_A = mkWA (compoundA "lento" (k38 "kelpoinen")) ; --UNCHK
lin airy_A = mkWA (k38 "eteerinen") ; --UNCHK
lin aisle_N = mkWN (k10 "käytävä") ; --UNCHK
lin aitchbone_N = mkWN (compoundN "reisi" (k9 "pala")) ; --UNCHK
lin ajar_A = mkWA (k99 "raollaan") ; --UNCHK
lin akaa_PN = mkPN "Akaa" ;
lin akaryocyte_N = mkWN "akaryootti" ; --UNCHK
lin akimbo_Adv = mkWAdv (k99 "puuskassa") ; --UNCHK
lin akin_A = mkWA (k38 "sukulainen") ; --UNCHK
lin akinesis_N = mkWN "akinesia" ; --UNCHK
lin akron_PN = foreignPN "Akron" ;
lin ala_N = mkWN (k7A "siipi") ; --UNCHK
lin alabama_PN = mkPN "Alabama" ;
lin alabaster_A = mkWA (compoundA "alabasteri" (k38 "mainen")) ; --UNCHK
lin alabaster_N = mkWN (k6 "alabasteri") ; --UNCHK
lin alacritous_A = mkWA (k15 "ripeä") ; --UNCHK
lin alacrity_N = mkWN (k1A "into") ; --UNCHK
lin alahärmä_PN = mkPN "Alahärmä" ;
lin alajärvi_PN = mkPN (mkN "Alajärvi" "Alajärviä") ;
lin alalia_N = mkWN "alalia" ; --UNCHK
lin alanine_N = mkWN (compoundN "ala" (k26 "niini")) ; --UNCHK
lin alar_A = mkWA (compoundA "siipi" (k38 "mäinen")) ; --UNCHK
lin alarm_N = mkWN (k33A "hälytin") ; --UNCHK
lin alarm_V2 = mkV2 "hälyttää" ;
lin alarm_clock_N = mkWN (compoundN "herätys" (k1 "kello")) ; --UNCHK
lin alarming_A = mkWA (compoundA "huoles" (k10 "tuttava")) ; --UNCHK
lin alarmism_N = mkWN (compoundN "alarm" (k5 "ismi")) ; --UNCHK
lin alarmist_N = mkWN "alarmisti" ; --UNCHK
lin alas_Interj = mkInterj "voi voi" ;
lin alaska_PN = mkPN "Alaska" ;
lin alastaro_PN = mkPN "Alastaro" ;
lin alastrim_N = mkWN (k51 "isorokko") "Länsi-Intian" ; --UNCHK
lin alate_A = mkWA (k38 "siivellinen") ; --UNCHK
lin alavieska_PN = mkPN "Alavieska" ;
lin alavus_PN = mkPN "Alavus" ;
lin alb_N = mkWN (k9 "alba") ; --UNCHK
lin albacore_N = mkWN (compoundN "pitkäevätonni" (k9 "kala")) ; --UNCHK
lin albania_PN = foreignPN "Albania" ;
lin albanian_A = mkWA (k38 "albanialainen") ; --UNCHK
lin albanian_N = mkWN (k38 "albanialainen") ; --UNCHK
lin albatross_N = mkWN (k5 "albatrossi") ; --UNCHK
lin albedo_N = mkWN (compoundN "heijastus" (k1 "teho")) ; --UNCHK
lin albeit_Subj = mkSubj "vaikkakin" ; --
lin albert_PN = foreignPN "Albert" ;
lin albescent_A = mkWA (compoundA "valke" (k9 "neva")) ; --UNCHK
lin albinal_A = mkWA (compoundA "albina" (k38 "alinen")) ; --UNCHK
lin albinism_N = mkWN (k5 "albinismi") ; --UNCHK
lin albino_N = mkWN (k2 "albiino") ; --UNCHK
lin albite_N = mkWN "valkoinen" "maasälpä" ; --UNCHK
lin albitic_A = mkWA "albiittinen" ; --UNCHK
lin albizzia_N = mkWN (compoundN "aka" (k12 "asia")) ; --UNCHK
lin albuca_N = mkWN "albuca" ; --UNCHK
lin albuginea_N = mkWN "albuginea" ; --UNCHK
lin album_N = mkWN (k6 "albumi") ; --UNCHK
lin albumen_N = mkWN (k38 "valkuainen") ; --UNCHK
lin albumin_N = mkWN "albumiini" ; --UNCHK
lin albuminous_A = mkWA (compoundA "albumiini" (k38 "mainen")) ; --UNCHK
lin albuminuria_N = mkWN "proteinuria" ; --UNCHK
lin albuminuric_A = mkWA (compoundA "albumi" (k38 "nuurinen")) ; --UNCHK
lin albuterol_N = mkWN "Proventil" ; --UNCHK
lin alcalde_N = mkWN (k6 "pormestari") ; --UNCHK
lin alcazar_N = mkWN (k5 "palatsi") "arabityylinen" ; --UNCHK
lin alchemic_A = mkWA (compoundA "alkemia" (k38 "llinen")) ; --UNCHK
lin alchemist_N = mkWN (k5 "alkemisti") ; --UNCHK
lin alchemistic_A = mkWA (compoundA "alkemisti" (k38 "nen")) ; --UNCHK
lin alchemy_N = mkWN (k12 "alkemia") ; --UNCHK
lin alcohol_N = mkWN (k9 "viina") ; --UNCHK
lin alcoholic_A = mkWA (compoundA "alkoholipi" (k38 "toinen")) ; --UNCHK
lin alcoholic_N = mkWN (k6 "juomari") ; --UNCHK
lin alcoholism_N = mkWN (k5 "alkoholismi") ; --UNCHK
lin alcove_N = mkWN (k39 "syvennys") ; --UNCHK
lin aldehyde_N = mkWN "aldehydi" ; --UNCHK
lin aldehydic_A = mkWA "aldehydi-" ; --UNCHK
lin alder_N = mkWN (k10A "leppä") ; --UNCHK
lin alderfly_N = mkWN (compoundN "kaisla" (k1A "korento")) ; --UNCHK
lin alderman_N = mkWN (k5 "oltermanni") ; --UNCHK
lin aldershot_PN = foreignPN "Aldershot" ;
lin aldohexose_N = mkWN (compoundN "aldohek" (k5 "soosi")) ; --UNCHK
lin aldol_N = mkWN (compoundN "aldehydi" (k5 "alkoholi")) ; --UNCHK
lin aldose_N = mkWN "aldoosi" ; --UNCHK
lin aldosterone_N = mkWN "aldosteroni" ; --UNCHK
lin aldosteronism_N = mkWN (compoundN "hyperaldosteron" (k5 "ismi")) ; --UNCHK
lin aleatory_A = mkWA (compoundA "ale" (k38 "atorinen")) ; --UNCHK
lin alee_Adv = mkWAdv "suojapuolelle" ; --UNCHK
lin alembic_N = mkWN (k5A "retortti") ; --UNCHK
lin alendronate_N = mkWN (compoundN "alendro" (k5A "naatti")) ; --UNCHK
lin aleph_N = mkWN "aalef" ; --UNCHK
lin aleppo_PN = foreignPN "Aleppo" ;
lin alert_A = mkWA (k15 "virkeä") ; --UNCHK
lin alert_N = mkWN (k2 "koneisto") "merkinantolaitteen" ; --UNCHK
lin alert_V2 = mkV2 "varoittaa" partitive ;
lin alertness_N = mkWN (k40 "vireys") ; --UNCHK
lin alessandria_PN = foreignPN "Alessandria" ;
lin aleurone_N = mkWN "aleuroni" ; --UNCHK
lin aleuronic_A = mkWA (compoundA "ale" (k38 "uroninen")) ; --UNCHK
lin alewife_N = mkWN (compoundN "pilkku" (k5 "silli")) ; --UNCHK
lin alexander_PN = foreignPN "Alexander" ;
lin alexandra_PN = foreignPN "Alexandra" ;
lin alexandria_PN = foreignPN "Aleksandria" ;
lin alexandrine_N = mkWN (compoundN "aleksandri" (k38 "alainen")) ; --UNCHK
lin alexandrite_N = mkWN (compoundN "aleksand" (k5A "riitti")) ; --UNCHK
lin alexia_N = mkWN (k12 "afasia") "visuaalinen" ; --UNCHK
lin alexic_A = mkWA (compoundA "sana" (k15 "sokea")) ; --UNCHK
lin alexic_N = mkWN (compoundN "sana" (k15 "sokea")) ; --UNCHK
lin alf_PN = foreignPN "Alf" ;
lin alfalfa_N = mkWN (compoundN "sini" (k38 "mailanen")) ; --UNCHK
lin alfred_PN = foreignPN "Alfred" ;
lin alfresco_A = mkWA "ulko-" ; --UNCHK
lin alfresco_Adv = mkWAdv (k99 "ulkosalla") ; --UNCHK
lin alfreton_PN = foreignPN "Alfreton" ;
lin alga_N = mkWN (k10 "levä") ; --UNCHK
lin algal_A = mkWA (compoundA "levä" (k38 "mäinen")) ; --UNCHK
lin algarroba_N = mkWN (compoundN "juliifl" (k10 "ora")) "Prosopis" ; --UNCHK
lin algebra_N = mkWN (k11 "algebra") ; --UNCHK
lin algebraic_A = mkWA (k38 "algebrallinen") ; --UNCHK
lin algebraical_A = mkWA (k38 "algebrallinen") ; --UNCHK
lin algebraist_N = mkWN (compoundN "algeb" (k5 "risti")) ; --UNCHK
lin algeria_PN = foreignPN "Algeria" ;
lin algerian_A = mkWA (compoundA "algeri" (k38 "alainen")) ; --UNCHK
lin algerian_N = mkWN (compoundN "algeri" (k38 "alainen")) ; --UNCHK
lin algid_A = mkWA (compoundA "jää" (k10 "kylmä")) ; --UNCHK
lin algidity_N = mkWN (k40 "kylmyys") ; --UNCHK
lin algin_N = mkWN (compoundN "algiini" (k1A "happo")) ; --UNCHK
lin algoid_A = mkWA (compoundA "levä" (k38 "mäinen")) ; --UNCHK
lin algolagnia_N = mkWN "algofilia" ; --UNCHK
lin algolagnic_A = mkWA "algolagninen" ; --UNCHK
lin algometer_N = mkWN (compoundN "algo" (k5 "metri")) ; --UNCHK
lin algometric_A = mkWA (compoundA "algo" (k38 "metrinen")) ; --UNCHK
lin algometry_N = mkWN "algometria" ; --UNCHK
lin algophobia_N = mkWN (compoundN "algo" (k12 "fobia")) ; --UNCHK
lin algophobic_A = mkWA "algofobinen" ; --UNCHK
lin algorism_N = mkWN (compoundN "algor" (k5 "ismi")) ; --UNCHK
lin algorithm_N = mkWN (k10 "ohjelma") "algoritminen" ; --UNCHK
lin algorithmic_A = mkWA (compoundA "algoritmi" (k38 "nen")) ; --UNCHK
lin alias_Adv = mkWAdv (k99 "alias") ; --UNCHK
lin alias_N = mkWN (k7 "nimi") "väärä" ; --UNCHK
lin alibi_N = mkWN (k1 "olo") "muualla" ; --UNCHK
lin alicante_PN = foreignPN "Alicante" ;
lin alice_PN = foreignPN "Alice" ;
lin alidade_N = mkWN "alhidadi" ; --UNCHK
lin alienFem_N = mkN "muukalainen" ;
lin alienMasc_N = mkN "muukalainen" ;
lin alien_A = mkWA (k38 "eksoottinen") ; --UNCHK
lin alienable_A = mkWA (k10 "oleva") "siirrettävissä" ; --UNCHK
lin alienage_N = mkWN (k40 "muukalaisuus") ; --UNCHK
lin alienate_V2 = mkWV2 (k71 "tehdä") "tyytymättömäksi" ; --UNCHK
lin alienating_A = mkWA "vieraannuttava" ; --UNCHK
lin alienation_N = mkWN (compoundN "etä" (k38 "ännyttäminen")) ; --UNCHK
lin alienator_N = mkWN "vieraannuttaja" ; --UNCHK
lin alienee_N = mkWN (k10 "omistaja") "uusi" ; --UNCHK
lin alienism_N = mkWN (k40 "muukalaisuus") ; --UNCHK
lin alienist_N = mkWN (compoundN "alie" (k5 "nisti")) ; --UNCHK
lin alienor_N = mkWN (k10 "siirtäjä") ; --UNCHK
lin alight_A = mkWA (k10 "oleva") "liekeissä" ; --UNCHK
lin alight_V = mkWV (k52A "laskeutua") ; --UNCHK
lin align_V2 = mkV2 (mkV (mkV "asettaa") "rinnakkain") ;
lin alignment_N = mkWN (k39 "kohdistus") ; --UNCHK
lin alike_A = mkWA (k38 "samanlainen") ; --UNCHK
lin alike_Adv = mkWAdv (k99 "samoin") ; --UNCHK
lin alimentary_A = mkWA (k10 "ravitseva") ; --UNCHK
lin alimentative_A = mkWA "ylläpito-" ; --UNCHK
lin alimony_N = mkWN (compoundN "elatus" (k1A "apu")) ; --UNCHK
lin aliphatic_A = mkWA (compoundA "suo" (k38 "raketjuinen")) ; --UNCHK
lin aliquot_A = mkWA "alikvootti" ; --UNCHK
lin aliquot_N = mkWN (k1A "luku") "tasan" "menevä" ; --UNCHK
lin aliterate_N = mkWN (k2 "henkilö") "kirjallisesti" "sivistymätön" ; --UNCHK
lin alive_A = mkWA (k99 "hengissä") ; --UNCHK
lin aliyah_N = mkWN "alija" ; --UNCHK
lin alizarin_N = mkWN "alitsariini" ; --UNCHK
lin alkahest_N = mkWN (k33A "liuotin") "universaali" ; --UNCHK
lin alkahestic_A = mkWA "alkahestinen" ; --UNCHK
lin alkalemia_N = mkWN (compoundN "emäs" (k40 "verisyys")) ; --UNCHK
lin alkalescent_A = mkWA (k38 "emäksinen") "heikosti" ; --UNCHK
lin alkali_N = mkWN (k6 "alkali") ; --UNCHK
lin alkalimetry_N = mkWN "alkalimetria" ; --UNCHK
lin alkalinity_N = mkWN (k40 "emäksisyys") ; --UNCHK
lin alkalinuria_N = mkWN "alkaluria" ; --UNCHK
lin alkaloid_N = mkWN (k5 "alkaloidi") ; --UNCHK
lin alkaloidal_A = mkWA (compoundA "alkaloidi" (k38 "nen")) ; --UNCHK
lin alkalosis_N = mkWN (compoundN "alka" (k5 "loosi")) ; --UNCHK
lin alkalotic_A = mkWA "alkaloottinen" ; --UNCHK
lin alkapton_N = mkWN (compoundN "homogentisiini" (k1A "happo")) ; --UNCHK
lin alkaptonuria_N = mkWN "alkaptonuria" ; --UNCHK
lin alkene_N = mkWN (compoundN "ole" (k5 "fiini")) ; --UNCHK
lin alkyd_N = mkWN (k5 "alkydi") ; --UNCHK
lin alkyl_N = mkWN (compoundN "alkyyli" (k5 "radikaali")) ; --UNCHK
lin alkylbenzene_N = mkWN "alkyylibentseeni" ; --UNCHK
lin alkylbenzenesulfonate_N = mkWN (compoundN "alkyylibentseenisulfo" (k5A "naatti")) ; --UNCHK
lin alkylic_A = mkWA (compoundA "alky" (k38 "ylinen")) ; --UNCHK
lin all_A = mkWA (kH1 "koko") ; --UNCHK
lin all_Predet = S.all_Predet ;
lin allamanda_N = mkWN (compoundN "köynnöskustaan" (k10A "kukka")) ; --UNCHK
lin allan_PN = foreignPN "Allan" ;
lin allantoic_A = mkWA "allantoiskalvoon" "liittyvä" ; --UNCHK
lin allantoid_A = mkWA (compoundA "makkaran" (k38 "muotoinen")) ; --UNCHK
lin allantois_N = mkWN (compoundN "rakko" (k1 "kalvo")) ; --UNCHK
lin allay_V2 = mkWV2 (k53A "tyydyttää") ; --UNCHK
lin allegation_N = mkWN (k48A "väite") ;
lin allege_V2 = mkV2 "väittää" ;
lin allege_VS = mkVS (mkV "väittää") ;
lin alleged_A = mkA "väitetty" ;
lin allegedly_AdA = mkAdA "muka" ;
lin allegedly_AdV = mkAdV "väitetysti" ;
lin allegiance_N = mkWN (k5A "lojaliteetti") ; --UNCHK
lin allegiant_A = mkWA (k38 "uskollinen") ; --UNCHK
lin allegoric_A = mkWA (k38 "allegorinen") ; --UNCHK
lin allegorical_A = mkWA (k38 "allegorinen") ; --UNCHK
lin allegorizer_N = mkWN (compoundN "allegori" (k10 "soija")) ; --UNCHK
lin allegory_N = mkWN (k12 "allegoria") ; --UNCHK
lin allegretto_A = mkWA (k99 "nopeasti") "melko" ; --UNCHK
lin allegretto_Adv = mkWAdv (k99 "nopeasti") "melko" ; --UNCHK
lin allegretto_N = mkWN (k99 "nopeasti") "melko" ; --UNCHK
lin allegro_A = mkWA (k99 "nopeasti") ; --UNCHK
lin allegro_Adv = mkWAdv (k99 "nopeasti") ; --UNCHK
lin allegro_N = mkWN (k99 "nopeasti") ; --UNCHK
lin allele_N = mkWN (k5 "alleeli") ; --UNCHK
lin allelic_A = mkWA (compoundA "alle" (k38 "lomorfinen")) ; --UNCHK
lin allemande_N = mkWN (compoundN "muna" (k48A "kastike")) ; --UNCHK
lin allen_PN = foreignPN "Allen" ;
lin allergen_N = mkWN (k5 "allergeeni") ; --UNCHK
lin allergenic_A = mkWA (k38 "allergeeninen") ; --UNCHK
lin allergic_A = mkWA (k38 "allerginen") ; --UNCHK
lin allergist_N = mkWN "allergologi" ; --UNCHK
lin allergology_N = mkWN "allergologia" ; --UNCHK
lin allergy_N = mkWN (k3 "reaktio") "allerginen" ; --UNCHK
lin alleviate_V2 = mkV2 "lievittää" partitive ;
lin alleviation_N = mkWN (k39 "helpotus") ; --UNCHK
lin alleviative_A = mkWA (k38 "palliatiivinen") ; --UNCHK
lin alleviator_N = mkWN "lievittäjä" ; --UNCHK
lin alley_N = mkWN (k10 "käytävä") ; --UNCHK
lin alleyway_N = mkWN (k10 "käytävä") ; --UNCHK
lin alliaceous_A = mkWA "sipuli-" ; --UNCHK
lin alliance_N = mkN "allianssi" | mkN "liitto" ;
lin allied_A = variants {} ; --
lin alligator_N = mkWN (k6 "alligaattori") ; --UNCHK
lin alligatored_A = mkWA (compoundA "patino" (k1A "itu")) ; --UNCHK
lin alligatorfish_N = mkWN (compoundN "alligaattori" (k9 "kala")) ; --UNCHK
lin alliteration_N = mkWN (k3 "allitteraatio") ; --UNCHK
lin alliterative_A = mkWA (compoundA "alku" (k38 "soinnullinen")) ; --UNCHK
lin alliterator_N = mkWN (k10 "käyttäjä") "alkusoinnun" ; --UNCHK
lin alloa_PN = foreignPN "Alloa" ;
lin allocable_A = mkWA (k10 "oleva") "allokoitavissa" ; --UNCHK
lin allocate_V = mkWV (k67 "annostella") ; --UNCHK
lin allocate_V2 = mkWV2 (k67 "annostella") ; --UNCHK
lin allocation_N = mkWN (k39 "varaus") ; --UNCHK
lin allocator_N = mkWN (k12 "jakelija") ; --UNCHK
lin allochronic_A = mkWA "allokroninen" ; --UNCHK
lin allochthonous_A = mkWA "alloktoninen" ; --UNCHK
lin allocution_N = mkWN (k2 "puhuttelu") ; --UNCHK
lin allogamous_A = mkWA (compoundA "risti" (k38 "pölytteinen")) ; --UNCHK
lin allogamy_N = mkWN (compoundN "risti" (k39 "pölytys")) ; --UNCHK
lin allogeneic_A = mkWA "allogeeninen" ; --UNCHK
lin allographic_A = mkWA "allografinen" ; --UNCHK
lin allomerism_N = mkWN (compoundN "allomer" (k5 "ismi")) ; --UNCHK
lin allomerous_A = mkWA "allomerinen" ; --UNCHK
lin allometric_A = mkWA (compoundA "allo" (k38 "metrinen")) ; --UNCHK
lin allometry_N = mkWN "allometria" ; --UNCHK
lin allomorph_N = mkWN "allomorfi" ; --UNCHK
lin allomorphic_A = mkWA "allomorfinen" ; --UNCHK
lin allopathic_A = mkWA "allopaattinen" ; --UNCHK
lin allopathy_N = mkWN "allopatia" ; --UNCHK
lin allopatric_A = mkWA "allopatrinen" ; --UNCHK
lin allopatry_N = mkWN "allopatria" ; --UNCHK
lin allophone_N = mkWN "allofoni" ; --UNCHK
lin allophonic_A = mkWA "allofoninen" ; --UNCHK
lin allopurinol_N = mkWN "Zyloprim" ; --UNCHK
lin allosaur_N = mkWN "allosaurus" ; --UNCHK
lin allot_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin allotment_N = mkN "jakaminen" ; --mkWN (k5A "allokointi") ;
lin allotrope_N = mkWN (compoundN "allotropia" (k1A "muoto")) ; --UNCHK
lin allotropic_A = mkWA (compoundA "allo" (k38 "trooppinen")) ; --UNCHK
lin allotropy_N = mkWN "allotropia" ; --UNCHK
lin allover_A = mkWA (k27 "täysi") ; --UNCHK
lin allow_V2 = mkV2 "hyväksyä" | mkV2 "sallia" ;
lin allow_V2V = mkV2Vf (mkV "sallia") (mkPrep genitive) infFirst ;
lin allow_for_V2 = mkWV2 (k56A "antaa") ; --UNCHK
lin allow_of_V2 = prepV2 (lin V OP_allow_V2) OP_of_Prep ; -- guess-p-verb
lin allowable_A = mkWA (k38 "luvallinen") ; --UNCHK
lin allowance_N = mkN "osuus" ; --WN (k10A "lupa") ;
lin alloy_N = mkWN (k39 "seostus") ; --UNCHK
lin alloy_V2 = mkWV2 (k53 "seostaa") ; --UNCHK
lin allspice_N = mkWN (compoundN "mauste" (k6 "pippuri")) ; --UNCHK
lin allude_V = mkWV (k73 "vihjata") ; --UNCHK
lin allure_N = mkWN (k39 "viehätys") ; --UNCHK
lin allure_V2 = mkWV2 (k53A "viehättää") ; --UNCHK
lin allurement_N = mkWN (k39 "houkutus") ; --UNCHK
lin alluring_A = mkWA (k10 "viehättävä") ; --UNCHK
lin allusion_N = mkWN (k39 "viittaus") ; --UNCHK
lin allusive_A = mkWA "vihjaileva" ; --UNCHK
lin allusiveness_N = mkWN "vihjailevuus" ; --UNCHK
lin alluvial_A = mkWA "alluviaali-" ; --UNCHK
lin alluvion_N = mkWN (k10 "liettymä") ; --UNCHK
lin ally_N = mkN "liittolainen" ;
lin ally_V2 = mkWV2 (k52A "liittoutua") ; --UNCHK
lin allyl_N = mkWN (compoundN "allyyli" (k5 "radikaali")) ; --UNCHK
lin allylic_A = mkWA (compoundA "ally" (k38 "ylinen")) ; --UNCHK
lin alma_mater_N = mkWN (compoundN "yli" (k2 "opisto")) ; --UNCHK
lin almanac_N = mkWN (k9A "almanakka") ; --UNCHK
lin almandine_N = mkWN (compoundN "jalo" (k5A "granaatti")) ; --UNCHK
lin almandite_N = mkWN (compoundN "jalo" (k5A "granaatti")) ; --UNCHK
lin almeria_PN = foreignPN "Almeria" ;
lin almighty_A = mkWA (compoundA "kaikki" (k41 "valtias")) ; --UNCHK
lin almighty_N = mkWN (compoundN "Kaikki" (k41 "valtias")) ; --UNCHK
lin almond_N = mkWN (k6 "manteli") ; --UNCHK
lin almoner_N = mkWN (compoundN "sosiaali" (k10 "hoitaja")) "sairaalan" ; --UNCHK
lin almost_AdA = S.almost_AdA ;
lin almost_AdN = S.almost_AdN ;
lin almost_Adv = mkAdv "melkein" | mkAdv "lähes" ;
lin alms_box_N = mkWN (compoundN "almu" (k4A "laatikko")) ; --UNCHK
lin almsgiver_N = mkWN (compoundN "almun" (k10 "antaja")) ; --UNCHK
lin alnwick_PN = foreignPN "Alnwick" ;
lin alocasia_N = mkWN (compoundN "alok" (k12 "asia")) ; --UNCHK
lin aloe_N = mkWN (k3 "aaloe") ; --UNCHK
lin aloft_Adv = mkWAdv (k10 "yläilmakehässä") ; --UNCHK
lin aloha_N = mkWN (k99 "moi") ; --UNCHK
lin alone_A = mkA "yksinäinen" ;
lin aloneness_N = mkWN (k40 "yksinäisyys") ; --UNCHK
lin along_Adv = mkAdv "mukana" | mkAdv "mukaan" ; ---- split be along ; go along
lin along_Prep = mkPrep "pitkin" ;
lin alongside_Adv = mkWAdv (k99 "vieressä") ; --UNCHK
lin alongside_Prep = mkPrep "rinnalla" ;
lin aloof_A = mkWA (k99 "olevinaan") ; --UNCHK
lin aloof_Adv = mkWAdv (k99 "syrjässä") ; --UNCHK
lin aloofness_N = mkWN (k40 "sulkeutuneisuus") ; --UNCHK
lin alopecia_N = mkWN (k40 "kaljupäisyys") ; --UNCHK
lin alopecic_A = mkWA "sulkasato-" ; --UNCHK
lin aloud_Adv = mkWAdv (k99 "ääneen") ; --UNCHK
lin alp_N = mkWN (kH1 "vuori") "korkea" ; --UNCHK
lin alpaca_N = mkWN (kH1 "alpakka") ; --UNCHK
lin alpenstock_N = mkWN (compoundN "alppi" (k9 "sauva")) ; --UNCHK
lin alpestrine_A = mkWA (compoundA "sub" (k38 "alpiininen")) ; --UNCHK
lin alpha_A = mkWA "alfa-" ; --UNCHK
lin alpha_N = mkWN (k9 "alfa") ; --UNCHK
lin alphabet_N = mkWN (k5A "rudimentti") ; --UNCHK
lin alphabetic_A = mkWA (k38 "aakkosellinen") ; --UNCHK
lin alphabetical_A = mkWA (k38 "aakkosellinen") ; --UNCHK
lin alphabetization_N = mkWN (k39 "aakkostus") ; --UNCHK
lin alphabetized_A = mkWA (compoundA "aakkos" (k1 "tettu")) ; --UNCHK
lin alphabetizer_N = mkWN (compoundN "aak" (k10 "kostaja")) ; --UNCHK
lin alphanumeric_A = mkWA (compoundA "alfa" (k38 "numeerinen")) ; --UNCHK
lin alphanumerics_N = mkWN (k1 "merkistö") "aakkosnumeerinen" ; --UNCHK
lin alphavirus_N = mkWN (compoundN "alfa" (k39 "virus")) ; --UNCHK
lin alpine_A = mkWA "vuoristo-" ; --UNCHK
lin alpinist_N = mkWN (compoundN "vuori" (k12 "kiipeilijä")) ; --UNCHK
lin alprazolam_N = mkWN "Xanax" ; --UNCHK
lin already_AdV = mkAdV "jo" ;
lin already_Adv = L.already_Adv ;
lin alright_A = mkWA (k99 "oikein") ; --UNCHK
lin alright_Adv = mkWAdv (k99 "mukavasti") ; --UNCHK
lin alsatianFem_N = mkWN (k1 "saku") ; --UNCHK
lin alsatianMasc_N = mkWN (k1 "saku") ; --UNCHK
lin also_AdV = lin AdV (ss "myös") ;
lin also_Adv = mkAdv "myös" | mkAdv "lisäksi" ;
lin alstroemeria_N = mkWN (compoundN "prinsessa" (k9 "lilja")) ; --UNCHK
lin altar_N = mkWN (k6 "alttari") ; --UNCHK
lin altar_piece_N = mkWN (compoundN "alttari" (k1 "taulu")) ; --UNCHK
lin altazimuth_N = mkWN (compoundN "universaali" (k48 "koje")) ; --UNCHK
lin alter_V = mkWV (k62 "steriloida") ; --UNCHK
lin alter_V2 = mkWV2 (k62 "steriloida") ; --UNCHK
lin alter_ego_N = mkWN (k101 "minä") "toinen" ; --UNCHK
lin alterability_N = mkWN (k40 "muuttuvuus") ; --UNCHK
lin alterable_A = mkWA (k10 "oleva") "muutettavissa" ; --UNCHK
lin alteration_N = mkWN (compoundN "muu" (k38 "ttaminen")) ; --UNCHK
lin altercation_N = mkWN (k14A "rytäkkä") ; --UNCHK
lin altered_A = mkA "muutettu" ;
lin alternate_A = mkWA (k38 "vuoroittainen") ; --UNCHK
lin alternate_V = mkWV (k67A "vuorotella") ; --UNCHK
lin alternate_V2 = mkWV2 (k67A "vuorotella") ; --UNCHK
lin alternation_N = mkWN (k2 "vuorottelu") ; --UNCHK
lin alternative_A = mkWA (compoundA "vaihtoeh" (k38 "toinen")) ; --UNCHK
lin alternative_N = mkN "vaihto" (mkN "ehto") ; --f79
lin alternator_N = mkWN (compoundN "lataus" (k6 "generaattori")) ; --UNCHK
lin althea_N = mkWN "rohtosalkoruusu" ; --UNCHK
lin although_Subj = S.although_Subj ;
lin altimeter_N = mkWN (compoundN "korkeus" (k6 "mittari")) ; --UNCHK
lin altissimo_A = mkWA (k15 "korkea") "erittäin" ; --UNCHK
lin altitude_N = mkWN (k40 "korkeus") ; --UNCHK
lin altitudinal_A = mkWA "korkeus-" ; --UNCHK
lin altitudinous_A = mkWA "korkeus-" ; --UNCHK
lin alto_A = mkWA "altto-" ; --UNCHK
lin alto_N = mkWN (k1A "altto") ; --UNCHK
lin altocumulus_N = mkWN (compoundN "hahtuva" (k7 "pilvi")) ; --UNCHK
lin altogether_Adv = mkWAdv (k99 "tyystin") ; --UNCHK
lin alton_PN = foreignPN "Alton" ;
lin altostratus_N = mkWN (compoundN "verho" (k7 "pilvi")) ; --UNCHK
lin altricial_A = mkWA (compoundA "altrikia" (k38 "alinen")) ; --UNCHK
lin altrincham_PN = foreignPN "Altrincham" ;
lin altruism_N = mkWN (k5 "altruismi") ; --UNCHK
lin altruist_N = mkWN (k5A "filantrooppi") ; --UNCHK
lin altruistic_A = mkWA (k34A "pyyteetön") ; --UNCHK
lin alula_N = mkWN (compoundN "pikku" (k7A "siipi")) ; --UNCHK
lin alular_A = mkWA "alulaarinen" ; --UNCHK
lin alum_N = mkWN (k13 "aluna") ; --UNCHK
lin alumina_N = mkWN (compoundN "alumiini" (k5 "oksidi")) ; --UNCHK
lin aluminate_N = mkWN (compoundN "alumi" (k5A "naatti")) ; --UNCHK
lin aluminiferous_A = mkWA (compoundA "alunapi" (k38 "toinen")) ; --UNCHK
lin aluminium_N = mkWN (k5 "alumiini") ; --UNCHK
lin aluminous_A = mkWA (compoundA "alunapi" (k38 "toinen")) ; --UNCHK
lin aluminum_N = mkWN (k5 "alumiini") ; --UNCHK
lin alumnus_N = mkN "alumni" ;
lin alumroot_N = mkWN (compoundN "amerikankeijun" (k10A "kukka")) ; --UNCHK
lin alundum_N = mkWN (compoundN "teko" (k5 "korundi")) ; --UNCHK
lin alvechurch_PN = foreignPN "Alvechurch" ;
lin alveolar_A = mkWA "keuhkorakkula-" ; --UNCHK
lin alveolar_N = mkWN (k5A "konsonantti") "dentaalinen" ; --UNCHK
lin alveolate_A = mkWA (k38 "kennomainen") ; --UNCHK
lin alveolitis_N = mkWN (compoundN "keuhkorakkula" (k39 "tulehdus")) ; --UNCHK
lin alveolus_N = mkWN (compoundN "hammas" (k10A "kuoppa")) ; --UNCHK
lin alvine_A = mkWA "alviininen" ; --UNCHK
lin always_AdV = S.always_AdV ;
lin always_Adv = mkAdv "aina" ;
lin alyssum_N = mkWN "suku" "Alyssum" ; --UNCHK
lin amah_N = mkWN (k32A "palvelijatar") ; --UNCHK
lin amain_Adv = mkWAdv "kaikin" "voimin" ; --UNCHK
lin amalgam_N = mkWN (k10 "yhdistelmä") ; --UNCHK
lin amalgamate_V = mkWV (k53A "sulauttaa") "yhteen" ; --UNCHK
lin amalgamate_V2 = mkWV2 (k53A "sulauttaa") "yhteen" ; --UNCHK
lin amalgamation_N = mkWN (k3 "fuusio") ; --UNCHK
lin amalgamative_A = mkWA "yhdistymis-" ; --UNCHK
lin amalgamator_N = mkWN "fuusioija" ; --UNCHK
lin amanuensis_N = mkWN (compoundN "pika" (k10 "kirjoittaja")) ; --UNCHK
lin amaranth_N = mkWN (compoundN "revon" (k10A "häntä")) ; --UNCHK
lin amaranthine_A = mkWA "amarantti-" ; --UNCHK
lin amarelle_N = mkWN (compoundN "hapan" (k14A "kirsikka")) ; --UNCHK
lin amaretto_N = mkWN "amaretto" ; --UNCHK
lin amaryllis_N = mkWN (k39 "amaryllis") ; --UNCHK
lin amass_V2 = mkV2 "kasata" ; --WV2 (k52A "kertyä") ;
lin amastia_N = mkWN "amastia" ; --UNCHK
lin amateurFem_N = mkWN (k12 "harrastelija") | mkN "ama" (mkN "tööri") ;
lin amateurMasc_N = variants {} ; --
lin amateur_A = mkWA "ei-ammattilais-" ; --UNCHK
lin amateurish_A = mkWA (k34A "taitamaton") ; --UNCHK
lin amateurishness_N = mkWN (compoundN "amatöörimä" (k40 "isyys")) ; --UNCHK
lin amateurism_N = mkWN (compoundN "kanna" (k38 "ttaminen")) "amatööriurheilun" ; --UNCHK
lin amative_A = mkWA (k41A "lemmekäs") ; --UNCHK
lin amatory_A = mkWA (k38 "romanttinen") ; --UNCHK
lin amaurosis_N = mkWN "amauroosi" ; --UNCHK
lin amaurotic_A = mkWA "amauroottinen" ; --UNCHK
lin amaze_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin amaze_V2V = mkWV2V (k53A "sekoittaa") ; --UNCHK
lin amazement_N = mkWN (k39 "ihmetys") ; --UNCHK
lin amazing_A = mkWA (k10 "vaikuttava") ; --UNCHK
lin amazon_N = mkWN (compoundN "amatsoni" (k9 "papukaija")) ; --UNCHK
lin ambassador_N = mkN "suur" (mkN "lähettiläs") ;
lin ambassadorial_A = mkWA "suurlähettilään" ; --UNCHK
lin ambassadorship_N = mkWN (k9A "virka") "suurlähettilään" ; --UNCHK
lin ambassadress_N = mkWN (k2 "puoliso") "suurlähettilään" ; --UNCHK
lin amber_A = mkWA (compoundA "ruskean" (k38 "keltainen")) ; --UNCHK
lin amber_N = mkWN (k38 "keltainen") ; --UNCHK
lin ambergris_N = mkWN (k9 "ambra") "harmaa" ; --UNCHK
lin amberjack_N = mkWN "amberfish" ; --UNCHK
lin ambidexterity_N = mkWN (compoundN "molempi" (k40 "kätisyys")) ; --UNCHK
lin ambidextrous_A = mkWA "molempikätinen" ; --UNCHK
lin ambience_N = mkWN (k1 "ympäristö") ; --UNCHK
lin ambient_A = mkWA "ympäröivä" ; --UNCHK
lin ambiguity_N = mkWN (compoundN "epä" (k40 "selvyys")) ; --UNCHK
lin ambiguous_A = mkWA (compoundA "epä" (k10 "selvä")) ; --UNCHK
lin ambit_N = mkWN (k40 "ulottuvuus") ; --UNCHK
lin ambition_N = mkWN (k39 "pyrkimys") ; --UNCHK
lin ambitious_A = mkWA (compoundA "kunnianhi" (k38 "moinen")) ;
lin ambivalence_N = mkWN (k5 "ambivalenssi") ; --UNCHK
lin ambivalent_A = mkWA (k38 "ambivalenttinen") ; --UNCHK
lin ambiversion_N = mkWN (compoundN "ambi" (k3 "versio")) ; --UNCHK
lin ambiversive_A = mkWA "ambivertti" ; --UNCHK
lin amble_N = mkWN (k2 "vaeltelu") ; --UNCHK
lin amble_V = mkWV (k67 "tallustella") ; --UNCHK
lin amblygonite_N = mkWN (compoundN "amblygo" (k5A "niitti")) ; --UNCHK
lin amblyopia_N = mkWN (compoundN "heikko" (k40 "näköisyys")) ; --UNCHK
lin amblyopic_A = mkWA (compoundA "heikko" (k38 "näköinen")) ; --UNCHK
lin amboyna_N = mkWN "Pterocarpus" "indicus" ; --UNCHK
lin ambrosia_N = mkWN (k6 "nektari") ; --UNCHK
lin ambrosial_A = mkWA "ambrosia-" ; --UNCHK
lin ambulacral_A = mkWA (compoundA "ambulakra" (k38 "alinen")) ; --UNCHK
lin ambulacrum_N = mkWN "ambulakrum" ; --UNCHK
lin ambulance_N = mkWN (k5 "ambulanssi") ; --UNCHK
lin ambulant_A = mkWA (k10 "oleva") "jalkeilla" ; --UNCHK
lin ambulation_N = mkWN (compoundN "liik" (k38 "kuminen")) ; --UNCHK
lin ambulatory_A = mkWA "kävely-" ; --UNCHK
lin ambulatory_N = mkWN (k10 "käytävä") "katettu" ; --UNCHK
lin ambuscade_N = mkWN (k9 "ansa") ; --UNCHK
lin ambuscade_V2 = mkWV2 (k53A "odottaa") "makuulla" ; --UNCHK
lin ambush_N = mkWN (k9 "ansa") ; --UNCHK
lin ambush_V2 = mkWV2 (k53A "odottaa") "makuulla" ; --UNCHK
lin ambusher_N = mkWN "väijyjä" ; --UNCHK
lin ambystomid_N = mkWN "aksolotli" ; --UNCHK
lin amebiasis_N = mkWN (k5A "tauti") "ameban" "aiheuttama" ; --UNCHK
lin ameboid_A = mkWA (compoundA "ameba" (k38 "mainen")) ; --UNCHK
lin ameer_N = mkWN (k6 "emiiri") ; --UNCHK
lin amelia_N = mkWN "amelia" ; --UNCHK
lin ameliorate_V = mkWV (k52A "parantua") ; --UNCHK
lin ameliorate_V2 = mkWV2 (k52A "parantua") ; --UNCHK
lin amelioration_N = mkWN (k39 "parannus") ; --UNCHK
lin ameloblast_N = mkWN (compoundN "amelob" (k5 "lasti")) ; --UNCHK
lin amelogenesis_N = mkWN "amelogeneesi" ; --UNCHK
lin amen_Interj = mkInterj "aamen" ;
lin amenability_N = mkWN (k40 "mukautuvuus") ; --UNCHK
lin amenable_A = mkWA (k38 "myöntyväinen") ; --UNCHK
lin amend_V = mkWV (k53A "muuttaa") ; --UNCHK
lin amend_V2 = mkWV2 (k53A "muuttaa") ; --UNCHK
lin amend_V2V = mkWV2V (k53A "muuttaa") ; --UNCHK
lin amendable_A = mkWA (k10 "oleva") "oikaistavissa" ; --UNCHK
lin amendatory_A = mkWA (compoundA "korj" (k9 "aava")) ; --UNCHK
lin amendment_N = mkWN (k2 "oikaisu") ; --f60
lin amenity_N = mkWN (k40 "mukavuus") ; --UNCHK
lin amenorrhea_N = mkWN (k12 "amenorrea") ; --UNCHK
lin amenorrheic_A = mkWA "amenorreeinen" ; --UNCHK
lin amentiferous_A = mkWA "urpu-" ; --UNCHK
lin amerciable_A = mkWA (k10 "oleva") "sakotettavissa" ; --UNCHK
lin america_PN = mkPN "Amerikka" ;
lin americanFem_N = mkWN (compoundN "Ame" (k9A "rikka")) ; --UNCHK
lin americanMasc_N = mkN "amerikkalainen" ;
lin american_A = mkA "amerikkalainen" ;
lin americanism_N = mkWN (k40 "amerikkalaisuus") ; --UNCHK
lin americanize_V2 = mkWV2 (k52 "amerikkalaistua") ; --UNCHK
lin amesbury_PN = foreignPN "Amesbury" ;
lin ametabolic_A = mkWA "ametabolinen" ; --UNCHK
lin amethyst_A = mkWA (compoundA "ametistin" (k38 "värinen")) ; --UNCHK
lin amethyst_N = mkWN (k5 "ametisti") ; --UNCHK
lin amethystine_A = mkWA (compoundA "ametisti" (k38 "mainen")) ; --UNCHK
lin ametria_N = mkWN "ametria" ; --UNCHK
lin ametropia_N = mkWN "ametropia" ; --UNCHK
lin ametropic_A = mkWA (compoundA "ame" (k38 "trooppinen")) ; --UNCHK
lin amiability_N = mkWN (k40 "sydämellisyys") ; --UNCHK
lin amiable_A = mkWA (k10 "mukava") ; --UNCHK
lin amicability_N = mkWN (k40 "sovinnollisuus") ; --UNCHK
lin amicable_A = mkWA (k10 "sopuisa") ; --UNCHK
lin amid_Prep = mkPrep "keskellä" ;
lin amide_N = mkWN "amidi" ; --UNCHK
lin amidship_A = mkWA (k99 "keskivaiheilla") ; --UNCHK
lin amidship_Adv = mkWAdv (compoundAdv "keskilai" (k99 "vaan")) ; --UNCHK
lin amidships_Adv = mkWAdv (k99 "keskivaiheille") ; --UNCHK
lin amidst_Prep = mkPrep "keskellä" ;
lin amiens_PN = foreignPN "Amiens" ;
lin amigo_N = mkWN (k6 "kaveri") ; --UNCHK
lin amino_A = mkWA "amiini-" ; --UNCHK
lin amino_N = mkWN (compoundN "amino" (k10 "ryhmä")) ; --UNCHK
lin aminoaciduria_N = mkWN "aminoasiduria" ; --UNCHK
lin aminomethane_N = mkWN (compoundN "amino" (k5 "metaani")) ; --UNCHK
lin aminophylline_N = mkWN "aminofylliini" ; --UNCHK
lin aminopyrine_N = mkWN "amidopyriini" ; --UNCHK
lin amiodarone_N = mkWN "Cordarone" ; --UNCHK
lin amir_N = mkWN (k6 "emiiri") ; --UNCHK
lin amiss_A = mkWA (k99 "sekaisin") ; --UNCHK
lin amiss_Adv = mkWAdv (k99 "huonosti") ; --UNCHK
lin amitosis_N = mkWN (k38 "solunjakautuminen") "välitön" ; --UNCHK
lin amitotic_A = mkWA "amitoottinen" ; --UNCHK
lin amitriptyline_N = mkWN "Elavil" ; --UNCHK
lin amity_N = mkWN (k40 "sydämellisyys") ; --UNCHK
lin ammanford_PN = foreignPN "Ammanford" ;
lin ammeter_N = mkWN (compoundN "virta" (k6 "mittari")) ; --UNCHK
lin ammine_N = mkWN "ammiini" ; --UNCHK
lin ammino_A = mkWA "ammiini-" ; --UNCHK
lin ammobium_N = mkWN (compoundN "iäisyyden" (k10A "kukka")) ; --UNCHK
lin ammonia_N = mkWN (k5A "ammoniakki") ; --UNCHK
lin ammoniac_A = mkWA (compoundA "ammoniaka" (k38 "alinen")) ; --UNCHK
lin ammoniac_N = mkWN (compoundN "ammoniakki" (k5 "kumi")) ; --UNCHK
lin ammoniated_A = mkWA "ammoniakilla" "käsitelty" ; --UNCHK
lin ammonification_N = mkWN (compoundN "ammoniakki" (k38 "utuminen")) ; --UNCHK
lin ammonite_N = mkWN (compoundN "ammo" (k5A "niitti")) ; --UNCHK
lin ammonitic_A = mkWA "ammoniittinen" ; --UNCHK
lin ammonium_N = mkWN (compoundN "ammonium" (k5 "ioni")) ; --UNCHK
lin ammoniuria_N = mkWN "ammoniuria" ; --UNCHK
lin ammunition_N = mkN "ampumatarvike" ;
lin amnesia_N = mkWN (k40 "muistamattomuus") ; --UNCHK
lin amnesic_A = mkWA "muistinmenetys-" ; --UNCHK
lin amnesic_N = mkWN (k2 "henkilö") "muistamaton" ; --UNCHK
lin amnestic_A = mkWA "muistinmenetys-" ; --UNCHK
lin amnesty_N = mkWN (k39 "armahdus") ; --UNCHK
lin amniocentesis_N = mkWN (k1A "otto") "lapsivesinäytteen" ; --UNCHK
lin amnion_N = mkWN (compoundN "vesi" (k1 "kalvo")) ; --UNCHK
lin amniote_N = mkWN (compoundN "vesi" (k38 "kalvollinen")) ; --UNCHK
lin amniotic_A = mkWA "sikiökalvo-" ; --UNCHK
lin amoeba_N = mkWN (k9 "ameba") ; --UNCHK
lin amoebic_A = mkWA (compoundA "ameba" (k38 "mainen")) ; --UNCHK
lin among_Prep = postPrep genitive "joukossa" ;
lin amongst_Prep = postPrep genitive "joukossa" ;
lin amora_N = mkWN "amora" ; --UNCHK
lin amoralism_N = mkWN "amoraalisuus" ; --UNCHK
lin amoralist_N = mkWN "amoralisti" ; --UNCHK
lin amorality_N = mkWN (compoundN "amoral" (k5 "ismi")) ; --UNCHK
lin amorist_N = mkWN (compoundN "amo" (k5 "risti")) ; --UNCHK
lin amoristic_A = mkWA "amoristinen" ; --UNCHK
lin amorous_A = mkWA (k41A "lemmekäs") ; --UNCHK
lin amorousness_N = mkWN (k40 "seksikkyys") ; --UNCHK
lin amorpha_N = mkWN (compoundN "sulkapensas" (k1A "suku")) ; --UNCHK
lin amorphous_A = mkWA (k38 "amorfinen") ; --UNCHK
lin amort_A = mkWA (k47 "kuollut") ; --UNCHK
lin amortization_N = mkWN (k39 "lyhennys") ; --UNCHK
lin amortize_V2 = mkWV2 (k54A "lyhentää") ; --UNCHK
lin amount_N = mkN "summa" ;
lin amount_V = mkWV (k66 "nousta") ;
lin amour_N = mkWN (k48A "suhde") "intiimi" ; --UNCHK
lin amour_propre_N = mkWN (k40 "turhamaisuus") ; --UNCHK
lin amoxicillin_N = mkWN "Augmentin" ; --UNCHK
lin amp_Conj = mkConj "&" ;
lin amp_N = mkWN (k6 "ampeeri") ; --UNCHK
lin amperage_N = mkWN (compoundN "ampeeri" (k10 "määrä")) ; --UNCHK
lin ampere_N = mkWN (k6 "ampeeri") ; --UNCHK
lin ampersand_N = mkWN (compoundN "et-" (k5A "merkki")) ; --UNCHK
lin amphetamine_N = mkWN (k5A "vauhti") ; --UNCHK
lin amphibia_N = mkWN "luokka" "Amphibia" ; --UNCHK
lin amphibian_N = mkWN (compoundN "sammakko" (k33 "eläin")) ; --UNCHK
lin amphibiotic_A = mkWA (compoundA "semi" (k38 "akvaattinen")) ; --UNCHK
lin amphibious_A = mkWA "amfibio-" ; --UNCHK
lin amphibole_N = mkWN "amfiboli" ; --UNCHK
lin amphibolite_N = mkWN "amfiboliitti" ; --UNCHK
lin amphibology_N = mkWN "amfibolia" ; --UNCHK
lin amphibrach_N = mkWN (compoundN "amfib" (k5 "raki")) ; --UNCHK
lin amphictyony_N = mkWN (compoundN "amfiktyoni" (k1A "liitto")) ; --UNCHK
lin amphidiploid_N = mkWN (compoundN "amfi" (k5 "diploidi")) ; --UNCHK
lin amphidiploidy_N = mkWN (compoundN "amfidiploi" (k9 "dia")) ; --UNCHK
lin amphigory_N = mkWN "hölynpölyrunomitta" ; --UNCHK
lin amphimixis_N = mkWN "amfimiksis" ; --UNCHK
lin amphipod_N = mkWN "amfipodi" ; --UNCHK
lin amphiprostylar_A = mkWA (compoundA "amfipros" (k38 "tyylinen")) ; --UNCHK
lin amphisbaena_N = mkWN "suku" "Amphisbaenia" ; --UNCHK
lin amphistylar_A = mkWA (compoundA "amfipros" (k38 "tyylinen")) ; --UNCHK
lin amphitheatre_N = mkWN (compoundN "amfi" (k6 "teatteri")) ; --UNCHK
lin amphitheatric_A = mkWA (compoundA "amfiteatteri" (k38 "mainen")) ; --UNCHK
lin amphitropous_A = mkWA (compoundA "amfi" (k38 "trooppinen")) ; --UNCHK
lin amphiuma_N = mkWN (compoundN "ankerias" (k6 "salamanteri")) ; --UNCHK
lin amphora_N = mkWN (k10 "amfora") ; --UNCHK
lin amphoric_A = mkWA (compoundA "amfora" (k38 "mainen")) ; --UNCHK
lin amphoteric_A = mkWA "amfiproottinen" ; --UNCHK
lin amphotericin_N = mkWN (compoundN "amfote" (k5 "risiini")) ; --UNCHK
lin ampicillin_N = mkWN "SK-Ampicillin" ; --UNCHK
lin ample_A = mkWA (k41 "runsas") ; --UNCHK
lin ampleness_N = mkWN "kookkaus" ; --UNCHK
lin amplification_N = mkWN "vahvistaminen" ; --UNCHK
lin amplifier_N = mkWN (k33 "vahvistin") ; --UNCHK
lin amplify_V2 = mkWV2 (k53 "voimistaa") ; --UNCHK
lin amplitude_N = mkWN (k5 "amplitudi") ; --UNCHK
lin ampoule_N = mkWN (k5 "ampulli") ; --UNCHK
lin ampulla_N = mkWN (k5 "ampulli") ; --UNCHK
lin ampullar_A = mkWA (compoundA "ampulli" (k38 "mainen")) ; --UNCHK
lin amputate_V2 = mkWV2 (k66 "katkaista") ; --UNCHK
lin amputation_N = mkWN (k5A "amputointi") ; --UNCHK
lin amputator_N = mkWN (k12 "katkaisija") ; --UNCHK
lin amputee_N = mkWN (compoundN "amputo" (k1A "itu")) ; --UNCHK
lin amrinone_N = mkWN "Inocor" ; --UNCHK
lin amsterdam_PN = foreignPN "Amsterdam" ;
lin amuck_A = mkWA (k1 "hullu") ; --UNCHK
lin amuck_Adv = mkWAdv (k99 "murhaavasti") ; --UNCHK
lin amulet_N = mkWN (k5 "talismaani") ; --UNCHK
lin amuse_V2 = mkWV2 (k53A "viihdyttää") ; --UNCHK
lin amusement_N = mkWN (k5 "huvi") ; --UNCHK
lin amusing_A = mkWA (k1 "hassu") ;
lin amygdala_N = mkWN (compoundN "manteli" (k48A "tumake")) ; --UNCHK
lin amygdalin_N = mkWN "amygdaliini" ; --UNCHK
lin amygdaline_A = mkWA (compoundA "manteli" (k38 "mainen")) ; --UNCHK
lin amygdaloid_N = mkWN (compoundN "manteli" (k7 "kivi")) ; --UNCHK
lin amylase_N = mkWN (compoundN "amyl" (k5 "aasi")) ; --UNCHK
lin amyloid_N = mkWN "amyloidi" ; --UNCHK
lin amyloidosis_N = mkWN "amyloidoosi" ; --UNCHK
lin amylolysis_N = mkWN (compoundN "amyloly" (k5 "ysi")) ; --UNCHK
lin amylolytic_A = mkWA "amylolyyttinen" ; --UNCHK
lin amyotrophia_N = mkWN "amyotrofia" ; --UNCHK
lin amyxia_N = mkWN "limattomuus" ; --UNCHK
lin ana_N = mkWN (compoundN "kasku" (k10 "kokoelma")) ; --UNCHK
lin anabatic_A = mkWA "anabaattinen" ; --UNCHK
lin anabiosis_N = mkWN "anabioosi" ; --UNCHK
lin anabolic_A = mkWA (k38 "anabolinen") ; --UNCHK
lin anabolism_N = mkWN (compoundN "metabol" (k5 "ismi")) "konstruktiivinen" ; --UNCHK
lin anachronic_A = mkWA (k34A "sopimaton") "aikaan" ; --UNCHK
lin anachronism_N = mkWN (k5 "anakronismi") ; --UNCHK
lin anachronistic_A = mkWA (k34A "sopimaton") "aikaan" ; --UNCHK
lin anachronistically_Adv = mkWAdv (k99 "anakronistisesti") ; --UNCHK
lin anaclinal_A = mkWA (compoundA "anaklina" (k38 "alinen")) ; --UNCHK
lin anaclisis_N = mkWN (compoundN "anakl" (k5 "iisi")) ; --UNCHK
lin anaclitic_A = mkWA "anakliittinen" ; --UNCHK
lin anacoluthia_N = mkWN "anakoluton" ; --UNCHK
lin anacoluthic_A = mkWA (k38 "anakoluuttinen") ; --UNCHK
lin anaconda_N = mkWN (k10 "anakonda") ; --UNCHK
lin anadiplosis_N = mkWN (compoundN "anadip" (k5 "loosi")) ; --UNCHK
lin anadromous_A = mkWA "anadrominen" ; --UNCHK
lin anaemia_N = mkWN (k12 "anemia") ; --UNCHK
lin anaemic_A = mkWA (k38 "aneeminen") ; --UNCHK
lin anaerobe_N = mkWN "anaerobi" ; --UNCHK
lin anaesthesia_N = mkWN (k12 "anestesia") ; --UNCHK
lin anaesthetic_A = mkWA (compoundA "anest" (k38 "eettinen")) ; --UNCHK
lin anaesthetic_N = mkWN (k48A "puudute") ; --UNCHK
lin anaesthetist_N = mkWN (k10 "antaja") "nukutuksen" ; --UNCHK
lin anaesthetize_V2 = mkWV2 (k53A "puuduttaa") ; --UNCHK
lin anaglyph_N = mkWN "anaglyfi" ; --UNCHK
lin anaglyphic_A = mkWA "anaglyptinen" ; --UNCHK
lin anaglyphy_N = mkWN "anaglyfia" ; --UNCHK
lin anagnost_N = mkWN (k12 "lukija") ; --UNCHK
lin anagoge_N = mkWN "anagogia" ; --UNCHK
lin anagogic_A = mkWA "anagoginen" ; --UNCHK
lin anagram_N = mkWN (k5 "anagrammi") ; --UNCHK
lin anagrammatic_A = mkWA (compoundA "ana" (k38 "grammaattinen")) ; --UNCHK
lin anal_A = mkWA (k38 "anaalinen") ; --UNCHK
lin analbuminemia_N = mkWN (k39 "puutos") "albumiinin" ; --UNCHK
lin analects_N = mkWN "analekti" ; --UNCHK
lin analeptic_A = mkWA "analeptinen" ; --UNCHK
lin analeptic_N = mkWN (compoundN "analepti" (k5 "kumi")) ; --UNCHK
lin analgesia_N = mkWN (k12 "analgesia") ; --UNCHK
lin analgesic_A = mkWA (k38 "analgeettinen") ; --UNCHK
lin analgesic_N = mkWN (k5A "analgeetti") ; --UNCHK
lin analog_N = mkWN (k12 "analogia") ; --UNCHK
lin analogical_A = mkWA (k38 "analoginen") ; --UNCHK
lin analogist_N = mkWN "analogi" ; --UNCHK
lin analogous_A = mkWA (k38 "analoginen") ; --UNCHK
lin analogue_A = mkWA (k38 "lineaarinen") ; --UNCHK
lin analogue_N = mkWN (k12 "analogia") ; --UNCHK
lin analogy_N = mkWN (k40 "vastaavuus") ; --UNCHK
lin analphabet_N = mkWN (k5A "analfabeetti") ; --UNCHK
lin analphabetic_A = mkWA (compoundA "luku" (k34A "taidoton")) ; --UNCHK
lin analysand_N = mkWN (k2 "henkilö") "psykoanalyysiä" "saava" ; --UNCHK
lin analysis_N = mkN "analyysi" | mkWN (k2 "tarkastelu") ;
lin analyst_N = mkN (lin NK {s = d04A "analyytikko"}) ;
lin analytic_A = mkWA (k38 "analyyttinen") ; --UNCHK
lin analytical_A = mkWA (k38 "analyyttinen") ; --UNCHK
lin analyticity_N = mkWN (k40 "analyyttisyys") ; --UNCHK
lin analyze_V2 = mkWV2 (k62 "analysoida") ; --UNCHK
lin analyzer_N = mkWN (k6 "analysaattori") ; --UNCHK
lin anamnestic_A = mkWA (k38 "anamnestinen") ; --UNCHK
lin anamorphic_A = mkWA "anamorfinen" ; --UNCHK
lin anamorphism_N = mkWN (compoundN "anamorf" (k5 "ismi")) ; --UNCHK
lin anamorphosis_N = mkWN (compoundN "anamorf" (k5 "ismi")) ; --UNCHK
lin anapaest_N = mkWN (compoundN "ana" (k5 "pesti")) ; --UNCHK
lin anapaestic_A = mkWA "anapestinen" ; --UNCHK
lin anapest_N = mkWN (compoundN "ana" (k5 "pesti")) ; --UNCHK
lin anapestic_A = mkWA "anapestinen" ; --UNCHK
lin anaphase_N = mkWN (compoundN "ana" (k5 "faasi")) ; --UNCHK
lin anaphasic_A = mkWA "anafaattinen" ; --UNCHK
lin anaphor_N = mkWN (compoundN "anaf" (k10 "ora")) ; --UNCHK
lin anaphora_N = mkWN (compoundN "anaf" (k10 "ora")) ; --UNCHK
lin anaphoric_A = mkWA "anaforinen" ; --UNCHK
lin anaphrodisia_N = mkWN (k48A "puute") "sukupuolivietin" ; --UNCHK
lin anaphrodisiac_A = mkWA "sukupuoliviettiä" "heikentävä" ; --UNCHK
lin anaphylactic_A = mkWA "anafylaktinen" ; --UNCHK
lin anaphylaxis_N = mkWN "anafylaksia" ; --UNCHK
lin anaplasia_N = mkWN (compoundN "anapl" (k12 "asia")) ; --UNCHK
lin anaplasmosis_N = mkWN "anaplasmoosi" ; --UNCHK
lin anaplastic_A = mkWA (compoundA "ana" (k38 "plastinen")) ; --UNCHK
lin anapsid_N = mkWN (compoundN "anapsidi" (k12 "matelija")) ; --UNCHK
lin anarchic_A = mkWA (k34A "laiton") ; --UNCHK
lin anarchism_N = mkWN (k5 "anarkismi") ; --UNCHK
lin anarchistFem_N = mkWN (k5 "syndikalisti") ; --UNCHK
lin anarchistMasc_N = mkWN (k5 "syndikalisti") ; --UNCHK
lin anarchistic_A = mkWA (k38 "anarkistinen") ; --UNCHK
lin anarchy_N = mkWN (k40 "laittomuus") ; --UNCHK
lin anarthria_N = mkWN "anartria" ; --UNCHK
lin anasarca_N = mkWN (compoundN "anas" (k9A "arka")) ; --UNCHK
lin anasarcous_A = mkWA "anasarkoottinen" ; --UNCHK
lin anaspid_N = mkWN "anaspidi" ; --UNCHK
lin anastigmat_N = mkWN (k5 "linssi") "anastigmaattinen" ; --UNCHK
lin anastigmatic_A = mkWA (compoundA "stigma" (k38 "attinen")) ; --UNCHK
lin anastomosis_N = mkWN "yhdyshaarojen" "muodostuminen" ; --UNCHK
lin anastomotic_A = mkWA "anastomoottinen" ; --UNCHK
lin anastrophe_N = mkWN (compoundN "sana" (k39 "järjestys")) "käänteinen" ; --UNCHK
lin anastylosis_N = mkWN (compoundN "anasty" (k5 "loosi")) ; --UNCHK
lin anathema_N = mkWN (compoundN "ana" (k9 "teema")) ; --UNCHK
lin anathematization_N = mkWN (k39 "karkotus") ; --UNCHK
lin anathematize_V = mkWV (k53 "julistaa") "pannaan" ; --UNCHK
lin anathematize_V2 = mkWV2 (k53 "julistaa") "pannaan" ; --UNCHK
lin anatomic_A = mkWA (k38 "anatominen") ; --UNCHK
lin anatomical_A = mkWA (k38 "anatominen") ; --UNCHK
lin anatomist_N = mkWN (k5 "anatomi") ; --UNCHK
lin anatomy_N = mkWN (k12 "anatomia") ; --UNCHK
lin anatotitan_N = mkWN (compoundN "jätti" (k9A "ankka")) ; --UNCHK
lin anatoxin_N = mkWN (compoundN "ana" (k5 "toksiini")) ; --UNCHK
lin anatropous_A = mkWA (k38 "käänteinen") ; --UNCHK
lin ancestor_N = mkWN (compoundN "kanta" (k10 "isä")) ; --UNCHK
lin ancestral_A = mkWA (compoundA "per" (k1 "itty")) "esi-isiltä" ; --UNCHK
lin ancestress_N = mkWN (compoundN "esi" (k5A "äiti")) ; --UNCHK
lin ancestry_N = mkWN (k40 "sukulaisuus") ; --UNCHK
lin anchor_N = mkWN (k6 "ankkuri") ; --UNCHK
lin anchor_V = mkWV (k53A "heittää") "ankkuri" ; --UNCHK
lin anchor_V2 = mkWV2 (k53A "heittää") "ankkuri" ; --UNCHK
lin anchorage_N = mkWN (k5A "ankkurointi") ; --UNCHK
lin anchorite_N = mkWN (k4A "erakko") ; --UNCHK
lin anchoritic_A = mkWA (compoundA "erakko" (k38 "mainen")) ; --UNCHK
lin anchorman_N = mkWN (k10 "juontaja") ; --UNCHK
lin anchovy_N = mkWN (k6 "sardelli") ; --UNCHK
lin anchusa_N = mkWN (k5 "rasti") ; --UNCHK
lin ancient_A = mkWA (compoundA "iki" (k9 "vanha")) ;
lin ancient_N = mkWN (k36 "vanhin") ; --UNCHK
lin ancientness_N = mkWN (k40 "muinaisuus") ; --UNCHK
lin ancillary_A = mkWA (k10 "kuuluva") ; --UNCHK
lin ancona_PN = foreignPN "Ancona" ;
lin and_Conj = S.and_Conj ;
lin andante_A = mkWA "andante" ; --UNCHK
lin andante_Adv = mkWAdv "andante" ; --UNCHK
lin andante_N = mkWN "käyden" ; --UNCHK
lin andantino_A = mkWA "andantino" ; --UNCHK
lin andesite_N = mkWN "andesiitti" ; --UNCHK
lin andiron_N = mkWN (k48 "teline") ; --UNCHK
lin andorra_PN = foreignPN "Andorra" ;
lin andorran_A = mkWA (compoundA "andorr" (k38 "alainen")) ; --UNCHK
lin andorran_N = mkWN (compoundN "andorr" (k38 "alainen")) ; --UNCHK
lin andover_PN = foreignPN "Andover" ;
lin andradite_N = mkWN "andradiitti" ; --UNCHK
lin andrena_N = mkWN (compoundN "maa" (k38 "mehiläinen")) ; --UNCHK
lin androecium_N = mkWN (k3 "hetiö") ; --UNCHK
lin androgen_N = mkWN (k5 "androgeeni") ; --UNCHK
lin androgenesis_N = mkWN "androgenia" ; --UNCHK
lin androgenetic_A = mkWA (k38 "androgeeninen") ; --UNCHK
lin androgenic_A = mkWA (k38 "androgeeninen") ; --UNCHK
lin androglossia_N = mkWN "androglossia" ; --UNCHK
lin androgynous_A = mkWA (k38 "androgyyninen") ; --UNCHK
lin androgyny_N = mkWN (k40 "biseksuaalisuus") ; --UNCHK
lin android_N = mkWN (k38 "ihminen") "mekaaninen" ; --UNCHK
lin andromeda_N = mkWN "Andromeda" ; --UNCHK
lin androphobia_N = mkWN (compoundN "mies" (k1 "kammo")) ; --UNCHK
lin androsterone_N = mkWN "androsteroni" ; --UNCHK
lin anecdotal_A = mkWA (compoundA "kasku" (k38 "mainen")) ; --UNCHK
lin anecdote_N = mkWN (k12 "tarina") ; --UNCHK
lin anecdotic_A = mkWA (compoundA "anekdootti" (k38 "mainen")) ; --UNCHK
lin anecdotist_N = mkWN (k10 "kertoja") ; --UNCHK
lin anechoic_A = mkWA (k34A "kaiuton") ; --UNCHK
lin anemia_N = mkWN "suku" "Anemia" ; --UNCHK
lin anemic_A = mkWA (k38 "aneeminen") ; --UNCHK
lin anemographic_A = mkWA (compoundA "ane" (k38 "mografinen")) ; --UNCHK
lin anemography_N = mkWN "anemografia" ; --UNCHK
lin anemometer_N = mkWN (compoundN "tuuli" (k6 "mittari")) ; --UNCHK
lin anemometric_A = mkWA (compoundA "anemo" (k38 "metrinen")) ; --UNCHK
lin anemometry_N = mkWN "anemometria" ; --UNCHK
lin anemone_N = mkWN (compoundN "meri" (k1A "vuokko")) ; --UNCHK
lin anemophilous_A = mkWA (compoundA "tuuli" (k38 "pölytteinen")) ; --UNCHK
lin anencephalic_A = mkWA "aivoton" ; --UNCHK
lin anencephaly_N = mkWN "aivottomuus" ; --UNCHK
lin anergy_N = mkWN "anergia" ; --UNCHK
lin aneroid_A = mkWA "aneroidi" ; --UNCHK
lin aneroid_N = mkWN (compoundN "aneroidi-ilma" (k6 "puntari")) ; --UNCHK
lin anesthesia_N = mkWN (k12 "anestesia") ; --UNCHK
lin anesthesiologist_N = mkWN (k10 "antaja") "nukutuksen" ; --UNCHK
lin anesthesiology_N = mkWN (k12 "anestesiologia") ; --UNCHK
lin anesthetic_A = mkWA (compoundA "anest" (k38 "eettinen")) ; --UNCHK
lin anesthetic_N = mkWN (k48A "puudute") ; --UNCHK
lin anesthetist_N = mkWN (k10 "antaja") "nukutuksen" ; --UNCHK
lin anesthetize_V2 = mkWV2 (k53A "puuduttaa") ; --UNCHK
lin anesthyl_N = mkWN (compoundN "anes" (k5 "tyyli")) ; --UNCHK
lin anestrus_N = mkWN (k9A "lepoaika") ; --UNCHK
lin aneuploid_A = mkWA (compoundA "ane" (k38 "uploidinen")) ; --UNCHK
lin aneuploidy_N = mkWN (compoundN "aneuploi" (k9 "dia")) ; --UNCHK
lin aneurysm_N = mkWN (k9 "aneurysma") ; --UNCHK
lin aneurysmal_A = mkWA (compoundA "ane" (k38 "urysmaattinen")) ; --UNCHK
lin anew_Adv = mkWAdv (k99 "uudelleen") ; --UNCHK
lin anfractuous_A = mkWA (k41A "mutkikas") ; --UNCHK
lin angel_N = mkN "enkeli" ;
lin angelfish_N = mkWN (compoundN "meri" (k6 "enkeli")) ; --UNCHK
lin angelic_A = mkWA (compoundA "enkeli" (k38 "mäinen")) ; --UNCHK
lin angelica_N = mkWN (compoundN "väinön" (k7 "putki")) ; --UNCHK
lin angelim_N = mkWN "andelmin" ; --UNCHK
lin angelology_N = mkWN (compoundN "enkeli" (k5A "oppi")) ; --UNCHK
lin angelus_N = mkWN "Angelus" ; --UNCHK
lin anger_N = mkWN (k39 "suuttumus") ; --UNCHK
lin anger_V2 = mkWV2 (k53A "vihastuttaa") ; --UNCHK
lin angers_PN = foreignPN "Angers" ;
lin angiitis_N = mkWN (compoundN "verisuoni" (k39 "tulehdus")) ; --UNCHK
lin angina_N = mkWN "rasitusrintakipu" ; --UNCHK
lin anginal_A = mkWA "angiina-" ; --UNCHK
lin angiocardiogram_N = mkWN "angiokardiogrammi" ; --UNCHK
lin angiocarp_N = mkWN (k5 "kasvi") "koppisiemeninen" ; --UNCHK
lin angiocarpic_A = mkWA "angiosperminen" ; --UNCHK
lin angioedema_N = mkWN "Quincken" "edeema" ; --UNCHK
lin angiogenesis_N = mkWN "angiogeneesi" ; --UNCHK
lin angiogram_N = mkWN "angiogrammi" ; --UNCHK
lin angiography_N = mkWN (k12 "angiografia") ; --UNCHK
lin angiologist_N = mkWN "angiologi" ; --UNCHK
lin angiology_N = mkWN (compoundN "verisuoni" (k5A "oppi")) ; --UNCHK
lin angioma_N = mkWN (compoundN "angio" (k10 "oma")) ; --UNCHK
lin angiomatous_A = mkWA "angiomatoosinen" ; --UNCHK
lin angiopathy_N = mkWN "angiopatia" ; --UNCHK
lin angioplasty_N = mkWN (compoundN "pallo" (k39 "laajennus")) ; --UNCHK
lin angiopteris_N = mkWN (compoundN "jättiläis" (k38 "saniainen")) ; --UNCHK
lin angiosarcoma_N = mkWN (compoundN "angio" (k10 "sarkooma")) ; --UNCHK
lin angioscope_N = mkWN (compoundN "angiosko" (k5A "oppi")) ; --UNCHK
lin angiosperm_N = mkWN (k5 "kasvi") "kukkiva" ; --UNCHK
lin angle_N = mkWN (k5 "perspektiivi") ; --UNCHK
lin angle_V = mkWV (k53A "painottaa") ; --UNCHK
lin angle_V2 = mkWV2 (k53A "painottaa") ; --UNCHK
lin angle_iron_N = mkWN (compoundN "kulma" (k39 "teräs")) ; --UNCHK
lin angle_dozer_N = mkWN (compoundN "pusku" (k6 "traktori")) ; --UNCHK
lin angler_N = mkWN "Lophius" "Americanus" ; --UNCHK
lin anglewing_N = mkWN "anglewing" ; --UNCHK
lin anglican_A = mkWA (k38 "anglikaaninen") ; --UNCHK
lin anglicism_N = mkWN (k40 "brittiläisyys") ; --UNCHK
lin anglicize_V2 = mkWV2 (compoundV "englanti" (k56 "laistaa")) ; --UNCHK
lin angling_N = mkWN (compoundN "onki" (k38 "minen")) ; --UNCHK
lin anglomania_N = mkWN (compoundN "anglo" (k12 "mania")) ; --UNCHK
lin anglophilFem_N = mkWN (compoundN "englantilais" (k38 "ystävällinen")) ; --UNCHK
lin anglophilMasc_N = mkWN (compoundN "englantilais" (k38 "ystävällinen")) ; --UNCHK
lin anglophileFem_N = mkWN (compoundN "englantilais" (k38 "ystävällinen")) ; --UNCHK
lin anglophileMasc_N = mkWN (compoundN "englantilais" (k38 "ystävällinen")) ; --UNCHK
lin anglophobe_N = mkWN (k38 "ihminen") "englantilaisvihamielinen" ; --UNCHK
lin anglophobia_N = mkWN (compoundN "anglo" (k12 "fobia")) ; --UNCHK
lin angola_PN = foreignPN "Angola" ;
lin angolan_A = mkWA "Angolan" ; --UNCHK
lin angolan_N = mkWN (compoundN "angol" (k38 "alainen")) ; --UNCHK
lin angora_N = mkWN (k12 "angora") ; --UNCHK
lin angostura_N = mkWN (kH1 "kuori") "angosturan" ; --UNCHK
lin angrecum_N = mkWN "angrecum" ; --UNCHK
lin angry_A = mkWA (k38 "vihainen") ;
lin angst_N = mkWN (k39 "ahdistus") ; --UNCHK
lin angstrom_N = mkWN (k4A "yksikkö") "Ångströmin" ; --UNCHK
lin anguilla_PN = foreignPN "Anguilla" ;
lin anguillan_A = mkWA (compoundA "anguill" (k38 "alainen")) ; --UNCHK
lin anguillan_N = mkWN (compoundN "anguill" (k38 "alainen")) ; --UNCHK
lin anguine_A = mkWA (k38 "käärmemäinen") ; --UNCHK
lin anguish_N = mkWN (k39 "kidutus") ; --UNCHK
lin anguished_A = mkWA (k38 "tuskainen") ; --UNCHK
lin angular_A = mkWA (k41A "kulmikas") ; --UNCHK
lin angularity_N = mkWN (k40 "kulmikkuus") ; --UNCHK
lin angulation_N = mkWN "kulmittaminen" ; --UNCHK
lin angus_PN = foreignPN "Angus" ;
lin angwantibo_N = mkWN (compoundN "pohjankarhul" (k48 "ori")) ; --UNCHK
lin anhedonia_N = mkWN (k48A "puute") "seksuaalisen" "nautinnon" ; --UNCHK
lin anhidrosis_N = mkWN (compoundN "hikoilu" (k40 "kyvyttömyys")) ; --UNCHK
lin anhydride_N = mkWN "anhydridi" ; --UNCHK
lin anhydrous_A = mkWA (k34A "vedetön") ; --UNCHK
lin ani_N = mkWN (k99 "ani") ; --UNCHK
lin anicteric_A = mkWA (compoundA "ani" (k38 "kteerinen")) ; --UNCHK
lin anil_N = mkWN (compoundN "suffrutic" (k10 "osa")) "Indigofera" ; --UNCHK
lin anile_A = mkWA (compoundA "vanhuuden" (k2 "höperö")) ; --UNCHK
lin aniline_N = mkWN (k5 "aniliini") ; --UNCHK
lin anima_N = mkWN "anima" ; --UNCHK
lin animadversion_N = mkWN (k48A "moite") ; --UNCHK
lin animadvert_V = mkWV (k67 "arvostella") ; --UNCHK
lin animal_A = mkA "eläimellinen" ;
lin animal_N = L.animal_N ;
lin animalcule_N = mkWN (k33 "eläin") "mikroskooppinen" ; --UNCHK
lin animalism_N = mkWN (k40 "fyysisyys") ; --UNCHK
lin animalistic_A = mkWA (compoundA "ani" (k38 "malistinen")) ; --UNCHK
lin animality_N = mkWN (k1A "luonto") "eläimellinen" ; --UNCHK
lin animalization_N = mkWN (compoundN "eläimellis" (k38 "tyminen")) ; --UNCHK
lin animate_A = mkWA (k10 "elävä") ; --UNCHK
lin animate_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin animatedly_A = variants {} ;
lin animatedly_Adv = mkWAdv (k99 "vilkkaasti") | adjAdv animatedly_A ; --UNCHK -- derived
lin animateness_N = mkWN (k40 "elollisuus") ; --UNCHK
lin animating_A = mkWA "elähdyttävä" ; --UNCHK
lin animation_N = mkWN (k40 "eloisuus") ; --UNCHK
lin animatistic_A = mkWA (compoundA "ani" (k38 "matistinen")) ; --UNCHK
lin animator_N = mkWN (k12 "tekijä") "piirroselokuvan" ; --UNCHK
lin animatronics_N = mkWN (compoundN "animatron" (k9A "iikka")) ; --UNCHK
lin animism_N = mkWN (k3 "personifikaatio") ; --UNCHK
lin animist_A = mkWA (k38 "animistinen") ; --UNCHK
lin animist_N = mkWN "animisti" ; --UNCHK
lin animosity_N = mkWN (k26 "veri") "paha" ; --UNCHK
lin animus_N = mkWN (k26 "veri") "paha" ; --UNCHK
lin anion_N = mkWN (k5 "ioni") "negatiivinen" ; --UNCHK
lin anionic_A = mkWA (compoundA "ani" (k38 "oninen")) ; --UNCHK
lin anise_N = mkWN (k32 "siemen") "aniksen" ; --UNCHK
lin aniseed_N = mkWN (k32 "siemen") "aniksen" ; --UNCHK
lin aniseikonia_N = mkWN "aniseikonia" ; --UNCHK
lin aniseikonic_A = mkWA (compoundA "anise" (k38 "ikoninen")) ; --UNCHK
lin anisette_N = mkWN (compoundN "anis" (k6 "likööri")) ; --UNCHK
lin anisogamete_N = mkWN (compoundN "aniso" (k5A "gameetti")) ; --UNCHK
lin anisogametic_A = mkWA (compoundA "anisogam" (k38 "eettinen")) ; --UNCHK
lin anisogamic_A = mkWA (compoundA "ani" (k38 "sogaaminen")) ; --UNCHK
lin anisogamy_N = mkWN "anisogamia" ; --UNCHK
lin anisometric_A = mkWA (compoundA "epä" (k38 "symmetrinen")) ; --UNCHK
lin anisometropia_N = mkWN "anisometropia" ; --UNCHK
lin anisometropic_A = mkWA (compoundA "anisome" (k38 "trooppinen")) ; --UNCHK
lin anisotropic_A = mkWA (compoundA "aniso" (k38 "trooppinen")) ; --UNCHK
lin anisotropy_N = mkWN "anisotropia" ; --UNCHK
lin anjala_PN = mkPN "Anjala" ;
lin anjou_N = mkWN "anjou" ; --UNCHK
lin ankara_PN = foreignPN "Ankara" ;
lin ankle_N = mkWN (k9A "nilkka") ; --UNCHK
lin anklebone_N = mkWN (compoundN "tela" (k18 "luu")) ; --UNCHK
lin anklet_N = mkWN (compoundN "nilkka" (k41A "rengas")) ; --UNCHK
lin ankus_N = mkWN "ankus" ; --UNCHK
lin ankylosaur_N = mkWN "ankylosaurus" ; --UNCHK
lin ankylosis_N = mkWN (compoundN "nivel" (k10 "jäykistymä")) ; --UNCHK
lin ankylotic_A = mkWA "ankyloottinen" ; --UNCHK
lin anna_N = mkWN "anna" ; --UNCHK
lin anna_PN = mkPN "Anna" ;
lin annalist_N = mkWN "annalisti" ; --UNCHK
lin annalistic_A = mkWA "annalistinen" ; --UNCHK
lin annan_PN = foreignPN "Annan" ;
lin anne_PN = mkPN "Anne" ;
lin anneal_V2 = mkWV2 (k62 "normalisoida") ; --UNCHK
lin annealing_N = mkWN (k1 "päästö") ; --UNCHK
lin annelid_A = mkWA "nivelmatojen" ; --UNCHK
lin annelid_N = mkWN (compoundN "nivel" (k1A "mato")) ; --UNCHK
lin annex_N = mkWN (k7A "siipi") ; --UNCHK
lin annex_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin annexation_N = mkWN (compoundN "haltuun" (k1A "otto")) ; --UNCHK
lin annexational_A = mkWA "annektointi-" ; --UNCHK
lin annexe_N = mkWN (k7A "siipi") ; --UNCHK
lin annihilate_V2 = mkWV2 (k64 "viedä") "hautaan" ; --UNCHK
lin annihilating_A = mkWA (k10 "murskaava") ; --UNCHK
lin annihilation_N = mkWN (k39 "hävitys") ; --UNCHK
lin annihilative_A = mkWA (k10 "murskaava") ; --UNCHK
lin annihilator_N = mkWN (k10 "tuhoaja") ; --UNCHK
lin anniversary_N = mkN "merkkipäivä" ;
lin annotation_N = mkWN (compoundN "lisä" (k38 "äminen")) "selityksen" ; --UNCHK
lin annotator_N = mkWN (k6 "kommentaattori") ; --UNCHK
lin announce_V2 = mkV2 "julkistaa" ;
lin announce_VS = mkVS "julkistaa" | mkVS "tiedottaa" ;
lin announcement_N = mkWN (k39 "kuulutus") ; --f135
lin announcer_N = mkWN (k10 "kuuluttaja") ; --UNCHK
lin annoy_V2 = mkWV2 (k53A "ottaa") "päähän" ; --UNCHK
lin annoyance_N = mkWN (compoundN "kiusan" (k1A "teko")) ; --UNCHK
lin annoying_A = mkWA (k10 "rasittava") ; --UNCHK
lin annual_A = mkA "vuosittainen" ;
lin annual_N = mkWN (compoundN "vuosi" (k9 "kirja")) ; --UNCHK
lin annuitant_N = mkWN (k10 "saaja") "elinkoron" ; --UNCHK
lin annuity_N = mkWN (k1A "korko") ; --UNCHK
lin annul_V2 = mkWV2 (k74 "kumota") ; --UNCHK
lin annular_A = mkWA (compoundA "rengas" (k38 "mainen")) ; --UNCHK
lin annulet_N = mkWN (k41A "rengas") "pieni" ; --UNCHK
lin annulment_N = mkWN (compoundN "pois" (k38 "taminen")) ; --UNCHK
lin annulus_N = mkWN (k41A "rengas") ; --UNCHK
lin annum_N = mkWN (k27 "vuosi") ; --UNCHK
lin annunciate_V2 = mkWV2 (k62 "ennakoida") ; --UNCHK
lin annunciation_N = mkWN (k39 "kuulutus") ; --UNCHK
lin annunciator_N = mkWN (compoundN "merkinanto" (k48A "laite")) ; --UNCHK
lin annunciatory_A = mkWA "merkinanto-" ; --UNCHK
lin anode_N = mkWN (k5 "anodi") ; --UNCHK
lin anodic_A = mkWA (compoundA "anodi" (k38 "nen")) ; --UNCHK
lin anodyne_A = mkWA (k38 "analgeettinen") ; --UNCHK
lin anodyne_N = mkWN (k5A "analgeetti") ; --UNCHK
lin anoint_V2 = mkWV2 (k67A "voidella") "linimentillä" ; --UNCHK
lin anointer_N = mkWN "voitelija" ; --UNCHK
lin anointing_N = mkWN (k2 "voitelu") ; --UNCHK
lin anointment_N = mkWN (k2 "voitelu") ; --UNCHK
lin anomalist_N = mkWN "anomalisti" ; --UNCHK
lin anomalops_N = mkWN (compoundN "lyhty" (k9 "kala")) ; --UNCHK
lin anomalopteryx_N = mkWN "Anomalopteryx" "oweni" ; --UNCHK
lin anomalous_A = mkWA (k10 "poikkeava") ; --UNCHK
lin anomaly_N = mkWN (k12 "anomalia") ; --UNCHK
lin anomie_N = mkWN "normittomuus" ; --UNCHK
lin anon_Adv = mkWAdv (k99 "pian") ; --UNCHK
lin anonymity_N = mkWN (k40 "nimettömyys") ; --UNCHK
lin anonymous_A = mkWA (k34A "nimetön") ;
lin anoperineal_A = mkWA (compoundA "anoperinea" (k38 "alinen")) ; --UNCHK
lin anopheles_N = mkWN "suku" "Anopheles" ; --UNCHK
lin anopheline_A = mkWA "malariahyttyseen" "liittyvä" ; --UNCHK
lin anopheline_N = mkWN (k1A "moskiitto") ; --UNCHK
lin anopia_N = mkWN (k48A "puute") "silmän" ; --UNCHK
lin anorak_N = mkWN (k5A "anorakki") ; --UNCHK
lin anorchism_N = mkWN "kiveksettömyys" ; --UNCHK
lin anorectal_A = mkWA (compoundA "anorekta" (k38 "alinen")) ; --UNCHK
lin anorectic_A = mkWA "anorektinen" ; --UNCHK
lin anorexia_N = mkWN (k12 "anoreksia") ; --UNCHK
lin anorexic_A = mkWA "anorektinen" ; --UNCHK
lin anorexic_N = mkWN (k4A "anorektikko") ; --UNCHK
lin anorgasmia_N = mkWN (compoundN "orgasmi" (k40 "vaikeus")) ; --UNCHK
lin anorthite_N = mkWN "kalkkimaasälpä" ; --UNCHK
lin anorthitic_A = mkWA "anortiittinen" ; --UNCHK
lin anorthopia_N = mkWN "anortopia" ; --UNCHK
lin anosmia_N = mkWN (compoundN "haistamis" (k40 "kyvyttömyys")) ; --UNCHK
lin anosmic_A = mkWA (compoundA "haistamis" (k34A "kyvytön")) ; --UNCHK
lin another_Det = mkDet Sg (mkN "toinen") ;
lin another_Quant = heavyQuant {s1 = \\n,c => (snoun2nounBind (mkN "toinen")).s ! NCase n c ; s2 = \\_ => [] ; isNum,isPoss,isNeg,isDef = False} ;
lin anovulation_N = mkWN "ovuloimattomuus" ; --UNCHK
lin anoxemia_N = mkWN "anoksemia" ; --UNCHK
lin anoxemic_A = mkWA "anokseeminen" ; --UNCHK
lin anoxia_N = mkWN (compoundN "hapen" (k48A "puute")) ; --UNCHK
lin anoxic_A = mkWA "hapenpuutteesta" "kärsivä" ; --UNCHK
lin anserine_A = mkWA (compoundA "hanhi" (k38 "mainen")) ; --UNCHK
lin anshan_PN = foreignPN "Anshan" ;
lin answer_N = mkN "vastaus" ;
lin answer_V = mkV "vastata" ;
lin answer_V2 = mkV2 "vastata" illative ;
lin answer_V2S = L.answer_V2S ;
lin answer_back_V2 = mkV2 (advV OP_answer_V OP_back_Adv ) ; -- guess-p-verb
lin answer_for_V2 = mkWV2 (k73 "vastata") ; --UNCHK
lin answerable_A = mkWA (k10 "oleva") "vastuussa" ; --UNCHK
lin ant_N = mkWN (k38 "kusiainen") ; --UNCHK
lin ant_eater_N = mkWN (k5 "nokkasiili") ; --UNCHK
lin ant_hill_N = mkWN (compoundN "muurahais" (k10 "pesä")) ; --UNCHK
lin antacid_A = mkWA (compoundA "neutra" (k10 "loiva")) "happoa" ; --UNCHK
lin antagonism_N = mkWN (k40 "vastakkaisuus") ; --UNCHK
lin antagonist_N = mkWN (k5 "antagonisti") ; --UNCHK
lin antagonistic_A = mkWA (k38 "antagonistinen") ; --UNCHK
lin antagonize_V2 = mkWV2 (k53 "vastustaa") ; --UNCHK
lin antapex_N = mkWN "antapeksi" ; --UNCHK
lin antarctic_A = mkWA (k38 "antarktinen") ; --UNCHK
lin antbird_N = mkWN (compoundN "muurahais" (k1A "lintu")) ; --UNCHK
lin ante_N = mkWN (compoundN "aloitus" (k39 "panos")) ; --UNCHK
lin ante_meridiem_Adv = mkWAdv "ennen" "puoltapäivää" ; --UNCHK
lin antecedence_N = mkWN "aiemmuus" ; --UNCHK
lin antecedent_A = mkWA (k10 "käyvä") "edellä" ; --UNCHK
lin antecedent_N = mkWN (k48A "tarkoite") ; --UNCHK
lin antechamber_N = mkWN (k3 "lämpiö") ; --UNCHK
lin antecubital_A = mkWA (compoundA "esikubita" (k38 "alinen")) ; --UNCHK
lin antedate_V2 = mkWV2 (k54A "edeltää") ; --UNCHK
lin antediluvian_N = mkWN (k2 "henkilö") "hyvin" "vanhanaikainen" ; --UNCHK
lin antefix_N = mkWN "antefiksi" ; --UNCHK
lin antelope_N = mkWN (k5A "antilooppi") ; --UNCHK
lin antemeridian_A = mkWA "aamupäivä-" ; --UNCHK
lin antemortem_A = mkWA "kuolemaa" "edeltävä" ; --UNCHK
lin antenatal_A = mkWA (k38 "prenataalinen") ; --UNCHK
lin antenna_N = mkWN (k6 "antenni") ; --UNCHK
lin antennal_A = mkWA "tuntosarvi-" ; --UNCHK
lin antepenultimate_A = mkWA (k38 "viimeinen") "kolmanneksi" ; --UNCHK
lin anterior_A = mkWA (k38 "etummainen") ; --UNCHK
lin anteriority_N = mkWN "aiemmuus" ; --UNCHK
lin anterograde_A = mkWA "anterogradinen" ; --UNCHK
lin anteroom_N = mkWN (k3 "lämpiö") ; --UNCHK
lin anthelmintic_A = mkWA "loismyrkky-" ; --UNCHK
lin anthem_N = mkWN (k28 "virsi") ; --UNCHK
lin anther_N = mkWN (k28 "ponsi") ; --UNCHK
lin antheral_A = mkWA (compoundA "hete" (k38 "inen")) ; --UNCHK
lin antheridial_A = mkWA "siittiöpesäkkeen" ; --UNCHK
lin antheridiophore_N = mkWN (compoundN "anteridiof" (k48 "ori")) ; --UNCHK
lin antheridium_N = mkWN (compoundN "siittiö" (k48A "pesäke")) ; --UNCHK
lin antherozoid_N = mkWN "spermatotsoidi" ; --UNCHK
lin anthologist_N = mkWN "antologisti" ; --UNCHK
lin anthology_N = mkWN (k12 "antologia") ; --UNCHK
lin anthony_PN = foreignPN "Anthony" ;
lin anthophagous_A = mkWA (compoundA "anto" (k38 "fiilinen")) ; --UNCHK
lin anthophyllite_N = mkWN "antofylliitti" ; --UNCHK
lin anthozoan_N = mkWN (compoundN "koralli" (k33 "eläin")) ; --UNCHK
lin anthracite_N = mkWN (k5A "antrasiitti") ; --UNCHK
lin anthracitic_A = mkWA "kivihiili-" ; --UNCHK
lin anthracosis_N = mkWN (compoundN "hiilipöly" (k1 "keuhko")) ; --UNCHK
lin anthrax_N = mkWN (k48 "paise") "pahanlaatuinen" ; --UNCHK
lin anthropic_A = mkWA "antrooppinen" ; --UNCHK
lin anthropocentric_A = mkWA "antroposentrinen" ; --UNCHK
lin anthropocentrism_N = mkWN (compoundN "ihmis" (k40 "keskeisyys")) ; --UNCHK
lin anthropogenesis_N = mkWN "antropogenia" ; --UNCHK
lin anthropogenetic_A = mkWA (compoundA "antropo" (k38 "geneettinen")) ; --UNCHK
lin anthropoid_A = mkWA (k38 "ihmismäinen") ; --UNCHK
lin anthropoid_N = mkWN (compoundN "ihmis" (k12 "apina")) ; --UNCHK
lin anthropolatry_N = mkWN (compoundN "ihmisen" (k9A "palvonta")) ; --UNCHK
lin anthropological_A = mkWA (k38 "antropologinen") ; --UNCHK
lin anthropologistFem_N = mkWN (k5 "antropologi") ; --UNCHK
lin anthropologistMasc_N = mkWN (k5 "antropologi") ; --UNCHK
lin anthropology_N = mkWN (k12 "antropologia") ; --UNCHK
lin anthropometric_A = mkWA (compoundA "antropo" (k38 "metrinen")) ; --UNCHK
lin anthropometry_N = mkWN "antropometria" ; --UNCHK
lin anthropomorphic_A = mkWA (compoundA "ihmisen" (k38 "kaltainen")) ; --UNCHK
lin anthropomorphism_N = mkWN (compoundN "tean" (k5 "tropismi")) ; --UNCHK
lin anthropophagous_A = mkWA "antropofaginen" ; --UNCHK
lin anthropophagy_N = mkWN (compoundN "ihmis" (k5A "syönti")) ; --UNCHK
lin anthroposophy_N = mkWN (k12 "antroposofia") ; --UNCHK
lin anthurium_N = mkWN (compoundN "flamingo" (k10A "kukka")) ; --UNCHK
lin anti_A = mkWA (k10 "oleva") "vastaan" ; --UNCHK
lin anti_N = mkWN (k10 "vastustaja") ; --UNCHK
lin anti_Prep = mkPrep "anti" nominative ;
lin anti_semitic_A = mkA (mkN "anti" (mkN "semitistinen")) ;
lin antiadrenergic_A = mkWA (compoundA "antiadr" (k38 "energinen")) ; --UNCHK
lin anti_aircraft_A = mkWA "ilmatorjunta-" ; --UNCHK
lin anti_aircraft_N = mkWN (k5A "konetykki") ; --UNCHK
lin antialiasing_N = mkWN (k39 "korjaus") "vääristymien" ; --UNCHK
lin antiapartheid_A = mkWA (compoundA "apartheidin" (k38 "vastainen")) ; --UNCHK
lin antiarrhythmic_N = mkWN (compoundN "antiarytmia" (k39 "lääkitys")) ; --UNCHK
lin antiauthoritarian_A = mkWA (compoundA "anti" (k38 "autoritaarinen")) ; --UNCHK
lin antibacterial_A = mkWA (compoundA "anti" (k38 "bakteerinen")) ; --UNCHK
lin antibacterial_N = mkWN (k5A "antibiootti") ; --UNCHK
lin antibaryon_N = mkWN "antibaryoni" ; --UNCHK
lin antibiosis_N = mkWN "antibioosi" ; --UNCHK
lin antibiotic_A = mkWA (k38 "antibioottinen") ; --UNCHK
lin antibiotic_N = mkN "antibiootti" | mkWN (k48A "lääke") "antibioottinen" ;
lin antibody_N = mkWN (compoundN "vasta-" (k48 "aine")) ; --UNCHK
lin antic_A = mkWA (k41A "irvokas") ; --UNCHK
lin antic_N = mkWN (k2 "pelleily") ; --UNCHK
lin anticancer_A = mkWA (compoundA "ehkäis" (k10 "evä")) "kasvaimia" ; --UNCHK
lin anticatalyst_N = mkWN (compoundN "vasta" (k5A "katalyytti")) ; --UNCHK
lin anticholinergic_A = mkWA (compoundA "anti" (k38 "kolinerginen")) ; --UNCHK
lin anticholinergic_N = mkWN (k48A "lääke") "antikolinerginen" ; --UNCHK
lin anticholinesterase_N = mkWN (compoundN "antikoliiniester" (k5 "aasi")) ; --UNCHK
lin anticipant_A = mkWA "odottava" ; --UNCHK
lin anticipate_V = mkWV (k62 "ennakoida") ; --UNCHK
lin anticipate_V2 = mkWV2 (k62 "ennakoida") ; --f62
lin anticipate_VS = mkWVS (k62 "ennakoida") ;
lin anticipate_VV = mkWVV (k62 "ennakoida") ; --UNCHK
lin anticipation_N = mkWN (k39 "povaus") ; --UNCHK
lin anticipator_N = mkWN (k12 "näkijä") ; --UNCHK
lin anticipatory_A = mkWA (compoundA "edellä" (k10 "käyvä")) ; --UNCHK
lin anticlimactic_A = mkWA (k38 "jälkeinen") "huipennuksen" ; --UNCHK
lin anticlimax_N = mkWN (compoundN "anti" (k5 "kliimaksi")) ; --UNCHK
lin anticlinal_A = mkWA (compoundA "antiklina" (k38 "alinen")) ; --UNCHK
lin anticlockwise_Adv = mkWAdv (k99 "vastapäivään") ; --UNCHK
lin anticoagulant_N = mkWN (k48 "aine") "hyytymistä" "estävä" ; --UNCHK
lin anticoagulation_N = mkWN (compoundN "anti" (k3 "koagulaatio")) ; --UNCHK
lin anticoagulative_A = mkWA (compoundA "anti" (k38 "koagulatiivinen")) ; --UNCHK
lin anticonvulsant_N = mkWN (k48A "lääke") "kouristuksia" "estävä" ; --UNCHK
lin anticyclone_N = mkWN (k50 "korkeapaine") ; --UNCHK
lin antidepressant_N = mkWN (compoundN "masennus" (k48A "lääke")) ; --UNCHK
lin antidiabetic_N = mkWN (compoundN "diabetes" (k48A "lääke")) ; --UNCHK
lin antidiarrheal_N = mkWN (compoundN "ripuli" (k48A "lääke")) ; --UNCHK
lin antidiuretic_N = mkWN (k48 "aine") "virtsaneritystä" "vähentävä" ; --UNCHK
lin antidotal_A = mkWA "vastamyrkky-" ; --UNCHK
lin antidote_N = mkWN (compoundN "vasta" (k1A "myrkky")) ; --UNCHK
lin antidromic_A = mkWA (compoundA "anti" (k38 "drominen")) ; --UNCHK
lin antiemetic_N = mkWN (k48A "lääke") "antiemeettinen" ; --UNCHK
lin antiestablishmentarianism_N = mkWN (compoundN "antiestablishmentarian" (k5 "ismi")) ; --UNCHK
lin antifeminist_N = mkWN (compoundN "anti" (k5 "feministi")) ; --UNCHK
lin antiferromagnetic_A = mkWA (compoundA "antiferro" (k38 "magneettinen")) ; --UNCHK
lin antiferromagnetism_N = mkWN (compoundN "antiferro" (k5 "magnetismi")) ; --UNCHK
lin antiflatulent_N = mkWN (compoundN "ilmavaiva" (k48A "lääke")) ; --UNCHK
lin antifreeze_N = mkWN (compoundN "jäätymisenesto" (k48 "aine")) ; --UNCHK
lin antifungal_N = mkWN (k48 "aine") "sieniä" "tappava" ; --UNCHK
lin antigen_N = mkWN (k5 "antigeeni") ; --UNCHK
lin antigenic_A = mkWA (compoundA "anti" (k38 "geeninen")) ; --UNCHK
lin antigram_N = mkWN "antigrammi" ; --UNCHK
lin antigua_PN = foreignPN "Antigua" ;
lin antiguan_A = mkWA (compoundA "antigu" (k38 "alainen")) ; --UNCHK
lin antiguan_N = mkWN (compoundN "antigu" (k38 "alainen")) ; --UNCHK
lin antiheretical_A = mkWA (compoundA "kerettiläisyyden" (k38 "vastainen")) ; --UNCHK
lin anti_hero_N = mkWN (compoundN "anti" (k6 "sankari")) ; --UNCHK
lin antihistamine_N = mkWN (compoundN "anti" (k5 "histamiini")) ; --UNCHK
lin antihypertensive_N = mkWN (k48A "lääke") "antihypertensiivinen" ; --UNCHK
lin antiknock_A = mkWA "nakutuksenesto-" ; --UNCHK
lin antiknock_N = mkWN (compoundN "nakutuksenesto" (k48 "aine")) ; --UNCHK
lin antilepton_N = mkWN (compoundN "anti" (k6 "leptoni")) ; --UNCHK
lin antimacassar_N = mkWN (compoundN "antima" (k5 "kassi")) ; --UNCHK
lin antimagnetic_A = mkWA (compoundA "anti" (k38 "magneettinen")) ; --UNCHK
lin antimalarial_N = mkWN (compoundN "malaria" (k48A "lääke")) ; --UNCHK
lin antimatter_N = mkWN (compoundN "anti" (k48 "aine")) ; --UNCHK
lin antimeson_N = mkWN (compoundN "anti" (k5 "mesoni")) ; --UNCHK
lin antimetabolite_N = mkWN "antimetaboliitti" ; --UNCHK
lin antimicrobial_A = mkWA (compoundA "antimikrobia" (k38 "alinen")) ; --UNCHK
lin antimonial_A = mkWA (compoundA "antimonipi" (k38 "toinen")) ; --UNCHK
lin antimonic_A = mkWA "antimoni-" ; --UNCHK
lin antimonopoly_A = mkWA (k38 "vastainen") "kartellien" ; --UNCHK
lin antimony_N = mkWN (k5 "antimoni") ; --UNCHK
lin antimuon_N = mkWN "positiivinen" "myoni" ; --UNCHK
lin antimycin_N = mkWN "antimysiini" ; --UNCHK
lin antineoplastic_N = mkWN (k48A "lääke") "antineoplastinen" ; --UNCHK
lin antineutrino_N = mkWN (compoundN "anti" (k2 "neutriino")) ; --UNCHK
lin antineutron_N = mkWN (compoundN "anti" (k5 "neutroni")) ; --UNCHK
lin antinode_N = mkWN (k10A "maksimikohta") ; --UNCHK
lin antinomasia_N = mkWN (compoundN "antinom" (k12 "asia")) ; --UNCHK
lin antinomian_A = mkWA (compoundA "antinomi" (k38 "lainen")) ; --UNCHK
lin antinomian_N = mkWN (compoundN "antinomi" (k38 "lainen")) ; --UNCHK
lin antinomianism_N = mkWN (compoundN "antinom" (k5 "ismi")) ; --UNCHK
lin antinomy_N = mkWN (compoundN "risti" (k40 "riitaisuus")) ; --UNCHK
lin antioxidant_N = mkWN (k5A "antioksidantti") ; --UNCHK
lin antiparallel_A = mkWA (compoundA "vastakkais" (k38 "suuntainen")) ; --UNCHK
lin antiparticle_N = mkWN (compoundN "vasta" (k38 "hiukkanen")) ; --UNCHK
lin antipasto_N = mkWN (k1 "antipasto") ; --UNCHK
lin antipathetic_A = mkWA (k38 "antagonistinen") ; --UNCHK
lin antipathy_N = mkWN (k12 "antipatia") ; --UNCHK
lin anti_personnel_A = mkWA "sirpale-" ; --UNCHK
lin antiperspirant_N = mkWN (k5A "antiperspirantti") ; --UNCHK
lin antiphlogistic_A = mkWA (compoundA "anti" (k38 "flogistinen")) ; --UNCHK
lin antiphon_N = mkWN (compoundN "vuoro" (k1 "laulu")) ; --UNCHK
lin antiphonary_A = mkWA (compoundA "antifona" (k38 "alinen")) ; --UNCHK
lin antiphonary_N = mkWN (compoundN "antifo" (k5 "naali")) ; --UNCHK
lin antiphony_N = mkWN (compoundN "vuoro" (k1 "laulu")) ; --UNCHK
lin antiphrasis_N = mkWN (compoundN "anti" (k5 "fraasi")) ; --UNCHK
lin antipodal_A = mkWA (k38 "vastakkainen") ; --UNCHK
lin antipodal_N = mkWN (k3 "oppositio") "diametraalinen" ; --UNCHK
lin antipode_N = mkWN (k10A "vastakohta") ; --UNCHK
lin antipollution_A = mkWA (k10 "torjuva") "saastumista" ; --UNCHK
lin antipope_N = mkWN (compoundN "vasta" (k5 "paavi")) ; --UNCHK
lin antiproton_N = mkWN (compoundN "anti" (k5 "protoni")) ; --UNCHK
lin antiprotozoal_N = mkWN (compoundN "alkueläin" (k48A "lääke")) ; --UNCHK
lin antipruritic_N = mkWN (k48A "lääke") "kutinaa" "lievittävä" ; --UNCHK
lin antipyresis_N = mkWN (compoundN "kuume" (k48A "lääke")) ; --UNCHK
lin antipyretic_A = mkWA (compoundA "antipyr" (k38 "eettinen")) ; --UNCHK
lin antipyretic_N = mkWN (k48A "lääke") "kuumetta" "vähentävä" ; --UNCHK
lin antiquarian_A = mkWA (k38 "antikvaarinen") ; --UNCHK
lin antiquarian_N = mkWN (k12 "tuntija") "vanhojen" "esineiden" ; --UNCHK
lin antiquark_N = mkWN (k5A "antikvarkki") ; --UNCHK
lin antiquary_N = mkWN (k12 "tuntija") "vanhojen" "esineiden" ; --UNCHK
lin antiquated_A = mkWA (k10 "vanhahtava") ; --UNCHK
lin antique_A = mkA "antiikkinen" ;
lin antique_N = mkWN (k5A "antiikki") ; --UNCHK
lin antiquity_N = mkWN (compoundN "muinais" (k39 "jäännös")) ; --UNCHK
lin antiredeposition_N = mkWN (compoundN "harmaantumisenesto" (k48 "aine")) ; --UNCHK
lin antirrhinum_N = mkWN "suku" "Antirrhinum" ; --UNCHK
lin antisatellite_A = mkWA (compoundA "satelliittien" (k38 "vastainen")) ; --UNCHK
lin antiseptic_A = mkWA (k38 "antiseptinen") ; --UNCHK
lin antiseptic_N = mkWN (k48 "aine") "antiseptinen" ; --UNCHK
lin antiserum_N = mkWN (compoundN "anti" (k6 "seerumi")) ; --UNCHK
lin antisocial_A = mkWA (k34A "sopeutumaton") "yhteiskuntaan" ; --UNCHK
lin antispasmodic_N = mkWN (compoundN "kouristus" (k48A "lääke")) ; --UNCHK
lin antistrophe_N = mkWN (compoundN "vastaus" (k2 "säkeistö")) ; --UNCHK
lin antistrophic_A = mkWA (compoundA "antis" (k38 "trooppinen")) ; --UNCHK
lin antisubmarine_A = mkWA "sukellusveneidentorjunta-" ; --UNCHK
lin antisyphilitic_N = mkWN (compoundN "kuppa" (k48A "lääke")) ; --UNCHK
lin antitank_A = mkWA "panssarintorjunta-" ; --UNCHK
lin antitauon_N = mkWN (compoundN "anti" (k18 "tau")) ; --UNCHK
lin antithesis_N = mkWN (compoundN "anti" (k5 "teesi")) ; --UNCHK
lin antithetic_A = mkWA (k38 "vastakkainen") ; --UNCHK
lin antithetical_A = mkWA (k38 "vastakkainen") ; --UNCHK
lin antithyroid_A = mkWA (compoundA "tyreo" (k38 "staattinen")) ; --UNCHK
lin antitoxic_A = mkWA (compoundA "anti" (k38 "toksinen")) ; --UNCHK
lin antitoxin_N = mkWN (compoundN "anti" (k5 "toksiini")) ; --UNCHK
lin antitrade_N = mkWN (compoundN "vasta" (k5 "pasaati")) ; --UNCHK
lin antitussive_N = mkWN "antitussiivi" ; --UNCHK
lin antitype_N = mkWN (compoundN "vasta" (k5A "tyyppi")) ; --UNCHK
lin antitypic_A = mkWA (compoundA "vertaus" (k38 "kuvallinen")) ; --UNCHK
lin antivenin_N = mkWN (compoundN "vasta" (k1A "myrkky")) ; --UNCHK
lin antiviral_A = mkWA (compoundA "antivira" (k38 "alinen")) ; --UNCHK
lin antiviral_N = mkWN (k48 "aine") "antiviraalinen" ; --UNCHK
lin antler_N = mkWN (compoundN "peuran" (k7 "sarvi")) ; --UNCHK
lin antlered_A = mkWA (k41A "sarvekas") ; --UNCHK
lin antony_PN = foreignPN "Antony" ;
lin antonym_N = mkWN (k10A "vastakohta") ; --UNCHK
lin antonymous_A = mkWA (k38 "vastakkainen") "merkitykseltään" ; --UNCHK
lin antonymy_N = mkWN (k40 "vastakkaisuus") "merkitysten" ; --UNCHK
lin antrim_PN = foreignPN "Antrim" ;
lin antrum_N = mkWN (k2 "ontelo") ; --UNCHK
lin antsy_A = mkWA (k10 "ärtyisä") ; --UNCHK
lin antwerp_PN = foreignPN "Antwerpen" ;
lin anuran_A = mkWA "sammakkoeläin-" ; --UNCHK
lin anuresis_N = mkWN (compoundN "virtsaamis" (k40 "kyvyttömyys")) ; --UNCHK
lin anuretic_A = mkWA (compoundA "anur" (k38 "eettinen")) ; --UNCHK
lin anurous_A = mkWA "pyrstötön" ; --UNCHK
lin anus_N = mkWN (compoundN "perä" (k1A "aukko")) ; --UNCHK
lin anvil_N = mkWN (k33 "alasin") ; --UNCHK
lin anxiety_N = mkWN (k26 "huoli") ; --UNCHK
lin anxiolytic_A = mkWA "anksiolyyttinen" ; --UNCHK
lin anxious_A = mkWA (k41A "innokas") ; --UNCHK
lin anxiousness_N = mkWN (k40 "rauhattomuus") ; --UNCHK
lin anyPl_Det = {s1,sp = S.mikaanPron ! Pl ; s2 = \\_ => [] ; isNum,isPoss,isNeg,isDef = False ; n = Pl} ;
lin anySg_Det = {s1,sp = S.mikaanPron ! Sg ; s2 = \\_ => [] ; isNum,isPoss,isNeg,isDef = False ; n = Sg} ;
lin any_Adv = mkWAdv (k99 "yhtään") ; --UNCHK
lin anybody_NP = {s = table {NPAcc => "kenet" ++ "tahansa" ; c => S.kukaInt ! Sg ! npform2case Sg c ++ "tahansa"} ; a = agrP3 Sg ; isPron, isNeg = False} ;
lin anyhow_Adv = mkWAdv (k99 "ainakin") ; --UNCHK
lin anymore_Adv = mkWAdv (k99 "enää") ; --UNCHK
lin anyone_NP = {s = table {NPAcc => "kenet" ++ "tahansa" ; c => S.kukaInt ! Sg ! npform2case Sg c ++ "tahansa"} ; a = agrP3 Sg ; isPron, isNeg = False} ;
lin anyplace_Adv = mkWAdv (k99 "tahansa") "missä" ; --UNCHK
lin anything_NP = {s = \\c => S.mikaInt ! Sg ! (npform2case Sg c) ++ "tahansa" ; a = agrP3 Sg ; isPron, isNeg = False} ;
lin anyway_Adv = mkAdv "joka tapauksessa" ;
lin anywhere_Adv = mkWAdv (k99 "tahansa") "missä" ; --UNCHK
lin aorist_N = mkWN "aoristi" ; --UNCHK
lin aoristic_A = mkWA "aoristinen" ; --UNCHK
lin aorta_N = mkWN (k9A "aortta") ; --UNCHK
lin aortal_A = mkWA "aorttaan" "liittyvä" ; --UNCHK
lin aortitis_N = mkWN (compoundN "aortta" (k39 "tulehdus")) ; --UNCHK
lin aoudad_N = mkWN (compoundN "harja" (k41A "lammas")) ; --UNCHK
lin apace_Adv = mkWAdv (k99 "joutuin") ; --UNCHK
lin apache_N = mkWN (k5 "apassi") ; --UNCHK
lin apadana_N = mkWN "apadana" ; --UNCHK
lin apar_N = mkWN (compoundN "pallo" (k38 "vyötiäinen")) ; --UNCHK
lin apart_Adv = mkAdv "erillään" | mkAdv "erikseen" | mkAdv "syrjässä" | mkAdv "syrjään" ; ---- split
lin apart_from_Prep = mkPrep "lisäksi" ;
lin apartheid_N = mkWN (k5 "apartheid") ; --UNCHK
lin apartment_N = L.apartment_N ;
lin apathetic_A = mkWA (k34A "haluton") ; --UNCHK
lin apathy_N = mkWN (k40 "hengettömyys") ; --UNCHK
lin apatite_N = mkWN (k5A "apatiitti") ; --UNCHK
lin apatosaur_N = mkWN (k39 "brontosaurus") ; --UNCHK
lin ape_N = mkWN (k12 "apina") ; --UNCHK
lin ape_V2 = mkWV2 (k62 "apinoida") ; --UNCHK
lin apeldoorn_PN = foreignPN "Apeldoorn" ;
lin apercu_N = mkWN (k39 "luonnos") ; --UNCHK
lin aperea_N = mkWN (compoundN "villi" (k1 "marsu")) ; --UNCHK
lin aperient_A = mkWA "aperientti" ; --UNCHK
lin aperient_N = mkWN (k5 "laksatiivi") ; --UNCHK
lin aperiodic_A = mkWA (compoundA "epä" (k38 "jaksollinen")) ; --UNCHK
lin aperitif_N = mkWN (k5 "aperitiivi") ; --UNCHK
lin aperture_N = mkWN (k10A "reikä") ; --UNCHK
lin apery_N = mkWN (k2 "jäljittely") ; --UNCHK
lin apetalous_A = mkWA "terälehdetön" ; --UNCHK
lin apex_N = mkWN "auringon" "apeksi" ; --UNCHK
lin aphaeresis_N = mkWN "afereesi" ; --UNCHK
lin aphaeretic_A = mkWA (compoundA "afer" (k38 "eettinen")) ; --UNCHK
lin aphagia_N = mkWN "afagia" ; --UNCHK
lin aphakia_N = mkWN "mykiöttömyys" ; --UNCHK
lin aphakic_A = mkWA "afakia-" ; --UNCHK
lin aphakic_N = mkWN (k38 "ihminen") "mykiötön" ; --UNCHK
lin aphanite_N = mkWN (compoundN "afa" (k5A "niitti")) ; --UNCHK
lin aphanitic_A = mkWA "afaniittinen" ; --UNCHK
lin aphasia_N = mkWN (k12 "afasia") ; --UNCHK
lin aphasic_A = mkWA (k38 "afaattinen") ; --UNCHK
lin aphasic_N = mkWN (k4A "afaatikko") ; --UNCHK
lin apheresis_N = mkWN "fereesi" ; --UNCHK
lin aphesis_N = mkWN "afeesi" ; --UNCHK
lin aphetic_A = mkWA "afeettinen" ; --UNCHK
lin aphid_N = mkWN (k9 "kirva") ; --UNCHK
lin aphis_N = mkWN "suku" "Aphis" ; --UNCHK
lin aphonia_N = mkWN (compoundN "äänen" (k1A "kato")) ; --UNCHK
lin aphonic_A = mkWA (compoundA "äänenka" (k38 "toinen")) ; --UNCHK
lin aphorism_N = mkWN (k5 "aforismi") ; --UNCHK
lin aphorist_N = mkWN (compoundN "afo" (k4A "ristikko")) ; --UNCHK
lin aphoristic_A = mkWA (k38 "aforistinen") ; --UNCHK
lin aphotic_A = mkWA "valoton" ; --UNCHK
lin aphrodisia_N = mkWN "afrodisia" ; --UNCHK
lin aphrodisiac_A = mkWA (k41A "seksikäs") ; --UNCHK
lin aphrodisiac_N = mkWN (k48 "aine") "sukuviettiä" "kiihottava" ; --UNCHK
lin aphyllous_A = mkWA "lehdetön" ; --UNCHK
lin apian_A = mkWA "mehiläis-" ; --UNCHK
lin apiarian_A = mkWA "mehiläishoito-" ; --UNCHK
lin apiarist_N = mkWN (compoundN "mehiläis" (k10 "hoitaja")) ; --UNCHK
lin apiary_N = mkWN (compoundN "mehiläis" (k9 "tarha")) ; --UNCHK
lin apical_A = mkWA (compoundA "apika" (k38 "alinen")) ; --UNCHK
lin apiculate_A = mkWA (k38 "kärjellinen") ; --UNCHK
lin apicultural_A = mkWA "mehiläishoito-" ; --UNCHK
lin apiculture_N = mkWN (k1A "hoito") "mehiläisten" ; --UNCHK
lin apiece_Adv = mkAdv "kappale" ;
lin apish_A = mkWA (k10 "typerä") ; --UNCHK
lin apishamore_N = mkWN (compoundN "satu" (k25 "loimi")) "puhvelinnahkainen" ; --UNCHK
lin apivorous_A = mkWA "mehiläissyöjä-" ; --UNCHK
lin aplacental_A = mkWA "istukaton" ; --UNCHK
lin aplanatic_A = mkWA "aplanaattinen" ; --UNCHK
lin aplasia_N = mkWN (compoundN "apl" (k12 "asia")) ; --UNCHK
lin aplite_N = mkWN "apliitti" ; --UNCHK
lin aplitic_A = mkWA "apliittinen" ; --UNCHK
lin aplomb_N = mkWN (k40 "viileys") ; --UNCHK
lin apnea_N = mkWN (k12 "apnea") ; --UNCHK
lin apneic_A = mkWA "apnea-" ; --UNCHK
lin apoapsis_N = mkWN "apofocus" ; --UNCHK
lin apocalypse_N = mkWN (k39 "ilmestys") "Johanneksen" ; --UNCHK
lin apocalyptic_A = mkWA (k38 "apokalyptinen") ; --UNCHK
lin apocarpous_A = mkWA "apokarppinen" ; --UNCHK
lin apochromatic_A = mkWA (compoundA "apo" (k38 "kromaattinen")) ; --UNCHK
lin apocope_N = mkWN (compoundN "loppu" (k1A "heitto")) ; --UNCHK
lin apocrine_A = mkWA "apokriininen" ; --UNCHK
lin apocryphal_A = mkWA (k38 "apokryfinen") ; --UNCHK
lin apocynaceous_A = mkWA "oleanteri-" ; --UNCHK
lin apodal_A = mkWA "jalaton" ; --UNCHK
lin apodeme_N = mkWN (compoundN "apode" (k5 "emi")) ; --UNCHK
lin apodictic_A = mkWA (k34A "välttämätön") ; --UNCHK
lin apoenzyme_N = mkWN (compoundN "apo" (k6 "entsyymi")) ; --UNCHK
lin apogamic_A = mkWA (compoundA "apogam" (k38 "eettinen")) ; --UNCHK
lin apogamy_N = mkWN "apogamia" ; --UNCHK
lin apogean_A = mkWA "apogeum-" ; --UNCHK
lin apogee_N = mkWN "apogeum" ; --UNCHK
lin apojove_N = mkWN (compoundN "apoj" (k7 "ovi")) ; --UNCHK
lin apolemia_N = mkWN "apolemia" ; --UNCHK
lin apolitical_A = mkWA (compoundA "epä" (k38 "poliittinen")) ; --UNCHK
lin apologetic_A = mkWA "anteeksipyytävä" ; --UNCHK
lin apologetics_N = mkWN (compoundN "apolog" (k14A "etiikka")) ; --UNCHK
lin apologist_N = mkWN (k10 "puolustaja") ; --UNCHK
lin apologize_V = mkWV (k54A "pyytää") "anteeksi" ; --UNCHK
lin apology_N = mkWN (compoundN "anteeksi" (k1A "pyyntö")) ; --UNCHK
lin apomict_N = mkWN "apomikti" ; --UNCHK
lin apomictic_A = mkWA "apomiktinen" ; --UNCHK
lin apomixis_N = mkWN "apomiksis" ; --UNCHK
lin apomorphine_N = mkWN (compoundN "apo" (k5 "morfiini")) ; --UNCHK
lin aponeurosis_N = mkWN (compoundN "kalvo" (k48A "jänne")) ; --UNCHK
lin aponeurotic_A = mkWA (compoundA "apo" (k38 "neuroottinen")) ; --UNCHK
lin apopemptic_A = mkWA "apopemptinen" ; --UNCHK
lin apophasis_N = mkWN (compoundN "apo" (k5 "faasi")) ; --UNCHK
lin apophatic_A = mkWA "apofaattinen" ; --UNCHK
lin apophthegm_N = mkWN (k5 "aforismi") ; --UNCHK
lin apophyseal_A = mkWA (compoundA "apo" (k38 "fyysinen")) ; --UNCHK
lin apophysis_N = mkWN (compoundN "apofy" (k5 "ysi")) ; --UNCHK
lin apoplectic_A = mkWA "apoplektinen" ; --UNCHK
lin apoplectiform_A = mkWA (compoundA "apoplektin" (k38 "tapainen")) ; --UNCHK
lin apoplexy_N = mkWN (compoundN "aivo" (k39 "halvaus")) ; --UNCHK
lin apoptosis_N = mkWN (k5 "apoptoosi") ; --UNCHK
lin aposelene_N = mkWN (compoundN "apol" (k24 "uni")) ; --UNCHK
lin aposiopesis_N = mkWN (compoundN "aposio" (k39 "pesis")) ; --UNCHK
lin aposiopetic_A = mkWA (compoundA "aposiop" (k38 "eettinen")) ; --UNCHK
lin apostasy_N = mkWN (k40 "petturuus") ; --UNCHK
lin apostate_A = mkWA (k34A "uskoton") ; --UNCHK
lin apostate_N = mkWN (k6 "petturi") ; --UNCHK
lin apostle_N = mkWN (k5 "apostoli") ; --UNCHK
lin apostleship_N = mkWN "apostolisuus" ; --UNCHK
lin apostolic_A = mkWA (k38 "apostolinen") ; --UNCHK
lin apostrophe_N = mkWN "puolilainausmerkki" ; --UNCHK
lin apostrophic_A = mkWA "apostrofinen" ; --UNCHK
lin apostrophize_V2 = mkWV2 (compoundV "heitto" (k53A "merkittää")) ; --UNCHK
lin apothecary_N = mkWN (k6 "proviisori") ; --UNCHK
lin apothecial_A = mkWA "kotelomaljan" ; --UNCHK
lin apothecium_N = mkWN (compoundN "kotelo" (k9 "malja")) ; --UNCHK
lin apothegm_N = mkWN (k5 "aforismi") ; --UNCHK
lin apothegmatic_A = mkWA (compoundA "mietelauseen" (k38 "omainen")) ; --UNCHK
lin apotheosis_N = mkWN "apoteoosi" ; --UNCHK
lin apotropaic_A = mkWA (compoundA "kark" (k10 "ottava")) "pahan" ; --UNCHK
lin appal_V2 = mkWV2 (k53A "pelästyttää") ; --UNCHK
lin appalling_A = mkWA (compoundA "kauhis" (k10 "tuttava")) ; --UNCHK
lin appalling_N = mkWN (compoundN "kauhis" (k10 "tuttava")) ; --UNCHK
lin appanage_N = mkWN (compoundN "apan" (k5 "aasi")) ; --UNCHK
lin apparatchik_N = mkWN "apparatsikki" ; --UNCHK
lin apparatus_N = mkWN (k5A "aparaatti") ; --UNCHK
lin apparel_N = mkWN (k1A "puku") ; --UNCHK
lin apparel_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin appareled_A = mkWA (compoundA "vaate" (k1 "tettu")) ; --UNCHK
lin apparent_A = mkA "ilmeinen" ;
lin apparentness_N = mkWN (compoundN "ilmi" (k1 "asu")) ; --UNCHK
lin apparition_N = mkWN (compoundN "ilme" (k38 "styminen")) ; --UNCHK
lin apparitional_A = mkWA (k38 "henkinen") ; --UNCHK
lin appeal_N = mkN "vetoomus" ;
lin appeal_V = mkV "vedota" ;
lin appeal_V2 = mkV2 "vedota" illative ; --mkWV2 (k67 "rukoilla") ;
lin appealable_A = mkWA (compoundA "valitus" (k38 "kelpoinen")) ; --UNCHK
lin appealing_A = variants {} ;
lin appear_V = mkV "ilmestyä" ;
lin appear_VA = mkVA (mkV "vaikuttaa") (casePrep ablative) ;
lin appear_VS = mkVS (mkV (mkV "näyttää") "siltä") ;
lin appear_VV = mkVV (mkV "näyttää") infPresPart ;
lin appearance_N = mkWN (compoundN "esi" (k38 "intyminen")) ; --UNCHK
lin appeasable_A = mkWA (k38 "sovinnollinen") ; --UNCHK
lin appease_V2 = mkWV2 (k53A "tyynnyttää") ; --UNCHK
lin appeasement_N = mkWN "tyynnyttäminen" ; --UNCHK
lin appeaser_N = mkWN (k12 "sovittelija") ; --UNCHK
lin appellant_A = mkWA "muutoksenhaku-" ; --UNCHK
lin appellant_N = mkWN (k10 "valittaja") ; --UNCHK
lin appellate_A = mkWA "muutoksenhaku-" ; --UNCHK
lin appellation_N = mkWN (k39 "nimitys") ; --UNCHK
lin appellative_A = mkWA (compoundA "appellatiivi" (k38 "nen")) ; --UNCHK
lin append_V2 = mkWV2 (k56 "jatkaa") ; --UNCHK
lin appendage_N = mkWN (k48A "liite") ; --UNCHK
lin appendaged_A = mkWA (k10 "oleva") "liitteenä" ; --UNCHK
lin appendant_A = mkWA (compoundA "liite" (k1 "tty")) ; --UNCHK
lin appendectomy_N = mkWN (k1 "poisto") "umpilisäkkeen" ; --UNCHK
lin appendicitis_N = mkWN (k39 "tulehdus") "umpilisäkkeen" ; --UNCHK
lin appendicle_N = mkWN (k48A "lisäke") "pieni" ; --UNCHK
lin appendicular_A = mkWA "lisäke-" ; --UNCHK
lin appendix_N = mkWN (k48A "lisäke") "sekaalinen" ; --UNCHK
lin appertain_V = mkWV (k58 "koskea") "jtk" ; --UNCHK
lin appetent_A = mkWA (k41A "himokas") ; --UNCHK
lin appetite_N = mkWN (k39 "viehtymys") ; --UNCHK
lin appetitive_A = mkWA (k41A "himokas") ; --UNCHK
lin appetizer_N = mkWN (compoundN "alku" (k9 "pala")) ; --UNCHK
lin appetizing_A = mkWA (k38 "herkullinen") ; --UNCHK
lin appetizingness_N = mkWN (k40 "herkullisuus") ; --UNCHK
lin applaud_V = mkWV (k53 "ylistää") ; --UNCHK
lin applaud_V2 = mkWV2 (k53 "ylistää") ;
lin applaudable_A = mkWA (k10 "kunnioitettava") ; --UNCHK
lin applause_N = mkN "suosionosoitus" ;
lin apple_N = L.apple_N ;
lin applejack_N = mkWN (compoundN "omena" (k1 "brandy")) ; --UNCHK
lin applesauce_N = mkWN (k6 "liirumlaarum") ; --UNCHK
lin applet_N = mkWN "sovelma" ; --UNCHK
lin applewood_N = mkWN (compoundN "omena" (k18 "puu")) ; --UNCHK
lin appliance_N = mkWN (k48A "laite") ; --UNCHK
lin applicability_N = mkWN (k5 "relevanssi") ; --UNCHK
lin applicable_A = mkWA (k10 "sopiva") ;
lin applicant_N = mkN (lin NK {s = d12 "hakija"}) ;
lin application_1_N = mkN "sovellus" ;
lin application_2_N = mkN "sovellus" ;
lin application_3_N = mkN "sovellus" ;
lin applicative_A = mkWA (k10 "oleva") "sovellettavissa" ; --UNCHK
lin applicator_N = mkWN (k33A "levitin") ; --UNCHK
lin applied_A = mkA "sovellettu" ;
lin applique_N = mkWN (k5A "applikointi") ; --UNCHK
lin applique_V2 = mkWV2 (k62 "applikoida") ; --UNCHK
lin apply_1_V2 = mkV2 "soveltaa" partitive ;
lin apply_2_V2 = mkV2 "hakea" partitive ;
lin apply_V = mkV "soveltua" ;
lin apply_V2 = mkV2 "soveltaa" partitive ;
lin apply_V2V = mkV2V (mkV "soveltaa") partitive infIllat ;
lin apply_VV = mkVV "hakea" infIllat ;
lin apply_for_V2 = prepV2 OP_apply_V OP_for_Prep ; -- guess-p-verb
lin appoint_V2 = mkV2 "nimittää" ; --WV2 (k53 "varustaa") ;
lin appoint_V2V = mkWV2V (k53 "varustaa") ; --UNCHK
lin appoint_V3 = mkWV3 (k53 "varustaa") ; --UNCHK
lin appointed_A = variants {} ; --
lin appointee_N = mkWN (k39 "nimitys") ; --UNCHK
lin appointive_A = mkWA (compoundA "määräyksen" (k38 "varainen")) ; --UNCHK
lin appointment_N = mkN "nimitys" ;
lin apportion_V2 = mkWV2 (k67 "annostella") ; --UNCHK
lin apportionment_N = mkWN (k5A "allokointi") ; --UNCHK
lin apposite_A = mkWA (k38 "olennainen") ; --UNCHK
lin apposition_N = mkWN (k2 "asettelu") "vierekkäin" ; --UNCHK
lin appositional_A = mkWA (compoundA "appositiona" (k38 "alinen")) ; --UNCHK
lin appositively_Adv = mkWAdv "appositiona" ; --UNCHK
lin appraisal_N = mkWN (k5A "arviointi") ;
lin appraise_V2 = mkWV2 (k62 "arvioida") ; --UNCHK
lin appraiser_N = mkWN (k10 "arvioija") ; --UNCHK
lin appreciable_A = mkWA (k10 "huomattava") ; --UNCHK
lin appreciate_V = mkV "arvostaa" ;
lin appreciate_V2 = mkV2 "arvostaa" partitive ;
lin appreciation_N = mkN "arvostus" ; ---ARB mkWN (compoundN "arvon" (k1 "nousu")) ;
lin appreciative_A = mkWA (k10 "ymmärtävä") ; --UNCHK
lin appreciator_N = mkWN (k2 "henkilö") "ymmärtävä" ; --UNCHK
lin apprehend_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin apprehender_N = mkWN (compoundN "kiinni" (k10 "ottaja")) ; --UNCHK
lin apprehensible_A = mkWA (k10 "ymmärrettävä") ; --UNCHK
lin apprehension_N = mkWN (k99 "kiinni") "saada" ; --UNCHK
lin apprehensive_A = mkWA (k41A "pelokas") ; --UNCHK
lin apprentice_N = mkWN (k41 "oppilas") ; --UNCHK
lin apprentice_V2 = mkWV2 (k67 "olla") "opissa" ; --UNCHK
lin apprenticeship_N = mkWN (k9A "oppiaika") ; --UNCHK
lin appressed_A = mkWA (compoundA "pai" (k47 "nautunut")) "tiukasti" ; --UNCHK
lin appro_N = mkWN (k10A "hyväksyntä") ; --UNCHK
lin approach_N = mkN "lähestymis" (mkN "tapa") ;
lin approach_V = mkWV (k52A "lähentyä") ; --UNCHK
lin approach_V2 = mkV2 "lähestyä" partitive ;
lin approachability_N = mkWN (k40 "saavutettavuus") ; --UNCHK
lin approachable_A = mkWA "helposti" "lähestyttävä" ; --UNCHK
lin approbation_N = mkWN (k10A "hyväksyntä") ; --UNCHK
lin appropriable_A = mkWA (k10 "oleva") "myönnettävissä" ; --UNCHK
lin appropriate_A = mkA "sopiva" ;
lin appropriate_V2 = mkV2 (mkV "myöntää") (casePrep illative) ; ---ARB varastaa, anastaa, omia ; myöntää jhkin käyttötarkoitukseen. dir obj missing, should be a V3.
lin appropriateness_N = mkWN (k40 "soveltuvuus") ; --UNCHK
lin appropriation_N = mkWN (compoundN "omaksi" (k1A "otto")) ; --f59
lin appropriative_A = mkWA "omaksiotto-" ; --UNCHK
lin appropriator_N = mkWN (k10 "anastaja") ; --UNCHK
lin approval_N = mkN "hyväksyntä" ;
lin approve_V = mkWV (k52 "hyväksyä") ; --f63
lin approve_V2 = mkV2 "hyväksyä" ;
lin approved_A = mkA "hyväksytty" ;
lin approver_N = mkWN (k10 "hyväksyjä") ; --UNCHK
lin approvingly_Adv = mkWAdv (compoundAdv "hyväk" (k99 "syvästi")) ; --UNCHK
lin approximate_A = mkA "likimääräinen" ;
lin approximate_V = mkWV (k62 "estimoida") ; --UNCHK
lin approximate_V2 = mkWV2 (k62 "estimoida") ; --UNCHK
lin approximately_Adv = mkAdv "suunnilleen" ;
lin approximation_N = mkWN (k38 "tuominen") "yhteen" ; --UNCHK
lin appurtenance_N = mkWN (k48 "varuste") ; --UNCHK
lin apractic_A = mkWA "apraksinen" ; --UNCHK
lin apraxia_N = mkWN "haparoivuus" ; --UNCHK
lin apricot_N = mkWN (k5 "aprikoosi") ; --UNCHK
lin apron_N = mkWN (k1 "essu") ; --UNCHK
lin apropos_A = mkWA (k99 "sopivasti") ; --UNCHK
lin apropos_Adv = mkWAdv (k99 "muuten") ; --UNCHK
lin apropos_Prep = mkPrep elative "puheenollen" ;
lin apse_N = mkWN (compoundN "alttari" (k2 "komero")) ; --UNCHK
lin apsidal_A = mkWA "apsis-" ; --UNCHK
lin apt_A = mkA "osuva" ; --mkWA (k38 "olennainen") ;
lin apteral_A = mkWA (compoundA "aptera" (k38 "alinen")) ; --UNCHK
lin apterous_A = mkWA (k34A "siivetön") ; --UNCHK
lin aptitude_N = mkWN (k1A "taito") ; --UNCHK
lin aptitudinal_A = mkWA "taito-" ; --UNCHK
lin aptness_N = mkWN (k40 "sattuvuus") ; --UNCHK
lin apud_Prep = mkPrep "luona" ;
lin aquamarine_N = mkWN (k6 "turkoosi") ; --UNCHK
lin aquanaut_N = mkWN (k10 "sukeltaja") ; --UNCHK
lin aquaphobia_N = mkWN (compoundN "vesi" (k12 "fobia")) ; --UNCHK
lin aquaplane_N = mkWN (compoundN "laine" (k9A "lauta")) ; --UNCHK
lin aquaplane_V = mkWV (compoundV "laine" (k67 "lautailla")) ; --UNCHK
lin aquarium_N = mkWN (k3 "akvaario") ; --UNCHK
lin aquatic_A = mkWA "vesi-" ; --UNCHK
lin aquatic_N = mkWN (compoundN "vesi" (k5 "kasvi")) ; --UNCHK
lin aquatint_N = mkWN (k9 "akvatinta") ; --UNCHK
lin aquavit_N = mkWN (k5A "akvaviitti") ; --UNCHK
lin aqueduct_N = mkWN "akvedukti" ; --UNCHK
lin aqueous_A = mkWA (compoundA "kerros" (k47 "tunut")) ; --UNCHK
lin aquicultural_A = mkWA "hydroponinen" ; --UNCHK
lin aquifer_N = mkWN (k39 "kerros") "pohjavettä" "johtava" ; --UNCHK
lin aquiferous_A = mkWA "pohjavesivara-" ; --UNCHK
lin aquiline_A = mkWA (compoundA "koukku" (k38 "mainen")) ; --UNCHK
lin arab_N = mkWN (k38 "arabialainen") ; --UNCHK
lin arabesque_N = mkWN (k5 "arabeski") ; --UNCHK
lin arabianFem_N = mkWN (k38 "arabialainen") ; --UNCHK
lin arabianMasc_N = mkWN (k38 "arabialainen") ; --UNCHK
lin arabian_A = mkWA (k38 "arabialainen") ; --UNCHK
lin arabic_A = mkWA (k38 "arabialainen") ; --UNCHK
lin arability_N = mkWN (compoundN "viljelys" (k40 "kelpoisuus")) ; --UNCHK
lin arabist_N = mkWN (k5 "arabisti") ; --UNCHK
lin arable_A = mkWA (compoundA "viljely" (k38 "kelpoinen")) ; --UNCHK
lin arachnid_N = mkWN (compoundN "hämähäkki" (k33 "eläin")) ; --UNCHK
lin arachnoid_A = mkWA (compoundA "hämähäkki" (k38 "mäinen")) ; --UNCHK
lin arachnoid_N = mkWN (compoundN "hämähäkki" (k33 "eläin")) ; --UNCHK
lin arachnophobia_N = mkWN (compoundN "hämähäkki" (k1 "kammo")) ; --UNCHK
lin aragonite_N = mkWN (compoundN "arago" (k5A "niitti")) ; --UNCHK
lin aralia_N = mkWN (k12 "aralia") ; --UNCHK
lin arame_N = mkWN "arame" ; --UNCHK
lin araneidal_A = mkWA "hämähäkki-" ; --UNCHK
lin arariba_N = mkWN "Centrolobium" "robustum" ; --UNCHK
lin araroba_N = mkWN "araroba" ; --UNCHK
lin araucaria_N = mkWN (k12 "araukaria") ; --UNCHK
lin arbiter_N = mkWN (k6 "tuomari") ; --UNCHK
lin arbitrable_A = mkWA (k10 "oleva") "soviteltavissa" ; --UNCHK
lin arbitrage_N = mkWN (compoundN "arbitr" (k5 "aasi")) ; --UNCHK
lin arbitrageur_N = mkWN (k2 "henkilö") "arbitraasia" "harjoittava" ; --UNCHK
lin arbitral_A = mkWA "välitys-" ; --UNCHK
lin arbitrament_N = mkWN (k39 "päätös") "välitystuomarin" ; --UNCHK
lin arbitrary_A = mkWA (k38 "mielivaltainen") ;
lin arbitrate_V = mkWV (k61 "toimia") "välittäjänä" ; --UNCHK
lin arbitrate_V2 = mkWV2 (k61 "toimia") "välittäjänä" ; --UNCHK
lin arbitration_N = mkN "sovittelu" ; --mkWN (k39 "päätös") "välitystuomarin" ;
lin arbitrative_A = mkWA "välitys-" ; --UNCHK
lin arbitrator_N = mkWN (k6 "tuomari") ;
lin arbor_N = mkWN (k12 "pergola") ; --UNCHK
lin arboraceous_A = mkWA (k38 "metsäinen") ; --UNCHK
lin arboreal_A = mkWA (k10 "elävä") "puussa" ; --UNCHK
lin arboretum_N = mkWN (k1 "puisto") "kasvitieteellinen" ; --UNCHK
lin arborical_A = mkWA "puu-" ; --UNCHK
lin arboriculture_N = mkWN (compoundN "metsän" (k39 "kasvatus")) ; --UNCHK
lin arborolatry_N = mkWN (k9A "palvonta") "puiden" ; --UNCHK
lin arborvitae_N = mkWN (compoundN "havu" (k18 "puu")) ; --UNCHK
lin arbour_N = mkWN (k12 "pergola") ; --UNCHK
lin arbovirus_N = mkWN (compoundN "arbo" (k39 "virus")) ; --UNCHK
lin arbroath_PN = foreignPN "Arbroath" ;
lin arbutus_N = mkWN "arbutus" ; --UNCHK
lin arc_N = mkWN (kH1 "kaari") ; --UNCHK
lin arc_lamp_N = mkWN (compoundN "kaari" (k1A "lamppu")) ; --UNCHK
lin arc_light_N = mkWN (compoundN "kaari" (k1A "lamppu")) ; --UNCHK
lin arcade_N = mkWN (k4A "pylväikkö") ; --UNCHK
lin arcadian_A = mkWA (k38 "maaseutumainen") ; --UNCHK
lin arcadian_N = mkWN (compoundN "arkadi" (k38 "alainen")) ; --UNCHK
lin arcane_A = mkWA (k38 "vaikeaselkoinen") ; --UNCHK
lin arced_A = mkWA (k10 "kaareva") ; --UNCHK
lin arcella_N = mkWN (compoundN "kiekkokuori" (k9 "ameba")) ; --UNCHK
lin arch_A = mkWA (k10 "tuhma") ; --UNCHK
lin arch_N = mkWN (kH1 "kaari") ; --UNCHK
lin arch_V = mkWV (k52 "käyristyä") ; --UNCHK
lin arch_V2 = mkWV2 (k52 "käyristyä") ; --UNCHK
lin archaebacteria_N = mkWN (compoundN "arkki" (k6 "bakteeri")) ; --UNCHK
lin archaeological_A = mkWA (k38 "arkeologinen") ; --UNCHK
lin archaeologist_N = mkWN (k5 "arkeologi") ; --UNCHK
lin archaeology_N = mkWN (k12 "arkeologia") ; --UNCHK
lin archaeopteryx_N = mkWN (compoundN "muinais" (k38 "siipinen")) ; --UNCHK
lin archaeornis_N = mkWN "archaeornis" ; --UNCHK
lin archaic_A = mkWA (k38 "primitiivinen") ; --UNCHK
lin archaism_N = mkWN (k5 "arkaismi") ; --UNCHK
lin archaist_N = mkWN (k12 "tuntija") "vanhojen" "esineiden" ; --UNCHK
lin archaistic_A = mkWA (k10 "vanhastava") ; --UNCHK
lin archangel_N = mkWN (compoundN "arkki" (k6 "enkeli")) ; --UNCHK
lin archangelic_A = mkWA (compoundA "arkkienk" (k33 "elin")) ; --UNCHK
lin archbishop_N = mkWN (compoundN "arkki" (k9 "piispa")) ; --UNCHK
lin archbishopric_N = mkWN "arkkihiippakunta" ; --UNCHK
lin archdeacon_N = mkWN (compoundN "tuomio" (k5 "rovasti")) ; --UNCHK
lin archdeaconry_N = mkWN (compoundN "tuomiorovasti" (k10A "kunta")) ; --UNCHK
lin archdiocesan_A = mkWA "arkkihiippakunta-" ; --UNCHK
lin archdiocese_N = mkWN "arkkihiippakunta" ; --UNCHK
lin archducal_A = mkWA "arkkiherttuan" ; --UNCHK
lin archduchess_N = mkWN (compoundN "arkki" (k32A "herttuatar")) ; --UNCHK
lin archduchy_N = mkWN (compoundN "arkkiherttua" (k10A "kunta")) ; --UNCHK
lin archduke_N = mkWN (compoundN "arkki" (k12 "herttua")) ; --UNCHK
lin archean_A = mkWA (k38 "arkaainen") ; --UNCHK
lin archegonial_A = mkWA "arkegoninen" ; --UNCHK
lin archegonium_N = mkWN "arkegoni" ; --UNCHK
lin archenteron_N = mkWN (compoundN "alku" (k26 "suoli")) ; --UNCHK
lin archeozoic_A = mkWA "arkeotsooinen" ; --UNCHK
lin archer_N = mkWN (compoundN "Jousim" (k41A "ies")) ; --UNCHK
lin archerfish_N = mkWN (compoundN "ampuja" (k9 "kala")) ; --UNCHK
lin archery_N = mkWN (k9A "jousiammunta") ; --UNCHK
lin archespore_N = mkWN (compoundN "arkesp" (k48 "ori")) ; --UNCHK
lin archesporial_A = mkWA "arkespori-" ; --UNCHK
lin archetypal_A = mkWA (k38 "tyypillinen") ; --UNCHK
lin archetype_N = mkWN (k5 "originaali") ; --UNCHK
lin archiannelid_N = mkWN "arkiannelidi" ; --UNCHK
lin archidiaconal_A = mkWA "tuomiorovasti-" ; --UNCHK
lin archidiaconate_N = mkWN (compoundN "arkkidiako" (k5A "naatti")) ; --UNCHK
lin archiepiscopal_A = mkWA "arkkipiispan" ; --UNCHK
lin archil_N = mkWN (compoundN "lakmus" (k10 "jäkälä")) ; --UNCHK
lin archimandrite_N = mkWN (k9A "arkkimandriitta") ; --UNCHK
lin archine_N = mkWN "arsina" ; --UNCHK
lin archipallium_N = mkWN "paleokorteksi" ; --UNCHK
lin archipelagic_A = mkWA "saaristo-" ; --UNCHK
lin archipelago_N = mkWN (k2 "saaristo") ; --UNCHK
lin architectFem_N = mkWN (k12 "suunnittelija") ; --UNCHK
lin architectMasc_N = variants {} ; --
lin architectonics_N = mkWN (k9A "tektoniikka") ; --UNCHK
lin architectural_A = mkWA (k38 "arkkitehtoninen") ;
lin architecture_N = mkWN (k5 "arkkitehtuuri") ; --UNCHK
lin architrave_N = mkWN (compoundN "liitin" (k5A "palkki")) ; --UNCHK
lin archival_A = mkWA "arkisto-" ; --UNCHK
lin archive_N = mkWN (k2 "arkisto") ; --UNCHK
lin archives_N = mkWN (k2 "arkisto") ; --UNCHK
lin archivist_N = mkWN (compoundN "arkiston" (k10 "hoitaja")) ; --UNCHK
lin archosaur_N = mkWN "arkosaurus" ; --UNCHK
lin archosaurian_A = mkWA "arkosaurus-" ; --UNCHK
lin archpriest_N = mkWN (k39 "priimas") ; --UNCHK
lin archway_N = mkWN (kH1 "kaari") ; --UNCHK
lin arco_A = mkWA "jousella" ; --UNCHK
lin arctic_A = mkWA (k38 "arktinen") ; --UNCHK
lin arctic_N = mkWN (k5 "kalossi") ; --UNCHK
lin arctiid_N = mkWN (compoundN "tiikeri" (k10 "kehrääjä")) ; --UNCHK
lin arcus_N = mkWN (compoundN "vanhuudenk" (k5 "aari")) ; --UNCHK
lin ardeb_N = mkWN "ardeb" ; --UNCHK
lin ardent_A = mkWA (k10 "polttava") ; --UNCHK
lin ardor_N = mkWN (k39 "innostus") ; --UNCHK
lin ardour_N = mkWN (k39 "innostus") ; --UNCHK
lin ardrossan_PN = foreignPN "Ardrossan" ;
lin arduous_A = mkWA (k10 "vaativa") ; --UNCHK
lin arduousness_N = mkWN (k40 "vaativuus") ; --UNCHK
lin are_N = mkWN (k5 "aari") ;
lin area_1_N = mkN "alue" ;
lin area_2_N = mkN "ala" ;
lin area_3_N = mkN "alue" ;
lin area_4_N = mkN "ala" ;
lin area_5_N = mkN "alue" ;
lin area_6_N = mkN "pinta-" (mkN "ala") ;
lin area_N = mkWN (k48 "alue") ;
lin areal_A = mkWA (k38 "alueellinen") ; --UNCHK
lin areaway_N = mkWN (compoundN "etu" (k9 "piha")) ; --UNCHK
lin areca_N = mkWN (compoundN "betel" (k1 "palmu")) ; --UNCHK
lin areflexia_N = mkWN "refleksittömyys" ; --UNCHK
lin arena_N = mkWN (k13 "areena") ;
lin arenaceous_A = mkWA (k38 "hiekkainen") ; --UNCHK
lin arenavirus_N = mkWN (compoundN "areena" (k39 "virus")) ; --UNCHK
lin arenicolous_A = mkWA (k10 "elävä") "hiekassa" ; --UNCHK
lin areola_N = mkWN (k48 "alue") "värillinen" ; --UNCHK
lin areolar_A = mkWA (k10 "kuuluva") "nänninpihaan" ; --UNCHK
lin arete_N = mkWN (compoundN "vuoren" (k9 "harja")) ; --UNCHK
lin arethusa_N = mkWN "arethusa" ; --UNCHK
lin argali_N = mkWN (compoundN "villi" (k41A "lammas")) ; --UNCHK
lin argent_A = mkWA (k38 "hopeainen") ; --UNCHK
lin argent_N = mkWN (k15 "hopea") ; --UNCHK
lin argentic_A = mkWA (compoundA "hopeapi" (k38 "toinen")) ; --UNCHK
lin argentiferous_A = mkWA (compoundA "hopeapi" (k38 "toinen")) ; --UNCHK
lin argentina_PN = foreignPN "Argentiina" ;
lin argentine_N = mkWN (compoundN "kulta" (k48 "kuore")) ; --UNCHK
lin argentine_PN = foreignPN "Argentine" ;
lin argentinian_A = mkWA (compoundA "argentiin" (k38 "alainen")) ; --UNCHK
lin argentinian_N = mkWN (compoundN "argentiin" (k38 "alainen")) ; --UNCHK
lin argentinosaur_N = mkWN "argentinosaurus" ; --UNCHK
lin argentite_N = mkWN (compoundN "hopea" (k48A "hohde")) ; --UNCHK
lin argentous_A = mkWA "hopea-" ; --UNCHK
lin argil_N = mkWN (k7 "savi") "savenvalajan" ; --UNCHK
lin argillaceous_A = mkWA (k38 "savinen") ; --UNCHK
lin argillite_N = mkWN (compoundN "savi" (k7 "kivi")) "tiivis" ; --UNCHK
lin arginine_N = mkWN (compoundN "argi" (k26 "niini")) ; --UNCHK
lin argon_N = mkWN (k5 "argon") ; --UNCHK
lin argonaut_N = mkWN (compoundN "paperi" (k48 "vene")) ; --UNCHK
lin argosy_N = mkWN (k2 "laivasto") ; --UNCHK
lin argot_N = mkWN (k48A "murre") ; --UNCHK
lin arguable_A = mkWA (k34A "ratkaisematon") ; --UNCHK
lin argue_V = mkV "riidellä" | mkV "kiistellä" ;
lin argue_V2 = mkV2 "perustella" ;
lin argue_VS = mkVS (mkV "väittää") ;
lin argue_down_V2 = prepV2 OP_argue_V OP_down_Prep ; -- guess-p-verb
lin argue_out_V2 = prepV2 OP_argue_V OP_out_Prep ; -- guess-p-verb
lin argument_N = mkN "argumentti" ;
lin argumentation_N = mkWN (k48 "peruste") ; --UNCHK
lin argumentative_A = mkWA (compoundA "väittelyn" (k38 "haluinen")) ; --UNCHK
lin argus_N = mkWN (compoundN "argus" (k6 "fasaani")) ; --UNCHK
lin argyle_N = mkWN (k10A "sukka") "ruutukuvioinen" ; --UNCHK
lin argyll_N = mkWN (k10A "sukka") "ruutukuvioinen" ; --UNCHK
lin argyrodite_N = mkWN "argyrodiitti" ; --UNCHK
lin aria_N = mkWN (k12 "aaria") ; --UNCHK
lin arianist_N = mkWN (compoundN "aria" (k5 "nisti")) ; --UNCHK
lin arid_A = mkWA (k10 "kuiva") ; --UNCHK
lin aridity_N = mkWN (k40 "tuottamattomuus") ; --UNCHK
lin aright_Adv = mkWAdv (k99 "oikein") ; --UNCHK
lin aril_N = mkWN (compoundN "siemen" (k9A "vaippa")) ; --UNCHK
lin ariled_A = mkWA (compoundA "siemen" (k38 "vaipallinen")) ; --UNCHK
lin ariose_A = mkWA (k38 "melodinen") ; --UNCHK
lin arioso_N = mkWN (compoundN "laulu" (k1 "soolo")) "lyhyehkö" ; --UNCHK
lin arise_V = mkV (lin VK {s = c66 "nousta"}) ;
lin arista_N = mkWN "arista" ; --UNCHK
lin aristocracy_N = mkWN (k1 "ylimystö") ; --UNCHK
lin aristocrat_N = mkWN (k5 "patriisi") ; --UNCHK
lin aristocratic_A = mkWA (k39 "ylimys") ; --UNCHK
lin arithmancy_N = mkWN (k12 "numerologia") ; --UNCHK
lin arithmetic_N = mkWN (k9A "aritmetiikka") ; --UNCHK
lin arithmetical_A = mkWA (k38 "laskennallinen") ; --UNCHK
lin arithmetician_N = mkWN "aritmeetikko" ; --UNCHK
lin arity_N = mkWN (k10 "määrä") "funktion" "parametrien" ; --UNCHK
lin arizona_PN = foreignPN "Arizona" ;
lin ark_N = mkWN (kH1 "arkki") ; --UNCHK
lin arkansas_PN = mkPN "Arkansas" ;
lin arm_1_N = mkN "käsivarsi" | mkN "käsi" ;
lin arm_2_N = mkN "ase" ;
lin arm_N = mkN "käsi" ;
lin arm_V = mkWV (k54A "rakentaa") "linnakkeita" ; --UNCHK
lin arm_V2 = mkWV2 (k54A "rakentaa") "linnakkeita" ; --UNCHK
lin armada_N = mkWN (k9 "armada") ; --UNCHK
lin armadale_PN = foreignPN "Armadale" ;
lin armadillo_N = mkWN (k38 "vyötiäinen") ; --UNCHK
lin armagh_PN = foreignPN "Armagh" ;
lin armament_N = mkWN (k39 "varustus") ; --UNCHK
lin armamentarium_N = mkWN (k1 "välineistö") ; --UNCHK
lin armature_N = mkWN (k6 "ankkuri") ; --UNCHK
lin armband_N = mkWN (compoundN "käsivarsi" (k9 "nauha")) ; --UNCHK
lin armchair_N = mkWN (compoundN "noja" (k5 "tuoli")) ; --UNCHK
lin armed_A = mkA "aseistettu" ;
lin armenian_N = mkWN (k2 "aakkosto") "armenialainen" ; --UNCHK
lin armful_N = mkWN (k39 "sylys") ; --UNCHK
lin arm_hole_N = mkWN (compoundN "hihan" (k10A "reikä")) ; --UNCHK
lin armiger_N = mkWN (compoundN "aseen" (k10 "kantaja")) ; --UNCHK
lin armilla_N = mkWN (compoundN "ranne" (k41A "rengas")) ; --UNCHK
lin armillary_A = mkWA "rannerenkaiden" ; --UNCHK
lin arming_N = mkWN (k39 "varustus") ; --UNCHK
lin armistice_N = mkWN (compoundN "väli" (k9 "rauha")) ; --UNCHK
lin armless_A = mkWA (k34A "kädetön") ; --UNCHK
lin armlet_N = mkWN (compoundN "käsivarsi" (k9 "nauha")) ; --UNCHK
lin armlike_A = mkWA (compoundA "käsivarsi" (k38 "mainen")) ; --UNCHK
lin armoire_N = mkWN "liinavaatekaappi" ; --UNCHK
lin armored_A = mkWA (compoundA "panssaro" (k1A "itu")) ; --UNCHK
lin armorial_A = mkWA "vaakuna-" ; --UNCHK
lin armour_N = mkWN (k6 "panssari") ; --UNCHK
lin armour_plate_N = mkWN (k13 "haarniska") ; --UNCHK
lin armoured_A = mkWA (compoundA "panssaro" (k1A "itu")) ; --UNCHK
lin armourer_N = mkWN (compoundN "ase" (k10 "valmistaja")) ; --UNCHK
lin armoury_N = mkWN (compoundN "ase" (k9 "paja")) ; --UNCHK
lin armpit_N = mkWN (k2 "kainalo") ; --UNCHK
lin armrest_N = mkWN (compoundN "käsi" (k10 "noja")) ; --UNCHK
lin arms_race_N = mkWN (compoundN "kilpa" (k2 "varustelu")) ; --UNCHK
lin army_N = mkN "armeija" ;
lin armyworm_N = mkWN (k38 "yökkönen") ; --UNCHK
lin arnhem_PN = foreignPN "Arnhem" ;
lin arnica_N = mkWN "arnikki" ; --UNCHK
lin arnold_PN = foreignPN "Arnold" ;
lin aroid_A = mkWA "vehkakasvi-" ; --UNCHK
lin aroma_N = mkWN (k1 "tuoksu") ; --UNCHK
lin aromatherapy_N = mkWN (compoundN "aroma" (k12 "terapia")) ; --UNCHK
lin aromatic_A = mkWA (k38 "aromaattinen") ; --UNCHK
lin around_AdN = mkAdN "suunnilleen" ;
lin around_Adv = mkAdv "suunnilleen" | mkAdv "lähes" ;
lin around_Prep = mkPrep "ympärillä" ;
lin arousal_N = mkWN (k39 "kiihotus") ; --UNCHK
lin arouse_V2 = mkV2 "herättää" ; --mkWV2 (k52A "havahtua") ;
lin arouse_V2V = mkWV2V (k52A "havahtua") ; --UNCHK
lin arpeggio_N = mkWN "arpeggio" ; --UNCHK
lin arquebus_N = mkWN (compoundN "haka" (k1 "pyssy")) ; --UNCHK
lin arrack_N = mkWN (k5A "arrakki") ; --UNCHK
lin arraign_V2 = mkWV2 (k53A "syyttää") ; --UNCHK
lin arraignment_N = mkWN (compoundN "haaste" (k48 "kirje")) ; --UNCHK
lin arrange_V = mkWV (k67A "asetella") ; --UNCHK
lin arrange_V2 = mkV2 "järjestää" | mkWV2 (k67A "asetella") ;
lin arrangement_N = mkN "järjestely" ;
lin arranger_N = mkWN (k10 "muokkaaja") ; --UNCHK
lin arrant_A = mkWA (k10 "syvä") ; --UNCHK
lin arras_N = mkWN (k5 "gobeliini") ; --UNCHK
lin array_N = mkWN "antenni-" ; --UNCHK
lin arrest_N = mkWN (k99 "kiinni") "saada" ; --UNCHK
lin arrest_V2 = mkWV2 (k67A "pidätellä") ; --UNCHK
lin arrester_N = mkWN (k33A "pidätin") ; --UNCHK
lin arresting_A = mkWA (k15 "upea") ; --UNCHK
lin arrhythmic_A = mkWA "rytmittä" ; --UNCHK
lin arriere_pensee_N = mkWN (k39 "epäilys") ; --UNCHK
lin arrival_N = mkN "saapuminen" ;
lin arrive_V = mkV "saapua" | mkV (mkV "tulla") "perille" ;
lin arroba_N = mkWN "arroba" ; --UNCHK
lin arrogance_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin arrogant_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin arrogate_V2 = mkWV2 (k53A "valloittaa") ; --UNCHK
lin arrogator_N = mkWN (k6 "huijari") ; --UNCHK
lin arrow_N = mkWN (k26 "nuoli") ; --UNCHK
lin arrowhead_N = mkWN (compoundN "nuolen" (k18 "pää")) ; --UNCHK
lin arrowroot_N = mkWN (k26 "nuolijuuri") ; --UNCHK
lin arrowsmith_N = mkWN (compoundN "nuoli" (k10A "seppä")) ; --UNCHK
lin arrowworm_N = mkWN (compoundN "nuoli" (k1A "mato")) ; --UNCHK
lin arroyo_N = mkWN (k10 "uoma") ; --UNCHK
lin arse_N = mkWN (k48 "perse") ; --UNCHK
lin arsehole_N = mkWN (k48 "perse") ; --UNCHK
lin arsenal_N = mkN "arsenaali" ; --mkWN (compoundN "ase" (k9 "paja")) ;
lin arsenate_N = mkWN (compoundN "arse" (k5A "naatti")) ; --UNCHK
lin arsenic_N = mkWN (k6 "arseeni") ; --UNCHK
lin arsenical_A = mkWA "arsenikki-" ; --UNCHK
lin arsenical_N = mkWN "arsenikki-" ; --UNCHK
lin arsenide_N = mkWN "arsenidi" ; --UNCHK
lin arsenious_A = mkWA "arsenikki-" ; --UNCHK
lin arsenopyrite_N = mkWN (compoundN "arseeni" (k1 "kiisu")) ; --UNCHK
lin arsine_N = mkWN (compoundN "arseeni" (k5 "hybridi")) ; --UNCHK
lin arson_N = mkWN (compoundN "murha" (k1A "poltto")) ; --UNCHK
lin arsonist_N = mkWN (k5 "pyromaani") ; --UNCHK
lin art_N = L.art_N ;
lin art_PN = mkPN "Art" ;
lin artefact_N = mkWN (k48 "esine") ; --UNCHK
lin artemisia_N = mkWN (k11 "maruna") ; --UNCHK
lin arterial_A = mkWA "valtimo-" ; --UNCHK
lin arteriectasis_N = mkWN (k10 "laajentuma") "valtimon" ; --UNCHK
lin arteriogram_N = mkWN (compoundN "röntgen" (k10 "kuva")) "valtimon" ; --UNCHK
lin arteriolar_A = mkWA "pikkuvaltimo-" ; --UNCHK
lin arteriole_N = mkWN (compoundN "hiussuoni" (k2 "valtimo")) ; --UNCHK
lin arteriosclerosis_N = mkWN (k5 "arterioskleroosi") ; --UNCHK
lin arteritis_N = mkWN (k39 "tulehdus") "valtimon" ; --UNCHK
lin artery_N = mkWN (compoundN "valta" (k10 "väylä")) ; --UNCHK
lin artesian_A = mkWA (k38 "arteesinen") ; --UNCHK
lin artful_A = mkWA (k41A "viekas") ; --UNCHK
lin artfulness_N = mkWN (k40 "viekkaus") ; --UNCHK
lin arthralgia_N = mkWN (compoundN "nivel" (k1A "särky")) ; --UNCHK
lin arthralgic_A = mkWA "nivelsärkyyn" "liittyvä" ; --UNCHK
lin arthritic_A = mkWA (k38 "reumaattinen") ; --UNCHK
lin arthritic_N = mkWN "niveltulehduksesta" "kärsivä" ; --UNCHK
lin arthritis_N = mkWN (compoundN "nivel" (k39 "tulehdus")) ; --UNCHK
lin arthrodesis_N = mkWN (compoundN "luudutus" (k39 "leikkaus")) ; --UNCHK
lin arthrogram_N = mkWN (compoundN "nive" (k66 "lestä")) "röntgenkuva" ; --UNCHK
lin arthrography_N = mkWN (compoundN "röntgen" (k39 "kuvaus")) "nivelen" ; --UNCHK
lin arthromere_N = mkWN (k48A "jaoke") ; --UNCHK
lin arthromeric_A = mkWA "jaokkeisiin" "liittyvä" ; --UNCHK
lin arthropathy_N = mkWN (compoundN "nivel" (k40 "sairaus")) ; --UNCHK
lin arthroplasty_N = mkWN (compoundN "muovaus" (k39 "leikkaus")) "nivelen" ; --UNCHK
lin arthropod_N = mkWN (compoundN "nivel" (k38 "jalkainen")) ; --UNCHK
lin arthropodal_A = mkWA "niveljalkaisia" "koskeva" ; --UNCHK
lin arthroscope_N = mkWN (k33 "tähystin") "nivelen" ; --UNCHK
lin arthroscopy_N = mkWN (compoundN "nivel" (k39 "tähystys")) ; --UNCHK
lin arthrospore_N = mkWN (compoundN "artrosp" (k48 "ori")) ; --UNCHK
lin arthrosporic_A = mkWA "artrosporeihin" "liittyvä" ; --UNCHK
lin arthur_PN = foreignPN "Arthur" ;
lin artichoke_N = mkWN (k10A "artisokka") ; --UNCHK
lin article_N = mkN "artikkeli" ;
lin article_V2 = mkWV2 (k71 "tehdä") "oppisopimus" ; --UNCHK
lin articular_A = mkWA "niveliä" "koskeva" ; --UNCHK
lin articulate_A = mkWA (k10 "ymmärrettävä") ; --UNCHK
lin articulate_V = mkWV (k52 "lausua") ; --UNCHK
lin articulate_V2 = mkWV2 (k52 "lausua") ; --UNCHK
lin articulation_N = mkWN (compoundN "nivel" (k39 "liitos")) ; --UNCHK
lin articulator_N = mkWN (compoundN "puhe" (k48A "laite")) ; --UNCHK
lin articulatory_A = mkWA "ääntämiseen" "liittyvä" ; --UNCHK
lin artifact_N = mkWN (k48 "esine") ; --UNCHK
lin artifactual_A = mkWA "artefakteihin" "liittyvä" ; --UNCHK
lin artifice_N = mkWN (k1A "temppu") ; --UNCHK
lin artificer_N = mkWN (k4A "mekaanikko") ; --UNCHK
lin artificial_A = mkA "keinotekoinen" ;
lin artificiality_N = mkWN "keinotekoisuus" ; --UNCHK
lin artillery_N = mkWN (kH1 "tykki") ; --UNCHK
lin artilleryman_N = mkWN (compoundN "tykki" (k42 "mies")) ; --UNCHK
lin artiodactyl_A = mkWA (compoundA "sorkka" (k33 "eläin")) ; --UNCHK
lin artisan_N = mkWN (k5 "artesaani") ; --UNCHK
lin artist_N = mkN "taiteilija" | mkWN (k5 "artisti") ;
lin artiste_N = mkWN (compoundN "viihde" (k12 "taiteilija")) ; --UNCHK
lin artistic_A = mkA "taiteellinen" ;
lin artistry_N = mkWN (k40 "kyvykkyys") ; --UNCHK
lin artjärvi_PN = mkPN (mkN "Artjärvi" "Artjärviä") ;
lin artlessness_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin artwork_N = mkWN (k14A "grafiikka") ; --UNCHK
lin arty_A = mkWA (k38 "teennäinen") ; --UNCHK
lin arum_N = mkWN (compoundN "vehka" (k5 "kasvi")) ; --UNCHK
lin arundinaceous_A = mkWA (compoundA "muis" (k10 "tuttava")) "ruokokasveja" ; --UNCHK
lin aryanFem_N = mkWN (k38 "indoiranilainen") ; --UNCHK
lin aryanMasc_N = mkWN (k38 "indoiranilainen") ; --UNCHK
lin aryan_A = mkWA (k38 "arjalainen") ; --UNCHK
lin arytenoid_N = mkWN (compoundN "kannu" (k1 "rusto")) ; --UNCHK
lin as_CAdv = S.as_CAdv ;
lin as_Prep = casePrep essive ;
lin as_Subj = mkSubj "kun" ;
lin as_for_Prep = mkPrep "mitä tulee" elative ;
lin as_long_as_Subj = mkSubj "niin kauan kun" ;
lin as_of_Prep = mkPrep "koskien" partitive ;
lin as_opposed_to_Prep = mkPrep "toisin kuin" nominative ;
lin as_regards_Prep = mkPrep "mitä tulee" illative ;
lin as_well_Adv = mkAdv "samoin" ;
lin as_well_as_Conj = mkConj "yhtä hyvin kuin" ;
lin asafetida_N = mkWN (compoundN "haju" (k9 "pihka")) ; --UNCHK
lin asana_N = mkWN (k1A "asento") ; --UNCHK
lin asarabacca_N = mkWN (compoundN "tapon" (k7A "lehti")) ; --UNCHK
lin asbestos_N = mkWN (k5 "asbesti") ;
lin asbestosis_N = mkWN (k5 "asbestoosi") ; --UNCHK
lin ascariasis_N = mkWN (k40 "sairaus") "suolinkaisten" "aiheuttama" ; --UNCHK
lin ascend_V = mkWV (k66 "nousta") ; --UNCHK
lin ascend_V2 = mkWV2 (k66 "nousta") ; --UNCHK
lin ascendable_A = mkWA (k10 "oleva") "noustavissa" ; --UNCHK
lin ascendancy_N = mkWN (k9A "valta") ; --UNCHK
lin ascendant_A = mkWA (k10 "hallitseva") ; --UNCHK
lin ascendant_N = mkWN (compoundN "kanta" (k10 "isä")) ; --UNCHK
lin ascendency_N = mkWN (k9A "valta") ; --UNCHK
lin ascendent_N = mkWN (compoundN "kanta" (k10 "isä")) ; --UNCHK
lin ascender_N = mkWN (compoundN "ylä" (k40 "pituus")) ; --UNCHK
lin ascension_N = mkWN (k1 "nousu") ; --UNCHK
lin ascensional_A = mkWA "nousu-" ; --UNCHK
lin ascent_N = mkWN (k1 "nousu") ; --UNCHK
lin ascertain_V2 = variants {} ; --
lin ascertainable_A = mkWA (k10 "oleva") "havaittavissa" ; --UNCHK
lin ascetic_A = mkWA (k38 "askeettinen") ; --UNCHK
lin ascetic_N = mkWN (k5A "askeetti") ; --UNCHK
lin asceticism_N = mkWN (k5 "askeesi") ; --UNCHK
lin ascidian_N = mkWN (compoundN "meri" (k7A "tuppi")) ; --UNCHK
lin ascites_N = mkWN (k39 "askites") ; --UNCHK
lin asclepiad_N = mkWN (compoundN "silkki" (k5A "yrtti")) ; --UNCHK
lin asclepiadaceous_A = mkWA "käärmeenpistonyrttikasveihin" "liittyvä" ; --UNCHK
lin ascocarp_N = mkWN (compoundN "asko" (k5A "karppi")) ; --UNCHK
lin ascocarpous_A = mkWA "askokarppiin" "liittyvä" ; --UNCHK
lin ascoma_N = mkWN (compoundN "asc" (k10 "oma")) ; --UNCHK
lin ascomycete_N = mkWN (compoundN "kotelo" (k26 "sieni")) ; --UNCHK
lin ascomycetous_A = mkWA "kotelosieniin" "liittyvä" ; --UNCHK
lin ascospore_N = mkWN (compoundN "kotelo" (k3 "itiö")) ; --UNCHK
lin ascosporic_A = mkWA "koteloitiöitä" "koskeva" ; --UNCHK
lin ascot_N = mkWN "plastron" ; --UNCHK
lin ascot_PN = foreignPN "Ascot" ;
lin ascribable_A = mkWA (k99 "takia") "jnk" ; --UNCHK
lin ascribe_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin ascription_N = mkWN (k38 "lukeminen") "ansioksi" ; --UNCHK
lin ascus_N = mkWN (compoundN "itiö" (k2 "kotelo")) ; --UNCHK
lin asdic_N = mkWN (compoundN "kaiku" (k33 "luotain")) ; --UNCHK
lin aseptic_A = mkWA (k6 "steriili") ; --UNCHK
lin asexual_A = mkWA (k34A "suvuton") ; --UNCHK
lin asexuality_N = mkWN "sukupuolettomuus" ; --UNCHK
lin ash_N = mkWN (k7 "saarni") ; --UNCHK
lin ash_bin_N = mkWN (k39 "roskis") ; --UNCHK
lin ash_can_N = mkWN (compoundN "Ashcan-koulu" (k10A "kunta")) | mkWN (k39 "roskis") ; --UNCHK --UNCHK
lin ashamed_A = mkWA (k1 "nolo") ; --UNCHK
lin ashbourne_PN = foreignPN "Ashbourne" ;
lin ashby_PN = foreignPN "Ashby" ;
lin ashby_de_la_zouch_PN = foreignPN "Ashby de la Zouch" ;
lin ashcake_N = mkWN (compoundN "maissi" (k1 "tasku")) ; --UNCHK
lin ashen_A = mkWA (k15 "valkea") ; --UNCHK
lin ashes_N = L.ashes_N ;
lin ashford_PN = foreignPN "Ashford" ;
lin ashington_PN = foreignPN "Ashington" ;
lin ashlar_N = mkWN (k1A "harkko") ; --UNCHK
lin ashore_Adv = mkWAdv (k99 "maissa") ; --UNCHK
lin ashram_N = mkWN "asrama" ; --UNCHK
lin ashtray_N = mkWN (compoundN "tuhka" (k5A "kuppi")) ; --UNCHK
lin ashy_A = mkWA (compoundA "tuhkan" (k17 "harmaa")) ; --UNCHK
lin asian_A = mkWA (k38 "aasialainen") ; --UNCHK
lin asian_N = mkWN (k38 "aasialainen") ; --UNCHK
lin asiatic_A = mkWA (k38 "aasialainen") ; --UNCHK
lin asiatic_N = mkWN (k38 "aasialainen") ; --UNCHK
lin aside_Adv = mkWAdv (k99 "syrjään") ; --UNCHK
lin aside_N = mkWN (compoundN "reuna" (k39 "huomautus")) ; --UNCHK
lin aside_from_Prep = mkPrep "syrjässä" elative ;
lin asikkala_PN = mkPN "Asikkala" ;
lin asinine_A = mkWA (k10 "tyhjä") ; --UNCHK
lin asininity_N = mkWN (k40 "uppiniskaisuus") ; --UNCHK
lin ask_V = mkV "kysyä" ;
lin ask_V2 = mkV2 (mkV "kysyä") ;
lin ask_V2Q = L.ask_V2Q ;
lin ask_V2V = mkV2V (mkV "pyytää" "pyysi") ;
lin ask_VQ = mkVQ (mkV "kysyä") ;
lin ask_about_V2 = prepV2 OP_ask_V OP_about_Prep ; -- guess-p-verb
lin ask_after_V2 = prepV2 OP_ask_V OP_after_Prep ; -- guess-p-verb
lin ask_around_V = advV OP_ask_V OP_around_Adv ; -- guess-p-verb
lin ask_around_V2 = prepV2 OP_ask_V OP_around_Prep ; -- guess-p-verb
lin ask_for_V2 = mkV2 (mkV "pyytää" "pyysi") partitive ;
lin ask_for_V3 = mkV3 (mkV "pyytää" "pyysi") (mkPrep ablative) (mkPrep partitive) ;
lin ask_in_V2 = mkWV2 (k54A "pyytää") "sisään" ; --UNCHK
lin ask_out_V2 = mkWV2 (k54A "pyytää") "ulos" ; --UNCHK
lin ask_over_V2 = mkWV2 (k54A "pyytää") "käymään" ; --UNCHK
lin ask_round_V2 = mkWV2 (k54A "pyytää") "käymään" ; --UNCHK
lin askainen_PN = mkPN "Askainen" ;
lin askance_A = mkWA (k99 "sirrillään") ; --UNCHK
lin askance_Adv = mkWAdv (k99 "karsaasti") ; --UNCHK
lin askern_PN = foreignPN "Askern" ;
lin askew_A = mkWA (k10 "oleva") "kiemurassa" ; --UNCHK
lin askew_Adv = mkWAdv (k99 "sekaisin") ; --UNCHK
lin asking_N = mkWN (k1A "pyyntö") ; --UNCHK
lin askola_PN = mkPN "Askola" ;
lin aslant_A = mkWA (k1 "vino") ; --UNCHK
lin aslant_Adv = mkWAdv (k99 "viistoon") ; --UNCHK
lin asleep_A = mkA "nukkuva" ; ---?? different POS
lin asleep_Adv = mkWAdv (k99 "nukuksissa") ; --UNCHK
lin asocial_A = mkA "asosiaalinen" ;
lin asp_N = mkN "aspis" (mkN "kyy") ;
lin asparaginase_N = mkWN (compoundN "Els" (k5 "par")) ; --UNCHK
lin asparagine_N = mkWN "asparagiini" ; --UNCHK
lin asparagus_N = mkWN (k9 "parsa") ; --UNCHK
lin aspartame_N = mkWN (k5 "aspartaami") ; --UNCHK
lin aspect_N = mkN "aspekti" ;
lin aspectual_A = mkWA (compoundA "aspektua" (k38 "alinen")) ; --UNCHK
lin aspen_N = mkWN (k9A "haapa") ; --UNCHK
lin asper_N = mkWN "Akçe" ; --UNCHK
lin aspergill_N = mkWN "aspergillium" ; --UNCHK
lin aspergillosis_N = mkWN (compoundN "aspergil" (k5 "loosi")) ; --UNCHK
lin asperity_N = mkWN (k40 "purevuus") ; --UNCHK
lin asperse_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin aspersion_N = mkWN "pirskottaminen" ; --UNCHK
lin aspersorium_N = mkWN "aspergillium" ; --UNCHK
lin asphalt_N = mkWN (k5A "asfaltti") ; --UNCHK
lin asphalt_V2 = mkWV2 (k62 "asfaltoida") ; --UNCHK
lin asphaltic_A = mkWA (k38 "asfalttinen") ; --UNCHK
lin aspheric_A = mkWA "asfäärinen" ; --UNCHK
lin asphodel_N = mkWN (compoundN "kelta" (k1A "soihtu")) ; --UNCHK
lin asphyxia_N = mkWN (compoundN "hapen" (k48A "puute")) ; --UNCHK
lin asphyxiate_V2 = mkWV2 (k52A "tukehtua") ; --UNCHK
lin asphyxiating_A = mkWA "tukahduttava" ; --UNCHK
lin asphyxiation_N = mkWN (compoundN "tuke" (k38 "hduttaminen")) ; --UNCHK
lin aspic_N = mkWN (k2 "hyytelö") ; --UNCHK
lin aspidistra_N = mkWN (compoundN "tuonen" (k1 "kielo")) ; --UNCHK
lin aspirant_A = mkWA (k41A "toiveikas") ; --UNCHK
lin aspirant_N = mkWN (k12 "havittelija") ; --UNCHK
lin aspirate_N = mkWN "aspiraatta" ; --UNCHK
lin aspirate_V2 = mkWV2 "aspiroida" ; --UNCHK
lin aspiration_N = mkWN (k3 "inhalaatio") ; --UNCHK
lin aspirator_N = mkWN (k6 "imuri") ; --UNCHK
lin aspire_V = mkWV (k73A "tähdätä") "jhk" ; --UNCHK
lin aspire_VV = mkWVV (k73A "tähdätä") "jhk" ; --UNCHK
lin aspirin_N = mkWN (compoundN "asetyylisalisyyli" (k1A "happo")) ; --UNCHK
lin assagai_N = mkWN (k41 "keihäs") ; --UNCHK
lin assail_V2 = mkWV2 (k67A "piikitellä") ; --UNCHK
lin assailability_N = mkWN (k40 "haavoittuvuus") ; --UNCHK
lin assailable_A = mkWA (k34A "suojaton") ; --UNCHK
lin assailant_N = mkWN (k10 "ahdistaja") ; --UNCHK
lin assassin_N = mkWN (compoundN "palkka" (k10 "murhaaja")) ; --UNCHK
lin assassinate_V2 = mkWV2 (k74 "tuhota") ; --UNCHK
lin assassination_N = mkWN (compoundN "sala" (k10 "murha")) ; --UNCHK
lin assault_N = mkWN (k4A "rynnäkkö") ;
lin assault_V2 = mkWV2 (k67A "piikitellä") ; --UNCHK
lin assaultive_A = mkWA (k10 "hyökkäävä") ; --UNCHK
lin assay_N = mkWN (k39 "määritys") ; --UNCHK
lin assay_V2 = mkWV2 (k53A "määrittää") ; --UNCHK
lin assayer_N = mkWN (k12 "tekijä") "analyysin" ; --UNCHK
lin assegai_N = mkWN (k41 "keihäs") ; --UNCHK
lin assemblage_N = mkWN (compoundN "koko" (k38 "ontuminen")) ; --UNCHK
lin assemble_V = mkV "kokoontua" ; --mkWV (k61 "kursia") ;
lin assemble_V2 = mkWV2 (k61 "kursia") ; --UNCHK
lin assembler_N = mkWN (k10 "kääntäjä") ; --UNCHK
lin assembly_N = mkN (lin NK {s = d39 "kokous"}) ;
lin assemblyman_N = mkWN (k32 "jäsen") "lakiasäätävän" "kokouksen" ; --UNCHK
lin assemblywoman_N = mkWN (k32 "jäsen") "lakiasäätävän" "kokouksen" ; --UNCHK
lin assent_N = mkWN (k40 "myöntyväisyys") ; --UNCHK
lin assent_V = mkWV (k52 "suostua") ; --UNCHK
lin assenter_N = mkWN (k10 "hyväksyjä") ; --UNCHK
lin assentient_A = mkWA (k10 "myöntyvä") ; --UNCHK
lin assert_V = mkWV (k53A "vakuuttaa") ; --UNCHK
lin assert_V2 = mkWV2 (k53A "vakuuttaa") ;
lin assert_VS = mkWVS (k53A "vakuuttaa") ; --UNCHK
lin asserter_N = mkWN (k10 "vahvistaja") ; --UNCHK
lin assertion_N = mkWN (k39 "julistus") ;
lin assertive_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin assertiveness_N = mkWN (k40 "vakuuttavuus") ; --UNCHK
lin assess_V2 = mkV2 "arvioida" ;
lin assessable_A = mkWA (k10 "oleva") "arvioitavissa" ; --UNCHK
lin assessee_N = mkWN (k10 "arvioija") ; --UNCHK
lin assessment_N = mkWN (k3 "arvio") ;
lin assessor_N = mkWN (k10 "arvioija") ; --UNCHK
lin asset_N = mkN "vara" ;
lin assets_N = mkWN (k40 "varallisuus") ; --UNCHK
lin asseveration_N = mkWN (k39 "julistus") ; --UNCHK
lin asshole_N = mkWN (k48 "perse") ; --UNCHK
lin assibilation_N = mkWN "suhauttaminen" ; --UNCHK
lin assiduity_N = mkWN (k40 "uutteruus") ; --UNCHK
lin assiduous_A = mkWA (k10 "uuttera") ; --UNCHK
lin assign_V2 = mkWV2 (k73 "varata") ; --UNCHK
lin assign_V2V = mkWV2V (k73 "varata") ; --UNCHK
lin assignable_A = mkWA (k10 "vaihdettava") ; --UNCHK
lin assignation_N = mkWN (k5A "allokointi") ; --UNCHK
lin assignee_N = mkWN (compoundN "siirron" (k10 "saaja")) ; --UNCHK
lin assignment_N = mkWN (compoundN "nimi" (k38 "ttäminen")) ; --UNCHK
lin assignor_N = mkWN (k10 "valtuuttaja") ; --UNCHK
lin assimilable_A = mkWA (k10 "oleva") "sulautettavissa" ; --UNCHK
lin assimilate_V = mkWV (k52A "sulautua") ; --UNCHK
lin assimilate_V2 = mkWV2 (k52A "sulautua") ; --UNCHK
lin assimilation_N = mkWN (k3 "assimilaatio") ; --UNCHK
lin assimilative_A = mkWA (compoundA "assimi" (k10 "loiva")) ; --UNCHK
lin assist_N = mkWN (k1A "syöttö") ; --UNCHK
lin assist_V = mkWV (k53 "avustaa") ; --UNCHK
lin assist_V2 = mkWV2 (k53 "avustaa") ; --UNCHK
lin assistance_N = mkWN (k7A "tuki") ; --f56
lin assistantFem_N = mkN "apulainen" ;
lin assistantMasc_N = mkN "apulainen" ;
lin assistant_A = mkA "avustava" ;
lin assistant_N = mkWN (k10 "avustaja") ;
lin assistive_A = mkWA "avustava" ; --UNCHK
lin assize_N = mkWN "käräjä-" ; --UNCHK
lin associability_N = mkWN "assosioituvuus" ; --UNCHK
lin associable_A = mkWA "assosioitava" ; --UNCHK
lin associate_A = mkWA "vara-" ; --UNCHK
lin associate_N = mkN "liittolainen" ;
lin associate_V = mkV "assosioitua" ;
lin associate_V2 = mkWV2 (k62 "assosioida") ;
lin associated_A = mkA "liitännäinen" ;
lin associateship_N = mkWN "kumppani-" ; --UNCHK
lin association_N = mkN "järjestö" | mkN "assosiaatio" ; ---- split
lin associational_A = mkWA "assosiaatioon" "liittyvä" ; --UNCHK
lin associationism_N = mkWN (compoundN "assosiaatio" (k12 "teoria")) ; --UNCHK
lin associative_A = mkWA (k38 "assosiatiivinen") ; --UNCHK
lin assonance_N = mkWN (compoundN "vokaali" (k1A "sointu")) ; --UNCHK
lin assonant_A = mkWA "assonantti" ; --UNCHK
lin assorted_A = mkWA (k38 "sekalainen") ; --UNCHK
lin assortment_N = mkWN (k2 "lajittelu") ; --UNCHK
lin assuage_V2 = mkWV2 (k53A "lievittää") ; --UNCHK
lin assuasive_A = mkWA (compoundA "help" (k10 "ottava")) ; --UNCHK
lin assume_V2 = mkV2 "olettaa" ;
lin assume_VS = mkVS (mkV "olettaa") ;
lin assumption_N = mkN "oletus" ;
lin assumptive_A = mkWA "oletettava" ; --UNCHK
lin assurance_N = mkWN (k40 "varmuus") ; --UNCHK
lin assure_V2 = mkV2 "varmistaa" ;
lin assure_V2S = mkV2S (mkV "vakuuttaa") (casePrep allative) ;
lin assuredly_Adv = mkWAdv (k99 "varmasti") ; --UNCHK
lin assuredness_N = mkWN (k40 "viileys") ; --UNCHK
lin assurgent_A = mkWA "nouseva" ; --UNCHK
lin assuring_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin astasia_N = mkWN (compoundN "seisomis" (k40 "kyvyttömyys")) ; --UNCHK
lin astatic_A = mkWA (compoundA "epä" (k17 "vakaa")) ; --UNCHK
lin astatine_N = mkWN (k5 "astatiini") ; --UNCHK
lin aster_N = mkWN (k7A "tähti") ; --UNCHK
lin asteriated_A = mkWA "tähti-" ; --UNCHK
lin asterion_N = mkWN "asterion" ; --UNCHK
lin asterisk_N = mkWN (k7A "tähti") ; --UNCHK
lin asterisked_A = mkWA "tähdellä" "merkitty" ; --UNCHK
lin asterism_N = mkWN (compoundN "aster" (k5 "ismi")) ; --UNCHK
lin asterismal_A = mkWA "asterismiin" "liittyvä" ; --UNCHK
lin astern_Adv = mkWAdv (k99 "perällä") ; --UNCHK
lin asternal_A = mkWA "rintalastaan" "liittymätön" ; --UNCHK
lin asteroid_A = mkWA (k38 "tähtimäinen") ; --UNCHK
lin asteroid_N = mkWN (k5 "asteroidi") ; --UNCHK
lin asteroidal_A = mkWA (compoundA "muis" (k10 "tuttava")) "asteroidia" ; --UNCHK
lin asthenia_N = mkWN (k12 "astenia") ; --UNCHK
lin asthenic_A = mkWA (k10 "hintelä") ; --UNCHK
lin asthenosphere_N = mkWN (compoundN "astenosf" (k26 "ääri")) ; --UNCHK
lin asthma_N = mkWN (k9 "astma") ; --UNCHK
lin asthmatic_A = mkWA (k38 "astmaattinen") ; --UNCHK
lin asthmatic_N = mkWN (k4A "astmaatikko") ; --UNCHK
lin astigmatic_A = mkWA (compoundA "hajatait" (k38 "toinen")) ; --UNCHK
lin astilbe_N = mkWN (k50 "jaloangervo") ; --UNCHK
lin astir_A = mkWA (k99 "liikkeellä") ; --UNCHK
lin astomatal_A = mkWA (compoundA "suu" (k34A "aukoton")) ; --UNCHK
lin astomatous_A = mkWA (compoundA "suu" (k34A "aukoton")) ; --UNCHK
lin astonish_V2 = mkWV2 (k53A "tyrmistyttää") ; --UNCHK
lin astonishing_A = mkWA "ällistyttävä" ; --UNCHK
lin astonishment_N = mkWN (k39 "ihmetys") ; --UNCHK
lin astound_V2 = mkWV2 (k53A "tyrmistyttää") ; --UNCHK
lin astounding_A = mkWA "mykistävä" ; --UNCHK
lin astragalar_A = mkWA "talukseen" "liittyvä" ; --UNCHK
lin astrakhan_N = mkWN "Astrahan" ; --UNCHK
lin astral_A = mkWA "astraali-" ; --UNCHK
lin astrantia_N = mkWN "rohtosuoputki" ; --UNCHK
lin astray_Adv = mkWAdv (k99 "harhateillä") ; --UNCHK
lin astride_Adv = mkWAdv (k99 "hajareisin") ; --UNCHK
lin astride_Prep = mkPrep "varrella" ;
lin astringency_N = mkWN (k40 "kutistuvuus") ; --UNCHK
lin astringent_A = mkWA (compoundA "yhteen" (k10 "vetävä")) ; --UNCHK
lin astringent_N = mkWN (k48A "lääke") "verenvuodon" "lakkauttava" ; --UNCHK
lin astrocyte_N = mkWN (compoundN "tähti" (k1 "solu")) ; --UNCHK
lin astrocytic_A = mkWA "astrosyyttinen" ; --UNCHK
lin astrodome_N = mkWN (compoundN "havaintojenteko" (k1A "kupu")) ; --UNCHK
lin astrodynamics_N = mkWN (compoundN "astro" (k9A "dynamiikka")) ; --UNCHK
lin astrogator_N = mkWN (compoundN "avaruus" (k10 "suunnistaja")) ; --UNCHK
lin astrolabe_N = mkWN (compoundN "astrol" (k5 "abi")) ; --UNCHK
lin astrolatry_N = mkWN "taivaankappaleiden" "palvominen" ; --UNCHK
lin astrologer_N = mkWN (k5 "astrologi") ; --UNCHK
lin astrological_A = mkWA (k38 "astrologinen") ; --UNCHK
lin astrology_N = mkWN (k12 "astrologia") ; --UNCHK
lin astrometry_N = mkWN "astrometria" ; --UNCHK
lin astronaut_N = mkWN (k5A "kosmonautti") ; --UNCHK
lin astronautic_A = mkWA (compoundA "astronautti" (k38 "nen")) ; --UNCHK
lin astronautics_N = mkWN (k9A "astronautiikka") ; --UNCHK
lin astronomer_N = mkWN (k12 "tutkija") "tähtien" ; --UNCHK
lin astronomic_A = mkWA (k38 "astronominen") ; --UNCHK
lin astronomical_A = mkWA (k38 "astronominen") ; --UNCHK
lin astronomy_N = mkWN (k12 "astronomia") ; --UNCHK
lin astrophysical_A = mkWA (compoundA "astro" (k38 "fysikaalinen")) ; --UNCHK
lin astrophysicist_N = mkWN (compoundN "astro" (k4A "fyysikko")) ; --UNCHK
lin astrophysics_N = mkWN (compoundN "astro" (k14A "fysiikka")) ; --UNCHK
lin astute_A = mkWA (k10 "näppärä") ; --UNCHK
lin astuteness_N = mkWN (k40 "perusteellisuus") ; --UNCHK
lin astylar_A = mkWA "pilariton" ; --UNCHK
lin asylum_N = mkWN (k13 "sairaala") "psykiatrinen" ; --UNCHK
lin asymmetric_A = mkWA (compoundA "epä" (k38 "symmetrinen")) ; --UNCHK
lin asymmetrical_A = mkWA (compoundA "epä" (k38 "symmetrinen")) ; --UNCHK
lin asymmetry_N = mkWN "epätasapaino" ; --UNCHK
lin asymptomatic_A = mkWA (k34A "oireeton") ; --UNCHK
lin asymptote_N = mkWN "asymptootti" ; --UNCHK
lin asymptotic_A = mkWA "asymptoottinen" ; --UNCHK
lin asynchronism_N = mkWN (compoundN "eri" (k40 "aikaisuus")) ; --UNCHK
lin asynchronous_A = mkWA (compoundA "epä" (k38 "tahtinen")) ; --UNCHK
lin asynclitism_N = mkWN (k40 "vinous") ; --UNCHK
lin asyndetic_A = mkWA (compoundA "asynd" (k38 "eettinen")) ; --UNCHK
lin asyndeton_N = mkWN (k39 "rinnastus") "sidesanaton" ; --UNCHK
lin asynergic_A = mkWA "asynerginen" ; --UNCHK
lin asynergy_N = mkWN "asynergia" ; --UNCHK
lin asystole_N = mkWN (compoundN "sydän" (k39 "pysähdys")) ; --UNCHK
lin at_N = mkWN "kip" ; --UNCHK
lin at_Prep = casePrep adessive | casePrep inessive ; ---- | mkPrep "luona" | mkPrep "tykönä" ; ---- split
lin at_all_Adv = mkAdv "ollenkaan" ;
lin at_home_Adv = mkAdv "kotona" ;
lin at_home_N = mkWN (compoundN "vastaan" (k1A "otto")) ; --UNCHK
lin at_least_AdN = S.at_least_AdN ;
lin at_most_AdN = S.at_most_AdN ;
lin at_the_behest_of_Prep = mkPrep "käskystä" ;
lin atabrine_N = mkWN "Atabrine" ; --UNCHK
lin ataractic_A = mkWA (compoundA "sedatiivi" (k38 "nen")) ; --UNCHK
lin ataraxia_N = mkWN (k40 "tyyneys") ; --UNCHK
lin atavism_N = mkWN (k10 "takauma") ; --UNCHK
lin atavist_N = mkWN (k38 "atavistinen") ; --UNCHK
lin atavistic_A = mkWA (k38 "atavistinen") ; --UNCHK
lin ataxia_N = mkWN (compoundN "yhteistoiminta" (k3 "häiriö")) "lihasten" ; --UNCHK
lin ataxic_A = mkWA "hapuileva" ; --UNCHK
lin ateleiosis_N = mkWN "atelioosi" ; --UNCHK
lin ateleiotic_A = mkWA "ateleioosiin" "liittyvä" ; --UNCHK
lin atelier_N = mkWN (k20 "ateljee") ; --UNCHK
lin atenolol_N = mkWN "Tenormin" ; --UNCHK
lin athanor_N = mkWN (compoundN "athanor-u" (k24 "uni")) ; --UNCHK
lin atheism_N = mkWN (k5 "ateismi") ; --UNCHK
lin atheist_A = mkWA (k38 "ateistinen") ; --UNCHK
lin atheist_N = mkWN (k5 "ateisti") ; --UNCHK
lin atheistic_A = mkWA (k38 "ateistinen") ; --UNCHK
lin athenaeum_N = mkWN (k2 "kirjasto") ; --UNCHK
lin athenianFem_N = mkWN (compoundN "ateen" (k38 "alainen")) ; --UNCHK
lin athenianMasc_N = mkWN (compoundN "ateen" (k38 "alainen")) ; --UNCHK
lin athenian_A = mkWA (compoundA "ateen" (k38 "alainen")) ; --UNCHK
lin athens_1_PN = foreignPN "Ateena" ;
lin athens_2_PN = foreignPN "Ateena" ;
lin athens_PN = mkPN "Ateena" ;
lin atherogenesis_N = mkWN "aterogeneesi" ; --UNCHK
lin atheromatous_A = mkWA (compoundA "atero" (k38 "omainen")) ; --UNCHK
lin atherosclerosis_N = mkWN (compoundN "sepelvaltimo" (k5A "tauti")) ; --UNCHK
lin atherosclerotic_A = mkWA (compoundA "ateroskl" (k38 "eroottinen")) ; --UNCHK
lin atherstone_PN = foreignPN "Atherstone" ;
lin athetosis_N = mkWN "atetoosi" ; --UNCHK
lin athirst_A = mkWA (k38 "-himoinen") ; --UNCHK
lin athlete_N = mkWN (k5A "atleetti") ; --UNCHK
lin athletic_A = mkA "atleettinen" ;
lin athleticism_N = mkWN (k40 "voimakkuus") ; --UNCHK
lin athletics_N = mkWN (k2 "urheilu") ;
lin athlone_PN = foreignPN "Athlone" ;
lin athwart_Adv = mkWAdv (k99 "viistoon") ; --UNCHK
lin atilt_A = mkWA (compoundA "kallis" (k47 "tunut")) ; --UNCHK
lin atlanta_PN = foreignPN "Atlanta" ;
lin atlantic_PN = foreignPN "Atlantic" ;
lin atlas_N = mkWN (k39 "atlas") ; --UNCHK
lin atmometer_N = mkWN (compoundN "haihtumis" (k6 "mittari")) ; --UNCHK
lin atmosphere_N = mkWN (k39 "tuulahdus") ; --UNCHK
lin atmospheric_A = mkA "ilmakehällinen" ; ---
lin atmospherics_N = mkWN (k13 "kohina") ; --UNCHK
lin atole_N = mkWN (k5 "velli") ; --UNCHK
lin atoll_N = mkWN (k6 "atolli") ; --UNCHK
lin atom_N = mkWN (k38 "hitunen") ; --UNCHK
lin atomic_A = mkWA "ydin-" ; --UNCHK
lin atomism_N = mkWN (k5 "atomismi") ; --UNCHK
lin atomistic_A = mkWA (k38 "atomistinen") ; --UNCHK
lin atomization_N = mkWN (compoundN "atomi" (k5A "sointi")) ; --UNCHK
lin atomize_V2 = mkWV2 (k53A "hajottaa") ; --UNCHK
lin atomizer_N = mkWN (k33A "suutin") ; --UNCHK
lin atonal_A = mkWA (k38 "atonaalinen") ; --UNCHK
lin atonalistic_A = mkWA "atonaalisuuteen" "liittyvä" ; --UNCHK
lin atonality_N = mkWN (k40 "atonaalisuus") ; --UNCHK
lin atone_V = mkWV (k71 "tehdä") "parannus" ; --UNCHK
lin atonement_N = mkWN (k39 "sovitus") ; --UNCHK
lin atonic_A = mkWA (k34A "painoton") ; --UNCHK
lin atonicity_N = mkWN (k40 "velttous") ; --UNCHK
lin atop_Adv = mkWAdv (k99 "päälle") ; --UNCHK
lin atop_Prep = mkPrep "huipulla" ;
lin atopognosia_N = mkWN "atopognosia" ; --UNCHK
lin atorvastatin_N = mkWN (compoundN "atorv" (k5 "astatiini")) ; --UNCHK
lin atrabilious_A = mkWA (k10 "pahoinvoiva") ; --UNCHK
lin atrazine_N = mkWN "atrasiini" ; --UNCHK
lin atresia_N = mkWN "atresia" ; --UNCHK
lin atrium_N = mkWN (k5 "atrium") ; --UNCHK
lin atrocious_A = mkWA (k10 "karmiva") ; --UNCHK
lin atrocity_N = mkWN (k40 "julmuus") ; --UNCHK
lin atrophic_A = mkWA "surkastunut" ; --UNCHK
lin atrophy_N = mkWN "surkastuminen" ; --UNCHK
lin atrophy_V = mkWV (k52A "näivettyä") ; --UNCHK
lin atrophy_V2 = mkWV2 (k52A "näivettyä") ; --UNCHK
lin atropine_N = mkWN "atropiini" ; --UNCHK
lin attach_V = mkWV (k53A "liittää") ; --UNCHK
lin attach_V2 = mkWV2 (k53A "liittää") ;
lin attachable_A = mkWA (k10 "oleva") "sidottavissa" ; --UNCHK
lin attache_N = mkWN (compoundN "attasea" (k1A "salkku")) ; --UNCHK
lin attachment_N = mkWN (k39 "kiinnitys") ; --UNCHK
lin attack_N = mkN "hyökkäys" ;
lin attack_V2 = mkV2 "hyökätä" ;
lin attacker_N = mkWN (k10 "ahdistaja") ; --UNCHK
lin attain_V = mkWV (k56 "kasvaa") ; --UNCHK
lin attain_V2 = mkWV2 (k56 "kasvaa") ; --UNCHK
lin attainable_A = mkWA (k10 "oleva") "saatavilla" ; --UNCHK
lin attainder_N = mkWN (compoundN "kansalais" (k10 "kuolema")) ; --UNCHK
lin attainment_N = mkWN (compoundN "pää" (k38 "seminen")) ; --UNCHK
lin attar_N = mkWN (compoundN "ruusu" (k1 "öljy")) ; --UNCHK
lin attempt_1_N = mkN "yritys" ;
lin attempt_2_N = mkN "yritys" ;
lin attempt_N = mkN (lin NK {s = d39 "yritys"}) ;
lin attempt_V2 = mkV2 "yrittää" partitive ;
lin attempt_VV = mkVV (mkV "yrittää") ;
lin attempted_A = variants {} ; --
lin attend_V = mkV "osallistua" ;
lin attend_V2 = mkV2 "osallistua" elative ;
lin attendance_N = mkWN (compoundN "läsnä" (k1A "olo")) ;
lin attendant_A = mkA "liittyvä" ; ---ARB ; jonkin seurassa oleva
lin attendant_N = mkWN (k10 "sattuma") ; --UNCHK
lin attention_N = mkN (lin NK {s = d03 "huomio"}) ;
lin attentional_A = mkWA "huomioon" "liittyvä" ; --UNCHK
lin attentive_A = mkWA (k41A "valpas") ; --UNCHK
lin attentiveness_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin attenuate_A = mkWA (k15 "vaimea") ; --UNCHK
lin attenuate_V2 = mkWV2 (k52A "vaimentua") ; --UNCHK
lin attenuation_N = mkWN (compoundN "vai" (k38 "mentuminen")) ; --UNCHK
lin attenuator_N = mkWN (k33A "vaimennin") ; --UNCHK
lin attest_V = mkWV (k53 "todistaa") ; --UNCHK
lin attest_V2 = mkWV2 (k53 "todistaa") ; --UNCHK
lin attest_VS = mkWVS (k53 "todistaa") ; --UNCHK
lin attestation_N = mkWN (k48 "todiste") ; --UNCHK
lin attester_N = mkWN (k10 "todistaja") ; --UNCHK
lin attic_A = mkWA (compoundA "atti" (k38 "kalainen")) ; --UNCHK
lin attic_N = mkWN "attika" ; --UNCHK
lin attire_N = mkWN (k1A "puku") ; --UNCHK
lin attire_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin attitude_N = mkN "asenne" ;
lin attitudinal_A = mkWA "suhtautumis-" ; --UNCHK
lin attitudinize_V = mkWV (k73 "poseerata") ; --UNCHK
lin attorney_N = mkWN (k5 "juristi") ; --f193
lin attorneyship_N = mkWN (compoundN "asian" (k10 "ajaja")) ; --UNCHK
lin attosecond_N = mkWN (compoundN "atto" (k5A "sekunti")) ; --UNCHK
lin attract_V2 = mkV2 (mkWV (k53A "vetää") "puoleensa") partitive ;
lin attractable_A = mkWA (k38 "magneettinen") ; --UNCHK
lin attraction_N = mkN "viehätys" ; --WN (k40 "viehättävyys") ;
lin attractive_A = mkWA (k10 "viehättävä") ;
lin attractiveness_N = mkWN (k40 "viehättävyys") ; --UNCHK
lin attractor_N = mkWN (k5A "magneetti") ; --UNCHK
lin attributable_A = mkWA (k10 "luettava") "syyksi" ; --UNCHK
lin attribute_N = mkWN (k5A "attribuutti") ; --UNCHK
lin attribute_V2 = mkV2 "nimittää" ;
lin attribution_N = mkWN (k38 "lukeminen") "ansioksi" ; --UNCHK
lin attributive_A = mkWA "attributiivinen" ; --UNCHK
lin attrited_A = mkWA (compoundA "kulu" (k47 "nut")) ; --UNCHK
lin attrition_N = mkWN (compoundN "hie" (k38 "rtyminen")) ; --UNCHK
lin attritional_A = mkWA "kulumiseen" "liittyvä" ; --UNCHK
lin attune_V2 = mkWV2 (k53A "virittää") ; --UNCHK
lin atypical_A = mkWA (k10 "poikkeava") ; --UNCHK
lin atypicality_N = mkWN (k40 "poikkeavuus") ; --UNCHK
lin au_fait_A = mkWA (k99 "tasalla") ; --UNCHK
lin au_pair_N = mkWN "au" "pair" ; --UNCHK
lin aubergine_N = mkWN (compoundN "muna" (k1 "koiso")) ; --UNCHK
lin auburn_A = mkWA (compoundA "kastanjan" (k15 "ruskea")) ; --UNCHK
lin auckland_PN = foreignPN "Auckland" ;
lin auction_N = mkWN (compoundN "huuto" (k9A "kauppa")) ;
lin auction_V2 = mkV2 "huutokaupata" ;
lin auctioneer_N = mkWN (k10 "toimittaja") "huutokaupan" ; --UNCHK
lin audacious_A = mkWA (k41 "uskalias") ; --UNCHK
lin audacity_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin audibility_N = mkWN (k40 "kuuluvuus") ; --UNCHK
lin audible_A = mkWA (k10 "kuuluva") ; --UNCHK
lin audible_N = mkWN "pelikuvion" "ilmoittaminen" ; --UNCHK
lin audience_N = mkN "yleisö" ;
lin audile_N = mkWN (compoundN "kuulo" (k38 "ihminen")) ; --UNCHK
lin audio_N = mkWN (k26 "ääni") ; --UNCHK
lin audiocassette_N = mkWN (compoundN "ääni" (k5A "kasetti")) ; --UNCHK
lin audiogram_N = mkWN "audiogrammi" ; --UNCHK
lin audiology_N = mkWN (compoundN "audio" (k5 "metri")) ; --UNCHK
lin audiometer_N = mkWN (compoundN "sono" (k5 "metri")) ; --UNCHK
lin audiometric_A = mkWA (compoundA "audio" (k38 "metrinen")) ; --UNCHK
lin audiometry_N = mkWN (compoundN "audio" (k5 "metri")) ; --UNCHK
lin audiotape_N = mkWN (compoundN "ääni" (k9 "nauha")) ; --UNCHK
lin audiovisual_A = mkWA (compoundA "audio" (k38 "visuaalinen")) ; --UNCHK
lin audiovisual_N = mkWN (compoundN "apu" (k48 "väline")) "audiovisuaalinen" ; --UNCHK
lin audit_N = mkWN (k39 "tarkastus") ; --UNCHK
lin audit_V2 = mkV2 "tarkastaa" ; --mkWV2 (k67 "olla") "kuunteluoppilaana" ;
lin audition_N = mkWN (compoundN "koe-" (k38 "esiintyminen")) ; --UNCHK
lin audition_V = mkWV (k52 "osallistua") "koe-esiintymiseen" ; --UNCHK
lin audition_V2 = mkWV2 (k52 "osallistua") "koe-esiintymiseen" ; --UNCHK
lin auditor_N = mkWN (compoundN "tilin" (k10 "tarkastaja")) ; --UNCHK
lin auditorium_N = mkWN (k2 "katsomo") ; --UNCHK
lin auditory_A = mkWA (k38 "auditiivinen") ; --UNCHK
lin audley_PN = foreignPN "Audley" ;
lin aug_PN = mkPN "Aug" ;
lin augend_N = mkWN "yhteenlaskettava" ; --UNCHK
lin auger_N = mkWN (k6 "näveri") ; --UNCHK
lin aught_N = mkWN (k101 "mikään") "ei" ; --UNCHK
lin augite_N = mkWN "augiitti" ; --UNCHK
lin augitic_A = mkWA "augiittinen" ; --UNCHK
lin augment_V = mkWV (k54A "laajentaa") ; --UNCHK
lin augment_V2 = mkWV2 (k54A "laajentaa") ; --UNCHK
lin augmentation_N = mkWN (compoundN "suu" (k38 "rentaminen")) ; --UNCHK
lin augsburg_PN = foreignPN "Augsburg" ;
lin augur_N = mkWN "auguuri" ; --UNCHK
lin augur_V = mkWV (k69 "merkitä") ; --UNCHK
lin augur_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin augury_N = mkWN (k48A "enne") ; --UNCHK
lin august_A = mkWA (compoundA "kunnian" (k10 "arvoisa")) ; --UNCHK
lin auk_N = mkWN (k5A "ruokki") ; --UNCHK
lin auklet_N = mkWN (compoundN "pikku" (k5A "ruokki")) ; --UNCHK
lin auld_A = mkWA "wanha" ; --UNCHK
lin aunt_N = mkWN (k5A "täti") ; --UNCHK
lin auntie_N = mkWN (k5A "täti") ; --UNCHK
lin aunty_N = mkWN (k5A "täti") ; --UNCHK
lin aura_N = mkWN (k39 "tuulahdus") ; --UNCHK
lin aura_PN = mkPN "Aura" ;
lin aural_A = mkWA (compoundA "aura" (k38 "alinen")) ; --UNCHK
lin aureate_A = mkWA (k38 "kultainen") ; --UNCHK
lin aureole_N = mkWN (kH1 "aura") ; --UNCHK
lin auricle_N = mkWN (compoundN "ulko" (k10 "korva")) ; --UNCHK
lin auricula_N = mkWN (k48A "korvake") "sydämen" ; --UNCHK
lin auriculare_N = mkWN (compoundN "keski" (k48 "piste")) "korvakäytävän" "ulkoaukon" ; --UNCHK
lin auriculate_A = mkWA (compoundA "korva" (k38 "kkeellinen")) ; --UNCHK
lin auriferous_A = mkWA (compoundA "kultapi" (k38 "toinen")) ; --UNCHK
lin auriform_A = mkWA (k38 "muotoinen") "korvan" ; --UNCHK
lin aurochs_N = mkWN (compoundN "alku" (k10A "härkä")) ; --UNCHK
lin aurora_N = mkWN (compoundN "Aur" (k10 "ora")) ; --UNCHK
lin auroral_A = mkWA "aamuruskon" ; --UNCHK
lin aurous_A = mkWA "kulta-" ; --UNCHK
lin auscultation_N = mkWN (k2 "kuuntelu") ; --UNCHK
lin auscultatory_A = mkWA "kuunteluun" "liittyvä" ; --UNCHK
lin auspice_N = mkWN (k48A "enne") ; --UNCHK
lin auspices_N = mkWN (kH1 "suoja") ; --UNCHK
lin auspicious_A = mkWA (k38 "otollinen") ; --UNCHK
lin auspiciousness_N = mkWN (k40 "suotuisuus") ; --UNCHK
lin aussie_N = mkWN (k5 "aussi") ; --UNCHK
lin austenite_N = mkWN (compoundN "auste" (k5A "niitti")) ; --UNCHK
lin austenitic_A = mkWA "austeniittinen" ; --UNCHK
lin austere_A = mkWA (k38 "spartalainen") ; --UNCHK
lin austereness_N = mkWN (k40 "karuus") ; --UNCHK
lin austerity_N = mkWN (k40 "karuus") ;
lin austral_A = mkWA (k38 "eteläinen") ; --UNCHK
lin austral_N = mkWN "austral" ; --UNCHK
lin australia_PN = foreignPN "Australia" ;
lin australianFem_N = variants {} ; ---- sense to be split
lin australianMasc_N = variants {} ; ---- sense to be split
lin australian_A = mkA "australialainen" ;
lin australopithecine_A = mkWA "Australopithecusiin" "liittyvä" ; --UNCHK
lin australopithecine_N = mkWN "Australopithecus" ; --UNCHK
lin austria_PN = mkPN "Itävalta" ;
lin austrianFem_N = mkWN (k38 "itävaltalainen") ; --UNCHK
lin austrianMasc_N = mkWN (k38 "itävaltalainen") ; --UNCHK
lin austrian_A = mkWA (k38 "itävaltalainen") ; --UNCHK
lin autacoid_N = mkWN "autakoidi" ; --UNCHK
lin autacoidal_A = mkWA "autakoidiin" "liittyvä" ; --UNCHK
lin autarchic_A = mkWA (compoundA "oma" (k38 "varainen")) ; --UNCHK
lin autarchy_N = mkWN (k40 "riippumattomuus") "taloudellinen" ; --UNCHK
lin autarkic_A = mkWA (compoundA "oma" (k38 "varainen")) ; --UNCHK
lin autarky_N = mkWN (k40 "riippumattomuus") "taloudellinen" ; --UNCHK
lin auteur_N = mkWN "auteur" ; --UNCHK
lin authentic_A = mkWA (k38 "varsinainen") ; --UNCHK
lin authenticate_V2 = mkWV2 (k54A "todentaa") ; --UNCHK
lin authentication_N = mkWN (k39 "todennus") ; --UNCHK
lin authenticity_N = mkWN (k40 "oikeellisuus") ; --UNCHK
lin author_N = mkWN (k12 "tekijä") ; --f57
lin authoress_N = mkWN (compoundN "nais" (k12 "kirjailija")) ; --UNCHK
lin authoritarian_A = mkWA (k38 "tyrannimainen") ; --UNCHK
lin authoritarian_N = mkWN (k6 "diktaattori") ; --UNCHK
lin authoritarianism_N = mkWN (k12 "tyrannia") ; --UNCHK
lin authoritative_A = mkWA (k1A "valtuutettu") ; --UNCHK
lin authority_1_N = mkN "auktoriteetti" ;
lin authority_2_N = mkN "viranomainen" ;
lin authority_N = mkN "viranomainen" ;
lin authorization_N = mkWN (k39 "oikeutus") ; --UNCHK
lin authorize_V2 = mkV2 "valtuuttaa" ;
lin authorize_V2V = mkV2V (mkV "valtuuttaa") accusative infIllat ;
lin authorizer_N = mkWN (k10 "valtuuttaja") ; --UNCHK
lin authorship_N = mkWN (k40 "henkilöllisyys") "kirjoittajan" ; --UNCHK
lin autism_N = mkWN (k5 "autismi") ; --UNCHK
lin autistic_A = mkWA (k38 "autistinen") ; --UNCHK
lin auto_N = mkN (lin NK {s = d01 "auto"}) ;
lin autobahn_N = mkWN "autobahn" ; --UNCHK
lin autobiographer_N = mkWN (k10 "kirjoittaja") "omaelämäkerran" ; --UNCHK
lin autobiographic_A = mkWA "omaelämäkerrallinen" ; --UNCHK
lin autobiographical_A = mkWA "omaelämäkerrallinen" ; --UNCHK
lin autobiography_N = mkWN (k50 "omaelämäkerta") ; --UNCHK
lin autocatalysis_N = mkWN (k3 "reaktio") "itseään" "kiihdyttävä" ; --UNCHK
lin autocatalytic_A = mkWA (compoundA "auto" (k38 "katalyyttinen")) ; --UNCHK
lin autochthon_N = mkWN "autoktoni" ; --UNCHK
lin autochthonal_A = mkWA (k38 "kotimainen") ; --UNCHK
lin autochthonous_A = mkWA (compoundA "auto" (k38 "ktoninen")) ; --UNCHK
lin autoclave_N = mkWN (k6 "sterilisaattori") ; --UNCHK
lin autocracy_N = mkWN (k40 "itsevaltius") ; --UNCHK
lin autocrat_N = mkWN (k5A "despootti") ; --UNCHK
lin autocratic_A = mkWA (k38 "tyrannimainen") ; --UNCHK
lin autodidactic_A = mkWA (compoundA "itse" (k47 "oppinut")) ; --UNCHK
lin autoerotic_A = mkWA (compoundA "auto" (k38 "eroottinen")) ; --UNCHK
lin autoeroticism_N = mkWN (k5A "masturbointi") ; --UNCHK
lin autofluorescence_N = mkWN (compoundN "autofluor" (k5 "esanssi")) ; --UNCHK
lin autofluorescent_A = mkWA (compoundA "autofluores" (k10 "oiva")) ; --UNCHK
lin autofocus_N = mkWN (compoundN "automaatti" (k39 "tarkennus")) ; --UNCHK
lin autogamous_A = mkWA (compoundA "itsesiit" (k38 "toinen")) ; --UNCHK
lin autogamy_N = mkWN "autogamia" ; --UNCHK
lin autogenetic_A = mkWA (compoundA "auto" (k38 "geeninen")) ; --UNCHK
lin autogenous_A = mkWA (compoundA "auto" (k38 "geeninen")) ; --UNCHK
lin autogiro_N = mkWN (k1 "autogiro") ; --UNCHK
lin autograft_N = mkWN (compoundN "autopl" (k12 "astia")) ; --UNCHK
lin autograph_N = mkWN (compoundN "nimi" (k39 "kirjoitus")) ; --UNCHK
lin autograph_V2 = mkWV2 (k56A "antaa") "nimikirjoitus" ; --UNCHK
lin autographic_A = mkWA (compoundA "auto" (k38 "grafinen")) ; --UNCHK
lin autogyro_N = mkWN (k1 "autogiro") ; --UNCHK
lin autoicous_A = mkWA "itsepölyttyvä" ; --UNCHK
lin autoimmune_A = mkWA "autoimmuuni-" ; --UNCHK
lin autoimmunity_N = mkWN (compoundN "auto" (k5A "immuniteetti")) ; --UNCHK
lin autoinjector_N = mkWN (compoundN "automaatti" (k1 "ruisku")) ; --UNCHK
lin autoloader_N = mkWN (k48 "ase") "itselataava" ; --UNCHK
lin autologous_A = mkWA (compoundA "auto" (k38 "loginen")) ; --UNCHK
lin autolysis_N = mkWN (compoundN "autoly" (k5 "ysi")) ; --UNCHK
lin autolytic_A = mkWA (compoundA "auto" (k38 "lyyttinen")) ; --UNCHK
lin automat_N = mkWN (compoundN "automaatti" (k12 "kahvila")) ; --UNCHK
lin automate_V2 = mkWV2 (k71 "tehdä") "automaattiseksi" ; --UNCHK
lin automated_A = mkA "automatisoitu" ;
lin automatic_A = mkWA (k38 "automaattinen") ; --UNCHK
lin automatic_N = mkWN (compoundN "automaatti" (k6 "pistooli")) ; --UNCHK
lin automation_N = mkWN (k3 "automaatio") ; --UNCHK
lin automaton_N = mkWN (k5A "robotti") ; --UNCHK
lin automobile_N = mkWN (k1 "auto") ;
lin automotive_A = mkWA "auto-" ; --UNCHK
lin automysophobia_N = mkWN (compoundN "automyso" (k12 "fobia")) ; --UNCHK
lin autonomic_A = mkWA (k34A "riippumaton") "tahdosta" ; --UNCHK
lin autonomous_A = mkWA (k38 "itsenäinen") ; --UNCHK
lin autonomy_N = mkWN (k40 "vapaus") ; --UNCHK
lin autophyte_N = mkWN (k3 "eliö") "omavarainen" ; --UNCHK
lin autopilot_N = mkWN (compoundN "auto" (k5A "pilotti")) ; --UNCHK
lin autoplastic_A = mkWA (compoundA "auto" (k38 "plastinen")) ; --UNCHK
lin autoplasty_N = mkWN (compoundN "autopl" (k12 "astia")) ; --UNCHK
lin autopsy_N = mkWN (compoundN "ruumiin" (k39 "avaus")) ; --UNCHK
lin autoradiograph_N = mkWN "autoradiografi" ; --UNCHK
lin autoradiographic_A = mkWA (compoundA "auto" (k38 "radiografinen")) ; --UNCHK
lin autoradiography_N = mkWN "autoradiografia" ; --UNCHK
lin autoregulation_N = mkWN (compoundN "itse" (k2 "säätely")) ; --UNCHK
lin autosemantic_A = mkWA (compoundA "auto" (k38 "semanttinen")) ; --UNCHK
lin autosexing_N = mkWN (compoundN "itse" (k39 "jalostus")) ; --UNCHK
lin autosomal_A = mkWA (compoundA "auto" (k38 "sominen")) ; --UNCHK
lin autosome_N = mkWN (k5 "kromosomi") "somaattinen" ; --UNCHK
lin autostrada_N = mkWN "autostrada" ; --UNCHK
lin autosuggestion_N = mkWN (compoundN "itse" (k3 "suggestio")) ; --UNCHK
lin autotelic_A = mkWA (compoundA "auto" (k38 "telinen")) ; --UNCHK
lin autotelism_N = mkWN (compoundN "autotel" (k5 "ismi")) ; --UNCHK
lin autotomic_A = mkWA (compoundA "auto" (k38 "tominen")) ; --UNCHK
lin autotomy_N = mkWN (compoundN "itsetypistymis" (k1A "kyky")) ; --UNCHK
lin autotrophic_A = mkWA (compoundA "oma" (k38 "varainen")) ; --UNCHK
lin autotype_N = mkWN (k12 "autotypia") ; --UNCHK
lin autotypic_A = mkWA (compoundA "auto" (k38 "tyyppinen")) ; --UNCHK
lin auttoinen_PN = mkPN "Auttoinen" ;
lin autumn_N = mkWN (k1 "syksy") ; --UNCHK
lin autumnal_A = mkWA (k38 "syksyinen") ; --UNCHK
lin auxesis_N = mkWN (k1 "kasvu") ; --UNCHK
lin auxetic_A = mkWA "kasvuun" "liittyvä" ; --UNCHK
lin auxiliary_A = mkWA "täydentävä" ; --UNCHK
lin auxiliary_N = mkWN (k38 "apulainen") ; --UNCHK
lin auxin_N = mkWN "auksiini" ; --UNCHK
lin auxinic_A = mkWA "auksiiniin" "liittyvä" ; --UNCHK
lin avadavat_N = mkWN (compoundN "punatiikeri" (k1A "peippo")) ; --UNCHK
lin avail_N = mkWN (k2 "palvelu") ; --UNCHK
lin avail_V = mkWV (k53A "tuottaa") "etua" ; --UNCHK
lin avail_V2 = mkWV2 (k53A "tuottaa") "etua" ; --UNCHK
lin availability_N = mkWN (k5A "saanti") ; --UNCHK
lin available_A = mkA "saatavillaoleva" | mkA "vapaa" ;
lin avalanche_N = mkWN (k1 "vyöry") ; --UNCHK
lin avaram_N = mkWN (compoundN "auricu" (k9A "lata")) "Cassia" ; --UNCHK
lin avarice_N = mkWN (k40 "kyltymättömyys") ; --UNCHK
lin avaricious_A = mkWA (k1 "perso") ; --UNCHK
lin avascular_A = mkWA "verisuoneton" ; --UNCHK
lin avatar_N = mkWN "avatar" ; --UNCHK
lin aveley_PN = foreignPN "Aveley" ;
lin avellan_A = mkWA (compoundA "pähkinä" (k38 "inen")) ; --UNCHK
lin avenge_V2 = mkWV2 (k53 "kostaa") ; --UNCHK
lin avenger_N = mkWN (k10 "kostaja") ; --UNCHK
lin avens_N = mkWN (k14A "kellukka") ; --UNCHK
lin avenue_N = mkWN (k19 "tie") ; --UNCHK
lin aver_V2 = mkWV2 (k52 "vannoa") ; --UNCHK
lin average_A = mkA "keskimääräinen" ;
lin average_N = mkN "keskiarvo" ;
lin average_V = mkWV (k58 "laskea") "keskiarvo" ; --UNCHK
lin average_V2 = mkWV2 (k58 "laskea") "keskiarvo" ; --UNCHK
lin averageness_N = mkWN (k40 "keskinkertaisuus") ; --UNCHK
lin averse_A = mkWA (k34A "haluton") ; --UNCHK
lin aversion_N = mkWN "pois" "nostaminen" ; --UNCHK
lin aversive_A = mkWA (compoundA "vaste" (k38 "nmielinen")) ; --UNCHK
lin avert_V2 = mkV2 "välttää" partitive ; --mkWV2 (k53 "nostaa") "pois" ;
lin averting_N = mkWN "pois" "nostaminen" ; --UNCHK
lin avian_A = mkWA "lintu-" ; --UNCHK
lin aviary_N = mkWN (compoundN "lintu" (k9 "tarha")) ; --UNCHK
lin aviation_N = mkWN (k2 "ilmailu") ; --UNCHK
lin aviatorFem_N = mkWN (k5A "pilotti") ; --UNCHK
lin aviatorMasc_N = mkWN (k5A "pilotti") ; --UNCHK
lin aviatrix_N = mkWN (compoundN "nais" (k10 "lentäjä")) ; --UNCHK
lin avid_A = mkWA (k38 "intohimoinen") ; --UNCHK
lin avidity_N = mkWN (k40 "kiihkeys") ; --UNCHK
lin avifauna_N = mkWN (k2 "linnusto") ; --UNCHK
lin avifaunal_A = mkWA "linnustoon" "liittyvä" ; --UNCHK
lin avignon_PN = foreignPN "Avignon" ;
lin avionic_A = mkWA "avioniikkaan" "liittyvä" ; --UNCHK
lin avionics_N = mkWN (k9A "avioniikka") ; --UNCHK
lin avirulent_A = mkWA (k34A "myrkytön") ; --UNCHK
lin avitaminosis_N = mkWN (k39 "puutos") "vitamiinin" ; --UNCHK
lin avitaminotic_A = mkWA "vitamiinipuutokseen" "liittyvä" ; --UNCHK
lin avo_N = mkWN (k99 "avo") ; --UNCHK
lin avocado_N = mkWN (k1 "avokado") ; --UNCHK
lin avocation_N = mkWN (k9A "toiminta") "vapaa-ajan" ; --UNCHK
lin avocational_A = mkWA "sivutyöhön" "liittyvä" ; --UNCHK
lin avocet_N = mkWN (k5A "avosetti") ; --UNCHK
lin avoid_V2 = mkWV2 (k53A "välttää") partitive ;
lin avoid_VV = mkVV (mkV "välttää") infElat ;
lin avoidable_A = mkWA (k10 "oleva") "vältettävissä" ; --UNCHK
lin avoidance_N = mkWN (k99 "pois") "kääntyminen" ; --UNCHK
lin avoirdupois_N = mkWN (k5 "läski") ; --UNCHK
lin avon_PN = foreignPN "Avon" ;
lin avouch_V = mkWV (k54A "myöntää") "avoimesti" ; --UNCHK
lin avouch_V2 = mkWV2 (k54A "myöntää") "avoimesti" ; --UNCHK
lin avow_V2 = mkWV2 (k54A "myöntää") "avoimesti" ; --UNCHK
lin avowal_N = mkWN (k39 "tunnustus") ; --UNCHK
lin avowedly_Adv = mkWAdv (k99 "tosiaan") ; --UNCHK
lin avower_N = mkWN (k10 "vahvistaja") ; --UNCHK
lin avulsion_N = mkWN (compoundN "irti" (k38 "repeäminen")) ; --UNCHK
lin avuncular_A = mkWA (k38 "setämäinen") ; --UNCHK
lin await_V2 = mkV2 "varautua" illative ;
lin awake_A = mkWA (k99 "valveilla") ; --UNCHK
lin awake_V = mkWV (k52A "havahtua") ; --UNCHK
lin awaken_V2 = mkWV2 (k52A "havahtua") ; --UNCHK
lin awakening_N = mkWN (k39 "herätys") ; --UNCHK
lin award_N = mkN "palkinto" ;
lin award_V2 = mkV2 "myöntää" ;
lin award_V3 = mkWV3 (k54A "ojentaa") ; --UNCHK
lin aware_A = mkA "tietoinen" ;
lin aware_of_A2 = mkA2 (mkA "tietoinen") (mkPrep elative) ;
lin awareness_N = mkN "tietoisuus" ;
lin away_1_Adv = mkAdv "poissa" ;
lin away_2_Adv = mkAdv "pois" ;
lin away_A = mkWA "vieras-" ; --UNCHK
lin away_Adv = mkAdv "pois" ;
lin awayness_N = mkWN "poissaolevuus" ; --UNCHK
lin awe_N = mkWN (k1A "pelko") "kunnioittava" ; --UNCHK
lin awe_V2 = mkWV2 (k53A "herättää") "kunnioitusta" ; --UNCHK
lin aweary_A = mkWA (k47 "väsynyt") ; --UNCHK
lin aweigh_A = mkWA (k99 "ylhäällä") "ankkuri" ; --UNCHK
lin aweless_A = mkWA (compoundA "epä" (k10 "kunnioittava")) ; --UNCHK
lin awesome_A = mkWA (k10 "vaikuttava") ; --UNCHK
lin awful_A = mkWA (k9 "paha") ; --UNCHK
lin awfulness_N = mkWN (k40 "hirveys") ; --UNCHK
lin awheel_A = mkWA "pyörillä" ; --UNCHK
lin awhile_Adv = mkWAdv (compoundAdv "het" (k101 "ken")) ; --UNCHK
lin awkward_A = mkWA (k2 "kömpelö") ; --UNCHK
lin awkwardness_N = mkWN (k40 "vaivalloisuus") ; --UNCHK
lin awl_N = mkWN (kH1 "naskali") ; --UNCHK
lin awlwort_N = mkWN (compoundN "äimä" (k1 "ruoho")) ; --UNCHK
lin awn_N = mkWN (k48 "vihne") ; --UNCHK
lin awned_A = mkWA (compoundA "vihne" (k38 "ellinen")) ; --UNCHK
lin awning_N = mkWN (k5 "markiisi") ; --UNCHK
lin awninged_A = mkWA "markiisin" "suojaama" ; --UNCHK
lin awnless_A = mkWA "vihneetön" ; --UNCHK
lin awry_A = mkWA (k99 "sekaisin") ; --UNCHK
lin awry_Adv = mkWAdv (k99 "väärin") ; --UNCHK
lin ax_N = mkWN (k41 "kirves") ; --UNCHK
lin ax_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin axe_N = mkWN (k41 "kirves") ; --UNCHK
lin axe_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin axenic_A = mkWA "mikrobiton" ; --UNCHK
lin axial_A = mkWA (k38 "pitkittäinen") ; --UNCHK
lin axil_N = mkWN (compoundN "hanka" (k10 "kulma")) ; --UNCHK
lin axile_A = mkWA "hanka-" ; --UNCHK
lin axillary_A = mkWA "kainalon" ; --UNCHK
lin axiological_A = mkWA "aksiologinen" ; --UNCHK
lin axiology_N = mkWN (compoundN "arvo" (k12 "filosofia")) ; --UNCHK
lin axiom_N = mkWN (k10 "aksiooma") ; --UNCHK
lin axiomatic_A = mkWA (k38 "aksiomaattinen") ; --UNCHK
lin axis_N = variants {} ; --
lin axle_N = mkWN (k6 "akseli") ; --UNCHK
lin axletree_N = mkWN (k6 "akseli") "pyörän" ; --UNCHK
lin axolemma_N = mkWN "aksolemma" ; --UNCHK
lin axolotl_N = mkWN "Ambystoma" "mexicanum" ; --UNCHK
lin axon_N = mkWN (compoundN "viejä" (k48A "haarake")) ; --UNCHK
lin axonal_A = mkWA (compoundA "aksona" (k38 "alinen")) ; --UNCHK
lin axseed_N = mkWN (compoundN "kirjonivel" (k9 "virna")) ; --UNCHK
lin ayah_N = mkWN (k10 "imettäjä") ; --UNCHK
lin ayapana_N = mkWN "Eupatorium" "ayapana" ; --UNCHK
lin ayatollah_N = mkWN (k5 "ajatollah") ; --UNCHK
lin aye_Interj = variants {} ; --
lin ayin_N = mkWN "ajin" ; --UNCHK
lin aylesbury_PN = foreignPN "Aylesbury" ;
lin aylesford_PN = foreignPN "Aylesford" ;
lin ayr_PN = foreignPN "Ayr" ;
lin azadirachtin_N = mkWN "atsadiraktiini" ; --UNCHK
lin azalea_N = mkWN (k13 "atsalea") ; --UNCHK
lin azathioprine_N = mkWN "Imuran" ; --UNCHK
lin azide_N = mkWN "atsidi" ; --UNCHK
lin azido_A = mkWA "atsidi" ; --UNCHK
lin azimuth_N = mkWN (compoundN "vaakasuunta" (k10 "kulma")) ; --UNCHK
lin azimuthal_A = mkWA (compoundA "atsimuta" (k38 "alinen")) ; --UNCHK
lin azithromycin_N = mkWN "Zithromax" ; --UNCHK
lin azo_A = mkWA "typpi-" ; --UNCHK
lin azoic_A = mkWA (k34A "eloton") ; --UNCHK
lin azonal_A = mkWA (k34A "jakamaton") "vyöhykkeisiin" ; --UNCHK
lin azonic_A = mkWA (k34A "jakamaton") "vyöhykkeisiin" ; --UNCHK
lin azote_N = mkWN (k7A "typpi") ; --UNCHK
lin azotemic_A = mkWA "virtsamyrkytykseen" "liittyvä" ; --UNCHK
lin azotic_A = mkWA "nitraatti-" ; --UNCHK
lin azoturia_N = mkWN "atsoturia" ; --UNCHK
lin aztreonam_N = mkWN "Azactam" ; --UNCHK
lin azure_A = mkWA (k38 "sininen") ; --UNCHK
lin azure_N = mkWN (k38 "sininen") ; --UNCHK
lin azurite_N = mkWN (compoundN "kuparila" (k26 "suuri")) ; --UNCHK
lin azygous_A = mkWA (k38 "yksittäinen") ; --UNCHK
lin azymia_N = mkWN (compoundN "entsyymi" (k39 "puutos")) ; --UNCHK
lin b_ed_N = mkN "kasvatustieteiden" (mkN "kandidaatti") ; ----sanaliitto
lin ba_N = mkWN (k5A "kandidaatti") "humanististen" "tieteiden" ; --UNCHK
lin baa_N = mkWN "mää" ; --UNCHK
lin baa_V = mkWV (k61A "määkiä") ; --UNCHK
lin baas_N = mkWN (k1 "pomo") ; --UNCHK
lin baba_N = mkWN (k1A "kakku") ; --UNCHK
lin babassu_N = mkWN (compoundN "speci" (k10 "osa")) "Orbignya" ; --UNCHK
lin babbitting_N = mkWN (compoundN "vala" (k38 "minen")) "laakerimetallin" ; --UNCHK
lin babble_N = mkWN (compoundN "sian" (k9 "saksa")) ; --UNCHK
lin babble_V = mkWV (k62 "vasikoida") ; --UNCHK
lin babble_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin babe_N = mkWN (k1 "sisko") ; --UNCHK
lin babel_N = mkWN (k9 "sekamelska") ; --UNCHK
lin babelike_A = mkWA (k41A "lapsekas") ; --UNCHK
lin babirusa_N = mkWN (compoundN "hirvi" (k9A "sika")) ; --UNCHK
lin babka_N = mkWN (k9 "baba") ; --UNCHK
lin baboo_N = mkWN (k9 "herra") ; --UNCHK
lin baboon_N = mkWN (k5 "paviaani") ; --UNCHK
lin baboonish_A = mkWA (compoundA "paviaani" (k38 "mainen")) ; --UNCHK
lin babu_N = mkWN (k9 "herra") ; --UNCHK
lin babushka_N = mkWN (compoundN "pää" (k9 "liina")) ; --UNCHK
lin baby_N = L.baby_N ;
lin baby_V2 = mkWV2 (k61 "helliä") ; --UNCHK
lin baby_farmer_N = mkWN (k10 "pitäjä") "lastentarhan" ; --UNCHK
lin baby_minder_N = mkWN (k12 "kaitsija") ; --UNCHK
lin baby_talk_N = mkWN (compoundN "vauvan" (k26 "kieli")) ; --UNCHK
lin babyhood_N = mkWN (compoundN "vauva" (k10A "ikä")) ; --UNCHK
lin babyish_A = mkWA (k38 "lapsellinen") ; --UNCHK
lin babysitter_N = mkWN (compoundN "lapsen" (k12 "kaitsija")) ; --UNCHK
lin babysitting_N = mkWN "lastenvahtiminen" ; --UNCHK
lin baccalaureate_N = mkWN (k1A "tutkinto") "kandidaatin" ; --UNCHK
lin baccate_A = mkWA (compoundA "marja" (k38 "mainen")) ; --UNCHK
lin bacchanal_A = mkWA (k38 "hekumallinen") ; --UNCHK
lin bacchanalian_A = mkWA (k38 "hekumallinen") ; --UNCHK
lin bacchant_N = mkWN (compoundN "bak" (k5A "kantti")) ; --UNCHK
lin bacchante_N = mkWN (k32A "papitar") "Bacchuksen" ; --UNCHK
lin bacchantic_A = mkWA (compoundA "bakk" (k38 "anaalinen")) ; --UNCHK
lin baccivorous_A = mkWA "marjoja" "syövä" ; --UNCHK
lin baccy_N = mkWN (k14A "tupakka") ; --UNCHK
lin bachelor_N = mkWN (k51 "vanhapoika") ; --UNCHK
lin bachelorhood_N = mkWN (k1 "olo") "poikamiehenä" ; --UNCHK
lin bacillar_A = mkWA "basilli-" ; --UNCHK
lin bacillus_N = mkWN (k6 "basilli") ; --UNCHK
lin bacitracin_N = mkWN (k5A "antibiootti") ; --UNCHK
lin back_A = mkA (mkN "taaempi" "taaemman" "taaempia") ;
lin back_Adv = mkAdv "takaisin" ;
lin back_N = L.back_N ;
lin back_V = mkWV (k52A "perääntyä") ;
lin back_away_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin back_down_V = mkWV (k52A "luopua") ; --UNCHK
lin back_into_V3 = variants {} ; -- guess-p-verb
lin back_off_V = mkWV (k52A "luopua") ; --UNCHK
lin back_out_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin back_out_of_V2 = prepV2 (advV OP_back_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin back_out_of_V3 = variants {} ; -- guess-p-verb
lin back_to_Prep = mkPrep "takaisin" elative ;
lin back_up_V = mkV "varmistaa" ;
lin back_up_1_V2 = mkV2 "varmistaa" ;
lin back_up_2_V2 = mkV2 "varmistaa" ;
lin backache_N = mkWN (compoundN "selkä" (k1A "kipu")) ; --UNCHK
lin backbeat_N = mkWN (k1 "takapotku") ; --UNCHK
lin backbench_N = mkWN (k9A "paikka") "riviparlamentaarikon" ; --UNCHK
lin backbencher_N = mkWN (compoundN "rivi" (k4A "parlamentaarikko")) ; --UNCHK
lin backbend_N = mkWN (k9A "silta") ; --UNCHK
lin backbite_V = mkWV (k53A "valittaa") ; --UNCHK
lin backbite_V2 = mkWV2 (k53A "valittaa") ; --UNCHK
lin backbiter_N = mkWN (k10 "parjaaja") ; --UNCHK
lin backblast_N = mkWN (compoundN "vasta" (k10 "voima")) ; --UNCHK
lin backboard_N = mkWN (compoundN "perä" (k9A "lauta")) ; --UNCHK
lin backbone_N = mkWN (compoundN "runko" (k1A "verkko")) ; --UNCHK
lin backchat_N = mkWN (k2 "pilailu") ; --UNCHK
lin backcloth_N = mkWN (k9 "tausta") ; --UNCHK
lin backdoor_N = mkWN (k99 "kautta") "takaoven" ; --UNCHK
lin backdrop_N = mkWN (k9 "tausta") ;
lin backerFem_N = mkWN (k10 "kannattaja") ; --UNCHK
lin backerMasc_N = mkWN (k10 "kannattaja") ; --UNCHK
lin backfield_N = mkWN (compoundN "taka" (k10A "kenttä")) ; --UNCHK
lin backfire_N = mkWN (compoundN "taka" (k1 "isku")) ; --UNCHK
lin backfire_V = mkV "kostautua" ; --mkWV (k53A "sytyttää") "vastatuli" ;
lin backflow_N = mkWN (compoundN "takaisin" (k39 "virtaus")) ; --UNCHK
lin backgammon_N = mkWN (k6 "backgammon") ; --UNCHK
lin background_N = mkWN (k9 "tausta") ;
lin backgrounder_N = mkWN (k39 "taustoitus") ; --UNCHK
lin backhand_A = mkWA "rysty-" ; --UNCHK
lin backhand_N = mkWN (compoundN "rysty" (k5A "lyönti")) ; --UNCHK
lin backhanded_A = mkWA "rysty-" ; --UNCHK
lin backhander_N = mkWN (k5A "lyönti") "kämmenselällä" "sivallettu" ; --UNCHK
lin backhoe_N = mkWN (compoundN "kaivin" (k48 "kone")) ; --UNCHK
lin backing_N = mkWN (k39 "kannatus") ; --UNCHK
lin backlash_N = mkWN (k39 "vastustus") ; --UNCHK
lin backless_A = mkWA "selkänojaton" ; --UNCHK
lin backlighting_N = mkWN (compoundN "tausta" (k39 "valaistus")) ; --UNCHK
lin backlog_N = mkWN (k10 "suma") ; --UNCHK
lin backmost_A = mkWA (k38 "viimeinen") ; --UNCHK
lin backpack_N = mkWN (k9A "rinkka") ; --UNCHK
lin backpacker_N = mkWN (k10 "vaeltaja") ; --UNCHK
lin backpedal_V = mkWV (k52A "perääntyä") "jstak" ; --UNCHK
lin backplate_N = mkWN (compoundN "selkä" (k6 "panssari")) ; --UNCHK
lin backroom_N = mkWN (compoundN "taka" (k48 "huone")) ; --UNCHK
lin backsaw_N = mkWN (compoundN "selkä" (k9 "saha")) ; --UNCHK
lin backscratcher_N = mkWN (compoundN "selän" (k33A "raaputin")) ; --UNCHK
lin backseat_N = mkWN (compoundN "taka" (k5A "penkki")) ; --UNCHK
lin backsheesh_N = mkWN (k5A "tippi") ; --UNCHK
lin backside_N = mkWN (k1 "takalisto") ; --UNCHK
lin backslapper_N = mkWN (k10 "kannustaja") ; --UNCHK
lin backslide_V = mkWV (k52 "lipsua") "periaatteistaan" ; --UNCHK
lin backsliding_N = mkWN (k99 "uudelleen") "sortuminen" ; --UNCHK
lin backspace_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin backspin_N = mkWN (compoundN "taka" (k48A "kierre")) ; --UNCHK
lin backstage_Adv = mkWAdv (k99 "takana") "näyttämön" ; --UNCHK
lin backstair_A = mkWA (k38 "vaivihkainen") ; --UNCHK
lin backstay_N = mkWN (k7A "tuki") ; --UNCHK
lin backstitch_N = mkWN (compoundN "taka" (k1 "pisto")) ; --UNCHK
lin backstop_N = mkWN (k48 "vaste") ; --UNCHK
lin backstroke_N = mkWN (compoundN "selkä" (k5A "uinti")) ; --UNCHK
lin backstroker_N = mkWN (compoundN "selkä" (k10 "uija")) ; --UNCHK
lin backswimmer_N = mkWN (compoundN "undu" (k9A "lata")) "Notonecta" ; --UNCHK
lin backsword_N = mkWN (k9A "miekka") ; --UNCHK
lin backtalk_N = mkWN (k9A "suunpieksentä") ; --UNCHK
lin back_up_N = mkWN (k39 "kannatus") ; --UNCHK
lin backward_A = mkWA (compoundA "taa" (k38 "ksepäinen")) ; --UNCHK
lin backward_Adv = mkWAdv (k99 "taakse") ; --UNCHK
lin backwards_Adv = mkWAdv (k99 "taemmaksi") ; --UNCHK
lin backwash_N = mkWN (compoundN "vana" (k27 "vesi")) ; --UNCHK
lin backwater_N = mkWN (k12 "takapajula") ; --UNCHK
lin backwoods_N = mkWN (k8 "lande") ; --UNCHK
lin backwoodsman_N = mkWN (k42 "mies") "takametsien" ; --UNCHK
lin backworth_PN = foreignPN "Backworth" ;
lin backyard_N = mkWN (compoundN "taka" (k9 "piha")) ; --UNCHK
lin bacon_N = mkWN (k6 "pekoni") ; --UNCHK
lin bacteremia_N = mkWN "bakteremia" ; --UNCHK
lin bacteremic_A = mkWA "baktereeminen" ; --UNCHK
lin bacteria_N = mkWN (k6 "bakteeri") ; --UNCHK
lin bacterial_A = mkWA "bakteeri-" ; --UNCHK
lin bactericidal_A = mkWA (compoundA "desinfi" (k10 "oiva")) ; --UNCHK
lin bactericide_N = mkWN (k5A "antibiootti") ; --UNCHK
lin bacteriochlorophyll_N = mkWN (compoundN "bakteeri" (k5 "klorofylli")) ; --UNCHK
lin bacteriological_A = mkWA (k38 "bakteriologinen") ; --UNCHK
lin bacteriologist_N = mkWN "bakteriologi" ; --UNCHK
lin bacteriology_N = mkWN (k12 "bakteriologia") ; --UNCHK
lin bacteriolysis_N = mkWN (compoundN "bakterioly" (k5 "ysi")) ; --UNCHK
lin bacteriolytic_A = mkWA "bakteriolyyttinen" ; --UNCHK
lin bacteriophage_N = mkWN "fagi" ; --UNCHK
lin bacteriophagic_A = mkWA "bakteriofaginen" ; --UNCHK
lin bacteriostat_N = mkWN "bakteriostaatti" ; --UNCHK
lin bacteriostatic_A = mkWA (compoundA "bakterio" (k38 "staattinen")) ; --UNCHK
lin bacterium_N = mkWN (k6 "bakteeri") ;
lin bacteroid_N = mkWN "bakteroidi" ; --UNCHK
lin bacteroidal_A = mkWA (compoundA "muis" (k10 "tuttava")) "bakteeria" ; --UNCHK
lin bacup_PN = foreignPN "Bacup" ;
lin bad_A = L.bad_A ;
lin bad_N = mkWN (k40 "pahuus") ; --UNCHK
lin badajoz_PN = foreignPN "Badajoz" ;
lin badalona_PN = foreignPN "Badalona" ;
lin baddeleyite_N = mkWN "baddeleyiitti" ; --UNCHK
lin badge_N = mkWN (k39 "tunnus") ; --UNCHK
lin badger_N = mkWN (k10 "mäyrä") ; --UNCHK
lin badger_V2 = mkWV2 (k67A "maanitella") ; --UNCHK
lin badgering_N = mkWN (k9 "piina") ; --UNCHK
lin badlands_N = mkWN "Badlands" ; --UNCHK
lin badminton_N = mkWN (compoundN "sulka" (k1 "pallo")) ; --UNCHK
lin badness_N = mkWN (k40 "tottelemattomuus") ; --UNCHK
lin baedeker_N = mkWN (compoundN "opas" (k9 "kirja")) ; --UNCHK
lin baffle_N = mkWN (kH1 "läppä") ; --UNCHK
lin baffle_V2 = mkWV2 (k53A "säätää") "äänenpainetta" ; --UNCHK
lin baffled_N = mkWN (k99 "ymmällä") ; --UNCHK
lin baffling_A = mkWA (k10 "hankala") ; --UNCHK
lin bag_N = mkWN (k1A "juttu") ; --UNCHK
lin bag_V = mkWV (k63 "saada") ; --UNCHK
lin bag_V2 = mkWV2 (k63 "saada") ; --UNCHK
lin bagasse_N = mkWN (compoundN "sokeriruoko" (k48A "jäte")) ; --UNCHK
lin bagassosis_N = mkWN (compoundN "bagas" (k5 "soosi")) ; --UNCHK
lin bagatelle_N = mkWN (k12 "fortuna") ; --UNCHK
lin bagel_N = mkWN (k6 "rinkeli") ; --UNCHK
lin baggage_N = mkN "painolasti" ; ---ARB ; matkatavarat
lin baggageman_N = mkWN (compoundN "matkatavara" (k12 "palvelija")) ; --UNCHK
lin bagger_N = mkWN (compoundN "pakkaus" (k48 "kone")) ; --UNCHK
lin baggy_A = mkWA (k10 "väljä") ; --UNCHK
lin baghdad_PN = foreignPN "Bagdad" ;
lin bagman_N = mkWN (k38 "rikollinen") ; --UNCHK
lin bagnio_N = mkWN (k12 "kylpylä") ; --UNCHK
lin bagpipe_N = mkWN (compoundN "säkki" (k5 "pilli")) ; --UNCHK
lin baguet_N = mkWN (k5A "patonki") ; --UNCHK
lin bahamas_PN = foreignPN "Bahama" ;
lin bahamian_A = mkWA (compoundA "baham" (k38 "alainen")) ; --UNCHK
lin bahamian_N = mkWN (compoundN "baham" (k38 "alainen")) ; --UNCHK
lin bahasa_N = mkWN "Bahasa" ; --UNCHK
lin bahrain_PN = foreignPN "Bahrain" ;
lin bahraini_A = mkWA (compoundA "bahraini" (k38 "lainen")) ; --UNCHK
lin bahraini_N = mkWN (compoundN "bahraini" (k38 "lainen")) ; --UNCHK
lin baht_N = mkWN "tical" ; --UNCHK
lin bail_N = mkWN (k17 "takuu") ; --UNCHK
lin bail_V = mkV (mkV "vapautua") "takuita vastaan" ; --mkWV (k62 "äyskäröidä") ;
lin bail_V2 = mkWV2 (k62 "äyskäröidä") ; --UNCHK
lin bail_out_V = mkWV (k62 "äyskäröidä") ; --UNCHK
lin bail_out_V2 = mkWV2 (k62 "äyskäröidä") ; --UNCHK
lin bailable_A = mkWA (k99 "vastaan") "takuuta" ; --UNCHK
lin bailee_N = mkWN (compoundN "vastaan" (k10 "ottaja")) "uskotun" "tavaran" ; --UNCHK
lin bailey_N = mkWN (compoundN "ulko" (k5 "muuri")) ; --UNCHK
lin bailiff_N = mkWN (compoundN "oikeuden" (k12 "palvelija")) ; --UNCHK
lin bailiffship_N = mkWN (k9A "virka") "oikeudenpalvelijan" ; --UNCHK
lin bailiwick_N = mkWN (k48 "aine") ; --UNCHK
lin bailment_N = mkWN "takauksen" "antaminen" ; --UNCHK
lin bailor_N = mkWN (k10 "tallettaja") ; --UNCHK
lin bairn_N = mkWN (k29 "lapsi") ; --UNCHK
lin bait_N = mkWN (k33A "houkutin") ; --UNCHK
lin bait_V = mkWV (k53A "ärsyttää") ; --UNCHK
lin bait_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin baiting_N = mkWN "rääkkääminen" ; --UNCHK
lin baiza_N = mkWN "baisa" ; --UNCHK
lin baize_N = mkWN "boiji" ; --UNCHK
lin bake_V = mkWV (k56 "paistaa") ; --UNCHK
lin bake_V2 = mkWV2 (k56 "paistaa") ; --UNCHK
lin bakelite_N = mkWN (compoundN "bak" (k5A "eliitti")) ; --UNCHK
lin baker_N = mkWN (k6 "paakari") ; --UNCHK
lin bakery_N = mkWN (k2 "leipomo") ; --UNCHK
lin baking_N = mkWN (k9A "leivonta") ; --UNCHK
lin baking_hot_A = mkWA (compoundA "tuli" (k10 "kuuma")) ; --UNCHK
lin baking_powder_N = mkWN (compoundN "leivin" (k48 "jauhe")) ; --UNCHK
lin baklava_N = mkWN (compoundN "bak" (k9 "lava")) ; --UNCHK
lin baksheesh_N = mkWN (k5A "tippi") ; --UNCHK
lin baku_PN = foreignPN "Baku" ;
lin balaclava_N = mkWN (compoundN "villa" (k10 "kypärä")) ; --UNCHK
lin balagan_N = mkWN (k39 "kaaos") ; --UNCHK
lin balalaika_N = mkWN (k9A "balalaikka") ; --UNCHK
lin balance_N = mkN "tasapaino" | mkN "balanssi" ;
lin balance_V = mkWV (k53A "pitää") "tasapainossa" ; --UNCHK
lin balance_V2 = mkV2 "tasapainottaa" partitive ; --mkWV2 (k53A "pitää") "tasapainossa" ;
lin balance_sheet_N = mkWN (k48 "tase") ; --UNCHK
lin balance_wheel_N = mkWN (k33A "liipotin") "taskukellon" ; --UNCHK
lin balanced_A = variants {} ; --
lin balanitis_N = mkWN (k39 "tulehdus") "terskan" ; --UNCHK
lin balas_N = mkWN "spinelli" ; --UNCHK
lin balata_N = mkWN "Manilkara" "bidentata" ; --UNCHK
lin balbriggan_N = mkWN (k39 "neulos") "sileä" ; --UNCHK
lin balconied_A = mkWA (compoundA "par" (k38 "vekkeellinen")) ; --UNCHK
lin balcony_N = mkWN (k48A "parveke") ; --UNCHK
lin bald_A = mkWA (k1 "kalju") ; --UNCHK
lin baldachin_N = mkWN (k39 "katos") ; --UNCHK
lin balderdash_N = mkWN (k99 "soopa") ; --UNCHK
lin bald_head_N = mkWN (k50 "kaljupää") ; --UNCHK
lin balding_A = mkWA (compoundA "kalju" (k10 "untuva")) ; --UNCHK
lin baldness_N = mkWN (k40 "kaljuus") ; --UNCHK
lin baldock_PN = foreignPN "Baldock" ;
lin baldric_N = mkWN (compoundN "miekka" (k19 "vyö")) ; --UNCHK
lin bale_N = mkWN (k5 "paali") ; --UNCHK
lin bale_V2 = mkWV2 (k53A "paalittaa") ; --UNCHK
lin baleful_A = mkWA (k10 "uhkaava") ; --UNCHK
lin balk_N = mkWN (compoundN "teko" (k1A "syöttö")) ; --UNCHK
lin balk_V = mkWV (k71 "tehdä") "tenä" ; --UNCHK
lin balk_V2 = mkWV2 (k71 "tehdä") "tenä" ; --UNCHK
lin balker_N = mkWN (k38 "ihminen") "tottelematon" ; --UNCHK
lin balkiness_N = mkWN (compoundN "vastus" (k38 "taminen")) ; --UNCHK
lin balkline_N = mkWN (k9 "viiva") ; --UNCHK
lin ball_N = mkN "pallo" ;
lin ball_V = mkWV (k61 "kääriä") "kerälle" ; --UNCHK
lin ball_V2 = mkWV2 (k61 "kääriä") "kerälle" ; --UNCHK
lin ball_cartridge_N = mkWN (kH1 "patruuna") "terävä" ; --UNCHK
lin ball_up_V2 = mkWV2 (k71 "tehdä") "virhe" ; --UNCHK
lin ballad_N = mkWN (k5 "balladi") ; --UNCHK
lin ballade_N = mkWN (k5 "balladi") ; --UNCHK
lin ballast_N = mkWN (compoundN "pohja" (k5 "lasti")) ; --UNCHK
lin ballast_V2 = mkWV2 (k53 "varustaa") "painolastilla" ; --UNCHK
lin ballcock_N = mkWN (compoundN "kuulauimur" (k10 "ihana")) ; --UNCHK
lin ball_dress_N = mkWN (compoundN "ilta" (k1A "puku")) ; --UNCHK
lin ballerina_N = mkWN (k9 "ballerina") ; --UNCHK
lin ballet_N = mkWN (k5A "baletti") ; --UNCHK
lin ballet_dancer_N = mkWN (compoundN "baletti" (k12 "tanssija")) ; --UNCHK
lin ballet_skirt_N = mkWN (compoundN "baletti" (k48 "hame")) ; --UNCHK
lin balletic_A = mkWA (k10 "sulava") ; --UNCHK
lin balletomane_N = mkWN (compoundN "baletti" (k5 "fani")) ; --UNCHK
lin balletomania_N = mkWN (compoundN "balleto" (k12 "mania")) ; --UNCHK
lin ballgame_N = mkWN (compoundN "pallo" (k5 "peli")) ; --UNCHK
lin ballistic_A = mkWA (k38 "ballistinen") ; --UNCHK
lin ballistics_N = mkWN (k9A "ballistiikka") ; --UNCHK
lin ballistocardiogram_N = mkWN "ballistokardiogrammi" ; --UNCHK
lin ballistocardiograph_N = mkWN "kardiografi" ; --UNCHK
lin ballock_N = mkWN (k39 "kives") ; --UNCHK
lin balloon_N = mkWN (k50 "kuumailmapallo") ; --UNCHK
lin balloon_V = mkWV (k52A "täyttyä") ; --UNCHK
lin balloon_V2 = mkWV2 (k52A "täyttyä") ; --UNCHK
lin ballooning_N = mkWN (compoundN "ilmapallo" (k39 "purjehdus")) ; --UNCHK
lin balloonist_N = mkWN (k10 "lentäjä") "kuumailmapallon" ; --UNCHK
lin ballot_N = mkWN (k26 "ääni") ; --UNCHK
lin ballot_V = mkWV (k53 "äänestää") ; --UNCHK
lin ballot_box_N = mkWN (compoundN "vaali" (k10 "uurna")) ; --UNCHK
lin ballottement_N = mkWN (compoundN "pallo" (k38 "aminen")) ; --UNCHK
lin ballpark_N = mkWN (k10A "kenttä") ; --UNCHK
lin ballpen_N = mkWN (compoundN "kuula" (k10 "kynä")) ; --UNCHK
lin ballplayer_N = mkWN (k10 "pelaaja") "baseballin" ; --UNCHK
lin ballpoint_N = mkWN (compoundN "kuula" (k10 "kynä")) ; --UNCHK
lin ballpoint_pen_N = mkWN (compoundN "kuula" (k10 "kynä")) ; --UNCHK
lin ballroom_N = mkWN (compoundN "tanssi" (k9 "lava")) ; --UNCHK
lin ballup_N = mkWN (k1 "sotku") ; --UNCHK
lin bally_A = variants {} ;
lin bally_Adv = adjAdv bally_A ; -- derived
lin ballyhoo_N = mkWN (k39 "mainos") ; --UNCHK
lin balm_N = mkWN (k9 "salva") ; --UNCHK
lin balminess_N = mkWN (k40 "lempeys") ; --UNCHK
lin balmoral_N = mkWN (k1A "hattu") "sininen" ; --UNCHK
lin balmy_A = mkWA (k10 "leppoisa") ; --UNCHK
lin baloney_N = mkWN (k5 "humpuuki") ; --UNCHK
lin balsa_N = mkWN (k9 "balsa") ; --UNCHK
lin balsam_N = mkWN (k5 "palsami") ; --UNCHK
lin balsamic_A = mkWA "palsamin" ; --UNCHK
lin balsamroot_N = mkWN (k26 "palsamijuuri") ; --UNCHK
lin baltic_sea_PN = mkPN (mkN "Itämeri" "Itämeren" "Itämeriä" "Itämerta") ;
lin baltimore_PN = foreignPN "Baltimore" ;
lin baluster_N = mkWN (kH1 "puola") ; --UNCHK
lin balustrade_N = mkWN (k48A "kaide") ; --UNCHK
lin bambino_N = mkWN (k2 "napero") ; --UNCHK
lin bamboo_N = mkWN (k1 "bambu") ; --UNCHK
lin bamboozle_V2 = mkWV2 (k73 "puliveivata") ; --UNCHK
lin ban_N = mkWN (k1A "kielto") ; --f52
lin ban_V2 = mkWV2 (k54A "kieltää") ; --f58
lin banal_A = mkWA (k38 "tavallinen") ; --UNCHK
lin banality_N = mkWN (k5A "trivialiteetti") ; --UNCHK
lin banana_N = mkWN (k6 "banaani") ; --UNCHK
lin banausic_A = mkWA (k38 "materialistinen") ; --UNCHK
lin banbury_PN = foreignPN "Banbury" ;
lin band_N = mkWN (k9A "panta") ;
lin band_V = mkWV (k53 "rengastaa") ; --UNCHK
lin band_V2 = mkWV2 (k53 "rengastaa") ; --UNCHK
lin band_saw_N = mkWN (compoundN "vanne" (k9 "saha")) ; --UNCHK
lin bandage_N = mkWN (k6 "laastari") ; --UNCHK
lin bandage_V2 = mkWV2 (k62 "laastaroida") ; --UNCHK
lin bandanna_N = mkWN (k9 "liina") ; --UNCHK
lin bandbox_N = mkWN (compoundN "hattu" (k12 "rasia")) ; --UNCHK
lin banderilla_N = mkWN "banderilla" ; --UNCHK
lin banderillero_N = mkWN (k12 "iskijä") "banderillan" ; --UNCHK
lin bandicoot_N = mkWN (compoundN "pussi" (k10 "mäyrä")) ; --UNCHK
lin bandit_N = mkWN (k5A "bandiitti") ; --UNCHK
lin banditry_N = mkWN (k39 "rosvous") ; --UNCHK
lin bandleader_N = mkWN (k10 "johtaja") "yhtyeen" ; --UNCHK
lin bandmaster_N = mkWN (compoundN "kapelli" (k6 "mestari")) ; --UNCHK
lin bandoleer_N = mkWN (compoundN "patruuna" (k19 "vyö")) ; --UNCHK
lin bandolier_N = mkWN (compoundN "patruuna" (k19 "vyö")) ; --UNCHK
lin bandoneon_N = mkWN "Bandoneón" ; --UNCHK
lin bandsman_N = mkWN (k10 "soittaja") ; --UNCHK
lin bandstand_N = mkWN (k9 "lava") ; --UNCHK
lin bandung_PN = foreignPN "Bandung" ;
lin bandwagon_N = mkWN (compoundN "paraati" (k1 "vaunu")) ; --UNCHK
lin bandwidth_N = mkWN (k9 "kaista") ; --UNCHK
lin bandy_A = mkWA (compoundA "väärä" (k38 "säärinen")) ; --UNCHK
lin bandy_V2 = mkWV2 (k61A "pohtia") ; --UNCHK
lin bane_N = mkWN (k40 "vaikeus") ; --UNCHK
lin baneberry_N = mkWN (compoundN "konnan" (k9 "marja")) ; --UNCHK
lin baneful_A = mkWA (k41A "kohtalokas") ; --UNCHK
lin bang_Adv = mkWAdv (k99 "päistikkaa") ; --UNCHK
lin bang_N = mkN "isku" ; --mkWN (k39 "menestys") ;
lin bang_V = mkWV (k53A "paukahtaa") ; --UNCHK
lin bang_V2 = mkWV2 (k53A "paukahtaa") ; --UNCHK
lin bang_out_V2 = mkWV2 (k53A "pimputtaa") ; --UNCHK
lin bang_up_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin bangalore_PN = foreignPN "Bangalore" ;
lin banger_N = mkWN (k38 "sähikäinen") ; --UNCHK
lin banging_N = mkWN (compoundN "pahoin" (k2 "pitely")) ; --UNCHK
lin bangkok_PN = foreignPN "Bangkok" ;
lin bangladesh_PN = foreignPN "Bangladesh" ;
lin bangladeshi_A = mkWA (compoundA "bangladeshi" (k38 "lainen")) ; --UNCHK
lin bangladeshi_N = mkWN (compoundN "bangladeshi" (k38 "lainen")) ; --UNCHK
lin bangle_N = mkWN (k1 "koru") ; --UNCHK
lin bangor_PN = foreignPN "Bangor" ;
lin banian_N = mkWN "banian" ; --UNCHK
lin banian_tree_N = mkWN (compoundN "banian" (k12 "viikuna")) ; --UNCHK
lin banish_V2 = mkWV2 (k56 "ajaa") "tiehensä" ; --UNCHK
lin banishment_N = mkWN (k3 "tuomio") ; --UNCHK
lin banister_N = mkWN (k48A "kaide") ; --UNCHK
lin banjo_N = mkWN (k1 "banjo") ; --UNCHK
lin bank_1_N = mkN (lin NK {s = d09A "penkka"}) ;
lin bank_2_N = L.bank_N ;
lin bank_V = mkWV (k53A "luottaa") ; --UNCHK
lin bank_V2 = mkWV2 (k53A "luottaa") ; --UNCHK
lin bank_bill_N = mkWN (k6 "seteli") "dollarin" ; --UNCHK
lin bank_draft_N = mkWN (compoundN "pankki" (k6 "vekseli")) ; --UNCHK
lin bank_rate_N = mkWN (compoundN "korko" (k9A "kanta")) ; --UNCHK
lin bankable_A = mkWA (compoundA "pankki" (k38 "kelpoinen")) ; --UNCHK
lin bank_book_N = mkWN (compoundN "pankki" (k9 "kirja")) ; --UNCHK
lin banker_N = mkWN (k6 "pankkiiri") ;
lin banking_N = mkN "pankkitoiminta" ;
lin banknote_N = mkWN (k6 "seteli") "dollarin" ; --UNCHK
lin bankroll_N = mkWN (compoundN "seteli" (k1A "nippu")) ; --UNCHK
lin bankrupt_A = mkA (mkN "konkurssi" (mkN "kypsä")) ;
lin bankrupt_N = mkWN (compoundN "tyrsky" (k10 "kahlaaja")) ; --UNCHK
lin bankrupt_V2 = mkWV2 (k57A "kaataa") ; --UNCHK
lin bankruptcy_N = mkWN (k5 "konkurssi") ;
lin banksia_N = mkWN (k10 "kuusama") ; --UNCHK
lin banner_A = mkWA (k38 "oivallinen") ; --UNCHK
lin banner_N = mkWN (k5 "viiri") ; --UNCHK
lin bannerlike_Adv = mkWAdv "lippumaisesti" ; --UNCHK
lin bannister_N = mkWN (k48A "kaide") ; --UNCHK
lin bannock_N = mkWN (k10A "leipä") ; --UNCHK
lin bannockburn_PN = foreignPN "Bannockburn" ;
lin banns_N = mkWN (compoundN "avioliitto" (k39 "kuulutus")) ; --UNCHK
lin banquet_N = mkN "juhla" ;
lin banquet_V = mkWV (k52 "osallistua") "juhliin" ; --UNCHK
lin banquet_V2 = mkWV2 (k52 "osallistua") "juhliin" ; --UNCHK
lin banquette_N = mkWN (k5A "penkki") ; --UNCHK
lin banshee_N = mkWN "banshee" ; --UNCHK
lin bantam_A = mkWA (k10 "sorja") ; --UNCHK
lin bantam_N = mkWN (compoundN "kääpiö" (k9 "kana")) ; --UNCHK
lin bantamweight_N = mkWN (compoundN "kääpiösarja" (k38 "lainen")) ; --UNCHK
lin banteng_N = mkWN (compoundN "balin" (k9A "nauta")) ; --UNCHK
lin banter_N = mkWN (k2 "pilailu") ; --UNCHK
lin banter_V = mkWV (k67 "pilailla") ; --UNCHK
lin banter_V2 = mkWV2 (k67 "pilailla") ; --UNCHK
lin banteringly_Adv = mkWAdv "leikkimielisesti" ; --UNCHK
lin banting_N = mkWN (compoundN "balin" (k9A "nauta")) ; --UNCHK
lin bantry_PN = foreignPN "Bantry" ;
lin bantu_A = mkWA "bantu-" ; --UNCHK
lin bantu_N = mkWN (k1 "bantu") ; --UNCHK
lin banyan_N = mkWN "banian" ; --UNCHK
lin banzai_N = mkWN "banzai" ; --UNCHK
lin baobab_N = mkWN "apinanleipäpuu" ; --UNCHK
lin bap_N = mkWN (k12 "sämpylä") ; --UNCHK
lin baptism_N = mkWN (k48 "kaste") ; --UNCHK
lin baptismal_A = mkWA "kaste-" ; --UNCHK
lin baptist_N = mkWN (k5 "baptisti") ; --UNCHK
lin baptize_V2 = mkWV2 (k61 "ristiä") ; --UNCHK
lin bar_1_N = mkN "baari" ;
lin bar_2_N = mkN "tanko" ;
lin bar_N = mkN "baari" ;
lin bar_V2 = mkWV2 (k58A "sulkea") "pois" ;
lin barb_N = mkN (lin NK {s = d05A "piikki"}) ;
lin barbadian_A = mkWA (compoundA "barbados" (k38 "lainen")) ; --UNCHK
lin barbadian_N = mkWN (compoundN "barbados" (k38 "lainen")) ; --UNCHK
lin barbados_PN = foreignPN "Barbados" ;
lin barbara_PN = foreignPN "Barbara" ;
lin barbarian_A = mkWA (k5 "villi") ; --UNCHK
lin barbarian_N = mkWN (k38 "raakalainen") ; --UNCHK
lin barbaric_A = mkWA (k5 "villi") ; --UNCHK
lin barbarism_N = mkWN (k40 "brutaalius") ; --UNCHK
lin barbarity_N = mkWN (k40 "brutaalius") ; --UNCHK
lin barbarization_N = mkWN (compoundN "raaka" (k38 "laistuminen")) ; --UNCHK
lin barbarize_V2 = mkWV2 (k71 "tehdä") "raaemmaksi" ; --UNCHK
lin barbarous_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin barbasco_N = mkWN "Jacquinia" "keyensis" ; --UNCHK
lin barbecue_N = mkWN (k12 "parila") ; --UNCHK
lin barbecue_V2 = mkWV2 (k62 "pariloida") ; --UNCHK
lin barbecuing_N = mkWN "grillaaminen" ; --UNCHK
lin barbed_A = mkWA (k38 "piikkinen") ; --UNCHK
lin barbel_N = mkWN (compoundN "tunto" (k7 "sarvi")) ; --UNCHK
lin barbell_N = mkWN (compoundN "levy" (k1A "tanko")) ; --UNCHK
lin barber_N = mkWN (k6 "parturi") ; --UNCHK
lin barberry_N = mkWN (compoundN "happo" (k9 "marja")) ; --UNCHK
lin barbershop_N = mkWN (k6 "parturi") ; --UNCHK
lin barbet_N = mkWN (compoundN "turkoosi" (k10A "seppä")) ; --UNCHK
lin barbette_N = mkWN (compoundN "tykki" (k49A "penger")) ; --UNCHK
lin barbican_N = mkWN (compoundN "vartio" (k5 "torni")) ; --UNCHK
lin barbital_N = mkWN (compoundN "vero" (k5 "naali")) ; --UNCHK
lin barbitone_N = mkWN (compoundN "vero" (k5 "naali")) ; --UNCHK
lin barbiturate_N = mkWN (k5A "barbituraatti") ; --UNCHK
lin barbu_N = mkWN (k9 "kala") ; --UNCHK
lin barcarole_N = mkWN "barkaroli" ; --UNCHK
lin barcarolle_N = mkWN "barkaroli" ; --UNCHK
lin barcelona_PN = foreignPN "Barcelona" ;
lin bard_N = mkWN (k25 "loimi") ; --UNCHK
lin bardic_A = mkWA (compoundA "bardi" (k38 "nen")) ; --UNCHK
lin bardolatry_N = mkWN (k9A "palvonta") "William" "Shakespearen" ; --UNCHK
lin bare_A = mkA "paljas" ;
lin bare_V2 = mkWV2 (k52A "koaguloitua") ; --UNCHK
lin bareback_A = mkWA (k10 "oleva") "satulatta" ; --UNCHK
lin bareback_Adv = mkWAdv (compoundAdv "satu" (k9A "latta")) ; --UNCHK
lin barebacked_A = mkWA (k10 "oleva") "satulatta" ; --UNCHK
lin barebacked_Adv = mkWAdv (compoundAdv "satu" (k9A "latta")) ; --UNCHK
lin barefaced_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin barefoot_A = mkWA (compoundA "paljas" (k38 "jalkainen")) ; --UNCHK
lin barefoot_Adv = mkWAdv (k99 "avojaloin") ; --UNCHK
lin barefooted_A = mkWA (compoundA "paljas" (k38 "jalkainen")) ; --UNCHK
lin barefooted_Adv = mkWAdv (k99 "avojaloin") ; --UNCHK
lin barehanded_A = mkWA (k99 "käsin") "paljain" ; --UNCHK
lin bareheaded_A = mkWA (k99 "päin") "paljain" ; --UNCHK
lin barelegged_A = mkWA (compoundA "paljas" (k38 "jalkainen")) ; --UNCHK
lin barely_Adv = adjAdv bare_A ; -- -- derived
lin bareness_N = mkWN (k40 "koruttomuus") ; --UNCHK
lin bargain_N = mkN "kauppa" ; --WN (k39 "sopimus") ;
lin bargain_V = mkWV (k67A "neuvotella") ; --UNCHK
lin bargain_V2 = mkWV2 (k67A "neuvotella") ; --UNCHK
lin bargain_down_V2 = mkWV2 (k52 "hieroa") "kauppoja" ; --UNCHK
lin bargainer_N = mkWN (k12 "neuvottelija") ; --UNCHK
lin bargaining_N = mkWN (k2 "neuvottelu") ; --UNCHK
lin barge_N = mkN "proomu" ; --mkWN (k10 "lotja") "raskas" ;
lin barge_V = mkWV (k53A "kuljettaa") "proomulla" ; --UNCHK
lin barge_in_V = mkWV (k52A "sekaantua") ; --UNCHK
lin bargee_N = mkWN (k10 "kuljettaja") "proomun" ; --UNCHK
lin bargello_N = mkWN (compoundN "Bargello-" (k39 "tikkaus")) ; --UNCHK
lin bargoed_PN = foreignPN "Bargoed" ;
lin bari_PN = foreignPN "Bari" ;
lin baric_A = mkWA "barium-" ; --UNCHK
lin barilla_N = mkWN "Halogeton" "souda" ; --UNCHK
lin baritone_A = mkWA "baritoni-" ; --UNCHK
lin baritone_N = mkWN (k5 "barytoni") ; --UNCHK
lin barium_N = mkWN (k5 "barium") ; --UNCHK
lin bark_N = L.bark_N ;
lin bark_V = mkWV (k69 "parkita") ; --UNCHK
lin bark_V2 = mkWV2 (k69 "parkita") ; --UNCHK
lin barker_N = mkWN (k5A "rakki") ; --UNCHK
lin barking_PN = foreignPN "Barking" ;
lin barky_A = mkWA (compoundA "kaarna" (k38 "mainen")) ; --UNCHK
lin barley_N = mkWN (k10 "ohra") ; --UNCHK
lin barley_water_N = mkWN (compoundN "ohra" (k27 "vesi")) ; --UNCHK
lin barleycorn_N = mkWN (k10 "ohra") ; --UNCHK
lin barm_N = mkWN (k9 "hiiva") ; --UNCHK
lin barmaid_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin barman_N = mkWN (k1A "baarimikko") ; --UNCHK
lin barmbrack_N = mkWN (k10A "leipä") ; --UNCHK
lin barmy_A = mkWA (k1 "pöllö") ; --UNCHK
lin barn_N = mkWN (k9A "aitta") ; --UNCHK
lin barn_door_N = mkWN (k7 "ovi") "ladon" | mkWN (k33 "varjostin") ; --UNCHK
lin barnacle_N = mkWN (compoundN "valkoposki" (k7 "hanhi")) ; --UNCHK
lin barnburner_N = mkWN (compoundN "jymy" (k39 "menestys")) ; --UNCHK
lin barnet_PN = foreignPN "Barnet" ;
lin barnful_N = mkWN "ladollinen" ; --UNCHK
lin barnoldswick_PN = foreignPN "Barnoldswick" ;
lin barnsley_PN = foreignPN "Barnsley" ;
lin barnstaple_PN = foreignPN "Barnstaple" ;
lin barnstorm_V = mkWV (k67 "olla") "vaalikiertueella" ; --UNCHK
lin barnstormer_N = mkWN (compoundN "taito" (k10 "lentäjä")) ; --UNCHK
lin barnyard_N = mkWN (k9 "piha") ; --UNCHK
lin barograph_N = mkWN "barografi" ; --UNCHK
lin barographic_A = mkWA "barografinen" ; --UNCHK
lin barometer_N = mkWN (k5 "barometri") ; --UNCHK
lin barometric_A = mkWA (compoundA "baro" (k38 "metrinen")) ; --UNCHK
lin baron_N = mkWN (k5 "moguli") ; --UNCHK
lin baronage_N = mkWN (compoundN "paroni" (k10A "kunta")) ; --UNCHK
lin baronduki_N = mkWN (k10 "orava") ; --UNCHK
lin baroness_N = mkWN (k32A "paronitar") ; --UNCHK
lin baronet_N = mkWN "baronetti" ; --UNCHK
lin baronetcy_N = mkWN (k1 "arvo") "baronetin" ; --UNCHK
lin barong_N = mkWN (k30 "veitsi") ; --UNCHK
lin baronial_A = mkWA (k41 "ylväs") ; --UNCHK
lin barony_N = mkWN (k1 "arvo") "paronin" ; --UNCHK
lin baroque_A = mkWA (compoundA "barokki" (k38 "tyylinen")) ; --UNCHK
lin baroque_N = mkWN (k9A "barokkiaika") ; --UNCHK
lin barosaur_N = mkWN "barosaurus" ; --UNCHK
lin barque_N = mkWN (kH1 "parkki") ; --UNCHK
lin barrack_N = mkWN (k5A "parakki") ; --UNCHK
lin barrack_V = mkWV (k67A "piikitellä") ; --UNCHK
lin barrack_V2 = mkWV2 (k67A "piikitellä") ; --UNCHK
lin barracking_N = mkWN (k39 "buuaus") ; --UNCHK
lin barracks_N = mkN "kasarmi" ;
lin barracouta_N = mkWN (k10 "barrakuda") ; --UNCHK
lin barracuda_N = mkWN (k10 "barrakuda") ; --UNCHK
lin barrage_N = mkWN (k39 "pommitus") ; --UNCHK
lin barramundi_N = mkWN "Lates" "calcarifer" ; --UNCHK
lin barranquilla_PN = foreignPN "Barranquilla" ;
lin barrator_N = mkWN (compoundN "meri" (k41A "varas")) ; --UNCHK
lin barratry_N = mkWN (k5A "käräjöinti") "tarpeeton" ; --UNCHK
lin barrel_N = mkN "tynnyri" ;
lin barreled_A = mkWA "tynnyreihin" "pakattu" ; --UNCHK
lin barrelfish_N = mkWN (k9 "kala") ; --UNCHK
lin barrelhouse_N = mkWN (k14A "kapakka") ; --UNCHK
lin barrels_N = mkWN (k6 "tynnyri") ; --UNCHK
lin barren_A = mkWA (k99 "ilman") ; --UNCHK
lin barren_N = mkWN (k18 "maa") "hedelmätön" ; --UNCHK
lin barrenness_N = mkWN (k40 "tuottamattomuus") ; --UNCHK
lin barrenwort_N = mkWN (compoundN "japaninvarjo" (k9A "hiippa")) ; --UNCHK
lin barrette_N = mkWN (compoundN "hius" (k7A "solki")) ; --UNCHK
lin barrhead_PN = foreignPN "Barrhead" ;
lin barricade_N = mkWN (k5 "barrikadi") ; --UNCHK
lin barricade_V2 = mkWV2 (k58A "sulkea") "esteellä" ; --UNCHK
lin barrier_N = mkN "este" ; --WN (k5 "puomi") ;
lin barring_N = mkWN (k99 "vastaan") "äänestäminen" ; --UNCHK
lin barrio_N = mkWN (compoundN "esi" (k5A "kaupunki")) ; --UNCHK
lin barrister_N = mkWN (compoundN "asian" (k10 "ajaja")) ; --UNCHK
lin barroom_N = mkWN (k13 "saluuna") ; --UNCHK
lin barry_PN = foreignPN "Barry" ;
lin bart_PN = foreignPN "Bart" ;
lin bartender_N = mkWN (k1A "baarimikko") ; --UNCHK
lin barter_N = mkWN (k1A "vaihto") ; --UNCHK
lin barter_V = mkWV (k71 "tehdä") "vaihtokauppa" ; --UNCHK
lin barter_V2 = mkWV2 (k71 "tehdä") "vaihtokauppa" ; --UNCHK
lin barterer_N = mkWN (compoundN "vaihtokaupan" (k12 "tekijä")) ; --UNCHK
lin bartlett_N = mkWN (k12 "päärynä") ; --UNCHK
lin bartonia_N = mkWN (compoundN "kulta" (k1 "tupsu")) ; --UNCHK
lin barycenter_N = mkWN "massakeskipiste" ; --UNCHK
lin barye_N = mkWN (k5 "mikrobaari") ; --UNCHK
lin baryon_N = mkWN (k5 "nukleoni") ; --UNCHK
lin baryta_N = mkWN "baryytti" ; --UNCHK
lin barytic_A = mkWA "baryyttinen" ; --UNCHK
lin bas_relief_N = mkWN (compoundN "koho" (k10 "kuva")) ; --UNCHK
lin basal_A = mkWA "tyvi-" ; --UNCHK
lin basalt_N = mkWN (k5A "basaltti") ; --UNCHK
lin basaltic_A = mkWA "basaltti-" ; --UNCHK
lin bascule_N = mkWN (compoundN "lasku" (k9A "salpa")) ; --UNCHK
lin base_A = mkWA (k10 "väärä") ; --UNCHK
lin base_N = mkN "perusta" | mkN "kanta" ;
lin base_V = mkV "pohjautua" ;
lin base_V2 = mkV2 "perustaa" ;
lin baseball_N = mkWN (k5 "baseball") ; --f60
lin baseboard_N = mkWN (compoundN "jalka" (k9 "lista")) ; --UNCHK
lin basel_PN = foreignPN "Basel" ;
lin baseless_A = mkWA (k10 "joutava") ; --UNCHK
lin baseline_N = mkWN (k9 "takaraja") ; --UNCHK
lin basement_N = mkN "pohjakerros" ; --WN (k6 "kellari") ;
lin baseness_N = mkWN (k40 "kurjuus") ; --UNCHK
lin basenji_N = mkWN (k6 "basenji") ; --UNCHK
lin bash_N = mkWN (k39 "täräys") ; --UNCHK
lin bash_V2 = mkWV2 (k64 "lyödä") ; --UNCHK
lin bashful_A = mkWA (k41A "pelokas") ; --UNCHK
lin basic_A = mkA "perustava" ; --WA (k38 "perimmäinen") ;
lin basic_N = mkWN "peruselintarvike" ; --UNCHK
lin basically_Adv = mkWAdv (k99 "sisimmältään") ; --UNCHK
lin basics_N = mkWN (k10 "pohja") ; --UNCHK
lin basidial_A = mkWA "itiökantaan" "liittyvä" ; --UNCHK
lin basidiocarp_N = mkWN (k26 "sieni") ; --UNCHK
lin basidiolichen_N = mkWN (k10 "jäkälä") "itiökantainen" ; --UNCHK
lin basidiomycete_N = mkWN (k26 "sieni") "itiökantainen" ; --UNCHK
lin basidiomycetous_A = mkWA (compoundA "itiö" (k38 "kantainen")) ; --UNCHK
lin basidiospore_N = mkWN (compoundN "kanta" (k3 "itiö")) ; --UNCHK
lin basidiosporous_A = mkWA "basidiosporinen" ; --UNCHK
lin basidium_N = mkWN (compoundN "itiö" (k9A "kanta")) ; --UNCHK
lin basil_N = mkWN (kH1 "basilika") ; --UNCHK
lin basilar_A = mkWA "tyveen" "liittyvä" ; --UNCHK
lin basildon_PN = foreignPN "Basildon" ;
lin basileus_N = mkWN (k41A "kuningas") ; --UNCHK
lin basilica_N = mkWN (kH1 "basilika") "Rooman" ; --UNCHK
lin basilican_A = mkWA "basilika-" ; --UNCHK
lin basilisk_N = mkWN "basiliski" ; --UNCHK
lin basin_N = mkWN (k10A "vuoka") ; --UNCHK
lin basinal_A = mkWA "vuoka-" ; --UNCHK
lin basined_A = mkWA (k10 "oleva") "vuoassa" ; --UNCHK
lin basinet_N = mkWN "basinetti" ; --UNCHK
lin basingstoke_PN = foreignPN "Basingstoke" ;
lin basipetal_A = mkWA "lehdellinen" ; --UNCHK
lin basis_N = mkN "perusta" ;
lin basiscopic_A = mkWA "tyvi-" ; --UNCHK
lin bask_V = mkWV (k67A "paistatella") ; --UNCHK
lin basket_N = mkWN (k5 "kori") ; --f55
lin basketball_N = mkWN (k39 "koris") ; --UNCHK
lin basketry_N = mkWN (compoundN "kori" (k19 "työ")) ; --UNCHK
lin basketweaver_N = mkWN (compoundN "korin" (k12 "tekijä")) ; --UNCHK
lin basophil_N = mkWN "basofiili" ; --UNCHK
lin basophilia_N = mkWN "basofilia" ; --UNCHK
lin basophilic_A = mkWA "basofiilinen" ; --UNCHK
lin bass_A = mkWA (k10 "tumma") ; --UNCHK
lin bass_N = mkWN (k32 "ahven") ; --UNCHK
lin bassarisk_N = mkWN (k39 "astutus") "Bassariscus" ; --UNCHK
lin bassine_N = mkWN (k1A "kuitu") ; --UNCHK
lin bassist_N = mkWN (k5 "basisti") ; --UNCHK
lin bassoon_N = mkWN (k5A "fagotti") ; --UNCHK
lin bassoonist_N = mkWN (k5 "fagotisti") ; --UNCHK
lin basswood_N = mkWN (k39 "lehmus") ; --UNCHK
lin bastard_N = mkWN (compoundN "seka" (k3 "sikiö")) ; --UNCHK
lin bastardization_N = mkWN "vääristyminen" ; --UNCHK
lin bastardize_V2 = mkWV2 (k53 "julistaa") "aviottomaksi" ; --UNCHK
lin bastardly_A = mkWA (k38 "viheliäinen") ; --UNCHK
lin bastardy_N = mkWN (compoundN "synty" (k10 "perä")) "avioton" ; --UNCHK
lin baste_N = mkWN "kursiminen" ; --UNCHK
lin baste_V2 = mkWV2 (k67 "valella") ; --UNCHK
lin bastille_N = mkWN (k12 "vankila") ; --UNCHK
lin bastinado_N = mkWN "jalkapohjien" "ruoskinta" ; --UNCHK
lin bastinado_V2 = mkWV2 (k61 "ruoskia") "jalkapohjia" ; --UNCHK
lin basting_N = mkWN (compoundN "vale" (k38 "leminen")) ; --UNCHK
lin bastion_N = mkWN (k5 "bastioni") ; --UNCHK
lin bastioned_A = mkWA (compoundA "linnoite" (k1 "ttu")) ; --UNCHK
lin bastnasite_N = mkWN "bastnäsiitti" ; --UNCHK
lin basuco_N = mkWN (compoundN "kokaiini" (k9 "suola")) ; --UNCHK
lin bat_N = mkN "maila" ; ---ARB --mkN "lepakko" ; --mkWN (k1 "vuoro") ;
lin bat_V = mkWV (k53A "rökittää") ; --UNCHK
lin bat_V2 = mkWV2 (k53A "rökittää") ; --UNCHK
lin batch_N = mkN "erä" ; --mkWN (k10 "ryhmä") ;
lin bate_V2 = mkWV2 (k73A "peitata") ; --UNCHK
lin batfish_N = mkWN "peikkokrotti" ; --UNCHK
lin bath_N = mkWN (k1A "kylpy") ; --UNCHK
lin bath_PN = foreignPN "Bath" ;
lin bath_chair_N = mkWN (compoundN "pyörä" (k5 "tuoli")) ; --UNCHK
lin bathe_N = mkWN (k5A "uinti") ; --UNCHK
lin bathe_V = mkWV (k52A "peseytyä") ; --UNCHK
lin bathe_V2 = mkWV2 (k52A "peseytyä") ; --UNCHK
lin bather_N = mkWN (k12 "kylpijä") ; --UNCHK
lin bathetic_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin bathgate_PN = foreignPN "Bathgate" ;
lin bathhouse_N = mkWN (k12 "kylpylä") ; --UNCHK
lin bathing_N = mkWN "peseytyminen" ; --UNCHK
lin bathing_cap_N = mkWN (compoundN "uima" (k5A "lakki")) ; --UNCHK
lin bathing_costume_N = mkWN (compoundN "uima" (k1A "puku")) ; --UNCHK
lin bathing_machine_N = mkWN (k5A "pukukoppi") ; --UNCHK
lin bathing_suit_N = mkWN (compoundN "uima" (k1A "puku")) ; --UNCHK
lin batholith_N = mkWN (k50 "syväkivilaji") ; --UNCHK
lin batholithic_A = mkWA "batoliittinen" ; --UNCHK
lin bathos_N = mkWN (compoundN "anti" (k5 "kliimaksi")) ; --UNCHK
lin bathrobe_N = mkWN (compoundN "kylpy" (k5A "takki")) ; --UNCHK
lin bathroom_N = mkWN (k99 "WC") ; --UNCHK
lin bathtub_N = mkWN (k41A "allas") ; --UNCHK
lin bathyal_A = mkWA (compoundA "batya" (k38 "alinen")) ; --UNCHK
lin bathymeter_N = mkWN (compoundN "syvyys" (k6 "mittari")) ; --UNCHK
lin bathymetric_A = mkWA "syvyysmittariin" "liittyvä" ; --UNCHK
lin bathymetry_N = mkWN (k39 "luotaus") ; --UNCHK
lin bathyscaphe_N = mkWN (compoundN "tutkimus" (k39 "alus")) "syvänmeren" ; --UNCHK
lin bathysphere_N = mkWN (compoundN "batysf" (k26 "ääri")) ; --UNCHK
lin batik_N = mkWN "batiikki" ; --UNCHK
lin batiste_N = mkWN (k5 "batisti") ; --UNCHK
lin batley_PN = foreignPN "Batley" ;
lin batman_N = mkWN (compoundN "sotilas" (k12 "palvelija")) ; --UNCHK
lin baton_N = mkWN (compoundN "tahti" (k1A "puikko")) ; --UNCHK
lin batrachomyomachia_N = mkWN (k9 "kiista") "hölmö" ; --UNCHK
lin bats_A = mkWA (k1 "pöllö") ; --UNCHK
lin batsman_N = mkWN (k10 "lyöjä") ; --UNCHK
lin battalion_N = mkWN (k10 "pataljoona") ; --UNCHK
lin batten_N = mkWN (k9 "piena") ; --UNCHK
lin batten_V = mkWV (k53A "listoittaa") ; --UNCHK
lin batten_V2 = mkWV2 (k53A "listoittaa") ; --UNCHK
lin batter_N = mkWN (k12 "taikina") ; --UNCHK
lin batter_V = mkWV (k71 "tehdä") "syvennys" ; --UNCHK
lin batter_V2 = mkV2 "mukiloida" ; --WV2 (k71 "tehdä") "syvennys" ;
lin battering_N = mkWN (compoundN "pahoin" (k2 "pitely")) ; --UNCHK
lin battery_1_N = mkWN (compoundN "pahoin" (k2 "pitely")) ; --UNCHK
lin battery_2_N = mkWN (compoundN "pahoin" (k2 "pitely")) ; --UNCHK
lin batting_N = mkWN (k5A "lyönti") ; --UNCHK
lin battle_N = mkN "taistelu" ;
lin battle_V = mkWV (k67 "taistella") ; --UNCHK
lin battle_V2 = mkV2 (mkV "taistella") (mkPrep "vastaan" partitive) ;
lin battle_cruiser_N = mkWN (compoundN "taistelu" (k12 "risteilijä")) ; --UNCHK
lin battledore_N = mkWN (compoundN "sulka" (k1 "pallo")) ; --UNCHK
lin battlefield_N = mkWN (k10A "kenttä") ; --UNCHK
lin battlefront_N = mkWN (k10 "rintama") ; --UNCHK
lin battleful_A = mkWA (k10 "sotaisa") ; --UNCHK
lin battleground_N = mkWN (k10A "kenttä") ; --UNCHK
lin battlement_N = mkWN (compoundN "rinta" (k39 "varustus")) ; --UNCHK
lin battlemented_A = mkWA (k38 "sakarainen") ; --UNCHK
lin battleship_N = mkWN (compoundN "taistelu" (k9 "laiva")) ; --UNCHK
lin battue_N = mkWN (compoundN "veri" (k1 "löyly")) ; --UNCHK
lin batty_A = mkWA (k1 "pöllö") ; --UNCHK
lin batwing_A = mkWA "lepakonsiipi-" ; --UNCHK
lin batwing_N = mkWN (compoundN "heiluri" (k7 "ovi")) ; --UNCHK
lin bauble_N = mkWN (k1 "koru") ; --UNCHK
lin baud_N = mkWN (k5 "baudi") ; --UNCHK
lin baulk_N = mkWN (compoundN "selkä" (k18 "puu")) ; --UNCHK
lin baulk_V = mkWV (k71 "tehdä") "tenä" ; --UNCHK
lin baulk_V2 = mkWV2 (k71 "tehdä") "tenä" ; --UNCHK
lin bauxite_N = mkWN (k5A "bauksiitti") ; --UNCHK
lin bauxitic_A = mkWA (compoundA "bauksiitti" (k38 "nen")) ; --UNCHK
lin bawbee_N = mkWN (k4A "kolikko") "puolen" "pennyn" ; --UNCHK
lin bawd_N = mkWN (k1A "lumppu") ; --UNCHK
lin bawdry_N = mkWN (k40 "säädyttömyys") ; --UNCHK
lin bawdy_A = mkWA (k34A "ruokoton") ; --UNCHK
lin bawdy_N = mkWN (k40 "säädyttömyys") ; --UNCHK
lin bawl_V = mkWV (k52 "karjua") ; --UNCHK
lin bawl_V2 = mkWV2 (k52 "karjua") ; --UNCHK
lin bawl_out_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin bawler_N = mkWN (compoundN "itku" (k5 "pilli")) ; --UNCHK
lin bay_A = mkWA (compoundA "puna" (k15 "ruskea")) ; --UNCHK
lin bay_N = mkWN (k4A "ruunikko") ; --UNCHK
lin bay_V = mkWV (k52 "ulvoa") ; --UNCHK
lin bay_wreath_N = mkWN (compoundN "laakeri" (k49 "seppele")) ; --UNCHK
lin baya_N = mkWN (compoundN "riisi" (k10 "kutoja")) ; --UNCHK
lin bayat_N = mkWN (compoundN "uskollisuuden" (k9 "vala")) ; --UNCHK
lin bayberry_N = mkWN (compoundN "suo" (k5A "myrtti")) ; --UNCHK
lin bayonet_V2 = mkWV2 (k53 "lävistää") "pistimellä" ; --UNCHK
lin bayou_N = mkWN (compoundN "suo" (k7 "järvi")) ; --UNCHK
lin bazooka_N = mkWN (k1A "sinko") ; --UNCHK
lin bbc_PN = mkPN "BBC" ;
lin bdellium_N = mkWN (compoundN "kumi" (k5 "hartsi")) "aromaattinen" ; --UNCHK
lin beach_N = mkWN (k9A "ranta") ; --UNCHK
lin beach_V2 = mkWV2 (k52A "rantautua") ; --UNCHK
lin beachcomber_N = mkWN (k42 "mies") "rantojen" ; --UNCHK
lin beachfront_N = mkWN (k9A "ranta") ; --UNCHK
lin beachhead_N = mkWN (compoundN "jalan" (k9 "sija")) ; --UNCHK
lin beacon_N = mkWN (k14A "majakka") ; --UNCHK
lin beacon_fire_N = mkWN (compoundN "merkki" (k1 "valo")) ; --UNCHK
lin beacon_light_N = mkWN (k14A "majakka") ; --UNCHK
lin beaconsfield_PN = foreignPN "Beaconsfield" ;
lin bead_N = mkWN (k7 "helmi") ; --UNCHK
lin beaded_A = mkWA (compoundA "pisar" (k10 "oiva")) ; --UNCHK
lin beading_N = mkWN (compoundN "helmi" (k48 "koriste")) ; --UNCHK
lin beadle_N = mkWN (k3 "suntio") ; --UNCHK
lin beads_N = mkWN (compoundN "helmi" (k9 "nauha")) ; --UNCHK
lin beadsman_N = mkWN (k12 "rukoilija") ; --UNCHK
lin beady_A = mkWA (compoundA "jalo" (k38 "kivikoristeinen")) ; --UNCHK
lin beagle_N = mkWN (k8 "beagle") ; --UNCHK
lin beagling_N = mkWN (compoundN "koira" (k39 "metsästys")) ; --UNCHK
lin beak_N = mkWN (k1 "kuono") ; --UNCHK
lin beaked_A = mkWA (k10 "terävä") ; --UNCHK
lin beaker_N = mkWN (compoundN "juoma" (k5 "lasi")) ; --UNCHK
lin beakless_A = mkWA "nokaton" ; --UNCHK
lin beaklike_A = mkWA (compoundA "nokka" (k38 "mainen")) ; --UNCHK
lin beam_N = mkWN (k5 "puomi") ; --UNCHK
lin beam_V = mkWV (k53 "loistaa") ; --UNCHK
lin beam_V2 = mkWV2 (k53 "loistaa") ; --UNCHK
lin beamish_A = mkWA (compoundA "hymy" (k38 "ileväinen")) ; --UNCHK
lin beamy_A = mkWA (k41A "kirkas") ; --UNCHK
lin bean_N = mkWN (k7A "päälaki") ; --UNCHK
lin beanbag_N = mkWN (compoundN "herne" (k5 "pussi")) ; --UNCHK
lin beanball_N = mkWN (compoundN "pää" (k1 "pallo")) ; --UNCHK
lin beanie_N = mkWN (k1 "pipo") ; --UNCHK
lin beano_N = mkWN (k1 "bingo") ; --UNCHK
lin beanstalk_N = mkWN (compoundN "pavun" (k28 "varsi")) ; --UNCHK
lin bear_N = mkN "karhu" ;
lin bear_V = mkV "kantaa" ;
lin bear_V2 = mkV2 "kantaa" | mkV2 "sietää" partitive ; ---- split
lin bear_down_on_V2 = mkWV2 (k53A "rasittaa") "painollaan" ; --UNCHK
lin bear_on_V2 = mkWV2 (k52A "liittyä") ; --UNCHK
lin bear_out_V2 = mkWV2 (k53A "kannattaa") ; --UNCHK
lin bear_up_V = mkWV (k52A "selviytyä") ; --UNCHK
lin bear_up_under_V2 = prepV2 (advV OP_bear_V OP_up_Adv ) OP_under_Prep ; -- guess-p-verb
lin bear_with_V2 = prepV2 OP_bear_V OP_with_Prep ; -- guess-p-verb
lin bearable_A = mkWA (k10 "siedettävä") ; --UNCHK
lin bearberry_N = mkWN (compoundN "sian" (k14A "puolukka")) ; --UNCHK
lin beard_N = mkWN (compoundN "kiinnitys" (k2 "rihmasto")) ; --UNCHK
lin beard_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin beardless_A = mkWA (k34A "parraton") ; --UNCHK
lin bearer_N = mkWN (k10 "kantaja") ; --UNCHK
lin bearing_N = mkWN (kH1 "laakeri") ; --UNCHK
lin bearish_A = mkWA (compoundA "lasku" (k38 "suuntainen")) ; --UNCHK
lin bearnaise_N = mkWN (compoundN "Béarnaise-" (k48A "kastike")) ; --UNCHK
lin bearsden_PN = foreignPN "Bearsden" ;
lin bearskin_N = mkWN (compoundN "karhunnahka" (k5A "lakki")) ; --UNCHK
lin beast_N = mkWN (k3 "olio") ; --UNCHK
lin beastliness_N = mkWN (k40 "kurjuus") ; --UNCHK
lin beastly_A = mkWA (k38 "petomainen") ; --UNCHK
lin beastly_Adv = mkWAdv (k99 "ilkeästi") | adjAdv beastly_A ; --UNCHK -- derived
lin beat_N = mkN "isku" ;
lin beat_V = mkWV (k52A "takoa") ;
lin beat_V2 = mkV2 "hakata" partitive | mkV2 "lyödä" partitive ;
lin beat_back_V = mkWV (k53A "tukahduttaa") ; --UNCHK
lin beat_down_V = mkWV (k61A "tinkiä") ; --UNCHK
lin beat_down_V2 = mkWV2 (k61A "tinkiä") ; --UNCHK
lin beat_out_V2 = mkWV2 (k53A "päihittää") ; --UNCHK
lin beat_up_V2 = mkWV2 (k74A "koota") ; --UNCHK
lin beatable_A = mkWA (k10 "oleva") "voitettavissa" ; --UNCHK
lin beaten_A = mkWA "taottu" ; --UNCHK
lin beater_N = mkWN (k12 "pahoinpitelijä") ; --UNCHK
lin beatific_A = mkWA (k10 "pyhä") ; --UNCHK
lin beatification_N = mkWN "beatifikaatio" ; --UNCHK
lin beatify_V2 = mkWV2 (k53 "julistaa") "autuaaksi" ; --UNCHK
lin beating_N = mkWN (k39 "löylytys") ; --UNCHK
lin beatnik_N = mkWN "beatnikki" ; --UNCHK
lin beatrice_PN = foreignPN "Beatrice" ;
lin beau_N = mkWN (k4A "nuorikko") ; --UNCHK
lin beaugregory_N = mkWN (k9 "kala") ; --UNCHK
lin beaujolais_N = mkWN "Beaujolais" ; --UNCHK
lin beaumaris_PN = foreignPN "Beaumaris" ;
lin beauteous_A = mkWA (k41 "kaunis") ; --UNCHK
lin beautician_N = mkWN (k5 "kosmetologi") ; --UNCHK
lin beautification_N = mkWN (compoundN "kaunis" (k38 "taminen")) ; --UNCHK
lin beautiful_A = L.beautiful_A ;
lin beautify_V2 = mkWV2 (k67 "kaunistella") ; --UNCHK
lin beauty_N = mkWN (k40 "kauneus") ; --UNCHK
lin beauty_parlour_N = mkWN (k5A "salonki") ; --UNCHK
lin beauty_salon_N = mkWN (k5A "salonki") ; --UNCHK
lin beauty_spot_N = mkWN (compoundN "kauneus" (k1A "pilkku")) ; --UNCHK
lin beaver_N = mkWN (k10 "majava") ; --UNCHK
lin beaver_V = mkWV (k53 "uurastaa") ; --UNCHK
lin beaver_away_V = mkWV (k53 "uurastaa") ; --UNCHK
lin bebington_PN = foreignPN "Bebington" ;
lin becalmed_A = mkWA "tyveneen" "joutunut" ; --UNCHK
lin because_Subj = S.because_Subj ;
lin because_of_Prep = mkPrep "vuoksi" ;
lin beccles_PN = foreignPN "Beccles" ;
lin beck_N = mkWN (k39 "viittaus") ; --UNCHK
lin becket_N = mkWN (k5A "lenkki") ; --UNCHK
lin beckon_V = mkWV (k53A "vilkuttaa") ; --UNCHK
lin beckon_V2 = mkWV2 (k53A "vilkuttaa") ; --UNCHK
lin become_V = caseV elative (mkV "tulla") ; --hänestä tuli
lin become_V2 = mkV2 "tulla" translative ;
lin become_VA = L.become_VA ;
lin becomingly_Adv = mkWAdv (k99 "säädyllisesti") ; --UNCHK
lin becomingness_N = mkWN (k40 "säädyllisyys") ; --UNCHK
lin bed_N = mkN "sänky" | mkN "vuode" ;
lin bed_V2 = mkWV2 (k67 "mennä") "sänkyyn" ; --UNCHK
lin bed_down_V = mkWV (k65 "käydä") "makuulle" ; --UNCHK
lin bedaubed_A = mkWA "töhritty" ; --UNCHK
lin bedbug_N = mkWN (k14A "lutikka") ; --UNCHK
lin beddau_PN = foreignPN "Beddau" ;
lin bedder_N = mkWN (k5 "kasvi") "yksivuotinen" ; --UNCHK
lin bedevil_V2 = mkWV2 (k53A "hämmästyttää") ; --UNCHK
lin bedevilment_N = mkWN (k9 "piina") ; --UNCHK
lin bedewed_A = mkWA (k38 "kasteinen") ; --UNCHK
lin bedfast_A = mkWA (compoundA "vuoteen" (k10 "oma")) ; --UNCHK
lin bedfellow_N = mkWN (compoundN "vuode" (k6 "toveri")) ; --UNCHK
lin bedford_PN = foreignPN "Bedford" ;
lin bedlam_N = mkWN (k3 "sanatorio") ; --UNCHK
lin bedlamite_N = mkWN (compoundN "mieli" (k26 "puoli")) ; --UNCHK
lin bedless_A = mkWA "vuoteeton" ; --UNCHK
lin bedlington_PN = foreignPN "Bedlington" ;
lin bedouin_N = mkWN (k5 "beduiini") ; --UNCHK
lin bedpan_N = mkWN (compoundN "alus" (k12 "astia")) ; --UNCHK
lin bedpost_N = mkWN (compoundN "sängyn" (k41 "pylväs")) ; --UNCHK
lin bedraggled_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin bedrest_N = mkWN (compoundN "vuode" (k1A "lepo")) ; --UNCHK
lin bedridden_A = mkWA (compoundA "vuoteen" (k10 "oma")) ; --UNCHK
lin bedrock_N = mkWN (k10 "pohja") ; --UNCHK
lin bedroll_N = mkWN (compoundN "makuu" (k5 "pussi")) ; --UNCHK
lin bedroom_N = mkWN (k6 "kamari") ; --UNCHK
lin bedside_N = mkWN (k26 "vieri") "vuoteen" ; --UNCHK
lin bedsit_N = mkWN (k3 "yksiö") ; --UNCHK
lin bedsitter_N = mkWN (k3 "yksiö") ; --UNCHK
lin bedsitting_room_N = mkWN (k3 "yksiö") ; --UNCHK
lin bedsore_N = mkWN (k9 "makuuhaava") ; --UNCHK
lin bedspread_N = mkWN (k48A "peite") ; --UNCHK
lin bedstead_N = mkWN (k1A "runko") "sängyn" ; --UNCHK
lin bedstraw_N = mkWN (k13 "matara") ; --UNCHK
lin bedtime_N = mkWN (k9A "nukkumaanmenoaika") ; --UNCHK
lin bedwas_PN = foreignPN "Bedwas" ;
lin bedwetter_N = mkWN "yökastelija" ; --UNCHK
lin bee_N = mkWN (k38 "mehiläinen") ; --UNCHK
lin beebread_N = mkWN (compoundN "mehiläis" (k10A "leipä")) ; --UNCHK
lin beech_N = mkWN (k5A "pyökki") ; --UNCHK
lin beechen_A = mkWA (compoundA "pyökki" (k38 "puinen")) ; --UNCHK
lin beechnut_N = mkWN (k1 "terho") "pyökin" ; --UNCHK
lin beef_1_N = mkWN (compoundN "liha" (k9 "karja")) ; --UNCHK
lin beef_2_N = mkWN (compoundN "liha" (k9 "karja")) ; --UNCHK
lin beef_V = mkWV (k53A "valittaa") ;
lin beef_up_V2 = mkWV2 (k53 "voimistaa") ; --UNCHK
lin beefeater_N = mkWN (k12 "vartija") ; --UNCHK
lin beefsteak_N = mkWN (k5 "pihvi") ; --UNCHK
lin beefwood_N = mkWN "Grevillea" "striata" ; --UNCHK
lin beefy_A = mkWA (k9 "vahva") ; --UNCHK
lin beehive_N = mkWN (compoundN "mehiläis" (k10 "pesä")) ; --UNCHK
lin beekeeper_N = mkWN (compoundN "mehiläis" (k10 "hoitaja")) ; --UNCHK
lin beekeeping_N = mkWN (k1A "hoito") "mehiläisten" ; --UNCHK
lin beeline_N = mkWN (k19 "tie") "suorin" ; --UNCHK
lin beep_N = mkWN (k39 "piipitys") ; --UNCHK
lin beeper_N = mkWN (compoundN "henkilöhaku" (k48A "laite")) ; --UNCHK
lin beer_N = L.beer_N ;
lin beery_A = mkWA (compoundA "oluen" (k38 "huuruinen")) ; --UNCHK
lin beeswax_N = mkWN (compoundN "mehiläis" (k9 "vaha")) ; --UNCHK
lin beeswax_V2 = mkWV2 (k73 "vahata") "mehiläisvahalla" ; --UNCHK
lin beet_N = mkWN (k26 "punajuuri") ; --UNCHK
lin beetle_A = mkWA (k15 "tuuhea") ; --UNCHK
lin beetle_N = mkWN (k38 "kuoriainen") ; --UNCHK
lin beetle_V = mkWV (k52 "survoa") ; --UNCHK
lin beetroot_N = mkWN (k26 "punajuuri") ; --UNCHK
lin befall_V = mkWV (k73A "kohdata") "jotakuta" ; --UNCHK
lin befall_V2 = mkWV2 (k73A "kohdata") "jotakuta" ; --UNCHK
lin befit_V2 = mkWV2 (k58A "pukea") ; --UNCHK
lin befitting_A = mkWA (k41 "sovelias") ; --UNCHK
lin befogged_A = mkWA (k10 "sekava") ; --UNCHK
lin before_Adv = mkAdv "ennen" ;
lin before_Prep = S.before_Prep ;
lin before_Subj = lin Subj (ss "ennen kuin") ;
lin beforehand_Adv = mkWAdv (k99 "etukäteen") ; --UNCHK
lin befoul_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin befoulment_N = mkWN (k2 "häpäisy") ; --UNCHK
lin beg_V = mkWV (k54A "pyytää") ; --UNCHK
lin beg_V2 = mkWV2 (k54A "pyytää") ; --UNCHK
lin beg_V2V = L.beg_V2V ;
lin beget_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin begetter_N = mkWN (k10 "siittäjä") ; --UNCHK
lin beggar_N = mkWN (k38 "kerjäläinen") ; --UNCHK
lin beggarly_A = mkWA (k10 "katala") ; --UNCHK
lin beggarman_N = mkWN (compoundN "mies" (k38 "kerjäläinen")) ; --UNCHK
lin beggarweed_N = mkWN (compoundN "lennätin" (k5 "kasvi")) ; --UNCHK
lin beggarwoman_N = mkWN (compoundN "nais" (k38 "kerjäläinen")) ; --UNCHK
lin beggary_N = mkWN (k40 "kerjäläisyys") ; --UNCHK
lin begin_V = mkV "alkaa" "alkoi" ;
lin begin_V2 = mkV2 "aloittaa" ;
lin begin_VV = mkVV (mkV "alkaa" "alkoi") ;
lin begin_ing_VV = mkVV (mkV "alkaa" "alkoi") ;
lin begin_to_VV = mkVV (mkV "alkaa" "alkoi") ;
lin begin_with_V = mkV "alkaa" "alkoi" ;
lin beginner_N = mkWN (k10 "aloittelija") ; --UNCHK
lin beginning_N = mkN "alku" ; ---- END checked AR
lin begonia_N = mkWN (k12 "begonia") ; --UNCHK
lin begrimed_A = mkWA (k34A "siivoton") ; --UNCHK
lin begrudge_V2 = mkWV2 (k67 "olla") "pahoillaan" ; --UNCHK
lin beguile_V2 = mkWV2 (k53A "petkuttaa") ; --UNCHK
lin beguilement_N = mkWN (k39 "huvitus") ; --UNCHK
lin beguiling_A = mkWA (k10 "valloittava") ; --UNCHK
lin beguine_N = mkWN (k8 "beguine") ; --UNCHK
lin begum_N = mkWN (k38 "nainen") "korkea-arvoinen" ; --UNCHK
lin behalf_N = mkWN (k99 "puolesta") ; --UNCHK
lin behave_V = mkWV (k67A "menetellä") ; --UNCHK
lin behavior_N = mkWN (k9A "toiminta") ; --UNCHK
lin behavioral_A = mkWA "käytös-" ; --UNCHK
lin behaviorism_N = mkWN (k12 "psykologia") "behavioristinen" ; --UNCHK
lin behaviorist_N = mkWN (k5 "behavioristi") ; --UNCHK
lin behavioristic_A = mkWA (k38 "behavioristinen") ; --UNCHK
lin behaviour_N = mkN "käyttäytyminen" | mkN "käytös" ; ---- split
lin behaviourism_N = mkWN (k12 "psykologia") "behavioristinen" ; --UNCHK
lin behaviourist_N = mkWN (k5 "behavioristi") ; --UNCHK
lin behest_N = mkWN (k1 "käsky") ; --UNCHK
lin behind_Adv = mkWAdv (k99 "takana") ; --UNCHK
lin behind_N = mkWN (k1 "takalisto") ; --UNCHK
lin behind_Prep = S.behind_Prep ;
lin behindhand_A = mkWA (k99 "myöhässä") ; --UNCHK
lin behold_V2 = mkWV2 (k71 "nähdä") ; --UNCHK
lin beholden_A = mkWA (compoundA "kiitollisuuden" (k38 "velkainen")) ; --UNCHK
lin beholder_N = mkWN (k10 "havainnoija") ; --UNCHK
lin behove_V2 = mkWV2 (k67 "olla") "velvollisuus" ; --UNCHK
lin beige_A = mkWA (k8 "beige") ; --UNCHK
lin beige_N = mkWN (k34A "valkaisematon") ; --UNCHK
lin beijing_PN = mkPN "Beijing" ;
lin being_A = mkA "oleva" ;
lin being_N = mkWN (k1A "olento") ; --UNCHK
lin beirut_PN = foreignPN "Beirut" ;
lin beith_PN = foreignPN "Beith" ;
lin belabour_V2 = mkWV2 (k52A "haukkua") ; --UNCHK
lin belated_A = mkWA (k99 "myöhässä") ; --UNCHK
lin belay_N = mkWN (k9 "vaarna") ; --UNCHK
lin belay_V2 = mkWV2 (k53A "kiinnittää") "vene" ; --UNCHK
lin belaying_pin_N = mkWN (k9 "vaarna") ; --UNCHK
lin belch_N = mkWN (k2 "röyhtäily") ; --UNCHK
lin belch_V = mkWV (k66 "röyhtäistä") ; --UNCHK
lin belch_V2 = mkWV2 (k66 "röyhtäistä") ; --UNCHK
lin belching_N = mkWN (k2 "röyhtäily") ; --UNCHK
lin beldam_N = mkWN (k1A "harppu") ; --UNCHK
lin beldame_N = mkWN (k1A "harppu") ; --UNCHK
lin beleaguer_V2 = mkWV2 (k53A "motittaa") ; --UNCHK
lin belemnite_N = mkWN (compoundN "belem" (k5A "niitti")) ; --UNCHK
lin belemnitic_A = mkWA "belemniittinen" ; --UNCHK
lin belfast_PN = foreignPN "Belfast" ;
lin belfry_N = mkWN (compoundN "kello" (k5 "torni")) ; --UNCHK
lin belgian_A = mkA "belgialainen" ;
lin belgian_N = mkWN (compoundN "belgi" (k38 "alainen")) ; --UNCHK
lin belgium_PN = foreignPN "Belgia" ;
lin belgrade_PN = foreignPN "Belgrad" ;
lin belie_V2 = mkV2 (mkV vOlla "ristiriidassa") (mkPrep "kanssa") ;
lin belief_N = mkWN (k48A "mielipide") ; --UNCHK
lin believable_A = mkWA (k10 "uskottava") ; --UNCHK
lin believe_V = mkV "uskoa" ;
lin believe_V2 = mkV2 "uskoa" illative ;
lin believe_VS = mkVS (mkV "uskoa") ;
lin believer_N = mkWN (k38 "uskovainen") ; --UNCHK
lin believing_N = mkWN (compoundN "usko" (k38 "minen")) ; --UNCHK
lin belike_Adv = mkWAdv (k99 "kaiketi") ; --UNCHK
lin belittle_V2 = mkWV2 (k52 "väheksyä") ; --UNCHK
lin belittling_A = mkWA (compoundA "halveks" (k9 "iva")) ; --UNCHK
lin belittling_N = mkWN (compoundN "ali" (k38 "arvioiminen")) ; --UNCHK
lin bell_N = mkN "soittokello" ; --WN (k1A "tiuku") ;
lin bell_V2 = mkWV2 (k56A "laittaa") "kello" ; --UNCHK
lin bell_buoy_N = mkWN (compoundN "kello" (k1 "poiju")) ; --UNCHK
lin bell_founder_N = mkWN (compoundN "kellon" (k10 "valaja")) ; --UNCHK
lin bell_foundry_N = mkWN (compoundN "kello" (k2 "valimo")) ; --UNCHK
lin bell_metal_N = mkWN (compoundN "kello" (k5 "metalli")) ; --UNCHK
lin bell_push_N = mkWN (compoundN "soitto" (k5A "nappi")) ; --UNCHK
lin bell_ringer_N = mkWN (k39 "menestys") ; --UNCHK
lin bell_tent_N = mkWN (compoundN "kupoli" (k9A "teltta")) ; --UNCHK
lin bella_PN = foreignPN "Bella" ;
lin belladonna_N = mkWN (k10 "belladonna") ; --UNCHK
lin bellarmine_N = mkWN (k1 "kannu") ; --UNCHK
lin bellbird_N = mkWN "etelänseppäkotinga" ; --UNCHK
lin bellboy_N = mkWN (k2 "pikkolo") ; --UNCHK
lin belle_N = mkWN (k32A "kaunotar") ; --UNCHK
lin belle_PN = foreignPN "Belle" ;
lin belletristic_A = mkWA (compoundA "kauno" (k38 "kirjallinen")) ; --UNCHK
lin bellhop_N = mkWN (k2 "pikkolo") ; --UNCHK
lin bellicose_A = mkWA (k10 "sotaisa") ; --UNCHK
lin bellicosity_N = mkWN (k40 "sotaisuus") ; --UNCHK
lin belligerence_N = mkWN (k40 "sotaisuus") ; --UNCHK
lin belligerency_N = mkWN (compoundN "vihamiel" (k40 "isyys")) ; --UNCHK
lin belligerent_A = mkWA (k10 "riitaisa") ; --UNCHK
lin belligerent_N = mkWN (k12 "ottelija") ; --UNCHK
lin bellow_N = mkWN (k9A "ärjyntä") ; --UNCHK
lin bellow_V = mkWV (k66 "ölistä") ; --UNCHK
lin bellow_V2 = mkWV2 (k66 "ölistä") ; --UNCHK
lin bellpull_N = mkWN (k33A "vedin") ; --UNCHK
lin bellshill_PN = foreignPN "Bellshill" ;
lin bellwether_N = mkWN (k41A "kellokas") ; --UNCHK
lin bellwort_N = mkWN (compoundN "kello" (k10A "kukka")) ; --UNCHK
lin belly_N = L.belly_N ;
lin belly_V = mkWV (k52 "pullistua") ; --UNCHK
lin belly_V2 = mkWV2 (k52 "pullistua") ; --UNCHK
lin bellyache_N = mkWN (compoundN "vatsa" (k1A "kipu")) ; --UNCHK
lin bellyache_V = mkWV (k53A "valittaa") ; --UNCHK
lin bellyband_N = mkWN (compoundN "maha" (k19 "vyö")) ; --UNCHK
lin bellylaugh_V = mkWV (compoundV "hörö" (k56 "nauraa")) ; --UNCHK
lin bellyless_A = mkWA (compoundA "litteä" (k38 "vatsainen")) ; --UNCHK
lin belo_horizonte_PN = foreignPN "Belo Horizonte" ;
lin belong_to_V2 = mkWV2 (k52 "kuulua") ; --UNCHK
lin belonging_N = mkWN (compoundN "yhteen" (k40 "kuuluvuus")) ; --UNCHK
lin beloved_A = mkWA (k1A "rakastettu") ; --UNCHK
lin beloved_N = mkWN (k1A "rakastettu") ; --UNCHK
lin below_Adv = mkAdv "alapuolella" ;
lin below_Prep = mkPrep "alapuolella" ;
lin belowground_A = mkWA (k99 "alta") "maan" ; --UNCHK
lin belper_PN = foreignPN "Belper" ;
lin belt_N = mkWN (k39 "läimäys") ; --UNCHK
lin belt_V2 = mkWV2 (k53A "vyöttää") ; --UNCHK
lin belt_out_V2 = mkWV2 (k56 "laulaa") ; --UNCHK
lin belt_up_V = mkWV (k72 "hiljetä") ; --UNCHK
lin belting_N = mkWN (compoundN "hihna" (k5 "materiaali")) ; --UNCHK
lin beltlike_A = mkWA (compoundA "vyö" (k38 "mäinen")) ; --UNCHK
lin beltway_N = mkWN (compoundN "ohikulku" (k19 "tie")) ; --UNCHK
lin beluga_N = mkWN (compoundN "maito" (k41 "valas")) ; --UNCHK
lin belvedere_N = mkWN (compoundN "näkö" (k5 "torni")) ; --UNCHK
lin bemoan_V2 = mkWV2 (k58 "itkeä") ; --UNCHK
lin bemused_A = mkWA (k10 "oleva") "pihalla" ; --UNCHK
lin ben_N = mkWN (kH1 "vuori") ; --UNCHK
lin bench_N = mkWN (k5A "penkki") ; --UNCHK
lin benchmark_N = mkWN (compoundN "kiinto" (k48 "piste")) ; --UNCHK
lin bend_N = mkWN (k5 "kurvi") ; --UNCHK
lin bend_V = mkWV (k54A "vääntää") "mutkalle" ; --UNCHK
lin bend_V2 = mkWV2 (k54A "vääntää") "mutkalle" ; --UNCHK
lin bend_down_V = advV OP_bend_V OP_down_Adv ; -- guess-p-verb
lin bend_over_V = advV OP_bend_V OP_over_Adv ; -- guess-p-verb
lin bend_over_backwards_V = mkWV (k71 "tehdä") "kaikkensa" ; --UNCHK
lin bendability_N = mkWN (k40 "taipuisuus") ; --UNCHK
lin bendable_A = mkWA (k15 "notkea") ; --UNCHK
lin bender_N = mkWN (k48A "kierre") ; --UNCHK
lin bending_N = mkWN (compoundN "tai" (k38 "vuttaminen")) ; --UNCHK
lin beneath_Adv = mkWAdv (k99 "alle") ; --UNCHK
lin beneath_Prep = mkPrep "alapuolella" ;
lin benedick_N = mkWN (compoundN "avio" (k42 "mies")) ; --UNCHK
lin benedictine_A = mkWA (compoundA "benediktiini" (k38 "läinen")) ; --UNCHK
lin benedictine_N = mkWN (compoundN "munkki" (k6 "likööri")) ; --UNCHK
lin benediction_N = mkWN (k39 "siunaus") ; --UNCHK
lin benedictory_A = mkWA (k38 "siunauksellinen") ; --UNCHK
lin benefaction_N = mkWN (k39 "lahjoitus") ; --UNCHK
lin benefactor_N = mkWN (k10 "lahjoittaja") ; --UNCHK
lin benefactress_N = mkWN (compoundN "hyvän" (k12 "tekijä")) ; --UNCHK
lin benefic_A = mkWA (k10 "suotuisa") ; --UNCHK
lin benefice_N = mkWN (compoundN "kirkkoherran" (k9A "virka")) ; --UNCHK
lin beneficed_A = mkWA (k10 "toimiva") "papinvirassa" ; --UNCHK
lin beneficence_N = mkWN (compoundN "hyväsydäm" (k40 "isyys")) ; --UNCHK
lin beneficent_A = mkWA (k10 "suotuisa") ; --UNCHK
lin beneficial_A = mkWA (k38 "hyödyllinen") ; --UNCHK
lin beneficiary_A = mkWA (compoundA "eduns" (k9 "aava")) ; --UNCHK
lin beneficiary_N = mkWN (compoundN "testamentin" (k10 "saaja")) ; --UNCHK
lin benefit_N = mkWN (k1A "hyöty") ;
lin benefit_V = mkV "hyötyä" ;
lin benefit_V2 = mkV2 "hyödyttää" partitive ;
lin benevolence_N = mkWN (k39 "lahjoitus") ; --UNCHK
lin benevolent_A = mkWA (compoundA "hyväntah" (k38 "toinen")) ; --UNCHK
lin bengali_A = mkWA (compoundA "bengali" (k38 "lainen")) ; --UNCHK
lin benighted_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin benign_A = mkA "hyväntahtoinen" ; --mkWA (k10 "tekevä") "hyvää" ;
lin benignant_A = mkWA (k10 "tekevä") "hyvää" ; --UNCHK
lin benignity_N = mkWN (k1A "teko") "hyväntahtoinen" ; --UNCHK
lin benin_PN = foreignPN "Benin" ;
lin beninese_A = mkWA "beniniläinen" ; --UNCHK
lin beninese_N = mkWN "beniniläinen" ; --UNCHK
lin benison_N = mkWN (k39 "siunaus") ; --UNCHK
lin benjamin_PN = foreignPN "Benjamin" ;
lin bennet_N = mkWN (compoundN "kanadan" (k14A "kellukka")) ; --UNCHK
lin bennäs_PN = mkPN "Bennäs" ;
lin bent_A = mkWA (k38 "lommoinen") ; --UNCHK
lin bent_N = mkWN (k1A "taito") ; --UNCHK
lin benthos_N = mkWN (compoundN "pohja" (k1 "eliöstö")) ; --UNCHK
lin bentonite_N = mkWN (compoundN "bento" (k5A "niitti")) ; --UNCHK
lin bentonitic_A = mkWA "bentoniittinen" ; --UNCHK
lin bentwood_N = mkWN (k18 "puu") "taivutettu" ; --UNCHK
lin benzedrine_N = mkWN (k5 "amfetamiini") ; --UNCHK
lin benzene_N = mkWN (k6 "bensiini") ; --UNCHK
lin benzenoid_A = mkWA (compoundA "bentseeni" (k38 "rakenteinen")) ; --UNCHK
lin benzine_N = mkWN (k6 "bensiini") ; --UNCHK
lin benzoate_N = mkWN "bentsoaatti" ; --UNCHK
lin benzocaine_N = mkWN "benzokaiini" ; --UNCHK
lin benzodiazepine_N = mkWN "bentsodiatsepiini" ; --UNCHK
lin benzofuran_N = mkWN (compoundN "bentsofu" (k5 "raani")) ; --UNCHK
lin benzoic_A = mkWA "bentsyyli-" ; --UNCHK
lin benzoin_N = mkWN "suku" "Benzoin" ; --UNCHK
lin benzol_N = mkWN (k6 "bensiini") ; --UNCHK
lin benzyl_N = mkWN (compoundN "bentsyyli" (k5 "radikaali")) ; --UNCHK
lin benzylic_A = mkWA (compoundA "bentsy" (k38 "ylinen")) ; --UNCHK
lin bequeath_V2 = mkWV2 (k53A "jättää") "perinnöksi" ;
lin bequest_N = mkWN (k5A "testamentti") ; --UNCHK
lin berate_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin berating_N = mkWN (compoundN "hauk" (k38 "kuminen")) ; --UNCHK
lin bereave_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin bereaved_N = mkWN (k38 "omainen") "sureva" ; --UNCHK
lin bereavement_N = mkWN (k39 "menetys") ; --UNCHK
lin bereft_A = mkWA (k38 "surullinen") ; --UNCHK
lin beret_N = mkWN (k6 "baskeri") ; --UNCHK
lin berg_N = mkWN (k26 "jäävuori") ; --UNCHK
lin bergamo_PN = foreignPN "Bergamo" ;
lin bergamot_N = mkWN (compoundN "väri" (k1A "minttu")) ; --UNCHK
lin bergen_PN = foreignPN "Bergen" ;
lin bergenia_N = mkWN (compoundN "vuoren" (k7A "kilpi")) ; --UNCHK
lin berk_N = mkWN (k3 "ääliö") ; --UNCHK
lin berkelium_N = mkWN "järjestysluku" "97" ; --UNCHK
lin berkhamsted_PN = foreignPN "Berkhamsted" ;
lin berlin_N = mkWN (k5 "limusiini") ; --UNCHK
lin berlin_PN = mkPN "Berliini" ;
lin berm_N = mkWN (k49A "piennar") ; --UNCHK
lin bermuda_PN = foreignPN "Bermuda" ;
lin bermudan_A = mkWA (compoundA "bermud" (k38 "alainen")) ; --UNCHK
lin bermudan_N = mkWN (compoundN "bermud" (k38 "alainen")) ; --UNCHK
lin bern_PN = foreignPN "Bern" ;
lin bernie_PN = foreignPN "Bernie" ;
lin beroe_N = mkWN "beroe" ; --UNCHK
lin berried_A = mkWA (k38 "marjainen") ; --UNCHK
lin berry_N = mkWN (k9 "marja") ; --UNCHK
lin berserk_A = mkWA (k1 "hullu") ; --UNCHK
lin berserker_N = mkWN (k1 "hullu") ; --UNCHK
lin berth_N = mkWN (k10 "tehtävä") ; --UNCHK
lin berth_V = mkWV (k52A "kiinnittyä") ; --UNCHK
lin berth_V2 = mkWV2 (k52A "kiinnittyä") ; --UNCHK
lin beryl_N = mkWN (k5 "berylli") ; --UNCHK
lin beryllium_N = mkWN (k5 "beryllium") ; --UNCHK
lin beseech_V2 = mkWV2 (k74A "vedota") ; --UNCHK
lin beseeching_A = mkWA "aneleva" ; --UNCHK
lin beseem_V2 = mkWV2 (k58A "pukea") ; --UNCHK
lin beset_V2 = mkV2 "vaivata" ; ---ARB
lin beshrew_V2 = mkWV2 (k74 "kirota") ; --UNCHK
lin beside_Prep = mkPrep "vieressä" ;
lin besides_Adv = mkWAdv (k99 "toisekseen") ; --UNCHK
lin besides_Prep = mkPrep "rinnalla" ;
lin besiege_V2 = mkV2 "piirittää" partitive ; --mkWV2 (k53A "pommittaa") "kysymyksillä" ;
lin besieger_N = mkWN (k10 "piirittäjä") ; --UNCHK
lin besmear_V2 = mkWV2 (k61 "tuhria") ; --UNCHK
lin besmirch_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin besom_N = mkWN (k10A "luuta") ; --UNCHK
lin besotted_A = mkWA (k10 "oleva") "tillin-tallin" ; --UNCHK
lin bespeak_V2 = mkWV2 (k52 "anoa") ; --UNCHK
lin bespectacled_A = mkWA (compoundA "silmä" (k38 "lasipäinen")) ; --UNCHK
lin bespoke_A = mkWA (compoundA "tek" (k10 "emä")) "räätälin" ; --UNCHK
lin besprent_A = mkWA "ripoteltu" ; --UNCHK
lin best_Adv = mkWAdv (k99 "parhaiten") ;
lin best_V2 = mkWV2 (k58 "kytkeä") ; --UNCHK
lin best_seller_N = mkWN (k6 "bestseller") ; --UNCHK
lin bestial_A = mkWA (k38 "petomainen") ; --UNCHK
lin bestiary_N = mkWN (compoundN "eläin" (k9 "kirja")) ; --UNCHK
lin bestir_V2 = mkWV2 (k73 "herätä") ; --UNCHK
lin bestow_V2 = mkWV2 (k64 "suoda") ; --UNCHK
lin bestowal_N = mkWN "lahjoittaminen" ; --UNCHK
lin bestrew_V2 = mkWV2 (k67A "sirotella") ; --UNCHK
lin bestride_V2 = mkWV2 (k73A "harpata") ; --UNCHK
lin bestubbled_A = mkWA (compoundA "sän" (k38 "kinen")) ; --UNCHK
lin bet_N = mkN "vedon" (mkN "lyönti") ;
lin bet_V = mkV (mkV "lyödä") "vetoa" ; --mkWV (k73 "nojata") ;
lin bet_V2 = mkWV2 (k73 "nojata") ; --UNCHK
lin bet_VS = mkWVS (k73 "nojata") ; --UNCHK
lin beta_A = mkWA "beeta-" ; --UNCHK
lin beta_N = mkWN (k9 "beeta") ; --UNCHK
lin betaine_N = mkWN "betaiini" ; --UNCHK
lin betatron_N = mkWN (compoundN "elektroni" (k1A "linko")) ; --UNCHK
lin bete_noire_N = mkWN (k2 "henkilö") "kirottu" ; --UNCHK
lin betel_N = mkWN "Piper" "betel" ; --UNCHK
lin betel_nut_N = mkWN (compoundN "beetel" (k12 "pähkinä")) ; --UNCHK
lin bethel_N = mkWN (k1A "kirkko") ; --UNCHK
lin bethink_V2 = mkWV2 (k61A "miettiä") "jtak" ; --UNCHK
lin betide_V2 = mkWV2 (k52A "tapahtua") ; --UNCHK
lin betimes_Adv = mkWAdv (k99 "ajoissa") ; --UNCHK
lin betoken_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin betray_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin betrayal_N = mkWN (k39 "petos") ; --UNCHK
lin betrayer_N = mkWN (k10 "kavaltaja") ; --UNCHK
lin betroth_V2 = mkWV2 (k52A "kihlautua") ; --UNCHK
lin betrothal_N = mkWN (k39 "kihlaus") ; --UNCHK
lin betrothedFem_N = mkWN (k1A "kihlattu") ; --UNCHK ---- sense to be split
lin betrothedMasc_N = mkWN (k1A "kihlattu") ; --UNCHK ---- sense to be split
lin betrothed_N = mkWN (k1A "kihlattu") ; --UNCHK
lin better_A = mkWA (k16A "parempi") ; --UNCHK
lin better_Adv = mkAdv "paremmin" ;
lin better_V2 = mkWV2 (k52A "parantua") ; --UNCHK
lin bettering_A = mkWA "paremmaksi" "muuttuva" ; --UNCHK
lin betterment_N = mkWN (k39 "parannus") ; --UNCHK
lin bettong_N = mkWN (compoundN "rotta" (k2 "kenguru")) ; --UNCHK
lin bettor_N = mkWN (k10 "pelaaja") ; --UNCHK
lin betulaceous_A = mkWA (compoundA "koivu" (k38 "mainen")) ; --UNCHK
lin between_Adv = mkWAdv (k99 "välissä") ; --UNCHK
lin between_Prep = S.between_Prep ;
lin bevatron_N = mkWN "bevatroni" ; --UNCHK
lin bevel_N = mkWN (compoundN "kulma" (k9A "mitta")) ; --UNCHK
lin bevel_V2 = mkWV2 (k53 "viistää") ; --UNCHK
lin beverage_N = mkWN (k10 "juotava") ;
lin beverley_PN = foreignPN "Beverley" ;
lin bevy_N = mkWN (k7 "parvi") ; --UNCHK
lin bewail_V2 = mkWV2 (k58 "itkeä") ; --UNCHK
lin beware_V = mkWV (k53A "välttää") ; --UNCHK
lin beware_V2 = mkWV2 (k53A "välttää") ; --UNCHK
lin bewdley_PN = foreignPN "Bewdley" ;
lin bewilder_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin bewilderedly_Adv = mkWAdv (compoundAdv "hämmentyn" (k5 "eesti")) ; --UNCHK
lin bewilderment_N = mkWN (k1 "olo") "ymmällään" ; --UNCHK
lin bewitch_V2 = mkWV2 (k61 "loitsia") ; --UNCHK
lin bewitchery_N = mkWN (compoundN "veto" (k10 "voima")) "eläimellinen" ; --UNCHK
lin bewitching_A = mkWA (k10 "hurmaava") ; --UNCHK
lin bexley_PN = foreignPN "Bexley" ;
lin bey_N = mkWN "bei" ; --UNCHK
lin beyond_Adv = mkWAdv (k99 "yli") "jnk" ; --UNCHK
lin beyond_Prep = mkPrep "saavuttamattomissa" ;
lin bezant_N = mkWN "solidus" ; --UNCHK
lin bezel_N = mkWN (compoundN "vino" (k10 "terä")) ; --UNCHK
lin bezique_N = mkWN "bezique" ; --UNCHK
lin bhakti_N = mkWN "bhakti" ; --UNCHK
lin bhang_N = mkWN "bhang" ; --UNCHK
lin bhutan_PN = foreignPN "Bhutan" ;
lin bhutani_N = mkWN (compoundN "bhutani" (k38 "lainen")) ; --UNCHK
lin bialy_N = mkWN (compoundN "sipuli" (k41A "rengas")) ; --UNCHK
lin biannually_Adv = mkWAdv (compoundAdv "puoli" (k38 "vuosittainen")) ; --UNCHK
lin bias_A = mkWA (compoundA "lei" (k1 "kattu")) "vinoon" ; --UNCHK
lin bias_N = mkWN (compoundN "ennakko" (k39 "käsitys")) ; --UNCHK
lin bias_V2 = mkWV2 (k73 "määrätä") "ennalta" ; --UNCHK
lin biauricular_A = mkWA "biaurikulaarinen" ; --UNCHK
lin biaxial_A = mkWA (compoundA "biaksia" (k38 "alinen")) ; --UNCHK
lin bib_N = mkWN (compoundN "ruoka" (k1A "lappu")) ; --UNCHK
lin bib_V = mkWV (k67A "tissutella") ; --UNCHK
lin bibbed_A = mkWA (compoundA "rinta" (k38 "lapullinen")) ; --UNCHK
lin bible_N = mkWN "raamattu" ; --UNCHK
lin bibless_A = mkWA "ruokalaputon" ; --UNCHK
lin biblical_A = mkWA (k38 "raamatullinen") ; --UNCHK
lin bibliographer_N = mkWN (k5 "bibliografi") ; --UNCHK
lin bibliographic_A = mkWA (k38 "bibliografinen") ; --UNCHK
lin bibliography_N = mkWN (k12 "bibliografia") ; --UNCHK
lin bibliolatrous_A = mkWA "Raamattua" "palvova" ; --UNCHK
lin bibliolatry_N = mkWN (k9A "palvonta") "Raamatun" ; --UNCHK
lin bibliomania_N = mkWN (compoundN "kirjojenkeräily" (k1 "himo")) ; --UNCHK
lin bibliomaniacal_A = mkWA (compoundA "biblio" (k38 "maaninen")) ; --UNCHK
lin bibliophile_N = mkWN (k12 "keräilijä") "kirjojen" ; --UNCHK
lin bibliophilic_A = mkWA (compoundA "bibliofiili" (k38 "nen")) ; --UNCHK
lin bibliopole_N = mkWN (k5A "antikvariaatti") ; --UNCHK
lin bibliopolic_A = mkWA "aktikvariaatti-" ; --UNCHK
lin bibliotheca_N = mkWN (k2 "kirjasto") ; --UNCHK
lin bibliothecal_A = mkWA (compoundA "kirja" (k38 "stollinen")) ; --UNCHK
lin bibliotic_A = mkWA "biblioottinen" ; --UNCHK
lin bibliotist_N = mkWN "bibliotisti" ; --UNCHK
lin bibulous_A = mkWA (k38 "humalainen") ; --UNCHK
lin bicameral_A = mkWA (compoundA "kaks" (k38 "ikamarinen")) ; --UNCHK
lin bicapsular_A = mkWA (compoundA "kaksikote" (k38 "loinen")) ; --UNCHK
lin bicarbonate_N = mkWN (k5A "bikarbonaatti") ; --UNCHK
lin bicentenary_N = mkWN (compoundN "kaksisataavuotis" (k10 "juhla")) ; --UNCHK
lin bicentennial_A = mkWA "kaksisataavuotis-" ; --UNCHK
lin bicentennial_N = mkWN (compoundN "kaksisataavuotis" (k10 "juhla")) ; --UNCHK
lin bicentric_A = mkWA (compoundA "kaks" (k38 "ikeskustainen")) ; --UNCHK
lin bicephalous_A = mkWA (compoundA "kaks" (k38 "ipäinen")) ; --UNCHK
lin biceps_N = mkWN (k39 "hauis") ; --UNCHK
lin bicester_PN = foreignPN "Bicester" ;
lin bichromate_N = mkWN "dikromaatti" ; --UNCHK
lin bichromated_A = mkWA "dikromaattinen" ; --UNCHK
lin bicipital_A = mkWA (compoundA "kaks" (k38 "ipäinen")) ; --UNCHK
lin bicker_N = mkWN (k13 "kahina") ; --UNCHK
lin bicker_V = mkWV (k66 "kitistä") ; --UNCHK
lin bicolor_A = mkWA (compoundA "kaksi" (k38 "värinen")) ; --UNCHK
lin biconcave_A = mkWA (compoundA "kaksois" (k10 "kovera")) ; --UNCHK
lin biconvex_A = mkWA (k38 "muotoinen") "linssin" ; --UNCHK
lin bicorn_A = mkWA (compoundA "kaks" (k38 "isarvinen")) ; --UNCHK
lin bicorn_N = mkWN "bicorne" ; --UNCHK
lin bicuspid_A = mkWA (compoundA "kaksi" (k38 "lehtinen")) ; --UNCHK
lin bicycle_N = mkWN (k10 "pyörä") ;
lin bicycle_V = mkWV (k58A "polkea") ; --UNCHK
lin bicyclic_A = mkWA (compoundA "kaks" (k38 "irenkainen")) ; --UNCHK
lin bicycling_N = mkWN (k2 "pyöräily") ; --UNCHK
lin bicylindrical_A = mkWA (compoundA "kaks" (k38 "isylinterinen")) ; --UNCHK
lin bid_N = mkN "tarjous" ;
lin bid_V = mkV "tarjota" ;
lin bid_V2 = mkWV2 (k74A "vedota") ; --UNCHK
lin biddable_A = mkWA (k38 "tottelevainen") ; --UNCHK
lin bidder_N = mkWN (k10 "tarjoaja") ;
lin bidding_N = mkWN (k39 "tarjous") ; --UNCHK
lin biddulph_PN = foreignPN "Biddulph" ;
lin bide_V2 = mkWV2 (k52A "viipyä") ; --UNCHK
lin bideford_PN = foreignPN "Bideford" ;
lin bidentate_A = mkWA (compoundA "kaks" (k38 "ihampainen")) ; --UNCHK
lin bidet_N = mkWN (k20 "bidee") ; --UNCHK
lin bidirectional_A = mkWA (compoundA "kaksi" (k38 "suuntainen")) ; --UNCHK
lin bielefeld_PN = foreignPN "Bielefeld" ;
lin biennial_A = mkWA (compoundA "kaks" (k38 "ivuotinen")) ; --UNCHK
lin biennial_N = mkWN (k5 "kasvi") "kaksivuotinen" ; --UNCHK
lin biface_A = mkWA (compoundA "kaks" (k38 "isivuinen")) ; --UNCHK
lin biff_N = mkWN (k5 "tälli") ; --UNCHK
lin biff_V2 = mkWV2 (k73A "hakata") ; --UNCHK
lin bifid_A = mkWA (compoundA "kaksi" (k38 "halkoinen")) ; --UNCHK
lin bifilar_A = mkWA (compoundA "kaksi" (k38 "säikeinen")) ; --UNCHK
lin biflagellate_A = mkWA (compoundA "kaksisii" (k38 "mainen")) ; --UNCHK
lin bifocal_A = mkWA "kaksiteho-" ; --UNCHK
lin bifoliate_A = mkWA (compoundA "kaksi" (k38 "lehtinen")) ; --UNCHK
lin biform_A = mkWA (compoundA "kaksi" (k38 "muotoinen")) ; --UNCHK
lin bifurcate_A = mkWA (k38 "haarainen") ; --UNCHK
lin bifurcate_V = mkWV (k52A "haarautua") "kahdeksi" ; --UNCHK
lin bifurcate_V2 = mkWV2 (k52A "haarautua") "kahdeksi" ; --UNCHK
lin bifurcation_N = mkWN (k99 "kahtia") "haarautuminen" ; --UNCHK
lin big_A = L.big_A ;
lin bigamist_N = mkWN (k2 "henkilö") "kaksiavioinen" ; --UNCHK
lin bigamous_A = mkWA (k38 "bigaaminen") ; --UNCHK
lin bigamy_N = mkWN (k38 "kaksinnaiminen") ; --UNCHK
lin bigeminal_A = mkWA (k38 "pareittainen") ; --UNCHK
lin bigeneric_A = mkWA (compoundA "kaksi" (k38 "sukuinen")) ; --UNCHK
lin bigeye_N = mkWN (compoundN "iso" (k10 "silmä")) ; --UNCHK
lin biggin_N = mkWN (k1A "hattu") "vauvan" ; --UNCHK
lin biggish_A = mkWA "suurehko" ; --UNCHK
lin biggleswade_PN = foreignPN "Biggleswade" ;
lin bighead_N = mkWN "isopää-" ; --UNCHK
lin bigheartedness_N = mkWN (compoundN "laajasydäm" (k40 "isyys")) ; --UNCHK
lin bighorn_N = mkWN (compoundN "paksusarvi" (k41A "lammas")) ; --UNCHK
lin bight_N = mkWN (k14A "silmukka") ; --UNCHK
lin bigmouthed_A = mkWA (k41 "puhelias") ; --UNCHK
lin bignoniaceous_A = mkWA "Bignoniaceae-heimoon" "liittyvä" ; --UNCHK
lin bignoniad_N = mkWN "bignoniadi" ; --UNCHK
lin bigos_N = mkWN (kH1 "pata") ; --UNCHK
lin bigot_N = mkWN (k12 "kiihkoilija") ; --UNCHK
lin bigoted_A = mkWA (k38 "fanaattinen") ; --UNCHK
lin bigotry_N = mkWN (k40 "dogmaattisuus") ; --UNCHK
lin bigram_N = mkWN "bigrammi" ; --UNCHK
lin bigwig_N = mkWN (kH1 "pamppu") ; --UNCHK
lin bijou_N = mkWN (k1 "koru") ; --UNCHK
lin bike_N = L.bike_N ;
lin bike_V = mkWV (k58A "polkea") ; --UNCHK
lin bikini_N = mkWN (compoundN "uima" (k1A "puku")) "kaksiosainen" ; --UNCHK
lin bilabial_A = mkWA (compoundA "bilabia" (k38 "alinen")) ; --UNCHK
lin bilabiate_A = mkWA (compoundA "kaks" (k38 "ihuulinen")) ; --UNCHK
lin bilateral_A = mkWA (compoundA "kaksi" (k38 "puolinen")) ; --UNCHK
lin bilateralism_N = mkWN (k12 "symmetria") "molemminpuolinen" ; --UNCHK
lin bilaterality_N = mkWN (k12 "symmetria") "molemminpuolinen" ; --UNCHK
lin bilbao_PN = foreignPN "Bilbao" ;
lin bilberry_N = mkWN (k14A "mustikka") ; --UNCHK
lin bile_N = mkWN (k7A "sappi") ; --UNCHK
lin bile_duct_N = mkWN (compoundN "sappi" (k19 "tie")) ; --UNCHK
lin bilge_N = mkWN (kH1 "palle") ; --UNCHK
lin bilge_water_N = mkWN (k5 "pilssi") ; --UNCHK
lin bilges_N = mkWN (k5 "pilssi") ; --UNCHK
lin bilgy_A = mkWA (compoundA "pilssi" (k38 "mäinen")) ; --UNCHK
lin bilharzia_N = mkWN (k5A "tauti") "bilhartsia-madon" "aiheuttama" ; --UNCHK
lin biliary_A = mkWA "sappi-" ; --UNCHK
lin bilimbi_N = mkWN (compoundN "tähti" (k10 "hedelmä")) ; --UNCHK
lin bilingual_A = mkWA (compoundA "kaks" (k38 "ikielinen")) ; --UNCHK
lin bilingual_N = mkWN (k2 "henkilö") "kaksikielinen" ; --UNCHK
lin bilingualism_N = mkWN (compoundN "kaksikiel" (k40 "isyys")) ; --UNCHK
lin bilious_A = mkWA (compoundA "sappi" (k38 "tautinen")) ; --UNCHK
lin biliousness_N = mkWN (k40 "äreys") ; --UNCHK
lin bilirubin_N = mkWN (compoundN "bili" (k6 "rubiini")) ; --UNCHK
lin bilk_V2 = mkWV2 (k53A "livahtaa") ; --UNCHK
lin bill_N = mkN "lasku" | mkN "seteli" ; ---- split
lin bill_PN = mkPN "Bill" ;
lin bill_V = mkWV (k53 "mainostaa") ; --UNCHK
lin bill_V2 = mkV2 "laskuttaa" ; --mkWV2 (k53 "mainostaa") ;
lin bill_poster_N = mkWN "julisteiden" "kiinnittäjä" ; --UNCHK
lin bill_sticker_N = mkWN "julisteiden" "kiinnittäjä" ; --UNCHK
lin billabong_N = mkWN (k9 "haara") ; --UNCHK
lin billboard_N = mkWN (compoundN "tienvarsi" (k39 "mainos")) ; --UNCHK
lin billericay_PN = foreignPN "Billericay" ;
lin billet_N = mkWN (k10 "tehtävä") ; --UNCHK
lin billet_V2 = mkWV2 (k53A "majoittaa") ; --UNCHK
lin billet_doux_N = mkWN (compoundN "rakkaus" (k48 "kirje")) ; --UNCHK
lin billfish_N = mkWN (compoundN "purje" (k9 "kala")) ; --UNCHK
lin billfold_N = mkWN (k4A "lompakko") ; --UNCHK
lin billhook_N = mkWN (k12 "kassara") ; --UNCHK
lin billiard_A = mkWA "biljardi-" ; --UNCHK
lin billiard_marker_N = mkWN (compoundN "piste" (k6 "laskuri")) "biljardin" ; --UNCHK
lin billiard_player_N = mkWN (k10 "pelaaja") "biljardin" ; --UNCHK
lin billiard_room_N = mkWN (compoundN "biljardi" (k5 "sali")) ; --UNCHK
lin billiard_table_N = mkWN (compoundN "biljardi" (k10A "pöytä")) ; --UNCHK
lin billiards_N = mkWN (k6 "biljardi") ; --UNCHK
lin billingsgate_N = mkWN (k39 "solvaus") ; --UNCHK
lin billington_PN = foreignPN "Billington" ;
lin billion_A = mkWA (k5 "miljardi") ;
lin billion_N = mkWN (k5 "miljardi") ;
lin billionaire_N = mkWN (k5 "miljardööri") ; --UNCHK
lin billionth_A = mkWA "miljardis" ; --UNCHK
lin billionth_N = mkWN (compoundN "miljardis" (k10 "osa")) ; --UNCHK
lin billow_N = mkWN (k1A "aalto") "suuri" ; --UNCHK
lin billow_V = mkWV (k52A "täyttyä") ; --UNCHK
lin billowy_A = mkWA (k38 "hyrskyinen") ; --UNCHK
lin billy_N = mkWN (kH1 "pukki") ; --UNCHK
lin billy_goat_N = mkWN (kH1 "pukki") ; --UNCHK
lin billy_o_N = mkWN (k99 "vimmatusti") ; --UNCHK
lin bilobate_A = mkWA (compoundA "kaksi" (k38 "lohkoinen")) ; --UNCHK
lin bilocation_N = mkWN "bilokaatio" ; --UNCHK
lin bilocular_A = mkWA (compoundA "kaks" (k38 "ipesäinen")) ; --UNCHK
lin biltong_N = mkWN (compoundN "kuiva" (k9 "liha")) ; --UNCHK
lin bimbo_N = mkWN "bimbo" ; --UNCHK
lin bimestrial_A = mkWA (compoundA "kaksi" (k38 "kuukautinen")) ; --UNCHK
lin bimetal_A = mkWA (compoundA "kaksois" (k38 "metallinen")) ; --UNCHK
lin bimetal_N = mkWN (compoundN "kaksois" (k5 "metalli")) ; --UNCHK
lin bimetallic_A = mkWA (compoundA "kaks" (k38 "imetallikantainen")) ; --UNCHK
lin bimetallism_N = mkWN (k5 "bimetallismi") ; --UNCHK
lin bimetallist_N = mkWN (compoundN "puolesta" (k10 "puhuja")) "kaksimetallikannan" ; --UNCHK
lin bimetallistic_A = mkWA (compoundA "kaks" (k38 "imetallikantainen")) ; --UNCHK
lin bimillenial_A = mkWA "kaksituhatvuotis-" ; --UNCHK
lin bimillennium_N = mkWN "kaksituhatvuotis-" ; --UNCHK
lin bimodal_A = mkWA (compoundA "kaksi" (k38 "muotoinen")) ; --UNCHK
lin bimolecular_A = mkWA (compoundA "kaksimoleky" (k38 "ylinen")) ; --UNCHK
lin bimorphemic_A = mkWA "bimorfeeminen" ; --UNCHK
lin bimotored_A = mkWA (compoundA "kaks" (k38 "imoottorinen")) ; --UNCHK
lin bin_N = mkWN (k3 "säiliö") ;
lin binary_A = mkWA (k38 "binaarinen") ; --UNCHK
lin binary_N = mkWN (compoundN "binaari" (k10 "ohjelma")) ; --UNCHK
lin binate_A = mkWA "kaksois-" ; --UNCHK
lin bind_N = mkWN (k39 "rasitus") ; --UNCHK
lin bind_V = mkWV (k53A "aiheuttaa") "ummetusta" ; --UNCHK
lin bind_V2 = mkV2 "sitoa" ; --WV2 (k53A "aiheuttaa") "ummetusta" ;
lin bindable_A = mkWA (k10 "oleva") "sidottavissa" ; --UNCHK
lin binder_N = mkWN (k39 "sidos") ; --UNCHK
lin bindery_N = mkWN (k2 "sitomo") ; --UNCHK
lin binding_A = variants {} ; --
lin binding_N = mkWN (k39 "sidos") ; --UNCHK
lin bindweed_N = mkWN (k1A "kierto") ; --UNCHK
lin bine_N = mkWN (k10 "humala") ; --UNCHK
lin binge_N = mkN "villitys" ; ---ARB --mkWN (compoundN "juoma" (k27 "kausi")) ;
lin bingley_PN = foreignPN "Bingley" ;
lin bingo_N = mkWN (k1 "bingo") ; --UNCHK
lin binnacle_N = mkWN (compoundN "kompassin" (k39 "suojus")) ; --UNCHK
lin binocular_A = mkWA (compoundA "kaks" (k38 "isilmäinen")) ; --UNCHK
lin binoculars_N = mkWN (k6 "kiikari") ; --UNCHK
lin binomial_A = mkWA (compoundA "kaks" (k38 "ijäseninen")) ; --UNCHK
lin binomial_N = mkWN (k5 "binomi") ; --UNCHK
lin binturong_N = mkWN (compoundN "karhu" (k10A "näätä")) ; --UNCHK
lin binucleate_A = mkWA (compoundA "kaksitu" (k38 "mainen")) ; --UNCHK
lin bioassay_N = mkWN (k5 "analyysi") "biologinen" ; --UNCHK
lin biocatalyst_N = mkWN (k6 "entsyymi") ; --UNCHK
lin biocatalytic_A = mkWA (compoundA "bio" (k38 "katalyyttinen")) ; --UNCHK
lin biochemical_A = mkWA (compoundA "bio" (k38 "kemiallinen")) ; --UNCHK
lin biochemist_N = mkWN (compoundN "bio" (k5 "kemisti")) ; --UNCHK
lin biochemistry_N = mkWN (compoundN "bio" (k12 "kemia")) ; --UNCHK
lin biochip_N = mkWN (compoundN "elo" (k1 "siru")) ; --UNCHK
lin bioclimatic_A = mkWA (compoundA "bio" (k38 "ilmastollinen")) ; --UNCHK
lin bioclimatology_N = mkWN (compoundN "bio" (k12 "klimatologia")) ; --UNCHK
lin biodegradable_A = mkWA "luonnossa" "hajoava" ; --UNCHK
lin biodiversity_N = mkWN (k5A "biodiversiteetti") ; --UNCHK
lin bioelectricity_N = mkWN (compoundN "bio" (k1 "sähkö")) ; --UNCHK
lin bioethics_N = mkWN (compoundN "bio" (k14A "etiikka")) ; --UNCHK
lin biofeedback_N = mkWN (compoundN "bio" (k48A "palaute")) ; --UNCHK
lin biogenesis_N = mkWN "biogeneesi" ; --UNCHK
lin biogenetic_A = mkWA (compoundA "bio" (k38 "geneettinen")) ; --UNCHK
lin biogenic_A = mkWA (k38 "biogeeninen") ; --UNCHK
lin biogenous_A = mkWA (k38 "biogeeninen") ; --UNCHK
lin biogeographic_A = mkWA "eliömaantieteellinen" ; --UNCHK
lin biogeography_N = mkWN "eliömaantiede" ; --UNCHK
lin biographer_N = mkWN (k10 "kirjoittaja") "elämäkertojen" ; --UNCHK
lin biographic_A = mkWA (k38 "biografinen") ; --UNCHK
lin biographical_A = mkWA (k38 "biografinen") ; --UNCHK
lin biography_N = mkWN (k10 "elämä") ; --UNCHK
lin biohazard_N = mkWN (k48 "aine") "biologinen" ; --UNCHK
lin biological_A = mkWA (k38 "biologinen") ; --UNCHK
lin biologism_N = mkWN (compoundN "biolog" (k5 "ismi")) ; --UNCHK
lin biologist_N = mkWN (k5 "biologi") ; --UNCHK
lin biologistic_A = mkWA (compoundA "biologi" (k38 "stinen")) ; --UNCHK
lin biology_N = mkWN (k12 "biologia") ; --UNCHK
lin bioluminescence_N = mkWN (compoundN "bio" (k5 "luminesenssi")) ; --UNCHK
lin bioluminescent_A = mkWA (compoundA "biolumin" (k10 "oiva")) ; --UNCHK
lin biomass_N = mkWN (compoundN "bio" (k9 "massa")) ; --UNCHK
lin biome_N = mkWN (compoundN "elo" (k2 "yhteisö")) ; --UNCHK
lin biomedicine_N = mkWN (compoundN "biolääke" (k48A "tiede")) ; --UNCHK
lin biometrics_N = mkWN (k9A "statistiikka") "biologinen" ; --UNCHK
lin bionic_A = mkWA "bioninen" ; --UNCHK
lin bionics_N = mkWN (compoundN "bion" (k9A "iikka")) ; --UNCHK
lin biophysicist_N = mkWN (compoundN "bio" (k4A "fyysikko")) ; --UNCHK
lin biophysics_N = mkWN (compoundN "bio" (k14A "fysiikka")) ; --UNCHK
lin biopiracy_N = mkWN (compoundN "bio" (k5 "piratismi")) ; --UNCHK
lin biopsy_N = mkWN (k12 "biopsia") ; --UNCHK
lin bioremediation_N = mkWN (compoundN "bio" (k39 "puhdistus")) ; --UNCHK
lin biosafety_N = mkWN (compoundN "bio" (k40 "turvallisuus")) ; --UNCHK
lin bioscope_N = mkWN (compoundN "biosko" (k5A "oppi")) ; --UNCHK
lin biosphere_N = mkWN (k5 "biosfääri") ; --UNCHK
lin biosynthesis_N = mkWN (compoundN "bio" (k5 "synteesi")) ; --UNCHK
lin biosynthetic_A = mkWA (compoundA "bio" (k38 "synteettinen")) ; --UNCHK
lin biosystematic_A = mkWA (compoundA "bio" (k38 "systemaattinen")) ; --UNCHK
lin biosystematics_N = mkWN (compoundN "bio" (k9A "systematiikka")) ; --UNCHK
lin biota_N = mkWN (k12 "biologia") ; --UNCHK
lin biotechnology_N = mkWN (k12 "ergonomia") ; --UNCHK
lin bioterrorism_N = mkWN (k5 "terrorismi") "biologinen" ; --UNCHK
lin biotic_A = mkWA (k10 "elävä") ; --UNCHK
lin biotin_N = mkWN "H-vitamiini" ; --UNCHK
lin biotite_N = mkWN (compoundN "musta" (k48A "kiille")) ; --UNCHK
lin biotitic_A = mkWA "biotiittinen" ; --UNCHK
lin biotype_N = mkWN (compoundN "bio" (k5A "tyyppi")) ; --UNCHK
lin biotypic_A = mkWA (compoundA "bio" (k38 "tyyppinen")) ; --UNCHK
lin bioweapon_N = mkWN (k48 "ase") "biologinen" ; --UNCHK
lin biparous_A = mkWA (k10 "tuottava") "kaksosia" ; --UNCHK
lin bipartisan_A = mkWA (compoundA "vasta" (k38 "vuoroinen")) ; --UNCHK
lin bipartite_A = mkWA (compoundA "kaksi" (k38 "puolinen")) ; --UNCHK
lin biped_N = mkWN (compoundN "kaks" (k38 "ijalkainen")) ; --UNCHK
lin bipedal_A = mkWA (compoundA "kaks" (k38 "ijalkainen")) ; --UNCHK
lin bipedalism_N = mkWN "kaksijalkaisuus" ; --UNCHK
lin bipinnate_A = mkWA (compoundA "kaks" (k38 "ilehdykkäinen")) ; --UNCHK
lin bipinnatifid_A = mkWA (compoundA "kaks" (k38 "ilehdykkäinen")) ; --UNCHK
lin biplane_N = mkWN (compoundN "lento" (k48 "kone")) "kaksitasoinen" ; --UNCHK
lin bipolar_A = mkWA (compoundA "kaks" (k38 "inapainen")) ; --UNCHK
lin biprism_N = mkWN "biprisma" ; --UNCHK
lin biquadrate_N = mkWN (k48 "aste") "neljäs" ; --UNCHK
lin biquadratic_A = mkWA "neljännen" "asteen" ; --UNCHK
lin biquadratic_N = mkWN (k5 "polynomi") "neljännen" "asteen" ; --UNCHK
lin biracial_A = mkWA (compoundA "kaksi" (k38 "rotuinen")) ; --UNCHK
lin biradial_A = mkWA (k38 "elliptinen") ; --UNCHK
lin birch_A = mkWA (k38 "koivuinen") ; --UNCHK
lin birch_N = mkWN (k9 "vitsa") ; --UNCHK
lin birch_V2 = mkWV2 (k73 "piiskata") ; --UNCHK
lin birch_rod_N = mkWN (k9 "vitsa") ; --UNCHK
lin bird_N = L.bird_N ;
lin bird_fancier_N = mkWN (compoundN "lintu" (k6 "bongari")) ; --UNCHK
lin birdbath_N = mkWN (compoundN "lintu" (k41A "allas")) ; --UNCHK
lin birdcage_N = mkWN (compoundN "lintu" (k5A "häkki")) ; --UNCHK
lin birdcall_N = mkWN (compoundN "linnunlaulu" (k48A "laite")) ; --UNCHK
lin birdhouse_N = mkWN (compoundN "lintu" (k9 "tarha")) ; --UNCHK
lin birdie_N = mkWN (compoundN "sulka" (k1 "pallo")) ; --UNCHK
lin birdlime_N = mkWN (compoundN "linnun" (k9 "liima")) ; --UNCHK
lin birdnesting_N = mkWN "linnunpesien" "etsiminen" ; --UNCHK
lin birefringent_A = mkWA (compoundA "kahtais" (k38 "taitteinen")) ; --UNCHK
lin biretta_N = mkWN "biretta" ; --UNCHK
lin birkenhead_PN = foreignPN "Birkenhead" ;
lin birling_N = mkWN (compoundN "tukin" (k39 "pyöritys")) ; --UNCHK
lin biro_N = mkWN (compoundN "kuula" (k10 "kynä")) ; --UNCHK
lin birr_N = mkWN (k12 "humina") ; --UNCHK
lin birth_N = mkWN (k10 "syntymä") ; --UNCHK
lin birth_control_N = mkWN (k2 "säännöstely") "syntyvyyden" ; --UNCHK
lin birthday_N = mkWN (compoundN "syntymä" (k10 "päivä")) ;
lin birthmark_N = mkWN (kH1 "luomi") ; --UNCHK
lin birthplace_N = mkWN (compoundN "syntymä" (k9A "paikka")) ; --UNCHK
lin birthrate_N = mkWN (k40 "fertiiliys") ; --UNCHK
lin birthwort_N = mkWN (compoundN "piippu" (k1 "ruoho")) ; --UNCHK
lin birtley_PN = foreignPN "Birtley" ;
lin biscuit_N = mkWN (kH1 "keksi") ; --UNCHK
lin bise_N = mkWN (k9 "viima") ; --UNCHK
lin bisect_V2 = mkWV2 (k53A "puolittaa") ; --UNCHK
lin bisection_N = mkWN (k99 "kahtia") "jakaminen" ; --UNCHK
lin biserrate_A = mkWA (compoundA "kaks" (k38 "ihampainen")) ; --UNCHK
lin bisexual_A = mkWA (compoundA "biseksua" (k38 "alinen")) ; --UNCHK
lin bisexuality_N = mkWN (k40 "biseksuaalisuus") ; --UNCHK
lin bishop_N = mkWN (k5A "lähetti") ; --UNCHK
lin bishopbriggs_PN = foreignPN "Bishopbriggs" ;
lin bishopric_N = mkWN (compoundN "piispan" (k9A "virka")) ; --UNCHK
lin bishopry_N = mkWN (k9A "virka") "piispan" ; --UNCHK
lin bismuth_N = mkWN (k5A "vismutti") ; --UNCHK
lin bismuthal_A = mkWA (compoundA "vismutti" (k38 "nen")) ; --UNCHK
lin bismuthic_A = mkWA "vismutti-" ; --UNCHK
lin bison_N = mkWN (k6 "biisoni") ; --UNCHK
lin bisontine_A = mkWA "biisonin" ; --UNCHK
lin bisque_N = mkWN (k1A "keitto") ; --UNCHK
lin bister_N = mkWN (compoundN "maali" (k5 "väri")) "ruskea" ; --UNCHK
lin bistered_A = mkWA (k15 "ruskea") ; --UNCHK
lin bistro_N = mkWN (k1 "bistro") ; --UNCHK
lin bistroic_A = mkWA "bistron" ; --UNCHK
lin bit_N = mkN "palanen" | mkN "bitti" ; ---- split
lin bitartrate_N = mkWN "vetytartraatti" ; --UNCHK
lin bitch_N = mkWN (k1A "narttu") ; --UNCHK
lin bitch_V = mkWV (k53A "valittaa") ; --UNCHK
lin bitchery_N = mkWN "narttumaisuus" ; --UNCHK
lin bitchy_A = mkWA (k15 "ilkeä") ; --UNCHK
lin bite_N = mkWN (k9 "pala") ; --UNCHK
lin bite_V = mkV "purra" ; --UNCHK
lin bite_V2 = L.bite_V2 ;
lin biter_N = mkWN (k12 "purija") ; --UNCHK
lin bitewing_N = mkWN (compoundN "hammas" (k5 "röntgen")) ; --UNCHK
lin biting_A = mkWA (k10 "pureva") ; --UNCHK
lin bitmap_N = mkWN (k10 "kuva") "elektroninen" ; --UNCHK
lin bitok_N = mkWN "bitok" ; --UNCHK
lin bitter_A = mkWA (k10 "katkera") ; --UNCHK
lin bitter_N = mkWN (k40 "kitkeryys") ; --UNCHK
lin bittercress_N = mkWN (compoundN "puro" (k14A "litukka")) ; --UNCHK
lin bitterish_A = mkWA "kitkerähkö" ; --UNCHK
lin bittern_N = mkWN (compoundN "kaulus" (k12 "haikara")) ; --UNCHK
lin bitterness_N = mkWN (k40 "piikikkyys") ; --UNCHK
lin bitternut_N = mkWN (compoundN "karvas" (k6 "hikkori")) ; --UNCHK
lin bitterroot_N = mkWN (compoundN "rediv" (k9 "iva")) "Lewisia" ; --UNCHK
lin bitters_N = mkWN (k2 "katkero") ; --UNCHK
lin bitter_sweet_A = mkWA (compoundA "katkeran" (k38 "suloinen")) ; --UNCHK
lin bittersweet_N = mkWN (compoundN "amerikankelas" (k39 "köynnös")) ; --UNCHK
lin bitthead_N = mkWN (k18 "pää") "pollarin" ; --UNCHK
lin bitty_A = mkWA (k38 "pikkuriikkinen") ; --UNCHK
lin bitumastic_N = mkWN "bitumi-" ; --UNCHK
lin bitumen_N = mkWN (k6 "bitumi") ; --UNCHK
lin bituminoid_A = mkWA "bituminoidi" ; --UNCHK
lin bituminous_A = mkWA (compoundA "bitumipi" (k38 "toinen")) ; --UNCHK
lin bivalent_A = mkWA (compoundA "kahden" (k38 "arvoinen")) ; --UNCHK
lin bivalve_A = mkWA (compoundA "kaks" (k38 "ikuorinen")) ; --UNCHK
lin bivalve_N = mkWN (k38 "nilviäinen") "kaksikuorinen" ; --UNCHK
lin bivariate_A = mkWA "kahden" "muuttujan" ; --UNCHK
lin bivouac_N = mkWN (k5 "leiri") ; --UNCHK
lin bivouac_V = mkWV (k52A "leiriytyä") ; --UNCHK
lin biz_N = mkWN (k39 "bisnes") ; --UNCHK
lin bizarre_A = mkWA (k38 "merkillinen") ; --UNCHK
lin bizonal_A = mkWA (compoundA "kaksi" (k38 "vyöhykkeinen")) ; --UNCHK
lin blab_V = mkWV (k62 "vasikoida") ; --UNCHK
lin blab_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin blabber_V = mkWV (k53A "pälättää") ; --UNCHK
lin blabber_V2 = mkWV2 (k53A "pälättää") ; --UNCHK
lin blabbermouth_N = mkWN (k1A "lörppö") ; --UNCHK
lin blabbermouthed_A = mkWA (k1A "lörppö") ; --UNCHK
lin black_A = L.black_A ;
lin black_N = mkWN (k10 "musta") ; --f69
lin black_V2 = mkWV2 (k52 "mustua") ; --UNCHK
lin black_lead_N = mkWN (k5A "grafiitti") ; --UNCHK
lin black_out_V = mkWV (k52A "pyörtyä") ; --UNCHK
lin blackamoor_N = mkWN (k6 "neekeri") ; --UNCHK
lin blackball_V2 = mkWV2 (k53A "käyttää") "veto-oikeutta" ; --UNCHK
lin blackberry_N = mkWN (compoundN "karhun" (k14A "vatukka")) ; --UNCHK
lin blackbird_N = mkWN (k50 "mustarastas") ; --UNCHK
lin blackboard_N = mkWN (k1 "taulu") ; --UNCHK
lin blackbuck_N = mkWN (compoundN "besoaari" (k5A "antilooppi")) ; --UNCHK
lin blackburn_PN = foreignPN "Blackburn" ;
lin blackcap_N = mkWN (compoundN "mustapää" (k1A "kerttu")) ; --UNCHK
lin blackcock_N = mkWN (k26 "teeri") ; --UNCHK
lin blacken_V = mkWV (k52 "mustua") ; --UNCHK
lin blacken_V2 = mkWV2 (k52 "mustua") ; --UNCHK
lin blackface_N = mkWN (compoundN "musta" (k9 "naama")) ; --UNCHK
lin blackfish_N = mkWN (compoundN "pitkäeväpallo" (k18 "pää")) ; --UNCHK
lin blackfly_N = mkWN (k38 "mäkäräinen") ; --UNCHK
lin blackguard_N = mkWN (k1 "roisto") ; --UNCHK
lin blackguard_V2 = mkWV2 (k73A "loukata") ; --UNCHK
lin blackguardly_A = mkWA (k38 "konnamainen") ; --UNCHK
lin blackhead_N = mkWN (compoundN "musta" (k18 "pää")) ; --UNCHK
lin blackheart_N = mkWN (k14A "kirsikka") ; --UNCHK
lin blacking_N = mkWN (compoundN "kenkä" (k48A "voide")) ; --UNCHK
lin blackish_A = mkWA (k10 "tumma") ; --UNCHK
lin blackjack_N = mkWN (k5A "ventti") ; --UNCHK
lin blackleg_N = mkWN (k10A "rotta") ; --UNCHK
lin blackleg_V = mkWV (k52A "rikkoa") "lakkoa" ; --UNCHK
lin blackleg_V2 = mkWV2 (k52A "rikkoa") "lakkoa" ; --UNCHK
lin blacklist_N = mkWN (k9 "lista") "musta" ; --UNCHK
lin blackmail_N = mkWN (k39 "kiristys") ; --UNCHK
lin blackmail_V2 = mkWV2 (k53 "kiristää") ; --UNCHK
lin blackmailer_N = mkWN (k10 "kiristäjä") ; --UNCHK
lin blackness_N = mkWN (k40 "mustuus") ; --UNCHK
lin blackout_N = mkWN (k40 "muistamattomuus") ; --UNCHK
lin blackpool_PN = foreignPN "Blackpool" ;
lin blackshirt_N = mkWN (k50 "mustapaita") ; --UNCHK
lin blacksmith_N = mkWN (k10A "seppä") ; --UNCHK
lin blacksnake_N = mkWN (compoundN "nuoli" (k48 "käärme")) ; --UNCHK
lin blackthorn_N = mkWN (compoundN "ora" (k10 "pihlaja")) ; --UNCHK
lin blacktop_N = mkWN (k5A "asfaltti") ; --UNCHK
lin blackwash_N = mkWN (compoundN "kengän" (k48 "muste")) ; --UNCHK
lin blackwater_N = mkWN (compoundN "mustavesi" (k48 "kuume")) ; --UNCHK
lin blackwood_N = mkWN (compoundN "musta" (k18 "puu")) ; --UNCHK
lin blackwood_PN = foreignPN "Blackwood" ;
lin bladder_N = mkWN (compoundN "sisä" (k5 "kumi")) ; --UNCHK
lin bladderpod_N = mkWN (compoundN "yrtti" (k5 "kasvi")) ; --UNCHK
lin bladderwort_N = mkWN (compoundN "vesi" (k48 "herne")) ; --UNCHK
lin bladderwrack_N = mkWN (compoundN "rakko" (k10 "levä")) ; --UNCHK
lin bladdery_A = mkWA (k38 "rakkulamainen") ; --UNCHK
lin blade_N = mkWN (k10 "terä") ; --UNCHK
lin bladed_A = mkWA (compoundA "terä" (k38 "inen")) ; --UNCHK
lin blae_A = mkWA (compoundA "harmaan" (k38 "sininen")) ; --UNCHK
lin blaeberry_N = mkWN (k14A "mustikka") ; --UNCHK
lin blaenavon_PN = foreignPN "Blaenavon" ;
lin blah_N = mkWN (k5 "humpuuki") ; --UNCHK
lin blahs_N = mkWN "plääh" ; --UNCHK
lin blain_N = mkWN (k12 "rakkula") ; --UNCHK
lin blairgowrie_PN = foreignPN "Blairgowrie" ;
lin blame_N = mkWN (k48A "moite") ; --UNCHK
lin blame_V = mkV "syyttää" ;
lin blame_V2 = mkV2 "syyttää" partitive ;
lin blameless_A = mkWA (k10 "luotettava") ; --UNCHK
lin blamelessness_N = mkWN (k40 "viattomuus") ; --UNCHK
lin blameworthiness_N = mkWN (k40 "syyllisyys") ; --UNCHK
lin blameworthy_A = mkWA (k38 "rikollinen") ; --UNCHK
lin blanc_N = mkWN (k48A "kastike") ; --UNCHK
lin blanch_V = mkWV (k72 "vaaleta") ; --UNCHK
lin blanch_V2 = mkWV2 (k72 "vaaleta") ; --UNCHK
lin blancmange_N = mkWN (compoundN "maito" (k2 "hyytelö")) ; --UNCHK
lin bland_A = mkA "mieto" ;
lin blandishment_N = mkWN (k2 "houkuttelu") ; --UNCHK
lin blandness_N = mkWN (k40 "värittömyys") ; --UNCHK
lin blank_A = mkWA (k34A "ilmeetön") ;
lin blank_N = mkWN (k13 "paukkupatruuna") ; --UNCHK
lin blank_out_V = mkWV (k53 "poistaa") ; --UNCHK
lin blank_out_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin blanket_N = mkWN (k1A "peitto") ;
lin blanket_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin blankness_N = mkWN (k40 "tyhjyys") ; --UNCHK
lin blanquillo_N = mkWN (k9 "kala") ; --UNCHK
lin blantyre_PN = foreignPN "Blantyre" ;
lin blare_N = mkWN (k1 "melu") ; --UNCHK
lin blare_V = mkWV (k52 "ulvoa") ; --UNCHK
lin blare_V2 = mkWV2 (k52 "ulvoa") ; --UNCHK
lin blare_out_V = mkWV (k53 "julistaa") "äänekkäästi" ; --UNCHK
lin blarney_N = mkWN (k2 "suostuttelu") ; --UNCHK
lin blase_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin blaspheme_V = mkWV (k73A "pilkata") "Jumalaa" ; --UNCHK
lin blaspheme_V2 = mkWV2 (k73A "pilkata") "Jumalaa" ; --UNCHK
lin blasphemer_N = mkWN (k10 "rienaaja") ; --UNCHK
lin blasphemous_A = mkWA (k1 "rivo") ; --UNCHK
lin blasphemy_N = mkWN (k39 "häväistys") ; --UNCHK
lin blast_N = mkN "purkaus" ; --mkWN (k5A "lyönti") "pitkä" ;
lin blast_V = mkWV (k67 "turmella") ; --UNCHK
lin blast_V2 = mkWV2 (k67 "turmella") ; --UNCHK
lin blast_furnace_N = mkWN (k5 "masuuni") ; --UNCHK
lin blast_off_V = mkWV (k66 "nousta") "ilmaan" ; --UNCHK
lin blastema_N = mkWN (compoundN "blas" (k9 "teema")) ; --UNCHK
lin blastemal_A = mkWA (compoundA "blastema" (k38 "alinen")) ; --UNCHK
lin blaster_N = mkWN (k10 "panostaja") ; --UNCHK
lin blastocoel_N = mkWN (k2 "ontelo") "blastulan" ; --UNCHK
lin blastocyst_N = mkWN (compoundN "alkio" (k12 "rakkula")) ; --UNCHK
lin blastocyte_N = mkWN (k1 "solu") "erilaistumaton" "sikiökautinen" ; --UNCHK
lin blastoderm_N = mkWN (compoundN "ulko" (k39 "kerros")) "blastulan" ; --UNCHK
lin blastodermatic_A = mkWA "blastodermi-" ; --UNCHK
lin blast_off_N = mkWN (k1A "lähtö") ; --UNCHK
lin blastogenesis_N = mkWN "blastogeneesi" ; --UNCHK
lin blastogenetic_A = mkWA (compoundA "blasto" (k38 "geneettinen")) ; --UNCHK
lin blastomeric_A = mkWA "blastomeeri-" ; --UNCHK
lin blastomycete_N = mkWN (compoundN "rakkula" (k26 "sieni")) ; --UNCHK
lin blastomycosis_N = mkWN "rakkulasienitauti" ; --UNCHK
lin blastomycotic_A = mkWA "blastomykoottinen" ; --UNCHK
lin blastopore_N = mkWN (k1A "aukko") "blastulan" "keskusontelon" ; --UNCHK
lin blastospheric_A = mkWA "blastulaan" "liittyvä" ; --UNCHK
lin blatancy_N = mkWN (k40 "räikeys") ; --UNCHK
lin blatant_A = mkWA (k10 "meluisa") ; --UNCHK
lin blather_N = mkWN (k1A "pöty") ; --UNCHK
lin blather_V = mkWV (k53A "lässyttää") ; --UNCHK
lin blaxploitation_N = mkWN (compoundN "hyvä" (k38 "ksikäyttäminen")) "mustien" ; --UNCHK
lin blaze_V = mkWV (k53 "loistaa") ; --UNCHK
lin blaze_V2 = mkWV2 (k53 "loistaa") ; --UNCHK
lin blaze_away_V = mkWV (k52 "puhua") ; --UNCHK
lin blazer_N = mkWN (k6 "bleiseri") ; --UNCHK
lin blazon_N = mkWN (k12 "vaakuna") ; --UNCHK
lin blazon_V2 = mkWV2 (k67 "koristella") ; --UNCHK
lin blazonry_N = mkWN (k12 "vaakuna") ; --UNCHK
lin bleach_N = mkWN (k2 "valkaisu") ; --UNCHK
lin bleach_V = mkWV (k66 "valkaista") ; --UNCHK
lin bleach_V2 = mkWV2 (k66 "valkaista") ; --UNCHK
lin bleacher_N = mkWN (compoundN "valkai" (k9 "sija")) ; --UNCHK
lin bleachers_N = mkWN (compoundN "avo" (k2 "katsomo")) ; --UNCHK
lin bleaching_powder_N = mkWN (kH1 "kalkki") "kloorattu" ; --UNCHK
lin bleak_A = mkWA (k1A "kolkko") ; --UNCHK
lin bleakness_N = mkWN (k40 "karuus") ; --UNCHK
lin bleary_A = mkWA (k10 "hämärä") ; --UNCHK
lin bleat_N = mkWN (k9A "määintä") ; --UNCHK
lin bleat_V = mkWV (k61A "määkiä") ; --UNCHK
lin bleat_V2 = mkWV2 (k61A "määkiä") ; --UNCHK
lin blebbed_A = mkWA (k38 "rakkulainen") ; --UNCHK
lin blebby_A = mkWA (k38 "rakkulainen") ; --UNCHK
lin bleed_V = mkV (mkV "vuotaa") "verta" ;
lin bleed_V2 = variants {} ; -- mkV (mkV "vuotaa") "verta" ;
lin bleed_VS = variants {} ; -- mkV (mkV "vuotaa") "verta" ;
lin bleeding_N = mkWN (k1A "vuoto") ; --UNCHK
lin bleep_N = mkWN (k39 "piipitys") ; --UNCHK
lin bleep_V = mkWV (k53A "piipittää") ; --UNCHK
lin blemish_N = mkWN (kH1 "vika") ; --UNCHK
lin blemish_V2 = mkWV2 (k73 "tahrata") ; --UNCHK
lin blench_V = mkWV (k72 "vaaleta") ; --UNCHK
lin blend_N = mkWN "yhdistäminen" ; --UNCHK
lin blend_V = mkWV (k52A "sulautua") ; --UNCHK
lin blend_V2 = mkWV2 (k52A "sulautua") ; --UNCHK
lin blender_N = mkWN (compoundN "teho" (k33A "sekoitin")) ; --UNCHK
lin blenny_N = mkWN (k9 "kala") "suomuton" ; --UNCHK
lin blepharism_N = mkWN (k39 "räpytys") "silmän" ; --UNCHK
lin blepharitis_N = mkWN (compoundN "luomi" (k39 "tulehdus")) ; --UNCHK
lin blepharospasm_N = mkWN (compoundN "blefaro" (k5 "spasmi")) ; --UNCHK
lin bless_V2 = mkWV2 (k73 "siunata") ; --UNCHK
lin blessedly_Adv = mkWAdv "siunatusti" ; --UNCHK
lin blessedness_N = mkWN (k7 "onni") "ylenpalttinen" ; --UNCHK
lin blessing_N = mkWN (k39 "siunaus") ;
lin bletchley_PN = foreignPN "Bletchley" ;
lin blether_N = mkWN (k12 "höpinä") ; --UNCHK
lin bletia_N = mkWN (k13 "orkidea") ; --UNCHK
lin bleu_N = mkWN (kH1 "aura") ; --UNCHK
lin blewits_N = mkWN (k13 "valmuska") ; --UNCHK
lin blidworth_PN = foreignPN "Blidworth" ;
lin blight_N = mkWN (compoundN "ruoste" (k26 "sieni")) ; --UNCHK
lin blight_V2 = mkWV2 (k67 "turmella") ; --UNCHK
lin blighter_N = mkWN (k5 "kundi") ; --UNCHK
lin blighty_N = mkWN (compoundN "koti" (k18 "maa")) ; --UNCHK
lin blimp_N = mkWN (compoundN "ilma" (k9 "laiva")) ; --UNCHK
lin blimpish_A = mkWA (k38 "taantumuksellinen") ; --UNCHK
lin blind_A = mkA "sokea" ; --mkWA (k34A "varaukseton") ;
lin blind_N = mkWN (k1 "verho") ; --UNCHK
lin blind_V2 = mkWV2 (k54A "hämärtää") ; --UNCHK
lin blindman's_buff_N = mkWN (k1A "sokko") ; --UNCHK
lin blindness_N = mkWN (k40 "sokeus") ; --UNCHK
lin blindworm_N = mkWN (k13 "vaskitsa") ; --UNCHK
lin bling_N = mkWN (k1 "koru") ; --UNCHK
lin blini_N = mkWN (k5 "blini") ; --UNCHK
lin blink_N = mkN "silmänräpäys" ; ---ARB
lin blink_V = mkWV (k53A "räpyttää") ; --UNCHK
lin blink_V2 = mkWV2 (k53A "räpyttää") ; --UNCHK
lin blinker_N = mkWN (k1A "vilkku") ; --UNCHK
lin blinks_N = mkWN (compoundN "hete" (k5 "kaali")) ; --UNCHK
lin blintz_N = mkWN "blintze" ; --UNCHK
lin blip_N = mkWN (kH1 "maali") "tutkan" ; --UNCHK
lin bliss_N = mkWN (k41 "taivas") "seitsemäs" ; --UNCHK
lin blissful_A = mkWA (k38 "onnellinen") ; --UNCHK
lin blister_N = mkWN (k12 "rakkula") ; --UNCHK
lin blister_V = mkWV (k66 "nousta") "rakkuloille" ; --UNCHK
lin blister_V2 = mkWV2 (k66 "nousta") "rakkuloille" ; --UNCHK
lin blithe_A = mkWA (k41A "riemukas") ; --UNCHK
lin blithesome_A = mkWA (k41A "riemukas") ; --UNCHK
lin blitz_N = mkWN (compoundN "salama" (k10A "sota")) ; --UNCHK
lin blizzard_N = mkWN (k1 "vyöry") ; --UNCHK
lin bloat_N = mkWN (k1 "ähky") ; --UNCHK
lin bloated_A = mkA "paisuteltu" ;
lin bloater_N = mkWN (compoundN "savu" (k5 "silli")) ; --UNCHK
lin blob_N = mkWN (k1A "möykky") ; --UNCHK
lin bloc_N = mkWN (k10 "ryhmittymä") ; --UNCHK
lin block_N = mkN "blokki" ;
lin block_V2 = mkWV2 (k58A "sulkea") ; --f88
lin block_in_V2 = prepV2 (lin V OP_block_V2) OP_in_Prep ; -- guess-p-verb
lin block_off_V2 = mkWV2 (k61A "tukkia") "kulku" ; --UNCHK
lin block_out_V2 = mkWV2 (k67A "suunnitella") ; --UNCHK
lin block_up_V2 = mkWV2 (k74A "teljetä") ; --UNCHK
lin blockade_N = mkWN (k39 "piiritys") ; --UNCHK
lin blockade_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin blockading_A = mkWA "saartava" ; --UNCHK
lin blockage_N = mkWN (k10 "tukkeutuma") ; --UNCHK
lin blockbuster_N = mkWN (k5A "hitti") ; --UNCHK
lin blocker_N = mkWN (k10 "salpaaja") ; --UNCHK
lin blockhead_N = mkWN (k1 "tollo") ; --UNCHK
lin blockheaded_A = mkWA (kH1 "mäntti") ; --UNCHK
lin blockhouse_N = mkWN (k10A "tukikohta") ; --UNCHK
lin blocking_N = mkWN "torjuminen" ; --UNCHK
lin blockish_A = mkWA (k38 "kuutiomainen") ; --UNCHK
lin blogger_N = mkWN (k10 "kirjoittaja") "verkkopäiväkirjan" ; --UNCHK
lin bloke_N = mkWN (k5 "kundi") ; --UNCHK
lin blolly_N = mkWN (k9 "alba") "Chiococca" ; --UNCHK
lin blond_A = mkWA (k15 "vaalea") ; --UNCHK
lin blond_N = mkWN (k15 "vaalea") ; --UNCHK
lin blonde_A = mkWA (k15 "vaalea") ; --UNCHK
lin blonde_N = mkWN (k15 "vaalea") ; --UNCHK
lin blood_N = L.blood_N ;
lin blood_V2 = mkWV2 (k61 "tuhria") "verellä" ;
lin blood_donor_N = mkWN (compoundN "veren" (k10 "luovuttaja")) ; --UNCHK
lin blood_group_N = mkWN (compoundN "veri" (k10 "ryhmä")) ; --UNCHK
lin blood_heat_N = mkWN (compoundN "ruumiinlämpö" (k9 "tila")) ; --UNCHK
lin blood_money_N = mkWN (k3 "palkkio") "palkkamurhaajan" ; --UNCHK
lin blood_poisoning_N = mkWN (compoundN "veren" (k39 "myrkytys")) ; --UNCHK
lin blood_pressure_N = mkWN (compoundN "veren" (k48 "paine")) ; --UNCHK
lin blood_relation_N = mkWN (k38 "sukulainen") ; --UNCHK
lin blood_transfusion_N = mkWN (compoundN "veren" (k1A "siirto")) ; --UNCHK
lin blood_type_N = mkWN (compoundN "veri" (k10 "ryhmä")) ; --UNCHK
lin blood_vessel_N = mkWN (compoundN "veri" (k26 "suoni")) ; --UNCHK
lin blood_bath_N = mkWN (compoundN "veri" (k1 "löyly")) ; --UNCHK
lin bloodberry_N = mkWN (compoundN "huone" (k5 "kasvi")) ; --UNCHK
lin bloodcurdling_A = mkWA (k38 "painajaismainen") ; --UNCHK
lin bloodguilt_N = mkWN "syyllinen" "verenvuodatukseen" ; --UNCHK
lin bloodguilty_A = mkWA (k38 "syyllinen") "verenvuodatukseen" ; --UNCHK
lin bloodhound_N = mkWN (compoundN "vihi" (k10 "koira")) ; --UNCHK
lin bloodiness_N = mkWN (k40 "verenhimoisuus") ; --UNCHK
lin bloodleaf_N = mkWN (compoundN "puna" (k7A "lehti")) ; --UNCHK
lin bloodless_A = mkWA (k34A "veretön") ; --UNCHK
lin blood_letting_N = mkWN (compoundN "veri" (k1 "löyly")) ; --UNCHK
lin bloodlust_N = mkWN (k1 "halu") "tappamisen" ; --UNCHK
lin bloodmobile_N = mkWN (compoundN "verenluovutus" (k1 "auto")) ; --UNCHK
lin bloodroot_N = mkWN (k26 "verijuuri") ; --UNCHK
lin bloodshed_N = mkWN (k26 "veri") ; --UNCHK
lin bloodshot_A = mkWA "verestävä" ; --UNCHK
lin bloodstain_N = mkWN (compoundN "veri" (k9 "tahra")) ; --UNCHK
lin bloodstained_A = mkWA (k10 "kammottava") ; --UNCHK
lin bloodstone_N = mkWN (k5A "heliotrooppi") ; --UNCHK
lin bloodstream_N = mkWN (compoundN "veren" (k1A "kierto")) ; --UNCHK
lin bloodsucker_N = mkWN (k12 "verenimijä") ; --UNCHK
lin bloodsucking_A = mkWA "verta" "imevä" ; --UNCHK
lin bloodthirstiness_N = mkWN (k40 "verenhimoisuus") ; --UNCHK
lin bloodthirsty_A = mkWA (k38 "verinen") ; --UNCHK
lin bloodworm_N = mkWN (compoundN "surviais" (k7 "sääski")) ; --UNCHK
lin bloodwort_N = mkWN (compoundN "ranta" (k7A "sappi")) ; --UNCHK
lin bloody_A = mkA "verinen" ;
lin bloody_Adv = mkWAdv (compoundAdv "pahuk" (k99 "sen")) ; --UNCHK
lin bloom_N = mkWN (k10 "härmä") ; --UNCHK
lin bloom_V = mkWV (k67 "olla") "kukassa" ; --UNCHK
lin bloomer_N = mkWN (k48 "virhe") ; --UNCHK
lin blooming_N = mkWN (k10A "kukka") ; --UNCHK
lin blossom_N = mkWN (k9A "kukinta") ; --UNCHK
lin blossom_V = mkWV (k53 "kukoistaa") ; --UNCHK
lin blossoming_N = mkWN (k9A "kukinta") ; --UNCHK
lin blot_N = mkWN (k10A "läikkä") ; --UNCHK
lin blot_V2 = mkWV2 (k61 "tahria") ; --UNCHK
lin blot_out_V = mkWV (k74 "verhota") ; --UNCHK
lin blotch_N = mkWN (k10A "läikkä") ; --UNCHK
lin blotched_A = mkWA (k41A "läikikäs") ; --UNCHK
lin blotchy_A = mkWA (k41A "läikikäs") ; --UNCHK
lin blotter_N = mkWN (compoundN "rikos" (k6 "rekisteri")) ; --UNCHK
lin blotting_paper_N = mkWN (compoundN "imu" (k6 "paperi")) ; --UNCHK
lin blotto_A = mkWA (k10 "oleva") "tillin-tallin" ; --UNCHK
lin blouse_N = mkWN (k2 "pusero") ; --UNCHK
lin blow_N = mkWN (k7A "henki") ;
lin blow_V = L.blow_V ;
lin blow_V2 = mkWV2 (k54A "puhaltaa") ; --UNCHK
lin blow_away_V = advV OP_blow_V OP_away_Adv ; -- guess-p-verb
lin blow_away_V2 = mkV2 (advV OP_blow_V OP_away_Adv ) ; -- guess-p-verb
lin blow_down_V2 = prepV2 OP_blow_V OP_down_Prep ; -- guess-p-verb
lin blow_dry_V2 = variants {} ; -- guess-p-verb
lin blow_in_V = advV OP_blow_V OP_in_Adv ; -- guess-p-verb
lin blow_off_V = advV OP_blow_V OP_off_Adv ; -- guess-p-verb
lin blow_off_V2 = prepV2 OP_blow_V OP_off_Prep ; -- guess-p-verb
lin blow_out_V2 = mkWV2 (k52A "särkyä") ; --UNCHK
lin blow_over_V = mkWV (k72A "heiketä") ; --UNCHK
lin blow_up_V = mkWV (k54A "suurentaa") ; --UNCHK
lin blow_up_V2 = mkWV2 (k54A "suurentaa") ; --UNCHK
lin blowback_N = mkWN (compoundN "taka" (k1 "isku")) ; --UNCHK
lin blower_N = mkWN (k41A "nisäkäs") "valaansukuinen" ; --UNCHK
lin blowfish_N = mkWN (compoundN "pallo" (k9 "kala")) ; --UNCHK
lin blowfly_N = mkWN (compoundN "raato" (k38 "kärpänen")) ; --UNCHK
lin blowgun_N = mkWN (compoundN "puhallus" (k7 "putki")) ; --UNCHK
lin blowhole_N = mkWN (k1A "aukko") ; --UNCHK
lin blowing_N = mkWN (k39 "puhallus") ; --UNCHK
lin blowing_up_N = mkWN (compoundN "hauk" (k38 "kuminen")) ; --UNCHK
lin blowlamp_N = mkWN (compoundN "puhallus" (k1A "lamppu")) ; --UNCHK
lin blowpipe_N = mkWN (compoundN "puhallus" (k7 "putki")) ; --UNCHK
lin blowsy_A = mkWA (k14A "pönäkkä") ; --UNCHK
lin blowtorch_N = mkWN (compoundN "puhallus" (k1A "lamppu")) ; --UNCHK
lin blowtube_N = mkWN (compoundN "puhallus" (k7 "putki")) ; --UNCHK
lin blowy_A = mkWA (k38 "tuulinen") ; --UNCHK
lin blowzy_A = mkWA (k14A "pönäkkä") ; --UNCHK
lin blubber_N = mkWN (k5 "läski") ; --UNCHK
lin blubber_V = mkWV (k61 "nyyhkiä") ; --UNCHK
lin blubber_V2 = mkWV2 (k61 "nyyhkiä") ; --UNCHK
lin blubberer_N = mkWN (k10 "ruikuttaja") ; --UNCHK
lin blubbery_A = mkWA (k5 "läski") ; --UNCHK
lin blucher_N = mkWN (k10A "kenkä") ; --UNCHK
lin bludgeon_N = mkWN (k10 "nuija") ; --UNCHK
lin bludgeon_V2 = mkWV2 (k61 "nuijia") ; --UNCHK
lin bludgeoner_N = mkWN (k10 "hakkaaja") ; --UNCHK
lin blue_A = L.blue_A ;
lin blue_N = mkN "sinisyys" ;
lin blue_V2 = mkWV2 (k52A "värjäytyä") "siniseksi" ; --UNCHK
lin blue_collar_A = mkA "työläishenkinen" ;
lin bluebell_N = mkWN (compoundN "sini" (k1 "kello")) ; --UNCHK
lin blueberry_N = mkWN (k14A "mustikka") ; --UNCHK
lin bluebird_N = mkWN "sinikka" ; --UNCHK
lin bluebonnet_N = mkWN (k1A "hattu") "sininen" ; --UNCHK
lin bluebottle_N = mkWN (compoundN "raato" (k38 "kärpänen")) ; --UNCHK
lin bluecoat_N = mkWN (compoundN "sotilas" (k2 "henkilö")) ; --UNCHK
lin bluefin_N = mkWN (compoundN "tonni" (k9 "kala")) ; --UNCHK
lin bluefish_N = mkWN (compoundN "sini" (k9 "kala")) ; --UNCHK
lin bluegill_N = mkWN (compoundN "isoaurinko" (k32 "ahven")) ; --UNCHK
lin bluegrass_N = mkWN "bluegrass" ; --UNCHK
lin bluehead_N = mkWN (compoundN "sinipäähuuli" (k9 "kala")) ; --UNCHK
lin blue_jacket_N = mkWN (k42 "mies") "laivaston" ; --UNCHK
lin blueprint_N = mkWN (compoundN "sini" (k3 "kopio")) ;
lin blues_N = mkWN (k5 "blues") ; --UNCHK
lin bluestem_N = mkWN "Andropogon" "gerardii" ; --UNCHK
lin bluestocking_N = mkWN (compoundN "sini" (k10A "sukka")) ; --UNCHK
lin bluestone_N = mkWN "bluestone" ; --UNCHK
lin bluethroat_N = mkWN (compoundN "sini" (k9A "rinta")) ; --UNCHK
lin bluetick_N = mkWN (compoundN "pesukarhu" (k10 "koira")) "sininen" ; --UNCHK
lin bluetongue_N = mkWN (compoundN "sinikieli" (k5A "tauti")) ; --UNCHK
lin blueweed_N = mkWN (compoundN "neidon" (k26 "kieli")) ; --UNCHK
lin bluewing_N = mkWN (compoundN "sinisiipi" (k5 "tavi")) ; --UNCHK
lin bluff_A = mkWA (compoundA "suo" (k38 "rapuheinen")) ; --UNCHK
lin bluff_N = mkWN (k39 "bluffaus") ; --UNCHK
lin bluff_V = mkWV (k73 "hämätä") ; --UNCHK
lin bluff_V2 = mkWV2 (k73 "hämätä") ; --UNCHK
lin bluffer_N = mkWN "bluffaaja" ; --UNCHK
lin bluffness_N = mkWN "suorapuheisuus" ; --UNCHK
lin bluing_N = mkWN (compoundN "sini" (k5 "seksi")) "värjäys" ; --UNCHK
lin bluish_A = mkWA (k10 "sinertävä") ; --UNCHK
lin blunder_N = mkN "kömmähdys" ;
lin blunder_V = mkWV (k53A "täräyttää") ; --UNCHK
lin blunder_V2 = mkWV2 (k53A "täräyttää") ; --UNCHK
lin blunderbuss_N = mkWN (compoundN "väki" (k1 "pyssy")) ; --UNCHK
lin blunderer_N = mkWN (k10 "hutiloija") ; --UNCHK
lin blunt_A = mkWA (k1 "karu") ; --UNCHK
lin blunt_V2 = mkWV2 (k53 "latistaa") ;
lin bluntness_N = mkWN (k40 "tylsyys") ; --UNCHK
lin blur_N = mkWN (k40 "sumeus") ; --UNCHK
lin blur_V = mkWV (k52A "hämärtyä") ; --UNCHK
lin blur_V2 = mkV2 "hämärtää" ; --WV2 (k52A "hämärtyä") ;
lin blurb_N = mkWN (compoundN "mainos" (k5 "teksti")) ; --UNCHK
lin blurt_V2 = mkWV2 (k53A "täräyttää") ; --UNCHK
lin blurt_out_V2 = mkWV2 (k53A "täräyttää") ; --UNCHK
lin blush_N = mkWN (k39 "punastus") ; --UNCHK
lin blush_V = mkWV (k52 "punastua") ; --UNCHK
lin blushful_A = mkWA (k38 "punainen") ; --UNCHK
lin bluster_N = mkWN (k2 "mahtailu") ; --UNCHK
lin bluster_V = mkWV (k67 "ylvästellä") ; --UNCHK
lin bluster_V2 = mkWV2 (k67 "ylvästellä") ; --UNCHK
lin blustery_A = mkWA (k10 "myrskyisä") ; --UNCHK
lin blyth_PN = foreignPN "Blyth" ;
lin bmus_N = mkWN (k5A "kandidaatti") "musiikkitieteen" ; --UNCHK
lin bo'sun_N = mkWN (k1 "puosu") ; --UNCHK
lin boa_N = mkWN (compoundN "boa" (k48 "käärme")) ; --UNCHK
lin boa_constrictor_N = mkWN (compoundN "kuningas" (k10 "boa")) ; --UNCHK
lin boar_N = mkWN (k1 "karju") ; --UNCHK
lin board_1_N = mkN "taulu" ;
lin board_2_N = mkN "hallitus" | mkN "lautakunta" ;
lin board_N = mkN "hallitus" ;
lin board_V2 = mkWV2 (k53A "majoittaa") ; --UNCHK
lin board_up_V2 = mkWV2 (k53A "laudoittaa") ; --UNCHK
lin boarder_N = mkWN (k41 "oppilas") "sisäoppilaitoksen" ; --UNCHK
lin boarding_N = mkWN (k1 "nousu") ; --UNCHK
lin boarding_card_N = mkWN (compoundN "maihinnousu" (k5A "kortti")) ; --UNCHK
lin boarding_house_N = mkWN (k12 "asuntola") ; --UNCHK
lin boarding_school_N = mkWN "sisäoppilaitos" ; --UNCHK
lin boardroom_N = mkWN (compoundN "kokous" (k48 "huone")) ; --UNCHK
lin boards_N = mkWN (k5 "ränni") ; --UNCHK
lin boardwalk_N = mkWN (compoundN "kävely" (k19 "tie")) ; --UNCHK
lin boarfish_N = mkWN (compoundN "karju" (k9 "kala")) ; --UNCHK
lin boarhound_N = mkWN "mastiffi" ; --UNCHK
lin boast_N = mkWN (k50 "omakehu") ; --UNCHK
lin boast_V = mkWV (k67A "rehennellä") ;
lin boast_V2 = mkWV2 (k67A "rehennellä") ; --UNCHK
lin boast_VS = mkWVS (k67A "rehennellä") ;
lin boaster_N = mkWN (k6 "öykkäri") ; --UNCHK
lin boastful_A = mkWA (compoundA "itse" (k15 "tärkeä")) ; --UNCHK
lin boastfulness_N = mkWN (k40 "omahyväisyys") ; --UNCHK
lin boat_N = L.boat_N ;
lin boat_V = mkWV (k67 "veneillä") ; --UNCHK
lin boat_hook_N = mkWN (k5 "venekeksi") ; --UNCHK
lin boat_race_N = mkWN (compoundN "vene" (k2 "kilpailu")) ; --UNCHK
lin boat_train_N = mkWN (compoundN "laiva" (k10 "juna")) ; --UNCHK
lin boatbill_N = mkWN (compoundN "ruuhi" (k10A "nokka")) ; --UNCHK
lin boatbuilder_N = mkWN (compoundN "veneen" (k10 "rakentaja")) ; --UNCHK
lin boater_N = mkWN (compoundN "panama" (k1A "hattu")) ; --UNCHK
lin boat_house_N = mkWN (compoundN "vene" (k9 "vaja")) ; --UNCHK
lin boating_N = mkWN (k2 "veneily") ; --UNCHK
lin boatload_N = mkWN (compoundN "vaunu" (k5 "lasti")) ; --UNCHK
lin boatman_N = mkWN (k12 "purjehtija") ; --UNCHK
lin boatmanship_N = mkWN (compoundN "veneily" (k1A "taito")) ; --UNCHK
lin boatswain_N = mkWN (k1 "puosu") ; --UNCHK
lin boatyard_N = mkWN (compoundN "vene" (k2 "veistämö")) ; --UNCHK
lin bob_N = mkWN (k39 "nyökkäys") ; --UNCHK
lin bob_V = mkWV (k73A "leikata") "polkkatukka" ; --UNCHK
lin bob_V2 = mkWV2 (k73A "leikata") "polkkatukka" ; --UNCHK
lin bobbin_N = mkWN (k10 "rulla") ; --UNCHK
lin bobble_N = mkWN (k5A "haparointi") ; --UNCHK
lin bobby_N = mkWN (k6 "poliisi") ; --UNCHK
lin bobby_soxer_N = mkWN (k10 "käyttäjä") "nilkkasukkien" ; --UNCHK
lin bobcat_N = mkWN (compoundN "puna" (k39 "ilves")) ; --UNCHK
lin bobolink_N = mkWN (compoundN "riisi" (k38 "varpunen")) ; --UNCHK
lin bobsled_N = mkWN (compoundN "ratti" (k9A "kelkka")) ; --UNCHK
lin bobsledding_N = mkWN (k2 "kelkkailu") ; --UNCHK
lin bobsleigh_N = mkWN (compoundN "ratti" (k9A "kelkka")) ; --UNCHK
lin bobtail_A = mkWA (compoundA "töpö" (k38 "häntäinen")) ; --UNCHK
lin bobtail_N = mkWN (compoundN "töpö" (k10A "häntä")) ; --UNCHK
lin bobwhite_N = mkWN (compoundN "pelto" (k18 "pyy")) ; --UNCHK
lin bocce_N = mkWN "bocci" ; --UNCHK
lin bocconia_N = mkWN "Bocconia" "frutescens" ; --UNCHK
lin bochum_PN = foreignPN "Bochum" ;
lin bodacious_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin bode_V = mkWV (k69 "merkitä") ; --UNCHK
lin bode_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin bodega_N = mkWN (compoundN "lähi" (k9A "kauppa")) ; --UNCHK
lin bodice_N = mkWN (compoundN "ylä" (k10 "osa")) "puvun" ; --UNCHK
lin bodiless_A = mkWA (k34A "ruumiiton") ; --UNCHK
lin bodily_A = mkWA (k38 "ruumiillinen") ; --UNCHK
lin bodily_Adv = mkWAdv (k99 "ruumiillisesti") | adjAdv bodily_A ; --UNCHK -- derived
lin boding_N = mkWN (k39 "aavistus") ; --UNCHK
lin bodkin_N = mkWN (kH1 "naskali") ; --UNCHK
lin bodmin_PN = foreignPN "Bodmin" ;
lin body_N = mkN "ruumis" ;
lin body_servant_N = mkWN (compoundN "henki" (k12 "palvelija")) ; --UNCHK
lin body_snatcher_N = mkWN (compoundN "ruumiin" (k10 "ryöstäjä")) ; --UNCHK
lin bodybuilder_N = mkWN (compoundN "kehon" (k10 "rakentaja")) ; --UNCHK
lin bodybuilding_N = mkWN (k39 "harjoitus") "anaerobinen" ; --UNCHK
lin bodyguard_N = mkWN (compoundN "henki" (k1 "vartiosto")) ; --UNCHK
lin bodywork_N = mkWN (compoundN "kori" (k19 "työ")) ; --UNCHK
lin boer_N = mkWN (k5 "buuri") ; --UNCHK
lin boffin_N = mkWN (k12 "tutkija") ; --UNCHK
lin boffo_A = mkWA "menestyvä" ; --UNCHK
lin bog_N = mkWN (k9 "neva") ; --UNCHK
lin bog_V = mkWV (k52A "juuttua") "paikoilleen" ; --UNCHK
lin bog_V2 = mkWV2 (k52A "juuttua") "paikoilleen" ; --UNCHK
lin bog_down_V = mkWV (k52A "juuttua") "paikoilleen" ; --UNCHK
lin bogey_N = mkWN (compoundN "vihollis" (k48 "kone")) ; --UNCHK
lin bogeyman_N = mkWN (k1A "peikko") ; --UNCHK
lin boggle_V = mkWV (k53A "tyrmistyttää") ; --UNCHK
lin boggy_A = mkWA (k10 "vetelä") ; --UNCHK
lin bogie_N = mkWN (compoundN "vihollis" (k48 "kone")) ; --UNCHK
lin bogota_PN = foreignPN "Bogota" ;
lin bogus_A = mkWA (k10 "väärä") ; --UNCHK
lin bogy_N = mkWN (compoundN "vihollis" (k48 "kone")) ; --UNCHK
lin bohemian_A = mkWA "böömiläinen" ; --UNCHK
lin bohemian_N = mkWN (k5 "boheemi") ; --UNCHK
lin bohemianism_N = mkWN (compoundN "boheemi" (k10 "elämä")) ; --UNCHK
lin bohrium_N = mkWN "järjestysluku" "107" ; --UNCHK
lin boil_N = mkWN (compoundN "kiehumis" (k48 "piste")) ; --UNCHK
lin boil_V = mkWV (k53A "keittää") ; --UNCHK
lin boil_V2 = mkWV2 (k53A "keittää") ; --UNCHK
lin boil_down_V2 = mkWV2 (k53A "kiehuttaa") "vähiin" ; --UNCHK
lin boil_over_V = mkWV (k52 "kiehua") "yli" ; --UNCHK
lin boiler_N = mkWN (compoundN "höyry" (k12 "kattila")) ; --UNCHK
lin boilerplate_N = mkWN (compoundN "teräs" (k1 "levy")) ; --UNCHK
lin boilersuit_N = mkWN (compoundN "työ" (k5A "takki")) ; --UNCHK
lin boiling_Adv = mkWAdv "raivoisan" ; --UNCHK
lin boiling_N = mkWN (k1A "keitto") ; --UNCHK
lin boiling_point_N = mkWN (compoundN "kiehumis" (k48 "piste")) ; --UNCHK
lin boisterous_A = mkWA (k10 "kova") ; --UNCHK
lin boisterousness_N = mkWN (k40 "riehakkuus") ; --UNCHK
lin bola_N = mkWN "bola" ; --UNCHK
lin bold_1_A = mkWA (k41 "uskalias") ; --UNCHK
lin bold_2_A = mkWA (k41 "uskalias") ; --UNCHK
lin boldface_N = mkWN (k5A "lihavointi") ; --UNCHK
lin boldness_N = mkWN (k40 "uskaliaisuus") ; --UNCHK
lin bole_N = mkWN "bolanci" ; --UNCHK
lin bolero_N = mkWN (k2 "bolero") ; --UNCHK
lin bolete_N = mkWN (k5A "tatti") ; --UNCHK
lin bolide_N = mkWN (compoundN "tuli" (k1 "pallo")) ; --UNCHK
lin bolivar_N = mkWN "El" "Libertador" ; --UNCHK
lin bolivia_PN = foreignPN "Bolivia" ;
lin bolivian_A = mkWA (compoundA "bolivi" (k38 "alainen")) ; --UNCHK
lin bolivian_N = mkWN (compoundN "bolivi" (k38 "alainen")) ; --UNCHK
lin boliviano_N = mkWN "boliviano" ; --UNCHK
lin boll_N = mkWN "boll" ; --UNCHK
lin bollard_N = mkWN (kH1 "pollari") ; --UNCHK
lin bollington_PN = foreignPN "Bollington" ;
lin bollock_N = mkWN "bullock" "block" ; --UNCHK
lin bollworm_N = mkWN "bollworm" ; --UNCHK
lin bolo_N = mkWN (compoundN "bolo-" (k30 "veitsi")) ; --UNCHK
lin bologna_N = mkWN (k12 "makkara") "Bolognan" ; --UNCHK
lin bologna_PN = foreignPN "Bologna" ;
lin bologram_N = mkWN "bologrammi" ; --UNCHK
lin bolographic_A = mkWA "bolografinen" ; --UNCHK
lin bolometer_N = mkWN (compoundN "bolo" (k5 "metri")) ; --UNCHK
lin bolometric_A = mkWA (compoundA "bolo" (k38 "metrinen")) ; --UNCHK
lin boloney_N = mkWN (k5 "humpuuki") ; --UNCHK
lin bolshevik_N = mkWN (k5A "punikki") ; --UNCHK
lin bolshy_A = mkWA (k10 "hankala") ; --UNCHK
lin bolsover_PN = foreignPN "Bolsover" ;
lin bolster_N = mkWN (k1 "tyyny") ; --UNCHK
lin bolster_V = mkWV (k53 "vahvistaa") ; --UNCHK
lin bolster_V2 = mkWV2 (k53 "vahvistaa") ;
lin bolster_up_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin bolt_Adv = mkWAdv (k99 "kankeasti") ; --UNCHK
lin bolt_N = mkN "pultti" ;
lin bolti_N = mkWN "Tilapia" "nilotica" ; --UNCHK
lin bolton_PN = foreignPN "Bolton" ;
lin bolus_N = mkWN "bolus" ; --UNCHK
lin bolzano_PN = foreignPN "Bolzano" ;
lin bomb_N = mkWN (kH1 "pommi") ;
lin bomb_V = mkWV (k53A "pommittaa") ; --UNCHK
lin bomb_V2 = mkV2 (mkV (lin VK {s = c53A "pommittaa"})) partitive ;
lin bomb_site_N = mkWN (compoundN "pommitus" (k48A "kohde")) ; --UNCHK
lin bombard_V2 = mkWV2 (k53A "pommittaa") ; --UNCHK
lin bombardier_N = mkWN (k10 "pommittaja") ; --UNCHK
lin bombardment_N = mkWN (k39 "pommitus") ; --UNCHK
lin bombardon_N = mkWN "bombard" ; --UNCHK
lin bombast_N = mkWN (k5 "humpuuki") ; --UNCHK
lin bombastic_A = mkWA (k38 "korkealentoinen") ; --UNCHK
lin bombazine_N = mkWN (k5 "pumasiini") ; --UNCHK
lin bomber_N = mkWN (compoundN "pommi" (k48 "kone")) ;
lin bombie_N = mkWN (k6 "suutari") ; --UNCHK
lin bombing_N = mkWN (k39 "pommitus") ; --UNCHK
lin bomblet_N = mkWN (k5 "rypälepommi") ; --UNCHK
lin bomb_proof_A = mkWA (compoundA "pommin" (k10 "kestävä")) ; --UNCHK
lin bombshell_N = mkWN (kH1 "pommi") ; --UNCHK
lin bomb_sight_N = mkWN (compoundN "tähtäys" (k48A "laite")) ; --UNCHK
lin bombycid_N = mkWN (compoundN "silkki" (k38 "perhonen")) ; --UNCHK
lin bon_mot_N = mkWN (k40 "sukkeluus") ; --UNCHK
lin bona_fide_A = mkWA (k38 "varsinainen") ; --UNCHK
lin bonanza_N = mkWN (k5A "jättipotti") ; --UNCHK
lin bonbon_N = mkWN (k5 "karamelli") ; --UNCHK
lin bond_N = mkN "sidos" ;
lin bond_V2 = mkWV2 (k52A "takertua") "jhk" ; --UNCHK
lin bondable_A = mkWA "liitettävä" ; --UNCHK
lin bond_holder_N = mkWN (k12 "haltija") "velkakirjan" ; --UNCHK
lin bonding_N = mkWN "liittäminen" ; --UNCHK
lin bondman_N = mkWN (k10 "orja") ; --UNCHK
lin bondsman_N = mkWN (k10 "orja") ; --UNCHK
lin bonduc_N = mkWN "Caesalpinia" "bonducella" ; --UNCHK
lin bondwoman_N = mkWN (compoundN "nais" (k10 "orja")) ; --UNCHK
lin bone_A = mkWA (k38 "luinen") ; --UNCHK
lin bone_N = L.bone_N ;
lin bone_V2 = mkWV2 (k53 "poistaa") "luut" ; --UNCHK
lin bone_dry_A = mkWA (compoundA "ruti" (k10 "kuiva")) ; --UNCHK
lin bone_up_V = mkWV (k56A "ahtaa") "päähänsä" ; --UNCHK
lin bonefish_N = mkWN (compoundN "nais" (k9 "kala")) ; --UNCHK
lin boneless_A = mkWA (k34A "luuton") ; --UNCHK
lin bonelike_A = mkWA (compoundA "luu" (k38 "mainen")) ; --UNCHK
lin bonemeal_N = mkWN (compoundN "luu" (k1 "jauho")) ; --UNCHK
lin boner_N = mkWN (k48 "virhe") ; --UNCHK
lin boneset_N = mkWN (compoundN "amerikanvalko" (k9 "latva")) ; --UNCHK
lin bone_setter_N = mkWN (k10 "niksauttaja") "luiden" ; --UNCHK
lin boneshaker_N = mkWN "kosla" ; --UNCHK
lin bonfire_N = mkWN (k1A "juhannuskokko") ; --UNCHK
lin bong_N = mkWN (k39 "kumahdus") ; --UNCHK
lin bongo_N = mkWN (k1 "bongo") ; --UNCHK
lin bonheur_N = mkWN (k7 "onni") ; --UNCHK
lin bonhomie_N = mkWN (k40 "sydämellisyys") ; --UNCHK
lin bonito_N = mkWN "juovaselkäsarda" ; --UNCHK
lin bonkers_A = mkWA (k1 "pöllö") ; --UNCHK
lin bonn_PN = foreignPN "Bonn" ;
lin bonnet_N = mkWN (k9A "hilkka") ; --UNCHK
lin bonny_A = mkWA (k15 "komea") ; --UNCHK
lin bonnybridge_PN = foreignPN "Bonnybridge" ;
lin bonnyrigg_PN = foreignPN "Bonnyrigg" ;
lin bonsai_N = mkWN "bonsai" ; --UNCHK
lin bonus_N = mkWN (k39 "bonus") ;
lin bony_A = mkWA (k38 "ruotoinen") ; --UNCHK
lin bonyness_N = mkWN (k40 "laihuus") ; --UNCHK
lin bonzer_A = mkWA (k10 "merkittävä") ; --UNCHK
lin boo_N = mkWN (k39 "tuhahdus") ; --UNCHK
lin boo_V = mkWV (k54A "viheltää") ; --UNCHK
lin boo_V2 = mkWV2 (k54A "viheltää") ; --UNCHK
lin boob_N = mkWN (k5 "nänni") ; --UNCHK
lin boob_V = mkWV (k73A "töpätä") ; --UNCHK
lin booby_N = mkWN (k10 "suula") ; --UNCHK
lin booby_trap_N = mkWN (k9 "miina") ; --UNCHK
lin boodle_N = mkWN (compoundN "kortti" (k5 "peli")) ; --UNCHK
lin booger_N = mkWN (k10A "räkä") ; --UNCHK
lin boogie_N = mkWN "boogie" "woogie" ; --UNCHK
lin book_N = L.book_N ;
lin book_V2 = mkV2 "varata" ; --mkWV2 (k53 "järjestää") ;
lin book_up_V = mkWV (k73 "varata") ; --UNCHK
lin bookable_A = mkWA (k10 "oleva") "varattavissa" ; --UNCHK
lin bookbinder_N = mkWN (compoundN "kirjan" (k10 "sitoja")) ; --UNCHK
lin bookbindery_N = mkWN (compoundN "kirjan" (k2 "sitomo")) ; --UNCHK
lin bookbinding_N = mkWN (compoundN "kirjan" (k9A "sidonta")) ; --UNCHK
lin bookcase_N = mkWN (compoundN "kirja" (k5A "kaappi")) ; --UNCHK
lin bookclub_N = mkWN (compoundN "kirja" (k1 "kerho")) ; --UNCHK
lin bookdealer_N = mkWN (compoundN "kirja" (k10 "myyjä")) ; --UNCHK
lin book_end_N = mkWN (compoundN "kirja" (k7A "tuki")) ; --UNCHK
lin booker_N = mkWN (compoundN "ohjelma" (k10 "myyjä")) ; --UNCHK
lin bookie_N = mkWN (compoundN "vedon" (k10 "välittäjä")) ; --UNCHK
lin booking_N = mkWN (k39 "varaus") ;
lin bookish_A = mkWA (compoundA "opin" (k38 "haluinen")) ; --UNCHK
lin bookishness_N = mkWN (compoundN "kirja" (k40 "viisaus")) ; --UNCHK
lin book_keeper_N = mkWN (compoundN "kirjan" (k10 "pitäjä")) ; --UNCHK
lin bookkeeping_N = mkWN (compoundN "kirjan" (k1A "pito")) ; --UNCHK
lin booklet_N = mkWN (k48A "esite") ;
lin booklouse_N = mkWN (compoundN "kirja" (k18 "täi")) ; --UNCHK
lin bookmaker_N = mkWN (compoundN "vedon" (k10 "välittäjä")) ; --UNCHK
lin bookmark_N = mkWN (compoundN "kirjan" (k5A "merkki")) ; --UNCHK
lin bookmarker_N = mkWN (compoundN "kirjan" (k5A "merkki")) ; --UNCHK
lin bookmobile_N = mkWN (compoundN "kirjasto" (k1 "auto")) ; --UNCHK
lin bookplate_N = mkWN (k39 "exlibris") ; --UNCHK
lin bookseller_N = mkWN (compoundN "kirja" (k41 "kauppias")) ; --UNCHK
lin bookshelf_N = mkWN (compoundN "kirja" (k1 "hylly")) ; --UNCHK
lin bookshop_N = mkWN (compoundN "kirja" (k9A "kauppa")) ; --UNCHK
lin bookstall_N = mkWN (compoundN "kirja" (k9A "kauppa")) ; --UNCHK
lin bookworm_N = mkWN (compoundN "kirja" (k10A "toukka")) ; --UNCHK
lin boom_N = mkN "buumi" ; --WN (k5 "puomi") ; ----ARB
lin boom_V = mkWV (k53 "kukoistaa") ; --UNCHK
lin boom_V2 = mkWV2 (k53 "kukoistaa") ; --UNCHK
lin boomerang_N = mkWN (compoundN "taka" (k1 "isku")) ; --UNCHK
lin boon_A = mkWA (k38 "läheinen") ; --UNCHK
lin boon_N = mkWN (k7 "onni") ; --UNCHK
lin boondoggle_N = mkWN (k39 "haaskaus") ; --UNCHK
lin boor_N = mkWN (k38 "raakalainen") ; --UNCHK
lin boorish_A = mkWA (k38 "sikamainen") ; --UNCHK
lin boorishness_N = mkWN (k40 "sivistymättömyys") ; --UNCHK
lin boost_N = mkN (lin NK {s = d07A "tuki"}) ;
lin boost_V2 = mkV2 "vahvistaa" partitive ;
lin booster_N = mkWN (k48 "tehoste") ; --UNCHK
lin boot_N = L.boot_N ;
lin boot_V2 = mkWV2 (k53 "käynnistää") "uudelleen" ; --UNCHK
lin bootblack_N = mkWN (k10 "kengänkiillottaja") ; --UNCHK
lin bootee_N = mkWN (k38 "töppönen") ; --UNCHK
lin booth_N = mkWN (kH1 "koppi") ;
lin boothose_N = mkWN (k10A "sukka") ; --UNCHK
lin bootjack_N = mkWN (compoundN "saapas" (k5A "renki")) ; --UNCHK
lin bootlace_N = mkWN (compoundN "kengän" (k9 "nauha")) ; --UNCHK
lin bootle_PN = foreignPN "Bootle" ;
lin bootleg_A = mkWA (k5 "pörssi") "musta" ; --UNCHK
lin bootleg_N = mkWN (compoundN "kengän" (k28 "varsi")) ; --UNCHK
lin bootleg_V2 = mkWV2 (k62 "kopioida") ; --UNCHK
lin bootlegger_N = mkWN (k6 "trokari") ; --UNCHK
lin bootlegging_N = mkWN "trokaaminen" ; --UNCHK
lin bootless_A = mkWA (k10 "tyhjä") ; --UNCHK
lin bootlicking_A = mkWA (compoundA "mieliste" (k10 "levä")) ; --UNCHK
lin bootmaker_N = mkWN (k6 "suutari") ; --UNCHK
lin bootstrap_N = mkWN (compoundN "saappaan" (k5 "raksi")) ; --UNCHK
lin booty_N = mkWN (k41 "saalis") ; --UNCHK
lin booze_N = mkWN (k10 "juoma") "vahva" ; --UNCHK
lin booze_V = mkWV (k73A "ryypätä") ; --UNCHK
lin boozer_N = mkWN (k6 "juomari") ; --UNCHK
lin boozy_A = mkWA (k38 "humalainen") ; --UNCHK
lin bop_N = mkWN (k5 "bebop") ; --UNCHK
lin bopeep_N = mkWN (compoundN "kurkistus" (k5A "leikki")) ; --UNCHK
lin boracic_A = mkWA "boori-" ; --UNCHK
lin borage_N = mkWN (compoundN "kurkku" (k5A "yrtti")) ; --UNCHK
lin borate_N = mkWN "boraatti" ; --UNCHK
lin borated_A = mkWA "borated" ; --UNCHK
lin borax_N = mkWN (compoundN "boo" (k5 "raksi")) ; --UNCHK
lin bordeaux_N = mkWN (k5 "bordeauxviini") ; --UNCHK
lin bordeaux_PN = foreignPN "Bordeaux" ;
lin bordelaise_N = mkWN (compoundN "bordelaise" (k48A "kastike")) ; --UNCHK
lin border_N = mkN "raja" ;
lin border_V = mkWV (k52A "liittyä") "päittäin" ; --UNCHK
lin border_V2 = mkWV2 (k52A "liittyä") "päittäin" ; --UNCHK
lin border_on_V2 = mkWV2 (k52 "lähestyä") ; --UNCHK
lin borderer_N = mkWN (compoundN "rajaseutu" (k38 "lainen")) ; --UNCHK
lin borderland_N = mkWN (compoundN "raja" (k18 "maa")) ; --UNCHK
lin borderline_A = mkWA (k38 "marginaalinen") ; --UNCHK
lin borderline_N = mkWN (kH1 "raja") ; --UNCHK
lin bordon_PN = foreignPN "Bordon" ;
lin bore_N = mkWN (compoundN "poraus" (k1A "aukko")) ; --UNCHK
lin bore_V = mkWV (k73 "kairata") ; ---ARB --mkV "ikävystyä" ;
lin bore_V2 = mkWV2 (k73 "kairata") ; --UNCHK
lin boreal_A = mkWA (compoundA "borea" (k38 "alinen")) ; --UNCHK
lin bored_A = variants {} ; --
lin boredom_N = mkWN (k40 "ikävystyttävyys") ; --UNCHK
lin borer_N = mkWN (k34A "selkärangaton") ; --UNCHK
lin boric_A = mkWA "boori-" ; --UNCHK
lin boring_A = mkA "ikävystyttävä" ;
lin boring_N = mkWN (k39 "poraus") ; --UNCHK
lin boringness_N = mkWN (k40 "ikävystyttävyys") ; --UNCHK
lin bornite_N = mkWN (compoundN "kupari" (k1 "kiisu")) "kirjava" ; --UNCHK
lin boron_N = mkWN (k5 "boori") ; --UNCHK
lin boronic_A = mkWA "boori-" ; --UNCHK
lin borosilicate_N = mkWN (compoundN "boro" (k5A "silikaatti")) ; --UNCHK
lin borough_N = mkN "kauppala" ; --UNCHK
lin borrelia_N = mkWN "Borrelia" ; --UNCHK
lin borrow_V = mkWV (k53A "ottaa") "lainaksi" ; --f59
lin borrow_V2 = mkV2 "lainata" | mkWV2 (k53A "ottaa") "lainaksi" ;
lin borrow_VV = mkWVV (k53A "ottaa") "lainaksi" ; --UNCHK
lin borrower_N = mkWN (k10 "lainaaja") ; --UNCHK
lin borrowing_N = mkWN (compoundN "oma" (k38 "ksuminen")) ; --UNCHK
lin borsch_N = mkWN (k5 "borštš") ; --UNCHK
lin borstal_N = mkWN (compoundN "koulu" (k5A "koti")) ; --UNCHK
lin borzoi_N = mkWN "venäjänvinttikoira" ; --UNCHK
lin bosc_N = mkWN "bosc" ; --UNCHK
lin bosh_N = mkWN (k5 "humpuuki") ; --UNCHK
lin bosk_N = mkWN (k4A "metsikkö") ; --UNCHK
lin boskopoid_A = mkWA "boskopoidi" ; --UNCHK
lin bosky_A = mkWA (k38 "pensaikkoinen") ; --UNCHK
lin bosom_N = mkWN (k10 "hoiva") ; --UNCHK
lin bosomed_A = mkWA (k41A "kurvikas") ; --UNCHK
lin bosomy_A = mkWA (k38 "täyteläinen") ; --UNCHK
lin boson_N = mkWN (k6 "bosoni") ; --UNCHK
lin boss_A = mkWA (k38 "erinomainen") ; --UNCHK
lin boss_N = L.boss_N | mkWN (compoundN "esi" (k42 "mies")) ;
lin boss_V2 = mkWV2 (k73 "leimata") ; --UNCHK
lin boss_around_V2 = mkWV2 (k67A "komennella") ; --UNCHK
lin bossism_N = mkWN "bossism" ; --UNCHK
lin bossy_A = mkWA (k15 "pöyhkeä") ; --UNCHK
lin boston_PN = foreignPN "Boston" ;
lin bot_N = mkWN (compoundN "nauta" (k38 "kiiliäinen")) ; --UNCHK
lin bota_N = mkWN "bota" ; --UNCHK
lin botanic_A = mkWA (k38 "botaaninen") ; --UNCHK
lin botanical_A = mkWA (k38 "botaaninen") ; --UNCHK
lin botanical_N = mkWN (k48A "lääke") "kasviperäinen" ; --UNCHK
lin botanist_N = mkWN (k5 "botanisti") ; --UNCHK
lin botanize_V = mkWV (k61 "tutkia") "kasveja" ; --UNCHK
lin botany_N = mkWN (k9A "botaniikka") ; --UNCHK
lin botch_N = mkWN (k48 "virhe") ; --UNCHK
lin botch_V2 = mkWV2 (k71 "tehdä") "virhe" ; --UNCHK
lin botch_up_V2 = mkWV2 (k71 "tehdä") "virhe" ; --UNCHK
lin botcher_N = mkWN (k10 "hutiloija") ; --UNCHK
lin botchy_A = mkWA (k34A "taidoton") ; --UNCHK
lin botfly_N = mkWN (k38 "kiiliäinen") ; --UNCHK
lin both7and_DConj = S.both7and_DConj ;
lin both_Adv = mkAdv "molemmat" ; ---- cat
lin both_Det = mkDet Pl (mkN "molempi" "molemman" "molempia") ;
lin bother_N = mkWN (k9 "riesa") ; --UNCHK
lin bother_V = mkV "vaivautua" ; --mkWV (k53A "ottaa") "päähän" ;
lin bother_V2 = mkV2 "vaivata" partitive ; --mkWV2 (k53A "ottaa") "päähän" ;
lin bother_V2V = mkWV2V (k53A "ottaa") "päähän" ; --UNCHK
lin bother_VV = variants {} ; -- mkWV2V (k53A "ottaa") "päähän" ; --UNCHK
lin bothersome_A = mkWA (k10 "rasittava") ; --UNCHK
lin botonee_A = mkWA "botonnee" ; --UNCHK
lin botryoid_A = mkWA (compoundA "viini" (k38 "rypälemäinen")) ; --UNCHK
lin botswana_PN = foreignPN "Botswana" ;
lin bottle_N = mkWN (k1 "pullo") ; --UNCHK
lin bottle_V2 = mkV2 "pullottaa" partitive ;
lin bottle_up_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin bottlebrush_N = mkWN (compoundN "pullo" (k9 "harja")) ; --UNCHK
lin bottlecap_N = mkWN (compoundN "pullon" (k5A "korkki")) ; --UNCHK
lin bottleneck_N = mkWN (compoundN "pullon" (k9 "kaula")) ; --UNCHK
lin bottler_N = mkWN (compoundN "pull" (k10 "ottaja")) ; --UNCHK
lin bottom_A = mkWA (k36 "alin") ; --UNCHK
lin bottom_N = mkN "pohja" ;
lin bottom_V = mkWV (k53A "käsittää") ; --UNCHK
lin bottom_out_V = mkWV (k73 "törmätä") ; --UNCHK
lin bottomed_A = mkWA (k38 "-pohjainen") ; --UNCHK
lin bottomland_N = mkWN (compoundN "joki" (k1 "laakso")) ; --UNCHK
lin bottomless_A = mkWA (compoundA "ala" (k34A "osaton")) ; --UNCHK
lin bottomlessness_N = mkWN "pohjattomuus" ; --UNCHK
lin bottommost_A = mkWA (k36 "alin") ; --UNCHK
lin bottrop_PN = foreignPN "Bottrop" ;
lin botuliform_A = mkWA (compoundA "makkaran" (k38 "muotoinen")) ; --UNCHK
lin botulin_N = mkWN (k5 "botuliini") ; --UNCHK
lin botulinal_A = mkWA "botuliini-" ; --UNCHK
lin botulinus_N = mkWN (compoundN "botulinus-bak" (k26 "teeri")) ; --UNCHK
lin botulism_N = mkWN (k5 "botulismi") ; --UNCHK
lin boucle_N = mkWN (k20 "buklee") ; --UNCHK
lin boudoir_N = mkWN (compoundN "budo" (k5 "aari")) ; --UNCHK
lin bouffant_A = mkWA (k15 "pullea") ; --UNCHK
lin bough_N = mkWN (k10 "oksa") ; --UNCHK
lin boughed_A = mkWA (k38 "oksainen") ; --UNCHK
lin boughless_A = mkWA "oksaton" ; --UNCHK
lin boughten_A = mkWA "ostettu" ; --UNCHK
lin bouillabaisse_N = mkWN (k8 "bouillabaisse") ; --UNCHK
lin bouillon_N = mkWN (compoundN "liha" (k25 "liemi")) ; --UNCHK
lin boulder_N = mkWN "Boulder" ; --UNCHK
lin boulevard_N = mkWN (k5 "bulevardi") ; --UNCHK
lin boulevardier_N = mkWN (k12 "kävelijä") ; --UNCHK
lin boulle_N = mkWN (compoundN "boulle-" (k39 "upotus")) ; --UNCHK
lin bounce_N = mkWN (k39 "hyppäys") ; --UNCHK
lin bounce_V = mkWV (k53A "hyppäyttää") ; --UNCHK
lin bounce_V2 = mkWV2 (k53A "hyppäyttää") ; --UNCHK
lin bounce_back_V = mkWV (k52A "toipua") ; --UNCHK
lin bouncer_N = mkWN (k6 "portsari") ; --UNCHK
lin bouncy_A = mkWA (k14A "terhakka") ; --UNCHK
lin bound_N = mkWN (k39 "hyppäys") ; --UNCHK
lin bound_V = mkWV (k54A "vähentää") ; --UNCHK
lin bound_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin bound_V2V = mkWV2V (k54A "vähentää") ; --UNCHK
lin boundary_N = mkWN (kH1 "raja") ; --UNCHK
lin bounden_A = mkWA (k38 "moraalinen") ; --UNCHK
lin bounder_N = mkWN (k10 "hyppääjä") ; --UNCHK
lin boundless_A = mkWA (k34A "ääretön") ; --UNCHK
lin bounteous_A = mkWA (k10 "lukuisa") ; --UNCHK
lin bountied_A = mkWA "palkittu" ; --UNCHK
lin bountiful_A = mkWA (k41 "runsas") ; --UNCHK
lin bounty_N = mkWN "H.M.S." "Bounty" ;
lin bouquet_N = mkWN (compoundN "kukka" (k1 "vihko")) ; --UNCHK
lin bourbon_N = mkWN (k6 "bourbon") ; --UNCHK
lin bourgeois_A = mkWA (k38 "porvarillinen") ; --UNCHK
lin bourgeois_N = mkWN (k32 "jäsen") "keskiluokan" ; --UNCHK
lin bourgeoisie_N = mkWN (k1 "porvaristo") ; --UNCHK
lin bourguignon_N = mkWN (compoundN "burgundin" (k48A "kastike")) ; --UNCHK
lin bourn_N = mkWN (k48A "kohde") ; --UNCHK
lin bourne_N = mkWN (k48A "kohde") ; --UNCHK
lin bourne_PN = foreignPN "Bourne" ;
lin bournemouth_PN = foreignPN "Bournemouth" ;
lin bourse_N = mkWN "Bourse" ; --UNCHK
lin bourtree_N = mkWN (compoundN "seljan" (k9 "marja")) ; --UNCHK
lin boustrophedon_N = mkWN "bustrofedon" ; --UNCHK
lin boustrophedonic_A = mkWA "boustrofedoninen" ; --UNCHK
lin bout_N = mkN "kausi" ; --mkWN (compoundN "juoma" (k27 "kausi")) ;
lin boutique_N = mkWN (k5A "putiikki") ; --UNCHK
lin boutonniere_N = mkWN (compoundN "napinläpi" (k10A "kukka")) ; --UNCHK
lin bovid_N = mkWN (compoundN "ontto" (k38 "sarvinen")) ; --UNCHK
lin bovine_A = mkWA "karja-" ; --UNCHK
lin bovine_N = mkWN (k9A "nauta") ; --UNCHK
lin bovril_N = mkWN (compoundN "liha" (k48A "uute")) ; --UNCHK
lin bow_N = mkWN "bow" ; --UNCHK
lin bow_V = mkWV (k56A "antaa") "myöten" ; --UNCHK
lin bow_V2 = mkWV2 (k56A "antaa") "myöten" ; --UNCHK
lin bowdlerization_N = mkWN (k5A "sensurointi") ; --UNCHK
lin bowdlerize_V2 = mkWV2 (k54A "lyhentää") ; --UNCHK
lin bowel_N = mkWN (k2 "suolisto") ; --UNCHK
lin bower_N = mkWN (k12 "pergola") ; --UNCHK
lin bowerbird_N = mkWN (k10 "lavastaja") ; --UNCHK
lin bowery_A = mkWA (k10 "lehtevä") ; --UNCHK
lin bowfin_N = mkWN "Amia" "calva" ; --UNCHK
lin bowfront_A = mkWA (k10 "kupera") ; --UNCHK
lin bowhead_N = mkWN (compoundN "grönlannin" (k41 "valas")) ; --UNCHK
lin bowie_knife_N = mkWN (compoundN "bowie-" (k30 "veitsi")) ; --UNCHK
lin bowing_N = mkWN (k1A "soitto") ; --UNCHK
lin bowl_N = mkWN (k39 "vieritys") ; --UNCHK
lin bowl_V = mkWV (k73 "keilata") ; --UNCHK
lin bowl_V2 = mkWV2 (k73 "keilata") ; --UNCHK
lin bowl_over_V2 = mkWV2 (k53A "tyrmistyttää") ; --UNCHK
lin bowleg_N = mkWN (k9 "vara") "tibia" ; --UNCHK
lin bowler_N = mkWN (k5 "knalli") ; --UNCHK
lin bowline_N = mkWN (compoundN "paalu" (k1 "solmu")) ; --UNCHK
lin bowling_N = mkWN (k2 "keilailu") ; --UNCHK
lin bowling_green_N = mkWN (k10A "kenttä") ; --UNCHK
lin bowls_N = mkWN (compoundN "nurmi" (k2 "keilailu")) ; --UNCHK
lin bowman_N = mkWN (compoundN "jousi" (k42 "mies")) ; --UNCHK
lin bowsprit_N = mkWN (compoundN "kokka" (k18 "puu")) ; --UNCHK
lin bowstring_N = mkWN (k48A "jänne") ; --UNCHK
lin box_N = mkN "laatikko" | mkWN (k41A "lipas") ;
lin box_V = mkWV (k67 "nyrkkeillä") ; --UNCHK
lin box_V2 = mkWV2 (k67 "nyrkkeillä") ; --UNCHK
lin box_in_V2 = mkWV2 (k53 "ahdistaa") "nurkkaan" ; --UNCHK
lin box_kite_N = mkWN (compoundN "laatikko" (k9 "leija")) ; --UNCHK
lin box_number_N = mkWN (compoundN "postilokero-" (k48A "osoite")) ; --UNCHK
lin box_office_N = mkWN (compoundN "lippu" (k1A "luukku")) ; --UNCHK
lin box_up_V2 = mkWV2 (k53 "ahdistaa") "nurkkaan" ; --UNCHK
lin boxcar_N = mkWN (compoundN "boksi" (k9 "nahka")) ; --UNCHK
lin boxcars_N = mkWN (k12 "tusina") ; --UNCHK
lin boxer_N = mkWN (k6 "bokseri") ; --UNCHK
lin boxfish_N = mkWN (compoundN "lossero" (k9 "kala")) ; --UNCHK
lin boxful_N = mkWN (k38 "rasiallinen") ; --UNCHK
lin boxing_N = mkWN (compoundN "pakka" (k38 "aminen")) ; --UNCHK
lin boxing_day_N = mkWN (k5 "tapani") ; --UNCHK
lin boxing_glove_N = mkWN (k9 "hanska") ; --UNCHK
lin boxing_match_N = mkWN (compoundN "nyrkkeily" (k2 "ottelu")) ; --UNCHK
lin boxlike_A = mkWA (compoundA "laatikko" (k38 "mainen")) ; --UNCHK
lin boxwood_N = mkWN (compoundN "puksi" (k18 "puu")) ; --UNCHK
lin boy_N = L.boy_N ;
lin boycott_N = mkWN (k5A "boikotti") ; --UNCHK
lin boycott_V2 = mkWV2 (k62 "boikotoida") ; --UNCHK
lin boyfriend_N = mkWN (k4A "nuorikko") ; --UNCHK
lin boyhood_N = mkWN (k40 "poikuus") ; --UNCHK
lin boyish_A = mkWA (k38 "poikamainen") ; --UNCHK
lin boyishness_N = mkWN (k40 "poikamaisuus") ; --UNCHK
lin boysenberry_N = mkWN (compoundN "boysen" (k9 "marja")) ; --UNCHK
lin bra_N = mkN "rinta" (mkN "liivi") ;
lin brace_N = mkWN (k50 "vinotuki") ; --UNCHK
lin brace_V = mkV "valmistautua" ;
lin brace_V2 = mkWV2 (k62 "stimuloida") ; --UNCHK
lin brace_up_V = mkWV (k58A "tukea") ; --UNCHK
lin bracelet_N = mkWN (compoundN "ranne" (k41A "rengas")) ; --UNCHK
lin bracer_N = mkWN (compoundN "krapula" (k1A "ryyppy")) ; --UNCHK
lin bracero_N = mkWN (compoundN "siirto" (k38 "työläinen")) ; --UNCHK
lin brachial_A = mkWA "olkavarsi-" ; --UNCHK
lin brachiate_A = mkWA (compoundA "käsi" (k38 "varrellinen")) ; --UNCHK
lin brachiation_N = mkWN (compoundN "roik" (k38 "kuminen")) ; --UNCHK
lin brachiopod_A = mkWA (compoundA "lonkero" (k38 "jalkainen")) ; --UNCHK
lin brachiopod_N = mkWN (compoundN "lonkero" (k38 "jalkainen")) ; --UNCHK
lin brachium_N = mkWN (compoundN "olka" (k28 "varsi")) ; --UNCHK
lin brachycephalic_A = mkWA (compoundA "brakykefa" (k38 "alinen")) ; --UNCHK
lin brachycephalic_N = mkWN (compoundN "lyhytkal" (k38 "loinen")) ; --UNCHK
lin brachycephaly_N = mkWN "brakykefalia" ; --UNCHK
lin brachydactylic_A = mkWA (compoundA "lyhyt" (k38 "varpainen")) ; --UNCHK
lin brachydactyly_N = mkWN "brakydaktylia" ; --UNCHK
lin brachypterous_A = mkWA (compoundA "lyhyt" (k38 "siipinen")) ; --UNCHK
lin brachyurous_A = mkWA "taskuravut" ; --UNCHK
lin bracken_N = mkWN (compoundN "sanan" (k9A "jalka")) ; --UNCHK
lin bracket_N = mkWN (k33A "pidin") ; --UNCHK
lin bracket_V2 = mkWV2 (k67A "ryhmitellä") ; --UNCHK
lin brackish_A = mkWA (k38 "suolainen") ; --UNCHK
lin brackishness_N = mkWN (k40 "suolaisuus") ; --UNCHK
lin bracknell_PN = foreignPN "Bracknell" ;
lin bract_N = mkWN (compoundN "suoja" (k7A "lehti")) ; --UNCHK
lin bracteal_A = mkWA (compoundA "suo" (k38 "juslehtimäinen")) ; --UNCHK
lin bracteate_A = mkWA (compoundA "suojus" (k38 "lehtinen")) ; --UNCHK
lin bracteolate_A = mkWA (compoundA "suojus" (k38 "lehtinen")) ; --UNCHK
lin bracteole_N = mkWN (compoundN "suojus" (k7A "lehti")) ; --UNCHK
lin brad_N = mkWN (k9 "naula") ; --UNCHK
lin bradawl_N = mkWN (k33 "purasin") ; --UNCHK
lin bradford_PN = foreignPN "Bradford" ;
lin bradycardia_N = mkWN (compoundN "bradykar" (k9 "dia")) ; --UNCHK
lin brae_N = mkWN (k48A "rinne") ; --UNCHK
lin brag_N = mkWN (k2 "mahtailu") ; --UNCHK
lin brag_V = mkWV (k67A "rehennellä") ; --UNCHK
lin braggadocio_N = mkWN (k2 "mahtailu") ; --UNCHK
lin braggart_N = mkWN (k6 "öykkäri") ; --UNCHK
lin bragger_N = mkWN (k6 "öykkäri") ; --UNCHK
lin bragging_N = mkWN (k2 "mahtailu") ; --UNCHK
lin brahman_N = mkWN (compoundN "ryhä" (k10A "härkä")) ; --UNCHK
lin brahmin_N = mkWN (compoundN "ryhä" (k10A "härkä")) ; --UNCHK
lin brahminic_A = mkWA (compoundA "brah" (k38 "maaninen")) ; --UNCHK
lin braid_N = mkWN (k5 "nyöri") ; --UNCHK
lin braid_V2 = mkWV2 (k62 "palmikoida") ; --UNCHK
lin brail_N = mkWN "supistin" ; --UNCHK
lin braille_N = mkWN (compoundN "piste" (k39 "kirjoitus")) ; --UNCHK
lin brain_N = mkN "aivo" ;
lin brain_V2 = mkWV2 (k73 "murskata") "kallo" ; --UNCHK
lin brainchild_N = mkWN (k39 "luomus") ; --UNCHK
lin brainless_A = mkWA (k10 "typerä") ; --UNCHK
lin brainsick_A = mkWA (k99 "tolaltaan") "poissa" ; --UNCHK
lin brainstem_N = mkWN (compoundN "aivo" (k1A "runko")) ; --UNCHK
lin brainstorm_N = mkWN (k39 "neronleimaus") ; --UNCHK
lin brainstorming_N = mkWN (compoundN "aivo" (k23 "riihi")) ; --UNCHK
lin braintree_PN = foreignPN "Braintree" ;
lin brainwash_V2 = mkWV2 (compoundV "aivo" (k66 "pestä")) ; --UNCHK
lin brainwashing_N = mkWN (compoundN "aivo" (k1 "pesu")) ; --UNCHK
lin brainwave_N = mkWN (k39 "neronleimaus") ; --UNCHK
lin brainworker_N = mkWN "aivotyöskentelijä" ; --UNCHK
lin brainy_A = mkWA (k10 "terävä") ; --UNCHK
lin braise_V2 = mkWV2 (k54A "muhentaa") ; --UNCHK
lin braising_N = mkWN (compoundN "hau" (k38 "duttaminen")) ; --UNCHK
lin brake_N = mkWN (k1 "jarru") ;
lin brake_V = mkWV (k53A "jarruttaa") ; --UNCHK
lin brake_V2 = mkWV2 (k53A "jarruttaa") ; --UNCHK
lin brakeman_N = mkWN (compoundN "jarru" (k42 "mies")) ; --UNCHK
lin braky_A = mkWA (k41 "vehmas") ; --UNCHK
lin bramble_N = mkWN (k14A "vatukka") ; --UNCHK
lin brambling_N = mkWN (compoundN "järri" (k1A "peippo")) ; --UNCHK
lin bran_N = mkWN (k48 "lese") ;
lin branch_N = mkWN (k9 "haara") | mkN "oksa" ; ---- split
lin branch_V = mkWV (k52A "erkaantua") ; --UNCHK
lin branch_out_V = mkWV (k52A "laajentua") ; --UNCHK
lin branched_A = mkWA (k41A "haarakas") ; --UNCHK
lin branchial_A = mkWA (compoundA "brankia" (k38 "alinen")) ; --UNCHK
lin branchiate_A = mkWA "kiduksellinen" ; --UNCHK
lin branching_N = mkWN (compoundN "haa" (k38 "roittuminen")) ; --UNCHK
lin branchiopod_A = mkWA "kidusjalkainen" ; --UNCHK
lin branchless_A = mkWA "oksaton" ; --UNCHK
lin branchlet_N = mkWN (k1 "verso") ; --UNCHK
lin branchy_A = mkWA (k38 "oksainen") ; --UNCHK
lin brand_N = mkN "tavaramerkki" ;
lin brand_V2 = mkWV2 (k73 "leimata") ; --UNCHK
lin branding_iron_N = mkWN (compoundN "poltin" (k9A "rauta")) ; --UNCHK
lin brandish_V2 = mkWV2 (k53 "heristää") ; --UNCHK
lin brandy_N = mkWN (k1 "brandy") ; --UNCHK
lin brandy_ball_N = mkWN (compoundN "likööri" (k5A "konvehti")) ; --UNCHK
lin brandy_snap_N = mkWN (compoundN "brandy" (k38 "leivonnainen")) ; --UNCHK
lin brant_N = mkWN (compoundN "sepel" (k7 "hanhi")) ; --UNCHK
lin brash_A = mkWA (k10 "tunkeileva") ; --UNCHK
lin brashness_N = mkWN (k40 "harkitsemattomuus") ; --UNCHK
lin brass_N = mkWN (k7 "torvi") ; --UNCHK
lin brassard_N = mkWN (compoundN "käsivarsi" (k39 "suojus")) ; --UNCHK
lin brassavola_N = mkWN "brassavola" ; --UNCHK
lin brassbound_A = mkWA (k38 "messinkinen") ; --UNCHK
lin brasserie_N = mkWN (k12 "kuppila") ; --UNCHK
lin brassie_N = mkWN "brassie" ; --UNCHK
lin brassiere_N = variants {} ;
lin brassy_A = mkWA (k38 "metallinen") ; --UNCHK
lin brat_N = mkWN (k5 "braatvursti") ; --UNCHK
lin bratislava_PN = foreignPN "Bratislava" ;
lin brattice_N = mkWN (compoundN "väli" (k39 "laudoitus")) ; --UNCHK
lin bratty_A = mkWA (k34A "kuriton") ; --UNCHK
lin bratwurst_N = mkWN (k5 "braatvursti") ; --UNCHK
lin braunschweig_PN = foreignPN "Braunschweig" ;
lin braunton_PN = foreignPN "Braunton" ;
lin bravado_N = mkWN (k2 "mahtailu") ; --UNCHK
lin brave_A = mkWA (k38 "urhoollinen") ; --UNCHK
lin brave_V2 = mkWV2 (k73A "kohdata") "rohkeasti" ; --UNCHK
lin bravery_N = mkWN (k40 "urhoollisuus") ; --UNCHK
lin bravo_N = mkWN (compoundN "bravo-" (k1A "huuto")) ; --UNCHK
lin bravura_N = mkWN (k40 "taituruus") ; --UNCHK
lin brawl_N = mkWN (k2 "tappelu") ; --UNCHK
lin brawl_V = mkWV (k62 "nujakoida") ; --UNCHK
lin brawler_N = mkWN (k12 "rähinöitsijä") ; --UNCHK
lin brawn_N = mkWN (k10 "voima") ; --UNCHK
lin brawny_A = mkWA (k11 "vanttera") ; --UNCHK
lin bray_N = mkWN (k2 "kiljaisu") ; --UNCHK
lin bray_V2 = mkWV2 (k52 "ulvoa") ; --UNCHK
lin braze_V2 = mkWV2 (k53A "juottaa") ; --UNCHK
lin brazen_A = mkWA (k38 "messinkinen") ; --UNCHK
lin brazier_N = mkWN (compoundN "hiili" (k1 "pannu")) ; --UNCHK
lin brazil_PN = foreignPN "Brasilia" ;
lin brazilian_A = mkWA (compoundA "brasili" (k38 "alainen")) ; --UNCHK
lin brazilian_N = mkWN (compoundN "brasili" (k38 "alainen")) ; --UNCHK
lin brazilwood_N = mkWN (compoundN "echi" (k9A "nata")) "Caesalpinia" ; --UNCHK
lin breach_N = mkWN (k39 "rikkomus") ; --UNCHK
lin breach_V2 = mkV2 "rikkoa" partitive ; --mkWV2 (k71 "tehdä") "aukko" ;
lin bread_N = L.bread_N ;
lin breadbasket_N = mkWN (compoundN "leipä" (k5 "kori")) ; --UNCHK
lin breadboard_N = mkWN (compoundN "leikkuu" (k9A "lauta")) ; --UNCHK
lin breadcrumb_N = mkWN (compoundN "korppu" (k1 "jauho")) ; --UNCHK
lin breadfruit_N = mkWN (k10 "hedelmä") "leipäpuun" ; --UNCHK
lin breadline_N = mkWN (compoundN "leipä" (k1 "jono")) ; --UNCHK
lin breadroot_N = mkWN "Psoralea" "esculenta" ; --UNCHK
lin breadstick_N = mkWN (compoundN "leipä" (k1A "tikku")) ; --UNCHK
lin breadth_N = mkWN (k40 "laajuus") ; --UNCHK
lin breadthways_Adv = mkWAdv (compoundAdv "leveys" (k99 "suuntaisesti")) ; --UNCHK
lin breadthwise_Adv = mkWAdv (compoundAdv "leveys" (k99 "suuntaisesti")) ; --UNCHK
lin breadwinner_N = mkWN (k10 "elättäjä") "perheen" ; --UNCHK
lin break_N = mkN "tauko" ;
lin break_V = mkV "murtua" ;
lin break_V2 = L.break_V2 ;
lin break_apart_V = mkWV (k74 "hajota") ; --UNCHK
lin break_away_V = mkWV (k74 "katketa") ; --UNCHK
lin break_down_V = mkWV (k52 "lyyhistyä") ; --UNCHK
lin break_down_V2 = mkWV2 (k52 "lyyhistyä") ; --UNCHK
lin break_in_V = mkWV (k56 "ajaa") "sisään" ; --UNCHK
lin break_in_V2 = mkWV2 (k56 "ajaa") "sisään" ; --UNCHK
lin break_in_on_V2 = prepV2 (advV OP_break_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin break_into_V2 = mkWV2 (k74A "ruveta") ; --UNCHK
lin break_off_V2 = mkWV2 (k53A "keskeyttää") ; --UNCHK
lin break_out_V = mkWV (k52A "ilmaantua") ; --UNCHK
lin break_out_V2 = mkWV2 (k52A "ilmaantua") ; --UNCHK
lin break_out_in_V2 = prepV2 (advV OP_break_V OP_out_Adv ) OP_in_Prep ; -- guess-p-verb
lin break_out_of_V2 = prepV2 (advV OP_break_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin break_through_V2 = mkWV2 (k67 "tulla") "esiin" ; --UNCHK
lin break_up_V = mkWV (k53A "hohottaa") ; --UNCHK
lin break_up_V2 = mkWV2 (k53A "hohottaa") ; --UNCHK
lin breakable_A = mkWA (k41 "hauras") ; --UNCHK
lin breakable_N = mkWN (k12 "tavara") "hauras" ; --UNCHK
lin breakableness_N = mkWN (k40 "hauraus") ; --UNCHK
lin breakage_N = mkWN (compoundN "rikko" (k38 "utuminen")) ; --UNCHK
lin breakaway_A = mkWA (k38 "separatistinen") ; --UNCHK
lin breakaway_N = mkWN (compoundN "irti" (k1A "otto")) ; --UNCHK
lin breakax_N = mkWN "Sloanea" "jamaicensis" ; --UNCHK
lin breakdown_N = mkWN (k3 "häiriö") ; --UNCHK
lin breaker_N = mkN "tyrsky" ; --WN (compoundN "automaatti" (k48A "sulake")) ; ----ARB
lin breakfast_N = mkWN (k38 "aamiainen") ; --UNCHK
lin breakneck_A = mkWA (k10 "hurja") ; --UNCHK
lin breakthrough_N = mkWN (compoundN "läpi" (k1A "murto")) ;
lin breakwater_N = mkWN (compoundN "ranta" (k49A "penger")) ; --UNCHK
lin bream_N = mkWN (k9 "lahna") ; --UNCHK
lin breast_N = L.breast_N ;
lin breast_V2 = mkWV2 (k73A "kohdata") ; --UNCHK
lin breastfeed_V = mkWV (k53A "imettää") ; --UNCHK
lin breastfeed_V2 = mkWV2 (k53A "imettää") ; --UNCHK
lin breastless_A = mkWA "rinnaton" ; --UNCHK
lin breast_plate_N = mkWN (compoundN "rinta" (k39 "suojus")) ; --UNCHK
lin breaststroke_N = mkWN (compoundN "rinta" (k5A "uinti")) ; --UNCHK
lin breaststroker_N = mkWN (compoundN "rinta" (k6 "uimari")) ; --UNCHK
lin breastwork_N = mkWN (k48A "kaide") ; --UNCHK
lin breath_N = mkWN (k2 "henkäisy") ;
lin breathalyser_N = mkWN (k5 "alkometri") ; --UNCHK
lin breathalyzer_N = mkWN (k5 "alkometri") ; --UNCHK
lin breathe_V = L.breathe_V ;
lin breathe_V2 = mkWV2 (k66 "henkäistä") ; --UNCHK
lin breather_N = mkWN (k6 "snorkkeli") ;
lin breathing_N = mkWN (k39 "hengitys") ; --UNCHK
lin breathing_space_N = mkWN (compoundN "hengitys" (k9 "tila")) ; --UNCHK
lin breathtaking_A = mkWA (k15 "huikea") ; --UNCHK
lin breccia_N = mkWN "breksia" ; --UNCHK
lin breda_PN = foreignPN "Breda" ;
lin breech_N = mkWN (compoundN "patruuna" (k10 "pesä")) ; --UNCHK
lin breech_block_N = mkWN (k1A "lukko") ; --UNCHK
lin breechcloth_N = mkWN (compoundN "lanne" (k48A "vaate")) ; --UNCHK
lin breeched_A = mkWA "housullinen" ; --UNCHK
lin breeches_buoy_N = mkWN (compoundN "pelastus" (k5 "tuoli")) ; --UNCHK
lin breechloader_N = mkWN (k48 "ase") "takaaladattava" ; --UNCHK
lin breed_N = mkN "rotu" ; --WN (k5A "tyyppi") ;
lin breed_V = mkWV (k52A "lisääntyä") ; --UNCHK
lin breed_V2 = mkWV2 (k52A "lisääntyä") ; --UNCHK
lin breeder_N = mkWN (k10 "kasvattaja") ; --UNCHK
lin breeding_N = mkWN (compoundN "lisä" (k38 "äntyminen")) ; --UNCHK
lin breeze_N = mkN "tuulen" (mkN "vire") ;
lin breeze_V = mkWV (k55A "liitää") ; --UNCHK
lin breeziness_N = mkWN (k40 "reippaus") ; --UNCHK
lin breezy_A = mkWA (k38 "tuulinen") ; --UNCHK
lin bregma_N = mkWN (compoundN "päälaki" (k48 "piste")) ; --UNCHK
lin bregmatic_A = mkWA "päälakipiste-" ; --UNCHK
lin bremen_PN = foreignPN "Bremen" ;
lin bremerhaven_PN = foreignPN "Bremerhaven" ;
lin bren_N = mkWN (compoundN "Bren-pikakiv" (k26 "ääri")) ; --UNCHK
lin bren_gun_N = mkWN (compoundN "Bren-pikakiv" (k26 "ääri")) ; --UNCHK
lin brent_PN = foreignPN "Brent" ;
lin brentwood_PN = foreignPN "Brentwood" ;
lin brescia_PN = foreignPN "Brescia" ;
lin brest_PN = foreignPN "Brest" ;
lin breve_N = mkWN (compoundN "lyhyys" (k5A "merkki")) ; --UNCHK
lin brevet_N = mkWN (k39 "nimitys") ; --UNCHK
lin breviary_N = mkWN (compoundN "rukous" (k9 "kirja")) ; --UNCHK
lin brevity_N = mkWN (k40 "suppeus") ; --UNCHK
lin brew_N = mkN "käymis_tuote" ;
lin brew_V = mkWV (k53A "hauduttaa") ; --UNCHK
lin brew_V2 = mkWV2 (k53A "hauduttaa") ; --UNCHK
lin brewer_N = mkN "oluen" (mkN "panija") ; --mkWN (compoundN "panimo" (k6 "mestari")) ;
lin brewery_N = mkWN (k2 "panimo") ; --UNCHK
lin brewing_N = mkWN (k1 "pano") ; --UNCHK
lin brewpub_N = mkWN (compoundN "panimo" (k12 "ravintola")) ; --UNCHK
lin brian_PN = mkPN "Brian" ;
lin briar_N = mkWN (compoundN "briar" (k1A "piippu")) ; --UNCHK
lin briard_N = mkWN "brienpaimenkoira" ; --UNCHK
lin briarroot_N = mkWN (compoundN "puu" (k10 "kanerva")) ; --UNCHK
lin briarwood_N = mkWN (compoundN "puu" (k10 "kanerva")) ; --UNCHK
lin bribable_A = mkWA (k10 "oleva") "ostettavissa" ; --UNCHK
lin bribe_N = mkWN (k39 "lahjus") ; --UNCHK
lin bribe_V = mkV "lahjoa" ; --mkWV (k53 "ostaa") ;
lin bribe_V2 = mkWV2 (k53 "ostaa") ; --UNCHK
lin briber_N = mkWN (compoundN "lahjuksen" (k10 "antaja")) ; --UNCHK
lin bribery_N = mkWN (k9A "lahjonta") ;
lin brick_N = mkWN (k23 "tiili") ; --UNCHK
lin brick_in_V2 = mkWV2 (k73 "muurata") ; --UNCHK
lin brick_up_V2 = mkWV2 (k73 "muurata") ; --UNCHK
lin brickbat_N = mkWN (k39 "herjaus") ; --UNCHK
lin brickkiln_N = mkWN (compoundN "tiili" (k5 "uuni")) ; --UNCHK
lin bricklayer_N = mkWN (k6 "muurari") ; --UNCHK
lin bricklaying_N = mkWN (k39 "muuraus") ; --UNCHK
lin brickwork_N = mkWN (k39 "muuraus") ; --UNCHK
lin brickyard_N = mkWN (compoundN "tiili" (k41A "tehdas")) ; --UNCHK
lin bridal_A = mkWA "morsius-" ; --UNCHK
lin bride_N = mkWN (k33 "morsian") ; --UNCHK
lin bridecake_N = mkWN (compoundN "morsius" (k1A "kakku")) ; --UNCHK
lin bridegroom_N = mkWN (k38 "sulhanen") ; --UNCHK
lin bridesmaid_N = mkWN (k1 "kaaso") ; --UNCHK
lin bridge_N = mkN "silta" ;
lin bridge_V2 = mkWV2 (k53A "silloittaa") ; --UNCHK
lin bridgeable_A = mkWA "silloitettava" ; --UNCHK
lin bridgehead_N = mkWN (compoundN "sillanpää" (k10 "asema")) ; --UNCHK
lin bridgend_PN = foreignPN "Bridgend" ;
lin bridgnorth_PN = foreignPN "Bridgnorth" ;
lin bridgwater_PN = foreignPN "Bridgwater" ;
lin bridle_N = mkWN (k33A "pidätin") ; --UNCHK
lin bridle_V = mkWV (k53 "hidastaa") ; --UNCHK
lin bridle_V2 = mkWV2 (k53 "hidastaa") ; --UNCHK
lin bridle_path_N = mkWN (compoundN "ratsastus" (k1A "polku")) ; --UNCHK
lin bridle_road_N = mkWN (compoundN "ratsastus" (k1A "polku")) ; --UNCHK
lin bridlington_PN = foreignPN "Bridlington" ;
lin bridoon_N = mkWN "bridongi" ; --UNCHK
lin bridport_PN = foreignPN "Bridport" ;
lin brief_A = mkWA (k43 "lyhyt") ;
lin brief_N = mkWN (k3 "muistio") ; --UNCHK
lin brief_V2 = mkWV2 (k53A "tiedottaa") ; --UNCHK
lin briefcase_N = mkWN (k1A "salkku") ; --UNCHK
lin briefing_N = mkN "opastus" ; --mkWN (compoundN "käskyn" (k1A "jako")) ;
lin briefless_A = mkWA "toimeksiannoton" ; --UNCHK
lin briefness_N = mkWN (k40 "suppeus") ; --UNCHK
lin brier_N = mkWN (compoundN "puu" (k10 "kanerva")) ; --UNCHK
lin brig_N = mkWN (k12 "vankila") ; --UNCHK
lin brig_PN = foreignPN "Brig" ;
lin brigade_N = mkWN (k5 "prikaati") ; --UNCHK
lin brigadier_N = mkWN (compoundN "prikaatin" (k10 "komentaja")) ; --UNCHK
lin brigand_N = mkWN (k5A "bandiitti") ; --UNCHK
lin brigandine_N = mkWN (compoundN "rauta" (k9A "paita")) ; --UNCHK
lin brigantine_N = mkWN (k6 "kuunari") ; --UNCHK
lin brighouse_PN = foreignPN "Brighouse" ;
lin bright_A = mkWA (k10 "loistava") ;
lin bright_Adv = mkWAdv (k99 "kirkkaasti") ; --UNCHK
lin brighten_V = mkWV (k53 "piristää") ; --UNCHK
lin brighten_V2 = mkWV2 (k53 "piristää") ; --UNCHK
lin brightlingsea_PN = foreignPN "Brightlingsea" ;
lin brightness_N = mkWN (k40 "kirkkaus") ; --UNCHK
lin brighton_PN = foreignPN "Brighton" ;
lin brill_N = mkWN (compoundN "silo" (k13 "kampela")) ; --UNCHK
lin brilliance_N = mkWN (k40 "suuruus") ; --UNCHK
lin brilliancy_N = mkWN (k48 "loiste") ; --UNCHK
lin brilliant_A = mkWA (k10 "loistava") ;
lin brilliantine_N = mkWN (compoundN "hius" (k48A "voide")) ; --UNCHK
lin brim_N = mkWN (k5 "lieri") ; --UNCHK
lin brim_V = mkWV (k53A "täyttää") "piripintaan" ; --UNCHK
lin brimful_A = mkWA (k99 "piripinnassa") ; --UNCHK
lin brimfull_A = mkWA (k99 "piripinnassa") ; --UNCHK
lin brimless_A = mkWA "lieritön" ; --UNCHK
lin brimstone_N = mkWN (kH1 "rikki") ; --UNCHK
lin brindled_A = mkWA (k41A "juovikas") ; --UNCHK
lin brine_N = mkWN (compoundN "suola" (k27 "vesi")) ; --UNCHK
lin bring_V2 = mkV2 "tuoda" ;
lin bring_V3 = mkV3 (mkV "saattaa") accusative (mkPrep illative) ; --saattaa hänet vankilaan
lin bring_about_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin bring_along_V2 = prepV2 (lin V OP_bring_V2) OP_along_Prep ; -- guess-p-verb
lin bring_around_V2 = mkWV2 (k53A "herättää") ; --UNCHK
lin bring_away_V2 = mkV2 (advV (lin V OP_bring_V2) OP_away_Adv ) ; -- guess-p-verb
lin bring_back_V2 = mkWV2 (k53A "herättää") ; --UNCHK
lin bring_down_V2 = mkWV2 (k54A "madaltaa") ; --UNCHK
lin bring_forth_V = mkWV (k53A "siittää") ; --UNCHK
lin bring_forth_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin bring_forward_V2 = mkWV2 (k67A "esitellä") ; --UNCHK
lin bring_in_V2 = mkWV2 (k64 "tuoda") ; --UNCHK
lin bring_off_V2 = mkWV2 (k52A "suoriutua") ; --UNCHK
lin bring_on_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin bring_out_V2 = mkWV2 (k64 "tuoda") "esille" ; --UNCHK
lin bring_out_in_V3 = variants {} ; -- guess-p-verb
lin bring_over_V2 = prepV2 (lin V OP_bring_V2) OP_over_Prep ; -- guess-p-verb
lin bring_round_V2 = mkWV2 (k53A "herättää") ; --UNCHK
lin bring_to_V2 = mkWV2 (k53A "herättää") ; --UNCHK
lin bring_up_V2 = mkWV2 (k53 "käynnistää") "uudelleen" ; --UNCHK
lin brininess_N = mkWN (k40 "suolaisuus") ; --UNCHK
lin brink_N = mkWN (k41A "parras") ; --UNCHK
lin brinkmanship_N = mkWN (k2 "tasapainoilu") ; --UNCHK
lin briny_A = mkWA (k38 "suolainen") ; --UNCHK
lin brioche_N = mkWN (k5 "briossi") ; --UNCHK
lin briquet_N = mkWN (k5A "briketti") ; --UNCHK
lin briquette_N = mkWN (k5A "briketti") ; --UNCHK
lin brisance_N = mkWN "sirpaloituminen" ; --UNCHK
lin brisant_A = mkWA "sirpaloituva" ; --UNCHK
lin brisbane_PN = foreignPN "Brisbane" ;
lin brisk_A = mkWA (k41A "vilkas") ; --UNCHK
lin brisket_N = mkWN (k9A "rinta") ; --UNCHK
lin brisling_N = mkWN (compoundN "kiho" (k5 "haili")) ; --UNCHK
lin bristle_N = mkWN (k9 "karva") ; --UNCHK
lin bristle_V = mkWV (k52 "kiukustua") ; --UNCHK
lin bristlegrass_N = mkWN (compoundN "panta" (k10 "heinä")) ; --UNCHK
lin bristlelike_A = mkWA (compoundA "jouhi" (k38 "mainen")) ; --UNCHK
lin bristletail_N = mkWN (compoundN "kolmi" (k38 "sukahäntäinen")) ; --UNCHK
lin bristly_A = mkWA (k38 "piikkinen") ; --UNCHK
lin bristol_PN = foreignPN "Bristol" ;
lin brit_N = mkWN "ruijanhankajalkainen" ; --UNCHK
lin britain_PN = mkPN "Britannia" ;
lin britannic_A = mkWA (k38 "brittiläinen") ; --UNCHK
lin british_A = mkA "brittiläinen" ;
lin britisher_N = mkWN (k5A "britti") ; --UNCHK
lin briton_A = mkWA (k38 "brittiläinen") ; --UNCHK
lin briton_N = mkWN (k5A "britti") ; --UNCHK
lin brittle_A = mkWA (k11 "hapera") ; --UNCHK
lin brittle_N = mkWN (k20 "toffee") ; --UNCHK
lin brittlebush_N = mkWN (compoundN "farin" (k10 "osa")) "Encelia" ; --UNCHK
lin brittleness_N = mkWN (k40 "hauraus") ; --UNCHK
lin brixham_PN = foreignPN "Brixham" ;
lin brno_PN = foreignPN "Brno" ;
lin broach_V = mkWV (k53A "aloittaa") ; --UNCHK
lin broach_V2 = mkWV2 (k53A "aloittaa") ; --UNCHK
lin broad_A = L.broad_A ;
lin broad_N = mkWN (k38 "naikkonen") ; --UNCHK
lin broadax_N = mkWN (k41 "kirves") ; --UNCHK
lin broadband_A = mkWA (compoundA "laaja" (k38 "kaistainen")) ; --UNCHK
lin broadbill_N = mkWN (k5 "harlekiini") ; --UNCHK
lin broadcast_N = mkWN (k39 "lähetys") ; --UNCHK
lin broadcast_V = mkV (mkV "lähettää") "ohjelmaa" ; --mkWV (k74 "juoruta") ;
lin broadcast_V2 = mkWV2 (k74 "juoruta") ; --UNCHK
lin broadcaster_N = mkWN (k33A "lähetin") ; --UNCHK
lin broadcasting_N = mkN "radiointi" ; --WN (compoundN "tiedotus" (k48 "väline")) ;
lin broadcloth_N = mkWN (k9A "verka") ; --UNCHK
lin broaden_V = mkWV (k72 "levetä") ; --UNCHK
lin broaden_V2 = mkV2 "laajentaa" partitive ;
lin broadening_N = mkWN "avartaminen" ; --UNCHK
lin broadleaf_A = mkWA (compoundA "iso" (k38 "lehtinen")) ; --UNCHK
lin broadloom_A = mkWA "kudottu" ; --UNCHK
lin broadloom_N = mkWN (k1A "matto") "kudottu" ; --UNCHK
lin broadness_N = mkWN (k40 "leveys") ; --UNCHK
lin broadsheet_N = mkWN (k38 "lehtinen") ; --UNCHK
lin broadside_A = mkWA (k99 "vasten") "kylkeä" ; --UNCHK
lin broadside_Adv = mkWAdv (k99 "kyljittäin") ; --UNCHK
lin broadside_N = mkWN (compoundN "täys" (k38 "laidallinen")) ; --UNCHK
lin broadsword_N = mkWN (compoundN "lyömä" (k9A "miekka")) ; --UNCHK
lin broadtail_N = mkWN (compoundN "karakul" (k41A "lammas")) ; --UNCHK
lin broadwise_Adv = mkWAdv (compoundAdv "leveys" (k99 "suuntaisesti")) ; --UNCHK
lin broby_PN = mkPN "Broby" ;
lin brocade_N = mkWN (k5 "brokadi") ; --UNCHK
lin brocade_V2 = mkWV2 (k52A "kutoa") "brokadia" ; --UNCHK
lin broccoli_N = mkWN (compoundN "parsa" (k5 "kaali")) ; --UNCHK
lin brochette_N = mkWN (k41A "varras") ; --UNCHK
lin brochure_N = mkWN (k48A "esite") ; --UNCHK
lin brocket_N = mkWN (compoundN "puna" (k9 "peura")) ; --UNCHK
lin brodiaea_N = mkWN (compoundN "Brodiaea-" (k1A "suku")) ; --UNCHK
lin brogan_N = mkWN (k10A "kenkä") "tukeva" ; --UNCHK
lin brogue_N = mkWN (k10A "kenkä") "tukeva" ; --UNCHK
lin broil_N = mkWN (k39 "grillaus") ; --UNCHK
lin broil_V = mkWV (k73 "grillata") ; --UNCHK
lin broil_V2 = mkWV2 (k73 "grillata") ; --UNCHK
lin broiler_N = mkWN (k12 "parila") ; --UNCHK
lin broke_A = mkWA (k38 "persaukinen") ; --UNCHK
lin broken_A = variants {} ; --
lin broken_hearted_A = mkWA (k34A "lohduton") ; --UNCHK
lin broker_N = mkN "välittäjä" ;
lin brokerage_N = mkWN (compoundN "pankkiiri" (k48A "liike")) ;
lin brolly_N = mkWN (k10 "sontsa") ; --UNCHK
lin brome_N = mkWN (k12 "kattara") ; --UNCHK
lin bromic_A = mkWA "bromi-" ; --UNCHK
lin bromide_N = mkWN (k5A "trivialiteetti") ; --UNCHK
lin bromidic_A = mkWA "bromidi-" ; --UNCHK
lin bromine_N = mkWN (k5 "bromi") ; --UNCHK
lin bromley_PN = foreignPN "Bromley" ;
lin bromoform_N = mkWN (compoundN "tribromi" (k5 "metaani")) ; --UNCHK
lin bromsgrove_PN = foreignPN "Bromsgrove" ;
lin bronchial_A = mkWA (compoundA "bronkia" (k38 "alinen")) ; --UNCHK
lin bronchiolar_A = mkWA "bronkioli-" ; --UNCHK
lin bronchitic_A = mkWA (compoundA "bronkiitti" (k38 "nen")) ; --UNCHK
lin bronchitis_N = mkWN (k5A "bronkiitti") ; --UNCHK
lin bronchopneumonia_N = mkWN "pesäkekeuhkokuume" ; --UNCHK
lin bronchoscope_N = mkWN (compoundN "bronkosko" (k5A "oppi")) ; --UNCHK
lin bronchoscopic_A = mkWA "bronkoskooppinen" ; --UNCHK
lin bronchospasm_N = mkWN (compoundN "bronko" (k5 "spasmi")) ; --UNCHK
lin bronchus_N = mkWN (compoundN "keuhko" (k7 "putki")) ; --UNCHK
lin bronco_N = mkWN (k50 "villihevonen") ; --UNCHK
lin bronze_A = mkWA (k38 "pronssinen") ; --UNCHK
lin bronze_N = mkWN (compoundN "pronssi" (k41 "patsas")) ; --UNCHK
lin bronze_V = mkWV (k52A "päivettyä") ; --UNCHK
lin bronze_V2 = mkWV2 (k52A "päivettyä") ; --UNCHK
lin brooch_N = mkWN (compoundN "rinta" (k9 "neula")) ; --UNCHK
lin brood_N = mkWN (k41 "katras") ; --UNCHK
lin brood_V = mkWV (k73 "suojata") ; --UNCHK
lin brood_hen_N = mkWN (k9 "kana") "hautomahaluinen" ; --UNCHK
lin brooding_N = mkWN (k40 "mietteliäisyys") ; --UNCHK
lin brood_mare_N = mkWN (compoundN "siitos" (k9 "tamma")) ; --UNCHK
lin broody_A = mkWA (k10 "harkitseva") ; --UNCHK
lin brook_N = mkWN (k1 "puro") ; --UNCHK
lin brook_V2 = mkWV2 (k69 "suvaita") ; --UNCHK
lin brooklet_N = mkWN (compoundN "puro" (k38 "nen")) ; --UNCHK
lin brooklime_N = mkWN (k48A "tädyke") ; --UNCHK
lin brookweed_N = mkWN (compoundN "suola" (k10A "punka")) ; --UNCHK
lin broom_N = mkWN (k9 "harja") ; --UNCHK
lin broomcorn_N = mkWN (compoundN "luuta" (k10 "durra")) ; --UNCHK
lin broomstick_N = mkWN (compoundN "luudan" (k28 "varsi")) ; --UNCHK
lin broomweed_N = mkWN "Gutierrezia" "texana" ; --UNCHK
lin broth_N = mkWN (k25 "liemi") ; --UNCHK
lin brothel_N = mkWN (k12 "porttola") ; --UNCHK
lin brother_N = exceptNomN (mkN "velji" "veljen" "veljiä") "veli" ;
lin brother_N2 = L.brother_N2 ;
lin brotherhood_N = mkWN (k40 "veljeys") ; --UNCHK
lin brotherly_A = mkWA (k38 "veljellinen") ; --UNCHK
lin brotherly_Adv = mkWAdv (k99 "veljellisesti") | adjAdv brotherly_A ; --UNCHK -- derived
lin brotula_N = mkWN (compoundN "Bythitidae-ala" (k1 "lahko")) ; --UNCHK
lin brougham_N = mkWN "brougham" ; --UNCHK
lin broughton_PN = foreignPN "Broughton" ;
lin brouhaha_N = mkWN (k39 "touhotus") ; --UNCHK
lin brow_N = mkWN (compoundN "kulma" (k9 "karva")) ; --UNCHK
lin browbeat_V2 = mkWV2 (k67A "pelotella") ; --UNCHK
lin brown_A = L.brown_A ;
lin brown_N = mkWN (compoundN "yli" (k2 "opisto")) "Brownin" ; --UNCHK
lin brown_V = mkWV (k73 "värjätä") "ruskeaksi" ; --UNCHK
lin brown_V2 = mkWV2 (k73 "värjätä") "ruskeaksi" ; --UNCHK
lin brownie_N = mkWN (compoundN "suklaa" (k39 "leivos")) ; --UNCHK
lin brownish_A = mkWA (k10 "ruskehtava") ; --UNCHK
lin brownstone_N = mkWN (compoundN "rivi" (k1 "talo")) ; --UNCHK
lin browntail_N = mkWN "Euproctis" "phaeorrhoea" ; --UNCHK
lin browse_N = mkWN (k38 "syöminen") ; --UNCHK
lin browse_V = mkWV (k67 "maistella") ; --UNCHK
lin broxburn_PN = foreignPN "Broxburn" ;
lin bruce_PN = foreignPN "Bruce" ;
lin brucellosis_N = mkWN (compoundN "luoma" (k5A "tauti")) ; --UNCHK
lin brucine_N = mkWN "brusiini" ; --UNCHK
lin bruges_PN = foreignPN "Bruges" ;
lin bruin_N = mkWN (k1 "karhu") ; --UNCHK
lin bruise_N = mkWN (k10 "mustelma") ; --UNCHK
lin bruise_V = mkWV (k61 "kolhia") ; --UNCHK
lin bruise_V2 = mkWV2 (k61 "kolhia") ; --UNCHK
lin bruiser_N = mkWN (k38 "jättiläinen") ; --UNCHK
lin bruit_V2 = mkWV2 (k74 "juoruta") ; --UNCHK
lin brumal_A = mkWA (k38 "talvinen") ; --UNCHK
lin brumous_A = mkWA (k38 "sumuinen") ; --UNCHK
lin brunch_N = mkWN (k5 "brunssi") ; --UNCHK
lin brunei_PN = foreignPN "Brunei" ;
lin bruneian_A = mkWA (compoundA "brunei" (k38 "lainen")) ; --UNCHK
lin bruneian_N = mkWN (compoundN "brunei" (k38 "lainen")) ; --UNCHK
lin brunet_A = mkWA (compoundA "risti" (k38 "verinen")) ; --UNCHK
lin brunet_N = mkWN (k4A "tummaverikkö") ; --UNCHK
lin brunetteFem_N = mkWN (k4A "tummaverikkö") ; --UNCHK
lin brunetteMasc_N = mkWN (k4A "tummaverikkö") ; --UNCHK
lin brunswick_PN = foreignPN "Brunswick" ;
lin brunt_N = mkN "haittavaikutus" ;
lin brush_N = mkWN (compoundN "yhteen" (k1A "otto")) ; --UNCHK
lin brush_V = mkWV (k61A "pyyhkiä") ;
lin brush_V2 = mkWV2 (k61A "pyyhkiä") ; --UNCHK
lin brush_aside_V = mkWV (k73 "tyrmätä") ; --UNCHK
lin brush_off_V2 = mkWV2 (k73 "tyrmätä") ; --UNCHK
lin brush_up_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin brushlike_A = mkWA (compoundA "harja" (k38 "mainen")) ; --UNCHK
lin brushwood_N = mkWN (k4A "pöheikkö") ; --UNCHK
lin brushwork_N = mkWN (compoundN "maalaus" (k9A "tapa")) ; --UNCHK
lin brusque_A = mkWA (k15 "töykeä") ; --UNCHK
lin brusqueness_N = mkWN (k40 "karkeus") ; --UNCHK
lin brussels_PN = foreignPN "Bryssel" ;
lin brut_A = mkWA (k10 "kuiva") ; --UNCHK
lin brutal_A = mkWA (k34A "säälimätön") ; --UNCHK
lin brutality_N = mkWN (k40 "brutaalius") ; --UNCHK
lin brutalization_N = mkWN (compoundN "eläimellis" (k38 "tyminen")) ; --UNCHK
lin brutalize_V2 = mkWV2 (k52 "raaistua") ; --UNCHK
lin brute_N = mkWN (k3 "olio") ; --UNCHK
lin brutish_A = mkWA (k38 "petomainen") ; --UNCHK
lin bruxism_N = mkWN (compoundN "bruks" (k5 "ismi")) ; --UNCHK
lin bryan_PN = foreignPN "Bryan" ;
lin bryanthus_N = mkWN (compoundN "kanerva" (k5 "kasvi")) ; --UNCHK
lin bryony_N = mkWN (compoundN "koiran" (k39 "köynnös")) ; --UNCHK
lin bryophyte_N = mkWN (k5 "kasvi") "juureton" ; --UNCHK
lin bryophytic_A = mkWA "sammal-" ; --UNCHK
lin bryozoan_N = mkWN (compoundN "sammal" (k33 "eläin")) ; --UNCHK
lin bubaline_A = mkWA "puhveli-" ; --UNCHK
lin bubble_N = mkWN (k1A "kupu") ; --UNCHK
lin bubble_V = mkWV (k66 "röyhtäistä") ; --UNCHK
lin bubble_over_V = mkWV (k74 "pursuta") ; --UNCHK
lin bubbler_N = mkWN (compoundN "juoma" (k1 "suihku")) ; --UNCHK
lin bubbliness_N = mkWN "poreilevuus" ; --UNCHK
lin bubbly_A = mkWA (k41A "vilkas") ; --UNCHK
lin bubbly_N = mkWN (k5 "kuohuviini") ; --UNCHK
lin bubo_N = mkWN (compoundN "Bubo-" (k1A "suku")) ; --UNCHK
lin bubonic_A = mkWA "paise-" ; --UNCHK
lin buccal_A = mkWA (compoundA "bukka" (k38 "alinen")) ; --UNCHK
lin buccaneer_N = mkWN (k5A "piraatti") ; --UNCHK
lin buck_N = mkN "taala" ; ---ARB --mkWN (k41 "koiras") ; --mkN "pukki" ;
lin buck_V = mkWV (k62 "vikuroida") ; --UNCHK
lin buck_V2 = mkV2 "vastustaa" partitive ; --mkWV2 (k62 "vikuroida") ;
lin buck_up_V2 = mkWV2 (k66 "rohkaista") "mielensä" ; --UNCHK
lin bucket_N = mkWN (k1A "sanko") ; --UNCHK
lin bucket_V = mkWV (k53A "kuljettaa") ; --UNCHK
lin bucketful_N = mkWN (k38 "sangollinen") ; --UNCHK
lin buckeye_N = mkWN (compoundN "ohio" (k38 "lainen")) ; --UNCHK
lin buckhaven_PN = foreignPN "Buckhaven" ;
lin buckie_PN = foreignPN "Buckie" ;
lin buckingham_PN = foreignPN "Buckingham" ;
lin buckle_N = mkWN (k7A "solki") ; --UNCHK
lin buckle_V = mkWV (k52A "vääntyä") ; --UNCHK
lin buckle_V2 = mkWV2 (k52A "vääntyä") ; --UNCHK
lin buckle_down_V = mkWV (k67 "ponnistella") ; --UNCHK
lin buckle_under_V = mkWV (k53A "luovuttaa") ; --UNCHK
lin buckler_N = mkWN (k6 "panssari") ; --UNCHK
lin buckley_PN = foreignPN "Buckley" ;
lin buckleya_N = mkWN "Buckleya" "distichophylla" ; --UNCHK
lin buckminsterfullerene_N = mkWN "pallofulleriini" ; --UNCHK
lin buckram_N = mkWN (k41A "tukikangas") ; --UNCHK
lin bucksaw_N = mkWN (compoundN "poka" (k9 "saha")) ; --UNCHK
lin buckshee_A = mkWA (k38 "ilmainen") ; --UNCHK
lin buckskin_N = mkWN "ruunivoikko" ; --UNCHK
lin buckthorn_N = mkWN (k2 "ratamo") "suikealehtinen" ; --UNCHK
lin bucktooth_N = mkWN (compoundN "etu" (k41A "hammas")) ; --UNCHK
lin buckwheat_N = mkWN (kH1 "tattari") ; --UNCHK
lin bucolic_A = mkWA "laidun-" ; --UNCHK
lin bud_N = mkWN (k1A "nuppu") ; --UNCHK
lin bud_V = mkWV (k53 "orastaa") ; --UNCHK
lin budapest_PN = foreignPN "Budapest" ;
lin buddhism_N = mkWN (k40 "buddhalaisuus") ; --UNCHK
lin buddhistFem_N = mkWN "buddhisti" ; --UNCHK
lin buddhistMasc_N = mkWN "buddhisti" ; --UNCHK
lin budding_N = mkWN "budding" ; --UNCHK
lin buddy_N = mkWN (k10 "tuttava") ; --UNCHK
lin budge_V = mkWV (k52A "myöntyä") ;
lin budge_V2 = mkWV2 (k52A "myöntyä") ; --UNCHK
lin budgerigar_N = mkWN (k5A "undulaatti") ; --UNCHK
lin budget_N = mkWN (k5A "budjetti") ;
lin budget_V = mkWV (k62 "budjetoida") ; --UNCHK
lin budget_V2 = mkWV2 (k62 "budjetoida") ; --UNCHK
lin budgetary_A = mkA (separateN "budjettiin" (mkN "liittyvä")) ;
lin budgie_N = mkWN (k5A "undulaatti") ; --UNCHK
lin buff_A = mkWA (compoundA "ruskean" (k38 "keltainen")) ; --UNCHK
lin buff_N = mkWN (kH1 "suoja") ; --UNCHK
lin buff_V2 = mkWV2 (k53A "kiillottaa") ; --UNCHK
lin buffalo_N = mkWN (k6 "puhveli") "vanhan" "maailman" ; --UNCHK
lin buffalo_PN = foreignPN "Buffalo" ;
lin buffalofish_N = mkWN (compoundN "Ictiobus-" (k1A "suku")) ; --UNCHK
lin buffer_N = mkWN (kH1 "suoja") ; --UNCHK
lin buffer_V2 = mkWV2 (k62 "puskuroida") ; --UNCHK
lin buffet_N = mkWN (k5A "senkki") ; --UNCHK
lin buffet_V = mkWV (k73 "piiskata") ; --UNCHK
lin buffet_V2 = mkV2 "kolhia" ; --WV2 (k73 "piiskata") ;
lin bufflehead_N = mkWN (compoundN "pikku" (k10A "telkkä")) ; --UNCHK
lin buffoon_N = mkWN (k5 "narri") ; --UNCHK
lin buffoonery_N = mkWN (k2 "kujeilu") ; --UNCHK
lin buffoonish_A = mkWA (compoundA "klovni" (k38 "mainen")) ; --UNCHK
lin bufo_N = mkWN (compoundN "rupi" (k4A "sammakko")) ; --UNCHK
lin bug_N = mkWN (k6 "bakteeri") ; --UNCHK
lin bug_V2 = mkWV2 (k69 "häiritä") ; --UNCHK
lin bug_out_V = mkWV (k53A "revähtää") "auki" ; --UNCHK
lin bugaboo_N = mkWN (k10 "uhka") ; --UNCHK
lin bugbane_N = mkWN "kimikki" ; --UNCHK
lin bugbear_N = mkWN (k1A "mörkö") ; --UNCHK
lin bugger_N = mkWN (k1 "homo") ; --UNCHK
lin bugger_V = mkWV (k53 "harrastaa") "anaaliseksiä" ; --UNCHK
lin bugger_V2 = mkWV2 (k53 "harrastaa") "anaaliseksiä" ; --UNCHK
lin bugger_all_N = mkWN (k99 "yhtään") "ei" ; --UNCHK
lin buggery_N = mkWN (k12 "sodomia") ; --UNCHK
lin bugginess_N = mkWN (k40 "virheellisyys") ; --UNCHK
lin buggy_A = mkWA (compoundA "ötökkä" (k38 "inen")) ; --UNCHK
lin bugle_N = mkWN (k7 "torvi") ; --UNCHK
lin bugler_N = mkWN (compoundN "torven" (k10 "soittaja")) ; --UNCHK
lin bugleweed_N = mkWN (compoundN "akan" (k5 "kaali")) ; --UNCHK
lin bugloss_N = mkWN (compoundN "keltano" (k2 "kitkerö")) ; --UNCHK
lin buhl_N = mkWN (compoundN "boulle-" (k39 "upotus")) ; --UNCHK
lin build_N = mkWN (k48A "rakenne") ; --UNCHK
lin build_V = mkV "rakentaa" ;
lin build_V2 = mkV2 "rakentaa" | mkV2 (mkV "rakentaa") partitive ;
lin build_up_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin builder_N = mkWN (k10 "rakentaja") ; --UNCHK
lin building_N = mkN "rakennus" ;
lin building_society_N = mkWN (compoundN "asuntolaina" (k2 "rahasto")) ; --UNCHK
lin build_up_N = mkWN (k39 "lisäys") ; --UNCHK
lin built_in_A = mkA "sisäänrakennettu" ;
lin bulb_N = mkWN (k1A "kupu") ; --UNCHK
lin bulbaceous_A = mkWA "sipuli-" ; --UNCHK
lin bulbar_A = mkWA "ydinjatke-" ; --UNCHK
lin bulbed_A = mkWA (compoundA "polttimo" (k38 "llinen")) ; --UNCHK
lin bulbil_N = mkWN (k12 "mukula") ; --UNCHK
lin bulblike_A = mkWA (compoundA "sipulin" (k38 "muotoinen")) ; --UNCHK
lin bulbous_A = mkWA (compoundA "kupu" (k38 "mainen")) ; --UNCHK
lin bulbul_N = mkWN "bulbuli" ; --UNCHK
lin bulgaria_PN = foreignPN "Bulgaria" ;
lin bulgarianFem_N = mkN "bulgaari" | mkN "bulgarialainen" ;
lin bulgarianMasc_N = mkN "bulgaari" | mkN "bulgarialainen" ;
lin bulgarian_A = mkWA (k38 "bulgarialainen") ;
lin bulge_N = mkWN (k48A "uloke") ; --UNCHK
lin bulge_V = mkWV (k54A "suurentaa") ; --UNCHK
lin bulge_V2 = mkWV2 (k54A "suurentaa") ; --UNCHK
lin bulgur_N = mkWN (compoundN "bulgur" (k10 "vehnä")) ; --UNCHK
lin bulimarexia_N = mkWN (compoundN "nerv" (k10 "osa")) "bulimia" ; --UNCHK
lin bulimia_N = mkWN (k12 "bulimia") ; --UNCHK
lin bulimic_A = mkWA "buliminen" ; --UNCHK
lin bulimic_N = mkWN "bulimikko" ; --UNCHK
lin bulk_N = mkWN (compoundN "aine" (k10 "määrä")) ; --UNCHK
lin bulk_V = mkWV (k54A "suurentaa") ; --UNCHK
lin bulkhead_N = mkWN (k3 "laipio") ; --UNCHK
lin bulkiness_N = mkWN (k40 "massiivisuus") ; --UNCHK
lin bulkington_PN = foreignPN "Bulkington" ;
lin bulky_A = mkWA (kH1 "iso") ; --UNCHK
lin bull's_eye_N = mkWN (k39 "menestys") ; --UNCHK
lin bull_N = mkN "härkä" ; ---ARB --mkWN (k39 "munaus") ;
lin bull_neck_N = mkWN (k9 "niska") "paksu" ; --UNCHK
lin bull_terrier_N = mkWN (compoundN "bull" (k5 "terrieri")) ; --UNCHK
lin bulla_N = mkWN (k10 "bulla") ; --UNCHK
lin bullace_N = mkWN (k12 "kriikuna") ; --UNCHK
lin bullbrier_N = mkWN "Smilax" "rotundifolia" ; --UNCHK
lin bulldog_N = mkWN (k5 "bulldoggi") ; --UNCHK
lin bulldoze_V2 = mkWV2 (k73 "raivata") ; --UNCHK
lin bulldozer_N = mkWN (compoundN "raivaus" (k6 "traktori")) ; --UNCHK
lin bullet_N = mkN "luoti" ; --WN (k1A "syöttö") "nopea" ;
lin bullethead_N = mkWN (k7A "kärki") "suippo" ; --UNCHK
lin bulletin_N = mkWN (k48A "tiedote") ; --UNCHK
lin bulletproof_A = mkWA (compoundA "luodin" (k10 "kestävä")) ; --UNCHK
lin bullfight_N = mkWN (compoundN "härkä" (k2 "taistelu")) ; --UNCHK
lin bullfighter_N = mkWN (k5 "toreadori") ; --UNCHK
lin bullfighting_N = mkWN (compoundN "härkä" (k2 "taistelu")) ; --UNCHK
lin bullfinch_N = mkWN (k1A "punatulkku") ; --UNCHK
lin bullfrog_N = mkWN (compoundN "härkä" (k4A "sammakko")) ; --UNCHK
lin bullhead_N = mkWN (compoundN "monni" (k9 "kala")) ; --UNCHK
lin bull_headed_A = mkWA (compoundA "jää" (k38 "räpäinen")) ; --UNCHK
lin bullhorn_N = mkWN (k5 "megafoni") ; --UNCHK
lin bullion_N = mkWN (compoundN "kulta" (k1A "harkko")) ; --UNCHK
lin bullish_A = mkWA (compoundA "nousu" (k38 "suuntainen")) ; --UNCHK
lin bullnecked_A = mkWA (compoundA "paksu" (k38 "niskainen")) ; --UNCHK
lin bullnose_N = mkWN (compoundN "nokkaolka" (k10 "höylä")) ; --UNCHK
lin bullock_N = mkWN (k10A "härkä") ; --UNCHK
lin bullocky_A = mkWA (compoundA "härkä" (k38 "mäinen")) ; --UNCHK
lin bullpen_N = mkWN (compoundN "yhteis" (k5 "selli")) ; --UNCHK
lin bullring_N = mkWN (compoundN "härkätaistelu" (k13 "areena")) ; --UNCHK
lin bullshit_N = mkWN (k1 "fusku") ; --UNCHK
lin bullshit_V = mkWV (k67A "teeskennellä") ; --UNCHK
lin bully_A = mkWA (k3 "mainio") ; --UNCHK
lin bully_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin bully_V = mkWV (k67A "pelotella") ; --UNCHK
lin bully_V2 = mkWV2 (k67A "pelotella") ; --UNCHK
lin bullyboy_N = mkWN (k6 "päällepäsmäri") ; --UNCHK
lin bullying_N = mkWN (k2 "uhkailu") ; --UNCHK
lin bulrush_N = mkWN (compoundN "röyhy" (k12 "vihvilä")) ; --UNCHK
lin bulwark_N = mkWN (compoundN "ranta" (k49A "penger")) ; --UNCHK
lin bum_A = mkWA (k2 "tökerö") ; --UNCHK
lin bum_N = mkWN (k1 "takalisto") ; --UNCHK
lin bum_V = mkWV (k67 "siipeillä") ; --UNCHK
lin bum_V2 = mkWV2 (k67 "siipeillä") ; --UNCHK
lin bumblebee_N = mkWN (k38 "kimalainen") ; --UNCHK
lin bumbling_A = mkWA (k10A "jäykkä") "liikkeissään" ; --UNCHK
lin bumboat_N = mkWN (compoundN "kauppa" (k48 "vene")) ; --UNCHK
lin bumf_N = mkWN (compoundN "paperi" (k48 "saaste")) ; --UNCHK
lin bummer_N = mkWN (k5A "trippi") "huono" ; --UNCHK
lin bump_N = mkWN (k39 "törmäys") ; --UNCHK
lin bump_V = mkWV (k73 "törmätä") ; --UNCHK
lin bump_V2 = mkWV2 (k73 "törmätä") ; --UNCHK
lin bump_into_V2 = mkWV2 (k52A "iskeytyä") "jhkin" ; --UNCHK
lin bump_off_V2 = mkWV2 (k73 "raivata") "tieltään" ; --UNCHK
lin bump_up_V2 = mkWV2 (k53 "nostaa") ; --UNCHK
lin bumper_N = mkWN (k6 "puskuri") ; --UNCHK
lin bumpiness_N = mkWN (compoundN "epä" (k40 "tasaisuus")) ; --UNCHK
lin bumpkin_N = mkWN (k6 "öykkäri") ; --UNCHK
lin bumpkinly_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin bumptious_A = mkWA (k10 "koppava") ; --UNCHK
lin bumptiousness_N = mkWN (k40 "pöyhkeys") ; --UNCHK
lin bumpy_A = mkWA (k38 "kuoppainen") ; --UNCHK
lin bun_N = mkWN (k10 "pulla") ; --UNCHK
lin buna_N = mkWN (compoundN "buna-" (k5 "kumi")) ; --UNCHK
lin bunch_N = mkWN (k1A "nippu") ;
lin bunch_V = mkWV (k74A "koota") "rykelmäksi" ; --UNCHK
lin bunch_V2 = mkWV2 (k74A "koota") "rykelmäksi" ; --UNCHK
lin bunchberry_N = mkWN (compoundN "kanadanruohokan" (k10A "nukka")) ; --UNCHK
lin bunchgrass_N = mkWN (k10 "heinä") ; --UNCHK
lin bunchy_A = mkWA (compoundA "terttu" (k38 "mainen")) ; --UNCHK
lin bunco_N = mkWN (k39 "huijaus") ; --UNCHK
lin bundle_N = mkWN (k1A "kimppu") ; --UNCHK
lin bundle_V = mkWV (k52A "nukkua") "yhdessä" ; --UNCHK
lin bundle_V2 = mkWV2 (k52A "nukkua") "yhdessä" ; --UNCHK
lin bundle_off_V2 = mkWV2 (k53A "passittaa") ; --UNCHK
lin bundle_up_V = mkWV (k52A "pukeutua") ; --UNCHK
lin bundle_up_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin bundling_N = mkWN "sysääminen" ; --UNCHK
lin bung_N = mkWN (k5A "tappi") ; --UNCHK
lin bung_V2 = mkWV2 (k73A "tulpata") ; --UNCHK
lin bungaloid_A = mkWA (compoundA "rakenne" (k1 "ttu")) "matalaan" ; --UNCHK
lin bungalow_N = mkWN (k9 "maja") ; --UNCHK
lin bungee_N = mkWN (compoundN "benji" (k27 "köysi")) ; --UNCHK
lin bung_hole_N = mkWN (compoundN "tapin" (k10A "reikä")) ; --UNCHK
lin bungle_N = mkWN (k48 "virhe") ; --UNCHK
lin bungle_V = mkWV (k62 "hutiloida") ; --UNCHK
lin bungle_V2 = mkWV2 (k62 "hutiloida") ; --UNCHK
lin bungler_N = mkWN (k10 "hutiloija") ; --UNCHK
lin bunion_N = mkWN (compoundN "vaivaisen" (k18 "luu")) ; --UNCHK
lin bunk_N = mkWN (kH1 "punkka") ; --UNCHK
lin bunk_V = mkWV (k52A "häipyä") ; --UNCHK
lin bunk_off_V = mkWV (k73 "pinnata") ; --UNCHK
lin bunker_N = mkWN (k6 "bunkkeri") ; --UNCHK
lin bunker_V = mkWV (k64 "lyödä") "hiekkaesteeseen" ; --UNCHK
lin bunker_V2 = mkWV2 (k64 "lyödä") "hiekkaesteeseen" ; --UNCHK
lin bunkmate_N = mkWN (compoundN "tupa" (k6 "kaveri")) ; --UNCHK
lin bunkum_N = mkWN (k99 "soopa") ; --UNCHK
lin bunny_N = mkWN (kH1 "kani") ; --UNCHK
lin bunsen_N = mkWN (compoundN "bunsen" (k1A "lamppu")) ; --UNCHK
lin bunt_N = mkWN (k39 "näpäytys") ; --UNCHK
lin buntal_N = mkWN "buntal" ; --UNCHK
lin bunter_N = mkWN "näpäyttäjä" ; --UNCHK
lin bunting_N = mkWN (k1A "sirkku") ; --UNCHK
lin bunyavirus_N = mkWN (compoundN "bunya" (k39 "virus")) ; --UNCHK
lin buoy_N = mkWN (k1 "poiju") ; --UNCHK
lin buoy_V = mkWV (k53A "poijuttaa") ; --UNCHK
lin buoy_V2 = mkWV2 (k53A "poijuttaa") ; --UNCHK
lin buoy_up_V2 = mkWV2 (k52 "piristyä") ; --UNCHK
lin buoyancy_N = mkWN (k40 "iloisuus") ; --UNCHK
lin buoyant_A = mkWA (k15 "virkeä") ; --UNCHK
lin bur_N = mkWN (k10 "pora") ; --UNCHK
lin burberry_N = mkWN "Burberry" ; --UNCHK
lin burble_V = mkWV (k66 "solista") ; --UNCHK
lin burble_VS = mkWVS (k66 "solista") ; --UNCHK
lin burbot_N = mkWN (kH1 "matikka") ; --UNCHK
lin burden_N = mkN "taakka" ;
lin burden_V2 = mkWV2 (k53A "sälyttää") ; --UNCHK
lin burdenless_A = mkWA "taakaton" ; --UNCHK
lin burdensome_A = mkWA (k10 "vaativa") ; --UNCHK
lin burdensomeness_N = mkWN (k40 "rasittavuus") ; --UNCHK
lin burdock_N = mkWN (k38 "takiainen") ; --UNCHK
lin bureau_N = mkN "virasto" ; ---ARB mkWN (k5A "piironki") ;
lin bureaucracy_N = mkWN (k12 "byrokratia") ; --UNCHK
lin bureaucrat_N = mkWN (k5A "byrokraatti") ; --UNCHK
lin bureaucratic_A = mkWA (k38 "byrokraattinen") ; --UNCHK
lin burette_N = mkWN "byretti" ; --UNCHK
lin burg_N = mkWN (k5A "kaupunki") ; --UNCHK
lin burgeon_V = mkWV (k56 "kasvaa") ; --UNCHK
lin burgess_N = mkWN (k38 "kaupunkilainen") ; --UNCHK
lin burgh_N = mkWN (compoundN "kaupunki" (k10A "kunta")) ; --UNCHK
lin burgher_N = mkWN (k32 "jäsen") "keskiluokan" ; --UNCHK
lin burglar_N = mkWN (compoundN "murto" (k41A "varas")) ; --UNCHK
lin burglar_alarm_N = mkWN (compoundN "varas" (k33A "hälytin")) ; --UNCHK
lin burglarious_A = mkWA "murto-" ; --UNCHK
lin burglar_proof_A = mkWA (compoundA "murto" (k9 "varma")) ; --UNCHK
lin burglary_N = mkWN (k1A "murto") ;
lin burgle_V = mkWV (k53 "ryöstää") ; --UNCHK
lin burgle_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin burgomaster_N = mkWN (k6 "pormestari") ; --UNCHK
lin burgoo_N = mkWN (compoundN "liha" (k39 "muhennos")) ; --UNCHK
lin burgos_PN = foreignPN "Burgos" ;
lin burgrass_N = mkWN (compoundN "piikki" (k10 "heinä")) ; --UNCHK
lin burgrave_N = mkWN (compoundN "linnan" (k9 "herra")) ; --UNCHK
lin burgundy_N = mkWN (compoundN "viinin" (k38 "punainen")) ; --UNCHK
lin burial_N = mkWN (k39 "hautaus") ; --UNCHK
lin burial_ground_N = mkWN (k2 "kalmisto") ; --UNCHK
lin burin_N = mkWN (k33A "kaiverrin") ; --UNCHK
lin burke_V2 = mkWV2 (k66 "lakaista") ; --UNCHK
lin burl_N = mkWN (k1A "nyppy") ; --UNCHK
lin burlap_N = mkWN (k41A "juuttikangas") ;
lin burled_A = mkWA (k38 "pahkainen") ; --UNCHK
lin burlesque_A = mkWA "burleski-" ; --UNCHK
lin burlesque_N = mkWN (k39 "huijaus") ; --UNCHK
lin burlesque_V2 = mkWV2 (k62 "parodioida") ; --UNCHK
lin burley_PN = foreignPN "Burley" ;
lin burly_A = mkWA (k9 "vahva") ; --UNCHK
lin burmese_A = mkWA (compoundA "burm" (k38 "alainen")) ; --UNCHK
lin burmese_N = mkWN "burma" ; --UNCHK
lin burn_N = mkN "palo" ;
lin burn_V = L.burn_V ;
lin burn_V2 = mkV2 "polttaa" ;
lin burn_down_V = advV OP_burn_V OP_down_Adv ; -- guess-p-verb
lin burn_down_V2 = prepV2 OP_burn_V OP_down_Prep ; -- guess-p-verb
lin burn_off_V2 = mkWV2 (k53A "polttaa") ; --UNCHK
lin burn_out_V = mkWV (k52A "särkyä") ; --UNCHK
lin burn_up_V = advV OP_burn_V OP_up_Adv ; -- guess-p-verb
lin burn_up_V2 = prepV2 OP_burn_V OP_up_Prep ; -- guess-p-verb
lin burnable_A = mkWA (k10 "palava") ; --UNCHK
lin burner_N = mkWN (k33A "poltin") ; --UNCHK
lin burning_A = variants {} ; --
lin burning_N = mkWN (k1A "poltto") ; --UNCHK
lin burnish_V = mkWV (k53A "kiillottaa") ; --UNCHK
lin burnish_V2 = mkWV2 (k53A "kiillottaa") ; --UNCHK
lin burnley_PN = foreignPN "Burnley" ;
lin burnous_N = mkWN (k1A "kaapu") ; --UNCHK
lin burnouse_N = mkWN (k1A "kaapu") ; --UNCHK
lin burntisland_PN = foreignPN "Burntisland" ;
lin burntwood_PN = foreignPN "Burntwood" ;
lin burn_up_N = mkWN (k39 "kulutus") ; --UNCHK
lin burp_N = mkWN (k2 "röyhtäily") ; --UNCHK
lin burp_V = mkWV (k66 "röyhtäistä") ; --UNCHK
lin burp_V2 = mkWV2 (k66 "röyhtäistä") ; --UNCHK
lin burqa_N = mkWN "burka" ; --UNCHK
lin burr_N = mkWN (k10 "pora") ; --UNCHK
lin burr_drill_N = mkWN (k10 "pora") "hammaslääkärin" ; --UNCHK
lin burrawong_N = mkWN (compoundN "käpy" (k1 "palmu")) ; --UNCHK
lin burrfish_N = mkWN (compoundN "siili" (k9 "kala")) ; --UNCHK
lin burrito_N = mkWN "burrito" ; --UNCHK
lin burrlike_A = mkWA (compoundA "takiais" (k38 "mainen")) ; --UNCHK
lin burro_N = mkWN (compoundN "kuorma-" (k5 "aasi")) ; --UNCHK
lin burrow_N = mkWN (k10 "käytävä") ; --UNCHK
lin burrow_V = mkWV (k52A "kaivautua") ; --UNCHK
lin burrow_V2 = mkWV2 (k52A "kaivautua") ; --UNCHK
lin bursa_N = mkWN (compoundN "nivelvoide" (k5 "pussi")) ; --UNCHK
lin bursal_A = mkWA "bursa-" ; --UNCHK
lin bursar_N = mkWN (compoundN "rahaston" (k10 "hoitaja")) ; --UNCHK
lin bursary_N = mkWN (k2 "rahasto") ; --UNCHK
lin bursitis_N = mkWN "bursiitti" ; --UNCHK
lin burst_N = mkWN (k10 "puuska") ; --UNCHK
lin burst_V = mkWV (k53A "syöksähtää") ; --UNCHK
lin burst_V2 = mkWV2 (k53A "syöksähtää") ; --UNCHK
lin burst_into_V2 = prepV2 OP_burst_V OP_into_Prep ; -- guess-p-verb
lin burthen_N = mkWN (k9A "taakka") ; --UNCHK
lin burthen_V2 = mkWV2 (k67 "olla") "painona" ; --UNCHK
lin burton_N = mkWN "Burton" ; --UNCHK
lin burundi_PN = foreignPN "Burundi" ;
lin burundian_A = mkWA (compoundA "burundi" (k38 "lainen")) ; --UNCHK
lin burundian_N = mkWN (compoundN "burundi" (k38 "lainen")) ; --UNCHK
lin bury_PN = foreignPN "Bury" ;
lin bury_V = mkWV (k53A "unohtaa") ; --UNCHK
lin bury_V2 = mkWV2 (k53A "unohtaa") ; --UNCHK
lin burying_N = mkWN (k39 "hautaus") ; --UNCHK
lin burying_ground_N = mkWN (k2 "kalmisto") ; --UNCHK
lin bus_N = mkN (lin NK {s = d05 "bussi"}) ;
lin bus_V = mkWV (k73 "kerätä") ; --UNCHK
lin bus_V2 = mkWV2 (k73 "kerätä") ; --UNCHK
lin busbar_N = mkWN (compoundN "virta" (k1 "kisko")) ; --UNCHK
lin busboy_N = mkWN (compoundN "astioiden" (k10 "kerääjä")) ; --UNCHK
lin busby_N = mkWN (compoundN "karhunnahka" (k5A "lakki")) ; --UNCHK
lin bush_N = mkWN (k10 "puska") ; --UNCHK
lin bushbuck_N = mkWN (compoundN "kirjo" (k5A "antilooppi")) ; --UNCHK
lin bushel_N = mkN "busheli" ;
lin bushing_N = mkWN (k1 "hylsy") ; --UNCHK
lin bushman_N = mkWN (compoundN "uudis" (k10 "raivaaja")) ; --UNCHK
lin bushtit_N = mkWN (compoundN "pensas" (k38 "tiainen")) ; --UNCHK
lin bushwhacker_N = mkWN (k5 "sissi") ; --UNCHK
lin bushwhacking_A = mkWA (compoundA "piileske" (k10 "levä")) ; --UNCHK
lin bushy_A = mkWA (k15 "tuuhea") ; --UNCHK
lin business_N = mkN "liikeasia" ;
lin businesslike_A = mkWA (k38 "järjestelmällinen") ; --UNCHK
lin businessman_N = mkN "liike" L.man_N ;
lin businessperson_N = mkWN (k6 "porvari") ; --UNCHK
lin businesswoman_N = mkWN (compoundN "liike" (k38 "nainen")) ; --UNCHK
lin busker_N = mkWN (compoundN "katu" (k10 "soittaja")) ; --UNCHK
lin buskin_N = mkWN (compoundN "maihinnousu" (k10A "kenkä")) ; --UNCHK
lin busload_N = mkWN (compoundN "linja-" (k38 "autollinen")) ; --UNCHK
lin busman_N = mkWN (compoundN "linja-auton" (k10 "kuljettaja")) ; --UNCHK
lin buspirone_N = mkWN (compoundN "BuS" (k5 "par")) ; --UNCHK
lin bust_N = mkN "epä" (mkN "onnistuminen") ; ---ARB --mkN "rintakuva" ; --mkWN (k5 "pysti") ;
lin bust_V = mkWV (k74A "haljeta") ; --UNCHK
lin bust_V2 = mkWV2 (k74A "haljeta") ; --UNCHK
lin bust_up_V = mkWV (k58A "särkeä") ; --UNCHK
lin bustard_N = mkWN "trappi" ; --UNCHK
lin bustier_N = mkWN (kH1 "toppi") "olkaimeton" ; --UNCHK
lin bustle_N = mkWN (k39 "touhotus") ; --UNCHK
lin bustle_V = mkWV (k66 "kihistä") ; --UNCHK
lin bustle_V2 = mkWV2 (k66 "kihistä") ; --UNCHK
lin busy_A = mkWA (k38 "kiireinen") ;
lin busy_V2 = mkWV2 (k53 "työllistää") ; --UNCHK
lin busybody_N = mkWN (k12 "utelija") ; --UNCHK
lin busyness_N = mkWN (k12 "hyörinä") ; --UNCHK
lin busywork_N = mkWN (k2 "puuhastelu") ; --UNCHK
lin but_Adv = mkWAdv (k99 "vain") ;
lin but_Conj = mkConj "mutta" ;
lin but_N = mkN "mutta" ;
lin but_PConj = S.but_PConj ;
lin but_Prep = mkPrep "paitsi" nominative ;
lin but_Subj = mkSubj "mutta" ;
lin butacaine_N = mkWN (compoundN "butakaiini" (k5A "sulfaatti")) ; --UNCHK
lin butadiene_N = mkWN "butadieeni" ; --UNCHK
lin butane_N = mkWN (k5 "butaani") ; --UNCHK
lin butanone_N = mkWN (compoundN "metyylietyyli" (k5 "ketoni")) ; --UNCHK
lin butch_A = mkWA (k38 "miesmäinen") ; --UNCHK
lin butch_N = mkWN (k4A "lepakko") ; --UNCHK
lin butcher_N = mkWN (k10 "hutiloija") ; --UNCHK
lin butcher_V2 = mkWV2 (k73A "lahdata") ; --UNCHK
lin butcherbird_N = mkWN (compoundN "huilu" (k39 "varis")) ; --UNCHK
lin butchery_N = mkWN (k39 "teurastus") ; --UNCHK
lin buteonine_A = mkWA (compoundA "hiirihaukka" (k38 "mainen")) ; --UNCHK
lin buteonine_N = mkWN (compoundN "hiiri" (k9A "haukka")) ; --UNCHK
lin butler_N = mkWN (compoundN "hovi" (k6 "mestari")) ;
lin butt_N = mkWN (k10 "perä") ; --UNCHK
lin butt_V = mkWV (k66 "töytäistä") ; --UNCHK
lin butt_V2 = mkWV2 (k66 "töytäistä") ; --UNCHK
lin butt_in_V = mkWV (k52A "sekaantua") ; --UNCHK
lin butte_N = mkWN "Butte" ; --UNCHK
lin butter_N = L.butter_N ;
lin butter_V2 = mkWV2 (k67A "voidella") ; --UNCHK
lin butter_up_V2 = mkWV2 (k67A "imarrella") ; --UNCHK
lin butterbean_N = mkWN (k1A "papu") ; --UNCHK
lin butterbur_N = mkWN (compoundN "etelän" (k26 "ruttojuuri")) ; --UNCHK
lin buttercrunch_N = mkWN (compoundN "jäävuori" (k5A "salaatti")) ; --UNCHK
lin buttercup_N = mkWN (k5A "leinikki") ; --UNCHK
lin butterfat_N = mkWN (compoundN "voi" (k9 "rasva")) ; --UNCHK
lin butterfingers_N = mkWN (compoundN "mämmi" (k10 "koura")) ; --UNCHK
lin butterfish_N = mkWN "Pholis" "gunnellus" ; --UNCHK
lin butterfly_N = mkWN (compoundN "perhos" (k5A "uinti")) ; --UNCHK
lin buttermilk_N = mkWN (compoundN "kirnu" (k10 "piimä")) ; --UNCHK
lin butternut_N = mkWN (compoundN "amerikanjalo" (k12 "pähkinä")) ; --UNCHK
lin butterscotch_N = mkWN (compoundN "kerma" (k20 "toffee")) ; --UNCHK
lin butterweed_N = mkWN (k4A "villakko") ; --UNCHK
lin butterwort_N = mkWN (compoundN "siniyökön" (k7A "lehti")) ; --UNCHK
lin buttery_A = mkWA (k38 "voinen") ; --UNCHK
lin buttery_N = mkWN (k6 "kanttiini") ; --UNCHK
lin buttinsky_N = mkWN "asioihin" "sekaantuja" ; --UNCHK
lin buttock_N = mkWN (k1A "kankku") ; --UNCHK
lin buttocks_N = mkWN (k1 "takalisto") ; --UNCHK
lin button_N = mkWN (k5A "nappi") ;
lin button_V = mkWV (k53A "kiinnittää") "napilla" ; --UNCHK
lin button_V2 = mkWV2 (k53A "kiinnittää") "napilla" ; --UNCHK
lin buttonhole_N = mkWN (k7A "napinläpi") ; --UNCHK
lin buttonhole_V2 = mkWV2 (k73 "lobata") ; --UNCHK
lin buttonhook_N = mkWN (compoundN "nappi" (k1A "koukku")) ; --UNCHK
lin buttonwood_N = mkWN (compoundN "Amerikan" (k6 "plataani")) ; --UNCHK
lin buttony_A = mkWA (k38 "napillinen") ; --UNCHK
lin buttress_N = mkWN (compoundN "tuki" (k41 "pylväs")) ; --UNCHK
lin buttress_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin butty_N = mkWN "kerrosvoileipä" ; --UNCHK
lin butylene_N = mkWN "buteeni" ; --UNCHK
lin butyraceous_A = mkWA (compoundA "voi" (k38 "mainen")) ; --UNCHK
lin butyric_A = mkWA "butaanihappo-" ; --UNCHK
lin butyrin_N = mkWN "butyriini" ; --UNCHK
lin buxom_A = mkWA (k10 "rehevä") ; --UNCHK
lin buxomness_N = mkWN "muodokkuus" ; --UNCHK
lin buxton_PN = foreignPN "Buxton" ;
lin buy_N = mkN "ostos" ;
lin buy_V = mkV "ostaa" ;
lin buy_V2 = L.buy_V2 ;
lin buy_back_V = mkWV (k53 "lunastaa") ; --UNCHK
lin buy_back_V2 = mkV2 (advV OP_buy_V OP_back_Adv ) ; -- guess-p-verb
lin buy_in_V2 = mkWV2 (k61A "hankkia") "varastoon" ; --UNCHK
lin buy_into_V2 = mkWV2 (k53 "ostaa") "osakkeita" ; --UNCHK
lin buy_off_V2 = mkWV2 (k52 "lahjoa") ; --UNCHK
lin buy_out_V2 = mkWV2 (k53A "ottaa") "haltuunsa" ; --UNCHK
lin buy_up_V2 = mkWV2 (k53A "ottaa") "haltuunsa" ; --UNCHK
lin buyerFem_N = mkWN (k10 "ostaja") ; --f235
lin buyerMasc_N = mkN "ostaja" ;
lin buying_N = mkWN (k1 "osto") ; --UNCHK
lin buyout_N = mkWN (compoundN "yritys" (k39 "valtaus")) ; --UNCHK
lin buzz_N = mkWN (k12 "suhina") ; --UNCHK
lin buzz_V = mkWV (k53A "soittaa") "summeria" ; --UNCHK
lin buzz_V2 = mkWV2 (k53A "soittaa") "summeria" ; --UNCHK
lin buzz_off_V = mkWV (k53A "ottaa") "hatkat" ; --UNCHK
lin buzzard_N = mkWN (compoundN "hiiri" (k9A "haukka")) ; --UNCHK
lin buzzer_N = mkWN (k6 "summeri") ; --UNCHK
lin buzzword_N = mkWN (compoundN "muoti" (k9 "sana")) ; --UNCHK
lin by8agent_Prep = S.by8agent_Prep ;
lin by8means_Prep = S.by8means_Prep ;
lin by_Adv = mkWAdv (k99 "talteen") ; --UNCHK
lin by_Prep = postPrep genitive "kautta" ;
lin by_means_of_Prep = mkPrep "avulla" ;
lin by_virtue_of_Prep = mkPrep "takia" ;
lin bye_Interj = mkInterj "hei sitten" ;
lin bye_bye_Interj = mkInterj "hei hei" ;
lin bygone_A = mkWA (k38 "entinen") ; --UNCHK
lin bylaw_N = mkWN (compoundN "ohje" (k1A "sääntö")) ; --UNCHK
lin bypass_N = mkWN (compoundN "ohikulku" (k19 "tie")) ; --UNCHK
lin bypass_V2 = mkWV2 (k53A "sivuuttaa") ; --UNCHK
lin bypath_N = mkWN (compoundN "sivu" (k19 "tie")) ; --UNCHK
lin byplay_N = mkWN (k14A "mimiikka") ; --UNCHK
lin byproduct_N = mkWN (compoundN "sivu" (k48A "tuote")) ; --UNCHK
lin byroad_N = mkWN (compoundN "sivu" (k19 "tie")) ; --UNCHK
lin byssus_N = mkWN (compoundN "kiinnitys" (k2 "rihmasto")) ; --UNCHK
lin bystander_N = mkWN (k38 "sivullinen") ; --UNCHK
lin byte_N = mkWN (k1 "tavu") ; --UNCHK
lin byway_N = mkWN (compoundN "sivu" (k19 "tie")) ; --UNCHK
lin byword_N = mkWN (k9A "sanonta") ; --UNCHK
lin c_of_e_N = mkN "Englannin " (mkN "kirkko") ; ----sanaliitto
lin cab_N = mkWN (k5 "pirssi") ; --UNCHK
lin cabal_N = mkWN (compoundN "sala" (k48A "hanke")) ; --UNCHK
lin cabala_N = mkWN (compoundN "Qabb" (k9 "ala")) ; --UNCHK
lin cabalist_N = mkWN "kabbalisti" ; --UNCHK
lin cabalistic_A = mkWA (k38 "arvoituksellinen") ; --UNCHK
lin cabana_N = mkWN (compoundN "pukeutumis" (k9A "teltta")) ; --UNCHK
lin cabaret_N = mkWN (k20 "kabaree") ; --UNCHK
lin cabbage_N = mkWN (k5 "kaali") ; --UNCHK
lin cabbageworm_N = mkWN (compoundN "nauris" (k38 "perhonen")) ; --UNCHK
lin cabby_N = mkWN (k14A "vossikka") ; --UNCHK
lin caber_N = mkWN (k5A "tukki") ; --UNCHK
lin cabin_N = mkWN (k2 "matkustamo") ; --UNCHK
lin cabinet_N = mkWN (k2 "kaapisto") ; --UNCHK
lin cabinet_maker_N = mkWN "huonekalupuuseppä" ; --UNCHK
lin cabinetmaking_N = mkWN (compoundN "puusepän" (k19 "työ")) ; --UNCHK
lin cabinetwork_N = mkWN (compoundN "huonekalupuusepän" (k19 "työ")) ; --UNCHK
lin cable's_length_N = mkWN (compoundN "kaapelin" (k9A "mitta")) ; --UNCHK
lin cable_N = mkN "kaapeli" "kaapeleita" ;
lin cable_V = mkWV (k53A "sähköttää") ; --UNCHK
lin cable_V2 = mkWV2 (k53A "sähköttää") ; --UNCHK
lin cable_car_N = mkWN (k1 "vaunu") ; --UNCHK
lin cable_length_N = mkWN (compoundN "kaapelin" (k9A "mitta")) ; --UNCHK
lin cable_railway_N = mkWN (compoundN "köysi" (k9A "rata")) ; --UNCHK
lin cablegram_N = mkWN (k48 "sähke") ; --UNCHK
lin cabman_N = mkWN (k14A "vossikka") ; --UNCHK
lin cabochon_N = mkWN "cabochon" ; --UNCHK
lin caboodle_N = mkWN (k1A "nippu") ; --UNCHK
lin caboose_N = mkWN (compoundN "konduktöörin" (k1 "vaunu")) ; --UNCHK
lin cabotage_N = mkWN (compoundN "rannikko" (k48A "liikenne")) ; --UNCHK
lin cabstand_N = mkWN (compoundN "taksi" (k10 "asema")) ; --UNCHK
lin cacao_N = mkWN (compoundN "kaakao" (k18 "puu")) ; --UNCHK
lin cacao_bean_N = mkWN (compoundN "kaakao" (k1A "papu")) ; --UNCHK
lin cacao_tree_N = mkWN (compoundN "kaakao" (k18 "puu")) ; --UNCHK
lin cache_N = mkWN (k1 "kätkö") ; --UNCHK
lin cache_V2 = mkWV2 (k62 "varastoida") ; --UNCHK
lin cachectic_A = mkWA "kuihtunut" ; --UNCHK
lin cachet_N = mkWN (k5A "sinetti") ; --UNCHK
lin cachexia_N = mkWN "kakeksia" ; --UNCHK
lin cachinnation_N = mkWN (k39 "hekotus") ; --UNCHK
lin cachou_N = mkWN (k5 "pastilli") ; --UNCHK
lin cacique_N = mkWN "kasikki" ; --UNCHK
lin cackle_N = mkWN (k39 "käkätys") ; --UNCHK
lin cackle_V = mkWV (k53A "käkättää") ; --UNCHK
lin cackly_A = mkWA (compoundA "kaakatus" (k38 "mainen")) ; --UNCHK
lin cacodemon_N = mkWN (k38 "paholainen") ; --UNCHK
lin cacodemonic_A = mkWA (compoundA "paholais" (k38 "mainen")) ; --UNCHK
lin cacodyl_N = mkWN (compoundN "arsenikki" (k10 "ryhmä")) ; --UNCHK
lin cacodylic_A = mkWA "kakodyyli-" ; --UNCHK
lin cacogenesis_N = mkWN "cacogenesis" ; --UNCHK
lin cacophonous_A = mkWA (k38 "kakofoninen") ; --UNCHK
lin cacophony_N = mkWN (k12 "kakofonia") ; --UNCHK
lin cactus_N = mkWN (k39 "kaktus") ; --UNCHK
lin cacuminal_A = mkWA (compoundA "kakumina" (k38 "alinen")) ; --UNCHK
lin cad_N = mkWN (k2 "suunnittelu") "tietokoneavusteinen" ; --UNCHK
lin cadaster_N = mkWN (compoundN "maa" (k6 "rekisteri")) ; --UNCHK
lin cadastral_A = mkWA "maarekisteriin" "liittyvä" ; --UNCHK
lin cadaver_N = mkWN (k1A "raato") ; --UNCHK
lin cadaverine_N = mkWN "kadaveriini" ; --UNCHK
lin cadaverous_A = mkWA (compoundA "kalman" (k15 "kalpea")) ; --UNCHK
lin caddie_N = mkWN (k8 "caddie") ; --UNCHK
lin caddish_A = mkWA (k1 "tyly") ; --UNCHK
lin caddisworm_N = mkWN "sirvi" ; --UNCHK
lin caddy_N = mkWN (compoundN "teenlehti" (k12 "rasia")) ; --UNCHK
lin cadence_N = mkWN (k5A "tahti") ; --UNCHK
lin cadenced_A = mkWA "tahditettu" ; --UNCHK
lin cadenza_N = mkWN (k5 "kadenssi") ; --UNCHK
lin cadet_N = mkWN (k5A "kadetti") ; --UNCHK
lin cadetship_N = mkWN "kadettius" ; --UNCHK
lin cadger_N = mkWN (k12 "siipeilijä") ; --UNCHK
lin cadiz_PN = foreignPN "Cádiz" ;
lin cadmium_N = mkWN (k5 "kadmium") ; --UNCHK
lin cadre_N = mkWN "kantahenkilökunta" ; --UNCHK
lin caducean_A = mkWA "caduceus-" ; --UNCHK
lin caduceus_N = mkWN "caduceus" ; --UNCHK
lin caducous_A = mkWA "shed" ; --UNCHK
lin caecilian_A = mkWA "matosammakoiden" ; --UNCHK
lin caecilian_N = mkWN (k13 "vaskitsa") ; --UNCHK
lin caen_PN = foreignPN "Caen" ;
lin caerleon_PN = foreignPN "Caerleon" ;
lin caernarfon_PN = foreignPN "Caernarfon" ;
lin caerphilly_PN = foreignPN "Caerphilly" ;
lin caesarian_A = mkWA "Caesarin" ; --UNCHK
lin caespitose_A = mkWA "tufted" ; --UNCHK
lin caesura_N = mkWN (k1A "tauko") ; --UNCHK
lin caesural_A = mkWA "tauko-" ; --UNCHK
lin cafe_N = mkWN (k12 "kuppila") ; --UNCHK
lin cafe_au_lait_N = mkWN (compoundN "maito" (k5 "kahvi")) ; --UNCHK
lin cafeteria_N = mkN "kahvila" ;
lin caff_N = mkWN (k12 "kahvila") ; --UNCHK
lin caffeine_N = mkWN (k5 "kofeiini") ; --UNCHK
lin caffeinic_A = mkWA (compoundA "kofeiinipi" (k38 "toinen")) ; --UNCHK
lin caffeinism_N = mkWN (compoundN "kofeiini" (k39 "myrkytys")) ; --UNCHK
lin caftan_N = mkWN (k6 "kaftaani") ; --UNCHK
lin cage_N = mkWN (compoundN "lyönti" (k5A "häkki")) ; --UNCHK
lin cage_V2 = mkWV2 (k69 "vangita") ; --UNCHK
lin cagey_A = mkWA (k38 "harkitsevainen") ; --UNCHK
lin cagily_Adv = mkWAdv (k99 "varovasti") ; --UNCHK
lin cagliari_PN = foreignPN "Cagliari" ;
lin cagoule_N = mkWN (k5A "anorakki") ; --UNCHK
lin cahoot_N = mkWN "yhteistoiminnassa" ; --UNCHK
lin caiman_N = mkWN (k5 "kaimaani") ; --UNCHK
lin cairn_N = mkWN (compoundN "cairn" (k5 "terrieri")) ; --UNCHK
lin cairned_A = mkWA "merkitty" ; --UNCHK
lin cairngorm_N = mkWN (compoundN "savu" (k5 "kvartsi")) ; --UNCHK
lin cairo_PN = foreignPN "Kairo" ;
lin caisson_N = mkWN (k5 "kasuuni") ; --UNCHK
lin caitiff_A = mkWA (k38 "raukkamainen") ; --UNCHK
lin caitiff_N = mkWN (k9A "raukka") ; --UNCHK
lin cajole_V2 = mkWV2 (k67A "viekoitella") ; --UNCHK
lin cajolery_N = mkWN (k2 "jaarittelu") ; --UNCHK
lin cake_N = mkWN (k14A "patukka") ; --UNCHK
lin cake_V = mkWV (k53A "peittää") ; --UNCHK
lin cake_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin cakewalk_N = mkWN (kH1 "nakki") "helppo" ; --UNCHK
lin calaba_N = mkWN "Calophyllum" "calaba" ; --UNCHK
lin calabash_N = mkWN (compoundN "kalebassi" (k1A "piippu")) ; --UNCHK
lin caladenia_N = mkWN "caladenia" ; --UNCHK
lin caladium_N = mkWN (compoundN "kirjo" (k7A "lehti")) ; --UNCHK
lin calamint_N = mkWN (compoundN "käen" (k1A "minttu")) ; --UNCHK
lin calamitous_A = mkWA (k38 "katastrofaalinen") ; --UNCHK
lin calamity_N = mkWN (k12 "tragedia") ; --UNCHK
lin calamus_N = mkWN (k1A "ruoto") ; --UNCHK
lin calando_A = mkWA "calando" ; --UNCHK
lin calanthe_N = mkWN "kalante" ; --UNCHK
lin calash_N = mkWN (compoundN "taitto" (k1A "katto")) ; --UNCHK
lin calcaneal_A = mkWA "kantaluu-" ; --UNCHK
lin calcareous_A = mkWA (compoundA "kalkki" (k38 "nen")) ; --UNCHK
lin calced_A = mkWA (compoundA "ken" (k1 "gitetty")) ; --UNCHK
lin calceolaria_N = mkWN (compoundN "tohveli" (k10A "kukka")) ; --UNCHK
lin calceolate_A = mkWA (compoundA "tohveli" (k38 "mainen")) ; --UNCHK
lin calceus_N = mkWN (compoundN "varsi" (k6 "sandaali")) ; --UNCHK
lin calcic_A = mkWA "kalkki-" ; --UNCHK
lin calcicolous_A = mkWA "calcicolous" ; --UNCHK
lin calciferous_A = mkWA (compoundA "kalkkipi" (k38 "toinen")) ; --UNCHK
lin calcific_A = mkWA "kalkkeutuva" ; --UNCHK
lin calcification_N = mkWN "kalkkeutuminen" ; --UNCHK
lin calcifugous_A = mkWA "calcifugous" ; --UNCHK
lin calcify_V = mkWV (k69 "kalkita") ; --UNCHK
lin calcify_V2 = mkWV2 (k69 "kalkita") ; --UNCHK
lin calcimine_N = mkWN (k5 "kalkkimaali") ; --UNCHK
lin calcination_N = mkWN (k39 "pasutus") ; --UNCHK
lin calcine_V = mkWV (k54A "kuumentaa") ; --UNCHK
lin calcine_V2 = mkWV2 (k54A "kuumentaa") ; --UNCHK
lin calcite_N = mkWN "kalsiitti" ; --UNCHK
lin calcitic_A = mkWA "kalsiitti-" ; --UNCHK
lin calcitonin_N = mkWN (compoundN "kalsito" (k26 "niini")) ; --UNCHK
lin calcium_N = mkWN (k5 "kalsium") ; --UNCHK
lin calculable_A = mkWA "laskettava" ; --UNCHK
lin calculate_V = mkWV (k58 "laskea") ;
lin calculate_V2 = mkWV2 (k58 "laskea") ;
lin calculate_VS = mkWVS (k58 "laskea") ;
lin calculatingly_Adv = mkWAdv (compoundAdv "laskelmoiv" (k99 "asti")) ; --UNCHK
lin calculation_N = mkWN (k9A "laskenta") ; --UNCHK
lin calculator_N = mkWN (k33 "laskin") ; --UNCHK
lin calculous_A = mkWA "kivi-" ; --UNCHK
lin calculus_N = mkWN (compoundN "differentiaali" (k9A "laskenta")) ; --UNCHK
lin calcutta_PN = foreignPN "Calcutta" ;
lin caldera_N = mkWN "kaldera" ; --UNCHK
lin caldicot_PN = foreignPN "Caldicot" ;
lin caldron_N = mkWN (kH1 "pata") ; --UNCHK
lin calefacient_A = mkWA "lämmittävä" ; --UNCHK
lin calefaction_N = mkWN "lämmittävyys" ; --UNCHK
lin calefactory_A = mkWA "lämmittävä" ; --UNCHK
lin calendar_N = mkWN (k6 "kalenteri") ;
lin calender_N = mkWN (k6 "kalanteri") ; --UNCHK
lin calender_V2 = mkWV2 (k62 "kalanteroida") ; --UNCHK
lin calendric_A = mkWA (k38 "kalendaarinen") ; --UNCHK
lin calendula_N = mkWN (compoundN "kalend" (k10 "ula")) ; --UNCHK
lin calf_N = mkWN (k14A "vasikka") ; --UNCHK
lin calf_love_N = mkWN (k7A "lempi") "nuori" ; --UNCHK
lin cali_PN = foreignPN "Cali" ;
lin calibrate_V2 = mkWV2 (k62 "kalibroida") ; --UNCHK
lin calibration_N = mkWN (k39 "normitus") ; --UNCHK
lin calibre_N = mkWN (k1 "taso") ; --UNCHK
lin caliche_N = mkWN (compoundN "chilen" (k6 "salpietari")) ; --UNCHK
lin calico_A = mkWA "kalikoo-" ; --UNCHK
lin calico_N = mkWN "kalikoo-" ; --UNCHK
lin calif_N = mkWN (k5 "kalifi") ; --UNCHK
lin california_PN = foreignPN "Kalifornia" ;
lin californian_A = mkWA (compoundA "kaliforni" (k38 "alainen")) ; --UNCHK
lin californian_N = mkWN (compoundN "kaliforni" (k38 "alainen")) ; --UNCHK
lin californium_N = mkWN "järjestysluku" "98" ; --UNCHK
lin caliginous_A = mkWA (k10A "synkkä") ; --UNCHK
lin caliper_N = mkWN (compoundN "mitta" (k5A "harppi")) ; --UNCHK
lin caliph_N = mkWN (k5 "kalifi") ; --UNCHK
lin caliphate_N = mkWN "kalifaatti" ; --UNCHK
lin calisaya_N = mkWN (compoundN "kiinan" (k18 "puu")) ; --UNCHK
lin calisthenic_A = mkWA "voimistelu-" ; --UNCHK
lin calisthenics_N = mkWN (k2 "voimistelu") ; --UNCHK
lin calk_N = mkWN "hokki" ; --UNCHK
lin calk_V2 = mkWV2 (k53A "vammauttaa") ; --UNCHK
lin call_N = mkN "kutsu" ;
lin call_V = mkV "soittaa" ; --mkV "kutsua" ;
lin call_V2 = mkV2 (mkV "soittaa") (casePrep allative) ;
lin call_VS = mkVS "kutsua" ; ---??
lin call_after_V2 = prepV2 OP_call_V OP_after_Prep ; -- guess-p-verb
lin call_around_V = advV OP_call_V OP_around_Adv ; -- guess-p-verb
lin call_back_V2 = mkWV2 (k64 "tuoda") "mieleen" ; --UNCHK
lin call_box_N = mkWN (compoundN "posti" (k2 "lokero")) ; --UNCHK
lin call_for_V2 = mkWV2 (k52 "anoa") ; --UNCHK
lin call_for_V2V = variants {} ; -- guess-p-verb
lin call_forth_V2 = mkWV2 (k64 "tuoda") "esiin" ; --UNCHK
lin call_girl_N = mkWN (compoundN "ilo" (k1A "tyttö")) ; --UNCHK
lin call_in_V = mkWV (k53A "soittaa") ; --UNCHK
lin call_in_V2 = mkWV2 (k53A "soittaa") ; --UNCHK
lin call_off_V2 = mkWV2 (k53A "kuuluttaa") ; --UNCHK
lin call_on_V = mkWV (k74A "vedota") ; --UNCHK
lin call_on_V2 = mkWV2 (k74A "vedota") ; --UNCHK
lin call_out_V2 = mkWV2 (k56 "haastaa") ; --UNCHK
lin call_over_V = advV OP_call_V OP_over_Adv ; -- guess-p-verb
lin call_round_V = advV OP_call_V OP_round_Adv ; -- guess-p-verb
lin call_up_N = mkWN (k9A "kutsunta") ; --UNCHK
lin call_up_V2 = mkWV2 (k64 "tuoda") "mieleen" ; --UNCHK
lin callable_A = mkWA "callable" ; --UNCHK
lin called_A = mkA "kutsuttu" ;
lin caller_N = mkWN (k39 "jarrutus") ; --UNCHK
lin calliandra_N = mkWN "kalliandra" ; --UNCHK
lin calligrapher_N = mkWN (k10 "tekstaaja") ; --UNCHK
lin calligraphic_A = mkWA "kalligrafinen" ; --UNCHK
lin calligraphy_N = mkWN (compoundN "kauno" (k39 "kirjoitus")) ; --UNCHK
lin calling_N = mkWN (k5A "ammatti") ; --UNCHK
lin calliopsis_N = mkWN "tiikerikaunosilmä" ; --UNCHK
lin callipygian_A = mkWA (k41A "muodokas") ; --UNCHK
lin callisthenics_N = mkWN (k2 "voimistelu") ; --UNCHK
lin callithump_N = mkWN (k5 "charivari") ; --UNCHK
lin callithumpian_A = mkWA "paraati-" ; --UNCHK
lin callosity_N = mkWN (k40 "piittaamattomuus") ; --UNCHK
lin callous_A = mkWA (k34A "sydämetön") ; --UNCHK
lin calloused_A = mkWA (k38 "känsäinen") ; --UNCHK
lin callousness_N = mkWN (k40 "piittaamattomuus") ; --UNCHK
lin callow_A = mkWA (k15 "vihreä") ; --UNCHK
lin callowness_N = mkWN (k40 "nuoruus") ; --UNCHK
lin callus_N = mkWN (k10 "kovettuma") ; --UNCHK
lin calm_A = mkWA (k26 "tyyni") ;
lin calm_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin calm_V = mkWV (k56A "antaa") "rauhoittavia" ; --UNCHK
lin calm_V2 = mkV2 "rauhoittaa" partitive ;
lin calm_down_V2 = mkWV2 (k52A "rauhoittua") ; --UNCHK
lin calmness_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin calne_PN = foreignPN "Calne" ;
lin caloric_A = mkWA "kalori-" ; --UNCHK
lin calorie_N = mkWN (k6 "kalori") ; --UNCHK
lin calorifacient_A = mkWA (k10 "tuottava") "lämpöä" ; --UNCHK
lin calorific_A = mkWA "lämmittävä" ; --UNCHK
lin calorimeter_N = mkWN (k5 "kalorimetri") ; --UNCHK
lin calorimetric_A = mkWA (compoundA "kalori" (k38 "metrinen")) ; --UNCHK
lin calorimetry_N = mkWN "kalorimetria" ; --UNCHK
lin calosoma_N = mkWN (compoundN "kaunokiitä" (k38 "jäinen")) ; --UNCHK
lin calpac_N = mkWN (k5A "kalpakki") ; --UNCHK
lin calque_N = mkWN (compoundN "käännös" (k9 "laina")) ; --UNCHK
lin caltrop_N = mkWN (compoundN "piikki" (k5A "kaunokki")) ; --UNCHK
lin calumet_N = mkWN (compoundN "rauhan" (k1A "piippu")) ; --UNCHK
lin calumniate_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin calumniatory_A = mkWA (compoundA "must" (k9 "aava")) ; --UNCHK
lin calumny_N = mkWN (k39 "mustamaalaus") ; --UNCHK
lin calvaria_N = mkWN (kH1 "laki") "pääkallon" ; --UNCHK
lin calvary_N = mkWN (k40 "marttyyrius") ; --UNCHK
lin calve_V = mkWV (k61A "poikia") ; --UNCHK
lin calverton_PN = foreignPN "Calverton" ;
lin calving_N = mkWN (k5A "vasikointi") ; --UNCHK
lin calvinism_N = mkWN (compoundN "Kalvin" (k5 "ismi")) ; --UNCHK
lin calvinist_N = mkWN (k5 "kalvinisti") ; --UNCHK
lin calyceal_A = mkWA (compoundA "pikari" (k38 "mainen")) ; --UNCHK
lin calycular_A = mkWA (k38 "maljamainen") ; --UNCHK
lin calyculate_A = mkWA "pikari-" ; --UNCHK
lin calyculus_N = mkWN (k9 "malja") ; --UNCHK
lin calypso_N = mkWN "Kalypso" ; --UNCHK
lin calyptra_N = mkWN (compoundN "juuri" (k1A "huntu")) ; --UNCHK
lin calyptrate_A = mkWA (compoundA "juu" (k38 "rihuntuinen")) ; --UNCHK
lin calyx_N = mkWN (k3 "verhiö") ; --UNCHK
lin cam_N = mkWN (compoundN "nokka" (k10 "pyörä")) ; --UNCHK
lin camail_N = mkWN (compoundN "rengaspanssari" (k1A "huppu")) ; --UNCHK
lin camaraderie_N = mkWN (k40 "ystävyys") ; --UNCHK
lin camas_N = mkWN (compoundN "tähti" (k5A "hyasintti")) ; --UNCHK
lin camber_N = mkWN (compoundN "pysty" (k10 "kallistuma")) ; --UNCHK
lin camber_V = mkWV (k52A "kaareutua") ; --UNCHK
lin camber_V2 = mkWV2 (k52A "kaareutua") ; --UNCHK
lin cambial_A = mkWA "jälsi-" ; --UNCHK
lin cambium_N = mkWN (k28A "jälsi") ; --UNCHK
lin cambodia_PN = foreignPN "Kambodza" ;
lin cambodian_A = mkWA (compoundA "kamputse" (k38 "alainen")) ; --UNCHK
lin cambodian_N = mkWN (compoundN "kamputse" (k38 "alainen")) ; --UNCHK
lin cambric_N = mkWN (k5 "batisti") ; --UNCHK
lin cambridge_PN = foreignPN "Cambridge" ;
lin camcorder_N = mkWN (compoundN "video" (k12 "kamera")) ; --UNCHK
lin camden_PN = foreignPN "Camden" ;
lin camel_N = mkWN (k6 "kameli") ; --UNCHK
lin camellia_N = mkWN (k12 "kamelia") ; --UNCHK
lin camelpox_N = mkWN (compoundN "kameli" (k1A "rokko")) ; --UNCHK
lin cameo_N = mkWN (k20 "kamee") ; --UNCHK
lin camera_N = L.camera_N ;
lin cameraman_N = mkWN (k10 "kuvaaja") ;
lin cameroon_PN = foreignPN "Kamerun" ;
lin cameroonian_A = mkWA (compoundA "kameruni" (k38 "lainen")) ; --UNCHK
lin cameroonian_N = mkWN (compoundN "kameruni" (k38 "lainen")) ; --UNCHK
lin camise_N = mkWN (k2 "pusero") ; --UNCHK
lin camisole_N = mkWN (compoundN "aamu" (k5A "takki")) ; --UNCHK
lin camlet_N = mkWN (k41A "silkkikangas") ; --UNCHK
lin camomile_N = mkWN (k2 "sauramo") ; --UNCHK
lin camouflage_N = mkWN (k5A "naamiointi") ; --UNCHK
lin camouflage_V2 = mkWV2 (k62 "naamioida") ; --UNCHK
lin camp_A = mkWA (k10 "huvittava") ; --UNCHK
lin camp_N = mkWN (k5 "leiri") ; --UNCHK
lin camp_V = mkWV (k67A "liioitella") ; --UNCHK
lin camp_V2 = mkWV2 (k67A "liioitella") ; --UNCHK
lin camp_bed_N = mkWN (compoundN "kenttä" (k48A "vuode")) ; --UNCHK
lin camp_chair_N = mkWN (compoundN "teltta" (k5 "tuoli")) ; --UNCHK
lin camp_follower_N = mkWN (k12 "myötäilijä") ; --UNCHK
lin camp_out_V = mkWV (k52A "leiriytyä") ; --UNCHK
lin campaign_N = mkN "kampanja" ;
lin campaign_V = mkWV (k60A "lähteä") "sotaan" ; --UNCHK
lin campaigner_N = mkWN (k5A "kandidaatti") ; --UNCHK
lin campaigning_N = mkWN (k5A "kampanjointi") ; --UNCHK
lin campanile_N = mkWN (compoundN "kello" (k5 "torni")) ; --UNCHK
lin campanula_N = mkWN (k1 "kello") ; --UNCHK
lin campanulate_A = mkWA (k38 "kellomainen") ; --UNCHK
lin campbeltown_PN = foreignPN "Campbeltown" ;
lin camper_N = mkWN (compoundN "asunto" (k1 "auto")) ; --UNCHK
lin campestral_A = mkWA "pelto-" ; --UNCHK
lin camp_fire_N = mkWN (k3 "nuotio") ; --UNCHK
lin camphor_N = mkWN (k6 "kamferi") ; --UNCHK
lin camphoraceous_A = mkWA (compoundA "kamferi" (k38 "mainen")) ; --UNCHK
lin camphorated_A = mkWA "kamferi-" ; --UNCHK
lin camphoric_A = mkWA "kamferi-" ; --UNCHK
lin camping_N = mkWN (k2 "telttailu") ; --UNCHK
lin campion_N = mkWN (k5A "kohokki") ; --UNCHK
lin campmate_N = mkWN (compoundN "leiri" (k6 "toveri")) ; --UNCHK
lin campsite_N = mkWN (k5 "leiri") ; --UNCHK
lin camp_stool_N = mkWN (compoundN "retki" (k5 "tuoli")) ; --UNCHK
lin campus_N = mkWN (k39 "kampus") ; --UNCHK
lin campylotropous_A = mkWA "campylotropous" ; --UNCHK
lin camshaft_N = mkWN (compoundN "nokka-" (k6 "akseli")) ; --UNCHK
lin camwood_N = mkWN "Baphia" "nitida" ; --UNCHK
lin can8know_VV = S.can8know_VV ;
lin can_1_VV = S.can_VV ;
lin can_2_VV = S.can8know_VV ;
lin can_N = mkWN (k5A "tölkki") ; --UNCHK
lin can_V2 = mkWV2 (k53A "purkittaa") ; --UNCHK
lin canada_PN = foreignPN "Kanada" ;
lin canadian_A = mkWA (k38 "kanadalainen") ; --UNCHK
lin canadian_N = mkWN (compoundN "Canadian-" (k7A "joki")) ; --UNCHK
lin canal_N = mkWN (k10 "kanava") ; --UNCHK
lin canalicular_A = mkWA (compoundA "kana" (k38 "likulaarinen")) ; --UNCHK
lin canaliculate_A = mkWA (compoundA "kana" (k38 "vallinen")) ; --UNCHK
lin canaliculus_N = mkWN (compoundN "pikku" (k10 "kanava")) ; --UNCHK
lin canalization_N = mkWN (k5A "kanavointi") ; --UNCHK
lin canalize_V2 = mkWV2 (k73A "suunnata") ; --UNCHK
lin canape_N = mkWN (k18 "kanapee") ; --UNCHK
lin canard_N = mkWN (k1A "tieto") "perätön" ; --UNCHK
lin canary_A = mkWA (compoundA "kanarian" (k38 "keltainen")) ; --UNCHK
lin canary_N = mkWN (compoundN "kanaria" (k1A "lintu")) ; --UNCHK
lin canary_bird_N = mkWN (compoundN "kanaria" (k1A "lintu")) ; --UNCHK
lin canary_wine_N = mkWN (kH1 "viini") "Kanarian" ; --UNCHK
lin canasta_N = mkWN (k9 "canasta") ; --UNCHK
lin canavanine_N = mkWN (compoundN "kanava" (k26 "niini")) ; --UNCHK
lin canberra_PN = foreignPN "Canberra" ;
lin cancan_N = mkWN (k5 "cancan") ; --UNCHK
lin cancel_V = mkV "peruuttaa" ; --UNCHK
lin cancel_V2 = mkV2 "peruuttaa" ;
lin cancel_out_V2 = mkWV2 (k62 "neutraloida") ; --UNCHK
lin cancellate_A = mkWA (k38 "hohkainen") ; --UNCHK
lin cancellation_N = mkWN (k39 "peruutus") ;
lin cancer_N = mkN "syöpä" ; --f112
lin cancerous_A = mkWA (k38 "syöpäinen") ; --UNCHK
lin cancerweed_N = mkWN (compoundN "lyyra" (k12 "salvia")) ; --UNCHK
lin cancroid_A = mkWA (compoundA "syöpä" (k38 "mäinen")) ; --UNCHK
lin cancroid_N = mkWN (compoundN "levyepiteeli" (k10A "syöpä")) ; --UNCHK
lin candelabrum_N = mkWN (k4A "kynttelikkö") ; --UNCHK
lin candelilla_N = mkWN (compoundN "kandedilla" (k5 "kasvi")) ; --UNCHK
lin candescent_A = mkWA (compoundA "heh" (k10 "kuva")) ; --UNCHK
lin candid_A = mkWA (k34A "kursailematon") ; --UNCHK
lin candida_N = mkWN "candida" ; --UNCHK
lin candidacy_N = mkWN (k5A "kampanjointi") ; --UNCHK
lin candidateFem_N = mkWN (k5A "kandidaatti") ; --f88
lin candidateMasc_N = mkN "ehdokas" ;
lin candidature_N = mkWN (k5A "kampanjointi") ; --UNCHK
lin candidiasis_N = mkWN (compoundN "hiivasieni" (k39 "tulehdus")) ; --UNCHK
lin candle_N = mkWN (k12 "kynttilä") ; --UNCHK
lin candlelight_N = mkWN (compoundN "kynttilän" (k1 "valo")) ; --UNCHK
lin candlemaker_N = mkWN (compoundN "kynttilän" (k12 "tekijä")) ; --UNCHK
lin candlenut_N = mkWN (compoundN "bankul" (k12 "pähkinä")) ; --UNCHK
lin candlepin_N = mkWN (k9 "keila") ; --UNCHK
lin candlepins_N = mkWN (compoundN "candlepin-" (k2 "keilailu")) ; --UNCHK
lin candle_power_N = mkWN (k5A "intensiteetti") "valon" ; --UNCHK
lin candlesnuffer_N = mkWN (compoundN "kynttilän" (k33A "sammutin")) ; --UNCHK
lin candlestick_N = mkWN (compoundN "kynttilän" (k9A "jalka")) ; --UNCHK
lin candlewick_N = mkWN (compoundN "kynttilän" (k33 "sydän")) ; --UNCHK
lin candlewood_N = mkWN (compoundN "poltto" (k18 "puu")) ; --UNCHK
lin candor_N = mkWN (k40 "avoimuus") ; --UNCHK
lin candour_N = mkWN (k40 "avoimuus") ; --UNCHK
lin candy_N = mkWN (k38 "makeinen") ; --UNCHK
lin candy_V = mkWV (k53A "kuorruttaa") "sokerilla" ; --UNCHK
lin candy_V2 = mkWV2 (k53A "kuorruttaa") "sokerilla" ; --UNCHK
lin candytuft_N = mkWN (k1A "saippo") ; --UNCHK
lin cane_N = mkWN (k5A "keppi") ; --UNCHK
lin cane_V2 = mkWV2 (k53A "kurittaa") ; --UNCHK
lin canebrake_N = mkWN (k4A "ruoikko") ; --UNCHK
lin canella_N = mkWN (k6 "kaneli") "valkoinen" ; --UNCHK
lin canescent_A = mkWA (compoundA "harmaan" (k15 "valkea")) ; --UNCHK
lin canfield_N = mkWN (compoundN "Canfield-" (k5 "pasianssi")) ; --UNCHK
lin cangue_N = mkWN (compoundN "kaula" (k9A "panta")) ; --UNCHK
lin canine_A = mkWA (compoundA "koira" (k38 "mainen")) ; --UNCHK
lin canine_N = mkWN (compoundN "koira" (k33 "eläin")) ; --UNCHK
lin canistel_N = mkWN "Pouteria" "campechiana" ; --UNCHK
lin canister_N = mkWN (k5A "purkki") ; --UNCHK
lin canker_N = mkWN (k10A "syöpä") ; --UNCHK
lin canker_V2 = mkWV2 (k53A "tartuttaa") ; --UNCHK
lin cankerous_A = mkWA (k38 "haavainen") ; --UNCHK
lin cankerworm_N = mkWN (k10A "toukka") ; --UNCHK
lin canna_N = mkWN (kH1 "kanna") ; --UNCHK
lin cannabin_N = mkWN (compoundN "kannabis" (k5 "hartsi")) ; --UNCHK
lin cannabis_N = mkWN (k11 "marihuana") ; --UNCHK
lin cannelloni_N = mkWN (k5 "cannelloni") ; --UNCHK
lin cannery_N = mkWN (compoundN "säilyke" (k41A "tehdas")) ; --UNCHK
lin cannes_PN = foreignPN "Cannes" ;
lin cannibal_N = mkWN (k5 "kannibaali") ; --UNCHK
lin cannibalic_A = mkWA (k38 "kannibaalinen") ; --UNCHK
lin cannibalism_N = mkWN (k5 "kannibalismi") ; --UNCHK
lin cannibalistic_A = mkWA "kannibalistinen" ; --UNCHK
lin cannibalize_V2 = mkWV2 (k53A "purkaa") "varaosiksi" ; --UNCHK
lin cannikin_N = mkWN (k5A "purkki") ; --UNCHK
lin cannock_PN = foreignPN "Cannock" ;
lin cannon_1_N = mkWN (k9 "kanuuna") ; --UNCHK
lin cannon_2_N = variants {} ; --UNCHK
lin cannon_fodder_N = mkWN (compoundN "tykin" (k10A "ruoka")) ; --UNCHK
lin cannonade_N = mkWN (compoundN "tykistö" (k23 "tuli")) ; --UNCHK
lin cannonball_N = mkWN (k10 "kuula") ; --UNCHK
lin cannula_N = mkWN (k5 "kanyyli") ; --UNCHK
lin cannulation_N = mkWN (compoundN "ase" (k38 "ttaminen")) "johtoputken" ; --UNCHK
lin canny_A = mkWA (k10 "ovela") ; --UNCHK
lin canoe_N = mkWN (k5A "kanootti") ; --UNCHK
lin canoe_V2 = mkWV2 (k52 "meloa") ; --UNCHK
lin canoeist_N = mkWN (k10 "meloja") ; --UNCHK
lin canon_N = mkWN (k6 "kaanon") ; --UNCHK
lin canonic_A = mkWA (k38 "kanoninen") ; --UNCHK
lin canonical_A = mkWA (k38 "kanoninen") ; --UNCHK
lin canonist_A = mkWA (compoundA "kanonis" (k38 "tinen")) ; --UNCHK
lin canonist_N = mkWN (k12 "tuntija") "kirkko-oikeuden" ; --UNCHK
lin canonization_N = mkWN (compoundN "kanoni" (k5A "sointi")) ; --UNCHK
lin canonize_V2 = mkWV2 (k53 "kanonistaa") ; --UNCHK
lin canopied_A = mkWA (compoundA "kate" (k1 "ttu")) ; --UNCHK
lin canopy_N = mkWN (k1 "varjo") ; --UNCHK
lin canorous_A = mkWA (k38 "laulullinen") ; --UNCHK
lin cant_N = mkWN (k40 "vinous") ; --UNCHK
lin cant_V = mkWV (k53A "viettää") ; --UNCHK
lin cant_V2 = mkWV2 (k53A "viettää") ; --UNCHK
lin cantabile_A = mkWA "laulaen" ; --UNCHK
lin cantaloupe_N = mkWN (compoundN "cantaloupe" (k6 "meloni")) ; --UNCHK
lin cantankerous_A = mkWA (k1 "häijy") ; --UNCHK
lin cantata_N = mkWN (k3 "oratorio") ; --UNCHK
lin canteen_N = mkWN (compoundN "kenttä" (k1 "pullo")) ; --UNCHK
lin canter_N = mkWN (kH1 "laukka") ; --UNCHK
lin canter_V = mkWV (k73A "laukata") ; --UNCHK
lin canter_V2 = mkWV2 (k73A "laukata") ; --UNCHK
lin canterbury_PN = foreignPN "Canterbury" ;
lin canthus_N = mkWN (compoundN "silmä" (k10 "kulma")) ; --UNCHK
lin canticle_N = mkWN (k5 "psalmi") ; --UNCHK
lin cantilever_N = mkWN (compoundN "tuki" (k5A "palkki")) ; --UNCHK
lin cantillation_N = mkWN "kantillaatio" ; --UNCHK
lin cantle_N = mkWN (k26 "takakaari") ; --UNCHK
lin canto_N = mkWN (k1A "luku") ; --UNCHK
lin canton_N = mkWN (k6 "kantoni") ; --UNCHK
lin canton_PN = foreignPN "Canton" ;
lin cantonal_A = mkWA "piirikunta-" ; --UNCHK
lin cantonment_N = mkWN (k5 "leiri") ; --UNCHK
lin cantor_N = mkWN (k6 "kanttori") ; --UNCHK
lin canty_A = mkWA (k41A "reipas") ; --UNCHK
lin canuck_N = mkWN (k38 "kanadalainen") ; --UNCHK
lin canvas_N = mkWN (k41A "telttakangas") ; --UNCHK
lin canvasback_N = mkWN "isopunasotka" ; --UNCHK
lin canvass_N = mkWN (k41A "telttakangas") ; --UNCHK
lin canvass_V = mkWV (k67 "tarkastella") ; --UNCHK
lin canvass_V2 = mkWV2 (k67 "tarkastella") ; --UNCHK
lin canvasser_N = mkWN (compoundN "vaali" (k12 "toimitsija")) ; --UNCHK
lin canyon_N = mkWN (k1 "kuru") ; --UNCHK
lin canyonside_N = mkWN (compoundN "kanjonin" (k9 "reuna")) ; --UNCHK
lin cap_1_N = L.cap_N ;
lin cap_2_N = L.cap_N ;
lin cap_V2 = mkWV2 (k53A "rajoittaa") ;
lin cap_off_V2 = mkWV2 (k53A "päättää") ; --UNCHK
lin capability_N = mkN (lin NK {s = d01A "kyky"}) ;
lin capable_of_A2 = mkA2 (mkWA (k10 "pystyvä")) (mkPrep illative) ; --UNCHK
lin capacious_A = mkWA (k10 "tilava") ; --UNCHK
lin capaciousness_N = mkWN (k40 "avaruus") ; --UNCHK
lin capacitance_N = mkWN (k6 "kondensaattori") ; --UNCHK
lin capacitive_A = mkWA "kapasitanssi-" ; --UNCHK
lin capacitor_N = mkWN (k6 "kondensaattori") ; --UNCHK
lin capacity_N = mkN "kapasiteetti" ;
lin caparison_N = mkWN (k25 "loimi") ; --UNCHK
lin caparison_V2 = mkWV2 (k53 "valjastaa") ; --UNCHK
lin cape_N = mkWN (k5A "keeppi") ; --UNCHK
lin capelin_N = mkWN (compoundN "villa" (k48 "kuore")) ; --UNCHK
lin caper_N = mkWN (k2 "pelleily") ; --UNCHK
lin caper_V = mkWV (k67A "hypähdellä") ; --UNCHK
lin capercaillie_N = mkWN (k1 "metso") ; --UNCHK
lin capful_N = mkWN (k38 "korkillinen") ; --UNCHK
lin capillarity_N = mkWN (k40 "kapillaarisuus") ; --UNCHK
lin capillary_A = mkWA (k38 "kapillaarinen") ; --UNCHK
lin capillary_N = mkWN (k5 "kapillaari") ; --UNCHK
lin capital_1_N = mkN "pää" (mkN "kaupunki") ;
lin capital_2_N = mkN "pää" (mkN "oma") ;
lin capital_3_N = mkN "isokirjain" ; ---- iso kirjain : CN
lin capital_A = mkA (mkN "pää" (mkN "asiallinen")) ; --mkWA (k6 "versaali") ;
lin capital_N = mkN "pää" (mkN "oma") ;
lin capitalism_N = mkWN (k5 "kapitalismi") ;
lin capitalist_A = mkWA (k38 "kapitalistinen") ; --UNCHK
lin capitalist_N = mkWN (k5 "kapitalisti") ; --UNCHK
lin capitalistic_A = mkWA (k38 "kapitalistinen") ; --UNCHK
lin capitalization_N = mkWN (k5A "kapitalointi") ; --UNCHK
lin capitalize_V = mkV "kapitalisoida" ;
lin capitalize_V2 = mkWV2 (k53A "pääomittaa") ;
lin capitate_A = mkWA (compoundA "ranneluu" (k38 "mainen")) ; --UNCHK
lin capitate_N = mkWN (compoundN "ranne" (k18 "luu")) "iso" ; --UNCHK
lin capitation_N = mkWN (compoundN "henki" (k1 "vero")) ; --UNCHK
lin capitol_N = mkWN "Capitol" "Building" ; --UNCHK
lin capitular_A = mkWA (k38 "kirkollinen") ; --UNCHK
lin capitulate_V = mkWV (k53A "luovuttaa") ; --UNCHK
lin capitulate_V2 = mkWV2 (k53A "luovuttaa") ; --UNCHK
lin capitulation_N = mkWN "antautuminen" ; --UNCHK
lin capitulum_N = mkWN (k2 "lehvistö") ; --UNCHK
lin capo_N = mkWN (k10 "johtaja") ; --UNCHK
lin capon_N = mkWN (compoundN "syöttö" (k1A "kukko")) ; --UNCHK
lin capote_N = mkWN (k12 "kauhtana") "hupullinen" ; --UNCHK
lin cappuccino_N = mkWN (k1 "cappuccino") ; --UNCHK
lin capriccio_N = mkWN (k5 "kapriisi") ; --UNCHK
lin caprice_N = mkWN (compoundN "päähän" (k1 "pisto")) ; --UNCHK
lin capricious_A = mkWA (k38 "äkillinen") ; --UNCHK
lin capriciousness_N = mkWN (k2 "oikuttelu") ; --UNCHK
lin caprifig_N = mkWN (compoundN "aito" (k12 "viikuna")) ; --UNCHK
lin caprine_A = mkWA (compoundA "vuohi" (k38 "mainen")) ; --UNCHK
lin capriole_N = mkWN (k1A "hyppy") ; --UNCHK
lin capsaicin_N = mkWN "kapsaisiini" ; --UNCHK
lin capsid_N = mkWN "kapsidi" ; --UNCHK
lin capsize_V = mkWV (k52A "kääntyä") "ympäri" ; --UNCHK
lin capsize_V2 = mkWV2 (k52A "kääntyä") "ympäri" ; --UNCHK
lin capsizing_N = mkWN "kaatuminen" ; --UNCHK
lin capstan_N = mkWN (compoundN "ankkuri" (k5 "vinssi")) ; --UNCHK
lin capstone_N = mkWN (compoundN "kansi" (k7 "kivi")) ; --UNCHK
lin capsular_A = mkWA "kapseli-" ; --UNCHK
lin capsulate_A = mkWA "kota-" ; --UNCHK
lin capsule_N = mkWN (k6 "kapseli") ; --UNCHK
lin captain_N = mkWN (compoundN "hovi" (k6 "mestari")) ; --UNCHK
lin captain_V2 = mkWV2 (k61 "toimia") "kapteenina" ; --UNCHK
lin captainship_N = mkWN (k40 "päällikkyys") ; --UNCHK
lin caption_N = mkWN (k48 "seloste") ; --UNCHK
lin captious_A = mkWA (k38 "pikkumainen") ; --UNCHK
lin captivate_V2 = mkWV2 (k53A "houkuttaa") ; --UNCHK
lin captivation_N = mkWN (k39 "viehätys") ; --UNCHK
lin captiveFem_N = mkWN (k33 "eläin") "vangittu" ; --UNCHK ---- sense to be split
lin captiveMasc_N = mkWN (k33 "eläin") "vangittu" ; --UNCHK ---- sense to be split
lin captive_N = mkWN (k33 "eläin") "vangittu" ; --UNCHK
lin captivity_N = mkWN (k40 "orjuus") ; --UNCHK
lin captopril_N = mkWN "Capoten" ; --UNCHK
lin captor_N = mkWN (k12 "vangitsija") ; --UNCHK
lin capture_N = mkWN (k39 "kaappaus") ; --UNCHK
lin capture_V2 = mkWV2 (k73A "napata") ;
lin capuchin_N = mkWN (k5 "kapusiini") ; --UNCHK
lin capulin_N = mkWN "Prunus" "salicifolia" ; --UNCHK
lin caput_N = mkWN (k1 "kallo") ; --UNCHK
lin capybara_N = mkWN (compoundN "vesi" (k9A "sika")) ; --UNCHK
lin car_N = L.car_N ;
lin car_V = variants {} ; --
lin carabao_N = mkWN (compoundN "vesi" (k6 "puhveli")) ; --UNCHK
lin carabiner_N = mkWN (k9A "karbiinihaka") ; --UNCHK
lin caracal_N = mkWN (compoundN "aavikko" (k39 "ilves")) ; --UNCHK
lin caracara_N = mkWN (compoundN "kara" (k9 "kara")) ; --UNCHK
lin caracas_PN = foreignPN "Caracas" ;
lin caracolito_N = mkWN (compoundN "caraco" (k1 "lito")) "Ruptiliocarpon" ; --UNCHK
lin carafe_N = mkN "karahvi" ;
lin carambola_N = mkWN (k10 "karambola") ; --UNCHK
lin caramel_A = mkWA (compoundA "karamellin" (k15 "ruskea")) ; --UNCHK
lin caramel_N = mkWN (compoundN "ruskean" (k38 "keltainen")) ; --UNCHK
lin carancha_N = mkWN (compoundN "töyhtökara" (k9 "kara")) ; --UNCHK
lin caranday_N = mkWN (k9 "alba") "Copernicia" ; --UNCHK
lin carat_N = mkWN (k5A "karaatti") ; --UNCHK
lin caravan_N = mkN "karavaani" ;
lin caravanning_N = mkWN (compoundN "asuntovaunu" (k2 "matkailu")) ; --UNCHK
lin caravanserai_N = mkWN (compoundN "maja" (k1 "talo")) ; --UNCHK
lin caraway_N = mkWN (kH1 "kumina") ; --UNCHK
lin carbamate_N = mkWN "karbamaatti" ; --UNCHK
lin carbide_N = mkWN (k5 "karbidi") ; --UNCHK
lin carbine_N = mkWN (k5 "karbiini") ; --UNCHK
lin carbineer_N = mkWN (k5 "karabinieeri") ; --UNCHK
lin carbocyclic_A = mkWA (compoundA "karbo" (k38 "syklinen")) ; --UNCHK
lin carbohydrate_N = mkWN (k6 "sokeri") ; --UNCHK
lin carbolated_A = mkWA "fenoli-" ; --UNCHK
lin carbomycin_N = mkWN "karbomysiini" ; --UNCHK
lin carbon_N = mkN "hiili" "hiilen" "hiiliä" ;
lin carbon_paper_N = mkWN (compoundN "hiili" (k6 "paperi")) ; --UNCHK
lin carbonaceous_A = mkWA (compoundA "hiilipi" (k38 "toinen")) ; --UNCHK
lin carbonado_N = mkWN "karbonado" ; --UNCHK
lin carbonara_N = mkWN "carbonara" ; --UNCHK
lin carbonate_N = mkWN (k5A "karbonaatti") ; --UNCHK
lin carbonated_A = mkWA (compoundA "hiili" (k38 "happoinen")) ; --UNCHK
lin carbonation_N = mkWN (compoundN "hiili" (k38 "hapottaminen")) ; --UNCHK
lin carbonic_A = mkWA (compoundA "hiilipi" (k38 "toinen")) ; --UNCHK
lin carboniferous_A = mkWA (compoundA "hiilipi" (k38 "toinen")) ; --UNCHK
lin carbonization_N = mkWN (k1A "hiilto") ; --UNCHK
lin carbonize_V2 = mkWV2 (k53A "hiillyttää") ; --UNCHK
lin carbonyl_A = mkWA "karbonyyli-" ; --UNCHK
lin carborundum_N = mkWN (compoundN "pii" (k5 "karbidi")) ; --UNCHK
lin carboxyl_A = mkWA "karboksyyli-" ; --UNCHK
lin carboxyl_N = mkWN (compoundN "karboksyyli" (k10 "ryhmä")) ; --UNCHK
lin carboy_N = mkWN (compoundN "happo" (k1 "pullo")) ; --UNCHK
lin carbuncle_N = mkWN (compoundN "ajos" (k9 "pahka")) ; --UNCHK
lin carburettor_N = mkWN (k33A "kaasutin") ; --UNCHK
lin carcase_N = mkWN (k1A "raato") ; --UNCHK
lin carcass_N = mkWN (k1A "raato") ; --UNCHK
lin carcinogen_N = mkWN (k48 "aine") "syöpää" "aiheuttava" ; --UNCHK
lin carcinogenic_A = mkWA (k38 "karsinogeeninen") ; --UNCHK
lin carcinoid_N = mkWN "karsinoidi" ; --UNCHK
lin carcinoma_N = mkWN (k10A "syöpä") ; --UNCHK
lin carcinomatous_A = mkWA "karsinooma-" ; --UNCHK
lin carcinosarcoma_N = mkWN (compoundN "karsino" (k10 "sarkooma")) ; --UNCHK
lin card_1_N = mkWN (k5A "kortti") ;
lin card_2_N = mkWN (k5A "kortti") ;
lin card_V2 = mkWV2 (k53 "tarkistaa") "henkilöllisyys" ; --UNCHK
lin card_sharper_N = mkWN (k6 "huijari") ; --UNCHK
lin cardamom_N = mkWN (k10 "kardemumma") ; --UNCHK
lin cardboard_A = mkWA (k34A "hengetön") ; --UNCHK
lin cardboard_N = mkWN (k5A "kartonki") ; --UNCHK
lin cardcase_N = mkWN (compoundN "kortti" (k12 "rasia")) ; --UNCHK
lin cardenden_PN = foreignPN "Cardenden" ;
lin cardholder_N = mkWN (compoundN "kortin" (k12 "haltija")) ; --UNCHK
lin cardia_N = mkWN (compoundN "mahan" (k18 "suu")) ; --UNCHK
lin cardiac_A = mkWA (compoundA "kardia" (k38 "alinen")) ; --UNCHK
lin cardiff_PN = foreignPN "Cardiff" ;
lin cardigan_PN = foreignPN "Cardigan" ;
lin cardinal_A = mkWA "kardinaali-" ; --UNCHK
lin cardinal_N = mkWN (compoundN "puna" (k5 "kardinaali")) ; --UNCHK
lin cardinalfish_N = mkWN (compoundN "kardinaali" (k9 "kala")) ; --UNCHK
lin cardinality_N = mkWN (k40 "mahtavuus") ; --UNCHK
lin cardinalship_N = mkWN (k9A "virka") "kardinaalin" ; --UNCHK
lin cardiograph_N = mkWN "kardiografi" ; --UNCHK
lin cardiographic_A = mkWA "kardiografinen" ; --UNCHK
lin cardiography_N = mkWN (compoundN "sydänsähkö" (k10 "käyrä")) ; --UNCHK
lin cardioid_N = mkWN "kardioidi" ; --UNCHK
lin cardiologic_A = mkWA (k38 "kardiologinen") ; --UNCHK
lin cardiologistFem_N = variants {} ; ---- sense to be split
lin cardiologistMasc_N = mkWN (k5 "kardiologi") ; --UNCHK
lin cardiology_N = mkWN (k12 "kardiologia") ; --UNCHK
lin cardiomegaly_N = mkWN (compoundN "suurisydäm" (k40 "isyys")) ; --UNCHK
lin cardiomyopathy_N = mkWN (compoundN "sydänlihas" (k40 "sairaus")) ; --UNCHK
lin cardiopulmonary_A = mkWA "kardiopulmonaarinen" ; --UNCHK
lin cardiospasm_N = mkWN (compoundN "kardio" (k5 "spasmi")) ; --UNCHK
lin cardiovascular_A = mkWA (compoundA "kardio" (k38 "vaskulaarinen")) ; --UNCHK
lin carditis_N = mkWN (compoundN "sydän" (k39 "tulehdus")) ; --UNCHK
lin cardoon_N = mkWN (k6 "kardoni") ; --UNCHK
lin cardroom_N = mkWN (compoundN "peli" (k48 "huone")) ; --UNCHK
lin cardsharp_N = mkWN (k6 "huijari") ; --UNCHK
lin care_N = mkN "hoito" ;
lin care_V = mkV "välittää" ;
lin care_for_V2 = mkWV2 (k53A "hoitaa") ; --UNCHK
lin careen_V = mkWV (k52 "heilua") ; --UNCHK
lin careen_V2 = mkWV2 (k52 "heilua") ; --UNCHK
lin career_N = mkWN (k10 "ura") ;
lin career_V = mkWV (k53A "viilettää") ; --UNCHK
lin careerism_N = mkWN (compoundN "karrier" (k5 "ismi")) ; --UNCHK
lin careerist_N = mkWN (k5 "karrieristi") ; --UNCHK
lin carefree_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin carefreeness_N = mkWN (k40 "huolettomuus") ; --UNCHK
lin careful_A = mkWA (k38 "varovainen") ;
lin carefulness_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin caregiver_N = mkWN (k10 "huoltaja") ; --UNCHK
lin careless_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin carelessness_N = mkWN (k40 "huolimattomuus") ; --UNCHK
lin carer_N = variants {} ; --
lin caress_N = mkWN (k2 "hyväily") ; --UNCHK
lin caress_V2 = mkWV2 (k67A "kosketella") ; --UNCHK
lin caressing_N = mkWN (k5 "petting") ; --UNCHK
lin caret_N = mkWN (k39 "huomautus") ; --UNCHK
lin caretaker_N = mkWN (k10 "hoitaja") ; --UNCHK
lin careworn_A = mkWA (k38 "näköinen") "sairaalloisen" ; --UNCHK
lin carful_N = mkWN (compoundN "auto" (k38 "llinen")) ; --UNCHK
lin cargo_N = mkWN (k39 "lähetys") ; --UNCHK
lin carhop_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin caribou_N = mkWN (kH1 "poro") ; --UNCHK
lin caricature_N = mkWN (k3 "imitaatio") ; --UNCHK
lin caricature_V2 = mkWV2 (k62 "apinoida") ; --UNCHK
lin caricaturist_N = mkWN (compoundN "pila" (k10 "piirtäjä")) ; --UNCHK
lin caries_N = mkWN (k39 "karies") ; --UNCHK
lin carillon_N = mkWN (k1A "soitto") "kellosoittimen" ; --UNCHK
lin carillonneur_N = mkWN (compoundN "kellopelin" (k10 "soittaja")) ; --UNCHK
lin carina_N = mkWN (k1 "harju") ; --UNCHK
lin carinal_A = mkWA (compoundA "harju" (k38 "mainen")) ; --UNCHK
lin carinate_N = mkWN (k1A "lintu") "lentokykyinen" ; --UNCHK
lin carioca_N = mkWN "carioca" ; --UNCHK
lin carious_A = mkWA (k38 "reikäinen") ; --UNCHK
lin carissa_N = mkWN (compoundN "kapmaan" (k1 "luumu")) ; --UNCHK
lin carjacking_N = mkWN "auton" "ryöstäminen" ; --UNCHK
lin carlisle_PN = foreignPN "Carlisle" ;
lin carload_N = mkWN (compoundN "auto" (k38 "lastillinen")) ; --UNCHK
lin carlow_PN = foreignPN "Carlow" ;
lin carluke_PN = foreignPN "Carluke" ;
lin carmarthen_PN = foreignPN "Carmarthen" ;
lin carmelite_A = mkWA "karmeliitta-" ; --UNCHK
lin carmelite_N = mkWN (k5A "munkki") "valkoinen" ; --UNCHK
lin carminative_A = mkWA "ilmavaivoja" "lievittävä" ; --UNCHK
lin carminative_N = mkWN "karminatiivi" ; --UNCHK
lin carmine_A = mkWA (k10 "punertava") ; --UNCHK
lin carmine_N = mkWN (k6 "karmiini") ; --UNCHK
lin carnage_N = mkWN (k39 "teurastus") ; --UNCHK
lin carnal_A = mkWA (k38 "lihallinen") ; --UNCHK
lin carnallite_N = mkWN "karnalliitti" ; --UNCHK
lin carnassial_A = mkWA "raatelu-" ; --UNCHK
lin carnation_A = mkWA (compoundA "heleän" (k38 "punainen")) ; --UNCHK
lin carnation_N = mkWN (compoundN "heleän" (k38 "punainen")) ; --UNCHK
lin carnauba_N = mkWN (compoundN "karnauba-" (k1 "palmu")) ; --UNCHK
lin carnelian_N = mkWN (k5 "karneoli") ; --UNCHK
lin carnforth_PN = foreignPN "Carnforth" ;
lin carnival_N = mkWN (k5 "karnevaali") ; --UNCHK
lin carnivore_N = mkWN (compoundN "lihan" (k10 "syöjä")) ; --UNCHK
lin carnivorous_A = mkWA "lihaa" "syövä" ; --UNCHK
lin carnosaur_N = mkWN "karnosauri" ; --UNCHK
lin carnotite_N = mkWN "karnotiitti" ; --UNCHK
lin carnoustie_PN = foreignPN "Carnoustie" ;
lin carob_N = mkWN (compoundN "johanneksenleipä" (k18 "puu")) ; --UNCHK
lin carol_N = mkWN (compoundN "joulu" (k1 "laulu")) ; --UNCHK
lin carol_V2 = mkWV2 (k56 "laulaa") ; --UNCHK
lin caroler_N = mkWN (k10 "laulaja") ; --UNCHK
lin carolina_PN = foreignPN "Carolina" ;
lin caroling_N = mkWN "laulaminen" ; --UNCHK
lin caroller_N = mkWN (k10 "laulaja") ; --UNCHK
lin carom_N = mkWN (k9 "kara") ; --UNCHK
lin carotene_N = mkWN (k5 "karoteeni") ; --UNCHK
lin carotenemia_N = mkWN "karotinemia" ; --UNCHK
lin carotenoid_N = mkWN "karotenoidi" ; --UNCHK
lin carotid_A = mkWA "kaulavaltimo-" ; --UNCHK
lin carouse_V2 = mkWV2 (k73A "ryypätä") ; --UNCHK
lin carousel_N = mkWN (k5 "karuselli") ; --UNCHK
lin carp_N = mkWN (k5A "karppi") ; --UNCHK
lin carp_V = mkWV (k67A "juonitella") ; --UNCHK
lin carp_V2 = mkWV2 (k67A "juonitella") ; --UNCHK
lin carpal_A = mkWA "ranne-" ; --UNCHK
lin carpal_N = mkWN (compoundN "ranne" (k18 "luu")) ; --UNCHK
lin carpel_N = mkWN (compoundN "emi" (k7A "lehti")) ; --UNCHK
lin carpellary_A = mkWA "emi-" ; --UNCHK
lin carpellate_A = mkWA "emi-" ; --UNCHK
lin carpenter_N = mkWN (k6 "timpuri") ; --UNCHK
lin carpenteria_N = mkWN "Carpenteria" "californica" ; --UNCHK
lin carpentry_N = mkWN (compoundN "puun" (k1 "työstö")) ; --UNCHK
lin carper_N = mkWN (k10 "niuhottaja") ; --UNCHK
lin carpet_N = L.carpet_N ;
lin carpet_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin carpet_beater_N = mkWN (compoundN "matto" (k9 "piiska")) ; --UNCHK
lin carpet_knight_N = mkWN (k6 "ritari") ; --UNCHK
lin carpet_sweeper_N = mkWN (k12 "lakaisija") ; --UNCHK
lin carpetbag_A = mkWA "keinotteleva" ; --UNCHK
lin carpetbag_N = mkWN (compoundN "matto" (k1A "laukku")) ; --UNCHK
lin carpetbagger_N = mkWN (compoundN "onnen" (k12 "onkija")) ; --UNCHK
lin carpetweed_N = mkWN (compoundN "verticil" (k9A "lata")) "Molluga" ; --UNCHK
lin carpophagous_A = mkWA (compoundA "hedelmän" (k10 "syöjä")) ; --UNCHK
lin carpophore_N = mkWN (compoundN "karpof" (k48 "ori")) ; --UNCHK
lin carport_N = mkWN (compoundN "auto" (k39 "katos")) ; --UNCHK
lin carpospore_N = mkWN (k3 "itiö") ; --UNCHK
lin carposporic_A = mkWA "karpospori-" ; --UNCHK
lin carposporous_A = mkWA "karpospori-" ; --UNCHK
lin carrack_N = mkWN "karakki" ; --UNCHK
lin carrageenin_N = mkWN (compoundN "karra" (k5 "geeni")) ; --UNCHK
lin carrel_N = mkWN (compoundN "luku" (k39 "syvennys")) ; --UNCHK
lin carriage_N = variants {} ; --
lin carriageway_N = mkWN (compoundN "ajo" (k9A "rata")) ; --UNCHK
lin carrier_N = mkWN (k10 "kantaja") ; --f135
lin carrier_bag_N = mkWN (k5 "pussi") ; --UNCHK
lin carrier_pigeon_N = mkWN (compoundN "kirje" (k1 "kyyhky")) ; --UNCHK
lin carrion_N = mkWN (k1A "raato") ; --UNCHK
lin carrion_crow_N = mkWN (compoundN "musta" (k6 "kondori")) ; --UNCHK
lin carrot_N = mkWN (k12 "porkkana") ; --UNCHK
lin carroty_A = mkWA (compoundA "puna" (k38 "päinen")) ; --UNCHK
lin carry_N = mkN "ote" | mkN "muistibitti" ; ---- split
lin carry_V = mkV "kantaa" ;
lin carry_V2 = mkV2 (mkV "kantaa") partitive ;
lin carry_forward_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin carry_off_V2 = mkWV2 (k64 "viedä") "hautaan" ; --UNCHK
lin carry_on_V = mkWV (k56 "jatkaa") ; --UNCHK
lin carry_on_V2 = mkWV2 (k56 "jatkaa") ; --UNCHK
lin carry_on_about_V2 = prepV2 (advV OP_carry_V OP_on_Adv ) OP_about_Prep ; -- guess-p-verb
lin carry_on_with_V2 = prepV2 (advV OP_carry_V OP_on_Adv ) OP_with_Prep ; -- guess-p-verb
lin carry_out_V = mkWV (k65 "käydä") "läpi" ; --UNCHK
lin carry_out_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin carry_over_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin carry_through_V2 = mkWV2 (k56A "saattaa") "voimaan" ; --UNCHK
lin carryall_N = mkWN (k5 "kori") ; --UNCHK
lin carrycot_N = mkWN (compoundN "kanto" (k5 "kassi")) ; --UNCHK
lin carsick_A = mkWA (compoundA "meri" (k41 "sairas")) ; --UNCHK
lin cart_N = mkWN (k1 "vaunu") ; --UNCHK
lin cart_V2 = mkWV2 (k73 "kärrätä") ; --UNCHK
lin cart_off_V2 = mkWV2 (k64 "viedä") "pois" ; --UNCHK
lin cart_track_N = mkWN (k1A "polku") ; --UNCHK
lin cartage_N = mkWN "kärrääminen" ; --UNCHK
lin cartagena_PN = foreignPN "Cartagena" ;
lin carte_blanche_N = mkWN (compoundN "valta" (k9 "kirja")) "avoin" ; --UNCHK
lin cartel_N = mkWN (k5 "kartelli") ; --UNCHK
lin carter_N = mkWN (k10 "kärrääjä") ; --UNCHK
lin carthorse_N = mkWN (compoundN "työ" (k38 "hevonen")) ; --UNCHK
lin cartilage_N = mkWN (k1 "rusto") ; --UNCHK
lin cartilaginification_N = mkWN (compoundN "rusto" (k38 "utuminen")) ; --UNCHK
lin cartilaginous_A = mkWA "rusto-" ; --UNCHK
lin cartload_N = mkWN (compoundN "kärry" (k38 "llinen")) ; --UNCHK
lin cartographer_N = mkWN (compoundN "kartan" (k10 "valmistaja")) ; --UNCHK
lin cartographic_A = mkWA (k38 "kartografinen") ; --UNCHK
lin cartography_N = mkWN (k12 "kartografia") ; --UNCHK
lin carton_N = mkWN (k4A "laatikko") ; --UNCHK
lin cartoon_N = mkN "piirros" (mkN "elokuva") ;
lin cartoon_V2 = mkWV2 (k54A "piirtää") ; --UNCHK
lin cartoonistFem_N = mkWN (compoundN "pila" (k10 "piirtäjä")) ; --UNCHK
lin cartoonistMasc_N = mkWN (compoundN "pila" (k10 "piirtäjä")) ; --UNCHK
lin cartouche_N = mkWN (compoundN "kar" (k5 "tussi")) ; --UNCHK
lin cartridge_N = mkWN (kH1 "patruuna") ; --UNCHK
lin cartridge_belt_N = mkWN (compoundN "patruuna" (k19 "vyö")) ; --UNCHK
lin cartridge_paper_N = mkWN (compoundN "kartuusi" (k6 "paperi")) ; --UNCHK
lin cartroad_N = mkWN (k1A "polku") ; --UNCHK
lin cartwheel_N = mkWN (compoundN "kärryn" (k10 "pyörä")) ; --UNCHK
lin cartwright_N = mkWN (compoundN "kärryn" (k12 "tekijä")) ; --UNCHK
lin caruncle_N = mkWN (k9A "heltta") ; --UNCHK
lin caruncular_A = mkWA (compoundA "heltta" (k38 "mainen")) ; --UNCHK
lin carunculate_A = mkWA "heltallinen" ; --UNCHK
lin carve_V = mkV "kaivertaa" ;
lin carve_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin carve_out_V2 = mkWV2 (k53A "ottaa") "haltuun" ; --UNCHK
lin carve_up_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin carvedilol_N = mkWN "karvediloli" ; --UNCHK
lin carver_N = mkWN (k10 "leikkaaja") "paistin" ; --UNCHK
lin carving_N = mkWN (compoundN "kuvanveisto" (k48A "taide")) ; --UNCHK
lin carving_fork_N = mkWN (compoundN "paisti" (k14A "haarukka")) ; --UNCHK
lin carving_knife_N = mkWN (compoundN "paisti" (k30 "veitsi")) ; --UNCHK
lin caryatid_N = mkWN "karyatidi" ; --UNCHK
lin caryophyllaceous_A = mkWA "kohokki-" ; --UNCHK
lin casaba_N = mkWN (compoundN "casaba" (k6 "meloni")) ; --UNCHK
lin casablanca_PN = foreignPN "Casablanca" ;
lin cascade_N = mkWN (k7 "pilvi") ; --UNCHK
lin cascade_V = mkWV (k53A "limittää") ; --UNCHK
lin cascara_N = mkWN (compoundN "rohto" (k11 "paatsama")) ; --UNCHK
lin cascarilla_N = mkWN "Croton" "eluteria" ; --UNCHK
lin case_N = mkN "tapaus" ;
lin case_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin case_history_N = mkWN (compoundN "tapaus" (k39 "kertomus")) ; --UNCHK
lin case_law_N = mkWN (k5A "prejudikaatti") ; --UNCHK
lin casebook_A = mkWA (compoundA "oppikirja" (k38 "mainen")) ; --UNCHK
lin casebook_N = mkWN (compoundN "työpäivä" (k9 "kirja")) ; --UNCHK
lin casein_N = mkWN (k5 "kaseiini") ; --UNCHK
lin casement_N = mkWN (k12 "ikkuna") ; --UNCHK
lin caseous_A = mkWA "kaseaatio-" ; --UNCHK
lin casern_N = mkWN (k5 "kasarmi") ; --UNCHK
lin casework_N = mkWN (compoundN "sosiaali" (k19 "työ")) ; --UNCHK
lin caseworm_N = mkWN (compoundN "kotelo" (k10A "toukka")) ; --UNCHK
lin cash_N = mkN "käteinen" ;
lin cash_V = mkWV (k53A "muuttaa") "rahaksi" ; --UNCHK
lin cash_V2 = mkWV2 (k53A "muuttaa") "rahaksi" ; --UNCHK
lin cash_in_V2 = mkWV2 (k53A "muuttaa") "rahaksi" ; --UNCHK
lin cash_in_on_V2 = mkWV2 (k53A "käyttää") "hyväkseen" ; --UNCHK
lin cash_out_V2 = mkWV2 (k56A "vaihtaa") "vapaalle" ; --UNCHK
lin cashable_A = mkWA (k10 "vaihdettava") "rahaksi" ; --UNCHK
lin cashbox_N = mkWN (k9 "kassa") ; --UNCHK
lin cashew_N = mkWN (compoundN "cashew" (k12 "pähkinä")) ; --UNCHK
lin cashier_N = mkWN (k9 "kassa") ; --UNCHK
lin cashier_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin cashmere_N = mkWN (k5 "kašmir") ; --UNCHK
lin casing_N = mkWN (k39 "kehys") ; --UNCHK
lin casino_N = mkWN (k2 "kasino") ;
lin cask_N = mkWN (k1A "pönttö") ; --UNCHK
lin casket_N = mkWN (k41A "lipas") ; --UNCHK
lin caspase_N = mkWN (compoundN "kas" (k27 "paasi")) ; --UNCHK
lin casque_N = mkWN (k7 "kaski") ; --UNCHK
lin casquet_N = mkWN (compoundN "suoja" (k10 "kypärä")) ; --UNCHK
lin cassareep_N = mkWN (compoundN "maniokki" (k48A "kastike")) ; --UNCHK
lin cassava_N = mkWN "maniokki" ; --UNCHK
lin casserole_N = mkWN (k10A "vuoka") ; --UNCHK
lin cassette_N = mkWN (k5A "kasetti") ; --UNCHK
lin cassia_N = mkWN (compoundN "kiinan" (k6 "kaneli")) ; --UNCHK
lin cassiri_N = mkWN "cassiri" ; --UNCHK
lin cassiterite_N = mkWN (compoundN "kassite" (k5A "riitti")) ; --UNCHK
lin cassock_N = mkWN (k14A "kasukka") ; --UNCHK
lin cassocked_A = mkWA "kasukkaan" "pukeutunut" ; --UNCHK
lin cassowary_N = mkWN (k5 "kasuaari") ; --UNCHK
lin cast_N = mkWN (k1A "heitto") ; --UNCHK
lin cast_V = mkV (mkV "saada") "rooli" ; ---ARB --mkV (mkV "antaa") "ääni") ; --mkWV (k53A "heittää") "laattaa" ;
lin cast_V2 = mkV2 "heittää" ;
lin cast_about_for_V2 = prepV2 (advV OP_cast_V OP_about_Adv ) OP_for_Prep ; -- guess-p-verb
lin cast_around_V = mkWV (k61 "etsiä") ; --UNCHK
lin cast_around_for_V2 = prepV2 (advV OP_cast_V OP_around_Adv ) OP_for_Prep ; -- guess-p-verb
lin cast_aside_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin cast_iron_A = mkA (mkN "valu" (mkN "rautainen")) ;
lin cast_off_V = mkWV (k52A "hankkiutua") "eroon" ; --UNCHK
lin cast_off_V2 = mkWV2 (k52A "hankkiutua") "eroon" ; --UNCHK
lin cast_out_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin cast_round_for_V2 = prepV2 (advV OP_cast_V OP_round_Adv ) OP_for_Prep ; -- guess-p-verb
lin cast_up_V2 = prepV2 OP_cast_V OP_up_Prep ; -- guess-p-verb
lin castaway_N = mkWN (k38 "haaksirikkoinen") ; --UNCHK
lin caste_N = mkWN (kH1 "kasti") ; --UNCHK
lin castellated_A = mkWA (k38 "sakarainen") ; --UNCHK
lin caster_N = mkWN (k10 "pyörä") ; --UNCHK
lin castigate_V2 = mkWV2 (k53A "kurittaa") ; --UNCHK
lin castigation_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin casting_N = mkWN "roolitus" ;
lin castle_N = mkWN (k39 "linnoitus") ; --UNCHK
lin castle_V = mkWV (k53A "tornittaa") ; --UNCHK
lin castleford_PN = foreignPN "Castleford" ;
lin castor_N = mkWN (compoundN "Castor-" (k1A "suku")) ; --UNCHK
lin castor_oil_N = mkWN (compoundN "risiini" (k1 "öljy")) ; --UNCHK
lin castrate_V2 = mkWV2 (k62 "steriloida") ; --UNCHK
lin castration_N = mkWN (compoundN "siivo" (k38 "aminen")) ; --UNCHK
lin castrato_N = mkWN (k5A "kastraatti") ; --UNCHK
lin casual_A = mkA "epäformaali" ;
lin casualness_N = mkWN (k40 "tuttuus") ; --UNCHK
lin casualty_N = mkWN (k3 "tappio") ; --UNCHK
lin casuarina_N = mkWN "kasuariina" ; --UNCHK
lin casuist_N = mkWN (k5 "sofisti") ; --UNCHK
lin casuistic_A = mkWA (k38 "kasuistinen") ; --UNCHK
lin casuistical_A = mkWA (k38 "kasuistinen") ; --UNCHK
lin casuistry_N = mkWN (k9A "kasuistiikka") ; --UNCHK
lin casus_belli_N = mkWN (k39 "oikeutus") "sodan" ; --UNCHK
lin cat_N = L.cat_N ;
lin catabiosis_N = mkWN "solujen" "surkastuminen" ; --UNCHK
lin catabolism_N = mkWN (compoundN "aineen" (k9A "vaihdunta")) "hajottava" ; --UNCHK
lin catachresis_N = mkWN "katakreesi" ; --UNCHK
lin catachrestic_A = mkWA "katakreesi-" ; --UNCHK
lin cataclinal_A = mkWA (compoundA "myötäi" (k10 "levä")) "maastoa" ; --UNCHK
lin cataclysm_N = mkWN (k12 "tragedia") ; --UNCHK
lin cataclysmal_A = mkWA (k38 "turmiollinen") ; --UNCHK
lin cataclysmic_A = mkWA (k38 "turmiollinen") ; --UNCHK
lin catacomb_N = mkWN (k5 "katakombi") ; --UNCHK
lin catacorner_A = mkWA (k99 "viistosti") ; --UNCHK
lin catadromous_A = mkWA "katadrominen" ; --UNCHK
lin catafalque_N = mkWN (k5A "katafalkki") ; --UNCHK
lin catalanFem_N = mkWN (k5 "katalaani") ; --UNCHK
lin catalanMasc_N = mkWN (k5 "katalaani") ; --UNCHK
lin catalan_A = mkA "katalonialainen" ;
lin catalase_N = mkWN (compoundN "katal" (k5 "aasi")) ; --UNCHK
lin catalatic_A = mkWA "katalaasi-" ; --UNCHK
lin catalectic_A = mkWA "katalektinen" ; --UNCHK
lin catalectic_N = mkWN (k48A "säe") "katalektinen" ; --UNCHK
lin catalepsy_N = mkWN "katalepsia" ; --UNCHK
lin cataleptic_A = mkWA "kataleptinen" ; --UNCHK
lin cataleptic_N = mkWN (k2 "henkilö") "kataleptinen" ; --UNCHK
lin catalexis_N = mkWN "kataleksi" ; --UNCHK
lin catalog_N = mkWN (k2 "luettelo") ; --UNCHK
lin catalog_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin cataloger_N = mkWN "luetteloija" ; --UNCHK
lin catalogue_N = mkWN (k2 "luettelo") ; --UNCHK
lin catalogue_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin catalpa_N = mkWN (compoundN "trumpetti" (k18 "puu")) ; --UNCHK
lin catalufa_N = mkWN (compoundN "suuri" (k10 "silmä")) ; --UNCHK
lin catalysis_N = mkWN (k5 "katalyysi") ; --UNCHK
lin catalyst_N = mkWN (k10 "käynnistäjä") ; --UNCHK
lin catalytic_A = mkWA (k38 "katalyyttinen") ; --UNCHK
lin catamaran_N = mkWN (k5 "katamaraani") ; --UNCHK
lin catamite_N = mkWN "katamiitti" ; --UNCHK
lin catananche_N = mkWN "katana" ; --UNCHK
lin catania_PN = foreignPN "Catania" ;
lin cataphasia_N = mkWN (compoundN "sanan" (k1 "toisto")) ; --UNCHK
lin cataphatic_A = mkWA (compoundA "kat" (k38 "afaattinen")) ; --UNCHK
lin cataphyll_N = mkWN (compoundN "sirkka" (k7A "lehti")) ; --UNCHK
lin cataplasia_N = mkWN (compoundN "rap" (k38 "peutuminen")) ; --UNCHK
lin cataplastic_A = mkWA "rappeutuva" ; --UNCHK
lin catapult_N = mkWN (k1A "linko") ; --UNCHK
lin catapult_V2 = mkWV2 (k53A "sinkauttaa") ; --UNCHK
lin catapultic_A = mkWA (compoundA "katapultti" (k38 "mainen")) ; --UNCHK
lin cataract_N = mkWN (compoundN "vesi" (k39 "putous")) ; --UNCHK
lin catarrh_N = mkWN (k5 "katarri") ; --UNCHK
lin catarrhal_A = mkWA "katarri-" ; --UNCHK
lin catarrhine_A = mkWA (compoundA "itäapina" (k38 "mainen")) ; --UNCHK
lin catastrophe_N = mkWN (k12 "tragedia") ; --UNCHK
lin catastrophic_A = mkA "katastrofaalinen" ;
lin catatonia_N = mkWN (k12 "skitsofrenia") "katatoninen" ; --UNCHK
lin catatonic_A = mkWA "katatoninen" ; --UNCHK
lin catbird_N = mkWN (compoundN "kissa" (k41 "rastas")) ; --UNCHK
lin catboat_N = mkWN (k5A "katti") ; --UNCHK
lin catcall_N = mkWN (k39 "vihellys") ; --UNCHK
lin catcall_V = mkWV (k54A "viheltää") ; --UNCHK
lin catch_N = mkWN (k99 "kiinni") "saada" ; --UNCHK
lin catch_V2 = mkV2 (mkV (mkV "saada") "kiinni") | mkV2 (mkV (mkV "ottaa") "kiinni") ;
lin catch_at_V2 = prepV2 (lin V OP_catch_V2) OP_at_Prep ; -- guess-p-verb
lin catch_crop_N = mkWN (compoundN "väli" (k1A "sato")) ; --UNCHK
lin catch_on_V = mkWV (k52 "menestyä") ; --UNCHK
lin catch_out_V2 = prepV2 (lin V OP_catch_V2) OP_out_Prep ; -- guess-p-verb
lin catch_up_V = mkWV (k53A "saavuttaa") ; --UNCHK
lin catch_up_V2 = mkWV2 (k53A "saavuttaa") ; --UNCHK
lin catch_up_in_V2 = prepV2 (advV (lin V OP_catch_V2) OP_up_Adv ) OP_in_Prep ; -- guess-p-verb
lin catch_up_on_V2 = prepV2 (advV (lin V OP_catch_V2) OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin catch_up_with_V2 = mkWV2 (k53A "tavoittaa") ; --UNCHK
lin catchall_N = mkWN (compoundN "säilytys" (k12 "astia")) ; --UNCHK
lin catcher_N = mkWN (k10 "sieppaaja") ; --UNCHK
lin catching_N = mkWN (k38 "saaminen") "sairauden" ; --UNCHK
lin catchment_N = mkWN (compoundN "valuma-" (k48 "alue")) ; --UNCHK
lin catchment_area_N = mkWN (k41A "allas") ; --UNCHK
lin catchment_basin_N = mkWN (k41A "allas") ; --UNCHK
lin catchpenny_A = mkWA (compoundA "halpa" (k48A "tuote")) ; --UNCHK
lin catchphrase_N = mkWN (compoundN "isku" (k48 "lause")) ; --UNCHK
lin catchword_N = mkWN (compoundN "opas" (k9 "sana")) ; --UNCHK
lin catchy_A = mkWA "tarttuva" ; --UNCHK
lin catechesis_N = mkWN "katekeesi" ; --UNCHK
lin catechetical_A = mkWA (compoundA "katek" (k38 "eettinen")) ; --UNCHK
lin catechin_N = mkWN "katekiini" ; --UNCHK
lin catechism_N = mkWN (k39 "katekismus") ; --UNCHK
lin catechismal_A = mkWA "katekismus-" ; --UNCHK
lin catechist_N = mkWN (k9A "katekeetta") ; --UNCHK
lin catechistic_A = mkWA (compoundA "katek" (k38 "eettinen")) ; --UNCHK
lin catechize_V2 = mkWV2 (k67 "kuulustella") ; --UNCHK
lin catecholamine_N = mkWN "katekoliamiini" ; --UNCHK
lin catechu_N = mkWN "Acacia" "catechu" ; --UNCHK
lin catechumen_N = mkWN (k38 "käännynnäinen") "uusi" ; --UNCHK
lin categorem_N = mkWN (compoundN "kategore" (k5 "emi")) ; --UNCHK
lin categorematic_A = mkWA (compoundA "kate" (k38 "goremaattinen")) ; --UNCHK
lin categorial_A = mkWA (k38 "kategorinen") ; --UNCHK
lin categoric_A = mkWA (k38 "kategorinen") ; --UNCHK
lin categorical_A = mkWA (k38 "kategorinen") ; --UNCHK
lin categorization_N = mkWN (k2 "lajittelu") ; --UNCHK
lin categorize_V2 = mkWV2 (k62 "lokeroida") ; --UNCHK
lin category_N = mkN "kategoria" ; --f53
lin catena_N = mkWN "kateeni" ; --UNCHK
lin catenary_N = mkWN (compoundN "ketju" (k10 "käyrä")) ; --UNCHK
lin catenulate_A = mkWA (compoundA "ketju" (k38 "mainen")) ; --UNCHK
lin cater_V = mkWV (k53A "toimittaa") "ruokaa" ; --UNCHK
lin caterer_N = mkWN (compoundN "pito" (k2 "palvelu")) ; --UNCHK
lin catering_N = mkWN (compoundN "pito" (k2 "palvelu")) ; --UNCHK
lin caterpillar_N = mkWN (k10A "toukka") ; --UNCHK
lin caterwaul_N = mkWN "mouku" ; --UNCHK
lin caterwaul_V = mkWV (k52A "monkua") ; --UNCHK
lin catfish_N = mkWN (compoundN "monni" (k9 "kala")) ; --UNCHK
lin catgut_N = mkWN (k5A "katgutti") ; --UNCHK
lin catharsis_N = mkWN (k39 "katarsis") ; --UNCHK
lin cathartic_A = mkWA (k10 "aikaansaava") "ulostuksen" ; --UNCHK
lin cathartic_N = mkWN (k5 "laksatiivi") ; --UNCHK
lin cathectic_A = mkWA (compoundA "kate" (k38 "ktinen")) ; --UNCHK
lin cathedra_N = mkWN (k33 "istuin") "piispan" ; --UNCHK
lin cathedral_A = mkWA "katedraali-" ; --UNCHK
lin cathedral_N = mkWN (k5 "katedraali") ; --UNCHK
lin catheter_N = mkWN (k5 "katetri") ; --UNCHK
lin catheterization_N = mkWN (k5A "katetrointi") ; --UNCHK
lin cathexis_N = mkWN (compoundN "viettienergia" (k39 "varaus")) ; --UNCHK
lin cathode_N = mkWN (k5 "katodi") ; --UNCHK
lin cathodic_A = mkWA (compoundA "kato" (k38 "dinen")) ; --UNCHK
lin catholicFem_N = mkWN (k38 "katolilainen") ; --UNCHK
lin catholicMasc_N = mkWN (k38 "katolilainen") ; --UNCHK
lin catholic_A = mkWA (k38 "katolilainen") ; --UNCHK
lin catholicism_N = mkWN (k40 "katolisuus") ; --UNCHK
lin catholicity_N = mkWN (compoundN "yleis" (k40 "maailmallisuus")) ; --UNCHK
lin cation_N = mkWN (k5 "kationi") ; --UNCHK
lin cationic_A = mkWA (compoundA "kationi" (k38 "nen")) ; --UNCHK
lin catkin_N = mkWN (k1A "norkko") ; --UNCHK
lin catkinate_A = mkWA (compoundA "urpu" (k38 "mainen")) ; --UNCHK
lin catling_N = mkWN (compoundN "leikkaus" (k30 "veitsi")) ; --UNCHK
lin catmint_N = mkWN "aitokissanminttu" ; --UNCHK
lin catoptric_A = mkWA "peilioptiikka-" ; --UNCHK
lin catoptrics_N = mkWN (compoundN "peili" (k14A "optiikka")) ; --UNCHK
lin catostomid_N = mkWN (compoundN "imu" (k5A "karppi")) ; --UNCHK
lin catsup_N = mkWN (k5A "ketsuppi") ; --UNCHK
lin cattail_N = mkWN (compoundN "osman" (k5 "käämi")) ; --UNCHK
lin cattalo_N = mkWN "beefalo" ; --UNCHK
lin cattiness_N = mkWN (k9 "kauna") ; --UNCHK
lin cattish_A = mkWA (k15 "ilkeä") ; --UNCHK
lin cattle_N = mkWN (k9A "nauta") ; --UNCHK
lin cattle_cake_N = mkWN (compoundN "väki" (k1 "rehu")) ; --UNCHK
lin cattleman_N = mkWN (compoundN "karjan" (k10 "kasvattaja")) ; --UNCHK
lin cattleship_N = mkWN (compoundN "karja" (k9 "laiva")) ; --UNCHK
lin catty_A = mkWA (k15 "ilkeä") ; --UNCHK
lin catty_N = mkWN (k9 "pauna") ; --UNCHK
lin catwalk_N = mkWN (k9A "silta") ; --UNCHK
lin caucasianFem_N = mkN "kaukasialainen" ;
lin caucasianMasc_N = mkN "kaukasialainen" ;
lin caucasian_A = mkWA (k38 "kaukasialainen") ; --UNCHK
lin caucus_N = mkWN (compoundN "puolue" (k39 "kokous")) ; --UNCHK
lin cauda_N = mkWN (k10A "häntä") ; --UNCHK
lin caudal_A = mkWA (compoundA "kauda" (k38 "alinen")) ; --UNCHK
lin caudate_A = mkWA (compoundA "kauda" (k38 "alinen")) ; --UNCHK
lin caudex_N = mkWN (compoundN "varsi" (k12 "mukula")) ; --UNCHK
lin caul_N = mkWN (compoundN "sikiö" (k1 "kalvo")) ; --UNCHK
lin cauldron_N = mkWN (kH1 "pata") ; --UNCHK
lin caulescent_A = mkWA (k38 "varrellinen") ; --UNCHK
lin cauliflower_N = mkWN (compoundN "kukka" (k5 "kaali")) ; --UNCHK
lin cauline_A = mkWA "varsi-" ; --UNCHK
lin caulk_N = mkWN (k48 "tiiviste") ; --UNCHK
lin caulk_V2 = mkWV2 (k69 "tilkitä") ; --UNCHK
lin causal_A = mkWA (k38 "kausaalinen") ; --UNCHK
lin causalgia_N = mkWN "kausalgia" ; --UNCHK
lin causality_N = mkWN (k5A "kausaliteetti") ; --UNCHK
lin causation_N = mkWN (compoundN "aihe" (k38 "uttaminen")) ; --UNCHK
lin causative_A = mkWA (k38 "kausaalinen") ; --UNCHK
lin cause_N = mkN "syy" ;
lin cause_V2 = mkV2 "aiheuttaa" ;
lin cause_V2V = mkV2V (mkV "saada") accusative infIllat ;
lin causeless_A = mkWA (k10 "yllättävä") ; --UNCHK
lin causerie_N = mkWN (k39 "pälpätys") ; --UNCHK
lin causeway_N = mkWN (compoundN "penger" (k19 "tie")) ; --UNCHK
lin causing_N = mkWN (compoundN "aihe" (k38 "uttaminen")) ; --UNCHK
lin caustic_A = mkWA "erittäin" "syövyttävä" ; --UNCHK
lin caustic_N = mkWN (k39 "emäs") "syövyttävä" ; --UNCHK
lin cautery_N = mkWN "kauterisaatio" ; --UNCHK
lin caution_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin caution_V = mkV "varoittaa" ; --mkWV (k53A "kehottaa") ;
lin caution_V2 = mkWV2 (k53A "kehottaa") ; --UNCHK
lin caution_V2V = mkWV2V (k53A "kehottaa") ; --UNCHK
lin caution_VS = mkWVS (k53A "kehottaa") ; --UNCHK
lin cautionary_A = mkWA "varoitukseksi" "annettu" ; --UNCHK
lin cautious_A = mkA "harkitsevainen" ;
lin cavalcade_N = mkWN (k48 "kulkue") ; --UNCHK
lin cavalier_A = mkA "piittaamaton" ;
lin cavalier_N = mkWN (k5 "rojalisti") ; --UNCHK
lin cavalryman_N = mkWN (compoundN "ratsu" (k41 "sotilas")) ; --UNCHK
lin cavan_PN = foreignPN "Cavan" ;
lin cave_N = mkWN (k2 "luolasto") ; --UNCHK
lin cave_V = mkWV (k61 "tutkia") "luolia" ; --UNCHK
lin cave_V2 = mkWV2 (k61 "tutkia") "luolia" ; --UNCHK
lin cave_dweller_N = mkWN (compoundN "luola" (k38 "ihminen")) ; --UNCHK
lin cave_in_N = mkWN "romahtaminen" ; --UNCHK
lin cave_in_V = mkWV (k52A "murtua") ; --UNCHK
lin caveat_N = mkWN (compoundN "vasta" (k48 "lause")) ; --UNCHK
lin caveman_N = mkWN (compoundN "luola" (k38 "ihminen")) ; --UNCHK
lin cavern_N = mkWN (k2 "onkalo") ; --UNCHK
lin cavernous_A = mkWA (compoundA "erek" (k23 "tiili")) ; --UNCHK
lin cavetto_N = mkWN (k1 "kouru") ; --UNCHK
lin caviar_N = mkWN (k5A "mäti") ; --UNCHK
lin cavil_V = mkWV (k67A "juonitella") ; --UNCHK
lin cavity_N = mkWN (k2 "ontelo") ; --UNCHK
lin cavort_V = mkWV (k68 "karkeloida") ; --UNCHK
lin cavy_N = mkWN (k1 "marsu") ; --UNCHK
lin caw_N = mkWN (compoundN "vaak" (k38 "kuminen")) ; --UNCHK
lin caw_V = mkWV (k52A "vaakkua") ; --UNCHK
lin caw_V2 = mkWV2 (k52A "vaakkua") ; --UNCHK
lin cayenne_N = mkWN (compoundN "cayennen" (k6 "pippuri")) ; --UNCHK
lin cayenne_pepper_N = mkWN (compoundN "cayennen" (k6 "pippuri")) ; --UNCHK
lin cayman_N = mkWN (k5 "kaimaani") ; --UNCHK
lin cayuse_N = mkWN (compoundN "intiaani" (k5 "poni")) ; --UNCHK
lin cc_N = mkWN (compoundN "kuutiosentti" (k5 "metri")) ; --UNCHK
lin cd_N = mkWN (k99 "CD") ; --f65
lin cease_N = mkWN (k1A "tauko") ;
lin cease_V = mkWV (k52A "loppua") ; --UNCHK
lin cease_V2 = mkWV2 (k52A "loppua") ; --UNCHK
lin cease_VS = mkWVS (k52A "loppua") ; --UNCHK
lin cease_fire_N = mkN "tulitauko" ;
lin ceasefire_N = mkN "tulitauko" ;
lin ceaseless_A = mkWA (k38 "alituinen") ; --UNCHK
lin cecal_A = mkWA "umpisuoli-" ; --UNCHK
lin cecilia_PN = foreignPN "Cecilia" ;
lin cecropia_N = mkWN "Hyalophora" "cecropia" ; --UNCHK
lin cecum_N = mkWN (compoundN "umpi" (k26 "suoli")) ; --UNCHK
lin cedar_N = mkWN (k5 "setri") ; --UNCHK
lin cedarn_A = mkWA "seetri-" ; --UNCHK
lin cede_V2 = mkWV2 (k52A "luopua") ; --UNCHK
lin cedi_N = mkWN "cedi" ; --UNCHK
lin cedilla_N = mkWN "sedilji" ; --UNCHK
lin cefadroxil_N = mkWN (k5 "kefadroksiili") ; --UNCHK
lin cefoperazone_N = mkWN "Cefobid" ; --UNCHK
lin cefotaxime_N = mkWN "Claforan" ; --UNCHK
lin ceftazidime_N = mkWN "Tazicef" ; --UNCHK
lin ceftriaxone_N = mkWN "Rocephin" ; --UNCHK
lin cefuroxime_N = mkWN "Zinacef" ; --UNCHK
lin ceibo_N = mkWN (k5 "crista-galli") "Erythrina" ; --UNCHK
lin ceiling_N = L.ceiling_N ;
lin ceilinged_A = mkWA (compoundA "kate" (k1 "ttu")) ; --UNCHK
lin celandine_N = mkWN (k2 "keltamo") ; --UNCHK
lin celebrant_N = mkWN (compoundN "messu" (k5A "pappi")) ; --UNCHK
lin celebrate_V2 = mkV2 "juhlia" partitive ; --WV2 (k53 "ylistää") ;
lin celebrated_A = mkWA (k41A "värikäs") ; --UNCHK
lin celebration_N = mkN "juhlinta" ;
lin celebratory_A = mkWA "juhla-" ; --UNCHK
lin celebrity_N = mkWN (k2 "henkilö") "julkisuuden" ;
lin celecoxib_N = mkWN "Celebrex" ; --UNCHK
lin celeriac_N = mkWN (k6 "selleri") ; --UNCHK
lin celerity_N = mkWN (k40 "ripeys") ; --UNCHK
lin celery_N = mkWN (k6 "selleri") ; --UNCHK
lin celesta_N = mkWN "celesta" ; --UNCHK
lin celestial_A = mkWA (k38 "taivaallinen") ; --UNCHK
lin celestite_N = mkWN "selestiitti" ; --UNCHK
lin celiac_A = mkWA "vatsaontelon" ; --UNCHK
lin celibacy_N = mkWN (k5A "selibaatti") ; --UNCHK
lin celibate_A = mkWA (k38 "pidättyväinen") ; --UNCHK
lin celibate_N = mkWN (k5A "selibaatti") ; --UNCHK
lin celiocentesis_N = mkWN (compoundN "laparosen" (k5 "teesi")) ; --UNCHK
lin celioma_N = mkWN (compoundN "vatsa" (k33 "kasvain")) ; --UNCHK
lin celioscopy_N = mkWN (k12 "laparoskopia") ; --UNCHK
lin cell_N = mkN "solu" ;
lin cellar_N = mkWN (k6 "kellari") ; --UNCHK
lin cellarage_N = mkWN (compoundN "kellari" (k9 "tila")) ; --UNCHK
lin cellblock_N = mkWN (compoundN "vanki" (k2 "osasto")) ; --UNCHK
lin cellistFem_N = mkWN (k5 "sellisti") ; --UNCHK
lin cellistMasc_N = mkWN (k5 "sellisti") ; --UNCHK
lin cello_N = mkWN (k1 "sello") ; --UNCHK
lin cellophane_N = mkWN (k5 "sellofaani") ; --UNCHK
lin cellular_A = mkWA (compoundA "solu" (k38 "mainen")) ;
lin cellularity_N = mkWN "solullisuus" ; --UNCHK
lin cellulite_N = mkWN (k5A "selluliitti") ; --UNCHK
lin cellulitis_N = mkWN (k5A "selluliitti") ; --UNCHK
lin celluloid_A = mkWA (k38 "teennäinen") ; --UNCHK
lin celluloid_N = mkWN (k5 "filmi") ; --UNCHK
lin cellulose_N = mkWN (k10 "selluloosa") ; --UNCHK
lin cellulosic_N = mkWN "selluloosa-" ; --UNCHK
lin cellulosid_A = mkWA "selluloosa-" ; --UNCHK
lin celom_N = mkWN (compoundN "coe" (k10 "loma")) ; --UNCHK
lin celt_N = mkWN (k5A "keltti") ; --UNCHK
lin celtic_A = mkWA (k38 "kelttiläinen") ; --UNCHK
lin celtic_N = mkN "kelttiläinen" ;
lin celtuce_N = mkWN (compoundN "parsa" (k5A "salaatti")) ; --UNCHK
lin cement_N = mkWN (compoundN "juuri" (k5A "sementti")) ; --UNCHK
lin cement_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin cement_mixer_N = mkWN (compoundN "betoni" (k1 "mylly")) ; --UNCHK
lin cementite_N = mkWN (compoundN "rauta" (k5 "karbidi")) ; --UNCHK
lin cementitious_A = mkWA (compoundA "sementti" (k38 "mäinen")) ; --UNCHK
lin cementum_N = mkWN (compoundN "juuri" (k5A "sementti")) ; --UNCHK
lin cemetery_N = mkWN (k2 "kalmisto") ; --UNCHK
lin cenobite_N = mkWN (compoundN "keno" (k5A "biitti")) ; --UNCHK
lin cenobitic_A = mkWA (compoundA "ken" (k38 "obioottinen")) ; --UNCHK
lin cenogenesis_N = mkWN "kenogeneesi" ; --UNCHK
lin cenogenetic_A = mkWA (compoundA "keno" (k38 "geneettinen")) ; --UNCHK
lin cenotaph_N = mkWN (compoundN "muisto" (k5A "merkki")) "sankarivainajien" ; --UNCHK
lin censer_N = mkWN (compoundN "suitsutus" (k12 "astia")) ; --UNCHK
lin censor_N = mkWN (k10 "tarkastaja") ; --UNCHK
lin censor_V2 = mkWV2 (k62 "sensuroida") ; --UNCHK
lin censorial_A = mkWA "sensuuri-" ; --UNCHK
lin censoring_N = mkWN (k5A "sensurointi") ; --UNCHK
lin censorious_A = mkWA (k38 "kriittinen") ; --UNCHK
lin censorship_N = mkWN (k5A "sensurointi") ;
lin censure_N = mkWN (k48A "moite") ; --UNCHK
lin censure_V2 = mkWV2 (k67 "arvostella") ; --UNCHK
lin census_N = mkWN (compoundN "väestön" (k9A "laskenta")) ; --UNCHK
lin cent_N = mkN (lin NK {s = d05A "sentti"}) ;
lin centas_N = mkWN "centas" ; --UNCHK
lin centaur_N = mkWN "Kentauri" ; --UNCHK
lin centaury_N = mkWN (k5A "kaunokki") ; --UNCHK
lin centenarian_A = mkWA (compoundA "sata" (k38 "vuotinen")) ; --UNCHK
lin centenarian_N = mkWN "satavuotias" ; --UNCHK
lin centenary_A = mkWA (compoundA "sata" (k38 "vuotinen")) ; --UNCHK
lin centenary_N = mkWN (compoundN "satavuotis" (k10 "juhla")) ; --UNCHK
lin centennial_A = mkWA (compoundA "sata" (k38 "vuotinen")) ; --UNCHK
lin centennial_N = mkWN (compoundN "satavuotis" (k10 "juhla")) ; --UNCHK
lin center_A = mkWA (k38 "keskustalainen") ; --UNCHK
lin centered_A = mkA "keskitetty" ; --WA (k99 "keskellä") ;
lin centerfold_N = mkWN (compoundN "keski" (k10 "aukeama")) ; --UNCHK
lin centering_N = mkWN (compoundN "aloitus" (k1A "syöttö")) ; --UNCHK
lin centerline_N = mkWN (compoundN "keski" (k9 "viiva")) ; --UNCHK
lin centesimal_A = mkWA "sadasosan" ; --UNCHK
lin centesimo_N = mkWN "centesimo" ; --UNCHK
lin centesis_N = mkWN (compoundN "imu" (k1 "pisto")) ; --UNCHK
lin centigrade_A = mkWA "celsiusastetta" ; --UNCHK
lin centiliter_N = mkWN (compoundN "sentti" (k9 "litra")) ; --UNCHK
lin centime_N = mkWN (k5A "sentti") ; --UNCHK
lin centimetre_N = mkWN (k5A "sentti") ; --UNCHK
lin centimo_N = mkWN "centimo" ; --UNCHK
lin centipede_N = mkWN (compoundN "juoksu" (k38 "jalkainen")) ; --UNCHK
lin central_A = mkA "keskeinen" ;
lin central_N = mkWN (k39 "keskus") ; --UNCHK
lin centralism_N = mkWN (compoundN "keskittämis" (k9A "politiikka")) ; --UNCHK
lin centralist_A = mkWA (k10 "tukeva") "keskittämispolitiikkaa" ; --UNCHK
lin centrality_N = mkWN (k40 "keskeisyys") ; --UNCHK
lin centralization_N = mkWN (k39 "keskitys") ; --UNCHK
lin centralize_V = mkWV (k53A "keskittää") ; --UNCHK
lin centralize_V2 = mkWV2 (k53A "keskittää") ; --UNCHK
lin centre_N = mkN "keskusta" ;
lin centre_V = mkWV (k53 "kohdistaa") "huomionsa" ; --UNCHK
lin centre_V2 = mkWV2 (k53 "kohdistaa") "huomionsa" ; --UNCHK
lin centre_bit_N = mkWN (compoundN "puu" (k10 "terä")) ; --UNCHK
lin centre_board_N = mkWN (compoundN "nosto" (k5 "köli")) ; --UNCHK
lin centrepiece_N = mkWN (compoundN "pöytä" (k48 "koriste")) ; --UNCHK
lin centrex_N = mkWN (compoundN "vaihde" (k2 "palvelu")) ; --UNCHK
lin centric_A = mkWA (k38 "keskinen") ; --UNCHK
lin centrifugal_A = mkWA (k38 "keskipakoinen") ; --UNCHK
lin centrifugation_N = mkWN (compoundN "linko" (k38 "aminen")) ; --UNCHK
lin centrifuge_N = mkWN (k33A "erotin") ; --UNCHK
lin centriole_N = mkWN (compoundN "sen" (k6 "trioli")) ; --UNCHK
lin centripetal_A = mkWA (compoundA "keski" (k38 "hakuinen")) ; --UNCHK
lin centrism_N = mkWN (k40 "maltillisuus") ; --UNCHK
lin centrist_A = mkWA (k38 "maltillinen") ; --UNCHK
lin centrist_N = mkWN (k38 "maltillinen") ; --UNCHK
lin centroid_N = mkWN (compoundN "keski" (k48 "piste")) "massan" ; --UNCHK
lin centroidal_A = mkWA "massan" "keskipisteen" ; --UNCHK
lin centromere_N = mkWN (compoundN "kinetok" (k48 "ori")) ; --UNCHK
lin centromeric_A = mkWA (compoundA "sen" (k38 "tromeerinen")) ; --UNCHK
lin centrosome_N = mkWN (compoundN "keskus" (k38 "jyvänen")) ; --UNCHK
lin centrosomic_A = mkWA "sentrosomin" ; --UNCHK
lin centrum_N = mkWN (compoundN "runko-" (k10 "osa")) "nikaman" ; --UNCHK
lin centurion_N = mkWN (compoundN "sadanpääm" (k41A "ies")) ; --UNCHK
lin century_N = mkN "vuosi" (mkN "sata") ;
lin cephalexin_N = mkWN "Keftab" ; --UNCHK
lin cephalhematoma_N = mkWN (compoundN "veri" (k9 "pahka")) ; --UNCHK
lin cephalic_A = mkWA (compoundA "kefa" (k38 "alinen")) ; --UNCHK
lin cephalochordate_N = mkWN (compoundN "Cephalochor" (k9 "data")) ; --UNCHK
lin cephaloglycin_N = mkWN "Kafocin" ; --UNCHK
lin cephalometry_N = mkWN (k39 "mittaus") "pään" ; --UNCHK
lin cephalopod_A = mkWA (k10 "kuuluva") "pääjalkaisiin" ; --UNCHK
lin cephalopod_N = mkWN (compoundN "pää" (k38 "jalkainen")) ; --UNCHK
lin cephaloridine_N = mkWN "kefaloridiini" ; --UNCHK
lin cephalosporin_N = mkWN (k5 "kefalosporiini") ; --UNCHK
lin cephalothin_N = mkWN "kefalotiini" ; --UNCHK
lin ceramic_A = mkWA (k38 "keraaminen") ;
lin ceramic_N = mkWN (k9A "keramiikka") ; --UNCHK
lin ceramics_N = mkWN (k9A "keramiikka") ; --UNCHK
lin ceras_N = mkWN "sarvimainen" "kidus" ; --UNCHK
lin cerate_N = mkWN (compoundN "vaha" (k9 "salva")) ; --UNCHK
lin ceratodus_N = mkWN "Ceratodus" ; --UNCHK
lin ceratopsian_N = mkWN (k10 "kuuluva") "Ceratopsia-alalahkoon" ; --UNCHK
lin ceratosaur_N = mkWN "Ceratosaurus" ; --UNCHK
lin ceratozamia_N = mkWN "Ceratozamia" ; --UNCHK
lin cercaria_N = mkWN "Cercaria" ; --UNCHK
lin cercarial_A = mkWA (k10 "kuuluva") "Cercaria-toukkiin" ; --UNCHK
lin cere_N = mkWN (compoundN "vaha" (k9 "nahka")) ; --UNCHK
lin cereal_A = mkWA "vilja-" ; --UNCHK
lin cereal_N = mkWN (k5 "velli") ; --UNCHK
lin cerebellar_A = mkWA "pikkuaivojen" ; --UNCHK
lin cerebral_A = mkWA (k38 "älyllinen") ; --UNCHK
lin cerebration_N = mkWN (k2 "ajattelu") ; --UNCHK
lin cerebrospinal_A = mkWA "aivoselkäydin-" ; --UNCHK
lin cerebrovascular_A = mkWA "aivoverisuoni-" ; --UNCHK
lin cerecloth_N = mkWN (compoundN "vaha" (k48 "kääre")) ; --UNCHK
lin ceremonial_A = mkWA (k38 "seremoniaalinen") ; --UNCHK
lin ceremonial_N = mkWN (k5A "riitti") ; --UNCHK
lin ceremonious_A = mkWA (k38 "juhlallinen") ; --UNCHK
lin ceremoniousness_N = mkWN (k40 "muodollisuus") ; --UNCHK
lin ceremony_N = mkWN (k12 "seremonia") ; --UNCHK
lin ceresin_N = mkWN "seresiini" ; --UNCHK
lin ceric_A = mkWA "cerium-" ; --UNCHK
lin ceriman_N = mkWN (k10 "hedelmä") "Monstera" "deliciosan" ; --UNCHK
lin cerise_A = mkWA (k10 "punertava") ; --UNCHK
lin cerise_N = mkWN (compoundN "kirsikan" (k38 "punainen")) ; --UNCHK
lin cerium_N = mkWN "järjestysluku" "58" ; --UNCHK
lin cerivastatin_N = mkWN (compoundN "seriv" (k5 "astatiini")) ; --UNCHK
lin cernuous_A = mkWA (k10 "riippuva") ; --UNCHK
lin cero_N = mkWN (compoundN "kuningas" (k5 "makrilli")) ; --UNCHK
lin cerous_A = mkWA "cerium-" ; --UNCHK
lin cert_N = mkWN (k12 "asia") "varma" ; --UNCHK
lin certain_1_A = mkA (mkN "varma") "varmempi" "varmin" ;
lin certain_2_A = mkA "tietty" ;
lin certain_A = mkA (mkN "varma") "varmempi" "varmin" ;
lin certainty_N = mkWN (k1A "juttu") "varma" ; --UNCHK
lin certifiable_A = mkWA (k10 "oleva") "todistettavissa" ; --UNCHK
lin certificate_N = mkN (lin NK {s = d39 "todistus"}) ;
lin certificate_V2 = mkWV2 (k56A "antaa") "todistus" ; --UNCHK
lin certification_N = mkWN (k39 "todennus") ; --UNCHK
lin certificatory_A = mkWA "todistus-" ; --UNCHK
lin certified_A = mkA "valtuutettu" ;
lin certify_V = mkWV (k53 "todistaa") ; --UNCHK
lin certify_V2 = mkV2 "varmentaa" ; --WV2 (k53 "todistaa") ;
lin certiorari_N = mkWN (compoundN "certiorari-" (k39 "määräys")) ; --UNCHK
lin certitude_N = mkWN (k40 "varmuus") "liiallinen" ; --UNCHK
lin cerulean_A = mkWA (k38 "sininen") ; --UNCHK
lin cerumen_N = mkWN (k1A "vaikku") ; --UNCHK
lin ceruminous_A = mkWA "korvavaha-" ; --UNCHK
lin cerussite_N = mkWN (compoundN "lyijy" (k38 "valkoinen")) ; --UNCHK
lin cervical_A = mkWA (compoundA "servika" (k38 "alinen")) ; --UNCHK
lin cervicitis_N = mkWN (k39 "tulehdus") "kohdunkaulan" ; --UNCHK
lin cervine_A = mkWA "hirvi-" ; --UNCHK
lin cervix_N = mkWN (compoundN "kohdunka" (k10 "ula")) ; --UNCHK
lin cesarean_A = mkWA "keisari-" ; --UNCHK
lin cesium_N = mkWN (k5 "cesium") ; --UNCHK
lin cessation_N = mkWN (compoundN "loppu" (k38 "minen")) ; --UNCHK
lin cession_N = mkWN (k39 "luovutus") ; --UNCHK
lin cesspit_N = mkWN (compoundN "saostus" (k1 "kaivo")) ; --UNCHK
lin cesspool_N = mkWN (compoundN "saostus" (k1 "kaivo")) ; --UNCHK
lin cetacean_A = mkWA (compoundA "valaan" (k38 "sukuinen")) ; --UNCHK
lin cetacean_N = mkWN (k41A "nisäkäs") "valaansukuinen" ; --UNCHK
lin cetrimide_N = mkWN (k5 "setrimidi") ; --UNCHK
lin cgs_N = mkWN (compoundN "cgs-" (k10 "järjestelmä")) ; --UNCHK
lin chabazite_N = mkWN "kabasiitti" ; --UNCHK
lin chachalaca_N = mkWN "kaklattaja" ; --UNCHK
lin chachka_N = mkWN (k1 "hely") ; --UNCHK
lin chacma_N = mkWN (compoundN "karhu" (k5 "paviaani")) ; --UNCHK
lin chad_N = mkN "tšadilainen" ;
lin chad_PN = foreignPN "Tsad" ;
lin chadian_A = mkWA (compoundA "tsadi" (k38 "lainen")) ; --UNCHK
lin chadian_N = mkWN (compoundN "tsadi" (k38 "lainen")) ; --UNCHK
lin chador_N = mkWN "burka" ; --UNCHK
lin chaenactis_N = mkWN "Chaenactis" ; --UNCHK
lin chaeta_N = mkWN (k38 "sukanen") ; --UNCHK
lin chaetodon_N = mkWN "Chaetodon" ; --UNCHK
lin chafe_N = mkWN (k9 "vaiva") ; --UNCHK
lin chafe_V = mkWV (k73A "hangata") ; --UNCHK
lin chafe_V2 = mkWV2 (k73A "hangata") ; --UNCHK
lin chafeweed_N = mkWN (compoundN "aho" (k12 "jäkkärä")) ; --UNCHK
lin chaff_N = mkWN (compoundN "tutkanhäirintä" (k1A "silppu")) ; --UNCHK
lin chaff_V2 = mkWV2 (k67 "pilailla") ; --UNCHK
lin chaffinch_N = mkWN (k1A "peippo") ; --UNCHK
lin chaffweed_N = mkWN (compoundN "pikku" (k10A "punka")) ; --UNCHK
lin chaffy_A = mkWA (k10 "oleva") "silppuna" ; --UNCHK
lin chafing_N = mkWN (k10 "hiertymä") ; --UNCHK
lin chafing_dish_N = mkWN (compoundN "lämpö" (k13 "alusta")) ; --UNCHK
lin chagrin_N = mkWN (k15 "häpeä") ; --UNCHK
lin chagrin_V2 = mkWV2 (k54A "alentaa") ; --UNCHK
lin chain_N = mkN "ketju" ;
lin chain_V2 = mkWV2 (k53A "kiinnittää") "ketjulla" ; --UNCHK
lin chain_armour_N = mkWN (compoundN "silmukka" (k6 "panssari")) ; --UNCHK
lin chain_letter_N = mkWN (compoundN "ketju" (k48 "kirje")) ; --UNCHK
lin chain_mail_N = mkWN (compoundN "silmukka" (k6 "panssari")) ; --UNCHK
lin chain_stitch_N = mkWN (compoundN "ketju" (k1 "pisto")) ; --UNCHK
lin chain_store_N = mkWN (compoundN "ketju" (k12 "myymälä")) ; --UNCHK
lin chair_N = L.chair_N ;
lin chair_V2 = mkWV2 (k53A "johtaa") "puhetta" ;
lin chair_lift_N = mkWN (compoundN "tuoli" (k5 "hissi")) ; --UNCHK
lin chairman_N = mkN "puheenjohtaja" | mkN "puhe" L.man_N ;
lin chairmanship_N = mkWN (compoundN "puheen" (k40 "johtajuus")) ; --UNCHK
lin chaise_longue_N = mkWN (k6 "divaani") ; --UNCHK
lin chaja_N = mkWN "Chauna" "torquata" ; --UNCHK
lin chalazion_N = mkWN (compoundN "luomi" (k12 "rakkula")) ; --UNCHK
lin chalcedony_N = mkWN "kalsedoni" ; --UNCHK
lin chalcocite_N = mkWN (compoundN "kupari" (k48A "hohde")) ; --UNCHK
lin chalcopyrite_N = mkWN (compoundN "kupari" (k1 "kiisu")) ; --UNCHK
lin chaldron_N = mkWN "chaldron" ; --UNCHK
lin chalet_N = mkWN (compoundN "alppi" (k9 "maja")) ; --UNCHK
lin chalfont_PN = foreignPN "Chalfont" ;
lin chalice_N = mkWN (k6 "pikari") ; --UNCHK
lin chalk_N = mkWN (k1A "liitu") ; --UNCHK
lin chalk_V2 = mkWV2 (k69 "merkitä") "liidulla" ; --UNCHK
lin chalk_out_V2 = mkWV2 (k67A "hahmotella") ; --UNCHK
lin chalk_up_V2 = mkWV2 (k53A "pitää") "kirjaa" ; --UNCHK
lin chalkpit_N = mkWN (compoundN "liitu" (k39 "louhos")) ; --UNCHK
lin chalky_A = mkWA (compoundA "kalkki" (k38 "nen")) ; --UNCHK
lin challah_N = mkWN (compoundN "chale-" (k10A "leipä")) ; --UNCHK
lin challenge_N = mkN "haaste" ; --f56
lin challenge_V = mkV (mkV "joutua") "kyseenalaiseksi" ; --mkWV (k61A "moittia") ;
lin challenge_V2 = mkV2 "haastaa" ;
lin challengeable_A = mkWA (k5 "jäävi") ; --UNCHK
lin challenger_N = mkWN (k10 "haastaja") ; --UNCHK
lin chalybeate_A = mkWA (compoundA "rautapi" (k38 "toinen")) ; --UNCHK
lin chamber_N = mkWN (k6 "kamari") ; --UNCHK
lin chambered_A = mkWA (compoundA "ontelo" (k38 "rakenteinen")) ; --UNCHK
lin chamberlain_N = mkWN (compoundN "kamari" (k9 "herra")) ; --UNCHK
lin chambermaid_N = mkWN (compoundN "huone" (k12 "palvelija")) ; --UNCHK
lin chamberpot_N = mkWN (k10A "potta") ; --UNCHK
lin chambray_N = mkWN (k5 "batisti") ; --UNCHK
lin chameleon_N = mkWN (k5A "kameleontti") ; --UNCHK
lin chammy_leather_N = mkWN (k13 "säämiskä") ; --UNCHK
lin chamois_N = mkWN "Rupicapra" "rupicapra" ; --UNCHK
lin chamois_leather_N = mkWN (k13 "säämiskä") ; --UNCHK
lin chamosite_N = mkWN "chamosiitti" ; --UNCHK
lin champ_N = mkWN (k6 "mestari") ; --UNCHK
lin champ_V = mkWV (k67 "pureskella") ; --UNCHK
lin champ_V2 = mkWV2 (k67 "pureskella") ; --UNCHK
lin champagne_N = mkWN (k5 "kuohuviini") ; --UNCHK
lin champerty_N = mkWN "champerty" ; --UNCHK
lin champion_A = mkWA (k6 "mestari") ; --UNCHK
lin champion_N = mkWN (k5A "ekspertti") ; --UNCHK
lin champion_V2 = mkV2 "hallita" ;
lin championship_N = mkN "mestaruus" ; --mkWN (k39 "kannatus") ;
lin champleve_A = mkWA (compoundA "soluem" (k38 "alinen")) ; --UNCHK
lin chanar_N = mkWN (compoundN "spin" (k10 "osa")) "Lucuma" ; --UNCHK
lin chance_N = mkN (lin NK {s = d40 "mahdollisuus"}) ;
lin chance_V = mkWV (k73A "kohdata") "sattumalta" ; --UNCHK
lin chance_V2 = mkWV2 (k73A "kohdata") "sattumalta" ; --UNCHK
lin chance_VS = mkWVS (k73A "kohdata") "sattumalta" ; --UNCHK
lin chance_upon_V2 = mkWV2 (k61 "keksiä") ; --UNCHK
lin chancel_N = mkWN (kH1 "kuori") ; --UNCHK
lin chancellery_N = mkWN (compoundN "kanslerin" (k1 "virasto")) ; --UNCHK
lin chancellor_N = mkWN (k6 "kansleri") ;
lin chancellorship_N = mkWN (compoundN "kanslerin" (k9A "virka")) ; --UNCHK
lin chancery_N = mkWN (k2 "arkisto") ; --UNCHK
lin chancre_N = mkWN (k6 "sankkeri") ; --UNCHK
lin chancroid_N = mkWN (k6 "sankkeri") "pehmeä" ; --UNCHK
lin chancrous_A = mkWA (compoundA "sankkeri" (k38 "mainen")) ; --UNCHK
lin chancy_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin chandelier_N = mkN "katto" (mkN "kruunu") ;
lin chandler_N = mkWN (compoundN "kynttilän" (k12 "tekijä")) ; --UNCHK
lin chandlery_N = mkWN (compoundN "kynttilä" (k2 "varasto")) ; --UNCHK
lin chanfron_N = mkWN (compoundN "otsa" (k13 "haarniska")) "hevosen" ; --UNCHK
lin changchun_PN = foreignPN "Changchun" ;
lin change_N = mkN "muutos" ;
lin change_V = mkV "muuttua" ;
lin change_V2 = mkV2 "muuttaa" ;
lin change_over_V2 = mkWV2 (k56A "vaihtaa") ; --UNCHK
lin changeable_A = mkWA (k38 "epävakainen") ; --UNCHK
lin changeableness_N = mkWN (k40 "epävakaisuus") ; --UNCHK
lin changeful_A = mkWA (k38 "epävakainen") ; --UNCHK
lin changeless_A = mkWA (k10 "pysyvä") ; --UNCHK
lin changelessness_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin changeling_N = mkWN (k41A "vaihdokas") ; --UNCHK
lin changeover_N = mkWN (k39 "muutos") ; --UNCHK
lin changer_N = mkWN (compoundN "levyn" (k10 "vaihtaja")) ; --UNCHK
lin changing_A = mkA "vaihteleva" ;
lin changsha_PN = foreignPN "Changsha" ;
lin channel_N = mkWN (k10 "kanava") ; --UNCHK
lin channel_V2 = mkWV2 (k53A "lähettää") ; --UNCHK
lin channelization_N = mkWN (k5A "kanavointi") ; --UNCHK
lin channels_N = mkWN (compoundN "virka" (k19 "tie")) ; --UNCHK
lin chant_N = mkWN (k5 "resitatiivi") ; --UNCHK
lin chant_V = mkWV (k74 "messuta") ; --UNCHK
lin chant_V2 = mkWV2 (k74 "messuta") ; --UNCHK
lin chanter_N = mkWN (k33A "puhallin") "säkkipillin" ; --UNCHK
lin chanterelle_N = mkWN (k5 "kantarelli") ; --UNCHK
lin chantey_N = mkWN (compoundN "merimies" (k1 "laulu")) ; --UNCHK
lin chantlike_A = mkWA (compoundA "loitsu" (k38 "mainen")) ; --UNCHK
lin chantry_N = mkWN (compoundN "sielumessu" (k6 "kappeli")) ; --UNCHK
lin chaos_N = mkWN (k39 "kaaos") ; --UNCHK
lin chaotic_A = mkWA (k38 "kaoottinen") ;
lin chap_N = mkN "poika" "pojan" "poikia" ;
lin chap_V = mkWV (k67 "halkeilla") ; --UNCHK
lin chap_V2 = mkWV2 (k67 "halkeilla") ; --UNCHK
lin chapatti_N = mkWN (k5A "chapatti") ; --UNCHK
lin chapel_N = mkWN (compoundN "jumalan" (k39 "palvelus")) ; --UNCHK
lin chapelgoer_N = mkWN (k5A "protestantti") ; --UNCHK
lin chaperon_N = mkWN (k12 "kaitsija") ; --UNCHK
lin chaperon_V2 = mkWV2 (k61 "toimia") "esiliinana" ; --UNCHK
lin chapfallen_A = mkWA (k38 "alakuloinen") ; --UNCHK
lin chaplain_N = mkWN (k38 "kappalainen") ; --UNCHK
lin chaplaincy_N = mkWN (k9A "virka") "kappalaisen" ; --UNCHK
lin chaplet_N = mkWN (k5 "kranssi") ; --UNCHK
lin chapleted_A = mkWA "seppelöity" ; --UNCHK
lin chapman_N = mkWN (compoundN "kulku" (k41 "kauppias")) ; --UNCHK
lin chapter_N = mkWN (k1A "luku") ;
lin chapterhouse_N = mkWN (k12 "asuntola") "opiskelijayhdistyksen" ; --UNCHK
lin char_N = mkWN (k12 "nieriä") ; --UNCHK
lin char_V = mkWV (k53 "ruskistaa") ; --UNCHK
lin char_V2 = mkWV2 (k53 "ruskistaa") ; --UNCHK
lin charabanc_N = variants {} ; ---- sense to be split
lin characin_N = mkWN (compoundN "karppi" (k23 "lohi")) ; --UNCHK
lin character_1_N = mkN "luonne" ; ---- sense ?
lin character_2_N = mkN "merkki" ; ---- sense ?
lin characteristic_A = mkWA (k38 "ominainen") ; --UNCHK
lin characteristic_N = mkWN (compoundN "tunto" (k5A "merkki")) ; --UNCHK
lin characterization_N = mkWN (k9A "tulkinta") ; --UNCHK
lin characterize_V2 = mkWV2 (k61A "luonnehtia") ; --UNCHK
lin characterless_A = mkWA (k10 "tylsä") ; --UNCHK
lin charade_N = mkWN (k39 "arvoitus") "miiminen" ; --UNCHK
lin charades_N = mkWN (compoundN "arvoitus" (k5A "leikki")) "miiminen" ; --UNCHK
lin charcoal_A = mkWA (k5A "antrasiitti") ; --UNCHK
lin charcoal_N = mkWN (compoundN "hiili" (k10 "kynä")) ; --UNCHK
lin charcoal_burner_N = mkWN (compoundN "hiili" (k33A "poltin")) ; --UNCHK
lin chard_N = mkWN (compoundN "lehti" (k5 "mangoldi")) ; --UNCHK
lin chard_PN = foreignPN "Chard" ;
lin charge_1_N = mkN "varaus" ;
lin charge_2_N = mkN "syytös" ;
lin charge_N = mkN "varaus" ;
lin charge_V = mkV "latautua" ;
lin charge_V2 = mkV2 "kuormittaa" partitive ;
lin charge_account_N = mkWN (compoundN "asiakas" (k5 "tili")) ; --UNCHK
lin charge_d'affaires_N = mkWN (compoundN "asiain" (k10 "hoitaja")) ; --UNCHK
lin charge_off_V = advV OP_charge_V OP_off_Adv ; -- guess-p-verb
lin charge_sheet_N = mkWN (compoundN "rikos" (k6 "rekisteri")) ; --UNCHK
lin charge_up_V2 = mkWV2 (k63 "saada") "innostumaan" ; --UNCHK
lin charge_with_V3 = variants {} ; -- guess-p-verb
lin chargeable_A = mkWA (k38 "alainen") "syytteen" ; --UNCHK
lin charger_N = mkWN (compoundN "sota" (k1 "ratsu")) ; --UNCHK
lin charioteer_N = mkWN (compoundN "Ajom" (k41A "ies")) ; --UNCHK
lin charisma_N = mkWN (k13 "karisma") ; --UNCHK
lin charismatic_A = mkWA (k38 "karismaattinen") ; --UNCHK
lin charitable_A = mkA (mkN "hyvän" (mkN "tahtoinen")) ; --mkWA (k41 "armelias") ;
lin charitableness_N = mkWN (k40 "hyväntekeväisyys") ; --UNCHK
lin charity_N = mkWN (k40 "hyväntekeväisyys") ;
lin charivari_N = mkWN (k5 "charivari") ; --UNCHK
lin charlatan_N = mkWN (k6 "huijari") ; --UNCHK
lin charlatanism_N = mkWN (k5A "puoskarointi") ; --UNCHK
lin charleston_N = mkWN "Charleston" ; --UNCHK
lin charlock_N = mkWN (compoundN "rikka" (k5A "sinappi")) ; --UNCHK
lin charlotte_N = mkWN (compoundN "charlotte-" (k41A "vanukas")) ; --UNCHK
lin charlotte_PN = foreignPN "Charlotte" ;
lin charm_N = mkWN (k5A "amuletti") ; --UNCHK
lin charm_V = mkWV (k67A "vietellä") ; --UNCHK
lin charm_V2 = mkWV2 (k67A "vietellä") ; --UNCHK
lin charmer_N = mkWN (k10 "lumooja") ; --UNCHK
lin charming_A = variants {} ; --
lin charnel_A = mkWA (compoundA "hauta" (k38 "mainen")) ; --UNCHK
lin charnel_house_N = mkWN (compoundN "ruumis" (k48 "huone")) ; --UNCHK
lin chart_N = mkWN (compoundN "meri" (k5A "kortti")) ; --UNCHK
lin chart_V2 = mkV2 "kartoittaa" ;
lin chartaceous_A = mkWA (k38 "paperinen") ; --UNCHK
lin charter_N = mkWN (compoundN "perustamis" (k9 "kirja")) ; --UNCHK
lin charter_V2 = mkV2 "vuokrata" ; --mkWV2 (k53A "ottaa") "vuokralle" ;
lin charterhouse_N = mkWN (compoundN "kartusiaani" (k6 "luostari")) ; --UNCHK
lin chartist_N = mkWN (k4A "analyytikko") "tekninen" ; --UNCHK
lin chartless_A = mkWA "kartoittamaton" ; --UNCHK
lin chartreuse_A = mkWA (compoundA "keltaisen" (k15 "vihreä")) ; --UNCHK
lin chartreuse_N = mkWN (compoundN "kelta" (k15 "vihreä")) "kirkkaan" ; --UNCHK
lin charwoman_N = mkWN (k10 "siivooja") ; --UNCHK
lin chary_A = mkWA (k38 "harkitsevainen") ; --UNCHK
lin chase_N = mkWN (kH1 "jahti") ; --UNCHK
lin chase_V = mkWV (k54A "kaivertaa") ; --UNCHK
lin chase_V2 = mkV2 (mkV (mkV "ajaa") "takaa") partitive ; --mkWV2 (k54A "kaivertaa") ;
lin chaser_N = mkWN "chaser" ; --UNCHK
lin chasm_N = mkWN (k1 "kuilu") ; --UNCHK
lin chasse_N = mkWN "chassé" ; --UNCHK
lin chassis_N = mkWN (k13 "alusta") ; --UNCHK
lin chasten_V2 = mkWV2 (k53 "alistaa") ; --UNCHK
lin chasteness_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin chastise_V2 = mkWV2 (k54A "ojentaa") ; --UNCHK
lin chastisement_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin chastity_N = mkWN (k5A "selibaatti") ; --UNCHK
lin chasuble_N = mkWN (compoundN "messu" (k14A "kasukka")) ; --UNCHK
lin chat_N = mkWN (k1A "sieppo") ; --UNCHK
lin chat_V = mkWV (k66 "horista") ; --UNCHK
lin chat_up_V2 = mkWV2 (k67A "suostutella") ; --UNCHK
lin chateau_N = mkWN (k9 "linna") ; --UNCHK
lin chatham_PN = foreignPN "Chatham" ;
lin chattel_N = mkWN (k48 "esine") "irtain" ; --UNCHK
lin chatter_N = mkWN (k39 "pälpätys") ; --UNCHK
lin chatter_V = mkWV (k53A "pälättää") ; --UNCHK
lin chatterbox_N = mkWN (k5A "suupaltti") ; --UNCHK
lin chatterer_N = mkWN "kotinga" ; --UNCHK
lin chatty_A = mkWA (k41 "suulas") ; --UNCHK
lin chauffeur_N = mkWN (k10 "kuljettaja") ; --UNCHK
lin chauffeur_V2 = mkWV2 (k56 "ajaa") ; --UNCHK
lin chauffeuse_N = mkWN (compoundN "auton" (k10 "kuljettaja")) ; --UNCHK
lin chaulmoogra_N = mkWN "Taraktogenos" "kurzii" ; --UNCHK
lin chauvinism_N = mkWN (k5 "sovinismi") ; --UNCHK
lin chauvinist_N = mkWN (k38 "ihminen") "kiihkoisänmaallinen" ; --UNCHK
lin chauvinistic_A = mkWA "šovinistinen" ; --UNCHK
lin chaw_N = mkWN (kH1 "mälli") ; --UNCHK
lin chaw_V2 = mkWV2 (k61 "pureksia") ; --UNCHK
lin cheadle_PN = foreignPN "Cheadle" ;
lin cheap_A = mkWA (k38 "edullinen") ; --f84
lin cheapen_V = mkWV (k58 "laskea") "hintaa" ; --UNCHK
lin cheapen_V2 = mkWV2 (k58 "laskea") "hintaa" ; --UNCHK
lin cheapjack_A = mkWA (k15 "surkea") ; --UNCHK
lin cheapjack_N = mkWN (k5A "helppoheikki") ; --UNCHK
lin cheapness_N = mkWN (k10 "roska") ; --UNCHK
lin cheapskate_N = mkWN (k6 "saituri") ; --UNCHK
lin cheat_N = mkWN (k5A "vilppi") ; --UNCHK
lin cheat_V = mkWV (k73 "huijata") ; --UNCHK
lin cheat_V2 = mkWV2 (k73 "huijata") ; --UNCHK
lin cheat_on_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin chebab_N = mkWN "chebab" ; --UNCHK
lin check_N = mkN "tarkistus" ;
lin check_V = mkV "tarkastaa" ; ---- subcat
lin check_V2 = mkV2 "tarkastaa" | mkV2 "tarkistaa" | mkV2 "estää" ; ---- split
lin check_back_V = advV OP_check_V OP_back_Adv ; -- guess-p-verb
lin check_by_V2 = prepV2 OP_check_V OP_by_Prep ; -- guess-p-verb
lin check_for_V2 = prepV2 OP_check_V OP_for_Prep ; -- guess-p-verb
lin check_in_V = mkWV (k71 "tehdä") "lähtöselvitys" ; --UNCHK
lin check_in_V2 = mkWV2 (k71 "tehdä") "lähtöselvitys" ; --UNCHK
lin check_into_V2 = mkWV2 (k73A "tsekata") ; --UNCHK
lin check_off_V2 = mkWV2 (k69 "merkitä") "rastilla" ; --UNCHK
lin check_on_V2 = prepV2 OP_check_V OP_on_Prep ; -- guess-p-verb
lin check_out_V = mkWV (k73A "tsekata") ; --UNCHK
lin check_out_V2 = mkWV2 (k73A "tsekata") ; --UNCHK
lin check_out_of_V2 = prepV2 (advV OP_check_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin check_over_V2 = mkWV2 (k73A "tsekata") ; --UNCHK
lin check_through_V2 = prepV2 OP_check_V OP_through_Prep ; -- guess-p-verb
lin check_up_on_V2 = mkWV2 (k73A "tsekata") ; --UNCHK
lin check_with_V2 = prepV2 OP_check_V OP_with_Prep ; -- guess-p-verb
lin checkbook_N = mkWN (compoundN "sekki" (k1 "vihko")) ; --UNCHK
lin checker_N = mkWN (compoundN "šakki" (k12 "nappula")) ; --UNCHK
lin checker_V2 = mkWV2 (k62 "kuvioida") ; --UNCHK
lin checkerbloom_N = mkWN (compoundN "jalo" (k9 "malva")) ; --UNCHK
lin checkerboard_N = mkWN (compoundN "šakki" (k9A "lauta")) ; --UNCHK
lin checkers_N = mkWN (kH1 "tammi") ; --UNCHK
lin checklist_N = mkWN (compoundN "muisti" (k9 "lista")) ; --UNCHK
lin checkmate_N = mkWN (kH1 "matti") ; --UNCHK
lin checkmate_V2 = mkWV2 (k71 "tehdä") "matti" ; --UNCHK
lin checkout_N = mkWN (k39 "varmistus") ; --UNCHK
lin checkpoint_N = mkWN (compoundN "tarkastus" (k48 "piste")) ; --UNCHK
lin checkroom_N = mkWN (compoundN "matkatavara" (k1 "säilö")) ; --UNCHK
lin checksum_N = mkWN (compoundN "tarkistus" (k10 "summa")) ; --UNCHK
lin checkup_N = mkWN (compoundN "lääkärin" (k39 "tarkastus")) ; --UNCHK
lin cheddar_N = mkWN (k5 "cheddar") ; --UNCHK
lin cheek_N = mkWN (k40 "hävyttömyys") ; --UNCHK
lin cheek_V2 = mkWV2 (k52 "puhua") "röyhkeästi" ; --UNCHK
lin cheekbone_N = mkWN (compoundN "poski" (k18 "pää")) ; --UNCHK
lin cheekpiece_N = mkWN (compoundN "poski" (k9 "hihna")) ; --UNCHK
lin cheeky_A = mkWA (k10 "tunkeileva") ; --UNCHK
lin cheep_N = mkWN (k39 "piipitys") ; --UNCHK
lin cheep_V = mkWV (k53A "sirittää") ; --UNCHK
lin cheer_N = mkWN (k40 "hilpeys") ; --UNCHK
lin cheer_V = mkV (lin VK {s = c53 "kannustaa"}) ;
lin cheer_V2 = mkWV2 (k73 "hurrata") ; --UNCHK
lin cheer_up_V = mkWV (k52A "ilahtua") ; --UNCHK
lin cheer_up_V2 = mkWV2 (k52A "ilahtua") ; --UNCHK
lin cheerer_N = mkWN (k5 "fani") ; --UNCHK
lin cheerful_A = mkWA (k15 "hilpeä") ; --UNCHK
lin cheerfulness_N = mkWN (k40 "hilpeys") ; --UNCHK
lin cheerleader_N = mkWN (k5 "cheerleader") ; --UNCHK
lin cheerless_A = mkWA (k34A "iloton") ; --UNCHK
lin cheerlessness_N = mkWN (k40 "lohduttomuus") ; --UNCHK
lin cheers_Interj = mkInterj "terveydeksi" ;
lin cheery_A = mkWA (k38 "aurinkoinen") ; --UNCHK
lin cheese_N = L.cheese_N ;
lin cheeseboard_N = mkWN (compoundN "juusto" (k33A "tarjotin")) ; --UNCHK
lin cheeseburger_N = mkWN (compoundN "juusto" (k38 "hampurilainen")) ; --UNCHK
lin cheesecake_N = mkWN (compoundN "kansikuva" (k1A "tyttö")) ; --UNCHK
lin cheesecloth_N = mkWN (k41A "juustokangas") ; --UNCHK
lin cheeselike_A = mkWA (compoundA "juusto" (k38 "mainen")) ; --UNCHK
lin cheesemonger_N = mkWN (compoundN "juusto" (k41 "kauppias")) ; --UNCHK
lin cheeseparing_A = mkWA (k9A "saita") ; --UNCHK
lin cheetah_N = mkWN (k5 "gepardi") ; --UNCHK
lin chef_N = mkWN (kH1 "kokki") ; --UNCHK
lin cheilitis_N = mkWN (compoundN "huuli" (k39 "tulehdus")) ; --UNCHK
lin cheilosis_N = mkWN (compoundN "huuli" (k10 "sierettymä")) ; --UNCHK
lin chela_N = mkWN "saksi" ; --UNCHK
lin chelate_A = mkWA (compoundA "saksi" (k38 "mainen")) ; --UNCHK
lin chelate_N = mkWN (compoundN "kelaatti" (k48 "yhdiste")) ; --UNCHK
lin chelation_N = mkWN (compoundN "kela" (k38 "toituminen")) ; --UNCHK
lin chelicera_N = mkWN (compoundN "leuka" (k1A "koukku")) ; --UNCHK
lin cheliceral_A = mkWA (compoundA "leukakoukku" (k38 "mainen")) ; --UNCHK
lin chelicerous_A = mkWA (compoundA "leuka" (k38 "koukullinen")) ; --UNCHK
lin cheliferous_A = mkWA "saksellinen" ; --UNCHK
lin chelmsford_PN = foreignPN "Chelmsford" ;
lin chelonian_A = mkWA (compoundA "kilpi" (k38 "konnamainen")) ; --UNCHK
lin chelonian_N = mkWN (k12 "matelija") "Chelonia-lahkoon" "kuuluva" ; --UNCHK
lin chelsea_PN = foreignPN "Chelsea" ;
lin cheltenham_PN = foreignPN "Cheltenham" ;
lin chelyabinsk_PN = foreignPN "Tšeljabinsk" ;
lin chemical_A = mkWA (k38 "kemiallinen") ; --UNCHK
lin chemical_N = mkN "kemikaali" ;
lin chemiluminescence_N = mkWN (compoundN "kemi" (k5 "luminesenssi")) ; --UNCHK
lin chemiluminescent_A = mkWA "kemiluminesenssi-" ; --UNCHK
lin chemise_N = mkWN (k1A "mekko") "suora" ; --UNCHK
lin chemisorption_N = mkWN (k3 "adsorptio") "kemiallinen" ; --UNCHK
lin chemisorptive_A = mkWA "kemiallisesti" "adsorboituva" ; --UNCHK
lin chemistFem_N = mkWN (k5 "kemisti") ;
lin chemistMasc_N = mkN "kemisti" ;
lin chemistry_N = mkWN (k12 "kemia") ;
lin chemoreceptive_A = mkWA "kemoreseptorin" ; --UNCHK
lin chemosis_N = mkWN "kemoosi" ; --UNCHK
lin chemosurgery_N = mkWN (k12 "kirurgia") "Mohsin" ; --UNCHK
lin chemosynthesis_N = mkWN (compoundN "kemo" (k5 "synteesi")) ; --UNCHK
lin chemotaxis_N = mkWN "kemotaksis" ; --UNCHK
lin chemotherapeutic_A = mkWA (compoundA "kemo" (k38 "terapeuttinen")) ; --UNCHK
lin chemotherapy_N = mkWN (compoundN "kemo" (k12 "terapia")) ; --UNCHK
lin chenille_N = mkWN (k8 "chenille") ; --UNCHK
lin chepstow_PN = foreignPN "Chepstow" ;
lin cheque_N = mkWN (k5A "šekki") ; --UNCHK
lin chequebook_N = mkWN (compoundN "sekki" (k1 "vihko")) ; --UNCHK
lin chequer_V2 = mkWV2 (k62 "kuvioida") ; --UNCHK
lin cherimoya_N = mkWN (k10 "annoona") ; --UNCHK
lin cherish_V2 = mkWV2 (k61 "vaalia") ; --UNCHK
lin cheroot_N = mkWN (compoundN "pikku" (k6 "sikari")) "tasapaksu" ; --UNCHK
lin cherry_A = mkWA (k10 "punertava") ; --UNCHK
lin cherry_N = mkWN (compoundN "kirsikan" (k38 "punainen")) ; --UNCHK
lin cherrystone_N = mkWN (compoundN "kauppavenus" (k14A "simpukka")) "pieni" ; --UNCHK
lin chert_N = mkWN "sertti" ; --UNCHK
lin cherty_A = mkWA "serttimäinen" ; --UNCHK
lin cherub_N = mkWN (k5 "kerubi") ; --UNCHK
lin cherubic_A = mkWA (k10 "ihana") ; --UNCHK
lin chervil_N = mkWN (k6 "kirveli") ; --UNCHK
lin chesham_PN = foreignPN "Chesham" ;
lin cheshire_PN = foreignPN "Cheshire" ;
lin chess_N = mkWN (k5A "shakki") ; --UNCHK
lin chessboard_N = mkWN (compoundN "šakki" (k9A "lauta")) ; --UNCHK
lin chessman_N = mkWN (compoundN "šakki" (k12 "nappula")) ; --UNCHK
lin chest_N = mkWN (k1 "kirstu") ; --UNCHK
lin chester_PN = foreignPN "Chester" ;
lin chesterfield_PN = foreignPN "Chesterfield" ;
lin chestnut_A = mkWA (compoundA "kastanjan" (k15 "ruskea")) ; --UNCHK
lin chestnut_N = mkWN (k41 "rautias") ; --UNCHK
lin chetrum_N = mkWN "chetrum" ; --UNCHK
lin cheval_glass_N = mkWN (compoundN "kääntö" (k5 "peili")) "iso" ; --UNCHK
lin chevron_N = mkWN (compoundN "polvi" (k28 "orsi")) ; --UNCHK
lin chevrotain_N = mkWN (compoundN "kääpiö" (k41 "kauris")) ; --UNCHK
lin chew_N = mkWN (k2 "pureskelu") ; --UNCHK
lin chew_V = mkWV (k61 "pureksia") ; --UNCHK
lin chew_V2 = mkWV2 (k61 "pureksia") ; --UNCHK
lin chew_out_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin chew_over_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin chew_up_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin chewable_A = mkWA "helposti" "leikattava" ; --UNCHK
lin chewer_N = mkWN "jauhaja" ; --UNCHK
lin chewing_gum_N = mkWN (k10A "purkka") ; --UNCHK
lin chewink_N = mkWN (compoundN "loistopip" (k1 "ilo")) ; --UNCHK
lin chewy_A = mkWA (k15 "sitkeä") ; --UNCHK
lin chez_Prep = mkPrep "luona" ;
lin chi_N = mkWN (k18 "khii") ; --UNCHK
lin chianti_N = mkWN (compoundN "Chi" (k5A "anti")) ; --UNCHK
lin chiaroscuro_N = mkWN "chiaroscuro" ; --UNCHK
lin chiasma_N = mkWN (k5 "risti") ; --UNCHK
lin chiasmus_N = mkWN "kiasmi" ; --UNCHK
lin chic_A = mkWA (k5A "elegantti") ; --UNCHK
lin chic_N = mkWN (k40 "upeus") ; --UNCHK
lin chicago_PN = foreignPN "Chicago" ;
lin chicane_N = mkWN (k39 "petos") ; --UNCHK
lin chicanery_N = mkWN (k39 "petos") ; --UNCHK
lin chichester_PN = foreignPN "Chichester" ;
lin chichi_A = mkWA "hienosteleva" ; --UNCHK
lin chichi_N = mkWN (k40 "upeus") ; --UNCHK
lin chichipe_N = mkWN "Lemaireocereus" "chichipe" ; --UNCHK
lin chick_N = mkWN (k4A "nuorikko") ; --UNCHK
lin chickadee_N = mkWN (k38 "tiainen") ; --UNCHK
lin chicken_A = mkWA (k38 "pelkurimainen") ; --UNCHK
lin chicken_N = mkN "kana" ;
lin chicken_out_V = mkWV (k53 "jänistää") ; --UNCHK
lin chicken_run_N = mkWN (compoundN "ulkoilu" (k48 "alue")) "kanojen" ; --UNCHK
lin chickenfeed_N = mkWN (k39 "korvaus") "mitätön" ; --UNCHK
lin chickenpox_N = mkWN (compoundN "vesi" (k1A "rokko")) ; --UNCHK
lin chickenshit_N = mkWN (compoundN "hätä" (k48 "vale")) ; --UNCHK
lin chickeree_N = mkWN (compoundN "lännenpuna" (k10 "orava")) ; --UNCHK
lin chickpea_N = mkWN (compoundN "kahvi" (k48 "herne")) ; --UNCHK
lin chickweed_N = mkWN (k5A "härkki") ; --UNCHK
lin chicle_N = mkWN (compoundN "chicle" (k5 "kumi")) ; --UNCHK
lin chicory_N = mkWN (k6 "sikuri") ; --UNCHK
lin chide_V = mkWV (k73 "saarnata") ; --UNCHK
lin chide_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin chiding_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin chief_A = mkA "johtava" ;
lin chief_N = mkN "päällikkö" ;
lin chieftainFem_N = mkWN (k4A "päällikkö") ; --UNCHK
lin chieftainMasc_N = mkWN (k4A "päällikkö") ; --UNCHK
lin chieftaincy_N = mkWN (k40 "päällikkyys") ; --UNCHK
lin chiffon_N = mkWN (k5A "sifonki") ; --UNCHK
lin chiffonier_N = mkWN (k2 "lipasto") ; --UNCHK
lin chignon_N = mkWN (k12 "nuttura") ; --UNCHK
lin chigoe_N = mkWN (compoundN "hieta" (k1A "kirppu")) ; --UNCHK
lin chilblain_N = mkWN (compoundN "kylmän" (k1 "kyhmy")) ; --UNCHK
lin chilblained_A = mkWA "kylmänkyhmy-" ; --UNCHK
lin child's_play_N = mkWN (k5A "leikki") ; --UNCHK
lin child_N = L.child_N ;
lin childbearing_A = mkWA (k38 "hedelmällinen") ; --UNCHK
lin childbirth_N = mkWN (k39 "synnytys") ; --UNCHK
lin childcare_N = mkWN (compoundN "lasten" (k1A "hoito")) ; --UNCHK
lin childhood_N = mkWN (k40 "lapseus") ; --UNCHK
lin childish_A = mkWA (k41A "lapsekas") ; --UNCHK
lin childishness_N = mkWN (k40 "lapsellisuus") ; --UNCHK
lin childless_A = mkWA (k34A "lapseton") ; --UNCHK
lin childlessness_N = mkWN (k40 "lapsettomuus") ; --UNCHK
lin childlike_A = mkWA (compoundA "lapsen" (k38 "omainen")) ; --UNCHK
lin chile_PN = foreignPN "Chile" ;
lin chileanFem_N = mkWN "chileläinen" ; --UNCHK
lin chileanMasc_N = mkWN "chileläinen" ; --UNCHK
lin chilean_A = mkWA "chileläinen" ; --UNCHK
lin chili_N = mkWN (k5 "chili") ; --UNCHK
lin chill_N = mkWN (k40 "kylmyys") ; --UNCHK
lin chill_V = mkWV (k52A "kylmentyä") ; --UNCHK
lin chill_V2 = mkWV2 (k52A "kylmentyä") ; --UNCHK
lin chill_out_V = mkWV (k52A "rentoutua") ; --UNCHK
lin chilliness_N = mkWN (k40 "etäisyys") ; --UNCHK
lin chilly_A = mkA "viileä" ;
lin chilly_N = mkWN (compoundN "asu" (k38 "ttaminen")) "uudelleen" ; --UNCHK
lin chimaera_N = mkWN "Chimaera" ; --UNCHK
lin chime_N = mkWN (k1 "kello") ; --UNCHK
lin chime_V = mkWV (k62 "soida") ; --UNCHK
lin chime_V2 = mkWV2 (k62 "soida") ; --UNCHK
lin chime_in_V = mkWV (k52A "sekaantua") ; --UNCHK
lin chimera_N = mkWN (compoundN "kauhu" (k10 "kuva")) ; --UNCHK
lin chimeric_A = mkWA (k38 "mielikuvituksellinen") ; --UNCHK
lin chimerical_A = mkWA (k38 "mielikuvituksellinen") ; --UNCHK
lin chimney_N = mkWN (compoundN "savu" (k1A "piippu")) ; --UNCHK
lin chimneypiece_N = mkWN (compoundN "takka" (k1 "hylly")) ; --UNCHK
lin chimneypot_N = mkWN (k39 "jatkos") "savupiipun" ; --UNCHK
lin chimneystack_N = mkWN (compoundN "savupiippu" (k10 "ryhmä")) ; --UNCHK
lin chimney_sweep_N = mkWN (k10 "nuohooja") ; --UNCHK
lin chimneysweeper_N = mkWN (k10 "nuohooja") ; --UNCHK
lin chimp_N = mkWN (k5 "simpanssi") ; --UNCHK
lin chimpanzee_N = mkWN (k5 "simpanssi") ; --UNCHK
lin chin_N = mkWN (k9A "leuka") ; --UNCHK
lin chin_strap_N = mkWN (compoundN "leuka" (k9 "hihna")) ; --UNCHK
lin chin_wagging_N = mkWN (k39 "pälpätys") ; --UNCHK
lin china_N = mkWN (k6 "posliini") ; --UNCHK
lin china_PN = mkPN "Kiina" ;
lin china_closet_N = mkWN (compoundN "astia" (k5A "kaappi")) ; --UNCHK
lin chinaberry_N = mkWN "Melia" "azedarach" ; --UNCHK
lin chinaware_N = mkWN (k6 "posliini") ; --UNCHK
lin chincapin_N = mkWN (compoundN "kääpiö" (k12 "kastanja")) ; --UNCHK
lin chincherinchee_N = mkWN (compoundN "afrikan" (k9 "lilja")) ; --UNCHK
lin chinchilla_N = mkWN (k9 "sinsilla") ; --UNCHK
lin chine_N = mkWN (compoundN "selkä" (k9A "ranka")) ; --UNCHK
lin chineseFem_N = mkN "kiinalainen" | mkN "kiinatar" ;
lin chineseMasc_N = mkN "kiinalainen" ;
lin chinese_A = mkWA (k38 "kiinalainen") ;
lin chink_N = mkWN (k39 "kilahdus") ; --UNCHK
lin chink_V = mkWV (k53A "aiheuttaa") "halkeama" ; --UNCHK
lin chink_V2 = mkWV2 (k53A "aiheuttaa") "halkeama" ; --UNCHK
lin chinless_A = mkWA "leuaton" ; --UNCHK
lin chino_N = mkWN (k41A "tvillikangas") "vahva" ; --UNCHK
lin chinoiserie_N = mkWN "chinoiserie" ; --UNCHK
lin chinook_N = mkWN (compoundN "kuningas" (k23 "lohi")) ; --UNCHK
lin chintz_N = mkWN (k5 "sintsi") ; --UNCHK
lin chip_N = mkN "hippu" ;
lin chip_V = mkWV (k74 "loveta") ; --UNCHK
lin chip_V2 = mkWV2 (k74 "loveta") ; --UNCHK
lin chip_away_V = mkWV (k56 "kalvaa") ; --UNCHK
lin chip_away_at_V2 = mkWV2 (k56 "kalvaa") ; --UNCHK
lin chipboard_N = mkWN (k50 "kovalevy") ; --UNCHK
lin chipmunk_N = mkWN (compoundN "maa" (k10 "orava")) ; --UNCHK
lin chipolata_N = mkWN (compoundN "chipo" (k9A "lata")) ; --UNCHK
lin chipotle_N = mkWN "chipotle" ; --UNCHK
lin chippendale_N = mkWN (k8 "Chippendale") "Thomas" ; --UNCHK
lin chippenham_PN = foreignPN "Chippenham" ;
lin chipper_A = mkWA (k38 "herttainen") ; --UNCHK
lin chiralgia_N = mkWN (compoundN "käsi" (k1A "kipu")) ; --UNCHK
lin chiromantic_A = mkWA "kädestäennustamiseen" "liittyvä" ; --UNCHK
lin chiropodist_N = mkWN (compoundN "jalka" (k10 "hoitaja")) ; --UNCHK
lin chiropody_N = mkWN (compoundN "jalkojen" (k1A "hoito")) ; --UNCHK
lin chiropractic_N = mkWN (k9A "kiropraktiikka") ; --UNCHK
lin chiropractor_N = mkWN (k4A "kiropraktikko") ; --UNCHK
lin chirp_N = mkWN (k39 "siritys") ; --UNCHK
lin chirp_V = mkWV (k53A "sirittää") ; --UNCHK
lin chirp_V2 = mkWV2 (k53A "sirittää") ; --UNCHK
lin chirpiness_N = mkWN (k40 "hilpeys") ; --UNCHK
lin chirpy_A = mkWA (compoundA "viserte" (k10 "levä")) ; --UNCHK
lin chirrup_N = mkWN (k39 "sirkutus") ; --UNCHK
lin chirrup_V = mkWV (k53A "sirittää") ; --UNCHK
lin chirrup_V2 = mkWV2 (k53A "sirittää") ; --UNCHK
lin chisel_N = mkWN (k9A "taltta") ; --UNCHK
lin chisel_V2 = mkWV2 (k54A "kaivertaa") ; --UNCHK
lin chiseled_A = mkWA (compoundA "selkeä" (k38 "piirteinen")) ; --UNCHK
lin chiseller_N = mkWN (k6 "petturi") ; --UNCHK
lin chit_N = mkWN (k5A "piikki") ; --UNCHK
lin chit_chat_N = mkWN (k39 "pälpätys") ; --UNCHK
lin chitchat_N = mkWN (k39 "pälpätys") ; --UNCHK
lin chitin_N = mkWN (k6 "kitiini") ; --UNCHK
lin chitinous_A = mkWA (compoundA "kitiini" (k38 "mäinen")) ; --UNCHK
lin chiton_N = mkWN (compoundN "nivel" (k2 "kotilo")) ; --UNCHK
lin chivalric_A = mkWA (k38 "ritarillinen") ; --UNCHK
lin chivalrous_A = mkWA (k41 "kohtelias") ; --UNCHK
lin chivalry_N = mkWN (k40 "huomaavaisuus") ; --UNCHK
lin chive_N = mkWN (k9A "ruoholaukka") ; --UNCHK
lin chives_N = mkWN (compoundN "ruoho" (k6 "sipuli")) ; --UNCHK
lin chivvy_V2 = mkWV2 (k53A "hätyyttää") ; --UNCHK
lin chlamydeous_A = mkWA (compoundA "kehä" (k38 "mäinen")) ; --UNCHK
lin chlamydia_N = mkWN (k12 "klamydia") ; --UNCHK
lin chlamydial_A = mkWA "klamydian" ; --UNCHK
lin chlamydospore_N = mkWN (compoundN "kätkö" (k3 "itiö")) ; --UNCHK
lin chlamys_N = mkWN (k10 "stoola") ; --UNCHK
lin chloasma_N = mkWN (compoundN "maksa" (k10A "läikkä")) ; --UNCHK
lin chlorambucil_N = mkWN (k5 "klorambusiili") ; --UNCHK
lin chloramine_N = mkWN "kloramiini-T" ; --UNCHK
lin chloramphenicol_N = mkWN "Chloromycetin" ; --UNCHK
lin chlorate_N = mkWN "kloraatti" ; --UNCHK
lin chlordiazepoxide_N = mkWN (compoundN "klooridiatsep" (k5 "oksidi")) ; --UNCHK
lin chlorella_N = mkWN "Chlorella" ; --UNCHK
lin chlorenchyma_N = mkWN "fotosynteettinen" "parenkyymi" ; --UNCHK
lin chlorhexidine_N = mkWN "klooriheksidiini" ; --UNCHK
lin chloride_N = mkWN "kloridi" ; --UNCHK
lin chlorinate_V2 = mkWV2 (k73 "kloorata") ; --UNCHK
lin chlorination_N = mkWN (k39 "klooraus") ; --UNCHK
lin chlorine_N = mkWN (k5 "kloori") ; --UNCHK
lin chlorinity_N = mkWN (compoundN "kloridi" (k40 "pitoisuus")) ; --UNCHK
lin chlorite_N = mkWN (compoundN "klo" (k5A "riitti")) ; --UNCHK
lin chloroacetophenone_N = mkWN (compoundN "CN-" (k1 "kaasu")) ; --UNCHK
lin chlorobenzene_N = mkWN "klooribentseeni" ; --UNCHK
lin chlorobenzylidenemalononitrile_N = mkWN (compoundN "CS-" (k1 "kaasu")) ; --UNCHK
lin chlorofluorocarbon_N = mkWN (k5 "freoni") ; --UNCHK
lin chloroform_N = mkWN (compoundN "trikloro" (k5 "metaani")) ; --UNCHK
lin chlorophyll_N = mkWN (k5 "klorofylli") ; --UNCHK
lin chlorophyllose_A = mkWA "klorofylli-" ; --UNCHK
lin chloropicrin_N = mkWN (compoundN "trikloorinitro" (k5 "metaani")) ; --UNCHK
lin chloroplast_N = mkWN (compoundN "viher" (k38 "hiukkanen")) ; --UNCHK
lin chloroprene_N = mkWN "kloropreeni" ; --UNCHK
lin chloroquine_N = mkWN (compoundN "kloroki" (k26 "niini")) ; --UNCHK
lin chlorosis_N = mkWN (compoundN "kalvetus" (k5A "tauti")) ; --UNCHK
lin chlorothiazide_N = mkWN "Diuril" ; --UNCHK
lin chlorotic_A = mkWA (k38 "aneeminen") ; --UNCHK
lin chlorpromazine_N = mkWN "Thorazine" ; --UNCHK
lin chlorpyrifos_N = mkWN (compoundN "klorpyrif" (k5 "ossi")) ; --UNCHK
lin chlortetracycline_N = mkWN (compoundN "kloori" (k5 "tetrasykliini")) ; --UNCHK
lin chlorthalidone_N = mkWN "Thalidone" ; --UNCHK
lin choanocyte_N = mkWN (compoundN "kaulussiima" (k1 "solu")) ; --UNCHK
lin choc_N = mkWN (k17 "suklaa") ; --UNCHK
lin chock_Adv = mkWAdv (k99 "kukkuroillaan") ; --UNCHK
lin chock_N = mkWN (k9 "kiila") ; --UNCHK
lin chock_V2 = mkWV2 (k53A "pönkittää") ; --UNCHK
lin chocolate_N = mkN "suklaa" ;
lin choice_A = mkWA (k38 "erinomainen") ; --UNCHK
lin choice_N = mkN "valinta" ;
lin choir_N = mkN "kuoro" ; ---ARB mkWN (kH1 "kuori") ; --UNCHK
lin choir_school_N = mkWN (compoundN "katedraali" (k1 "koulu")) ; --UNCHK
lin choirboy_N = mkWN (compoundN "kuori" (k10A "poika")) ; --UNCHK
lin choirmaster_N = mkWN (k6 "kanttori") ; --UNCHK
lin choke_N = mkWN (compoundN "kuristus" (k6 "venttiili")) ; --UNCHK
lin choke_V = mkWV (k52A "tukahtua") ; --UNCHK
lin choke_V2 = mkWV2 (k52A "tukahtua") ; --UNCHK
lin choke_off_V2 = mkWV2 (k53A "laannuttaa") ; --UNCHK
lin choke_up_V = mkWV (k61A "tukkia") ; --UNCHK
lin choke_up_V2 = mkWV2 (k61A "tukkia") ; --UNCHK
lin chokecherry_N = mkWN (compoundN "virginian" (k25 "tuomi")) ; --UNCHK
lin choke_damp_N = mkWN (compoundN "kaivos" (k1 "kaasu")) ; --UNCHK
lin chokehold_N = mkWN (compoundN "kuristus" (k48A "ote")) ; --UNCHK
lin chokepoint_N = mkWN (compoundN "pullon" (k9 "kaula")) ; --UNCHK
lin choker_N = mkWN (k39 "kaulus") "korkea" ; --UNCHK
lin chokey_N = mkWN (k10 "tyrmä") ; --UNCHK
lin choking_N = mkWN (compoundN "kuri" (k38 "staminen")) ; --UNCHK
lin choky_A = mkWA "kuristava" ; --UNCHK
lin choky_N = mkWN (k10 "tyrmä") ; --UNCHK
lin cholangiography_N = mkWN (compoundN "kol" (k12 "angiografia")) ; --UNCHK
lin cholangitis_N = mkWN (compoundN "sappitie" (k39 "tulehdus")) ; --UNCHK
lin cholecystectomy_N = mkWN (k1 "poisto") "sappirakon" ; --UNCHK
lin cholecystitis_N = mkWN (compoundN "kole" (k5A "kystiitti")) ; --UNCHK
lin cholecystokinin_N = mkWN (compoundN "kolekystoki" (k26 "niini")) ; --UNCHK
lin cholelithiasis_N = mkWN (compoundN "sappikivi" (k5A "tauti")) ; --UNCHK
lin cholelithotomy_N = mkWN (k1 "poisto") "sappikiven" ; --UNCHK
lin choler_N = mkWN (k7A "sappi") ; --UNCHK
lin cholera_N = mkWN (k12 "kolera") ; --UNCHK
lin choleraic_A = mkWA "koleran" ; --UNCHK
lin choleric_A = mkWA (k14A "ärhäkkä") ; --UNCHK
lin cholesterol_N = mkWN (k5 "kolesteroli") ; --UNCHK
lin choline_N = mkWN "koliini" ; --UNCHK
lin cholinergic_A = mkWA "kolinerginen" ; --UNCHK
lin cholinesterase_N = mkWN (compoundN "koliiniester" (k5 "aasi")) ; --UNCHK
lin cholla_N = mkWN "Opuntia" "cholla" ; --UNCHK
lin chomping_N = mkWN (k39 "rouskutus") ; --UNCHK
lin chon_N = mkWN "chon" ; --UNCHK
lin chondrin_N = mkWN "kondriini" ; --UNCHK
lin chondrite_N = mkWN (compoundN "kond" (k5A "riitti")) ; --UNCHK
lin chondritic_A = mkWA (k38 "rakeinen") ; --UNCHK
lin chondroma_N = mkWN (compoundN "rusto" (k33 "kasvain")) ; --UNCHK
lin chondrosarcoma_N = mkWN (compoundN "kondro" (k10 "sarkooma")) ; --UNCHK
lin chondrule_N = mkWN "kondri" ; --UNCHK
lin choose_V2 = mkV2 "valita" ;
lin choose_VV = mkVV "päättää" ;
lin choose_up_V = mkWV (k69 "valita") "joukkueet" ; --UNCHK
lin choose_up_V2 = mkWV2 (k69 "valita") "joukkueet" ; --UNCHK
lin choosey_A = mkWA (k6 "ronkeli") ; --UNCHK
lin choosy_A = mkWA (k6 "ronkeli") ; --UNCHK
lin chop_V = mkWV (k58 "iskeä") ; --UNCHK
lin chop_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin chop_down_V2 = mkWV2 (k57A "kaataa") ; --UNCHK
lin chop_off_V = mkWV (k52 "katkoa") ; --UNCHK
lin chop_suey_N = mkWN "chop" "suey" ; --UNCHK
lin chop_up_V2 = mkWV2 (k52A "pilkkoa") ; --UNCHK
lin chopine_N = mkWN (k10A "kenkä") "korokepohjainen" ; --UNCHK
lin choppiness_N = mkWN (k24 "meri") "myrskyinen" ; --UNCHK
lin choppy_A = mkWA "vellova" ; --UNCHK
lin chopstick_N = mkWN (k1A "puikko") ; --UNCHK
lin choragic_A = mkWA "kuoronjohtajan" ; --UNCHK
lin choragus_N = mkWN (compoundN "kuoron" (k10 "johtaja")) ; --UNCHK
lin choral_A = mkWA "kuorolaulu-" ; --UNCHK
lin chorale_N = mkWN (k5 "koraali") ; --UNCHK
lin chord_N = mkWN (k1A "sointu") ; --UNCHK
lin chordal_A = mkWA (k41A "soinnukas") ; --UNCHK
lin chordamesoderm_N = mkWN (compoundN "selkä" (k48A "jänne")) ; --UNCHK
lin chordate_N = mkWN (compoundN "selkä" (k38 "jänteinen")) ; --UNCHK
lin chorditis_N = mkWN (k39 "tulehdus") "äänijänteiden" ; --UNCHK
lin chordophone_N = mkWN "kordofoni" ; --UNCHK
lin chore_N = mkWN (k25 "toimi") ;
lin chorea_N = mkWN (compoundN "tanssi" (k5A "tauti")) ; --UNCHK
lin choreographer_N = mkWN (k5 "koreografi") ; --UNCHK
lin choreographic_A = mkWA (k38 "koreografinen") ; --UNCHK
lin choreography_N = mkWN (k12 "koreografia") ; --UNCHK
lin choric_A = mkWA "kuorolausunta-" ; --UNCHK
lin chorioallantois_N = mkWN (k1 "kalvo") "korioallantoinen" ; --UNCHK
lin choriomeningitis_N = mkWN "koriomeningiitti" ; --UNCHK
lin chorion_N = mkWN (compoundN "suoni" (k1 "kalvo")) "sikiön" ; --UNCHK
lin chorionic_A = mkWA "korionin" ; --UNCHK
lin chorister_N = mkWN (k38 "kuorolainen") ; --UNCHK
lin chorizo_N = mkWN "chorizo" ; --UNCHK
lin chorley_PN = foreignPN "Chorley" ;
lin choroid_N = mkWN (compoundN "suoni" (k1 "kalvo")) ; --UNCHK
lin chortle_N = mkWN (k39 "hihitys") ; --UNCHK
lin chortle_V = mkWV (k67A "myhähdellä") ; --UNCHK
lin chorus_N = mkN "kuoro" ; ---ARB --mkWN (compoundN "kerto" (k48A "säe")) ;
lin chorus_V2 = mkWV2 (k52 "lausua") "kuorossa" ; --UNCHK
lin chorus_girl_N = mkWN (compoundN "tanssi" (k1A "tyttö")) ; --UNCHK
lin chosen_A = variants {} ; --
lin chough_N = mkWN (compoundN "alppi" (k39 "varis")) ; --UNCHK
lin chow_N = mkWN "kiinanpystykorva" ; --UNCHK
lin chowchow_N = mkWN (compoundN "hedelmä" (k1 "hillo")) "kiinalainen" ; --UNCHK
lin chowder_N = mkWN (compoundN "kala" (k1A "keitto")) "suurustettu" ; --UNCHK
lin chrestomathy_N = mkWN "krestomatia" ; --UNCHK
lin chrism_N = mkWN (k6 "mirhami") ; --UNCHK
lin christchurch_PN = foreignPN "Christchurch" ;
lin christella_N = mkWN "Christella" ; --UNCHK
lin christen_V2 = mkWV2 (k61 "ristiä") ; --UNCHK
lin christendom_N = mkWN (k40 "kristillisyys") ; --UNCHK
lin christening_N = mkWN (k48 "kaste") ; --UNCHK
lin christian_A = mkWA (k1A "kristitty") ;
lin christian_N = mkWN (k1A "kristitty") ; --UNCHK
lin christianity_N = mkWN (k1 "usko") "kristillinen" ; --UNCHK
lin christianly_A = mkWA (k38 "kristillinen") ; --UNCHK
lin christless_A = mkWA (compoundA "ei-" (k1A "kristitty")) ; --UNCHK
lin christlike_A = mkWA (k38 "kaltainen") "Kristuksen" ; --UNCHK
lin christmas_N = mkWN (k1 "joulu") ; --UNCHK
lin christmas_PN = foreignPN "Christmas" ;
lin christmas_box_N = mkWN (compoundN "joulu" (k9 "raha")) ; --UNCHK
lin christmas_tree_N = mkWN (k24 "joulukuusi") ; --UNCHK
lin christmastide_N = mkWN (k9A "joulunaika") ; --UNCHK
lin christmastime_N = mkWN (k9A "joulunaika") ; --UNCHK
lin christopher_PN = foreignPN "Christopher" ;
lin chromate_N = mkWN "kromaatti" ; --UNCHK
lin chromatic_A = mkWA "väri-" ; --UNCHK
lin chromatid_N = mkWN "kromatidi" ; --UNCHK
lin chromatin_N = mkWN "kromatiini" ; --UNCHK
lin chromatinic_A = mkWA "kromatiininen" ; --UNCHK
lin chromatogram_N = mkWN "kromatogrammi" ; --UNCHK
lin chromatographic_A = mkWA "kromatografian" ; --UNCHK
lin chromatography_N = mkWN "kromatografia" ; --UNCHK
lin chrome_N = mkWN (k5 "kromi") ; --UNCHK
lin chromesthesia_N = mkWN "chromaesthesia" ; --UNCHK
lin chromite_N = mkWN "kromiitti" ; --UNCHK
lin chromium_N = mkWN (k5 "kromi") ; --UNCHK
lin chromoblastomycosis_N = mkWN "kromoblastomykoosi" ; --UNCHK
lin chromogen_N = mkWN (compoundN "kromo" (k5 "geeni")) ; --UNCHK
lin chromolithography_N = mkWN (compoundN "väri" (k12 "litografia")) ; --UNCHK
lin chromophore_N = mkWN (compoundN "kromof" (k48 "ori")) ; --UNCHK
lin chromoplast_N = mkWN (compoundN "kromop" (k5 "lasti")) ; --UNCHK
lin chromosomal_A = mkWA "kromosomin" ; --UNCHK
lin chromosome_N = mkWN (k5 "kromosomi") ; --UNCHK
lin chromosphere_N = mkWN (compoundN "kromosf" (k26 "ääri")) ; --UNCHK
lin chronic_A = mkWA (k38 "krooninen") ; --UNCHK
lin chronicle_N = mkWN (k39 "selostus") ; --UNCHK
lin chronicle_V2 = mkWV2 (k69 "merkitä") "aikakirjoihin" ; --UNCHK
lin chronicler_N = mkWN (k12 "kronikoitsija") ; --UNCHK
lin chronograph_N = mkWN "kronografi" ; --UNCHK
lin chronological_A = mkWA (k38 "kronologinen") ; --UNCHK
lin chronology_N = mkWN (k12 "kronologia") ; --UNCHK
lin chronometer_N = mkWN (k5 "kronometri") ; --UNCHK
lin chronoscope_N = mkWN (compoundN "kronosko" (k5A "oppi")) ; --UNCHK
lin chrysalis_N = mkWN (k2 "kotelo") ; --UNCHK
lin chrysoberyl_N = mkWN (compoundN "kryso" (k5 "berylli")) ; --UNCHK
lin chrysolite_N = mkWN "krysoliitti" ; --UNCHK
lin chrysoprase_N = mkWN (compoundN "krysopr" (k5 "aasi")) ; --UNCHK
lin chrysotherapy_N = mkWN (compoundN "kulta" (k1A "hoito")) ; --UNCHK
lin chrysotile_N = mkWN (compoundN "kryso" (k23 "tiili")) ; --UNCHK
lin chthonian_A = mkWA (compoundA "maan" (k38 "alainen")) ; --UNCHK
lin chub_N = mkWN (kH1 "turpa") ; --UNCHK
lin chubbiness_N = mkWN (k40 "pyylevyys") ; --UNCHK
lin chubby_A = mkWA (k10 "pulska") ; --UNCHK
lin chuck_N = mkWN (compoundN "leuka" (k14A "istukka")) ; --UNCHK
lin chuck_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin chuck_out_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin chuckle_N = mkWN (k39 "hihitys") ; --UNCHK
lin chuckle_V = mkWV (k67A "myhähdellä") ; --UNCHK
lin chuckle_VS = mkWVS (k67A "myhähdellä") ; --UNCHK
lin chufa_N = mkWN (compoundN "maa" (k6 "manteli")) ; --UNCHK
lin chuffed_A = mkWA (k99 "mielissään") ; --UNCHK
lin chug_N = mkWN (k39 "sätkätys") ; --UNCHK
lin chug_V = mkWV (k53A "puksuttaa") ; --UNCHK
lin chukka_N = mkWN (compoundN "chukka-" (k48 "jalkine")) ; --UNCHK
lin chukker_N = mkWN (k10 "erä") "poolopelin" ; --UNCHK
lin chum_N = mkWN (compoundN "koira" (k23 "lohi")) ; --UNCHK
lin chumminess_N = mkWN (k40 "ystävyys") ; --UNCHK
lin chump_N = mkWN (k6 "tomppeli") ; --UNCHK
lin chunk_N = mkN "palanen" ;
lin chunky_A = mkWA (k38 "paakkuinen") ; --UNCHK
lin chunnel_N = mkWN (k6 "tunneli") "Kanaalin" ; --UNCHK
lin church_N = L.church_N ;
lin churchgoer_N = mkWN (k32 "jäsen") "kirkon" ; --UNCHK
lin churchgoing_A = mkWA (k10 "käyvä") "kirkossa" ; --UNCHK
lin churchly_A = mkWA (k38 "kirkollinen") ; --UNCHK
lin churchman_N = mkWN (k5A "pappi") ; --UNCHK
lin churchwarden_N = mkWN (compoundN "kirkon" (k10A "isäntä")) ; --UNCHK
lin churchyard_N = mkWN (compoundN "hautaus" (k18 "maa")) ; --UNCHK
lin churl_N = mkWN (k12 "kiukuttelija") ; --UNCHK
lin churlish_A = mkWA (k15 "äreä") ; --UNCHK
lin churn_N = mkWN (k1 "kirnu") ; --UNCHK
lin churn_V = mkWV (k54A "hämmentää") ; --UNCHK
lin churn_V2 = mkWV2 (k54A "hämmentää") ; --UNCHK
lin churn_out_V2 = mkWV2 (k53A "syytää") "ulos" ; --UNCHK
lin chute_N = mkWN (k10 "kuurna") ; --UNCHK
lin chutney_N = mkWN "Indian" "relish" ; --UNCHK
lin chutzpa_N = mkWN "hutzpah" ; --UNCHK
lin chutzpanik_N = mkWN (k6 "öykkäri") ; --UNCHK
lin chylaceous_A = mkWA "maitiaisnesteen" ; --UNCHK
lin chyle_N = mkWN (compoundN "maitiais" (k48 "neste")) ; --UNCHK
lin chyliferous_A = mkWA "maitiaisnestettä" "kuljettava" ; --UNCHK
lin chylific_A = mkWA (k10 "tuottava") "maitiaisnestettä" ; --UNCHK
lin chylomicron_N = mkWN (compoundN "kylo" (k5 "mikroni")) ; --UNCHK
lin chyme_N = mkWN (compoundN "ruoka" (k10 "sula")) ; --UNCHK
lin cia_N = mkWN (compoundN "tiedustelu" (k2 "palvelu")) "Yhdysvaltain" ; --UNCHK
lin cicatrice_N = mkWN (k7A "arpi") ; --UNCHK
lin cicatrix_N = mkWN (k7A "arpi") ; --UNCHK
lin cicero_N = mkWN (compoundN "Cic" (k1 "ero")) "Marcus" "Tullius" ; --UNCHK
lin cicerone_N = mkWN (compoundN "matkailu" (k41A "opas")) ; --UNCHK
lin cichlid_N = mkWN (compoundN "kirjo" (k32 "ahven")) ; --UNCHK
lin cid_N = mkWN "CID" ; --UNCHK
lin cider_N = mkWN (k6 "siideri") ; --UNCHK
lin ciderpress_N = mkWN "omenapuristamo" ; --UNCHK
lin cigar_N = mkWN (k6 "sikari") ; --UNCHK
lin cigarette_N = mkN "savuke" ;
lin cigarette_case_N = mkWN (compoundN "savuke" (k2 "kotelo")) ; --UNCHK
lin cigarette_holder_N = mkWN (k48A "imuke") ; --UNCHK
lin cigarette_paper_N = mkWN (compoundN "savuke" (k6 "paperi")) ; --UNCHK
lin cigarillo_N = mkWN (compoundN "pikku" (k6 "sikari")) ; --UNCHK
lin ciliate_N = mkWN (compoundN "alku" (k33 "eläin")) "värekarvallinen" ; --UNCHK
lin cilium_N = mkWN (compoundN "väre" (k9 "karva")) ; --UNCHK
lin cinch_N = mkWN "cinch" ; --UNCHK
lin cinch_V2 = mkWV2 (k69 "hallita") ; --UNCHK
lin cinchona_N = mkWN (compoundN "kiina" (k18 "puu")) ; --UNCHK
lin cinchonine_N = mkWN (compoundN "kinko" (k26 "niini")) ; --UNCHK
lin cincinnati_PN = foreignPN "Cincinnati" ;
lin cincture_N = mkWN (k19 "vyö") ; --UNCHK
lin cinder_N = mkWN (k10 "kuona") ; --UNCHK
lin cinder_track_N = mkWN (compoundN "hiilimurska" (k9A "rata")) ; --UNCHK
lin cinderella_N = mkWN (compoundN "Tuh" (k1 "kimo")) ; --UNCHK
lin cinderford_PN = foreignPN "Cinderford" ;
lin cine_projector_N = mkWN (compoundN "filmi" (k6 "projektori")) ; --UNCHK
lin cinema_N = mkWN (compoundN "elokuva" (k6 "teatteri")) ;
lin cinematic_A = mkWA "filmi-" ; --UNCHK
lin cinematography_N = mkWN (k39 "kuvaus") ; --UNCHK
lin cineraria_N = mkWN (k12 "sineraria") ; --UNCHK
lin cinerary_A = mkWA "tuhka-" ; --UNCHK
lin cingulum_N = mkWN "cingulum" ; --UNCHK
lin cinnabar_N = mkWN "Callimorpha" "jacobeae" ; --UNCHK
lin cinnamon_N = mkWN (k6 "kaneli") ; --UNCHK
lin cinquefoil_N = mkWN (k48A "ruusuke") ; --UNCHK
lin cipher_N = mkWN (compoundN "salakirjoitus" (k5 "viesti")) ; --UNCHK
lin cipher_V = mkWV (k58 "laskea") ; --UNCHK
lin cipher_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin ciprofloxacin_N = mkWN "Cipro" ; --UNCHK
lin circa_Prep = mkPrep "noin" nominative ;
lin circadian_A = mkWA "vuorokausi-" ; --UNCHK
lin circle_N = mkWN (k39 "kierros") ; --UNCHK
lin circle_V = mkWV (k62 "ympyröidä") ; --UNCHK
lin circle_V2 = mkWV2 (k62 "ympyröidä") ; --UNCHK
lin circlet_N = mkWN (k9A "otsaripa") ; --UNCHK
lin circuit_N = mkWN (k39 "kierros") ; --f57
lin circuitous_A = mkWA (k10 "poikkeava") ; --UNCHK
lin circuitry_N = mkWN (k5 "piiri") ; --UNCHK
lin circular_A = mkWA (k15 "pyöreä") ; --UNCHK
lin circular_N = mkWN (k38 "lehtinen") ; --UNCHK
lin circularity_N = mkWN (compoundN "ympyrän" (k40 "muotoisuus")) ; --UNCHK
lin circularization_N = mkWN (compoundN "joukko" (k39 "postitus")) ; --UNCHK
lin circularize_V2 = mkWV2 (k53 "pyöristää") ; --UNCHK
lin circulate_V = mkV "kiertää" ;
lin circulate_V2 = mkV2 "levittää" partitive ; --mkWV2 (k53A "kierrättää") ;
lin circulation_N = mkWN (k2 "jakelu") ;
lin circulative_A = mkWA "kierron" ; --UNCHK
lin circulatory_A = mkWA "verenkierto-" ; --UNCHK
lin circumcise_V2 = mkWV2 (compoundV "ympäri" (k73A "leikata")) ; --UNCHK
lin circumcision_N = mkWN (compoundN "ympäri" (k39 "leikkaus")) ; --UNCHK
lin circumduction_N = mkWN "sirkumduktio" ; --UNCHK
lin circumference_N = mkWN (k10 "kehä") ; --UNCHK
lin circumferential_A = mkWA "ympärys-" ; --UNCHK
lin circumflex_N = mkWN (k5 "sirkumfleksi") ; --UNCHK
lin circumlocution_N = mkWN (k39 "ilmaus") "epäsuora" ; --UNCHK
lin circumlocutious_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin circumnavigate_V2 = mkWV2 (k54A "kiertää") ; --UNCHK
lin circumnavigation_N = mkWN (compoundN "ympäri" (k39 "purjehdus")) ; --UNCHK
lin circumpolar_A = mkWA (k99 "ympärillä") "navan" ; --UNCHK
lin circumscribe_V2 = mkWV2 (k53A "rajoittaa") ; --UNCHK
lin circumscription_N = mkWN "rajoittaminen" ; --UNCHK
lin circumspect_A = mkWA (k38 "varovainen") ; --UNCHK
lin circumspection_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin circumstance_N = mkN "olosuhde" ;
lin circumstances_N = mkWN (k10 "asema") "taloudellinen" ; --UNCHK
lin circumstantial_A = mkWA (compoundA "sei" (k38 "kkaperäinen")) ; --UNCHK
lin circumvent_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin circumvention_N = mkWN "kiertäminen" ; --UNCHK
lin circumvolution_N = mkWN "pyöriminen" ; --UNCHK
lin circus_N = mkWN (k39 "sirkus") ; --UNCHK
lin cirencester_PN = foreignPN "Cirencester" ;
lin cirque_N = mkWN (compoundN "kattila" (k1 "laakso")) ; --UNCHK
lin cirrhosis_N = mkWN (k5 "kirroosi") ; --UNCHK
lin cirrocumulus_N = mkWN (compoundN "pallero" (k7 "pilvi")) ; --UNCHK
lin cirrostratus_N = mkWN (compoundN "harso" (k7 "pilvi")) ; --UNCHK
lin cirrus_N = mkWN (k9 "siima") ; --UNCHK
lin cisalpine_A = mkWA (compoundA "etelä" (k38 "puolinen")) "Alppien" ; --UNCHK
lin cisco_N = mkWN (k9A "siika") ; --UNCHK
lin cissy_A = mkWA (k38 "feminiininen") ; --UNCHK
lin cistern_N = mkWN (compoundN "vesi" (k3 "säiliö")) ; --UNCHK
lin cisterna_N = mkWN (k3 "säiliö") ; --UNCHK
lin citadel_N = mkWN (k39 "linnoitus") ; --UNCHK
lin citation_N = mkWN "Citation" ; --UNCHK
lin cite_V2 = mkV2 "lainata" partitive ;
lin citified_A = mkWA (k38 "kaupunkilainen") ; --UNCHK
lin citizenFem_N = mkN "kansalainen" ;
lin citizenMasc_N = mkN "kansalainen" ;
lin citizenry_N = mkWN (k2 "väestö") ; --UNCHK
lin citizenship_N = mkWN (compoundN "kansalais" (k7A "henki")) ; --UNCHK
lin citrate_N = mkWN "sitraatti" ; --UNCHK
lin citric_A = mkWA "sitruunahappo-" ; --UNCHK
lin citrine_N = mkWN "sitriini" ; --UNCHK
lin citron_N = mkWN (compoundN "sukaatti" (k13 "sitruuna")) ; --UNCHK
lin citronwood_N = mkWN (compoundN "sanda" (k5A "rakki")) ; --UNCHK
lin citrous_A = mkWA "sitrus-" ; --UNCHK
lin citrulline_N = mkWN "sitrulliini" ; --UNCHK
lin citrus_N = mkWN (compoundN "sitrus" (k10 "hedelmä")) ; --UNCHK
lin cittern_N = mkWN (k9 "sitra") ; --UNCHK
lin city_N = L.city_N ;
lin cityscape_N = mkWN (compoundN "kaupunki" (k10 "maisema")) ; --UNCHK
lin citywide_A = mkWA (k38 "laajuinen") "kaupungin" ; --UNCHK
lin civet_N = mkWN (compoundN "sivetti" (k33 "eläin")) ; --UNCHK
lin civet_cat_N = mkWN (compoundN "sivetti" (k33 "eläin")) ; --UNCHK
lin civic_A = mkWA "kansalais-" ; --UNCHK
lin civics_N = mkWN (compoundN "yhteiskunta" (k5A "oppi")) ; --UNCHK
lin civil_A = mkA "siviili" ; ---
lin civilian_A = mkWA "siviili-" ; --UNCHK
lin civilian_N = mkWN (k6 "siviili") ; --UNCHK
lin civility_N = mkWN (k40 "kohteliaisuus") ; --UNCHK
lin civilization_N = mkWN (k40 "sivistyneisyys") ; --UNCHK
lin civilize_V2 = mkWV2 (k53 "sivistää") ; --UNCHK
lin clabber_N = mkWN (k10 "piimä") ; --UNCHK
lin clack_N = mkWN (compoundN "läppä" (k6 "venttiili")) ; --UNCHK
lin clack_V = mkWV (k53A "pälättää") ; --UNCHK
lin clad_V2 = mkV2 "päällystää" ;
lin clade_N = mkWN "kladi" ; --UNCHK
lin cladode_N = mkWN (compoundN "laaka" (k28 "varsi")) ; --UNCHK
lin cladogram_N = mkWN "kladogrammi" ; --UNCHK
lin claim_N = mkN "vaatimus" ;
lin claim_V = mkV (mkV "hakea") "korvausta" ; --mkWV (k61 "periä") ;
lin claim_V2 = mkV2 "vaatia" ;
lin claim_VS = mkVS (mkV "väittää") ;
lin claimant_N = mkWN (k12 "vaatija") ;
lin clairvoyance_N = mkWN (k1A "havainto") "yliaistillinen" ; --UNCHK
lin clairvoyant_A = mkWA (k10 "povaaja") ; --UNCHK
lin clairvoyant_N = mkWN (k10 "ennustaja") ; --UNCHK
lin clam_N = mkWN (k14A "simpukka") ; --UNCHK
lin clam_V = mkWV (k73 "kerätä") "simpukoita" ; --UNCHK
lin clam_up_V = mkWV (k72 "hiljetä") ; --UNCHK
lin clamant_A = mkWA (k10 "pakottava") ; --UNCHK
lin clamatorial_A = mkWA "clamatores-" ; --UNCHK
lin clamber_N = mkWN "kapuaminen" ; --UNCHK
lin clamber_V = mkWV (k74 "könytä") ; --UNCHK
lin clammy_A = mkWA (k15 "kostea") ; --UNCHK
lin clammyweed_N = mkWN "Polanisia" "dodecandra" ; --UNCHK
lin clamor_N = mkWN (k14A "metakka") ; --UNCHK
lin clamorous_A = mkWA (k10 "meluisa") ; --UNCHK
lin clamour_N = mkWN (k14A "metakka") ; --UNCHK
lin clamour_V = mkWV (k54A "huutaa") ; --UNCHK
lin clamour_V2 = mkWV2 (k54A "huutaa") ; --UNCHK
lin clamp_N = mkWN (k33 "kiristin") ; --UNCHK
lin clamp_V = mkWV (k53A "pakottaa") ; --UNCHK
lin clamp_V2 = mkWV2 (k53A "pakottaa") ; --UNCHK
lin clamp_down_N = mkWN (k39 "rajoitus") ; --UNCHK
lin clamshell_N = mkWN (k26 "simpukankuori") ; --UNCHK
lin clan_N = mkWN (k1 "heimo") ; --UNCHK
lin clandestine_A = mkWA (k38 "salainen") ; --UNCHK
lin clang_N = mkWN (k12 "kalina") ; --UNCHK
lin clang_V = mkWV (k53A "kilahtaa") ; --UNCHK
lin clang_V2 = mkWV2 (k53A "kilahtaa") ; --UNCHK
lin clanger_N = mkWN (k39 "munaus") ; --UNCHK
lin clangorous_A = mkWA (compoundA "kalk" (k10 "kuva")) ; --UNCHK
lin clangour_N = mkWN (k12 "kalina") ; --UNCHK
lin clank_N = mkWN (k12 "kalina") ; --UNCHK
lin clank_V = mkWV (k67A "kalahdella") ; --UNCHK
lin clank_V2 = mkWV2 (k67A "kalahdella") ; --UNCHK
lin clannish_A = mkWA (k38 "nurkkakuntainen") ; --UNCHK
lin clannishness_N = mkWN (compoundN "heimo" (k7A "henki")) ; --UNCHK
lin clansman_N = mkWN (k32 "jäsen") "heimon" ; --UNCHK
lin clap_N = mkWN (k39 "töräys") ; --UNCHK
lin clap_V = mkWV (k53A "läimäyttää") ; --UNCHK
lin clap_V2 = mkWV2 (k53A "läimäyttää") ; --UNCHK
lin clapboard_N = mkWN (compoundN "ulko" (k9A "lauta")) ; --UNCHK
lin clapper_N = mkWN (k26 "kieli") ; --UNCHK
lin clapperboard_N = mkWN (k5 "klaffi") ; --UNCHK
lin claptrap_N = mkWN (k5 "humpuuki") ; --UNCHK
lin clare_PN = foreignPN "Clare" ;
lin claret_N = mkWN (compoundN "purppuran" (k38 "punainen")) ; --UNCHK
lin clarification_N = mkWN (compoundN "selven" (k38 "täminen")) ;
lin clarify_V = mkWV (k53 "kirkastaa") ; --UNCHK
lin clarify_V2 = mkWV2 (k53 "kirkastaa") ; --UNCHK
lin clarinet_N = mkWN (k5A "klarinetti") ; --UNCHK
lin clarinetistFem_N = mkWN (k5 "klarinetisti") ;
lin clarinetistMasc_N = mkWN (k5 "klarinetisti") ;
lin clarion_A = mkWA "herätys-" ; --UNCHK
lin clarion_N = mkWN "klarino" ; --UNCHK
lin clarity_N = mkWN (k40 "kirkkaus") ; --UNCHK
lin clarkston_PN = foreignPN "Clarkston" ;
lin claro_N = mkWN (compoundN "claro-si" (k5 "kari")) ; --UNCHK
lin clary_N = mkWN (compoundN "muskatelli" (k12 "salvia")) ; --UNCHK
lin clash_N = mkN "yhteen" (mkN "törmäys") ; --mkWN (k1A "suukopu") ;
lin clash_V = mkWV (k53A "ottaa") "yhteen" ; --UNCHK
lin clash_V2 = mkWV2 (k53A "ottaa") "yhteen" ; --UNCHK
lin clasp_N = mkWN (k48A "ote") ; --UNCHK
lin clasp_V = mkWV (k52A "tarrautua") ; --UNCHK
lin clasp_V2 = mkWV2 (k52A "tarrautua") ; --UNCHK
lin clasp_knife_N = mkWN (compoundN "kääntö" (k30 "veitsi")) ; --UNCHK
lin class_N = mkN "luokka" ;
lin class_V2 = mkWV2 (k53A "ryhmittää") ; --UNCHK
lin class_feeling_N = mkWN (compoundN "luokka" (k48A "tunne")) ; --UNCHK
lin class_fellow_N = mkWN (compoundN "luokka" (k6 "toveri")) ; --UNCHK
lin class_list_N = mkWN (compoundN "arvosana" (k2 "luettelo")) ; --UNCHK
lin class_warfare_N = mkWN (compoundN "luokka" (k10A "sota")) ; --UNCHK
lin classic_A = mkWA (k38 "klassinen") ; --UNCHK
lin classic_N = mkWN (k4A "klassikko") ; --UNCHK
lin classical_A = mkWA (k38 "klassinen") ; --UNCHK
lin classicism_N = mkWN (k5 "tyyli") "klassinen" ; --UNCHK
lin classicist_N = mkWN (k12 "taiteilija") "klassinen" ; --UNCHK
lin classicistic_A = mkWA (k38 "klassinen") ; --UNCHK
lin classics_N = mkWN (k40 "kirjallisuus") "klassinen" ; --UNCHK
lin classifiable_A = mkWA (k10 "oleva") "luokiteltavissa" ; --UNCHK
lin classification_N = mkWN (k2 "lajittelu") ; --UNCHK
lin classificatory_A = mkWA "luokitus-" ; --UNCHK
lin classifier_N = mkWN (k5 "morfeemi") "luokitteleva" ; --UNCHK
lin classify_V2 = mkWV2 (k53A "ryhmittää") ; --UNCHK
lin classless_A = mkWA (k34A "luokaton") ; --UNCHK
lin classmate_N = mkWN (compoundN "luokka" (k6 "toveri")) ; --UNCHK
lin classroom_N = mkWN (kH1 "luokka") ; --UNCHK
lin classwork_N = mkWN (compoundN "luokka" (k2 "työskentely")) ; --UNCHK
lin classy_A = mkWA (k47 "hienostunut") ; --UNCHK
lin clast_N = mkWN "klasti" ; --UNCHK
lin clastic_A = mkWA "osiin" "irrotettava" ; --UNCHK
lin clathrate_A = mkWA "klatraatti-" ; --UNCHK
lin clatter_N = mkWN (k12 "kalina") ; --UNCHK
lin clatter_V = mkWV (k52A "paukkua") ; --UNCHK
lin clatter_V2 = mkWV2 (k52A "paukkua") ; --UNCHK
lin clattery_A = mkWA (compoundA "rämis" (k10 "evä")) ; --UNCHK
lin claude_PN = foreignPN "Claude" ;
lin clausal_A = mkWA "lause-" ; --UNCHK
lin clause_N = mkWN (k48 "lause") ;
lin claustrophobe_N = mkWN (k2 "henkilö") "klaustrofobinen" ; --UNCHK
lin claustrophobia_N = mkWN (k1 "kammo") "suljetun" "paikan" ; --UNCHK
lin claustrophobic_A = mkWA "klaustrofobinen" ; --UNCHK
lin claustrum_N = mkWN (compoundN "aivo" (k5 "muuri")) ; --UNCHK
lin clavichord_N = mkWN "klavikordi" ; --UNCHK
lin clavicle_N = mkWN (compoundN "solis" (k18 "luu")) ; --UNCHK
lin clavier_N = mkWN (compoundN "kosketin" (k33A "soitin")) ; --UNCHK
lin claw_N = mkWN (k28 "kynsi") ; --UNCHK
lin claw_V2 = mkWV2 (k67A "raadella") ; --UNCHK
lin clawback_N = mkWN (compoundN "taka" (k38 "isinnyhtäminen")) ; --UNCHK
lin clawfoot_N = mkWN (compoundN "kaari" (k9A "jalka")) ; --UNCHK
lin clawhammer_N = mkWN (compoundN "kirvesmiehen" (k12 "vasara")) ; --UNCHK
lin clawlike_A = mkWA (compoundA "kynsi" (k38 "mäinen")) ; --UNCHK
lin clay_N = mkWN (k1A "raato") ; --UNCHK
lin clayey_A = mkWA (k38 "savinen") ; --UNCHK
lin claymore_N = mkWN (compoundN "jalkaväki" (k9 "miina")) ; --UNCHK
lin claystone_N = mkWN (compoundN "savi" (k7 "kivi")) ; --UNCHK
lin clean_A = L.clean_A ;
lin clean_Adv = mkWAdv (k99 "täysin") ; --UNCHK
lin clean_N = mkWN (k1A "työntö") ; --UNCHK
lin clean_V = mkWV (k53 "puhdistaa") ; --UNCHK
lin clean_V2 = mkWV2 (k53 "puhdistaa") ; --UNCHK
lin clean_out_V = mkWV (k73 "putsata") ; --UNCHK
lin clean_out_V2 = mkWV2 (k73 "putsata") ; --UNCHK
lin clean_up_V = mkWV (k52A "siistiytyä") ; --UNCHK
lin clean_up_V2 = mkWV2 (k52A "siistiytyä") ; --UNCHK
lin cleanable_A = mkWA (k10 "oleva") "puhdistettavissa" ; --UNCHK
lin cleaner_N = mkWN (k33 "puhdistin") ; --UNCHK
lin cleaners_N = mkWN (k12 "pesula") ; --UNCHK
lin cleaning_N = mkWN (k40 "siivous") ; --UNCHK
lin cleanliness_N = mkWN "siistiys" ; --UNCHK
lin cleanly_A = mkWA (k5 "siisti") ; --UNCHK
lin cleanness_N = mkWN (k40 "siveys") ; --UNCHK
lin cleanse_V2 = mkWV2 (k53 "puhdistaa") ; --UNCHK
lin cleanser_N = mkWN (k33 "puhdistin") ; --UNCHK
lin cleansing_A = mkWA "puhdistus-" ; --UNCHK
lin clean_up_N = mkWN (k40 "siivous") ; --UNCHK
lin clear_A = mkA (mkN "selvä") "selvempi" "selvin" ;
lin clear_Adv = mkAdv "selvästi" ;
lin clear_N = mkWN (k9 "aava") ; --UNCHK
lin clear_V = mkV "selkeytyä" ;
lin clear_V2 = mkWV2 (k53 "puhdistaa") ;
lin clear_away_V = mkWV (k72 "hälvetä") ; --UNCHK
lin clear_away_V2 = mkWV2 (k72 "hälvetä") ; --UNCHK
lin clear_off_V = mkWV (k72 "hälvetä") ; --UNCHK
lin clear_out_V = mkWV (k73 "putsata") ; --UNCHK
lin clear_out_V2 = mkWV2 (k73 "putsata") ; --UNCHK
lin clear_up_V = mkWV (k67 "kakistella") ; --UNCHK
lin clear_up_V2 = mkWV2 (k67 "kakistella") ; --UNCHK
lin clearance_N = mkWN (k10A "lupa") ; --UNCHK
lin clearing_N = mkWN (compoundN "kirkas" (k38 "taminen")) ; --UNCHK
lin clearing_house_N = mkWN (compoundN "selvitys" (k3 "yhtiö")) ; --UNCHK
lin clearness_N = mkWN (k40 "kirkkaus") ; --UNCHK
lin clearway_N = mkWN (k19 "tie") "pysähtymiskiellon" "alainen" ; --UNCHK
lin cleat_N = mkWN (k9 "lista") ; --UNCHK
lin cleavable_A = mkWA "halkaistava" ; --UNCHK
lin cleavage_N = mkWN (k38 "halkeaminen") ; --UNCHK
lin cleave_V = mkWV (k52A "tarttua") "yhteen" ; --UNCHK
lin cleave_V2 = mkWV2 (k52A "tarttua") "yhteen" ; --UNCHK
lin cleaver_N = mkWN (compoundN "liha" (k41 "kirves")) ; --UNCHK
lin cleavers_N = mkWN (compoundN "kieru" (k13 "matara")) ; --UNCHK
lin cleethorpes_PN = foreignPN "Cleethorpes" ;
lin clef_N = mkWN (compoundN "nuotti" (k33 "avain")) ; --UNCHK
lin cleft_A = mkWA "leikelty" ; --UNCHK
lin cleft_N = mkWN (k1A "rako") ; --UNCHK
lin cleistogamous_A = mkWA (compoundA "umpi" (k38 "pölytteinen")) ; --UNCHK
lin cleistogamy_N = mkWN "kleistogamia" ; --UNCHK
lin cleistothecium_N = mkWN (compoundN "kotelo" (k1A "rakko")) ; --UNCHK
lin clemency_N = mkWN (k1 "armo") ; --UNCHK
lin clement_A = mkWA (k41 "armelias") ; --UNCHK
lin clementine_N = mkWN (k5 "klementiini") ; --UNCHK
lin clerestory_N = mkWN "klerestorio" ; --UNCHK
lin clergy_N = mkWN (k2 "papisto") ; --UNCHK
lin clergyman_N = mkWN (k6 "pastori") ; --UNCHK
lin cleric_N = mkWN (k5A "pappi") ; --UNCHK
lin clerical_A = mkWA "papin" ; --UNCHK
lin clericalism_N = mkWN (compoundN "pappis" (k40 "valtaisuus")) ; --UNCHK
lin clericalist_N = mkWN (k10 "kannattaja") "pappisvaltaisuuden" ; --UNCHK
lin clerihew_N = mkWN (k1 "runo") "humoristinen" ; --UNCHK
lin clerk_N = mkWN (k5 "konttoristi") ; --UNCHK
lin clerk_V = mkWV (k71 "tehdä") "konttorityötä" ; --UNCHK
lin clerkship_N = mkWN (k19 "työ") "konttoristin" ; --UNCHK
lin clevedon_PN = foreignPN "Clevedon" ;
lin cleveland_PN = foreignPN "Cleveland" ;
lin clever_A = L.clever_A ;
lin cleverness_N = mkWN (k40 "nokkeluus") ; --UNCHK
lin clevis_N = mkWN (compoundN "ketju" (k32 "nivel")) ; --UNCHK
lin clew_N = mkWN (k48 "vihje") ; --UNCHK
lin clew_V2 = mkWV2 (k61 "pyöriä") ; --UNCHK
lin cliche_N = mkWN (k5A "trivialiteetti") ; --UNCHK
lin cliched_A = mkWA (compoundA "joka" (k38 "päiväinen")) ; --UNCHK
lin click_N = mkWN "napsautus" "hiirellä" ; --UNCHK
lin click_V = mkWV (k52 "paljastua") ; --UNCHK
lin client_N = mkN (lin NK {s = d41A "asiakas"}) ;
lin clientage_N = mkWN (k40 "asiakkuus") ; --UNCHK
lin clientele_N = mkWN (compoundN "asiakas" (k10A "kunta")) ; --UNCHK
lin cliff_N = mkWN (k48A "jyrkänne") ; --UNCHK
lin cliff_hanger_N = mkWN (compoundN "loppu" (k39 "huipennus")) ; --UNCHK
lin clifford_PN = foreignPN "Clifford" ;
lin climacteric_N = mkWN (k5 "menopaussi") ; --UNCHK
lin climactic_A = mkWA (k10 "oleva") "huipussaan" ; --UNCHK
lin climate_N = mkWN (k2 "ilmasto") ;
lin climatic_A = mkWA (k38 "ilmastollinen") ; --UNCHK
lin climatologist_N = mkWN "klimatologi" ; --UNCHK
lin climatology_N = mkWN (k12 "klimatologia") ; --UNCHK
lin climax_N = mkWN (k10 "huipentuma") ; --UNCHK
lin climax_V = mkWV (k52A "huipentua") ; --UNCHK
lin climax_V2 = mkWV2 (k52A "huipentua") ; --UNCHK
lin climb_N = mkWN (compoundN "koho" (k38 "aminen")) ; --UNCHK
lin climb_V = mkWV (k74A "kiivetä") ; --f63
lin climb_V2 = mkV2 (mkV "kiivetä") partitive ; --f56
lin climb_down_V = mkWV (k52A "laskeutua") ; --UNCHK
lin climber_N = mkWN (k9 "nasta") ; --UNCHK
lin clime_N = mkWN (k2 "ilmasto") ; --UNCHK
lin clinch_N = mkWN "sitominen" ; --UNCHK
lin clinch_V = mkWV (k64 "lyödä") "lukkoon" ; --UNCHK
lin clinch_V2 = mkWV2 (k64 "lyödä") "lukkoon" ; --UNCHK
lin clincher_N = mkWN (k10 "nitoja") ; --UNCHK
lin cling_V = mkWV (k52A "roikkua") ; --UNCHK
lin cling_to_V2 = mkWV2 (k52A "takertua") ; --UNCHK
lin clingfish_N = mkWN (compoundN "imulevy" (k9 "kala")) ; --UNCHK
lin clinic_N = mkWN (k14A "klinikka") ; --UNCHK
lin clinical_A = mkWA (k38 "kliininen") ;
lin clinician_N = mkWN (k4A "kliinikko") ; --UNCHK
lin clinid_N = mkWN "Clinidae" ; --UNCHK
lin clink_N = mkWN (k10 "putka") ; --UNCHK
lin clink_V = mkWV (k53A "kilahtaa") ; --UNCHK
lin clink_V2 = mkWV2 (k53A "kilahtaa") ; --UNCHK
lin clinker_N = mkWN (k6 "klinkkeri") ; --UNCHK
lin clinocephaly_N = mkWN (compoundN "satulapä" (k40 "isyys")) ; --UNCHK
lin clinodactyly_N = mkWN "klinodaktylia" ; --UNCHK
lin clinometer_N = mkWN (compoundN "kaltevuus" (k6 "mittari")) ; --UNCHK
lin clinquant_A = mkWA (k10 "kiiltävä") ; --UNCHK
lin clintonia_N = mkWN "Clintonia" ; --UNCHK
lin clip_N = mkWN "läimäytys" ; --UNCHK
lin clip_V2 = mkWV2 (k53A "keskeyttää") ; --UNCHK
lin clip_joint_N = mkWN (compoundN "nylky" (k9 "mesta")) ; --UNCHK
lin clipboard_N = mkWN (compoundN "kirjoitus" (k1 "levy")) ; --UNCHK
lin clipper_N = mkWN (compoundN "kynsi" (k6 "leikkuri")) ; --UNCHK
lin clipping_N = mkWN (compoundN "lei" (k38 "kkaaminen")) ; --UNCHK
lin clique_N = mkWN (k10 "ryhmittymä") ; --UNCHK
lin cliquish_A = mkWA (k38 "nurkkakuntainen") ; --UNCHK
lin clitheroe_PN = foreignPN "Clitheroe" ;
lin clitoris_N = mkWN (k39 "klitoris") ; --UNCHK
lin clive_PN = foreignPN "Clive" ;
lin cloaca_N = mkWN (k5A "kloaakki") ; --UNCHK
lin cloak_N = mkWN (kH1 "viitta") ; --UNCHK
lin cloak_V2 = mkWV2 (k53A "peittää") "kaavulla" ; --UNCHK
lin cloakmaker_N = mkWN (k6 "turkkuri") ; --UNCHK
lin cloakroom_N = mkWN (k14A "narikka") ; --UNCHK
lin clobber_V2 = mkV2 "murskata" ; --mkWV2 (k53A "rökittää") ;
lin cloche_N = mkWN (compoundN "kupu" (k1A "hattu")) ; --UNCHK
lin clock_N = mkWN (k1 "kello") ;
lin clock_dial_N = mkWN (compoundN "kello" (k1 "taulu")) ; --UNCHK
lin clock_face_N = mkWN (compoundN "kello" (k1 "taulu")) ; --UNCHK
lin clock_golf_N = mkWN (compoundN "kello" (k5 "golf")) ; --UNCHK
lin clock_tower_N = mkWN (compoundN "kello" (k5 "torni")) ; --UNCHK
lin clocking_N = mkWN (kH1 "aika") ; --UNCHK
lin clocksmith_N = mkWN (compoundN "kello" (k10A "seppä")) ; --UNCHK
lin clockwise_A = mkWA (compoundA "myötä" (k38 "päiväinen")) ; --UNCHK
lin clockwise_Adv = mkWAdv (k99 "myötäpäivään") ; --UNCHK
lin clockwork_N = mkWN (compoundN "jousi" (k2 "koneisto")) ; --UNCHK
lin clod_N = mkWN (k5A "klöntti") ; --UNCHK
lin cloddish_A = mkWA (k38 "moukkamainen") ; --UNCHK
lin clodhopper_N = mkWN (k10A "kenkä") "tukeva" ; --UNCHK
lin clofibrate_N = mkWN "Atromid-S" ; --UNCHK
lin clog_N = mkWN (compoundN "puukenkä" (k5 "tanssi")) ; --UNCHK
lin clog_V = mkWV (k53A "rasittaa") ; --UNCHK
lin clog_V2 = mkWV2 (k53A "rasittaa") ; --UNCHK
lin clog_dance_N = mkWN (compoundN "puukenkä" (k5 "tanssi")) ; --UNCHK
lin clog_up_V2 = mkWV2 (k53A "ruuhkauttaa") ; --UNCHK
lin cloggy_A = mkWA (k41 "tiivis") ; --UNCHK
lin cloisonne_N = mkWN (compoundN "solu" (k5A "emalointi")) ; --UNCHK
lin cloister_V2 = mkWV2 (k52A "eristäytyä") ; --UNCHK
lin clomiphene_N = mkWN "Clomid" ; --UNCHK
lin clomipramine_N = mkWN "klomipramiini" ; --UNCHK
lin clonal_A = mkWA "klooni-" ; --UNCHK
lin clone_N = mkWN (k10 "jäljitelmä") ; --UNCHK
lin clone_V2 = mkWV2 (k73 "kloonata") ; --UNCHK
lin clonic_A = mkWA (compoundA "klooni" (k38 "nen")) ; --UNCHK
lin clonidine_N = mkWN "Catapres" ; --UNCHK
lin cloning_N = mkWN (compoundN "klooni" (k39 "tutkimus")) ; --UNCHK
lin clonus_N = mkWN (compoundN "nykimä" (k39 "kouristus")) ; --UNCHK
lin close_A = mkA "läheinen" ;
lin close_Adv = mkWAdv (k99 "lähettyvillä") ; --f74
lin close_N = mkWN (k1A "loppu") ; --f109
lin close_V = mkV "sulkea" ;
lin close_V2 = L.close_V2 ;
lin close_down_V = advV OP_close_V OP_down_Adv ; -- guess-p-verb
lin close_down_V2 = prepV2 OP_close_V OP_down_Prep ; -- guess-p-verb
lin close_in_V = mkWV (k58A "sulkea") "sisään" ; --UNCHK
lin close_in_on_V2 = prepV2 (advV OP_close_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin close_in_upon_V2 = prepV2 (advV OP_close_V OP_in_Adv ) OP_upon_Prep ; -- guess-p-verb
lin close_off_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin close_on_V2 = prepV2 OP_close_V OP_on_Prep ; -- guess-p-verb
lin close_out_V2 = mkWV2 (k53A "lopettaa") ; --UNCHK
lin close_set_A = mkWA (k99 "kiinni") "tiukasti" ; --UNCHK
lin close_to_Prep = mkPrep "lähellä" ;
lin close_up_V = mkWV (k72 "hiljetä") ; --UNCHK
lin close_up_V2 = mkWV2 (k72 "hiljetä") ; --UNCHK
lin closed_A = mkA "suljettu" ;
lin close_fisted_A = mkWA (k5 "pihi") ; --UNCHK
lin closeness_N = mkWN (k40 "läheisyys") ; --UNCHK
lin closeout_N = mkWN (compoundN "loppuun" (k5A "myynti")) ; --UNCHK
lin closer_N = mkWN (compoundN "sulkija" (k10 "syöttäjä")) ; --UNCHK
lin closet_N = mkWN (k6 "kamari") ; --UNCHK
lin closet_V2 = mkWV2 (k52A "sulkeutua") ; --UNCHK
lin close_up_N = mkWN (compoundN "lähi" (k10 "kuva")) ; --UNCHK
lin closing_N = mkWN (k1A "loppu") ; --UNCHK
lin clostridium_N = mkWN (compoundN "clostri" (k9 "dia")) ; --UNCHK
lin closure_N = mkWN (compoundN "lakka" (k38 "uttaminen")) ; --UNCHK
lin clot_N = mkWN (k10 "hyytymä") ; --UNCHK
lin clot_V = mkWV (k52A "koaguloitua") ; --UNCHK
lin clot_V2 = mkWV2 (k52A "koaguloitua") ; --UNCHK
lin cloth_N = mkWN (k48A "vaate") ; --UNCHK
lin clothe_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin clothes_N = mkN "asu" | mkN "vaate" ; ---- plural only
lin clothes_basket_N = mkWN (compoundN "pyykki" (k5 "kori")) ; --UNCHK
lin clothes_hanger_N = mkWN (k6 "henkari") ; --UNCHK
lin clothes_moth_N = mkWN (k18 "vaatekoi") ; --UNCHK
lin clothes_peg_N = mkWN (compoundN "pyykki" (k10A "poika")) ; --UNCHK
lin clothes_pin_N = mkWN (compoundN "pyykki" (k10A "poika")) ; --UNCHK
lin clothesbrush_N = mkWN (compoundN "vaate" (k9 "harja")) ; --UNCHK
lin clotheshorse_N = mkWN (compoundN "kuivaus" (k48 "teline")) ; --UNCHK
lin clothesless_A = mkWA (k10 "oleva") "vaatteitta" ; --UNCHK
lin clothesline_N = mkWN (compoundN "pyykki" (k1 "naru")) ; --UNCHK
lin clothier_N = mkWN (compoundN "miestenvaate" (k41 "kauppias")) ; --UNCHK
lin clothing_N = mkWN (k1A "puku") ; --UNCHK
lin cloud_N = L.cloud_N ;
lin cloud_V = mkWV (k54A "synkentää") ; --UNCHK
lin cloud_V2 = mkWV2 (k54A "synkentää") ; --UNCHK
lin cloud_bank_N = mkWN (compoundN "pilvi" (k1 "verho")) ; --UNCHK
lin cloud_over_V = mkWV (k52 "pilvistyä") ; --UNCHK
lin cloudberry_N = mkWN (k33 "muurain") ; --UNCHK
lin cloudburst_N = mkWN (k10 "tulva") ; --UNCHK
lin cloudiness_N = mkWN (k40 "hämäryys") ; --UNCHK
lin clouding_N = mkWN (compoundN "pilvi" (k38 "styminen")) ; --UNCHK
lin cloudless_A = mkWA (k34A "pilvetön") ; --UNCHK
lin cloudlessness_N = mkWN "pilvettömyys" ; --UNCHK
lin cloudlike_A = mkWA (compoundA "pilvi" (k38 "mäinen")) ; --UNCHK
lin cloudy_A = mkWA (k38 "pilvinen") ; --UNCHK
lin clout_N = mkWN (k5 "tälli") ; --UNCHK
lin clout_V2 = mkWV2 (k64 "lyödä") ; --UNCHK
lin clove_N = mkWN (compoundN "mauste" (k14A "neilikka")) ; --UNCHK
lin clove_hitch_N = mkWN (compoundN "kaksois" (k7 "polvi")) ; --UNCHK
lin cloven_A = mkWA "sorkka-" ; --UNCHK
lin clover_N = mkWN (k13 "apila") ; --UNCHK
lin cloverleaf_N = mkWN (compoundN "apilanlehti" (k39 "risteys")) ; --UNCHK
lin clowder_N = mkWN (compoundN "kissa" (k9 "lauma")) ; --UNCHK
lin clown_N = mkWN (k5 "narri") ; --UNCHK
lin clown_V = mkWV (k67 "ilveillä") ; --UNCHK
lin clown_around_V = mkWV (k67 "ilveillä") ; --UNCHK
lin clowne_PN = foreignPN "Clowne" ;
lin clownish_A = mkWA (compoundA "klovni" (k38 "mainen")) ; --UNCHK
lin cloy_V = mkWV (k53A "kyllästyttää") ; --UNCHK
lin cloy_V2 = mkWV2 (k53A "kyllästyttää") ; --UNCHK
lin cloyingly_Adv = mkWAdv (compoundAdv "yli" (k99 "makeasti")) ; --UNCHK
lin clozapine_N = mkWN "Clozaril" ; --UNCHK
lin cloze_A = mkWA "täydennys-" ; --UNCHK
lin club_1_N = mkN "kerho" | mkN "klubi" ;
lin club_2_N = mkN "maila" ;
lin club_N = mkN "klubi" ;
lin club_V = mkWV (k73 "kerätä") "yhteen" ; --UNCHK
lin club_V2 = mkWV2 (k73 "kerätä") "yhteen" ; --UNCHK
lin clubbable_A = mkWA (k38 "sosiaalinen") ; --UNCHK
lin clubbish_A = mkWA (k38 "sosiaalinen") ; --UNCHK
lin clubfoot_N = mkWN (compoundN "kampura" (k9A "jalka")) ; --UNCHK
lin club_footed_A = mkWA (compoundA "kampura" (k38 "jalkainen")) ; --UNCHK
lin clubhouse_N = mkWN (k5 "klubi") ; --UNCHK
lin clubroom_N = mkWN (compoundN "kerho" (k48 "huone")) ; --UNCHK
lin cluck_N = mkWN (k39 "kaakatus") ; --UNCHK
lin cluck_V = mkWV (k53A "kalkattaa") ; --UNCHK
lin clue_N = mkWN (k48 "vihje") ; --UNCHK
lin clueless_A = mkWA (k34A "tietämätön") "täysin" ; --UNCHK
lin clumber_N = mkWN (compoundN "clumberin" (k5 "spanieli")) ; --UNCHK
lin clump_N = mkWN (k39 "mätkähdys") ; --UNCHK
lin clump_V = mkWV (k74A "koota") "rykelmäksi" ; --UNCHK
lin clump_V2 = mkWV2 (k74A "koota") "rykelmäksi" ; --UNCHK
lin clumsiness_N = mkWN (k40 "jäykkyys") ; --UNCHK
lin clumsy_A = mkWA (k2 "tökerö") ; --UNCHK
lin clunk_N = mkWN (k39 "mätkähdys") ; --UNCHK
lin clunk_V = mkWV (k66 "tömistä") ; --UNCHK
lin clunky_A = mkWA "jysähtävä" ; --UNCHK
lin clusia_N = mkWN "klusia" ; --UNCHK
lin cluster_N = mkWN (k1A "terttu") ; --UNCHK
lin cluster_V = mkWV (k74A "koota") "rykelmäksi" ; --UNCHK
lin cluster_V2 = mkWV2 (k74A "koota") "rykelmäksi" ; --UNCHK
lin clutch_N = mkWN (k48A "ote") ; --UNCHK
lin clutch_V = mkWV (k58 "iskeä") ; --UNCHK
lin clutch_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin clutter_N = mkN "epä" (mkN "järjestys") ; --mkWN (compoundN "tutka" (k3 "häiriö")) ;
lin clutter_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin clydach_PN = foreignPN "Clydach" ;
lin clydebank_PN = foreignPN "Clydebank" ;
lin clypeus_N = mkWN (compoundN "suu" (k7A "kilpi")) ; --UNCHK
lin cm_N = mkWN (k5A "sentti") ; --UNCHK
lin co_N = mkN "kumppani" ;
lin co_found_V2 = mkV2 (mkV olla_V "mukana perustamassa") partitive ;
lin co_manage_V2 = mkV2 (mkV (mkV "johtaa") "yhdessä") ;
lin coach_1_N = variants {} ; --
lin coach_2_N = variants {} ; --
lin coach_3_N = mkN "valmentaja" ;
lin coach_N = mkWN (k5 "bussi") ; --UNCHK
lin coach_V = mkWV (k54A "valmentaa") ; --UNCHK
lin coach_V2 = mkWV2 (k54A "valmentaa") ; --UNCHK
lin coach_builder_N = mkWN (compoundN "korin" (k10 "rakentaja")) ; --UNCHK
lin coaching_N = mkWN (k19 "työ") "valmentajan" ; --UNCHK
lin coachman_N = mkWN (k10 "ajaja") ; --UNCHK
lin coachwhip_N = mkWN "Masticophis" "flagellum" ; --UNCHK
lin coadjutor_N = mkWN (compoundN "apulais" (k9 "piispa")) ; --UNCHK
lin coagulable_A = mkWA "hyytyvä" ; --UNCHK
lin coagulant_N = mkWN (k48A "hyydyte") ; --UNCHK
lin coagulase_N = mkWN (compoundN "koagul" (k5 "aasi")) ; --UNCHK
lin coagulate_V = mkWV (k52A "koaguloitua") ; --UNCHK
lin coagulate_V2 = mkWV2 (k52A "koaguloitua") ; --UNCHK
lin coagulation_N = mkWN (k3 "koagulaatio") ; --UNCHK
lin coal_N = mkN "hiili" "hiiliä" ; --WN (k48 "kekäle") ;
lin coal_gas_N = mkWN (compoundN "hiili" (k1 "kaasu")) ; --UNCHK
lin coal_house_N = mkWN (compoundN "hiili" (k9 "vaja")) ; --UNCHK
lin coal_scuttle_N = mkWN (k1A "sanko") ; --UNCHK
lin coal_seam_N = mkWN (compoundN "kivihiili" (k48A "juonne")) ; --UNCHK
lin coal_tar_N = mkWN (compoundN "kivihiili" (k9 "terva")) ; --UNCHK
lin coalbin_N = mkWN (compoundN "hiili" (k12 "astia")) ; --UNCHK
lin coalesce_V = mkWV (k52A "sulautua") ; --UNCHK
lin coalescence_N = mkWN (compoundN "yhteen" (k38 "liityminen")) ; --UNCHK
lin coalface_N = mkWN (compoundN "rin" (k39 "taus")) "hiilikaivoksen" ; --UNCHK
lin coalfield_N = mkWN (compoundN "hiili" (k10A "kenttä")) ; --UNCHK
lin coaling_station_N = mkWN (compoundN "hiili" (k10 "asema")) ; --UNCHK
lin coalition_N = mkWN (compoundN "yhteen" (k38 "liityminen")) ; --UNCHK
lin coalman_N = mkWN (compoundN "hiili" (k42 "mies")) ; --UNCHK
lin coalpit_N = mkWN (compoundN "hiili" (k39 "kaivos")) ; --UNCHK
lin coalville_PN = foreignPN "Coalville" ;
lin coaming_N = mkWN (compoundN "roiske" (k9 "reuna")) ; --UNCHK
lin coarctate_A = mkWA (compoundA "kotelo" (k47 "itunut")) ; --UNCHK
lin coarctation_N = mkWN (k10 "ahtauma") ; --UNCHK
lin coarse_A = mkWA (k15 "karhea") ; --UNCHK
lin coarsen_V = mkWV (k53 "raaistaa") ; --UNCHK
lin coarsen_V2 = mkWV2 (k53 "raaistaa") ; --UNCHK
lin coarseness_N = mkWN (k40 "rivous") ; --UNCHK
lin coast_N = mkN "rannikko" ;
lin coast_V = mkWV (k52A "liukua") ; --UNCHK
lin coast_V2 = mkWV2 (k52A "liukua") ; --UNCHK
lin coastal_A = mkWA "rannikko-" ; --UNCHK
lin coaster_N = mkWN (k38 "alunen") ; --UNCHK
lin coastguard_N = mkWN (compoundN "rannikko" (k1 "vartiosto")) ; --UNCHK
lin coastguardsman_N = mkWN (compoundN "rannikko" (k12 "vartija")) ; --UNCHK
lin coastland_N = mkWN (k4A "rannikko") ; --UNCHK
lin coastline_N = mkWN (compoundN "ranta" (k9 "viiva")) ; --UNCHK
lin coastward_Adv = mkWAdv "rannikon" "suuntaan" ; --UNCHK
lin coastwise_A = mkWA "rannikko-" ; --UNCHK
lin coastwise_Adv = mkWAdv (k99 "suuntaisesti") "rannikon" ; --UNCHK
lin coat_N = L.coat_N ;
lin coat_V2 = mkWV2 (k58A "pukea") "takkiin" ; --UNCHK
lin coat_hanger_N = mkWN (k6 "henkari") ; --UNCHK
lin coatbridge_PN = foreignPN "Coatbridge" ;
lin coati_N = mkWN (compoundN "valkonenä" (k1 "karhu")) ; --UNCHK
lin coating_N = mkWN (k2 "sively") ; --UNCHK
lin coatrack_N = mkWN (compoundN "vaate" (k4A "naulakko")) "seisova" ; --UNCHK
lin coattail_N = mkWN (compoundN "takin" (k48A "lieve")) ; --UNCHK
lin coauthorFem_N = mkWN (k12 "tekijä") "toinen" ; --UNCHK
lin coauthorMasc_N = mkWN (k12 "tekijä") "toinen" ; --UNCHK
lin coax_V = mkWV (k67A "viekoitella") ; --UNCHK
lin coax_V2 = mkWV2 (k67A "viekoitella") ; --UNCHK
lin coaxial_A = mkWA (compoundA "sama" (k38 "keskinen")) ; --UNCHK
lin coaxing_N = mkWN (k2 "suostuttelu") ; --UNCHK
lin coaxingly_Adv = mkWAdv (compoundAdv "houkuttelev" (k99 "asti")) ; --UNCHK
lin cob_N = mkWN (k32 "joutsen") ; --UNCHK
lin cobalt_N = mkWN (k5A "koboltti") ; --UNCHK
lin cobaltite_N = mkWN (compoundN "koboltti" (k48A "hohde")) ; --UNCHK
lin cobber_N = mkWN (k6 "kaveri") ; --UNCHK
lin cobble_N = mkWN (compoundN "mukula" (k7 "kivi")) ; --UNCHK
lin cobble_V2 = mkWV2 (k61 "kursia") "kasaan" ; --UNCHK
lin cobble_together_V2 = mkWV2 (k54A "tuhertaa") ; --UNCHK
lin cobbler_N = mkWN (compoundN "hedelmä" (k1A "torttu")) ; --UNCHK
lin cobblestone_N = mkWN (compoundN "mukula" (k7 "kivi")) ; --UNCHK
lin cobham_PN = foreignPN "Cobham" ;
lin cobia_N = mkWN (compoundN "oka" (k9 "kala")) ; --UNCHK
lin cob_nut_N = mkWN (k12 "pähkinä") ; --UNCHK
lin cobra_N = mkWN (k10 "kobra") ; --UNCHK
lin cobweb_N = mkWN (k5A "seitti") ; --UNCHK
lin cobwebby_A = mkWA (k99 "peitossa") "hämähäkinverkkojen" ; --UNCHK
lin coca_cola_N = mkWN "kokis" ; --UNCHK
lin cocaine_N = mkWN (k5 "kokaiini") ; --UNCHK
lin cocarboxylase_N = mkWN (compoundN "tiamiinipyro" (k5A "fosfaatti")) ; --UNCHK
lin coccal_A = mkWA (compoundA "pallo" (k38 "mainen")) ; --UNCHK
lin coccidioidomycosis_N = mkWN "koksidioidomykoosi" ; --UNCHK
lin coccidiosis_N = mkWN "kokkidioosi" ; --UNCHK
lin coccidium_N = mkWN "Eimeria" ; --UNCHK
lin coccoid_A = mkWA (compoundA "kokki" (k38 "mainen")) ; --UNCHK
lin coccus_N = mkWN (kH1 "kokki") ; --UNCHK
lin coccygeal_A = mkWA "häntäluun" ; --UNCHK
lin coccyx_N = mkWN (compoundN "häntä" (k18 "luu")) ; --UNCHK
lin cochin_N = mkWN (compoundN "kochin-" (k9 "kana")) ; --UNCHK
lin cochineal_N = mkWN (compoundN "karmiini" (k9 "kirva")) ; --UNCHK
lin cochlea_N = mkWN (k14A "simpukka") ; --UNCHK
lin cochlear_A = mkWA "simpukka-" ; --UNCHK
lin cock_N = mkWN (k1A "ukko") ; --UNCHK
lin cock_V2 = mkWV2 (k53A "virittää") ; --UNCHK
lin cock_up_V2 = mkWV2 (k67 "olla") "höröllä" ; --UNCHK
lin cockade_N = mkWN (k5 "kokardi") ; --UNCHK
lin cockamamie_A = mkWA (k38 "hullunkurinen") ; --UNCHK
lin cockateel_N = mkWN (compoundN "neito" (k2 "kakadu")) ; --UNCHK
lin cockatoo_N = mkWN (k2 "kakadu") ; --UNCHK
lin cockatrice_N = mkWN "basiliski" ; --UNCHK
lin cockchafer_N = mkWN (compoundN "saksan" (k41 "turilas")) ; --UNCHK
lin cocker_N = mkWN (compoundN "cocker" (k5 "spanieli")) ; --UNCHK
lin cockerel_N = mkWN (compoundN "kukon" (k10A "poika")) ; --UNCHK
lin cockermouth_PN = foreignPN "Cockermouth" ;
lin cockeyed_A = mkWA (k10 "oleva") "tillin-tallin" ; --UNCHK
lin cockfight_N = mkWN (compoundN "kukko" (k2 "tappelu")) ; --UNCHK
lin cockfighting_N = mkWN (compoundN "kukko" (k2 "tappelu")) ; --UNCHK
lin cockhorse_N = mkWN (compoundN "keppi" (k38 "hevonen")) ; --UNCHK
lin cockle_N = mkWN (compoundN "sydän" (k14A "simpukka")) ; --UNCHK
lin cocklebur_N = mkWN (compoundN "iso" (k38 "takiainen")) ; --UNCHK
lin cockleshell_N = mkWN (k48 "vene") "pieni" "kiikkerä" ; --UNCHK
lin cockloft_N = mkWN (compoundN "ullakko" (k6 "kamari")) ; --UNCHK
lin cockney_A = mkWA "Cockneyn" ; --UNCHK
lin cockney_N = mkWN "cockney" ; --UNCHK
lin cockpit_N = mkWN (k2 "ohjaamo") ; --UNCHK
lin cockroach_N = mkWN (k14A "russakka") ; --UNCHK
lin cockscomb_N = mkWN (k9 "harja") ; --UNCHK
lin cockspur_N = mkWN "Pisonia" "aculeata" ; --UNCHK
lin cocksucker_N = mkWN (k1 "roisto") ; --UNCHK
lin cocksure_A = mkWA (k9 "varma") "aivan" ; --UNCHK
lin cocktail_N = mkWN (compoundN "ruoka" (k1A "ryyppy")) ; --UNCHK
lin cockup_N = mkWN (k1 "sotku") ; --UNCHK
lin cocky_A = mkWA (k15 "pöyhkeä") ; --UNCHK
lin coco_N = mkWN (compoundN "kookos" (k12 "pähkinä")) ; --UNCHK
lin cocoa_N = mkWN (compoundN "kaakao" (k48 "jauhe")) ; --UNCHK
lin cocobolo_N = mkWN (compoundN "ruusu" (k18 "puu")) ; --UNCHK
lin coconut_N = mkWN (compoundN "kookos" (k12 "pähkinä")) ; --UNCHK
lin cocoon_N = mkWN (k2 "kotelo") ; --UNCHK
lin cocoon_V2 = mkWV2 (k62 "koteloida") ; --UNCHK
lin cocooning_N = mkWN (compoundN "kotelo" (k38 "ituminen")) ; --UNCHK
lin cocotte_N = mkWN (compoundN "annos" (k10A "vuoka")) ; --UNCHK
lin cocozelle_N = mkWN (compoundN "cocozelle-kesäkurpitsa" (k48A "lajike")) ; --UNCHK
lin cocuswood_N = mkWN "Aspalathus" "ebenus" ; --UNCHK
lin cod_N = mkWN (k10 "turska") ; --UNCHK
lin cod_V = mkWV (k53A "ärsyttää") ; --UNCHK
lin cod_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin cod_liver_oil_N = mkWN (compoundN "kalanmaksa" (k1 "öljy")) ; --UNCHK
lin coda_N = mkWN (k10 "osa") "viimeinen" ; --UNCHK
lin code_N = mkN "koodi" ;
lin code_V2 = mkV2 "koodata" ;
lin codefendant_N = mkWN (compoundN "kanssa" (k10 "vastaaja")) ; --UNCHK
lin codeine_N = mkWN (k5 "kodeiini") ; --UNCHK
lin codetalker_N = mkWN (compoundN "navajo-salakielen" (k10 "käyttäjä")) ; --UNCHK
lin codex_N = mkWN (k5 "koodeksi") ; --UNCHK
lin codfish_N = mkWN (k10 "turska") ; --UNCHK
lin codger_N = mkWN (k6 "ukkeli") "vanha" ; --UNCHK
lin codicil_N = mkWN (compoundN "lisä" (k5A "testamentti")) ; --UNCHK
lin codification_N = mkWN (k3 "kodifikaatio") ; --UNCHK
lin codify_V2 = mkWV2 (k62 "kodifioida") ; --UNCHK
lin codling_N = mkWN (k10 "turska") "nuori" ; --UNCHK
lin codon_N = mkWN "kodoni" ; --UNCHK
lin codpiece_N = mkWN (compoundN "kalu" (k2 "kukkaro")) ; --UNCHK
lin codsall_PN = foreignPN "Codsall" ;
lin coeducation_N = mkWN (compoundN "yhteis" (k39 "opetus")) ; --UNCHK
lin coeducational_A = mkWA "yhteis-" ; --UNCHK
lin coefficient_N = mkWN (kH1 "kerroin") ; --UNCHK
lin coelacanth_N = mkWN "Latimeria" "chalumnae" ; --UNCHK
lin coelenterate_N = mkWN "Cnidaria" ; --UNCHK
lin coelenteron_N = mkWN (k2 "ontelo") ; --UNCHK
lin coeliac_A = mkWA "vatsaontelon" ; --UNCHK
lin coelophysis_N = mkWN "Coelophysis" ; --UNCHK
lin coelostat_N = mkWN (compoundN "aurinko" (k5A "teleskooppi")) ; --UNCHK
lin coenzyme_N = mkWN "koentsyymi" ; --UNCHK
lin coequal_A = mkWA (compoundA "yhden" (k38 "vertainen")) ; --UNCHK
lin coerce_V2 = mkWV2 (k53 "painostaa") ; --UNCHK
lin coercion_N = mkWN (k1A "pakko") ; --UNCHK
lin coercive_A = mkWA (k10 "pakottava") ; --UNCHK
lin coetaneous_A = mkWA (k38 "aikalainen") ; --UNCHK
lin coeval_A = mkWA (k38 "aikalainen") ; --UNCHK
lin coeval_N = mkWN (k38 "aikalainen") ; --UNCHK
lin co_exist_V = mkWV (k52A "esiintyä") "yhtaikaisesti" ; --UNCHK
lin coexistence_N = mkWN (compoundN "yhteis" (k1 "elo")) ; --UNCHK
lin coexistent_A = mkWA (compoundA "saman" (k38 "aikainen")) ; --UNCHK
lin coextension_N = mkWN (compoundN "samank" (k40 "estoisuus")) ; --UNCHK
lin coextensive_A = mkWA (compoundA "saman" (k38 "laajuinen")) ; --UNCHK
lin coffee_N = mkN "kahvi" ;
lin coffee_mill_N = mkWN (compoundN "kahvi" (k1 "mylly")) ; --UNCHK
lin coffee_stall_N = mkWN (compoundN "kahvi" (k5 "kioski")) ; --UNCHK
lin coffeeberry_N = mkWN "Rhamnus" "californicus" ; --UNCHK
lin coffeecake_N = mkWN (compoundN "kahvi" (k1A "kakku")) ; --UNCHK
lin coffeepot_N = mkWN (compoundN "kahvi" (k1 "pannu")) ; --UNCHK
lin coffer_N = mkWN (k41A "lipas") ; --UNCHK
lin coffin_N = mkWN (k1A "arkku") ; --UNCHK
lin cofounder_N = mkWN (k10 "perustaja") "toinen" ; --UNCHK
lin cog_N = mkWN (k41A "hammas") ; --UNCHK
lin cogency_N = mkWN (k40 "oikeellisuus") ; --UNCHK
lin cogent_A = mkWA (k10 "painava") ; --UNCHK
lin cogged_A = mkWA (compoundA "hammas" (k1 "tettu")) ; --UNCHK
lin cogitable_A = mkWA (k38 "arvoinen") "harkitsemisen" ; --UNCHK
lin cogitate_V = mkWV (k61A "miettiä") ; --UNCHK
lin cogitate_V2 = mkWV2 (k61A "miettiä") ; --UNCHK
lin cogitation_N = mkWN (k2 "pohdiskelu") ; --UNCHK
lin cogitative_A = mkWA "ajattelu-" ; --UNCHK
lin cognac_N = mkWN (k5A "konjakki") ; --UNCHK
lin cognate_A = mkWA (k38 "sukulainen") ; --UNCHK
lin cognate_N = mkWN (compoundN "sukulais" (k9 "sana")) ; --UNCHK
lin cognition_N = mkWN (k9A "tajunta") ; --UNCHK
lin cognitive_A = mkWA (k38 "kognitiivinen") ; --UNCHK
lin cognizance_N = mkWN (k9A "tajunta") ; --UNCHK
lin cognizant_A = mkWA (k10 "tietävä") ; --UNCHK
lin cognomen_N = mkWN (compoundN "suku" (k7 "nimi")) ; --UNCHK
lin cogwheel_N = mkWN (k41A "ratas") ; --UNCHK
lin cohabitation_N = mkWN (compoundN "avo" (k1A "liitto")) ; --UNCHK
lin cohere_V = mkWV (k52A "tarttua") "yhteen" ; --UNCHK
lin coherence_N = mkWN (k40 "yhtenäisyys") ; --UNCHK
lin coherency_N = mkWN (k40 "yhtenäisyys") ; --UNCHK
lin coherent_A = mkWA (k5A "koherentti") ; --UNCHK
lin cohesion_N = mkWN (k3 "koheesio") ; --UNCHK
lin cohesive_A = mkWA "koheesio-" ; --UNCHK
lin cohesiveness_N = mkWN (k40 "tahmeus") ; --UNCHK
lin coho_N = mkWN (compoundN "hopea" (k23 "lohi")) ; --UNCHK
lin cohort_N = mkWN (k5A "kohortti") ; --UNCHK
lin coif_N = mkWN (k48 "päähine") ; --UNCHK
lin coiffeur_N = mkWN (k10 "kampaaja") ; --UNCHK
lin coiffeuse_N = mkWN (k10 "kampaaja") ; --UNCHK
lin coiffure_N = mkWN (k39 "kampaus") ; --UNCHK
lin coign_N = mkWN (compoundN "laki" (k7 "kivi")) ; --UNCHK
lin coil_N = mkWN (k6 "spiraali") ; --UNCHK
lin coil_V = mkWV (k61 "keriä") ; --UNCHK
lin coil_V2 = mkWV2 (k61 "keriä") ; --UNCHK
lin coimbatore_PN = foreignPN "Coimbatore" ;
lin coin_N = mkN "kolikko" ; --WN (k5A "lantti") ;
lin coin_V2 = mkWV2 (k64 "lyödä") "rahaa" ; --UNCHK
lin coinage_N = mkWN (k1A "käyttö") "uudissanojen" ; --UNCHK
lin coincide_V = mkV (mkV "sattua") "samaan aikaan" ;
lin coincidence_N = mkWN (k10 "tapahtuma") "samanaikainen" ; --UNCHK
lin coincident_A = mkWA (compoundA "yhtä" (k10 "pitävä")) ; --UNCHK
lin coincidental_A = mkWA (k38 "rinnakkainen") ; --UNCHK
lin coiner_N = mkWN (compoundN "rahan" (k10 "lyöjä")) ; --UNCHK
lin coinsurance_N = mkWN (compoundN "rinnakkais" (k39 "vakuutus")) ; --UNCHK
lin coir_N = mkWN (compoundN "kookos" (k1A "kuitu")) ; --UNCHK
lin coital_A = mkWA "parittelu-" ; --UNCHK
lin coition_N = mkWN (k38 "kanssakäyminen") "seksuaalinen" ; --UNCHK
lin coitus_N = mkWN (k38 "kanssakäyminen") "seksuaalinen" ; --UNCHK
lin coke_N = mkWN (k5 "kokaiini") ; --UNCHK
lin coke_V2 = mkWV2 (k52A "koksiintua") ; --UNCHK
lin col_N = mkWN (k1 "rotko") ; --UNCHK
lin cola_N = mkWN (k10 "kola") ; --UNCHK
lin colander_N = mkWN (k4A "lävikkö") ; --UNCHK
lin colchester_PN = foreignPN "Colchester" ;
lin colchicine_N = mkWN "kolkisiini" ; --UNCHK
lin cold_A = L.cold_A ;
lin cold_N = mkWN (k38 "vilustuminen") ;
lin cold_hearted_A = mkWA (compoundA "kylmä" (k38 "sydäminen")) ; --UNCHK
lin coldness_N = mkWN (k40 "etäisyys") ; --UNCHK
lin coleslaw_N = mkWN (compoundN "kaali" (k5A "salaatti")) ; --UNCHK
lin coleus_N = mkWN (compoundN "väri" (k38 "nokkonen")) ; --UNCHK
lin colic_N = mkWN (k9 "vatsa") "akuutti" ; --UNCHK
lin colicky_A = mkWA "kaasu-" ; --UNCHK
lin colicroot_N = mkWN (compoundN "farin" (k10 "osa")) "Aletris" ; --UNCHK
lin coliphage_N = mkWN "koolifagi" ; --UNCHK
lin colitis_N = mkWN (k39 "tulehdus") "paksunsuolen" ; --UNCHK
lin collaborate_V = mkWV (k61 "toimia") "yhteistyössä" ;
lin collaboration_N = mkN "yhteis" (mkN "työ") ;
lin collaborationist_N = mkWN (k5 "quisling") ; --UNCHK
lin collaborative_A = mkWA "yhteistyö-" ; --UNCHK
lin collaborator_N = mkWN (k6 "partneri") ; --UNCHK
lin collage_N = mkWN (k5 "montaasi") ; --UNCHK
lin collagen_N = mkWN (k5 "kollageeni") ; --UNCHK
lin collagenase_N = mkWN (compoundN "kollagen" (k5 "aasi")) ; --UNCHK
lin collagenous_A = mkWA (compoundA "kollage" (k36 "enin")) ; --UNCHK
lin collapsable_A = mkWA "kokoon" "taitettava" ; --UNCHK
lin collapse_N = mkWN (k39 "romahdus") ; --f74
lin collapse_V = mkV (lin VK {s = c53A "romahtaa"}) ;
lin collapse_V2 = mkWV2 (k52 "lyyhistyä") ; --UNCHK
lin collapsible_A = mkWA "kokoon" "taitettava" ; --UNCHK
lin collar_N = mkWN (k99 "kiinni") "saada" ; --UNCHK
lin collar_V2 = mkWV2 (k69 "vangita") ; --UNCHK
lin collarbone_N = mkWN (compoundN "solis" (k18 "luu")) ; --UNCHK
lin collard_N = mkWN (compoundN "lehti" (k5 "kaali")) ; --UNCHK
lin collards_N = mkWN (compoundN "lehti" (k5 "kaali")) ; --UNCHK
lin collarless_A = mkWA "kaulukseton" ; --UNCHK
lin collate_V2 = mkWV2 (k67 "vertailla") ; --UNCHK
lin collateral_A = mkWA (k10 "oleva") "sivusukua" ; --UNCHK
lin collateral_N = mkWN (k40 "vakuus") ; --UNCHK
lin collation_N = mkWN (k2 "vertailu") ; --UNCHK
lin colleague_N = mkWN (k13 "kollega") ; --f55
lin collect_A = mkWA "vasta-" ; --UNCHK
lin collect_Adv = mkWAdv "vasta-" ; --UNCHK
lin collect_N = mkWN (compoundN "kollehta" (k39 "rukous")) ; --UNCHK
lin collect_V = mkWV (k53 "yhdistää") ; --UNCHK
lin collect_V2 = mkV2 "kerätä" partitive ;
lin collectedly_Adv = mkWAdv (k99 "hillitysti") ; --UNCHK
lin collectible_A = mkWA "maksettava" ; --UNCHK
lin collectible_N = mkWN (compoundN "keräily" (k48 "esine")) ; --UNCHK
lin collection_N = mkN "kokoelma" ;
lin collective_A = mkA "kollektiivinen" ;
lin collective_N = mkWN (k5 "kollektiivi") ; --UNCHK
lin collectivism_N = mkWN (k5 "kollektivismi") ; --UNCHK
lin collectivist_A = mkWA (k38 "kollektivistinen") ; --UNCHK
lin collectivist_N = mkWN (k38 "vasemmistolainen") ; --UNCHK
lin collectivization_N = mkWN (compoundN "kollekti" (k5A "vointi")) ; --UNCHK
lin collectivize_V2 = mkWV2 (k62 "kollektivoida") ; --UNCHK
lin collector_N = mkWN (k5 "kollektori") ; --UNCHK
lin colleen_N = mkWN (compoundN "irkku" (k1A "tyttö")) ; --UNCHK
lin college_N = mkWN (k8 "college") ; ---- yliopisto
lin collegial_A = mkWA "collegen" ; --UNCHK
lin collegian_N = mkWN (k41 "oppilas") "collegen" ; --UNCHK
lin collegiate_A = mkWA "collegen" ; --UNCHK
lin collembolan_N = mkWN (compoundN "hyppy" (k38 "häntäinen")) ; --UNCHK
lin collet_N = mkWN (k39 "kehys") "jalokiven" ; --UNCHK
lin collide_V = mkWV (k73 "törmätä") ; --UNCHK
lin collider_N = mkWN (k33A "törmäytin") ; --UNCHK
lin collie_N = mkWN (k3 "collie") ; --UNCHK
lin collier_N = mkWN (compoundN "kaivos" (k38 "työläinen")) ; --UNCHK
lin colliery_N = mkWN (k39 "kaivos") ; --UNCHK
lin colligation_N = mkWN "looginen" "yhdistäminen" ; --UNCHK
lin collimation_N = mkWN "kollimaatio" ; --UNCHK
lin collinear_A = mkWA (compoundA "kol" (k38 "lineaarinen")) ; --UNCHK
lin collins_N = mkWN "Tom" "Collins" ; --UNCHK
lin collision_N = mkWN (compoundN "risti" (k9A "riita")) ; --UNCHK
lin collocate_V = mkWV (k56A "laittaa") "rinnakkain" ; --UNCHK
lin collocation_N = mkWN (k2 "asettelu") "vierekkäin" ; --UNCHK
lin collodion_N = mkWN "kollodi" ; --UNCHK
lin colloid_N = mkWN (k5 "kolloidi") ; --UNCHK
lin colloidal_A = mkWA (k38 "kolloidinen") ; --UNCHK
lin colloquial_A = mkWA (compoundA "arki" (k38 "kielinen")) ; --UNCHK
lin colloquialism_N = mkWN (k39 "ilmaus") "arkikielen" ; --UNCHK
lin colloquium_N = mkWN (k10 "esitelmä") ; --UNCHK
lin colloquy_N = mkWN (k2 "keskustelu") ; --UNCHK
lin collotype_N = mkWN (compoundN "valo" (k1 "paino")) ; --UNCHK
lin collusion_N = mkWN (k39 "sopimus") "salainen" ; --UNCHK
lin collusive_A = mkWA (k38 "vilpillinen") ; --UNCHK
lin colne_PN = foreignPN "Colne" ;
lin colobus_N = mkWN (compoundN "Colobus-" (k12 "apina")) ; --UNCHK
lin cologne_N = mkWN (compoundN "kölnin" (k27 "vesi")) ; --UNCHK
lin cologne_PN = foreignPN "Cologne" ;
lin colombia_PN = foreignPN "Kolumbia" ;
lin colombian_A = mkWA (compoundA "kolumbi" (k38 "alainen")) ; --UNCHK
lin colombian_N = mkWN (compoundN "kolumbi" (k38 "alainen")) ; --UNCHK
lin colombo_PN = foreignPN "Colombo" ;
lin colon_N = mkWN (k50 "paksusuoli") ; --UNCHK
lin colonel_N = mkWN (k5 "eversti") ; --UNCHK
lin colonial_A = mkWA "siirtomaa-" ; --UNCHK
lin colonial_N = mkWN (k41A "asukas") "siirtomaan" ; --UNCHK
lin colonialism_N = mkWN (k5 "kolonialismi") ; --UNCHK
lin colonialist_N = mkWN (k5 "kolonialisti") ; --UNCHK
lin colonic_A = mkWA "paksusuoli-" ; --UNCHK
lin colonist_N = mkWN (compoundN "uudis" (k10 "raivaaja")) ; --UNCHK
lin colonization_N = mkWN (k39 "asutus") ; --UNCHK
lin colonize_V2 = mkWV2 (k53A "asuttaa") ; --UNCHK
lin colonizer_N = mkWN (k10 "perustaja") "siirtokunnan" ; --UNCHK
lin colonnade_N = mkWN (k4A "pylväikkö") ; --UNCHK
lin colonnaded_A = mkWA "pylväikkö-" ; --UNCHK
lin colonoscope_N = mkWN (compoundN "kolonosko" (k5A "oppi")) ; --UNCHK
lin colonoscopy_N = mkWN "kolonoskopia" ; --UNCHK
lin colony_N = mkN "siirtokunta" ; --WN (compoundN "yhdys" (k10A "kunta")) ;
lin colophon_N = mkWN "kolofoni" ; --UNCHK
lin colophony_N = mkWN (compoundN "jousi" (k5 "hartsi")) ; --UNCHK
lin color_A = mkWA (k38 "värillinen") ; --UNCHK
lin colorado_PN = foreignPN "Colorado" ;
lin coloration_N = mkWN (compoundN "värien" (k1A "käyttö")) ; --UNCHK
lin coloratura_N = mkWN (k5 "koloratuuri") ; --UNCHK
lin colorcast_N = mkWN (compoundN "väri" (k39 "lähetys")) ; --UNCHK
lin colorectal_A = mkWA (compoundA "kolorekta" (k38 "alinen")) ; --UNCHK
lin colorfast_A = mkWA (compoundA "värin" (k10 "pitävä")) ; --UNCHK
lin colorimeter_N = mkWN (compoundN "värisävy" (k6 "mittari")) ; --UNCHK
lin colorimetric_A = mkWA "värinmittaukseen" "liittyvä" ; --UNCHK
lin colorimetry_N = mkWN (compoundN "värin" (k39 "mittaus")) ; --UNCHK
lin colorist_N = mkWN (k5 "koloristi") ; --UNCHK
lin colorless_A = mkWA (k34A "väritön") ; --UNCHK
lin colorlessness_N = mkWN (k40 "värittömyys") ; --UNCHK
lin colossal_A = mkWA (k38 "jättiläismäinen") ; --UNCHK
lin colossus_N = mkWN (k6 "titaani") ; --UNCHK
lin colostomy_N = mkWN (k1A "teko") "paksusuoliavanteen" ; --UNCHK
lin colostrum_N = mkWN (compoundN "terni" (k1A "maito")) ; --UNCHK
lin colour_N = mkN "väri" ;
lin colour_V = mkWV (k52A "värjääntyä") ; --UNCHK
lin colour_V2 = mkWV2 (k52A "värjääntyä") ; --UNCHK
lin colour_V2A = mkWV2A (k52A "värjääntyä") ; --UNCHK
lin colour_bar_N = mkWN (compoundN "rotu" (k2 "erottelu")) ; --UNCHK
lin colour_code_V2 = mkV2 "värikoodata" ;
lin colour_wash_N = mkWN (compoundN "pesu" (k39 "värjäys")) ; --UNCHK
lin coloured_A = mkWA (k38 "sävyinen") ; --UNCHK
lin colourful_A = mkWA (k41A "värikäs") | mkWA (k38 "sävyinen") ; --UNCHK
lin colouring_N = mkWN (compoundN "väri" (k38 "ttäminen")) ; --UNCHK
lin colourless_A = mkWA (k34A "väritön") ; --UNCHK
lin colpitis_N = mkWN (compoundN "emätin" (k39 "tulehdus")) ; --UNCHK
lin colpocele_N = mkWN (compoundN "emätin" (k10 "tyrä")) ; --UNCHK
lin colpoxerosis_N = mkWN (k33A "emätin") "kuiva" ; --UNCHK
lin colt_N = mkWN (k9 "varsa") ; --UNCHK
lin colter_N = mkWN (k10 "terä") "auran" ; --UNCHK
lin coltish_A = mkWA (k10 "leikkisä") ; --UNCHK
lin coltsfoot_N = mkWN (compoundN "lesken" (k7A "lehti")) ; --UNCHK
lin columbarium_N = mkWN (compoundN "uurna" (k5 "holvi")) ; --UNCHK
lin columbia_PN = foreignPN "Columbia" ;
lin columbine_N = mkWN (k9 "akileija") ; --UNCHK
lin columbium_N = mkWN (k5 "niobium") ; --UNCHK
lin columbo_N = mkWN (k26 "kolumbojuuri") ; --UNCHK
lin columbus_PN = foreignPN "Columbus" ;
lin columella_N = mkWN "kolumella" ; --UNCHK
lin column_N = mkN "kolumni" ;
lin columnar_A = mkWA (compoundA "pylväs" (k38 "mäinen")) ; --UNCHK
lin columnea_N = mkWN (compoundN "tuli" (k39 "köynnös")) ; --UNCHK
lin columned_A = mkWA (compoundA "pylväs" (k38 "mäinen")) ; --UNCHK
lin columniation_N = mkWN (k2 "sommittelu") "pylväiden" ; --UNCHK
lin columniform_A = mkWA (k38 "muotoinen") "pylvään" ; --UNCHK
lin columnistFem_N = mkWN (k5 "kolumnisti") ; --UNCHK
lin columnistMasc_N = mkWN (k5 "kolumnisti") ; --UNCHK
lin coma_N = mkWN (k40 "tajuttomuus") ; --UNCHK
lin comate_A = mkWA (compoundA "siemen" (k38 "karvallinen")) ; --UNCHK
lin comatose_A = mkWA "kooma-" ; --UNCHK
lin comb_N = mkWN (compoundN "kampa" (k38 "aminen")) ; --UNCHK
lin comb_V = mkWV (k53A "selvittää") ; --UNCHK
lin comb_V2 = mkWV2 (k53A "selvittää") ; --UNCHK
lin combat_N = mkWN (k2 "taistelu") "aseellinen" ; --UNCHK
lin combat_V = mkWV (k67 "taistella") ; --UNCHK
lin combat_V2 = mkV2 (mkV "taistella") (mkPrep "vastaan" partitive) ;
lin combatant_A = mkWA "valmis" "taisteluun" ; --UNCHK
lin combatant_N = mkWN (k12 "ottelija") ; --UNCHK
lin combative_A = mkWA (k10 "sotaisa") ; --UNCHK
lin combativeness_N = mkWN (k40 "sotaisuus") ; --UNCHK
lin comber_N = mkWN (compoundN "kampaus" (k48 "kone")) ; --UNCHK
lin combinable_A = mkWA "yhtyvä" ; --UNCHK
lin combination_N = mkN "yhdistelmä" ; --WN (k3 "kombinaatio") ;
lin combination_lock_N = mkWN (compoundN "numero" (k1A "lukko")) ; --UNCHK
lin combinative_A = mkWA "yhtymä-" ; --UNCHK
lin combinatorial_A = mkWA "kombinatorinen" ; --UNCHK
lin combine_N = mkWN (k6 "puimuri") ; --UNCHK
lin combine_V = mkWV (k53 "yhdistää") ;
lin combine_V2 = mkWV2 (k53 "yhdistää") ;
lin combine_VV = mkWVV (k53 "yhdistää") ; ---- subcat
lin combined_A = variants {} ; --
lin combining_N = mkWN (k3 "kombinaatio") ; --UNCHK
lin combretum_N = mkWN "Combretum" ; --UNCHK
lin comburent_A = mkWA (k10 "palava") ; --UNCHK
lin combustibility_N = mkWN (compoundN "palamis" (k40 "kelpoisuus")) ; --UNCHK
lin combustible_A = mkWA "syttyvä" ; --UNCHK
lin combustible_N = mkWN (k48 "aine") "syttyvä" ; --UNCHK
lin combustion_N = mkWN (k1A "poltto") ; --UNCHK
lin come_V = L.come_V ;
lin come_about_V = mkWV (k65 "käydä") ; --UNCHK
lin come_across_V = mkWV (k63 "saada") "vastakaikua" ; --UNCHK
lin come_across_V2 = mkWV2 (k63 "saada") "vastakaikua" ; --UNCHK
lin come_along_V = mkWV (k52A "kehittyä") ; --UNCHK
lin come_along_with_V2 = prepV2 (advV OP_come_V OP_along_Adv ) OP_with_Prep ; -- guess-p-verb
lin come_apart_V = mkWV (k67 "mennä") "rikki" ; --UNCHK
lin come_around_V = mkWV (k52A "saapua") "ajallaan" ; --UNCHK
lin come_around_to_V2 = prepV2 (advV OP_come_V OP_around_Adv ) OP_to_Prep ; -- guess-p-verb
lin come_away_V = mkWV (k52A "irtaantua") ; --UNCHK
lin come_back_V = mkWV (k73 "palata") ; --UNCHK
lin come_before_V2 = mkWV2 (k54A "edeltää") ; --UNCHK
lin come_by_V = mkWV (k54A "löytää") ; --UNCHK
lin come_by_V2 = mkWV2 (k54A "löytää") ; --UNCHK
lin come_down_V = mkWV (k52 "sairastua") ; --UNCHK
lin come_down_on_V2 = prepV2 (advV OP_come_V OP_down_Adv ) OP_on_Prep ; -- guess-p-verb
lin come_down_upon_V2 = prepV2 (advV OP_come_V OP_down_Adv ) OP_upon_Prep ; -- guess-p-verb
lin come_down_with_V2 = prepV2 (advV OP_come_V OP_down_Adv ) OP_with_Prep ; -- guess-p-verb
lin come_forth_V = mkWV (k67 "tulla") "näkyviin" ; --UNCHK
lin come_forth_with_V2 = prepV2 (advV OP_come_V OP_forth_Adv ) OP_with_Prep ; -- guess-p-verb
lin come_forward_V = mkWV (k67 "tulla") "julkisuuteen" ; --UNCHK
lin come_from_V2 = prepV2 OP_come_V OP_from_Prep ; -- guess-p-verb
lin come_in_V = mkWV (k67 "tulla") ; --UNCHK
lin come_in_V2 = mkWV2 (k67 "tulla") ; --UNCHK
lin come_in_for_V2 = mkWV2 (k52A "joutua") "kohteeksi" ; --UNCHK
lin come_into_V2 = mkV2 (mkV (mkV "tulla") "mukaan") illative ;
lin come_into_use_V = variants {} ; -- guess-p-verb
lin come_off_V = mkWV (k67 "tulla") "ymmärretyksi" ; --UNCHK
lin come_off_V2 = mkWV2 (k67 "tulla") "ymmärretyksi" ; --UNCHK
lin come_off_it_V = variants {} ; -- guess-p-verb
lin come_on_V = mkWV (k52A "kehittyä") ; --UNCHK
lin come_out_V = mkWV (k52A "näyttäytyä") ; --UNCHK
lin come_out_in_V2 = prepV2 (advV OP_come_V OP_out_Adv ) OP_in_Prep ; -- guess-p-verb
lin come_out_of_V2 = prepV2 (advV OP_come_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin come_out_with_V2 = prepV2 (advV OP_come_V OP_out_Adv ) OP_with_Prep ; -- guess-p-verb
lin come_over_V = mkWV (k71 "tehdä") "tiettäväksi" ; --UNCHK
lin come_over_V2 = mkWV2 (k71 "tehdä") "tiettäväksi" ; --UNCHK
lin come_round_V = advV OP_come_V OP_round_Adv ; -- guess-p-verb
lin come_through_V = mkV (mkV "päästä") "läpi" ; --UNCHK
lin come_through_with_V2 = prepV2 (advV OP_come_V OP_through_Adv ) OP_with_Prep ; -- guess-p-verb
lin come_to_V = mkWV (k67 "tulla") "tajuihinsa" ; --UNCHK
lin come_to_V2 = mkV2 (mkV "tulla") illative ;
lin come_up_V = mkV "ilmaantua" ;
lin come_up_against_V2 = prepV2 (advV OP_come_V OP_up_Adv ) OP_against_Prep ; -- guess-p-verb
lin come_up_to_V2 = mkWV2 (k52 "lähestyä") ; --UNCHK
lin come_up_with_V2 = prepV2 (advV OP_come_V OP_up_Adv ) OP_with_Prep ; -- guess-p-verb
lin come_upon_V2 = mkWV2 (k63 "saada") "tuurilla" ; --UNCHK
lin come_with_V2 = mkWV2 (k65 "käydä") ; --UNCHK
lin comeback_N = mkWN (k17 "paluu") ; --UNCHK
lin comedian_N = mkWN (k4A "koomikko") ;
lin comedienne_N = mkWN (k8 "komedienne") ; --UNCHK
lin comedown_N = mkWN (compoundN "arvon" (k39 "alennus")) ; --UNCHK
lin comedy_N = mkN "komedia" ;
lin comeliness_N = mkWN (k40 "ihanuus") ; --UNCHK
lin comely_A = mkWA (k15 "komea") ; --UNCHK
lin comer_N = mkWN (k12 "tulija") ; --UNCHK
lin comestible_N = mkWN (k10 "muona") ; --UNCHK
lin comet_N = mkWN (k9A "komeetta") ; --UNCHK
lin cometary_A = mkWA (compoundA "pyrstö" (k38 "tähtimäinen")) ; --UNCHK
lin comfit_N = mkWN (k12 "pähkinä") "sokeroitu" ; --UNCHK
lin comfort_N = mkWN (k7A "tuki") ; --UNCHK
lin comfort_V2 = mkWV2 (k53A "lievittää") ; --UNCHK
lin comfortable_A = mkA "mukava" ;
lin comfortableness_N = mkWN (compoundN "hyvin" (k5A "vointi")) ; --UNCHK
lin comforter_N = mkWN (k5A "huvitutti") ; --UNCHK
lin comforting_A = mkWA (k38 "lohdullinen") ; --UNCHK
lin comfortless_A = mkWA (compoundA "epä" (k41A "kodikas")) ; --UNCHK
lin comfrey_N = mkWN (compoundN "raunio" (k5A "yrtti")) ; --UNCHK
lin comfy_A = mkWA (k10 "lokoisa") ; --UNCHK
lin comic_A = mkWA (k38 "koominen") ; --UNCHK
lin comic_N = mkWN (k4A "koomikko") ; --UNCHK
lin comical_A = mkWA (k1 "hassu") ; --UNCHK
lin comicality_N = mkWN (k40 "koomisuus") ; --UNCHK
lin coming_A = mkA "tuleva" ;
lin coming_N = mkWN "saapuminen" ; --UNCHK
lin comity_N = mkWN (k1A "sopu") ; --UNCHK
lin comma_N = mkWN (compoundN "herukka" (k38 "perhonen")) ; --UNCHK
lin command_1_N = variants {} ; --
lin command_2_N = variants {} ; --
lin command_N = mkWN (k9A "hallinta") ; --UNCHK
lin command_V = mkWV (k58 "käskeä") ; --UNCHK
lin command_V2 = mkWV2 (k58 "käskeä") ; --UNCHK
lin commandant_N = mkWN (k10 "komentaja") ; --UNCHK
lin commandeer_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin commander_N = mkWN (k10 "komentaja") ;
lin commandership_N = mkWN (k40 "päällikkyys") ; --UNCHK
lin commandment_N = mkWN (k5A "oppi") ; --UNCHK
lin commando_N = mkWN (compoundN "isku" (k1A "joukko")) ; --UNCHK
lin commelina_N = mkWN "soljo" ; --UNCHK
lin commemorate_V2 = mkV2 (mkV "muistella") partitive ;
lin commemoration_N = mkWN (k2 "muistelu") ; --UNCHK
lin commemorative_A = mkWA "muisto-" ; --UNCHK
lin commemorative_N = mkWN "muisto-" ; --UNCHK
lin commence_V = variants {} ; -- mkV2 "aloittaa" ;
lin commence_V2 = mkV2 "aloittaa" ;
lin commencement_N = mkWN (k39 "aloitus") ; --UNCHK
lin commend_V2 = mkWV2 (k53 "ylistää") ; --UNCHK
lin commendable_A = mkWA (k10 "kunnioitettava") ; --UNCHK
lin commendation_N = mkWN (k39 "suositus") ; --UNCHK
lin commensal_A = mkWA (compoundA "kommensa" (k38 "alinen")) ; --UNCHK
lin commensal_N = mkWN (compoundN "pöytä" (k41 "vieras")) ; --UNCHK
lin commensalism_N = mkWN (compoundN "pöytävieras" (k48A "suhde")) ; --UNCHK
lin commensurable_A = mkWA (compoundA "yhteis" (k38 "mitallinen")) ; --UNCHK
lin commensurateness_N = mkWN (k40 "suhteellisuus") ; --UNCHK
lin comment_N = mkN "kommentti" ;
lin comment_V = mkV "kommentoida" ;
lin comment_V2 = variants {} ; -- mkV "kommentoida" ;
lin comment_VS = mkVS "kommentoida" ;
lin commentary_N = mkWN (k39 "selitys") ; --UNCHK
lin commentate_V = mkWV (k53 "selostaa") ; --UNCHK
lin commentator_N = mkN (lin NK {s = d06 "kommentaattori"}) ;
lin commerce_N = mkN "kauppa" ; --mkWN (k40 "kaupallisuus") ;
lin commercial_A = mkWA (k38 "kaupallinen") ;
lin commercial_N = mkWN (k39 "mainos") ;
lin commercialism_N = mkWN (k40 "kaupallisuus") ; --UNCHK
lin commercialization_N = mkWN (compoundN "kaupallis" (k38 "taminen")) ; --UNCHK
lin commercialize_V2 = mkV2 "kaupallistaa" ; --WV2 (k62 "markkinoida") ;
lin commination_N = mkWN (k10 "uhka") "Jumalan" "koston" ; --UNCHK
lin comminatory_A = mkWA (k10 "arvosteleva") "ankarasti" ; --UNCHK
lin commingle_V = mkWV (k52A "sulautua") ; --UNCHK
lin commingle_V2 = mkWV2 (k52A "sulautua") ; --UNCHK
lin commiserate_V = mkWV (k53A "osoittaa") "sympatiaa" ; --UNCHK
lin commiseration_N = mkWN (compoundN "osan" (k1A "otto")) ; --UNCHK
lin commiserative_A = mkWA (compoundA "myötätun" (k38 "toinen")) ; --UNCHK
lin commissar_N = mkWN (k5 "komissaari") ; --UNCHK
lin commissariat_N = mkWN (k10A "ruoka") ; --UNCHK
lin commissary_N = mkWN (k6 "kanttiini") ; --UNCHK
lin commission_N = mkN (lin NK {s = d03 "komissio"}) ;
lin commission_V2 = mkWV2 (k56A "antaa") "tehtäväksi" ;
lin commission_V2V = mkWV2V (k56A "antaa") "tehtäväksi" ; --UNCHK
lin commissionaire_N = mkWN (compoundN "vahti" (k6 "mestari")) ; --UNCHK
lin commissioner_N = mkWN "hallintovirkamies" ; --UNCHK
lin commissure_N = mkWN (k9 "sauma") ; --UNCHK
lin commit_V2 = mkV2 "harjoittaa" ; --f59 ---ARB ; tehdä ; velvoittaa , sitouttaa
lin commitment_N = mkN "sitoumus" ;
lin committedness_N = mkWN (k39 "vakaumus") ; --UNCHK
lin committee_N = mkN "komitea" "komiteoita" ;
lin committeeman_N = mkWN (k32 "jäsen") "valiokunnan" ; --UNCHK
lin committeewoman_N = mkWN (k32 "jäsen") "valiokunnan" ; --UNCHK
lin commode_1_N = mkWN (k2 "lipasto") ; --UNCHK
lin commode_2_N = mkWN (k2 "lipasto") ; --UNCHK
lin commodious_A = mkWA (k10 "sopiva") ; --UNCHK
lin commodity_N = mkN "hyödyke" ;
lin commodore_N = mkWN (k5 "kommodori") ; --UNCHK
lin common_1_A = mkA "tavallinen" ;
lin common_2_A = mkA "yhteinen" ;
lin common_A = mkA "tavallinen" ;
lin common_N = mkWN (k10A "kenttä") ; --UNCHK
lin common_room_N = mkWN (compoundN "olo" (k48 "huone")) ; --UNCHK
lin commonage_N = mkWN (compoundN "yhteis" (k18 "maa")) ; --UNCHK
lin commonality_N = mkWN (k48A "piirre") "yhteinen" ; --UNCHK
lin commonalty_N = mkWN (k1A "sääty") "kolmas" ; --UNCHK
lin commoner_N = mkWN (k38 "ihminen") "tavallinen" ; --UNCHK
lin commonness_N = mkWN (k48A "piirre") "yhteinen" ; --UNCHK
lin commonplace_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin commonplace_N = mkN "tavanomainen" ;
lin commons_N = mkWN (k1A "sääty") "kolmas" ; --UNCHK
lin commonsense_A = mkWA (k7A "järki") "terve" ; --UNCHK
lin commonwealth_N = mkWN (k33 "elin") "poliittinen" ; --UNCHK
lin commotion_N = mkWN (k12 "rähinä") ; --UNCHK
lin communal_A = mkWA (k38 "kunnallinen") ; --UNCHK
lin communalism_N = mkWN (compoundN "etnosentr" (k40 "isyys")) ; --UNCHK
lin commune_N = mkWN (k6 "kommuuni") ; --UNCHK
lin communicable_A = mkWA "helposti" "välitettävä" ; --UNCHK
lin communicant_N = mkWN (compoundN "ehtoollis" (k41 "vieras")) ; --UNCHK
lin communicate_V = mkWV (k67 "olla") "vuorovaikutuksessa" ; --UNCHK
lin communicate_V2 = mkWV2 (k67 "olla") "vuorovaikutuksessa" ; --UNCHK
lin communication_N = mkN "kommunikaatio" | mkN "tiedon" (mkN "välitys") ;
lin communicational_A = mkWA "viesti-" ; --UNCHK
lin communications_N = mkWN (compoundN "informaatio" (k12 "teoria")) ; --UNCHK
lin communicative_A = mkWA (k41 "puhelias") ; --UNCHK
lin communicativeness_N = mkWN (k40 "puheliaisuus") ; --UNCHK
lin communicator_N = mkWN "viestijä" ; --UNCHK
lin communion_N = mkWN (k12 "ateria") "pyhä" ; --UNCHK
lin communique_N = mkWN (k12 "kommunikea") ; --UNCHK
lin communism_N = mkWN (k5 "kommunismi") ; --UNCHK
lin communist_A = mkA "kommunistinen" ;
lin communist_N = mkWN (compoundN "Bordeaux-" (k39 "seos")) ; --UNCHK
lin community_N = mkN "yhteisö" ;
lin communization_N = mkWN (k38 "tekeminen") "kommunistiseksi" ; --UNCHK
lin commutability_N = mkWN (k40 "vaihdettavuus") ; --UNCHK
lin commutable_A = mkWA (k10 "oleva") "muunnettavissa" ; --UNCHK
lin commutation_N = mkWN (k1A "vaihto") ; --UNCHK
lin commutator_N = mkWN (k6 "kommutaattori") ; --UNCHK
lin commute_N = mkWN (compoundN "työ" (k9 "matka")) ; --UNCHK
lin commute_V = mkWV (k54A "muuntaa") ; --UNCHK
lin commute_V2 = mkWV2 (k54A "muuntaa") ; --UNCHK
lin commuter_N = mkWN (compoundN "työmatka" (k10 "juna")) ; --UNCHK
lin compact_A = mkWA (k41 "tiivis") ;
lin compact_N = mkWN (compoundN "puuteri" (k12 "rasia")) ; --UNCHK
lin compact_V2 = mkWV2 (k56A "ahtaa") ; --UNCHK
lin compaction_N = mkWN (k39 "puristus") ; --UNCHK
lin compactness_N = mkWN (k40 "tiiviys") ; --UNCHK
lin companion_N = mkWN (k38 "seuralainen") ;
lin companionability_N = mkWN (k40 "sosiaalisuus") ; --UNCHK
lin companionable_A = mkWA (k38 "seurallinen") ; --UNCHK
lin companionate_A = mkWA (k38 "toverillinen") ; --UNCHK
lin companionship_N = mkWN (k40 "kumppanuus") ; --UNCHK
lin company_1_N = mkN "yhtiö" ;
lin company_2_N = mkN "seura" ;
lin comparability_N = mkWN (k40 "vastaavuus") ; --UNCHK
lin comparable_A = mkWA (k10 "oleva") "verrattavissa" ; --f60
lin comparative_A = mkWA (k38 "relatiivinen") ; --UNCHK
lin comparative_N = mkWN (k5 "komparatiivi") ; --UNCHK
lin compare_N = mkWN (k40 "vastaavuus") ; --UNCHK
lin compare_V = mkV "verrata" ;
lin comparison_N = mkWN (k2 "vertailu") ;
lin compartment_N = mkWN (k2 "osasto") ; --UNCHK
lin compartmental_A = mkWA (compoundA "lokero" (k1A "itu")) ; --UNCHK
lin compartmentalization_N = mkWN (k2 "lajittelu") ; --UNCHK
lin compartmentalize_V2 = mkWV2 (k67A "jaotella") ; --UNCHK
lin compartmented_A = mkWA (compoundA "lokero" (k1A "itu")) ; --UNCHK
lin compass_N = mkWN (k5 "kompassi") ; --UNCHK
lin compass_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin compassion_N = mkWN (k5 "sääli") ; --UNCHK
lin compassionate_A = mkWA (k38 "ymmärtäväinen") ; --UNCHK
lin compatibility_N = mkWN (k40 "soveltuvuus") "yhteen" ; --UNCHK
lin compatible_A = mkA (mkN "yhteen" (mkN "sopiva")) ; --mkWA (compoundA "sopu" (k38 "sointuinen")) ;
lin compatriotFem_N = mkWN (compoundN "maan" (k42 "mies")) ; --UNCHK
lin compatriotMasc_N = mkWN (compoundN "maan" (k42 "mies")) ; --UNCHK
lin compeer_N = mkWN (k38 "vertainen") ; --UNCHK
lin compel_V2 = mkWV2 (k53A "edellyttää") ; --UNCHK
lin compel_V2V = mkWV2V (k53A "edellyttää") ; --UNCHK
lin compel_VV = mkWVV (k53A "edellyttää") ; --UNCHK
lin compelling_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin compendious_A = mkWA (k5 "kompakti") ; --UNCHK
lin compendium_N = mkWN (k10 "tiivistelmä") ; --UNCHK
lin compensable_A = mkWA (k10 "tuottoisa") ; --UNCHK
lin compensate_V = mkWV (k62 "kompensoida") ;
lin compensate_V2 = mkWV2 (k62 "kompensoida") ; --UNCHK
lin compensation_N = mkN "korvaus" ;
lin compensatory_A = mkA "korvaava" ;
lin compere_N = mkWN (k10 "juontaja") ; --UNCHK
lin compere_V2 = mkWV2 (k53A "kuuluttaa") ; --UNCHK
lin compete_V = mkV (lin VK {s = c67 "kilpailla"}) ;
lin competence_N = mkWN (k40 "pätevyys") ; --UNCHK
lin competent_A = mkA "kompetentti" ;
lin competition_N = mkWN (k2 "kilpailu") ;
lin competitive_A = mkWA "kilpailu-" ; --f77
lin competitiveness_N = mkN "kilpailu" (mkN "kyky") ;
lin competitor_N = mkN "kilpailija" ;
lin compilation_N = mkWN (compoundN "toi" (k38 "mittaminen")) "kokoomateoksen" ; --UNCHK
lin compile_V2 = mkWV2 (k53 "koostaa") ; --UNCHK
lin compiler_N = mkWN (k10 "kääntäjä") "ohjelmointikielen" ; --UNCHK
lin complacence_N = mkWN (k40 "omahyväisyys") ; --UNCHK
lin complacency_N = mkWN (k40 "omahyväisyys") ; --UNCHK
lin complacent_A = mkWA (k38 "itseriittoinen") ; --UNCHK
lin complain_V = mkV "valittaa" ;
lin complain_VS = mkVS "valittaa" ; --WVS (k53 "nostaa") "kanne" ;
lin complainant_N = mkWN (k10 "kantaja") ; --UNCHK
lin complainingly_Adv = mkWAdv "valittaen" ; --UNCHK
lin complaint_N = mkWN (k48A "kanne") ; --f61
lin complaisance_N = mkWN (k39 "kunnioitus") ; --UNCHK
lin complaisant_A = mkWA (k38 "ystävällinen") ; --UNCHK
lin complement_N = mkWN (k48A "lisäke") ; --UNCHK
lin complement_V2 = mkWV2 (k54A "täydentää") ;
lin complemental_A = mkWA (k38 "komplementaarinen") ; --UNCHK
lin complementarity_N = mkWN "toisiaan" "täydentävyys" ; --UNCHK
lin complementary_A = mkWA (k38 "komplementaarinen") ; --UNCHK
lin complementation_N = mkWN (k3 "distribuutio") "komplementaarinen" ; --UNCHK
lin complete_A = mkA "täydellinen" ;
lin complete_V = mkWV (k54A "täydentää") ;
lin complete_V2 = mkV2 (mkV "täydentää") partitive ;
lin completeness_N = mkWN (k40 "täydellisyys") ;
lin completion_N = mkWN (k1A "loppu") ; --UNCHK
lin complex_A = mkA "monimutkainen" ;
lin complex_N = mkWN (k5 "kompleksi") ;
lin complexifier_N = mkWN "mutkistaja" ; --UNCHK
lin complexion_N = mkWN (k5A "temperamentti") ; --UNCHK
lin complexity_N = mkWN (k40 "mutkikkuus") ; --UNCHK
lin compliance_N = mkWN (compoundN "ali" (k38 "stuminen")) ; --UNCHK
lin compliant_A = mkWA (k38 "suostuvainen") ; --UNCHK
lin complicate_V2 = mkV2 "monimutkaistaa" partitive ;
lin complicated_A = variants {} ; --
lin complicatedness_N = mkWN (compoundN "kiemu" (k40 "raisuus")) ; --UNCHK
lin complication_N = mkN "komplikaatio" ;
lin complicity_N = mkWN (compoundN "rikos" (k40 "kumppanuus")) ; --UNCHK
lin compliment_N = mkWN (k40 "kohteliaisuus") ; --UNCHK
lin compliment_V2 = mkWV2 (k52 "lausua") "kohteliaisuus" ; --UNCHK
lin complimentary_A = mkWA "mairitteleva" ; --UNCHK
lin complin_N = mkWN "kompletorio" ; --UNCHK
lin compline_N = mkWN "kompletorio" ; --UNCHK
lin comply_V = mkWV (k52A "taipua") ; --UNCHK
lin comply_V2 = mkWV2 (k52A "taipua") ; --UNCHK
lin component_N = mkWN (k5A "komponentti") ;
lin comport_V = mkWV (k52A "liikkua") ; --UNCHK
lin comport_V2 = mkWV2 (k52A "liikkua") ; --UNCHK
lin comportment_N = mkWN (k39 "olemus") ; --UNCHK
lin compos_mentis_A = mkWA (k38 "syyntakeinen") ; --UNCHK
lin compose_V = mkWV (k61A "laatia") ; --UNCHK
lin compose_V2 = mkWV2 (k61A "laatia") ;
lin composer_N = mkWN (k10 "säveltäjä") ;
lin composing_N = mkWN (compoundN "sävel" (k38 "täminen")) ; --UNCHK
lin composite_A = mkA "yhdistetty" ;
lin composite_N = mkWN (k10 "yhdistelmä") ; --UNCHK
lin compositeness_N = mkWN (k1A "luku") "yhdistetty" ; --UNCHK
lin composition_N = mkWN (k2 "kynäily") ; --UNCHK
lin compositional_A = mkWA "koostumus-" ; --UNCHK
lin compositor_N = mkWN (k10 "latoja") ; --UNCHK
lin compost_N = mkWN (k5 "komposti") ; --UNCHK
lin compost_V2 = mkWV2 (k62 "kompostoida") ; --UNCHK
lin composure_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin compote_N = mkWN (k5A "kompotti") ; --UNCHK
lin compound_A = mkWA (k38 "kerrannainen") ; --UNCHK
lin compound_N = mkWN "kampong" ; --UNCHK
lin compound_V = mkWV (k53 "yhdistää") ; --UNCHK
lin compound_V2 = mkWV2 (k53 "yhdistää") ;
lin comprehend_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin comprehensibility_N = mkWN (k40 "ymmärrettävyys") ; --UNCHK
lin comprehensible_A = mkWA (k10 "ymmärrettävä") ; --UNCHK
lin comprehension_N = mkWN (k39 "ymmärrys") ; --UNCHK
lin comprehensive_A = mkWA "kattava" ;
lin comprehensiveness_N = mkWN (k40 "monipuolisuus") ; --UNCHK
lin compress_N = mkWN (k5 "kompressi") ; --UNCHK
lin compress_V2 = mkWV2 (k56A "ahtaa") ; --UNCHK
lin compressibility_N = mkWN (k40 "huokoisuus") ; --UNCHK
lin compression_N = mkWN (compoundN "pai" (k38 "neistaminen")) ; --UNCHK
lin compressor_N = mkWN (k6 "kompressori") ; --UNCHK
lin comprise_V2 = mkWV2 (k54A "sisältää") ; --UNCHK
lin compromise_N = mkWN (k5 "kompromissi") ; --f56
lin compromise_V = mkWV (k67A "sovitella") ;
lin compromise_V2 = mkWV2 (k67A "sovitella") ; --UNCHK
lin compromiser_N = mkWN (k12 "sovittelija") ; --UNCHK
lin comptroller_N = mkWN (k10 "valvoja") "varainhoidon" ; --UNCHK
lin comptrollership_N = mkWN (k9A "virka") "valtion" "tilintarkastajan" ; --UNCHK
lin compulsion_N = mkWN (k1A "pakko") ; --UNCHK
lin compulsive_A = mkWA (k41A "tarmokas") ; --UNCHK
lin compulsive_N = mkWN (compoundN "pakko" (k4A "neurootikko")) ; --UNCHK
lin compulsiveness_N = mkWN (compoundN "pakkomielte" (k40 "isyys")) ; --UNCHK
lin compulsory_A = mkA "pakollinen" ;
lin compunction_N = mkWN (k39 "katumus") ; --UNCHK
lin computable_A = mkWA (k10 "oleva") "arvioitavissa" ; --UNCHK
lin computation_N = mkWN (k9A "laskenta") ; --UNCHK
lin computational_A = mkWA "tietokone-" ; --UNCHK
lin compute_V = mkWV (k58 "laskea") ;
lin compute_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin computer_N = L.computer_N ;
lin computer_science_N = mkN "tietojenkäsittelyoppi" ;
lin computerization_N = mkWN (compoundN "tietojen" (k2 "käsittely")) "automaattinen" ; --UNCHK
lin computerize_V2 = mkV2 "tietokoneistaa" ;
lin computing_N = variants {} ; --
lin comrade_N = mkWN (k6 "toveri") ; --UNCHK
lin comradely_A = mkWA (k99 "toverillisesti") ; --UNCHK
lin comradely_Adv = adjAdv comradely_A ; -- derived
lin comradeship_N = mkWN (k40 "ystävyys") ; --UNCHK
lin con_Adv = mkWAdv (k99 "vastaan") ; --UNCHK
lin con_N = mkWN (k39 "huijaus") ; --UNCHK
lin con_V2 = mkWV2 (k56 "painaa") "muistiin" ; --UNCHK
lin con_man_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin conacaste_N = mkWN (compoundN "cycloc" (k9A "arpa")) "Enterolobium" ; --UNCHK
lin concatenation_N = mkWN (k39 "ketjutus") ; --UNCHK
lin concave_A = mkWA (k10 "kovera") ; --UNCHK
lin concavity_N = mkWN (k40 "koveruus") ; --UNCHK
lin conceal_V2 = mkWV2 (k53A "peittää") ;
lin conceale_V = mkV "salata" ;
lin concealment_N = mkWN (k2 "salailu") ; --UNCHK
lin concede_V = mkV (mkV "antaa") "myöten" ; --mkWV (k54A "myöntää") ;
lin concede_V2 = mkWV2 (k54A "myöntää") ; --UNCHK
lin concede_VS = mkVS (mkV "tunnustaa") ; --f56
lin conceit_N = mkWN (k40 "turhamaisuus") ; --UNCHK
lin conceited_A = mkWA (k38 "turhamainen") ; --UNCHK
lin conceivable_A = mkWA (k10 "oleva") "kuviteltavissa" ; --UNCHK
lin conceivableness_N = mkWN (k40 "mahdollisuus") ; --UNCHK
lin conceive_V = mkWV (k67 "tulla") "raskaaksi" ; --UNCHK
lin conceive_V2 = mkWV2 (k67 "tulla") "raskaaksi" ; --UNCHK
lin concentrate_N = mkWN "malliesimerkki" ; --UNCHK
lin concentrate_V = mkV "keskittyä" ; --WV (k53A "kiehuttaa") "vähiin" ;
lin concentrate_V2 = mkWV2 (k53A "kiehuttaa") "vähiin" ; --UNCHK
lin concentrated_A = mkA "keskittynyt" ;
lin concentration_N = mkN "keskittyminen" ;
lin concentric_A = mkWA (compoundA "saman" (k38 "keskinen")) ; --UNCHK
lin concentricity_N = mkWN (k40 "samankeskisyys") ; --UNCHK
lin concept_N = mkN "käsite" | mkN "konsepti" ;
lin conception_N = mkN "käsitys" ; ---ARB --mkWN (compoundN "hede" (k38 "lmöittyminen")) ;
lin conceptional_A = mkWA (k38 "teoreettinen") ; --UNCHK
lin conceptive_A = mkWA (k38 "hedelmällinen") ; --UNCHK
lin conceptual_A = mkWA (k38 "käsitteellinen") ; --UNCHK
lin conceptualism_N = mkWN (compoundN "konseptual" (k5 "ismi")) ; --UNCHK
lin conceptualistic_A = mkWA "konseptualistinen" ; --UNCHK
lin conceptualization_N = mkWN (k2 "muotoilu") ; --UNCHK
lin concern_N = mkN "konserni" ;
lin concern_V2 = mkV2 (mkV vOlla "tekemistä") (mkPrep "kanssa") ; --f65
lin concerned_A = mkA "tarkoitettu" ;
lin concerning_Prep = mkPrep "mitä tulee" illative ; --
lin concert_N = mkWN (k5A "konsertti") ;
lin concert_V2 = mkWV2 (k61A "sopia") ; --UNCHK
lin concert_hall_N = mkWN (compoundN "konsertti" (k5 "sali")) ; --UNCHK
lin concertina_N = mkWN (compoundN "käsi" (k9A "harmonikka")) ; --UNCHK
lin concerto_N = mkWN (k1A "konsertto") ; --UNCHK
lin concession_N = mkWN (compoundN "toimi" (k10A "lupa")) ; --UNCHK
lin concessionaire_N = mkWN (compoundN "toimiluvan" (k12 "haltija")) ; --UNCHK
lin conch_N = mkWN (k2 "kotilo") ; --UNCHK
lin concha_N = mkWN (k4A "kuorikko") ; --UNCHK
lin conchfish_N = mkWN "Astrapogon" "stellatus" ; --UNCHK
lin conchologist_N = mkWN (k12 "tutkija") "näkinkenkien" ; --UNCHK
lin conchology_N = mkWN (compoundN "kerä" (k38 "ileminen")) "näkinkuorien" ; --UNCHK
lin concierge_N = mkWN (compoundN "oven" (k12 "vartija")) ; --UNCHK
lin conciliate_V2 = mkWV2 (k63 "saada") "sopimaan" ; --UNCHK
lin conciliation_N = mkWN (k2 "sovittelu") ; --UNCHK
lin conciliator_N = mkWN (k12 "sovittelija") ; --UNCHK
lin conciliatory_A = mkWA (k38 "sovinnollinen") ; --UNCHK
lin concise_A = mkWA (k41A "ytimekäs") ; --UNCHK
lin conciseness_N = mkWN (k40 "ytimekkyys") ; --UNCHK
lin conclave_N = mkWN (k2 "neuvottelu") "salainen" ; --UNCHK
lin conclude_V = mkWV (k67A "päätellä") ; --UNCHK
lin conclude_V2 = mkWV2 (k67A "päätellä") ; --UNCHK
lin conclude_VS = mkWVS (k67A "päätellä") ; --f52
lin conclusion_N = mkWN (compoundN "pää" (k38 "ttäminen")) ; --UNCHK
lin conclusive_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin concoct_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin concoction_N = mkWN (compoundN "valmis" (k38 "taminen")) ; --UNCHK
lin concomitance_N = mkWN (compoundN "saman" (k40 "aikaisuus")) ; --UNCHK
lin concomitant_A = mkA "liittyvä" ;
lin concomitant_N = mkWN (k10 "sattuma") ; --UNCHK
lin concordance_N = mkWN (k1 "hakemisto") ; --UNCHK
lin concordat_N = mkWN (k39 "sopimus") ; --UNCHK
lin concourse_N = mkWN (compoundN "väen" (k39 "tungos")) ; --UNCHK
lin concrete_A = mkWA (k38 "konkreettinen") ; --UNCHK
lin concrete_N = mkWN (k6 "betoni") ; --UNCHK
lin concreteness_N = mkWN (k40 "konkreettisuus") ; --UNCHK
lin concretion_N = mkWN (compoundN "yhteen" (k38 "liityminen")) ; --UNCHK
lin concretism_N = mkWN (k39 "esitys") "konkreettinen" ; --UNCHK
lin concretistic_A = mkWA (k38 "konkreettinen") ; --UNCHK
lin concubinage_N = mkWN (compoundN "konkubi" (k5A "naatti")) ; --UNCHK
lin concubine_N = mkWN (k32A "rakastajatar") ; --UNCHK
lin concupiscence_N = mkWN (k40 "himokkuus") ; --UNCHK
lin concur_V = mkV "yhtyä" ;
lin concurrence_N = mkWN (compoundN "myötä" (k39 "vaikutus")) ; --UNCHK
lin concurrent_A = mkWA (k38 "rinnakkainen") ; --UNCHK
lin concuss_V2 = mkWV2 (k53A "aiheuttaa") "aivotärähdys" ; --UNCHK
lin concussion_N = mkWN (k1 "isku") ; --UNCHK
lin condemn_V2 = mkWV2 (k69 "tuomita") ; --UNCHK
lin condemnable_A = mkWA (k38 "paheellinen") ; --UNCHK
lin condemnation_N = mkWN (k3 "tuomio") ; --UNCHK
lin condemnatory_A = mkWA "langettava" ; --UNCHK
lin condensate_N = mkWN (k3 "kondensaatio") ; --UNCHK
lin condensation_N = mkWN (k39 "tiivistys") ; --UNCHK
lin condense_V = mkWV (k53 "tiivistää") ; --UNCHK
lin condense_V2 = mkWV2 (k53 "tiivistää") ; --UNCHK
lin condenser_N = mkWN (k6 "kondensaattori") ; --UNCHK
lin condensing_N = mkWN (k39 "tiivistys") ; --UNCHK
lin condescend_V = mkWV (k52A "suhtautua") "alentuvasti" ; --UNCHK
lin condescendingly_Adv = mkWAdv (k99 "alentuvasti") ; --UNCHK
lin condescension_N = mkWN (k40 "armollisuus") ; --UNCHK
lin condign_A = mkWA (compoundA "ansa" (k1 "ittu")) ; --UNCHK
lin condiment_N = mkWN (k48 "mauste") ; --UNCHK
lin condition_1_N = mkN "ehto" ;
lin condition_2_N = mkN "olosuhde" ;
lin condition_N = mkN "ehto" ;
lin condition_V2 = mkWV2 (k53A "käyttää") "hoitoainetta" ; --UNCHK
lin conditional_A = mkA "ehdollinen" ;
lin conditionality_N = mkWN (k40 "ehdollisuus") ; --UNCHK
lin conditioner_N = mkWN (k2 "kuntoilu") ; --UNCHK
lin conditioning_N = mkWN (compoundN "ehdollis" (k38 "taminen")) ; --UNCHK
lin conditions_N = mkWN (k18 "sää") ; --UNCHK
lin condole_V = mkWV (k53A "valittaa") "surua" ; --UNCHK
lin condolence_N = mkWN (compoundN "osan" (k1A "otto")) ; --UNCHK
lin condolent_A = mkWA "surua" "valittava" ; --UNCHK
lin condom_N = mkWN (k5A "kortonki") ; --UNCHK
lin condominium_N = mkWN (compoundN "asunto-osake" (k3 "yhtiö")) ; --UNCHK
lin condonation_N = mkWN (compoundN "anteeksi" (k1A "anto")) ; --UNCHK
lin condone_V2 = mkWV2 (k69 "suvaita") ; --UNCHK
lin condor_N = mkWN (compoundN "korppi" (k10 "kotka")) ; --UNCHK
lin conduce_V = mkWV (k67 "olla") "osallisena" ; --UNCHK
lin conducive_A = mkWA (compoundA "myötä" (k10 "vaikuttava")) ; --UNCHK
lin conduct_N = mkWN (k9A "toiminta") ; --UNCHK
lin conduct_V = mkWV (k53A "johtaa") ; --UNCHK
lin conduct_V2 = mkWV2 (k53A "johtaa") ; --f57
lin conductance_N = mkWN (k40 "johtavuus") ; --UNCHK
lin conducting_N = mkWN "johtaminen" ; --UNCHK
lin conduction_N = mkWN (k40 "johtavuus") ; --UNCHK
lin conductive_A = mkWA (k10 "johtava") ; --UNCHK
lin conductivity_N = mkWN (k40 "johtavuus") ; --UNCHK
lin conductor_N = mkN "johdin" ; ---ARB ; rahastaja ; kapellimestari
lin conductress_N = mkWN (k10 "johtaja") ; --UNCHK
lin conduit_N = mkWN (k7 "putki") ;
lin condylar_A = mkWA "nivelnastan" ; --UNCHK
lin condyle_N = mkWN (compoundN "nivel" (k9 "nasta")) ; --UNCHK
lin cone_N = mkWN (k3 "kartio") ; --UNCHK
lin cone_V2 = mkWV2 (k54A "suipentaa") ; --UNCHK
lin coneflower_N = mkWN (compoundN "päivän" (k1A "hattu")) ; --UNCHK
lin conenose_N = mkWN "Triatominae" ; --UNCHK
lin coney_N = mkWN (kH1 "kani") ; --UNCHK
lin confab_N = mkWN (k2 "keskustelu") ; --UNCHK
lin confab_V = mkWV (k67A "neuvotella") ; --UNCHK
lin confabulate_V = mkWV (k67A "neuvotella") ; --UNCHK
lin confabulation_N = mkWN (k2 "satuilu") ; --UNCHK
lin confection_N = mkWN (compoundN "valmis" (k38 "taminen")) ; --UNCHK
lin confectioner_N = mkWN (k6 "kondiittori") ; --UNCHK
lin confectionery_N = mkWN (k19 "työ") "sokerileipurin" ; --UNCHK
lin confederacy_N = mkWN (compoundN "sala" (k1A "liitto")) ; --UNCHK
lin confederate_A = mkWA "etelävaltioiden" ; --UNCHK
lin confederate_N = mkWN (k38 "osallinen") ; --UNCHK
lin confederate_V = mkWV (k53 "muodostaa") "valtioliitto" ; --UNCHK
lin confederate_V2 = mkWV2 (k53 "muodostaa") "valtioliitto" ; --UNCHK
lin confederation_N = mkWN (compoundN "liitto" (k38 "utuminen")) ; --UNCHK
lin confer_V = mkWV (k67A "neuvotella") ; --UNCHK
lin conferee_N = mkWN (compoundN "osan" (k10 "ottaja")) ; --UNCHK
lin conference_N = mkN "konferenssi" ;
lin conferment_N = mkWN "lahjoittaminen" ; --UNCHK
lin conferrer_N = mkWN (k12 "neuvottelija") ; --UNCHK
lin conferva_N = mkWN (compoundN "lanka" (k10 "levä")) ; --UNCHK
lin confess_V = mkWV (k54A "myöntää") ; --UNCHK
lin confess_V2 = mkWV2 (k54A "myöntää") ; --UNCHK
lin confess_VS = mkWVS (k54A "myöntää") ; --UNCHK
lin confessedly_Adv = mkWAdv (k99 "tosiaan") ; --UNCHK
lin confession_N = mkWN (k5A "rippi") ; --UNCHK
lin confessional_N = mkWN (compoundN "rippi" (k5 "tuoli")) ; --UNCHK
lin confessor_N = mkWN (compoundN "rippi-" (k10 "isä")) ; --UNCHK
lin confidantFem_N = mkWN (k10 "ystävä") "läheinen" ; --UNCHK
lin confidantMasc_N = mkWN (k10 "ystävä") "läheinen" ; --UNCHK
lin confidante_N = mkWN (k1A "uskottu") ; --UNCHK
lin confide_V = mkWV (k52A "uskoutua") ; --UNCHK
lin confide_V2 = mkWV2 (k52A "uskoutua") ; --UNCHK
lin confide_VS = mkWVS (k52A "uskoutua") ; --UNCHK
lin confidence_N = mkN "luottamus" ;
lin confident_A = mkA "luottavainen" ;
lin confidential_A = mkWA (k38 "luottamuksellinen") ;
lin confidentiality_N = mkWN (k40 "luottamuksellisuus") ; --UNCHK
lin configuration_N = mkWN (k10 "asetelma") ; --UNCHK
lin configurational_A = mkWA "muoto-" ; --UNCHK
lin configure_V2 = mkWV2 "konfiguroida" ; --UNCHK
lin confine_N = mkN "rajoite" ; --plurale tantum
lin confine_V2 = mkV2 "rajoittaa" partitive ; --mkWV2 (k54A "vähentää") ;
lin confinement_N = mkWN "vangitseminen" ; --UNCHK
lin confining_A = mkWA (k38 "rajallinen") ; --UNCHK
lin confirm_V2 = mkV2 "vahvistaa" | mkV2 "varmistaa" ;
lin confirm_VS = mkVS (mkV "vahvistaa") ;
lin confirmable_A = mkWA (k10 "oleva") "tarkistettavissa" ; --UNCHK
lin confirmation_N = mkWN (k3 "konfirmaatio") ; --UNCHK
lin confiscate_A = mkWA (compoundA "takavariko" (k1A "itu")) ; --UNCHK
lin confiscate_V2 = mkWV2 (k53A "ottaa") "haltuun" ; --UNCHK
lin confiscation_N = mkWN (k39 "lunastus") ; --UNCHK
lin confit_N = mkWN (kH1 "pata") ; --UNCHK
lin confiture_N = mkWN (compoundN "hedelmä" (k1 "hillo")) ; --UNCHK
lin conflagration_N = mkWN (k5 "pätsi") ; --UNCHK
lin conflict_N = mkN "konflikti" ; --WN (k14A "kahakka") ;
lin conflict_V = mkWV (k73A "loukata") ; --UNCHK
lin confluence_N = mkWN (compoundN "väen" (k39 "tungos")) ; --UNCHK
lin confluent_A = mkWA "sulautuva" ; --UNCHK
lin conform_V = mkWV (k52A "tottua") ; --UNCHK
lin conform_V2 = mkWV2 (k52A "tottua") ; --UNCHK
lin conformable_A = mkWA (k10 "vastaava") ; --UNCHK
lin conformation_N = mkWN (k40 "mukautuvuus") ; --UNCHK
lin conformist_A = mkWA (k38 "konservatiivinen") ; --UNCHK
lin conformist_N = mkWN "konformisti" ; --UNCHK
lin conformity_N = mkWN (k40 "mukautuvuus") ; --UNCHK
lin confound_V2 = mkWV2 (k52A "erehtyä") ; --UNCHK
lin confounding_A = mkWA (compoundA "risti" (k38 "riitainen")) ; --UNCHK
lin confrere_N = mkWN (k13 "kollega") ; --UNCHK
lin confront_V2 = mkWV2 (k73A "kohdata") ; --UNCHK
lin confrontation_N = mkN "vastakkainasettaminen" ;
lin confrontational_A = mkWA "konfrontaatio-" ; --UNCHK
lin confucian_A = mkWA (k38 "konfutselainen") ; --UNCHK
lin confucian_N = mkWN (k38 "konfutselainen") ; --UNCHK
lin confuse_V2 = mkWV2 (k52A "erehtyä") ; --UNCHK
lin confused_A = mkA "sekava" ;
lin confusing_A = mkWA (k10 "sekava") ; --UNCHK
lin confusion_N = mkWN (compoundN "seka" (k38 "antuminen")) ; --UNCHK
lin confutation_N = mkWN (k48 "todiste") "kumoava" ; --UNCHK
lin confute_V2 = mkWV2 (k53A "osoittaa") "vääräksi" ; --UNCHK
lin conga_N = mkWN (compoundN "konga-" (k5 "tanssi")) ; --UNCHK
lin conge_N = mkWN (compoundN "ero" (k38 "ttaminen")) ; --UNCHK
lin congeal_V = mkWV (k52A "asettua") ; --UNCHK
lin congeal_V2 = mkWV2 (k52A "asettua") ; --UNCHK
lin congealment_N = mkWN (compoundN "jää" (k38 "dyttäminen")) ; --UNCHK
lin congee_N = mkWN (compoundN "ero" (k38 "ttaminen")) ; --UNCHK
lin congener_N = mkWN (k38 "samanlainen") ; --UNCHK
lin congenial_A = mkWA (k38 "mieluinen") ; --UNCHK
lin congeniality_N = mkWN (compoundN "hengen" (k40 "heimolaisuus")) ; --UNCHK
lin congenialness_N = mkWN (compoundN "saman" (k40 "henkisyys")) ; --UNCHK
lin congenital_A = mkWA (k38 "synnynnäinen") ; --UNCHK
lin conger_N = mkWN (compoundN "meri" (k41 "ankerias")) ; --UNCHK
lin conger_eel_N = mkWN (compoundN "meri" (k41 "ankerias")) ; --UNCHK
lin congested_A = mkWA "tukkeutunut" ; --UNCHK
lin congestion_N = mkWN (k39 "tungos") ; --UNCHK
lin congestive_A = mkWA "kongestiivinen" ; --UNCHK
lin congleton_PN = foreignPN "Congleton" ;
lin conglomerate_A = mkWA (compoundA "sula" (k47 "utunut")) "yhteen" ; --UNCHK
lin conglomerate_N = mkWN (compoundN "moniala" (k10 "yhtymä")) ; --UNCHK
lin conglomerate_V = mkWV (k52A "kertyä") ; --UNCHK
lin conglomerate_V2 = mkWV2 (k52A "kertyä") ; --UNCHK
lin conglomeration_N = mkWN (compoundN "kas" (k38 "aantuminen")) ; --UNCHK
lin congolese_A = mkWA (compoundA "kongo" (k38 "lainen")) ; --UNCHK
lin congolese_N = mkWN (compoundN "kongo" (k38 "lainen")) ; --UNCHK
lin congou_N = mkWN (compoundN "congou-" (k18 "tee")) ; --UNCHK
lin congratulate_V2 = mkWV2 (k52 "lausua") "kohteliaisuus" ; --UNCHK
lin congratulation_N = mkWN (k2 "onnittelu") ; --UNCHK
lin congratulatory_A = mkWA "onnittelu-" ; --UNCHK
lin congregant_N = mkWN (k32 "jäsen") "seurakunnan" ; --UNCHK
lin congregate_V = mkWV (k52A "kerääntyä") ; --UNCHK
lin congregate_V2 = mkWV2 (k52A "kerääntyä") ; --UNCHK
lin congregation_N = mkWN (compoundN "koko" (k38 "ontuminen")) ; --UNCHK
lin congregational_A = mkWA (compoundA "seura" (k38 "kunnallinen")) ; --UNCHK
lin congress_N = mkN "kongressi" ;
lin congressional_A = mkA "kongressionaalinen" ;
lin congressman_N = mkN "kongressi" (mkWN (k10 "edustaja")) ;
lin congresswoman_N = mkWN (k10 "edustaja") ; --UNCHK
lin congruent_A = mkWA (compoundA "yhtenevä" (k38 "inen")) ; --UNCHK
lin congruity_N = mkWN (k40 "soveliaisuus") ; --UNCHK
lin congruous_A = mkWA (k10 "vastaava") ; --UNCHK
lin conic_A = mkWA (compoundA "keila" (k38 "mainen")) ; --UNCHK
lin conical_A = mkWA (compoundA "keila" (k38 "mainen")) ; --UNCHK
lin conidiophore_N = mkWN (compoundN "konidiof" (k48 "ori")) ; --UNCHK
lin conidium_N = mkWN (compoundN "kur" (k10 "oma")) ; --UNCHK
lin conifer_N = mkWN (compoundN "havu" (k18 "puu")) ; --UNCHK
lin coniferous_A = mkWA "havupuun" ; --UNCHK
lin conima_N = mkWN (compoundN "kumi" (k5 "hartsi")) ; --UNCHK
lin conjectural_A = mkWA (k38 "hypoteettinen") ; --UNCHK
lin conjecture_N = mkWN (k10 "otaksuma") ; --UNCHK
lin conjecture_V = mkWV (k52 "otaksua") ; --UNCHK
lin conjecture_V2 = mkWV2 (k52 "otaksua") ; --UNCHK
lin conjoin_V = mkWV (k53 "yhdistää") ; --UNCHK
lin conjoin_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin conjugal_A = mkWA (k38 "aviollinen") ; --UNCHK
lin conjugate_A = mkWA (compoundA "konjugo" (k1A "itu")) ; --UNCHK
lin conjugate_V = mkWV (k62 "konjugoida") ; --UNCHK
lin conjugate_V2 = mkWV2 (k62 "konjugoida") ; --UNCHK
lin conjugation_N = mkWN (compoundN "liitto" (k38 "utuminen")) ; --UNCHK
lin conjunct_A = mkWA "sävelkulku-" ; --UNCHK
lin conjunction_N = mkWN (k48 "yhdiste") ; --UNCHK
lin conjunctiva_N = mkWN (compoundN "side" (k1 "kalvo")) ; --UNCHK
lin conjunctival_A = mkWA "sidekalvon" ; --UNCHK
lin conjunctive_A = mkWA "yhdistävä" ; --UNCHK
lin conjunctive_N = mkWN (k3 "konjunktio") ; --UNCHK
lin conjunctivitis_N = mkWN (compoundN "sidekalvon" (k39 "tulehdus")) ; --UNCHK
lin conjuncture_N = mkWN (k10A "käännekohta") ; --UNCHK
lin conjuration_N = mkWN (k3 "illuusio") ; --UNCHK
lin conjure_V = mkWV (k67A "juonitella") ; --UNCHK
lin conjure_V2 = mkWV2 (k67A "juonitella") ; --UNCHK
lin conjure_up_V2 = mkWV2 (k64 "tuoda") "esiin" ; --UNCHK
lin conjurer_N = mkWN (k6 "puoskari") ; --UNCHK
lin conjuring_N = mkWN (k39 "kirous") ; --UNCHK
lin conjuror_N = mkWN (k6 "puoskari") ; --UNCHK
lin conk_N = mkWN (k10A "nokka") ; --UNCHK
lin conk_V = mkWV (k53A "menettää") "tajuntansa" ; --UNCHK
lin conk_out_V = mkWV (k52 "väsyä") ; --UNCHK
lin conker_N = mkWN (compoundN "hevos" (k12 "kastanja")) ; --UNCHK
lin connate_A = mkWA (compoundA "yhteen" (k47 "kasvanut")) ; --UNCHK
lin connatural_A = mkWA (k38 "luontainen") ; --UNCHK
lin connect_V = mkWV (k63 "saada") "yhteys" ; --UNCHK
lin connect_V2 = mkWV2 (k63 "saada") "yhteys" ; --UNCHK
lin connected_A = mkA "yhdistetty" ;
lin connecticut_PN = mkPN "Connecticut" ;
lin connection_N = mkWN (k40 "yhteys") ;
lin connective_A = mkWA "yhdistävä" ; --UNCHK
lin connective_N = mkWN (k33A "liitin") ; --UNCHK
lin connectivity_N = mkWN (k40 "yhteys") ; --UNCHK
lin connexion_N = mkWN (k40 "yhteys") ; --UNCHK
lin connivance_N = mkWN (compoundN "hyvä" (k38 "ksyminen")) "äänetön" ; --UNCHK
lin connive_V = mkWV (k67A "suunnitella") ; --UNCHK
lin connoisseur_N = mkWN (k12 "tuntija") ; --UNCHK
lin connotation_N = mkWN (compoundN "lisä" (k39 "merkitys")) ; --UNCHK
lin connotational_A = mkWA "konnotaation" ; --UNCHK
lin connotative_A = mkWA (k38 "viitteellinen") ; --UNCHK
lin connote_V2 = mkWV2 (k73 "vihjata") ; --UNCHK
lin connubial_A = mkWA (k38 "aviollinen") ; --UNCHK
lin conodont_N = mkWN "Conodon" ; --UNCHK
lin conquer_V2 = mkWV2 (k53A "taltuttaa") ; --UNCHK
lin conquerable_A = mkWA (k10 "oleva") "voitettavissa" ; --UNCHK
lin conqueror_N = mkWN (k10 "valloittaja") ; --UNCHK
lin conquest_N = mkWN (k39 "valloitus") ; --UNCHK
lin conquistador_N = mkWN (k5 "konkistadori") ; --UNCHK
lin consanguinity_N = mkWN (k40 "sukulaisuus") ; --UNCHK
lin conscience_N = mkWN (k51 "omatunto") ; --UNCHK
lin conscienceless_A = mkWA (k34A "häikäilemätön") ; --UNCHK
lin conscientious_A = mkWA "omantunnontarkka" ; --UNCHK
lin conscientiousness_N = mkWN (k40 "huolellisuus") ; --UNCHK
lin conscionable_A = mkWA (k10 "hyväksyttävä") "moraalisesti" ; --UNCHK
lin conscious_A = mkWA (k38 "tietoinen") ; --UNCHK
lin consciousness_N = mkWN (k1 "taju") ; --UNCHK
lin conscript_N = mkWN (compoundN "ase" (k38 "velvollinen")) ; --UNCHK
lin conscript_V2 = mkWV2 (k73 "värvätä") ; --UNCHK
lin conscription_N = mkWN (k9A "kutsunta") ; --UNCHK
lin consecrate_V2 = mkWV2 (k61A "vihkiä") ; --UNCHK
lin consecration_N = mkWN (compoundN "pyh" (k38 "ittäminen")) ; --UNCHK
lin consecutive_A = mkWA (k38 "peräkkäinen") ;
lin consecutive_Adv = mkWAdv (k99 "peräkkäisesti") ; --UNCHK
lin consensual_A = mkWA (compoundA "kon" (k38 "sensuaalinen")) ; --UNCHK
lin consensus_N = mkWN (k39 "konsensus") ;
lin consent_N = mkWN (k39 "suostumus") ;
lin consent_V = mkWV (k52A "taipua") ; --UNCHK
lin consent_V2V = mkWV2V (k52A "taipua") ; --UNCHK
lin consentaneous_A = mkWA (compoundA "yks" (k38 "imielinen")) ; --UNCHK
lin consequence_N = mkN "seuraus" ;
lin consequent_A = mkA "johdonmukainen" ;
lin consequential_A = mkWA (k10 "muistettava") ; --UNCHK
lin conservancy_N = mkWN (compoundN "luonnon" (k2 "suojelu")) ; --UNCHK
lin conservation_N = mkWN (compoundN "ympäristön" (k2 "suojelu")) ; --UNCHK
lin conservatism_N = mkWN (k40 "vanhoillisuus") ; --UNCHK
lin conservative_1_N = mkN "konservatiivi" ;
lin conservative_2_N = mkN "säilöntäaine" ;
lin conservative_A = mkWA (k38 "konservatiivinen") ; --f85
lin conservatoire_N = mkWN (k3 "konservatorio") ; --UNCHK
lin conservator_N = mkWN (compoundN "edun" (k10 "valvoja")) ; --UNCHK
lin conservatory_N = mkWN "talvipuutarha" ; --UNCHK
lin conserve_N = mkWN (k48A "hilloke") ; --UNCHK
lin conserve_V2 = mkWV2 (k52 "säilöä") ; --UNCHK
lin consett_PN = foreignPN "Consett" ;
lin consider_V = mkV vOlla "mieltä" ;
lin consider_V2 = mkV2 "harkita" partitive ;
lin consider_V2A = mkV2A (mkV "pitää") (mkPrep partitive) (mkPrep essive) ;
lin consider_V2V = mkV2V (mkV "arvella" "alveli") genitive infPresPart ;
lin consider_V3 = mkV3 (mkV "pitää") (mkPrep partitive) (mkPrep essive) ;
lin consider_VS = mkVS (mkV "arvella" "arveli") ;
lin consider_VV = mkVV "harkita" infPresPart ;
lin considerable_A = mkA "huomattava" | mkWA (k10 "varteenotettava") ;
lin considerate_A = mkWA (k38 "huomaavainen") ; --UNCHK
lin considerateness_N = mkWN (k40 "ystävällisyys") ; --UNCHK
lin consideration_N = mkWN (k40 "huomaavaisuus") ;
lin considering_Prep = mkPrep "huomioonottaen" ;
lin considering_Subj = mkSubj "huomioonottaen" ;
lin consign_V2 = mkWV2 (k52 "uskoa") "haltuun" ; --UNCHK
lin consignee_N = mkWN (k10 "saaja") ; --UNCHK
lin consigner_N = mkWN (k10 "lähettäjä") ; --UNCHK
lin consignment_N = mkWN (compoundN "tavara" (k39 "lähetys")) ; --UNCHK
lin consignor_N = mkWN (k10 "lähettäjä") ; --UNCHK
lin consist_V = mkV "koostua" ;
lin consistence_N = mkWN (k40 "loogisuus") ; --UNCHK
lin consistency_N = mkWN (k40 "loogisuus") ; --UNCHK
lin consistent_A = mkA "johdonmukainen" ;
lin consistory_N = mkWN (k6 "konsistori") ; --UNCHK
lin consolable_A = mkWA (k10 "oleva") "lohdutettavissa" ; --UNCHK
lin consolation_N = mkWN (k39 "helpotus") ; --UNCHK
lin consolatory_A = mkWA (k38 "lohdullinen") ; --UNCHK
lin console_N = mkWN (k6 "konsoli") ; --UNCHK
lin console_V2 = mkWV2 (k53A "lievittää") ; --UNCHK
lin consolidate_V = mkWV (k53 "vahvistaa") ; --UNCHK
lin consolidate_V2 = mkWV2 (k53 "vahvistaa") ;
lin consolidation_N = mkWN (compoundN "yhteen" (k38 "sovittaminen")) ; --UNCHK
lin consolidative_A = mkWA (compoundA "integr" (k10 "oiva")) ; --UNCHK
lin consomme_N = mkWN (compoundN "liha" (k25 "liemi")) ; --UNCHK
lin consonance_N = mkWN (k12 "harmonia") ; --UNCHK
lin consonant_A = mkWA (k10 "vastaava") ; --UNCHK
lin consonant_N = mkWN (k48A "kerake") ; --UNCHK
lin consonantal_A = mkWA "konsonantti-" ; --UNCHK
lin consort_N = mkWN (compoundN "soitin" (k10 "ryhmä")) ; --UNCHK
lin consort_V = mkWV (k52A "liikkua") "yhdessä" ; --UNCHK
lin consortium_N = mkN "konsortio" ;
lin conspecific_N = mkWN (k10 "kuuluva") "samaan" "lajiin" ; --UNCHK
lin conspectus_N = mkWN (compoundN "yleis" (k39 "katsaus")) ; --UNCHK
lin conspicuous_A = mkWA (k10 "näkyvä") ; --UNCHK
lin conspicuousness_N = mkWN (k40 "näkyvyys") ; --UNCHK
lin conspiracy_N = mkWN (compoundN "sala" (k48A "hanke")) ; --UNCHK
lin conspirator_N = mkWN (k12 "juonittelija") ; --UNCHK
lin conspiratorial_A = mkWA "vehkeily-" ; --UNCHK
lin conspire_V = mkWV (k67A "juonitella") ; --UNCHK
lin conspire_V2 = mkWV2 (k67A "juonitella") ; --UNCHK
lin conspire_V2V = mkWV2V (k67A "juonitella") ; --UNCHK
lin constable_N = mkWN (k6 "konstaapeli") ; --UNCHK
lin constabulary_N = mkWN (k6 "poliisi") ; --UNCHK
lin constancy_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin constant_A = mkA "jatkuva" ;
lin constant_N = mkN "vakio" "vakioita" ;
lin constellation_N = mkWN (k10 "asetelma") ; --UNCHK
lin consternation_N = mkWN (k39 "tyrmistys") ; --UNCHK
lin constipate_1_V2 = mkWV2 (k53A "aiheuttaa") "ummetusta" ; --UNCHK
lin constipate_2_V2 = mkWV2 (k53A "aiheuttaa") "ummetusta" ; --UNCHK
lin constipation_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin constituency_N = mkWN (compoundN "valitsija" (k10A "kunta")) ; --UNCHK
lin constituent_A = mkWA (k10 "osa") "olennainen" ; --UNCHK
lin constituent_N = mkWN (k5A "komponentti") ; --UNCHK
lin constitute_V2 = mkV2 "muodostaa" ;
lin constitution_N = mkN "perustus" (mkN "laki") | mkN "koostumus" ; ---- split
lin constitutional_A = mkWA (compoundA "perustus" (k38 "laillinen")) ;
lin constitutional_N = mkWN (compoundN "kävely" (k5A "lenkki")) ; --UNCHK
lin constitutionalism_N = mkWN (compoundN "perustus" (k40 "laillisuus")) ; --UNCHK
lin constitutionalist_N = mkWN (k10 "kannattaja") "perustuslaillisuuden" ; --UNCHK
lin constitutionalize_V2 = mkWV2 (k53A "ottaa") "perustuslakiin" ; --UNCHK
lin constitutive_A = mkA "perustava" ;
lin constrain_V2 = mkV2 "rajoittaa" ;
lin constrainedly_Adv = mkWAdv (k99 "väkinäisesti") ; --UNCHK
lin constraint_N = mkN "rajoite" ;
lin constrict_V2 = mkWV2 (k52A "kaventua") ; --UNCHK
lin constriction_N = mkWN "kokoon" "vetäminen" ; --UNCHK
lin constrictor_N = mkWN (compoundN "kuristaja" (k48 "käärme")) ; --UNCHK
lin construal_N = mkWN (k39 "selitys") ; --UNCHK
lin construct_V2 = mkWV2 (k54A "jäljentää") ; --UNCHK
lin construction_N = mkN "konstruktio" "konstruktioita" ;
lin constructive_A = mkWA (k10 "rakentava") | mkA "konstruktiivinen" ;
lin constructiveness_N = mkN "rakentavuus" ;
lin constructivism_N = mkWN (k5 "konstruktivismi") ; --UNCHK
lin constructivist_N = mkWN (compoundN "konstrukti" (k5 "visti")) ; --UNCHK
lin constructor_N = mkWN (k10 "rakentaja") ; --UNCHK
lin construe_V = mkWV (k53A "käsittää") ; --UNCHK
lin construe_V2 = mkWV2 (k53A "käsittää") ; --UNCHK
lin construe_V2V = mkWV2V (k53A "käsittää") ; --UNCHK
lin consubstantiation_N = mkWN "konsubstantiaatio" ; --UNCHK
lin consuetude_N = mkWN (compoundN "tapa" (k40 "oikeus")) ; --UNCHK
lin consuetudinary_N = mkWN "consuetudinarius" ; --UNCHK
lin consul_N = mkWN (k6 "konsuli") ; --UNCHK
lin consular_A = mkWA "konsuli-" ; --UNCHK
lin consulate_N = mkWN (k5A "konsulaatti") ; --UNCHK
lin consulship_N = mkWN (k10 "asema") "konsulin" ; --UNCHK
lin consult_V = mkV (mkV "pyytää") "neuvoa" ;
lin consult_V2 = mkV2 "konsultoida" partitive ; --WV2 (k61 "toimia") "neuvonantajana" ;
lin consultancy_N = mkWN (k5A "konsultointi") ;
lin consultant_N = mkWN (k5A "konsultti") ;
lin consultation_N = mkWN (k5A "konsultointi") ; --UNCHK
lin consultative_A = mkWA (k10 "neuvoa-antava") ; --UNCHK
lin consumable_A = mkWA "kuluva" ; --UNCHK
lin consume_V = mkWV (k53A "kuluttaa") ; --UNCHK
lin consume_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin consumer_N = mkWN (k10 "kuluttaja") ;
lin consumerism_N = mkWN (k10 "kuluttajansuoja") ; --UNCHK
lin consummate_A = mkWA (k10 "syvä") ; --UNCHK
lin consummate_V2 = mkWV2 (k56A "saattaa") "täydelliseksi" ; --UNCHK
lin consummation_N = mkWN (compoundN "täydellis" (k38 "täminen")) ; --UNCHK
lin consumption_N = mkWN (k39 "kulutus") ;
lin consumptive_A = mkA "kuluttava" ;
lin consumptive_N = mkWN (k38 "ihminen") "tuberkuloottinen" ; --UNCHK
lin contact_N = mkN "kontakti" | mkWN (k40 "yhteys") ;
lin contact_V2 = mkV2 (mkV (mkV "ottaa") "yhteyttä") illative ;
lin contadino_N = mkWN "contadino" ; --UNCHK
lin contagion_N = mkWN (k9A "tartunta") ; --UNCHK
lin contagious_A = mkA "tarttuva" ; --WA (compoundA "tartunta" (k38 "vaarallinen")) ;
lin contain_V2 = mkV2 "sisältää" | mkV2 "pidätellä" ; ---- split
lin container_N = mkWN (k3 "säiliö") ; --UNCHK
lin containerful_N = mkN "säiliöllinen" | mkWN "kontillinen" ;
lin containment_N = mkWN "tukahduttaminen" ; --UNCHK
lin contaminant_N = mkWN (k48 "saaste") ; --UNCHK
lin contaminate_V2 = mkWV2 (k53A "saastuttaa") ; --UNCHK
lin contamination_N = mkWN (compoundN "pila" (k38 "aminen")) ; --UNCHK
lin contaminative_A = mkWA (compoundA "saas" (k10 "tuttava")) ; --UNCHK
lin contemn_V2 = mkWV2 (k52 "halveksua") ; --UNCHK
lin contemplate_V = mkWV (k61 "tuumia") ; --UNCHK
lin contemplate_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin contemplate_VS = mkWVS (k61 "tuumia") ; --UNCHK
lin contemplation_N = mkWN (k2 "tutkiskelu") ; --UNCHK
lin contemplative_A = mkWA (k10 "harkitseva") ; --UNCHK
lin contemplative_N = mkWN (k12 "mietiskelijä") ; --UNCHK
lin contemporaneity_N = mkWN (compoundN "saman" (k40 "aikaisuus")) ; --UNCHK
lin contemporaneous_A = mkWA (k38 "aikalainen") ; --UNCHK
lin contemporary_A = mkWA (k38 "nykyinen") ; --UNCHK
lin contemporary_N = mkWN (k38 "aikalainen") ; --UNCHK
lin contempt_N = mkWN "oikeuden" "halventaminen" ; --UNCHK
lin contemptible_A = mkWA (k38 "alhainen") ; --UNCHK
lin contemptuousness_N = mkWN (k10A "halveksunta") ; --UNCHK
lin contend_V = mkWV (k53A "pitää") "selviönä" ; --UNCHK
lin contend_VS = mkVS (mkV (mkV "pitää") "selviönä") ; --f93
lin contender_N = mkWN (k10 "haastaja") ; --UNCHK
lin content_A = mkWA (k38 "tyytyväinen") ; --UNCHK
lin content_N = mkWN (k48 "aihe") ; --UNCHK
lin content_V2 = mkWV2 (k52A "tyytyä") ; --UNCHK
lin contentedly_Adv = mkWAdv (k99 "tyynesti") ; --UNCHK
lin contentedness_N = mkWN (k40 "tyytyväisyys") ; --UNCHK
lin contention_N = mkN "kiista" ; ---ARB --mkN "väite" ; --mkWN (k2 "kilpailu") ;
lin contentious_A = mkWA (compoundA "kiistan" (k38 "alainen")) ;
lin contentment_N = mkWN (k40 "tyytyväisyys") ; --UNCHK
lin contents_N = mkWN (k39 "sisällys") ; --UNCHK
lin conterminous_A = mkWA (compoundA "saman" (k38 "laajuinen")) ; --UNCHK
lin contest_N = mkN (lin NK {s = d02 "kilpailu"}) ;
lin contest_V = mkWV (k53 "kyseenalaistaa") ; --UNCHK
lin contest_V2 = mkWV2 (k53 "kyseenalaistaa") ; --UNCHK
lin contestable_A = mkWA (compoundA "kiistan" (k38 "alainen")) ; --UNCHK
lin contestant_N = mkWN (k12 "kilpailija") ; --UNCHK
lin contestee_N = mkWN (k10 "voittaja") "kiistanalainen" ; --UNCHK
lin context_N = mkN "konteksti" | mkWN (k40 "yhteys") ;
lin contextual_A = mkWA (compoundA "kontekstua" (k38 "alinen")) ; --UNCHK
lin contextualism_N = mkWN (compoundN "kontekstual" (k5 "ismi")) ; --UNCHK
lin contiguity_N = mkWN (k40 "vierekkäisyys") ; --UNCHK
lin contiguous_A = mkWA (k34A "välitön") ; --UNCHK
lin continence_N = mkWN (k40 "pidättyvyys") ; --UNCHK
lin continent_A = mkWA (compoundA "pidätysky" (k38 "kyinen")) ; --UNCHK
lin continent_N = mkWN "Manner-Eurooppa" ; --UNCHK
lin continental_A = mkA "mannermainen" ;
lin contingency_N = mkN "riippuvuus" ; --mkWN (k10 "sattuma") "mahdollinen" ;
lin contingent_A = mkA "riippuva" ; --mkWA (compoundA "sattuman" (k38 "varainen")) ;
lin contingent_N = mkWN (k48 "joukkue") ; --UNCHK
lin continual_A = mkWA (kH1 "lakkaamaton") ;
lin continuance_N = mkWN "jatkaminen" ; --UNCHK
lin continuation_N = mkWN "jatkaminen" ; --UNCHK
lin continue_V = mkV "jatkua" ;
lin continue_V2 = mkV2 (mkV "jatkaa") partitive ;
lin continue_VV = mkVV (mkV "jatkaa") ; --- add more Inf3 forms *jatkaa kulkea
lin continue_on_V = advV OP_continue_V OP_on_Adv ; -- guess-p-verb
lin continued_A = variants {} ; --
lin continuing_A = variants {} ; --
lin continuity_N = mkWN (k40 "yhtäjaksoisuus") ; --UNCHK
lin continuous_A = mkWA (k34A "keskeytymätön") ; --UNCHK
lin continuousness_N = mkWN (k40 "yhtäjaksoisuus") ; --UNCHK
lin continuum_N = mkWN (k2 "jatkumo") ; --UNCHK
lin conto_N = mkWN "conto" ; --UNCHK
lin contort_V2 = mkWV2 (k67 "turmella") ; --UNCHK
lin contortion_N = mkWN (k2 "vääristely") ; --UNCHK
lin contortionist_N = mkWN (compoundN "käärme" (k38 "ihminen")) ; --UNCHK
lin contour_N = mkWN (k10 "asetelma") ; --UNCHK
lin contour_V2 = mkWV2 (k53 "muodostaa") "ääriviivat" ; --UNCHK
lin contra_Prep = mkPrep partitive "vastaan" ;
lin contraband_N = mkWN (compoundN "salakuljetus" (k12 "tavara")) ; --UNCHK
lin contrabass_A = mkWA "basso-" ; --UNCHK
lin contrabass_N = mkWN (compoundN "basso" (k1 "viulu")) ; --UNCHK
lin contrabassoon_N = mkWN (compoundN "kontra" (k5A "fagotti")) ; --UNCHK
lin contraception_N = mkWN (k2 "säännöstely") "syntyvyyden" ; --UNCHK
lin contraceptive_A = mkWA "ehkäisy-" ; --UNCHK
lin contraceptive_N = mkWN (compoundN "ehkäisy" (k48 "väline")) ; --UNCHK
lin contract_N = mkN "sopimus" ;
lin contract_V = mkWV (k63 "saada") ; --UNCHK
lin contract_V2 = mkV2 (mkV (mkV "ottaa") "palvelukseen") ; --mkWV2 (k63 "saada") ;
lin contract_V2V = mkWV2V (k63 "saada") ; --UNCHK
lin contractile_A = mkWA (compoundA "supistumisky" (k38 "kyinen")) ; --UNCHK
lin contractility_N = mkWN (compoundN "supistumis" (k1A "kyky")) ; --UNCHK
lin contraction_N = mkWN (k39 "supistus") ;
lin contractor_N = mkN "osapuoli" ;
lin contractual_A = mkWA "sopimus-" ; --UNCHK
lin contracture_N = mkWN (compoundN "kontrak" (k10 "tuura")) ; --UNCHK
lin contradict_V2 = mkWV2 (k54A "kieltää") ; --UNCHK
lin contradiction_N = mkWN (compoundN "kii" (k38 "stäminen")) ; --UNCHK
lin contradictoriness_N = mkWN "kontradiktorisuus" ; --UNCHK
lin contradictory_A = mkWA "toisensa" "poissulkevat" ; --UNCHK
lin contradictory_N = mkWN (k3 "propositio") "vastakkainen" ; --UNCHK
lin contradistinction_N = mkWN "vastakohtaisuus" ; --UNCHK
lin contradistinguish_V2 = mkWV2 (k53A "erottaa") "vastakohtana" ; --UNCHK
lin contrail_N = mkWN (k9 "vana") ; --UNCHK
lin contraindication_N = mkWN (compoundN "vasta-" (k48 "aihe")) ; --UNCHK
lin contralateral_A = mkWA (compoundA "vasta" (k38 "puolinen")) ; --UNCHK
lin contralto_N = mkWN (k1A "altto") ; --UNCHK
lin contraption_N = mkWN (k5A "värkki") ; --UNCHK
lin contrapuntal_A = mkWA (k38 "kontrapunktinen") ; --UNCHK
lin contrapuntist_N = mkWN "kontrapunktikko" ; --UNCHK
lin contrariety_N = mkWN "vastakohtaisuus" ; --UNCHK
lin contrariness_N = mkWN (k40 "uppiniskaisuus") ; --UNCHK
lin contrarious_A = mkWA (k1 "häijy") ; --UNCHK
lin contrariwise_Adv = mkWAdv (k99 "vastakkain") ; --UNCHK
lin contrary_A = mkWA (k38 "vastakkainen") ; --UNCHK
lin contrary_N = mkWN (k10A "vastakohta") ; --UNCHK
lin contrast_N = mkWN (k2 "vertailu") ; --f59
lin contrast_V = mkWV (k73A "verrata") ; --UNCHK
lin contrast_V2 = mkWV2 (k73A "verrata") ; --UNCHK
lin contrastingly_Adv = mkWAdv "vastakohtana" ; --UNCHK
lin contrastive_A = mkWA (compoundA "kontrasti" (k38 "ivinen")) ; --UNCHK
lin contrasty_A = mkWA (compoundA "kontrasti" (k38 "ivinen")) ; --UNCHK
lin contravene_V2 = mkWV2 (k53 "vastustaa") ; --UNCHK
lin contravention_N = mkWN (k2 "väittely") ; --UNCHK
lin contretemps_N = mkWN (k39 "kömmähdys") ; --UNCHK
lin contribute_V = mkV "osallistua" ;
lin contribute_V2 = mkWV2 (k56 "maksaa") "osansa" ; --UNCHK
lin contribution_N = mkN "kontribuutio" ;
lin contributor_N = mkWN (k10 "avustaja") ; --UNCHK
lin contributory_A = mkWA (compoundA "myötä" (k10 "vaikuttava")) ; --UNCHK
lin contrite_A = mkWA (k15 "surkea") ; --UNCHK
lin contrition_N = mkWN (k39 "katumus") ; --UNCHK
lin contrivance_N = mkWN (compoundN "keksi" (k38 "minen")) ; --UNCHK
lin contrive_V = mkWV (k73A "kekata") ; --UNCHK
lin contrive_V2 = mkWV2 (k73A "kekata") ; --UNCHK
lin contriver_N = mkWN (k12 "keksijä") ; --UNCHK
lin control_N = mkN "kontrolli" ;
lin control_V2 = mkV2 "kontrolloida" partitive ;
lin controllable_A = mkWA (k10 "ohjattava") ; --UNCHK
lin controlled_A = variants {} ; --
lin controller_N = mkWN (k33A "säädin") ;
lin controllership_N = mkWN (k10 "asema") "varainhoidon" "valvojan" ; --UNCHK
lin controlling_A = mkWA (k10 "määräävä") ; --UNCHK
lin controversial_A = mkWA (compoundA "kiistan" (k38 "alainen")) ;
lin controversialist_N = mkWN (k1A "poleemikko") ; --UNCHK
lin controversy_N = mkN "kiista" ;
lin controvert_V2 = mkWV2 (k53A "osoittaa") ; --UNCHK
lin contumacious_A = mkWA (compoundA "epä" (k38 "kuuliainen")) ; --UNCHK
lin contumacy_N = mkWN (k2 "niskoittelu") ; --UNCHK
lin contumelious_A = mkWA (k15 "julkea") ; --UNCHK
lin contumely_N = mkWN (k2 "panettelu") ; --UNCHK
lin contuse_V2 = mkWV2 (k61 "kolhia") "mustelmille" ; --UNCHK
lin contusion_N = mkWN (k48 "ruhje") ; --UNCHK
lin conundrum_N = mkWN (k10 "pulma") ; --UNCHK
lin conurbation_N = mkWN (compoundN "asutus" (k1 "ketju")) ; --UNCHK
lin convalesce_V = mkWV (k52A "tervehtyä") ; --UNCHK
lin convalescence_N = mkWN (compoundN "pala" (k38 "utuminen")) ; --UNCHK
lin convalescent_A = mkWA "toipilas-" ; --UNCHK
lin convalescent_N = mkWN (k41 "toipilas") ; --UNCHK
lin convection_N = mkWN (k39 "virtaus") "lämmön" ; --UNCHK
lin convector_N = mkWN (compoundN "lämpö" (k6 "patteri")) ; --UNCHK
lin convene_V = mkWV (k52 "kutsua") "kokoon" ; --UNCHK
lin convene_V2 = mkWV2 (k52 "kutsua") "kokoon" ;
lin convener_N = mkWN (compoundN "kokoon" (k10 "kutsuja")) ; --UNCHK
lin convenience_N = mkN "mukavuus" ; --WN (k5A "värkki") ;
lin convenient_A = mkWA (k10 "sopiva") ;
lin convent_N = mkWN (k6 "luostari") ; --UNCHK
lin conventicle_N = mkWN (compoundN "kokous" (k48 "huone")) ; --UNCHK
lin convention_N = mkWN (compoundN "koko" (k38 "ontuminen")) ; --UNCHK
lin conventional_A = mkWA (k38 "sovinnainen") ; --f60
lin conventionality_N = mkWN (k40 "sovinnaisuus") ; --UNCHK
lin conventionalized_A = mkWA "tyylitelty" ; --UNCHK
lin conventioneer_N = mkWN (k10 "osallistuja") "konventin" ; --UNCHK
lin converge_V = mkWV (k52A "lähentyä") ; --UNCHK
lin convergence_N = mkWN "läheneminen" ; --UNCHK
lin convergent_A = mkWA (compoundA "lähen" (k10 "evä")) ; --UNCHK
lin conversation_N = mkWN (k2 "keskustelu") ;
lin conversational_A = mkWA (compoundA "arki" (k38 "kielinen")) ; --UNCHK
lin conversationalist_N = mkWN (k12 "keskustelija") "taitava" ; --UNCHK
lin converse_A = mkWA (k38 "käänteinen") ; --UNCHK
lin converse_N = mkWN (k2 "keskustelu") ; --UNCHK
lin converse_V = mkWV (k56A "vaihtaa") "mielipiteitä" ; --UNCHK
lin conversion_N = mkWN (k38 "uudestisyntyminen") ; --UNCHK
lin convert_N = mkWN (k38 "käännynnäinen") ; --UNCHK
lin convert_V = mkWV (k52A "muuntua") ; --UNCHK
lin convert_V2 = mkV2 "muuntaa" ; --f56
lin converter_N = mkWN (k33A "muunnin") ;
lin convertibility_N = mkWN (k40 "vaihdettavuus") ; --UNCHK
lin convertible_A = mkWA (k10 "vaihdettava") ; --f109
lin convertible_N = separateN "vaihdettava" (mkN "arvopaperi") ; ---ARB --mkWN (compoundN "avo" (k1 "auto")) ;
lin convex_A = mkWA (k10 "kupera") ; --UNCHK
lin convexity_N = mkWN "kuperuus" ; --UNCHK
lin convey_V2 = mkWV2 (k53A "välittää") ;
lin conveyance_N = mkWN (k1A "siirto") ; --UNCHK
lin conveyancer_N = mkWN (k6 "notaari") "luovutuskirjoja" "laativa" ; --UNCHK
lin conveyer_N = mkWN (k33A "kuljetin") ; --UNCHK
lin conveyer_belt_N = mkWN (k33A "kuljetin") ; --UNCHK
lin conveyor_N = mkWN (k33A "kuljetin") ; --UNCHK
lin convict_N = mkWN (k5A "vanki") ; --UNCHK
lin convict_V2 = mkWV2 (k69 "tuomita") ;
lin conviction_N = mkN "vakaumus" ; ---ARB mkWN (k3 "tuomio") ;
lin convince_V2 = mkWV2 (k53A "vakuuttaa") ;
lin convince_V2V = mkWV2V (k53A "vakuuttaa") ; --UNCHK
lin convincible_A = mkWA (k38 "vastaanottavainen") ; --UNCHK
lin convincing_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin convincingness_N = mkWN (k40 "vakuuttavuus") ; --UNCHK
lin convivial_A = mkWA (k15 "hilpeä") ; --UNCHK
lin convocation_N = mkWN (compoundN "kutsu" (k38 "minen")) "kokoon" ; --UNCHK
lin convoke_V2 = mkWV2 (k52 "kutsua") "kokoon" ; --UNCHK
lin convolute_A = mkWA (k38 "kierteinen") ; --UNCHK
lin convoluted_A = mkWA (k41A "mutkikas") ; --UNCHK
lin convolution_N = mkWN "kiertyminen" ; --UNCHK
lin convolvulus_N = mkWN (k1A "kierto") ; --UNCHK
lin convoy_N = mkWN "saattaminen" ; --UNCHK
lin convoy_V2 = mkWV2 (k56A "saattaa") ; --UNCHK
lin convulse_V2 = mkWV2 (k56 "nauraa") "kippurassa" ; --UNCHK
lin convulsion_N = mkWN (k39 "mullistus") ; --UNCHK
lin convulsive_A = mkWA (k38 "spastinen") ; --UNCHK
lin conwy_PN = foreignPN "Conwy" ;
lin cony_N = mkWN (kH1 "kani") ; --UNCHK
lin coo_N = mkWN (k39 "kujerrus") ; --UNCHK
lin coo_V = mkWV (k54A "kujertaa") ; --UNCHK
lin coo_V2 = mkWV2 (k54A "kujertaa") ; --UNCHK
lin cook_N = mkWN (k10 "keittäjä") ; --UNCHK
lin cook_V = mkWV (k52 "kypsyä") ; --UNCHK
lin cook_V2 = mkWV2 (k52 "kypsyä") ; --UNCHK
lin cookbook_N = mkWN (compoundN "keitto" (k9 "kirja")) ; --UNCHK
lin cooker_N = mkWN (compoundN "keitto" (k12 "astia")) ; --UNCHK
lin cookery_N = mkWN (compoundN "ruuan" (k39 "valmistus")) ; --UNCHK
lin cookery_book_N = mkWN (compoundN "keitto" (k9 "kirja")) ; --UNCHK
lin cookfire_N = mkWN (k23 "tuli") ; --UNCHK
lin cookham_PN = foreignPN "Cookham" ;
lin cookhouse_N = mkWN (compoundN "kenttä" (k3 "keittiö")) ; --UNCHK
lin cookie_N = mkWN "eväste" ; --UNCHK
lin cooking_N = mkWN (compoundN "ruuan" (k39 "valmistus")) ; --UNCHK
lin cookout_N = mkWN (compoundN "ulkoilma-" (k12 "ateria")) ; --UNCHK
lin cookstove_N = mkWN (compoundN "keitto" (k27 "liesi")) ; --UNCHK
lin cooky_N = mkWN (kH1 "keksi") ; --UNCHK
lin cool_A = mkWA (k15 "viileä") ; --UNCHK
lin cool_N = mkWN (k40 "viileys") ; --UNCHK
lin cool_V = mkWV (k52A "kylmentyä") ; --UNCHK
lin cool_V2 = mkV2 "viilentää" partitive ;
lin cool_down_V = mkWV (k52A "kylmentyä") ; --UNCHK
lin cool_down_V2 = mkWV2 (k52A "kylmentyä") ; --UNCHK
lin cool_off_V = mkWV (k52A "viilentyä") ; --UNCHK
lin coolant_N = mkWN (compoundN "jäähdytys" (k48 "neste")) ; --UNCHK
lin cooler_N = mkWN (k5 "jääboksi") ; --UNCHK
lin coolie_N = mkWN (k5 "kuli") ; --UNCHK
lin cooling_N = mkWN (compoundN "jäähdytys" (k10 "järjestelmä")) ; --UNCHK
lin cooling_tower_N = mkWN (compoundN "jäähdytys" (k5 "torni")) ; --UNCHK
lin coolness_N = mkWN (k40 "etäisyys") ; --UNCHK
lin coon_N = mkWN (k5 "supi") ; --UNCHK
lin coondog_N = mkWN (compoundN "metsästys" (k10 "koira")) "supijahdissa" "käytettävä" ; --UNCHK
lin coonhound_N = mkWN (compoundN "metsästyskoira" (k1A "rotu")) "supijahtiin" "kehitetty" ; --UNCHK
lin coontie_N = mkWN (compoundN "käpy" (k1 "palmu")) ; --UNCHK
lin coop_N = mkWN (k5A "häkki") ; --UNCHK
lin coop_up_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin cooper_N = mkWN (compoundN "tynnyrin" (k12 "tekijä")) ; --UNCHK
lin cooperate_V = mkWV (k61 "toimia") "yhteistyössä" ; --UNCHK
lin cooperation_N = mkWN (compoundN "yhteis" (k19 "työ")) ;
lin cooperative_A = mkWA (compoundA "yhteis" (k38 "toiminnallinen")) ; --UNCHK
lin cooperative_N = mkWN (compoundN "osuus" (k10A "kunta")) ; --UNCHK
lin cooperator_N = mkWN (k6 "partneri") ; --UNCHK
lin coordinate_A = mkWA (compoundA "tasa" (k38 "vertainen")) ; --UNCHK
lin coordinate_N = mkWN (k5A "koordinaatti") ; --UNCHK
lin coordinate_V = mkWV (k53 "järjestää") ; --UNCHK
lin coordinate_V2 = mkV2 "koordinoida" ; --WV2 (k53 "järjestää") ;
lin coordination_N = mkWN (k5A "koordinointi") ; --UNCHK
lin coordinator_N = mkN (lin NK {s = d06 "koordinaattori"}) ;
lin coot_N = mkWN (compoundN "noki" (k9 "kana")) ; --UNCHK
lin cooter_N = mkWN "Pseudemys" "concinna" ; --UNCHK
lin cop_N = mkWN (kH1 "pollari") ; --UNCHK
lin cop_V2 = mkWV2 (k69 "vangita") ; --UNCHK
lin cop_out_V = mkWV (k53 "luistaa") ; --UNCHK
lin copacetic_A = mkWA (k34A "verraton") ; --UNCHK
lin copaiba_N = mkWN (compoundN "kopaiva" (k6 "balsami")) ; --UNCHK
lin copartner_N = mkWN (compoundN "yhtiö" (k6 "toveri")) ; --UNCHK
lin copartnership_N = mkWN (k40 "osakkuus") ; --UNCHK
lin cope_N = mkWN (compoundN "papin" (k1A "kaapu")) ; --UNCHK
lin cope_V = mkWV (k53 "kestää") ; --UNCHK
lin copeck_N = mkWN (k14A "kopeekka") ; --UNCHK
lin copenhagen_PN = foreignPN "Kööpenhamina" ;
lin copepod_N = mkWN (compoundN "han" (k38 "kajalkainen")) ; --UNCHK
lin copilot_N = mkWN (k10 "lentäjä") "toinen" ; --UNCHK
lin coping_N = mkWN (k48A "peite") ; --UNCHK
lin coping_stone_N = mkWN (compoundN "kansi" (k7 "kivi")) ; --UNCHK
lin copious_A = mkWA (k99 "paljon") ; --UNCHK
lin cop_out_N = mkWN "livistäminen" ; --UNCHK
lin copper_N = mkN (lin NK {s = d06 "kupari"}) ;
lin copper_V2 = mkWV2 (k53A "pinnoittaa") "kuparilla" ; --UNCHK
lin copperhead_N = mkWN "Denisonia" "superba" ; --UNCHK
lin copperplate_N = mkWN (compoundN "kupari" (k39 "piirros")) ; --UNCHK
lin coppersmith_N = mkWN (compoundN "kupari" (k10A "seppä")) ; --UNCHK
lin coppery_A = mkWA (compoundA "kuparin" (k15 "ruskea")) ; --UNCHK
lin coppice_N = mkWN (k4A "pöheikkö") ; --UNCHK
lin coppull_PN = foreignPN "Coppull" ;
lin copra_N = mkWN (k10 "kopra") ; --UNCHK
lin coprolalia_N = mkWN "rivopuheisuus" ; --UNCHK
lin coprolite_N = mkWN "koproliitti" ; --UNCHK
lin coprolith_N = mkWN (compoundN "uloste" (k7 "kivi")) ; --UNCHK
lin coprophagy_N = mkWN "koprofagia" ; --UNCHK
lin copse_N = mkWN (k4A "pöheikkö") ; --UNCHK
lin copt_N = mkWN (k38 "koptilainen") ; --UNCHK
lin coptic_N = mkWN (k5 "kopti") ; --UNCHK
lin copula_N = mkWN (k5 "verbi") "vaillinainen" ; --UNCHK
lin copular_A = mkWA "kopula-" ; --UNCHK
lin copulate_V = mkWV (k52A "pariutua") ; --UNCHK
lin copulation_N = mkWN (k38 "kanssakäyminen") "seksuaalinen" ; --UNCHK
lin copulative_A = mkWA (compoundA "kop" (k38 "ulatiivinen")) ; --UNCHK
lin copulative_N = mkWN (k5 "verbi") "vaillinainen" ; --UNCHK
lin copy_N = mkN "kopio" | mkN "jäljennös" ;
lin copy_V = mkV "kopioida" ;
lin copy_V2 = mkWV2 (k73 "kopsata") ; --UNCHK
lin copybook_N = mkWN (compoundN "käsiala" (k1 "vihko")) ; --UNCHK
lin copycat_N = mkWN (k12 "apina") ; --UNCHK
lin copyhold_N = mkWN (compoundN "asukas" (k40 "oikeus")) ; --UNCHK
lin copyholder_N = mkWN (k33A "pidin") "käsikirjoituksen" ; --UNCHK
lin copying_N = mkWN "jäljentäminen" ; --UNCHK
lin copyist_N = mkWN (k6 "kirjuri") ; --UNCHK
lin copyright_N = mkWN (compoundN "tekijän" (k40 "oikeus")) ;
lin copyright_V2 = mkWV2 (k73 "suojata") "tekijänoikeus" ; --UNCHK
lin copywriter_N = mkWN (k12 "laatija") "mainostekstien" ; --UNCHK
lin coquetry_N = mkWN (k2 "flirttailu") ; --UNCHK
lin coquette_N = mkWN (k5A "koketti") ; --UNCHK
lin coquettish_A = mkWA "flirttaileva" ; --UNCHK
lin coquille_N = mkWN (k12 "astia") "simpukankuoren" "muotoinen" ; --UNCHK
lin cor_anglais_N = mkWN (compoundN "englannin" (k7 "torvi")) ; --UNCHK
lin coral_A = mkWA (compoundA "korallin" (k38 "punainen")) ; --UNCHK
lin coral_N = mkWN (k5 "koralli") ; --UNCHK
lin coral_reef_N = mkWN (compoundN "koralli" (k9A "riutta")) ; --UNCHK
lin coralbells_N = mkWN (compoundN "keijun" (k10A "kukka")) ; --UNCHK
lin coralberry_N = mkWN (compoundN "cre" (k9A "nata")) "Ardisia" ; --UNCHK
lin coralwood_N = mkWN "Adenanthera" "pavonina" ; --UNCHK
lin corbel_N = mkWN (k41 "ansas") ; --UNCHK
lin corbelled_A = mkWA "olkakivin" "tuettu" ; --UNCHK
lin corbina_N = mkWN "Menticirrhus" "undulatus" ; --UNCHK
lin corby_PN = foreignPN "Corby" ;
lin corchorus_N = mkWN (compoundN "Corchorus-" (k1A "suku")) ; --UNCHK
lin cord_N = mkWN (k1 "naru") ; --UNCHK
lin cord_V2 = mkWV2 (k53A "köyttää") ; --UNCHK
lin cordage_N = mkWN (k2 "köysistö") ; --UNCHK
lin cordate_A = mkWA (k38 "muotoinen") "sydämen" ; --UNCHK
lin cordgrass_N = mkWN (compoundN "aro" (k10 "heinä")) ; --UNCHK
lin cordial_A = mkWA (k10 "mukava") ; --UNCHK
lin cordial_N = mkWN (k6 "likööri") ; --UNCHK
lin cordiality_N = mkWN (k40 "sydämellisyys") ; --UNCHK
lin cordierite_N = mkWN (compoundN "kordie" (k5A "riitti")) ; --UNCHK
lin cordite_N = mkWN "kordiitti" ; --UNCHK
lin corditis_N = mkWN (k39 "tulehdus") "siemenjohtimen" ; --UNCHK
lin cordless_A = mkWA (k34A "langaton") ; --UNCHK
lin cordoba_N = mkWN "Cordova" ; --UNCHK
lin cordon_N = mkWN (compoundN "koriste" (k39 "punos")) ; --UNCHK
lin cordovan_N = mkWN (compoundN "karduaani" (k9 "nahka")) ; --UNCHK
lin corduroy_N = mkWN (compoundN "vako" (k5A "sametti")) ; --UNCHK
lin cordwood_N = mkWN (compoundN "poltto" (k18 "puu")) ; --UNCHK
lin core_N = mkN "ydin" ;
lin core_V2 = mkWV2 (k53 "poistaa") "sisus" ; --UNCHK
lin coreference_N = mkWN (compoundN "samaviitte" (k40 "isyys")) ; --UNCHK
lin coreferent_A = mkWA (compoundA "sama" (k38 "viitteinen")) ; --UNCHK
lin coreferential_A = mkWA (compoundA "sama" (k38 "viitteinen")) ; --UNCHK
lin coreligionist_N = mkWN (compoundN "uskon" (k7 "veli")) ; --UNCHK
lin coreopsis_N = mkWN (compoundN "kauno" (k10 "silmä")) ; --UNCHK
lin corer_N = mkWN (k9 "omenakaira") ; --UNCHK
lin corgi_N = mkWN "walesincorgi" ; --UNCHK
lin coriaceous_A = mkWA (k38 "nahkainen") ; --UNCHK
lin coriander_N = mkWN (k6 "korianteri") ; --UNCHK
lin corinthian_A = mkWA (k38 "korinttilainen") ; --UNCHK
lin corinthian_N = mkWN (k38 "korinttilainen") ; --UNCHK
lin cork_N = mkWN (k1 "koho") ; --UNCHK
lin cork_PN = foreignPN "Cork" ;
lin cork_V2 = mkWV2 (k53A "täyttää") "korkilla" ; --UNCHK
lin corkage_N = mkWN (compoundN "korkki" (k9 "raha")) ; --UNCHK
lin corkboard_N = mkWN (compoundN "korkki" (k1 "levy")) ; --UNCHK
lin corker_N = mkWN (compoundN "korkitus" (k48 "kone")) ; --UNCHK
lin corkscrew_N = mkWN (compoundN "korkki" (k5 "ruuvi")) ; --UNCHK
lin corkwood_N = mkWN "Leitneria" "floridana" ; --UNCHK
lin corm_N = mkWN (compoundN "varsi" (k12 "mukula")) ; --UNCHK
lin cormorant_N = mkWN (compoundN "meri" (k1 "metso")) ; --UNCHK
lin cormous_A = mkWA "varsimukuloita" "kasvattava" ; --UNCHK
lin corn_N = mkN "maissi" ; --f63
lin corn_V2 = mkWV2 (k73 "suolata") ; --UNCHK
lin corn_exchange_N = mkWN (compoundN "vilja" (k5 "pörssi")) ; --UNCHK
lin cornbread_N = mkWN (compoundN "maissi" (k10A "leipä")) ; --UNCHK
lin corncob_N = mkWN (compoundN "maissin" (k10 "tähkä")) ; --UNCHK
lin corncrake_N = mkWN (k10A "ruisrääkkä") ; --UNCHK
lin corncrib_N = mkWN (compoundN "maissin" (k2 "kuivaamo")) ; --UNCHK
lin cornea_N = mkWN (compoundN "sarveis" (k1 "kalvo")) ; --UNCHK
lin corneal_A = mkWA "sarveiskalvon" ; --UNCHK
lin cornelian_N = mkWN (k5 "karneoli") ; --UNCHK
lin corneous_A = mkWA (compoundA "sarvi" (k38 "mainen")) ; --UNCHK
lin corner_N = mkWN (k10 "kulma") ;
lin corner_V = mkV (lin VK {s = c73A "vallata"}) ;
lin corner_V2 = mkWV2 (k52A "kääntyä") "kulmasta" ; --UNCHK
lin corner_kick_N = mkWN (k1 "kulmapotku") ; --UNCHK
lin cornerback_N = mkWN (compoundN "laita" (k10 "puolustaja")) ; --UNCHK
lin cornerstone_N = mkWN (compoundN "kulma" (k7 "kivi")) ; --UNCHK
lin cornet_N = mkWN (k5A "trumpetti") ; --UNCHK
lin cornetfish_N = mkWN (compoundN "kornetti" (k9 "kala")) ; --UNCHK
lin cornfield_N = mkWN (compoundN "maissi" (k1A "pelto")) ; --UNCHK
lin cornflour_N = mkWN (compoundN "maissi" (k1 "jauho")) ; --UNCHK
lin cornflower_N = mkWN (compoundN "ruis" (k5A "kaunokki")) ; --UNCHK
lin cornhusk_N = mkWN (kH1 "kuori") ; --UNCHK
lin cornhusker_N = mkWN (compoundN "nebras" (k38 "kalainen")) ; --UNCHK
lin cornhusking_N = mkWN (compoundN "kuori" (k38 "minen")) "maissintähkien" ; --UNCHK
lin cornice_N = mkWN (compoundN "korni" (k5 "isi")) ; --UNCHK
lin cornmeal_N = mkWN (compoundN "maissi" (k1 "jauho")) ; --UNCHK
lin cornpone_N = mkWN (compoundN "maissi" (k10A "leipä")) ; --UNCHK
lin cornsmut_N = mkWN (compoundN "noki" (k26 "sieni")) "maissin" ; --UNCHK
lin cornstalk_N = mkWN (compoundN "maissin" (k28 "korsi")) ; --UNCHK
lin cornstarch_N = mkWN (compoundN "maissi" (k1 "jauho")) ; --UNCHK
lin cornu_N = mkWN (k7 "sarvi") ; --UNCHK
lin cornucopia_N = mkWN (k40 "runsaus") ; --UNCHK
lin cornwall_PN = foreignPN "Cornwall" ;
lin corny_A = mkWA (k15 "lattea") ; --UNCHK
lin corolla_N = mkWN (k3 "teriö") ; --UNCHK
lin corollary_N = mkWN (compoundN "korol" (k5 "laari")) ; --UNCHK
lin corona_N = mkWN "corona" ; --UNCHK
lin coronary_A = mkWA (compoundA "korona" (k38 "arinen")) ; --UNCHK
lin coronary_N = mkWN (compoundN "sepelvaltimo" (k39 "tukos")) ; --UNCHK
lin coroner_N = mkWN (compoundN "kuolemansyyn" (k12 "tutkija")) ; --UNCHK
lin coronet_N = mkWN (k10 "kehä") ; --UNCHK
lin coroneted_A = mkWA (k38 "aatelinen") ; --UNCHK
lin coronilla_N = mkWN (compoundN "nivel" (k9 "virna")) ; --UNCHK
lin corozo_N = mkWN "Attalea" "cohune" ; --UNCHK
lin corporal_A = mkWA (k38 "lihallinen") ; --UNCHK
lin corporal_N = mkWN (k5 "korpraali") ; --UNCHK
lin corporate_A = mkA "yhtiönlaajuinen" ;
lin corporation_N = mkN "korporaatio" ;
lin corporatism_N = mkWN (k5 "korporativismi") ; --UNCHK
lin corporatist_A = mkWA "korporatistinen" ; --UNCHK
lin corporatist_N = mkWN "korporatisti" ; --UNCHK
lin corporeal_A = mkWA (k38 "aineellinen") ; --UNCHK
lin corps_N = mkWN (compoundN "armeija" (k10A "kunta")) ; --UNCHK
lin corps_de_ballet_N = mkWN (compoundN "baletti" (k10A "kunta")) ; --UNCHK
lin corps_diplomatique_N = mkWN (compoundN "diplomaatti" (k10A "kunta")) ; --UNCHK
lin corpse_N = mkWN (k1A "raato") ; --UNCHK
lin corpulence_N = mkWN (k40 "paksuus") ; --UNCHK
lin corpulent_A = mkWA (k15 "pullea") ; --UNCHK
lin corpus_N = mkWN (k1A "runko") ; --UNCHK
lin corpuscle_N = mkWN (k1 "solu") ; --UNCHK
lin corpuscular_A = mkWA "hiukkas-" ; --UNCHK
lin corral_N = mkWN (k39 "aitaus") ; --UNCHK
lin corral_V2 = mkWV2 (k61 "haalia") ; --UNCHK
lin correct_A = L.correct_A ;
lin correct_V = mkWV (k73 "korjata") ; --UNCHK
lin correct_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin correct_VS = mkWVS (k73 "korjata") ; --UNCHK
lin correctable_A = mkWA (k10 "oleva") "oikaistavissa" ; --UNCHK
lin correction_1_N = mkWN (k2 "oikaisu") ; --UNCH
lin correction_2_N = mkWN (compoundN "seuraamus" (k10 "järjestelmä")) ; --UNCHKK
lin correctional_A = mkWA "parannus-" ; --UNCHK
lin correctitude_N = mkWN (k40 "säädyllisyys") ; --UNCHK
lin corrective_A = mkWA (compoundA "korj" (k9 "aava")) ; --UNCHK
lin corrective_N = mkWN (compoundN "parannus" (k1 "keino")) ; --UNCHK
lin correctness_N = mkWN (k40 "oikeellisuus") ; --UNCHK
lin correlate_N = mkWN (k5A "korrelaatti") ; --UNCHK
lin correlate_V = mkWV (k56A "saattaa") "vastaavuussuhteeseen" ; --UNCHK
lin correlate_V2 = mkWV2 (k56A "saattaa") "vastaavuussuhteeseen" ; --UNCHK
lin correlation_N = mkWN (k40 "vastaavuus") "tilastollinen" ; --UNCHK
lin correlational_A = mkWA (compoundA "kor" (k38 "relatiivinen")) ; --UNCHK
lin correlative_A = mkA "korreloiva" ;
lin correlative_N = mkWN (k5A "korrelaatti") ; --UNCHK
lin correspond_V = mkV vOlla "kirjeenvaihdossa" ;
lin correspond_V2 = mkV2 (mkV "vastata") partitive ;
lin correspondence_N = mkWN (k40 "vastaavuus") ; --UNCHK
lin correspondent_N = mkN "kirjeenvaihtaja" ; --mkWN (k10 "kirjoittaja") "kirjeiden" ;
lin corresponding_A = variants {} ; --
lin corridor_N = mkWN (k10 "käytävä") ; --UNCHK
lin corrie_N = mkWN (compoundN "kattila" (k1 "laakso")) ; --UNCHK
lin corrigenda_N = mkWN (compoundN "oikaisu" (k2 "luettelo")) ; --UNCHK
lin corrigendum_N = mkWN (compoundN "paino" (k48 "virhe")) ; --UNCHK
lin corrigible_A = mkWA (k10 "oleva") "parannettavissa" ; --UNCHK
lin corroborant_A = mkWA "vahvistava" ; --UNCHK
lin corroborate_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin corroboration_N = mkWN "vahvistaminen" ; --UNCHK
lin corroborative_A = mkWA "sivu-" ; --UNCHK
lin corrode_V = mkWV (k52 "kulua") ; --UNCHK
lin corrode_V2 = mkWV2 (k52 "kulua") ; --UNCHK
lin corrosion_N = mkWN (k3 "korroosio") ; --UNCHK
lin corrosive_A = mkWA "erittäin" "syövyttävä" ; --UNCHK
lin corrosive_N = mkWN (k48 "aine") "syövyttävä" ; --UNCHK
lin corrugate_V = mkWV (k53A "poimuttaa") ; --UNCHK
lin corrugate_V2 = mkWV2 (k53A "poimuttaa") ; --UNCHK
lin corrugation_N = mkWN (compoundN "poimu" (k38 "ttaminen")) ; --UNCHK
lin corrupt_A = mkWA "turmeltunut" ; --UNCHK
lin corrupt_V = mkWV (k73 "pilata") ; --UNCHK
lin corrupt_V2 = mkWV2 (k73 "pilata") ; --UNCHK
lin corruptibility_N = mkWN (k40 "lahjottavuus") ; --UNCHK
lin corruptible_A = mkWA (k10 "oleva") "ostettavissa" ; --UNCHK
lin corruption_N = mkN "korruptio" ;
lin corruptive_A = mkWA (k38 "turmiollinen") ; --UNCHK
lin corruptness_N = mkWN (k3 "korruptio") ; --UNCHK
lin corsage_N = mkWN (compoundN "kukka" (k1 "vihko")) ; --UNCHK
lin corsair_N = mkWN (compoundN "kaappari" (k9 "laiva")) ; --UNCHK
lin corse_N = mkWN (compoundN "Kor" (k9A "sika")) ; --UNCHK
lin corselet_N = mkWN (k13 "haarniska") ; --UNCHK
lin corset_N = mkWN (k5 "kureliivi") ; --UNCHK
lin corsham_PN = foreignPN "Corsham" ;
lin corslet_N = mkWN (k13 "haarniska") ; --UNCHK
lin cortege_1_N = mkWN (k48 "seurue") ; --UNCHK
lin cortege_2_N = variants {} ; --UNCHK
lin cortege_N = mkWN (k48 "seurue") ; --UNCHK
lin cortex_N = mkWN (compoundN "kuori" (k39 "kerros")) ; --UNCHK
lin cortical_A = mkWA (compoundA "kortika" (k38 "alinen")) ; --UNCHK
lin corticoafferent_A = mkWA "aivokuoreen" "tuova" ; --UNCHK
lin corticoefferent_A = mkWA "aivokuoresta" "tuova" ; --UNCHK
lin corticosteroid_N = mkWN (compoundN "kortiko" (k5 "steroidi")) ; --UNCHK
lin corticosterone_N = mkWN "kortikosteroni" ; --UNCHK
lin cortina_N = mkWN (k41A "rengas") "sienen" "harsomainen" ; --UNCHK
lin cortisone_N = mkWN (k5 "kortisoni") ; --UNCHK
lin corundom_N = mkWN (k5 "korundi") ; --UNCHK
lin corundum_N = mkWN (k5 "korundi") ; --UNCHK
lin corunna_PN = foreignPN "Corunna" ;
lin coruscate_V = mkWV (k52 "säihkyä") ; --UNCHK
lin coruscation_N = mkWN (k48 "säihke") ; --UNCHK
lin corvee_N = mkWN (k5A "taksvärkki") ; --UNCHK
lin corvette_N = mkWN (k5A "korvetti") ; --UNCHK
lin corvine_A = mkWA (compoundA "varis" (k38 "mainen")) ; --UNCHK
lin corydalis_N = mkWN (compoundN "Corydalus-" (k1A "suku")) ; --UNCHK
lin corymb_N = mkWN (k2 "huiskilo") ; --UNCHK
lin corymbose_A = mkWA (compoundA "huiskilo" (k38 "mainen")) ; --UNCHK
lin corynebacterium_N = mkWN (compoundN "korynebak" (k26 "teeri")) ; --UNCHK
lin coryphantha_N = mkWN "Coryphantha" ; --UNCHK
lin corythosaur_N = mkWN (k1 "kypärälisko") ; --UNCHK
lin cos_N = mkWN (compoundN "side" (k5A "salaatti")) ; --UNCHK
lin coscoroba_N = mkWN (compoundN "ankka" (k32 "joutsen")) ; --UNCHK
lin cosecant_N = mkWN (k5A "kosekantti") ; --UNCHK
lin coseismic_A = mkWA "koseisminen" ; --UNCHK
lin cosenza_PN = foreignPN "Cosenza" ;
lin cosh_N = mkWN (k14A "pulikka") ; --UNCHK
lin cosh_V2 = mkWV2 (k58 "iskeä") "lyijypatukalla" ; --UNCHK
lin cosher_A = mkWA (k5 "košer") ; --UNCHK
lin cosignatory_N = mkWN (compoundN "allekirjoittaja" (k6 "kumppani")) ; --UNCHK
lin cosigner_N = mkWN (compoundN "allekirjoittaja" (k6 "kumppani")) ; --UNCHK
lin cosine_N = mkWN (k5 "kosini") ; --UNCHK
lin cosiness_N = mkWN (k40 "mukavuus") ; --UNCHK
lin cosmetic_A = mkWA (k38 "kosmeettinen") ; --UNCHK
lin cosmetic_N = mkWN (k9A "kosmetiikka") ;
lin cosmetician_N = mkWN (k5 "kosmetologi") ; --UNCHK
lin cosmetologist_N = mkWN (k5 "kosmetologi") ; --UNCHK
lin cosmetology_N = mkWN (k12 "kosmetologia") ; --UNCHK
lin cosmic_A = mkWA (k38 "kosminen") ; --UNCHK
lin cosmid_N = mkWN (k5 "kosmidi") ; --UNCHK
lin cosmogony_N = mkWN (k12 "kosmogonia") ; --UNCHK
lin cosmographer_N = mkWN "kosmografi" ; --UNCHK
lin cosmography_N = mkWN "kosmografia" ; --UNCHK
lin cosmolatry_N = mkWN "kosmolatria" ; --UNCHK
lin cosmologic_A = mkWA (k38 "kosmologinen") ; --UNCHK
lin cosmologist_N = mkWN "kosmologi" ; --UNCHK
lin cosmology_N = mkWN (k12 "kosmogonia") ; --UNCHK
lin cosmonaut_N = mkWN (k5A "kosmonautti") ; --UNCHK
lin cosmopolitan_A = mkWA (k38 "kosmopoliittinen") ; --UNCHK
lin cosmopolitan_N = mkWN (k5A "kosmopoliitti") ; --UNCHK
lin cosmos_N = mkWN (k40 "avaruus") ; --UNCHK
lin cosmotron_N = mkWN (compoundN "Cosmotron-hiukkas" (k33A "kiihdytin")) ; --UNCHK
lin cosset_V2 = mkWV2 (k61 "helliä") ; --UNCHK
lin cost_N = mkN "kustannus" ;
lin cost_V = mkWV (k56 "maksaa") ;
lin cost_V2 = mkWV2 (k56 "maksaa") ;
lin cost_up_V2 = prepV2 OP_cost_V OP_up_Prep ; -- guess-p-verb
lin costa_N = mkWN (compoundN "kylki" (k18 "luu")) ; --UNCHK
lin costa_rican_A = mkWA (compoundA "costaric" (k38 "alainen")) ; --UNCHK
lin costa_rican_N = mkWN (compoundN "costaric" (k38 "alainen")) ; --UNCHK
lin costal_A = mkWA "kylkiluun" ; --UNCHK
lin costermonger_N = mkWN (compoundN "katu" (k41 "kauppias")) ; --UNCHK
lin costia_N = mkWN "Costia" "necatrix" ; --UNCHK
lin costiasis_N = mkWN "costiasis" ; --UNCHK
lin costing_N = mkWN (compoundN "kustannus" (k9A "laskenta")) ; --UNCHK
lin costive_A = mkWA (compoundA "ummetus" (k38 "tautinen")) ; --UNCHK
lin costliness_N = mkWN (k40 "arvokkuus") ; --UNCHK
lin costly_A = mkA "hintava" ;
lin costmary_N = mkWN "Chrysanthemum" "majus" ; --UNCHK
lin costochondritis_N = mkWN (compoundN "oire" (k10 "yhtymä")) "Tietzen" ; --UNCHK
lin costs_N = mkWN "korvaus" "oikeudenkäyntikuluista" ; --UNCHK
lin costume_N = mkWN (k1 "asu") ; --UNCHK
lin costumed_A = mkWA "pukeutunut" ; --UNCHK
lin costumier_N = mkWN (k10 "puvustaja") ; --UNCHK
lin costusroot_N = mkWN "Saussurea" "lappa" ; --UNCHK
lin cosy_A = mkWA (k10 "kotoisa") ; --UNCHK
lin cosy_N = mkWN (compoundN "tee" (k1 "myssy")) ; --UNCHK
lin cot_N = mkWN (compoundN "kenttä" (k48A "vuode")) ; --UNCHK
lin cotangent_N = mkWN (k5A "kotangentti") ; --UNCHK
lin cote_N = mkWN (kH1 "suoja") ; --UNCHK
lin cotenant_N = mkWN (compoundN "yhteis" (k10 "vuokraaja")) ; --UNCHK
lin coterie_N = mkWN (k10 "ryhmittymä") ; --UNCHK
lin coterminous_A = mkWA (compoundA "saman" (k38 "laajuinen")) ; --UNCHK
lin cotilion_N = mkWN (compoundN "kotilj" (k7A "onki")) ; --UNCHK
lin cotillion_N = mkWN (compoundN "kotilj" (k7A "onki")) ; --UNCHK
lin cotinga_N = mkWN "kotinga" ; --UNCHK
lin cotoneaster_N = mkWN (compoundN "tuhka" (k41 "pensas")) ; --UNCHK
lin cottage_N = mkWN (k9 "maja") ; --UNCHK
lin cottager_N = mkWN (k38 "mäkitupalainen") ; --UNCHK
lin cottar_N = mkWN (k5A "tappi") ; --UNCHK
lin cotter_N = mkWN (k5A "tappi") ; --UNCHK
lin cotton_N = mkWN (k9 "puuvilla") ;
lin cotton_V = mkWV (k52 "tykästyä") ; --UNCHK
lin cotton_cake_N = mkWN "puuvillansiemenkakku" ; --UNCHK
lin cotton_on_V = mkWV (k74 "älytä") ; --UNCHK
lin cotton_plant_N = mkWN (k9 "puuvilla") ; --UNCHK
lin cotton_wool_N = mkWN (k9 "puuvilla") ; --UNCHK
lin cottonseed_N = mkWN (compoundN "puuvillan" (k32 "siemen")) ; --UNCHK
lin cottontail_N = mkWN (compoundN "pumpulihäntäka" (k26 "niini")) ; --UNCHK
lin cottonweed_N = mkWN "Froelichia" ; --UNCHK
lin cottonwick_N = mkWN "Haemulon" "melanurum" ; --UNCHK
lin cottonwood_N = mkWN "Tilia" "heterophylla" ; --UNCHK
lin cottony_A = mkWA (compoundA "pumpuli" (k38 "mainen")) ; --UNCHK
lin cotyledon_N = mkWN (compoundN "sirkka" (k7A "lehti")) ; --UNCHK
lin coucal_N = mkWN (compoundN "kannus" (k7A "käki")) ; --UNCHK
lin couch_N = mkWN (k10 "sohva") "psykiatrin" ; --UNCHK
lin couch_V = mkWV (k53A "esittää") ; --UNCHK
lin couch_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin couch_grass_N = mkWN (compoundN "juola" (k10 "vehnä")) ; --UNCHK
lin couchant_A = mkWA (compoundA "mak" (k9 "aava")) ; --UNCHK
lin couchette_N = mkWN (compoundN "makuu" (k1 "vaunu")) ; --UNCHK
lin cougar_N = mkWN (k10 "puuma") ; --UNCHK
lin cough_N = mkWN (k39 "yskähdys") ;
lin cough_V = mkWV (k61 "köhiä") ; --UNCHK
lin cough_up_V2 = mkWV2 (k58A "sylkeä") ; --UNCHK
lin coulisse_N = mkWN (k1 "kouru") ; --UNCHK
lin coulter_N = mkWN (k10 "terä") "auran" ; --UNCHK
lin council_N = mkN "neuvosto" ;
lin council_board_N = mkWN (compoundN "neuvottelu" (k10A "pöytä")) ; --UNCHK
lin council_chamber_N = mkWN (compoundN "kokous" (k48 "huone")) ; --UNCHK
lin councillor_N = mkWN (k32 "jäsen") "neuvoston" ; --UNCHK
lin councillorship_N = mkWN (k40 "jäsenyys") "neuvoston" ; --UNCHK
lin councilman_N = mkWN (k32 "jäsen") "neuvoston" ; --UNCHK
lin councilwoman_N = mkWN (k32 "jäsen") "valtuuston" ; --UNCHK
lin counsel_N = mkWN (k39 "ohjaus") ;
lin counsel_V2 = mkWV2 (k73 "ohjata") ; --UNCHK
lin counselling_N = variants {} ; --
lin counsellor_N = mkWN (compoundN "oikeus" (k10 "avustaja")) ; --UNCHK
lin counselorship_N = mkWN (k25 "toimi") "asianajajan" ; --UNCHK
lin count_1_N = mkWN (k38 "lukeminen") "numeroiden" ; --UNCHK
lin count_2_N = mkWN (k38 "lukeminen") "numeroiden" ; --UNCHK
lin count_V = mkWV (k53A "ottaa") "lukuun" ;
lin count_V2 = L.count_V2 ;
lin count_against_V2 = prepV2 OP_count_V OP_against_Prep ; -- guess-p-verb
lin count_among_V2 = prepV2 OP_count_V OP_among_Prep ; -- guess-p-verb
lin count_down_V2 = mkWV2 (k58 "laskea") "taaksepäin" ; --UNCHK
lin count_for_V2 = prepV2 OP_count_V OP_for_Prep ; -- guess-p-verb
lin count_in_V2 = prepV2 OP_count_V OP_in_Prep ; -- guess-p-verb
lin count_off_V2 = mkWV2 (k67A "luetella") "numeroita" ; --UNCHK
lin count_on_V2 = mkWV2 (k53 "ennustaa") ; --UNCHK
lin count_out_V2 = mkWV2 (k53 "julistaa") "häviäjä" ; --UNCHK
lin count_towards_V2 = prepV2 OP_count_V OP_towards_Prep ; -- guess-p-verb
lin count_up_V2 = prepV2 OP_count_V OP_up_Prep ; -- guess-p-verb
lin count_upon_V2 = prepV2 OP_count_V OP_upon_Prep ; -- guess-p-verb
lin countable_A = mkWA (k10 "oleva") "laskettavissa" ; --UNCHK
lin countdown_N = mkWN (compoundN "lähtö" (k9A "laskenta")) ; --UNCHK
lin countenance_N = mkWN (k48 "ilme") ; --UNCHK
lin countenance_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin counter_Adv = mkWAdv "päinvastaiseen" "suuntaan" ; --UNCHK
lin counter_N = mkWN (compoundN "vasta" (k1 "isku")) ; --UNCHK
lin counter_V = mkWV (k73 "vastata") ; --UNCHK
lin counter_VS = mkWVS (k73 "vastata") ;
lin counteract_V2 = mkWV2 (k62 "sabotoida") ; --UNCHK
lin counteraction_N = mkWN (compoundN "vasta" (k1 "isku")) ; --UNCHK
lin counteractive_A = mkWA (k10 "vaikuttava") "vastaan" ; --UNCHK
lin counterargument_N = mkWN (compoundN "vasta" (k48A "väite")) ; --UNCHK
lin counterattack_N = mkN "vasta" (mkN "hyökkäys") ;
lin counterattack_V = mkV (mkV "hyökätä") "takaisin" ;
lin counterattack_V2 = mkV2 (mkV (mkV "hyökätä") "takaisin") (mkPrep "kimppuun") ;
lin counterattraction_N = mkWN (compoundN "veto" (k2 "numero")) "kilpaileva" ; --UNCHK
lin counterbalance_N = mkWN (compoundN "vasta" (k1 "paino")) ; --UNCHK
lin counterbalance_V2 = mkWV2 (k62 "mitätöidä") ; --UNCHK
lin counterblast_N = mkWN (k39 "vastustus") "voimakas" ; --UNCHK
lin counterblow_N = mkWN (compoundN "vasta" (k1 "isku")) ; --UNCHK
lin counterbombardment_N = mkWN (compoundN "vasta" (k39 "pommitus")) ; --UNCHK
lin counterbore_N = mkWN "kartioupotuspora" ; --UNCHK
lin countercharge_N = mkWN (compoundN "vasta" (k39 "hyökkäys")) ; --UNCHK
lin countercheck_N = mkWN (k39 "varmistus") ; --UNCHK
lin counterclaim_N = mkWN (compoundN "vasta" (k48A "kanne")) ; --UNCHK
lin counterclockwise_A = mkWA (k38 "suuntainen") "vastapäivän" ; --UNCHK
lin counterclockwise_Adv = mkWAdv (k99 "vastapäivään") ; --UNCHK
lin countercoup_N = mkWN "vastavallankaappaus" ; --UNCHK
lin counterculture_N = mkWN (compoundN "vasta" (k6 "kulttuuri")) ; --UNCHK
lin countercurrent_N = mkWN (compoundN "vasta" (k39 "virtaus")) ; --UNCHK
lin counterdemonstration_N = mkWN "vastamielenosoitus" ; --UNCHK
lin counterdemonstrator_N = mkWN "vastamielenosoittaja" ; --UNCHK
lin counterespionage_N = mkWN (compoundN "vasta" (k2 "vakoilu")) ; --UNCHK
lin counter_example_N = mkWN "vastaesimerkki" ; --UNCHK
lin counterfactual_A = mkWA (k38 "vastainen") "tosiasioiden" ; --UNCHK
lin counterfactuality_N = mkWN (k40 "vastaisuus") "tosiasioiden" ; --UNCHK
lin counterfeit_A = mkWA (k10 "väärä") ; --UNCHK
lin counterfeit_N = mkWN (k10 "jäljitelmä") ; --UNCHK
lin counterfeit_V2 = mkWV2 (k54A "väärentää") ; --UNCHK
lin counterfeiter_N = mkWN (k10 "väärentäjä") ; --UNCHK
lin counterfire_N = mkWN (compoundN "vasta" (k23 "tuli")) ; --UNCHK
lin counterfoil_N = mkWN (k9A "kanta") "shekin" ; --UNCHK
lin counterglow_N = mkWN (compoundN "vasta" (k1 "valo")) ; --UNCHK
lin counterinsurgent_A = mkWA (compoundA "vasta" (k38 "kumouksellinen")) ; --UNCHK
lin counterintelligence_N = mkWN (compoundN "vasta" (k2 "vakoilu")) ; --UNCHK
lin counterirritant_N = mkWN (compoundN "vasta" (k48A "ärsyke")) ; --UNCHK
lin countermand_N = mkWN (k39 "peruutus") ; --UNCHK
lin countermand_V2 = mkWV2 (k74 "kumota") ; --UNCHK
lin countermarch_N = mkWN (compoundN "paluu" (k5 "marssi")) ; --UNCHK
lin countermeasure_N = mkWN (compoundN "vasta" (k25 "toimi")) ; --UNCHK
lin countermine_N = mkWN (k6 "tunneli") "vastatoimena" "kaivettu" ; --UNCHK
lin countermine_V = mkWV (k73 "raivata") "miinoja" ; --UNCHK
lin countermine_V2 = mkWV2 (k73 "raivata") "miinoja" ; --UNCHK
lin counteroffensive_N = mkWN (compoundN "vasta" (k5 "offensiivi")) ; --UNCHK
lin counteroffer_N = mkWN (compoundN "vasta" (k39 "tarjous")) ; --UNCHK
lin counterpane_N = mkWN (k48A "peite") ; --UNCHK
lin counterpart_N = mkN "vastine" ;
lin counterperson_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin counterplea_N = mkWN (compoundN "vasta" (k48A "väite")) ; --UNCHK
lin counterplot_N = mkWN (compoundN "vasta" (k10 "suunnitelma")) ; --UNCHK
lin counterplot_V = mkWV (k61A "laatia") "vastajuoni" ; --UNCHK
lin counterplot_V2 = mkWV2 (k61A "laatia") "vastajuoni" ; --UNCHK
lin counterpoint_N = mkWN (k5 "kontrapunkti") ; --UNCHK
lin counterpoise_N = mkWN (compoundN "vasta" (k1 "paino")) ; --UNCHK
lin counterpoise_V2 = mkWV2 (k61 "toimia") "vastapainona" ; --UNCHK
lin counterproductive_A = mkWA (k38 "haitallinen") ; --UNCHK
lin counterproposal_N = mkWN (compoundN "vasta" (k39 "ehdotus")) ; --UNCHK
lin counterpunch_N = mkWN (compoundN "vasta" (k1 "isku")) ; --UNCHK
lin counterreformation_N = mkWN "vastauskonpuhdistus" ; --UNCHK
lin counter_revolution_N = mkWN "vastavallankumous" ; --UNCHK
lin counter_revolutionary_A = mkWA "vastavallankumouksellinen" ; --UNCHK
lin counterrevolutionist_N = mkWN "vastavallankumouksellinen" ; --UNCHK
lin countershot_N = mkWN (compoundN "vasta" (k39 "laukaus")) ; --UNCHK
lin countersign_N = mkWN (k39 "varmennus") ; --UNCHK
lin countersign_V2 = mkWV2 (k54A "varmentaa") "nimikirjoituksella" ; --UNCHK
lin countersignature_N = mkWN (k39 "varmennus") ; --UNCHK
lin countersink_N = mkWN "kartioupotuspora" ; --UNCHK
lin countersink_V2 = mkWV2 (k53A "upottaa") ; --UNCHK
lin counterspy_N = mkWN (k10 "vakooja") ; --UNCHK
lin counterstain_N = mkWN (compoundN "vastaväri" (k1A "laikku")) ; --UNCHK
lin countersubversion_N = mkWN (k9A "toiminta") "vastakumouksellinen" ; --UNCHK
lin countersuit_N = mkWN (compoundN "vasta" (k48A "kanne")) ; --UNCHK
lin countertenor_A = mkWA (compoundA "kontraten" (k48 "ori")) ; --UNCHK
lin countertenor_N = mkWN (k1A "altto") ; --UNCHK
lin counterterror_A = mkWA "terrorismin" "torjunta-" ; --UNCHK
lin counterterrorism_N = mkWN (compoundN "torjunta" (k12 "strategia")) "terrorismin" ; --UNCHK
lin counterterrorist_N = mkWN "terrorismintorjuja" ; --UNCHK
lin countertop_N = mkWN (compoundN "tiskin" (k38 "päällinen")) ; --UNCHK
lin countertransference_N = mkWN (compoundN "vasta" (k5 "transferenssi")) ; --UNCHK
lin countervail_V = mkWV (k62 "mitätöidä") ; --UNCHK
lin countervail_V2 = mkWV2 (k62 "mitätöidä") ; --UNCHK
lin counterweight_N = mkWN (compoundN "vasta" (k1 "paino")) ; --UNCHK
lin countess_N = mkWN (k32A "kreivitär") ; --UNCHK
lin counting_house_N = mkWN (k6 "konttori") ; --UNCHK
lin countless_A = mkWA (k34A "rajaton") ; --UNCHK
lin countrified_A = mkWA (k38 "maaseutumainen") ; --UNCHK
lin country_N = L.country_N ;
lin country_house_N = mkWN (k2 "kartano") ; --UNCHK
lin countryman_N = mkWN (compoundN "maan" (k42 "mies")) ; --UNCHK
lin country_seat_N = mkWN (compoundN "suur" (k9 "tila")) ; --UNCHK
lin countryside_N = mkWN (k18 "maa") ; --UNCHK
lin countrywide_A = mkWA (compoundA "maan" (k38 "laajuinen")) ; --UNCHK
lin countrywoman_N = mkWN (compoundN "maan" (k42 "mies")) ; --UNCHK
lin county_N = mkWN (compoundN "maa" (k10A "kunta")) | mkWN (compoundN "kreivi" (k10A "kunta")) ;
lin countywide_A = mkWA (k38 "laajuinen") "piirikunnan" ; --UNCHK
lin coup_N = mkWN (k39 "menestys") ; ---ARB --mkN "vallankaappaus" ;
lin coup_d'etat_N = mkWN (compoundN "vallan" (k39 "kaappaus")) ; --UNCHK
lin coup_de_grace_N = mkWN (compoundN "armon" (k1 "isku")) ;
lin coupe_N = mkWN "kupee" ; --UNCHK
lin couple_N = mkN "pari" ;
lin couple_V = mkWV (k53 "yhdistää") ; --UNCHK
lin couple_V2 = mkWV2 (k53 "yhdistää") ;
lin couplet_N = mkWN (k5 "säepari") ; --UNCHK
lin coupling_N = mkWN (k38 "kanssakäyminen") "seksuaalinen" ; --UNCHK
lin coupon_N = mkN "kuponki" ; --f80
lin courage_N = mkWN (k40 "urhoollisuus") ; --UNCHK
lin courageous_A = mkWA (k38 "urhoollinen") ; --UNCHK
lin courante_N = mkWN "courante" ; --UNCHK
lin courbaril_N = mkWN "Hymenaea" "courbaril" ; --UNCHK
lin courgette_N = mkWN (compoundN "kesä" (k13 "kurpitsa")) ; --UNCHK
lin courier_N = mkWN (k6 "kuriiri") ;
lin courlan_N = mkWN (compoundN "kotilo" (k7A "kurki")) ; --UNCHK
lin course_N = mkN "kurssi" ;
lin course_V = mkWV (k56 "ajaa") ; --UNCHK
lin course_V2 = mkWV2 (k56 "ajaa") ; --UNCHK
lin courser_N = mkWN (compoundN "pääsky" (k10 "kahlaaja")) ; --UNCHK
lin coursework_N = mkWN (compoundN "opinto" (k10 "tehtävä")) ; --UNCHK
lin coursing_N = mkWN (compoundN "koira" (k39 "metsästys")) ; --UNCHK
lin court_1_N = mkN "hovi" ;
lin court_2_N = mkN "tuomioistuin" ;
lin court_N = mkN "tuomioistuin" ;
lin court_V = mkWV (k67A "vokotella") ; --UNCHK
lin court_V2 = mkV2 "kosiskella" partitive ;
lin court_card_N = mkWN (compoundN "kuva" (k5A "kortti")) ; --UNCHK
lin courteous_A = mkWA (k41 "kohtelias") ; --UNCHK
lin courtesan_N = mkWN (k32A "rakastajatar") ; --UNCHK
lin courtesy_N = mkWN (k40 "kohteliaisuus") ; --UNCHK
lin courthouse_N = mkWN (compoundN "oikeus" (k1 "talo")) ; --UNCHK
lin courtier_N = mkWN (compoundN "hovi" (k9 "herra")) ; --UNCHK
lin courtliness_N = mkWN (k40 "hienostuneisuus") ; --UNCHK
lin courtly_A = mkWA (k41A "arvokas") ; --UNCHK
lin courtroom_N = mkWN (compoundN "oikeus" (k5 "sali")) ; --UNCHK
lin courtship_N = mkWN (k17 "riiuu") ; --UNCHK
lin courtyard_N = mkWN (k9 "piha") ; --UNCHK
lin couscous_N = mkWN (k5 "kuskus") ; --UNCHK
lin cousin_N = L.cousin_N ;
lin couth_A = mkWA (k47 "hienostunut") ; --UNCHK
lin couthie_A = mkWA (k38 "ystävällinen") ; --UNCHK
lin couture_N = mkWN "haute" "couture" ; --UNCHK
lin couturier_N = mkWN (k12 "suunnittelija") ; --UNCHK
lin couvade_N = mkWN (compoundN "lapsi" (k48A "vuode")) "miehen" ; --UNCHK
lin couverture_N = mkWN (compoundN "kuorrute" (k17 "suklaa")) ; --UNCHK
lin covalence_N = mkWN "kovalenssi" ; --UNCHK
lin covalent_A = mkWA (compoundA "kova" (k38 "lenttinen")) ; --UNCHK
lin covariance_N = mkWN "kovarianssi" ; --UNCHK
lin covariant_A = mkWA "kovariantti" ; --UNCHK
lin covariation_N = mkWN (compoundN "yhteis" (k2 "vaihtelu")) ; --UNCHK
lin cove_N = mkWN (k7A "merenlahti") ; --UNCHK
lin coven_N = mkWN (k39 "kokous") "noitien" ; --UNCHK
lin covenant_N = mkWN (k1A "liitto") ; --UNCHK
lin covenant_V = mkWV (k52A "sitoutua") ; --UNCHK
lin covenant_V2 = mkWV2 (k52A "sitoutua") ; --UNCHK
lin coventry_PN = foreignPN "Coventry" ;
lin cover_N = mkN "kansi" "kannen" "kansia" ;
lin cover_V2 = mkV2 "peittää" ;
lin cover_for_V2 = mkWV2 (k61 "keksiä") "verukkeita" ; --UNCHK
lin cover_up_V2 = mkWV2 (k67A "peitellä") ; --UNCHK
lin coverage_N = mkN "kattavuus" ;
lin coverall_N = mkWN (k6 "haalari") ; --UNCHK
lin covering_N = mkN "peite" ; --WN (k2 "sively") ;
lin coverlet_N = mkWN (compoundN "päivä" (k48A "peite")) ; --UNCHK
lin covert_A = mkWA (k38 "salainen") ; --UNCHK
lin covert_N = mkWN (k1 "piilo") ; --UNCHK
lin covet_V2 = mkWV2 (k75 "haluta") ; --UNCHK
lin covetous_A = mkWA (k1 "perso") ; --UNCHK
lin covetousness_N = mkWN (k40 "kyltymättömyys") ; --UNCHK
lin covey_N = mkWN (k7 "peltopyyparvi") "pieni" ; --UNCHK
lin cow_N = L.cow_N ;
lin cow_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin coward_N = mkWN (k6 "pelkuri") ; --UNCHK
lin cowardice_N = mkWN (k40 "pelkuruus") ; --UNCHK
lin cowardly_A = mkWA (k41A "pelokas") ; --UNCHK
lin cowbarn_N = mkWN (k10 "läävä") ; --UNCHK
lin cowbell_N = mkWN (compoundN "lehmän" (k1 "kello")) ; --UNCHK
lin cowberry_N = mkWN (k14A "puolukka") ; --UNCHK
lin cowboy_N = mkWN (k21 "cowboy") ; --UNCHK
lin cowcatcher_N = mkWN (k6 "puskuri") ; --UNCHK
lin cowdenbeath_PN = foreignPN "Cowdenbeath" ;
lin cower_V = mkWV (k52 "kyyristyä") "peloissaan" ; --UNCHK
lin cowes_PN = foreignPN "Cowes" ;
lin cowfish_N = mkWN "Lactophrys" "quadricornis" ; --UNCHK
lin cowgirl_N = mkWN (compoundN "karja" (k32 "paimen")) ; --UNCHK
lin cowhand_N = mkWN (k21 "cowboy") ; --UNCHK
lin cowherb_N = mkWN (compoundN "touko" (k10A "kukka")) ; --UNCHK
lin cowherd_N = mkWN (k21 "cowboy") ; --UNCHK
lin cowhide_N = mkWN (compoundN "nahka" (k9 "piiska")) ; --UNCHK
lin cowhouse_N = mkWN (k10 "läävä") ; --UNCHK
lin cowl_N = mkWN (k1A "huppu") ; --UNCHK
lin cowled_A = mkWA "kaapuun" "puettu" ; --UNCHK
lin cowlick_N = mkWN (compoundN "hius" (k1 "tupsu")) ; --UNCHK
lin cowling_N = mkWN (k39 "suojus") "moottorin" ; --UNCHK
lin cowman_N = mkWN (k21 "cowboy") ; --UNCHK
lin cowpea_N = mkWN (compoundN "lehmän" (k1A "papu")) ; --UNCHK
lin cowpox_N = mkWN (compoundN "lehmä" (k1A "rokko")) ; --UNCHK
lin cowshed_N = mkWN (k10 "läävä") ; --UNCHK
lin cowskin_N = mkWN (compoundN "naudan" (k9 "nahka")) ; --UNCHK
lin cowslip_N = mkWN (k14A "rentukka") ; --UNCHK
lin cox_N = mkWN (compoundN "perän" (k10 "pitäjä")) ; --UNCHK
lin coxcomb_N = mkWN (k9 "harja") ; --UNCHK
lin coxsackievirus_N = mkWN (compoundN "coxsackie" (k39 "virus")) ; --UNCHK
lin coxswain_N = mkWN (compoundN "perän" (k10 "pitäjä")) ; --UNCHK
lin coy_A = mkWA (k1 "kaino") ; --UNCHK
lin coyness_N = mkWN (k40 "siveys") "teennäinen" ; --UNCHK
lin coyol_N = mkWN "Acrocomia" "vinifera" ; --UNCHK
lin coyote_N = mkWN (k5A "kojootti") ; --UNCHK
lin coypu_N = mkWN (k12 "nutria") ; --UNCHK
lin cozen_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin coziness_N = mkWN (k40 "mukavuus") ; --UNCHK
lin cozy_A = mkWA (k10 "kätevä") ; --UNCHK
lin cozy_up_V = mkWV (k67 "nuoleskella") ; --UNCHK
lin crab_N = mkWN (kH1 "veto") "tyhjä" ; --UNCHK
lin crab_V = mkWV (k53A "valittaa") ; --UNCHK
lin crab_V2 = mkWV2 (k53A "valittaa") ; --UNCHK
lin crab_apple_N = mkWN (compoundN "metsä" (k11 "omena")) ; --UNCHK
lin crabbiness_N = mkWN (k40 "äreys") ; --UNCHK
lin crabgrass_N = mkWN (compoundN "veri" (k5 "hirssi")) ; --UNCHK
lin crabwise_A = mkWA (k38 "sivuttainen") ; --UNCHK
lin crack_N = mkWN (compoundN "rikko" (k38 "minen")) ; --UNCHK
lin crack_V2 = mkV2 "murtaa" ; --WV2 "krakkautua" ;
lin crack_up_V = mkWV (k53A "hohottaa") ; --UNCHK
lin crack_up_V2 = mkWV2 (k53A "hohottaa") ; --UNCHK
lin crackbrained_A = mkWA (k38 "idioottimainen") ; --UNCHK
lin crack_down_N = mkWN (k12 "ratsia") ; --UNCHK
lin cracker_N = mkWN (compoundN "paukku" (k5 "karamelli")) ; --UNCHK
lin crackers_A = mkWA (k1 "pöllö") ; --UNCHK
lin cracking_N = mkWN (compoundN "rikko" (k38 "minen")) ; --UNCHK
lin crackle_A = mkWA (compoundA "särö" (k38 "lasitteinen")) ; --UNCHK
lin crackle_N = mkWN (k6 "posliini") "särölasitteinen" ; --UNCHK
lin crackle_china_N = mkWN (k6 "posliini") "särölasitteinen" ; --UNCHK
lin crackleware_N = mkWN (k6 "posliini") "särölasitteinen" ; --UNCHK
lin crackling_N = mkWN (k39 "risahdus") ; --UNCHK
lin cracklings_N = mkWN (kH1 "kuori") "kinkun" ; --UNCHK
lin crackpot_N = mkWN (k10 "pöljä") ; --UNCHK
lin cracksman_N = mkWN (k10 "murtautuja") ; --UNCHK
lin cradle_N = mkWN (k1A "kehto") ; --UNCHK
lin craft_N = mkWN (k1A "taito") ; --UNCHK
lin craft_V2 = mkV2 "valmistella" ; --mkWV2 (k53 "valmistaa") "käsin" ;
lin craftiness_N = mkWN (k40 "juonikkuus") ; --UNCHK
lin craftsman_N = mkWN (k5 "artesaani") ; --UNCHK
lin craftsmanship_N = mkWN (compoundN "ammatti" (k1A "taito")) ; --UNCHK
lin crafty_A = mkWA (k10 "näppärä") ; --UNCHK
lin crag_N = mkWN (k3 "kallio") "jyrkkä" "rosoinen" ; --UNCHK
lin cragfast_A = mkWA (k99 "jumissa") ; --UNCHK
lin cragged_A = mkWA (k38 "kukkulainen") ; --UNCHK
lin craggy_A = mkWA (k38 "kukkulainen") ; --UNCHK
lin cragsman_N = mkWN (compoundN "vuori" (k12 "kiipeilijä")) ; --UNCHK
lin crake_N = mkWN (compoundN "ranta" (k9 "kana")) ; --UNCHK
lin cram_V = mkWV (k56A "ahtaa") "päähänsä" ; --UNCHK
lin cram_V2 = mkWV2 (k56A "ahtaa") "päähänsä" ; --UNCHK
lin cram_full_A = mkWA (k99 "täynnä") "tupaten" ; --UNCHK
lin cramlington_PN = foreignPN "Cramlington" ;
lin crammer_N = mkWN (compoundN "preppaus" (k9 "kirja")) ; --UNCHK
lin cramp_N = mkWN (k1 "määrly") ; --UNCHK
lin cramp_V2 = mkWV2 (k53A "vetää") "suonta" ; --UNCHK
lin cramp_iron_N = mkWN (k1 "määrly") ; --UNCHK
lin crampon_N = mkWN (k9 "nasta") ; --UNCHK
lin cran_N = mkWN "cran" ; --UNCHK
lin cranberry_N = mkWN (k2 "karpalo") ; --UNCHK
lin crane_N = mkWN (k7A "kurki") ;
lin crane_V = mkWV (k52A "kurkottautua") ; --UNCHK
lin crane_V2 = mkWV2 (k52A "kurkottautua") ; --UNCHK
lin crane_fly_N = mkWN (k38 "vaaksiainen") ; --UNCHK
lin cranesbill_N = mkWN (compoundN "kurjenp" (k5 "olvi")) ; --UNCHK
lin cranial_A = mkWA "kallon" ; --UNCHK
lin craniology_N = mkWN (compoundN "kallo-" (k5A "oppi")) ; --UNCHK
lin craniometer_N = mkWN (compoundN "mittaus" (k48A "laite")) "kallon" ; --UNCHK
lin craniometric_A = mkWA (compoundA "kranio" (k38 "metrinen")) ; --UNCHK
lin craniometry_N = mkWN "kraniometria" ; --UNCHK
lin craniotomy_N = mkWN (k39 "avaus") "kallon" ; --UNCHK
lin cranium_N = mkWN (k1 "kallo") ; --UNCHK
lin crank_A = mkWA (k11 "hutera") ; --UNCHK
lin crank_N = mkWN (k5 "veivi") ; --UNCHK
lin crank_V2 = mkWV2 (k53A "taivuttaa") "polvelle" ; --UNCHK
lin crank_up_V2 = mkWV2 (k73 "veivata") ; --UNCHK
lin crankcase_N = mkWN (compoundN "kampi" (k3 "kammio")) ; --UNCHK
lin crankiness_N = mkWN (k40 "uppiniskaisuus") ; --UNCHK
lin crankshaft_N = mkWN (compoundN "kampi" (k6 "akseli")) ; --UNCHK
lin cranky_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin crannied_A = mkWA (k38 "koloinen") ; --UNCHK
lin cranny_N = mkWN (k1 "kolo") ; --UNCHK
lin crap_N = mkWN (k1 "fusku") ; --UNCHK
lin crap_V = mkWV (k73A "kakata") ; --UNCHK
lin crap_shooting_N = mkWN "crapsin" "pelaaminen" ; --UNCHK
lin crapaud_N = mkWN "Leptodactylus" "pentadactylus" ; --UNCHK
lin crape_N = mkWN (k5A "kreppi") ; --UNCHK
lin crappie_N = mkWN "Pomoxis" ; --UNCHK
lin craps_N = mkWN "craps" ; --UNCHK
lin crapshoot_N = mkWN "crapsin" "pelaaminen" ; --UNCHK
lin crapshooter_N = mkWN (k10 "pelaaja") "crapsin" ; --UNCHK
lin crapulent_A = mkWA (k38 "humalainen") ; --UNCHK
lin crapulous_A = mkWA (k38 "humalainen") ; --UNCHK
lin crash_N = mkN "törmays" ;
lin crash_V = mkWV (k52A "nukkua") ; --UNCHK
lin crash_dive_N = mkWN (k39 "sukellus") "nopea" ; --UNCHK
lin crash_dive_V = variants {} ; -- guess-p-verb
lin crash_helmet_N = mkWN (compoundN "suoja" (k10 "kypärä")) ; --UNCHK
lin crash_land_V = mkWV (k71 "tehdä") "pakkolasku" ; --UNCHK
lin crash_land_V2 = mkWV2 (k71 "tehdä") "pakkolasku" ; --UNCHK
lin crash_landing_N = mkWN (compoundN "maahan" (k1 "syöksy")) ; --UNCHK
lin crash_out_V = advV OP_crash_V OP_out_Adv ; -- guess-p-verb
lin crass_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin crassness_N = mkWN (k40 "karkeus") ; --UNCHK
lin crate_N = mkWN (k4A "laatikko") ; --UNCHK
lin crater_N = mkWN (k6 "kraatteri") ; --UNCHK
lin craton_N = mkWN (compoundN "manner" (k33A "ydin")) ; --UNCHK
lin cravat_N = mkWN (k3 "solmio") ; --UNCHK
lin crave_V = mkWV (k54A "pyytää") "hartaasti" ; --UNCHK
lin crave_V2 = mkWV2 (k54A "pyytää") "hartaasti" ; --UNCHK
lin craven_A = mkWA (k38 "raukkamainen") ; --UNCHK
lin craven_N = mkWN (k9A "raukka") ; --UNCHK
lin cravenness_N = mkWN "pelkurimaisuus" ; --UNCHK
lin craving_N = mkWN (k1 "jano") ; --UNCHK
lin craw_N = mkWN (k1A "kupu") ; --UNCHK
lin crawfish_N = mkWN (k5 "langusti") ; --UNCHK
lin crawl_N = mkWN (k39 "konttaus") ; --UNCHK
lin crawl_V = mkWV (k61A "mönkiä") ; --UNCHK
lin crawler_N = mkWN (k1 "liero") ; --UNCHK
lin crawley_PN = foreignPN "Crawley" ;
lin crawlspace_N = mkWN (compoundN "ryömintä" (k9 "tila")) ; --UNCHK
lin crayfish_N = mkWN (k5 "langusti") ; --UNCHK
lin crayon_N = mkWN (compoundN "vaha" (k1A "liitu")) ; --UNCHK
lin crayon_V2 = mkWV2 (k54A "piirtää") "väriliidulla" ; --UNCHK
lin craze_N = mkWN (k1 "särö") ; --UNCHK
lin crazed_A = mkWA (k47 "häiriintynyt") ; --UNCHK
lin craziness_N = mkWN (k39 "hullutus") ; --UNCHK
lin crazy_A = mkWA (k47 "höpsähtänyt") ; --UNCHK
lin crazy_N = mkWN (k6 "kaheli") ; --UNCHK
lin creak_N = mkWN (k12 "kitinä") ; --UNCHK
lin creak_V = mkWV (k66 "natista") ; --UNCHK
lin creaky_A = mkWA (k38 "reumaattinen") ; --UNCHK
lin cream_N = mkWN (k48A "voide") ; --UNCHK
lin cream_V2 = mkWV2 (k53A "rökittää") ; --UNCHK
lin creamcups_N = mkWN "Platystemon" "californicus" ; --UNCHK
lin creamery_N = mkWN (k6 "meijeri") ; --UNCHK
lin creaminess_N = mkWN "sakeus" ; --UNCHK
lin creamy_A = mkWA (compoundA "kerman" (k38 "valkoinen")) ; --UNCHK
lin crease_N = mkWN "kris" ; --UNCHK
lin crease_V = mkWV (k52A "poimuttua") ; --UNCHK
lin crease_V2 = mkWV2 (k52A "poimuttua") ; --UNCHK
lin creaseless_A = mkWA "rypytön" ; --UNCHK
lin creaseproof_A = mkWA (k34A "rypistymätön") ; --UNCHK
lin create_V = mkV "luoda" ;
lin create_V2 = mkV2 "luoda" ;
lin creatine_N = mkWN "kreatiini" ; --UNCHK
lin creation_N = mkWN (compoundN "luoma" (k10A "kunta")) ; --UNCHK
lin creationism_N = mkWN (k5 "kreationismi") ; --UNCHK
lin creative_A = mkWA (k10 "luova") ;
lin creativeness_N = mkWN (k2 "ajattelu") "luova" ; --UNCHK
lin creativity_N = mkWN (k2 "ajattelu") "luova" ; --UNCHK
lin creator_N = mkN "luoja" ; --mkWN (compoundN "Kaikki" (k41 "valtias")) ;
lin creature_N = mkWN (k3 "olio") ; --UNCHK
lin creche_N = mkWN "löytölastenkoti" ; --UNCHK
lin credence_N = mkWN (compoundN "sivu" (k10A "pöytä")) ; --UNCHK
lin credenza_N = mkWN (compoundN "sivu" (k10A "pöytä")) ; --UNCHK
lin credibility_N = mkN "uskottavuus" | mkWN (k40 "luotettavuus") ;
lin credible_A = mkWA (k10 "uskottava") ;
lin credit_N = mkN "luotto" ;
lin credit_V2 = mkWV2 (k52 "uskoa") ; --UNCHK
lin credit_side_N = mkWN (compoundN "credit-" (k26 "puoli")) ; --UNCHK
lin creditable_A = mkWA (k41A "kunniakas") ; --UNCHK
lin creditor_N = mkWN (k10 "velkoja") ; --f140
lin credits_N = mkWN (compoundN "tekijä" (k2 "luettelo")) ; --UNCHK
lin credit_worthiness_N = mkWN (compoundN "luotto" (k40 "kelpoisuus")) ; --UNCHK
lin credit_worthy_A = mkWA (k10 "luotettava") ; --UNCHK
lin credo_N = mkWN (k5A "oppi") ; --UNCHK
lin credulity_N = mkWN "herkkäuskoisuus" ; --UNCHK
lin credulous_A = mkWA (compoundA "sini" (k38 "silmäinen")) ; --UNCHK
lin credulousness_N = mkWN "hyväuskoisuus" ; --UNCHK
lin creed_N = mkWN (k5A "oppi") ; --UNCHK
lin creedal_A = mkWA "uskon" ; --UNCHK
lin creek_N = mkWN (k1 "puro") ; --UNCHK
lin creel_N = mkWN (compoundN "kala" (k5 "kori")) ; --UNCHK
lin creep_N = mkWN (k39 "konttaus") ; --UNCHK
lin creep_V = mkV "madella" ;
lin creep_in_V = mkWV (k53A "pujahtaa") ; --UNCHK
lin creep_up_V = mkWV (k61A "hiipiä") ; --UNCHK
lin creeper_N = mkWN (compoundN "puu" (k12 "kiipijä")) ; --UNCHK
lin creepy_A = mkWA (k10 "karmiva") ; --UNCHK
lin cremains_N = mkWN (k10 "tuhka") "vainajan" ; --UNCHK
lin cremate_V2 = mkWV2 (k53A "polttaa") "tuhkaksi" ; --UNCHK
lin cremation_N = mkWN (k39 "tuhkaus") ; --UNCHK
lin crematorium_N = mkWN (k3 "krematorio") ; --UNCHK
lin crematory_N = mkWN (k3 "krematorio") ; --UNCHK
lin crenate_A = mkWA (compoundA "hammas" (k1 "tettu")) ; --UNCHK
lin crenel_N = mkWN (compoundN "ampuma-" (k1A "aukko")) ; --UNCHK
lin crenulate_A = mkWA (compoundA "nyhä" (k38 "laitainen")) ; --UNCHK
lin creole_A = mkWA (compoundA "kreoli" (k38 "lainen")) ; --UNCHK
lin creole_N = mkWN (k5 "kreoli") ; --UNCHK
lin creosol_N = mkWN "kreosoli" ; --UNCHK
lin creosote_N = mkWN (compoundN "kreosootti" (k1 "öljy")) ; --UNCHK
lin crepe_1_N = mkWN (k5A "kreppi") ; --UNCHK ---- sense to be split
lin crepe_2_N = mkWN (k5A "kreppi") ; --UNCHK ---- sense to be split
lin crepe_N = mkWN (k5A "kreppi") ; --UNCHK
lin crepitate_V = mkWV (k66 "ratista") ; --UNCHK
lin crepitation_N = mkWN (k39 "risahdus") ; --UNCHK
lin crepuscular_A = mkWA "hämärä-" ; --UNCHK
lin cres_PN = foreignPN "Cres" ;
lin crescendo_A = mkWA "voimistuva" ; --UNCHK
lin crescendo_N = mkWN "crescendo" ; --UNCHK
lin crescent_N = mkWN (k5A "sirppi") ; --UNCHK
lin cresol_N = mkWN (compoundN "butyyli" (k5 "fenoli")) ; --UNCHK
lin cress_N = mkWN (k5 "krassi") ; --UNCHK
lin crest_N = mkWN (k1A "töyhtö") ; --UNCHK
lin crest_V = mkWV (k66 "nousta") "korkeimmilleen" ; --UNCHK
lin crest_V2 = mkWV2 (k66 "nousta") "korkeimmilleen" ; --UNCHK
lin crestfallen_A = mkWA (k38 "alakuloinen") ; --UNCHK
lin creswell_PN = foreignPN "Creswell" ;
lin cretaceous_A = mkWA "liitukauden" ; --UNCHK
lin cretin_N = mkWN (k1 "tollo") ; --UNCHK
lin cretinism_N = mkWN (compoundN "kretin" (k5 "ismi")) ; --UNCHK
lin cretinous_A = mkWA "kretinismistä" "kärsivä" ; --UNCHK
lin cretonne_N = mkWN (k5A "kretonki") ; --UNCHK
lin crevasse_N = mkWN (k1 "railo") ; --UNCHK
lin crevice_N = mkWN (k1A "rako") ; --UNCHK
lin crew_N = mkWN (k2 "miehistö") ; --UNCHK
lin crew_V = mkWV (k52 "kuulua") "miehistöön" ; --UNCHK
lin crew_cut_N = mkWN (compoundN "pysty" (k10A "tukka")) ; --UNCHK
lin crew_neck_N = mkWN (compoundN "pään" (k19 "tie")) "pyöreä" ; --UNCHK
lin crewe_PN = foreignPN "Crewe" ;
lin crewelwork_N = mkWN (compoundN "kirjonta" (k19 "työ")) ; --UNCHK
lin crewman_N = mkWN (k32 "jäsen") "miehistön" ; --UNCHK
lin crib_N = mkWN "cribbage" ; --UNCHK
lin crib_V = mkWV (k53 "vahvistaa") "salvoksella" ; --UNCHK
lin crib_V2 = mkWV2 (k53 "vahvistaa") "salvoksella" ; --UNCHK
lin cribbage_N = mkWN "cribbage" ; --UNCHK
lin cribbage_board_N = mkWN (compoundN "cribbage-" (k9A "lauta")) ; --UNCHK
lin crick_V2 = mkWV2 (k54A "vääntää") ; --UNCHK
lin cricket_N = mkWN (k5A "kriketti") ; --UNCHK
lin cricketer_N = mkWN (compoundN "kriketin" (k10 "pelaaja")) ; --UNCHK
lin crieff_PN = foreignPN "Crieff" ;
lin crier_N = mkWN (k12 "kaupustelija") ; --UNCHK
lin crime_N = mkWN (k39 "rikos") ;
lin criminal_A = mkA (lin AK {s = d38 "rikollinen"}) ;
lin criminal_N = mkWN (k10 "konna") ; --UNCHK
lin criminalism_N = mkWN (k40 "rikollisuus") ; --UNCHK
lin criminalization_N = mkWN (k5A "kriminalisointi") ; --UNCHK
lin criminalize_V2 = mkWV2 (k53 "julistaa") "laittomaksi" ; --UNCHK
lin criminative_A = mkWA (k10 "raskauttava") ; --UNCHK
lin criminological_A = mkWA (compoundA "rikos" (k38 "opillinen")) ; --UNCHK
lin criminologist_N = mkWN (k5 "kriminologi") ; --UNCHK
lin criminology_N = mkWN (k12 "kriminologia") ; --UNCHK
lin crimp_N = mkWN (k11 "kihara") "käherretty" ; --UNCHK
lin crimp_V2 = mkWV2 (k54A "sykertää") ; --UNCHK
lin crimson_A = mkWA (k38 "verinen") ; --UNCHK
lin crimson_N = mkWN (compoundN "rubiinin" (k38 "punainen")) ; --UNCHK
lin crimson_V = mkWV (k52 "punastua") ; --UNCHK
lin crimson_V2 = mkWV2 (k52 "punastua") ; --UNCHK
lin cringe_V = mkWV (k53A "säpsähtää") ; --UNCHK
lin cringle_N = mkWN (k14A "silmukka") ; --UNCHK
lin crinkle_N = mkWN (k1A "kurttu") ; --UNCHK
lin crinkle_V = mkWV (k52A "poimuttua") ; --UNCHK
lin crinkle_V2 = mkWV2 (k52A "poimuttua") ; --UNCHK
lin crinkleroot_N = mkWN (k26 "hammasjuuri") ; --UNCHK
lin crinkly_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin crinoid_A = mkWA (k10 "kuuluva") "merililjoihin" ; --UNCHK
lin crinoid_N = mkWN (compoundN "meri" (k9 "lilja")) ; --UNCHK
lin crinoline_N = mkWN (k5 "krinoliini") ; --UNCHK
lin criollo_N = mkWN "criollo" ; --UNCHK
lin cripple_N = mkWN (k38 "vammainen") ; --UNCHK
lin cripple_V2 = mkWV2 (k53A "vammauttaa") ; --UNCHK
lin crippling_A = mkWA (compoundA "ramp" (k10 "auttava")) ; --UNCHK
lin crisis_N = mkN (lin NK {s = d05 "kriisi"}) ;
lin crisp_A = mkWA (k15 "selkeä") ; --UNCHK
lin crisp_N = mkWN (k5 "sipsi") ; --UNCHK
lin crisp_V = mkWV (k56A "paahtaa") ; --UNCHK
lin crisp_V2 = mkWV2 (k56A "paahtaa") ; --UNCHK
lin crispate_A = mkWA (k10 "kähärä") ; --UNCHK
lin crispness_N = mkWN (k40 "tuoreus") ; --UNCHK
lin crisscross_A = mkWA "ristikko-" ; --UNCHK
lin crisscross_Adv = mkWAdv (k99 "ristikkäin") ; --UNCHK
lin crisscross_N = mkWN (k5 "kruksi") ; --UNCHK
lin cristobalite_N = mkWN "kristobaliitti" ; --UNCHK
lin criterial_A = mkWA "kriteeri-" ; --UNCHK
lin criterion_N = mkWN (k6 "standardi") ; --UNCHK
lin crith_N = mkWN (k1 "paino") "vetylitran" ; --UNCHK
lin critic_N = mkN (lin NK {s = d04A "kriitikko"}) ;
lin critical_1_A = mkA "kriittinen" ;
lin critical_2_A = mkA "kriittinen" ;
lin critical_A = mkA "kriittinen" ;
lin criticality_N = mkWN (k9 "tila") "kriittinen" ; --UNCHK
lin criticism_N = mkN "kritiikki" ; --f56
lin criticize_V = mkWV (k61A "moittia") ;
lin criticize_V2 = mkV2 (mkV "kritisoida") partitive ;
lin critique_N = mkWN (k2 "tarkastelu") ; --UNCHK
lin critter_N = mkWN (k14A "elukka") ; --UNCHK
lin croak_N = mkWN "kurnutus" ; --UNCHK
lin croak_V = mkWV (k67 "kuolla") "äkillisesti" ; --UNCHK
lin croak_V2 = mkWV2 (k67 "kuolla") "äkillisesti" ; --UNCHK
lin croaker_N = mkWN (compoundN "rumpu" (k9 "kala")) ; --UNCHK
lin croaky_A = mkWA (compoundA "kähis" (k10 "evä")) ; --UNCHK
lin crochet_N = mkWN (k39 "virkkaus") ; --UNCHK
lin crochet_V = mkWV (k73A "virkata") ; --UNCHK
lin crochet_V2 = mkWV2 (k73A "virkata") ; --UNCHK
lin crochet_hook_N = mkWN (compoundN "virkkaus" (k1A "koukku")) ; --UNCHK
lin crocheting_N = mkWN (compoundN "virkkaa" (k38 "minen")) ; --UNCHK
lin crock_N = mkWN (compoundN "savi" (k12 "astia")) ; --UNCHK
lin crock_V = mkWV (k74A "noeta") ; --UNCHK
lin crock_V2 = mkWV2 (k74A "noeta") ; --UNCHK
lin crocket_N = mkWN (compoundN "lehti" (k48 "koriste")) ; --UNCHK
lin crocketed_A = mkWA "varustettu" "lehtikoristeella" ; --UNCHK
lin crocodile_N = mkWN (k5 "krokotiili") ; --UNCHK
lin crocolite_N = mkWN "krokoiitti" ; --UNCHK
lin crocus_N = mkWN (k39 "krookus") ; --UNCHK
lin croft_N = mkWN (compoundN "pien" (k9 "tila")) ; --UNCHK
lin crofter_N = mkWN (compoundN "pien" (k38 "tilallinen")) ; --UNCHK
lin cromer_PN = foreignPN "Cromer" ;
lin cromlech_N = mkWN (k9A "hauta") "kivikautinen" ; --UNCHK
lin crone_N = mkWN (k1A "harppu") ; --UNCHK
lin crony_N = mkWN (k10 "tuttava") ; --UNCHK
lin cronyism_N = mkWN (compoundN "suo" (k38 "siminen")) "ystävien" ; --UNCHK
lin crook_N = mkWN (compoundN "paimen" (k9 "sauva")) ; --UNCHK
lin crook_PN = foreignPN "Crook" ;
lin crook_V = mkWV (k53 "käyristää") ; --UNCHK
lin crook_V2 = mkWV2 (k53 "käyristää") ; --UNCHK
lin crook_back_A = mkWA (compoundA "koukku" (k38 "selkäinen")) ; --UNCHK
lin crookedness_N = mkWN (k40 "kieroutuneisuus") ; --UNCHK
lin crookneck_N = mkWN (compoundN "jättiläis" (k13 "kurpitsa")) ; --UNCHK
lin croon_V = mkWV (k67 "hyräillä") ; --UNCHK
lin croon_V2 = mkWV2 (k67 "hyräillä") ; --UNCHK
lin crooner_N = mkWN (k10 "laulaja") "viisujen" ; --UNCHK
lin crooning_N = mkWN (compoundN "lau" (k1 "lelu")) "iskelmien" ; --UNCHK
lin crop_N = mkWN (k1A "sato") ; --f65
lin crop_V = mkWV (k61 "oksia") ; --UNCHK
lin crop_V2 = mkWV2 (k61 "oksia") ; --UNCHK
lin crop_up_V = mkWV (k53A "putkahtaa") ; --UNCHK
lin cropper_N = mkWN (compoundN "maan" (k10 "vuokraaja")) ; --UNCHK
lin croquet_N = mkWN (k5A "kroketti") ; --UNCHK
lin croquette_N = mkWN (k14A "kuorukka") ; --UNCHK
lin crore_N = mkWN "kymmenen" "miljoonaa" ; --UNCHK
lin crosby_PN = foreignPN "Crosby" ;
lin crosier_N = mkWN (compoundN "piispan" (k9 "sauva")) ; --UNCHK
lin cross_A = mkWA (k10 "ärtyisä") ; --UNCHK
lin cross_N = mkWN (k39 "risteytys") ;
lin cross_V = mkWV (k53A "risteyttää") ; --UNCHK
lin cross_V2 = mkWV2 (k53A "risteyttää") ; --UNCHK
lin cross_examine_V2 = mkWV2 (compoundV "risti" (k67 "kuulustella")) ; --UNCHK
lin cross_fertilize_V2 = variants {} ; -- guess-p-verb
lin cross_index_V2 = variants {} ; -- guess-p-verb
lin cross_off_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin cross_out_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin cross_question_V2 = mkWV2 (compoundV "risti" (k67 "kuulustella")) ; --UNCHK
lin cross_section_N = mkWN (compoundN "vaikutus" (k9 "ala")) ; --UNCHK
lin cross_up_V2 = prepV2 OP_cross_V OP_up_Prep ; -- guess-p-verb
lin crossbar_N = mkWN (compoundN "poikki" (k18 "puu")) ; --UNCHK
lin crossbeam_N = mkWN (compoundN "poikki" (k5A "palkki")) ; --UNCHK
lin cross_bench_N = mkWN (k5A "penkki") "puolueettomien" ; --UNCHK
lin cross_bencher_N = mkWN (k32 "jäsen") "riippumaton" "alahuoneen" ; --UNCHK
lin crossbill_N = mkWN "pikkukäpylintu" ; --UNCHK
lin crossbow_N = mkWN (compoundN "varsi" (k26 "jousi")) ; --UNCHK
lin crossbreed_N = mkWN (k39 "risteytys") ; --UNCHK
lin crossbreed_V2 = mkWV2 (k53A "risteyttää") ; --UNCHK
lin crosscheck_N = mkWN (k9 "maila") "poikittainen" ; --UNCHK
lin crosscurrent_N = mkWN (compoundN "vasta" (k39 "virtaus")) ; --UNCHK
lin crosscut_N = mkWN (k2 "oikaisu") ; --UNCHK
lin crosse_N = mkWN (compoundN "haavipallo" (k9 "maila")) ; --UNCHK
lin crossfire_N = mkWN (compoundN "risti" (k23 "tuli")) ; --UNCHK
lin crosshairs_N = mkWN (compoundN "keski" (k48 "piste")) ; --UNCHK
lin crosshead_N = mkWN (compoundN "risti" (k48 "kappale")) ; --UNCHK
lin cross_heading_N = mkWN (compoundN "väli" (k4A "otsikko")) ; --UNCHK
lin crossing_N = mkWN (k39 "ylitys") ; --UNCHK
lin crossjack_N = mkWN (compoundN "mesaani" (k48 "purje")) ; --UNCHK
lin crossness_N = mkWN (k40 "äreys") ; --UNCHK
lin crossopterygian_N = mkWN (compoundN "varsi" (k38 "eväinen")) ; --UNCHK
lin crossover_N = mkWN (compoundN "suoja" (k19 "tie")) ; --UNCHK
lin crosspatch_N = mkWN (k12 "kiukuttelija") ; --UNCHK
lin crosspiece_N = mkWN (compoundN "risti" (k48 "kappale")) ; --UNCHK
lin crossroad_N = mkWN (k39 "risteys") ; --UNCHK
lin crossroads_N = mkWN (k10A "risteyskohta") ; --UNCHK
lin crosstalk_N = mkWN (compoundN "keskinäis" (k3 "häiriö")) ; --UNCHK
lin crosstown_A = mkWA (k99 "poikki") "kaupungin" ; --UNCHK
lin crosstown_Adv = mkWAdv (k99 "poikki") "kaupungin" ; --UNCHK
lin crosswalk_N = mkWN (compoundN "suoja" (k19 "tie")) ; --UNCHK
lin crosswind_N = mkWN (compoundN "sivu" (k26 "tuuli")) ; --UNCHK
lin crosswise_A = mkWA (k38 "poikittainen") ; --UNCHK
lin crosswise_Adv = mkWAdv (k99 "ristiin") ; --UNCHK
lin crossword_N = mkWN (compoundN "sana" (k4A "ristikko")) ; --UNCHK
lin crotalaria_N = mkWN (compoundN "kuitu" (k48 "herne")) ; --UNCHK
lin crotaphion_N = mkWN (k7A "kärki") "kitaluun" "isosiiven" ; --UNCHK
lin crotchet_N = mkWN (k1A "koukku") ; --UNCHK
lin crotchety_A = mkWA (k1 "häijy") ; --UNCHK
lin croton_N = mkWN (compoundN "ihme" (k41 "pensas")) ; --UNCHK
lin crottle_N = mkWN (compoundN "iso" (k48A "karve")) ; --UNCHK
lin crouch_N = mkWN (k1A "kyykky") ; --UNCHK
lin crouch_V = mkWV (k52 "kyykistyä") ; --UNCHK
lin croup_N = mkWN (k10 "perä") ; --UNCHK
lin croupier_N = mkWN (k5 "krupieeri") ; --UNCHK
lin croupy_A = mkWA (compoundA "muis" (k10 "tuttava")) "kuristustautia" ; --UNCHK
lin crouton_N = mkWN (compoundN "leipä" (k3 "kuutio")) "paistettu" ; --UNCHK
lin crow's_nest_N = mkWN (compoundN "märssy" (k5 "kori")) ; --UNCHK
lin crow_N = mkWN (k39 "varis") ; --UNCHK
lin crow_V = mkWV (k67A "kiljahdella") "ilosta" ; --UNCHK
lin crow_VS = mkWVS (k67A "kiljahdella") "ilosta" ; --UNCHK
lin crowbait_N = mkWN (k10 "luuska") ; --UNCHK
lin crowbar_N = mkWN (compoundN "sorkka" (k9A "rauta")) ; --UNCHK
lin crowberry_N = mkWN (compoundN "variksen" (k9 "marja")) ; --UNCHK
lin crowborough_PN = foreignPN "Crowborough" ;
lin crowd_N = mkWN (k1A "joukko") ;
lin crowd_V = mkWV (k61 "tungeksia") ;
lin crowd_V2 = mkWV2 (k61 "tungeksia") ; --UNCHK
lin crowded_A = mkA "kansoitettu" ;
lin crowding_N = mkWN (k39 "tungos") ; --UNCHK
lin crown_N = mkWN (k1A "kupu") ; --UNCHK
lin crown_V2 = mkWV2 (k67 "olla") "huippukohta" ; --UNCHK
lin crown_land_N = mkWN (compoundN "valtion" (k18 "maa")) ; --UNCHK
lin crownbeard_N = mkWN (compoundN "kulta" (k1 "kruunu")) ; --UNCHK
lin crowning_A = mkWA "huippu-" ; --UNCHK
lin crowthorne_PN = foreignPN "Crowthorne" ;
lin croydon_PN = foreignPN "Croydon" ;
lin crozier_N = mkWN (compoundN "piispan" (k9 "sauva")) ; --UNCHK
lin crucial_A = mkA "ratkaiseva" ;
lin cruciate_A = mkWA (k38 "muotoinen") "ristin" ; --UNCHK
lin crucible_N = mkWN (k41A "upokas") ; --UNCHK
lin crucifer_N = mkWN (compoundN "ristikukkais" (k5 "kasvi")) ; --UNCHK
lin cruciferous_A = mkWA "ristikukkaiskasvin" ; --UNCHK
lin crucifix_N = mkWN (compoundN "risti" (k9A "riipunta")) ; --UNCHK
lin crucifixion_N = mkWN (k39 "kidutus") ; --UNCHK
lin cruciform_A = mkWA (k38 "muotoinen") "ristin" ; --UNCHK
lin crucify_V2 = mkWV2 (k61A "sättiä") ; --UNCHK
lin crud_N = mkWN (k5A "tauti") "epämääräinen" ; --UNCHK
lin cruddy_A = mkWA (k10 "ruma") ; --UNCHK
lin crude_A = mkWA (kH1 "raaka") ;
lin crudeness_N = mkWN (k40 "karkeus") ; --UNCHK
lin crudity_N = mkWN (k40 "tahdittomuus") ; --UNCHK
lin cruel_A = mkWA (kH1 "raaka") ; --UNCHK
lin cruelty_N = mkWN (k2 "kohtelu") "epäinhimillinen" ; --UNCHK
lin cruet_N = mkWN (compoundN "öljy" (k1 "kannu")) ; --UNCHK
lin cruise_N = mkN (lin NK {s = d02 "risteily"}) ;
lin cruise_V = mkWV (k67 "risteillä") ; --UNCHK
lin cruiser_N = mkWN (compoundN "huvi" (k28 "pursi")) ; --UNCHK
lin cruller_N = mkWN (k12 "rinkilä") "rasvassa" "kypsennetty" ; --UNCHK
lin crumb_N = mkWN (k1 "muru") ; --UNCHK
lin crumble_V = mkWV (k74 "lahota") ; --UNCHK
lin crumble_V2 = mkWV2 (k74 "lahota") ; --UNCHK
lin crumbliness_N = mkWN (k40 "hauraus") ; --UNCHK
lin crumbly_A = mkWA (k41 "hauras") ; --UNCHK
lin crumpet_N = mkWN (compoundN "tee" (k10A "leipä")) "murea" ; --UNCHK
lin crumple_V = mkWV (k52A "poimuttua") ; --UNCHK
lin crumple_V2 = mkWV2 (k52A "poimuttua") ; --UNCHK
lin crunch_N = mkWN (k39 "puristus") ; --UNCHK
lin crunch_V = mkWV (k73 "muusata") ; --UNCHK
lin crunch_V2 = mkWV2 (k73 "muusata") ; --UNCHK
lin crupper_N = mkWN (compoundN "häntä" (k19 "vyö")) ; --UNCHK
lin crural_A = mkWA "sääri-" ; --UNCHK
lin crus_N = mkWN (k26 "sääri") ; --UNCHK
lin crusade_N = mkN "kampanja" ; --mkWN (k39 "pyrkimys") ;
lin crusade_V = mkWV (k67 "olla") "ristiretkellä" ; --UNCHK
lin crusader_N = mkWN (compoundN "risti" (k38 "retkeläinen")) ; --UNCHK
lin cruse_N = mkWN (k1A "ruukku") "pieni" ; --UNCHK
lin crush_N = mkN "murska" ;
lin crush_V = mkWV (k71 "tehdä") "loppu" ; --UNCHK
lin crush_V2 = mkV2 "murskata" ;
lin crusher_N = mkWN (k33 "rouhin") ; --UNCHK
lin crushingly_Adv = mkWAdv (k99 "murskaavasti") ; --UNCHK
lin crust_N = mkWN (k10A "pokka") ; --UNCHK
lin crust_V = mkWV (k52 "muodostua") "kuori" ; --UNCHK
lin crust_V2 = mkWV2 (k52 "muodostua") "kuori" ; --UNCHK
lin crustacean_N = mkWN (k38 "äyriäinen") ; --UNCHK
lin crustaceous_A = mkWA (compoundA "kuori" (k38 "mainen")) ; --UNCHK
lin crustal_A = mkWA "maankuoren" ; --UNCHK
lin crustose_A = mkWA "rupi-" ; --UNCHK
lin crusty_A = mkWA (k15 "töykeä") ; --UNCHK
lin crutch_N = mkWN (compoundN "kainalo" (k9 "sauva")) ; --UNCHK
lin crux_N = mkWN (k33A "ydin") "asian" ; --UNCHK
lin cry_N = mkWN (k1A "parku") ;
lin cry_V = mkV "itkeä" ;
lin cry_V2 = mkV2 (mkV "itkeä") partitive ;
lin cry_off_V2 = prepV2 OP_cry_V OP_off_Prep ; -- guess-p-verb
lin cry_out_V = mkWV (k52A "parkua") ; --UNCHK
lin crybaby_N = mkWN (k12 "marisija") ; --UNCHK
lin cryesthesia_N = mkWN (compoundN "kylmän" (k40 "herkkyys")) ; --UNCHK
lin crying_N = mkWN (k1 "itku") ; --UNCHK
lin cryoanesthesia_N = mkWN (compoundN "kylmä" (k12 "anestesia")) ; --UNCHK
lin cryobiology_N = mkWN (compoundN "kryo" (k12 "biologia")) ; --UNCHK
lin cryocautery_N = mkWN (k39 "jäädytys") ; --UNCHK
lin cryogen_N = mkWN (compoundN "kylmä" (k48 "aine")) "kryogeeninen" ; --UNCHK
lin cryogenic_A = mkWA "kryogeeninen" ; --UNCHK
lin cryogenics_N = mkWN (compoundN "kryogen" (k9A "iikka")) ; --UNCHK
lin cryolite_N = mkWN (compoundN "trinatriumheksafluorialumi" (k5A "naatti")) ; --UNCHK
lin cryometer_N = mkWN (compoundN "kryo" (k5 "metri")) ; --UNCHK
lin cryonics_N = mkWN (compoundN "syvä" (k39 "jäädytys")) ; --UNCHK
lin cryophobia_N = mkWN (compoundN "kryo" (k12 "fobia")) ; --UNCHK
lin cryoscope_N = mkWN (compoundN "kryosko" (k5A "oppi")) ; --UNCHK
lin cryostat_N = mkWN "kryostaatti" ; --UNCHK
lin cryosurgery_N = mkWN (compoundN "jäädytys" (k12 "kirurgia")) ; --UNCHK
lin crypt_N = mkWN (k9 "krypta") ; --UNCHK
lin cryptanalysis_N = mkWN (compoundN "krypto" (k5 "analyysi")) ; --UNCHK
lin cryptanalyst_N = mkWN (compoundN "krypto" (k4A "analyytikko")) ; --UNCHK
lin cryptanalytic_A = mkWA (compoundA "krypto" (k38 "analyyttinen")) ; --UNCHK
lin cryptic_A = mkWA "kryptinen" ; --UNCHK
lin cryptobiosis_N = mkWN "kryptobioosi" ; --UNCHK
lin cryptobiotic_A = mkWA (compoundA "krypto" (k38 "bioottinen")) ; --UNCHK
lin cryptococcosis_N = mkWN "kryptokokkoosi" ; --UNCHK
lin cryptocoryne_N = mkWN (compoundN "mela" (k7A "lehti")) ; --UNCHK
lin cryptogam_N = mkWN (compoundN "itiö" (k5 "kasvi")) ; --UNCHK
lin cryptogamic_A = mkWA "itiökasveihin" "liittyvä" ; --UNCHK
lin cryptogram_N = mkWN (compoundN "sala" (k39 "kirjoitus")) ; --UNCHK
lin cryptograph_N = mkWN (k5A "salakirjoitustulkki") ; --UNCHK
lin cryptography_N = mkWN (k5A "ohjelmointi") ; --UNCHK
lin cryptomonad_N = mkWN "kryptofyytti" ; --UNCHK
lin cryptorchidy_N = mkWN (k40 "piilokiveksisyys") ; --UNCHK
lin crystal_N = mkWN (compoundN "kellon" (k5 "lasi")) ; --UNCHK
lin crystal_gazing_N = mkWN "krystallomantia" ; --UNCHK
lin crystalline_A = mkA "kiteinen" ;
lin crystallite_N = mkWN "kristalliitti" ; --UNCHK
lin crystallization_N = mkWN "kiteytyminen" ; --UNCHK
lin crystallize_V = mkWV (k53A "kiteyttää") ; --UNCHK
lin crystallize_V2 = mkWV2 (k53A "kiteyttää") ; --UNCHK
lin crystallographer_N = mkWN "kristallografi" ; --UNCHK
lin crystallography_N = mkWN (compoundN "kide" (k48A "tiede")) ; --UNCHK
lin ctene_N = mkWN (compoundN "kampa" (k1 "levy")) ; --UNCHK
lin ctenidium_N = mkWN (compoundN "mikrosukas" (k9A "kampa")) ; --UNCHK
lin ctenoid_A = mkWA (compoundA "kampa" (k38 "mainen")) ; --UNCHK
lin ctenophore_N = mkWN (compoundN "kampa" (k5A "maneetti")) ; --UNCHK
lin cub_N = mkWN (k38 "poikanen") ; --UNCHK
lin cuba_PN = foreignPN "Kuuba" ;
lin cuban_A = mkWA (compoundA "kuub" (k38 "alainen")) ;
lin cuban_N = mkWN (compoundN "kuub" (k38 "alainen")) ; --UNCHK
lin cubby_N = mkWN (k9A "paikka") "mukava" ; --UNCHK
lin cubbyhole_N = mkWN (k9A "paikka") "mukava" ; --UNCHK
lin cube_N = mkWN (k3 "kuutio") ; --UNCHK
lin cubeb_N = mkWN (k48A "savuke") "kubebapippuria" "sisältävä" ; --UNCHK
lin cubelike_A = mkWA (k38 "muotoinen") "kuution" ; --UNCHK
lin cubic_A = mkWA (compoundA "kolmi" (k38 "ulotteinen")) ; --UNCHK
lin cubical_A = mkWA (k38 "muotoinen") "kuution" ; --UNCHK
lin cubicity_N = mkWN (k40 "kuutiomaisuus") ; --UNCHK
lin cubicle_N = mkWN (kH1 "koppi") ; --UNCHK
lin cubism_N = mkWN (k5 "kubismi") ; --UNCHK
lin cubist_A = mkWA (k38 "kubistinen") ; --UNCHK
lin cubist_N = mkWN (k5 "kubisti") ; --UNCHK
lin cubit_N = mkWN (k10 "kyynärä") ; --UNCHK
lin cubitiere_N = mkWN (compoundN "kyynärsu" (k10 "oja")) ; --UNCHK
lin cubitus_N = mkWN (compoundN "käsi" (k28 "varsi")) ; --UNCHK
lin cuboid_N = mkWN (k3 "särmiö") "suorakulmainen" ; --UNCHK
lin cuckold_N = mkWN (compoundN "aisan" (k10 "kannattaja")) ; --UNCHK
lin cuckold_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin cuckoldom_N = mkWN "aisankannattajuus" ; --UNCHK
lin cuckoldry_N = mkWN (k38 "tekeminen") "aisankannattajaksi" ; --UNCHK
lin cuckoo_N = mkWN (k7A "käki") ; --UNCHK
lin cuckoo_clock_N = mkWN (compoundN "käki" (k1 "kello")) ; --UNCHK
lin cuckoopint_N = mkWN (compoundN "munkin" (k1A "huppu")) ; --UNCHK
lin cucumber_N = mkWN (kH1 "kurkku") ; --UNCHK
lin cucurbit_N = mkWN (k13 "kurpitsa") ; --UNCHK
lin cucurbitaceous_A = mkWA "kurkkukasveihin" "liittyvä" ; --UNCHK
lin cud_N = mkWN (kH1 "mälli") ; --UNCHK
lin cuddle_N = mkWN (k39 "halaus") ; --UNCHK
lin cuddlesome_A = mkWA "paijattava" ; --UNCHK
lin cuddly_A = mkWA "paijattava" ; --UNCHK
lin cuddy_N = mkWN (k3 "keittiö") ; --UNCHK
lin cudgel_N = mkWN (k10 "nuija") ; --UNCHK
lin cudgel_V2 = mkWV2 (k64 "lyödä") "nuijalla" ; --UNCHK
lin cudweed_N = mkWN (compoundN "hopea" (k11 "maruna")) ; --UNCHK
lin cudworth_PN = foreignPN "Cudworth" ;
lin cue_N = mkWN (k18 "köö") ; --UNCHK
lin cuff_N = mkWN (k33 "kalvosin") ; --UNCHK
lin cuff_V2 = mkWV2 (k56A "laittaa") "käsiraudat" ; --UNCHK
lin cuffley_PN = foreignPN "Cuffley" ;
lin cufflink_N = mkWN (compoundN "kalvosin" (k5A "nappi")) ; --UNCHK
lin cuirass_N = mkWN (compoundN "rinta" (k13 "haarniska")) ; --UNCHK
lin cuisine_N = mkWN (compoundN "keitto" (k1A "taito")) ; --UNCHK
lin cuisse_N = mkWN (compoundN "reisi" (k13 "haarniska")) ; --UNCHK
lin cul_N = mkWN (compoundN "umpi" (k10 "kuja")) ; --UNCHK
lin cul_de_sac_N = mkWN (compoundN "umpi" (k1A "katu")) ; --UNCHK
lin culcheth_PN = foreignPN "Culcheth" ;
lin culdoscope_N = mkWN (compoundN "kuldosko" (k5A "oppi")) ; --UNCHK
lin culdoscopy_N = mkWN "kuldoskopia" ; --UNCHK
lin culinary_A = mkWA (k38 "kulinaarinen") ; --UNCHK
lin cull_N = mkWN (k1A "hylky") ; --UNCHK
lin cull_V2 = mkWV2 (k61 "poimia") ; --UNCHK
lin cullender_N = mkWN (k4A "lävikkö") ; --UNCHK
lin cullis_N = mkWN (compoundN "katto" (k1 "kouru")) ; --UNCHK
lin culm_N = mkWN (k7A "olki") ; --UNCHK
lin culminate_V = mkWV (k53A "saavuttaa") "huippunsa" ; --UNCHK
lin culminate_V2 = mkWV2 (k53A "saavuttaa") "huippunsa" ; --UNCHK
lin culmination_N = mkWN (k1A "loppu") ; --UNCHK
lin culotte_N = mkWN (compoundN "housu" (k48 "hame")) ; --UNCHK
lin culpability_N = mkWN (k40 "syyllisyys") ; --UNCHK
lin culpable_A = mkWA (k38 "rikollinen") ; --UNCHK
lin culprit_N = mkWN (k12 "tekijä") ;
lin cult_N = mkWN (k5A "muoti") ; --UNCHK
lin cultism_N = mkWN (k40 "hartaus") ; --UNCHK
lin cultist_N = mkWN (k10 "palvoja") ; --UNCHK
lin cultivable_A = mkWA (compoundA "viljely" (k38 "kelpoinen")) ; --UNCHK
lin cultivar_N = mkWN (k48A "lajike") ; --UNCHK
lin cultivate_V2 = mkWV2 (k67 "viljellä") ; --UNCHK
lin cultivation_N = mkWN (k2 "viljely") ; --UNCHK
lin cultivator_N = mkWN (k9 "hara") ; --UNCHK
lin cultural_A = mkA "kultturelli" ;
lin culture_N = mkN "kulttuuri" ; ---- WN (k2 "viljely") ;
lin cultured_A = mkWA (k1 "hieno") ; --UNCHK
lin culverin_N = mkWN "kulevriini" ; --UNCHK
lin culvert_N = mkWN (compoundN "silta" (k1A "rumpu")) ; --UNCHK
lin cum_Prep = mkPrep "kanssa" ;
lin cumber_V2 = mkWV2 (k73A "haitata") ; --UNCHK
lin cumberland_PN = foreignPN "Cumberland" ;
lin cumbernauld_PN = foreignPN "Cumbernauld" ;
lin cumbersome_A = mkWA (k2 "tökerö") ; --UNCHK
lin cumbrous_A = mkWA (k38 "vaivalloinen") ; --UNCHK
lin cumin_N = mkWN (kH1 "kumina") ; --UNCHK
lin cummerbund_N = mkWN (compoundN "smokki" (k19 "vyö")) ; --UNCHK
lin cumnock_PN = foreignPN "Cumnock" ;
lin cumulative_A = mkWA (k38 "kumulatiivinen") ; --UNCHK
lin cumuliform_A = mkWA (k38 "muotoinen") "kumpupilven" ; --UNCHK
lin cumulonimbus_N = mkWN (compoundN "ukkos" (k7 "pilvi")) ; --UNCHK
lin cumulous_A = mkWA (k10 "oleva") "kasassa" ; --UNCHK
lin cumulus_N = mkWN (k1A "keko") ; --UNCHK
lin cuneate_A = mkWA (compoundA "kiilan" (k38 "muotoinen")) ; --UNCHK
lin cuneiform_A = mkWA "vaajaluun" ; --UNCHK
lin cuneiform_N = mkWN (compoundN "nuolenpää" (k39 "kirjoitus")) ; --UNCHK
lin cunner_N = mkWN "kuparihuulikala" ; --UNCHK
lin cunnilingus_N = mkWN "kunnilingus" ; --UNCHK
lin cunning_N = mkWN (k1A "vaihto") ; --UNCHK
lin cunt_N = mkN "vittu" ;
lin cup_N = mkWN (k5A "kuppi") ;
lin cup_V2 = mkWV2 (k58 "laskea") "verta" ; --UNCHK
lin cup_final_N = mkWN (compoundN "cup-" (k6 "finaali")) ; --UNCHK
lin cup_tie_N = mkWN (compoundN "karsinta" (k2 "ottelu")) "cupin" ; --UNCHK
lin cupar_PN = foreignPN "Cupar" ;
lin cup_bearer_N = mkWN (compoundN "juoman" (k12 "laskija")) ; --UNCHK
lin cupboard_N = mkWN (k2 "komero") ; --UNCHK
lin cupboard_love_N = mkWN (k40 "rakkaus") "omanvoitonpyyntöinen" ; --UNCHK
lin cupcake_N = mkWN (compoundN "vuoka" (k39 "leivos")) ; --UNCHK
lin cupflower_N = mkWN "Nierembergia" ; --UNCHK
lin cupful_N = mkWN (k38 "kupillinen") ; --UNCHK
lin cupid_N = mkWN (k5 "amoriini") ; --UNCHK
lin cupidity_N = mkWN (k40 "ahneus") ; --UNCHK
lin cuplike_A = mkWA (compoundA "kuppi" (k38 "mainen")) ; --UNCHK
lin cupola_N = mkWN (k6 "kupoli") ; --UNCHK
lin cuppa_N = mkWN (k38 "kupponen") ; --UNCHK
lin cupping_N = mkWN (k39 "kuppaus") ; --UNCHK
lin cupric_A = mkWA (compoundA "kuparipi" (k38 "toinen")) ; --UNCHK
lin cuprite_N = mkWN (k5A "kupriitti") ; --UNCHK
lin cupro_nickel_N = mkWN (compoundN "nikkeli" (k6 "kupari")) ; --UNCHK
lin cupule_N = mkWN (compoundN "imu" (k5A "kuppi")) ; --UNCHK
lin cur_N = mkWN (k10A "hurtta") ; --UNCHK
lin curability_N = mkWN "parannettavuus" ; --UNCHK
lin curable_A = mkWA (k10 "oleva") "parannettavissa" ; --UNCHK
lin curacao_N = mkWN (compoundN "pomeranssi" (k6 "likööri")) ; --UNCHK
lin curacoa_N = mkWN (compoundN "pomeranssi" (k6 "likööri")) ; --UNCHK
lin curacy_N = mkWN (k9A "virka") "kappalaisen" ; --UNCHK
lin curandera_N = mkWN "curandera" ; --UNCHK
lin curandero_N = mkWN (compoundN "curand" (k1 "ero")) ; --UNCHK
lin curassow_N = mkWN (compoundN "hokko" (k9 "kana")) ; --UNCHK
lin curate_N = mkWN (k6 "pastori") ; --UNCHK
lin curative_A = mkWA (k38 "terapeuttinen") ; --UNCHK
lin curator_N = mkWN (k6 "kuraattori") ; --UNCHK
lin curatorial_A = mkWA "intendentti-" ; --UNCHK
lin curatorship_N = mkWN (k9A "virka") "intendentin" ; --UNCHK
lin curb_N = mkWN (k33A "pidätin") ; --UNCHK
lin curb_V2 = mkV2 "hillitä" partitive ; --WV2 (k73A "leikata") ;
lin curbside_N = mkWN (k26 "puoli") "reunakiveyksen" ; --UNCHK
lin curbstone_N = mkWN (compoundN "reuna" (k7 "kivi")) ; --UNCHK
lin curdle_V = mkWV (k52A "hyytyä") ; --UNCHK
lin curdle_V2 = mkWV2 (k52A "hyytyä") ; --UNCHK
lin curdling_N = mkWN (k3 "koagulaatio") ; --UNCHK
lin cure_N = mkN "hoito" ;
lin cure_V = mkWV (k53A "hoitaa") ; --UNCHK
lin cure_V2 = mkV2 "parantaa" ; --mkWV2 (k53A "hoitaa") ;
lin curettage_N = mkWN (k9A "kaavinta") ; --UNCHK
lin curette_N = mkWN (k33A "kaavin") ; --UNCHK
lin curfew_N = mkWN (compoundN "ulkonaliikkumis" (k1A "kielto")) ; --UNCHK
lin curie_N = mkWN "Marya" "Sklodowska" ; --UNCHK
lin curio_N = mkWN (k40 "erikoisuus") ; --UNCHK
lin curiosity_N = mkWN (k40 "erikoisuus") ; --UNCHK
lin curious_A = mkWA (compoundA "tiedon" (k38 "haluinen")) ; --UNCHK
lin curiousness_N = mkWN (k40 "outous") ; --UNCHK
lin curitiba_PN = foreignPN "Curitiba" ;
lin curium_N = mkWN "järjestysluku" "96" ; --UNCHK
lin curl_N = mkWN (k12 "kiehkura") ; --UNCHK
lin curl_V = mkWV (k52A "kiertyä") ; --UNCHK
lin curl_up_V = mkWV (k52 "käpristyä") ; --UNCHK
lin curler_N = mkWN (k5A "papiljotti") ; --UNCHK
lin curlew_N = mkWN (k5 "kuovi") ; --UNCHK
lin curliness_N = mkWN (compoundN "kiha" (k40 "raisuus")) ; --UNCHK
lin curling_N = mkWN "curling" ; --UNCHK
lin curly_A = mkWA (k11 "kihara") ; --UNCHK
lin curmudgeon_N = mkWN (compoundN "äkä" (k5 "pussi")) ; --UNCHK
lin currant_N = mkWN (compoundN "viini" (k9 "marja")) ; --UNCHK
lin currawong_N = mkWN (k5A "huilukorppi") ; --UNCHK
lin currency_N = mkN "valuutta" ;
lin current_A = mkA "nykyinen" ;
lin current_1_N = mkWN (k9A "virta") ; --UNCHK
lin current_2_N = mkWN (k9A "virta") ; --UNCHK
lin currentness_N = mkWN (k40 "ajanmukaisuus") ; --UNCHK
lin curricular_A = mkWA "oppikurssin" ; --UNCHK
lin curriculum_N = mkWN (compoundN "opetus" (k10 "suunnitelma")) ; --UNCHK
lin curriculum_vitae_N = mkWN (compoundN "ansio" (k2 "luettelo")) ; --UNCHK
lin currie_PN = foreignPN "Currie" ;
lin currier_N = mkWN (k6 "nahkuri") ; --UNCHK
lin currish_A = mkWA (compoundA "rakkikoira" (k38 "mainen")) ; --UNCHK
lin curry_N = mkWN (k1 "curry") ; --UNCHK
lin curry_V2 = mkWV2 (k61 "siistiä") ; --UNCHK
lin curry_powder_N = mkWN (k1 "curry") ; --UNCHK
lin currycomb_N = mkWN (k10A "suka") ; --UNCHK
lin curse_N = mkWN (k2 "sadattelu") ; --UNCHK
lin curse_V = mkWV (k74 "kirota") ; --UNCHK
lin curse_V2 = mkWV2 (k74 "kirota") ; --UNCHK
lin cursive_A = mkWA (compoundA "kirjo" (k1 "itettu")) "käsin" ; --UNCHK
lin cursor_N = mkWN (k33A "osoitin") ; --UNCHK
lin cursorial_A = mkWA "juoksu-" ; --UNCHK
lin cursory_A = mkWA (k38 "kursorinen") ; --UNCHK
lin curst_A = mkWA (k1A "kirottu") ; --UNCHK
lin curt_A = mkWA (k15 "selkeä") ; --UNCHK
lin curtail_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin curtailment_N = mkWN (compoundN "säästö" (k25 "toimi")) ; --UNCHK
lin curtain_N = mkN "esirippu" ;
lin curtain_V2 = mkWV2 (k74 "verhota") ; --UNCHK
lin curtain_call_N = mkWN (compoundN "esiin" (k1A "huuto")) ; --UNCHK
lin curtain_lecture_N = mkWN (compoundN "koti" (k39 "ripitys")) ; --UNCHK
lin curtain_raiser_N = mkWN (compoundN "esi" (k2 "valmistelu")) ; --UNCHK
lin curtainless_A = mkWA "verhoton" ; --UNCHK
lin curtal_A = mkWA "typistetty" ; --UNCHK
lin curtness_N = mkWN (k40 "karkeus") ; --UNCHK
lin curtsey_N = mkWN (k39 "niiaus") ; --UNCHK
lin curtsey_V = mkWV (k73 "niiata") ; --UNCHK
lin curtsy_N = mkWN (k39 "niiaus") ; --UNCHK
lin curtsy_V = mkWV (k73 "niiata") ; --UNCHK
lin curvaceously_Adv = mkWAdv (k99 "rehevästi") ; --UNCHK
lin curvaceousness_N = mkWN (k40 "uhkeus") ; --UNCHK
lin curvature_N = mkWN (k40 "käyryys") ; --UNCHK
lin curve_N = mkN "käyrä" ; ---ARB --mkWN (k48A "kierre") ;
lin curve_V = mkWV (k52A "kiertyä") ; --UNCHK
lin curve_V2 = mkWV2 (k52A "kiertyä") ; --UNCHK
lin curvet_N = mkWN (k1A "hyppy") ; --UNCHK
lin curvilineal_A = mkWA (k10 "kaareva") ; --UNCHK
lin curvy_A = mkWA (k38 "täyteläinen") ; --UNCHK
lin cuscus_N = mkWN (k5 "kuskus") ; --UNCHK
lin cushaw_N = mkWN (compoundN "myski" (k13 "kurpitsa")) ; --UNCHK
lin cushion_N = mkWN (k1 "tyyny") ;
lin cushion_V2 = mkV2 "pehmentää" partitive ;
lin cushy_A = mkWA (k10 "mukava") ; --UNCHK
lin cusk_N = mkWN (kH1 "matikka") ; --UNCHK
lin cusp_N = mkWN (k7A "kärki") ; --UNCHK
lin cuspate_A = mkWA (compoundA "terä" (k38 "väkärkinen")) ; --UNCHK
lin cuspidation_N = mkWN (compoundN "teräväkärk" (k40 "isyys")) ; --UNCHK
lin cuspidor_N = mkWN (compoundN "sylky" (k5A "kuppi")) ; --UNCHK
lin cuss_N = mkWN (k2 "sadattelu") ; --UNCHK
lin cussed_A = mkWA (k47 "paatunut") ; --UNCHK
lin cussedness_N = mkWN (k40 "häijyys") ; --UNCHK
lin custard_N = mkWN (compoundN "maito" (k6 "kiisseli")) ; --UNCHK
lin custodial_A = mkWA "holhous-" ; --UNCHK
lin custodian_N = mkWN (k6 "pehtori") ; --UNCHK
lin custodianship_N = mkWN (k9A "virka") "vartijan" ; --UNCHK
lin custody_N = mkWN "huoltajuus" ; --UNCHK
lin custom_N = mkWN (k1A "käytäntö") ; --UNCHK
lin customary_A = mkWA (k38 "totunnainen") ;
lin customerFem_N = variants {} ; ---- sense to be split
lin customerMasc_N = mkN "asiakas" ;
lin customhouse_N = mkWN (k5 "tulli") ; --UNCHK
lin customize_V2 = mkV2 "räätälöidä" ;
lin customs_N = mkWN (k5 "tulli") ; --UNCHK
lin cut_N = mkN "leikkaus" ;
lin cut_V = mkV "leikata" ;
lin cut_V2 = L.cut_V2 ;
lin cut_across_V2 = mkWV2 (k73A "leikata") "poikki" ; --UNCHK
lin cut_back_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin cut_back_on_V2 = prepV2 (advV OP_cut_V OP_back_Adv ) OP_on_Prep ; -- guess-p-verb
lin cut_down_V = mkWV (k53A "vetää") "maahan" ; --UNCHK
lin cut_down_V2 = mkWV2 (k53A "vetää") "maahan" ; --UNCHK
lin cut_down_on_V2 = prepV2 (advV OP_cut_V OP_down_Adv ) OP_on_Prep ; -- guess-p-verb
lin cut_in_V = mkWV (k73 "lisätä") ; --UNCHK
lin cut_in_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin cut_in_on_V2 = prepV2 (advV OP_cut_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin cut_it_out_V2 = variants {} ; -- guess-p-verb
lin cut_off_V = mkWV (k53A "lopettaa") ; --UNCHK
lin cut_off_V2 = mkWV2 (k53A "lopettaa") ; --UNCHK
lin cut_out_V = mkWV (k52 "sammua") ; --UNCHK
lin cut_out_V2 = mkWV2 (k52 "sammua") ; --UNCHK
lin cut_out_on_V2 = prepV2 (advV OP_cut_V OP_out_Adv ) OP_on_Prep ; -- guess-p-verb
lin cut_up_V = mkWV (k73A "muokata") "pilkkomalla" ; --UNCHK
lin cut_up_V2 = mkWV2 (k73A "muokata") "pilkkomalla" ; --UNCHK
lin cutaneous_A = mkWA (compoundA "kuta" (k38 "aninen")) ; --UNCHK
lin cutaway_N = mkWN (k5A "saketti") ; --UNCHK
lin cutback_N = mkWN (k39 "supistus") ; --UNCHK
lin cutch_N = mkWN "kateku" ; --UNCHK
lin cute_A = mkA "suloinen" ;
lin cuteness_N = mkWN (k40 "sievyys") ; --UNCHK
lin cuticula_N = mkWN (k26 "kitiinikuori") ; --UNCHK
lin cuticular_A = mkWA "orvaskesi-" ; --UNCHK
lin cutin_N = mkWN "kutiini" ; --UNCHK
lin cutlassfish_N = mkWN (compoundN "huotra" (k9 "kala")) ; --UNCHK
lin cutler_N = mkWN (compoundN "aterin" (k41 "kauppias")) ; --UNCHK
lin cutlet_N = mkWN (k48A "leike") ; --UNCHK
lin cutoff_N = mkWN (k10A "sulkuläppä") ; --UNCHK
lin cut_out_N = mkWN (k48A "leike") ; --UNCHK
lin cutpurse_N = mkWN (compoundN "tasku" (k41A "varas")) ; --UNCHK
lin cutter_N = mkWN (compoundN "leikkuu" (k48 "väline")) ; --UNCHK
lin cut_throat_A = mkWA (kH1 "raaka") ; --UNCHK
lin cut_throat_N = mkWN (k10 "murhaaja") ; --UNCHK
lin cutting_N = mkWN (k17 "leikkuu") ; --UNCHK
lin cutting_room_N = mkWN (k2 "leikkaamo") ; --UNCHK
lin cuttingly_Adv = mkWAdv "pistävästi" ; --UNCHK
lin cuttlefish_N = mkWN (k12 "seepia") ; --UNCHK
lin cutwork_N = mkWN (k2 "ompelu") "venetsialainen" ; --UNCHK
lin cutworm_N = mkWN (k10A "toukka") "yökkösen" ; --UNCHK
lin cwmbran_PN = foreignPN "Cwmbran" ;
lin cyan_N = mkWN (k5 "syaani") ; --UNCHK
lin cyanamide_N = mkWN (k5 "syanamidi") ; --UNCHK
lin cyanide_N = mkWN (k5 "syanidi") ; --UNCHK
lin cyanobacterial_A = mkWA "syanobakteeri-" ; --UNCHK
lin cyanogen_N = mkWN (k5 "syaani") ; --UNCHK
lin cyanogenetic_A = mkWA (k10 "tuottava") "syaania" ; --UNCHK
lin cyanohydrin_N = mkWN "syanohydriini" ; --UNCHK
lin cyanosis_N = mkWN (k39 "sinerrys") ; --UNCHK
lin cyberart_N = mkWN (k48A "taide") "sähköinen" ; --UNCHK
lin cybercrime_N = mkWN (compoundN "tietoverkko" (k40 "rikollisuus")) ; --UNCHK
lin cyberculture_N = mkWN (k6 "kulttuuri") "sähköinen" ; --UNCHK
lin cybernaut_N = mkWN (k10 "käyttäjä") "tietokoneen" ; --UNCHK
lin cybernetic_A = mkWA (k38 "kyberneettinen") ; --UNCHK
lin cybernetics_N = mkWN (k9A "kybernetiikka") ; --UNCHK
lin cyberphobia_N = mkWN (compoundN "tietokone" (k1 "kammo")) ; --UNCHK
lin cyberpunk_N = mkWN (compoundN "kyber" (k5 "punk")) ; --UNCHK
lin cybersex_N = mkWN (compoundN "verkko" (k5 "seksi")) ; --UNCHK
lin cyborg_N = mkWN (k5 "kyborgi") ; --UNCHK
lin cycad_N = mkWN (compoundN "käpy" (k1 "palmu")) ; --UNCHK
lin cyclamen_N = mkWN (k6 "syklaami") ; --UNCHK
lin cycle_N = mkN "sykli" ;
lin cycle_V = mkWV (k52 "toistua") ; --UNCHK
lin cyclic_A = mkWA (k38 "jaksoittainen") ; --UNCHK
lin cyclical_A = mkWA (k38 "jaksoittainen") ; --UNCHK
lin cyclicity_N = mkWN (k40 "jaksoittaisuus") ; --UNCHK
lin cycling_N = mkWN (k2 "pyöräily") ; --UNCHK
lin cyclist_N = mkWN (k12 "pyöräilijä") ; --UNCHK
lin cyclobenzaprine_N = mkWN "Flexeril" ; --UNCHK
lin cyclohexanol_N = mkWN "sykloheksanoli" ; --UNCHK
lin cycloid_A = mkWA "sykloidinen" ; --UNCHK
lin cycloid_N = mkWN "sykloidi" ; --UNCHK
lin cyclone_N = mkWN (k5 "sykloni") ; --UNCHK
lin cyclonic_A = mkWA (compoundA "sykloni" (k38 "nen")) ; --UNCHK
lin cyclooxygenase_N = mkWN (compoundN "syklo-oksygen" (k5 "aasi")) ; --UNCHK
lin cyclopaedia_N = mkWN (k12 "ensyklopedia") ; --UNCHK
lin cyclopean_A = mkWA (compoundA "kyklooppi" (k38 "nen")) ; --UNCHK
lin cyclopia_N = mkWN (compoundN "yksisilmäepä" (k10 "muodostuma")) ; --UNCHK
lin cyclopropane_N = mkWN (compoundN "syklo" (k5 "propaani")) ; --UNCHK
lin cycloserine_N = mkWN "sykloseriini" ; --UNCHK
lin cyclosis_N = mkWN (compoundN "sol" (k10 "ussa")) "soluliman" "kierto" ; --UNCHK
lin cyclostome_N = mkWN (compoundN "ympyrä" (k38 "suinen")) ; --UNCHK
lin cyclostyle_N = mkWN (compoundN "kirjoitus" (k9A "laita")) "vahapaperille" ; --UNCHK
lin cyclothymia_N = mkWN (compoundN "persoonallisuus" (k3 "häiriö")) "affektiivinen" ; --UNCHK
lin cyclothymic_A = mkWA (compoundA "aalto" (k38 "iluhäiriöllinen")) "mielialan" ; --UNCHK
lin cyclotron_N = mkWN "syklotroni" ; --UNCHK
lin cyder_N = mkWN (k6 "siideri") ; --UNCHK
lin cygnet_N = mkWN (k32 "joutsen") ; --UNCHK
lin cylinder_N = mkWN (k1 "pullo") ; --UNCHK
lin cylindrical_A = mkWA (k38 "muotoinen") "lieriön" ; --UNCHK
lin cylindricality_N = mkWN (compoundN "sylinterimä" (k40 "isyys")) ; --UNCHK
lin cyma_N = mkWN "kyma" ; --UNCHK
lin cymbal_N = mkWN (k38 "lautanen") ; --UNCHK
lin cymbalist_N = mkWN (k10 "soittaja") "symbaalin" ; --UNCHK
lin cymbid_N = mkWN "Cymbidium" ; --UNCHK
lin cyme_N = mkWN (k1 "viuhko") ; --UNCHK
lin cymene_N = mkWN "symeeni" ; --UNCHK
lin cymose_A = mkWA (compoundA "viuhko" (k38 "mainen")) ; --UNCHK
lin cymule_N = mkWN (k1 "viuhko") "pieni" ; --UNCHK
lin cynancum_N = mkWN "Cynanchum" ; --UNCHK
lin cynic_N = mkWN (k4A "kyynikko") ; --UNCHK
lin cynical_A = mkWA (k38 "kyyninen") ; --UNCHK
lin cynicism_N = mkWN (k40 "kyynisyys") ; --UNCHK
lin cynodont_N = mkWN "kynodontti" ; --UNCHK
lin cynophobia_N = mkWN (compoundN "koira" (k1 "kammo")) ; --UNCHK
lin cynosure_N = mkWN (k48A "kohde") "huomion" ; --UNCHK
lin cypher_N = mkWN (compoundN "salakirjoitus" (k5 "viesti")) ; --UNCHK
lin cypher_V = mkWV (k58 "laskea") ; --UNCHK
lin cypher_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin cypress_N = mkWN (k6 "sypressi") ; --UNCHK
lin cyprian_A = mkWA (compoundA "kypros" (k38 "lainen")) ; --UNCHK
lin cyprinid_A = mkWA "särkikala-" ; --UNCHK
lin cyprinid_N = mkWN (compoundN "särki" (k9 "kala")) ; --UNCHK
lin cyprinodont_N = mkWN "hammaskilli" ; --UNCHK
lin cypriot_A = mkWA (compoundA "kypros" (k38 "lainen")) ; --UNCHK
lin cypripedia_N = mkWN (k5A "tikankontti") ; --UNCHK
lin cyproheptadine_N = mkWN "Periactin" ; --UNCHK
lin cyprus_PN = foreignPN "Kypros" ;
lin cyril_PN = foreignPN "Cyril" ;
lin cyrilla_N = mkWN (compoundN "racemifl" (k10 "ora")) "Cyrilla" ; --UNCHK
lin cyrillic_A = mkWA (k38 "kyrillinen") ; --UNCHK
lin cyst_N = mkWN (k12 "rakkula") ; --UNCHK
lin cysteine_N = mkWN (compoundN "kys" (k5 "teiini")) ; --UNCHK
lin cystic_A = mkWA "kystinen" ; --UNCHK
lin cystine_N = mkWN "systiini" ; --UNCHK
lin cystitis_N = mkWN (compoundN "virtsarakon" (k39 "tulehdus")) ; --UNCHK
lin cystocele_N = mkWN (compoundN "kystose" (k48 "ele")) ; --UNCHK
lin cystoplegia_N = mkWN (k39 "halvaus") "virtsarakon" ; --UNCHK
lin cytoarchitecture_N = mkWN (k48A "rakenne") "solujen" "muodostama" ; --UNCHK
lin cytochrome_N = mkWN (compoundN "syto" (k5 "kromi")) ; --UNCHK
lin cytogenesis_N = mkWN "sytogeneesi" ; --UNCHK
lin cytogenetic_A = mkWA (compoundA "syto" (k38 "geneettinen")) ; --UNCHK
lin cytogeneticist_N = mkWN (k12 "tuntija") "sytogenetiikan" ; --UNCHK
lin cytogenetics_N = mkWN (compoundN "sytogen" (k14A "etiikka")) ; --UNCHK
lin cytokine_N = mkWN "sytokiini" ; --UNCHK
lin cytokinesis_N = mkWN (k38 "solunjakautuminen") ; --UNCHK
lin cytokinetic_A = mkWA (compoundA "syto" (k38 "kineettinen")) ; --UNCHK
lin cytological_A = mkWA (compoundA "solu" (k38 "opillinen")) ; --UNCHK
lin cytologist_N = mkWN "sytologi" ; --UNCHK
lin cytology_N = mkWN (k12 "sytologia") ; --UNCHK
lin cytolysin_N = mkWN "sytolysiini" ; --UNCHK
lin cytolysis_N = mkWN (compoundN "sytoly" (k5 "ysi")) ; --UNCHK
lin cytolytic_A = mkWA "sytolyyttinen" ; --UNCHK
lin cytomegalic_A = mkWA "sytomegalia-" ; --UNCHK
lin cytomegalovirus_N = mkWN (compoundN "sytomegalo" (k39 "virus")) ; --UNCHK
lin cytopathogenic_A = mkWA (compoundA "syto" (k38 "patogeeninen")) ; --UNCHK
lin cytopenia_N = mkWN (k40 "niukkuus") "veren" "solujen" ; --UNCHK
lin cytophotometer_N = mkWN (compoundN "sytofoto" (k5 "metri")) ; --UNCHK
lin cytophotometric_A = mkWA (compoundA "sytofoto" (k38 "metrinen")) ; --UNCHK
lin cytophotometry_N = mkWN "sytofotometria" ; --UNCHK
lin cytoplasm_N = mkWN (compoundN "solu" (k9 "lima")) ; --UNCHK
lin cytoplasmic_A = mkWA "soluplasman" ; --UNCHK
lin cytoplast_N = mkWN (compoundN "solu" (k9 "lima")) ; --UNCHK
lin cytoplastic_A = mkWA (compoundA "syto" (k38 "plastinen")) ; --UNCHK
lin cytosine_N = mkWN "C" ; --UNCHK
lin cytoskeleton_N = mkWN (compoundN "tuki" (k9A "ranka")) "solun" ; --UNCHK
lin cytosol_N = mkWN "sytosoli" ; --UNCHK
lin cytostome_N = mkWN (k18 "suu") "alkueläimen" ; --UNCHK
lin cytotoxic_A = mkWA (k38 "sytotoksinen") ; --UNCHK
lin cytotoxicity_N = mkWN "sytotoksisuus" ; --UNCHK
lin cytotoxin_N = mkWN (compoundN "solu" (k1A "myrkky")) ; --UNCHK
lin czar_N = mkWN (compoundN "yksin" (k41 "valtias")) ; --UNCHK
lin czarina_N = mkWN (k32A "tsaaritar") ; --UNCHK
lin czarist_A = mkWA (k38 "tsaristinen") ; --UNCHK
lin czech_A = mkWA (k38 "tšekkiläinen") ; --UNCHK
lin czech_N = mkWN (k5A "tšekki") ; --UNCHK
lin czechoslovak_N = mkWN (k38 "tšekkiläinen") ; --UNCHK
lin czechoslovakian_A = mkWA (k38 "tšekkiläinen") ; --UNCHK
lin czechoslovakian_N = mkWN (k38 "tšekkiläinen") ; --UNCHK
lin dab_V = mkWV (k53A "taputtaa") ; --UNCHK
lin dab_V2 = mkWV2 (k53A "taputtaa") ; --UNCHK
lin dabble_V = mkWV (k54A "sukeltaa") ; --UNCHK
lin dabble_V2 = mkWV2 (k54A "sukeltaa") ; --UNCHK
lin dabbler_N = mkWN (compoundN "puolisukeltaja" (k10 "sorsa")) ; --UNCHK
lin dabchick_N = mkWN (compoundN "pikku-" (k1A "uikku")) ; --UNCHK
lin dace_N = mkWN (k5 "seipi") ; --UNCHK
lin dacha_N = mkWN (k9 "datša") ; --UNCHK
lin dachshund_N = mkWN (compoundN "mäyrä" (k10 "koira")) ; --UNCHK
lin dacite_N = mkWN "dasiitti" ; --UNCHK
lin dacitic_A = mkWA "dasiitti-" ; --UNCHK
lin dacoit_N = mkWN (k1 "rosvo") ; --UNCHK
lin dacoity_N = mkWN (k2 "rosvoilu") ; --UNCHK
lin dacryocystitis_N = mkWN (compoundN "kyynelpussi" (k39 "tulehdus")) ; --UNCHK
lin dacryon_N = mkWN (compoundN "kallonmittaus" (k48 "piste")) ; --UNCHK
lin dactyl_N = mkWN (k41A "varvas") ; --UNCHK
lin dactylic_A = mkWA (compoundA "dak" (k38 "tyylinen")) ; --UNCHK
lin dactylomegaly_N = mkWN "makrodaktylia" ; --UNCHK
lin dad_N = mkWN (k9A "pappa") ; --UNCHK
lin dada_N = mkWN (k5 "dadaismi") ; --UNCHK
lin daddy_N = mkWN (k9A "pappa") ; --UNCHK
lin daddy_longlegs_N = mkWN (k5A "lukki") ; --UNCHK
lin daedal_A = mkWA (k41A "nerokas") ; --UNCHK
lin daemon_N = mkWN (k5 "demoni") ; --UNCHK
lin daffodil_N = mkWN (k5 "narsissi") ; --UNCHK
lin daft_A = mkWA (k1 "pöllö") ; --UNCHK
lin dagame_N = mkWN "Calycophyllum" "candidissimum" ; --UNCHK
lin dagga_N = mkWN (compoundN "leijonan" (k10 "korva")) ; --UNCHK
lin dagger_N = mkWN (k1A "puukko") ; --UNCHK
lin daggerboard_N = mkWN (compoundN "nosto" (k5 "köli")) ; --UNCHK
lin dago_N = mkWN (k39 "ilmaus") "halventava" ; --UNCHK
lin daguerreotype_N = mkWN "dagerrotypia" ; --UNCHK
lin dail_eireann_N = mkWN "Dail" ; --UNCHK
lin daily_A = mkA "päivittäinen" ;
lin daily_Adv = mkWAdv (k99 "päivittäin") ; --UNCHK
lin daily_N = mkWN (compoundN "päivä" (k7A "lehti")) ;
lin daintiness_N = mkWN (k40 "hienostuneisuus") ; --UNCHK
lin dainty_A = mkWA (k10 "ihastuttava") ; --UNCHK
lin dainty_N = mkWN (k5 "nami") ; --UNCHK
lin daiquiri_N = mkWN (compoundN "rommi" (k5 "cocktail")) ; --UNCHK
lin dairy_N = mkWN (k6 "meijeri") ;
lin dairy_farm_N = mkWN (k6 "meijeri") ; --UNCHK
lin dairy_farming_N = mkWN "maitotilan" "pitäminen" ; --UNCHK
lin dairying_N = mkWN "maitotilan" "pitäminen" ; --UNCHK
lin dairymaid_N = mkWN (k4A "karjakko") ; --UNCHK
lin dairyman_N = mkWN (k4A "karjakko") ; --UNCHK
lin dais_N = mkWN (k48A "koroke") ; --UNCHK
lin daisy_N = mkWN (k38 "kaunokainen") ; --UNCHK
lin daisybush_N = mkWN "Olearia" ; --UNCHK
lin daisylike_A = mkWA (k38 "kaltainen") "kaunokaisen" ; --UNCHK
lin dakar_PN = foreignPN "Dakar" ;
lin dalasi_N = mkWN "dalasi" ; --UNCHK
lin dale_N = mkWN (k1 "laakso") ; --UNCHK
lin dalesman_N = mkWN (compoundN "laakso" (k38 "lainen")) ; --UNCHK
lin dalkeith_PN = foreignPN "Dalkeith" ;
lin dallas_PN = foreignPN "Dallas" ;
lin dalliance_N = mkWN (k2 "flirttailu") ; --UNCHK
lin dallier_N = mkWN (k12 "kuhnailija") ; --UNCHK
lin dallisgrass_N = mkWN (compoundN "helmi" (k5 "hirssi")) ; --UNCHK
lin dally_V = mkWV (k61A "leikkiä") ; --UNCHK
lin dalmatian_N = mkWN (compoundN "dalmatian" (k10 "koira")) ; --UNCHK
lin dalry_PN = foreignPN "Dalry" ;
lin dalton_PN = foreignPN "Dalton" ;
lin dam_N = mkN "pato" ;
lin dam_V2 = mkWV2 (k74A "padota") ; --UNCHK
lin damage_N = mkN "vahinko" ;
lin damage_V2 = mkV2 (lin VK {s = c53A "vahingoittaa"}) ;
lin damages_N = mkWN (k39 "korvaus") ; --UNCHK
lin damaging_A = mkWA (k38 "kielteinen") ; --UNCHK
lin damascene_N = mkWN (k48 "esine") "damaskoitu" ; --UNCHK
lin damascene_V2 = mkWV2 "damaskoida" ; --UNCHK
lin damascus_PN = foreignPN "Damaskos" ;
lin damask_A = mkWA "damasti-" ; --UNCHK
lin damask_N = mkWN (k5 "damasti") ; --UNCHK
lin dame_N = mkWN (k9 "kissa") ; --UNCHK
lin dammar_N = mkWN (compoundN "dammar" (k5 "hartsi")) ; --UNCHK
lin damn_A = mkWA (k38 "pirunmoinen") ; --UNCHK
lin damn_Adv = mkWAdv (compoundAdv "pahuk" (k99 "sen")) ; --UNCHK
lin damn_Interj = mkInterj "hitto" ;
lin damn_V2 = mkWV2 (k74 "kirota") ; --UNCHK
lin damnable_A = mkWA (k10 "katala") ; --UNCHK
lin damnation_N = mkWN (compoundN "kiro" (k38 "aminen")) ; --UNCHK
lin damnatory_A = mkWA "hylkäävä" ; --UNCHK
lin damned_Adv = mkWAdv "kirotun" ; --UNCHK
lin damourite_N = mkWN (compoundN "damou" (k5A "riitti")) ; --UNCHK
lin damp_A = mkWA (k15 "kostea") ; --UNCHK
lin damp_N = mkWN (k40 "kosteus") ; --UNCHK
lin damp_V = mkWV (k53A "pehmittää") ; --UNCHK
lin damp_V2 = mkWV2 (k53A "pehmittää") ; --UNCHK
lin dampen_V = mkWV (k53A "kostuttaa") ; --UNCHK
lin dampen_V2 = mkWV2 (k53A "kostuttaa") ; --UNCHK
lin dampener_N = mkWN (k33A "kostutin") ; --UNCHK
lin damper_N = mkWN (k1 "suihku") "kylmä" ; --UNCHK
lin dampish_A = mkWA (k15 "kostea") ; --UNCHK
lin dampness_N = mkWN (k40 "kosteus") ; --UNCHK
lin damsel_N = mkWN (k5A "neiti") ; --UNCHK
lin damselfish_N = mkWN "demoiselle" ; --UNCHK
lin damselfly_N = mkWN "hentosudenkorento" ; --UNCHK
lin damson_N = mkWN (k1 "luumu") ; --UNCHK
lin danaid_N = mkWN "Danainae" ; --UNCHK
lin dance_N = mkWN (k5 "tanssi") ; --UNCHK
lin dance_V = mkWV (k73 "jorata") ; --UNCHK
lin dance_V2 = mkWV2 (k73 "jorata") ; --UNCHK
lin dance_band_N = mkWN (k1A "pumppu") ; --UNCHK
lin dance_hall_N = mkWN (compoundN "tanssi" (k9 "lava")) ; --UNCHK
lin dance_orchestra_N = mkWN (k1A "pumppu") ; --UNCHK
lin danceable_A = mkWA "tanssittava" ; --UNCHK
lin dancer_N = mkWN (k12 "tanssija") ; --UNCHK
lin dancing_N = mkWN (k5 "tanssi") ; --UNCHK
lin dandelion_N = mkWN (compoundN "voi" (k10A "kukka")) ; --UNCHK
lin dander_N = mkWN (k39 "ärtymys") ; --UNCHK
lin dandified_A = mkWA (compoundA "keikari" (k38 "mainen")) ; --UNCHK
lin dandle_V2 = mkWV2 (k67 "hyväillä") ; --UNCHK
lin dandruff_N = mkWN (k48 "hilse") ; --UNCHK
lin dandy_A = mkWA (k3 "mainio") ; --UNCHK
lin dandy_N = mkWN (k5 "jooli") ; --UNCHK
lin dane_N = mkWN (k38 "tanskalainen") ; --UNCHK
lin danger_N = mkWN (kH1 "vaara") ;
lin dangerous_A = mkA (lin AK {s = d38 "vaarallinen"}) ;
lin dangerousness_N = mkWN (k40 "vaarallisuus") ; --UNCHK
lin dangle_V = mkWV (k53 "ripustaa") ; --UNCHK
lin dangle_V2 = mkWV2 (k53 "ripustaa") ; --UNCHK
lin dangleberry_N = mkWN (compoundN "frond" (k10 "osa")) "Gaylussacia" ; --UNCHK
lin daniel_N = mkWN (k9 "kirja") "profeetta" "Danielin" ; --UNCHK
lin danishFem_N = mkN "tanskalainen" ;
lin danishMasc_N = mkN "tanskalainen" ;
lin danish_A = mkA "tanskalainen" ;
lin dank_A = mkWA (k15 "kostea") ; --UNCHK
lin dankness_N = mkWN (k40 "nihkeys") ; --UNCHK
lin danse_macabre_N = mkWN (compoundN "kuoleman" (k5 "tanssi")) ; --UNCHK
lin danseur_N = mkWN (compoundN "baletti" (k12 "tanssija")) ; --UNCHK
lin daphne_N = mkWN "Dafne" ; --UNCHK
lin daphne_PN = foreignPN "Daphne" ;
lin daphnia_N = mkWN (compoundN "vesi" (k1A "kirppu")) ; --UNCHK
lin dapper_A = mkWA (k15 "upea") ; --UNCHK
lin dapple_V2 = mkWV2 (k53 "varjostaa") ; --UNCHK
lin dapsone_N = mkWN "dapsoni" ; --UNCHK
lin daraf_N = mkWN "daraf" ; --UNCHK
lin darby_PN = foreignPN "Darby" ;
lin dare_N = mkWN (k48 "haaste") ; --UNCHK
lin dare_V2 = mkWV2 (k56 "haastaa") ; --UNCHK
lin dare_VV = mkWVV (k56 "haastaa") ; --UNCHK
lin daredevil_A = mkWA (k1A "uskalikko") ; --UNCHK
lin daredevil_N = mkWN (k1A "uskalikko") ; --UNCHK
lin daredevilry_N = mkWN (k40 "uskaliaisuus") ; --UNCHK
lin darfield_PN = foreignPN "Darfield" ;
lin daring_N = mkWN (k39 "uskallus") ; --UNCHK
lin daringly_Adv = mkWAdv (k99 "huimapäisesti") ; --UNCHK
lin dark_A = mkA "pimeä" | mkA "tumma" ; ---- split
lin dark_N = mkWN (k40 "tietämättömyys") ; --UNCHK
lin darken_V = mkWV (k54A "tummentaa") ; --UNCHK
lin darken_V2 = mkWV2 (k54A "tummentaa") ; --UNCHK
lin darkey_N = mkWN (k6 "neekeri") ; --UNCHK
lin darkie_N = mkWN (k6 "neekeri") ; --UNCHK
lin darkish_A = mkWA "tummahko" ; --UNCHK
lin darkling_A = mkWA (k10 "pimeässä") ; --UNCHK
lin darkness_N = mkWN "tummaihoisuus" ; --UNCHK
lin darkroom_N = mkWN (k3 "pimiö") ; --UNCHK
lin darky_N = mkWN (k6 "neekeri") ; --UNCHK
lin darling_N = mkWN (compoundN "Darling-" (k7A "joki")) ; --UNCHK
lin darlington_PN = foreignPN "Darlington" ;
lin darmstadt_PN = foreignPN "Darmstadt" ;
lin darmstadtium_N = mkWN "järjestysluku" "110" ; --UNCHK
lin darn_N = mkWN (kH1 "kohta") "parsittu" ; --UNCHK
lin darn_V = mkWV (k61 "parsia") ; --UNCHK
lin darn_V2 = mkWV2 (k61 "parsia") ; --UNCHK
lin darnel_N = mkWN "myrkkyraiheinä" ; --UNCHK
lin darner_N = mkWN (compoundN "par" (k9 "sija")) ; --UNCHK
lin darning_N = mkWN (compoundN "par" (k38 "siminen")) ; --UNCHK
lin darning_needle_N = mkWN (compoundN "pirun" (k6 "puntari")) ; --UNCHK
lin dart_N = mkWN (k39 "syöksähdys") ; --UNCHK
lin dart_V = mkWV (k52A "sinkoutua") ; --UNCHK
lin dart_V2 = mkWV2 (k52A "sinkoutua") ; --UNCHK
lin dartboard_N = mkWN (compoundN "tikka" (k1 "taulu")) ; --UNCHK
lin darter_N = mkWN "syöksähtelijä" ; --UNCHK
lin dartford_PN = foreignPN "Dartford" ;
lin dartmouth_PN = foreignPN "Dartmouth" ;
lin darts_N = mkWN (compoundN "tikka" (k5 "peli")) ; --UNCHK
lin darwen_PN = foreignPN "Darwen" ;
lin dash_N = mkWN (k5A "spurtti") ; --UNCHK
lin dash_V = mkWV (k53A "pirskauttaa") ; --UNCHK
lin dash_down_V2 = mkWV2 (k53 "raapustaa") ; --UNCHK
lin dash_off_V = mkWV (k53 "raapustaa") ; --UNCHK
lin dash_off_V2 = mkWV2 (k53 "raapustaa") ; --UNCHK
lin dashboard_N = mkWN (compoundN "koje" (k9A "lauta")) ; --UNCHK
lin dashiki_N = mkWN (compoundN "dais" (k7A "hiki")) ; --UNCHK
lin dashingly_Adv = mkWAdv (compoundAdv "huippu" (k99 "tyylikkäästi")) ; --UNCHK
lin dastard_N = mkWN (k1 "roisto") "pelkurimainen" ; --UNCHK
lin dastardliness_N = mkWN "pelkurimaisuus" ; --UNCHK
lin dastardly_A = mkWA (k38 "raukkamainen") ; --UNCHK
lin dasymeter_N = mkWN (compoundN "dasy" (k5 "metri")) ; --UNCHK
lin dasyure_N = mkWN (compoundN "pussi" (k10A "näätä")) ; --UNCHK
lin data_N = mkN "data" ;
lin database_N = mkWN (compoundN "tieto" (k9A "kanta")) ; --UNCHK
lin datable_A = mkWA (k10 "oleva") "päivättävissä" ; --UNCHK
lin date_1_N = mkN "päivä" (mkN "määrä") ;
lin date_3_N = mkN "tapaaminen" ;
lin date_7_N = mkN "taateli" ;
lin date_N = mkN "päivämäärä" ; --- already split
lin date_V = mkWV (k53A "määrittää") "ikä" ; --UNCHK
lin date_V2 = mkWV2 (k53A "määrittää") "ikä" ; --UNCHK
lin dateless_A = mkWA (k34A "ajaton") ; --UNCHK
lin dateline_N = mkWN (compoundN "päiväys" (k5 "rivi")) ; --UNCHK
lin dating_N = mkWN (compoundN "ajo" (k38 "ittaminen")) "geologinen" ; --UNCHK
lin dative_N = mkWN (k5 "datiivi") ; --UNCHK
lin datum_N = mkWN (k1A "tieto") ; --f142
lin daub_N = mkWN (k39 "töherrys") ; --UNCHK
lin daub_V = mkWV (k67 "sivellä") ; --UNCHK
lin daub_V2 = mkWV2 (k67 "sivellä") ; --UNCHK
lin dauber_N = mkWN (k12 "töhrijä") ; --UNCHK
lin daughter_N = mkN "tytär" ;
lin daughterly_A = mkWA "tyttären" ; --UNCHK
lin daunt_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin daunting_A = mkWA (k10 "musertava") ; --UNCHK
lin dauntless_A = mkWA (k15 "urhea") ; --UNCHK
lin dauntlessness_N = mkWN (k40 "urheus") ; --UNCHK
lin dauphin_N = mkWN "dauphin" ; --UNCHK
lin davallia_N = mkWN "Davallia" ; --UNCHK
lin davenport_N = mkWN (compoundN "vuode" (k10 "sohva")) ; --UNCHK
lin daventry_PN = foreignPN "Daventry" ;
lin david_PN = foreignPN "David" ;
lin davit_N = mkWN (k5A "taavetti") ; --UNCHK
lin daw_N = mkWN (k9A "naakka") ; --UNCHK
lin dawah_N = mkWN "da’wa" ; --UNCHK
lin dawdle_V = mkWV (k74A "pudota") ; --UNCHK
lin dawdle_V2 = mkWV2 (k74A "pudota") ; --UNCHK
lin dawdler_N = mkWN (k12 "kuhnailija") ; --UNCHK
lin dawlish_PN = foreignPN "Dawlish" ;
lin dawn_N = mkWN (k39 "sarastus") ; --UNCHK
lin dawn_V = mkWV (k53 "sarastaa") ; --UNCHK
lin day_N = L.day_N ;
lin day_boarder_N = mkWN (compoundN "päivä" (k41 "oppilas")) ; --UNCHK
lin day_labourer_N = mkWN (compoundN "päivä" (k38 "työläinen")) ; --UNCHK
lin day_return_N = mkWN (compoundN "päivä" (k1A "lippu")) ; --UNCHK
lin day_school_N = mkWN (compoundN "päivä" (k1 "koulu")) ; --UNCHK
lin daybed_N = mkWN (k6 "divaani") ; --UNCHK
lin daybook_N = mkWN (compoundN "tili" (k9 "kirja")) ; --UNCHK
lin dayboy_N = mkWN (compoundN "päivä" (k41 "oppilas")) ; --UNCHK
lin daybreak_N = mkWN (k1A "koitto") ; --UNCHK
lin daycare_N = mkWN (compoundN "päivä" (k1A "hoito")) "lasten" ; --UNCHK
lin daydream_N = mkWN (k24 "uni") ; --UNCHK
lin daydream_V = mkWV (k67 "haaveilla") ; --UNCHK
lin daydreamer_N = mkWN (k12 "haihattelija") ; --UNCHK
lin daygirl_N = mkWN (compoundN "päivä" (k41 "oppilas")) ; --UNCHK
lin daylight_N = mkWN (compoundN "päivän" (k1 "valo")) ; --UNCHK
lin daylight_saving_N = mkWN (k9A "kesäaika") ; --UNCHK
lin daylong_A = mkWA (k10 "kestävä") "päivän" ; --UNCHK
lin daylong_Adv = mkWAdv "koko" "päivän" ; --UNCHK
lin days_N = mkWN (k9A "elinaika") ; --UNCHK
lin dayspring_N = mkWN (k1A "koitto") ; --UNCHK
lin daytime_N = mkWN (kH1 "aika") "valoisa" ; --UNCHK
lin dayton_PN = foreignPN "Dayton" ;
lin daze_N = mkWN (k40 "sameus") ; --UNCHK
lin daze_V2 = mkWV2 (k53A "pökerryttää") ; --UNCHK
lin dazedly_Adv = mkWAdv (k99 "apaattisesti") ; --UNCHK
lin dazzle_N = mkWN (k39 "kimallus") ; --UNCHK
lin dazzle_V2 = mkWV2 (k54A "hämmentää") ; --UNCHK
lin dazzling_A = mkWA (k15 "räikeä") ; --UNCHK
lin ddt_N = mkWN (compoundN "diklooridifenyylitrikloori" (k5 "etaani")) ; --UNCHK
lin de_emphasize_V2 = mkV2 "häivyttää" ; ---ARB
lin de_facto_A = mkWA (compoundA "tosi" (k38 "asiallinen")) ; --UNCHK
lin de_facto_Adv = mkWAdv "tosiasiassa" ; --UNCHK
lin de_jure_A = mkWA (k38 "mukainen") "lain" ; --UNCHK
lin de_jure_Adv = mkWAdv (k99 "laillisesti") ; --UNCHK
lin de_luxe_A = mkWA (k10 "loistava") ; --UNCHK
lin deacon_N = mkWN (k6 "diakoni") ; --UNCHK
lin deaconess_N = mkWN (k9 "diakonissa") ; --UNCHK
lin deactivate_V2 = mkWV2 (k58 "kytkeä") "pois" ; --UNCHK
lin deactivation_N = mkWN (compoundN "deakti" (k5A "vointi")) ; --UNCHK
lin dead_A = mkWA (k47 "kuollut") ;
lin dead_Adv = mkWAdv (k99 "kaikkiaan") "kerta" ; --UNCHK
lin dead_N = mkN "vainaja" | mkWN (k47 "kuollut") ;
lin deadeye_N = mkWN (k6 "silmuri") ; --UNCHK
lin deadhead_N = mkWN (compoundN "ajo" (k1 "neuvo")) "tyhjä" ; --UNCHK
lin deadlight_N = mkWN (compoundN "sokko" (k1A "luukku")) ; --UNCHK
lin deadline_N = mkN "määräaika" ;
lin deadliness_N = mkWN (k40 "kuolettavuus") ; --UNCHK
lin deadlock_N = mkWN (k39 "pysähdys") ; --UNCHK
lin deadlock_V = mkV vOlla "umpikujassa" ;
lin deadlocked_A = mkWA (k10 "oleva") "pattitilanteessa" ; --UNCHK
lin deadly_A = mkWA "tappava" ;
lin deadness_N = mkWN (k40 "elottomuus") ; --UNCHK
lin deadpan_A = mkWA (k34A "eleetön") ; --UNCHK
lin deadpan_Adv = mkWAdv (compoundAdv "pokerinaam" (k99 "alla")) ; --UNCHK
lin deadwood_N = mkWN (k12 "tavara") "tarpeeton" ; --UNCHK
lin deaf_A = mkWA (compoundA "kuulo" (k38 "vammainen")) ; --UNCHK
lin deaf_N = mkWN (kH1 "kuuro") ; --UNCHK
lin deafen_V2 = mkWV2 (compoundV "ääni" (k53 "eristää")) ; --UNCHK
lin deafening_A = mkWA (k10 "korviasärkevä") ; --UNCHK
lin deafness_N = mkWN (k40 "kuurous") ; --UNCHK
lin deal_N = mkN "jako" ;
lin deal_PN = foreignPN "Deal" ;
lin deal_V = mkV (mkV "käydä") "kauppaa" ;
lin deal_V2 = mkV2 "käsitellä" partitive | mkV2 "jakaa" ; ---- split
lin dealer_N = mkWN (k41 "kauppias") ; --f226
lin dealfish_N = mkWN "Trachipterus" "arcticus" ; --UNCHK
lin dealignment_N = mkWN "puoluerajojen" "hämärtyminen" ; --UNCHK
lin dealing_N = mkWN (k39 "toimitus") ;
lin dealings_N = mkWN (k38 "kanssakäyminen") ; --UNCHK
lin deamination_N = mkWN "deaminaatio" ; --UNCHK
lin dean_N = mkWN (kH1 "dekaani") ; --UNCHK
lin deanery_N = mkWN (k9A "virka") "tuomiorovastin" ; --UNCHK
lin deanship_N = mkWN (k9A "virka") "tuomiorovastin" ; --UNCHK
lin dear_A = mkWA (k38 "läheinen") ; --UNCHK
lin dear_Adv = mkWAdv "kalliiksi" ; --UNCHK
lin dear_Interj = variants {} ; --
lin dear_N = mkWN (k1A "rakastettu") ; --UNCHK
lin dearest_N = mkWN (k1A "rakastettu") ; --UNCHK
lin dearie_N = mkWN (k41A "rakas") ; --UNCHK
lin dearness_N = mkWN (k40 "arvokkuus") ; --UNCHK
lin dearth_N = mkWN (k40 "niukkuus") ; --UNCHK
lin deary_N = mkWN (k41A "rakas") ; --UNCHK
lin death_N = mkN "kuolema" ;
lin death_mask_N = mkWN (compoundN "kuolin" (k3 "naamio")) ; --UNCHK
lin death_rate_N = mkWN (k40 "kuolleisuus") ; --UNCHK
lin death_warrant_N = mkWN (compoundN "kuoleman" (k3 "tuomio")) ; --UNCHK
lin deathbed_N = mkWN (compoundN "kuolin" (k48A "vuode")) ; --UNCHK
lin deathblow_N = mkWN (compoundN "armon" (k1 "isku")) ; --UNCHK
lin deathless_A = mkWA (k38 "ikuinen") ; --UNCHK
lin deathlike_A = mkWA (k38 "kaltainen") "kuoleman" ; --UNCHK
lin deathly_A = mkWA (k38 "kaltainen") "kuoleman" ; --UNCHK
lin deathly_Adv = mkWAdv "kuoleman-" | adjAdv deathly_A ; --UNCHK -- derived
lin deathtrap_N = mkWN (compoundN "kuoleman" (k1A "loukku")) ; --UNCHK
lin deb_N = mkWN (k5A "debytantti") ; --UNCHK
lin debacle_N = mkWN (k2 "fiasko") ; --UNCHK
lin debar_V2 = mkWV2 (k58A "sulkea") "pois" ; --UNCHK
lin debark_V = mkWV (k52 "astua") "maihin" ; --UNCHK
lin debark_V2 = mkWV2 (k52 "astua") "maihin" ; --UNCHK
lin debarkation_N = mkWN (compoundN "maihin" (k1 "nousu")) ; --UNCHK
lin debarment_N = mkWN (compoundN "pois" (k38 "sulkeminen")) ; --UNCHK
lin debase_V2 = mkWV2 (k53A "vesittää") ; --UNCHK
lin debasement_N = mkWN (compoundN "arvon" (k39 "alennus")) ; --UNCHK
lin debaser_N = mkWN "arvon" "alentaja" ; --UNCHK
lin debasing_A = mkWA (k10 "alentava") ; --UNCHK
lin debatable_A = mkWA (k34A "selvittämätön") ; --UNCHK
lin debate_N = mkN "debatti" ;
lin debate_V = mkWV (k67A "väitellä") ; --UNCHK
lin debate_V2 = mkWV2 (k67A "väitellä") ; --UNCHK
lin debater_N = mkWN (k12 "keskustelija") ; --UNCHK
lin debauch_V2 = mkWV2 (k53A "johtaa") "harhaan" ; --UNCHK
lin debaucheeFem_N = mkWN (k12 "irstailija") ; --UNCHK ---- sense to be split
lin debaucheeMasc_N = mkWN (k12 "irstailija") ; --UNCHK ---- sense to be split
lin debauchee_N = mkWN (k12 "irstailija") ; --UNCHK
lin debenture_N = mkWN (compoundN "velka" (k39 "sitoumus")) ; --f99
lin debilitate_V2 = mkWV2 (k64 "viedä") "voimat" ; --UNCHK
lin debilitating_A = mkWA "heikentävä" ; --UNCHK
lin debilitation_N = mkWN (k39 "väsymys") ; --UNCHK
lin debilitative_A = mkWA "heikentävä" ; --UNCHK
lin debility_N = mkWN (k40 "sairaalloisuus") ; --UNCHK
lin debit_V2 = mkWV2 (k53A "veloittaa") ; --UNCHK
lin debonair_A = mkWA (k38 "herttainen") ; --UNCHK
lin debouch_V = mkWV (k58 "laskea") ; --UNCHK
lin debouch_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin debridement_N = mkWN "avaaminen" ; --UNCHK
lin debrief_V2 = mkWV2 (k54A "pyytää") "selvitystä" ; --UNCHK
lin debriefing_N = mkWN (k39 "selvitys") ; --UNCHK
lin debris_N = mkWN (k1 "romu") ; --UNCHK
lin debt_N = mkN (lin NK {s = d09A "velka"}) ;
lin debtor_N = mkWN (k38 "velallinen") ; --UNCHK
lin debugger_N = mkWN (compoundN "tarkastus" (k10 "ohjelma")) "virheiden" ; --UNCHK
lin debunk_V2 = mkWV2 (k53A "romuttaa") ; --UNCHK
lin debut_1_N = mkN "debyytti" ;
lin debut_2_N = mkWN (k38 "ensiesiintyminen") ; --
lin debut_V2 = mkWV2 (k62 "debytoida") ; --UNCHK
lin debutante_N = mkWN (k5A "debytantti") ; --UNCHK
lin decade_N = mkN "vuosi" (mkN "kymmen" "kymmenen" "kymmeniä") ;
lin decadence_N = mkWN (k5 "dekadenssi") ; --UNCHK
lin decadent_A = mkWA "turmeltunut" ; --UNCHK
lin decadent_N = mkWN (k5A "dekadentti") ; --UNCHK
lin decagon_N = mkWN "kymmenkulmio" ; --UNCHK
lin decahedron_N = mkWN (compoundN "kymmen" (k41A "tahokas")) ; --UNCHK
lin decal_N = mkWN "siirtopainokuva" ; --UNCHK
lin decalcification_N = mkWN (compoundN "kalkki" (k1A "kato")) ; --UNCHK
lin decalcomania_N = mkWN (compoundN "siirtopainokuva" (k10 "menetelmä")) ; --UNCHK
lin decalescence_N = mkWN (compoundN "hidas" (k38 "tuminen")) "lämpötilan" "nousun" ; --UNCHK
lin decalescent_A = mkWA "lämpöä" "imevä" ; --UNCHK
lin decalogue_N = mkWN "Kymmenen" "käskyä" ; --UNCHK
lin decameter_N = mkWN (compoundN "deka" (k5 "metri")) ; --UNCHK
lin decamp_V = mkWV (k52A "häipyä") ; --UNCHK
lin decampment_N = mkWN "leirin" "purkaminen" ; --UNCHK
lin decant_V2 = mkWV2 (k57A "kaataa") ; --UNCHK
lin decantation_N = mkWN (k5A "dekantointi") ; --UNCHK
lin decanter_N = mkWN (k6 "dekantteri") ; --UNCHK
lin decapitation_N = mkWN (k39 "mestaus") ; --UNCHK
lin decapod_N = mkWN (compoundN "kymmen" (k38 "jalkainen")) ; --UNCHK
lin decarbonize_V2 = mkWV2 (k53 "poistaa") "karsta" ; --UNCHK
lin decarboxylase_N = mkWN (compoundN "dekarboksyl" (k5 "aasi")) ; --UNCHK
lin decarboxylation_N = mkWN (compoundN "pois" (k38 "taminen")) "karboksyylien" ; --UNCHK
lin decasyllabic_A = mkWA (compoundA "kymmen" (k38 "tavuinen")) ; --UNCHK
lin decasyllable_N = mkWN (k48A "säe") "kymmentavuinen" ; --UNCHK
lin decathlon_N = mkWN (compoundN "kymmen" (k2 "ottelu")) ; --UNCHK
lin decay_N = mkWN (compoundN "mätä" (k38 "neminen")) ; --UNCHK
lin decay_V = mkWV (k74 "lahota") ; --UNCHK
lin decayable_A = mkWA (compoundA "mätän" (k10 "evä")) ; --UNCHK
lin decayed_A = mkWA (k1 "laho") ; --UNCHK
lin decease_N = mkWN (k1A "hengenveto") "viimeinen" ; --UNCHK
lin decease_V = mkWV (k67 "kuolla") "äkillisesti" ; --UNCHK
lin deceased_A = mkA (mkN "kuollut" "kuolleen" "kuolleita") ;
lin deceit_N = mkWN (k39 "huiputus") ; --UNCHK
lin deceitful_A = mkWA (k38 "valheellinen") ; --UNCHK
lin deceitfulness_N = mkWN (k40 "juonikkuus") ; --UNCHK
lin deceive_V2 = mkWV2 (k53A "johtaa") "harhaan" ; --UNCHK
lin deceiver_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin deceivingly_Adv = mkWAdv (k99 "valheellisesti") ; --UNCHK
lin decelerate_V = mkWV (k53 "hidastaa") ; --UNCHK
lin decelerate_V2 = mkWV2 (k53 "hidastaa") ; --UNCHK
lin deceleration_N = mkWN (compoundN "hidas" (k38 "taminen")) ; --UNCHK
lin decency_N = mkWN (k40 "säädyllisyys") ; --UNCHK
lin decent_A = mkWA (k38 "säädyllinen") ; --UNCHK
lin decentralization_N = mkWN (compoundN "haja" (k38 "uttaminen")) ; --UNCHK
lin decentralize_V2 = mkWV2 (k53A "hajauttaa") ; --UNCHK
lin deception_N = mkWN (k3 "illuusio") ; --UNCHK
lin deceptive_A = mkWA (k38 "petollinen") ;
lin deceptiveness_N = mkWN (k40 "kieroutuneisuus") ; --UNCHK
lin decibel_N = mkWN (k5 "desibeli") ; --UNCHK
lin decide_V = mkV "päättää" ;
lin decide_V2 = mkV2 (mkV "päättää") ;
lin decide_VS = mkVS (mkV "päättää") ;
lin decide_VV = mkVV "päättää" ;
lin decide_on_V2 = prepV2 OP_decide_V OP_on_Prep ; -- guess-p-verb
lin decide_upon_V2 = prepV2 OP_decide_V OP_upon_Prep ; -- guess-p-verb
lin decided_A = mkWA (k10 "selvä") ; --UNCHK
lin decidua_N = mkWN (compoundN "kato" (k1 "kalvo")) ; --UNCHK
lin deciduous_A = mkWA (compoundA "kesä" (k9A "vihanta")) ; --UNCHK
lin decigram_N = mkWN (compoundN "desi" (k9 "gramma")) ; --UNCHK
lin decile_N = mkWN "desiili" ; --UNCHK
lin deciliter_N = mkWN (compoundN "desi" (k9 "litra")) ; --UNCHK
lin decimal_A = mkWA "desimaali-" ; --UNCHK
lin decimal_N = mkWN (compoundN "desimaali" (k1A "luku")) ; --UNCHK
lin decimalization_N = mkWN "kymmenlukujärjestelmään" "siirtyminen" ; --UNCHK
lin decimalize_V2 = mkWV2 (k52A "siirtyä") "kymmenlukujärjestelmään" ; --UNCHK
lin decimate_V2 = mkWV2 (k64 "viedä") "hautaan" ; --UNCHK
lin decimation_N = mkWN (compoundN "joukko" (k1 "tuho")) ; --UNCHK
lin decimeter_N = mkWN (compoundN "desi" (k5 "metri")) ; --UNCHK
lin decipherable_A = mkWA (k10 "luettava") ; --UNCHK
lin decipherer_N = mkWN (k10 "purkaja") "salakirjoituksen" ; --UNCHK
lin decision_N = mkN "päätös" ;
lin decision_making_N = mkN "päätöksenteko" ;
lin decisive_A = mkWA (k10 "ratkaiseva") ;
lin decisiveness_N = mkWN (k40 "lopullisuus") ; --UNCHK
lin deck_N = mkN (lin NK {s = d28 "kansi"}) ;
lin deck_V2 = mkWV2 (k73 "tyrmätä") ; --UNCHK
lin deck_out_V = mkWV (k52A "pukeutua") ; --UNCHK
lin decker_N = mkWN "-kerroksinen" ; --UNCHK
lin deckhand_N = mkWN (compoundN "kansi" (k42 "mies")) ; --UNCHK
lin deckle_N = mkWN (compoundN "dek" (k5 "keli")) ; --UNCHK
lin deckled_A = mkWA (compoundA "rosoreu" (k38 "nainen")) ; --UNCHK
lin declaim_V = mkWV (k61A "sättiä") ; --UNCHK
lin declaim_V2 = mkWV2 (k61A "sättiä") ; --UNCHK
lin declamation_N = mkWN (k48 "puhe") "kiivas" ; --UNCHK
lin declamatory_A = mkWA (k38 "korkealentoinen") ; --UNCHK
lin declarable_A = mkWA "ilmoitettava" ; --UNCHK
lin declaration_N = mkN (lin NK {s = d39 "julistus"}) ;
lin declarative_A = mkWA "selittävä" ; --UNCHK
lin declare_V = mkWV (k53A "ilmoittaa") ; --UNCHK
lin declare_V2 = mkWV2 (k53A "ilmoittaa") ; --UNCHK
lin declare_VS = mkVS (mkV "julistaa") ;
lin declassification_N = mkWN "salassapitomääräyksen" "kumoaminen" ; --UNCHK
lin declension_N = mkWN (k3 "deklinaatio") ; --UNCHK
lin declination_N = mkWN "kohtelias" "kieltäytyminen" ; --UNCHK
lin decline_N = mkN "rappio" ;
lin decline_V = mkV (lin VK {s = c58 "laskea"}) ;
lin decline_V2 = mkV2 (mkV "hylätä" "hylkäsi") ;
lin decline_VV = mkVV (mkV "pidättäytyä") infElat ;
lin declivitous_A = mkWA (k10A "jyrkkä") ; --UNCHK
lin declivity_N = mkWN (k1 "lasku") ; --UNCHK
lin declutch_V = mkWV (k53 "nostaa") "kytkin" ; --UNCHK
lin decoction_N = mkWN (k39 "valmistus") "dekoktin" ; --UNCHK
lin decode_V2 = mkWV2 (k66 "ratkaista") ; --UNCHK
lin decoder_N = mkWN (k6 "dekooderi") ; --UNCHK
lin decoding_N = mkWN (k1A "purku") "salauksen" ; --UNCHK
lin decoke_V2 = mkWV2 (k53 "poistaa") "karsta" ; --UNCHK
lin decolletage_N = mkWN (compoundN "pään" (k19 "tie")) "syvään" "uurrettu" ; --UNCHK
lin decollete_A = mkWA (compoundA "uurre" (k1 "ttu")) "syvään" ; --UNCHK
lin decolonization_N = mkWN (compoundN "itse" (k38 "näistyminen")) "siirtomaiden" ; --UNCHK
lin decolonize_V2 = mkWV2 (k53 "itsenäistää") ; --UNCHK
lin decompose_V = mkWV (k53A "hajottaa") ; --UNCHK
lin decompose_V2 = mkWV2 (k53A "hajottaa") ; --UNCHK
lin decomposition_N = mkWN (compoundN "dekom" (k3 "positio")) ; --UNCHK
lin decompositional_A = mkWA "mädättävä" ; --UNCHK
lin decompound_A = mkWA (k38 "kerrannainen") "kahdesti" ; --UNCHK
lin decompress_V2 = mkWV2 (k52A "rauhoittua") ; --UNCHK
lin decompression_N = mkWN (compoundN "ale" (k38 "ntaminen")) "paineen" ; --UNCHK
lin decongestant_N = mkWN (compoundN "dekonges" (k5A "tantti")) ; --UNCHK
lin deconsecrated_A = mkWA (compoundA "sekulariso" (k1A "itu")) ; --UNCHK
lin deconstruction_N = mkWN (compoundN "dekonstruktion" (k5 "ismi")) ; --UNCHK
lin deconstructionist_A = mkWA (k10 "kannattava") "dekonstruktiota" ; --UNCHK
lin deconstructivism_N = mkWN (compoundN "dekonstruktiv" (k5 "ismi")) ; --UNCHK
lin decontaminate_V2 = mkWV2 (k53 "puhdistaa") "saasteesta" ; --UNCHK
lin decontamination_N = mkWN "dekontaminaatio" ; --UNCHK
lin decontrol_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin decor_N = mkWN (k39 "sisustus") ; --UNCHK
lin decorate_V2 = mkWV2 (k53 "somistaa") ; --UNCHK
lin decoration_N = mkWN (k2 "koristelu") ;
lin decorative_A = mkWA (k38 "koristeellinen") ; --UNCHK
lin decorativeness_N = mkWN (k40 "koristeellisuus") ; --UNCHK
lin decorator_N = mkWN (k10 "somistaja") ; --UNCHK
lin decorous_A = mkWA (k34A "moitteeton") ; --UNCHK
lin decortication_N = mkWN (compoundN "pois" (k38 "taminen")) "kuoren" ; --UNCHK
lin decorum_N = mkWN (k40 "säädyllisyys") ; --UNCHK
lin decoupage_N = mkWN "decoupage" ; --UNCHK
lin decoy_N = mkWN (k33A "houkutin") ; --UNCHK
lin decoy_V2 = mkWV2 (k67A "houkutella") "ansaan" ; --UNCHK
lin decrease_N = mkWN (k39 "vähennys") ; --UNCHK
lin decrease_V = mkWV (k58 "laskea") ; --UNCHK
lin decrease_V2 = mkWV2 (k58 "laskea") ;
lin decree_N = mkWN (k39 "asetus") ; --UNCHK
lin decree_V2 = mkWV2 (k53A "säätää") ; --UNCHK
lin decree_nisi_N = mkWN (compoundN "asumusero" (k39 "päätös")) ; --UNCHK
lin decrepit_A = mkWA (k41 "hauras") ; --UNCHK
lin decrepitation_N = mkWN (k12 "rätinä") ; --UNCHK
lin decrepitude_N = mkWN (k40 "raihnaisuus") ; --UNCHK
lin decrescendo_A = mkWA "diminuendo" ; --UNCHK
lin decrescendo_N = mkWN "diminuendo" ; --UNCHK
lin decriminalization_N = mkWN (compoundN "dekriminali" (k5A "sointi")) ; --UNCHK
lin decry_V2 = mkWV2 (k61A "sättiä") ; --UNCHK
lin decubitus_N = mkWN (compoundN "makuu" (k1A "asento")) ; --UNCHK
lin decumary_N = mkWN "Decumaria" "barbara" ; --UNCHK
lin decurved_A = mkWA "alaspäin" "kaartuva" ; --UNCHK
lin decussate_A = mkWA (k38 "ristimäinen") ; --UNCHK
lin dedicate_V2 = mkV2 "omistaa" ; --mkWV2 (k53A "pyhittää") ;
lin dedication_N = mkWN (k5A "lojaliteetti") ; --UNCHK
lin dedifferentiated_A = mkWA (compoundA "taa" (k47 "ntunut")) "erilaistumisessa" ; --UNCHK
lin dedifferentiation_N = mkWN "dedifferentiaatio" ; --UNCHK
lin deduce_V2 = mkWV2 (k53A "johtaa") ; --UNCHK
lin deducible_A = mkWA (k10 "oleva") "johdettavissa" ; --UNCHK
lin deduct_V2 = mkV2 "vähentää" ; --mkWV2 (k53A "johtaa") ;
lin deductible_A = mkWA (compoundA "vähennys" (k38 "kelpoinen")) ;
lin deductible_N = mkWN (k50 "omavastuu") ; --UNCHK
lin deduction_N = mkWN (k39 "vähennys") ; --UNCHK
lin deductive_A = mkWA (k38 "deduktiivinen") ; --UNCHK
lin deed_N = mkWN (k25 "toimi") ; --UNCHK
lin deem_V2 = mkWV2 (k53A "olettaa") ; --UNCHK
lin deem_V2A = mkWV2A (k53A "olettaa") ; --UNCHK
lin deem_V2V = mkWV2V (k53A "olettaa") ; --UNCHK
lin deep_A = mkWA (k10 "syvä") | mkA "syvällinen" ; ---- split ?
lin deep_Adv = mkWAdv (k99 "syvälle") ; --UNCHK
lin deep_N = mkWN (k24 "meri") ; --UNCHK
lin deep_freeze_N = mkWN (compoundN "jää" (k38 "dyttäminen")) ; --UNCHK
lin deep_freeze_V2 = mkWV2 (k53 "pakastaa") ; --UNCHK
lin deepen_V = mkWV (k54A "syventää") ; --UNCHK
lin deepen_V2 = mkWV2 (k54A "syventää") ; --UNCHK
lin deepening_N = mkWN "syveneminen" ; --UNCHK
lin deepness_N = mkWN (k26 "ääni") "matala" ; --UNCHK
lin deer_N = mkWN (k41 "kauris") ; --UNCHK
lin deerberry_N = mkWN "Vaccinium" "stamineum" ; --UNCHK
lin deerskin_N = mkWN (compoundN "hirven" (k9 "nahka")) ; --UNCHK
lin deerstalker_N = mkWN (compoundN "metsästäjän" (k1A "hattu")) ; --UNCHK
lin deerstalking_N = mkWN (compoundN "hirven" (k39 "metsästys")) ; --UNCHK
lin deface_V2 = mkWV2 (k53A "vahingoittaa") ; --UNCHK
lin defacement_N = mkWN (compoundN "pila" (k38 "aminen")) ; --UNCHK
lin defalcation_N = mkWN (k39 "anastus") ; --UNCHK
lin defamation_N = mkWN (k39 "mustamaalaus") ; --UNCHK
lin defamatory_A = mkWA (compoundA "must" (k9 "aava")) ; --UNCHK
lin defame_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin defamer_N = mkWN (k10 "parjaaja") ; --UNCHK
lin default_N = mkN "laimin" (mkN "lyönti") ; --f56
lin default_V = mkV "laiminlyödä" ;
lin defeasible_A = mkWA (k10 "oleva") "kumottavissa" ; --UNCHK
lin defeat_N = mkWN (k3 "häviö") ;
lin defeat_V2 = mkWV2 (k64 "lyödä") ;
lin defeatism_N = mkWN "tappiomieliala" ; --UNCHK
lin defeatist_N = mkWN (k5 "pessimisti") ; --UNCHK
lin defecate_V = mkWV (k73A "kakata") ; --UNCHK
lin defecation_N = mkWN (compoundN "pas" (k38 "kantaminen")) ; --UNCHK
lin defecator_N = mkWN (compoundN "pask" (k10 "oja")) ; --UNCHK
lin defect_N = mkWN (kH1 "vika") ; --UNCHK
lin defect_V = mkWV (k60A "lähteä") "paikaltaan" ; --UNCHK
lin defection_N = mkWN "hylkääminen" ; --UNCHK
lin defective_A = mkWA (k38 "rikkinäinen") ;
lin defectiveness_N = mkWN (k40 "viallisuus") ; --UNCHK
lin defector_N = mkWN (k6 "loikkari") ; --UNCHK
lin defence_N = mkN "puolustus" ;
lin defenceless_A = mkWA (k34A "aseeton") ; --UNCHK
lin defencelessness_N = mkWN (compoundN "puolustus" (k40 "kyvyttömyys")) ; --UNCHK
lin defend_V2 = mkV2 "puolustaa" partitive ;
lin defendable_A = mkWA (k10 "oleva") "puolustettavissa" ; --UNCHK
lin defendant_N = mkN (lin NK {s = d10 "vastaaja"}) ;
lin defenderFem_N = mkWN (k5A "vahti") ;
lin defenderMasc_N = variants {} ; --
lin defenestration_N = mkWN (compoundN "ikku" (k9 "nasta")) "heittäminen" "ulos" ; --UNCHK
lin defense_N = mkN "puolustus" ;
lin defenseless_A = mkWA (k34A "aseeton") ; --UNCHK
lin defenseless_Adv = mkWAdv "puolustuskyvyttömänä" ; --UNCHK
lin defenselessness_N = mkWN (compoundN "puolustus" (k40 "kyvyttömyys")) ; --UNCHK
lin defensibility_N = mkWN "puolustettavuus" ; --UNCHK
lin defensible_A = mkWA (k10 "oleva") "puolustettavissa" ; --UNCHK
lin defensive_A = mkA "defensiivinen" ; ---ARB WA "puolustus-" ;
lin defensive_N = mkWN (compoundN "puolustus" (k48A "asenne")) ; --UNCHK
lin defensiveness_N = mkWN "puolustelevuus" ; --UNCHK
lin defer_V = mkWV (k56A "antaa") "myöten" ; --UNCHK
lin defer_V2 = mkWV2 (k56A "antaa") "myöten" ; --UNCHK
lin deference_N = mkWN (k39 "kunnioitus") ; --UNCHK
lin deferent_A = mkWA (k38 "huomaavainen") ; --UNCHK
lin deferential_A = mkWA (k38 "huomaavainen") ; --UNCHK
lin deferment_N = mkWN (k39 "lykkäys") ; --UNCHK
lin deferral_N = mkWN (k39 "lykkäys") ; --UNCHK
lin defervescence_N = mkWN "kuumeen" "laskeminen" ; --UNCHK
lin defiance_N = mkWN (compoundN "uhma" (k38 "aminen")) ; --UNCHK
lin defiant_A = mkWA (k34A "taipumaton") ; --UNCHK
lin defibrillation_N = mkWN (compoundN "rytmin" (k1A "siirto")) "sähköinen" ; --UNCHK
lin deficiency_N = mkWN (k39 "vajaus") ; --UNCHK
lin deficit_N = mkWN (k48 "vaje") ; --f197
lin defile_N = mkWN (k1 "rotko") ; --UNCHK
lin defile_V = mkWV (k73A "liata") ; --UNCHK
lin defile_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin defilement_N = mkWN (k2 "häpäisy") ; --UNCHK
lin definable_A = mkWA (k10 "oleva") "määriteltävissä" ; --UNCHK
lin define_V = mkV "määritellä" ;
lin define_V2 = mkV2 "määritellä" ;
lin definite_A = mkA (lin AK {s = d09 "varma"}) ;
lin definition_N = mkWN (k39 "rajaus") ; --UNCHK
lin definitive_A = mkWA (k38 "lopullinen") ;
lin deflagration_N = mkWN (compoundN "pala" (k38 "minen")) "nopea" ; --UNCHK
lin deflate_V2 = mkWV2 (k52A "tyhjentyä") ; --UNCHK
lin deflation_N = mkWN (k39 "tyhjennys") ; --UNCHK
lin deflationary_A = mkWA "deflatorinen" ; --UNCHK
lin deflect_V = mkWV (k53 "estää") ; --UNCHK
lin deflect_V2 = mkWV2 (k53 "estää") ; --UNCHK
lin deflection_N = mkWN (compoundN "kierto" (k19 "tie")) ; --UNCHK
lin deflective_A = mkWA "taittava" ; --UNCHK
lin defloration_N = mkWN (k38 "vieminen") "neitsyyden" ; --UNCHK
lin deflower_V2 = mkWV2 (k53A "vesittää") ; --UNCHK
lin defoliant_N = mkWN (compoundN "vesakko" (k1A "myrkky")) ; --UNCHK
lin defoliate_A = mkWA "lehtensä" "pudottanut" ; --UNCHK
lin defoliation_N = mkWN "lehtien" "riistäminen" ; --UNCHK
lin defoliator_N = mkWN (k38 "hyönteinen") "lehtikatoa" "aiheuttava" ; --UNCHK
lin deforest_V2 = mkWV2 (k53 "poistaa") "metsä" ; --UNCHK
lin deforestation_N = mkWN "metsän" "hävittäminen" ; --UNCHK
lin deform_V2 = mkWV2 (k53A "muuttaa") "muotoa" ; --UNCHK
lin deformation_N = mkWN (k2 "vääristely") ; --UNCHK
lin deformational_A = mkWA "vääristävä" ; --UNCHK
lin deformity_N = mkWN (k9 "vamma") "näkyvä" ; --UNCHK
lin defraud_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin defray_V2 = mkWV2 (k54A "kustantaa") ; --UNCHK
lin defrayal_N = mkWN (k39 "suoritus") "maksun" ; --UNCHK
lin defrayment_N = mkWN (k39 "suoritus") "maksun" ; --UNCHK
lin defrost_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin defroster_N = mkWN (k33A "lämmitin") ; --UNCHK
lin deft_A = mkWA (k10 "kätevä") ; --UNCHK
lin deftness_N = mkWN (k40 "nopeus") ; --UNCHK
lin defunct_A = mkWA (k47 "kuollut") ;
lin defuse_V2 = mkWV2 (k71 "tehdä") "vaarattomaksi" ; --UNCHK
lin defy_V2 = mkWV2 (k56 "haastaa") ;
lin defy_V2V = mkWV2V (k56 "haastaa") ; --UNCHK
lin degage_A = mkWA (k34A "puolueeton") ; --UNCHK
lin degauss_V2 = mkWV2 (k62 "demagnetoida") ; --UNCHK
lin degaussing_N = mkWN (compoundN "pois" (k38 "taminen")) "magneettisuuden" ; --UNCHK
lin degeneracy_N = mkWN (k39 "turmelus") ; --UNCHK
lin degenerate_A = mkWA (k38 "paheellinen") ; --UNCHK
lin degenerate_N = mkWN (k1 "pervo") ; --UNCHK
lin degenerate_V = mkWV (k72A "heiketä") ; --UNCHK
lin degeneration_N = mkWN (k3 "regressio") ; --UNCHK
lin degenerative_A = mkWA "rappeutumis-" ; --UNCHK
lin degradation_N = mkWN (compoundN "arvon" (k39 "alennus")) ; --UNCHK
lin degrade_V2 = mkWV2 (k58 "laskea") "hintaa" ; --UNCHK
lin degree_1_N = mkN "aste" ;
lin degree_2_N = mkN "oppiarvo" ;
lin degree_3_N = mkN "aste" ;
lin degree_N = mkN "aste" ; ---- already split
lin degressive_A = mkWA (k10 "aleneva") ; --UNCHK
lin dehiscence_N = mkWN (compoundN "vari" (k38 "staminen")) "siementen" ; --UNCHK
lin dehorn_V2 = mkWV2 (k53 "poistaa") "sarvet" ; --UNCHK
lin dehumanization_N = mkWN (compoundN "epä" (k38 "inhimillistäminen")) ; --UNCHK
lin dehumanize_V2 = mkWV2 (k53 "koneistaa") ; --UNCHK
lin dehydrate_V2 = mkWV2 (k52 "kuivua") ; --UNCHK
lin dehydration_N = mkWN (k39 "haihdutus") ; --UNCHK
lin deictic_A = mkWA "deiktinen" ; --UNCHK
lin deictic_N = mkWN (k9 "sana") "deiktinen" ; --UNCHK
lin deific_A = mkWA (k38 "jumalainen") ; --UNCHK
lin deification_N = mkWN "apoteoosi" ; --UNCHK
lin deify_V2 = mkWV2 (k53A "korottaa") "jumalaksi" ; --UNCHK
lin deign_V = mkWV (k74 "vajota") ; --UNCHK
lin deinocheirus_N = mkWN "Deinocheirus" ; --UNCHK
lin deipnosophist_N = mkWN "taitava" "jutustelija" ; --UNCHK
lin deism_N = mkWN (k50 "vapaa-ajattelu") ; --UNCHK
lin deist_A = mkWA (k38 "deistinen") ; --UNCHK
lin deist_N = mkWN (k50 "vapaa-ajattelija") ; --UNCHK
lin deity_N = mkWN (k34A "kuolematon") ; --UNCHK
lin deixis_N = mkWN "deiksis" ; --UNCHK
lin deject_V2 = mkWV2 (k53 "ahdistaa") ; --UNCHK
lin dejectedly_Adv = mkWAdv (k99 "alakuloisesti") ; --UNCHK
lin dejection_N = mkWN (k40 "masentuneisuus") ; --UNCHK
lin dekagram_N = mkWN (compoundN "deka" (k9 "gramma")) ; --UNCHK
lin dekaliter_N = mkWN (compoundN "deka" (k9 "litra")) ; --UNCHK
lin dekko_N = mkWN (k2 "vilkaisu") ; --UNCHK
lin delavirdine_N = mkWN "Rescriptor" ; --UNCHK
lin delaware_PN = foreignPN "Delaware" ;
lin delay_N = mkWN (k39 "viivästys") ; --f72
lin delay_V = mkWV (k53A "viivyttää") ; --UNCHK
lin delay_V2 = mkWV2 (k53A "viivyttää") ; --f56
lin delay_VS = mkWVS (k53A "viivyttää") ; --UNCHK
lin delayed_action_N = mkWN (k9A "toiminta") "hidastettu" ; --UNCHK
lin delayer_N = mkWN "viivyttäjä" ; --UNCHK
lin delectability_N = mkWN (k40 "herkullisuus") ; --UNCHK
lin delectable_A = mkWA (k10 "viehättävä") "seksuaalisesti" ; --UNCHK
lin delectation_N = mkWN (k1 "ilo") ; --UNCHK
lin delegacy_N = mkWN (compoundN "nimi" (k38 "ttäminen")) "edustajan" ; --UNCHK
lin delegate_N = mkWN (k10 "edustaja") ;
lin delegate_V2 = mkWV2 (k73 "määrätä") "tehtävään" ; --UNCHK
lin delegating_N = mkWN "valtuuttaminen" ; --UNCHK
lin delegation_N = mkWN "valtuuttaminen" ; --UNCHK
lin delete_V2 = mkV2 "hävittää" ;
lin deleterious_A = mkWA (k38 "turmiollinen") ; --UNCHK
lin deletion_N = mkWN (compoundN "pois" (k38 "taminen")) ; --UNCHK
lin delf_N = mkWN (k1A "kaivanto") ; --UNCHK
lin delft_N = mkWN (k5 "fajanssi") "Delftin" ; --UNCHK
lin delhi_PN = foreignPN "Delhi" ;
lin deliberate_A = mkWA (k38 "verkkainen") ; --UNCHK
lin deliberate_V = mkWV (k62 "puntaroida") ; --UNCHK
lin deliberate_V2 = mkWV2 (k62 "puntaroida") ; --UNCHK
lin deliberation_N = mkWN (k40 "varovaisuus") ;
lin deliberative_A = mkWA (k10 "harkitseva") ; --UNCHK
lin delible_A = mkWA "poistettavissa" ; --UNCHK
lin delicacy_N = mkWN (k40 "herkkyys") ; --UNCHK
lin delicate_A = mkWA (k41 "hauras") ;
lin delicatessen_N = mkWN (compoundN "ruoka" (k9A "kauppa")) ; --UNCHK
lin delicious_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin delight_N = mkWN (k1 "ilo") ; --UNCHK
lin delight_V = mkV "nauttia" ; --intransitive
lin delight_V2 = mkV2 "ilahduttaa" ;
lin delighted_A = variants {} ; --
lin delightful_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin delimit_V2 = mkWV2 (k53A "määrittää") "rajat" ; --UNCHK
lin delimitate_V2 = mkWV2 (k53A "määrittää") "rajat" ; --UNCHK
lin delimitation_N = mkWN (kH1 "raja") ; --UNCHK
lin delineate_V2 = mkWV2 (k73 "kuvata") ; --UNCHK
lin delineation_N = mkWN (k10 "kuva") ; --UNCHK
lin delineative_A = mkWA "hahmoteltu" ; --UNCHK
lin delinquency_N = mkWN (k39 "rikos") "nuoren" "tekemä" ; --UNCHK
lin delinquent_A = mkWA (k10 "oleva") "myöhässä" ; --UNCHK
lin delinquent_N = mkWN (compoundN "nuoriso" (k38 "rikollinen")) ; --UNCHK
lin deliquescent_A = mkWA (compoundA "liuke" (k9 "neva")) ; --UNCHK
lin delirious_A = mkWA (k41A "riehakas") ; --UNCHK
lin delirium_N = mkWN (compoundN "houre" (k9 "tila")) ; --UNCHK
lin delirium_tremens_N = mkWN (compoundN "juoppo" (k40 "hulluus")) ; --UNCHK
lin deliver_V = mkV (mkV "tuottaa") "tulosta" ; ---ARB mkWV (k63 "saada") "lapsi" ;
lin deliver_V2 = mkV2 "toimittaa" ; --f64
lin deliverable_A = mkWA (k10 "oleva") "toimitettavissa" ; --UNCHK
lin deliverable_N = mkWN (k48A "tuote") ; --UNCHK
lin deliverance_N = mkWN (k39 "vapahdus") ; --UNCHK
lin deliverer_N = mkWN (k10 "toimittaja") ; --UNCHK
lin delivery_N = mkWN (k39 "synnytys") ; --f140
lin deliveryman_N = mkWN (k10 "jakaja") ; --UNCHK
lin dell_N = mkWN (k1 "laakso") "metsäinen" ; --UNCHK
lin delouse_V2 = mkWV2 (k53 "puhdistaa") "syöpäläisistä" ; --UNCHK
lin delphic_A = mkWA (compoundA "delfoi" (k38 "lainen")) ; --UNCHK
lin delphinium_N = mkWN (k39 "ritarinkannus") ; --UNCHK
lin delta_N = mkWN (k9 "delta") ;
lin deltoid_A = mkWA (compoundA "kolmi" (k38 "omainen")) ; --UNCHK
lin deltoid_N = mkWN (compoundN "hartia" (k39 "lihas")) "kolmipäinen" ; --UNCHK
lin delude_V2 = mkWV2 (k73 "huijata") ; --UNCHK
lin deluge_N = mkWN (k39 "vedenpaisumus") ; --UNCHK
lin deluge_V2 = mkWV2 (k53A "hukuttaa") ; --UNCHK
lin delusion_N = mkWN (k9 "harha") ; --UNCHK
lin delusional_A = mkWA (k38 "harhainen") ; --UNCHK
lin delusive_A = mkWA (k38 "valheellinen") ; --UNCHK
lin deluxe_A = mkWA (k10 "loistava") ; --UNCHK
lin delve_V = mkWV (k61A "tonkia") ; --UNCHK
lin delve_V2 = mkWV2 (k61A "tonkia") ; --UNCHK
lin demagnetization_N = mkWN (compoundN "demagneti" (k5A "sointi")) ; --UNCHK
lin demagnetize_V2 = mkWV2 (k62 "demagnetoida") ; --UNCHK
lin demagogic_A = mkWA (k38 "demagoginen") ; --UNCHK
lin demagogue_N = mkWN (k5 "demagogi") ; --UNCHK
lin demagoguery_N = mkWN (k12 "demagogia") ; --UNCHK
lin demagogy_N = mkWN (k12 "demagogia") ; --UNCHK
lin demand_N = mkN "kysyntä" ;
lin demand_V2 = mkWV2 (k61A "vaatia") ; --f52
lin demand_VS = mkWVS (k61A "vaatia") ;
lin demander_N = mkWN (k12 "vaatija") ; --UNCHK
lin demanding_A = mkWA (k10 "vaativa") ; --UNCHK
lin demantoid_N = mkWN "demantoidi" ; --UNCHK
lin demarcate_V2 = mkWV2 (k53A "määrittää") "rajat" ; --UNCHK
lin demarcation_N = mkWN (kH1 "raja") ; --UNCHK
lin demarche_N = mkWN "demarssi" ; --UNCHK
lin demean_V2 = mkWV2 (k52 "väheksyä") ; --UNCHK
lin demeaning_A = mkWA (k38 "häpeällinen") ; --UNCHK
lin demeanor_N = mkWN (k9A "toiminta") ; --UNCHK
lin demeanour_N = mkWN (k9A "toiminta") ; --UNCHK
lin demented_A = mkWA (k99 "tolaltaan") "poissa" ; --UNCHK
lin dementia_N = mkWN (k12 "dementia") ; --UNCHK
lin demerara_N = mkWN (compoundN "demerara" (k6 "sokeri")) ; --UNCHK
lin demerit_N = mkWN (kH1 "vika") ; --UNCHK
lin demesne_N = mkWN (k18 "maa") ; --UNCHK
lin demiglace_N = mkWN (compoundN "liha" (k25 "liemi")) "kokoon" "keitetty" ; --UNCHK
lin demigod_N = mkWN (k5 "demoni") ; --UNCHK
lin demijohn_N = mkWN (compoundN "kori" (k1 "pullo")) ; --UNCHK
lin demilitarize_V2 = mkWV2 (k62 "demilitarisoida") ; --UNCHK
lin demimondaine_N = mkWN (k38 "nainen") "puolimaailman" ; --UNCHK
lin demimonde_N = mkWN (k38 "nainen") "puolimaailman" ; --UNCHK
lin demineralization_N = mkWN (compoundN "pois" (k38 "taminen")) "suolojen" ; --UNCHK
lin demise_N = mkWN (k10 "kuolema") ; --UNCHK
lin demist_V2 = mkWV2 (k53 "poistaa") "huuru" ; --UNCHK
lin demister_N = mkWN (compoundN "tuulilasin" (k33A "lämmitin")) ; --UNCHK
lin demitasse_N = mkWN (compoundN "mokka" (k5A "kuppi")) ; --UNCHK
lin demiurge_N = mkWN "demiurgi" ; --UNCHK
lin demo_N = mkWN (k5A "demonstrointi") ; --UNCHK
lin demob_V2 = mkWV2 (k52A "kotiutua") "sotapalveluksesta" ; --UNCHK
lin demobilization_N = mkWN (k5A "demobilisointi") ; --UNCHK
lin demobilize_V2 = mkWV2 (k52A "kotiutua") "sotapalveluksesta" ; --UNCHK
lin democracy_N = mkN (lin NK {s = d12 "demokratia"}) ;
lin democrat_N = mkWN (k5 "populisti") ; --UNCHK
lin democratic_A = mkA (lin AK {s = d38 "demokraattinen"}) ;
lin democratization_N = mkN (lin NK {s = d05A "demokratisointi"}) ;
lin democratize_V2 = mkWV2 (k62 "demokratisoida") ; --UNCHK
lin demodulation_N = mkWN "demodulaatio" ; --UNCHK
lin demographer_N = mkWN (k5 "demografi") ; --UNCHK
lin demographic_A = mkWA (k38 "demografinen") ; --UNCHK
lin demographic_N = mkWN (compoundN "väestö" (k2 "tilasto")) ; --UNCHK
lin demography_N = mkWN (k12 "demografia") ; --UNCHK
lin demolish_V2 = mkWV2 (k71 "tehdä") "loppu" ; --UNCHK
lin demolition_N = mkWN (compoundN "romu" (k38 "ttaminen")) ; --UNCHK
lin demon_N = mkWN (k5 "demoni") ;
lin demonetization_N = mkWN (compoundN "demonetari" (k5A "sointi")) ; --UNCHK
lin demonetize_V2 = mkWV2 (compoundV "demoneti" (k62 "soida")) ; --UNCHK
lin demoniac_A = mkWA (k1 "hullu") ; --UNCHK
lin demoniac_N = mkWN (k1A "riivattu") ; --UNCHK
lin demoniacal_A = mkWA (k1 "hullu") ; --UNCHK
lin demonic_A = mkWA (k34A "jumalaton") ; --UNCHK
lin demonization_N = mkWN (compoundN "demoni" (k5A "sointi")) ; --UNCHK
lin demonize_V2 = mkWV2 (k53A "muuttaa") "paholaiseksi" ; --UNCHK
lin demonstrability_N = mkWN "todistettavuus" ; --UNCHK
lin demonstrable_A = mkWA (k34A "kiistämätön") ; --UNCHK
lin demonstrate_V = mkV (mkV "osoittaa") "mieltä" ;
lin demonstrate_V2 = mkWV2 (k53 "havainnollistaa") ;
lin demonstrate_VS = mkWVS (k53 "vahvistaa") ; --UNCHK
lin demonstration_N = mkN "demonstraatio" ;
lin demonstrative_A = mkWA (k33 "avoin") ; --UNCHK
lin demonstrativeness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin demonstrator_N = mkWN (compoundN "mielen" (k10 "osoittaja")) ; --UNCHK
lin demoralization_N = mkWN (k5A "demoralisointi") ; --UNCHK
lin demoralize_V2 = mkWV2 (k62 "demoralisoida") ; --UNCHK
lin demoralizing_A = mkWA (k10 "masentava") ; --UNCHK
lin demote_V2 = mkWV2 (k66 "potkaista") "alas" ; --UNCHK
lin demotic_A = mkWA (k38 "arkinen") ; --UNCHK
lin demotion_N = mkWN (compoundN "arvon" (k39 "alennus")) ; --UNCHK
lin demulcent_A = mkWA "rauhoittava" ; --UNCHK
lin demulcent_N = mkWN (k48A "lääke") "ärsytystä" "lievittävä" ; --UNCHK
lin demur_N = mkWN (k48A "väite") ; --UNCHK
lin demur_V = mkWV (k53A "esittää") "vastalause" ; --UNCHK
lin demur_VS = mkWVS (k53A "esittää") "vastalause" ; --UNCHK
lin demure_A = mkWA (k1 "kaino") ; --UNCHK
lin demureness_N = mkWN (k40 "siveys") "teennäinen" ; --UNCHK
lin demurrage_N = mkWN (compoundN "lisä" (k9A "seisonta-aika")) ; --UNCHK
lin demurrer_N = mkWN (k39 "puolustus") ; --UNCHK
lin demyelination_N = mkWN "demyelinaatio" ; --UNCHK
lin demythologization_N = mkWN (compoundN "demytologi" (k5A "sointi")) ; --UNCHK
lin demythologized_A = mkWA (compoundA "demytologiso" (k1A "itu")) ; --UNCHK
lin den_N = mkWN (k7A "soppi") "rauhallinen" ; --UNCHK
lin denain_PN = foreignPN "Denain" ;
lin denary_A = mkWA "desimaali-" ; --UNCHK
lin denationalization_N = mkWN (compoundN "yks" (k38 "ityistäminen")) ; --UNCHK
lin denationalize_V2 = mkWV2 (k53 "yksityistää") ; --UNCHK
lin denaturant_N = mkWN (compoundN "denaturoimis" (k48 "aine")) ; --UNCHK
lin denatured_A = mkWA (compoundA "denaturo" (k1A "itu")) ; --UNCHK
lin denazification_N = mkWN "natsilaisuuden" "hävittäminen" ; --UNCHK
lin denbigh_PN = foreignPN "Denbigh" ;
lin dendrite_N = mkWN (compoundN "tuoja" (k48A "haarake")) ; --UNCHK
lin dendritic_A = mkWA "dendriittinen" ; --UNCHK
lin dendrobium_N = mkWN "Dendrobium" ; --UNCHK
lin dengue_N = mkWN (compoundN "dengue-verenvuoto" (k48 "kuume")) ; --UNCHK
lin deniable_A = mkWA (k10 "oleva") "kiellettävissä" ; --UNCHK
lin denial_N = mkWN (k39 "kieltäymys") ; --UNCHK
lin denier_N = mkWN (k10 "kieltäjä") ; --UNCHK
lin denigrate_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin denigration_N = mkWN (k9A "paheksunta") ; --UNCHK
lin denim_N = mkWN (k41A "farkkukangas") ; --UNCHK
lin denizen_N = mkN "asukas" ;
lin denmark_PN = foreignPN "Tanska" ;
lin dennis_PN = foreignPN "Dennis" ;
lin denny_PN = foreignPN "Denny" ;
lin denominate_V2 = mkWV2 (k75 "nimetä") ; --UNCHK
lin denomination_N = mkWN (k39 "nimitys") ; --UNCHK
lin denominationalism_N = mkWN (k40 "lahkolaisuus") ; --UNCHK
lin denominator_N = mkWN (k10 "nimittäjä") ; --UNCHK
lin denotative_A = mkWA "osoittava" ; --UNCHK
lin denotatum_N = mkWN "denotaatio" ; --UNCHK
lin denote_V2 = mkWV2 (k53A "tarkoittaa") ; --UNCHK
lin denouement_N = mkWN (compoundN "loppu" (k2 "ratkaisu")) ; --UNCHK
lin denounce_V2 = mkWV2 (k62 "kritisoida") ; --UNCHK
lin dense_A = mkWA (k38 "idioottimainen") ; --UNCHK
lin denseness_N = mkWN (k40 "tiiviys") ; --UNCHK
lin densimeter_N = mkWN (compoundN "tiheys" (k6 "mittari")) ; --UNCHK
lin densitometer_N = mkWN (compoundN "tiheys" (k6 "mittari")) ; --UNCHK
lin densitometry_N = mkWN "densitometria" ; --UNCHK
lin density_N = mkWN (k40 "tiiviys") ; --UNCHK
lin dent_N = mkWN (k1 "naarmu") ; --UNCHK
lin dent_V = mkWV (k71 "tehdä") "lommo" ; --UNCHK
lin dent_V2 = mkWV2 (k71 "tehdä") "lommo" ; --UNCHK
lin dental_A = mkWA "hammas-" ; --UNCHK
lin dentate_A = mkWA (compoundA "saha" (k38 "laitainen")) ; --UNCHK
lin denticle_N = mkWN (k10A "pykä") ; --UNCHK
lin denticulate_A = mkWA (compoundA "nirha" (k38 "laitainen")) ; --UNCHK
lin dentifrice_N = mkWN (compoundN "hammas" (k9 "tahna")) ; --UNCHK
lin dentine_N = mkWN (compoundN "hammas" (k18 "luu")) ; --UNCHK
lin dentist_N = mkWN (compoundN "hammas" (k6 "lääkäri")) ; --UNCHK
lin dentistry_N = mkWN (k12 "odontologia") ; --UNCHK
lin dentition_N = mkWN (k1 "hampaisto") ; --UNCHK
lin denture_N = mkWN (compoundN "hammas" (k6 "proteesi")) ; --UNCHK
lin denudation_N = mkWN (compoundN "paljas" (k38 "taminen")) ; --UNCHK
lin denude_V2 = mkWV2 (k73A "hakata") "paljaaksi" ; --UNCHK
lin denunciation_N = mkWN (k9A "paheksunta") "julkinen" ; --UNCHK
lin denver_PN = foreignPN "Denver" ;
lin deny_V2 = mkWV2 (k53 "kiistää") ; --f84
lin deny_V3 = mkWV3 (k53 "kiistää") ; --UNCHK
lin deodar_N = mkWN (compoundN "himalajan" (k5 "setri")) ; --UNCHK
lin deodorant_N = mkWN (k5A "deodorantti") ; --UNCHK
lin deodorize_V2 = mkWV2 (k53 "poistaa") "haju" ; --UNCHK
lin deossification_N = mkWN (compoundN "luu" (k1A "kato")) ; --UNCHK
lin deoxyadenosine_N = mkWN "deoksiadenosiini" ; --UNCHK
lin deoxycytidine_N = mkWN "deoksisytidiini" ; --UNCHK
lin deoxyguanosine_N = mkWN "deoksiguanosiini" ; --UNCHK
lin deoxyribose_N = mkWN "deoksiriboosi" ; --UNCHK
lin deoxythymidine_N = mkWN "tymidiini" ; --UNCHK
lin depart_V = mkWV (k52 "poistua") ;
lin departed_N = mkWN (k39 "vapautus") ; --UNCHK
lin departer_N = mkWN (k12 "lähtijä") ; --UNCHK
lin department_N = mkN "osasto" | mkN "laitos" ; ---- split
lin departmental_A = mkWA "osaston" ; --UNCHK
lin departure_N = mkN "lähtö" ;
lin depend_V = mkV "riippua" ;
lin dependability_N = mkWN (k40 "luotettavuus") ; --UNCHK
lin dependable_A = mkWA (k10 "luotettava") ; --UNCHK
lin dependant_N = mkWN (k10 "oleva") "riippuvuussuhteessa" ; --UNCHK
lin dependence_N = mkWN (k40 "riippuvuus") ;
lin dependency_N = mkWN (compoundN "alus" (k18 "maa")) ; --UNCHK
lin dependent_A = mkWA (k10 "oleva") "riippuvuussuhteessa" ; --UNCHK
lin dependent_N = mkWN (k10 "oleva") "riippuvuussuhteessa" ; --UNCHK
lin depending_A = variants {} ; --
lin depersonalization_N = mkWN "yksilöllisyyden" "riistäminen" ; --UNCHK
lin depict_V2 = mkWV2 (k53A "hahmottaa") ; --UNCHK
lin depicting_N = mkWN (k10 "kuva") ; --UNCHK
lin depiction_N = mkWN (k10 "kuva") ; --UNCHK
lin depigmentation_N = mkWN (compoundN "pigmentin" (k1A "kato")) ; --UNCHK
lin depilation_N = mkWN (compoundN "karvan" (k1 "poisto")) ; --UNCHK
lin depilatory_A = mkWA "ihokarvoja" "poistava" ; --UNCHK
lin depilatory_N = mkWN (compoundN "karvanpoisto" (k48 "aine")) ; --UNCHK
lin depilous_A = mkWA "karvaton" ; --UNCHK
lin deplane_V = mkWV (k66 "nousta") "lentokoneesta" ; --UNCHK
lin depletable_A = mkWA (k10 "oleva") "hävitettävissä" ; --UNCHK
lin deplete_V2 = mkWV2 (k53A "kuluttaa") "loppuun" ; --UNCHK
lin depletion_N = mkWN "tyhjentäminen" ;
lin deplorable_A = mkWA (k38 "surullinen") ; --UNCHK
lin deplore_V2 = mkWV2 (k52 "paheksua") ; --UNCHK
lin deploy_V = mkWV (k53A "sijoittaa") ; --UNCHK
lin deploy_V2 = mkWV2 (k53A "sijoittaa") ; --UNCHK
lin deployment_N = mkWN (k2 "asettelu") "joukkojen" ; --UNCHK
lin depolarization_N = mkWN "depolarisaatio" ; --UNCHK
lin deponent_N = mkWN (k10 "todistaja") ; --UNCHK
lin depopulate_V2 = mkWV2 (k53A "hävittää") "asukkaat" ; --UNCHK
lin depopulation_N = mkWN (compoundN "autio" (k38 "ituminen")) ; --UNCHK
lin deport_V2 = mkWV2 (k53A "karkottaa") ; --UNCHK
lin deportation_N = mkWN (k39 "karkotus") ; --UNCHK
lin deportee_N = mkWN (k2 "henkilö") "karkotettu" ; --UNCHK
lin deportment_N = mkWN (k9A "toiminta") ; --UNCHK
lin depose_V = mkWV (k53 "todistaa") "valaehtoisesti" ; --UNCHK
lin depose_V2 = mkWV2 (k53 "todistaa") "valaehtoisesti" ; --UNCHK
lin deposit_N = mkN "takuusumma" ; ---??
lin deposit_V2 = mkWV2 (k56A "laittaa") ; --UNCHK
lin deposition_N = mkWN (compoundN "viralta" (k1 "pano")) ; --UNCHK
lin depositor_N = mkWN (k10 "tallettaja") ; --UNCHK
lin depository_N = mkN (lin NK {s = d02 "varasto"}) ;
lin depot_N = mkWN (k2 "varasto") ; --UNCHK
lin deprave_V2 = mkWV2 (k53A "johtaa") "harhaan" ; --UNCHK
lin depravity_N = mkWN (k40 "halpamaisuus") ; --UNCHK
lin deprecate_V2 = mkWV2 (k67A "kohdella") "halveksivasti" ; --UNCHK
lin deprecation_N = mkWN (k9A "paheksunta") ; --UNCHK
lin deprecative_A = mkWA "paheksuva" ; --UNCHK
lin depreciate_V = mkWV (k52A "devalvoitua") ; --UNCHK
lin depreciate_V2 = mkWV2 (k52A "devalvoitua") ; --UNCHK
lin depreciation_N = mkWN (k1 "lasku") "arvon" ; --UNCHK
lin depreciatory_A = mkWA (compoundA "halveks" (k9 "iva")) ; --UNCHK
lin depredation_N = mkWN (compoundN "rosvo" (k38 "aminen")) ; --UNCHK
lin depress_V2 = mkV2 (mkV (mkV "painaa") "alaspäin") ;
lin depressant_A = mkWA "ruumiintoimintoja" "hidastava" ; --UNCHK
lin depressed_A = variants {} ; --
lin depressing_A = mkWA (k34A "iloton") ; --UNCHK
lin depression_N = mkWN (compoundN "pai" (k38 "naminen")) ; --UNCHK
lin depressor_N = mkWN (k48A "laite") "alas" "painava" ; --UNCHK
lin deprivation_N = mkWN (k48A "puute") ; --UNCHK
lin deprive_V2 = mkWV2 (k53A "köyhdyttää") ; --UNCHK
lin depth_N = mkWN (k40 "syvyys") ;
lin depth_bomb_N = mkWN (k5 "syvyyspommi") ; --UNCHK
lin depth_charge_N = mkWN (k5 "syvyyspommi") ; --UNCHK
lin deputation_N = mkWN "valtuuttaminen" ; --UNCHK
lin depute_V2 = mkWV2 (k73 "määrätä") "tehtävään" ; --UNCHK
lin deputize_V = mkWV (k73 "määrätä") "sijaiseksi" ; --UNCHK
lin deputy_N = mkN "sijainen" ;
lin derail_V2 = mkWV2 (k52 "suistua") "[raiteilta]" ; --UNCHK
lin derailment_N = mkWN "raiteilta" "suistuminen" ; --UNCHK
lin derange_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin derangement_N = mkWN (k39 "järkytys") ; --UNCHK
lin derby_N = mkWN (k5 "knalli") ; --UNCHK
lin derby_PN = foreignPN "Derby" ;
lin deregulate_V2 = mkWV2 (k53 "poistaa") "sääntely" ; --UNCHK
lin deregulation_N = mkWN (compoundN "pois" (k38 "taminen")) "sääntelyn" ; --UNCHK
lin derelict_A = mkWA (k38 "rähjäinen") ; --UNCHK
lin derelict_N = mkWN (k1A "hylky") ; --UNCHK
lin dereliction_N = mkWN (compoundN "laimin" (k5A "lyönti")) ; --UNCHK
lin derestrict_V2 = mkWV2 (k53 "poistaa") "rajoitukset" ; --UNCHK
lin deride_V2 = mkWV2 (k73A "pilkata") ; --UNCHK
lin derision_N = mkWN (kH1 "pilkka") ; --UNCHK
lin derisive_A = mkWA (k38 "pilkallinen") ; --UNCHK
lin derisory_A = mkWA (k34A "posketon") ; --UNCHK
lin derivable_A = mkWA (k10 "oleva") "johdettavissa" ; --UNCHK
lin derivation_N = mkWN "johtuminen" ; --UNCHK
lin derivational_A = mkWA (compoundA "johde" (k1 "ttu")) ; --UNCHK
lin derivative_A = mkWA (compoundA "johde" (k1 "ttu")) ; --UNCHK
lin derivative_N = mkWN (k9A "derivaatta") ; --UNCHK
lin derive_V = mkWV (k52A "kehittyä") ; --UNCHK
lin derive_V2 = mkV2 "johtaa" ;
lin dermabrasion_N = mkWN (k9A "hionta") "ihon" ; --UNCHK
lin dermal_A = mkWA (compoundA "kuta" (k38 "aninen")) ; --UNCHK
lin dermatitis_N = mkWN (k10 "ihottuma") ; --UNCHK
lin dermatoglyphic_N = mkWN (compoundN "iho" (k9 "piena")) ; --UNCHK
lin dermatoglyphics_N = mkWN (k39 "tutkimus") "ihopienojen" ; --UNCHK
lin dermatologic_A = mkWA "ihotauti-" ; --UNCHK
lin dermatologistFem_N = variants {} ; ---- sense to be split
lin dermatologistMasc_N = mkWN (compoundN "ihotauti" (k6 "lääkäri")) ; --UNCHK
lin dermatology_N = mkWN (k12 "dermatologia") ; --UNCHK
lin dermatome_N = mkWN (compoundN "ihonsiirto" (k48 "koje")) ; --UNCHK
lin dermatomycosis_N = mkWN "dermatofytoosi" ; --UNCHK
lin dermatomyositis_N = mkWN "dermatomyosiitti" ; --UNCHK
lin dermatosis_N = mkWN (compoundN "iho" (k5A "tauti")) ; --UNCHK
lin dermis_N = mkWN (compoundN "veri" (k9 "nahka")) ; --UNCHK
lin derogate_V = mkWV (k54A "halventaa") ; --UNCHK
lin derogation_N = mkWN (k39 "poikkeus") ; --UNCHK
lin derogative_A = mkWA (compoundA "halveks" (k9 "iva")) ; --UNCHK
lin derogatory_A = mkWA (compoundA "halveks" (k9 "iva")) ; --UNCHK
lin derrick_N = mkWN (k6 "nosturi") ; --UNCHK
lin derringer_N = mkWN (compoundN "tasku" (k6 "pistooli")) ; --UNCHK
lin derris_N = mkWN "Derris" ; --UNCHK
lin derv_N = mkWN (compoundN "diesel" (k1 "öljy")) ; --UNCHK
lin dervish_N = mkWN (compoundN "der" (k5 "vissi")) ; --UNCHK
lin des_N = mkWN "DES" ; --UNCHK
lin desalinate_V2 = mkWV2 (k53 "poistaa") "suola" ; --UNCHK
lin desalination_N = mkWN (compoundN "suolan" (k1 "poisto")) ; --UNCHK
lin desalinization_N = mkWN (compoundN "suolan" (k1 "poisto")) ; --UNCHK
lin desalinize_V2 = mkWV2 (k53 "poistaa") "suola" ; --UNCHK
lin desalt_V2 = mkWV2 (k53 "poistaa") "suola" ; --UNCHK
lin descale_V2 = mkWV2 (k53 "suomustaa") ; --UNCHK
lin descant_N = mkWN (k39 "säestys") "improvisoitu" ; --UNCHK
lin descend_V = mkWV (k52A "laskeutua") ; --UNCHK
lin descend_V2 = mkWV2 (k52A "laskeutua") ; --UNCHK
lin descendant_A = mkWA "periytyvä" ; --UNCHK
lin descendant_N = mkWN (k29 "lapsi") ; --UNCHK
lin descender_N = mkWN (compoundN "ala" (k14A "silmukka")) ; --UNCHK
lin descent_N = mkWN (k1 "lasku") ; --UNCHK
lin describable_A = mkWA (k10 "oleva") "kuvattavissa" ; --UNCHK
lin describe_V2 = mkV2 (mkV "kuvailla") partitive ;
lin describe_VS = mkVS (mkV "kuvailla") ;
lin description_N = mkWN (k5 "laji") ; --UNCHK
lin descriptive_A = mkWA (k38 "deskriptiivinen") ; --UNCHK
lin descriptivism_N = mkWN (compoundN "deskriptiv" (k5 "ismi")) ; --UNCHK
lin descriptor_N = mkWN "määrittelijä" ; --UNCHK
lin descry_V2 = mkWV2 (k73 "bongata") ; --UNCHK
lin desecrate_V2 = mkWV2 (k62 "sekularisoida") ; --UNCHK
lin desecration_N = mkWN (k39 "häväistys") ; --UNCHK
lin desegrated_A = mkWA "ilman" "rotuerottelua" ; --UNCHK
lin desegregate_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin desegregation_N = mkWN (k3 "integraatio") ; --UNCHK
lin desensitization_N = mkWN "siedättäminen" ; --UNCHK
lin desensitize_V2 = mkWV2 (k53A "turruttaa") ; --UNCHK
lin desensitizing_A = mkWA (k10 "tekevä") "tunnottomaksi" ; --UNCHK
lin desert_N = mkWN (k4A "aavikko") ; --UNCHK
lin desert_V = mkWV (k53A "jättää") "heitteille" ; --UNCHK
lin desert_V2 = mkWV2 (k53A "jättää") "heitteille" ; --UNCHK
lin deserter_N = mkWN (k6 "loikkari") ; --UNCHK
lin desertification_N = mkWN "aavikoituminen" ; --UNCHK
lin desertion_N = mkWN "hylkääminen" ; --UNCHK
lin deserts_N = mkWN (k39 "seuraus") "ansaittu" ; --UNCHK
lin deserve_V = mkWV (k69 "ansaita") ; --UNCHK
lin deserve_V2 = mkWV2 (k69 "ansaita") ; --UNCHK
lin deserve_VV = mkWVV (k69 "ansaita") ; --UNCHK
lin deservedly_Adv = mkWAdv (k99 "ansaitusti") ; --UNCHK
lin deservingness_N = mkWN (k3 "ansio") ; --UNCHK
lin deshabille_N = mkWN (k99 "puolipukeissa") ; --UNCHK
lin desiccant_N = mkWN (k5 "sikkatiivi") ; --UNCHK
lin desiccate_V2 = mkWV2 (k52 "kuivua") ; --UNCHK
lin desideratum_N = mkWN (k48 "toive") ; --UNCHK
lin design_N = mkN "muotoilu" | mkN "design" "designin" "designia" "designina" "designiin" "designien" "designeja" "designeina" "designeissa" "designeihin" ;
lin design_V = mkV "muotoilla" ;
lin design_V2 = mkV2 "muotoilla" ;
lin designate_A = mkWA (compoundA "nimi" (k1 "tetty")) "tehtävään" ; --UNCHK
lin designate_V = mkWV (k54A "täsmentää") ; --UNCHK
lin designate_V2 = mkV2 "nimittää" ; --mkWV2 (k54A "täsmentää") ;
lin designate_V2V = mkV2V (mkV "osoittaa") accusative infIness ; --mkWV2V (k54A "täsmentää")
lin designate_VS = mkWVS (k54A "täsmentää") ; --UNCHK
lin designation_N = mkN (lin NK {s = d39 "nimitys"}) ;
lin designative_A = mkWA "osoittava" ; --UNCHK
lin designatum_N = mkWN (k48A "kohde") "nimeämisen" ; --UNCHK
lin designedly_Adv = mkWAdv (k99 "vasten") "varta" ; --UNCHK
lin designer_N = mkWN (k12 "suunnittelija") ; --UNCHK
lin designing_N = mkWN (compoundN "suu" (k38 "nnitteleminen")) ; --UNCHK
lin desipramine_N = mkWN "desipramiini" ; --UNCHK
lin desirability_N = mkWN (k40 "seksikkyys") ; --UNCHK
lin desirable_A = mkWA (k10 "toivottava") ;
lin desire_N = mkWN (k1 "himo") ;
lin desire_V2 = mkV2 "haluta" partitive ; --mkWV2 (k61 "mieliä") ;
lin desired_A = mkA "haluttu" ;
lin desirous_A = mkWA (k41A "toiveikas") ; --UNCHK
lin desist_V = mkWV (k52A "pidättäytyä") ; --UNCHK
lin desk_N = mkWN (compoundN "työ" (k10A "pöytä")) ;
lin desktop_N = mkWN (k9 "tausta") ; --UNCHK
lin desmid_N = mkWN (compoundN "koru" (k10 "levä")) ; --UNCHK
lin desolate_A = mkWA (k34A "lohduton") ; --UNCHK
lin desolate_V2 = mkWV2 (k53 "kylvää") "tuhoa" ; --UNCHK
lin desolation_N = mkWN (k39 "hävitys") ; --UNCHK
lin desorption_N = mkWN "desorptio" ; --UNCHK
lin despair_N = mkWN (compoundN "epä" (k1 "toivo")) ; --UNCHK
lin despair_V = mkWV (k53A "menettää") "toivonsa" ; --UNCHK
lin despairingly_Adv = mkWAdv (k99 "toivottomasti") ; --UNCHK
lin despatch_N = mkWN (k39 "toimitus") ; --UNCHK
lin desperate_A = mkA "epätoivoinen" ;
lin desperate_N = mkWN (k38 "ihminen") "epätoivoinen" ; --UNCHK
lin desperation_N = mkWN (k40 "rämäpäisyys") ; --UNCHK
lin despicable_A = mkWA (k10 "katala") ; --UNCHK
lin despisal_N = mkWN (k10A "halveksunta") ; --UNCHK
lin despise_V2 = mkWV2 (k52 "halveksua") ; --UNCHK
lin despite_N = mkWN (k10A "halveksunta") ; --UNCHK
lin despite_Prep = postPrep elative "huolimatta" ;
lin despiteful_A = mkWA (k15 "ilkeä") ; --UNCHK
lin despoil_V2 = mkWV2 (k73 "ryövätä") ; --UNCHK
lin despondency_N = mkWN (k40 "lohduttomuus") ; --UNCHK
lin despondent_A = mkWA (k38 "epätoivoinen") ; --UNCHK
lin despot_N = mkWN (k5A "despootti") ; --UNCHK
lin despotic_A = mkWA (k38 "despoottinen") ; --UNCHK
lin despotism_N = mkWN (k12 "tyrannia") ; --UNCHK
lin desquamation_N = mkWN (k2 "hilseily") ; --UNCHK
lin dessau_PN = foreignPN "Dessau" ;
lin dessert_N = mkWN (compoundN "jälki" (k10A "ruoka")) ; --UNCHK
lin dessertspoon_N = mkWN (compoundN "jälkiruoka" (k38 "lusikallinen")) ; --UNCHK
lin dessertspoonful_N = mkWN (compoundN "jälkiruoka" (k38 "lusikallinen")) ; --UNCHK
lin dessiatine_N = mkWN "desjatiina" ; --UNCHK
lin destabilization_N = mkWN "horjuttaminen" ; --UNCHK
lin destalinization_N = mkWN (compoundN "destalini" (k5A "sointi")) ; --UNCHK
lin destination_N = mkWN (k48A "tavoite") ;
lin destine_V2 = mkWV2 (k54A "täsmentää") ; --UNCHK
lin destine_V2V = mkWV2V (k54A "täsmentää") ; --UNCHK
lin destiny_N = mkWN (k2 "kohtalo") ; --UNCHK
lin destitute_A = mkWA (k99 "ilman") ; --UNCHK
lin destitution_N = mkWN (k40 "varattomuus") ; --UNCHK
lin destroy_V2 = mkV2 "hävittää" ;
lin destroyable_A = mkWA (k10 "oleva") "tuhottavissa" ; --UNCHK
lin destroyer_N = mkWN (k10 "hävittäjä") ; --UNCHK
lin destructibility_N = mkWN "hävitettävyys" ; --UNCHK
lin destruction_N = mkWN (compoundN "tuho" (k38 "aminen")) ; --UNCHK
lin destructive_A = mkWA (k10 "tuhoisa") ; --UNCHK
lin destructiveness_N = mkWN (k40 "tuhoisuus") ; --UNCHK
lin desuetude_N = mkWN "käyttämättömyys" ; --UNCHK
lin desultory_A = mkWA "hyppelehtivä" ; --UNCHK
lin detach_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin detachable_A = mkWA "irrotettava" ; --UNCHK
lin detachment_N = mkWN (compoundN "ero" (k38 "ttaminen")) ; --UNCHK
lin detail_N = mkN "yksityiskohta" ;
lin detail_V2 = mkV2 "eritellä" ;
lin detailed_A = mkA "yksityiskohtainen" ;
lin details_N = mkWN (k1A "tieto") "sisäpiirin" ; --UNCHK
lin detain_V2 = mkWV2 (k53A "viivästyttää") ; --UNCHK
lin detainee_N = mkWN (k5A "vanki") "poliittinen" ; --UNCHK
lin detect_V2 = mkWV2 (k73 "huomata") ; --UNCHK
lin detectable_A = mkWA (k10 "oleva") "havaittavissa" ; --UNCHK
lin detection_N = mkWN "löytäminen" ; --UNCHK
lin detective_N = mkWN (k10 "etsivä") ;
lin detector_N = mkWN (k33 "aistin") ; --UNCHK
lin detente_N = mkWN (k39 "liennytys") ; --UNCHK
lin detention_N = mkWN (compoundN "jälki-" (k1A "istunto")) ; --UNCHK
lin deter_V2 = mkWV2 (k63 "saada") "luopumaan" ; --UNCHK
lin detergency_N = mkWN (compoundN "puhdistus" (k1A "kyky")) ; --UNCHK
lin detergent_A = mkWA "puhdistava" ; --UNCHK
lin detergent_N = mkWN (compoundN "pesu" (k48 "aine")) ; --UNCHK
lin deteriorate_V = mkWV (k72A "heiketä") ; --UNCHK
lin deteriorate_V2 = mkWV2 (k72A "heiketä") ; --UNCHK
lin deterioration_N = mkWN (k3 "rappio") ; --UNCHK
lin determent_N = mkWN (k2 "uhkailu") ; --UNCHK
lin determinable_A = mkWA (k10 "oleva") "rajattavissa" ; --UNCHK
lin determinant_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin determinant_N = mkWN (k12 "tekijä") "syynä" "oleva" ; --UNCHK
lin determinate_A = mkWA (k1A "määrätty") ; --UNCHK
lin determinateness_N = mkWN (k40 "ehdottomuus") ; --UNCHK
lin determination_N = mkN "päättäväisyys" ;
lin determinative_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin determinative_N = mkWN (k12 "tekijä") "syynä" "oleva" ; --UNCHK
lin determine_V = mkV "määrätä" | mkV "päättää" ;
lin determine_V2 = mkV2 "päättää" | mkV2 "määrätä" ;
lin determine_V2V = mkV2V (mkV "päättää") genitive infPresPart ;
lin determine_VS = mkVS (mkV "päättää") ;
lin determine_VV = mkVV "päättää" ;
lin determined_A = variants {} ; --
lin determiner_N = mkWN (k12 "tekijä") "syynä" "oleva" ; --UNCHK
lin determinism_N = mkWN (k5 "determinismi") ; --UNCHK
lin deterministic_A = mkWA (k38 "deterministinen") ; --UNCHK
lin deterrence_N = mkWN (k2 "pelottelu") ; --UNCHK
lin deterrent_A = mkWA "estävä" ; --UNCHK
lin deterrent_N = mkWN (k48A "rasite") ; --UNCHK
lin detest_V2 = mkWV2 (k74 "inhota") ; --UNCHK
lin detestable_A = mkWA (k15 "kauhea") ; --UNCHK
lin detestation_N = mkWN (k39 "iljetys") ; --UNCHK
lin dethrone_V2 = mkWV2 (k70 "syöstä") "vallasta" ; --UNCHK
lin dethronement_N = mkWN (compoundN "viralta" (k1 "pano")) ; --UNCHK
lin detonate_V = mkWV (k53A "pamahtaa") ; --UNCHK
lin detonate_V2 = mkWV2 (k53A "pamahtaa") ; --UNCHK
lin detonation_N = mkWN "räjäyttäminen" ; --UNCHK
lin detonative_A = mkWA "räjähtävä" ; --UNCHK
lin detonator_N = mkWN (k33A "sytytin") ; --UNCHK
lin detour_N = mkWN (compoundN "kierto" (k19 "tie")) ; --UNCHK
lin detour_V2 = mkWV2 (k53A "käyttää") "kiertotietä" ; --UNCHK
lin detox_N = mkWN (compoundN "päihde" (k2 "osasto")) ; --UNCHK
lin detoxification_N = mkWN (compoundN "pois" (k38 "taminen")) "myrkyn" ; --UNCHK
lin detract_V = mkWV (k54A "vähentää") ; --UNCHK
lin detraction_N = mkWN (k39 "parjaus") ; --UNCHK
lin detractive_A = mkWA "vähentävä" ; --UNCHK
lin detractor_N = mkWN (k12 "panettelija") ; --UNCHK
lin detrain_V = mkWV (k66 "nousta") "junasta" ; --UNCHK
lin detrain_V2 = mkWV2 (k66 "nousta") "junasta" ; --UNCHK
lin detribalization_N = mkWN "heimojärjestelmän" "hajoaminen" ; --UNCHK
lin detribalize_V2 = mkWV2 (k53A "hävittää") "heimoidentiteetti" ; --UNCHK
lin detriment_N = mkWN (k9A "haitta") ; --UNCHK
lin detrimental_A = mkWA (k38 "haitallinen") ; --UNCHK
lin detritus_N = mkWN "detritus" ; --UNCHK
lin detroit_PN = foreignPN "Detroit" ;
lin detumescence_N = mkWN (compoundN "lie" (k38 "veneminen")) "turvotuksen" ; --UNCHK
lin deuce_N = mkWN (k38 "kakkonen") ; --UNCHK
lin deuced_A = mkWA (k38 "pirunmoinen") ; --UNCHK
lin deuteranopia_N = mkWN (compoundN "viher" (k40 "sokeus")) ; --UNCHK
lin deuteranopic_A = mkWA (compoundA "viher" (k15 "sokea")) ; --UNCHK
lin deuterium_N = mkWN (k1A "vety") "raskas" ; --UNCHK
lin deuteron_N = mkWN "deuteroni" ; --UNCHK
lin deutschmark_N = mkWN (k9A "markka") "Saksan" ; --UNCHK
lin deutzia_N = mkWN (compoundN "nietos" (k41 "pensas")) ; --UNCHK
lin devaluate_V2 = mkWV2 (k52A "devalvoitua") ; --UNCHK
lin devaluation_N = mkN "devalvaatio" ; --WN (compoundN "ale" (k38 "neminen")) "arvon" ;
lin devalue_V2 = mkWV2 (k52A "devalvoitua") ; --UNCHK
lin devastate_V2 = mkV2 "musertaa" ; --mkWV2 (k52A "musertua") ;
lin devastation_N = mkN "tuho" ; --mkWN (compoundN "tuho" (k38 "aminen")) ;
lin develop_V = mkV "kehittyä" ;
lin develop_V2 = mkV2 "kehittää" ;
lin developed_A = mkA "kehittynyt" ;
lin developer_N = mkN "kehittäjä" ;
lin developing_A = mkA "kehittyvä" ;
lin development_N = mkN "kehitys" ;
lin developmental_A = mkWA "kehitys-" ; --UNCHK
lin deviant_A = mkWA (k10 "poikkeava") ; --UNCHK
lin deviant_N = mkWN (k1 "pervo") ; --UNCHK
lin deviate_V = mkWV (k52A "kääntyä") "toisaalle" ; --UNCHK
lin deviation_N = mkN "poikkeama" ; --mkWN (compoundN "kierto" (k19 "tie")) ;
lin deviationist_N = mkWN (compoundN "toisin" (k12 "ajattelija")) ; --UNCHK
lin device_N = mkN "laite" ;
lin devil_N = mkWN (k48 "perkele") ; --UNCHK
lin devil_V = mkWV (k56 "maustaa") "voimakkaasti" ; --UNCHK
lin devil_V2 = mkWV2 (k56 "maustaa") "voimakkaasti" ; --UNCHK
lin devilish_A = mkWA (k38 "saatanallinen") ; --UNCHK
lin devilish_Adv = mkWAdv (compoundAdv "pahuk" (k99 "sen")) ; --UNCHK
lin devilment_N = mkWN (k10 "jäynä") ; --UNCHK
lin devilry_N = mkWN (k10 "jäynä") ; --UNCHK
lin deviltry_N = mkWN (k10 "jäynä") ; --UNCHK
lin devilwood_N = mkWN (compoundN "tuoksu" (k41 "pensas")) ; --UNCHK
lin devious_A = mkWA (k10 "poikkeava") ; --UNCHK
lin deviousness_N = mkWN (k40 "kieroutuneisuus") ; --UNCHK
lin devisal_N = mkWN (compoundN "keksi" (k38 "minen")) ; --UNCHK
lin devise_N = mkWN (k39 "testamenttaus") ; --UNCHK
lin devise_V2 = mkV2 "keksiä" ; --WV2 (k73A "kekata") ;
lin devisee_N = mkWN (compoundN "testamentin" (k10 "saaja")) ; --UNCHK
lin devising_N = mkWN (k1A "tuotanto") ; --UNCHK
lin devisor_N = mkWN (k12 "tekijä") "testamentin" ; --UNCHK
lin devitalization_N = mkWN "näivettäminen" ; --UNCHK
lin devitalize_V2 = mkWV2 (k54A "heikentää") ; --UNCHK
lin devizes_PN = foreignPN "Devizes" ;
lin devoid_A = mkWA (k99 "ilman") ; --UNCHK
lin devoir_N = mkWN (compoundN "kohteliaisuuden" (k39 "osoitus")) ; --UNCHK
lin devolution_N = mkWN (k1A "siirto") "tehtävien" ; --UNCHK
lin devolve_V = mkWV (k72A "heiketä") ; --UNCHK
lin devolve_V2 = mkWV2 (k72A "heiketä") ; --UNCHK
lin devon_PN = foreignPN "Devon" ;
lin devote_V2 = mkV2 "omistaa" ;
lin devoted_A = variants {} ; --
lin devotee_N = mkWN (k5A "friikki") ; --UNCHK
lin devotion_N = mkWN (compoundN "hartauden" (k39 "harjoitus")) ; --UNCHK
lin devotional_A = mkWA (k41A "harras") ; --UNCHK
lin devotional_N = mkWN (compoundN "hartaus" (k7 "hetki")) ; --UNCHK
lin devour_V2 = mkWV2 (k64 "syödä") ; --UNCHK
lin devourer_N = mkWN (k5A "ahmatti") ; --UNCHK
lin devout_A = mkWA (k10 "jumalaapelkäävä") ; --UNCHK
lin devoutness_N = mkWN (k40 "hengellisyys") ; --UNCHK
lin devries_N = mkWN (compoundN "deVr" (k41A "ies")) "Hugo" ; --UNCHK
lin dew_N = mkWN (k48 "kaste") ; --UNCHK
lin dewberry_N = mkWN (compoundN "sini" (k14A "vatukka")) ; --UNCHK
lin dewdrop_N = mkWN (compoundN "kaste" (k12 "pisara")) ; --UNCHK
lin dewlap_N = mkWN (compoundN "kaula" (k9 "nahka")) ; --UNCHK
lin dewsbury_PN = foreignPN "Dewsbury" ;
lin dewy_A = mkWA (k38 "kasteinen") ; --UNCHK
lin dexamethasone_N = mkWN "Oradexon" ; --UNCHK
lin dexter_A = mkWA (compoundA "oikean" (k38 "puoleinen")) ; --UNCHK
lin dexterity_N = mkWN (k40 "taitavuus") ; --UNCHK
lin dexterous_A = mkWA (k10 "kätevä") ; --UNCHK
lin dextral_A = mkWA (compoundA "oikean" (k38 "puoleinen")) ; --UNCHK
lin dextrin_N = mkWN "dekstriini" ; --UNCHK
lin dextrorotary_A = mkWA "oikealle" "kääntyvä" ; --UNCHK
lin dextrorotation_N = mkWN "myötäpäivään" "kiertäminen" ; --UNCHK
lin dextrorse_A = mkWA (compoundA "oikea" (k38 "kierteinen")) ; --UNCHK
lin dextrose_N = mkWN (compoundN "rypäle" (k6 "sokeri")) ; --UNCHK
lin dextrous_A = mkWA (k10 "kätevä") ; --UNCHK
lin dhak_N = mkWN (compoundN "mono" (k9 "sperma")) "Butea" ; --UNCHK
lin dhawa_N = mkWN "dhava" ; --UNCHK
lin dhole_N = mkWN (compoundN "vuori" (k27 "susi")) ; --UNCHK
lin dhoti_N = mkWN "dhoti" ; --UNCHK
lin dhow_N = mkWN (compoundN "rannikko" (k39 "alus")) ; --UNCHK
lin diabatic_A = mkWA (compoundA "dia" (k38 "baattinen")) ; --UNCHK
lin diabetes_N = mkWN (k39 "diabetes") ; --UNCHK
lin diabetic_A = mkWA (compoundA "diab" (k38 "eettinen")) ; --UNCHK
lin diabetic_N = mkWN (k4A "diabeetikko") ;
lin diabolatry_N = mkWN (k5 "satanismi") ; --UNCHK
lin diabolic_A = mkWA (k34A "jumalaton") ; --UNCHK
lin diabolical_A = mkWA (k34A "jumalaton") ; --UNCHK
lin diabolism_N = mkWN (k5 "satanismi") ; --UNCHK
lin diachronic_A = mkWA (k38 "historiallinen") ; --UNCHK
lin diacritic_A = mkWA (compoundA "dia" (k38 "kriittinen")) ; --UNCHK
lin diacritic_N = mkWN (k48A "tarke") ; --UNCHK
lin diacritical_A = mkWA (compoundA "dia" (k38 "kriittinen")) ; --UNCHK
lin diadem_N = mkWN (k5 "diadeemi") ; --UNCHK
lin diadromous_A = mkWA (compoundA "dia" (k38 "drominen")) ; --UNCHK
lin diaeresis_N = mkWN (k9 "treema") ; --UNCHK
lin diagnosable_A = mkWA "diagnosoitava" ; --UNCHK
lin diagnose_V2 = mkWV2 (k53A "määrittää") "tauti" ; --UNCHK
lin diagnosis_N = mkWN (k5 "diagnoosi") ; --UNCHK
lin diagnostic_A = mkWA (k38 "diagnostinen") ;
lin diagnostician_N = mkWN (k5 "patologi") ; --UNCHK
lin diagonal_A = mkWA (k1 "vino") ; --UNCHK
lin diagonal_N = mkWN (k50 "vinoviiva") ; --UNCHK
lin diagonalizable_A = mkWA "diagonalisoitava" ; --UNCHK
lin diagonalization_N = mkWN (compoundN "diagonali" (k5A "sointi")) ; --UNCHK
lin diagram_N = mkWN (k3 "kaavio") ; --UNCHK
lin diakinesis_N = mkWN "diakineesi" ; --UNCHK
lin dial_N = mkWN (compoundN "kello" (k1 "taulu")) ; --UNCHK
lin dial_V2 = mkWV2 (k69 "valita") ; --UNCHK
lin dialect_N = mkWN (k39 "korostus") ; --UNCHK
lin dialectal_A = mkWA (k38 "murteellinen") ; --UNCHK
lin dialectic_A = mkWA (k38 "dialektinen") ; --UNCHK
lin dialectic_N = mkWN (k2 "väittely") ; --UNCHK
lin dialectical_A = mkWA (k38 "dialektinen") ; --UNCHK
lin dialectician_N = mkWN "dialektikko" ; --UNCHK
lin dialectics_N = mkWN (k9A "dialektiikka") ; --UNCHK
lin dialectology_N = mkWN (compoundN "murre" (k39 "tutkimus")) ; --UNCHK
lin dialogue_N = mkWN (k5 "dialogi") ; --UNCHK
lin dialysis_N = mkWN (k5 "dialyysi") ; --UNCHK
lin dialyzer_N = mkWN (compoundN "dialyysi" (k48A "laite")) ; --UNCHK
lin diamagnet_N = mkWN (k48 "aine") "diamagneettinen" ; --UNCHK
lin diamagnetic_A = mkWA (compoundA "dia" (k38 "magneettinen")) ; --UNCHK
lin diamagnetism_N = mkWN (compoundN "dia" (k5 "magnetismi")) ; --UNCHK
lin diamante_N = mkWN "strassikoristeltu" ; --UNCHK
lin diamantine_A = mkWA (k38 "timanttinen") ; --UNCHK
lin diameter_N = mkWN (k12 "halkaisija") ; --UNCHK
lin diametral_A = mkWA (compoundA "dia" (k38 "metrinen")) ; --UNCHK
lin diametric_A = mkWA (compoundA "dia" (k38 "metrinen")) ; --UNCHK
lin diamine_N = mkWN "diamiini" ; --UNCHK
lin diamond_N = mkWN (compoundN "sisä" (k10A "kenttä")) ; --UNCHK
lin diamondback_N = mkWN "timanttikalkkarokäärme" ; --UNCHK
lin dianoetic_A = mkWA (compoundA "eritte" (k10 "levä")) ; --UNCHK
lin diapason_N = mkWN (k6 "rekisteri") ; --UNCHK
lin diapedesis_N = mkWN "diapedeesi" ; --UNCHK
lin diapensia_N = mkWN "uuvana" ; --UNCHK
lin diaper_N = mkWN (k9A "vaippa") ; --UNCHK
lin diaphanous_A = mkWA (k43 "ohut") ; --UNCHK
lin diapheromera_N = mkWN (k9A "sauvasirkka") ; --UNCHK
lin diaphone_N = mkWN (k6 "sumusireeni") "kaksiääninen" ; --UNCHK
lin diaphoretic_N = mkWN "hikoilua" "edistävä" ; --UNCHK
lin diaphragm_N = mkWN (k33A "himmennin") ; --UNCHK
lin diaphyseal_A = mkWA (compoundA "dia" (k38 "fyysinen")) ; --UNCHK
lin diaphysis_N = mkWN (compoundN "luun" (k28 "varsi")) ; --UNCHK
lin diapir_N = mkWN (compoundN "dia" (k5 "piiri")) ; --UNCHK
lin diapsid_N = mkWN (k12 "matelija") ; --UNCHK
lin diarchy_N = mkWN (compoundN "kaksin" (k9A "valta")) ; --UNCHK
lin diarist_N = mkWN (k10 "pitäjä") "päiväkirjan" ; --UNCHK
lin diarrhea_N = mkWN (k6 "ripuli") ; --UNCHK
lin diarrheal_A = mkWA (k38 "ripulinen") ; --UNCHK
lin diarrhoea_N = mkWN (k6 "ripuli") ; --UNCHK
lin diary_N = mkWN (k6 "päivyri") ; --UNCHK
lin diaspora_N = mkWN (k10 "diaspora") ; --UNCHK
lin diastema_N = mkWN (compoundN "hammas" (k10 "loma")) ; --UNCHK
lin diastole_N = mkWN (compoundN "lepo" (k48 "vaihe")) ; --UNCHK
lin diastolic_A = mkWA (k38 "diastolinen") ; --UNCHK
lin diastrophism_N = mkWN (compoundN "deformaatio" (k5 "prosessi")) "maan" "kuoren" ; --UNCHK
lin diathermy_N = mkWN "diatermia" ; --UNCHK
lin diathesis_N = mkWN (k39 "taipumus") ; --UNCHK
lin diatom_N = mkWN (kH1 "piilevä") ; --UNCHK
lin diatomic_A = mkWA (compoundA "kaks" (k38 "iatominen")) ; --UNCHK
lin diatonic_A = mkWA (k38 "diatoninen") ; --UNCHK
lin diatribe_N = mkWN (k39 "hyökkäys") "kiivas" "sanallinen" ; --UNCHK
lin diazepam_N = mkWN (k5 "diatsepaami") ; --UNCHK
lin diazo_A = mkWA "diatso-" ; --UNCHK
lin diazonium_N = mkWN "diatsonium" ; --UNCHK
lin diazoxide_N = mkWN (compoundN "diats" (k5 "oksidi")) ; --UNCHK
lin dibber_N = mkWN (compoundN "istutus" (k1A "puikko")) ; --UNCHK
lin dibble_N = mkWN (compoundN "istutus" (k1A "puikko")) ; --UNCHK
lin dibble_V2 = mkWV2 (k53A "rei'ittää") ; --UNCHK
lin dibranchiate_N = mkWN (k38 "nilviäinen") "kaksikiduksinen" ; --UNCHK
lin dibs_N = mkWN (k39 "varaus") ; --UNCHK
lin dibucaine_N = mkWN "dibukaiini" ; --UNCHK
lin dicamptodon_N = mkWN (k6 "salamanteri") ; --UNCHK
lin dicarboxylic_A = mkWA "dikarboksyyli-" ; --UNCHK
lin dice_N = mkWN (k10A "noppa") ; --UNCHK
lin dice_V = mkWV (k53A "heittää") "noppaa" ; --UNCHK
lin dice_V2 = mkWV2 (k53A "heittää") "noppaa" ; --UNCHK
lin dice_box_N = mkWN (compoundN "noppa" (k6 "pikari")) ; --UNCHK
lin dicer_N = mkWN (k6 "leikkuri") ; --UNCHK
lin dicey_A = mkWA (k38 "vaarallinen") ; --UNCHK
lin dichloride_N = mkWN "dikloridi" ; --UNCHK
lin dichlorodiphenyltrichloroethane_N = mkWN (compoundN "diklooridifenyylitrikloori" (k5 "etaani")) ; --UNCHK
lin dichondra_N = mkWN (compoundN "pikku" (k9 "vitja")) ; --UNCHK
lin dichotomization_N = mkWN (compoundN "kahtia" (k1A "jako")) ; --UNCHK
lin dichotomous_A = mkWA (compoundA "kaks" (k38 "ijakoinen")) ; --UNCHK
lin dichotomy_N = mkWN (k40 "kaksijakoisuus") ; --UNCHK
lin dichroism_N = mkWN (compoundN "kaksi" (k40 "värisyys")) ; --UNCHK
lin dichromacy_N = mkWN (compoundN "väri" (k40 "sokeus")) "osittainen" ; --UNCHK
lin dichromat_N = mkWN "osittaisvärisokea" ; --UNCHK
lin dichromatic_A = mkWA (compoundA "kaksiväri" (k38 "näköinen")) ; --UNCHK
lin dick_N = mkN "kulli" ;
lin dickens_N = mkWN (k48 "perkele") ; --UNCHK
lin dicker_V = mkWV (k52 "hieroa") "kauppoja" ; --UNCHK
lin dickey_N = mkWN (compoundN "irto" (k39 "etumus")) ; --UNCHK
lin dickeybird_N = mkWN (k1 "tipu") ; --UNCHK
lin dicky_A = mkWA (k1A "heikko") ; --UNCHK
lin dicky_N = mkWN (compoundN "irto" (k39 "etumus")) ; --UNCHK
lin dickybird_N = mkWN (k1 "tipu") ; --UNCHK
lin diclinous_A = mkWA (compoundA "yksineu" (k38 "voinen")) ; --UNCHK
lin dicloxacillin_N = mkWN "Dynapen" ; --UNCHK
lin dicot_N = mkWN (compoundN "kaks" (k38 "isirkkainen")) ; --UNCHK
lin dicotyledonous_A = mkWA (compoundA "kaks" (k38 "isirkkainen")) ; --UNCHK
lin dictaphone_N = mkWN (compoundN "sanelu" (k48 "kone")) ; --UNCHK
lin dictate_N = mkWN (compoundN "ohje" (k10 "nuora")) ; --UNCHK
lin dictate_V = mkWV (k67 "sanella") ; --UNCHK
lin dictate_V2 = mkWV2 (k67 "sanella") ; --UNCHK
lin dictate_VS = mkWVS (k67 "sanella") ; --UNCHK
lin dictation_N = mkWN (k2 "sanelu") ; --UNCHK
lin dictator_N = mkWN (k6 "diktaattori") ; --UNCHK
lin dictatorial_A = mkWA (k38 "diktatorinen") ; --UNCHK
lin dictatorship_N = mkWN (k12 "tyrannia") ; --UNCHK
lin diction_N = mkWN (k12 "fraseologia") ; --UNCHK
lin dictionary_N = mkWN (k2 "sanasto") ; --UNCHK
lin dictostylium_N = mkWN (compoundN "lima" (k26 "sieni")) ; --UNCHK
lin dictum_N = mkWN (k10A "lupa") ; --UNCHK
lin dictyopteran_A = mkWA "torakoihin" "liittyvä" ; --UNCHK
lin dicumarol_N = mkWN "dikumariini" ; --UNCHK
lin dicynodont_N = mkWN "dicynodontti" ; --UNCHK
lin didactic_A = mkWA (k38 "didaktinen") ; --UNCHK
lin didacticism_N = mkWN "didaktisuus" ; --UNCHK
lin didcot_PN = foreignPN "Didcot" ;
lin diddle_V2 = mkWV2 (k62 "näpelöidä") ; --UNCHK
lin dideoxycytosine_N = mkWN "DDC" ; --UNCHK
lin dideoxyinosine_N = mkWN "DDI" ; --UNCHK
lin die_N = mkWN (k10A "noppa") ; --UNCHK
lin die_V = L.die_V ;
lin die_away_V = mkWV (k52A "vähentyä") ; --UNCHK
lin die_back_V = mkWV (k67 "kuolla") ; --UNCHK
lin die_down_V = mkWV (k52A "hiipua") ; --UNCHK
lin die_for_V2 = prepV2 OP_die_V OP_for_Prep ; -- guess-p-verb
lin die_off_V = mkWV (k75 "hävitä") ; --UNCHK
lin die_out_V = mkWV (k75 "hävitä") ; --UNCHK
lin dieback_N = mkWN (compoundN "verso" (k5A "tauti")) ; --UNCHK
lin diemaker_N = mkWN "meistäjä" ; --UNCHK
lin dieresis_N = mkWN (k9 "treema") ; --UNCHK
lin diesel_N = mkWN (compoundN "diesel" (k6 "moottori")) ; --UNCHK
lin diestock_N = mkWN (compoundN "kierre" (k10A "sorkka")) ; --UNCHK
lin diestrous_A = mkWA (k10 "oleva") "diestruksessa" ; --UNCHK
lin diestrus_N = mkWN "diestrus" ; --UNCHK
lin diet_N = mkN "ravinto" ; --mkWN (k5 "laihdutuskuuri") ;
lin diet_V = mkWV (k67 "olla") "dieetillä" ; --UNCHK
lin diet_V2 = mkWV2 (k67 "olla") "dieetillä" ; --UNCHK
lin dietary_A = mkWA "ruokavalio-" ; --UNCHK
lin dietary_N = mkWN "ruokavalio-" ; --UNCHK
lin dieter_N = mkWN (k2 "henkilö") "ruokavaliota" "noudattava" ; --UNCHK
lin dietetics_N = mkWN (k9A "dietetiikka") ; --UNCHK
lin diethylstilbesterol_N = mkWN "DES" ; --UNCHK
lin diethylstilbestrol_N = mkWN "DES" ; --UNCHK
lin dietician_N = mkWN (k4A "dieteetikko") ; --UNCHK
lin dietitian_N = mkWN (k4A "dieteetikko") ; --UNCHK
lin differ_V = mkV "erota" ;
lin difference_N = mkN "ero" ;
lin different_A = mkA "erilainen" ;
lin differentiable_A = mkWA "differentioituva" ; --UNCHK
lin differential_A = mkWA (k38 "erilainen") ; --UNCHK
lin differential_N = mkN "erotus" ; --WN (compoundN "tasaus" (k2 "pyörästö")) ;
lin differentiate_V = mkWV (k52 "erilaistua") ; --UNCHK
lin differentiate_V2 = mkWV2 (k52 "erilaistua") ; --UNCHK
lin differentiation_N = mkWN "differentaatio" ; --UNCHK
lin differentiator_N = mkWN "erottelija" ; --UNCHK
lin difficult_A = mkA "vaikea" ;
lin difficulty_N = mkN "ongelma" ;
lin diffidence_N = mkWN (k48A "puute") "itseluottamuksen" ; --UNCHK
lin diffident_A = mkWA (k41A "pelokas") ; --UNCHK
lin difflugia_N = mkWN (compoundN "alku" (k33 "eläin")) ; --UNCHK
lin diffract_V2 = mkWV2 (k53A "taivuttaa") ; --UNCHK
lin diffraction_N = mkWN (k3 "diffraktio") ; --UNCHK
lin diffuse_A = mkWA (k5 "diffuusi") ; --UNCHK
lin diffuse_V = mkWV (k74 "juoruta") ; --UNCHK
lin diffuse_V2 = mkWV2 (k74 "juoruta") ; --UNCHK
lin diffuseness_N = mkWN (k40 "hajanaisuus") ; --UNCHK
lin diffuser_N = mkWN (compoundN "diffuus" (k48 "ori")) ; --UNCHK
lin diffusion_N = mkWN (k39 "levitys") ; --UNCHK
lin diflunisal_N = mkWN (compoundN "difluni" (k5 "saali")) ; --UNCHK
lin dig_N = mkWN (k2 "tönäisy") ; --UNCHK
lin dig_V = L.dig_V ;
lin dig_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin dig_in_V = advV OP_dig_V OP_in_Adv ; -- guess-p-verb
lin dig_into_V2 = mkWV2 (k67 "tunnustella") ; --UNCHK
lin dig_out_V2 = mkWV2 (k56 "kaivaa") ; --UNCHK
lin dig_up_V2 = mkWV2 (k56 "kaivaa") "esiin" ; --UNCHK
lin digest_N = mkWN (k48 "kooste") ; --UNCHK
lin digest_V = mkWV (k53A "sulattaa") ; --UNCHK
lin digest_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin digester_N = mkWN (compoundN "paine" (k33A "keitin")) ; --UNCHK
lin digestibility_N = mkWN (k40 "sulavuus") ; --UNCHK
lin digestible_A = mkWA (k10 "sulava") ; --UNCHK
lin digestion_N = mkWN (compoundN "oma" (k38 "ksuminen")) ; --UNCHK
lin digestive_A = mkWA "ruoansulatus-" ; --UNCHK
lin digestive_N = mkWN (k48 "aine") "ruoansulatusta" "edistävä" ; --UNCHK
lin digger_N = mkWN (k6 "kaivuri") ; --UNCHK
lin digging_N = mkWN (k39 "kaivaus") ; --UNCHK
lin diggings_N = mkWN (k1A "luukku") ; --UNCHK
lin dighted_A = mkWA (compoundA "varus" (k1 "tettu")) ; --UNCHK
lin digit_N = mkWN (k41A "varvas") ; --UNCHK
lin digital_A = mkWA (k38 "digitaalinen") ;
lin digitalis_N = mkWN (compoundN "sormustin" (k10A "kukka")) ; --UNCHK
lin digitalization_N = mkWN (k5A "digitalisointi") ; --UNCHK
lin digitigrade_A = mkWA (compoundA "varvas" (k10 "astuja")) ; --UNCHK
lin digitization_N = mkWN (k5A "digitalisointi") ; --UNCHK
lin digitizer_N = mkWN (compoundN "analogia-digitaali" (k33A "muunnin")) ; --UNCHK
lin digitoxin_N = mkWN (compoundN "digi" (k5 "toksiini")) ; --UNCHK
lin dignify_V2 = mkWV2 (k53A "kunnioittaa") ; --UNCHK
lin dignifying_A = mkWA (compoundA "kor" (k10 "ottava")) ; --UNCHK
lin dignitary_N = mkWN (k9 "herra") "suuri" ; --UNCHK
lin dignity_N = mkN "arvokkuus" ;
lin digoxin_N = mkWN "Lanoxin" ; --UNCHK
lin digraph_N = mkWN (compoundN "kaksois" (k33 "kirjain")) ; --UNCHK
lin digress_V = mkWV (k74A "poiketa") ; --UNCHK
lin digression_N = mkWN "aiheesta" "eksyminen" ; --UNCHK
lin digressive_A = mkWA (k10 "poikkeava") "aiheesta" ; --UNCHK
lin dihybrid_N = mkWN "dihybridi" ; --UNCHK
lin dihydrostreptomycin_N = mkWN "dihydrostreptomysiini" ; --UNCHK
lin dijon_PN = foreignPN "Dijon" ;
lin dike_N = mkWN (k1A "pato") ; --UNCHK
lin dike_V = mkWV (k62 "ympäröidä") "vallilla" ; --UNCHK
lin dike_V2 = mkWV2 (k62 "ympäröidä") "vallilla" ; --UNCHK
lin dilapidated_A = mkWA (k38 "rähjäinen") ; --UNCHK
lin dilapidation_N = mkWN (k3 "rappio") ; --UNCHK
lin dilatation_N = mkWN "dilataatio" ; --UNCHK
lin dilate_V = mkWV (k52A "laajentua") ; --UNCHK
lin dilate_V2 = mkWV2 (k52A "laajentua") ; --UNCHK
lin dilation_N = mkWN "dilataatio" ; --UNCHK
lin dilator_N = mkWN "laajennin" ; --UNCHK
lin dilatoriness_N = mkWN (k2 "vitkastelu") ; --UNCHK
lin dilatory_A = mkWA (k41A "hidas") ; --UNCHK
lin dildo_N = mkWN (compoundN "hieroma" (k9 "sauva")) ; --UNCHK
lin dilemma_N = mkWN (k10 "pulma") ;
lin dilettante_A = mkWA (k38 "pinnallinen") ; --UNCHK
lin dilettante_N = mkWN (k5A "diletantti") ; --UNCHK
lin diligence_N = mkWN (k40 "uutteruus") ; --UNCHK
lin diligent_A = mkWA (k10 "ahkera") ; --UNCHK
lin dill_N = mkWN (k5 "tilli") ; --UNCHK
lin diltiazem_N = mkWN (compoundN "diltiatse" (k5 "emi")) ; --UNCHK
lin dilutant_N = mkWN (k48A "ohenne") ; --UNCHK
lin dilute_A = mkWA (k1A "mieto") ; --UNCHK
lin dilute_V = mkWV (k53A "vesittää") ; --UNCHK
lin dilute_V2 = mkWV2 (k53A "vesittää") ; --UNCHK
lin dilution_N = mkWN (k39 "laimennus") ; --UNCHK
lin diluvian_A = mkWA "diluviaali-" ; --UNCHK
lin dim_A = mkWA (k15 "himmeä") ; --UNCHK
lin dim_V = mkWV (k52A "hämärtyä") ; --UNCHK
lin dim_V2 = mkWV2 (k52A "hämärtyä") ; --UNCHK
lin dime_N = mkWN (compoundN "huume" (k5A "paketti")) ; --UNCHK
lin dimenhydrinate_N = mkWN (compoundN "dimenhydri" (k5A "naatti")) ; --UNCHK
lin dimension_N = mkWN (k40 "laajuus") ; --UNCHK
lin dimensional_A = mkWA (k38 "-ulotteinen") ; --UNCHK
lin dimensionality_N = mkWN (k40 "ulotteisuus") ; --UNCHK
lin dimensioning_A = mkWA "mitoittava" ; --UNCHK
lin dimethylglyoxime_N = mkWN "dimetyyliglyoksiimi" ; --UNCHK
lin dimetrodon_N = mkWN "dimetrodon" ; --UNCHK
lin diminish_V = mkWV (k58 "laskea") ; --UNCHK
lin diminish_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin diminuendo_N = mkWN "diminuendo" ; --UNCHK
lin diminution_N = mkWN (k39 "vähennys") ; --UNCHK
lin diminutive_A = mkWA (k10 "sorja") ; --UNCHK
lin diminutive_N = mkWN (k5 "deminutiivi") ; --UNCHK
lin diminutiveness_N = mkWN (k40 "pienuus") ; --UNCHK
lin dimity_N = mkWN (compoundN "park" (k5 "kumi")) ; --UNCHK
lin dimmer_N = mkWN (k33A "himmennin") ; --UNCHK
lin dimness_N = mkWN (k40 "hämäryys") ; --UNCHK
lin dimorphic_A = mkWA (compoundA "kaksi" (k38 "muotoinen")) ; --UNCHK
lin dimorphism_N = mkWN (compoundN "dimorf" (k5 "ismi")) ; --UNCHK
lin dimple_N = mkWN (compoundN "hymy" (k10A "kuoppa")) ; --UNCHK
lin dimple_V = mkWV (k53 "paljastaa") "hymykuopat" ; --UNCHK
lin dimple_V2 = mkWV2 (k53 "paljastaa") "hymykuopat" ; --UNCHK
lin dimwit_N = mkWN (k6 "tomppeli") ; --UNCHK
lin din_N = mkWN (k12 "rähinä") ; --UNCHK
lin din_V = mkWV (k58A "hokea") ; --UNCHK
lin din_V2 = mkWV2 (k58A "hokea") ; --UNCHK
lin dinar_N = mkWN (compoundN "din" (k5 "aari")) ; --UNCHK
lin dine_V = mkV (mkV "syödä") "päivällistä" ; --UNCHK
lin dine_out_V = mkWV (k64 "syödä") "ravintolassa" ; --UNCHK
lin diner_N = mkWN "tienvarsiruokapaikka" ; --UNCHK
lin dinette_N = mkWN (compoundN "ruokailu" (k9 "tila")) ; --UNCHK
lin ding_N = mkWN (k1 "naarmu") ; --UNCHK
lin dingbat_N = mkWN (k39 "typerys") ; --UNCHK
lin dingdong_Adv = mkWAdv (k99 "tarmokkaasti") ; --UNCHK
lin dinghy_N = mkWN (k48 "vene") ; --UNCHK
lin dinginess_N = mkWN "nuhruisuus" ; --UNCHK
lin dingle_N = mkWN (k1 "laakso") "metsäinen" ; --UNCHK
lin dingle_PN = foreignPN "Dingle" ;
lin dingo_N = mkWN (compoundN "villi" (k10 "koira")) ; --UNCHK
lin dingy_A = mkWA (k15 "synkeä") ; --UNCHK
lin dining_N = mkWN (k38 "syöminen") "päivällisen" ; --UNCHK
lin dining_car_N = mkWN (compoundN "ravintola" (k1 "vaunu")) ; --UNCHK
lin dining_room_N = mkWN (compoundN "ruoka" (k5 "sali")) ; --UNCHK
lin dining_table_N = mkWN (compoundN "ruoka" (k10A "pöytä")) ; --UNCHK
lin dinky_A = mkWA (k10 "soma") ; --UNCHK
lin dinky_N = mkWN (k6 "veturi") "pieni" ; --UNCHK
lin dinner_N = mkWN (k38 "päivällinen") ; --UNCHK
lin dinner_jacket_N = mkWN (k5A "smokki") ; --UNCHK
lin dinner_service_N = mkWN (compoundN "pöytä" (k1 "astiasto")) ; --UNCHK
lin dinner_set_N = mkWN (compoundN "pöytä" (k1 "astiasto")) ; --UNCHK
lin dinnertime_N = mkWN (k9A "päivällisaika") ; --UNCHK
lin dinnerware_N = mkWN (compoundN "pöytä" (k1 "kalusto")) ; --UNCHK
lin dinnington_PN = foreignPN "Dinnington" ;
lin dinocerate_N = mkWN "dinocerate" ; --UNCHK
lin dinosaur_N = mkWN (k39 "dinosaurus") ; --UNCHK
lin dint_N = mkWN "avulla" ; --UNCHK
lin diocesan_A = mkWA "hiippakunnan-" ; --UNCHK
lin diocesan_N = mkWN (k9 "piispa") ; --UNCHK
lin diocese_N = mkWN (compoundN "piispan" (k9A "virka")) ; --UNCHK
lin diode_N = mkWN (k5 "diodi") ; --UNCHK
lin dioecious_A = mkWA (k38 "kaksikotinen") ; --UNCHK
lin diol_N = mkWN (compoundN "dihydro" (k5 "alkoholi")) ; --UNCHK
lin diopter_N = mkWN (k6 "diopteri") ; --UNCHK
lin diorite_N = mkWN (compoundN "dio" (k5A "riitti")) ; --UNCHK
lin dioxide_N = mkWN "dioksidi" ; --UNCHK
lin dioxin_N = mkWN (k5 "dioksiini") ; --UNCHK
lin dip_N = mkWN (k5A "dippi") ; --UNCHK
lin dip_V = mkWV (k52A "hyytyä") ; --UNCHK
lin dip_V2 = mkWV2 (k52A "hyytyä") ; --UNCHK
lin dip_ed_N = mkN "kasvatustieteiden" (mkN "maisteri") ; ----sanaliitto
lin dip_into_V2 = mkWV2 (k58A "lukea") "kursorisesti" ; --UNCHK
lin diphenhydramine_N = mkWN "Benadryl" ; --UNCHK
lin diphenylhydantoin_N = mkWN "Dilantin" ; --UNCHK
lin diphtheria_N = mkWN (compoundN "kurkku" (k10A "mätä")) ; --UNCHK
lin diphthong_N = mkWN (k5 "diftongi") ; --UNCHK
lin diplegia_N = mkWN (compoundN "kaksois" (k39 "halvaus")) ; --UNCHK
lin diplococcus_N = mkWN (k5A "diplokokki") ; --UNCHK
lin diplodocus_N = mkWN "diplodocus" ; --UNCHK
lin diploid_A = mkWA (k5 "diploidi") ; --UNCHK
lin diploid_N = mkWN (k5 "diploidi") ; --UNCHK
lin diploidy_N = mkWN "diploidisuus" ; --UNCHK
lin diploma_N = mkWN (k5 "diplomi") ; --UNCHK
lin diplomacy_N = mkWN (k40 "tahdikkuus") ; --UNCHK
lin diplomat_N = mkWN (k5A "diplomaatti") ;
lin diplomate_N = mkWN (compoundN "erikois" (k6 "lääkäri")) ; --UNCHK
lin diplomatic_A = mkA "diplomaattinen" ;
lin diplomatically_Adv = mkWAdv "diplomaattisesti" ; --UNCHK
lin diplomatist_N = mkWN (k5A "diplomaatti") ; --UNCHK
lin diplopia_N = mkWN "kahtena" "näkeminen" ; --UNCHK
lin diplotene_N = mkWN "diploteeni" ; --UNCHK
lin dipolar_A = mkWA (compoundA "kaks" (k38 "inapainen")) ; --UNCHK
lin dipole_N = mkWN (k5 "dipoli") ; --UNCHK
lin dipper_N = mkWN (compoundN "koski" (k9 "kara")) ; --UNCHK
lin dipsomania_N = mkWN (k5 "alkoholismi") ; --UNCHK
lin dipsomaniac_N = mkWN (k6 "juomari") ; --UNCHK
lin dipstick_N = mkWN (compoundN "mitta" (k1A "tikku")) ; --UNCHK
lin dipterous_A = mkWA (compoundA "kaks" (k38 "isiipinen")) ; --UNCHK
lin diptych_N = mkWN "diptyykki" ; --UNCHK
lin dire_A = mkA "vakava" ; --mkWA (k38 "hirmuinen") ;
lin direct_A = mkWA (k10 "suora") ;
lin direct_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin direct_V = mkWV (k53A "toteuttaa") ; --UNCHK
lin direct_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin direction_N = mkWN (k39 "ohjaus") ;
lin direction_finder_N = mkWN (compoundN "radio" (k33A "suunnin")) ; --UNCHK
lin directional_A = mkWA (compoundA "suu" (k1 "nnattu")) ; --UNCHK
lin directionality_N = mkWN (k40 "suuntaisuus") ; --UNCHK
lin directive_N = mkWN (k5 "direktiivi") ;
lin directivity_N = mkWN (compoundN "suunta" (k40 "herkkyys")) ; --UNCHK
lin directness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin director_N = mkN "johtaja" ;
lin directorate_N = mkWN (k39 "hallitus") ; --UNCHK
lin directorship_N = mkWN (k40 "johtajuus") ; --UNCHK
lin directory_N = mkN "hakemisto" ; --mkWN (k2 "luettelo") ;
lin direful_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin dirge_N = mkWN (compoundN "sielu" (k1 "messu")) ; --UNCHK
lin dirigible_N = mkWN (compoundN "ilma-" (k39 "alus")) ; --UNCHK
lin dirk_N = mkWN (k6 "tikari") ; --UNCHK
lin dirndl_N = mkWN (compoundN "tirolilais" (k1A "puku")) ; --UNCHK
lin dirt_A = mkWA "päällystämätön" ; --UNCHK
lin dirt_N = mkWN (k1A "törky") ; --UNCHK
lin dirt_cheap_A = mkWA (k9A "halpa") "hyvin" ; --UNCHK
lin dirt_track_N = mkWN (compoundN "maa" (k9A "rata")) ; --UNCHK
lin dirtiness_N = mkWN (k40 "hävyttömyys") ; --UNCHK
lin dirty_A = L.dirty_A ;
lin dirty_V = mkWV (k58 "iskeä") ; --UNCHK
lin dirty_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin disa_N = mkWN "DISA" ; --UNCHK
lin disability_N = mkN "kykenemättömyys" ; --mkWN (k40 "vammaisuus") ;
lin disable_V2 = mkV2 (mkV (mkV "poistaa") "toiminnasta") ; --WV2 (k52A "vammautua") ;
lin disabled_A = variants {} ; --
lin disablement_N = mkWN (k40 "vammaisuus") ; --UNCHK
lin disabling_A = mkWA (k10 "tekevä") "esteelliseksi" ; --UNCHK
lin disabuse_V2 = mkWV2 (k53 "poistaa") "harhaluulot" ; --UNCHK
lin disaccharidase_N = mkWN (compoundN "disakkarid" (k5 "aasi")) ; --UNCHK
lin disaccharide_N = mkWN "disakkaridi" ; --UNCHK
lin disadvantage_N = mkWN (k10 "asema") "epäedullinen" ; --UNCHK
lin disadvantageous_A = mkWA (k38 "haitallinen") ; --UNCHK
lin disaffected_A = mkWA (k38 "kapinallinen") ; --UNCHK
lin disaffection_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin disafforest_V2 = mkWV2 (k53 "poistaa") "metsä" ; --UNCHK
lin disagree_V = mkV vOlla "eri mieltä" ;
lin disagree_V2 = variants {} ; -- mkV vOlla "eri mieltä" ;
lin disagree_VS = variants {} ; -- mkV vOlla "eri mieltä" ;
lin disagree_with_V2 = mkWV2 (k67 "olla") "sopimaton" ; --UNCHK
lin disagreeable_A = mkWA (compoundA "epä" (k10 "miellyttävä")) ; --UNCHK
lin disagreeableness_N = mkWN (compoundN "epä" (k40 "miellyttävyys")) ; --UNCHK
lin disagreement_N = mkN (lin NK {s = d09 "kiista"}) ;
lin disallow_V2 = mkWV2 (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin disambiguation_N = mkWN (k39 "selvennys") ; --UNCHK
lin disambiguator_N = mkWN "yksiselitteistäjä" ; --UNCHK
lin disappear_V = mkV "kadota" ;
lin disappearance_N = mkWN (compoundN "kato" (k38 "aminen")) ;
lin disappoint_V2 = mkWV2 (k53A "pettää") ;
lin disappointedly_Adv = mkWAdv "pettyneenä" ; --UNCHK
lin disappointing_A = mkWA (k10 "tuottava") "pettymyksen" ;
lin disappointment_N = mkWN (compoundN "aihe" (k38 "uttaminen")) "pettymyksen" ; --UNCHK
lin disapprobation_N = mkWN (k9A "paheksunta") ; --UNCHK
lin disapproval_N = mkWN (k9A "paheksunta") ; --UNCHK
lin disapprove_V = mkWV (k69 "tuomita") ; --UNCHK
lin disapprove_V2 = mkWV2 (k69 "tuomita") ; --UNCHK
lin disapprovingly_Adv = mkWAdv "paheksuen" ; --UNCHK
lin disarm_V = mkWV (k62 "demilitarisoida") ; --UNCHK
lin disarm_V2 = mkWV2 (k62 "demilitarisoida") ; --UNCHK
lin disarmament_N = mkWN (compoundN "aseiden" (k9A "riisunta")) ; --UNCHK
lin disarming_N = mkWN (compoundN "aseiden" (k9A "riisunta")) ; --UNCHK
lin disarrange_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin disarrangement_N = mkWN (k39 "hajaannus") ; --UNCHK
lin disarray_N = mkWN (k40 "sekaisuus") ; --UNCHK
lin disassociate_V2 = mkWV2 (k52A "erottautua") ; --UNCHK
lin disassociation_N = mkWN "persoonallisuuden" "jakautuminen" ; --UNCHK
lin disaster_N = mkWN (k5 "katastrofi") ; --f107
lin disastrous_A = mkWA (k38 "katastrofaalinen") ; --UNCHK
lin disavow_V2 = mkWV2 (k53 "kiistää") ; --UNCHK
lin disavowable_A = mkWA "kiistettävä" ; --UNCHK
lin disavowal_N = mkWN (compoundN "kii" (k38 "stäminen")) ; --UNCHK
lin disband_V = mkWV (k52A "hajaantua") ; --UNCHK
lin disband_V2 = mkWV2 (k52A "hajaantua") ; --UNCHK
lin disbandment_N = mkWN "hajottaminen" ; --UNCHK
lin disbarment_N = mkWN (compoundN "ero" (k38 "ttaminen")) "asianajajaliitosta" ; --UNCHK
lin disbelief_N = mkWN (k39 "epäilys") ; --UNCHK
lin disbelieve_V = mkWV (k67 "epäillä") ; --UNCHK
lin disbelieve_V2 = mkWV2 (k67 "epäillä") ; --UNCHK
lin disbeliever_N = mkWN (k4A "skeptikko") ; --UNCHK
lin disbelievingly_Adv = mkWAdv (k99 "epäuskoisesti") ; --UNCHK
lin disbud_V2 = mkWV2 (k71 "tehdä") "sarvettomaksi" ; --UNCHK
lin disburden_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin disburse_V = mkWV (k53A "suorittaa") "maksu" ; --UNCHK
lin disburse_V2 = mkWV2 (k53A "suorittaa") "maksu" ; --UNCHK
lin disbursement_N = mkWN (compoundN "rahan" (k1A "käyttö")) ; --UNCHK
lin disc_N = mkWN (k38 "lautanen") ; --UNCHK
lin discalced_A = mkWA (compoundA "paljas" (k38 "jalkainen")) ; --UNCHK
lin discard_N = mkWN (compoundN "hei" (k38 "ttäminen")) "pois" ; --UNCHK
lin discard_V2 = mkWV2 (k73A "hylätä") ;
lin discern_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin discernability_N = mkWN (k40 "luettavuus") ; --UNCHK
lin discernible_A = mkWA (k10 "näkyvä") ; --UNCHK
lin discerning_A = mkWA (compoundA "tarkka" (k38 "näköinen")) ; --UNCHK
lin discernment_N = mkWN (compoundN "harkinta" (k1A "kyky")) ; --UNCHK
lin discharge_N = mkWN (k2 "laukaisu") ; --UNCHK
lin discharge_V = mkWV (k53A "vapauttaa") ; --UNCHK
lin discharge_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin disciform_A = mkWA (compoundA "kiekko" (k38 "mainen")) ; --UNCHK
lin disciple_N = mkWN (k10 "kannattaja") ; --UNCHK
lin discipleship_N = mkWN (k41 "oppilas") ; --UNCHK
lin disciplinarian_N = mkWN (k5 "moralisti") ; --UNCHK
lin disciplinary_A = mkWA "oppisuunnan" ; --UNCHK
lin discipline_N = mkWN (k39 "harjoitus") ; --UNCHK
lin discipline_V2 = mkWV2 (k54A "ojentaa") ; --UNCHK
lin disclaim_V2 = mkWV2 (k52A "vetäytyä") "jstk" ; --UNCHK
lin disclaim_VS = mkWVS (k52A "vetäytyä") "jstk" ; --UNCHK
lin disclaimer_N = mkWN (compoundN "kii" (k38 "stäminen")) ; --UNCHK
lin disclose_V = mkWV (k52A "kertoa") ;
lin disclose_V2 = mkV2 (lin VK {s = c53 "paljastaa"}) ;
lin disclose_VS = mkWVS (k52A "kertoa") ; --UNCHK
lin disclosure_N = mkN "paljastaminen" ;
lin disco_1_N = mkN "disko" ;
lin disco_2_N = mkN "disko" ;
lin discography_N = mkWN (k12 "diskografia") ; --UNCHK
lin discoid_A = mkWA (k38 "muotoinen") "kiekon" ; --UNCHK
lin discoloration_N = mkWN (compoundN "haa" (k38 "listuminen")) ; --UNCHK
lin discolour_V = mkWV (k52A "värjääntyä") ; --UNCHK
lin discolour_V2 = mkWV2 (k52A "värjääntyä") ; --UNCHK
lin discolouration_N = mkWN (compoundN "haa" (k38 "listuminen")) ; --UNCHK
lin discombobulated_A = mkWA (k10 "oleva") "hämillään" ; --UNCHK
lin discomfit_V2 = mkWV2 (k53A "hermostuttaa") ; --UNCHK
lin discomfiture_N = mkWN (k40 "nolous") ; --UNCHK
lin discomfort_N = mkWN (k1A "ahdinko") ; --UNCHK
lin discompose_V2 = mkWV2 (k53A "hermostuttaa") ; --UNCHK
lin discomposure_N = mkWN (k40 "levottomuus") ; --UNCHK
lin discomycete_N = mkWN (compoundN "kotelo" (k38 "maljainen")) ; --UNCHK
lin discomycetous_A = mkWA "kotelomaljaisiin" "liittyvä" ; --UNCHK
lin disconcert_V2 = mkWV2 (k53A "hermostuttaa") ; --UNCHK
lin disconcerting_A = mkWA (k38 "kiusallinen") ; --UNCHK
lin disconfirming_A = mkWA (k38 "negatiivinen") ; --UNCHK
lin disconnect_V2 = mkV2 (mkV (mkV "katkaista") "yhteys") illative ;
lin disconnection_N = mkWN (compoundN "katka" (k38 "iseminen")) "yhteyden" ; --UNCHK
lin disconsolate_A = mkWA (k38 "murheellinen") ; --UNCHK
lin discontent_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin discontent_V2 = mkWV2 (k71 "tehdä") "tyytymättömäksi" ; --UNCHK
lin discontentedly_Adv = mkWAdv (k99 "tyytymättömästi") ; --UNCHK
lin discontentment_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin discontinuance_N = mkWN (k39 "keskeytys") ; --UNCHK
lin discontinue_V = mkWV (k53A "keskeyttää") ; --UNCHK
lin discontinue_V2 = mkWV2 (k53A "keskeyttää") ;
lin discontinuity_N = mkWN (k39 "keskeytys") ; --UNCHK
lin discontinuous_A = mkWA (k38 "katkonainen") ; --UNCHK
lin discord_N = mkWN (k10 "eripura") ; --UNCHK
lin discordance_N = mkWN (k10 "eripura") ; --UNCHK
lin discordant_A = mkWA (compoundA "sora" (k38 "ääninen")) ; --UNCHK
lin discorporate_A = mkWA (k34A "aineeton") ; --UNCHK
lin discotheque_N = mkWN (k5A "diskoteekki") ; --UNCHK
lin discount_N = mkN "alennus" ;
lin discount_V = mkWV (k73 "tyrmätä") ; --UNCHK
lin discount_V2 = mkWV2 (k73 "tyrmätä") ; --UNCHK
lin discountenance_V2 = mkWV2 (k52 "paheksua") ; --UNCHK
lin discourage_V2 = mkV2 "lannistaa" ;
lin discouragement_N = mkWN (compoundN "ehkä" (k38 "iseminen")) ; --UNCHK
lin discouraging_A = mkWA "lannistava" ; --UNCHK
lin discourse_N = mkWN (k10 "tutkielma") ; --UNCHK
lin discourse_V = mkWV (k52 "puhua") "paljon" ; --UNCHK
lin discourteous_A = mkWA (compoundA "epä" (k41 "kohtelias")) ; --UNCHK
lin discourtesy_N = mkWN (k38 "käyttäytyminen") "loukkaava" ; --UNCHK
lin discover_V = mkV "löytää" ;
lin discover_V2 = mkV2 "löytää" ;
lin discover_VS = mkWVS (k63 "saada") "tietää" ;
lin discovererFem_N = mkWN (k12 "tarkkailija") ; --UNCHK
lin discovererMasc_N = mkWN (k12 "tarkkailija") ; --UNCHK
lin discovery_N = mkN "löytö" ;
lin discredit_N = mkWN (k15 "häpeä") ; --UNCHK
lin discredit_V2 = mkV2 (mkV (mkV "saattaa") "huonoon valoon") ; --mkWV2 (k67 "epäillä") ;
lin discreditable_A = mkWA (k10 "alentava") ; --UNCHK
lin discreet_A = mkWA (k1A "hillitty") ; --UNCHK
lin discrepancy_N = mkWN (k40 "eroavuus") ;
lin discrepant_A = mkWA (k10 "poikkeava") "jstak" ; --UNCHK
lin discrete_A = mkWA (k38 "itsenäinen") ; --UNCHK
lin discreteness_N = mkWN (k40 "irrallisuus") ; --UNCHK
lin discretion_N = mkWN (compoundN "harkinta" (k1A "kyky")) ;
lin discretionary_A = mkA "harkinnanvarainen" ;
lin discriminable_A = mkWA "erottuva" ; --UNCHK
lin discriminate_A = mkWA (compoundA "arvosteluky" (k38 "kyinen")) ; --UNCHK
lin discriminate_V = mkWV (k71 "tehdä") "ero" ; --UNCHK
lin discriminate_V2 = mkWV2 (k71 "tehdä") "ero" ; --UNCHK
lin discrimination_N = mkWN (k9A "syrjintä") ; --UNCHK
lin discriminative_A = mkWA (k9A "tarkka") ; --UNCHK
lin discriminatory_A = mkA "erotteleva" ;
lin discursive_A = mkWA (k10 "poikkeava") "aiheesta" ; --UNCHK
lin discursiveness_N = mkWN (k2 "kiertely") ; --UNCHK
lin discus_N = mkWN (k1A "kiekko") ; --UNCHK
lin discuss_V2 = mkV2 "keskustella" elative ;
lin discuss_VS = mkVS "keskustella" ;
lin discussant_N = mkWN (k12 "keskustelija") ; --UNCHK
lin discussion_N = mkN "keskustelu" ;
lin disdain_N = mkWN (k40 "alentuvuus") ; --UNCHK
lin disdain_V2 = mkWV2 (k67 "olla") "hyväksymättä" ; --UNCHK
lin disdainful_A = mkWA (k15 "ylpeä") ; --UNCHK
lin disease_N = mkWN (k5A "tauti") ;
lin diseased_A = mkWA (k38 "patologinen") ; --UNCHK
lin disembark_V = mkWV (k52 "astua") "maihin" ; --UNCHK
lin disembark_V2 = mkWV2 (k52 "astua") "maihin" ; --UNCHK
lin disembarkation_N = mkWN (compoundN "maihin" (k1 "nousu")) ; --UNCHK
lin disembarrass_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin disembarrassment_N = mkWN "helpottaa" "hämmennystä" ; --UNCHK
lin disembody_V2 = mkWV2 (k53A "vapauttaa") "jstk" ; --UNCHK
lin disembowel_V2 = mkWV2 (k53 "poistaa") "sisälmykset" ; --UNCHK
lin disembowelment_N = mkWN (k1 "poisto") "sisusten" ; --UNCHK
lin disenchant_V2 = mkV2 (mkV (mkV "rikkoa") "lumous") ;
lin disenchanting_A = mkWA "harhakuvitelmista" "herättävä" ; --UNCHK
lin disenchantment_N = mkWN (compoundN "pois" (k38 "taminen")) "harhakuvitelmien" ; --UNCHK
lin disencumber_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin disenfranchise_V2 = mkWV2 (k73A "evätä") "äänioikeus" ; --UNCHK
lin disenfranchisement_N = mkWN (compoundN "irti" (k38 "sanominen")) "toimiluvan" ; --UNCHK
lin disengage_V = mkWV (k53A "vapauttaa") ; --UNCHK
lin disengage_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin disengagement_N = mkWN (compoundN "per" (k38 "ääntyminen")) ; --UNCHK
lin disentangle_V = mkWV (k53A "selvittää") ; --UNCHK
lin disentangle_V2 = mkWV2 (k53A "selvittää") ; --UNCHK
lin disentanglement_N = mkWN (compoundN "vapa" (k38 "uttaminen")) ; --UNCHK
lin disentangler_N = mkWN (k10 "selvittäjä") ; --UNCHK
lin disequilibrium_N = mkWN "epätasapaino" ; --UNCHK
lin disesteem_N = mkWN (k10 "asema") "halveksittu" ; --UNCHK
lin disfavor_N = mkWN (k9A "paheksunta") ; --UNCHK
lin disfavour_N = mkWN (k9A "paheksunta") ; --UNCHK
lin disfavour_V2 = mkWV2 (k67 "olla") "haitaksi" ; --UNCHK
lin disfigure_V2 = mkWV2 (k53A "vahingoittaa") ; --UNCHK
lin disfigurement_N = mkWN (compoundN "pila" (k38 "aminen")) ; --UNCHK
lin disfluency_N = mkWN (k40 "taitamattomuus") ; --UNCHK
lin disforest_V2 = mkWV2 (k53 "poistaa") "metsä" ; --UNCHK
lin disfranchise_V2 = mkWV2 (k73A "evätä") "äänioikeus" ; --UNCHK
lin disfranchisement_N = mkWN (compoundN "epä" (k38 "äminen")) ; --UNCHK
lin disgorge_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin disgrace_N = mkWN (k39 "nöyryytys") ; --UNCHK
lin disgrace_V2 = mkWV2 (k66 "häpäistä") ; --UNCHK
lin disgraceful_A = mkWA (k34A "kunniaton") ; --UNCHK
lin disgruntled_A = mkWA (k34A "tyytymätön") ; --UNCHK
lin disgruntlement_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin disguise_N = mkWN (k5A "naamiointi") ; --UNCHK
lin disguise_V2 = mkWV2 (k73 "salata") ; --UNCHK
lin disgust_N = mkWN (k1 "inho") ; --UNCHK
lin disgust_V2 = mkWV2 (k53A "kuvottaa") ; --UNCHK
lin disgustedly_Adv = mkWAdv "inhoten" ; --UNCHK
lin disgusting_A = mkWA (k15 "törkeä") ; --UNCHK
lin disgustingness_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin dish_N = mkN "annos" ; ---ARB --mkWN (k1A "juttu") ;
lin dish_V2 = mkWV2 (k54A "kovertaa") ; --UNCHK
lin dish_out_V2 = mkWV2 (k73 "pilata") ; --UNCHK
lin dish_up_V2 = mkWV2 (k73 "pilata") ; --UNCHK
lin dishabille_N = mkWN (k99 "puolipukeissa") ; --UNCHK
lin disharmonious_A = mkWA (compoundA "riita" (k38 "sointuinen")) ; --UNCHK
lin disharmony_N = mkWN (compoundN "epä" (k1A "sointu")) ; --UNCHK
lin dishcloth_N = mkWN (compoundN "tiski" (k5A "rätti")) ; --UNCHK
lin dishearten_V2 = mkWV2 (k54A "masentaa") ; --UNCHK
lin disheartenment_N = mkWN (k39 "vastustus") ; --UNCHK
lin disheveled_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin dishevelled_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin dishful_N = mkWN (k38 "vadillinen") ; --UNCHK
lin dishonest_A = mkWA (k38 "häpeällinen") ; --UNCHK
lin dishonesty_N = mkWN (compoundN "epä" (k40 "rehellisyys")) ; --UNCHK
lin dishonorable_A = mkWA (k38 "häpeällinen") ; --UNCHK
lin dishonorableness_N = mkWN (compoundN "häpeäll" (k40 "isyys")) ; --UNCHK
lin dishonour_N = mkWN (k15 "häpeä") ; --UNCHK
lin dishonour_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin dishonourable_A = mkWA (k38 "valheellinen") ; --UNCHK
lin dishpan_N = mkWN (compoundN "tiski" (k1A "soikko")) ; --UNCHK
lin dishrag_N = mkWN (compoundN "tiski" (k5A "rätti")) ; --UNCHK
lin dishtowel_N = mkWN (compoundN "astia" (k48A "pyyhe")) ; --UNCHK
lin dishwasher_N = mkWN (compoundN "tiski" (k48 "kone")) ;
lin dishwashing_N = mkWN (k1 "pesu") "astioiden" ; --UNCHK
lin dishwater_N = mkWN (compoundN "tiski" (k27 "vesi")) ; --UNCHK
lin dishy_A = mkWA (compoundA "hyvän" (k38 "näköinen")) ; --UNCHK
lin disillusion_N = mkWN (compoundN "pois" (k38 "taminen")) "harhakuvitelmien" ; --UNCHK
lin disillusionment_N = mkWN (compoundN "pois" (k38 "taminen")) "harhakuvitelmien" ; --UNCHK
lin disincentive_N = mkWN (k48 "este") ; --UNCHK
lin disinclination_N = mkWN (k40 "innottomuus") ; --UNCHK
lin disincline_V2 = mkWV2 (k67 "olla") "vastahakoinen" ; --UNCHK
lin disincline_V2V = mkWV2V (k67 "olla") "vastahakoinen" ; --UNCHK
lin disinfect_V2 = mkWV2 (k62 "desinfioida") ; --UNCHK
lin disinfectant_A = mkWA (compoundA "desinfi" (k10 "oiva")) ; --UNCHK
lin disinfectant_N = mkWN (compoundN "mikrobi" (k48A "lääke")) ; --UNCHK
lin disinfection_N = mkWN (k5A "desinfiointi") ; --UNCHK
lin disinfest_V2 = mkWV2 (k74 "tuhota") "syöpäläiset" ; --UNCHK
lin disinfestation_N = mkWN (k9A "torjunta") "syöpäläisten" ; --UNCHK
lin disinflation_N = mkWN (k3 "deflaatio") ; --UNCHK
lin disinformation_N = mkWN (k1A "tieto") "tarkoituksellisen" "harhaanjohtava" ; --UNCHK
lin disingenuous_A = mkWA (k38 "teennäinen") ; --UNCHK
lin disingenuousness_N = mkWN (k40 "petollisuus") ; --UNCHK
lin disinherit_V2 = mkWV2 (k71 "tehdä") "perinnöttömäksi" ; --UNCHK
lin disinheritance_N = mkWN (k38 "tekeminen") "perinnöttömäksi" ; --UNCHK
lin disintegrate_V = mkWV (k74 "hajota") ; --UNCHK
lin disintegrate_V2 = mkWV2 (k74 "hajota") ; --UNCHK
lin disintegration_N = mkWN (compoundN "dis" (k3 "integraatio")) ; --UNCHK
lin disintegrative_A = mkWA (compoundA "haj" (k10 "ottava")) ; --UNCHK
lin disinter_V2 = mkWV2 (k56 "kaivaa") "haudasta" ; --UNCHK
lin disinterest_N = mkWN (k40 "puolueettomuus") ; --UNCHK
lin disinterested_A = mkWA (compoundA "epä" (k41A "itsekäs")) ; --UNCHK
lin disinterestedness_N = mkWN (compoundN "epä" (k40 "itsekkyys")) ; --UNCHK
lin disinterment_N = mkWN (compoundN "kai" (k38 "vaminen")) "esiin" ; --UNCHK
lin disinvestment_N = mkWN (compoundN "des" (k5A "investointi")) ; --UNCHK
lin disjoined_A = mkWA (compoundA "ero" (k1 "tettu")) ; --UNCHK
lin disjoint_A = mkWA (k38 "irrallinen") ; --UNCHK
lin disjoint_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin disjointedly_Adv = mkWAdv (k99 "sekavasti") ; --UNCHK
lin disjointedness_N = mkWN (k40 "sekavuus") ; --UNCHK
lin disjunct_A = mkWA (k38 "hyppäyksittäinen") ; --UNCHK
lin disjunction_N = mkWN (compoundN "katka" (k38 "iseminen")) "yhteyden" ; --UNCHK
lin disjunctive_A = mkWA "erottava" ; --UNCHK
lin disk_N = mkN (lin NK {s = d01 "levy"}) ;
lin diskette_N = mkWN (k1A "korppu") ; --UNCHK
lin dislikable_A = mkWA (compoundA "epä" (k10 "miellyttävä")) ; --UNCHK
lin dislike_N = mkWN (k9A "paheksunta") ; --UNCHK
lin dislike_V2 = mkV2 "inhota" partitive ; --WV2 (k53A "pitää") "vastenmielisenä" ;
lin dislocate_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin dislocation_N = mkWN (k3 "häiriö") ; --UNCHK
lin dislodge_V2 = mkWV2 (k54A "työntää") "syrjään" ; --UNCHK
lin dislodgement_N = mkWN (compoundN "syrjä" (k38 "yttäminen")) ; --UNCHK
lin dislodgment_N = mkWN (compoundN "syrjä" (k38 "yttäminen")) ; --UNCHK
lin disloyal_A = mkWA (k38 "petollinen") ; --UNCHK
lin disloyalty_N = mkWN (compoundN "epä" (k40 "lojaalius")) ; --UNCHK
lin dismal_A = mkWA (k15 "synkeä") ; --UNCHK
lin dismantle_V2 = mkV2 "purkaa" ; --mkWV2 (k61A "repiä") ;
lin dismantlement_N = mkWN (k1A "purku") ; --UNCHK
lin dismantling_N = mkWN (k1A "purku") ; --UNCHK
lin dismay_N = mkWN (k39 "tyrmistys") ; --UNCHK
lin dismay_V = mkWV (k53A "pelästyttää") ; --UNCHK
lin dismay_V2 = mkWV2 (k53A "pelästyttää") ; --UNCHK
lin dismember_V2 = mkWV2 (k53A "irrottaa") "raajat" ; --UNCHK
lin dismemberment_N = mkWN (k2 "paloittelu") ; --UNCHK
lin dismiss_V2 = mkV2 (mkV "hylätä" "hylkäsi") ;
lin dismissal_N = mkWN (k39 "vapautus") ; --UNCHK
lin dismissible_A = mkWA "erotettava" ; --UNCHK
lin dismissive_A = mkWA "viraltapano-" ; --UNCHK
lin dismount_N = mkWN (compoundN "alas" (k1 "tulo")) ; --UNCHK
lin disobedience_N = mkN "itsepäisyys" ;
lin disobedient_A = mkWA (k34A "tottelematon") ; --UNCHK
lin disobey_V2 = mkWV2 (k67 "olla") "tottelematon" ; --UNCHK
lin disobliging_A = mkWA (k15 "töykeä") ; --UNCHK
lin disorder_N = mkN "epäjärjestys" ;
lin disorderliness_N = mkWN (k40 "sekaisuus") ; --UNCHK
lin disorderly_A = mkWA (k10 "tuottava") "häiriötä" ; --UNCHK
lin disorganization_N = mkWN (compoundN "aihe" (k38 "uttaminen")) "hajaannuksen" ; --UNCHK
lin disorganize_V2 = mkWV2 (k58 "sotkea") ; --UNCHK
lin disorient_V2 = mkWV2 (k53A "harhauttaa") ; --UNCHK
lin disorientate_V2 = mkWV2 (k53A "harhauttaa") ; --UNCHK
lin disorientation_N = mkWN (k39 "hämmennys") ; --UNCHK
lin disorienting_A = mkWA "hämmentävä" ; --UNCHK
lin disown_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin disownment_N = mkWN "kieltäminen" ; --UNCHK
lin disparage_V2 = mkWV2 (k54A "halventaa") ; --UNCHK
lin disparagement_N = mkWN (k10A "väheksyntä") ; --UNCHK
lin disparagingly_Adv = mkWAdv (k99 "halventavasti") ; --UNCHK
lin disparate_A = mkWA (k38 "erilainen") ; --UNCHK
lin disparateness_N = mkWN (k40 "erilaisuus") ; --UNCHK
lin disparity_N = mkWN (k40 "eroavuus") ; --UNCHK
lin dispassion_N = mkWN (k40 "arkipäiväisyys") ; --UNCHK
lin dispassionate_A = mkWA (k38 "maltillinen") ; --UNCHK
lin dispassionateness_N = mkWN (k40 "arkipäiväisyys") ; --UNCHK
lin dispatch_N = mkWN (k39 "toimitus") ; --UNCHK
lin dispatch_V2 = mkWV2 (k56A "tappaa") ; --UNCHK
lin dispatch_V2V = mkWV2V (k56A "tappaa") ; --UNCHK
lin dispatch_box_N = mkWN (compoundN "asiakirja" (k2 "kotelo")) ; --UNCHK
lin dispatch_rider_N = mkWN (compoundN "pika" (k5A "lähetti")) ; --UNCHK
lin dispatcher_N = mkWN (k10 "lähettäjä") ; --UNCHK
lin dispel_V2 = mkWV2 (k54A "hälventää") ; --UNCHK
lin dispensability_N = mkWN (k40 "tarpeettomuus") ; --UNCHK
lin dispensable_A = mkWA (k10 "turha") ; --UNCHK
lin dispensary_N = mkWN (k12 "neuvola") ; --UNCHK
lin dispensation_N = mkWN (k2 "jakelu") ; --UNCHK
lin dispense_V = mkWV (k56A "jakaa") ; --UNCHK
lin dispense_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin dispenser_N = mkWN (compoundN "jakelu" (k48A "laite")) ; --UNCHK
lin dispersal_N = mkWN (k39 "levitys") ; --UNCHK
lin disperse_V = mkWV (k53A "hajottaa") ; --UNCHK
lin disperse_V2 = mkWV2 (k53A "hajottaa") ; --UNCHK
lin dispersion_N = mkWN (k39 "levitys") ; --UNCHK
lin dispirit_V2 = mkWV2 (k53 "ahdistaa") ; --UNCHK
lin dispiritedly_Adv = mkWAdv (k99 "toivottomasti") ; --UNCHK
lin displace_V2 = mkWV2 (k64 "viedä") ; --UNCHK
lin displacement_N = mkWN (compoundN "syrjä" (k38 "yttäminen")) ; --UNCHK
lin display_N = mkN "näyttö" ; ---ARB mkWN (k2 "näyttely") ;
lin display_V2 = mkV2 "näyttää" ;
lin display_VS = variants {} ; -- mkV2 "näyttää" ;
lin displease_V2 = mkWV2 (k53A "pahastuttaa") ; --UNCHK
lin displeasing_A = mkWA (compoundA "epä" (k10 "mieluisa")) ; --UNCHK
lin displeasure_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin disport_V2 = mkWV2 (k68 "karkeloida") ; --UNCHK
lin disposable_A = mkWA (compoundA "kertakäytt" (k38 "öinen")) ; --UNCHK
lin disposable_N = mkWN (compoundN "kertakäyttö" (k12 "tavara")) ; --UNCHK
lin disposal_N = mkWN (compoundN "hei" (k38 "ttäminen")) "pois" ; --UNCHK
lin dispose_V = mkWV (k53A "kelpuuttaa") ; --UNCHK
lin dispose_V2 = mkWV2 (k53A "kelpuuttaa") ; --UNCHK
lin disposition_N = mkWN (compoundN "hei" (k38 "ttäminen")) "pois" ; --UNCHK
lin dispossess_V2 = mkWV2 (k53 "riistää") ; --UNCHK
lin dispossession_N = mkWN (k1A "häätö") ; --UNCHK
lin disproof_N = mkWN "vääräksi" "osoittaminen" ; --UNCHK
lin disproportion_N = mkWN "epäsuhtaisuus" ; --UNCHK
lin disproportionate_A = mkWA (k34A "suhteeton") ;
lin disprove_V2 = mkWV2 (k53A "osoittaa") "vääräksi" ; --UNCHK
lin disprove_VS = mkWVS (k53A "osoittaa") "vääräksi" ; --UNCHK
lin disputable_A = mkWA (k34A "selvittämätön") ; --UNCHK
lin disputant_N = mkWN (k1A "poleemikko") ; --UNCHK
lin disputation_N = mkWN (k2 "keskustelu") ; --UNCHK
lin disputatious_A = mkWA (k10 "riitaisa") ; --UNCHK
lin dispute_N = mkWN (k2 "väittely") ;
lin dispute_V = mkWV (k67A "väitellä") ; --UNCHK
lin dispute_V2 = mkWV2 (k67A "väitellä") ; --UNCHK
lin disqualification_N = mkWN (k5A "diskvalifiointi") ; --UNCHK
lin disqualify_V2 = mkV2 "diskvalifioida" ; --WV2 (k73 "jäävätä") ;
lin disquiet_N = mkWN (k40 "huolestuneisuus") ; --UNCHK
lin disquiet_V2 = mkWV2 (k52 "huolestua") ; --UNCHK
lin disquieting_A = mkWA "levottomuutta" "herättävä" ; --UNCHK
lin disquietude_N = mkWN (k40 "rauhattomuus") ; --UNCHK
lin disquisition_N = mkWN (k10 "tutkielma") ; --UNCHK
lin disregard_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin disregard_V2 = mkWV2 (k67 "olla") "piittaamatta" ; --UNCHK
lin disrepair_N = mkWN (k1A "kunto") "huono" ; --UNCHK
lin disreputable_A = mkWA (compoundA "huono" (k38 "maineinen")) ; --UNCHK
lin disrepute_N = mkWN (k15 "häpeä") ; --UNCHK
lin disrespect_N = mkWN (k10A "halveksunta") ; --UNCHK
lin disrespectful_A = mkWA (compoundA "epä" (k10 "kunnioittava")) ; --UNCHK
lin disrobe_V = mkWV (k52A "riisuuntua") ; --UNCHK
lin disrobe_V2 = mkWV2 (k52A "riisuuntua") ; --UNCHK
lin disrupt_V = mkWV (k66 "katkaista") ; --UNCHK
lin disrupt_V2 = mkWV2 (k66 "katkaista") ; --UNCHK
lin disruption_N = mkWN (k5 "väli") ; --UNCHK
lin disruptive_A = mkWA (k15 "kiihkeä") ; --UNCHK
lin dissatisfaction_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin dissatisfy_V2 = mkWV2 (k71 "tehdä") "tyytymättömäksi" ; --UNCHK
lin dissect_V2 = mkWV2 (k52 "ratkoa") ; --UNCHK
lin dissection_N = mkWN (compoundN "dis" (k3 "sektio")) ; --UNCHK
lin dissemble_V = mkWV (k53A "esittää") ; --UNCHK
lin dissemble_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin dissembler_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin disseminate_V = mkWV (k74 "juoruta") ; --UNCHK
lin disseminate_V2 = mkWV2 (k74 "juoruta") ; --UNCHK
lin dissemination_N = mkWN (k39 "levitys") ; --UNCHK
lin dissension_N = mkWN (k10 "eripura") ; --UNCHK
lin dissent_N = mkWN (k39 "vastustus") ; --UNCHK
lin dissent_V = mkV vOlla "eri mieltä" ;
lin dissenter_N = mkN "toisin" (mkN "ajattelija") ; --mkWN (k5A "dissidentti") ;
lin dissentient_A = mkWA (k10 "toisinajatteleva") ; --UNCHK
lin dissentious_A = mkWA (compoundA "ryhmä" (k38 "kuntainen")) ; --UNCHK
lin dissertation_N = mkWN (k10 "tutkielma") "tieteellinen" ; --UNCHK
lin disservice_N = mkWN (compoundN "karhun" (k39 "palvelus")) ; --UNCHK
lin dissever_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin dissidence_N = mkWN (compoundN "mielipide-" (k1 "ero")) ; --UNCHK
lin dissident_A = mkWA (k10 "toisinajatteleva") ; --UNCHK
lin dissident_N = mkWN (k5A "dissidentti") ;
lin dissilience_N = mkWN (compoundN "esiin" (k1 "tulo")) "siementen" ; --UNCHK
lin dissilient_A = mkWA "lohkeava" ; --UNCHK
lin dissimilar_A = mkWA (k38 "erilainen") ; --UNCHK
lin dissimilarity_N = mkWN (k40 "poikkeavuus") ; --UNCHK
lin dissimilation_N = mkWN (compoundN "aineen" (k9A "vaihdunta")) "hajottava" ; --UNCHK
lin dissimilitude_N = mkWN (k40 "erilaisuus") ; --UNCHK
lin dissimulate_V = mkWV (k73 "salata") ; --UNCHK
lin dissimulate_V2 = mkWV2 (k73 "salata") ; --UNCHK
lin dissimulation_N = mkWN (k39 "huiputus") ; --UNCHK
lin dissimulative_A = mkWA (compoundA "peite" (k1 "tty")) ; --UNCHK
lin dissipate_V = mkWV (k53A "kuluttaa") ; --UNCHK
lin dissipate_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin dissipation_N = mkWN (k10A "hukka") ; --UNCHK
lin dissociable_A = mkWA (k10 "oleva") "erotettavissa" ; --UNCHK
lin dissociate_V2 = mkWV2 (k74 "hajota") ; --UNCHK
lin dissociation_N = mkWN "jakautuminen" ; --UNCHK
lin dissociative_A = mkWA (compoundA "dissosi" (k10 "oiva")) ; --UNCHK
lin dissolubility_N = mkWN (k40 "liukenevuus") ; --UNCHK
lin dissoluble_A = mkWA (compoundA "liuke" (k9 "neva")) ; --UNCHK
lin dissolute_A = mkWA (k38 "paheellinen") ; --UNCHK
lin dissoluteness_N = mkWN (k40 "huikentelevuus") ; --UNCHK
lin dissolution_N = mkWN (compoundN "ero" (k38 "aminen")) ; --UNCHK
lin dissolvable_A = mkWA (compoundA "liuke" (k9 "neva")) ; --UNCHK
lin dissolve_N = mkWN (compoundN "risti" (k10 "kuva")) ; --UNCHK
lin dissolve_V = mkWV (k53A "hajottaa") ; --UNCHK
lin dissolve_V2 = mkWV2 (k53A "hajottaa") ; --UNCHK
lin dissolving_N = mkWN (k39 "liuotus") ; --UNCHK
lin dissonance_N = mkWN (k5 "dissonanssi") ; --UNCHK
lin dissonant_A = mkWA (k10 "poikkeava") "jstak" ; --UNCHK
lin dissuade_V2 = mkWV2 (k63 "saada") "luopumaan" ; --UNCHK
lin dissuasion_N = mkWN (k39 "varoitus") ; --UNCHK
lin dissuasive_A = mkWA (k10 "kieltävä") ; --UNCHK
lin dissyllable_N = mkWN (k9 "sana") "kaksitavuinen" ; --UNCHK
lin distaff_N = mkWN (k12 "värttinä") ; --UNCHK
lin distal_A = mkWA (k36 "uloin") ; --UNCHK
lin distance_N = mkWN (compoundN "väli" (k9 "matka")) ; --UNCHK
lin distance_N3 = L.distance_N3 ;
lin distance_V2 = mkWV2 (k53A "jättää") "jälkeensä" ; --UNCHK
lin distant_A = mkWA (k38 "kaukainen") ;
lin distaste_N = mkWN (k1 "inho") ; --UNCHK
lin distasteful_A = mkWA (k15 "törkeä") ; --UNCHK
lin distastefulness_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin distemper_N = mkWN (k39 "temperamaalaus") ; --UNCHK
lin distend_V = mkWV (k52 "pullistua") ; --UNCHK
lin distend_V2 = mkWV2 (k52 "pullistua") ; --UNCHK
lin distensible_A = mkWA (compoundA "laaje" (k9 "neva")) ; --UNCHK
lin distension_N = mkWN (k10 "laajentuma") ; --UNCHK
lin distention_N = mkWN (k10 "laajentuma") ; --UNCHK
lin distil_V = mkWV (k53A "tiputtaa") ; --UNCHK
lin distil_V2 = mkWV2 (k53A "tiputtaa") ; --UNCHK
lin distillate_N = mkWN (k48 "tisle") ; --UNCHK
lin distillation_N = mkWN (k39 "tislaus") ; --UNCHK
lin distiller_N = mkWN (k2 "tislaamo") ; --UNCHK
lin distillery_N = mkWN (k2 "tislaamo") ; --UNCHK
lin distinct_A = mkWA "erottuva" ;
lin distinction_N = mkWN (k1 "ero") ;
lin distinctive_A = mkWA (k38 "tyypillinen") ; --UNCHK
lin distinctiveness_N = mkWN (k40 "erilaisuus") ; --UNCHK
lin distinctness_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin distinguish_V = mkWV (k73 "huomata") "ero" ; --UNCHK
lin distinguish_V2 = mkV2 "erottaa" partitive ; --mkWV2 (k73 "huomata") "ero" ;
lin distinguishable_A = mkWA "erottuva" ; --UNCHK
lin distinguished_A = variants {} ; --
lin distort_V2 = mkV2 "vääristää" ; --mkWV2 (k54A "rumentaa") ;
lin distortable_A = mkWA "vääristeltävä" ; --UNCHK
lin distortion_N = mkWN (k10 "vääristymä") ; --UNCHK
lin distortionist_N = mkWN (kH1 "maalari") "vääristymiä" "käyttävä" ; --UNCHK
lin distract_V = mkWV (k52 "huolestua") ; --UNCHK
lin distract_V2 = mkWV2 (k52 "huolestua") ; --UNCHK
lin distractedly_Adv = mkWAdv (compoundAdv "poissaolev" (k99 "asti")) ; --UNCHK
lin distraction_N = mkWN "harhaan" "johtaminen" ; --UNCHK
lin distrain_V = mkWV (k62 "takavarikoida") ; --UNCHK
lin distraint_N = mkWN (compoundN "ulos" (k1A "otto")) ; --UNCHK
lin distraught_A = mkWA (k99 "sekaisin") ; --UNCHK
lin distress_N = mkWN (compoundN "ulos" (k1A "otto")) ; --UNCHK
lin distress_V2 = mkWV2 (k53 "ahdistaa") ; --UNCHK
lin distressful_A = mkWA (compoundA "hermos" (k10 "tuttava")) ; --UNCHK
lin distressing_A = mkWA (k38 "surullinen") ; --UNCHK
lin distributary_N = mkWN (compoundN "suu" (k9 "haara")) ; --UNCHK
lin distribute_V2 = mkV2 "levittää" ; --f63
lin distributed_A = variants {} ; --
lin distribution_N = mkN (lin NK {s = d02 "jakelu"}) ;
lin distributional_A = mkWA "jakelu-" ; --UNCHK
lin distributive_A = mkWA "jakelu-" ; --UNCHK
lin distributor_N = mkN "jakelija" ;
lin district_N = mkN "piiri" ;
lin distrust_N = mkWN (k39 "epäilys") ; --UNCHK
lin distrust_V2 = mkWV2 (k67 "epäillä") ; --UNCHK
lin distrustful_A = mkWA (k10 "epäilevä") ; --UNCHK
lin distrustfulness_N = mkWN (k39 "epäilys") ; --UNCHK
lin disturb_V2 = mkWV2 (k53A "vahingoittaa") ; --UNCHK
lin disturbance_N = mkWN (k9A "häirintä") ; --UNCHK
lin disturber_N = mkWN (k4A "häirikkö") ; --UNCHK
lin disturbing_A = variants {} ;
lin disulfiram_N = mkWN "Antabus" ; --UNCHK
lin disunion_N = mkWN (k39 "hajotus") ; --UNCHK
lin disunite_V = mkWV (k56A "jakaa") ; --UNCHK
lin disunite_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin disunity_N = mkWN (k40 "eripuraisuus") ; --UNCHK
lin disuse_N = mkWN (compoundN "laimin" (k5A "lyönti")) ; --UNCHK
lin disused_A = mkWA (compoundA "pois" (k1 "tettu")) "käytöstä" ; --UNCHK
lin disyllabic_A = mkWA (compoundA "kaks" (k38 "itavuinen")) ; --UNCHK
lin disyllable_N = mkWN (k9 "sana") "kaksitavuinen" ; --UNCHK
lin dita_N = mkWN (compoundN "aasiansaitan" (k18 "puu")) ; --UNCHK
lin ditch_N = mkWN (k10 "oja") ; --UNCHK
lin ditch_V = mkWV (k53A "ojittaa") ; --UNCHK
lin ditch_V2 = mkWV2 (k53A "ojittaa") ; --UNCHK
lin dither_N = mkWN (k39 "kiihtymys") ; --UNCHK
lin dither_V = mkWV (k53 "nostaa") "meteli" ; --UNCHK
lin dithering_N = mkWN (k2 "sirottelu") ; --UNCHK
lin dithyramb_N = mkWN (compoundN "ylistys" (k1 "runo")) ; --UNCHK
lin dithyrambic_A = mkWA (k10 "mukaansatempaava") ; --UNCHK
lin ditto_N = mkWN (compoundN "edellä" (k1A "sanottu")) ; --UNCHK
lin ditty_N = mkWN (k1 "laulu") ; --UNCHK
lin diurnal_A = mkWA (compoundA "päivä" (k38 "aikainen")) ; --UNCHK
lin divagate_V = mkWV (k74A "poiketa") ; --UNCHK
lin divagation_N = mkWN (compoundN "kierto" (k19 "tie")) ; --UNCHK
lin divan_N = mkWN (k6 "divaani") ; --UNCHK
lin divan_bed_N = mkWN (k6 "divaani") ; --UNCHK
lin divarication_N = mkWN (compoundN "kas" (k38 "vaminen")) "hajalleen" ; --UNCHK
lin dive_N = mkWN (k1 "syöksy") ; --UNCHK
lin dive_V = mkWV (k54A "sukeltaa") ;
lin dive_bomber_N = mkWN (compoundN "syöksy" (k10 "pommittaja")) ; --UNCHK
lin diver_N = mkWN (k10A "kuikka") ; --UNCHK
lin diverge_V = mkWV (k52A "erkaantua") ; --UNCHK
lin divergence_N = mkWN (compoundN "haa" (k38 "rautuminen")) ; --UNCHK
lin divergency_N = mkWN (compoundN "haa" (k38 "rautuminen")) ; --UNCHK
lin divergent_A = mkWA (k10 "menevä") "erilleen" ; --UNCHK
lin divers_A = mkWA (k38 "erilainen") ; --UNCHK
lin diverse_A = mkWA (k38 "erilainen") ;
lin diverseness_N = mkWN (k40 "moninaisuus") ; --UNCHK
lin diversification_N = mkWN (compoundN "moni" (k38 "puolistaminen")) ; --UNCHK
lin diversify_V = mkWV (k52A "laajentua") ; --UNCHK
lin diversify_V2 = mkWV2 (k52A "laajentua") ; --UNCHK
lin diversion_N = mkWN (compoundN "kierto" (k19 "tie")) ; ---ARB --mkN "huvitus" ;
lin diversionary_A = mkWA (compoundA "harh" (k10 "auttava")) ; --UNCHK
lin diversionist_N = mkWN (k10 "tuhoaja") ; --UNCHK
lin diversity_N = mkN "moni" (mkN "puolisuus") ; --mkWN "vaihtelevuus" ;
lin divert_V = mkWV (k53A "harhauttaa") ; --UNCHK
lin diverticulitis_N = mkWN (k39 "tulehdus") "umpipussin" ; --UNCHK
lin diverticulosis_N = mkWN (compoundN "divertiku" (k5 "loosi")) ; --UNCHK
lin diverticulum_N = mkWN (compoundN "umpi" (k5 "pussi")) ; --UNCHK
lin divertimento_N = mkWN (k5 "serenadi") ; --UNCHK
lin divest_V2 = mkWV2 (k52A "riisuuntua") ; --UNCHK
lin divestiture_N = mkWN (k5A "myynti") "toimintojen" ; --UNCHK
lin dividable_A = mkWA (k38 "jaollinen") ; --UNCHK
lin divide_N = mkWN (compoundN "veden" (k10 "jakaja")) ; --UNCHK
lin divide_V = mkV "jakautua" ; --WV (k56A "jakaa") ;
lin divide_V2 = mkWV2 (k56A "jakaa") ;
lin divide_up_V2 = prepV2 OP_divide_V OP_up_Prep ; -- guess-p-verb
lin dividend_N = mkWN (k1A "osinko") ;
lin dividend_warrant_N = mkWN (compoundN "osinko" (k1A "lippu")) ; --UNCHK
lin divider_N = mkWN (k10 "jakaja") ; --UNCHK
lin divination_N = mkWN "divinaatio" ; --UNCHK
lin divinatory_A = mkWA (k38 "hypoteettinen") ; --UNCHK
lin divine_A = mkWA (k38 "taivaallinen") ; --UNCHK
lin divine_N = mkWN (compoundN "Kaikki" (k41 "valtias")) ; --UNCHK
lin diviner_N = mkWN (k10 "tietäjä") ; --UNCHK
lin diving_N = mkWN (k39 "sukellus") ; --UNCHK
lin diving_bell_N = mkWN (compoundN "sukellus" (k1 "kello")) ; --UNCHK
lin diving_board_N = mkWN (compoundN "ponnahdus" (k9A "lauta")) ; --UNCHK
lin diving_dress_N = mkWN (compoundN "sukellus" (k1A "puku")) ; --UNCHK
lin diving_suit_N = mkWN (compoundN "sukellus" (k1A "puku")) ; --UNCHK
lin divinity_N = mkWN (k40 "jumaluus") ; --UNCHK
lin divisibility_N = mkWN (k40 "jaollisuus") ; --UNCHK
lin divisible_A = mkWA (k10 "jaettava") ; --UNCHK
lin division_1_N = mkN "osasto" ;
lin division_2_N = mkN "divisioona" ;
lin division_3_N = mkN "jako" (mkN "lasku") ;
lin division_N = mkN "osasto" ;
lin divisional_A = mkWA "divisioonan" ; --UNCHK
lin divisor_N = mkWN (k10 "jakaja") ; --UNCHK
lin divorce_N = mkWN (k1 "ero") ; --UNCHK
lin divorce_V2 = mkWV2 (k52A "erottautua") ; --UNCHK
lin divot_N = mkWN (compoundN "turpeen" (k9 "pala")) ; --UNCHK
lin divulge_V2 = mkWV2 (k52A "kertoa") ; --UNCHK
lin divulgence_N = mkWN (k39 "paljastus") ; --UNCHK
lin divvy_N = mkWN (k40 "osuus") ; --UNCHK
lin divvy_up_V2 = mkWV2 (k67 "annostella") ; --UNCHK
lin dixie_N = mkWN (compoundN "kenttä" (k12 "kattila")) ; --UNCHK
lin dizygotic_A = mkWA "erimunaiset" ; --UNCHK
lin dizziness_N = mkWN (k39 "pyörrytys") ; --UNCHK
lin dizzy_A = mkWA (k10 "tyhmä") ; --UNCHK
lin dizzy_V2 = mkWV2 (k73 "huimata") ; --UNCHK
lin dj_N = mkWN (k10A "tiskijukka") ; --UNCHK
lin djibouti_PN = foreignPN "Djibouti" ;
lin djiboutian_A = mkWA (compoundA "djibouti" (k38 "lainen")) ; --UNCHK
lin djiboutian_N = mkWN (compoundN "djibouti" (k38 "lainen")) ; --UNCHK
lin djinn_N = mkWN (k7A "henki") ; --UNCHK
lin dm_N = mkWN (compoundN "desi" (k5 "metri")) ; --UNCHK
lin dna_N = mkWN (k99 "DNA") ; --UNCHK
lin do_N = mkN "teko" ;
lin do_V2 = mkV2 tehda_V ;
lin dobbin_N = mkWN (compoundN "työ" (k38 "hevonen")) ; --UNCHK
lin dobra_N = mkWN "dobra" ; --UNCHK
lin dobson_N = mkWN (compoundN "kaisla" (k1A "korento")) ; --UNCHK
lin docent_N = mkWN (k5A "dosentti") ; --UNCHK
lin docile_A = mkWA (k10 "mukautuva") ; --UNCHK
lin docility_N = mkWN (k40 "mukautuvaisuus") ; --UNCHK
lin dock_N = mkWN (compoundN "töpö" (k10A "häntä")) ; --UNCHK
lin dock_V = mkWV (k62 "telakoida") ; --UNCHK
lin dock_V2 = mkWV2 (k62 "telakoida") ; --UNCHK
lin dockage_N = mkWN (k5A "ankkurointi") ; --UNCHK
lin docker_N = mkWN (k10 "lastaaja") ; --UNCHK
lin docket_N = mkWN (k10 "ohjelma") ; --UNCHK
lin docking_N = mkWN (k5A "ankkurointi") ; --UNCHK
lin dockside_N = mkWN (compoundN "satama-" (k48 "alue")) ; --UNCHK
lin dockyard_N = mkWN (k14A "telakka") ; --UNCHK
lin doctor_N = L.doctor_N ;
lin doctor_V2 = mkWV2 (k53A "hoitaa") ; --UNCHK
lin doctoral_A = mkWA "tohtorin" ; --UNCHK
lin doctorate_N = mkWN (compoundN "tohtorin" (k1 "arvo")) ; --UNCHK
lin doctorfish_N = mkWN (compoundN "tohtori" (k9 "kala")) ; --UNCHK
lin doctorspeak_N = mkWN (compoundN "ammatti" (k26 "kieli")) "lääkäreiden" ; --UNCHK
lin doctrinaire_A = mkWA (k38 "teoreettinen") ; --UNCHK
lin doctrinaire_N = mkWN (k4A "teoreetikko") ; --UNCHK
lin doctrinal_A = mkWA (k38 "dogmaattinen") ; --UNCHK
lin doctrine_N = mkWN (k5A "oppi") ;
lin document_N = mkN "dokumentti" | mkN "asia" (mkN "kirja") ;
lin document_V2 = mkV2 "dokumentoida" partitive ; --mkWV2 (k53 "vahvistaa") ;
lin documentary_A = mkWA (k38 "dokumentaarinen") ; --UNCHK
lin documentary_N = mkWN (k5A "dokumentti") ; --UNCHK
lin documentation_N = mkWN (k39 "vahvistus") ; --UNCHK
lin dodder_N = mkWN (compoundN "humala" (k41 "vieras")) ; --UNCHK
lin dodder_V = mkWV (k52A "vaappua") ; --UNCHK
lin dodderer_N = mkWN (compoundN "vanhuuden" (k1A "heikko")) ; --UNCHK
lin doddery_A = mkWA (k6 "seniili") ; --UNCHK
lin doddle_N = mkWN (compoundN "lasten" (k61A "leikkiä")) ; --UNCHK
lin dodecagon_N = mkWN "kaksitoistakulmio" ; --UNCHK
lin dodecahedron_N = mkWN (compoundN "kaksitoista" (k41A "tahokas")) ; --UNCHK
lin dodge_N = mkWN (compoundN "väistö" (k48A "liike")) ; --UNCHK
lin dodge_V = mkWV (k67A "luikerrella") ; --UNCHK
lin dodge_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin dodgem_N = mkWN (compoundN "sähkö" (k1 "auto")) ; --UNCHK
lin dodger_N = mkWN (compoundN "maissi" (k1A "kakku")) ; --UNCHK
lin dodgy_A = mkWA (k10 "näppärä") ; --UNCHK
lin dodo_N = mkWN "Raphus" "cucullatus" ; --UNCHK
lin doe_N = mkWN (k33A "vaadin") ; --UNCHK
lin doer_N = mkWN (k42 "mies") "toiminnan" ; --UNCHK
lin doeskin_N = mkWN (compoundN "villa" (k6 "satiini")) ; --UNCHK
lin doff_V2 = mkWV2 (k52 "riisua") ; --UNCHK
lin dog_N = L.dog_N ;
lin dog_V2 = mkV2 "seurata" partitive ; --mkWV2 (k56 "ajaa") ;
lin dog_biscuit_N = mkWN (k5 "koirankeksi") ; --UNCHK
lin dog_collar_N = mkWN (k9A "panta") ; --UNCHK
lin dogbane_N = mkWN (compoundN "oleanteri" (k5 "kasvi")) ; --UNCHK
lin doge_N = mkWN "dogi" ; --UNCHK
lin dogfight_N = mkWN (compoundN "koira" (k2 "tappelu")) ; --UNCHK
lin dogfighter_N = mkWN (compoundN "taistelu" (k10 "lentäjä")) ; --UNCHK
lin dogfish_N = mkWN (compoundN "piste" (k18 "hai")) ; --UNCHK
lin doggedly_Adv = mkWAdv (k99 "lujasti") ; --UNCHK
lin doggedness_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin doggerel_N = mkWN (kH1 "ralli") ; --UNCHK
lin doggie_N = mkWN (k5A "rakki") ; --UNCHK
lin dogging_A = mkWA (k41A "sinnikäs") ; --UNCHK
lin doggo_Adv = mkWAdv (k99 "näkyvistä") "poissa" ; --UNCHK
lin doggy_N = mkWN (k5A "rakki") ; --UNCHK
lin doghouse_N = mkWN (k5A "koirankoppi") ; --UNCHK
lin dogleg_N = mkWN (k48A "polveke") ; --UNCHK
lin dog_like_A = mkWA (compoundA "koira" (k38 "mainen")) ; --UNCHK
lin dogma_N = mkWN (k5 "dogmi") ; --UNCHK
lin dogmatic_A = mkWA (k38 "dogmaattinen") ; --UNCHK
lin dogmatism_N = mkWN (k40 "dogmaattisuus") ; --UNCHK
lin dogmatist_N = mkWN (k4A "teoreetikko") ; --UNCHK
lin dogmatize_V = mkWV (k74A "vedota") "opinkappaleisiin" ; --UNCHK
lin dogmatize_V2 = mkWV2 (k74A "vedota") "opinkappaleisiin" ; --UNCHK
lin dogsbody_N = mkWN (k38 "käskyläinen") ; --UNCHK
lin dogsled_N = mkWN (compoundN "koira" (k4A "valjakko")) ; --UNCHK
lin dogtooth_N = mkWN (compoundN "hammas" (k5A "ornamentti")) ; --UNCHK
lin dogtrot_N = mkWN (k10A "hölkkä") "tasainen" ; --UNCHK
lin dogwatch_N = mkWN (compoundN "koiran" (k5A "vahti")) ; --UNCHK
lin dogwood_N = mkWN (k14A "kanukka") ; --UNCHK
lin doh_N = mkWN "do" ; --UNCHK
lin doily_N = mkWN (compoundN "kakku" (k6 "paperi")) ; --UNCHK
lin doing_N = mkN "tekeminen" ;
lin dol_N = mkWN (compoundN "työ" (k3 "ministeriö")) ; --UNCHK
lin dolabriform_A = mkWA (k10 "kaareva") ; --UNCHK
lin dolce_Adv = mkWAdv (k99 "suloisesti") ; --UNCHK
lin dole_N = mkWN (k39 "avustus") ; --UNCHK
lin dole_V2 = mkV2 (mkV "jakaa") partitive ;
lin dole_out_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin doleful_A = mkWA (k10 "sureva") ; --UNCHK
lin dolefulness_N = mkWN (k40 "surullisuus") ; --UNCHK
lin dolichocephalic_A = mkWA (compoundA "pitkäkal" (k38 "loinen")) ; --UNCHK
lin dolichocephalic_N = mkWN (compoundN "pitkäkal" (k38 "loinen")) ; --UNCHK
lin dolichocephaly_N = mkWN "pitkäkalloisuus" ; --UNCHK
lin doliolum_N = mkWN (compoundN "vaippa" (k33 "eläin")) ; --UNCHK
lin doll_N = mkWN (k8A "nukke") ; --UNCHK
lin dollar_N = mkN "dollari" ;
lin dollarfish_N = mkWN "Selene" "setapinnis" ; --UNCHK
lin dollhouse_N = mkWN (compoundN "nukke" (k5A "koti")) ; --UNCHK
lin dollop_N = mkWN (k38 "lusikallinen") ; --UNCHK
lin dolly_N = mkWN (k8A "nukke") ; --UNCHK
lin dolman_N = mkWN (kH1 "viitta") ; --UNCHK
lin dolmen_N = mkWN (k9A "hauta") "kivikautinen" ; --UNCHK
lin dolomite_N = mkWN (k5A "dolomiitti") ; --UNCHK
lin dolomitic_A = mkWA (compoundA "dolomiitti" (k38 "nen")) ; --UNCHK
lin dolor_N = mkWN (k10 "tuska") ; --UNCHK
lin dolorous_A = mkWA (k38 "itkuinen") ; --UNCHK
lin dolour_N = mkWN (k10 "tuska") ; --UNCHK
lin dolourous_A = mkWA (k38 "itkuinen") ; --UNCHK
lin dolphin_N = mkWN (k6 "delfiini") ;
lin dolphinfish_N = mkWN (compoundN "kulta" (k5 "makrilli")) ; --UNCHK
lin dolt_N = mkWN (k5 "pahvi") ; --UNCHK
lin doltish_A = mkWA (k38 "moukkamainen") ; --UNCHK
lin domain_N = mkWN (k39 "tietämys") ; --UNCHK
lin domatium_N = mkWN (k10 "osa") "kaareutuva" "kasvin" ; --UNCHK
lin dombeya_N = mkWN "dombeija" ; --UNCHK
lin dome_N = mkWN (k6 "kupoli") ; --UNCHK
lin domed_A = mkWA (compoundA "hol" (k1A "vattu")) ; --UNCHK
lin domestic_A = mkWA (k38 "kotimainen") ; --f191
lin domestic_N = mkWN (k9A "piika") ; --UNCHK
lin domesticate_V2 = mkWV2 (k53A "kesyttää") ; --UNCHK
lin domestication_N = mkWN (compoundN "kesy" (k38 "ttäminen")) ; --UNCHK
lin domesticity_N = mkWN (compoundN "perhe-" (k10 "elämä")) ; --UNCHK
lin domicile_N = mkWN (k1A "asunto") ; --UNCHK
lin domiciliary_A = mkWA "koti-" ; --UNCHK
lin dominance_N = mkN "valta-" (mkN "asema") ; --mkWN (k5 "dominanssi") ;
lin dominant_A = mkWA (k10 "hallitseva") ; --UNCHK
lin dominant_N = mkWN (k5A "dominantti") ; --UNCHK
lin dominate_V = mkV vOlla "hallitseva" ; --mkWV (k53A "ylittää") ;
lin dominate_V2 = mkV2 (mkV "dominoida") partitive ;
lin domination_N = mkWN (k40 "herruus") ;
lin dominatrix_N = mkWN "dominatrix" ; --UNCHK
lin domineer_V = mkWV (k69 "hallita") "tyrannimaisesti" ; --UNCHK
lin domineeringly_Adv = mkWAdv (k99 "määräävästi") ; --UNCHK
lin dominica_PN = foreignPN "Dominica" ;
lin dominical_A = mkWA "pyhä-" ; --UNCHK
lin dominican_A = mkWA "dominikaani-" ; --UNCHK
lin dominican_N = mkWN (k5 "dominikaani") ; --UNCHK
lin dominie_N = mkWN (k5A "pappi") ; --UNCHK
lin dominion_N = mkWN "Dominion" ; --UNCHK
lin domino_N = mkWN (k2 "domino") ; --UNCHK
lin dominoes_N = mkWN (k2 "domino") ; --UNCHK
lin dominus_N = mkWN (k5A "pappi") ; --UNCHK
lin don_N = mkWN "Don" ; --UNCHK
lin don_PN = foreignPN "Don" ;
lin don_V2 = mkWV2 (k52A "sonnustautua") ; --UNCHK
lin donate_V = mkWV (k53A "lahjoittaa") ; --UNCHK
lin donate_V2 = mkWV2 (k53A "lahjoittaa") ; --UNCHK
lin donation_N = mkWN (k39 "lahjoitus") ;
lin doncaster_PN = foreignPN "Doncaster" ;
lin donegal_PN = foreignPN "Donegal" ;
lin donetsk_PN = foreignPN "Donetsk" ;
lin dong_N = mkWN "dong" ; --UNCHK
lin dongle_N = mkWN (compoundN "suojaus" (k33 "avain")) ; --UNCHK
lin donjon_N = mkWN (k5 "torni") ; --UNCHK
lin donkey_N = mkWN (k5 "aasi") ; --UNCHK
lin donna_N = mkWN (k10 "rouva") ; --UNCHK
lin donnish_A = mkWA (k38 "pikkumainen") ; --UNCHK
lin donor_N = mkWN (k10 "lahjoittaja") ;
lin doodad_N = mkWN (k33A "hilavitkutin") ; --UNCHK
lin doodia_N = mkWN (compoundN "Doo" (k9 "dia")) ; --UNCHK
lin doodle_V = mkWV (k67A "piirrellä") ; --UNCHK
lin doodlebug_N = mkWN (k10A "toukka") "muurahaisleijonan" ; --UNCHK
lin doom_N = mkWN (k1A "loppu") ; --UNCHK
lin doom_V2 = mkV2 "tuomita" ; --mkWV2 (k67 "olla") "määrätty" ;
lin doomed_N = mkWN (k10 "oma") "tuhon" ; --UNCHK
lin door_N = L.door_N ;
lin door_to_door_A = mkA "ovelta ovelle" ;
lin doorbell_N = mkWN (compoundN "ovi" (k6 "summeri")) ; --UNCHK
lin doorcase_N = mkWN (compoundN "oven" (k5 "karmi")) ; --UNCHK
lin doorframe_N = mkWN (compoundN "oven" (k5 "karmi")) ; --UNCHK
lin doorhandle_N = mkWN (compoundN "oven" (k9 "kahva")) ; --UNCHK
lin doorjamb_N = mkWN (compoundN "pihti" (k26 "pieli")) ; --UNCHK
lin doorkeeper_N = mkWN (compoundN "portti" (k5A "vahti")) ; --UNCHK
lin doorknob_N = mkWN (compoundN "oven" (k9 "kahva")) ; --UNCHK
lin doorknocker_N = mkWN (k33A "kolkutin") ; --UNCHK
lin doorlock_N = mkWN (k1A "lukko") "ulko-oven" ; --UNCHK
lin doorman_N = mkWN (compoundN "portti" (k5A "vahti")) ; --UNCHK
lin doormat_N = mkWN (compoundN "kynnys" (k1A "matto")) ; --UNCHK
lin doornail_N = mkWN (k9 "naula") ; --UNCHK
lin doorplate_N = mkWN (compoundN "nimi" (k9A "laatta")) ; --UNCHK
lin doorpost_N = mkWN (compoundN "pihti" (k26 "pieli")) ; --UNCHK
lin doorsill_N = mkWN (k39 "kynnys") ; --UNCHK
lin doorstep_N = mkWN (k39 "kynnys") ; --UNCHK
lin doorstop_N = mkWN (k33A "pidätin") "oven" ; --UNCHK
lin doorstopper_N = mkWN (k33A "pidätin") "oven" ; --UNCHK
lin doorway_N = mkWN (compoundN "ovi" (k1A "aukko")) ; --UNCHK
lin dooryard_N = mkWN (compoundN "taka" (k9 "piha")) ; --UNCHK
lin dopa_N = mkWN (compoundN "dihydroksifenyyliala" (k26 "niini")) ; --UNCHK
lin dopamine_N = mkWN "Intropin" ; --UNCHK
lin dope_N = mkWN (k7 "pilvi") ; --UNCHK
lin dopey_A = mkWA (k34A "älytön") ; --UNCHK
lin doppelganger_N = mkWN (k1 "haamu") ; --UNCHK
lin dora_PN = foreignPN "Dora" ;
lin dorbeetle_N = mkWN (k38 "sontiainen") ; --UNCHK
lin dorchester_PN = foreignPN "Dorchester" ;
lin dordrecht_PN = foreignPN "Dordrecht" ;
lin doric_A = mkWA (k38 "doorilainen") ; --UNCHK
lin dorking_PN = foreignPN "Dorking" ;
lin dormancy_N = mkWN (k40 "liikkumattomuus") ; --UNCHK
lin dormant_A = mkWA "toimimaton" ; --UNCHK
lin dormer_N = mkWN (compoundN "pysty" (k12 "ikkuna")) "vinokaton" ; --UNCHK
lin dormer_window_N = mkWN (compoundN "pysty" (k12 "ikkuna")) "vinokaton" ; --UNCHK
lin dormitory_N = mkWN (k12 "asuntola") ; --UNCHK
lin dormouse_N = mkWN (compoundN "pähkinä" (k24 "hiiri")) ; --UNCHK
lin dorsal_A = mkWA (compoundA "selän" (k38 "puoleinen")) ; --UNCHK
lin dorsiflexion_N = mkWN "taakse" "kääntyminen" ; --UNCHK
lin dorsoventral_A = mkWA (compoundA "pystyaks" (k33 "elin")) ; --UNCHK
lin dorsum_N = mkWN (compoundN "selkä" (k26 "puoli")) ; --UNCHK
lin dortmund_PN = foreignPN "Dortmund" ;
lin dory_N = mkWN (compoundN "pietarin" (k9 "kala")) ; --UNCHK
lin dosage_N = mkWN (k39 "annos") ; --UNCHK
lin dose_N = mkN "annos" ; --mkWN (k1A "lappu") ;
lin dose_V2 = mkWV2 (k73 "huumata") ; --UNCHK
lin dosemeter_N = mkWN (k5 "dosimetri") ; --UNCHK
lin dosimetry_N = mkWN (compoundN "annos" (k39 "mittaus")) ; --UNCHK
lin doss_V = mkWV (k52A "nukkua") ; --UNCHK
lin doss_down_V = mkWV (k52A "nukkua") ; --UNCHK
lin dossal_N = mkWN (k48A "vaate") "alttarin" "peräseinän" ; --UNCHK
lin dosser_N = mkWN (k34A "koditon") ; --UNCHK
lin dot_N = mkWN (k1A "lappu") ; --UNCHK
lin dot_V2 = mkWV2 (k69 "merkitä") "piste" ; --UNCHK
lin dotage_N = mkWN (k5A "seniliteetti") ; --UNCHK
lin dotard_N = mkWN (compoundN "vanhuuden" (k2 "höperö")) ; --UNCHK
lin dote_V = mkWV (k62 "jumaloida") ; --UNCHK
lin dotterel_N = mkWN (compoundN "kerä" (k13 "kurmitsa")) ; --UNCHK
lin dotty_A = mkWA (k47 "höpsähtänyt") ; --UNCHK
lin douai_PN = foreignPN "Douai" ;
lin double_A = mkA "kaksinkertainen" ; --WA (compoundA "kahden" (k38 "arvoinen")) ;
lin double_Adv = mkWAdv (k99 "kaksinkertaisesti") ; --UNCHK
lin double_N = mkWN (k5A "lyönti") "kahden" "pesän" ; --UNCHK
lin double_V = mkWV (k52 "kaksinkertaistua") ;
lin double_V2 = mkWV2 (k52 "kaksinkertaistua") ; --UNCHK
lin double_as_V2 = prepV2 OP_double_V OP_as_Prep ; -- guess-p-verb
lin double_back_V = mkWV (k71 "tehdä") "täyskäännös" ; --UNCHK
lin double_bass_N = mkWN (compoundN "basso" (k1 "viulu")) ; --UNCHK
lin double_check_V2 = variants {} ; -- guess-p-verb
lin double_cross_N = mkWN (k39 "petkutus") ; --UNCHK
lin double_cross_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin double_edged_A = mkA "kaksiteräinen" ;
lin double_entry_N = mkWN (compoundN "kirjan" (k1A "pito")) "kaksinkertainen" ; --UNCHK
lin double_over_V = mkWV (k67 "mennä") "kaksinkerroin" ; --UNCHK
lin double_park_V = variants {} ; -- guess-p-verb
lin double_park_V2 = variants {} ; -- guess-p-verb
lin double_talk_N = mkWN (compoundN "sian" (k9 "saksa")) ; --UNCHK
lin double_up_V = mkWV (k56A "jakaa") ; --UNCHK
lin double_up_as_V2 = prepV2 (advV OP_double_V OP_up_Adv ) OP_as_Prep ; -- guess-p-verb
lin doubler_N = mkWN (compoundN "kertaus" (k48 "kone")) ; --UNCHK
lin doubles_N = mkWN (compoundN "nelin" (k5 "peli")) ; --UNCHK
lin doublespeak_N = mkWN (compoundN "kaksois" (k9A "viestintä")) ; --UNCHK
lin doublet_N = mkWN (k1A "jakku") "miehen" ; --UNCHK
lin double_think_N = mkWN (compoundN "kaksois" (k2 "ajattelu")) ; --UNCHK
lin doubletree_N = mkWN (compoundN "poikki" (k18 "puu")) ; --UNCHK
lin doubling_N = mkWN (compoundN "tupla" (k38 "aminen")) ; --UNCHK
lin doubloon_N = mkWN "dubloni" ; --UNCHK
lin doubt_N = mkN "epäilys" ;
lin doubt_V2 = mkV2 "epäillä" partitive ;
lin doubt_VS = mkWVS (k67 "epäillä") ; --UNCHK
lin doubtful_A = mkWA (k10 "epäilevä") ;
lin doubting_A = mkWA (k38 "skeptinen") ; --UNCHK
lin doubtless_Adv = mkWAdv (k99 "varmaan") ; --UNCHK
lin douche_N = mkWN (k2 "huuhtelu") ; --UNCHK
lin dough_N = mkWN (k12 "taikina") ; --UNCHK
lin doughboy_N = mkWN (k5 "donitsi") ; --UNCHK
lin doughnut_N = mkWN (k5A "munkki") ; --UNCHK
lin doughy_A = mkWA (k38 "taikinainen") ; --UNCHK
lin douglas_PN = foreignPN "Douglas" ;
lin dour_A = mkWA (k15 "äreä") ; --UNCHK
lin douroucouli_N = mkWN "Aotus" "trivirgatus" ; --UNCHK
lin douse_V2 = mkWV2 (k56 "kastaa") ; --UNCHK
lin dove_N = mkWN (k38 "kyyhkynen") ; --UNCHK
lin dovecote_N = mkWN (k9A "kyyhkyslakka") ; --UNCHK
lin dover_PN = foreignPN "Dover" ;
lin dovetail_N = mkWN (k39 "sinkkaus") ; --UNCHK
lin dovetail_V = mkWV (k73A "sinkata") ; --UNCHK
lin dovetail_V2 = mkWV2 (k73A "sinkata") ; --UNCHK
lin dovishness_N = mkWN (compoundN "sodan" (k40 "vastaisuus")) ; --UNCHK
lin dowager_N = mkWN (k7 "leski") ; --UNCHK
lin dowdiness_N = mkWN (compoundN "epä" (k40 "siisteys")) ; --UNCHK
lin dowdy_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin dowdy_N = mkWN (k41 "piiras") ; --UNCHK
lin dowel_N = mkWN (k1A "proppu") ; --UNCHK
lin doweling_N = mkWN (k39 "vaarnaus") ; --UNCHK
lin dower_N = mkWN (k40 "osuus") "lesken" ; --UNCHK
lin dower_V2 = mkWV2 (k53 "varustaa") "myötäjäisillä" ; --UNCHK
lin dowerless_A = mkWA "vailla" "myötäjäisiä" ; --UNCHK
lin dowitcher_N = mkWN (k10 "kahlaaja") ; --UNCHK
lin down_Adv = mkAdv "alhaalla" | mkAdv "alas" ;
lin down_N = mkN "taka" (mkN "isku") ; --mkWN (k39 "yritys") ;
lin down_Prep = mkPrep "alas" partitive ;
lin down_V2 = mkWV2 (k53A "vetää") "maahan" ; --UNCHK
lin downbeat_N = mkWN (compoundN "alas" (k5A "lyönti")) ; --UNCHK
lin downbound_A = mkWA (compoundA "suunt" (k9 "aava")) "alas" ; --UNCHK
lin downcast_A = mkWA (k15 "synkeä") ; --UNCHK
lin downcast_N = mkWN (compoundN "raitisilma" (k1 "kuilu")) ; --UNCHK
lin downdraft_N = mkWN (k1A "alaveto") ; --UNCHK
lin downfall_N = mkWN (k39 "romahdus") ; --UNCHK
lin downfield_A = mkWA "alakentän" ; --UNCHK
lin downfield_Adv = mkWAdv (k99 "alas") "kenttää" ; --UNCHK
lin downgrade_N = mkWN (k40 "kaltevuus") ; --UNCHK
lin downgrade_V2 = mkWV2 (k54A "huonontaa") ; --UNCHK
lin downhearted_A = mkWA (k15 "synkeä") ; --UNCHK
lin downheartedness_N = mkWN (k1 "alakulo") ; --UNCHK
lin downhill_Adv = mkWAdv (k99 "alas") ; --UNCHK
lin downhill_N = mkWN (k5 "slalom") ; --UNCHK
lin downiness_N = mkWN (k40 "pehmeys") ; --UNCHK
lin download_N = mkN "lataus" ;
lin down_market_A = mkWA (k9A "halpa") ; --UNCHK
lin downplay_V2 = mkWV2 (k52 "väheksyä") ; --UNCHK
lin downpour_N = mkWN (k10 "tulva") ; --UNCHK
lin downright_A = mkWA (k9A "silkka") ; --UNCHK
lin downright_Adv = mkWAdv (k99 "läpeensä") ; --UNCHK
lin downrightness_N = mkWN (k40 "rehellisyys") ; --UNCHK
lin downriver_Adv = mkWAdv (k99 "alas") ; --UNCHK
lin downscale_A = mkWA "halpatuotanto-" ; --UNCHK
lin downside_N = mkWN (k26 "puoli") "huono" ; --UNCHK
lin downsize_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin downspin_N = mkWN (compoundN "alas" (k1 "syöksy")) ; --UNCHK
lin downstage_A = mkWA "etunäyttämön" ; --UNCHK
lin downstage_Adv = mkWAdv "kohti" "etunäyttämöä" ; --UNCHK
lin downstage_N = mkWN (compoundN "etu" (k2 "näyttämö")) ; --UNCHK
lin downstairs_Adv = mkWAdv (k99 "alhaalla") ; --UNCHK
lin downstream_A = mkWA "myötävirtaan" ; --UNCHK
lin downstream_Adv = mkWAdv (k99 "alas") ; --UNCHK
lin downstroke_N = mkWN (k1A "alasveto") ; --UNCHK
lin downswing_N = mkWN (k1 "lasku") ; --UNCHK
lin downtime_N = mkWN (k9A "seisonta-aika") ; --UNCHK
lin downtown_A = mkWA (k10 "oleva") "keskustassa" ; --UNCHK
lin downtown_Adv = mkWAdv "keskustassa" ; --UNCHK
lin downtrodden_A = mkWA "poljettu" ; --UNCHK
lin downturn_N = mkWN (k1 "lasku") ; --UNCHK
lin downward_A = mkA (mkN "alaspäin" (mkN "viettävä")) ;
lin downward_Adv = mkWAdv (k99 "alas") ; --UNCHK
lin downwards_Adv = mkWAdv (k99 "alas") ; --UNCHK
lin downwind_A = mkWA (compoundA "suojan" (k38 "puoleinen")) ; --UNCHK
lin downwind_Adv = mkWAdv "myötätuuleen" ; --UNCHK
lin downy_A = mkWA (k38 "silkkinen") ; --UNCHK
lin dowse_N = mkWN "taikavarvulla" "etsiminen" ; --UNCHK
lin dowse_V2 = mkWV2 (k56 "kastaa") ; --UNCHK
lin dowser_N = mkWN (compoundN "taika" (k1A "varpu")) ; --UNCHK
lin dowsing_N = mkWN "taikavarvulla" "etsiminen" ; --UNCHK
lin doxazosin_N = mkWN (compoundN "Card" (k10 "ura")) ; --UNCHK
lin doxepin_N = mkWN "Sinequan" ; --UNCHK
lin doxology_N = mkWN "doksologia" ; --UNCHK
lin doxorubicin_N = mkWN "doksorubisiini" ; --UNCHK
lin doxycycline_N = mkWN "doksisykliini" ; --UNCHK
lin doyen_N = mkWN (k36 "vanhin") ; --UNCHK
lin doyenne_N = mkWN (k36 "vanhin") ; --UNCHK
lin doyley_N = mkWN (compoundN "kakku" (k6 "paperi")) ; --UNCHK
lin doyly_N = mkWN (compoundN "kakku" (k6 "paperi")) ; --UNCHK
lin doze_N = mkWN (k2 "torkahtelu") ; --UNCHK
lin doze_V = mkWV (k52A "nuokkua") ; --UNCHK
lin doze_off_V = mkWV (k61A "pilkkiä") ; --UNCHK
lin dozen_N = mkWN (k12 "tusina") ; --f72
lin dphil_N = mkWN "DPhil" ; --UNCHK
lin drab_A = mkWA (k15 "synkeä") ; --UNCHK
lin draba_N = mkWN (k2 "kynsimö") ; --UNCHK
lin drabness_N = mkWN (compoundN "epä" (k40 "siisteys")) ; --UNCHK
lin dracaena_N = mkWN (compoundN "traakki" (k18 "puu")) ; --UNCHK
lin drachma_N = mkWN (k9 "drakma") ; --UNCHK
lin draconian_A = mkWA "drakoninen" ; --UNCHK
lin dracontium_N = mkWN (compoundN "kärsä" (k9 "kalla")) ; --UNCHK
lin draft_N = mkWN (kH1 "veto") ; --UNCHK
lin draft_V2 = mkWV2 (k52 "kutsua") "palvelukseen" ; --UNCHK
lin draftee_N = mkWN (compoundN "ase" (k38 "velvollinen")) ; --UNCHK
lin drafter_N = mkWN "luonnostelija" ; --UNCHK
lin drafting_N = mkWN (k39 "piirustus") "mekaaninen" ; --UNCHK
lin draftsman_N = mkWN (k12 "suunnittelija") ; --UNCHK
lin drafty_A = mkWA (k38 "vetoinen") ; --UNCHK
lin drag_N = mkN "hidaste" ; ---ARB --mkWN (kH1 "veto") ;
lin drag_V = mkWV (k52A "pitkittyä") ; --UNCHK
lin drag_V2 = mkV2 "vetää" ; ---ARB --mkV2 "raahata" ; --mkV2 "pitkittää" ;
lin drag_down_A = mkWV (k53A "rasittaa") "painollaan" ; --UNCHK
lin drag_down_V = advV OP_drag_V OP_down_Adv ; -- guess-p-verb
lin drag_in_V = mkWV (k58 "sotkea") ; --UNCHK
lin drag_on_V = mkWV (k52A "pitkittyä") ; --UNCHK
lin dragee_N = mkWN (compoundN "lääke" (k48A "rae")) ; --UNCHK
lin draggingly_Adv = mkWAdv (compoundAdv "laahaav" (k99 "asti")) ; --UNCHK
lin draggled_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin dragnet_N = mkWN (k5 "trooli") ; --UNCHK
lin dragoman_N = mkWN (kH1 "tulkki") ; --UNCHK
lin dragon_N = mkWN (k1 "liitolisko") ; --UNCHK
lin dragonet_N = mkWN (k5A "merikokki") ; --UNCHK
lin dragonfly_N = mkWN (compoundN "pirun" (k6 "puntari")) ; --UNCHK
lin dragonhead_N = mkWN (compoundN "amerikanampiais" (k5A "yrtti")) ; --UNCHK
lin dragoon_N = mkWN (compoundN "rakuuna" (k5A "rykmentti")) ; --UNCHK
lin dragoon_V2 = mkWV2 (k53A "pakottaa") ; --UNCHK
lin dragsfjärd_PN = mkPN "Dragsfjärd" ;
lin drain_N = mkWN (k39 "kuivatus") ;
lin drain_V = mkWV (k64 "viedä") "voimat" ; --UNCHK
lin drain_V2 = mkV2 "kuluttaa" partitive ; --mkWV2 (k64 "viedä") "voimat" ;
lin drainage_N = mkWN (k39 "kuivatus") ; --UNCHK
lin drainage_basin_N = mkWN (k41A "allas") ; --UNCHK
lin drainboard_N = mkWN (compoundN "tiski" (k10A "pöytä")) ; --UNCHK
lin draining_board_N = mkWN (compoundN "tiski" (k10A "pöytä")) ; --UNCHK
lin drainpipe_N = mkWN (k6 "viemäri") ; --UNCHK
lin drainplug_N = mkWN (k10A "tulppa") ; --UNCHK
lin drake_N = mkWN (compoundN "uros" (k10 "sorsa")) ; --UNCHK
lin dram_N = mkWN "dram" ; --UNCHK
lin drama_N = mkWN (k40 "dramaattisuus") ; --UNCHK
lin dramatic_A = mkWA (k38 "dramaattinen") ;
lin dramatics_N = mkWN (k9 "draama") ; --UNCHK
lin dramatist_N = mkWN (k5 "dramaturgi") ; --UNCHK
lin dramatization_N = mkWN (k5A "dramatisointi") ; --UNCHK
lin dramatize_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin dramaturgic_A = mkWA (compoundA "dramaturgi" (k38 "nen")) ; --UNCHK
lin dramaturgy_N = mkWN (k6 "teatteri") ; --UNCHK
lin drape_N = mkN "verho" ; ---ARB ; laskeutuminen. plurale tantum.
lin drape_V2 = mkWV2 (k53 "laskostaa") ; --UNCHK
lin draper_N = mkWN (compoundN "kangas" (k41 "kauppias")) ; --UNCHK
lin drastic_A = mkWA (k38 "äärimmäinen") ; --UNCHK
lin draught_N = mkWN (kH1 "veto") ; --UNCHK
lin draught_V2 = mkWV2 (k67A "hahmotella") ; --UNCHK
lin draught_horse_N = mkWN (compoundN "kylmä" (k38 "verinen")) ; --UNCHK
lin draughts_N = mkWN (kH1 "tammi") ; --UNCHK
lin draughtsman_N = mkWN (k12 "suunnittelija") ; --UNCHK
lin draughty_A = mkWA (k38 "vetoinen") ; --UNCHK
lin draw_1_V2 = mkV2 "piirtää" ;
lin draw_2_V2 = mkV2 "vetää" ;
lin draw_N = mkN "tasapeli" ; ---ARB ; arvonta
lin draw_V = mkV "vetää" ;
lin draw_V2 = mkV2 "vetää" ;
lin draw_back_V2 = mkWV2 (k53A "vetää") ; --UNCHK
lin draw_down_V2 = prepV2 OP_draw_V OP_down_Prep ; -- guess-p-verb
lin draw_even_V = advV OP_draw_V OP_even_Adv ; -- guess-p-verb
lin draw_in_V = mkWV (k58 "imeä") ; --UNCHK
lin draw_into_V2 = prepV2 OP_draw_V OP_into_Prep ; -- guess-p-verb
lin draw_off_V = mkWV (k53A "vetää") "pois" ; --UNCHK
lin draw_on_V = advV OP_draw_V OP_on_Adv ; -- guess-p-verb
lin draw_on_V2 = prepV2 OP_draw_V OP_on_Prep ; -- guess-p-verb
lin draw_out_V2 = mkWV2 (k53A "vetää") "ulos" ; --UNCHK
lin draw_up_V = mkWV (k61A "laatia") ; --UNCHK
lin draw_up_V2 = mkWV2 (k61A "laatia") ; --UNCHK
lin drawback_N = mkWN (k9A "haitta") ; --UNCHK
lin drawbar_N = mkWN (compoundN "veto" (k1A "tanko")) ; --UNCHK
lin drawbridge_N = mkWN (compoundN "läppä" (k9A "silta")) ; --UNCHK
lin drawee_N = mkWN (k5A "trassaatti") ; --UNCHK
lin drawer_N = mkWN (k4A "laatikko") ; --UNCHK
lin drawing_N = mkN "piirustus" ; --WN (k1A "otto") ;
lin drawing_board_N = mkWN (compoundN "piirustus" (k9A "lauta")) ; --UNCHK
lin drawing_pin_N = mkWN (k9 "nasta") ; --UNCHK
lin drawing_room_N = mkWN (k5A "salonki") ; --UNCHK
lin drawknife_N = mkWN (compoundN "vuolin" (k30 "veitsi")) ; --UNCHK
lin drawl_N = mkWN (compoundN "puhe" (k9A "tapa")) "venyttelevä" ; --UNCHK
lin drawl_V = mkWV (k53A "venyttää") ; --UNCHK
lin drawl_V2 = mkWV2 (k53A "venyttää") ; --UNCHK
lin drawnwork_N = mkWN (compoundN "revinnäis" (k2 "ompelu")) ; --UNCHK
lin drawstring_N = mkWN (compoundN "kure" (k9 "nauha")) ; --UNCHK
lin dread_N = mkWN (k39 "aavistus") ; --UNCHK
lin dread_V = mkWV (k53A "odottaa") "pelolla" ; --UNCHK
lin dread_V2 = mkWV2 (k53A "odottaa") "pelolla" ; --UNCHK
lin dreadful_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin dreadfulness_N = mkWN (k40 "hirveys") ; --UNCHK
lin dreadlock_N = mkWN (compoundN "rasta" (k5A "letti")) ; --UNCHK
lin dreadnought_N = mkWN (compoundN "panssari" (k9 "laiva")) ; --UNCHK
lin dream_N = mkWN (k10 "unelma") ; --UNCHK
lin dream_V = mkWV (k67 "haaveilla") ;
lin dream_V2 = mkWV2 (k67 "haaveilla") ; --UNCHK
lin dream_of_V2 = prepV2 OP_dream_V OP_of_Prep ; -- guess-p-verb
lin dream_up_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin dreamer_N = mkWN (compoundN "unen" (k12 "näkijä")) ; --UNCHK
lin dreamland_N = mkWN (k18 "maa") "unelmien" ; --UNCHK
lin dreamless_A = mkWA (k34A "näkemätön") "unia" ; --UNCHK
lin dreamlike_A = mkWA (compoundA "epä" (k38 "todellinen")) ; --UNCHK
lin dreamworld_N = mkWN (k18 "maa") "unelmien" ; --UNCHK
lin dreamy_A = mkWA (compoundA "haaveks" (k9 "iva")) ; --UNCHK
lin drear_A = mkWA (k15 "synkeä") ; --UNCHK
lin dreariness_N = mkWN (k40 "ikävystyttävyys") ; --UNCHK
lin dreary_A = mkWA (k15 "synkeä") ; --UNCHK
lin dredge_N = mkWN (compoundN "ruoppaus" (k48 "kone")) ; --UNCHK
lin dredge_V = mkWV (k73A "ruopata") ; --UNCHK
lin dredge_V2 = mkWV2 (k73A "ruopata") ; --UNCHK
lin dredge_up_V2 = mkWV2 (k56 "kaivaa") "esiin" ; --UNCHK
lin dredger_N = mkWN (k10 "ruoppaaja") ; --UNCHK
lin dreg_N = mkWN (k9A "sakka") ; --UNCHK
lin dregs_N = mkWN (k9A "sakka") ; --UNCHK
lin drench_V2 = mkWV2 (k56 "kastaa") ; --UNCHK
lin drenching_N = mkWN (k39 "upotus") ; --UNCHK
lin dresden_PN = foreignPN "Dresden" ;
lin dress_A = mkWA "juhla-" ; --UNCHK
lin dress_N = mkWN (k1A "puku") ; --UNCHK
lin dress_V = mkV "pukeutua" ;
lin dress_V2 = mkV2 "pukea" ;
lin dress_down_V = mkWV (k52A "pukeutua") "rennosti" ; --UNCHK
lin dress_down_V2 = mkWV2 (k52A "pukeutua") "rennosti" ; --UNCHK
lin dress_hanger_N = mkWN (k6 "henkari") ; --UNCHK
lin dress_up_V = mkWV (k52A "pukeutua") ; --UNCHK
lin dress_up_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin dressage_N = mkWN (compoundN "koulu" (k39 "ratsastus")) ; --UNCHK
lin dresser_N = mkWN (k5A "piironki") ; --UNCHK
lin dressing_N = mkWN (k39 "sidos") ; --UNCHK
lin dressing_case_N = mkWN (k5 "nesessääri") ; --UNCHK
lin dressing_down_N = mkWN (k39 "läksytys") ; --UNCHK
lin dressing_gown_N = mkWN (compoundN "kylpy" (k5A "takki")) ; --UNCHK
lin dressing_table_N = mkWN (compoundN "pukeutumis" (k10A "pöytä")) ; --UNCHK
lin dressmaker_N = mkWN (k5 "modisti") ; --UNCHK
lin dressmaking_N = mkWN (compoundN "puku" (k2 "ompelu")) ; --UNCHK
lin dressy_A = mkWA "pyntätty" ; --UNCHK
lin drey_N = mkWN (compoundN "oravan" (k10 "pesä")) ; --UNCHK
lin dribble_N = mkWN (k39 "kuljetus") "pallon" ; --UNCHK
lin dribble_V = mkWV (k73 "kuolata") ; --UNCHK
lin dribble_V2 = mkWV2 (k73 "kuolata") ; --UNCHK
lin dribbler_N = mkWN (compoundN "sotta" (k1A "pytty")) ; --UNCHK
lin driblet_N = mkWN (k12 "pisara") ; --UNCHK
lin drier_N = mkWN (k6 "kuivuri") ; --UNCHK
lin driffield_PN = foreignPN "Driffield" ;
lin drift_N = mkWN (k10 "perä") ; --UNCHK
lin drift_V = mkWV (k52 "kinostua") ; --UNCHK
lin drift_V2 = mkWV2 (k52 "kinostua") ; --UNCHK
lin drift_apart_V = mkWV (k72A "loitota") ; --UNCHK
lin drift_ice_N = mkWN (compoundN "ajo" (k18 "jää")) ; --UNCHK
lin drift_net_N = mkWN (compoundN "ajo" (k1A "verkko")) ; --UNCHK
lin drift_off_V = mkWV (k61A "pilkkiä") ; --UNCHK
lin driftage_N = mkWN (k1A "sorto") ; --UNCHK
lin drifter_N = mkWN (k38 "irtolainen") ; --UNCHK
lin driftfish_N = mkWN (compoundN "polyyppi" (k9 "kala")) ; --UNCHK
lin drifting_N = mkWN "ajelehtiminen" ; --UNCHK
lin drill_N = mkWN (k39 "harjoitus") ; --UNCHK
lin drill_V = mkWV (k53A "harjoituttaa") ;
lin drill_V2 = mkWV2 (k53A "harjoituttaa") ;
lin drilling_N = mkWN (k39 "poraus") ; --UNCHK
lin drink_N = mkN "juoma" ;
lin drink_V = mkV "juoda" ;
lin drink_V2 = L.drink_V2 ;
lin drink_up_V2 = mkWV2 (k64 "juoda") "loppuun" ; --UNCHK
lin drinkable_A = mkWA (k10 "juotava") ; --UNCHK
lin drinker_N = mkWN (k1A "juoppo") ; --UNCHK
lin drinking_N = mkWN (k38 "juominen") ; --UNCHK
lin drinking_bout_N = mkWN (compoundN "juoma" (k27 "kausi")) ; --UNCHK
lin drinking_fountain_N = mkWN (compoundN "juoma" (k1 "suihku")) ; --UNCHK
lin drinking_song_N = mkWN (compoundN "juoma" (k1 "laulu")) ; --UNCHK
lin drinking_water_N = mkWN (compoundN "juoma" (k27 "vesi")) ; --UNCHK
lin drip_N = mkWN (compoundN "tippa" (k10A "nokka")) ; --UNCHK
lin drip_V = mkWV (k57A "kaataa") "tipotellen" ; --UNCHK
lin drip_V2 = mkWV2 (k57A "kaataa") "tipotellen" ; --UNCHK
lin dripless_A = mkWA (k34A "vuotamaton") ; --UNCHK
lin drippiness_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin dripping_N = mkWN "tiputtelu" ; --UNCHK
lin dripping_pan_N = mkWN (compoundN "uuni" (k1 "pannu")) ; --UNCHK
lin drippings_N = mkWN (compoundN "paistin" (k9 "rasva")) ; --UNCHK
lin drippy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin dripstone_N = mkWN (compoundN "vesi" (k9 "lista")) ; --UNCHK
lin drive_N = mkN "ajomatka" ;
lin drive_V = mkV "ajaa" ;
lin drive_V2 = mkV2 "ajaa" partitive ;
lin drive_V2V = mkV2V "ajaa" ;
lin drive_away_V2 = mkWV2 (k54A "hälventää") ; --UNCHK
lin drive_back_V2 = mkWV2 (k52 "torjua") ; --UNCHK
lin drive_by_V = advV OP_drive_V OP_by_Adv ; -- guess-p-verb
lin drive_down_V = advV OP_drive_V OP_down_Adv ; -- guess-p-verb
lin drive_off_V = mkWV (k54A "hälventää") ; --UNCHK
lin drive_out_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin drive_up_V = mkWV (k52 "lähestyä") ; --UNCHK
lin drive_up_V2 = mkWV2 (k52 "lähestyä") ; --UNCHK
lin drivel_N = mkWN (k7A "sylki") ; --UNCHK
lin drivel_V = mkWV (k73 "kuolata") ; --UNCHK
lin driveller_N = mkWN (compoundN "sotta" (k1A "pytty")) ; --UNCHK
lin driverFem_N = mkWN (compoundN "puuykkös" (k9 "maila")) ; --UNCHK
lin driverMasc_N = mkN "ajaja" ;
lin driveshaft_N = mkWN (compoundN "käyttö" (k6 "akseli")) ; --UNCHK
lin driveway_N = mkWN (k19 "tie") ; --UNCHK
lin driving_A = mkA "ajava" ;
lin driving_N = mkWN "ajaminen" ; --UNCHK
lin driving_belt_N = mkWN (compoundN "käyttö" (k9 "hihna")) ; --UNCHK
lin driving_wheel_N = mkWN (compoundN "ohjaus" (k10 "pyörä")) ; --UNCHK
lin drizzle_N = mkWN (k1 "tihku") ; --UNCHK
lin drizzle_V = mkWV (k67 "valella") ; --UNCHK
lin drizzly_A = mkWA (k38 "tihkuinen") ; --UNCHK
lin drogheda_PN = foreignPN "Drogheda" ;
lin drogue_N = mkWN "hidastuslaskuvarjo" ; --UNCHK
lin droitwich_PN = foreignPN "Droitwich" ;
lin droll_A = mkWA (k38 "hassunkurinen") ; --UNCHK
lin drollery_N = mkWN (k9 "pila") ; --UNCHK
lin dromaeosaur_N = mkWN "dromaeosauri" ; --UNCHK
lin dromedary_N = mkWN (k6 "kameli") "yksikyttyräinen" ; --UNCHK
lin dronabinol_N = mkWN "dronabinoli" ; --UNCHK
lin drone_N = mkWN (k38 "työläinen") ; --UNCHK
lin dronfield_PN = foreignPN "Dronfield" ;
lin drool_N = mkWN (k7A "sylki") ; --UNCHK
lin drool_V = mkWV (k73 "kuolata") ; --UNCHK
lin droop_N = mkWN (k10 "painauma") ; --UNCHK
lin droop_V = mkWV (k53A "väsähtää") ; --UNCHK
lin droop_V2 = mkWV2 (k53A "väsähtää") ; --UNCHK
lin droopingly_Adv = mkWAdv (compoundAdv "nuokkuv" (k99 "asti")) ; --UNCHK
lin drop_N = mkN "putoaminen" ;
lin drop_V = mkV "pudota" ;
lin drop_V2 = mkWV2 (k53A "pudottaa") ;
lin drop_around_V = advV OP_drop_V OP_around_Adv ; -- guess-p-verb
lin drop_around_V2 = prepV2 OP_drop_V OP_around_Prep ; -- guess-p-verb
lin drop_away_V = mkWV (k74A "pudota") ; --UNCHK
lin drop_back_V = mkWV (k52A "vetäytyä") "taakse" ; --UNCHK
lin drop_by_V = mkWV (k74A "poiketa") ; --UNCHK
lin drop_curtain_N = mkWN (compoundN "väli" (k1 "verho")) ; --UNCHK
lin drop_in_V = mkWV (k74A "poiketa") ; --UNCHK
lin drop_in_on_V2 = prepV2 (advV OP_drop_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin drop_off_V = mkWV (k61A "pilkkiä") ; --UNCHK
lin drop_off_V2 = mkWV2 (k61A "pilkkiä") ; --UNCHK
lin drop_out_V = mkWV (k53A "keskeyttää") ; --UNCHK
lin drop_out_of_V2 = prepV2 (advV OP_drop_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin drop_over_V = advV OP_drop_V OP_over_Adv ; -- guess-p-verb
lin drop_round_V = advV OP_drop_V OP_round_Adv ; -- guess-p-verb
lin drop_round_V2 = prepV2 OP_drop_V OP_round_Prep ; -- guess-p-verb
lin drop_someone_in_it_V2 = variants {} ; -- guess-p-verb
lin drop_through_V = advV OP_drop_V OP_through_Adv ; -- guess-p-verb
lin dropkick_N = mkWN (k1 "pudotuspotku") ; --UNCHK
lin dropkicker_N = mkWN (compoundN "pudotuspotkai" (k9 "sija")) ; --UNCHK
lin droplet_N = mkWN (k9A "tippa") ; --UNCHK
lin dropline_N = mkWN (compoundN "porras" (k9 "viiva")) ; --UNCHK
lin dropout_N = mkN "keskeyttänyt" ;
lin dropper_N = mkWN (k5A "pipetti") ; --UNCHK
lin dropping_zone_N = mkWN (compoundN "pudotus" (k48 "alue")) ; --UNCHK
lin droppings_N = mkWN (k10A "sonta") ; --UNCHK
lin dropseed_N = mkWN (k10 "heinä") ; --UNCHK
lin dropsical_A = mkWA (compoundA "vesi" (k38 "pöhöinen")) ; --UNCHK
lin dropsy_N = mkWN (k39 "turvotus") ; --UNCHK
lin drosophila_N = mkWN (compoundN "banaani" (k38 "kärpänen")) ; --UNCHK
lin dross_N = mkWN (k10 "kuona") ; --UNCHK
lin drought_N = mkN (lin NK {s = d40 "kuivuus"}) ;
lin drove_N = mkWN (compoundN "kivi" (k9A "taltta")) ; --UNCHK
lin drover_N = mkWN (k32 "paimen") ; --UNCHK
lin drown_V = mkWV (k52A "hukkua") ; --UNCHK
lin drown_V2 = mkWV2 (k52A "hukkua") ; --UNCHK
lin drown_out_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin drowse_N = mkWN (k2 "torkahtelu") ; --UNCHK
lin drowse_V = mkWV (k52A "nuokkua") ; --UNCHK
lin drowse_V2 = mkWV2 (k52A "nuokkua") ; --UNCHK
lin drowsiness_N = mkWN (k40 "raukeus") ; --UNCHK
lin drowsy_A = mkWA (k41 "unelias") ; --UNCHK
lin drub_V2 = mkWV2 (k53A "rökittää") ; --UNCHK
lin drubbing_N = mkWN (k39 "löylytys") ; --UNCHK
lin drudge_N = mkWN (kH1 "peoni") ; --UNCHK
lin drudge_V = mkWV (k53 "uurastaa") ; --UNCHK
lin drudgery_N = mkWN (k39 "uurastus") ; --UNCHK
lin drug_N = mkWN (k48 "huume") | mkN "lääke" ; ---- split
lin drug_V2 = mkWV2 (k73 "huumata") ; --UNCHK
lin drugget_N = mkWN (k41A "huopakangas") ; --UNCHK
lin druggist_N = mkWN (k6 "proviisori") ; --UNCHK
lin drugless_A = mkWA "lääkkeetön" ; --UNCHK
lin drugstore_N = mkWN (k5A "apteekki") ;
lin druid_N = mkWN (k5 "druidi") ; --UNCHK
lin druidism_N = mkWN (compoundN "druid" (k5 "ismi")) ; --UNCHK
lin drum_N = mkWN (compoundN "rumpu" (k9 "kala")) ; --UNCHK
lin drum_V = mkV "rummuttaa" ; --mkWV (k56A "ahtaa") "päähänsä" ;
lin drum_V2 = mkWV2 (k56A "ahtaa") "päähänsä" ; --UNCHK
lin drum_major_N = mkWN (k10 "johtaja") "soittokunnan" ; --UNCHK
lin drum_majorette_N = mkWN (k10 "johtaja") "paraatisoittokunnan" ; --UNCHK
lin drum_out_V2 = mkWV2 (k56A "antaa") "potkut" ; --UNCHK
lin drum_up_V2 = mkWV2 (k74A "koota") ; --UNCHK
lin drumbeat_N = mkWN (k39 "rummutus") ; --UNCHK
lin drumfire_N = mkWN (compoundN "tykistö" (k23 "tuli")) ; --UNCHK
lin drumhead_A = mkWA "pika-" ; --UNCHK
lin drumhead_N = mkWN (k1 "kalvo") ; --UNCHK
lin drumlin_N = mkWN (compoundN "pitkittäis" (k6 "moreeni")) ; --UNCHK
lin drummer_N = mkWN (k6 "rumpali") ; --UNCHK
lin drumming_N = mkWN (k1A "soitto") "rumpujen" ; --UNCHK
lin drumstick_N = mkWN (compoundN "rumpu" (k12 "kapula")) ; --UNCHK
lin drunk_A = mkWA (k38 "humalainen") ; --UNCHK
lin drunk_N = mkWN (k1A "juoppo") ; --UNCHK
lin drunkard_N = mkWN (k38 "humalainen") ; --UNCHK
lin drunken_A = mkWA (k38 "humalainen") ; --UNCHK
lin drunkenness_N = mkWN (k38 "juominen") ; --UNCHK
lin drupaceous_A = mkWA (compoundA "luu" (k38 "marjainen")) ; --UNCHK
lin drupe_N = mkWN (compoundN "luu" (k9 "marja")) ; --UNCHK
lin drupelet_N = mkWN (compoundN "luu" (k9 "marja")) "pieni" ; --UNCHK
lin dry_A = L.dry_A ;
lin dry_N = mkWN (k10 "kannattaja") "kieltolain" ; --UNCHK
lin dry_V = mkWV (k53A "kuivattaa") ; --UNCHK
lin dry_V2 = mkWV2 (k53A "kuivattaa") ; --UNCHK
lin dry_clean_V2 = mkWV2 (compoundV "kuiva" (k66 "pestä")) ; --UNCHK
lin dry_cleaner_N = mkWN (compoundN "pesulan" (k10 "pitäjä")) ; --UNCHK
lin dry_cleaning_N = mkWN (k50 "kuivapesu") ; --UNCHK
lin dry_off_V2 = prepV2 OP_dry_V OP_off_Prep ; -- guess-p-verb
lin dry_out_V = mkWV (k53A "kuivattaa") ; --UNCHK
lin dry_out_V2 = mkWV2 (k53A "kuivattaa") ; --UNCHK
lin dry_up_V = mkWV (k52 "kuivua") ; --UNCHK
lin dry_up_V2 = mkWV2 (k52 "kuivua") ; --UNCHK
lin dry_walling_N = mkWN "kivimuurin" "rakentaminen" ; --UNCHK
lin dryad_N = mkWN (compoundN "metsän" (k1A "neito")) ; --UNCHK
lin dryer_N = mkWN (k6 "kuivuri") ; --UNCHK
lin drygoods_N = mkWN (k50 "lyhyttavara") ; --UNCHK
lin dryness_N = mkWN (k40 "arkipäiväisyys") ; --UNCHK
lin dryopithecine_N = mkWN (k5 "hominidi") ; --UNCHK
lin drypis_N = mkWN (k5A "yrtti") ; --UNCHK
lin dual_A = mkA "duaalinen" ;
lin dualism_N = mkWN (k5 "dualismi") ; --UNCHK
lin dualist_N = mkWN "dualisti" ; --UNCHK
lin dualistic_A = mkWA (k38 "dualistinen") ; --UNCHK
lin duality_N = mkWN (k40 "kahtalaisuus") ; --UNCHK
lin dub_N = mkWN (k39 "dubbaus") ; --UNCHK
lin dub_V2 = mkWV2 (k73 "dubata") ; --UNCHK
lin dub_V3 = mkWV3 (k73 "dubata") ; --UNCHK
lin dubbin_N = mkWN (compoundN "nahka" (k48A "voide")) ; --UNCHK
lin dubbing_N = mkWN (k39 "dubbaus") ; --UNCHK
lin dubiety_N = mkWN (k2 "epäily") ; --UNCHK
lin dubious_A = mkA (mkN "kyseen" (mkN "alainen")) ; --mkWA (k10 "epäilevä") ;
lin dubiousness_N = mkWN (k39 "kysymys") ; --UNCHK
lin dublin_PN = foreignPN "Dublin" ;
lin dubliner_N = mkWN (compoundN "dublini" (k38 "lainen")) ; --UNCHK
lin dubnium_N = mkWN "järjestysluku" "105" ; --UNCHK
lin ducal_A = mkWA (compoundA "herttua" (k38 "llinen")) ; --UNCHK
lin ducat_N = mkWN "dukaatti" ; --UNCHK
lin duce_N = mkWN (k10 "johtaja") ; --UNCHK
lin duchess_N = mkWN (k32A "herttuatar") ; --UNCHK
lin duchy_N = mkWN (compoundN "herttua" (k10A "kunta")) ; --UNCHK
lin duck_N = mkWN (k10 "sorsa") ; --UNCHK
lin duck_V = mkWV (k67A "luikerrella") ; --UNCHK
lin duck_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin duckbill_A = mkWA "nokka-" ; --UNCHK
lin ducking_N = mkWN (compoundN "kas" (k38 "taminen")) ; --UNCHK
lin ducking_stool_N = mkWN (compoundN "rangaistus" (k5 "tuoli")) ; --UNCHK
lin duckling_N = mkWN (compoundN "ankan" (k38 "poikanen")) ; --UNCHK
lin duckpin_N = mkWN (k9 "keila") "matala" ; --UNCHK
lin duckpins_N = mkWN (compoundN "keila" (k5 "peli")) ; --UNCHK
lin duckweed_N = mkWN (k13 "limaska") ; --UNCHK
lin ducky_N = mkWN (k41A "rakas") ; --UNCHK
lin duct_N = mkWN (k7 "putki") ; --UNCHK
lin ductile_A = mkWA (k38 "mukautuvainen") ; --UNCHK
lin ductility_N = mkWN (k40 "taottavuus") ; --UNCHK
lin ductless_A = mkWA "umpi-" ; --UNCHK
lin dud_A = mkWA (k6 "suutari") ; --UNCHK
lin dud_N = mkWN (k5A "floppi") ; --UNCHK
lin dude_N = mkWN (k12 "hienostelija") ; --UNCHK
lin dudgeon_N = mkWN (k9 "vimma") "vihan" ; --UNCHK
lin dudley_PN = foreignPN "Dudley" ;
lin due_A = mkA "asianmukainen" ;
lin due_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin due_N = mkN "oikeus" ; ---ARB --mkN "maksu" ; --mkWN (k10 "osa") ;
lin due_to_Prep = mkPrep "johdosta" ;
lin duel_N = mkWN (compoundN "kaksin" (k2 "kamppailu")) ; --UNCHK
lin duel_V = mkWV (k67 "olla") "kaksintaistelussa" ; --UNCHK
lin dueler_N = mkWN (compoundN "kaksin" (k12 "taistelija")) ; --UNCHK
lin duellist_N = mkWN (compoundN "kaksin" (k12 "taistelija")) ; --UNCHK
lin duenna_N = mkWN (compoundN "seura" (k38 "nainen")) ; --UNCHK
lin duet_N = mkWN (compoundN "kaksin" (k5 "tanssi")) ; --UNCHK
lin duff_N = mkWN (compoundN "luumu" (k41A "vanukas")) ; --UNCHK
lin duffel_N = mkWN (k41A "duffelikangas") ; --UNCHK
lin duffer_N = mkWN (k6 "tunari") ; --UNCHK
lin duffle_N = mkWN (k41A "duffelikangas") ; --UNCHK
lin dug_N = mkWN (k49 "utare") ; --UNCHK
lin dugong_N = mkWN (compoundN "meri" (k10 "lehmä")) ; --UNCHK
lin dugout_N = mkWN (k6 "bunkkeri") ; --UNCHK
lin duisburg_PN = foreignPN "Duisburg" ;
lin duke_N = mkWN (k12 "herttua") ; --UNCHK
lin dukedom_N = mkWN (compoundN "herttua" (k10A "kunta")) ; --UNCHK
lin dukinfield_PN = foreignPN "Dukinfield" ;
lin dulcet_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin dulciana_N = mkWN "huuliäänikerta" ; --UNCHK
lin dulcimer_N = mkWN "dulcimer" ; --UNCHK
lin dull_A = L.dull_A ;
lin dull_V = mkWV (k54A "heikentää") ; --UNCHK
lin dull_V2 = mkWV2 (k54A "heikentää") ; --UNCHK
lin dullard_N = mkWN (k39 "typerys") ; --UNCHK
lin dullness_N = mkWN (k40 "tylsyys") ; --UNCHK
lin dulse_N = mkWN (compoundN "puna" (k10 "levä")) ; --UNCHK
lin duly_AdV = mkAdV "odotetusti" ;
lin duly_Adv = variants {} ; -- mkAdV "odotetusti" ;
lin dumb_A = mkWA (k10A "mykkä") ;
lin dumbarton_PN = foreignPN "Dumbarton" ;
lin dumbbell_N = mkWN (k1 "paino") ; --UNCHK
lin dumbfound_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin dumbness_N = mkWN (k40 "typeryys") ; --UNCHK
lin dumbwaiter_N = mkWN (compoundN "ruoka" (k5 "hissi")) ; --UNCHK
lin dumdum_N = mkWN (k5A "luoti") "räjähtävä" ; --UNCHK
lin dumfries_PN = foreignPN "Dumfries" ;
lin dummy_A = mkWA "vale-" ; --UNCHK
lin dummy_N = mkWN (k13 "paukkupatruuna") ; --UNCHK
lin dump_N = mkWN (k2 "varasto") ; --UNCHK
lin dump_V = mkWV (k73 "tyrmätä") ; --UNCHK
lin dump_V2 = mkV2 (mkV (mkV "heittää") "pois") ; --WV2 (k73 "tyrmätä") ;
lin dumpcart_N = mkWN (compoundN "kotti" (k1 "kärry")) ; --UNCHK
lin dumper_N = mkWN (compoundN "kuorma-" (k1 "auto")) "kääntyvälavainen" ; --UNCHK
lin dumpiness_N = mkWN (k40 "tanakkuus") ; --UNCHK
lin dumping_N = mkWN (k39 "dumppaus") ; --UNCHK
lin dumpling_N = mkWN (k41 "piiras") ; --UNCHK
lin dumps_N = mkWN (k40 "synkkyys") ; --UNCHK
lin dumpy_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin dun_A = mkWA (compoundA "harmaan" (k15 "ruskea")) ; --UNCHK
lin dun_N = mkWN (k38 "hevonen") "harmaanruskea" ; --UNCHK
lin dun_V2 = mkWV2 (k53A "harmaannuttaa") ; --UNCHK
lin duncan_PN = foreignPN "Duncan" ;
lin dunce_N = mkWN (k1 "tollo") ; --UNCHK
lin dundalk_PN = foreignPN "Dundalk" ;
lin dundee_PN = foreignPN "Dundee" ;
lin dunderhead_N = mkWN (k1 "tollo") ; --UNCHK
lin dune_N = mkWN (k5 "dyyni") ;
lin dunfermline_PN = foreignPN "Dunfermline" ;
lin dung_N = mkWN (k10A "sonta") ; --UNCHK
lin dungeon_N = mkWN (compoundN "vanki" (k10 "tyrmä")) ; --UNCHK
lin dunghill_N = mkWN (k3 "tunkio") ; --UNCHK
lin dunk_N = mkWN (k39 "donkkaus") ; --UNCHK
lin dunk_V2 = mkWV2 (k73A "dipata") ; --UNCHK
lin dunker_N = mkWN "kastaja" ; --UNCHK
lin dunkirk_PN = foreignPN "Dunkirk" ;
lin dunoon_PN = foreignPN "Dunoon" ;
lin dunstable_PN = foreignPN "Dunstable" ;
lin duo_N = mkN "duo" ;
lin duodecimal_A = mkWA (compoundA "kaks" (k38 "itoistakantainen")) ; --UNCHK
lin duodenal_A = mkWA "pohjukaissuolen" ; --UNCHK
lin duodenum_N = mkWN (compoundN "pohjukais" (k26 "suoli")) ; --UNCHK
lin duologue_N = mkWN (compoundN "kaksin" (k2 "puhelu")) ; --UNCHK
lin dupe_N = mkWN (k1 "hölmö") "hyväuskoinen" ; --UNCHK
lin dupe_V2 = mkWV2 (k73 "narrata") ; --UNCHK
lin duplex_A = mkWA (compoundA "kaksi" (k38 "suuntainen")) ; --UNCHK
lin duplicable_A = mkWA "kopioitava" ; --UNCHK
lin duplicate_A = mkWA (kH1 "pari") ; --UNCHK
lin duplicate_N = mkWN (k39 "jäljennös") ; --UNCHK
lin duplicate_V2 = mkWV2 (k52 "kaksinkertaistua") ; --UNCHK
lin duplication_N = mkWN (k5A "kopiointi") ; --UNCHK
lin duplicator_N = mkWN (compoundN "kopio" (k48 "kone")) ; --UNCHK
lin duplicity_N = mkWN (k40 "petollisuus") ; --UNCHK
lin durability_N = mkWN (k1 "kesto") ; --UNCHK
lin durable_A = mkA "kestävä" ;
lin durable_N = mkN "kestokulutus" (mkN "hyödyke") ;
lin dural_A = mkWA "kovakalvon" ; --UNCHK
lin durance_N = mkWN (k40 "vankeus") ; --UNCHK
lin duration_N = mkWN (k40 "pituus") ; --UNCHK
lin durative_N = mkWN (k5 "aspekti") "duratiivinen" ; --UNCHK
lin durban_PN = foreignPN "Durban" ;
lin durbar_N = mkWN (compoundN "vastaanotto" (k5 "sali")) ; --UNCHK
lin duress_N = mkWN (k1A "pakko") ; --UNCHK
lin durham_PN = foreignPN "Durham" ;
lin durian_N = mkWN "durio" ; --UNCHK
lin during_Prep = S.during_Prep | postGenPrep "kuluessa" ;
lin durmast_N = mkWN (k7 "talvitammi") ; --UNCHK
lin durra_N = mkWN (k10 "durra") ; --UNCHK
lin durrington_PN = foreignPN "Durrington" ;
lin dursley_PN = foreignPN "Dursley" ;
lin durum_N = mkWN (compoundN "durum" (k10 "vehnä")) ; --UNCHK
lin dusk_N = mkWN (k1 "hämy") ; --UNCHK
lin dusky_A = mkWA (k10 "tumma") ; --UNCHK
lin dust_N = L.dust_N ;
lin dust_V2 = mkWV2 (k53A "tomuttaa") ; --UNCHK
lin dust_bowl_N = mkWN "tomumyrskyalue" ; --UNCHK
lin dust_coat_N = mkWN (k12 "kauhtana") ; --UNCHK
lin dust_jacket_N = mkWN (compoundN "kirjan" (k39 "päällys")) ; --UNCHK
lin dust_sheet_N = mkWN (compoundN "irto" (k38 "päällinen")) ; --UNCHK
lin dust_wrapper_N = mkWN (compoundN "kirjan" (k39 "päällys")) ; --UNCHK
lin dustbin_N = mkWN (k39 "roskis") ; --UNCHK
lin dustcart_N = mkWN (compoundN "jäte" (k1 "auto")) ; --UNCHK
lin dustcloth_N = mkWN (compoundN "tomu" (k1A "riepu")) ; --UNCHK
lin duster_N = mkWN (k1A "syöttö") ; --UNCHK
lin dustiness_N = mkWN (k40 "pölyisyys") ; --UNCHK
lin dustlike_A = mkWA (compoundA "pöly" (k38 "mäinen")) ; --UNCHK
lin dustman_N = mkWN (compoundN "roska" (k5 "kuski")) ; --UNCHK
lin dustmop_N = mkWN (compoundN "pöly" (k5A "moppi")) ; --UNCHK
lin dustpan_N = mkWN (k6 "kihveli") ; --UNCHK
lin dusty_A = mkWA (k10 "koinsyömä") ; --UNCHK
lin dutchFem_N = mkN "hollantilainen" ;
lin dutchMasc_N = mkN "hollantilainen" ;
lin dutch_A = mkA "hollantilainen" ;
lin dutchman_N = mkWN (k38 "hollantilainen") ; --UNCHK
lin duteous_A = mkWA (k38 "kuuliainen") ; --UNCHK
lin dutiable_A = mkWA (compoundA "tullin" (k38 "alainen")) ; --UNCHK
lin dutiful_A = mkWA (k38 "kuuliainen") ; --UNCHK
lin dutifulness_N = mkWN (k40 "kuuliaisuus") ; --UNCHK
lin duty_N = mkN (lin NK {s = d40 "velvollisuus"}) ;
lin duty_free_A = mkA "verovapaa" ;
lin duvet_N = mkWN (kH1 "täkki") ; --UNCHK
lin dwarf_N = mkWN (k3 "kääpiö") ; --UNCHK
lin dwarf_V2 = mkWV2 (k53A "jättää") "pienikokoiseksi" ; --UNCHK
lin dwarfish_A = mkWA (compoundA "kääpiö" (k38 "mäinen")) ; --UNCHK
lin dwarfishness_N = mkWN (compoundN "kääpiömä" (k40 "isyys")) ; --UNCHK
lin dwarfism_N = mkWN (compoundN "kääpiö" (k1 "kasvu")) ; --UNCHK
lin dwell_V = mkWV (k52A "hautoa") ; --UNCHK
lin dwell_on_V2 = mkWV2 (k52A "viipyä") ; --UNCHK
lin dweller_N = mkN "asukas" ;
lin dwelling_N = mkWN (k1A "asunto") ; --UNCHK
lin dwelling_house_N = mkWN (k1A "asunto") ; --UNCHK
lin dwindle_V = mkWV (k72 "vähetä") ; --UNCHK
lin dwindling_N = mkWN "pieneneminen" ; --UNCHK
lin dyarchy_N = mkWN (compoundN "kaksin" (k9A "valta")) ; --UNCHK
lin dybbuk_N = mkWN "dibbuk" ; --UNCHK
lin dye_N = mkWN (k5 "väri") ; --UNCHK
lin dye_V = mkWV (k53A "sävyttää") ;
lin dye_V2 = mkWV2 (k53A "sävyttää") ; --UNCHK
lin dyeing_N = mkWN (k39 "värjäys") ; --UNCHK
lin dyer_N = mkWN (k6 "värjäri") ; --UNCHK
lin dyestuff_N = mkWN (k5 "väri") ; --UNCHK
lin dyewood_N = mkWN (compoundN "väri" (k18 "puu")) ; --UNCHK
lin dyke_N = mkWN (k1A "pato") ; --UNCHK
lin dyke_V = mkWV (k62 "ympäröidä") "vallilla" ; --UNCHK
lin dyke_V2 = mkWV2 (k62 "ympäröidä") "vallilla" ; --UNCHK
lin dynamic_A = mkWA (k38 "dynaaminen") ;
lin dynamic_N = mkWN (k33 "kannustin") ; --UNCHK
lin dynamics_N = mkWN (k9A "kinetiikka") ; --UNCHK
lin dynamism_N = mkWN (k1 "tarmo") ; --UNCHK
lin dynamite_N = mkWN (k5A "dynamiitti") ; --UNCHK
lin dynamite_V2 = mkWV2 (k53A "räjäyttää") "dynamiitilla" ; --UNCHK
lin dynamiter_N = mkWN (compoundN "dynamiitti" (k6 "sankari")) ; --UNCHK
lin dynamo_N = mkWN (k2 "dynamo") ; --UNCHK
lin dynamometer_N = mkWN (k5 "ergometri") ; --UNCHK
lin dynast_N = mkWN (k41 "ruhtinas") ; --UNCHK
lin dynastic_A = mkWA "dynastinen" ; --UNCHK
lin dynasty_N = mkWN (k12 "dynastia") ; --UNCHK
lin dyne_N = mkWN "dyne" ; --UNCHK
lin dysaphia_N = mkWN "kosketustunnon" "häiriintyminen" ; --UNCHK
lin dysarthria_N = mkWN "dysartria" ; --UNCHK
lin dyscalculia_N = mkWN "dyskalkulia" ; --UNCHK
lin dyschezia_N = mkWN (compoundN "ulostamis" (k40 "vaikeus")) ; --UNCHK
lin dyscrasia_N = mkWN (compoundN "dysk" (k12 "rasia")) ; --UNCHK
lin dysentery_N = mkWN (compoundN "puna" (k5A "tauti")) ; --UNCHK
lin dysfunction_N = mkWN (compoundN "toiminta" (k3 "häiriö")) ; --UNCHK
lin dysfunctional_A = mkWA "mukautumaton" ; --UNCHK
lin dysgenesis_N = mkWN "dysgeneesi" ; --UNCHK
lin dysgenic_A = mkWA "rappeuttava" ; --UNCHK
lin dysgenics_N = mkWN (compoundN "rappeutumis" (k5A "oppi")) ; --UNCHK
lin dysgraphia_N = mkWN (compoundN "kirjoitus" (k3 "häiriö")) ; --UNCHK
lin dyskinesia_N = mkWN (compoundN "liikunta" (k3 "häiriö")) ; --UNCHK
lin dyslectic_A = mkWA (compoundA "lukihäiri" (k38 "öinen")) ; --UNCHK
lin dyslectic_N = mkWN (compoundN "kirjoitushäiri" (k38 "öinen")) "luku-" "ja" ; --UNCHK
lin dyslexia_N = mkWN (compoundN "luku" (k3 "häiriö")) ; --UNCHK
lin dyslexic_A = mkWA "dysleksinen" ; --UNCHK
lin dyslogia_N = mkWN "aivosyntyinen" "sekavapuheisuus" ; --UNCHK
lin dyslogistic_A = mkWA (k10 "alentava") ; --UNCHK
lin dysmenorrhea_N = mkWN "dysmenorrea" ; --UNCHK
lin dysomia_N = mkWN (k3 "häiriö") "hajuaistin" ; --UNCHK
lin dysosmia_N = mkWN (k3 "häiriö") "hajuaistin" ; --UNCHK
lin dyspepsia_N = mkWN (compoundN "maha" (k5A "tauti")) ; --UNCHK
lin dyspeptic_A = mkWA (k10 "pahoinvoiva") ; --UNCHK
lin dyspeptic_N = mkWN (k38 "ihminen") "ruoansulatushäiriöinen" ; --UNCHK
lin dysphagia_N = mkWN (compoundN "nielemis" (k3 "häiriö")) ; --UNCHK
lin dysphasia_N = mkWN (k12 "dysfasia") ; --UNCHK
lin dysphemism_N = mkWN (compoundN "kierto" (k39 "ilmaus")) "alkuperäistä" "karkeampi" ; --UNCHK
lin dysphemistic_A = mkWA (k10 "alentava") ; --UNCHK
lin dysphonia_N = mkWN (compoundN "ääntö" (k3 "häiriö")) ; --UNCHK
lin dysphoria_N = mkWN (k1 "olo") "epämiellyttävä" ; --UNCHK
lin dysphoric_A = mkWA (k34A "onneton") ; --UNCHK
lin dysplasia_N = mkWN (compoundN "kasvu" (k3 "häiriö")) ; --UNCHK
lin dysplastic_A = mkWA "kasvuhäiriöön" "liittyvä" ; --UNCHK
lin dyspnea_N = mkWN (compoundN "hengen" (k39 "ahdistus")) ; --UNCHK
lin dysprosium_N = mkWN "järjestysluku" "66" ; --UNCHK
lin dysthymia_N = mkWN (k40 "masentuneisuus") "pitkäaikainen" ; --UNCHK
lin dystopia_N = mkWN "dystopia" ; --UNCHK
lin dystopian_A = mkWA "dystopinen" ; --UNCHK
lin dystrophy_N = mkWN (k10 "surkastuma") ; --UNCHK
lin dysuria_N = mkWN (compoundN "virtsaamis" (k3 "häiriö")) ; --UNCHK
lin e'en_Adv = mkWAdv (k99 "tasan") ; --UNCHK
lin e'er_Adv = mkWAdv (k99 "alati") ; --UNCHK
lin e_N = mkWN "e" ; --UNCHK
lin each_Det = mkDet Sg (mkN "jokainen") ;
lin eager_A = mkA "innokas" ;
lin eagerness_N = mkWN (k40 "innokkuus") ;
lin eagle_N = mkWN (k10 "kotka") ; --UNCHK
lin eaglescliffe_PN = foreignPN "Eaglescliffe" ;
lin eaglet_N = mkWN (compoundN "kotkan" (k38 "poikanen")) ; --UNCHK
lin ealing_PN = foreignPN "Ealing" ;
lin ear_N = L.ear_N ;
lin ear_trumpet_N = mkWN (compoundN "kuulo" (k7 "torvi")) ; --UNCHK
lin earache_N = mkWN (compoundN "korva" (k1A "kipu")) ; --UNCHK
lin eardrop_N = mkWN (compoundN "korva" (k41A "rengas")) ; --UNCHK
lin eardrum_N = mkWN (compoundN "täry" (k1 "kalvo")) ; --UNCHK
lin eared_A = mkWA (k38 "-korvainen") ; --UNCHK
lin earflap_N = mkWN (compoundN "korvan" (k39 "suojus")) ; --UNCHK
lin earful_N = mkWN (k39 "läksytys") ; --UNCHK
lin earl_N = mkWN (k5 "kreivi") ; --UNCHK
lin earless_A = mkWA "korvaton" ; --UNCHK
lin earlier_A = mkWA (k16A "aiempi") ; --UNCHK
lin earlier_Adv = mkWAdv (k99 "aiemmin") ;
lin earliness_N = mkWN (k40 "aikaisuus") ; --UNCHK
lin earlobe_N = mkWN (compoundN "korvan" (k14A "nipukka")) ; --UNCHK
lin early_A = mkA "aikainen" ;
lin early_Adv = mkAdv "aikaisin" ;
lin early_on_Adv = mkWAdv (k99 "varhain") ; --UNCHK
lin earlyish_A = mkWA (k99 "aikaisin") "melko" ; --UNCHK
lin earmark_N = mkWN (compoundN "korva" (k5A "merkki")) ; --UNCHK
lin earmark_V2 = mkV2 (mkV "korva" (mkV "merkitä")) ;
lin earmuff_N = mkWN (compoundN "korva" (k1A "lappu")) ; --UNCHK
lin earn_V = mkWV (k53A "tuottaa") ; --f64
lin earn_V2 = mkV2 "ansaita" ;
lin earner_N = mkWN (compoundN "palkan" (k10 "saaja")) ; --UNCHK
lin earnest_A = mkWA (k38 "asiallinen") ; --UNCHK
lin earnest_N = mkWN (k40 "vakuus") ; --UNCHK
lin earnest_money_N = mkWN (compoundN "käsi" (k9 "raha")) ; --UNCHK
lin earnestness_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin earning_N = mkN "ansio" ;
lin earphone_N = mkWN (k48A "kuuloke") ; --UNCHK
lin earpiece_N = mkWN (k48A "kuuloke") ; --UNCHK
lin earplug_N = mkWN (compoundN "korva" (k10A "tulppa")) ; --UNCHK
lin earring_N = mkWN (compoundN "korva" (k41A "rengas")) ; --UNCHK
lin earshot_N = mkWN (compoundN "kuulo" (k9 "matka")) ; --UNCHK
lin earth_N = L.earth_N ;
lin earth_V2 = mkWV2 (k56A "maattaa") ; --UNCHK
lin earthball_N = mkWN (k2 "tuhkelo") ; --UNCHK
lin earthborn_A = mkWA (k38 "kuolevainen") ; --UNCHK
lin earthbound_A = mkWA "maahan" "sidottu" ; --UNCHK
lin earthen_A = mkWA "savi-" ; --UNCHK
lin earthenware_N = mkWN (k9A "keramiikka") ; --UNCHK
lin earthlike_A = mkWA "maan" ; --UNCHK
lin earthly_A = mkWA (k38 "maallinen") ; --UNCHK
lin earthnut_N = mkWN (k6 "tryffeli") ; --UNCHK
lin earthquake_N = mkWN (compoundN "maan" (k39 "järistys")) ; --f263
lin earthshaking_A = mkWA (k10 "mullistava") "maailmaa" ; --UNCHK
lin earthstar_N = mkWN (compoundN "maa" (k7A "tähti")) ; --UNCHK
lin earthtongue_N = mkWN (k26 "sieni") ; --UNCHK
lin earthwork_N = mkWN (compoundN "maa" (k5 "valli")) ; --UNCHK
lin earthworm_N = mkWN (k1 "liero") ; --UNCHK
lin earthy_A = mkWA "maa-" ; --UNCHK
lin earwax_N = mkWN (k1A "vaikku") ; --UNCHK
lin earwig_N = mkWN (compoundN "isopihti" (k10A "häntä")) ; --UNCHK
lin ease_N = mkWN (k1A "lepo") ; --UNCHK
lin ease_V = mkV "lievittyä" ; --f55
lin ease_V2 = mkWV2 (k53A "lievittää") partitive ;
lin ease_off_V2 = mkWV2 (k53A "hellittää") ; --UNCHK
lin ease_up_V = mkWV (k53A "hellittää") ; --UNCHK
lin easel_N = mkWN (compoundN "maalaus" (k48 "teline")) ; --UNCHK
lin easement_N = mkWN (k39 "helpotus") ; --UNCHK
lin easiness_N = mkWN (k40 "mukavuus") ; --UNCHK
lin easing_N = mkWN (k39 "helpotus") ; --UNCHK
lin easington_PN = foreignPN "Easington" ;
lin east_A = mkWA (k38 "itäinen") ;
lin east_Adv = mkWAdv (k99 "päin") "itään" ; --UNCHK
lin east_N = mkWN (k10A "itä") ; --UNCHK
lin eastbourne_PN = foreignPN "Eastbourne" ;
lin easter_N = mkWN (compoundN "itä" (k26 "tuuli")) ; --UNCHK
lin easterly_A = mkWA (k38 "itäinen") ; --UNCHK
lin easterly_Adv = mkWAdv "idästä" | adjAdv easterly_A ; --UNCHK -- derived
lin eastern_A = mkA "itäinen" ;
lin easterner_N = mkWN (k41A "asukas") "itäosan" ; --UNCHK
lin easternmost_A = mkWA "itäisin" ; --UNCHK
lin eastleigh_PN = foreignPN "Eastleigh" ;
lin eastside_A = mkWA (compoundA "itä" (k38 "puolinen")) ; --UNCHK
lin eastward_Adv = mkWAdv (k99 "päin") "itään" ; --UNCHK
lin eastwards_Adv = mkWAdv (k99 "päin") "itään" ; --UNCHK
lin easy_A = mkA "helppo" ;
lin easy_A2V = L.easy_A2V ;
lin easy_Adv = mkWAdv (k99 "helposti") ;
lin easygoing_A = mkWA (k1A "rento") ; --UNCHK
lin easygoingness_N = mkWN (k40 "rentous") ; --UNCHK
lin eat_V = mkV "syödä" ;
lin eat_V2 = L.eat_V2 ;
lin eat_away_V = mkWV (k53A "rapauttaa") ; --UNCHK
lin eat_away_V2 = mkWV2 (k53A "rapauttaa") ; --UNCHK
lin eat_in_V = mkWV (k64 "syödä") "kotona" ; --UNCHK
lin eat_into_V2 = mkWV2 (k53A "jäytää") ; --UNCHK
lin eat_out_V = mkWV (k64 "syödä") "ravintolassa" ; --UNCHK
lin eat_up_V2 = mkWV2 (k53A "kuluttaa") "loppuun" ; --UNCHK
lin eatable_A = mkWA (k10 "syötävä") ; --UNCHK
lin eatable_N = mkWN (k10 "muona") ; --UNCHK
lin eatage_N = mkWN (k4A "nurmikko") ; --UNCHK
lin eater_N = mkWN "syönti-" ; --UNCHK
lin eating_N = mkWN (k2 "ruokailu") ; --UNCHK
lin eating_apple_N = mkWN (compoundN "syönti" (k11 "omena")) ; --UNCHK
lin eating_house_N = mkWN (k12 "ruokala") ; --UNCHK
lin eau_de_cologne_N = mkWN (compoundN "kölnin" (k27 "vesi")) ; --UNCHK
lin eau_de_vie_N = mkWN (k5A "konjakki") ; --UNCHK
lin eaves_N = mkWN (k41 "räystäs") ; --UNCHK
lin eavesdrop_V = mkWV (k67A "kuunnella") "salaa" ; --UNCHK
lin eavesdropper_N = mkWN (compoundN "sala" (k12 "kuuntelija")) ; --UNCHK
lin ebb_N = mkWN (kH1 "luode") ; --UNCHK
lin ebb_V = mkWV (k72A "heiketä") ; --UNCHK
lin ebb_away_V = mkWV (k73A "virrata") "ulos" ; --UNCHK
lin ebbtide_N = mkWN (kH1 "luode") ; --UNCHK
lin eblis_N = mkWN "eblis" ; --UNCHK
lin ebon_A = mkWA (compoundA "sysi" (k10 "musta")) ; --UNCHK
lin ebonite_N = mkWN (k5A "eboniitti") ; --UNCHK
lin ebony_A = mkWA (compoundA "sysi" (k10 "musta")) ; --UNCHK
lin ebony_N = mkWN (k10 "musta") ; --UNCHK
lin ebracteate_A = mkWA "suojuslehdetön" ; --UNCHK
lin ebullience_N = mkWN (k1A "into") ; --UNCHK
lin ebullient_A = mkWA (k41 "uskalias") ; --UNCHK
lin eburnation_N = mkWN "kovettuminen" ; --UNCHK
lin ec_N = mkWN (k2 "yhteisö") "Euroopan" ; --UNCHK
lin ecarte_N = mkWN "ecarte" ; --UNCHK
lin eccentric_A = mkWA (compoundA "epä" (k38 "keskinen")) ; --UNCHK
lin eccentric_N = mkWN (k5A "tyyppi") "outo" ; --UNCHK
lin eccentricity_N = mkWN (k40 "omituisuus") ; --UNCHK
lin ecchymosis_N = mkWN (k10 "mustelma") ; --UNCHK
lin eccles_PN = foreignPN "Eccles" ;
lin ecclesiastic_N = mkWN (k5A "pappi") ; --UNCHK
lin ecclesiastical_A = mkWA (k38 "hengellinen") ; --UNCHK
lin ecclesiasticism_N = mkWN (k40 "kirkollisuus") ; --UNCHK
lin ecclesiology_N = mkWN (compoundN "kirkko-" (k5A "oppi")) ; --UNCHK
lin eccrine_A = mkWA (compoundA "avo" (k38 "eritteinen")) ; --UNCHK
lin ecdemic_A = mkWA "ekdeeminen" ; --UNCHK
lin echelon_N = mkWN (k39 "porrastus") ; --UNCHK
lin echidna_N = mkWN (k5 "nokkasiili") ; --UNCHK
lin echinocactus_N = mkWN (compoundN "siili" (k39 "kaktus")) ; --UNCHK
lin echinococcosis_N = mkWN "ekinokokkoosi" ; --UNCHK
lin echinococcus_N = mkWN (k5A "ekinokokki") ; --UNCHK
lin echinoderm_N = mkWN (compoundN "piikki" (k38 "nahkainen")) ; --UNCHK
lin echinus_N = mkWN "ekinus" ; --UNCHK
lin echo_N = mkWN (k10 "jäljitelmä") ; --UNCHK
lin echo_V = mkWV (k67A "jäljitellä") ; --UNCHK
lin echo_V2 = mkWV2 (k67A "jäljitellä") ; --UNCHK
lin echo_sounder_N = mkWN (compoundN "kaiku" (k33 "luotain")) ; --UNCHK
lin echo_sounding_N = mkWN (compoundN "kaiku" (k39 "luotaus")) ; --UNCHK
lin echocardiogram_N = mkWN (compoundN "kaiku" (k10 "käyrä")) ; --UNCHK
lin echocardiograph_N = mkWN (compoundN "kaikukuvaus" (k48A "laite")) "sydämen" ; --UNCHK
lin echocardiography_N = mkWN (compoundN "kaiku" (k39 "kuvaus")) "sydämen" ; --UNCHK
lin echoencephalogram_N = mkWN (compoundN "röntgen" (k10 "kuva")) "aivojen" ; --UNCHK
lin echoencephalograph_N = mkWN (compoundN "enkefalografia" (k48A "laite")) ; --UNCHK
lin echoencephalography_N = mkWN "enkefalografia" ; --UNCHK
lin echoic_A = mkWA (k38 "onomatopoeettinen") ; --UNCHK
lin echolalia_N = mkWN (compoundN "kaiku" (k1A "hoku")) ; --UNCHK
lin echoless_A = mkWA (k34A "kaiuton") ; --UNCHK
lin echolocation_N = mkWN (compoundN "kaiku" (k39 "luotaus")) ; --UNCHK
lin echovirus_N = mkWN (compoundN "echo" (k39 "virus")) ; --UNCHK
lin eclair_N = mkWN (compoundN "tuuli" (k1A "hattu")) ; --UNCHK
lin eclampsia_N = mkWN (compoundN "kouristus" (k5A "tauti")) ; --UNCHK
lin eclat_N = mkWN (k39 "menestys") "suuri" ; --UNCHK
lin eclectic_A = mkWA (compoundA "valik" (k10 "oiva")) ; --UNCHK
lin eclectic_N = mkWN (k2 "henkilö") "valikoiva" ; --UNCHK
lin eclecticism_N = mkWN (compoundN "eklektis" (k5 "ismi")) ; --UNCHK
lin eclipse_N = mkWN (k39 "pimennys") ; --UNCHK
lin eclipse_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin ecliptic_N = mkWN (k12 "ekliptika") ; --UNCHK
lin eclogue_N = mkWN (k10 "runoelma") "pieni" ; --UNCHK
lin ecobabble_N = mkWN "ekologinen" "jargon" ; --UNCHK
lin ecological_A = mkWA (k38 "ekologinen") ;
lin ecologist_N = mkWN (k5 "ekologi") ; --UNCHK
lin ecology_N = mkWN (k12 "ekologia") ; --UNCHK
lin econometric_A = mkWA (k38 "ekonometrinen") ; --UNCHK
lin econometrics_N = mkWN (k12 "ekonometria") ; --UNCHK
lin economic_A = mkA "taloudellinen" ;
lin economical_A = mkWA (k38 "ekonominen") ; --UNCHK
lin economics_N = mkWN (k12 "ekonomia") ; --UNCHK
lin economist_N = mkWN (k5 "ekonomisti") ; --f211
lin economize_V = mkWV (k53A "käyttää") "säästäväisesti" ; --UNCHK
lin economize_V2 = mkWV2 (k53A "käyttää") "säästäväisesti" ; --UNCHK
lin economizer_N = mkWN (k10 "säästäjä") ; --UNCHK
lin economy_1_N = mkN "talous" ;
lin economy_2_N = mkN "säästö" ;
lin economy_N = mkN "talous" "talouden" "talouksia" ;
lin ecosystem_N = mkWN (compoundN "ekosyste" (k5 "emi")) ; --UNCHK
lin ecoterrorism_N = mkWN (compoundN "sodan" (k5A "käynti")) "ekologinen" ; --UNCHK
lin ecotourism_N = mkWN (compoundN "eko" (k2 "matkailu")) ; --UNCHK
lin ecphonesis_N = mkWN (k39 "huudahdus") ; --UNCHK
lin ecstasy_N = mkWN (k5 "ekstaasi") ; --UNCHK
lin ecstatic_A = mkWA (compoundA "hurmio" (k47 "itunut")) ; --UNCHK
lin ectasia_N = mkWN (k10 "pullistuma") ; --UNCHK
lin ectoderm_N = mkWN (compoundN "ulkoalkio" (k7A "lehti")) ; --UNCHK
lin ectodermal_A = mkWA "ulkoalkiolehteen" "liittyvä" ; --UNCHK
lin ectomorph_N = mkWN "ektomorfi" ; --UNCHK
lin ectomorphic_A = mkWA (compoundA "hintelä" (k38 "rakenteinen")) ; --UNCHK
lin ectoparasite_N = mkWN (compoundN "pinta" (k38 "loinen")) ; --UNCHK
lin ectopia_N = mkWN (k10 "siirtymä") ; --UNCHK
lin ectopic_A = mkWA (compoundA "virhe" (k38 "sijaintinen")) ; --UNCHK
lin ectoplasm_N = mkWN (compoundN "ulko" (k9 "lima")) ; --UNCHK
lin ectoproct_N = mkWN (compoundN "sammal" (k33 "eläin")) ; --UNCHK
lin ectrodactyly_N = mkWN "ektrodaktylia" ; --UNCHK
lin ecuador_PN = foreignPN "Ecuador" ;
lin ecuadorian_A = mkWA (compoundA "ecuadori" (k38 "lainen")) ; --UNCHK
lin ecuadorian_N = mkWN (compoundN "ecuadori" (k38 "lainen")) ; --UNCHK
lin ecumenic_A = mkWA (k38 "ekumeeninen") ; --UNCHK
lin ecumenical_A = mkWA (k5 "universaali") ; --UNCHK
lin ecumenism_N = mkWN (k40 "ekumeenisuus") ; --UNCHK
lin eczema_N = mkWN (k10 "rohtuma") ; --UNCHK
lin ed_PN = foreignPN "Ed" ;
lin edacious_A = mkWA (k34A "kyltymätön") ; --UNCHK
lin edacity_N = mkWN (k40 "ahnaus") ; --UNCHK
lin edaphosaurus_N = mkWN "edaphosaurus" ; --UNCHK
lin eddy_N = mkWN (compoundN "vesi" (k48A "pyörre")) "pieni" ; --UNCHK
lin eddy_V = mkWV (k67A "pyörähdellä") ; --UNCHK
lin edelweiss_N = mkWN (compoundN "alppi" (k7A "tähti")) ; --UNCHK
lin edema_N = mkWN (k39 "turvotus") ; --UNCHK
lin edematous_A = mkWA (compoundA "vesi" (k38 "pöhöinen")) ; --UNCHK
lin eden_PN = foreignPN "Eden" ;
lin edenbridge_PN = foreignPN "Edenbridge" ;
lin edental_A = mkWA (k34A "hampaaton") ; --UNCHK
lin edentate_N = mkWN (k34A "hampaaton") ; --UNCHK
lin edentulous_A = mkWA (k34A "hampaaton") ; --UNCHK
lin edgar_PN = foreignPN "Edgar" ;
lin edge_N = mkN "terä" | mkWN (k10 "särmä") | mkN "reuna" ; ---- split
lin edge_V = mkWV (k53A "teroittaa") ;
lin edge_V2 = mkWV2 (k53A "teroittaa") ; --UNCHK
lin edge_up_V = mkWV (k52A "tunkeutua") ; --UNCHK
lin edgeless_A = mkWA "terätön" ; --UNCHK
lin edger_N = mkWN (compoundN "reuna" (k6 "leikkuri")) ; --UNCHK
lin edgeways_Adv = mkWAdv (k99 "syrjittäin") ; --UNCHK
lin edgewise_Adv = mkWAdv (k99 "syrjittäin") ; --UNCHK
lin edginess_N = mkWN (k40 "rauhattomuus") ; --UNCHK
lin edging_N = mkWN (k39 "reunus") ; --UNCHK
lin edgy_A = mkWA (k15 "kireä") ; --UNCHK
lin edibility_N = mkWN (compoundN "syömä" (k40 "kelpoisuus")) ; --UNCHK
lin edible_A = mkWA (k10 "syötävä") ; --UNCHK
lin edible_N = mkWN (k10 "muona") ; --UNCHK
lin edict_N = mkWN (k39 "asetus") ; --UNCHK
lin edification_N = mkWN (k39 "valistus") ; --UNCHK
lin edifice_N = mkWN (k39 "rakennus") ; --UNCHK
lin edify_V2 = mkWV2 (k53 "valistaa") ; --UNCHK
lin edifying_A = mkWA "valaiseva" ; --UNCHK
lin edinburgh_PN = foreignPN "Edinburgh" ;
lin edit_V2 = mkWV2 (k62 "editoida") ; --UNCHK
lin editing_N = mkWN (k39 "toimitus") ; --UNCHK
lin edition_N = mkWN (k39 "painos") ;
lin editor_N = mkWN (k5 "editori") ; --f80
lin editorial_A = mkA "toimituksellinen" ;
lin editorial_N = mkWN (k5 "kolumni") ;
lin editorship_N = mkWN "päätoimittajuus" ; --UNCHK
lin edmontosaurus_N = mkWN "edmontosaurus" ; --UNCHK
lin edp_N = mkWN (compoundN "tietojen" (k2 "käsittely")) "automaattinen" ; --UNCHK
lin educate_V2 = mkWV2 (k53A "opettaa") ; --UNCHK
lin education_N = mkN "koulutus" | mkN "sivistys" ;
lin educational_A = mkA "kasvatuksellinen" ;
lin educationalist_N = mkWN (k10 "kasvattaja") ; --UNCHK
lin educationist_N = mkWN (k10 "kasvattaja") ; --UNCHK
lin educative_A = mkWA (k38 "opettavainen") ; --UNCHK
lin educator_N = mkN "kouluttaja" ; --kWN (k5 "pedagogi") ;
lin educe_V2 = mkWV2 (k52A "kehittyä") ; --UNCHK
lin edutainment_N = mkWN (compoundN "opetus" (k48A "viihde")) ; --UNCHK
lin edwardian_N = mkWN (k38 "aikalainen") "Edvard" "VII:n" ; --UNCHK
lin eec_N = mkWN (k2 "yhteisö") "Euroopan" ; --UNCHK
lin eeg_N = mkWN (k5 "elektroenkefalogrammi") ; --UNCHK
lin eel_N = mkWN (k41 "ankerias") ; --UNCHK
lin eelblenny_N = mkWN (k41 "ankerias") ; --UNCHK
lin eelgrass_N = mkWN (compoundN "kierre" (k10 "heinä")) "tavallinen" ; --UNCHK
lin eellike_A = mkWA (compoundA "ankerias" (k38 "mainen")) ; --UNCHK
lin eelpout_N = mkWN (kH1 "matikka") ; --UNCHK
lin eelworm_N = mkWN (k38 "ankeroinen") ; --UNCHK
lin eerie_A = mkWA (k10 "pelottava") ; --UNCHK
lin eeriness_N = mkWN (k40 "aavemaisuus") ; --UNCHK
lin eery_A = mkWA (k10 "pelottava") ; --UNCHK
lin eff_V = mkWV (k63 "saada") ; --UNCHK
lin efface_V2 = mkWV2 (k61A "pyyhkiä") "pois" ; --UNCHK
lin effaceable_A = mkWA "poistettava" ; --UNCHK
lin effacement_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin effect_N = mkN "vaikutus" ;
lin effect_V2 = mkV2 "toteuttaa" ;
lin effecter_N = mkWN (k10 "suorittaja") ; --UNCHK
lin effective_A = mkA "toimiva" ;
lin effectiveness_N = mkWN (k1 "teho") ;
lin effects_N = mkWN (k40 "omaisuus") ; --UNCHK
lin effectual_A = mkWA (k41A "tehokas") ; --UNCHK
lin effectuality_N = mkWN (k1 "teho") ; --UNCHK
lin effectualness_N = mkWN (k1 "teho") ; --UNCHK
lin effeminacy_N = mkWN (k40 "pehmeys") ; --UNCHK
lin effeminate_A = mkWA (k38 "feminiininen") ; --UNCHK
lin effendi_N = mkWN (k9 "herra") ; --UNCHK
lin efferent_A = mkWA "vievä" ; --UNCHK
lin effervesce_V = mkWV (k61 "kuplia") ; --UNCHK
lin effervescence_N = mkWN "poreilevuus" ; --UNCHK
lin effervescent_A = mkWA "kuohuva" ; --UNCHK
lin effete_A = mkWA "turmeltunut" ; --UNCHK
lin efficacious_A = mkWA (k41A "tehokas") ; --UNCHK
lin efficacy_N = mkWN (k39 "vaikutus") ; --UNCHK
lin efficiency_N = mkWN (k40 "tehokkuus") ; --UNCHK
lin efficient_A = mkWA (k41A "tehokas") ;
lin effigy_N = mkWN (k10 "kuva") ; --UNCHK
lin effleurage_N = mkWN "hively" ; --UNCHK
lin efflorescence_N = mkWN (k10 "härmä") ; --UNCHK
lin efflorescent_A = mkWA (compoundA "kuk" (k9 "kiva")) ; --UNCHK
lin effluent_A = mkWA (compoundA "ulosvirt" (k9 "aava")) ; --UNCHK
lin effluent_N = mkWN (compoundN "jäte" (k27 "vesi")) ; --UNCHK
lin effluvium_N = mkWN (k1A "vuoto") "vahingollinen" "höyryn" ; --UNCHK
lin efflux_N = mkWN (compoundN "ulos" (k39 "virtaus")) ; --UNCHK
lin effort_N = mkN "ponnistus" ;
lin effortful_A = mkWA (k10 "vaativa") ; --UNCHK
lin effortfulness_N = mkWN (k40 "vaativuus") ; --UNCHK
lin effortless_A = mkWA (k34A "vaivaton") ; --UNCHK
lin effortlessness_N = mkWN (k40 "vaivattomuus") ; --UNCHK
lin effrontery_N = mkWN (k40 "pöyhkeys") ; --UNCHK
lin effulgence_N = mkWN (k48 "loiste") ; --UNCHK
lin effulgent_A = mkWA (k41A "kirkas") ; --UNCHK
lin effusion_N = mkWN "purkautuminen" ; --UNCHK
lin effusive_A = mkWA (k41 "vuolas") ; --UNCHK
lin effusiveness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin eft_N = mkWN (k1 "vesilisko") ; --UNCHK
lin eg_PN = foreignPN "Eg" ;
lin egad_Interj = mkInterj "voi veljet" ;
lin egalitarian_A = mkWA (k34A "luokaton") ; --UNCHK
lin egalitarian_N = mkWN (k10 "kannattava") "tasa-arvoisuutta" ; --UNCHK
lin egalitarianism_N = mkWN (compoundN "egalitar" (k5 "ismi")) ; --UNCHK
lin egality_N = mkWN (compoundN "tasa-" (k1 "arvo")) ; --UNCHK
lin egg_N = L.egg_N ;
lin egg_V2 = mkWV2 (k67A "voidella") "kananmunalla" ; --UNCHK
lin egg_cup_N = mkWN (compoundN "muna" (k5A "kuppi")) ; --UNCHK
lin egg_on_V2 = mkWV2 (k53A "yllyttää") ; --UNCHK
lin eggar_N = mkWN (compoundN "tammi" (k10 "kehrääjä")) ; --UNCHK
lin egg_beater_N = mkWN (k12 "vispilä") ; --UNCHK
lin egghead_N = mkWN "älyniekka" ; --UNCHK
lin eggnog_N = mkWN (compoundN "muna" (k5 "toti")) ; --UNCHK
lin eggplant_N = mkWN (compoundN "muna" (k1 "koiso")) ; --UNCHK
lin eggshake_N = mkWN (k2 "pirtelö") ; --UNCHK
lin eggshell_N = mkWN (k26 "munankuori") ; --UNCHK
lin eglantine_N = mkWN (compoundN "orjan" (k1 "ruusu")) ; --UNCHK
lin ego_N = mkWN (k1 "ego") ; --UNCHK
lin egocentric_A = mkWA (k41A "itsekäs") ; --UNCHK
lin egocentric_N = mkWN (k5 "egoisti") ; --UNCHK
lin egoism_N = mkWN (k40 "itsekkyys") ; --UNCHK
lin egoist_N = mkWN (k5 "egoisti") ; --UNCHK
lin egoistic_A = mkWA (k41A "itsekäs") ; --UNCHK
lin egoistical_A = mkWA (k41A "itsekäs") ; --UNCHK
lin egomania_N = mkWN (compoundN "itse" (k40 "keskeisyys")) "sairaalloinen" ; --UNCHK
lin egomaniac_N = mkWN (k2 "henkilö") "sairaalloisen" "itsekeskeinen" ; --UNCHK
lin egotism_N = mkWN (compoundN "itse" (k40 "keskeisyys")) ; --UNCHK
lin egotist_N = mkWN (k5 "egoisti") ; --UNCHK
lin egotistic_A = mkWA (k38 "turhamainen") ; --UNCHK
lin egotrip_V = mkWV (k53A "käyttää") "itsetehostusta" ; --UNCHK
lin egregious_A = mkWA (k10 "vakava") ; --UNCHK
lin egremont_PN = foreignPN "Egremont" ;
lin egress_N = mkWN (compoundN "ulos" (k1 "tulo")) ; --UNCHK
lin egret_N = mkWN (compoundN "jalo" (k12 "haikara")) ; --UNCHK
lin egypt_PN = foreignPN "Egypti" ;
lin egyptian_A = mkWA (k38 "egyptiläinen") ;
lin egyptian_N = mkWN "Egyptian" ; --UNCHK
lin eider_N = mkWN (k9 "haahka") ; --UNCHK
lin eiderdown_N = mkWN (compoundN "haahkan" (k10 "untuva")) ; --UNCHK
lin eidetic_A = mkWA (k38 "eideettinen") ; --UNCHK
lin eidos_N = mkWN (k1A "muoto") ; --UNCHK
lin eigenvalue_N = mkWN (compoundN "ominais" (k1 "arvo")) "neliömatriisin" ; --UNCHK
lin eightpence_N = mkWN (compoundN "kahdeksan" (k38 "penninen")) ; --UNCHK
lin eightpenny_A = mkWA (compoundA "6,4-sentti" (k38 "metrinen")) ; --UNCHK
lin eindhoven_PN = foreignPN "Eindhoven" ;
lin einsteinium_N = mkWN "järjestysluku" "99" ; --UNCHK
lin eisegesis_N = mkWN "eisegeesi" ; --UNCHK
lin either7or_DConj = S.either7or_DConj ;
lin either_Adv = mkAdv "myöskään" ;
lin either_Det = MorphoFin.mkDetPol False Sg {s = table NForm {nf => (snoun2nounBind (nforms2snoun (dSuurempi "kumpi"))).s ! nf ++ "tahansa"} ; h = Back} ;
lin ejaculate_V2 = mkWV2 "ejakuloida" ; --UNCHK
lin ejaculation_N = mkWN (k39 "huudahdus") ; --UNCHK
lin ejaculator_N = mkWN "huudahtaja" ; --UNCHK
lin eject_V = mkWV (k53A "vapauttaa") ; --UNCHK
lin eject_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin ejection_N = mkWN (compoundN "ulos" (k1A "työntö")) ; --UNCHK
lin ejector_N = mkWN (compoundN "ulos" (k10 "heittäjä")) ; --UNCHK
lin ejector_seat_N = mkWN (compoundN "heitto" (k33 "istuin")) ; --UNCHK
lin eke_V2 = mkV2 (mkV (mkV "saada") "riittämään") ;
lin eke_out_V2 = mkWV2 (k53 "puristaa") ; --UNCHK
lin ekenäs_PN = mkPN "Ekenäs" ;
lin el_dorado_N = mkWN (k1 "eldorado") ; --UNCHK
lin el_salvador_PN = foreignPN "El Salvador" ;
lin elaborate_A = mkWA (k9A "tarkka") ; --UNCHK
lin elaborate_V = mkV (mkV "kehittää") "pidemmälle" ;
lin elaborate_V2 = mkV2 "kehitellä" partitive ; --WV2 (k67A "neuvotella") ;
lin elaborateness_N = mkWN (k40 "taidokkuus") ; --UNCHK
lin elaboration_N = mkWN (k9A "laadinta") "huolellinen" ; --UNCHK
lin elan_N = mkWN (k40 "lennokkuus") ; --UNCHK
lin eland_N = mkWN (compoundN "hirvi" (k5A "antilooppi")) ; --UNCHK
lin elapid_N = mkWN "myrkkytarhakäärme" ; --UNCHK
lin elapse_V = mkWV (k53A "hurahtaa") ; --UNCHK
lin elapsed_A = mkWA (compoundA "kulu" (k47 "nut")) ; --UNCHK
lin elasmobranch_N = mkWN (compoundN "rusto" (k9 "kala")) "leveäsuinen" ; --UNCHK
lin elastance_N = mkWN (compoundN "käänteis" (k1 "arvo")) "kapasitanssin" ; --UNCHK
lin elastic_A = mkWA (k10 "joustava") ; --UNCHK
lin elastic_N = mkWN (k5 "materiaali") "kimmoisa" ; --UNCHK
lin elasticity_N = mkWN (k40 "elastisuus") ; --UNCHK
lin elasticized_A = mkWA "jousto-" ; --UNCHK
lin elastin_N = mkWN "elastiini" ; --UNCHK
lin elastosis_N = mkWN "elastoosi" ; --UNCHK
lin elate_V2 = mkWV2 (k53A "päihdyttää") ; --UNCHK
lin elating_A = mkWA (compoundA "riemas" (k10 "tuttava")) ; --UNCHK
lin elation_N = mkWN (k1 "riemu") ; --UNCHK
lin elbow_N = mkWN (compoundN "kyynär" (k18 "pää")) ; --UNCHK
lin elbowing_N = mkWN (compoundN "työ" (k38 "ntäminen")) "kyynärpäillä" ; --UNCHK
lin elder_A = mkWA (k16A "vanhempi") ; --UNCHK
lin elder_1_N = mkWN (k2 "henkilö") "vanhempi" ; --UNCHK
lin elder_2_N = mkWN (k2 "henkilö") "vanhempi" ; --UNCHK
lin elderberry_N = mkWN (k9 "marja") "seljapensaan" ; --UNCHK
lin elderly_A = mkWA (k41A "iäkäs") ; --UNCHK
lin eldership_N = mkWN (k10 "asema") "vanhimman" ; --UNCHK
lin elderslie_PN = foreignPN "Elderslie" ;
lin eldritch_A = mkWA (k34A "selittämätön") ; --UNCHK
lin eleanor_PN = foreignPN "Eleanor" ;
lin elecampane_N = mkWN (compoundN "iso" (k26 "hirvenjuuri")) ; --UNCHK
lin elect_A = mkWA (k10 "tuleva") ; --UNCHK
lin elect_V = mkV "valita" ;
lin elect_V2 = mkV2 (lin VK {s = c69 "valita"}) ;
lin elect_V2V = mkWV2V (k53A "päättää") ; --UNCHK
lin elect_V3 = mkV3 (mkV "valita") accusative (mkPrep translative) ;
lin elected_A = mkA "valittu" ;
lin election_N = mkN "äänestys" ;
lin electioneering_N = mkWN (k5A "kampanjointi") ; --UNCHK
lin elective_A = mkWA "vaali-" ; --UNCHK
lin elector_N = mkWN (compoundN "vaali" (k41 "ruhtinas")) ; --UNCHK
lin electoral_A = mkA (separateN "vaaleja" (mkN "koskeva" "koskevia")) ; ---?? --WA "valitsija-" ;
lin electorate_N = mkWN (compoundN "valitsija" (k10A "kunta")) ; --UNCHK
lin electric_A = mkA "sähköinen" ; ---ARB WA "sähkö-" ;
lin electric_N = mkWN (compoundN "sähkö" (k1 "auto")) ; --UNCHK
lin electrical_A = mkWA "sähkö-" ; --UNCHK
lin electrician_N = mkWN (compoundN "sähkö" (k42 "mies")) ; --UNCHK
lin electricity_N = mkN "sähkö" ;
lin electrification_N = mkWN (k39 "sähköistys") ; --UNCHK
lin electrify_V2 = mkWV2 (k53 "sähköistää") ; --UNCHK
lin electrifying_A = mkWA (k10 "jännittävä") ; --UNCHK
lin electrocardiogram_N = mkWN (k5 "elektrokardiogrammi") ; --UNCHK
lin electrocardiograph_N = mkWN "sähkökardiografi" ; --UNCHK
lin electrocardiographic_A = mkWA "sähkökardiografiin" "liittyvä" ; --UNCHK
lin electrocautery_N = mkWN (compoundN "sähkö" (k1A "poltto")) ; --UNCHK
lin electrochemical_A = mkWA (compoundA "sähkö" (k38 "kemiallinen")) ; --UNCHK
lin electrochemistry_N = mkWN (compoundN "sähkö" (k12 "kemia")) ; --UNCHK
lin electrocute_V2 = mkWV2 (k53A "teloittaa") "sähkötuolissa" ; --UNCHK
lin electrocution_N = mkWN (compoundN "sähkö" (k39 "teurastus")) ; --UNCHK
lin electrocutioner_N = mkWN (k10 "teloittaja") "sähköllä" ; --UNCHK
lin electrode_N = mkWN (k9A "napa") ; --UNCHK
lin electrodeposition_N = mkWN (compoundN "sähkö" (k38 "saostaminen")) ; --UNCHK
lin electrodynamometer_N = mkWN (compoundN "sähkö" (k5 "dynamometri")) ; --UNCHK
lin electroencephalogram_N = mkWN (k5 "elektroenkefalogrammi") ; --UNCHK
lin electroencephalograph_N = mkWN (compoundN "EEG-" (k48A "laite")) ; --UNCHK
lin electroencephalographic_A = mkWA "EEG-laitteeseen" "liittyvä" ; --UNCHK
lin electrograph_N = mkWN "electrograph" ; --UNCHK
lin electrologist_N = mkWN (k10 "hoitaja") "elektrolyysiä" "käyttävä" ; --UNCHK
lin electrolysis_N = mkWN (k5 "elektrolyysi") ; --UNCHK
lin electrolyte_N = mkWN (k5A "elektrolyytti") ; --UNCHK
lin electrolytic_A = mkWA (k38 "elektrolyyttinen") ; --UNCHK
lin electrolytic_N = mkWN (k6 "kondensaattori") "elektrolyyttinen" ; --UNCHK
lin electromagnet_N = mkWN (compoundN "sähkö" (k5A "magneetti")) ; --UNCHK
lin electromagnetic_A = mkWA (compoundA "sähkö" (k38 "magneettinen")) ; --UNCHK
lin electromagnetism_N = mkWN (compoundN "sähkö" (k5 "magnetismi")) ; --UNCHK
lin electromechanical_A = mkWA (compoundA "sähkö" (k38 "mekaaninen")) ; --UNCHK
lin electrometer_N = mkWN (compoundN "elektro" (k5 "metri")) ; --UNCHK
lin electromotive_A = mkWA (compoundA "sähkö" (k38 "motorinen")) ; --UNCHK
lin electromyogram_N = mkWN (compoundN "lihassähkö" (k10 "käyrä")) ; --UNCHK
lin electromyograph_N = mkWN "elektromyografi" ; --UNCHK
lin electromyography_N = mkWN "elektromyografia" ; --UNCHK
lin electron_N = mkWN (k5 "elektroni") ; --UNCHK
lin electronegativity_N = mkWN (k40 "negatiivisuus") ; --UNCHK
lin electronic_A = mkWA (k38 "elektroninen") ; --f82
lin electronics_N = mkWN (k9A "elektroniikka") ;
lin electrophoresis_N = mkWN "sähköforeesi" ; --UNCHK
lin electrophoretic_A = mkWA (compoundA "katafor" (k38 "eettinen")) ; --UNCHK
lin electrophorus_N = mkWN (compoundN "Electrophorus-" (k1A "suku")) ; --UNCHK
lin electroplate_N = mkWN (k48 "esine") "hopeoitu" ; --UNCHK
lin electroplate_V2 = mkWV2 (k62 "hopeoida") ; --UNCHK
lin electroplater_N = mkWN "galvanoija" ; --UNCHK
lin electroretinogram_N = mkWN "elektroretinogrammi" ; --UNCHK
lin electroscope_N = mkWN (compoundN "elektrosko" (k5A "oppi")) ; --UNCHK
lin electrosleep_N = mkWN (k40 "tajuttomuus") ; --UNCHK
lin electrostatic_A = mkWA (k38 "staattinen") ; --UNCHK
lin electrostatics_N = mkWN (compoundN "sähkö" (k14A "statiikka")) ; --UNCHK
lin electrosurgery_N = mkWN (compoundN "sähkö" (k12 "kirurgia")) ; --UNCHK
lin electrotherapist_N = mkWN (compoundN "asian" (k12 "tuntija")) "sähköhoidon" ; --UNCHK
lin electrotherapy_N = mkWN (compoundN "sähkö" (k1A "hoito")) ; --UNCHK
lin electrum_N = mkWN (k10A "kulta") "hopeapitoinen" ; --UNCHK
lin eleemosynary_A = mkWA (compoundA "hyväntah" (k38 "toinen")) ; --UNCHK
lin elegance_N = mkWN (k5 "tyyli") ; --UNCHK
lin elegant_A = mkA "elegantti" | mkWA (k41A "tyylikäs") ;
lin elegiac_A = mkWA (k38 "eleginen") ; --UNCHK
lin elegist_N = mkWN "elegikko" ; --UNCHK
lin elegy_N = mkWN (k12 "elegia") ; --UNCHK
lin element_N = mkN "alku" (mkN "aine") ;
lin elemental_A = mkWA (compoundA "elementt" (k32A "ien")) ; --UNCHK
lin elementary_A = mkWA "perus-" ; --UNCHK
lin elemi_N = mkWN (compoundN "elemi" (k5 "hartsi")) ; --UNCHK
lin elephant_N = mkWN (k1 "norsu") ;
lin elephantiasis_N = mkWN (compoundN "elefantti" (k5A "tauti")) ; --UNCHK
lin elephantine_A = mkWA (k10 "valtava") ; --UNCHK
lin elevate_V2 = mkWV2 (k53 "nostaa") ; --UNCHK
lin elevation_N = mkWN (compoundN "lisä" (k38 "äminen")) ; --UNCHK
lin elevator_N = mkWN (k5 "hissi") ; --UNCHK
lin elf_N = mkWN (k40 "taajuus") "erittäin" "pieni" ; --UNCHK
lin elfin_A = mkWA "keijukais-" ; --UNCHK
lin elfish_A = mkWA (compoundA "vekkuli" (k38 "mainen")) ; --UNCHK
lin elgin_PN = foreignPN "Elgin" ;
lin elicit_V2 = mkWV2 (k53A "johtaa") ; --UNCHK
lin elicitation_N = mkWN (k38 "tuominen") "esiin" ; --UNCHK
lin elide_V2 = mkWV2 (k53A "jättää") "lausumatta" ; --UNCHK
lin eligibility_N = mkWN (k40 "kelpoisuus") ; --UNCHK
lin eligible_A = mkWA (k41 "sovelias") ; --UNCHK
lin eliminate_V2 = mkV2 (lin VK {s = c53 "poistaa"}) ;
lin elimination_N = mkWN (k5A "eliminointi") ;
lin eliminator_N = mkWN (compoundN "hävitys" (k48 "aine")) ; --UNCHK
lin elimäki_PN = mkPN (mkN "Elimäki" "Elimäkiä") ;
lin elision_N = mkWN (k1 "poisto") ; --UNCHK
lin elite_N = mkWN (k1 "parhaimmisto") ; --UNCHK
lin elitism_N = mkWN (k5 "elitismi") ; --UNCHK
lin elitistFem_N = mkWN "elitisti" ; --UNCHK
lin elitistMasc_N = mkWN "elitisti" ; --UNCHK
lin elixir_N = mkWN (k5 "eliksiiri") ; --UNCHK
lin elizabeth_PN = foreignPN "Elizabeth" ;
lin elizabethan_A = mkWA (k38 "aikainen") "Elisabetin" ; --UNCHK
lin elk_N = mkWN (compoundN "saksan" (k7 "hirvi")) ; --UNCHK
lin ell_N = mkWN (k7A "siipi") ; --UNCHK
lin elland_PN = foreignPN "Elland" ;
lin ellesmere_PN = foreignPN "Ellesmere" ;
lin ellipse_N = mkWN (k6 "ovaali") ; --UNCHK
lin ellipsis_N = mkWN (k5 "ellipsi") ; --UNCHK
lin ellipsoid_A = mkWA (k38 "elliptinen") ; --UNCHK
lin ellipsoid_N = mkWN "ellipsoidi" ; --UNCHK
lin elliptic_A = mkWA (k38 "elliptinen") ; --UNCHK
lin elliptical_A = mkWA (k38 "elliptinen") ; --UNCHK
lin elm_N = mkWN (k10 "jalava") ; --UNCHK
lin elocution_N = mkWN (compoundN "puhe" (k14A "tekniikka")) ; --UNCHK
lin elocutionary_A = mkWA "lausunnallinen" ; --UNCHK
lin elocutionistFem_N = mkWN (k10 "lausuja") ; --UNCHK
lin elocutionistMasc_N = mkWN (k10 "lausuja") ; --UNCHK
lin elongate_V = mkWV (k54A "pidentää") ; --UNCHK
lin elongate_V2 = mkWV2 (k54A "pidentää") ; --UNCHK
lin elongation_N = mkWN "pidentäminen" ; --UNCHK
lin elope_V = mkWV (k73A "karata") ; --UNCHK
lin elopement_N = mkWN "karkaaminen" ; --UNCHK
lin eloquence_N = mkWN (k40 "kaunopuheisuus") ; --UNCHK
lin eloquent_A = mkWA (k10 "puhuva") "miellyttävästi" ; --UNCHK
lin else_Adv = mkAdv "muutoin" ;
lin elsewhere_Adv = mkAdv "muualla" | mkWAdv (k99 "toisaalla") ;
lin elstree_PN = foreignPN "Elstree" ;
lin eluate_N = mkWN "eluaatti" ; --UNCHK
lin elucidate_V2 = mkWV2 (k53 "havainnollistaa") ; --UNCHK
lin elucidation_N = mkWN (k2 "valaisu") ; --UNCHK
lin elude_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin elusive_A = mkA "saavuttamaton" ;
lin elusiveness_N = mkWN (k40 "vaikeaselkoisuus") ; --UNCHK
lin elution_N = mkWN "eluusio" ; --UNCHK
lin elver_N = mkWN (k41 "ankerias") "nuori" ; --UNCHK
lin elves_N = mkWN (compoundN "ilma" (k1 "sähkö")) ; --UNCHK
lin elvish_A = mkWA (compoundA "vekkuli" (k38 "mainen")) ; --UNCHK
lin ely_PN = foreignPN "Ely" ;
lin elysian_A = mkWA (compoundA "elysio" (k38 "lainen")) ; --UNCHK
lin em_N = mkWN (k3 "neliö") ; --UNCHK
lin emaciate_V2 = mkWV2 (k52A "riutua") ; --UNCHK
lin emaciation_N = mkWN (k40 "laihuus") ; --UNCHK
lin email_N = mkN "sähköposti" ;
lin emanate_V = mkWV (k52A "kantautua") ; --UNCHK
lin emanation_N = mkWN (k1A "vuoto") ; --UNCHK
lin emancipate_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin emancipation_N = mkWN (k3 "emansipaatio") ; --UNCHK
lin emancipative_A = mkWA (compoundA "vap" (k10 "auttava")) ; --UNCHK
lin emancipator_N = mkWN (k10 "vapauttaja") ; --UNCHK
lin emarginate_A = mkWA (compoundA "lantto" (k38 "päinen")) ; --UNCHK
lin emasculate_V2 = mkWV2 (k62 "kastroida") ; --UNCHK
lin emasculation_N = mkWN (k9A "kuohinta") ; --UNCHK
lin embalm_V2 = mkWV2 (k62 "palsamoida") ; --UNCHK
lin embalmer_N = mkWN "palsamoija" ; --UNCHK
lin embalmment_N = mkWN (k5A "palsamointi") ; --UNCHK
lin embankment_N = mkWN (k5 "valli") ; --UNCHK
lin embargo_N = mkWN (compoundN "talous" (k1A "saarto")) ;
lin embargo_V2 = mkWV2 (k53 "julistaa") "kauppasaartoon" ; --UNCHK
lin embark_V = mkWV (k52A "uskaltautua") ; --UNCHK
lin embark_V2 = mkWV2 (k52A "uskaltautua") ; --UNCHK
lin embark_on_V2 = mkWV2 (k53 "perustaa") ; --UNCHK
lin embarkation_N = mkWN (k1 "nousu") ; --UNCHK
lin embarrass_V2 = mkV2 "nolata" ; --mkWV2 (k56A "saattaa") "häpeilemään" ;
lin embarrassed_A = mkA "hämmentynyt" ;
lin embarrassing_A = mkWA (k38 "kiusallinen") ;
lin embarrassment_N = mkWN (k10 "määrä") "yletön" ; --UNCHK
lin embassy_N = mkWN (compoundN "suur" (k1 "lähetystö")) ; --UNCHK
lin embattled_A = mkWA (k38 "sakarainen") ; --UNCHK
lin embed_V2 = mkWV2 (k53A "sijoittaa") ; --UNCHK
lin embellish_V2 = mkWV2 (k67 "kaunistella") ; --UNCHK
lin embellishment_N = mkWN (k2 "kaunistelu") ; --UNCHK
lin ember_N = mkWN (k48 "kekäle") ; --UNCHK
lin embezzle_V2 = mkWV2 (k71 "tehdä") "virkarikos" ; --UNCHK
lin embezzlement_N = mkWN (k39 "anastus") ; --UNCHK
lin embezzler_N = mkWN (k10 "kavaltaja") ; --UNCHK
lin embitter_V2 = mkWV2 (k53A "suututtaa") ; --UNCHK
lin embitterment_N = mkWN (k40 "katkeruus") ; --UNCHK
lin emblazon_V2 = mkWV2 (k67 "koristella") ; --UNCHK
lin emblem_N = mkWN (k6 "symboli") ; --UNCHK
lin emblematic_A = mkWA (k38 "symbolinen") ; --UNCHK
lin embodiment_N = mkWN (k10 "ruumiillistuma") ; --UNCHK
lin embody_V2 = mkWV2 (k62 "personoida") ; --UNCHK
lin embolden_V2 = mkWV2 (k53 "kannustaa") ; --UNCHK
lin embolectomy_N = mkWN (k1 "poisto") "veritulpan" ; --UNCHK
lin embolic_A = mkWA "veritulppa-" ; --UNCHK
lin embolism_N = mkWN (compoundN "veri" (k10A "tulppa")) ; --UNCHK
lin embolus_N = mkWN (compoundN "veri" (k10A "tulppa")) ; --UNCHK
lin embonpoint_A = mkWA (k10 "pulska") ; --UNCHK
lin embonpoint_N = mkWN (k40 "pyöreys") ; --UNCHK
lin emboss_V2 = mkWV2 (k73 "leimata") ; --UNCHK
lin embrace_V = mkWV (k52A "liittyä") "jhk" ; --UNCHK
lin embrace_V2 = mkWV2 (k52A "liittyä") "jhk" ; --UNCHK
lin embrasure_N = mkWN (compoundN "ampuma-" (k1A "aukko")) ; --UNCHK
lin embrocation_N = mkWN (k5A "linimentti") ; --UNCHK
lin embroider_V = mkWV (k53A "värittää") ; --UNCHK
lin embroider_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin embroiderer_N = mkWN (compoundN "koru" (k12 "ompelija")) ; --UNCHK
lin embroideress_N = mkWN (compoundN "koru" (k12 "ompelija")) ; --UNCHK
lin embroidery_N = mkWN (k9A "kirjonta") ; --UNCHK
lin embroil_V = mkWV (k58 "sotkea") ; --UNCHK
lin embroil_V2 = mkWV2 (k58 "sotkea") ; --UNCHK
lin embryo_N = mkWN (k3 "alkio") ;
lin embryologist_N = mkWN (k5 "embryologi") ; --UNCHK
lin embryology_N = mkWN (k12 "embryologia") ; --UNCHK
lin embryonic_A = mkWA (k10 "tuleva") ; --UNCHK
lin emeer_N = mkWN (k6 "emiiri") ; --UNCHK
lin emend_V2 = mkWV2 (k67A "parannella") ; --UNCHK
lin emendation_N = mkWN (k39 "parannus") ; --UNCHK
lin emerald_N = mkWN (compoundN "smaragdin" (k15 "vihreä")) ; --UNCHK
lin emerge_V = mkWV (k67 "tulla") "näkyviin" ; --f71
lin emergence_N = mkN "ilmaantuminen" ; ---ARB --mkN "nousu" ; --mkWN (compoundN "ulos" (k1 "tulo")) ;
lin emergency_N = mkN "hätä" (mkN "jarru") ; --f96
lin emeritus_A = mkWA (k47 "täysinpalvellut") ; --UNCHK
lin emeritus_N = mkN "emeritus" ;
lin emery_N = mkWN (k6 "smirgeli") ; --UNCHK
lin emetic_N = mkWN (compoundN "oksetus" (k48 "aine")) ; --UNCHK
lin emigrant_N = mkWN (k5A "emigrantti") ; --UNCHK
lin emigrate_V = mkWV (k52A "emigroitua") ; --UNCHK
lin emigrate_V2V = mkWV2V (k52A "emigroitua") ; --UNCHK
lin emigration_N = mkWN (k39 "karkotus") ; --UNCHK
lin emigre_N = mkWN (k5A "emigrantti") ; --UNCHK
lin eminence_N = mkWN (k12 "nystyrä") ; --UNCHK
lin eminent_A = mkWA (k15 "huikea") ; --UNCHK
lin emir_N = mkWN (k6 "emiiri") ; --UNCHK
lin emirate_N = mkWN (k1 "arvo") "emiirin" ; --UNCHK
lin emissary_N = mkWN (k41 "lähettiläs") ; --UNCHK
lin emission_N = mkN "päästö" ;
lin emit_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin emitter_N = mkN "lähettäjä" ;
lin emmenagogue_N = mkWN (k48A "lääke") "kuukautisia" "edistävä" ; --UNCHK
lin emmer_N = mkWN (compoundN "kaksijyväis" (k10 "vehnä")) ; --UNCHK
lin emmetropia_N = mkWN "oikeataittoisuus" ; --UNCHK
lin emmetropic_A = mkWA (compoundA "emme" (k38 "trooppinen")) ; --UNCHK
lin emoticon_N = mkWN (k3 "hymiö") ; --UNCHK
lin emotion_N = mkWN (k48A "tunne") ; --UNCHK
lin emotional_A = mkA "emotionaalinen" ;
lin emotionality_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin emotionless_A = mkWA (k34A "kiihkoton") ; --UNCHK
lin emotionlessness_N = mkWN (k40 "tunteettomuus") ; --UNCHK
lin emotive_A = mkWA (compoundA "tunnepi" (k38 "toinen")) ; --UNCHK
lin empale_V2 = mkWV2 (k73 "naulata") ; --UNCHK
lin empanel_V2 = mkWV2 (k75 "nimetä") ; --UNCHK
lin empathic_A = mkWA (k38 "empaattinen") ; --UNCHK
lin empathize_V = mkWV (k54A "ymmärtää") ; --UNCHK
lin empathy_N = mkWN (k12 "empatia") ; --UNCHK
lin emperor_N = mkWN (compoundN "häive" (k38 "perhonen")) ; --UNCHK
lin emphasis_N = mkWN (k39 "painotus") ;
lin emphasize_V2 = mkWV2 (k54A "tähdentää") ; --UNCHK
lin emphasize_VS = mkWVS (k54A "tähdentää") ; --UNCHK
lin emphasizing_N = mkWN (compoundN "tähde" (k38 "ntäminen")) ; --UNCHK
lin emphatic_A = mkWA (k41A "voimakas") ; --UNCHK
lin emphysema_N = mkWN (compoundN "keuhko" (k10 "laajentuma")) ; --UNCHK
lin emphysematous_A = mkWA (compoundA "ilma" (k38 "pöhöinen")) ; --UNCHK
lin empire_N = mkWN "Empire" ; --UNCHK
lin empiric_A = mkWA (k38 "kokeellinen") ; --UNCHK
lin empirical_A = mkWA (k38 "kokeellinen") ; --UNCHK
lin empiricism_N = mkWN (k5 "empirismi") ; --UNCHK
lin empiricist_N = mkWN (k5 "empiristi") ; --UNCHK
lin emplacement_N = mkWN (k39 "sijoitus") ; --UNCHK
lin emplane_V = mkWV (k66 "nousta") "lentokoneeseen" ; --UNCHK
lin emplane_V2 = mkWV2 (k66 "nousta") "lentokoneeseen" ; --UNCHK
lin employ_N = mkWN (k25 "toimi") ; --UNCHK
lin employ_V2 = mkV2 "työllistää" ;
lin employable_A = mkWA "työllistettävä" ; --UNCHK
lin employable_N = mkWN "työllistettävä" ; --UNCHK
lin employee_N = mkN "työntekijä" ;
lin employer_N = mkWN (compoundN "työn" (k10 "antaja")) ;
lin employment_N = mkN "työllisyys" ; ---- split
lin emporium_N = mkWN (compoundN "tavara" (k1 "talo")) ; --UNCHK
lin empower_V2 = mkWV2 (k53A "valtuuttaa") ; --UNCHK
lin empower_V2V = mkWV2V (k53A "valtuuttaa") ; --UNCHK
lin empress_N = mkWN (k9 "keisarinna") ; --UNCHK
lin emptiness_N = mkWN (k40 "tyhjänpäiväisyys") ; --UNCHK
lin empty_A = L.empty_A ;
lin empty_N = mkWN (k12 "astia") "tyhjä" ; --UNCHK
lin empty_V = mkWV (k53A "miehittää") ; --UNCHK
lin empty_V2 = mkWV2 (k53A "miehittää") ; --UNCHK
lin emptying_N = mkWN (k5A "evakuointi") ; --UNCHK
lin empurpled_A = mkWA (k38 "mahtipontinen") ; --UNCHK
lin empyema_N = mkWN "ontelomärkimä" ; --UNCHK
lin empyreal_A = mkWA (k38 "taivaallinen") ; --UNCHK
lin empyrean_A = mkWA (k38 "taivaallinen") ; --UNCHK
lin empyrean_N = mkWN (k40 "avaruus") ; --UNCHK
lin emsworth_PN = foreignPN "Emsworth" ;
lin emu_N = mkWN (k1 "emu") ; --UNCHK
lin emulate_V2 = mkWV2 (k55A "yltää") "samaan" ; --UNCHK
lin emulation_N = mkWN (k2 "kilpailu") ; --UNCHK
lin emulous_A = mkWA "kilpaileva" ; --UNCHK
lin emulsifier_N = mkWN (compoundN "emulgointi" (k48 "aine")) ; --UNCHK
lin emulsify_V2 = mkWV2 "maidostua" ; --UNCHK
lin emulsion_N = mkWN (k1 "kalvo") "valonherkkä" ; --UNCHK
lin en_N = mkWN (k41A "puolikas") ; --UNCHK
lin en_clair_Adv = mkWAdv (k99 "selväkielisesti") ; --UNCHK
lin en_famille_Adv = mkWAdv (k99 "kesken") "perheen" ; --UNCHK
lin en_masse_Adv = mkWAdv "ryhmänä" ; --UNCHK
lin en_route_Adv = mkWAdv (compoundAdv "mat" (k9 "kalla")) ; --UNCHK
lin enable_V2 = mkV2 "mahdollistaa" ;
lin enable_V2V = mkWV2V (k71 "tehdä") "kykeneväksi" ;
lin enable_VS = mkVS (mkV "mahdollistaa") ;
lin enabling_A = mkWA "valtuutus-" ; --UNCHK
lin enact_V2 = mkWV2 (k67A "näytellä") partitive ;
lin enact_V2V = mkWV2V (k67A "näytellä") ; --UNCHK
lin enactment_N = mkWN (k9A "tulkinta") ; --UNCHK
lin enalapril_N = mkWN "Vasotec" ; --UNCHK
lin enallage_N = mkWN (k39 "korvaus") ; --UNCHK
lin enamel_N = mkWN (k39 "lasitus") ; --UNCHK
lin enamel_V2 = mkWV2 (k53A "lasittaa") ; --UNCHK
lin enamelware_N = mkWN (compoundN "emali" (k12 "tavara")) ; --UNCHK
lin enamine_N = mkWN "enamiini" ; --UNCHK
lin enamored_A = mkWA (k47 "innostunut") ; --UNCHK
lin enamour_V2 = mkWV2 (k53A "houkuttaa") ; --UNCHK
lin enantiomorph_N = mkWN (k41A "puolikas") "kiteen" "peilikuvamainen" ; --UNCHK
lin enantiomorphism_N = mkWN (k48A "suhde") "peilikuvien" ; --UNCHK
lin enate_A = mkWA (compoundA "äidin" (k38 "puoleinen")) ; --UNCHK
lin enate_N = mkWN (k38 "sukulainen") "äidinpuoleinen" ; --UNCHK
lin encainide_N = mkWN "Enkaid" ; --UNCHK
lin encamp_V = mkWV (k52A "leiriytyä") ; --UNCHK
lin encamp_V2 = mkWV2 (k52A "leiriytyä") ; --UNCHK
lin encampment_N = mkWN (k2 "telttailu") ; --UNCHK
lin encapsulation_N = mkWN "kotelointi" ; --UNCHK
lin encase_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin encasement_N = mkWN (compoundN "kotelo" (k38 "iminen")) ; --UNCHK
lin encaustic_N = mkWN (compoundN "vaha" (k5 "väri")) ; --UNCHK
lin encephalartos_N = mkWN (compoundN "käpy" (k1 "palmu")) ; --UNCHK
lin encephalitis_N = mkWN (compoundN "aivo" (k48 "kuume")) ; --UNCHK
lin encephalocele_N = mkWN (k10 "pullistuma") "aivojen" ; --UNCHK
lin encephalogram_N = mkWN (compoundN "röntgen" (k10 "kuva")) "aivojen" ; --UNCHK
lin encephalography_N = mkWN "enkefalografia" ; --UNCHK
lin encephalomyelitis_N = mkWN (compoundN "aivo-selkäydin" (k39 "tulehdus")) ; --UNCHK
lin enchain_V2 = mkWV2 (k61A "kahlehtia") ; --UNCHK
lin enchant_V2 = mkWV2 (k61 "loitsia") ; --UNCHK
lin enchanter_N = mkWN (k1 "velho") ; --UNCHK
lin enchantingly_Adv = mkWAdv (k99 "ihastuttavasti") ; --UNCHK
lin enchantment_N = mkWN (k40 "taikuus") ; --UNCHK
lin enchantress_N = mkWN (k10A "noita") ; --UNCHK
lin enchilada_N = mkWN (k9 "enchilada") ; --UNCHK
lin enchondroma_N = mkWN (compoundN "rusto" (k33 "kasvain")) ; --UNCHK
lin encircle_V2 = mkWV2 (k52A "sitoa") ; --UNCHK
lin encirclement_N = mkWN (k39 "piiritys") ; --UNCHK
lin enclave_N = mkWN (compoundN "erillis" (k48 "alue")) ; --UNCHK
lin enclose_V2 = mkWV2 (k56A "laittaa") ; --UNCHK
lin enclosure_1_N = mkWN (k5A "ympäröinti") ; --UNCHK
lin enclosure_2_N = mkWN (k5A "ympäröinti") ; --UNCHK
lin enclosure_3_N = mkWN (k5A "ympäröinti") ; --UNCHK
lin encode_V2 = mkWV2 (k54A "muuntaa") "koodimuotoon" ; --UNCHK
lin encoding_N = mkWN (k39 "salaus") ; --UNCHK
lin encolure_N = mkWN (k9 "harja") ; --UNCHK
lin encomiastic_A = mkWA "kiittävä" ; --UNCHK
lin encomium_N = mkWN (k39 "ylistys") ; --UNCHK
lin encompass_V2 = mkWV2 (k53A "käsittää") ; --UNCHK
lin encompassment_N = mkWN (compoundN "sisä" (k38 "ltäminen")) ; --UNCHK
lin encopresis_N = mkWN (compoundN "ulosteenpidätys" (k40 "kyvyttömyys")) ; --UNCHK
lin encore_N = mkWN (k2 "numero") "ylimääräinen" ; --UNCHK
lin encounter_N = mkN "kohtaaminen" ;
lin encounter_V2 = mkV2 "kohdata" partitive ; --WV2 (k53A "ottaa") "yhteen" ;
lin encourage_V2 = mkWV2 (k66 "rohkaista") ;
lin encourage_V2V = mkV2V (mkWV (k66 "rohkaista")) (mkPrep partitive) ;
lin encouragement_N = mkN "rohkaisu" ;
lin encouraging_A = mkWA (k10 "lupaava") ; --UNCHK
lin encroach_V = mkWV (k73A "loukata") ; --UNCHK
lin encroachment_N = mkWN (k39 "vaikutus") ; --UNCHK
lin encrust_V = mkWV (k53A "kuorruttaa") ; --UNCHK
lin encrust_V2 = mkWV2 (k53A "kuorruttaa") ; --UNCHK
lin encrypt_V2 = mkWV2 (k73 "kryptata") ; --UNCHK
lin encumber_V2 = mkWV2 (k73A "haitata") ; --UNCHK
lin encumbrance_N = mkWN (k2 "koukero") ; --UNCHK
lin encyclical_A = mkWA (compoundA "tarkoite" (k1 "ttu")) "jakoon" ; --UNCHK
lin encyclical_N = mkWN (compoundN "kierto" (k48 "kirje")) "paavin" ; --UNCHK
lin encyclopaedia_N = mkWN (k12 "ensyklopedia") ; --UNCHK
lin encyclopaedic_A = mkWA (compoundA "tietosanakirja" (k38 "mainen")) ; --UNCHK
lin encyclopedia_N = mkWN (k12 "ensyklopedia") ; --UNCHK
lin encyclopedic_A = mkWA (compoundA "tietosanakirja" (k38 "mainen")) ; --UNCHK
lin encyclopedist_N = mkWN (compoundN "tietosanakirjan" (k10 "toimittaja")) ; --UNCHK
lin encysted_A = mkWA (compoundA "kotelo" (k47 "itunut")) ; --UNCHK
lin end_1_N = mkN "loppu" ;
lin end_2_N = mkN "pää" | mkN "perä" ;
lin end_N = mkN "loppu" ;
lin end_V = mkV "loppua" ;
lin end_V2 = mkV2 "lopettaa" ;
lin end_VS = mkWVS (k53A "päättää") ; --UNCHK
lin end_in_V2 = prepV2 OP_end_V OP_in_Prep ; -- guess-p-verb
lin end_tail_V2 = variants {} ; -- guess-p-verb
lin end_up_V2 = mkV2 "päätyä" illative ;
lin end_up_with_V2 = prepV2 (advV OP_end_V OP_up_Adv ) OP_with_Prep ; -- guess-p-verb
lin endameba_N = mkWN (k9 "ameba") ; --UNCHK
lin endanger_V2 = mkWV2 (k53 "altistaa") ; --UNCHK
lin endarteritis_N = mkWN (k39 "tulehdus") "valtimon" "sisäkalvon" ; --UNCHK
lin endear_V2 = mkWV2 (k71 "tehdä") "rakkaaksi" ; --UNCHK
lin endearingly_Adv = mkWAdv (k99 "rakastettavasti") ; --UNCHK
lin endearment_N = mkWN (compoundN "hellyyden" (k39 "osoitus")) ; --UNCHK
lin endeavour_N = mkWN (k2 "kokeilu") ; --UNCHK
lin endeavour_V = mkWV (k53A "yrittää") ; --UNCHK
lin endemic_A = mkWA (k38 "endeeminen") ; --UNCHK
lin endemic_N = mkWN (k5 "laji") "kotoperäinen" ; --UNCHK
lin endergonic_A = mkWA "endergoninen" ; --UNCHK
lin endermic_A = mkWA (compoundA "ihon" (k38 "sisäinen")) ; --UNCHK
lin endgame_N = mkWN (k1A "loppu") "pelin" ; --UNCHK
lin ending_N = mkWN (k39 "lopetus") ; --UNCHK
lin endive_N = mkWN (k5 "endiivi") ; --UNCHK
lin endless_A = mkWA (k34A "päättymätön") ;
lin endlessness_N = mkWN (k40 "rajattomuus") ; --UNCHK
lin endocarditis_N = mkWN (k39 "tulehdus") "sydämen" "sisäkalvon" ; --UNCHK
lin endocardium_N = mkWN (compoundN "sisä" (k1 "kalvo")) "sydämen" ; --UNCHK
lin endocentric_A = mkWA "endosentrinen" ; --UNCHK
lin endocervicitis_N = mkWN (compoundN "endoser" (k5A "visiitti")) ; --UNCHK
lin endocranium_N = mkWN (k50 "kovakalvo") ; --UNCHK
lin endocrine_A = mkWA (k38 "umpieritteinen") ; --UNCHK
lin endocrinologist_N = mkWN "endokrinologi" ; --UNCHK
lin endocrinology_N = mkWN (k12 "endokrinologia") ; --UNCHK
lin endoderm_N = mkWN (compoundN "hypob" (k5 "lasti")) ; --UNCHK
lin endodontic_A = mkWA "endodontian" ; --UNCHK
lin endodontics_N = mkWN "endodontia" ; --UNCHK
lin endodontist_N = mkWN "endodontti" ; --UNCHK
lin endoergic_A = mkWA "energiaa" "sitova" ; --UNCHK
lin endogamous_A = mkWA "endogaminen" ; --UNCHK
lin endogamy_N = mkWN (compoundN "sisäryhmäavio" (k1A "liitto")) ; --UNCHK
lin endogenic_A = mkWA (k38 "endogeeninen") ; --UNCHK
lin endogenous_A = mkWA (k38 "endogeeninen") ; --UNCHK
lin endogeny_N = mkWN "endogenia" ; --UNCHK
lin endolymph_N = mkWN (compoundN "sisä" (k48 "neste")) "sisäkorvan" ; --UNCHK
lin endometrial_A = mkWA "endometriumin" ; --UNCHK
lin endometriosis_N = mkWN (k5 "endometrioosi") ; --UNCHK
lin endometrium_N = mkWN (compoundN "lima" (k1 "kalvo")) "kohdun" ; --UNCHK
lin endomorph_N = mkWN "endomorfi" ; --UNCHK
lin endomorphic_A = mkWA (k38 "pykninen") ; --UNCHK
lin endomorphy_N = mkWN (k4A "pyknikko") ; --UNCHK
lin endoneurium_N = mkWN "endoneurium" ; --UNCHK
lin endonuclease_N = mkWN (compoundN "endonukle" (k5 "aasi")) ; --UNCHK
lin endoparasite_N = mkWN (compoundN "sisä" (k38 "loinen")) ; --UNCHK
lin endoparasitic_A = mkWA "sisäloisiin" "liittyvä" ; --UNCHK
lin endoplasm_N = mkWN (compoundN "endo" (k9 "plasma")) ; --UNCHK
lin endorphin_N = mkWN (k5 "endorfiini") ; --UNCHK
lin endorse_V2 = mkWV2 (k52 "hyväksyä") ; --UNCHK
lin endorsement_N = mkWN (k7A "tuki") ; --UNCHK
lin endorser_N = mkWN (k10 "siirtäjä") ; --UNCHK
lin endoscope_N = mkWN (k5A "endoskooppi") ; --UNCHK
lin endoscopic_A = mkWA (compoundA "endoskooppi" (k38 "nen")) ; --UNCHK
lin endoscopy_N = mkWN (k39 "tähystys") ; --UNCHK
lin endoskeleton_N = mkWN (compoundN "tuki" (k9A "ranka")) "sisäinen" ; --UNCHK
lin endosperm_N = mkWN (compoundN "siemen" (k38 "valkuainen")) ; --UNCHK
lin endospore_N = mkWN (compoundN "sisä" (k3 "itiö")) ; --UNCHK
lin endosteum_N = mkWN (compoundN "sisä" (k1 "kalvo")) "luun" ; --UNCHK
lin endothelial_A = mkWA "endoteelinen" ; --UNCHK
lin endothermic_A = mkWA (compoundA "endo" (k38 "terminen")) ; --UNCHK
lin endotoxin_N = mkWN (compoundN "endo" (k5 "toksiini")) ; --UNCHK
lin endow_V2 = mkWV2 (k53 "varustaa") "myötäjäisillä" ; --UNCHK
lin endowment_N = mkWN (k39 "lahjoitus") ; --UNCHK
lin endue_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin endurable_A = mkWA (k10 "siedettävä") ; --UNCHK
lin endurance_N = mkWN (k40 "kestävyys") ; --UNCHK
lin endure_V = mkWV (k52 "pysyä") "järkähtämättömänä" ; --UNCHK
lin endure_V2 = mkV2 (mkV "kestää") partitive ; --mkWV2 (k52 "pysyä") "järkähtämättömänä" ;
lin enduring_A = variants {} ;
lin endways_Adv = mkWAdv (k99 "päittäin") ; --UNCHK
lin endwise_Adv = mkWAdv (k99 "päittäin") ; --UNCHK
lin enema_N = mkWN (compoundN "perä" (k48 "ruiske")) ; --UNCHK
lin enemy_N = L.enemy_N ;
lin energetic_A = mkA "energinen" ; --mkWA (k41 "toimelias") ;
lin energid_N = mkWN (compoundN "protop" (k5 "lasti")) ; --UNCHK
lin energizer_N = mkWN (compoundN "aktivointi" (k48A "laite")) ; --UNCHK
lin energizing_A = mkWA (compoundA "energis" (k10 "oiva")) ; --UNCHK
lin energizing_N = mkWN (k5A "aktivointi") ; --UNCHK
lin energy_N = mkN "energia" ;
lin enervate_V2 = mkWV2 (k54A "heikentää") ; --UNCHK
lin enervation_N = mkWN (k1 "poisto") "hermon" ; --UNCHK
lin enfant_terrible_N = mkWN (compoundN "kauhu" (k12 "kakara")) ; --UNCHK
lin enfeeble_V2 = mkWV2 (k64 "viedä") "voimat" ; --UNCHK
lin enfeoffment_N = mkWN (compoundN "läänitys" (k9 "kirja")) ; --UNCHK
lin enfield_PN = foreignPN "Enfield" ;
lin enfilade_N = mkWN (compoundN "sivusta" (k23 "tuli")) ; --UNCHK
lin enflurane_N = mkWN (compoundN "Ethr" (k48 "ane")) ; --UNCHK
lin enfold_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin enforce_V2 = mkV2 "pakottaa" ;
lin enforceable_A = mkWA (compoundA "täytäntöönpano" (k38 "kelpoinen")) ; --UNCHK
lin enforcement_N = mkN "pakottaminen" ; ---ARB mkWN (compoundN "pakko" (k1 "keino")) ;
lin enfranchisement_N = mkWN "edustusoikeuden" "myöntäminen" ; --UNCHK
lin engage_V = mkWV (k58 "kytkeä") ;
lin engage_V2 = mkWV2 (k58 "kytkeä") ; --UNCHK
lin engagement_N = mkWN (k39 "kiinnitys") ; --UNCHK
lin engelmannia_N = mkWN "engelmannia" ; --UNCHK
lin engender_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin engine_N = mkWN (k6 "moottori") ; --f57
lin engine_driver_N = mkWN (compoundN "veturin" (k10 "kuljettaja")) ; --UNCHK
lin engineer_N = mkWN (k5 "insinööri") ;
lin engineer_V = mkWV (k53A "toteuttaa") ; --UNCHK
lin engineer_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin engineering_N = mkWN (k12 "teknologia") ; --f64
lin enginery_N = mkWN (k2 "koneisto") ; --UNCHK
lin england_PN = mkPN "Englanti" ;
lin englishFem_N = mkN "englantilainen" ;
lin englishMasc_N = mkWN (k38 "englantilainen") ;
lin english_A = mkWA (k38 "englantilainen") ;
lin engorgement_N = mkWN (k9A "ahminta") ; --UNCHK
lin engraft_V2 = mkWV2 (k53A "asettaa") ; --UNCHK
lin engram_N = mkWN (compoundN "muisti" (k7A "jälki")) ; --UNCHK
lin engrave_V2 = mkWV2 (k54A "kaivertaa") ; --UNCHK
lin engraver_N = mkWN (k10 "kaivertaja") ; --UNCHK
lin engraving_N = mkWN (compoundN "kai" (k38 "vertaminen")) ; --UNCHK
lin engulf_V2 = mkWV2 (k52A "hautautua") ; --UNCHK
lin enhance_V2 = mkWV2 (k53 "tehostaa") ;
lin enhanced_A = variants {} ; --
lin enhancement_N = mkWN (k39 "kohennus") ;
lin enigma_N = mkWN (k12 "asia") "tuntematon" ; --UNCHK
lin enigmatic_A = mkWA (k38 "oraakkelimainen") ; --UNCHK
lin enjambment_N = mkWN (compoundN "säkeen" (k39 "ylitys")) ; --UNCHK
lin enjoin_V2 = mkV2 "kieltää" partitive ; ---ARB --mkWV2 (k73 "määrätä") ;
lin enjoy_V2 = mkV2 (mkV "nauttia") partitive ;
lin enjoy_VV = mkVV "pitää" infElat ; --- tekemisestä ; add more Inf3s in ParadigmsFin
lin enjoyable_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin enjoyableness_N = mkWN (k40 "nautittavuus") ; --UNCHK
lin enjoyer_N = mkWN (k12 "nautiskelija") ; --UNCHK
lin enjoyment_N = mkWN (k1 "ilo") ; --UNCHK
lin enkephalin_N = mkWN "enkefaliini" ; --UNCHK
lin enkindle_V2 = mkWV2 (k53A "synnyttää") ; --UNCHK
lin enlarge_V = mkWV (k54A "laajentaa") ; --UNCHK
lin enlarge_V2 = mkWV2 (k54A "laajentaa") ; --UNCHK
lin enlargement_N = mkWN "laajentuminen" ; --UNCHK
lin enlarger_N = mkWN (compoundN "suurennus" (k48 "kone")) ; --UNCHK
lin enlighten_V2 = mkWV2 (k53 "havainnollistaa") ; --UNCHK
lin enlightening_A = mkWA "valaiseva" ; --UNCHK
lin enlightenment_N = mkWN (k39 "valistus") ; --UNCHK
lin enlist_V = mkWV (k52A "värväytyä") ; --UNCHK
lin enlist_V2 = mkWV2 (k52A "värväytyä") ; --UNCHK
lin enlistment_N = mkWN (k39 "värväys") ; --UNCHK
lin enliven_V2 = mkWV2 (k53A "elähdyttää") ; --UNCHK
lin enmesh_V2 = mkWV2 (k63 "saada") "satimeen" ; --UNCHK
lin enmity_N = mkWN (k40 "pahansuopuus") ; --UNCHK
lin ennoble_V2 = mkWV2 (k62 "aateloida") ; --UNCHK
lin ennoblement_N = mkWN (k5A "aatelointi") ; --UNCHK
lin ennobling_A = mkWA "jalostava" ; --UNCHK
lin ennui_N = mkWN (k40 "ikävystyttävyys") ; --UNCHK
lin eno_PN = mkPN "Eno" ;
lin enoch_PN = foreignPN "Enoch" ;
lin enol_N = mkWN "enoli" ; --UNCHK
lin enolic_A = mkWA "enoli-" ; --UNCHK
lin enologist_N = mkWN (compoundN "viini" (k12 "tieteilijä")) ; --UNCHK
lin enology_N = mkWN (compoundN "viini" (k5A "oppi")) ; --UNCHK
lin enonkoski_PN = mkPN (mkN "Enonkoski" "Enonkoskia") ;
lin enontekiö_PN = mkPN "Enontekiö" ;
lin enophile_N = mkWN (compoundN "viinin" (k12 "tuntija")) ; --UNCHK
lin enormity_N = mkWN (compoundN "hirmu" (k19 "työ")) ; --UNCHK
lin enormous_A = mkA "suunnaton" ;
lin enormousness_N = mkWN (k40 "laajuus") ; --UNCHK
lin enosis_N = mkWN "enosis" ; --UNCHK
lin enough_A = mkA "riittävä" ;
lin enough_N = mkWN (k99 "riittävästi") ;
lin enough_Predet = {s = \\_,_ => "tarpeeksi"} ; ---- cat
lin enplane_V = mkWV (k66 "nousta") "lentokoneeseen" ; --UNCHK
lin enplane_V2 = mkWV2 (k66 "nousta") "lentokoneeseen" ; --UNCHK
lin enquire_V = mkWV (k67 "tiedustella") ; --UNCHK
lin enquire_V2 = mkWV2 (k67 "tiedustella") ; --UNCHK
lin enquirer_N = mkWN (k10 "kysyjä") ; --UNCHK
lin enquiringly_Adv = mkWAdv (k99 "kysyvästi") ; --UNCHK
lin enquiry_N = mkWN (k39 "tutkimus") ; --UNCHK
lin enrage_V2 = mkWV2 (k53A "raivostuttaa") ; --UNCHK
lin enrapture_V2 = mkWV2 (k61 "loitsia") ; --UNCHK
lin enrich_V2 = mkWV2 (k53 "rikastaa") ; --UNCHK
lin enrichment_N = mkWN (compoundN "rikas" (k38 "tuttaminen")) ; --UNCHK
lin enrol_V = mkWV (k62 "rekrytoida") ; --UNCHK
lin enrol_V2 = mkWV2 (k62 "rekrytoida") ; --UNCHK
lin enroll_V = mkWV (k62 "rekrytoida") ; --UNCHK
lin enroll_V2 = mkWV2 (k62 "rekrytoida") ; --UNCHK
lin enrollee_N = mkWN (k10 "osallistuja") ; --UNCHK
lin enrolment_N = mkWN (compoundN "kirjo" (k38 "ittautuminen")) ; --UNCHK
lin enschede_PN = foreignPN "Enschede" ;
lin ensconce_V2 = mkWV2 (k52A "asettautua") ; --UNCHK
lin ensemble_N = mkWN (compoundN "asu" (k40 "kokonaisuus")) ; --UNCHK
lin enshrine_V2 = mkWV2 (k53A "säilyttää") ; --UNCHK
lin enshroud_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin ensiform_A = mkWA (compoundA "miekka" (k38 "mainen")) ; --UNCHK
lin ensign_N = mkWN (compoundN "kansallis" (k1A "lippu")) ; --UNCHK
lin ensilage_N = mkWN (compoundN "säilö" (k1 "rehu")) ; --UNCHK
lin enslave_V2 = mkWV2 (k53A "orjuuttaa") ; --UNCHK
lin enslavement_N = mkWN (k39 "orjuutus") ; --UNCHK
lin ensnare_V2 = mkWV2 (k56 "ajaa") "ansaan" ; --UNCHK
lin ensue_V = mkWV (k73 "seurata") ; --UNCHK
lin ensure_V = mkV "varmistaa" ;
lin ensure_V2 = mkV2 "varmistaa" ;
lin ensure_VS = mkVS "varmistaa" ;
lin entablature_N = mkWN (k2 "palkisto") ; --UNCHK
lin entail_N = mkWN (compoundN "määrä" (k38 "äminen")) "sääntöperinnöksi" ; --UNCHK
lin entail_V2 = mkWV2 (k53A "rajoittaa") "perintöä" ; --UNCHK
lin entangle_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin entanglement_N = mkWN (k5A "seitti") ; --UNCHK
lin entasis_N = mkWN "pullistuminen" ; --UNCHK
lin entelechy_N = mkWN (k40 "todellisuus") ; --UNCHK
lin entente_N = mkWN (compoundN "yhteis" (k39 "ymmärrys")) ; --UNCHK
lin entente_cordiale_N = mkWN (compoundN "yhteis" (k39 "ymmärrys")) ; --UNCHK
lin enter_V = mkV L.go_V "sisään" ;
lin enter_V2 = mkV2 (mkV L.go_V "sisään") illative ;
lin enter_for_V2 = prepV2 OP_enter_V OP_for_Prep ; -- guess-p-verb
lin enter_into_V2 = prepV2 OP_enter_V OP_into_Prep ; -- guess-p-verb
lin enteric_A = mkWA "suolisto-" ; --UNCHK
lin enteritis_N = mkWN (compoundN "suoli" (k39 "tulehdus")) ; --UNCHK
lin enterobiasis_N = mkWN (compoundN "kihomato" (k5A "tauti")) ; --UNCHK
lin enterokinase_N = mkWN (compoundN "enterokin" (k5 "aasi")) ; --UNCHK
lin enterolith_N = mkWN "enteroliitti" ; --UNCHK
lin enterolithiasis_N = mkWN (compoundN "liti" (k5 "aasi")) ; --UNCHK
lin enteron_N = mkWN (compoundN "ruoansulatus" (k10 "kanava")) ; --UNCHK
lin enteropathy_N = mkWN "enteropatia" ; --UNCHK
lin enteroptosis_N = mkWN (compoundN "suolen" (k10 "laskeuma")) ; --UNCHK
lin enterostenosis_N = mkWN (compoundN "suoli" (k10 "ahtauma")) ; --UNCHK
lin enterostomy_N = mkWN (k1A "teko") "suoliavanteen" ; --UNCHK
lin enterotoxemia_N = mkWN (compoundN "entero" (k12 "toksemia")) ; --UNCHK
lin enterotoxin_N = mkWN (compoundN "suolisto" (k1A "myrkky")) ; --UNCHK
lin enterovirus_N = mkWN (compoundN "entero" (k39 "virus")) ; --UNCHK
lin enterprise_N = mkWN (k48A "hanke") ; --UNCHK
lin enterprising_A = mkWA (k41 "yritteliäs") ; --UNCHK
lin entertain_V2 = mkWV2 (k69 "harkita") ; --UNCHK
lin entertainer_N = mkWN (k10 "viihdyttäjä") ; --UNCHK
lin entertaining_A = mkWA "viihdyttävä" ; --UNCHK
lin entertainment_N = mkN "viihde" ;
lin enthral_V2 = mkWV2 (k61 "loitsia") ; --UNCHK
lin enthrall_V2 = mkWV2 (k61 "loitsia") ; --UNCHK
lin enthrone_V2 = mkWV2 (k75 "nimetä") "joksikin" ; --UNCHK
lin enthuse_V = mkWV (k67 "intoilla") ; --UNCHK
lin enthusiasm_N = mkWN (k1A "into") ; --UNCHK
lin enthusiast_N = mkN "intoilija" ; --mkWN (k10 "kannattaja") ;
lin enthusiastic_A = mkWA (k47 "innostunut") ;
lin enthusiastically_Adv = mkWAdv (k99 "innostuneesti") ; --UNCHK
lin entice_V2 = mkWV2 (k67A "houkutella") ;
lin enticement_N = mkWN (k2 "viettely") ; --UNCHK
lin entire_A = mkA "kokonainen" ;
lin entirety_N = mkWN (k40 "täydellisyys") ; --UNCHK
lin entitle_V2V = mkV2V (mkV "oikeuttaa") accusative infIllat ; --mkWV2V (k75 "nimetä") ;
lin entitle_VS = mkWVS (k75 "nimetä") ; --UNCHK
lin entitlement_N = mkWN (compoundN "tuki" (k40 "oikeus")) ; --UNCHK
lin entity_N = mkN "olio" ;
lin entomb_V2 = mkWV2 (k73A "haudata") ; --UNCHK
lin entomion_N = mkWN "entomion" ; --UNCHK
lin entomological_A = mkWA (compoundA "hyönteis" (k38 "tieteellinen")) ; --UNCHK
lin entomologist_N = mkWN (compoundN "hyönteis" (k12 "tutkija")) ; --UNCHK
lin entomology_N = mkWN (compoundN "hyönteis" (k48A "tiede")) ; --UNCHK
lin entomophilous_A = mkWA (compoundA "hyönteis" (k12 "suosija")) ; --UNCHK
lin entomophobia_N = mkWN (compoundN "hyönteis" (k1 "kammo")) ; --UNCHK
lin entoproct_N = mkWN (compoundN "pikari" (k1A "mato")) ; --UNCHK
lin entourage_N = mkWN (k48 "seurue") ; --UNCHK
lin entozoan_A = mkWA (k10 "elävä") "sisäloisena" ; --UNCHK
lin entozoic_A = mkWA (k10 "elävä") "sisäloisena" ; --UNCHK
lin entr'acte_N = mkWN (k9A "väliaika") ; --UNCHK
lin entrain_V = mkWV (k66 "nousta") "junaan" ; --UNCHK
lin entrain_V2 = mkWV2 (k66 "nousta") "junaan" ; --UNCHK
lin entrance_N = mkWN (compoundN "sisään" (k1 "tulo")) ; --UNCHK
lin entrance_V2 = mkWV2 (k74 "lumota") ; --UNCHK
lin entrance_fee_N = mkWN (compoundN "sisäänpääsy" (k1 "maksu")) ; --UNCHK
lin entrance_money_N = mkWN (compoundN "sisäänpääsy" (k1 "maksu")) ; --UNCHK
lin entrancement_N = mkWN (k39 "ihastus") ; --UNCHK
lin entrant_N = mkWN (compoundN "osan" (k10 "ottaja")) ; --UNCHK
lin entrap_V2 = mkWV2 (k56 "ajaa") "ansaan" ; --UNCHK
lin entrapment_N = mkWN "rikokseen" "yllyttäminen" ; --UNCHK
lin entreat_V2 = mkWV2 (k74A "vedota") ; --UNCHK
lin entreatingly_Adv = mkWAdv (k99 "itsepintaisesti") ; --UNCHK
lin entreaty_N = mkWN (k39 "vetoomus") ; --UNCHK
lin entrecote_N = mkWN (compoundN "väli" (k39 "kyljys")) ; --UNCHK
lin entree_N = mkWN (compoundN "sisään" (k1 "tulo")) ; --UNCHK
lin entrench_V2 = mkWV2 (k53A "juurruttaa") ; ---ARB
lin entrenchment_N = mkWN (compoundN "taistelu" (k9A "hauta")) ; --UNCHK
lin entrepot_N = mkWN (k2 "varasto") ; --UNCHK
lin entrepreneur_N = mkWN (k10 "yrittäjä") ;
lin entrepreneurial_A = mkWA "yrittäjän" ; --UNCHK
lin entrust_V2 = mkWV2 (k52 "uskoa") ; --UNCHK
lin entry_1_N = mkN "pääsy" ;
lin entry_2_N = mkN "haku" (mkN "sana") ;
lin entry_N = mkWN (compoundN "sisään" (k1 "tulo")) ;
lin entwine_V2 = mkWV2 (k52 "punoa") "yhteen" ; --UNCHK
lin enumerate_V2 = mkWV2 (k67A "eritellä") ; --UNCHK
lin enumeration_N = mkWN (k38 "lukeminen") "numeroiden" ; --UNCHK
lin enunciate_V = mkWV (k52 "lausua") ; --UNCHK
lin enunciate_V2 = mkWV2 (k52 "lausua") ; --UNCHK
lin enunciation_N = mkWN (k39 "esitys") ; --UNCHK
lin enured_A = mkWA (compoundA "kara" (k47 "istunut")) ; --UNCHK
lin enuresis_N = mkWN (k5 "inkontinenssi") ; --UNCHK
lin envelop_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin envelope_N = mkWN (k39 "päällys") ; --UNCHK
lin envelopment_N = mkWN (k5A "ympäröinti") ; --UNCHK
lin envenom_V2 = mkWV2 (k53A "myrkyttää") ; --UNCHK
lin enviable_A = mkWA "kadehdittava" ; --UNCHK
lin envious_A = mkWA (k38 "mustasukkainen") ; --UNCHK
lin environ_V2 = mkWV2 (k53 "reunustaa") ; --UNCHK
lin environment_N = mkN "ympäristö" ;
lin environmental_A = mkA (separateN "ympäristöä" (mkN "koskeva")) ;
lin environmentalism_N = mkWN (compoundN "ympäristön" (k2 "suojelu")) ; --UNCHK
lin environmentalist_N = mkWN (compoundN "ympäristön" (k12 "suojelija")) ; --UNCHK
lin environs_N = mkWN (compoundN "lähi" (k1A "seutu")) ; --UNCHK
lin envisage_V2 = mkWV2 (k71 "nähdä") "mielessään" ; --UNCHK
lin envision_V2 = mkWV2 (k62 "visioida") ; --UNCHK
lin envision_VS = mkWVS (k62 "visioida") ; --UNCHK
lin envisioned_A = mkWA "kuviteltu" ; --UNCHK
lin envoi_N = mkWN (compoundN "loppu" (k48A "säe")) ; --UNCHK
lin envoy_N = mkWN (compoundN "loppu" (k48A "säe")) ; --UNCHK
lin envy_N = mkWN (k40 "kateus") ; --UNCHK
lin envy_V2 = mkWV2 (k61A "kadehtia") ; --UNCHK
lin enwrap_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin enzootic_A = mkWA "paikallistauti-" ; --UNCHK
lin enzymatic_A = mkWA "entsymaattinen" ; --UNCHK
lin enzyme_N = mkWN (k6 "entsyymi") ; --UNCHK
lin enzymologist_N = mkWN "entsymologi" ; --UNCHK
lin enzymology_N = mkWN "entsymologia" ; --UNCHK
lin eolith_N = mkWN "eoliitti" ; --UNCHK
lin eolithic_A = mkWA "eoliittinen" ; --UNCHK
lin eon_N = mkWN (k40 "iäisyys") ; --UNCHK
lin eonian_A = mkWA "maailmankauden" ; --UNCHK
lin eoraptor_N = mkWN "eoraptor" ; --UNCHK
lin eosin_N = mkWN "bromeosiini" ; --UNCHK
lin eosinopenia_N = mkWN (k40 "niukkuus") "eosinofiilien" ; --UNCHK
lin eosinophil_N = mkWN "eosinofiili" ; --UNCHK
lin eosinophilia_N = mkWN (k40 "runsaus") "eosinofiilien" ; --UNCHK
lin eosinophilic_A = mkWA "eosinifilian" ; --UNCHK
lin epacris_N = mkWN "epacris" ; --UNCHK
lin epanalepsis_N = mkWN "epanalepsis" ; --UNCHK
lin epanaphora_N = mkWN (compoundN "anaf" (k10 "ora")) ; --UNCHK
lin epanodos_N = mkWN "epanodos" ; --UNCHK
lin epanorthosis_N = mkWN "epanorthosis" ; --UNCHK
lin eparch_N = mkWN (compoundN "käskyn" (k12 "haltija")) ; --UNCHK
lin eparchial_A = mkWA "eparkhiaan" "liittyvä" ; --UNCHK
lin eparchy_N = mkWN (compoundN "hallinto" (k48 "alue")) ; --UNCHK
lin epaulet_N = mkWN (k5A "epoletti") ; --UNCHK
lin epaulette_N = mkWN (k5A "epoletti") ; --UNCHK
lin epauliere_N = mkWN (compoundN "olka" (k33 "suojain")) ; --UNCHK
lin epee_N = mkWN (k9A "miekka") ; --UNCHK
lin ependyma_N = mkWN "ependyymi" ; --UNCHK
lin epenthesis_N = mkWN (compoundN "epen" (k5 "teesi")) ; --UNCHK
lin epenthetic_A = mkWA (compoundA "epent" (k38 "eettinen")) ; --UNCHK
lin epergne_N = mkWN (compoundN "pöytä" (k48 "koriste")) ; --UNCHK
lin ephah_N = mkWN (k9A "vakka") ; --UNCHK
lin ephedra_N = mkWN "efedra" ; --UNCHK
lin ephedrine_N = mkWN "efedriini" ; --UNCHK
lin ephemera_N = mkWN (k3 "ilmiö") "ohimenevä" ; --UNCHK
lin ephemeral_A = mkWA (k38 "katoavainen") ; --UNCHK
lin ephemerality_N = mkWN (k40 "katoavuus") ; --UNCHK
lin ephemerid_N = mkWN (compoundN "päivän" (k1A "korento")) ; --UNCHK
lin ephemeris_N = mkWN (k4A "taulukko") "tähtitieteellinen" ; --UNCHK
lin ephemeron_N = mkWN (compoundN "päivän" (k1A "korento")) ; --UNCHK
lin epic_A = mkWA (k38 "eeppinen") ; --UNCHK
lin epic_N = mkWN (k39 "eepos") ; --UNCHK
lin epicalyx_N = mkWN (compoundN "ulko" (k3 "verhiö")) ; --UNCHK
lin epicanthus_N = mkWN (compoundN "mongolin" (k1 "poimu")) ; --UNCHK
lin epicardia_N = mkWN (compoundN "mahansuu" (k10 "osa")) ; --UNCHK
lin epicardium_N = mkWN (compoundN "sisä" (k7A "lehti")) "sydänpussin" ; --UNCHK
lin epicarp_N = mkWN (compoundN "ekso" (k5A "karppi")) ; --UNCHK
lin epicarpal_A = mkWA "epikarpin" ; --UNCHK
lin epicondyle_N = mkWN (compoundN "sivu" (k9 "nasta")) ; --UNCHK
lin epicondylitis_N = mkWN "epikondyliitti" ; --UNCHK
lin epicranium_N = mkWN "epikranium" ; --UNCHK
lin epicure_N = mkWN (k12 "herkuttelija") ; --UNCHK
lin epicurean_A = mkWA (k38 "epikurolainen") ; --UNCHK
lin epicurean_N = mkWN (k12 "herkuttelija") ; --UNCHK
lin epicureanism_N = mkWN (k40 "epikurolaisuus") ; --UNCHK
lin epicurism_N = mkWN (k40 "epikurolaisuus") ; --UNCHK
lin epicycle_N = mkWN (compoundN "epi" (k5 "sykli")) ; --UNCHK
lin epicyclic_A = mkWA (compoundA "epi" (k38 "syklinen")) ; --UNCHK
lin epicycloid_N = mkWN "episykloidi" ; --UNCHK
lin epideictic_A = mkWA "epideiktinen" ; --UNCHK
lin epidemic_A = mkWA (k38 "epideeminen") ; --UNCHK
lin epidemic_N = mkWN (k12 "epidemia") ; --UNCHK
lin epidemiologic_A = mkWA (k38 "epidemiologinen") ; --UNCHK
lin epidemiologist_N = mkWN (k5 "epidemiologi") ; --UNCHK
lin epidemiology_N = mkWN (k12 "epidemiologia") ; --UNCHK
lin epidendron_N = mkWN (k13 "orkidea") ; --UNCHK
lin epidermis_N = mkWN (k5 "epidermi") ; --UNCHK
lin epidiascope_N = mkWN (compoundN "kuultokuva" (k33A "heitin")) ; --UNCHK
lin epididymis_N = mkWN (compoundN "lisä" (k39 "kives")) ; --UNCHK
lin epididymitis_N = mkWN (compoundN "lisäkives" (k39 "tulehdus")) ; --UNCHK
lin epidural_A = mkWA "ekstraduraali-" ; --UNCHK
lin epigastric_A = mkWA "epigastrinen" ; --UNCHK
lin epigastrium_N = mkWN (compoundN "sydän" (k9 "ala")) ; --UNCHK
lin epigenesis_N = mkWN "epigeneesi" ; --UNCHK
lin epiglottis_N = mkWN (compoundN "kurkun" (k28 "kansi")) ; --UNCHK
lin epiglottitis_N = mkWN (compoundN "kurkunkansi" (k39 "tulehdus")) ; --UNCHK
lin epigone_N = mkWN "jäljittelijä" ; --UNCHK
lin epigram_N = mkWN (k10A "kompa") ; --UNCHK
lin epigrammatic_A = mkWA (k10 "osuva") ; --UNCHK
lin epigraph_N = mkWN (compoundN "piirto" (k39 "kirjoitus")) ; --UNCHK
lin epigraphy_N = mkWN (compoundN "epi" (k14A "grafiikka")) ; --UNCHK
lin epikeratophakia_N = mkWN "epikeratofakia" ; --UNCHK
lin epilation_N = mkWN (compoundN "karvan" (k1 "poisto")) ; --UNCHK
lin epilepsy_N = mkWN (k12 "epilepsia") ;
lin epilepticFem_N = mkWN (k4A "epileptikko") ; --UNCHK
lin epilepticMasc_N = mkWN (k4A "epileptikko") ; --UNCHK
lin epileptic_A = mkWA (k38 "epileptinen") ; --UNCHK
lin epilithic_A = mkWA "epiliittinen" ; --UNCHK
lin epilogue_N = mkWN (k5 "epilogi") ; --UNCHK
lin epimorphic_A = mkWA "epimorfinen" ; --UNCHK
lin epinephrine_N = mkWN (k5 "adrenaliini") ; --UNCHK
lin epiphany_N = mkWN (k39 "ilmestys") ; --UNCHK
lin epiphenomenon_N = mkWN (compoundN "seurannais" (k3 "ilmiö")) ; --UNCHK
lin epiphora_N = mkWN (k1 "toisto") "lauseen" "lopun" ; --UNCHK
lin epiphyllum_N = mkWN (k39 "kaktus") ; --UNCHK
lin epiphyseal_A = mkWA (compoundA "epifysia" (k38 "alinen")) ; --UNCHK
lin epiphysis_N = mkWN (compoundN "käpy" (k38 "rauhanen")) ; --UNCHK
lin epiphytic_A = mkWA "epifyyttinen" ; --UNCHK
lin epiphytotic_A = mkWA (compoundA "epiphyto" (k5 "tic")) ; --UNCHK
lin epiplexis_N = mkWN "epiplexis" ; --UNCHK
lin episcia_N = mkWN (compoundN "kupari" (k7A "lehti")) ; --UNCHK
lin episcleritis_N = mkWN (compoundN "pinta" (k39 "tulehdus")) "silmän" "kovankalvon" ; --UNCHK
lin episcopacy_N = mkWN (k1A "hallinto") "episkopaalinen" ; --UNCHK
lin episcopal_A = mkWA (k38 "papillinen") ; --UNCHK
lin episcopalian_A = mkWA (k38 "episkopaalinen") ; --UNCHK
lin episcopalian_N = mkWN (k32 "jäsen") "episkopaalisen" "kirkon" ; --UNCHK
lin episcopate_N = mkWN (k9A "virka") "piispan" ; --UNCHK
lin episiotomy_N = mkWN (k39 "leikkaus") "välilihan" ; --UNCHK
lin episode_N = mkWN (k5 "episodi") ;
lin episodic_A = mkWA (compoundA "ohi" (k10 "menevä")) ; --UNCHK
lin episome_N = mkWN "episomi" ; --UNCHK
lin epispadias_N = mkWN (compoundN "epispa" (k9 "dia")) ; --UNCHK
lin episteme_N = mkWN (compoundN "alku" (k1A "tieto")) ; --UNCHK
lin epistemic_A = mkWA "tietoa" "koskeva" ; --UNCHK
lin epistemologist_N = mkWN "epistemologi" ; --UNCHK
lin epistemology_N = mkWN (compoundN "tieto" (k12 "teoria")) ; --UNCHK
lin epistle_N = mkWN (k12 "epistola") ; --UNCHK
lin epitaph_N = mkWN (compoundN "hauta" (k39 "kirjoitus")) ; --UNCHK
lin epitaxy_N = mkWN (compoundN "epi" (k12 "taksia")) ; --UNCHK
lin epithalamium_N = mkWN (compoundN "hää" (k1 "runo")) ; --UNCHK
lin epithelial_A = mkWA "epiteeli-" ; --UNCHK
lin epitheliod_A = mkWA (compoundA "epiteeli" (k38 "mäinen")) ; --UNCHK
lin epithelioma_N = mkWN (compoundN "epiteeli" (k33 "kasvain")) ; --UNCHK
lin epithelium_N = mkWN (k5 "epiteeli") ; --UNCHK
lin epithet_N = mkWN (k5A "epiteetti") ; --UNCHK
lin epitome_N = mkWN (k10 "ruumiillistuma") ; --UNCHK
lin epizoan_A = mkWA "ulkolois-" ; --UNCHK
lin epizoic_A = mkWA "ulkoloisena" ; --UNCHK
lin epizootic_A = mkWA (k38 "epideeminen") ; --UNCHK
lin epoch_N = mkWN (k27 "kausi") ; --UNCHK
lin epochal_A = mkWA (k10 "mullistava") ; --UNCHK
lin eponym_N = mkWN "eponyymi" ; --UNCHK
lin eponymous_A = mkWA (compoundA "saman" (k38 "niminen")) ; --UNCHK
lin eponymy_N = mkWN "eponymia" ; --UNCHK
lin epos_N = mkWN (k39 "eepos") ; --UNCHK
lin epoxy_N = mkWN (compoundN "epoksi" (k9 "liima")) ; --UNCHK
lin epping_PN = foreignPN "Epping" ;
lin epsilon_N = mkWN "epsilon" ; --UNCHK
lin epsom_PN = foreignPN "Epsom" ;
lin eptatretus_N = mkWN "eptatretus" ; --UNCHK
lin equable_A = mkWA (k26 "tyyni") ; --UNCHK
lin equal_A = mkA "samanarvoinen" ;
lin equal_N = mkWN (k38 "vertainen") ; --UNCHK
lin equal_V2 = mkV2 (mkV olla_V "sama") (mkPrep "kuin" nominative) ; ----
lin equalitarian_N = mkWN (k10 "kannattava") "tasa-arvoisuutta" ; --UNCHK
lin equality_N = mkWN (compoundN "yhtä" (k40 "suuruus")) ; --UNCHK
lin equalization_N = mkWN (k39 "tasoitus") ; --UNCHK
lin equalize_V2 = mkWV2 (k56A "saattaa") "samanarvoiseksi" ; --UNCHK
lin equalizer_N = mkWN (k5 "tasoitusmaali") ; --UNCHK
lin equanimity_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin equatability_N = mkWN "rinnastettavuus" ; --UNCHK
lin equate_V2 = mkWV2 (k56A "saattaa") "samanarvoiseksi" ; --UNCHK
lin equation_N = mkN "yhtälö" ;
lin equator_N = mkWN (compoundN "päivän" (k10 "tasaaja")) ; --UNCHK
lin equatorial_A = mkWA "päiväntasaajan" ; --UNCHK
lin equerry_N = mkWN (compoundN "talli" (k6 "mestari")) ; --UNCHK
lin equestrian_A = mkWA "ratsastaja-" ; --UNCHK
lin equestrian_N = mkWN (k10 "ratsastaja") ; --UNCHK
lin equiangular_A = mkWA (compoundA "tasakul" (k38 "mainen")) ; --UNCHK
lin equidistribution_N = mkWN "tasainen" "jakautuminen" ; --UNCHK
lin equilateral_A = mkWA "tasasivuinen" ; --UNCHK
lin equilateral_N = mkWN (k3 "kuvio") "tasasivuinen" ; --UNCHK
lin equilibration_N = mkWN (compoundN "tasa" (k39 "painotus")) ; --UNCHK
lin equilibrium_N = mkWN (compoundN "tasapaino" (k5 "aisti")) ; --UNCHK
lin equine_A = mkWA "hevoseläimiä" "koskeva" ; --UNCHK
lin equine_N = mkWN (compoundN "hevos" (k33 "eläin")) ; --UNCHK
lin equinoctial_A = mkWA "päiväntasaus-" ; --UNCHK
lin equinox_N = mkWN (compoundN "päiväntasaus" (k48 "piste")) ; --UNCHK
lin equip_V2 = mkV2 "varustaa" ;
lin equipment_N = mkWN (k1 "kalusto") | mkN "varuste" ;
lin equipoise_N = mkWN (compoundN "vasta" (k1 "paino")) ; --UNCHK
lin equipoised_A = mkWA "molempikätinen" ; --UNCHK
lin equipotent_A = mkWA (k41A "voimakas") "yhtä" ; --UNCHK
lin equiprobable_A = mkWA (compoundA "toden" (k38 "näköinen")) "yhtä" ; --UNCHK
lin equitable_A = mkWA (compoundA "oikeuden" (k38 "mukainen")) ; --UNCHK
lin equity_N = mkN "osakkuus" ;
lin equivalence_N = mkWN (k40 "vastaavuus") ; --UNCHK
lin equivalent_A = mkWA (k38 "samanlainen") ; --UNCHK
lin equivalent_N = mkN "samanarvoinen" ; --WN (k5A "ekvivalentti") ;
lin equivocal_A = mkWA (compoundA "epä" (k10 "selvä")) ; --UNCHK
lin equivocation_N = mkWN (compoundN "kaksiselitte" (k40 "isyys")) ; --UNCHK
lin er_Interj = mkInterj "öh" ;
lin era_N = mkN "aikakausi" "aikakauden" "aikakausia" ;
lin eradicate_V2 = mkWV2 (k64 "viedä") "hautaan" ; --UNCHK
lin eradication_N = mkWN (k39 "hävitys") ; --UNCHK
lin erase_V2 = mkWV2 (k53A "hävittää") ; --UNCHK
lin eraser_N = mkWN (k5 "kumi") ; --UNCHK
lin erasure_N = mkWN (compoundN "pyy" (k38 "hkiminen")) ; --UNCHK
lin erbium_N = mkWN "järjestysluku" "68" ; --UNCHK
lin erect_A = mkWA (k10 "oleva") "pystyasennossa" ; --UNCHK
lin erect_V2 = mkWV2 (k53A "pystyttää") ; --UNCHK
lin erectile_A = mkWA (compoundA "erek" (k23 "tiili")) ; --UNCHK
lin erecting_N = mkWN (k39 "pystytys") ; --UNCHK
lin erection_N = mkWN (k39 "pystytys") ; --UNCHK
lin erectness_N = mkWN (compoundN "pysty" (k40 "suoruus")) ; --UNCHK
lin eremite_N = mkWN (k4A "erakko") ; --UNCHK
lin eremitic_A = mkWA "erakko-" ; --UNCHK
lin eremitism_N = mkWN "erakkous" ; --UNCHK
lin erfurt_PN = foreignPN "Erfurt" ;
lin erg_N = mkWN "ergi" ; --UNCHK
lin ergo_Adv = mkWAdv (k99 "siis") ; --UNCHK
lin ergodic_A = mkWA "ergodinen" ; --UNCHK
lin ergodicity_N = mkWN "ergodisuus" ; --UNCHK
lin ergonomic_A = mkWA (k38 "ergonominen") ; --UNCHK
lin ergonomics_N = mkWN (k12 "ergonomia") ; --UNCHK
lin ergonovine_N = mkWN (k5 "ergonoviini") ; --UNCHK
lin ergosterol_N = mkWN "ergosteroli" ; --UNCHK
lin ergot_N = mkWN (compoundN "tora" (k10 "jyvä")) ; --UNCHK
lin ergotamine_N = mkWN "ergotamiini" ; --UNCHK
lin ergotic_A = mkWA "torajyvä-" ; --UNCHK
lin ergotism_N = mkWN (compoundN "torajyvä" (k39 "myrkytys")) ; --UNCHK
lin ergotropic_A = mkWA (compoundA "ergo" (k38 "trooppinen")) ; --UNCHK
lin ergotropism_N = mkWN (compoundN "ergo" (k5 "tropismi")) ; --UNCHK
lin erica_N = mkWN (compoundN "kello" (k10 "kanerva")) ; --UNCHK
lin erin_PN = foreignPN "Erin" ;
lin eriogonum_N = mkWN "pumissi" ; --UNCHK
lin eristic_A = mkWA (compoundA "kiistelyn" (k38 "haluinen")) ; --UNCHK
lin eristic_N = mkWN (k2 "väittely") ; --UNCHK
lin eritrea_PN = foreignPN "Eritrea" ;
lin eritrean_A = mkWA (compoundA "eritre" (k38 "alainen")) ; --UNCHK
lin eritrean_N = mkWN (compoundN "eritre" (k38 "alainen")) ; --UNCHK
lin erlangen_PN = foreignPN "Erlangen" ;
lin ermine_N = mkWN (k10A "kärppä") ; --UNCHK
lin ern_N = mkWN (compoundN "meri" (k10 "kotka")) ; --UNCHK
lin erode_V = mkWV (k53A "rapauttaa") ; --UNCHK
lin erode_V2 = mkWV2 (k53A "rapauttaa") ;
lin erogenous_A = mkWA (k38 "erogeeninen") ; --UNCHK
lin erose_A = mkWA (k41A "särmikäs") ; --UNCHK
lin erosion_N = mkWN (k3 "eroosio") ;
lin erosive_A = mkWA "erittäin" "syövyttävä" ; --UNCHK
lin erotic_A = mkWA (k38 "eroottinen") ; --UNCHK
lin erotic_N = mkWN (k2 "henkilö") "eroottinen" ; --UNCHK
lin eroticism_N = mkWN (k40 "seksikkyys") ; --UNCHK
lin err_V = mkWV (k71 "tehdä") "virhe" ; --UNCHK
lin errancy_N = mkWN (k40 "erehtyväisyys") ; --UNCHK
lin errand_N = mkWN (k10 "tehtävä") ; --UNCHK
lin errant_A = mkWA "harhaileva" ; --UNCHK
lin erratic_A = mkWA (k10 "häilyvä") ; --UNCHK
lin erratum_N = mkWN (k48 "virhe") "typografinen" ; --UNCHK
lin erroneous_A = mkWA (k10 "väärä") ; --UNCHK
lin erroneousness_N = mkWN (k48 "virhe") ; --UNCHK
lin error_N = mkN "virhe" ;
lin errorless_A = mkWA (k34A "virheetön") ; --UNCHK
lin ersatz_A = mkWA (compoundA "keino" (k38 "tekoinen")) ; --UNCHK
lin ersatz_N = mkWN "korvike-" ; --UNCHK
lin erse_N = mkWN (k38 "kelttiläinen") ; --UNCHK
lin eructation_N = mkWN (k2 "röyhtäily") ; --UNCHK
lin erudite_A = mkWA (k47 "oppinut") ; --UNCHK
lin eruditeness_N = mkWN (k39 "tietämys") ; --UNCHK
lin erudition_N = mkWN (k39 "tietämys") ; --UNCHK
lin erupt_V = mkWV (k52A "purkautua") ;
lin eruption_N = mkWN "puhkeaminen" ; --UNCHK
lin eruptive_A = mkWA (k38 "eruptiivinen") ; --UNCHK
lin erwinia_N = mkWN "erwinia" ; --UNCHK
lin eryngo_N = mkWN (compoundN "jalo-" (k48A "ohdake")) ; --UNCHK
lin erysipelas_N = mkWN (k1 "ruusu") ; --UNCHK
lin erythema_N = mkWN (k39 "punoitus") ; --UNCHK
lin erythematous_A = mkWA "eryteemaan" "liittyvä" ; --UNCHK
lin erythroblast_N = mkWN "varhaispunasolu" ; --UNCHK
lin erythroblastosis_N = mkWN (compoundN "liika" (k40 "runsaus")) "varhaispunasolujen" ; --UNCHK
lin erythroderma_N = mkWN (k39 "punoitus") "ihon" "sairaalloinen" ; --UNCHK
lin erythroid_A = mkWA "punasoluihin" "liittyvä" ; --UNCHK
lin erythromycin_N = mkWN "Pediamycin" ; --UNCHK
lin erythropoiesis_N = mkWN (k39 "muodostus") "punasolujen" ; --UNCHK
lin erythropoietic_A = mkWA (compoundA "erytropoi" (k38 "eettinen")) ; --UNCHK
lin erythropoietin_N = mkWN (k5 "erytropoietiini") ; --UNCHK
lin escadrille_N = mkWN (k48 "laivue") ; --UNCHK
lin escalade_N = mkWN (k4A "rynnäkkö") ; --UNCHK
lin escalader_N = mkWN "kiipeäjä" ; --UNCHK
lin escalate_V = mkWV (k52A "eskaloitua") ; --UNCHK
lin escalate_V2 = mkWV2 (k52A "eskaloitua") ; --UNCHK
lin escalation_N = mkWN (k1 "nousu") ; --UNCHK
lin escapade_N = mkWN (k9 "pila") ; --UNCHK
lin escape_N = mkWN (k1A "pako") ; --UNCHK
lin escape_V = mkV (mkV "lähteä") "pakoon" ;
lin escape_V2 = mkV2 (mkWV (k72A "paeta")) partitive ;
lin escape_VS = variants {} ; -- mkV2 "paeta" partitive ;
lin escapee_N = mkWN (k6 "karkuri") ; --UNCHK
lin escapement_N = mkWN (k48A "pidäke") ; --UNCHK
lin escapism_N = mkWN (k5 "eskapismi") ; --UNCHK
lin escapist_N = mkWN (k12 "haaveilija") ; --UNCHK
lin escapologist_N = mkWN (compoundN "kahle" (k41A "kuningas")) ; --UNCHK
lin escapology_N = mkWN "pakojen" "tutkiminen" ; --UNCHK
lin escargot_N = mkWN (k12 "etana") ; --UNCHK
lin escarpment_N = mkWN (k10 "luiska") "kaivannon" ; --UNCHK
lin eschar_N = mkWN (k7A "rupi") ; --UNCHK
lin eschatological_A = mkWA (k38 "eskatologinen") ; --UNCHK
lin eschatologist_N = mkWN "eskatologi" ; --UNCHK
lin eschatology_N = mkWN (k12 "eskatologia") ; --UNCHK
lin escherichia_N = mkWN "escherichia" ; --UNCHK
lin eschew_V2 = mkWV2 (k53A "välttää") ; --UNCHK
lin escolar_N = mkWN (compoundN "esko" (k5 "laari")) ; --UNCHK
lin escort_N = mkWN "saattaminen" ; --UNCHK
lin escort_V2 = mkWV2 (k61 "toimia") "seuralaisena" ; --UNCHK
lin escritoire_N = mkWN (compoundN "kirjoitus" (k10A "pöytä")) ; --UNCHK
lin escudo_N = mkWN "escudo" ; --UNCHK
lin escutcheon_N = mkWN (compoundN "vaakuna" (k7A "kilpi")) ; --UNCHK
lin esker_N = mkWN (compoundN "pitkittäis" (k1 "harju")) ; --UNCHK
lin eskimo_N = mkWN (k2 "eskimo") ; --UNCHK
lin esmolol_N = mkWN "Brevibloc" ; --UNCHK
lin esophageal_A = mkWA "ruokatorven" ; --UNCHK
lin esophagitis_N = mkWN "esofagiitti" ; --UNCHK
lin esophagoscope_N = mkWN (compoundN "esofagosko" (k5A "oppi")) ; --UNCHK
lin esophagus_N = mkWN (k1 "nielu") ; --UNCHK
lin esoteric_A = mkWA (k38 "esoteerinen") ; --UNCHK
lin esoterica_N = mkWN (compoundN "esoter" (k9A "iikka")) ; --UNCHK
lin esp_N = mkWN (k1A "havainto") "yliaistillinen" ; --UNCHK
lin espadrille_N = mkWN (k6 "sandaali") "punospohjainen" ; --UNCHK
lin espalier_N = mkWN (k4A "säleikkö") ; --UNCHK
lin especial_A = mkWA (k38 "erikoinen") ;
lin esperanto_N = mkWN (k1 "esperanto") ; --UNCHK
lin espionage_N = mkWN (k2 "vakoilu") ; --UNCHK
lin esplanade_N = mkWN (k5 "esplanadi") ; --UNCHK
lin espoo_PN = mkPN "Espoo" ;
lin espousal_N = mkWN (k10A "hyväksyntä") ; --UNCHK
lin espouse_V2 = mkWV2 (k52A "liittyä") "jhk" ; --UNCHK
lin espresso_N = mkWN (k2 "espresso") ; --UNCHK
lin esprit_N = mkWN (k40 "älykkyys") ; --UNCHK
lin esprit_de_corps_N = mkWN (k7A "henki") ; --UNCHK
lin espy_V2 = mkWV2 (k73 "bongata") ; --UNCHK
lin esquire_N = mkWN (k9 "herra") ; --UNCHK
lin essay_N = mkN "essee" ;
lin essay_V = mkWV (k61 "tutkia") ; --UNCHK
lin essay_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin essayist_N = mkWN (k5 "esseisti") ; --UNCHK
lin essen_PN = foreignPN "Essen" ;
lin essence_N = mkWN (k1 "tuoksu") ; --UNCHK
lin essential_A = mkA "olennainen" ;
lin essential_N = mkWN (k48A "tarve") ; --UNCHK
lin essentiality_N = mkWN (k40 "olennaisuus") ; --UNCHK
lin essex_PN = foreignPN "Essex" ;
lin establish_V2 = mkWV2 (mkV "perustaa") ;
lin established_A = variants {} ; --
lin establishment_N = mkN "perustaminen" ; --WN (compoundN "koko" (k38 "aminen")) ;
lin establishmentarianism_N = mkWN (compoundN "kanna" (k38 "ttaminen")) "vallitsevan" "järjestelmän" ; --UNCHK
lin estaminet_N = mkWN (k12 "kuppila") ; --UNCHK
lin estate_N = mkN (lin NK {s = d09 "tila"}) ;
lin estazolam_N = mkWN "ProSom" ; --UNCHK
lin esteem_N = mkWN (k39 "luottamus") ; --UNCHK
lin esteem_V2 = mkWV2 (k52 "katsoa") ; --UNCHK
lin ester_N = mkWN (k6 "esteri") ; --UNCHK
lin esther_PN = foreignPN "Esther" ;
lin esthete_N = mkWN (k4A "esteetikko") ; --UNCHK
lin esthetic_N = mkWN (k14A "estetiikka") ; --UNCHK
lin esthetical_A = mkWA (k38 "esteettinen") ; --UNCHK
lin esthetician_N = mkWN (k4A "esteetikko") ; --UNCHK
lin esthetics_N = mkWN (k14A "estetiikka") ; --UNCHK
lin estimable_A = mkWA (k10 "kunnioitettava") ; --UNCHK
lin estimate_N = mkWN (k3 "arvio") ; --f218
lin estimate_V = mkWV (k62 "estimoida") ; --f77
lin estimate_V2 = mkV2 (mkV (lin VK {s = c62 "arvioida"})) partitive ;
lin estimate_V2V = mkWV2V (k62 "estimoida") ; --UNCHK
lin estimate_VS = mkVS "arvioida" ;
lin estimated_A = variants {} ; --
lin estimation_N = mkWN (k3 "arvio") ; --UNCHK
lin estivation_N = mkWN (compoundN "lehti" (k1A "asento")) "silmun" ; --UNCHK
lin estoppel_N = mkWN (compoundN "estoppel-peri" (k48A "aate")) ; --UNCHK
lin estradiol_N = mkWN "estradioli" ; --UNCHK
lin estrange_V2 = mkWV2 (k71 "tehdä") "tyytymättömäksi" ; --UNCHK
lin estrangement_N = mkWN (k40 "tyytymättömyys") ; --UNCHK
lin estranging_A = mkWA "vieraannuttava" ; --UNCHK
lin estriol_N = mkWN "estrioli" ; --UNCHK
lin estrogen_N = mkWN (k5 "estrogeeni") ; --UNCHK
lin estrogenic_A = mkWA (compoundA "estrogeeni" (k38 "nen")) ; --UNCHK
lin estrone_N = mkWN "Estronol" ; --UNCHK
lin estrous_A = mkWA "kiima-" ; --UNCHK
lin estrus_N = mkWN (k9 "kiima") ; --UNCHK
lin estuarine_A = mkWA "estuaarinen" ; --UNCHK
lin estuary_N = mkWN (compoundN "joen" (k18 "suu")) ; --UNCHK
lin eta_N = mkWN "eeta" ; --UNCHK
lin etagere_N = mkWN (k4A "hyllykkö") ; --UNCHK
lin etamine_N = mkWN "etamiini" ; --UNCHK
lin etanercept_N = mkWN "Enbrel" ; --UNCHK
lin etcetera_N = mkWN (compoundN "epä" (k40 "määräisyys")) ; --UNCHK
lin etch_V = mkWV (k53A "syövyttää") ; --UNCHK
lin etch_V2 = mkWV2 (k53A "syövyttää") ; --UNCHK
lin etcher_N = mkWN (k10 "etsaaja") ; --UNCHK
lin etching_N = mkWN (compoundN "kai" (k38 "vertaminen")) ; --UNCHK
lin etd_N = mkWN (compoundN "räjähdysainejäämä" (k33 "ilmaisin")) ; --UNCHK
lin eternal_A = mkWA (k34A "päättymätön") ; --UNCHK
lin eternity_N = mkWN (k40 "iäisyys") ; --UNCHK
lin ethane_N = mkWN (k5 "etaani") ; --UNCHK
lin ethchlorvynol_N = mkWN "Placidyl" ; --UNCHK
lin ether_N = mkWN (k6 "eetteri") ; --UNCHK
lin ethereal_A = mkWA "eetteri-" ; --UNCHK
lin ethic_N = mkWN (k14A "etiikka") ; --UNCHK
lin ethical_A = mkWA (k38 "eettinen") ; --UNCHK
lin ethicism_N = mkWN (compoundN "etis" (k5 "ismi")) ; --UNCHK
lin ethicist_N = mkWN "eetikko" ; --UNCHK
lin ethics_N = mkWN (k14A "etiikka") ; --UNCHK
lin ethiopia_PN = foreignPN "Etiopia" ;
lin ethiopian_A = mkWA (compoundA "etiopi" (k38 "alainen")) ; --UNCHK
lin ethiopian_N = mkWN (compoundN "etiopi" (k38 "alainen")) ; --UNCHK
lin ethmoid_N = mkWN (compoundN "seula" (k18 "luu")) ; --UNCHK
lin ethnarch_N = mkWN (compoundN "käskyn" (k12 "haltija")) ; --UNCHK
lin ethnic_A = mkWA (k38 "etninen") ; --UNCHK
lin ethnic_N = mkWN (k38 "etninen") ; --UNCHK
lin ethnicity_N = mkWN (compoundN "etn" (k40 "isyys")) ; --UNCHK
lin ethnocentric_A = mkWA (compoundA "ryhmä" (k38 "keskeinen")) ; --UNCHK
lin ethnocentrism_N = mkWN (compoundN "ryhmä" (k40 "keskeisyys")) ; --UNCHK
lin ethnographer_N = mkWN (k5 "etnografi") ; --UNCHK
lin ethnographic_A = mkWA (k38 "etnografinen") ; --UNCHK
lin ethnography_N = mkWN (k12 "etnografia") ; --UNCHK
lin ethnological_A = mkWA (k38 "etnologinen") ; --UNCHK
lin ethnologist_N = mkWN (k5 "etnologi") ; --UNCHK
lin ethnology_N = mkWN (k12 "etnologia") ; --UNCHK
lin ethologist_N = mkWN "etologi" ; --UNCHK
lin ethology_N = mkWN "etologia" ; --UNCHK
lin ethos_N = mkWN "eetos" ; --UNCHK
lin ethosuximide_N = mkWN (compoundN "Eme" (k48A "side")) ; --UNCHK
lin ethyl_N = mkWN (compoundN "etyyli" (k5 "radikaali")) ; --UNCHK
lin ethylene_N = mkWN (k5 "eteeni") ; --UNCHK
lin etiolate_A = mkWA (k34A "väritön") ; --UNCHK
lin etiolation_N = mkWN (k38 "tekeminen") "värittömäksi" ; --UNCHK
lin etiological_A = mkWA (k38 "etiologinen") ; --UNCHK
lin etiologist_N = mkWN "etiologi" ; --UNCHK
lin etiology_N = mkWN (k12 "etiologia") ; --UNCHK
lin etiquette_N = mkWN (k5A "etiketti") ; --UNCHK
lin etodolac_N = mkWN "Lodine" ; --UNCHK
lin etude_N = mkWN (k5 "etydi") ; --UNCHK
lin etui_N = mkWN (k12 "rasia") ; --UNCHK
lin etymological_A = mkWA (k38 "etymologinen") ; --UNCHK
lin etymologist_N = mkWN "etymologi" ; --UNCHK
lin etymology_N = mkWN (k12 "etymologia") ; --UNCHK
lin etymon_N = mkWN (compoundN "kanta" (k9 "sana")) ; --UNCHK
lin eucalyptus_N = mkWN (k39 "eukalyptus") ; --UNCHK
lin eucharist_N = mkWN (k38 "ehtoollinen") "pyhä" ; --UNCHK
lin euchre_N = mkWN "euchre" ; --UNCHK
lin euclidean_A = mkWA (k38 "euklidinen") ; --UNCHK
lin euclidian_A = mkWA (k38 "euklidinen") ; --UNCHK
lin eudemon_N = mkWN "eudaimon" ; --UNCHK
lin eudemonic_A = mkWA "eudaimoninen" ; --UNCHK
lin eudemonism_N = mkWN (compoundN "onnellisuus" (k5A "oppi")) ; --UNCHK
lin eudiometer_N = mkWN (compoundN "eudio" (k5 "metri")) ; --UNCHK
lin eugene_PN = foreignPN "Eugene" ;
lin eugenic_A = mkWA (compoundA "rotu" (k38 "hygieeninen")) ; --UNCHK
lin eugenics_N = mkWN (compoundN "rotu" (k12 "hygienia")) ; --UNCHK
lin euglena_N = mkWN (compoundN "vihersiima" (k3 "eliö")) ; --UNCHK
lin euglenoid_N = mkWN (k10 "levä") ; --UNCHK
lin eukaryote_N = mkWN (k50 "aitotumallinen") ; --UNCHK
lin eukaryotic_A = mkWA (k50 "aitotumallinen") ; --UNCHK
lin eulogist_N = mkWN (k10 "pitäjä") "ylistyspuheen" ; --UNCHK
lin eulogistic_A = mkWA "kiittävä" ; --UNCHK
lin eulogize_V2 = mkWV2 (k53A "kiittää") ; --UNCHK
lin eulogy_N = mkWN (k39 "ylistys") ; --UNCHK
lin eunice_PN = foreignPN "Eunice" ;
lin eunuch_N = mkWN (k41 "kuohilas") ; --UNCHK
lin euphemism_N = mkWN (k5 "eufemismi") ; --UNCHK
lin euphemistic_A = mkWA (k38 "eufemistinen") ; --UNCHK
lin euphonic_A = mkWA (k41A "soinnukas") ; --UNCHK
lin euphonious_A = mkWA (k41A "soinnukas") ; --UNCHK
lin euphonium_N = mkWN (k5 "barytoni") ; --UNCHK
lin euphony_N = mkWN (k5A "musiikki") ; --UNCHK
lin euphorbium_N = mkWN "euforbia" ; --UNCHK
lin euphoria_N = mkWN (k12 "euforia") ;
lin euphoriant_A = mkWA (compoundA "euforis" (k10 "oiva")) ; --UNCHK
lin euphoriant_N = mkWN (k48A "lääke") "euforisoiva" ; --UNCHK
lin euphoric_A = mkWA (k38 "euforinen") ; --UNCHK
lin euphuism_N = mkWN (compoundN "eufu" (k5 "ismi")) ; --UNCHK
lin eupnea_N = mkWN (k39 "hengitys") "normaali" ; --UNCHK
lin eura_PN = mkPN "Eura" ;
lin eurajoki_PN = mkPN (mkN "Eurajoki" "Eurajokia") ;
lin eurasian_A = mkWA (k38 "euraasialainen") ; --UNCHK
lin eurasian_N = mkWN (k38 "euraasialainen") ; --UNCHK
lin eurhythmics_N = mkWN (k40 "sopusointuisuus") "rytminen" ; --UNCHK
lin euro_N = mkN "euro" ;
lin eurodollar_N = mkWN (compoundN "euro" (k6 "dollari")) ; --UNCHK
lin europe_PN = mkPN "Eurooppa" ;
lin european_A = mkWA (k38 "eurooppalainen") ;
lin european_N = mkWN (k38 "eurooppalainen") ; --UNCHK
lin european_union_NP = Syntax.mkNP (mkPN "Euroopan Unioni") ;
lin europium_N = mkWN "järjestysluku" "63" ; --UNCHK
lin eurypterid_N = mkWN (compoundN "järvi" (k5 "skorpioni")) ; --UNCHK
lin eurythmics_N = mkWN (k40 "sopusointuisuus") "rytminen" ; --UNCHK
lin eurythmy_N = mkWN (k40 "sopusointuisuus") "rytminen" ; --UNCHK
lin eusporangiate_A = mkWA "itiöpesäkkeelliset" ; --UNCHK
lin eusporangium_N = mkWN (compoundN "itiö" (k48A "pesäke")) ; --UNCHK
lin eutectic_N = mkWN (k39 "seos") "eutektinen" ; --UNCHK
lin euthanasia_N = mkWN (k12 "eutanasia") ; --UNCHK
lin euthenics_N = mkWN (k12 "ergonomia") ; --UNCHK
lin eutherian_A = mkWA "istukkanisäkäs-" ; --UNCHK
lin eutrophic_A = mkWA (k10 "rehevä") ; --UNCHK
lin eutrophication_N = mkWN "rehevöityminen" ; --UNCHK
lin evacuate_V2 = mkWV2 (k54A "tyhjentää") ; --UNCHK
lin evacuation_N = mkWN (k5A "evakuointi") ; --UNCHK
lin evacuee_N = mkWN (k2 "henkilö") "evakuoitu" ; --UNCHK
lin evade_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin evaluate_V = mkWV (k67 "arvostella") ; --UNCHK
lin evaluate_V2 = mkWV2 (k67 "arvostella") ; --UNCHK
lin evaluation_N = mkWN (k5A "evaluointi") ; --UNCHK
lin evaluative_A = mkWA (compoundA "arvio" (k9 "iva")) ; --UNCHK
lin evaluator_N = mkWN (k6 "tuomari") ; --UNCHK
lin evanescence_N = mkWN (compoundN "kato" (k38 "aminen")) ; --UNCHK
lin evanescent_A = mkWA (k10 "katoava") ; --UNCHK
lin evangelical_A = mkWA (k38 "evankelinen") ; --UNCHK
lin evangelicalism_N = mkWN (k5 "pietismi") ; --UNCHK
lin evangelism_N = mkWN "evankeliumin" "levittäminen" ; --UNCHK
lin evangelist_N = mkWN (k12 "lukija") "evankeliumitekstin" ; --UNCHK
lin evangelistic_A = mkWA (k38 "evankelinen") ; --UNCHK
lin evaporable_A = mkWA "höyrystyvä" ; --UNCHK
lin evaporate_V = mkWV (k52A "haihtua") ; --UNCHK
lin evaporate_V2 = mkWV2 (k52A "haihtua") ; --UNCHK
lin evaporate_VS = mkWVS (k52A "haihtua") ; --UNCHK
lin evaporation_N = mkWN (k39 "haihdutus") ; --UNCHK
lin evaporative_A = mkWA "höyrytys-" ; --UNCHK
lin evaporite_N = mkWN (compoundN "evapo" (k5A "riitti")) ; --UNCHK
lin evasion_N = mkWN "välttely" ;
lin evasive_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin evasiveness_N = mkWN (k2 "karttelu") ; --UNCHK
lin eve_N = mkWN "Eeva" ; --UNCHK
lin even_1_A = mkWA (k99 "tasan") ; --UNCHK
lin even_2_A = mkWA (k99 "tasan") ; --UNCHK
lin even_AdA = mkAdA "jopa" ; --WAdA (k99 "tasan") ;
lin even_AdV = mkAdV "jopa" ;
lin even_Adv = mkAdv "jopa" ;
lin even_N = mkWN (k9A "ilta") ; --UNCHK
lin even_V2 = mkWV2 (k53A "tasoittaa") ; --UNCHK
lin even_out_V = mkWV (k53A "tasoittaa") ; --UNCHK
lin even_though_Subj = mkSubj "vaikka" ;
lin even_handed_A = mkWA (k34A "puolueeton") ; --UNCHK
lin evening_N = mkWN (k9A "ilta") ;
lin evenness_N = mkWN (k40 "tasapuolisuus") ; --UNCHK
lin evensong_N = mkWN (compoundN "ilta" (k40 "hartaus")) ; --UNCHK
lin event_N = mkN "tapahtuma" ;
lin eventful_A = mkWA (k41A "vauhdikas") ; --UNCHK
lin eventide_N = mkWN (k9A "ilta") ; --UNCHK
lin eventration_N = mkWN (compoundN "vatsa" (k10 "tyrä")) "suuri" ; --UNCHK
lin eventual_A = mkA (mkN "lopulta" (mkN "tapahtuva")) ;
lin eventuality_N = mkWN (k10 "sattuma") "mahdollinen" ; --UNCHK
lin ever_AdV = mkAdV "koskaan" ;
lin ever_Adv = mkAdv "aina" ;
lin evergreen_A = mkWA (compoundA "iki" (k15 "vihreä")) ; --UNCHK
lin evergreen_N = mkWN (k5 "kasvi") "ainavihanta" ; --UNCHK
lin everlasting_A = mkWA (k10 "syvä") ; --UNCHK
lin everlasting_N = mkWN (compoundN "iki" (k10A "kukka")) ; --UNCHK
lin everlastingness_N = mkWN (k40 "iankaikkisuus") ; --UNCHK
lin evermore_Adv = mkWAdv (k99 "ikuisesti") ; --UNCHK
lin eversion_N = mkWN "ulospäin" "kääntyminen" ; --UNCHK
lin every_Det = S.every_Det ;
lin everybody_NP = S.everybody_NP ;
lin everyday_A = mkWA (compoundA "joka" (k38 "päiväinen")) ;
lin everyman_N = mkWN (compoundN "joka" (k42 "mies")) ; --UNCHK
lin everyone_NP = S.everybody_NP ;
lin everyplace_Adv = mkWAdv (k99 "kaikkialle") ; --UNCHK
lin everything_NP = S.everything_NP ;
lin everywhere_Adv = S.everywhere_Adv ;
lin evesham_PN = foreignPN "Evesham" ;
lin evict_V2 = mkWV2 (k55A "häätää") ; --UNCHK
lin eviction_N = mkWN (k1A "häätö") ; --UNCHK
lin evidence_1_N = mkN "todiste" | mkN "evidenssi" ;
lin evidence_2_N = mkN "evidenssi" ;
lin evidence_N = mkN "evidenssi" ;
lin evidence_V2 = mkWV2 (k53 "todistaa") ; --UNCHK
lin evident_A = mkWA (kH1 "ilmeinen") ; --UNCHK
lin evidential_A = mkWA (k38 "todisteellinen") ; --UNCHK
lin evidentiary_A = mkWA (k38 "todisteellinen") ; --UNCHK
lin evijärvi_PN = mkPN (mkN "Evijärvi" "Evijärviä") ;
lin evil_A = mkWA (k9 "paha") ;
lin evil_N = mkWN (k40 "häijyys") ; --UNCHK
lin evince_V2 = mkWV2 (k53A "osoittaa") ; --UNCHK
lin eviscerate_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin evisceration_N = mkWN (compoundN "vesi" (k38 "ttäminen")) ; --UNCHK
lin evitable_A = mkWA (k10 "oleva") "vältettävissä" ; --UNCHK
lin evocation_N = mkWN "esiin" "herättäminen" ; --UNCHK
lin evocative_A = mkWA (compoundA "muis" (k10 "tuttava")) "jstk" ; --UNCHK
lin evoke_V2 = mkWV2 (k64 "tuoda") "mieleen" ; --UNCHK
lin evolution_N = mkN "evoluutio" ; --mkWN "kehittyminen" ;
lin evolutionary_A = mkWA (compoundA "kehitys" (k38 "opillinen")) ; --UNCHK
lin evolutionistFem_N = mkWN (k10 "kannattaja") "kehitysopin" ; --UNCHK
lin evolutionistMasc_N = mkWN (k10 "kannattaja") "kehitysopin" ; --UNCHK
lin evolve_V = mkWV (k52A "kehittyä") ;
lin evolve_V2 = mkWV2 (k52A "kehittyä") ; --UNCHK
lin ewe_N = mkWN (k23 "uuhi") ; --UNCHK
lin ewell_PN = foreignPN "Ewell" ;
lin ewer_N = mkWN (k33A "kaadin") ; --UNCHK
lin ex_gratia_A = mkWA (compoundA "vapaaeh" (k38 "toinen")) ; --UNCHK
lin ex_officio_A = mkWA (k99 "puolesta") "viran" ; --UNCHK
lin ex_officio_Adv = mkWAdv (k99 "puolesta") "viran" ; --UNCHK
lin exabit_N = mkWN (compoundN "eksa" (k5A "bitti")) ; --UNCHK
lin exabyte_N = mkWN (compoundN "eksa" (k1 "tavu")) ; --UNCHK
lin exacerbate_V2 = mkWV2 (k73 "lisätä") partitive ;
lin exacerbation_N = mkWN (compoundN "pahe" (k38 "neminen")) ; --UNCHK
lin exact_A = mkA "eksaksi" ;
lin exact_V2 = mkWV2 (k61 "periä") ; --UNCHK
lin exacta_N = mkWN "kaksoisvedonlyönti" ; --UNCHK
lin exacting_A = mkWA (k10 "vaativa") ; --UNCHK
lin exaction_N = mkWN (kH1 "kanto") ; --UNCHK
lin exactitude_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin exactness_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin exaggerate_V = mkWV (k52A "ampua") "yli" ; --UNCHK
lin exaggerate_V2 = mkV2 "liioitella" partitive ; --mkWV2 (k52A "ampua") "yli" ;
lin exaggeration_N = mkWN (k2 "liioittelu") ; --UNCHK
lin exalt_V2 = mkWV2 (k54A "ylentää") ; --UNCHK
lin exaltation_N = mkWN "apoteoosi" ; --UNCHK
lin exam_N = mkWN (k5A "tentti") ; --UNCHK
lin examen_N = mkWN (k39 "tarkastus") ; --UNCHK
lin examination_N = mkWN (k2 "tarkastelu") ; --UNCHK
lin examine_V2 = mkV2 (lin VK {s = c61 "tutkia"}) ;
lin examiner_N = mkWN (k10 "tarkastaja") ; --UNCHK
lin example_N = mkN "esimerkki" ;
lin exanthem_N = mkWN (k10 "ihottuma") ; --UNCHK
lin exarch_N = mkWN (k5A "eksarkki") ; --UNCHK
lin exasperate_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin exasperating_A = mkWA (k10 "raskauttava") ; --UNCHK
lin exasperation_N = mkWN "ärsyttäminen" ; --UNCHK
lin exaugural_A = mkWA (k10 "päättävä") "virkakauden" ; --UNCHK
lin exbibit_N = mkWN (compoundN "eksbi" (k5A "bitti")) ; --UNCHK
lin excavate_V = mkWV (k56 "kaivaa") ; --UNCHK
lin excavate_V2 = mkWV2 (k56 "kaivaa") ; --UNCHK
lin excavation_N = mkWN (k9A "louhinta") ; --UNCHK
lin excavator_N = mkWN (k6 "kaivuri") ; --UNCHK
lin exceed_V2 = mkV2 "ylittää" ;
lin exceedance_N = mkWN (k40 "pysyvyys") ; --UNCHK
lin exceeding_A = mkWA (k34A "tavaton") ; --UNCHK
lin excel_V = mkWV (k67 "olla") "parempi" ; --UNCHK
lin excel_V2 = mkWV2 (k67 "olla") "parempi" ; --UNCHK
lin excellence_N = mkWN (k40 "erinomaisuus") ; --UNCHK
lin excellency_N = mkWN (k40 "taidokkuus") ; --UNCHK
lin excellent_A = mkA "erinomainen" ;
lin excelsior_N = mkWN (k9 "lastuvilla") ; --UNCHK
lin except_Conj = mkConj "paitsi" ;
lin except_Prep = S.except_Prep ;
lin except_V2 = mkWV2 (k53A "jättää") "pois" ; --UNCHK
lin except_for_Prep = mkPrep "lukuunottamatta" partitive ;
lin exception_N = mkN "poikkeus" ;
lin exceptionable_A = mkWA (compoundA "kiistan" (k38 "alainen")) ; --UNCHK
lin exceptional_A = mkWA (k38 "erikoinen") ; --UNCHK
lin excerpt_N = mkWN (k10 "katkelma") ; --UNCHK
lin excess_A = mkWA (k38 "liiallinen") ;
lin excess_N = mkN (lin NK {s = d09A "liika"}) ;
lin excessive_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin exchange_N = mkN "vaihto" ;
lin exchange_V2 = mkWV2 (k56A "vaihtaa") ; --UNCHK
lin exchangeability_N = mkWN (k40 "vaihdettavuus") ; --UNCHK
lin exchangeable_A = mkWA (k10 "vaihdettava") ; --UNCHK
lin exchanger_N = mkWN (compoundN "rahan" (k10 "vaihtaja")) ; --UNCHK
lin exchequer_N = mkWN (k40 "varallisuus") ; --UNCHK
lin excise_N = mkWN (compoundN "valmiste" (k1 "vero")) ; --UNCHK
lin excise_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin exciseman_N = mkWN (k10 "verottaja") ; --UNCHK
lin excision_N = mkWN (compoundN "juu" (k38 "riminen")) ; --UNCHK
lin excitability_N = mkWN (k40 "kiihottuvuus") ; --UNCHK
lin excitable_A = mkWA (k41 "kiivas") ; --UNCHK
lin excitant_A = mkWA (compoundA "kiih" (k10 "ottava")) ; --UNCHK
lin excitation_N = mkWN (k39 "jännitys") ; --UNCHK
lin excite_V2 = mkWV2 (k53 "piristää") ; --UNCHK
lin excited_A = variants {} ; --
lin excitement_N = mkN "innostus" ; --mkWN (k6 "meteli") ;
lin exciting_A = mkWA (k10 "jännittävä") ; --UNCHK
lin exclaim_V2 = mkWV2 (k52A "parkua") ; --UNCHK
lin exclamation_N = mkWN (k39 "huudahdus") ; --UNCHK
lin exclamatory_A = mkWA (k41A "painokas") ; --UNCHK
lin exclude_V2 = mkV2 (mkV (mkV "jättää") "ulkopuolelle") ;
lin exclusion_N = mkWN (k39 "karkotus") ; --UNCHK
lin exclusive_A = mkA "eksklusiivinen" ;
lin exclusive_N = mkWN (k5A "skuuppi") ; --UNCHK
lin excogitate_V2 = mkWV2 (k73A "kekata") ; --UNCHK
lin excogitation_N = mkWN (k39 "aikomus") ; --UNCHK
lin excogitative_A = mkWA (compoundA "poht" (k9 "iva")) ; --UNCHK
lin excogitator_N = mkWN "pohtija" ; --UNCHK
lin excommunicate_V2 = mkWV2 (k53 "julistaa") "kirkonkiroukseen" ; --UNCHK
lin excommunication_N = mkWN (kH1 "panna") ; --UNCHK
lin excoriate_V2 = mkWV2 (k61A "sättiä") ; --UNCHK
lin excoriation_N = mkWN (k5A "kritiikki") "armoton" ; --UNCHK
lin excrement_N = mkWN (k48 "uloste") ; --UNCHK
lin excrescence_N = mkWN (k38 "kasvannainen") ; --UNCHK
lin excrete_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin excretion_N = mkWN (k39 "ulostus") ; --UNCHK
lin excretory_A = mkWA "erittävä" ; --UNCHK
lin excruciating_A = mkWA (k34A "sietämätön") ; --UNCHK
lin exculpate_V2 = mkWV2 (k53A "vapauttaa") "vastuusta" ; --UNCHK
lin exculpation_N = mkWN "syyttömäksi" "todistaminen" ; --UNCHK
lin exculpatory_A = mkWA "syyttömäksi" "todistava" ; --UNCHK
lin excursion_N = mkWN "aiheesta" "eksyminen" ; --UNCHK
lin excursionist_N = mkWN (k12 "töllistelijä") ; --UNCHK
lin excusable_A = mkWA (k10 "anteeksiannettava") ; --UNCHK
lin excuse_N = mkWN (compoundN "anteeksi" (k1A "pyyntö")) ; --UNCHK
lin excuse_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin excuse_me_Interj = mkInterj "anteeksi" ;
lin execrable_A = mkWA (k10 "katala") ; --UNCHK
lin execrate_V2 = mkWV2 (k53 "julistaa") "pannaan" ; --UNCHK
lin execration_N = mkWN (k48A "kohde") "inhon" ; --UNCHK
lin executability_N = mkWN "toteutettavuus" ; --UNCHK
lin executant_N = mkWN (k4A "muusikko") ; --UNCHK
lin execute_V2 = mkV2 "suorittaa" ; --WV2 (k53A "teloittaa") ; ----ARB
lin execution_N = mkWN (k39 "toteutus") ;
lin executioner_N = mkWN (k6 "pyöveli") ; --UNCHK
lin executive_A = mkA "suorittava" ;
lin executive_N = mkN (lin NK {s = d10 "johtaja"}) ;
lin executor_N = mkWN (compoundN "pesän" (k10 "jakaja")) ; --UNCHK
lin executrix_N = mkWN (compoundN "pesän" (k10 "jakaja")) ; --UNCHK
lin exegesis_N = mkWN (compoundN "tekstin" (k39 "selitys")) ; --UNCHK
lin exegete_N = mkWN (compoundN "raamatun" (k10 "selittäjä")) ; --UNCHK
lin exegetic_A = mkWA (compoundA "ekseg" (k38 "eettinen")) ; --UNCHK
lin exemplar_N = mkWN (k5 "malli") ; --UNCHK
lin exemplary_A = mkWA "varoitukseksi" "annettu" ; --UNCHK
lin exemplification_N = mkWN "malliesimerkki" ; --UNCHK
lin exemplify_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin exemplifying_A = mkWA (k38 "havainnollinen") ; --UNCHK
lin exempt_A = mkA "vapautettu" ;
lin exempt_V2 = mkWV2 (k53A "vapauttaa") ;
lin exempt_V2V = mkWV2V (k53A "vapauttaa") ; --UNCHK
lin exemption_N = mkWN (k39 "vapautus") ; --UNCHK
lin exenteration_N = mkWN (k39 "tyhjennys") ; --UNCHK
lin exercise_N = mkN "harjoitus" ; ---ARB mkWN (k2 "kuntoilu") ;
lin exercise_V = mkWV (k67 "kuntoilla") ;
lin exercise_V2 = mkV2 "harjoittaa" ;
lin exercise_VV = mkWVV (k67 "kuntoilla") ; --UNCHK
lin exergonic_A = mkWA "eksergoninen" ; --UNCHK
lin exert_V2 = mkWV2 (k53A "ottaa") "käyttöön" ; --UNCHK
lin exertion_N = mkWN (k9 "vaiva") ; --UNCHK
lin exeter_PN = foreignPN "Exeter" ;
lin exfoliation_N = mkWN (k48 "hilse") ; --UNCHK
lin exhalation_N = mkWN (compoundN "ulos" (k39 "hengitys")) ; --UNCHK
lin exhale_V = mkWV (k53A "hengittää") "ulos" ; --UNCHK
lin exhale_V2 = mkWV2 (k53A "hengittää") "ulos" ; --UNCHK
lin exhaust_N = mkWN (compoundN "pako" (k7 "putki")) ; --UNCHK
lin exhaust_V2 = mkWV2 (k53A "näännyttää") ; --UNCHK
lin exhaust_pipe_N = mkWN (compoundN "pako" (k7 "putki")) ; --UNCHK
lin exhaustible_A = mkWA "ehtyvä" ; --UNCHK
lin exhausting_A = mkWA (k10 "rasittava") ; --UNCHK
lin exhaustion_N = mkWN (k39 "tyhjennys") ; --UNCHK
lin exhaustive_A = mkWA (k38 "perusteellinen") ; --UNCHK
lin exhibit_N = mkWN (k2 "näyttely") ;
lin exhibit_V2 = mkWV2 (k53A "marssittaa") ; --UNCHK
lin exhibition_N = mkWN (k39 "osoitus") ; --UNCHK
lin exhibitioner_N = mkWN (k12 "näytteillepanija") ; --UNCHK
lin exhibitionism_N = mkWN (k40 "säädyttömyys") ; --UNCHK
lin exhibitionist_N = mkWN (k12 "mahtailija") ; --UNCHK
lin exhibitionistic_A = mkWA "huomiota" "tavoitteleva" ; --UNCHK
lin exhibitor_N = mkWN (k12 "näytteillepanija") ; --UNCHK
lin exhilarate_V2 = mkWV2 (k53A "sykähdyttää") ; --UNCHK
lin exhilarating_A = mkWA (compoundA "riemas" (k10 "tuttava")) ; --UNCHK
lin exhilaration_N = mkWN (k39 "innostus") ; --UNCHK
lin exhort_V2 = mkWV2 (k53 "ahdistaa") ; --UNCHK
lin exhortation_N = mkWN (k39 "kehotus") ; --UNCHK
lin exhortative_A = mkWA (compoundA "keh" (k10 "ottava")) ; --UNCHK
lin exhumation_N = mkWN (compoundN "kai" (k38 "vaminen")) "esiin" ; --UNCHK
lin exhume_V2 = mkWV2 (k56 "kaivaa") "haudasta" ; --UNCHK
lin exigency_N = mkWN (k1A "ahdinko") ; --UNCHK
lin exigent_A = mkWA (k10 "vaativa") ; --UNCHK
lin exiguous_A = mkWA (k9A "niukka") ; --UNCHK
lin exile_N = mkWN (k39 "karkotus") ; --UNCHK
lin exile_V2 = mkWV2 (k53A "karkottaa") ; --UNCHK
lin exilic_A = mkWA "maanpaon" ; --UNCHK
lin exist_V = mkV vOlla "olemassa" ;
lin existence_N = mkWN (k40 "avaruus") ; --UNCHK
lin existent_A = mkWA (k10 "oleva") ; --UNCHK
lin existential_A = mkWA (k38 "eksistentiaalinen") ; --UNCHK
lin existentialism_N = mkWN (k12 "filosofia") "eksistentialistinen" ; --UNCHK
lin existentialist_A = mkWA (k38 "eksistentialistinen") ; --UNCHK
lin existentialist_N = mkWN (k5 "filosofi") "eksistentialistinen" ; --UNCHK
lin existing_A = mkA "olemassaoleva" ;
lin exit_N = mkWN (compoundN "pois" (k38 "tuminen")) ;
lin exit_V = mkWV (k67 "kuolla") "äkillisesti" ; --UNCHK
lin exmouth_PN = foreignPN "Exmouth" ;
lin exobiology_N = mkWN (compoundN "astro" (k12 "biologia")) ; --UNCHK
lin exocentric_A = mkWA "eksosentrinen" ; --UNCHK
lin exocrine_A = mkWA (compoundA "avo" (k38 "eritteinen")) ; --UNCHK
lin exode_N = mkWN (compoundN "jälki" (k39 "näytös")) ; --UNCHK
lin exodontist_N = mkWN (compoundN "hammas" (k6 "lääkäri")) ; --UNCHK
lin exodus_N = mkWN (k1A "pako") ; --UNCHK
lin exoergic_A = mkWA (compoundA "vap" (k10 "auttava")) "energiaa" ; --UNCHK
lin exogamous_A = mkWA "eksogaaminen" ; --UNCHK
lin exogamy_N = mkWN "seka-avioliitto" ; --UNCHK
lin exogenous_A = mkWA (k38 "eksogeeninen") ; --UNCHK
lin exomphalos_N = mkWN (compoundN "napanuora" (k10 "tyrä")) ; --UNCHK
lin exon_N = mkWN (k99 "DNA") "koodaava" ; --UNCHK
lin exonerate_V2 = mkWV2 (k53A "vapauttaa") "vastuusta" ; --UNCHK
lin exoneration_N = mkWN (compoundN "vapa" (k38 "uttaminen")) "syytteistä" ; --UNCHK
lin exonuclease_N = mkWN (compoundN "eksonukle" (k5 "aasi")) ; --UNCHK
lin exophthalmos_N = mkWN (compoundN "mulko" (k10 "silmä")) ; --UNCHK
lin exorbitance_N = mkWN (k40 "kohtuuttomuus") ; --UNCHK
lin exorbitant_A = mkWA (k10 "järkyttävä") ; --UNCHK
lin exorcise_V2 = mkWV2 (k56 "ajaa") "ulos" ; --UNCHK
lin exorcism_N = mkWN (k39 "manaus") ; --UNCHK
lin exorcist_N = mkWN (k10 "manaaja") ; --UNCHK
lin exorcize_V2 = mkWV2 (k56 "ajaa") "ulos" ; --UNCHK
lin exordium_N = mkWN (k1A "johdanto") ; --UNCHK
lin exoskeleton_N = mkWN (compoundN "tuki" (k9A "ranka")) "ulkoinen" ; --UNCHK
lin exosphere_N = mkWN (compoundN "eksosf" (k26 "ääri")) ; --UNCHK
lin exostosis_N = mkWN "eksostoosi" ; --UNCHK
lin exoteric_A = mkWA (compoundA "yleis" (k38 "tajuinen")) ; --UNCHK
lin exotherm_N = mkWN (compoundN "ekso" (k5 "termi")) ; --UNCHK
lin exothermic_A = mkWA (k10 "kehittävä") "lämpöä" ; --UNCHK
lin exotic_A = mkWA (k38 "eksoottinen") ; --UNCHK
lin exoticism_N = mkWN (k40 "eksoottisuus") ; --UNCHK
lin exotoxin_N = mkWN (compoundN "ekso" (k5 "toksiini")) ; --UNCHK
lin expand_V = mkWV (k52A "laajentua") ;
lin expand_V2 = mkV2 "laajentaa" partitive ;
lin expandable_A = mkWA (compoundA "laaje" (k9 "neva")) ; --UNCHK
lin expanse_N = mkWN (k40 "ulottuvuus") ; --UNCHK
lin expansion_N = mkN "laajeneminen" ;
lin expansionism_N = mkWN (compoundN "laajentumis" (k9A "politiikka")) ; --UNCHK
lin expansionist_A = mkWA (compoundA "ekspan" (k38 "sionistinen")) ; --UNCHK
lin expansive_A = mkWA (compoundA "laaje" (k9 "neva")) ; --UNCHK
lin expansiveness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin expatiate_V = mkWV (k54A "täsmentää") ; --UNCHK
lin expatiation_N = mkWN (k2 "keskustelu") "laaja" ; --UNCHK
lin expatriate_N = mkWN (k2 "henkilö") "ulkomailla" "asuva" ; --UNCHK
lin expatriate_V2 = mkWV2 (k53A "muuttaa") "maasta" ; --UNCHK
lin expect_V = mkWV (k53A "odottaa") ;
lin expect_V2 = mkV2 "odottaa" partitive ;
lin expect_V2V = mkV2V (mkV "odottaa") (mkPrep genitive) infPresPart ;
lin expect_VS = mkVS (mkV "odottaa") ;
lin expect_VV = mkVV (mkV "aikoa") ;
lin expectable_A = mkWA (k10 "oleva") "odotettavissa" ; --UNCHK
lin expectancy_N = mkWN (k39 "odotus") ; --UNCHK
lin expectation_N = mkWN (k10 "näkymä") ;
lin expected_A = mkA "odotettu" ;
lin expectedness_N = mkWN (compoundN "toden" (k40 "näköisyys")) ; --UNCHK
lin expectorant_N = mkWN (k48A "lääke") "limaa" "poistava" ; --UNCHK
lin expectorate_V = mkWV (k58A "sylkeä") ; --UNCHK
lin expectorate_V2 = mkWV2 (k58A "sylkeä") ; --UNCHK
lin expectoration_N = mkWN "yskiminen" ; --UNCHK
lin expedience_N = mkWN (k2 "tavoittelu") "oman" "edun" ; --UNCHK
lin expediency_N = mkWN (k40 "sopivuus") ; --UNCHK
lin expedient_A = mkWA (k38 "hyödyllinen") ; --UNCHK
lin expedient_N = mkWN (k1 "keino") ; --UNCHK
lin expedite_V2 = mkV2 "jouduttaa" partitive ; --mkWV2 (k61A "kiirehtiä") ;
lin expedition_N = mkWN (compoundN "tutkimus" (k7 "retki")) ; --UNCHK
lin expeditionary_A = mkWA (compoundA "siirto-" (k2 "osasto")) ; --UNCHK
lin expeditious_A = mkWA (k15 "ripeä") ; --UNCHK
lin expel_V2 = mkWV2 (k53A "erottaa") ;
lin expend_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin expendable_A = mkWA (k10 "oleva") "uhrattavissa" ; --UNCHK
lin expending_N = mkWN (k1A "käyttö") "rahan" ; --UNCHK
lin expenditure_N = mkN "kulu" ;
lin expense_N = mkWN (k39 "kustannus") ; --f149
lin expensive_A = mkA "kallis" ;
lin expensiveness_N = mkWN (k40 "kalleus") ; --UNCHK
lin experience_N = mkN "kokemus" ;
lin experience_V2 = mkWV2 (k58A "kokea") ;
lin experienced_A = mkWA (k47 "kokenut") ; --UNCHK
lin experiential_A = mkWA (compoundA "kokemus" (k38 "peräinen")) ; --UNCHK
lin experiment_N = mkN "koe" "kokeen" "koetta" "kokeita" ;
lin experiment_V = mkWV (k71 "tehdä") "koe" ; --UNCHK
lin experiment_V2 = mkWV2 (k71 "tehdä") "koe" ; --UNCHK
lin experimental_A = mkWA (k38 "kokeellinen") ;
lin experimentalism_N = mkWN (k39 "tutkimus") "empiirinen" ; --UNCHK
lin experimentation_N = mkWN (k2 "kokeilu") ; --UNCHK
lin experimenterFem_N = mkWN (k10 "testaaja") ; --UNCHK
lin experimenterMasc_N = mkWN (k10 "testaaja") ; --UNCHK
lin expert_A = mkWA (k41A "taidokas") ; --UNCHK
lin expert_N = mkWN (k5A "ekspertti") | mkN "asiantuntija" "asiantuntijoita" ;
lin expertise_N = mkWN (k1A "taito") ; --UNCHK
lin expertness_N = mkWN (k1A "taito") ; --UNCHK
lin expiable_A = mkWA (k10 "oleva") "sovitettavissa" ; --UNCHK
lin expiate_V2 = mkWV2 (k53A "sovittaa") ; --UNCHK
lin expiation_N = mkWN (k39 "sovitus") ; --UNCHK
lin expiatory_A = mkWA "sovitus-" ; --UNCHK
lin expiration_N = mkWN (compoundN "ulos" (k39 "hengitys")) ; --UNCHK
lin expiratory_A = mkWA "uloshengitys-" ; --UNCHK
lin expire_V = mkV (mkV "poistua") "voimasta" ; --WV (k53A "hengittää") "ulos" ;
lin expire_V2 = mkV2 "lakkauttaa" ;
lin expire_VS = mkWVS (k53A "hengittää") "ulos" ; --UNCHK
lin expiry_N = mkWN (k1A "hengenveto") "viimeinen" ; --UNCHK
lin explain_V2 = mkV2 "selittää" ;
lin explain_VS = mkVS (mkV "selittää") ;
lin explain_away_V = advV (lin V OP_explain_V2) OP_away_Adv ; -- guess-p-verb
lin explainable_A = mkWA (k10 "oleva") "tulkittavissa" ; --UNCHK
lin explanans_N = mkWN "explanans" ; --UNCHK
lin explanation_N = mkWN (k39 "selitys") ; --UNCHK
lin explanatory_A = mkWA "selittävä" ; --UNCHK
lin expletive_N = mkWN (k2 "sadattelu") ; --UNCHK
lin explicable_A = mkWA (k10 "oleva") "selitettävissä" ; --UNCHK
lin explicandum_N = mkWN "eksplanandum" ; --UNCHK
lin explicate_V2 = mkWV2 (k67A "kehitellä") ; --UNCHK
lin explication_N = mkWN (k2 "selvittely") ; --UNCHK
lin explicit_A = mkWA (k15 "selkeä") ;
lin explicitness_N = mkWN (k40 "täsmällisyys") ; --UNCHK
lin explode_V = mkWV (k53 "päästää") "valloilleen" ; --UNCHK
lin exploit_V2 = mkWV2 (k52A "hyötyä") "jstk" ; --UNCHK
lin exploitation_N = mkWN (k1 "riisto") ; --UNCHK
lin exploitative_A = mkWA "sortava" ; --UNCHK
lin exploiter_N = mkWN (compoundN "hyväksi" (k10 "käyttäjä")) ; --UNCHK
lin exploration_N = mkWN (k39 "tutkimus") ;
lin exploratory_A = mkWA "tutkimus-" ; --UNCHK
lin explore_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin explore_VS = mkWVS (k61 "tutkia") ; --UNCHK
lin explorerFem_N = mkWN "IE" ; --UNCHK
lin explorerMasc_N = mkWN "IE" ; --UNCHK
lin explosion_N = mkWN (k39 "räjähdys") ;
lin explosive_A = mkWA "räjähtävä" ;
lin explosive_N = mkWN (k48A "räjähde") ; --UNCHK
lin expo_N = mkWN (k2 "näyttely") ; --UNCHK
lin exponent_1_N = mkWN (k5 "potenssi") ; --UNCHK
lin exponent_2_N = mkWN (k5 "potenssi") ; --UNCHK
lin exponential_A = mkWA (k38 "räjähdysmäinen") ; --UNCHK
lin exponential_N = mkWN (compoundN "eksponentti" (k3 "funktio")) ; --UNCHK
lin exponentiation_N = mkWN (k39 "korotus") "potenssiin" ; --UNCHK
lin export_N = mkWN (k5A "vienti") ;
lin export_V = mkWV (k64 "viedä") ; --UNCHK
lin export_V2 = mkV2 "viedä" partitive ;
lin exportable_A = mkWA "vienti-" ; --UNCHK
lin exportation_N = mkWN (k5A "vienti") ; --UNCHK
lin exporterFem_N = mkWN (k10 "viejä") ; --UNCHK
lin exporterMasc_N = mkWN (k10 "viejä") ; --UNCHK
lin exporting_N = mkWN (k5A "vienti") ; --UNCHK
lin expose_N = mkWN (k39 "paljastus") ; --UNCHK
lin expose_V = mkV (mkV "tulla") "ilmi" ; --mkWV (k53A "jättää") "heitteille" ;
lin expose_V2 = mkWV2 (k53A "jättää") "heitteille" ; --UNCHK
lin exposition_N = mkWN (compoundN "pää" (k1 "jakso")) ; --UNCHK
lin expositor_N = mkWN (k12 "tulkitsija") ; --UNCHK
lin expository_A = mkWA "selittävä" ; --UNCHK
lin expostulate_V = mkWV (k67A "nuhdella") ; --UNCHK
lin expostulation_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin exposure_N = mkN "altistuminen" ;
lin expound_V2 = mkWV2 (k54A "täsmentää") ; --UNCHK
lin expound_VS = mkWVS (k54A "täsmentää") ; --UNCHK
lin express_A = mkWA (compoundA "nimen" (k38 "omainen")) ; --UNCHK
lin express_Adv = mkWAdv "pikalähetyksenä" ; --UNCHK
lin express_N = mkWN (compoundN "pika" (k39 "lähetys")) ; --UNCHK
lin express_V2 = mkV2 "ilmaista" ;
lin expressible_A = mkWA (k10 "oleva") "ilmaistavissa" ; --UNCHK
lin expression_N = mkN "ilmaisu" | mkN "ilmaus" ;
lin expressionism_N = mkWN (k5 "ekspressionismi") ; --UNCHK
lin expressionistFem_N = mkWN (k5 "ekspressionisti") ; --UNCHK
lin expressionistMasc_N = mkWN (k5 "ekspressionisti") ; --UNCHK
lin expressionist_A = mkWA (k38 "ekspressionistinen") ; --UNCHK
lin expressionless_A = mkWA (k34A "eleetön") ; --UNCHK
lin expressive_A = mkWA (k41A "ilmeikäs") ; --UNCHK
lin expressiveness_N = mkWN (k40 "ilmeikkyys") ; --UNCHK
lin expressway_N = mkWN (compoundN "valta" (k19 "tie")) ; --UNCHK
lin expropriation_N = mkWN (compoundN "pakko-" (k1A "otto")) ; --UNCHK
lin expulsion_N = mkWN (compoundN "ulos" (k1A "työntö")) ; --UNCHK
lin expunction_N = mkWN (compoundN "pyy" (k38 "hkiminen")) ; --UNCHK
lin expunge_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin expurgate_V2 = mkWV2 (k54A "lyhentää") ; --UNCHK
lin expurgation_N = mkWN (compoundN "siivo" (k38 "aminen")) ; --UNCHK
lin expurgator_N = mkWN (k6 "sensori") ; --UNCHK
lin exquisite_A = mkWA (k10 "ihastuttava") ; --UNCHK
lin exquisiteness_N = mkWN "sirous" ; --UNCHK
lin extempore_Adv = mkWAdv (compoundAdv "tem" (k48 "pore")) "ex" ; --UNCHK
lin extemporization_N = mkWN (k5A "improvisointi") ; --UNCHK
lin extend_V = mkV "jatkua" ;
lin extend_V2 = mkV2 "laajentaa" | mkV2 "pidentää" ;
lin extended_A = variants {} ; --
lin extendible_A = mkWA (k10 "oleva") "laajennettavissa" ; --UNCHK
lin extensile_A = mkWA "venytettävä" ; --UNCHK
lin extension_N = mkN "laajennus" ; ---ARB mkWN "laajentaminen" ;
lin extensional_A = mkWA "joukko-" ; --UNCHK
lin extensive_A = mkWA (compoundA "laaja" (k38 "peräinen")) ; --UNCHK
lin extent_N = mkWN (k40 "laajuus") ;
lin extenuate_V2 = mkWV2 (k54A "lieventää") ; --UNCHK
lin extenuating_A = mkWA "lieventävä" ; --UNCHK
lin extenuation_N = mkWN (compoundN "lie" (k38 "ventäminen")) ; --UNCHK
lin exterior_A = mkWA "ulko-" ; --UNCHK
lin exterior_N = mkWN (compoundN "ulko" (k9A "pinta")) ; --UNCHK
lin exteriorize_V2 = mkWV2 (k53 "havainnollistaa") ; --UNCHK
lin exterminable_A = mkWA (k10 "oleva") "tuhottavissa" ; --UNCHK
lin extermination_N = mkWN (compoundN "tuho" (k38 "aminen")) ; --UNCHK
lin exterminator_N = mkWN "tuholaistorjuja" ; --UNCHK
lin extern_N = mkWN (k12 "opiskelija") "lääketieteen" ; --UNCHK
lin external_A = mkWA (k38 "ulkoinen") ;
lin external_N = mkWN (k9A "seikka") "ulkoinen" ; --UNCHK
lin externalization_N = mkWN (compoundN "ruumiillis" (k38 "taminen")) ; --UNCHK
lin externalize_V2 = mkWV2 (k53 "havainnollistaa") ; --UNCHK
lin exteroceptive_A = mkWA "ulkoaisteihin" "liittyvä" ; --UNCHK
lin exteroceptor_N = mkWN (compoundN "ulko" (k5 "aisti")) ; --UNCHK
lin exterritorial_A = mkWA (compoundA "eks" (k38 "territoriaalinen")) ; --UNCHK
lin extinct_A = mkWA "sammunut" ; --UNCHK
lin extinction_N = mkWN "sammuttaminen" ; --UNCHK
lin extinguish_V2 = mkWV2 (k64 "viedä") "hautaan" ; --UNCHK
lin extinguishable_A = mkWA (k10 "oleva") "sammutettavissa" ; --UNCHK
lin extinguisher_N = mkWN (k33A "sammutin") ; --UNCHK
lin extirpate_V2 = mkWV2 (k58 "kitkeä") ; --UNCHK
lin extirpation_N = mkWN (compoundN "juu" (k38 "riminen")) ; --UNCHK
lin extol_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin extort_V = mkWV (k54A "pusertaa") ; --UNCHK
lin extort_V2 = mkWV2 (k54A "pusertaa") ; --UNCHK
lin extortion_N = mkWN (k39 "kiristys") ; --UNCHK
lin extortionate_A = mkWA (k10 "järkyttävä") ; --UNCHK
lin extra_A = mkA "ylimääräinen" ;
lin extra_Adv = mkWAdv (compoundAdv "erityi" (k99 "sen")) ; --UNCHK
lin extra_N = mkWN (k5A "duplikaatti") ; --UNCHK
lin extracellular_A = mkWA (compoundA "ulko" (k38 "puolinen")) "solun" ; --UNCHK
lin extract_N = variants {} ; --
lin extract_V2 = mkWV2 (k53A "vetää") "ulos" ; --UNCHK
lin extraction_N = mkWN (k1 "poisto") ; --UNCHK
lin extractor_N = mkWN (compoundN "ulos" (k10 "vetäjä")) ; --UNCHK
lin extracurricular_A = mkWA (k34A "avioton") ; --UNCHK
lin extradite_V2 = mkWV2 (k53A "karkottaa") ; --UNCHK
lin extradition_N = mkWN (k39 "luovutus") ;
lin extrados_N = mkWN (compoundN "ulko" (k9 "viiva")) "holvikaaren" ; --UNCHK
lin extragalactic_A = mkWA (compoundA "ulko" (k38 "puolinen")) "linnunradan" ; --UNCHK
lin extrajudicial_A = mkWA (compoundA "ekstrajudisia" (k38 "alinen")) ; --UNCHK
lin extralinguistic_A = mkWA (compoundA "ekstra" (k38 "lingvistinen")) ; --UNCHK
lin extramarital_A = mkWA (k34A "avioton") ; --UNCHK
lin extramural_A = mkWA (compoundA "ulko" (k38 "puolinen")) "yhteisön" ; --UNCHK
lin extraneous_A = mkWA (k10 "tuleva") "ulkoa" ; --UNCHK
lin extraneousness_N = mkWN (compoundN "epä" (k40 "olennaisuus")) ; --UNCHK
lin extraordinariness_N = mkWN (k40 "harvinaisuus") ; --UNCHK
lin extraordinary_A = mkA (separateN "tavallisuudesta" (mkN "poikkeava" "poikkeavia")) ;
lin extrapolate_V = mkWV "ekstrapoloida" ; --UNCHK
lin extrapolate_V2 = mkWV2 "ekstrapoloida" ; --UNCHK
lin extrapolation_N = mkWN "ekstrapolointi" ; --UNCHK
lin extrasensory_A = mkWA (compoundA "para" (k6 "normaali")) ; --UNCHK
lin extrasystole_N = mkWN (compoundN "lisä" (k39 "sykäys")) "sydämen" ; --UNCHK
lin extrasystolic_A = mkWA (compoundA "ekstra" (k38 "systolinen")) ; --UNCHK
lin extraterrestrial_A = mkWA (compoundA "ulko" (k38 "puolinen")) "maapallon" ; --UNCHK
lin extraterritorial_A = mkWA (compoundA "eks" (k38 "territoriaalinen")) ; --UNCHK
lin extravagance_N = mkWN (k40 "ylenpalttisuus") ; --UNCHK
lin extravagant_A = mkWA (k38 "ylenpalttinen") ; --UNCHK
lin extravaganza_N = mkWN (compoundN "puku" (k10 "näytelmä")) "loistelias" ; --UNCHK
lin extravasation_N = mkWN "purkautuminen" ; --UNCHK
lin extraversion_N = mkWN (compoundN "ekstro" (k3 "versio")) ; --UNCHK
lin extreme_A = mkA "äärimmäinen" ; --f66
lin extreme_N = mkWN (k40 "äärimmäisyys") ; --UNCHK
lin extremeness_N = mkWN (k40 "äärimmäisyys") ; --UNCHK
lin extremism_N = mkWN (compoundN "ääri" (k48A "liike")) ; --UNCHK
lin extremist_A = mkWA (k10A "jyrkkä") ; --UNCHK
lin extremist_N = mkWN "ekstremisti" ; --UNCHK
lin extremity_N = mkWN (k33 "elin") ; --UNCHK
lin extremum_N = mkWN (compoundN "ääri" (k48 "piste")) ; --UNCHK
lin extricable_A = mkWA (k10 "oleva") "irrotettavissa" ; --UNCHK
lin extricate_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin extrication_N = mkWN (compoundN "vapa" (k38 "uttaminen")) ; --UNCHK
lin extrinsic_A = mkWA (k10 "tuleva") "ulkoa" ; --UNCHK
lin extropic_A = mkWA "ekstropiaan" "liittyvä" ; --UNCHK
lin extropy_N = mkWN "ekstropia" ; --UNCHK
lin extrospective_A = mkWA (k5A "ekstrovertti") ; --UNCHK
lin extroversion_N = mkWN (compoundN "ekstro" (k3 "versio")) ; --UNCHK
lin extroversive_A = mkWA (k5A "ekstrovertti") ; --UNCHK
lin extrovert_A = mkWA (compoundA "ekstrovertti" (k38 "nen")) ; --UNCHK
lin extroverted_A = mkWA (k5A "ekstrovertti") ; --UNCHK
lin extrovertish_A = mkWA "ulospäin" "suuntautuva" ; --UNCHK
lin extrude_V2 = mkWV2 (k53 "puristaa") ; --UNCHK
lin extrusion_N = mkWN (k39 "puristus") ; --UNCHK
lin extrusive_A = mkWA "purkautunut" ; --UNCHK
lin exuberance_N = mkWN (k1A "into") ; --UNCHK
lin exuberant_A = mkWA (k5 "villi") ; --UNCHK
lin exudate_N = mkWN (compoundN "tulehdus" (k48 "neste")) ; --UNCHK
lin exudation_N = mkWN (compoundN "tih" (k38 "kuminen")) ; --UNCHK
lin exude_V = mkWV (k53A "erittää") ; --UNCHK
lin exude_V2 = mkWV2 (k53A "erittää") ; --UNCHK
lin exult_V = mkWV (k53 "juhlistaa") ; --UNCHK
lin exultant_A = mkWA (k10 "voittoisa") ; --UNCHK
lin exultation_N = mkWN (compoundN "ilo" (k38 "itseminen")) ; --UNCHK
lin exurbia_N = mkWN (compoundN "puutarha" (k5A "kaupunki")) ; --UNCHK
lin exuviae_N = mkWN (k9 "nahka") ; --UNCHK
lin eyas_N = mkWN (compoundN "haukan" (k38 "poikanen")) ; --UNCHK
lin eye_N = L.eye_N ;
lin eye_V2 = mkWV2 (k67 "tarkastella") ; --UNCHK
lin eye_catching_A = mkA (mkN "huomiota" (mkN "herättävä")) ;
lin eye_opener_N = mkWN (k12 "asia") "paljastava" ; --UNCHK
lin eyeball_N = mkWN (k10 "silmä") ; --UNCHK
lin eyeball_V2 = mkWV2 (k67 "tarkastella") ; --UNCHK
lin eyebath_N = mkWN (compoundN "silmähaude" (k5A "kuppi")) ; --UNCHK
lin eyebrow_N = mkWN (compoundN "kulma" (k9 "karva")) ; --UNCHK
lin eyecup_N = mkWN (k10A "kuoppa") "näköhermon" "nystyn" ; --UNCHK
lin eyedness_N = mkWN (k40 "-silmäisyys") ; --UNCHK
lin eyedrop_N = mkWN (compoundN "silmä" (k9A "tippa")) ; --UNCHK
lin eyeful_N = mkWN (k99 "kerrakseen") "nähtävää" ; --UNCHK
lin eyeglass_N = mkWN (k6 "monokkeli") ; --UNCHK
lin eyelash_N = mkWN (kH1 "ripsi") ; --UNCHK
lin eyeless_A = mkWA "silmätön" ; --UNCHK
lin eyelessness_N = mkWN "silmättömyys" ; --UNCHK
lin eyelet_N = mkWN (k14A "silmukka") ; --UNCHK
lin eyelid_N = mkWN (kH1 "luomi") ; --UNCHK
lin eyelike_A = mkWA (compoundA "silmä" (k38 "mäinen")) ; --UNCHK
lin eyeliner_N = mkWN (compoundN "rajaus" (k10 "kynä")) ; --UNCHK
lin eyepatch_N = mkWN (compoundN "silmä" (k1A "lappu")) ; --UNCHK
lin eyepiece_N = mkWN (k5 "okulaari") ; --UNCHK
lin eyes_N = mkWN "näkökulmasta" ; --UNCHK
lin eye_shadow_N = mkWN (compoundN "luomi" (k5 "väri")) ; --UNCHK
lin eyeshot_N = mkWN (compoundN "silmän" (k10 "kantama")) ; --UNCHK
lin eyesight_N = mkWN (k1A "näkö") ; --UNCHK
lin eyesore_N = mkWN (k10 "näkymä") "ruma" ; --UNCHK
lin eyespot_N = mkWN (compoundN "silmä" (k10 "täplä")) ; --UNCHK
lin eyestrain_N = mkWN (compoundN "näkö" (k39 "väsymys")) ; --UNCHK
lin eyetooth_N = mkWN (compoundN "raatelu" (k41A "hammas")) ; --UNCHK
lin eyewash_N = mkWN (compoundN "silmä" (k48A "haude")) ; --UNCHK
lin eyewitness_N = mkWN (compoundN "silmin" (k12 "näkijä")) ; --UNCHK
lin eyrie_N = mkWN (k1A "asunto") "korkealla" "sijaitseva" ; --UNCHK
lin eyrir_N = mkWN (k5 "äyri") ; --UNCHK
lin eyry_N = mkWN (k1A "asunto") "korkealla" "sijaitseva" ; --UNCHK
lin fa_N = mkWN "fa" ; --UNCHK
lin fab_A = mkWA (k10 "mahtava") ; --UNCHK
lin fabian_A = mkWA "fabianistinen" ; --UNCHK
lin fabian_N = mkWN (compoundN "fabia" (k5 "nisti")) ; --UNCHK
lin fable_N = mkWN (k6 "faabeli") ; --UNCHK
lin fabled_A = mkWA (k38 "tarumainen") ; --UNCHK
lin fabric_N = mkWN (k48A "vaate") ; --UNCHK
lin fabricate_V2 = mkWV2 (k53A "sepittää") ; --UNCHK
lin fabrication_N = mkWN (k2 "valehtelu") ;
lin fabulist_N = mkWN (k10 "sepittäjä") "tarujen" ; --UNCHK
lin fabulous_A = mkWA (k34A "uskomaton") ; --UNCHK
lin facade_N = mkWN (k5 "fasadi") ; --UNCHK
lin face_N = mkN "kasvo" | mkN "naama" ; ---- plural "kasvot" also possible
lin face_V = mkV "kohdata" ;
lin face_V2 = mkV2 (mkV "kohdata") ;
lin face_card_N = mkWN (compoundN "kuva" (k5A "kortti")) ; --UNCHK
lin face_cloth_N = mkWN (compoundN "pesu" (k1A "lappu")) ; --UNCHK
lin face_cream_N = mkWN (compoundN "päivä" (k48A "voide")) ; --UNCHK
lin face_lift_N = mkWN (k39 "kohennus") ; --UNCHK
lin face_lifting_N = mkWN (k39 "kohennus") ; --UNCHK
lin face_off_V2 = mkWV2 (k53A "aloittaa") ; --UNCHK
lin face_pack_N = mkWN (k3 "naamio") ; --UNCHK
lin face_powder_N = mkWN (k6 "puuteri") ; --UNCHK
lin face_saving_A = mkA "pelastava" ; ---ARB
lin face_up_to_V2 = prepV2 (advV OP_face_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin faceless_A = mkWA (k34A "kasvoton") ; --UNCHK
lin faceplate_N = mkWN (k28 "kansi") ; --UNCHK
lin facer_N = mkWN (compoundN "kasv" (k10 "oja")) "isku" "vasten" ; --UNCHK
lin facet_N = mkWN (k26 "puoli") ; --UNCHK
lin faceted_A = mkWA (compoundA "viis" (k1 "tetty")) ; --UNCHK
lin facetious_A = mkWA (compoundA "sala" (k38 "ivallinen")) ; --UNCHK
lin facetiousness_N = mkWN (k40 "leikillisyys") ; --UNCHK
lin facia_N = mkWN (compoundN "peitin" (k1 "kalvo")) ; --UNCHK
lin facial_A = mkWA "kasvo-" ; --UNCHK
lin facial_N = mkWN (compoundN "kasvo" (k1A "hoito")) ; --UNCHK
lin facile_A = mkWA (k10 "puhuva") "miellyttävästi" ; --UNCHK
lin facilitate_V2 = mkV2 "helpottaa" partitive ; --mkWV2 (k53A "lievittää") ;
lin facilitation_N = mkWN "helpottaminen" ; --UNCHK
lin facilitative_A = mkWA "avustava" ; --UNCHK
lin facilitatory_A = mkWA (compoundA "fasilit" (k10 "oiva")) ; --UNCHK
lin facility_N = mkN "fasiliteetti" ;
lin facing_N = mkWN (k39 "vuoraus") ; --UNCHK
lin facsimile_N = mkWN (k5 "faksi") ; --UNCHK
lin fact_N = mkN "tosiasia" ;
lin fact_finding_A = mkA (mkN "tietoa" (mkN "etsivä")) ;
lin faction_N = mkN "ryhmä" (mkN "kunta") ; --mkWN (k10 "kopla") ;
lin factious_A = mkWA (compoundA "ryhmä" (k38 "kuntainen")) ; --UNCHK
lin factitious_A = mkWA (compoundA "keino" (k38 "tekoinen")) ; --UNCHK
lin factoid_N = mkWN (k38 "uutinen") "yhden" "rivin" ; --UNCHK
lin factor_N = mkN "tekijä" ;
lin factor_in_V = mkWV (k54A "vähentää") ; --UNCHK
lin factorial_A = mkWA "faktori-" ; --UNCHK
lin factorial_N = mkWN (k10 "kertoma") ; --UNCHK
lin factorization_N = mkWN "faktorointi" ; --UNCHK
lin factorize_V2 = mkWV2 (k56A "jakaa") "tekijöihin" ; --UNCHK
lin factory_N = L.factory_N ;
lin factotum_N = mkWN (compoundN "yksin" (k12 "palvelija")) ; --UNCHK
lin factual_A = mkWA (compoundA "tosi" (k38 "asiallinen")) ; --UNCHK
lin facula_N = mkWN (compoundN "fak" (k10 "ula")) ; --UNCHK
lin facultative_A = mkWA (k38 "fakultatiivinen") ; --UNCHK
lin faculty_N = mkN "henkilö" (mkN "kunta") ; --mkWN (k6 "moduuli") ;
lin fad_N = mkWN (k5A "muoti") ;
lin faddish_A = mkWA (k41A "trendikäs") ; --UNCHK
lin faddist_N = mkWN (compoundN "trendi" (k8 "pelle")) ; --UNCHK
lin faddy_A = mkWA (k41A "trendikäs") ; --UNCHK
lin fade_N = mkWN (compoundN "kato" (k38 "aminen")) ; --UNCHK
lin fade_V = mkWV (k52 "virua") ; --UNCHK
lin fade_V2 = mkWV2 (k52 "virua") ; --UNCHK
lin fadeout_N = mkWN (k39 "himmennys") ; --UNCHK
lin fado_N = mkWN "fado" ; --UNCHK
lin faecal_A = mkWA "ulostus-" ; --UNCHK
lin faerie_N = mkWN (k18 "maa") "keijukaisten" ; --UNCHK
lin faery_N = mkWN (k18 "maa") "keijukaisten" ; --UNCHK
lin fag_N = mkWN (k14A "tupakka") ; --UNCHK
lin fag_V = mkWV (k52A "uupua") ; --UNCHK
lin fag_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin faggot_N = mkWN (k1A "kimppu") ; --UNCHK
lin fagot_N = mkWN (k1A "kimppu") ; --UNCHK
lin fagoting_N = mkWN (k9A "kirjonta") ; --UNCHK
lin faience_N = mkWN (k5 "fajanssi") ; --UNCHK
lin fail_N = mkN "epäonnistuminen" ;
lin fail_V = mkV "epäonnistua" ;
lin fail_V2 = mkV2 (mkV "epäonnistua") (mkPrep inessive) ;
lin fail_VS = mkWVS (k72A "heiketä") ; --UNCHK
lin fail_VV = mkVV (mkV "epäonnistua") infIllat ;
lin faille_N = mkWN (compoundN "loimiripsi" (k5A "silkki")) ; --UNCHK
lin failure_N = mkN "epä" (mkN "onnistuminen") ;
lin fain_Adv = mkWAdv (k99 "halukkaasti") ; --UNCHK
lin faineance_N = mkWN (k40 "joutilaisuus") ; --UNCHK
lin faineant_A = mkWA (k1A "veltto") ; --UNCHK
lin faint_A = mkWA (k1A "säikky") ; --UNCHK
lin faint_N = mkWN (k39 "menetys") "tajunnan" ; --UNCHK
lin faint_V = mkWV (k53A "menettää") "tajuntansa" ; --UNCHK
lin faintheartedness_N = mkWN (k40 "heikkous") ; --UNCHK
lin faintness_N = mkWN (k40 "hämäryys") ; --UNCHK
lin fair_A = mkA "reilu" ;
lin fair_Adv = mkWAdv (k99 "tasapuolisesti") ; --UNCHK
lin fair_N = mkWN (k6 "tivoli") ; --UNCHK
lin fairground_N = mkWN (compoundN "sirkus" (k10A "kenttä")) ; --UNCHK
lin fairish_A = mkWA (k15 "vaalea") ; --UNCHK
lin fairlead_N = mkWN (k33 "ohjain") "vaijerin" ; --UNCHK
lin fairly_Adv = mkAdv "melkoisesti" | adjAdv fair_A ; -- derived
lin fairness_N = mkN "reiluus" ; --WN (k40 "ihanuus") ;
lin fairy_N = mkWN (k1A "tonttu") ; --UNCHK
lin fairyland_N = mkWN (k18 "maa") "keijukaisten" ; --UNCHK
lin fairytale_N = mkWN (k39 "selitys") "pitkä" ; --UNCHK
lin fait_accompli_N = mkN (mkN "tapahtunut") (mkN "tosiasia") ;
lin faith_N = mkWN (k1 "usko") ;
lin faith_healing_N = mkWN (compoundN "henki" (k39 "parannus")) ; --UNCHK
lin faithful_A = mkWA (k38 "uskollinen") ; --UNCHK
lin faithful_N = mkWN (k41 "katras") ; --UNCHK
lin faithfulness_N = mkWN (k40 "lojaalius") ; --UNCHK
lin faithless_A = mkWA (k34A "uskoton") ; --UNCHK
lin faithlessness_N = mkWN (k40 "epävakaisuus") ; --UNCHK
lin fake_A = mkWA (k10 "väärä") ; --UNCHK
lin fake_N = mkWN (k39 "harhautus") ; --UNCHK
lin fake_V2 = mkWV2 (k67A "teeskennellä") ; --UNCHK
lin fakery_N = mkWN (k39 "väärennös") ; --UNCHK
lin fakir_N = mkWN (k6 "fakiiri") ; --UNCHK
lin falafel_N = mkWN "falafel" ; --UNCHK
lin falangist_N = mkWN (k5 "falangisti") ; --UNCHK
lin falcate_A = mkWA (k38 "muotoinen") "sirpin" ; --UNCHK
lin falchion_N = mkWN (k9A "miekka") "käyrä" "leveäteräinen" ; --UNCHK
lin falcon_N = mkWN (k9A "haukka") ; --UNCHK
lin falconer_N = mkWN (compoundN "haukka" (k10 "metsästäjä")) ; --UNCHK
lin falconine_A = mkWA (compoundA "haukka" (k38 "mainen")) ; --UNCHK
lin falconry_N = mkWN (compoundN "ope" (k38 "ttaminen")) "ajohaukan" ; --UNCHK
lin falkirk_PN = foreignPN "Falkirk" ;
lin fall_1_N = variants {} ; --
lin fall_2_N = variants {} ; --
lin fall_N = mkN "putoaminen" ;
lin fall_V = mkV "pudota" ;
lin fall_about_V = advV OP_fall_V OP_about_Adv ; -- guess-p-verb
lin fall_apart_V = mkWV (k67 "mennä") "rikki" ; --UNCHK
lin fall_back_V = mkWV (k74A "langeta") ; --UNCHK
lin fall_back_on_V2 = prepV2 (advV OP_fall_V OP_back_Adv ) OP_on_Prep ; -- guess-p-verb
lin fall_behind_V = mkWV (k52A "vetäytyä") ; --UNCHK
lin fall_behind_in_V2 = prepV2 (advV OP_fall_V OP_behind_Adv ) OP_in_Prep ; -- guess-p-verb
lin fall_down_V = mkWV (k74A "pudota") ; --UNCHK
lin fall_for_V2 = mkWV2 (k52 "rakastua") ; --UNCHK
lin fall_in_V = mkWV (k52A "murtua") ; --UNCHK
lin fall_into_V2 = mkWV2 (k52 "kuulua") "jhk" ; --UNCHK
lin fall_off_V = mkWV (k72 "laimeta") ; --UNCHK
lin fall_out_V = mkWV (k65 "käydä") ; --UNCHK
lin fall_out_with_V2 = prepV2 (advV OP_fall_V OP_out_Adv ) OP_with_Prep ; -- guess-p-verb
lin fall_over_V = mkWV (k52A "kaatua") ; --UNCHK
lin fall_through_V = mkWV (k52A "ajautua") "karille" ; --UNCHK
lin fall_under_V2 = mkWV2 (k52 "kuulua") "jhk" ; --UNCHK
lin fallacious_A = mkWA (k10 "väärä") ; --UNCHK
lin fallaciousness_N = mkWN (k40 "virheellisyys") ; --UNCHK
lin fallacy_N = mkWN (k39 "käsitys") "väärä" ; --UNCHK
lin fallboard_N = mkWN (k28 "kansi") ; --UNCHK
lin fallibility_N = mkWN "erehtyvyys" ; --UNCHK
lin fallible_A = mkWA (k38 "erehtyväinen") ; --UNCHK
lin fallout_N = mkWN (k39 "seuraus") ;
lin fallow_A = mkWA (k34A "kehittymätön") ; --UNCHK
lin fallow_N = mkWN (k18 "maa") "viljelemätön" ; --UNCHK
lin fallow_deer_N = mkWN (compoundN "kuusi" (k9 "peura")) ; --UNCHK
lin falls_N = mkWN (compoundN "vesi" (k39 "putous")) ; --UNCHK
lin falmouth_PN = foreignPN "Falmouth" ;
lin false_A = mkWA (k10 "väärä") ;
lin false_Adv = mkWAdv (k99 "kavalasti") ; --UNCHK
lin falsehood_N = mkWN "väärentäminen" ; --UNCHK
lin falseness_N = mkWN (k40 "tyhjyys") ; --UNCHK
lin falsetto_A = mkWA "falsetti-" ; --UNCHK
lin falsetto_N = mkWN (k5A "falsetti") ; --UNCHK
lin falsie_N = mkWN (k48A "täyte") ; --UNCHK
lin falsification_N = mkWN "vääräksi" "osoittaminen" ; --UNCHK
lin falsifier_N = mkWN (k10 "väärentäjä") ; --UNCHK
lin falsify_V2 = mkWV2 (k54A "väärentää") ; --UNCHK
lin falsity_N = mkWN (k48 "vale") ; --UNCHK
lin falter_V = mkWV (k67A "takellella") ; --UNCHK
lin falter_V2 = mkWV2 (k67A "takellella") ; --UNCHK
lin falteringly_Adv = mkWAdv (compoundAdv "epä" (k99 "varmasti")) ; --UNCHK
lin fame_N = mkWN (k40 "julkisuus") ; --UNCHK
lin fame_V2 = mkV2 (mkV (mkV "tehdä") "kuuluisaksi") ;
lin familial_A = mkWA "perhe-" ; --UNCHK
lin familiar_A = mkWA (k1A "tuttu") ;
lin familiar_N = mkWN (k7A "henki") ; --UNCHK
lin familiar_with_A2 = mkA2 (mkA "perehtynyt") (mkPrep illative) ;
lin familiarity_N = mkWN (k40 "vapaus") ; --UNCHK
lin familiarization_N = mkWN (compoundN "per" (k38 "ehtyminen")) ; --UNCHK
lin familiarize_V2 = mkWV2 (k52A "totuttautua") ; --UNCHK
lin familiarizing_A = mkWA (compoundA "tutus" (k10 "tuttava")) ; --UNCHK
lin family_N = mkWN (k48 "perhe") ;
lin famine_N = mkWN (compoundN "nälän" (k10A "hätä")) ; --UNCHK
lin famish_V = mkWV (k52A "nääntyä") ; --UNCHK
lin famish_V2 = mkWV2 (k52A "nääntyä") ; --UNCHK
lin famotidine_N = mkWN "Pepcid" ; --UNCHK
lin famous_A = mkA "kuuluisa" ;
lin famulus_N = mkWN (k38 "apulainen") ; --UNCHK
lin fan_1_N = mkN "ihailija" ; ---ARB viuhka
lin fan_2_N = mkN "ihailija" ; ---ARB viuhka
lin fan_3_N = mkN "ihailija" ; ---ARB viuhka
lin fan_N = variants {} ; --
lin fan_V = mkWV (k52 "lietsoa") ; --UNCHK
lin fan_V2 = mkWV2 (k52 "lietsoa") ; --UNCHK
lin fan_belt_N = mkWN (k9 "hihna") "tuulettimen" ; --UNCHK
lin fanaloka_N = mkWN (compoundN "fana" (k5A "lukki")) ; --UNCHK
lin fanaticFem_N = mkWN (k12 "kiihkoilija") ; --UNCHK
lin fanaticMasc_N = mkWN (k12 "kiihkoilija") ; --UNCHK
lin fanatic_A = mkWA (k41A "raivokas") ; --UNCHK
lin fanatical_A = mkWA (k41A "raivokas") ; --UNCHK
lin fanaticism_N = mkWN (k2 "kiihkoilu") ; --UNCHK
lin fancier_N = mkWN (k10 "harrastaja") ; --UNCHK
lin fanciful_A = mkWA (k38 "oikullinen") ; --UNCHK
lin fancy_A = mkWA (k47 "hienostunut") ; --UNCHK
lin fancy_N = mkWN (k2 "kuvittelu") ; --UNCHK
lin fancy_V2 = mkWV2 (k62 "visioida") ; --UNCHK
lin fancy_VS = mkWVS (k62 "visioida") ; --UNCHK
lin fandango_N = mkWN "fandango" ; --UNCHK
lin fandom_N = mkWN (compoundN "fani" (k10A "kunta")) ; --UNCHK
lin fanfare_N = mkWN (k6 "fanfaari") ;
lin fang_N = mkWN (compoundN "myrkky" (k41A "hammas")) ; --UNCHK
lin fanged_A = mkWA (compoundA "tora" (k38 "hampainen")) ; --UNCHK
lin fanion_N = mkWN (compoundN "merkki" (k1A "lippu")) "pieni" ; --UNCHK
lin fanjet_N = mkWN (compoundN "turbiini" (k6 "moottori")) ; --UNCHK
lin fanlight_N = mkWN (compoundN "ylä" (k12 "ikkuna")) "oven" ; --UNCHK
lin fanlike_A = mkWA (k38 "viuhkamainen") ; --UNCHK
lin fanny_N = mkWN (k5A "pimppi") ; --UNCHK
lin fantail_N = mkWN (compoundN "perä" (k5 "peili")) "ulkoneva" ; --UNCHK
lin fantan_N = mkWN (k9 "kiusa") ; --UNCHK
lin fantasia_N = mkWN (k12 "fantasia") ; --UNCHK
lin fantasist_N = mkWN (k12 "haaveksija") ; --UNCHK
lin fantasize_V = mkWV (k62 "fantisoida") ; --UNCHK
lin fantast_N = mkWN (k5 "futurologi") ; --UNCHK
lin fantastic_A = mkWA (k41A "irvokas") ; --UNCHK
lin fantastically_Adv = mkWAdv (k99 "loistavasti") ; --UNCHK
lin fantasy_N = mkWN (k12 "fantasia") ; --UNCHK
lin fantods_N = mkWN (k40 "ärtyisyys") ; --UNCHK
lin far_A = mkA "etäinen" | mkA "kaukainen" ;
lin far_AdA = mkAdA "paljon" ;
lin far_flung_A = mkA "kaukainen" ;
lin far_from_Prep = mkPrep "kaukana" elative ;
lin far_reaching_A = mkA "kauaskantoinen" ;
lin farad_N = mkWN (k5 "faradi") ; --UNCHK
lin farandole_N = mkWN "farandole" ; --UNCHK
lin faraway_A = mkWA (k38 "etäinen") ; --UNCHK
lin farce_N = mkWN (k5 "farssi") ; --UNCHK
lin farcical_A = mkWA (k34A "älytön") ; --UNCHK
lin fardel_N = mkWN (k5A "nyytti") ; --UNCHK
lin fare_N = mkWN (k10 "ohjelma") ; --UNCHK
lin fare_V = mkWV (k64 "syödä") "hyvin" ; --UNCHK
lin farewell_N = mkWN (k2 "hyvästely") ; --UNCHK
lin farfalle_N = mkWN (k5 "farfalli") ; --UNCHK
lin far_fetched_A = mkWA "epätodennäköinen" ; --UNCHK
lin farina_N = mkWN (k1 "jauho") ; --UNCHK
lin farinaceous_A = mkWA (k38 "jauhomainen") ; --UNCHK
lin farkleberry_N = mkWN (k14A "puolukka") ; --UNCHK
lin farm_N = mkN "maatila" ;
lin farm_V = mkWV (k53 "valmistaa") ; --UNCHK
lin farm_V2 = mkWV2 (k53 "valmistaa") ; --UNCHK
lin farm_out_V2 = mkWV2 (k53A "teettää") "alihankintana" ; --UNCHK
lin farmer_N = mkN "viljelijä" ;
lin farmerette_N = mkWN (compoundN "maatalous" (k38 "työläinen")) ; --UNCHK
lin farmhand_N = mkWN (k5A "renki") ; --UNCHK
lin farmhouse_N = mkWN (compoundN "maalais" (k1 "talo")) ; --UNCHK
lin farming_N = mkWN (compoundN "maan" (k39 "viljelys")) ; --UNCHK
lin farmland_N = mkWN (compoundN "viljelys" (k18 "maa")) ; --UNCHK
lin farmplace_N = mkWN (compoundN "maa" (k1 "talo")) ; --UNCHK
lin farmstead_N = mkWN (compoundN "maa" (k1 "talo")) ; --UNCHK
lin farmyard_N = mkWN (k9 "piha") "maatalon" ; --UNCHK
lin farness_N = mkWN (k40 "kaukaisuus") ; --UNCHK
lin farnham_PN = foreignPN "Farnham" ;
lin farnworth_PN = foreignPN "Farnworth" ;
lin faro_N = mkWN "faro" ; --UNCHK
lin farrago_N = mkWN (k9 "kama") ; --UNCHK
lin farrier_N = mkWN (compoundN "kengitys" (k10A "seppä")) ; --UNCHK
lin farrow_N = mkWN "porsinta" ; --UNCHK
lin farrow_V = mkWV (k61 "porsia") ; --UNCHK
lin far_seeing_A = mkWA (k10 "harkitseva") ; --UNCHK
lin farsi_N = mkWN (k12 "persia") ; --UNCHK
lin far_sighted_A = mkWA (compoundA "ikä" (k38 "näköinen")) ; --UNCHK
lin fart_N = mkWN (k1 "pieru") ; --UNCHK
lin fart_V = mkWV (k67 "piereskellä") ; --UNCHK
lin farther_A = mkWA "kaukaisempi" ; --UNCHK
lin farther_Adv = mkWAdv (k99 "kauempana") ; --UNCHK
lin farthermost_A = mkWA (k36 "uloin") ; --UNCHK
lin farthest_Adv = mkWAdv (k99 "kauimmas") ; --UNCHK
lin farthing_N = mkWN (compoundN "kupari" (k9 "raha")) "1/4" "pennyn" ; --UNCHK
lin farthingale_N = mkWN (compoundN "pönkkä" (k48 "hame")) ; --UNCHK
lin fartlek_N = mkWN (compoundN "intervalli" (k2 "harjoittelu")) ; --UNCHK
lin fasces_N = mkWN (compoundN "vitsa" (k1A "kimppu")) ; --UNCHK
lin fascia_N = mkWN (compoundN "koje" (k9A "lauta")) ; --UNCHK
lin fascicle_N = mkWN (compoundN "syy" (k1A "kimppu")) ; --UNCHK
lin fasciculation_N = mkWN (compoundN "elo" (k24 "hiiri")) ; --UNCHK
lin fascinate_V2 = mkWV2 (k53A "houkuttaa") ; --UNCHK
lin fascinating_A = mkWA (k10 "hurmaava") ; --UNCHK
lin fascination_N = mkWN (compoundN "viehätys" (k10 "voima")) ; --UNCHK
lin fascioliasis_N = mkWN (compoundN "faskioli" (k5 "aasi")) ; --UNCHK
lin fasciolopsiasis_N = mkWN (compoundN "faskiolopsi" (k5 "aasi")) ; --UNCHK
lin fascism_N = mkWN (k5 "fasismi") ; --UNCHK
lin fascist_A = mkWA (k38 "fasistinen") ; --UNCHK
lin fascist_N = mkWN (k5 "fasisti") ; --UNCHK
lin fascista_N = mkWN (k5 "fasisti") ; --UNCHK
lin fashion_N = mkN "muoti" ; ---ARB mkWN (k9A "tapa") ;
lin fashion_V2 = mkWV2 (k73A "muokata") ; --UNCHK
lin fashionable_A = mkWA (k41A "tyylikäs") ;
lin fast_A = mkWA (k15 "nopea") ;
lin fast_N = mkWN (k1 "paasto") ;
lin fast_V = mkWV (k74 "paastota") ; --UNCHK
lin fastball_N = mkWN (k1A "syöttö") "nopea" ; --UNCHK
lin fasten_V = mkWV (k53A "napittaa") ; --UNCHK
lin fasten_V2 = mkWV2 (k53A "napittaa") ; --UNCHK
lin fasten_on_V2 = mkWV2 (k73 "hoksata") ; --UNCHK
lin fastener_N = mkN "pidike" ;
lin fastening_N = mkWN (k39 "kiinnitys") ; --UNCHK
lin fastidious_A = mkWA (compoundA "turhan" (k9A "tarkka")) ; --UNCHK
lin fastidiousness_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin fastigiate_A = mkWA (compoundA "pyramidi" (k38 "mainen")) ; --UNCHK
lin fastness_N = mkWN (k48A "linnake") ; --UNCHK
lin fat_A = mkWA (k10 "pulska") ; --UNCHK
lin fat_N = L.fat_N ;
lin fat_V2 = mkWV2 (k53 "pulskistaa") ; --UNCHK
lin fatal_A = mkWA (k38 "fataalinen") ; --UNCHK
lin fatalism_N = mkWN (k5 "fatalismi") ; --UNCHK
lin fatalistFem_N = mkWN (k10 "kannattaja") "predestinaatio-opin" ; --UNCHK
lin fatalistMasc_N = mkWN (k10 "kannattaja") "predestinaatio-opin" ; --UNCHK
lin fatalist_A = mkWA (k38 "fatalistinen") ; --UNCHK
lin fatalistic_A = mkWA (k38 "fatalistinen") ; --UNCHK
lin fatality_N = mkN "hengen" (mkN "vaara") ; --mkWN (compoundN "hengen" (k40 "vaarallisuus")) ;
lin fate_N = mkWN (k2 "kohtalo") ; --UNCHK
lin fate_V2 = mkWV2 (k67 "olla") "määrätty" ; --UNCHK
lin fateful_A = mkWA (k38 "enteellinen") ; --UNCHK
lin fathead_N = mkWN (k5 "aasi") ; --UNCHK
lin father_N = mkN "isä" ;
lin father_N2 = L.father_N2 ;
lin father_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin father_in_law_N = mkN "appi" ;
lin fatherhood_N = mkWN (k40 "isyys") ; --UNCHK
lin fatherland_N = mkWN (compoundN "synnyin" (k18 "maa")) ; --UNCHK
lin fatherless_A = mkWA (k34A "isätön") ; --UNCHK
lin fatherliness_N = mkWN (compoundN "isäll" (k40 "isyys")) ; --UNCHK
lin fatherly_A = mkWA (k38 "isällinen") ; --UNCHK
lin fathom_N = mkWN (compoundN "kuutio" (k5 "syli")) ; --UNCHK
lin fathom_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin fathomable_A = mkWA (k10 "oleva") "mitattavissa" ; --UNCHK
lin fatigability_N = mkWN "väsyvyys" ; --UNCHK
lin fatigue_N = mkWN (compoundN "työ" (k2 "palvelu")) ; --UNCHK
lin fatigue_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin fatigue_party_N = mkWN (compoundN "työkomennus" (k10A "kunta")) ; --UNCHK
lin fatigues_N = mkWN (compoundN "työ" (k1A "puku")) ; --UNCHK
lin fatless_A = mkWA (k34A "rasvaton") ; --UNCHK
lin fatness_N = mkWN (k5 "läski") ; --UNCHK
lin fatso_N = mkWN (k2 "punkero") ; --UNCHK
lin fatten_V = mkWV (k53 "pulskistaa") ; --UNCHK
lin fatten_V2 = mkWV2 (k53 "pulskistaa") ; --UNCHK
lin fatten_up_V2 = mkWV2 (k53 "pulskistaa") ; --UNCHK
lin fattish_A = mkWA "lihavahko" ; --UNCHK
lin fattism_N = mkWN (k9A "syrjintä") "lihavien" ; --UNCHK
lin fatty_A = mkWA (k38 "rasvainen") ; --UNCHK
lin fatuity_N = mkWN (k40 "mielettömyys") ; --UNCHK
lin fatuous_A = mkWA (k10 "tyhjä") ; --UNCHK
lin fatuousness_N = mkWN (k40 "mielettömyys") ; --UNCHK
lin fatwa_N = mkWN "fatwa" ; --UNCHK
lin fatwah_N = mkWN "fatwa" ; --UNCHK
lin faubourg_N = mkWN (compoundN "esi" (k5A "kaupunki")) ; --UNCHK
lin faucal_A = mkWA "nielu-" ; --UNCHK
lin fauces_N = mkWN (k1 "nielu") ; --UNCHK
lin faucet_N = mkWN (k9 "hana") ; --UNCHK
lin fauld_N = mkWN (k1 "levy") ; --UNCHK
lin fauldhouse_PN = foreignPN "Fauldhouse" ;
lin fault_N = mkN "virhe" ;
lin fault_V2 = mkWV2 (k61A "moittia") ; --UNCHK
lin fault_finding_N = mkWN (k39 "nalkutus") ; --UNCHK
lin faultless_A = mkWA (k34A "nuhteeton") ; --UNCHK
lin faultlessness_N = mkWN (k40 "nuhteettomuus") ; --UNCHK
lin faulty_A = mkWA (k10 "väärä") ; --UNCHK
lin faun_N = mkWN (k5 "fauni") ; --UNCHK
lin fauna_N = mkWN (k3 "olio") ; --UNCHK
lin fauteuil_N = mkWN (compoundN "noja" (k5 "tuoli")) ; --UNCHK
lin fauvism_N = mkWN (compoundN "fauv" (k5 "ismi")) ; --UNCHK
lin faux_pas_N = mkWN (k40 "karkeus") ; --UNCHK
lin faversham_PN = foreignPN "Faversham" ;
lin favism_N = mkWN (compoundN "fav" (k5 "ismi")) ; --UNCHK
lin favour_N = mkN "palvelus" ;
lin favour_V = mkWV (k61 "suosia") ; --UNCHK
lin favour_V2 = mkWV2 (k61 "suosia") ;
lin favour_VS = mkWVS (k61 "suosia") ; --UNCHK
lin favourable_A = mkWA (k10 "suotuisa") ; --UNCHK
lin favourableness_N = mkWN (k40 "kannattavuus") ; --UNCHK
lin favouriteFem_N = mkWN (k5A "suosikki") ; --UNCHK
lin favouriteMasc_N = variants {} ; --
lin favourite_A = mkWA "mieli-" ; --UNCHK
lin favouritism_N = mkWN (k9A "syrjintä") ; --UNCHK
lin favus_N = mkWN (compoundN "rupi" (k9 "silsa")) ; --UNCHK
lin fawn_N = mkWN (kH1 "vasa") ; --UNCHK
lin fawn_V = mkWV (k62 "vasikoida") ; --UNCHK
lin fax_N = variants {} ; --
lin fealty_N = mkWN (k40 "uskollisuus") ; --UNCHK
lin fear_N = mkN "pelko" ;
lin fear_V = mkV "pelätä" "pelkäsi" ; --mkWV (k53A "kunnioittaa") "syvästi" ;
lin fear_V2 = L.fear_V2 ;
lin fear_VS = L.fear_VS ;
lin fearful_A = mkWA (k41A "pelokas") ; --UNCHK
lin fearfulness_N = mkWN (k40 "pelokkuus") ; --UNCHK
lin fearless_A = mkWA (k34A "peloton") ; --UNCHK
lin fearlessness_N = mkWN (k40 "pelottomuus") ; --UNCHK
lin fearsome_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin feasibility_N = mkWN "toteutettavuus" ; --UNCHK
lin feasible_A = mkWA (k38 "mahdollinen") ; --UNCHK
lin feast_N = variants {} ; --
lin feast_V = mkWV (k52 "osallistua") "juhliin" ; --UNCHK
lin feast_V2 = mkWV2 (k52 "osallistua") "juhliin" ; --UNCHK
lin feast_day_N = mkWN (compoundN "juhla" (k10 "päivä")) ; --UNCHK
lin feat_N = mkN "uroteko" ;
lin feather_N = L.feather_N ;
lin feather_V2 = mkWV2 (k63 "saada") "höyhenet" ; --UNCHK
lin feather_boa_N = mkWN (k10 "puuhka") ; --UNCHK
lin featherbed_N = mkWN (compoundN "höyhen" (k9 "patja")) ; --UNCHK
lin featherbedding_N = mkWN (compoundN "työllistämis" (k39 "vaatimus")) ; --UNCHK
lin featherbrained_A = mkWA (k10 "tyhmä") ; --UNCHK
lin featheredge_N = mkWN (k9 "reuna") "ohennettu" ; --UNCHK
lin featherfoil_N = mkWN (compoundN "tarha" (k12 "kakkara")) ; --UNCHK
lin featherlike_A = mkWA (compoundA "sulka" (k38 "mainen")) ; --UNCHK
lin featherstone_PN = foreignPN "Featherstone" ;
lin feathertop_N = mkWN (compoundN "koriste" (k14A "kastikka")) ; --UNCHK
lin featherweight_N = mkWN (k12 "nyrkkeilijä") "höyhensarjan" ; --UNCHK
lin feathery_A = mkWA (compoundA "kori" (k1 "stettu")) "sulin" ; --UNCHK
lin feature_N = mkN "piirre" | mkWN (compoundN "erikois" (k6 "artikkeli")) ; ---- split
lin feature_V2 = mkV2 "esittää" ;
lin featureless_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin febrile_A = mkWA "kuume-" ; --UNCHK
lin feckless_A = mkWA (k34A "avuton") ; --UNCHK
lin fecklessness_N = mkWN (k40 "avuttomuus") ; --UNCHK
lin fecula_N = mkWN (k48 "uloste") ; --UNCHK
lin feculence_N = mkWN (k9A "lika") ; --UNCHK
lin feculent_A = mkWA (k38 "likainen") ; --UNCHK
lin fecund_A = mkWA (k38 "hedelmällinen") ; --UNCHK
lin fecundity_N = mkWN (k40 "hedelmällisyys") ; --UNCHK
lin fed_N = mkWN (compoundN "keskus" (k5A "pankki")) "Yhdysvaltain" ; --UNCHK
lin fedelline_N = mkWN "fedelline" ; --UNCHK
lin federal_A = mkA "liittovaltiollinen" ;
lin federalism_N = mkWN (k5 "federalismi") ; --UNCHK
lin federalist_N = mkWN "federalisti" ; --UNCHK
lin federalization_N = mkWN (compoundN "federali" (k5A "sointi")) ; --UNCHK
lin federate_A = mkWA "liitto-" ; --UNCHK
lin federate_V = mkWV (k53 "yhdistää") "valtioliitoksi" ; --UNCHK
lin federate_V2 = mkWV2 (k53 "yhdistää") "valtioliitoksi" ; --UNCHK
lin federation_N = mkN "liittovaltio" ;
lin fedora_N = mkWN (compoundN "huopa" (k1A "hattu")) ; --UNCHK
lin fee_N = mkN (lin NK {s = d01 "maksu"}) ;
lin fee_V2 = mkWV2 (k56A "antaa") "tippiä" ; --UNCHK
lin feeble_A = mkWA (k34A "hervoton") ; --UNCHK
lin feeblemindedness_N = mkWN "heikkolahjaisuus" ; --UNCHK
lin feebleness_N = mkWN (k40 "voimattomuus") ; --UNCHK
lin feed_N = mkN "syöttö" ; --mkWN (k48A "ape") ;
lin feed_V = mkWV (k53A "syöttää") ; --UNCHK
lin feed_V2 = mkWV2 (k53A "syöttää") ; --UNCHK
lin feed_off_V2 = prepV2 OP_feed_V OP_off_Prep ; -- guess-p-verb
lin feed_on_V2 = mkWV2 (k53 "elää") "jllak" ; --UNCHK
lin feed_up_V2 = prepV2 OP_feed_V OP_up_Prep ; -- guess-p-verb
lin feedback_N = mkWN (k48A "palaute") ; --UNCHK
lin feeder_N = mkWN (compoundN "lihotus" (k33 "eläin")) ; --UNCHK
lin feeding_N = mkWN (k2 "ruokailu") ; --UNCHK
lin feeding_bottle_N = mkWN (compoundN "tutti" (k1 "pullo")) ; --UNCHK
lin feedlot_N = mkWN (k2 "kasvattamo") ; --UNCHK
lin feedstock_N = mkWN (k50 "raaka-aine") ; --UNCHK
lin feel_N = mkWN (k2 "koskettelu") ; --UNCHK
lin feel_V = mkV "tuntea" ;
lin feel_V2 = mkV2 "tuntea" ;
lin feel_VA = mkVA (caseV elative (mkV "tuntua")) (mkPrep ablative) ;
lin feel_VS = mkVS "tuntea" ;
lin feel_out_V = mkWV (k67 "tunnustella") ; --UNCHK
lin feel_up_V2 = prepV2 OP_feel_V OP_up_Prep ; -- guess-p-verb
lin feel_up_to_V2 = prepV2 (advV OP_feel_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin feeler_N = mkWN (k6 "antenni") ; --UNCHK
lin feeling_N = mkN "tunne" ;
lin feelingly_Adv = mkWAdv (k99 "tunteikkaasti") ; --UNCHK
lin feetfirst_Adv = mkWAdv (k99 "edellä") "jalat" ; --UNCHK
lin feign_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin feijoa_N = mkWN (k10 "feijoa") ; --UNCHK
lin feint_N = mkWN (k39 "harhautus") ; --UNCHK
lin feint_V = mkWV (k53A "harhauttaa") ; --UNCHK
lin feist_N = mkWN (k5A "rakki") ; --UNCHK
lin feisty_A = mkWA (k10A "herkkä") ; --UNCHK
lin feldspar_N = mkWN "maasälpä" ; --UNCHK
lin felicitate_V2 = mkWV2 (k67A "onnitella") ; --UNCHK
lin felicitation_N = mkWN (k2 "onnittelu") ; --UNCHK
lin felicitous_A = mkWA (k10 "osuva") ; --UNCHK
lin felicity_N = mkWN (k40 "osuvuus") ; --UNCHK
lin feline_A = mkWA "kissan-" ; --UNCHK
lin feline_N = mkWN (k9 "kissa") ; --UNCHK
lin felixstowe_PN = foreignPN "Felixstowe" ;
lin fell_A = mkWA (kH1 "raaka") ; --UNCHK
lin fell_N = mkWN (k17 "hakkuu") ; --UNCHK
lin fell_V2 = mkWV2 (k64 "lyödä") "maahan" ; --UNCHK
lin fell_V2V = mkWV2V (k64 "lyödä") "maahan" ; --UNCHK
lin fell_VA = mkWVA (k64 "lyödä") "maahan" ; --UNCHK
lin fellah_N = mkWN "fellah" ; --UNCHK
lin fellatio_N = mkWN "fellaatio" ; --UNCHK
lin felloe_N = mkWN (k10 "kehä") "pyörän" ; --UNCHK
lin fellow_A = variants {} ; --
lin fellow_N = mkWN (k4A "nuorikko") ; --UNCHK
lin fellow_feeling_N = mkWN (k12 "empatia") ; --UNCHK
lin fellow_traveller_N = mkWN (k6 "kumppani") ; --UNCHK
lin fellowship_N = mkWN (k2 "yhteisö") ; --UNCHK
lin felon_N = mkWN (k10 "konna") ; --UNCHK
lin felonious_A = mkWA (k38 "rikollinen") ; --UNCHK
lin felony_N = mkWN (k39 "rikos") ; --UNCHK
lin felspar_N = mkWN "maasälpä" ; --UNCHK
lin felt_N = mkWN (k10A "huopa") ; --UNCHK
lin felted_A = mkWA "huovutettu" ; --UNCHK
lin felucca_N = mkWN (compoundN "fel" (k5A "ukki")) ; --UNCHK
lin felwort_N = mkWN (compoundN "horkka" (k2 "katkero")) ; --UNCHK
lin female_A = mkWA (compoundA "nais" (k38 "puolinen")) ;
lin female_N = mkN "nainen" ; --mkWN (k41 "naaras") ; --figured it's worse to call nainen a naaras than vice versa.
lin femaleness_N = mkWN (k40 "naiseus") ; --UNCHK
lin feminine_A = mkWA (k38 "naisellinen") ; --UNCHK
lin feminine_N = mkWN (k5 "feminiini") ; --UNCHK
lin femininity_N = mkWN (k40 "naisellisuus") ; --UNCHK
lin feminism_N = mkWN (k5 "feminismi") ; --UNCHK
lin feministFem_N = mkN "feministi" ;
lin feministMasc_N = variants {} ; --
lin feminist_A = mkWA (k38 "feministinen") ; --UNCHK
lin feminization_N = mkWN (compoundN "nais" (k38 "maistuminen")) ; --UNCHK
lin femtochemistry_N = mkWN (compoundN "femto" (k12 "kemia")) ; --UNCHK
lin femtometer_N = mkWN (compoundN "femto" (k5 "metri")) ; --UNCHK
lin femtosecond_N = mkWN (compoundN "femto" (k5A "sekunti")) ; --UNCHK
lin femtovolt_N = mkWN (k5A "femtovoltti") ; --UNCHK
lin femur_N = mkWN (compoundN "reisi" (k39 "lihas")) ; --UNCHK
lin fen_N = mkWN (k1A "letto") ; --UNCHK
lin fence_N = mkWN (k39 "aitaus") ;
lin fence_V2 = mkWV2 (k67 "kinastella") ; --UNCHK
lin fence_in_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin fencelike_A = mkWA (compoundA "aita" (k38 "mainen")) ; --UNCHK
lin fencer_N = mkWN (k12 "miekkailija") ; --UNCHK
lin fencing_N = mkWN (k2 "miekkailu") ; --UNCHK
lin fend_V = mkWV (k53 "vastustaa") ; --UNCHK
lin fend_V2 = mkWV2 (k53 "vastustaa") ; --UNCHK
lin fend_for_V2 = mkWV2 (k52 "puhua") "puolesta" ; --UNCHK
lin fend_off_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin fender_N = mkWN (k33 "puskin") ; --UNCHK
lin fenestra_N = mkWN (k1A "aukko") ; --UNCHK
lin fenestral_A = mkWA "ikkunan" ; --UNCHK
lin fenestration_N = mkWN (k1A "teko") "aukon" ; --UNCHK
lin fennel_N = mkWN (kH1 "fenkoli") ; --UNCHK
lin fenoprofen_N = mkWN (compoundN "fenoprofeeni" (k5 "kalsium")) ; --UNCHK
lin fenugreek_N = mkWN (k32 "siemen") "sarviapilan" ; --UNCHK
lin feoff_N = mkWN (k39 "läänitys") ; --UNCHK
lin feral_A = mkWA "villi-" ; --UNCHK
lin fergusonite_N = mkWN (compoundN "ferguso" (k5A "niitti")) ; --UNCHK
lin ferial_A = mkWA "arki-" ; --UNCHK
lin fermata_N = mkWN (k5A "fermaatti") ; --UNCHK
lin ferment_N = mkWN (k38 "käyminen") ; --UNCHK
lin ferment_V = mkWV (k65 "käydä") ; --UNCHK
lin ferment_V2 = mkWV2 (k65 "käydä") ; --UNCHK
lin fermentable_A = mkWA (compoundA "käymisky" (k38 "kyinen")) ; --UNCHK
lin fermentation_N = mkWN (k38 "käyminen") ; --UNCHK
lin fermion_N = mkWN (compoundN "ferm" (k5 "ioni")) ; --UNCHK
lin fermium_N = mkWN "järjestysluku" "100" ; --UNCHK
lin fern_N = mkWN (k38 "saniainen") ; --UNCHK
lin ferned_A = mkWA "saniais-" ; --UNCHK
lin fernlike_A = mkWA (compoundA "saniais" (k38 "mainen")) ; --UNCHK
lin ferny_A = mkWA "saniais-" ; --UNCHK
lin ferocious_A = mkWA (kH1 "raaka") ; --UNCHK
lin ferociousness_N = mkWN (k40 "häijyys") ; --UNCHK
lin ferocity_N = mkWN (k40 "villiys") ; --UNCHK
lin ferrara_PN = foreignPN "Ferrara" ;
lin ferret_N = mkWN "fretti" ; --UNCHK
lin ferret_V = mkWV (k61 "nuuskia") ; --UNCHK
lin ferret_V2 = mkWV2 (k61 "nuuskia") ; --UNCHK
lin ferret_out_V2 = mkWV2 (k61 "nuuskia") ; --UNCHK
lin ferric_A = mkWA (compoundA "rautapi" (k38 "toinen")) ; --UNCHK
lin ferricyanide_N = mkWN (compoundN "ferri" (k5 "syanidi")) ; --UNCHK
lin ferrimagnetism_N = mkWN (compoundN "ferri" (k5 "magnetismi")) ; --UNCHK
lin ferris_wheel_N = mkN "maailman" (mkN "pyörä") ;
lin ferrite_N = mkWN (k5A "ferriitti") ; --UNCHK
lin ferritin_N = mkWN "ferritiini" ; --UNCHK
lin ferrocerium_N = mkWN "ferroserium" ; --UNCHK
lin ferroconcrete_N = mkWN (compoundN "teräs" (k6 "betoni")) ; --UNCHK
lin ferrocyanide_N = mkWN (compoundN "ferro" (k5 "syanidi")) ; --UNCHK
lin ferromagnetic_A = mkWA (compoundA "ferro" (k38 "magneettinen")) ; --UNCHK
lin ferromagnetism_N = mkWN (compoundN "ferro" (k5 "magnetismi")) ; --UNCHK
lin ferrous_A = mkWA (compoundA "rautapi" (k38 "toinen")) ; --UNCHK
lin ferrule_N = mkWN (k5A "holkki") ; --UNCHK
lin ferry_N = mkWN (k39 "kuljetus") ; --UNCHK
lin ferry_V = mkWV (k67 "mennä") "lautalla" ; --UNCHK
lin ferry_V2 = mkWV2 (k67 "mennä") "lautalla" ; --UNCHK
lin ferryboat_N = mkWN (k9A "lautta") ; --UNCHK
lin ferryhill_PN = foreignPN "Ferryhill" ;
lin ferryman_N = mkWN (k6 "lautturi") ; --UNCHK
lin fertile_A = mkWA (k38 "hedelmällinen") ; --UNCHK
lin fertility_N = mkWN (k40 "hedelmällisyys") ; --UNCHK
lin fertilizable_A = mkWA (compoundA "hedelmöitys" (k38 "kelpoinen")) ; --UNCHK
lin fertilization_N = mkWN (k39 "lannoitus") ; --UNCHK
lin fertilize_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin fertilizer_N = mkWN (k48A "lannoite") ; --UNCHK
lin ferule_N = mkWN (k14A "patukka") ; --UNCHK
lin fervency_N = mkWN (k39 "innostus") ; --UNCHK
lin fervent_A = mkWA (k10 "kuuma") ; --UNCHK
lin fervid_A = mkWA (k10 "kuuma") ; --UNCHK
lin fervour_N = mkWN (k39 "innostus") ; --UNCHK
lin fescue_N = mkWN (k9A "nata") ; --UNCHK
lin fess_up_V = mkWV (k53 "kakistaa") "ulos" ; --UNCHK
lin fess_up_V2 = mkWV2 (k53 "kakistaa") "ulos" ; --UNCHK
lin fesse_N = mkWN (k28 "hirsi") ; --UNCHK
lin festal_A = mkWA (k9 "hauska") ; --UNCHK
lin fester_N = mkWN (kH1 "haava") "märkivä" ; --UNCHK
lin fester_V = mkWV (k61A "märkiä") ; --UNCHK
lin festering_N = mkWN (k9 "visva") ; --UNCHK
lin festination_N = mkWN "askelten" "tihentyminen" ; --UNCHK
lin festival_N = mkN "festivaali" ;
lin festive_A = mkWA (k9 "hauska") ; --UNCHK
lin festivity_N = mkWN (k40 "juhlallisuus") ; --UNCHK
lin festoon_N = mkWN (compoundN "koriste" (k39 "köynnös")) ; --UNCHK
lin festoon_V2 = mkWV2 (k53 "koristaa") "köynnöksin" ; --UNCHK
lin festschrift_N = mkWN (compoundN "juhla" (k2 "julkaisu")) ; --UNCHK
lin fetal_A = mkWA "sikiö-" ; --UNCHK
lin fetch_N = mkWN (k1A "nouto") ; --UNCHK
lin fetch_V2 = mkWV2 (k53A "kuljettaa") ; --UNCHK
lin fetching_A = mkWA (k10 "viehättävä") ; --UNCHK
lin fete_N = mkWN (k10 "juhla") ; --UNCHK
lin fete_V2 = mkWV2 (k53 "juhlistaa") ; --UNCHK
lin fete_day_N = mkWN (compoundN "juhla" (k10 "päivä")) ; --UNCHK
lin feterita_N = mkWN (k10 "durra") ; --UNCHK
lin fetid_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin fetish_N = mkWN (compoundN "päähän" (k10 "pinttymä")) ; --UNCHK
lin fetishism_N = mkWN (k5 "fetisismi") ; --UNCHK
lin fetishist_N = mkWN (k5 "fetisisti") ; --UNCHK
lin fetlock_N = mkWN (compoundN "vuohis" (k32 "nivel")) ; --UNCHK
lin fetology_N = mkWN (compoundN "sikiö" (k5A "oppi")) ; --UNCHK
lin fetometry_N = mkWN (k39 "mittaus") "sikiön" ; --UNCHK
lin fetoprotein_N = mkWN (compoundN "feto" (k5 "proteiini")) ; --UNCHK
lin fetoscope_N = mkWN (k33 "tähystin") "sikiön" ; --UNCHK
lin fetoscopy_N = mkWN (compoundN "sikiön" (k39 "tähystys")) ; --UNCHK
lin fetter_N = mkWN (k48 "kahle") ; --UNCHK
lin fetter_V2 = mkWV2 (k69 "kahlita") ; --UNCHK
lin fetterbush_N = mkWN (compoundN "kanerva" (k5 "kasvi")) ; --UNCHK
lin fettle_N = mkWN (k1A "kunto") ; --UNCHK
lin fettuccine_N = mkWN "fettuccini" ; --UNCHK
lin fetus_N = mkWN (k3 "sikiö") ; --UNCHK
lin feud_N = mkWN (k9A "riita") ; --UNCHK
lin feudal_A = mkWA (k38 "feodaalinen") ; --UNCHK
lin feudalism_N = mkWN (k5 "feodalismi") ; --UNCHK
lin feudatory_A = mkWA "vasalli-" ; --UNCHK
lin feudatory_N = mkWN (k5 "vasalli") ; --UNCHK
lin feude_V = mkV "vihoitella" ;
lin fever_N = mkWN (k48 "kuume") ;
lin feverfew_N = mkWN (compoundN "tarha" (k12 "kakkara")) ; --UNCHK
lin feverish_A = mkWA "kuume-" ; --UNCHK
lin feverroot_N = mkWN (k26 "kuumejuuri") ; --UNCHK
lin few_A = mkWA (k10 "muutama") ; --UNCHK
lin few_Det = S.few_Det ;
lin few_N = mkN "harva" ;
lin few_Num = {s = \\n,c => (snoun2nounBind (mkN "harva")).s ! NCase n c ; n = Sg ; isNum = True} ; --suspect
lin fewer_A = mkWA "harvemmat" ; --UNCHK
lin fewer_Det = mkDet Pl (mkN "harvempi" "harvemman" "harvempia") ;
lin fewer_than_AdN = mkAdN "vähemmän kuin" ;
lin fewness_N = mkWN (k40 "vähyys") ; --UNCHK
lin fey_A = mkWA (compoundA "sala" (k38 "peräinen")) ; --UNCHK
lin fez_N = mkWN "fetsi" ; --UNCHK
lin fiance_N = mkWN (k38 "sulhanen") ; --UNCHK
lin fiancee_N = mkWN (k33 "morsian") ; --UNCHK
lin fiasco_N = mkWN (k2 "fiasko") ; --UNCHK
lin fiat_N = mkWN (k39 "asetus") ; --UNCHK
lin fib_N = mkWN (k1A "pöty") ; --UNCHK
lin fib_V = mkWV (k73 "narrata") ; --UNCHK
lin fibber_N = mkWN (k12 "valehtelija") ; --UNCHK
lin fibbing_N = mkWN (k2 "valehtelu") ; --UNCHK
lin fiberboard_N = mkWN (compoundN "lastu" (k1 "levy")) ; --UNCHK
lin fiberglass_N = mkWN (compoundN "lasi" (k1A "kuitu")) ; --UNCHK
lin fiberscope_N = mkWN (k33 "tähystin") ; --UNCHK
lin fibre_N = mkN "kuitu" ;
lin fibreboard_N = mkWN (compoundN "lastu" (k1 "levy")) ; --UNCHK
lin fibreglass_N = mkWN (compoundN "lasi" (k1A "kuitu")) ; --UNCHK
lin fibril_N = mkWN (k48A "säie") ; --UNCHK
lin fibrillation_N = mkWN (compoundN "säikeis" (k38 "tyminen")) ; --UNCHK
lin fibrillose_A = mkWA (k38 "säikeinen") ; --UNCHK
lin fibrin_N = mkWN (k5 "fibriini") ; --UNCHK
lin fibrinase_N = mkWN (compoundN "fibrin" (k5 "aasi")) ; --UNCHK
lin fibrinogen_N = mkWN (compoundN "fibrino" (k5 "geeni")) ; --UNCHK
lin fibrinolysis_N = mkWN (compoundN "fibrinoly" (k5 "ysi")) ; --UNCHK
lin fibrinopeptide_N = mkWN (compoundN "fibrino" (k5 "peptidi")) ; --UNCHK
lin fibrinous_A = mkWA (compoundA "fibriini" (k38 "nen")) ; --UNCHK
lin fibroadenoma_N = mkWN (compoundN "fibro" (k10 "adenooma")) ; --UNCHK
lin fibroblast_N = mkWN (compoundN "fibrob" (k5 "lasti")) ; --UNCHK
lin fibrocartilage_N = mkWN (compoundN "syy" (k1 "rusto")) ; --UNCHK
lin fibrocartilaginous_A = mkWA "syyrusto-" ; --UNCHK
lin fibroma_N = mkWN (compoundN "sidekudos" (k33 "kasvain")) ; --UNCHK
lin fibromyositis_N = mkWN "fibromyosiitti" ; --UNCHK
lin fibrosis_N = mkWN "fibroosi" ; --UNCHK
lin fibrositis_N = mkWN (compoundN "lihas" (k9 "reuma")) ; --UNCHK
lin fibrosity_N = mkWN (k40 "säikeisyys") ; --UNCHK
lin fibrous_A = mkWA (k15 "sitkeä") ; --UNCHK
lin fibula_N = mkWN (compoundN "pohje" (k18 "luu")) ; --UNCHK
lin fichu_N = mkWN (compoundN "hartia" (k9 "liina")) ; --UNCHK
lin fickle_A = mkWA (k10 "häilyvä") ; --UNCHK
lin fickleness_N = mkWN (k40 "epävakaisuus") ; --UNCHK
lin fictile_A = mkWA (k10 "oleva") "muovailtavissa" ; --UNCHK
lin fiction_N = mkWN (k39 "teos") "kaunokirjallinen" ; --UNCHK
lin fictional_A = mkWA (compoundA "kauno" (k38 "kirjallinen")) ; --UNCHK
lin fictionalization_N = mkWN (compoundN "fiktionali" (k5A "sointi")) ; --UNCHK
lin fictitious_A = mkWA (k38 "valheellinen") ; --UNCHK
lin fictive_A = mkWA (k10 "luova") ; --UNCHK
lin fiddle_N = mkWN (k1 "viulu") ; --UNCHK
lin fiddle_V2 = mkWV2 (k67 "korjailla") ; --UNCHK
lin fiddleneck_N = mkWN (compoundN "aitohunaja" (k10A "kukka")) ; --UNCHK
lin fiddler_N = mkWN (k6 "tunari") ; --UNCHK
lin fiddlestick_N = mkWN (compoundN "viulun" (k26 "jousi")) ; --UNCHK
lin fidelity_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin fidget_N = mkWN (k40 "hermostuneisuus") ; --UNCHK
lin fidget_V = mkWV (k61 "sätkiä") ; --UNCHK
lin fidget_V2 = mkWV2 (k61 "sätkiä") ; --UNCHK
lin fidgety_A = mkWA (k10 "ärtyisä") ; --UNCHK
lin fiducial_A = mkWA "perus-" ; --UNCHK
lin fiduciary_A = mkWA (k1A "uskottu") ; --UNCHK
lin fiduciary_N = mkWN (k42 "mies") "uskottu" ; --UNCHK
lin fief_N = mkWN (k39 "läänitys") ; --UNCHK
lin fiefdom_N = mkWN (compoundN "seuraaja" (k10A "kunta")) ; --UNCHK
lin field_1_N = mkN "pelto" ;
lin field_2_N = mkN "kenttä" ;
lin field_3_N = mkN "kenttä" ;
lin field_4_N = mkN "kunta" ;
lin field_N = mkN "kenttä" ;
lin field_V = mkV (mkV "asettua") "ehdolle" ;
lin field_V2 = mkV2 (mkV (mkV "asettaa") "ehdolle") ;
lin field_hospital_N = mkWN (compoundN "kenttä" (k13 "sairaala")) ; --UNCHK
lin field_officer_N = mkWN (compoundN "esi" (k6 "upseeri")) ; --UNCHK
lin fielder_N = mkWN (compoundN "ulko" (k10 "pelaaja")) ; --UNCHK
lin fieldfare_N = mkWN (compoundN "räkätti" (k41 "rastas")) ; --UNCHK
lin fielding_N = mkWN (compoundN "kenttä" (k5 "peli")) ; --UNCHK
lin fieldsman_N = mkWN (compoundN "ulko" (k10 "pelaaja")) ; --UNCHK
lin fieldstone_N = mkWN (compoundN "mukula" (k7 "kivi")) ; --UNCHK
lin fieldwork_N = mkWN (compoundN "kenttä" (k39 "varustus")) ; --UNCHK
lin fieldworker_N = mkWN (compoundN "kenttätyön" (k12 "tekijä")) ; --UNCHK
lin fiend_N = mkWN (k5 "demoni") ; --UNCHK
lin fiendish_A = mkWA (k34A "jumalaton") ; --UNCHK
lin fierce_A = mkA "raju" ; --WA (k10 "kova") ;
lin fierceness_N = mkWN (k40 "villiys") ; --UNCHK
lin fieriness_N = mkWN (k40 "kiivaus") ; --UNCHK
lin fiery_A = mkWA (k38 "tulinen") ; --UNCHK
lin fife_N = mkWN (k5 "pilli") ; --UNCHK
lin fife_PN = foreignPN "Fife" ;
lin fig_N = mkWN (k3 "kaavio") ; --UNCHK
lin fig_leaf_N = mkWN (compoundN "viikunan" (k7A "lehti")) ; --UNCHK
lin fight_N = mkN "taistelu" ;
lin fight_V = mkWV (k67 "taistella") ;
lin fight_V2 = L.fight_V2 ;
lin fight_back_V = mkWV (k52A "puolustautua") ; --UNCHK
lin fight_back_V2 = mkWV2 (k52A "puolustautua") ; --UNCHK
lin fight_it_out_V2 = variants {} ; -- guess-p-verb
lin fight_off_V2 = mkWV2 (k52 "torjua") ; --UNCHK
lin fighter_N = mkWN (k10 "hävittäjä") ; --UNCHK
lin fighting_N = mkWN (k2 "kamppailu") ;
lin figment_N = mkWN (k1A "keksintö") ; --UNCHK
lin figural_A = mkWA (compoundA "vertaus" (k38 "kuvallinen")) ; --UNCHK
lin figuration_N = mkWN (k5A "kuviointi") ; --UNCHK
lin figurative_A = mkWA (k38 "kuvaannollinen") ; --UNCHK
lin figure_1_N = mkN "kuvio" ;
lin figure_2_N = mkN "luku" ;
lin figure_N = mkN "kuvio" ; --- split already mkN "luku"
lin figure_V = mkV "kuvitella" ;
lin figure_VS = mkWVS (k74 "tajuta") ;
lin figure_on_V2 = prepV2 OP_figure_V OP_on_Prep ; -- guess-p-verb
lin figure_out_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin figure_up_V2 = prepV2 OP_figure_V OP_up_Prep ; -- guess-p-verb
lin figurehead_N = mkWN (compoundN "keula" (k10 "kuva")) ; --UNCHK
lin figurine_N = mkWN (compoundN "pienois" (k39 "veistos")) ; --UNCHK
lin figwort_N = mkWN (k26 "syyläjuuri") ; --UNCHK
lin fiji_PN = foreignPN "Fidži" ;
lin fijian_A = mkWA "fidžiläinen" ; --UNCHK
lin fijian_N = mkWN "fidži" ; --UNCHK
lin filaggrin_N = mkWN "filaggriini" ; --UNCHK
lin filament_N = mkWN (k9A "lanka") ; --UNCHK
lin filamentous_A = mkWA (compoundA "rihma" (k38 "mainen")) ; --UNCHK
lin filar_A = mkWA "hiusristikko-" ; --UNCHK
lin filarial_A = mkWA "rihmamato-" ; --UNCHK
lin filariasis_N = mkWN (compoundN "rihmamato" (k5A "tauti")) ; --UNCHK
lin filariid_A = mkWA "sukkulamato-" ; --UNCHK
lin filature_N = mkWN (compoundN "vyyhdin" (k18 "puu")) ; --UNCHK
lin filbert_N = mkWN (k12 "pähkinä") ; --UNCHK
lin filch_V2 = mkWV2 (k67 "näpistellä") ; --UNCHK
lin file_N = mkN "tiedosto" ; ---- split WN (k9 "viila") ;
lin file_V = mkV "arkistoida" ;
lin file_V2 = mkV2 "arkistoida" ; ---- split (mkWV (k53 "nostaa") "kanne") (mkPrep partitive "vastaan") ;
lin file_away_V2 = mkWV2 (k54A "tallentaa") ; --UNCHK
lin file_for_V2 = prepV2 OP_file_V OP_for_Prep ; -- guess-p-verb
lin filefish_N = mkWN (compoundN "säppi" (k9 "kala")) ; --UNCHK
lin filename_N = mkWN (compoundN "tiedosto" (k7 "nimi")) ; --UNCHK
lin filer_N = mkWN (k10 "hoitaja") "kortiston" ; --UNCHK
lin filet_N = mkWN (compoundN "verkko" (k5 "pitsi")) ; --UNCHK
lin filibuster_N = mkWN (k39 "jarrutus") ; --UNCHK
lin filibuster_V = mkWV (k53A "jarruttaa") ; --UNCHK
lin filicide_N = mkWN (compoundN "lapsen" (k10 "murha")) ; --UNCHK
lin filigree_N = mkWN (k5 "filigraani") ; --UNCHK
lin filing_N = mkWN (k5A "arkistointi") ; --UNCHK
lin filipino_A = mkWA (compoundA "Filippiin" (k32A "ien")) ; --UNCHK
lin filipino_N = mkWN (compoundN "fili" (k1 "pino")) ; --UNCHK
lin fill_N = mkWN (k99 "tarpeeksi") ; --UNCHK
lin fill_V = mkV "täyttyä" ;
lin fill_V2 = mkV2 "täyttää" ;
lin fill_in_V = advV OP_fill_V OP_in_Adv ; -- guess-p-verb
lin fill_in_V2 = prepV2 OP_fill_V OP_in_Prep ; -- guess-p-verb
lin fill_in_for_V2 = prepV2 (advV OP_fill_V OP_in_Adv ) OP_for_Prep ; -- guess-p-verb
lin fill_in_on_V3 = variants {} ; -- guess-p-verb
lin fill_out_V = mkWV (k52A "tukevoitua") ; --UNCHK
lin fill_out_V2 = mkWV2 (k52A "tukevoitua") ; --UNCHK
lin fill_up_V2 = mkWV2 (k67 "tulla") "täyteen" ; --UNCHK
lin filler_N = mkWN (compoundN "täyte" (k48 "aine")) ; --UNCHK
lin fillet_N = mkWN (k48A "listake") ; --UNCHK
lin fillet_V2 = mkWV2 (k73 "fileerata") ; --UNCHK
lin filling_N = mkN "täyte" ; --WN "täyttäminen" ;
lin fillip_N = mkWN (k39 "bonus") ; --UNCHK
lin filly_N = mkWN (k9 "varsa") ; --UNCHK
lin film_1_N = mkN "filmi" | mkN "elo" (mkN "kuva") ;
lin film_2_N = mkN "kalvo" ;
lin film_N = mkN "elokuva" ;
lin film_V = mkWV (k53A "ottaa") ; --UNCHK
lin film_V2 = mkWV2 (k53A "ottaa") ; --UNCHK
lin film_star_N = mkWN (compoundN "elokuva" (k7A "tähti")) ; --UNCHK
lin filmable_A = mkWA (k10 "oleva") "kuvattavissa" ; --UNCHK
lin filmdom_N = mkWN (k41A "valkokangas") ; --UNCHK
lin filming_N = mkWN (k39 "kuvaus") ; --UNCHK
lin filmy_A = mkWA (k43 "ohut") ; --UNCHK
lin filovirus_N = mkWN (compoundN "filo" (k39 "virus")) ; --UNCHK
lin fils_N = mkWN "fils" ; --UNCHK
lin filter_N = mkWN (k33A "suodatin") ;
lin filter_V = mkWV (k52A "siivilöityä") ; --UNCHK
lin filter_V2 = mkWV2 (k52A "siivilöityä") ; --UNCHK
lin filter_out_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin filth_N = mkWN (k9 "sana") "ruma" ; --UNCHK
lin filthiness_N = mkWN (k40 "saastaisuus") ; --UNCHK
lin filthy_A = mkWA (k38 "saastainen") ; --UNCHK
lin filtrate_N = mkWN (k39 "suodos") ; --UNCHK
lin filtrate_V = mkWV (k53A "erottaa") ; --UNCHK
lin filtrate_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin filtration_N = mkWN (k39 "suodatus") ; --UNCHK
lin fimbria_N = mkWN (k48A "haarake") ; --UNCHK
lin fimbriate_A = mkWA (k38 "haarakkeinen") ; --UNCHK
lin fin_N = mkWN (k10 "evä") ; --UNCHK
lin finable_A = mkWA (compoundA "sakon" (k38 "alainen")) ; --UNCHK
lin finagle_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin finagler_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin final_A = mkA "lopullinen" ;
lin final_N = mkWN (compoundN "loppu" (k48A "koe")) ; --UNCHK
lin finale_N = mkWN (k1A "loppu") ; --UNCHK
lin finalist_N = mkWN (k5 "finalisti") ; --UNCHK
lin finality_N = mkWN (k40 "lopullisuus") ; --UNCHK
lin finalization_N = mkWN (k2 "viimeistely") ; --UNCHK
lin finalize_V2 = mkWV2 (k64 "lyödä") "lukkoon" ; --UNCHK
lin finally_Adv = mkAdv "lopuksi" | mkAdv "lopulta" ; ---- split
lin finance_N = mkN "finanssi" ;
lin finance_V2 = mkWV2 (k53A "rahoittaa") ; --f132
lin financial_A = mkA "taloudellinen" ;
lin financier_N = mkWN (k10 "rahoittaja") ;
lin financing_N = mkWN (k39 "rahoitus") ; --UNCHK
lin finback_N = mkWN (compoundN "uurteis" (k41 "valas")) ; --UNCHK
lin finch_N = mkWN (k1A "peippo") ; --UNCHK
lin find_N = mkWN (compoundN "keksi" (k38 "minen")) ; --UNCHK
lin find_V = mkV "löytää" "löysi" ;
lin find_V2 = L.find_V2 ;
lin find_V2A = mkV2A (mkV "pitää") (mkPrep partitive) (mkPrep essive) ;
lin find_VS = mkVS (mkV "huomata") ; --?
lin find_out_V = mkWV (k63 "saada") "tietää" ; --UNCHK
lin find_out_V2 = mkWV2 (k63 "saada") "tietää" ; --UNCHK
lin finder_N = mkWN (k33 "tähtäin") ; --UNCHK
lin finding_N = mkN "löydös" ; --WN "löytäminen" ;
lin findings_N = mkWN (k1 "välineistö") ; --UNCHK
lin fine_A = mkA "hieno" ;
lin fine_Adv = mkWAdv (k99 "OK") ; --UNCHK
lin fine_N = mkWN (k1A "sakko") ;
lin fine_V2 = mkV2 (mkV "sakottaa") partitive ;
lin fineable_A = mkWA (compoundA "sakon" (k38 "alainen")) ; --UNCHK
lin fineness_N = mkWN (k40 "erinomaisuus") ; --UNCHK
lin finer_A = mkWA "hienompi" ; --UNCHK
lin finespun_A = mkWA (compoundA "hiuksen" (k1 "hieno")) ; --UNCHK
lin finesse_N = mkWN (k40 "tahdikkuus") ; --UNCHK
lin finger_N = mkWN (k7 "sormi") ;
lin finger_V2 = mkWV2 (k69 "merkitä") "sormitus" ; --UNCHK
lin finger_bowl_N = mkWN (compoundN "huuhtelu" (k5A "kuppi")) ; --UNCHK
lin finger_plate_N = mkWN (k39 "suojus") ; --UNCHK
lin fingerboard_N = mkWN (compoundN "ote" (k9A "lauta")) ; --UNCHK
lin fingering_N = mkWN (k2 "sormeilu") ; --UNCHK
lin fingerless_A = mkWA "sormeton" ; --UNCHK
lin fingerling_N = mkWN (compoundN "kalan" (k38 "poikanen")) ; --UNCHK
lin fingermark_N = mkWN (compoundN "sormen" (k7A "jälki")) ; --UNCHK
lin fingernail_N = L.fingernail_N ;
lin finger_post_N = mkWN (k9A "tienviitta") ; --UNCHK
lin fingerprint_N = mkWN (compoundN "sormen" (k7A "jälki")) ; --UNCHK
lin fingerprinting_N = mkWN "sormenjälkien" "ottaminen" ; --UNCHK
lin fingerstall_N = mkWN (k39 "suojus") ; --UNCHK
lin fingertip_N = mkWN (compoundN "sormen" (k18 "pää")) ; --UNCHK
lin finial_N = mkWN (compoundN "risti" (k10A "kukka")) ; --UNCHK
lin finical_A = mkWA (k41 "vaatelias") ; --UNCHK
lin finicky_A = mkWA (k41 "vaatelias") ; --UNCHK
lin finis_N = mkWN (k1A "loppu") ; --UNCHK
lin finish_N = mkWN (k39 "lopetus") ; --UNCHK
lin finish_V = mkWV (k53A "lopettaa") ;
lin finish_V2 = mkWV2 (k53A "lopettaa") ;
lin finish_off_V2 = mkWV2 (k63 "saada") "valmiiksi" ; --UNCHK
lin finish_up_V = mkWV (k52A "joutua") ; --UNCHK
lin finish_up_with_V2 = prepV2 (advV OP_finish_V OP_up_Adv ) OP_with_Prep ; -- guess-p-verb
lin finish_with_V2 = prepV2 OP_finish_V OP_with_Prep ; -- guess-p-verb
lin finished_A = mkA "päättynyt" ;
lin finisher_N = mkWN (k10 "voittaja") ; --UNCHK
lin finite_A = mkWA (k38 "äärellinen") ; --UNCHK
lin finiteness_N = mkWN (k40 "rajallisuus") ; --UNCHK
lin fink_N = mkWN (k10 "visertäjä") ; --UNCHK
lin finland_PN = mkPN (mkN "Suomi" "Suomia") ;
lin finn_N = mkWN (k38 "suomalainen") ; --UNCHK
lin finnan_N = mkWN (k10 "kolja") "savustettu" ; --UNCHK
lin finnan_haddie_N = mkWN (k10 "kolja") "savustettu" ; --UNCHK
lin finnan_haddock_N = mkWN (k10 "kolja") "savustettu" ; --UNCHK
lin finnishFem_N = mkN "suomalainen" ;
lin finnishMasc_N = mkN "suomalainen" ;
lin finnish_A = mkWA (k38 "suomalainen") ;
lin fiord_N = mkWN (k1 "vuono") ; --UNCHK
lin fipple_N = mkWN (k10A "nokka") ; --UNCHK
lin fir_N = mkN "kuusi" "kuusia" ;
lin fir_cone_N = mkWN (compoundN "kuusen" (k1A "käpy")) ; --UNCHK
lin fire_1_N = mkN "tuli" "tulia" ;
lin fire_2_N = mkN "tulipalo" | mkN "palo" ;
lin fire_N = mkN "tuli" "tulia" ;
lin fire_V = mkWV (k53A "polttaa") ; --UNCHK
lin fire_V2 = mkWV2 (k53A "polttaa") ; --UNCHK
lin fire_alarm_N = mkWN (compoundN "palo" (k33A "varoitin")) ; --UNCHK
lin fire_away_V = advV OP_fire_V OP_away_Adv ; -- guess-p-verb
lin fire_back_V = advV OP_fire_V OP_back_Adv ; -- guess-p-verb
lin fire_brigade_N = mkWN (compoundN "palo" (k10A "kunta")) ; --UNCHK
lin fire_control_N = mkWN (compoundN "tulen" (k1A "johto")) ; --UNCHK
lin fire_engine_N = mkWN (compoundN "palo" (k1 "auto")) ; --UNCHK
lin fire_escape_N = mkWN "hätäpoistumistie" ; --UNCHK
lin fire_extinguisher_N = mkWN (k33A "sammutin") ; --UNCHK
lin fire_fighter_N = mkWN (compoundN "palo" (k42 "mies")) ; --UNCHK
lin fire_hose_N = mkWN (compoundN "palo" (k1 "letku")) ; --UNCHK
lin fire_off_V2 = prepV2 OP_fire_V OP_off_Prep ; -- guess-p-verb
lin fire_up_V = advV OP_fire_V OP_up_Adv ; -- guess-p-verb
lin fire_up_V2 = prepV2 OP_fire_V OP_up_Prep ; -- guess-p-verb
lin fire_walker_N = mkWN (compoundN "tuli" (k12 "kävelijä")) ; --UNCHK
lin fire_walking_N = mkWN (compoundN "tuli" (k2 "kävely")) ; --UNCHK
lin fire_watcher_N = mkWN (compoundN "palo" (k12 "vartija")) ; --UNCHK
lin fire_watching_N = mkWN (k25 "toimi") "palovartijan" ; --UNCHK
lin firearm_N = mkWN (k48 "ase") ; --UNCHK
lin fireball_N = mkWN (compoundN "tuli" (k1 "pallo")) ; --UNCHK
lin firebase_N = mkWN (compoundN "tuli" (k10 "asema")) ; --UNCHK
lin firebird_N = mkWN (compoundN "puna" (k5 "tyranni")) ; --UNCHK
lin fireboat_N = mkWN (compoundN "ruisku" (k9 "laiva")) ; --UNCHK
lin firebomb_N = mkWN (k5 "palopommi") ; --UNCHK
lin firebox_N = mkWN (compoundN "tuli" (k10 "pesä")) ; --UNCHK
lin firebrand_N = mkWN (k10 "kiihottaja") ; --UNCHK
lin firebrat_N = mkWN (compoundN "uuni" (k10A "toukka")) ; --UNCHK
lin firebreak_N = mkWN (compoundN "palo" (k9 "linja")) ; --UNCHK
lin firebrick_N = mkWN (k23 "tiili") "tulenkestävä" ; --UNCHK
lin firebug_N = mkWN (k48A "lude") ; --UNCHK
lin fireclay_N = mkWN (k7 "savi") "tulenkestävä" ; --UNCHK
lin firecracker_N = mkWN (k38 "sähikäinen") ; --UNCHK
lin firedamp_N = mkWN (compoundN "kaivos" (k1 "kaasu")) ; --UNCHK
lin firedog_N = mkWN (k48 "teline") ; --UNCHK
lin firefly_N = mkWN (compoundN "tuli" (k38 "kärpänen")) ; --UNCHK
lin fireguard_N = mkWN (compoundN "kipinä" (k39 "suojus")) ; --UNCHK
lin firelight_N = mkWN (compoundN "takka" (k23 "tuli")) ; --UNCHK
lin firelighter_N = mkWN (compoundN "sytytys" (k9 "pala")) ; --UNCHK
lin fireman_N = mkWN (compoundN "palomies" (k5A "leikki")) ; --UNCHK
lin fireplace_N = mkN "takka" ;
lin fireplug_N = mkWN (k5 "vesiposti") ; --UNCHK
lin fire_power_N = mkWN (compoundN "tuli" (k10 "voima")) ; --UNCHK
lin fireproof_A = mkWA (compoundA "tulen" (k10 "kestävä")) ; --UNCHK
lin fireside_N = mkWN (compoundN "koti" (k1A "kontu")) ; --UNCHK
lin firestone_N = mkWN (compoundN "hiekka" (k7 "kivi")) ; --UNCHK
lin firestorm_N = mkWN (k9A "kuohunta") ; --UNCHK
lin firetrap_N = mkWN (compoundN "kuoleman" (k1A "loukku")) ; --UNCHK
lin firewall_N = mkWN (compoundN "palo" (k5 "muuri")) ; --UNCHK
lin firewater_N = mkWN (compoundN "tuli" (k25 "liemi")) ; --UNCHK
lin fireweed_N = mkWN "Erechtites" "hieracifolia" ; --UNCHK
lin firewood_N = mkWN "puupolttoaine" ; --UNCHK
lin firework_N = mkWN (compoundN "ilo" (k48A "tulite")) ; --UNCHK
lin firing_line_N = mkWN (compoundN "etu" (k1A "joukko")) ; --UNCHK
lin firing_party_N = mkWN "teloituskomennuskunta" ; --UNCHK
lin firing_squad_N = mkWN "teloituskomennuskunta" ; --UNCHK
lin firkin_N = mkWN (k14A "nassakka") ; --UNCHK
lin firm_A = mkWA (k10 "luja") ; --f73
lin firm_Adv = mkWAdv (k99 "vankkumatta") ; --UNCHK
lin firm_N = mkN "yritys" ;
lin firm_V = mkV (mkV "pitää") "vakaana" ; --mkWV (k53A "kiinnittää") "lujasti" ;
lin firm_V2 = mkV2 (mkV (mkV "pitää") "vakaana") ; --mkWV2 (k53A "kiinnittää") "lujasti" ;
lin firm_up_V2 = mkWV2 (k53A "lujittaa") ; --UNCHK
lin firmament_N = mkWN (k40 "avaruus") ; --UNCHK
lin firmamental_A = mkWA "taivaan-" ; --UNCHK
lin firmness_N = mkWN (kH1 "vakaus") ; --UNCHK
lin firmware_N = mkWN (k10 "ohjelma") "sulautettu" ; --UNCHK
lin first_A = variants {} ; --
lin first_Adv = mkAdv "ensimmäisenä" | mkAdv "ensimmäiseksi" | mkAdv "ensiksi" ;
lin first_class_A = mkA (mkN "ensi" (mkN "luokkainen")) ;
lin first_class_Adv = mkWAdv (compoundAdv "luo" (k9 "kassa")) "ensimmäisessä" ; --UNCHK
lin first_rate_A = mkA "ensiluokkainen" ;
lin firstborn_A = mkWA (k36 "vanhin") ; --UNCHK
lin firstborn_N = mkWN (k36 "vanhin") ; --UNCHK
lin first_hand_A = mkWA "ensi" "käden" ; --UNCHK
lin firstly_Adv = variants {} ; --
lin firth_N = mkWN (k1 "vuono") ; --UNCHK
lin fisc_N = mkWN (compoundN "valtiovarain" (k3 "ministeriö")) ; --UNCHK
lin fiscal_A = mkA "verotuksellinen" ;
lin fish_N = L.fish_N ;
lin fish_V = mkWV (k53 "kalastaa") ; --UNCHK
lin fish_V2 = mkWV2 (k53 "kalastaa") ; --UNCHK
lin fish_knife_N = mkWN (compoundN "kala" (k30 "veitsi")) ; --UNCHK
lin fish_slice_N = mkWN (k9 "lasta") ; --UNCHK
lin fishbone_N = mkWN (k1A "ruoto") ; --UNCHK
lin fishbowl_N = mkWN (compoundN "kala" (k9 "malja")) ; --UNCHK
lin fisher_N = mkWN (compoundN "kalastaja" (k10A "näätä")) ; --UNCHK
lin fisherman_N = mkWN (k10 "kalastaja") ; --UNCHK
lin fishery_N = mkWN (compoundN "kalastus" (k48 "alue")) ; --UNCHK
lin fisheye_A = mkWA "laajakulma-" ; --UNCHK
lin fish_hook_N = mkWN (compoundN "ongen" (k1A "koukku")) ; --UNCHK
lin fishing_N = mkWN (k39 "kalastus") ; --UNCHK
lin fishing_line_N = mkWN (k9 "siima") ; --UNCHK
lin fishing_rod_N = mkWN (k9A "vapa") ; --UNCHK
lin fishmonger_N = mkWN (compoundN "kala" (k41 "kauppias")) ; --UNCHK
lin fishnet_N = mkWN (compoundN "kala" (k1A "verkko")) ; --UNCHK
lin fishpaste_N = mkWN (compoundN "kala" (k9 "tahna")) ; --UNCHK
lin fishplate_N = mkWN (compoundN "side" (k1 "kisko")) ; --UNCHK
lin fishpond_N = mkWN (compoundN "kala" (k4A "lammikko")) ; --UNCHK
lin fishwife_N = mkWN (compoundN "kala" (k41 "kauppias")) ; --UNCHK
lin fishy_A = mkWA (compoundA "kala" (k38 "mainen")) ; --UNCHK
lin fissile_A = mkWA "halkeava" ; --UNCHK
lin fission_N = mkWN (k3 "fissio") ; --UNCHK
lin fissionable_A = mkWA (compoundA "fissio" (k38 "kelpoinen")) ; --UNCHK
lin fissiparity_N = mkWN "jakautuvuus" ; --UNCHK
lin fissiparous_A = mkWA (k38 "separatistinen") ; --UNCHK
lin fissure_N = mkWN (k3 "halkio") ; --UNCHK
lin fist_N = mkWN (k5A "nyrkki") ; --UNCHK
lin fistfight_N = mkWN (compoundN "nyrkki" (k2 "tappelu")) "ankara" ; --UNCHK
lin fistmele_N = mkWN (k9 "vaaksa") ; --UNCHK
lin fistula_N = mkWN (k2 "ontelo") ; --UNCHK
lin fistular_A = mkWA (k38 "kaltainen") "fistelin" ; --UNCHK
lin fistulous_A = mkWA (compoundA "putki" (k38 "mainen")) ; --UNCHK
lin fit_A = mkA "sopiva" ; ---ARB ; hyväkuntoinen
lin fit_N = mkWN (k10 "puuska") ; --UNCHK
lin fit_V = mkV "sopia" | mkV "mahtua" ;
lin fit_V2 = mkV2 "sovittaa" partitive ;
lin fit_in_V = mkWV (k61A "sopia") ; --UNCHK
lin fit_in_V2 = mkWV2 (k61A "sopia") ; --UNCHK
lin fit_in_with_V2 = prepV2 (advV OP_fit_V OP_in_Adv ) OP_with_Prep ; -- guess-p-verb
lin fit_into_V2 = prepV2 OP_fit_V OP_into_Prep ; -- guess-p-verb
lin fit_out_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin fit_out_with_V2 = prepV2 (advV OP_fit_V OP_out_Adv ) OP_with_Prep ; -- guess-p-verb
lin fit_up_V2 = prepV2 OP_fit_V OP_up_Prep ; -- guess-p-verb
lin fitful_A = mkWA (k38 "katkonainen") ; --UNCHK
lin fitfulness_N = mkWN (k40 "katkonaisuus") ; --UNCHK
lin fitment_N = mkWN (k39 "kalustus") ; --UNCHK
lin fitness_N = mkWN (k40 "soveltuvuus") ;
lin fitter_A = mkWA (compoundA "parempikun" (k38 "toinen")) ; --UNCHK
lin fitter_N = mkWN (k10 "sovittaja") ; --UNCHK
lin fitting_A = mkWA (k10 "sopiva") ; --UNCHK
lin fitting_N = mkWN (k39 "sovitus") ; --UNCHK
lin fivefold_A = mkWA (compoundA "viis" (k38 "inkertainen")) ; --UNCHK
lin fivepence_N = mkWN (compoundN "viis" (k38 "isenttinen")) ; --UNCHK
lin fiver_N = mkWN (k6 "seteli") "viiden" "dollarin" ; --UNCHK
lin fives_N = mkWN (compoundN "seinäpallo" (k5 "peli")) ; --UNCHK
lin fix_N = mkWN (k9A "paikka") ; --UNCHK
lin fix_V = mkV "kiinnittää" ;
lin fix_V2 = mkV2 "kiinnittää" ;
lin fix_up_V2 = mkWV2 (k53A "hoitaa") ; --UNCHK
lin fixate_V2 = mkWV2 (k53A "kiinnittää") "katseensa" ; --UNCHK
lin fixation_N = mkWN (k39 "fikseeraus") ; --UNCHK
lin fixative_N = mkWN (k5 "fiksatiivi") ; --UNCHK
lin fixed_A = mkA "kiinteä" ;
lin fixedness_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin fixer_N = mkWN (k5 "heroiini") "synteettinen" ; --UNCHK
lin fixture_N = mkWN (k1A "huolto") ; --UNCHK
lin fizgig_N = mkWN (k38 "sähikäinen") ; --UNCHK
lin fizz_N = mkWN (compoundN "pore" (k10 "juoma")) ; --UNCHK
lin fizz_V = mkWV (k61 "kuplia") ; --UNCHK
lin fizzle_V = mkWV (k52A "hiljentyä") ; --UNCHK
lin fizzle_out_V = mkWV (k52A "hiljentyä") ; --UNCHK
lin fizzy_A = mkWA "poreileva" ; --UNCHK
lin fjord_N = mkWN (k1 "vuono") ; --UNCHK
lin flab_N = mkWN (k9 "ihra") "löyhä" ; --UNCHK
lin flabbergast_V2 = mkWV2 (k53A "tyrmistyttää") ; --UNCHK
lin flabbiness_N = mkWN (k40 "vetelyys") ; --UNCHK
lin flabby_A = mkWA (k1A "veltto") ; --UNCHK
lin flaccid_A = mkWA (k1A "veltto") ; --UNCHK
lin flaccidity_N = mkWN (k40 "vetelyys") ; --UNCHK
lin flag_N = mkN "lippu" ;
lin flag_V = mkWV (k52A "helpottua") ; --UNCHK
lin flag_V2 = mkWV2 (k52A "helpottua") ; --UNCHK
lin flag_captain_N = mkWN (k4A "päällikkö") "lippulaivan" ; --UNCHK
lin flag_day_N = mkWN (k10 "päivä") "kesäkuun" "14." ; --UNCHK
lin flag_down_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin flagellant_N = mkWN (compoundN "flagel" (k5A "lantti")) ; --UNCHK
lin flagellate_A = mkWA (compoundA "piiska" (k38 "mainen")) ; --UNCHK
lin flagellate_N = mkWN (compoundN "siima" (k3 "eliö")) ; --UNCHK
lin flagellate_V2 = mkWV2 (k73 "piiskata") ; --UNCHK
lin flagellation_N = mkWN (k39 "parkitus") ; --UNCHK
lin flagellum_N = mkWN (k9 "siima") ; --UNCHK
lin flageolet_N = mkWN (compoundN "flageo" (k5A "letti")) ; --UNCHK
lin flagfish_N = mkWN (compoundN "floridanhamma" (k5A "skarppi")) ; --UNCHK
lin flagging_N = mkWN (compoundN "laatta" (k39 "kiveys")) ; --UNCHK
lin flagitious_A = mkWA (k15 "hirveä") ; --UNCHK
lin flagon_N = mkWN (compoundN "viini" (k1 "kannu")) ; --UNCHK
lin flagpole_N = mkWN (compoundN "lippu" (k1A "salko")) ; --UNCHK
lin flagrant_A = mkWA (k10 "vakava") ; --UNCHK
lin flagship_N = mkWN (compoundN "lippu" (k9 "laiva")) ; --UNCHK
lin flagstaff_N = mkWN (compoundN "lippu" (k1A "salko")) ; --UNCHK
lin flagstone_N = mkWN (k48 "liuske") ; --UNCHK
lin flail_N = mkWN (k9 "varsta") ; --UNCHK
lin flail_V2 = mkWV2 (k54 "pieksää") ; --UNCHK
lin flair_N = mkWN (k5 "tyyli") ; --UNCHK
lin flak_N = mkWN (k5A "konetykki") ; --UNCHK
lin flake_N = mkWN (k1A "tilkku") ; --UNCHK
lin flake_V = mkWV (k67 "hilseillä") ; --UNCHK
lin flake_out_V = mkWV (k61A "pilkkiä") ; --UNCHK
lin flakiness_N = mkWN "hiutaleisuus" ; --UNCHK
lin flaky_A = mkWA "hiutale-" ; --UNCHK
lin flambeau_N = mkWN (k1A "soihtu") ; --UNCHK
lin flamboyance_N = mkWN (k40 "koristeellisuus") ; --UNCHK
lin flamboyant_A = mkA (lin AK {s = d38 "mahtipontinen"}) ;
lin flame_N = mkWN (k5A "liekki") ; --UNCHK
lin flame_V = mkWV (k62 "kritisoida") ; --UNCHK
lin flame_up_V = mkWV (k74 "roihuta") ; --UNCHK
lin flamen_N = mkWN "flamen" ; --UNCHK
lin flamenco_N = mkWN (k1 "flamenco") ; --UNCHK
lin flameproof_A = mkWA (compoundA "tulen" (k10 "kestävä")) ; --UNCHK
lin flamethrower_N = mkWN (compoundN "liekin" (k33A "heitin")) ; --UNCHK
lin flamingo_N = mkWN (k1 "flamingo") ; --UNCHK
lin flammability_N = mkWN (k40 "syttyvyys") ; --UNCHK
lin flammable_A = mkWA (k10 "palava") ; --UNCHK
lin flan_N = mkWN (k1A "torttu") ; --UNCHK
lin flange_N = mkWN (k41A "rengas") ; --UNCHK
lin flank_N = mkWN (k7A "kylki") ; --UNCHK
lin flank_V = mkWV (k53 "reunustaa") ; --UNCHK
lin flank_V2 = mkWV2 (k53 "reunustaa") ; --UNCHK
lin flanker_N = mkWN (k10 "sivustasuoja") ; --UNCHK
lin flannel_N = mkWN (k6 "flanelli") ; --UNCHK
lin flannelbush_N = mkWN "Fremontodendron" ; --UNCHK
lin flannelette_N = mkWN (compoundN "pumpuli" (k6 "flanelli")) ; --UNCHK
lin flap_N = mkWN (kH1 "läppä") ;
lin flap_V = mkWV (k54A "ääntää") "yksitäryisenä" ; --UNCHK
lin flap_V2 = mkWV2 (k54A "ääntää") "yksitäryisenä" ; --UNCHK
lin flapjack_N = mkWN (k1A "lettu") ; --UNCHK
lin flare_V = mkWV (k75 "loimuta") | mkWV (k52 "leimahtaa") ;
lin flare_V2 = mkWV2 (k75 "loimuta") | mkWV2 (k52 "leimahtaa") ; ----SUBCAT
lin flare_out_V = mkWV (k72 "levetä") ;
lin flare_path_N = mkWN (compoundN "kiito" (k9A "rata")) "valaistu" ; --UNCHK
lin flare_up_V = mkWV (k53A "räjähtää") ; --UNCHK
lin flash_N = mkWN (k12 "salama") ; --UNCHK
lin flash_V = mkWV (k53A "välähtää") ;
lin flashback_N = mkWN (k10 "takauma") ; --UNCHK
lin flashboard_N = mkWN (compoundN "säätö" (k1A "lankku")) ; --UNCHK
lin flashbulb_N = mkWN (k12 "salama") ; --UNCHK
lin flasher_N = mkWN (k1A "vilkku") ; --UNCHK
lin flashgun_N = mkWN (k12 "salama") ; --UNCHK
lin flashiness_N = mkWN (k40 "mauttomuus") ; --UNCHK
lin flashing_N = mkWN "suojapellitys" ; --UNCHK
lin flashlight_N = mkWN (compoundN "tasku" (k1A "lamppu")) ; --UNCHK
lin flashover_N = mkWN (compoundN "yli" (k5A "lyönti")) ; --UNCHK
lin flashpoint_N = mkWN (compoundN "leimahdus" (k48 "piste")) ; --UNCHK
lin flashy_A = mkWA (k15 "räikeä") ;
lin flask_N = mkWN (k1 "pullo") "pitkäkaulainen" ; --UNCHK
lin flat_A = mkA "litteä" ;
lin flat_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin flat_N = mkWN (k1A "asunto") ; --UNCHK
lin flatbed_N = mkWN (compoundN "kuljetus" (k13 "alusta")) ; --UNCHK
lin flatbottom_A = mkWA (compoundA "tasapohja" (k38 "inen")) ; --UNCHK
lin flatbread_N = mkWN (k9 "rieska") ; --UNCHK
lin flatbrod_N = mkWN (k1A "korppu") ; --UNCHK
lin flat_car_N = mkWN "avotavaravaunu" ; --UNCHK
lin flatfish_N = mkWN (k13 "kampela") ; --UNCHK
lin flatfoot_N = mkWN (compoundN "latuska" (k9A "jalka")) ; --UNCHK
lin flathead_N = mkWN (k9 "kala") "litteäpäinen" ; --UNCHK
lin flat_iron_N = mkWN (compoundN "silitys" (k9A "rauta")) "liedellä" "kuumennettava" ; --UNCHK
lin flatlet_N = mkWN (compoundN "pien" (k2 "huoneisto")) ; --UNCHK
lin flatmate_N = mkWN (compoundN "kämppä" (k6 "kaveri")) ; --UNCHK
lin flatness_N = mkWN (k40 "latteus") ; --UNCHK
lin flatten_V = mkWV (k54A "alentaa") ;
lin flatten_V2 = mkWV2 (k54A "alentaa") ; --UNCHK
lin flatter_V2 = mkWV2 (k67 "nuoleskella") ; --UNCHK
lin flatterer_N = mkWN (k12 "mielistelijä") ; --UNCHK
lin flattering_A = mkWA "imarteleva" ; --UNCHK
lin flattery_N = mkWN (k2 "mielistely") ; --UNCHK
lin flattop_N = mkWN (compoundN "tuki" (k39 "alus")) ; --UNCHK
lin flatulence_N = mkWN (k40 "mahtipontisuus") ; --UNCHK
lin flatulent_A = mkWA "kaasu-" ; --UNCHK
lin flatwork_N = mkWN (k5A "mankelipyykki") ; --UNCHK
lin flatworm_N = mkWN (compoundN "laaka" (k1A "mato")) ; --UNCHK
lin flaunt_N = mkWN (k2 "pöyhkeily") ; --UNCHK
lin flaunt_V = mkWV (k67 "ylpeillä") ; --UNCHK
lin flaunt_V2 = mkWV2 (k67 "ylpeillä") ; --UNCHK
lin flaunty_A = mkWA (compoundA "pöyhkei" (k10 "levä")) ; --UNCHK
lin flautist_N = mkWN (k5 "huilisti") ; --UNCHK
lin flavin_N = mkWN (k5 "flaviini") ; --UNCHK
lin flavivirus_N = mkWN (compoundN "flavi" (k39 "virus")) ; --UNCHK
lin flavone_N = mkWN "flavoni" ; --UNCHK
lin flavonoid_N = mkWN "flavonoidi" ; --UNCHK
lin flavorful_A = mkWA (k41A "maukas") ; --UNCHK
lin flavorlessness_N = mkWN (k40 "mauttomuus") ; --UNCHK
lin flavorsomeness_N = mkWN (k40 "maukkuus") ; --UNCHK
lin flavour_N = mkN "maku" ; --WN (k1A "maku") "vahva" ;
lin flavour_V2 = mkWV2 (k53 "höystää") ; --UNCHK
lin flavourer_N = mkWN (k48 "mauste") ; --UNCHK
lin flavouring_N = mkWN (k48 "mauste") ; --UNCHK
lin flavourless_A = mkWA (k1 "valju") ; --UNCHK
lin flaw_N = mkWN (k48 "virhe") ; --UNCHK
lin flaw_V2 = mkV2 "turmella" ; --mkWV2 (k73 "tahrata") ;
lin flawless_A = mkWA (k38 "täydellinen") ; --UNCHK
lin flax_N = mkWN (k10 "pellava") ; --UNCHK
lin flaxen_A = mkWA (compoundA "vaalean" (k15 "ruskea")) ; --UNCHK
lin flay_V2 = mkWV2 (k58A "nylkeä") ; --UNCHK
lin flea_N = mkWN (k1A "kirppu") ; --UNCHK
lin flea_bite_N = mkWN (k1A "juttu") "pikku" ; --UNCHK
lin fleabag_N = mkWN (k6 "hotelli") "halpa" ; --UNCHK
lin fleabane_N = mkWN (compoundN "kanadankoiran" (k10 "silmä")) ; --UNCHK
lin fleapit_N = mkWN (compoundN "elokuva" (k6 "teatteri")) "rähjäinen" ; --UNCHK
lin fleawort_N = mkWN (k2 "ratamo") ; --UNCHK
lin flecainide_N = mkWN "Tambocor" ; --UNCHK
lin fleck_N = mkWN (k1A "pilkku") ; --UNCHK
lin fleck_V2 = mkWV2 (k61 "tahria") ; --UNCHK
lin fledged_A = mkWA (compoundA "lentoky" (k38 "kyinen")) ; --UNCHK
lin fledgeling_N = mkWN (compoundN "lento" (k38 "poikanen")) ; --UNCHK
lin fledgling_A = mkWA (k15 "vihreä") ; --UNCHK
lin fledgling_N = mkN "vasta-" (mkN "alkaja") ; --mkWN (compoundN "lento" (k38 "poikanen")) ;
lin flee_V = mkWV (k73A "karata") ; --UNCHK
lin flee_V2 = mkWV2 (k73A "karata") ; --UNCHK
lin fleece_N = mkWN (kH1 "turkki") ; --UNCHK
lin fleeceable_A = mkWA (k34A "kokematon") ; --UNCHK
lin fleecy_A = mkWA "napped" ; --UNCHK
lin fleer_N = mkWN (kH1 "pilkka") ; --UNCHK
lin fleet_A = mkWA (k10 "vikkelä") ; --UNCHK
lin fleet_N = mkWN (k2 "laivasto") ;
lin fleet_PN = foreignPN "Fleet" ;
lin fleeting_A = mkWA (k10 "ohikiitävä") ;
lin fleetness_N = mkWN (k40 "nopeus") ; --UNCHK
lin fleetwood_PN = foreignPN "Fleetwood" ;
lin flemish_A = mkWA (k38 "flaamilainen") ; --UNCHK
lin flemish_N = mkN "flaamilainen" ;
lin flesh_N = mkWN (k41 "ruumis") ; --UNCHK
lin flesh_out_V2 = mkWV2 (k52A "tukevoitua") ; --UNCHK
lin flesh_wound_N = mkWN (k9 "lihashaava") ; --UNCHK
lin fleshiness_N = mkWN (k40 "pyylevyys") ; --UNCHK
lin fleshly_A = mkWA (k38 "ruumiillinen") ; --UNCHK
lin fleshy_A = mkWA (k38 "lihainen") ; --UNCHK
lin flex_N = mkWN (k1 "jousto") ; --UNCHK
lin flex_V2 = mkWV2 (k54A "vääntää") "mutkalle" ; --UNCHK
lin flexibility_N = mkWN (k40 "joustavuus") ; --UNCHK
lin flexible_A = mkWA (k15 "notkea") ; --UNCHK
lin flexion_N = mkWN (k39 "koukistus") ; --UNCHK
lin flexuous_A = mkWA "mutkitteleva" ; --UNCHK
lin flexure_N = mkWN (k39 "koukistus") ; --UNCHK
lin flibbertigibbet_N = mkWN (k4A "hupakko") ; --UNCHK
lin flick_N = mkWN (k5 "filmi") ; --UNCHK
lin flick_V2 = mkWV2 (k53 "karistaa") ; --UNCHK
lin flick_knife_N = mkWN (k5A "stiletti") ; --UNCHK
lin flicker_N = mkWN (k39 "lepatus") ; --UNCHK
lin flicker_V = mkWV (k66 "väristä") ; --UNCHK
lin flickertail_N = mkWN (compoundN "maa" (k10 "orava")) "Richardsonin" ; --UNCHK
lin flier_N = mkWN (k38 "lehtinen") ;
lin flies_N = mkWN (k38 "ylinen") "näyttämön" ; --UNCHK
lin flight_N = mkN "lento" ;
lin flight_V2 = mkWV2 (k53A "sulittaa") ; --UNCHK
lin flightiness_N = mkWN (k2 "oikuttelu") ; --UNCHK
lin flightless_A = mkWA (compoundA "lento" (k34A "kyvytön")) ; --UNCHK
lin flighty_A = mkWA (k34A "levoton") ; --UNCHK
lin flimsiness_N = mkWN (k40 "hataruus") ; --UNCHK
lin flimsy_A = mkWA (compoundA "epä" (k10 "uskottava")) ; --UNCHK
lin flinch_V = mkWV (k53A "säpsähtää") ; --UNCHK
lin fling_N = mkWN (compoundN "hei" (k38 "ttäminen")) ; --UNCHK
lin fling_V = mkWV (k53A "heittää") ; --UNCHK
lin fling_V2 = mkWV2 (k53A "heittää") ; --UNCHK
lin flint_PN = foreignPN "Flint" ;
lin flintlock_N = mkWN (compoundN "pii" (k1A "lukko")) ; --UNCHK
lin flintstone_N = mkWN (compoundN "pii" (k7 "kivi")) ; --UNCHK
lin flinty_A = mkWA "piikivi-" ; --UNCHK
lin flip_A = mkWA (k10 "lipevä") ; --UNCHK
lin flip_N = mkWN (k1A "heitto") ; --UNCHK
lin flip_V = mkWV (k54A "kääntää") "kelkkansa" ; --UNCHK
lin flip_V2 = mkWV2 (k54A "kääntää") "kelkkansa" ; --UNCHK
lin flip_out_V = mkWV (k53A "pimahtaa") ; --UNCHK
lin flippancy_N = mkWN (compoundN "kevytmiel" (k40 "isyys")) ; --UNCHK
lin flippant_A = mkWA (k41A "nenäkäs") ; --UNCHK
lin flipper_N = mkWN (k12 "räpylä") ; --UNCHK
lin flirt_N = mkWN (k2 "flirttailu") ; --UNCHK
lin flirt_V = mkWV (k73A "flirtata") ; --UNCHK
lin flirtation_N = mkWN (k2 "flirttailu") ; --UNCHK
lin flirtatious_A = mkWA "flirttaileva" ; --UNCHK
lin flit_N = mkWN (k1A "muutto") ; --UNCHK
lin flit_V = mkWV (k54A "lentää") ; --UNCHK
lin flitch_N = mkWN (compoundN "sian" (k7A "kylki")) ; --UNCHK
lin float_N = mkWN (compoundN "uima" (k1A "rakko")) ; --UNCHK
lin float_V = L.float_V ;
lin floatation_N = mkWN (compoundN "liikkeelle" (k1 "lasku")) ; --UNCHK
lin floater_N = mkWN (compoundN "yleis" (k39 "vakuutus")) ; --UNCHK
lin floating_N = mkWN (k5A "uinti") ; --UNCHK
lin floatplane_N = mkWN (compoundN "vesi" (k1 "taso")) ; --UNCHK
lin floccose_A = mkWA (compoundA "villa" (k38 "karvainen")) ; --UNCHK
lin flocculation_N = mkWN (compoundN "saos" (k38 "tuminen")) "höytäleiksi" ; --UNCHK
lin floccule_N = mkWN (k48 "hiutale") ; --UNCHK
lin flocculent_A = mkWA (k10 "villava") ; --UNCHK
lin flock_N = mkWN (k7 "parvi") ; --UNCHK
lin flock_V = mkWV (k52A "kerääntyä") ;
lin flock_V2V = mkWV2V (k52A "kerääntyä") ; --UNCHK
lin floe_N = mkWN (compoundN "ajo" (k18 "jää")) ; --UNCHK
lin flog_V2 = mkWV2 (k56A "antaa") "selkään" ; --UNCHK
lin flogger_N = mkWN "ruoskija" ; --UNCHK
lin flogging_N = mkWN (k39 "parkitus") ; --UNCHK
lin flood_N = mkWN (k10 "tulva") ;
lin flood_V = mkWV (k53A "peittää") ; --UNCHK
lin flood_V2 = mkWV2 (k53A "täyttää") ;
lin flood_tide_N = mkWN (kH1 "vuoksi") ; --UNCHK
lin floodgate_N = mkWN (k1A "sulku") ; --UNCHK
lin floodhead_N = mkWN (compoundN "hyöky" (k1A "aalto")) ; --UNCHK
lin floodlight_V2 = mkWV2 (k66 "valaista") "valonheittimin" ; --UNCHK
lin floodlit_A = mkWA "valonheittimin" "valaistu" ; --UNCHK
lin floodplain_N = mkWN (compoundN "tulva" (k48A "tasanne")) ; --UNCHK
lin floor_N = L.floor_N ;
lin floor_V2 = mkWV2 (k73 "tyrmätä") ; --UNCHK
lin floorboard_N = mkWN (compoundN "lattia" (k9A "lauta")) ; --UNCHK
lin flooring_N = mkWN (k12 "lattia") ; --UNCHK
lin floor_walker_N = mkWN (compoundN "myymälä" (k10A "emäntä")) ; --UNCHK
lin floozie_N = mkWN (k1A "prostituoitu") ; --UNCHK
lin floozy_N = mkWN (k1A "prostituoitu") ; --UNCHK
lin flop_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin flop_N = mkWN (k39 "mätkähdys") ; --UNCHK
lin flop_V = mkWV (k53A "mätkähtää") ; --UNCHK
lin flop_V2 = mkWV2 (k53A "mätkähtää") ; --UNCHK
lin flophouse_N = mkWN "yömaja" ; --UNCHK
lin floppy_A = mkA "taipuisa" ;
lin flora_PN = foreignPN "Flora" ;
lin floral_A = mkWA "kukka-" ; --UNCHK
lin florence_1_PN = foreignPN "Firenze" ;
lin florence_2_PN = foreignPN "Florence" ;
lin floret_N = mkWN (k10A "kukka") ; --UNCHK
lin floricultural_A = mkWA "kukkaviljelyyn" "liittyvä" ; --UNCHK
lin floriculture_N = mkWN (compoundN "kukka" (k2 "viljely")) ; --UNCHK
lin florid_A = mkWA (k14A "helakka") ; --UNCHK
lin florida_PN = foreignPN "Florida" ;
lin florilegium_N = mkWN (k12 "antologia") ; --UNCHK
lin florin_N = mkWN (k6 "floriini") "Hollannin" ; --UNCHK
lin florist_N = mkWN (compoundN "kukka" (k9A "kauppa")) ; --UNCHK
lin floss_N = mkWN (compoundN "hammas" (k9A "lanka")) ; --UNCHK
lin flotation_N = mkWN (compoundN "liikkeelle" (k1 "lasku")) ; --UNCHK
lin flotilla_N = mkWN (k48 "laivue") ; --UNCHK
lin flotsam_N = mkWN (compoundN "hylky" (k12 "tavara")) "ajelehtiva" ; --UNCHK
lin flounce_N = mkWN (k5 "marssi") ; --UNCHK
lin flounce_V = mkWV (k61 "marssia") ; --UNCHK
lin flounce_V2 = mkWV2 (k61 "marssia") ; --UNCHK
lin flounder_N = mkWN (k13 "kampela") ; --UNCHK
lin flounder_V = mkWV (k62 "räpiköidä") ; --UNCHK
lin flour_N = mkWN (k1 "jauho") ; --UNCHK
lin flour_V2 = mkWV2 (k56 "jauhaa") ; --UNCHK
lin flourish_N = mkWN (k6 "fanfaari") ; --UNCHK
lin flourish_V = mkWV (k53 "kukoistaa") ; --UNCHK
lin floury_A = mkWA (k38 "jauhoinen") ; --UNCHK
lin flout_V2 = mkWV2 (k61 "halveksia") ; --UNCHK
lin flow_N = mkWN (k39 "virtaus") ; --f72
lin flow_V = L.flow_V ;
lin flowage_N = mkWN "tulviminen" ; --UNCHK
lin flower_N = L.flower_N ;
lin flower_V = mkWV (k67 "olla") "kukassa" ; --UNCHK
lin flower_girl_N = mkWN (compoundN "morsius" (k1A "tyttö")) ; --UNCHK
lin flowerbed_N = mkWN (compoundN "kukka" (k5A "penkki")) ; --UNCHK
lin flowered_A = mkWA (k38 "kukallinen") ; --UNCHK
lin flowerless_A = mkWA "itiö-" ; --UNCHK
lin flowerpot_N = mkWN (k1A "ruukku") ; --UNCHK
lin flowery_A = mkWA (k38 "kukkainen") ; --UNCHK
lin floxuridine_N = mkWN "floksuridiini" ; --UNCHK
lin flu_N = mkWN (k10 "flunssa") ; --UNCHK
lin fluctuate_V = mkWV (k67A "heitellä") ;
lin fluctuation_N = mkWN (k40 "epävakaisuus") ; --UNCHK
lin flue_N = mkWN (k5 "hormi") ; --UNCHK
lin fluency_N = mkWN (k40 "sujuvuus") ; --UNCHK
lin fluent_A = mkWA (k10 "puhuva") "miellyttävästi" ; --UNCHK
lin fluff_N = mkWN (k48 "virhe") ; --UNCHK
lin fluff_V2 = mkWV2 (k73 "tupeerata") ; --UNCHK
lin fluff_up_V2 = mkWV2 (k61 "pöyhiä") ; --UNCHK
lin fluffy_A = mkWA (k15 "pöyheä") ; --UNCHK
lin flugelhorn_N = mkWN (compoundN "flyygeli" (k7 "torvi")) ; --UNCHK
lin fluid_A = mkA "epävakaa" ; ---ARB ; nestemäinen, juokseva
lin fluid_N = mkWN (k39 "petos") ; --UNCHK
lin fluidity_N = mkWN (k40 "sujuvuus") ; --UNCHK
lin fluidounce_N = mkWN (compoundN "neste" (k5 "unssi")) ; --UNCHK
lin fluidram_N = mkWN (k9 "drakma") ; --UNCHK
lin fluke_N = mkWN (compoundN "imu" (k1A "mato")) ; --UNCHK
lin flume_N = mkWN (compoundN "vesi" (k1 "kouru")) ; --UNCHK
lin flummery_N = mkWN (k2 "imartelu") ; --UNCHK
lin flummox_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin flunitrazepan_N = mkWN "Rohypnol" ; --UNCHK
lin flunk_V = mkWV (k53A "reputtaa") ; --UNCHK
lin flunk_V2 = mkWV2 (k53A "reputtaa") ; --UNCHK
lin flunkey_N = mkWN (k12 "myötäilijä") ; --UNCHK
lin flunky_N = mkWN (k12 "myötäilijä") ; --UNCHK
lin fluorapatite_N = mkWN (compoundN "fluori" (k5A "apatiitti")) ; --UNCHK
lin fluorescein_N = mkWN (compoundN "väri" (k48 "aine")) "fluoresoiva" ; --UNCHK
lin fluorescence_N = mkWN (k5 "fluoresenssi") ; --UNCHK
lin fluorescent_A = mkWA (compoundA "fluores" (k10 "oiva")) ; --UNCHK
lin fluorescent_N = mkWN (k33 "valaisin") "fluoresoiva" ; --UNCHK
lin fluoridate_V2 = mkWV2 (k73 "fluorata") ; --UNCHK
lin fluoridation_N = mkWN (k39 "fluoraus") ; --UNCHK
lin fluoride_N = mkWN "fluoridi" ; --UNCHK
lin fluoridization_N = mkWN (k39 "fluoraus") ; --UNCHK
lin fluoridize_V2 = mkWV2 (k73 "fluorata") ; --UNCHK
lin fluorine_N = mkWN (k5 "fluori") ; --UNCHK
lin fluorite_N = mkWN (compoundN "fluo" (k5A "riitti")) ; --UNCHK
lin fluoroboride_N = mkWN "fluoriboridi" ; --UNCHK
lin fluorocarbon_N = mkWN (compoundN "hiili" (k1A "vety")) "fluorattu" ; --UNCHK
lin fluorochrome_N = mkWN (compoundN "fluoro" (k5 "kromi")) ; --UNCHK
lin fluoroform_N = mkWN (compoundN "trifluori" (k5 "metaani")) ; --UNCHK
lin fluoroscope_N = mkWN (compoundN "röntgenläpivalaisu" (k48A "laite")) ; --UNCHK
lin fluoroscopy_N = mkWN "röntgenläpivalaisu" ; --UNCHK
lin fluorosis_N = mkWN "fluoroosi" ; --UNCHK
lin fluorouracil_N = mkWN (k5 "fluorourasiili") ; --UNCHK
lin fluosilicate_N = mkWN (compoundN "fluori" (k5A "silikaatti")) ; --UNCHK
lin fluoxetine_N = mkWN "Sarafem" ; --UNCHK
lin fluphenazine_N = mkWN "flufenatsiini" ; --UNCHK
lin flurazepam_N = mkWN (compoundN "Dalm" (k48 "ane")) ; --UNCHK
lin flurbiprofen_N = mkWN "Ansaid" ; --UNCHK
lin flurry_N = mkN "puuska" ; --mkWN (k39 "touhotus") ;
lin flurry_V2 = mkWV2 (k56A "saattaa") "hämilleen" ; --UNCHK
lin flush_A = mkA "samantasoinen" ; ---- ?
lin flush_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin flush_N = mkWN (k39 "punastus") ; --UNCHK
lin flush_V = mkWV (k52 "punastua") ; --UNCHK
lin flush_V2 = mkWV2 (k52 "punastua") ; --UNCHK
lin fluster_N = mkWN (k39 "hämmennys") ; --UNCHK
lin fluster_V2 = mkWV2 (k53A "hermostuttaa") ; --UNCHK
lin flute_N = mkWN (k1 "huilu") ; --UNCHK
lin flute_V = mkWV (k54A "uurtaa") ; --UNCHK
lin flute_V2 = mkWV2 (k54A "uurtaa") ; --UNCHK
lin fluting_N = mkWN (k48A "uurre") ; --UNCHK
lin flutist_N = mkWN (k5 "huilisti") ; --UNCHK
lin flutter_N = mkWN (k39 "lepatus") ; --UNCHK
lin flutter_V = mkWV (k73A "vinkata") ; --UNCHK
lin flutter_V2 = mkWV2 (k73A "vinkata") ; --UNCHK
lin fluvastatin_N = mkWN (compoundN "fluv" (k5 "astatiini")) ; --UNCHK
lin fluvial_A = mkWA "joki-" ; --UNCHK
lin flux_N = mkWN (k39 "muutos") ; --UNCHK
lin fluxmeter_N = mkWN (compoundN "vuo" (k6 "mittari")) ; --UNCHK
lin fly_A = mkWA (k10 "terävä") ; --UNCHK
lin fly_N = mkWN (k1 "pallo") "korkea" ; --UNCHK
lin fly_V = L.fly_V ;
lin fly_V2 = mkV2 "lennättää" partitive ;
lin fly_about_V = advV OP_fly_V OP_about_Adv ; -- guess-p-verb
lin fly_around_V = advV OP_fly_V OP_around_Adv ; -- guess-p-verb
lin fly_at_V2 = prepV2 OP_fly_V OP_at_Prep ; -- guess-p-verb
lin fly_by_V = mkWV (k54A "lentää") "ohi" ; --UNCHK
lin fly_fish_V = variants {} ; -- guess-p-verb
lin fly_into_V2 = prepV2 OP_fly_V OP_into_Prep ; -- guess-p-verb
lin fly_out_V = advV OP_fly_V OP_out_Adv ; -- guess-p-verb
lin flyaway_A = mkWA "liehuva" ; --UNCHK
lin flyblown_A = mkWA (compoundA "pila" (k47 "antunut")) ; --UNCHK
lin flycatcher_N = mkWN (k5 "tyranni") ; --UNCHK
lin flyer_N = mkWN (k38 "lehtinen") ; --UNCHK
lin flying_bomb_N = mkWN (kH1 "pommi") "lentävä" ; --UNCHK
lin flying_fish_N = mkWN (compoundN "lento" (k9 "kala")) ; --UNCHK
lin flying_fox_N = mkWN (k10 "koira") "lentävä" ; --UNCHK
lin flying_squad_N = mkWN (compoundN "isku" (k10 "ryhmä")) ; --UNCHK
lin flyleaf_N = mkWN (compoundN "liite" (k7A "lehti")) ; --UNCHK
lin flyover_N = mkWN (k1A "ohilento") ; --UNCHK
lin flypaper_N = mkWN (compoundN "kärpäs" (k6 "paperi")) ; --UNCHK
lin flypast_N = mkWN (k1A "ohilento") ; --UNCHK
lin flyspeck_N = mkWN (compoundN "kärpäsen" (k9A "lika")) ; --UNCHK
lin flytrap_N = mkWN (compoundN "kärpäs" (k1A "loukku")) ; --UNCHK
lin flyweight_N = mkWN (compoundN "kärpässarja" (k38 "lainen")) ; --UNCHK
lin flywheel_N = mkWN (compoundN "vauhti" (k10 "pyörä")) ; --UNCHK
lin fm_N = mkWN (compoundN "taajuus" (k3 "modulaatio")) ; --UNCHK
lin fo'c'sle_N = mkWN (k10 "miehistösuoja") ; --UNCHK
lin fo_N = mkWN (compoundN "esi" (k6 "upseeri")) ; --UNCHK
lin foal_N = mkWN (k9 "varsa") ; --UNCHK
lin foal_V = mkWV (k52 "varsoa") ; --UNCHK
lin foam_N = mkWN (k1A "vaahto") ; --UNCHK
lin foam_V = mkWV (k61 "kuplia") ; --UNCHK
lin foam_rubber_N = mkWN (compoundN "vaahto" (k5 "kumi")) ; --UNCHK
lin foamflower_N = mkWN "Tiarella" "cordifolia" ; --UNCHK
lin foaminess_N = mkWN (k40 "vaahtoisuus") ; --UNCHK
lin foamy_A = mkWA "vaahtoava" ; --UNCHK
lin fob_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin fob_off_V2 = mkWV2 (k63 "myydä") "väkisin" ; --UNCHK
lin focal_A = mkWA "poltto-" ; --UNCHK
lin focalization_N = mkWN (compoundN "tarke" (k38 "ntaminen")) ; --UNCHK
lin focus_N = mkWN (k39 "fokus") ;
lin focus_V = mkV "keskittyä" ;
lin focus_V2 = mkWV2 (k54A "tarkentaa") illative ;
lin focus_on_V2 = mkWV2 (k53A "painottaa") ; --UNCHK
lin fodder_N = mkWN (k1 "rehu") ; --UNCHK
lin foe_N = mkWN (k10 "vastustaja") ;
lin foetal_A = mkWA "sikiö-" ; --UNCHK
lin foetus_N = mkWN (k3 "sikiö") ; --UNCHK
lin fog_N = L.fog_N ;
lin fog_V2 = mkWV2 (k53A "peittää") "pilviin" ; --UNCHK
lin fogbank_N = mkWN (compoundN "sumu" (k10 "seinämä")) ; --UNCHK
lin fogey_N = mkWN (k6 "fossiili") ; --UNCHK
lin foggia_PN = foreignPN "Foggia" ;
lin foggy_A = mkWA (k38 "huuruinen") ; --UNCHK
lin foghorn_N = mkWN (k6 "sumusireeni") ; --UNCHK
lin foglamp_N = mkWN (compoundN "sumu" (k1 "valo")) ; --UNCHK
lin fogsignal_N = mkWN (k6 "sumusireeni") ; --UNCHK
lin fogyish_A = mkWA (k10 "tylsä") ; --UNCHK
lin fohn_N = mkWN (compoundN "föhn-" (k26 "tuuli")) ; --UNCHK
lin foible_N = mkWN (k26 "puoli") "heikko" ; --UNCHK
lin foil_N = mkWN (k5A "floretti") ; --UNCHK
lin foil_V2 = mkV2 "estää" ; ---ARB --mkV2 "korostaa" partitive ; --mkWV2 (k53A "kiinnittää") "tausta" ;
lin foist_V2 = mkWV2 (k53A "ujuttaa") ; --UNCHK
lin fold_N = mkWN (compoundN "tai" (k38 "ttaminen")) ; --UNCHK
lin fold_V = mkV (mkV "kaatua") "kokoon" ; --mkWV (k53A "sekoittaa") ;
lin fold_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin fold_up_V2 = mkWV2 (k52A "taittua") "kokoon" ; --UNCHK
lin foldable_A = mkWA (k10 "kokoontaitettava") ; --UNCHK
lin folder_N = mkWN (k3 "kansio") ; --UNCHK
lin folderal_N = mkWN (k40 "turhuus") ; --UNCHK
lin folderol_N = mkWN (k6 "liirumlaarum") ; --UNCHK
lin foldout_N = mkWN (k5A "taitearkki") ; --UNCHK
lin foliaceous_A = mkWA (compoundA "lehti" (k38 "mäinen")) ; --UNCHK
lin foliage_N = mkWN (compoundN "lehti" (k48 "koriste")) ; --UNCHK
lin foliate_A = mkWA "lehti-" ; --UNCHK
lin foliation_N = mkWN (k5A "metallointi") ; --UNCHK
lin folio_N = mkWN (k9 "kirja") "foliokokoinen" ; --UNCHK
lin foliolate_A = mkWA "-lehdykkäinen" ; --UNCHK
lin folium_N = mkWN (k39 "kerros") ; --UNCHK
lin folk_N = mkWN (compoundN "folk" (k5A "musiikki")) ; --UNCHK
lin folk_dance_N = mkWN (compoundN "kansan" (k5 "tanssi")) ; --UNCHK
lin folkestone_PN = foreignPN "Folkestone" ;
lin folklore_N = mkWN (compoundN "kansan" (k48A "perinne")) ; --UNCHK
lin folks_N = mkWN (k9 "kansa") "tavallinen" ; --UNCHK
lin folksong_N = mkWN (compoundN "kansan" (k1 "laulu")) ; --UNCHK
lin folksy_A = mkWA (k10 "mukava") ; --UNCHK
lin folktale_N = mkWN (compoundN "kansan" (k12 "tarina")) ; --UNCHK
lin follicle_N = mkWN (k12 "rakkula") ; --UNCHK
lin follicular_A = mkWA (k38 "rakkulainen") ; --UNCHK
lin folliculitis_N = mkWN (compoundN "karvatupen" (k39 "tulehdus")) ; --UNCHK
lin follies_N = mkWN (k20 "revyy") ; --UNCHK
lin follow_V = mkV "seurata" ;
lin follow_V2 = mkV2 (mkV "seurata") partitive ;
lin follow_VS = mkVS (caseV elative (mkV "seurata")) ; --siitä seuraa, että
lin follow_on_V = advV OP_follow_V OP_on_Adv ; -- guess-p-verb
lin follow_on_from_V2 = prepV2 (advV OP_follow_V OP_on_Adv ) OP_from_Prep ; -- guess-p-verb
lin follow_through_V = mkWV (k65 "käydä") "läpi" ; --UNCHK
lin follow_up_V2 = mkWV2 (k54A "täydentää") ; --UNCHK
lin follower_N = mkWN (k10 "seuraaja") ; --UNCHK
lin following_A = mkWA (k10 "seuraava") ;
lin following_N = mkWN (kH1 "jahti") ; --UNCHK
lin following_Prep = mkPrep partitive "seuraten" ; --
lin folly_N = mkWN (k39 "hullutus") ; --UNCHK
lin foment_V2 = mkWV2 (k52A "hautoa") ; --UNCHK
lin fomentation_N = mkWN (k39 "yllytys") ; --UNCHK
lin fomite_N = mkWN (k10 "välittäjä") ; --UNCHK
lin fond_A = mkA "kiintynyt" ;
lin fondant_N = mkWN (compoundN "sokeri" (k9 "massa")) ; --UNCHK
lin fondle_V2 = mkWV2 (k67A "kosketella") ; --UNCHK
lin fondler_N = mkWN "koskettelija" ; --UNCHK
lin fondness_N = mkWN (k1A "lämpö") ; --UNCHK
lin fondue_N = mkWN (k21 "fondue") ; --UNCHK
lin font_N = mkWN (compoundN "kaste" (k9 "malja")) ; --UNCHK
lin fontanelle_N = mkWN (k48 "aukile") ; --UNCHK
lin food_N = mkWN (k10A "ruoka") ;
lin foodless_A = mkWA (compoundA "rav" (k34A "innoton")) ; --UNCHK
lin foodstuff_N = mkWN (compoundN "elin" (k48A "tarvike")) ; --UNCHK
lin fool_N = mkN "typerys" ; --mkWN (k6 "tomppeli") ;
lin fool_V2 = mkWV2 (k67A "hullutella") ; --UNCHK
lin fool_around_V = mkWV (k67A "hullutella") ; --UNCHK
lin foolery_N = mkWN (k39 "hullutus") ; --UNCHK
lin foolhardiness_N = mkWN (k40 "rämäpäisyys") ; --UNCHK
lin foolhardy_A = mkWA (k34A "holtiton") ; --UNCHK
lin foolish_A = mkWA (k34A "älytön") ; --UNCHK
lin foolishness_N = mkWN (k39 "möhläys") ; --UNCHK
lin foolproof_A = mkWA (k34A "pettämätön") ; --UNCHK
lin foolscap_N = mkWN (compoundN "asiakirja" (k6 "paperi")) ; --UNCHK
lin foot_N = L.foot_N ;
lin foot_V = mkWV (k58 "laskea") "yhteen" ; --UNCHK
lin foot_V2 = mkWV2 (k58 "laskea") "yhteen" ; --UNCHK
lin foot_race_N = mkWN (compoundN "juoksu" (k9 "kisa")) ; --UNCHK
lin foot_rot_N = mkWN (compoundN "sorkka" (k10A "mätä")) ; --UNCHK
lin footage_N = mkWN (compoundN "kuva" (k5 "materiaali")) ; --UNCHK
lin football_N = mkN "jalka" (mkN "pallo") ;
lin footballer_N = mkWN (k10 "pelaaja") "amerikkalaisen" "jalkapallon" ; --UNCHK
lin foot_bath_N = mkWN (compoundN "jalka" (k1A "kylpy")) ; --UNCHK
lin footboard_N = mkWN (k1A "pääty") ; --UNCHK
lin footbridge_N = mkWN (compoundN "jalka" (k9A "silta")) ; --UNCHK
lin footedness_N = mkWN "jalkaisuus" ; --UNCHK
lin footer_N = mkWN (compoundN "ala" (k48A "viite")) ; --UNCHK
lin footfall_N = mkWN (k49 "askel") ; --UNCHK
lin footfault_N = mkWN (compoundN "jalka" (k48 "virhe")) ; --UNCHK
lin foothold_N = mkWN (compoundN "jalan" (k9 "sija")) ; --UNCHK
lin footing_N = mkWN (compoundN "jalan" (k9 "sija")) ; --UNCHK
lin footle_V = mkWV (k52 "puhua") "joutavia" ; --UNCHK
lin footle_V2 = mkWV2 (k52 "puhua") "joutavia" ; --UNCHK
lin footless_A = mkWA "jalaton" ; --UNCHK
lin footlocker_N = mkWN (k5A "kaappi") ; --UNCHK
lin footloose_A = mkWA (k17 "vapaa") ; --UNCHK
lin footman_N = mkWN (compoundN "mies" (k12 "palvelija")) ; --UNCHK
lin footmark_N = mkWN (compoundN "jalan" (k7A "jälki")) ; --UNCHK
lin footnote_N = mkWN (compoundN "ala" (k48A "viite")) ; --UNCHK
lin footpad_N = mkWN (compoundN "maantie" (k1 "rosvo")) "jalan" "liikkuva" ; --UNCHK
lin footpath_N = mkWN (k1A "polku") ; --UNCHK
lin footplate_N = mkWN (k9A "silta") "veturin" ; --UNCHK
lin footprint_N = mkWN (compoundN "peitto" (k48 "alue")) ; --UNCHK
lin footslog_V = mkWV (k53 "laahustaa") ; --UNCHK
lin footslogger_N = mkWN (k12 "marssija") ; --UNCHK
lin footsore_A = mkWA (compoundA "kipeä" (k38 "jalkainen")) ; --UNCHK
lin footstep_N = mkWN (k49 "askel") ; --UNCHK
lin footstool_N = mkWN (k5 "rahi") ; --UNCHK
lin footsure_A = mkWA (k17 "vakaa") ; --UNCHK
lin footwall_N = mkWN (compoundN "jalka" (k26 "puoli")) ; --UNCHK
lin footwork_N = mkWN (k3 "kuvio") ; --UNCHK
lin fop_N = mkWN (k12 "hienostelija") ; --UNCHK
lin foppish_A = mkWA (compoundA "keikari" (k38 "mainen")) ; --UNCHK
lin foppishness_N = mkWN (k5A "keikarointi") ; --UNCHK
lin for_Adv = mkAdv "puolesta" ;
lin for_PConj = mkPConj "sillä" ;
lin for_Prep = S.for_Prep ;
lin for_example_Adv = mkAdv "esimerkiksi" ; --f225
lin for_instance_Adv = mkAdv "esimerkiksi" ; --f105
lin for_starters_Adv = mkAdv "alkajaisiksi" ;
lin for_the_sake_of_Prep = mkPrep "vuoksi" ;
lin forage_N = mkWN (compoundN "saali" (k38 "staminen")) ; --UNCHK
lin forage_V = mkWV (k54A "laiduntaa") ; --UNCHK
lin forager_N = mkWN (k10 "kerääjä") ; --UNCHK
lin foraging_N = mkWN (compoundN "saali" (k38 "staminen")) ; --UNCHK
lin foram_N = mkWN (compoundN "huokos" (k33 "eläin")) ; --UNCHK
lin foramen_N = mkWN (k1A "rako") ; --UNCHK
lin foray_N = mkWN (k39 "yritys") ; --UNCHK
lin foray_V = mkWV (k73A "hyökätä") ; --UNCHK
lin forbear_N = mkWN (compoundN "esi-" (k10 "isä")) ; --UNCHK
lin forbear_V = mkWV (k53A "välttää") ; --UNCHK
lin forbear_V2 = mkWV2 (k53A "välttää") ; --UNCHK
lin forbearance_N = mkWN "pidättyminen" ; --UNCHK
lin forbid_V2 = mkV2 "kieltää" partitive ; --mkWV2 (k53A "käyttää") "veto-oikeuttaan" ;
lin forbidding_A = mkWA (k10 "uhkaava") ; --UNCHK
lin force_N = mkN "voima" ;
lin force_V = mkV "pakottaa" ;
lin force_V2 = mkV2 "pakottaa" ;
lin force_V2V = mkV2V (mkV "pakottaa") accusative infIllat ; ---ARB (k53A "tyrkyttää") ;
lin force_VS = mkVS "pakottaa" ;
lin force_feed_V2 = variants {} ; -- guess-p-verb
lin force_land_V = variants {} ; -- guess-p-verb
lin force_land_V2 = variants {} ; -- guess-p-verb
lin force_majeure_N = mkWN (k48 "este") "pakottava" ; --UNCHK
lin force_out_V = mkWV (k53A "pakottaa") "ulos" ; --UNCHK
lin forceful_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin forcefulness_N = mkWN (k40 "voimakkuus") ; --UNCHK
lin forceless_A = mkWA (k34A "voimaton") ; --UNCHK
lin forcemeat_N = mkWN (k48A "mureke") ; --UNCHK
lin forcible_A = mkWA (compoundA "väki" (k38 "valtainen")) ; --UNCHK
lin forcipate_A = mkWA (compoundA "haa" (k47 "rautunut")) ; --UNCHK
lin ford_N = mkWN (k17 "kahluu") ; --UNCHK
lin ford_V2 = mkWV2 (k73 "kahlata") ; --UNCHK
lin fordable_A = mkWA (k10 "oleva") "kahlattavissa" ; --UNCHK
lin fore_A = mkWA (compoundA "keulan" (k38 "puoleinen")) ; --UNCHK
lin fore_Adv = mkWAdv "keulaan" ; --UNCHK
lin fore_N = mkWN (k10A "kokka") ; --UNCHK
lin forearm_N = mkWN (compoundN "kyynär" (k28 "varsi")) ; --UNCHK
lin forearm_V2 = mkWV2 (k53 "aseistaa") "ennakolta" ; --UNCHK
lin forebear_N = mkWN (compoundN "esi-" (k10 "isä")) ; --UNCHK
lin forebode_V2 = mkWV2 (k67 "enteillä") ; --UNCHK
lin foreboding_N = mkWN (k48A "enne") "paha" ; --UNCHK
lin forecast_N = mkN (lin NK {s = d48 "ennuste"}) ;
lin forecast_V = mkWV (k53 "ennustaa") ; --UNCHK
lin forecast_V2 = mkWV2 (k53 "ennustaa") ; --UNCHK
lin forecast_VS = mkWVS (k53 "ennustaa") ; --UNCHK
lin forecaster_N = mkWN (k10 "ennustaja") ; --UNCHK
lin forecastle_N = mkWN (k10 "miehistösuoja") ; --UNCHK
lin foreclose_V = mkV (mkV "sulkea") "markkinoilta" ;
lin foreclose_V2 = mkV2 "ulosmitata" ;
lin foreclosure_N = mkWN (compoundN "ulos" (k1A "otto")) ; --UNCHK
lin forecourt_N = mkWN (compoundN "etu" (k9 "piha")) ; --UNCHK
lin foredeck_N = mkWN (compoundN "etu" (k28 "kansi")) ; --UNCHK
lin foredoom_V2 = mkWV2 (k69 "tuomita") "ennakolta" ; --UNCHK
lin forefather_N = mkWN (k10 "isä") ; --UNCHK
lin forefinger_N = mkWN (compoundN "etu" (k7 "sormi")) ; --UNCHK
lin forefoot_N = mkWN (compoundN "etu" (k9A "jalka")) ; --UNCHK
lin forefront_N = mkWN (k10 "asema") "johtava" ; --UNCHK
lin foregather_V = mkWV (k52A "kerääntyä") ; --UNCHK
lin forego_V = mkWV (k52A "pidättyä") ; --UNCHK
lin forego_V2 = mkWV2 (k52A "pidättyä") ; --UNCHK
lin foreground_N = mkWN (k13 "edusta") ; --UNCHK
lin forehand_A = mkWA "kämmen-" ; --UNCHK
lin forehand_N = mkWN (compoundN "kämmen" (k5A "lyönti")) ; --UNCHK
lin forehead_N = mkWN (k10 "otsa") ; --UNCHK
lin foreign_1_A = mkA "ulkomaalainen" | mkA "ulkomainen" ;
lin foreign_2_A = mkA "vieras" ;
lin foreign_A = mkA "ulkomainen" ;
lin foreigner_N = mkWN (compoundN "vieras" (k38 "maalainen")) ; --UNCHK
lin foreignness_N = mkWN (k40 "outous") ; --UNCHK
lin foreknow_V = mkWV (k53 "ennustaa") ; --UNCHK
lin foreknow_V2 = mkWV2 (k53 "ennustaa") ; --UNCHK
lin foreknowledge_N = mkWN (compoundN "ennakko" (k1A "tieto")) ; --UNCHK
lin foreland_N = mkWN (compoundN "etu" (k18 "maa")) ; --UNCHK
lin foreleg_N = mkWN (compoundN "etu" (k9A "jalka")) ; --UNCHK
lin forelimb_N = mkWN (compoundN "etu" (k9 "raaja")) ; --UNCHK
lin forelock_N = mkWN (compoundN "otsa" (k10A "tukka")) ; --UNCHK
lin foreman_N = mkWN (k4A "päällikkö") ; --UNCHK
lin foremanship_N = mkWN (k10 "tehtävä") "työnjohtajan" ; --UNCHK
lin foremast_N = mkWN (compoundN "keula" (k1 "masto")) ; --UNCHK
lin foremost_A = mkWA (k38 "etummainen") ; --UNCHK
lin foremost_Adv = mkWAdv (k99 "ensisijaisesti") ; --UNCHK
lin foremother_N = mkWN (compoundN "esi" (k5A "äiti")) ; --UNCHK
lin forename_N = mkWN (compoundN "etu" (k7 "nimi")) ; --UNCHK
lin forenoon_N = mkWN (k1 "aamu") ; --UNCHK
lin forensic_A = mkWA (compoundA "rikos" (k38 "tekninen")) ; --UNCHK
lin forensics_N = mkWN (k9A "tutkinta") "rikostekninen" ; --UNCHK
lin foreordain_V2 = mkWV2 (k73 "määrätä") "ennalta" ; --UNCHK
lin forepaw_N = mkWN (compoundN "etu" (k11 "käpälä")) ; --UNCHK
lin foreperson_N = mkWN (compoundN "puheen" (k10 "johtaja")) ; --UNCHK
lin foreplay_N = mkWN (k39 "kiihotus") ; --UNCHK
lin forequarter_N = mkWN (compoundN "etu" (k39 "neljännes")) ; --UNCHK
lin forerunner_N = mkWN (k10 "edeltäjä") ; --UNCHK
lin foresail_N = mkWN "keularaakapurje" ; --UNCHK
lin foresee_V2 = mkWV2 (k53 "ennustaa") ;
lin foreseeable_A = mkWA (k10 "oleva") "ennakoitavissa" ; --UNCHK
lin foreshadow_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin foreshank_N = mkWN (compoundN "etu" (k10 "potka")) ; --UNCHK
lin foreshock_N = mkWN (compoundN "esi" (k39 "järistys")) ; --UNCHK
lin foreshore_N = mkWN (compoundN "vuorovesi" (k48A "vyöhyke")) ; --UNCHK
lin foreshorten_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin foresight_N = mkWN (k40 "harkitsevuus") ; --UNCHK
lin foreskin_N = mkWN (compoundN "esi" (k9 "nahka")) ; --UNCHK
lin forest_N = mkN "metsä" ;
lin forestall_V2 = mkWV2 (k52 "torjua") ; --UNCHK
lin forestay_N = mkWN (compoundN "etu" (k39 "harus")) ; --UNCHK
lin forested_A = mkWA (k38 "metsäinen") ; --UNCHK
lin forester_N = mkWN (compoundN "metsän" (k10 "hoitaja")) ; --UNCHK
lin forestiera_N = mkWN (compoundN "öljypuu" (k5 "kasvi")) ; --UNCHK
lin forestry_N = mkWN (compoundN "metsätalous" (k48A "tiede")) ; --UNCHK
lin foreswear_V2 = mkWV2 (k52A "luopua") ; --UNCHK
lin foretaste_N = mkWN (compoundN "esi" (k1A "maku")) ; --UNCHK
lin foretell_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin forethought_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin forethoughtful_A = mkWA (compoundA "huoleht" (k9 "iva")) ; --UNCHK
lin foretop_N = mkWN (compoundN "otsa" (k10A "tukka")) ; --UNCHK
lin forever_Adv = mkAdv "ikuisesti" ; --WAdv (k99 "alati") ;
lin forewarn_V2 = mkWV2 (k53A "varoittaa") "ennakolta" ; --UNCHK
lin forewarning_N = mkWN (k48A "enne") ; --UNCHK
lin forewing_N = mkWN (compoundN "etu" (k7A "siipi")) ; --UNCHK
lin forewoman_N = mkWN (compoundN "työn" (k10 "johtaja")) ; --UNCHK
lin foreword_N = mkWN (k1A "johdanto") ; --UNCHK
lin forfar_PN = foreignPN "Forfar" ;
lin forfeit_N = mkWN (k39 "uhraus") ; --UNCHK
lin forfeit_V2 = mkWV2 (k52A "pidättyä") ; --UNCHK
lin forfeiture_N = mkWN (k39 "uhraus") ; --UNCHK
lin forgather_V = mkWV (k52A "kerääntyä") ; --UNCHK
lin forge_N = mkWN (k2 "takomo") ; --UNCHK
lin forge_V = mkWV (k73A "kekata") ; --UNCHK
lin forge_V2 = mkV2 "takoa" partitive ; --mkWV2 (k73A "kekata") ;
lin forger_N = mkWN (k10 "väärentäjä") ; --UNCHK
lin forgery_N = mkWN (k39 "väärennys") ; --UNCHK
lin forget_V = mkV "unohtaa" ;
lin forget_V2 = L.forget_V2 ;
lin forget_VS = mkV "unohtaa" ;
lin forgetful_A = mkWA (compoundA "haja" (k38 "mielinen")) ; --UNCHK
lin forgetfulness_N = mkWN "huonomuistisuus" ; --UNCHK
lin forgettable_A = mkWA "helposti" "unohdettava" ; --UNCHK
lin forging_N = mkWN (k9A "taonta") ; --UNCHK
lin forgivable_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin forgive_V = mkWV (k56A "antaa") "anteeksi" ; --UNCHK
lin forgive_V2 = mkV2 (mkV (mkV "antaa") "anteeksi") allative ;
lin forgiveness_N = mkWN (compoundN "anteeksi" (k1A "anto")) ; --UNCHK
lin forgivingly_Adv = mkWAdv (compoundAdv "anteeksiantav" (k99 "asti")) ; --UNCHK
lin forgivingness_N = mkWN (k40 "kiltteys") ; --UNCHK
lin forgo_V2 = mkWV2 (k52A "pidättyä") ; --UNCHK
lin forint_N = mkWN (compoundN "for" (k5A "intti")) ; --UNCHK
lin fork_1_N = mkWN (compoundN "haa" (k38 "roittuminen")) ; --UNCHK
lin fork_3_N = variants {} ; --
lin fork_4_N = variants {} ; --
lin fork_N = variants {} ; --
lin fork_V = mkWV (k53A "harottaa") ; --UNCHK
lin fork_V2 = mkWV2 (k53A "harottaa") ; --UNCHK
lin fork_out_V = mkWV (k56A "antaa") ; --UNCHK
lin fork_over_V = mkWV (k56A "antaa") ; --UNCHK
lin forklift_N = mkWN (k5A "trukki") ; --UNCHK
lin forlorn_A = mkWA (k34A "toivoton") ; --UNCHK
lin forlornness_N = mkWN (k40 "lohduttomuus") ; --UNCHK
lin form_N = mkWN (k1A "muoto") ;
lin form_V = mkV "muodostua" | mkV "muovautua" ;
lin form_V2 = mkV2 "muodostaa" | mkV2 "muovata" ;
lin formal_A = mkWA (k38 "muodollinen") ; --f64
lin formaldehyde_N = mkWN (k5 "formaldehydi") ; --UNCHK
lin formalin_N = mkWN (k5 "formaliini") ; --UNCHK
lin formalism_N = mkWN (k5 "formalismi") ; --UNCHK
lin formalistic_A = mkWA (k38 "kaavamainen") ; --UNCHK
lin formality_N = mkWN (k40 "muodollisuus") ; --UNCHK
lin formalization_N = mkWN (compoundN "virallis" (k38 "taminen")) ; --UNCHK
lin formalize_V2 = mkWV2 (k53 "virallistaa") ; --UNCHK
lin formalwear_N = mkWN (k5A "frakki") ; --UNCHK
lin format_N = mkWN (kH1 "koko") ; --UNCHK
lin formation_N = mkWN (compoundN "koko" (k38 "aminen")) ; --UNCHK
lin formative_A = mkWA (compoundA "muov" (k9 "aava")) ; --UNCHK
lin formative_N = mkWN (k33A "johdin") ; --UNCHK
lin formby_PN = foreignPN "Formby" ;
lin former_A = mkA "entinen" ;
lin former_N = mkWN (compoundN "main" (k1 "ittu")) "ensin" ; --UNCHK
lin formic_A = mkWA "muurahaishappo-" ; --UNCHK
lin formica_N = mkWN (compoundN "Formica-" (k1A "suku")) ; --UNCHK
lin formication_N = mkWN "formikaatio" ; --UNCHK
lin formidability_N = mkWN (k40 "vaativuus") ; --UNCHK
lin formidable_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin formless_A = mkWA (k34A "muodoton") ; --UNCHK
lin formosa_PN = foreignPN "Formosa" ;
lin formula_N = mkWN (k1A "käytäntö") ; --UNCHK
lin formulaic_A = mkWA (k38 "kaavamainen") ; --UNCHK
lin formulary_A = mkWA "kaava-" ; --UNCHK
lin formulary_N = mkWN (compoundN "farma" (k15 "kopea")) ; --UNCHK
lin formulate_V2 = mkWV2 (k73A "kekata") ; --UNCHK
lin formulation_N = mkWN (k2 "muotoilu") ; --UNCHK
lin fornicate_V = mkWV (k53A "harjoittaa") "haureutta" ; --UNCHK
lin fornication_N = mkWN (k40 "haureus") ; --UNCHK
lin fornix_N = mkWN (k26 "aivokaari") ; --UNCHK
lin forrader_Adv = mkWAdv (k99 "edelleen") ; --UNCHK
lin forsake_V2 = mkWV2 (k53A "jättää") "heitteille" ; --UNCHK
lin forsaking_N = mkWN (k39 "luovutus") ; --UNCHK
lin forsooth_Adv = mkWAdv (k99 "totisesti") ; --UNCHK
lin forssa_PN = mkPN "Forssa" ;
lin forswear_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin forsythia_N = mkWN (compoundN "onnen" (k41 "pensas")) ; --UNCHK
lin fortaleza_PN = foreignPN "Fortaleza" ;
lin forte_A = mkWA (k41A "äänekäs") ; --UNCHK
lin forte_Adv = mkWAdv (k99 "kovaa") ; --UNCHK
lin forte_N = mkWN (k7 "tyvi") ; --UNCHK
lin fortemente_A = mkWA "fortemente" ; --UNCHK
lin forth_Adv = mkWAdv (k99 "esiin") ;
lin forthcoming_A = mkWA (k99 "saatavilla") ; --UNCHK
lin forthright_A = mkWA (k34A "kursailematon") ; --UNCHK
lin forthwith_Adv = mkWAdv (k99 "pikimmiten") ; --UNCHK
lin forties_N = mkWN "lähes" "viisikymmenvuotias" ; --UNCHK
lin fortieth_A = mkWA (k45 "neljäskymmenes") ; --UNCHK
lin fortieth_N = mkWN (k45 "neljäskymmenes") ; --UNCHK
lin fortification_N = mkWN (k5A "vitaminointi") ; --UNCHK
lin fortify_V2 = mkWV2 (k53 "voimistaa") ; --UNCHK
lin fortissimo_A = mkWA "fortissimo" ; --UNCHK
lin fortissimo_Adv = mkWAdv (k99 "kovaa") "erittäin" ; --UNCHK
lin fortitude_N = mkWN (k40 "lujuus") ; --UNCHK
lin fortnight_N = mkWN "kaksi" "viikkoa" ; --UNCHK
lin fortnightly_A = variants {} ;
lin fortnightly_Adv = adjAdv fortnightly_A ; -- derived
lin fortress_N = mkWN (k39 "linnoitus") ; --UNCHK
lin fortuitous_A = mkWA (k41A "onnekas") ; --UNCHK
lin fortuitousness_N = mkWN (k40 "onnekkuus") ; --UNCHK
lin fortunate_A = mkWA (k41A "onnekas") ;
lin fortunately_Adv = adjAdv fortunate_A ; -- -- derived
lin fortune_N = mkWN (kH1 "säkä") ; --UNCHK
lin fortuneteller_N = mkWN (kH1 "povari") ; --UNCHK
lin fortunetelling_N = mkWN "ennustaminen" ; --UNCHK
lin forum_N = mkWN (k39 "kokous") ; --UNCHK
lin forward_A = mkWA (compoundA "suu" (k1 "nnattu")) "eteenpäin" ; --UNCHK
lin forward_Adv = mkAdv "eteenpäin" | mkAdv "edelleen" ;
lin forward_N = mkN "termiini" ; ---ARB --mkWN (k10 "hyökkääjä") ;
lin forward_V2 = mkWV2 (k53A "lähettää") "eteenpäin" ; --UNCHK
lin forwarding_N = mkWN "eteenpäin" "lähettäminen" ; --UNCHK
lin forwardness_N = mkWN (k40 "uskaliaisuus") ; --UNCHK
lin forwards_Adv = mkWAdv (k99 "edelleen") ; --UNCHK
lin fossa_N = mkWN "Cryptoprocta" "ferox" ; --UNCHK
lin fosse_N = mkWN (k1A "kaivanto") ; --UNCHK
lin fossil_A = mkWA (k38 "fossiilinen") ; --UNCHK
lin fossil_N = mkWN (k6 "fossiili") ; --UNCHK
lin fossiliferous_A = mkWA (compoundA "fossiilipi" (k38 "toinen")) ; --UNCHK
lin fossilization_N = mkWN "kivettyminen" ; --UNCHK
lin fossilize_V = mkWV (k52A "piintyä") ; --UNCHK
lin fossilize_V2 = mkWV2 (k52A "piintyä") ; --UNCHK
lin fossorial_A = mkWA "kaivin-" ; --UNCHK
lin foster_A = mkWA "kasvatti-" ; --UNCHK
lin foster_V2 = mkV2 "edistää" partitive ;
lin foster_brother_N = mkWN (compoundN "kasvatti" (k7 "veli")) ; --UNCHK
lin foster_child_N = mkWN (k5A "kasvatti") ; --UNCHK
lin foster_father_N = mkWN (compoundN "kasvatus" (k10 "isä")) ; --UNCHK
lin foster_mother_N = mkWN (compoundN "kasvatus" (k5A "äiti")) ; --UNCHK
lin foster_parent_N = mkWN (compoundN "sijais" (k16A "vanhempi")) ; --UNCHK
lin foster_sister_N = mkWN (compoundN "kasvatti" (k32 "sisar")) ; --UNCHK
lin fostering_N = mkWN (k39 "kasvatus") ; --UNCHK
lin fothergilla_N = mkWN "Fothergilla" ; --UNCHK
lin foul_A = mkWA (k5A "lyönti") "laiton" ; --UNCHK
lin foul_N = mkWN (k48A "rike") ; --UNCHK
lin foul_V = mkWV (k52A "sotkeutua") ; --UNCHK
lin foul_V2 = mkWV2 (k52A "sotkeutua") ; --UNCHK
lin foul_mouthed_A = mkA (mkN "rivo" (mkN "suinen")) ;
lin foulard_N = mkWN "fulardi" ; --UNCHK
lin foulness_N = mkWN (k10 "löyhkä") ; --UNCHK
lin found_N = mkWN (compoundN "yllä" (k1A "pito")) ; --UNCHK
lin found_V2 = mkV2 "perustaa" ;
lin foundation_N = mkN "säätiö" ; --WN (k3 "initiaatio") ;
lin foundation_stone_N = mkWN (compoundN "perus" (k7 "kivi")) ; --UNCHK
lin founder_N = mkN "perustaja" ;
lin founder_V = mkWV (k52A "ontua") ; --UNCHK
lin founder_V2 = mkWV2 (k52A "ontua") ; --UNCHK
lin foundering_N = mkWN "uppoaminen" ; --UNCHK
lin foundling_N = mkWN (compoundN "löytö" (k29 "lapsi")) ; --UNCHK
lin foundress_N = mkWN (k10 "perustaja") ; --UNCHK
lin foundry_N = mkWN (k2 "valimo") ; --UNCHK
lin fount_N = mkWN (k48A "lähde") ; --UNCHK
lin fountain_N = mkWN (k48A "lähde") ; --UNCHK
lin fountain_pen_N = mkWN (compoundN "täyte" (k10 "kynä")) ; --UNCHK
lin fountain_head_N = mkWN (k48A "lähde") ; --UNCHK
lin four_part_A = mkA "neljänkeskinen" ;
lin fourfold_A = mkWA (compoundA "neli" (k38 "nkertainen")) ; --UNCHK
lin fourfold_Adv = mkWAdv (k99 "nelinkertaisesti") ; --UNCHK
lin fourhanded_A = mkWA "neljän" "hengen" ; --UNCHK
lin fourpence_N = mkWN (k9 "raha") "neljän" "pennyn" ; --UNCHK
lin fourpenny_A = mkWA (compoundA "3,8-sentti" (k38 "metrinen")) ; --UNCHK
lin fourscore_A = mkWA "lxxx-" ; --UNCHK
lin foursome_N = mkWN (k4A "nelikkö") ; --UNCHK
lin foursquare_A = mkWA (k10 "luja") ; --UNCHK
lin foursquare_Adv = mkWAdv "lujana" ; --UNCHK
lin fovea_N = mkWN (compoundN "keski" (k10A "kuoppa")) "verkkokalvon" ; --UNCHK
lin fowey_PN = foreignPN "Fowey" ;
lin fowl_N = mkWN (compoundN "kana" (k1A "lintu")) ; --UNCHK
lin fowl_V = mkWV (k53 "linnustaa") ; --UNCHK
lin fowl_run_N = mkWN (compoundN "ulkoilu" (k48 "alue")) "kanojen" ; --UNCHK
lin fowler_N = mkWN (k10 "linnustaja") ; --UNCHK
lin fox_N = mkWN (k1A "kettu") ; --UNCHK
lin fox_V2 = mkWV2 (k52 "kellastua") ; --UNCHK
lin fox_terrier_N = mkWN (compoundN "kettu" (k5 "terrieri")) ; --UNCHK
lin foxglove_N = mkWN (compoundN "sormustin" (k10A "kukka")) ; --UNCHK
lin foxhole_N = mkWN (k2 "potero") ; --UNCHK
lin foxhound_N = mkWN (compoundN "kettu" (k10 "koira")) ; --UNCHK
lin foxhunt_N = mkWN (compoundN "ketun" (k39 "metsästys")) ; --UNCHK
lin foxhunt_V = mkWV (k52 "osallistua") "ketunajoon" ; --UNCHK
lin foxtail_N = mkWN (compoundN "puntar" (k18 "pää")) ; --UNCHK
lin foxtrot_N = mkWN (k5A "fokstrotti") ; --UNCHK
lin foxy_A = mkWA (k10 "näppärä") ; --UNCHK
lin foyer_N = mkWN (k3 "lämpiö") ; --UNCHK
lin fracas_N = mkWN (k14A "rytäkkä") ; --UNCHK
lin fractal_N = mkWN (k6 "fraktaali") ; --UNCHK
lin fraction_N = mkWN (compoundN "murto-" (k10 "osa")) ; --UNCHK
lin fractional_A = mkA "määräosainen" ; ---ARB --mkWA "murto-" ;
lin fractionation_N = mkWN (compoundN "jako" (k39 "tislaus")) ; --UNCHK
lin fractious_A = mkWA (k10 "hankala") ; --UNCHK
lin fractiousness_N = mkWN (k40 "kurittomuus") ; --UNCHK
lin fracture_N = mkWN (compoundN "rikko" (k38 "minen")) ; --UNCHK
lin fracture_V = mkWV (k54A "murtaa") ; --UNCHK
lin fracture_V2 = mkWV2 (k54A "murtaa") ; --UNCHK
lin fragile_A = mkWA (k41 "hauras") ; --UNCHK
lin fragility_N = mkWN (k40 "heikkous") ; --UNCHK
lin fragment_N = mkWN (k38 "osanen") ; --UNCHK
lin fragment_V = mkWV (k52A "rikkoutua") ; --UNCHK
lin fragment_V2 = mkWV2 (k52A "rikkoutua") ; --UNCHK
lin fragmental_A = mkWA (k38 "hajanainen") ; --UNCHK
lin fragmentary_A = mkWA (k38 "hajanainen") ; --UNCHK
lin fragmentation_N = mkWN "pirstominen" ; --UNCHK
lin fragrance_N = mkWN (k39 "tuulahdus") ; --UNCHK
lin fragrant_A = mkWA (compoundA "hyvän" (k38 "tuoksuinen")) ; --UNCHK
lin frail_A = mkWA (k41 "hauras") ; --UNCHK
lin frail_N = mkWN (compoundN "viikuna" (k5 "kori")) ; --UNCHK
lin frailty_N = mkWN (k48 "pahe") ; --UNCHK
lin fraise_N = mkWN (k39 "paalutus") ; --UNCHK
lin frame_N = mkN "kehys" ; ---ARB --mkWN (k39 "kierros") ;
lin frame_V = mkWV (k61A "laatia") ; --UNCHK
lin frame_V2 = mkWV2 (k61A "laatia") ; --UNCHK
lin framer_N = mkWN (k12 "laatija") ; --UNCHK
lin framework_N = mkN "kehys" ;
lin framing_N = mkWN "laatiminen" ; --UNCHK
lin franc_N = mkWN (k5 "frangi") ; --f131
lin france_PN = foreignPN "Ranska" ;
lin franchise_N = mkWN (k40 "oikeus") ;
lin francis_PN = foreignPN "Francis" ;
lin franciscan_A = mkWA "fransiskaani-" ; --UNCHK
lin franciscan_N = mkWN (k7 "veli") "harmaa" ; --UNCHK
lin francium_N = mkWN "järjestysluku" "87" ; --UNCHK
lin frangible_A = mkWA (k41 "hauras") ; --UNCHK
lin frangipane_N = mkWN "mantelikermaleivos" ; --UNCHK
lin frangipani_N = mkWN (k5 "jasmiini") "punainen" ; --UNCHK
lin frank_A = mkWA (k34A "kursailematon") ; --UNCHK
lin frank_N = mkWN (kH1 "nakki") ; --UNCHK
lin frank_PN = mkPN "Frank" ;
lin frank_V2 = mkWV2 (k53A "lähettää") "vapaakirjeenä" ; --UNCHK
lin frankfurt_PN = mkPN "Frankfurt" ;
lin frankfurter_N = mkWN (kH1 "nakki") ; --UNCHK
lin frankincense_N = mkWN (compoundN "olibaanikumi" (k5 "hartsi")) ; --UNCHK
lin franking_machine_N = mkWN (compoundN "frankeeraus" (k48 "kone")) ; --UNCHK
lin franklin_N = mkWN (compoundN "suurtalon" (k10A "poika")) "vapaa" ; --UNCHK
lin frankly_Adv = adjAdv frank_A ; -- -- derived
lin frankness_N = mkWN (k40 "suoruus") ; --UNCHK
lin frantic_A = mkWA (k10 "raivoisa") ; --UNCHK
lin frappe_N = mkWN (k48A "jäädyke") ; --UNCHK
lin fraserburgh_PN = foreignPN "Fraserburgh" ;
lin fraternal_A = mkWA (k38 "veljellinen") ; --UNCHK
lin fraternity_N = mkWN (k5 "piiri") ; --UNCHK
lin fraternization_N = mkWN (k2 "veljeily") ; --UNCHK
lin fraternize_V = mkWV (k67 "veljeillä") ; --UNCHK
lin fratricide_N = mkWN (compoundN "veljen" (k10 "surma")) ; --UNCHK
lin frau_N = mkWN (k10 "rouva") ; --UNCHK
lin fraud_N = mkN (lin NK {s = d39 "petos"}) ;
lin fraudulence_N = mkWN (k5 "humpuuki") ; --UNCHK
lin fraudulent_A = mkWA (k38 "vilpillinen") ; --UNCHK
lin fraught_A = mkA (mkN "täysi" "täysiä") ; --mkWA "täynnä" "jotakin" ;
lin fraulein_N = mkWN (k5A "neiti") ; --UNCHK
lin fraxinella_N = mkWN (k51 "palavapensas") ; --UNCHK
lin fray_N = mkWN (k9A "riita") ; --UNCHK
lin fray_V = mkWV (k73A "hangata") ; --UNCHK
lin fray_V2 = mkWV2 (k73A "hangata") ; --UNCHK
lin frazzle_N = mkWN (k39 "uupumus") ; --UNCHK
lin freak_N = mkWN (k5 "entusiasti") ; --UNCHK
lin freak_V = mkWV (k53A "pimahtaa") ; --UNCHK
lin freak_V2 = mkWV2 (k53A "pimahtaa") ; --UNCHK
lin freak_out_N = mkWN (k3 "hallusinaatio") ; --UNCHK
lin freak_out_V2 = mkWV2 (k53A "pimahtaa") ; --UNCHK
lin freakish_A = mkWA (k38 "merkillinen") ; --UNCHK
lin freakishness_N = mkWN (k40 "poikkeavuus") ; --UNCHK
lin freaky_A = mkWA (k38 "merkillinen") ; --UNCHK
lin freckle_N = mkWN (k10 "pisama") ; --UNCHK
lin freckle_V = mkWV "pisamoitua" ; --UNCHK
lin freckle_V2 = mkWV2 "pisamoitua" ; --UNCHK
lin freckleton_PN = foreignPN "Freckleton" ;
lin frederick_PN = foreignPN "Frederick" ;
lin frederiksberg_PN = foreignPN "Frederiksberg" ;
lin free_1_A = mkA "vapaa" ;
lin free_2_A = mkA "vapaa" ;
lin free_N = mkWN (compoundN "kylä" (k38 "pöllönen")) ; --UNCHK
lin free_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin free_V2V = mkWV2V (k53A "vapauttaa") ; --UNCHK
lin free_list_N = mkWN (k2 "luettelo") "lisämaksuttomien" "tuotteiden" ; --UNCHK
lin free_living_N = mkWN (k2 "nautiskelu") "elämästä" ; --UNCHK
lin free_of_A2 = mkA2 (mkA "vapaa") (mkPrep elative) ;
lin free_standing_A = mkA "itsenäinen" | mkWA (k38 "erillinen") ; --UNCHK
lin free_thought_N = mkWN (k50 "vapaa-ajattelu") ; --UNCHK
lin free_trader_N = mkWN (k10 "kannattaja") "vapaakaupan" ; --UNCHK
lin free_up_V2 = prepV2 (lin V OP_free_V2) OP_up_Prep ; -- guess-p-verb
lin freebie_N = mkWN (k38 "kylkiäinen") ; --UNCHK
lin freebooter_N = mkWN (k10 "ryöstäjä") ; --UNCHK
lin freedman_N = mkWN (k10 "orja") "vapautettu" ; --UNCHK
lin freedom_N = mkWN (k40 "vapaus") ;
lin freehand_A = mkWA (compoundA "käsi" (k38 "varainen")) ; --UNCHK
lin freehold_N = mkWN (compoundN "omistus" (k40 "oikeus")) "täysi" ; --UNCHK
lin freeholder_N = mkWN (compoundN "maan" (k10 "omistaja")) ; --UNCHK
lin freelance_A = mkWA "itsensä" "työllistävä" ; --UNCHK
lin freelance_N = mkWN (k10 "toimittaja") "vapaa" ; --UNCHK
lin freelance_V = mkWV (k67A "työskennellä") "freelancerina" ; --UNCHK
lin freelancer_N = mkWN (k10 "toimittaja") "vapaa" ; --UNCHK
lin freeloader_N = mkWN (k50 "vapaamatkustaja") ; --UNCHK
lin freemail_N = mkWN (k5 "ilmaisposti") ; --UNCHK
lin freeman_N = mkWN (k38 "ihminen") "vapaa" ; --UNCHK
lin freemason_N = mkWN (k50 "vapaamuurari") ; --UNCHK
lin freemasonry_N = mkWN (k40 "vapaamuurarius") ; --UNCHK
lin freesia_N = mkWN (k12 "freesia") ; --UNCHK
lin freestone_N = mkWN "freestone" ; --UNCHK
lin freestyle_N = mkWN (k50 "vapaapaini") ; --UNCHK
lin freetail_N = mkWN (compoundN "meksikondoggile" (k1A "pakko")) ; --UNCHK
lin freeware_N = mkWN (compoundN "ilmais" (k10 "ohjelma")) ; --UNCHK
lin freeway_N = mkWN (compoundN "valta" (k19 "tie")) ; --UNCHK
lin freewheel_N = mkWN (compoundN "vapaa" (k41A "ratas")) ; --UNCHK
lin freewill_A = mkWA "vapaasta" "tahdosta" ; --UNCHK
lin freeze_N = mkN "pysähdys" ; ---ARB --mkWN (compoundN "palkka" (k1A "sulku")) ; --mkN "jäätyminen" ;
lin freeze_V = L.freeze_V ;
lin freeze_V2 = mkWV2 (k52A "käyttäytyä") "jäätävästi" ; --UNCHK
lin freeze_out_V2 = mkWV2 (k52A "jäätyä") ; --UNCHK
lin freezer_N = mkWN (k33 "pakastin") ; --UNCHK
lin freezing_mixture_N = mkWN (k50 "kylmäseos") ; --UNCHK
lin freezing_point_N = mkWN (compoundN "sulamis" (k48 "piste")) ; --UNCHK
lin freiburg_PN = foreignPN "Freiburg" ;
lin freight_N = mkN "rahti" ; ---ARB mkWN (k39 "rahtaus") ;
lin freight_V2 = mkWV2 (k73A "rahdata") ; --UNCHK
lin freight_train_N = mkWN (compoundN "tavara" (k10 "juna")) ; --UNCHK
lin freighter_N = mkWN (compoundN "kauppa-" (k39 "alus")) ; --UNCHK
lin frenchFem_N = mkN "ranskatar" ;
lin frenchMasc_N = mkN "ranskalainen" ;
lin french_A = mkA "ranskalainen" ;
lin frenchman_N = mkWN (k38 "ranskalainen") ; --UNCHK
lin frenchwoman_N = mkWN (k38 "ranskalainen") ; --UNCHK
lin frenetic_A = mkWA (k10 "raivoisa") ; --UNCHK
lin frenzied_A = mkWA (k10 "raivoisa") ; --UNCHK
lin frenzy_N = mkWN (k12 "hysteria") ;
lin frequency_N = mkN "frekvenssi" ; --WN (k5 "frekvenssi") "absoluuttinen" ;
lin frequent_A = mkWA (k38 "yleinen") ; --f59
lin frequent_V2 = mkWV2 (k65 "käydä") "usein" ; --UNCHK
lin frequentative_N = mkWN "frekventatiivi" ; --UNCHK
lin fresco_N = mkWN (k1 "fresko") ; --UNCHK
lin fresh_A = mkA (lin AK {s = d48 "tuore"}) ;
lin fresh_Adv = mkWAdv (k99 "äsken") "vasta" ; --UNCHK
lin freshen_V = mkWV (k53A "elävöittää") ; --UNCHK
lin freshen_V2 = mkWV2 (k53A "elävöittää") ; --UNCHK
lin freshen_up_V = mkWV (k52A "virkistäytyä") ; --UNCHK
lin freshen_up_V2 = mkWV2 (k52A "virkistäytyä") ; --UNCHK
lin freshener_N = mkWN (k48 "raikaste") ; --UNCHK
lin fresher_N = mkWN (k5 "fuksi") ; --UNCHK
lin freshet_N = mkWN (k1A "ryöppy") ; --UNCHK
lin freshman_A = mkWA (k5 "fuksi") ; --UNCHK
lin freshman_N = mkN "aloittelija" ;
lin freshness_N = mkWN (k40 "uutuus") ; --UNCHK
lin freshwater_PN = foreignPN "Freshwater" ;
lin fret_N = mkWN (compoundN "ote" (k9 "nauha")) ; --UNCHK
lin fret_V = mkWV (k53A "rapauttaa") ; --UNCHK
lin fret_V2 = mkWV2 (k53A "rapauttaa") ; --UNCHK
lin fret_VS = mkWVS (k53A "rapauttaa") ; --UNCHK
lin fretful_A = mkWA "valitteleva" ; --UNCHK
lin fretsaw_N = mkWN (compoundN "lehti" (k9 "saha")) ; --UNCHK
lin fretwork_N = mkWN (k4A "ristikko") ; --UNCHK
lin freudian_A = mkWA (k38 "freudilainen") ; --UNCHK
lin friability_N = mkWN (k40 "hauraus") ; --UNCHK
lin friable_A = mkWA (k41 "hauras") ; --UNCHK
lin friar_N = mkWN (k5A "munkki") ; --UNCHK
lin friary_N = mkWN (compoundN "munkki" (k6 "luostari")) ; --UNCHK
lin fricandeau_N = mkWN (k5A "viillokki") ; --UNCHK
lin fricassee_N = mkWN (k5A "viillokki") ; --UNCHK
lin fricassee_V2 = mkWV2 (k53 "valmistaa") "viillokkia" ; --UNCHK
lin fricative_A = mkWA "suhiseva" ; --UNCHK
lin fricative_N = mkWN (k5A "konsonantti") "frikatiivinen" ; --UNCHK
lin friction_N = mkWN (k39 "hankaus") ; --UNCHK
lin frictional_A = mkWA "kitka-" ; --UNCHK
lin frictionless_A = mkWA (k34A "kitkaton") ; --UNCHK
lin fridge_N = L.fridge_N ;
lin friedcake_N = mkWN (k38 "leivonnainen") "rasvassa" "keitetty" ; --UNCHK
lin friend_N = L.friend_N ;
lin friendlessness_N = mkWN (k40 "yksinäisyys") ; --UNCHK
lin friendliness_N = mkWN (k40 "ystävällisyys") ; --UNCHK
lin friendly_A = mkWA (k38 "ystävällinen") ;
lin friendship_N = mkWN (k40 "ystävyys") ; --UNCHK
lin frier_N = mkWN (k4A "nuorikko") ; --UNCHK
lin frieze_N = mkWN (kH1 "sarka") ; --UNCHK
lin frigate_N = mkWN (k5A "fregatti") ; --UNCHK
lin fright_N = mkWN (k1 "kauhu") ; --UNCHK
lin fright_V2 = mkWV2 (k67A "pelotella") ; --UNCHK
lin frighten_V2 = mkV2 "pelotella" partitive ;
lin frighten_away_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin frighten_off_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin frightened_A = variants {} ; --
lin frightening_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin frightful_A = mkWA (k10 "karmiva") ; --UNCHK
lin frightfulness_N = mkWN (k40 "kamaluus") ; --UNCHK
lin frigid_A = mkWA (k38 "arktinen") ; --UNCHK
lin frigidity_N = mkWN (k40 "etäisyys") ; --UNCHK
lin frigorific_A = mkWA (k10 "kylmä") ; --UNCHK
lin frijole_N = mkWN (compoundN "frijole-" (k1A "papu")) ; --UNCHK
lin frill_N = mkWN (k40 "turhuus") ; --UNCHK
lin frilled_A = mkWA (k38 "röyhelöinen") ; --UNCHK
lin frilly_A = mkWA (k38 "röyhelöinen") ; --UNCHK
lin fringe_N = mkN "laita" ;
lin fringe_V2 = mkWV2 (k53 "reunustaa") ; --UNCHK
lin fringy_A = mkWA (k38 "marginaalinen") ; --UNCHK
lin frippery_N = mkWN (k1A "höttö") ; --UNCHK
lin frisk_N = mkWN (compoundN "ruumiin" (k39 "tarkastus")) ; --UNCHK
lin frisk_V = mkWV (k71 "tehdä") "ruumiintarkastus" ; --UNCHK
lin frisk_V2 = mkWV2 (k71 "tehdä") "ruumiintarkastus" ; --UNCHK
lin friskiness_N = mkWN (k40 "vallattomuus") ; --UNCHK
lin frisky_A = mkWA (k10 "eloisa") ; --UNCHK
lin frisson_N = mkWN (k12 "tutina") ; --UNCHK
lin fritillary_N = mkWN (k38 "perhonen") "oranssi" ; --UNCHK
lin frittata_N = mkWN (compoundN "kasvi" (k41A "munakas")) ; --UNCHK
lin fritter_N = mkWN (k38 "leivonnainen") "uppopaistettu" ; --UNCHK
lin fritter_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin fritter_away_V = mkWV (k53A "kuluttaa") ; --UNCHK
lin frivol_V = mkWV (k67 "pilailla") ; --UNCHK
lin frivol_V2 = mkWV2 (k67 "pilailla") ; --UNCHK
lin frivolity_N = mkWN (k2 "kujeilu") ; --UNCHK
lin frivolous_A = mkWA (k10 "typerä") ; --UNCHK
lin frizz_N = mkWN (k11 "kihara") ; --UNCHK
lin frizz_V2 = mkWV2 (k54A "sykertää") ; --UNCHK
lin frizzle_V = mkWV (k53 "käristää") ; --UNCHK
lin frizzle_V2 = mkWV2 (k53 "käristää") ; --UNCHK
lin frizzy_A = mkWA (k99 "sikkurassa") ; --UNCHK
lin frock_N = mkN (lin NK {s = d01A "kaapu"}) ;
lin frock_coat_N = mkWN (compoundN "lieve" (k5A "takki")) ; --UNCHK
lin frodsham_PN = foreignPN "Frodsham" ;
lin frog_N = mkWN (k10 "konna") ; --UNCHK
lin frogbit_N = mkWN (k14A "kilpukka") ; --UNCHK
lin frogfish_N = mkWN "antennikrotti" ; --UNCHK
lin froghopper_N = mkWN (compoundN "-sylki" (k41 "kaskas")) "Cercopis" "vulnerata" ; --UNCHK
lin frogman_N = mkWN (k10 "sukeltaja") ; --UNCHK
lin frogmouth_N = mkWN (compoundN "pöllö" (k10 "kehrääjä")) ; --UNCHK
lin frolic_N = mkWN (k2 "hulluttelu") ; --UNCHK
lin frolic_V = mkWV (k68 "karkeloida") ; --UNCHK
lin frolicsome_A = mkWA (k10 "leikkisä") ; --UNCHK
lin from_Prep = casePrep elative | casePrep ablative ; ---- | mkPrep "luota" | mkPrep "tyköä" ; ---- split
lin from_home_Adv = mkAdv "kotoa" ;
lin frome_PN = foreignPN "Frome" ;
lin frond_N = mkWN (k7A "lehti") "saniaisen" ; --UNCHK
lin front_A = mkA "etummainen" ;
lin front_N = mkWN (compoundN "etu" (k26 "puoli")) ;
lin front_V = mkWV (k73A "kohdata") ; --UNCHK
lin front_V2 = mkWV2 (k73A "kohdata") ; --UNCHK
lin frontage_N = mkWN (k5 "fasadi") ; --UNCHK
lin frontal_N = mkWN (k5 "fasadi") ; --UNCHK
lin front_bencher_N = mkWN (k32 "jäsen") "varjohallituksen" ; --UNCHK
lin frontier_N = mkWN (compoundN "etu" (k10 "rintama")) "tieteen" ; --UNCHK
lin frontiersman_N = mkWN (k42 "mies") "takametsien" ; --UNCHK
lin frontierswoman_N = mkWN (k41A "asukas") "rajaseudun" ; --UNCHK
lin frontlet_N = mkWN (compoundN "otsa" (k48 "koriste")) ; --UNCHK
lin frore_A = mkWA (compoundA "jää" (k10 "kylmä")) ; --UNCHK
lin frost_V = mkWV (k52A "paleltua") ; --UNCHK
lin frost_V2 = mkWV2 (k52A "paleltua") ; --UNCHK
lin frostbite_N = mkWN (k10 "paleltuma") ; --UNCHK
lin frostbitten_A = mkWA "paleltunut" ; --UNCHK
lin frostiness_N = mkWN (compoundN "kuuran" (k15 "valkea")) ; --UNCHK
lin frosting_N = mkWN (k39 "kuorrutus") ; --UNCHK
lin frostweed_N = mkWN "Verbesina" "virginica" ; --UNCHK
lin frosty_A = mkWA (k41A "raitis") ; --UNCHK
lin froth_N = mkWN (k1A "vaahto") ; --UNCHK
lin froth_V = mkWV (k74A "vaahdota") ; --UNCHK
lin frothiness_N = mkWN "poreilevuus" ; --UNCHK
lin frothy_A = mkWA (k41A "vilkas") ; --UNCHK
lin frottage_N = mkWN (compoundN "frotteur" (k5 "ismi")) ; --UNCHK
lin frotteur_N = mkWN (compoundN "frotteu" (k5 "risti")) ; --UNCHK
lin froward_A = mkWA (k41A "sisukas") ; --UNCHK
lin frown_N = mkWN (k48 "katse") "vihainen" ; --UNCHK
lin frown_V = mkWV (k67 "mulkoilla") ; --UNCHK
lin frown_on_V2 = mkWV2 (k52 "paheksua") ; --UNCHK
lin frowningly_Adv = mkWAdv (compoundAdv "paheksuv" (k99 "asti")) ; --UNCHK
lin frowsty_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin frowsy_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin frowzy_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin frozen_A = mkA "jäätynyt" ;
lin frs_N = mkWN (compoundN "keskus" (k5A "pankki")) "Yhdysvaltain" ; --UNCHK
lin fructify_V = mkWV (k71 "tehdä") "hedelmää" ; --UNCHK
lin fructify_V2 = mkWV2 (k71 "tehdä") "hedelmää" ; --UNCHK
lin fructose_N = mkWN (k5 "fruktoosi") ; --UNCHK
lin fructosuria_N = mkWN "fruktosuria" ; --UNCHK
lin frugal_A = mkWA (k38 "taloudellinen") ; --UNCHK
lin frugality_N = mkWN (k40 "taloudellisuus") ; --UNCHK
lin fruit_N = L.fruit_N ;
lin fruit_V = mkWV (k56A "kantaa") "hedelmää" ; --UNCHK
lin fruit_fly_N = mkWN (compoundN "banaani" (k38 "kärpänen")) ; --UNCHK
lin fruitage_N = mkWN (k1A "sato") ; --UNCHK
lin fruitcake_N = mkWN (compoundN "hedelmä" (k1A "kakku")) ; --UNCHK
lin fruiterer_N = mkWN (compoundN "hedelmä" (k41 "kauppias")) ; --UNCHK
lin fruitful_A = mkWA (k38 "hedelmällinen") ; --UNCHK
lin fruitfulness_N = mkWN (k40 "hedelmällisyys") ; --UNCHK
lin fruition_N = mkWN (k10 "toteutuma") ; --UNCHK
lin fruitless_A = mkWA (k10 "tyhjä") ; --UNCHK
lin fruitlessness_N = mkWN (k40 "tuottamattomuus") ; --UNCHK
lin fruitlet_N = mkWN (k10 "hedelmä") "pieni" ; --UNCHK
lin fruitwood_N = mkWN (compoundN "hedelmä" (k18 "puu")) ; --UNCHK
lin fruity_A = mkWA (k1 "pöllö") ; --UNCHK
lin frump_N = mkWN (k10 "ämmä") "ruma" ; --UNCHK
lin frumpish_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin frumpy_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin frustrate_V2 = mkV2 "turhauttaa" ; --WV2 (k53 "ahdistaa") ;
lin frustrating_A = mkWA (compoundA "turh" (k10 "auttava")) ; --UNCHK
lin frustration_N = mkWN (k38 "tekeminen") "tyhjäksi" ; --UNCHK
lin frustum_N = mkWN (k3 "kartio") "katkaistu" ; --UNCHK
lin fry_N = mkWN (k38 "nuorukainen") ; --UNCHK
lin fry_V = mkWV (k56 "paistaa") ; --UNCHK
lin fry_V2 = mkWV2 (k56 "paistaa") ; --UNCHK
lin fryer_N = mkWN (k4A "nuorikko") ; --UNCHK
lin frying_N = mkWN (compoundN "pai" (k38 "staminen")) ; --UNCHK
lin frying_pan_N = mkWN (compoundN "paistin" (k1 "pannu")) ; --UNCHK
lin fuchsia_N = mkWN "fuksia" ; --UNCHK
lin fuck_N = mkN "pano" ; --UNCHK
lin fuck_V = mkV "naida" | mkV "nussia" ;
lin fuck_V2 = mkV2 "naida" partitive | mkV2 "panna" partitive ;
lin fuck_all_N = mkWN (k99 "yhtään") "ei" ; --UNCHK
lin fucker_N = mkWN (k38 "paskiainen") ; --UNCHK
lin fucking_A = mkA "vittumainen" ; ----
lin fucking_Adv = mkWAdv "vitun" ; --UNCHK
lin fucoid_N = mkWN (compoundN "rusko" (k10 "levä")) ; --UNCHK
lin fucus_N = mkWN (compoundN "rusko" (k10 "levä")) ; --UNCHK
lin fuddle_V2 = mkWV2 (k53A "hämmästyttää") ; --UNCHK
lin fudge_N = mkWN (compoundN "kerma" (k5 "karamelli")) "pehmeä" ; --UNCHK
lin fuel_N = mkWN (compoundN "poltto" (k48 "aine")) ; --f53
lin fuel_V = mkWV (k61A "ruokkia") ; --UNCHK
lin fuel_V2 = mkWV2 (k61A "ruokkia") partitive ;
lin fueling_N = mkWN (kH1 "tankkaus") ; --UNCHK
lin fug_N = mkWN (k40 "tunkkaisuus") ; --UNCHK
lin fugacity_N = mkWN (compoundN "lyhytikä" (k40 "isyys")) ; --UNCHK
lin fugal_A = mkWA "fuuga-" ; --UNCHK
lin fuggy_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin fugitive_A = mkWA (k10 "ohikiitävä") ; --UNCHK
lin fugitive_N = mkWN (k2 "henkilö") "oikeutta" "pakoileva" ; --UNCHK
lin fugleman_N = mkWN (compoundN "nokka" (k42 "mies")) ; --UNCHK
lin fugly_A = mkWA (k10 "ruma") "vitun" ; --UNCHK
lin fugu_N = mkWN "fugu" ; --UNCHK
lin fugue_N = mkWN (k10 "fuuga") ; --UNCHK
lin fuji_N = mkWN (compoundN "Fuji-vu" (k48 "ori")) ; --UNCHK
lin fulcrum_N = mkWN (k9A "napa") ; --UNCHK
lin fulfil_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin fulfill_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin fulfillment_N = mkWN "täyttäminen" ; --UNCHK
lin fulfilment_N = mkWN "täyttäminen" ; --UNCHK
lin fulgurating_A = mkWA (k10 "terävä") ; --UNCHK
lin full_A = L.full_A ;
lin full_blown_A = mkA (mkN "täysi" (mkN "mittainen")) ;
lin full_fledged_A = mkA "täysimääräinen" ;
lin full_length_A = mkA "täyspitkä" ;
lin full_page_A = mkA "kokosivun" ;
lin full_scale_A = mkA (mkN "täysi" (mkN "mittainen")) ;
lin full_time_A = mkA "täyspäiväinen" ;
lin fullback_N = mkWN (compoundN "keskus" (k10 "hyökkääjä")) "blokkaava" ; --UNCHK
lin fuller_N = mkWN "huovuttaja" ; --UNCHK
lin fullerene_N = mkWN (compoundN "pallo" (k24 "hiili")) ; --UNCHK
lin fullness_N = mkWN (k40 "runsaus") ; --UNCHK
lin fully_Adv = mkAdv "täysin" | adjAdv full_A ; -- derived
lin fully_fashioned_A = mkWA (compoundA "muoto" (k1 "kudottu")) ; --UNCHK
lin fully_fledged_A = mkWA (k41 "valmis") ; --UNCHK
lin fully_grown_A = mkWA (kH1 "iso") ; --UNCHK
lin fulmar_N = mkWN (compoundN "myrsky" (k1A "lintu")) ; --UNCHK
lin fulminant_A = mkWA (k38 "äkillinen") ; --UNCHK
lin fulminate_N = mkWN (compoundN "fulmi" (k5A "naatti")) ; --UNCHK
lin fulminate_V = mkWV (k53A "välähtää") ; --UNCHK
lin fulmination_N = mkWN (k39 "välähdys") ; --UNCHK
lin fulsome_A = mkWA (k15 "mairea") ; --UNCHK
lin fulsomeness_N = mkWN (k40 "lipevyys") ; --UNCHK
lin fumble_V = mkWV (k62 "haparoida") ; --UNCHK
lin fumble_V2 = mkWV2 (k62 "haparoida") ; --UNCHK
lin fumbler_N = mkWN (k10 "hutiloija") ; --UNCHK
lin fume_N = mkWN (k1 "sauhu") ; --UNCHK
lin fume_V = mkWV (k74 "höyrytä") ; --UNCHK
lin fume_V2 = mkWV2 (k74 "höyrytä") ; --UNCHK
lin fume_VS = mkWVS (k74 "höyrytä") ; --UNCHK
lin fumewort_N = mkWN "pystykiurunkannus" ; --UNCHK
lin fumigant_N = mkWN (compoundN "savutus" (k48 "aine")) ; --UNCHK
lin fumigate_V2 = mkWV2 (k53A "savuttaa") ; --UNCHK
lin fumigation_N = mkWN (k39 "höyrytys") ; --UNCHK
lin fumigator_N = mkWN (compoundN "savustus" (k3 "kammio")) ; --UNCHK
lin fumitory_N = mkWN (compoundN "pelto" (k5A "emäkki")) ; --UNCHK
lin fun_A = variants {} ; --
lin fun_AV = L.fun_AV ;
lin fun_N = mkWN (k40 "hauskuus") ; --UNCHK
lin funambulism_N = mkWN (compoundN "nuoralla" (k5 "tanssi")) ; --UNCHK
lin funambulistFem_N = mkWN (compoundN "nuoralla" (k12 "tanssija")) ; --UNCHK
lin funambulistMasc_N = mkWN (compoundN "nuoralla" (k12 "tanssija")) ; --UNCHK
lin function_N = mkN "funktio" | mkN "tehtävä" ;
lin function_V = mkWV (k61 "toimia") ;
lin functional_A = mkWA (k38 "toiminnallinen") ; --UNCHK
lin functionalism_N = mkWN (k5 "funktionalismi") ; --UNCHK
lin functionalist_N = mkWN "funktionalisti" ; --UNCHK
lin functionality_N = mkWN "toimivuus" ; --UNCHK
lin functionary_N = mkWN (k12 "virkailija") ; --UNCHK
lin fund_N = mkN "rahasto" ;
lin fund_V2 = mkWV2 (k53A "rahoittaa") ; --f64
lin fundamental_A = mkA "perustavanlaatuinen" ; --WA "kardinaali-" ;
lin fundamental_N = mkWN (compoundN "perus" (k32 "sävel")) ; --UNCHK
lin fundamentalism_N = mkWN (k5 "fundamentalismi") ; --UNCHK
lin fundamentalist_A = mkWA (k38 "fundamentalistinen") ; --UNCHK
lin fundamentalist_N = mkWN (k5 "fundamentalisti") ; --UNCHK
lin fundamentals_N = mkWN (k10 "pohja") ; --UNCHK
lin funding_N = mkN "rahoitus" ;
lin fundraiser_N = mkWN (compoundN "varainhankinta" (k40 "tilaisuus")) ; --UNCHK
lin fundraising_N = mkN "rahanhankinta" ;
lin funds_N = mkWN (k38 "käteinen") ; --UNCHK
lin fundus_N = mkWN (k14A "pohjukka") ; --UNCHK
lin funeral_N = mkN "hautajaistilaisuus" ;
lin funerary_A = mkWA "hautaus-" ; --UNCHK
lin funereal_A = mkWA (compoundA "hauta" (k38 "mainen")) ; --UNCHK
lin funfair_N = mkWN (k6 "tivoli") ; --UNCHK
lin fungal_A = mkWA "sieni-" ; --UNCHK
lin fungible_A = mkWA "korvattava" ; --UNCHK
lin fungible_N = mkWN (compoundN "paljous" (k48 "esine")) ; --UNCHK
lin fungicidal_A = mkWA (compoundA "antifunga" (k38 "alinen")) ; --UNCHK
lin fungicide_N = mkWN (k48 "aine") "sieniä" "tappava" ; --UNCHK
lin fungoid_A = mkWA (k38 "sienimäinen") ; --UNCHK
lin fungous_A = mkWA "sieni-" ; --UNCHK
lin fungus_N = mkWN (k26 "sieni") ; --UNCHK
lin funicle_N = mkWN (compoundN "funik" (k5 "keli")) ; --UNCHK
lin funicular_A = mkWA "köysi-" ; --UNCHK
lin funicular_N = mkWN (compoundN "köysi" (k9A "rata")) ; --UNCHK
lin funiculitis_N = mkWN "funikuliitti" ; --UNCHK
lin funiculus_N = mkWN (compoundN "funik" (k5 "keli")) ; --UNCHK
lin funk_N = mkWN "funk" ; --UNCHK
lin funk_V = mkWV (k53A "säpsähtää") ; --UNCHK
lin funk_V2 = mkWV2 (k53A "säpsähtää") ; --UNCHK
lin funky_A = mkWA (k38 "pelkurimainen") ; --UNCHK
lin funnel_N = mkWN (compoundN "savu" (k10 "kanava")) ; --UNCHK
lin funnel_V2 = mkV2 "kanavoida" ;
lin funniness_N = mkWN (k40 "hauskuus") ; --UNCHK
lin funny_A = mkA "hauska" ; --UNCHK
lin funny_bone_N = mkWN (compoundN "kiukku" (k26 "suoni")) ; --UNCHK
lin funrun_N = mkWN (compoundN "hyväntekeväisyys" (k1 "juoksu")) ; --UNCHK
lin fur_N = mkN "turkis" ; --UNCHK
lin furbelow_N = mkWN (k2 "röyhelö") ; --UNCHK
lin furbish_V2 = mkWV2 (k53A "kiillottaa") ; --UNCHK
lin furcation_N = mkWN (k10 "haarauma") ; --UNCHK
lin furcula_N = mkWN (compoundN "hanka" (k18 "luu")) ; --UNCHK
lin furious_A = mkA "raivokas" ;
lin furl_V = mkWV (k61 "kääriä") ; --UNCHK
lin furl_V2 = mkWV2 (k61 "kääriä") ; --UNCHK
lin furlike_A = mkWA (compoundA "turkis" (k38 "mainen")) ; --UNCHK
lin furlong_N = mkWN "201,2" "metriä" ; --UNCHK
lin furlough_N = mkWN (compoundN "koti" (k10 "loma")) ; --UNCHK
lin furnace_N = mkWN (k5 "uuni") ; --UNCHK
lin furnish_V2 = mkWV2 (k53 "kalustaa") ; --UNCHK
lin furnishing_N = mkWN (compoundN "sisu" (k38 "staminen")) ; --UNCHK
lin furniture_N = mkWN (compoundN "huone" (k1 "kalu")) ;
lin furore_N = mkWN (k39 "suuttumus") "yleinen" ; --UNCHK
lin furosemide_N = mkWN (k5 "furosemidi") ; --UNCHK
lin furred_A = mkWA (k38 "karvainen") ; --UNCHK
lin furrier_N = mkWN (k6 "turkkuri") ; --UNCHK
lin furring_N = mkWN (k39 "listoitus") ; --UNCHK
lin furrow_N = mkWN (k1A "vako") ; --UNCHK
lin furrow_V = mkWV (k71 "tehdä") "uurre" ; --UNCHK
lin furrow_V2 = mkWV2 (k71 "tehdä") "uurre" ; --UNCHK
lin furry_A = mkWA (k38 "karvainen") ; --UNCHK
lin furth_PN = foreignPN "Furth" ;
lin further_A = mkA "kaukaisempi" ;
lin further_AdV = mkAdV "edelleen" ;
lin further_Adv = mkAdv "pidemmälle" ;
lin further_V2 = mkWV2 (k53 "edistää") ; --UNCHK
lin furtherance_N = mkWN "edistäminen" ; --UNCHK
lin furthermore_Adv = mkWAdv (k99 "lisäksi") "sen" ; --UNCHK
lin furthermost_A = mkWA (k36 "uloin") ; --UNCHK
lin furthest_A = mkWA (k36 "uloin") ; --UNCHK
lin furthest_Adv = mkWAdv (k99 "kauimmas") ; --UNCHK
lin furtive_A = mkWA (k38 "vaivihkainen") ; --UNCHK
lin furtiveness_N = mkWN (k40 "salamyhkäisyys") ; --UNCHK
lin furunculosis_N = mkWN (compoundN "äkämä" (k5A "tauti")) ; --UNCHK
lin fury_N = mkWN (k40 "villiys") ; --UNCHK
lin furze_N = mkWN (compoundN "piikki" (k48 "herne")) ; --UNCHK
lin fuschia_N = mkWN "fuksia" ; --UNCHK
lin fuscous_A = mkWA (k10 "tumma") ; --UNCHK
lin fuse_N = mkWN (k48A "sytyke") ; --UNCHK
lin fuse_V = mkWV (k52A "sulautua") ; --UNCHK
lin fuse_V2 = mkWV2 (k52A "sulautua") ; --UNCHK
lin fusee_N = mkWN (k48A "sytyke") ; --UNCHK
lin fuselage_N = mkWN (k1A "runko") ; --UNCHK
lin fushun_PN = foreignPN "Fushun" ;
lin fusible_A = mkWA (k10 "sulava") ; --UNCHK
lin fusiform_A = mkWA (compoundA "sikarin" (k38 "muotoinen")) ; --UNCHK
lin fusil_N = mkWN (k5A "musketti") ; --UNCHK
lin fusilier_N = mkWN (k5 "musketööri") ; --UNCHK
lin fusillade_N = mkWN (k39 "tulitus") ; --UNCHK
lin fusion_N = mkWN (k3 "fuusio") ; --UNCHK
lin fuss_N = mkWN (k39 "touhotus") ; --UNCHK
lin fuss_V = mkWV (k67 "hermoilla") ; --UNCHK
lin fuss_V2 = mkWV2 (k67 "hermoilla") ; --UNCHK
lin fussiness_N = mkWN (compoundN "pikku" (k40 "tarkkuus")) ; --UNCHK
lin fusspot_N = mkWN (k10 "valittaja") ; --UNCHK
lin fussy_A = mkWA (k41 "vaatelias") ; --UNCHK
lin fustian_N = mkWN "puuvillavakosametti" ; --UNCHK
lin fusty_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin futile_A = mkWA (k10 "tyhjä") ; --UNCHK
lin futility_N = mkWN (k40 "hyödyttömyys") ; --UNCHK
lin futon_N = mkWN "futon" ; --UNCHK
lin future_1_N = mkN "tulevaisuus" ;
lin future_3_N = mkN "futuuri" ;
lin future_A = mkWA (k10 "tuleva") ;
lin future_N = mkN "tulevaisuus" ; --- already split
lin futureless_A = mkWA "vailla" "tulevaisuutta" ; --UNCHK
lin futurism_N = mkWN (k5 "futurismi") ; --UNCHK
lin futuristFem_N = mkWN (k5 "futurologi") ; --UNCHK
lin futuristMasc_N = mkWN (k5 "futurologi") ; --UNCHK
lin futuristic_A = mkWA (k38 "futuristinen") ; --UNCHK
lin futurity_N = mkWN "futuurisuus" ; --UNCHK
lin futurology_N = mkWN (k12 "futurologia") ; --UNCHK
lin fuze_N = mkWN (k48A "sytyke") ; --UNCHK
lin fuzz_N = mkWN (k10 "haituva") ; --UNCHK
lin fuzzed_A = mkWA (k38 "nukkainen") ; --UNCHK
lin fuzzy_A = mkWA (k38 "nukkainen") ; --UNCHK
lin g_N = mkWN "g" ; --UNCHK
lin gab_N = mkWN (k39 "pälpätys") ; --UNCHK
lin gabapentin_N = mkWN "Neurontin" ; --UNCHK
lin gabardine_N = mkWN (k12 "kauhtana") ; --UNCHK
lin gabble_N = mkWN (k39 "pälpätys") ; --UNCHK
lin gabble_V = mkWV (k53A "pälättää") ; --UNCHK
lin gabble_V2 = mkWV2 (k53A "pälättää") ; --UNCHK
lin gabbro_N = mkWN (k1 "gabro") ; --UNCHK
lin gaberdine_N = mkWN (k12 "kauhtana") ; --UNCHK
lin gable_N = mkWN (k1A "pääty") ; --UNCHK
lin gabled_A = mkWA (compoundA "harjakat" (k38 "toinen")) ; --UNCHK
lin gabon_PN = foreignPN "Gabon" ;
lin gabonese_A = mkWA (compoundA "gaboni" (k38 "lainen")) ; --UNCHK
lin gabonese_N = mkWN (compoundN "gaboni" (k38 "lainen")) ; --UNCHK
lin gad_V = mkWV (k53 "piristää") ; --UNCHK
lin gadabout_N = mkWN "hurvittelija" ; --UNCHK
lin gaddi_N = mkWN "gaddi" ; --UNCHK
lin gadfly_N = mkWN (k9 "paarma") ; --UNCHK
lin gadget_N = mkWN (k5A "värkki") ; --UNCHK
lin gadgeteer_N = mkWN (k12 "keksijä") ; --UNCHK
lin gadoid_N = mkWN (k10 "turska") ; --UNCHK
lin gadolinite_N = mkWN (compoundN "gadoli" (k5A "niitti")) ; --UNCHK
lin gadolinium_N = mkWN "järjestysluku" "64" ; --UNCHK
lin gael_N = mkWN (k5 "gaeli") ; --UNCHK
lin gaelic_A = mkWA (k38 "kelttiläinen") ; --UNCHK
lin gaelic_N = mkWN (k38 "kelttiläinen") ; --UNCHK
lin gaff_N = mkWN (k6 "kahveli") ; --UNCHK
lin gaffe_N = mkWN (k40 "karkeus") ; --UNCHK
lin gaffer_N = mkWN (k4A "päällikkö") ; --UNCHK
lin gaffsail_N = mkWN (compoundN "haarukka" (k48 "purje")) ; --UNCHK
lin gag_N = mkWN (compoundN "kuono" (k10A "koppa")) ; --UNCHK
lin gag_V = mkWV (k67 "kakistella") ; --UNCHK
lin gag_V2 = mkWV2 (k67 "kakistella") ; --UNCHK
lin gaga_A = mkWA (k47 "höpsähtänyt") ; --UNCHK
lin gage_N = mkWN (k9A "mitta") ; --UNCHK
lin gage_V2 = mkWV2 (k73 "riskeerata") ; --UNCHK
lin gaggle_N = mkWN (k7 "hanhiparvi") ; --UNCHK
lin gagman_N = mkWN (compoundN "-käsi" (k10 "kirjoittaja")) "stand" "up" ; --UNCHK
lin gaiety_N = mkWN (k40 "hilpeys") ; --UNCHK
lin gaillardia_N = mkWN (compoundN "säde" (k10A "kukka")) ; --UNCHK
lin gain_N = mkN "hyöty" ;
lin gain_V = mkV "voittaa" ;
lin gain_V2 = mkV2 (mkV "voittaa") partitive ;
lin gain_back_V = advV OP_gain_V OP_back_Adv ; -- guess-p-verb
lin gainer_N = mkN "hyötyjä" ;
lin gainful_A = mkWA (k10 "tuottava") ; --UNCHK
lin gainly_A = mkWA (k41A "tyylikäs") ; --UNCHK
lin gainsay_V2 = mkWV2 (k53 "kyseenalaistaa") ; --UNCHK
lin gainsborough_N = mkWN "Thomas" "Gainsborough" ; --UNCHK
lin gainsborough_PN = foreignPN "Gainsborough" ;
lin gait_N = mkWN (k5A "käynti") ; --UNCHK
lin gaiter_N = mkWN (k39 "säärys") ; --UNCHK
lin gal_N = mkWN (k9A "likka") ; --UNCHK
lin galactagogue_N = mkWN (k48 "aine") "maidoneritystä" "stimuloiva" ; --UNCHK
lin galactic_A = mkWA "linnunrataa" "koskeva" ; --UNCHK
lin galactocele_N = mkWN (compoundN "maito" (k9 "kysta")) ; --UNCHK
lin galactose_N = mkWN "galaktoosi" ; --UNCHK
lin galactosemia_N = mkWN "galaktosemia" ; --UNCHK
lin galactosis_N = mkWN (compoundN "maidon" (k39 "eritys")) ; --UNCHK
lin galago_N = mkWN "galago" ; --UNCHK
lin galangal_N = mkWN "Cyperus" "longus" ; --UNCHK
lin galantine_N = mkWN "galantiini" ; --UNCHK
lin galashiels_PN = foreignPN "Galashiels" ;
lin galax_N = mkWN (compoundN "urceo" (k9A "lata")) "Galax" ; --UNCHK
lin galaxy_N = mkWN (k1A "joukko") "häikäisevä" ; --UNCHK
lin galbanum_N = mkWN (compoundN "galbanum-kumi" (k9 "pihka")) ; --UNCHK
lin galbulus_N = mkWN (k1A "käpy") "sypressin" ; --UNCHK
lin gale_N = mkWN (k26 "tuuli") "myrskyinen" ; --UNCHK
lin galea_N = mkWN (k10 "kypärä") ; --UNCHK
lin galena_N = mkWN (compoundN "lyijy" (k48A "hohde")) ; --UNCHK
lin galere_N = mkWN (compoundN "räkä" (k5A "sakki")) ; --UNCHK
lin galingale_N = mkWN "Cyperus" "longus" ; --UNCHK
lin gall_N = mkWN (k10A "pokka") ; --UNCHK
lin gall_V2 = mkWV2 (k73 "vaivata") ; --UNCHK
lin gallamine_N = mkWN "Flaxedil" ; --UNCHK
lin gallant_A = mkWA (k15 "urhea") ; --UNCHK
lin gallant_N = mkWN (k12 "hienostelija") ; --UNCHK
lin gallantry_N = mkWN (k40 "ritarillisuus") ; --UNCHK
lin gallbladder_N = mkWN (compoundN "sappi" (k1A "rakko")) ; --UNCHK
lin galleon_N = mkWN "kaljuuna" ; --UNCHK
lin gallery_N = mkWN (k10 "perä") ; --UNCHK
lin galley_N = mkWN (k6 "pentteri") ; --UNCHK
lin galley_proof_N = mkWN (compoundN "palsta" (k39 "vedos")) ; --UNCHK
lin galley_slave_N = mkWN (kH1 "peoni") ; --UNCHK
lin gallfly_N = mkWN (compoundN "äkämä" (k38 "hyönteinen")) ; --UNCHK
lin gallic_A = mkWA (k38 "gallialainen") ; --UNCHK
lin gallicism_N = mkWN (compoundN "gallis" (k5 "ismi")) ; --UNCHK
lin gallinaceous_A = mkWA "kanalintu-" ; --UNCHK
lin gallinule_N = mkWN (compoundN "ranta" (k9 "kana")) ; --UNCHK
lin gallium_N = mkWN "järjestysnumero" "31" ; --UNCHK
lin gallivant_V = mkWV (k53 "piristää") ; --UNCHK
lin gallon_N = mkWN (k10 "gallona") "amerikkalainen" ; --UNCHK
lin gallop_N = mkWN (kH1 "neli") ; --UNCHK
lin gallop_V = mkWV (k53 "nelistää") ; --UNCHK
lin gallop_V2 = mkWV2 (k53 "nelistää") ; --UNCHK
lin gallows_N = mkWN (compoundN "hirsi" (k18 "puu")) ; --UNCHK
lin gallows_bird_N = mkWN "hirttotuomion" "ansaitseva" ; --UNCHK
lin gallstone_N = mkWN (compoundN "sappi" (k7 "kivi")) ; --UNCHK
lin gallup_PN = foreignPN "Gallup" ;
lin galoot_N = mkWN (k39 "köntys") ; --UNCHK
lin galosh_N = mkWN (k5 "kalossi") ; --UNCHK
lin galvanic_A = mkWA (k38 "galvaaninen") ; --UNCHK
lin galvanism_N = mkWN (compoundN "sähkö" (k1A "hoito")) ; --UNCHK
lin galvanization_N = mkWN (k5A "galvanointi") ; --UNCHK
lin galvanize_V2 = mkWV2 (k62 "stimuloida") ; --UNCHK
lin galvanize_VS = mkWVS (k62 "stimuloida") ; --UNCHK
lin galvanizer_N = mkWN (k10 "innostaja") ; --UNCHK
lin galvanometer_N = mkWN (compoundN "kiertokäämi" (k6 "mittari")) ; --UNCHK
lin gam_N = mkWN (k7 "valasparvi") ; --UNCHK
lin gambia_PN = foreignPN "Gambia" ;
lin gambian_A = mkWA (compoundA "gambi" (k38 "alainen")) ; --UNCHK
lin gambian_N = mkWN (compoundN "gambi" (k38 "alainen")) ; --UNCHK
lin gambist_N = mkWN "gambisti" ; --UNCHK
lin gambit_N = mkWN (k5A "gambiitti") ; --UNCHK
lin gamble_N = mkWN (compoundN "uhka" (k5 "peli")) ;
lin gamble_V = mkWV (k73 "pelata") "uhkapeliä" ;
lin gamble_V2 = mkWV2 (k73 "pelata") "uhkapeliä" ; --UNCHK
lin gambler_N = mkWN (compoundN "uhka" (k6 "peluri")) ; --UNCHK
lin gambling_N = mkWN (compoundN "uhka" (k5 "peli")) ;
lin gambling_den_N = mkWN (compoundN "peli" (k10 "luola")) ; --UNCHK
lin gamboge_N = mkWN (compoundN "sitruunan" (k38 "keltainen")) ; --UNCHK
lin gambol_N = mkWN (k2 "hulluttelu") ; --UNCHK
lin gambol_V = mkWV (k68 "karkeloida") ; --UNCHK
lin gambrel_N = mkWN (compoundN "taite" (k1A "katto")) ; --UNCHK
lin game_1_N = mkN "peli" ;
lin game_2_N = mkN "leikki" ;
lin game_3_N = mkN "riista" ;
lin game_A = mkWA (k15 "rohkea") ; --UNCHK
lin game_N = mkWN (k5 "peli") ;
lin game_V = mkWV (k73 "riskeerata") ; --UNCHK
lin game_V2 = mkWV2 (k73 "riskeerata") ; --UNCHK
lin game_bird_N = mkWN (compoundN "riista" (k1A "lintu")) ; --UNCHK
lin game_bag_N = mkWN (compoundN "riista" (k1A "laukku")) ; --UNCHK
lin gamecock_N = mkWN (compoundN "tappelu" (k1A "kukko")) ; --UNCHK
lin gamekeeper_N = mkWN (compoundN "riistan" (k10 "valvoja")) ; --UNCHK
lin gamelan_N = mkWN (compoundN "gamelan-" (k48 "yhtye")) ; --UNCHK
lin gamesmanship_N = mkWN (k5A "taktikointi") ; --UNCHK
lin gametangium_N = mkWN "gametangium" ; --UNCHK
lin gamete_N = mkWN (k5A "gameetti") ; --UNCHK
lin gametocyte_N = mkWN "gametosyytti" ; --UNCHK
lin gametoecium_N = mkWN "gametoecium" ; --UNCHK
lin gametophore_N = mkWN "gametophore" ; --UNCHK
lin gametophyte_N = mkWN "gametofyytti" ; --UNCHK
lin gamey_A = mkWA (k15 "rohkea") ; --UNCHK
lin gamine_N = mkWN (k1A "tyttö") "ilkikurinen" ; --UNCHK
lin gaminess_N = mkWN (k40 "ruokottomuus") ; --UNCHK
lin gaming_N = mkN "pelaaminen" ;
lin gaming_house_N = mkWN (compoundN "peli" (k10 "luola")) ; --UNCHK
lin gaming_table_N = mkWN (compoundN "peli" (k10A "pöytä")) ; --UNCHK
lin gamma_N = mkWN (k9 "gamma") ; --UNCHK
lin gammon_N = mkWN (compoundN "taka" (k10 "osa")) "siankyljen" ; --UNCHK
lin gammopathy_N = mkWN "gammopatia" ; --UNCHK
lin gamp_N = mkWN (k10 "sontsa") ; --UNCHK
lin gamut_N = mkWN (k1 "kirjo") ; --UNCHK
lin gamy_A = mkWA (k15 "rohkea") ; --UNCHK
lin gander_N = mkWN (compoundN "uros" (k7 "hanhi")) ; --UNCHK
lin gang_N = mkWN (compoundN "työkalu" (k9A "kerta")) ; --UNCHK
lin gang_V = mkWV (k53 "muodostaa") "jengi" ; --UNCHK
lin gang_up_V = mkWV (k53 "muodostaa") "jengi" ; --UNCHK
lin ganger_N = mkWN (compoundN "työn" (k10 "johtaja")) ; --UNCHK
lin ganglion_N = mkWN (k3 "ganglio") ; --UNCHK
lin gangplank_N = mkWN (k5A "lankonki") ; --UNCHK
lin gangrene_N = mkWN (k5 "nekroosi") ; --UNCHK
lin gangrene_V = mkWV (k52A "kuolioitua") ; --UNCHK
lin gangrene_V2 = mkWV2 (k52A "kuolioitua") ; --UNCHK
lin gangrenous_A = mkWA (k38 "kuolioinen") ; --UNCHK
lin gangsaw_N = mkWN (compoundN "kehys" (k9 "saha")) ; --UNCHK
lin gangsta_N = mkWN (k38 "jengiläinen") ; --UNCHK
lin gangster_N = mkWN (k38 "jengiläinen") ; --UNCHK
lin gangway_N = mkWN (k10 "käytävä") ; --UNCHK
lin gannet_N = mkWN (k10 "suula") ; --UNCHK
lin ganoid_N = mkWN (k9 "kala") "kiillesuomuinen" ; --UNCHK
lin ganoin_N = mkWN (compoundN "kiille" (k1 "suomu")) ; --UNCHK
lin gantlet_N = mkWN (compoundN "kujan" (k1 "juoksu")) ; --UNCHK
lin gantry_N = mkWN (compoundN "silta" (k6 "nosturi")) ; --UNCHK
lin gaol_N = mkWN (k10 "putka") ; --UNCHK
lin gaolbird_N = mkWN (compoundN "vankila" (k5 "kundi")) ; --UNCHK
lin gaolbreak_N = mkWN (k1A "pako") ; --UNCHK
lin gaoler_N = mkWN (kH1 "pamppu") ; --UNCHK
lin gap_N = mkWN (k5 "väli") ;
lin gape_N = mkWN (k2 "töllistely") ; --UNCHK
lin gape_V = mkWV (k67 "töllistellä") ; --UNCHK
lin gar_N = mkWN (compoundN "purje" (k9 "kala")) ; --UNCHK
lin garage_N = mkN "auto" (mkN "talli") ;
lin garage_V2 = mkWV2 (k53A "pitää") "autotallissa" ; --UNCHK
lin garambulla_N = mkWN (k10 "karambola") ; --UNCHK
lin garb_N = mkWN (k1A "puku") ; --UNCHK
lin garb_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin garbage_N = mkN "jäte" ;
lin garbage_can_N = mkWN (k39 "roskis") ; --UNCHK
lin garble_V2 = mkWV2 (k53 "vääristää") ; --UNCHK
lin garboard_N = mkWN (compoundN "köli" (k1A "lankku")) ; --UNCHK
lin garbology_N = mkWN (compoundN "jätteiden" (k39 "tutkimus")) ; --UNCHK
lin garden_N = L.garden_N ;
lin garden_V = mkWV (k53A "hoitaa") "puutarhaa" ; --UNCHK
lin garden_truck_N = mkWN (k1A "sato") ; --UNCHK
lin gardenerFem_N = mkWN (k6 "puutarhuri") ; --UNCHK
lin gardenerMasc_N = variants {} ; --
lin gardenia_N = mkWN (k12 "gardenia") ; --UNCHK
lin gardening_N = mkWN (compoundN "puutarhan" (k2 "viljely")) ; --UNCHK
lin garforth_PN = foreignPN "Garforth" ;
lin garganey_N = mkWN (compoundN "heinä" (k5 "tavi")) ; --UNCHK
lin gargantuan_A = mkWA (k10 "valtava") ; --UNCHK
lin gargle_N = mkWN (k39 "kurlaus") ; --UNCHK
lin gargle_V = mkWV (k67A "huuhdella") ; --UNCHK
lin gargle_V2 = mkWV2 (k67A "huuhdella") ; --UNCHK
lin gargoyle_N = mkWN (compoundN "kattokour" (k10 "ussa")) "irvokas" "veistos" ; --UNCHK
lin garish_A = mkWA (k15 "pramea") ; --UNCHK
lin garishness_N = mkWN (k40 "räikeys") ; --UNCHK
lin garland_N = mkWN (k5 "kranssi") ; --UNCHK
lin garland_V2 = mkWV2 (k67 "koristella") "kukkaköynnöksin" ; --UNCHK
lin garlic_N = mkWN (k9A "kynsilaukka") ; --UNCHK
lin garlicky_A = mkWA (compoundA "valkosipuli" (k38 "nen")) ; --UNCHK
lin garment_N = mkWN (k48A "vaate") ; --UNCHK
lin garmentmaker_N = mkWN (compoundN "tekstiilityön" (k12 "tekijä")) ; --UNCHK
lin garner_N = mkWN (k9A "aitta") ; --UNCHK
lin garner_V2 = mkV2 "haalia" partitive ; --mkWV2 (k53 "yhdistää") ;
lin garnet_N = mkWN (k5A "granaatti") ; --UNCHK
lin garnierite_N = mkWN (compoundN "garnie" (k5A "riitti")) ; --UNCHK
lin garnish_N = mkWN (k48 "koriste") ; --UNCHK
lin garnish_V2 = mkWV2 (k67 "koristella") ; --UNCHK
lin garnishee_N = mkWN (compoundN "tertius" (k38 "velallinen")) ; --UNCHK
lin garnishment_N = mkWN (compoundN "palkan" (k39 "pidätys")) ; --UNCHK
lin garotte_N = mkWN (compoundN "rauta" (k9A "lanka")) ; --UNCHK
lin garret_N = mkWN (k7 "parvi") ; --UNCHK
lin garrison_N = mkWN (k10A "tukikohta") ; --UNCHK
lin garrote_N = mkWN (compoundN "rauta" (k9A "lanka")) ; --UNCHK
lin garroter_N = mkWN (k10 "kuristaja") ; --UNCHK
lin garrotte_N = mkWN (compoundN "rauta" (k9A "lanka")) ; --UNCHK
lin garrulity_N = mkWN (k40 "suulaus") ; --UNCHK
lin garrulous_A = mkWA (k41 "puhelias") ; --UNCHK
lin garter_N = mkWN (compoundN "sukka" (k9 "nauha")) ; --UNCHK
lin gary_PN = foreignPN "Gary" ;
lin gas_N = mkWN (k1 "kaasu") | mkN "bensiini" | mkN "bensa" ; ---- split liquid or gas ; gasoline
lin gas_V = mkWV (k67A "rehennellä") ; --UNCHK
lin gas_V2 = mkWV2 (k67A "rehennellä") ; --UNCHK
lin gas_bracket_N = mkWN (compoundN "kaasu" (k33A "suutin")) ; --UNCHK
lin gas_cooker_N = mkWN (compoundN "kaasu" (k33A "keitin")) ; --UNCHK
lin gas_engine_N = mkWN (compoundN "kaasu" (k6 "moottori")) ; --UNCHK
lin gas_fitter_N = mkWN (compoundN "kaasu" (k10 "asentaja")) ; --UNCHK
lin gas_helmet_N = mkWN (compoundN "hengitys" (k33 "suojain")) ; --UNCHK
lin gas_holder_N = mkWN (compoundN "kaasu" (k1 "kello")) ; --UNCHK
lin gas_meter_N = mkWN (compoundN "kaasu" (k1 "kello")) ; --UNCHK
lin gas_oven_N = mkWN (compoundN "kaasu-" (k5 "uuni")) ; --UNCHK
lin gas_ring_N = mkWN (compoundN "rengas" (k33A "poltin")) ; --UNCHK
lin gas_station_N = mkWN (compoundN "bensiini" (k10 "asema")) ; --UNCHK
lin gas_stove_N = mkWN (compoundN "kaasu" (k33A "keitin")) ; --UNCHK
lin gasbag_N = mkWN (compoundN "kaasu" (k3 "säiliö")) ; --UNCHK
lin gaseous_A = mkWA (k38 "kaasumainen") ; --UNCHK
lin gaseousness_N = mkWN "kaasu-" ; --UNCHK
lin gasfield_N = mkWN (compoundN "kaasu" (k10A "kenttä")) ; --UNCHK
lin gash_V2 = mkWV2 (k53 "yksilöllistää") ; --UNCHK
lin gasification_N = mkWN "kaasuunnutus" ; --UNCHK
lin gasket_N = mkWN (k48 "tiiviste") ; --UNCHK
lin gaskin_N = mkWN (compoundN "taka" (k27 "reisi")) "hevosen" ; --UNCHK
lin gaslight_N = mkWN (compoundN "kaasu" (k1 "valo")) ; --UNCHK
lin gasman_N = mkWN (k12 "lukija") "kaasumittarin" ; --UNCHK
lin gas_mask_N = mkWN (compoundN "hengitys" (k33 "suojain")) ; --UNCHK
lin gasohol_N = mkWN "gasoholi" ; --UNCHK
lin gasolene_N = mkWN (k9 "bensa") ; --UNCHK
lin gasoline_N = mkN "bensiini" ;
lin gasometer_N = mkWN (compoundN "kaasu" (k1 "kello")) ; --UNCHK
lin gasp_N = mkWN (k1A "hengenveto") "nopea" ; --UNCHK
lin gasp_V = mkWV (k53A "läähättää") ; --UNCHK
lin gasp_V2 = mkWV2 (k53A "läähättää") ; --UNCHK
lin gassing_N = mkWN (k39 "kaasutus") ; --UNCHK
lin gassy_A = mkWA "kaasu-" ; --UNCHK
lin gasteromycete_N = mkWN (compoundN "gastromycete-" (k26 "sieni")) ; --UNCHK
lin gastric_A = mkWA "vatsa-" ; --UNCHK
lin gastrin_N = mkWN "gastriini" ; --UNCHK
lin gastritis_N = mkWN (compoundN "maha" (k5 "katarri")) ; --UNCHK
lin gastrocnemius_N = mkWN (compoundN "kaksoiskanta" (k39 "lihas")) ; --UNCHK
lin gastroduodenal_A = mkWA "maha-pohjukaissuoli-" ; --UNCHK
lin gastroenterologistFem_N = variants {} ; ---- sense to be split
lin gastroenterologistMasc_N = mkWN "gastroenterologi" ; --UNCHK
lin gastroenterology_N = mkWN "gastroenterologia" ; --UNCHK
lin gastroesophageal_A = mkWA (compoundA "gastroesofagea" (k38 "alinen")) ; --UNCHK
lin gastrointestinal_A = mkWA (compoundA "gastrointestina" (k38 "alinen")) ; --UNCHK
lin gastromy_N = mkWN (compoundN "gastr" (k61 "omia")) ; --UNCHK
lin gastronomic_A = mkWA (k38 "gastronominen") ; --UNCHK
lin gastronomy_N = mkWN (k12 "gastronomia") ; --UNCHK
lin gastropod_N = mkWN (k2 "kotilo") ; --UNCHK
lin gastroscope_N = mkWN (compoundN "maha" (k33 "tähystin")) ; --UNCHK
lin gastroscopy_N = mkWN "gastroskopia" ; --UNCHK
lin gastrula_N = mkWN (k12 "gastrula") ; --UNCHK
lin gastrulation_N = mkWN "gastrulaatio" ; --UNCHK
lin gasworks_N = mkWN (compoundN "kaasu" (k39 "laitos")) ; --UNCHK
lin gat_N = mkWN (k1 "pyssy") ; --UNCHK
lin gate_N = mkWN (k5A "portti") ; --UNCHK
lin gate_V2 = mkWV2 (k56A "antaa") "poistumiskielto" ; --UNCHK
lin gateau_N = mkWN (k1A "kakku") ; --UNCHK
lin gatecrasher_N = mkWN (k41 "vieras") "ei-toivottu" ; --UNCHK
lin gatehouse_N = mkWN (k1 "talo") "portinvartijan" ; --UNCHK
lin gatekeeper_N = mkWN (compoundN "portti" (k5A "vahti")) ; --UNCHK
lin gatepost_N = mkWN (compoundN "portin" (k26 "pieli")) ; --UNCHK
lin gateshead_PN = foreignPN "Gateshead" ;
lin gateway_N = mkWN (compoundN "portti" (k10 "käytävä")) ; --UNCHK
lin gather_N = mkWN (compoundN "koko" (k38 "aminen")) ; --UNCHK
lin gather_V = mkV "kerääntyä" ;
lin gather_V2 = mkV2 "koota" ;
lin gatherer_N = mkWN (k10 "kerääjä") ; --UNCHK
lin gathering_N = mkWN (compoundN "koko" (k38 "aminen")) ; --UNCHK
lin gatt_N = mkWN "GATT" ; --UNCHK
lin gauche_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin gaucherie_N = mkWN (k40 "karkeus") ; --UNCHK
lin gaucho_N = mkWN (k1 "gaucho") ; --UNCHK
lin gaud_N = mkWN (k1 "koru") ; --UNCHK
lin gaudery_N = mkWN (k2 "prameilu") ; --UNCHK
lin gaudy_A = mkWA (k15 "upea") ; --UNCHK
lin gaudy_N = mkWN (compoundN "vuosi" (k10 "juhla")) ; --UNCHK
lin gauge_N = mkWN (k9A "mitta") ; --UNCHK
lin gauge_V2 = mkV2 (mkV "arvioida") partitive ;
lin gaul_N = mkWN "Gallia" ; --UNCHK
lin gaumless_A = mkWA (k10 "tyhmä") ; --UNCHK
lin gaunt_A = mkWA (k38 "näköinen") "sairaalloisen" ; --UNCHK
lin gauntlet_N = mkWN (compoundN "kujan" (k1 "juoksu")) ; --UNCHK
lin gauntleted_A = mkWA "suojakäsinettä" "käyttävä" ; --UNCHK
lin gauntness_N = mkWN (k40 "laihuus") ; --UNCHK
lin gaur_N = mkWN (compoundN "gaur-" (k10A "härkä")) ; --UNCHK
lin gauze_N = mkWN (k1 "harso") ; --UNCHK
lin gauzy_A = mkWA (k43 "ohut") ; --UNCHK
lin gavel_N = mkWN (k10 "nuija") ; --UNCHK
lin gavotte_N = mkWN "gavotti" ; --UNCHK
lin gawk_N = mkWN (k2 "tohelo") ; --UNCHK
lin gawker_N = mkWN (k12 "töllistelijä") ; --UNCHK
lin gawkiness_N = mkWN (k40 "kömpelyys") ; --UNCHK
lin gawky_A = mkWA (k34A "taipumaton") ; --UNCHK
lin gawp_V = mkWV (k67 "töllistellä") ; --UNCHK
lin gay_A = mkWA (k38 "aurinkoinen") ; --UNCHK
lin gay_N = mkWN (k21 "gay") ; --UNCHK
lin gayness_N = mkWN (k40 "lesbous") ; --UNCHK
lin gazania_N = mkWN "gazania" ; --UNCHK
lin gaze_N = mkWN (k48 "katse") ; --UNCHK
lin gaze_V = mkWV (k53A "tuijottaa") ; --UNCHK
lin gazebo_N = mkWN (compoundN "huvi" (k9 "maja")) ; --UNCHK
lin gazelle_N = mkWN (k6 "gaselli") ; --UNCHK
lin gazette_N = mkWN (k7A "lehti") "virallinen" ; --UNCHK
lin gazetteer_N = mkWN (k1 "hakemisto") "karttakirjan" ; --UNCHK
lin gazpacho_N = mkWN "gazpacho" ; --UNCHK
lin gcse_N = mkWN "O" "level" ; --UNCHK
lin gean_N = mkWN (compoundN "mazzard-" (k14A "kirsikka")) ; --UNCHK
lin gear_N = mkWN (k41A "ratas") ;
lin gear_V = mkWV (k52A "varustautua") ; --UNCHK
lin gear_V2 = mkWV2 (k53 "kohdistaa") allative ;
lin gear_case_N = mkWN (k1 "vaihteisto") ; --UNCHK
lin gear_up_V = mkWV (k52A "varautua") ; --UNCHK
lin gearbox_N = mkWN (k1 "vaihteisto") ; --UNCHK
lin gearing_N = mkWN (k48A "vaihde") ; --UNCHK
lin gearshift_N = mkWN (compoundN "vaihde" (k5A "keppi")) ; --UNCHK
lin gecko_N = mkWN "gekko" ; --UNCHK
lin geebung_N = mkWN (k18 "puu") "Persoonia-suvun" ; --UNCHK
lin geek_N = mkWN (k5A "friikki") ; --UNCHK
lin geezer_N = mkWN (k10 "äijä") ; --UNCHK
lin geiger_N = mkWN "Hans" "Geiger" ; --UNCHK
lin geisha_N = mkWN (k9 "geiša") ; --UNCHK
lin gel_N = mkWN (compoundN "geeli" (k1 "kalvo")) ; --UNCHK
lin gel_V = mkWV (k53A "levittää") "geeliä" ; --UNCHK
lin gelatin_N = mkWN (compoundN "geeli" (k1 "kalvo")) ; --UNCHK
lin gelatine_N = mkWN (k48A "liivate") ; --UNCHK
lin gelatinous_A = mkWA (compoundA "gelatiini" (k38 "nen")) ; --UNCHK
lin gelatinousness_N = mkWN (compoundN "hyytelömä" (k40 "isyys")) ; --UNCHK
lin geld_V2 = mkWV2 (k56 "salvaa") ; --UNCHK
lin gelding_N = mkWN (k14A "valakka") ; --UNCHK
lin gelechiid_N = mkWN (k18 "gelechiid-koi") ; --UNCHK
lin gelignite_N = mkWN (compoundN "gelig" (k5A "niitti")) ; --UNCHK
lin gelligaer_PN = foreignPN "Gelligaer" ;
lin gelsenkirchen_PN = foreignPN "Gelsenkirchen" ;
lin gem_N = mkWN (compoundN "taide" (k48A "aarre")) ; --UNCHK
lin gemfibrozil_N = mkWN (k5 "gemfibrotsiili") ; --UNCHK
lin geminate_N = mkWN (k9A "geminaatta") ; --UNCHK
lin gemination_N = mkWN (k5A "kopiointi") ; --UNCHK
lin gemini_PN = foreignPN "Gemini" ;
lin gemma_N = mkWN (k1 "silmu") ; --UNCHK
lin gemmed_A = mkWA (compoundA "jalo" (k38 "kivikoristeinen")) ; --UNCHK
lin gemmiferous_A = mkWA (compoundA "silmuk" (k10 "oiva")) ; --UNCHK
lin gemmule_N = mkWN (compoundN "pan" (k5 "geeni")) ; --UNCHK
lin gempylid_N = mkWN (compoundN "käärme" (k5 "makrilli")) ; --UNCHK
lin gemsbok_N = mkWN (compoundN "keihäs" (k5A "antilooppi")) ; --UNCHK
lin gen_N = mkWN (k1A "tieto") ; --UNCHK
lin gendarme_N = mkWN (k5 "santarmi") ; --UNCHK
lin gendarmerie_N = mkWN (compoundN "poliisi" (k10 "asema")) ; --UNCHK
lin gender_1_N = mkWN (k40 "sukupuolisuus") ; --UNCHK
lin gender_2_N = mkWN (k40 "sukupuolisuus") ; --UNCHK
lin gene_N = mkWN (k5 "geeni") ; --f99
lin genealogic_A = mkWA "genealoginen" ; --UNCHK
lin genealogical_A = mkWA "genealoginen" ; --UNCHK
lin genealogist_N = mkWN "genealogi" ; --UNCHK
lin genealogy_N = mkWN (k12 "genealogia") ; --UNCHK
lin general_A = mkA "yleinen" ;
lin general_N = mkWN (k38 "yleinen") ;
lin generalissimo_N = mkWN (k10 "komentaja") "puolustusvoimien" ; --UNCHK
lin generality_N = mkWN (k40 "yleisyys") ; --UNCHK
lin generalization_N = mkWN (k39 "yleistys") ; --UNCHK
lin generalize_V = mkV "yleistyä" ; --mkWV (k75 "levitä") ;
lin generalize_V2 = mkV2 "yleistää" ; --mkWV2 (k75 "levitä") ;
lin generally_Adv = mkAdv "yleisesti" | adjAdv general_A ; -- derived
lin generalship_N = mkWN "kenraaliesikunta" ; --UNCHK
lin generate_V2 = mkV2 "tuottaa" ; --f73
lin generation_N = mkN "suku" (mkN "polvi") ; --f62
lin generational_A = mkWA "sukupolvi-" ; --UNCHK
lin generative_A = mkWA (k10 "tuottoisa") ; --UNCHK
lin generator_N = mkWN (k6 "generaattori") ;
lin generic_A = mkA (mkN "yleis" (mkN "pätevä")) ;
lin generic_N = mkWN (k48A "tuote") "rekisteröimätön" ; --UNCHK
lin generosity_N = mkWN (k40 "anteliaisuus") ; --UNCHK
lin generous_A = mkWA (k1 "reilu") ; --UNCHK
lin genesis_N = mkWN (k9 "kirja") "Ensimmäinen" "Mooseksen" ; --UNCHK
lin genet_N = mkWN "Genetta" "genetta" ; --UNCHK
lin genetic_A = mkA "perinnöllinen" ; ---ARB mkWA (k38 "geneettinen") ;
lin geneticist_N = mkWN (k4A "geneetikko") ; --UNCHK
lin genetics_N = mkWN (k9A "genetiikka") ; --UNCHK
lin geneva_N = mkWN (compoundN "gene" (k26 "veri")) ; --UNCHK
lin geneva_PN = foreignPN "Geneva" ;
lin genial_A = mkWA (k38 "mentaalinen") ; --UNCHK
lin geniality_N = mkWN (k40 "sydämellisyys") ; --UNCHK
lin genic_A = mkWA (k38 "geneettinen") ; --UNCHK
lin geniculate_A = mkWA (compoundA "tai" (k47 "punut")) "terävään" "kulmaan" ; --UNCHK
lin genie_N = mkWN (k7A "henki") ; --UNCHK
lin genip_N = mkWN "genip" ; --UNCHK
lin genipa_N = mkWN "genipa" ; --UNCHK
lin genipap_N = mkWN (compoundN "genipap-" (k10 "hedelmä")) ; --UNCHK
lin genital_A = mkWA (k38 "veneerinen") ; --UNCHK
lin genitive_A = mkWA "genetiivi-" ; --UNCHK
lin genitive_N = mkWN (k5 "genetiivi") ; --UNCHK
lin genitor_N = mkWN (k16A "vanhempi") "biologinen" ; --UNCHK
lin genitourinary_A = mkWA (compoundA "genitourina" (k38 "alinen")) ; --UNCHK
lin genius_N = mkWN (k40 "nerokkuus") ; --UNCHK
lin genius_loci_N = mkWN (k7A "henki") "paikan" ; --UNCHK
lin genlisea_N = mkWN "genlisea" ; --UNCHK
lin genoa_PN = foreignPN "Genova" ;
lin genocide_N = mkWN (k9A "joukkotuhonta") ; --UNCHK
lin genoise_N = mkWN (compoundN "genoise-" (k1A "kakku")) ; --UNCHK
lin genome_N = mkWN (k10 "perimä") ; --UNCHK
lin genomics_N = mkWN (compoundN "genomi" (k39 "tutkimus")) ; --UNCHK
lin genotype_N = mkWN (k3 "konstituutio") "geneettinen" ; --UNCHK
lin genotypical_A = mkWA (compoundA "geno" (k38 "tyyppinen")) ; --UNCHK
lin genre_N = mkWN (compoundN "tyyli" (k5 "laji")) ; --UNCHK
lin genre_painting_N = mkWN (k39 "laatukuvamaalaus") ; --UNCHK
lin gentamicin_N = mkWN "Garamycin" ; --UNCHK
lin genteel_A = mkWA (k1 "hieno") ; --UNCHK
lin gentian_N = mkWN (k2 "katkero") ; --UNCHK
lin gentianella_N = mkWN (compoundN "alppi" (k2 "katkero")) ; --UNCHK
lin gentile_A = mkWA (compoundA "ei-" (k38 "juutalainen")) ; --UNCHK
lin gentile_N = mkWN (compoundN "ei-" (k38 "juutalainen")) ; --UNCHK
lin gentility_N = mkWN (k40 "sivistyneisyys") ; --UNCHK
lin gentle_A = mkA "lempeä" ; --mkWA (k38 "vähittäinen") ;
lin gentlefolk_N = mkWN (compoundN "herras" (k7A "väki")) ; --UNCHK
lin gentleman_N = mkWN (compoundN "herras" (k42 "mies")) ; --UNCHK
lin gentleness_N = mkWN (k40 "lempeys") ; --UNCHK
lin gentlewoman_N = mkWN (k5 "daami") ; --UNCHK
lin gentrification_N = mkWN (k1 "nousu") "asuinalueen" "arvostuksen" ; --UNCHK
lin gentry_N = mkWN (k1 "ylimystö") ; --UNCHK
lin genuflect_V = mkWV (k54A "kumartaa") "syvään" ; --UNCHK
lin genuflection_N = mkWN (compoundN "polvi" (k38 "stuminen")) ; --UNCHK
lin genuflexion_N = mkWN (compoundN "polvi" (k38 "stuminen")) ; --UNCHK
lin genuine_A = mkWA (k1A "aito") ; --UNCHK
lin genuineness_N = mkWN (k40 "oikeellisuus") ; --UNCHK
lin genus_N = mkWN (k5 "laji") ; --UNCHK
lin geocentric_A = mkWA (k38 "geosentrinen") ; --UNCHK
lin geochemistry_N = mkWN (compoundN "geo" (k12 "kemia")) ; --UNCHK
lin geode_N = mkWN "geodi" ; --UNCHK
lin geodesic_N = mkWN (k9 "viiva") "geodeettinen" ; --UNCHK
lin geodesy_N = mkWN (k12 "geodesia") ; --UNCHK
lin geodetic_A = mkWA (k38 "geodeettinen") ; --UNCHK
lin geoduck_N = mkWN (compoundN "geoduck-" (k14A "simpukka")) ; --UNCHK
lin geographer_N = mkWN (compoundN "maan" (k12 "tieteilijä")) ; --UNCHK
lin geographic_A = mkWA (compoundA "maan" (k38 "tieteellinen")) ; --UNCHK
lin geographical_A = mkWA (compoundA "maan" (k38 "tieteellinen")) ; --UNCHK
lin geography_N = mkWN (compoundN "maan" (k1A "tieto")) ;
lin geological_A = mkWA (k38 "geologinen") ; --UNCHK
lin geologistFem_N = mkWN (k5 "geologi") ; --UNCHK
lin geologistMasc_N = mkWN (k5 "geologi") ; --UNCHK
lin geology_N = mkWN (k12 "geologia") ; --UNCHK
lin geomancer_N = mkWN "geomantikko" ; --UNCHK
lin geomancy_N = mkWN "geomantia" ; --UNCHK
lin geometric_A = mkWA (k38 "geometrinen") ; --UNCHK
lin geometrical_A = mkWA (k38 "geometrinen") ; --UNCHK
lin geometrid_N = mkWN (compoundN "mittari" (k38 "perhonen")) ; --UNCHK
lin geometry_N = mkWN (k12 "geometria") ; --UNCHK
lin geomorphologic_A = mkWA (k38 "morfologinen") ; --UNCHK
lin geophagy_N = mkWN "geofagia" ; --UNCHK
lin geophysical_A = mkWA (compoundA "geo" (k38 "fyysinen")) ; --UNCHK
lin geophysicist_N = mkWN (compoundN "geo" (k4A "fyysikko")) ; --UNCHK
lin geophysics_N = mkWN (k48A "tiede") "geofyysinen" ; --UNCHK
lin geophyte_N = mkWN (compoundN "piilo" (k12 "talvehtija")) ; --UNCHK
lin geophytic_A = mkWA (compoundA "piilotalveht" (k9 "iva")) ; --UNCHK
lin geopolitical_A = mkWA (compoundA "geo" (k38 "poliittinen")) ; --UNCHK
lin geopolitics_N = mkWN (compoundN "maan" (k48A "tiede")) "poliittinen" ; --UNCHK
lin geordie_N = mkWN "geordie" ; --UNCHK
lin george_PN = foreignPN "George" ;
lin georgette_N = mkWN (k41A "georgette-kangas") ; --UNCHK
lin georgia_PN = foreignPN "Georgia" ;
lin georgian_A = mkWA "georgiaanisen" "aikakauden" ; --UNCHK
lin georgian_N = mkWN "Georgia" ; --UNCHK
lin geostationary_A = mkWA "geostationaarinen" ; --UNCHK
lin geostrategic_A = mkWA (compoundA "geo" (k38 "strateginen")) ; --UNCHK
lin geostrategy_N = mkWN (compoundN "geo" (k12 "strategia")) ; --UNCHK
lin geosynchronous_A = mkWA (compoundA "geo" (k38 "synkroninen")) ; --UNCHK
lin geothermal_A = mkWA (compoundA "geo" (k38 "terminen")) ; --UNCHK
lin geotropism_N = mkWN (compoundN "geo" (k5 "tropismi")) ; --UNCHK
lin gerald_PN = foreignPN "Gerald" ;
lin geranium_N = mkWN (compoundN "kurjenp" (k5 "olvi")) ; --UNCHK
lin gerardia_N = mkWN (compoundN "gerar" (k9 "dia")) ; --UNCHK
lin gerbil_N = mkWN (k5 "gerbiili") ; --UNCHK
lin gerenuk_N = mkWN (compoundN "kirahvi" (k5A "antilooppi")) ; --UNCHK
lin geriatric_A = mkWA (k38 "gerontologinen") ; --UNCHK
lin geriatrician_N = mkWN "gerontologi" ; --UNCHK
lin geriatrics_N = mkWN (k12 "gerontologia") ; --UNCHK
lin germ_N = mkWN (k6 "bakteeri") ; --UNCHK
lin germanFem_N = mkN "saksalainen" ;
lin germanMasc_N = mkN "saksalainen" ;
lin german_A = mkA "saksalainen" ;
lin germander_N = mkWN "germander" ; --UNCHK
lin germane_A = mkWA (k5A "relevantti") ; --UNCHK
lin germaneness_N = mkWN (compoundN "asiaan" (k40 "kuuluvuus")) ; --UNCHK
lin germanic_A = mkWA (k38 "germaaninen") ; --UNCHK
lin germanite_N = mkWN (compoundN "germ" (k5A "aniitti")) ; --UNCHK
lin germanium_N = mkWN "järjestysluku" "32" ; --UNCHK
lin germany_PN = foreignPN "Saksa" ;
lin germfree_A = mkWA "mikrobiton" ; --UNCHK
lin germicide_N = mkWN (compoundN "mikrobi" (k48A "lääke")) ; --UNCHK
lin germinal_A = mkWA (compoundA "germina" (k38 "alinen")) ; --UNCHK
lin germinate_V = mkWV (k53 "orastaa") ; --UNCHK
lin germinate_V2 = mkWV2 (k53 "orastaa") ; --UNCHK
lin germination_N = mkWN (compoundN "itä" (k38 "minen")) ; --UNCHK
lin germy_A = mkWA "basilleja" "sisältävä" ; --UNCHK
lin gerontologist_N = mkWN "gerontologi" ; --UNCHK
lin gerontology_N = mkWN (k12 "gerontologia") ; --UNCHK
lin gerund_N = mkWN "gerundi" ; --UNCHK
lin gerundial_A = mkWA "gerundi-" ; --UNCHK
lin gesneria_N = mkWN "gesneria" ; --UNCHK
lin gesneriad_N = mkWN (compoundN "gesneriad-" (k5 "kasvi")) ; --UNCHK
lin gesso_N = mkWN (compoundN "kipsi" (k9A "pinta")) "imevä" ; --UNCHK
lin gestalt_N = mkWN (k1 "hahmo") ; --UNCHK
lin gestapo_N = mkWN "Gestapo" ; --UNCHK
lin gestation_N = mkWN (k2 "kypsyttely") ; --UNCHK
lin gestational_A = mkWA "raskaus-" ; --UNCHK
lin gesticulate_V = mkWV (k52A "viittoa") ; --UNCHK
lin gesticulation_N = mkWN (k9A "elehdintä") ; --UNCHK
lin gestural_A = mkWA (k34A "sanaton") ; --UNCHK
lin gesture_N = mkWN (k48 "ele") ;
lin gesture_V = mkWV (k52A "viittoa") ; --UNCHK
lin get_V2 = mkV2 (mkV "saada") ;
lin get_V2V = mkV2V (mkV "saada") accusative infIllat ;
lin get_VV = mkVV "päätyä" infIllat ;
lin get_about_V = advV (lin V OP_get_V2) OP_about_Adv ; -- guess-p-verb
lin get_above_V2 = prepV2 (lin V OP_get_V2) OP_above_Prep ; -- guess-p-verb
lin get_across_V = mkWV (k52 "paljastua") ; --UNCHK
lin get_across_V2 = mkWV2 (k52 "paljastua") ; --UNCHK
lin get_across_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_across_Adv ) OP_to_Prep ; -- guess-p-verb
lin get_after_V2 = prepV2 (lin V OP_get_V2) OP_after_Prep ; -- guess-p-verb
lin get_ahead_V = mkWV (k63 "saada") "jalansijaa" ; --UNCHK
lin get_ahead_of_V2 = prepV2 (advV (lin V OP_get_V2) OP_ahead_Adv ) OP_of_Prep ; -- guess-p-verb
lin get_along_V = mkWV (k52A "kehittyä") ; --UNCHK
lin get_along_in_V2 = prepV2 (advV (lin V OP_get_V2) OP_along_Adv ) OP_in_Prep ; -- guess-p-verb
lin get_along_with_V2 = mkWV2 (k67 "tulla") "toimeen" ; --UNCHK
lin get_around_V = mkWV (k53A "sivuuttaa") ; --UNCHK
lin get_around_V2 = mkWV2 (k53A "sivuuttaa") ; --UNCHK
lin get_around_to_V2 = mkWV2 (k63 "saada") "aikaiseksi" ; --UNCHK
lin get_at_V2 = mkWV2 (k53A "ottaa") "päähän" ; --UNCHK
lin get_away_V = mkWV (k75 "selvitä") ; --UNCHK
lin get_away_from_V2 = prepV2 (advV (lin V OP_get_V2) OP_away_Adv ) OP_from_Prep ; -- guess-p-verb
lin get_away_with_V2 = prepV2 (advV (lin V OP_get_V2) OP_away_Adv ) OP_with_Prep ; -- guess-p-verb
lin get_back_V = mkWV (k56 "maksaa") "takaisin" ; --UNCHK
lin get_back_V2 = mkWV2 (k56 "maksaa") "takaisin" ; --UNCHK
lin get_back_at_V2 = prepV2 (advV (lin V OP_get_V2) OP_back_Adv ) OP_at_Prep ; -- guess-p-verb
lin get_back_into_V2 = prepV2 (advV (lin V OP_get_V2) OP_back_Adv ) OP_into_Prep ; -- guess-p-verb
lin get_back_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_back_Adv ) OP_to_Prep ; -- guess-p-verb
lin get_back_together_V = variants {} ; -- guess-p-verb
lin get_behind_V2 = mkWV2 (k73 "laahata") "perässä" ; --UNCHK
lin get_behind_with_V2 = prepV2 (advV (lin V OP_get_V2) OP_behind_Adv ) OP_with_Prep ; -- guess-p-verb
lin get_by_V = mkWV (k75 "selvitä") ; --UNCHK
lin get_by_V2 = mkWV2 (k75 "selvitä") ; --UNCHK
lin get_by_on_V2 = prepV2 (advV (lin V OP_get_V2) OP_by_Adv ) OP_on_Prep ; -- guess-p-verb
lin get_by_with_V2 = prepV2 (advV (lin V OP_get_V2) OP_by_Adv ) OP_with_Prep ; -- guess-p-verb
lin get_down_V = advV (lin V OP_get_V2) OP_down_Adv ; -- guess-p-verb
lin get_down_V2 = prepV2 (lin V OP_get_V2) OP_down_Prep ; -- guess-p-verb
lin get_down_on_V2 = prepV2 (advV (lin V OP_get_V2) OP_down_Adv ) OP_on_Prep ; -- guess-p-verb
lin get_down_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_down_Adv ) OP_to_Prep ; -- guess-p-verb
lin get_even_V = advV (lin V OP_get_V2) OP_even_Adv ; -- guess-p-verb
lin get_in_V = mkWV (k52A "saapua") "asemalle" ; --UNCHK
lin get_in_V2 = mkWV2 (k52A "saapua") "asemalle" ; --UNCHK
lin get_in_on_V2 = prepV2 (advV (lin V OP_get_V2) OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin get_in_with_V2 = prepV2 (advV (lin V OP_get_V2) OP_in_Adv ) OP_with_Prep ; -- guess-p-verb
lin get_into_V2 = mkWV2 (k52A "sonnustautua") ; --UNCHK
lin get_it_V = mkWV (k74 "älytä") ; --UNCHK
lin get_it_off_V = variants {} ; -- guess-p-verb
lin get_it_off_with_V2 = variants {} ; -- guess-p-verb
lin get_it_on_V = mkWV (k63 "saada") ; --UNCHK
lin get_it_on_with_V2 = variants {} ; -- guess-p-verb
lin get_it_together_V = variants {} ; -- guess-p-verb
lin get_it_up_V = variants {} ; -- guess-p-verb
lin get_off_V = mkWV (k75 "selvitä") ; --UNCHK
lin get_off_V2 = mkWV2 (k75 "selvitä") ; --UNCHK
lin get_off_it_V2 = variants {} ; -- guess-p-verb
lin get_off_on_V2 = prepV2 (advV (lin V OP_get_V2) OP_off_Adv ) OP_on_Prep ; -- guess-p-verb
lin get_off_with_V2 = prepV2 (advV (lin V OP_get_V2) OP_off_Adv ) OP_with_Prep ; -- guess-p-verb
lin get_on_1_V2 = variants {} ; -- guess-p-verb
lin get_on_2_V2 = variants {} ; -- guess-p-verb
lin get_on_V = mkWV (k52A "vanhentua") ; --UNCHK
lin get_on_at_V2 = prepV2 (advV (lin V OP_get_V2) OP_on_Adv ) OP_at_Prep ; -- guess-p-verb
lin get_on_for_V2 = prepV2 (advV (lin V OP_get_V2) OP_on_Adv ) OP_for_Prep ; -- guess-p-verb
lin get_on_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_on_Adv ) OP_to_Prep ; -- guess-p-verb
lin get_on_with_V2 = mkWV2 (k67 "tulla") "toimeen" ; --UNCHK
lin get_onto_V2 = mkWV2 (k74 "älytä") ; --UNCHK
lin get_out_V = mkWV (k75 "selvitä") ; --UNCHK
lin get_out_V2 = mkWV2 (k75 "selvitä") ; --UNCHK
lin get_out_of_V2 = prepV2 (advV (lin V OP_get_V2) OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin get_over_V = mkWV (k52A "toipua") ; --UNCHK
lin get_over_V2 = mkWV2 (k52A "toipua") ; --UNCHK
lin get_over_with_V2 = prepV2 (advV (lin V OP_get_V2) OP_over_Adv ) OP_with_Prep ; -- guess-p-verb
lin get_round_V = advV (lin V OP_get_V2) OP_round_Adv ; -- guess-p-verb
lin get_round_V2 = prepV2 (lin V OP_get_V2) OP_round_Prep ; -- guess-p-verb
lin get_round_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_round_Adv ) OP_to_Prep ; -- guess-p-verb
lin get_through_V = mkWV (k63 "saada") "valmiiksi" ; --UNCHK
lin get_through_V2 = mkWV2 (k63 "saada") "valmiiksi" ; --UNCHK
lin get_through_V3 = mkWV3 (k63 "saada") "valmiiksi" ; --UNCHK
lin get_through_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_through_Adv ) OP_to_Prep ; -- guess-p-verb
lin get_to_V2 = mkWV2 (k67 "tulla") "joksikin" ; --UNCHK
lin get_together_N = mkWN (compoundN "koko" (k38 "ontuminen")) ; --UNCHK
lin get_together_V = mkWV (k52A "kokoontua") ; --UNCHK
lin get_up_V = mkWV (k66 "nousta") "ylös" ; --UNCHK
lin get_up_V2 = mkWV2 (k66 "nousta") "ylös" ; --UNCHK
lin get_up_to_V2 = prepV2 (advV (lin V OP_get_V2) OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin getaway_N = mkWN (k1A "pako") ; --UNCHK
lin gettable_A = mkWA (k10 "oleva") "hankittavissa" ; --UNCHK
lin geum_N = mkWN "suku" "Geum" ; --UNCHK
lin geyser_N = mkWN (k5 "geysir") ; --UNCHK
lin ghana_PN = foreignPN "Ghana" ;
lin ghanaian_A = mkWA (compoundA "ghan" (k38 "alainen")) ; --UNCHK
lin gharry_N = mkWN "gharry" ; --UNCHK
lin ghastliness_N = mkWN (k40 "karmeus") ; --UNCHK
lin ghastly_A = mkWA (k10 "kamala") ; --UNCHK
lin ghatti_N = mkWN (compoundN "ghatti-" (k5 "kumi")) ; --UNCHK
lin ghee_N = mkWN "ghee" ; --UNCHK
lin gherkin_N = mkWN (k1A "etikkakurkku") ; --UNCHK
lin ghetto_N = mkWN (k1A "getto") ; --UNCHK
lin ghillie_N = mkWN (compoundN "nauha" (k10A "kenkä")) ; --UNCHK
lin ghost_N = mkWN (k1 "haamu") ;
lin ghost_V = mkWV (k67 "olla") "haamukirjoittajana" ; --UNCHK
lin ghost_V2 = mkWV2 (k67 "olla") "haamukirjoittajana" ; --UNCHK
lin ghostliness_N = mkWN (k40 "aavemaisuus") ; --UNCHK
lin ghostly_A = mkWA (k38 "henkinen") ; --UNCHK
lin ghost_writer_N = mkWN (compoundN "haamu" (k10 "kirjoittaja")) ; --UNCHK
lin ghoul_N = mkWN (k7A "henki") "paha" ; --UNCHK
lin ghoulish_A = mkWA (k5 "makaaberi") ; --UNCHK
lin ghrelin_N = mkWN "greliini" ; --UNCHK
lin gi_N = mkWN "Gi" ; --UNCHK
lin giant_A = variants {} ; --
lin giant_N = mkWN (k38 "jättiläinen") ; --f78
lin giantess_N = mkWN (k38 "jättiläinen") ; --UNCHK
lin giantism_N = mkWN (compoundN "jätti" (k1 "kasvu")) ; --UNCHK
lin giardia_N = mkWN (compoundN "giar" (k9 "dia")) ; --UNCHK
lin giardiasis_N = mkWN (compoundN "giardi" (k5 "aasi")) ; --UNCHK
lin gib_N = mkWN (kH1 "kolli") "leikattu" ; --UNCHK
lin gibber_V = mkWV (k54A "sokeltaa") ; --UNCHK
lin gibberellin_N = mkWN "gibberelliini" ; --UNCHK
lin gibberish_N = mkWN (k39 "sokellus") ; --UNCHK
lin gibbet_N = mkWN (compoundN "hirsi" (k18 "puu")) ; --UNCHK
lin gibbon_N = mkWN (k6 "gibboni") ; --UNCHK
lin gibbous_A = mkWA (k51 "täysikuu") "melkein" ; --UNCHK
lin gibbsite_N = mkWN "gibsiitti" ; --UNCHK
lin gibe_N = mkWN (k39 "sivallus") ; --UNCHK
lin gibe_V = mkWV (k67A "piikitellä") ; --UNCHK
lin gibibit_N = mkWN (compoundN "gibi" (k5A "bitti")) ; --UNCHK
lin gibingly_Adv = mkWAdv (k99 "pilkallisesti") ; --UNCHK
lin giblet_N = mkWN (compoundN "sisä" (k33 "elin")) "linnun" ; --UNCHK
lin gibraltar_PN = foreignPN "Gibraltar" ;
lin gibraltarian_A = mkWA (compoundA "gibraltari" (k38 "lainen")) ; --UNCHK
lin gibraltarian_N = mkWN (compoundN "gibraltari" (k38 "lainen")) ; --UNCHK
lin giddiness_N = mkWN (k40 "huimaavuus") ; --UNCHK
lin giddy_A = mkWA (k10 "tyhmä") ; --UNCHK
lin gidgee_N = mkWN "Acacia" "cambegei" ; --UNCHK
lin giffnock_PN = foreignPN "Giffnock" ;
lin gift_N = mkN "lahja" ;
lin gift_V2 = mkWV2 (k53A "lahjoittaa") ; --UNCHK
lin gig_N = mkWN (k9A "keikka") ;
lin gigabit_N = mkWN (compoundN "giga" (k5A "bitti")) ; --UNCHK
lin gigabyte_N = mkWN (compoundN "giga" (k1 "tavu")) ; --UNCHK
lin gigahertz_N = mkWN (compoundN "giga" (k5 "hertsi")) ; --UNCHK
lin gigantic_A = mkWA (k38 "jättimäinen") ; --UNCHK
lin gigantism_N = mkWN (compoundN "jätti" (k1 "kasvu")) ; --UNCHK
lin giggle_N = mkWN (k39 "kikatus") ;
lin giggle_V = mkWV (k53A "hihittää") ;
lin gigolo_N = mkWN (k2 "gigolo") ; --UNCHK
lin gilbert_PN = foreignPN "Gilbert" ;
lin gilbertian_A = mkWA "Gilbertian" ; --UNCHK
lin gild_N = mkWN (k5 "loosi") ; --UNCHK
lin gild_V2 = mkWV2 (k73A "kullata") ; --UNCHK
lin gilder_N = mkWN (compoundN "kul" (k9 "taaja")) ; --UNCHK
lin gildhall_N = mkWN (compoundN "kilta" (k1 "talo")) ; --UNCHK
lin gilding_N = mkWN (k39 "kultaus") ; --UNCHK
lin gill_N = mkWN "kidus" ; --UNCHK
lin gill_PN = foreignPN "Gill" ;
lin gillie_N = mkWN (compoundN "nauha" (k10A "kenkä")) ; --UNCHK
lin gillingham_PN = foreignPN "Gillingham" ;
lin gilt_N = mkWN (k39 "kultaus") ; --UNCHK
lin gimbal_N = mkWN (k5 "kardaani") ; --UNCHK
lin gimbaled_A = mkWA "kardaanisesti" "ripustettu" ; --UNCHK
lin gimcrack_A = mkWA (k15 "pramea") ; --UNCHK
lin gimel_N = mkWN "gimel" ; --UNCHK
lin gimlet_N = mkWN (k6 "näveri") ; --UNCHK
lin gimmick_N = mkWN (k5 "konsti") ; --UNCHK
lin gin_N = mkWN (k5 "gini") ;
lin gin_V2 = mkWV2 (k63 "saada") "ansaan" ; --UNCHK
lin ginger_A = mkWA (compoundA "kellan" (k38 "punainen")) ; --UNCHK
lin ginger_N = mkWN (k1 "tarmo") ; --UNCHK
lin ginger_V2 = mkWV2 (k56 "maustaa") "inkiväärillä" ; --UNCHK
lin ginger_up_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin gingerbread_N = mkWN (compoundN "pipar" (k1A "kakku")) ; --UNCHK
lin gingerly_A = mkWA (k99 "varovasti") ; --UNCHK
lin gingerol_N = mkWN "gingerol" ; --UNCHK
lin gingersnap_N = mkWN (kH1 "keksi") ; --UNCHK
lin gingery_A = mkWA (compoundA "kellan" (k38 "punainen")) ; --UNCHK
lin gingham_N = mkWN "gingham" ; --UNCHK
lin gingiva_N = mkWN (k32A "ien") ; --UNCHK
lin gingival_A = mkWA "ien-" ; --UNCHK
lin gingivitis_N = mkWN (compoundN "ien" (k39 "tulehdus")) ; --UNCHK
lin gingko_N = mkWN (compoundN "neidonhius" (k18 "puu")) ; --UNCHK
lin ginkgo_N = mkWN (compoundN "neidonhius" (k18 "puu")) ; --UNCHK
lin ginseng_N = mkN "ginseng" ;
lin gipsyFem_N = mkWN (k6 "romani") ; --UNCHK
lin gipsyMasc_N = mkWN (k6 "romani") ; --UNCHK
lin gipsywort_N = mkWN (compoundN "ranta" (k5A "yrtti")) ; --UNCHK
lin giraffe_N = mkWN (k5 "kirahvi") ; --UNCHK
lin girandole_N = mkWN (compoundN "kynttilän" (k9A "jalka")) "koristeellinen" ; --UNCHK
lin gird_V = mkWV (k54A "rakentaa") "linnakkeita" ; --UNCHK
lin gird_V2 = mkWV2 (k54A "rakentaa") "linnakkeita" ; --UNCHK
lin girder_N = mkWN (compoundN "kannatin" (k5A "palkki")) ; --UNCHK
lin girdle_N = mkWN (k5 "kureliivi") ; --UNCHK
lin girdle_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin girl_N = L.girl_N ;
lin girlfriend_N = mkWN (compoundN "tyttö" (k10 "ystävä")) ;
lin girlhood_N = mkWN (k9A "tyttöaika") ; --UNCHK
lin girlish_A = mkWA (k38 "tyttömäinen") ; --UNCHK
lin girlishness_N = mkWN (k40 "tyttömäisyys") ; --UNCHK
lin giro_N = mkWN (compoundN "tili" (k1A "siirto")) ; --UNCHK
lin girth_N = mkWN (compoundN "satula" (k19 "vyö")) ; --UNCHK
lin girvan_PN = foreignPN "Girvan" ;
lin gist_N = mkWN (k48A "piirre") "tärkeä" ; --UNCHK
lin gitana_N = mkWN "gitana" ; --UNCHK
lin gitano_N = mkWN "gitano" ; --UNCHK
lin give_N = mkWN (k40 "kimmoisuus") ; --UNCHK
lin give_V = mkV "antaa" ;
lin give_V2 = mkV2 "antaa" ;
lin give_V3 = mkV3 (mkV "antaa") (mkPrep allative) accusative ;
lin give_away_V = mkWV (k62 "vasikoida") ; --UNCHK
lin give_away_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin give_back_V2 = mkWV2 (k56A "antaa") "takaisin" ; --UNCHK
lin give_in_V = mkWV (k53A "luovuttaa") ; 
lin give_in_V2 = mkWV2 (k53A "luovuttaa") ;
lin give_in_to_V2 = mkWV2 (mkV "antaa") "periksi" ;
lin give_it_to_V2 = variants {} ; -- guess-p-verb
lin give_it_up_for_V2 = mkWV2 (mkV "toivottaa") "tervetulleeksi" ;
lin give_it_up_to_V2 = mkWV2 (mkV "toivottaa") "tervetulleeksi" ;
lin give_of_V2 = prepV2 OP_give_V OP_of_Prep ; -- guess-p-verb
lin give_off_V = mkWV (k67 "säteillä") ; --UNCHK
lin give_off_V2 = mkWV2 (k67 "säteillä") ; --UNCHK
lin give_onto_V2 = prepV2 OP_give_V OP_onto_Prep ; -- guess-p-verb
lin give_out_V = mkWV (k52A "pysähtyä") ; --UNCHK
lin give_out_V2 = mkWV2 (k52A "pysähtyä") ; --UNCHK
lin give_over_V = advV OP_give_V OP_over_Adv ; -- guess-p-verb
lin give_over_V2 = prepV2 OP_give_V OP_over_Prep ; -- guess-p-verb
lin give_over_to_V3 = variants {} ; -- guess-p-verb
lin give_up_V = mkWV (k73A "hylätä") ; --UNCHK
lin give_up_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin give_up_on_V2 = prepV2 (advV OP_give_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin give_up_to_V2 = prepV2 (advV OP_give_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin give_way_V = mkWV (k52A "pysähtyä") ; --UNCHK
lin give_way_to_V2 = prepV2 (advV OP_give_V OP_way_Adv ) OP_to_Prep ; -- guess-p-verb
lin give_yourself_up_V = variants {} ; -- guess-p-verb
lin give_yourself_up_to_V2 = variants {} ; -- guess-p-verb
lin giveaway_N = mkN "ilmais" (mkN "lahja") ; --mkWN (k2 "visailu") ;
lin given_A = mkA "annettu" ;
lin given_N = mkWN (k39 "oletus") ; --UNCHK
lin givenness_N = mkWN "oletuksellisuus" ; --UNCHK
lin giver_N = mkWN (k10 "antaja") ; --UNCHK
lin giving_N = mkWN (k39 "luovutus") ; --UNCHK
lin gizzard_N = mkWN (k1A "kupu") ; --UNCHK
lin glabella_N = mkWN (compoundN "otsa" (k3 "kolmio")) ; --UNCHK
lin glabellar_A = mkWA "otsakolmio-" ; --UNCHK
lin glabrescent_A = mkWA (k1 "kalju") ; --UNCHK
lin glabrous_A = mkWA (k15 "sileä") ; --UNCHK
lin glace_A = mkWA (compoundA "sokero" (k1A "itu")) ; --UNCHK
lin glacial_A = mkWA (k38 "glasiaalinen") ; --UNCHK
lin glaciation_N = mkWN (compoundN "jää" (k38 "tiköityminen")) ; --UNCHK
lin glacier_N = mkWN (k4A "jäätikkö") ; --UNCHK
lin glad_A = mkWA (k99 "mielissään") ; --UNCHK
lin gladden_V2 = mkWV2 (k52A "ilahtua") ; --UNCHK
lin glade_N = mkWN (compoundN "metsä" (k3 "aukio")) ; --UNCHK
lin gladiator_N = mkWN (k6 "gladiaattori") ; --UNCHK
lin gladiatorial_A = mkWA "gladiaattorin" ; --UNCHK
lin gladness_N = mkWN (k40 "iloisuus") ; --UNCHK
lin gladsome_A = mkWA (k38 "iloinen") ; --UNCHK
lin glamor_N = mkWN (k1 "tenho") ; --UNCHK
lin glamorization_N = mkWN (k5A "ihannointi") ; --UNCHK
lin glamorize_V2 = mkWV2 (k56A "antaa") "hohtoa" ; --UNCHK
lin glamorous_A = mkWA (k41A "tyylikäs") ;
lin glamour_N = mkWN (k1 "tenho") ; --UNCHK
lin glance_N = mkWN (k39 "silmäys") ; --UNCHK
lin glance_V = mkWV (k64 "lyödä") "kulmaan" ; --UNCHK
lin glance_V2 = mkWV2 (k64 "lyödä") "kulmaan" ; --UNCHK
lin gland_N = mkWN (k38 "rauhanen") ; --UNCHK
lin glanders_N = mkWN (compoundN "räkä" (k5A "tauti")) ; --UNCHK
lin glandular_A = mkWA "rauhas-" ; --UNCHK
lin glans_N = mkWN (k9 "terska") ; --UNCHK
lin glare_N = mkWN (k48 "katse") "vihainen" ; --UNCHK
lin glare_V = mkWV (k67 "mulkoilla") ; --UNCHK
lin glare_V2 = mkWV2 (k67 "mulkoilla") ; --UNCHK
lin glaring_A = mkWA (k15 "räikeä") ; --UNCHK
lin glasgow_PN = foreignPN "Glasgow" ;
lin glass_1_N = mkN "lasi" ;
lin glass_2_N = mkN "lasi" ;
lin glass_V2 = mkWV2 (k67 "tulla") "poissaolevaksi" ; --UNCHK
lin glass_cutter_N = mkWN (compoundN "lasi" (k30 "veitsi")) ; --UNCHK
lin glass_wool_N = mkWN (k9 "lasivilla") ; --UNCHK
lin glass_blower_N = mkWN (compoundN "lasin" (k10 "puhaltaja")) ; --UNCHK
lin glassful_N = mkWN (k38 "lasillinen") ; --UNCHK
lin glasshouse_N = mkWN (compoundN "taimi" (k9 "tarha")) ; --UNCHK
lin glassmaker_N = mkWN (compoundN "lasin" (k12 "tekijä")) ; --UNCHK
lin glassware_N = mkWN (compoundN "lasi" (k12 "tavara")) ; --UNCHK
lin glassworks_N = mkWN (compoundN "lasi" (k41A "tehdas")) ; --UNCHK
lin glasswort_N = mkWN (compoundN "suola" (k5A "yrtti")) ; --UNCHK
lin glassy_A = mkWA (k34A "eloton") ; --UNCHK
lin glastonbury_PN = foreignPN "Glastonbury" ;
lin glaswegian_A = mkWA (compoundA "glasgow" (k38 "lainen")) ; --UNCHK
lin glaswegian_N = mkWN (compoundN "glasgow'" (k38 "lainen")) ; --UNCHK
lin glaucoma_N = mkWN (k10 "glaukooma") ; --UNCHK
lin glauconite_N = mkWN (compoundN "glauko" (k5A "niitti")) ; --UNCHK
lin glaucous_A = mkWA (k15 "vihreä") "sinertävän" ; --UNCHK
lin glaze_N = mkWN (k39 "lasitus") ; --UNCHK
lin glaze_V = mkWV (k67 "tulla") "poissaolevaksi" ; --UNCHK
lin glaze_V2 = mkWV2 (k67 "tulla") "poissaolevaksi" ; --UNCHK
lin glazier_N = mkWN (k10 "lasittaja") ; --UNCHK
lin gleam_N = mkWN (k48A "välke") ; --UNCHK
lin gleam_V = mkWV (k53A "välkähtää") ; --UNCHK
lin glean_V = mkWV (k53A "niittää") ; --UNCHK
lin glean_V2 = mkWV2 (k53A "niittää") ; --UNCHK
lin gleaner_N = mkWN (k10 "kokoaja") ; --UNCHK
lin gleba_N = mkWN "gleba" ; --UNCHK
lin glebe_N = mkWN (compoundN "maa-" (k48 "alue")) "kirkon" ; --UNCHK
lin glee_N = mkWN (k1 "riemu") ; --UNCHK
lin gleeful_A = mkWA (k38 "iloinen") ; --UNCHK
lin gleet_N = mkWN (k10A "märkä") ; --UNCHK
lin glen_N = mkWN (k1 "laakso") ; --UNCHK
lin glengarry_N = mkWN "Glengarry" ; --UNCHK
lin glenrothes_PN = foreignPN "Glenrothes" ;
lin glial_A = mkWA "hermotukikudosta" "koskeva" ; --UNCHK
lin glib_A = mkWA (k10 "lipevä") ; --UNCHK
lin glibness_N = mkWN (k40 "lipevyys") ; --UNCHK
lin glide_N = mkWN (k1A "purjelento") ; --UNCHK
lin glide_V = mkWV (k52A "lipua") ; --UNCHK
lin glider_N = mkWN (k33A "liidin") ; --UNCHK
lin gliding_N = mkWN (k1A "purjelento") ; --UNCHK
lin glimmer_N = mkWN (k39 "pilkahdus") ; --UNCHK
lin glimmer_V = mkWV (k53A "hohtaa") ; --UNCHK
lin glimmery_A = mkWA (compoundA "tuik" (k9 "kiva")) ; --UNCHK
lin glimpse_N = mkWN (k39 "silmäys") ; --UNCHK
lin glimpse_V2 = mkWV2 (k71 "nähdä") "vilaukselta" ; --UNCHK
lin glint_N = mkWN (k39 "välähdys") ; --UNCHK
lin glint_V = mkWV (k61A "välkehtiä") ; --UNCHK
lin glioblastoma_N = mkWN (compoundN "spongioblasto" (k10 "oma")) ; --UNCHK
lin glioma_N = mkWN (compoundN "glio" (k10 "oma")) ; --UNCHK
lin glipizide_N = mkWN "Glucotrol" ; --UNCHK
lin gliricidia_N = mkWN (compoundN "gliricidia-" (k18 "puu")) ; --UNCHK
lin glissade_N = mkWN (compoundN "glis" (k48A "sade")) ; --UNCHK
lin glissade_V = mkWV (k71 "tehdä") "glissade-askel" ; --UNCHK
lin glissando_Adv = mkWAdv "glissando" ; --UNCHK
lin glissando_N = mkWN "glissando" ; --UNCHK
lin glisten_V = mkWV (k61A "välkehtiä") ; --UNCHK
lin glister_N = mkWN (k48 "säihke") ; --UNCHK
lin glitter_N = mkWN (k48 "säihke") ; --UNCHK
lin glitter_V = mkWV (k61A "välkehtiä") ; --UNCHK
lin gloaming_N = mkWN (k1 "hämy") ; --UNCHK
lin gloat_N = mkWN (k40 "omahyväisyys") ; --UNCHK
lin gloat_V = mkWV (k68 "hekumoida") ; --UNCHK
lin gloat_VS = mkWVS (k68 "hekumoida") ; --UNCHK
lin gloatingly_Adv = mkWAdv (compoundAdv "vahingon" (k99 "iloisesti")) ; --UNCHK
lin global_A = mkWA (k38 "globaalinen") ;
lin globalization_N = mkWN (compoundN "maa" (k38 "palloistuminen")) ; --UNCHK
lin globe_N = mkWN (compoundN "kartta" (k1 "pallo")) ; --UNCHK
lin globeflower_N = mkWN (k2 "kullero") ; --UNCHK
lin globetrotter_N = mkWN (compoundN "maailman" (k10 "matkaaja")) ; --UNCHK
lin globigerina_N = mkWN "globigerina" ; --UNCHK
lin globin_N = mkWN "globiini" ; --UNCHK
lin globular_A = mkWA (k15 "pyöreä") ; --UNCHK
lin globule_N = mkWN (k12 "pisara") "pieni" ; --UNCHK
lin globulin_N = mkWN "globuliini" ; --UNCHK
lin glochidium_N = mkWN (compoundN "glokidium-" (k10A "toukka")) ; --UNCHK
lin glockenspiel_N = mkWN (compoundN "kello" (k5 "peli")) ; --UNCHK
lin glogg_N = mkWN (k5 "glögi") ; --UNCHK
lin glomerular_A = mkWA "verisuonikerästen" ; --UNCHK
lin glomerule_N = mkWN (k12 "kiemura") ; --UNCHK
lin glomerulonephritis_N = mkWN (compoundN "munuaiskeräs" (k39 "tulehdus")) ; --UNCHK
lin glomerulus_N = mkWN (k38 "munuaiskeränen") ; --UNCHK
lin gloom_N = mkWN (k40 "synkkyys") ; --UNCHK
lin gloominess_N = mkWN (k40 "surullisuus") ; --UNCHK
lin glooming_A = mkWA (k15 "synkeä") ; --UNCHK
lin gloomy_A = mkWA (k15 "synkeä") ;
lin glop_N = mkWN (k5A "siirappi") ; --UNCHK
lin gloria_PN = foreignPN "Gloria" ;
lin glorification_N = mkWN (compoundN "yli" (k38 "stäminen")) ; --UNCHK
lin glorify_V2 = mkWV2 (k67 "olla") "kunniaksi" ; --UNCHK
lin gloriosa_N = mkWN (compoundN "keijun" (k9 "lilja")) ; --UNCHK
lin glorious_A = mkWA (k41A "maineikas") ; --UNCHK
lin glory_N = mkWN (k40 "upeus") ;
lin glory_V = mkWV (k62 "piehtaroida") "jossakin" ; --UNCHK
lin glory_hole_N = mkWN (compoundN "karanteeni" (k9 "tila")) ; --UNCHK
lin gloss_N = mkWN (k39 "väritys") ; --UNCHK
lin gloss_V2 = mkWV2 (k53A "kiillottaa") ; --UNCHK
lin gloss_over_V2 = mkWV2 (k73 "salata") ; --UNCHK
lin glossalgia_N = mkWN (compoundN "kieli" (k1A "kipu")) ; --UNCHK
lin glossarist_N = mkWN (k12 "laatija") "sanaston" ; --UNCHK
lin glossary_N = mkWN (k2 "sanasto") ; --UNCHK
lin glossiness_N = mkWN (k1 "loisto") ; --UNCHK
lin glossitis_N = mkWN (compoundN "kieli" (k39 "tulehdus")) ; --UNCHK
lin glossolalia_N = mkWN (compoundN "kieli" (k38 "lläpuhuminen")) ; --UNCHK
lin glossop_PN = foreignPN "Glossop" ;
lin glossopharyngeal_A = mkWA (compoundA "glossofaryngea" (k38 "alinen")) ; --UNCHK
lin glossoptosis_N = mkWN "glossoptosis" ; --UNCHK
lin glossy_A = mkWA (k15 "pramea") ;
lin glossy_N = mkWN (compoundN "valo" (k10 "kuva")) "kiiltäväpintainen" ; --UNCHK
lin glottal_A = mkWA (compoundA "glotta" (k38 "alinen")) ; --UNCHK
lin glottis_N = mkWN (compoundN "ääni" (k1A "rako")) ; --UNCHK
lin glottochronological_A = mkWA (compoundA "glotto" (k38 "kronologinen")) ; --UNCHK
lin glottochronology_N = mkWN (compoundN "glotto" (k12 "kronologia")) ; --UNCHK
lin gloucester_PN = foreignPN "Gloucester" ;
lin glove_N = L.glove_N ;
lin glove_compartment_N = mkWN (compoundN "hansikas" (k2 "lokero")) ; --UNCHK
lin gloved_A = mkWA "käsine" "kädessä" ; --UNCHK
lin gloveless_A = mkWA "käsineetön" ; --UNCHK
lin glow_N = variants {} ; --
lin glow_V = mkWV (k52 "hehkua") ; --UNCHK
lin glower_V = mkWV (k67 "mulkoilla") ; --UNCHK
lin gloweringly_Adv = mkWAdv (k99 "äreästi") ; --UNCHK
lin glowingly_Adv = mkWAdv "ylistävästi" ; --UNCHK
lin glow_worm_N = mkWN (compoundN "kiilto" (k1A "mato")) ; --UNCHK
lin gloxinia_N = mkWN (compoundN "suppilo" (k10A "kukka")) ; --UNCHK
lin glucagon_N = mkWN "glukagoni" ; --UNCHK
lin glucocorticoid_N = mkWN "glukokortikoidi" ; --UNCHK
lin glucosamine_N = mkWN "glukosamiini" ; --UNCHK
lin glucose_N = mkWN (k6 "glukoosi") ; --UNCHK
lin glucoside_N = mkWN "glukosidi" ; --UNCHK
lin glucosuria_N = mkWN "glukosuria" ; --UNCHK
lin glue_N = mkWN (k9 "liima") ; --UNCHK
lin glue_V2 = mkWV2 (k52A "liimautua") ; --UNCHK
lin glued_A = mkWA (compoundA "liima" (k1 "ttu")) ; --UNCHK
lin gluey_A = mkWA (k15 "tahmea") ; --UNCHK
lin glum_A = mkWA (k15 "apea") ; --UNCHK
lin glume_N = mkWN (k12 "akana") ; --UNCHK
lin glumness_N = mkWN (k40 "nyreys") ; --UNCHK
lin gluon_N = mkWN "gluoni" ; --UNCHK
lin glusburn_PN = foreignPN "Glusburn" ;
lin glut_N = mkWN (k9A "liika") ; --UNCHK
lin glut_V2 = mkWV2 (k61 "hotkia") ; --UNCHK
lin glutamate_N = mkWN "glutamaatti" ; --UNCHK
lin glutamine_N = mkWN "glutamiini" ; --UNCHK
lin gluteal_A = mkWA (compoundA "glutea" (k38 "alinen")) ; --UNCHK
lin glutelin_N = mkWN "gluteliini" ; --UNCHK
lin gluten_N = mkWN (k5 "gluteeni") ; --UNCHK
lin glutethimide_N = mkWN (k5 "glutetimidi") ; --UNCHK
lin gluteus_N = mkWN (compoundN "pakara" (k39 "lihas")) ; --UNCHK
lin glutinous_A = mkWA (k15 "tahmea") ; --UNCHK
lin glutton_N = mkWN (k9 "ahma") ; --UNCHK
lin gluttonous_A = mkWA (k41 "ahnas") ; --UNCHK
lin gluttony_N = mkWN (k2 "mässäily") ; --UNCHK
lin glyburide_N = mkWN (compoundN "Micron" (k48 "ase")) ; --UNCHK
lin glyceraldehyde_N = mkWN "glyseraldehydi" ; --UNCHK
lin glyceride_N = mkWN "glyseridi" ; --UNCHK
lin glycerine_N = mkWN (k5 "glyseriini") ; --UNCHK
lin glycerite_N = mkWN (k5 "glyseroli") ; --UNCHK
lin glycerol_N = mkWN (k5 "glyseriini") ; --UNCHK
lin glycine_N = mkWN "suku" "Glycine" ; --UNCHK
lin glycogen_N = mkWN (compoundN "eläin" (k39 "tärkkelys")) ; --UNCHK
lin glycogenesis_N = mkWN "glykogeneesi" ; --UNCHK
lin glycogenic_A = mkWA "glykogeeninen" ; --UNCHK
lin glycolysis_N = mkWN (compoundN "glykoly" (k5 "ysi")) ; --UNCHK
lin glycoprotein_N = mkWN (compoundN "glyko" (k5 "proteiini")) ; --UNCHK
lin glycoside_N = mkWN "glykosidi" ; --UNCHK
lin glycosuria_N = mkWN "glykosuria" ; --UNCHK
lin glyph_N = mkWN (k6 "symboli") ; --UNCHK
lin glyptics_N = mkWN (compoundN "kai" (k38 "vertaminen")) ; --UNCHK
lin glyptography_N = mkWN (compoundN "kai" (k38 "vertaminen")) ; --UNCHK
lin gnarled_A = mkWA (k38 "pahkainen") ; --UNCHK
lin gnash_V = mkWV (k53A "narskuttaa") ; --UNCHK
lin gnash_V2 = mkWV2 (k53A "narskuttaa") ; --UNCHK
lin gnat_N = mkWN (k7 "sääski") ; --UNCHK
lin gnatcatcher_N = mkWN (compoundN "sääski" (k1A "kerttu")) ; --UNCHK
lin gnathion_N = mkWN (compoundN "ala" (k7A "kärki")) "leuan" ; --UNCHK
lin gnathostome_N = mkWN (k38 "selkärankainen") "leuallinen" ; --UNCHK
lin gnaw_V = mkWV (k53A "kuluttaa") ; --UNCHK
lin gnaw_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin gnaw_at_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin gneiss_N = mkWN (k5 "gneissi") ; --UNCHK
lin gnetum_N = mkWN "Gnetum" "gnemon" ; --UNCHK
lin gnocchi_N = mkWN "gnocchi" ; --UNCHK
lin gnome_N = mkWN (k10 "ajatelma") ; --UNCHK
lin gnomic_A = mkWA (k38 "arvoituksellinen") ; --UNCHK
lin gnomish_A = mkWA "maahis-" ; --UNCHK
lin gnomon_N = mkWN "gnomon" ; --UNCHK
lin gnosis_N = mkWN "gnosis" ; --UNCHK
lin gnostic_A = mkWA "gnostinen" ; --UNCHK
lin gnp_N = mkWN "bruttokansantuote" ; --UNCHK
lin gnu_N = mkWN (k18 "gnuu") ; --UNCHK
lin go_N = mkWN (compoundN "go-" (k5 "peli")) ; --UNCHK
lin go_V = L.go_V ;
lin go_VA = mkVA (mkV "käydä") (casePrep translative) ;
lin go_VV = mkVV (mkV "aikoa") ; ---- subcat
lin go_about_V = mkWV (k52 "lähestyä") ; --UNCHK
lin go_about_V2 = mkWV2 (k52 "lähestyä") ; --UNCHK
lin go_across_V = mkWV (k65 "käydä") ; --UNCHK
lin go_after_V2 = mkWV2 (k67A "tavoitella") ; --UNCHK
lin go_against_V2 = mkWV2 (k53 "vastustaa") ; --UNCHK
lin go_ahead_V = mkWV (k73 "kahlata") "eteenpäin" ; --UNCHK
lin go_ahead_with_V2 = prepV2 (advV OP_go_V OP_ahead_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_along_V = mkWV (k53A "hurahtaa") ; --UNCHK
lin go_along_with_V2 = prepV2 (advV OP_go_V OP_along_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_around_V = mkWV (k53A "sivuuttaa") ; --UNCHK
lin go_at_V2 = prepV2 OP_go_V OP_at_Prep ; -- guess-p-verb
lin go_away_V = mkWV (k75 "hävitä") ; --UNCHK
lin go_back_V = mkWV (k52A "tointua") ; --UNCHK
lin go_back_V2 = mkWV2 (k52A "tointua") ; --UNCHK
lin go_back_on_V2 = mkWV2 (k52A "rikkoa") "lupaus" ; --UNCHK
lin go_before_V = advV OP_go_V OP_before_Adv ; -- guess-p-verb
lin go_below_V = advV OP_go_V OP_below_Adv ; -- guess-p-verb
lin go_by_V = mkWV (k61 "toimia") "mukaisesti" ; --UNCHK
lin go_by_V2 = mkWV2 (k61 "toimia") "mukaisesti" ; --UNCHK
lin go_down_V = mkWV (k72A "heiketä") ; --UNCHK
lin go_down_on_V2 = mkWV2 (k53A "ottaa") "suihin" ; --UNCHK
lin go_down_to_V2 = prepV2 (advV OP_go_V OP_down_Adv ) OP_to_Prep ; -- guess-p-verb
lin go_down_with_V2 = prepV2 (advV OP_go_V OP_down_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_for_V = mkWV (k53A "yrittää") ; --UNCHK
lin go_for_V2 = mkWV2 (k53A "yrittää") ; --UNCHK
lin go_for_it_V = variants {} ; -- guess-p-verb
lin go_forth_V = mkWV (k67 "tulla") "näkyviin" ; --UNCHK
lin go_forward_V = mkWV (k56 "jatkaa") ; --UNCHK
lin go_in_V = mkWV (k67 "tulla") ; --UNCHK
lin go_in_for_V2 = prepV2 (advV OP_go_V OP_in_Adv ) OP_for_Prep ; -- guess-p-verb
lin go_in_with_V2 = prepV2 (advV OP_go_V OP_in_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_into_V2 = mkWV2 (k67 "tulla") ; --UNCHK
lin go_it_V = variants {} ; -- guess-p-verb
lin go_it_alone_V = variants {} ; -- guess-p-verb
lin go_off_V = mkWV (k53A "romahtaa") ; --UNCHK
lin go_off_V2 = mkWV2 (k53A "romahtaa") ; --UNCHK
lin go_off_with_V2 = prepV2 (advV OP_go_V OP_off_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_on_V = mkWV (k65 "käydä") ; --UNCHK
lin go_on_V2 = mkWV2 (k65 "käydä") ; --UNCHK
lin go_on_about_V2 = prepV2 (advV OP_go_V OP_on_Adv ) OP_about_Prep ; -- guess-p-verb
lin go_on_at_V2 = prepV2 (advV OP_go_V OP_on_Adv ) OP_at_Prep ; -- guess-p-verb
lin go_on_to_V2 = prepV2 (advV OP_go_V OP_on_Adv ) OP_to_Prep ; -- guess-p-verb
lin go_on_with_V2 = prepV2 (advV OP_go_V OP_on_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_one_V = variants {} ; -- guess-p-verb
lin go_out_V = mkWV (k52 "sammua") ; --UNCHK
lin go_out_for_V2 = prepV2 (advV OP_go_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin go_out_to_V2 = prepV2 (advV OP_go_V OP_out_Adv ) OP_to_Prep ; -- guess-p-verb
lin go_out_with_V2 = prepV2 (advV OP_go_V OP_out_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_over_V = mkWV (k52A "kaatua") ; --UNCHK
lin go_over_V2 = mkWV2 (k52A "kaatua") ; --UNCHK
lin go_over_to_V2 = prepV2 (advV OP_go_V OP_over_Adv ) OP_to_Prep ; -- guess-p-verb
lin go_past_V2 = mkWV2 (k53A "sivuuttaa") ; --UNCHK
lin go_round_V = advV OP_go_V OP_round_Adv ; -- guess-p-verb
lin go_through_V = mkWV (k65 "käydä") "läpi" ; --UNCHK
lin go_through_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin go_through_with_V2 = prepV2 (advV OP_go_V OP_through_Adv ) OP_with_Prep ; -- guess-p-verb
lin go_to_V2 = mkV2 (mkV "mennä") illative ;
lin go_together_V = advV OP_go_V OP_together_Adv ; -- guess-p-verb
lin go_towards_V2 = prepV2 OP_go_V OP_towards_Prep ; -- guess-p-verb
lin go_under_V = mkV "vajota" ;
lin go_up_V = mkWV (k74A "kiivetä") ; --UNCHK
lin go_up_to_V2 = prepV2 (advV OP_go_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin go_with_V2 = mkWV2 (k52 "kuulua") "yhteen" ; --UNCHK
lin go_without_V2 = prepV2 OP_go_V OP_without_Prep ; -- guess-p-verb
lin goad_N = mkWN (k33 "pistin") ; --UNCHK
lin goad_V2 = mkWV2 (k53A "kiihottaa") ; --UNCHK
lin goal_1_N = mkWN (kH1 "maali") ;
lin goal_2_N = mkWN (kH1 "maali") ;
lin goal_line_N = mkWN (k9 "maaliraja") ; --UNCHK
lin goalie_N = mkWN (k9 "veska") ; --UNCHK
lin goalkeeper_N = mkN "maalivahti" ;
lin goalless_A = mkWA (kH1 "maaliton") ; --UNCHK
lin goalmouth_N = mkWN (compoundN "maali" (k48 "alue")) ; --UNCHK
lin goalpost_N = mkWN (compoundN "maali" (k10A "tolppa")) ; --UNCHK
lin goat_N = mkWN (k23 "vuohi") ; --UNCHK
lin goatee_N = mkWN (compoundN "pukin" (k9A "parta")) ; --UNCHK
lin goateed_A = mkWA (compoundA "pukin" (k38 "partainen")) ; --UNCHK
lin goatfish_N = mkWN "Mullus" "surmuletus" ; --UNCHK
lin goatherd_N = mkWN (compoundN "vuohi" (k32 "paimen")) ; --UNCHK
lin goatsfoot_N = mkWN "Oxalis" "caprina" ; --UNCHK
lin goatskin_N = mkWN (compoundN "vuohen" (k9 "nahka")) ; --UNCHK
lin goatsucker_N = mkWN (k10 "kehrääjä") ; --UNCHK
lin gob_N = mkWN (kH1 "turpa") ; --UNCHK
lin gobbet_N = mkWN (k1A "paakku") ; --UNCHK
lin gobble_N = mkWN (k39 "kaakatus") ; --UNCHK
lin gobble_V = mkWV (k53A "kaakattaa") ; --UNCHK
lin gobble_V2 = mkWV2 (k53A "kaakattaa") ; --UNCHK
lin gobbledygook_N = mkWN (compoundN "kapula" (k26 "kieli")) ; --UNCHK
lin gobbler_N = mkWN (compoundN "kalkkuna" (k1A "kukko")) ; --UNCHK
lin goblet_N = mkWN (k6 "pikari") ; --UNCHK
lin goblin_N = mkWN (k1A "tonttu") ; --UNCHK
lin go_by_N = mkWN (k5A "syötti") ; --UNCHK
lin god_N = mkWN (k10 "jumala") ; --UNCHK
lin godalming_PN = foreignPN "Godalming" ;
lin godchild_N = mkWN (compoundN "kummi" (k29 "lapsi")) ; --UNCHK
lin goddam_A = mkWA (k38 "pirunmoinen") ; --UNCHK
lin goddam_Adv = mkWAdv "helkkarin" ; --UNCHK
lin goddaughter_N = mkWN (compoundN "kummi" (k32A "tytär")) ; --UNCHK
lin goddess_N = mkWN (k32A "jumalatar") ; --UNCHK
lin godfather_N = mkWN (compoundN "kummi" (k10A "setä")) ; --UNCHK
lin godforsaken_A = mkWA (k5 "villi") ; --UNCHK
lin godfrey_PN = foreignPN "Godfrey" ;
lin godhead_N = mkWN (compoundN "Kaikki" (k41 "valtias")) ; --UNCHK
lin godless_A = mkWA (k34A "jumalaton") ; --UNCHK
lin godlessness_N = mkWN "jumalattomuus" ; --UNCHK
lin godlike_A = mkWA (k38 "jumalallinen") ; --UNCHK
lin godliness_N = mkWN (k40 "jumalisuus") ; --UNCHK
lin godly_A = mkWA (k10 "pyhä") ; --UNCHK
lin godmanchester_PN = foreignPN "Godmanchester" ;
lin godmother_N = mkWN (compoundN "kummi" (k5A "täti")) ; --UNCHK
lin godown_N = mkWN "godown" ; --UNCHK
lin godparent_N = mkWN (k5 "kummi") ; --UNCHK
lin godsend_N = mkWN (k5A "jättipotti") ; --UNCHK
lin godson_N = mkWN (compoundN "kummi" (k10A "poika")) ; --UNCHK
lin godspeed_N = mkWN "Herran" "siunausta" ; --UNCHK
lin godwit_N = mkWN (k5 "kuiri") ; --UNCHK
lin gofer_N = mkWN (k5A "lähetti") ; --UNCHK
lin goffer_N = mkWN (k2 "röyhelö") "pliseerattu" ; --UNCHK
lin goggle_V = mkWV (k67 "töllistellä") ; --UNCHK
lin goggle_box_N = mkWN (k20 "teevee") ; --UNCHK
lin going_N = mkWN "lähteminen" ; --UNCHK
lin goiter_N = mkWN (k10 "struuma") ; --UNCHK
lin goitre_N = mkWN (k10 "struuma") ; --UNCHK
lin goitrogen_N = mkWN (compoundN "goitro" (k5 "geeni")) ; --UNCHK
lin gold_A = mkWA (k38 "kultainen") ; --UNCHK
lin gold_N = L.gold_N ;
lin gold_dust_N = mkWN (compoundN "kulta" (k1 "pöly")) ; --UNCHK
lin gold_foil_N = mkWN (compoundN "lehti" (k10A "kulta")) ; --UNCHK
lin gold_leaf_N = mkWN (compoundN "lehti" (k10A "kulta")) ; --UNCHK
lin gold_plate_N = mkWN (k39 "kultaus") ; --UNCHK
lin gold_rush_N = mkWN (compoundN "kulta" (k48 "kuume")) ; --UNCHK
lin goldbeater_N = mkWN (k10 "valmistaja") "lehtikullan" ; --UNCHK
lin goldcrest_N = mkWN (k38 "hippiäinen") ; --UNCHK
lin golden_A = mkWA (k41A "onnekas") ; --UNCHK
lin goldenbush_N = mkWN (k5 "kasvi") "Chrysothamnus-suvun" ; --UNCHK
lin goldeneye_N = mkWN (k10A "telkkä") ; --UNCHK
lin goldenrod_N = mkWN (k1 "piisku") ; --UNCHK
lin goldenseal_N = mkWN "Hydrastis" "Canadensis" ; --UNCHK
lin goldfield_N = mkWN (compoundN "kulta" (k10A "kenttä")) ; --UNCHK
lin goldfinch_N = mkWN (k5 "tikli") ; --UNCHK
lin goldfish_N = mkWN (compoundN "kulta" (k9 "kala")) ; --UNCHK
lin goldilocks_N = mkWN (compoundN "kulta-" (k6 "asteri")) ; --UNCHK
lin goldmine_N = mkWN (compoundN "kulta" (k39 "kaivos")) ; --UNCHK
lin goldsmith_N = mkWN (compoundN "kulta" (k10A "seppä")) ; --UNCHK
lin goldstone_N = mkWN (compoundN "aventuriini" (k5 "kvartsi")) ; --UNCHK
lin golem_N = mkWN (k5A "robotti") ; --UNCHK
lin golf_N = mkWN (k5 "golf") ; --UNCHK
lin golf_V = mkWV (k73 "pelata") "golfia" ; --UNCHK
lin golf_ball_N = mkWN (compoundN "golf" (k1 "pallo")) ; --UNCHK
lin golf_club_N = mkWN (k9 "maila") ; --UNCHK
lin golf_course_N = mkWN (compoundN "golf" (k9A "rata")) ; --UNCHK
lin golf_links_N = mkWN (compoundN "golf" (k9A "rata")) ; --UNCHK
lin golfcart_N = mkWN (compoundN "golf" (k1 "auto")) ; --UNCHK
lin golfer_N = mkWN (k10 "pelaaja") "golfin" ; --UNCHK
lin golfing_N = mkWN (compoundN "golf" (k38 "aaminen")) ; --UNCHK
lin goliard_N = mkWN (compoundN "kirkonmies" (k6 "kulkuri")) "rappiolla" "oleva" ; --UNCHK
lin goliath_N = mkWN (k5 "kolossi") ; --UNCHK
lin golliwog_N = mkWN "golliwogg" ; --UNCHK
lin golosh_N = mkWN (k5 "kalossi") ; --UNCHK
lin gonad_N = mkWN (compoundN "sukupuoli" (k38 "rauhanen")) ; --UNCHK
lin gonadal_A = mkWA (compoundA "gonada" (k38 "alinen")) ; --UNCHK
lin gonadotropic_A = mkWA (compoundA "gonado" (k38 "trooppinen")) ; --UNCHK
lin gonadotropin_N = mkWN (k5 "hormoni") "gonadotrooppinen" ; --UNCHK
lin gondola_N = mkWN (k5 "kori") ; --UNCHK
lin gondolier_N = mkWN (k5 "gondolieeri") ; --UNCHK
lin goner_N = mkWN "pulassa" ; --UNCHK
lin gong_N = mkWN (k1 "kello") ; --UNCHK
lin gong_V2 = mkWV2 (k64 "lyödä") "kumistinta" ; --UNCHK
lin gonif_N = mkWN (k41A "varas") ; --UNCHK
lin goniometer_N = mkWN (compoundN "kulma" (k6 "mittari")) ; --UNCHK
lin gonion_N = mkWN "leukakulmapiste" ; --UNCHK
lin gonioscopy_N = mkWN "gonioskopia" ; --UNCHK
lin gonococcus_N = mkWN (k5A "gonokokki") ; --UNCHK
lin gonorrhea_N = mkWN (k6 "tippuri") ; --UNCHK
lin gonorrhoea_N = mkWN (k6 "tippuri") ; --UNCHK
lin goo_N = mkWN (k1A "törky") ; --UNCHK
lin good_A = L.good_A ;
lin good_N = mkN "hyvä" ;
lin good_afternoon_Interj = mkInterj "hyvää päivää" ;
lin good_evening_Interj = mkInterj "hyvää iltaa" ;
lin good_luck_Interj = mkInterj "onnea" ;
lin good_morning_Interj = mkInterj "hyvää huomenta" ;
lin good_natured_A = mkA "hyväluontoinen" ;
lin good_night_Interj = mkInterj "hyvää yötä" ;
lin goodbye_Interj = mkInterj "näkemiin" ;
lin goodish_A = mkWA (k1 "reilu") ; --UNCHK
lin goodly_A = mkWA (k1 "reilu") ; --UNCHK
lin goodness_N = mkWN (k40 "hyvyys") ; --UNCHK
lin goodwill_N = mkWN (k40 "suopeus") ;
lin goody_N = mkWN (k5 "nami") ; --UNCHK
lin gooey_A = mkWA (k38 "tahmainen") ; --UNCHK
lin goof_N = mkWN (k5 "narri") ; --UNCHK
lin goof_V = mkWV (k73A "töpätä") ; --UNCHK
lin goof_V2 = mkWV2 (k73A "töpätä") ; --UNCHK
lin goofy_A = mkWA (k38 "hullunkurinen") ; --UNCHK
lin googly_N = mkWN (compoundN "kierto" (k1A "heitto")) ; --UNCHK
lin googol_N = mkWN "googol" ; --UNCHK
lin googolplex_N = mkWN "googolplex" ; --UNCHK
lin gook_N = mkWN (k50 "vinosilmä") ; --UNCHK
lin goole_PN = foreignPN "Goole" ;
lin goon_N = mkWN (k1 "rosvo") ; --UNCHK
lin goosander_N = mkWN (k50 "isokoskelo") ; --UNCHK
lin goose_N = mkWN (k7 "hanhi") ; --UNCHK
lin goose_step_N = mkWN (compoundN "paraati" (k5 "marssi")) ; --UNCHK
lin gooseberry_N = mkWN (compoundN "karviais" (k9 "marja")) ; --UNCHK
lin goosefish_N = mkWN "Lophius" "Americanus" ; --UNCHK
lin goosefoot_N = mkWN (k14A "savikka") ; --UNCHK
lin gooseneck_N = mkWN (compoundN "pullon" (k9 "kaula")) ; --UNCHK
lin gopher_N = mkWN "Gopherus" "polypemus" ; --UNCHK
lin gordian_A = mkWA "Gordionin" ; --UNCHK
lin gordon_PN = foreignPN "Gordon" ;
lin gore_N = mkWN (k26 "veri") ; --UNCHK
lin gore_V2 = mkWV2 (k58 "puskea") ; --UNCHK
lin gorge_N = mkWN (k1 "nielu") ; --UNCHK
lin gorge_V = mkWV (k61 "hotkia") ; --UNCHK
lin gorge_V2 = mkWV2 (k61 "hotkia") ; --UNCHK
lin gorgeous_A = mkWA (k15 "hulppea") ; --UNCHK
lin gorgerin_N = mkWN (kH1 "friisi") ; --UNCHK
lin gorget_N = mkWN (compoundN "panssari" (k39 "kaulus")) ; --UNCHK
lin gorgon_N = mkWN "Gorgon" ; --UNCHK
lin gorgonian_N = mkWN (compoundN "gorgonia-" (k5 "koralli")) ; --UNCHK
lin gorgonzola_N = mkWN (k10 "gorgonzola") ; --UNCHK
lin gorilla_N = mkWN (k13 "gorilla") "Gorilla" ; --UNCHK
lin gormandize_V = mkWV (k61 "hotkia") ; --UNCHK
lin gormless_A = mkWA (k10 "tyhmä") ; --UNCHK
lin gorse_N = mkWN (compoundN "piikki" (k48 "herne")) ; --UNCHK
lin gorseinon_PN = foreignPN "Gorseinon" ;
lin gory_A = mkWA (k10 "kammottava") ; --UNCHK
lin goshawk_N = mkWN (compoundN "kana" (k9A "haukka")) ; --UNCHK
lin gosling_N = mkWN (compoundN "hanhen" (k10A "poika")) ; --UNCHK
lin gospel_N = mkWN (k5A "oppi") ; --UNCHK
lin gosport_PN = foreignPN "Gosport" ;
lin gossamer_N = mkWN (k5A "seitti") ; --UNCHK
lin gossip_N = mkN "juoru" ;
lin gossip_V = mkWV (k66 "horista") ; --UNCHK
lin gossiping_N = mkWN (k2 "juoruilu") ; --UNCHK
lin goth_N = mkWN (k5A "gootti") ; --UNCHK
lin gothenburg_PN = foreignPN "Gothenburg" ;
lin gothic_A = mkWA (compoundA "goott" (k32A "ien")) ; --UNCHK
lin gothic_N = mkWN (k5 "arkkitehtuuri") "goottilainen" ; --UNCHK
lin gouache_N = mkWN (k5 "guassi") ; --UNCHK
lin gouge_N = mkWN (compoundN "kai" (k38 "vertaminen")) ; --UNCHK
lin gouge_V2 = mkWV2 (k53 "puristaa") "ulos" ; --UNCHK
lin gouger_N = mkWN (k6 "petturi") ; --UNCHK
lin goulash_N = mkWN (k5 "gulassi") ; --UNCHK
lin gourd_N = mkWN "kalebassi" ; --UNCHK
lin gourde_N = mkWN "Haitin" "gourde" ; --UNCHK
lin gourmand_N = mkWN (k6 "syömäri") ; --UNCHK
lin gourmandism_N = mkWN (compoundN "gourmand" (k5 "ismi")) ; --UNCHK
lin gourmet_N = mkWN (k12 "herkuttelija") ; --UNCHK
lin gourock_PN = foreignPN "Gourock" ;
lin gout_N = mkWN (k5A "kihti") ; --UNCHK
lin gouty_A = mkWA "kihtiä" "sairastava" ; --UNCHK
lin govern_V = mkWV (k53A "vaikuttaa") "ratkaisevasti" ; --UNCHK
lin govern_V2 = mkWV2 (k53A "vaikuttaa") "ratkaisevasti" ; --UNCHK
lin governance_N = mkWN (k1A "hoito") ; --UNCHK
lin governed_N = mkWN (k9 "kansa") ; --UNCHK
lin governess_N = mkWN (compoundN "koti" (k32A "opettajatar")) ; --UNCHK
lin government_N = mkN "hallitus" ;
lin governmental_A = mkA "hallituksellekuuluva" ;
lin governor_N = mkN "kuvernööri" ;
lin governor_general_N = mkWN (compoundN "kenraali" (k5 "kuvernööri")) ; --UNCHK
lin governorship_N = mkWN (compoundN "maaherran" (k9A "virka")) ; --UNCHK
lin gown_N = mkWN (k1A "puku") "naisen" ; --UNCHK
lin gown_V2 = mkWV2 (k52A "pukeutua") "kaapuun" ; --UNCHK
lin gp_N = mkWN (compoundN "yleis" (k6 "lääkäri")) ; --UNCHK
lin grab_N = mkWN (k2 "kouraisu") ; --UNCHK
lin grab_V = mkWV (k53A "valloittaa") ; --UNCHK
lin grab_V2 = mkWV2 (k53A "valloittaa") ; --UNCHK
lin grabber_N = mkWN "kourija" ; --UNCHK
lin grace_N = mkWN (k40 "arvokkuus") ;
lin grace_V2 = mkWV2 (k53 "komistaa") ; --UNCHK
lin graceful_A = mkWA (k10 "viehättävä") ; --UNCHK
lin gracefulness_N = mkWN (k40 "viehkeys") ; --UNCHK
lin graceless_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin gracelessness_N = mkWN (k40 "jäykkyys") ; --UNCHK
lin gracilariid_N = mkWN (k18 "miinaajakoi") ; --UNCHK
lin gracile_A = mkWA (k15 "sorea") ; --UNCHK
lin gracious_A = mkWA (k38 "ylellinen") ; --UNCHK
lin graciousness_N = mkWN (k40 "ystävällisyys") ; --UNCHK
lin gradable_A = mkWA (k10 "oleva") "luokiteltavissa" ; --UNCHK
lin gradation_N = mkWN (k39 "porrastus") ; --UNCHK
lin gradational_A = mkWA (k38 "asteittainen") ; --UNCHK
lin grade_N = mkWN (k1 "taso") ; --UNCHK
lin grade_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin grader_N = mkWN (k12 "lajittelija") ; --UNCHK
lin gradient_N = mkWN (k40 "kaltevuus") ; --UNCHK
lin grading_N = mkWN (k2 "arvostelu") ; --UNCHK
lin gradual_A = mkWA (k38 "vähittäinen") ; --UNCHK
lin graduality_N = mkWN (k40 "asteittaisuus") ; --UNCHK
lin gradualness_N = mkWN (k40 "asteittaisuus") ; --UNCHK
lin graduate_N = mkWN (compoundN "mitta" (k5 "lasi")) ; --UNCHK
lin graduate_V = mkWV (k62 "kalibroida") ; --UNCHK
lin graduate_V2 = mkWV2 (k62 "kalibroida") ; --UNCHK
lin graduation_N = mkWN (compoundN "valmis" (k38 "tuminen")) ; --UNCHK
lin graffito_N = mkWN (k5 "graffiti") ; --UNCHK
lin graft_N = mkWN "varttaminen" ; --UNCHK
lin graft_V = mkWV (k71 "tehdä") "elinsiirto" ; --UNCHK
lin graft_V2 = mkWV2 (k71 "tehdä") "elinsiirto" ; --UNCHK
lin grail_N = mkWN (k9 "malja") "Graalin" ; --UNCHK
lin grain_N = mkN "vilja" ;
lin grainfield_N = mkWN (compoundN "vilja" (k1A "pelto")) ; --UNCHK
lin graining_N = mkWN (k39 "ootraus") ; --UNCHK
lin gram_N = mkN "gramma" ;
lin grama_N = mkWN (compoundN "gramma-" (k10 "heinä")) ; --UNCHK
lin gramicidin_N = mkWN "gramisidiini" ; --UNCHK
lin grammar_N = L.grammar_N ;
lin grammarian_N = mkWN (k12 "tutkija") "lauseopin" ; --UNCHK
lin grammatical_A = mkWA (k15 "oikea") "kieliopillisesti" ; --UNCHK
lin gramme_N = mkWN (k9 "gramma") ; --UNCHK
lin gramophone_N = mkWN (k5 "gramofoni") "akustinen" ; --UNCHK
lin grampus_N = mkWN (compoundN "iso" (k6 "delfiini")) ; --UNCHK
lin granada_PN = foreignPN "Grenada" ;
lin granadilla_N = mkWN (k9 "granadilla") ; --UNCHK
lin granary_N = mkWN (k9A "aitta") ; --UNCHK
lin grand_A = mkWA (k10 "mahtava") ;
lin grand_prix_N = mkWN "Grand" "Prix" ; --UNCHK
lin grandad_N = mkWN (kH1 "vaari") ; --UNCHK
lin grandaunt_N = mkWN (k50 "isotäti") ; --UNCHK
lin grandchild_N = mkWN (compoundN "lapsen" (k29 "lapsi")) ; --UNCHK
lin granddad_N = mkWN (kH1 "vaari") ; --UNCHK
lin granddaughter_N = mkWN (compoundN "tyttären" (k32A "tytär")) ; --UNCHK
lin grandee_N = mkWN (compoundN "ylhäis" (k38 "aatelinen")) "portugalilainen" ; --UNCHK
lin grandeur_N = mkWN (k40 "suuruus") ; --UNCHK
lin grandfather_N = mkN "iso" (mkN "isä") | mkWN (kH1 "vaari") ; 
lin grandiloquence_N = mkWN (k40 "pateettisuus") ; --UNCHK
lin grandiloquent_A = mkWA (k38 "suurellinen") ; --UNCHK
lin grandiose_A = mkA "suureellinen" ; --WA (k38 "suurellinen") ;
lin grandiosity_N = mkWN (k40 "pateettisuus") ; --UNCHK
lin grandma_N = mkWN (k5 "mummi") ; --UNCHK
lin grandmaster_N = mkWN (compoundN "suur" (k6 "mestari")) ; --UNCHK
lin grandmother_N = mkN "iso" (mkN "äiti") | mkWN (k5 "mummi") ; 
lin grandnephew_N = mkWN (k10A "poika") "veljentyttären" ; --UNCHK
lin grandniece_N = mkWN (k32A "tytär") "veljentyttären" ; --UNCHK
lin grandpa_N = mkWN (kH1 "vaari") ; --UNCHK
lin grandparent_N = mkWN (compoundN "iso" (k16A "vanhempi")) ; --UNCHK
lin grandson_N = mkWN (compoundN "tyttären" (k10A "poika")) ; --UNCHK
lin grandstand_N = mkWN (k2 "katsomo") "katettu" ; --UNCHK
lin grandstander_N = mkWN (k10 "esiintyjä") "yleisöä" "kosiskeleva" ; --UNCHK
lin granduncle_N = mkWN (k50 "isosetä") ; --UNCHK
lin grange_N = mkWN (compoundN "maa" (k9 "tila")) ; --UNCHK
lin grangemouth_PN = foreignPN "Grangemouth" ;
lin granite_N = mkWN (k3 "kallio") ; --UNCHK
lin granitic_A = mkWA (k38 "graniittinen") ; --UNCHK
lin grannie_N = mkWN (k5 "mummi") ; --UNCHK
lin granny_N = mkWN (compoundN "ämmän" (k1 "solmu")) ; --UNCHK
lin granola_N = mkWN (k5 "mysli") ; --UNCHK
lin grant_N = mkN "apuraha" ;
lin grant_V2 = mkWV2 (k54A "myöntää") ;
lin grant_V3 = mkWV3 (k54A "myöntää") ; --UNCHK
lin grantee_N = mkWN (k10 "omistaja") "uusi" ; --UNCHK
lin granter_N = mkWN (k10 "myöntäjä") ; --UNCHK
lin grantham_PN = foreignPN "Grantham" ;
lin grantor_N = mkWN (k10 "myöntäjä") ; --UNCHK
lin granular_A = mkWA (k38 "rakeinen") ; --UNCHK
lin granularity_N = mkWN (k40 "rakeisuus") ; --UNCHK
lin granulate_V = mkWV (k61 "rouhia") ; --UNCHK
lin granulate_V2 = mkWV2 (k61 "rouhia") ; --UNCHK
lin granulation_N = mkWN (compoundN "rakeis" (k38 "tuminen")) ; --UNCHK
lin granule_N = mkWN (k48A "rae") ; --UNCHK
lin granuliferous_A = mkWA (compoundA "runsas" (k38 "rakeinen")) ; --UNCHK
lin granulocyte_N = mkWN (compoundN "jyväs" (k1 "solu")) ; --UNCHK
lin granulocytic_A = mkWA "granulosyyttinen" ; --UNCHK
lin granuloma_N = mkWN (compoundN "granulo" (k10 "oma")) ; --UNCHK
lin granulomatous_A = mkWA "granulooma-" ; --UNCHK
lin grape_N = mkWN "raehaulipanos" ; --UNCHK
lin grape_sugar_N = mkWN (compoundN "rypäle" (k6 "sokeri")) ; --UNCHK
lin grapefruit_N = mkWN (k5A "greippi") ; --UNCHK
lin grapelike_A = mkWA (compoundA "viini" (k38 "rypälemäinen")) ; --UNCHK
lin grapeshot_N = mkWN "raehaulipanos" ; --UNCHK
lin grapevine_N = mkWN (k1A "tieto") "suullisesti" "leviävä" ; --UNCHK
lin grapey_A = mkWA (compoundA "rypäleen" (k38 "makuinen")) ; --UNCHK
lin graph_N = mkWN (k10 "kuvaaja") ; --UNCHK
lin graphic_A = mkWA (k38 "graafinen") ; --UNCHK
lin graphical_A = mkWA (k38 "graafinen") ; --UNCHK
lin graphics_N = mkWN (k14A "grafiikka") ; --UNCHK
lin graphite_N = mkWN (k5A "grafiitti") ; --UNCHK
lin graphologist_N = mkWN (k5 "grafologi") ; --UNCHK
lin graphology_N = mkWN (k12 "grafologia") ; --UNCHK
lin grapnel_N = mkWN (k9 "naara") ; --UNCHK
lin grappa_N = mkWN "grappa" ; --UNCHK
lin grapple_V = mkWV (k53A "pitää") "kiinni" ; --UNCHK
lin grappling_iron_N = mkWN (compoundN "heitto" (k1A "koukku")) ; --UNCHK
lin grasp_N = mkWN (k48A "ote") ; --UNCHK
lin grasp_V = mkWV (k74 "tajuta") ; --UNCHK
lin grasp_V2 = mkWV2 (k74 "tajuta") ; --UNCHK
lin grasping_N = mkWN (compoundN "tarra" (k38 "aminen")) ; --UNCHK
lin grass_N = L.grass_N ;
lin grass_V = mkWV (k62 "vasikoida") ; --UNCHK
lin grass_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin grassfinch_N = mkWN (compoundN "paratiisi" (k1A "peippo")) ; --UNCHK
lin grassfire_N = mkWN (compoundN "preeria" (k1 "palo")) ; --UNCHK
lin grasshopper_N = mkWN (k9A "heinäsirkka") ; --UNCHK
lin grassland_N = mkWN (compoundN "ruoho" (k1A "tasanko")) ; --UNCHK
lin grassless_A = mkWA "ruohoton" ; --UNCHK
lin grasslike_A = mkWA (compoundA "ruoho" (k38 "mainen")) ; --UNCHK
lin grassroots_A = mkWA "kansan-" ; --UNCHK
lin grassy_A = mkWA (k38 "ruohoinen") ; --UNCHK
lin grate_N = mkWN (k12 "ritilä") ; --UNCHK
lin grate_V = mkWV (k61A "raapia") ; --UNCHK
lin grate_V2 = mkWV2 (k61A "raapia") ; --UNCHK
lin grateful_A = mkWA (k38 "kiitollinen") ; --UNCHK
lin gratefulness_N = mkWN (k40 "huomaavaisuus") ; --UNCHK
lin grater_N = mkWN (k33 "raastin") ; --UNCHK
lin gratification_N = mkWN (k40 "tyytyväisyys") ; --UNCHK
lin gratify_V2 = mkWV2 (k52A "sortua") ; --UNCHK
lin gratifying_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin grating_N = mkWN (k10 "taipuma") ; --UNCHK
lin gratingly_Adv = mkWAdv (k99 "ankarasti") ; --UNCHK
lin gratis_A = mkWA (k17 "vapaa") ; --UNCHK
lin gratis_Adv = mkWAdv (k99 "ilmaiseksi") ; --UNCHK
lin gratitude_N = mkWN (k40 "kiitollisuus") ; --UNCHK
lin gratuitous_A = mkWA (k34A "perusteeton") ; --UNCHK
lin gratuity_N = mkWN (compoundN "palvelu" (k9 "raha")) ; --UNCHK
lin grave_A = mkWA (k10 "ankara") ;
lin grave_N = mkWN (k9A "hauta") ; --UNCHK
lin grave_V2 = mkWV2 (k54A "kaivertaa") ; --UNCHK
lin gravedigger_N = mkWN (compoundN "haudan" (k10 "kaivaja")) ; --UNCHK
lin gravel_N = mkWN (k10 "sora") ; --UNCHK
lin gravel_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin gravelly_A = mkWA (compoundA "raap" (k9 "iva")) ; --UNCHK
lin gravelweed_N = mkWN "Verbesina" "helianthoides" ; --UNCHK
lin graven_A = mkWA (compoundA "kai" (k1 "verrettu")) ; --UNCHK
lin graveness_N = mkWN (k40 "synkkyys") ; --UNCHK
lin graver_N = mkWN (k33A "kaiverrin") ; --UNCHK
lin graverobber_N = mkWN (compoundN "ruumiin" (k10 "ryöstäjä")) ; --UNCHK
lin gravesend_PN = foreignPN "Gravesend" ;
lin gravestone_N = mkWN (compoundN "hauta" (k7 "kivi")) ; --UNCHK
lin graveyard_N = mkWN (k2 "kalmisto") ; --UNCHK
lin gravida_N = mkWN (k38 "nainen") "raskaana" "oleva" ; --UNCHK
lin gravidity_N = mkWN (k40 "raskaus") ; --UNCHK
lin gravimeter_N = mkWN (compoundN "gravi" (k5 "metri")) ; --UNCHK
lin graving_dock_N = mkWN (k50 "kuivatelakka") ; --UNCHK
lin gravitate_V = mkWV (k52A "suuntautua") ; --UNCHK
lin gravitation_N = mkWN (compoundN "veto" (k10 "voima")) ; --UNCHK
lin gravitational_A = mkWA (compoundA "painovoi" (k38 "mainen")) ; --UNCHK
lin graviton_N = mkWN "gravitoni" ; --UNCHK
lin gravity_N = mkWN (k40 "synkkyys") ; --UNCHK
lin gravure_N = mkWN (compoundN "syvä" (k39 "painatus")) ; --UNCHK
lin gravy_N = mkN "kastike" ;
lin gravy_boat_N = mkWN (compoundN "kastike" (k1 "kulho")) ; --UNCHK
lin graz_PN = foreignPN "Graz" ;
lin graze_N = mkWN "laidunnus" ; --UNCHK
lin graze_V = mkWV (k67 "maistella") ; --UNCHK
lin graze_V2 = mkWV2 (k67 "maistella") ; --UNCHK
lin grazier_N = mkWN (compoundN "karjan" (k10 "kasvattaja")) ; --UNCHK
lin grazing_N = mkWN (k39 "suhahdus") ; --UNCHK
lin grazing_land_N = mkWN (k1A "niitty") ; --UNCHK
lin grease_N = mkWN (k40 "törkyisyys") ; --UNCHK
lin grease_V2 = mkWV2 (k74 "öljytä") ; --UNCHK
lin greasepaint_N = mkWN (k5 "maski") ; --UNCHK
lin greaseproof_A = mkWA (k34A "läpäisemätön") "rasvaa" ; --UNCHK
lin greasewood_N = mkWN "Sarcobatus" "vermiculatus" ; --UNCHK
lin greasiness_N = mkWN (k40 "rasvaisuus") ; --UNCHK
lin greasy_A = mkWA (k38 "öljyinen") ; --UNCHK
lin great_A = mkA "hieno" | mkA "suurenmoinen" ;
lin great_N = mkWN (k40 "suuruus") ; --UNCHK
lin greatcoat_N = mkWN (k17 "palttoo") ; --UNCHK
lin greater_A = mkWA "suurempi" ; --UNCHK
lin greatest_A = mkWA (k41 "paras") ; --UNCHK
lin greathearted_A = mkWA (compoundA "ylevä" (k38 "mielinen")) ; --UNCHK
lin greatly_Adv = adjAdv great_A ; -- -- derived
lin greatness_N = mkWN (k40 "laajuus") ; --UNCHK
lin greave_N = mkWN (k10 "säärisuoja") ; --UNCHK
lin greaves_N = mkWN (k12 "kamara") "kinkun" "paistettu" ; --UNCHK
lin grebe_N = mkWN (k1A "uikku") ; --UNCHK
lin grecian_A = mkWA (k38 "helleeninen") ; --UNCHK
lin greece_PN = foreignPN "Kreikka" ;
lin greed_N = mkWN (k40 "kyltymättömyys") ; --UNCHK
lin greediness_N = mkWN (k40 "kyltymättömyys") ; --UNCHK
lin greedy_A = mkWA (k48 "ahne") ;
lin greekFem_N = mkN "kreikkalainen" ;
lin greekMasc_N = mkN "kreikkalainen" ;
lin greek_A = mkA "kreikkalainen" ;
lin green_A = L.green_A ;
lin green_N = mkN "vihreä" ; --mkWN "super" "C" ;
lin greenback_N = mkWN (k6 "seteli") "dollarin" ; --UNCHK
lin greenbelt_N = mkWN (compoundN "viher" (k48 "alue")) ; --UNCHK
lin greenbottle_N = mkWN (compoundN "raato" (k38 "kärpänen")) ; --UNCHK
lin greenery_N = mkWN (k40 "vehreys") ; --UNCHK
lin greeneye_N = mkWN (compoundN "viher" (k10 "silmä")) ; --UNCHK
lin greenfly_N = mkWN (k9 "kirva") ; --UNCHK
lin greengage_N = mkWN (compoundN "viher" (k1 "luumu")) ; --UNCHK
lin greengrocer_N = mkWN (compoundN "vihannes" (k41 "kauppias")) ; --UNCHK
lin greengrocery_N = mkWN (compoundN "vihannes" (k9A "kauppa")) "hedelmä-" "ja" ; --UNCHK
lin greenhorn_N = mkWN (k5 "noviisi") ; --UNCHK
lin greenhouse_A = mkWA "kasvihuone-" ; --UNCHK
lin greenhouse_N = mkWN (compoundN "taimi" (k9 "tarha")) ; --UNCHK
lin greenish_A = mkWA (k10 "vihertävä") ; --UNCHK
lin greenishness_N = mkWN "vihertävyys" ; --UNCHK
lin greenling_N = mkWN (compoundN "greenling-" (k9 "kala")) ; --UNCHK
lin greenmail_N = mkWN (compoundN "nurkan" (k39 "valtaus")) "ystävällismielinen" ; --UNCHK
lin greenness_N = mkWN (k40 "vihreys") ; --UNCHK
lin greenock_PN = foreignPN "Greenock" ;
lin greenockite_N = mkWN (compoundN "kadmium" (k5 "sulfidi")) ; --UNCHK
lin greenroom_N = mkWN (k3 "lämpiö") ; --UNCHK
lin greens_N = mkWN (k39 "vihannes") ; --UNCHK
lin greensand_N = mkWN (compoundN "hiekka" (k7 "kivi")) "glaukoniittipitoinen" ; --UNCHK
lin greenshank_N = mkWN (compoundN "valko" (k1 "viklo")) ; --UNCHK
lin greenside_A = mkWA (k38 "viereinen") "viheriön" ; --UNCHK
lin greenskeeper_N = mkWN (k10 "hoitaja") "golfkentän" ; --UNCHK
lin greensward_N = mkWN (k4A "nurmikko") ; --UNCHK
lin greenwich_PN = foreignPN "Greenwich" ;
lin greenwing_N = mkWN (k5 "tavi") ; --UNCHK
lin greet_V2 = mkWV2 (k53A "ottaa") "vastaan" ;
lin greeter_N = mkWN (k2 "henkilö") "tervetulleeksi" "toivottava" ; --UNCHK
lin greeting_N = mkWN (k39 "tervehdys") ; --UNCHK
lin gregarine_N = mkWN (compoundN "gregarine-itiö" (k33 "eläin")) ; --UNCHK
lin gregarious_A = mkWA (k10 "elävä") "laumassa" ; --UNCHK
lin gregariousness_N = mkWN (k40 "seurallisuus") ; --UNCHK
lin gregorian_A = mkWA (k38 "gregoriaaninen") ; --UNCHK
lin gregory_PN = foreignPN "Gregory" ;
lin gremlin_N = mkWN (k38 "maahinen") ; --UNCHK
lin grenada_PN = foreignPN "Grenada" ;
lin grenade_N = mkWN (k5A "kranaatti") ; --UNCHK
lin grenadian_A = mkWA (compoundA "grenad" (k38 "alainen")) ; --UNCHK
lin grenadian_N = mkWN (compoundN "grenad" (k38 "alainen")) ; --UNCHK
lin grenadier_N = mkWN (compoundN "lesti" (k9 "kala")) ; --UNCHK
lin grenadine_N = mkWN "grenadiini" ; --UNCHK
lin grevillea_N = mkWN (compoundN "silkki" (k41 "pensas")) ; --UNCHK
lin grey_A = mkWA (k10 "harmahtava") | mkA "harmaa" ;
lin grey_N = mkWN (k38 "hevonen") "harmaa" ; --UNCHK
lin grey_V = mkWV (k52A "harmaantua") ; --UNCHK
lin grey_V2 = mkWV2 (k52A "harmaantua") ; --UNCHK
lin greyback_N = mkWN (compoundN "iso" (k5 "sirri")) ; --UNCHK
lin greybeard_N = mkWN (k1 "kannu") ; --UNCHK
lin greyhen_N = mkWN (compoundN "metsäkana" (k41 "naaras")) ; --UNCHK
lin greyhound_N = mkWN (compoundN "vintti" (k10 "koira")) ; --UNCHK
lin greyish_A = mkWA (k10 "harmahtava") ; --UNCHK
lin greylag_N = mkWN (compoundN "meri" (k7 "hanhi")) ; --UNCHK
lin grid_N = mkWN (k6 "halstari") ; --UNCHK
lin griddle_N = mkWN (k12 "parila") ; --UNCHK
lin gridiron_N = mkWN (compoundN "jalkapallo" (k10A "kenttä")) "amerikkalainen" ; --UNCHK
lin gridlock_N = mkWN (k10 "suma") ; --UNCHK
lin grief_N = mkWN (k1 "suru") ; --UNCHK
lin grievance_N = mkN "epä" (mkN "kohta") ; --mkWN (k48 "aihe") "valituksen" ;
lin grieve_V = mkWV (k61A "murehtia") ; --UNCHK
lin grieve_V2 = mkWV2 (k61A "murehtia") ; --UNCHK
lin grievous_A = mkWA (k10 "ankara") ; --UNCHK
lin griffin_N = mkWN (compoundN "vaaka" (k1A "lintu")) ; --UNCHK
lin griffon_N = mkWN "hanhikorppikotka" ; --UNCHK
lin grigri_N = mkWN "grigri" ; --UNCHK
lin grill_N = mkWN (k4A "ristikko") ; --UNCHK
lin grill_V = mkWV (k73A "tentata") ; --UNCHK
lin grill_V2 = mkWV2 (k73A "tentata") ; --UNCHK
lin grille_N = mkWN (k4A "ristikko") ; --UNCHK
lin grillroom_N = mkWN (k5 "grilli") ; --UNCHK
lin grim_A = mkWA (k10 "kamala") ; --UNCHK
lin grimace_N = mkWN (k48 "ilme") ; --UNCHK
lin grimace_V = mkWV (k67 "irvistellä") ; --UNCHK
lin grime_N = mkWN (k40 "törkyisyys") ; --UNCHK
lin grime_V2 = mkWV2 (k73 "kurata") ; --UNCHK
lin grimethorpe_PN = foreignPN "Grimethorpe" ;
lin griminess_N = mkWN "nuhruisuus" ; --UNCHK
lin grimness_N = mkWN (k40 "vakavuus") ; --UNCHK
lin grimoire_N = mkWN (compoundN "taika" (k9 "kirja")) ; --UNCHK
lin grimsby_PN = foreignPN "Grimsby" ;
lin grimy_A = mkWA (k34A "siivoton") ; --UNCHK
lin grin_N = mkWN (k39 "virnistys") ; --UNCHK
lin grin_V = mkWV (k67 "virnistellä") ; --UNCHK
lin grind_N = mkWN (compoundN "hie" (k38 "nontaminen")) ; --UNCHK
lin grind_V = mkV "jauhaa" ; --mkWV (k73 "muusata") ;
lin grind_V2 = mkWV2 (k73 "muusata") ; --UNCHK
lin grind_away_V = mkWV (k56A "ahtaa") "päähänsä" ; --UNCHK
lin grind_down_V2 = mkWV2 (k62 "tyrannisoida") ; --UNCHK
lin grinder_N = mkWN (k33A "teroitin") ; --UNCHK
lin grinding_N = mkWN (k9A "kirskunta") ; --UNCHK
lin grindstone_N = mkWN (k1 "tahko") ; --UNCHK
lin gringo_N = mkWN (compoundN "ulko" (k38 "maalainen")) ; --UNCHK
lin grinner_N = mkWN "virnuilija" ; --UNCHK
lin griot_N = mkWN "griotti" ; --UNCHK
lin grip_N = mkWN (k48A "ote") ;
lin grip_V2 = mkWV2 (k52A "tarttua") ; --UNCHK
lin gripe_N = mkWN (k39 "ruikutus") ; --UNCHK
lin gripe_VS = mkWVS (k53A "valittaa") ; --UNCHK
lin grippe_N = mkWN (k10 "flunssa") ; --UNCHK
lin gripsack_N = mkWN (compoundN "matka" (k1A "laukku")) "pieni" ; --UNCHK
lin grisaille_N = mkWN "grisaille" ; --UNCHK
lin griseofulvin_N = mkWN (k5 "griseofulviini") ; --UNCHK
lin grisly_A = mkWA (k10 "kamala") ; --UNCHK
lin grison_N = mkWN "Grison" "vittatus" ; --UNCHK
lin grissino_N = mkWN (compoundN "leipä" (k1A "tikku")) ; --UNCHK
lin grist_N = mkWN (k9 "vilja") "jauhettava" ; --UNCHK
lin gristle_N = mkWN (k1 "rusto") ; --UNCHK
lin gristmill_N = mkWN (k1 "mylly") ; --UNCHK
lin grit_N = mkWN (k40 "tarmokkuus") ; --UNCHK
lin grit_V2 = mkWV2 (k53A "narskuttaa") ; --UNCHK
lin grits_N = mkWN (compoundN "maissi" (k5 "velli")) ; --UNCHK
lin gritty_A = mkWA (k15 "rohkea") ; --UNCHK
lin grivet_N = mkWN (compoundN "häntä" (k12 "apina")) ; --UNCHK
lin grizzle_N = mkWN (k5A "peruukki") "harmaa" ; --UNCHK
lin grizzle_V = mkWV (k66 "kitistä") ; --UNCHK
lin grizzled_A = mkWA (k38 "harmaahapsinen") ; --UNCHK
lin grizzly_N = mkWN (k50 "harmaakarhu") ; --UNCHK
lin groan_N = mkWN (k39 "valitus") ; --UNCHK
lin groan_V = mkWV (k73 "purnata") ; --UNCHK
lin groan_V2 = mkWV2 (k73 "purnata") ; --UNCHK
lin groaner_N = mkWN (k10 "valittaja") ; --UNCHK
lin groat_N = mkWN (k9 "raha") "neljän" "pennyn" ; --UNCHK
lin groats_N = mkWN (k48 "rouhe") ; --UNCHK
lin grocer_N = mkWN (compoundN "sekatavara" (k9A "kauppa")) ; --UNCHK
lin grocery_N = mkWN (compoundN "elin" (k48A "tarvike")) ; --UNCHK
lin groenendael_N = mkWN "belgianpaimenkoira" "groenendael" ; --UNCHK
lin grog_N = mkWN (k5 "grogi") ; --UNCHK
lin grogginess_N = mkWN (k12 "tokkura") ; --UNCHK
lin groggy_A = mkWA (k38 "tokkurainen") ; --UNCHK
lin grogram_N = mkWN (k41A "grogram-kangas") ; --UNCHK
lin groin_N = mkWN (compoundN "ranta" (k49A "penger")) ; --UNCHK
lin groin_V2 = mkWV2 (k53 "varustaa") "ristikaarella" ; --UNCHK
lin gromwell_N = mkWN (k26 "rusojuuri") ; --UNCHK
lin groningen_PN = foreignPN "Groningen" ;
lin groom_N = mkWN (k38 "sulhanen") ; --UNCHK
lin groom_V2 = mkWV2 (k61 "siistiä") ; --UNCHK
lin groomsman_N = mkWN (k10 "avustaja") "sulhasen" ; --UNCHK
lin groove_N = mkWN (k10 "uoma") ; --UNCHK
lin groove_V2 = mkWV2 (k71 "tehdä") "uurre" ; --UNCHK
lin groover_N = mkWN (k33A "kaiverrin") ; --UNCHK
lin grooving_N = mkWN (k39 "rihlaus") ; --UNCHK
lin groovy_A = mkWA (k41A "tyylikäs") ; --UNCHK
lin grope_N = mkWN (k2 "tunnustelu") ; --UNCHK
lin grope_V = mkWV (k67 "puristella") ; --UNCHK
lin grope_V2 = mkWV2 (k67 "puristella") ; --UNCHK
lin gropingly_Adv = mkWAdv (compoundAdv "hapuilev" (k99 "asti")) ; --UNCHK
lin grosbeak_N = mkWN (k1A "lintu") "Passeriformes-lahkon" ; --UNCHK
lin groschen_N = mkWN "groschen" ; --UNCHK
lin grosgrain_N = mkWN (k41A "grosgrain-kangas") ; --UNCHK
lin gross_A = mkWA "kokonais-" ; --f56
lin gross_N = mkWN (k1A "brutto") ; --UNCHK
lin grossness_N = mkWN (k40 "rivous") ; --UNCHK
lin grosz_N = mkWN "grosz" ; --UNCHK
lin grot_N = mkWN (k10 "luola") ; --UNCHK
lin grotesque_A = mkWA (k10 "hirvittävä") ; --UNCHK
lin grotesque_N = mkWN (compoundN "groteski" (k48A "taide")) ; --UNCHK
lin grotesqueness_N = mkWN (k40 "kammottavuus") ; --UNCHK
lin grotto_N = mkWN (k10 "luola") ; --UNCHK
lin grotty_A = mkWA (k38 "viheliäinen") ; --UNCHK
lin grouch_N = mkWN (k12 "kiukuttelija") ; --UNCHK
lin grouch_V = mkWV (k52 "torua") ; --UNCHK
lin grouchy_A = mkWA (k10 "ärtyisä") ; --UNCHK
lin ground_1_N = mkN "tontti" | mkN "perusta" ;
lin ground_2_N = mkN "peruste" ;
lin ground_N = mkN "perusta" ;
lin ground_V = mkWV (k52A "pohjautua") ; --UNCHK
lin ground_V2 = mkWV2 (k52A "pohjautua") ; --UNCHK
lin ground_bait_N = mkWN (compoundN "kalan" (k5A "syötti")) "veteen" "ripoteltava" ; --UNCHK
lin ground_plan_N = mkWN (compoundN "pohja" (k39 "piirros")) ; --UNCHK
lin ground_rent_N = mkWN (compoundN "maan" (k10 "vuokra")) ; --UNCHK
lin groundbreaking_N = mkWN (compoundN "aloitus" (k12 "seremonia")) "rakennusprojektin" ; --UNCHK
lin groundcover_N = mkWN (compoundN "pohja" (k40 "kasvillisuus")) ; --UNCHK
lin ground_fish_N = mkWN (compoundN "pohja" (k9 "kala")) ; --UNCHK
lin groundhog_N = mkWN (compoundN "metsä" (k6 "murmeli")) ; --UNCHK
lin grounding_N = mkWN (k39 "maadoitus") ; --UNCHK
lin groundless_A = mkWA (k10 "joutava") ; --UNCHK
lin groundlessness_N = mkWN (k40 "tyhjänpäiväisyys") ; --UNCHK
lin groundling_N = mkWN "groundling" ; --UNCHK
lin groundmass_N = mkWN (compoundN "perus" (k9 "massa")) ; --UNCHK
lin groundnut_N = mkWN (compoundN "maa" (k12 "pähkinä")) ; --UNCHK
lin grounds_N = mkWN (k9 "piha") ; --UNCHK
lin groundsel_N = mkWN (compoundN "pelto" (k4A "villakko")) ; --UNCHK
lin groundsheet_N = mkWN (compoundN "suoja-" (k13 "alusta")) ; --UNCHK
lin groundsman_N = mkWN (k6 "puutarhuri") ; --UNCHK
lin groundspeed_N = mkWN (compoundN "maa" (k40 "nopeus")) ; --UNCHK
lin groundwork_N = mkWN (compoundN "pohja" (k19 "työ")) ; --UNCHK
lin group_N = mkN "ryhmä" ;
lin group_V = mkWV (k67A "luokitella") ; --UNCHK
lin group_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin grouper_N = mkWN (compoundN "meri" (k32 "ahven")) ; --UNCHK
lin groupie_N = mkWN (k5 "fani") ; --UNCHK
lin grouping_N = mkWN (k10 "ryhmittymä") ; --UNCHK
lin groupthink_N = mkWN (compoundN "ryhmä" (k2 "ajattelu")) ; --UNCHK
lin groupware_N = mkWN (compoundN "työryhmä" (k1 "ohjelmisto")) ; --UNCHK
lin grouse_N = mkWN (compoundN "metsä" (k9 "kana")) ; --UNCHK
lin grouse_V = mkWV (k53A "valittaa") ; --UNCHK
lin grouse_VS = mkWVS (k53A "valittaa") ; --UNCHK
lin grouseberry_N = mkWN "Vaccinium" "scoparium" ; --UNCHK
lin grout_N = mkWN (k5 "laasti") ; --UNCHK
lin grove_N = mkWN (k4A "metsikkö") ; --UNCHK
lin grovel_V = mkWV (k52 "kyyristyä") "peloissaan" ; --UNCHK
lin groveller_N = mkWN (k12 "matelija") ; --UNCHK
lin grow_V = mkV "kasvaa" ;
lin grow_V2 = mkV2 "kasvattaa" ;
lin grow_VA = mkVA (mkV "kasvaa") (mkPrep translative) ;
lin grow_apart_V = advV OP_grow_V OP_apart_Adv ; -- guess-p-verb
lin grow_away_from_V2 = prepV2 (advV OP_grow_V OP_away_Adv ) OP_from_Prep ; -- guess-p-verb
lin grow_back_V = advV OP_grow_V OP_back_Adv ; -- guess-p-verb
lin grow_from_V2 = prepV2 OP_grow_V OP_from_Prep ; -- guess-p-verb
lin grow_into_V2 = prepV2 OP_grow_V OP_into_Prep ; -- guess-p-verb
lin grow_on_V2 = prepV2 OP_grow_V OP_on_Prep ; -- guess-p-verb
lin grow_out_V = advV OP_grow_V OP_out_Adv ; -- guess-p-verb
lin grow_out_of_V2 = prepV2 (advV OP_grow_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin grow_to_V = advV OP_grow_V OP_to_Adv ; -- guess-p-verb
lin grow_together_V = advV OP_grow_V OP_together_Adv ; -- guess-p-verb
lin grow_under_V = advV OP_grow_V OP_under_Adv ; -- guess-p-verb
lin grow_up_V = mkWV (k52A "varttua") ; --UNCHK
lin grow_up_on_V2 = prepV2 (advV OP_grow_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin grow_upon_V2 = prepV2 OP_grow_V OP_upon_Prep ; -- guess-p-verb
lin grower_N = mkWN (k10 "tuottaja") ; --UNCHK
lin growing_A = mkA "kasvava" ;
lin growing_N = mkWN "kehittyminen" ; --UNCHK
lin growl_N = mkWN (k12 "murina") ; --UNCHK
lin growl_V = mkWV (k66 "murista") ; --UNCHK
lin growl_V2 = mkWV2 (k66 "murista") ; --UNCHK
lin growler_N = mkWN (k26 "jäävuori") "pieni" ; --UNCHK
lin growling_N = mkWN (k12 "murina") ; --UNCHK
lin growth_N = mkN "kasvu" ;
lin groyne_N = mkWN (compoundN "ranta" (k49A "penger")) ; --UNCHK
lin grub_N = mkWN (k10A "toukka") ; --UNCHK
lin grub_V = mkWV (k61A "tonkia") ; --UNCHK
lin grub_V2 = mkWV2 (k61A "tonkia") ; --UNCHK
lin grubbiness_N = mkWN "nuhruisuus" ; --UNCHK
lin grubby_A = mkWA (k38 "toukkainen") ; --UNCHK
lin grubby_N = mkWN "Myxocephalus" "aenaeus" ; --UNCHK
lin grubstake_N = mkWN (k39 "sijoitus") ; --UNCHK
lin grudge_N = mkWN (k40 "vääryys") ; --UNCHK
lin grudge_V2 = mkWV2 (k64 "suoda") "vastahakoisesti" ; --UNCHK
lin grudging_A = mkWA (k9A "saita") ; --UNCHK
lin gruel_N = mkWN (k5 "velli") ; --UNCHK
lin gruelling_A = mkWA (k10 "vaativa") ; --UNCHK
lin gruesome_A = mkWA (k10 "kamala") ; --UNCHK
lin gruesomeness_N = mkWN (k40 "karmeus") ; --UNCHK
lin gruff_A = mkWA (k15 "käheä") ; --UNCHK
lin gruffness_N = mkWN (k40 "karkeus") ; --UNCHK
lin grugru_N = mkWN "Acrocomia" "aculeata" ; --UNCHK
lin grumble_N = mkWN (k39 "purnaus") ; --UNCHK
lin grumble_V = mkWV (k66 "äristä") ; --UNCHK
lin grumble_V2 = mkWV2 (k66 "äristä") ; --UNCHK
lin grumble_VS = mkWVS (k66 "äristä") ; --UNCHK
lin grumbler_N = mkWN (k12 "marisija") ; --UNCHK
lin grume_N = mkWN (k5 "trombi") ; --UNCHK
lin grumpiness_N = mkWN (k40 "uppiniskaisuus") ; --UNCHK
lin grumpy_A = mkWA (k10 "ärtyisä") ; --UNCHK
lin grundyism_N = mkWN (k2 "hienostelu") ; --UNCHK
lin grunt_N = mkWN (compoundN "muri" (k9 "sija")) ; --UNCHK
lin grunt_V = mkWV (k66 "murista") ; --UNCHK
lin grunt_V2 = mkWV2 (k66 "murista") ; --UNCHK
lin grunter_N = mkWN (k1 "possu") ; --UNCHK
lin gryphon_N = mkWN (compoundN "vaaka" (k1A "lintu")) ; --UNCHK
lin guacamole_N = mkWN "guacamole" ; --UNCHK
lin guadalajara_PN = foreignPN "Guadalajara" ;
lin guaiacum_N = mkWN "suku" "Guaiacum" ; --UNCHK
lin guama_N = mkWN "Inga" "laurina" ; --UNCHK
lin guan_N = mkWN (compoundN "saku" (k9 "kana")) ; --UNCHK
lin guanaco_N = mkWN "guanako" ; --UNCHK
lin guanine_N = mkWN (compoundN "gua" (k26 "niini")) ; --UNCHK
lin guano_N = mkWN (k1 "guano") ; --UNCHK
lin guar_N = mkWN (compoundN "terttu" (k1A "papu")) ; --UNCHK
lin guarantee_N = mkWN (k17 "takuu") ; --f83
lin guarantee_V = mkWV (k73A "luvata") ; --UNCHK
lin guarantee_V2 = mkV2 "taata" ;
lin guarantee_VS = mkWVS (k73A "luvata") ; --UNCHK
lin guarantor_N = mkWN (k10 "takaaja") ; --UNCHK
lin guaranty_N = mkWN (k17 "takuu") ; --UNCHK
lin guard_N = mkN "vartija" ;
lin guard_V = mkWV (k73 "suojata") ; --UNCHK
lin guard_V2 = mkV2 "suojata" partitive ;
lin guard_boat_N = mkWN (compoundN "vartio" (k9 "laiva")) ; --UNCHK
lin guardhouse_N = mkWN (compoundN "vartio" (k10A "tupa")) ; --UNCHK
lin guardian_N = mkWN (k5A "vahti") ; --UNCHK
lin guardianship_N = mkWN (k10 "turva") ; --UNCHK
lin guardrail_N = mkWN (compoundN "suoja" (k48A "kaide")) ; --UNCHK
lin guardroom_N = mkWN (compoundN "vartio" (k10A "tupa")) ; --UNCHK
lin guardsman_N = mkWN (k38 "kaartilainen") ; --UNCHK
lin guatemala_PN = foreignPN "Guatemala" ;
lin guatemalan_A = mkWA (compoundA "guatemal" (k38 "alainen")) ; --UNCHK
lin guatemalan_N = mkWN (compoundN "guatemal" (k38 "alainen")) ; --UNCHK
lin guava_N = mkWN (k9 "guava") ; --UNCHK
lin guayaquil_PN = foreignPN "Guayaquil" ;
lin guayule_N = mkWN "Parthenium" "argentatum" ; --UNCHK
lin gubernatorial_A = mkWA "kuvernöörin" ; --UNCHK
lin gudgeon_N = mkWN "Gobio" "gobio" ; --UNCHK
lin guelder_rose_N = mkWN (compoundN "koiran" (k27 "heisi")) ; --UNCHK
lin guenon_N = mkWN (compoundN "guenon-" (k12 "apina")) ; --UNCHK
lin guerdon_N = mkWN (k3 "palkkio") ; --UNCHK
lin guereza_N = mkWN "Colobus" "guereza" ; --UNCHK
lin gueridon_N = mkWN (k10A "pöytä") "pieni" "pyöreä" ; --UNCHK
lin guerilla_N = mkWN (k5 "partisaani") ; --UNCHK
lin guerrilla_N = mkWN (k5 "partisaani") ; --UNCHK
lin guess_N = mkWN (k2 "arvelu") ; --UNCHK
lin guess_V = mkWV (k73 "arvata") ; --UNCHK
lin guess_V2 = mkWV2 (k73 "arvata") ; --UNCHK
lin guess_VS = mkWVS (k73 "arvata") ; --UNCHK
lin guesser_N = mkWN "arvaaja" ; --UNCHK
lin guesstimate_N = mkWN (k39 "arvaus") "karkea" ; --UNCHK
lin guesswork_N = mkWN (k2 "arvelu") ; --UNCHK
lin guest_N = mkN "vieras" | mkWN (k12 "vierailija") ;
lin guesthouse_N = mkWN (compoundN "vieras" (k1 "talo")) ; --UNCHK
lin guestroom_N = mkWN (compoundN "vieras" (k48 "huone")) ; --UNCHK
lin guffaw_N = mkWN (k39 "hohotus") ; --UNCHK
lin guffaw_V = mkWV (k56 "nauraa") "äänekkäästi" ; --UNCHK
lin guidance_N = mkWN (k39 "ohjaus") ; --UNCHK
lin guide_N = mkWN (k9A "merkintä") ; --UNCHK
lin guide_V2 = mkWV2 (k53A "liikuttaa") ; --UNCHK
lin guidebook_N = mkWN (k41A "opas") ; --UNCHK
lin guideline_N = mkN (lin NK {s = d48 "ohje"}) ;
lin guidepost_N = mkWN (k39 "suositus") ; --UNCHK
lin guiding_A = mkWA (compoundA "ohj" (k9 "aava")) ; --UNCHK
lin guild_N = mkN "kilta" ; --mkWN (k5 "loosi") ;
lin guilder_N = mkWN (k6 "floriini") "Hollannin" ; --UNCHK
lin guildford_PN = foreignPN "Guildford" ;
lin guild_hall_N = mkWN (compoundN "kilta" (k1 "talo")) ; --UNCHK
lin guile_N = mkWN (k39 "petos") ; --UNCHK
lin guileful_A = mkWA (k10 "näppärä") ; --UNCHK
lin guileless_A = mkWA (k38 "rehellinen") ; --UNCHK
lin guilloche_N = mkWN (compoundN "guilloche-" (k3 "kuvio")) ; --UNCHK
lin guillotine_N = mkWN (k5 "giljotiini") ; --UNCHK
lin guillotine_V2 = mkWV2 (k73 "mestata") "giljotiinilla" ; --UNCHK
lin guilt_N = mkWN (k51 "omatunto") "syyllinen" ; --UNCHK
lin guiltiness_N = mkWN (k40 "syyllisyys") ; --UNCHK
lin guiltless_A = mkWA (k34A "syytön") ; --UNCHK
lin guilty_A = mkWA (k38 "syyllinen") ; --f67
lin guimpe_N = mkWN "guimpe" ; --UNCHK
lin guinea_N = mkN "guinea" ; --WN (compoundN "helmi" (k9 "kana")) ;
lin guinea_PN = foreignPN "Guinea" ;
lin guinea_fowl_N = mkWN (compoundN "helmi" (k9 "kana")) ; --UNCHK
lin guinea_pig_N = mkWN (k1 "marsu") ; --UNCHK
lin guinean_A = mkWA (compoundA "guine" (k38 "alainen")) ; --UNCHK
lin guinean_N = mkWN (compoundN "guine" (k38 "alainen")) ; --UNCHK
lin guinness_N = mkWN "Guinness" ; --UNCHK
lin guisborough_PN = foreignPN "Guisborough" ;
lin guise_N = mkWN (k48A "veruke") ; --UNCHK
lin guitar_N = mkWN (k13 "kitara") ; --UNCHK
lin guitarfish_N = mkWN (compoundN "kitara" (k1 "rausku")) ; --UNCHK
lin guitarist_N = mkWN (k5 "kitaristi") ; --UNCHK
lin gulag_N = mkWN (compoundN "vanki" (k5 "leiri")) "venäläinen" ; --UNCHK
lin gulch_N = mkWN (k1 "kuru") ; --UNCHK
lin gulden_N = mkWN (k6 "floriini") "Hollannin" ; --UNCHK
lin gulf_N = mkWN (k10A "juopa") ; --UNCHK
lin gulfweed_N = mkWN (compoundN "marja" (k10 "levä")) ; --UNCHK
lin gull_1_N = mkWN (k5A "lokki") ; --UNCHK
lin gull_2_N = mkWN (k5A "lokki") ; --UNCHK
lin gull_V2 = mkWV2 (k73 "narrata") ; --UNCHK
lin gullet_N = mkWN (k1 "nielu") ; --UNCHK
lin gullibility_N = mkWN "hyväuskoisuus" ; --UNCHK
lin gullible_A = mkWA (compoundA "sini" (k38 "silmäinen")) ; --UNCHK
lin gully_N = mkWN (compoundN "vesi" (k39 "uurros")) ; --UNCHK
lin gulp_N = mkWN (k10A "huikka") ; --UNCHK
lin gulp_V = mkWV (k66 "kähistä") ; --UNCHK
lin gulp_V2 = mkWV2 (k66 "kähistä") ; --UNCHK
lin gulper_N = mkWN "ahmija" ; --UNCHK
lin gulping_N = mkWN (compoundN "nielaisu" (k6 "refleksi")) ; --UNCHK
lin gum_N = mkN "kumi" ; ---ARB --mkWN (k32A "ien") ;
lin gum_V2 = mkWV2 (k53A "erittää") "pihkaa" ; --UNCHK
lin gumbo_N = mkWN "gumbo" ; --UNCHK
lin gumboil_N = mkWN "gumboil" ; --UNCHK
lin gumdrop_N = mkWN (compoundN "hedelmä" (k5 "karamelli")) "sokeripäällysteinen" ; --UNCHK
lin gumma_N = mkWN "gumma" ; --UNCHK
lin gummite_N = mkWN "gummiitti" ; --UNCHK
lin gummosis_N = mkWN (compoundN "kurkun" (k1A "laikku")) ; --UNCHK
lin gummy_A = mkWA (k15 "tahmea") ; --UNCHK
lin gumption_N = mkWN (k40 "tarmokkuus") ; --UNCHK
lin gumshoe_N = mkWN (k5 "kalossi") ; --UNCHK
lin gumweed_N = mkWN (k5 "kasvi") "Grindelia-suvun" ; --UNCHK
lin gumwood_N = mkWN (compoundN "kumi" (k18 "puu")) ; --UNCHK
lin gun_N = mkN "ase" ; --WN (compoundN "tykin" (k39 "laukaus")) ;
lin gun_V2 = mkWV2 (k52A "ampua") ; --UNCHK
lin gun_carriage_N = mkWN (k5A "lavetti") ; --UNCHK
lin gunboat_N = mkWN (compoundN "tykki" (k48 "vene")) ; --UNCHK
lin guncotton_N = mkWN (compoundN "nitro" (k10 "selluloosa")) ; --UNCHK
lin gunfight_N = mkWN (k2 "ammuskelu") ; --UNCHK
lin gunfire_N = mkWN (k39 "laukaus") ; --UNCHK
lin gunflint_N = mkWN (compoundN "pii" (k7 "kivi")) "aseen" ; --UNCHK
lin gunite_N = mkWN (compoundN "ruisku" (k6 "betoni")) ; --UNCHK
lin gunlock_N = mkWN (k39 "lukitus") "aseen" ; --UNCHK
lin gunman_N = mkWN (compoundN "palkka" (k10 "murhaaja")) ; --UNCHK
lin gunmetal_N = mkWN (compoundN "ase" (k5 "metalli")) ; --UNCHK
lin gunnel_N = mkWN (kH1 "teisti") ; --UNCHK
lin gunner_N = mkWN (compoundN "tykki" (k42 "mies")) ; --UNCHK
lin gunnery_N = mkWN "aseisto" ; --UNCHK
lin gunny_N = mkWN (k41A "juuttikangas") ; --UNCHK
lin gunnysack_N = mkWN (compoundN "juutti" (k5A "säkki")) ; --UNCHK
lin gunplay_N = mkWN (k2 "ammuskelu") ; --UNCHK
lin gunpoint_N = mkWN (k1A "piippu") "aseen" ; --UNCHK
lin gunpowder_N = mkWN (k5A "ruuti") ; --UNCHK
lin gunrunner_N = mkWN (compoundN "sala" (k10 "kuljettaja")) "aseiden" ; --UNCHK
lin gunrunning_N = mkWN (compoundN "sala" (k39 "kuljetus")) "aseiden" ; --UNCHK
lin gunshot_N = mkWN (k39 "laukaus") ; --UNCHK
lin gunsight_N = mkWN (k33 "tähtäin") ; --UNCHK
lin gunsmith_N = mkWN (compoundN "ase" (k10A "seppä")) ; --UNCHK
lin gunwale_N = mkWN (k5A "reelinki") ; --UNCHK
lin guppy_N = mkWN "Lebistes" "reticulatus" ; --UNCHK
lin gurgle_N = mkWN (k39 "pulputus") ; --UNCHK
lin gurgle_V = mkWV (k66 "kurista") ; --UNCHK
lin gurkha_N = mkWN "gurkha" ; --UNCHK
lin gurnard_N = mkWN (k9 "kala") "Scorpaenidae-heimon" ; --UNCHK
lin guru_N = mkWN (k1 "guru") ; --UNCHK
lin gush_N = mkWN (k39 "räjähdys") ; --UNCHK
lin gush_V = mkWV (k52 "kehua") "voimakkaasti" ; --UNCHK
lin gusher_N = mkWN (compoundN "öljy" (k48A "lähde")) "pulppuava" ; --UNCHK
lin gushingly_Adv = mkWAdv (compoundAdv "intoilev" (k99 "asti")) ; --UNCHK
lin gusset_N = mkWN (k9 "kiila") ; --UNCHK
lin gusseted_A = mkWA (compoundA "varus" (k1 "tettu")) "kiilalla" ; --UNCHK
lin gussy_up_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin gust_N = mkWN (k6 "puhuri") ; --UNCHK
lin gustation_N = mkWN (k1A "maku") ; --UNCHK
lin gustatory_A = mkWA "maistumis-" ; --UNCHK
lin gusto_N = mkWN (k40 "innostuneisuus") ; --UNCHK
lin gusty_A = mkWA (k38 "puuskittainen") ; --UNCHK
lin gut_N = mkN "sisu" ; ---ARB --mkN "suoli" ; --mkN "sisälmys" ; --mkWN (k5A "katgutti") ;
lin gut_V2 = mkWV2 (k53A "ottaa") "sisälmykset" ; --UNCHK
lin gutless_A = mkWA (k38 "pelkurimainen") ; --UNCHK
lin gutlessness_N = mkWN "pelkurimaisuus" ; --UNCHK
lin guts_N = L.guts_N ;
lin gutsiness_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin gutsy_A = mkWA (k15 "rohkea") ; --UNCHK
lin gutter_N = mkWN (k1 "kouru") ; --UNCHK
lin gutter_V = mkWV (k53 "varustaa") "ränneillä" ; --UNCHK
lin guttersnipe_N = mkWN (compoundN "katu" (k10A "poika")) ; --UNCHK
lin guttural_A = mkWA (compoundA "guttura" (k38 "alinen")) ; --UNCHK
lin guttural_N = mkWN (k5A "konsonantti") "faryngaalinen" ; --UNCHK
lin guvnor_N = mkWN (k1 "pomo") ; --UNCHK
lin guy_N = mkN "kaveri" ; --f62
lin guy_V2 = mkWV2 (k58A "tukea") "vaijerilla" ; --UNCHK
lin guyana_PN = foreignPN "Guyana" ;
lin guyanese_A = mkWA (compoundA "guyan" (k38 "alainen")) ; --UNCHK
lin guyanese_N = mkWN (compoundN "guyan" (k38 "alainen")) ; --UNCHK
lin guyot_N = mkWN (kH1 "vuori") "merenalainen" ; --UNCHK
lin guzzle_V = mkWV (k61 "hotkia") ; --UNCHK
lin guzzle_V2 = mkWV2 (k61 "hotkia") ; --UNCHK
lin guzzler_N = mkWN "ahmija" ; --UNCHK
lin gym_N = mkWN (k5 "sali") ; --UNCHK
lin gymkhana_N = mkWN (compoundN "ratsastus" (k2 "kilpailu")) ; --UNCHK
lin gymnasium_N = mkWN (k5 "sali") ; --UNCHK
lin gymnast_N = mkWN (k12 "voimistelija") ; --UNCHK
lin gymnastic_A = mkWA "voimistelu-" ; --UNCHK
lin gymnastics_N = mkWN (k2 "voimistelu") ; --UNCHK
lin gymnosophical_A = mkWA (compoundA "gymnosofia" (k38 "alinen")) ; --UNCHK
lin gymnosophist_N = mkWN "gymnosofi" ; --UNCHK
lin gymnosophy_N = mkWN "gymnosofia" ; --UNCHK
lin gymnosperm_N = mkWN (k5 "kasvi") "paljassiemeninen" ; --UNCHK
lin gymnospermous_A = mkWA (compoundA "paljas" (k38 "siemeninen")) ; --UNCHK
lin gymslip_N = mkWN (compoundN "liivi" (k48 "hame")) ; --UNCHK
lin gynaecological_A = mkWA (k38 "gynekologinen") ; --UNCHK
lin gynaecologist_N = mkWN (k5 "gynekologi") ; --UNCHK
lin gynaecology_N = mkWN (k12 "gynekologia") ; --UNCHK
lin gynandromorphic_A = mkWA "gynandromorfinen" ; --UNCHK
lin gynecocracy_N = mkWN "gynarkia" ; --UNCHK
lin gynecological_A = mkWA (k38 "gynekologinen") ; --UNCHK
lin gynecologistFem_N = variants {} ; ---- sense to be split
lin gynecologistMasc_N = mkWN (k5 "gynekologi") ; --UNCHK
lin gynecology_N = mkWN (k12 "gynekologia") ; --UNCHK
lin gynecomastia_N = mkWN (compoundN "gynekom" (k12 "astia")) ; --UNCHK
lin gyneolatry_N = mkWN (compoundN "naisen" (k9A "palvonta")) ; --UNCHK
lin gynoecium_N = mkWN (k3 "emiö") ; --UNCHK
lin gynogenesis_N = mkWN "gynogeneesi" ; --UNCHK
lin gynophobia_N = mkWN (compoundN "gyno" (k12 "fobia")) ; --UNCHK
lin gynophore_N = mkWN (compoundN "emiö" (k26 "pieli")) ; --UNCHK
lin gynostegium_N = mkWN (k10 "osa") "Asclepias-suvun" "kasvien" ; --UNCHK
lin gyp_N = mkWN (k39 "huijaus") ; --UNCHK
lin gyp_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin gypsum_N = mkWN (k5 "kipsi") ; --UNCHK
lin gypsy_N = mkWN (k6 "romani") ; --UNCHK
lin gyral_A = mkWA "aivopoimu-" ; --UNCHK
lin gyrate_V = mkWV (k52A "kieppua") ; --UNCHK
lin gyration_N = mkWN "pyöriminen" ;
lin gyrfalcon_N = mkWN (compoundN "tunturi" (k9A "haukka")) ; --UNCHK
lin gyro_N = mkWN (k10 "hyrrä") ; --UNCHK
lin gyrocompass_N = mkWN (compoundN "hyrrä" (k5 "kompassi")) ; --UNCHK
lin gyromitra_N = mkWN (compoundN "korva" (k26 "sieni")) ; --UNCHK
lin gyroscope_N = mkWN (k10 "hyrrä") ; --UNCHK
lin gyroscopic_A = mkWA (compoundA "gyroskooppi" (k38 "nen")) ; --UNCHK
lin gyrostabilizer_N = mkWN (compoundN "hyrrä" (k33 "vakain")) ; --UNCHK
lin gyrus_N = mkWN (compoundN "aivo" (k1 "poimu")) ; --UNCHK
lin ha'p'orth_N = mkWN (k1 "arvo") "puolen" "pennyn" ; --UNCHK
lin ha'penny_N = mkWN (k4A "kolikko") "puolen" "pennyn" ; --UNCHK
lin ha_Interj = variants {} ; --
lin haapajärvi_PN = mkPN (mkN "Haapajärvi" "Haapajärviä") ;
lin haapavesi_PN = mkPN (mkN "Haapavesi" "Haapaveden" "Haapavesiä") ;
lin haarlem_PN = foreignPN "Haarlem" ;
lin habanera_N = mkWN "habanera" ; --UNCHK
lin haberdasher_N = mkWN (compoundN "miestenvaate" (k41 "kauppias")) ; --UNCHK
lin haberdashery_N = mkWN (compoundN "vaate" (k9A "kauppa")) ; --UNCHK
lin habergeon_N = mkWN (compoundN "rengas" (k9A "paita")) "hihaton" ; --UNCHK
lin habit_N = mkN (lin NK {s = d09A "tapa"}) ;
lin habitability_N = mkWN (compoundN "asumis" (k40 "kelpoisuus")) ; --UNCHK
lin habitable_A = mkWA (compoundA "asuin" (k38 "kelpoinen")) ; --UNCHK
lin habitat_N = mkWN (k5A "habitaatti") ; --UNCHK
lin habitation_N = mkWN (compoundN "asu" (k38 "minen")) ; --UNCHK
lin habited_A = mkWA "asuun" "pukeutunut" ; --UNCHK
lin habitual_A = mkWA (k38 "totunnainen") ; --UNCHK
lin habituate_V2 = mkWV2 (k53A "sopeuttaa") ; --UNCHK
lin habituation_N = mkWN "tottuminen" ; --UNCHK
lin habitude_N = mkWN (k9A "tapa") ; --UNCHK
lin habitue_N = mkWN (compoundN "vaki" (k41A "asiakas")) ; --UNCHK
lin habitus_N = mkWN (k48A "rakenne") ; --UNCHK
lin hacek_N = mkWN (k1A "hattu") ; --UNCHK
lin hacienda_N = mkWN (k9 "tila") ; --UNCHK
lin hack_N = mkN "tietomurto" ;
lin hack_V = mkWV (k61 "köhiä") ; --UNCHK
lin hack_V2 = mkV2 "murtautua" illative ;
lin hackberry_N = mkWN (k25 "tuomi") ; --UNCHK
lin hacker_N = mkWN (k6 "hakkeri") ; --UNCHK
lin hackney_PN = foreignPN "Hackney" ;
lin hackneyed_A = mkWA (k38 "tavallinen") ; --UNCHK
lin hacksaw_N = mkWN (compoundN "rauta" (k9 "saha")) ; --UNCHK
lin hackwork_N = mkWN (compoundN "rutiini" (k19 "työ")) ; --UNCHK
lin hadal_A = mkWA "syvänmeren" ; --UNCHK
lin haddington_PN = foreignPN "Haddington" ;
lin haddock_N = mkWN (k10 "kolja") ; --UNCHK
lin hadji_N = mkWN "hajji" ; --UNCHK
lin hadron_N = mkWN (k5 "hadroni") ; --UNCHK
lin hadrosaur_N = mkWN (k1 "sorsalisko") ; --UNCHK
lin haematite_N = mkWN (k5A "hematiitti") ; --UNCHK
lin haemoglobin_N = mkWN (k5 "hemoglobiini") ; --UNCHK
lin haemophilia_N = mkWN (k12 "hemofilia") ; --UNCHK
lin haemophiliac_N = mkWN (compoundN "verenvuoto" (k38 "tautinen")) ; --UNCHK
lin haemophilic_A = mkWA "hemofiilinen" ; --UNCHK
lin haemoproteid_N = mkWN "haemoproteid" ; --UNCHK
lin haemorrhage_N = mkWN (k1A "vuoto") ; --UNCHK
lin haemosporidian_N = mkWN "veri-itiöeläin" ; --UNCHK
lin hafnium_N = mkWN "järjestysluku" "72" ; --UNCHK
lin haft_N = mkWN (k28 "varsi") ; --UNCHK
lin hag_N = mkWN (compoundN "lima" (k38 "nahkiainen")) ; --UNCHK
lin hagberry_N = mkWN (k25 "tuomi") ; --UNCHK
lin hagen_PN = foreignPN "Hagen" ;
lin hagfish_N = mkWN (compoundN "lima" (k38 "nahkiainen")) ; --UNCHK
lin haggard_A = mkWA (k38 "näköinen") "sairaalloisen" ; --UNCHK
lin haggis_N = mkWN "haggis" ; --UNCHK
lin haggle_N = mkWN (k9A "riita") ; --UNCHK
lin haggle_V = mkWV (k61A "tinkiä") ; --UNCHK
lin haggler_N = mkWN (k10 "tinkaaja") ; --UNCHK
lin hagiographer_N = mkWN "hagiografi" ; --UNCHK
lin hagiography_N = mkWN "hagiografia" ; --UNCHK
lin hagiolatry_N = mkWN "hagiolatria" ; --UNCHK
lin hagiology_N = mkWN "hagiologia" ; --UNCHK
lin hagley_PN = foreignPN "Hagley" ;
lin haik_N = mkWN "haick" ; --UNCHK
lin haiku_N = mkWN (kH1 "haiku") ; --UNCHK
lin hail_N = mkWN (k39 "tervehdys") ; --UNCHK
lin hail_V = mkWV (k53 "julistaa") ; --UNCHK
lin hail_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin hailsham_PN = foreignPN "Hailsham" ;
lin hailstone_N = mkWN (k48A "rae") ; --UNCHK
lin hailstorm_N = mkWN (k1 "raekuuro") ; --UNCHK
lin hailuoto_PN = mkPN "Hailuoto" ;
lin haiphong_PN = foreignPN "Haiphong" ;
lin hair_N = L.hair_N ;
lin hair_dye_N = mkWN (compoundN "hius" (k5 "väri")) ; --UNCHK
lin hair_oil_N = mkWN (compoundN "hius" (k1 "öljy")) ; --UNCHK
lin hair_shirt_N = mkWN (compoundN "jouhi" (k9A "paita")) ; --UNCHK
lin hair_slide_N = mkWN (compoundN "hius" (k7A "solki")) ; --UNCHK
lin hair_trigger_N = mkWN (compoundN "pika" (k33 "liipaisin")) ; --UNCHK
lin hairball_N = mkWN (compoundN "karva" (k1 "pallo")) ; --UNCHK
lin hairbrush_N = mkWN (compoundN "hius" (k9 "harja")) ; --UNCHK
lin haircloth_N = mkWN "hair" ; --UNCHK
lin haircut_N = mkWN (k39 "leikkaus") ; --UNCHK
lin hairdo_N = mkWN (k39 "kampaus") ; --UNCHK
lin hairdresser_N = mkWN (k10 "kampaaja") ; --UNCHK
lin hairdressing_N = mkWN (compoundN "hiusten" (k39 "leikkaus")) ; --UNCHK
lin hairiness_N = mkWN (k40 "karvaisuus") ; --UNCHK
lin hairlessness_N = mkWN (k40 "kaljuus") ; --UNCHK
lin hairlike_A = mkWA "hius-" ; --UNCHK
lin hairline_N = mkWN (k9 "hiusraja") ; --UNCHK
lin hairnet_N = mkWN (compoundN "hius" (k1A "verkko")) ; --UNCHK
lin hairpiece_N = mkWN (k5A "peruukki") ; --UNCHK
lin hairpin_N = mkWN (compoundN "hius" (k5 "pinni")) ; --UNCHK
lin hairsplitter_N = mkWN (compoundN "hiuksenhalk" (k10 "oja")) ; --UNCHK
lin hairsplitting_A = mkWA (compoundA "hiuksen" (k1 "hieno")) ; --UNCHK
lin hairsplitting_N = mkWN (k38 "hiuksenhalkominen") ; --UNCHK
lin hairspring_N = mkWN (k26 "jousi") "taskukellon" "liipottimen" ; --UNCHK
lin hairstreak_N = mkWN (compoundN "sini" (k7A "siipi")) ; --UNCHK
lin hairstyle_N = mkWN (k39 "kampaus") ; --UNCHK
lin hairstylist_N = mkWN (k10 "kampaaja") ; --UNCHK
lin hairy_A = mkWA (k38 "karvainen") ; --UNCHK
lin haiti_PN = foreignPN "Haiti" ;
lin haitian_A = mkWA (compoundA "haiti" (k38 "lainen")) ; --UNCHK
lin haitian_N = mkWN (compoundN "haiti" (k38 "lainen")) ; --UNCHK
lin hajj_N = mkWN "hadž" ; --UNCHK
lin hajji_N = mkWN "hajji" ; --UNCHK
lin hake_N = mkWN (compoundN "kummeli" (k10 "turska")) ; --UNCHK
lin hakim_N = mkWN "hakeem" ; --UNCHK
lin halal_A = mkWA "halal" ; --UNCHK
lin halal_N = mkWN "halal" ; --UNCHK
lin halberd_N = mkWN (k6 "hilpari") ; --UNCHK
lin halberdier_N = mkWN (compoundN "hilpari" (k42 "mies")) ; --UNCHK
lin halcyon_A = mkWA (k41 "vauras") ; --UNCHK
lin halcyon_N = mkWN "halkyon" ; --UNCHK
lin hale_A = mkWA (k10 "hyvinvoiva") ; --UNCHK
lin haler_N = mkWN "heller" ; --UNCHK
lin halesowen_PN = foreignPN "Halesowen" ;
lin half_A = mkWA "-puoli" ; --UNCHK
lin half_Adv = mkWAdv (k99 "puolittain") ; --UNCHK
lin half_N = mkN (lin NK {s = d26 "puoli"}) ;
lin half_Predet = mkPredet "puoliksi" ;
lin half_blood_N = mkWN (compoundN "sukulaisuus" (k48A "suhde")) "puolisisarusten" ; --UNCHK
lin half_brother_N = mkWN (compoundN "veli" (k26 "puoli")) ; --UNCHK
lin half_crown_N = mkWN (k4A "kolikko") "puolen" "kruunun" ; --UNCHK
lin half_sister_N = mkWN (compoundN "sisar" (k26 "puoli")) ; --UNCHK
lin half_track_N = mkWN (compoundN "puoli" (k9 "tela")) ; --UNCHK
lin half_volley_N = mkWN "puolilentolyönti" ; --UNCHK
lin halfback_N = mkWN (compoundN "tuki" (k42 "mies")) ; --UNCHK
lin halfbeak_N = mkWN (compoundN "puoli" (k10A "nokka")) ; --UNCHK
lin halfhearted_A = mkWA (k15 "vaimea") ; --UNCHK
lin halfpenny_N = mkWN (k4A "kolikko") "puolen" "pennyn" ; --UNCHK
lin halfpennyworth_N = mkWN (k1 "arvo") "puolen" "pennyn" ; --UNCHK
lin halftime_N = mkWN (k1A "tauko") ; --UNCHK
lin halftone_N = mkWN (compoundN "kuva" (k9A "laatta")) ; --UNCHK
lin halfway_A = mkWA (k99 "puolitiessä") ; --UNCHK
lin halfway_Adv = mkWAdv (k99 "puolitiessä") ; --UNCHK
lin halibut_N = mkWN (compoundN "ruijan" (k41A "pallas")) ; --UNCHK
lin halide_N = mkWN "haloidi" ; --UNCHK
lin halifax_PN = foreignPN "Halifax" ;
lin halikko_PN = mkPN "Halikko" ;
lin halite_N = mkWN (compoundN "vuori" (k9 "suola")) ; --UNCHK
lin halitosis_N = mkWN (k39 "hengitys") "pahanhajuinen" ; --UNCHK
lin halitus_N = mkWN (compoundN "ulos" (k39 "hengitys")) ; --UNCHK
lin hall_N = mkWN (k3 "lämpiö") ; --UNCHK
lin halle_PN = foreignPN "Halle" ;
lin hallelujah_N = mkWN (k39 "ylistys") ; --UNCHK
lin halliard_N = mkWN (compoundN "nosto" (k27 "köysi")) ; --UNCHK
lin hallmark_N = mkWN (compoundN "korva" (k5A "merkki")) ; --UNCHK
lin halloo_N = mkWN (k99 "hoi") ; --UNCHK
lin halloo_V = mkWV (k73A "moikata") ; --UNCHK
lin hallow_V2 = mkWV2 (k61A "vihkiä") ; --UNCHK
lin hallowe'en_N = mkWN (k1A "aatto") "pyhäinpäivän" ; --UNCHK
lin hall_stand_N = mkWN (compoundN "eteis" (k4A "naulakko")) ; --UNCHK
lin hallucination_N = mkWN (k3 "hallusinaatio") ; --UNCHK
lin hallucinatory_A = mkWA (k38 "hallusinatorinen") ; --UNCHK
lin hallucinogen_N = mkWN (k48 "aine") "psykedeelinen" ; --UNCHK
lin hallucinogenic_A = mkWA (compoundA "hallusinogeeni" (k38 "nen")) ; --UNCHK
lin hallucinosis_N = mkWN "aistiharhaisuus" ; --UNCHK
lin hallway_N = mkWN (k38 "eteinen") ; --UNCHK
lin halma_N = mkWN (k9 "halma") ; --UNCHK
lin halo_N = mkWN (kH1 "aura") ; --UNCHK
lin halobacteria_N = mkWN (compoundN "halobak" (k26 "teeri")) ; --UNCHK
lin halocarbon_N = mkWN (compoundN "organo" (k5 "halogeeni")) ; --UNCHK
lin haloform_N = mkWN "haloformi" ; --UNCHK
lin halogen_N = mkWN (k5 "halogeeni") ; --UNCHK
lin halogeton_N = mkWN "Halogeton" "glomeratus" ; --UNCHK
lin halon_N = mkWN "haloni" ; --UNCHK
lin haloperidol_N = mkWN (compoundN "haloper" (k6 "idoli")) ; --UNCHK
lin halophile_N = mkWN "halofiili" ; --UNCHK
lin halophyte_N = mkWN (compoundN "suola" (k5 "kasvi")) ; --UNCHK
lin halstead_PN = foreignPN "Halstead" ;
lin halsua_PN = mkPN "Halsua" ;
lin halt_A = mkWA (k9A "rampa") ; --UNCHK
lin halt_N = mkWN (k39 "pysähdys") ;
lin halt_V = mkWV (k53A "tyrehdyttää") ; --UNCHK
lin halt_V2 = mkV2 "pysäyttää" ;
lin haltingly_Adv = mkWAdv (k99 "katkonaisesti") ; --UNCHK
lin halve_V2 = mkWV2 (k53A "puolittaa") ; --UNCHK
lin halyard_N = mkWN (compoundN "nosto" (k27 "köysi")) ; --UNCHK
lin ham_N = mkWN (k1A "kinkku") ; --UNCHK
lin ham_V = mkWV (k67A "liioitella") ; --UNCHK
lin ham_V2 = mkWV2 (k67A "liioitella") ; --UNCHK
lin hamadryad_N = mkWN (compoundN "kuningas" (k10 "kobra")) ; --UNCHK
lin hamartoma_N = mkWN (compoundN "hamarto" (k10 "oma")) ; --UNCHK
lin hamate_N = mkWN (compoundN "haka" (k18 "luu")) ; --UNCHK
lin hamburg_PN = foreignPN "Hampuri" ;
lin hamburger_N = mkN "hampurilainen" | mkWN (compoundN "jauheliha" (k5 "pihvi")) ; --UNCHK
lin hamelia_N = mkWN "hamelia" ; --UNCHK
lin hamilton_PN = foreignPN "Hamilton" ;
lin hamina_PN = mkPN "Hamina" ;
lin hamlet_N = mkWN (k10 "kylä") "pieni" ; --UNCHK
lin hammer_N = mkN "vasara" ;
lin hammer_V = mkWV (k62 "vasaroida") ; --UNCHK
lin hammer_V2 = mkV2 "vasaroida" partitive ;
lin hammer_out_V2 = mkWV2 (k64 "lyödä") "lukkoon" ; --UNCHK
lin hammerhead_N = mkWN (compoundN "vasara" (k18 "hai")) ; --UNCHK
lin hammerlock_N = mkWN (compoundN "vasara" (k48A "ote")) ; --UNCHK
lin hammersmith_PN = foreignPN "Hammersmith" ;
lin hammertoe_N = mkWN (compoundN "vasara" (k41A "varvas")) ; --UNCHK
lin hamming_N = mkWN (compoundN "yli" (k38 "näytteleminen")) ; --UNCHK
lin hammock_N = mkWN (compoundN "verkko" (k1 "keinu")) ; --UNCHK
lin hammy_A = mkWA (compoundA "ylinäytte" (k10 "levä")) ; --UNCHK
lin hamper_N = mkWN (k5 "kori") ; --UNCHK
lin hamper_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin hampshire_PN = foreignPN "Hampshire" ;
lin hamster_N = mkWN (k6 "hamsteri") ; --UNCHK
lin hamstring_N = mkWN (compoundN "kinner" (k48A "jänne")) ; --UNCHK
lin hamstring_V2 = mkWV2 (k53A "rampauttaa") ; --UNCHK
lin hand_N = L.hand_N ;
lin hand_V2 = mkWV2 (k53A "johdattaa") ; --UNCHK
lin hand_back_V2 = mkV2 (advV (lin V OP_hand_V2) OP_back_Adv ) ; -- guess-p-verb
lin hand_carry_V2 = variants {} ; -- guess-p-verb
lin hand_down_V2 = mkWV2 (k53A "jättää") "perinnöksi" ; --UNCHK
lin hand_grenade_N = mkWN (compoundN "käsi" (k5A "kranaatti")) ; --UNCHK
lin hand_in_V2 = prepV2 (lin V OP_hand_V2) OP_in_Prep ; -- guess-p-verb
lin hand_on_V2 = prepV2 (lin V OP_hand_V2) OP_on_Prep ; -- guess-p-verb
lin hand_organ_N = mkWN (k5 "posetiivi") ; --UNCHK
lin hand_out_V2 = mkWV2 (k67A "jaella") ; --UNCHK
lin hand_over_V2 = mkWV2 (k56A "antaa") ; --UNCHK
lin handbag_N = mkWN (k2 "kukkaro") ; --UNCHK
lin handball_N = mkWN (compoundN "käsi" (k1 "pallo")) ; --UNCHK
lin handbell_N = mkWN (compoundN "käsi" (k1 "kello")) ; --UNCHK
lin handbill_N = mkWN (k38 "lehtinen") ; --UNCHK
lin handbook_N = mkWN (k5 "manuaali") ; --UNCHK
lin handbow_N = mkWN (compoundN "käsi" (k26 "jousi")) ; --UNCHK
lin handbreadth_N = mkWN (compoundN "kämmenen" (k40 "leveys")) ; --UNCHK
lin handcar_N = mkWN (k13 "resiina") ; --UNCHK
lin handcart_N = mkWN (k1 "vaunu") ; --UNCHK
lin handclap_N = mkWN (compoundN "kätten" (k39 "taputus")) ; --UNCHK
lin handcuff_V2 = mkWV2 (k56A "laittaa") "käsiraudat" ; --UNCHK
lin handedness_N = mkWN (k40 "kätisyys") ; --UNCHK
lin handful_N = mkWN (k38 "kourallinen") ;
lin handhold_N = mkWN (kH1 "kohta") "kiinnitartuttava" ; --UNCHK
lin handicap_N = mkWN (k39 "tasoitus") ; --UNCHK
lin handicap_V2 = mkWV2 (k52A "vammautua") ; --UNCHK
lin handicapped_A = variants {} ; --
lin handicraft_N = mkWN (compoundN "käsi" (k19 "työ")) ; --UNCHK
lin handiness_N = mkWN (k5A "saanti") ; --UNCHK
lin handiwork_N = mkWN (k19 "työ") "käsin" "suoritettu" ; --UNCHK
lin handkerchief_N = mkWN (compoundN "nenä" (k9 "liina")) ; --UNCHK
lin handle_N = mkWN (k33A "otin") ; --UNCHK
lin handle_V = mkWV (k67A "käsitellä") ;
lin handle_V2 = mkV2 (mkV "käsitellä") partitive ;
lin handlebar_N = mkWN (compoundN "ohjaus" (k1A "tanko")) ; --UNCHK
lin handleless_A = mkWA "rivaton" ; --UNCHK
lin handler_N = mkWN (k6 "manageri") ; --UNCHK
lin handless_A = mkWA (k34A "kädetön") ; --UNCHK
lin handline_N = mkWN (compoundN "käsi" (k9 "siima")) ; --UNCHK
lin handling_N = mkWN (k1A "käyttö") ; --UNCHK
lin handmade_A = mkWA "käsityönä" "tehty" ; --UNCHK
lin handmaid_N = mkWN (k32A "palvelijatar") ; --UNCHK
lin handoff_N = mkWN "handoff" ; --UNCHK
lin hand_out_N = mkWN (k39 "avustus") ; --UNCHK
lin handover_N = mkWN (k39 "luovutus") ; --UNCHK
lin handrail_N = mkWN (k48A "kaide") ; --UNCHK
lin handrest_N = mkWN (compoundN "käsi" (k7A "tuki")) ; --UNCHK
lin hands_N = mkWN "huoltajuus" ; --UNCHK
lin handsaw_N = mkWN (k9 "saha") "kirvesmiehen" ; --UNCHK
lin handset_N = mkWN (k5 "luuri") ; --UNCHK
lin handsewn_A = mkWA "handstitched" ; --UNCHK
lin handshake_N = mkWN (k2 "kättely") ; --UNCHK
lin handshaking_N = mkWN (k2 "kättely") ; --UNCHK
lin handsome_A = mkWA (k15 "upea") ;
lin handsomeness_N = mkWN (k40 "komeus") ; --UNCHK
lin handspike_N = mkWN (compoundN "vääntö" (k7A "kanki")) ; --UNCHK
lin handspring_N = mkWN (compoundN "käsi" (k9A "seisonta")) ; --UNCHK
lin handstamp_N = mkWN (k33 "leimasin") ; --UNCHK
lin handstand_N = mkWN (compoundN "käsi" (k9A "seisonta")) ; --UNCHK
lin handwheel_N = mkWN (compoundN "käsi" (k10 "pyörä")) ; --UNCHK
lin handwork_N = mkWN (k19 "työ") "käsin" "suoritettu" ; --UNCHK
lin handwriting_N = mkWN (compoundN "käsin" (k39 "kirjoitus")) ; --UNCHK
lin handwritten_A = mkWA (compoundA "kirjo" (k1 "itettu")) "käsin" ; --UNCHK
lin handy_A = mkA "kätevä" ;
lin handyman_N = mkWN (compoundN "yleis" (k42 "mies")) ; --UNCHK
lin hang_N = mkWN "hang" ; --UNCHK
lin hang_V = mkV "riippua" | mkV "roikkua" ;
lin hang_V2 = mkV2 "ripustaa" | mkWV2 (k53A "riiputtaa") | mkV2 "hirttää" ; ---- split
lin hang_about_V = advV OP_hang_V OP_about_Adv ; -- guess-p-verb
lin hang_around_V = mkWV (k52A "roikkua") ; --UNCHK
lin hang_around_V2 = mkWV2 (k52A "roikkua") ; --UNCHK
lin hang_back_V = mkWV (k73 "laahata") "perässä" ; --UNCHK
lin hang_back_from_V2 = prepV2 (advV OP_hang_V OP_back_Adv ) OP_from_Prep ; -- guess-p-verb
lin hang_in_there_V = variants {} ; -- guess-p-verb
lin hang_it_up_V = variants {} ; -- guess-p-verb
lin hang_on_V = mkWV (k56 "jatkaa") ; --UNCHK
lin hang_onto_V2 = prepV2 OP_hang_V OP_onto_Prep ; -- guess-p-verb
lin hang_out_V = mkWV (k61A "vetelehtiä") ; --UNCHK
lin hang_out_V2 = mkWV2 (k61A "vetelehtiä") ; --UNCHK
lin hang_out_for_V2 = prepV2 (advV OP_hang_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin hang_over_V2 = mkV2 (mkV "riippua") (mkPrep "yläpuolella") ;
lin hang_together_V = mkWV (k67A "pysytellä") "yhdessä" ; --UNCHK
lin hang_up_V = mkWV (k66 "katkaista") "puhelu" ; --UNCHK
lin hang_up_V2 = mkWV2 (k66 "katkaista") "puhelu" ; --UNCHK
lin hang_up_on_V2 = prepV2 (advV OP_hang_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin hang_with_V2 = prepV2 OP_hang_V OP_with_Prep ; -- guess-p-verb
lin hangar_N = mkWN (k5 "lentokonehalli") ; --UNCHK
lin hangdog_A = mkWA (k38 "syyllinen") ; --UNCHK
lin hanger_N = mkWN (k33 "ripustin") ; --UNCHK
lin hanging_N = mkWN "ripustaminen" ; --UNCHK
lin hangman_N = mkWN (k6 "pyöveli") ; --UNCHK
lin hangnail_N = mkWN (compoundN "kynsi" (k5 "valli")) ; --UNCHK
lin hangover_N = mkWN (k1A "perintö") ; --UNCHK
lin hank_N = mkWN (k5A "kieppi") ; --UNCHK
lin hankasalmi_PN = mkPN (mkN "Hankasalmi" "Hankasalmia") ;
lin hanker_V = mkWV (k68 "ikävöidä") ; --UNCHK
lin hankering_N = mkWN (k39 "kaipaus") ; --UNCHK
lin hanko_PN = mkPN "Hanko" ;
lin hanky_N = mkWN (compoundN "nenä" (k9 "liina")) ; --UNCHK
lin hanky_panky_N = mkWN (k39 "hämäys") ; --UNCHK
lin hanoi_PN = foreignPN "Hanoi" ;
lin hanover_PN = foreignPN "Hanover" ;
lin hansard_N = mkWN "Hansard" ; --UNCHK
lin hao_N = mkWN "hao" ; --UNCHK
lin hap_N = mkWN (k10 "tapahtuma") "epäonninen" ; --UNCHK
lin hap_V = mkWV (k65 "käydä") ; --UNCHK
lin haphazard_A = mkWA (k34A "holtiton") ; --UNCHK
lin haphazard_Adv = mkWAdv (k99 "huolettomasti") ; --UNCHK
lin hapless_A = mkWA (k38 "poloinen") ; --UNCHK
lin haploid_A = mkWA (k38 "haploidinen") ; --UNCHK
lin haploid_N = mkWN (k5 "haploidi") ; --UNCHK
lin haploidy_N = mkWN "haploidisuus" ; --UNCHK
lin haplosporidian_N = mkWN "haplosporidian" ; --UNCHK
lin haplotype_N = mkWN (compoundN "haplo" (k5A "tyyppi")) ; --UNCHK
lin haply_Adv = mkWAdv (k99 "sattumalta") ; --UNCHK
lin happen_V = mkV "tapahtua" ;
lin happen_VV = mkVV "sattua" infIllat ;
lin happening_N = mkN "tapahtuma" ; --UNCHK
lin happiness_N = mkN "onnellisuus" ; --UNCHK
lin happy_A = mkA "onnellinen" ;
lin haptic_A = mkA "tuntoonperustuva" ; --UNCHK
lin haptoglobin_N = mkWN "haptoglobiini" ; --UNCHK
lin harakiri_N = mkWN (k5 "harakiri") ; --UNCHK
lin harangue_N = mkWN (k39 "vuodatus") ; --UNCHK
lin harangue_V = mkWV (k73 "saarnata") ; --UNCHK
lin harangue_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin haranguer_N = mkWN (k10 "saarnaaja") ; --UNCHK
lin harass_V2 = mkWV2 (k53A "väsyttää") ; --UNCHK
lin harasser_N = mkWN (k10 "kiusaaja") ; --UNCHK
lin harassment_N = mkWN (k2 "ahdistelu") ; --UNCHK
lin harbin_PN = foreignPN "Harbin" ;
lin harbinger_N = mkWN (k10 "edeltäjä") ; --UNCHK
lin harbor_V2 = mkWV2 (k67A "elätellä") ; --UNCHK
lin harborage_N = mkWN (compoundN "turva" (k9A "paikka")) ; --UNCHK
lin harbour_N = L.harbour_N ;
lin harbour_V = mkWV (k67A "elätellä") ; --UNCHK
lin harbour_V2 = mkWV2 (k67A "elätellä") ; --UNCHK
lin harbourage_N = mkWN (compoundN "turva" (k9A "paikka")) ; --UNCHK
lin hard_1_A = mkA "kova" ;
lin hard_2_A = mkA "vaikea" ;
lin hard_bitten_A = mkA (mkN "kova" (mkN "pintainen")) ;
lin hardback_N = mkWN (compoundN "kova" (k38 "kantinen")) ; --UNCHK
lin hardbacked_A = mkWA (compoundA "kova" (k38 "kantinen")) ; --UNCHK
lin hardbake_N = mkWN (compoundN "hardbake-" (k38 "leivonnainen")) ; --UNCHK
lin hardball_N = mkWN (k5 "baseball") ; --UNCHK
lin hardboard_N = mkWN (k50 "kovalevy") ; --UNCHK
lin hardbound_A = mkWA (compoundA "kova" (k38 "kantinen")) ; --UNCHK
lin hardcover_N = mkWN (compoundN "kova" (k38 "kantinen")) ;
lin harden_V = mkWV (k53A "totuttaa") ; --UNCHK
lin harden_V2 = mkWV2 (k53A "totuttaa") ; --UNCHK
lin hardening_N = mkWN (k2 "karkaisu") ; --UNCHK
lin hardheaded_A = mkWA (k38 "pragmaattinen") ; --UNCHK
lin hardhearted_A = mkWA (k34A "tunteeton") ; --UNCHK
lin hardihood_N = mkWN (k39 "uskallus") ; --UNCHK
lin hardiness_N = mkWN (k39 "uskallus") ; --UNCHK
lin hardinggrass_N = mkWN (compoundN "tuber" (k10 "osa")) "Phalaris" ; --UNCHK
lin hardliner_N = mkWN (k10 "kannattaja") "kovan" "linjan" ; --UNCHK
lin hardly_AdV = mkAdV "tuskin" ;
lin hardness_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin hardscrabble_A = mkWA (k38 "vaivalloinen") ; --UNCHK
lin hardship_N = mkWN (k40 "vakavuus") ; --UNCHK
lin hardtack_N = mkWN (compoundN "näkki" (k10A "leipä")) "paksu" ; --UNCHK
lin hardtop_N = mkWN (k1 "auto") "kovakattoinen" ; --UNCHK
lin hardware_N = mkWN (k1 "laitteisto") ; --UNCHK
lin hardwood_N = mkWN (k50 "jalopuu") ; --UNCHK
lin hardworking_A = mkWA (k34A "uupumaton") ; --UNCHK
lin hardy_A = mkWA (k15 "urhea") ; --UNCHK
lin hare_N = mkWN (k39 "jänis") ; --UNCHK
lin hare_V = mkWV (k73A "sännätä") ; --UNCHK
lin harebell_N = mkWN (compoundN "sini" (k1 "kello")) ; --UNCHK
lin harebrained_A = mkWA (k1 "hullu") ; --UNCHK
lin harelip_N = mkWN (compoundN "huuli" (k3 "halkio")) ; --UNCHK
lin harem_N = mkWN (k6 "haaremi") ; --UNCHK
lin haricot_N = mkWN (compoundN "leikko" (k1A "papu")) ; --UNCHK
lin harjavalta_PN = mkPN "Harjavalta" ;
lin hark_V = mkWV (k67A "kuunnella") "tarkkaavaisesti" ; --UNCHK
lin harlequin_N = mkWN (k5 "harlekiini") ; --UNCHK
lin harlequinade_N = mkWN (k2 "kujeilu") ; --UNCHK
lin harlot_N = mkWN (k1A "lumppu") ; --UNCHK
lin harlow_PN = foreignPN "Harlow" ;
lin harm_N = mkN "haitta" ; --mkWN (compoundN "hai" (k38 "ttaaminen")) ;
lin harm_V2 = mkWV2 (k53A "vahingoittaa") ; --UNCHK
lin harmattan_N = mkWN "harmattan" ; --UNCHK
lin harmful_A = mkWA (k38 "vahingollinen") ;
lin harmfulness_N = mkWN (k40 "haitallisuus") ; --UNCHK
lin harmless_A = mkWA (k34A "vaaraton") ; --UNCHK
lin harmonic_A = mkWA (k38 "harmoninen") ; --UNCHK
lin harmonic_N = mkWN (compoundN "ylä" (k32 "sävel")) ; --UNCHK
lin harmonica_N = mkWN (compoundN "huuli" (k1A "harppu")) ; --UNCHK
lin harmonics_N = mkWN (k12 "harmonia") ; --UNCHK
lin harmonious_A = mkWA (k38 "harmoninen") ; --UNCHK
lin harmonium_N = mkWN (k5 "harmoni") ; --UNCHK
lin harmonizable_A = mkWA (k10 "oleva") "harmonisoitavissa" ; --UNCHK
lin harmonization_N = mkWN (k39 "soinnutus") ; --UNCHK
lin harmonize_V = mkWV (k53A "soinnuttaa") ; --UNCHK
lin harmonize_V2 = mkWV2 (k53A "soinnuttaa") ; --UNCHK
lin harmonizer_N = mkWN (compoundN "harmoni" (k10 "soija")) ; --UNCHK
lin harmony_N = mkWN (k12 "harmonia") ; --UNCHK
lin harness_V2 = mkWV2 (k69 "hillitä") ; --UNCHK
lin harp_N = mkWN (compoundN "huuli" (k1A "harppu")) ; --UNCHK
lin harp_V = mkWV (k53A "jankuttaa") ; --UNCHK
lin harpenden_PN = foreignPN "Harpenden" ;
lin harper_N = mkWN (k5 "harpisti") ; --UNCHK
lin harpist_N = mkWN (k5 "harpisti") ; --UNCHK
lin harpoon_N = mkWN (k12 "harppuuna") ; --UNCHK
lin harpoon_V2 = mkWV2 (k62 "harppunoida") ; --UNCHK
lin harpooner_N = mkWN "harppunoija" ; --UNCHK
lin harpsichord_N = mkWN (k2 "cembalo") ; --UNCHK
lin harpsichordist_N = mkWN "cembalisti" ; --UNCHK
lin harpulla_N = mkWN (compoundN "har" (k10 "pulla")) ; --UNCHK
lin harpullia_N = mkWN "harpullia" ; --UNCHK
lin harpy_N = mkWN "Harpia" "harpyja" ; --UNCHK
lin harridan_N = mkWN (compoundN "noita-" (k9A "akka")) ; --UNCHK
lin harrier_N = mkWN (k10 "saalistaja") ; --UNCHK
lin harrogate_PN = foreignPN "Harrogate" ;
lin harrow_N = mkWN (k41A "äes") ; --UNCHK
lin harrow_PN = foreignPN "Harrow" ;
lin harrow_V2 = mkWV2 (k53 "äestää") ; --UNCHK
lin harry_V2 = mkWV2 (k53A "hävittää") ; --UNCHK
lin harsh_A = mkWA (k15 "karhea") ; --UNCHK
lin harshness_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin hart_N = mkWN (compoundN "uros" (k7 "hirvi")) ; --UNCHK
lin hartebeest_N = mkWN (compoundN "lehmä" (k5A "antilooppi")) ; --UNCHK
lin hartlepool_PN = foreignPN "Hartlepool" ;
lin hartley_PN = foreignPN "Hartley" ;
lin hartola_PN = mkPN "Hartola" ;
lin harvest_N = mkN (lin NK {s = d01A "sato"}) ;
lin harvest_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin harvester_N = mkWN (compoundN "niitto" (k48 "kone")) ; --UNCHK
lin harvestfish_N = mkWN (compoundN "voi" (k9 "kala")) ; --UNCHK
lin harvestman_N = mkWN (k5A "lukki") ; --UNCHK
lin harvey_PN = foreignPN "Harvey" ;
lin harwich_PN = foreignPN "Harwich" ;
lin hash_N = mkWN (k39 "hasis") ; --UNCHK
lin hash_V2 = mkWV2 (k52A "pilkkoa") ; --UNCHK
lin hash_out_V = mkWV (k61A "pohtia") ; --UNCHK
lin hashish_N = mkWN (k39 "hasis") ; --UNCHK
lin haslemere_PN = foreignPN "Haslemere" ;
lin haslet_N = mkWN "sisäelinjauheliha" ; --UNCHK
lin haslingden_PN = foreignPN "Haslingden" ;
lin hasp_N = mkWN (k9A "salpa") ; --UNCHK
lin hassium_N = mkWN "järjestysluku" "108" ; --UNCHK
lin hassle_N = mkWN (kH1 "kina") ; --UNCHK
lin hassle_V = mkWV (k53A "hätyyttää") ; --UNCHK
lin hassle_V2 = mkWV2 (k53A "hätyyttää") ; --UNCHK
lin hassock_N = mkWN (compoundN "polvistumis" (k1 "tyyny")) ; --UNCHK
lin haste_N = mkWN (k1 "syöksy") ; --UNCHK
lin hasten_V = mkWV (k53A "kiirehtää") ; --UNCHK
lin hasten_V2 = mkWV2 (k53A "kiirehtää") ; --UNCHK
lin hastiness_N = mkWN (k40 "impulsiivisuus") "hätäinen" ; --UNCHK
lin hastings_PN = foreignPN "Hastings" ;
lin hasty_A = mkA (lin AK {s = d38 "pikainen"}) ;
lin hat_N = L.hat_N ;
lin hatband_N = mkWN (k9 "nauha") "hatun" ; --UNCHK
lin hatbox_N = mkWN (compoundN "hattu" (k12 "rasia")) ; --UNCHK
lin hatch_N = mkWN (k1A "luukku") ; --UNCHK
lin hatch_V = mkWV (k73 "suojata") ; --UNCHK
lin hatch_V2 = mkWV2 (k73 "suojata") ; --UNCHK
lin hatchback_N = mkWN (k50 "viistoperä") ; --UNCHK
lin hatchel_N = mkWN "häkilä" ; --UNCHK
lin hatchery_N = mkWN (k2 "hautomo") ; --UNCHK
lin hatchet_N = mkWN (compoundN "piilu" (k41 "kirves")) ; --UNCHK
lin hatching_N = mkWN (k39 "varjostus") ; --UNCHK
lin hatchway_N = mkWN (k1A "luukku") ; --UNCHK
lin hate_N = mkWN (k9 "viha") ; --UNCHK
lin hate_V2 = L.hate_V2 ;
lin hate_VS = mkWVS (k74 "inhota") ; --UNCHK
lin hate_VV = variants {} ; -- mkWV2V (k74 "inhota") ; --UNCHK
lin hate_on_V2 = prepV2 (lin V OP_hate_V2) OP_on_Prep ; -- guess-p-verb
lin hateful_A = mkWA "vihattava" ; --UNCHK
lin hatefulness_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin hatemonger_N = mkWN (compoundN "vihan" (k10 "lietsoja")) ; --UNCHK
lin hater_N = mkWN (k10 "vihaaja") ; --UNCHK
lin hatfield_PN = foreignPN "Hatfield" ;
lin hatful_N = mkWN "hatullinen" ; --UNCHK
lin hatless_A = mkWA "hatuton" ; --UNCHK
lin hatmaker_N = mkWN (k5 "modisti") ; --UNCHK
lin hatpin_N = mkWN (compoundN "hattu" (k9 "neula")) ; --UNCHK
lin hatred_N = mkWN (k9 "viha") ; --UNCHK
lin hatted_A = mkWA "hattua" "käyttävä" ; --UNCHK
lin hatter_N = mkWN (k5 "modisti") ; --UNCHK
lin hauberk_N = mkWN (compoundN "panssari" (k9A "paita")) ; --UNCHK
lin haughtiness_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin haughty_A = mkWA (k15 "ylpeä") ; --UNCHK
lin hauho_PN = mkPN "Hauho" ;
lin haukipudas_PN = mkPN "Haukipudas" ;
lin haukivuori_PN = mkPN (mkN "Haukivuori" "Haukivuoria") ;
lin haul_N = mkN "saalis" ; ---ARB --mkWN (kH1 "veto") ;
lin haul_V = mkWV (k73A "rahdata") ; --UNCHK
lin haul_V2 = mkWV2 (k73A "rahdata") ; --UNCHK
lin haulage_N = mkWN (kH1 "veto") ; --UNCHK
lin hauler_N = mkWN (k10 "kuljettaja") ; --UNCHK
lin haulier_N = mkWN (k10 "kuljettaja") ; --UNCHK
lin hauling_N = mkWN (k39 "kuljetus") ; --UNCHK
lin haulm_N = mkWN (k28 "korsi") ; --UNCHK
lin haunch_N = mkWN (k10A "lonkka") ; --UNCHK
lin haunt_N = mkWN (compoundN "vaki" (k9A "paikka")) ; --UNCHK
lin haunt_V2 = mkWV2 (k52A "näyttäytyä") "kummituksena" ; --UNCHK
lin haunting_A = mkWA (k34A "unohtumaton") ; --UNCHK
lin hausjärvi_PN = mkPN (mkN "Hausjärvi" "Hausjärviä") ;
lin hausmannite_N = mkWN (compoundN "hausman" (k5A "niitti")) ; --UNCHK
lin haustorium_N = mkWN (k26 "imujuuri") ; --UNCHK
lin hautboy_N = mkWN (k3 "oboe") ; --UNCHK
lin hauteur_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin havana_N = mkWN (compoundN "pää" (k5A "kaupunki")) "Kuuban" ; --UNCHK
lin havana_PN = foreignPN "Havanna" ;
lin have_V = lin V S.have_V2 ;
lin have_V2 = S.have_V2 ;
lin have_VV = S.must_VV ;
lin have_against_V2 = prepV2 OP_have_V OP_against_Prep ; -- guess-p-verb
lin have_around_V2 = prepV2 OP_have_V OP_around_Prep ; -- guess-p-verb
lin have_down_as_V3 = variants {} ; -- guess-p-verb
lin have_in_V2 = prepV2 OP_have_V OP_in_Prep ; -- guess-p-verb
lin have_it_away_V = mkWV (k63 "saada") ; --UNCHK
lin have_it_in_for_V2 = variants {} ; -- guess-p-verb
lin have_it_off_V = mkWV (k63 "saada") ; --UNCHK
lin have_it_out_with_V2 = variants {} ; -- guess-p-verb
lin have_off_V2 = prepV2 OP_have_V OP_off_Prep ; -- guess-p-verb
lin have_on_V = mkWV (k53A "pitää") ; --UNCHK
lin have_on_V2 = mkWV2 (k53A "pitää") ; --UNCHK
lin have_over_V2 = prepV2 OP_have_V OP_over_Prep ; -- guess-p-verb
lin have_round_V2 = prepV2 OP_have_V OP_round_Prep ; -- guess-p-verb
lin have_up_V2 = prepV2 OP_have_V OP_up_Prep ; -- guess-p-verb
lin havelock_N = mkWN "havelock" ; --UNCHK
lin haven_N = mkWN (compoundN "turva" (k9A "paikka")) ;
lin haverfordwest_PN = foreignPN "Haverfordwest" ;
lin haverhill_PN = foreignPN "Haverhill" ;
lin haversack_N = mkWN (k9A "rinkka") ; --UNCHK
lin havoc_N = mkWN (k1 "tuho") ;
lin haw_N = mkWN (k25 "vilkkuluomi") ; --UNCHK
lin haw_V = mkWV (k67 "kakistella") ; --UNCHK
lin hawaii_PN = mkPN "Havaiji" ;
lin hawala_N = mkWN (compoundN "hawala-" (k10 "järjestelmä")) ; --UNCHK
lin hawfinch_N = mkWN (compoundN "nokka" (k38 "varpunen")) ; --UNCHK
lin hawick_PN = foreignPN "Hawick" ;
lin hawk_N = mkWN (k9A "haukka") ; --UNCHK
lin hawk_V2 = mkWV2 (k61A "rykiä") ; --UNCHK
lin hawkbit_N = mkWN (k38 "maitiainen") ; --UNCHK
lin hawker_N = mkWN (compoundN "haukka" (k10 "metsästäjä")) ; --UNCHK
lin hawkishness_N = mkWN "sotaintoisuus" ; --UNCHK
lin hawkmoth_N = mkWN (k10 "kiitäjä") ; --UNCHK
lin hawkweed_N = mkWN (k2 "keltano") ; --UNCHK
lin hawse_N = mkWN (compoundN "ankkuri" (k48A "silmäke")) ; --UNCHK
lin hawser_N = mkWN (k5 "touvi") ; --UNCHK
lin hawthorn_N = mkWN (compoundN "ora" (k10 "pihlaja")) ; --UNCHK
lin hay_N = mkWN (k10 "heinä") ; --UNCHK
lin haycock_N = mkWN (compoundN "heinä" (k1A "ruko")) ; --UNCHK
lin hayfield_N = mkWN (k1A "niitty") ; --UNCHK
lin hayfork_N = mkWN (compoundN "heinä" (k1A "hanko")) ; --UNCHK
lin haying_N = mkWN (kH1 "aika") "heinänkorjuun" ; --UNCHK
lin hayloft_N = mkWN (compoundN "heinä" (k10 "suova")) ; --UNCHK
lin haymaker_N = mkWN (k5A "lyönti") "voimakas" ; --UNCHK
lin haymaking_N = mkWN (compoundN "heinän" (k17 "korjuu")) ; --UNCHK
lin haymow_N = mkWN (compoundN "heinä" (k10 "suova")) ; --UNCHK
lin hayrack_N = mkWN (compoundN "heinä" (k1 "kärry")) ; --UNCHK
lin hayrick_N = mkWN (k10 "suova") ; --UNCHK
lin haystack_N = mkWN (k10 "suova") ; --UNCHK
lin haywire_A = mkWA (k99 "sekaisin") ; --UNCHK
lin haywire_N = mkWN (compoundN "metalli" (k9A "lanka")) ; --UNCHK
lin hazard_N = mkWN (k48 "este") ; --UNCHK
lin hazard_V2 = mkWV2 (k54A "uskaltaa") "arvata" ; --UNCHK
lin hazardous_A = mkA "vaarallinen" ; --mkWA (k41 "uskalias") ;
lin hazardousness_N = mkWN (k40 "vaarallisuus") ; --UNCHK
lin haze_N = mkWN (k40 "sameus") ; --UNCHK
lin haze_V2 = mkWV2 (k53A "simputtaa") ; --UNCHK
lin hazel_A = mkWA (compoundA "pähkinän" (k15 "ruskea")) ; --UNCHK
lin hazel_N = mkWN (compoundN "pähkinän" (k15 "ruskea")) ; --UNCHK
lin hazelnut_N = mkWN (k12 "pähkinä") ; --UNCHK
lin haziness_N = mkWN (compoundN "höyry" (k40 "isyys")) ; --UNCHK
lin hazy_A = mkWA (k38 "sumuinen") ; --UNCHK
lin he_N = mkWN (kH1 "he") ; --UNCHK
lin he_Pron = S.he_Pron ;
lin head_A = mkA "johtava" ;
lin head_N = L.head_N ;
lin head_V = mkV "johtaa" ; --f60
lin head_V2 = mkV2 "johtaa" partitive ;
lin head_for_V2 = prepV2 OP_head_V OP_for_Prep ; -- guess-p-verb
lin head_off_V = mkWV (k53A "pysäyttää") ; --UNCHK
lin head_off_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin head_out_V = advV OP_head_V OP_out_Adv ; -- guess-p-verb
lin head_up_V2 = mkWV2 (k67 "olla") "kärjessä" ; --UNCHK
lin headache_N = mkWN (k9 "vaiva") ; ---ARB --mkN "päänsärky" ;
lin headband_N = mkWN (compoundN "otsa" (k9 "nauha")) ; --UNCHK
lin headboard_N = mkWN (compoundN "sängyn" (k1A "pääty")) ; --UNCHK
lin headcheese_N = mkWN (k1A "syltty") ; --UNCHK
lin headdress_N = mkWN (k48 "päähine") ; --UNCHK
lin header_N = mkWN (k1A "hyppy") ; --UNCHK
lin headfast_N = mkWN (compoundN "keula" (k27 "köysi")) ; --UNCHK
lin headfirst_A = mkWA (k99 "päistikkaa") ; --UNCHK
lin headful_N = mkWN (k99 "verran") "pään" ; --UNCHK
lin headgear_N = mkWN (k48 "päähine") ; --UNCHK
lin head_hunter_N = mkWN (k10 "kallonkutistaja") ; --UNCHK
lin heading_N = mkWN (k10 "perä") ; --UNCHK
lin headlamp_N = mkWN (compoundN "etu" (k1 "valo")) ; --UNCHK
lin headland_N = mkWN (k48A "niemeke") ; --UNCHK
lin headless_A = mkWA (k34A "päätön") ; --UNCHK
lin headlight_N = mkWN (compoundN "etu" (k1 "valo")) ; --UNCHK
lin headlike_A = mkWA (compoundA "muis" (k10 "tuttava")) "päätä" ; --UNCHK
lin headline_N = mkWN (k4A "otsikko") ; --UNCHK
lin headliner_N = mkWN (k7A "tähti") ; --UNCHK
lin headlinese_N = mkWN (compoundN "otsikko" (k26 "kieli")) ; --UNCHK
lin headlock_N = mkWN (compoundN "pää" (k48A "ote")) ; --UNCHK
lin headlong_A = mkWA (k99 "päistikkaa") ; --UNCHK
lin headlong_Adv = mkWAdv (k99 "edellä") "pää" ; --UNCHK
lin headman_N = mkWN (k4A "päällikkö") ; --UNCHK
lin headmaster_N = mkWN (k6 "rehtori") ; --UNCHK
lin headmastership_N = mkWN (k40 "rehtorius") ; --UNCHK
lin headmistress_N = mkWN (k6 "rehtori") ; --UNCHK
lin headmistressship_N = mkWN (k40 "rehtorius") ; --UNCHK
lin headpiece_N = mkWN (k10 "kypärä") ; --UNCHK
lin headpin_N = mkWN (compoundN "ykkös" (k9 "keila")) ; --UNCHK
lin headquarters_N = mkWN (compoundN "esi" (k10A "kunta")) ; --UNCHK
lin headrace_N = mkWN (compoundN "tulo" (k10 "kanava")) ; --UNCHK
lin headrest_N = mkWN (compoundN "pää" (k10 "noja")) ; --UNCHK
lin headroom_N = mkWN (compoundN "transientti" (k1 "toisto")) ; --UNCHK
lin headsail_N = mkWN (compoundN "keula" (k48 "purje")) ; --UNCHK
lin headscarf_N = mkWN (k5 "huivi") ; --UNCHK
lin headshake_N = mkWN (k39 "pudistus") ; --UNCHK
lin headship_N = mkWN (k40 "johtajuus") ; --UNCHK
lin headshot_N = mkWN (compoundN "pää" (k39 "laukaus")) ; --UNCHK
lin headsman_N = mkWN (k10 "mestaaja") ; --UNCHK
lin headspace_N = mkWN (compoundN "kaasu" (k9 "tila")) ; --UNCHK
lin headstand_N = mkWN (compoundN "päällä" (k9A "seisonta")) ; --UNCHK
lin headstock_N = mkWN (compoundN "kara" (k10A "pylkkä")) ; --UNCHK
lin headstone_N = mkWN (compoundN "hauta" (k7 "kivi")) ; --UNCHK
lin headstream_N = mkWN (compoundN "alku" (k48A "lähde")) ; --UNCHK
lin headstrong_A = mkWA (k41A "sisukas") ; --UNCHK
lin headwater_N = mkWN (compoundN "alku" (k48A "lähde")) ; --UNCHK
lin headway_N = mkWN (compoundN "men" (k38 "eminen")) "eteenpäin" ; --UNCHK
lin headwind_N = mkWN (compoundN "vasta" (k26 "tuuli")) ; --UNCHK
lin headword_N = mkWN (compoundN "haku" (k9 "sana")) ; --UNCHK
lin heady_A = mkWA (k34A "holtiton") ; --UNCHK
lin heal_V = mkWV (k53A "hoitaa") ; --UNCHK
lin heal_V2 = mkWV2 (k53A "hoitaa") ; --UNCHK
lin healer_N = mkWN (k10 "parantaja") ; --UNCHK
lin healing_N = mkWN (compoundN "par" (k38 "antuminen")) ; --UNCHK
lin health_N = mkWN (k40 "terveys") ;
lin healthcare_N = mkWN (compoundN "sairaan" (k1A "hoito")) ; --UNCHK
lin healthful_A = mkWA (k38 "terveellinen") ; --UNCHK
lin healthfulness_N = mkWN (k40 "terveellisyys") ; --UNCHK
lin healthy_A = mkA (lin AK {s = d48 "terve"}) ;
lin heanor_PN = foreignPN "Heanor" ;
lin heap_N = mkWN (k2 "kottero") ; --UNCHK
lin heap_V2 = mkWV2 (k73 "kasata") "kukkuroilleen" ; --UNCHK
lin heaps_Adv = mkWAdv (k99 "paljon") ; --UNCHK
lin hear_V = mkV "kuulla" ;
lin hear_V2 = L.hear_V2 ;
lin hear_V2V = mkV2V (mkV "kuulla") genitive infPresPart ; --kuulin hänen tehneen
lin hear_VS = mkVS (mkV "kuulla") | mkVS (mkV (mkV "saada") "tietää") ;
lin hear_about_V2 = prepV2 OP_hear_V OP_about_Prep ; -- guess-p-verb
lin hear_from_V2 = prepV2 OP_hear_V OP_from_Prep ; -- guess-p-verb
lin hear_of_V2 = mkV2 "kuulla" elative ;
lin hear_of_V3 = variants {} ; -- guess-p-verb
lin hear_out_V2 = mkWV2 (k67A "kuunnella") "loppuun" ; --UNCHK
lin hearer_N = mkWN (k12 "kuuntelija") ; --UNCHK
lin hearing_N = mkN "kuulustelu" ;
lin hearing_aid_N = mkWN (compoundN "kuulo" (k7 "torvi")) ; --UNCHK
lin hearken_V = mkWV (k67A "kuunnella") "tarkkaavaisesti" ; --UNCHK
lin hearsay_A = mkWA "kuulopuheisiin" "perustuva" ; --UNCHK
lin hearsay_N = mkWN (k1 "juoru") ; --UNCHK
lin hearse_N = mkWN (compoundN "ruumis" (k1 "auto")) ; --UNCHK
lin heart_N = L.heart_N ;
lin heart_disease_N = mkWN (compoundN "sydän" (k40 "sairaus")) ; --UNCHK
lin heart_failure_N = mkWN (compoundN "sydän" (k39 "kohtaus")) ; --UNCHK
lin heartache_N = mkWN (k1 "isku") "kova" ; --UNCHK
lin heartbeat_N = mkWN (k39 "keskus") ; --UNCHK
lin heartbreak_N = mkWN (k1 "isku") "kova" ; --UNCHK
lin heartbreaker_N = mkWN (k3 "tappio") ; --UNCHK
lin heartbreaking_A = mkWA (k10 "vakava") ; --UNCHK
lin heartbroken_A = mkWA (k34A "lohduton") ; --UNCHK
lin heartburn_N = mkWN (k39 "närästys") ; --UNCHK
lin heartburning_N = mkWN (k39 "närkästys") ; --UNCHK
lin hearten_V2 = mkWV2 (k53 "kannustaa") ; --UNCHK
lin heartening_A = mkWA "innostava" ; --UNCHK
lin heartfelt_A = mkWA (k38 "sydämellinen") ; --UNCHK
lin hearth_N = mkWN (k9A "avotakka") ; --UNCHK
lin hearthrug_N = mkWN (k1A "matto") ; --UNCHK
lin hearthstone_N = mkWN (compoundN "takka" (k7 "kivi")) ; --UNCHK
lin heartiness_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin heartland_N = mkWN (compoundN "ydin" (k48 "alue")) ; --UNCHK
lin heartleaf_N = mkWN (compoundN "tapon" (k7A "lehti")) ; --UNCHK
lin heartless_A = mkWA (k34A "tunteeton") ; --UNCHK
lin heartlessness_N = mkWN (k40 "tunteettomuus") ; --UNCHK
lin heartrot_N = mkWN (compoundN "sydän" (k1 "laho")) ; --UNCHK
lin hearts_N = mkWN (k51 "mustamaija") ; --UNCHK
lin heartseed_N = mkWN (k39 "köynnös") ; --UNCHK
lin heartsick_A = mkWA (k38 "epätoivoinen") ; --UNCHK
lin heartthrob_N = mkWN (k6 "hurmuri") ; --UNCHK
lin heartwarming_A = mkWA "sydäntä" "lämmittävä" ; --UNCHK
lin heartwood_N = mkWN (compoundN "ydin" (k18 "puu")) ; --UNCHK
lin hearty_A = mkWA (k34A "vilpitön") ; --UNCHK
lin heat_N = mkN "lämpö" ;
lin heat_V = mkWV (k54A "kuumentaa") ; --UNCHK
lin heat_V2 = mkWV2 (k54A "kuumentaa") ; --UNCHK
lin heat_flash_N = mkWN (compoundN "lämpö" (k1 "syöksy")) ; --UNCHK
lin heat_up_V2 = mkWV2 (k53A "kiihdyttää") ; --UNCHK
lin heatable_A = mkWA "lämmitettävä" ; --UNCHK
lin heated_A = mkWA (compoundA "kuu" (k1 "mennettu")) ; --UNCHK
lin heater_N = mkWN (k1A "syöttö") "nopea" ; --UNCHK
lin heath_N = mkWN (k4A "kanervikko") ; --UNCHK
lin heathen_A = mkWA (k38 "etninen") ; --UNCHK
lin heathen_N = mkWN (k12 "pakana") ; --UNCHK
lin heathenish_A = mkWA (k38 "etninen") ; --UNCHK
lin heather_N = mkWN (k48A "sekoite") ; --UNCHK
lin heather_PN = mkPN "Heather" ;
lin heather_mixture_N = mkWN (k48A "sekoite") ; --UNCHK
lin heathlike_A = mkWA (compoundA "nummi" (k38 "mainen")) ; --UNCHK
lin heating_N = mkWN (k33A "lämmitin") ; --UNCHK
lin heatless_A = mkWA "lämmötön" ; --UNCHK
lin heatstroke_N = mkWN (compoundN "lämpö" (k39 "halvaus")) ; --UNCHK
lin heaume_N = mkWN (compoundN "pata" (k10 "kypärä")) ; --UNCHK
lin heave_N = mkWN (compoundN "pai" (k38 "skaaminen")) ; --UNCHK
lin heave_V = mkWV (k53A "läähättää") ; --UNCHK
lin heave_V2 = mkWV2 (k53A "läähättää") ; --UNCHK
lin heaven_N = mkWN (k41 "taivas") ; --UNCHK
lin heavenly_A = mkWA (k38 "taivaallinen") ; --UNCHK
lin heavenward_A = mkWA "taivaaseen" ; --UNCHK
lin heavenward_Adv = mkWAdv (k99 "kohti") "taivasta" ; --UNCHK
lin heavenwards_Adv = mkWAdv (k99 "kohti") "taivasta" ; --UNCHK
lin heaver_N = mkWN (k7A "kanki") ; --UNCHK
lin heaves_N = mkWN (compoundN "puh" (k5 "kuri")) ; --UNCHK
lin heavily_Adv = adjAdv heavy_A ; -- -- derived
lin heaviness_N = mkWN (k40 "rasittavuus") ; --UNCHK
lin heavy_A = L.heavy_A ;
lin heavy_Adv = mkWAdv (k99 "raskaasti") ; --UNCHK
lin heavy_N = mkWN (k5 "rooli") "vakava" ; --UNCHK
lin heavy_handed_A = mkA (mkN "raskas" (mkN "kätinen")) ;
lin heavy_hearted_A = mkWA (k15 "apea") ; --UNCHK
lin heavyheartedness_N = mkWN (compoundN "surumiel" (k40 "isyys")) ; --UNCHK
lin heavyweight_N = mkWN (k6 "titaani") ; --UNCHK
lin hebdomadal_A = mkWA (k38 "viikoittainen") ; --UNCHK
lin hebephrenia_N = mkWN (k12 "skitsofrenia") "järjestäytymätön" ; --UNCHK
lin hebephrenic_A = mkWA "hebefreninen" ; --UNCHK
lin hebetude_N = mkWN (compoundN "tylsämiel" (k40 "isyys")) ; --UNCHK
lin hebraic_A = mkWA (k38 "heprealainen") ; --UNCHK
lin hebrew_A = mkWA (k38 "heprealainen") ; --UNCHK
lin hecatomb_N = mkWN "hekatombi" ; --UNCHK
lin heck_N = mkN "hitto" ;
lin heckelphone_N = mkWN (compoundN "baritoni" (k3 "oboe")) ; --UNCHK
lin heckle_V2 = mkWV2 (k53A "keskeyttää") ; --UNCHK
lin heckler_N = mkWN (k12 "häiritsijä") ; --UNCHK
lin heckling_N = mkWN (k39 "buuaus") ; --UNCHK
lin hectare_N = mkWN (k6 "hehtaari") ; --UNCHK
lin hectic_A = mkA "hektinen" ; --mkWA (k15 "kiihkeä") ;
lin hectogram_N = mkWN (compoundN "hehto" (k9 "gramma")) ; --UNCHK
lin hectograph_N = mkWN (compoundN "monistus" (k48 "kone")) ; --UNCHK
lin hectoliter_N = mkWN (compoundN "hehto" (k9 "litra")) ; --UNCHK
lin hectometer_N = mkWN (compoundN "hehto" (k5 "metri")) ; --UNCHK
lin hector_V = mkWV (k67A "komennella") ; --UNCHK
lin hector_V2 = mkWV2 (k67A "komennella") ; --UNCHK
lin hedge_N = mkN "suoja" ; --mkWN (k4A "pensaikko") ;
lin hedge_V = mkWV (k52A "suojautua") ;
lin hedge_V2 = mkWV2 (k52A "suojautua") ; --UNCHK
lin hedge_sparrow_N = mkWN (k38 "rautiainen") ; --UNCHK
lin hedgehog_N = mkWN (kH1 "siili") ; --UNCHK
lin hedgehop_V = mkWV (k67A "lennellä") ; --UNCHK
lin hedger_N = mkWN (k6 "puutarhuri") ; --UNCHK
lin hedgerow_N = mkWN (k4A "pensaikko") ; --UNCHK
lin hedonic_A = mkWA (k38 "hedonistinen") ; --UNCHK
lin hedonism_N = mkWN (k5 "hedonismi") ; --UNCHK
lin hedonist_N = mkWN (k12 "nautiskelija") ; --UNCHK
lin hedonistic_A = mkWA (k38 "hedonistinen") ; --UNCHK
lin heed_N = mkWN (k3 "huomio") ; --UNCHK
lin heed_V2 = mkWV2 (k62 "huomioida") ; --UNCHK
lin heedful_A = mkWA (k38 "huomaavainen") ; --UNCHK
lin heedless_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin heedlessness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin heel_N = mkWN (k1A "korko") ; --UNCHK
lin heel_V = mkWV (k56A "laittaa") "kanta" ; --UNCHK
lin heel_V2 = mkWV2 (k56A "laittaa") "kanta" ; --UNCHK
lin heelbone_N = mkWN (compoundN "kanta" (k18 "luu")) ; --UNCHK
lin heft_N = mkWN (k40 "raskaus") ; --UNCHK
lin hefty_A = mkWA (k1 "reilu") ;
lin hegari_N = mkWN "hegari" ; --UNCHK
lin hegemon_N = mkWN (compoundN "hege" (k23 "moni")) ; --UNCHK
lin hegemony_N = mkWN (k12 "hegemonia") ; --UNCHK
lin hegira_N = mkWN (k1A "pako") ; --UNCHK
lin heifer_N = mkWN (k1 "hieho") ; --UNCHK
lin height_N = mkWN (k40 "pituus") ;
lin heighten_V = mkWV (k53 "korostaa") ; --UNCHK
lin heighten_V2 = mkWV2 (k53 "korostaa") ; --UNCHK
lin heinola_PN = mkPN "Heinola" ;
lin heinous_A = mkWA (k10 "katala") ; --UNCHK
lin heinousness_N = mkWN (k40 "kataluus") ; --UNCHK
lin heinävesi_PN = mkPN (mkN "Heinävesi" "Heinäveden" "Heinävesiä") ;
lin heir_N = mkWN (k12 "perijä") ;
lin heiress_N = mkWN (k32A "perijätär") ; --UNCHK
lin heirloom_N = mkWN (compoundN "perintö" (k40 "kalleus")) ; --UNCHK
lin heist_N = mkWN (k9A "keikka") ; --UNCHK
lin hejira_N = mkWN (k1A "pako") ; --UNCHK
lin helensburgh_PN = foreignPN "Helensburgh" ;
lin heliacal_A = mkWA "heliakinen" ; --UNCHK
lin helianthemum_N = mkWN (compoundN "päivän" (k1A "nouto")) ; --UNCHK
lin helicon_N = mkWN (compoundN "basso" (k10 "tuuba")) ; --UNCHK
lin helicopter_N = mkWN (k6 "kopteri") ; --UNCHK
lin heliocentric_A = mkWA (k38 "heliosentrinen") ; --UNCHK
lin heliogram_N = mkWN (compoundN "aurinko" (k5 "viesti")) ; --UNCHK
lin heliograph_N = mkWN "heliografi" ; --UNCHK
lin heliograph_V2 = mkWV2 (k53A "viestittää") "heliografilla" ; --UNCHK
lin heliolatry_N = mkWN (compoundN "auringon" (k9A "palvonta")) ; --UNCHK
lin heliometer_N = mkWN (compoundN "helio" (k5 "metri")) ; --UNCHK
lin heliopause_N = mkWN (compoundN "helio" (k5 "paussi")) ; --UNCHK
lin heliophila_N = mkWN (compoundN "päivän" (k1 "loisto")) ; --UNCHK
lin heliopsis_N = mkWN (compoundN "päivän" (k10 "silmä")) ; --UNCHK
lin heliosphere_N = mkWN (compoundN "heliosf" (k26 "ääri")) ; --UNCHK
lin heliotherapy_N = mkWN (compoundN "aurinko" (k1A "hoito")) ; --UNCHK
lin heliotrope_N = mkWN (k5A "heliotrooppi") ; --UNCHK
lin heliotropism_N = mkWN (compoundN "helio" (k5 "tropismi")) ; --UNCHK
lin heliport_N = mkWN (compoundN "helikopteri" (k10A "kenttä")) ; --UNCHK
lin helium_N = mkWN (k5 "helium") ; --UNCHK
lin helix_N = mkWN (k2 "kotilo") ; --UNCHK
lin hell_Interj = mkInterj "helvetti" ;
lin hell_N = mkN "helvetti" ; --UNCHK
lin hellbender_N = mkWN (compoundN "lieju" (k1 "piru")) ; --UNCHK
lin hellcat_N = mkWN (k10 "ämmä") "pahansisuinen" ; --UNCHK
lin hellebore_N = mkWN (compoundN "joulu" (k1 "ruusu")) ; --UNCHK
lin helleborine_N = mkWN "valkku" ; --UNCHK
lin hellene_N = mkWN (k6 "helleeni") ; --UNCHK
lin hellenic_A = mkWA (k38 "hellenistinen") ; --UNCHK
lin hellfire_N = mkWN (compoundN "tuli" (k5 "pätsi")) ; --UNCHK
lin hellgrammiate_N = mkWN "Corydalinae" ; --UNCHK
lin hellhound_N = mkWN "Kerberos" ; --UNCHK
lin hellion_N = mkWN (k38 "paholainen") ; --UNCHK
lin hellish_A = mkWA (k34A "jumalaton") ; --UNCHK
lin hello_Interj = mkInterj "terve" | mkInterj "moro" ;
lin helm_N = mkWN (k33 "peräsin") ; --UNCHK
lin helmet_N = mkWN (k10 "kypärä") ; --UNCHK
lin helmeted_A = mkWA (compoundA "kypärä" (k38 "päinen")) ; --UNCHK
lin helmetflower_N = mkWN "aitoukonhattu" ; --UNCHK
lin helminth_N = mkWN (compoundN "lois" (k1A "mato")) ; --UNCHK
lin helminthiasis_N = mkWN (compoundN "mato" (k5A "tauti")) ; --UNCHK
lin helmsman_N = mkWN (k10 "ohjaaja") ; --UNCHK
lin helot_N = mkWN (compoundN "maa" (k10 "orja")) ; --UNCHK
lin help_N = mkN "apu" ;
lin help_V = mkV "auttaa" ;
lin help_V2 = mkV2 "auttaa" partitive ;
lin help_V2V = mkWV2V (mkV "auttaa") ;
lin help_out_V2 = mkWV2 (k56A "auttaa") ; --UNCHK
lin help_to_VV = variants {} ; -- guess-p-verb
lin helperFem_N = mkWN (k10 "lahjoittaja") ; --UNCHK
lin helperMasc_N = mkWN (k10 "lahjoittaja") ; --UNCHK
lin helpful_A = mkWA (k38 "hyödyllinen") ;
lin helpfulness_N = mkWN (k40 "auttavaisuus") ; --UNCHK
lin helping_N = mkWN (k5 "satsi") ; --UNCHK
lin helpless_A = mkWA (k34A "avuton") ; --UNCHK
lin helplessness_N = mkWN (k40 "voimattomuus") ; --UNCHK
lin helpmate_N = mkWN (k38 "apulainen") ; --UNCHK
lin helpmeet_N = mkWN (k38 "apulainen") ; --UNCHK
lin helsinki_PN = mkPN "Helsinki" ;
lin helston_PN = foreignPN "Helston" ;
lin helve_N = mkWN (k28 "varsi") ; --UNCHK
lin helvella_N = mkWN (k1 "mörsky") ; --UNCHK
lin hem_N = mkWN (k9 "helma") ; --UNCHK
lin hem_V = mkWV (k53A "hymähtää") ; --UNCHK
lin hem_V2 = mkWV2 (k53A "hymähtää") ; --UNCHK
lin hemagglutination_N = mkWN (compoundN "yhteen" (k38 "pakkautuminen")) "punasolujen" ; --UNCHK
lin hemal_A = mkWA "verisuoniin" "liittyvä" ; --UNCHK
lin hemangioma_N = mkWN (k25 "verisuoniluomi") ; --UNCHK
lin hematemesis_N = mkWN (compoundN "veri" (k39 "oksennus")) ; --UNCHK
lin hematinic_N = mkWN (k48A "lääke") "hemoglobiinia" "nostava" ; --UNCHK
lin hematite_N = mkWN (k5A "hematiitti") ; --UNCHK
lin hematocele_N = mkWN (compoundN "veri" (k10 "tyrä")) ; --UNCHK
lin hematochezia_N = mkWN (compoundN "veri" (k48 "uloste")) ; --UNCHK
lin hematochrome_N = mkWN (compoundN "väri" (k48 "aine")) ; --UNCHK
lin hematocrit_N = mkWN (compoundN "hematok" (k5A "riitti")) ; --UNCHK
lin hematocytopenia_N = mkWN "cytopenia" ; --UNCHK
lin hematocyturia_N = mkWN "haematocyturia" ; --UNCHK
lin hematologic_A = mkWA "hematologinen" ; --UNCHK
lin hematologist_N = mkWN (compoundN "erikois" (k6 "lääkäri")) "hematologian" ; --UNCHK
lin hematology_N = mkWN (k12 "hematologia") ; --UNCHK
lin hematopoiesis_N = mkWN (compoundN "veren" (k39 "muodostus")) ; --UNCHK
lin hematopoietic_A = mkWA (compoundA "hemopoi" (k38 "eettinen")) ; --UNCHK
lin hematuria_N = mkWN (k40 "verivirtsaisuus") ; --UNCHK
lin heme_N = mkWN (compoundN "protoh" (k5 "emi")) ; --UNCHK
lin hemeralopia_N = mkWN (k50 "hämäräsokeus") ; --UNCHK
lin hemianopia_N = mkWN (compoundN "puolikentän" (k39 "puutos")) ; --UNCHK
lin hemic_A = mkWA "hemo-" ; --UNCHK
lin hemiepiphyte_N = mkWN (compoundN "päällys" (k5 "kasvi")) ; --UNCHK
lin hemimetabolous_A = mkWA (compoundA "hemimet" (k38 "amorfinen")) ; --UNCHK
lin hemimetamorphosis_N = mkWN (compoundN "muodon" (k39 "vaihdos")) "osittainen" ; --UNCHK
lin hemimorphite_N = mkWN "kalamiini" ; --UNCHK
lin hemin_N = mkWN "protohemiini" ; --UNCHK
lin hemiparasite_N = mkWN (compoundN "puoli" (k38 "loinen")) ; --UNCHK
lin hemiparasitic_A = mkWA (compoundA "puoli" (k38 "loinen")) ; --UNCHK
lin hemiplegia_N = mkWN (compoundN "toispuoli" (k39 "halvaus")) ; --UNCHK
lin hemisphere_N = mkWN (k5 "hemisfääri") ; --UNCHK
lin hemispheric_A = mkWA "aivopuoliskoon" "liittyvä" ; --UNCHK
lin hemispherical_A = mkWA (compoundA "puolipallo" (k38 "mainen")) ; --UNCHK
lin hemline_N = mkWN (k40 "korkeus") "helman" ; --UNCHK
lin hemlock_N = mkWN (compoundN "hemlokki" (k18 "puu")) ; --UNCHK
lin hemochromatosis_N = mkWN (compoundN "pronssi" (k39 "diabetes")) ; --UNCHK
lin hemodialysis_N = mkWN (compoundN "keinomunuais" (k1A "hoito")) ; --UNCHK
lin hemodynamic_A = mkWA (compoundA "hemo" (k38 "dynaaminen")) ; --UNCHK
lin hemodynamics_N = mkWN (compoundN "hemo" (k9A "dynamiikka")) ; --UNCHK
lin hemoglobin_N = mkWN (k5 "hemoglobiini") ; --UNCHK
lin hemoglobinemia_N = mkWN "haemoglobinemia" ; --UNCHK
lin hemoglobinopathy_N = mkWN (compoundN "verenpuna" (k5A "tauti")) ; --UNCHK
lin hemoglobinuria_N = mkWN "verenpunavirtsaisuus" ; --UNCHK
lin hemolysin_N = mkWN "erytrosytolysiini" ; --UNCHK
lin hemolysis_N = mkWN (compoundN "hemoly" (k5 "ysi")) ; --UNCHK
lin hemolytic_A = mkWA "haemolyticus" ; --UNCHK
lin hemophilia_N = mkWN (k12 "hemofilia") ; --UNCHK
lin hemophiliac_N = mkWN (compoundN "verenvuoto" (k38 "tautinen")) ; --UNCHK
lin hemoprotein_N = mkWN (compoundN "hemo" (k5 "proteiini")) ; --UNCHK
lin hemoptysis_N = mkWN (compoundN "veri" (k10 "yskä")) ; --UNCHK
lin hemorrhage_N = mkWN (k1A "vuoto") ; --UNCHK
lin hemorrhage_V = mkV (mkV "vuotaa") "verta" ; ----
lin hemorrhagic_A = mkWA "verenvuotoon" "liittyvä" ; --UNCHK
lin hemorrhoid_N = mkWN (k10 "peräpukama") ; --UNCHK
lin hemorrhoidectomy_N = mkWN (k1 "poisto") "peräpukamien" ; --UNCHK
lin hemosiderin_N = mkWN "hemosideriini" ; --UNCHK
lin hemosiderosis_N = mkWN "haemosiderosis" ; --UNCHK
lin hemostat_N = mkWN "hemostaatti" ; --UNCHK
lin hemothorax_N = mkWN (compoundN "veri" (k9A "rinta")) ; --UNCHK
lin hemp_N = mkWN (compoundN "hirtto" (k27 "köysi")) ; --UNCHK
lin hempen_A = mkWA (k38 "kuituinen") ; --UNCHK
lin hemstitch_N = mkWN (compoundN "lintuniisi" (k39 "sidos")) ; --UNCHK
lin hemstitch_V2 = mkWV2 (k67A "ommella") "päärmepistoin" ; --UNCHK
lin hemsworth_PN = foreignPN "Hemsworth" ;
lin hen_N = mkWN "naaras-" ; --UNCHK
lin hen_party_N = mkWN (k9A "ilta") "naisten" ; --UNCHK
lin henbane_N = mkWN (k50 "hullukaali") ; --UNCHK
lin henbit_N = mkWN (k51 "sepiväpeippi") ; --UNCHK
lin hence_Adv = mkAdv "sen vuoksi" ;
lin henchman_N = mkWN (k6 "kätyri") ; --UNCHK
lin hencoop_N = mkWN (k12 "kanala") ; --UNCHK
lin hendiadys_N = mkWN "hendiadys" ; --UNCHK
lin henhouse_N = mkWN (k12 "kanala") ; --UNCHK
lin henna_N = mkWN (k9 "henna") ; --UNCHK
lin henpecked_A = mkWA (k99 "alla") "tossun" ; --UNCHK
lin henroost_N = mkWN (k28 "orsi") ; --UNCHK
lin henry_N = mkWN "Joseph" "Henry" ; --UNCHK
lin henry_PN = foreignPN "Henry" ;
lin hep_A = mkWA (k10 "seuraava") "trendejä" ; --UNCHK
lin hepadnavirus_N = mkWN (compoundN "hepadna" (k39 "virus")) ; --UNCHK
lin heparin_N = mkWN (k5 "hepariini") ; --UNCHK
lin hepatic_A = mkWA "maksa-" ; --UNCHK
lin hepatica_N = mkWN "palokeuhkosammal" ; --UNCHK
lin hepatitis_N = mkWN (k5A "hepatiitti") ;
lin hepatoma_N = mkWN (k10 "karsinooma") "hepatosellulaarinen" ; --UNCHK
lin hepatomegaly_N = mkWN (k10 "suurentuma") "maksan" ; --UNCHK
lin hepatotoxic_A = mkWA (compoundA "maksa" (k38 "toksinen")) ; --UNCHK
lin hepatotoxin_N = mkWN (compoundN "maksa" (k1A "myrkky")) ; --UNCHK
lin heptagon_N = mkWN "seitsenkulmio" ; --UNCHK
lin herald_N = mkWN (k10 "edeltäjä") ; --UNCHK
lin herald_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin heraldic_A = mkWA (k38 "heraldinen") ; --UNCHK
lin heraldry_N = mkWN (k6 "symboli") "heraldinen" ; --UNCHK
lin herb_N = mkWN (k5A "yrtti") ; --UNCHK
lin herbaceous_A = mkWA (compoundA "ruoho" (k38 "mainen")) ; --UNCHK
lin herbage_N = mkWN (k33A "laidun") ; --UNCHK
lin herbal_A = mkWA "yrtti-" ; --UNCHK
lin herbalist_N = mkWN (k10 "parantaja") "yrteillä" ; --UNCHK
lin herbarium_N = mkWN (k3 "kasvio") ; --UNCHK
lin herbicide_N = mkWN (compoundN "kasvi" (k1A "myrkky")) ; --UNCHK
lin herbivore_N = mkWN (compoundN "kasvis" (k10 "syöjä")) ; --UNCHK
lin herbivorous_A = mkWA (compoundA "kasvis" (k10 "syöjä")) ; --UNCHK
lin herculean_A = mkWA "uuvuttava" ; --UNCHK
lin herd_N = mkWN (k9 "lauma") ;
lin herd_V = mkWV (k58A "kulkea") "laumassa" ; --UNCHK
lin herd_V2 = mkWV2 (k58A "kulkea") "laumassa" ; --UNCHK
lin herder_N = mkWN (k32 "paimen") ; --UNCHK
lin herdsman_N = mkWN (k32 "paimen") ; --UNCHK
lin here7from_Adv = S.here7from_Adv ;
lin here7to_Adv = S.here7to_Adv ;
lin here_Adv = mkAdv "täällä" ;
lin here_N = mkWN (k99 "täällä") ; --UNCHK
lin hereabout_Adv = mkWAdv (k99 "main") "näillä" ; --UNCHK
lin hereabouts_Adv = mkWAdv (k99 "main") "näillä" ; --UNCHK
lin hereafter_Adv = mkWAdv (compoundAdv "täst" (k99 "edes")) ; --UNCHK
lin hereafter_N = mkWN (kH1 "aika") "tuleva" ; --UNCHK
lin hereby_Adv = mkWAdv (k99 "täten") ; --UNCHK
lin hereditament_N = mkWN (compoundN "perintö" (k40 "omaisuus")) ; --UNCHK
lin hereditarianism_N = mkWN (compoundN "perintö" (k48A "tiede")) ; --UNCHK
lin hereditary_A = mkWA (k10 "oleva") "siirrettävissä" ; --UNCHK
lin heredity_N = mkWN (k10 "perimä") ; --UNCHK
lin hereford_PN = foreignPN "Hereford" ;
lin herein_Adv = mkWAdv "tässä" "kohdin" ; --UNCHK
lin hereinafter_Adv = mkWAdv (k99 "myöhemmin") ; --UNCHK
lin hereinbefore_Adv = mkWAdv (k99 "aiemmin") ; --UNCHK
lin hereness_N = mkWN (compoundN "täällä" (k1 "olo")) ; --UNCHK
lin hereof_Adv = mkWAdv (k99 "tästä") ; --UNCHK
lin heresy_N = mkWN (k40 "kerettiläisyys") ; --UNCHK
lin heretic_N = mkWN (k38 "kerettiläinen") ; --UNCHK
lin heretical_A = mkWA (k38 "kerettiläinen") ; --UNCHK
lin hereto_Adv = mkWAdv (k99 "oheen") ; --UNCHK
lin heretofore_Adv = mkWAdv (k99 "vielä") ; --UNCHK
lin hereunder_Adv = mkWAdv (k99 "mukaisesti") ; --UNCHK
lin hereupon_Adv = mkWAdv (k99 "jälkeen") "heti" "tämän" ; --UNCHK
lin herewith_Adv = mkWAdv (k99 "täten") ; --UNCHK
lin heritable_A = mkWA (k38 "perinnöllinen") ; --UNCHK
lin heritage_N = mkWN (k1A "perintö") ; --UNCHK
lin herm_N = mkWN "hermi" ; --UNCHK
lin hermaphrodite_N = mkWN (k40 "kaksineuvoisuus") ; --UNCHK
lin hermaphroditic_A = mkWA (k38 "hermafrodiittinen") ; --UNCHK
lin hermaphroditism_N = mkWN (k40 "biseksuaalisuus") ; --UNCHK
lin hermeneutic_A = mkWA (k38 "hermeneuttinen") ; --UNCHK
lin hermeneutics_N = mkWN (k9A "hermeneutiikka") ; --UNCHK
lin hermit_N = mkWN (k4A "erakko") ; --UNCHK
lin hermitage_N = mkWN (compoundN "erakko" (k9 "maja")) ; --UNCHK
lin herne_PN = foreignPN "Herne" ;
lin hernia_N = mkWN (k10 "tyrä") ; --UNCHK
lin hero_N = mkWN (compoundN "pää" (k2 "henkilö")) ; --UNCHK
lin heroic_A = mkWA (k38 "sankarillinen") ; --UNCHK
lin heroin_N = mkWN (k5 "heroiini") ; --UNCHK
lin heroine_N = mkWN (compoundN "pää" (k2 "henkilö")) ; --UNCHK
lin heroism_N = mkWN (k40 "urheus") ; --UNCHK
lin heron_N = mkWN (k12 "haikara") ; --UNCHK
lin heronry_N = mkWN (compoundN "pesintä" (k48 "alue")) ; --UNCHK
lin herpangia_N = mkWN "herpangina" ; --UNCHK
lin herpes_N = mkWN (k39 "herpes") ; --UNCHK
lin herpetologist_N = mkWN "herpetologi" ; --UNCHK
lin herpetology_N = mkWN "herpetologia" ; --UNCHK
lin herr_N = mkWN "Herr" ; --UNCHK
lin herrerasaur_N = mkWN "herrerasaurus" ; --UNCHK
lin herring_N = mkWN (k5 "silli") ; --UNCHK
lin herringbone_N = mkWN (kH1 "kangas") "kalanruotokuvioinen" ; --UNCHK
lin hertford_PN = foreignPN "Hertford" ;
lin hertzian_A = mkWA "Hertzin" ; --UNCHK
lin hesitance_N = mkWN (k5A "epäröinti") ; --UNCHK
lin hesitancy_N = mkWN (k40 "innottomuus") ; --UNCHK
lin hesitant_A = mkWA "epäröivä" ; --UNCHK
lin hesitate_V = mkWV (k67 "aikailla") ; --UNCHK
lin hesitate_VS = mkWVS (k67 "aikailla") ; --UNCHK
lin hesitate_VV = mkWVV (k67 "aikailla") ; --UNCHK
lin hesitatingly_Adv = mkWAdv (compoundAdv "emp" (k32A "ien")) ; --UNCHK
lin hesitation_N = mkWN (k2 "jahkailu") ; --UNCHK
lin hessian_N = mkWN (k41A "saapas") "hesseniläinen" ; --UNCHK
lin het_up_A = mkWA (k38 "vihainen") ; --UNCHK
lin heterocercal_A = mkWA (compoundA "vinopyrst" (k38 "öinen")) ; --UNCHK
lin heterocyclic_A = mkWA (compoundA "hetero" (k38 "syklinen")) ; --UNCHK
lin heterodox_A = mkWA (k38 "kerettiläinen") ; --UNCHK
lin heterodoxy_N = mkWN (compoundN "epä" (k40 "sovinnaisuus")) ; --UNCHK
lin heterodyne_A = mkWA (compoundA "väli" (k38 "taajuinen")) ; --UNCHK
lin heteroecious_A = mkWA "lois-" ; --UNCHK
lin heterogeneity_N = mkWN (k40 "heterogeenisuus") ; --UNCHK
lin heterogeneous_A = mkA "heterogeeninen" ;
lin heterograft_N = mkWN (compoundN "vieraslaji" (k48A "siirre")) ; --UNCHK
lin heteroicous_A = mkWA (k38 "polygaaminen") ; --UNCHK
lin heterologous_A = mkWA (compoundA "hete" (k38 "rologinen")) ; --UNCHK
lin heterology_N = mkWN "heterologia" ; --UNCHK
lin heterometabolism_N = mkWN (compoundN "hetero" (k12 "metabolia")) ; --UNCHK
lin heterometabolous_A = mkWA (compoundA "hetero" (k38 "metabolinen")) ; --UNCHK
lin heteronym_N = mkWN "heteronyymi" ; --UNCHK
lin heteroploid_N = mkWN (k5 "organismi") "heteroploidinen" ; --UNCHK
lin heteroploidy_N = mkWN (compoundN "heteroploi" (k9 "dia")) ; --UNCHK
lin heterosexism_N = mkWN (compoundN "hetero" (k5 "seksismi")) ; --UNCHK
lin heterosexual_A = mkWA (compoundA "hetero" (k38 "seksuaalinen")) ; --UNCHK
lin heterosexual_N = mkWN (k2 "hetero") ; --UNCHK
lin heterosexuality_N = mkWN (compoundN "hetero" (k40 "seksuaalisuus")) ; --UNCHK
lin heterosis_N = mkWN (compoundN "elin" (k10 "voima")) "risteytyksen" ; --UNCHK
lin heterosporous_A = mkWA (compoundA "hete" (k38 "rosporinen")) ; --UNCHK
lin heterospory_N = mkWN "heterosporia" ; --UNCHK
lin heterostracan_N = mkWN "heterostracan" ; --UNCHK
lin heterotroph_N = mkWN (compoundN "toisen" (k38 "varainen")) ; --UNCHK
lin heterotrophic_A = mkWA (compoundA "hete" (k38 "rotrofinen")) ; --UNCHK
lin heterozygosity_N = mkWN "heterotsygoottisuus" ; --UNCHK
lin heterozygote_N = mkWN (k5A "heterotsygootti") ; --UNCHK
lin heterozygous_A = mkWA (k38 "heterotsygoottinen") ; --UNCHK
lin heth_N = mkWN "heth" ; --UNCHK
lin heulandite_N = mkWN "heulandiitti" ; --UNCHK
lin heuristic_A = mkWA "heuristinen" ; --UNCHK
lin heuristic_N = mkWN (k10 "ohjelma") "heuristinen" ; --UNCHK
lin hew_V = mkWV (k52A "pilkkoa") ; --UNCHK
lin hew_V2 = mkWV2 (k52A "pilkkoa") ; --UNCHK
lin hewer_N = mkWN (compoundN "puun" (k10 "hakkaaja")) ; --UNCHK
lin hewn_A = mkWA (compoundA "käsi" (k1 "nhakattu")) ; --UNCHK
lin hex_N = mkWN (k9A "taika") ; --UNCHK
lin hexachlorophene_N = mkWN (k5 "heksaklorofeeni") ; --UNCHK
lin hexadecimal_A = mkWA (compoundA "heksa" (k38 "desimaalinen")) ; --UNCHK
lin hexagon_N = mkN "kuusikulmio" "kuusikulmioita" ;
lin hexagonal_A = mkA "kuusikulmainen" ;
lin hexagram_N = mkWN (compoundN "kuusi" (k9A "kanta")) ; --UNCHK
lin hexahedron_N = mkWN (k5 "heksaedri") ; --UNCHK
lin hexameter_N = mkWN (k5 "heksametri") ; --UNCHK
lin hexangular_A = mkWA (k38 "heksagoninen") ; --UNCHK
lin hexapod_N = mkWN (compoundN "kuu" (k38 "sijalkainen")) ; --UNCHK
lin hexed_A = mkWA (k1A "kirottu") ; --UNCHK
lin hexestrol_N = mkWN "heksestroli" ; --UNCHK
lin hexham_PN = foreignPN "Hexham" ;
lin hexose_N = mkWN (compoundN "hek" (k5 "soosi")) ; --UNCHK
lin hey_Interj = mkInterj "hei" ;
lin heyday_N = mkWN (k40 "runsaus") ; --UNCHK
lin heywood_PN = foreignPN "Heywood" ;
lin hi_Interj = mkInterj "moi" ;
lin hiatus_N = mkWN (k1A "rako") ; --UNCHK
lin hibachi_N = mkWN (compoundN "hibachi-" (k1 "pannu")) ; --UNCHK
lin hibernate_V = mkWV (k53 "horrostaa") ; --UNCHK
lin hibernation_N = mkWN "vetäytyminen" ; --UNCHK
lin hibiscus_N = mkWN (k39 "hibiskus") ; --UNCHK
lin hiccough_N = mkWN (k39 "nikotus") ; --UNCHK
lin hiccough_V = mkWV (k67A "nikotella") ; --UNCHK
lin hiccup_N = mkWN (k39 "nikotus") ; --UNCHK
lin hiccup_V = mkWV (k67A "nikotella") ; --UNCHK
lin hick_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin hick_N = mkWN (k6 "öykkäri") ; --UNCHK
lin hickey_N = mkWN (k1 "fritsu") ; --UNCHK
lin hickory_N = mkWN (k6 "hikkori") ; --UNCHK
lin hidden_A = variants {} ; --
lin hiddenite_N = mkWN (compoundN "hidde" (k5A "niitti")) ; --UNCHK
lin hiddenness_N = mkWN "salassa" "oleminen" ; --UNCHK
lin hide_N = mkWN (k9 "nahka") ; --UNCHK
lin hide_V = mkWV (k74 "verhota") ; --UNCHK
lin hide_V2 = mkWV2 (k74 "verhota") ; --UNCHK
lin hide_away_V = advV OP_hide_V OP_away_Adv ; -- guess-p-verb
lin hide_away_V2 = mkV2 (advV OP_hide_V OP_away_Adv ) ; -- guess-p-verb
lin hide_out_V = mkWV (k52A "kätkeytyä") ; --UNCHK
lin hideaway_N = mkWN (compoundN "pako" (k9A "paikka")) ; --UNCHK
lin hidebound_A = mkWA (k38 "vanhoillinen") ; --UNCHK
lin hideous_A = mkWA (k15 "kauhea") ; --UNCHK
lin hideousness_N = mkWN (k40 "kammottavuus") ; --UNCHK
lin hide_out_N = mkWN (k10 "luola") ; --UNCHK
lin hiding_N = mkWN (k2 "salailu") ; --UNCHK
lin hiding_place_N = mkWN (k1 "piilo") ; --UNCHK
lin hidrotic_A = mkWA "hiostava" ; --UNCHK
lin hie_V = mkWV (k53A "kiirehtää") ; --UNCHK
lin hierarch_N = mkWN (k39 "priimas") ; --UNCHK
lin hierarchic_A = mkWA (k38 "hierarkkinen") ; --UNCHK
lin hierarchical_A = mkWA (k38 "hierarkkinen") ; --UNCHK
lin hierarchy_N = mkWN (k12 "hierarkia") ; --UNCHK
lin hieratic_A = mkWA (compoundA "hie" (k38 "raattinen")) ; --UNCHK
lin hieratic_N = mkWN (k39 "kirjoitus") "hieraattinen" ; --UNCHK
lin hierocracy_N = mkWN "hierokratia" ; --UNCHK
lin hieroglyph_N = mkWN (k5 "hieroglyfi") ; --UNCHK
lin hieroglyphic_A = mkWA (compoundA "hie" (k38 "roglyfinen")) ; --UNCHK
lin high_A = mkA "korkea" ;
lin high_Adv = mkWAdv (k99 "ylös") ; --UNCHK
lin high_N = mkWN (k48A "vaihde") "iso" ; --UNCHK
lin high_fidelity_N = mkWN (k5 "hifi") ; --UNCHK
lin high_frequency_N = mkWN (k40 "taajuus") "korkea" ; --UNCHK
lin high_grade_A = mkA "korkea-asteinen" ;
lin high_level_A = mkA "korkeatasoinen" ;
lin high_minded_A = mkA (mkN "ylevä" (mkN "mielinen")) ;
lin high_octane_A = mkA (mkN "korkea-" (mkN "oktaaninen")) ;
lin high_powered_A = mkA "voimakas" ;
lin high_priced_A = mkA "hintava" ;
lin high_ranking_A = mkA (mkN "korkea-" (mkN "arvoinen")) ;
lin high_speed_A = mkA "nopea" ;
lin highball_N = mkWN (k5 "grogi") ; --UNCHK
lin highboard_N = mkWN (compoundN "ponnahdus" (k9A "lauta")) "korkea" ; --UNCHK
lin highborn_A = mkWA (k38 "aatelinen") ; --UNCHK
lin highboy_N = mkWN (k5A "piironki") "korkea" ; --UNCHK
lin highbrow_A = mkWA (k38 "korkealentoinen") ; --UNCHK
lin highbrow_N = mkWN (k4A "älykkö") ; --UNCHK
lin highchair_N = mkWN (compoundN "syöttö" (k5 "tuoli")) ; --UNCHK
lin highflier_N = mkWN (k38 "ihminen") "menestyvä" ; --UNCHK
lin highflyer_N = mkWN (k38 "ihminen") "menestyvä" ; --UNCHK
lin highflying_A = mkWA (compoundA "kunnianhi" (k38 "moinen")) ; --UNCHK
lin highjack_N = mkWN (k39 "kaappaus") ; --UNCHK
lin highjack_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin highjacker_N = mkWN (k10 "kaappaaja") ; --UNCHK
lin highjacking_N = mkWN (k39 "kaappaus") ; --UNCHK
lin highland_N = mkWN (k1A "ylänkö") ; --UNCHK
lin highland_PN = foreignPN "Highland" ;
lin highlander_N = mkWN (compoundN "ylä" (k38 "maalainen")) "skotlantilainen" ; --UNCHK
lin highlight_N = mkWN (k39 "korostus") ; --UNCHK
lin highlight_V2 = mkWV2 (k53 "korostaa") ; --UNCHK
lin highlighter_N = mkWN (compoundN "korostus" (k10 "kynä")) ; --UNCHK
lin highly_Adv = mkAdv "suuressa määrin" | adjAdv high_A ; -- derived
lin highness_N = mkWN (k40 "korkeus") ; --UNCHK
lin highroad_N = mkWN (compoundN "runko" (k19 "tie")) ; --UNCHK
lin highway_N = mkWN (compoundN "valta" (k19 "tie")) ;
lin highwayman_N = mkWN (k10 "kaappaaja") ; --UNCHK
lin hijab_N = mkWN "hijab" ; --UNCHK
lin hijack_N = mkWN (k39 "kaappaus") ; --UNCHK
lin hijack_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin hijacker_N = mkWN (k10 "kaappaaja") ; --UNCHK
lin hike_N = mkWN (k39 "vaellus") ; --UNCHK
lin hike_V = mkWV (k54A "vaeltaa") ; --UNCHK
lin hiker_N = mkWN (k10 "vaeltaja") ; --UNCHK
lin hilar_A = mkWA (compoundA "hila" (k38 "arinen")) ; --UNCHK
lin hilarious_A = mkWA (k41A "riemukas") ; --UNCHK
lin hilarity_N = mkWN (k1 "riemu") ; --UNCHK
lin hill_N = L.hill_N ;
lin hill_billy_N = mkWN (compoundN "kaura" (k1A "hattu")) ; --UNCHK
lin hilliness_N = mkWN (k40 "mäkisyys") ; --UNCHK
lin hillock_N = mkWN (k41A "mätäs") ; --UNCHK
lin hillside_N = mkWN (k48A "rinne") ; --UNCHK
lin hilltop_N = mkWN (k1A "huippu") ; --UNCHK
lin hilly_A = mkWA (k38 "kukkulainen") ; --UNCHK
lin hilt_N = mkWN (k9 "kahva") ; --UNCHK
lin hilum_N = mkWN "hilum" ; --UNCHK
lin hilus_N = mkWN "hilum" ; --UNCHK
lin himanka_PN = mkPN "Himanka" ;
lin hin_N = mkWN (compoundN "hiin-" (k9A "mitta")) ; --UNCHK
lin hinckley_PN = foreignPN "Hinckley" ;
lin hind_A = mkWA (k10A "selkä") ; --UNCHK
lin hind_N = mkWN (compoundN "naaras" (k7 "hirvi")) ; --UNCHK
lin hinder_V2 = mkWV2 (k73A "haitata") ; --UNCHK
lin hindfoot_N = mkWN (compoundN "taka" (k10 "osa")) "jalkaterän" ; --UNCHK
lin hindgut_N = mkWN (compoundN "taka" (k26 "suoli")) ; --UNCHK
lin hindi_A = mkWA (k38 "hindulainen") ; --UNCHK
lin hindmost_A = mkWA (k38 "viimeinen") ; --UNCHK
lin hindquarter_N = mkWN (k48 "viipale") ; --UNCHK
lin hindquarters_N = mkWN (k10 "perä") ; --UNCHK
lin hindrance_N = mkWN (k9A "häirintä") ; --UNCHK
lin hindshank_N = mkWN (compoundN "taka" (k10 "potka")) ; --UNCHK
lin hindsight_N = mkWN (compoundN "jälki" (k40 "viisaus")) ; --UNCHK
lin hindu_A = mkWA (k38 "hindulainen") ; --UNCHK
lin hindu_N = mkWN (k1 "hindu") ; --UNCHK
lin hinduism_N = mkWN (k40 "hindulaisuus") ; --UNCHK
lin hindustani_A = mkWA (compoundA "hindustani" (k38 "lainen")) ; --UNCHK
lin hindustani_N = mkWN (k5 "hindustani") ; --UNCHK
lin hinge_N = mkWN (k12 "sarana") ; --UNCHK
lin hinge_V = mkWV (k62 "saranoida") ; --UNCHK
lin hinge_V2 = mkWV2 (k62 "saranoida") ; --UNCHK
lin hinge_on_V2 = mkWV2 (k52A "riippua") ; --UNCHK
lin hinge_upon_V2 = mkWV2 (k52A "riippua") ; --UNCHK
lin hinny_N = mkWN (compoundN "muuli" (k5 "aasi")) ; --UNCHK
lin hint_N = mkWN (k5A "vinkki") ;
lin hint_V = mkWV (k66 "vihjaista") ; --UNCHK
lin hint_V2 = mkWV2 (k66 "vihjaista") ; --UNCHK
lin hint_VS = mkWVS (k66 "vihjaista") ;
lin hinterland_N = mkWN (k8 "lande") ; --UNCHK
lin hip_A = mkWA (k10 "seuraava") "trendejä" ; --UNCHK
lin hip_N = mkWN (k10A "lonkka") ; --UNCHK
lin hip_bath_N = mkWN (compoundN "istuma-" (k48 "amme")) ; --UNCHK
lin hip_pocket_N = mkWN (compoundN "taka" (k1 "tasku")) ; --UNCHK
lin hipbone_N = mkWN (compoundN "lonkka" (k18 "luu")) ; --UNCHK
lin hip_flask_N = mkWN (k5A "taskumatti") ; --UNCHK
lin hiplength_A = mkWA (compoundA "lantio" (k38 "pituinen")) ; --UNCHK
lin hipless_A = mkWA "lantioton" ; --UNCHK
lin hipline_N = mkWN (compoundN "lantio" (k9 "linja")) ; --UNCHK
lin hippeastrum_N = mkWN (compoundN "ritarin" (k10A "kukka")) ; --UNCHK
lin hipped_A = mkWA (k38 "taitteinen") ; --UNCHK
lin hippie_N = mkWN (k5A "hippi") ; --UNCHK
lin hippo_N = mkWN (compoundN "virta" (k1A "hepo")) ; --UNCHK
lin hippocampus_N = mkWN (compoundN "Hippocampus-" (k1A "suku")) ; --UNCHK
lin hippocratic_A = mkWA "Hippokrateen" ; --UNCHK
lin hippodrome_N = mkWN (k5 "hippodromi") ; --UNCHK
lin hippopotamus_N = mkWN (compoundN "virta" (k1A "hepo")) ; --UNCHK
lin hippy_N = mkWN (k5A "hippi") ; --UNCHK
lin hircine_A = mkWA (compoundA "vuohi" (k38 "mainen")) ; --UNCHK
lin hire_N = mkWN (k39 "vuokraus") ; --UNCHK
lin hire_V2 = mkV2 (lin VK {s = c73A "palkata"}) ;
lin hire_V2V = mkWV2V (k53A "ottaa") "vuokralle" ; --UNCHK
lin hireling_N = mkWN (k38 "palkollinen") ; --UNCHK
lin hirsute_A = mkWA (k38 "karvainen") ; --UNCHK
lin hirsuteness_N = mkWN (k40 "karvaisuus") ; --UNCHK
lin hirvensalmi_PN = mkPN (mkN "Hirvensalmi" "Hirvensalmia") ;
lin hispid_A = mkWA (compoundA "karkea" (k38 "karvainen")) ; --UNCHK
lin hiss_N = mkWN (k39 "tuhahdus") ; --UNCHK
lin hiss_V = mkWV (k54A "viheltää") ; --UNCHK
lin hiss_V2 = mkWV2 (k54A "viheltää") ; --UNCHK
lin hiss_VQ = mkWVQ (k54A "viheltää") ; --UNCHK
lin hisser_N = mkWN "sihisijä" ; --UNCHK
lin histaminase_N = mkWN (compoundN "histamin" (k5 "aasi")) ; --UNCHK
lin histamine_N = mkWN (k5 "histamiini") ; --UNCHK
lin histidine_N = mkWN "histidiini" ; --UNCHK
lin histiocyte_N = mkWN "histiosyytti" ; --UNCHK
lin histiocytosis_N = mkWN "histiosytoosi" ; --UNCHK
lin histocompatibility_N = mkWN (compoundN "yhteen" (k40 "sopivuus")) "kudosten" ; --UNCHK
lin histogram_N = mkWN (k5 "histogrammi") ; --UNCHK
lin histoincompatibility_N = mkWN "histoinkompatibiliteetti" ; --UNCHK
lin histological_A = mkWA (k38 "histologinen") ; --UNCHK
lin histologist_N = mkWN (k5 "histologi") ; --UNCHK
lin histology_N = mkWN (k12 "histologia") ; --UNCHK
lin histone_N = mkWN "histoni" ; --UNCHK
lin historian_N = mkWN (k12 "historioitsija") ; --UNCHK
lin historic_A = mkWA (k38 "historiallinen") ; --UNCHK
lin historical_A = mkWA (k38 "historiallinen") ;
lin historicalness_N = mkWN "historiallisuus" ; --UNCHK
lin historicism_N = mkWN (compoundN "historis" (k5 "ismi")) ; --UNCHK
lin historiography_N = mkWN (compoundN "historian" (k39 "kirjoitus")) ; --UNCHK
lin history_N = mkN "historia" ;
lin histrionic_A = mkWA (k38 "pateettinen") ; --UNCHK
lin histrionics_N = mkWN (k39 "esitys") ; --UNCHK
lin hit_N = mkWN (k10 "osuma") ;
lin hit_V = mkWV (k58 "iskeä") ;
lin hit_V2 = L.hit_V2 ;
lin hit_back_V2 = mkV2 (advV OP_hit_V OP_back_Adv ) ; -- guess-p-verb
lin hit_for_V3 = variants {} ; -- guess-p-verb
lin hit_it_off_V = variants {} ; -- guess-p-verb
lin hit_it_off_with_V2 = variants {} ; -- guess-p-verb
lin hit_on_V2 = prepV2 OP_hit_V OP_on_Prep ; -- guess-p-verb
lin hit_out_at_V2 = prepV2 (advV OP_hit_V OP_out_Adv ) OP_at_Prep ; -- guess-p-verb
lin hit_up_V = advV OP_hit_V OP_up_Adv ; -- guess-p-verb
lin hit_up_V2 = prepV2 OP_hit_V OP_up_Prep ; -- guess-p-verb
lin hit_up_on_V2 = prepV2 (advV OP_hit_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin hit_upon_V2 = prepV2 OP_hit_V OP_upon_Prep ; -- guess-p-verb
lin hit_with_V3 = variants {} ; -- guess-p-verb
lin hitch_N = mkWN (k39 "nilkutus") ; --UNCHK
lin hitch_V = mkWV (k52A "juuttua") ; --UNCHK
lin hitch_V2 = mkWV2 (k52A "juuttua") ; --UNCHK
lin hitchhike_V = mkWV (k54A "pyytää") "peukalokyytiä" ; --UNCHK
lin hitchhiker_N = mkWN (k38 "peukalokyytiläinen") ; --UNCHK
lin hitchin_PN = foreignPN "Hitchin" ;
lin hitchrack_N = mkWN (compoundN "hevos" (k5 "puomi")) ; --UNCHK
lin hither_Adv = mkWAdv (k99 "tähän") ; --UNCHK
lin hitherto_Adv = mkWAdv (k99 "vielä") ; --UNCHK
lin hitless_A = mkWA "osumaton" ; --UNCHK
lin hitter_N = mkWN (k10 "lyöjä") ; --UNCHK
lin hive_N = mkWN (compoundN "mehiläis" (k10 "pesä")) ; --UNCHK
lin hive_V = mkWV (k58A "sulkea") "pesiin" ; --UNCHK
lin hive_V2 = mkWV2 (k58A "sulkea") "pesiin" ; --UNCHK
lin hive_off_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin hoar_A = mkWA (k38 "valkohapsinen") ; --UNCHK
lin hoard_N = mkWN (k9 "jemma") ; --UNCHK
lin hoard_V = mkWV (k61A "ahnehtia") ; --UNCHK
lin hoard_V2 = mkWV2 (k61A "ahnehtia") ; --UNCHK
lin hoarder_N = mkWN (k10 "hamstraaja") ; --UNCHK
lin hoarding_N = mkWN (compoundN "tienvarsi" (k39 "mainos")) ; --UNCHK
lin hoarfrost_N = mkWN (k10A "routa") ; --UNCHK
lin hoariness_N = mkWN (compoundN "iki" (k40 "vanhuus")) ; --UNCHK
lin hoarse_A = mkWA (k15 "käheä") ; --UNCHK
lin hoarseness_N = mkWN (k40 "käheys") ; --UNCHK
lin hoary_A = mkWA (compoundA "harmaan" (k15 "valkea")) ; --UNCHK
lin hoatzin_N = mkWN (compoundN "haisu" (k7A "käki")) ; --UNCHK
lin hoax_N = mkWN (k5 "humpuuki") ; --UNCHK
lin hoaxer_N = mkWN (k12 "kujeilija") ; --UNCHK
lin hob_N = mkWN (compoundN "keitto" (k1 "taso")) ; --UNCHK
lin hobbit_N = mkWN "hobitti" ; --UNCHK
lin hobble_N = mkWN (k39 "nilkutus") ; --UNCHK
lin hobble_V = mkWV (k58 "kytkeä") ; --UNCHK
lin hobble_V2 = mkWV2 (k58 "kytkeä") ; --UNCHK
lin hobble_skirt_N = mkWN (k48 "hame") "kapea" ; --UNCHK
lin hobbledehoy_N = mkWN (compoundN "teini" (k10A "poika")) ; --UNCHK
lin hobbler_N = mkWN (k2 "henkilö") "nilkuttava" ; --UNCHK
lin hobby_N = mkWN (k9A "toiminta") "vapaa-ajan" ; --UNCHK
lin hobbyhorse_N = mkWN (compoundN "keinu" (k38 "hevonen")) ; --UNCHK
lin hobbyism_N = mkWN (k40 "harrastuneisuus") ; --UNCHK
lin hobbyist_N = mkWN (k12 "harrastelija") ; --UNCHK
lin hobgoblin_N = mkWN (k1A "mörkö") ; --UNCHK
lin hobnail_N = mkWN (compoundN "kenkä" (k9 "naula")) ; --UNCHK
lin hobnob_V = mkWV (k67 "seurustella") ; --UNCHK
lin hobo_N = mkWN (k5 "pummi") ; --UNCHK
lin hock_N = mkWN (k49A "kinner") ; --UNCHK
lin hock_V2 = mkWV2 (k73A "leikata") "kinner" ; --UNCHK
lin hockey_N = mkWN (k1A "kiekko") ; --UNCHK
lin hockley_PN = foreignPN "Hockley" ;
lin hod_N = mkWN (compoundN "laasti" (k2 "kaukalo")) ; --UNCHK
lin hoddesdon_PN = foreignPN "Hoddesdon" ;
lin hodgepodge_N = mkWN (k1 "sotku") ; --UNCHK
lin hodoscope_N = mkWN (compoundN "hodosko" (k5A "oppi")) ; --UNCHK
lin hoe_N = mkWN (k10A "kuokka") ; --UNCHK
lin hoe_V = mkWV (k61A "kuokkia") ; --UNCHK
lin hoe_V2 = mkWV2 (k61A "kuokkia") ; --UNCHK
lin hoecake_N = mkWN (compoundN "maissi" (k10A "leipä")) ; --UNCHK
lin hog_N = mkN "ahnehtija" ; ---ARB --mkN "sika" ;
lin hog_V2 = mkWV2 (k61A "ahnehtia") ; --UNCHK
lin hogan_N = mkWN (compoundN "navajo-" (k39 "asumus")) ; --UNCHK
lin hogback_N = mkWN (k48A "harjanne") ; --UNCHK
lin hogchoker_N = mkWN "Trinectes" "maculatus" ; --UNCHK
lin hogfish_N = mkWN (compoundN "porsasmuri" (k9 "sija")) ; --UNCHK
lin hoggish_A = mkWA (k38 "sottainen") ; --UNCHK
lin hogmanay_N = mkWN "Hogmanay" ; --UNCHK
lin hogshead_N = mkWN (k6 "tynnyri") ; --UNCHK
lin hogwash_N = mkWN (k99 "soopa") ; --UNCHK
lin hoist_N = mkWN (k6 "nosturi") ; --UNCHK
lin hoist_V2 = mkWV2 (k53 "nostaa") "ylös" ; --UNCHK
lin hoister_N = mkWN (k10 "käyttäjä") "nostolaitteen" ; --UNCHK
lin hold_N = mkWN (k48A "ote") ;
lin hold_V = mkV "pitää" ;
lin hold_V2 = L.hold_V2 ;
lin hold_VS = mkVS "katsoa" ; --hän katsoo, että XYZ
lin hold_against_V3 = variants {} ; -- guess-p-verb
lin hold_back_V = mkWV (k67A "pidätellä") ; --UNCHK
lin hold_back_V2 = mkWV2 (k67A "pidätellä") ; --UNCHK
lin hold_back_from_V2 = prepV2 (advV OP_hold_V OP_back_Adv ) OP_from_Prep ; -- guess-p-verb
lin hold_down_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin hold_forth_V = mkWV (k52 "puhua") "paljon" ; --UNCHK
lin hold_off_V = mkWV (k53A "pitää") "puoliaan" ; --UNCHK
lin hold_off_V2 = mkWV2 (k53A "pitää") "puoliaan" ; --UNCHK
lin hold_off_on_V2 = prepV2 (advV OP_hold_V OP_off_Adv ) OP_on_Prep ; -- guess-p-verb
lin hold_on_V = mkWV (k56 "jatkaa") ; --UNCHK
lin hold_on_to_V2 = prepV2 (advV OP_hold_V OP_on_Adv ) OP_to_Prep ; -- guess-p-verb
lin hold_onto_V = variants {} ; -- guess-p-verb
lin hold_onto_V2 = prepV2 OP_hold_V OP_onto_Prep ; -- guess-p-verb
lin hold_out_V = mkWV (k54A "ojentaa") ; --UNCHK
lin hold_out_V2 = mkWV2 (k54A "ojentaa") ; --UNCHK
lin hold_out_against_V2 = prepV2 (advV OP_hold_V OP_out_Adv ) OP_against_Prep ; -- guess-p-verb
lin hold_out_for_V2 = prepV2 (advV OP_hold_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin hold_out_on_V2 = prepV2 (advV OP_hold_V OP_out_Adv ) OP_on_Prep ; -- guess-p-verb
lin hold_over_V2 = mkWV2 (k73A "uhata") ; --UNCHK
lin hold_together_V = advV OP_hold_V OP_together_Adv ; -- guess-p-verb
lin hold_up_V2 = mkWV2 (k53A "viivästyttää") ; --UNCHK
lin hold_with_V2 = prepV2 OP_hold_V OP_with_Prep ; -- guess-p-verb
lin holdall_N = mkWN (k5 "kori") ; --UNCHK
lin holder_N = mkN "omistaja" ; ---ARB mkN "pitäjä"
lin holding_N = mkN "omistus" ;
lin holdout_N = mkWN (k39 "pimitys") ; --UNCHK
lin holdover_N = mkWN (k1A "perintö") ; --UNCHK
lin hold_up_N = mkWN (k9A "keikka") ; --UNCHK
lin hole_N = mkWN (k1 "kolo") ; --UNCHK
lin hole_V = mkWV (k53A "rei'ittää") ; --UNCHK
lin hole_V2 = mkWV2 (k53A "rei'ittää") ; --UNCHK
lin hole_up_V = mkWV (k53 "horrostaa") ; --UNCHK
lin holey_A = mkWA (k38 "puutteellinen") ; --UNCHK
lin holiday_N = mkWN (k10 "loma") ;
lin holiday_V = mkWV (k53A "viettää") "lomaa" ; --UNCHK
lin holiness_N = mkWN (k40 "pyhyys") ; --UNCHK
lin holism_N = mkWN (k12 "teoria") "holistinen" ; --UNCHK
lin holistic_A = mkWA (k38 "holistinen") ; --UNCHK
lin holland_PN = foreignPN "Holland" ;
lin hollandaise_N = mkWN (compoundN "hollandaise" (k48A "kastike")) ; --UNCHK
lin hollander_N = mkWN (k38 "hollantilainen") ; --UNCHK
lin holler_V = mkWV (k53A "valittaa") ; --UNCHK
lin holler_V2 = mkWV2 (k53A "valittaa") ; --UNCHK
lin holloa_N = mkWN (k9A "ärjyntä") ; --UNCHK
lin hollola_PN = mkPN "Hollola" ;
lin hollow_A = mkWA (k1A "ontto") ; --UNCHK
lin hollow_N = mkWN (k2 "onkalo") ; --UNCHK
lin hollow_V2 = mkWV2 (k56 "kaivaa") "tyhjäksi" ; --UNCHK
lin hollowness_N = mkWN (k40 "tyhjyys") ; --UNCHK
lin hollowware_N = mkWN (compoundN "hopea-" (k1 "astiasto")) ; --UNCHK
lin holly_N = variants {} ; --
lin hollyhock_N = mkWN (compoundN "salko" (k1 "ruusu")) ; --UNCHK
lin hollywood_PN = foreignPN "Hollywood" ;
lin holm_oak_N = mkWN (kH1 "tammi") "ikivihreä" ; --UNCHK
lin holmfirth_PN = foreignPN "Holmfirth" ;
lin holmium_N = mkWN "järjestysluku" "67" ; --UNCHK
lin holocaust_N = mkWN (compoundN "kansan" (k10 "murha")) ; --UNCHK
lin holocephalan_N = mkWN "holocephalian" ; --UNCHK
lin hologram_N = mkWN (k5 "hologrammi") ; --UNCHK
lin holograph_N = mkWN (k5 "hologrammi") ; --UNCHK
lin holographic_A = mkWA (compoundA "oma" (k38 "kätinen")) ; --UNCHK
lin holography_N = mkWN (k12 "holografia") ; --UNCHK
lin holometabola_N = mkWN "metabola" ; --UNCHK
lin holometabolic_A = mkWA (compoundA "holo" (k38 "metabolinen")) ; --UNCHK
lin holometabolism_N = mkWN (compoundN "muodon" (k39 "vaihdos")) "täydellinen" ; --UNCHK
lin holonym_N = mkWN (compoundN "kokonais" (k48A "käsite")) ; --UNCHK
lin holonymy_N = mkWN (compoundN "kokonaiskäsitte" (k40 "isyys")) "merkityksen" ; --UNCHK
lin holophyte_N = mkWN "holofyytti" ; --UNCHK
lin holophytic_A = mkWA "holofyyttinen" ; --UNCHK
lin holster_N = mkWN (k2 "kotelo") ; --UNCHK
lin holy_A = mkWA (k10 "pyhä") ; --UNCHK
lin holy_N = mkWN (k9A "paikka") "pyhä" ; --UNCHK
lin holyhead_PN = foreignPN "Holyhead" ;
lin holystone_N = mkWN (compoundN "hohka" (k7 "kivi")) ; --UNCHK
lin holystone_V2 = mkWV2 (k53 "puhdistaa") "hohkakivellä" ; --UNCHK
lin homage_N = mkWN (compoundN "kunnian" (k39 "osoitus")) ; --UNCHK
lin home_A = mkWA "koti-" ; --UNCHK
lin home_Adv = mkAdv "kotiin" | mkAdv "kotona" ; ---- split
lin home_N = mkN "koti" ;
lin homebound_A = mkWA (k10 "pysyvä") "kotona" ; --UNCHK
lin homebound_N = mkWN (compoundN "koti" (k10A "rotta")) ; --UNCHK
lin homeboy_N = mkWN (k5 "kundi") "kotikylän" ; --UNCHK
lin homebuilder_N = mkWN (k10 "rakentaja") "talojen" ; --UNCHK
lin homecoming_N = mkWN (k17 "paluu") ; --UNCHK
lin homefolk_N = mkWN (compoundN "koti" (k7A "väki")) ; --UNCHK
lin homegirl_N = mkWN (compoundN "jengi" (k6 "kaveri")) ; --UNCHK
lin home_grown_A = mkWA "oman" "sadon" ; --UNCHK
lin homeland_N = mkWN (compoundN "synnyin" (k18 "maa")) ; --UNCHK
lin homeless_A = mkWA (k34A "asunnoton") ; --UNCHK
lin homelessness_N = mkWN (k40 "asunnottomuus") ; --UNCHK
lin homelike_A = mkWA (k10 "viihtyisä") ; --UNCHK
lin homeliness_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin homely_A = mkWA (k34A "vaatimaton") ; --UNCHK
lin home_made_A = mkWA (compoundA "koti" (k38 "tekoinen")) ; --UNCHK
lin homemaking_N = mkWN (compoundN "kodin" (k1A "hoito")) ; --UNCHK
lin homeobox_N = mkWN (compoundN "homeobox-" (k5 "geeni")) ; --UNCHK
lin homeopath_N = mkWN (compoundN "homeo" (k5A "paatti")) ; --UNCHK
lin homeopathic_A = mkWA (k38 "homeopaattinen") ; --UNCHK
lin homeopathy_N = mkWN (k12 "homeopatia") ; --UNCHK
lin homeostasis_N = mkWN (k5 "homeostaasi") ; --UNCHK
lin homeostatic_A = mkWA (k38 "homeostaattinen") ; --UNCHK
lin homeotherm_N = mkWN (k33 "eläin") "homeoterminen" ; --UNCHK
lin homeowner_N = mkWN (compoundN "talon" (k10 "omistaja")) ; --UNCHK
lin homer_N = mkWN (k6 "kunnari") ; --UNCHK
lin homer_V = mkWV (k64 "lyödä") "kunnari" ; --UNCHK
lin homeric_A = mkWA (k38 "homeerinen") ; --UNCHK
lin homesick_A = mkWA "koti-ikävää" "tunteva" ; --UNCHK
lin homesickness_N = mkWN (compoundN "koti-" (k10 "ikävä")) ; --UNCHK
lin homespun_A = mkWA (compoundA "käsi" (k1 "nkehrätty")) ; --UNCHK
lin homespun_N = mkWN (kH1 "kangas") "käsinkehrätty" ; --UNCHK
lin homestead_N = mkWN (compoundN "maa" (k9 "tila")) ; --UNCHK
lin homestretch_N = mkWN (compoundN "maali" (k10 "suora")) ; --UNCHK
lin hometown_N = mkWN (compoundN "koti" (k9A "paikka")) ; --UNCHK
lin homeward_A = mkWA (compoundA "suunt" (k9 "aava")) "kotiinpäin" ; --UNCHK
lin homeward_Adv = mkWAdv (k99 "päin") "kotiin" ; --UNCHK
lin homewards_Adv = mkWAdv (k99 "päin") "kotiin" ; --UNCHK
lin homework_N = mkWN (compoundN "valmis" (k38 "tautuminen")) ; --UNCHK
lin homey_A = mkWA (k10 "viihtyisä") ; --UNCHK
lin homicidal_A = mkWA (k10 "murhaava") ; --UNCHK
lin homicide_N = mkWN (k1A "tappo") ; --UNCHK
lin homiletic_A = mkWA (compoundA "homil" (k38 "eettinen")) ; --UNCHK
lin homiletics_N = mkWN (compoundN "saarna" (k38 "aminen")) ; --UNCHK
lin homily_N = mkWN (k9 "saarna") ; --UNCHK
lin hominal_A = mkWA "ihmis-" ; --UNCHK
lin homing_A = mkWA "paluu-" ; --UNCHK
lin hominian_A = mkWA "ihmisapina-" ; --UNCHK
lin hominid_N = mkWN (k5 "hominidi") ; --UNCHK
lin hominine_A = mkWA "ihmis-" ; --UNCHK
lin hominoid_N = mkWN (compoundN "ihmis" (k12 "apina")) ; --UNCHK
lin homo_N = mkWN (k38 "ihminen") ; --UNCHK
lin homo_sapiens_N = mkWN "Homo" "sapiens" ; --UNCHK
lin homocercal_A = mkWA (compoundA "tasapyrst" (k38 "öinen")) ; --UNCHK
lin homocyclic_A = mkWA (compoundA "iso" (k38 "syklinen")) ; --UNCHK
lin homoeopath_N = mkWN (compoundN "homeo" (k5A "paatti")) ; --UNCHK
lin homoeopathy_N = mkWN (k12 "homeopatia") ; --UNCHK
lin homoerotic_A = mkWA (compoundA "homo" (k38 "eroottinen")) ; --UNCHK
lin homogenate_N = mkWN (compoundN "homoge" (k5A "naatti")) ; --UNCHK
lin homogeneity_N = mkWN (k40 "homogeenisuus") ; --UNCHK
lin homogeneous_A = mkWA (k38 "yhtenäinen") ; --UNCHK
lin homogenize_V2 = mkWV2 (k62 "homogenoida") ; --UNCHK
lin homogeny_N = mkWN "homogenia" ; --UNCHK
lin homograft_N = mkWN "allografti" ; --UNCHK
lin homograph_N = mkWN "homografi" ; --UNCHK
lin homoiothermic_A = mkWA (compoundA "tasa" (k38 "lämpöinen")) ; --UNCHK
lin homologic_A = mkWA (compoundA "sama" (k38 "syntyinen")) ; --UNCHK
lin homologous_A = mkWA (compoundA "sama" (k38 "syntyinen")) ; --UNCHK
lin homology_N = mkWN "homologia" ; --UNCHK
lin homomorphism_N = mkWN (compoundN "homomorf" (k5 "ismi")) ; --UNCHK
lin homonym_N = mkWN (k5 "homonyymi") ; --UNCHK
lin homonymic_A = mkWA (compoundA "homo" (k38 "nyyminen")) ; --UNCHK
lin homonymy_N = mkWN "homonymia" ; --UNCHK
lin homophobe_N = mkWN "homofobi" ; --UNCHK
lin homophobia_N = mkWN (compoundN "homo" (k12 "fobia")) ; --UNCHK
lin homophobic_A = mkWA (compoundA "homo" (k38 "fobinen")) ; --UNCHK
lin homophone_N = mkWN "homofoni" ; --UNCHK
lin homophonic_A = mkWA (compoundA "homo" (k38 "foninen")) ; --UNCHK
lin homophonous_A = mkWA (compoundA "homo" (k38 "foninen")) ; --UNCHK
lin homophony_N = mkWN "homofonia" ; --UNCHK
lin homosexual_A = mkWA (k1 "homo") ; --UNCHK
lin homosexual_N = mkWN (k21 "gay") ; --UNCHK
lin homosexuality_N = mkWN (k40 "lesbous") ; --UNCHK
lin homosporous_A = mkWA (compoundA "homo" (k38 "sporinen")) ; --UNCHK
lin homospory_N = mkWN "homosporia" ; --UNCHK
lin homozygosity_N = mkWN "homotsygoottisuus" ; --UNCHK
lin homozygote_N = mkWN (k5A "homotsygootti") ; --UNCHK
lin homozygous_A = mkWA (k38 "homotsygoottinen") ; --UNCHK
lin homunculus_N = mkWN "homunculus" ; --UNCHK
lin honduran_A = mkWA (compoundA "hondurasi" (k38 "lainen")) ; --UNCHK
lin honduran_N = mkWN (compoundN "hondurasi" (k38 "lainen")) ; --UNCHK
lin honduras_PN = foreignPN "Honduras" ;
lin hone_N = mkWN (compoundN "liippa" (k7 "kivi")) ; --UNCHK
lin hone_V2 = mkWV2 (k71 "tehdä") "täydelliseksi" ; --UNCHK
lin honest_A = mkA "rehellinen" ;
lin honesty_N = mkWN (k40 "rehtiys") ; --UNCHK
lin honey_A = mkWA (compoundA "hunajan" (k38 "värinen")) ; --UNCHK
lin honey_N = mkWN (k10 "hunaja") ; --UNCHK
lin honeybee_N = mkWN (k38 "mehiläinen") ; --UNCHK
lin honeycomb_N = mkWN (k2 "kennosto") ; --UNCHK
lin honeycomb_V2 = mkWV2 (compoundV "kenn" (k53A "ottaa")) ; --UNCHK
lin honeycreeper_N = mkWN "Cyanerpes" ; --UNCHK
lin honeydew_N = mkWN (compoundN "hunaja" (k6 "meloni")) ; --UNCHK
lin honeyed_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin honeyflower_N = mkWN "Protea" "mellifera" ; --UNCHK
lin honeylike_A = mkWA (compoundA "hunaja" (k38 "mainen")) ; --UNCHK
lin honeymoon_N = mkWN (compoundN "hää" (k9 "matka")) ; --UNCHK
lin honeymoon_V = mkWV (k67 "mennä") "häämatkalle" ; --UNCHK
lin honeypot_N = mkWN "Protea" "cynaroides" ; --UNCHK
lin honeysuckle_N = mkWN (compoundN "kanadan" (k9 "akileija")) ; --UNCHK
lin hong_kong_PN = foreignPN "Hong Kong" ;
lin honiton_PN = foreignPN "Honiton" ;
lin honk_N = mkWN (k39 "kaakatus") ; --UNCHK
lin honk_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin honkajoki_PN = mkPN (mkN "Honkajoki" "Honkajokia") ;
lin honker_N = mkWN (compoundN "kanadan" (k7 "hanhi")) ; --UNCHK
lin honkytonk_N = mkWN (k14A "kapakka") ; --UNCHK
lin honor_V2 = mkWV2 (k53A "kelpuuttaa") ; --UNCHK
lin honorable_A = mkWA (k38 "kunniallinen") ; --UNCHK
lin honorableness_N = mkWN (k40 "kunniakkuus") ; --UNCHK
lin honorarium_N = mkWN (k3 "palkkio") ; --UNCHK
lin honorary_A = mkWA "kunnia-" ; --UNCHK
lin honoree_N = mkWN (k10 "saaja") "kunniamerkin" ; --UNCHK
lin honorific_A = mkWA "kunnioitusta" "osoittava" ; --UNCHK
lin honorific_N = mkWN (compoundN "arvo" (k7 "nimi")) ; --UNCHK
lin honoring_N = mkWN "noudatus" ; --UNCHK
lin honour_N = mkWN (k40 "koskemattomuus") ; --UNCHK
lin honour_V2 = mkWV2 (k53A "kelpuuttaa") ; --UNCHK
lin honourable_A = mkWA (k38 "kunniallinen") ; --UNCHK
lin hoo_PN = foreignPN "Hoo" ;
lin hooch_N = mkWN (k9 "viina") "kotipolttoinen" ; --UNCHK
lin hood_N = mkWN (compoundN "iho" (k1 "poimu")) ; --UNCHK
lin hood_V2 = mkWV2 (k53A "peittää") "hupulla" ; --UNCHK
lin hoodlum_N = mkWN (k1 "rosvo") ; --UNCHK
lin hoodoo_N = mkWN (k10 "tuottaja") "epäonnen" ; --UNCHK
lin hoodoo_V2 = mkWV2 (k53A "tuottaa") "epäonnea" ; --UNCHK
lin hoodwink_V2 = mkWV2 (k53A "petkuttaa") ; --UNCHK
lin hooey_N = mkWN (k99 "soopa") ; --UNCHK
lin hoof_N = mkWN (k3 "kavio") ; --UNCHK
lin hoofer_N = mkWN (k10 "steppaaja") ; --UNCHK
lin hooflike_A = mkWA (compoundA "kavio" (k38 "mainen")) ; --UNCHK
lin hoofprint_N = mkWN (k7A "jälki") "kavion" ; --UNCHK
lin hook_N = mkN "koukku" ;
lin hook_V = mkWV (k67 "ahdistella") ; --UNCHK
lin hook_V2 = mkWV2 (k67 "ahdistella") ; --UNCHK
lin hook_up_V = mkWV (k53A "liittää") ; --UNCHK
lin hook_up_V2 = mkWV2 (k53A "liittää") ; --UNCHK
lin hookah_N = mkWN (compoundN "vesi" (k1A "piippu")) ; --UNCHK
lin hooker_N = mkWN (compoundN "hooker-" (k10 "pelaaja")) ; --UNCHK
lin hooklike_A = mkWA (k38 "koukkuinen") ; --UNCHK
lin hook_up_N = mkWN (k39 "asennus") ; --UNCHK
lin hookworm_N = mkWN (compoundN "koukku" (k1A "mato")) ; --UNCHK
lin hooky_N = mkWN (k39 "pinnaus") ; --UNCHK
lin hooligan_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin hooliganism_N = mkWN (k5 "huliganismi") ; --UNCHK
lin hoop_N = mkWN (compoundN "kori" (k41A "rengas")) ; --UNCHK
lin hoop_V2 = mkWV2 (k61A "vannehtia") ; --UNCHK
lin hoopoe_N = mkWN (compoundN "harja" (k1A "lintu")) ; --UNCHK
lin hoopskirt_N = mkWN (k5 "krinoliini") ; --UNCHK
lin hoosegow_N = mkWN (k10 "tyrmä") ; --UNCHK
lin hoot_V = mkWV (k52 "ulvoa") ; --UNCHK
lin hoot_V2 = mkWV2 (k52 "ulvoa") ; --UNCHK
lin hooter_N = mkWN (k1 "pöllö") "Minervan" ; --UNCHK
lin hoover_N = mkWN "Hoover" ; --UNCHK
lin hoover_V2 = mkWV2 (k62 "imuroida") ; --UNCHK
lin hop_N = mkWN (k39 "hyppäys") ; --UNCHK
lin hop_V = mkWV (k53 "matkustaa") ; --UNCHK
lin hop_V2 = mkWV2 (k53 "matkustaa") ; --UNCHK
lin hop_field_N = mkWN (k1 "humalisto") ; --UNCHK
lin hop_garden_N = mkWN (k1 "humalisto") ; --UNCHK
lin hop_pole_N = mkWN (compoundN "humala" (k1A "salko")) ; --UNCHK
lin hope_N = mkWN (k1 "toivo") ;
lin hope_PN = foreignPN "Hope" ;
lin hope_V = mkV "toivoa" ;
lin hope_VS = L.hope_VS ;
lin hope_VV = mkVV (mkV "toivoa") infPresPartAgr ;
lin hopeful_A = mkWA (k41A "toiveikas") ; --UNCHK
lin hopefulness_N = mkWN (k1 "toivo") ; --UNCHK
lin hopeless_A = mkWA (k38 "epätoivoinen") ; --UNCHK
lin hopelessness_N = mkWN (compoundN "epä" (k1 "toivo")) ; --UNCHK
lin hoper_N = mkWN (compoundN "toiv" (k10 "oja")) ; --UNCHK
lin hopsacking_N = mkWN (compoundN "panama" (k39 "sidos")) ; --UNCHK
lin hopscotch_N = mkWN (compoundN "ruutu" (k2 "hyppely")) ; --UNCHK
lin horace_PN = foreignPN "Horace" ;
lin horary_A = mkWA "tunti-" ; --UNCHK
lin horde_N = mkWN (k10 "määrä") "valtava" ; --UNCHK
lin horehound_N = mkWN (compoundN "hurtan" (k1A "minttu")) ; --UNCHK
lin horizon_N = mkWN (k10 "näkymä") ; --UNCHK
lin horizontal_A = mkWA (compoundA "vaaka" (k10 "suora")) ; --UNCHK
lin horizontal_N = mkWN (compoundN "vaaka" (k10 "suora")) ; --UNCHK
lin horizontality_N = mkWN (compoundN "vaaka" (k40 "suoruus")) ; --UNCHK
lin horley_PN = foreignPN "Horley" ;
lin hormonal_A = mkWA (k38 "hormonaalinen") ; --UNCHK
lin hormone_N = mkWN (k5 "hormoni") ; --UNCHK
lin horn_N = L.horn_N ;
lin horn_V = mkWV (k53 "lävistää") "sarvella" ; --UNCHK
lin hornbeam_N = mkWN (compoundN "valko" (k5A "pyökki")) ; --UNCHK
lin hornbill_N = mkWN (compoundN "sarvi" (k10A "nokka")) ; --UNCHK
lin hornblende_N = mkWN (compoundN "sarvi" (k48A "välke")) ; --UNCHK
lin hornbook_N = mkWN (compoundN "alkeis" (k9 "kirja")) ; --UNCHK
lin horned_A = mkWA (k41A "sarvekas") ; --UNCHK
lin hornet_N = mkWN (k38 "herhiläinen") ; --UNCHK
lin hornfels_N = mkWN (compoundN "sarvi" (k7 "kivi")) ; --UNCHK
lin horniness_N = mkWN (k40 "kiihottuneisuus") ; --UNCHK
lin hornist_N = mkWN (compoundN "torven" (k10 "soittaja")) ; --UNCHK
lin hornless_A = mkWA "sarveton" ; --UNCHK
lin hornlike_A = mkWA (compoundA "sarvi" (k38 "mainen")) ; --UNCHK
lin hornpipe_N = mkWN (compoundN "merimies" (k5 "tanssi")) "brittiläinen" ; --UNCHK
lin hornsea_PN = foreignPN "Hornsea" ;
lin hornwort_N = mkWN (compoundN "karva" (k7A "lehti")) ; --UNCHK
lin horny_A = mkWA (compoundA "sarvi" (k38 "mainen")) ; --UNCHK
lin horology_N = mkWN (k39 "valmistus") "kellojen" ; --UNCHK
lin horoscope_N = mkWN (k5A "horoskooppi") ; --UNCHK
lin horoscopy_N = mkWN "horoskopia" ; --UNCHK
lin horrible_A = mkA "kamala" ;
lin horrid_A = mkWA (k15 "kauhea") ; --UNCHK
lin horridness_N = mkWN (k40 "hirveys") ; --UNCHK
lin horrific_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin horrify_V2 = mkWV2 (k53A "pelästyttää") ; --UNCHK
lin horrifyingly_Adv = mkWAdv (compoundAdv "kauhistuttav" (k99 "asti")) ; --UNCHK
lin horror_N = mkWN (k39 "kauhistus") ; --UNCHK
lin hors_de_combat_A = mkA "haavoittunut" ;
lin horse_N = L.horse_N ;
lin horse_around_V = mkWV (k67A "hullutella") ; --UNCHK
lin horse_chestnut_N = mkWN (compoundN "hevos" (k12 "kastanja")) ; --UNCHK
lin horse_sense_N = mkWN (k1 "vaisto") "äidin" ; --UNCHK
lin horseback_Adv = mkWAdv (k99 "ratsailla") ; --UNCHK
lin horseback_N = mkWN (k10A "selkä") "hevosen" ; --UNCHK
lin horsebox_N = mkWN (compoundN "hevoskuljetus" (k1 "vaunu")) ; --UNCHK
lin horsecar_N = mkWN "hevosraitiovaunu" ; --UNCHK
lin horsecloth_N = mkWN (compoundN "hevos" (k25 "loimi")) ; --UNCHK
lin horseflesh_N = mkWN (k9 "liha") "hevosen" ; --UNCHK
lin horsefly_N = mkWN (k9 "paarma") ; --UNCHK
lin horsehair_N = mkWN (k41A "jouhikangas") ; --UNCHK
lin horsehide_N = mkWN (compoundN "hevosen" (k10A "vuota")) ; --UNCHK
lin horseleech_N = mkWN (compoundN "hevos" (k41A "juotikas")) ; --UNCHK
lin horseman_N = mkWN (compoundN "hevos" (k10 "harrastaja")) ; --UNCHK
lin horsemanship_N = mkWN (compoundN "ratsastus" (k1A "taito")) ; --UNCHK
lin horsemeat_N = mkWN (k9 "liha") "hevosen" ; --UNCHK
lin horsemint_N = mkWN (compoundN "harmaa" (k1A "minttu")) ; --UNCHK
lin horseplay_N = mkWN (compoundN "hevosen" (k5A "leikki")) ; --UNCHK
lin horse_pond_N = mkWN (k4A "lammikko") ; --UNCHK
lin horsepower_N = mkWN (compoundN "hevos" (k10 "voima")) ; --UNCHK
lin horseradish_N = mkWN (k26 "piparjuuri") ; --UNCHK
lin horseshoe_N = mkWN (k10A "kenkä") ; --UNCHK
lin horsetail_N = mkWN (k48A "korte") ; --UNCHK
lin horseweed_N = mkWN (compoundN "kanadankoiran" (k10 "silmä")) ; --UNCHK
lin horsewhip_N = mkWN (compoundN "ratsu" (k9 "piiska")) ; --UNCHK
lin horsewhip_V2 = mkWV2 (k61 "ruoskia") ; --UNCHK
lin horsewhipping_N = mkWN "ruoskinta" ; --UNCHK
lin horsewoman_N = mkWN (compoundN "nais" (k10 "ratsastaja")) ; --UNCHK
lin horsham_PN = foreignPN "Horsham" ;
lin horsley_PN = foreignPN "Horsley" ;
lin horst_N = mkWN (k5 "horsti") ; --UNCHK
lin hortative_A = mkWA (compoundA "keh" (k10 "ottava")) ; --UNCHK
lin hortensia_N = mkWN (k12 "hortensia") "Rudbeckia" "laciniata" ; --UNCHK
lin horticultural_A = mkWA "puutarha-" ; --UNCHK
lin horticulture_N = mkWN (compoundN "puutarhan" (k2 "viljely")) ; --UNCHK
lin horticulturist_N = mkWN (k5 "hortonomi") ; --UNCHK
lin horwich_PN = foreignPN "Horwich" ;
lin hosanna_N = mkWN (k9 "hoosianna") ; --UNCHK
lin hose_N = mkWN (k7 "putki") "joustava" ; --UNCHK
lin hose_V2 = mkWV2 (k66 "pestä") ; --UNCHK
lin hose_down_V2 = mkWV2 (k66 "pestä") ; --UNCHK
lin hosepipe_N = mkWN (k7 "putki") "joustava" ; --UNCHK
lin hosier_N = mkWN (compoundN "sukka" (k41 "kauppias")) ; --UNCHK
lin hospice_N = mkWN (compoundN "hoiva" (k5A "koti")) ; --UNCHK
lin hospitable_A = mkWA (k38 "edullinen") ; --UNCHK
lin hospitableness_N = mkWN (compoundN "vieraanva" (k40 "raisuus")) ; --UNCHK
lin hospital_N = mkWN (k13 "sairaala") ;
lin hospitality_N = mkN "vieraanvaraisuus" ;
lin hospitalization_N = mkWN (k1 "olo") "sairaalassa" ; --UNCHK
lin hospitalize_V2 = mkWV2 (k52A "joutua") "sairaalaan" ; --UNCHK
lin host_N = mkWN (k10A "isäntä") ;
lin host_V2 = mkV2 "isännöidä" partitive ; --WV2 (k61 "toimia") "isäntänä" ;
lin hostage_N = mkWN (compoundN "pantti" (k5A "vanki")) ;
lin hostel_N = mkWN (compoundN "opiskelija-" (k12 "asuntola")) ; --UNCHK
lin hosteller_N = mkWN (k10 "matkustaja") ; --UNCHK
lin hostelry_N = mkWN (k6 "kievari") ; --UNCHK
lin hostess_N = mkWN (k10A "emäntä") ; --UNCHK
lin hostile_A = mkA "vihamielinen" ;
lin hostile_N = mkWN (k38 "vihollinen") ; --UNCHK
lin hostilities_N = mkWN (compoundN "vihamiel" (k40 "isyys")) ; --UNCHK
lin hostility_N = mkWN (k39 "hyökkäys") ; --UNCHK
lin hot_A = L.hot_A ;
lin hotbed_N = mkWN (compoundN "taimi" (k9 "lava")) ; --UNCHK
lin hotchpotch_N = mkWN (compoundN "lihavihannes" (k39 "muhennos")) ; --UNCHK
lin hotdog_N = mkWN (kH1 "nakki") ; --UNCHK
lin hotel_N = mkWN (k6 "hotelli") ;
lin hotelier_N = mkWN (k10 "johtaja") "hotellin" ; --UNCHK
lin hotfoot_Adv = mkWAdv (k99 "vilkkaa") "kiireen" ; --UNCHK
lin hotfoot_N = mkWN (k9 "pila") "käytännön" ; --UNCHK
lin hotfoot_V = mkWV (k53A "kiirehtää") ; --UNCHK
lin hothead_N = mkWN (k1A "uskalikko") ; --UNCHK
lin hot_headed_A = mkWA (k38 "äkillinen") ; --UNCHK
lin hothouse_N = mkWN "talvipuutarha" ; --UNCHK
lin hotness_N = mkWN (k40 "tulisuus") ; --UNCHK
lin hotplate_N = mkWN (compoundN "keitto" (k1 "levy")) ; --UNCHK
lin hotspur_N = mkWN (k38 "ihminen") "kiivas" ; --UNCHK
lin hottish_A = mkWA "kuumahko" ; --UNCHK
lin houghton_PN = foreignPN "Houghton" ;
lin hound_N = mkWN (compoundN "ajo" (k10 "koira")) ; --UNCHK
lin hound_V2 = mkWV2 (k53A "jäljittää") ; --UNCHK
lin hounslow_PN = foreignPN "Hounslow" ;
lin hour_N = mkN "tunti" ;
lin hourglass_N = mkWN (compoundN "tiima" (k5 "lasi")) ; --UNCHK
lin houri_N = mkWN (k5 "huuri") ; --UNCHK
lin hourlong_A = mkWA (k10 "kestävä") "tunnin" ; --UNCHK
lin hourly_A = mkWA (compoundA "joka" (k38 "tuntinen")) ; --UNCHK
lin hourly_Adv = adjAdv hourly_A ; -- derived
lin hours_N = mkWN "tunteja" ; --UNCHK
lin house_N = L.house_N ;
lin house_V2 = mkV2 "majoittaa" ; --mkV2 (mkV (mkV "antaa") "yösija") allative ;
lin houseboat_N = mkWN (compoundN "asunto" (k9 "laiva")) ; --UNCHK
lin housebound_A = mkWA (k10 "pysyvä") "kotona" ; --UNCHK
lin housebreaker_N = mkWN (k10 "murtautuja") ; --UNCHK
lin housebreaking_N = mkWN (k1A "murto") ; --UNCHK
lin housebroken_A = mkWA (compoundA "sisä" (k5 "siisti")) ; --UNCHK
lin housecleaning_N = mkWN (k39 "suursiivous") ; --UNCHK
lin housecoat_N = mkWN (compoundN "aamu" (k5A "takki")) ; --UNCHK
lin housecraft_N = mkWN (compoundN "talouden" (k1A "hoito")) ; --UNCHK
lin housedog_N = mkWN (compoundN "vartio" (k10 "koira")) ; --UNCHK
lin housefather_N = mkWN (compoundN "asuntolan" (k10 "johtaja")) ; --UNCHK
lin housefly_N = mkWN (k38 "kärpänen") ; --UNCHK
lin houseful_N = mkWN (k38 "talollinen") ; --UNCHK
lin household_N = mkN "kotitalous" ;
lin householder_N = mkWN (compoundN "talon" (k10 "omistaja")) ; --UNCHK
lin housekeeper_N = mkWN (compoundN "talouden" (k10 "hoitaja")) ; --UNCHK
lin housemaid_N = mkWN (k32A "palvelijatar") ; --UNCHK
lin houseman_N = mkWN (k5 "amanuenssi") ; --UNCHK
lin housemaster_N = mkWN (compoundN "mies" (k10 "opettaja")) "oppilasasuntolaa" "valvova" ; --UNCHK
lin housemate_N = mkWN (compoundN "kämppä" (k6 "kaveri")) ; --UNCHK
lin housemother_N = mkWN (compoundN "asuntolan" (k10 "johtaja")) ; --UNCHK
lin houseplant_N = mkWN (compoundN "huone" (k5 "kasvi")) ; --UNCHK
lin houseroom_N = mkWN (compoundN "asuin" (k9 "tila")) ; --UNCHK
lin housetop_N = mkWN (k1A "katto") ; --UNCHK
lin housewife_N = mkWN (k10A "emäntä") "talon" ; --UNCHK
lin housewifely_A = mkWA (compoundA "koti" (k38 "rouvamainen")) ; --UNCHK
lin housewifery_N = mkWN (k40 "emännyys") ; --UNCHK
lin housework_N = mkWN (compoundN "kodin" (k1A "hoito")) ; --UNCHK
lin housewrecker_N = mkWN (k10 "murtautuja") ; --UNCHK
lin housing_N = mkN "asuntotuotanto" ;
lin houston_PN = foreignPN "Houston" ;
lin houtskär_PN = mkPN "Houtskär" ;
lin hove_PN = foreignPN "Hove" ;
lin hovea_N = mkWN "hovea" ; --UNCHK
lin hovel_N = mkWN (k5A "mökki") ; --UNCHK
lin hover_V = mkV "leijua" ;
lin hovercraft_N = mkWN (compoundN "pinta" (k33A "liidin")) ; --UNCHK
lin how8many_IDet = S.how8many_IDet ;
lin how8much_IAdv = S.how8much_IAdv ;
lin how8much_IDet = {s = \\c => "kuinka" ++ (snoun2nounBind (exceptNomN (mkN "paljo") "paljon")).s ! NCase Sg c ; n = Sg ; isNum = False} ;
lin how_IAdv = S.how_IAdv ;
lin howard_PN = foreignPN "Howard" ;
lin howdah_N = mkWN (k33 "istuin") "katoksellinen" ; --UNCHK
lin however_Adv = mkAdv "kuitenkin" | mkAdv "kuitenkaan" ;
lin howitzer_N = mkWN (k5 "haupitsi") ; --UNCHK
lin howl_N = mkWN (k12 "ulina") ; --UNCHK
lin howl_V = mkWV (k52 "ulvoa") ; --UNCHK
lin howl_V2 = mkWV2 (k52 "ulvoa") ; --UNCHK
lin howler_N = mkWN (k39 "kömmähdys") ; --UNCHK
lin hoyden_N = mkWN (compoundN "poika" (k1A "tyttö")) ; --UNCHK
lin hoydenish_A = mkWA (k38 "poikamainen") ; --UNCHK
lin hoydenism_N = mkWN (k40 "poikamaisuus") ; --UNCHK
lin hoylake_PN = foreignPN "Hoylake" ;
lin hp_N = mkWN (compoundN "hevos" (k10 "voima")) ; --UNCHK
lin hryvnia_N = mkWN "grivna" ; --UNCHK
lin huarache_N = mkWN (compoundN "nahka" (k6 "sandaali")) ; --UNCHK
lin hub_N = mkN "keskus" ; --mkWN (k9A "napa") ;
lin hubbub_N = mkWN (k12 "mekkala") ; --UNCHK
lin hubby_N = mkWN (k1A "ukko") ; --UNCHK
lin hubcap_N = mkWN (compoundN "pöly" (k6 "kapseli")) ; --UNCHK
lin hubris_N = mkWN (k39 "hybris") ; --UNCHK
lin huck_N = mkWN "huckaback" ; --UNCHK
lin huckaback_N = mkWN "huckaback" ; --UNCHK
lin huckleberry_N = mkWN (k14A "mustikka") ; --UNCHK
lin hucknall_PN = foreignPN "Hucknall" ;
lin huckster_N = mkWN (k12 "kaupustelija") ; --UNCHK
lin huddersfield_PN = foreignPN "Huddersfield" ;
lin huddle_N = mkWN (k5 "palaveri") ; --UNCHK
lin huddle_V = mkV "käpertyä" ;
lin huddler_N = mkWN "kyyristelijä" ; --UNCHK
lin hudud_N = mkWN (kH1 "laki") "islamilainen" ; --UNCHK
lin hue_N = mkWN (k5 "väri") ; --UNCHK
lin hueless_A = mkWA (k34A "väritön") ; --UNCHK
lin huff_N = mkWN (k39 "ärsytys") ; --UNCHK
lin huff_V = mkWV (k53A "puuskuttaa") ; --UNCHK
lin huffiness_N = mkWN (compoundN "kiukun" (k10 "puuska")) ; --UNCHK
lin huffish_A = mkWA (k33A "hapan") ; --UNCHK
lin huffy_A = mkWA (k38 "vihainen") ; --UNCHK
lin hug_N = mkWN (k39 "rutistus") ; --UNCHK
lin hug_V2 = mkV2 "halata" ;
lin huge_A = mkWA (k10 "valtava") ; --f167
lin hugely_Adv = adjAdv huge_A ; -- derived
lin hugger_N = mkWN "halaaja" ; --UNCHK
lin huguenot_N = mkWN (k5A "hugenotti") ; --UNCHK
lin huisache_N = mkWN "Acacia" "farnesiana" ; --UNCHK
lin huitre_N = mkWN (k6 "osteri") ; --UNCHK
lin huittinen_PN = mkPN "Huittinen" ;
lin hula_N = mkWN (k5 "tanssi") "havaijilainen" ; --UNCHK
lin hulk_N = mkWN (k1A "hylky") ; --UNCHK
lin hulking_A = mkWA (kH1 "iso") ; --UNCHK
lin hull_N = mkWN (k1A "runko") ; --UNCHK
lin hull_V2 = mkWV2 (k61 "kuoria") ; --UNCHK
lin hullabaloo_N = mkWN (k6 "meteli") ; --UNCHK
lin hum_N = mkWN (k12 "hurina") ; --UNCHK
lin hum_V = mkWV (k66 "hymistä") ; --UNCHK
lin hum_V2 = mkWV2 (k66 "hymistä") ; --UNCHK
lin human_A = mkA "inhimillinen" ;
lin human_N = mkWN (k38 "ihminen") ;
lin humaneness_N = mkWN (k40 "inhimillisyys") ; --UNCHK
lin humanism_N = mkWN (k5 "humanismi") "sekulaari" ; --UNCHK
lin humanist_N = mkWN (compoundN "kuva" (k48A "taide")) ; --UNCHK
lin humanitarian_A = mkWA (k38 "humanitaarinen") ;
lin humanitarian_N = mkWN (k5 "humanisti") ; --UNCHK
lin humanitarianism_N = mkWN (k5 "humanismi") ; --UNCHK
lin humanity_N = mkN "ihmiskunta" ;
lin humanization_N = mkWN (compoundN "ihmis" (k38 "täminen")) ; --UNCHK
lin humanize_V = mkWV (k53 "humaanistaa") ; --UNCHK
lin humanize_V2 = mkWV2 (k53 "humaanistaa") ; --UNCHK
lin humankind_N = mkWN (k13 "maailma") ; --UNCHK
lin humanness_N = mkWN (k40 "ihmisyys") ; --UNCHK
lin humate_N = mkWN "humaatti" ; --UNCHK
lin humberston_PN = foreignPN "Humberston" ;
lin humble_A = mkWA (k10 "nöyrä") ; --UNCHK
lin humble_V2 = mkWV2 (k54A "alentaa") ; --UNCHK
lin humbleness_N = mkWN (k39 "nöyrtymys") ; --UNCHK
lin humbug_N = mkWN (k5 "humpuuki") ; --UNCHK
lin humbug_V2 = mkWV2 (k53A "huiputtaa") ; --UNCHK
lin humdinger_N = mkWN (compoundN "loisto" (k5A "tyyppi")) ; --UNCHK
lin humdrum_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin humectant_N = mkWN (compoundN "kosteuden" (k10 "säilyttäjä")) ; --UNCHK
lin humerus_N = mkWN (compoundN "olka" (k18 "luu")) ; --UNCHK
lin humic_A = mkWA "humus-" ; --UNCHK
lin humid_A = mkWA (k15 "kostea") ; --UNCHK
lin humidify_V2 = mkWV2 (k71 "tehdä") "kosteaksi" ; --UNCHK
lin humidity_N = mkWN (k40 "kosteus") ; --UNCHK
lin humification_N = mkWN (compoundN "maa" (k38 "tuminen")) ; --UNCHK
lin humified_A = mkWA (compoundA "maa" (k47 "tunut")) ; --UNCHK
lin humiliate_V2 = mkWV2 (k54A "alentaa") ; --UNCHK
lin humiliatingly_Adv = mkWAdv (compoundAdv "alentav" (k99 "asti")) ; --UNCHK
lin humiliation_N = mkWN (k39 "nöyryytys") ; --UNCHK
lin humility_N = mkWN (k39 "nöyrtymys") ; --UNCHK
lin humin_N = mkWN "humiini" ; --UNCHK
lin hummer_N = mkWN (k1A "syöttö") "nopea" ; --UNCHK
lin humming_N = mkWN (k2 "hyräily") ; --UNCHK
lin humming_top_N = mkWN (k10 "hyrrä") ; --UNCHK
lin hummingbird_N = mkWN (k5 "kolibri") ; --UNCHK
lin hummock_N = mkWN (k41A "mätäs") ; --UNCHK
lin humongous_A = mkWA (k38 "jättimäinen") ; --UNCHK
lin humor_N = mkWN (k6 "huumori") ; --UNCHK
lin humoral_A = mkWA (compoundA "hum" (k38 "oraalinen")) ; --UNCHK
lin humorist_N = mkWN (k5 "humoristi") ; --UNCHK
lin humorless_A = mkWA (k4A "tosikko") ; --UNCHK
lin humorous_A = mkWA (k10 "huvittava") ; --UNCHK
lin humour_N = mkWN (k6 "huumori") ; --UNCHK
lin humour_V2 = mkWV2 (k67 "olla") "mieliksi" ; --UNCHK
lin humourist_N = mkWN (k5 "humoristi") ; --UNCHK
lin humourless_A = mkWA (k4A "tosikko") ; --UNCHK
lin hump_N = mkWN (k48A "uloke") ; --UNCHK
lin hump_V2 = mkWV2 (k63 "saada") ; --UNCHK
lin humpback_N = mkWN (compoundN "ryhä" (k41 "valas")) ; --UNCHK
lin humpbacked_A = mkWA (compoundA "koukku" (k38 "selkäinen")) ; --UNCHK
lin humppila_PN = mkPN "Humppila" ;
lin hun_N = mkWN (k5 "hunni") ; --UNCHK
lin hunch_N = mkWN (compoundN "kyy" (k38 "ristyminen")) ; --UNCHK
lin hunch_V2 = mkWV2 (k53 "köyristää") ; --UNCHK
lin hunchback_N = mkWN (k2 "henkilö") "kyttyräselkäinen" ; --UNCHK
lin hunchbacked_A = mkWA (compoundA "koukku" (k38 "selkäinen")) ; --UNCHK
lin hundredfold_Adv = mkWAdv (k99 "satakertaisesti") ; --UNCHK
lin hungarian_A = mkWA (k38 "unkarilainen") ; --UNCHK
lin hungarian_N = mkWN (k6 "unkari") ; --UNCHK
lin hungary_PN = foreignPN "Unkari" ;
lin hunger_N = mkN "nälkä" ; --WN (k1 "himo") ;
lin hunger_V = mkWV (k52A "nääntyä") ; --UNCHK
lin hunger_march_N = mkWN (compoundN "mielen" (k39 "osoitus")) "työttömien" ; --UNCHK
lin hunger_marcher_N = mkWN (compoundN "mielen" (k10 "osoittaja")) "työtön" ; --UNCHK
lin hungry_A = mkWA (k38 "nälkäinen") ; --UNCHK
lin hunk_N = mkWN (k5A "klöntti") ; --UNCHK
lin hunker_down_V = mkWV (k52 "pysyä") "kannallaan" ; --UNCHK
lin hunt_N = mkWN (k39 "metsästys") ;
lin hunt_V = mkV "metsästää" ;
lin hunt_V2 = L.hunt_V2 ;
lin hunt_down_V2 = mkWV2 (k53 "pyydystää") ; --UNCHK
lin hunter_N = mkN "metsästäjä" ;
lin hunting_N = mkWN (k39 "metsästys") ; --UNCHK
lin hunting_crop_N = mkWN (k9A "raippa") ; --UNCHK
lin huntingdon_PN = foreignPN "Huntingdon" ;
lin huntress_N = mkWN "metsästäjätär" ; --UNCHK
lin huntsman_N = mkWN (k10 "metsästäjä") ; --UNCHK
lin hurdle_N = mkN (lin NK {s = d48 "este"}) ;
lin hurdler_N = mkWN (compoundN "aita" (k12 "juoksija")) ; --UNCHK
lin hurdles_N = mkWN (compoundN "aita" (k1 "juoksu")) ; --UNCHK
lin hurdy_gurdy_N = mkWN (k5 "posetiivi") ; --UNCHK
lin hurl_N = mkWN (k1A "heitto") ; --UNCHK
lin hurl_V2 = mkWV2 (k52A "laukoa") ; --UNCHK
lin hurling_N = mkWN (compoundN "nurmi" (k1 "pallo")) "irlantilainen" ; --UNCHK
lin hurly_burly_N = mkWN (k1 "häly") ; --UNCHK
lin hurrah_N = mkWN (k17 "hurraa") ; --UNCHK
lin hurrah_V = mkWV (k73 "hurrata") ; --UNCHK
lin hurricane_N = mkWN (k5 "hurrikaani") ; --UNCHK
lin hurried_A = mkWA (k38 "pikainen") ; --UNCHK
lin hurry_N = mkN "kiire" ; --mkWN (k1 "syöksy") ;
lin hurry_V = mkV "kiirehtiä" | mkV "kiiruhtaa" ;
lin hurstpierpoint_PN = foreignPN "Hurstpierpoint" ;
lin hurt_N = mkWN (compoundN "hai" (k38 "ttaaminen")) ; --UNCHK
lin hurt_V = mkWV (k52A "sattua") ;
lin hurt_V2 = mkV2 (mkV "loukata") partitive ;
lin hurtful_A = mkWA (k38 "turmiollinen") ; --UNCHK
lin hurtle_V = mkWV (k53A "heittää") ; --UNCHK
lin husband_N = L.husband_N ;
lin husband_V2 = mkWV2 (k53A "käyttää") "säästäväisesti" ; --UNCHK
lin husbandly_A = mkWA (k38 "aviollinen") ; --UNCHK
lin husbandman_N = mkWN (k6 "farmari") ; --UNCHK
lin husbandry_N = mkWN (compoundN "maa" (k40 "talous")) ; --UNCHK
lin hush_N = mkWN (k40 "hiljaisuus") ; --UNCHK
lin hush_V = mkWV (k52A "huuhtoa") ; --UNCHK
lin hush_V2 = mkWV2 (k52A "huuhtoa") ; --UNCHK
lin hush_money_N = mkWN (compoundN "vaitiolo" (k9 "raha")) ; --UNCHK
lin hush_up_V2 = mkWV2 (k73 "salata") ; --UNCHK
lin husk_N = mkWN (kH1 "kuori") ; --UNCHK
lin husk_V2 = mkWV2 (k53 "poistaa") "kuori" ; --UNCHK
lin huskiness_N = mkWN (k40 "käheys") ; --UNCHK
lin husky_A = mkWA (k15 "käheä") ; --UNCHK
lin husky_N = mkWN (compoundN "eskimo" (k10 "koira")) ; --UNCHK
lin hussar_N = mkWN (k6 "husaari") ; --UNCHK
lin hussy_N = mkWN (k1A "narttu") ; --UNCHK
lin hustings_N = mkWN (compoundN "vaali" (k40 "tilaisuus")) ; --UNCHK
lin hustle_N = mkWN (k39 "touhotus") ; --UNCHK
lin hustle_V = mkWV (k61A "kiirehtiä") ; --UNCHK
lin hustle_V2 = mkWV2 (k61A "kiirehtiä") ; --UNCHK
lin hustler_N = mkWN (compoundN "supliikki" (k42 "mies")) ; --UNCHK
lin hut_N = mkWN (k5A "mökki") ; --UNCHK
lin hutch_N = mkWN (k5A "mökki") ; --UNCHK
lin hutment_N = mkWN (k5 "leiri") ; --UNCHK
lin hyacinth_N = mkWN (k5A "hyasintti") ; --UNCHK
lin hyaena_N = mkWN (k13 "hyeena") ; --UNCHK
lin hyaline_A = mkWA (k38 "lasimainen") ; --UNCHK
lin hyaline_N = mkWN "hyaliini" ; --UNCHK
lin hyalinization_N = mkWN "hyalinoituminen" ; --UNCHK
lin hyaloplasm_N = mkWN (compoundN "perus" (k48 "aine")) "solujen" ; --UNCHK
lin hyaloplasmic_A = mkWA "hyaloplasmaan" "liittyvä" ; --UNCHK
lin hyaluronidase_N = mkWN (k6 "entsyymi") ; --UNCHK
lin hybrid_A = mkWA (compoundA "risti" (k1 "siitetty")) ; --UNCHK
lin hybrid_N = mkWN (k39 "risteytys") ;
lin hybridization_N = mkWN (k39 "risteytys") ; --UNCHK
lin hybridize_V = mkWV (k53A "risteyttää") ; --UNCHK
lin hybridize_V2 = mkWV2 (k53A "risteyttää") ; --UNCHK
lin hybridoma_N = mkWN (compoundN "hybrid" (k10 "oma")) ; --UNCHK
lin hydantoin_N = mkWN "hydantoiini" ; --UNCHK
lin hydathode_N = mkWN "vesittäjä" ; --UNCHK
lin hydatid_N = mkWN "hydatidi" ; --UNCHK
lin hyde_PN = foreignPN "Hyde" ;
lin hyderabad_PN = foreignPN "Hyderabad" ;
lin hydra_N = mkWN (compoundN "lampi" (k5A "polyyppi")) ; --UNCHK
lin hydralazine_N = mkWN "Apresoline" ; --UNCHK
lin hydramnios_N = mkWN "hydramnion" ; --UNCHK
lin hydrangea_N = mkWN (k12 "hortensia") ; --UNCHK
lin hydrant_N = mkWN (k5 "vesiposti") ; --UNCHK
lin hydrarthrosis_N = mkWN (compoundN "hydr" (k5 "artroosi")) ; --UNCHK
lin hydrate_N = mkWN (k5A "hydraatti") ; --UNCHK
lin hydrate_V = mkWV (k53A "kosteuttaa") ; --UNCHK
lin hydrate_V2 = mkWV2 (k53A "kosteuttaa") ; --UNCHK
lin hydration_N = mkWN "hydraatio" ; --UNCHK
lin hydraulic_A = mkWA "hydrauliikka-" ; --UNCHK
lin hydraulics_N = mkWN (k9A "hydrauliikka") ; --UNCHK
lin hydrazine_N = mkWN "hydratsiini" ; --UNCHK
lin hydrazoite_N = mkWN "hydrazoite" ; --UNCHK
lin hydremia_N = mkWN "hydremia" ; --UNCHK
lin hydric_A = mkWA (k15 "kostea") "erittäin" ; --UNCHK
lin hydride_N = mkWN "hydridi" ; --UNCHK
lin hydrilla_N = mkWN (compoundN "pohjavesi" (k1A "rutto")) ; --UNCHK
lin hydrocarbon_N = mkWN (compoundN "hiili" (k1A "vety")) ; --UNCHK
lin hydrocele_N = mkWN (compoundN "vesi" (k10 "tyrä")) ; --UNCHK
lin hydrocephalic_A = mkWA (compoundA "vesi" (k38 "päinen")) ; --UNCHK
lin hydrocephalus_N = mkWN (compoundN "vesi" (k18 "pää")) ; --UNCHK
lin hydrochloride_N = mkWN "hydrokloridi" ; --UNCHK
lin hydrochlorofluorocarbon_N = mkWN (compoundN "kloorifluorihiili" (k1A "vety")) ; --UNCHK
lin hydrochlorothiazide_N = mkWN "Diuramin" ; --UNCHK
lin hydrocolloid_N = mkWN (compoundN "hydro" (k5 "kolloidi")) ; --UNCHK
lin hydrocortisone_N = mkWN (compoundN "hydro" (k5 "kortisoni")) ; --UNCHK
lin hydrocracking_N = mkWN (compoundN "vety" (k39 "krakkaus")) ; --UNCHK
lin hydrodynamic_A = mkWA (compoundA "hydro" (k38 "dynaaminen")) ; --UNCHK
lin hydrodynamics_N = mkWN (compoundN "virtaus" (k5A "oppi")) ; --UNCHK
lin hydroelectric_A = mkWA "vesivoima-" ; --UNCHK
lin hydroelectricity_N = mkWN (compoundN "vesi" (k10 "voima")) ; --UNCHK
lin hydroflumethiazide_N = mkWN "hydroflumetiatsidi" ; --UNCHK
lin hydrofluorocarbon_N = mkWN "fluorihiilivety" ; --UNCHK
lin hydrofoil_N = mkWN (compoundN "liuku" (k48 "vene")) ; --UNCHK
lin hydrogel_N = mkWN (compoundN "hydro" (k5 "geeli")) ; --UNCHK
lin hydrogen_N = mkWN (k1A "vety") ; --UNCHK
lin hydrogenation_N = mkWN "vedytys" ; --UNCHK
lin hydrographic_A = mkWA "hydrografinen" ; --UNCHK
lin hydrography_N = mkWN "hydrografia" ; --UNCHK
lin hydrokinetic_A = mkWA (compoundA "hydro" (k38 "kineettinen")) ; --UNCHK
lin hydrologist_N = mkWN "hydrologi" ; --UNCHK
lin hydrology_N = mkWN (k12 "hydrologia") ; --UNCHK
lin hydrolysate_N = mkWN "hydrolysaatti" ; --UNCHK
lin hydrolysis_N = mkWN (compoundN "hydroly" (k5 "ysi")) ; --UNCHK
lin hydrolyzable_A = mkWA "hydrolyyttinen" ; --UNCHK
lin hydromancer_N = mkWN (k10 "ennustaja") "vedestä" ; --UNCHK
lin hydromancy_N = mkWN "hydromantia" ; --UNCHK
lin hydromel_N = mkWN (compoundN "hunaja" (k9 "sima")) ; --UNCHK
lin hydrometer_N = mkWN (compoundN "gravi" (k5 "metri")) ; --UNCHK
lin hydrometric_A = mkWA (compoundA "gravi" (k38 "metrinen")) ; --UNCHK
lin hydrometry_N = mkWN (compoundN "paino" (k5 "analyysi")) ; --UNCHK
lin hydronephrosis_N = mkWN "hydronefroosi" ; --UNCHK
lin hydropathic_A = mkWA (compoundA "vesi" (k38 "hoidollinen")) ; --UNCHK
lin hydropathy_N = mkWN (compoundN "vesi" (k1A "hoito")) ; --UNCHK
lin hydrophilic_A = mkWA "hydrofiilinen" ; --UNCHK
lin hydrophobia_N = mkWN (compoundN "raivo" (k5A "tauti")) ; --UNCHK
lin hydrophobic_A = mkWA "hydrofobinen" ; --UNCHK
lin hydrophobicity_N = mkWN "hydrofobisuus" ; --UNCHK
lin hydrophytic_A = mkWA "vedessä" "kasvava" ; --UNCHK
lin hydroplane_N = mkWN (compoundN "liuku" (k48 "vene")) ; --UNCHK
lin hydroponics_N = mkWN (compoundN "vesi" (k2 "viljely")) ; --UNCHK
lin hydrosphere_N = mkWN (compoundN "vesi" (k10 "kehä")) ; --UNCHK
lin hydrostatic_A = mkWA (compoundA "hydro" (k38 "staattinen")) ; --UNCHK
lin hydrostatics_N = mkWN (compoundN "hydro" (k14A "statiikka")) ; --UNCHK
lin hydrothorax_N = mkWN (compoundN "vesi" (k9A "rinta")) ; --UNCHK
lin hydrous_A = mkWA "kidevesipitoinen" ; --UNCHK
lin hydroxide_N = mkWN (k5 "hydroksidi") ; --UNCHK
lin hydroxy_A = mkWA "hydroksi-" ; --UNCHK
lin hydroxychloroquine_N = mkWN "Oxiklorin" ; --UNCHK
lin hydroxyl_N = mkWN (k5 "hydroksyyli") ; --UNCHK
lin hydroxymethyl_N = mkWN (compoundN "hydroksime" (k5 "tyyli")) ; --UNCHK
lin hydroxyproline_N = mkWN "hydroksiproliini" ; --UNCHK
lin hydrozoan_N = mkWN (compoundN "polyyppi" (k33 "eläin")) ; --UNCHK
lin hyena_N = mkWN (k13 "hyeena") ; --UNCHK
lin hygiene_N = mkWN (compoundN "terveys" (k5A "oppi")) ; --UNCHK
lin hygienic_A = mkWA (k38 "hygieeninen") ; --UNCHK
lin hygienist_N = mkWN (k4A "hygieenikko") ; --UNCHK
lin hygrodeik_N = mkWN "hygrodeik" ; --UNCHK
lin hygrometer_N = mkWN (k5 "hygrometri") ; --UNCHK
lin hygrophyte_N = mkWN (compoundN "kosteikko" (k5 "kasvi")) ; --UNCHK
lin hygrophytic_A = mkWA (k10 "elävä") "kosteikoissa" ; --UNCHK
lin hygroscope_N = mkWN (compoundN "hygrosko" (k5A "oppi")) ; --UNCHK
lin hygroscopic_A = mkWA "hygroskooppinen" ; --UNCHK
lin hymen_N = mkWN (k5 "hymen") ; --UNCHK
lin hymenal_A = mkWA (compoundA "hymena" (k38 "alinen")) ; --UNCHK
lin hymeneal_A = mkWA (k38 "aviollinen") ; --UNCHK
lin hymeneal_N = mkWN (compoundN "hää" (k28 "virsi")) ; --UNCHK
lin hymenium_N = mkWN (compoundN "itiö" (k9 "lava")) ; --UNCHK
lin hymenopterous_A = mkWA "pistiäis-" ; --UNCHK
lin hymn_N = mkWN (k28 "virsi") ; --UNCHK
lin hymn_V2 = mkWV2 (k53 "ylistää") ; --UNCHK
lin hymnal_N = mkWN (compoundN "virsi" (k9 "kirja")) ; --UNCHK
lin hyoid_A = mkWA "kieliluuhun" "liittyvä" ; --UNCHK
lin hyoid_N = mkWN (compoundN "kieli" (k18 "luu")) ; --UNCHK
lin hyoscyamine_N = mkWN "hyoskyamiini" ; --UNCHK
lin hypaethral_A = mkWA (k33 "avoin") ; --UNCHK
lin hypallage_N = mkWN "hypallage" ; --UNCHK
lin hypanthium_N = mkWN (compoundN "kukka" (k39 "pohjus")) ; --UNCHK
lin hype_V2 = mkWV2 (compoundV "yli" (k53 "mainostaa")) ; --UNCHK
lin hyperacidity_N = mkWN (compoundN "liika" (k40 "happoisuus")) ; --UNCHK
lin hyperactive_A = mkWA (compoundA "yli" (k38 "aktiivinen")) ; --UNCHK
lin hyperactivity_N = mkWN (compoundN "hyper" (k40 "aktiivisuus")) ; --UNCHK
lin hyperbaton_N = mkWN "hyperbaton" ; --UNCHK
lin hyperbetalipoproteinemia_N = mkWN "hyperbetalipoproteinemia" ; --UNCHK
lin hyperbilirubinemia_N = mkWN "hyperbilirubinemia" ; --UNCHK
lin hyperbola_N = mkWN (k5 "hyperbeli") ; --UNCHK
lin hyperbole_N = mkWN (k2 "liioittelu") ; --UNCHK
lin hyperbolic_A = mkWA (k38 "hyperbolinen") ; --UNCHK
lin hyperboloid_N = mkWN "hyperboloidi" ; --UNCHK
lin hyperboloidal_A = mkWA (k38 "muotoinen") "hyperboloidin" ; --UNCHK
lin hypercalcemia_N = mkWN "hypercalcaemia" ; --UNCHK
lin hypercalciuria_N = mkWN (compoundN "kalsium" (k40 "runsaus")) "virtsan" ; --UNCHK
lin hypercapnia_N = mkWN "hyperkarbia" ; --UNCHK
lin hypercatalectic_A = mkWA (compoundA "hyper" (k38 "katalektinen")) ; --UNCHK
lin hypercatalectic_N = mkWN (k48A "säe") "hyperkatalektinen" ; --UNCHK
lin hypercellularity_N = mkWN "hypersellulaarisuus" ; --UNCHK
lin hypercholesterolemia_N = mkWN "hyperkolesterolemia" ; --UNCHK
lin hypercoaster_N = mkWN (compoundN "vuoristo" (k9A "rata")) "iso" ; --UNCHK
lin hypercritical_A = mkWA (k10 "arvosteleva") "ankarasti" ; --UNCHK
lin hyperemesis_N = mkWN "hyperemeesi" ; --UNCHK
lin hyperemia_N = mkWN (k40 "verekkyys") ; --UNCHK
lin hyperemic_A = mkWA (compoundA "hyper" (k38 "eeminen")) ; --UNCHK
lin hyperextension_N = mkWN (compoundN "yli" (k39 "ojennus")) ; --UNCHK
lin hyperfine_A = mkWA "ylihieno-" ; --UNCHK
lin hyperglycemia_N = mkWN (compoundN "hypergly" (k12 "kemia")) ; --UNCHK
lin hyperhidrosis_N = mkWN "polyhidroosi" ; --UNCHK
lin hypericism_N = mkWN "dermatiitti" ; --UNCHK
lin hyperinflation_N = mkN "hyperinflaatio" ;
lin hyperkalemia_N = mkWN "hyperkalemia" ; --UNCHK
lin hyperlink_N = mkWN (compoundN "hyper" (k5A "linkki")) ; --UNCHK
lin hyperlipoproteinemia_N = mkWN "hyperlipoproteinemia" ; --UNCHK
lin hypermarket_N = mkWN (compoundN "hyper" (k5A "marketti")) ; --UNCHK
lin hypermastigote_N = mkWN (compoundN "siima" (k3 "eliö")) ; --UNCHK
lin hypermedia_N = mkWN (compoundN "hyper" (k13 "media")) ; --UNCHK
lin hypermotility_N = mkWN (compoundN "liika" (k40 "liikkuvuus")) ; --UNCHK
lin hypernatremia_N = mkWN "hypernatremia" ; --UNCHK
lin hypernym_N = mkWN (compoundN "ylä" (k48A "käsite")) ; --UNCHK
lin hypernymy_N = mkWN (compoundN "yläkäsitte" (k40 "isyys")) ; --UNCHK
lin hyperon_N = mkWN "hyperoni" ; --UNCHK
lin hyperope_N = mkWN (k2 "henkilö") "kaukonäköinen" ; --UNCHK
lin hyperopia_N = mkWN (compoundN "pitkä" (k40 "näköisyys")) ; --UNCHK
lin hyperopic_A = mkWA (compoundA "pitkä" (k38 "näköinen")) ; --UNCHK
lin hyperparathyroidism_N = mkWN (compoundN "hyperparatyroid" (k5 "ismi")) ; --UNCHK
lin hyperpigmentation_N = mkWN "hyperpigmentaatio" ; --UNCHK
lin hyperpituitarism_N = mkWN (compoundN "hyperpituitar" (k5 "ismi")) ; --UNCHK
lin hyperplasia_N = mkWN (compoundN "hyperpl" (k12 "asia")) ; --UNCHK
lin hyperpnea_N = mkWN "hyperpnea" ; --UNCHK
lin hyperpyrexia_N = mkWN "hyperpyreksia" ; --UNCHK
lin hypersecretion_N = mkWN (compoundN "liika" (k39 "eritys")) ; --UNCHK
lin hypersensitive_A = mkWA (k38 "allerginen") ; --UNCHK
lin hypersensitivity_N = mkWN (compoundN "yli" (k40 "herkkyys")) ; --UNCHK
lin hypersomnia_N = mkWN (compoundN "liika" (k40 "unisuus")) ; --UNCHK
lin hypersplenism_N = mkWN (compoundN "hypersplen" (k5 "ismi")) ; --UNCHK
lin hypertensive_A = mkWA (compoundA "verenpaine" (k38 "tautinen")) ; --UNCHK
lin hypertensive_N = mkWN (k2 "henkilö") "verenpainetautinen" ; --UNCHK
lin hypertext_N = mkWN (compoundN "hyper" (k5 "teksti")) ; --UNCHK
lin hyperthermal_A = mkWA (k38 "kuumeinen") ; --UNCHK
lin hyperthermia_N = mkWN (compoundN "liikalämpö" (k40 "isyys")) ; --UNCHK
lin hyperthyroidism_N = mkWN (compoundN "liika" (k9A "toiminta")) "kilpirauhasen" ; --UNCHK
lin hypertonia_N = mkWN (k12 "hypertonia") ; --UNCHK
lin hypertonic_A = mkWA (compoundA "hyper" (k38 "toninen")) ; --UNCHK
lin hypertonicity_N = mkWN (k12 "hypertonia") ; --UNCHK
lin hypertrophied_A = mkWA (compoundA "hyper" (k38 "trofinen")) ; --UNCHK
lin hypertrophy_N = mkWN (compoundN "liika" (k1 "kasvu")) ; --UNCHK
lin hypervelocity_N = mkWN (k40 "nopeus") "suuri" ; --UNCHK
lin hyperventilation_N = mkWN (k3 "hyperventilaatio") ; --UNCHK
lin hypervitaminosis_N = mkWN (compoundN "vitamiini" (k39 "myrkytys")) ; --UNCHK
lin hypervolemia_N = mkWN "hypervolaemia" ; --UNCHK
lin hypha_N = mkWN (k9 "rihma") ; --UNCHK
lin hyphema_N = mkWN "hyfeema" ; --UNCHK
lin hyphen_N = mkWN (k9 "viiva") ; --UNCHK
lin hyphen_V2 = mkWV2 (k56A "jakaa") "tavuihin" ; --UNCHK
lin hyphenate_V2 = mkWV2 (k56A "jakaa") "tavuihin" ; --UNCHK
lin hyphenation_N = mkWN (k39 "tavutus") ; --UNCHK
lin hypnagogue_N = mkWN (compoundN "uni" (k48A "lääke")) ; --UNCHK
lin hypnoanalysis_N = mkWN (compoundN "hypno" (k5 "analyysi")) ; --UNCHK
lin hypnogenesis_N = mkWN (compoundN "vai" (k38 "vuttaminen")) "hypnoosiin" ; --UNCHK
lin hypnoid_A = mkWA (compoundA "muis" (k10 "tuttava")) "unta" ; --UNCHK
lin hypnophobia_N = mkWN (k1A "pelko") "nukahtamisen" ; --UNCHK
lin hypnosis_N = mkWN (k5 "hypnoosi") ; --UNCHK
lin hypnotherapy_N = mkWN (compoundN "hypno" (k12 "terapia")) ; --UNCHK
lin hypnotic_A = mkWA (k38 "hypnoottinen") ; --UNCHK
lin hypnotism_N = mkWN (k3 "suggestio") ; --UNCHK
lin hypnotist_N = mkWN (k10 "saattaja") "hypnoosiin" ; --UNCHK
lin hypnotize_V2 = mkWV2 (k53A "ottaa") "valtoihinsa" ; --UNCHK
lin hypo_N = mkWN (k48 "ruiske") "ihonalainen" ; --UNCHK
lin hypoactive_A = mkWA (compoundA "ali" (k38 "aktiivinen")) ; --UNCHK
lin hypobasidium_N = mkWN (compoundN "itiö" (k9A "kanta")) ; --UNCHK
lin hypobetalipoproteinemia_N = mkWN "hypobeetalipoproteinemia" ; --UNCHK
lin hypocalcemia_N = mkWN "hypocalcaemia" ; --UNCHK
lin hypocapnia_N = mkWN (compoundN "hiilidioksidi" (k40 "niukkuus")) "veren" ; --UNCHK
lin hypochlorite_N = mkWN (compoundN "hypoklo" (k5A "riitti")) ; --UNCHK
lin hypochondria_N = mkWN (compoundN "luulo" (k40 "sairaus")) ; --UNCHK
lin hypochondriac_A = mkWA (compoundA "luulo" (k38 "tautinen")) ; --UNCHK
lin hypochondriac_N = mkWN (compoundN "luulo" (k41 "sairas")) ; --UNCHK
lin hypochondriacal_A = mkWA (compoundA "luulo" (k38 "tautinen")) ; --UNCHK
lin hypochondrium_N = mkWN (compoundN "ylä" (k9 "vatsa")) ; --UNCHK
lin hypocrisy_N = mkWN (compoundN "teko" (k40 "pyhyys")) ; --UNCHK
lin hypocrite_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin hypocritical_A = mkWA (compoundA "teko" (k10 "pyhä")) ; --UNCHK
lin hypocycloid_N = mkWN "hyposykloidi" ; --UNCHK
lin hypodermal_A = mkWA (compoundA "ihon" (k38 "alainen")) ; --UNCHK
lin hypodermic_A = mkWA (compoundA "ihon" (k38 "alainen")) ; --UNCHK
lin hypodermic_N = mkWN (k48 "ruiske") "ihonalainen" ; --UNCHK
lin hypodermis_N = mkWN (compoundN "ihonalais" (k39 "kudos")) ; --UNCHK
lin hypoesthesia_N = mkWN "hypestesia" ; --UNCHK
lin hypogammaglobulinemia_N = mkWN "hypogammaglobulinemia" ; --UNCHK
lin hypoglossal_N = mkWN (compoundN "aivo" (k1 "hermo")) "kahdestoista" ; --UNCHK
lin hypoglycemia_N = mkWN (compoundN "veren" (k6 "sokeri")) "matala" ; --UNCHK
lin hypoglycemic_A = mkWA "hypoglykeeminen" ; --UNCHK
lin hypogonadism_N = mkWN (compoundN "hypogonad" (k5 "ismi")) ; --UNCHK
lin hypokalemia_N = mkWN "hypokalemia" ; --UNCHK
lin hypolipoproteinemia_N = mkWN "hypolipoproteinemia" ; --UNCHK
lin hyponatremia_N = mkWN "hyponatremia" ; --UNCHK
lin hyponym_N = mkWN (compoundN "ala" (k48A "käsite")) ; --UNCHK
lin hyponymy_N = mkWN (compoundN "alakäsitte" (k40 "isyys")) ; --UNCHK
lin hypoparathyroidism_N = mkWN (compoundN "hypoparatyroid" (k5 "ismi")) ; --UNCHK
lin hypophyseal_A = mkWA (compoundA "hypofysia" (k38 "alinen")) ; --UNCHK
lin hypopigmentation_N = mkWN "hypopigmentaatio" ; --UNCHK
lin hypoplasia_N = mkWN (compoundN "hypopl" (k12 "asia")) ; --UNCHK
lin hypopnea_N = mkWN "hypopnea" ; --UNCHK
lin hypoproteinemia_N = mkWN "hypoproteinemia" ; --UNCHK
lin hyposmia_N = mkWN "hyposmia" ; --UNCHK
lin hypospadias_N = mkWN (compoundN "ala" (k3 "halkio")) "virtsaputken" ; --UNCHK
lin hypostatization_N = mkWN (compoundN "hypostati" (k5A "sointi")) ; --UNCHK
lin hypotension_N = mkWN (compoundN "veren" (k48 "paine")) "matala" ; --UNCHK
lin hypotensive_A = mkWA "hypotensiivinen" ; --UNCHK
lin hypotensive_N = mkWN "hypotensiosta" "kärsivä" ; --UNCHK
lin hypotenuse_N = mkWN (k10 "hypotenuusa") ; --UNCHK
lin hypothalamic_A = mkWA "hypotalamukseen" "liittyvä" ; --UNCHK
lin hypothalamus_N = mkWN (k39 "hypotalamus") ; --UNCHK
lin hypothecate_V2 = mkWV2 (k52 "otaksua") ; --UNCHK
lin hypothermia_N = mkWN (k40 "vajaalämpöisyys") ; --UNCHK
lin hypothermic_A = mkWA (compoundA "hypo" (k38 "terminen")) ; --UNCHK
lin hypothesis_N = mkWN (k12 "teoria") ; --UNCHK
lin hypothesize_V2 = mkWV2 (k52 "otaksua") ; --UNCHK
lin hypothetical_A = mkWA (k38 "hypoteettinen") ; --UNCHK
lin hypothetical_N = mkWN (k39 "oletus") ; --UNCHK
lin hypothrombinemia_N = mkWN (k39 "puutos") "protrombiinin" ; --UNCHK
lin hypothyroidism_N = mkWN (k50 "vajaatoiminta") "kilpirauhasen" ; --UNCHK
lin hypotonia_N = mkWN "hypotoonisuus" ; --UNCHK
lin hypotonic_A = mkWA (compoundA "ali" (k38 "paineinen")) ; --UNCHK
lin hypotonicity_N = mkWN "hypotoonisuus" ; --UNCHK
lin hypovolemia_N = mkWN "hypovolaemia" ; --UNCHK
lin hypovolemic_A = mkWA "hypovoleeminen" ; --UNCHK
lin hypoxia_N = mkWN (compoundN "hyp" (k61 "oksia")) ; --UNCHK
lin hypozeugma_N = mkWN "iestys" ; --UNCHK
lin hypozeuxis_N = mkWN "hypozeuksis" ; --UNCHK
lin hypsography_N = mkWN (k39 "mittaus") "korkeuden" ; --UNCHK
lin hypsometer_N = mkWN (compoundN "hypso" (k5 "metri")) ; --UNCHK
lin hypsometry_N = mkWN (k39 "mittaus") "korkeuden" ; --UNCHK
lin hyrynsalmi_PN = mkPN (mkN "Hyrynsalmi" "Hyrynsalmia") ;
lin hyson_N = mkWN "hyson" ; --UNCHK
lin hyssop_N = mkWN (k5A "iisoppi") ; --UNCHK
lin hysterectomy_N = mkWN (compoundN "kohdun" (k1 "poisto")) ; --UNCHK
lin hysteresis_N = mkWN (k5 "hystereesi") ; --UNCHK
lin hysteria_N = mkWN (k12 "hysteria") ; --UNCHK
lin hysteric_A = mkWA (k38 "hysteerinen") ; --UNCHK
lin hysteric_N = mkWN (k4A "hysteerikko") ; --UNCHK
lin hysterical_A = mkWA (k38 "hysteerinen") ; --UNCHK
lin hysterics_N = mkWN (k39 "kohtaus") "hysteerinen" ; --UNCHK
lin hysterocatalepsy_N = mkWN (k12 "hysteria") "kataleptinen" ; --UNCHK
lin hysterosalpingogram_N = mkWN "hysterosalpingografia" ; --UNCHK
lin hysteroscopy_N = mkWN (compoundN "hysterosko" (k5A "oppi")) ; --UNCHK
lin hythe_PN = foreignPN "Hythe" ;
lin hyvinge_PN = mkPN "Hyvinge" ;
lin hämeenkoski_PN = mkPN (mkN "Hämeenkoski" "Hämeenkoskia") ;
lin hämeenkyrö_PN = mkPN "Hämeenkyrö" ;
lin hämeenlinna_PN = mkPN "Hämeenlinna" ;
lin iFem_Pron = optProDrop S.i_Pron ;
lin i_Pron = optProDrop S.i_Pron ;
lin i_e__Adv = mkAdv"so." ;
lin iamb_N = mkWN (k5 "jambi") ; --UNCHK
lin iambic_A = mkWA (compoundA "jambi" (k38 "nen")) ; --UNCHK
lin iambic_N = mkWN (k48A "säe") "jambinen" ; --UNCHK
lin iambus_N = mkWN (k5 "jambi") ; --UNCHK
lin iatrogenic_A = mkWA "lääkärin" "aiheuttama" ; --UNCHK
lin ibadan_PN = foreignPN "Ibadan" ;
lin ibex_N = mkWN (compoundN "vuori" (k41 "kauris")) ; --UNCHK
lin ibis_N = mkWN (k39 "iibis") ; --UNCHK
lin ibuprofen_N = mkWN "Ibuxin" ; --UNCHK
lin icbm_N = mkWN (k39 "ohjus") "mannertenvälinen" "ballistinen" ; --UNCHK
lin ice_N = L.ice_N ;
lin ice_V = mkWV (k53A "jäähdyttää") ; --UNCHK
lin ice_V2 = mkWV2 (k53A "jäähdyttää") ; --UNCHK
lin ice_axe_N = mkWN (compoundN "jää" (k1A "hakku")) | mkN "hakku" ;
lin ice_cream_N = mkN "jäätelö" | mkWN (k5 "jätski") ;
lin ice_lolly_N = mkWN (k1A "puikko") ; --UNCHK
lin ice_show_N = mkWN (compoundN "jää" (k22 "show")) ; --UNCHK
lin ice_skate_N = mkWN (k33 "luistin") ; --UNCHK
lin ice_skate_V = mkWV (k67 "luistella") ; --UNCHK
lin ice_skating_N = mkWN (k2 "luistelu") ; --UNCHK
lin iceberg_N = mkWN (compoundN "jäävuori" (k5A "salaatti")) ; --UNCHK
lin iceboat_N = mkWN (compoundN "jää" (k48 "vene")) ; --UNCHK
lin icebound_A = mkWA "jään" "sulkema" ; --UNCHK
lin icebox_N = mkWN (compoundN "jää" (k5A "kaappi")) ; --UNCHK
lin icebreaker_N = mkWN (k39 "kevennys") ; --UNCHK
lin icecap_N = mkWN (compoundN "laki" (k4A "jäätikkö")) ; --UNCHK
lin icefall_N = mkWN (compoundN "jää" (k39 "putous")) ; --UNCHK
lin icehouse_N = mkWN (compoundN "jää" (k48 "huone")) ; --UNCHK
lin iceland_PN = mkPN "Islanti" ;
lin icelander_N = mkWN (k38 "islantilainen") ; --UNCHK
lin icelandic_A = mkWA (k38 "islantilainen") ; --UNCHK
lin icelandic_N = mkWN (k5A "islanti") ; --UNCHK
lin iceman_N = mkWN (k10 "tappaja") ; --UNCHK
lin icepick_N = mkWN (compoundN "jää" (k1A "hakku")) ; --UNCHK
lin ice_tray_N = mkWN (compoundN "jääpala-" (k12 "astia")) ; --UNCHK
lin ichneumon_N = mkWN (compoundN "ikneu" (k23 "moni")) ; --UNCHK
lin ichneumon_fly_N = mkWN (compoundN "lois" (k38 "pistiäinen")) ; --UNCHK
lin ichor_N = mkWN (k9 "visva") ; --UNCHK
lin ichorous_A = mkWA (k38 "märkäinen") ; --UNCHK
lin ichthyolatry_N = mkWN (k9A "palvonta") "kalojen" ; --UNCHK
lin ichthyologist_N = mkWN "iktyologi" ; --UNCHK
lin ichthyology_N = mkWN "iktyologia" ; --UNCHK
lin ichthyosaur_N = mkWN (k1 "kalalisko") ; --UNCHK
lin ichthyosaurus_N = mkWN "ichthyosaurus" ; --UNCHK
lin ichthyosis_N = mkWN "iktyoosi" ; --UNCHK
lin icicle_N = mkWN (compoundN "jää" (k1A "puikko")) ; --UNCHK
lin icing_N = mkWN (k1A "kiekko") "pitkä" ; --UNCHK
lin icky_A = mkWA (k38 "tahmainen") ; --UNCHK
lin icon_N = mkWN (k6 "ikoni") ; --UNCHK
lin iconic_A = mkWA (k38 "ikoninen") ; --UNCHK
lin iconoclasm_N = mkWN "ikonoklasmi" ; --UNCHK
lin iconoclast_N = mkWN (k38 "kapinallinen") ; --UNCHK
lin iconoclastic_A = mkWA "ikonoklastinen" ; --UNCHK
lin iconography_N = mkWN "ikonografia" ; --UNCHK
lin iconolatry_N = mkWN (compoundN "kuvain" (k9A "palvonta")) ; --UNCHK
lin iconology_N = mkWN "ikonologia" ; --UNCHK
lin iconoscope_N = mkWN (compoundN "ikonosko" (k5A "oppi")) ; --UNCHK
lin icosahedral_A = mkWA "ikosaedrinen" ; --UNCHK
lin icosahedron_N = mkWN (compoundN "kaksikymmen" (k41A "tahokas")) ; --UNCHK
lin ictal_A = mkWA (compoundA "ikta" (k38 "alinen")) ; --UNCHK
lin icterogenic_A = mkWA "keltaisuutta" "aiheuttava" ; --UNCHK
lin ictodosaur_N = mkWN "ictodosaurus" ; --UNCHK
lin icy_A = mkWA (k38 "jäinen") ; --UNCHK
lin id_N = mkWN (compoundN "vietti" (k10 "pohja")) ; --UNCHK
lin idea_N = mkN "idea" "ideoita" ;
lin idea_of_N2 = mkN2 (mkN "ajatus") (mkPrep elative) ;
lin ideal_A = mkWA (k38 "ihanteellinen") ;
lin ideal_N = mkN "ihanne" ; --mkWN (k5 "ideaali") ;
lin idealism_N = mkWN (k5 "idealismi") ; --UNCHK
lin idealist_N = mkWN (k12 "uneksija") ; --UNCHK
lin idealistic_A = mkWA (k38 "idealistinen") ; --UNCHK
lin ideality_N = mkWN (k40 "ideaalisuus") ; --UNCHK
lin idealization_N = mkWN (k5A "ihannointi") ; --UNCHK
lin idealize_V2 = mkWV2 (k62 "ihannoida") ; --UNCHK
lin ideally_Adv = adjAdv ideal_A ; -- -- derived
lin ideation_N = mkWN "ajatusten" "muodostaminen" ; --UNCHK
lin idempotent_A = mkWA (compoundA "idem" (k5A "potentti")) ; --UNCHK
lin identical_A = mkWA (k38 "identtinen") ;
lin identifiable_A = mkWA "tunnistettava" ; --UNCHK
lin identification_N = mkWN "tunnistaminen" ; --UNCHK
lin identifier_N = mkWN (k48 "tunniste") ; --UNCHK
lin identify_V = mkV "tunnistaa" ;
lin identify_V2 = mkV2 "tunnistaa" ;
lin identikit_N = mkWN (compoundN "tunnistus" (k10 "kuva")) ; --UNCHK
lin identity_N = mkN "identiteetti" ;
lin ideogram_N = mkWN "ideografi" ; --UNCHK
lin ideograph_N = mkWN "ideografi" ; --UNCHK
lin ideographic_A = mkWA "ideografinen" ; --UNCHK
lin ideography_N = mkWN (compoundN "käsite" (k39 "kirjoitus")) ; --UNCHK
lin ideological_A = mkWA (k38 "ideologinen") ; --UNCHK
lin ideologist_N = mkWN (k5 "ideologi") ; --UNCHK
lin ideology_N = mkWN (k12 "ideologia") ; --UNCHK
lin ides_N = mkWN "idus" ; --UNCHK
lin idesia_N = mkWN (compoundN "polyc" (k9A "arpa")) "Idesia" ; --UNCHK
lin idiocy_N = mkWN (compoundN "tylsämiel" (k40 "isyys")) ; --UNCHK
lin idiographic_A = mkWA "idiografinen" ; --UNCHK
lin idiolatry_N = mkWN (compoundN "itsensä" (k9A "palvonta")) ; --UNCHK
lin idiolect_N = mkWN (compoundN "yksilö" (k48A "murre")) ; --UNCHK
lin idiom_N = mkWN (k5 "tyyli") "taiteellinen" ; --UNCHK
lin idiomatic_A = mkWA "idiomaattinen" ; --UNCHK
lin idiopathic_A = mkWA "idiopaattinen" ; --UNCHK
lin idiosyncrasy_N = mkWN (k6 "maneeri") ; --UNCHK
lin idiosyncratic_A = mkWA (k38 "ominainen") ; --UNCHK
lin idiot_N = mkWN (k1 "tollo") ; --UNCHK
lin idiotic_A = mkWA (k5 "imbesilli") ; --UNCHK
lin idle_A = mkWA (k41 "joutilas") ; --UNCHK
lin idle_N = mkWN (compoundN "jouto" (k5A "käynti")) ; --UNCHK
lin idle_V = mkWV (k67 "olla") "joutokäynnillä" ; --UNCHK
lin idle_V2 = mkV2 (mkV (mkV "pitää") "joutokäynnillä") partitive ;
lin idleness_N = mkWN (k40 "joutilaisuus") ; --UNCHK
lin idler_N = mkWN (k5 "pummi") ; --UNCHK
lin idol_N = mkWN (k10 "jumala") ; --UNCHK
lin idolater_N = mkWN (k10 "palvoja") "idolin" ; --UNCHK
lin idolatress_N = mkWN (compoundN "epäjumalan" (k10 "palvoja")) ; --UNCHK
lin idolatrous_A = mkWA "epäjumala-" ; --UNCHK
lin idolatry_N = mkWN (k9A "palvonta") "epäjumalan" ; --UNCHK
lin idolization_N = mkWN (k9A "palvonta") ; --UNCHK
lin idolize_V2 = mkWV2 (k67 "ihailla") ; --UNCHK
lin idolizer_N = mkWN (k10 "palvoja") "idolin" ; --UNCHK
lin idyll_N = mkWN (k10 "runoelma") "pieni" ; --UNCHK
lin idyllic_A = mkWA (k38 "idyllinen") ; --UNCHK
lin if_Subj = S.if_Subj ;
lin if_then_Conj = S.if_then_Conj ;
lin igloo_N = mkWN (k1 "iglu") ; --UNCHK
lin igneous_A = mkWA (k38 "eruptiivinen") ; --UNCHK
lin ignescent_A = mkWA "syttyvä" ; --UNCHK
lin ignis_fatuus_N = mkWN (k48 "haave") "tavoittamaton" ; --UNCHK
lin ignite_V = mkWV (k63 "saada") "aikaan" ; --UNCHK
lin ignite_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin igniter_N = mkWN (k6 "sytkäri") ; --UNCHK
lin ignition_N = mkWN (k39 "sytytys") ; --UNCHK
lin ignoble_A = mkWA (k38 "halpamainen") ; --UNCHK
lin ignobleness_N = mkWN (k40 "halpamaisuus") ; --UNCHK
lin ignominious_A = mkWA (k34A "kunniaton") ; --UNCHK
lin ignominy_N = mkWN (k39 "nöyryytys") ; --UNCHK
lin ignoramus_N = mkWN (k38 "ihminen") "valistumaton" ; --UNCHK
lin ignorance_N = mkWN (k40 "tietämättömyys") ; --UNCHK
lin ignorant_A = mkWA (k34A "oppimaton") ; --UNCHK
lin ignorantness_N = mkWN (k40 "sivistymättömyys") ; --UNCHK
lin ignore_V = mkWV (k67 "olla") "huomaamatta" ; --UNCHK
lin ignore_V2 = mkWV2 (k67 "olla") "huomaamatta" ;
lin iguana_N = mkWN (k5 "leguaani") ; --UNCHK
lin iguanid_N = mkWN (k5 "leguaani") ; --UNCHK
lin iguanodon_N = mkWN "iguanodon" ; --UNCHK
lin ii_PN = mkPN "Ii" ;
lin iisalmi_PN = mkPN (mkN "Iisalmi" "Iisalmia") ;
lin iitti_PN = mkPN (mkN "Iitti" "Iittiä") ;
lin ijtihad_N = mkWN "ijtihad" ; --UNCHK
lin ikaalinen_PN = mkPN "Ikaalinen" ;
lin ikon_N = mkWN (k6 "ikoni") ; --UNCHK
lin ilama_N = mkWN "Annona" "diversifolia" ; --UNCHK
lin ileitis_N = mkWN "ileiitti" ; --UNCHK
lin ileum_N = mkWN (compoundN "sykkyrä" (k26 "suoli")) ; --UNCHK
lin ilex_N = mkWN (compoundN "Ilex-" (k1A "suku")) ; --UNCHK
lin ilfracombe_PN = foreignPN "Ilfracombe" ;
lin iliac_A = mkWA "suoliluuhun" "liittyvä" ; --UNCHK
lin ilium_N = mkWN (compoundN "suoli" (k18 "luu")) ; --UNCHK
lin ilk_N = mkWN (k38 "lainen") ; --UNCHK
lin ilkeston_PN = foreignPN "Ilkeston" ;
lin ilkley_PN = foreignPN "Ilkley" ;
lin ill_1_A = mkWA (k41 "sairas") ;
lin ill_2_A = mkWA (k41 "sairas") ;
lin ill_AdV = mkAdV (k99 "huonosti") ; --UNCHK
lin ill_N = mkWN (k9 "vaiva") ; --UNCHK
lin ill_advised_A = mkA "harkitsematon" ;
lin illative_A = mkWA (compoundA "päätte" (k10 "levä")) ; --UNCHK
lin illegal_A = mkWA (k34A "laiton") ; --f69
lin illegality_N = mkWN (k40 "laittomuus") ; --UNCHK
lin illegibility_N = mkWN "vaikealukuisuus" ; --UNCHK
lin illegible_A = mkWA (compoundA "vaikea" (k38 "lukuinen")) ; --UNCHK
lin illegitimacy_N = mkWN (k40 "laittomuus") ; --UNCHK
lin illegitimate_A = mkA "lainvastainen" ;
lin illegitimate_N = mkWN (k10A "Chlorophyceae-luokka") ; --UNCHK
lin illiberal_A = mkWA (k34A "suvaitsematon") ; --UNCHK
lin illiberality_N = mkWN (k40 "saituus") ; --UNCHK
lin illicit_A = mkWA (k1A "kielletty") ; --UNCHK
lin illicitness_N = mkWN (k40 "laittomuus") ; --UNCHK
lin illimitable_A = mkWA (k34A "ääretön") ; --UNCHK
lin illinois_PN = mkPN (mkN "Illinois" "Illinoiseja") ;
lin illiteracy_N = mkWN (compoundN "luku" (k40 "taidottomuus")) ; --UNCHK
lin illiterate_A = mkWA (k34A "oppimaton") ; --UNCHK
lin illiterate_N = mkWN (k2 "henkilö") "lukutaidoton" ; --UNCHK
lin illness_N = mkWN (k5A "tauti") ; --UNCHK
lin illogical_A = mkWA (compoundA "epä" (k38 "looginen")) ; --UNCHK
lin illogicality_N = mkWN (compoundN "epä" (k40 "loogisuus")) ; --UNCHK
lin illogicalness_N = mkWN (compoundN "epä" (k40 "loogisuus")) ; --UNCHK
lin illume_V2 = mkWV2 (k66 "valaista") ; --UNCHK
lin illuminance_N = mkWN (k39 "valaistus") ; --UNCHK
lin illuminant_N = mkWN (k48 "aine") "valaiseva" ; --UNCHK
lin illuminate_V2 = mkWV2 (k66 "valaista") ; --UNCHK
lin illumination_N = mkWN (k39 "kuvitus") ; --UNCHK
lin illumine_V2 = mkWV2 (k66 "valaista") ; --UNCHK
lin illusion_N = mkWN (k3 "illuusio") ;
lin illusional_A = mkWA (k10 "vaikuttava") "todellisuudelta" ; --UNCHK
lin illusionist_N = mkWN (k4A "maagikko") ; --UNCHK
lin illusive_A = mkWA (k38 "näennäinen") ; --UNCHK
lin illusory_A = mkWA (k38 "näennäinen") ; --UNCHK
lin illustrate_V = mkWV (k53A "esittää") ; --UNCHK
lin illustrate_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin illustrate_VS = mkWVS (k53A "esittää") ; --UNCHK
lin illustration_N = mkWN (k39 "kuvitus") ; --UNCHK
lin illustrative_A = mkWA (k38 "havainnollinen") ; --UNCHK
lin illustrator_N = mkWN (k10 "kuvittaja") ; --UNCHK
lin illustrious_A = mkWA (k41A "maineikas") ; --UNCHK
lin ilmajoki_PN = mkPN (mkN "Ilmajoki" "Ilmajokia") ;
lin ilmenite_N = mkWN (compoundN "ilme" (k5A "niitti")) ; --UNCHK
lin ilo_N = mkWN (compoundN "työ" (k2 "järjestö")) "Kansainvälinen" ; --UNCHK
lin ilomantsi_PN = mkPN "Ilomantsi" ;
lin image_N = mkN "mielikuva" ;
lin image_V2 = mkWV2 (k62 "visioida") ; --UNCHK
lin imagery_N = mkWN (k39 "ajatus") ; --UNCHK
lin imaginable_A = mkWA (k10 "oleva") "kuviteltavissa" ; --UNCHK
lin imaginary_A = mkWA (k38 "imaginaarinen") ; --UNCHK
lin imagination_N = mkWN (k2 "kuvittelu") ; --UNCHK
lin imaginative_A = mkWA (k38 "mielikuvituksellinen") ; --UNCHK
lin imagine_V = mkV "kuvitella" ;
lin imagine_V2 = mkV2 "kuvitella" ;
lin imagine_VS = mkVS (mkV "kuvitella") ;
lin imaging_N = mkWN (k12 "tomografia") ; --UNCHK
lin imagism_N = mkWN (compoundN "imag" (k5 "ismi")) ; --UNCHK
lin imago_N = mkWN (k2 "imago") ; --UNCHK
lin imam_N = mkWN (k5 "imaami") ; --UNCHK
lin imatra_PN = mkPN "Imatra" ;
lin imbalance_N = mkWN "epätasapaino" ; --UNCHK
lin imbecile_A = mkWA (k5 "imbesilli") ; --UNCHK
lin imbecile_N = mkWN (k1 "tollo") ; --UNCHK
lin imbecility_N = mkWN (k39 "möhläys") ; --UNCHK
lin imbed_V2 = mkWV2 (k53A "asettaa") ; --UNCHK
lin imbibe_V2 = mkWV2 (k52 "omaksua") ; --UNCHK
lin imbibition_N = mkWN (k5A "juonti") ; --UNCHK
lin imbricate_A = mkWA (k38 "limittäinen") ; --UNCHK
lin imbrication_N = mkWN (k39 "limitys") ; --UNCHK
lin imbroglio_N = mkWN (k39 "sekaannus") "nolo" ; --UNCHK
lin imbue_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin imf_N = mkWN (compoundN "valuutta" (k2 "rahasto")) "Kansainvälinen" ; --UNCHK
lin imidazole_N = mkWN "glyoksaliini" ; --UNCHK
lin imide_N = mkWN "imidi" ; --UNCHK
lin imipramine_N = mkWN "Surmontil" ; --UNCHK
lin imitate_V2 = mkWV2 (k62 "imitoida") ; --UNCHK
lin imitation_N = mkWN (k2 "jäljittely") ; --UNCHK
lin imitative_A = mkWA (k10 "väärä") ; --UNCHK
lin imitator_N = mkWN (k12 "apina") ; --UNCHK
lin immaculate_A = mkWA (k34A "tahriintumaton") ; --UNCHK
lin immanence_N = mkWN (compoundN "läsnä" (k1 "olo")) ; --UNCHK
lin immanent_A = mkWA (k38 "subjektiivinen") ; --UNCHK
lin immaterial_A = mkWA (k34A "aineeton") ; --UNCHK
lin immateriality_N = mkWN (k40 "aineettomuus") ; --UNCHK
lin immature_A = mkWA "sulaton" ; --UNCHK
lin immaturity_N = mkWN (k40 "kehittymättömyys") ; --UNCHK
lin immeasurable_A = mkWA (k34A "määrätön") ; --UNCHK
lin immediacy_N = mkWN (k40 "välittömyys") ; --UNCHK
lin immediate_A = mkWA (k34A "välitön") ; --f136
lin immemorial_A = mkWA (compoundA "iki" (k9 "vanha")) ; --UNCHK
lin immense_A = mkWA (k10 "valtava") ; --UNCHK
lin immensity_N = mkWN (k40 "laajuus") ; --UNCHK
lin immerse_V2 = mkWV2 (k52A "hautautua") ; --UNCHK
lin immersion_N = mkWN (compoundN "kas" (k38 "taminen")) ; --UNCHK
lin immigrant_N = mkWN (k38 "siirtolainen") ; --UNCHK
lin immigrate_V = mkWV (k53A "muuttaa") "maahan" ; --UNCHK
lin immigration_N = mkWN (k40 "siirtolaisuus") ; --UNCHK
lin imminence_N = mkWN (k40 "uhkaavuus") ; --UNCHK
lin imminent_A = mkWA (k10 "tuleva") ; --UNCHK
lin immingham_PN = foreignPN "Immingham" ;
lin immiscible_A = mkWA "sekoittumaton" ; --UNCHK
lin immobile_A = mkWA (compoundA "liikunta" (k34A "kyvytön")) ; --UNCHK
lin immobility_N = mkWN (k40 "liikkumattomuus") ; --UNCHK
lin immobilization_N = mkWN (k1 "esto") "liikkumisen" ; --UNCHK
lin immobilize_V2 = mkWV2 (k71 "tehdä") "liikuntakyvyttömäksi" ; --UNCHK
lin immoderate_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin immoderation_N = mkWN (k40 "ylettömyys") ; --UNCHK
lin immodest_A = mkWA (k34A "säädytön") ; --UNCHK
lin immodesty_N = mkWN (k40 "säädyttömyys") ; --UNCHK
lin immolate_V2 = mkWV2 (k73 "uhrata") ; --UNCHK
lin immolation_N = mkWN (compoundN "uhri" (k9 "lahja")) ; --UNCHK
lin immoral_A = mkWA (k34A "moraaliton") ; --UNCHK
lin immorality_N = mkWN (k40 "häijyys") ; --UNCHK
lin immortal_A = mkWA (k34A "kuolematon") ; --UNCHK
lin immortal_N = mkWN (k34A "kuolematon") ; --UNCHK
lin immortality_N = mkWN (k40 "kuolemattomuus") ; --UNCHK
lin immortalize_V2 = mkWV2 (k71 "tehdä") "ikuiseksi" ; --UNCHK
lin immortelle_N = mkWN (compoundN "paperi" (k10A "kukka")) ; --UNCHK
lin immotility_N = mkWN (compoundN "liikunta" (k40 "kyvyttömyys")) ; --UNCHK
lin immovability_N = mkWN (k40 "kiinteys") ; --UNCHK
lin immovable_A = mkWA (k34A "järkähtämätön") ; --UNCHK
lin immune_A = mkWA "immuuni-" ; --UNCHK
lin immune_N = mkWN (k5 "immuuni") ; --UNCHK
lin immunity_N = mkN "immuniteetti" ; --WN (k39 "vapautus") ;
lin immunization_N = mkWN (k5A "immunisointi") ; --UNCHK
lin immunize_V2 = mkWV2 (k71 "tehdä") "immuuniksi" ; --UNCHK
lin immunoassay_N = mkWN (k5 "analyysi") "immunokemiallinen" ; --UNCHK
lin immunochemical_A = mkWA (compoundA "immuno" (k38 "kemiallinen")) ; --UNCHK
lin immunochemistry_N = mkWN (k12 "immunologia") "kemiallinen" ; --UNCHK
lin immunocompetence_N = mkWN (compoundN "immuno" (k5 "kompetenssi")) ; --UNCHK
lin immunocompetent_A = mkWA (compoundA "immuno" (k5A "kompetentti")) ; --UNCHK
lin immunodeficiency_N = mkWN (compoundN "immuuni" (k39 "puutos")) ; --UNCHK
lin immunodeficient_A = mkWA "immuunipuutoksesta" "kärsivä" ; --UNCHK
lin immunoelectrophoresis_N = mkWN "immunoelektroforeesi" ; --UNCHK
lin immunofluorescence_N = mkWN (compoundN "immuno" (k5 "fluoresenssi")) ; --UNCHK
lin immunogen_N = mkWN (k12 "tekijä") "immunisoiva" ; --UNCHK
lin immunogenic_A = mkWA "immunogeeninen" ; --UNCHK
lin immunogenicity_N = mkWN "immunogeenisuus" ; --UNCHK
lin immunoglobulin_N = mkWN (compoundN "immuno" (k5 "gammaglobuliini")) ; --UNCHK
lin immunohistochemistry_N = mkWN (compoundN "immunohisto" (k12 "kemia")) ; --UNCHK
lin immunological_A = mkWA (k38 "immunologinen") ; --UNCHK
lin immunologist_N = mkWN "immunologi" ; --UNCHK
lin immunology_N = mkWN (k12 "immunologia") ; --UNCHK
lin immunopathology_N = mkWN (compoundN "immuno" (k12 "patologia")) ; --UNCHK
lin immunosuppressant_N = mkWN (k48A "lääke") "immunosuppressiivinen" ; --UNCHK
lin immunosuppressed_A = mkWA (compoundA "immunosuppresso" (k1A "itu")) ; --UNCHK
lin immunosuppression_N = mkWN "immunosuppressio" ; --UNCHK
lin immunosuppressive_A = mkWA "immunosuppressiivinen" ; --UNCHK
lin immunotherapeutic_A = mkWA (compoundA "immuno" (k38 "terapeuttinen")) ; --UNCHK
lin immunotherapy_N = mkWN (compoundN "immuno" (k12 "terapia")) ; --UNCHK
lin immutability_N = mkWN (k40 "pysyvyys") ; --UNCHK
lin immutable_A = mkWA (k10 "pysyvä") ; --UNCHK
lin imp_N = mkWN (k38 "maahinen") ; --UNCHK
lin impact_N = mkN (lin NK {s = d39 "vaikutus"}) ;
lin impact_V2 = mkWV2 (k52A "liittyä") ; --UNCHK
lin impaction_N = mkWN (k39 "törmäys") ; --UNCHK
lin impair_V2 = mkWV2 (k54A "heikentää") ; --UNCHK
lin impairer_N = mkWN "heikentäjä" ; --UNCHK
lin impairment_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin impale_V2 = mkWV2 (k73 "naulata") ; --UNCHK
lin impalement_N = mkWN (k39 "lävistys") ; --UNCHK
lin impalpable_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin impanel_V2 = mkWV2 (k75 "nimetä") ; --UNCHK
lin impart_V2 = mkWV2 (k53A "kuljettaa") ; --UNCHK
lin impartial_A = mkWA (k34A "ennakkoluuloton") ; --UNCHK
lin impartiality_N = mkWN (k40 "tasapuolisuus") ; --UNCHK
lin impassable_A = mkWA (compoundA "yli" (k34A "pääsemätön")) ; --UNCHK
lin impasse_N = mkWN (compoundN "umpi" (k1A "katu")) ; --UNCHK
lin impassioned_A = mkWA (k10 "kuuma") ; --UNCHK
lin impassive_A = mkWA (k34A "eleetön") ; --UNCHK
lin impassiveness_N = mkWN (k40 "ilmeettömyys") ; --UNCHK
lin impassivity_N = mkWN (k40 "ilmeettömyys") ; --UNCHK
lin impasto_N = mkWN (kH1 "maalaus") ; --UNCHK
lin impatience_N = mkWN (k40 "kärsimättömyys") ; --UNCHK
lin impatient_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin impeach_V2 = mkWV2 (k53A "syyttää") "rikoksesta" ; --UNCHK
lin impeachability_N = mkWN (compoundN "ase" (k1 "tettu")) "syytteeseen" ; --UNCHK
lin impeachment_N = mkWN (compoundN "virka" (k48A "syyte")) ; --UNCHK
lin impeccability_N = mkWN "synnittömyys" ; --UNCHK
lin impeccable_A = mkWA (k34A "nuhteeton") ; --UNCHK
lin impeccant_A = mkWA (k34A "synnitön") ; --UNCHK
lin impecunious_A = mkWA (k99 "kovilla") ; --UNCHK
lin impecuniousness_N = mkWN (k40 "rahattomuus") ; --UNCHK
lin impede_V2 = mkWV2 (k53 "estää") ;
lin impediment_N = mkWN (k39 "vastus") ; --UNCHK
lin impedimenta_N = mkWN (k1 "kuormasto") ; --UNCHK
lin impel_V2 = mkWV2 (k53A "liikuttaa") ; --UNCHK
lin impellent_A = mkWA "liikkeelle" "paneva" ; --UNCHK
lin impeller_N = mkWN (compoundN "juoksu" (k10 "pyörä")) ; --UNCHK
lin impelling_A = mkWA "herättävä" ; --UNCHK
lin impend_V = mkWV (k67 "olla") "tapahtumaisillaan" ; --UNCHK
lin impenetrability_N = mkWN (k40 "käsittämättömyys") ; --UNCHK
lin impenetrable_A = mkWA (compoundA "läpi" (k34A "pääsemätön")) ; --UNCHK
lin impenitence_N = mkWN "katumattomuus" ; --UNCHK
lin impenitent_A = mkWA (k34A "tuntematon") "mielipahaa" ; --UNCHK
lin imperative_A = mkWA (k34A "välttämätön") ; --UNCHK
lin imperative_N = mkWN (k40 "välttämättömyys") ; --UNCHK
lin imperativeness_N = mkWN (k40 "hellittämättömyys") ; --UNCHK
lin imperceptibility_N = mkWN (k40 "huomaamattomuus") ; --UNCHK
lin imperceptible_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin imperfect_A = mkWA (k38 "vajavainen") ; --UNCHK
lin imperfect_N = mkWN (k5 "imperfekti") ; --UNCHK
lin imperfectibility_N = mkWN (compoundN "epä" (k40 "täydellisyys")) ; --UNCHK
lin imperfectible_A = mkWA (compoundA "epä" (k38 "täydellinen")) ; --UNCHK
lin imperfection_N = mkWN (kH1 "vika") ; --UNCHK
lin imperfective_N = mkWN (k5 "aspekti") "imperfektiivinen" ; --UNCHK
lin imperforate_A = mkWA "reiätön" ; --UNCHK
lin imperial_A = mkWA (k38 "keisarillinen") ; --UNCHK
lin imperial_N = mkWN (compoundN "matka" (k12 "tavara")) ; --UNCHK
lin imperialism_N = mkWN (k5 "imperialismi") ; --UNCHK
lin imperialist_N = mkWN (k5 "imperialisti") ; --UNCHK
lin imperialistic_A = mkWA (k38 "imperialistinen") ; --UNCHK
lin imperil_V2 = mkWV2 (k54A "vaarantaa") ; --UNCHK
lin imperious_A = mkWA (k15 "ylpeä") ; --UNCHK
lin imperiousness_N = mkWN (k40 "kopeus") ; --UNCHK
lin imperishability_N = mkWN (k40 "ikuisuus") ; --UNCHK
lin imperishable_A = mkWA (k34A "häviämätön") ; --UNCHK
lin imperium_N = mkWN (k5A "auktoriteetti") ; --UNCHK
lin impermanence_N = mkWN (k40 "kestämättömyys") ; --UNCHK
lin impermanent_A = mkWA (k38 "tilapäinen") ; --UNCHK
lin impermeability_N = mkWN (k40 "läpäisemättömyys") ; --UNCHK
lin impermeable_A = mkWA (k34A "läpäisemätön") ; --UNCHK
lin impermissibility_N = mkWN (k40 "luvattomuus") ; --UNCHK
lin impermissible_A = mkWA (k1A "sallittu") "ei" ; --UNCHK
lin impersonate_V2 = mkWV2 (k53A "esittää") "jotakuta" ; --UNCHK
lin impersonation_N = mkWN (k5A "imitointi") ; --UNCHK
lin impersonator_N = mkWN (k6 "imitaattori") ; --UNCHK
lin impertinence_N = mkWN (k40 "nokkavuus") ; --UNCHK
lin impertinent_A = mkWA (k10 "nokkava") ; --UNCHK
lin imperturbability_N = mkWN (k40 "järkähtämättömyys") ; --UNCHK
lin imperturbable_A = mkWA (k38 "rauhallinen") ; --UNCHK
lin impervious_A = mkWA (k34A "läpäisemätön") ; --UNCHK
lin impetiginous_A = mkWA "märkärupeen" "liittyvä" ; --UNCHK
lin impetigo_N = mkWN (compoundN "märkä" (k7A "rupi")) ; --UNCHK
lin impetuosity_N = mkWN (k40 "impulsiivisuus") ; --UNCHK
lin impetuous_A = mkWA (k38 "äkillinen") ; --UNCHK
lin impetuousness_N = mkWN (k40 "impulsiivisuus") ; --UNCHK
lin impetus_N = mkWN (k5 "impulssi") ; --UNCHK
lin impiety_N = mkWN (compoundN "epä" (k40 "hurskaus")) ; --UNCHK
lin impinge_V = mkWV (k73A "loukata") ; --UNCHK
lin impingement_N = mkWN (k39 "törmäys") ; --UNCHK
lin impious_A = mkWA (k34A "jumalaton") ; --UNCHK
lin impish_A = mkWA (k10 "tuhma") ; --UNCHK
lin impishness_N = mkWN (k40 "leikillisyys") ; --UNCHK
lin implacable_A = mkWA (k34A "hellittämätön") ; --UNCHK
lin implant_N = mkWN (k48A "istute") ; --UNCHK
lin implant_V2 = mkWV2 (k53A "juurruttaa") ; --UNCHK
lin implantation_N = mkWN (k3 "implantaatio") ; --UNCHK
lin implausibility_N = mkWN "epätodennäköisyys" ; --UNCHK
lin implausible_A = mkWA (compoundA "epä" (k10 "uskottava")) ; --UNCHK
lin implement_N = mkWN (k48 "väline") ; --UNCHK
lin implement_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin implemental_A = mkWA (k38 "hyödyllinen") ; --UNCHK
lin implementation_N = mkWN (k39 "toteutus") ; --UNCHK
lin implicate_V2 = mkWV2 (k53A "osoittaa") "syylliseksi" ; --UNCHK
lin implication_N = mkN "seuraus" ;
lin implicational_A = mkWA "päätelmään" "perustuva" ; --UNCHK
lin implicative_A = mkWA (compoundA "viitt" (k9 "aava")) ; --UNCHK
lin implicit_A = mkWA (k38 "implisiittinen") ;
lin implicitness_N = mkWN (k40 "implisiittisyys") ; --UNCHK
lin implore_V2 = mkWV2 (k54A "pyytää") ; --UNCHK
lin implore_VS = mkWVS (k54A "pyytää") ; --UNCHK
lin imploringly_Adv = mkWAdv (k99 "itsepintaisesti") ; --UNCHK
lin implosion_N = mkWN (compoundN "implo" (k3 "osio")) ; --UNCHK
lin imply_V = mkWV (k73 "vihjata") ; --UNCHK
lin imply_V2 = mkWV2 (k73 "vihjata") ; --UNCHK
lin imply_VS = mkWVS (k73 "vihjata") ; --UNCHK
lin impolite_A = mkWA (compoundA "epä" (k41 "kohtelias")) ; --UNCHK
lin impoliteness_N = mkWN (compoundN "epä" (k40 "kohteliaisuus")) ; --UNCHK
lin impolitic_A = mkWA (compoundA "epä" (k41 "viisas")) ; --UNCHK
lin imponderable_A = mkWA (k34A "arvaamaton") ; --UNCHK
lin imponderable_N = mkWN (compoundN "epävarmuus" (k12 "tekijä")) ; --UNCHK
lin import_N = mkN "tuonti" ;
lin import_V2 = mkV2 "tuoda" ; --WV2 (k76A "tietää") ;
lin importance_N = mkWN (k40 "tärkeys") ;
lin important_A = L.important_A ;
lin importation_N = mkWN (k5A "tuonti") ; --UNCHK
lin importerFem_N = mkWN (compoundN "maahan" (k10 "tuoja")) ;
lin importerMasc_N = mkWN (compoundN "maahan" (k10 "tuoja")) ;
lin importing_N = mkWN (k5A "tuonti") ; --UNCHK
lin importunate_A = mkWA (k34A "hellittämätön") ; --UNCHK
lin importune_V2 = mkWV2 (k53A "inttää") ; --UNCHK
lin importunity_N = mkWN (k1 "halu") ; --UNCHK
lin impose_V = mkWV (k53A "tyrkyttää") ; --UNCHK
lin impose_V2 = mkV2 "määrätä" ;
lin imposition_N = mkWN (k39 "määräys") ; --UNCHK
lin impossibility_N = mkWN (k1A "teko") "mahdoton" ; --UNCHK
lin impossible_A = mkWA (k34A "mahdoton") ;
lin impossible_N = mkWN (k34A "mahdoton") ; --UNCHK
lin imposter_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin impostor_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin imposture_N = mkWN (k5A "imitointi") ; --UNCHK
lin impotence_N = mkWN (k40 "kyvyttömyys") ; --UNCHK
lin impotent_A = mkWA (k34A "voimaton") ; --UNCHK
lin impound_V2 = mkWV2 (k73 "tarhata") ; --UNCHK
lin impoundment_N = mkWN (k5A "internointi") ; --UNCHK
lin impoverish_V2 = mkWV2 (k53A "köyhdyttää") ; --UNCHK
lin impoverishment_N = mkWN "köyhdyttäminen" ; --UNCHK
lin impracticability_N = mkWN (k40 "mahdottomuus") "käytön" ; --UNCHK
lin impracticableness_N = mkWN (k40 "mahdottomuus") "käytön" ; --UNCHK
lin impractical_A = mkWA (compoundA "epä" (k38 "käytännöllinen")) ; --UNCHK
lin impracticality_N = mkWN (compoundN "epä" (k40 "käytännöllisyys")) ; --UNCHK
lin imprecate_V2 = mkWV2 (k74 "kirota") ; --UNCHK
lin imprecation_N = mkWN (k39 "kirous") ; --UNCHK
lin imprecise_A = mkWA (compoundA "epä" (k38 "täsmällinen")) ; --UNCHK
lin impreciseness_N = mkWN (compoundN "epä" (k40 "täsmällisyys")) ; --UNCHK
lin imprecision_N = mkWN (compoundN "epä" (k40 "täsmällisyys")) ; --UNCHK
lin impregnability_N = mkWN (k40 "kestävyys") "hyökkäyksen" ; --UNCHK
lin impregnable_A = mkWA (k34A "järkkymätön") ; --UNCHK
lin impregnate_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin impregnation_N = mkWN (k39 "hedelmöitys") ; --UNCHK
lin impresario_N = mkWN (k6 "promoottori") ; --UNCHK
lin impress_N = mkWN (k39 "värväys") "väkisin" ; --UNCHK
lin impress_V = mkWV (k73 "värjätä") ; --UNCHK
lin impress_V2 = mkV2 (mkV (mkWV (k71 "tehdä")) "vaikutus") (mkPrep illative) ; --mkWV2 (k73 "värjätä") ;
lin impression_N = mkWN (k10 "painauma") ; --UNCHK
lin impressionable_A = mkWA (k41A "altis") "vaikutuksille" ; --UNCHK
lin impressionism_N = mkWN (k5 "impressionismi") ; --UNCHK
lin impressionist_A = mkWA (k38 "impressionistinen") ; --UNCHK
lin impressionist_N = mkWN (k5 "impressionisti") ; --UNCHK
lin impressionistic_A = mkWA (k38 "impressionistinen") ; --UNCHK
lin impressive_A = mkWA (k10 "vaikuttava") ; --UNCHK
lin impressiveness_N = mkWN (k40 "vaikuttavuus") ; --UNCHK
lin imprimatur_N = mkWN (k10A "lupa") ; --UNCHK
lin imprint_N = mkWN (k7A "jälki") ; --UNCHK
lin imprint_V2 = mkWV2 (k56 "painaa") ; --UNCHK
lin imprinting_N = mkWN (compoundN "lei" (k38 "mautuminen")) ; --UNCHK
lin imprison_V2 = mkV2 "vangita" ;
lin imprisonment_N = mkWN (k40 "vankeus") ;
lin improbability_N = mkWN "epätodennäköisyys" ; --UNCHK
lin improbable_A = mkWA "epätodennäköinen" ; --UNCHK
lin impromptu_Adv = mkWAdv (k99 "spontaanisti") ; --UNCHK
lin impromptu_N = mkWN (k3 "improvisaatio") ; --UNCHK
lin improper_A = mkWA (k34A "säädytön") ; --UNCHK
lin impropriety_N = mkWN (k40 "vapaus") ; --UNCHK
lin improvable_A = mkWA "parannettava" ; --UNCHK
lin improve_V = mkWV (k52A "parantua") ;
lin improve_V2 = mkV2 "parantaa" partitive ;
lin improved_A = variants {} ; --
lin improvement_N = mkN "parannus" ;
lin improver_N = mkWN (k10 "lisä") ; --UNCHK
lin improvidence_N = mkWN (k40 "ajattelemattomuus") ; --UNCHK
lin improvident_A = mkWA (k38 "tuhlaavainen") ; --UNCHK
lin improvisation_N = mkWN (k5A "improvisointi") ; --UNCHK
lin imprudence_N = mkWN (k40 "harkitsemattomuus") ; --UNCHK
lin imprudent_A = mkWA (k34A "harkitsematon") ; --UNCHK
lin impudence_N = mkWN (k10A "pokka") ; --UNCHK
lin impudent_A = mkWA (k10 "nokkava") ; --UNCHK
lin impugn_V2 = mkWV2 (k53 "kyseenalaistaa") ; --UNCHK
lin impugnable_A = mkWA "kyseenalaistettava" ; --UNCHK
lin impuissant_A = mkWA (k34A "voimaton") ; --UNCHK
lin impulse_N = mkWN (k5 "impulssi") ; --UNCHK
lin impulsion_N = mkWN (k5 "impulssi") ; --UNCHK
lin impulsive_A = mkWA (k38 "äkillinen") ; --UNCHK
lin impulsiveness_N = mkWN (k40 "impulsiivisuus") ; --UNCHK
lin impunity_N = mkWN "rankaisemattomuus" ; --UNCHK
lin impure_A = mkWA (compoundA "epä" (k41A "puhdas")) ; --UNCHK
lin impurity_N = mkWN (compoundN "epä" (k40 "puhtaus")) ; --UNCHK
lin imputation_N = mkWN (compoundN "syyksi" (k38 "lukeminen")) ; --UNCHK
lin impute_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin imputrescible_A = mkWA "mätänemätön" ; --UNCHK
lin in8front_Prep = S.in8front_Prep ;
lin in_1_Adv = mkAdv "sisällä" ;
lin in_2_Adv = mkAdv "sisään" ;
lin in_A = mkWA (k10 "oleva") "muodissa" ; --UNCHK
lin in_Adv = mkAdv "sisään" ; --- already split
lin in_N = mkN "muoti" ;
lin in_Prep = S.in_Prep ;
lin in_accordance_with_Prep = mkPrep "mukaan" ;
lin in_addition_Adv = mkAdv "lisäksi" ;
lin in_addition_to_Prep = mkPrep "lisäksi" ;
lin in_case_of_Prep = mkPrep "sattuessa" ;
lin in_front_of_Prep = mkPrep "edessä" ;
lin in_lieu_of_Prep = mkPrep "sijasta" ;
lin in_loco_parentis_Adv = mkWAdv "vanhempien" "sijasta" ; --UNCHK
lin in_order_to_Prep = mkPrep "tarkoituksena" nominative ; ---- cat ??
lin in_place_of_Prep = mkPrep "sijasta" ;
lin in_point_of_Prep = mkPrep "viitaten" illative ;
lin in_situ_Adv = mkWAdv (k99 "paikallaan") ; --UNCHK
lin in_spite_of_Prep = mkPrep elative "huolimatta" ;
lin in_toto_Adv = mkWAdv (k99 "kokonaan") ; --f60
lin inability_N = mkWN (k40 "kyvyttömyys") ; --UNCHK
lin inaccessibility_N = mkWN (compoundN "epä" (k40 "käytettävyys")) ; --UNCHK
lin inaccessible_A = mkWA (compoundA "luokse" (k34A "pääsemätön")) ; --UNCHK
lin inaccuracy_N = mkWN (k40 "virheellisyys") ; --UNCHK
lin inaccurate_A = mkWA (k38 "virheellinen") ;
lin inaction_N = mkWN (k40 "joutilaisuus") ; --UNCHK
lin inactivate_V2 = mkWV2 (k58 "kytkeä") "pois" ; --UNCHK
lin inactivation_N = mkWN (compoundN "deakti" (k5A "vointi")) ; --UNCHK
lin inactive_A = mkWA (k34A "toimeton") ; --UNCHK
lin inactiveness_N = mkWN (k40 "velttous") ; --UNCHK
lin inactivity_N = mkWN "toimettomuus" ; --UNCHK
lin inadequacy_N = mkWN (k40 "riittämättömyys") ; --UNCHK
lin inadequate_A = mkWA (k34A "sopimaton") ; --UNCHK
lin inadmissible_A = mkWA "todisteeksi" "kelpaamaton" ; --UNCHK
lin inadvertence_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin inadvertent_A = mkWA (k34A "tahaton") ; --UNCHK
lin inadvisability_N = mkWN (compoundN "epä" (k40 "viisaus")) ; --UNCHK
lin inadvisable_A = mkWA (compoundA "epä" (k41 "viisas")) ; --UNCHK
lin inaesthetic_A = mkWA (compoundA "epä" (k38 "esteettinen")) ; --UNCHK
lin inalienable_A = mkWA (k34A "luovuttamaton") ; --UNCHK
lin inamorata_N = mkWN (k32A "rakastajatar") ; --UNCHK
lin inamorato_N = mkWN (k10 "rakastaja") ; --UNCHK
lin inane_A = mkWA (k10 "tyhjä") ; --UNCHK
lin inanimate_A = mkWA (k34A "hengetön") ; --UNCHK
lin inanimateness_N = mkWN (k40 "hengettömyys") ; --UNCHK
lin inanition_N = mkWN "nääntyminen" ; --UNCHK
lin inanity_N = mkWN (k40 "tarkoituksettomuus") ; --UNCHK
lin inapplicability_N = mkWN (compoundN "käyttö" (k40 "kelvottomuus")) ; --UNCHK
lin inapplicable_A = mkWA (k34A "sopimaton") ; --UNCHK
lin inapposite_A = mkWA (k34A "sopimaton") ; --UNCHK
lin inappreciable_A = mkWA (k26 "pieni") "merkityksettömän" ; --UNCHK
lin inappropriate_A = mkWA (k34A "sopimaton") ; --UNCHK
lin inappropriateness_N = mkWN (k40 "kelvottomuus") ; --UNCHK
lin inapt_A = mkWA (k2 "tökerö") ; --UNCHK
lin inaptitude_N = mkWN (k40 "sopimattomuus") ; --UNCHK
lin inaptness_N = mkWN (k40 "sopimattomuus") ; --UNCHK
lin inarguable_A = mkWA (k34A "kiistaton") ; --UNCHK
lin inari_PN = mkPN "Inari" ;
lin inarticulate_A = mkWA (compoundA "puhe" (k34A "kyvytön")) ; --UNCHK
lin inartistic_A = mkWA (k34A "lahjaton") "taiteellisesti" ; --UNCHK
lin inasmuch_as_Adv = mkAdv "siinä määrin kuin" ;
lin inattention_N = mkWN (k40 "tarkkaamattomuus") ; --UNCHK
lin inattentive_A = mkWA (k34A "tarkkaamaton") ; --UNCHK
lin inattentiveness_N = mkWN (k40 "piittaamattomuus") ; --UNCHK
lin inaudibility_N = mkWN (k40 "kuulemattomuus") ; --UNCHK
lin inaudible_A = mkWA (k34A "kuulumaton") ; --UNCHK
lin inaugural_A = mkWA "avajais-" ; --UNCHK
lin inaugurate_V2 = mkWV2 (k56A "alkaa") ; --UNCHK
lin inauguration_N = mkWN (compoundN "per" (k38 "ustaminen")) ; --UNCHK
lin inauspicious_A = mkWA (compoundA "huono" (k38 "enteinen")) ; --UNCHK
lin inauspiciousness_N = mkWN (compoundN "epä" (k40 "suotuisuus")) ; --UNCHK
lin inauthentic_A = mkWA (compoundA "epä" (k1A "aito")) ; --UNCHK
lin inboard_A = mkWA (k38 "sisäinen") ; --UNCHK
lin inborn_A = mkWA (k38 "luontainen") ; --UNCHK
lin inbound_A = mkWA (compoundA "suu" (k47 "ntautunut")) "sisäänpäin" ; --UNCHK
lin inbred_A = mkWA (compoundA "sisäsiit" (k38 "toinen")) ; --UNCHK
lin inbreeding_N = mkWN (compoundN "suku" (k39 "siitos")) ; --UNCHK
lin inbuilt_A = mkWA (k38 "oleellinen") ; --UNCHK
lin incalculable_A = mkWA (k34A "lukematon") ; --UNCHK
lin incandescence_N = mkWN (k1 "hehku") ; --UNCHK
lin incandescent_A = mkWA (compoundA "heh" (k10 "kuva")) ; --UNCHK
lin incantation_N = mkWN (k1 "loitsu") ; --UNCHK
lin incapability_N = mkWN (k40 "kyvyttömyys") ; --UNCHK
lin incapable_A = mkWA (k34A "kykenemätön") ; --UNCHK
lin incapacitate_V2 = mkWV2 (k52A "vammautua") ; --UNCHK
lin incapacity_N = mkWN (k40 "kyvyttömyys") ; --UNCHK
lin incarceration_N = mkWN (k40 "vankeus") ; --UNCHK
lin incarnate_A = mkWA (compoundA "liha" (k47 "llistunut")) ; --UNCHK
lin incarnation_N = mkWN (k3 "personifikaatio") ; --UNCHK
lin incaution_N = mkWN (k40 "harkitsemattomuus") ; --UNCHK
lin incautious_A = mkWA (k34A "harkitsematon") ; --UNCHK
lin incendiarism_N = mkWN (compoundN "murha" (k1A "poltto")) ; --UNCHK
lin incendiary_A = mkWA "tuho-" ; --UNCHK
lin incendiary_N = mkWN (k5 "palopommi") ; --UNCHK
lin incense_N = mkWN (compoundN "suitsuke" (k1 "savu")) ; --UNCHK
lin incense_V2 = mkWV2 (k53A "suututtaa") ; --UNCHK
lin incentive_N = mkN (lin NK {s = d33 "kannustin"}) ;
lin inception_N = mkWN (k1A "alku") ; --UNCHK
lin incertitude_N = mkWN (k2 "epäily") ; --UNCHK
lin incessant_A = mkWA (k38 "alituinen") ; --UNCHK
lin incest_N = mkWN (k10 "sukurutsa") ; --UNCHK
lin incestuous_A = mkWA (k38 "sukurutsainen") ; --UNCHK
lin inch_N = mkWN (kH1 "tuuma") ; --UNCHK
lin inch_V = mkWV (k52A "hivuttautua") ; --UNCHK
lin inch_V2 = mkWV2 (k52A "hivuttautua") ; --UNCHK
lin inchoative_A = mkWA "inkoatiivinen" ; --UNCHK
lin inchoative_N = mkWN (k5 "aspekti") "inkoatiivinen" ; --UNCHK
lin incidence_N = mkWN (compoundN "kohta" (k38 "aminen")) ; --UNCHK
lin incident_A = mkWA (k38 "satunnainen") ; --UNCHK
lin incident_N = mkWN (k10 "tapahtuma") ; --UNCHK
lin incidental_A = mkWA (k38 "satunnainen") ; --UNCHK
lin incidental_N = mkWN (k12 "asia") "satunnainen" ; --UNCHK
lin incinerate_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin incineration_N = mkWN (compoundN "jätteen" (k1A "poltto")) ; --UNCHK
lin incinerator_N = mkWN (compoundN "poltto" (k5 "uuni")) ;
lin incipiency_N = mkWN (k1A "alku") ; --UNCHK
lin incise_V2 = mkWV2 (k54A "kaivertaa") ; --UNCHK
lin incision_N = mkWN (k3 "sektio") ; --UNCHK
lin incisive_A = mkWA (k10 "terävä") ; --UNCHK
lin incisiveness_N = mkWN (k40 "purevuus") ; --UNCHK
lin incisor_N = mkWN (compoundN "etu" (k41A "hammas")) ; --UNCHK
lin incisure_N = mkWN (k10 "halkeama") ; --UNCHK
lin incitation_N = mkWN (k39 "yllytys") ; --UNCHK
lin incite_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin incitement_N = mkWN (k39 "yllytys") ; --UNCHK
lin incivility_N = mkWN (compoundN "epä" (k40 "kohteliaisuus")) ; --UNCHK
lin inclemency_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin inclement_A = mkWA (k34A "armoton") ; --UNCHK
lin inclination_N = mkWN (k39 "nyökkäys") ; --UNCHK
lin incline_N = mkWN (k10 "luiska") ; --UNCHK
lin incline_V = mkWV (k53A "taivuttaa") ; --UNCHK
lin incline_V2 = mkWV2 (k53A "taivuttaa") ; --UNCHK
lin incline_V2V = mkWV2V (k53A "taivuttaa") ; --UNCHK
lin inclined_A = variants {} ; --
lin inclinometer_N = mkWN (compoundN "kaltevuus" (k6 "mittari")) ; --UNCHK
lin inclose_V2 = mkWV2 (k56A "laittaa") ; --UNCHK
lin inclosure_N = mkWN (k5A "ympäröinti") ; --UNCHK
lin include_V = mkV "sisältää" ;
lin include_V2 = mkV2 "sisältää" ;
lin including_Prep = mkPrep "mukaanluettuna" nominative ;
lin inclusion_N = mkN "mukaanotto" ; --WN (k39 "lisäys") ;
lin inclusive_A = mkWA "kattava" ; --UNCHK
lin incognito_A = mkWA (k9 "tuntemattomana") ; --UNCHK
lin incognito_Adv = mkWAdv (compoundAdv "tuntemattom" (k99 "asti")) ; --UNCHK
lin incognizable_A = mkWA (k34A "tuntematon") ; --UNCHK
lin incognizance_N = mkWN (k40 "tietämättömyys") ; --UNCHK
lin incoherence_N = mkWN (k40 "käsittämättömyys") ; --UNCHK
lin incoherent_A = mkWA (compoundA "epä" (k5A "koherentti")) ; --UNCHK
lin incombustible_A = mkWA (k34A "syttymätön") ; --UNCHK
lin income_N = mkN "tulo" ;
lin income_tax_N = mkWN (compoundN "tulo" (k1 "vero")) ; --UNCHK
lin incoming_A = mkWA "virkaan" "astuva" ; --UNCHK
lin incommensurable_A = mkWA (k34A "yhteismitaton") ; --UNCHK
lin incommensurate_A = mkWA (compoundA "epä" (k38 "suhtainen")) ; --UNCHK
lin incommodious_A = mkWA (k41A "ahdas") ; --UNCHK
lin incommunicado_A = mkWA (k10 "oleva") "eristettynä" ; --UNCHK
lin incommutability_N = mkWN "muuttamattomuus" ; --UNCHK
lin incommutable_A = mkWA "muuttamaton" ; --UNCHK
lin incomparable_A = mkWA (compoundA "ainut" (k38 "laatuinen")) ; --UNCHK
lin incompatibility_N = mkWN (compoundN "yhteen" (k40 "sopimattomuus")) ; --UNCHK
lin incompatible_A = mkWA (compoundA "yhteen" (k34A "sopimaton")) ; --UNCHK
lin incompetence_N = mkWN (k40 "taitamattomuus") ; --UNCHK
lin incompetency_N = mkWN (k40 "taitamattomuus") ; --UNCHK
lin incompetent_A = mkWA (compoundA "epä" (k10 "pätevä")) ; --UNCHK
lin incompetent_N = mkWN (k2 "henkilö") "epäpätevä" ; --UNCHK
lin incomplete_A = mkWA (k38 "puutteellinen") ;
lin incompleteness_N = mkWN (k40 "raakuus") ; --UNCHK
lin incomprehensibility_N = mkWN (k40 "käsittämättömyys") ; --UNCHK
lin incomprehensible_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin incomprehension_N = mkWN (compoundN "käsitys" (k40 "kyvyttömyys")) ; --UNCHK
lin incompressibility_N = mkWN "kokoonpuristumattomuus" ; --UNCHK
lin incompressible_A = mkWA "puristumaton" ; --UNCHK
lin incomputable_A = mkWA (k34A "lukematon") ; --UNCHK
lin inconceivability_N = mkWN (k40 "käsittämättömyys") ; --UNCHK
lin inconceivable_A = mkWA (k34A "uskomaton") ; --UNCHK
lin inconclusive_A = mkWA (k10 "ratkaiseva") "ei" ; --UNCHK
lin inconclusiveness_N = mkWN "tuloksettomuus" ; --UNCHK
lin incongruent_A = mkWA (compoundA "epä" (k5A "kongruentti")) ; --UNCHK
lin incongruity_N = mkWN (compoundN "risti" (k9A "riita")) ; --UNCHK
lin incongruous_A = mkWA (k34A "sopimaton") "tilanteeseen" ; --UNCHK
lin inconsequence_N = mkWN (compoundN "epä" (k40 "loogisuus")) ; --UNCHK
lin inconsequent_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin inconsequential_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin inconsiderable_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin inconsiderate_A = mkWA (k34A "tahditon") ; --UNCHK
lin inconsideration_N = mkWN (k40 "harkitsemattomuus") ; --UNCHK
lin inconsistency_N = mkWN "epäjohdonmukaisuus" ; --UNCHK
lin inconsistent_A = mkWA "epäjohdonmukainen" ; --UNCHK
lin inconsolable_A = mkWA (k38 "murheellinen") ; --UNCHK
lin inconspicuous_A = mkWA (k34A "näkymätön") ; --UNCHK
lin inconspicuousness_N = mkWN (k40 "huomaamattomuus") ; --UNCHK
lin inconstancy_N = mkWN (k40 "muuttuvuus") ; --UNCHK
lin inconstant_A = mkWA (k38 "muuttuvainen") ; --UNCHK
lin incontestable_A = mkWA (k34A "eittämätön") ; --UNCHK
lin incontinence_N = mkWN (k40 "huikentelevuus") ; --UNCHK
lin incontinent_A = mkWA (compoundA "pidätys" (k34A "kyvytön")) ; --UNCHK
lin incontrovertibility_N = mkWN (k40 "luotettavuus") ; --UNCHK
lin incontrovertible_A = mkWA (k34A "kiistämätön") ; --UNCHK
lin inconvenience_N = mkWN (k9 "vaiva") ; --UNCHK
lin inconvenient_A = mkWA (k34A "sopimaton") ; --UNCHK
lin inconvertibility_N = mkWN (compoundN "vaihto" (k40 "kelvottomuus")) ; --UNCHK
lin inconvertible_A = mkWA (compoundA "vaihto" (k34A "kelvoton")) ; --UNCHK
lin incoordination_N = mkWN (compoundN "koordinaatio" (k3 "häiriö")) ; --UNCHK
lin incorporate_A = mkWA (k1A "yhdistetty") ; --UNCHK
lin incorporate_V2 = mkWV2 (k53A "sisällyttää") ;
lin incorporation_N = mkWN (compoundN "sisä" (k38 "llyttäminen")) ; --UNCHK
lin incorporative_A = mkWA "liittävä" ; --UNCHK
lin incorporeal_A = mkWA (k34A "aineeton") ; --UNCHK
lin incorrect_A = mkWA (k10 "väärä") ; --UNCHK
lin incorrectness_N = mkWN (k40 "vääryys") ; --UNCHK
lin incorrigible_A = mkWA (k34A "parantumaton") ; --UNCHK
lin incorrupt_A = mkWA (k34A "turmeltumaton") ; --UNCHK
lin incorruptibility_N = mkWN "korruptoitumattomuus" ; --UNCHK
lin incorruptible_A = mkWA (k34A "lahjomaton") ; --UNCHK
lin incorruptness_N = mkWN (k40 "turmeltumattomuus") ; --UNCHK
lin increase_N = mkN "nousu" ;
lin increase_V = mkV "kasvaa" ;
lin increase_V2 = mkV2 "lisätä" partitive ;
lin increased_A = mkA "lisääntynyt" ;
lin increasing_A = mkA "lisääntyvä" ;
lin increasingly_AdA = mkAdA "enenevästi" ;
lin increasingly_AdV = mkAdV "enenevästi" ;
lin increasingly_Adv = mkWAdv (k99 "enemmän") "yhä" ; --f80
lin incredibility_N = mkWN (k40 "uskomattomuus") ; --UNCHK
lin incredible_A = mkWA (k34A "uskomaton") ;
lin incredulity_N = mkWN (k39 "epäilys") ; --UNCHK
lin incredulous_A = mkWA (k38 "skeptinen") ; --UNCHK
lin increment_N = mkWN (k39 "lisäys") ; --UNCHK
lin incremental_A = mkWA (compoundA "inkre" (k38 "mentaalinen")) ; --UNCHK
lin incriminate_V2 = mkWV2 (k53A "syyttää") "rikoksesta" ; --UNCHK
lin incriminatingly_Adv = mkWAdv (compoundAdv "rask" (k99 "auttavasti")) ; --UNCHK
lin incrimination_N = mkWN (kH1 "vika") ; --UNCHK
lin incrustation_N = mkWN (kH1 "kuori") ; --UNCHK
lin incubate_V = mkWV (k73 "suojata") ; --UNCHK
lin incubate_V2 = mkWV2 (k73 "suojata") ; --UNCHK
lin incubation_N = mkWN (compoundN "hau" (k38 "tominen")) ; --UNCHK
lin incubator_N = mkWN (compoundN "keskos" (k5A "kaappi")) ; --UNCHK
lin incubus_N = mkWN (k5 "demoni") "miespuolinen" ; --UNCHK
lin inculcate_V2 = mkWV2 (k56 "valaa") ; --UNCHK
lin inculcation_N = mkWN (compoundN "juu" (k38 "rruttaminen")) ; --UNCHK
lin inculpate_V2 = mkWV2 (k53A "väittää") "syylliseksi" ; --UNCHK
lin inculpatory_A = mkWA "syylliseksi" "osoittava" ; --UNCHK
lin incumbency_N = mkWN "viranhaltijuus" ; --UNCHK
lin incumbent_A = mkWA (k10 "oleva") "virassa" ; --UNCHK
lin incumbent_N = mkWN (compoundN "virka" (k42 "mies")) ; --UNCHK
lin incur_V2 = mkV2 (lin VK {s = c53A "aiheuttaa"}) ;
lin incurability_N = mkWN (k40 "parantumattomuus") ; --UNCHK
lin incurable_A = mkWA (k34A "parantumaton") ; --UNCHK
lin incurable_N = mkWN (k41 "sairas") "parantumattomasti" ; --UNCHK
lin incurring_N = mkWN "ottaminen" ; --UNCHK
lin incursion_N = mkWN "tunkeutuminen" ; --UNCHK
lin incursive_A = mkWA (k10 "hyökkäävä") ; --UNCHK
lin incurvate_A = mkWA "kaartunut" ; --UNCHK
lin incurvation_N = mkWN "kaartuminen" ; --UNCHK
lin incurved_A = mkWA "kaartunut" ; --UNCHK
lin incus_N = mkWN (k33 "alasin") ; --UNCHK
lin indaba_N = mkWN (k2 "neuvottelu") ; --UNCHK
lin indapamide_N = mkWN (k5 "indapamidi") ; --UNCHK
lin indebted_A = mkWA (k10 "oleva") "kiitollisuudenvelassa" ; --UNCHK
lin indebtedness_N = mkWN (compoundN "kiitollisuuden" (k9A "velka")) ; --UNCHK
lin indecency_N = mkWN (k40 "sopimattomuus") ; --UNCHK
lin indecent_A = mkWA (k34A "säädytön") ; --UNCHK
lin indecipherable_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin indecision_N = mkWN (k40 "päättämättömyys") ; --UNCHK
lin indecisive_A = mkWA (k34A "ratkaisematon") ; --UNCHK
lin indecisiveness_N = mkWN (k40 "päättämättömyys") ; --UNCHK
lin indecorous_A = mkWA (k34A "tahditon") ; --UNCHK
lin indecorum_N = mkWN (k40 "vapaus") ; --UNCHK
lin indeed_AdV = lin AdV (ss "todella") ;
lin indeed_Adv = mkAdv "tosiaan" ;
lin indefatigability_N = mkWN (k40 "uupumattomuus") ; --UNCHK
lin indefatigable_A = mkWA (k34A "uupumaton") ; --UNCHK
lin indefeasible_A = mkWA (k34A "peruuttamaton") ; --UNCHK
lin indefensible_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin indefinable_A = mkWA (k34A "määrittelemätön") ; --UNCHK
lin indefinite_A = mkWA (k38 "ylimalkainen") ; --UNCHK
lin indefiniteness_N = mkWN (k40 "häilyvyys") ; --UNCHK
lin indehiscent_A = mkWA "aukeamaton" ; --UNCHK
lin indelible_A = mkWA (k34A "unohtumaton") ; --UNCHK
lin indelicacy_N = mkWN (k40 "tahdittomuus") ; --UNCHK
lin indelicate_A = mkWA (k34A "tahditon") ; --UNCHK
lin indemnification_N = mkWN (k39 "hyvitys") ; --UNCHK
lin indemnify_V2 = mkWV2 (k53A "hyvittää") ; --UNCHK
lin indemnity_N = mkWN (k39 "korvaus") ; --UNCHK
lin indene_N = mkWN "indeeni" ; --UNCHK
lin indent_N = mkWN (k39 "sisennys") ; --UNCHK
lin indent_V = mkWV (k53A "kiinnittää") ; --UNCHK
lin indent_V2 = mkWV2 (k53A "kiinnittää") ; --UNCHK
lin indentation_N = mkWN (k39 "hammastus") ; --UNCHK
lin indenture_N = mkWN (k39 "sisennys") ; --UNCHK
lin indenture_V2 = mkWV2 (k53A "kiinnittää") ; --UNCHK
lin independence_N = mkWN (k40 "itsenäisyys") "Yhdysvaltain" ; --UNCHK
lin independent_1_A = mkA "riippumaton" ;
lin independent_2_A = mkA "itsenäinen" ;
lin independent_A = mkWA (k38 "itsenäinen") ;
lin independent_N = mkWN (k10 "toimittaja") "vapaa" ; --UNCHK
lin indescribable_A = mkWA (k34A "sanomaton") ; --UNCHK
lin indestructibility_N = mkWN "tuhoutumattomuus" ; --UNCHK
lin indestructible_A = mkWA "tuhoutumaton" ; --UNCHK
lin indeterminacy_N = mkWN (k40 "häilyvyys") ; --UNCHK
lin indeterminate_A = mkWA (k34A "tuntematon") ; --UNCHK
lin index_N = mkN (lin NK {s = d05 "indeksi"}) ;
lin index_V2 = mkWV2 (k62 "indeksoida") ; --UNCHK
lin indexation_N = mkWN (compoundN "indek" (k5A "sointi")) ; --UNCHK
lin indexer_N = mkWN "kortistoija" ;
lin indexical_A = mkWA (compoundA "hake" (k38 "mistollinen")) ; --UNCHK
lin indexing_N = mkWN (compoundN "indek" (k5A "sointi")) ; --UNCHK
lin indexless_A = mkWA "indeksitön" ; --UNCHK
lin india_PN = foreignPN "Intia" ;
lin india_rubber_N = mkWN (k1 "kautsu") ; --UNCHK
lin indiaman_N = mkWN "Indiaman" ; --UNCHK
lin indianFem_1_N = mkN "intialainen" ;
lin indianFem_2_N = mkN "intiaani" ;
lin indianMasc_1_N = mkN "intialainen" ;
lin indianMasc_2_N = mkN "intiaani" ;
lin indian_A = mkA "intialainen" ;
lin indiana_PN = foreignPN "Indiana" ;
lin indianapolis_PN = foreignPN "Indianapolis" ;
lin indicate_V2 = mkWV2 (k53A "osoittaa") ;
lin indicate_VS = mkWVS (k53A "osoittaa") ;
lin indication_N = mkN "merkki" ; --f61
lin indicative_A = mkWA "deklaratiivinen" ; --UNCHK
lin indicator_N = mkWN (k6 "mittari") ; --f57
lin indict_V = mkWV (k53A "syyttää") ;
lin indict_V2 = mkWV2 (k53A "syyttää") ; --UNCHK
lin indictable_A = mkWA (k38 "alainen") "syytteen" ; --UNCHK
lin indiction_N = mkWN "indiktio" ; --UNCHK
lin indictment_N = mkN (lin NK {s = d48A "syyte"}) ;
lin indie_N = mkWN (compoundN "levy-" (k3 "yhtiö")) "riippumaton" ; --UNCHK
lin indifference_N = mkWN (k40 "hengettömyys") ; --UNCHK
lin indifferent_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin indigence_N = mkWN (k40 "köyhyys") ; --UNCHK
lin indigenous_A = mkWA (k38 "kotimainen") ; --UNCHK
lin indigenousness_N = mkWN (k40 "endeemisyys") ; --UNCHK
lin indigent_A = mkWA (k34A "varaton") ; --UNCHK
lin indigestibility_N = mkWN (k40 "sulavuus") "huonosti" ; --UNCHK
lin indigestible_A = mkWA "sulamaton" ; --UNCHK
lin indigestion_N = mkWN (compoundN "maha" (k5A "tauti")) ; --UNCHK
lin indignation_N = mkWN (k39 "suuttumus") ; --UNCHK
lin indignity_N = mkWN (k39 "nöyryytys") ; --UNCHK
lin indigo_A = mkWA (compoundA "indigon" (k38 "sininen")) ; --UNCHK
lin indigo_N = mkWN (compoundN "indigon" (k38 "sininen")) ; --UNCHK
lin indinavir_N = mkWN (compoundN "indina" (k5 "viiri")) ; --UNCHK
lin indirect_A = mkWA (compoundA "epä" (k10 "suora")) ; --UNCHK
lin indirection_N = mkWN (k40 "petollisuus") ; --UNCHK
lin indirectness_N = mkWN (compoundN "epä" (k40 "suoruus")) ; --UNCHK
lin indiscernible_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin indiscipline_N = mkWN (k40 "tottelemattomuus") ; --UNCHK
lin indiscreet_A = mkWA (k34A "sopimaton") ; --UNCHK
lin indiscrete_A = mkWA (k34A "jakamaton") ; --UNCHK
lin indiscretion_N = mkWN (k39 "hairahdus") ; --UNCHK
lin indiscriminate_A = mkWA (k38 "umpimähkäinen") ; --UNCHK
lin indispensability_N = mkWN (k40 "tarpeellisuus") ; --UNCHK
lin indispensable_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin indisposed_A = mkWA (k34A "haluton") ; --UNCHK
lin indisposition_N = mkWN (k40 "innottomuus") ; --UNCHK
lin indisputability_N = mkWN (k40 "kiistattomuus") ; --UNCHK
lin indisputable_A = mkWA (k9 "varma") ; --UNCHK
lin indissoluble_A = mkWA (k34A "liukenematon") ; --UNCHK
lin indistinct_A = mkWA (compoundA "epä" (k10 "selvä")) ; --UNCHK
lin indistinctness_N = mkWN (k40 "hämäryys") ; --UNCHK
lin indistinguishable_A = mkA (mkN "mahdoton erottaa") ; ----sanaliitto ; head word 'mahdoton'
lin indite_V2 = mkWV2 (k67 "kynäillä") ; --UNCHK
lin indium_N = mkWN (k5 "indium") ; --UNCHK
lin individual_A = mkA "yksilöllinen" ;
lin individual_N = mkN "yksilö" ;
lin individualism_N = mkWN (k5 "individualismi") ; --UNCHK
lin individualist_A = mkWA (k38 "individualistinen") ; --UNCHK
lin individualist_N = mkWN (k5 "individualisti") ; --UNCHK
lin individualistic_A = mkWA (k10 "salliva") ; --UNCHK
lin individuality_N = mkWN (k40 "yksilöllisyys") ; --UNCHK
lin individualization_N = mkWN (compoundN "yks" (k38 "ilöiminen")) ; --UNCHK
lin individualize_V2 = mkWV2 (k53 "yksilöllistää") ; --UNCHK
lin indivisible_A = mkWA (k34A "jakamaton") ; --UNCHK
lin indocile_A = mkWA (k34A "vallaton") ; --UNCHK
lin indoctrinate_V2 = mkWV2 (k53 "iskostaa") ; --UNCHK
lin indoctrination_N = mkWN (k3 "indoktrinaatio") ; --UNCHK
lin indolence_N = mkWN (k40 "laiskuus") ; --UNCHK
lin indolent_A = mkWA "indolentti" ; --UNCHK
lin indomethacin_N = mkWN "Indometin" ; --UNCHK
lin indomitability_N = mkWN (k40 "voittamattomuus") ; --UNCHK
lin indomitable_A = mkWA (k34A "peräänantamaton") ; --UNCHK
lin indonesia_PN = foreignPN "Indonesia" ;
lin indonesian_A = mkWA (compoundA "indonesi" (k38 "alainen")) ; --UNCHK
lin indonesian_N = mkWN "Bahasa" ; --UNCHK
lin indoor_A = mkWA "sisä-" ; --UNCHK
lin indoors_Adv = mkWAdv (k99 "sisällä") ; --UNCHK
lin indore_PN = foreignPN "Indore" ;
lin indorse_V2 = mkWV2 (k52 "hyväksyä") ; --UNCHK
lin indrawn_A = mkWA (k47 "sulkeutunut") ; --UNCHK
lin indri_N = mkWN "Indri" "brevicaudatus" ; --UNCHK
lin indubitable_A = mkWA (kH1 "ilmeinen") ; --UNCHK
lin induce_V2 = mkWV2 (k67A "päätellä") ; --UNCHK
lin inducement_N = mkWN (k38 "saaminen") "aikaan" ; --UNCHK
lin inducer_N = mkWN "suostuttelija" ; --UNCHK
lin induct_V2 = mkWV2 (k53A "perehdyttää") ; --UNCHK
lin inductee_N = mkWN (compoundN "ase" (k38 "velvollinen")) ; --UNCHK
lin induction_N = mkWN (compoundN "alku" (k39 "sysäys")) ; --UNCHK
lin inductive_A = mkWA (compoundA "päätte" (k10 "levä")) ; --UNCHK
lin indue_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin indulge_V = mkWV (k52A "sortua") ; --UNCHK
lin indulge_V2 = mkWV2 (k52A "sortua") ; --UNCHK
lin indulgence_N = mkWN (k48 "ane") ; --UNCHK
lin indulgent_A = mkWA (compoundA "avo" (k38 "kätinen")) ; --UNCHK
lin indumentum_N = mkWN "indumentum" ; --UNCHK
lin indusial_A = mkWA "katesuomuun" "liittyvä" ; --UNCHK
lin indusium_N = mkWN (compoundN "kate" (k1 "suomu")) ; --UNCHK
lin industrial_A = mkA "teollinen" ;
lin industrialism_N = mkWN (k5 "industrialismi") ; --UNCHK
lin industrialist_N = mkWN (compoundN "teollisuuden" (k10 "harjoittaja")) ; --UNCHK
lin industrialization_N = mkWN (compoundN "teollisuus" (k39 "laitos")) ; --UNCHK
lin industrialize_V2 = mkV2 "teollistaa" ; --mkWV2 (k52 "teollistua") ;
lin industrious_A = mkWA (k34A "uupumaton") ; --UNCHK
lin industry_N = L.industry_N ;
lin indweller_N = mkWN (k5A "asukki") ; --UNCHK
lin indwelling_A = mkWA (compoundA "läsnä" (k10 "oleva")) ; --UNCHK
lin inebriate_N = mkWN (k38 "humalainen") ; --UNCHK
lin inebriate_V2 = mkWV2 (k67A "juopotella") ; --UNCHK
lin inebriation_N = mkWN (k14A "hiprakka") ; --UNCHK
lin inebriety_N = mkWN (k14A "hiprakka") ; --UNCHK
lin inedible_A = mkWA (compoundA "syömä" (k34A "kelvoton")) ; --UNCHK
lin ineffable_A = mkWA (k34A "sanomaton") ; --UNCHK
lin ineffective_A = mkWA (k34A "pystymätön") ; --UNCHK
lin ineffectiveness_N = mkWN (k40 "tehottomuus") ; --UNCHK
lin ineffectual_A = mkWA (k34A "pystymätön") ; --UNCHK
lin ineffectuality_N = mkWN (k40 "tehottomuus") ; --UNCHK
lin inefficacious_A = mkWA (k34A "tehoton") ; --UNCHK
lin inefficacy_N = mkWN (k40 "tehottomuus") ; --UNCHK
lin inefficiency_N = mkWN (k40 "tehottomuus") ;
lin inefficient_A = mkWA (k34A "tehoton") ;
lin inelaborate_A = mkWA (compoundA "epä" (k9A "tarkka")) ; --UNCHK
lin inelastic_A = mkWA (k34A "joustamaton") ; --UNCHK
lin inelasticity_N = mkWN (compoundN "epä" (k40 "elastisuus")) ; --UNCHK
lin inelegance_N = mkWN (k40 "tyylittömyys") ; --UNCHK
lin inelegant_A = mkWA (k34A "tyylitön") ; --UNCHK
lin ineligibility_N = mkWN "kelpaamattomuus" ; --UNCHK
lin ineligible_A = mkWA (k1A "oikeutettu") "ei" ; --UNCHK
lin ineloquently_Adv = mkWAdv (compoundAdv "epä" (k99 "selvästi")) ; --UNCHK
lin ineluctability_N = mkWN (k40 "vääjäämättömyys") ; --UNCHK
lin ineluctable_A = mkWA (k34A "väistämätön") ; --UNCHK
lin inept_A = mkWA (k34A "tahditon") ; --UNCHK
lin ineptitude_N = mkWN (k40 "taitamattomuus") ; --UNCHK
lin inequality_N = mkWN "epätasa-arvo" ; --UNCHK
lin inequitable_A = mkWA (k34A "oikeudeton") ; --UNCHK
lin inequity_N = mkWN (compoundN "epä" (k40 "reiluus")) ; --UNCHK
lin ineradicable_A = mkWA (k34A "lähtemätön") ; --UNCHK
lin inerrable_A = mkWA (k34A "erehtymätön") ; --UNCHK
lin inerrancy_N = mkWN (k40 "erehtymättömyys") ; --UNCHK
lin inert_A = mkWA (k1A "veltto") ; --UNCHK
lin inertia_N = mkWN (k40 "velttous") ; --UNCHK
lin inertial_A = mkWA "jatkavuus-" ; --UNCHK
lin inertness_N = mkWN (k40 "liikkumattomuus") ; --UNCHK
lin inescapable_A = mkWA (k34A "väistämätön") ; --UNCHK
lin inessential_A = mkWA (k34A "tarpeeton") ; --UNCHK
lin inessential_N = mkWN (k40 "tarpeettomuus") ; --UNCHK
lin inessentiality_N = mkWN (compoundN "tois" (k40 "arvoisuus")) ; --UNCHK
lin inestimable_A = mkWA (k34A "lukematon") ; --UNCHK
lin inevitability_N = mkWN (k40 "vääjäämättömyys") ; --UNCHK
lin inevitable_A = mkWA (k34A "vääjäämätön") ; --UNCHK
lin inevitable_N = mkWN (k12 "asia") "väistämätön" ; --UNCHK
lin inexact_A = mkWA (compoundA "epä" (k38 "täsmällinen")) ; --UNCHK
lin inexactitude_N = mkWN (compoundN "epä" (k40 "täsmällisyys")) ; --UNCHK
lin inexactness_N = mkWN (compoundN "epä" (k40 "täsmällisyys")) ; --UNCHK
lin inexcusable_A = mkWA (k34A "anteeksiantamaton") ; --UNCHK
lin inexhaustible_A = mkWA (k34A "ehtymätön") ; --UNCHK
lin inexorable_A = mkWA (k34A "peräänantamaton") ; --UNCHK
lin inexpedience_N = mkWN (compoundN "epä" (k40 "käytännöllisyys")) ; --UNCHK
lin inexpediency_N = mkWN (compoundN "epä" (k40 "käytännöllisyys")) ; --UNCHK
lin inexpedient_A = mkWA (compoundA "epä" (k41 "viisas")) ; --UNCHK
lin inexpensive_A = mkWA (k38 "edullinen") ; --UNCHK
lin inexpensiveness_N = mkWN (k40 "edullisuus") ; --UNCHK
lin inexperience_N = mkWN (k40 "raakuus") ; --UNCHK
lin inexperienced_A = mkWA (k34A "kokematon") ; --UNCHK
lin inexpert_A = mkWA (k34A "taitamaton") ; --UNCHK
lin inexpiable_A = mkWA (k34A "sovittamaton") ; --UNCHK
lin inexplicable_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin inexplicitness_N = mkWN (compoundN "epä" (k40 "selvyys")) ; --UNCHK
lin inexpressible_A = mkWA (k34A "sanomaton") ; --UNCHK
lin inexpressive_A = mkWA (k34A "ilmeetön") ; --UNCHK
lin inexpungible_A = mkWA "poispyyhkimätön" ; --UNCHK
lin inextinguishable_A = mkWA (k34A "sammumaton") ; --UNCHK
lin inextricable_A = mkWA (k34A "erottamaton") ; --UNCHK
lin infallibility_N = mkWN (k40 "erehtymättömyys") ; --UNCHK
lin infallible_A = mkWA (k34A "erehtymätön") ; --UNCHK
lin infamous_A = mkWA (k34A "kunniaton") ; --UNCHK
lin infamy_N = mkWN (k40 "pahamaineisuus") ; --UNCHK
lin infancy_N = mkWN (compoundN "vauva" (k10A "ikä")) ; --UNCHK
lin infant_N = mkN "pikku" (mkN "lapsi") ; --mkWN (k38 "pienokainen") ;
lin infanticide_N = mkWN (compoundN "lapsen" (k10 "murha")) ; --UNCHK
lin infantile_A = mkWA "lapsuusajan" ; --UNCHK
lin infantilism_N = mkWN (k40 "lapsellisuus") ; --UNCHK
lin infantry_N = mkWN (compoundN "jalka" (k7A "väki")) ; --UNCHK
lin infantryman_N = mkWN (k12 "marssija") ; --UNCHK
lin infarct_N = mkWN (k5 "infarkti") ; --UNCHK
lin infatuate_V2 = mkWV2 (k53A "hullaannuttaa") ; --UNCHK
lin infatuation_N = mkWN (k48A "kohde") "hullaantumisen" ; --UNCHK
lin infeasibility_N = mkWN (compoundN "epä" (k40 "käytännöllisyys")) ; --UNCHK
lin infect_V = mkV "tarttua" ;
lin infect_V2 = mkV2 "tartuttaa" | mkWV2 (k53A "saastuttaa") ;
lin infected_A = mkA "tulehtunut" ;
lin infection_N = mkWN (k9A "tartunta") ;
lin infectious_A = mkWA "tarttuva" ;
lin infective_A = mkWA (k38 "patogeeninen") ; --UNCHK
lin infelicitous_A = mkWA "huonosti" "valittu" ; --UNCHK
lin infelicity_N = mkWN (k12 "asia") "huonosti" "valittu" ; --UNCHK
lin infer_V2 = mkWV2 (k52 "uskoa") ; --UNCHK
lin inference_N = mkWN (k2 "päättely") ;
lin inferential_A = mkWA (compoundA "päätte" (k10 "levä")) ; --UNCHK
lin inferior_A = mkA (mkN "alempi" (mkN "arvoinen")) ;
lin inferior_N = mkWN (k5 "indeksi") ; --UNCHK
lin inferiority_N = mkWN (k1A "laatu") "alempi" ; --UNCHK
lin infernal_A = mkWA "helvetin" ; --UNCHK
lin infernal_N = mkWN (k41A "asukas") "helvetin" ; --UNCHK
lin inferno_N = mkWN (k1 "kuilu") "hornan" ; --UNCHK
lin infertile_A = mkWA (k1 "maho") ; --UNCHK
lin infertility_N = mkWN (k5A "steriliteetti") ; --UNCHK
lin infest_V2 = mkWV2 (k66 "vilistä") ; --UNCHK
lin infestation_N = mkWN (k39 "vitsaus") ; --UNCHK
lin infidel_N = mkWN (k12 "pakana") ; --UNCHK
lin infidelity_N = mkWN (k40 "uskottomuus") ; --UNCHK
lin infield_N = mkWN (compoundN "etu" (k10A "kenttä")) ; --UNCHK
lin infielder_N = mkWN "etukenttäpelaaja" ; --UNCHK
lin infiltrate_V = mkWV (k67 "mennä") "läpi" ; --UNCHK
lin infiltrate_V2 = mkWV2 (k67 "mennä") "läpi" ; --UNCHK
lin infiltration_N = mkWN (compoundN "solu" (k38 "ttautuminen")) ; --UNCHK
lin infiltrator_N = mkWN (k10 "tunkeutuja") ; --UNCHK
lin infinite_A = mkWA (k34A "rajaton") ; --UNCHK
lin infiniteness_N = mkWN (k40 "suunnattomuus") ; --UNCHK
lin infinitesimal_A = mkWA (k26 "pieni") "äärettömän" ; --UNCHK
lin infinitival_A = mkWA "infinitiivi-" ; --UNCHK
lin infinitive_N = mkWN (k5 "infinitiivi") ; --UNCHK
lin infinitude_N = mkWN (k40 "suunnattomuus") ; --UNCHK
lin infinity_N = mkWN (k40 "äärettömyys") ; --UNCHK
lin infirm_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin infirmary_N = mkWN (k13 "sairaala") ; --UNCHK
lin infirmity_N = mkWN (k40 "sairaalloisuus") ; --UNCHK
lin infix_N = mkWN (compoundN "sisä" (k48A "liite")) ; --UNCHK
lin inflame_V = mkWV (k52A "tulehtua") ; --UNCHK
lin inflame_V2 = mkWV2 (k52A "tulehtua") ; --UNCHK
lin inflammable_A = mkWA (k10 "palava") ; --UNCHK
lin inflammation_N = mkWN (k39 "sytytys") ; --UNCHK
lin inflammatory_A = mkWA (k38 "tulehduksellinen") ; --UNCHK
lin inflatable_A = mkWA "puhallettava" ; --UNCHK
lin inflate_V = mkWV (k52A "täyttyä") ; --UNCHK
lin inflate_V2 = mkV2 "täyttää" ; --mkWV2 (k52A "täyttyä") ;
lin inflater_N = mkWN (k1A "pumppu") ; --UNCHK
lin inflation_N = mkN "inflaatio" ;
lin inflationary_A = mkWA (k38 "inflatorinen") ; --UNCHK
lin inflect_V2 = mkWV2 (k53A "muuttaa") "äänensävyä" ; --UNCHK
lin inflection_N = mkWN (compoundN "äänen" (k2 "vaihtelu")) ; --UNCHK
lin inflectional_A = mkWA (compoundA "tai" (k38 "vutuksellinen")) ; --UNCHK
lin inflexibility_N = mkWN (k40 "ankaruus") ; --UNCHK
lin inflexible_A = mkWA (k34A "taipumaton") ; --UNCHK
lin inflexion_N = mkWN (k39 "taivutus") ; --UNCHK
lin inflict_V2 = mkWV2 (k53A "tyrkyttää") ; --UNCHK
lin infliction_N = mkWN (compoundN "aihe" (k38 "uttaminen")) ; --UNCHK
lin infliximab_N = mkWN (compoundN "infliksim" (k5 "abi")) ; --UNCHK
lin inflorescence_N = mkWN (k1A "kukinto") ; --UNCHK
lin inflow_N = mkWN (compoundN "sisään" (k39 "virtaus")) ;
lin inflowing_A = mkWA (compoundA "virt" (k9 "aava")) "sisään" ; --UNCHK
lin influence_N = mkWN (k39 "vaikutus") ;
lin influence_V2 = mkWV2 (k67A "säännellä") ; --UNCHK
lin influential_A = mkWA (compoundA "vaikutus" (k38 "valtainen")) ; --UNCHK
lin influenza_N = mkWN (k10 "flunssa") ; --UNCHK
lin influx_N = mkWN (compoundN "sisään" (k39 "virtaus")) ;
lin info_N = mkWN (k1 "info") ; --UNCHK
lin infomercial_N = mkWN (compoundN "mainos" (k10 "pätkä")) ; --UNCHK
lin inform_V = mkV "tiedottaa" ;
lin inform_V2 = mkV2 (mkV "informoida") partitive ;
lin informal_A = mkWA (compoundA "epä" (k38 "virallinen")) ; --UNCHK
lin informality_N = mkWN (k40 "luontevuus") ; --UNCHK
lin informant_N = mkWN (k48A "lähde") ; --UNCHK
lin information_N = mkN "informaatio" ;
lin informational_A = mkWA "tieto-" ; --UNCHK
lin informative_A = mkWA (k38 "informatiivinen") ; --UNCHK
lin informer_N = mkWN (k1A "lörppö") ; --UNCHK
lin informing_N = mkWN (k5A "informointi") ; --UNCHK
lin infra_Adv = mkWAdv (k99 "alempana") ; --UNCHK
lin infra_dig_A = mkWA (compoundA "ala" (k38 "puolinen")) "arvon" ; --UNCHK
lin infraction_N = mkWN (k39 "rikos") "lievä" ; --UNCHK
lin infrahuman_A = mkWA (k16A "alempi") "ihmistä" ; --UNCHK
lin infra_red_A = mkWA "infrapuna-" ; --UNCHK
lin infrared_N = mkWN (compoundN "infrapuna" (k2 "säteily")) ; --UNCHK
lin infrasonic_A = mkWA "infraääni-" ; --UNCHK
lin infrastructure_N = mkN "infrastruktuuri" ; --WN (k10 "pohja") ;
lin infrequency_N = mkWN (k40 "harvinaisuus") ; --UNCHK
lin infrequent_A = mkWA (k38 "harvinainen") ; --UNCHK
lin infringe_V = mkV (mkV "tulla") "loukatuksi" ;
lin infringe_V2 = mkWV2 (k73A "loukata") partitive ;
lin infringement_N = mkWN (k39 "rikos") "lievä" ;
lin infructescence_N = mkWN (k1 "hedelmistö") ; --UNCHK
lin infundibulum_N = mkWN (k2 "suppilo") ; --UNCHK
lin infuriate_V2 = mkWV2 (k53A "suututtaa") ; --UNCHK
lin infuriation_N = mkWN (k1 "raivo") ; --UNCHK
lin infuse_V = mkWV "infundoida" ; --UNCHK
lin infuse_V2 = mkWV2 "infundoida" ; --UNCHK
lin infusion_N = mkWN (compoundN "lisä" (k38 "äminen")) ; --UNCHK
lin infusorian_N = mkWN (compoundN "liko" (k33 "eläin")) ; --UNCHK
lin inga_N = mkWN "inga" ; --UNCHK
lin ingatestone_PN = foreignPN "Ingatestone" ;
lin ingathering_N = mkWN (k39 "keräys") ; --UNCHK
lin ingenious_A = mkWA (k10 "terävä") ; --UNCHK
lin ingenuity_N = mkWN (k40 "nokkeluus") ; --UNCHK
lin ingenuous_A = mkWA (k34A "teeskentelemätön") ; --UNCHK
lin ingenuousness_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin ingest_V2 = mkWV2 (k53 "sisäistää") ; --UNCHK
lin ingesta_N = mkWN (k1A "ravinto") ; --UNCHK
lin inglorious_A = mkWA (k34A "kunniaton") ; --UNCHK
lin ingot_N = mkWN (k1A "harkko") ; --UNCHK
lin ingraft_V2 = mkWV2 (k56A "varttaa") ; --UNCHK
lin ingrate_N = mkWN (k39 "lurjus") "kiittämätön" ; --UNCHK
lin ingratiate_V2 = mkWV2 (k67 "mielistellä") ; --UNCHK
lin ingratiating_A = mkWA (compoundA "mieliste" (k10 "levä")) ; --UNCHK
lin ingratiation_N = mkWN (k2 "vihjailu") ; --UNCHK
lin ingratitude_N = mkWN (k40 "kiittämättömyys") ; --UNCHK
lin ingredient_N = mkWN (k39 "aines") ;
lin ingress_N = mkWN (compoundN "sisään" (k1 "tulo")) ; --UNCHK
lin ingrowing_A = mkWA "sisään" "kasvava" ; --UNCHK
lin ingrowth_N = mkWN (k12 "asia") "sisäänpäin" "kasvava" ; --UNCHK
lin inguinal_A = mkWA "nivus-" ; --UNCHK
lin ingå_PN = mkPN "Inkoo" ;
lin inhabit_V2 = mkWV2 (k67 "elellä") ; --UNCHK
lin inhabitable_A = mkWA (compoundA "asuin" (k38 "kelpoinen")) ; --UNCHK
lin inhabitancy_N = mkWN (compoundN "asu" (k38 "minen")) ; --UNCHK
lin inhabitant_N = mkN "asukas" ;
lin inhalant_A = mkWA "hengittävä" ; --UNCHK
lin inhalant_N = mkWN (k48A "lääke") "hengitettävä" ; --UNCHK
lin inhalation_N = mkWN (k3 "inhalaatio") ; --UNCHK
lin inhale_V = mkWV (k53A "hengittää") "sisään" ; --UNCHK
lin inhale_V2 = mkWV2 (k53A "hengittää") "sisään" ; --UNCHK
lin inhaler_N = mkWN (k6 "inhalaattori") ; --UNCHK
lin inharmonious_A = mkWA (compoundA "epä" (k38 "sointuinen")) ; --UNCHK
lin inherence_N = mkWN (k40 "synnynnäisyys") ; --UNCHK
lin inherent_A = mkWA "kätketty" ; --UNCHK
lin inherit_V = mkWV (k61 "periä") ; --UNCHK
lin inherit_V2 = mkWV2 (k61 "periä") ; --also mkV2 "periä" partitive ;
lin inheritable_A = mkWA (k38 "perinnöllinen") ; --UNCHK
lin inheritance_N = mkWN (k1A "perintö") ; --UNCHK
lin inheritorFem_N = variants {} ; ---- sense to be split
lin inheritorMasc_N = mkWN (k12 "perijä") ; --UNCHK
lin inhibit_V2 = mkV2 "estää" partitive ;
lin inhibition_N = mkWN (k1A "kielto") ; --UNCHK
lin inhibitor_N = mkWN (k6 "inhibiittori") ; --UNCHK
lin inhibitory_A = mkWA (compoundA "ehkäis" (k10 "evä")) ; --UNCHK
lin inhomogeneity_N = mkWN (compoundN "epä" (k40 "yhtenäisyys")) ; --UNCHK
lin inhomogeneous_A = mkWA (compoundA "epä" (k38 "yhtenäinen")) ; --UNCHK
lin inhospitable_A = mkWA (k1 "karu") ; --UNCHK
lin inhospitableness_N = mkWN "epävieraanvaraisuus" ; --UNCHK
lin inhospitality_N = mkWN "epävieraanvaraisuus" ; --UNCHK
lin inhuman_A = mkWA (compoundA "epä" (k38 "inhimillinen")) ; --UNCHK
lin inhumane_A = mkWA (k10 "julma") ; --UNCHK
lin inhumaneness_N = mkWN (k40 "julmuus") ; --UNCHK
lin inhumanity_N = mkWN (k40 "julmuus") ; --UNCHK
lin inimical_A = mkWA (k15 "ynseä") ; --UNCHK
lin inimitable_A = mkWA (k34A "jäljittelemätön") ; --UNCHK
lin inion_N = mkWN (compoundN "takaraivo" (k1 "kyhmy")) ; --UNCHK
lin iniquitous_A = mkWA (k34A "jumalaton") ; --UNCHK
lin iniquity_N = mkWN (k40 "vääryys") ; --UNCHK
lin initial_A = mkA "alustava" ;
lin initial_N = mkWN (compoundN "alku" (k33 "kirjain")) ; --UNCHK
lin initial_V2 = mkWV2 (k69 "merkitä") "nimikirjaimensa" ; --UNCHK
lin initiate_N = mkWN (k41A "tulokas") ; --UNCHK
lin initiate_V2 = mkV2 "aloittaa" ;
lin initiation_N = mkWN (compoundN "alku" (k39 "sysäys")) ; --UNCHK
lin initiative_N = mkN "aloite" ;
lin iniö_PN = mkPN "Iniö" ;
lin inject_V2 = mkWV2 (k53 "pistää") ; --UNCHK
lin injectable_A = mkWA (compoundA "ruiskutus" (k38 "kelpoinen")) ; --UNCHK
lin injection_N = mkN (lin NK {s = d03 "injektio"}) ;
lin injector_N = mkWN (compoundN "ruiskutus" (k6 "venttiili")) ; --UNCHK
lin injudicious_A = mkWA (compoundA "epä" (k41 "viisas")) ; --UNCHK
lin injudiciousness_N = mkWN (k40 "tahdittomuus") ; --UNCHK
lin injunction_N = mkWN (k1A "kielto") ; --UNCHK
lin injure_V2 = mkV2 "vammauttaa" ;
lin injured_A = mkA "haavoittunut" ;
lin injurious_A = mkWA (k38 "turmiollinen") ; --UNCHK
lin injury_N = mkN "vamma" ;
lin injustice_N = mkWN (k40 "vääryys") ; --UNCHK
lin ink_N = mkWN (k48 "muste") ; --UNCHK
lin ink_V2 = mkWV2 (k53A "täyttää") "musteella" ; --UNCHK
lin ink_bottle_N = mkWN (compoundN "muste" (k1 "pullo")) ; --UNCHK
lin inkberry_N = mkWN "Ilex" "glabra" ; --UNCHK
lin inkblot_N = mkWN (compoundN "muste" (k9 "tahra")) ; --UNCHK
lin inkle_N = mkWN (k9A "pirta") ; --UNCHK
lin inkling_N = mkWN (k39 "pilkahdus") ; --UNCHK
lin inkstand_N = mkWN (compoundN "muste" (k48 "teline")) ; --UNCHK
lin inkwell_N = mkWN (compoundN "muste" (k1 "pullo")) ; --UNCHK
lin inky_A = mkWA (compoundA "musteen" (k10 "musta")) ; --UNCHK
lin inland_A = mkWA "sisämaa-" ; --UNCHK
lin inland_Adv = mkWAdv "sisämaahan" ; --UNCHK
lin inlay_N = mkWN (k48A "upote") ; --UNCHK
lin inlay_V2 = mkWV2 (k53 "koristaa") "upotuksin" ; --UNCHK
lin inlet_N = mkWN (compoundN "sisään" (k1 "tulo")) ; --UNCHK
lin inmate_N = mkWN (k5A "vanki") ; --UNCHK
lin inmost_A = mkWA (k38 "sisimmäinen") ; --UNCHK
lin inn_N = mkWN (k6 "kievari") ; --UNCHK
lin innate_A = mkWA (k38 "synnynnäinen") ; --UNCHK
lin innateness_N = mkWN (k40 "synnynnäisyys") ; --UNCHK
lin inner_A = mkWA (k16A "sisempi") ; --UNCHK
lin innermost_A = mkWA (k38 "sisimmäinen") ; --UNCHK
lin innervation_N = mkWN (k39 "hermotus") ; --UNCHK
lin inning_N = mkWN (k39 "kierros") ; --UNCHK
lin innings_N = mkWN (compoundN "lyönti" (k1 "vuoro")) ; --UNCHK
lin innkeeper_N = mkWN (k10A "isäntä") "majatalon" ; --UNCHK
lin innocence_N = mkWN (k40 "luonnollisuus") ; --UNCHK
lin innocency_N = mkWN (k40 "viattomuus") ; --UNCHK
lin innocent_A = mkWA (k34A "syytön") ; --UNCHK
lin innocent_N = mkWN (k38 "pulmunen") ; --UNCHK
lin innocuous_A = mkWA (k34A "vaaraton") ; --UNCHK
lin innovate_V = mkWV (k64 "tuoda") "markkinoille" ; --UNCHK
lin innovate_V2 = mkWV2 (k64 "tuoda") "markkinoille" ; --UNCHK
lin innovation_N = mkWN (k3 "initiaatio") ; --UNCHK
lin innovative_A = mkWA (k10 "uraauurtava") ; --UNCHK
lin innovativeness_N = mkWN (k40 "innovatiivisuus") ; --UNCHK
lin innovator_N = mkWN (k10 "tiennäyttäjä") ; --UNCHK
lin innoxious_A = mkWA (k34A "vaaraton") ; --UNCHK
lin innsbruck_PN = foreignPN "Innsbruck" ;
lin innuendo_N = mkWN (k39 "vihjaus") ; --UNCHK
lin innumerable_A = mkWA (k34A "rajaton") ; --UNCHK
lin innumerableness_N = mkWN (k40 "rajattomuus") ; --UNCHK
lin innumerate_A = mkWA (compoundA "numero" (k34A "taidoton")) ; --UNCHK
lin inoculant_N = mkWN (k48A "rokote") ; --UNCHK
lin inoculate_V2 = mkWV2 (k53A "rokottaa") ; --UNCHK
lin inoculating_N = mkWN "rokottaminen" ; --UNCHK
lin inoculation_N = mkWN (k48A "rokote") ; --UNCHK
lin inoculator_N = mkWN (compoundN "rok" (k10 "ottaja")) ; --UNCHK
lin inoffensive_A = mkWA (k38 "eufemistinen") ; --UNCHK
lin inoperative_A = mkWA (k34A "tehoton") ; --UNCHK
lin inopportune_A = mkWA (k34A "sopimaton") ; --UNCHK
lin inopportuneness_N = mkWN (k39 "ajoitus") "huono" ; --UNCHK
lin inordinate_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin inorganic_A = mkWA (compoundA "epä" (k38 "orgaaninen")) ; --UNCHK
lin inosine_N = mkWN "inosiini" ; --UNCHK
lin inositol_N = mkWN "inositoli" ; --UNCHK
lin in_patient_N = mkWN (k41 "potilas") ; --UNCHK
lin inpouring_A = mkWA (compoundA "virt" (k9 "aava")) "sisäänpäin" ; --UNCHK
lin inpouring_N = mkWN (compoundN "syöksy" (k38 "minen")) "sisään" ; --UNCHK
lin input_N = mkN "syöte" ;
lin inquest_N = mkWN (k39 "tutkimus") "kuolemansyyn" ; --UNCHK
lin inquietude_N = mkWN (k40 "rauhattomuus") ; --UNCHK
lin inquire_V = mkWV (k67 "tiedustella") ; --UNCHK
lin inquire_V2 = mkWV2 (k67 "tiedustella") ; --UNCHK
lin inquirer_N = mkWN (k10 "kysyjä") ; --UNCHK
lin inquiringly_Adv = mkWAdv (k99 "kysyvästi") ; --UNCHK
lin inquiry_N = mkN "kysely" ;
lin inquisition_N = mkWN (k3 "inkvisitio") ; --UNCHK
lin inquisitive_A = mkWA (k41 "utelias") ; --UNCHK
lin inquisitiveness_N = mkWN (k40 "uteliaisuus") ; --UNCHK
lin inquisitor_N = mkWN (k12 "kuulustelija") ; --UNCHK
lin inquisitorial_A = mkWA "inkvisitorinen" ; --UNCHK
lin inquisitory_A = mkWA (k10 "tutkiva") ; --UNCHK
lin inroad_N = mkWN "tunkeutuminen" ; --UNCHK
lin inrush_N = mkWN (compoundN "syöksy" (k38 "minen")) "sisään" ; --UNCHK
lin insalubrious_A = mkWA (k38 "vahingollinen") "terveydelle" ; --UNCHK
lin insalubrity_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin insane_A = mkWA (k1 "hullu") ; --UNCHK
lin insanitary_A = mkWA (compoundA "epä" (k38 "terveellinen")) ; --UNCHK
lin insanity_N = mkWN (k40 "hulluus") ; --UNCHK
lin insatiable_A = mkWA (k34A "tyydyttämätön") ; --UNCHK
lin insatiate_A = mkWA (k34A "tyydyttämätön") ; --UNCHK
lin inscribe_V2 = mkWV2 (k53 "varustaa") "omistuskirjoituksella" ; --UNCHK
lin inscription_N = mkWN (compoundN "kirjo" (k38 "ittaminen")) ; --UNCHK
lin inscriptive_A = mkWA "kirjoitus-" ; --UNCHK
lin inscrutability_N = mkWN (k40 "tutkimattomuus") ; --UNCHK
lin inscrutable_A = mkWA (k38 "salamyhkäinen") ; --UNCHK
lin insect_N = mkWN (k14A "ötökkä") ; --UNCHK
lin insect_powder_N = mkWN (compoundN "hyönteis" (k1A "myrkky")) ; --UNCHK
lin insectan_A = mkWA "hyönteis-" ; --UNCHK
lin insecticidal_A = mkWA "insektisidinen" ; --UNCHK
lin insecticide_N = mkWN (compoundN "hyönteis" (k1A "myrkky")) ; --UNCHK
lin insectifuge_N = mkWN (k48 "aine") "hyönteisiä" "karkottava" ; --UNCHK
lin insectivore_N = mkWN (compoundN "hyönteis" (k10 "syöjä")) ; --UNCHK
lin insectivorous_A = mkWA (compoundA "hyönteis" (k10 "syöjä")) ; --UNCHK
lin insecure_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin insecureness_N = mkWN (k40 "turvattomuus") ; --UNCHK
lin insecurity_N = mkWN (k40 "pelokkuus") ; --UNCHK
lin inseminate_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin insemination_N = mkWN (k39 "siitos") ; --UNCHK
lin insensate_A = mkWA (k34A "hengetön") ; --UNCHK
lin insensibility_N = mkWN (k40 "piittaamattomuus") ; --UNCHK
lin insensible_A = mkWA (k34A "tunnoton") ; --UNCHK
lin insensitive_A = mkWA (k10A "turta") ; --UNCHK
lin insensitivity_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin insentience_N = mkWN (k40 "elottomuus") ; --UNCHK
lin insentient_A = mkWA (k34A "hengetön") ; --UNCHK
lin inseparable_A = mkWA (k34A "erottamaton") ; --UNCHK
lin insert_N = mkWN (k5A "insertti") ; --UNCHK
lin insert_V2 = mkWV2 (k56A "laittaa") ;
lin insertion_N = mkWN (compoundN "lisä" (k38 "äminen")) ; --UNCHK
lin inset_N = mkWN (k9 "kiila") ; --UNCHK
lin inset_V2 = mkWV2 (k53A "sijoittaa") ; --UNCHK
lin inshore_A = mkWA (compoundA "rannan" (k38 "puoleinen")) ; --UNCHK
lin inshore_Adv = mkWAdv "rantaan" ; --UNCHK
lin inside_A = mkWA "sisä-" ; --UNCHK
lin inside_Adv = mkWAdv (k99 "sisimmältään") ;
lin inside_N = mkWN (k13 "sisusta") ; --UNCHK
lin inside_Prep = mkPrep "sisällä" | mkPrep "sisälle" ; ---- split
lin inside_of_Prep = mkPrep "sisäpuolella" ;
lin insider_N = mkWN (k32 "jäsen") "sisäpiirin" ;
lin insidious_A = mkWA (k38 "haitallinen") ; --UNCHK
lin insidiousness_N = mkWN (compoundN "sala" (k40 "kavaluus")) ; --UNCHK
lin insight_N = mkWN (k5 "aisti") "kuudes" ; --UNCHK
lin insightful_A = mkWA "oivaltava" ; --UNCHK
lin insightfulness_N = mkWN (k1 "äly") ; --UNCHK
lin insignia_N = mkWN (k39 "tunnus") ; --UNCHK
lin insignificance_N = mkWN (k40 "vähäpätöisyys") ; --UNCHK
lin insignificant_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin insincere_A = mkWA (k38 "vilpillinen") ; --UNCHK
lin insincerity_N = mkWN (k40 "tyhjyys") ; --UNCHK
lin insinuate_V2 = mkWV2 (k67 "vihjailla") ; --UNCHK
lin insinuatingly_Adv = mkWAdv (compoundAdv "vihjailev" (k99 "asti")) ; --UNCHK
lin insinuation_N = mkWN (k2 "vihjailu") ; --UNCHK
lin insipid_A = mkWA (k1 "valju") ; --UNCHK
lin insipidity_N = mkWN (k40 "valjuus") ; --UNCHK
lin insipidness_N = mkWN (k40 "valjuus") ; --UNCHK
lin insist_V = mkV "inttää" ;
lin insist_V2 = mkWV2 (k53A "vakuuttaa") ; --UNCHK
lin insist_VS = mkWVS (k53A "vakuuttaa") ; --f77
lin insistence_N = mkWN (k39 "vaatimus") ;
lin insistent_A = mkWA (k34A "hellittämätön") ; --UNCHK
lin insofar_Adv = mkWAdv (k99 "kuin") "siinä" "määrin" ; --UNCHK
lin insolation_N = mkWN (compoundN "aurinko" (k1A "hoito")) ; --UNCHK
lin insole_N = mkWN (k38 "pohjallinen") ; --UNCHK
lin insolence_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin insolent_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin insolubility_N = mkWN (k40 "liukenemattomuus") ; --UNCHK
lin insoluble_A = mkWA (k34A "liukenematon") ; --UNCHK
lin insolvency_N = mkWN (compoundN "maksu" (k40 "kyvyttömyys")) ; --UNCHK
lin insolvent_A = mkWA (compoundA "maksu" (k34A "kyvytön")) ; --UNCHK
lin insolvent_N = mkWN (k2 "henkilö") "maksukyvytön" ; --UNCHK
lin insomnia_N = mkWN (k40 "unettomuus") ; --UNCHK
lin insomniac_A = mkWA (k34A "uneton") ; --UNCHK
lin insomniac_N = mkWN (k2 "henkilö") "uneton" ; --UNCHK
lin insomuch_Adv = mkWAdv (k99 "että") "siinä" "määrin" ; --UNCHK
lin insouciance_N = mkWN (k40 "suruttomuus") ; --UNCHK
lin insouciant_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin inspan_V2 = mkWV2 (k53 "valjastaa") ; --UNCHK
lin inspect_V2 = mkV2 "tutkia" partitive ;
lin inspection_N = mkWN (k2 "tarkastelu") ;
lin inspector_N = mkWN (k10 "tarkastaja") ; --UNCHK
lin inspectorate_N = mkWN (compoundN "valvonta" (k33 "elin")) ; --UNCHK
lin inspectorship_N = mkWN (k9A "virka") "tarkastajan" ; --UNCHK
lin inspiration_N = mkWN (k3 "inhalaatio") ; --UNCHK
lin inspirational_A = mkWA (compoundA "inspir" (k10 "oiva")) ; --UNCHK
lin inspiratory_A = mkWA "sisäänhengitykseen" "liittyvä" ; --UNCHK
lin inspire_V2 = mkV2 "inspiroida" partitive ;
lin inspire_V2V = mkWV2V (k53A "hengittää") "sisään" ; --UNCHK
lin inspiring_A = mkWA (compoundA "inspir" (k10 "oiva")) ; --UNCHK
lin inspissation_N = mkWN (k39 "saostus") ; --UNCHK
lin instability_N = mkWN (k40 "epävakaus") ; --UNCHK
lin instal_V = variants {} ; --
lin install_V = mkV "asentua" ;
lin install_V2 = mkV2 "asentaa" ;
lin installation_N = mkWN (k39 "asennus") ; --UNCHK
lin installment_N = mkWN (k39 "asennus") ; --UNCHK
lin instalment_N = mkWN (k39 "asennus") ; --UNCHK
lin instance_N = mkN "tapaus" ;
lin instance_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin instant_A = mkWA (k10 "pakottava") ; --UNCHK
lin instant_N = mkWN (k10A "ajankohta") ; --UNCHK
lin instantaneous_A = mkWA (k38 "silmänräpäyksellinen") ; --UNCHK
lin instantiation_N = mkWN (k39 "ilmennys") ; --UNCHK
lin instar_N = mkWN (compoundN "kehitys" (k48 "vaihe")) ; --UNCHK
lin instead_Adv = mkAdv "sen sijaan" ;
lin instead_of_Prep = mkPrep "sijasta" ;
lin instep_N = mkWN (k10 "pohja") ; --UNCHK
lin instigate_V2 = mkWV2 (k53A "yllyttää") ; --UNCHK
lin instigation_N = mkWN (k39 "yllytys") ; --UNCHK
lin instigator_N = mkWN (k12 "tekijä") "aloitteen" ; --UNCHK
lin instil_V2 = mkWV2 (k53A "valuttaa") ; --UNCHK
lin instillation_N = mkWN (k39 "tiputus") ; --UNCHK
lin instillator_N = mkWN (compoundN "tippa" (k48 "ruiske")) ; --UNCHK
lin instinct_N = mkWN (k1A "kyky") "luontainen" ; --UNCHK
lin instinctive_A = mkWA (k6 "normaali") ; --UNCHK
lin institute_N = mkN "instituutti" ;
lin institute_V2 = mkWV2 (k64 "tuoda") ; --UNCHK
lin institution_N = mkN "instituutio" ;
lin institutional_A = mkA "institutionaalinen" ;
lin institutionalize_V2 = mkWV2 (k53A "toimittaa") ; --UNCHK
lin instruct_V2 = mkWV2 (k52 "neuvoa") ;
lin instruction_N = mkWN (k9A "didaktiikka") ; --UNCHK
lin instructional_A = mkWA (k38 "opetuksellinen") ; --UNCHK
lin instructive_A = mkWA (k38 "informatiivinen") ; --UNCHK
lin instructor_N = mkWN (k10 "kouluttaja") ; --UNCHK
lin instructorship_N = mkWN (k10 "asema") "opettajan" ; --UNCHK
lin instructress_N = mkWN (compoundN "nais" (k10 "opettaja")) ; --UNCHK
lin instrument_N = mkWN (k48 "väline") ; --f64
lin instrumental_A = mkWA (k38 "instrumentaalinen") ; --UNCHK
lin instrumentalism_N = mkWN (compoundN "instru" (k5 "mentalismi")) ; --UNCHK
lin instrumentalist_N = mkWN (k5 "pelimanni") ; --UNCHK
lin instrumentality_N = mkWN (k1 "laitteisto") ; --UNCHK
lin instrumentation_N = mkWN (k39 "soitinnus") ; --UNCHK
lin insubordinate_A = mkWA (k34A "tottelematon") ; --UNCHK
lin insubordination_N = mkWN (k2 "niskoittelu") ; --UNCHK
lin insubstantial_A = mkWA (k34A "aineeton") ; --UNCHK
lin insubstantiality_N = mkWN (k40 "aineettomuus") ; --UNCHK
lin insufferable_A = mkWA (k10 "hyväksyttävä") "ei" ; --UNCHK
lin insufficiency_N = mkWN (k39 "vajaus") ; --UNCHK
lin insufficient_A = mkWA (k38 "vajavainen") ;
lin insufflation_N = mkWN "sisään" "puhaltaminen" ; --UNCHK
lin insular_A = mkWA "saaristo-" ; --UNCHK
lin insularism_N = mkWN (k40 "irrallisuus") ; --UNCHK
lin insularity_N = mkWN (k40 "irrallisuus") ; --UNCHK
lin insulate_V2 = mkWV2 (k53A "erottaa") ;
lin insulation_N = mkWN (k39 "eristys") ; --UNCHK
lin insulator_N = mkWN (k33 "eristin") ; --UNCHK
lin insulin_N = mkWN (k5 "insuliini") ;
lin insult_N = mkWN (k39 "solvaus") ; --UNCHK
lin insult_V2 = mkWV2 (k73 "parjata") ; --UNCHK
lin insulting_A = mkWA (k38 "ylenkatseellinen") ; --UNCHK
lin insuperable_A = mkWA (compoundA "yli" (k34A "pääsemätön")) ; --UNCHK
lin insupportable_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin insurability_N = mkWN (compoundN "vakuutus" (k40 "kelpoisuus")) ; --UNCHK
lin insurable_A = mkWA (compoundA "vakuutus" (k38 "kelpoinen")) ; --UNCHK
lin insurance_N = mkN (lin NK {s = d39 "vakuutus"}) ;
lin insure_V = mkV "vakuuttaa" ;
lin insure_V2 = mkV2 "vakuuttaa" ;
lin insure_VS = variants {} ; -- mkV2 "vakuuttaa" ;
lin insured_N = mkWN (k2 "henkilö") "vakuutettu" ; --UNCHK
lin insurgency_N = mkWN (k12 "kapina") ; --UNCHK
lin insurgent_N = mkN "kapinallinen" ;
lin insurmountable_A = mkWA (compoundA "yli" (k34A "pääsemätön")) ; --UNCHK
lin insurrection_N = mkWN (k5A "kapinointi") ; --UNCHK
lin insurrectional_A = mkWA (k38 "kapinallinen") ; --UNCHK
lin insurrectionism_N = mkWN (compoundN "kapina" (k7A "henki")) ; --UNCHK
lin intact_A = mkWA (k10 "ehjä") ; --UNCHK
lin intactness_N = mkWN "vahingoittumattomuus" ; --UNCHK
lin intaglio_N = mkWN (k39 "kaiverrus") ; --UNCHK
lin intake_N = mkWN (k3 "inhalaatio") ; --UNCHK
lin intangibility_N = mkWN (k40 "abstraktius") ; --UNCHK
lin intangible_A = mkWA (k5 "abstrakti") ; --UNCHK
lin intangible_N = mkWN (k48A "hyödyke") "aineeton" ; --UNCHK
lin integer_N = mkWN (compoundN "kokonais" (k1A "luku")) ; --UNCHK
lin integral_A = mkWA (k38 "kokonainen") ; --UNCHK
lin integral_N = mkWN (k5 "integraali") ; --UNCHK
lin integrate_V = mkWV (k53A "sisällyttää") ; --UNCHK
lin integrate_V2 = mkWV2 (k53A "sisällyttää") ; --UNCHK
lin integrated_A = variants {} ; --
lin integration_N = mkN "integraatio" "integraatioita" ; --WN (k5A "integrointi") ;
lin integrative_A = mkWA "yhdistävä" ; --UNCHK
lin integrator_N = mkWN (compoundN "plani" (k5 "metri")) ; --UNCHK
lin integrity_N = mkWN (k40 "rehellisyys") ; --UNCHK
lin integument_N = mkWN (kH1 "kuori") ; --UNCHK
lin integumentary_A = mkWA "verhoava" ; --UNCHK
lin intellect_N = mkWN (k1 "äly") ; --UNCHK
lin intellectual_A = mkWA (k41A "älykäs") ; --UNCHK
lin intellectual_N = mkN "älykkö" ;
lin intellectualization_N = mkWN (compoundN "äly" (k38 "llistäminen")) ; --UNCHK
lin intelligence_1_N = mkN "älykkyys" ; ---ARB WN (k2 "tiedustelu") ;
lin intelligence_2_N = mkN "älykkyys" ; ---ARB WN (k2 "tiedustelu") ;
lin intelligence_N = variants {} ; --
lin intelligent_A = mkA "älykäs" ; --mkWA (k38 "älyllinen") ;
lin intelligentsia_N = mkWN (k1 "älymystö") ; --UNCHK
lin intelligibility_N = mkWN (compoundN "helppo" (k40 "tajuisuus")) ; --UNCHK
lin intelligible_A = mkWA (compoundA "helppo" (k38 "tajuinen")) ; --UNCHK
lin intemperance_N = mkWN (k40 "harkitsemattomuus") ; --UNCHK
lin intemperate_A = mkWA (k34A "harkitsematon") ; --UNCHK
lin intend_VV = mkVV (mkV "aikoa") ;
lin intended_A = mkA "aiottu" ;
lin intense_A = mkA "intensiivinen" ;
lin intensification_N = mkWN (k39 "lisäys") ; --UNCHK
lin intensifier_N = mkWN (k33 "vahvistin") ; --UNCHK
lin intensify_V = mkWV (k54A "syventää") ;
lin intensify_V2 = mkV2 "syventää" partitive ;
lin intension_N = mkWN (k39 "tarkoitus") ; --UNCHK
lin intensional_A = mkWA (compoundA "intensiona" (k38 "alinen")) ; --UNCHK
lin intensity_N = mkN "intensiteetti" ;
lin intensive_A = mkA "tehokas" ;
lin intent_A = mkA "tarkkaavainen" ; ---
lin intent_N = mkWN (k10 "suunnitelma") ;
lin intention_N = mkWN (k39 "aikomus") ;
lin intentional_A = mkWA (k38 "tarkoituksellinen") ;
lin intentionality_N = mkWN (k40 "tarkoituksellisuus") ; --UNCHK
lin intentness_N = mkWN (compoundN "syventyne" (k40 "isyys")) ; --UNCHK
lin inter_V2 = mkWV2 (k73A "haudata") ; --UNCHK
lin inter_alia_Adv = mkWAdv (k99 "muassa") "muun" ; --UNCHK
lin interact_V = mkWV (k67 "olla") "vuorovaikutuksessa" ; --UNCHK
lin interaction_N = mkWN (k2 "keskustelu") ; --UNCHK
lin interactional_A = mkWA (compoundA "vuoro" (k10 "vaikuttava")) ; --UNCHK
lin interactive_A = mkWA (k38 "synergistinen") ; --UNCHK
lin interbreed_V = mkWV (k53A "risteyttää") ; --UNCHK
lin interbreed_V2 = mkWV2 (k53A "risteyttää") ; --UNCHK
lin intercalary_A = mkWA (compoundA "lisä" (k1 "tty")) "ajanlaskuun" ; --UNCHK
lin intercede_V = mkWV (k61 "toimia") "välittäjänä" ; --UNCHK
lin intercellular_A = mkWA (compoundA "solujen" (k38 "välinen")) ; --UNCHK
lin intercept_N = mkWN (compoundN "leikkaus" (k48 "piste")) ; --UNCHK
lin intercept_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin interception_N = mkWN (k39 "sieppaus") ; --UNCHK
lin interceptor_N = mkWN (compoundN "torjunta" (k10 "hävittäjä")) ; --UNCHK
lin intercession_N = mkWN (compoundN "väliin" (k1 "tulo")) ; --UNCHK
lin interchange_N = mkWN (k40 "molemminpuolisuus") ; --UNCHK
lin interchange_V2 = mkWV2 (k54A "kääntää") "kelkkansa" ; --UNCHK
lin interchangeable_A = mkWA (k10 "vastaava") ; --UNCHK
lin interchurch_A = mkWA (k38 "välinen") "uskontokuntien" ; --UNCHK
lin intercollegiate_A = mkWA (k38 "välinen") "yliopistojen" ; --UNCHK
lin intercom_N = mkWN (compoundN "sisä" (k33 "puhelin")) ; --UNCHK
lin intercommunicate_V = mkWV (k67 "olla") "vuorovaikutuksessa" ; --UNCHK
lin intercommunication_N = mkWN "keskinäinen" "kommunikointi" ; --UNCHK
lin intercommunion_N = mkWN "interkommuunio" ; --UNCHK
lin interconnect_V = mkWV (k58 "kytkeä") "toisiinsa" ; --UNCHK
lin interconnect_V2 = mkWV2 (k58 "kytkeä") "toisiinsa" ; --UNCHK
lin interconnectedness_N = mkWN (k40 "yhteys") ; --UNCHK
lin interconnection_N = mkWN (k40 "yhteys") ; --UNCHK
lin intercontinental_A = mkWA (compoundA "mannerten" (k38 "välinen")) ; --UNCHK
lin intercostal_A = mkWA (k38 "välinen") "kylkiluiden" ; --UNCHK
lin intercostal_N = mkWN (k39 "lihas") "kylkiluiden" "välinen" ; --UNCHK
lin intercourse_N = mkWN (k38 "kanssakäyminen") "seksuaalinen" ; --UNCHK
lin interdenominational_A = mkWA (k38 "välinen") "uskontokuntien" ; --UNCHK
lin interdepartmental_A = mkWA (k38 "välinen") "osastojen" ; --UNCHK
lin interdepartmental_Adv = mkWAdv (k99 "kesken") "osastojen" ; --UNCHK
lin interdependence_N = mkWN (k40 "molemminpuolisuus") ; --UNCHK
lin interdependent_A = mkWA (compoundA "vasta" (k38 "vuoroinen")) ; --UNCHK
lin interdict_N = mkWN (k1A "kielto") ; --UNCHK
lin interdict_V2 = mkWV2 (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin interdiction_N = mkWN (k1A "kielto") ; --UNCHK
lin interdisciplinary_A = mkWA (k38 "monitieteinen") ; --UNCHK
lin interest_1_N = mkN "kiinnostus" | mkN "mielenkiinto" ;
lin interest_2_N = mkN "korko" ;
lin interest_N = mkN "korko" ;
lin interest_V = mkWV (k53 "kiinnostaa") ; --UNCHK
lin interest_V2 = mkWV2 (k53 "kiinnostaa") ; --f65
lin interested_A = mkA ("kiinnostunut") ;
lin interestedness_N = mkWN "kiinnostuneisuus" ; --UNCHK
lin interesting_A = mkA "kiinnostava" | mkA "mielenkiintoinen" | mkWA (k10 "kiintoisa") ;
lin interface_N = mkWN (compoundN "liittymä" (k9A "pinta")) ; --UNCHK
lin interfacial_A = mkWA (k38 "välinen") "pintojen" ; --UNCHK
lin interfaith_A = mkWA (compoundA "uskontojen" (k38 "välinen")) ; --UNCHK
lin interfere_V = mkWV (k69 "häiritä") ; --UNCHK
lin interference_N = mkWN "blokkaaminen" ; --UNCHK
lin interferometer_N = mkWN (compoundN "interfero" (k5 "metri")) ; --UNCHK
lin interferon_N = mkWN (k5 "interferoni") ; --UNCHK
lin intergalactic_A = mkWA (k38 "välinen") "galaksien" ; --UNCHK
lin interim_A = mkWA (compoundA "väli" (k38 "aikainen")) ; --UNCHK
lin interim_N = mkWN (k5 "väli") ; --UNCHK
lin interior_A = mkWA (k38 "sisäinen") ; --UNCHK
lin interior_N = mkN "sisus" ; --mkWN (compoundN "sisäasiain" (k3 "ministeriö")) ;
lin interject_V2 = mkWV2 (k73 "lisätä") "väliin" ; --UNCHK
lin interjection_N = mkWN (k39 "keskeytys") ; --UNCHK
lin interlace_V = mkWV (k52 "punoa") "yhteen" ; --UNCHK
lin interlace_V2 = mkWV2 (k52 "punoa") "yhteen" ; --UNCHK
lin interlard_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin interlayer_N = mkWN (compoundN "väli" (k39 "kerros")) ; --UNCHK
lin interleaf_N = mkWN (compoundN "väli" (k7A "lehti")) ; --UNCHK
lin interleukin_N = mkWN "interleukiini" ; --UNCHK
lin interlinear_A = mkWA (compoundA "rivien" (k38 "välinen")) ; --UNCHK
lin interlink_V = mkWV (k58 "kytkeä") "toisiinsa" ; --UNCHK
lin interlink_V2 = mkWV2 (k58 "kytkeä") "toisiinsa" ; --UNCHK
lin interlobular_A = mkWA (k38 "välinen") "liuskojen" ; --UNCHK
lin interlock_N = mkWN (k39 "lukitus") ; --UNCHK
lin interlock_V = mkWV (k53A "sovittaa") ; --UNCHK
lin interlock_V2 = mkWV2 (k53A "sovittaa") ; --UNCHK
lin interlocutor_N = mkWN (compoundN "keskustelu" (k6 "kumppani")) ; --UNCHK
lin interlocutory_A = mkWA "neuvottelu-" ; --UNCHK
lin interloper_N = mkWN (k12 "tungettelija") ; --UNCHK
lin interlude_N = mkWN (k9A "väliaika") ; --UNCHK
lin intermarriage_N = mkWN (compoundN "sisäryhmäavio" (k1A "liitto")) ; --UNCHK
lin intermarry_V = mkWV (k61 "solmia") "seka-avioliitto" ; --UNCHK
lin intermediary_N = mkWN (k12 "neuvottelija") ; --UNCHK
lin intermediate_A = mkWA (k10 "oleva") "välillä" ; --UNCHK
lin intermediate_N = mkWN "intermediaatti" ; --UNCHK
lin intermezzo_N = mkWN (k9A "väliaika") ; --UNCHK
lin interminable_A = mkWA (k34A "päättymätön") ; --UNCHK
lin intermingle_V = mkWV (k53 "yhdistää") ; --UNCHK
lin intermingle_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin intermission_N = mkWN (k9A "väliaika") ; --UNCHK
lin intermittence_N = mkWN (k40 "ajoittaisuus") ; --UNCHK
lin intermittent_A = mkA "ajoittainen" ;
lin intermix_V = mkWV (k53 "yhdistää") ; --UNCHK
lin intermix_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin intermixture_N = mkWN (k39 "seos") ; --UNCHK
lin intermolecular_A = mkWA (k38 "välinen") "molekyylien" ; --UNCHK
lin intermural_A = mkWA (k38 "välinen") "yksiköiden" ; --UNCHK
lin intern_N = mkWN (k5 "amanuenssi") ; --UNCHK
lin intern_V2 = mkWV2 (k67 "olla") "työharjoittelussa" ; --UNCHK
lin internal_A = mkA "sisäinen" ;
lin internalization_N = mkWN (k39 "sisäistys") ; --UNCHK
lin internalize_V2 = mkWV2 (k53 "sisäistää") ; --UNCHK
lin international_A = mkWA (compoundA "kansain" (k38 "välinen")) ;
lin international_N = mkWN (k5 "internationaali") ; --UNCHK
lin internationale_N = mkWN (k8 "Internationale") ; --UNCHK
lin internationalism_N = mkWN (k5 "internationalismi") ; --UNCHK
lin internationalist_A = mkWA (compoundA "inter" (k38 "nationalistinen")) ; --UNCHK
lin internationalist_N = mkWN (compoundN "inter" (k5 "nationalisti")) ; --UNCHK
lin internationality_N = mkWN (k5 "internationalismi") ; --UNCHK
lin internationalization_N = mkWN (compoundN "kansa" (k38 "invälistyminen")) ; --UNCHK
lin internationalize_V2 = mkWV2 (k53 "kansainvälistää") ; --UNCHK
lin interne_N = mkWN (k5 "amanuenssi") ; --UNCHK
lin internee_N = mkWN (k2 "henkilö") "internoitu" ; --UNCHK
lin internet_N = mkWN (k1A "verkko") ; --UNCHK
lin internist_N = mkWN (compoundN "sisätauti" (k6 "lääkäri")) ; --UNCHK
lin internment_N = mkWN (k5A "internointi") ; --UNCHK
lin internode_N = mkWN (compoundN "nivel" (k5 "väli")) ; --UNCHK
lin internship_N = mkWN (compoundN "työ" (k2 "harjoittelu")) ; --UNCHK
lin internuncio_N = mkWN (k10 "edustaja") "Paavin" "diplomaattinen" ; --UNCHK
lin interoception_N = mkWN "interoseptio" ; --UNCHK
lin interoceptive_A = mkWA (compoundA "intero" (k38 "septinen")) ; --UNCHK
lin interoperability_N = mkWN "yhteentoimivuus" ; --UNCHK
lin interpellate_V2 = mkWV2 (k71 "tehdä") "välikysymys" ; --UNCHK
lin interpellation_N = mkN "välikysymys" ;
lin interpenetration_N = mkWN (k2 "läpäisy") ; --UNCHK
lin interpersonal_A = mkWA (compoundA "ihmisten" (k38 "välinen")) ; --UNCHK
lin interphone_N = mkWN (compoundN "sisä" (k33 "puhelin")) ; --UNCHK
lin interplanetary_A = mkWA (compoundA "planeettain" (k38 "välinen")) ; --UNCHK
lin interplay_N = mkWN (compoundN "vuoro" (k39 "vaikutus")) ; --UNCHK
lin interpolate_V2 = mkWV2 (k54A "väärentää") ; --UNCHK
lin interpolation_N = mkWN (k39 "keskeytys") ; --UNCHK
lin interpose_V = mkWV (k73 "lisätä") "väliin" ; --UNCHK
lin interpose_V2 = mkWV2 (k73 "lisätä") "väliin" ; --UNCHK
lin interposition_N = mkWN (k3 "interventio") ; --UNCHK
lin interpret_V = mkWV (k73 "osata") ; --UNCHK
lin interpret_V2 = mkWV2 (k73 "osata") ; --UNCHK
lin interpretation_N = mkWN (k9A "tulkinta") ; --UNCHK
lin interpretative_A = mkWA (k38 "tulkinnallinen") ; --UNCHK
lin interpreter_N = mkWN (kH1 "tulkki") ; --UNCHK
lin interracial_A = mkWA (compoundA "moni" (k38 "rotuinen")) ; --UNCHK
lin interreflection_N = mkWN (compoundN "keski" (k38 "näisheijastuminen")) ; --UNCHK
lin interregnum_N = mkWN (compoundN "väliaikais" (k39 "hallitus")) ; --UNCHK
lin interrelate_V = mkWV (k53 "yhdistää") "toisiinsa" ; --UNCHK
lin interrelate_V2 = mkWV2 (k53 "yhdistää") "toisiinsa" ; --UNCHK
lin interrelation_N = mkWN (k48A "suhde") "keskinäinen" ; --UNCHK
lin interrelationship_N = mkWN (k48A "suhde") "keskinäinen" ; --UNCHK
lin interrogate_V2 = mkWV2 (k67 "kysellä") ; --UNCHK
lin interrogation_N = mkWN (k2 "kuulustelu") ; --UNCHK
lin interrogative_A = mkWA (k10 "kysyvä") ; --UNCHK
lin interrogative_N = mkWN (k2 "kysely") ; --UNCHK
lin interrogator_N = mkWN (k12 "kuulustelija") ; --UNCHK
lin interrogatory_A = mkWA (k10 "kysyvä") ; --UNCHK
lin interrupt_N = mkWN (k39 "keskeytys") ; --UNCHK
lin interrupt_V = mkWV (k66 "katkaista") ; --UNCHK
lin interrupt_V2 = mkWV2 (k66 "katkaista") ; --UNCHK
lin interrupter_N = mkWN (k33 "katkaisin") ; --UNCHK
lin interruption_N = mkWN (k5 "väli") ; --UNCHK
lin interscholastic_A = mkWA (compoundA "koulujen" (k38 "välinen")) ; --UNCHK
lin intersect_V = mkWV (k67 "mennä") "ristiin" ; --UNCHK
lin intersect_V2 = mkWV2 (k67 "mennä") "ristiin" ; --UNCHK
lin intersection_N = mkWN "risteäminen" ; --UNCHK
lin intersexual_A = mkWA (compoundA "inter" (k38 "seksuaalinen")) ; --UNCHK
lin interspecies_A = mkWA (compoundA "lajien" (k38 "välinen")) ; --UNCHK
lin intersperse_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin interspersion_N = mkWN (k39 "lisäys") ; --UNCHK
lin interstate_A = mkA (mkN "osavaltioiden" (mkN "välinen")) ;
lin interstate_N = mkWN (compoundN "pää" (k19 "tie")) "osavaltioiden" "välinen" ; --UNCHK
lin interstellar_A = mkWA (compoundA "tähtien" (k38 "välinen")) ; --UNCHK
lin interstice_N = mkWN (k1A "rako") ; --UNCHK
lin interstitial_A = mkWA "rako-" ; --UNCHK
lin intertidal_A = mkWA "vuorovesi-" ; --UNCHK
lin intertribal_A = mkWA (compoundA "heimojen" (k38 "välinen")) ; --UNCHK
lin intertrigo_N = mkWN (k10 "hiertymä") ; --UNCHK
lin intertwine_V = mkWV (k52 "punoa") "yhteen" ; --UNCHK
lin intertwine_V2 = mkWV2 (k52 "punoa") "yhteen" ; --UNCHK
lin interval_N = mkWN (k1 "ero") ; --UNCHK
lin intervene_V = mkWV (k67 "tulla") "väliin" ;
lin intervene_V2V = mkWV2V (k67 "tulla") "väliin" ; --UNCHK
lin intervenor_N = mkWN (compoundN "väli" (k48 "puolue")) ; --UNCHK
lin intervention_N = mkWN (k2 "käsittely") ; --UNCHK
lin intervertebral_A = mkWA (k38 "välinen") "nikamien" ; --UNCHK
lin interview_N = mkN "haastattelu" ;
lin interview_V2 = mkWV2 (k67 "kysellä") ; --UNCHK
lin interviewee_N = mkWN (k10 "haastateltava") ; --UNCHK
lin interviewer_N = mkWN (k12 "haastattelija") ; --UNCHK
lin interweave_V2 = mkWV2 (k52A "kutoa") "yhteen" ; --UNCHK
lin intestacy_N = mkWN (compoundN "puu" (k38 "ttuminen")) "testamentin" ; --UNCHK
lin intestate_A = mkWA "testamentiton" ; --UNCHK
lin intestinal_A = mkWA "suolisto-" ; --UNCHK
lin intestine_N = mkWN (k2 "suolisto") ; --UNCHK
lin inti_N = mkWN "inti" ; --UNCHK
lin intifada_N = mkWN (compoundN "kansan" (k1 "nousu")) ; --UNCHK
lin intima_N = mkWN (compoundN "sisä" (k1 "kalvo")) ; --UNCHK
lin intimacy_N = mkWN (k40 "läheisyys") ; --UNCHK
lin intimal_A = mkWA "sisäkalvoon" "liittyvä" ; --UNCHK
lin intimate_A = mkA "läheinen" ;
lin intimate_N = mkWN (k10 "ystävä") "läheinen" ; --UNCHK
lin intimate_V2 = mkWV2 (k67 "vihjailla") ; --UNCHK
lin intimation_N = mkWN (k39 "pilkahdus") ; --UNCHK
lin intimidate_V2 = mkV2 (mkV "pelotella") partitive ;
lin intimidation_N = mkWN (k2 "uhkailu") ;
lin into_Prep = casePrep illative | mkPrep "sisään" | mkPrep "sisälle" ;
lin intolerable_A = mkWA (k34A "kestämätön") ;
lin intolerance_N = mkWN (compoundN "yli" (k40 "herkkyys")) ; --UNCHK
lin intolerant_A = mkWA (k34A "suvaitsematon") ; --UNCHK
lin intonation_N = mkWN (k3 "intonaatio") ; --UNCHK
lin intone_V = mkWV (k74 "messuta") ; --UNCHK
lin intone_V2 = mkWV2 (k74 "messuta") ; --UNCHK
lin intoxicant_A = mkWA "huumaannuttava" ; --UNCHK
lin intoxicant_N = mkWN (k48A "päihde") ; --UNCHK
lin intoxicate_V2 = mkWV2 (k73 "huumata") ; --UNCHK
lin intoxication_N = mkWN (k39 "päihtymys") ; --UNCHK
lin intracellular_A = mkWA (compoundA "solun" (k38 "sisäinen")) ; --UNCHK
lin intracerebral_A = mkWA (compoundA "intraserebra" (k38 "alinen")) ; --UNCHK
lin intracranial_A = mkWA (compoundA "kallon" (k38 "sisäinen")) ; --UNCHK
lin intractability_N = mkWN (k40 "hankaluus") ; --UNCHK
lin intractable_A = mkWA (k10 "hankala") ; --UNCHK
lin intradepartmental_A = mkWA (compoundA "osaston" (k38 "sisäinen")) ; --UNCHK
lin intradermal_A = mkWA (compoundA "ihon" (k38 "alainen")) ; --UNCHK
lin intrados_N = mkWN (compoundN "sisä" (k9A "pinta")) "holvin" ; --UNCHK
lin intralinguistic_A = mkWA (compoundA "kielen" (k38 "sisäinen")) ; --UNCHK
lin intralobular_A = mkWA "intralobulaarinen" ; --UNCHK
lin intramolecular_A = mkWA (k38 "sisäinen") "molekyylin" ; --UNCHK
lin intramural_A = mkWA (k38 "välinen") "yksiköiden" ; --UNCHK
lin intramuscular_A = mkWA (compoundA "lihaksen" (k38 "sisäinen")) ; --UNCHK
lin intransigence_N = mkWN (k40 "myöntymättömyys") ; --UNCHK
lin intransigency_N = mkWN (k40 "myöntymättömyys") ; --UNCHK
lin intransigent_A = mkWA (k34A "peräänantamaton") ; --UNCHK
lin intransitive_A = mkWA (k38 "intransitiivinen") ; --UNCHK
lin intransitivity_N = mkWN "intransitiivisuus" ; --UNCHK
lin intrapulmonary_A = mkWA (compoundA "keuhkon" (k38 "sisäinen")) ; --UNCHK
lin intrasentential_A = mkWA (compoundA "lauseen" (k38 "sisäinen")) ; --UNCHK
lin intraspecies_A = mkWA (compoundA "lajin" (k38 "sisäinen")) ; --UNCHK
lin intrastate_A = mkWA (k38 "sisäinen") "valtion" ; --UNCHK
lin intra_uterine_A = mkWA (compoundA "kohdun" (k38 "sisäinen")) ; --UNCHK
lin intravasation_N = mkWN "intravasaatio" ; --UNCHK
lin intravenous_A = mkWA (compoundA "suonen" (k38 "sisäinen")) ; --UNCHK
lin intraventricular_A = mkWA (compoundA "kammion" (k38 "sisäinen")) ; --UNCHK
lin intrench_V2 = mkWV2 (k53A "juurruttaa") ; --UNCHK
lin intrepid_A = mkWA (k15 "urhea") ; --UNCHK
lin intrepidity_N = mkWN (k40 "urheus") ; --UNCHK
lin intricacy_N = mkWN (k40 "mutkikkuus") ; --UNCHK
lin intricate_A = mkWA (compoundA "moni" (k38 "mutkainen")) ; --UNCHK
lin intrigue_N = mkWN (k26 "juoni") ; --UNCHK
lin intrigue_V = mkWV (k67A "suunnitella") ; --UNCHK
lin intrigue_V2 = mkWV2 (k67A "suunnitella") ; --UNCHK
lin intrinsic_A = mkWA (k38 "luontainen") ; --UNCHK
lin intro_N = mkWN (k1A "johdanto") ; --UNCHK
lin introduce_V2 = mkV2 "esitellä" ;
lin introduction_N = mkN "esittely" ;
lin introductory_A = mkWA (k10 "alustava") ; --UNCHK
lin introit_N = mkWN (k10 "osa") "messun" "ensimmäinen" ; --UNCHK
lin introitus_N = mkWN (k10 "osa") "messun" "ensimmäinen" ; --UNCHK
lin introject_N = mkWN (compoundN "sisä" (k38 "istäminen")) ; --UNCHK
lin introjected_A = mkWA (compoundA "sisä" (k1 "istetty")) ; --UNCHK
lin introjection_N = mkWN (k39 "sisäistys") ; --UNCHK
lin intron_N = mkWN (k99 "DNA") "kooditon" ; --UNCHK
lin introspect_V = mkWV (k62 "havainnoida") ; --UNCHK
lin introspection_N = mkWN (k3 "introspektio") ; --UNCHK
lin introspective_A = mkWA (k47 "sulkeutunut") ; --UNCHK
lin introspectiveness_N = mkWN "itsensä" "ymmärtäminen" ; --UNCHK
lin introuvable_A = mkWA "kadonnut" ; --UNCHK
lin introversion_N = mkWN (k40 "sulkeutuneisuus") ; --UNCHK
lin introvert_V2 = mkWV2 (k52A "sulkeutua") ; --UNCHK
lin introvertish_A = mkWA (k47 "sulkeutunut") ; --UNCHK
lin intrude_V = mkWV (k52A "tunkeutua") ; --UNCHK
lin intrude_V2 = mkWV2 (k52A "tunkeutua") ; --UNCHK
lin intruder_N = mkWN (k12 "tungettelija") ; --UNCHK
lin intrusion_N = mkWN "tunkeutuminen" ; --UNCHK
lin intrusive_A = mkWA (k10 "tunkeileva") ; --UNCHK
lin intrusiveness_N = mkWN (k40 "tungettelevuus") ; --UNCHK
lin intrust_V2 = mkWV2 (k52 "uskoa") ; --UNCHK
lin intuit_V = mkWV (k74 "vaistota") ; --UNCHK
lin intuit_V2 = mkWV2 (k74 "vaistota") ; --UNCHK
lin intuition_N = mkWN (k1 "vaisto") ; --UNCHK
lin intuitionism_N = mkWN (compoundN "intuition" (k5 "ismi")) ; --UNCHK
lin intuitionist_A = mkWA (compoundA "intuitio" (k38 "nistinen")) ; --UNCHK
lin intuitive_A = mkWA (k38 "vaistomainen") ; --UNCHK
lin intumescence_N = mkWN (compoundN "pai" (k38 "suminen")) ; --UNCHK
lin intussusception_N = mkWN "intussuspektio" ; --UNCHK
lin inula_N = mkWN (k26 "hirvenjuuri") ; --UNCHK
lin inulin_N = mkWN "inuliini" ; --UNCHK
lin inundate_V2 = mkWV2 (k53A "hukuttaa") ; --UNCHK
lin inundation_N = mkWN (k39 "vedenpaisumus") ; --UNCHK
lin inure_V2 = mkWV2 (k53A "totuttaa") ; --UNCHK
lin inutile_A = mkWA (compoundA "käyttö" (k34A "kelvoton")) ; --UNCHK
lin inutility_N = mkWN (k40 "tarpeettomuus") ; --UNCHK
lin invade_V2 = mkWV2 (k73A "vallata") ;
lin invader_N = mkWN (k10 "valtaaja") ; --UNCHK
lin invagination_N = mkWN (k10 "tuppeuma") ; --UNCHK
lin invalid_A = mkWA (k34A "kelvoton") ; --UNCHK
lin invalid_N = mkWN (k41 "potilas") ; --UNCHK
lin invalid_V2 = mkWV2 (k52A "vammautua") ; --UNCHK
lin invalidate_V2 = mkWV2 (k62 "mitätöidä") ; --UNCHK
lin invalidation_N = mkWN (k38 "tekeminen") "pätemättömäksi" ; --UNCHK
lin invalidator_N = mkWN "mitätöijä" ; --UNCHK
lin invalidism_N = mkWN (compoundN "invalid" (k5 "ismi")) ; --UNCHK
lin invalidity_N = mkWN (k40 "pätemättömyys") ; --UNCHK
lin invaluable_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin invaluableness_N = mkWN (k40 "arvokkuus") ; --UNCHK
lin invariability_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin invariable_A = mkWA (k34A "muuttumaton") ;
lin invariance_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin invariant_A = mkWA (k17 "vakaa") ; --UNCHK
lin invariant_N = mkWN (k5A "invariantti") ; --UNCHK
lin invasion_N = mkWN (k3 "invaasio") ; --UNCHK
lin invasive_A = mkA "sisääntunkeva" ;
lin invective_N = mkWN (k40 "katkeruus") ; --UNCHK
lin inveigh_V = mkWV (k61A "sättiä") ; --UNCHK
lin inveigle_V2 = mkWV2 (k67A "viekoitella") ; --UNCHK
lin invent_V = mkV "keksiä" ;
lin invent_V2 = mkV2 "keksiä" ;
lin invention_N = mkN "keksintö" ;
lin inventive_A = mkA "kekseliäs" ;
lin inventiveness_N = mkN "kekseliäisyys" ;
lin inventor_N = mkWN (k12 "keksijä") ;
lin inventory_N = mkWN (k3 "inventaario") ; --f74
lin inverkeithing_PN = foreignPN "Inverkeithing" ;
lin inverness_PN = foreignPN "Inverness" ;
lin inverse_A = mkWA (k38 "käänteinen") ; --UNCHK
lin inverse_N = mkWN (k10A "vastakohta") ; --UNCHK
lin invertase_N = mkWN (compoundN "sukr" (k5 "aasi")) ; --UNCHK
lin invertebrate_A = mkWA (k34A "selkärangaton") ; --UNCHK
lin invertebrate_N = mkWN (k34A "selkärangaton") ; --UNCHK
lin inverter_N = mkWN (k33A "muunnin") ; --UNCHK
lin invertible_A = mkWA "kääntyvä" ; --UNCHK
lin inverurie_PN = foreignPN "Inverurie" ;
lin invest_V = mkV (lin VK {s = c53A "sijoittaa"}) ;
lin invest_V2 = mkV2 "investoida" ; --WV2 (k73 "satsata") ;
lin investigate_V = mkV "tutkia" ;
lin investigate_V2 = mkV2 "tutkia" ;
lin investigation_N = mkWN (k9A "tutkinta") ;
lin investigator_N = mkWN (k10 "etsivä") ; --UNCHK
lin investing_N = mkWN (k5A "investointi") ; --UNCHK
lin investiture_N = mkWN (k39 "ylennys") ; --UNCHK
lin investment_N = mkN (lin NK {s = d05A "investointi"}) ;
lin investor_N = mkN (lin NK {s = d10 "sijoittaja"}) ;
lin inveterate_A = mkWA (k38 "ainainen") ; --UNCHK
lin invidious_A = mkWA "epäoikeudenmukainen" ; --UNCHK
lin invigilate_V = mkWV (k52 "valvoa") ; --UNCHK
lin invigilation_N = mkWN (k9A "valvonta") ; --UNCHK
lin invigilator_N = mkWN (k10 "valvoja") ; --UNCHK
lin invigorate_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin invigorating_A = mkWA "elvyttävä" ; --UNCHK
lin invincibility_N = mkWN (k40 "voittamattomuus") ; --UNCHK
lin invincible_A = mkWA (k34A "lyömätön") ; --UNCHK
lin inviolable_A = mkWA (k34A "loukkaamaton") ; --UNCHK
lin inviolate_A = mkWA (k34A "loukkaamaton") ; --UNCHK
lin invisibility_N = mkWN (k40 "näkymättömyys") ; --UNCHK
lin invisible_A = mkWA (k34A "näkymätön") ; --UNCHK
lin invitation_N = mkN "kutsu" ; --WN (k39 "houkutus") ;
lin invitational_A = mkWA "kutsu-" ; --UNCHK
lin invitatory_A = mkWA "kutsuva" ; --UNCHK
lin invite_N = mkWN (k1 "kutsu") ; --UNCHK
lin invite_V2 = mkV2 "kutsua" ;
lin invite_V2V = mkWV2V (k54A "pyytää") ; --UNCHK
lin invite_in_V = advV (lin V OP_invite_V2) OP_in_Adv ; -- guess-p-verb
lin invocation_N = mkWN "hyödyntäminen" ; --UNCHK
lin invoice_N = mkWN (k5 "tili") ; --UNCHK
lin invoice_V2 = mkWV2 (k53A "laskuttaa") ; --UNCHK
lin invoke_V2 = mkWV2 (k67 "rukoilla") ; --UNCHK
lin involucrate_A = mkWA (compoundA "suo" (k38 "juslehdellinen")) ; --UNCHK
lin involucre_N = mkWN (compoundN "suojus" (k7A "lehti")) ; --UNCHK
lin involuntary_A = mkWA (k34A "tahaton") ; --UNCHK
lin involute_A = mkWA (compoundA "sisä" (k38 "kierteinen")) ; --UNCHK
lin involution_N = mkWN "kääriminen" ; --UNCHK
lin involve_V = mkV "koskea" ;
lin involve_V2 = mkV2 "koskea" partitive ;
lin involve_VS = mkVS "sisältää" ;
lin involved_A = mkA "asiaanomainen" ;
lin involvement_N = mkWN (compoundN "osan" (k1A "otto")) ; --UNCHK
lin invulnerability_N = mkWN "haavoittumattomuus" ; --UNCHK
lin invulnerable_A = mkWA (k10 "kestävä") ; --UNCHK
lin inward_A = mkWA (k38 "sisäinen") ; --UNCHK
lin inward_Adv = mkWAdv (compoundAdv "sisään" (k99 "päin")) ; --UNCHK
lin inwardness_N = mkWN (compoundN "sisäänpäinkääntyne" (k40 "isyys")) ; --UNCHK
lin inwards_Adv = mkWAdv (compoundAdv "sisään" (k99 "päin")) ; --UNCHK
lin inwrought_A = mkWA "kudottu" ; --UNCHK
lin iodide_N = mkWN (k5 "jodidi") ; --UNCHK
lin iodinated_A = mkWA (compoundA "jodio" (k1A "itu")) ; --UNCHK
lin iodinating_A = mkWA "jodia" "sisältävä" ; --UNCHK
lin iodination_N = mkWN (compoundN "jodi" (k38 "ttaminen")) ; --UNCHK
lin iodine_N = mkWN (k5 "jodi") ; --UNCHK
lin iodochlorhydroxyquin_N = mkWN "kliokinoli" ; --UNCHK
lin iodocompound_N = mkWN (compoundN "jodi" (k48 "yhdiste")) ; --UNCHK
lin iodoform_N = mkWN (compoundN "trijodi" (k5 "metaani")) ; --UNCHK
lin iodoprotein_N = mkWN (k5 "proteiini") "jodipitoinen" ; --UNCHK
lin iodopsin_N = mkWN "jodopsiini" ; --UNCHK
lin iodothyronine_N = mkWN (compoundN "jodityro" (k26 "niini")) ; --UNCHK
lin iodotyrosine_N = mkWN "jodityrosiini" ; --UNCHK
lin ion_N = mkWN (k5 "ioni") ; --UNCHK
lin ionic_A = mkWA (compoundA "ioni" (k38 "nen")) ; --UNCHK
lin ionization_N = mkWN (k5A "ionisointi") ; --UNCHK
lin ionize_V = mkWV (k62 "ionisoida") ; --UNCHK
lin ionize_V2 = mkWV2 (k62 "ionisoida") ; --UNCHK
lin ionosphere_N = mkWN (k5 "ionosfääri") ; --UNCHK
lin iontophoresis_N = mkWN (compoundN "ioni" (k12 "terapia")) ; --UNCHK
lin iota_N = mkWN "ioota" ; --UNCHK
lin iou_N = mkWN "IOU" ; --UNCHK
lin iowa_PN = foreignPN "Iowa" ;
lin ipecac_N = mkWN (k26 "oksetusjuuri") ; --UNCHK
lin ipod_N = mkWN "iPod" ; --UNCHK
lin iproclozide_N = mkWN "iproclozide" ; --UNCHK
lin ipse_dixit_N = mkWN (k48A "väite") "dogmaattinen" ; --UNCHK
lin ipsilateral_A = mkWA (compoundA "ipsi" (k38 "lateraalinen")) ; --UNCHK
lin ipso_facto_Adv = mkWAdv (k99 "itsessään") ; --UNCHK
lin ipswich_PN = foreignPN "Ipswich" ;
lin iq_N = mkWN (k99 "ÄO") ; --UNCHK
lin ira_N = mkWN (k39 "suuttumus") ;
lin iran_PN = foreignPN "Iran" ;
lin iranianFem_N = mkN "iranilainen" ;
lin iranianMasc_N = mkN "iranilainen" ;
lin iranian_A = mkA "iranilainen" | mkA "persialainen" ;
lin iraq_PN = foreignPN "Irak" ;
lin iraqi_A = mkWA (compoundA "iraki" (k38 "lainen")) ; --UNCHK
lin iraqi_N = mkWN (compoundN "Iraki" (k38 "lainen")) ; --UNCHK
lin irascibility_N = mkWN (k1A "kiukku") ; --UNCHK
lin irascible_A = mkWA (k14A "ärhäkkä") ; --UNCHK
lin irate_A = mkWA (compoundA "viha" (k47 "stunut")) ; --UNCHK
lin ire_N = mkWN (k39 "suuttumus") ; --UNCHK
lin ireful_A = mkWA (compoundA "viha" (k47 "stunut")) ; --UNCHK
lin ireland_PN = mkPN "Irlanti" ;
lin irenic_A = mkWA "rauhaa" "edistävä" ; --UNCHK
lin iridaceous_A = mkWA (k10 "kuuluva") "kurjenmiekkakasveihin" ; --UNCHK
lin iridescence_N = mkWN (k2 "kimaltelu") ; --UNCHK
lin iridescent_A = mkWA (k10 "kirjava") ; --UNCHK
lin iridic_A = mkWA "iirikseen" "liittyvä" ; --UNCHK
lin iridium_N = mkWN (k5 "iridium") ; --UNCHK
lin iridocyclitis_N = mkWN "iridosykliitti" ; --UNCHK
lin iridokeratitis_N = mkWN (k39 "tulehdus") "värikalvon" ; --UNCHK
lin iridoncus_N = mkWN (k10 "pullistuma") "värikalvon" ; --UNCHK
lin iris_N = mkWN (k33A "himmennin") ; --UNCHK
lin irishFem_N = mkWN (k5 "iiri") ; --UNCHK
lin irishMasc_N = mkWN (k5 "iiri") ; --UNCHK
lin irish_A = mkWA (k38 "irlantilainen") ; --UNCHK
lin irishman_N = mkWN (k38 "irlantilainen") ; --UNCHK
lin irishwoman_N = mkWN (k38 "irlantilainen") ; --UNCHK
lin iritic_A = mkWA "iirikseen" "liittyvä" ; --UNCHK
lin iritis_N = mkWN (compoundN "värikalvo" (k39 "tulehdus")) ; --UNCHK
lin irk_V2 = mkWV2 (k73 "vaivata") ; --UNCHK
lin irksome_A = mkWA (k10 "rasittava") ; --UNCHK
lin iron_N = L.iron_N ;
lin iron_V = mkWV (k53A "silittää") ; --UNCHK
lin iron_V2 = mkWV2 (k53A "silittää") ; --UNCHK
lin iron_foundry_N = mkWN (compoundN "rauta" (k2 "valimo")) ; --UNCHK
lin iron_out_V = mkWV (k53A "sovittaa") ; --UNCHK
lin iron_out_V2 = mkWV2 (k53A "sovittaa") ; --UNCHK
lin ironclad_A = mkWA (compoundA "raudan" (k10 "luja")) ; --UNCHK
lin ironclad_N = mkWN (compoundN "taistelu" (k39 "alus")) ; --UNCHK
lin ironic_A = mkWA (k38 "ironinen") ;
lin ironical_A = mkWA (k38 "ironinen") ;
lin ironing_N = mkWN (k39 "silitys") ; --UNCHK
lin ironing_board_N = mkWN (compoundN "silitys" (k9A "lauta")) ; --UNCHK
lin ironlike_A = mkWA (compoundA "raudan" (k10 "luja")) ; --UNCHK
lin ironmonger_N = mkWN (compoundN "rauta" (k9A "kauppa")) ; --UNCHK
lin ironshod_A = mkWA (compoundA "raudoite" (k1 "ttu")) ; --UNCHK
lin ironside_N = mkWN (k38 "ihminen") "vahva" ; --UNCHK
lin ironware_N = mkWN (compoundN "rauta" (k12 "tavara")) ; --UNCHK
lin ironweed_N = mkWN "vernonia" ; --UNCHK
lin ironwood_N = mkWN (compoundN "humala" (k5A "pyökki")) ; --UNCHK
lin ironwork_N = mkWN (compoundN "takorauta" (k19 "työ")) ; --UNCHK
lin ironworker_N = mkWN (k10 "takoja") ; --UNCHK
lin ironworks_N = mkWN (compoundN "rauta" (k5A "ruukki")) ; --UNCHK
lin irony_N = mkWN (k12 "ironia") ;
lin irradiate_V2 = mkWV2 (k67 "säteillä") ; --UNCHK
lin irradiation_N = mkWN (compoundN "säde" (k1A "hoito")) ; --UNCHK
lin irrational_A = mkWA (k38 "irrationaalinen") ; --UNCHK
lin irrationality_N = mkWN (k40 "irrationaalisuus") ; --UNCHK
lin irreclaimable_A = mkWA (k10 "oleva") "parantumattomissa" ; --UNCHK
lin irreconcilable_A = mkWA "hyväksymätön" ; --UNCHK
lin irrecoverable_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin irredeemable_A = mkWA (k10 "oleva") "lunastamattomissa" ; --UNCHK
lin irredenta_N = mkWN (compoundN "irredenta-" (k48 "alue")) ; --UNCHK
lin irredentist_N = mkWN "irredentti" ; --UNCHK
lin irrefutable_A = mkWA (k34A "kiistämätön") ; --UNCHK
lin irregardless_Adv = mkWAdv (k99 "riippumatta") ; --UNCHK
lin irregular_A = mkA "epäsäännöllinen" ;
lin irregular_N = mkWN (k5A "lehtoraatti") ; --UNCHK
lin irregularity_N = mkWN (k40 "poikkeavuus") ; --UNCHK
lin irrelevance_N = mkWN "merkityksettömyys" ; --UNCHK
lin irrelevancy_N = mkWN "merkityksettömyys" ; --UNCHK
lin irrelevant_A = mkWA (compoundA "asiaan" (k34A "kuulumaton")) ;
lin irreligionist_N = mkWN "uskonnoton" ; --UNCHK
lin irreligious_A = mkWA "uskonnoton" ; --UNCHK
lin irreligiousness_N = mkWN (compoundN "epä" (k40 "uskonnollisuus")) ; --UNCHK
lin irremediable_A = mkWA (k34A "peruuttamaton") ; --UNCHK
lin irremovable_A = mkWA (k34A "peruuttamaton") ; --UNCHK
lin irreparable_A = mkA "korjaamaton" ;
lin irreplaceable_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin irreplaceableness_N = mkWN "korvaamattomuus" ; --UNCHK
lin irrepressibility_N = mkWN (k40 "iloisuus") ; --UNCHK
lin irrepressible_A = mkWA (k34A "pitelemätön") ; --UNCHK
lin irreproachable_A = mkWA (k10 "luotettava") ; --UNCHK
lin irreproducibility_N = mkWN "jäljittelemättömyys" ; --UNCHK
lin irresistibility_N = mkWN (k40 "vastustamattomuus") ; --UNCHK
lin irresistible_A = mkWA (k34A "vastustamaton") ; --UNCHK
lin irresolute_A = mkWA "epäröivä" ; --UNCHK
lin irresoluteness_N = mkWN (k5A "epäröinti") ; --UNCHK
lin irresolution_N = mkWN (k5A "epäröinti") ; --UNCHK
lin irrespective_A = variants {} ; --
lin irresponsibility_N = mkWN (k40 "vastuuttomuus") ; --UNCHK
lin irresponsible_A = mkWA (k34A "vastuuton") ; --UNCHK
lin irreverence_N = mkWN (k2 "häpäisy") ; --UNCHK
lin irreverent_A = mkWA (compoundA "epä" (k10 "kunnioittava")) ; --UNCHK
lin irreversibility_N = mkWN (k40 "peruuttamattomuus") ; --UNCHK
lin irreversible_A = mkWA (k34A "peruuttamaton") ; --UNCHK
lin irrevocable_A = mkWA (k34A "peruuttamaton") ; --UNCHK
lin irrigate_V2 = mkWV2 (k67A "huuhdella") ; --UNCHK
lin irrigation_N = mkWN (k2 "huuhtelu") ; --UNCHK
lin irritability_N = mkWN (k40 "äreys") ; --UNCHK
lin irritable_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin irritant_N = mkWN (k5A "piikki") ; --UNCHK
lin irritate_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin irritating_A = mkWA (k10 "rasittava") ; --UNCHK
lin irritation_N = mkWN (compoundN "kiusan" (k1A "teko")) ; --UNCHK
lin irruption_N = mkWN (k39 "purkaus") ; --UNCHK
lin irruptive_A = mkWA "plutoninen" ; --UNCHK
lin irthlingborough_PN = foreignPN "Irthlingborough" ;
lin irvine_PN = foreignPN "Irvine" ;
lin isabel_PN = foreignPN "Isabel" ;
lin ischemia_N = mkWN "iskemia" ; --UNCHK
lin ischemic_A = mkWA "iskeeminen" ; --UNCHK
lin ischium_N = mkWN (compoundN "istuin" (k18 "luu")) ; --UNCHK
lin isentropic_A = mkWA (compoundA "isen" (k38 "trooppinen")) ; --UNCHK
lin isinglass_N = mkWN (k5 "gelatiini") ; --UNCHK
lin islam_N = mkWN (k40 "muhamettilaisuus") ; --UNCHK
lin islamic_A = mkWA (k38 "islamilainen") ; --UNCHK
lin island_N = mkWN (k26 "saari") ;
lin islander_N = mkWN (k38 "saaristolainen") ; --UNCHK
lin isle_N = mkWN (k26 "saari") "pieni" ; --UNCHK
lin islet_N = mkWN (k26 "saari") "pieni" ; --UNCHK
lin islington_PN = foreignPN "Islington" ;
lin ism_N = mkWN (k5A "oppi") ; --UNCHK
lin isoagglutination_N = mkWN "isoagglutinaatio" ; --UNCHK
lin isoagglutinin_N = mkWN (compoundN "isoaggluti" (k5A "niitti")) ; --UNCHK
lin isoagglutinogen_N = mkWN (compoundN "isoagglutino" (k5 "geeni")) ; --UNCHK
lin isoantibody_N = mkWN "isovasta-aine" ; --UNCHK
lin isobar_N = mkWN (k5 "isobaari") ; --UNCHK
lin isobutylene_N = mkWN "2-metyylipropeeni" ; --UNCHK
lin isocarboxazid_N = mkWN "Marplan" ; --UNCHK
lin isochronal_A = mkWA (compoundA "saman" (k38 "aikainen")) ; --UNCHK
lin isochrone_N = mkWN "isokroni" ; --UNCHK
lin isoclinal_A = mkWA (compoundA "iso" (k38 "kliininen")) ; --UNCHK
lin isocyanate_N = mkWN (compoundN "isosy" (k5A "aniitti")) ; --UNCHK
lin isoflurane_N = mkWN (compoundN "isoflu" (k5 "raani")) ; --UNCHK
lin isogamete_N = mkWN (k5A "gameetti") ; --UNCHK
lin isogamy_N = mkWN "isogamia" ; --UNCHK
lin isogon_N = mkWN "isogoni" ; --UNCHK
lin isogonic_A = mkWA (compoundA "samankul" (k38 "mainen")) ; --UNCHK
lin isogram_N = mkWN (compoundN "vakiokoostumus" (k10 "suora")) ; --UNCHK
lin isohel_N = mkWN (compoundN "aurinkoisuus" (k10 "käyrä")) ; --UNCHK
lin isojoki_PN = mkPN (mkN "Isojoki" "Isojokia") ;
lin isokyrö_PN = mkPN "Isokyrö" ;
lin isolable_A = mkWA (k10 "oleva") "eristettävissä" ; --UNCHK
lin isolate_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin isolated_A = variants {} ; --
lin isolation_N = mkWN (k39 "eristys") ; --UNCHK
lin isolationism_N = mkWN (compoundN "isolation" (k5 "ismi")) ; --UNCHK
lin isolationist_A = mkWA (compoundA "iso" (k38 "lationistinen")) ; --UNCHK
lin isolationist_N = mkWN (k10 "kannattaja") "eristäytymisen" ; --UNCHK
lin isoleucine_N = mkWN "isoleusiini" ; --UNCHK
lin isomerase_N = mkWN (compoundN "isomer" (k5 "aasi")) ; --UNCHK
lin isomeric_A = mkWA (compoundA "iso" (k38 "meerinen")) ; --UNCHK
lin isomerism_N = mkWN "isomeria" ; --UNCHK
lin isomerization_N = mkWN (compoundN "iso" (k38 "meroituminen")) ; --UNCHK
lin isometric_A = mkWA (k38 "isometrinen") ; --UNCHK
lin isometrics_N = mkWN (k2 "harjoittelu") "isometrinen" ; --UNCHK
lin isometropia_N = mkWN "isometropia" ; --UNCHK
lin isometry_N = mkWN "isometria" ; --UNCHK
lin isomorphism_N = mkWN (k12 "isomorfia") ; --UNCHK
lin isomorphous_A = mkWA (compoundA "iso" (k38 "morfinen")) ; --UNCHK
lin isoniazid_N = mkWN "INH" ; --UNCHK
lin isopod_N = mkWN (k9 "siira") ;
lin isoproterenol_N = mkWN "isoproterenoli" ; --UNCHK
lin isopteran_A = mkWA "termiitteihin" "liittyvä" ; --UNCHK
lin isosceles_A = mkWA "tasakylkinen" ; --UNCHK
lin isosorbide_N = mkWN "Isordil" ; --UNCHK
lin isotherm_N = mkWN (k5 "isotermi") ; --UNCHK
lin isothermal_A = mkWA (compoundA "iso" (k38 "terminen")) ; --UNCHK
lin isothermic_A = mkWA (compoundA "iso" (k38 "terminen")) ; --UNCHK
lin isothiocyanate_N = mkWN (compoundN "isotiosya" (k5A "naatti")) ; --UNCHK
lin isotonic_A = mkWA (compoundA "iso" (k38 "toninen")) ; --UNCHK
lin isotope_N = mkWN (k5A "isotooppi") ; --UNCHK
lin isotopic_A = mkWA (compoundA "iso" (k38 "tooppinen")) ; --UNCHK
lin isotropic_A = mkWA (compoundA "iso" (k38 "trooppinen")) ; --UNCHK
lin isotropy_N = mkWN (k12 "symmetria") ; --UNCHK
lin israel_PN = foreignPN "Israel" ;
lin israeli_A = mkA "israelilainen" ;
lin israeli_N = mkWN (k38 "israelilainen") ; --UNCHK
lin issue_1_N = mkN "ongelma" ;
lin issue_2_N = mkN "numero" ;
lin issue_N = mkN "ongelma" ;
lin issue_V = mkWV (k67 "tulla") "esiin" ; ---- sense
lin issue_V2 = mkV2 "julkaista" ;
lin issue_forth_V = mkWV (k67 "tulla") "esiin" ; --UNCHK
lin issuer_N = mkWN (k10 "antaja") ; --UNCHK
lin isthmian_A = mkWA "kannaksen" "muodostava" ; --UNCHK
lin isthmus_N = mkWN (k10 "sola") ; --UNCHK
lin it_Pron = S.it_Pron ;
lin italianFem_N = mkN "italialainen" ;
lin italianMasc_N = mkN "italialainen" ;
lin italian_A = mkWA (k38 "italialainen") ; --UNCHK
lin italic_A = mkWA (compoundA "ita" (k38 "alinen")) ; --UNCHK
lin italic_N = mkWN (k5 "kursiivi") ; --UNCHK
lin italicize_V2 = mkWV2 (k62 "kursivoida") ; --UNCHK
lin italy_PN = foreignPN "Italia" ;
lin itch_N = mkWN (k12 "kutina") ; --UNCHK
lin itchy_A = mkWA "syyhyävä" ; --UNCHK
lin item_Adv = mkWAdv (k99 "myös") ; --UNCHK
lin item_N = mkN "kohta" | mkN "esine" ; ---- split
lin itemize_V2 = mkWV2 (k67A "eritellä") ; --UNCHK
lin iterate_V2 = mkWV2 (k53 "toistaa") ; --UNCHK
lin iteration_N = mkWN (k1 "toisto") ; --UNCHK
lin iterative_A = mkWA "iteratiivinen" ; --UNCHK
lin iterative_N = mkWN (k1A "muoto") "toistuva" ; --UNCHK
lin itinerant_A = mkWA "kiertävä" ; --UNCHK
lin itinerant_N = mkWN (k38 "kiertolainen") ; --UNCHK
lin itinerary_N = mkWN (compoundN "matka" (k5A "reitti")) ; --UNCHK
lin itineration_N = mkWN (compoundN "kierto" (k9 "matka")) ; --UNCHK
lin itraconazole_N = mkWN "Sporanox" ; --UNCHK
lin iud_N = mkWN (k14A "kierukka") ; --UNCHK
lin ivalo_PN = mkPN "Ivalo" ;
lin iver_PN = foreignPN "Iver" ;
lin ivory_N = mkWN (compoundN "luun" (k38 "valkoinen")) ; --UNCHK
lin ivorybill_N = mkWN (compoundN "rämetuli" (k7A "kärki")) ; --UNCHK
lin ivy_N = mkWN (k5A "muratti") ; --UNCHK
lin izar_N = mkWN "izar" ; --UNCHK
lin jaala_PN = mkPN "Jaala" ;
lin jab_N = mkWN (k2 "tönäisy") ; --UNCHK
lin jab_V = mkWV (k66 "tökkäistä") ; --UNCHK
lin jab_V2 = mkWV2 (k66 "tökkäistä") ; --UNCHK
lin jabalpur_PN = foreignPN "Jabalpur" ;
lin jabber_N = mkWN (k39 "pälpätys") ; --UNCHK
lin jabber_V = mkWV (k73 "pauhata") ; --UNCHK
lin jabber_V2 = mkWV2 (k73 "pauhata") ; --UNCHK
lin jabberer_N = mkWN (k10 "puhuja") "tyhjän" ; --UNCHK
lin jabiru_N = mkWN (k12 "haikara") ; --UNCHK
lin jabot_N = mkWN (k2 "röyhelö") ; --UNCHK
lin jaboticaba_N = mkWN "jaboticaba" ; --UNCHK
lin jacamar_N = mkWN (compoundN "jaka" (k5 "mari")) ; --UNCHK
lin jack_N = mkWN (k5 "aasi") ; --UNCHK
lin jack_V2 = mkWV2 (k53 "tuulastaa") ; --UNCHK
lin jack_plane_N = mkWN (compoundN "silitys" (k10 "höylä")) ; --UNCHK
lin jack_up_V = mkWV (k53 "nostaa") "tunkilla" ; --UNCHK
lin jack_up_V2 = mkWV2 (k53 "nostaa") "tunkilla" ; --UNCHK
lin jackal_N = mkWN (k6 "sakaali") ; --UNCHK
lin jackanapes_N = mkWN (k38 "ihminen") "vähäpätöinen" ; --UNCHK
lin jackass_N = mkWN (k5 "aasi") ; --UNCHK
lin jackboot_N = mkWN (k41A "saapas") "hesseniläinen" ; --UNCHK
lin jackdaw_N = mkWN (k9A "naakka") ; --UNCHK
lin jacket_N = mkN "pusakka" ;
lin jackfruit_N = mkWN (compoundN "jakki" (k10 "hedelmä")) ; --UNCHK
lin jack_knife_N = mkWN (compoundN "linkku" (k30 "veitsi")) ; --UNCHK
lin jacklight_N = mkWN (compoundN "tuulas" (k1 "valo")) ; --UNCHK
lin jackpot_N = mkWN (k5A "jättipotti") ; --UNCHK
lin jackrabbit_N = mkWN (k39 "jänis") ; --UNCHK
lin jacks_N = mkWN (compoundN "jacks-" (k5 "peli")) ; --UNCHK
lin jackscrew_N = mkWN (compoundN "väki" (k5 "ruuvi")) ; --UNCHK
lin jacksmelt_N = mkWN (compoundN "hopea" (k7A "kylki")) ; --UNCHK
lin jacksnipe_N = mkWN (compoundN "melan" (k39 "otos")) "Calidris" ; --UNCHK
lin jacksonville_PN = foreignPN "Jacksonville" ;
lin jackstraw_N = mkWN (k1A "tikku") ; --UNCHK
lin jackstraws_N = mkWN (compoundN "tikku" (k5 "peli")) ; --UNCHK
lin jacobin_N = mkWN (k5 "jakobiini") ; --UNCHK
lin jacobinism_N = mkWN (compoundN "jakobin" (k5 "ismi")) ; --UNCHK
lin jacobite_N = mkWN (compoundN "jako" (k5A "biitti")) ; --UNCHK
lin jaconet_N = mkWN "jakonetti" ; --UNCHK
lin jacquard_N = mkWN "jakardikutomakone" ; --UNCHK
lin jactitation_N = mkWN "jaktaatio" ; --UNCHK
lin jade_A = mkWA (compoundA "jaden" (k15 "vihreä")) ; --UNCHK
lin jade_N = mkWN (k10 "luuska") ; --UNCHK
lin jadeite_N = mkWN "jadeiitti" ; --UNCHK
lin jaeger_N = mkWN (k1 "kihu") ; --UNCHK
lin jag_N = mkWN (k39 "annos") ; --UNCHK
lin jag_V2 = mkWV2 (k74 "loveta") ; --UNCHK
lin jaggedness_N = mkWN (k40 "rosoisuus") ; --UNCHK
lin jaggery_N = mkWN (compoundN "taatelipalmu" (k6 "sokeri")) "raaka" ; --UNCHK
lin jaggy_A = mkWA (k41A "särmikäs") ; --UNCHK
lin jaguar_N = mkWN (k6 "pantteri") ; --UNCHK
lin jaguarundi_N = mkWN (compoundN "jagua" (k5 "rundi")) ; --UNCHK
lin jail_N = mkN "vankila" ;
lin jail_V2 = mkV2 "vangita" ;
lin jailer_N = mkWN (kH1 "pamppu") ; --UNCHK
lin jailor_N = mkWN (kH1 "pamppu") ; --UNCHK
lin jaipur_PN = foreignPN "Jaipur" ;
lin jakarta_PN = foreignPN "Jakarta" ;
lin jake_PN = mkPN "Jake" ;
lin jakes_N = mkWN (k50 "kuivakäymälä") ; --UNCHK
lin jakobstad_PN = mkPN (mkN "Pietarsaari" "Pietarsaaria") ;
lin jalapeno_N = mkWN (k1 "jalapeno") ; --UNCHK
lin jalasjärvi_PN = mkPN (mkN "Jalasjärvi" "Jalasjärviä") ;
lin jalopy_N = mkWN (k2 "kottero") ; --UNCHK
lin jalousie_N = mkWN (compoundN "ristikko" (k12 "ikkuna")) ; --UNCHK
lin jam_N = mkN "ruuhka" ; ---ARB --mkN "hillo" ; --mkWN (k9A "häirintä") ;
lin jam_V = mkV "tukkeutua" ;
lin jam_V2 = mkWV2 (k61A "tukkia") ; --UNCHK
lin jam_VS = mkWVS (k61A "tukkia") ; --UNCHK
lin jamaica_PN = foreignPN "Jamaika" ;
lin jamaican_A = mkWA (compoundA "jam" (k38 "aikalainen")) ;
lin jamaican_N = mkWN (compoundN "jam" (k38 "aikalainen")) ; --UNCHK
lin jamb_N = mkWN (k26 "pieli") ; --UNCHK
lin jambalaya_N = mkWN "jambalaya" ; --UNCHK
lin james_PN = mkPN "James" ;
lin jamjar_N = mkWN (compoundN "hillo" (k5A "purkki")) ; --UNCHK
lin jammer_N = mkWN (compoundN "häirintä" (k33A "lähetin")) ; --UNCHK
lin jamming_N = mkWN (k9A "häirintä") ; --UNCHK
lin jampack_V2 = mkWV2 (k56A "ahtaa") ; --UNCHK
lin jampan_N = mkWN (compoundN "kanto" (k5 "tuoli")) ; --UNCHK
lin jampot_N = mkWN (compoundN "hillo" (k5A "purkki")) ; --UNCHK
lin janakkala_PN = mkPN "Janakkala" ;
lin jangle_N = mkWN (kH1 "kolina") ; --UNCHK
lin jangle_V = mkWV (k66 "kalista") ; --UNCHK
lin jangle_V2 = mkWV2 (k66 "kalista") ; --UNCHK
lin janitor_N = mkWN (k10 "siivooja") ; --UNCHK
lin japan_N = mkWN (kH1 "lakka") "japanilainen" ; --UNCHK
lin japan_PN = foreignPN "Japani" ;
lin japaneseFem_N = variants {} ; ---- sense to be split
lin japaneseMasc_N = mkN "japanilainen" ;
lin japanese_A = mkWA (k38 "japanilainen") ; --f121
lin jape_N = mkWN (k1 "kasku") ; --UNCHK
lin japonica_N = mkWN "japaninruusukvitteni" ; --UNCHK
lin jar_N = mkWN (k5A "tölkki") ; --UNCHK
lin jar_V = mkWV (k53A "purkittaa") ; --UNCHK
lin jar_V2 = mkWV2 (k53A "purkittaa") ; --UNCHK
lin jarful_N = mkWN (k38 "tölkillinen") ; --UNCHK
lin jargon_N = mkWN (compoundN "ammatti" (k26 "kieli")) ; --UNCHK
lin jargoon_N = mkWN (k6 "sirkoni") ; --UNCHK
lin jarringly_Adv = mkWAdv "rämisten" ; --UNCHK
lin jarrow_PN = foreignPN "Jarrow" ;
lin jasmine_N = mkWN (k5 "jasmiini") ; --UNCHK
lin jasper_N = mkWN (k39 "jaspis") ; --UNCHK
lin jassid_N = mkWN "jassid" ; --UNCHK
lin jati_N = mkWN "jati" ; --UNCHK
lin jaundice_N = mkWN (k40 "piikikkyys") ; --UNCHK
lin jaundice_V2 = mkWV2 (k53A "aiheuttaa") "keltatauti" ; --UNCHK
lin jaunt_N = mkWN (k9 "matka") ; --UNCHK
lin jaunt_V = mkWV (k53 "matkustaa") ; --UNCHK
lin jauntiness_N = mkWN (k40 "reippaus") ; --UNCHK
lin jaunting_car_N = mkWN (compoundN "hevos" (k1 "kärry")) ; --UNCHK
lin jaunty_A = mkWA (k38 "herttainen") ; --UNCHK
lin java_PN = foreignPN "Java" ;
lin javanese_A = mkWA (compoundA "jaav" (k38 "alainen")) ; --UNCHK
lin javanese_N = mkN "jaavalainen" ;
lin javelin_N = mkWN (k41 "keihäs") ; --UNCHK
lin jaw_N = mkWN (compoundN "kiinnitys" (k9A "leuka")) ; --UNCHK
lin jaw_V = mkWV (k73 "saarnata") ; --UNCHK
lin jawan_N = mkWN "jawan" ; --UNCHK
lin jawbone_N = mkWN (k9A "leuka") ; --UNCHK
lin jawbreaker_N = mkWN (compoundN "sana" (k3 "hirviö")) ; --UNCHK
lin jawed_A = mkWA "leualliset" ; --UNCHK
lin jawfish_N = mkWN (compoundN "leuka" (k9 "kala")) ; --UNCHK
lin jawless_A = mkWA "leuattomat" ; --UNCHK
lin jay_N = mkWN (k7 "närhi") ; --UNCHK
lin jaywalker_N = mkWN (compoundN "jalan" (k12 "kulkija")) "uhkarohkea" ; --UNCHK
lin jazz_N = mkWN (k5 "jazz") ;
lin jazz_V2 = mkWV2 (k63 "saada") ; --UNCHK
lin jazz_up_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin jazzy_A = mkWA (k15 "upea") ; --UNCHK
lin jealous_A = mkWA (k38 "mustasukkainen") ; --UNCHK
lin jealousy_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin jean_N = mkWN (k41A "farkkukangas") ;
lin jeans_N = variants {} ; --
lin jedburgh_PN = foreignPN "Jedburgh" ;
lin jeep_N = mkWN (k5A "jeeppi") ; --UNCHK
lin jeer_N = mkWN (k9 "iva") ; --UNCHK
lin jeer_V = mkWV (k67A "piikitellä") ; --UNCHK
lin jeer_V2 = mkWV2 (k67A "piikitellä") ; --UNCHK
lin jeeringly_Adv = mkWAdv (k99 "pilkallisesti") ; --UNCHK
lin jejune_A = mkWA (k1 "valju") ; --UNCHK
lin jejuneness_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin jejunitis_N = mkWN (compoundN "tyhjäsuoli" (k39 "tulehdus")) ; --UNCHK
lin jejunity_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin jejunoileitis_N = mkWN "jejunoileiitti" ; --UNCHK
lin jejunum_N = mkWN (k50 "tyhjäsuoli") ; --UNCHK
lin jell_V = mkWV (k52A "asettua") ; --UNCHK
lin jell_V2 = mkWV2 (k52A "asettua") ; --UNCHK
lin jellaba_N = mkWN "jellaba" ; --UNCHK
lin jello_N = mkWN (k2 "hyytelö") ; --UNCHK
lin jelly_N = mkWN (k2 "hyytelö") ; --UNCHK
lin jelly_V = mkWV (k74 "hillota") ; --UNCHK
lin jelly_V2 = mkWV2 (k74 "hillota") ; --UNCHK
lin jellyfish_N = mkWN (k13 "meduusa") ; --UNCHK
lin jellyroll_N = mkWN (compoundN "kääre" (k1A "torttu")) ; --UNCHK
lin jemmy_N = mkWN (compoundN "sorkka" (k9A "rauta")) ; --UNCHK
lin jennet_N = mkWN (compoundN "aasi" (k9 "tamma")) ; --UNCHK
lin jenny_N = mkWN (compoundN "aasi" (k9 "tamma")) ; --UNCHK
lin jeopardize_V2 = mkWV2 (k54A "vaarantaa") ; --UNCHK
lin jeopardy_N = mkWN (kH1 "vaara") ; --UNCHK
lin jerboa_N = mkWN (compoundN "hyppy" (k10A "rotta")) ; --UNCHK
lin jeremiad_N = mkWN (k39 "vuodatus") ; --UNCHK
lin jerk_N = mkWN (k2 "nykäisy") ; --UNCHK
lin jerk_V = mkWV (k53A "nytkähtää") ; --UNCHK
lin jerk_V2 = mkWV2 (k53A "nytkähtää") ; --UNCHK
lin jerk_off_V = mkWV (k53A "tyydyttää") "itsensä" ; --UNCHK
lin jerkin_N = mkWN (kH1 "liivi") ; --UNCHK
lin jerkiness_N = mkWN (k40 "katkonaisuus") ; --UNCHK
lin jerkwater_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin jerky_A = mkWA (k34A "älytön") ; --UNCHK
lin jerky_N = mkWN (k9 "liha") "kuivattu" ; --UNCHK
lin jeroboam_N = mkWN "tuplamagnum" ; --UNCHK
lin jerome_PN = foreignPN "Jerome" ;
lin jerry_N = mkWN (k5 "hunni") ; --UNCHK
lin jersey_N = mkWN "Jersey" ; --UNCHK
lin jersey_PN = foreignPN "Jersey" ;
lin jest_N = mkWN (k40 "leikkisyys") ; --UNCHK
lin jest_V = mkWV (k67 "pilailla") ; --UNCHK
lin jester_N = mkWN (k5 "narri") ; --UNCHK
lin jesuit_N = mkWN (k9A "jesuiitta") ; --UNCHK
lin jesuitical_A = mkWA (k38 "jesuiittamainen") ; --UNCHK
lin jet_N = mkN "suihkukone" ; ---ARB mkWN (k1 "suihku") ;
lin jet_V = mkWV (k73A "virrata") "voimakkaasti" ; --UNCHK
lin jet_V2 = mkWV2 (k73A "virrata") "voimakkaasti" ; --UNCHK
lin jetliner_N = mkWN "reittisuihkukone" ; --UNCHK
lin jetsam_N = mkWN (compoundN "hylky" (k12 "tavara")) "ajelehtiva" ; --UNCHK
lin jettison_V2 = mkV2 "hylätä" ;
lin jetty_N = mkWN (compoundN "ranta" (k49A "penger")) ; --UNCHK
lin jew_N = mkWN (k38 "israelilainen") ; --UNCHK
lin jewel_N = mkWN (k50 "jalokivi") ; --UNCHK
lin jewel_V2 = mkWV2 (k53 "somistaa") ; --UNCHK
lin jeweler_N = mkWN (compoundN "jalokivi" (k41 "kauppias")) ; --UNCHK
lin jeweller_N = mkWN (compoundN "jalokivi" (k41 "kauppias")) ; --UNCHK
lin jewellery_N = mkWN (k1 "koru") ; --UNCHK
lin jewelry_N = mkWN (k1 "koru") ; --UNCHK
lin jewelweed_N = mkWN (compoundN "lännen" (k5 "palsami")) ; --UNCHK
lin jewess_N = mkWN (k38 "juutalainen") ; --UNCHK
lin jewfish_N = mkWN "Mycteroperca" "bonaci" ; --UNCHK
lin jewish_A = mkA "juutalainen" ;
lin jezebel_N = mkWN (k38 "nainen") "paha" ; --UNCHK
lin jiao_N = mkWN "jiao" ; --UNCHK
lin jib_N = mkWN (compoundN "viisto" (k48 "purje")) ; --UNCHK
lin jib_boom_N = mkWN (k5 "puomi") "kokkapuun" ; --UNCHK
lin jibe_N = mkWN (k39 "sivallus") ; --UNCHK
lin jiffy_N = mkWN (k10 "kotva") ; --UNCHK
lin jig_N = mkWN "gigue" ; --UNCHK
lin jig_V = mkWV (k61 "tanssia") "gigueta" ; --UNCHK
lin jig_V2 = mkWV2 (k61 "tanssia") "gigueta" ; --UNCHK
lin jigger_N = mkWN (kH1 "punkki") ; --UNCHK
lin jiggermast_N = mkWN (k1 "masto") "pieni" ; --UNCHK
lin jiggle_N = mkWN (k12 "tärinä") ; --UNCHK
lin jiggle_V = mkWV (k53A "tutisuttaa") ; --UNCHK
lin jiggle_V2 = mkWV2 (k53A "tutisuttaa") ; --UNCHK
lin jigsaw_N = mkWN (compoundN "lehti" (k9 "saha")) ; --UNCHK
lin jihad_N = mkWN (k10A "sota") "pyhä" ; --UNCHK
lin jilt_N = mkWN (k38 "nainen") "uskoton" ; --UNCHK
lin jilt_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin jim_crow_N = mkWN (compoundN "sorkka" (k9A "rauta")) ; --UNCHK
lin jimdandy_N = mkWN (k10 "loistava") ; --UNCHK
lin jimmy_N = mkWN (compoundN "sorkka" (k9A "rauta")) ; --UNCHK
lin jimsonweed_N = mkWN (k50 "hulluruoho") ; --UNCHK
lin jingle_N = mkWN (kH1 "ralli") ; --UNCHK
lin jingle_V = mkWV (k66 "kalista") ; --UNCHK
lin jingle_V2 = mkWV2 (k66 "kalista") ; --UNCHK
lin jingo_N = mkWN (k38 "ihminen") "kiihkoisänmaallinen" ; --UNCHK
lin jingoism_N = mkWN (k5 "nationalismi") ; --UNCHK
lin jingoist_N = mkWN (k38 "ihminen") "kiihkoisänmaallinen" ; --UNCHK
lin jingoistic_A = mkWA (compoundA "isän" (k38 "maallinen")) ; --UNCHK
lin jinks_N = mkWN (k9A "juhlinta") "riehakas" ; --UNCHK
lin jinrikisha_N = mkWN (k9 "rikša") ; --UNCHK
lin jinx_N = mkWN (k9A "taika") ; --UNCHK
lin jiqui_N = mkWN "Malpighia" "obovata" ; --UNCHK
lin jird_N = mkWN (k5 "gerbiili") ; --UNCHK
lin jitney_N = mkWN (k5 "bussi") ; --UNCHK
lin jitter_N = mkWN (k9A "huojunta") ; --UNCHK
lin jitterbug_N = mkWN "jitterbug" ; --UNCHK
lin jitteriness_N = mkWN (k40 "kärsimättömyys") ; --UNCHK
lin jittering_A = mkWA (compoundA "väris" (k10 "evä")) ; --UNCHK
lin jitters_N = mkWN (k40 "hermostuneisuus") ; --UNCHK
lin jittery_A = mkWA (compoundA "täris" (k10 "evä")) ;
lin jive_N = mkWN (k5 "swing") ; --UNCHK
lin jive_V = mkWV (k61 "tanssia") "jivea" ; --UNCHK
lin joanna_PN = foreignPN "Joanna" ;
lin job_N = mkN "työ" | mkN "työpaikka" ;
lin job_PN = foreignPN "Job" ;
lin job_V = mkWV (k67A "keinotella") ; --UNCHK
lin job_V2 = mkWV2 (k67A "keinotella") ; --UNCHK
lin jobber_N = mkWN (k10 "välittäjä") ; --UNCHK
lin jobbery_N = mkWN "korruptoituneisuus" ; --UNCHK
lin jobcentre_N = mkWN (compoundN "työnvälitys" (k2 "toimisto")) ; --UNCHK
lin jobholder_N = mkWN (compoundN "viran" (k12 "haltija")) ; --UNCHK
lin jockey_N = mkWN (compoundN "kilpa" (k10 "ratsastaja")) ; --UNCHK
lin jockey_V = mkWV (k53 "ohjastaa") "kilpahevosta" ; --UNCHK
lin jockey_V2 = mkWV2 (k53 "ohjastaa") "kilpahevosta" ; --UNCHK
lin jocose_A = mkWA (k41A "vitsikäs") ; --UNCHK
lin jocoseness_N = mkWN (k40 "humoristisuus") ; --UNCHK
lin jocosity_N = mkWN (k40 "humoristisuus") ; --UNCHK
lin jocular_A = mkWA (k41A "vitsikäs") ; --UNCHK
lin jocularity_N = mkWN (k40 "leikkisyys") ; --UNCHK
lin jocund_A = mkWA (k38 "iloinen") ; --UNCHK
lin jocundity_N = mkWN (k1 "riemu") ; --UNCHK
lin jodhpur_N = mkWN (compoundN "ratsastus" (k41A "saapas")) ; --UNCHK
lin joensuu_PN = mkPN "Joensuu" ;
lin jog_N = mkWN (k1A "työntö") ; --UNCHK
lin jog_V = mkWV (k53A "yllyttää") ; --UNCHK
lin jog_V2 = mkWV2 (k53A "yllyttää") ; --UNCHK
lin jog_trot_N = mkWN (k5 "ravi") "hidas" ; --UNCHK
lin jogger_N = mkWN (k10 "hölkkääjä") ; --UNCHK
lin jogging_N = mkWN (k2 "lenkkeily") ; --UNCHK
lin joggle_N = mkWN (k12 "tärinä") ; --UNCHK
lin joggle_V = mkWV (k71 "tehdä") "tappiliitos" ; --UNCHK
lin joggle_V2 = mkWV2 (k71 "tehdä") "tappiliitos" ; --UNCHK
lin johannesburg_PN = foreignPN "Johannesburg" ;
lin john_PN = L.john_PN ;
lin john_bull_N = mkWN (k5 "engelsmanni") ; --UNCHK
lin johnnycake_N = mkWN "maissipannukakku" ; --UNCHK
lin johnstone_PN = foreignPN "Johnstone" ;
lin joie_de_vivre_N = mkWN (compoundN "elämän" (k1 "ilo")) ; --UNCHK
lin join_N = mkWN (k48 "yhdiste") ; --UNCHK
lin join_V = mkV (mkV "tulla") "mukaan" ;
lin join_V2 = mkV2 "liittyä" illative ;
lin join_up_V = advV OP_join_V OP_up_Adv ; -- guess-p-verb
lin joiner_N = mkWN (compoundN "puu" (k10A "seppä")) ; --UNCHK
lin joinery_N = mkWN (compoundN "puusepän" (k19 "työ")) ; --UNCHK
lin joining_N = mkWN (k40 "yhteys") ; --UNCHK
lin joint_A = mkA (lin AK {s = d38 "yhteinen"}) ;
lin joint_N = mkWN (compoundN "kannabis" (k48A "savuke")) ; --UNCHK
lin joint_V2 = mkWV2 (k67A "paloitella") ; --UNCHK
lin jointer_N = mkWN (compoundN "sauma" (k10 "höylä")) ; --UNCHK
lin jointure_N = mkWN (compoundN "liitto" (k38 "utuminen")) ; --UNCHK
lin joist_N = mkWN (kH1 "vasa") ; --UNCHK
lin joke_N = mkN (lin NK {s = d05 "vitsi"}) ;
lin joke_V = mkWV (k67 "pilailla") ; --UNCHK
lin joker_N = mkWN (k6 "jokeri") ; --UNCHK
lin jokingly_Adv = mkWAdv (k99 "ironisesti") ; --UNCHK
lin jokioinen_PN = mkPN "Jokioinen" ;
lin jollity_N = mkWN (k40 "hilpeys") ; --UNCHK
lin jolly_A = mkWA (k38 "iloinen") ; --UNCHK
lin jolly_Adv = mkWAdv (k99 "ihan") ; --UNCHK
lin jolly_N = mkWN (k10 "jolla") ; --UNCHK
lin jolly_V2 = mkWV2 (k67 "pilailla") ; --UNCHK
lin jolt_N = mkWN (k39 "nytkähdys") ;
lin jolt_V = mkWV (k53A "järkyttää") ; --UNCHK
lin jolt_V2 = mkWV2 (k53A "järkyttää") ; --UNCHK
lin jolty_A = mkWA (k38 "kuoppainen") ; --UNCHK
lin jonah_N = mkWN (k9 "kirja") "Joonan" ; --UNCHK
lin jonquil_N = mkWN (compoundN "nunna" (k5 "narsissi")) ; --UNCHK
lin jordan_PN = foreignPN "Jordania" ;
lin jordanian_A = mkWA (compoundA "jordani" (k38 "alainen")) ; --UNCHK
lin jordanian_N = mkWN (compoundN "jordani" (k38 "alainen")) ; --UNCHK
lin joroinen_PN = mkPN "Joroinen" ;
lin jorum_N = mkWN "jorum" ; --UNCHK
lin joseph_PN = foreignPN "Joseph" ;
lin joshua_PN = foreignPN "Joshua" ;
lin joss_N = mkWN (compoundN "epä" (k10 "jumala")) ; --UNCHK
lin joss_house_N = mkWN (k6 "temppeli") "taolainen" ; --UNCHK
lin joss_stick_N = mkWN (k48A "suitsuke") ; --UNCHK
lin jostle_N = mkWN "töniminen" ; --UNCHK
lin jostle_V = mkWV (k61 "töniä") ; --UNCHK
lin jostle_V2 = mkWV2 (k61 "töniä") ; --UNCHK
lin jot_N = mkWN (compoundN "muistiin" (k1 "pano")) ; --UNCHK
lin jot_V2 = mkWV2 (k66 "sutaista") ; --UNCHK
lin jot_down_V2 = mkWV2 (k66 "sutaista") ; --UNCHK
lin jotter_N = mkWN (compoundN "muisti" (k1 "vihko")) ; --UNCHK
lin jotting_N = mkWN (compoundN "muistiin" (k1 "pano")) ; --UNCHK
lin journal_N = mkWN (compoundN "laakeri" (k9A "pinta")) ; --UNCHK
lin journalese_N = mkWN (compoundN "sanomalehti" (k5 "tyyli")) ; --UNCHK
lin journalism_N = mkWN (k5 "journalismi") ;
lin journalist_N = mkN "journalisti" ;
lin journalistic_A = mkWA (k38 "journalistinen") ; --UNCHK
lin journey_N = mkN "matka" ;
lin journey_V = mkWV (k53 "matkustaa") ; --UNCHK
lin journeyman_N = mkWN (k5 "artesaani") ; --UNCHK
lin joust_V = mkWV "turnailla" ; --UNCHK
lin joutsa_PN = mkPN "Joutsa" ;
lin joutseno_PN = mkPN "Joutseno" ;
lin jovial_A = mkWA (k38 "iloinen") ; --UNCHK
lin joviality_N = mkWN (k40 "hilpeys") ; --UNCHK
lin jowl_N = mkWN (k9A "leuka") ; --UNCHK
lin jowly_A = mkWA (compoundA "kaks" (k38 "oisleukainen")) ; --UNCHK
lin joy_N = mkWN (k1 "ilo") ; --UNCHK
lin joy_V = mkWV (k53A "ilahduttaa") ; --UNCHK
lin joyful_A = mkWA (k38 "iloinen") ; --UNCHK
lin joyfulness_N = mkWN (k1 "riemu") ; --UNCHK
lin joyless_A = mkWA (k34A "iloton") ; --UNCHK
lin joylessness_N = mkWN (k40 "ilottomuus") ; --UNCHK
lin joyous_A = mkWA (k41A "riemukas") ; --UNCHK
lin joyousness_N = mkWN (k1 "riemu") ; --UNCHK
lin joy_ride_N = mkWN (compoundN "huvi" (k2 "ajelu")) ; --UNCHK
lin joy_stick_N = mkWN (compoundN "sauva" (k33 "ohjain")) ; --UNCHK
lin juankoski_PN = mkPN (mkN "Juankoski" "Juankoskia") ;
lin jubilant_A = mkWA (k10 "voittoisa") ; --UNCHK
lin jubilation_N = mkWN (compoundN "ilo" (k38 "itseminen")) ; --UNCHK
lin jubilee_N = mkWN (compoundN "vuosi" (k10 "juhla")) ; --UNCHK
lin judaic_A = mkWA (k38 "juutalainen") ; --UNCHK
lin judaism_N = mkWN (k40 "juutalaisuus") ; --UNCHK
lin judas_N = mkWN (compoundN "ovi" (k10 "silmä")) ; --UNCHK
lin judder_V = mkWV (k66 "täristä") ; --UNCHK
lin judge_N = mkWN (k6 "tuomari") ; --f195
lin judge_V = mkWV (k67 "arvostella") ; --UNCHK
lin judge_V2 = mkWV2 (k67 "arvostella") ; --UNCHK
lin judge_VS = mkWVS (k67 "arvostella") ; --UNCHK
lin judgement_N = mkWN (k3 "arvio") ; --UNCHK
lin judgeship_N = mkWN (compoundN "tuomarin" (k9A "virka")) ; --UNCHK
lin judgment_N = mkWN (k3 "arvio") ; --UNCHK
lin judgmental_A = mkWA "tuomitseva" ; --UNCHK
lin judicable_A = mkWA (k10 "oleva") "ratkaistavissa" ; --UNCHK
lin judicial_A = mkWA (k38 "juridinen") ; --UNCHK
lin judiciary_N = mkWN (compoundN "tuomari" (k10A "kunta")) ;
lin judicious_A = mkWA (k41 "viisas") ; --UNCHK
lin judiciousness_N = mkWN (k40 "viisaus") ; --UNCHK
lin judo_N = mkWN (k1 "judo") ; --UNCHK
lin jug_N = mkWN (k1 "kannu") ; --UNCHK
lin jug_V2 = mkWV2 (k53A "hauduttaa") "savipadassa" ; --UNCHK
lin jugale_N = mkWN (k8 "jugale") ; --UNCHK
lin jugful_N = mkWN (k38 "kannullinen") ; --UNCHK
lin juggle_N = mkWN "jongleeraus" ; --UNCHK
lin juggle_V = mkWV (k53A "petkuttaa") ; --UNCHK
lin juggle_V2 = mkWV2 (k53A "petkuttaa") ; --UNCHK
lin jugglerMasc_N = mkWN (k5 "jonglööri") ; --UNCHK
lin jugglerFem_N = mkWN (k5 "jonglööri") ; --UNCHK
lin jugglery_N = mkWN (k1A "temppu") ; --UNCHK
lin jugular_A = mkWA "kaula-" ; --UNCHK
lin jugular_N = mkWN (kH1 "kohta") "heikko" ; --UNCHK
lin juice_1_N = mkWN (k48 "neste") ; --UNCHK
lin juice_2_N = mkWN (k48 "neste") ; --UNCHK
lin juice_up_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin juiceless_A = mkWA "nesteetön" ; --UNCHK
lin juiciness_N = mkWN (k40 "mehukkuus") ; --UNCHK
lin juicy_A = mkWA (k41A "mehukas") ; --UNCHK
lin juju_N = mkWN (k5 "fetissi") ; --UNCHK
lin jujube_N = mkWN (k38 "makeinen") "hyytelöity" ; --UNCHK
lin jujutsu_N = mkWN (k1 "jiujitsu") ; --UNCHK
lin juke_N = mkWN (k39 "harhautus") ; --UNCHK
lin jukebox_N = mkWN (k5 "jukeboksi") ; --UNCHK
lin julep_N = mkWN (k5 "grogi") ; --UNCHK
lin julian_A = mkWA "Juliaaninen" ; --UNCHK
lin julian_PN = foreignPN "Julian" ;
lin julienne_N = mkWN (compoundN "juli" (k48A "enne")) ; --UNCHK
lin jumble_N = mkWN (k1 "sotku") ; --UNCHK
lin jumble_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin jumble_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin jumbo_A = mkWA (k10 "valtava") ;
lin jumbojet_N = mkWN (compoundN "jumbo" (k5A "jetti")) ; --UNCHK
lin jumentous_A = mkWA "haiseva" ; --UNCHK
lin jump_N = mkN "hyppy" ; ---WN (k2 "ponkaisu") ;
lin jump_V = L.jump_V ;
lin jump_V2 = mkV2 "anastaa" ; --f77
lin jump_at_V2 = prepV2 OP_jump_V OP_at_Prep ; -- guess-p-verb
lin jump_in_V = advV OP_jump_V OP_in_Adv ; -- guess-p-verb
lin jump_on_V2 = mkWV2 (k73A "harpata") ; --UNCHK
lin jump_to_V2 = prepV2 OP_jump_V OP_to_Prep ; -- guess-p-verb
lin jumper_N = mkWN (k10 "hyppääjä") ; --UNCHK
lin jumpiness_N = mkWN (k40 "kärsimättömyys") ; --UNCHK
lin jumping_N = mkWN (k2 "ponkaisu") ; --UNCHK
lin jumpy_A = mkWA (k38 "kuoppainen") ; --UNCHK
lin jun_PN = foreignPN "Jun" ;
lin junco_N = mkWN "junco" ; --UNCHK
lin junction_N = mkWN (k39 "liitos") ; --UNCHK
lin juncture_N = mkWN (k39 "tapaus") ; --UNCHK
lin jungle_N = mkWN (k4A "viidakko") ; --UNCHK
lin jungly_A = mkWA (compoundA "viidakko" (k38 "mainen")) ; --UNCHK
lin junior_A = mkWA (k16A "alempi") ; --UNCHK
lin junior_N = mkWN "nuorempi" ; --UNCHK
lin juniper_N = mkWN (k10 "kataja") ; --UNCHK
lin junk_N = mkN "roska" ;
lin junk_V2 = mkWV2 (k53A "romuttaa") ; --UNCHK
lin junk_shop_N = mkWN "halpatavarakauppa" ; --UNCHK
lin junket_N = mkN "huvimatka" ; ---ARB ; herajuusto
lin junket_V = mkWV (k52 "osallistua") "juhliin" ; --UNCHK
lin junketing_N = mkWN (k2 "matkailu") ; --UNCHK
lin junkie_N = mkWN (k5 "entusiasti") ; --UNCHK
lin junky_N = mkWN (k5 "entusiasti") ; --UNCHK
lin junkyard_N = mkWN (compoundN "romu" (k48A "liike")) ; --UNCHK
lin junoesque_A = mkWA (k38 "veistoksellinen") ; --UNCHK
lin junta_N = mkWN (kH1 "juntta") ; --UNCHK
lin jupati_N = mkWN (compoundN "raffia" (k1 "palmu")) ; --UNCHK
lin jupiter_PN = foreignPN "Jupiter" ;
lin jural_A = mkWA (k38 "laillinen") ; --UNCHK
lin juridical_A = mkWA (k38 "juridinen") ; --UNCHK
lin jurisdiction_N = mkWN (k9A "valta") "oikeudellinen" ; --UNCHK
lin jurisdictional_A = mkWA (compoundA "oikeudenkäyttö" (k38 "alueellinen")) ; --UNCHK
lin jurisprudence_N = mkWN (k9A "juridiikka") ; --UNCHK
lin jurisprudential_A = mkWA (compoundA "oikeus" (k38 "opillinen")) ; --UNCHK
lin jurist_N = mkWN (k5 "juristi") ; --UNCHK
lin juror_N = mkWN (compoundN "lauta" (k42 "mies")) ; --UNCHK
lin jurva_PN = mkPN "Jurva" ;
lin jury_N = mkWN (compoundN "vala" (k2 "miehistö")) ; --f83
lin jury_box_N = mkWN (k3 "aitio") "valamiehistön" ; --UNCHK
lin jury_mast_N = mkWN (k1 "masto") "väliaikainen" ; --UNCHK
lin juryman_N = mkWN (compoundN "lauta" (k42 "mies")) ; --UNCHK
lin just_A = mkWA (k1 "reilu") ; --UNCHK
lin just_AdV = mkAdV "pelkästään" ;
lin just_Adv = mkAdv "juuri" ;
lin just_because_Subj = mkSubj "vain koska" ;
lin just_Predet = mkPredet "pelkästään" ;
lin justice_N = mkN "oikeus" ;
lin justiciar_N = mkWN (k6 "tuomari") ; --UNCHK
lin justiciary_N = mkWN (compoundN "toimi" (k9A "valta")) ; --UNCHK
lin justifiable_A = mkWA (k38 "aiheellinen") ; --UNCHK
lin justification_N = mkWN (k39 "oikeutus") ; --UNCHK
lin justificative_A = mkWA "puolusteltu" ; --UNCHK
lin justified_A = variants {} ; --
lin justify_V2 = mkV2 "oikeuttaa" ;
lin justify_VV = mkWVV (k73 "tasata") ; --UNCHK
lin justin_PN = foreignPN "Justin" ;
lin justness_N = mkWN (k40 "hienous") ; --UNCHK
lin jut_V = mkWV (k53A "sojottaa") ; --UNCHK
lin jute_N = mkWN (kH1 "juutti") ; --UNCHK
lin juuka_PN = mkPN "Juuka" ;
lin juupajoki_PN = mkPN (mkN "Juupajoki" "Juupajokia") ;
lin juva_PN = mkPN "Juva" ;
lin juvenescence_N = mkWN (k1 "kasvu") ; --UNCHK
lin juvenile_A = mkWA "nuoriso-" ; --UNCHK
lin juvenile_N = mkWN (k38 "ihminen") "nuori" ; --UNCHK
lin juxtapose_V2 = mkWV2 (k53A "asettaa") "vierekkäin" ; --UNCHK
lin juxtaposition_N = mkWN (k2 "asettelu") "vierekkäin" ; --UNCHK
lin jyväskylä_PN = mkPN "Jyväskylä" ;
lin jämijärvi_PN = mkPN (mkN "Jämijärvi" "Jämijärviä") ;
lin jämsä_PN = mkPN "Jämsä" ;
lin jämsänkoski_PN = mkPN (mkN "Jämsänkoski" "Jämsänkoskia") ;
lin jäppilä_PN = mkPN "Jäppilä" ;
lin järvelä_PN = mkPN "Järvelä" ;
lin järvenpää_PN = mkPN "Järvenpää" ;
lin kaarina_PN = mkPN "Kaarina" ;
lin kaavi_PN = mkPN "Kaavi" ;
lin kabbalism_N = mkWN (compoundN "kabbal" (k5 "ismi")) ; --UNCHK
lin kabob_N = mkWN (k5 "kebab") ; --UNCHK
lin kachina_N = mkWN (compoundN "kachina-" (k8A "nukke")) ; --UNCHK
lin kaffiyeh_N = mkWN "kaffiyeh" ; --UNCHK
lin kafkaesque_A = mkWA (compoundA "kafka" (k38 "mainen")) ; --UNCHK
lin kahikatea_N = mkWN "Podocarpus" "dacrydioides" ; --UNCHK
lin kail_N = mkWN (k5 "kaali") ; --UNCHK
lin kainite_N = mkWN (compoundN "kai" (k5A "niitti")) ; --UNCHK
lin kaiser_N = mkWN (compoundN "Kei" (k5 "sari")) ; --UNCHK
lin kajaani_PN = mkPN "Kajaani" ;
lin kakemono_N = mkWN (k1 "Kakemono") ; --UNCHK
lin kaki_N = mkWN (compoundN "kaki" (k18 "puu")) ; --UNCHK
lin kalajoki_PN = mkPN (mkN "Kalajoki" "Kalajokia") ;
lin kalansuwa_N = mkWN "kalansuwa" ; --UNCHK
lin kale_N = mkWN (k5 "kaali") ; --UNCHK
lin kaleidoscope_N = mkWN (compoundN "kuva" (k6 "kiikari")) ; --UNCHK
lin kaleidoscopic_A = mkWA (compoundA "kale" (k38 "idoskooppinen")) ; --UNCHK
lin kalemia_N = mkWN "kalemia" ; --UNCHK
lin kaliuresis_N = mkWN "kaluresis" ; --UNCHK
lin kalmia_N = mkWN "kalmia" ; --UNCHK
lin kalumpang_N = mkWN "Sterculia" "foetida" ; --UNCHK
lin kalvola_PN = mkPN "Kalvola" ;
lin kameez_N = mkWN "kameez" ; --UNCHK
lin kamikaze_N = mkWN "kamikaze" ; --UNCHK
lin kampong_N = mkWN "kampong" ; --UNCHK
lin kampuchean_A = mkWA (compoundA "kamputse" (k38 "alainen")) ; --UNCHK
lin kampuchean_N = mkWN (compoundN "kamputse" (k38 "alainen")) ; --UNCHK
lin kanamycin_N = mkWN "Kantrex" ; --UNCHK
lin kanchil_N = mkWN (compoundN "kääpiö" (k41 "kauris")) ; --UNCHK
lin kangaroo_N = mkWN (k2 "kenguru") ; --UNCHK
lin kangasala_PN = mkPN "Kangasala" ;
lin kangaslampi_PN = mkPN (mkN "Kangaslampi" "Kangaslampia") ;
lin kangasniemi_PN = mkPN (mkN "Kangasniemi" "Kangasniemiä") ;
lin kankaanpää_PN = mkPN "Kankaanpää" ;
lin kannonkoski_PN = mkPN (mkN "Kannonkoski" "Kannonkoskia") ;
lin kannus_PN = mkPN "Kannus" ;
lin kansas_PN = mkPN "Kansas" ;
lin kanzu_N = mkWN "kanzu" ; --UNCHK
lin kaohsiung_PN = foreignPN "Kaohsiung" ;
lin kaoliang_N = mkWN (compoundN "kaoliang-li" (k5 "kööri")) ; --UNCHK
lin kaolin_N = mkWN (k9 "alba") "terra" ; --UNCHK
lin kaolinite_N = mkWN (compoundN "kaoli" (k5A "niitti")) ; --UNCHK
lin kaon_N = mkWN "k-hiukkanen" ; --UNCHK
lin kapeika_N = mkWN "kapeika" ; --UNCHK
lin kaph_N = mkWN (kH1 "kappa") ; --UNCHK
lin kapok_N = mkWN (compoundN "kapokki" (k18 "puu")) ; --UNCHK
lin kappa_N = mkWN (kH1 "kappa") ; --UNCHK
lin kapuka_N = mkWN "Griselinia" "littoralis" ; --UNCHK
lin kaput_A = mkWA (k34A "toivoton") ; --UNCHK
lin karachi_PN = foreignPN "Karachi" ;
lin karaoke_N = mkWN (k8 "karaoke") ; --UNCHK
lin karat_N = mkWN (k5A "karaatti") ; --UNCHK
lin karate_N = mkWN (k8 "karate") ; --UNCHK
lin karhula_PN = mkPN "Karhula" ;
lin karijoki_PN = mkPN (mkN "Karijoki" "Karijokia") ;
lin karinainen_PN = mkPN "Karinainen" ;
lin karis_PN = mkPN "Karjaa" ;
lin karjalohja_PN = mkPN "Karjalohja" ;
lin karkkila_PN = mkPN "Karkkila" ;
lin karlsruhe_PN = foreignPN "Karlsruhe" ;
lin karma_N = mkWN (k9 "karma") ; --UNCHK
lin karstula_PN = mkPN "Karstula" ;
lin karttula_PN = mkPN "Karttula" ;
lin karvia_PN = mkPN "Karvia" ;
lin karyokinesis_N = mkWN "tuman" "jakautuminen" ; --UNCHK
lin karyokinetic_A = mkWA (compoundA "karyo" (k38 "kineettinen")) ; --UNCHK
lin karyolymph_N = mkWN (compoundN "tuma" (k48 "neste")) ; --UNCHK
lin karyolysis_N = mkWN (compoundN "karyoly" (k5 "ysi")) ; --UNCHK
lin karyotype_N = mkWN (compoundN "karyo" (k5A "tyyppi")) ; --UNCHK
lin kasbah_N = mkWN "kasbah" ; --UNCHK
lin kasha_N = mkWN "kasha" ; --UNCHK
lin kashmiri_A = mkWA "kašmirin" ; --UNCHK
lin kashmiri_N = mkWN (k5 "kašmiri") ; --UNCHK
lin kaskinen_PN = mkPN "Kaskinen" ;
lin kassel_PN = foreignPN "Kassel" ;
lin kat_N = mkWN "kati" ; --UNCHK
lin katabatic_A = mkWA "katabaattinen" ; --UNCHK
lin katamorphism_N = mkWN (compoundN "pintametamorf" (k5 "ismi")) ; --UNCHK
lin katharobe_N = mkWN (k5 "organismi") ; --UNCHK
lin katharobic_A = mkWA "katarobinen" ; --UNCHK
lin katharometer_N = mkWN (compoundN "mitta" (k48A "laite")) ; --UNCHK
lin katherine_PN = foreignPN "Katherine" ;
lin katowice_PN = foreignPN "Katowice" ;
lin katydid_N = mkWN (k5A "hepokatti") ; --UNCHK
lin kauhajoki_PN = mkPN (mkN "Kauhajoki" "Kauhajokia") ;
lin kauhava_PN = mkPN "Kauhava" ;
lin kauniainen_PN = mkPN "Kauniainen" ;
lin kauri_N = mkWN "kauri" ; --UNCHK
lin kaustinen_PN = mkPN "Kaustinen" ;
lin kava_N = mkWN "kava" ; --UNCHK
lin kawaka_N = mkWN (compoundN "setri" (k18 "puu")) ; --UNCHK
lin kazan_PN = foreignPN "Kazan" ;
lin kazoo_N = mkWN (compoundN "puhallin" (k33A "soitin")) ; --UNCHK
lin kea_N = mkWN "Nestor" "notabilis" ; --UNCHK
lin kebab_N = mkWN (k5 "kebab") ; --UNCHK
lin kedgeree_N = mkWN "kedgeree" ; --UNCHK
lin keel_N = mkWN (k5 "köli") ; --UNCHK
lin keel_V = mkWV (k62 "toikkaroida") ; --UNCHK
lin keel_V2 = mkWV2 (k62 "toikkaroida") ; --UNCHK
lin keel_over_V = mkWV (k52A "kaatua") ; --UNCHK
lin keelboat_N = mkWN (compoundN "köli" (k48 "vene")) ; --UNCHK
lin keelson_N = mkWN (compoundN "sisä" (k5 "köli")) ; --UNCHK
lin keen_A = mkWA (k9A "tarkka") ;
lin keen_N = mkWN (compoundN "itku" (k28 "virsi")) ; --UNCHK
lin keen_V = mkWV (k56 "laulaa") "itkuvirttä" ; --UNCHK
lin keen_V2 = mkWV2 (k56 "laulaa") "itkuvirttä" ; --UNCHK
lin keenness_N = mkWN (k40 "terävyys") ; --UNCHK
lin keep_N = mkWN (kH1 "koppi") ; --UNCHK
lin keep_V = mkV "pysyä" ;
lin keep_V2 = mkV2 "pitää" ;
lin keep_V2A = mkV2A (mkV "säilyttää") accusative (mkPrep essive) ;
lin keep_VV = mkVV "jatkaa" ; ---- ??? puhumista ; add more Inf3s in ParadigmsFin
lin keep_around_V2 = prepV2 OP_keep_V OP_around_Prep ; -- guess-p-verb
lin keep_at_V2 = prepV2 OP_keep_V OP_at_Prep ; -- guess-p-verb
lin keep_away_V2 = mkWV2 (k53A "pitää") "erossa" ; --UNCHK
lin keep_back_V = mkWV (k53A "pitää") "itsellään" ; --UNCHK
lin keep_back_V2 = mkWV2 (k53A "pitää") "itsellään" ; --UNCHK
lin keep_down_V2 = prepV2 OP_keep_V OP_down_Prep ; -- guess-p-verb
lin keep_from_V2 = prepV2 OP_keep_V OP_from_Prep ; -- guess-p-verb
lin keep_in_V2 = mkWV2 (k53A "pitää") "jossakin" ; --UNCHK
lin keep_ing_V2V = variants {} ; -- guess-p-verb
lin keep_off_V2 = mkWV2 (k52 "pysyä") "poissa" ; --UNCHK
lin keep_on_V = mkWV (k56 "jatkaa") ; --UNCHK
lin keep_on_V2 = mkWV2 (k56 "jatkaa") ; --UNCHK
lin keep_out_V = mkWV (k52 "pysyä") "poissa" ; --UNCHK
lin keep_out_V2 = mkWV2 (k52 "pysyä") "poissa" ; --UNCHK
lin keep_over_V2 = prepV2 OP_keep_V OP_over_Prep ; -- guess-p-verb
lin keep_to_V2 = prepV2 OP_keep_V OP_to_Prep ; -- guess-p-verb
lin keep_to_V2V = mkV2V (mkV "pitäytyä") (mkPrep genitive) infIness ;
lin keep_up_V = mkWV (k53A "pitää") "hereillä" ; --UNCHK
lin keep_up_V2 = mkWV2 (k53A "pitää") "hereillä" ; --UNCHK
lin keep_up_at_V2 = prepV2 (advV OP_keep_V OP_up_Adv ) OP_at_Prep ; -- guess-p-verb
lin keep_up_with_V2 = prepV2 (advV OP_keep_V OP_up_Adv ) OP_with_Prep ; -- guess-p-verb
lin keeper_N = mkWN (k6 "pehtori") ; --UNCHK
lin keeping_N = mkWN "pitäminen" ; --UNCHK
lin keepsake_N = mkWN (k1 "muisto") ; --UNCHK
lin keeshond_N = mkWN "keeshond" ; --UNCHK
lin keg_N = mkWN (k6 "lekkeri") ; --UNCHK
lin keighley_PN = foreignPN "Keighley" ;
lin keitele_PN = mkPN "Keitele" ;
lin keith_PN = foreignPN "Keith" ;
lin keloid_N = mkWN "keloidi" ; --UNCHK
lin kelp_N = mkWN (compoundN "rakko" (k10 "levä")) ; --UNCHK
lin kelpie_N = mkWN "australiankelpie" ; --UNCHK
lin kelpy_N = mkWN (compoundN "vetehis" (k38 "hevonen")) ; --UNCHK
lin kelso_PN = foreignPN "Kelso" ;
lin kelt_N = mkWN (k5A "keltti") ; --UNCHK
lin kelty_PN = foreignPN "Kelty" ;
lin kelvin_N = mkWN "William" "Thompson" ; --UNCHK
lin kemi_PN = mkPN "Kemi" ;
lin kemijärvi_PN = mkPN (mkN "Kemijärvi" "Kemijärviä") ;
lin keminmaa_PN = mkPN "Keminmaa" ;
lin kempele_PN = mkPN "Kempele" ;
lin kempt_A = mkWA (k5 "siisti") ; --UNCHK
lin kemsing_PN = foreignPN "Kemsing" ;
lin ken_N = mkWN (compoundN "näkö" (k10A "kenttä")) ; --UNCHK
lin kenaf_N = mkWN "Hibiscus" "cannabinus" ; --UNCHK
lin kendal_PN = foreignPN "Kendal" ;
lin kenilworth_PN = foreignPN "Kenilworth" ;
lin kennel_N = mkWN (k5A "koirankoppi") ; --UNCHK
lin kenning_N = mkWN (compoundN "kierto" (k2 "ilmaisu")) ; --UNCHK
lin kensington_PN = foreignPN "Kensington" ;
lin kent_PN = foreignPN "Kent" ;
lin kentucky_PN = mkPN "Kentucky" ;
lin kenya_PN = foreignPN "Kenia" ;
lin kenyan_A = mkWA (compoundA "keni" (k38 "alainen")) ; --UNCHK
lin kenyan_N = mkWN (compoundN "Keni" (k38 "alainen")) ; --UNCHK
lin kepi_N = mkWN "képi" ; --UNCHK
lin keratalgia_N = mkWN "keratalgia" ; --UNCHK
lin keratin_N = mkWN (k5 "keratiini") ; --UNCHK
lin keratinization_N = mkWN (compoundN "sarveis" (k38 "tuminen")) ; --UNCHK
lin keratitis_N = mkWN "keratiitti" ; --UNCHK
lin keratoacanthoma_N = mkWN (compoundN "keratoakanto" (k10 "oma")) ; --UNCHK
lin keratocele_N = mkWN (compoundN "keratoc" (k48 "ele")) ; --UNCHK
lin keratoconus_N = mkWN (compoundN "kartio" (k10 "pullistuma")) ; --UNCHK
lin keratoderma_N = mkWN "sarveisihoisuus" ; --UNCHK
lin keratohyalin_N = mkWN "keratohyaliini" ; --UNCHK
lin keratomalacia_N = mkWN (compoundN "keratomal" (k12 "asia")) ; --UNCHK
lin keratomycosis_N = mkWN (compoundN "sieni-" (k3 "infektio")) "sarveiskalvon" ; --UNCHK
lin keratonosis_N = mkWN (compoundN "iho" (k40 "sairaus")) ; --UNCHK
lin keratonosus_N = mkWN (k40 "sairaus") "sarveiskalvon" ; --UNCHK
lin keratoplasty_N = mkWN (k1A "siirto") "sarveiskalvon" ; --UNCHK
lin keratoscope_N = mkWN (compoundN "keratosko" (k5A "oppi")) ; --UNCHK
lin keratoscopy_N = mkWN "keratoskopia" ; --UNCHK
lin keratosis_N = mkWN (k10 "sarveistuma") ; --UNCHK
lin kerava_PN = mkPN "Kerava" ;
lin kerb_N = mkWN (k9 "reuna") "jalkakäytävän" ; --UNCHK
lin kerbstone_N = mkWN (compoundN "reuna" (k7 "kivi")) ; --UNCHK
lin kerchief_N = mkWN (k5 "huivi") ; --UNCHK
lin kerimäki_PN = mkPN (mkN "Kerimäki" "Kerimäkiä") ;
lin kerion_N = mkWN (k3 "infektio") "hiuspohjan" ; --UNCHK
lin kern_N = mkWN (k33 "kirjasin") ; --UNCHK
lin kernel_N = mkWN (k48A "piirre") "tärkeä" ; --UNCHK
lin kernicterus_N = mkWN "kernikterus" ; --UNCHK
lin kernite_N = mkWN (compoundN "ker" (k5A "niitti")) ; --UNCHK
lin kerosene_N = mkWN (k5 "kerosiini") ; --UNCHK
lin kerygma_N = mkWN (k9 "saarna") ; --UNCHK
lin kestilä_PN = mkPN "Kestilä" ;
lin kestrel_N = mkWN (compoundN "tuuli" (k9A "haukka")) ; --UNCHK
lin kesälahti_PN = mkPN (mkN "Kesälahti" "Kesälahtia") ;
lin ketamine_N = mkWN "Ketalar" ; --UNCHK
lin ketch_N = mkWN (k5 "ketsi") ; --UNCHK
lin ketchup_N = mkWN (k5A "ketsuppi") ; --UNCHK
lin keteleeria_N = mkWN "keteleeria" ; --UNCHK
lin ketembilla_N = mkWN (compoundN "hebec" (k9A "arpa")) "Dovyalis" ; --UNCHK
lin ketoacidosis_N = mkWN "diabeettinen" "ketoasidoosi" ; --UNCHK
lin ketohexose_N = mkWN (compoundN "ketohek" (k5 "soosi")) ; --UNCHK
lin ketone_N = mkWN (k5 "ketoni") ; --UNCHK
lin ketonemia_N = mkWN (kH1 "ketoosi") ; --UNCHK
lin ketonuria_N = mkWN "asetonuria" ; --UNCHK
lin ketoprofen_N = mkWN "Oruvail" ; --UNCHK
lin ketorolac_N = mkWN "Torodal" ; --UNCHK
lin ketose_N = mkWN (kH1 "ketoosi") ; --UNCHK
lin ketosteroid_N = mkWN (compoundN "keto" (k5 "steroidi")) ; --UNCHK
lin kettering_PN = foreignPN "Kettering" ;
lin kettle_N = mkWN (k6 "boileri") ; --UNCHK
lin kettledrum_N = mkWN (kH1 "pata") ; --UNCHK
lin keurboom_N = mkWN "Virgilia" "oroboides" ; --UNCHK
lin keuruu_PN = mkPN "Keuruu" ;
lin key_1_N = mkN "avain" "avaimen" "avaimia" ;
lin key_2_N = mkN "sävel" (mkN "laji") ;
lin key_3_N = mkWN (k33 "avain") ; ---- sense to be split
lin key_A = mkA "ratkaiseva" ;
lin key_N = mkWN (k33 "avain") ;
lin key_V2 = mkWV2 (k74 "tuhota") ; --UNCHK
lin keyboard_N = mkN "näppäimistö" ; --mkWN (compoundN "avain" (k48A "pidike")) ;
lin keyboardist_N = mkWN (compoundN "kosketin" (k10 "soittaja")) ; --UNCHK
lin keycard_N = mkWN (compoundN "avain" (k5A "kortti")) ; --UNCHK
lin keyhole_N = mkWN (compoundN "avaimen" (k10A "reikä")) ; --UNCHK
lin keyless_A = mkWA "avaimeton" ; --UNCHK
lin keynote_N = mkWN (compoundN "pää" (k39 "ajatus")) ; --UNCHK
lin keynsham_PN = foreignPN "Keynsham" ;
lin keystone_N = mkWN (compoundN "laki" (k7 "kivi")) ; --UNCHK
lin keystroke_N = mkWN (k39 "painallus") ; --UNCHK
lin kg_N = mkWN (kH1 "kilo") ; --UNCHK
lin kgb_N = mkWN (compoundN "turvallisuus" (k12 "komitea")) "SNTL:n" "valtion" ; --UNCHK
lin khadi_N = mkWN (k9 "puuvilla") ; --UNCHK
lin khaki_A = mkWA (compoundA "khakin" (k38 "värinen")) ; --UNCHK
lin khaki_N = mkWN (k5 "khaki") ; --UNCHK
lin khalka_N = mkWN "halha" ; --UNCHK
lin khamsin_N = mkWN (compoundN "khamsin-" (k26 "tuuli")) ; --UNCHK
lin khan_N = mkWN (compoundN "maja" (k1 "talo")) ; --UNCHK
lin khanate_N = mkWN (compoundN "kha" (k5A "naatti")) ; --UNCHK
lin khartoum_PN = foreignPN "Khartum" ;
lin khmer_N = mkWN (k5 "khmer") ; --UNCHK
lin khoum_N = mkWN "khoum" ; --UNCHK
lin khukuri_N = mkWN (compoundN "khu" (k5 "kuri")) ; --UNCHK
lin kiang_N = mkWN "Equus" "kiang" ; --UNCHK
lin kibble_N = mkWN (compoundN "nosto" (k9 "kauha")) ; --UNCHK
lin kibbutz_N = mkWN (k5 "kibbutsi") ; --UNCHK
lin kibbutznik_N = mkWN (compoundN "kibbutsi" (k38 "lainen")) ; --UNCHK
lin kibe_N = mkWN (k1 "kyhmy") ; --UNCHK
lin kibibit_N = mkWN (compoundN "kibi" (k5A "bitti")) ; --UNCHK
lin kibitzer_N = mkWN (compoundN "taka" (k1 "piru")) ; --UNCHK
lin kick_N = mkWN (kH1 "potku") ; --UNCHK
lin kick_V = mkV "potkia" ;
lin kick_V2 = mkV2 (mkV "potkaista") partitive ;
lin kick_about_V2 = mkWV2 (k67 "oleilla") ; --UNCHK
lin kick_around_V2 = mkWV2 (k61A "pohtia") ; --UNCHK
lin kick_around_with_V2 = prepV2 (advV OP_kick_V OP_around_Adv ) OP_with_Prep ; -- guess-p-verb
lin kick_back_V = mkWV (k66 "potkaista") ; --UNCHK
lin kick_back_V2 = mkWV2 (k66 "potkaista") ; --UNCHK
lin kick_down_V2 = mkWV2 (k66 "potkaista") "hajalle" ; --UNCHK
lin kick_in_V = mkWV (k66 "potkaista") "hajalle" ; --UNCHK
lin kick_in_V2 = mkWV2 (k66 "potkaista") "hajalle" ; --UNCHK
lin kick_off_V = mkWV (k56A "alkaa") ; --UNCHK
lin kick_off_V2 = mkWV2 (k56A "alkaa") ; --UNCHK
lin kick_out_V2 = mkWV2 (k56A "antaa") "potkut" ; --UNCHK
lin kick_start_N = mkWN (compoundN "poljin" (k39 "käynnistys")) ; --UNCHK
lin kick_starter_N = mkWN (compoundN "poljin" (k39 "käynnistys")) ; --UNCHK
lin kick_through_V = advV OP_kick_V OP_through_Adv ; -- guess-p-verb
lin kick_up_V = mkWV (k53A "nostattaa") ; --UNCHK
lin kickback_N = mkWN (k39 "lahjus") ;
lin kicker_N = mkWN (compoundN "potkai" (k9 "sija")) ; --UNCHK
lin kickoff_N = mkWN (k1 "alkupotku") ; --UNCHK
lin kicksorter_N = mkWN (compoundN "pulssi" (k6 "analysaattori")) ; --UNCHK
lin kickstand_N = mkWN (k9A "jalka") ; --UNCHK
lin kid_N = mkN "lapsi" ; ---ARB mkWN (k10 "vohla") ;
lin kid_V = mkWV (k73 "narrata") ; --UNCHK
lin kid_V2 = mkWV2 (k73 "narrata") ; --UNCHK
lin kidderminster_PN = foreignPN "Kidderminster" ;
lin kiddy_N = mkWN (k29 "lapsi") ; --UNCHK
lin kidlington_PN = foreignPN "Kidlington" ;
lin kidnap_V2 = mkWV2 (k64 "viedä") ; --UNCHK
lin kidnapper_N = mkWN (k10 "kidnappaaja") ; --UNCHK
lin kidnapping_N = mkWN (k39 "kidnappaus") ;
lin kidney_N = mkWN (k38 "munuainen") ; --UNCHK
lin kidney_bean_N = mkWN (compoundN "tarha" (k1A "papu")) ; --UNCHK
lin kidsgrove_PN = foreignPN "Kidsgrove" ;
lin kieserite_N = mkWN (compoundN "kiese" (k5A "riitti")) ; --UNCHK
lin kiev_PN = foreignPN "Kiova" ;
lin kihniö_PN = mkPN "Kihniö" ;
lin kiihtelysvaara_PN = mkPN "Kiihtelysvaara" ;
lin kiikala_PN = mkPN "Kiikala" ;
lin kiikoinen_PN = mkPN "Kiikoinen" ;
lin kiiminki_PN = mkPN "Kiiminki" ;
lin kike_N = mkWN (k1 "jutsku") ; --UNCHK
lin kilbirnie_PN = foreignPN "Kilbirnie" ;
lin kildare_PN = foreignPN "Kildare" ;
lin kilderkin_N = mkWN "kilderkin" ; --UNCHK
lin kilkenny_PN = foreignPN "Kilkenny" ;
lin kill_N = mkN "tappo" ;
lin kill_V = mkV "tappaa" ;
lin kill_V2 = L.kill_V2 ;
lin kill_off_V2 = prepV2 OP_kill_V OP_off_Prep ; -- guess-p-verb
lin killable_A = mkWA "tappava" ; --UNCHK
lin killarney_PN = foreignPN "Killarney" ;
lin killer_N = mkN "tappaja" ; --mkWN (compoundN "miekka" (k41 "valas")) ;
lin killifish_N = mkWN (compoundN "kulta" (k10 "korva")) ; --UNCHK
lin killing_N = mkN "tappaminen" ;
lin killingly_Adv = mkWAdv (k99 "hauskasti") "hurjan" ; --UNCHK
lin killjoy_N = mkWN (k50 "hapannaama") ; --UNCHK
lin kilmarnock_PN = foreignPN "Kilmarnock" ;
lin kiln_N = mkWN (k5 "uuni") ; --UNCHK
lin kilo_N = mkWN (kH1 "kilo") ; --UNCHK
lin kilo_PN = mkPN "Kilo" ;
lin kilobit_N = mkWN (compoundN "kilo" (k5A "bitti")) ; --UNCHK
lin kilobyte_N = mkWN (compoundN "kilo" (k5A "bitti")) ; --UNCHK
lin kilocycle_N = mkWN (compoundN "kilo" (k5 "hertsi")) ; --UNCHK
lin kilogram_N = mkWN (kH1 "kilo") ; --UNCHK
lin kilohertz_N = mkWN (compoundN "kilo" (k5 "hertsi")) ; --UNCHK
lin kilolitre_N = mkWN (compoundN "kuutio" (k5 "metri")) ; --UNCHK
lin kilometre_N = mkWN (compoundN "kilo" (k5 "metri")) ; --UNCHK
lin kiloton_N = mkWN (compoundN "kilo" (k5 "tonni")) ; --UNCHK
lin kilovolt_N = mkWN (k5A "kilovoltti") ; --UNCHK
lin kilowatt_N = mkWN (compoundN "kilo" (k5A "watti")) ; --UNCHK
lin kilsyth_PN = foreignPN "Kilsyth" ;
lin kilt_N = mkWN (kH1 "kiltti") ; --UNCHK
lin kilter_N = mkWN (k39 "järjestys") ; --UNCHK
lin kilwinning_PN = foreignPN "Kilwinning" ;
lin kimberley_PN = foreignPN "Kimberley" ;
lin kimberlite_N = mkWN "kimberliitti" ; --UNCHK
lin kimito_PN = mkPN "Kemiö" ;
lin kimono_N = mkWN (k2 "kimono") ; --UNCHK
lin kin_N = mkWN (k1 "heimo") ; --UNCHK
lin kina_N = mkWN (kH1 "kina") ; --UNCHK
lin kinanesthesia_N = mkWN (compoundN "liike" (k5 "aisti")) ; --UNCHK
lin kinase_N = mkWN (compoundN "kin" (k5 "aasi")) ; --UNCHK
lin kind_A = mkWA (k38 "ystävällinen") ;
lin kind_N = mkN "laji" ;
lin kinda_Adv = mkWAdv (k99 "melko") ; --UNCHK
lin kindergarten_N = mkWN (k9 "tarha") ; --UNCHK
lin kindhearted_A = mkWA (compoundA "hyvä" (k38 "sydäminen")) ; --UNCHK
lin kindheartedness_N = mkWN (compoundN "hyväsydäm" (k40 "isyys")) ; --UNCHK
lin kindle_V = mkWV (k53A "synnyttää") ; --UNCHK
lin kindle_V2 = mkWV2 (k53A "synnyttää") ; --UNCHK
lin kindliness_N = mkWN (k40 "auttavaisuus") ; --UNCHK
lin kindling_N = mkWN (k39 "sytytys") ; --UNCHK
lin kindly_A = variants {} ;
lin kindness_N = mkWN (k1A "teko") "hyväntahtoinen" ; --UNCHK
lin kindred_A = mkWA "sukulaiset" ; --UNCHK
lin kindred_N = mkWN (k1 "heimo") ; --UNCHK
lin kinematics_N = mkWN (k9A "kinematiikka") ; --UNCHK
lin kinescope_N = mkWN (compoundN "kuva" (k7 "putki")) ; --UNCHK
lin kinesiology_N = mkWN "kinesiologia" ; --UNCHK
lin kinesis_N = mkWN "kineesi" ; --UNCHK
lin kinesthesia_N = mkWN (compoundN "liike" (k5 "aisti")) ; --UNCHK
lin kinesthesis_N = mkWN (compoundN "liike" (k5 "aisti")) ; --UNCHK
lin kinesthetic_A = mkWA (k38 "kinesteettinen") ; --UNCHK
lin kinetic_A = mkWA (k38 "kineettinen") ; --UNCHK
lin kinetics_N = mkWN (k9A "kinetiikka") ; --UNCHK
lin king_N = L.king_N ;
lin kingbird_N = mkWN (compoundN "piha" (k5 "tyranni")) ; --UNCHK
lin kingbolt_N = mkWN (compoundN "olka" (k5A "tappi")) ; --UNCHK
lin kingcup_N = mkWN (k5A "leinikki") ; --UNCHK
lin kingdom_N = mkWN (k10A "kunta") ; --UNCHK
lin kingfish_N = mkWN "Seriola" "grandis" ; --UNCHK
lin kingfisher_N = mkWN (compoundN "kuningas" (k10 "kalastaja")) ; --UNCHK
lin kinglet_N = mkWN (compoundN "amerikan" (k38 "hippiäinen")) ; --UNCHK
lin kinglike_A = mkWA (k38 "kuninkaallinen") ; --UNCHK
lin kingly_A = mkWA (k38 "kuninkaallinen") ; --UNCHK
lin kingmaker_N = mkWN (compoundN "kuninkaan" (k12 "tekijä")) ; --UNCHK
lin kingpin_N = mkWN (compoundN "ykkös" (k9 "keila")) ; --UNCHK
lin kingsbury_PN = foreignPN "Kingsbury" ;
lin kingship_N = mkWN (k40 "kuninkuus") ; --UNCHK
lin kingsteignton_PN = foreignPN "Kingsteignton" ;
lin kingston_PN = foreignPN "Kingston" ;
lin kingwood_N = mkWN (compoundN "ruusu" (k18 "puu")) "Brasilian" ; --UNCHK
lin kinin_N = mkWN (k5 "kiniini") ; --UNCHK
lin kink_N = mkWN (kH1 "vika") ; --UNCHK
lin kink_V = mkWV (k52A "kiertyä") ; --UNCHK
lin kink_V2 = mkWV2 (k52A "kiertyä") ; --UNCHK
lin kinkajou_N = mkWN "Perodicticus" "potto" ; --UNCHK
lin kinky_A = mkWA (k1A "outo") ; --UNCHK
lin kinnula_PN = mkPN "Kinnula" ;
lin kino_N = mkWN (k1 "kino") ; --UNCHK
lin kinshasa_PN = foreignPN "Kinshasa" ;
lin kinship_N = mkWN (compoundN "saman" (k40 "kaltaisuus")) ; --UNCHK
lin kinsman_N = mkWN (compoundN "sukulais" (k42 "mies")) ; --UNCHK
lin kinswoman_N = mkWN (compoundN "nais" (k38 "sukulainen")) ; --UNCHK
lin kiosk_N = mkWN (kH1 "koppi") ; --UNCHK
lin kip_1_N = mkWN (k5A "kippi") ; --UNCHK
lin kip_2_N = mkWN (k5A "kippi") ; --UNCHK
lin kip_V = mkWV (k52A "torkkua") ; --UNCHK
lin kip_down_V = mkWV (k67 "mennä") "sänkyyn" ; --UNCHK
lin kipper_N = mkWN (compoundN "savu" (k5 "silli")) ; --UNCHK
lin kirk_N = mkWN (k1A "kirkko") ; --UNCHK
lin kirkby_PN = foreignPN "Kirkby" ;
lin kirkcaldy_PN = foreignPN "Kirkcaldy" ;
lin kirkham_PN = foreignPN "Kirkham" ;
lin kirkintilloch_PN = foreignPN "Kirkintilloch" ;
lin kirkkonummi_PN = mkPN (mkN "Kirkkonummi" "Kirkkonummia") ;
lin kirkwall_PN = foreignPN "Kirkwall" ;
lin kirpan_N = mkWN "kirpan" ; --UNCHK
lin kirsch_N = mkWN (compoundN "kirsikka" (k9 "viina")) ; --UNCHK
lin kirtle_N = mkWN "kirtle" ; --UNCHK
lin kishke_N = mkWN "täytetty" "derma" ; --UNCHK
lin kisko_PN = mkPN "Kisko" ;
lin kiss_N = mkN "suudelma" ;
lin kiss_V2 = mkV2 (mkV "suudella") partitive | mkWV2 (k73 "pussata") ;
lin kiss_off_V = advV (lin V OP_kiss_V2) OP_off_Adv ; -- guess-p-verb
lin kiss_off_V2 = prepV2 (lin V OP_kiss_V2) OP_off_Prep ; -- guess-p-verb
lin kiss_up_to_V2 = prepV2 (advV (lin V OP_kiss_V2) OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin kisser_N = mkN "suutelija" ;
lin kit_N = mkWN (k1A "pentu") ; --UNCHK
lin kit_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin kitbag_N = mkWN (compoundN "merimies" (k5A "säkki")) ; --UNCHK
lin kitchen_N = mkWN (k3 "keittiö") ;
lin kitchenette_N = mkWN (compoundN "keitto" (k2 "komero")) ; --UNCHK
lin kite_N = mkWN (compoundN "haara" (k9A "haukka")) ; --UNCHK
lin kite_balloon_N = mkWN (compoundN "leija" (k1 "pallo")) ; --UNCHK
lin kitee_PN = mkPN "Kitee" ;
lin kitsch_N = mkWN (k10 "rihkama") ; --UNCHK
lin kitten_N = mkWN (k38 "poikanen") ; --UNCHK
lin kittenish_A = mkWA (k10 "eloisa") ; --UNCHK
lin kittilä_PN = mkPN "Kittilä" ;
lin kittiwake_N = mkWN (compoundN "pikku" (k10 "kajava")) ; --UNCHK
lin kitty_N = mkWN (k1 "kisu") ; --UNCHK
lin kiukainen_PN = mkPN "Kiukainen" ;
lin kiuruvesi_PN = mkPN (mkN "Kiuruvesi" "Kiuruvesia") ;
lin kivijärvi_PN = mkPN (mkN "Kivijärvi" "Kivijärviä") ;
lin kiwi_N = mkWN (k5 "kiivi") ; --UNCHK
lin klavern_N = mkWN "klavern" ; --UNCHK
lin klaxon_N = mkWN (k7 "torvi") ; --UNCHK
lin klebsiella_N = mkWN "klebsiella" ; --UNCHK
lin kleenex_N = mkWN "Kleenex" ; --UNCHK
lin kleptomania_N = mkWN (k12 "kleptomania") ; --UNCHK
lin kleptomaniac_N = mkWN (k5 "kleptomaani") ; --UNCHK
lin klondike_N = mkWN "klondike" ; --UNCHK
lin kludge_N = mkWN (k10 "kokoelma") ; --UNCHK
lin klutz_N = mkWN (k39 "typerys") ; --UNCHK
lin klystron_N = mkWN "klystroni" ; --UNCHK
lin km_N = mkWN (compoundN "kilo" (k5 "metri")) ; --UNCHK
lin knack_N = mkWN (k1A "taito") ; --UNCHK
lin knackered_A = mkWA (k99 "puhki") ; --UNCHK
lin knackwurst_N = mkWN (kH1 "nakki") ; --UNCHK
lin knap_V2 = mkWV2 (k54A "murtaa") ; --UNCHK
lin knapsack_N = mkWN (k9A "rinkka") ; --UNCHK
lin knapweed_N = mkWN (k5A "kaunokki") ; --UNCHK
lin knaresborough_PN = foreignPN "Knaresborough" ;
lin knave_N = mkWN (k41 "sotilas") ; --UNCHK
lin knavery_N = mkWN (compoundN "epä" (k40 "rehellisyys")) ; --UNCHK
lin knavish_A = mkWA (k10 "näppärä") ; --UNCHK
lin knawel_N = mkWN (compoundN "viherjäsen" (k1 "ruoho")) ; --UNCHK
lin knead_V = mkWV (k52 "hieroa") ; --UNCHK
lin knead_V2 = mkWV2 (k52 "hieroa") ; --UNCHK
lin knee_N = L.knee_N ;
lin kneecap_N = mkWN (compoundN "polvi" (k3 "lumpio")) ; --UNCHK
lin kneel_N = mkWN (compoundN "polvi" (k38 "stuminen")) ; --UNCHK
lin kneel_V = mkWV (k52 "polvistua") ; --UNCHK
lin kneeler_N = mkWN (k5A "penkki") ; --UNCHK
lin knell_N = mkN "kuolin" (mkN "kello") ;
lin knick_knack_N = mkWN (k10 "rihkama") ; --UNCHK
lin knife_N = mkWN (k30 "veitsi") ; --UNCHK
lin knife_V2 = mkWV2 (k53A "puukottaa") ; --UNCHK
lin knife_edge_N = mkWN (k9 "reuna") "veitsen" "terävä" ; --UNCHK
lin knifelike_A = mkWA (compoundA "veitsen" (k10 "terävä")) ; --UNCHK
lin knight_N = mkWN (k1 "ratsu") ; --UNCHK
lin knight_V2 = mkWV2 (k64 "lyödä") "ritariksi" ; --UNCHK
lin knighthood_N = mkWN (k1 "ritaristo") ; --UNCHK
lin knightly_A = mkWA (k41 "kohtelias") ; --UNCHK
lin kniphofia_N = mkWN (compoundN "soihtu" (k9 "lilja")) ; --UNCHK
lin knish_N = mkWN "knish" ; --UNCHK
lin knit_N = mkWN (k48 "neule") ; --UNCHK
lin knit_V = mkWV (k53 "mutristaa") ; --UNCHK
lin knit_V2 = mkWV2 (k53 "mutristaa") ; --UNCHK
lin knitter_N = mkWN (k10 "neuloja") ; --UNCHK
lin knitting_N = mkWN (k9A "neulonta") ; --UNCHK
lin knitting_machine_N = mkWN (compoundN "neule" (k48 "kone")) ; --UNCHK
lin knitting_needle_N = mkWN (k1A "puikko") ; --UNCHK
lin knitwear_N = mkN "neule" ;
lin knob_N = mkWN (compoundN "käden" (k9 "sija")) ; --UNCHK
lin knobble_N = mkWN (k12 "muhkura") "pieni" ; --UNCHK
lin knobbly_A = mkWA (k38 "kuhmurainen") ; --UNCHK
lin knobby_A = mkWA (k38 "kuhmurainen") ; --UNCHK
lin knobkerrie_N = mkWN (compoundN "puu" (k10 "nuija")) ; --UNCHK
lin knock_N = mkWN (k39 "läimäys") ; --UNCHK
lin knock_V = mkV "koputtaa" ; ---ARB mkWV (k61A "moittia") ;
lin knock_V2 = mkWV2 (k61A "moittia") ; --UNCHK
lin knock_about_V2 = mkWV2 (k53A "jyskyttää") ; --UNCHK
lin knock_around_V2 = prepV2 OP_knock_V OP_around_Prep ; -- guess-p-verb
lin knock_back_V2 = mkWV2 (k61 "kärsiä") ; --UNCHK
lin knock_down_V2 = mkWV2 (k53A "vetää") "maahan" ; --UNCHK
lin knock_it_off_V2 = variants {} ; -- guess-p-verb
lin knock_off_V = mkWV (k53A "lopettaa") ; --UNCHK
lin knock_off_V2 = mkWV2 (k53A "lopettaa") ; --UNCHK
lin knock_on_N = mkWN (k39 "pudotus") "pallon" ; --UNCHK
lin knock_out_V = mkWV (k74 "tuhota") ; --UNCHK
lin knock_out_V2 = mkWV2 (k74 "tuhota") ; --UNCHK
lin knock_over_V = mkWV (k57A "kaataa") "ympäri" ; --UNCHK
lin knock_together_V2 = mkV2 (advV OP_knock_V OP_together_Adv ) ; -- guess-p-verb
lin knock_up_V = mkWV (k53A "siittää") ; --UNCHK
lin knock_up_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin knockabout_A = mkWA (compoundA "tarkoite" (k1 "ttu")) "kovaan" "käyttöön" ; --UNCHK
lin knockabout_N = mkWN "pieni" "sluuppi" ; --UNCHK
lin knockdown_A = mkWA "helposti" "koottava" ; --UNCHK
lin knockdown_N = mkWN (k1 "isku") ; --UNCHK
lin knocker_N = mkWN (k33A "kolkutin") ; --UNCHK
lin knockoff_N = mkWN (k10 "jäljitelmä") ; --UNCHK
lin knockout_A = mkWA (k1 "raju") ; --UNCHK
lin knockout_N = mkWN (k39 "tyrmäys") ; --UNCHK
lin knoll_N = mkWN (k41A "mätäs") ; --UNCHK
lin knot_N = mkWN (compoundN "iso" (k5 "sirri")) ; --UNCHK
lin knot_V = mkWV (k61 "solmia") ; --UNCHK
lin knot_V2 = mkWV2 (k61 "solmia") ; --UNCHK
lin knotgrass_N = mkWN (k32A "tatar") ; --UNCHK
lin knothole_N = mkWN (compoundN "oksan" (k10A "reikä")) ; --UNCHK
lin knottingley_PN = foreignPN "Knottingley" ;
lin knotty_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin knout_N = mkWN (k10 "ruoska") ; --UNCHK
lin know_N = mkWN (k40 "tietoisuus") ; --UNCHK
lin know_V = mkV "tietää" ;
lin know_V2 = L.know_V2 ;
lin know_VQ = L.know_VQ ;
lin know_VS = L.know_VS ;
lin knowable_A = mkWA (k10 "ymmärrettävä") ; --UNCHK
lin knower_N = mkWN (k10 "tietäjä") ; --UNCHK
lin knowing_N = mkWN (k1A "tieto") ; --UNCHK
lin knowingness_N = mkWN (k40 "tietoisuus") ; --UNCHK
lin knowledge_N = mkN "tieto" ;
lin knowledgeability_N = mkWN (k40 "perehtyneisyys") ; --UNCHK
lin knowledgeable_A = mkWA (k47 "perehtynyt") ;
lin known_A = mkA "tunnettu" ;
lin knuckle_N = mkWN (k38 "rystynen") ; --UNCHK
lin knuckle_V = mkWV (k52A "ampua") ; --UNCHK
lin knuckle_down_V = mkWV (k67 "ponnistella") ; --UNCHK
lin knuckle_under_V = mkWV (k53A "luovuttaa") ; --UNCHK
lin knuckleball_N = mkWN (compoundN "baseball-" (k1A "syöttö")) ; --UNCHK
lin knutsford_PN = foreignPN "Knutsford" ;
lin ko_N = mkWN (k39 "tyrmäys") ; --UNCHK
lin koala_N = mkWN (k9 "koala") ; --UNCHK
lin koan_N = mkWN "koan" ; --UNCHK
lin kob_N = mkWN (compoundN "kob" (k5A "antilooppi")) ; --UNCHK
lin kobe_PN = foreignPN "Kobe" ;
lin koblenz_PN = foreignPN "Koblenz" ;
lin kobo_N = mkWN "kobo" ; --UNCHK
lin kohl_N = mkWN (k5 "kajaali") ; --UNCHK
lin kohleria_N = mkWN (compoundN "narrin" (k9A "hiippa")) ; --UNCHK
lin kohlrabi_N = mkWN (compoundN "kyssä" (k5 "kaali")) ; --UNCHK
lin koinonia_N = mkWN "koinonia" ; --UNCHK
lin kokemäki_PN = mkPN (mkN "Kokemäki" "Kokemäkia") ;
lin kokkola_PN = mkPN "Kokkola" ;
lin kola_N = mkWN "Musgoi" ; --UNCHK
lin kola_nut_N = mkWN (compoundN "koola" (k18 "puu")) ; --UNCHK
lin kolari_PN = mkPN "Kolari" ;
lin kolkhoz_N = mkWN (k6 "kolhoosi") ; --UNCHK
lin kolkhoznik_N = mkWN (k32 "jäsen") "kolhoosin" ; --UNCHK
lin komondor_N = mkWN "komondor" ; --UNCHK
lin konini_N = mkWN (compoundN "veren" (k12 "pisara")) ; --UNCHK
lin konnevesi_PN = mkPN (mkN "Konnevesi" "Konneveden" "Konnevesiä") ;
lin kontiolahti_PN = mkPN (mkN "Kontiolahti" "Kontiolahtia") ;
lin kook_N = mkWN (k1 "hullu") ; --UNCHK
lin kookaburra_N = mkWN "Dacelo" "gigas" ; --UNCHK
lin kopeck_N = mkWN (k14A "kopeekka") ; --UNCHK
lin kopek_N = mkWN (k14A "kopeekka") ; --UNCHK
lin kopiyka_N = mkWN (k14A "kopeekka") ; --UNCHK
lin kopje_N = mkWN (k48 "kumpare") ; --UNCHK
lin koppie_N = mkWN (k48 "kumpare") ; --UNCHK
lin koran_N = mkWN (k5 "Koraani") ; --UNCHK
lin koranic_A = mkWA "Koraanin" ; --UNCHK
lin korea_PN = mkPN "Korea" ;
lin korean_A = mkA "korealainen" ;
lin korean_N = mkWN (kH1 "korea") ; --UNCHK
lin korpilahti_PN = mkPN (mkN "Korpilahti" "Korpilahtia") ;
lin korsholm_PN = mkPN "Korsholm" ;
lin korsnäs_PN = mkPN "Korsnäs" ;
lin kortesjärvi_PN = mkPN (mkN "Kortesjärvi" "Kortesjärviä") ;
lin koruna_N = mkWN "koruna" ; --UNCHK
lin kos_N = mkWN "kos" ; --UNCHK
lin kosher_A = mkWA (k5 "košer") ; --UNCHK
lin kosher_N = mkWN "kosher" ; --UNCHK
lin koski_PN = mkPN (mkN "Koski" "Koskia") ;
lin kotka_PN = mkPN "Kotka" ;
lin koto_N = mkWN (kH1 "koto") ; --UNCHK
lin kotow_N = mkWN (k39 "tervehdys") "kiinalainen" "nöyrä" ; --UNCHK
lin kotow_V = mkWV (k68 "pokkuroida") ; --UNCHK
lin koukkuniemi_PN = mkPN (mkN "Koukkuniemi" "Koukkuniemiä") ;
lin koumiss_N = mkWN (k5 "kumissi") ; --UNCHK
lin kouvola_PN = mkPN "Kouvola" ;
lin kowhai_N = mkWN (compoundN "pagodi" (k18 "puu")) ; --UNCHK
lin kowtow_N = mkWN (k39 "tervehdys") "kiinalainen" "nöyrä" ; --UNCHK
lin kowtow_V = mkWV (k68 "pokkuroida") ; --UNCHK
lin kraal_N = mkWN (compoundN "karja-" (k39 "aitaus")) ; --UNCHK
lin kraft_N = mkWN (compoundN "voima" (k6 "paperi")) ; --UNCHK
lin krasnoyarsk_PN = foreignPN "Krasnoyarsk" ;
lin kraurosis_N = mkWN "kurtistuminen" ; --UNCHK
lin krefeld_PN = foreignPN "Krefeld" ;
lin kremlin_N = mkWN "Kreml" ; --UNCHK
lin krigia_N = mkWN "krigia" ; --UNCHK
lin kris_N = mkWN "kris" ; --UNCHK
lin kristinestad_PN = mkPN "Kristiinankaupunki" ;
lin krona_N = mkWN (k1 "kruunu") ;
lin krone_N = mkWN (k1 "kruunu") ;
lin kroon_N = mkWN (k1 "kruunu") ;
lin kronoby_PN = mkPN "Kruunupyy" ;
lin kroon_N = mkWN (k1 "kruunu") ; --UNCHK
lin krubi_N = mkWN "Amorphophallus" "titanum" ; --UNCHK
lin krummhorn_N = mkWN "cromorne" ; --UNCHK
lin krypton_N = mkWN (k5 "krypton") ; --UNCHK
lin kudos_N = mkWN (k12 "kunnia") ; --UNCHK
lin kudu_N = mkWN (compoundN "kudu-" (k5A "antilooppi")) ; --UNCHK
lin kuhmalahti_PN = mkPN (mkN "Kuhmalahti" "Kuhmalahtia") ;
lin kuhmo_PN = mkPN "Kuhmo" ;
lin kuhmoinen_PN = mkPN "Kuhmoinen" ;
lin kuivaniemi_PN = mkPN (mkN "Kuivaniemi" "Kuivaniemiä") ;
lin kullaa_PN = mkPN "Kullaa" ;
lin kummel_N = mkWN "kummel" ; --UNCHK
lin kumquat_N = mkWN (k5A "kumkvatti") ; --UNCHK
lin kung_fu_N = mkWN (k21 "kung-fu") ; --UNCHK
lin kunming_PN = foreignPN "Kunming" ;
lin kunzite_N = mkWN "kunziitti" ; --UNCHK
lin kuopio_PN = mkPN "Kuopio" ;
lin kuortane_PN = mkPN "Kuortane" ;
lin kurd_N = mkWN (k5 "kurdi") ; --UNCHK
lin kurikka_PN = mkPN "Kurikka" ;
lin kurrajong_N = mkWN "Brachychiton" "populneus" ; --UNCHK
lin kurta_N = mkWN "kurta" ; --UNCHK
lin kuru_N = mkWN (k1 "kuru") ; --UNCHK
lin kuru_PN = mkPN "Kuru" ;
lin kustavi_PN = mkPN "Kustavi" ;
lin kuusamo_PN = mkPN "Kuusamo" ;
lin kuusjoki_PN = mkPN (mkN "Kuusjoki" "Kuusjokia") ;
lin kuvasz_N = mkWN "kuvasz" ; --UNCHK
lin kuwait_PN = foreignPN "Kuwait" ;
lin kuwaiti_A = mkWA (compoundA "kuwaiti" (k38 "lainen")) ; --UNCHK
lin kuwaiti_N = mkWN (compoundN "kuwaiti" (k38 "lainen")) ; --UNCHK
lin kuybyshev_PN = foreignPN "Kuybyshev" ;
lin kvass_N = mkWN "kvassi" ; --UNCHK
lin kvetch_N = mkWN (k39 "valitus") ; --UNCHK
lin kw_N = mkWN (compoundN "kilo" (k5A "watti")) ; --UNCHK
lin kwacha_N = mkWN "kwacha" ; --UNCHK
lin kwanza_N = mkWN "Kwanza" ; --UNCHK
lin kwashiorkor_N = mkWN "kvašiorkor" ; --UNCHK
lin kwela_N = mkWN "kwela" ; --UNCHK
lin kyanite_N = mkWN (compoundN "sya" (k5A "niitti")) ; --UNCHK
lin kylie_N = mkWN (k5 "bumerangi") ; --UNCHK
lin kylix_N = mkWN (k5A "kuppi") ; --UNCHK
lin kylmäkoski_PN = mkPN (mkN "Kylmäkoski" "Kylmäkoskia") ;
lin kymograph_N = mkWN (compoundN "heilahdus" (k6 "mittari")) ; --UNCHK
lin kyoto_PN = foreignPN "Kioto" ;
lin kyphosis_N = mkWN (k12 "kyttyrä") ; --UNCHK
lin kyrö_PN = mkPN "Kyrö" ;
lin kyyjärvi_PN = mkPN (mkN "Kyyjärvi" "Kyyjärviä") ;
lin kälviä_PN = mkPN "Kälviä" ;
lin kärkölä_PN = mkPN "Kärkölä" ;
lin kärsämäki_PN = mkPN (mkN "Kärsämäki" "Kärsämäkiä") ;
lin köyliö_PN = mkPN "Köyliö" ;
lin la_N = mkWN "la" ; --UNCHK
lin laager_N = mkWN (k5 "leiri") ; --UNCHK
lin lab_N = mkWN (k3 "laboratorio") ; --UNCHK
lin lab_PN = foreignPN "Lab" ;
lin labdanum_N = mkWN "ladanum" ; --UNCHK
lin label_N = mkWN (compoundN "levy-" (k3 "yhtiö")) ; --UNCHK
lin label_V = mkWV (k73 "leimata") ; --UNCHK
lin label_V2 = mkWV2 (k73 "leimata") ; --UNCHK
lin label_V3 = variants {} ; -- mkWV2 (k73 "leimata") ; --UNCHK
lin label_VS = mkVS "julistaa" ;
lin labeled_A = mkWA "merkitty" ; --UNCHK
lin labetalol_N = mkWN "Normodyne" ; --UNCHK
lin labial_A = mkWA (compoundA "labia" (k38 "alinen")) ; --UNCHK
lin labiate_A = mkWA (compoundA "huuli" (k38 "mainen")) ; --UNCHK
lin labile_A = mkWA (k5 "labiili") ; --UNCHK
lin labium_N = mkWN (compoundN "häpy" (k24 "huuli")) ; --UNCHK
lin labor_N = mkN "työ" ;
lin laboratory_N = mkWN (k3 "laboratorio") ;
lin labored_A = mkWA (k41 "työläs") ; --UNCHK
lin laborer_N = mkWN (k38 "työläinen") ; --UNCHK
lin laborious_A = mkWA (k10 "vaativa") ; --UNCHK
lin laboriousness_N = mkWN (k40 "työläys") ; --UNCHK
lin laborsaving_A = mkWA "työtä" "säästävä" ; --UNCHK
lin labour_N = mkN "työ" ;
lin labour_V = mkWV (k53A "synnyttää") ; --UNCHK
lin labour_V2 = mkWV2 (k53A "synnyttää") ; --UNCHK
lin labourer_N = mkWN (k38 "työläinen") ; --UNCHK
lin labourite_N = mkWN (k10 "edustaja") "työväenpuolueen" ; --UNCHK
lin labrador_PN = foreignPN "Labrador" ;
lin labyrinth_N = mkWN (k5A "labyrintti") ; --UNCHK
lin labyrinthine_A = mkWA "sisäkorvaan" "liittyvä" ; --UNCHK
lin labyrinthitis_N = mkWN (k39 "tulehdus") "sisäkorvan" ; --UNCHK
lin labyrinthodont_N = mkWN "labyrinthodontti" ; --UNCHK
lin lac_N = mkWN (kH1 "lakka") ; --UNCHK
lin lace_N = mkWN (k5 "pitsi") ; --UNCHK
lin lace_V = mkWV (k73 "lisätä") ; --UNCHK
lin lace_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin lacebark_N = mkWN "Hoheria" "populnea" ; --UNCHK
lin lacer_N = mkWN (k10 "sitoja") ; --UNCHK
lin lacerate_V2 = mkWV2 (k61A "repiä") "rikki" ; --UNCHK
lin laceration_N = mkWN "repiminen" ; --UNCHK
lin lacework_N = mkWN (compoundN "punonta" (k19 "työ")) ; --UNCHK
lin lachrymal_A = mkWA (compoundA "lakrima" (k38 "alinen")) ; --UNCHK
lin lachrymose_A = mkWA (k38 "itkuinen") ; --UNCHK
lin lacing_N = mkWN (k39 "löylytys") ; --UNCHK
lin lack_N = mkN "puute" ;
lin lack_V = mkV "puuttua" ;
lin lack_V2 = mkV2 (caseV ablative (mkV "puuttua")) ;
lin lackadaisical_A = mkWA (k15 "raukea") ; --UNCHK
lin lackey_N = mkWN (k12 "lakeija") ; --UNCHK
lin lacking_A = variants {} ; --
lin lackluster_A = mkWA (k15 "himmeä") ; --UNCHK
lin laconic_A = mkWA (k15 "selkeä") ; --UNCHK
lin laconicism_N = mkWN (k40 "lakonisuus") ; --UNCHK
lin laconism_N = mkWN (k40 "lakonisuus") ; --UNCHK
lin lacquer_N = mkWN (kH1 "lakka") ; --UNCHK
lin lacquerware_N = mkWN (compoundN "lakka" (k19 "työ")) ; --UNCHK
lin lacrimal_A = mkWA (compoundA "lakrima" (k38 "alinen")) ; --UNCHK
lin lacrimation_N = mkWN (k2 "vetistely") ; --UNCHK
lin lacrimatory_A = mkWA "kyynel-" ; --UNCHK
lin lacrosse_N = mkWN (compoundN "haavi" (k1 "pallo")) ; --UNCHK
lin lactalbumin_N = mkWN "maitoalbumiini" ; --UNCHK
lin lactase_N = mkWN (k5 "laktaasi") ; --UNCHK
lin lactate_N = mkWN (k9 "suola") "maitohapon" ; --UNCHK
lin lactation_N = mkWN (k39 "imetys") ; --UNCHK
lin lacteal_A = mkWA (k10 "tuottava") "maitoa" ; --UNCHK
lin lacteal_N = mkWN (compoundN "imu" (k26 "suoni")) ; --UNCHK
lin lactic_A = mkWA (compoundA "maitopi" (k38 "toinen")) ; --UNCHK
lin lactobacillus_N = mkWN (compoundN "laktoba" (k5 "silli")) ; --UNCHK
lin lactogen_N = mkWN (k5 "prolaktiini") ; --UNCHK
lin lactogenic_A = mkWA "laktogeeninen" ; --UNCHK
lin lactose_N = mkWN (k5 "laktoosi") ; --UNCHK
lin lactosuria_N = mkWN "laktosuria" ; --UNCHK
lin lacuna_N = mkWN (k5A "kasetti") ; --UNCHK
lin lacustrine_A = mkWA (compoundA "laku" (k38 "strinen")) ; --UNCHK
lin lacy_A = mkWA (compoundA "pitsi" (k38 "nen")) ; --UNCHK
lin lad_N = mkWN (k1 "poju") ; --UNCHK
lin ladder_N = mkN "arvojärjestys" ; ---ARB
lin ladder_V = mkWV (k67 "olla") "silmäpako" ; --UNCHK
lin laddie_N = mkWN (k1 "poju") ; --UNCHK
lin lade_V2 = mkWV2 (k54A "ammentaa") ; --UNCHK
lin laden_A = mkWA (k10 "oleva") "täynnä" ; --UNCHK
lin lading_N = mkWN (k39 "lähetys") ; --UNCHK
lin ladle_V2 = mkWV2 (k54A "ammentaa") ; --UNCHK
lin lady's_maid_N = mkWN (compoundN "kamari" (k5A "neiti")) ; --UNCHK
lin lady_N = mkN "lady" "ladyja" ;
lin lady_chapel_N = mkWN (k6 "kappeli") ; --UNCHK
lin lady_killer_N = mkWN (k12 "viettelijä") ; --UNCHK
lin ladybird_N = mkWN (k1A "leppäpirkko") ; --UNCHK
lin ladybug_N = mkWN (k1A "leppäpirkko") ; --UNCHK
lin ladyfinger_N = mkWN (compoundN "lusikka" (k10A "leipä")) ; --UNCHK
lin ladyfish_N = mkWN "Elops" "saurus" ; --UNCHK
lin ladylike_A = mkWA (k38 "naisellinen") ; --UNCHK
lin ladylikeness_N = mkWN (k40 "naisellisuus") ; --UNCHK
lin ladylove_N = mkWN (k1A "rakastettu") ; --UNCHK
lin ladyship_N = mkWN "Teidän" "armonne" ; --UNCHK
lin laelia_N = mkWN "laelia" ; --UNCHK
lin laetrile_N = mkWN "laetriili" ; --UNCHK
lin lag_N = mkWN (k48 "viive") ; --UNCHK
lin lag_V = mkWV (compoundV "lämpö" (k53 "eristää")) ; --UNCHK
lin lag_V2 = mkV2 "viivyttää" partitive ; --mkWV2 (compoundV "lämpö" (k53 "eristää")) ;
lin lager_1_N = mkWN (k5 "leiri") ; --UNCHK
lin lager_2_N = mkWN (k5 "leiri") ; --UNCHK
lin lagerphone_N = mkWN "lagerphone" ; --UNCHK
lin laggard_N = mkWN (k12 "kuhnailija") ; --UNCHK
lin lagging_N = mkWN (compoundN "lämpö" (k48 "eriste")) ; --UNCHK
lin lagniappe_N = mkWN (k9 "lahja") ; --UNCHK
lin lagomorph_N = mkWN (compoundN "jänis" (k33 "eläin")) ; --UNCHK
lin lagoon_N = mkWN (k5 "laguuni") ; --UNCHK
lin lagophthalmos_N = mkWN "lagophthalmos" ; --UNCHK
lin lagos_PN = foreignPN "Lagos" ;
lin lahar_N = mkWN (compoundN "muta" (k1 "vyöry")) "vulkaaninen" ; --UNCHK
lin lahore_PN = foreignPN "Lahore" ;
lin lahti_PN = mkPN (mkN "Lahti" "Lahden" "Lahtia") ;
lin laic_A = mkWA (k38 "sekulaarinen") ; --UNCHK
lin laihia_PN = mkPN "Laihia" ;
lin lair_N = mkWN (k10 "luola") ; --UNCHK
lin laird_N = mkWN (compoundN "kartanon" (k9 "herra")) ; --UNCHK
lin laissez_faire_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin laitila_PN = mkPN "Laitila" ;
lin lake_N = L.lake_N ;
lin lakefront_N = mkWN (compoundN "järven" (k9A "ranta")) ; --UNCHK
lin lakenheath_PN = foreignPN "Lakenheath" ;
lin lakeside_N = mkWN (k9A "ranta") "järven" ; --UNCHK
lin lakh_N = mkWN "satatuhatta" ; --UNCHK
lin lallation_N = mkWN (compoundN "sian" (k9 "saksa")) ; --UNCHK
lin lally_N = mkWN (compoundN "tuki" (k41 "pylväs")) ; --UNCHK
lin lam_V = mkWV (k54 "pieksää") ; --UNCHK
lin lam_V2 = mkWV2 (k54 "pieksää") ; --UNCHK
lin lamasery_N = mkWN (k6 "luostari") ; --UNCHK
lin lamb_N = mkWN (k10 "vuona") ; --UNCHK
lin lamb_V = mkWV (k61 "vuonia") ; --UNCHK
lin lambaste_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin lambda_N = mkWN "lambda" ; --UNCHK
lin lambdacism_N = mkWN "lallatus" ; --UNCHK
lin lambency_N = mkWN (k48A "välke") ; --UNCHK
lin lambent_A = mkWA (k10 "loistava") ; --UNCHK
lin lambeth_PN = foreignPN "Lambeth" ;
lin lambkin_N = mkWN (k13 "karitsa") ; --UNCHK
lin lamblike_A = mkWA (k38 "lammasmainen") ; --UNCHK
lin lambrequin_N = mkWN (compoundN "reuna" (k48 "koriste")) ; --UNCHK
lin lambskin_N = mkWN (k5A "pergamentti") ; --UNCHK
lin lame_A = mkWA (k9A "rampa") ; --UNCHK
lin lame_N = mkWN (k20 "lamee") ; --UNCHK
lin lame_V2 = mkWV2 (k53A "vammauttaa") ; --UNCHK
lin lamedh_N = mkWN "lamed" ; --UNCHK
lin lamella_N = mkWN (k5 "lamelli") ; --UNCHK
lin lamellibranch_A = mkWA "simpukat" ; --UNCHK
lin lameness_N = mkWN (k40 "puutteellisuus") ; --UNCHK
lin lament_N = mkWN (k12 "elegia") ; --UNCHK
lin lament_V = mkWV (k58 "itkeä") ; --UNCHK
lin lament_V2 = mkWV2 (k58 "itkeä") ; --UNCHK
lin lament_VS = mkWVS (k58 "itkeä") ; --UNCHK
lin lamentable_A = mkWA (k38 "surullinen") ; --UNCHK
lin lamentation_N = mkWN (k1 "suru") ; --UNCHK
lin lamina_N = mkWN (k5 "lamelli") ; --UNCHK
lin laminar_A = mkWA (compoundA "lamelli" (k38 "nen")) ; --UNCHK
lin laminate_N = mkWN (k5A "laminaatti") ; --UNCHK
lin laminate_V = mkWV (k53A "viiluttaa") ; --UNCHK
lin laminate_V2 = mkWV2 (k53A "viiluttaa") ; --UNCHK
lin lamination_N = mkWN (k5A "laminointi") ; --UNCHK
lin laminator_N = mkWN "laminoija" ; --UNCHK
lin laminitis_N = mkWN (compoundN "kavio" (k48 "kuume")) ; --UNCHK
lin lamivudine_N = mkWN "3TC" ; --UNCHK
lin lammas_N = mkWN (k10 "päivä") "elokuun" "1." ; --UNCHK
lin lammi_PN = mkPN "Lammi" ;
lin lamp_N = L.lamp_N ;
lin lamplight_N = mkWN (compoundN "lampun" (k1 "valo")) ; --UNCHK
lin lamplighter_N = mkWN (compoundN "lampun" (k10 "sytyttäjä")) ; --UNCHK
lin lamplit_A = mkWA "lampun" "valaisema" ; --UNCHK
lin lampoon_N = mkWN (k39 "huijaus") ; --UNCHK
lin lampoon_V2 = mkWV2 (k73A "pilkata") ; --UNCHK
lin lamppost_N = mkWN (compoundN "lyhty" (k41 "pylväs")) ; --UNCHK
lin lamprey_N = mkWN (k38 "nahkiainen") ; --UNCHK
lin lampshade_N = mkWN (compoundN "lampun" (k33 "varjostin")) ; --UNCHK
lin lanai_N = mkWN (k5 "kuisti") ; --UNCHK
lin lanark_PN = foreignPN "Lanark" ;
lin lanate_A = mkWA (k38 "villainen") ; --UNCHK
lin lancaster_PN = foreignPN "Lancaster" ;
lin lancastrian_A = mkWA "Lancasterin" ; --UNCHK
lin lance_N = mkWN (k5A "lansetti") ; --UNCHK
lin lance_V2 = mkWV2 (k66 "puhkaista") ; --UNCHK
lin lance_corporal_N = mkWN (k5 "korpraali") ; --UNCHK
lin lancelet_N = mkWN "amphioxus" ; --UNCHK
lin lanceolate_A = mkWA (k38 "muotoinen") "keihään" ; --UNCHK
lin lancer_N = mkWN (k5 "katrilli") ; --UNCHK
lin lancet_N = mkWN (k5A "lansetti") ; --UNCHK
lin lancewood_N = mkWN (compoundN "lanceo" (k9A "lata")) "Oxandra" ; --UNCHK
lin lancing_PN = foreignPN "Lancing" ;
lin land_N = mkN "maa" ;
lin land_V = mkV "laskeutua" ;
lin land_V2 = mkWV2 (k56A "saattaa") ; --UNCHK
lin land_agent_N = mkWN (compoundN "tilan" (k10 "hoitaja")) ; --UNCHK
lin land_in_V2 = prepV2 OP_land_V OP_in_Prep ; -- guess-p-verb
lin land_up_in_V2 = prepV2 (advV OP_land_V OP_up_Adv ) OP_in_Prep ; -- guess-p-verb
lin land_with_V3 = variants {} ; -- guess-p-verb
lin landau_N = mkWN "landau" ; --UNCHK
lin lander_N = mkWN "laskeutuja" ; --UNCHK
lin landfall_N = mkWN (compoundN "maan" (k10 "tuntuma")) ; --UNCHK
lin landfill_N = mkWN "maankaatopaikka" ; --UNCHK
lin landgrave_N = mkWN (compoundN "maa" (k5 "kreivi")) ; --UNCHK
lin landholder_N = mkWN (compoundN "maan" (k10 "omistaja")) ; --UNCHK
lin landholding_N = mkWN (compoundN "maan" (k40 "omaisuus")) ; --UNCHK
lin landing_N = mkWN (k1 "lasku") ; --UNCHK
lin landing_craft_N = mkWN (compoundN "maihinnousu" (k39 "alus")) ; --UNCHK
lin landing_field_N = mkWN (k10A "kenttä") ; --UNCHK
lin landing_gear_N = mkWN (compoundN "lasku" (k48 "teline")) ; --UNCHK
lin landing_net_N = mkWN (k5 "haavi") ; --UNCHK
lin landing_place_N = mkWN (kH1 "laituri") ; --UNCHK
lin landing_stage_N = mkWN (k6 "laivalaituri") ; --UNCHK
lin landing_strip_N = mkWN (compoundN "kiito" (k19 "tie")) ; --UNCHK
lin landlady_N = mkWN (compoundN "vuokra" (k10A "emäntä")) ; --UNCHK
lin landler_N = mkWN (compoundN "ländler-" (k5 "tanssi")) ; --UNCHK
lin landless_A = mkWA (k34A "maaton") ; --UNCHK
lin landlocked_A = mkWA (compoundA "sulje" (k1 "ttu")) ; --UNCHK
lin landlord_N = mkWN (k10 "omistaja") ; --UNCHK
lin landlubber_N = mkWN (compoundN "maa" (k1A "krapu")) ; --UNCHK
lin landmark_N = mkWN (compoundN "maa" (k5A "merkki")) ; --UNCHK
lin landmass_N = mkWN (compoundN "maa" (k9 "massa")) ; --UNCHK
lin landowner_N = mkWN (compoundN "maan" (k10 "omistaja")) ; --UNCHK
lin landrover_N = mkWN (k5A "jeeppi") ; --UNCHK
lin landscape_N = mkWN (k39 "maisemamaalaus") ; --UNCHK
lin landscape_V2 = mkWV2 (k62 "maisemoida") ; --UNCHK
lin landscaping_N = mkWN (k5A "maisemointi") ; --UNCHK
lin landscapist_N = mkWN (compoundN "maisema-" (k5A "arkkitehti")) ; --UNCHK
lin landside_N = mkWN (compoundN "sivu" (k10 "osa")) ; --UNCHK
lin landslide_N = mkWN (compoundN "maan" (k10 "vyörymä")) ; --UNCHK
lin landslip_N = mkWN (compoundN "maan" (k10 "vyörymä")) ; --UNCHK
lin landsman_N = mkWN (compoundN "maa" (k1A "krapu")) ; --UNCHK
lin landward_Adv = mkWAdv (k99 "päin") "sisämaahan" ; --UNCHK
lin lane_N = mkWN (k10 "kuja") ; --UNCHK
lin langbeinite_N = mkWN "langbeinite" ; --UNCHK
lin langlaufer_N = mkWN (compoundN "murtomaa" (k10 "hiihtäjä")) ; --UNCHK
lin langsyne_Adv = mkWAdv (k99 "sitten") "kauan" ; --UNCHK
lin language_N = L.language_N ;
lin languid_A = mkWA (k38 "hypnoottinen") ; --UNCHK
lin languish_V = mkV "riutua" ; --mkWV (k52 "virua") ;
lin languisher_N = mkWN "riutuja" ; --UNCHK
lin languor_N = mkWN (k40 "latteus") ; --UNCHK
lin languorous_A = mkWA (k38 "hypnoottinen") ; --UNCHK
lin langur_N = mkWN "langur" ; --UNCHK
lin lankiness_N = mkWN "honteluus" ; --UNCHK
lin lanolin_N = mkWN (k5 "lanoliini") ; --UNCHK
lin lansoprazole_N = mkWN "Prevacid" ; --UNCHK
lin lantana_N = mkWN "lantana" ; --UNCHK
lin lantern_N = mkWN (k1A "lyhty") ; --UNCHK
lin lanternfish_N = mkWN (compoundN "lyhty" (k9 "kala")) ; --UNCHK
lin lanthanum_N = mkWN (k5 "lantaani") ; --UNCHK
lin lanugo_N = mkWN (k10A "nukka") ; --UNCHK
lin lanyard_N = mkWN (compoundN "talja" (k10 "nuora")) ; --UNCHK
lin lao_N = mkWN "lao" ; --UNCHK
lin laos_PN = foreignPN "Laos" ;
lin laotian_A = mkWA (compoundA "laosi" (k38 "lainen")) ; --UNCHK
lin laotian_N = mkWN (compoundN "lao" (k38 "lainen")) ; --UNCHK
lin lap_N = mkWN (k39 "lipitys") ; --UNCHK
lin lap_V = mkWV (k61 "loiskia") ; --UNCHK
lin lap_V2 = mkWV2 (k61 "loiskia") ; --UNCHK
lin lap_up_V2 = mkWV2 (k67 "nuolla") ; --UNCHK
lin laparocele_N = mkWN (k10 "tyrä") ; --UNCHK
lin laparoscope_N = mkWN (compoundN "laparosko" (k5A "oppi")) ; --UNCHK
lin laparoscopy_N = mkWN (k12 "laparoskopia") ; --UNCHK
lin lapboard_N = mkWN (compoundN "kirjoitus" (k13 "alusta")) ; --UNCHK
lin lap_dog_N = mkWN (compoundN "syli" (k10 "koira")) ; --UNCHK
lin lapel_N = mkWN (k48A "lieve") ; --UNCHK
lin lapful_N = mkWN (k38 "sylillinen") ; --UNCHK
lin lapidarian_A = mkWA "kiveen" "hiottu" ; --UNCHK
lin lapidary_A = mkWA "jalokivi-" ; --UNCHK
lin lapidary_N = mkWN (k10 "jalokivihioja") ; --UNCHK
lin lapin_N = mkWN (k6 "kaniini") ; --UNCHK
lin lapinjärvi_PN = mkPN (mkN "Lapinjärvi" "Lapinjärviä") ;
lin lapinlahti_PN = mkPN (mkN "Lapinlahti" "Lapinlahtia") ;
lin lapis_lazuli_N = mkWN (compoundN "lasu" (k5A "riitti")) ; --UNCHK
lin lapland_PN = mkPN "Lappi" ;
lin lappajärvi_PN = mkPN (mkN "Lappajärvi" "Lappajärviä") ;
lin lappeenranta_PN = mkPN "Lappeenranta" ;
lin lappet_N = mkWN "yöperhonen" ; --UNCHK
lin lappi_PN = mkPN "Lappi" ;
lin lapse_N = mkN "ajanjakso" ;
lin lapse_V = mkWV (k52A "vaipua") ; --UNCHK
lin lapsed_A = mkWA (compoundA "luo" (k47 "punut")) "kirkosta" ; --UNCHK
lin laptop_N = mkWN (compoundN "syli" (k1 "mikro")) ; --UNCHK
lin lapua_PN = mkPN "Lapua" ;
lin lapwing_N = mkWN (k10A "töyhtöhyyppä") ; --UNCHK
lin larboard_A = mkWA (k5 "paapuuri") ; --UNCHK
lin larboard_N = mkWN (k5 "paapuuri") ; --UNCHK
lin larcenist_N = mkWN (k10 "anastaja") ; --UNCHK
lin larceny_N = mkWN (k2 "varastelu") ; --UNCHK
lin larch_N = mkWN (k24 "lehtikuusi") ; --UNCHK
lin lard_N = mkWN (k5 "laardi") ; --UNCHK
lin lard_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin larder_N = mkWN (k6 "pentteri") ; --UNCHK
lin large_A = mkA (mkN "suuri" "suuria") ;
lin large_Adv = mkWAdv (k99 "leveästi") ; --UNCHK
lin large_N = mkWN (kH1 "koko") "suuri" ; --UNCHK
lin large_scale_A = mkA "laajamittainen" ;
lin largemouth_N = mkWN "Micropterus" "salmoides" ; --UNCHK
lin largeness_N = mkWN (k40 "suurellisuus") ; --UNCHK
lin largess_N = mkWN (k40 "anteliaisuus") ; --UNCHK
lin largesse_N = mkWN (k40 "anteliaisuus") ; --UNCHK
lin larghetto_A = mkWA "hitaahko" ; --UNCHK
lin larghetto_N = mkWN (compoundN "lar" (k1A "ghetto")) ; --UNCHK
lin larghissimo_A = mkWA "mitä" "leveimmin" ; --UNCHK
lin largish_A = mkWA "suurehko" ; --UNCHK
lin largo_A = mkWA (k99 "leveästi") ; --UNCHK
lin largo_Adv = mkWAdv (k99 "leveästi") "hitaasti" "ja" ; --UNCHK
lin largo_N = mkWN "largo" ; --UNCHK
lin largs_PN = foreignPN "Largs" ;
lin lari_N = mkWN "Alalahko" "Lari" ; --UNCHK
lin lariat_N = mkWN (k5A "suopunki") ; --UNCHK
lin larid_N = mkWN "larid" ; --UNCHK
lin lark_N = mkWN (k9 "pila") ; --UNCHK
lin lark_V = mkWV (k68 "karkeloida") ; --UNCHK
lin lark_about_V = mkWV (k68 "karkeloida") ; --UNCHK
lin larkhall_PN = foreignPN "Larkhall" ;
lin larkspur_N = mkWN (k39 "kukonkannus") ; --UNCHK
lin larn_V = mkWV (k61A "oppia") ; --UNCHK
lin larn_V2 = mkWV2 (k61A "oppia") ; --UNCHK
lin larne_PN = foreignPN "Larne" ;
lin larsmo_PN = mkPN "Larsmo" ;
lin larva_N = mkWN (k10A "toukka") ; --UNCHK
lin larvacean_N = mkWN (k41A "pyrstökäs") ; --UNCHK
lin larvacide_N = mkWN "larvisidi" ; --UNCHK
lin larval_A = mkWA "toukka-" ; --UNCHK
lin larvicide_N = mkWN (compoundN "toukka" (k1A "myrkky")) ; --UNCHK
lin laryngeal_A = mkWA "kurkunpään" ; --UNCHK
lin laryngismus_N = mkWN (k39 "kouristus") "kurkunpään" ; --UNCHK
lin laryngitis_N = mkWN (k39 "tulehdus") "kurkunpään" ; --UNCHK
lin laryngopharyngeal_A = mkWA (compoundA "laryngofaryngea" (k38 "alinen")) ; --UNCHK
lin laryngopharyngitis_N = mkWN "laryngofaryngiitti" ; --UNCHK
lin laryngopharynx_N = mkWN (compoundN "ala" (k1 "nielu")) ; --UNCHK
lin laryngoscope_N = mkWN (compoundN "laryngosko" (k5A "oppi")) ; --UNCHK
lin laryngospasm_N = mkWN (k39 "kouristus") "kurkunpään" "äänihuulten" ; --UNCHK
lin laryngostenosis_N = mkWN (kH1 "ahtaus") "kurkunpään" ; --UNCHK
lin laryngotracheobronchitis_N = mkWN (compoundN "kuristus" (k5A "tauti")) ; --UNCHK
lin larynx_N = mkWN (compoundN "kurkun" (k18 "pää")) ; --UNCHK
lin lasagna_N = mkWN (k8 "lasagne") ; --UNCHK
lin lascar_N = mkWN "Lascar" ; --UNCHK
lin lascivious_A = mkWA (k38 "hekumallinen") ; --UNCHK
lin lasciviousness_N = mkWN (k40 "riettaus") ; --UNCHK
lin laser_N = mkWN (k6 "laser") ; --UNCHK
lin lash_N = mkWN (k1 "isku") "piiskan" ; --UNCHK
lin lash_V = mkWV (k52A "sitoa") ; --UNCHK
lin lash_V2 = mkWV2 (k52A "sitoa") ; --UNCHK
lin lash_out_V = mkWV (k67A "piikitellä") ; --UNCHK
lin lasher_N = mkWN "ruoskija" ; --UNCHK
lin lashing_N = mkWN (k39 "parkitus") ; --UNCHK
lin lass_N = mkWN (k14A "typykkä") ; --UNCHK
lin lassie_N = mkWN (k14A "typykkä") ; --UNCHK
lin lassitude_N = mkWN (k40 "velttous") ; --UNCHK
lin lasso_N = mkWN (k5A "suopunki") ; --UNCHK
lin lasso_V2 = mkWV2 (k75 "lassota") ; --UNCHK
lin last_1_A = mkA "viimeinen" ;
lin last_2_A = invarA "viime" ;
lin last_A = mkA "viimeinen" ;
lin last_N = mkWN (k38 "viimeinen") ; --UNCHK
lin last_V = mkWV (k53A "rökittää") ; --UNCHK
lin lasting_A = mkWA (k38 "vakituinen") ; --UNCHK
lin lastingness_N = mkWN (k1 "kesto") ; --UNCHK
lin lat_N = mkWN (compoundN "selkä" (k39 "lihas")) "leveä" ; --UNCHK
lin latanier_N = mkWN (compoundN "latanier-" (k1 "palmu")) ; --UNCHK
lin latch_N = mkWN (k5A "säppi") ; --UNCHK
lin latch_V = mkWV (k73A "salvata") ; --UNCHK
lin latch_V2 = mkWV2 (k73A "salvata") ; --UNCHK
lin latch_on_V = mkWV (k74 "älytä") ; --UNCHK
lin latchet_N = mkWN (k5 "remmi") ; --UNCHK
lin latchkey_N = mkWN (k33 "avain") ; --UNCHK
lin latchstring_N = mkWN (k33 "avain") ; --UNCHK
lin late_A = mkA "myöhäinen" ;
lin late_Adv = mkWAdv (k99 "myöhään") ; --f122
lin latecomer_N = mkWN "myöhästyjä" ; --UNCHK
lin lateen_A = mkWA (compoundA "varus" (k1 "tettu")) "latinalaispurjeella" ; --UNCHK
lin lateen_N = mkWN (compoundN "latinalais" (k48 "purje")) ; --UNCHK
lin lately_Adv = adjAdv late_A ; -- -- derived
lin latency_N = mkWN (k5 "latenssi") ; --UNCHK
lin lateness_N = mkWN (compoundN "myöhässä" (k1 "olo")) ; --UNCHK
lin latent_A = mkWA (kH1 "piilevä") ; --UNCHK
lin later_Adv = mkAdv "myöhemmin" ;
lin lateral_A = mkWA (k38 "lateraalinen") ; --UNCHK
lin laterality_N = mkWN (k5 "dominanssi") ; --UNCHK
lin lateralization_N = mkWN (compoundN "laterali" (k5A "sointi")) ; --UNCHK
lin laterite_N = mkWN (compoundN "late" (k5A "riitti")) ; --UNCHK
lin latest_A = mkWA "viimeisin" ; --UNCHK
lin latest_N = mkWN "uusin" ; --UNCHK
lin latex_N = mkWN (kH1 "maali") "kumipohjainen" ; --UNCHK
lin lath_N = mkWN (k9 "rima") ; --UNCHK
lin lathe_N = mkWN (k5 "sorvi") ; --UNCHK
lin lather_N = mkWN (k1A "vaahto") ; --UNCHK
lin lather_V = mkWV (k53A "vaahdottaa") ; --UNCHK
lin lather_V2 = mkWV2 (k53A "vaahdottaa") ; --UNCHK
lin lathery_A = mkWA "vaahtoava" ; --UNCHK
lin lathi_N = mkWN "lathi" ; --UNCHK
lin latin_A = mkWA (k38 "latinalainen") ; --UNCHK
lin latinate_A = mkWA (compoundA "lati" (k38 "nalaisperäinen")) ; --UNCHK
lin latinist_N = mkWN (k5 "latinisti") ; --UNCHK
lin latinize_V2 = mkWV2 (k53A "käännyttää") ; --UNCHK
lin latish_A = mkWA (k99 "myöhässä") "hieman" ; --UNCHK
lin latitude_N = mkWN (k40 "vapaus") ; --UNCHK
lin latitudinal_A = mkWA "leveys-" ; --UNCHK
lin latitudinarian_A = mkWA "vapaasti" "ajatteleva" ; --UNCHK
lin latitudinarian_N = mkWN (compoundN "vapa" (k38 "amielinen")) ; --UNCHK
lin latrine_N = mkWN (compoundN "kenttä" (k12 "käymälä")) ; --UNCHK
lin lats_N = mkWN (k5 "lati") ; --UNCHK
lin latten_N = mkWN (k7 "vaski") ; --UNCHK
lin latter_A = mkWA (k38 "jälkimmäinen") ; --UNCHK
lin latter_N = mkWN (k38 "jälkimmäinen") ; --UNCHK
lin latter_day_A = mkA "tämänpäiväinen" ; ---?? different POS
lin lattice_N = mkWN (k4A "ristikko") ; --UNCHK
lin latticed_A = mkWA (compoundA "risti" (k38 "kkoinen")) ; --UNCHK
lin laud_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin laudable_A = mkWA (k10 "kunnioitettava") ; --UNCHK
lin laudanum_N = mkWN (compoundN "oopium" (k48A "uute")) ; --UNCHK
lin laudator_N = mkWN "ylistäjä" ; --UNCHK
lin laudatory_A = mkWA "ylistävä" ; --UNCHK
lin laugh_N = mkWN (k1 "kasku") ; --UNCHK
lin laugh_V = L.laugh_V ;
lin laugh_V2 = mkV2 "nauraa" allative ;
lin laugh_VS = mkVS (mkV "nauraa") ;
lin laugh_at_V2 = prepV2 OP_laugh_V OP_at_Prep ; -- guess-p-verb
lin laugh_off_V2 = mkWV2 (k64 "lyödä") "leikiksi" ; --UNCHK
lin laughable_A = mkWA (k1 "hassu") ; --UNCHK
lin laugher_N = mkWN (k1A "voitto") "helppo" ; --UNCHK
lin laughing_A = mkWA "naurava" ; --UNCHK
lin laughing_gas_N = mkWN (k5 "typpioksiduuli") ; --UNCHK
lin laughter_N = mkWN (k1 "nauru") ; --UNCHK
lin laukaa_PN = mkPN "Laukaa" ;
lin launch_N = mkWN (k2 "laukaisu") ; --UNCHK
lin launch_V = mkWV (k53A "aloittaa") ;
lin launch_V2 = mkV2 (mkV (mkV "tuoda") "markkinoille") ;
lin launcher_N = mkWN (k33 "laukaisin") ; --UNCHK
lin launching_N = mkWN (k2 "laukaisu") ; --UNCHK
lin launching_pad_N = mkWN (compoundN "laukaisu" (k13 "alusta")) ; --UNCHK
lin launching_site_N = mkWN (compoundN "sijoitus" (k9A "paikka")) "laukaisualustan" ; --UNCHK
lin launder_V = mkWV (k66 "pestä") "rahaa" ;
lin launder_V2 = mkWV2 (k66 "pestä") "rahaa" ; --UNCHK
lin launderette_N = mkWN (compoundN "itsepalvelu" (k12 "pesula")) ; --UNCHK
lin laundering_N = mkWN (compoundN "pyykin" (k1 "pesu")) ; --UNCHK
lin laundress_N = mkWN (k12 "pyykinpesijä") ; --UNCHK
lin laundry_N = mkWN (k12 "pesula") ; --UNCHK
lin laundryman_N = mkWN (kH1 "pesijä") ; --UNCHK
lin laundrywoman_N = mkWN (k12 "pyykinpesijä") ; --UNCHK
lin laura_PN = foreignPN "Laura" ;
lin laureateFem_N = mkWN (k10 "saaja") "palkinnon" ; --UNCHK
lin laureateMasc_N = mkWN (k10 "saaja") "palkinnon" ; --UNCHK
lin laureate_A = mkWA "palkinnon" "saava" ; --UNCHK
lin laurel_N = mkWN (compoundN "laakeri" (k49 "seppele")) ; --UNCHK
lin laureled_A = mkWA (compoundA "kruuna" (k1 "ttu")) "seppeleellä" ; --UNCHK
lin laurelled_A = mkWA (compoundA "kruuna" (k1 "ttu")) "seppeleellä" ; --UNCHK
lin laurelwood_N = mkWN "Calophyllum" "candidissimum" ; --UNCHK
lin lausanne_PN = foreignPN "Lausanne" ;
lin lav_N = mkWN (k5 "veski") ; --UNCHK
lin lava_N = mkWN (k9 "laava") ; --UNCHK
lin lavage_N = mkWN (k1 "pesu") ; --UNCHK
lin lavalava_N = mkWN (compoundN "lava" (k9 "lava")) ; --UNCHK
lin lavaliere_N = mkWN (k39 "riipus") ; --UNCHK
lin lavatory_N = mkWN (k99 "WC") ; --UNCHK
lin lave_V2 = mkWV2 (k66 "pestä") ; --UNCHK
lin lavender_A = mkWA (k5A "violetti") ; --UNCHK
lin lavender_N = mkWN (compoundN "laventelin" (k38 "sininen")) ; --UNCHK
lin laver_N = mkWN "ulva" ; --UNCHK
lin lavia_PN = mkPN "Lavia" ;
lin lavish_A = mkWA (k41 "aulis") ;
lin lavish_V2 = mkWV2 (k53A "syytää") ; --UNCHK
lin lavishness_N = mkWN (k40 "ylenpalttisuus") ; --UNCHK
lin law_1_N = mkN "laki" ;
lin law_2_N = mkN "oikeustiede" ;
lin law_N = mkN "laki" ;
lin law_abiding_A = mkA (mkN "lain" (mkN "kuuliainen")) ;
lin law_officer_N = mkWN (compoundN "järjestys" (k42 "mies")) ; --UNCHK
lin lawbreaker_N = mkWN (k6 "rikkuri") ; --UNCHK
lin lawful_A = mkWA (k38 "laillinen") ; --UNCHK
lin lawfulness_N = mkWN (k40 "laillisuus") ; --UNCHK
lin lawgiver_N = mkWN (compoundN "lain" (k10 "säätäjä")) ; --UNCHK
lin lawless_A = mkWA (k34A "laiton") ; --UNCHK
lin lawlessness_N = mkWN (compoundN "lain" (k40 "vastaisuus")) ; --UNCHK
lin lawmaker_N = mkWN (compoundN "lain" (k10 "säätäjä")) ; --f88
lin lawmaking_N = mkWN (compoundN "lain" (k9A "säädäntä")) ; --UNCHK
lin lawman_N = mkWN (compoundN "järjestys" (k42 "mies")) ; --UNCHK
lin lawn_N = mkWN (k7 "nurmi") ; --UNCHK
lin lawn_mower_N = mkWN (compoundN "ruohon" (k6 "leikkuri")) ; --UNCHK
lin lawrence_PN = foreignPN "Lawrence" ;
lin lawrencium_N = mkWN "atominumero" "103" ; --UNCHK
lin lawsuit_N = mkWN (k48A "kanne") ; --UNCHK
lin lawyer_N = mkN "asianajaja" ;
lin lawyerbush_N = mkWN "Rubus" "australis" ; --UNCHK
lin lax_A = mkWA (k10 "löyhä") ; --UNCHK
lin laxative_A = mkWA (compoundA "laksatiivi" (k38 "nen")) ; --UNCHK
lin laxative_N = mkWN (k5 "laksatiivi") ; --UNCHK
lin laxity_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin laxness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin lay_A = mkWA "maallikko-" ; --UNCHK
lin lay_N = mkWN (k5 "balladi") ; --UNCHK
lin lay_V = mkWV (k53 "pistää") ; --UNCHK
lin lay_V2 = mkV2 "asettaa" ;
lin lay_away_V2 = mkWV2 (k62 "varastoida") ; --UNCHK
lin lay_down_V = mkWV (k53A "asettaa") ; --UNCHK
lin lay_down_V2 = mkWV2 (k53A "asettaa") ; --UNCHK
lin lay_figure_N = mkN "mallinukke" "mallinuken" "mallinukkeja" ;
lin lay_in_on_V2 = prepV2 (advV OP_lay_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin lay_into_V2 = mkWV2 (k65 "käydä") "käsiksi" ; --UNCHK
lin lay_off_V2 = mkWV2 (k53A "lomauttaa") ; --UNCHK
lin lay_on_V2 = prepV2 OP_lay_V OP_on_Prep ; -- guess-p-verb
lin lay_out_V2 = mkWV2 (k56A "kattaa") ; --UNCHK
lin layabout_N = mkWN (k5 "pummi") ; --UNCHK
lin layby_N = mkWN (compoundN "pysähdys" (k9A "paikka")) ; --UNCHK
lin layer_N = mkWN (k39 "kerros") ; --UNCHK
lin layer_V2 = mkWV2 (k74 "pinota") ; --UNCHK
lin layer_cake_N = mkWN (compoundN "täyte" (k1A "kakku")) ; --UNCHK
lin layette_N = mkWN (compoundN "uni" (k1 "asu")) "vauvan" ; --UNCHK
lin laying_N = mkWN (k9A "muninta") ; --UNCHK
lin layman_N = mkWN (k4A "maallikko") ; --UNCHK
lin lay_off_N = mkWN (k39 "lomautus") ; --UNCHK
lin lay_out_N = mkWN (k2 "asettelu") ; --UNCHK
lin layover_N = mkWN (k39 "pysähdys") ; --UNCHK
lin lazar_N = mkWN (k38 "ihminen") "spitaalinen" ; --UNCHK
lin lazaret_N = mkWN (k5A "lasaretti") ; --UNCHK
lin lazarette_N = mkWN (k5A "lasaretti") ; --UNCHK
lin lazaretto_N = mkWN (compoundN "karanteeni" (k9 "tila")) ; --UNCHK
lin lazarus_N = mkWN "Lasarus" ; --UNCHK
lin laze_V = mkWV (k67 "olla") "vapaalla" ; --UNCHK
lin laze_V2 = mkWV2 (k67 "olla") "vapaalla" ; --UNCHK
lin laziness_N = mkWN (k40 "velttous") ; --UNCHK
lin lazy_A = mkWA (k1A "veltto") ; --UNCHK
lin lazybones_N = mkWN (k39 "laiskimus") ; --UNCHK
lin lb_N = mkWN (k9 "pauna") ; --UNCHK
lin lea_N = mkWN (k1A "niitty") ; --UNCHK
lin leach_N = mkWN (k39 "suodatus") ; --UNCHK
lin leach_V2 = mkWV2 (k61 "kuoria") ; --UNCHK
lin lead_N = mkN "johto" (mkN "asema") ; --f56
lin lead_V = mkV "johtaa" ;
lin lead_V2 = mkV2 "johtaa" partitive ;
lin lead_V2V = mkV2V (mkV "ajaa") accusative infIllat ;
lin lead_on_V2 = mkWV2 (k53A "johtaa") "harhaan" ; --UNCHK
lin lead_ore_N = mkWN (compoundN "lyijy" (k5 "malmi")) ; --UNCHK
lin lead_to_V2 = prepV2 OP_lead_V OP_to_Prep ; -- guess-p-verb
lin lead_up_V = advV OP_lead_V OP_up_Adv ; -- guess-p-verb
lin leaded_A = mkWA (compoundA "lyijypi" (k38 "toinen")) ; --UNCHK
lin leaden_A = mkWA "lyijystä" "tehty" ; --UNCHK
lin leader_N = mkN (lin NK {s = d10 "johtaja"}) ;
lin leadership_N = mkWN (k40 "johtajuus") ; --f60
lin leading_A = mkA "johtava" ;
lin leading_N = mkWN (k40 "johtajuus") ; --UNCHK
lin leadplant_N = mkWN "Amorpha" "canescens" ; --UNCHK
lin leadwort_N = mkWN (compoundN "lyijy" (k10A "kukka")) ; --UNCHK
lin leaf_N = L.leaf_N ;
lin leaf_V = mkWV (k61A "lehtiä") ; --UNCHK
lin leaf_bud_N = mkWN (k1 "silmu") "lehden" ; --UNCHK
lin leaf_mould_N = mkWN (compoundN "lehti" (k10A "multa")) ; --UNCHK
lin leafed_A = mkWA (k38 "-lehtinen") ; --UNCHK
lin leafhopper_N = mkWN (compoundN "pikku" (k41 "kaskas")) ; --UNCHK
lin leafless_A = mkWA "lehdetön" ; --UNCHK
lin leaflet_N = mkWN (kH1 "läppä") ; --UNCHK
lin leaflike_A = mkWA (compoundA "lehti" (k38 "mäinen")) ; --UNCHK
lin leafy_A = mkWA (k10 "lehtevä") ; --UNCHK
lin league_1_N = mkN "liiga" ;
lin league_2_N = mkN "liiga" ;
lin league_N = mkWN (k1A "liitto") ;
lin league_V = mkWV (k52A "liittoutua") ; --UNCHK
lin league_V2 = mkWV2 (k52A "liittoutua") ; --UNCHK
lin leak_N = mkWN (k1A "vuoto") ;
lin leak_V = mkWV (k53A "vuotaa") ; --UNCHK
lin leak_V2 = mkWV2 (k53A "vuotaa") ; --UNCHK
lin leakage_N = mkWN (k1A "vuoto") ; --UNCHK
lin leaker_N = mkWN "vuotaja" ; --UNCHK
lin leakiness_N = mkWN "vuotavuus" ; --UNCHK
lin leakproof_A = mkWA (compoundA "vuodon" (k10 "kestävä")) ; --UNCHK
lin leaky_A = mkWA "vuotava" ; --UNCHK
lin leal_A = mkWA (k38 "uskollinen") ; --UNCHK
lin lean_A = mkWA (k14A "solakka") ; --UNCHK
lin lean_N = mkWN (k10 "kallistuma") ; --UNCHK
lin lean_V = mkWV (k52A "tukeutua") ; --UNCHK
lin lean_V2 = mkWV2 (k52A "tukeutua") ; --UNCHK
lin lean_on_V2 = mkWV2 (k73 "nojata") ; --UNCHK
lin leaner_N = mkWN (compoundN "noja-" (k1A "asento")) ; --UNCHK
lin leaning_N = mkWN (compoundN "kallis" (k38 "tuminen")) ; --UNCHK
lin leanness_N = mkWN (k40 "hoikkuus") ; --UNCHK
lin leap_N = mkWN (k39 "hyppäys") ;
lin leap_V = mkWV (k73A "loikata") ; --UNCHK
lin leap_V2 = mkWV2 (k73A "loikata") ; --UNCHK
lin leap_out_V = mkWV (k52 "syöksyä") "esiin" ; --UNCHK
lin leap_year_N = mkWN (compoundN "karkaus" (k27 "vuosi")) ; --UNCHK
lin leapfrog_N = mkWN (compoundN "pukki" (k1A "hyppy")) ; --UNCHK
lin leapfrog_V2 = mkWV2 (k66 "nousta") "hetkessä" ; --UNCHK
lin learn_V = mkV "oppia" ;
lin learn_V2 = L.learn_V2 ;
lin learn_VS = mkVS (mkV "oppia") ;
lin learn_VV = mkVV (mkV "oppia") infIllat ;
lin learner_N = mkWN (k41 "oppilas") ; --UNCHK
lin learning_N = mkWN (compoundN "han" (k38 "kkiminen")) "tiedon" ; --UNCHK
lin lease_N = mkWN (compoundN "vuokra" (k39 "sopimus")) ;
lin lease_V2 = mkWV2 (k53A "ottaa") "vuokralle" ;
lin leasehold_N = mkWN (compoundN "vuokra" (k18 "maa")) ; --UNCHK
lin leaseholder_N = mkWN (k38 "vuokralainen") ; --UNCHK
lin leash_N = mkWN (k5 "kuri") ; --UNCHK
lin least_Adv = mkAdv "vähiten" ;
lin least_N = mkWN (k99 "vähin") ; --UNCHK
lin leastways_Adv = mkWAdv (k99 "edes") ; --UNCHK
lin leastwise_Adv = mkWAdv (k99 "edes") ; --UNCHK
lin leather_N = L.leather_N ;
lin leatherette_N = mkWN (compoundN "keino" (k9 "nahka")) ; --UNCHK
lin leatherhead_PN = foreignPN "Leatherhead" ;
lin leather_jacket_N = mkWN (compoundN "kaali" (k38 "vaaksiainen")) ; --UNCHK
lin leatherleaf_N = mkWN (k2 "vaivero") ; --UNCHK
lin leatherneck_N = mkWN (k41 "sotilas") "merijalkaväen" ; --UNCHK
lin leatherwood_N = mkWN "Dirca" "palustris" ; --UNCHK
lin leatherwork_N = mkWN (compoundN "nahka" (k19 "työ")) ; --UNCHK
lin leathery_A = mkWA (k38 "nahkainen") ; --UNCHK
lin leave_N = mkN "virkavapaa" ; --WN (k2 "hyvästely") ---ARB
lin leave_V = mkV "lähteä" ;
lin leave_V2 = L.leave_V2 ;
lin leave_V2V = mkV2V (mkV "jättää") accusative ;
lin leave_behind_V = mkWV (k53A "jättää") "taakseen" ; --UNCHK
lin leave_off_V = mkWV (k53A "lopettaa") ; --UNCHK
lin leave_on_V2 = prepV2 OP_leave_V OP_on_Prep ; -- guess-p-verb
lin leave_open_V = advV OP_leave_V OP_open_Adv ; -- guess-p-verb
lin leave_out_V2 = mkWV2 (k73 "missata") ; --UNCHK
lin leave_over_V = advV OP_leave_V OP_over_Adv ; -- guess-p-verb
lin leaven_N = mkWN (compoundN "piristys" (k48 "ruiske")) ; --UNCHK
lin leaven_V2 = mkWV2 (k53A "kohottaa") ; --UNCHK
lin lebaneseFem_N = mkWN (compoundN "libanoni" (k38 "lainen")) ; --UNCHK
lin lebaneseMasc_N = mkWN (compoundN "libanoni" (k38 "lainen")) ; --UNCHK
lin lebanese_A = mkWA (compoundA "libanoni" (k38 "lainen")) ; --UNCHK
lin lebanon_PN = foreignPN "Libanon" ;
lin lecanopteris_N = mkWN "lecanopteris" ; --UNCHK
lin lecanora_N = mkWN (compoundN "lecan" (k10 "ora")) ; --UNCHK
lin lecher_N = mkWN (kH1 "pukki") ; --UNCHK
lin lecherous_A = mkWA (k41A "rietas") ; --UNCHK
lin lecherousness_N = mkWN (k1 "halu") ; --UNCHK
lin lechery_N = mkWN (k40 "riettaus") ; --UNCHK
lin lechwe_N = mkWN (k99 "liki") ; --UNCHK
lin lecithin_N = mkWN (k5 "lesitiini") ; --UNCHK
lin lectern_N = mkWN (k6 "lehteri") ; --UNCHK
lin lectin_N = mkWN "lektiini" ; --UNCHK
lin lector_N = mkWN (k12 "luennoitsija") ; --UNCHK
lin lecture_N = mkWN (k5A "esitelmöinti") ; --UNCHK
lin lecture_V = mkWV (k73 "saarnata") ; --UNCHK
lin lecture_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin lecturer_N = mkWN (k12 "luennoitsija") ; --UNCHK
lin lectureship_N = mkWN (k5A "lehtoraatti") ; --UNCHK
lin ledge_N = mkWN (k48A "kieleke") ; --UNCHK
lin ledger_N = mkWN (compoundN "tili" (k9 "kirja")) ; --UNCHK
lin lee_N = mkWN (k26 "puoli") "tuulensuojainen" ; --UNCHK
lin leech_N = mkWN (k12 "verenimijä") ; --UNCHK
lin leeds_PN = foreignPN "Leeds" ;
lin leek_N = mkWN (k1 "purjo") ; --UNCHK
lin leek_PN = foreignPN "Leek" ;
lin leer_N = mkWN (k39 "silmäys") ; --UNCHK
lin leer_V = mkWV (k67 "silmäillä") ; --UNCHK
lin leery_A = mkWA (k38 "varovainen") ; --UNCHK
lin lees_N = mkWN (k9A "sakka") ; --UNCHK
lin leeward_A = mkWA (compoundA "suojan" (k38 "puoleinen")) ; --UNCHK
lin leeward_Adv = mkWAdv (k99 "vastaan") "tuulta" ; --UNCHK
lin leeward_N = mkWN (k26 "puoli") "tuulensuojainen" ; --UNCHK
lin leeway_N = mkWN (k5 "toleranssi") ;
lin leflunomide_N = mkWN (k5 "leflunomidi") ; --UNCHK
lin left_A = mkA "vasemmistolainen" ;
lin left_N = mkWN (k37 "vasen") ; --UNCHK
lin left_Ord = L.left_Ord ;
lin left_hand_A = mkA (mkN "vasemman" (mkN "puoleinen")) ;
lin left_handed_A = mkA (mkN "vasen" (mkN "kätinen")) ;
lin left_of_Prep = mkPrep elative "vasemmalla" ;
lin left_wing_N = mkWN (k1 "vasemmisto") ; --UNCHK
lin leftish_A = mkWA (k99 "päin") "vasemmistoon" ; --UNCHK
lin leftism_N = mkWN (k40 "vasemmistolaisuus") ; --UNCHK
lin leftist_A = mkWA (k38 "vasemmistolainen") ; --UNCHK
lin leftist_N = mkWN (k38 "vasemmistolainen") ; --UNCHK
lin leftmost_A = mkWA (k99 "vasemmalla") "äärimmäisenä" ; --UNCHK
lin leftover_A = mkWA (k10 "oleva") "jäljellä" ; --UNCHK
lin leftover_N = mkWN (k48A "ripe") ; --UNCHK
lin leg_N = L.leg_N ;
lin legacy_N = mkWN (k5A "testamentti") ; --UNCHK
lin legal_A = mkA "laillinen" ;
lin legalese_N = mkWN (compoundN "laki" (k26 "kieli")) ; --UNCHK
lin legalism_N = mkWN (compoundN "lain" (k40 "mukaisuus")) ; --UNCHK
lin legalistic_A = mkA "legalistinen" ;
lin legality_N = mkWN (k40 "laillisuus") ; --UNCHK
lin legalization_N = mkWN (k39 "laillistus") ; --UNCHK
lin legalize_V2 = mkWV2 (k62 "legitimoida") ; --UNCHK
lin legate_N = mkWN (k41 "lähettiläs") "virallinen" ; --UNCHK
lin legation_N = mkWN (k1 "lähetystö") ; --UNCHK
lin legato_A = mkWA (k38 "tasainen") ; --UNCHK
lin legato_Adv = mkWAdv "legato" ; --UNCHK
lin legend_N = mkN "legenda" ; ---- split WN (k48 "seloste") ;
lin legendary_A = mkWA (k38 "legendaarinen") ;
lin leger_line_N = mkWN (compoundN "pitkittäis" (k9 "linja")) ; --UNCHK
lin legerdemain_N = mkWN (k3 "illuusio") ; --UNCHK
lin legged_A = mkWA (k38 "-jalkainen") ; --UNCHK
lin leggy_A = mkWA (compoundA "pitkä" (k38 "jalkainen")) ; --UNCHK
lin leghorn_N = mkWN (compoundN "panama" (k1A "hattu")) ; --UNCHK
lin legibility_N = mkWN (k40 "luettavuus") ; --UNCHK
lin legible_A = mkWA (k10 "luettava") ; --UNCHK
lin legion_N = mkWN (k10 "määrä") "valtava" ; --UNCHK
lin legionary_N = mkWN (k38 "legioonalainen") ; --UNCHK
lin legionnaire_N = mkWN (k38 "legioonalainen") ; --UNCHK
lin legislate_V = mkWV (k53A "säätää") ; --UNCHK
lin legislate_V2 = mkWV2 (k53A "säätää") ; --UNCHK
lin legislation_N = mkN "lain" (mkN "säädäntö") ;
lin legislative_A = mkWA (k38 "lainsäädännöllinen") ;
lin legislator_N = mkWN (compoundN "lain" (k10 "säätäjä")) ;
lin legislatorship_N = mkWN (k25 "toimi") "lainsäätäjän" ; --UNCHK
lin legislature_N = mkN "lain" (mkN "säädäntö") ;
lin legitimacy_N = mkWN (k40 "oikeellisuus") ; --UNCHK
lin legitimate_A = mkWA (k10 "pätevä") ; --UNCHK
lin legitimation_N = mkWN (k39 "laillistus") ; --UNCHK
lin legitimatize_V2 = mkWV2 (k62 "legitimoida") ; --UNCHK
lin legitimize_V2 = mkWV2 (k62 "legitimoida") ; --UNCHK
lin legitimize_V2V = mkWV2V (k62 "legitimoida") ; --UNCHK
lin legless_A = mkWA "jalaton" ; --UNCHK
lin leglike_A = mkWA (compoundA "jalan" (k38 "omainen")) ; --UNCHK
lin legume_N = mkWN (k1A "palko") ; --UNCHK
lin leguminous_A = mkWA (k38 "omainen") "palkokasvin" ; --UNCHK
lin lehtimäki_PN = mkPN (mkN "Lehtimäki" "Lehtimäkiä") ;
lin lei_N = mkWN (k5 "kranssi") ; --UNCHK
lin leicester_PN = foreignPN "Leicester" ;
lin leiden_PN = foreignPN "Leiden" ;
lin leigh_PN = foreignPN "Leigh" ;
lin leiomyoma_N = mkWN (compoundN "leio" (k10 "myooma")) ; --UNCHK
lin leiomyosarcoma_N = mkWN (compoundN "leiomyo" (k10 "sarkooma")) ; --UNCHK
lin leipzig_PN = foreignPN "Leipzig" ;
lin leishmaniasis_N = mkWN (compoundN "leishmani" (k5 "aasi")) ; --UNCHK
lin leister_N = mkWN (k12 "harppuuna") ; --UNCHK
lin leisure_N = mkWN (k9 "vapaa-aika") ;
lin leisured_A = mkWA (k41 "joutilas") ; --UNCHK
lin leisureliness_N = mkWN (k40 "verkkaisuus") ; --UNCHK
lin leisurely_A = mkWA (k34A "kiireetön") ; --UNCHK
lin leisurely_Adv = mkWAdv (k99 "verkkaisesti") | adjAdv leisurely_A ; --UNCHK -- derived
lin leitmotiv_N = mkWN (compoundN "johto" (k48 "aihe")) ; --UNCHK
lin leivonmäki_PN = mkPN (mkN "Leivonmäki" "Leivonmäkiä") ;
lin lek_N = mkWN "lek" ; --UNCHK
lin lekvar_N = mkWN "lekvar" ; --UNCHK
lin lemi_PN = mkPN "Lemi" ;
lin lemma_N = mkWN (k4A "otsikko") ; --UNCHK
lin lemming_N = mkWN (k6 "sopuli") ; --UNCHK
lin lemniscus_N = mkWN (compoundN "aisti" (k1 "hermo")) ; --UNCHK
lin lemon_N = mkWN (k27 "susi") ; --UNCHK
lin lemonade_N = mkWN (k5 "limonadi") ; --UNCHK
lin lemongrass_N = mkWN (compoundN "sitruuna" (k1 "ruoho")) ; --UNCHK
lin lemonwood_N = mkWN "Psychotria" "capensis" ; --UNCHK
lin lemony_A = mkWA (k15 "kirpeä") ; --UNCHK
lin lempira_N = mkWN "lempira" ; --UNCHK
lin lempäälä_PN = mkPN "Lempäälä" ;
lin lemu_PN = mkPN "Lemu" ;
lin lemur_N = mkWN "maki" ; --UNCHK
lin lend_V = mkWV (k56A "antaa") "lainaksi" ; --f76
lin lend_V2 = mkWV2 (k56A "antaa") "lainaksi" ; --UNCHK
lin lendable_A = mkWA (k10 "oleva") "lainattavissa" ; --UNCHK
lin lender_N = mkWN (k10 "lainaaja") ; --f58
lin lending_N = mkWN (k39 "lainaus") ; --UNCHK
lin lending_library_N = mkWN (k2 "kirjasto") ; --UNCHK
lin length_N = mkWN (k40 "pituus") ;
lin lengthen_V = mkWV (k72A "pidetä") ; --UNCHK
lin lengthen_V2 = mkWV2 (k72A "pidetä") ; --UNCHK
lin lengthiness_N = mkWN (k39 "pidennys") ; --UNCHK
lin lengthways_A = mkWA (k38 "pitkittäinen") ; --UNCHK
lin lengthways_Adv = mkWAdv (k99 "pitkittäin") ; --UNCHK
lin lengthwise_A = mkWA (k38 "pitkittäinen") ; --UNCHK
lin lengthwise_Adv = mkWAdv (k99 "pitkittäin") ; --UNCHK
lin lengthy_A = mkWA (k38 "pitkällinen") ; --UNCHK
lin lenience_N = mkWN (k40 "lievyys") ; --UNCHK
lin leniency_N = mkWN (k40 "lievyys") ; --UNCHK
lin lenient_A = mkWA (k38 "armollinen") ; --UNCHK
lin lenitive_N = mkWN (k48A "lääke") "lievittävä" ; --UNCHK
lin lenity_N = mkWN (k40 "lievyys") ; --UNCHK
lin lens_N = mkWN (k5 "linssi") ; --UNCHK
lin lens_PN = foreignPN "Lens" ;
lin lent_N = mkWN (k1 "paasto") ; --UNCHK
lin lent_PN = foreignPN "Lent" ;
lin lenten_A = mkWA (compoundA "paaston" (k38 "aikainen")) ; --UNCHK
lin lentic_A = mkWA "järvi-" ; --UNCHK
lin lenticel_N = mkWN (compoundN "korkki" (k38 "huokonen")) ; --UNCHK
lin lentil_N = mkWN (k5 "linssi") ; --UNCHK
lin lentissimo_A = mkWA (k99 "hitaasti") "hyvin" ; --UNCHK
lin lento_A = mkWA (kH1 "lento") ; --UNCHK
lin leominster_PN = foreignPN "Leominster" ;
lin leon_PN = foreignPN "Leon" ;
lin leonard_PN = foreignPN "Leonard" ;
lin leone_N = mkWN "leone" ; --UNCHK
lin leonine_A = mkWA (compoundA "muis" (k10 "tuttava")) "leijonaa" ; --UNCHK
lin leopard_N = mkWN (k5 "leopardi") ; --UNCHK
lin leopardess_N = mkWN (compoundN "naaras" (k5 "leopardi")) ; --UNCHK
lin leotard_N = mkWN (compoundN "kissa-" (k1 "asu")) ; --UNCHK
lin leper_N = mkWN (k2 "henkilö") "hyljeksitty" ; --UNCHK
lin lepidobotrys_N = mkWN "lepidobotrys" ; --UNCHK
lin lepidolite_N = mkWN (compoundN "litium" (k48A "kiille")) ; --UNCHK
lin lepidophobia_N = mkWN (compoundN "lepido" (k12 "fobia")) ; --UNCHK
lin lepidopterist_N = mkWN (compoundN "perhos" (k12 "tutkija")) ; --UNCHK
lin lepidopterology_N = mkWN (compoundN "perhos" (k39 "tutkimus")) ; --UNCHK
lin lepidote_A = mkWA (k38 "rosoinen") ; --UNCHK
lin lepiota_N = mkWN (compoundN "lepi" (k10A "ota")) ; --UNCHK
lin leppävirta_PN = mkPN "Leppävirta" ;
lin leprechaun_N = mkWN (k12 "haltija") "ilkikurinen" ; --UNCHK
lin leprosy_N = mkWN (k6 "spitaali") ; --UNCHK
lin leprous_A = mkWA (k38 "spitaalinen") ; --UNCHK
lin leptocephalus_N = mkWN (compoundN "leptoceph" (k39 "alus")) ; --UNCHK
lin leptomeningitis_N = mkWN "leptomeningiitti" ; --UNCHK
lin lepton_1_N = mkWN (k6 "leptoni") ; --UNCHK
lin lepton_2_N = mkWN (k6 "leptoni") ; --UNCHK
lin leptorrhine_A = mkWA (compoundA "kapea" (k38 "nenäinen")) "pitkä-" "ja" ; --UNCHK
lin leptospira_N = mkWN "leptospira" ; --UNCHK
lin leptosporangiate_A = mkWA "leptosporangiate" ; --UNCHK
lin leptosporangium_N = mkWN "leptosporangium" ; --UNCHK
lin leptotene_N = mkWN "leptoteeni" ; --UNCHK
lin leresis_N = mkWN (k40 "puheliaisuus") ; --UNCHK
lin lerot_N = mkWN (compoundN "tammi" (k24 "hiiri")) ; --UNCHK
lin lerwick_PN = foreignPN "Lerwick" ;
lin les_PN = foreignPN "Les" ;
lin lesbian_A = mkWA "lesbo-" ; --UNCHK
lin lesbian_N = mkWN (compoundN "lesbos" (k38 "lainen")) ; --UNCHK
lin lesbianism_N = mkWN (k40 "lesbous") ; --UNCHK
lin lese_majesty_N = mkWN (compoundN "majesteetti" (k39 "rikos")) ; --UNCHK
lin lesion_N = mkWN (k10 "vioittuma") ; --UNCHK
lin leslie_PN = foreignPN "Leslie" ;
lin lesotho_PN = foreignPN "Lesotho" ;
lin less_A = mkWA (k99 "vähemmän") ; --UNCHK
lin less_AdA = mkWAdA (k99 "vähemmän") ; --UNCHK
lin less_Adv = mkAdv "vähemmän" ;
lin less_CAdv = S.less_CAdv ;
lin less_Det = mkDet Sg (exceptNomN (mkN "vähempä") "vähemmän") ;
lin less_than_AdN = mkAdN "alle" ;
lin lessee_N = mkWN (k38 "vuokralainen") ; --UNCHK
lin lessen_V = mkWV (k58 "laskea") ; --UNCHK
lin lessen_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin lesser_A = mkWA "vähäpätöisempi" ; --UNCHK
lin lesson_N = mkWN (k10 "tehtävä") ; --UNCHK
lin lessor_N = mkWN (k10 "vuokraaja") ; --UNCHK
lin lest_Prep = mkPrep "ellei" partitive ; ---??
lin lestijärvi_PN = mkPN (mkN "Lestijärvi" "Lestijärviä") ;
lin let_N = mkWN (compoundN "verkko" (k1A "syöttö")) ; --UNCHK
lin let_V2V = mkV2V (mkV "antaa") genitive infFirst ;
lin let_down_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin let_in_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin let_off_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin let_on_V = mkWV (k52A "kertoa") ; --UNCHK
lin let_out_V2 = mkWV2 (k54A "suurentaa") ; --UNCHK
lin let_up_V = mkWV (k53A "hellittää") ; --UNCHK
lin letchworth_PN = foreignPN "Letchworth" ;
lin lethal_A = mkWA (k10 "kuolettava") ; --UNCHK
lin lethargic_A = mkWA (k10 "vetelä") ; --UNCHK
lin lethargy_N = mkWN (k40 "latteus") ; --UNCHK
lin letter_1_N = mkN "kirje" ;
lin letter_2_N = mkN "kirjain" ;
lin letter_N = mkN "kirje" ;
lin letter_box_N = mkWN (compoundN "posti" (k4A "laatikko")) ; --UNCHK
lin letter_case_N = mkWN (compoundN "kirje" (k1 "tasku")) ; --UNCHK
lin letter_card_N = mkWN (compoundN "posti" (k5A "kortti")) ; --UNCHK
lin lettered_A = mkWA (k47 "sivistynyt") ; --UNCHK
lin letterer_N = mkWN (k10 "kirjoittaja") ; --UNCHK
lin letterhead_N = mkWN (compoundN "kirje" (k48A "lomake")) ; --UNCHK
lin lettering_N = mkWN (k39 "kirjoitus") ; --UNCHK
lin letterman_N = mkWN (k12 "urheilija") ; --UNCHK
lin letterpress_N = mkWN (compoundN "koho" (k1 "paino")) ; --UNCHK
lin letters_N = mkWN (k6 "kulttuuri") "kirjallinen" ; --UNCHK
lin letting_N = mkWN (compoundN "vuokra" (k48A "kohde")) ; --UNCHK
lin lettuce_N = mkWN (compoundN "lehti" (k5A "salaatti")) ; --UNCHK
lin let_up_N = mkWN (k1A "tauko") ; --UNCHK
lin leu_N = mkWN "lei" ;
lin leucine_N = mkWN "leusiini" ; --UNCHK
lin leucocyte_N = mkWN (k5A "leukosyytti") ; --UNCHK
lin leucocytozoan_N = mkWN "leucocytozoon" ; --UNCHK
lin leucothoe_N = mkWN "leucothoe" ; --UNCHK
lin leukaemia_N = mkWN (k12 "leukemia") ; --UNCHK
lin leukocyte_N = mkWN (k5A "leukosyytti") ; --UNCHK
lin leukocytosis_N = mkWN "leukosytoosi" ; --UNCHK
lin leukoderma_N = mkWN "leukoderma" ; --UNCHK
lin leukoencephalitis_N = mkWN "leukoenkefaliitti" ; --UNCHK
lin leukoma_N = mkWN (compoundN "leu" (k10 "kooma")) ; --UNCHK
lin leukopenia_N = mkWN "leukopenia" ; --UNCHK
lin leukorrhea_N = mkWN (compoundN "valko" (k1A "vuoto")) ; --UNCHK
lin lev_N = mkWN "leva" ;
lin levallorphan_N = mkWN (compoundN "Lor" (k5 "fan")) ; --UNCHK
lin levant_PN = foreignPN "Levant" ;
lin levanter_N = mkWN "itätuuli" "Levante" ; --UNCHK
lin levantine_A = mkWA (compoundA "levantti" (k38 "lainen")) ; --UNCHK
lin levantine_N = mkWN (compoundN "levantti" (k38 "lainen")) ; --UNCHK
lin levator_N = mkWN (compoundN "nostaja" (k39 "lihas")) ; --UNCHK
lin levee_N = mkWN (compoundN "tulva" (k1A "pato")) ; --UNCHK
lin level_1_N = mkN "taso" ;
lin level_2_N = mkN "taso" ;
lin level_A = mkWA (k99 "tasan") ; --UNCHK
lin level_N = mkN "taso" ;
lin level_V = mkWV (k52A "tasoittua") ; --UNCHK
lin level_V2 = mkWV2 (k52A "tasoittua") ; --UNCHK
lin level_off_V = mkWV (k52A "tasoittua") ; --UNCHK
lin leveler_N = mkWN "tasoittaja" ; --UNCHK
lin leveller_N = mkWN "tasoittaja" ; --UNCHK
lin leven_PN = foreignPN "Leven" ;
lin lever_N = mkWN (k7A "kanki") ; --UNCHK
lin lever_V2 = mkWV2 (k74A "kangeta") ; --UNCHK
lin leverage_N = mkN "vipu" (mkN "voima") ;
lin leveret_N = mkWN (k39 "jänis") "nuori" ; --UNCHK
lin leverkusen_PN = foreignPN "Leverkusen" ;
lin leviathan_N = mkWN (compoundN "meri" (k3 "hirviö")) ; --UNCHK
lin levirate_N = mkWN (compoundN "leviraattiavio" (k1A "liitto")) ; --UNCHK
lin levitate_V = mkWV (k52 "leijua") ; --UNCHK
lin levitate_V2 = mkWV2 (k52 "leijua") ; --UNCHK
lin levitation_N = mkWN (k3 "levitaatio") ; --UNCHK
lin levity_N = mkWN (k40 "keveys") ; --UNCHK
lin levorotary_A = mkWA "vasemmalle" "kiertävä" ; --UNCHK
lin levorotation_N = mkWN (k1A "kierto") "vastapäivään" ; --UNCHK
lin levy_N = mkWN (k9A "kutsunta") ; --UNCHK
lin levy_V = mkWV (k53A "ottaa") "sotaväkeen" ; --UNCHK
lin levy_V2 = mkWV2 (k53A "ottaa") "sotaväkeen" ; --UNCHK
lin lewd_A = mkWA (k34A "moraaliton") ; --UNCHK
lin lewdness_N = mkWN (k40 "riettaus") ; --UNCHK
lin lewes_PN = foreignPN "Lewes" ;
lin lexeme_N = mkWN (compoundN "lekse" (k5 "emi")) ; --UNCHK
lin lexical_A = mkWA (k38 "sanastollinen") ; --UNCHK
lin lexicalization_N = mkWN (compoundN "leksikali" (k5A "sointi")) ; --UNCHK
lin lexicalized_A = mkWA (compoundA "leksikaalis" (k47 "tunut")) ; --UNCHK
lin lexicographerFem_N = mkWN (k5 "leksikografi") ; --UNCHK
lin lexicographerMasc_N = mkWN (k5 "leksikografi") ; --UNCHK
lin lexicographic_A = mkWA (compoundA "leksikografi" (k38 "nen")) ; --UNCHK
lin lexicography_N = mkWN (k12 "leksikografia") ; --UNCHK
lin lexicology_N = mkWN (k12 "leksikologia") ; --UNCHK
lin lexicon_N = mkWN (k2 "sanasto") "mentaalinen" ; --UNCHK
lin lexicostatistic_A = mkWA "leksikostatistiikkaan" "liittyvä" ; --UNCHK
lin lexicostatistics_N = mkWN (compoundN "leksiko" (k9A "statistiikka")) ; --UNCHK
lin lexis_N = mkWN (k2 "sanasto") ; --UNCHK
lin ley_N = mkWN (k1A "niitty") ; --UNCHK
lin leyland_PN = foreignPN "Leyland" ;
lin li_N = mkWN "li" ; --UNCHK
lin liabilities_N = mkWN (k9A "velka") ; --UNCHK
lin liability_N = mkWN (k48A "rasite") ; --f86
lin liable_A = mkWA (k41A "altis") ; --UNCHK
lin liaise_V = mkWV (k61 "toimia") "välittäjänä" ; --UNCHK
lin liaison_N = mkWN (k5 "kontakti") ; --UNCHK
lin liana_N = mkWN (k5 "liaani") ; --UNCHK
lin liar_N = mkWN (k12 "valehtelija") ; --UNCHK
lin lib_PN = foreignPN "Lib" ;
lin libation_N = mkWN (compoundN "juoma" (k5 "uhri")) ; --UNCHK
lin libel_N = mkWN (compoundN "kunnian" (k39 "loukkaus")) ;
lin libel_V2 = mkWV2 (k73 "herjata") ; --UNCHK
lin libellous_A = mkWA (compoundA "must" (k9 "aava")) ; --UNCHK
lin liberal_A = mkWA (k38 "liberaalinen") ; --UNCHK
lin liberal_N = mkWN (k5 "liberalisti") ; --UNCHK
lin liberalism_N = mkWN (k5 "liberalismi") ; --UNCHK
lin liberalistic_A = mkWA (compoundA "vapa" (k38 "amielinen")) ; --UNCHK
lin liberality_N = mkWN (k40 "suvaitsevaisuus") ; --UNCHK
lin liberalization_N = mkWN (k39 "höllennys") "sääntöjen" ;
lin liberalize_V2 = mkV2 "liberalisoida" ; --WV2 (k53 "liberaalistaa") ;
lin liberate_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin liberation_N = mkWN (k39 "vapautus") ; --UNCHK
lin liberator_N = mkWN (k10 "vapauttaja") ; --UNCHK
lin liberia_PN = foreignPN "Liberia" ;
lin liberian_A = mkWA (compoundA "liberi" (k38 "alainen")) ; --UNCHK
lin liberian_N = mkWN (compoundN "liberi" (k38 "alainen")) ; --UNCHK
lin libertarianism_N = mkWN (compoundN "libertarian" (k5 "ismi")) ; --UNCHK
lin libertine_N = mkWN (k12 "irstailija") ; --UNCHK
lin liberty_N = mkWN (k40 "vapaus") ; --UNCHK
lin libidinal_A = mkWA (compoundA "libidina" (k38 "alinen")) ; --UNCHK
lin libidinous_A = mkWA (k38 "hekumallinen") ; --UNCHK
lin libido_N = mkWN (k1 "libido") ; --UNCHK
lin librarian_N = mkWN (compoundN "kirjaston" (k10 "hoitaja")) ; --UNCHK
lin librarianship_N = mkWN (k25 "toimi") "kirjastonhoitajan" ; --UNCHK
lin library_N = mkWN (k2 "kirjasto") ;
lin libration_N = mkWN (k2 "leijailu") ; --UNCHK
lin librettist_N = mkWN "libretisti" ; --UNCHK
lin libretto_N = mkWN (k5 "teksti") ; --UNCHK
lin libya_PN = foreignPN "Libya" ;
lin libyan_A = mkA "libyalainen" ;
lin libyan_N = mkWN (compoundN "liby" (k38 "alainen")) ; --UNCHK
lin licence_N = mkWN (k5 "lisenssi") ; --UNCHK
lin licence_V2 = mkWV2 (k53 "laillistaa") ; --UNCHK
lin license_N = mkN "lisenssi" ;
lin license_V2 = mkV2 "luvallistaa" ;
lin licensee_N = mkWN (k12 "haltija") "luvan" ; --UNCHK
lin licenser_N = mkWN (compoundN "lisenssin" (k10 "antaja")) ; --UNCHK
lin licentiate_N = mkWN (k5A "lisensiaatti") ; --UNCHK
lin licentious_A = mkWA (k1 "rivo") ; --UNCHK
lin licentiousness_N = mkWN (k40 "rivous") ; --UNCHK
lin lichen_N = mkWN (k10 "jäkälä") ; --UNCHK
lin lichfield_PN = foreignPN "Lichfield" ;
lin lichgate_N = mkWN (k5A "portti") "katettu" ; --UNCHK
lin licit_A = mkWA (k38 "luvallinen") ; --UNCHK
lin licitness_N = mkWN (k40 "laillisuus") ; --UNCHK
lin lick_N = mkWN (k5 "tälli") ; --UNCHK
lin lick_V2 = mkWV2 (k53A "rökittää") ; --UNCHK
lin licking_N = mkWN (k39 "löylytys") ; --UNCHK
lin lid_N = mkN "kansi" "kannen" "kansia" ; --mkWN (k5A "lakki") ;
lin lidar_N = mkWN (compoundN "lidar-mitta" (k48A "laite")) ; --UNCHK
lin lidded_A = mkWA (k10 "oleva") "puoliummessa" ; --UNCHK
lin lidless_A = mkWA "kanneton" ; --UNCHK
lin lido_N = mkWN (compoundN "maa" (k12 "uimala")) ; --UNCHK
lin lie_1_V = mkV "maata" ;
lin lie_2_V = mkV "valehdella" ;
lin lie_N = mkWN (k48 "valhe") ; --UNCHK
lin lie_V = L.lie_V ;
lin lie_VS = mkVS (mkV "valehdella") ;
lin lie_around_V = mkWV (k67 "lorvailla") ; --UNCHK
lin lie_back_V = advV OP_lie_V OP_back_Adv ; -- guess-p-verb
lin lie_detector_N = mkWN (compoundN "valheen" (k33 "paljastin")) ; --UNCHK
lin lie_down_V = advV OP_lie_V OP_down_Adv ; -- guess-p-verb
lin lie_down_on_V2 = prepV2 (advV OP_lie_V OP_down_Adv ) OP_on_Prep ; -- guess-p-verb
lin lie_with_V2 = mkV2 (mkV "maata") (postGenPrep "kanssa") ; --UNCHK
lin liebfraumilch_N = mkWN "liebfraumilch" ; --UNCHK
lin liechtenstein_PN = foreignPN "Liechtenstein" ;
lin liechtensteiner_A = mkWA (compoundA "liechtensteini" (k38 "lainen")) ; --UNCHK
lin liechtensteiner_N = mkWN (compoundN "liechtensteini" (k38 "lainen")) ; --UNCHK
lin lied_N = mkWN (k5 "lied") ; --UNCHK
lin lieder_singer_N = mkWN (compoundN "lied" (k10 "laulaja")) ; --UNCHK
lin lief_Adv = mkWAdv (k99 "halukkaasti") ; --UNCHK
lin liege_A = mkWA "feodaali-" ; --UNCHK
lin liege_N = mkWN "Luik" ; --UNCHK
lin liegeman_N = mkWN (k5 "vasalli") ; --UNCHK
lin lieksa_PN = mkPN "Lieksa" ;
lin lien_N = mkWN (k9 "perna") ; --UNCHK
lin lieto_PN = mkPN "Lieto" ;
lin lieu_N = mkWN (k9 "sija") ; --UNCHK
lin lieutenancy_N = mkWN (k9A "virka") "luutnantin" ; --UNCHK
lin lieutenant_N = mkWN (k10 "edustaja") ; --UNCHK
lin life_N = mkN "elämä" ;
lin life_buoy_N = mkWN (compoundN "pelastus" (k41A "rengas")) ; --UNCHK
lin life_jacket_N = mkWN (k5 "pelastusliivi") ; --UNCHK
lin life_office_N = mkWN (compoundN "henkivakuutus" (k3 "yhtiö")) ; --UNCHK
lin life_preserver_N = mkWN (k5 "pelastusliivi") ; --UNCHK
lin life_raft_N = mkWN (compoundN "pelastus" (k9A "lautta")) ; --UNCHK
lin life_saver_N = mkWN "Life" "Saver" ; --UNCHK
lin lifeblood_N = mkWN (compoundN "elin" (k1A "ehto")) ; --UNCHK
lin lifeboat_N = mkWN (compoundN "pelastus" (k48 "vene")) ; --UNCHK
lin lifeguard_N = mkWN (compoundN "hengen" (k10 "pelastaja")) ; --UNCHK
lin lifeless_A = mkWA (k47 "kuollut") ; --UNCHK
lin lifelike_A = mkWA (k10 "luonteva") ; --UNCHK
lin lifeline_N = mkWN (compoundN "pelastus" (k27 "köysi")) ; --UNCHK
lin lifelong_A = mkWA (compoundA "elin" (k38 "ikäinen")) ; --UNCHK
lin lifer_N = mkWN (compoundN "elinkautis" (k5A "vanki")) ; --UNCHK
lin lifesaving_N = mkWN (compoundN "hengen" (k39 "pelastus")) ; --UNCHK
lin life_span_N = variants {} ; --
lin lifestyle_N = variants {} ; --
lin lifetime_N = mkN "elin" (mkN "aika") ;
lin life_work_N = mkWN (compoundN "elämän" (k19 "työ")) ; --UNCHK
lin lift_N = mkWN (k1 "nosto") ; --UNCHK
lin lift_V = mkWV (k71 "tehdä") "kasvojenkohotusleikkaus" ; --UNCHK
lin lift_V2 = mkWV2 (k71 "tehdä") "kasvojenkohotusleikkaus" ; --UNCHK
lin lift_off_N = mkWN (k1A "lähtö") ; --UNCHK
lin lift_off_V = mkWV (k66 "nousta") ; --UNCHK
lin liftman_N = mkWN (compoundN "hissi" (k10A "poika")) ; --UNCHK
lin ligament_N = mkWN (k48A "side") ; --UNCHK
lin ligand_N = mkWN "ligandi" ; --UNCHK
lin ligation_N = mkWN "sitominen" ; --UNCHK
lin ligature_N = mkWN "sitominen" ; --UNCHK
lin light_1_A = mkA (mkN "kevyt" "kevyitä") ;
lin light_2_A = mkWA (k10 "valoisa") ;
lin light_Adv = mkWAdv (k99 "kevyesti") ; --UNCHK
lin light_N = mkN "valo" ;
lin light_V = mkWV (k66 "valaista") ; --UNCHK
lin light_V2 = mkWV2 (k66 "valaista") ; --UNCHK
lin light_heavyweight_N = mkWN (compoundN "keskis" (k38 "arjalainen")) "ylempi" ; --UNCHK
lin light_out_V = advV OP_light_V OP_out_Adv ; -- guess-p-verb
lin light_up_V = mkWV (k66 "valaista") ; --UNCHK
lin light_up_V2 = mkWV2 (k66 "valaista") ; --UNCHK
lin lighten_V = mkWV (k54A "keventää") ; --UNCHK
lin lighten_V2 = mkWV2 (k54A "keventää") ; --UNCHK
lin lighten_up_V2 = mkWV2 (k52 "kirkastua") ; --UNCHK
lin lightening_N = mkWN "vaaleneminen" ; --UNCHK
lin lighter_N = mkWN (k10 "lotja") "raskas" ; --UNCHK
lin lighter_V2 = mkWV2 (k58A "kulkea") "lotjalla" ; --UNCHK
lin lighterage_N = mkWN (compoundN "proomu" (k39 "kuljetus")) ; --UNCHK
lin lighterman_N = mkWN (k10 "kuljettaja") "proomun" ; --UNCHK
lin light_headedness_N = mkWN (k40 "sekavuus") ; --UNCHK
lin lighthouse_N = mkWN (k14A "majakka") ; --UNCHK
lin lighting_N = mkWN (k39 "sytytys") ; --UNCHK
lin lightless_A = mkWA (k15 "pimeä") ; --UNCHK
lin lightness_N = mkWN (k40 "keveys") ; --UNCHK
lin lightning_N = mkWN (k12 "salama") ;
lin lightning_conductor_N = mkWN (compoundN "ukkosen" (k33A "johdatin")) ; --UNCHK
lin lightning_rod_N = mkWN (compoundN "ukkosen" (k33A "johdatin")) ; --UNCHK
lin lightproof_A = mkWA (compoundA "valon" (k10 "kestävä")) ; --UNCHK
lin lightship_N = mkWN (compoundN "majakka" (k9 "laiva")) ; --UNCHK
lin lightsome_A = mkWA (k41A "riemukas") ; --UNCHK
lin lightsomeness_N = mkWN (k40 "keveys") ; --UNCHK
lin lightweight_A = mkWA (k38 "köykäinen") ; --UNCHK
lin lightweight_N = mkWN (compoundN "kevytsarja" (k38 "lainen")) ; --UNCHK
lin lightwood_N = mkWN (compoundN "mustapuu" (k12 "akasia")) ; --UNCHK
lin ligne_N = mkWN "ligne" ; --UNCHK
lin ligneous_A = mkWA (compoundA "ligniinipi" (k38 "toinen")) ; --UNCHK
lin lignin_N = mkWN (k5 "ligniini") ; --UNCHK
lin lignite_N = mkWN (compoundN "rusko" (k24 "hiili")) ; --UNCHK
lin lignosae_N = mkWN "lignosae" ; --UNCHK
lin lignum_N = mkWN "lignum" ; --UNCHK
lin ligule_N = mkWN (k48A "kieleke") ; --UNCHK
lin likable_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin like_A = mkWA (k38 "samanlainen") ;
lin like_Adv = variants {} ; -- postPrep genitive "tavalla" ; ---
lin like_N = mkWN (k38 "lainen") ; --UNCHK
lin like_Prep = postPrep genitive "tavalla" | mkPrep nominative "kuin" ;
lin like_Subj = mkSubj "kuten" ; --
lin like_V2 = L.like_V2 ;
lin like_VS = mkVS (mkV (mkV "pitää") "siitä") ; -- pidän siitä, että XYZ
lin like_VV = mkVV "tykätä" ; ---- need more inf forms ; "pidän kutomisesta" rather than "tykkään kutoa"
lin likeable_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin likelihood_N = mkWN (compoundN "toden" (k40 "näköisyys")) ; --UNCHK
lin likely_A = mkWA (compoundA "toden" (k38 "näköinen")) ;
lin liken_V2 = mkWV2 (k53 "rinnastaa") ; --UNCHK
lin likeness_N = mkWN (compoundN "ulko" (k1A "muoto")) ; --UNCHK
lin likening_N = mkWN (k2 "vertailu") "samankaltaisuuden" ; --UNCHK
lin likewise_Adv = mkWAdv (k99 "kanssa") ; --UNCHK
lin liking_N = mkWN (k39 "mieltymys") ; --UNCHK
lin likuta_N = mkWN "makuta" ; --UNCHK
lin lilac_N = mkWN (k6 "syreeni") ; --UNCHK
lin lilangeni_N = mkWN "lilangeni" ; --UNCHK
lin liliaceous_A = mkWA "liliaceous" ; --UNCHK
lin lilian_PN = foreignPN "Lilian" ;
lin liljendal_PN = mkPN "Liljendal" ;
lin lille_PN = foreignPN "Lille" ;
lin lilliputian_A = mkWA "Lilliputin" ; --UNCHK
lin lilliputian_N = mkWN (k5A "lilliputti") ; --UNCHK
lin lilt_N = mkWN (k5 "rytmi") ; --UNCHK
lin lilt_V = mkWV (k54A "ääntää") "huolellisesti" ; --UNCHK
lin lilt_V2 = mkWV2 (k54A "ääntää") "huolellisesti" ; --UNCHK
lin lily_N = mkWN (k9 "lilja") ; --UNCHK
lin lilyturf_N = mkWN "Liriope" "muscari" ; --UNCHK
lin lima_PN = foreignPN "Lima" ;
lin limacine_A = mkWA (compoundA "etana" (k38 "mainen")) ; --UNCHK
lin liman_N = mkWN (k5 "laguuni") ; --UNCHK
lin limb_N = mkWN (k9 "raaja") ; --UNCHK
lin limbed_A = mkWA (k38 "-raajainen") ; --UNCHK
lin limber_A = mkWA (k10 "taipuisa") ; --UNCHK
lin limber_V = mkWV (k67A "verrytellä") ; --UNCHK
lin limber_V2 = mkWV2 (k67A "verrytellä") ; --UNCHK
lin limber_up_V = mkWV (k67A "verrytellä") ; --UNCHK
lin limbers_N = mkWN (compoundN "virtaus" (k10A "reikä")) ; --UNCHK
lin limbic_A = mkWA "reuna-alueeseen" "liittyvä" ; --UNCHK
lin limbless_A = mkWA "raajaton" ; --UNCHK
lin limbo_N = mkN "jännitys" (mkN "tila") ; ---ARB --mkN "limbo" ; --mkWN (compoundN "esi" (k2 "kartano")) "helvetin" ;
lin limbus_N = mkWN (k9 "reuna") ; --UNCHK
lin lime_1_N = mkWN (k5A "limetti") ; --UNCHK
lin lime_2_N = mkWN (k5A "limetti") ; --UNCHK
lin lime_V2 = mkWV2 (k69 "kalkita") ; --UNCHK
lin lime_tree_N = mkWN (k39 "lehmus") ; --UNCHK
lin limeade_N = mkWN (compoundN "lime" (k1 "mehu")) ; --UNCHK
lin limekiln_N = mkWN (compoundN "poltto" (k5 "uuni")) ; --UNCHK
lin limelight_N = mkWN (compoundN "kalkki" (k1 "valo")) ; --UNCHK
lin limerick_N = mkWN (k5A "limerikki") ; --UNCHK
lin limerick_PN = foreignPN "Limerick" ;
lin limestone_N = mkWN (compoundN "kalkki" (k7 "kivi")) ; --UNCHK
lin limewater_N = mkWN (compoundN "kalkki" (k27 "vesi")) ; --UNCHK
lin limey_N = mkWN (k5 "engelsmanni") ; --UNCHK
lin liminka_PN = mkPN "Liminka" ;
lin limit_N = mkWN (kH1 "raja") ;
lin limit_V2 = mkV2 "rajoittaa" partitive ;
lin limit_V2V = mkV2V "rajoittaa" ;
lin limitation_N = mkWN (k39 "rajoitus") ;
lin limited_A = mkA "rajoitettu" | mkA "rajattu" ;
lin limiter_N = mkWN (k33 "leikkain") ; --UNCHK
lin limiting_A = mkWA "rajoittava" ; --UNCHK
lin limitless_A = mkWA (k34A "ääretön") ; --UNCHK
lin limnological_A = mkWA (compoundA "limnologi" (k38 "nen")) ; --UNCHK
lin limnologist_N = mkWN (k5 "limnologi") ; --UNCHK
lin limnology_N = mkWN (k12 "limnologia") ; --UNCHK
lin limoges_PN = foreignPN "Limoges" ;
lin limonene_N = mkWN "limoneeni" ; --UNCHK
lin limonite_N = mkWN (compoundN "suo" (k5 "malmi")) ; --UNCHK
lin limousine_N = mkWN (k5 "limusiini") ; --UNCHK
lin limp_A = mkWA "kuihtunut" ; --UNCHK
lin limp_N = mkWN (k39 "nilkutus") ; --UNCHK
lin limp_V = mkWV (k52A "ontua") ; --UNCHK
lin limpa_N = mkWN (k1A "limppu") ; --UNCHK
lin limpet_N = mkWN (compoundN "malja" (k2 "kotilo")) ; --UNCHK
lin limpid_A = mkWA (k10 "selvä") ; --UNCHK
lin limpidity_N = mkWN (k40 "kirkkaus") ; --UNCHK
lin limpkin_N = mkWN "Aramus" "pictus" ; --UNCHK
lin limpness_N = mkWN (k40 "vetelyys") ; --UNCHK
lin linage_N = mkWN "lineage" ; --UNCHK
lin linalool_N = mkWN "linaloli" ; --UNCHK
lin linchpin_N = mkWN (compoundN "sokka" (k9 "naula")) ; --UNCHK
lin lincoln_PN = foreignPN "Lincoln" ;
lin lincolnshire_PN = foreignPN "Lincolnshire" ;
lin lincomycin_N = mkWN "Lincocin" ; --UNCHK
lin linda_PN = foreignPN "Linda" ;
lin linden_N = mkWN (k39 "lehmus") ; --UNCHK
lin linden_tree_N = mkWN (k39 "lehmus") ; --UNCHK
lin lindy_N = mkWN "lindy" "hop" ; --UNCHK
lin line_N = mkN "linja" ;
lin line_V = mkWV (k53 "päällystää") ; --UNCHK
lin line_V2 = mkWV2 (k53 "päällystää") ; --UNCHK
lin line_up_V = mkWV (k53 "suoristaa") ; --UNCHK
lin line_up_V2 = mkWV2 (k53 "suoristaa") ; --UNCHK
lin lineage_N = mkWN (k40 "sukulaisuus") ; --UNCHK
lin lineal_A = mkWA (k99 "suoraan") ; --UNCHK
lin lineament_N = mkWN (k48A "piirre") ; --UNCHK
lin linear_A = mkA "lineaarinen" ;
lin lineation_N = mkWN (k39 "viivoitus") ; --UNCHK
lin linebacker_N = mkWN (compoundN "tuki" (k42 "mies")) ; --UNCHK
lin linecut_N = mkWN (compoundN "viiva" (k9A "laatta")) ; --UNCHK
lin linelike_A = mkWA (compoundA "viiva" (k38 "mainen")) ; --UNCHK
lin lineman_N = mkWN (compoundN "viiva" (k42 "mies")) ; --UNCHK
lin linen_N = mkWN (k9 "liina") ; --UNCHK
lin linen_draper_N = mkWN (compoundN "kangas" (k41 "kauppias")) ; --UNCHK
lin liner_N = mkWN (k5A "lyönti") ; --UNCHK
lin liner_train_N = mkWN (compoundN "tavara" (k10 "juna")) ; --UNCHK
lin linesman_N = mkWN (compoundN "sähkö" (k42 "mies")) ; --UNCHK
lin line_up_N = mkWN (compoundN "kokoon" (k1 "pano")) ;
lin ling_N = mkWN (kH1 "matikka") ; --UNCHK
lin lingam_N = mkWN "linga" ; --UNCHK
lin lingcod_N = mkWN "Ophiodon" "elongatus" ; --UNCHK
lin linger_V = mkWV (k67 "viivytellä") ;
lin lingerer_N = mkWN (k12 "vitkastelija") ; --UNCHK
lin lingerie_N = mkN "alusvaate" ; --plurale tantum
lin lingeringly_Adv = mkWAdv (compoundAdv "pitkittyn" (k5 "eesti")) ; --UNCHK
lin lingo_N = mkWN (k48A "murre") ; --UNCHK
lin lingonberry_N = mkWN (k14A "puolukka") ; --UNCHK
lin lingua_franca_N = mkWN (compoundN "yhteis" (k26 "kieli")) ; --UNCHK
lin lingual_A = mkWA (compoundA "lingva" (k38 "alinen")) ; --UNCHK
lin lingual_N = mkWN (k5A "konsonantti") "lingvaalinen" ; --UNCHK
lin linguica_N = mkWN (k12 "makkara") "maustettu" ; --UNCHK
lin linguine_N = mkWN (compoundN "linguine-" (k9 "pasta")) ; --UNCHK
lin linguist_N = mkWN (k38 "ihminen") "monikielinen" ; --UNCHK
lin linguistic_A = mkWA (k38 "kielellinen") ; --UNCHK
lin linguistics_N = mkWN (k9A "lingvistiikka") ; --UNCHK
lin lingulate_A = mkWA (k38 "muotoinen") "kielen" ; --UNCHK
lin liniment_N = mkWN (k5A "linimentti") ; --UNCHK
lin linin_N = mkWN "linin" ; --UNCHK
lin lining_N = mkWN (k2 "ompelu") "vuoren" ; --UNCHK
lin link_N = mkWN (k48 "kahle") ; --UNCHK
lin link_V = mkV "yhdistää" ;
lin link_V2 = mkV2 "yhdistää" ;
lin link_up_V2 = mkWV2 (k62 "assosioida") ; --UNCHK
lin link_up_with_V2 = prepV2 (advV OP_link_V OP_up_Adv ) OP_with_Prep ; -- guess-p-verb
lin linkage_N = mkWN (k40 "yhteys") ; --UNCHK
lin linkboy_N = mkWN (k12 "palvelija") ; --UNCHK
lin linkman_N = mkWN (k12 "palvelija") ; --UNCHK
lin links_N = mkWN (compoundN "golf" (k9A "rata")) ; --UNCHK
lin linlithgow_PN = foreignPN "Linlithgow" ;
lin linnet_N = mkWN (k1A "hemppo") ; --UNCHK
lin lino_N = mkWN (k6 "linoli") ; --UNCHK
lin linocut_N = mkWN (compoundN "linoleumi" (k39 "leikkaus")) ; --UNCHK
lin linoleum_N = mkWN (k6 "linoli") ; --UNCHK
lin linotype_N = mkWN "Linotype" ; --UNCHK
lin linseed_N = mkWN (compoundN "pellavan" (k32 "siemen")) ; --UNCHK
lin linstock_N = mkWN (compoundN "sytytys" (k5A "keppi")) ; --UNCHK
lin lint_N = mkWN (k6 "pumpuli") ; --UNCHK
lin lintel_N = mkWN (k12 "kamana") ; --UNCHK
lin linuron_N = mkWN (compoundN "kasvi" (k1A "myrkky")) ; --UNCHK
lin linwood_PN = foreignPN "Linwood" ;
lin linz_PN = foreignPN "Linz" ;
lin lion_N = mkN "leijona" ; --mkWN (k41A "kuningas") "eläinten" ;
lin lioness_N = mkWN (compoundN "naaras" (k10 "leijona")) ; --UNCHK
lin lionet_N = mkWN (k10 "leijona") "nuori" ; --UNCHK
lin lionfish_N = mkWN (compoundN "leijona" (k9 "kala")) ; --UNCHK
lin lion_hearted_A = mkWA (k38 "urhoollinen") ; --UNCHK
lin lionize_V2 = mkWV2 (k53 "ylistää") ; --UNCHK
lin lip_N = mkN "huuli" "huulia" ; --mkWN (k9 "reuna") ;
lin liparis_N = mkWN "suku" "Liparis" ; --UNCHK
lin lipase_N = mkWN (compoundN "lip" (k5 "aasi")) ; --UNCHK
lin lipectomy_N = mkWN (compoundN "poisto" (k39 "leikkaus")) "rasvakudoksen" ; --UNCHK
lin lipemia_N = mkWN "hyperlipidemia" ; --UNCHK
lin liperi_PN = mkPN "Liperi" ;
lin lipid_N = mkWN (k5 "lipidi") ; --UNCHK
lin lipidosis_N = mkWN "lipidoosi" ; --UNCHK
lin lipless_A = mkWA "huuleton" ; --UNCHK
lin lipogram_N = mkWN "lipogrammi" ; --UNCHK
lin lipoma_N = mkWN (k5A "rasvapatti") ; --UNCHK
lin lipomatosis_N = mkWN "lipomatoosi" ; --UNCHK
lin lipophilic_A = mkWA (compoundA "lipo" (k38 "trooppinen")) ; --UNCHK
lin lipoprotein_N = mkWN (compoundN "lipo" (k5 "proteiini")) ; --UNCHK
lin liposarcoma_N = mkWN (compoundN "lipo" (k10 "sarkooma")) ; --UNCHK
lin liposome_N = mkWN "liposomi" ; --UNCHK
lin liposuction_N = mkWN (compoundN "rasva" (k1 "imu")) ; --UNCHK
lin lipped_A = mkWA (k38 "-huulinen") ; --UNCHK
lin lip_reading_N = mkWN (compoundN "huulilta" (k38 "lukeminen")) ; --UNCHK
lin lipstick_N = mkWN (compoundN "huuli" (k10 "puna")) ; --UNCHK
lin liquefaction_N = mkWN (k39 "nesteytys") ; --UNCHK
lin liquefiable_A = mkWA (compoundA "liuke" (k9 "neva")) ; --UNCHK
lin liquefy_V = mkWV (k53A "sulattaa") ; --UNCHK
lin liquefy_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin liquescent_A = mkWA (k10 "sulava") ; --UNCHK
lin liqueur_N = mkWN (k6 "likööri") ; --UNCHK
lin liquid_A = mkA "nestemäinen" ;
lin liquid_N = mkN "likvidi" ; ---ARB --mkN "neste" ; --mkWN (k39 "petos") ;
lin liquidambar_N = mkWN "Liquidambar" ; --UNCHK
lin liquidate_V = mkWV (k62 "likvidoida") ;
lin liquidate_V2 = mkWV2 (k62 "likvidoida") ; --UNCHK
lin liquidation_N = mkWN (k5A "likvidointi") ;
lin liquidator_N = mkWN (compoundN "pesän" (k10 "hoitaja")) ; --UNCHK
lin liquidity_N = mkWN (compoundN "maksu" (k40 "valmius")) ;
lin liquidize_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin liquidizer_N = mkWN (compoundN "teho" (k33A "sekoitin")) ; --UNCHK
lin liquor_N = mkWN (compoundN "väki" (k10 "juoma")) ; --UNCHK
lin liquorice_N = mkWN (k1 "laku") | mkN "lakritsi" ; --UNCHK
lin lira_N = mkWN (k9 "liira") "Italian" ; --UNCHK
lin lisa_PN = foreignPN "Lisa" ;
lin lisbon_PN = foreignPN "Lissabon" ;
lin lisinopril_N = mkWN "Zestril" ; --UNCHK
lin liskeard_PN = foreignPN "Liskeard" ;
lin lisle_N = mkWN (compoundN "puuvilla" (k9A "lanka")) ; --UNCHK
lin lisp_N = mkWN (compoundN "ohjelmointi" (k26 "kieli")) ; --UNCHK
lin lisp_V = mkWV (k73 "lespata") ; --UNCHK
lin lisp_V2 = mkWV2 (k73 "lespata") ; --UNCHK
lin lisper_N = mkWN "sammaltaja" ; --UNCHK
lin lispingly_Adv = mkWAdv "sammaltaen" ; --UNCHK
lin lissom_A = mkWA (k10 "taipuisa") ; --UNCHK
lin lissome_A = mkWA (k10 "taipuisa") ; --UNCHK
lin lissomeness_N = mkWN (k40 "taipuisuus") ; --UNCHK
lin list_N = mkN "lista" ;
lin list_V = mkWV (k67A "luetella") ; --UNCHK
lin list_V2 = mkWV2 (k67A "luetella") ;
lin list_V2V = mkWV2V (k67A "luetella") ; --UNCHK
lin list_of_N2 = mkN2 (mkN "lista") (mkPrep elative) ;
lin list_price_N = mkWN "ohjevähittäishinta" ; --UNCHK
lin listen_V = mkWV (k67A "kuunnella") ;
lin listen_V2 = L.listen_V2 ;
lin listen_in_V = mkWV (k67A "kuunnella") "salaa" ; --UNCHK
lin listen_out_for_V2 = prepV2 (advV OP_listen_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin listen_up_V = advV OP_listen_V OP_up_Adv ; -- guess-p-verb
lin listenerFem_N = mkWN (k12 "kuuntelija") ; --UNCHK
lin listenerMasc_N = variants {} ; --
lin listening_N = mkWN (k2 "kuuntelu") ; --UNCHK
lin lister_N = mkWN (k9 "vakoaura") ; --UNCHK
lin listeria_N = mkWN "listeria" ; --UNCHK
lin listeriosis_N = mkWN "listeria" "meningitis" ; --UNCHK
lin listing_N = mkWN (k2 "erittely") ; --UNCHK
lin listless_A = mkWA (k34A "voimaton") ; --UNCHK
lin listlessness_N = mkWN (k39 "turtumus") ; --UNCHK
lin lit_V2 = mkV2 "valaista" ;
lin litany_N = mkWN (k12 "litania") ; --UNCHK
lin litas_N = mkWN (k5 "liti") ; --UNCHK
lin liter_N = mkWN (k9 "litra") ; --UNCHK
lin literacy_N = mkWN (compoundN "luku" (k1A "taito")) ; --UNCHK
lin literal_A = mkWA (k38 "kirjaimellinen") ; --UNCHK
lin literal_N = mkWN (k48 "virhe") "typografinen" ; --UNCHK
lin literalism_N = mkWN (compoundN "literal" (k5 "ismi")) ; --UNCHK
lin literalness_N = mkWN "kirjaimellisuus" ; --UNCHK
lin literary_A = mkWA (compoundA "kauno" (k38 "kirjallinen")) ;
lin literate_A = mkWA "asiaa" "tunteva" ; --UNCHK
lin literate_N = mkWN (compoundN "kirjoitus" (k38 "taitoinen")) "luku-" "ja" ; --UNCHK
lin literati_N = mkWN (k1 "lukeneisto") ; --UNCHK
lin literatim_Adv = mkWAdv "kirjain" "kirjaimelta" ; --UNCHK
lin literature_N = mkN "kirjallisuus" ;
lin lithe_A = mkWA (k10 "taipuisa") ; --UNCHK
lin lithiasis_N = mkWN (compoundN "liti" (k5 "aasi")) ; --UNCHK
lin lithic_A = mkWA "pyroklastinen" ; --UNCHK
lin lithium_N = mkWN (k5 "litium") ; --UNCHK
lin lithograph_N = mkWN (compoundN "kivi" (k1 "paino")) ; --UNCHK
lin lithograph_V = mkWV (k56 "painaa") "litografisesti" ; --UNCHK
lin lithograph_V2 = mkWV2 (k56 "painaa") "litografisesti" ; --UNCHK
lin lithographer_N = mkWN (compoundN "kivi" (k10 "painaja")) ; --UNCHK
lin lithographic_A = mkWA (k38 "litografinen") ; --UNCHK
lin lithography_N = mkWN (k12 "litografia") ; --UNCHK
lin lithomancer_N = mkWN (k10 "ennustaja") "kivistä" ; --UNCHK
lin lithomancy_N = mkWN "kivistä" "ennustaminen" ; --UNCHK
lin lithomantic_A = mkWA (compoundA "lito" (k38 "mantinen")) ; --UNCHK
lin lithophyte_N = mkWN (compoundN "lithophyte-" (k5 "kasvi")) ; --UNCHK
lin lithophytic_A = mkWA "lithopythe-kasveihin" "liittyvä" ; --UNCHK
lin lithosphere_N = mkWN (k5 "litosfääri") ; --UNCHK
lin lithotomy_N = mkWN (compoundN "kivi" (k39 "leikkaus")) ; --UNCHK
lin litigant_N = mkWN (compoundN "asian" (k10 "ajaja")) ; --UNCHK
lin litigate_V = mkWV (k56 "haastaa") ; --UNCHK
lin litigate_V2 = mkWV2 (k56 "haastaa") ; --UNCHK
lin litigation_N = mkN "riita" ;
lin litigious_A = mkWA (compoundA "käräjöinti" (k38 "haluinen")) ; --UNCHK
lin litigiousness_N = mkWN "käräjöintihaluisuus" ; --UNCHK
lin litmus_N = mkWN (k39 "lakmus") ; --UNCHK
lin litmus_paper_N = mkWN (compoundN "lakmus" (k6 "paperi")) ; --UNCHK
lin litotes_N = mkWN (compoundN "lito" (k5 "teesi")) ; --UNCHK
lin litre_N = mkWN (k9 "litra") ; --UNCHK
lin litter_N = mkN "roska" ; ---ARB ; kissanhiekka ; poikue
lin litter_V = mkWV (k61A "poikia") ; --UNCHK
lin litter_V2 = mkWV2 (k61A "poikia") ; --UNCHK
lin litter_basket_N = mkWN (compoundN "roska" (k5 "kori")) ; --UNCHK
lin litter_lout_N = mkWN (k10 "roskaaja") ; --UNCHK
lin litterbin_N = mkWN (compoundN "roska" (k5 "kori")) ; --UNCHK
lin litterer_N = mkWN (k10 "roskaaja") ; --UNCHK
lin little_A = mkA "pieni" | mkA "vähäinen" ;
lin little_Det = mkDet False Sg (exceptNomN (mkN "vähä") "vähän") partitive ;
lin little_N = mkWN (k99 "vähän") ; --UNCHK
lin littlehampton_PN = foreignPN "Littlehampton" ;
lin littleneck_N = mkWN (k14A "simpukka") ; --UNCHK
lin littleness_N = mkWN (k40 "halpamaisuus") ; --UNCHK
lin littoral_A = mkWA "ranta-" ; --UNCHK
lin littoral_N = mkWN (k4A "rannikko") ; --UNCHK
lin liturgical_A = mkWA (k38 "liturginen") ; --UNCHK
lin liturgist_N = mkWN (k5 "liturgi") ; --UNCHK
lin liturgy_N = mkWN (k12 "liturgia") ; --UNCHK
lin livable_A = mkWA (compoundA "asumis" (k38 "kelpoinen")) ; --UNCHK
lin live_A = mkWA (k99 "hengissä") ; --UNCHK
lin live_Adv = mkWAdv "live-" ; --UNCHK
lin live_V = L.live_V ;
lin live_birth_N = mkWN (k10 "syntymä") ; --UNCHK
lin live_by_V2 = prepV2 OP_live_V OP_by_Prep ; -- guess-p-verb
lin live_down_V2 = mkWV2 (k61A "pyyhkiä") "pois" ; --UNCHK
lin live_for_V2 = prepV2 OP_live_V OP_for_Prep ; -- guess-p-verb
lin live_in_V = mkWV (k52 "asua") ; --UNCHK
lin live_it_up_V2 = mkWV2 (k61A "nauttia") "elämästä" ; --UNCHK
lin live_off_V2 = prepV2 OP_live_V OP_off_Prep ; -- guess-p-verb
lin live_on_V = mkWV (k67A "sinnitellä") ; --UNCHK
lin live_on_V2 = mkWV2 (k67A "sinnitellä") ; --UNCHK
lin live_out_V = advV OP_live_V OP_out_Adv ; -- guess-p-verb
lin live_out_V2 = prepV2 OP_live_V OP_out_Prep ; -- guess-p-verb
lin live_through_V2 = prepV2 OP_live_V OP_through_Prep ; -- guess-p-verb
lin live_together_V = advV OP_live_V OP_together_Adv ; -- guess-p-verb
lin live_up_V = advV OP_live_V OP_up_Adv ; -- guess-p-verb
lin live_up_to_V2 = mkWV2 (k53A "täyttää") ; --UNCHK
lin live_with_V2 = mkWV2 (k53A "sietää") ; --UNCHK
lin liveable_A = mkWA (compoundA "asumis" (k38 "kelpoinen")) ; --UNCHK
lin livedo_N = mkWN "livedo" ; --UNCHK
lin livelihood_N = mkWN (k10A "leipä") "jokapäiväinen" ; --UNCHK
lin liveliness_N = mkWN (k40 "eloisuus") ; --UNCHK
lin lively_A = mkWA (k41A "vilkas") ; --UNCHK
lin liven_V = mkWV (k53A "elähdyttää") ; --UNCHK
lin liven_V2 = mkWV2 (k53A "elähdyttää") ; --UNCHK
lin liver_N = L.liver_N ;
lin liveried_A = mkWA (compoundA "virka" (k38 "pukuinen")) ; --UNCHK
lin liverish_A = mkWA (k10 "pahoinvoiva") ; --UNCHK
lin liverpool_PN = foreignPN "Liverpool" ;
lin liverpudlian_A = mkWA (compoundA "liverpooli" (k38 "lainen")) ; --UNCHK
lin liverpudlian_N = mkWN (compoundN "liverpooli" (k38 "lainen")) ; --UNCHK
lin liverwort_N = mkWN (compoundN "maksa" (k1 "ruoho")) ; --UNCHK
lin liverwurst_N = mkWN (compoundN "maksa" (k12 "makkara")) ; --UNCHK
lin livery_A = mkWA (k10 "pahoinvoiva") ; --UNCHK
lin livery_N = mkWN (compoundN "vuokra" (k5 "talli")) ; --UNCHK
lin liveryman_N = mkWN (compoundN "työn" (k12 "tekijä")) "vuokratallin" ; --UNCHK
lin livestock_N = mkWN (k9 "karja") ; --UNCHK
lin livid_A = mkWA (compoundA "raivo" (k47 "stunut")) ; --UNCHK
lin lividity_N = mkWN (k40 "hailakkuus") ; --UNCHK
lin lividness_N = mkWN (k40 "hailakkuus") ; --UNCHK
lin living_A = mkWA (k10 "elävä") ; --UNCHK
lin living_N = mkWN (k1 "elo") ; --UNCHK
lin living_room_N = mkWN (k5 "sali") ; --UNCHK
lin living_space_N = mkWN (compoundN "elin" (k9 "tila")) ; --UNCHK
lin livingston_PN = foreignPN "Livingston" ;
lin livorno_PN = foreignPN "Livorno" ;
lin liza_N = mkWN "Mugil" "liza" ; --UNCHK
lin lizard_N = mkWN (kH1 "lisko") ; --UNCHK
lin lizardfish_N = mkWN (compoundN "käärme" (k9 "kala")) ; --UNCHK
lin ljubljana_PN = foreignPN "Ljubljana" ;
lin llama_N = mkWN (kH1 "laama") ; --UNCHK
lin llandudno_PN = foreignPN "Llandudno" ;
lin llanelli_PN = foreignPN "Llanelli" ;
lin llangollen_PN = foreignPN "Llangollen" ;
lin llano_N = mkWN (k1A "tasanko") ; --UNCHK
lin llantrisant_PN = foreignPN "Llantrisant" ;
lin llb_N = mkWN (k5A "kandidaatti") "oikeustieteiden" ; --UNCHK
lin loach_N = mkWN (k38 "kivennuoliainen") ; --UNCHK
lin load_N = mkWN (k39 "lähetys") ; --UNCHK
lin load_V = mkWV (k53A "vesittää") ; --UNCHK
lin load_V2 = mkV2 "lastata" ; --mkWV2 (k53A "vesittää") ;
lin load_line_N = mkWN (k5A "merkki") "Plimsollin" ; --UNCHK
lin load_up_V = mkWV (k73 "lastata") ; --UNCHK
lin load_up_V2 = mkWV2 (k73 "lastata") ; --UNCHK
lin loader_N = mkWN "lataaja" ; --UNCHK
lin loading_N = mkWN (compoundN "lasta" (k38 "aminen")) ; --UNCHK
lin loadstar_N = mkWN (compoundN "johto" (k7A "tähti")) ; --UNCHK
lin loadstone_N = mkWN (compoundN "magneetti" (k9A "rauta")) ; --UNCHK
lin loaf_N = mkWN (k10A "toppa") ; --UNCHK
lin loaf_V = mkWV (k52A "roikkua") ; --UNCHK
lin loaf_V2 = mkWV2 (k52A "roikkua") ; --UNCHK
lin loaf_sugar_N = mkWN (compoundN "toppa" (k6 "sokeri")) ; --UNCHK
lin loafer_N = mkN "mokkasiini" ; ---ARB ; maleksija, vetelehtijä
lin loam_N = mkWN (k1 "hiesu") ; --UNCHK
lin loamless_A = mkWA "hiesuton" ; --UNCHK
lin loamy_A = mkWA (compoundA "hiesu" (k38 "mainen")) ; --UNCHK
lin loan_N = mkN "laina" ;
lin loan_V2 = mkWV2 (k56A "antaa") "lainaksi" ; --UNCHK
lin loan_collection_N = mkWN (compoundN "laina" (k10 "kokoelma")) ; --UNCHK
lin loan_office_N = mkWN (compoundN "laina" (k2 "toimisto")) ; --UNCHK
lin loanblend_N = mkWN (k5 "hybridi") ; --UNCHK
lin loaner_N = mkWN (compoundN "sijais" (k1 "auto")) ; --UNCHK
lin loanhead_PN = foreignPN "Loanhead" ;
lin loanword_N = mkWN (k9 "laina") ; --UNCHK
lin loasa_N = mkWN "loasa" ; --UNCHK
lin loath_A = mkWA (k34A "haluton") ; --UNCHK
lin loathe_V2 = mkWV2 (k73 "vihata") ; --UNCHK
lin loathing_N = mkWN (k39 "iljetys") ; --UNCHK
lin loathly_A = mkWA (k15 "törkeä") ; --UNCHK
lin loathsome_A = mkWA (k15 "törkeä") ; --UNCHK
lin loathsomeness_N = mkWN (k40 "häijyys") ; --UNCHK
lin lob_N = mkWN (compoundN "koho" (k5A "lyönti")) ; --UNCHK
lin lob_V = mkWV (k64 "lyödä") "koholyönti" ; --UNCHK
lin lob_V2 = mkWV2 (k64 "lyödä") "koholyönti" ; --UNCHK
lin lobar_A = mkWA "lohkoon" "liittyvä" ; --UNCHK
lin lobate_A = mkWA "lohkoon" "liittyvä" ; --UNCHK
lin lobby_N = mkN "aula" ;
lin lobby_V = mkWV (k73 "lobata") ; --UNCHK
lin lobby_V2 = mkWV2 (k73 "lobata") ; --UNCHK
lin lobby_V2V = mkWV2V (k73 "lobata") ; --UNCHK
lin lobbyism_N = mkWN (k39 "lobbaus") ; --UNCHK
lin lobbyist_N = mkWN (k10 "lobbaaja") ; --UNCHK
lin lobe_N = mkWN (k1 "lohko") ; --UNCHK
lin lobectomy_N = mkWN (k1 "poisto") "lohkon" ; --UNCHK
lin lobed_A = mkWA (k38 "liuskainen") ; --UNCHK
lin lobelia_N = mkWN (k12 "lobelia") ; --UNCHK
lin lobeliaceous_A = mkWA "lobeliaceous" ; --UNCHK
lin loblolly_N = mkWN (k5 "velli") ; --UNCHK
lin lobotomy_N = mkWN (compoundN "otsalohko" (k39 "leikkaus")) ; --UNCHK
lin lobscouse_N = mkWN "lapskoussi" ; --UNCHK
lin lobster_N = mkWN (k6 "hummeri") ; --UNCHK
lin lobster_pot_N = mkWN (compoundN "hummeri" (k9A "merta")) ; --UNCHK
lin lobsterman_N = mkWN (compoundN "hummerin" (k10 "pyytäjä")) ; --UNCHK
lin lobular_A = mkWA (k38 "liuskainen") ; --UNCHK
lin lobularity_N = mkWN "liuskaisuus" ; --UNCHK
lin lobule_N = mkWN (k9 "liuska") ; --UNCHK
lin local_A = mkA "paikallinen" ;
lin local_N = mkWN (compoundN "paikallis" (k10 "juna")) ; --UNCHK
lin locale_N = mkWN (k9A "paikka") ; --UNCHK
lin localism_N = mkWN (k5 "provinsialismi") ; --UNCHK
lin locality_N = mkWN (k40 "läheisyys") ; --UNCHK
lin localization_N = mkWN (k9A "paikka") ; --UNCHK
lin localize_V2 = mkWV2 (k67 "olla") ; --UNCHK
lin locate_V = mkWV (k52A "sijoittua") ;
lin locate_V2 = mkV2 "sijoittaa" ; --WV2 (k52A "sijoittua") ;
lin location_N = mkN "sijainti" ; --f54
lin locator_N = mkWN (compoundN "maan" (k6 "mittari")) ; --UNCHK
lin loch_N = mkWN (k7 "järvi") ; --UNCHK
lin lochgelly_PN = foreignPN "Lochgelly" ;
lin lochia_N = mkWN (compoundN "jälki" (k1A "vuoto")) "synnytyksen" ; --UNCHK
lin lock_N = mkN "lukko" ;
lin lock_V = mkWV (k73A "pilkata") "Jumalaa" ; --UNCHK
lin lock_V2 = mkV2 "lukita" ; --mkWV2 (k73A "pilkata") "Jumalaa" ;
lin lock_away_V2 = mkWV2 (k69 "lukita") "sisään" ; --UNCHK
lin lock_down_V2 = prepV2 OP_lock_V OP_down_Prep ; -- guess-p-verb
lin lock_in_V2 = mkWV2 (k69 "lukita") "sisään" ; --UNCHK
lin lock_onto_V2 = prepV2 OP_lock_V OP_onto_Prep ; -- guess-p-verb
lin lock_out_V2 = prepV2 OP_lock_V OP_out_Prep ; -- guess-p-verb
lin lock_up_V2 = mkWV2 (k69 "lukita") "sisään" ; --UNCHK
lin lock_yourself_away_V = variants {} ; -- guess-p-verb
lin lockage_N = mkWN (k1A "sulku") ; --UNCHK
lin lockdown_N = mkWN (compoundN "täys" (k39 "lukitus")) ; --UNCHK
lin locker_N = mkWN (k2 "lokero") ; --UNCHK
lin locket_N = mkWN (k5A "medaljonki") ; --UNCHK
lin locking_N = mkWN (k39 "suojaus") ; --UNCHK
lin lockjaw_N = mkWN (k39 "tetanus") ; --UNCHK
lin lockmaster_N = mkWN (compoundN "sulku" (k5A "vahti")) ; --UNCHK
lin locknut_N = mkWN (compoundN "vasta" (k6 "mutteri")) ; --UNCHK
lin lockout_N = mkWN (compoundN "työn" (k1A "sulku")) ; --UNCHK
lin lockring_N = mkWN (compoundN "lukko" (k1 "levy")) ; --UNCHK
lin locksmith_N = mkWN (compoundN "lukko" (k10A "seppä")) ; --UNCHK
lin lockstep_N = mkWN (compoundN "sulkeis" (k39 "järjestys")) ; --UNCHK
lin lockstitch_N = mkWN (compoundN "lukko" (k5A "tikki")) ; --UNCHK
lin lockup_N = mkWN (k39 "suojaus") ; --UNCHK
lin loco_A = mkWA (k1 "pöllö") ; --UNCHK
lin locomotion_N = mkWN (compoundN "liik" (k38 "kuminen")) ; --UNCHK
lin locomotive_N = mkWN (k6 "veturi") ; --UNCHK
lin locoweed_N = mkWN (k7 "pilvi") ; --UNCHK
lin locule_N = mkWN (k2 "lokero") ; --UNCHK
lin locum_N = mkWN (k38 "sijainen") ; --UNCHK
lin locum_tenens_N = mkWN (k38 "sijainen") ; --UNCHK
lin locus_N = mkWN (k9A "paikka") "geometrinen" ; --UNCHK
lin locus_classicus_N = mkWN "locus" "classicus" ; --UNCHK
lin locust_N = mkWN (k9A "kulkusirkka") ; --UNCHK
lin locust_tree_N = mkWN (compoundN "valeaka" (k12 "asia")) ; --UNCHK
lin locution_N = mkWN (k2 "ilmaisu") ; --UNCHK
lin lode_N = mkWN (compoundN "malmi" (k26 "juoni")) ; --UNCHK
lin lodestar_N = mkWN (compoundN "johto" (k7A "tähti")) ; --UNCHK
lin lodestone_N = mkWN (compoundN "magneetti" (k9A "rauta")) ; --UNCHK
lin lodge_N = mkWN (k6 "kievari") ; --UNCHK
lin lodge_V = mkWV (k53 "nostaa") "kanne" ; --UNCHK
lin lodge_V2 = mkWV2 (k53 "nostaa") "kanne" ; --UNCHK
lin lodgement_N = mkWN (k39 "kiinnitys") ; --UNCHK
lin lodger_N = mkWN (k38 "vuokralainen") ; --UNCHK
lin lodging_N = mkWN (compoundN "asu" (k38 "minen")) ; --UNCHK
lin lodging_house_N = mkWN (k12 "asuntola") ; --UNCHK
lin lodgment_N = mkWN (k39 "kiinnitys") ; --UNCHK
lin loess_N = mkWN (kH1 "lössi") ; --UNCHK
lin loft_N = mkWN (k7 "parvi") ; --UNCHK
lin loft_V2 = mkWV2 (k61A "laatia") ; --UNCHK
lin loftiness_N = mkWN (k40 "ylevyys") ; --UNCHK
lin loftus_PN = foreignPN "Loftus" ;
lin lofty_A = mkWA (k15 "huikea") ; --UNCHK
lin log_N = mkWN (k5 "loki") ; --UNCHK
lin log_V2 = mkWV2 (k73 "kirjata") ;
lin log_cabin_N = mkWN (compoundN "hirsi" (k39 "rakennus")) ; --UNCHK
lin log_in_V = mkWV "sisäänkirjautua" ; --UNCHK
lin log_off_V2 = mkWV2 "uloskirjautua" ; --UNCHK
lin log_on_V2 = mkWV2 "sisäänkirjautua" ; --UNCHK
lin log_out_V = mkWV "uloskirjautua" ; --UNCHK
lin loganberry_N = mkWN (compoundN "logan" (k9 "marja")) ; --UNCHK
lin logarithm_N = mkWN (k5 "logaritmi") ; --UNCHK
lin logarithmic_A = mkWA (k38 "logaritminen") ; --UNCHK
lin logbook_N = mkWN (k5 "loki") ; --UNCHK
lin loge_N = mkWN (k3 "aitio") ; --UNCHK
lin loggerhead_N = mkWN (compoundN "valekarettikilpi" (k10 "konna")) ; --UNCHK
lin loggia_N = mkWN "loggia" ; --UNCHK
lin logging_N = mkWN (compoundN "metsän" (k17 "hakkuu")) ; --UNCHK
lin logic_N = mkWN (k14A "logiikka") ; --UNCHK
lin logical_A = mkA "looginen" ; --mkWA (k38 "järjestelmällinen") ;
lin logicality_N = mkWN (k40 "loogisuus") ; --UNCHK
lin logician_N = mkWN "loogikko" ; --UNCHK
lin logicism_N = mkWN (compoundN "logis" (k5 "ismi")) ; --UNCHK
lin loginess_N = mkWN (k39 "väsymys") ; --UNCHK
lin logion_N = mkWN "logion" ; --UNCHK
lin logistic_A = mkWA "logistinen" ; --UNCHK
lin logistics_N = mkWN (kH1 "logistiikka") ; --UNCHK
lin log_jam_N = mkWN (compoundN "tukki" (k10 "suma")) ; --UNCHK
lin logo_N = mkWN (k1 "logo") ; --UNCHK
lin logogram_N = mkWN (compoundN "sana" (k5A "merkki")) ; --UNCHK
lin logogrammatic_A = mkWA (compoundA "logo" (k38 "grafinen")) ; --UNCHK
lin logomach_N = mkWN (k12 "saivartelija") ; --UNCHK
lin logomachy_N = mkWN (k2 "saivartelu") ; --UNCHK
lin logorrhea_N = mkWN (compoundN "puhe" (k6 "ripuli")) ; --UNCHK
lin log_rolling_N = mkWN (compoundN "tukin" (k39 "pyöritys")) ; --UNCHK
lin logwood_N = mkWN (compoundN "sini" (k18 "puu")) ; --UNCHK
lin lohja_PN = mkPN "Lohja" ;
lin lohtaja_PN = mkPN "Lohtaja" ;
lin loimaa_PN = mkPN "Loimaa" ;
lin loin_N = mkWN (k48A "kuve") ; --UNCHK
lin loincloth_N = mkWN (compoundN "lanne" (k48A "vaate")) ; --UNCHK
lin loins_N = mkWN (compoundN "häpy" (k48 "alue")) ; --UNCHK
lin loir_N = mkWN (compoundN "uni" (k1A "keko")) ; --UNCHK
lin loiter_V = mkWV (k52A "roikkua") ; --UNCHK
lin loiter_V2 = mkWV2 (k52A "roikkua") ; --UNCHK
lin loiterer_N = mkWN (k12 "vitkastelija") ; --UNCHK
lin loligo_N = mkWN "loligo" ; --UNCHK
lin loll_V = mkWV (k67 "loikoilla") ; --UNCHK
lin loll_V2 = mkWV2 (k67 "loikoilla") ; --UNCHK
lin lollipop_N = mkWN (k6 "tikkari") ; --UNCHK
lin lolly_N = mkWN (k1A "puikko") ; --UNCHK
lin lomatia_N = mkWN "lomatia" ; --UNCHK
lin loment_N = mkWN (k1A "palko") "nivelikäs" ; --UNCHK
lin lomustine_N = mkWN "lomustiini" ; --UNCHK
lin london_PN = mkPN "Lontoo" ;
lin londonderry_PN = foreignPN "Londonderry" ;
lin londoner_N = mkWN (compoundN "lontoo" (k38 "lainen")) ; --UNCHK
lin lone_A = mkWA (k99 "ainut") ; --UNCHK
lin loneliness_N = mkWN (k40 "yksinäisyys") ; --UNCHK
lin lonely_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin loner_N = mkWN (k27 "susi") "yksinäinen" ; --UNCHK
lin lonesome_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin long_A = L.long_A ;
lin long_N = mkN "pitkä" ; ----TODO "one taking a long position especially in a security or commodity market"
lin long_V = mkWV (k68 "ikävöidä") ; --UNCHK
lin long_distance_A = mkA "pitkämatkalainen" ;
lin long_range_A = mkA "pitkävaikutteinen" ;
lin long_suffering_A = mkA (mkN "pitkä" (mkN "mielinen")) ;
lin long_term_A = mkA "pitkäaikainen" ;
lin long_time_A = mkA "pitkäaikainen" ;
lin longanberry_N = mkWN (compoundN "longaani" (k10 "hedelmä")) ; --UNCHK
lin longboat_N = mkWN (compoundN "pitkä" (k48 "vene")) ; --UNCHK
lin longbow_N = mkWN (compoundN "käsi" (k26 "jousi")) ; --UNCHK
lin longbowman_N = mkWN "pitkäjousimies" ; --UNCHK
lin longer_Adv = mkWAdv (k99 "kauemmin") ;
lin longest_Adv = mkWAdv (k99 "kauimmin") ; --UNCHK
lin longevity_N = mkN "pitkä" (mkN "ikäisyys") ; --UNCHK
lin longhand_A = mkA "kursivoitu" ; --UNCHK
lin longhand_N = mkWN (k5 "kursiivi") ; --UNCHK
lin longhorn_N = mkWN (k9A "nauta") "pitkäsarvinen" ; --UNCHK
lin longing_N = mkWN (k17 "kaipuu") ; --UNCHK
lin longingly_Adv = mkWAdv "kaivaten" ; --UNCHK
lin longish_A = mkWA "pitkähkö" ; --UNCHK
lin longitude_N = mkWN (k40 "pituus") "läntinen" ; --UNCHK
lin longitudinal_A = mkWA (compoundA "longitudina" (k38 "alinen")) ; --UNCHK
lin longness_N = mkWN (k40 "pituus") ; --UNCHK
lin longridge_PN = foreignPN "Longridge" ;
lin longshoreman_N = mkWN (k10 "lastaaja") ; --UNCHK
lin longshot_N = mkWN (compoundN "kauko" (k10 "kuva")) ; --UNCHK
lin long_standing_A = mkWA (compoundA "pitkä" (k38 "aikainen")) ; --UNCHK
lin longton_PN = foreignPN "Longton" ;
lin longueur_N = mkWN (k7 "hetki") "pitkästyttävä" ; --UNCHK
lin longways_Adv = mkWAdv (k99 "pitkittäin") ; --UNCHK
lin longways_N = mkWN (compoundN "rivi" (k5 "tanssi")) ; --UNCHK
lin longwise_Adv = mkWAdv (k99 "pitkittäin") ; --UNCHK
lin longwool_N = mkWN (k41A "lammas") ; --UNCHK
lin loo_N = mkWN (k5 "veski") ; --UNCHK
lin loofa_N = mkWN (compoundN "pesu" (k26 "sieni")) ; --UNCHK
lin loofah_N = mkWN (k1A "pesusienikurkku") ; --UNCHK
lin look_N = mkWN (k48 "katse") ;
lin look_V = mkV "katsoa" ;
lin look_V2 = mkV2 (mkV "näyttää") (mkPrep ablative) ;
lin look_VA = mkVA (mkV "näyttää") (mkPrep ablative) ;
lin look_after_V2 = mkWV2 (k53A "pitää") "huolta" ; --UNCHK
lin look_ahead_to_V2 = prepV2 (advV OP_look_V OP_ahead_Adv ) OP_to_Prep ; -- guess-p-verb
lin look_around_V = advV OP_look_V OP_around_Adv ; -- guess-p-verb
lin look_around_at_V2 = prepV2 (advV OP_look_V OP_around_Adv ) OP_at_Prep ; -- guess-p-verb
lin look_at_V2 = prepV2 OP_look_V OP_at_Prep ; -- guess-p-verb
lin look_back_V = mkWV (k67 "muistella") ; --UNCHK
lin look_back_on_V2 = prepV2 (advV OP_look_V OP_back_Adv ) OP_on_Prep ; -- guess-p-verb
lin look_down_V = advV OP_look_V OP_down_Adv ; -- guess-p-verb
lin look_down_on_V2 = mkWV2 (k61 "halveksia") ; --UNCHK
lin look_for_V2 = mkV2 "etsiä" partitive ;
lin look_forward_V = advV OP_look_V OP_forward_Adv ; -- guess-p-verb
lin look_forward_to_V2 = prepV2 (advV OP_look_V OP_forward_Adv ) OP_to_Prep ; -- guess-p-verb
lin look_in_V2 = prepV2 OP_look_V OP_in_Prep ; -- guess-p-verb
lin look_in_on_V2 = prepV2 (advV OP_look_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin look_into_V2 = mkWV2 (k73A "tsekata") ; --UNCHK
lin look_on_V = mkWV (k52 "katsoa") ; --UNCHK
lin look_on_as_V3 = variants {} ; -- guess-p-verb
lin look_out_V = mkWV (k67 "suojella") ; --UNCHK
lin look_out_for_V2 = prepV2 (advV OP_look_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin look_over_V2 = prepV2 OP_look_V OP_over_Prep ; -- guess-p-verb
lin look_round_V2 = prepV2 OP_look_V OP_round_Prep ; -- guess-p-verb
lin look_through_V2 = prepV2 OP_look_V OP_through_Prep ; -- guess-p-verb
lin look_to_V2 = mkWV2 (k52 "katsoa") ; --UNCHK
lin look_toward_V2 = prepV2 OP_look_V OP_toward_Prep ; -- guess-p-verb
lin look_up_V = mkWV (k61 "etsiä") "jstak" ; --UNCHK
lin look_up_V2 = mkWV2 (k61 "etsiä") "jstak" ; --UNCHK
lin look_up_to_V2 = mkWV2 (k53A "kunnioittaa") ; --UNCHK
lin look_upon_as_V3 = variants {} ; -- guess-p-verb
lin lookdown_N = mkWN (k5 "makrilli") ; --UNCHK
lin looker_N = mkWN (k38 "kaunokainen") ; --UNCHK
lin looking_N = mkWN (k48 "katse") ; --UNCHK
lin looking_glass_N = mkWN (k5 "peili") ; --UNCHK
lin lookout_N = mkWN "ulos" "katsominen" ; --UNCHK
lin loom_N = mkN "kangastus" ;
lin loom_V = mkWV (k52A "kutoa") ; --UNCHK
lin loon_N = mkWN (k10A "kuikka") ; --UNCHK
lin loony_A = mkWA (k1 "pöllö") ; --UNCHK
lin loony_N = mkWN (k6 "kaheli") ; --UNCHK
lin loop_1_N = mkWN (k14A "silmukka") ; --UNCHK
lin loop_2_N = mkWN (k14A "silmukka") ; --UNCHK
lin loop_V = mkWV (k52A "kietoa") ; --UNCHK
lin loop_V2 = mkWV2 (k52A "kietoa") ; --UNCHK
lin loophole_N = mkN "porsaan" (mkN "reikä") ; --mkWN (compoundN "ampuma-" (k1A "aukko")) ;
lin loopy_A = mkWA (compoundA "silmu" (k38 "kkainen")) ; --UNCHK
lin loose_A = mkWA (k99 "irti") ; --UNCHK
lin loose_Adv = mkWAdv (k99 "vapaasti") ; --UNCHK
lin loose_V2 = mkWV2 (k72 "hölletä") ; --UNCHK
lin loose_leaf_A = mkWA (compoundA "irto" (k38 "lehtinen")) ; --UNCHK
lin loosen_V = mkWV (k72 "hölletä") ; --UNCHK
lin loosen_V2 = mkWV2 (k72 "hölletä") ; --UNCHK
lin loosen_up_V = mkWV (k71 "tehdä") "rentoutuneeksi" ; --UNCHK
lin looseness_N = mkWN (k40 "rivous") ; --UNCHK
lin loosening_N = mkWN (compoundN "löysä" (k38 "äminen")) ; --UNCHK
lin loosestrife_N = mkWN (k7A "alpi") ; --UNCHK
lin loot_N = mkWN (k41 "saalis") ; --UNCHK
lin loot_V = mkWV (k53 "anastaa") ; --UNCHK
lin loot_V2 = mkWV2 (k53 "anastaa") ; --UNCHK
lin looter_N = mkWN (k10 "ryöstäjä") ; --UNCHK
lin looting_N = mkWN (k1 "ryöstö") ; --UNCHK
lin lop_V = mkWV (k61 "oksia") ; --UNCHK
lin lop_V2 = mkWV2 (k61 "oksia") ; --UNCHK
lin lope_N = mkWN (kH1 "laukka") ; --UNCHK
lin lope_V = mkWV (k52A "harppoa") ; --UNCHK
lin loppi_PN = mkPN (mkN "Loppi" "Loppia") ;
lin lopsided_A = mkWA (k10 "oleva") "kiemurassa" ; --UNCHK
lin lopsidedness_N = mkWN (k40 "viistous") ; --UNCHK
lin loquacious_A = mkWA (k41 "puhelias") ; --UNCHK
lin loquaciousness_N = mkWN (k40 "suulaus") ; --UNCHK
lin loquacity_N = mkWN (k40 "suulaus") ; --UNCHK
lin loquat_N = mkWN (k5A "lokvatti") ; --UNCHK
lin lorazepam_N = mkWN "Ativan" ; --UNCHK
lin lorchel_N = mkWN (k1 "mörsky") ; --UNCHK
lin lord_N = mkWN (compoundN "Kaikki" (k41 "valtias")) ; --UNCHK
lin lord_V2 = mkWV2 (k62 "aateloida") ; --UNCHK
lin lord_it_over_V2 = mkWV2 (k67 "olla") "päällepäsmärinä" ; --UNCHK
lin lordless_A = mkWA (k34A "isännätön") ; --UNCHK
lin lordliness_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin lordly_A = mkWA (k38 "aristokraattinen") ; --UNCHK
lin lordolatry_N = mkWN (k9A "palvonta") ; --UNCHK
lin lordosis_N = mkWN (k5 "lordoosi") ; --UNCHK
lin lordship_N = mkWN (k40 "herruus") ; --UNCHK
lin lore_N = mkWN (compoundN "perimä" (k1A "tieto")) ; --UNCHK
lin lorgnette_N = mkWN "lornetti" ; --UNCHK
lin lorica_N = mkWN "lorica" ; --UNCHK
lin lorikeet_N = mkWN "luri" ; --UNCHK
lin lorry_N = mkWN (compoundN "kuorma-" (k1 "auto")) ; --UNCHK
lin lory_N = mkWN "luri" ; --UNCHK
lin los_angeles_PN = foreignPN "Los Angeles" ;
lin lose_V = mkV "hävitä" ;
lin lose_V2 = L.lose_V2 ;
lin lose_out_V = mkV (mkV "jäädä") "häviölle" ;
lin lose_out_on_V2 = prepV2 (advV OP_lose_V OP_out_Adv ) OP_on_Prep ; -- guess-p-verb
lin lose_out_to_V2 = prepV2 (advV OP_lose_V OP_out_Adv ) OP_to_Prep ; -- guess-p-verb
lin lose_up_V = advV OP_lose_V OP_up_Adv ; -- guess-p-verb
lin loser_N = mkWN (k10 "häviäjä") ; --UNCHK
lin loss_N = mkN "menetys" ;
lin loss_leader_N = mkWN (compoundN "tarjous" (k12 "tavara")) ; --UNCHK
lin lossiemouth_PN = foreignPN "Lossiemouth" ;
lin lossless_A = mkWA "häviötön" ; --UNCHK
lin lossy_A = mkWA (compoundA "häviö" (k38 "llinen")) ; --UNCHK
lin lost_A = variants {} ; --
lin lot_1_N = mkN "paljous" | mkWN (k9A "arpa") ; ---- split
lin lot_2_N = mkN "paljous" | mkWN (k9A "arpa") ; ---- split
lin lot_3_N = mkN "paljous" | mkWN (k9A "arpa") ; ---- split
lin lota_N = mkWN (k48A "made") ; --UNCHK
lin loth_A = mkWA (k34A "haluton") ; --UNCHK
lin loti_N = mkWN "loti" ; --UNCHK
lin lotic_A = mkWA "loottinen" ; --UNCHK
lin lotion_N = mkWN (k48A "voide") ; --UNCHK
lin lottery_N = mkWN (k9A "arvonta") ;
lin lotto_N = mkWN (k1 "bingo") ; --UNCHK
lin lotus_N = mkWN (k39 "lootus") "egyptiläinen" "valkoinen" ; --UNCHK
lin lotusland_N = mkWN "lotus" "land" ; --UNCHK
lin louche_A = mkWA (compoundA "valon" (k9A "arka")) ; --UNCHK
lin loud_A = mkWA (k10 "kova") ;
lin loud_Adv = mkWAdv (k99 "kovaa") ; --UNCHK
lin loud_hailer_N = mkWN (k5 "megafoni") ; --UNCHK
lin loudmouth_N = mkWN (k12 "mahtailija") ; --UNCHK
lin loudness_N = mkWN (k40 "mauttomuus") ; --UNCHK
lin loudspeaker_N = mkWN (k33A "kaiutin") ; --UNCHK
lin lough_N = mkWN (k7 "järvi") ; --UNCHK
lin loughborough_PN = foreignPN "Loughborough" ;
lin louisiana_PN = foreignPN "Louisiana" ;
lin louisville_PN = foreignPN "Louisville" ;
lin lounge_N = mkWN (k9 "aula") ;
lin lounge_V = mkWV (k74 "löhötä") ; --UNCHK
lin lounge_chair_N = mkWN (compoundN "laiskan" (k9 "linna")) ; --UNCHK
lin lounge_lizard_N = mkWN (k2 "gigolo") ; --UNCHK
lin lounge_suit_N = mkWN (compoundN "koko" (k1A "puku")) ; --UNCHK
lin lounger_N = mkWN (compoundN "arki" (k48A "vaate")) ; --UNCHK
lin loungewear_N = mkWN (compoundN "arki" (k48A "vaate")) ; --UNCHK
lin loupe_N = mkWN (k5A "luuppi") ; --UNCHK
lin lour_V = mkWV (k67 "mulkoilla") ; --UNCHK
lin louse_N = L.louse_N ;
lin lousy_A = mkWA (compoundA "täi" (k38 "nen")) ; --UNCHK
lin lout_N = mkWN (k2 "tohelo") ; --UNCHK
lin louth_PN = foreignPN "Louth" ;
lin loutish_A = mkWA (k38 "sikamainen") ; --UNCHK
lin louvar_N = mkWN "Luvarus" "imperialis" ; --UNCHK
lin louver_N = mkWN (k48 "säle") ; --UNCHK
lin louvered_A = mkWA (compoundA "varus" (k1 "tettu")) "säleiköllä" ; --UNCHK
lin louvre_N = mkWN (k48 "säle") ; --UNCHK
lin lovable_A = mkWA (k38 "herttainen") ; --UNCHK
lin lovage_N = mkWN (kH1 "liperi") ; --UNCHK
lin lovastatin_N = mkWN (compoundN "lov" (k5 "astatiini")) ; --UNCHK
lin love_N = L.love_N ;
lin love_V2 = L.love_V2 ;
lin love_VV = mkVV "rakastaa" ;
lin love_affair_N = mkWN (k5 "romanssi") ; --UNCHK
lin love_child_N = mkWN (k29 "lapsi") "avioton" ; --UNCHK
lin love_feast_N = mkWN (compoundN "rakkauden" (k12 "ateria")) ; --UNCHK
lin love_knot_N = mkWN (k1 "solmu") "rakkauden" ; --UNCHK
lin love_letter_N = mkWN (compoundN "rakkaus" (k48 "kirje")) ; --UNCHK
lin love_match_N = mkWN "rakkausavioliitto" ; --UNCHK
lin love_seat_N = mkWN (k10 "sohva") "kahdenistuttava" ; --UNCHK
lin love_song_N = mkWN (compoundN "rakkaus" (k1 "laulu")) ; --UNCHK
lin love_story_N = mkWN (compoundN "rakkaus" (k12 "tarina")) ; --UNCHK
lin lovebird_N = mkWN (compoundN "rakkaus" (k9 "papukaija")) ; --UNCHK
lin loveless_A = mkWA (k34A "rakkaudeton") ; --UNCHK
lin loveliness_N = mkWN (k40 "ihanuus") ; --UNCHK
lin lovelorn_A = mkWA (compoundA "rakas" (k47 "tunut")) "onnettomasti" ; --UNCHK
lin lovely_A = mkWA (k38 "suloinen") ;
lin lovemaking_N = mkWN (k7A "lempi") ; --UNCHK
lin lover_N = mkWN (k10 "rakastaja") ; --UNCHK
lin loverlike_A = mkWA (compoundA "rakka" (k67A "udella")) ; --UNCHK
lin lovesick_A = mkWA (compoundA "lemmen" (k15 "kipeä")) ; --UNCHK
lin lovesickness_N = mkWN (compoundN "lemmen" (k40 "kipeys")) ; --UNCHK
lin loving_A = mkWA (k10 "hellä") ; --UNCHK
lin loving_cup_N = mkWN (k6 "pokaali") ; --UNCHK
lin lovingness_N = mkWN (k1A "lämpö") ; --UNCHK
lin lovisa_PN = mkPN "Loviisa" ;
lin low_A = mkA "matala" ;
lin low_Adv = mkWAdv (k99 "matalalla") ;
lin low_N = mkN "pohjalukema" ;
lin low_V = mkWV (k73A "napata") ; --UNCHK
lin low_relief_N = mkWN (compoundN "koho" (k10 "kuva")) ; --UNCHK
lin lowborn_A = mkWA (compoundA "alhais" (k38 "sukuinen")) ; --UNCHK
lin lowboy_N = mkWN (k2 "lipasto") ; --UNCHK
lin lowbred_A = mkWA (k15 "töykeä") ; --UNCHK
lin lowbrow_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin lowbrow_N = mkWN (k38 "pulliainen") "tavallinen" ; --UNCHK
lin lower_V = mkWV (k67 "mulkoilla") ; --UNCHK
lin lower_V2 = mkV2 (mkV (lin VK {s = c58 "laskea"})) partitive ;
lin lowercase_A = mkWA (k26 "pieni") ; --UNCHK
lin lowerclassman_N = mkWN (k12 "opiskelija") "toisen" "vuoden" ; --UNCHK
lin lowering_N = mkWN "laskeminen" ; --UNCHK
lin loweringly_Adv = mkWAdv (k99 "uhkaavasti") ; --UNCHK
lin lowermost_A = mkWA (k36 "alin") ; --UNCHK
lin lowest_Adv = mkWAdv (k99 "alimpana") ; --UNCHK
lin lowestoft_PN = foreignPN "Lowestoft" ;
lin lowland_A = mkWA "alanko-" ; --UNCHK
lin lowland_N = mkWN (k1A "alanko") ; --UNCHK
lin lowlander_N = mkWN (k5A "skotti") "alamaan" ; --UNCHK
lin lowliness_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin lowly_A = mkWA (k34A "vaatimaton") ; --UNCHK
lin lowness_N = mkWN (k40 "mataluus") ; --UNCHK
lin lowset_A = mkWA (k10 "matala") "epätavallisen" ; --UNCHK
lin lox_N = mkWN (compoundN "savu" (k23 "lohi")) ; --UNCHK
lin loyal_A = mkWA (k5 "lojaali") ;
lin loyalist_N = mkWN (k10 "kannattaja") "uskollinen" ; --UNCHK
lin loyalty_N = mkWN (k5A "lojaliteetti") ;
lin lozenge_N = mkWN (kH1 "tabu") ; --UNCHK
lin lp_N = mkWN "L-P" ; --UNCHK
lin lsd_N = mkWN "LSD" ; --UNCHK
lin luau_N = mkWN (compoundN "luau-" (k10 "juhla")) ; --UNCHK
lin lubber_N = mkWN (compoundN "maa" (k1A "krapu")) ; --UNCHK
lin lubberly_A = mkWA (compoundA "maa" (k1A "krapu")) ; --UNCHK
lin lubeck_PN = mkPN "Lyypekki" ;
lin lubricant_N = mkWN (k48 "liukaste") ;
lin lubricate_V2 = mkWV2 (k67A "voidella") ; --UNCHK
lin lubrication_N = mkWN (k2 "voitelu") ; --UNCHK
lin lubricious_A = mkWA (k41A "rietas") ; --UNCHK
lin lucent_A = mkWA (k10 "loistava") ; --UNCHK
lin lucerne_N = mkWN (compoundN "sini" (k38 "mailanen")) ; --UNCHK
lin lucid_A = mkWA (k10 "selvä") ; --UNCHK
lin lucidity_N = mkWN (k40 "kirkkaus") ; --UNCHK
lin lucifer_N = mkWN (compoundN "tuli" (k1A "tikku")) ; --UNCHK
lin luciferin_N = mkWN "lusiferiini" ; --UNCHK
lin lucifugous_A = mkWA "valoa" "kaihtava" ; --UNCHK
lin luck_N = mkN "tuuri" ;
lin luck_into_V2 = mkWV2 (k63 "saada") "tuurilla" ; --UNCHK
lin luck_out_V = mkWV (k53A "voittaa") "jättipotti" ; --UNCHK
lin luckily_Adv = adjAdv lucky_A ; -- derived
lin luckless_A = mkWA (k34A "onneton") ; --UNCHK
lin lucknow_PN = foreignPN "Lucknow" ;
lin lucky_A = mkWA (k41A "onnekas") ; --UNCHK
lin lucrative_A = mkWA (k10 "tuottava") ; --UNCHK
lin lucre_N = mkWN (k1A "netto") ; --UNCHK
lin lucubration_N = mkWN (k9A "pohdinta") ; --UNCHK
lin luddite_N = mkWN "luddiitti" ; --UNCHK
lin ludicrous_A = mkWA (k34A "mieletön") ;
lin ludlow_PN = foreignPN "Ludlow" ;
lin ludo_N = mkWN "ludo" ; --UNCHK
lin luff_N = mkWN (compoundN "luo" (k38 "viminen")) ; --UNCHK
lin luff_V = mkWV (k53A "lepattaa") ; --UNCHK
lin luff_V2 = mkWV2 (k53A "lepattaa") ; --UNCHK
lin luffa_N = mkWN (k1A "pesusienikurkku") ; --UNCHK
lin lug_N = mkWN (compoundN "hieta" (k1A "mato")) ; --UNCHK
lin lug_V2 = mkWV2 (k52 "kiskoa") ; --UNCHK
lin luge_N = mkWN (k9A "kelkka") ; --UNCHK
lin luger_N = mkWN "Luger" ; --UNCHK
lin luggage_carrier_N = mkWN (compoundN "tavara" (k48 "teline")) ; --UNCHK
lin luggage_rack_N = mkWN (compoundN "katto" (k48 "teline")) ; --UNCHK
lin luggage_van_N = mkWN (compoundN "matkatavara" (k1 "vaunu")) ; --UNCHK
lin lugger_N = mkWN "lugger" ; --UNCHK
lin luging_N = mkWN (k2 "kelkkailu") ; --UNCHK
lin lugsail_N = mkWN (compoundN "logertti" (k48 "purje")) ; --UNCHK
lin lugubrious_A = mkWA (k38 "murheellinen") ; --UNCHK
lin lugubriousness_N = mkWN (k40 "surullisuus") ; --UNCHK
lin lugworm_N = mkWN (compoundN "hieta" (k1A "mato")) ; --UNCHK
lin luhanka_PN = mkPN "Luhanka" ;
lin lukewarm_A = mkWA (k15 "vaimea") ; --UNCHK
lin lukewarmness_N = mkWN (k40 "laimeus") ; --UNCHK
lin lull_N = mkWN (k40 "tyyneys") ; --UNCHK
lin lull_V = mkWV (k52A "rauhoittua") ; --UNCHK
lin lull_V2 = mkWV2 (k52A "rauhoittua") ; --UNCHK
lin lullaby_N = mkWN (compoundN "kehto" (k1 "laulu")) "laulaa" ; --UNCHK
lin lumbago_N = mkWN (compoundN "ristiselkä" (k1A "kipu")) ; --UNCHK
lin lumbar_A = mkWA (compoundA "lumba" (k38 "alinen")) ; --UNCHK
lin lumber_N = mkWN (compoundN "baseball-" (k9 "maila")) ; --UNCHK
lin lumber_V = mkWV (k57A "kaataa") "puita" ; --UNCHK
lin lumber_V2 = mkWV2 (k57A "kaataa") "puita" ; --UNCHK
lin lumbering_N = mkWN (compoundN "puu" (k9A "kauppa")) ; --UNCHK
lin lumberjack_N = mkWN (k5A "takki") "metsurin" ; --UNCHK
lin lumberman_N = mkWN (k6 "metsuri") ; --UNCHK
lin lumber_mill_N = mkWN (k9 "saha") ; --UNCHK
lin lumberyard_N = mkWN (compoundN "puutavara" (k48A "liike")) ; --UNCHK
lin lumbosacral_A = mkWA (compoundA "lumbo" (k38 "sakraalinen")) ; --UNCHK
lin lumen_N = mkWN (k2 "ontelo") ; --UNCHK
lin lumijoki_PN = mkPN (mkN "Lumijoki" "Lumijokia") ;
lin luminary_N = mkWN (k2 "henkilö") "kuuluisa" ; --UNCHK
lin luminescence_N = mkWN (k48 "loiste") ; --UNCHK
lin luminescent_A = mkWA "valoa" "heijastava" ; --UNCHK
lin luminism_N = mkWN (compoundN "lumin" (k5 "ismi")) ; --UNCHK
lin luminosity_N = mkWN (k1 "valo") ; --UNCHK
lin luminous_A = mkWA (k10 "loistava") ; --UNCHK
lin lumma_N = mkWN "lumma" ; --UNCHK
lin lump_N = mkWN (k5A "klöntti") ; --UNCHK
lin lump_V2 = mkWV2 (k56A "laittaa") "rinnakkain" ; --UNCHK
lin lumpectomy_N = mkWN (k1 "poisto") "kyhmyn" ; --UNCHK
lin lumpenproletariat_N = mkWN (compoundN "ryysy" (k1 "köyhälistö")) ; --UNCHK
lin lumper_N = mkWN "taksonomisti" ; --UNCHK
lin lumpfish_N = mkWN (compoundN "rasva" (k9 "kala")) ; --UNCHK
lin lumpish_A = mkWA (k34A "ajattelematon") ; --UNCHK
lin lumpsucker_N = mkWN (compoundN "rasva" (k9 "kala")) ; --UNCHK
lin lumpy_A = mkWA (k38 "kokkareinen") ; --UNCHK
lin lunacy_N = mkWN (k39 "hullutus") ; --UNCHK
lin lunar_A = mkWA "lunaarinen" ; --UNCHK
lin lunatic_A = mkWA (compoundA "kuu" (k1 "hullu")) ; --UNCHK
lin lunatic_N = mkWN (k1A "uskalikko") ; --UNCHK
lin lunch_N = mkN "lounas" ;
lin lunch_V = mkWV (k53 "lounastaa") ; --UNCHK
lin lunch_V2 = mkWV2 (k53 "lounastaa") ; --UNCHK
lin luncheon_N = mkWN (k41 "lounas") "virallinen" ; --UNCHK
lin luncher_N = mkWN "lounastaja" ; --UNCHK
lin lunching_N = mkWN (compoundN "lounas" (k38 "taminen")) ; --UNCHK
lin lunchroom_N = mkWN (k12 "ruokala") ; --UNCHK
lin lunchtime_N = mkWN (compoundN "ruoka" (k5A "tunti")) ; --UNCHK
lin lunette_N = mkWN "lynetti" ; --UNCHK
lin lung_N = mkWN (k1 "keuhko") ; --UNCHK
lin lunge_N = mkWN (k1 "syöksy") ; --UNCHK
lin lunge_V = mkWV (k66 "ampaista") ; --UNCHK
lin lunger_N = mkWN (k38 "ihminen") "tuberkuloottinen" ; --UNCHK
lin lungfish_N = mkWN (compoundN "keuhko" (k9 "kala")) ; --UNCHK
lin lungi_N = mkWN "longyi" ; --UNCHK
lin lunisolar_A = mkWA (compoundA "luni" (k38 "solaarinen")) ; --UNCHK
lin lunula_N = mkWN (compoundN "lun" (k10 "ula")) ; --UNCHK
lin luopioinen_PN = mkPN "Luopioinen" ;
lin lupin_N = mkWN (k6 "lupiini") ; --UNCHK
lin lupine_A = mkWA (compoundA "susi" (k38 "mainen")) ; --UNCHK
lin lupine_N = mkWN (k6 "lupiini") ; --UNCHK
lin lupus_N = mkWN "Susi" ; --UNCHK
lin lurch_N = mkWN (k2 "horjahtelu") ; --UNCHK
lin lurch_V = mkWV (k53A "rökittää") ; --UNCHK
lin lurcher_N = mkWN (k12 "vaanija") ; --UNCHK
lin lure_N = mkWN (k33A "houkutin") ; --UNCHK
lin lure_V2 = mkWV2 (k67A "viekoitella") ; --UNCHK
lin lurid_A = mkWA (compoundA "räikeän" (k38 "värinen")) ; --UNCHK
lin luridness_N = mkWN (k40 "karmeus") ; --UNCHK
lin lurk_V = mkWV (k53A "odottaa") "makuulla" ; --UNCHK
lin lurker_N = mkWN (k12 "vaanija") ; --UNCHK
lin lurking_place_N = mkWN (compoundN "piilo" (k9A "paikka")) ; --UNCHK
lin luscious_A = mkWA (k38 "hekumallinen") ; --UNCHK
lin lusciousness_N = mkWN (k40 "herkullisuus") ; --UNCHK
lin lush_A = mkWA (k5 "villi") ; --UNCHK
lin lush_N = mkWN (k6 "juomari") ; --UNCHK
lin lust_N = mkWN (k1 "halu") ; --UNCHK
lin lust_after_V2 = mkWV2 (k69 "himoita") ; --UNCHK
lin luster_N = mkWN (k48A "lasite") ; --UNCHK
lin lusterware_N = mkWN (compoundN "savi" (k12 "tavara")) ; --UNCHK
lin lustful_A = mkWA (k41A "himokas") ; --UNCHK
lin lustre_N = mkWN (k48A "lasite") ; --UNCHK
lin lustrous_A = mkWA (k10 "loistava") ; --UNCHK
lin lustrum_N = mkWN "lustrum" ; --UNCHK
lin lusty_A = mkWA (k41A "voimakas") ; --UNCHK
lin lutanist_N = mkWN (compoundN "luutun" (k10 "soittaja")) ; --UNCHK
lin lute_N = mkWN (kH1 "luuttu") ; --UNCHK
lin luteal_A = mkWA "keltarauhas-" ; --UNCHK
lin lutefisk_N = mkWN (compoundN "live" (k9 "kala")) ; --UNCHK
lin lutenist_N = mkWN (compoundN "luutun" (k10 "soittaja")) ; --UNCHK
lin lutetium_N = mkWN "järjestysluku" "71" ; --UNCHK
lin lutheran_A = mkWA (k38 "luterilainen") ; --UNCHK
lin lutheran_N = mkWN (k38 "luterilainen") ; --UNCHK
lin luthier_N = mkWN (k10 "rakentaja") "kielisoitinten" ; --UNCHK
lin lutist_N = mkWN (compoundN "luutun" (k10 "soittaja")) ; --UNCHK
lin luton_PN = foreignPN "Luton" ;
lin luumäki_PN = mkPN (mkN "Luumäki" "Luumäkiä") ;
lin luvia_PN = mkPN "Luvia" ;
lin lux_N = mkWN (k5 "luksi") ; --UNCHK
lin luxation_N = mkWN (compoundN "sijoiltaan" (k1 "meno")) ; --UNCHK
lin luxe_A = mkWA (k10 "loistava") ; --UNCHK
lin luxembourg_PN = foreignPN "Luxemburg" ;
lin luxemburger_N = mkWN (compoundN "yhdistelmä" (k5 "linssi")) ; --UNCHK
lin luxuriance_N = mkWN (k40 "täyteläisyys") ; --UNCHK
lin luxuriant_A = mkWA (k5 "villi") ; --UNCHK
lin luxuriate_V = mkWV (k53 "kukoistaa") ; --UNCHK
lin luxuriation_N = mkWN (k40 "ylellisyys") ; --UNCHK
lin luxurious_A = mkWA (k38 "aistillinen") ; --UNCHK
lin luxury_A = variants {} ; --
lin luxury_N = mkWN (k39 "luksus") ; --f64
lin lwei_N = mkWN "lwei" ; --UNCHK
lin lycaenid_N = mkWN (compoundN "sini" (k7A "siipi")) ; --UNCHK
lin lycanthropy_N = mkWN (compoundN "muu" (k38 "ttuminen")) "ihmissudeksi" ; --UNCHK
lin lycee_N = mkWN (k3 "lukio") ; --UNCHK
lin lyceum_N = mkWN (compoundN "luento" (k5 "sali")) ; --UNCHK
lin lychee_N = mkWN (kH1 "litsi") ; --UNCHK
lin lychgate_N = mkWN (k5A "portti") "katettu" ; --UNCHK
lin lychnis_N = mkWN (compoundN "käen" (k10A "kukka")) ; --UNCHK
lin lycopene_N = mkWN "lykopeeni" ; --UNCHK
lin lydney_PN = foreignPN "Lydney" ;
lin lye_N = mkWN (k15 "lipeä") ; --UNCHK
lin lygaeid_N = mkWN (compoundN "varjo" (k48A "lude")) ; --UNCHK
lin lying_N = mkWN (k2 "valehtelu") ; --UNCHK
lin lymington_PN = foreignPN "Lymington" ;
lin lymm_PN = foreignPN "Lymm" ;
lin lymph_N = mkWN (k9 "lymfa") ; --UNCHK
lin lymphadenitis_N = mkWN (compoundN "imusolmuke" (k39 "tulehdus")) ; --UNCHK
lin lymphadenoma_N = mkWN (compoundN "imusolmuke" (k33 "kasvain")) ; --UNCHK
lin lymphadenopathy_N = mkWN (compoundN "imusolmuke" (k5A "tauti")) ; --UNCHK
lin lymphangiectasia_N = mkWN (compoundN "imusuoni" (k10 "laajentuma")) ; --UNCHK
lin lymphangiogram_N = mkWN (compoundN "imusuoni" (k10 "kuva")) ; --UNCHK
lin lymphangiography_N = mkWN (compoundN "varjoaine" (k39 "kuvaus")) "imuteiden" ; --UNCHK
lin lymphangioma_N = mkWN (compoundN "imusuoni" (k33 "kasvain")) ; --UNCHK
lin lymphangitis_N = mkWN (compoundN "imusuoni" (k39 "tulehdus")) ; --UNCHK
lin lymphatic_A = mkWA (k38 "lymfaattinen") ; --UNCHK
lin lymphedema_N = mkWN (compoundN "imuneste" (k39 "turvotus")) ; --UNCHK
lin lymphoblast_N = mkWN "varhaisimusolu" ; --UNCHK
lin lymphocyte_N = mkWN (k5A "lymfosyytti") ; --UNCHK
lin lymphocytic_A = mkWA (compoundA "lymfosyytti" (k38 "nen")) ; --UNCHK
lin lymphocytopenia_N = mkWN "lymfopenia" ; --UNCHK
lin lymphocytosis_N = mkWN "lymfosytoosi" ; --UNCHK
lin lymphogranuloma_N = mkWN (compoundN "lymfogranulo" (k10 "oma")) ; --UNCHK
lin lymphoid_A = mkWA (k38 "kaltainen") "imukudoksen" ; --UNCHK
lin lymphokine_N = mkWN "lymfokiini" ; --UNCHK
lin lymphoma_N = mkWN (k10 "lymfooma") ; --UNCHK
lin lymphopoiesis_N = mkWN "lymfopoieesi" ; --UNCHK
lin lynch_V2 = mkWV2 (k73A "lynkata") ; --UNCHK
lin lynching_N = mkWN (k39 "lynkkaus") ; --UNCHK
lin lynchpin_N = mkWN (compoundN "sokka" (k9 "naula")) ; --UNCHK
lin lynn_PN = foreignPN "Lynn" ;
lin lynx_N = mkWN (k39 "ilves") ; --UNCHK
lin lyonnaise_A = mkWA "lyonnaise" ; --UNCHK
lin lyons_PN = foreignPN "Lyon" ;
lin lyophilized_A = mkWA (compoundA "pakastekui" (k1A "vattu")) ; --UNCHK
lin lypressin_N = mkWN "lypressiini" ; --UNCHK
lin lyrate_A = mkWA (compoundA "lyyra" (k38 "mainen")) ; --UNCHK
lin lyre_N = mkWN (k9 "lyyra") ; --UNCHK
lin lyre_bird_N = mkWN (compoundN "lyyra" (k1A "lintu")) ; --UNCHK
lin lyric_A = mkWA (k38 "lyyrinen") ; --UNCHK
lin lyric_N = mkWN (k1 "runo") "lyyrinen" ; --UNCHK
lin lyrical_A = mkWA (k38 "lyyrinen") ; --UNCHK
lin lyricality_N = mkWN (k40 "lyyrisyys") ; --UNCHK
lin lyricism_N = mkWN (k40 "lyyrisyys") ; --UNCHK
lin lyricist_N = mkWN (k10 "sanoittaja") ; --UNCHK
lin lysin_N = mkWN "lysiini" ; --UNCHK
lin lysine_N = mkWN "lysiini" ; --UNCHK
lin lysinemia_N = mkWN "lysinemia" ; --UNCHK
lin lysis_N = mkWN "liukeneminen" ; --UNCHK
lin lysogenic_A = mkWA "lysogeeninen" ; --UNCHK
lin lysogenization_N = mkWN "lysogenisaatio" ; --UNCHK
lin lysogeny_N = mkWN "lysogeenisuus" ; --UNCHK
lin lysol_N = mkWN (k5 "lysoli") ; --UNCHK
lin lysosome_N = mkWN "lysosomi" ; --UNCHK
lin lysozyme_N = mkWN (compoundN "muramid" (k5 "aasi")) ; --UNCHK
lin lyssavirus_N = mkWN (compoundN "vesikauhu" (k39 "virus")) ; --UNCHK
lin längelmäki_PN = mkPN (mkN "Längelmäki" "Längelmäkiä") ;
lin länsi_turunmaa_PN = mkPN "Länsi-Turunmaa" ;
lin ma'am_N = mkWN (k5 "daami") ; --UNCHK
lin ma_N = mkN "äiti" "äitejä" ; ---- split MA WN (k6 "maisteri") "filosofian" ; --UNCHK
lin maaninka_PN = mkPN "Maaninka" ;
lin maar_N = mkWN "maari" ; --UNCHK
lin maastricht_PN = foreignPN "Maastricht" ;
lin mac_N = mkWN (compoundN "sade" (k5A "takki")) ; --UNCHK
lin macabre_A = mkWA (k10 "kamala") ; --UNCHK
lin macadam_N = mkWN (k5A "asfaltti") ; --UNCHK
lin macadamia_N = mkWN (compoundN "australian" (k12 "pähkinä")) ; --UNCHK
lin macadamize_V2 = mkWV2 (k53 "päällystää") "asfaltilla" ; --UNCHK
lin macaque_N = mkWN (k5 "makaki") ; --UNCHK
lin macaroni_N = mkWN (k5 "makaroni") ; --UNCHK
lin macaronic_A = mkWA (compoundA "makaroni" (k38 "nen")) ; --UNCHK
lin macaroon_N = mkWN (k5 "macaron-keksi") ; --UNCHK
lin macaw_N = mkWN "ara" ; --UNCHK
lin macclesfield_PN = foreignPN "Macclesfield" ;
lin mace_N = mkWN (k9 "sauva") ; --UNCHK
lin mace_bearer_N = mkWN (compoundN "sauvan" (k10 "kantaja")) ; --UNCHK
lin macedoine_N = mkWN "macedoine" ; --UNCHK
lin macedonian_A = mkWA (compoundA "makedoni" (k38 "alainen")) ; --UNCHK
lin macedonian_N = mkWN "makedonia" ; --UNCHK
lin macerate_V = mkWV (k53A "riuduttaa") ; --UNCHK
lin macerate_V2 = mkWV2 (k53A "riuduttaa") ; --UNCHK
lin maceration_N = mkWN (k40 "laihuus") ; --UNCHK
lin macerative_A = mkWA "pehmentyvä" ; --UNCHK
lin mach_PN = foreignPN "Mach" ;
lin machete_N = mkWN (compoundN "viidakko" (k30 "veitsi")) ; --UNCHK
lin machiavellian_A = mkWA "machiavelliläinen" ; --UNCHK
lin machicolation_N = mkWN (compoundN "ampuma" (k10A "reikä")) ; --UNCHK
lin machination_N = mkWN (k26 "juoni") ; --UNCHK
lin machine_N = mkN "kone" ;
lin machine_V2 = mkWV2 (k53 "valmistaa") "koneella" ; --UNCHK
lin machine_gun_N = mkWN (compoundN "kone" (k6 "kivääri")) ; --UNCHK
lin machinery_N = mkN "koneisto" ;
lin machinist_N = mkWN (k10 "koneistaja") ; --f54
lin machismo_N = mkWN (k2 "machoilu") ; --UNCHK
lin machmeter_N = mkWN (compoundN "mach-" (k6 "mittari")) ; --UNCHK
lin macho_N = mkWN (k1 "macho") ; --UNCHK
lin mackerel_N = mkWN (k5 "makrilli") ; --UNCHK
lin mackinaw_N = mkWN (k41A "villakangas") ; --UNCHK
lin mackintosh_N = mkWN (compoundN "sade" (k5A "takki")) ; --UNCHK
lin mackle_N = mkWN (k10 "painauma") ; --UNCHK
lin macon_N = mkWN "maconnais" ; --UNCHK
lin macrame_N = mkWN (k20 "makramee") ; --UNCHK
lin macrencephalic_A = mkWA (compoundA "suu" (k38 "ripäinen")) ; --UNCHK
lin macrencephaly_N = mkWN "makrenkefalia" ; --UNCHK
lin macro_A = mkWA "makro-" ; --UNCHK
lin macro_N = mkWN (k1 "makro") ; --UNCHK
lin macrobiotic_A = mkWA (k38 "makrobioottinen") ; --UNCHK
lin macrocephalic_A = mkWA (compoundA "iso" (k38 "päinen")) ; --UNCHK
lin macrocephaly_N = mkWN (compoundN "isopä" (k40 "isyys")) ; --UNCHK
lin macrocosm_N = mkWN (k40 "avaruus") ; --UNCHK
lin macrocosmic_A = mkWA (compoundA "makro" (k38 "kosminen")) ; --UNCHK
lin macrocytosis_N = mkWN "makrosytoosi" ; --UNCHK
lin macroeconomic_A = mkWA "makrotaloustieteellinen" ; --UNCHK
lin macroeconomics_N = mkWN "makrotaloustiede" ; --UNCHK
lin macroeconomist_N = mkWN (compoundN "asian" (k12 "tuntija")) "makrotalouden" ; --UNCHK
lin macroevolution_N = mkWN (compoundN "makro" (k3 "evoluutio")) ; --UNCHK
lin macroglossia_N = mkWN (compoundN "suurikiel" (k40 "isyys")) ; --UNCHK
lin macromolecular_A = mkWA (compoundA "makromoleky" (k38 "ylinen")) ; --UNCHK
lin macromolecule_N = mkWN (compoundN "makro" (k5 "molekyyli")) ; --UNCHK
lin macron_N = mkWN (compoundN "pituus" (k5A "merkki")) ; --UNCHK
lin macrophage_N = mkWN "makrofagi" ; --UNCHK
lin macroscopic_A = mkWA (k38 "makroskooppinen") ; --UNCHK
lin macroscopically_Adv = mkWAdv "paljain" "silmin" ; --UNCHK
lin macrotus_N = mkWN "Macrotus" "californicus" ; --UNCHK
lin macrozamia_N = mkWN (compoundN "käpy" (k1 "palmu")) ; --UNCHK
lin macula_N = mkWN (k10 "täplä") ; --UNCHK
lin maculate_A = mkWA (k38 "täpläinen") ; --UNCHK
lin macule_N = mkWN (k10 "täplä") ; --UNCHK
lin macumba_N = mkWN "macumba" ; --UNCHK
lin macushla_N = mkWN (compoundN "kullan" (k1A "nuppu")) ; --UNCHK
lin mad_A = mkWA (k38 "vihainen") ;
lin madagascan_A = mkWA (compoundA "madagaskari" (k38 "lainen")) ; --UNCHK
lin madagascan_N = mkWN (compoundN "madagaskari" (k38 "lainen")) ; --UNCHK
lin madagascar_PN = foreignPN "Madagaskar" ;
lin madam_N = mkN "rouva" ; --UNCHK
lin madame_N = mkWN (k10 "rouva") ; --UNCHK
lin madcap_N = mkWN (k1A "uskalikko") ; --UNCHK
lin madden_V2 = mkWV2 (k53A "raivostuttaa") ; --UNCHK
lin madder_N = mkWN (k13 "matara") ; --UNCHK
lin madderwort_N = mkWN (compoundN "matara" (k5 "kasvi")) ; --UNCHK
lin madeira_N = mkWN (k13 "madeira") ; --UNCHK
lin mademoiselle_N = mkN "neiti" ;
lin madhouse_N = mkWN (k3 "sanatorio") ; --UNCHK
lin madman_N = mkWN (k1 "hullu") ; --UNCHK
lin madness_N = mkWN (k40 "mielettömyys") ; --UNCHK
lin madras_N = mkWN (k39 "madras") ; --UNCHK
lin madras_PN = foreignPN "Madras" ;
lin madrasa_N = mkWN "madrassa" ; --UNCHK
lin madrid_PN = foreignPN "Madrid" ;
lin madrigal_N = mkWN (k5 "madrigaali") ; --UNCHK
lin madrigalist_N = mkWN "madrigalisti" ; --UNCHK
lin madrilene_N = mkWN (k1A "keitto") ; --UNCHK
lin madrona_N = mkWN "Arbutus" "menziesii" ; --UNCHK
lin madurai_PN = foreignPN "Madurai" ;
lin madwoman_N = mkWN (k1 "hullu") ; --UNCHK
lin maelstrom_N = mkWN (k48A "pyörre") ; --UNCHK
lin maenad_N = mkWN "mainadi" ; --UNCHK
lin maesteg_PN = foreignPN "Maesteg" ;
lin maestro_N = mkWN (k6 "mestari") ; --UNCHK
lin mafia_N = mkWN (k12 "mafia") ;
lin mafioso_N = mkWN (k1 "mafioso") ; --UNCHK
lin mag_N = mkWN (k7A "lehti") ; --UNCHK
lin magazine_N = mkN (lin NK {s = d05 "makasiini"}) ;
lin magdalen_N = mkWN (k1A "prostituoitu") "entinen" ; --UNCHK
lin magdeburg_PN = foreignPN "Magdeburg" ;
lin magenta_A = mkWA (compoundA "aniliinin" (k38 "punainen")) ; --UNCHK
lin magenta_N = mkWN (k2 "taistelu") "Magentan" ; --UNCHK
lin maggot_N = mkWN (k10A "toukka") ; --UNCHK
lin maggoty_A = mkWA (k38 "matoinen") ; --UNCHK
lin maghull_PN = foreignPN "Maghull" ;
lin magic_A = mkWA (k10 "lumoava") ; --UNCHK
lin magic_N = mkWN (k3 "illuusio") ; --UNCHK
lin magical_A = mkWA (k10 "lumoava") ; --UNCHK
lin magician_N = mkWN (k4A "maagikko") ; --UNCHK
lin magisterial_A = mkA "määräävä" ; ---ARB ; virkavallan ; tuomarin
lin magistracy_N = mkWN (k6 "tuomari") ; --UNCHK
lin magistrate_N = mkWN (k5A "maistraatti") ; --UNCHK
lin magma_N = mkWN (k9 "magma") ; --UNCHK
lin magnanimity_N = mkWN (k40 "anteliaisuus") ; --UNCHK
lin magnanimous_A = mkWA (k26 "suuri") ; --UNCHK
lin magnate_N = mkWN (k5 "moguli") ; --UNCHK
lin magnesia_N = mkWN (compoundN "magnesium" (k5 "oksidi")) ; --UNCHK
lin magnesite_N = mkWN (k5A "magnesiitti") ; --UNCHK
lin magnesium_N = mkWN (k5 "magnesium") ; --UNCHK
lin magnet_N = mkWN (k5A "magneetti") ; --UNCHK
lin magnetic_A = mkA "magneettinen" ;
lin magnetism_N = mkWN (k5 "magnetismi") ; --UNCHK
lin magnetite_N = mkWN (k5A "magnetiitti") ; --UNCHK
lin magnetize_V2 = mkWV2 (k62 "magnetoida") ; --UNCHK
lin magneto_N = mkWN (k1A "magneetto") ; --UNCHK
lin magnetograph_N = mkWN "magnetografi" ; --UNCHK
lin magnetohydrodynamics_N = mkWN (compoundN "magnetohydro" (k9A "dynamiikka")) ; --UNCHK
lin magnetometer_N = mkWN (compoundN "magneto" (k5 "metri")) ; --UNCHK
lin magneton_N = mkWN "magnetoni" ; --UNCHK
lin magnetosphere_N = mkWN (compoundN "magnetosf" (k26 "ääri")) ; --UNCHK
lin magnetron_N = mkWN "magnetroni" ; --UNCHK
lin magnification_N = mkWN (k39 "suurennus") ; --UNCHK
lin magnificence_N = mkWN (k40 "suurenmoisuus") ; --UNCHK
lin magnificent_A = mkWA (k38 "suurenmoinen") ; --UNCHK
lin magnifico_N = mkWN (compoundN "arvo" (k2 "henkilö")) ; --UNCHK
lin magnifier_N = mkWN (compoundN "suurennus" (k5 "lasi")) ; --UNCHK
lin magnify_V2 = mkV2 "suurentaa" partitive ;
lin magniloquence_N = mkWN (k40 "pateettisuus") ; --UNCHK
lin magniloquent_A = mkWA (k38 "pateettinen") ; --UNCHK
lin magnitude_N = mkWN (k40 "voimakkuus") ; --UNCHK
lin magnolia_N = mkWN (k12 "magnolia") ; --UNCHK
lin magnum_N = mkWN (compoundN "magnum" (k1 "pullo")) ; --UNCHK
lin magnum_opus_N = mkWN (compoundN "pää" (k39 "teos")) ; --UNCHK
lin magpie_N = mkWN (k14A "harakka") ; --UNCHK
lin magus_N = mkWN (k5 "maagi") ; --UNCHK
lin magyarFem_N = mkWN (k6 "unkari") ; --UNCHK
lin magyarMasc_N = mkWN (k6 "unkari") ; --UNCHK
lin magyar_A = mkWA (k38 "unkarilainen") ; --UNCHK
lin maharaja_N = mkWN (k9 "maharadža") ; --UNCHK
lin mahatma_N = mkWN (k11 "mahatma") ; --UNCHK
lin mahjong_N = mkWN "mah-jong" ; --UNCHK
lin mahoe_N = mkWN (k39 "elatus") "Hibiscus" ; --UNCHK
lin mahogany_N = mkWN (k5A "mahonki") ; --UNCHK
lin mahuang_N = mkWN "Ephedra" "sinica" ; --UNCHK
lin maid_N = mkWN (k5A "neiti") ; --UNCHK
lin maiden_A = mkWA (k38 "ensimmäinen") ; --UNCHK
lin maiden_N = mkWN (k5A "neiti") ; --UNCHK
lin maidenhair_N = mkWN (k38 "saniainen") ; --UNCHK
lin maidenhead_N = mkWN (k5 "hymen") ; --UNCHK
lin maidenhead_PN = foreignPN "Maidenhead" ;
lin maidenhood_N = mkWN (k9A "tyttöaika") ; --UNCHK
lin maidenlike_A = mkWA (k38 "neitseellinen") ; --UNCHK
lin maidenliness_N = mkWN (k40 "neitseellisyys") ; --UNCHK
lin maidenly_A = mkWA (k38 "neitseellinen") ; --UNCHK
lin maidservant_N = mkWN (k32A "palvelijatar") ; --UNCHK
lin maidstone_PN = foreignPN "Maidstone" ;
lin maigre_N = mkWN (compoundN "kotka" (k9 "kala")) ; --UNCHK
lin mail_N = mkN "posti" ;
lin mail_V2 = mkWV2 (k53A "toimittaa") ;
lin mail_train_N = mkWN (compoundN "posti" (k10 "juna")) ; --UNCHK
lin mailbag_N = mkWN (compoundN "posti" (k1A "laukku")) ; --UNCHK
lin mailboat_N = mkWN (compoundN "posti" (k48 "vene")) ; --UNCHK
lin mailbox_N = mkWN (compoundN "posti" (k4A "laatikko")) ; --UNCHK
lin maildrop_N = mkWN (compoundN "posti" (k1A "luukku")) ; --UNCHK
lin mailer_N = mkWN (compoundN "posti" (k5A "paketti")) ; --UNCHK
lin mailing_N = mkWN (k39 "postitus") ; --UNCHK
lin mailing_list_N = mkWN (compoundN "postitus" (k9 "lista")) ; --UNCHK
lin mailman_N = mkWN (compoundN "postin" (k10 "jakaja")) ; --UNCHK
lin mailsorter_N = mkWN (k12 "lajittelija") ; --UNCHK
lin maim_V2 = mkWV2 (k52A "silpoa") ; --UNCHK
lin main_A = mkA "pääasiallinen" ;
lin main_N = mkWN (compoundN "pää" (k1A "johto")) ; --UNCHK
lin mainframe_N = mkWN (k6 "prosessori") ; --UNCHK
lin mainland_N = mkWN (k49 "mantere") ; --UNCHK
lin mainly_Adv = mkAdv "pääasiassa" ;
lin mainmast_N = mkWN (k51 "isomasto") ; --UNCHK
lin mains_N = variants {} ; --
lin mainsail_N = mkWN (k51 "isopurje") ; --UNCHK
lin mainspring_N = mkWN (compoundN "veto" (k26 "jousi")) ; --UNCHK
lin mainstay_N = mkN "tukipilari" ; --mkWN (compoundN "keula" (k39 "harus")) ;
lin mainstream_N = mkWN (compoundN "valta" (k9A "virta")) ;
lin mainstreamed_A = mkWA "sopeutettu" ; --UNCHK
lin maintain_V = mkV "säilyä" | mkWV (k53A "säilyttää") ;
lin maintain_V2 = mkV2 "ylläpitää" partitive ;
lin maintain_VS = mkVS "vakuuttaa" ;
lin maintainable_A = mkWA "ylläpidettävä" ; --UNCHK
lin maintenance_N = mkN "ylläpito" ;
lin mainz_PN = foreignPN "Mainz" ;
lin maisonette_N = mkWN (compoundN "pien" (k1 "talo")) ; --UNCHK
lin maisonnette_N = mkWN (compoundN "pien" (k1 "talo")) ; --UNCHK
lin maize_N = mkWN (compoundN "sitruunan" (k38 "keltainen")) ; --UNCHK
lin majestic_A = mkWA (k41 "ylväs") ; --UNCHK
lin majesty_N = mkWN (k40 "ylevyys") ; --UNCHK
lin majolica_N = mkWN (k13 "majolika") ; --UNCHK
lin major_A = mkA "merkittävä" ;
lin major_N = mkN "pää" (mkN "aine") ; ---ARB --mkN "majuri" ; --mkN "duuri" ;
lin major_V = mkV (mkV "opiskella") "pääaineena" ;
lin majority_N = mkN "enemmistö" ;
lin majuscular_A = mkWA (compoundA "versa" (k38 "alinen")) ; --UNCHK
lin majuscule_A = mkWA (compoundA "versa" (k38 "alinen")) ; --UNCHK
lin make_N = mkN "teko" ;
lin make_V = tehda_V ;
lin make_V2 = mkV2 tehda_V ;
lin make_V2A = mkV2A tehda_V accusative (mkPrep translative) ;
lin make_V2V = mkV2V (mkV "saada") accusative ;
lin make_after_V = advV OP_make_V OP_after_Adv ; -- guess-p-verb
lin make_away_with_V2 = prepV2 (advV OP_make_V OP_away_Adv ) OP_with_Prep ; -- guess-p-verb
lin make_do_with_V2 = variants {} ; -- guess-p-verb
lin make_for_V2 = mkWV2 (k71 "tehdä") ; --UNCHK
lin make_into_V2 = prepV2 OP_make_V OP_into_Prep ; -- guess-p-verb
lin make_it_V = mkV "onnistua" ;
lin make_it_up_to_V2 = variants {} ; -- guess-p-verb
lin make_of_V3 = mkV3 (mkV "ajatella") (casePrep partitive) (casePrep elative) ;
lin make_off_V = mkWV (k60A "lähteä") "tiehensä" ; --UNCHK
lin make_off_with_V2 = prepV2 (advV OP_make_V OP_off_Adv ) OP_with_Prep ; -- guess-p-verb
lin make_out_V = mkWV (k54A "ymmärtää") ; --UNCHK
lin make_out_V2 = mkWV2 (k54A "ymmärtää") ; --UNCHK
lin make_out_with_V2 = prepV2 (advV OP_make_V OP_out_Adv ) OP_with_Prep ; -- guess-p-verb
lin make_over_V2 = prepV2 OP_make_V OP_over_Prep ; -- guess-p-verb
lin make_towards_V2 = prepV2 OP_make_V OP_towards_Prep ; -- guess-p-verb
lin make_up_N = variants {} ; --
lin make_up_V = mkWV (k53 "ehostaa") ; --UNCHK
lin make_up_V2 = mkWV2 (k53 "ehostaa") ; --UNCHK
lin make_up_for_V2 = prepV2 (advV OP_make_V OP_up_Adv ) OP_for_Prep ; -- guess-p-verb
lin make_up_to_V2 = prepV2 (advV OP_make_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin make_with_V2 = prepV2 OP_make_V OP_with_Prep ; -- guess-p-verb
lin makeover_N = mkWN (compoundN "muodon" (k39 "muutos")) ; --UNCHK
lin maker_N = mkN "tekijä" ;
lin makeready_N = mkWN (compoundN "valmis" (k38 "tautuminen")) ; --UNCHK
lin makeshift_N = mkWN (k48A "korvike") ; --UNCHK
lin makeup_N = mkWN (k6 "pakkeli") ; --UNCHK
lin makeweight_N = mkWN (compoundN "lisä" (k1 "paino")) ; --UNCHK
lin making_N = mkWN (k1A "tuotanto") ; --UNCHK
lin mako_N = mkWN (compoundN "makrilli" (k18 "hai")) ; --UNCHK
lin makomako_N = mkWN (compoundN "racem" (k10 "osa")) "Aristotelia" ; --UNCHK
lin malabsorption_N = mkWN (compoundN "imeytymis" (k3 "häiriö")) ; --UNCHK
lin malacca_N = mkWN (compoundN "rottinki" (k5A "keppi")) ; --UNCHK
lin malachite_N = mkWN (k5A "malakiitti") ; --UNCHK
lin malacia_N = mkWN "pehmentyminen" ; --UNCHK
lin malacologist_N = mkWN "malakologi" ; --UNCHK
lin malacology_N = mkWN "malakologia" ; --UNCHK
lin maladaptive_A = mkWA (compoundA "haitt" (k9 "aava")) "sopeutumista" ; --UNCHK
lin maladjusted_A = mkWA (k34A "sopeutumaton") ; --UNCHK
lin maladjustive_A = mkWA (k10 "sopiva") "huonosti" ; --UNCHK
lin maladjustment_N = mkWN (compoundN "tasa" (k34A "painoton")) "henkisesti" ; --UNCHK
lin maladroit_A = mkWA (k2 "kömpelö") ; --UNCHK
lin maladroitness_N = mkWN (k40 "hitaus") ; --UNCHK
lin malady_N = mkWN (k5A "tauti") ; --UNCHK
lin malaga_PN = foreignPN "Malaga" ;
lin malahini_N = mkWN (k41A "tulokas") ; --UNCHK
lin malaise_N = mkWN (k40 "levottomuus") ; --UNCHK
lin malamute_N = mkWN "alaskanmalamuutti" ; --UNCHK
lin malapropism_N = mkWN (compoundN "malaprop" (k5 "ismi")) ; --UNCHK
lin malapropos_A = mkWA (k34A "sopimaton") ; --UNCHK
lin malapropos_Adv = mkWAdv (k99 "sopimattomasti") ; --UNCHK
lin malaria_N = mkWN (k12 "malaria") ; --UNCHK
lin malarial_A = mkWA "malaria-" ; --UNCHK
lin malawi_PN = foreignPN "Malawi" ;
lin malawian_A = mkWA (compoundA "malawi" (k38 "lainen")) ; --UNCHK
lin malawian_N = mkWN (compoundN "malawi" (k38 "lainen")) ; --UNCHK
lin malax_PN = mkPN (mkN "Maalahti" "Maalahden" "Maalahtia") ;
lin malay_A = mkWA (k38 "malaijilainen") ; --UNCHK
lin malay_N = mkWN (k5 "malaiji") ; --UNCHK
lin malaya_PN = foreignPN "Malaya" ;
lin malayan_A = mkWA (k38 "malaijilainen") ; --UNCHK
lin malayan_N = mkWN (k5 "malaiji") ; --UNCHK
lin malaysia_PN = foreignPN "Malesia" ;
lin malaysian_A = mkWA (compoundA "malesi" (k38 "alainen")) ; --UNCHK
lin malaysian_N = mkWN (k5 "malaiji") ; --UNCHK
lin malcontent_A = mkWA (k38 "kapinallinen") ; --UNCHK
lin malcontent_N = mkWN (k2 "henkilö") "tyytymätön" ; --UNCHK
lin maldon_PN = foreignPN "Maldon" ;
lin male_A = mkA "miespuolinen" | mkA "urospuolinen" ;
lin male_N = mkWN (k41 "koiras") ; --UNCHK
lin maleate_N = mkWN "maleaatti" ; --UNCHK
lin maleberry_N = mkWN "Lyonia" "ligustrina" ; --UNCHK
lin malediction_N = mkWN (k39 "kirous") ; --UNCHK
lin malefactor_N = mkWN (k10 "konna") ; --UNCHK
lin malefic_A = mkWA (k10 "julma") ; --UNCHK
lin maleficence_N = mkWN (k40 "turmiollisuus") ; --UNCHK
lin maleficent_A = mkWA (k38 "vahingollinen") ; --UNCHK
lin maleness_N = mkWN (k40 "maskuliinisuus") ; --UNCHK
lin maleo_N = mkWN (compoundN "vasarapää" (k9 "kana")) ; --UNCHK
lin malevolence_N = mkWN (k40 "pahanilkisyys") ; --UNCHK
lin malevolent_A = mkWA (k10 "julma") ; --UNCHK
lin malfeasance_N = mkWN (compoundN "väärin" (k39 "käytös")) ; --UNCHK
lin malfeasant_N = mkWN (compoundN "väärin" (k10 "käyttäjä")) ; --UNCHK
lin malformation_N = mkWN (compoundN "epä" (k40 "muotoisuus")) ; --UNCHK
lin malformed_A = mkWA (k34A "muodoton") ; --UNCHK
lin malfunction_N = mkWN (compoundN "toiminta" (k3 "häiriö")) ; --UNCHK
lin malfunction_V = mkWV (k61 "toimia") "huonosti" ; --UNCHK
lin mali_PN = foreignPN "Mali" ;
lin malian_A = mkWA (compoundA "mali" (k38 "lainen")) ; --UNCHK
lin malian_N = mkWN (compoundN "mali" (k38 "lainen")) ; --UNCHK
lin malice_N = mkWN (k40 "pahanilkisyys") ; --UNCHK
lin malicious_A = mkWA (compoundA "paha" (k38 "nilkinen")) ; --UNCHK
lin malign_A = mkWA (compoundA "pahan" (k10A "suopa")) ; --UNCHK
lin malign_V2 = mkWV2 (k52 "puhua") "pahaa" ; --UNCHK
lin malignancy_N = mkWN (k40 "ilkeys") ; --UNCHK
lin malignant_A = mkWA (k38 "vahingollinen") ;
lin malignity_N = mkWN (k40 "ilkeys") ; --UNCHK
lin malik_N = mkWN "malik" ; --UNCHK
lin malinger_V = mkWV (k53 "luistaa") ; --UNCHK
lin malingerer_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin malingering_N = mkWN (k2 "pakoilu") "töistä" ; --UNCHK
lin malinois_N = mkWN "belgianpaimenkoira" "malinois" ; --UNCHK
lin mallard_N = mkWN (compoundN "sini" (k10 "sorsa")) ; --UNCHK
lin malleability_N = mkWN (k40 "plastisuus") ; --UNCHK
lin malleable_A = mkWA (k38 "mukautuvainen") ; --UNCHK
lin mallee_N = mkWN (k39 "eukalyptus") ; --UNCHK
lin mallet_N = mkWN (k10 "nuija") ; --UNCHK
lin malleus_N = mkWN (k12 "vasara") ; --UNCHK
lin mallow_N = mkWN (k9 "malva") ; --UNCHK
lin mallow_PN = foreignPN "Mallow" ;
lin malmsey_N = mkWN (compoundN "malv" (k12 "asia")) ; --UNCHK
lin malnourished_A = mkWA (k1A "aliravittu") ; --UNCHK
lin malnutrition_N = mkWN (compoundN "ali" (k39 "ravitsemus")) ; --UNCHK
lin malocclusion_N = mkWN (k9A "purentavika") ; --UNCHK
lin malodor_N = mkWN (k1 "haju") "myrkyllinen" ; --UNCHK
lin malodorous_A = mkWA (k38 "hajuinen") "epämiellyttävän" ; --UNCHK
lin malodorousness_N = mkWN (k10 "löyhkä") ; --UNCHK
lin malope_N = mkWN "Malope" "trifida" ; --UNCHK
lin malposed_A = mkWA (compoundA "virheasen" (k38 "toinen")) ; --UNCHK
lin malposition_N = mkWN (compoundN "virhe" (k1A "asento")) ; --UNCHK
lin malpractice_N = mkWN (compoundN "väärin" (k39 "käytös")) ; --UNCHK
lin malt_N = mkWN (k41A "mallas") ; --UNCHK
lin malt_V = mkWV (k53 "mallastaa") ; --UNCHK
lin malt_V2 = mkWV2 (k53 "mallastaa") ; --UNCHK
lin malta_PN = foreignPN "Malta" ;
lin maltby_PN = foreignPN "Maltby" ;
lin malted_N = mkWN (k1A "maito") "mallastettu" ; --UNCHK
lin malteseFem_N = mkWN (compoundN "maltan" (k10 "koira")) ; --UNCHK
lin malteseMasc_N = mkWN (compoundN "maltan" (k10 "koira")) ; --UNCHK
lin maltese_A = mkWA (compoundA "malt" (k38 "alainen")) ; --UNCHK
lin maltha_N = mkWN (compoundN "luonnon" (k6 "bitumi")) ; --UNCHK
lin malthusian_A = mkWA (compoundA "malthusi" (k38 "lainen")) ; --UNCHK
lin maltose_N = mkWN (k5 "maltoosi") ; --UNCHK
lin maltreat_V2 = mkWV2 (k67A "kohdella") "kaltoin" ; --UNCHK
lin maltreatment_N = mkWN (k2 "kohtelu") "huono" ; --UNCHK
lin maltster_N = mkWN "mallastaja" ; --UNCHK
lin malvasia_N = mkWN (compoundN "malvasia-" (k48 "rypäle")) ; --UNCHK
lin malvern_PN = foreignPN "Malvern" ;
lin malversation_N = mkWN (compoundN "virka" (k48 "virhe")) ; --UNCHK
lin mama_N = mkWN "Mama" ; --UNCHK
lin mamba_N = mkWN (k9 "mamba") ; --UNCHK
lin mambo_N = mkWN (k1 "mambo") ; --UNCHK
lin mamey_N = mkWN "Mammea" "americana" ; --UNCHK
lin mamma_N = mkWN (k10 "nisä") ; --UNCHK
lin mammal_N = mkWN (k38 "imettäväinen") ; --UNCHK
lin mammalian_A = mkWA "nisäkäs-" ; --UNCHK
lin mammalogist_N = mkWN (compoundN "nisäkäs" (k12 "tutkija")) ; --UNCHK
lin mammalogy_N = mkWN "mammalogia" ; --UNCHK
lin mammary_A = mkWA "nisä-" ; --UNCHK
lin mammogram_N = mkWN (compoundN "mammografia" (k10 "kuva")) ; --UNCHK
lin mammography_N = mkWN (k12 "mammografia") ; --UNCHK
lin mammon_N = mkWN (k11 "mammona") ; --UNCHK
lin mammoth_N = mkWN (k5A "mammutti") ; --UNCHK
lin mammothermography_N = mkWN (compoundN "lämpö" (k39 "kuvaus")) "maitorauhasen" ; --UNCHK
lin mammy_N = mkWN (k10 "äiskä") ; --UNCHK
lin man_N = L.man_N ;
lin man_V2 = mkWV2 (k53A "täyttää") ; --UNCHK
lin man_hour_N = mkWN "henkilötyötunti" ; --UNCHK
lin manacle_N = mkN "käsirauta" ; --plurale tantum
lin manacle_V2 = mkWV2 (k56A "laittaa") "käsiraudat" ; --UNCHK
lin manage_V = mkV "johtaa" ;
lin manage_V2 = mkV2 "johtaa" partitive ;
lin manage_VV = mkVVf (mkV "onnistua") infIllat ;
lin manageability_N = mkWN (k40 "käsiteltävyys") ; --UNCHK
lin manageable_A = mkWA "helposti" "käsiteltävä" ; --UNCHK
lin management_N = mkN "johto" ;
lin manager_N = mkN "johtaja" | mkWN (compoundN "esi" (k42 "mies")) ;
lin manageress_N = mkWN (k32A "johtajatar") ; --UNCHK
lin managerial_A = mkWA "liikkeenjohdollinen" ; --UNCHK
lin managership_N = mkWN (k40 "johtajuus") ; --UNCHK
lin managing_A = mkA "johtava" ;
lin manakin_N = mkWN (k12 "tanssija") ; --UNCHK
lin manana_N = mkWN (k40 "tulevaisuus") ; --UNCHK
lin manatee_N = mkWN "Trichechus" "manatus" ; --UNCHK
lin manchester_PN = foreignPN "Manchester" ;
lin mancunian_A = mkWA (compoundA "man" (k38 "chesteriläinen")) ; --UNCHK
lin mancunian_N = mkWN (compoundN "man" (k38 "chesteriläinen")) ; --UNCHK
lin mandala_N = mkWN (compoundN "mand" (k9 "ala")) ; --UNCHK
lin mandamus_N = mkWN (k39 "määräys") ; --UNCHK
lin mandarin_N = mkWN (k48A "murre") "Pekingin" ; --UNCHK
lin mandatary_N = mkWN (compoundN "toimeksi" (k10 "saaja")) ; --UNCHK
lin mandate_N = mkN "mandaatti" ;
lin mandate_V2 = mkWV2 (k53A "valtuuttaa") ; --UNCHK
lin mandate_VS = mkWVS (k53A "valtuuttaa") ; --UNCHK
lin mandator_N = mkWN (compoundN "toimeksi" (k10 "antaja")) ; --UNCHK
lin mandatory_A = mkA "pakollinen" ;
lin mandatory_N = mkWN (k40 "haureus") ; --UNCHK
lin mandible_N = mkWN (k9A "leuka") ; --UNCHK
lin mandibular_A = mkWA (compoundA "man" (k38 "dibulaarinen")) ; --UNCHK
lin mandibulate_A = mkWA "leuka-" ; --UNCHK
lin mandibulofacial_A = mkWA (compoundA "mandibulofasia" (k38 "alinen")) ; --UNCHK
lin mandola_N = mkWN "mandola" ; --UNCHK
lin mandolin_N = mkWN (k5 "mandoliini") ; --UNCHK
lin mandragora_N = mkWN (compoundN "Mandragora-" (k1A "suku")) ; --UNCHK
lin mandrake_N = mkWN (compoundN "lemmen" (k9 "marja")) ; --UNCHK
lin mandrill_N = mkWN (k5 "mandrilli") ; --UNCHK
lin mane_N = mkWN (k9 "harja") ; --UNCHK
lin maneuver_N = mkWN (k5 "manööveri") ; --UNCHK
lin maneuverability_N = mkWN (k40 "ohjattavuus") ; --UNCHK
lin maneuverable_A = mkWA (compoundA "ohjausky" (k38 "kyinen")) ; --UNCHK
lin maneuverer_N = mkWN (k4A "taktikko") ; --UNCHK
lin manful_A = mkWA (k38 "miesmäinen") ; --UNCHK
lin manfulness_N = mkWN (k40 "miehuullisuus") ; --UNCHK
lin mangabey_N = mkWN (compoundN "mang" (k5 "abi")) ; --UNCHK
lin manganate_N = mkWN (compoundN "manga" (k5A "naatti")) ; --UNCHK
lin manganese_N = mkWN (k5 "mangaani") ; --UNCHK
lin manganite_N = mkWN (compoundN "mang" (k5A "aniitti")) ; --UNCHK
lin mange_N = mkWN (k5 "kapi") ; --UNCHK
lin manger_N = mkWN (k2 "kaukalo") ; --UNCHK
lin mangle_N = mkWN (k6 "mankeli") ; --UNCHK
lin mangle_V2 = mkWV2 (k67 "tärvellä") ; --UNCHK
lin manglietia_N = mkWN (compoundN "Manglietia-" (k1A "suku")) ; --UNCHK
lin mango_N = mkWN (k1 "mango") ; --UNCHK
lin mangrove_N = mkWN (compoundN "mangrove" (k18 "puu")) ; --UNCHK
lin mangy_A = mkWA (k10 "kurja") ; --UNCHK
lin manhandle_V2 = mkWV2 (k67A "runnella") ; --UNCHK
lin manhattan_PN = foreignPN "Manhattan" ;
lin manhole_N = mkWN (compoundN "viemäri" (k1A "aukko")) ; --UNCHK
lin manhood_N = mkWN (k40 "miehuus") ; --UNCHK
lin manhunt_N = mkWN (k5A "ajojahti") ; --UNCHK
lin mania_N = mkWN (k9 "vimma") ; --UNCHK
lin maniac_N = mkWN (k1 "hullu") ; --UNCHK
lin maniacal_A = mkWA (k10 "raivoisa") ; --UNCHK
lin maniclike_A = mkWA (k38 "maaninen") ; --UNCHK
lin manicotti_N = mkWN "manicotti" ; --UNCHK
lin manicure_N = mkWN (k5 "manikyyri") ; --UNCHK
lin manicurist_N = mkWN (k5 "manikyristi") ; --UNCHK
lin manifest_A = mkWA (k10 "selvä") ; --UNCHK
lin manifest_N = mkWN (k2 "luettelo") ; --UNCHK
lin manifest_V2 = mkWV2 (k52 "ilmestyä") ; --UNCHK
lin manifestation_N = mkWN (compoundN "mielen" (k39 "osoitus")) ; --UNCHK
lin manifesto_N = mkWN (k5 "manifesti") ; --UNCHK
lin manifold_A = mkWA (k38 "moninainen") ; --UNCHK
lin manifold_N = mkWN (compoundN "jakelu" (k2 "putkisto")) ; --UNCHK
lin manifold_V2 = mkWV2 (k53 "monistaa") ; --UNCHK
lin manikin_N = mkWN (k5 "mannekiini") ; --UNCHK
lin manila_N = mkWN (compoundN "pää" (k5A "kaupunki")) "Filippiinien" ; --UNCHK
lin manila_PN = foreignPN "Manila" ;
lin manilla_N = mkWN (compoundN "kääre" (k6 "paperi")) ; --UNCHK
lin manipulability_N = mkWN (k40 "käsiteltävyys") ; --UNCHK
lin manipulate_V2 = mkWV2 (k62 "manipuloida") ; --UNCHK
lin manipulation_N = mkN "manipulointi" ; --WN (k1A "käyttö") ;
lin manipulative_A = mkWA (compoundA "manipu" (k10 "loiva")) ; --UNCHK
lin manipulator_N = mkWN (k10 "manipuloija") ; --UNCHK
lin maniraptor_N = mkWN (compoundN "peto" (k27 "käsi")) ; --UNCHK
lin mankind_N = mkWN (k13 "maailma") ; --UNCHK
lin manky_A = mkWA (k10 "kurja") ; --UNCHK
lin manlike_A = mkWA (k38 "miesmäinen") ; --UNCHK
lin manliness_N = mkWN (k40 "miehuullisuus") ; --UNCHK
lin manly_A = mkWA (k38 "miesmäinen") ; --UNCHK
lin manna_N = mkWN (k9 "manna") ; --UNCHK
lin mannequin_N = mkWN (k5 "mannekiini") ; --UNCHK
lin manner_N = mkN "tapa" ;
lin mannered_A = mkWA (k38 "teennäinen") ; --UNCHK
lin mannerism_N = mkWN (k40 "teennäisyys") ; --UNCHK
lin mannerly_A = mkWA (k41 "kohtelias") ; --UNCHK
lin mannheim_PN = foreignPN "Mannheim" ;
lin mannish_A = mkWA (k38 "miesmäinen") ; --UNCHK
lin mannitol_N = mkWN "Osmitrol" ; --UNCHK
lin manoeuvrability_N = mkWN (k40 "ohjattavuus") ; --UNCHK
lin manoeuvrable_A = mkWA (compoundA "ohjausky" (k38 "kyinen")) ; --UNCHK
lin manoeuvre_N = mkWN (k5 "manööveri") ; --UNCHK
lin manoeuvre_V = mkWV (k62 "operoida") ; --UNCHK
lin manoeuvre_V2 = mkWV2 (k62 "operoida") ; --UNCHK
lin manoeuvrer_N = mkWN (k4A "taktikko") ; --UNCHK
lin manometer_N = mkWN (k5 "manometri") ; --UNCHK
lin manor_N = mkWN (k2 "kartano") ; --UNCHK
lin manor_house_N = mkWN (k2 "kartano") ; --UNCHK
lin manorial_A = mkWA "kartanon" ; --UNCHK
lin manpower_N = mkWN (k2 "miehistö") ; --UNCHK
lin manque_A = mkWA (compoundA "men" (k1 "etetty")) ; --UNCHK
lin mansard_A = mkWA (compoundA "taite" (k1A "katto")) ; --UNCHK
lin mansard_N = mkWN (compoundN "taite" (k1A "katto")) ; --UNCHK
lin manse_N = mkWN (k12 "pappila") ; --UNCHK
lin manservant_N = mkWN (compoundN "mies" (k12 "palvelija")) ; --UNCHK
lin mansfield_PN = foreignPN "Mansfield" ;
lin mansion_N = mkWN (k5 "residenssi") ; --UNCHK
lin manslaughter_N = mkWN (k1A "tappo") ; --UNCHK
lin manta_N = mkWN (compoundN "paholais" (k1 "rausku")) ; --UNCHK
lin mantel_N = mkWN (compoundN "takka" (k1 "hylly")) ; --UNCHK
lin mantelet_N = mkWN (k13 "mantilja") ; --UNCHK
lin mantelpiece_N = mkWN (compoundN "takka" (k1 "hylly")) ; --UNCHK
lin manticore_N = mkWN (compoundN "mantik" (k48 "ori")) ; --UNCHK
lin mantilla_N = mkWN (k13 "mantilja") ; --UNCHK
lin mantis_N = mkWN (k9A "rukoilijasirkka") ; --UNCHK
lin mantispid_N = mkWN (compoundN "rukoilija" (k1A "korento")) ; --UNCHK
lin mantissa_N = mkWN (k9 "mantissa") ; --UNCHK
lin mantle_N = mkWN (k5A "keeppi") ; --UNCHK
lin mantle_V = mkWV (k74 "verhota") ; --UNCHK
lin mantle_V2 = mkWV2 (k74 "verhota") ; --UNCHK
lin mantra_N = mkWN (k9 "mantra") ; --UNCHK
lin mantrap_N = mkWN (k9 "ansa") ; --UNCHK
lin mantua_N = mkWN "mantua" ; --UNCHK
lin manual_A = mkA "manuaalinen" ;
lin manual_N = mkWN (compoundN "sulkeis" (k39 "harjoitus")) ; --UNCHK
lin manubrium_N = mkWN (k9 "kahva") "rintalastan" ; --UNCHK
lin manufacture_N = mkWN (k1A "tuotanto") ; --UNCHK
lin manufacture_V2 = mkV2 (lin VK {s = c53A "tuottaa"}) ;
lin manufacturer_N = mkWN (k10 "valmistaja") ; --f129
lin manufacturing_A = variants {} ; --
lin manufacturing_N = variants {} ; --
lin manul_N = mkWN (compoundN "aro" (k9 "kissa")) ; --UNCHK
lin manumission_N = mkWN (compoundN "manu" (k3 "missio")) ; --UNCHK
lin manumit_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin manure_N = mkWN (k10A "sonta") ; --UNCHK
lin manure_V2 = mkWV2 (k53A "levittää") "lantaa" ; --UNCHK
lin manuscript_N = mkWN (compoundN "käsi" (k39 "kirjoitus")) ; --UNCHK
lin manx_A = mkWA (compoundA "man" (k38 "saarelainen")) ; --UNCHK
lin manx_N = mkWN (compoundN "mansaaren" (k9 "kissa")) ; --UNCHK
lin many_Det = S.many_Det ;
lin manzanita_N = mkWN "Arbutus" "menziesii" ; --UNCHK
lin maoism_N = mkWN (k40 "maolaisuus") ; --UNCHK
lin maoist_N = mkWN (k38 "maolainen") ; --UNCHK
lin maori_N = mkN "maori" ;
lin map_N = mkWN (k9A "kartta") ; --UNCHK
lin map_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin map_out_V = mkWV (k67A "suunnitella") ; --UNCHK
lin mapinguari_N = mkWN "mapinguari" ; --UNCHK
lin maple_N = mkWN (k13 "vaahtera") ; --UNCHK
lin maplelike_A = mkWA (compoundA "vaahtera" (k38 "mainen")) ; --UNCHK
lin mapmaking_N = mkWN (k12 "kartografia") ; --UNCHK
lin mapping_N = mkWN (k39 "kartoitus") ; --UNCHK
lin maquiladora_N = mkWN (k41A "tehdas") ; --UNCHK
lin maquis_N = mkWN "Maquis" ; --UNCHK
lin mar_V2 = mkWV2 (k67 "turmella") ; --UNCHK
lin mara_N = mkWN (compoundN "pampa" (k39 "jänis")) ; --UNCHK
lin marabou_N = mkWN (k10A "sulka") "marabun" ; --UNCHK
lin maraca_N = mkWN (compoundN "mara" (k5 "kassi")) ; --UNCHK
lin maracaibo_PN = foreignPN "Maracaibo" ;
lin marang_N = mkWN "marang" ; --UNCHK
lin maranta_N = mkWN (k26 "arrowjuuri") ; --UNCHK
lin marasca_N = mkWN (compoundN "hapan" (k14A "kirsikka")) ; --UNCHK
lin maraschino_N = mkWN (compoundN "cocktail" (k14A "kirsikka")) ; --UNCHK
lin marasmus_N = mkWN (compoundN "aliravitsemus" (k9 "tila")) "vaikea" ; --UNCHK
lin marathon_N = mkWN (k5 "maraton") ; --UNCHK
lin marathoner_N = mkWN (k6 "maratoonari") ; --UNCHK
lin maraud_V = mkWV "ryöstellä" ; --UNCHK
lin marauder_N = mkWN (k10 "riistäjä") ; --UNCHK
lin marble_N = mkN "marmori" ; --mkWN (compoundN "marmori" (k10 "kuula")) ;
lin marbled_A = mkWA (compoundA "marmorikuvio" (k1A "itu")) ; --UNCHK
lin marbleization_N = mkWN (k9A "pinta") "marmorimainen" ; --UNCHK
lin marbles_N = mkWN (compoundN "marmorikuula" (k5 "peli")) ; --UNCHK
lin marblewood_N = mkWN "Diospyros" "kurzii" ; --UNCHK
lin marbling_N = mkWN (k5A "marmorointi") ; --UNCHK
lin marc_N = mkWN (compoundN "marc-" (k1 "brandy")) ; --UNCHK
lin marcel_N = mkWN "marcel" ; --UNCHK
lin march_V = mkWV (k52A "liittyä") "päittäin" ; --UNCHK
lin march_V2 = mkWV2 (k52A "liittyä") "päittäin" ; --UNCHK
lin marcher_N = mkWN (k12 "marssija") ; --UNCHK
lin marchioness_N = mkWN (k32A "markiisitar") ; --UNCHK
lin mardi_gras_N = mkWN (compoundN "laskiais" (k18 "tiistai")) ; --UNCHK
lin mare_N = mkWN (k9 "tamma") ; --UNCHK
lin margaret_PN = foreignPN "Margaret" ;
lin margarin_N = mkWN (k1 "öljy") ; --UNCHK
lin margarine_N = mkWN (k1 "öljy") ; --UNCHK
lin margarita_N = mkWN (compoundN "marga" (k9A "rita")) ; --UNCHK
lin margate_N = mkWN (compoundN "muri" (k9 "sija")) ; --UNCHK
lin margate_PN = foreignPN "Margate" ;
lin margay_N = mkWN (compoundN "pitkähäntä" (k9 "kissa")) ; --UNCHK
lin marge_N = mkWN (k1 "öljy") ; --UNCHK
lin margin_N = mkN "marginaali" ;
lin marginal_A = mkWA (k38 "marginaalinen") ; --UNCHK
lin marginality_N = mkWN (k40 "vähäpätöisyys") ; --UNCHK
lin marginalization_N = mkWN (k10A "väheksyntä") ; --UNCHK
lin marginalize_V2 = mkWV2 (k53A "jättää") "sivuun" ; --UNCHK
lin margrave_N = mkWN (compoundN "raja" (k5 "kreivi")) ; --UNCHK
lin marguerite_N = mkWN (k5 "krysanteemi") ; --UNCHK
lin maria_PN = foreignPN "Maria" ;
lin mariachi_N = mkWN (compoundN "mariachi-" (k6 "orkesteri")) ; --UNCHK
lin marie_PN = foreignPN "Marie" ;
lin marigold_N = mkWN (compoundN "sametti" (k10A "kukka")) ; --UNCHK
lin marihuana_N = mkWN (k11 "marihuana") ; --UNCHK
lin marimba_N = mkWN (k5 "ksylofoni") ; --UNCHK
lin marina_N = mkWN (compoundN "vene" (k10 "satama")) ; --UNCHK
lin marinade_N = mkWN (k5 "marinadi") ; --UNCHK
lin marinade_V2 = mkWV2 (k62 "marinoida") ; --UNCHK
lin marinara_N = mkWN "marinara" ; --UNCHK
lin marinate_V2 = mkWV2 (k62 "marinoida") ; --UNCHK
lin marine_A = mkWA (k38 "merellinen") ; --UNCHK
lin marine_N = mkWN (k41 "sotilas") "merijalkaväen" ; --UNCHK
lin mariner_N = mkWN (k14A "silakka") ; --UNCHK
lin marion_PN = foreignPN "Marion" ;
lin marionette_N = mkWN (k5A "marionetti") ; --UNCHK
lin mariposa_N = mkWN "Calochortus" ; --UNCHK
lin marital_A = mkWA (k38 "aviollinen") ; --UNCHK
lin mariticide_N = mkWN (compoundN "avio" (k10 "murha")) ; --UNCHK
lin maritime_A = mkWA "meri-" ; --UNCHK
lin marjoram_N = mkWN (k1 "oregano") ; --UNCHK
lin mark_N = mkN "merkki" ;
lin mark_V2 = mkWV2 (k53A "merkitä") ;
lin mark_V3 = mkV3 (mkV "merkitä") accusative (mkPrep allative) ; ---- sense
lin mark_down_V2 = mkWV2 (k54A "alentaa") "hintaa" ; --UNCHK
lin mark_down_as_V3 = variants {} ; -- guess-p-verb
lin mark_off_V2 = mkWV2 (k53A "linjoittaa") ; --UNCHK
lin mark_out_V2 = mkWV2 (k53A "linjoittaa") ; --UNCHK
lin mark_out_for_V3 = variants {} ; -- guess-p-verb
lin mark_out_from_V3 = variants {} ; -- guess-p-verb
lin mark_up_V2 = mkWV2 (k53A "korottaa") "hintaa" ; --UNCHK
lin marke_VS = mkVS "merkitä" ;
lin marked_A = mkWA "merkitty" ;
lin marker_N = mkWN (k5A "merkki") ; --UNCHK
lin market_1_N = mkN "tori" ;
lin market_2_N = mkN "markkina" ; ---- plural only
lin market_N = mkN "markkina" ;
lin market_V = mkWV (k62 "markkinoida") ;
lin market_V2 = mkWV2 (k62 "markkinoida") partitive ;
lin market_cross_N = mkWN (k5 "risti") "kauppatorin" ; --UNCHK
lin market_day_N = mkWN (compoundN "markkina" (k10 "päivä")) ; --UNCHK
lin market_garden_N = mkWN "kauppapuutarha" ; --UNCHK
lin market_gardening_N = mkWN (compoundN "puutarhan" (k2 "viljely")) ; --UNCHK
lin market_square_N = mkWN (k5 "tori") ; --UNCHK
lin market_town_N = mkWN (k12 "kauppala") ; --UNCHK
lin marketable_A = mkWA (compoundA "markkina" (k38 "kelpoinen")) ; --UNCHK
lin marketing_N = mkN (lin NK {s = d05A "markkinointi"}) ;
lin marketplace_N = mkN "markkinapaikka" ;
lin marking_N = mkWN "merkitseminen" ; --UNCHK
lin marking_ink_N = mkWN (compoundN "leimaus" (k48 "muste")) ; --UNCHK
lin markka_N = mkWN (k9A "markka") "Suomen" ; --UNCHK
lin marksman_N = mkWN (k50 "tarkka-ampuja") ; --UNCHK
lin marksmanship_N = mkWN (compoundN "ampuma" (k1A "taito")) ; --UNCHK
lin mark_up_N = mkWN (compoundN "oiko" (k1A "luku")) ; --UNCHK
lin marl_N = mkWN (compoundN "kalkki" (k1 "lieju")) ; --UNCHK
lin marlberry_N = mkWN (compoundN "panicu" (k9A "lata")) "Ardisia" ; --UNCHK
lin marlborough_PN = foreignPN "Marlborough" ;
lin marline_N = mkWN (k27 "köysi") ; --UNCHK
lin marlinespike_N = mkWN (compoundN "pujonta" (k1A "puikko")) ; --UNCHK
lin marlite_N = mkWN (compoundN "merkeli" (k7 "kivi")) ; --UNCHK
lin marlow_PN = foreignPN "Marlow" ;
lin marly_A = mkWA (compoundA "kalkki" (k38 "liejuinen")) ; --UNCHK
lin marmalade_N = mkWN (k5 "marmeladi") ; --UNCHK
lin marmite_N = mkWN (kH1 "pata") ; --UNCHK
lin marmoreal_A = mkWA (compoundA "marmori" (k38 "mainen")) ; --UNCHK
lin marmorean_A = mkWA (compoundA "marmori" (k38 "mainen")) ; --UNCHK
lin marmoset_N = mkWN (compoundN "silkki" (k12 "apina")) ; --UNCHK
lin marmot_N = mkWN (k6 "murmeli") ; --UNCHK
lin marocain_N = mkWN (compoundN "marocain-" (k41A "kreppikangas")) ; --UNCHK
lin maroon_A = mkWA (compoundA "puna" (k15 "ruskea")) ; --UNCHK
lin maroon_N = mkWN (compoundN "hätä" (k5A "raketti")) ; --UNCHK
lin marple_PN = foreignPN "Marple" ;
lin marque_N = mkWN (k5 "brändi") ; --UNCHK
lin marquee_N = mkWN (compoundN "teltta" (k39 "katos")) ; --UNCHK
lin marquess_N = mkWN (k5 "markiisi") ; --UNCHK
lin marquetry_N = mkWN (compoundN "koriste" (k39 "upotus")) ; --UNCHK
lin marquis_N = mkWN (k5 "markiisi") ; --UNCHK
lin marriage_N = mkN "avioliitto" ;
lin marriageability_N = mkWN (compoundN "naima" (k40 "kelpoisuus")) ; --UNCHK
lin marriageable_A = mkWA (compoundA "avioliitto" (k38 "kelpoinen")) ; --UNCHK
lin married_A = mkA "nainut" ;
lin married_A2 = L.married_A2 ;
lin married_N = mkWN (k38 "ihminen") "naimisissa" "oleva" ; --UNCHK
lin marrow_1_N = mkWN (compoundN "luu" (k33A "ydin")) ; --UNCHK
lin marrow_2_N = mkWN (compoundN "luu" (k33A "ydin")) ; --UNCHK
lin marrowbone_N = mkWN (compoundN "ydin" (k18 "luu")) ; --UNCHK
lin marry_V = mkV L.go_V "naimisiin" | mkV "avioitua" ;
lin marry_V2 = mkV2 "naida" ;
lin marry_in_V = advV OP_marry_V OP_in_Adv ; -- guess-p-verb
lin marry_out_V = advV OP_marry_V OP_out_Adv ; -- guess-p-verb
lin mars_PN = foreignPN "Mars" ;
lin marsala_N = mkWN (compoundN "Mar" (k9 "sala")) ; --UNCHK
lin marseillaise_N = mkWN "Marseljeesi" ; --UNCHK
lin marseille_N = mkWN (k41A "marseille-kangas") ; --UNCHK
lin marseilles_PN = foreignPN "Marseille" ;
lin marsh_N = mkWN (k1A "letto") ; --UNCHK
lin marshal_N = mkWN (compoundN "poliisi" (k6 "mestari")) ; --UNCHK
lin marshal_V2 = mkWV2 (k73 "kerätä") ; --UNCHK
lin marshalling_yard_N = mkWN "järjestelyratapiha" ; --UNCHK
lin marshalship_N = mkWN "šeriffiys" ; --UNCHK
lin marshmallow_N = mkWN (compoundN "vaahto" (k5 "karamelli")) ; --UNCHK
lin marshy_A = mkWA (k10 "vetelä") ; --UNCHK
lin marsupial_A = mkWA "pussi-" ; --UNCHK
lin marsupial_N = mkWN (compoundN "pussi" (k33 "eläin")) ; --UNCHK
lin marsupium_N = mkWN (k5 "pussi") ; --UNCHK
lin mart_N = mkWN (k5 "tori") ; --UNCHK
lin marten_N = mkWN (k10A "näätä") ; --UNCHK
lin martensite_N = mkWN "martensiitti" ; --UNCHK
lin martial_A = mkWA "sota-" ; --UNCHK
lin martian_A = mkWA (k38 "marsilainen") ; --UNCHK
lin martin_N = mkWN (k1 "pääsky") ; --UNCHK
lin martin_PN = foreignPN "Martin" ;
lin martinet_N = mkWN (k5 "moralisti") ; --UNCHK
lin martingale_N = mkWN (compoundN "vesi" (k39 "harus")) ; --UNCHK
lin martini_N = mkWN (k5 "martini") ; --UNCHK
lin marttila_PN = mkPN "Marttila" ;
lin martynia_N = mkWN "Martynia" "annua" ; --UNCHK
lin martyr_N = mkWN (k12 "kärsijä") ; --UNCHK
lin martyr_V2 = mkWV2 (k53A "kiduttaa") ; --UNCHK
lin martyrdom_N = mkWN (k40 "marttyyrius") ; --UNCHK
lin marumi_N = mkWN (k5A "kumkvatti") ; --UNCHK
lin marupa_N = mkWN "Simarouba" "amara" ; --UNCHK
lin marvel_N = mkWN (k48 "ihme") ; --UNCHK
lin marvel_V = mkWV (k67 "äimistellä") ; --UNCHK
lin marvel_VS = mkWVS (k67 "äimistellä") ; --UNCHK
lin marvellous_A = mkWA (k38 "ihmeellinen") ; --UNCHK
lin marxism_N = mkWN (k5 "marxismi") ; --UNCHK
lin marxistFem_N = mkWN (k5A "punikki") ; --UNCHK
lin marxistMasc_N = mkWN (k5A "punikki") ; --UNCHK
lin mary_PN = foreignPN "Mary" ;
lin maryport_PN = foreignPN "Maryport" ;
lin marzipan_N = mkWN (k5 "marsipaani") ; --UNCHK
lin mascara_N = mkWN (k12 "maskara") ; --UNCHK
lin mascarpone_N = mkWN "mascarpone" ; --UNCHK
lin mascot_N = mkWN (k5A "maskotti") ; --UNCHK
lin masculine_A = mkWA (k38 "miesmäinen") ; --UNCHK
lin masculine_N = mkWN (k5 "maskuliini") ; --UNCHK
lin masculinity_N = mkWN (k40 "miehekkyys") ; --UNCHK
lin masculinization_N = mkWN (compoundN "viri" (k38 "lisoituminen")) ; --UNCHK
lin masdevallia_N = mkWN "masdevallia" ; --UNCHK
lin maser_N = mkWN (compoundN "maser-" (k33 "vahvistin")) ; --UNCHK
lin mash_N = mkWN (k48A "ape") ; --UNCHK
lin mash_V2 = mkWV2 (k73 "muusata") ; --UNCHK
lin masher_N = mkWN (k33 "survin") ; --UNCHK
lin mashie_N = mkWN (compoundN "mas" (k48 "hie")) ; --UNCHK
lin masjid_N = mkWN (k12 "moskeija") ; --UNCHK
lin mask_N = mkN "naamio" ;
lin mask_V2 = mkWV2 (k52A "naamioitua") ; --UNCHK
lin masking_N = mkWN (k39 "suojaus") ; --UNCHK
lin masku_PN = mkPN "Masku" ;
lin masochism_N = mkWN (k5 "masokismi") ; --UNCHK
lin masochist_N = mkWN (k5 "masokisti") ; --UNCHK
lin masochistic_A = mkWA (k38 "masokistinen") ; --UNCHK
lin mason_N = mkWN (k50 "vapaamuurari") ; --UNCHK
lin masonic_A = mkWA "vapaamuurariuden" ; --UNCHK
lin masonry_N = mkWN (k39 "muuraus") ; --UNCHK
lin masquerade_N = mkWN (k2 "teeskentely") ; --UNCHK
lin masquerade_V = mkWV (k67A "teeskennellä") ; --UNCHK
lin masquerader_N = mkWN (compoundN "naamiais" (k12 "juhlija")) ; --UNCHK
lin mass_A = variants {} ; --
lin mass_1_N = mkWN (k1 "messu") ; --UNCHK
lin mass_2_N = mkWN (k1 "messu") ; --UNCHK
lin mass_3_N = mkWN (k1 "messu") ; --UNCHK
lin mass_V = mkWV (k52A "kokoontua") ; --UNCHK
lin mass_V2 = mkWV2 (k52A "kokoontua") ; --UNCHK
lin mass_produce_V2 = mkV2 "massatuottaa" ;
lin massachusetts_PN = mkPN "Massachusetts" ;
lin massacre_N = mkWN (k39 "teurastus") ; --UNCHK
lin massacre_V2 = mkWV2 (k73A "lahdata") ; --UNCHK
lin massage_N = mkWN (k9A "hieronta") ;
lin massage_V2 = mkWV2 (k52 "hieroa") ; --UNCHK
lin massager_N = mkWN (k10 "hieroja") ; --UNCHK
lin massasauga_N = mkWN "suokalkkarokäärme" ; --UNCHK
lin masse_N = mkWN (compoundN "massé-" (k5A "lyönti")) ; --UNCHK
lin masseter_N = mkWN (compoundN "purema" (k39 "lihas")) "ulompi" ; --UNCHK
lin masseur_N = mkWN (k10 "hieroja") "miespuolinen" ; --UNCHK
lin masseuse_N = mkWN (k10 "hieroja") "naispuolinen" ; --UNCHK
lin massicot_N = mkWN (compoundN "lyijy" (k48 "hilse")) ; --UNCHK
lin massif_N = mkWN (k5 "massiivi") ; --UNCHK
lin massive_A = mkA "massiivinen" ;
lin massiveness_N = mkWN (k40 "raskaus") ; --UNCHK
lin mast_N = mkWN (k1 "masto") ; --UNCHK
lin mastaba_N = mkWN (compoundN "hautaus" (k39 "rakennus")) ; --UNCHK
lin mastalgia_N = mkWN (compoundN "rintarauhas" (k1A "kipu")) ; --UNCHK
lin mastectomy_N = mkWN (compoundN "rinnan" (k1 "poisto")) ; --UNCHK
lin masted_A = mkWA (k38 "-mastoinen") ; --UNCHK
lin master_1_N = mkN "mestari" ;
lin master_2_N = mkN "maisteri" ;
lin master_N = mkN "mestari" ; ---ARB WN (k5 "originaali") ;
lin master_V2 = mkWV2 (k69 "hallita") ; --UNCHK
lin master_key_N = mkWN (compoundN "yleis" (k33 "avain")) ; --UNCHK
lin masterful_A = mkWA (k38 "virtuoosimainen") ; --UNCHK
lin mastering_N = mkWN "masterointi" ; --UNCHK
lin masterless_A = mkWA (k34A "isännätön") ; --UNCHK
lin masterly_A = mkWA (k38 "virtuoosimainen") ; --UNCHK
lin mastermind_N = mkWN (k4A "älykkö") ; --UNCHK
lin mastermind_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin masterpiece_N = mkWN (compoundN "taidon" (k48A "näyte")) ; --UNCHK
lin mastership_N = mkWN (k40 "herruus") ; --UNCHK
lin masterstroke_N = mkWN (compoundN "mestari" (k39 "suoritus")) ; --UNCHK
lin mastery_N = mkWN (k40 "herruus") ; --UNCHK
lin masthead_N = mkWN (compoundN "maston" (k1A "huippu")) ; --UNCHK
lin mastic_N = mkWN (compoundN "mastiksipistaasi" (k18 "puu")) ; --UNCHK
lin masticate_V2 = mkWV2 (k61 "pureksia") ; --UNCHK
lin mastication_N = mkWN (k2 "pureskelu") ; --UNCHK
lin mastiff_N = mkWN "mastiffi" ; --UNCHK
lin mastitis_N = mkWN (compoundN "maitorauhas" (k39 "tulehdus")) ; --UNCHK
lin mastoid_A = mkWA (compoundA "muis" (k10 "tuttava")) "nisää" ; --UNCHK
lin mastoid_N = mkWN (compoundN "kartio" (k48A "lisäke")) ; --UNCHK
lin mastoiditis_N = mkWN (k39 "tulehdus") "kartiolisäkkeen" ; --UNCHK
lin mastopathy_N = mkWN (compoundN "nisä" (k40 "sairaus")) ; --UNCHK
lin masturbate_V = mkWV (k53A "tyydyttää") "itsensä" ; --UNCHK
lin masturbate_V2 = mkWV2 (k53A "tyydyttää") "itsensä" ; --UNCHK
lin masturbation_N = mkWN (k5A "masturbointi") ; --UNCHK
lin masturbator_N = mkWN "onanoija" ; --UNCHK
lin mat_A = mkWA (k9A "matta") ; --UNCHK
lin mat_N = mkWN (k1A "matto") ; --UNCHK
lin mat_V = mkWV (k52 "vanua") ; --UNCHK
lin mat_V2 = mkWV2 (k52 "vanua") ; --UNCHK
lin matador_N = mkWN (k5 "matadori") ; --UNCHK
lin match_1_N = mkN "ottelu" | mkN "matsi" ;
lin match_2_N = mkN "tuli" (mkN "tikku") ;
lin match_3_N = mkN "yhteensopivuus" ;
lin match_N = mkN "vastine" ;
lin match_V2 = mkV2 (mkV "vastata") (casePrep partitive) ; --f60
lin match_point_N = mkWN (compoundN "ottelu" (k1 "pallo")) ; --UNCHK
lin match_up_V = advV (lin V OP_match_V2) OP_up_Adv ; -- guess-p-verb
lin matchboard_N = mkWN (compoundN "pontti" (k9A "lauta")) ; --UNCHK
lin matchbook_N = mkWN (compoundN "tulitikku" (k3 "kansio")) ; --UNCHK
lin matchbox_N = mkWN (compoundN "tulitikku" (k4A "laatikko")) ; --UNCHK
lin matchet_N = mkWN (compoundN "viidakko" (k30 "veitsi")) ; --UNCHK
lin matchlock_N = mkWN (k5A "musketti") ; --UNCHK
lin matchmaker_N = mkWN (k10 "naittaja") ; --UNCHK
lin matchmaking_N = mkWN (k39 "välitys") "naimakaupan" ; --UNCHK
lin matchstick_N = mkWN (compoundN "tuli" (k1A "tikku")) ; --UNCHK
lin matchweed_N = mkWN "Gutierrezia" ; --UNCHK
lin matchwood_N = mkWN (k48 "säpäle") ; --UNCHK
lin mateFem_1_N = variants {} ; ---- sense to be split
lin mateFem_2_N = variants {} ; ---- sense to be split
lin mateMasc_1_N = variants {} ; ---- sense to be split
lin mateMasc_2_N = variants {} ; ---- sense to be split
lin mate_1_N = mkN "kumppani" ;
lin mate_2_N = variants {} ; --
lin mate_N = mkWN (kH1 "matti") ; --UNCHK
lin mate_V = mkWV (k71 "tehdä") "matti" ; --UNCHK
lin mate_V2 = mkWV2 (k71 "tehdä") "matti" ; --UNCHK
lin mateless_A = mkWA (k34A "naimaton") ; --UNCHK
lin matelote_N = mkWN "sekakalamuhennos" ; --UNCHK
lin mater_N = mkWN (k5A "äiti") ; --UNCHK
lin material_A = mkWA (k38 "todellinen") ;
lin material_N = mkN "materiaali" ;
lin materialism_N = mkWN (k5 "materialismi") ; --UNCHK
lin materialist_N = mkWN (k5 "materialisti") ; --UNCHK
lin materialistic_A = mkWA (k38 "materialistinen") ; --UNCHK
lin materiality_N = mkWN (k40 "ruumiillisuus") ; --UNCHK
lin materialization_N = mkWN (k10 "aineistuma") ; --UNCHK
lin materialize_V = mkWV (k52A "materialisoitua") ; --UNCHK
lin materialize_V2V = mkWV2V (k52A "materialisoitua") ; --UNCHK
lin materiel_N = mkWN (k5 "arsenaali") ; --UNCHK
lin maternal_A = mkWA (k38 "isällinen") ; --UNCHK
lin maternalism_N = mkWN (k40 "äidillisyys") ; --UNCHK
lin maternalistic_A = mkWA (k38 "äidillinen") ; --UNCHK
lin maternity_N = mkWN (k40 "äidillisyys") ; --UNCHK
lin matey_A = mkWA (k99 "keskenään") "kamuja" ; --UNCHK
lin mathematical_A = mkWA (k38 "matemaattinen") ;
lin mathematicianFem_N = mkWN (k4A "matemaatikko") ; --UNCHK
lin mathematicianMasc_N = mkWN (k4A "matemaatikko") ; --UNCHK
lin mathematics_N = mkN "matematiikka" ; ---!! WN (kH1 "matikka") ;
lin maths_N = mkWN (kH1 "matikka") ; --UNCHK
lin matinee_N = mkWN (k12 "matinea") ; --UNCHK
lin matins_N = mkWN "aamujumalanpalvelus" ; --UNCHK
lin matlock_PN = foreignPN "Matlock" ;
lin matriarch_N = mkWN (k5A "äiti") "perheen" ; --UNCHK
lin matriarchal_A = mkWA (k38 "matriarkaalinen") ; --UNCHK
lin matriarchic_A = mkWA (compoundA "äidin" (k38 "valtainen")) ; --UNCHK
lin matriarchy_N = mkWN (k5A "matriarkaatti") ; --UNCHK
lin matric_N = mkWN (compoundN "pääsy" (k48A "koe")) ; --UNCHK
lin matricentric_A = mkWA (compoundA "äiti" (k38 "keskeinen")) ; --UNCHK
lin matricide_N = mkWN (compoundN "äidin" (k10 "murha")) ; --UNCHK
lin matriculate_N = mkWN (compoundN "korkeakoulu" (k12 "opiskelija")) ; --UNCHK
lin matriculate_V = mkWV (k52A "kirjoittautua") ; --UNCHK
lin matriculate_V2 = mkWV2 (k52A "kirjoittautua") ; --UNCHK
lin matriculation_N = mkWN (compoundN "pääsy" (k48A "koe")) ; --UNCHK
lin matrilineage_N = mkWN "äidinpuoleinen" "polveutuminen" ; --UNCHK
lin matrilineal_A = mkWA (compoundA "matri" (k38 "lineaarinen")) ; --UNCHK
lin matrimonial_A = mkWA (k38 "aviollinen") ; --UNCHK
lin matrimony_N = mkWN (compoundN "avio" (k1A "liitto")) ; --UNCHK
lin matrix_N = mkWN (compoundN "valu" (k5A "muotti")) ; --UNCHK
lin matron_N = mkWN (k10 "matroona") ; --UNCHK
lin matronly_A = mkWA (k38 "rouvamainen") ; --UNCHK
lin matronymic_N = mkWN (k5 "matronyymi") ; --UNCHK
lin matsyendra_N = mkWN "matsyendra" ; --UNCHK
lin matt_A = mkWA (k9A "matta") ; --UNCHK
lin matte_N = mkWN (k40 "himmeys") ; --UNCHK
lin matter_1_N = mkN "materia" | mkN "aine" ;
lin matter_2_N = mkN "ongelma" ;
lin matter_N = mkWN (k48 "aine") ;
lin matter_V = mkWV (k67 "olla") "merkitystä" ; --UNCHK
lin matter_of_fact_A = mkA "arkipäiväinen" ;
lin matting_N = mkWN (k39 "kehys") ; --UNCHK
lin mattock_N = mkWN (k10A "kuokka") ; --UNCHK
lin mattress_N = mkWN (k9 "patja") ; --UNCHK
lin maturate_V = mkWV (k61A "märkiä") ; --UNCHK
lin maturation_N = mkWN "märkiminen" ; --UNCHK
lin maturational_A = mkWA "kypsymis-" ; --UNCHK
lin mature_A = mkA "kypsä" ; --mkWA (compoundA "lentoky" (k38 "kyinen")) ;
lin mature_V = mkWV (k53A "kypsyttää") ; --UNCHK
lin mature_V2 = mkWV2 (k53A "kypsyttää") ; --UNCHK
lin maturity_1_N = variants {} ; --
lin maturity_2_N = variants {} ; --
lin maturity_3_N = mkN "kypsyys" ;
lin maturity_N = mkWN (k40 "kypsyys") ; --UNCHK
lin matutinal_A = mkWA "aamu-" ; --UNCHK
lin matzo_N = mkWN (k10A "leipä") "happamaton" ; --UNCHK
lin maud_PN = foreignPN "Maud" ;
lin maudlin_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin maul_N = mkWN (k6 "moukari") ; --UNCHK
lin maul_V2 = mkWV2 (k52 "runnoa") ; --UNCHK
lin mauler_N = mkWN "raatelija" ; --UNCHK
lin maulstick_N = mkWN (compoundN "tuki" (k5A "keppi")) ; --UNCHK
lin maund_N = mkWN "maund" ; --UNCHK
lin maunder_V = mkWV (k53A "pälättää") ; --UNCHK
lin maundy_thursday_N = mkWN (compoundN "kiiras" (k18 "torstai")) ; --UNCHK
lin mauritania_PN = foreignPN "Mauritania" ;
lin mauritanian_A = mkWA (compoundA "mauritius" (k38 "lainen")) ; --UNCHK
lin mauritanian_N = mkWN (compoundN "mauritani" (k38 "alainen")) ; --UNCHK
lin mauritian_A = mkWA (compoundA "mauritius" (k38 "lainen")) ; --UNCHK
lin mauritian_N = mkWN (compoundN "Mauritius" (k38 "lainen")) ; --UNCHK
lin mauritius_PN = foreignPN "Mauritius" ;
lin mausoleum_N = mkWN (k5 "mausoleumi") ; --UNCHK
lin mauve_A = mkWA (compoundA "malvan" (k38 "värinen")) ; --UNCHK
lin mauve_N = mkWN (compoundN "malvan" (k5 "väri")) ; --UNCHK
lin maverick_N = mkWN (k33 "eläin") "merkitsemätön" ; --UNCHK
lin mavis_N = mkWN (compoundN "laulu" (k41 "rastas")) ; --UNCHK
lin maw_N = mkWN (kH1 "turpa") ; --UNCHK
lin mawkish_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin mawkishness_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin max_N = mkWN (k9 "gamma") ; --UNCHK
lin max_out_V2 = mkWV2 (k53A "käyttää") "kokonaan" ; --UNCHK
lin maxi_A = mkWA (compoundA "maksi" (k38 "pituinen")) ; --UNCHK
lin maxi_N = mkWN (k48 "hame") "maksipituinen" ; --UNCHK
lin maxillaria_N = mkWN "maxillaria" ; --UNCHK
lin maxillary_A = mkWA (compoundA "maksi" (k38 "llaarinen")) ; --UNCHK
lin maxim_N = mkWN (k5 "maksiimi") ; --UNCHK
lin maximal_A = mkWA (k38 "maksimaalinen") ; --UNCHK
lin maximization_N = mkWN (k5A "maksimointi") ; --UNCHK
lin maximize_V2 = mkWV2 (k62 "maksimoida") ; --UNCHK
lin maximizing_A = mkWA (compoundA "maksim" (k10 "oiva")) ; --UNCHK
lin maximum_A = mkWA (k38 "maksimaalinen") ; --UNCHK
lin maximum_N = mkWN (k1 "taso") "paras" ; --UNCHK
lin may_1_VV = mkVV (mkV "saattaa") ;
lin may_2_VV = mkVV (mkV "saada") ;
lin may_beetle_N = mkWN (k50 "kovakuoriainen") ; --UNCHK
lin may_bug_N = mkWN (k50 "kovakuoriainen") ; --UNCHK
lin mayapple_N = mkWN (compoundN "happo" (k9 "marja")) ; --UNCHK
lin maybe_Adv = mkAdv "ehkä" ;
lin mayday_N = mkWN "Mayday" ; --UNCHK
lin mayeng_N = mkWN "Pterospermum" "acerifolium" ; --UNCHK
lin mayfield_PN = foreignPN "Mayfield" ;
lin mayfly_N = mkWN (k38 "surviainen") ; --UNCHK
lin mayhaw_N = mkWN (compoundN "ora" (k10 "pihlaja")) ; --UNCHK
lin mayhem_N = mkWN (k1 "tuho") ; --UNCHK
lin mayo_PN = foreignPN "Mayo" ;
lin mayonnaise_N = mkWN (k5 "majoneesi") ; --UNCHK
lin mayor_N = mkWN (k6 "pormestari") ;
lin mayoral_A = mkWA "pormestarin" ; --UNCHK
lin mayoralty_N = mkWN (compoundN "kaupungin" (k40 "johtajuus")) ; --UNCHK
lin mayoress_N = mkWN (k6 "pormestari") ; --UNCHK
lin maypole_N = mkWN (compoundN "juhannus" (k1A "salko")) ; --UNCHK
lin maypop_N = mkWN (compoundN "kärsimys" (k10A "kukka")) ; --UNCHK
lin mayweed_N = mkWN (k2 "sauramo") "konnan" ; --UNCHK
lin maze_N = mkWN (k5A "labyrintti") ; --UNCHK
lin mazed_A = mkWA (k10 "oleva") "pihalla" ; --UNCHK
lin mazer_N = mkWN (compoundN "juoma-" (k12 "astia")) ; --UNCHK
lin mazurka_N = mkWN (k14A "masurkka") ; --UNCHK
lin mb_N = mkWN (k5A "kandidaatti") "lääketieteen" ; --UNCHK
lin mc_N = mkWN (compoundN "mega" (k5 "hertsi")) ; --UNCHK
lin mccarthyism_N = mkWN (compoundN "mccarthy" (k5 "ismi")) ; --UNCHK
lin md_N = mkWN (k6 "tohtori") "lääketieteen" ; --UNCHK
lin mead_N = mkWN (k9 "sima") ; --UNCHK
lin meadow_N = mkWN (k1A "niitty") ; --UNCHK
lin meadowgrass_N = mkWN (k14A "nurmikka") ; --UNCHK
lin meadowlark_N = mkWN (k1 "kiuru") ; --UNCHK
lin meager_A = mkWA (k34A "riittämätön") ; --UNCHK
lin meagerness_N = mkWN (k40 "vajavaisuus") ; --UNCHK
lin meagre_A = mkWA (k34A "riittämätön") ; --UNCHK
lin meagreness_N = mkWN (k40 "vajavaisuus") ; --UNCHK
lin meal_N = mkN "ateria" "aterioita" ;
lin mealie_N = mkWN (compoundN "maissin" (k10 "tähkä")) ; --UNCHK
lin mealtime_N = mkWN (k9A "ruoka-aika") ; --UNCHK
lin mealworm_N = mkWN (compoundN "jauho" (k1A "mato")) ; --UNCHK
lin mealy_A = mkWA (k38 "jauhoinen") ; --UNCHK
lin mealy_bug_N = mkWN "villakilpikirva" ; --UNCHK
lin mealymouthed_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin mean_A = mkA "ilkeä" ; --mkWA (k38 "viheliäinen") ;
lin mean_N = mkWN (compoundN "keski" (k1 "arvo")) ;
lin mean_V2 = mkV2 "tarkoittaa" partitive ;
lin mean_V2V = mkV2V (mkV "tarkoittaa") (mkPrep genitive) infPresPart ;
lin mean_VS = mkVS (mkV "tarkoittaa") ;
lin mean_VV = mkVV (mkV "ajatella") ;
lin meander_N = mkWN (k2 "harhailu") ; --UNCHK
lin meander_V = mkWV (k67A "kaarrella") ; --UNCHK
lin meanderingly_Adv = mkWAdv "kiemuraisesti" ; --UNCHK
lin meanie_N = mkWN (k2 "henkilö") "epäystävällinen" ; --UNCHK
lin meaning_N = mkN "merkitys" ;
lin meaningful_A = mkWA (k41A "mielekäs") ;
lin meaningfulness_N = mkWN (k40 "mielekkyys") ; --UNCHK
lin meaningless_A = mkWA (k34A "merkityksetön") ; --UNCHK
lin meaninglessness_N = mkWN "merkityksettömyys" ; --UNCHK
lin meanness_N = mkWN (k2 "kitsastelu") ; --UNCHK
lin means_N = mkN "keino" | mkWN (k5 "konsti") ;
lin meanspiritedly_Adv = mkWAdv (k99 "ilkeästi") ; --UNCHK
lin meantime_Adv = mkWAdv "sillä" "aikaa" ; --UNCHK
lin meantime_N = mkWN (k5 "väli") ; --UNCHK
lin meanwhile_Adv = mkAdv "samaan aikaan" ; --f194
lin meany_N = mkWN (k2 "henkilö") "epäystävällinen" ; --UNCHK
lin measles_N = mkWN (compoundN "tuhka" (k1A "rokko")) ; --UNCHK
lin measly_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin measurable_A = mkWA (k10 "oleva") "mitattavissa" ; --UNCHK
lin measure_N = mkN "mitta" | mkN "keino" ; ---- split
lin measure_V = mkWV (k73A "mitata") ; --UNCHK
lin measure_V2 = mkWV2 (k73A "mitata") ;
lin measure_against_V3 = variants {} ; -- guess-p-verb
lin measure_off_V2 = prepV2 OP_measure_V OP_off_Prep ; -- guess-p-verb
lin measure_out_V2 = mkWV2 (k73A "mitata") ; --UNCHK
lin measure_up_V = mkWV (k53A "täyttää") "vaatimukset" ; --UNCHK
lin measure_up_V2 = mkWV2 (k53A "täyttää") "vaatimukset" ; --UNCHK
lin measure_up_to_V2 = prepV2 (advV OP_measure_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin measuredly_Adv = mkWAdv (k99 "rauhallisesti") ; --UNCHK
lin measureless_A = mkWA (k34A "ääretön") ; --UNCHK
lin measurement_N = mkWN (k9A "mitta") ; --UNCHK
lin measurer_N = mkWN (k10 "mittaaja") ; --UNCHK
lin meat_N = L.meat_N ;
lin meat_safe_N = mkWN (compoundN "liha" (k2 "varasto")) ; --UNCHK
lin meatball_N = mkWN (compoundN "liha" (k14A "pyörykkä")) ; --UNCHK
lin meatless_A = mkWA "lihaton" ; --UNCHK
lin meatpacking_N = mkWN (k39 "valmistus") "lihasäilykkeiden" ; --UNCHK
lin meatus_N = mkWN (k10 "käytävä") ; --UNCHK
lin meaty_A = mkWA (k10 "lihaisa") ; --UNCHK
lin mebendazole_N = mkWN "mebendatsoli" ; --UNCHK
lin mebibit_N = mkWN (compoundN "mebi" (k5A "bitti")) ; --UNCHK
lin mecca_N = mkWN "mekka" ; --UNCHK
lin mecca_PN = foreignPN "Mekka" ;
lin mechanic_A = mkWA (k38 "mekaaninen") ; --UNCHK
lin mechanic_N = mkWN (k4A "mekaanikko") ; --UNCHK
lin mechanical_A = mkWA (k38 "mekaaninen") ;
lin mechanics_N = mkWN (k9A "toiminta") ; --UNCHK
lin mechanism_N = mkWN (k9A "toiminta") ; --UNCHK
lin mechanist_N = mkWN (compoundN "meka" (k5 "nisti")) ; --UNCHK
lin mechanistic_A = mkWA (k38 "mekanistinen") ; --UNCHK
lin mechanistically_Adv = mkWAdv "mekanistisesti" ; --UNCHK
lin mechanization_N = mkWN (k3 "automaatio") ; --UNCHK
lin mechanize_V2 = mkWV2 (k62 "moottoroida") ; --UNCHK
lin meclofenamate_N = mkWN "Meclomen" ; --UNCHK
lin meconium_N = mkWN (compoundN "lapsen" (k9 "pihka")) ; --UNCHK
lin mecopteran_N = mkWN (k10 "kuuluva") "kärsäkorentoihin" ; --UNCHK
lin mecopterous_A = mkWA "kärsäkorennon" ; --UNCHK
lin med_N = mkWN (k6 "maisteri") "kasvatustieteen" ; --UNCHK
lin medal_N = mkWN (k1A "palkinto") ; --UNCHK
lin medalist_N = mkWN (k10 "voittaja") "mitalin" ; --UNCHK
lin medallion_N = mkWN (k1A "palkinto") ; --UNCHK
lin medallist_N = mkWN (k10 "voittaja") "mitalin" ; --UNCHK
lin medan_PN = foreignPN "Medan" ;
lin meddle_V = mkWV (k74 "kajota") ; --UNCHK
lin meddlesome_A = mkWA (k10 "tungetteleva") ; --UNCHK
lin meddling_N = mkWN (compoundN "kajo" (k38 "aminen")) ; --UNCHK
lin medellin_PN = foreignPN "Medellin" ;
lin media_N = mkN "media" ;
lin mediacy_N = mkWN (k40 "välillisyys") ; --UNCHK
lin mediaeval_A = mkWA (compoundA "keski" (k38 "aikainen")) ; --UNCHK
lin medial_A = mkWA (k38 "keskimmäinen") ; --UNCHK
lin median_A = mkWA (k38 "keskimmäinen") ;
lin median_N = mkN "mediaani" ;
lin mediant_N = mkWN "mediantti" ; --UNCHK
lin mediastinum_N = mkWN (compoundN "väli" (k12 "karsina")) ; --UNCHK
lin mediate_A = mkWA (compoundA "epä" (k10 "suora")) ; --UNCHK
lin mediate_V = mkWV (k61 "toimia") "välittäjänä" ; --UNCHK
lin mediate_V2 = mkWV2 (k61 "toimia") "välittäjänä" ; --UNCHK
lin mediation_N = mkWN (k2 "sovittelu") ; --UNCHK
lin mediator_N = mkWN (k12 "neuvottelija") ; --UNCHK
lin mediatorial_A = mkWA (k10 "sovitteleva") ; --UNCHK
lin mediatory_A = mkWA "sovittelu-" ; --UNCHK
lin mediatrix_N = mkWN (k12 "sovittelija") ; --UNCHK
lin medic_N = mkWN (compoundN "lääkintä" (k6 "upseeri")) ; --UNCHK
lin medical_A = mkA "lääketieteellinen" | mkWA (k38 "lääkinnällinen") ;
lin medical_N = mkWN (compoundN "lääkärin" (k39 "tarkastus")) ; --UNCHK
lin medicament_N = mkWN (k39 "lääkitys") ; --UNCHK
lin medicare_N = mkWN "Medicare" ; --UNCHK
lin medicate_V2 = mkWV2 (k53A "hoitaa") "lääkkeillä" ; --UNCHK
lin medication_N = mkN "lääkitys" ;
lin medicative_A = mkWA (k38 "lääkinnällinen") ; --UNCHK
lin medicinal_A = mkWA (k38 "lääkinnällinen") ; --UNCHK
lin medicine_N = mkWN (compoundN "lääke" (k48A "tiede")) ; --UNCHK
lin medicine_ball_N = mkWN (compoundN "kunto" (k1 "pallo")) ; --UNCHK
lin medicine_chest_N = mkWN (compoundN "lääke" (k5A "kaappi")) ; --UNCHK
lin medicine_man_N = mkWN (compoundN "poppa" (k42 "mies")) ; --UNCHK
lin medico_N = mkWN (k6 "tohtori") ; --UNCHK
lin medicolegal_A = mkWA "oikeuslääketieteellinen" ; --UNCHK
lin medieval_A = mkWA (compoundA "keski" (k38 "aikainen")) ; --UNCHK
lin medina_N = mkWN "medina" ; --UNCHK
lin mediocre_A = mkWA (compoundA "keski" (k38 "nkertainen")) ; --UNCHK
lin mediocrity_N = mkWN (k40 "keskinkertaisuus") ; --UNCHK
lin meditate_V = mkWV (k61 "tuumia") ; --UNCHK
lin meditate_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin meditation_N = mkWN (k2 "pohdiskelu") ; --UNCHK
lin meditative_A = mkWA (k10 "harkitseva") ; --UNCHK
lin mediterranean_A = mkWA "Välimeren" ; --UNCHK
lin medium_A = mkWA (compoundA "puoli" (k10 "kypsä")) ; --UNCHK
lin medium_N = mkN "välikappale" ; ----
lin medium_grade_A = mkA "keskiverto" ; ---- ?
lin medlar_N = mkWN (k6 "mispeli") ; --UNCHK
lin medley_N = mkWN (k10 "sikermä") ; --UNCHK
lin medroxyprogesterone_N = mkWN (compoundN "medroksi" (k5 "progesteroni")) ; --UNCHK
lin medulla_N = mkWN (compoundN "ydin" (k39 "kerros")) ; --UNCHK
lin medullary_A = mkWA "medullaarinen" ; --UNCHK
lin medusa_N = mkWN (k13 "meduusa") ; --UNCHK
lin medusoid_A = mkWA (compoundA "meduusa" (k38 "mainen")) ; --UNCHK
lin meed_N = mkWN (k1A "palkinto") ; --UNCHK
lin meek_A = mkWA (k10 "nöyrä") ; --UNCHK
lin meekness_N = mkWN (k40 "lauhkeus") ; --UNCHK
lin meerkat_N = mkWN "surikaatti" ; --UNCHK
lin meerschaum_N = mkWN (compoundN "merenvaha" (k1A "piippu")) ; --UNCHK
lin meet_N = mkWN (k9 "kisa") ; --UNCHK
lin meet_V = mkV "kokoontua" ;
lin meet_V2 = mkV2 "tavata" ;
lin meet_up_V = advV OP_meet_V OP_up_Adv ; -- guess-p-verb
lin meet_with_V2 = prepV2 OP_meet_V OP_with_Prep ; -- guess-p-verb
lin meeting_N = mkN "kokous" ;
lin meeting_house_N = mkWN (compoundN "kanadan" (k9 "akileija")) ; --UNCHK
lin meeting_place_N = mkWN (k39 "kokous") ; --UNCHK
lin mefloquine_N = mkWN "Mephaquine" ; --UNCHK
lin megabit_N = mkWN (compoundN "mega" (k5A "bitti")) ; --UNCHK
lin megabyte_N = mkWN (compoundN "mega" (k1 "tavu")) ; --UNCHK
lin megacolon_N = mkWN "megakoolon" ; --UNCHK
lin megacycle_N = mkWN (compoundN "mega" (k5 "hertsi")) ; --UNCHK
lin megadeath_N = mkWN "miljoona" "kuollutta" ; --UNCHK
lin megagametophyte_N = mkWN "megagametofyytti" ; --UNCHK
lin megahertz_N = mkWN (compoundN "mega" (k5 "hertsi")) ; --UNCHK
lin megakaryocyte_N = mkWN "megakaryosyytti" ; --UNCHK
lin megakaryocytic_A = mkWA (compoundA "mega" (k38 "karyosyyttinen")) ; --UNCHK
lin megalith_N = mkWN (compoundN "megaliitti" (k10 "rakennelma")) ; --UNCHK
lin megalithic_A = mkWA "megaliitti-" ; --UNCHK
lin megaloblast_N = mkWN (compoundN "megalob" (k5 "lasti")) ; --UNCHK
lin megaloblastic_A = mkWA (compoundA "mega" (k38 "loblastinen")) ; --UNCHK
lin megalocyte_N = mkWN "makrosyytti" ; --UNCHK
lin megalomania_N = mkWN (compoundN "suuruuden" (k40 "hulluus")) ; --UNCHK
lin megalomaniac_N = mkWN (k2 "henkilö") "suuruudenhullu" ; --UNCHK
lin megalomaniacal_A = mkWA (compoundA "suuruuden" (k1 "hullu")) ; --UNCHK
lin megalopolis_N = mkWN (k5 "megalopoli") ; --UNCHK
lin megalosaur_N = mkWN "megalosaurus" ; --UNCHK
lin megaphone_N = mkWN (k5 "megafoni") ; --UNCHK
lin megapode_N = mkWN (compoundN "isojalk" (k12 "akana")) ; --UNCHK
lin megascopic_A = mkWA "silmällä" "havaittava" ; --UNCHK
lin megasporangium_N = mkWN "macrosporangium" ; --UNCHK
lin megaspore_N = mkWN (compoundN "macros" (k48 "pore")) ; --UNCHK
lin megasporophyll_N = mkWN (compoundN "sporo" (k5 "fylli")) ; --UNCHK
lin megatherian_N = mkWN (compoundN "jättiläismaa" (k38 "laiskiainen")) ; --UNCHK
lin megaton_N = mkWN (compoundN "mega" (k5 "tonni")) ; --UNCHK
lin megawatt_N = mkWN (compoundN "mega" (k5A "watti")) ; --UNCHK
lin megestrol_N = mkWN (compoundN "megestroli" (k5A "asetaatti")) ; --UNCHK
lin megillah_N = mkWN "Megillah" ; --UNCHK
lin megilp_N = mkWN (k33A "kiinnitin") "väriaineen" ; --UNCHK
lin megohm_N = mkWN (compoundN "mega" (k5 "ohmi")) ; --UNCHK
lin megrim_N = mkWN (k5 "migreeni") ; --UNCHK
lin meiosis_N = mkWN (compoundN "lito" (k5 "teesi")) ; --UNCHK
lin meiotic_A = mkWA "meioottinen" ; --UNCHK
lin meitnerium_N = mkWN "järjestysluku" "109" ; --UNCHK
lin melagra_N = mkWN (k1A "kipu") ; --UNCHK
lin melamine_N = mkWN (k5 "melamiini") ; --UNCHK
lin melancholia_N = mkWN (k12 "melankolia") ; --UNCHK
lin melancholic_A = mkWA (k15 "apea") ; --UNCHK
lin melancholic_N = mkWN (k4A "melankolikko") ; --UNCHK
lin melancholy_A = mkWA (k10 "vakava") ; --UNCHK
lin melancholy_N = mkWN (k12 "melankolia") ; --UNCHK
lin melange_N = mkWN (k9 "kama") ; --UNCHK
lin melanin_N = mkWN (k5 "melaniini") ; --UNCHK
lin melanoblast_N = mkWN (compoundN "melanob" (k5 "lasti")) ; --UNCHK
lin melanocyte_N = mkWN "melanosyytti" ; --UNCHK
lin melanoderma_N = mkWN "melanodermia" ; --UNCHK
lin melanoma_N = mkWN (k10 "melanooma") ; --UNCHK
lin melanosis_N = mkWN (compoundN "melan" (k5 "ismi")) ; --UNCHK
lin melatonin_N = mkWN (k5 "melatoniini") ; --UNCHK
lin melbourne_PN = foreignPN "Melbourne" ;
lin meld_V2 = mkWV2 (k52A "sulautua") ; --UNCHK
lin melee_N = mkWN (k14A "nujakka") ; --UNCHK
lin melilotus_N = mkWN (k14A "mesikkä") ; --UNCHK
lin meliorate_V = mkWV (k52A "parantua") ; --UNCHK
lin meliorate_V2 = mkWV2 (k52A "parantua") ; --UNCHK
lin melioration_N = mkWN (k39 "parannus") ; --UNCHK
lin meliorism_N = mkWN (compoundN "melior" (k5 "ismi")) ; --UNCHK
lin melksham_PN = foreignPN "Melksham" ;
lin mellifluous_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin mellilä_PN = mkPN "Mellilä" ;
lin mellow_A = mkWA (k10 "oleva") "pilvessä" ; --UNCHK
lin mellow_V = mkWV (k54A "pehmentää") ; --UNCHK
lin mellow_V2 = mkWV2 (k54A "pehmentää") ; --UNCHK
lin mellowing_N = mkWN "kypsyminen" ; --UNCHK
lin mellowingly_Adv = mkWAdv "pehmentäen" ; --UNCHK
lin mellowness_N = mkWN (k40 "rentous") ; --UNCHK
lin melodic_A = mkWA (k38 "melodinen") ; --UNCHK
lin melodious_A = mkWA (k38 "melodinen") ; --UNCHK
lin melodiousness_N = mkWN (k40 "melodisuus") ; --UNCHK
lin melodrama_N = mkWN (compoundN "melo" (k9 "draama")) ; --UNCHK
lin melodramatic_A = mkWA (compoundA "melo" (k38 "dramaattinen")) ; --UNCHK
lin melody_N = mkWN (k10 "sävelmä") ; --UNCHK
lin melon_N = mkWN (k6 "meloni") ; --UNCHK
lin melt_V = mkWV (k52A "haihtua") ; --UNCHK
lin melt_V2 = mkWV2 (k52A "haihtua") ; --UNCHK
lin melt_down_V2 = mkWV2 (k53 "sulaa") ; --UNCHK
lin meltable_A = mkWA (k10 "sulava") ; --UNCHK
lin meltdown_N = mkWN (k39 "romahdus") ; --UNCHK
lin melter_N = mkWN "sulattaja" ; --UNCHK
lin meltham_PN = foreignPN "Meltham" ;
lin melting_point_N = mkWN (compoundN "sulamis" (k48 "piste")) ; --UNCHK
lin melting_pot_N = mkWN (k41A "upokas") ; --UNCHK
lin meltwater_N = mkWN (k50 "sulavesi") ; --UNCHK
lin mem_N = mkWN "mem" ; --UNCHK
lin member_N = mkN "jäsen" ;
lin membered_A = mkWA "renkainen" ; --UNCHK
lin memberless_A = mkWA "jäsenetön" ; --UNCHK
lin membership_N = mkN "jäsenyys" ;
lin membrane_N = mkWN (k1 "kalvo") ; --UNCHK
lin membranous_A = mkWA "kalvo-" ; --UNCHK
lin meme_N = mkWN "meemi" ; --UNCHK
lin memento_N = mkWN (k1 "muisto") ; --UNCHK
lin memo_N = mkWN (k1A "mietintö") ; --UNCHK
lin memoir_N = mkWN (k10 "tutkielma") ; --UNCHK
lin memorabilia_N = mkWN (compoundN "muistelma" (k39 "teos")) ; --UNCHK
lin memorability_N = mkWN "muistettavuus" ; --UNCHK
lin memorable_A = mkWA (compoundA "ikimuis" (k38 "toinen")) ; --UNCHK
lin memorandum_N = mkWN (k1A "mietintö") ;
lin memorial_N = mkWN (k5A "monumentti") ; --UNCHK
lin memorialize_V2 = mkWV2 (k53A "säilyttää") "jälkipolville" ; --UNCHK
lin memorization_N = mkWN (compoundN "ope" (k38 "tteleminen")) "ulkoa" ; --UNCHK
lin memorize_V2 = mkWV2 (k56 "painaa") "muistiin" ; --UNCHK
lin memorizer_N = mkWN "ulkoa" "opettelija" ; --UNCHK
lin memory_N = mkWN (k5 "muisti") ;
lin memphis_PN = foreignPN "Memphis" ;
lin memsahib_N = mkWN "memsahib" ; --UNCHK
lin menace_N = mkWN (k10 "uhka") ; --UNCHK
lin menace_V2 = mkWV2 (k73A "uhata") ; --UNCHK
lin menacingly_Adv = mkWAdv (k99 "uhkaavasti") ; --UNCHK
lin menage_N = mkWN (k48 "perhe") ; --UNCHK
lin menagerie_N = mkWN (compoundN "eläin" (k9 "tarha")) ; --UNCHK
lin menarche_N = mkWN "menarke" ; --UNCHK
lin mend_N = mkWN (k1A "huolto") ; --UNCHK
lin mend_V = mkWV (k62 "entisöidä") ; --UNCHK
lin mend_V2 = mkWV2 (k62 "entisöidä") ; --UNCHK
lin mendacious_A = mkWA "valehteleva" ; --UNCHK
lin mendacity_N = mkWN (k40 "valheellisuus") ; --UNCHK
lin mendelevium_N = mkWN "järjestysluku" "101" ; --UNCHK
lin mendelian_A = mkWA (compoundA "Mend" (k33 "elin")) ; --UNCHK
lin mender_N = mkWN (k10 "korjaaja") ; --UNCHK
lin mendicant_A = mkWA "kerjäläis-" ; --UNCHK
lin mendicant_N = mkWN (k38 "kerjäläinen") ; --UNCHK
lin mending_N = mkWN (k1A "huolto") ; --UNCHK
lin menhir_N = mkWN (compoundN "pysty" (k7 "kivi")) ; --UNCHK
lin menial_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin menial_N = mkWN (k12 "palvelija") ; --UNCHK
lin meningeal_A = mkWA (compoundA "meningea" (k38 "alinen")) ; --UNCHK
lin meningioma_N = mkWN (compoundN "aivokalvo" (k33 "kasvain")) ; --UNCHK
lin meningism_N = mkWN (compoundN "niska" (k40 "jäykkyys")) ; --UNCHK
lin meningitis_N = mkWN (compoundN "aivokalvo" (k39 "tulehdus")) ; --UNCHK
lin meningocele_N = mkWN (compoundN "meningose" (k48 "ele")) ; --UNCHK
lin meninx_N = mkWN (k1 "kalvo") ; --UNCHK
lin meniscectomy_N = mkWN (k1 "poisto") "nivelkierukan" ; --UNCHK
lin meniscus_N = mkWN "meniscus" ; --UNCHK
lin menopausal_A = mkWA (compoundA "vaihdevuos" (k32A "ien")) ; --UNCHK
lin menopause_N = mkWN (k5 "menopaussi") ; --UNCHK
lin menorah_N = mkWN (compoundN "men" (k10 "ora")) ; --UNCHK
lin menorrhagia_N = mkWN (compoundN "kuukautis" (k1A "vuoto")) "runsas" ; --UNCHK
lin menorrhea_N = mkWN (compoundN "kuukautis" (k1A "vuoto")) ; --UNCHK
lin mensal_A = mkWA (k1A "käytetty") "ruokapöydässä" ; --UNCHK
lin mensch_N = mkWN (k38 "ihminen") "hyvä" ; --UNCHK
lin menstrual_A = mkWA (compoundA "menstrua" (k38 "alinen")) ; --UNCHK
lin menstruate_V = mkWV (k67 "olla") "kuukautiset" ; --UNCHK
lin menstruation_N = mkWN (k3 "menstruaatio") ; --UNCHK
lin menstruum_N = mkWN (k3 "menstruaatio") ; --UNCHK
lin mensurable_A = mkWA (k10 "oleva") "mitattavissa" ; --UNCHK
lin mensural_A = mkWA (k38 "rytminen") ; --UNCHK
lin mensuration_N = mkWN (k9A "mitta") ; --UNCHK
lin mental_A = mkA "henkinen" | mkWA (k38 "psyykkinen") ;
lin mentalism_N = mkWN (k5 "mentalismi") ; --UNCHK
lin mentality_N = mkWN (k40 "älykkyys") ; --UNCHK
lin menthol_N = mkWN (compoundN "mentoli" (k48A "voide")) ; --UNCHK
lin mentholated_A = mkWA (compoundA "mentolipi" (k38 "toinen")) ; --UNCHK
lin mention_N = mkWN (compoundN "kunnia" (k9A "maininta")) ; --UNCHK
lin mention_V = mkV "mainita" ;
lin mention_V2 = mkV2 "mainita" ;
lin mention_VS = mkVS "mainita" ;
lin mentor_N = mkWN (k10 "ohjaaja") ; --UNCHK
lin mentum_N = mkWN (compoundN "leuan" (k7A "kärki")) ; --UNCHK
lin menu_N = mkWN (k10 "ohjelma") ; ---ARB --mkN "valikko" ; --mkN "ruokalista" ;
lin meopham_PN = foreignPN "Meopham" ;
lin meow_N = mkWN (k9A "nau'unta") ; --UNCHK
lin meperidine_N = mkWN "Demerol" ; --UNCHK
lin mephenytoin_N = mkWN "Mesantoin" ; --UNCHK
lin mephistophelian_A = mkWA (k38 "saatanallinen") ; --UNCHK
lin mephitis_N = mkWN (compoundN "Mephitis-" (k1A "suku")) ; --UNCHK
lin meprobamate_N = mkWN "Meprin" ; --UNCHK
lin meralgia_N = mkWN (compoundN "reisi" (k1A "särky")) ; --UNCHK
lin merbromine_N = mkWN "Mercurochrome" ; --UNCHK
lin mercantile_A = mkWA (k38 "merkantiilinen") ; --UNCHK
lin mercantilism_N = mkWN (k40 "kaupallisuus") ; --UNCHK
lin mercaptopurine_N = mkWN "Purinethol" ; --UNCHK
lin mercenary_A = mkWA (k10 "tuottoisa") ; --UNCHK
lin mercenary_N = mkWN (compoundN "palkka" (k6 "soturi")) ; --UNCHK
lin mercer_N = mkWN (k41 "kauppias") ; --UNCHK
lin mercerize_V2 = mkWV2 (k62 "merseroida") ; --UNCHK
lin merchandise_N = mkN "kauppatavara" ;
lin merchant_N = mkWN (k41 "kauppias") ;
lin merchantability_N = mkWN (compoundN "myynti" (k40 "kelpoisuus")) ; --UNCHK
lin merchantman_N = mkWN (compoundN "kauppa-" (k39 "alus")) ; --UNCHK
lin merciful_A = mkWA (k41 "armelias") ; --UNCHK
lin mercifulness_N = mkWN (k1 "armo") ; --UNCHK
lin merciless_A = mkWA (k34A "säälimätön") ; --UNCHK
lin mercilessness_N = mkWN (k40 "säälimättömyys") ; --UNCHK
lin mercurial_A = mkWA "elohopeapitoinen" ; --UNCHK
lin mercuric_A = mkWA (compoundA "elohopea" (k38 "mainen")) ; --UNCHK
lin mercury_N = mkWN (compoundN "elo" (k15 "hopea")) ; --UNCHK
lin mercury_PN = foreignPN "Mercury" ;
lin mercy_N = mkWN (k1 "armo") ; --UNCHK
lin mere_A = mkWA (k10A "pelkkä") ; --f64
lin mere_N = mkWN (k7A "lampi") ; --UNCHK
lin merestone_N = mkWN (k5A "rajapyykki") ; --UNCHK
lin meretricious_A = mkWA (k34A "siveetön") ; --UNCHK
lin meretriciousness_N = mkWN (k40 "mauttomuus") ; --UNCHK
lin merganser_N = mkWN (k2 "koskelo") ; --UNCHK
lin merge_V = mkV "yhdistyä" ;
lin merge_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin merger_N = mkWN (k3 "fuusio") ; --f154
lin merging_N = mkWN (compoundN "pää" (k38 "seminen")) "yksimielisyyteen" ; --UNCHK
lin mericarp_N = mkWN (k39 "hedelmys") ; --UNCHK
lin meridian_A = mkWA "keskipäivän" ; --UNCHK
lin meridian_N = mkWN (k5 "meridiaani") ; --UNCHK
lin meridional_A = mkWA "meridiaani-" ; --UNCHK
lin merijärvi_PN = mkPN (mkN "Merijärvi" "Merijärviä") ;
lin merikarvia_PN = mkPN "Merikarvia" ;
lin merimasku_PN = mkPN "Merimasku" ;
lin meringue_N = mkWN (k5A "marenki") ; --UNCHK
lin merino_N = mkWN (k2 "merino") ; --UNCHK
lin merino_sheep_N = mkWN (k2 "merino") ; --UNCHK
lin meristem_N = mkWN (compoundN "kasvu" (k4A "solukko")) ; --UNCHK
lin merit_N = mkWN (k3 "ansio") ; --UNCHK
lin merit_V2 = mkWV2 (k69 "ansaita") ; --UNCHK
lin meritocracy_N = mkWN (k12 "meritokratia") ; --UNCHK
lin meritocratic_A = mkWA (k38 "meritokraattinen") ; --UNCHK
lin meritorious_A = mkWA (k41A "kunniakas") ; --UNCHK
lin mermaid_N = mkWN (compoundN "meren" (k1A "neito")) ; --UNCHK
lin merman_N = mkWN (k38 "vetehinen") ; --UNCHK
lin meromelia_N = mkWN "meromelia" ; --UNCHK
lin meronym_N = mkWN (compoundN "osa" (k48A "käsite")) ; --UNCHK
lin meronymy_N = mkWN (compoundN "osakäsitte" (k40 "isyys")) "merkityksen" ; --UNCHK
lin merozoite_N = mkWN "merotsoiitti" ; --UNCHK
lin merriment_N = mkWN (k40 "hauskuus") ; --UNCHK
lin merry_A = mkWA (k15 "nopea") ; --UNCHK
lin merry_christmas_Interj = mkInterj "hyvää joulua" ;
lin merrymaker_N = mkWN (k12 "juhlija") ; --UNCHK
lin merton_PN = foreignPN "Merton" ;
lin mesa_N = mkWN "Mesa" ; --UNCHK
lin mesalliance_N = mkWN (compoundN "avio" (k1A "liitto")) "epäsäätyinen" ; --UNCHK
lin mescal_N = mkWN "mezcal" ; --UNCHK
lin mescaline_N = mkWN (k5 "meskaliini") ; --UNCHK
lin mesenchyme_N = mkWN "alkeistukikudos" ; --UNCHK
lin mesenteric_A = mkWA "mesenteerinen" ; --UNCHK
lin mesentery_N = mkWN (compoundN "suoli" (k48A "lieve")) ; --UNCHK
lin mesh_N = mkWN (k39 "lukitus") ; --UNCHK
lin mesh_V = mkWV (k53A "sovittaa") ; --UNCHK
lin mesh_V2 = mkWV2 (k53A "sovittaa") ; --UNCHK
lin meshugaas_N = mkWN (k40 "hulluus") ; --UNCHK
lin meshugge_A = mkWA (k34A "älytön") ; --UNCHK
lin meshuggeneh_N = mkWN (k1 "hullu") ; --UNCHK
lin mesial_A = mkWA (compoundA "mesia" (k38 "alinen")) ; --UNCHK
lin mesic_A = mkWA (k15 "kostea") ; --UNCHK
lin mesmeric_A = mkWA (k10 "lumoava") ; --UNCHK
lin mesmerism_N = mkWN (k3 "suggestio") ; --UNCHK
lin mesmerist_N = mkWN (k10 "saattaja") "hypnoosiin" ; --UNCHK
lin mesmerize_V2 = mkWV2 (k53A "ottaa") "valtoihinsa" ; --UNCHK
lin mesoblastic_A = mkWA (compoundA "mesoderma" (k38 "alinen")) ; --UNCHK
lin mesocarp_N = mkWN (compoundN "hedelmä" (k9 "liha")) ; --UNCHK
lin mesocolon_N = mkWN "mesokoolon" ; --UNCHK
lin mesoderm_N = mkWN (compoundN "keski" (k39 "kerros")) "alkion" ; --UNCHK
lin mesolithic_A = mkWA "mesoliittinen" ; --UNCHK
lin mesomorph_N = mkWN "mesomorfi" ; --UNCHK
lin mesomorphic_A = mkWA (k41A "lihaksikas") ; --UNCHK
lin meson_N = mkWN (k5 "mesoni") ; --UNCHK
lin mesonic_A = mkWA "mesoni-" ; --UNCHK
lin mesophyte_N = mkWN "mesofyytti" ; --UNCHK
lin mesophytic_A = mkWA "mesofyyttinen" ; --UNCHK
lin mesosphere_N = mkWN (compoundN "mesosf" (k26 "ääri")) ; --UNCHK
lin mesothelioma_N = mkWN (compoundN "mesotelio" (k10 "oma")) ; --UNCHK
lin mesquite_N = mkWN (compoundN "mesquito" (k18 "puu")) ; --UNCHK
lin mess_N = mkWN (k6 "kanttiini") ; --UNCHK
lin mess_V = mkWV (k67 "tärvellä") ; --UNCHK
lin mess_V2 = mkWV2 (k67 "tärvellä") ; --UNCHK
lin mess_about_V = mkWV (k52A "roikkua") ; --UNCHK
lin mess_about_V2 = mkWV2 (k52A "roikkua") ; --UNCHK
lin mess_around_V = mkWV (k67 "pelleillä") ; --UNCHK
lin mess_around_V2 = mkWV2 (k67 "pelleillä") ; --UNCHK
lin mess_jacket_N = mkWN (k5A "takki") "juhlapuvun" ; --UNCHK
lin mess_up_V2 = mkWV2 (k67 "tärvellä") ; --UNCHK
lin message_N = mkN "viesti" ;
lin messaging_N = mkWN (compoundN "sanoma" (k48A "liikenne")) "sähköinen" ; --UNCHK
lin messenger_N = mkN "viestinviejä" ;
lin messiah_N = mkWN "Messias" ; --UNCHK
lin messiahship_N = mkWN (k10 "asema") "messiaan" ; --UNCHK
lin messianic_A = mkWA (k38 "messiaaninen") ; --UNCHK
lin messina_PN = foreignPN "Messina" ;
lin messiness_N = mkWN (k40 "sotkuisuus") ; --UNCHK
lin messmate_N = mkWN (compoundN "laiva" (k6 "toveri")) ; --UNCHK
lin messuage_N = mkWN "asuinrakennus" "tontteineen" ; --UNCHK
lin messy_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin mestiza_N = mkWN (k5 "mestitsi") ; --UNCHK
lin mestizo_N = mkWN (k5 "mestitsi") ; --UNCHK
lin mestranol_N = mkWN "mestranoli" ; --UNCHK
lin metabolic_A = mkWA (k38 "metabolinen") ; --UNCHK
lin metabolism_N = mkWN (k12 "metabolia") ; --UNCHK
lin metabolite_N = mkWN (compoundN "aineenvaihdunta" (k48A "tuote")) ; --UNCHK
lin metabolize_V2 = mkWV2 "metaboloida" ; --UNCHK
lin metacarpal_A = mkWA (compoundA "metakarpa" (k38 "alinen")) ; --UNCHK
lin metacarpal_N = mkWN (compoundN "kämmen" (k18 "luu")) ; --UNCHK
lin metacarpus_N = mkWN (k32 "kämmen") ; --UNCHK
lin metacenter_N = mkWN "metasentri" ; --UNCHK
lin metacentric_A = mkWA "metasentrinen" ; --UNCHK
lin metadata_N = mkWN (compoundN "meta" (k1A "tieto")) ; --UNCHK
lin metagenesis_N = mkWN (compoundN "sukupolven" (k2 "vuorottelu")) ; --UNCHK
lin metagrobolized_A = mkWA (k99 "ymmällään") ; --UNCHK
lin metaknowledge_N = mkWN (compoundN "meta" (k1A "tieto")) ; --UNCHK
lin metal_N = mkWN (k5 "metalli") ;
lin metal_V2 = mkWV2 (k53 "päällystää") "metallilla" ; --UNCHK
lin metalanguage_N = mkWN (compoundN "meta" (k26 "kieli")) ; --UNCHK
lin metalepsis_N = mkWN "metalepsis" ; --UNCHK
lin metalhead_N = mkWN "hevari" ; --UNCHK
lin metallic_A = mkWA (k38 "metallinen") ; --UNCHK
lin metallic_N = mkWN (compoundN "metalli" (k9A "lanka")) ; --UNCHK
lin metallike_A = mkWA (k38 "metallimainen") ; --UNCHK
lin metalloid_A = mkWA "puolimetalli-" ; --UNCHK
lin metallurgical_A = mkWA (k38 "metallurginen") ; --UNCHK
lin metallurgist_N = mkWN (k5 "metallurgi") ; --UNCHK
lin metallurgy_N = mkWN (k12 "metallurgia") ; --UNCHK
lin metalwork_N = mkWN (compoundN "metalli" (k19 "työ")) ; --UNCHK
lin metalworker_N = mkWN (k10A "seppä") ; --UNCHK
lin metalworking_N = mkWN (compoundN "metalli" (k19 "työ")) ; --UNCHK
lin metamathematics_N = mkWN (compoundN "meta" (k9A "matematiikka")) ; --UNCHK
lin metamere_N = mkWN (compoundN "alku" (k48A "jaoke")) ; --UNCHK
lin metameric_A = mkWA (k38 "jaokkeinen") ; --UNCHK
lin metamorphic_A = mkWA (compoundA "met" (k38 "amorfinen")) ; --UNCHK
lin metamorphism_N = mkWN (compoundN "metamorf" (k5 "ismi")) ; --UNCHK
lin metamorphopsia_N = mkWN "metamorfopsia" ; --UNCHK
lin metamorphose_V = mkWV (k52A "muuttua") ; --UNCHK
lin metamorphose_V2 = mkWV2 (k52A "muuttua") ; --UNCHK
lin metamorphosis_N = mkWN (k5 "metamorfoosi") ; --UNCHK
lin metamorphous_A = mkWA (compoundA "met" (k38 "amorfinen")) ; --UNCHK
lin metaphase_N = mkWN (compoundN "meta" (k5 "faasi")) ; --UNCHK
lin metaphor_N = mkWN (k10 "metafora") ;
lin metaphorical_A = mkWA (k38 "metaforinen") ; --UNCHK
lin metaphysical_A = mkWA (compoundA "meta" (k38 "fyysinen")) ; --UNCHK
lin metaphysics_N = mkWN (compoundN "meta" (k14A "fysiikka")) ; --UNCHK
lin metaphysis_N = mkWN (compoundN "metafy" (k5 "ysi")) ; --UNCHK
lin metarule_N = mkWN (compoundN "meta" (k1A "sääntö")) ; --UNCHK
lin metasequoia_N = mkWN "kiinanpunapuu" ; --UNCHK
lin metastability_N = mkWN (compoundN "meta" (k5A "stabiliteetti")) ; --UNCHK
lin metastable_A = mkWA (compoundA "meta" (k6 "stabiili")) ; --UNCHK
lin metastasis_N = mkWN (k5 "metastaasi") ; --UNCHK
lin metastatic_A = mkWA (k38 "metastaattinen") ; --UNCHK
lin metatarsal_A = mkWA (compoundA "metatarsa" (k38 "alinen")) ; --UNCHK
lin metatarsal_N = mkWN (compoundN "jalkapöytä" (k18 "luu")) ; --UNCHK
lin metatarsus_N = mkWN (compoundN "jalka" (k10A "pöytä")) ; --UNCHK
lin metatherian_N = mkWN (compoundN "pussi" (k33 "eläin")) ; --UNCHK
lin metathesis_N = mkWN (compoundN "meta" (k5 "teesi")) ; --UNCHK
lin metazoan_N = mkWN (k33 "eläin") "monisoluinen" ; --UNCHK
lin mete_V2 = mkV2 "jakaa" ;
lin mete_out_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin metempsychosis_N = mkWN (k38 "jälleensyntyminen") ; --UNCHK
lin meteor_N = mkWN (k5 "meteori") ; --UNCHK
lin meteoric_A = mkWA "meteori-" ; --UNCHK
lin meteorite_N = mkWN (k5A "meteoriitti") ; --UNCHK
lin meteoritic_A = mkWA (compoundA "meteori" (k38 "ittinen")) ; --UNCHK
lin meteoroid_N = mkWN (k5 "meteori") ; --UNCHK
lin meteorologic_A = mkWA (k38 "meteorologinen") ; --UNCHK
lin meteorological_A = mkWA (k38 "meteorologinen") ; --UNCHK
lin meteorologist_N = mkWN (k5 "meteorologi") ; --UNCHK
lin meteorology_N = mkWN (k12 "meteorologia") ; --UNCHK
lin meteortropism_N = mkWN (compoundN "sää" (k5 "tropismi")) ; --UNCHK
lin meter_N = mkWN (k9A "mitta") ; --UNCHK
lin meterstick_N = mkWN (compoundN "metri" (k5A "keppi")) ; --UNCHK
lin metformin_N = mkWN "Glucophage" ; --UNCHK
lin methacholine_N = mkWN "Mecholyl" ; --UNCHK
lin methadone_N = mkWN (k5 "heroiini") "synteettinen" ; --UNCHK
lin methamphetamine_N = mkWN (k18 "jää") ; --UNCHK
lin methane_N = mkWN (k5 "metaani") ; --UNCHK
lin methanogen_N = mkWN (compoundN "metano" (k5 "geeni")) ; --UNCHK
lin methanol_N = mkWN (k5 "metanoli") ; --UNCHK
lin methapyrilene_N = mkWN "metapyrileeni" ; --UNCHK
lin methaqualone_N = mkWN (compoundN "Quaa" (k48A "lude")) ; --UNCHK
lin metheglin_N = mkWN (k9 "sima") ; --UNCHK
lin methenamine_N = mkWN "Urex" ; --UNCHK
lin methicillin_N = mkWN "metisilliini" ; --UNCHK
lin methionine_N = mkWN (compoundN "metio" (k26 "niini")) ; --UNCHK
lin methocarbamol_N = mkWN "Robaxin" ; --UNCHK
lin method_N = mkN "menetelmä" ;
lin methodical_A = mkWA (k38 "järjestelmällinen") ; --UNCHK
lin methodism_N = mkWN (k5 "metodismi") ; --UNCHK
lin methodist_A = mkWA (k38 "metodistinen") ; --UNCHK
lin methodist_N = mkWN (k5 "metodisti") ; --UNCHK
lin methodological_A = mkWA (k38 "metodologinen") ; --UNCHK
lin methodology_N = mkWN (k12 "metodologia") ; --UNCHK
lin methotrexate_N = mkWN "metotreksaatti" ; --UNCHK
lin methyl_N = mkWN (k5 "metaani") "radikaali" ; --UNCHK
lin methylated_A = mkWA (compoundA "denaturo" (k1A "itu")) ; --UNCHK
lin methyltestosterone_N = mkWN (compoundN "metyyli" (k6 "testosteroni")) ; --UNCHK
lin metic_N = mkWN "metoikki" ; --UNCHK
lin metical_N = mkWN "metical" ; --UNCHK
lin meticulous_A = mkWA (k38 "säntillinen") ; --UNCHK
lin meticulousness_N = mkWN (k40 "perusteellisuus") ; --UNCHK
lin metier_N = mkWN (k9 "ala") ; --UNCHK
lin metonym_N = mkWN "metonyymi" ; --UNCHK
lin metonymic_A = mkWA "metonyyminen" ; --UNCHK
lin metonymy_N = mkWN "metonymia" ; --UNCHK
lin metopion_N = mkWN (compoundN "keskiotsa" (k48 "piste")) ; --UNCHK
lin metoprolol_N = mkWN "Lopressor" ; --UNCHK
lin metralgia_N = mkWN (compoundN "kohtu" (k1A "kipu")) ; --UNCHK
lin metre_N = mkWN (compoundN "tasa" (k5 "rytmi")) ; --UNCHK
lin metric_A = mkWA (k38 "metrinen") ;
lin metrical_A = mkWA (k38 "metrinen") ; --UNCHK
lin metrication_N = mkWN (compoundN "muu" (k38 "ttaminen")) "metrijärjestelmään" ; --UNCHK
lin metricize_V2 = mkWV2 (k53A "muuttaa") "metriseksi" ; --UNCHK
lin metrification_N = mkWN (compoundN "muu" (k38 "ttaminen")) "metrijärjestelmään" ; --UNCHK
lin metritis_N = mkWN (compoundN "kohtu" (k39 "tulehdus")) ; --UNCHK
lin metro_N = mkWN (k1 "metro") ; --UNCHK
lin metrological_A = mkWA (k38 "metrologinen") ; --UNCHK
lin metrology_N = mkWN (k12 "metrologia") ; --UNCHK
lin metronidazole_N = mkWN "Flagyl" ; --UNCHK
lin metronome_N = mkWN (k5 "metronomi") ; --UNCHK
lin metropolis_N = mkWN (k5 "metropoli") ; --UNCHK
lin metropolitan_A = mkWA "suurkaupunkilainen" ;
lin metropolitan_N = mkWN (k41A "asukas") "suurkaupungin" ; --UNCHK
lin metroptosis_N = mkWN "descensus" "uteri" ; --UNCHK
lin metrorrhagia_N = mkWN "metrorragia" ; --UNCHK
lin mettle_N = mkWN (k1 "sisu") ; --UNCHK
lin mettlesome_A = mkWA (k15 "rohkea") ; --UNCHK
lin mettlesomeness_N = mkWN (compoundN "luja" (k40 "luonteisuus")) ; --UNCHK
lin metz_PN = foreignPN "Metz" ;
lin mew_N = mkWN (compoundN "kala" (k5A "lokki")) | mkWN (k9A "nau'unta") ; --UNCHK
lin mew_V = mkWV (k52A "maukua") | mkWV (k52A "naukua"); --UNCHK
lin mews_N = mkWN (k19 "tie") ; --UNCHK
lin mexican_A = mkWA (k38 "meksikolainen") ; --UNCHK
lin mexican_N = mkWN (k38 "meksikolainen") ; --UNCHK
lin mexico_PN = foreignPN "Meksiko" ;
lin mexiletine_N = mkWN "Mexitil" ; --UNCHK
lin mezereon_N = mkWN (k12 "näsiä") ; --UNCHK
lin mezereum_N = mkWN (compoundN "niiden" (k9 "marja")) ; --UNCHK
lin mezuzah_N = mkWN "mezuza" ; --UNCHK
lin mezzanine_N = mkWN (compoundN "puoli" (k39 "kerros")) ; --UNCHK
lin mezzotint_N = mkWN (k1 "mezzotinto") ; --UNCHK
lin mg_N = mkWN (compoundN "milli" (k9 "gramma")) ; --UNCHK
lin mho_N = mkWN (compoundN "käänteis" (k5 "ohmi")) ; --UNCHK
lin mi_N = mkWN (k99 "mi") ; --UNCHK
lin miami_PN = foreignPN "Miami" ;
lin miasma_N = mkWN (compoundN "myrkky" (k1 "höyry")) ; --UNCHK
lin miasmal_A = mkWA (k38 "höyryinen") ; --UNCHK
lin miasmic_A = mkWA (k38 "höyryinen") ; --UNCHK
lin mica_N = mkWN (k5 "gelatiini") ; --UNCHK
lin micaceous_A = mkWA (compoundA "kii" (k38 "lteinen")) ; --UNCHK
lin micelle_N = mkWN "miselli" ; --UNCHK
lin michaelmas_N = mkWN (k10 "päivä") "syyskuun" "29." ; --UNCHK
lin michigan_PN = mkPN (mkN "Michigan" "Michiganeja") ;
lin mickey_N = mkWN "Mickey" ; --UNCHK
lin mickle_N = mkWN (k99 "roppakaupalla") ; --UNCHK
lin micro_A = mkWA (k26 "pieni") "erittäin" ; --UNCHK
lin microbalance_N = mkWN (compoundN "mikro" (k9A "vaaka")) ; --UNCHK
lin microbe_N = mkWN (k6 "bakteeri") ; --UNCHK
lin microbial_A = mkWA (compoundA "mikro" (k38 "binen")) ; --UNCHK
lin microbiologist_N = mkWN (compoundN "mikro" (k5 "biologi")) ; --UNCHK
lin microbiology_N = mkWN (compoundN "mikro" (k12 "biologia")) ; --UNCHK
lin microbrachia_N = mkWN "mikrobrakia" ; --UNCHK
lin microbrewery_N = mkWN (compoundN "mikro" (k2 "panimo")) ; --UNCHK
lin microcephalic_A = mkWA (compoundA "pieni" (k38 "päinen")) ; --UNCHK
lin microcephaly_N = mkWN (compoundN "pienipä" (k40 "isyys")) ; --UNCHK
lin microcosm_N = mkWN (compoundN "mikro" (k39 "kosmos")) ; --UNCHK
lin microcosmic_A = mkWA (compoundA "mikro" (k38 "kosminen")) ; --UNCHK
lin microcrystalline_A = mkWA (compoundA "hieno" (k38 "kiteinen")) ; --UNCHK
lin microcyte_N = mkWN "mikrosyytti" ; --UNCHK
lin microcytosis_N = mkWN "mikrosytoosi" ; --UNCHK
lin microdot_N = mkWN (compoundN "mikro" (k48 "piste")) ; --UNCHK
lin microeconomic_A = mkWA (compoundA "mikro" (k38 "taloudellinen")) ; --UNCHK
lin microeconomics_N = mkWN "mikrotaloustiede" ; --UNCHK
lin microeconomist_N = mkWN (compoundN "asian" (k12 "tuntija")) "mikrotalouden" ; --UNCHK
lin microelectronic_A = mkWA "mikroelektroniikka-" ; --UNCHK
lin microelectronics_N = mkWN (compoundN "mikro" (k9A "elektroniikka")) ; --UNCHK
lin microevolution_N = mkWN (compoundN "mikro" (k3 "evoluutio")) ; --UNCHK
lin microfarad_N = mkWN (compoundN "mikro" (k5 "faradi")) ; --UNCHK
lin microfiche_N = mkWN (compoundN "mikro" (k5A "kortti")) ; --UNCHK
lin microfilm_N = mkWN (compoundN "mikro" (k5 "filmi")) ; --UNCHK
lin microfilm_V2 = mkWV2 (k54A "tallentaa") "mikrofilmille" ; --UNCHK
lin microflora_N = mkWN (compoundN "mikro" (k10 "floora")) ; --UNCHK
lin microfossil_N = mkWN (compoundN "mikro" (k6 "fossiili")) ; --UNCHK
lin microgametophyte_N = mkWN "mikrogametofyytti" ; --UNCHK
lin microgauss_N = mkWN (compoundN "mikrog" (k5 "aussi")) ; --UNCHK
lin microglia_N = mkWN "mikroglia" ; --UNCHK
lin microgliacyte_N = mkWN (compoundN "mikroglia" (k1 "solu")) ; --UNCHK
lin microgram_N = mkWN (compoundN "mikro" (k9 "gramma")) ; --UNCHK
lin micrometeoric_A = mkWA (compoundA "mikro" (k38 "meteoriittinen")) ; --UNCHK
lin micrometeorite_N = mkWN (compoundN "mikro" (k5 "meteori")) ; --UNCHK
lin micrometeoritic_A = mkWA (compoundA "mikro" (k38 "meteoriittinen")) ; --UNCHK
lin micrometer_N = mkWN (compoundN "mikro" (k6 "mittari")) ; --UNCHK
lin micrometry_N = mkWN (compoundN "mitta" (k38 "aminen")) "mikrometrillä" ; --UNCHK
lin micron_N = mkWN (k5 "mikroni") ; --UNCHK
lin micronutrient_N = mkWN (compoundN "hiven" (k48 "aine")) ; --UNCHK
lin microorganism_N = mkWN (k5 "mikrobi") ; --UNCHK
lin micropaleontology_N = mkWN (compoundN "mikro" (k12 "paleontologia")) ; --UNCHK
lin micropenis_N = mkWN (compoundN "mikro" (k39 "fallos")) ; --UNCHK
lin microphage_N = mkWN "mikrofagi" ; --UNCHK
lin microphone_N = mkWN (k5A "mikki") ; --UNCHK
lin microphoning_N = mkWN (k1A "siirto") "äänen" ; --UNCHK
lin microphotometer_N = mkWN (compoundN "mikrofoto" (k5 "metri")) ; --UNCHK
lin microprocessor_N = mkWN (compoundN "mikro" (k6 "prosessori")) ; --UNCHK
lin micropylar_A = mkWA "siitereikään" "liittyvä" ; --UNCHK
lin micropyle_N = mkWN (compoundN "siite" (k10A "reikä")) ; --UNCHK
lin microradian_N = mkWN (compoundN "mikro" (k5 "radiaani")) ; --UNCHK
lin microscope_N = mkWN (k5A "mikroskooppi") ; --UNCHK
lin microscopic_A = mkWA "mikroskooppi-" ; --UNCHK
lin microscopical_A = mkWA "mikroskooppi-" ; --UNCHK
lin microscopist_N = mkWN (compoundN "mikros" (k5 "kopisti")) ; --UNCHK
lin microscopy_N = mkWN (k12 "mikroskopia") ; --UNCHK
lin microsecond_N = mkWN (compoundN "mikro" (k5A "sekunti")) ; --UNCHK
lin microsomal_A = mkWA (compoundA "mikrosoma" (k38 "alinen")) ; --UNCHK
lin microsome_N = mkWN "mikrosomi" ; --UNCHK
lin microsporangium_N = mkWN "microsporangium" ; --UNCHK
lin microspore_N = mkWN (compoundN "mikro" (k3 "itiö")) ; --UNCHK
lin microsporidian_N = mkWN "siimaloisio" ; --UNCHK
lin microsporophyll_N = mkWN (compoundN "mikrosporo" (k5 "fylli")) ; --UNCHK
lin microsurgery_N = mkWN (compoundN "mikro" (k12 "kirurgia")) ; --UNCHK
lin microtome_N = mkWN (k5 "mikrotomi") ; --UNCHK
lin microtubule_N = mkWN (compoundN "mikro" (k7 "putki")) ; --UNCHK
lin microvolt_N = mkWN (k5A "mikrovoltti") ; --UNCHK
lin microwave_N = mkWN (k1 "mikro") ; --UNCHK
lin mid_A = mkWA "keski-" ; --UNCHK
lin mid_Prep = mkPrep "keskellä" ;
lin midafternoon_N = mkWN (compoundN "keski" (k10 "päivä")) ; --UNCHK
lin midair_N = mkWN (k9 "ilma") ; --UNCHK
lin midazolam_N = mkWN "Versed" ; --UNCHK
lin midday_N = mkWN (k7 "hetki") "keskipäivän" ; --UNCHK
lin midden_N = mkWN (k3 "tunkio") ; --UNCHK
lin middle_A = variants {} ; --
lin middle_N = mkN "keskikohta" ;
lin middle_aged_A = mkA "keski-ikäinen" ;
lin middle_class_A = mkA "keskiluokkainen" ;
lin middle_of_the_road_A = mkA "maltillinen" ;
lin middlebrow_N = mkWN (k10 "ystävä") "kevyen" "taiteen" ; --UNCHK
lin middlemanFem_N = mkWN (k40 "yhteys") ; --UNCHK
lin middlemanMasc_N = mkWN (k40 "yhteys") ; --UNCHK
lin middlemost_A = mkWA (k38 "keskimmäinen") ; --UNCHK
lin middlesex_PN = foreignPN "Middlesex" ;
lin middleton_PN = foreignPN "Middleton" ;
lin middleweight_N = mkWN (compoundN "keskis" (k38 "arjalainen")) ; --UNCHK
lin middlewich_PN = foreignPN "Middlewich" ;
lin middling_A = mkWA (k38 "kohtalainen") ; --UNCHK
lin middling_Adv = mkWAdv (k99 "ihan") ; --UNCHK
lin middling_N = mkWN (compoundN "keski" (k38 "nkertainen")) ; --UNCHK
lin middy_N = mkWN (compoundN "merimies" (k2 "pusero")) ; --UNCHK
lin midfield_N = mkWN (compoundN "keski" (k10A "kenttä")) ; --UNCHK
lin midfielder_N = mkN "keskikenttäpelaaja" ;
lin midge_N = mkWN (k14A "itikka") ; --UNCHK
lin midget_N = mkWN (k38 "ihminen") "lyhytkasvuinen" ; --UNCHK
lin midgrass_N = mkWN (k1 "ruoho") "keskipitkä" ; --UNCHK
lin midi_A = mkWA "midi-" ; --UNCHK
lin midinette_N = mkWN "midinetti" ; --UNCHK
lin midiron_N = mkWN (k9A "rauta") "2" ; --UNCHK
lin midland_N = mkWN (compoundN "sisä" (k18 "maa")) ; --UNCHK
lin midlands_PN = foreignPN "Midlands" ;
lin midmost_A = mkWA (k38 "keskimmäinen") ; --UNCHK
lin midmost_Adv = mkWAdv (k99 "keskellä") ; --UNCHK
lin midnight_N = mkWN "keskiyö" ; --UNCHK
lin midplane_N = mkWN (compoundN "keski" (k9 "viiva")) ; --UNCHK
lin midrib_N = mkWN (compoundN "keski" (k26 "suoni")) ; --UNCHK
lin midriff_N = mkWN (k12 "pallea") ; --UNCHK
lin midshipman_N = mkWN (compoundN "meri" (k5A "kadetti")) ; --UNCHK
lin midships_Adv = mkWAdv (k99 "keskivaiheille") ; --UNCHK
lin midst_N = mkWN (k99 "keskellä") ; --UNCHK
lin midst_Prep = mkPrep "joukossa" ;
lin midstream_N = mkWN (k10A "keskikohta") "virran" ; --UNCHK
lin midsummer_N = mkWN (k39 "juhannus") ; --UNCHK
lin midterm_N = mkWN (k48A "koe") "puolivälin" ; --UNCHK
lin midway_A = mkWA (k99 "puolitiessä") ; --UNCHK
lin midway_Adv = mkWAdv (k99 "puolitiessä") ; --UNCHK
lin midway_N = mkWN (k2 "taistelu") "Midwayn" ; --UNCHK
lin midweek_A = mkA "viikonkeskeinen" ; ---?? different POS
lin midweek_Adv = mkWAdv (compoundAdv "puoli" (k99 "välissä")) "viikon" ; --UNCHK
lin midweek_N = mkWN (k50 "puoliväli") "viikon" ; --UNCHK
lin midweekly_A = mkWA (compoundA "puoli" (k38 "viikoittainen")) ; --UNCHK
lin midwestern_A = mkWA "Keskilännen" ; --UNCHK
lin midwife_N = mkWN (k2 "kätilö") ; --UNCHK
lin midwifery_N = mkWN (compoundN "toi" (k38 "miminen")) "kätilönä" ; --UNCHK
lin midwinter_N = mkWN (compoundN "keski" (k7 "talvi")) ; --UNCHK
lin miehikkälä_PN = mkPN "Miehikkälä" ;
lin mien_N = mkWN (k39 "olemus") ; --UNCHK
lin mietoinen_PN = mkPN "Mietoinen" ;
lin miff_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin might_N = mkN "valta" ;
lin mighty_A = mkWA (k10 "mahtava") ;
lin mighty_Adv = mkWAdv (k99 "todella") ; --UNCHK
lin mignonette_N = mkWN (compoundN "tuoksu" (k13 "reseda")) ; --UNCHK
lin migraine_N = mkWN (k5 "migreeni") ; --UNCHK
lin migrant_A = mkWA "muutto-" ; --UNCHK
lin migrant_N = mkWN (k38 "siirtolainen") ; --UNCHK
lin migrate_V = mkWV (k53A "muuttaa") ; --UNCHK
lin migration_N = mkWN (k1A "muutto") ; --UNCHK
lin migrational_A = mkWA "muutto-" ; --UNCHK
lin migrator_N = mkWN (k10 "muuttaja") ; --UNCHK
lin migratory_A = mkWA "muutto-" ; --UNCHK
lin mihrab_N = mkWN "mihrab" ; --UNCHK
lin mikado_N = mkWN (k6 "keisari") "Japanin" ; --UNCHK
lin mike_N = mkWN (k5A "mikki") ; --UNCHK
lin mikkeli_PN = mkPN "Mikkeli" ;
lin mikvah_N = mkWN "mikva" ; --UNCHK
lin mil_N = mkWN (k99 "mi") ; --UNCHK
lin milady_N = mkWN "Milady" ; --UNCHK
lin milage_N = mkWN (k40 "pituus") "matkan" ; --UNCHK
lin milan_PN = foreignPN "Milan" ;
lin milano_PN = foreignPN "Milano" ;
lin milch_A = mkWA (k10 "tuottava") "maitoa" ; --UNCHK
lin mild_A = mkWA (k1 "vaisu") ; --UNCHK
lin mildenhall_PN = foreignPN "Mildenhall" ;
lin mildew_N = mkWN (k48 "home") ; --UNCHK
lin mildew_V = mkWV (k52A "homehtua") ; --UNCHK
lin mildew_V2 = mkWV2 (k52A "homehtua") ; --UNCHK
lin mildness_N = mkWN (k40 "lievyys") ; --UNCHK
lin mile_N = mkWN (kH1 "maili") ;
lin mileage_N = mkWN (k40 "pituus") "matkan" ; --UNCHK
lin mileometer_N = mkWN (compoundN "matka" (k6 "mittari")) ; --UNCHK
lin miler_N = mkWN (k6 "maileri") ; --UNCHK
lin milestone_N = mkWN (compoundN "kilometri" (k41 "pylväs")) ; --UNCHK
lin milford_PN = foreignPN "Milford" ;
lin milieu_N = mkWN (k1 "ympäristö") ; --UNCHK
lin militainment_N = mkWN "puolustusvoimien" "viihdyttäminen" ; --UNCHK
lin militancy_N = mkWN (k40 "sotaisuus") ; --UNCHK
lin militant_A = mkWA (k5A "militantti") ; --UNCHK
lin militant_N = mkWN (k5 "aktivisti") ; --UNCHK
lin militarism_N = mkWN (k5 "militarismi") ; --UNCHK
lin militarist_N = mkWN (k5 "militaristi") ; --UNCHK
lin militaristic_A = mkWA (k38 "militaristinen") ; --UNCHK
lin militarized_A = mkWA (compoundA "ase" (k1 "istettu")) ; --UNCHK
lin military_A = mkA "sotilaallinen" ;
lin military_N = mkWN (k12 "armeija") ; --UNCHK
lin militate_V = mkV vOlla "haitaksi" ;
lin militia_N = mkWN (k5 "reservi") ; --UNCHK
lin militiaman_N = mkWN (k5 "miliisi") ; --UNCHK
lin milk_N = L.milk_N ;
lin milk_V = mkWV (k54 "lypsää") ; --UNCHK
lin milk_V2 = mkWV2 (k54 "lypsää") ; --UNCHK
lin milk_powder_N = mkWN (compoundN "maito" (k48 "jauhe")) ; --UNCHK
lin milk_shake_N = mkWN (k2 "pirtelö") ; --UNCHK
lin milk_tooth_N = mkWN (compoundN "maito" (k41A "hammas")) ; --UNCHK
lin milkcap_N = mkWN (k1 "rousku") ; --UNCHK
lin milking_machine_N = mkWN (compoundN "lypsy" (k48 "kone")) ; --UNCHK
lin milkless_A = mkWA "maidoton" ; --UNCHK
lin milkmaid_N = mkWN (k4A "karjakko") ; --UNCHK
lin milkman_N = mkWN (compoundN "maito" (k42 "mies")) ; --UNCHK
lin milksop_N = mkWN (k2 "nyhverö") ; --UNCHK
lin milkweed_N = mkWN (compoundN "mesisilkki" (k5A "yrtti")) ; --UNCHK
lin milkwort_N = mkWN (compoundN "linnun" (k1 "ruoho")) ; --UNCHK
lin milky_A = mkWA (k38 "maitomainen") ; --UNCHK
lin mill_N = mkN "mylly" ;
lin mill_V = mkWV (k56 "jauhaa") ; --UNCHK
lin mill_V2 = mkWV2 (k56 "jauhaa") ; --UNCHK
lin mill_around_V = mkWV (k67 "palloilla") ; --UNCHK
lin millboard_N = mkWN (compoundN "käsi" (k5 "pahvi")) ; --UNCHK
lin mill_dam_N = mkWN (compoundN "mylly" (k1A "pato")) ; --UNCHK
lin millenarian_A = mkWA (k38 "kiliastinen") ; --UNCHK
lin millenarian_N = mkWN (k5 "kiliasti") ; --UNCHK
lin millenarianism_N = mkWN (k5 "kiliasmi") ; --UNCHK
lin millenary_A = mkWA (k46 "tuhat") ; --UNCHK
lin millennial_A = mkWA (compoundA "tuhat" (k38 "vuosittainen")) ; --UNCHK
lin miller_N = mkWN "Acronicta" "leporina" ; --UNCHK
lin millerite_N = mkWN (compoundN "mille" (k5A "riitti")) ; --UNCHK
lin millet_N = mkWN (k5 "hirssi") ; --UNCHK
lin millettia_N = mkWN "millettia" ; --UNCHK
lin milliammeter_N = mkWN (compoundN "milliampeeri" (k6 "mittari")) ; --UNCHK
lin milliampere_N = mkWN (compoundN "milli" (k6 "ampeeri")) ; --UNCHK
lin milliard_N = mkWN (k5 "miljardi") ; --UNCHK
lin millibar_N = mkWN (k5 "millibaari") ; --UNCHK
lin millicent_PN = foreignPN "Millicent" ;
lin millicurie_N = mkWN "millicurie" ; --UNCHK
lin millidegree_N = mkWN (compoundN "milli" (k48 "aste")) ; --UNCHK
lin milliequivalent_N = mkWN (compoundN "milli" (k5A "ekvivalentti")) ; --UNCHK
lin millifarad_N = mkWN (compoundN "milli" (k5 "faradi")) ; --UNCHK
lin milligram_N = mkWN (compoundN "milli" (k9 "gramma")) ; --UNCHK
lin millihenry_N = mkWN (compoundN "milli" (k1 "henry")) ; --UNCHK
lin milliliter_N = mkWN (compoundN "kuutiosentti" (k5 "metri")) ; --UNCHK
lin millime_N = mkWN (compoundN "mil" (k8 "lime")) ; --UNCHK
lin millimetre_N = mkWN (k5 "milli") ; --UNCHK
lin milline_N = mkWN "milliini" ; --UNCHK
lin milliner_N = mkWN (k5 "modisti") ; --UNCHK
lin millinery_N = mkWN (k1A "hattu") "naisten" ; --UNCHK
lin milling_N = mkWN (k9 "reuna") "lovettu" ; --UNCHK
lin million_A = mkWA (k10 "miljoona") ; --UNCHK
lin million_N = mkWN (k10 "miljoona") ;
lin millionaire_N = mkWN (k5 "miljonääri") ; --UNCHK
lin millionairess_N = mkWN (k5 "miljonääri") ; --UNCHK
lin millionfold_Adv = mkWAdv (compoundAdv "ker" (k99 "taa")) "miljoona" ; --UNCHK
lin millionth_A = mkWA (k45 "miljoonas") ; --UNCHK
lin millionth_N = mkWN (compoundN "miljoonas" (k10 "osa")) ; --UNCHK
lin millipede_N = mkWN (compoundN "kaks" (k38 "oisjalkainen")) ; --UNCHK
lin milliradian_N = mkWN (compoundN "milli" (k5 "radiaani")) ; --UNCHK
lin millisecond_N = mkWN (compoundN "milli" (k5A "sekunti")) ; --UNCHK
lin millivolt_N = mkWN (k5A "millivoltti") ; --UNCHK
lin millivoltmeter_N = mkWN (compoundN "millivoltti" (k6 "mittari")) ; --UNCHK
lin milliwatt_N = mkWN (compoundN "milli" (k5A "watti")) ; --UNCHK
lin millom_PN = foreignPN "Millom" ;
lin millpond_N = mkWN (compoundN "mylly" (k7A "lampi")) ; --UNCHK
lin millrace_N = mkWN (k1 "kouru") "myllyn" ; --UNCHK
lin millstone_N = mkWN (compoundN "myllyn" (k7 "kivi")) ; --UNCHK
lin millwheel_N = mkWN (compoundN "myllyn" (k41A "ratas")) ; --UNCHK
lin millwork_N = mkWN (compoundN "puu" (k12 "tavara")) "myllyssä" "jalostettu" ; --UNCHK
lin millwright_N = mkWN (k10 "rakentaja") ; --UNCHK
lin milngavie_PN = foreignPN "Milngavie" ;
lin milnrow_PN = foreignPN "Milnrow" ;
lin milo_N = mkWN (compoundN "kafferi" (k5 "hirssi")) ; --UNCHK
lin milometer_N = mkWN (compoundN "matka" (k6 "mittari")) ; --UNCHK
lin milord_N = mkWN (k9 "herra") ; --UNCHK
lin milt_N = mkWN (k5A "maiti") ; --UNCHK
lin milwaukee_PN = foreignPN "Milwaukee" ;
lin mime_N = mkWN (k5 "pantomiimi") ; --UNCHK
lin mime_V = mkWV (k53A "esittää") "pantomiimia" ; --UNCHK
lin mime_V2 = mkWV2 (k53A "esittää") "pantomiimia" ; --UNCHK
lin mimeograph_N = mkWN "vahamonistuskone" ; --UNCHK
lin mimeograph_V2 = mkWV2 (k62 "kopioida") "mimeografilla" ; --UNCHK
lin mimesis_N = mkWN (k2 "jäljittely") ; --UNCHK
lin mimetic_A = mkWA (compoundA "jäljitte" (k10 "levä")) ; --UNCHK
lin mimic_A = mkWA (compoundA "jäljitte" (k10 "levä")) ; --UNCHK
lin mimic_N = mkWN (k6 "imitaattori") ; --UNCHK
lin mimic_V2 = mkWV2 (k61 "matkia") ; --UNCHK
lin mimicry_N = mkWN (k2 "jäljittely") ; --UNCHK
lin mimosa_N = mkWN (compoundN "mim" (k10 "osa")) ; --UNCHK
lin min_N = mkWN (k48A "murre") "Taiwanin" ; --UNCHK
lin minaret_N = mkWN (k5A "minareetti") ; --UNCHK
lin minatory_A = mkWA (k10 "uhkaava") ; --UNCHK
lin mince_N = mkWN (compoundN "hie" (k1 "nonnettu")) ; --UNCHK
lin mince_V = mkWV (k54A "lieventää") ; --UNCHK
lin mince_V2 = mkWV2 (k54A "lieventää") ; --UNCHK
lin mince_pie_N = mkWN (compoundN "joulu" (k1A "torttu")) ; --UNCHK
lin mincemeat_N = mkWN (compoundN "sekahedelmä" (k48A "täyte")) ; --UNCHK
lin mincer_N = mkWN (compoundN "liha" (k1 "mylly")) ; --UNCHK
lin mincingly_Adv = mkWAdv "sipsutellen" ; --UNCHK
lin mind_N = mkN "mieli" ;
lin mind_V = mkV "pahastua" ;
lin mind_V2 = mkWV2 (k62 "huomioida") ;
lin mind_VS = mkWVS (k62 "huomioida") ;
lin mind_boggling_A = mkA "hämmentävä" ;
lin mind_reader_N = mkWN (compoundN "ajatusten" (k12 "lukija")) ; --UNCHK
lin minder_N = mkWN (k12 "kaitsija") ; --UNCHK
lin mindful_A = mkWA (k38 "tietoinen") "jostakin" ; --UNCHK
lin mindfulness_N = mkWN (k40 "tietoisuus") ; --UNCHK
lin mindless_A = mkWA (compoundA "haja" (k38 "mielinen")) ; --UNCHK
lin mindlessness_N = mkWN (k40 "varomattomuus") ; --UNCHK
lin mine_A = mkA "ehtymätön" ; --ARB
lin mine_N = mkWN (k9 "miina") ; --f57
lin mine_V = mkWV (k53A "miinoittaa") ; --UNCHK
lin mine_V2 = mkWV2 (k53A "miinoittaa") ; --UNCHK
lin mine_detector_N = mkWN (compoundN "miina" (k11 "harava")) ; --UNCHK
lin mine_disposal_N = mkWN "miinan" "hävittäminen" ; --UNCHK
lin minefield_N = mkWN (compoundN "miina" (k10A "kenttä")) ; --UNCHK
lin minehead_PN = foreignPN "Minehead" ;
lin minelayer_N = mkWN (compoundN "miina" (k9 "laiva")) ; --UNCHK
lin minelaying_N = mkWN (compoundN "miinan" (k1 "lasku")) ; --UNCHK
lin miner_N = mkWN (compoundN "kaivos" (k38 "työläinen")) ;
lin mineral_A = mkWA "kivennäis-" ; --UNCHK
lin mineral_N = mkWN (k5 "mineraali") ; --UNCHK
lin mineralocorticoid_N = mkWN "mineralokortikoidi" ; --UNCHK
lin mineralogist_N = mkWN (k5 "mineralogi") ; --UNCHK
lin mineralogy_N = mkWN (k12 "mineralogia") ; --UNCHK
lin mineshaft_N = mkWN (compoundN "kaivos" (k1 "kuilu")) ; --UNCHK
lin minestrone_N = mkWN (compoundN "kasvis" (k1A "keitto")) ; --UNCHK
lin minesweeper_N = mkWN (compoundN "miinan" (k10 "raivaaja")) ; --UNCHK
lin minesweeping_N = mkWN (compoundN "miinan" (k39 "raivaus")) ; --UNCHK
lin mineworker_N = mkWN (compoundN "kaivos" (k38 "työläinen")) ; --UNCHK
lin minge_N = mkWN (k1 "pillu") ; --UNCHK
lin mingle_V = mkWV (k53A "sulauttaa") "yhteen" ; --UNCHK
lin mingle_V2 = mkWV2 (k53A "sulauttaa") "yhteen" ; --UNCHK
lin mingling_N = mkWN (k2 "seurustelu") ; --UNCHK
lin mingy_A = mkWA (k41 "kitsas") ; --UNCHK
lin mini_A = mkWA "mini-" ; --UNCHK
lin miniature_A = mkWA "pienois-" ; --UNCHK
lin miniature_N = mkWN (k1 "lelu") ; --UNCHK
lin miniaturist_N = mkWN (k6 "miniatyyrimaalari") ; --UNCHK
lin miniaturization_N = mkWN "pienoiskoossa" "rakentaminen" ; --UNCHK
lin miniaturize_V2 = mkWV2 (k54A "rakentaa") "pienoiskoossa" ; --UNCHK
lin minibar_N = mkWN (k5 "minibaari") ; --UNCHK
lin minibike_N = mkWN (compoundN "mini" (k1 "moto")) ; --UNCHK
lin minibus_N = mkWN (compoundN "mini" (k5 "bussi")) ; --UNCHK
lin minicab_N = mkWN (compoundN "pikku" (k5 "taksi")) ; --UNCHK
lin minicar_N = mkWN (compoundN "pikku" (k1 "auto")) ; --UNCHK
lin minicomputer_N = mkWN "minitietokone" ; --UNCHK
lin minim_N = mkWN (compoundN "puoli" (k5A "nuotti")) ; --UNCHK
lin minimal_A = mkWA (k38 "minimaalinen") ; --UNCHK
lin minimalism_N = mkWN (k48A "taide") "minimalistinen" ; --UNCHK
lin minimalist_A = mkWA (k38 "minimalistinen") ; --UNCHK
lin minimalist_N = mkWN (k5 "minimalisti") ; --UNCHK
lin minimization_N = mkWN (k5A "minimointi") ; --UNCHK
lin minimize_V2 = mkWV2 (k62 "minimoida") ; --UNCHK
lin minimum_A = mkWA (k38 "minimaalinen") ; --f64
lin minimum_N = mkN "minimi" ;
lin minimus_N = mkWN (compoundN "pikku" (k41A "varvas")) ; --UNCHK
lin mining_N = mkWN (k9A "louhinta") ;
lin minion_N = mkWN (k38 "käskyläinen") ; --UNCHK
lin miniskirt_N = mkWN (compoundN "mini" (k48 "hame")) ; --UNCHK
lin minister_1_N = mkN "ministeri" ;
lin minister_2_N = mkN "pastori" ;
lin minister_N = mkN "ministeri" ;
lin minister_V = mkWV (k53A "hoitaa") "papinvirkaa" ; --UNCHK
lin ministerial_A = mkWA "ministeriön" ; --UNCHK
lin ministrant_A = mkWA (k10 "auttava") ; --UNCHK
lin ministrant_N = mkWN (compoundN "apulais" (k5A "pappi")) ; --UNCHK
lin ministration_N = mkWN (k39 "avustus") ; --UNCHK
lin ministry_N = mkN "ministeriö" ;
lin minisub_N = mkWN "pienoissukellusvene" ; --UNCHK
lin minivan_N = mkWN (compoundN "tila-" (k1 "auto")) ; --UNCHK
lin miniver_N = mkWN (compoundN "turkis" (k39 "reunus")) ; --UNCHK
lin mink_N = mkWN (k5A "minkki") ; --UNCHK
lin minneapolis_PN = foreignPN "Minneapolis" ;
lin minnesota_PN = mkPN "Minnesota" ;
lin minniebush_N = mkWN (compoundN "pil" (k10 "osa")) "Menziesia" ; --UNCHK
lin minnow_N = mkWN (kH1 "mutu") ; --UNCHK
lin minocycline_N = mkWN "Minocin" ; --UNCHK
lin minor_A = mkWA (k26 "pieni") ; --f56
lin minor_N = mkWN (k38 "alaikäinen") ;
lin minority_N = mkWN (k1 "vähemmistö") ; --f88
lin minotaur_N = mkWN (compoundN "Minota" (k39 "uros")) ; --UNCHK
lin minoxidil_N = mkWN (compoundN "Rog" (k48 "aine")) ; --UNCHK
lin minsk_PN = foreignPN "Minsk" ;
lin minster_N = mkWN (compoundN "tuomio" (k1A "kirkko")) ; --UNCHK
lin minstrel_N = mkWN (k5 "trubaduuri") ; --UNCHK
lin minstrelsy_N = mkWN "minstreliys" ; --UNCHK
lin mint_N = mkWN (compoundN "raha" (k9 "paja")) ; ---ARB --mkN "minttu" ;
lin mint_V2 = mkWV2 (k64 "lyödä") "rahaa" ; --UNCHK
lin mintage_N = mkWN (kH1 "leimaus") "rahan" ; --UNCHK
lin mintmark_N = mkWN (k9 "leima") "rahapajan" ; --UNCHK
lin minty_A = mkWA (compoundA "minttu" (k38 "mainen")) ; --UNCHK
lin minuend_N = mkWN (k10 "vähennettävä") ; --UNCHK
lin minuet_N = mkWN (k5A "menuetti") ; --UNCHK
lin minus_A = mkWA (k39 "miinus") ; --UNCHK
lin minus_N = mkWN (k39 "miinus") ; --UNCHK
lin minus_Prep = prePrep nominative "miinus" ;
lin minuscule_A = mkWA (compoundA "kirjo" (k1 "itettu")) "pienin" "kirjaimin" ; --UNCHK
lin minuscule_N = mkWN (k33 "kirjain") "pieni" ; --UNCHK
lin minute_A = mkWA (compoundA "yks" (k38 "ityiskohtainen")) ; --UNCHK
lin minute_N = mkN "minuutti" | mkN "muistiinpano" ; ---- split
lin minute_book_N = mkWN (compoundN "pöytä" (k9 "kirja")) ; --UNCHK
lin minute_gun_N = mkWN (compoundN "tuli" (k48 "ase")) ; --UNCHK
lin minute_hand_N = mkWN (compoundN "minuutti" (k33A "osoitin")) ; --UNCHK
lin minuteman_N = mkWN "Minuteman" ; --UNCHK
lin minuteness_N = mkWN (k40 "tarkkaavaisuus") ; --UNCHK
lin minutes_N = mkWN (compoundN "pöytä" (k9 "kirja")) ; --UNCHK
lin minutia_N = mkWN (k10A "yksityiskohta") "pieni" ; --UNCHK
lin minx_N = mkWN (k5A "koketti") ; --UNCHK
lin minyan_N = mkWN (compoundN "jäsen" (k1A "luku")) "päätösvaltainen" ; --UNCHK
lin miotic_A = mkWA "mioottinen" ; --UNCHK
lin miracle_N = mkWN (k48 "ihme") ; --UNCHK
lin miraculous_A = mkWA (k38 "onnellinen") ; --UNCHK
lin mirage_N = mkWN (compoundN "harha" (k10 "kuva")) ; --UNCHK
lin miranda_PN = foreignPN "Miranda" ;
lin mire_N = mkWN (k1A "letto") ; --UNCHK
lin mire_V = mkWV (k58 "sotkea") ; --UNCHK
lin mire_V2 = mkWV2 (k58 "sotkea") ; --UNCHK
lin miro_N = mkWN "Joan" "Miro" ; --UNCHK
lin mirror_N = mkWN (k5 "peili") ; --UNCHK
lin mirror_V2 = mkV2 "muistuttaa" partitive ;
lin mirrorlike_A = mkWA (compoundA "peili" (k38 "mäinen")) ; --UNCHK
lin mirth_N = mkWN (k1 "riemu") ; --UNCHK
lin mirthful_A = mkWA (k1 "hassu") ; --UNCHK
lin mirthless_A = mkWA (k34A "iloton") ; --UNCHK
lin miry_A = mkWA (k10 "vetelä") ; --UNCHK
lin misadventure_N = mkWN (k40 "onnettomuus") ; --UNCHK
lin misadvise_V2 = mkWV2 (k53A "johtaa") "harhaan" ; --UNCHK
lin misalignment_N = mkWN (compoundN "sovitus" (k48 "virhe")) ; --UNCHK
lin misalliance_N = mkWN (compoundN "avio" (k1A "liitto")) "epäsäätyinen" ; --UNCHK
lin misanthrope_N = mkWN (compoundN "ihmis" (k10 "vihaaja")) ; --UNCHK
lin misanthropic_A = mkWA (compoundA "vih" (k9 "aava")) "ihmisiä" ; --UNCHK
lin misanthropy_N = mkWN (compoundN "ihmis" (k9 "viha")) ; --UNCHK
lin misapplication_N = mkWN (k39 "anastus") ; --UNCHK
lin misapply_V2 = mkWV2 (k53A "käyttää") "väärin" ; --UNCHK
lin misapprehend_V2 = mkWV2 (k53A "käsittää") "väärin" ; --UNCHK
lin misapprehension_N = mkWN (k39 "sekaannus") ; --UNCHK
lin misappropriate_V2 = mkWV2 (k71 "tehdä") "virkarikos" ; --UNCHK
lin misappropriation_N = mkWN (k39 "kavallus") ; --UNCHK
lin misbegotten_A = mkWA (k11 "äpärä") ; --UNCHK
lin misbehave_V = mkWV (k52A "käyttäytyä") "huonosti" ; --UNCHK
lin misbehave_V2 = mkWV2 (k52A "käyttäytyä") "huonosti" ; --UNCHK
lin misbehavior_N = mkWN (k39 "käytös") "huono" ; --UNCHK
lin misbehaviour_N = mkWN (k39 "käytös") "huono" ; --UNCHK
lin misbranded_A = mkWA "väärin" "merkitty" ; --UNCHK
lin miscalculate_V = mkWV (k62 "arvioida") "väärin" ; --UNCHK
lin miscalculate_V2 = mkWV2 (k62 "arvioida") "väärin" ; --UNCHK
lin miscalculation_N = mkWN (compoundN "virhe" (k3 "arvio")) ; --UNCHK
lin miscarriage_N = mkWN (k5A "abortti") "spontaani" ; --UNCHK
lin miscarry_V2 = mkWV2 (k63 "saada") "keskenmeno" ; --UNCHK
lin miscegenation_N = mkWN "risteyttäminen" ; --UNCHK
lin miscellaneous_A = mkWA (k38 "sekalainen") ; --UNCHK
lin miscellany_N = mkWN (k12 "antologia") ; --UNCHK
lin mischance_N = mkWN (k40 "onnettomuus") ; --UNCHK
lin mischief_N = mkWN (k10 "jäynä") ; --UNCHK
lin mischievous_A = mkWA (compoundA "paha" (k38 "nilkinen")) ; --UNCHK
lin mischievousness_N = mkWN (k10 "jäynä") ; --UNCHK
lin miscible_A = mkWA "sekoittuva" ; --UNCHK
lin misconceive_V = mkWV (k53A "käsittää") "väärin" ; --UNCHK
lin misconceive_V2 = mkWV2 (k53A "käsittää") "väärin" ; --UNCHK
lin misconception_N = mkWN (compoundN "harha" (k39 "käsitys")) ; --UNCHK
lin misconduct_N = mkWN (k1A "teko") "väärä" ; --UNCHK
lin misconduct_V2 = mkWV2 (k67A "käsitellä") "väärin" ; --UNCHK
lin misconstrual_N = mkWN (k9A "tulkinta") "väärä" ; --UNCHK
lin misconstruction_N = mkWN (compoundN "lauseen" (k10 "osa")) "väärä" ; --UNCHK
lin misconstrue_V2 = mkWV2 (k53A "käsittää") "väärin" ; --UNCHK
lin miscount_N = mkWN (k1A "luku") "väärä" ; --UNCHK
lin miscount_V = mkWV (k58 "laskea") "väärin" ; --UNCHK
lin miscount_V2 = mkWV2 (k58 "laskea") "väärin" ; --UNCHK
lin miscreant_N = mkWN (k39 "lurjus") ; --UNCHK
lin miscue_N = mkWN (k39 "lapsus") ; --UNCHK
lin misdate_V2 = mkWV2 (k73 "päivätä") "väärin" ; --UNCHK
lin misdeal_N = mkWN (k39 "sopimus") "väärä" ; --UNCHK
lin misdeal_V = mkWV (k56A "jakaa") "väärin" ; --UNCHK
lin misdeal_V2 = mkWV2 (k56A "jakaa") "väärin" ; --UNCHK
lin misdeed_N = mkWN (k39 "käytös") "huono" ; --UNCHK
lin misdemeanor_N = mkWN (k39 "rikos") "lievä" ; --UNCHK
lin misdemeanour_N = mkWN (k39 "rikos") "lievä" ; --UNCHK
lin misdirection_N = mkWN "harhaan" "johtaminen" ; --UNCHK
lin mise_en_scene_N = mkWN (k39 "lavastus") ; --UNCHK
lin miser_N = mkWN (k6 "saituri") ; --UNCHK
lin miserable_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin miserliness_N = mkWN "saituruus" ; --UNCHK
lin miserly_A = mkWA (k41 "kitsas") ; --UNCHK
lin misery_N = mkWN (k40 "surkeus") ; --UNCHK
lin misfeasance_N = mkWN (k39 "rikkomus") ; --UNCHK
lin misfire_N = mkWN (compoundN "ohi" (k39 "laukaus")) ; --UNCHK
lin misfire_V = mkWV (k63 "jäädä") "laukeamatta" ; --UNCHK
lin misfit_N = mkWN (k2 "henkilö") "sopeutumaton" ; --UNCHK
lin misfortune_N = mkWN (k40 "onnettomuus") ; --UNCHK
lin misgive_V2 = mkWV2 (k67 "epäillä") ; --UNCHK
lin misgiving_N = mkWN (k39 "epäilys") ; --UNCHK
lin misgovern_V2 = mkWV2 (k69 "hallita") "huonosti" ; --UNCHK
lin misgovernment_N = mkWN (k1A "hallinto") "huono" ; --UNCHK
lin misguide_V2 = mkWV2 (k53A "johtaa") "harhaan" ; --UNCHK
lin mishandle_V2 = mkWV2 (k67A "käsitellä") "väärin" ; --UNCHK
lin mishap_N = mkWN (k40 "onnettomuus") ; --UNCHK
lin mishmash_N = mkWN (k9 "kama") ; --UNCHK
lin mishpocha_N = mkWN "mispacha" ; --UNCHK
lin misinform_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin misinformation_N = mkWN (k1A "tieto") "väärä" ; --UNCHK
lin misinterpret_V2 = mkWV2 (k53A "käsittää") "väärin" ; --UNCHK
lin misinterpretation_N = mkWN (k9A "tulkinta") "väärä" ; --UNCHK
lin mislaid_A = mkWA (compoundA "laite" (k1 "ttu")) "väärään" "paikkaan" ; --UNCHK
lin mislay_V2 = mkWV2 (k53A "kadottaa") ; --UNCHK
lin mislead_V2 = mkV2 (mkV (mkV "johtaa") "harhaan") partitive ;
lin misleader_N = mkWN (compoundN "harh" (k10 "auttaja")) ; --UNCHK
lin misleading_A = variants {} ; --
lin mismanage_V2 = mkWV2 (k67A "käsitellä") "väärin" ; --UNCHK
lin mismanagement_N = mkWN (k1A "hoito") "huono" ; --UNCHK
lin mismatch_N = mkWN (compoundN "yhteen" (k40 "sopimattomuus")) ; --UNCHK
lin mismatched_A = mkWA (compoundA "yhteen" (k34A "sopimaton")) ; --UNCHK
lin misnomer_N = mkWN (k9A "sanonta") "harhaanjohtava" ; --UNCHK
lin miso_N = mkWN "miso" ; --UNCHK
lin misocainea_N = mkWN (compoundN "viha" (k38 "aminen")) "uusien" "ideoiden" ; --UNCHK
lin misogamist_N = mkWN (k10 "vihaaja") "avioliiton" ; --UNCHK
lin misogamy_N = mkWN (compoundN "viha" (k38 "aminen")) "avioliiton" ; --UNCHK
lin misogynic_A = mkWA (compoundA "vih" (k9 "aava")) "naisia" ; --UNCHK
lin misogynist_N = mkWN (k10 "naistenvihaaja") ; --UNCHK
lin misogynous_A = mkWA (k38 "misogyyninen") ; --UNCHK
lin misogyny_N = mkWN (k12 "misogynia") ; --UNCHK
lin misology_N = mkWN (compoundN "vastus" (k38 "taminen")) "järkevän" "todistelun" ; --UNCHK
lin misoneism_N = mkWN (compoundN "misone" (k5 "ismi")) ; --UNCHK
lin misopedia_N = mkWN (compoundN "viha" (k38 "aminen")) "lasten" ; --UNCHK
lin misplace_V2 = mkWV2 (k53A "sijoittaa") "väärin" ; --UNCHK
lin misprint_N = mkWN (k48 "virhe") "typografinen" ; --UNCHK
lin misprint_V2 = mkWV2 (k56 "painaa") "väärin" ; --UNCHK
lin mispronounce_V2 = mkWV2 (k52 "lausua") "väärin" ; --UNCHK
lin mispronunciation_N = mkWN (compoundN "ääntämis" (k48 "virhe")) ; --UNCHK
lin misquotation_N = mkWN (k39 "lainaus") "väärä" ; --UNCHK
lin misquote_V2 = mkWV2 (k73 "siteerata") "väärin" ; --UNCHK
lin misread_V2 = mkWV2 (k69 "tulkita") "väärin" ; --UNCHK
lin misreading_N = mkWN (k9A "tulkinta") "väärä" ; --UNCHK
lin misrelated_A = mkWA (k1A "yhdistetty") "väärin" ; --UNCHK
lin misrepresent_V2 = mkV2 "vääristellä" partitive ;
lin misrepresentation_N = mkN "harhaan" (mkN "johtaminen") ; --mkWN (k2 "panettelu") ;
lin misrule_N = mkWN (k1A "hallinto") "huono" ; --UNCHK
lin miss_N = mkWN (k5A "neiti") ; --UNCHK
lin miss_V = mkV "puuttua" ;
lin miss_V2 = mkV2 "menettää" | mkV2 "kaivata" partitive | mkWV2 (k73 "missata") ; ---- split
lin miss_out_V = advV OP_miss_V OP_out_Adv ; -- guess-p-verb
lin miss_out_V2 = prepV2 OP_miss_V OP_out_Prep ; -- guess-p-verb
lin miss_out_on_V2 = prepV2 (advV OP_miss_V OP_out_Adv ) OP_on_Prep ; -- guess-p-verb
lin missal_N = mkWN (compoundN "messu" (k9 "kirja")) ; --UNCHK
lin misshapen_A = mkWA (k34A "muodoton") ; --UNCHK
lin missile_N = mkWN (k39 "ohjus") ;
lin missing_A = mkA "puuttuva" ;
lin mission_N = mkN "tehtävä" ;
lin missionary_A = mkWA "käännytys-" ; --UNCHK
lin missionary_N = mkWN (compoundN "käännytystyön" (k12 "tekijä")) ; --UNCHK
lin missis_N = mkWN (k1 "vaimo") ; --UNCHK
lin mississippi_PN = mkPN "Mississippi" ;
lin missive_N = mkWN (k48 "kirje") ; --UNCHK
lin missouri_PN = mkPN "Missouri" ;
lin misspell_V2 = mkWV2 (k53A "kirjoittaa") "väärin" ; --UNCHK
lin misspelling_N = mkWN (compoundN "kirjoitus" (k48 "virhe")) ; --UNCHK
lin misspend_V2 = mkWV2 (k73 "haaskata") ; --UNCHK
lin misstate_V2 = mkWV2 (k66 "ilmaista") "väärin" ; --UNCHK
lin misstatement_N = mkWN (k1A "lausunto") "väärä" ; --UNCHK
lin missus_N = mkWN (k1 "vaimo") ; --UNCHK
lin missy_N = mkWN (k38 "neitonen") ; --UNCHK
lin mist_N = mkWN (k1A "utu") ; --UNCHK
lin mist_V = mkWV (k52A "sumentua") ; --UNCHK
lin mist_V2 = mkWV2 (k52A "sumentua") ; --UNCHK
lin mistake_N = mkN "erehdys" ;
lin mistake_V = mkWV (k71 "tehdä") "virhe" ; --UNCHK
lin mistake_V2 = mkWV2 (k71 "tehdä") "virhe" ; --UNCHK
lin mistaken_A = mkWA (k38 "virheellinen") ;
lin mister_N = mkWN (k9 "herra") ; --UNCHK
lin mistflower_N = mkWN "Eupatorium" "coelestinum" ; --UNCHK
lin mistiness_N = mkWN (compoundN "höyry" (k40 "isyys")) ; --UNCHK
lin mistletoe_N = mkWN "Loranthus" "europaeus" ; --UNCHK
lin mistranslate_V2 = mkWV2 (k54A "kääntää") "väärin" ; --UNCHK
lin mistranslation_N = mkWN (compoundN "käännös" (k48 "virhe")) ; --UNCHK
lin mistreat_V2 = mkWV2 (k67A "kohdella") "kaltoin" ; --UNCHK
lin mistreatment_N = mkWN (k2 "kohtelu") "huono" ; --UNCHK
lin mistress_N = mkWN (k32A "valtiatar") ; --UNCHK
lin mistrial_N = mkN "mistraali" ;
lin mistrust_N = mkWN (k39 "epäilys") ; --UNCHK
lin mistrust_V2 = mkWV2 (k67 "epäillä") ; --UNCHK
lin mistrustful_A = mkWA (k38 "varovainen") ; --UNCHK
lin misty_A = mkWA (k38 "sumuinen") ; --UNCHK
lin misunderstand_V2 = mkWV2 (k53A "käsittää") "väärin" ; --UNCHK
lin misunderstanding_N = mkWN (k39 "sekaannus") ; --UNCHK
lin misuse_N = mkWN (compoundN "väärin" (k39 "käytös")) ; --UNCHK
lin misuse_V2 = mkWV2 (k53A "käyttää") "väärin" ; --UNCHK
lin mite_N = mkWN (kH1 "punkki") ; --UNCHK
lin miter_N = mkWN (k9 "mitra") ; --UNCHK
lin miterwort_N = mkWN (compoundN "varjo" (k9A "hiippa")) ; --UNCHK
lin mithraic_A = mkWA (compoundA "mithr" (k38 "alainen")) ; --UNCHK
lin mithramycin_N = mkWN "Mithracin" ; --UNCHK
lin mitigable_A = mkWA "lievennettävä" ; --UNCHK
lin mitigate_V2 = mkWV2 (k53A "helpottaa") ; --UNCHK
lin mitigation_N = mkWN (k39 "lievennys") ; --UNCHK
lin mitochondrion_N = mkWN "mitokondrio" ; --UNCHK
lin mitogen_N = mkWN (compoundN "mito" (k5 "geeni")) ; --UNCHK
lin mitomycin_N = mkWN "Mutamycin" ; --UNCHK
lin mitosis_N = mkWN (k5 "mitoosi") ; --UNCHK
lin mitotic_A = mkWA (k38 "mitoottinen") ; --UNCHK
lin mitral_A = mkWA (compoundA "mitra" (k38 "alinen")) ; --UNCHK
lin mitre_N = mkWN (k9 "mitra") ; --UNCHK
lin mitre_joint_N = mkWN (k48 "viiste") ; --UNCHK
lin mitt_N = mkWN (k12 "räpylä") ; --UNCHK
lin mittelschmerz_N = mkWN (compoundN "väli" (k1A "kipu")) ; --UNCHK
lin mitten_N = mkWN (k1A "tumppu") ; --UNCHK
lin mitzvah_N = mkWN "mitzvah" ; --UNCHK
lin mix_N = mkWN (k39 "seos") ; --UNCHK
lin mix_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin mix_V2 = mkWV2 (k53A "sekoittaa") ;
lin mix_up_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin mixed_A = variants {} ; --
lin mixed_up_A = mkA "sekaisin" ;
lin mixer_N = mkWN (k33A "sekoitin") ; --UNCHK
lin mixology_N = mkWN "miksologia" ; --UNCHK
lin mixture_N = mkWN (k39 "seos") ; --UNCHK
lin mizen_N = mkWN (compoundN "mesaani" (k48 "purje")) ; --UNCHK
lin mizzen_N = mkWN (compoundN "mesaani" (k48 "purje")) ; --UNCHK
lin mizzen_mast_N = mkWN (compoundN "mesaani" (k1 "masto")) ; --UNCHK
lin mizzle_V = mkWV (k53A "tihuttaa") ; --UNCHK
lin ml_N = mkWN (compoundN "kuutiosentti" (k5 "metri")) ; --UNCHK
lin mm_N = mkWN (k5 "milli") ; --UNCHK
lin mnemonic_A = mkWA "mnemoninen" ; --UNCHK
lin mnemonic_N = mkWN (compoundN "muisti" (k1A "sääntö")) ; --UNCHK
lin mnemonics_N = mkWN (compoundN "muisti" (k1A "sääntö")) ; --UNCHK
lin mnemonist_N = mkWN (compoundN "mne" (k5 "monisti")) ; --UNCHK
lin mo_N = mkWN "MO" ; --UNCHK
lin mo_PN = foreignPN "Mo" ;
lin moan_N = mkWN (k39 "valitus") ; --UNCHK
lin moan_V = mkWV (k73 "purnata") ; --UNCHK
lin moan_VS = mkWVS (k73 "purnata") ; --UNCHK
lin moat_N = mkWN (k1A "kaivanto") ; --UNCHK
lin moated_A = mkWA (compoundA "valli" (k1 "haudoitettu")) ; --UNCHK
lin mob_N = mkWN (compoundN "ihmis" (k1A "joukko")) ; --UNCHK
lin mob_V2 = mkWV2 (k58A "tunkea") ; --UNCHK
lin mobbish_A = mkWA (k38 "roistomainen") ; --UNCHK
lin mobcap_N = mkWN (k9A "hilkka") ; --UNCHK
lin mobile_A = mkWA (k10 "liikkuva") ;
lin mobile_N = mkWN (k8 "mobile") ; --UNCHK
lin mobility_N = mkWN (k40 "liikkuvuus") ; --UNCHK
lin mobilization_N = mkWN (k3 "mobilisaatio") ; --UNCHK
lin mobilize_V = mkWV (k53A "kierrättää") ; --UNCHK
lin mobilize_V2 = mkWV2 (k53A "kierrättää") ; --UNCHK
lin mobster_N = mkWN (k38 "jengiläinen") ; --UNCHK
lin moccasin_N = mkWN (k5 "mokkasiini") ; --UNCHK
lin mocha_N = mkWN (compoundN "mokka" (k9 "nahka")) ; --UNCHK
lin mock_A = mkWA "teko-" ; --UNCHK
lin mock_N = mkWN (kH1 "pilkka") ; --UNCHK
lin mock_V = mkWV (k73 "halveerata") ; --UNCHK
lin mock_V2 = mkWV2 (k73 "halveerata") ; --UNCHK
lin mock_up_V2 = mkWV2 (k71 "tehdä") "malli" ; --UNCHK
lin mocker_N = mkWN (compoundN "matkija" (k1A "lintu")) ; --UNCHK
lin mockernut_N = mkWN (k6 "hikkori") ; --UNCHK
lin mockery_N = mkWN (k5 "karikatyyri") ; --UNCHK
lin mockingbird_N = mkWN (compoundN "matkija" (k1A "lintu")) ; --UNCHK
lin mockingly_Adv = mkWAdv (k99 "pisteliäästi") ; --UNCHK
lin mod_A = mkWA (k5 "moderni") ; --UNCHK
lin mod_N = mkWN "modi" ; --UNCHK
lin mod_cons_N = mkN "mukavuus" ;
lin modal_A = mkWA (k38 "modaalinen") ; --UNCHK
lin modality_N = mkWN "modaliteetti" ; --UNCHK
lin mode_N = mkN "tapa" ; ---ARB --mkWN (k5 "tyyli") ;
lin model_N = mkN "malli" ;
lin model_V = mkWV (k73A "muokata") ; --UNCHK
lin model_V2 = mkWV2 (k73A "muokata") ; --UNCHK
lin modeler_N = mkWN (k12 "muotoilija") ; --UNCHK
lin modeling_N = mkWN (k39 "mallinnus") ; --UNCHK
lin modeller_N = mkWN (k12 "muotoilija") ; --UNCHK
lin modelling_N = mkWN (k39 "mallinnus") ; --UNCHK
lin modem_N = mkWN (k5 "modeemi") ; --UNCHK
lin modena_PN = foreignPN "Modena" ;
lin moderate_A = mkWA (k38 "kohtuullinen") ; --f56
lin moderate_N = mkWN (k38 "maltillinen") ;
lin moderate_V = mkWV (k69 "hillitä") ; --UNCHK
lin moderate_V2 = mkWV2 (k69 "hillitä") ; --UNCHK
lin moderation_N = mkWN (k39 "lievennys") ; --UNCHK
lin moderationism_N = mkWN (k40 "kohtuullisuus") ; --UNCHK
lin moderationist_N = mkWN (k38 "maltillinen") ; --UNCHK
lin moderato_A = mkWA (k99 "kohtalaisesti") ; --UNCHK
lin moderator_N = mkWN (k12 "sovittelija") ; --UNCHK
lin moderatorship_N = mkWN (compoundN "puheen" (k40 "johtajuus")) ; --UNCHK
lin modern_A = mkA "moderni" | mkWA (compoundA "nyky" (k38 "aikainen")) ;
lin modern_N = mkWN "Bodoni-fontti" ; --UNCHK
lin moderne_A = mkWA (k5 "moderni") ; --UNCHK
lin modernism_N = mkWN (compoundN "nyky" (k40 "aikaisuus")) ; --UNCHK
lin modernist_N = mkWN (kH1 "modernisti") ; --UNCHK
lin modernistic_A = mkWA (k5 "moderni") ; --UNCHK
lin modernity_N = mkWN (k40 "modernius") ; --UNCHK
lin modernization_N = mkN "modernisointi" ; --mkWN (compoundN "uudelleen" (k38 "rakentaminen")) ;
lin modernize_V2 = mkWV2 (k53 "kunnostaa") ; --UNCHK
lin modest_A = mkA "vaatimaton" ;
lin modesty_N = mkWN (k40 "säädyllisyys") ; --UNCHK
lin modicum_N = mkWN (k38 "hiukkanen") ; --UNCHK
lin modifiable_A = mkWA "muunnettava" ; --UNCHK
lin modification_N = mkWN (compoundN "muu" (k38 "ttaminen")) ; --UNCHK
lin modifier_N = mkWN (compoundN "modifikaattori" (k5 "geeni")) ; --UNCHK
lin modify_V2 = mkWV2 (k53A "muuttaa") ; --UNCHK
lin modillion_N = mkWN (k7A "tuki") ; --UNCHK
lin modiolus_N = mkWN "modiolus" ; --UNCHK
lin modish_A = mkWA (k10 "oleva") "muotia" ; --UNCHK
lin modiste_N = mkWN (k5 "modisti") ; --UNCHK
lin modular_A = mkWA (k38 "modulaarinen") ; --UNCHK
lin modulate_V = mkWV (k67A "muunnella") ; --UNCHK
lin modulate_V2 = mkWV2 (k67A "muunnella") ; --UNCHK
lin modulation_N = mkWN "sovittaminen" ; --UNCHK
lin module_N = mkWN (k6 "moduuli") ; --UNCHK
lin modulo_Prep = mkPrep "modulo" nominative ;
lin modulus_N = mkWN (kH1 "kerroin") ; --UNCHK
lin modus_operandi_N = mkWN (k5 "rutiini") ; --UNCHK
lin modus_vivendi_N = mkWN (compoundN "elämän" (k9A "tapa")) ; --UNCHK
lin mogul_N = mkWN (k5 "moguli") ; --UNCHK
lin mohair_N = mkWN (kH1 "villa") "angoravuohen" ; --UNCHK
lin mohammedan_N = mkWN (k38 "muhamettilainen") ; --UNCHK
lin mohawk_N = mkWN (k5 "irokeesi") ; --UNCHK
lin moiety_N = mkWN (k2 "puolisko") ; --UNCHK
lin moil_V = mkWV (k53A "kostuttaa") ; --UNCHK
lin moira_PN = foreignPN "Moira" ;
lin moire_A = mkWA "virikäs" ; --UNCHK
lin moire_N = mkWN (k5A "silkki") "virikäs" ; --UNCHK
lin moist_A = mkWA (k15 "kostea") ; --UNCHK
lin moisten_V = mkWV (k53A "kostuttaa") ; --UNCHK
lin moisten_V2 = mkWV2 (k53A "kostuttaa") ; --UNCHK
lin moistening_N = mkWN (k39 "kostutus") ; --UNCHK
lin moisture_N = mkWN (k40 "märkyys") ; --UNCHK
lin mojarra_N = mkWN "mojarra" ; --UNCHK
lin mojo_N = mkWN (k9A "taika") ; --UNCHK
lin moke_N = mkWN (k5 "aasi") ; --UNCHK
lin moksa_N = mkWN "mokša" ; --UNCHK
lin molal_A = mkWA (compoundA "mola" (k38 "alinen")) ; --UNCHK
lin molality_N = mkWN (k40 "molaalisuus") ; --UNCHK
lin molar_A = mkWA (k38 "molaarinen") ; --UNCHK
lin molar_N = mkWN (compoundN "poski" (k41A "hammas")) ; --UNCHK
lin molarity_N = mkWN (k40 "molaarisuus") ; --UNCHK
lin molasses_N = mkWN (k5 "melassi") ; --UNCHK
lin mold_PN = foreignPN "Mold" ;
lin mold_V = mkWV (k52A "homehtua") ; --UNCHK
lin mold_V2 = mkWV2 (k52A "homehtua") ; --UNCHK
lin moldboard_N = mkWN (k7A "siipi") "auran" ; --UNCHK
lin molding_N = mkWN (k1 "valu") ; --UNCHK
lin moldy_A = mkWA (k38 "homeinen") ; --UNCHK
lin mole_N = mkWN (k10 "myyrä") ; --UNCHK
lin molecular_A = mkWA (k38 "alkeellinen") ; --UNCHK
lin molecule_N = mkWN (k38 "hitunen") ; --UNCHK
lin molehill_N = mkWN (compoundN "myyrän" (k41A "mätäs")) ; --UNCHK
lin moleskin_N = mkWN (k5 "molski") ; --UNCHK
lin molest_V2 = mkWV2 (k53A "hätyyttää") ; --UNCHK
lin molestation_N = mkWN (k2 "ahdistelu") ; --UNCHK
lin molester_N = mkWN (k12 "ahdistelija") ; --UNCHK
lin molindone_N = mkWN "Moban" ; --UNCHK
lin moll_N = mkWN (kH1 "siippa") "gangsterin" ; --UNCHK
lin mollie_N = mkWN (compoundN "hammas" (k5A "karppi")) ; --UNCHK
lin mollification_N = mkWN "tyynnyttäminen" ; --UNCHK
lin mollify_V2 = mkWV2 (k54A "pehmentää") ; --UNCHK
lin mollusc_N = mkWN (k38 "nilviäinen") ; --UNCHK
lin molluscum_N = mkWN (compoundN "ontelo" (k10 "syylä")) ; --UNCHK
lin mollusk_N = mkWN (k38 "nilviäinen") ; --UNCHK
lin mollycoddle_N = mkWN (k5A "lellikki") ; --UNCHK
lin mollycoddle_V2 = mkWV2 (k61 "helliä") ; --UNCHK
lin moloch_N = mkWN (compoundN "piikki" (k1 "piru")) ; --UNCHK
lin molt_N = mkWN (compoundN "karvan" (k1A "lähtö")) ; --UNCHK
lin molten_A = mkWA (k38 "nestemäinen") ; --UNCHK
lin molter_N = mkWN (k10 "luova") "nahkansa" ; --UNCHK
lin molto_Adv = mkWAdv (k99 "paljon") ; --UNCHK
lin molybdenite_N = mkWN (compoundN "molybdeeni" (k48A "hohde")) ; --UNCHK
lin molybdenum_N = mkWN (k5 "molybdeeni") ; --UNCHK
lin mombin_N = mkWN "mombin" ; --UNCHK
lin moment_N = mkN "hetki" "hetkiä" ;
lin momentary_A = mkA "hetkellinen" ; --mkWA (k10 "ohikiitävä") ;
lin momentous_A = mkWA (k15 "tärkeä") ; --UNCHK
lin momentousness_N = mkWN (k40 "tärkeys") ; --UNCHK
lin momentum_N = mkWN (compoundN "liike" (k10 "määrä")) ; --UNCHK
lin momism_N = mkWN (compoundN "yli" (k2 "suojelu")) ; --UNCHK
lin mon_PN = foreignPN "Mon" ;
lin monaco_PN = foreignPN "Monaco" ;
lin monad_N = mkWN (k3 "eliö") "yksisoluinen" ; --UNCHK
lin monaghan_PN = foreignPN "Monaghan" ;
lin monal_N = mkWN (k6 "fasaani") ; --UNCHK
lin monandrous_A = mkWA (compoundA "yks" (k38 "iavioinen")) ; --UNCHK
lin monandry_N = mkWN "yksiavioisuus" ; --UNCHK
lin monarch_N = mkWN (k5A "monarkki") ; --UNCHK
lin monarchal_A = mkWA (k38 "monarkkinen") ; --UNCHK
lin monarchic_A = mkWA (k38 "monarkkinen") ; --UNCHK
lin monarchism_N = mkWN (k5 "monarkismi") ; --UNCHK
lin monarchist_N = mkWN (k5 "monarkisti") ; --UNCHK
lin monarchy_N = mkWN (k12 "monarkia") ; --UNCHK
lin monarda_N = mkWN (compoundN "väri" (k1A "minttu")) ; --UNCHK
lin monastery_N = mkWN (k6 "luostari") ; --UNCHK
lin monastic_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin monasticism_N = mkWN (compoundN "luostari" (k39 "laitos")) ; --UNCHK
lin monatomic_A = mkWA (compoundA "yks" (k38 "iatominen")) ; --UNCHK
lin monaural_A = mkWA (compoundA "monaura" (k38 "alinen")) ; --UNCHK
lin monazite_N = mkWN "monatsiitti" ; --UNCHK
lin monegasque_A = mkWA (compoundA "monaco" (k38 "lainen")) ; --UNCHK
lin monegasque_N = mkWN (compoundN "monaco" (k38 "lainen")) ; --UNCHK
lin moneran_A = mkWA "moneraaninen" ; --UNCHK
lin moneran_N = mkWN (compoundN "pie" (k3 "neliö")) ; --UNCHK
lin monetarism_N = mkWN (k5 "monetarismi") ; --UNCHK
lin monetarist_N = mkWN (k5 "monetaristi") ; --UNCHK
lin monetary_A = mkWA (k38 "rahallinen") ; --f62
lin monetization_N = mkWN (compoundN "laillis" (k38 "taminen")) "valuutan" ; --UNCHK
lin monetize_V2 = mkWV2 (k52 "hyväksyä") "valuutaksi" ; --UNCHK
lin money_N = mkN "raha" ;
lin money_order_N = mkWN (compoundN "posti" (k39 "osoitus")) ; --UNCHK
lin moneybag_N = mkWN (compoundN "raha" (k5 "pussi")) ; --UNCHK
lin moneyed_A = mkWA (k38 "rahallinen") ; --UNCHK
lin money_grubber_N = mkWN (compoundN "rahan" (k48 "ahne")) ; --UNCHK
lin moneylender_N = mkWN (compoundN "koron" (k10 "kiskoja")) ; --UNCHK
lin moneyless_A = mkWA (k34A "rahaton") ; --UNCHK
lin moneymaker_N = mkWN (k5 "projekti") "tuottoisa" ; --UNCHK
lin moneymaking_N = mkWN (compoundN "rahan" (k1A "teko")) ; --UNCHK
lin moneywort_N = mkWN (compoundN "suikero" (k7A "alpi")) ; --UNCHK
lin monger_N = mkWN (k10 "välittäjä") ; --UNCHK
lin mongo_N = mkWN "mongo" ; --UNCHK
lin mongol_A = mkWA (compoundA "mongoli" (k38 "alainen")) ; --UNCHK
lin mongol_N = mkWN (k5 "mongoli") ; --UNCHK
lin mongolia_PN = foreignPN "Mongolia" ;
lin mongolian_A = mkWA (compoundA "mongoli" (k38 "alainen")) ; --UNCHK
lin mongolian_N = mkN "mongoli" ;
lin mongolism_N = mkWN (k10 "syndrooma") "Downin" ; --UNCHK
lin mongoloid_A = mkWA (k38 "mongolidinen") ; --UNCHK
lin mongoloid_N = mkWN (k5 "mongoloidi") ; --UNCHK
lin mongoose_N = mkWN "mungo" ; --UNCHK
lin mongrel_N = mkWN (k10A "hurtta") ; --UNCHK
lin monilia_N = mkWN "monilia" ; --UNCHK
lin monism_N = mkWN (k5 "monismi") ; --UNCHK
lin monistic_A = mkWA (k38 "monistinen") ; --UNCHK
lin monition_N = mkWN (k48 "haaste") ; --UNCHK
lin monitor_N = mkN "valvoja" ; ---ARB --mkN "monitori" ;
lin monitor_V = mkWV (k61A "vahtia") ; --UNCHK
lin monitor_V2 = mkWV2 (k61A "vahtia") ;
lin monitoring_N = mkWN (k9A "valvonta") ; --UNCHK
lin monk_N = mkWN (k5A "munkki") ; --UNCHK
lin monkey_N = mkWN (k12 "apina") ; --UNCHK
lin monkey_V = mkWV (k67 "pelleillä") ; --UNCHK
lin monkey_around_V = mkWV (k67 "pelleillä") ; --UNCHK
lin monkey_jacket_N = mkWN (k5A "takki") "juhlapuvun" ; --UNCHK
lin monkey_nut_N = mkWN (compoundN "maa" (k12 "pähkinä")) ; --UNCHK
lin monkey_puzzle_N = mkWN "Araucaria" "araucana" ; --UNCHK
lin monkey_wrench_N = mkWN (compoundN "jako" (k33 "avain")) ; --UNCHK
lin monkfish_N = mkWN (compoundN "meri" (k6 "enkeli")) ; --UNCHK
lin monkish_A = mkWA (compoundA "munkki" (k38 "mainen")) ; --UNCHK
lin monkshood_N = mkWN "aitoukonhattu" ; --UNCHK
lin monmouth_PN = foreignPN "Monmouth" ;
lin mono_A = mkWA (k38 "monofoninen") ; --UNCHK
lin monoamine_N = mkWN "monoamiini" ; --UNCHK
lin monoblast_N = mkWN (compoundN "monob" (k5 "lasti")) ; --UNCHK
lin monocarboxylic_A = mkWA "monokarboksyyli-" ; --UNCHK
lin monocarp_N = mkWN (k5 "kasvi") "kerran" "hedelmöivä" ; --UNCHK
lin monocarpic_A = mkWA "kerran" "hedelmöivä" ; --UNCHK
lin monochromacy_N = mkWN (compoundN "väri" (k40 "sokeus")) ; --UNCHK
lin monochromat_N = mkWN (compoundN "väri" (k15 "sokea")) ; --UNCHK
lin monochromatic_A = mkWA (compoundA "yksi" (k38 "värinen")) ; --UNCHK
lin monochrome_A = mkWA (compoundA "yksi" (k38 "värinen")) ; --UNCHK
lin monochrome_N = mkWN (k10 "kuva") "yksivärinen" ; --UNCHK
lin monocle_N = mkWN (k6 "monokkeli") ; --UNCHK
lin monocled_A = mkWA (compoundA "silmä" (k38 "lasipäinen")) ; --UNCHK
lin monoclinal_A = mkWA (compoundA "mono" (k38 "kliininen")) ; --UNCHK
lin monocline_N = mkWN (k1 "poimu") "yksipuolinen" ; --UNCHK
lin monoclinic_A = mkWA (compoundA "mono" (k38 "kliininen")) ; --UNCHK
lin monoclinous_A = mkWA (compoundA "kaksineu" (k38 "voinen")) ; --UNCHK
lin monoclonal_A = mkWA (compoundA "monoklona" (k38 "alinen")) ; --UNCHK
lin monocot_N = mkWN (compoundN "yks" (k38 "isirkkainen")) ; --UNCHK
lin monocotyledonous_A = mkWA (compoundA "yks" (k38 "isirkkainen")) ; --UNCHK
lin monoculture_N = mkWN (k2 "viljely") "yksipuolinen" ; --UNCHK
lin monocyte_N = mkWN "monosyytti" ; --UNCHK
lin monocytosis_N = mkWN "monosytoosi" ; --UNCHK
lin monodic_A = mkWA (compoundA "yksi" (k38 "ääninen")) ; --UNCHK
lin monoecious_A = mkWA (k38 "yksikotinen") ; --UNCHK
lin monogamist_N = mkWN (k2 "henkilö") "yksiavioinen" ; --UNCHK
lin monogamous_A = mkWA (compoundA "yks" (k38 "iavioinen")) ; --UNCHK
lin monogamy_N = mkWN (k12 "monogamia") ; --UNCHK
lin monogenesis_N = mkWN "sporulaatio" ; --UNCHK
lin monogenic_A = mkWA (compoundA "mono" (k38 "geeninen")) ; --UNCHK
lin monogram_N = mkWN (k5 "monogrammi") ; --UNCHK
lin monograph_N = mkWN (k12 "monografia") ; --UNCHK
lin monogynous_A = mkWA (k38 "yksivaimoinen") ; --UNCHK
lin monogyny_N = mkWN (k40 "yksivaimoisuus") ; --UNCHK
lin monohybrid_N = mkWN (compoundN "mono" (k5 "hybridi")) ; --UNCHK
lin monohydrate_N = mkWN (compoundN "mono" (k5A "hydraatti")) ; --UNCHK
lin monolatry_N = mkWN (k9A "palvonta") "yhden" "jumalan" ; --UNCHK
lin monolingual_A = mkWA (compoundA "yks" (k38 "ikielinen")) ; --UNCHK
lin monolingual_N = mkWN (k2 "henkilö") "yksikielinen" ; --UNCHK
lin monolith_N = mkWN (k5A "monoliitti") ; --UNCHK
lin monolithic_A = mkWA (k38 "monoliittinen") ; --UNCHK
lin monologist_N = mkWN "monologisti" ; --UNCHK
lin monologue_N = mkWN (k5 "monologi") ; --UNCHK
lin monomania_N = mkWN (compoundN "pakko" (k48A "mielle")) ; --UNCHK
lin monomaniacal_A = mkWA (compoundA "mono" (k38 "maaninen")) ; --UNCHK
lin monometallic_A = mkWA (compoundA "yksi" (k38 "metallinen")) ; --UNCHK
lin monomorphemic_A = mkWA (compoundA "yks" (k38 "imorfeeminen")) ; --UNCHK
lin mononeuropathy_N = mkWN "mononeuropatia" ; --UNCHK
lin mononuclear_A = mkWA (compoundA "yks" (k38 "iytiminen")) ; --UNCHK
lin monophonic_A = mkWA (k38 "monofoninen") ; --UNCHK
lin monophony_N = mkWN (k5A "musiikki") "monofoninen" ; --UNCHK
lin monoplane_N = mkWN (compoundN "lento" (k48 "kone")) "yksitasoinen" ; --UNCHK
lin monoplegia_N = mkWN "monoplegia" ; --UNCHK
lin monopolist_N = mkWN (compoundN "monopoli" (k10 "soija")) ; --UNCHK
lin monopolistic_A = mkWA (k38 "monopolistinen") ; --UNCHK
lin monopolization_N = mkWN (k5A "monopolisointi") ; --UNCHK
lin monopolize_V2 = mkWV2 (k62 "monopolisoida") ; --UNCHK
lin monopoly_N = mkWN "Monopoly" ; --UNCHK
lin monopsony_N = mkWN "monopsoni" ; --UNCHK
lin monorail_N = mkWN (k9A "rata") "yksikiskoinen" ; --UNCHK
lin monorchism_N = mkWN (compoundN "yksikiveks" (k40 "isyys")) ; --UNCHK
lin monosaccharide_N = mkWN (k6 "sokeri") "yksinkertainen" ; --UNCHK
lin monosemous_A = mkWA (compoundA "yks" (k38 "imerkityksinen")) ; --UNCHK
lin monosemy_N = mkWN (compoundN "yksimerkityks" (k40 "isyys")) ; --UNCHK
lin monosomy_N = mkWN (compoundN "monos" (k61 "omia")) ; --UNCHK
lin monosyllabic_A = mkWA (compoundA "yks" (k38 "itavuinen")) ; --UNCHK
lin monosyllable_N = mkWN (k9 "sana") "yksitavuinen" ; --UNCHK
lin monotheism_N = mkWN (k5 "monoteismi") ; --UNCHK
lin monotheist_N = mkWN (k5 "monoteisti") ; --UNCHK
lin monotheistic_A = mkWA (k38 "monoteistinen") ; --UNCHK
lin monotone_N = mkWN (k39 "jaaritus") ; --UNCHK
lin monotonic_A = mkWA (k38 "monotoninen") ; --UNCHK
lin monotonous_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin monotony_N = mkWN (k12 "monotonia") ; --UNCHK
lin monotreme_N = mkWN (k41A "nisäkäs") "muniva" ; --UNCHK
lin monotype_N = mkWN (compoundN "mono" (k5A "tyyppi")) ; --UNCHK
lin monotypic_A = mkWA (compoundA "mono" (k38 "tyyppinen")) ; --UNCHK
lin monounsaturated_A = mkWA (compoundA "yksittäis" (k34A "tyydyttymätön")) ; --UNCHK
lin monovalent_A = mkWA (compoundA "yhden" (k38 "arvoinen")) ; --UNCHK
lin monoxide_N = mkWN (compoundN "mon" (k5 "oksidi")) ; --UNCHK
lin monozygotic_A = mkWA (compoundA "mono" (k38 "tsygoottinen")) ; --UNCHK
lin mons_N = mkWN (compoundN "häpy" (k12 "kukkula")) ; --UNCHK
lin monsieur_N = mkWN (k9 "herra") ; --UNCHK
lin monsignor_N = mkWN "Monsignore" ; --UNCHK
lin monsoon_N = mkWN (k6 "monsuuni") ; --UNCHK
lin monster_N = mkWN (compoundN "epä" (k3 "sikiö")) ; --UNCHK
lin monstera_N = mkWN (k10 "hedelmä") "Monstera" "deliciosan" ; --UNCHK
lin monstrance_N = mkWN (compoundN "mons" (k5 "transsi")) ; --UNCHK
lin monstrosity_N = mkWN (k40 "hirveys") ; --UNCHK
lin monstrous_A = mkWA (k10 "hirvittävä") ; --UNCHK
lin montage_N = mkWN (k5 "montaasi") ; --UNCHK
lin montana_PN = foreignPN "Montana" ;
lin montane_A = mkWA "vuori-" ; --UNCHK
lin monte_N = mkWN "three-card" "monte" ; --UNCHK
lin monterrey_PN = foreignPN "Monterrey" ;
lin montevideo_PN = foreignPN "Montevideo" ;
lin month_N = mkN "kuukausi" "kuukauden" "kuukausia" ;
lin monthlong_A = mkWA (k38 "pituinen") "kuukauden" ; --UNCHK
lin monthly_A = mkA "kuukausittainen" ;
lin monthly_Adv = mkWAdv (k99 "kuukausittain") ;
lin monthly_N = mkWN (compoundN "kuukausi" (k2 "julkaisu")) ; --UNCHK
lin montrose_PN = foreignPN "Montrose" ;
lin montserrat_PN = foreignPN "Montserrat" ;
lin montserratian_A = mkWA (compoundA "montserrati" (k38 "lainen")) ; --UNCHK
lin montserratian_N = mkWN (compoundN "montserrati" (k38 "lainen")) ; --UNCHK
lin monument_N = mkWN (k5A "monumentti") ; --UNCHK
lin monumental_A = mkWA (k38 "monumentaalinen") ; --UNCHK
lin monza_PN = foreignPN "Monza" ;
lin moo_N = mkWN (kH1 "ammunta") ; --UNCHK
lin moo_V = mkWV (k52 "ammua") ; --UNCHK
lin mooch_V = mkWV (k67 "siipeillä") ; --UNCHK
lin moocher_N = mkWN (k12 "siipeilijä") ; --UNCHK
lin mood_N = mkWN (k26 "tuuli") ; --UNCHK
lin moodiness_N = mkWN "ailahteleva" ; --UNCHK
lin moody_A = mkWA (k41A "oikukas") ; --UNCHK
lin moon_N = L.moon_N ;
lin moon_V = mkWV (k53A "näyttää") "persettä" ; --UNCHK
lin moon_V2 = mkWV2 (k53A "näyttää") "persettä" ; --UNCHK
lin moonbeam_N = mkWN (compoundN "kuun" (k48A "säde")) ; --UNCHK
lin moonfish_N = mkWN (compoundN "kiilto" (k9 "lahna")) ; --UNCHK
lin moonflower_N = mkWN (k9 "alba") "Ipomoea" ; --UNCHK
lin moonless_A = mkWA (k34A "kuuton") ; --UNCHK
lin moonlight_N = mkWN (k2 "kuutamo") ; --UNCHK
lin moonlighter_N = mkWN (compoundN "kuutamo" (k12 "urakoitsija")) ; --UNCHK
lin moonlike_A = mkWA (k38 "muotoinen") "kuun" ; --UNCHK
lin moonlit_A = mkWA (k38 "kuutamoinen") ; --UNCHK
lin moonseed_N = mkWN (compoundN "kilpi" (k1A "kierto")) ; --UNCHK
lin moonshine_N = mkWN (k49 "kyynel") "korpikuusen" ; --UNCHK
lin moonstone_N = mkWN (compoundN "kuu" (k7 "kivi")) ; --UNCHK
lin moonstruck_A = mkWA (compoundA "kuu" (k1 "hullu")) ; --UNCHK
lin moonwalk_N = mkWN (compoundN "kuu" (k2 "kävely")) ; --UNCHK
lin moonwort_N = mkWN (compoundN "ketonoidan" (k1A "lukko")) ; --UNCHK
lin moony_A = mkWA (k38 "kuutamoinen") ; --UNCHK
lin moor_N = mkWN (k7 "nummi") ; --UNCHK
lin moor_V2 = mkWV2 (k53A "kiinnittää") "köydellä" ; --UNCHK
lin moorage_N = mkWN (k5A "ankkurointi") ; --UNCHK
lin moorfowl_N = mkWN (compoundN "nummi" (k1A "riekko")) ; --UNCHK
lin moorgame_N = mkWN (compoundN "nummi" (k1A "riekko")) ; --UNCHK
lin moorhen_N = mkWN (compoundN "nummi" (k1A "riekko")) ; --UNCHK
lin mooring_N = mkWN (compoundN "ankkuri" (k27 "köysi")) ; --UNCHK
lin mooring_mast_N = mkWN (compoundN "kiinnitys" (k1 "masto")) ; --UNCHK
lin moorish_A = mkWA (k38 "maurilainen") ; --UNCHK
lin moorland_N = mkWN (k7 "nummi") ; --UNCHK
lin moose_N = mkWN (k7 "hirvi") ; --UNCHK
lin moosewood_N = mkWN "Dirca" "palustris" ; --UNCHK
lin moot_A = mkWA (k34A "ratkaisematon") ; --UNCHK
lin moot_N = mkWN "harjoitusoikeudenkäynti" ; --UNCHK
lin moot_V2 = mkWV2 (k62 "puntaroida") ; --UNCHK
lin mop_N = mkWN (k5A "moppi") ; --UNCHK
lin mop_V = mkWV (k53 "mutristaa") ; --UNCHK
lin mop_V2 = mkWV2 (k53 "mutristaa") ; --UNCHK
lin mop_up_V2 = mkWV2 (k63 "saada") "valmiiksi" ; --UNCHK
lin mope_N = mkWN (k12 "kuhnailija") ; --UNCHK
lin mope_V = mkWV (k53A "jurottaa") ; --UNCHK
lin mope_around_V = mkWV (k53A "jurottaa") ; --UNCHK
lin moped_N = mkWN (k1 "mopo") ; --UNCHK
lin mopper_N = mkWN "luuttuaja" ; --UNCHK
lin moppet_N = mkWN (k2 "tyllerö") ; --UNCHK
lin moquette_N = mkWN "moketti" ; --UNCHK
lin moraceous_A = mkWA (compoundA "mulperi" (k38 "mainen")) ; --UNCHK
lin moraine_N = mkWN (k6 "moreeni") ; --UNCHK
lin moral_A = mkWA (k38 "moraalinen") ;
lin moral_N = mkWN (k1 "läksy") ; --UNCHK
lin morale_N = mkWN (k7A "henki") ;
lin moralism_N = mkWN (k5 "moralismi") ; --UNCHK
lin moralist_N = mkWN (k5 "moralisti") ; --UNCHK
lin moralistic_A = mkWA (compoundA "moralis" (k10 "oiva")) ; --UNCHK
lin morality_N = mkWN (k40 "moraalisuus") ; --UNCHK
lin moralization_N = mkWN (k5A "moralisointi") ; --UNCHK
lin moralize_V = mkWV (k62 "moralisoida") ; --UNCHK
lin moralize_V2 = mkWV2 (k62 "moralisoida") ; --UNCHK
lin moralizing_N = mkWN (k5A "moralisointi") ; --UNCHK
lin morass_N = mkWN (k1A "letto") ; --UNCHK
lin moratorium_N = mkWN (k39 "keskeytys") ; --UNCHK
lin moray_N = mkWN (k13 "mureena") ; --UNCHK
lin morbidity_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin morbidness_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin morbilliform_A = mkWA (compoundA "tuhkarokko" (k38 "mainen")) ; --UNCHK
lin mordacious_A = mkWA (k10 "pureva") ; --UNCHK
lin mordacity_N = mkWN (k40 "purevuus") ; --UNCHK
lin mordant_A = mkWA "erittäin" "syövyttävä" ; --UNCHK
lin mordant_N = mkWN (compoundN "peittaus" (k48 "aine")) ; --UNCHK
lin more_Adv = mkWAdv (k99 "enemmän") ;
lin more_CAdv = S.more_CAdv ;
lin more_N = mkN "lisä" ; ---- ?
lin more_Quant = mkQuant (mkN "useampi" "useamman" "useampia") (exceptNomN (mkN "enempä") "enemmän") ;
lin more_than_AdN = mkAdN "yli" ;
lin more_than_Predet = mkPredet "enemmän kuin" ;
lin morecambe_PN = foreignPN "Morecambe" ;
lin moreen_N = mkWN (k6 "moreeni") ; --UNCHK
lin morel_N = mkWN (compoundN "huhta" (k26 "sieni")) ; --UNCHK
lin morello_N = mkWN "morello" ; --UNCHK
lin moreover_Adv = mkAdv "lisäksi" ;
lin moresque_A = mkWA (k38 "maurilainen") ; --UNCHK
lin morganatic_A = mkWA (compoundA "epä" (k38 "säätyinen")) ; --UNCHK
lin morganite_N = mkWN (compoundN "morg" (k5A "aniitti")) ; --UNCHK
lin morgen_N = mkWN "morgen" ; --UNCHK
lin morgue_N = mkWN (compoundN "ruumis" (k48 "huone")) ; --UNCHK
lin moribund_A = mkWA (k10 "oleva") "kuolemaisillaan" ; --UNCHK
lin morion_N = mkWN (k10 "kypärä") ; --UNCHK
lin morley_PN = foreignPN "Morley" ;
lin mormon_A = mkWA "mormoni-" ; --UNCHK
lin mormon_N = mkWN (k5 "mormoni") ; --UNCHK
lin mormonism_N = mkWN (compoundN "mor" (k5 "monismi")) ; --UNCHK
lin morn_N = mkWN (k1 "aamu") ; --UNCHK
lin morning_N = mkN "aamu" ;
lin morning_glory_N = mkWN "aitoelämänlanka" ; --UNCHK
lin morning_room_N = mkWN (compoundN "arki" (k48 "huone")) ; --UNCHK
lin moroccan_A = mkWA (compoundA "marokko" (k38 "lainen")) ; --UNCHK
lin moroccan_N = mkWN (compoundN "marokko" (k38 "lainen")) ; --UNCHK
lin morocco_N = mkWN (compoundN "kuningas" (k10A "kunta")) "Marokon" ; --UNCHK
lin morocco_PN = foreignPN "Marokko" ;
lin moron_N = mkWN "Moron" ; --UNCHK
lin moronic_A = mkWA (k38 "idioottimainen") ; --UNCHK
lin moronity_N = mkWN (compoundN "vajaamiel" (k40 "isyys")) ; --UNCHK
lin morose_A = mkWA (k15 "äreä") ; --UNCHK
lin moroseness_N = mkWN (k40 "happamuus") ; --UNCHK
lin morosoph_N = mkWN (k5 "narri") ; --UNCHK
lin morpeth_PN = foreignPN "Morpeth" ;
lin morphallaxis_N = mkWN (k3 "regeneraatio") ; --UNCHK
lin morphea_N = mkWN "paikallinen" "skleroderma" ; --UNCHK
lin morpheme_N = mkWN (k5 "morfeemi") ; --UNCHK
lin morphemic_A = mkWA (compoundA "morfeemi" (k38 "nen")) ; --UNCHK
lin morphia_N = mkWN (k5 "morfiini") ; --UNCHK
lin morphine_N = mkWN (k5 "morfiini") ; --UNCHK
lin morphogenesis_N = mkWN "morfogeneesi" ; --UNCHK
lin morphologic_A = mkWA (k38 "rakenteellinen") ; --UNCHK
lin morphological_A = mkWA (k38 "rakenteellinen") ; --UNCHK
lin morphology_N = mkWN (k12 "morfologia") ; --UNCHK
lin morphophoneme_N = mkWN (compoundN "morfofone" (k5 "emi")) ; --UNCHK
lin morphophonemic_A = mkWA "morfofoneeminen" ; --UNCHK
lin morphophonemics_N = mkWN (compoundN "morfofon" (k14A "etiikka")) ; --UNCHK
lin morris_dance_N = mkWN (compoundN "morris-" (k5 "tanssi")) ;
lin morrow_N = mkWN (k10 "päivä") "seuraava" ; --UNCHK
lin morse_N = mkWN (compoundN "Morse-" (k5 "koodi")) "kansainvälinen" ; --UNCHK
lin morsel_N = mkWN (k38 "murunen") ; --UNCHK
lin mortal_A = mkWA (k38 "kuolevainen") ; --UNCHK
lin mortal_N = mkWN (k7A "henki") ; --UNCHK
lin mortality_N = mkWN (k40 "kuolevaisuus") ; --UNCHK
lin mortar_N = mkWN (k5 "haupitsi") ; --UNCHK
lin mortar_V2 = mkWV2 (k52A "sitoa") "laastilla" ; --UNCHK
lin mortarboard_N = mkWN (k48 "päähine") "akateeminen" ; --UNCHK
lin mortgage_N = mkN "kiinnelaina" ;
lin mortgage_V2 = mkWV2 (k53A "kiinnittää") ; --UNCHK
lin mortgagee_N = mkWN (compoundN "kiinnitys" (k10 "velkoja")) ; --UNCHK
lin mortgagor_N = mkWN (compoundN "kiinnitys" (k38 "velallinen")) ; --UNCHK
lin mortice_N = mkWN (k39 "upotus") ; --UNCHK
lin mortice_V2 = mkWV2 (k53A "liittää") "tappiliitoksella" ; --UNCHK
lin mortician_N = mkWN (compoundN "hautaus" (k12 "urakoitsija")) ; --UNCHK
lin mortification_N = mkWN (k39 "kieltäymys") ; --UNCHK
lin mortify_V = mkWV (k52A "kuolioitua") ; --UNCHK
lin mortify_V2 = mkWV2 (k52A "kuolioitua") ; --UNCHK
lin mortise_N = mkWN (k39 "upotus") ; --UNCHK
lin mortise_V2 = mkWV2 (k53A "liittää") "tappiliitoksella" ; --UNCHK
lin mortmain_N = mkWN (k48A "perinne") "kehitystä" "jarruttava" ; --UNCHK
lin mortuary_A = mkWA "hautaus-" ; --UNCHK
lin mortuary_N = mkWN (compoundN "ruumis" (k48 "huone")) ; --UNCHK
lin morula_N = mkWN (k12 "morula") ; --UNCHK
lin mosaic_N = mkWN (k5A "mosaiikki") ; --UNCHK
lin mosaicism_N = mkWN "mosaiikkisuus" ; --UNCHK
lin moscow_1_PN = foreignPN "Moskova" ;
lin moscow_2_PN = foreignPN "Moskova" ;
lin moscow_PN = mkPN "Moskova" ;
lin moselle_N = mkWN "Mosel" ; --UNCHK
lin mosey_V = mkWV (k67 "tallustella") ; --UNCHK
lin moshav_N = mkWN "moshav" ; --UNCHK
lin moslem_A = mkWA (k38 "islamilainen") ; --UNCHK
lin moslem_N = mkWN (k6 "muslimi") ; --UNCHK
lin mosque_N = mkWN (k12 "moskeija") ; --UNCHK
lin mosquito_N = mkWN (k1A "moskiitto") ; --UNCHK
lin mosquito_craft_N = mkWN "moottoritorpedovene" ; --UNCHK
lin mosquito_net_N = mkWN (compoundN "hyttys" (k1A "verkko")) ; --UNCHK
lin mosquitofish_N = mkWN (compoundN "moskiitto" (k9 "kala")) ; --UNCHK
lin moss_N = mkWN (k49 "sammal") ; --UNCHK
lin mossback_N = mkWN (k5 "konservatiivi") ; --UNCHK
lin mossley_PN = foreignPN "Mossley" ;
lin mossy_A = mkWA (k10 "tylsä") ; --UNCHK
lin most_Adv = mkAdv "suurin osa" ;
lin most_Det = mkDet Pl (mkN "usein" "useimman" "useimpia") ;
lin most_Predet = S.most_Predet ;
lin mostaccioli_N = mkWN "mostaccioli" ; --UNCHK
lin mostly_Adv = mkAdv "enimmäkseen" ;
lin mote_N = mkWN (k38 "hitunen") ; --UNCHK
lin motel_N = mkWN (k6 "motelli") ; --UNCHK
lin motet_N = mkWN (k5A "motetti") ; --UNCHK
lin moth_N = mkWN (kH1 "koi") ; --UNCHK
lin mothball_N = mkWN (compoundN "koi" (k1 "pallo")) ; --UNCHK
lin mother_N = mkN "äiti" ;
lin mother_N2 = L.mother_N2 ;
lin mother_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin motherhood_N = mkWN (k40 "äitiys") ; --UNCHK
lin motherland_N = mkWN (compoundN "synnyin" (k18 "maa")) ; --UNCHK
lin motherless_A = mkWA (k34A "äiditön") ; --UNCHK
lin motherlike_A = mkWA (k38 "äidillinen") ; --UNCHK
lin motherliness_N = mkWN (k40 "äidillisyys") ; --UNCHK
lin motherly_A = mkWA (k38 "äidillinen") ; --UNCHK
lin motherwell_PN = foreignPN "Motherwell" ;
lin motherwort_N = mkWN (k12 "nukula") ; --UNCHK
lin mothproof_A = mkWA (compoundA "koin" (k10 "kestävä")) ; --UNCHK
lin mothproof_V2 = mkWV2 (k71 "tehdä") "koinkestäväksi" ; --UNCHK
lin mothy_A = mkWA "täynnä" "koita" ; --UNCHK
lin motif_N = mkWN (k10 "aihelma") ; --UNCHK
lin motile_A = mkWA (compoundA "liikkumisky" (k38 "kyinen")) ; --UNCHK
lin motile_N = mkWN "mieltäjä" ; --UNCHK
lin motilin_N = mkWN "motiliini" ; --UNCHK
lin motility_N = mkWN (k40 "liikkuvuus") ; --UNCHK
lin motion_N = mkWN (k48A "liike") ;
lin motion_V = mkWV (k52A "viittoa") ; --UNCHK
lin motion_V2 = mkWV2 (k52A "viittoa") ; --UNCHK
lin motional_A = mkWA "liike-" ; --UNCHK
lin motionless_A = mkWA (k34A "liikkumaton") ; --UNCHK
lin motionlessness_N = mkWN (k40 "elottomuus") ; --UNCHK
lin motivate_V2 = mkV2 "innostaa" partitive ;
lin motivate_V2V = mkWV2V (k53 "innostaa") ; --UNCHK
lin motivation_N = mkWN (k48A "tarve") ; --UNCHK
lin motivational_A = mkWA "motivaatio-" ; --UNCHK
lin motive_A = mkWA (compoundA "motiv" (k10 "oiva")) ; --UNCHK
lin motive_N = mkN "motiivi" ; --WN (k48A "tarve") ;
lin motiveless_A = mkWA (compoundA "mieli" (k38 "valtainen")) ; --UNCHK
lin motley_A = mkWA (k41A "laikukas") ; --UNCHK
lin motley_N = mkWN (kH1 "kangas") "kirjava" ; --UNCHK
lin motmot_N = mkWN (k5A "motmotti") ; --UNCHK
lin motor_N = mkWN (k6 "moottori") ; --UNCHK
lin motor_V = mkWV (k67 "ajella") ; --UNCHK
lin motorbike_N = mkWN (compoundN "mini" (k1 "moto")) ; --UNCHK
lin motorboat_N = mkWN (compoundN "pika" (k48 "vene")) ; --UNCHK
lin motorcade_N = mkWN (compoundN "auto" (k48 "kulkue")) ; --UNCHK
lin motorcar_N = mkWN (k1 "auto") ; --UNCHK
lin motorcoach_N = mkWN (k5 "bussi") ; --UNCHK
lin motorcycle_N = mkWN (k10 "pyörä") ; --UNCHK
lin motorcycling_N = mkWN (compoundN "moottori" (k2 "pyöräily")) ; --UNCHK
lin motorcyclist_N = mkWN (k5 "motoristi") ; --UNCHK
lin motoring_N = mkWN (k2 "autoilu") ; --UNCHK
lin motorist_N = mkWN (k12 "autoilija") ;
lin motorization_N = mkWN (compoundN "motori" (k5A "sointi")) ; --UNCHK
lin motorize_V2 = mkWV2 (k62 "moottoroida") ; --UNCHK
lin motorman_N = mkWN (compoundN "moottorin" (k10 "käyttäjä")) ; --UNCHK
lin motormouth_N = mkWN "jaarittelija" ; --UNCHK
lin motorway_N = mkWN (compoundN "valta" (k19 "tie")) ; --UNCHK
lin mottle_N = mkWN (compoundN "täplä" (k5A "kuviointi")) ; --UNCHK
lin mottle_V2 = mkWV2 (k53 "varjostaa") ; --UNCHK
lin mottling_N = mkWN "täplittäminen" ; --UNCHK
lin motto_N = mkWN (k5 "fraasi") ; --UNCHK
lin mouflon_N = mkWN "Ovis" "musimon" ; --UNCHK
lin mouhijärvi_PN = mkPN (mkN "Mouhijärvi" "Mouhijärviä") ;
lin moujik_N = mkWN (k14A "musikka") ; --UNCHK
lin mould_1_N = mkWN (k39 "valos") ; --UNCHK
lin mould_2_N = mkWN (k39 "valos") ; --UNCHK
lin mould_3_N = mkWN (k39 "valos") ; --UNCHK
lin mould_V = mkWV (k73A "muokata") ; --UNCHK
lin mould_V2 = mkWV2 (k73A "muokata") ; --UNCHK
lin moulder_V = mkWV (k72A "mädätä") ; --UNCHK
lin moulding_N = mkWN (k39 "muovaus") ; --UNCHK
lin mouldy_A = mkWA (k38 "homeinen") ; --UNCHK
lin moult_N = mkWN (compoundN "karvan" (k1A "lähtö")) ; --UNCHK
lin moult_V = mkWV (k64 "luoda") "nahkansa" ; --UNCHK
lin moult_V2 = mkWV2 (k64 "luoda") "nahkansa" ; --UNCHK
lin mound_N = mkWN (k10 "syöttäjä") ; --UNCHK
lin mount_N = mkWN (compoundN "koho" (k38 "aminen")) ; --UNCHK
lin mount_V = mkWV (k54A "asentaa") ; --UNCHK
lin mount_V2 = mkWV2 (k54A "asentaa") ; --UNCHK
lin mount_up_V = mkWV (k73A "harpata") ; --UNCHK
lin mountain_N = L.mountain_N ;
lin mountaineer_N = mkWN (compoundN "vuori" (k12 "kiipeilijä")) ; --UNCHK
lin mountaineering_N = mkWN (compoundN "vuoristo" (k2 "kiipeily")) ; --UNCHK
lin mountainous_A = mkWA (k38 "vuoristoinen") ; --UNCHK
lin mountainside_N = mkWN (compoundN "vuoren" (k48A "rinne")) ; --UNCHK
lin mountebank_N = mkWN (k6 "huijari") ; --UNCHK
lin mounter_N = mkWN (k12 "kiipeilijä") ; --UNCHK
lin mountie_N = mkWN (compoundN "Moun" (k19 "tie")) ; --UNCHK
lin mounting_N = mkWN (k13 "alusta") ; --UNCHK
lin mourn_V = mkWV (k67 "surra") ; --UNCHK
lin mourn_V2 = mkWV2 (k67 "surra") ; --UNCHK
lin mourner_N = mkWN "vaikertaja" ; --UNCHK
lin mournful_A = mkWA (k10 "sureva") ; --UNCHK
lin mournfulness_N = mkWN (k40 "alakuloisuus") ; --UNCHK
lin mourning_N = mkWN (k1 "suru") ; --UNCHK
lin mourning_band_N = mkWN (compoundN "suru" (k9 "nauha")) ; --UNCHK
lin mourning_ring_N = mkWN (compoundN "suru" (k39 "sormus")) ; --UNCHK
lin mouse_N = mkWN (k24 "hiiri") ; --UNCHK
lin mouse_V = mkWV (k53A "liikuttaa") "hiirtä" ; --UNCHK
lin mousepad_N = mkWN (compoundN "hiiri" (k13 "alusta")) ; --UNCHK
lin mouser_N = mkWN (compoundN "hiiren" (k10 "pyytäjä")) ; --UNCHK
lin mousetrap_N = mkWN (compoundN "ansa" (k5 "peli")) ; --UNCHK
lin moussaka_N = mkWN (k13 "musaka") ; --UNCHK
lin mousse_N = mkWN (compoundN "hius" (k5 "geeli")) ; --UNCHK
lin moustache_N = mkN "viiksi" ;
lin mousy_A = mkWA (compoundA "vilis" (k10 "evä")) "hiiriä" ; --UNCHK
lin mouth_N = L.mouth_N ;
lin mouth_V = mkWV (k56A "virkkaa") ; --UNCHK
lin mouth_V2 = mkWV2 (k56A "virkkaa") ; --UNCHK
lin mouth_off_V = mkWV (k73 "pauhata") ; --UNCHK
lin mouth_organ_N = mkWN (compoundN "huuli" (k1A "harppu")) ; --UNCHK
lin mouthful_N = mkWN (compoundN "suu" (k9 "pala")) ; --UNCHK
lin mouthlike_A = mkWA (compoundA "suu" (k38 "mainen")) ; --UNCHK
lin mouthpart_N = mkWN (k10 "kärsä") ; --UNCHK
lin mouthpiece_N = mkWN (compoundN "suu" (k10 "osa")) ; --UNCHK
lin mouton_N = mkWN (k41A "lammas") ; --UNCHK
lin movability_N = mkWN (k40 "liikkuvuus") ; --UNCHK
lin movable_A = mkWA (k10 "liikkuva") ; --UNCHK
lin move_1_V = mkV "liikkua" ;
lin move_2_V = mkV "muuttaa" ;
lin move_N = mkN "siirto" ;
lin move_V = mkV "liikkua" ;
lin move_V2 = mkV2 "siirtää" | mkV2 "liikuttaa" ;
lin move_ahead_V = advV OP_move_V OP_ahead_Adv ; -- guess-p-verb
lin move_along_V = advV OP_move_V OP_along_Adv ; -- guess-p-verb
lin move_away_V = advV OP_move_V OP_away_Adv ; -- guess-p-verb
lin move_away_from_V2 = prepV2 (advV OP_move_V OP_away_Adv ) OP_from_Prep ; -- guess-p-verb
lin move_down_V2 = prepV2 OP_move_V OP_down_Prep ; -- guess-p-verb
lin move_in_V = mkWV (k53A "muuttaa") ; --UNCHK
lin move_in_on_V2 = mkWV2 (k67A "tungetella") ; --UNCHK
lin move_into_V2 = mkWV2 (k67 "tulla") ; --UNCHK
lin move_on_V = mkWV (k58A "kulkea") "eteenpäin" ; --UNCHK
lin move_on_V2 = mkWV2 (k58A "kulkea") "eteenpäin" ; --UNCHK
lin move_out_V = mkWV (k53A "muuttaa") "pois" ; --UNCHK
lin move_out_V2 = mkWV2 (k53A "muuttaa") "pois" ; --UNCHK
lin move_towards_V2 = prepV2 OP_move_V OP_towards_Prep ; -- guess-p-verb
lin move_up_V = mkWV (k67 "tulla") "ylös" ; --UNCHK
lin move_up_V2 = mkWV2 (k67 "tulla") "ylös" ; --UNCHK
lin movement_N = mkN "liike" ;
lin mover_N = mkWN (compoundN "muutto" (k48A "liike")) ; --UNCHK
lin movie_N = mkN "elokuva" ;
lin moviegoer_N = mkWN (k10 "ystävä") "elokuvan" ; --UNCHK
lin moviemaking_N = mkWN (k39 "filmaus") ; --UNCHK
lin moving_A = mkA "liikkuva" ;
lin mow_N = mkWN (compoundN "heinä" (k10 "suova")) ; --UNCHK
lin mow_V = mkWV (k53 "mutristaa") ; --UNCHK
lin mow_V2 = mkWV2 (k53 "mutristaa") ; --UNCHK
lin mower_N = mkWN (compoundN "ruohon" (k6 "leikkuri")) ; --UNCHK
lin mown_A = mkWA (compoundA "lei" (k1 "kattu")) ; --UNCHK
lin mozambican_A = mkWA (compoundA "mosambiki" (k38 "lainen")) ; --UNCHK
lin mozambican_N = mkWN (compoundN "mosambiki" (k38 "lainen")) ; --UNCHK
lin mozambique_PN = foreignPN "Mosambik" ;
lin mozzarella_N = mkWN "mozzarella" ; --UNCHK
lin mp_N = mkWN (compoundN "sotilas" (k6 "poliisi")) ; --UNCHK
lin mph_N = mkWN "mph" ; --UNCHK
lin ms_N = mkN "rouva" ;
lin msasa_N = mkWN "Brachystegia" "speciformis" ; --UNCHK
lin msc_N = mkWN (k6 "maisteri") "filosofian" ; --UNCHK
lin mu_N = mkWN "myy" ; --UNCHK
lin much_AdA = lin AdA (ss "suuresti") ;
lin much_Adv = mkAdv "paljon" ;
lin much_Det = S.much_Det ;
lin much_N = mkWN (k99 "paljon") ; --UNCHK
lin muchness_N = mkWN (k40 "suuruus") ; --UNCHK
lin muciferous_A = mkWA (k38 "limainen") ; --UNCHK
lin mucilage_N = mkWN (k9 "liima") ; --UNCHK
lin mucin_N = mkWN "musiini" ; --UNCHK
lin mucinoid_A = mkWA (k38 "tapainen") "musiinin" ; --UNCHK
lin mucinous_A = mkWA (k38 "limainen") ; --UNCHK
lin muck_N = mkWN (k10A "sonta") ; --UNCHK
lin muck_V = mkWV (k53A "ottaa") "pois" ; --UNCHK
lin muck_V2 = mkWV2 (k53A "ottaa") "pois" ; --UNCHK
lin muckle_N = mkWN (k99 "roppakaupalla") ; --UNCHK
lin muckraker_N = mkWN (compoundN "loan" (k10 "heittäjä")) ; --UNCHK
lin muckraking_N = mkWN (compoundN "loan" (k1A "heitto")) ; --UNCHK
lin mucky_A = mkWA (k38 "kurainen") ; --UNCHK
lin mucocutaneous_A = mkWA "mukokutaaninen" ; --UNCHK
lin mucoid_A = mkWA (k38 "limainen") ; --UNCHK
lin mucoid_N = mkWN "mukoidi" ; --UNCHK
lin mucopolysaccharide_N = mkWN (compoundN "mukopoly" (k5 "sakkaridi")) ; --UNCHK
lin mucopolysaccharidosis_N = mkWN "mukopolysakkaridoosi" ; --UNCHK
lin mucopurulent_A = mkWA "mukopurulentti" ; --UNCHK
lin mucor_N = mkWN "mucor" ; --UNCHK
lin mucosal_A = mkWA "limakalvo-" ; --UNCHK
lin mucous_A = mkWA "mukoosi" ; --UNCHK
lin mucuna_N = mkWN "mucuna" ; --UNCHK
lin mucus_N = mkWN (k10A "räkä") ; --UNCHK
lin mud_N = mkWN (k10A "loka") ; --UNCHK
lin mud_V2 = mkWV2 (k74 "saveta") ; --UNCHK
lin mud_bath_N = mkWN (compoundN "muta" (k1A "kylpy")) ; --UNCHK
lin mudder_N = mkWN "mudder" ; --UNCHK
lin muddle_N = mkWN (k48A "pinne") ; --UNCHK
lin muddle_V = mkWV (k58 "sotkea") ; --UNCHK
lin muddle_V2 = mkWV2 (k58 "sotkea") ; --UNCHK
lin muddy_A = mkWA (k38 "kurainen") ; --UNCHK
lin muddy_V2 = mkWV2 (k54A "samentaa") ; --UNCHK
lin mudguard_N = mkWN (k10 "lokasuoja") ; --UNCHK
lin mudhif_N = mkWN (compoundN "kaisla" (k1 "talo")) ; --UNCHK
lin mudra_N = mkWN "mudra" ; --UNCHK
lin mudskipper_N = mkWN "liejuryömijä" ; --UNCHK
lin mudslide_N = mkWN (compoundN "muta" (k1 "vyöry")) ; --UNCHK
lin mudslinger_N = mkWN (compoundN "loan" (k10 "heittäjä")) ; --UNCHK
lin muesli_N = mkWN (k5 "mysli") ; --UNCHK
lin muezzin_N = mkWN "muessin" ; --UNCHK
lin muff_N = mkWN (k39 "munaus") ; --UNCHK
lin muff_V2 = mkWV2 (k71 "tehdä") "virhe" ; --UNCHK
lin muffin_N = mkWN (k6 "muffini") ; --UNCHK
lin muffin_man_N = mkWN (compoundN "muffini" (k41 "kauppias")) ; --UNCHK
lin muffle_N = mkWN (compoundN "muhveliu" (k24 "uni")) ; --UNCHK
lin muffle_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin muffler_N = mkWN (k33A "vaimennin") ; --UNCHK
lin mufti_N = mkWN (compoundN "siviili" (k1A "puku")) ; --UNCHK
lin mug_N = mkWN (k5 "muki") ; --UNCHK
lin mug_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin mug_up_V = mkWV (k56A "ahtaa") "päähänsä" ; --UNCHK
lin muggee_N = mkWN (k5 "uhri") "ryöstön" ; --UNCHK
lin mugger_N = mkWN (k10 "ryöstäjä") ; --UNCHK
lin mugginess_N = mkWN "hiostavuus" ; --UNCHK
lin mugging_N = mkWN (k1 "ryöstö") "väkivaltainen" ; --UNCHK
lin muggins_N = mkWN (k1 "pöllö") ; --UNCHK
lin muggy_A = mkWA (k38 "höyryinen") ; --UNCHK
lin mugwort_N = mkWN (k1 "pujo") ; --UNCHK
lin mugwump_N = mkWN (k12 "olija") "odottavalla" "kannalla" ; --UNCHK
lin muhammadan_A = mkWA (k38 "muhamettilainen") ; --UNCHK
lin muhammadan_N = mkWN (k38 "muhamettilainen") ; --UNCHK
lin muhammadanism_N = mkWN (k40 "muhamettilaisuus") ; --UNCHK
lin muhos_PN = mkPN "Muhos" ;
lin muishond_N = mkWN (compoundN "kirjo" (k10A "kärppä")) ; --UNCHK
lin mujahid_N = mkWN "mujahideen" ; --UNCHK
lin mujahidin_N = mkWN "mujahideen" ; --UNCHK
lin mujtihad_N = mkWN "mujtihad" ; --UNCHK
lin mulatto_N = mkWN (k5A "mulatti") ; --UNCHK
lin mulberry_N = mkWN (k9 "marja") "silkkiäispuun" ; --UNCHK
lin mulch_N = mkWN (compoundN "maan" (k48A "kate")) ; --UNCHK
lin mulch_V2 = mkWV2 (k56A "kattaa") "oljilla" ; --UNCHK
lin mulct_V2 = mkWV2 (k53A "sakottaa") ; --UNCHK
lin mule_N = mkWN (k5 "muuli") ; --UNCHK
lin muleteer_N = mkWN (k6 "ajuri") ; --UNCHK
lin mulhouse_PN = foreignPN "Mulhouse" ;
lin mulish_A = mkWA (k34A "peräänantamaton") ; --UNCHK
lin mulishness_N = mkWN (k40 "uppiniskaisuus") ; --UNCHK
lin mull_N = mkWN "Mull" ; --UNCHK
lin mull_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin mull_over_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin mullah_N = mkWN "Mulla" ; --UNCHK
lin mullein_N = mkWN (compoundN "ukontuli" (k10A "kukka")) ; --UNCHK
lin muller_N = mkWN (compoundN "glögi" (k1 "pannu")) ; --UNCHK
lin mullet_N = mkWN "mullo" ; --UNCHK
lin mulligatawny_N = mkWN (compoundN "curry" (k1A "keitto")) ; --UNCHK
lin mullion_N = mkWN (compoundN "pysty" (k9 "piena")) ; --UNCHK
lin mullioned_A = mkWA (compoundA "moni" (k38 "osainen")) ; --UNCHK
lin mulloway_N = mkWN (compoundN "juutalais" (k9 "kala")) ; --UNCHK
lin multia_PN = mkPN "Multia" ;
lin multicellular_A = mkWA (compoundA "moniso" (k38 "luinen")) ; --UNCHK
lin multicollinearity_N = mkWN "multikollineaarisuus" ; --UNCHK
lin multicultural_A = mkWA (compoundA "moni" (k38 "kulttuurinen")) ; --UNCHK
lin multiculturalism_N = mkWN "monikulttuurisuus" ; --UNCHK
lin multidimensional_A = mkWA (compoundA "moni" (k38 "ulotteinen")) ; --UNCHK
lin multiethnic_A = mkWA (compoundA "moni" (k38 "etninen")) ; --UNCHK
lin multifactorial_A = mkWA (compoundA "moniteki" (k38 "jäinen")) ; --UNCHK
lin multifarious_A = mkWA (k38 "moninainen") ; --UNCHK
lin multiflora_N = mkWN "japaninköynnösruusu" ; --UNCHK
lin multiform_A = mkWA (compoundA "moni" (k38 "muotoinen")) ; --UNCHK
lin multilane_A = mkWA (compoundA "moni" (k38 "kaistainen")) ; --UNCHK
lin multilateral_A = mkWA (compoundA "moni" (k38 "puolinen")) ; --UNCHK
lin multilevel_A = mkWA (compoundA "moni" (k38 "kerroksinen")) ; --UNCHK
lin multi_lingual_A = mkWA (compoundA "moni" (k38 "kielinen")) ; --UNCHK
lin multimedia_N = mkWN (compoundN "multimedia" (k10 "järjestelmä")) ; --UNCHK
lin multinational_A = mkWA (compoundA "moni" (k38 "kansallinen")) ; --UNCHK
lin multinucleate_A = mkWA (compoundA "monitu" (k38 "mainen")) ; --UNCHK
lin multipartite_A = mkWA (compoundA "moni" (k38 "osainen")) ; --UNCHK
lin multiphase_A = mkWA (compoundA "moni" (k38 "vaiheinen")) ; --UNCHK
lin multiple_A = mkWA (k15 "usea") ; --UNCHK
lin multiple_N = mkWN (compoundN "moni" (k9A "kerta")) ; --UNCHK
lin multiplex_A = mkWA (compoundA "moni" (k38 "nkertainen")) ; --UNCHK
lin multiplex_N = mkWN (compoundN "elokuva" (k6 "teatteri")) ; --UNCHK
lin multiplexer_N = mkWN (compoundN "kanavointi" (k48A "laite")) ; --UNCHK
lin multiplicand_N = mkWN (k10 "kerrottava") ; --UNCHK
lin multiplication_N = mkWN (compoundN "lisä" (k38 "äntyminen")) ; --UNCHK
lin multiplicative_A = mkWA "moninkertaistava" ; --UNCHK
lin multiplicity_N = mkWN (k40 "paljous") ; --UNCHK
lin multiplier_N = mkWN (k10 "kertoja") ; --UNCHK
lin multiply_V = mkWV (k56 "jatkaa") "sukua" ; --UNCHK
lin multiply_V2 = mkWV2 (k56 "jatkaa") "sukua" ; --UNCHK
lin multipotent_A = mkWA (compoundA "moniky" (k38 "kyinen")) ; --UNCHK
lin multiprocessing_N = mkWN (compoundN "rinnakkais" (k1 "ajo")) ; --UNCHK
lin multiprocessor_N = mkWN (compoundN "moni" (k33A "suoritin")) ; --UNCHK
lin multiprogramming_N = mkWN (compoundN "rinnakkais" (k39 "suoritus")) ; --UNCHK
lin multipurpose_A = mkWA (compoundA "monikäytt" (k38 "öinen")) ; --UNCHK
lin multiracial_A = mkWA (compoundA "moni" (k38 "rotuinen")) ; --UNCHK
lin multistage_N = mkWN (compoundN "moni" (k38 "vaiheinen")) ; --UNCHK
lin multistory_A = mkWA (compoundA "moni" (k38 "kerroksinen")) ; --UNCHK
lin multitude_N = mkWN (k7A "väki") ; --UNCHK
lin multitudinous_A = mkWA (k34A "rajaton") ; --UNCHK
lin multitudinousness_N = mkWN "runsaslukuisuus" ; --UNCHK
lin multivalent_A = mkWA (compoundA "moni" (k38 "valenssinen")) ; --UNCHK
lin multivariate_A = mkWA (compoundA "moni" (k38 "ulotteinen")) ; --UNCHK
lin multiversity_N = mkWN (compoundN "yli" (k2 "opisto")) "laaja" ; --UNCHK
lin multivitamin_N = mkWN "monivitamiinipilleri" ; --UNCHK
lin multum_in_parvo_N = mkN "tiivistelmä" ; ---ARB separateN "multum in" (mkN "parvo") ; ----sanaliitto ; meaning: much in little ; summary
lin mum_A = mkWA (k38 "hiljainen") ; --UNCHK
lin mum_N = mkN "äiti" ;
lin mumble_N = mkWN (k12 "mumina") ; --UNCHK
lin mumble_V = mkWV (k54A "mongertaa") ; --UNCHK
lin mumble_V2 = mkWV2 (k54A "mongertaa") ; --UNCHK
lin mumbling_N = mkWN (k2 "mutustelu") ; --UNCHK
lin mumbo_jumbo_N = mkWN (compoundN "hölyn" (k1 "pöly")) ; --UNCHK
lin mummer_N = mkWN (k4A "miimikko") ; --UNCHK
lin mummery_N = mkWN (k2 "imartelu") ; --UNCHK
lin mummichog_N = mkWN "Fundulus" "heteroclitus" ; --UNCHK
lin mummification_N = mkWN "muumiointi" ; --UNCHK
lin mummify_V2 = mkWV2 (k52 "kuivua") ; --UNCHK
lin mummy_N = mkWN (k3 "muumio") ; --UNCHK
lin mumps_N = mkWN (compoundN "siko" (k5A "tauti")) ; --UNCHK
lin mumpsimus_N = mkWN (k39 "uskomus") ; --UNCHK
lin munch_N = mkWN (kH1 "haukku") ; --UNCHK
lin munch_V = mkWV (k67A "rouskutella") ; --UNCHK
lin munch_V2 = mkWV2 (k67A "rouskutella") ; --UNCHK
lin muncher_N = mkWN "rouskuttelija" ; --UNCHK
lin mundane_A = mkA "maallinen" ;
lin mung_N = mkWN (compoundN "mungo" (k1A "papu")) ; --UNCHK
lin munich_PN = foreignPN "München" ;
lin municipal_A = mkWA (k38 "kunnallinen") ; --f67
lin municipality_N = mkWN (k10A "kunta") ; --UNCHK
lin munificence_N = mkWN (k40 "anteliaisuus") ; --UNCHK
lin munificent_A = mkWA (k41 "aulis") ; --UNCHK
lin munition_N = mkWN (k39 "linnoitus") ; --UNCHK
lin munition_V2 = mkWV2 (k53 "aseistaa") ; --UNCHK
lin munj_N = mkWN (compoundN "norsu" (k10 "heinä")) ; --UNCHK
lin munster_PN = foreignPN "Munster" ;
lin muntjac_N = mkWN (k5A "muntjakki") ; --UNCHK
lin muon_N = mkWN "negatiivinen" "myoni" ; --UNCHK
lin muonio_PN = mkPN "Muonio" ;
lin mural_A = mkWA "seinä-" ; --UNCHK
lin mural_N = mkWN (k39 "seinämaalaus") ; --UNCHK
lin muralist_N = mkWN (k12 "tekijä") "seinämaalausten" ; --UNCHK
lin murder_N = mkN "murha" ;
lin murder_V2 = mkV2 "murhata" ;
lin murderee_N = mkWN (compoundN "mur" (k1A "hattu")) ; --UNCHK
lin murderer_N = mkWN (k10 "tappaja") ; --UNCHK
lin murderess_N = mkWN (k10 "murhaaja") ; --UNCHK
lin murderous_A = mkWA (k10 "murhaava") ; --UNCHK
lin murderousness_N = mkWN "murhanhimoisuus" ; --UNCHK
lin murine_A = mkWA "rotta-" ; --UNCHK
lin murine_N = mkWN (compoundN "rotta" (k33 "eläin")) ; --UNCHK
lin murk_N = mkWN (k1A "utu") ; --UNCHK
lin murky_A = mkWA (k10 "hämärä") ; --UNCHK
lin murmur_N = mkWN (compoundN "švaavo" (k5 "kaali")) ; --UNCHK
lin murmur_V = mkWV (k66 "äristä") ; --UNCHK
lin murmur_V2 = mkWV2 (k66 "äristä") ; --UNCHK
lin murmurous_A = mkWA "kuiskaileva" ; --UNCHK
lin murphy_N = mkWN (k5A "potaatti") ; --UNCHK
lin murrain_N = mkWN (compoundN "karja" (k1A "rutto")) ; --UNCHK
lin murre_N = mkWN "kiisla" ; --UNCHK
lin murton_PN = foreignPN "Murton" ;
lin muscadine_N = mkWN (k5 "muskatelli") ; --UNCHK
lin muscat_N = mkWN (compoundN "muskatelli" (k48 "rypäle")) ; --UNCHK
lin muscatel_N = mkWN (compoundN "muskatelli" (k48 "rypäle")) ; --UNCHK
lin muscle_N = mkWN (k10 "voima") ; ---ARB --mkN "lihas" "lihaksia" ;
lin muscle_V = mkWV (k52A "tunkeutua") ; --UNCHK
lin muscle_V2 = mkWV2 (k52A "tunkeutua") ; --UNCHK
lin muscle_into_V2 = mkWV2 (k52A "tunkeutua") "sisään" ; --UNCHK
lin muscleman_N = mkWN (compoundN "kehon" (k10 "rakentaja")) ; --UNCHK
lin muscovite_A = mkWA (compoundA "moskov" (k38 "alainen")) ; --UNCHK
lin muscovite_N = mkWN (compoundN "moskov" (k38 "alainen")) ; --UNCHK
lin muscovy_N = mkWN (compoundN "Mos" (k10 "kova")) ; --UNCHK
lin muscular_A = mkWA (k41A "lihaksikas") ; --UNCHK
lin muscularity_N = mkWN (k40 "pontevuus") ; --UNCHK
lin musculoskeletal_A = mkWA (compoundA "muskuloskeleta" (k38 "alinen")) ; --UNCHK
lin muse_N = mkWN (k10 "muusa") ; --UNCHK
lin muse_V = mkWV (k61 "tuumia") ; --UNCHK
lin muse_VS = mkWVS (k61 "tuumia") ; --UNCHK
lin muser_N = mkWN (k12 "mietiskelijä") ; --UNCHK
lin musette_N = mkWN (compoundN "säkki" (k5 "pilli")) ; --UNCHK
lin museum_N = mkWN (k3 "museo") ;
lin mush_N = mkWN (compoundN "koiravaljakko" (k2 "ajelu")) ; --UNCHK
lin musher_N = mkWN (k10 "ajaja") "koiravaljakon" ; --UNCHK
lin mushiness_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin mushroom_N = mkWN (k26 "sieni") ;
lin mushroom_V = mkWV (k52 "paisua") ; --UNCHK
lin mushy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin music_N = L.music_N ;
lin music_box_N = mkWN (compoundN "soitto" (k12 "rasia")) ; --UNCHK
lin music_hall_N = mkWN (compoundN "varietee" (k6 "teatteri")) ; --UNCHK
lin music_stand_N = mkWN (compoundN "nuotti" (k48 "teline")) ; --UNCHK
lin music_stool_N = mkWN (compoundN "piano" (k5 "tuoli")) ; --UNCHK
lin musical_A = mkWA (k38 "melodinen") ; --UNCHK
lin musical_N = mkWN (k5 "musikaali") ; --UNCHK
lin musical_box_N = mkWN (compoundN "soitto" (k12 "rasia")) ; --UNCHK
lin musicality_N = mkWN (k40 "musikaalisuus") ; --UNCHK
lin musicianFem_N = mkN "muusikko" ;
lin musicianMasc_N = variants {} ; --
lin musicianship_N = mkWN (compoundN "soitto" (k1A "taito")) ; --UNCHK
lin musicological_A = mkWA (compoundA "musiikki" (k38 "tieteellinen")) ; --UNCHK
lin musicologist_N = mkWN (compoundN "musiikki" (k12 "tieteilijä")) ; --UNCHK
lin musicology_N = mkWN (k12 "musikologia") ; --UNCHK
lin musingly_Adv = mkWAdv "mietiskelevästi" ; --UNCHK
lin musk_N = mkWN (k5 "myski") ; --UNCHK
lin musk_deer_N = mkWN (compoundN "myski" (k7 "hirvi")) ; --UNCHK
lin musk_rose_N = mkWN (compoundN "myski" (k1 "ruusu")) ; --UNCHK
lin muskellunge_N = mkWN (compoundN "jätti" (k7A "hauki")) ; --UNCHK
lin musket_N = mkWN (k5A "musketti") ; --UNCHK
lin musketeer_N = mkWN (k5 "musketööri") ; --UNCHK
lin musketry_N = mkWN (compoundN "ampuma" (k1A "taito")) ; --UNCHK
lin muskmelon_N = mkWN (k6 "meloni") ; --UNCHK
lin muskrat_N = mkWN (k6 "piisami") ; --UNCHK
lin muskwood_N = mkWN "Olearia" "argophylla" ; --UNCHK
lin musky_A = mkWA (compoundA "myski" (k38 "nen")) ; --UNCHK
lin muslim_N = mkWN (k6 "muslimi") ; --UNCHK
lin muslin_N = mkWN (k6 "musliini") ; --UNCHK
lin musnud_N = mkWN (compoundN "valta" (k33 "istuin")) ; --UNCHK
lin musophobia_N = mkWN (compoundN "hiiri" (k1 "kammo")) ; --UNCHK
lin musquash_N = mkWN (k6 "piisami") ; --UNCHK
lin muss_N = mkWN (k1 "sotku") ; --UNCHK
lin muss_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin mussel_N = mkWN (k14A "simpukka") ; --UNCHK
lin musselburgh_PN = foreignPN "Musselburgh" ;
lin must_N = mkWN (k40 "tunkkaisuus") ; --UNCHK
lin must_VV = S.must_VV ;
lin mustachioed_A = mkWA (k41A "viiksekäs") ; --UNCHK
lin mustang_N = mkWN (k5 "mustangi") ; --UNCHK
lin mustard_N = mkWN (k5A "sinappi") ; --UNCHK
lin muster_N = mkWN (k9A "kutsunta") ; --UNCHK
lin muster_V = mkWV (k52 "kutsua") "palvelukseen" ; --UNCHK
lin muster_V2 = mkWV2 (k52 "kutsua") "palvelukseen" ; --UNCHK
lin musth_N = mkWN "raivotila" ; --UNCHK
lin mustiness_N = mkWN (k40 "tunkkaisuus") ; --UNCHK
lin musty_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin mutability_N = mkWN (k40 "muuttuvuus") ; --UNCHK
lin mutable_A = mkWA "vaihteleva" ; --UNCHK
lin mutafacient_A = mkWA (compoundA "help" (k10 "ottava")) "mutaatiota" ; --UNCHK
lin mutagen_N = mkWN (k5 "mutageeni") ; --UNCHK
lin mutagenesis_N = mkWN "mutageneesi" ; --UNCHK
lin mutagenic_A = mkWA (k38 "mutageeninen") ; --UNCHK
lin mutant_A = mkWA "mutantti-" ; --UNCHK
lin mutant_N = mkWN (k5A "mutantti") ; --UNCHK
lin mutation_N = mkWN (k39 "muutos") ; --UNCHK
lin mutational_A = mkWA "mutaatio-" ; --UNCHK
lin mutatis_mutandis_Adv = mkWAdv "tarpeellisin" "muutoksin" ; --UNCHK
lin mutative_A = mkWA "mutatoituva" ; --UNCHK
lin mutchkin_N = mkWN "mutchkin" ; --UNCHK
lin mute_A = mkWA (k10A "mykkä") ; --UNCHK
lin mute_N = mkWN (k33A "vaimennin") ; --UNCHK
lin mute_V2 = mkWV2 (k54A "vaientaa") ; --UNCHK
lin muteness_N = mkWN (k40 "puhumattomuus") ; --UNCHK
lin mutilate_V = mkWV (k67 "turmella") ; --UNCHK
lin mutilate_V2 = mkWV2 (k67 "turmella") ; --UNCHK
lin mutilation_N = mkWN "silpominen" ; --UNCHK
lin mutilator_N = mkWN (compoundN "silp" (k10 "oja")) ; --UNCHK
lin mutineer_N = mkWN (k38 "kapinallinen") ; --UNCHK
lin mutinous_A = mkWA (k38 "kapinallinen") ; --UNCHK
lin mutiny_N = mkWN (k12 "kapina") ; --UNCHK
lin mutiny_V = mkWV (k68 "kapinoida") ; --UNCHK
lin mutisia_N = mkWN "mutisia" ; --UNCHK
lin mutism_N = mkWN (k40 "puhumattomuus") ; --UNCHK
lin muton_N = mkWN "mutoni" ; --UNCHK
lin mutt_N = mkWN (k10A "hurtta") ; --UNCHK
lin mutter_N = mkWN (k39 "purnaus") ; --UNCHK
lin mutter_V = mkWV (k66 "äristä") ; --UNCHK
lin mutter_V2 = mkWV2 (k66 "äristä") ; --UNCHK
lin mutterer_N = mkWN (compoundN "mumi" (k9 "sija")) ; --UNCHK
lin mutton_N = mkWN (k41A "lammas") ; --UNCHK
lin mutual_A = mkWA (k38 "keskinäinen") ; --f89
lin mutuality_N = mkWN (k40 "molemminpuolisuus") ; --UNCHK
lin muurame_PN = mkPN "Muurame" ;
lin muurla_PN = mkPN "Muurla" ;
lin muzhik_N = mkWN (k14A "musikka") ; --UNCHK
lin muzzle_N = mkWN (kH1 "turpa") ; --UNCHK
lin muzzle_V2 = mkWV2 (k56A "laittaa") "kuonokoppa" ; --UNCHK
lin muzzle_velocity_N = mkWN (compoundN "lähtö" (k40 "nopeus")) ; --UNCHK
lin muzzler_N = mkWN (k12 "pukija") "kuonokoppien" ; --UNCHK
lin muzzy_A = mkWA (k38 "sekainen") ; --UNCHK
lin myalgia_N = mkWN (compoundN "lihas" (k1A "särky")) ; --UNCHK
lin myalgic_A = mkWA "myalginen" ; --UNCHK
lin myasthenia_N = mkWN (compoundN "lihas" (k40 "heikkous")) ; --UNCHK
lin mycelium_N = mkWN (k2 "rihmasto") ; --UNCHK
lin mycobacteria_N = mkWN (compoundN "mykobak" (k26 "teeri")) ; --UNCHK
lin mycologist_N = mkWN (compoundN "sieni" (k12 "tieteilijä")) ; --UNCHK
lin mycology_N = mkWN (k12 "mykologia") ; --UNCHK
lin mycomycin_N = mkWN "mykomysiini" ; --UNCHK
lin mycophagist_N = mkWN (compoundN "sienen" (k10 "syöjä")) ; --UNCHK
lin mycophagy_N = mkWN (compoundN "sienen" (k5A "syönti")) ; --UNCHK
lin mycoplasma_N = mkWN (compoundN "myko" (k9 "plasma")) ; --UNCHK
lin mycotoxin_N = mkWN (compoundN "home" (k1A "myrkky")) ; --UNCHK
lin mydriasis_N = mkWN (compoundN "mustuais" (k10 "laajentuma")) ; --UNCHK
lin mydriatic_N = mkWN (compoundN "lääke" (k48 "aine")) "silmäterää" "laajentava" ; --UNCHK
lin myelatelia_N = mkWN "myelatelia" ; --UNCHK
lin myelencephalon_N = mkWN (compoundN "ydin" (k48 "jatke")) ; --UNCHK
lin myelic_A = mkWA "myelooinen" ; --UNCHK
lin myelin_N = mkWN "medulla" ; --UNCHK
lin myelinated_A = mkWA "medulloitunut" ; --UNCHK
lin myelinic_A = mkWA "myeliininen" ; --UNCHK
lin myelinization_N = mkWN "myelinisaatio" ; --UNCHK
lin myelitis_N = mkWN (compoundN "selkäydin" (k39 "tulehdus")) ; --UNCHK
lin myeloblast_N = mkWN "varhaisjyvässolu" ; --UNCHK
lin myelocyte_N = mkWN "myelosyytti" ; --UNCHK
lin myelofibrosis_N = mkWN "myelofibroosi" ; --UNCHK
lin myelogram_N = mkWN "myelogrammi" ; --UNCHK
lin myelography_N = mkWN "myelografia" ; --UNCHK
lin myeloid_A = mkWA "myeloidi" ; --UNCHK
lin myeloma_N = mkWN (compoundN "luuydin" (k33 "kasvain")) ; --UNCHK
lin myelomeningocele_N = mkWN (compoundN "myelomeningose" (k48 "ele")) ; --UNCHK
lin myiasis_N = mkWN (compoundN "myi" (k5 "aasi")) ; --UNCHK
lin mylodon_N = mkWN "mylodon" ; --UNCHK
lin mylodontid_N = mkWN "mylodontid" ; --UNCHK
lin myna_N = mkWN (compoundN "laulu" (k38 "kottarainen")) "pyhä" ; --UNCHK
lin mynämäki_PN = mkPN (mkN "Mynämäki" "Mynämäkiä") ;
lin myocardial_A = mkWA (compoundA "myokardia" (k38 "alinen")) ; --UNCHK
lin myocardium_N = mkWN (compoundN "sydän" (k39 "lihas")) ; --UNCHK
lin myoclonus_N = mkWN "myoklonus" ; --UNCHK
lin myofibril_N = mkWN (compoundN "lihas" (k48A "säie")) ; --UNCHK
lin myoglobin_N = mkWN "myoglobiini" ; --UNCHK
lin myoglobinuria_N = mkWN "myoglobinuria" ; --UNCHK
lin myogram_N = mkWN "myogrammi" ; --UNCHK
lin myoid_A = mkWA "myoidi" ; --UNCHK
lin myology_N = mkWN "myologia" ; --UNCHK
lin myoma_N = mkWN (compoundN "lihas" (k33 "kasvain")) ; --UNCHK
lin myometrium_N = mkWN (compoundN "kohtu" (k39 "lihas")) ; --UNCHK
lin myonecrosis_N = mkWN (compoundN "myo" (k5 "nekroosi")) ; --UNCHK
lin myopathic_A = mkWA "myopaattinen" ; --UNCHK
lin myopathy_N = mkWN "myopatia" ; --UNCHK
lin myope_N = mkWN (k38 "ihminen") "likinäköinen" ; --UNCHK
lin myopia_N = mkWN (compoundN "liki" (k40 "näköisyys")) ; --UNCHK
lin myopic_A = mkWA (compoundA "liki" (k38 "näköinen")) ; --UNCHK
lin myosarcoma_N = mkWN (compoundN "myo" (k10 "sarkooma")) ; --UNCHK
lin myosin_N = mkWN "myosiini" ; --UNCHK
lin myositis_N = mkWN (compoundN "lihas" (k39 "tulehdus")) ; --UNCHK
lin myotonia_N = mkWN "myotonia" ; --UNCHK
lin myotonic_A = mkWA "myotoninen" ; --UNCHK
lin myra_PN = foreignPN "Myra" ;
lin myriad_A = mkWA (k34A "rajaton") ; --UNCHK
lin myriad_N = mkWN "kymmenentuhatta" ; --UNCHK
lin myriagram_N = mkWN "myg" ; --UNCHK
lin myriameter_N = mkWN (compoundN "penin" (k10 "kulma")) ; --UNCHK
lin myringoplasty_N = mkWN (compoundN "myringopl" (k12 "astia")) ; --UNCHK
lin myrmecophagous_A = mkWA "muurahaisia" "syövä" ; --UNCHK
lin myrmecophile_N = mkWN (compoundN "muurahais" (k41 "vieras")) ; --UNCHK
lin myrmecophilous_A = mkWA "muurahaisvieras-" ; --UNCHK
lin myrmecophyte_N = mkWN (compoundN "muurahais" (k5 "kasvi")) ; --UNCHK
lin myrmecophytic_A = mkWA (compoundA "suos" (k9 "iva")) "muurahaisia" ; --UNCHK
lin myrmidon_N = mkWN "myrmidoni" ; --UNCHK
lin myrrh_N = mkWN (k10 "myrha") ; --UNCHK
lin myrskylä_PN = mkPN "Myrskylä" ;
lin myrtle_N = mkWN (compoundN "pikku" (k3 "talvio")) ; --UNCHK
lin mysophilia_N = mkWN "mysofilia" ; --UNCHK
lin mysophobia_N = mkWN (compoundN "myso" (k12 "fobia")) ; --UNCHK
lin mysophobic_A = mkWA "mysofobinen" ; --UNCHK
lin mysterious_A = mkA "mystinen" ; --mkWA (k38 "okkulttinen") ;
lin mystery_N = mkWN (k12 "asia") "tuntematon" ; --UNCHK
lin mysticFem_N = mkWN (k4A "mystikko") "uskonnollinen" ; --UNCHK
lin mysticMasc_N = mkWN (k4A "mystikko") "uskonnollinen" ; --UNCHK
lin mystic_A = mkWA (k38 "mystinen") ; --UNCHK
lin mystical_A = mkWA (k38 "mystinen") ; --UNCHK
lin mysticism_N = mkWN (compoundN "mystis" (k5 "ismi")) ; --UNCHK
lin mystification_N = mkWN (k39 "hämmennys") ; --UNCHK
lin mystify_V2 = mkWV2 (k54A "hämmentää") ; --UNCHK
lin mystique_N = mkWN (k1A "hohto") ; --UNCHK
lin myth_N = mkWN (k39 "uskomus") ; --UNCHK
lin mythic_A = mkWA (k38 "myyttinen") ; --UNCHK
lin mythical_A = mkWA (k38 "tarumainen") ; --UNCHK
lin mythological_A = mkWA (k38 "tarumainen") ; --UNCHK
lin mythologist_N = mkWN (k5 "mytologi") ; --UNCHK
lin mythologization_N = mkWN (k38 "tekeminen") "myytiksi" ; --UNCHK
lin mythology_N = mkWN (k12 "mytologia") ; --UNCHK
lin myxedema_N = mkWN (compoundN "myks" (k11 "ödeema")) ; --UNCHK
lin myxobacteria_N = mkWN (compoundN "myksobak" (k26 "teeri")) ; --UNCHK
lin myxoma_N = mkWN (compoundN "myk" (k10 "sooma")) ; --UNCHK
lin myxomatosis_N = mkWN "myksomatoosi" ; --UNCHK
lin myxosporidian_N = mkWN "myksosporidi" ; --UNCHK
lin myxovirus_N = mkWN (compoundN "mykso" (k39 "virus")) ; --UNCHK
lin mäntsälä_PN = mkPN "Mäntsälä" ;
lin mänttä_PN = mkPN "Mänttä" ;
lin mäntyharju_PN = mkPN "Mäntyharju" ;
lin naantali_PN = mkPN "Naantali" ;
lin nab_V2 = mkWV2 (k73A "napata") ; --UNCHK
lin nabob_N = mkWN (compoundN "uppo" (k41A "rikas")) ; --UNCHK
lin naboom_N = mkWN "Euphorbia" "ingens" ; --UNCHK
lin nabumetone_N = mkWN "Relafen" ; --UNCHK
lin nacelle_N = mkWN (compoundN "moottori" (k1A "kehto")) ; --UNCHK
lin nacho_N = mkWN "nacho" ; --UNCHK
lin nacre_N = mkWN (k38 "helmiäinen") ; --UNCHK
lin nacreous_A = mkWA "helmiäis-" ; --UNCHK
lin nadir_N = mkWN (compoundN "nad" (k5 "iiri")) ; --UNCHK
lin nadolol_N = mkWN "Corgard" ; --UNCHK
lin nafcillin_N = mkWN "Nafcil" ; --UNCHK
lin nag_N = mkWN (k10 "luuska") ; --UNCHK
lin nag_V = mkWV (k53A "jäkättää") ; --UNCHK
lin nag_V2 = mkWV2 (k53A "jäkättää") ; --UNCHK
lin nagami_N = mkWN (k5A "kumkvatti") ; --UNCHK
lin nagger_N = mkWN (compoundN "äkä" (k5 "pussi")) ; --UNCHK
lin nagi_N = mkWN "Nageia" "nagi" ; --UNCHK
lin nagpur_PN = foreignPN "Nagpur" ;
lin nagu_PN = mkPN "Nauvo" ;
lin naiad_N = mkWN (compoundN "veden" (k1A "neito")) ; --UNCHK
lin naiant_A = mkWA (k10 "uiva") ; --UNCHK
lin naif_N = mkWN (k38 "ihminen") "naiivi" ; --UNCHK
lin nail_N = mkWN (k9 "naula") ; --UNCHK
lin nail_V2 = mkWV2 (k73A "napata") "syöttö" ; --UNCHK
lin nail_down_V2 = mkWV2 (k64 "lyödä") "lukkoon" ; --UNCHK
lin nail_polish_N = mkWN (k9A "kynsilakka") ; --UNCHK
lin nail_varnish_N = mkWN (k9A "kynsilakka") ; --UNCHK
lin nailbrush_N = mkWN (compoundN "kynsi" (k9 "harja")) ; --UNCHK
lin nailer_N = mkWN (compoundN "naula" (k10A "seppä")) ; --UNCHK
lin nailfile_N = mkWN (compoundN "kynsi" (k9 "viila")) ; --UNCHK
lin nailhead_N = mkWN (k9A "kanta") "naulan" ; --UNCHK
lin nailsea_PN = foreignPN "Nailsea" ;
lin nainsook_N = mkWN "nainsook" ; --UNCHK
lin naira_N = mkWN "naira" ; --UNCHK
lin nairn_PN = foreignPN "Nairn" ;
lin nairobi_PN = foreignPN "Nairobi" ;
lin naive_A = mkWA (k38 "lapsellinen") ; --UNCHK
lin naivete_N = mkWN (k40 "typeryys") ; --UNCHK
lin naivety_N = mkWN (k40 "typeryys") ; --UNCHK
lin naked_A = mkA "alaston" ;
lin nakedness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin nakedwood_N = mkWN "Eugenia" "dicrana" ; --UNCHK
lin nakkila_PN = mkPN "Nakkila" ;
lin nalorphine_N = mkWN (compoundN "nalor" (k5 "fiini")) ; --UNCHK
lin naloxone_N = mkWN "Narcan" ; --UNCHK
lin naltrexone_N = mkWN "naltreksoni" ; --UNCHK
lin name_N = L.name_N ;
lin name_V2 = mkV2 "nimetä" ;
lin name_V3 = mkV3 (mkV "nimittää") accusative (mkPrep translative) ;
lin name_day_N = mkWN (compoundN "nimi" (k10 "päivä")) ; --UNCHK
lin name_drop_V = mkV (mkV "ylpeillä") "hienoilla tuttavuuksilla" ;
lin name_part_N = mkWN (compoundN "nimi" (k5 "rooli")) ; --UNCHK
lin nameko_N = mkWN (compoundN "kanto" (k26 "sieni")) ; --UNCHK
lin nameless_A = mkWA (k34A "nimetön") ; --UNCHK
lin namely_Adv = mkWAdv (k99 "nimittäin") ;
lin nameplate_N = mkWN (compoundN "nimi" (k9A "laatta")) ;
lin namer_N = mkWN "nimeäjä" ; --UNCHK
lin namesake_N = mkWN (k9 "kaima") ; --UNCHK
lin namibia_PN = foreignPN "Namibia" ;
lin namibianFem_N = mkWN (compoundN "namibi" (k38 "alainen")) ; --UNCHK
lin namibianMasc_N = mkWN (compoundN "namibi" (k38 "alainen")) ; --UNCHK
lin namibian_A = mkWA (compoundA "namibi" (k38 "alainen")) ; --UNCHK
lin naming_N = mkWN (compoundN "nimi" (k38 "ttäminen")) ; --UNCHK
lin nan_N = mkWN (compoundN "naan-" (k10A "leipä")) ; --UNCHK
lin nanchang_PN = foreignPN "Nanchang" ;
lin nancy_PN = foreignPN "Nancy" ;
lin nandrolone_N = mkWN "Kabolin" ; --UNCHK
lin nankeen_N = mkWN "nankiini" ; --UNCHK
lin nanning_PN = foreignPN "Nanning" ;
lin nanny_N = mkWN (k1A "kuttu") ; --UNCHK
lin nanogram_N = mkWN (compoundN "nano" (k9 "gramma")) ; --UNCHK
lin nanometer_N = mkWN (compoundN "nano" (k5 "metri")) ; --UNCHK
lin nanomia_N = mkWN (compoundN "nan" (k61 "omia")) ; --UNCHK
lin nanophthalmos_N = mkWN "nanoftalmia" ; --UNCHK
lin nanosecond_N = mkWN (compoundN "nano" (k5A "sekunti")) ; --UNCHK
lin nanotechnology_N = mkWN (compoundN "nano" (k12 "teknologia")) ; --UNCHK
lin nanovolt_N = mkWN (k5A "nanovoltti") ; --UNCHK
lin nantwich_PN = foreignPN "Nantwich" ;
lin nap_N = mkWN "napoleon" ; --UNCHK
lin nap_V = mkWV (k53A "ottaa") "nokoset" ; --UNCHK
lin napalm_N = mkWN (k5 "napalm") ; --UNCHK
lin nape_N = mkWN (k9 "niska") ; --UNCHK
lin naphazoline_N = mkWN "Sudafed" ; --UNCHK
lin naphtha_N = mkWN (k9 "nafta") ; --UNCHK
lin naphthalene_N = mkWN (k5 "naftaleeni") ; --UNCHK
lin naphthol_N = mkWN "naftoli" ; --UNCHK
lin napkin_N = mkWN (k9A "vaippa") ; --UNCHK
lin napkin_ring_N = mkWN (compoundN "lautasliina" (k41A "rengas")) ; --UNCHK
lin naples_PN = foreignPN "Napoli" ;
lin napoleon_N = mkWN "napoleon" ; --UNCHK
lin napoleonic_A = mkWA "Napoleonin" ; --UNCHK
lin napoli_PN = foreignPN "Napoli" ;
lin nappy_N = mkWN (k9A "vaippa") ; --UNCHK
lin naprapath_N = mkWN (k5A "naprapaatti") ; --UNCHK
lin naprapathy_N = mkWN (k12 "naprapatia") ; --UNCHK
lin naproxen_N = mkWN "Naprosyn" ; --UNCHK
lin napu_N = mkWN (compoundN "jaavankääpiö" (k41 "kauris")) ; --UNCHK
lin naranjilla_N = mkWN "Solanum" "quitoense" ; --UNCHK
lin narborough_PN = foreignPN "Narborough" ;
lin narc_N = mkWN (compoundN "huume" (k6 "poliisi")) ; --UNCHK
lin narcissism_N = mkWN (k5 "narsismi") ; --UNCHK
lin narcissist_N = mkWN (k5 "narsisti") ; --UNCHK
lin narcissus_N = mkWN "Narkissos" ; --UNCHK
lin narcolepsy_N = mkWN (compoundN "nukahtelu" (k40 "sairaus")) ; --UNCHK
lin narcoleptic_A = mkWA "narkoleptinen" ; --UNCHK
lin narcoleptic_N = mkWN "narkolepti" ; --UNCHK
lin narcosis_N = mkWN (k6 "narkoosi") ; --UNCHK
lin narcoterrorism_N = mkWN (k5 "terrorismi") "huumekaupalla" "rahoitettu" ; --UNCHK
lin narcotic_A = mkWA "huume-" ; --UNCHK
lin narcotic_N = mkWN (k48 "huume") ; --UNCHK
lin nard_N = mkWN (compoundN "nardus" (k1 "öljy")) ; --UNCHK
lin nardoo_N = mkWN (compoundN "apila" (k38 "saniainen")) ; --UNCHK
lin narial_A = mkWA "sierain-" ; --UNCHK
lin naris_N = mkWN (k33 "sierain") ; --UNCHK
lin nark_N = mkWN (compoundN "huume" (k6 "poliisi")) ; --UNCHK
lin nark_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin narrate_V2 = mkWV2 (k52 "lausua") ; --UNCHK
lin narration_N = mkWN (k39 "kertomus") ; --UNCHK
lin narrative_A = mkWA "kertova" ; --UNCHK
lin narrative_N = mkWN (k39 "kertomus") ; --UNCHK
lin narrator_N = mkWN (k10 "kertoja") ; --UNCHK
lin narrow_A = L.narrow_A ;
lin narrow_N = mkWN (k7 "salmi") ; --UNCHK
lin narrow_V = mkWV (k52A "kaventua") ;
lin narrow_V2 = mkV2 "kaventaa" partitive ;
lin narrow_down_V2 = mkWV2 (k53A "rajoittaa") ; --UNCHK
lin narrowing_N = mkWN "kaventaminen" ; --UNCHK
lin narrowness_N = mkWN (k40 "hoikkuus") ; --UNCHK
lin narthex_N = mkWN (k5 "eteishalli") ; --UNCHK
lin narwhal_N = mkWN (compoundN "sarvi" (k41 "valas")) ; --UNCHK
lin nary_Predet = mkPredet "n-arvoinen" ;
lin nasal_A = mkWA "nenä-" ; --UNCHK
lin nasal_N = mkWN (compoundN "nenä" (k18 "luu")) ; --UNCHK
lin nasality_N = mkWN "nasaalisuus" ; --UNCHK
lin nasalization_N = mkWN (compoundN "nasali" (k5A "sointi")) ; --UNCHK
lin nasalize_V2 = mkWV2 (compoundV "nasali" (k62 "soida")) ; --UNCHK
lin nascent_A = mkWA (k26 "nuori") ; --UNCHK
lin nasion_N = mkWN "nasion" ; --UNCHK
lin nasopharyngeal_A = mkWA (compoundA "nasofaryngea" (k38 "alinen")) ; --UNCHK
lin nasopharynx_N = mkWN (compoundN "nenä" (k1 "nielu")) ; --UNCHK
lin nastiness_N = mkWN (k40 "ilkeys") ; --UNCHK
lin nastola_PN = mkPN "Nastola" ;
lin nasturtium_N = mkWN (compoundN "koriste" (k5 "krassi")) ; --UNCHK
lin nasty_A = mkWA (k9 "paha") ; --UNCHK
lin natal_A = mkWA "syntymä-" ; --UNCHK
lin nation_N = mkN "kansa" (mkN "kunta") ;
lin national_A = mkA "kansallinen" ;
lin national_N = mkWN (k38 "alamainen") ; --UNCHK
lin nationalism_N = mkWN (compoundN "kansallis" (k48A "tunne")) ; --UNCHK
lin nationalist_A = mkWA (compoundA "kansa" (k38 "llismielinen")) ; --UNCHK
lin nationalist_N = mkWN (k5 "nationalisti") ; --UNCHK
lin nationalistic_A = mkWA (compoundA "kansa" (k38 "llismielinen")) ; --UNCHK
lin nationality_N = mkWN (k9 "kansa") ; --UNCHK
lin nationalization_N = mkWN (k38 "tekeminen") "kommunistiseksi" ; --UNCHK
lin nationalize_V2 = mkWV2 (k62 "sosialisoida") ; --UNCHK
lin nationhood_N = mkWN "kansakuntana" "oleminen" ; --UNCHK
lin nationwide_A = mkWA (compoundA "maan" (k38 "laajuinen")) ; --UNCHK
lin nationwide_Adv = mkWAdv (k99 "valtakunnallisesti") ; --UNCHK
lin native_A = mkA (mkN "synty" (mkN "peräinen")) ;
lin native_N = mkWN (compoundN "eliö" (k5 "laji")) "kotoperäinen" ; --UNCHK
lin nativeness_N = mkWN (compoundN "alkuperä" (k40 "isyys")) ; --UNCHK
lin nativism_N = mkWN (compoundN "nativ" (k5 "ismi")) ; --UNCHK
lin nativist_A = mkWA "nativistinen" ; --UNCHK
lin nativist_N = mkWN (compoundN "nati" (k5 "visti")) ; --UNCHK
lin nativity_N = mkWN (k10 "syntymä") "Kristuksen" ; --UNCHK
lin nato_PN = foreignPN "Nato" ;
lin natriuresis_N = mkWN "natriureesi" ; --UNCHK
lin natriuretic_A = mkWA (compoundA "natriur" (k38 "eettinen")) ; --UNCHK
lin natrolite_N = mkWN "natroliitti" ; --UNCHK
lin natter_V = mkWV (k66 "horista") ; --UNCHK
lin natterjack_N = mkWN (compoundN "haisu" (k10 "konna")) ; --UNCHK
lin natty_A = mkWA (k15 "upea") ; --UNCHK
lin natural_A = mkA "luonnollinen" ;
lin natural_N = mkWN "natural" ; --UNCHK
lin naturalism_N = mkWN (k5 "naturalismi") ; --UNCHK
lin naturalist_N = mkWN (compoundN "luonnon" (k12 "tieteilijä")) ; --UNCHK
lin naturalistic_A = mkWA (k38 "realistinen") ; --UNCHK
lin naturalization_N = mkWN (compoundN "muka" (k38 "utuminen")) "ääntämyksen" ; --UNCHK
lin naturalize_V = mkWV (k67 "viljellä") ; --UNCHK
lin naturalize_V2 = mkWV2 (k67 "viljellä") ; --UNCHK
lin naturalness_N = mkWN (k40 "luonnollisuus") ; --UNCHK
lin nature_N = mkN "luonto" ;
lin naturism_N = mkWN (k5 "naturismi") ; --UNCHK
lin naturist_N = mkWN (k5 "naturisti") ; --UNCHK
lin naturistic_A = mkWA (compoundA "naturisti" (k38 "nen")) ; --UNCHK
lin naturopath_N = mkWN (compoundN "luonnon" (k10 "parantaja")) ; --UNCHK
lin naturopathy_N = mkWN (compoundN "luontais" (k9A "lääkintä")) ; --UNCHK
lin naught_N = mkWN (compoundN "epä" (k38 "onnistuminen")) ; --UNCHK
lin naughtiness_N = mkWN (k40 "tottelemattomuus") ; --UNCHK
lin naughty_A = mkWA (k15 "ilkeä") ; --UNCHK
lin naumachy_N = mkWN "naumachia" ; --UNCHK
lin nauru_PN = foreignPN "Nauru" ;
lin nauruan_A = mkWA (compoundA "nauru" (k38 "lainen")) ; --UNCHK
lin nauruan_N = mkWN (compoundN "nauru" (k38 "lainen")) ; --UNCHK
lin nausea_N = mkWN (k39 "kuvotus") ; --UNCHK
lin nauseate_V2 = mkWV2 (k53A "kuvottaa") ; --UNCHK
lin nauseating_A = mkWA (k10 "inhottava") ; --UNCHK
lin nauseous_A = mkWA (k10 "pahoinvoiva") ; --UNCHK
lin nautch_N = mkWN (compoundN "tanssi" (k39 "esitys")) ; --UNCHK
lin nautch_girl_N = mkWN (k32A "tanssijatar") ; --UNCHK
lin nautical_A = mkWA "meri-" ; --UNCHK
lin nautilus_N = mkWN (compoundN "helmi" (k48 "vene")) ; --UNCHK
lin naval_A = mkWA (compoundA "merivoim" (k32A "ien")) ; --UNCHK
lin nave_N = mkWN (compoundN "keski" (k9 "laiva")) ; --UNCHK
lin navel_N = mkWN (k9A "napa") ; --UNCHK
lin navicular_A = mkWA (k38 "muotoinen") "veneen" ; --UNCHK
lin navigability_N = mkWN (compoundN "purjehdus" (k40 "kelpoisuus")) ; --UNCHK
lin navigable_A = mkWA (compoundA "meri" (k38 "kelpoinen")) ; --UNCHK
lin navigate_V = mkWV (k73 "seilata") ; --UNCHK
lin navigate_V2 = mkWV2 (k73 "seilata") ; --UNCHK
lin navigation_N = mkWN (k5A "navigointi") ; --UNCHK
lin navigational_A = mkWA "merenkulku-" ; --UNCHK
lin navigator_N = mkWN (compoundN "meren" (k12 "kulkija")) ; --UNCHK
lin navvy_N = mkWN (kH1 "peoni") ; --UNCHK
lin navy_N = mkWN (compoundN "laivaston" (k38 "sininen")) ; --UNCHK
lin nawab_N = mkWN (k41 "ruhtinas") ; --UNCHK
lin nay_Adv = mkWAdv (k99 "oikeastaan") ; --UNCHK
lin nay_N = mkWN (compoundN "ei-" (k26 "ääni")) ; --UNCHK
lin naysay_V2 = mkV2 "vastustaa" ;
lin naysayer_N = mkWN (k10 "vastustaja") ; --UNCHK
lin naysaying_N = mkWN "kieltäytyminen" ; --UNCHK
lin nazi_A = mkWA (compoundA "kansallis" (k38 "sosialistinen")) ; --UNCHK
lin nazi_N = mkWN (k5 "natsi") "saksalainen" ; --UNCHK
lin nazism_N = mkWN (k5 "natsismi") ; --UNCHK
lin ne'er_Adv = mkWAdv (k99 "ei koskaan") ; --UNCHK
lin ne_plus_ultra_N = mkWN (k40 "virheettömyys") ; --UNCHK
lin neanderthal_A = mkWA (compoundA "neandert" (k36 "alin")) ; --UNCHK
lin neap_N = mkWN (compoundN "nousu" (k27 "vesi")) "matalin" ; --UNCHK
lin neap_tide_N = mkWN (compoundN "nousu" (k27 "vesi")) "matalin" ; --UNCHK
lin neapolitan_A = mkWA (compoundA "napoli" (k38 "lainen")) ; --UNCHK
lin neapolitan_N = mkWN (compoundN "napoli" (k38 "lainen")) ; --UNCHK
lin near_A = L.near_A ;
lin near_Adv = mkWAdv (k99 "liki") ; --UNCHK
lin near_Prep = postPrep genitive "lähellä" ;
lin near_V = mkV "lähestyä" ; --mkWV (k67 "tulla") "lähelle" ;
lin near_V2 = mkWV2 (k67 "tulla") "lähelle" ; --UNCHK
lin near_to_Prep = mkPrep "lähellä" ;
lin nearby_A = mkA "läheinen" ;
lin nearby_Adv = mkWAdv (k99 "lähellä") ; --UNCHK
lin nearer_Adv = mkWAdv (k99 "lähempänä") ; --UNCHK
lin nearer_Prep = mkPrep "lähempänä" partitive ;
lin nearest_Adv = mkWAdv (k99 "lähimpänä") ; --UNCHK
lin nearest_Prep = mkPrep "lähimpänä" partitive ;
lin nearly_Adv = mkAdv "lähestulkoon" | adjAdv near_A ; -- derived
lin nearness_N = mkWN (k40 "likeisyys") ; --UNCHK
lin nearside_N = mkWN (k26 "puoli") "oikea" ; --UNCHK
lin near_sighted_A = mkWA (compoundA "liki" (k38 "näköinen")) ; --UNCHK
lin neat_A = mkWA (k10 "taitava") ; --UNCHK
lin neath_PN = foreignPN "Neath" ;
lin neatness_N = mkWN (k40 "siisteys") ; --UNCHK
lin nebbish_N = mkWN (k6 "tomppeli") ; --UNCHK
lin nebuchadnezzar_N = mkWN "nebukadnessar" ; --UNCHK
lin nebula_N = mkWN (k10 "samentuma") ; --UNCHK
lin nebular_A = mkWA "tähtisumu-" ; --UNCHK
lin nebule_N = mkWN (compoundN "pikku" (k7 "pilvi")) ; --UNCHK
lin nebulous_A = mkWA "tähtisumu-" ; --UNCHK
lin necessary_A = mkA "välttämätön" ;
lin necessary_N = mkWN (k48A "tarve") ; --UNCHK
lin necessitarian_N = mkWN (compoundN "determi" (k5 "nisti")) ; --UNCHK
lin necessitate_V2 = mkWV2 (k52 "kysyä") ; --UNCHK
lin necessitous_A = mkWA (k34A "varaton") ; --UNCHK
lin necessity_N = mkWN (k48A "tarve") ; --UNCHK
lin neck_N = mkN "kaula" ; ---ARB mkN "niska"
lin neck_V = mkWV (k67 "lemmiskellä") ; --UNCHK
lin neckband_N = mkWN (k9A "panta") ; --UNCHK
lin neckcloth_N = mkWN (k5A "kravatti") ; --UNCHK
lin necked_A = mkWA (k38 "-kaulainen") ; --UNCHK
lin necker_N = mkWN "halailija" ; --UNCHK
lin neckerchief_N = mkWN (k5 "huivi") ; --UNCHK
lin necklace_N = mkWN (compoundN "kaula" (k9 "nauha")) ; --UNCHK
lin neckless_A = mkWA "kaulaton" ; --UNCHK
lin necklet_N = mkWN (k39 "kaulus") ; --UNCHK
lin necklike_A = mkWA (compoundA "kaula" (k38 "mainen")) ; --UNCHK
lin neckline_N = mkWN (compoundN "kaula-" (k1A "aukko")) ; --UNCHK
lin neckpiece_N = mkWN (k39 "kaulus") ; --UNCHK
lin necktie_N = mkWN (k5A "kravatti") ; --UNCHK
lin necrobiosis_N = mkWN (compoundN "solu" (k10 "kuolema")) ; --UNCHK
lin necrology_N = mkWN (k2 "luettelo") "vainajien" ; --UNCHK
lin necrolysis_N = mkWN (compoundN "nekroly" (k5 "ysi")) ; --UNCHK
lin necromancer_N = mkWN (k10 "manaaja") "henkien" ; --UNCHK
lin necromancy_N = mkWN (compoundN "man" (k38 "aaminen")) "henkien" ; --UNCHK
lin necromantic_A = mkWA (compoundA "nek" (k38 "romanttinen")) ; --UNCHK
lin necrophagia_N = mkWN (compoundN "raadon" (k5A "syönti")) ; --UNCHK
lin necrophilia_N = mkWN "nekrofilia" ; --UNCHK
lin necropolis_N = mkWN (k2 "kalmisto") ; --UNCHK
lin necrosis_N = mkWN (k5 "nekroosi") ; --UNCHK
lin necrotic_A = mkWA (k38 "kuolioinen") ; --UNCHK
lin nectar_N = mkWN (k6 "nektari") ; --UNCHK
lin nectariferous_A = mkWA (k38 "metinen") ; --UNCHK
lin nectarine_N = mkWN (k5 "nektariini") ; --UNCHK
lin nectary_N = mkWN (k38 "mesiäinen") ; --UNCHK
lin nee_A = mkWA "o.s." ; --UNCHK
lin need_N = mkWN (k48A "tarve") ;
lin need_V = mkV "tarvita" ;
lin need_V2 = mkV2 (mkV "tarvita") partitive ;
lin need_VV = mkVV (caseV genitive (mkV "tarvita")) ;
lin needful_A = mkWA (k34A "välttämätön") ; --UNCHK
lin neediness_N = mkWN (k1A "ahdinko") ; --UNCHK
lin needle_N = mkWN (k9 "neula") ; --UNCHK
lin needle_V2 = mkWV2 (k53A "kiihottaa") ; --UNCHK
lin needlebush_N = mkWN (compoundN "lisso" (k9 "sperma")) "Hakea" ; --UNCHK
lin needlecraft_N = mkWN (compoundN "käsi" (k19 "työ")) ; --UNCHK
lin needlefish_N = mkWN (compoundN "meri" (k9 "neula")) ; --UNCHK
lin needlepoint_N = mkWN (compoundN "kanava" (k9A "kirjonta")) ; --UNCHK
lin needless_A = mkWA (k34A "sopimaton") ; --UNCHK
lin needlewoman_N = mkWN (k5 "modisti") ; --UNCHK
lin needlewood_N = mkWN "Hakea" "leucoptera" ; --UNCHK
lin needlework_N = mkWN (compoundN "käsi" (k19 "työ")) ; --UNCHK
lin needleworker_N = mkWN (k12 "ompelija") ; --UNCHK
lin needs_Adv = mkWAdv (k99 "vääjäämättä") ; --UNCHK
lin needy_A = mkWA "hätää" "kärsivä" ; --UNCHK
lin neem_N = mkWN (compoundN "neem" (k18 "puu")) ; --UNCHK
lin neencephalon_N = mkWN "neoenkefalon" ; --UNCHK
lin nefarious_A = mkWA (k38 "roistomainen") ; --UNCHK
lin nefariousness_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin nefazodone_N = mkWN "Serzone" ; --UNCHK
lin negate_V2 = mkWV2 (k71 "tehdä") "tyhjäksi" ; --UNCHK
lin negation_N = mkWN (k3 "negaatio") ; --UNCHK
lin negative_A = mkWA (k38 "kielteinen") ; --f90
lin negative_N = mkWN (k5 "negatiivi") ; --UNCHK
lin negative_V2 = mkWV2 (k53A "käyttää") "veto-oikeutta" ; --UNCHK
lin negativist_N = mkWN (k5 "pessimisti") ; --UNCHK
lin negativity_N = mkWN (k40 "negatiivisuus") ; --UNCHK
lin neglect_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin neglect_V2 = mkV2 "laiminlyödä" partitive ; --mkWV2 (k73 "missata") ;
lin neglecter_N = mkWN (compoundN "laimin" (k10 "lyöjä")) ; --UNCHK
lin neglectful_A = mkWA (k34A "huolimaton") ; --UNCHK
lin neglectfulness_N = mkWN (k40 "piittaamattomuus") ; --UNCHK
lin neglige_N = mkWN (compoundN "aamu" (k5A "takki")) ; --UNCHK
lin negligee_N = mkWN (compoundN "aamu" (k5A "takki")) ; --UNCHK
lin negligence_N = mkWN (k40 "huolimattomuus") ; --UNCHK
lin negligent_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin negligible_A = mkWA (k34A "merkityksetön") ;
lin negotiable_A = mkWA (k10 "vaihdettava") ; --UNCHK
lin negotiate_V = mkV "neuvotella" ;
lin negotiate_V2 = mkV2 "neuvotella" elative ;
lin negotiate_VV = mkWVV (k61A "sopia") "ehdoista" ; --UNCHK
lin negotiation_N = mkWN (k2 "neuvottelu") ;
lin negotiator_N = mkWN (k12 "sovittelija") ; --UNCHK
lin negotiatress_N = mkWN (k12 "sovittelija") ; --UNCHK
lin negress_N = mkWN (compoundN "neekeri" (k38 "nainen")) ; --UNCHK
lin negro_A = mkWA (compoundA "must" (k38 "aihoinen")) ; --UNCHK
lin negro_N = mkWN (k6 "neekeri") ; --UNCHK
lin negroid_A = mkWA "negroidi" ; --UNCHK
lin negroid_N = mkWN (k6 "neekeri") ; --UNCHK
lin negus_N = mkWN (compoundN "viini" (k5 "toti")) ; --UNCHK
lin neigh_N = mkWN (k12 "yninä") ; --UNCHK
lin neigh_V = mkWV (k53A "hirnahtaa") ; --UNCHK
lin neighbor_N = mkN "naapuri" ;
lin neighbour_N = mkWN (k6 "naapuri") ; --UNCHK
lin neighbour_V = mkWV (k52A "rajoittua") ; --UNCHK
lin neighbour_V2 = mkWV2 (k52A "rajoittua") ; --UNCHK
lin neighbourhood_N = mkWN (k1 "naapurusto") ; --UNCHK
lin neighbouring_A = variants {} ; --
lin neighbourliness_N = mkWN (k40 "ystävällisyys") ; --UNCHK
lin neighbourly_A = mkWA (k38 "ystävällinen") ; --UNCHK
lin neither7nor_DConj = mkConj "ei" "eikä" ;
lin neither_A = mkWA (k16 "kumpikaan") "ei" ; --UNCHK
lin neither_Adv = variants {} ; --
lin neither_Det = MorphoFin.mkDetPol True Sg {s = table NForm {nf => (snoun2nounBind (nforms2snoun (dSuurempi "kumpi"))).s ! nf + "kaan"} ; h = Back} ;
lin neither_Prep = mkPrep "eikä" nominative ; ---- cat ??
lin nekton_N = mkWN "nektoni" ; --UNCHK
lin nelfinavir_N = mkWN (compoundN "nelfina" (k5 "viiri")) ; --UNCHK
lin nelson_N = mkWN "nelsoni" ; --UNCHK
lin nelson_PN = foreignPN "Nelson" ;
lin nem_con_Adv = mkWAdv (k99 "yksimielisesti") ; --UNCHK
lin nematode_N = mkWN (k38 "suolinkainen") ; --UNCHK
lin nemesis_N = mkWN "Nemesis" ; --UNCHK
lin nemophila_N = mkWN (k5A "sievikki") ; --UNCHK
lin neo_A = mkWA "uus-" ; --UNCHK
lin neoclassic_A = mkWA (compoundA "uus" (k38 "klassinen")) ; --UNCHK
lin neoclassicism_N = mkWN (compoundN "uusklassis" (k5 "ismi")) ; --UNCHK
lin neoclassicist_A = mkWA (compoundA "uus" (k38 "klassisistinen")) ; --UNCHK
lin neoclassicist_N = mkWN "uusklassisisti" ; --UNCHK
lin neocolonialism_N = mkWN (compoundN "uus" (k5 "kolonialismi")) ; --UNCHK
lin neoconservatism_N = mkWN (compoundN "uus" (k5 "konservatismi")) ; --UNCHK
lin neoconservative_N = mkWN (compoundN "uus" (k5 "konservatiivi")) ; --UNCHK
lin neocortical_A = mkWA (compoundA "neokortika" (k38 "alinen")) ; --UNCHK
lin neodymium_N = mkWN (k5 "neodyymi") ; --UNCHK
lin neoexpressionism_N = mkWN (compoundN "uus" (k5 "ekspressionismi")) ; --UNCHK
lin neoliberal_A = mkWA (compoundA "uus" (k38 "liberalistinen")) ; --UNCHK
lin neoliberal_N = mkWN (compoundN "uus" (k5 "liberalisti")) ; --UNCHK
lin neoliberalism_N = mkWN (compoundN "uus" (k5 "liberalismi")) ; --UNCHK
lin neolith_N = mkWN (compoundN "kivi" (k48 "esine")) "nuoremman" "kivikauden" ; --UNCHK
lin neolithic_A = mkWA (k38 "neoliittinen") ; --UNCHK
lin neologism_N = mkWN (k1A "käyttö") "uudissanojen" ; --UNCHK
lin neologist_N = mkWN (k12 "keksijä") "uudissanojen" ; --UNCHK
lin neomycin_N = mkWN (compoundN "Neobio" (k5 "tic")) ; --UNCHK
lin neon_N = mkWN (k5 "neon") ; --UNCHK
lin neonatal_A = mkWA (k47 "vastasyntynyt") ; --UNCHK
lin neonatology_N = mkWN "neonatologia" ; --UNCHK
lin neopallium_N = mkWN "neokorteksi" ; --UNCHK
lin neophobia_N = mkWN (compoundN "neo" (k12 "fobia")) ; --UNCHK
lin neophyte_N = mkWN (k38 "käännynnäinen") "uusi" ; --UNCHK
lin neoplasia_N = mkWN (compoundN "uudis" (k1 "kasvu")) ; --UNCHK
lin neoplasm_N = mkWN (k33 "kasvain") ; --UNCHK
lin neoplastic_A = mkWA (compoundA "neo" (k38 "plastinen")) ; --UNCHK
lin neoprene_N = mkWN "neopreeni" ; --UNCHK
lin neoromanticism_N = mkWN (compoundN "uus" (k9A "romantiikka")) ; --UNCHK
lin neostigmine_N = mkWN "Prostigmin" ; --UNCHK
lin neotenic_A = mkWA "neoteeninen" ; --UNCHK
lin neoteny_N = mkWN "neotenia" ; --UNCHK
lin neotony_N = mkWN "neotenia" ; --UNCHK
lin nepal_PN = foreignPN "Nepal" ;
lin nepalese_A = mkWA (compoundA "nepali" (k38 "lainen")) ; --UNCHK
lin nepalese_N = mkWN (compoundN "nepali" (k38 "lainen")) ; --UNCHK
lin nepaliFem_N = mkWN "nepal" ; --UNCHK
lin nepaliMasc_N = mkWN "nepal" ; --UNCHK
lin nepali_A = mkWA (compoundA "nepali" (k38 "lainen")) ; --UNCHK
lin nepheline_N = mkWN (compoundN "nef" (k5A "eliitti")) ; --UNCHK
lin nephelinite_N = mkWN (compoundN "nef" (k5A "eliitti")) ; --UNCHK
lin nephew_N = mkWN (compoundN "veljen" (k10A "poika")) ; --UNCHK
lin nephology_N = mkWN (k39 "tutkimus") "pilvien" ; --UNCHK
lin nephoscope_N = mkWN (compoundN "nefosko" (k5A "oppi")) ; --UNCHK
lin nephralgia_N = mkWN (compoundN "munuais" (k1A "kipu")) ; --UNCHK
lin nephrite_N = mkWN (compoundN "nef" (k5A "riitti")) ; --UNCHK
lin nephritic_A = mkWA (compoundA "rena" (k38 "alinen")) ; --UNCHK
lin nephritis_N = mkWN (k5A "tauti") "Brightin" ; --UNCHK
lin nephrocalcinosis_N = mkWN "nefrokalsinoosi" ; --UNCHK
lin nephrolithiasis_N = mkWN (compoundN "munuaiskivi" (k5A "tauti")) ; --UNCHK
lin nephrology_N = mkWN "nefrologia" ; --UNCHK
lin nephroptosis_N = mkWN (compoundN "munuais" (k10 "laskeuma")) ; --UNCHK
lin nephrosclerosis_N = mkWN (compoundN "nefroangio" (k5 "skleroosi")) ; --UNCHK
lin nephrotoxic_A = mkWA (compoundA "nefro" (k38 "toksinen")) ; --UNCHK
lin nephrotoxin_N = mkWN (compoundN "nefro" (k5 "toksiini")) ; --UNCHK
lin nephthytis_N = mkWN "Nephthytis" ; --UNCHK
lin nepotism_N = mkWN (k5 "nepotismi") ; --UNCHK
lin nepotist_N = mkWN "nepotisti" ; --UNCHK
lin neptunium_N = mkWN "atomiluku" "93" ; --UNCHK
lin nerd_N = mkWN (k5A "nörtti") ; --UNCHK
lin nereid_N = mkWN "nereidi" ; --UNCHK
lin neritic_A = mkWA "matalanmeren" ; --UNCHK
lin nerve_N = mkWN (k40 "hävyttömyys") ; --UNCHK
lin nerve_V2 = mkWV2 (k52A "terästäytyä") ; --UNCHK
lin nerve_cell_N = mkWN (k5 "neuroni") ; --UNCHK
lin nerve_centre_N = mkWN (k39 "keskus") ; --UNCHK
lin nerve_racking_A = mkA "hermojaraastava" ;
lin nerveless_A = mkWA (compoundA "kylmä" (k38 "verinen")) ; --UNCHK
lin nervous_A = mkA "hermostunut" ; ---ARB WA (k38 "hermostollinen") ;
lin nervousness_N = mkWN (k40 "hermostuneisuus") ;
lin nervy_A = mkWA (k10 "tunkeileva") ; --UNCHK
lin nescience_N = mkWN (k40 "sivistymättömyys") ; --UNCHK
lin nescient_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin ness_N = mkWN (k48A "niemeke") ; --UNCHK
lin nest_N = mkWN (k48A "pesäke") ; --UNCHK
lin nest_V = mkWV (k73 "kerätä") "linnunpesiä" ; --UNCHK
lin nest_egg_N = mkWN (compoundN "pesä" (k10 "muna")) ; --UNCHK
lin nester_N = mkWN (kH1 "pesijä") ; --UNCHK
lin nestling_N = mkWN (compoundN "linnun" (k10A "poika")) ; --UNCHK
lin neston_PN = foreignPN "Neston" ;
lin net_A = mkA "puhdas" ;
lin net_N = mkWN (k1A "verkko") ; --f213
lin net_V2 = mkWV2 (k63 "saada") "verkkoon" ; --UNCHK
lin netball_N = mkWN (compoundN "verkko" (k1 "pallo")) ; --UNCHK
lin nether_A = mkWA (k16A "alempi") ; --UNCHK
lin netherlander_N = mkWN (k38 "hollantilainen") ; --UNCHK
lin netherlands_PN = mkPN "Hollanti" | mkPN "Alankomaa" ; ---- plural
lin nethermost_A = mkWA (k36 "alin") ; --UNCHK
lin netley_PN = foreignPN "Netley" ;
lin nett_A = mkWA (k41A "puhdas") ; --UNCHK
lin nett_V2 = mkWV2 (k63 "saada") "verkkoon" ; --UNCHK
lin netting_N = mkWN (compoundN "verkon" (k9A "kudonta")) ; --UNCHK
lin nettle_N = mkWN (k38 "nokkonen") ; --UNCHK
lin nettle_V2 = mkWV2 (k53A "ottaa") "päähän" ; --UNCHK
lin network_N = mkN "verkosto" ;
lin networklike_A = mkWA (compoundA "verkko" (k38 "mainen")) ; --UNCHK
lin neural_A = mkWA (compoundA "neurona" (k38 "alinen")) ; --UNCHK
lin neuralgia_N = mkWN (k12 "neuralgia") ; --UNCHK
lin neuralgic_A = mkWA (k38 "neuralginen") ; --UNCHK
lin neurasthenia_N = mkWN (k12 "neurastenia") ; --UNCHK
lin neurasthenic_A = mkWA (compoundA "heikkoher" (k38 "moinen")) ; --UNCHK
lin neurasthenic_N = mkWN (compoundN "heikkoher" (k38 "moinen")) ; --UNCHK
lin neurectomy_N = mkWN (compoundN "hermon" (k1 "poisto")) ; --UNCHK
lin neurinoma_N = mkWN (compoundN "neurino" (k10 "oma")) ; --UNCHK
lin neuritis_N = mkWN (k5A "neuriitti") ; --UNCHK
lin neuroanatomic_A = mkWA (compoundA "neuro" (k38 "anatominen")) ; --UNCHK
lin neuroanatomy_N = mkWN (compoundN "neuro" (k12 "anatomia")) ; --UNCHK
lin neurobiological_A = mkWA (compoundA "neuro" (k38 "biologinen")) ; --UNCHK
lin neurobiological_Adv = mkWAdv (compoundAdv "neuro" (k99 "biologisesti")) ; --UNCHK
lin neurobiologist_N = mkWN (compoundN "neuro" (k5 "biologi")) ; --UNCHK
lin neurobiology_N = mkWN (compoundN "neuro" (k12 "biologia")) ; --UNCHK
lin neuroblast_N = mkWN (compoundN "neurob" (k5 "lasti")) ; --UNCHK
lin neuroblastoma_N = mkWN (compoundN "neuroblasto" (k10 "oma")) ; --UNCHK
lin neurochemical_N = mkWN (compoundN "neuro" (k5 "kemikaali")) ; --UNCHK
lin neurodermatitis_N = mkWN "neurodermatiitti" ; --UNCHK
lin neuroendocrine_A = mkWA (compoundA "neuro" (k38 "endokriininen")) ; --UNCHK
lin neuroepithelioma_N = mkWN (compoundN "neuroepitelio" (k10 "oma")) ; --UNCHK
lin neuroepithelium_N = mkWN (compoundN "neuro" (k5 "epiteeli")) ; --UNCHK
lin neuroethics_N = mkWN (compoundN "neuro" (k14A "etiikka")) ; --UNCHK
lin neurofibroma_N = mkWN (compoundN "neurilemmo" (k10 "oma")) ; --UNCHK
lin neurofibromatosis_N = mkWN (k5A "tauti") "von" "Recklinghausenin" ; --UNCHK
lin neurogenesis_N = mkWN "neurogeneesi" ; --UNCHK
lin neurogenic_A = mkWA (compoundA "hermo" (k38 "peräinen")) ; --UNCHK
lin neuroglia_N = mkWN "hermotukikudos" ; --UNCHK
lin neurogliacyte_N = mkWN (compoundN "neuroglia" (k1 "solu")) ; --UNCHK
lin neuroglial_A = mkWA (compoundA "neuroglia" (k38 "alinen")) ; --UNCHK
lin neurohormone_N = mkWN (compoundN "hermo" (k5 "hormoni")) ; --UNCHK
lin neurolemma_N = mkWN (k7A "tuppi") "hermosyyn" ; --UNCHK
lin neurolinguist_N = mkWN (compoundN "neuro" (k5 "lingvisti")) ; --UNCHK
lin neurolinguistics_N = mkWN (compoundN "neuro" (k9A "lingvistiikka")) ; --UNCHK
lin neurological_A = mkWA (k38 "neurologinen") ; --UNCHK
lin neurologistFem_N = mkWN (k5 "neurologi") ; --UNCHK
lin neurologistMasc_N = mkWN (k5 "neurologi") ; --UNCHK
lin neurology_N = mkWN (k12 "neurologia") "kliininen" ; --UNCHK
lin neuroma_N = mkWN (compoundN "hermo" (k33 "kasvain")) ; --UNCHK
lin neuromotor_A = mkWA (compoundA "neuro" (k38 "motorinen")) ; --UNCHK
lin neuromuscular_A = mkWA "neuromuskulaarinen" ; --UNCHK
lin neuropathy_N = mkWN (compoundN "hermo" (k40 "sairaus")) ; --UNCHK
lin neurophysiological_A = mkWA (compoundA "neuro" (k38 "fysiologinen")) ; --UNCHK
lin neurophysiology_N = mkWN (compoundN "neuro" (k12 "fysiologia")) ; --UNCHK
lin neuropil_N = mkWN "neuropiili" ; --UNCHK
lin neuroplasty_N = mkWN (compoundN "neuropl" (k12 "astia")) ; --UNCHK
lin neuropsychiatric_A = mkWA (compoundA "neuro" (k38 "psykiatrinen")) ; --UNCHK
lin neuropsychiatry_N = mkWN (compoundN "neuro" (k12 "psykiatria")) ; --UNCHK
lin neuropsychological_A = mkWA (compoundA "neuro" (k38 "psykologinen")) ; --UNCHK
lin neuropteron_N = mkWN (k38 "hyönteinen") "verkkosiipinen" ; --UNCHK
lin neurosarcoma_N = mkWN (compoundN "neuro" (k10 "oma")) "pahanlaatuinen" ; --UNCHK
lin neuroscience_N = mkWN (compoundN "neuro" (k48A "tiede")) ; --UNCHK
lin neuroscientist_N = mkWN (compoundN "neuro" (k12 "tieteilijä")) ; --UNCHK
lin neurosis_N = mkWN (k40 "neuroottisuus") ; --UNCHK
lin neurosurgeon_N = mkWN (compoundN "aivo" (k5 "kirurgi")) ; --UNCHK
lin neurosurgery_N = mkWN (compoundN "neuro" (k12 "kirurgia")) ; --UNCHK
lin neurosyphilis_N = mkWN (compoundN "neuro" (k39 "syfilis")) ; --UNCHK
lin neurotic_A = mkWA (k38 "neuroottinen") ; --UNCHK
lin neurotic_N = mkWN (k4A "neurootikko") ; --UNCHK
lin neurotoxic_A = mkWA (compoundA "neuro" (k38 "toksinen")) ; --UNCHK
lin neurotoxin_N = mkWN (compoundN "hermo" (k1A "myrkky")) ; --UNCHK
lin neurotransmitter_N = mkWN (compoundN "välittäjä" (k48 "aine")) "hermoston" ; --UNCHK
lin neurotropic_A = mkWA (compoundA "neuro" (k38 "trooppinen")) ; --UNCHK
lin neurotropism_N = mkWN (compoundN "neuro" (k5 "tropismi")) ; --UNCHK
lin neuss_PN = foreignPN "Neuss" ;
lin neuter_A = mkWA (compoundA "neutri" (k38 "sukuinen")) ; --UNCHK
lin neuter_N = mkWN (k5 "neutri") ; --UNCHK
lin neuter_V2 = mkWV2 (k62 "steriloida") ; --UNCHK
lin neutering_N = mkWN (k9A "kuohinta") ; --UNCHK
lin neutral_A = mkWA (k6 "neutraali") ;
lin neutral_N = mkWN (k34A "puolueeton") ; --UNCHK
lin neutralism_N = mkWN (k40 "puolueettomuus") ; --UNCHK
lin neutralist_N = mkWN (k10 "kannattaja") "puolueettomuuden" ; --UNCHK
lin neutrality_N = mkWN (k40 "puolueettomuus") ; --UNCHK
lin neutralization_N = mkWN (compoundN "vasta" (k1 "isku")) ; --UNCHK
lin neutralize_V2 = mkWV2 (k62 "neutraloida") ; --UNCHK
lin neutrino_N = mkWN (k2 "neutriino") ; --UNCHK
lin neutron_N = mkWN (k5 "neutroni") ; --UNCHK
lin neutropenia_N = mkWN "neutropenia" ; --UNCHK
lin neutrophil_N = mkWN "neutrofiili" ; --UNCHK
lin nevada_PN = foreignPN "Nevada" ;
lin neve_N = mkWN (compoundN "lumi" (k18 "jää")) ; --UNCHK
lin never_AdV = mkAdV "ei koskaan" ;
lin never_Adv = mkAdv "ei koskaan" | mkAdv "koskaan" ; ---- will look weird in sentences
lin nevermore_Adv = mkWAdv (k99 "koskaan") "ei" "enää" ; --UNCHK
lin nevertheless_Adv = mkAdv "kuitenkin" ;
lin nevirapine_N = mkWN "Viramune" ; --UNCHK
lin new_A = L.new_A ;
lin new_Adv = mkWAdv (k99 "äsken") "vasta" ; --UNCHK
lin new_cumnock_PN = foreignPN "New Cumnock" ;
lin new_mills_PN = foreignPN "New Mills" ;
lin new_orleans_PN = foreignPN "New Orleans" ;
lin new_tredegar_PN = foreignPN "New Tredegar" ;
lin new_windsor_PN = foreignPN "New Windsor" ;
lin new_york_PN = mkPN "New York" ;
lin newark_PN = foreignPN "Newark" ;
lin newarthill_PN = foreignPN "Newarthill" ;
lin newbiggin_PN = foreignPN "Newbiggin" ;
lin newborn_A = mkWA (k47 "vastasyntynyt") ; --UNCHK
lin newbury_PN = foreignPN "Newbury" ;
lin newcastle_PN = foreignPN "Newcastle" ;
lin newcomer_N = mkWN (k41A "tulokas") ; --UNCHK
lin newel_N = mkWN (compoundN "keski" (k6 "pilari")) ; --UNCHK
lin newfangled_A = mkWA (k27 "uusi") ; --UNCHK
lin newfound_A = mkWA "vasta" "löydetty" ; --UNCHK
lin newhaven_PN = foreignPN "Newhaven" ;
lin newmains_PN = foreignPN "Newmains" ;
lin newmarket_N = mkWN (compoundN "kortti" (k5 "peli")) ; --UNCHK
lin newmarket_PN = foreignPN "Newmarket" ;
lin newness_N = mkWN (k40 "uutuus") ; --UNCHK
lin newport_PN = foreignPN "Newport" ;
lin newport_pagnell_PN = foreignPN "Newport Pagnell" ;
lin newquay_PN = foreignPN "Newquay" ;
lin newry_PN = foreignPN "Newry" ;
lin news_N = mkN "uutinen" ;
lin newsagent_N = mkWN (k10 "pitäjä") "lehtikioskin" ; --UNCHK
lin newsboy_N = mkWN (compoundN "lehden" (k10 "jakaja")) ; --UNCHK
lin newscast_N = mkWN (compoundN "uutis" (k39 "lähetys")) ; --UNCHK
lin newscaster_N = mkWN (compoundN "uutisten" (k12 "lukija")) ; --UNCHK
lin newsdealer_N = mkWN (k10 "pitäjä") "lehtikioskin" ; --UNCHK
lin newsflash_N = mkWN (compoundN "uutis" (k39 "katsaus")) ; --UNCHK
lin newsless_A = mkWA (k34A "mielenkiinnoton") ; --UNCHK
lin newsletter_N = mkWN (compoundN "tiedotus" (k7A "lehti")) ;
lin newsmonger_N = mkWN (compoundN "kieli" (k1 "kello")) ; --UNCHK
lin newspaper_N = L.newspaper_N ;
lin newspapering_N = mkWN (compoundN "lehti" (k5 "journalismi")) ; --UNCHK
lin newspaperman_N = mkWN (compoundN "lehti" (k42 "mies")) ; --UNCHK
lin newspeak_N = mkWN (compoundN "kapula" (k26 "kieli")) ; --UNCHK
lin newsprint_N = mkWN (compoundN "sanomalehti" (k6 "paperi")) ; --UNCHK
lin newsreader_N = mkWN (compoundN "uutisten" (k12 "lukija")) ; --UNCHK
lin newsreel_N = mkWN (compoundN "uutis" (k39 "katsaus")) ; --UNCHK
lin newsroom_N = mkWN (compoundN "luku" (k5 "sali")) ; --UNCHK
lin newssheet_N = mkWN (compoundN "tiedotus" (k7A "lehti")) ; --UNCHK
lin newsstand_N = mkWN (compoundN "lehti" (k5 "kioski")) ; --UNCHK
lin newsvendor_N = mkWN (k10 "pitäjä") "lehtikioskin" ; --UNCHK
lin newswoman_N = mkWN (compoundN "lehti" (k38 "nainen")) ; --UNCHK
lin newsworthiness_N = mkWN (k38 "uutinen") ; --UNCHK
lin newsworthy_A = mkWA (compoundA "uutis" (k38 "arvoinen")) ; --UNCHK
lin newsy_A = mkWA (k41 "suulas") ; --UNCHK
lin newt_N = mkWN (k1 "vesilisko") ; --UNCHK
lin newtonian_A = mkWA (compoundA "newtoni" (k38 "lainen")) ; --UNCHK
lin newtonian_N = mkWN (compoundN "newtoni" (k38 "lainen")) ; --UNCHK
lin newtown_PN = foreignPN "Newtown" ;
lin next_A = mkA "seuraava" | invarA "ensi" ;
lin next_Prep = mkPrep elative "seuraava" ;
lin next_to_Prep = mkPrep "vieressä" ;
lin nexus_N = mkWN (k10 "ryhmä") ; --UNCHK
lin ngultrum_N = mkWN "ngultrum" ; --UNCHK
lin ngwee_N = mkWN "ngwee" ; --UNCHK
lin niacin_N = mkWN (compoundN "nikotiini" (k1A "happo")) ; --UNCHK
lin nib_N = mkWN (k1 "kuono") ; --UNCHK
lin nibbed_A = mkWA (k38 "-teräinen") ; --UNCHK
lin nibble_N = mkWN "näykkäisy" ; --UNCHK
lin nibble_V = mkWV (k61 "napsia") ; --UNCHK
lin nibble_V2 = mkWV2 (k61 "napsia") ; --UNCHK
lin nibbler_N = mkWN (k12 "jyrsijä") ; --UNCHK
lin niblick_N = mkWN (compoundN "rauta" (k5 "ysi")) ; --UNCHK
lin nicad_N = mkWN (compoundN "nikkelikadmium" (k1A "akku")) ; --UNCHK
lin nicaragua_PN = foreignPN "Nicaragua" ;
lin nicaraguan_A = mkWA (compoundA "nicaragu" (k38 "alainen")) ; --UNCHK
lin nicaraguan_N = mkWN (compoundN "nicaragu" (k38 "alainen")) ; --UNCHK
lin nice_A = mkA "mukava" ;
lin nice_PN = foreignPN "Nizza" ;
lin niceness_N = mkWN (k40 "herkkyys") ; --UNCHK
lin nicety_N = mkWN (k40 "hienous") ; --UNCHK
lin niche_N = mkWN (k39 "syvennys") ; --UNCHK
lin nick_N = mkWN (k1A "viilto") ; --UNCHK
lin nick_V2 = mkWV2 (k67A "paritella") ; --UNCHK
lin nickby_PN = mkPN "Nikkilä" ;
lin nickel_N = mkWN (compoundN "viis" (k38 "isenttinen")) ;
lin nickel_V2 = mkWV2 (k73 "niklata") ; --UNCHK
lin nicknack_N = mkWN (k10 "rihkama") ; --UNCHK
lin nickname_N = mkWN (compoundN "liika" (k7 "nimi")) ;
lin nickname_V2 = mkWV2 (k56A "antaa") "lisänimi" ; --UNCHK
lin nickname_V3 = mkWV3 (k56A "antaa") "lisänimi" ; --UNCHK
lin nicotine_N = mkWN (k5 "nikotiini") ; --UNCHK
lin nidicolous_A = mkWA (compoundA "pesä" (k38 "viipyinen")) ; --UNCHK
lin nidifugous_A = mkWA (compoundA "pesäjätt" (k38 "öinen")) ; --UNCHK
lin nidus_N = mkWN (k10 "pesä") ; --UNCHK
lin niece_N = mkWN (compoundN "veljen" (k32A "tytär")) ; --UNCHK
lin nifedipine_N = mkWN (compoundN "Procar" (k9 "dia")) ; --UNCHK
lin niff_N = mkWN (k1 "lemu") ; --UNCHK
lin niffy_A = mkWA "löyhkäävä" ; --UNCHK
lin nifty_A = mkWA (k3 "mainio") ; --UNCHK
lin nigel_PN = foreignPN "Nigel" ;
lin nigella_N = mkWN (compoundN "neidon" (k10A "kukka")) ; --UNCHK
lin niger_PN = foreignPN "Niger" ;
lin nigeria_PN = foreignPN "Nigeria" ;
lin nigerian_A = mkWA (compoundA "nigeri" (k38 "alainen")) ; --UNCHK
lin nigerian_N = mkWN (compoundN "nigeri" (k38 "alainen")) ; --UNCHK
lin nigerien_A = mkWA (compoundA "nigeri" (k38 "alainen")) ; --UNCHK
lin nigerien_N = mkWN "nigeriläinen" ; --UNCHK
lin niggard_N = mkWN (k5A "kitupiikki") ; --UNCHK
lin niggardliness_N = mkWN (k2 "kitsastelu") ; --UNCHK
lin niggardly_A = mkWA (k9A "saita") ; --UNCHK
lin nigger_N = mkWN (k1 "nekru") ; --UNCHK
lin niggle_V = mkWV (k66 "kitistä") ; --UNCHK
lin nigh_Adv = mkWAdv (k99 "liki") ; --UNCHK
lin nigher_Adv = mkWAdv (k99 "lähempänä") ; --UNCHK
lin nighest_Adv = mkWAdv (k99 "lähimpänä") ; --UNCHK
lin night_N = L.night_N ;
lin night_bell_N = mkWN "yökello" ; --UNCHK
lin night_bird_N = mkWN "yölintu" ; --UNCHK
lin night_soil_N = mkWN (k48 "uloste") ; --UNCHK
lin night_watch_N = mkWN "yövuoro" ; --UNCHK
lin night_watchman_N = mkWN "yövartija" ; --UNCHK
lin nightcap_N = mkWN (k2 "ottelu") "päivän" "viimeinen" ; --UNCHK
lin nightclub_N = mkWN (k5 "klubi") ; --UNCHK
lin nightdress_N = mkWN (k5A "leninki") ; --UNCHK
lin nightfall_N = mkWN (k1 "hämy") ; --UNCHK
lin nightgown_N = mkWN (k5A "leninki") ; --UNCHK
lin nighthawk_N = mkWN (k10 "kehrääjä") ; --UNCHK
lin nightie_N = mkWN (k5A "leninki") ; --UNCHK
lin nightingale_N = mkWN (compoundN "sata" (k26 "kieli")) ; --UNCHK
lin nightjar_N = mkWN (k10 "kehrääjä") ; --UNCHK
lin nightlife_N = mkWN "yöelämä" ; --UNCHK
lin nightly_A = mkWA (compoundA "joka" (k38 "öinen")) ; --UNCHK
lin nightly_Adv = mkAdv "öinen" | adjAdv nightly_A ; -- derived
lin nightmare_N = mkWN (k38 "painajainen") ;
lin nightmarish_A = mkWA (k38 "painajaismainen") ; --UNCHK
lin nightshade_N = mkWN (k1 "koiso") ; --UNCHK
lin nightshirt_N = mkWN (compoundN "yöp" (k9A "aita")) ; --UNCHK
lin nightwear_N = mkWN "yöpuku" ; --UNCHK
lin nightwork_N = mkWN "yötyö" ; --UNCHK
lin nihil_N = mkWN "nihil" ; --UNCHK
lin nihilism_N = mkWN (k5 "nihilismi") ; --UNCHK
lin nihilist_N = mkWN (k5 "syndikalisti") ; --UNCHK
lin nihilistic_A = mkWA (k38 "nihilistinen") ; --UNCHK
lin nijmegen_PN = foreignPN "Nĳmegen" ;
lin nil_N = mkWN (k101 "mikään") "ei" ; --UNCHK
lin nilgai_N = mkWN "Boselaphus" "tragocamelus" ; --UNCHK
lin nilotic_A = mkWA "niloottinen" ; --UNCHK
lin nilpotent_A = mkWA (compoundA "nil" (k5A "potentti")) ; --UNCHK
lin nilsiä_PN = mkPN "Nilsiä" ;
lin nim_N = mkWN "nim" ; --UNCHK
lin nimble_A = mkWA (k10 "sukkela") ; --UNCHK
lin nimbleness_N = mkWN (k40 "vikkelyys") ; --UNCHK
lin nimbus_N = mkWN (kH1 "aura") ; --UNCHK
lin nincompoop_N = mkWN (k12 "tolvana") ; --UNCHK
lin ninefold_A = mkWA (k4A "yhdeksikkö") ; --UNCHK
lin ninefold_Adv = mkWAdv "yhdeksänkertaisesti" ; --UNCHK
lin ninepence_N = mkWN (k9 "raha") "yhdeksän" "pennyn" ; --UNCHK
lin ninepin_N = mkWN (k9 "keila") ; --UNCHK
lin ninepins_N = mkWN (compoundN "keila" (k5 "peli")) ; --UNCHK
lin ninja_N = mkWN "ninja" ; --UNCHK
lin ninjutsu_N = mkWN "ninjutsu" ; --UNCHK
lin ninny_N = mkWN (k12 "tolvana") ; --UNCHK
lin ninon_N = mkWN "ninon" ; --UNCHK
lin ninth_N = mkWN (k39 "yhdeksännes") ; --UNCHK
lin niobite_N = mkWN (compoundN "kolum" (k5A "biitti")) ; --UNCHK
lin niobium_N = mkWN (k5 "niobi") ; --UNCHK
lin nip_N = mkWN (k39 "nipistys") ; --UNCHK
lin nip_V = mkWV (k66 "näykkäistä") ; --UNCHK
lin nip_V2 = mkWV2 (k66 "näykkäistä") ; --UNCHK
lin nip_off_V = mkWV (k61 "saksia") ; --UNCHK
lin nipa_N = mkWN "nipa" ; --UNCHK
lin nipper_N = mkWN "saksi" ; --UNCHK
lin nipple_N = mkWN (k5 "nänni") ;
lin nipponese_A = mkWA (k38 "japanilainen") ; --UNCHK
lin nippy_A = mkWA (k41A "raitis") ; --UNCHK
lin niqaabi_N = mkWN (k10 "käyttäjä") "niqabin" ; --UNCHK
lin niqab_N = mkWN "niqab" ; --UNCHK
lin nirvana_N = mkWN (k18 "maa") "luvattu" ; --UNCHK
lin nisi_A = mkWA "nisi" ; --UNCHK
lin nit_N = mkWN (k10 "muna") "täin" ; --UNCHK
lin nitpicker_N = mkWN (k12 "saivartelija") ; --UNCHK
lin nitrate_N = mkWN (k5A "nitraatti") ; --UNCHK
lin nitrazepam_N = mkWN "nitratsepaami" ; --UNCHK
lin nitre_N = mkWN (k6 "salpietari") ; --UNCHK
lin nitric_A = mkWA "nitraatti-" ; --UNCHK
lin nitride_N = mkWN "nitridi" ; --UNCHK
lin nitrification_N = mkWN "nitrifikaatio" ; --UNCHK
lin nitrile_N = mkWN (k5 "syanidi") ; --UNCHK
lin nitrite_N = mkWN (k5A "nitriitti") ; --UNCHK
lin nitrobacterium_N = mkWN (compoundN "typpi" (k6 "bakteeri")) ; --UNCHK
lin nitrobenzene_N = mkWN "nitrobentseeni" ; --UNCHK
lin nitrocalcite_N = mkWN (compoundN "kalsium" (k5A "nitraatti")) ; --UNCHK
lin nitrochloromethane_N = mkWN (compoundN "nitrotrikloori" (k5 "metaani")) ; --UNCHK
lin nitrofuran_N = mkWN (compoundN "nitrofu" (k5 "raani")) ; --UNCHK
lin nitrofurantoin_N = mkWN "Macrodantin" ; --UNCHK
lin nitrogen_N = mkWN (k7A "typpi") ; --UNCHK
lin nitrogenase_N = mkWN (compoundN "nitrogen" (k5 "aasi")) ; --UNCHK
lin nitrogenous_A = mkWA (compoundA "typpipi" (k38 "toinen")) ; --UNCHK
lin nitroglycerin_N = mkWN (k5 "nitroglyseroli") ; --UNCHK
lin nitroglycerine_N = mkWN (k5 "nitroglyseroli") ; --UNCHK
lin nitrous_A = mkWA "nitraatti-" ; --UNCHK
lin nitwit_N = mkWN (k6 "tomppeli") ; --UNCHK
lin nitwitted_A = mkWA (k34A "älytön") ; --UNCHK
lin nivala_PN = mkPN "Nivala" ;
lin nix_N = mkWN (k101 "mikään") "ei" ; --UNCHK
lin nix_V2 = mkWV2 (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin no_Adv = mkWAdv (k99 "ei") ; --UNCHK
lin no_Interj = mkInterj "ei" | mkInterj "en" ;
lin no_Quant = S.no_Quant ** {s1 = \\n,c => "ei" ++ S.no_Quant.s1 ! n ! c} ; ---- proper handling of polarity wanted
lin no_Utt = S.no_Utt ;
lin no_ball_N = mkWN (k34A "laiton") ; --UNCHK
lin no_fewer_than_AdN = mkAdN "peräti" ;
lin no_longer_AdV = mkAdV "enää" ;
lin no_man's_land_N = mkWN (k18 "maa") "ei" "kenenkään" ; --UNCHK
lin no_more_than_AdN = mkAdN "korkeintaan" | mkAdN "enintään" ;
lin no_one_NP = S.nobody_NP ** {s = \\c => "ei" ++ S.nobody_NP.s ! c} | S.nobody_NP ** {s = \\c => S.nobody_NP.s ! c} ;
lin nob_N = mkWN (k1 "kiho") "iso" ; --UNCHK
lin nobble_V2 = mkWV2 (k73 "huumata") ; --UNCHK
lin nobelium_N = mkWN "atomiluku" "102" ; --UNCHK
lin nobility_N = mkWN (k40 "ylhäisyys") ; --UNCHK
lin nobleFem_N = variants {} ; ---- sense to be split
lin nobleMasc_N = variants {} ; ---- sense to be split
lin noble_A = mkA "jalo" ;
lin nobleman_N = mkWN (k38 "aatelinen") ; --UNCHK
lin noblesse_N = mkWN (k2 "ylhäisö") ; --UNCHK
lin noblesse_oblige_N = mkWN (k48A "velvoite") "aateluuden" ; --UNCHK
lin nobody_NP = S.nobody_NP ** {s = \\c => "ei" ++ S.nobody_NP.s ! c} | S.nobody_NP ** {s = \\c => S.nobody_NP.s ! c} ;
lin nocent_A = mkWA "harmeja" "aiheuttava" ; --UNCHK
lin nociceptive_A = mkWA (compoundA "nosi" (k38 "septinen")) ; --UNCHK
lin noctambulist_N = mkWN (compoundN "unissa" (k12 "kävelijä")) ; --UNCHK
lin noctiluca_N = mkWN (compoundN "loisto" (k3 "eliö")) ; --UNCHK
lin noctilucent_A = mkWA "pimeässä" "hohtava" ; --UNCHK
lin nocturia_N = mkWN "nykturia" ; --UNCHK
lin nocturnal_A = mkWA "yö-" ; --UNCHK
lin nocturne_N = mkWN "nokturno" ; --UNCHK
lin nod_N = mkWN (k39 "nyökkäys") ; --UNCHK
lin nod_V = mkWV (k52A "nuokkua") ; --UNCHK
lin nod_off_V = mkWV (k61A "pilkkiä") ; --UNCHK
lin nod_through_V2 = prepV2 OP_nod_V OP_through_Prep ; -- guess-p-verb
lin noddle_N = mkWN (k18 "pää") ; --UNCHK
lin node_N = mkWN (k12 "vierailija") ; --UNCHK
lin nodular_A = mkWA (k38 "kyhmyinen") ; --UNCHK
lin nodulated_A = mkWA (k38 "nystermäinen") ; --UNCHK
lin nodule_N = mkWN (k48A "solmuke") ; --UNCHK
lin nodulose_A = mkWA (k38 "nystermäinen") ; --UNCHK
lin noel_N = mkWN (k9A "joulunaika") ; --UNCHK
lin noel_PN = foreignPN "Noel" ;
lin nog_N = mkWN (compoundN "puu" (k48 "kappale")) ; --UNCHK
lin noggin_N = mkWN (k7A "päälaki") ; --UNCHK
lin nogging_N = mkWN (compoundN "poikki" (k9 "piena")) ; --UNCHK
lin nohow_Adv = mkWAdv (k99 "mitenkään") "ei" ; --UNCHK
lin noise_N = mkN "häly" ; --mkWN (k40 "umpimähkäisyys") ;
lin noise_V2 = mkWV2 (k68 "metelöidä") ; --UNCHK
lin noiseless_A = mkWA (k34A "äänetön") ; --UNCHK
lin noiselessness_N = mkWN (k40 "äänettömyys") ; --UNCHK
lin noisemaker_N = mkWN (k7 "torvi") ; --UNCHK
lin noisiness_N = mkWN (k40 "meluisuus") ; --UNCHK
lin noisome_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin noisy_A = mkWA (k41A "äänekäs") ; --UNCHK
lin nokia_PN = mkPN "Nokia" ;
lin nom_de_plume_N = mkWN (k5 "pseudonyymi") ; --UNCHK
lin noma_N = mkWN (compoundN "vesi" (k3 "kuolio")) ; --UNCHK
lin nomad_N = mkWN (k6 "kulkuri") ; --UNCHK
lin nomadic_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin nombril_N = mkWN (k9A "napa") ; --UNCHK
lin nomenclature_N = mkWN (k2 "sanasto") ; --UNCHK
lin nomenklatura_N = mkWN (k13 "nomenklatuura") ; --UNCHK
lin nomia_N = mkWN (compoundN "Nomia-" (k1A "suku")) ; --UNCHK
lin nominal_A = mkWA "nimellis-" ; --UNCHK
lin nominalism_N = mkWN (compoundN "nominal" (k5 "ismi")) ; --UNCHK
lin nominalist_N = mkWN "nominalisti" ; --UNCHK
lin nominalistic_A = mkWA "nominalistinen" ; --UNCHK
lin nominate_V2 = mkWV2 (k53A "esittää") partitive ;
lin nomination_N = mkWN (compoundN "ehdolle" (k1 "pano")) ;
lin nominative_A = mkWA "nominatiivi-" ; --UNCHK
lin nominative_N = mkWN (k5 "nominatiivi") ; --UNCHK
lin nominator_N = mkWN (k10 "nimittäjä") ; --UNCHK
lin nominee_N = mkWN (k5A "kandidaatti") ; --UNCHK
lin nomogram_N = mkWN "nomogrammi" ; --UNCHK
lin nomothetic_A = mkWA (compoundA "nomot" (k38 "eettinen")) ; --UNCHK
lin non_sequitur_N = mkWN (compoundN "johto" (k39 "päätös")) "väärä" ; --UNCHK
lin nonabsorbency_N = mkWN (compoundN "hylkimis" (k1A "kyky")) ; --UNCHK
lin nonabsorbent_A = mkWA "vettä" "hylkivä" ; --UNCHK
lin nonacceptance_N = mkWN "kieltäytyminen" ; --UNCHK
lin nonaccomplishment_N = mkWN (compoundN "jää" (k38 "minen")) "saavuttamatta" ; --UNCHK
lin nonaddictive_A = mkWA "riippuvuutta" "aiheuttamaton" ; --UNCHK
lin nonadhesive_A = mkWA "kiinnittymätön" ; --UNCHK
lin nonadjacent_A = mkWA (k38 "erillinen") ; --UNCHK
lin nonadsorbent_A = mkWA "adsorboitumaton" ; --UNCHK
lin nonage_N = mkWN (k40 "nuoruus") ; --UNCHK
lin nonagenarian_A = mkWA (compoundA "yhdeksän" (k38 "kymppinen")) ; --UNCHK
lin nonagenarian_N = mkWN "yhdeksänkymmenvuotias" ; --UNCHK
lin nonaggression_N = mkWN "hyökkäämättömyys" ; --UNCHK
lin nonagon_N = mkWN "yhdeksänkulmio" ; --UNCHK
lin nonalcoholic_A = mkWA (k34A "alkoholiton") ; --UNCHK
lin nonaligned_A = mkWA (k34A "puolueeton") ; --UNCHK
lin nonalignment_N = mkWN (k40 "sitoutumattomuus") ; --UNCHK
lin nonallele_N = mkWN (compoundN "ei-" (k5 "alleeli")) ; --UNCHK
lin nonappearance_N = mkWN (compoundN "poissa" (k1 "olo")) ; --UNCHK
lin nonappointive_A = mkWA "äänestyksellä" "valittava" ; --UNCHK
lin nonarbitrable_A = mkWA (k34A "kuulumaton") "välimiestuomioon" ; --UNCHK
lin nonarbitrary_A = mkWA (k38 "umpimähkäinen") "ei" ; --UNCHK
lin nonarboreal_A = mkWA (compoundA "ei-puu" (k38 "mainen")) ; --UNCHK
lin nonassertive_A = mkWA (compoundA "määrä" (k38 "tietoinen")) "ei" ; --UNCHK
lin nonassociative_A = mkWA (compoundA "epä" (k38 "assosiatiivinen")) ; --UNCHK
lin nonattendance_N = mkWN (compoundN "poissa" (k1 "olo")) ; --UNCHK
lin nonautonomous_A = mkWA (compoundA "epä" (k38 "itsenäinen")) ; --UNCHK
lin nonbearing_A = mkWA (k34A "kantamaton") ; --UNCHK
lin nonbeing_N = mkWN (k40 "olemattomuus") ; --UNCHK
lin nonbelligerent_A = mkWA "sotaakäymätön" ; --UNCHK
lin noncaloric_A = mkWA (k34A "kaloriton") ; --UNCHK
lin noncarbonated_A = mkWA "karbonoimaton" ; --UNCHK
lin noncausative_A = mkWA (compoundA "ei-" (k38 "kausaalinen")) ; --UNCHK
lin nonce_N = mkWN (compoundN "nyky" (k7 "hetki")) ; --UNCHK
lin nonce_word_N = mkWN (compoundN "tilapäis" (k48 "muodoste")) ; --UNCHK
lin nonchalance_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin nonchalant_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin noncivilized_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin nonclassical_A = mkWA (compoundA "ei-" (k38 "klassillinen")) ; --UNCHK
lin noncollapsible_A = mkWA "romahtamaton" ; --UNCHK
lin noncolumned_A = mkWA "pylväätön" ; --UNCHK
lin noncombatant_A = mkWA "taisteluihin" "osallistumaton" ; --UNCHK
lin noncombatant_N = mkWN "taisteluihin" "osallistumaton" ; --UNCHK
lin noncombinative_A = mkWA "yhdistelmätön" ; --UNCHK
lin noncombining_A = mkWA "yhdistymätön" ; --UNCHK
lin noncombustible_A = mkWA (k34A "syttymätön") ; --UNCHK
lin noncommercial_A = mkWA (compoundA "epä" (k38 "kaupallinen")) ; --UNCHK
lin noncommissioned_A = mkWA "värvätty" ; --UNCHK
lin noncommittal_A = mkWA "kantaansa" "ilmoittamaton" ; --UNCHK
lin noncommunicable_A = mkWA "tarttumaton" ; --UNCHK
lin noncompetitive_A = mkWA "ei-kilpaileva" ; --UNCHK
lin noncomprehensive_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin nonconductive_A = mkWA "eristävä" ; --UNCHK
lin nonconductor_N = mkWN (k33 "eristin") ; --UNCHK
lin nonconforming_A = mkWA (k10 "toisinajatteleva") ; --UNCHK
lin nonconformism_N = mkWN (compoundN "nonkonform" (k5 "ismi")) ; --UNCHK
lin nonconformist_A = mkWA (k34A "sopeutumaton") ; --UNCHK
lin nonconformist_N = mkWN (compoundN "toisin" (k12 "ajattelija")) ; --UNCHK
lin nonconformity_N = mkWN (k40 "sopeutumattomuus") ; --UNCHK
lin nonconscious_A = mkWA (k34A "tiedostamaton") ; --UNCHK
lin non_contentious_A = mkWA (k10 "sopuisa") ; --UNCHK
lin nonconvergent_A = mkWA "leikkaamaton" ; --UNCHK
lin noncritical_A = mkWA (k34A "kritiikitön") ; --UNCHK
lin noncrucial_A = mkWA (compoundA "ei-" (k38 "kriittinen")) ; --UNCHK
lin noncrystalline_A = mkWA (compoundA "ei-" (k38 "kiteinen")) ; --UNCHK
lin noncyclic_A = mkWA "jaksoton" ; --UNCHK
lin nondeductible_A = mkWA (compoundA "vähennys" (k34A "kelvoton")) ; --UNCHK
lin nondenominational_A = mkWA (k34A "tunnustukseton") ; --UNCHK
lin nondescript_A = mkWA (k10 "tylsä") ; --UNCHK
lin nondescript_N = mkWN (k10 "tylsä") ; --UNCHK
lin nondevelopment_N = mkWN (compoundN "kehitys" (k48 "vaje")) ; --UNCHK
lin nondigestible_A = mkWA "sulamaton" ; --UNCHK
lin nondisjunction_N = mkWN "nondisjunktio" ; --UNCHK
lin nondisposable_A = mkWA "kestokäyttö-" ; --UNCHK
lin nondriver_N = mkWN "autoton" ; --UNCHK
lin none_A = mkWA (k99 "yhtään") "ei" ; --UNCHK
lin none_Adv = mkWAdv (k99 "lainkaan") "ei" ; --UNCHK
lin none_NP = S.nothing_NP ** {s = \\c => "ei" ++ S.nothing_NP.s ! c} ;
lin nonechoic_A = mkWA (compoundA "ei-kaiku" (k38 "mainen")) ; --UNCHK
lin noneffervescent_A = mkWA "kuohumaton" ; --UNCHK
lin nonelective_A = mkWA "vaaleihin" "perustumaton" ; --UNCHK
lin nonentity_N = mkWN (k5A "tyyppi") "olematon" ; --UNCHK
lin nonenzymatic_A = mkWA (compoundA "ei-" (k38 "entsymaattinen")) ; --UNCHK
lin nonequivalence_N = mkWN "vastaamattomuus" ; --UNCHK
lin nonequivalent_A = mkWA (compoundA "eri" (k38 "arvoinen")) ; --UNCHK
lin nones_N = mkWN "nona" ; --UNCHK
lin nonesuch_N = mkWN (k5 "ideaali") ; --UNCHK
lin nonetheless_Adv = variants {} ; --
lin nonevent_N = mkWN (compoundN "pannu" (k1A "kakku")) ; --UNCHK
lin nonexempt_A = mkWA (compoundA "vap" (k34A "auttamaton")) ; --UNCHK
lin nonexistence_N = mkWN (k40 "olemattomuus") ; --UNCHK
lin nonexistent_A = mkWA (k34A "olematon") ; --UNCHK
lin nonexploratory_A = mkWA (compoundA "ei-" (k38 "eksploratiivinen")) ; --UNCHK
lin nonexplosive_A = mkWA "räjähtämätön" ; --UNCHK
lin nonextant_A = mkWA (k47 "kuollut") "sukupuuttoon" ; --UNCHK
lin nonextensile_A = mkWA "pidentämätön" ; --UNCHK
lin nonfat_A = mkWA (k34A "rasvaton") ; --UNCHK
lin nonfeasance_N = mkWN (compoundN "laimin" (k5A "lyönti")) ; --UNCHK
lin nonfiction_N = mkWN (compoundN "asia" (k10 "proosa")) ; --UNCHK
lin nonfictional_A = mkWA "asia-" ; --UNCHK
lin nonfinancial_A = mkWA "talouteen" "liittymätön" ; --UNCHK
lin nonfissile_A = mkWA "liuskoittumaton" ; --UNCHK
lin nonfissionable_A = mkWA "fissioitumaton" ; --UNCHK
lin nonflammable_A = mkWA (k34A "palamaton") ; --UNCHK
lin nonfunctional_A = mkWA "toimimaton" ; --UNCHK
lin nonglutinous_A = mkWA (compoundA "ei-" (k15 "tahmea")) ; --UNCHK
lin nongranular_A = mkWA "rakeeton" ; --UNCHK
lin nongregarious_A = mkWA (compoundA "yksin" (k10 "elävä")) ; --UNCHK
lin nonhairy_A = mkWA "karvaton" ; --UNCHK
lin nonharmonic_A = mkWA (compoundA "epä" (k38 "harmoninen")) ; --UNCHK
lin nonhereditary_A = mkWA "periytymätön" ; --UNCHK
lin nonhierarchical_A = mkWA (compoundA "epä" (k38 "hierarkkinen")) ; --UNCHK
lin nonimitative_A = mkWA (k34A "jäljittelemätön") ; --UNCHK
lin nonindulgent_A = mkWA (k10 "kova") ; --UNCHK
lin nonindustrial_A = mkWA "teollistumaton" ; --UNCHK
lin noninfectious_A = mkWA "tarttumaton" ; --UNCHK
lin noninflammatory_A = mkWA (compoundA "ei-" (k38 "tulehduksellinen")) ; --UNCHK
lin noninheritable_A = mkWA "periytymätön" ; --UNCHK
lin noninstitutional_A = mkWA "avohoito-" ; --UNCHK
lin noninstitutionalized_A = mkWA (k10 "oleva") "avohoidossa" ; --UNCHK
lin nonintegrated_A = mkWA "integroimaton" ; --UNCHK
lin nonintellectual_A = mkWA (compoundA "epä" (k38 "intellektuaalinen")) ; --UNCHK
lin noninterchangeable_A = mkWA (compoundA "vaihto" (k34A "kelvoton")) ; --UNCHK
lin nonintervention_N = mkWN "sekaantumattomuus" ; --UNCHK
lin noninvasive_A = mkWA "kajoamaton" ; --UNCHK
lin nonionic_A = mkWA "ioniton" ; --UNCHK
lin nonionized_A = mkWA "ioniton" ; --UNCHK
lin nonjudgmental_A = mkWA "tuomitsematon" ; --UNCHK
lin nonkosher_A = mkWA (compoundA "epä" (k41A "puhdas")) ; --UNCHK
lin nonlethal_A = mkWA "ei-tappava" ; --UNCHK
lin nonlexical_A = mkWA (compoundA "ei-" (k38 "leksikaalinen")) ; --UNCHK
lin nonlinear_A = mkWA (compoundA "epä" (k38 "lineaarinen")) ; --UNCHK
lin nonlinguistic_A = mkWA (compoundA "ei-" (k38 "kielellinen")) ; --UNCHK
lin nonmagnetic_A = mkWA (compoundA "ei-" (k38 "magneettinen")) ; --UNCHK
lin nonmandatory_A = mkWA (compoundA "tahdon" (k38 "valtainen")) ; --UNCHK
lin nonmechanical_A = mkWA (compoundA "epä" (k38 "mekaaninen")) ; --UNCHK
lin nonmechanistic_A = mkWA (compoundA "epä" (k38 "mekaaninen")) ; --UNCHK
lin nonmember_N = mkWN (k32 "jäsen") "ei" ; --UNCHK
lin nonmetal_N = mkWN (compoundN "epä" (k5 "metalli")) ; --UNCHK
lin nonmetallic_A = mkWA (compoundA "ei-" (k38 "metallinen")) ; --UNCHK
lin nonmetamorphic_A = mkWA (compoundA "epämet" (k38 "amorfinen")) ; --UNCHK
lin nonmigratory_A = mkWA "paikka-" ; --UNCHK
lin nonmodern_A = mkWA (compoundA "epä" (k5 "moderni")) ; --UNCHK
lin nonmonotonic_A = mkWA (compoundA "ei-" (k38 "monotoninen")) ; --UNCHK
lin nonmotile_A = mkWA (k34A "liikkumaton") ; --UNCHK
lin nonmoving_A = mkWA (k34A "liikkumaton") ; --UNCHK
lin nonnative_A = mkWA "ei-syntyperäinen" ; --UNCHK
lin nonnatural_A = mkWA (compoundA "tuon" (k38 "puoleinen")) ; --UNCHK
lin nonnegative_A = mkWA (compoundA "epä" (k38 "negatiivinen")) ; --UNCHK
lin nonnomadic_A = mkWA (compoundA "ase" (k47 "ttunut")) "paikoilleen" ; --UNCHK
lin nonnormative_A = mkWA (compoundA "epä" (k38 "normatiivinen")) ; --UNCHK
lin nonobservance_N = mkWN "noudattamatta" "jättäminen" ; --UNCHK
lin nonobservant_A = mkWA "noudattamatta" "jättävä" ; --UNCHK
lin nonoccurrence_N = mkWN "esiintymättömyys" ; --UNCHK
lin nonopening_A = mkWA "avautumaton" ; --UNCHK
lin nonoperational_A = mkWA (k34A "toimeton") ; --UNCHK
lin nonoscillatory_A = mkWA "värähtelemätön" ; --UNCHK
lin nonparallel_A = mkWA "epäyhdensuuntainen" ; --UNCHK
lin nonparametric_A = mkWA (compoundA "epäpara" (k38 "metrinen")) ; --UNCHK
lin nonpareil_N = mkWN (compoundN "suklaa" (k38 "makeinen")) ; --UNCHK
lin nonparticipant_N = mkWN (k2 "henkilö") "osallistumaton" ; --UNCHK
lin nonparticulate_A = mkWA "hiukkasista" "koostumaton" ; --UNCHK
lin nonpartisan_A = mkWA (k34A "sitoutumaton") ; --UNCHK
lin nonpartisan_N = mkWN (k2 "henkilö") "poliittisesti" "sitoutumaton" ; --UNCHK
lin nonpasserine_A = mkWA (compoundA "ei-varpus" (k38 "mainen")) ; --UNCHK
lin nonpayment_N = mkWN "maksamatta" "jättäminen" ; --UNCHK
lin nonperson_N = mkWN (compoundN "epä" (k2 "henkilö")) ; --UNCHK
lin nonpersonal_A = mkWA (k34A "persoonaton") ; --UNCHK
lin nonphotosynthetic_A = mkWA (compoundA "ei-foto" (k38 "synteettinen")) ; --UNCHK
lin nonplus_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin nonpoisonous_A = mkWA (k34A "myrkytön") ; --UNCHK
lin nonpolitical_A = mkWA (compoundA "epä" (k38 "poliittinen")) ; --UNCHK
lin nonporous_A = mkWA "huokoseton" ; --UNCHK
lin nonprehensile_A = mkWA "tarttumaton" ; --UNCHK
lin nonproductive_A = mkWA (k34A "tuottamaton") ; --UNCHK
lin nonprofessional_A = mkWA "harrastaja-" ; --UNCHK
lin nonprofit_A = mkWA (compoundA "ei-" (k38 "kaupallinen")) ; --UNCHK
lin nonprognosticative_A = mkWA (k34A "tekemätön") "ennustuksia" ; --UNCHK
lin nonproliferation_N = mkWN (compoundN "ase" (k39 "rajoitus")) ; --UNCHK
lin nonpsychoactive_A = mkWA (compoundA "akti" (k34A "voimaton")) "mieltä" ; --UNCHK
lin nonpublic_A = mkWA (k38 "yksityinen") ; --UNCHK
lin nonpurulent_A = mkWA "märkimätön" ; --UNCHK
lin nonracial_A = mkWA (compoundA "ei-" (k38 "rodullinen")) ; --UNCHK
lin nonradioactive_A = mkWA "säteilemätön" ; --UNCHK
lin nonrandom_A = mkWA (compoundA "epä" (k38 "satunnainen")) ; --UNCHK
lin nonrational_A = mkWA (k38 "vaistomainen") ; --UNCHK
lin nonreader_N = mkWN (k2 "henkilö") "lukutaidoton" ; --UNCHK
lin nonreciprocal_A = mkWA (compoundA "epä" (k38 "resiprookkinen")) ; --UNCHK
lin nonrecreational_A = mkWA (k38 "palkallinen") ; --UNCHK
lin nonreflective_A = mkWA "heijastamaton" ; --UNCHK
lin nonrepetitive_A = mkWA "toistumaton" ; --UNCHK
lin nonrepresentational_A = mkWA (k38 "abstraktinen") ; --UNCHK
lin nonrepresentative_A = mkWA "vertauskuvaton" ; --UNCHK
lin nonresident_A = mkWA "muualla" "asuva" ; --UNCHK
lin nonresident_N = mkWN "vieraspaikkakuntalainen" ; --UNCHK
lin nonresidential_A = mkWA (k34A "asumaton") ; --UNCHK
lin nonresilient_A = mkWA (k34A "joustamaton") ; --UNCHK
lin nonresistance_N = mkWN "väkivallasta" "pidättyminen" ; --UNCHK
lin nonresistant_A = mkWA (compoundA "vastustus" (k34A "kyvytön")) ; --UNCHK
lin nonrestrictive_A = mkWA (k38 "irrallinen") ; --UNCHK
lin nonreticulate_A = mkWA "verkottumaton" ; --UNCHK
lin nonretractile_A = mkWA "ei-sisäänvedettävä" ; --UNCHK
lin nonreversible_A = mkWA (compoundA "yksi" (k38 "puolinen")) ; --UNCHK
lin nonrhythmic_A = mkWA "rytmitön" ; --UNCHK
lin nonrigid_A = mkWA (k10 "joustava") ; --UNCHK
lin nonruminant_A = mkWA "märehtimätön" ; --UNCHK
lin nonsectarian_A = mkWA "lahkoutumaton" ; --UNCHK
lin nonsense_N = mkWN (k40 "turhuus") ; --UNCHK
lin nonsensical_A = mkWA (k34A "järjetön") ; --UNCHK
lin nonsensitive_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin nonsignificant_A = mkWA (k34A "merkityksetön") ; --UNCHK
lin non_skid_A = mkWA "luisumaton" ; --UNCHK
lin nonslip_A = mkWA "liukumaton" ; --UNCHK
lin nonslippery_A = mkWA "liukumaton" ; --UNCHK
lin nonsmoker_N = mkWN (k1 "vaunu") "tupakoimattomien" ; --UNCHK
lin nonspatial_A = mkWA (compoundA "epä" (k38 "spatiaalinen")) ; --UNCHK
lin nonspeaking_A = mkWA (k10A "mykkä") ; --UNCHK
lin nonspecific_A = mkWA (compoundA "epä" (k38 "määräinen")) ; --UNCHK
lin nonspherical_A = mkWA (compoundA "ei-pall" (k38 "omainen")) ; --UNCHK
lin nonstandard_A = mkWA (k10 "poikkeava") "normista" ; --UNCHK
lin nonsteroid_N = mkWN (compoundN "ei-" (k5 "steroidi")) ; --UNCHK
lin nonsteroidal_A = mkWA (k34A "kuulumaton") "steroideihin" ; --UNCHK
lin nonstick_A = mkWA "tarttumaton" ; --UNCHK
lin nonstop_A = mkWA (k99 "ympäri") "vuorokauden" ; --UNCHK
lin nonstop_Adv = mkWAdv "yhtä" "soittoa" ; --UNCHK
lin nonsubmersible_A = mkWA "ei-upotettava" ; --UNCHK
lin nonsuch_N = mkWN (k5 "ideaali") ; --UNCHK
lin nonsuppurative_A = mkWA "märkimätön" ; --UNCHK
lin nonsurgical_A = mkWA "kajoamaton" ; --UNCHK
lin nonsyllabic_A = mkWA (compoundA "epä" (k38 "syllaabinen")) ; --UNCHK
lin nonsynchronous_A = mkWA (compoundA "epä" (k38 "synkroninen")) ; --UNCHK
lin nonsynthetic_A = mkWA "ei-keinotekoinen" ; --UNCHK
lin nontaxable_A = mkWA (compoundA "vero" (k17 "vapaa")) ; --UNCHK
lin nontechnical_A = mkWA (compoundA "ei-" (k38 "tekninen")) ; --UNCHK
lin nontelescopic_A = mkWA (compoundA "ei-" (k38 "teleskooppinen")) ; --UNCHK
lin nonterritorial_A = mkWA "reviiritön" ; --UNCHK
lin nonthermal_A = mkWA "lämmötön" ; --UNCHK
lin nontoxic_A = mkWA (k34A "myrkytön") ; --UNCHK
lin nontraditional_A = mkWA (k38 "uudenlainen") ; --UNCHK
lin nontranslational_A = mkWA (compoundA "epä" (k38 "translatorinen")) ; --UNCHK
lin nontricyclic_N = mkWN (k48A "lääke") "ei-trisyklinen" ; --UNCHK
lin nonturbulent_A = mkWA "pyörteetön" ; --UNCHK
lin nonuniformity_N = mkWN "epäyhdenmukaisuus" ; --UNCHK
lin nonunion_A = mkWA "järjestäytymätön" ; --UNCHK
lin nonuple_A = mkWA (k4A "yhdeksikkö") ; --UNCHK
lin nonvenomous_A = mkWA (k34A "myrkytön") ; --UNCHK
lin nonverbal_A = mkWA (k34A "sanaton") ; --UNCHK
lin nonviable_A = mkWA (compoundA "elin" (k34A "kelvoton")) ; --UNCHK
lin nonviolence_N = mkWN (compoundN "väki" (k40 "vallattomuus")) ; --UNCHK
lin nonvisual_A = mkWA (compoundA "ei-" (k38 "visuaalinen")) ; --UNCHK
lin nonvolatile_A = mkWA "haihtumaton" ; --UNCHK
lin nonwashable_A = mkWA (compoundA "pesun" (k34A "kestämätön")) ; --UNCHK
lin nonwoody_A = mkWA (k34A "puuton") ; --UNCHK
lin nonworker_N = mkWN (k2 "henkilö") "työtä" "tekemätön" ; --UNCHK
lin noodle_N = mkWN (k7A "päälaki") ; --UNCHK
lin nook_N = mkWN (k7A "soppi") ; --UNCHK
lin noon_N = mkN "keski" (mkN "päivä") ;
lin noontide_N = mkWN (k7 "hetki") "keskipäivän" ; --UNCHK
lin noormarkku_PN = mkPN "Noormarkku" ;
lin noose_N = mkWN (compoundN "juoksu" (k14A "silmukka")) ; --UNCHK
lin noose_V2 = mkWV2 (k53A "kiinnittää") "juoksusilmukalla" ; --UNCHK
lin nopal_N = mkWN (compoundN "nopal-" (k39 "kaktus")) ; --UNCHK
lin nope_Interj = mkInterj "ei" ;
lin nor_Conj = mkConj "eikä" ;
lin nora_PN = foreignPN "Nora" ;
lin noradrenaline_N = mkWN (compoundN "nor" (k5 "adrenaliini")) ; --UNCHK
lin nordic_A = mkA "pohjoismainen" ;
lin nordic_N = mkN "pohjoismaalainen" ;
lin norethindrone_N = mkWN (compoundN "noretindroni" (k5A "asetaatti")) ; --UNCHK
lin norfolk_PN = foreignPN "Norfolk" ;
lin noria_N = mkWN (compoundN "vedennosto" (k41A "ratas")) ; --UNCHK
lin norm_N = mkWN (k6 "standardi") ;
lin normal_A = mkWA (k6 "normaali") ;
lin normal_N = mkWN (k1A "käytäntö") ; --UNCHK
lin normalcy_N = mkWN (k40 "tavallisuus") ; --UNCHK
lin normality_N = mkWN (k40 "normaalius") ; --UNCHK
lin normalization_N = mkWN (k5A "normalisointi") ; --UNCHK
lin normalize_V2 = mkWV2 (k62 "normalisoida") ; --UNCHK
lin normalizer_N = mkWN (compoundN "normali" (k10 "soija")) ; --UNCHK
lin norman_A = mkWA (compoundA "normanni" (k38 "lainen")) ; --UNCHK
lin norman_N = mkWN (k5 "normanni") ; --UNCHK
lin norman_PN = foreignPN "Norman" ;
lin normanton_PN = foreignPN "Normanton" ;
lin normative_A = mkWA "ohjaileva" ; --UNCHK
lin normotensive_A = mkWA "normotensiivinen" ; --UNCHK
lin normothermia_N = mkWN "normotermia" ; --UNCHK
lin norse_A = mkWA (k38 "norjalainen") ; --UNCHK
lin norse_N = mkN "muinaisnorjalainen" ;
lin north_A = mkWA (k38 "pohjoinen") ;
lin north_Adv = mkWAdv (k99 "päin") "pohjoiseen" ; --UNCHK
lin north_N = mkN (lin NK {s = d38 "pohjoinen"}) ;
lin north_korea_PN = mkPN "Pohjois-Korea" ;
lin north_northeast_N = mkWN (compoundN "pohjois" (k38 "koillinen")) ; --UNCHK
lin north_northwest_N = mkWN (k48A "pohjoisluode") ; --UNCHK
lin northallerton_PN = foreignPN "Northallerton" ;
lin northam_PN = foreignPN "Northam" ;
lin northampton_PN = foreignPN "Northampton" ;
lin northbound_A = mkWA (k10 "menevä") "pohjoiseen" ; --UNCHK
lin northeast_Adv = mkWAdv "koilliseen" ; --UNCHK
lin northeast_N = mkWN (k38 "koillinen") ;
lin northeaster_N = mkWN (compoundN "koillis" (k26 "tuuli")) ; --UNCHK
lin northeasterly_A = mkWA "koillis-" ; --UNCHK
lin northeastern_A = mkWA "Koillis-" ; --UNCHK
lin northeastward_A = mkWA "koillis-" ; --UNCHK
lin northeastward_Adv = mkWAdv "koilliseen" ; --UNCHK
lin northerly_A = mkWA "pohjois-" ; --UNCHK
lin northerly_Adv = mkWAdv (k99 "päin") "pohjoiseen" | adjAdv northerly_A ; --UNCHK -- derived
lin northern_A = mkWA (k38 "pohjoinen") ;
lin northerner_N = mkWN (k41A "asukas") "pohjoisvaltioiden" ; --UNCHK
lin northernmost_A = mkWA "pohjoisin" ; --UNCHK
lin northernness_N = mkWN "pohjoisuus" ; --UNCHK
lin northland_N = mkWN (k18 "maa") "pohjoinen" ; --UNCHK
lin northman_N = mkWN (k5 "skandinaavi") ; --UNCHK
lin northumberland_PN = foreignPN "Northumberland" ;
lin northwards_Adv = mkWAdv (k99 "päin") "pohjoiseen" ; --UNCHK
lin northwest_Adv = mkWAdv "luoteeseen" ; --UNCHK
lin northwest_N = mkWN (compoundN "luoteis" (k10 "osa")) ; --UNCHK
lin northwester_N = mkWN (compoundN "luoteis" (k1 "myrsky")) ; --UNCHK
lin northwesterly_A = mkWA "luoteis-" ; --UNCHK
lin northwestern_A = mkWA "Luoteis-" ; --UNCHK
lin northwestward_A = mkWA "luoteeseen" ; --UNCHK
lin northwestward_Adv = mkWAdv "luoteeseen" ; --UNCHK
lin northwich_PN = foreignPN "Northwich" ;
lin norton_PN = foreignPN "Norton" ;
lin nortriptyline_N = mkWN "Pamelor" ; --UNCHK
lin norway_PN = foreignPN "Norja" ;
lin norwegianFem_N = mkWN (kH1 "norja") ; --UNCHK
lin norwegianMasc_N = mkWN (kH1 "norja") ; --UNCHK
lin norwegian_A = mkWA (k38 "norjalainen") ; --UNCHK
lin norwich_PN = foreignPN "Norwich" ;
lin nose_N = L.nose_N ;
lin nose_V = mkWV (k53A "voittaa") "täpärästi" ; --UNCHK
lin nose_V2 = mkWV2 (k53A "voittaa") "täpärästi" ; --UNCHK
lin nose_flute_N = mkWN (compoundN "nenä" (k1 "huilu")) ; --UNCHK
lin nose_out_V2 = mkWV2 (k74 "vaistota") ; --UNCHK
lin nosebag_N = mkWN (compoundN "rehu" (k5 "pussi")) ; --UNCHK
lin noseband_N = mkWN (k9A "silta") ; --UNCHK
lin nosebleed_N = mkWN "nenäverenvuoto" ; --UNCHK
lin nosedive_N = mkWN (k1 "syöksy") ; --UNCHK
lin nosedive_V = mkWV (k52 "syöksyä") ; --UNCHK
lin nosegay_N = mkWN (compoundN "kukka" (k1 "vihko")) ; --UNCHK
lin noseless_A = mkWA "nenätön" ; --UNCHK
lin nosepiece_N = mkWN (k9A "silta") ; --UNCHK
lin nose_wheel_N = mkWN (compoundN "nokka" (k10 "pyörä")) ; --UNCHK
lin nosey_A = mkWA (k41 "utelias") ; --UNCHK
lin nosh_N = mkWN (compoundN "väli" (k9 "pala")) ; --UNCHK
lin nosh_V = mkWV (k67 "napostella") ; --UNCHK
lin nosher_N = mkWN "napostelija" ; --UNCHK
lin nosiness_N = mkWN (k40 "uteliaisuus") ; --UNCHK
lin nosocomial_A = mkWA "sairaala-" ; --UNCHK
lin nosohusial_A = mkWA "kotihoito-" ; --UNCHK
lin nosology_N = mkWN (k9A "diagnostiikka") ; --UNCHK
lin nostalgia_N = mkWN (k40 "haikeus") ; --UNCHK
lin nostalgic_A = mkWA (k38 "nostalginen") ; --UNCHK
lin nostalgically_Adv = mkWAdv (k99 "nostalgisesti") ; --UNCHK
lin nostoc_N = mkWN (compoundN "sini" (k10 "levä")) ; --UNCHK
lin nostril_N = mkWN (k33 "sierain") ; --UNCHK
lin nostrum_N = mkWN (compoundN "patentti" (k48A "lääke")) ; --UNCHK
lin nosy_A = mkWA (k41 "utelias") ; --UNCHK
lin not_Adv = mkAdv "ei" ;
lin not_Predet = S.not_Predet ;
lin notability_N = mkWN (k2 "henkilö") "kuuluisa" ; --UNCHK
lin notable_A = mkA "huomattava" ;
lin notable_N = mkWN (k2 "henkilö") "kuuluisa" ; --UNCHK
lin notary_N = mkWN (k6 "notaari") "julkinen" ; --UNCHK
lin notation_N = mkWN (compoundN "merkintä" (k9A "tapa")) ; --UNCHK
lin notch_N = mkWN (k1A "viilto") ; --UNCHK
lin notch_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin note_1_N = mkN "muistiin" (mkN "pano") ;
lin note_2_N = mkN "huomautus" ;
lin note_3_N = mkN "nuotti" ;
lin note_N = mkN "huomautus" ; --- already split
lin note_V = mkWV (k73 "huomata") ; --UNCHK
lin note_V2 = mkWV2 (k73 "huomata") ;
lin note_VS = mkVS (mkV "huomauttaa") ;
lin note_down_V2 = prepV2 OP_note_V OP_down_Prep ; -- guess-p-verb
lin notebook_N = mkWN (compoundN "tieto" (k48 "kone")) "kannettava" ; --UNCHK
lin notecase_N = mkWN (k4A "lompakko") ; --UNCHK
lin noted_A = mkA "huomattu" ;
lin notepad_N = mkWN (compoundN "muisti" (k3 "lehtiö")) ; --UNCHK
lin notepaper_N = mkWN (compoundN "kirje" (k6 "paperi")) ; --UNCHK
lin noteworthy_A = mkWA (k10 "huomattava") ; --UNCHK
lin nothing_Adv = mkWAdv (k99 "ensinkään") "ei" ; --UNCHK
lin nothing_N = mkWN (k101 "mikään") "ei" ; --UNCHK
lin nothing_NP = S.nothing_NP ** {s = \\c => "ei" ++ S.nothing_NP.s ! c} | S.nothing_NP ** {s = \\c => S.nothing_NP.s ! c} ;
lin nothingness_N = mkWN (k48 "puhe") "turha" ; --UNCHK
lin nothosaur_N = mkWN "nothosaurus" ; --UNCHK
lin notice_N = mkWN (k1A "havainto") ; --UNCHK
lin notice_V2 = mkV2 "huomata" ;
lin notice_VS = mkVS (mkV "huomata") ;
lin notice_board_N = mkWN (compoundN "ilmoitus" (k1 "taulu")) ; --UNCHK
lin noticeable_A = mkWA (k10 "näkyvä") ; --UNCHK
lin noticer_N = mkWN (compoundN "tiedon" (k10 "antaja")) ; --UNCHK
lin notifiable_A = mkWA "ilmoitettava" ; --UNCHK
lin notification_N = mkWN (k39 "ilmoitus") ; --UNCHK
lin notify_V2 = mkV2 "ilmoittaa" allative ;
lin notion_N = mkN "käsite" ; --WN (k50 "lyhyttavara") ;
lin notional_A = mkWA (k38 "teoreettinen") ; --UNCHK
lin notochord_N = mkWN (compoundN "selkä" (k48A "jänne")) ; --UNCHK
lin notoriety_N = mkWN (k40 "pahamaineisuus") ; --UNCHK
lin notorious_A = mkA (mkN "paha" (mkN "maineinen")) ;
lin notornis_N = mkWN "jättiliejukana" ; --UNCHK
lin nottingham_PN = foreignPN "Nottingham" ;
lin notwithstanding_Adv = mkAdv "huolimatta" ;
lin notwithstanding_Prep = mkPrep elative "huolimatta" ;
lin nought_N = mkWN (k10 "nolla") ; --UNCHK
lin noumenon_N = mkWN (k99 "sinänsä") ; --UNCHK
lin noun_N = mkWN (k5 "substantiivi") ; --UNCHK
lin nourish_V2 = mkWV2 (k69 "ravita") ; --UNCHK
lin nourishment_N = mkWN (compoundN "ravi" (k38 "tseminen")) ; --UNCHK
lin nous_N = mkWN (k5 "älli") ; --UNCHK
lin nousiainen_PN = mkPN "Nousiainen" ;
lin nov_PN = foreignPN "Nov" ;
lin nova_N = mkWN (k10 "nova") ; --UNCHK
lin novara_PN = foreignPN "Novara" ;
lin novation_N = mkWN (compoundN "uudis" (k38 "taminen")) ; --UNCHK
lin novel_A = mkWA (k38 "uudenlainen") ; --UNCHK
lin novel_N = mkWN (k6 "romaani") ;
lin novelette_N = mkWN (k5 "novelli") ; --UNCHK
lin novelist_N = mkN "romaanikirjailija" ;
lin novelization_N = mkWN (compoundN "kirjo" (k38 "ittaminen")) "romaaniksi" ; --UNCHK
lin novelty_N = mkWN (k1 "koru") ; --UNCHK
lin novena_N = mkWN "novena" ; --UNCHK
lin novice_N = mkWN (k10 "aloittaja") ; --UNCHK
lin noviciate_N = mkWN (k9A "noviisiaika") ; --UNCHK
lin novillada_N = mkWN (compoundN "härkä" (k2 "taistelu")) ; --UNCHK
lin novillero_N = mkWN (compoundN "novill" (k1 "ero")) ; --UNCHK
lin novitiate_N = mkWN (k5 "noviisi") ; --UNCHK
lin novobiocin_N = mkWN "novobiosiini" ; --UNCHK
lin novokuznetsk_PN = foreignPN "Novokuznetsk" ;
lin novosibirsk_PN = foreignPN "Novosibirsk" ;
lin now_AdV = lin AdV (ss "nyt") ;
lin now_Adv = L.now_Adv ;
lin nowadays_Adv = mkWAdv (k99 "nykyään") ; --UNCHK
lin nowhere_Adv = mkAdv "ei missään" | mkAdv "ei minnekään" | mkAdv "missään" | mkAdv "minnekään" ; ---- split: be nowhere ; go nowhere
lin nowhere_N = mkWN (k101 "missään") "ei" ; --UNCHK
lin nowise_Adv = mkWAdv (k99 "lailla") "ei" "millään" ; --UNCHK
lin noxious_A = mkWA (k38 "vahingollinen") ; --UNCHK
lin noxiousness_N = mkWN (k40 "haitallisuus") ; --UNCHK
lin nozzle_N = mkWN (k10A "nokka") ; --UNCHK
lin nt_N = mkWN "NT" ; --UNCHK
lin nth_A = mkWA (k38 "äärimmäinen") ; --UNCHK
lin nu_N = mkWN "nyy" ; --UNCHK
lin nuance_N = mkWN (k1 "ero") "hiuksenhieno" ; --UNCHK
lin nub_N = mkWN (k48A "piirre") "tärkeä" ; --UNCHK
lin nubbin_N = mkWN (k10 "tähkä") "kehittymätön" ; --UNCHK
lin nubile_A = mkWA (compoundA "avioliitto" (k38 "kelpoinen")) ; --UNCHK
lin nucellus_N = mkWN (k33 "sydän") ; --UNCHK
lin nuclear_A = mkA "ytimellinen" ; ---ARB mkWA "ydin-" ;
lin nuclease_N = mkWN (compoundN "nukle" (k5 "aasi")) ; --UNCHK
lin nucleolus_N = mkWN (compoundN "tuma" (k38 "jyvänen")) ; --UNCHK
lin nucleon_N = mkWN (k5 "nukleoni") ; --UNCHK
lin nucleoplasm_N = mkWN (compoundN "tuma" (k9 "lima")) ; --UNCHK
lin nucleoprotein_N = mkWN (compoundN "nukleo" (k5 "proteiini")) ; --UNCHK
lin nucleoside_N = mkWN "nukleosidi" ; --UNCHK
lin nucleosynthesis_N = mkWN (compoundN "nukleo" (k5 "synteesi")) ; --UNCHK
lin nucleotide_N = mkWN (k39 "emäs") ; --UNCHK
lin nucleus_N = mkWN (k33A "ydin") ; --UNCHK
lin nude_A = mkA "alaston" ;
lin nude_N = mkWN (compoundN "alaston" (k10 "kuva")) ; --UNCHK
lin nudge_N = mkWN (k1A "työntö") ; --UNCHK
lin nudge_V2 = mkWV2 (k54A "työntää") ; --UNCHK
lin nudger_N = mkWN "tönijä" ; --UNCHK
lin nudism_N = mkWN (k5 "naturismi") ; --UNCHK
lin nudist_N = mkWN (k5 "naturisti") ; --UNCHK
lin nudity_N = mkWN (k40 "alastomuus") ; --UNCHK
lin nudnik_N = mkWN (k1 "hölmö") ; --UNCHK
lin nugatory_A = mkWA (k34A "tehoton") ; --UNCHK
lin nugget_N = mkWN (k1A "hippu") ; --UNCHK
lin nuijamaa_PN = mkPN "Nuijamaa" ;
lin nuisance_N = mkWN (k3 "häiriö") ; --UNCHK
lin null_A = mkWA (k34A "pätemätön") ; --UNCHK
lin nullah_N = mkWN (k1 "laakso") ; --UNCHK
lin nullification_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin nullifier_N = mkWN "mitätöijä" ; --UNCHK
lin nullify_V2 = mkWV2 (k71 "tehdä") "tyhjäksi" ; --UNCHK
lin nullipara_N = mkWN (k38 "nainen") "synnyttämätön" ; --UNCHK
lin nullity_N = mkWN (k40 "pätemättömyys") ; --UNCHK
lin numb_A = mkWA (compoundA "lama" (k47 "antunut")) ; --UNCHK
lin numb_V2 = mkWV2 (k53A "tylsyttää") ; --UNCHK
lin numbat_N = mkWN (compoundN "muurahais" (k1 "karhu")) ; --UNCHK
lin number_1_N = mkN "luku" ;
lin number_2_N = mkN "luku" (mkN "määrä") | mkN "määrä" ;
lin number_3_N = mkN "luku" ;
lin number_N = mkN "luku" ; --- split already
lin number_V2 = mkV2 "numeroida" partitive ; --mkWV2 (k53 "estää") "kohoamasta" ;
lin numberless_A = mkWA (k34A "rajaton") ; --UNCHK
lin numberplate_N = mkWN (compoundN "rekisteri" (k7A "kilpi")) ; --UNCHK
lin numbing_A = mkWA "puuduttava" ; --UNCHK
lin numbness_N = mkWN (k40 "hengettömyys") ; --UNCHK
lin numdah_N = mkWN (compoundN "numdah-" (k1A "matto")) ; --UNCHK
lin numen_N = mkWN "numen" ; --UNCHK
lin numerable_A = mkWA (k10 "oleva") "laskettavissa" ; --UNCHK
lin numeracy_N = mkWN (compoundN "lasku" (k1A "taito")) ; --UNCHK
lin numeral_A = mkWA (k38 "numeerinen") ; --UNCHK
lin numeral_N = mkWN (k2 "numero") ; --UNCHK
lin numerate_A = mkWA (compoundA "lasku" (k38 "taitoinen")) ; --UNCHK
lin numeration_N = mkWN (k38 "lukeminen") "numeroiden" ; --UNCHK
lin numerator_N = mkWN (k10 "osoittaja") ; --UNCHK
lin numeric_A = mkWA (k38 "numeerinen") ; --UNCHK
lin numerical_A = mkWA (k38 "matemaattinen") ; --UNCHK
lin numerological_A = mkWA (compoundA "numero" (k38 "loginen")) ; --UNCHK
lin numerologistFem_N = mkWN "numerologi" ; --UNCHK
lin numerologistMasc_N = mkWN "numerologi" ; --UNCHK
lin numerology_N = mkWN (k12 "numerologia") ; --UNCHK
lin numerous_A = mkA "lukematon" ;
lin numerousness_N = mkWN (k40 "paljous") ; --UNCHK
lin numinous_A = mkWA "numeeninen" ; --UNCHK
lin numismatics_N = mkWN (k2 "keräily") "rahojen" ; --UNCHK
lin numismatist_N = mkWN (k12 "keräilijä") "rahojen" ; --UNCHK
lin nummulite_N = mkWN "nummuliitti" ; --UNCHK
lin numskull_N = mkWN (k1 "tollo") ; --UNCHK
lin nun_N = mkWN "nun" ; --UNCHK
lin nuncio_N = mkWN "apostolinen" "nuntius" ; --UNCHK
lin nuneaton_PN = foreignPN "Nuneaton" ;
lin nunnery_N = mkWN (k6 "luostari") ; --UNCHK
lin nuptial_A = mkWA (k38 "aviollinen") ; --UNCHK
lin nurmes_PN = mkPN "Nurmes" ;
lin nurmijärvi_PN = mkPN (mkN "Nurmijärvi" "Nurmijärviä") ;
lin nurmo_PN = mkPN "Nurmo" ;
lin nurse_N = mkN "sairaanhoitaja" "sairaanhoitajia" ;
lin nurse_V2 = mkWV2 (k53A "hoitaa") ; --UNCHK
lin nurseling_N = mkWN (k38 "imeväinen") ; --UNCHK
lin nursemaid_N = mkWN (k10 "imettäjä") ; --UNCHK
lin nurser_N = mkWN "hoivaaja" ; --UNCHK
lin nursery_N = mkWN (compoundN "taimi" (k9 "tarha")) ; --UNCHK
lin nurseryman_N = mkWN (k6 "puutarhuri") ; --UNCHK
lin nursing_A = variants {} ; --
lin nursing_N = mkWN (compoundN "hoito" (k19 "työ")) ; --UNCHK
lin nursing_home_N = mkWN (k12 "hoitola") ; --UNCHK
lin nursling_N = mkWN (k38 "imeväinen") ; --UNCHK
lin nurtural_A = mkWA "hoito-" ; --UNCHK
lin nurturance_N = mkWN (k10 "hoiva") ; --UNCHK
lin nurturant_A = mkWA "hoiva-" ; --UNCHK
lin nurture_N = mkWN (k39 "kasvatus") ; --UNCHK
lin nurture_V2 = mkWV2 (k53A "kouluttaa") ; --UNCHK
lin nut_N = mkWN (k6 "mutteri") ; --UNCHK
lin nut_V = mkWV (k73 "kerätä") "pähkinöitä" ; --UNCHK
lin nut_butter_N = mkWN (k18 "pähkinävoi") ; --UNCHK
lin nutation_N = mkWN (compoundN "nuok" (k38 "kuminen")) ; --UNCHK
lin nut_brown_A = mkWA (compoundA "pähkinän" (k15 "ruskea")) ; --UNCHK
lin nutcracker_N = mkWN (k5A "pähkinähakki") ; --UNCHK
lin nutgrass_N = mkWN (compoundN "säde" (k9 "kaisla")) ; --UNCHK
lin nuthatch_N = mkWN (k5A "pähkinähakki") ; --UNCHK
lin nuthouse_N = mkWN (k3 "sanatorio") ; --UNCHK
lin nutlet_N = mkWN (k12 "pähkylä") ; --UNCHK
lin nutlike_A = mkWA (compoundA "pähkinä" (k38 "mäinen")) ; --UNCHK
lin nutmeg_N = mkWN (compoundN "muskotti" (k12 "pähkinä")) ; --UNCHK
lin nutria_N = mkWN (k12 "nutria") ; --UNCHK
lin nutrient_A = mkWA (k10 "ravitseva") ;
lin nutrient_N = mkN "ravinto" ;
lin nutriment_N = mkWN (k10A "ruoka") ; --UNCHK
lin nutrition_N = mkWN (compoundN "ravinto-" (k5A "oppi")) ; --UNCHK
lin nutritional_A = mkWA "ravinto-" ; --UNCHK
lin nutritious_A = mkWA (k10 "ravitseva") ; --UNCHK
lin nutritiousness_N = mkWN (k40 "ravitsevuus") ; --UNCHK
lin nutritive_A = mkWA (k10 "ravitseva") ; --UNCHK
lin nuts_A = mkWA (k1 "pöllö") ; --UNCHK
lin nutshell_N = mkWN (k26 "pähkinänkuori") ; --UNCHK
lin nutter_N = mkWN (k1 "kahjo") ; --UNCHK
lin nutty_A = mkWA (k1 "pöllö") ; --UNCHK
lin nuzzle_V = mkWV (k61A "tonkia") ; --UNCHK
lin nuzzle_V2 = mkWV2 (k61A "tonkia") ; --UNCHK
lin nyala_N = mkWN "Tragelaphus" "angasi" ; --UNCHK
lin nybble_N = mkWN (compoundN "puoli" (k1 "tavu")) ; --UNCHK
lin nyctalopia_N = mkWN (k50 "hämäräsokeus") ; --UNCHK
lin nyctophobia_N = mkWN (compoundN "pimeän" (k1A "pelko")) ; --UNCHK
lin nykarleby_PN = mkPN "Uusi-Kaarlepyy" ;
lin nylon_N = mkWN (k6 "nailon") ; --UNCHK
lin nymph_N = mkWN (k5 "nymfi") ; --UNCHK
lin nymphalid_N = mkWN (compoundN "täplä" (k38 "perhonen")) ; --UNCHK
lin nymphet_N = mkWN (k5A "nymfetti") ; --UNCHK
lin nympho_N = mkWN (k5 "nymfomaani") ; --UNCHK
lin nympholepsy_N = mkWN (k1 "kiihko") ; --UNCHK
lin nympholept_N = mkWN "nymfolepti" ; --UNCHK
lin nymphomania_N = mkWN (k12 "nymfomania") ; --UNCHK
lin nymphomaniac_A = mkWA (k38 "nymfomaaninen") ; --UNCHK
lin nymphomaniac_N = mkWN (k5 "nymfomaani") ; --UNCHK
lin nymphomaniacal_A = mkWA (k38 "nymfomaaninen") ; --UNCHK
lin nystagmus_N = mkWN (compoundN "silmä" (k48 "väre")) ; --UNCHK
lin nystatin_N = mkWN "Nystan" ; --UNCHK
lin närpes_PN = mkPN "Närpiä" ;
lin o'er_Adv = mkWAdv (k99 "yli") ; --UNCHK
lin o_level_N = mkWN "O" "level" ; --UNCHK
lin oaf_N = mkWN (k2 "tohelo") ; --UNCHK
lin oafish_A = mkWA (k38 "sikamainen") ; --UNCHK
lin oak_N = mkWN (kH1 "tammi") ; --UNCHK
lin oak_apple_N = mkWN (compoundN "väri" (k11 "omena")) ; --UNCHK
lin oakengates_PN = foreignPN "Oakengates" ;
lin oakum_N = mkWN (k48A "tilke") ; --UNCHK
lin oar_N = mkWN (k1 "airo") ; --UNCHK
lin oarfish_N = mkWN (compoundN "viikate" (k9 "kala")) ; --UNCHK
lin oarsman_N = mkWN (k10 "soutaja") ; --UNCHK
lin oarsmanship_N = mkWN (compoundN "soutu" (k1A "taito")) ; --UNCHK
lin oarswoman_N = mkWN (k10 "soutaja") ; --UNCHK
lin oasis_N = mkWN (compoundN "turva" (k9A "paikka")) ; --UNCHK
lin oast_N = mkWN (compoundN "kuivatus" (k5 "uuni")) ; --UNCHK
lin oat_N = mkWN (k9 "kaura") ;
lin oatcake_N = mkWN (compoundN "kaura" (k1A "kakku")) ; --UNCHK
lin oaten_A = mkWA (compoundA "kaura" (k38 "inen")) ; --UNCHK
lin oath_N = mkWN (k9 "vala") ; --UNCHK
lin oban_PN = foreignPN "Oban" ;
lin obbligato_N = mkWN "obligato" ; --UNCHK
lin obduracy_N = mkWN (k40 "taipumattomuus") ; --UNCHK
lin obdurate_A = mkWA (k47 "paatunut") ; --UNCHK
lin obeah_N = mkWN "obi" ; --UNCHK
lin obeche_N = mkWN (k9 "samba") ; --UNCHK
lin obedience_N = mkWN (k39 "kunnioitus") ; --UNCHK
lin obedient_A = mkWA (k38 "tottelevainen") ; --UNCHK
lin obeisance_N = mkWN (k40 "nöyryys") ; --UNCHK
lin obelion_N = mkWN "obelion" ; --UNCHK
lin obelisk_N = mkWN (k5 "obeliski") ; --UNCHK
lin oberhausen_PN = foreignPN "Oberhausen" ;
lin obese_A = mkWA (k15 "pullea") ; --UNCHK
lin obesity_N = mkWN (k40 "pyylevyys") ; --UNCHK
lin obey_V = mkWV (k67A "totella") ; --UNCHK
lin obey_V2 = mkWV2 (k67A "totella") ; --UNCHK
lin obfuscate_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin obfuscation_N = mkWN (k39 "pimennys") ; --UNCHK
lin obi_N = mkWN "obi" ; --UNCHK
lin obiism_N = mkWN "obilaisuus" ; --UNCHK
lin obiter_dictum_N = mkWN "dictum" ; --UNCHK
lin obituary_N = mkWN (k5 "nekrologi") ; --UNCHK
lin object_N = mkN "objekti" | mkN "esine" ;
lin object_V = mkWV (k62 "protestoida") ;
lin object_V2 = mkWV2 (k62 "protestoida") ; --UNCHK
lin objectification_N = mkWN (compoundN "havainnollis" (k38 "taminen")) ; --UNCHK
lin objection_N = mkWN (compoundN "vasta" (k48 "lause")) ; --UNCHK
lin objectionable_A = mkWA (compoundA "kiistan" (k38 "alainen")) ; --UNCHK
lin objective_A = mkWA (k34A "puolueeton") ; --UNCHK
lin objective_N = mkN "tavoite" ; ---ARB mkWN (k5 "linssi") "objektiivin" ;
lin objectivity_N = mkWN (k40 "puolueettomuus") ; --UNCHK
lin objector_N = mkWN (k5A "dissidentti") ; --UNCHK
lin objurgate_V2 = mkWV2 (k54A "ojentaa") ; --UNCHK
lin objurgation_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin oblanceolate_A = mkWA (compoundA "vasta" (k15 "suikea")) ; --UNCHK
lin oblate_A = mkWA (compoundA "kurpitsan" (k38 "muotoinen")) ; --UNCHK
lin oblate_N = mkWN (compoundN "pyh" (k1 "itetty")) ; --UNCHK
lin oblateness_N = mkWN (k40 "elliptisyys") ; --UNCHK
lin oblation_N = mkWN (k38 "ehtoollinen") ; --UNCHK
lin obligate_A = mkWA (k34A "ehdoton") ; --UNCHK
lin obligate_V2 = mkWV2 (k53A "pitää") "voimassa" ; --UNCHK
lin obligate_V2V = mkWV2V (k53A "pitää") "voimassa" ; --UNCHK
lin obligation_N = mkWN (k17 "vastuu") ; --f73
lin obligational_A = mkWA "velvoittava" ; --UNCHK
lin obligatory_A = mkWA (k38 "pakollinen") ; --UNCHK
lin oblige_V2 = mkWV2 (k53A "pitää") "voimassa" ; --UNCHK
lin oblige_V2V = mkWV2V (k53A "pitää") "voimassa" ; --UNCHK
lin obliger_N = mkWN "velvoittautuja" ; --UNCHK
lin obliging_A = mkWA (k38 "ystävällinen") ; --UNCHK
lin oblique_A = mkWA (k1 "vino") ; --UNCHK
lin oblique_N = mkWN (compoundN "vatsa" (k39 "lihas")) "vino" ; --UNCHK
lin obliqueness_N = mkWN (k2 "kiertely") ; --UNCHK
lin obliquity_N = mkWN (k40 "kieroutuneisuus") ; --UNCHK
lin obliterable_A = mkWA (k10 "oleva") "hävitettävissä" ; --UNCHK
lin obliterate_V2 = mkWV2 (k61A "pyyhkiä") "pois" ; --UNCHK
lin obliteration_N = mkWN (k39 "hävitys") ; --UNCHK
lin obliterator_N = mkWN (k10 "tuhoaja") ; --UNCHK
lin oblivion_N = mkWN (k39 "unohdus") ; --UNCHK
lin oblivious_A = mkWA (k38 "unohtavainen") ; --UNCHK
lin obliviousness_N = mkWN (k39 "unohdus") ; --UNCHK
lin oblong_A = mkWA (k15 "soikea") ; --UNCHK
lin oblong_N = mkWN (k3 "soikio") ; --UNCHK
lin obloquy_N = mkWN (k2 "häpäisy") ; --UNCHK
lin obnoxious_A = mkWA (k34A "sietämätön") ; --UNCHK
lin obnoxiousness_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin oboe_N = mkWN (k3 "oboe") ; --UNCHK
lin oboist_N = mkWN (k5 "oboisti") ; --UNCHK
lin obolus_N = mkWN "oboli" ; --UNCHK
lin obovate_A = mkWA (compoundA "vasta" (k15 "puikea")) ; --UNCHK
lin obscene_A = mkWA (k34A "moraaliton") ; --UNCHK
lin obscenity_N = mkWN (k40 "säädyttömyys") ; --UNCHK
lin obscurantist_N = mkWN (k38 "vihollinen") "valistuksen" ; --UNCHK
lin obscure_A = mkWA (k10 "hämärä") ; --UNCHK
lin obscure_V2 = mkWV2 (k54A "pimentää") ; --UNCHK
lin obscureness_N = mkWN (compoundN "vaikea" (k40 "tajuisuus")) ; --UNCHK
lin obscurity_N = mkWN (compoundN "vaikea" (k40 "tajuisuus")) ; --UNCHK
lin obsequious_A = mkWA (k38 "tottelevainen") ; --UNCHK
lin obsequiousness_N = mkWN (k40 "nöyryys") ; --UNCHK
lin observable_A = mkWA (kH1 "ilmeinen") ; --UNCHK
lin observance_N = mkWN (k2 "tarkkailu") ; --UNCHK
lin observant_A = mkWA (k38 "tarkkaavainen") ; --UNCHK
lin observation_N = mkWN (k2 "tarkkailu") ; --UNCHK
lin observatory_N = mkWN (k3 "observatorio") ; --UNCHK
lin observe_V2 = mkV2 "tarkkailla" partitive ; --mkWV2 (k53A "säilyttää") ;
lin observe_VS = mkWVS (k53A "säilyttää") ; --UNCHK
lin observer_N = mkN "tarkkailija" ;
lin obsess_V2 = mkWV2 (k52A "näyttäytyä") "kummituksena" ; --UNCHK
lin obsession_N = mkWN (k40 "riippuvuus") ; --UNCHK
lin obsessive_N = mkWN (k2 "henkilö") "pakkomielteinen" ; --UNCHK
lin obsessiveness_N = mkWN (compoundN "pakkomielte" (k40 "isyys")) ; --UNCHK
lin obsidian_N = mkWN (compoundN "laava" (k5 "lasi")) ; --UNCHK
lin obsolescence_N = mkWN "vanhentuminen" ; --UNCHK
lin obsolescent_A = mkWA (k10 "oleva") "vanhentumassa" ; --UNCHK
lin obsolete_A = mkWA (compoundA "pois" (k1 "tettu")) "käytöstä" ; --UNCHK
lin obsoleteness_N = mkWN (k1 "pano") "eläkkeelle" ; --UNCHK
lin obstacle_N = mkWN (k48 "este") ; --UNCHK
lin obstetric_A = mkWA (compoundA "synnytys" (k38 "opillinen")) ; --UNCHK
lin obstetrical_A = mkWA (compoundA "synnytys" (k38 "opillinen")) ; --UNCHK
lin obstetrician_N = mkWN (compoundN "synnytys" (k6 "lääkäri")) ; --UNCHK
lin obstetrics_N = mkWN (compoundN "synnytys" (k5A "oppi")) ; --UNCHK
lin obstinacy_N = mkWN (k40 "omapäisyys") ; --UNCHK
lin obstinate_A = mkWA (compoundA "itse" (k38 "päinen")) ; --UNCHK
lin obstipation_N = mkWN (k39 "ummetus") ; --UNCHK
lin obstreperous_A = mkWA "rettelöivä" ; --UNCHK
lin obstreperousness_N = mkWN (k40 "kurittomuus") ; --UNCHK
lin obstruct_V2 = mkWV2 (k53 "estää") ; --UNCHK
lin obstruction_N = mkWN "estäminen" ; --UNCHK
lin obstructionism_N = mkWN (compoundN "jarrutus" (k9A "politiikka")) ; --UNCHK
lin obstructionist_N = mkWN (k10 "vastustaja") ; --UNCHK
lin obstructive_A = mkWA (compoundA "tuk" (k9 "kiva")) ; --UNCHK
lin obstruent_N = mkWN "obstruentti" ; --UNCHK
lin obtain_V = mkWV (k61A "hankkia") ;
lin obtain_V2 = mkWV2 (k61A "hankkia") ;
lin obtainable_A = mkWA (k10 "oleva") "hankittavissa" ; --UNCHK
lin obtainment_N = mkWN (k5A "saanti") ; --UNCHK
lin obtrude_V = mkWV (k52A "tunkeutua") ; --UNCHK
lin obtrude_V2 = mkWV2 (k52A "tunkeutua") ; --UNCHK
lin obtrusive_A = mkWA (k10 "huomattava") ; --UNCHK
lin obtrusiveness_N = mkWN (k40 "silmiinpistävyys") ; --UNCHK
lin obturator_N = mkWN (compoundN "sulku" (k6 "proteesi")) ; --UNCHK
lin obtuse_A = mkWA (k10A "tylppä") ; --UNCHK
lin obtuseness_N = mkWN (k40 "tylsyys") ; --UNCHK
lin obverse_N = mkWN (compoundN "kuva" (k26 "puoli")) ; --UNCHK
lin obviate_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin obviation_N = mkWN (k2 "ehkäisy") ; --UNCHK
lin obvious_A = mkWA (kH1 "ilmeinen") ;
lin obviousness_N = mkWN (k40 "havaittavuus") ; --UNCHK
lin oca_N = mkWN (compoundN "ketun" (k10A "leipä")) ; --UNCHK
lin ocarina_N = mkWN (k9 "okariina") ; --UNCHK
lin occasion_N = mkWN (k39 "tapaus") ;
lin occasion_V2 = mkWV2 (k53A "aiheuttaa") ; --UNCHK
lin occasional_A = mkWA (k38 "ajoittainen") ; --UNCHK
lin occidental_A = mkWA (k38 "läntinen") ; --UNCHK
lin occidental_N = mkWN "Occidental" ; --UNCHK
lin occidentalism_N = mkWN (k40 "länsimaisuus") ; --UNCHK
lin occipital_A = mkWA "takaraivo-" ; --UNCHK
lin occiput_N = mkWN (compoundN "taka" (k1 "raivo")) ; --UNCHK
lin occluded_A = mkWA (compoundA "absorbo" (k1A "itu")) ; --UNCHK
lin occlusion_N = mkWN (k10 "tukkeutuma") ; --UNCHK
lin occlusive_A = mkWA (compoundA "tuk" (k9 "kiva")) ; --UNCHK
lin occult_A = mkWA (k38 "okkulttinen") ; --UNCHK
lin occult_N = mkWN (k5 "okkultismi") ; --UNCHK
lin occultism_N = mkWN (k5 "okkultismi") ; --UNCHK
lin occultist_N = mkWN (k5 "okkultisti") ; --UNCHK
lin occupancy_N = mkWN (k1A "muutto") ; --UNCHK
lin occupant_N = mkWN (k12 "haltija") ; --UNCHK
lin occupation_N = mkN "ammatti" ; ---ARB --mkN "miehitys" ; --mkN "haltuunotto" ; --mkWN (k1A "muutto") ;
lin occupational_A = mkWA "ammatti-" ; --UNCHK
lin occupier_N = mkWN (k10 "miehittäjä") ; --UNCHK
lin occupy_V = mkV "vallata" ;
lin occupy_V2 = mkV2 "vallata" ;
lin occur_V = mkV "käydä" ;
lin occur_to_V2 = prepV2 OP_occur_V OP_to_Prep ; -- guess-p-verb
lin occurr_V2 = mkV2 "tapahtua" ;
lin occurrence_N = mkWN (k39 "tapaus") ; --UNCHK
lin occurrent_A = mkWA "esiintyvä" ; --UNCHK
lin ocean_N = mkWN (compoundN "valta" (k24 "meri")) ; --UNCHK
lin oceanfront_N = mkWN (k4A "rannikko") ; --UNCHK
lin oceangoing_A = mkWA "valtameri-" ; --UNCHK
lin oceanic_A = mkWA "avomeri-" ; --UNCHK
lin oceanographer_N = mkWN (compoundN "valtameren" (k12 "tutkija")) ; --UNCHK
lin oceanography_N = mkWN (k12 "oseanologia") ; --UNCHK
lin ocellated_A = mkWA "pistesilmä-" ; --UNCHK
lin ocelot_N = mkWN (k5A "oselotti") ; --UNCHK
lin ocher_A = mkWA (kH1 "okra") ; --UNCHK
lin ocher_N = mkWN (kH1 "okra") ; --UNCHK
lin ochre_N = mkWN (kH1 "okra") ; --UNCHK
lin ochronosis_N = mkWN "okronoosi" ; --UNCHK
lin ocotillo_N = mkWN "Fouquieria" "splendens" ; --UNCHK
lin octagon_N = mkWN "kahdeksankulmio" ; --UNCHK
lin octagonal_A = mkWA (compoundA "kahdeksankul" (k38 "mainen")) ; --UNCHK
lin octahedron_N = mkWN (k5 "oktaedri") ; --UNCHK
lin octal_A = mkWA "oktaali-" ; --UNCHK
lin octameter_N = mkWN (compoundN "okta" (k5 "metri")) ; --UNCHK
lin octane_N = mkWN (k5 "oktaani") ; --UNCHK
lin octangular_A = mkWA (compoundA "kahdeksankul" (k38 "mainen")) ; --UNCHK
lin octant_N = mkWN "oktantti" ; --UNCHK
lin octave_N = mkWN (k2 "säkeistö") "kahdeksan" "säkeen" ; --UNCHK
lin octet_N = mkWN (k1A "oktetto") ; --UNCHK
lin octette_N = mkWN (k1A "oktetto") ; --UNCHK
lin octillion_N = mkWN "oktiljoona" ; --UNCHK
lin octogenarian_A = mkWA "kahdeksankymmenvuotias" ; --UNCHK
lin octogenarian_N = mkWN (compoundN "kahdeksan" (k38 "kymppinen")) ; --UNCHK
lin octopod_N = mkWN (compoundN "kahdeksan" (k38 "lonkeroinen")) ; --UNCHK
lin octopus_N = mkWN (compoundN "muste" (k9 "kala")) ; --UNCHK
lin octoroon_N = mkWN (compoundN "kahdeksasosa" (k6 "neekeri")) ; --UNCHK
lin octosyllabic_A = mkWA (compoundA "kahdeksan" (k38 "tavuinen")) ; --UNCHK
lin octosyllable_N = mkWN (k48A "säe") "kahdeksantavuinen" ; --UNCHK
lin octroi_N = mkWN (k5 "tulli") ; --UNCHK
lin octuple_A = mkWA (compoundA "kahdeksan" (k38 "kertainen")) ; --UNCHK
lin oculism_N = mkWN (compoundN "silmä" (k14A "optiikka")) ; --UNCHK
lin oculist_N = mkWN (compoundN "silmä" (k6 "lääkäri")) ; --UNCHK
lin oculomotor_N = mkWN (compoundN "aivo" (k1 "hermo")) "kolmas" ; --UNCHK
lin odalisque_N = mkWN "odaliski" ; --UNCHK
lin odd_1_A = mkWA (k34A "pariton") ; --UNCHK
lin odd_2_A = mkWA (k34A "pariton") ; --UNCHK
lin oddish_A = mkWA (k38 "omituinen") "aika" ; --UNCHK
lin oddity_N = mkWN (k40 "erikoisuus") ; --UNCHK
lin oddment_N = mkWN (k40 "erikoisuus") ; --UNCHK
lin oddness_N = mkWN (k40 "merkillisyys") ; --UNCHK
lin odds_N = mkWN (compoundN "toden" (k40 "näköisyys")) ; --UNCHK
lin odds_on_A = mkA "todennäköinen" ;
lin ode_N = mkWN (k5 "oodi") ; --UNCHK
lin odessa_PN = foreignPN "Odessa" ;
lin odious_A = mkWA (k15 "kauhea") ; --UNCHK
lin odist_N = mkWN (k12 "runoilija") ; --UNCHK
lin odium_N = mkWN (k39 "iljetys") ; --UNCHK
lin odometer_N = mkWN (compoundN "matka" (k6 "mittari")) ; --UNCHK
lin odonate_N = mkWN (compoundN "suden" (k1A "korento")) ; --UNCHK
lin odontoglossum_N = mkWN (compoundN "tiikeri" (k14A "kämmekkä")) ; --UNCHK
lin odoriferous_A = mkWA (compoundA "hyvän" (k38 "tuoksuinen")) ; --UNCHK
lin odorless_A = mkWA (k34A "tuoksuton") ; --UNCHK
lin odorous_A = mkWA "tuoksuva" ; --UNCHK
lin odour_N = mkWN (k1 "tuoksu") ; --UNCHK
lin odourless_A = mkWA (k34A "tuoksuton") ; --UNCHK
lin odynophagia_N = mkWN (compoundN "nielemis" (k1A "kipu")) ; --UNCHK
lin odyssey_N = mkWN (k2 "seikkailu") ; --UNCHK
lin oecumenical_A = mkWA (k5 "universaali") ; --UNCHK
lin oed_N = mkWN "OED" ; --UNCHK
lin oenomel_N = mkWN (k5 "hunajaviini") ; --UNCHK
lin oesophagus_N = mkWN (k1 "nielu") ; --UNCHK
lin oeuvre_N = mkWN (k39 "teos") ; --UNCHK
lin of_Prep = casePrep genitive ; ---
lin of_course_Adv = mkAdv "tietenkin" ;
lin off_A = mkWA (k99 "pois") ; --UNCHK
lin off_Adv = mkAdv "pois" ;
lin off_Prep = mkPrep "ulkopuolella" ;
lin offbeat_A = mkWA (k1A "outo") ; --UNCHK
lin offenbach_PN = foreignPN "Offenbach" ;
lin offence_N = mkWN (k39 "rikos") ; --UNCHK
lin offenceless_A = mkWA (compoundA "hyökkäys" (k34A "kyvytön")) ; --UNCHK
lin offend_V = mkWV (k73A "loukata") ; --UNCHK
lin offend_V2 = mkV2 "loukata" partitive ;
lin offenderFem_N = mkWN (k38 "rikollinen") ;
lin offenderMasc_N = mkN "loukkaaja" ;
lin offensive_A = mkWA (k10 "loukkaava") ;
lin offensive_N = mkN "hyökkäys" ; --mkWN (k5 "offensiivi") ;
lin offensiveness_N = mkWN (k40 "inhottavuus") ; --UNCHK
lin offer_N = mkN "tarjous" ;
lin offer_V2 = mkV2 (mkV "tarjota") ;
lin offer_VV = mkVV "tarjoutua" infIllat ;
lin offer_up_V = mkWV (k67 "rukoilla") ; --UNCHK
lin offerer_N = mkWN (k10 "esittäjä") ; --UNCHK
lin offering_N = mkN "tarjous" ;
lin offertory_N = mkWN (compoundN "offer" (k5 "torium")) ; --UNCHK
lin offhand_A = mkWA (k34A "huoleton") ; --UNCHK
lin offhand_Adv = mkWAdv (k99 "välinpitämättömästi") ; --UNCHK
lin offhanded_A = mkWA (k34A "huoleton") ; --UNCHK
lin offhanded_Adv = mkWAdv (k99 "välinpitämättömästi") ; --UNCHK
lin office_N = mkN "toimisto" ;
lin office_block_N = mkWN (compoundN "toimi" (k1 "talo")) ; --UNCHK
lin office_boy_N = mkWN (compoundN "lähetti" (k10A "poika")) ; --UNCHK
lin office_holder_N = mkWN (compoundN "virka" (k42 "mies")) ; --UNCHK
lin officer_1_N = mkN "vastaava" ;
lin officer_2_N = mkN "upseeri" ;
lin officer_3_N = mkN "poliisi" ;
lin officer_N = mkN "vastaava" ; --- already split
lin officialFem_N = variants {} ; ---- sense to be split
lin officialMasc_N = mkN "virkailija" ;
lin official_A = mkWA (k38 "virallinen") ; --f107
lin officialdom_N = mkWN (compoundN "virka" (k2 "koneisto")) ; --UNCHK
lin officialese_N = mkWN (compoundN "virasto" (k26 "kieli")) ; --UNCHK
lin officiant_N = mkWN "offisiantti" ; --UNCHK
lin officiate_V = mkWV (k61 "toimia") ; --UNCHK
lin officiation_N = mkWN (k39 "toimitus") ; --UNCHK
lin officious_A = mkWA (k10 "tungetteleva") ; --UNCHK
lin officiousness_N = mkWN (k40 "tungettelevuus") ; --UNCHK
lin offing_N = mkWN (k14A "ulappa") ; --UNCHK
lin offish_A = mkWA (k38 "etäinen") ; --UNCHK
lin offprint_N = mkWN (compoundN "eri" (k39 "painos")) ; --UNCHK
lin offset_N = mkWN (k48A "haarake") ; --UNCHK
lin offset_V2 = mkWV2 (k56 "painaa") "offsetilla" ; --f118
lin offshoot_N = mkWN (k48A "haarake") ; --UNCHK
lin offshore_A = mkWA "mereltä" "puhaltava" ; --UNCHK
lin offshore_Adv = mkWAdv (compoundAdv "ran" (k9 "nasta")) ; --UNCHK
lin offside_A = mkWA (k10 "oleva") "paitsiossa" ; --UNCHK
lin offside_Adv = mkWAdv "paitsiossa" ; --UNCHK
lin offside_N = mkWN (k3 "paitsio") ; --UNCHK
lin offspring_N = mkWN (k38 "jälkeläinen") ; --UNCHK
lin offstage_A = mkWA (k38 "takainen") "kulissien" ; --UNCHK
lin offstage_Adv = mkWAdv (k99 "takana") "kulissien" ; --UNCHK
lin oft_Adv = mkWAdv (k99 "monesti") ; --UNCHK
lin often_AdA = mkAdA "usein" ;
lin often_AdV = mkAdV "usein" ;
lin often_Adv = mkAdv "usein" ;
lin oftener_Adv = mkWAdv "useammin" ; --UNCHK
lin ogee_N = mkWN (compoundN "kar" (k27 "niisi")) ; --UNCHK
lin ogle_V = mkWV (k53A "tuijottaa") ; --UNCHK
lin ogle_V2 = mkWV2 (k53A "tuijottaa") ; --UNCHK
lin ogler_N = mkWN (k12 "töllistelijä") ; --UNCHK
lin ogre_N = mkWN (k38 "jättiläinen") ; --UNCHK
lin ogress_N = mkWN (k32A "syöjätär") ; --UNCHK
lin oh_Interj = mkInterj "oi" ;
lin ohio_PN = mkPN "Ohio" ;
lin ohmage_N = mkWN (k39 "vastus") "ohminen" ; --UNCHK
lin ohmic_A = mkWA (compoundA "ohmi" (k38 "nen")) ; --UNCHK
lin ohmmeter_N = mkWN (compoundN "vastus" (k6 "mittari")) ; --UNCHK
lin oil_N = L.oil_N ;
lin oil_V2 = mkWV2 (k67A "voidella") "linimentillä" ; --UNCHK
lin oil_burner_N = mkWN (compoundN "öljy" (k33A "poltin")) ; --UNCHK
lin oil_cake_N = mkWN (compoundN "öljy" (k1A "kakku")) ; --UNCHK
lin oil_painting_N = mkWN (k39 "öljymaalaus") ; --UNCHK
lin oil_palm_N = mkWN (compoundN "öljy" (k1 "palmu")) ; --UNCHK
lin oil_rig_N = mkWN (compoundN "öljynporaus" (k9A "lautta")) ; --UNCHK
lin oil_slick_N = mkWN (compoundN "öljy" (k9A "lautta")) ; --UNCHK
lin oil_tanker_N = mkWN (k6 "tankkeri") ; --UNCHK
lin oil_well_N = mkWN (compoundN "öljy" (k48A "lähde")) ; --UNCHK
lin oilbird_N = mkWN (compoundN "rasva" (k1A "lintu")) ; --UNCHK
lin oilcan_N = mkWN (compoundN "öljy" (k1 "kannu")) ; --UNCHK
lin oilcloth_N = mkWN (k41A "vahakangas") ; --UNCHK
lin oiler_N = mkWN (k6 "tankkeri") ; --UNCHK
lin oilfield_N = mkWN (compoundN "öljy" (k10A "kenttä")) ; --UNCHK
lin oilfish_N = mkWN (compoundN "käärme" (k5 "makrilli")) ; --UNCHK
lin oiliness_N = mkWN (k40 "lipevyys") ; --UNCHK
lin oilman_N = mkWN "öljytyöntekijä" ; --UNCHK
lin oil_paper_N = mkWN (compoundN "öljy" (k6 "paperi")) ; --UNCHK
lin oilseed_N = mkWN (k32 "siemen") "öljypitoinen" ; --UNCHK
lin oilskin_N = mkWN (compoundN "öljykangas" (k5A "takki")) ; --UNCHK
lin oilstone_N = mkWN (compoundN "öljy" (k7 "kivi")) ; --UNCHK
lin oily_A = mkWA (k38 "öljyinen") ; --UNCHK
lin ointment_N = mkWN (k48A "voide") ; --UNCHK
lin oitti_PN = mkPN "Oitti" ;
lin ok_Interj = mkInterj "okei" ;
lin oka_N = mkWN (compoundN "ketun" (k10A "leipä")) ; --UNCHK
lin okapi_N = mkWN "Okapia" "johnstoni" ; --UNCHK
lin okay_A = mkA "kelvollinen" ;
lin okay_Adv = mkAdv "hyvin" | mkAdv "ihan hyvin" | mkWAdv (k99 "mukavasti") ;
lin okay_Interj = mkInterj "okei" ;
lin okay_N = mkWN (k39 "suostumus") ; --UNCHK
lin okay_V2 = mkWV2 (k56A "antaa") "suostumus" ; --UNCHK
lin oklahoma_PN = mkPN "Oklahoma" ;
lin okra_N = mkWN (kH1 "okra") ; --UNCHK
lin old_A = L.old_A ;
lin old_N = mkWN (k38 "entinen") ; --UNCHK
lin old_fashioned_A = mkA "vanhanaikainen" ;
lin old_time_A = mkA "vanhanaikainen" ;
lin olden_A = mkWA (k38 "entinen") ; --UNCHK
lin oldenburg_PN = foreignPN "Oldenburg" ;
lin oldham_PN = foreignPN "Oldham" ;
lin oldie_N = mkWN (k48 "kappale") "vanha" ; --UNCHK
lin oldish_A = mkWA "vanhahko" ; --UNCHK
lin oldline_A = mkWA (k38 "konservatiivinen") ; --UNCHK
lin oldness_N = mkWN (k40 "vanhuus") ; --UNCHK
lin oldster_N = mkWN (k38 "ihminen") "vanhempi" ; --UNCHK
lin oleaceous_A = mkWA "oliivi-" ; --UNCHK
lin oleaginous_A = mkWA (k38 "öljyinen") ; --UNCHK
lin oleander_N = mkWN (k6 "oleanteri") ; --UNCHK
lin oleaster_N = mkWN (compoundN "hopea" (k41 "pensas")) ; --UNCHK
lin olecranon_N = mkWN (compoundN "kyynär" (k48A "lisäke")) ; --UNCHK
lin oleophilic_A = mkWA (compoundA "öljy" (k38 "hakuinen")) ; --UNCHK
lin oleophobic_A = mkWA (compoundA "öljy" (k38 "pakoinen")) ; --UNCHK
lin oleoresin_N = mkWN (k9 "pihka") ; --UNCHK
lin olfactory_A = mkWA "haju-" ; --UNCHK
lin oligarch_N = mkWN (k5A "oligarkki") ; --UNCHK
lin oligarchic_A = mkWA (k38 "oligarkkinen") ; --UNCHK
lin oligarchy_N = mkWN (k12 "oligarkia") ; --UNCHK
lin oligochaete_N = mkWN (compoundN "harvasukas" (k1A "mato")) ; --UNCHK
lin oligodactyly_N = mkWN "oligodaktylia" ; --UNCHK
lin oligodendrocyte_N = mkWN "oligodendrosyytti" ; --UNCHK
lin oligodendroglia_N = mkWN "oligodendroglia" ; --UNCHK
lin oligodontia_N = mkWN "oligodontia" ; --UNCHK
lin oligomenorrhea_N = mkWN "oligomenorrea" ; --UNCHK
lin oligopoly_N = mkWN (k5 "oligopoli") ; --UNCHK
lin oligosaccharide_N = mkWN (compoundN "oligo" (k5 "sakkaridi")) ; --UNCHK
lin oligospermia_N = mkWN "oligospermia" ; --UNCHK
lin oliguria_N = mkWN "oliguria" ; --UNCHK
lin olive_A = mkWA (compoundA "oliivin" (k15 "vihreä")) ; --UNCHK
lin olive_N = mkWN (compoundN "oliivin" (k15 "vihreä")) ; --UNCHK
lin olive_tree_N = mkWN (compoundN "oliivi" (k18 "puu")) ; --UNCHK
lin olivelike_A = mkWA (compoundA "oliivin" (k38 "kaltainen")) ; --UNCHK
lin olivenite_N = mkWN (compoundN "olivi" (k5A "niitti")) ; --UNCHK
lin oliver_PN = foreignPN "Oliver" ;
lin olivia_PN = foreignPN "Olivia" ;
lin olivine_N = mkWN (k5 "oliviini") ; --UNCHK
lin olm_N = mkWN (k5 "olmi") ; --UNCHK
lin ology_N = mkWN "logia" ; --UNCHK
lin olympian_N = mkWN (k10 "jumala") "olympolainen" ; --UNCHK
lin olympic_A = mkWA "olympia-" ; --UNCHK
lin oman_PN = foreignPN "Oman" ;
lin omani_A = mkWA (compoundA "omani" (k38 "lainen")) ; --UNCHK
lin omani_N = mkWN (compoundN "omani" (k38 "lainen")) ; --UNCHK
lin ombu_N = mkWN "Phytolacca" "dioica" ; --UNCHK
lin ombudsman_N = mkWN (compoundN "oikeusasia" (k42 "mies")) ; --UNCHK
lin omega_N = mkWN (k13 "oomega") ; --UNCHK
lin omelet_N = mkWN (k5A "omeletti") ; --UNCHK
lin omelette_N = mkWN (k5A "omeletti") ; --UNCHK
lin omen_N = mkWN (k39 "ennustus") ; --UNCHK
lin omen_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin omentum_N = mkWN (compoundN "vatsa" (k9A "paita")) ; --UNCHK
lin omeprazole_N = mkWN "Prilosec" ; --UNCHK
lin omerta_N = mkWN "omertà" ; --UNCHK
lin omicron_N = mkWN "omikron" ; --UNCHK
lin ominous_A = mkWA (k10 "uhkaava") ; --UNCHK
lin omissible_A = mkWA "poisjätettävä" ; --UNCHK
lin omission_N = mkWN "väliin" "jättäminen" ; --UNCHK
lin omissive_A = mkWA "laiminlyönti-" ; --UNCHK
lin omit_V2 = mkV2 (mkV (mkV "jättää") "pois") ;
lin ommastrephes_N = mkWN (k6 "kalmari") ; --UNCHK
lin ommatidium_N = mkWN "ommatidi" ; --UNCHK
lin omnibus_N = mkWN (k5 "bussi") ; --UNCHK
lin omnidirectional_A = mkWA "suuntaamaton" ; --UNCHK
lin omnifarious_A = mkWA (compoundA "monen" (k10 "kirjava")) ; --UNCHK
lin omnipotence_N = mkWN (compoundN "kaikki" (k40 "valtius")) ; --UNCHK
lin omnipotent_A = mkWA (compoundA "kaikki" (k41 "valtias")) ; --UNCHK
lin omnipresent_A = mkWA (k10 "oleva") "kaikkialla" ; --UNCHK
lin omnirange_N = mkWN (compoundN "radio" (k14A "majakka")) "suuntaamaton" ; --UNCHK
lin omniscience_N = mkWN (compoundN "kaikki" (k40 "tietävyys")) ; --UNCHK
lin omniscient_A = mkWA (compoundA "kaikki" (k10 "tietävä")) ; --UNCHK
lin omnivore_N = mkWN (k33 "eläin") "kaikkiruokainen" ; --UNCHK
lin omnivorous_A = mkWA (compoundA "kaikkiru" (k38 "okainen")) ; --UNCHK
lin omophagia_N = mkWN "omofagia" ; --UNCHK
lin omsk_PN = foreignPN "Omsk" ;
lin on_Adv = mkAdv "päällä" ;
lin on_Prep = mkPrep adessive | mkPrep "päällä" | mkPrep "päälle" ;
lin on_behalf_of_Prep = mkPrep "puolesta" ;
lin on_top_of_Prep = mkPrep "päälle" ;
lin once_AdV = lin AdV (ss "kerran") ;
lin once_Adv = mkAdv "kerran" ;
lin once_Prep = mkPrep "kerran" nominative ;
lin once_Subj = mkSubj "sitten kun" ;
lin onchocerciasis_N = mkWN (compoundN "joki" (k40 "sokeus")) ; --UNCHK
lin oncidium_N = mkWN (compoundN "kelta" (k5A "lehdokki")) ; --UNCHK
lin oncogene_N = mkWN (k5 "geeni") "viruksen" ; --UNCHK
lin oncological_A = mkWA "onkologinen" ; --UNCHK
lin oncology_N = mkWN (k12 "onkologia") ; --UNCHK
lin oncoming_A = mkWA "lähestyvä" ; --UNCHK
lin oncoming_N = mkWN (k1 "tulo") ; --UNCHK
lin one_sided_A = mkA (mkN "yksi" (mkN "puolinen")) ;
lin one_time_A = mkA "ainutkertainen" ;
lin oneiric_A = mkWA "uni-" ; --UNCHK
lin oneiromancer_N = mkWN (k10 "ennustaja") "unista" ; --UNCHK
lin oneiromancy_N = mkWN "unien" "selittäminen" ; --UNCHK
lin oneness_N = mkWN (k40 "ykseys") ; --UNCHK
lin onerous_A = mkWA (k10 "vaativa") ;
lin ongoing_A = mkWA (k10 "oleva") "käynnissä" ; --UNCHK
lin onion_N = mkWN (k6 "sipuli") ; --UNCHK
lin online_A = mkA "kytketty" ;
lin onlooker_N = mkWN (k10 "katsoja") ; --UNCHK
lin only_Adv = mkAdv "vain" ;
lin only_Predet = S.only_Predet ;
lin onomancer_N = mkWN (k10 "ennustaja") "nimestä" ; --UNCHK
lin onomancy_N = mkWN "nimestä" "ennustaminen" ; --UNCHK
lin onomastic_A = mkWA "onomastinen" ; --UNCHK
lin onomasticon_N = mkWN "onomasticon" ; --UNCHK
lin onomastics_N = mkWN (compoundN "nimistön" (k39 "tutkimus")) ; --UNCHK
lin onomatomania_N = mkWN (compoundN "onomato" (k12 "mania")) ; --UNCHK
lin onomatopoeia_N = mkWN (compoundN "atk" (k38 "iminen")) "luonnonäänten" ; --UNCHK
lin onomatopoeic_A = mkWA (k38 "onomatopoeettinen") ; --UNCHK
lin onrush_N = mkWN (k39 "hyökkäys") ; --UNCHK
lin onset_N = mkWN (k39 "hyökkäys") ; --UNCHK
lin onshore_A = mkWA (compoundA "rannan" (k38 "puoleinen")) ; --UNCHK
lin onshore_Adv = mkWAdv (compoundAdv "rann" (k99 "alla")) ; --UNCHK
lin onslaught_N = mkWN (k39 "hyökkäys") ; --UNCHK
lin onstage_A = mkWA "lavalla" "tapahtuva" ; --UNCHK
lin onstage_Adv = mkWAdv (compoundAdv "lav" (k99 "alla")) ; --UNCHK
lin ontario_PN = foreignPN "Ontario" ;
lin onto_Prep = mkPrep "päälle" | mkPrep allative ;
lin ontogenetic_A = mkWA (compoundA "onto" (k38 "geneettinen")) ; --UNCHK
lin ontological_A = mkWA "ontologinen" ; --UNCHK
lin ontology_N = mkWN "ontologia" ; --UNCHK
lin onus_N = mkWN (k17 "vastuu") ; --UNCHK
lin onward_A = mkA "jatkuva" ;
lin onward_Adv = mkWAdv (k99 "edelleen") ; --UNCHK
lin onwards_Adv = mkWAdv (k99 "edelleen") ; --UNCHK
lin onycholysis_N = mkWN (compoundN "onykoly" (k5 "ysi")) ; --UNCHK
lin onychophoran_N = mkWN (compoundN "sametti" (k1A "mato")) ; --UNCHK
lin onychosis_N = mkWN (compoundN "kynsi" (k5A "tauti")) ; --UNCHK
lin onymous_A = mkWA (compoundA "varus" (k1 "tettu")) "tekijän" "nimellä" ; --UNCHK
lin onyx_N = mkWN (k5 "onyksi") ; --UNCHK
lin oocyte_N = mkWN "oosyytti" ; --UNCHK
lin oogenesis_N = mkWN "oogeneesi" ; --UNCHK
lin oology_N = mkWN (k39 "tutkimus") "linnunmunien" ; --UNCHK
lin oolong_N = mkWN (compoundN "oolong-" (k18 "tee")) ; --UNCHK
lin oomph_N = mkWN (k1 "tarmo") ; --UNCHK
lin oophorectomy_N = mkWN (compoundN "munasarjan" (k1 "poisto")) ; --UNCHK
lin oophoritis_N = mkWN (compoundN "munasarjan" (k39 "tulehdus")) ; --UNCHK
lin oosphere_N = mkWN (compoundN "muna" (k1 "solu")) ; --UNCHK
lin oospore_N = mkWN (compoundN "muna" (k3 "itiö")) ; --UNCHK
lin ooze_N = mkWN (k1A "vuoto") ; --UNCHK
lin ooze_V = mkWV (k53A "erittää") ; --UNCHK
lin ooze_V2 = mkWV2 (k53A "erittää") ; --UNCHK
lin oozy_A = mkWA (compoundA "tih" (k10 "kuva")) ; --UNCHK
lin op_PN = foreignPN "Op" ;
lin op_art_N = mkWN (compoundN "op-" (k48A "taide")) ; --f71
lin opacification_N = mkWN "samentuminen" ; --UNCHK
lin opacity_N = mkWN (k40 "himmeys") ; --UNCHK
lin opah_N = mkWN (compoundN "kiilto" (k9 "lahna")) ; --UNCHK
lin opal_N = mkWN (k6 "opaali") ; --UNCHK
lin opalescence_N = mkWN (k2 "kimaltelu") ; --UNCHK
lin opalescent_A = mkWA (k10 "kirjava") ; --UNCHK
lin opaque_A = mkWA (k34A "läpikuultamaton") ; --UNCHK
lin opaqueness_N = mkWN (k40 "himmeys") ; --UNCHK
lin open_A = mkA "avoin" ;
lin open_Adv = variants {} ; --
lin open_N = mkWN (k9A "pinta") ; --UNCHK
lin open_V = mkV "aueta" "aukesi" ;
lin open_V2 = L.open_V2 ;
lin open_ended_A = mkA "rajaamaton" ;
lin open_up_V = mkWV (k64 "tuoda") "ilmi" ; --UNCHK
lin open_up_V2 = mkWV2 (k64 "tuoda") "ilmi" ; --UNCHK
lin openbill_N = mkWN (compoundN "rako" (k10A "nokka")) ; --UNCHK
lin opencast_A = mkWA "avolouhos-" ; --UNCHK
lin opener_N = mkWN (k10 "avaaja") ; --UNCHK
lin open_hearted_A = mkWA (compoundA "avo" (k38 "mielinen")) ; --UNCHK
lin opening_A = mkA "avaava" ;
lin opening_N = mkWN (k39 "avaus") ; --f59
lin openness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin openwork_N = mkWN (compoundN "reikä" (k49A "ommel")) ; --UNCHK
lin opepe_N = mkWN "Sarcocephalus" "diderrichii" ; --UNCHK
lin opera_N = mkWN (k12 "ooppera") ; --UNCHK
lin opera_cloak_N = mkWN (k9A "iltaviitta") ; --UNCHK
lin opera_hat_N = mkWN (k6 "silinteri") ; --UNCHK
lin opera_house_N = mkWN (k12 "ooppera") ; --UNCHK
lin operable_A = mkWA (compoundA "leikkaus" (k38 "kelpoinen")) ; --UNCHK
lin operagoer_N = mkWN (k12 "kävijä") "oopperassa" ; --UNCHK
lin operand_N = mkWN "operandi" ; --UNCHK
lin operant_A = mkWA (k10 "vaikuttava") ; --UNCHK
lin operate_V = mkV "operoida" | mkV "toimia" ;
lin operate_V2 = mkWV2 (k62 "operoida") ;
lin operate_on_V2 = mkWV2 (k62 "operoida") ; --UNCHK
lin operatic_A = mkWA "ooppera-" ; --UNCHK
lin operating_N = variants {} ; --
lin operating_table_N = mkWN (compoundN "leikkaus" (k10A "pöytä")) ; --UNCHK
lin operating_theatre_N = mkWN (compoundN "leikkaus" (k5 "sali")) ; --UNCHK
lin operation_N = mkN "operaatio" ;
lin operational_A = mkWA "operaatio-" ; --UNCHK
lin operationalism_N = mkWN (compoundN "ope" (k5 "rationalismi")) ; --UNCHK
lin operationalist_A = mkWA (compoundA "ope" (k38 "rationalistinen")) ; --UNCHK
lin operations_N = mkWN (k9A "toiminta") ; --UNCHK
lin operative_A = mkWA (k10 "oleva") "voimassa" ; --UNCHK
lin operative_N = mkWN (k5A "agentti") ; --UNCHK
lin operator_N = mkN "operaattori" "operaattoreita" ;
lin operculate_A = mkWA "kiduskantinen" ; --UNCHK
lin operculum_N = mkWN (compoundN "kidus" (k28 "kansi")) ; --UNCHK
lin operetta_N = mkWN (k5A "operetti") ; --UNCHK
lin operon_N = mkWN "operoni" ; --UNCHK
lin ophidism_N = mkWN (compoundN "käärmeen" (k10 "purema")) ; --UNCHK
lin ophiolatry_N = mkWN (compoundN "käärmeen" (k9A "palvonta")) ; --UNCHK
lin ophryon_N = mkWN "ophryon" ; --UNCHK
lin ophthalmectomy_N = mkWN (compoundN "silmän" (k1 "poisto")) ; --UNCHK
lin ophthalmia_N = mkWN (compoundN "silmä" (k39 "tulehdus")) ; --UNCHK
lin ophthalmic_A = mkWA "silmä-" ; --UNCHK
lin ophthalmologist_N = mkWN (compoundN "silmä" (k6 "lääkäri")) ; --UNCHK
lin ophthalmology_N = mkWN (compoundN "silmätauti" (k5A "oppi")) ; --UNCHK
lin ophthalmoplegia_N = mkWN (compoundN "silmälihas" (k39 "halvaus")) ; --UNCHK
lin ophthalmoscope_N = mkWN (compoundN "silmän" (k33 "tähystin")) ; --UNCHK
lin ophthalmoscopy_N = mkWN (compoundN "silmän" (k39 "tähystys")) ; --UNCHK
lin opiate_N = mkWN (k5A "opiaatti") ; --UNCHK
lin opine_V2 = mkWV2 (k73 "arvata") ; --UNCHK
lin opine_VS = mkWVS (k73 "arvata") ; --UNCHK
lin opinion_N = mkN "mielipide" ;
lin opinionated_A = mkWA (compoundA "itse" (k38 "tietoinen")) ; --UNCHK
lin opinionative_A = mkWA (compoundA "itse" (k38 "tietoinen")) ; --UNCHK
lin opisthognathous_A = mkWA "opisthognathous" ; --UNCHK
lin opisthorchiasis_N = mkWN (compoundN "opistorki" (k5 "aasi")) ; --UNCHK
lin opisthotonos_N = mkWN (compoundN "opisto" (k39 "tonus")) ; --UNCHK
lin opium_N = mkWN (k5 "oopiumi") ; --UNCHK
lin opium_den_N = mkWN (compoundN "oopiumi" (k10 "luola")) ; --UNCHK
lin opopanax_N = mkWN (k6 "mirhami") ; --UNCHK
lin opossum_N = mkWN (k5 "opossumi") ; --UNCHK
lin opp_PN = foreignPN "Opp" ;
lin opponentFem_N = mkN "vastustaja" ;
lin opponentMasc_N = variants {} ; --
lin opponent_A = mkWA "vastustava" ; --UNCHK
lin opportune_A = mkWA (k10 "sopiva") ; --UNCHK
lin opportuneness_N = mkWN (k40 "sattuvuus") ; --UNCHK
lin opportunism_N = mkWN (k2 "tavoittelu") "oman" "edun" ; --UNCHK
lin opportunistFem_N = mkWN (k5 "egoisti") ; --UNCHK
lin opportunistMasc_N = mkWN (k5 "egoisti") ; --UNCHK
lin opportunist_A = mkWA (k38 "opportunistinen") ; --UNCHK
lin opportunity_N = mkN (lin NK {s = d40 "tilaisuus"}) ;
lin oppose_V = mkWV (k53 "vastustaa") ;
lin oppose_V2 = mkWV2 (k53 "vastustaa") partitive ;
lin opposed_A = mkA "vastustettu" ;
lin opposite_A = mkWA (k38 "parillinen") ; --UNCHK
lin opposite_Adv = variants {} ; -- mkPrep "vastapäätä" partitive ;
lin opposite_N = mkWN (k10A "vastakohta") ; --UNCHK
lin opposite_Prep = mkPrep "vastapäätä" partitive ;
lin opposition_N = mkN "oppositio" | mkN "vastustus" ;
lin oppress_V2 = mkWV2 (k53 "alistaa") ; --UNCHK
lin oppression_N = mkWN (k1A "sorto") ; --UNCHK
lin oppressive_A = mkWA (k38 "tyrannimainen") ; --UNCHK
lin oppressor_N = mkWN (k10 "sortaja") ; --UNCHK
lin opprobrious_A = mkWA (k34A "kunniaton") ; --UNCHK
lin opprobrium_N = mkWN (k10A "halveksunta") ; --UNCHK
lin oppugn_V2 = mkWV2 (k53A "asettaa") "kyseenalaiseksi" ; --UNCHK
lin opsin_N = mkWN "opsiini" ; --UNCHK
lin opsonin_N = mkWN (compoundN "opso" (k26 "niini")) ; --UNCHK
lin opsonization_N = mkWN "opsonisaatio" ; --UNCHK
lin opt_V = mkV (mkV "antaa") "äänensä" ; --mkWV (k53A "pitää") "parempana" ; --assuming a complement beginning with "for", that's why chose this verb in Finnish.
lin opt_VS = mkWVS (k53A "pitää") "parempana" ; --UNCHK
lin opt_VV = mkWVV (k53A "pitää") "parempana" ; --UNCHK
lin opt_out_V2 = mkWV2 (k53 "luistaa") ; --UNCHK
lin optative_A = mkWA "optatiivi-" ; --UNCHK
lin optative_N = mkWN "optatiivi" ; --UNCHK
lin optical_A = mkA "optinen" ;
lin optician_N = mkWN (k4A "optikko") ; --UNCHK
lin optics_N = mkWN (k14A "optiikka") ; --UNCHK
lin optimal_A = mkWA (k38 "optimaalinen") ; --UNCHK
lin optimism_N = mkWN (k5 "optimismi") ; --UNCHK
lin optimistFem_N = mkWN (k5 "optimisti") ; --UNCHK
lin optimistMasc_N = mkWN (k5 "optimisti") ; --UNCHK
lin optimistic_A = mkWA (k38 "optimistinen") ;
lin optimization_N = mkWN (k5A "optimointi") ; --UNCHK
lin optimum_A = mkWA (k38 "optimaalinen") ; --UNCHK
lin option_N = mkN "optio" ;
lin optional_A = mkWA (k38 "valinnainen") ; --UNCHK
lin optometrist_N = mkWN (k4A "optikko") ; --UNCHK
lin optometry_N = mkWN (k12 "optometria") ; --UNCHK
lin opulence_N = mkWN (k40 "ruhtinaallisuus") ; --UNCHK
lin opulent_A = mkWA (k38 "ruhtinaallinen") ; --UNCHK
lin opus_N = mkWN (k39 "opus") ; --UNCHK
lin or_Conj = S.or_Conj ;
lin orach_N = mkWN (k9 "maltsa") ; --UNCHK
lin oracle_N = mkWN "kaikkeinpyhin" ; --UNCHK
lin oracular_A = mkWA (k38 "oraakkelimainen") ; --UNCHK
lin orad_Adv = mkWAdv (k99 "kohti") "suuta" ; --UNCHK
lin oral_A = mkA "suullinen" ; --mkWA (k38 "oraalinen") ;
lin oral_N = mkWN (k5A "tentti") "suullinen" ; --UNCHK
lin orange_1_N = mkN "appelsiini" ;
lin orange_2_N = variants {} ; --
lin orange_A = mkWA (k5 "oranssi") ; --UNCHK
lin orange_N = mkWN (k5 "oranssi") ; --UNCHK
lin orangeade_N = mkWN (compoundN "appelsiini" (k10 "juoma")) ; --UNCHK
lin orangeman_N = mkWN "Orangeman" ; --UNCHK
lin orangery_N = mkWN (k6 "ansari") ; --UNCHK
lin orangewood_N = mkWN (compoundN "appelsiini" (k18 "puu")) ; --UNCHK
lin orangutan_N = mkWN (k5A "oranki") ; --UNCHK
lin orate_V = mkWV (k73 "saarnata") ; --UNCHK
lin oration_N = mkWN (k48 "puhe") ; --UNCHK
lin oratorFem_N = mkWN (k10 "puhuja") "julkinen" ; --UNCHK
lin oratorMasc_N = mkWN (k10 "puhuja") "julkinen" ; --UNCHK
lin oratorical_A = mkWA (compoundA "ora" (k38 "torinen")) ; --UNCHK
lin oratorio_N = mkWN (k3 "oratorio") ; --UNCHK
lin oratory_N = mkWN (k48 "puhe") ; --UNCHK
lin oravais_PN = mkPN "Oravainen" ;
lin orb_N = mkWN (k10 "silmä") ; --UNCHK
lin orbiculate_A = mkWA (k15 "pyöreä") ; --UNCHK
lin orbit_N = mkWN (k40 "ulottuvuus") ; --UNCHK
lin orbit_V = mkWV (k61 "pyöriä") ; --UNCHK
lin orbit_V2 = mkWV2 (k61 "pyöriä") ; --UNCHK
lin orbital_A = mkWA "silmäkuoppa-" ; --UNCHK
lin orchard_N = mkWN (k4A "metsikkö") ; --UNCHK
lin orchestra_N = mkN "orkesteri" ; --mkWN (k1A "permanto") ;
lin orchestral_A = mkWA "orkesteri-" ; --UNCHK
lin orchestrate_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin orchestration_N = mkWN (k39 "soitinnus") ; --UNCHK
lin orchestrator_N = mkWN "soitintaja" ; --UNCHK
lin orchid_N = mkWN (k13 "orkidea") ; --UNCHK
lin orchidalgia_N = mkWN "orkidalgia" ; --UNCHK
lin orchil_N = mkWN (compoundN "lakmus" (k10 "jäkälä")) ; --UNCHK
lin orchiopexy_N = mkWN "orkiopeksia" ; --UNCHK
lin orchis_N = mkWN (k39 "kives") ; --UNCHK
lin orchitis_N = mkWN (compoundN "kives" (k39 "tulehdus")) ; --UNCHK
lin orchotomy_N = mkWN (compoundN "kives" (k39 "leikkaus")) ; --UNCHK
lin ordain_V2 = mkWV2 (k53A "säätää") ; --UNCHK
lin ordain_VS = mkWVS (k53A "säätää") ; --UNCHK
lin ordainer_N = mkWN (k12 "vihkijä") ; --UNCHK
lin ordeal_N = mkWN (compoundN "jumalan" (k3 "tuomio")) ; --UNCHK
lin order_N = mkN "järjestys" ;
lin order_V = mkWV (k53 "järjestää") ; --UNCHK
lin order_V2 = mkV2 "tilata" ;
lin order_V2V = mkWV2V (k53 "järjestää") ; --UNCHK
lin order_VS = mkWVS (k53 "järjestää") ; --UNCHK
lin order_book_N = mkWN (compoundN "tilaus" (k9 "kirja")) ; --UNCHK
lin order_form_N = mkWN (compoundN "tilaus" (k48A "lomake")) ; --UNCHK
lin order_paper_N = mkWN (compoundN "esitys" (k9 "lista")) ; --UNCHK
lin orderer_N = mkWN (k4A "systemaatikko") ; --UNCHK
lin ordering_N = mkWN (k2 "järjestely") ; --UNCHK
lin orderliness_N = mkWN (k40 "järjestelmällisyys") ; --UNCHK
lin orderly_A = mkA "kunnollinen" ; --WA (k38 "rauhallinen") ;
lin orderly_N = mkWN (compoundN "sairaala-" (k38 "apulainen")) ; --UNCHK
lin ordinal_A = mkWA "järjestys-" ; --UNCHK
lin ordinal_N = mkWN (compoundN "järjestys" (k1A "luku")) ; --UNCHK
lin ordinance_N = mkN "säädös" ; --mkWN (k5 "rituaali") ;
lin ordinand_N = mkWN (compoundN "pappis" (k41 "kokelas")) ; --UNCHK
lin ordinariness_N = mkWN (k40 "arkipäiväisyys") ; --UNCHK
lin ordinary_A = mkWA (k38 "tavallinen") ;
lin ordinate_N = mkWN (k9A "ordinaatta") ; --UNCHK
lin ordination_N = mkWN (k5 "rituaali") ; --UNCHK
lin ordnance_N = mkWN (kH1 "tykki") ; --UNCHK
lin ordure_N = mkWN (k48 "uloste") ; --UNCHK
lin ore_N = mkWN (k5 "äyri") ; --UNCHK
lin oregano_N = mkWN (k1 "oregano") ; --UNCHK
lin oregon_PN = foreignPN "Oregon" ;
lin oreo_N = mkWN (k5 "suklaakeksi") ; --UNCHK
lin organ_N = mkN "elin" ;
lin organ_loft_N = mkWN (k7 "urkuparvi") ; --UNCHK
lin organdie_N = mkWN (k5 "organdi") ; --UNCHK
lin organdy_N = mkWN (k5 "organdi") ; --UNCHK
lin organelle_N = mkWN (compoundN "solu" (k33 "elin")) ; --UNCHK
lin organic_A = mkWA (k38 "elimellinen") ; --UNCHK
lin organic_N = mkWN (k48A "lannoite") "orgaaninen" ; --UNCHK
lin organicism_N = mkWN (compoundN "organis" (k5 "ismi")) ; --UNCHK
lin organicistic_A = mkWA "organisistinen" ; --UNCHK
lin organification_N = mkWN "organisoituminen" ; --UNCHK
lin organisation_N = mkN "organisaatio" ;
lin organism_N = mkWN (k1A "olento") ; --UNCHK
lin organismal_A = mkWA "organismi-" ; --UNCHK
lin organist_N = mkWN (k6 "urkuri") ; --UNCHK
lin organization_N = mkN "organisaatio" ;
lin organizational_A = mkWA (k38 "järjestöllinen") ; --UNCHK
lin organize_V2 = mkV2 "organisoida" ;
lin organize_V2V = mkWV2V (k53 "järjestää") ; --UNCHK
lin organizer_N = mkN "organisoija" ;
lin organon_N = mkWN (k6 "systeemi") ; --UNCHK
lin organophosphate_N = mkWN (compoundN "organo" (k5A "fosfaatti")) ; --UNCHK
lin organza_N = mkWN "organza" ; --UNCHK
lin orgasm_N = mkWN (k10 "huipentuma") ; --UNCHK
lin orgiastic_A = mkWA (k38 "hekumallinen") ; --UNCHK
lin orgy_N = mkN "orgia" ;
lin oriel_N = mkWN (k6 "erkkeri") ; --UNCHK
lin orient_N = mkWN (k10A "itä") ; --UNCHK
lin orient_V2 = mkWV2 (k73A "suunnata") ; --UNCHK
lin oriental_A = mkWA (k38 "orientaalinen") ; --UNCHK
lin oriental_N = mkWN (k2 "henkilö") "itämainen" ; --UNCHK
lin orientalism_N = mkWN (compoundN "oriental" (k5 "ismi")) ; --UNCHK
lin orientalistFem_N = mkWN (k5 "orientalisti") ; --UNCHK
lin orientalistMasc_N = mkWN (k5 "orientalisti") ; --UNCHK
lin orientate_V2 = mkWV2 (k67A "määritellä") "sijainti" ; --UNCHK
lin orientation_N = mkWN (compoundN "johdanto" (k5 "kurssi")) ; --UNCHK
lin orienting_A = mkWA "suuntaus-" ; --UNCHK
lin orifice_N = mkWN (k10A "reikä") ; --UNCHK
lin oriflamme_N = mkWN (compoundN "orifl" (k48 "amme")) ; --UNCHK
lin origami_N = mkWN "origami" ; --UNCHK
lin origanum_N = mkWN (k6 "meirami") ; --UNCHK
lin origin_N = mkWN (compoundN "synty" (k10 "perä")) ; --UNCHK
lin original_A = mkA (mkN "alku" (mkN "peräinen")) ;
lin original_N = mkWN (k5 "originaali") ; --UNCHK
lin originalism_N = mkWN (compoundN "original" (k5 "ismi")) ; --UNCHK
lin originality_N = mkWN (k40 "omintakeisuus") ; --UNCHK
lin originate_V = mkWV (k53 "perustaa") ; --UNCHK
lin originate_V2 = mkWV2 (k53 "perustaa") ; --UNCHK
lin originatorFem_N = mkWN (k10 "luoja") ; --UNCHK
lin originatorMasc_N = mkWN (k10 "luoja") ; --UNCHK
lin orimattila_PN = mkPN "Orimattila" ;
lin oripää_PN = mkPN "Oripää" ;
lin orison_N = mkWN (k1A "pyyntö") ; --UNCHK
lin orivesi_PN = mkPN (mkN "Orivesi" "Oriveden" "Orivesiä") ;
lin orkney_PN = foreignPN "Orkney" ;
lin orleans_PN = foreignPN "Orleans" ;
lin orlop_N = mkWN (k28 "kansi") "neljäs" ; --UNCHK
lin ormer_N = mkWN (compoundN "meri" (k10 "korva")) ; --UNCHK
lin ormolu_N = mkWN (compoundN "kulta" (k5 "pronssi")) ; --UNCHK
lin ormskirk_PN = foreignPN "Ormskirk" ;
lin ornament_N = mkWN (k5A "ornamentti") ; --UNCHK
lin ornament_V2 = mkWV2 (k53 "komistaa") ; --UNCHK
lin ornamental_A = mkWA (k38 "koristeellinen") ; --UNCHK
lin ornamental_N = mkWN (compoundN "koriste" (k5 "kasvi")) ; --UNCHK
lin ornamentalism_N = mkWN (compoundN "kori" (k38 "steleminen")) ; --UNCHK
lin ornamentation_N = mkWN (k2 "kaunistelu") ; --UNCHK
lin ornate_A = mkWA (k38 "koristeellinen") ; --UNCHK
lin ornateness_N = mkWN (k40 "taidokkuus") ; --UNCHK
lin ornery_A = mkWA (k1 "häijy") ; --UNCHK
lin ornithine_N = mkWN "ornitiini" ; --UNCHK
lin ornithischian_N = mkWN (k1 "nokkalisko") ; --UNCHK
lin ornithological_A = mkWA (compoundA "lintu" (k38 "tieteellinen")) ; --UNCHK
lin ornithologistFem_N = mkWN (k5 "ornitologi") ; --UNCHK
lin ornithologistMasc_N = mkWN (k5 "ornitologi") ; --UNCHK
lin ornithology_N = mkWN (k12 "ornitologia") ; --UNCHK
lin ornithomimid_N = mkWN "ornitomimosaurus" ; --UNCHK
lin ornithopod_N = mkWN (k39 "dinosaurus") "ornitopodinen" ; --UNCHK
lin orogeny_N = mkWN (compoundN "vuorijonon" (k39 "muodostus")) ; --UNCHK
lin oroide_N = mkWN (k10A "kulta") "jäljitelty" ; --UNCHK
lin orologistFem_N = variants {} ; ---- sense to be split
lin orologistMasc_N = variants {} ; ---- sense to be split
lin orology_N = mkWN (compoundN "vuoristo-" (k5A "oppi")) ; --UNCHK
lin oropharyngeal_A = mkWA "suunielu-" ; --UNCHK
lin oropharynx_N = mkWN (compoundN "suu" (k1 "nielu")) ; --UNCHK
lin orotund_A = mkWA (k38 "täyteläinen") ; --UNCHK
lin orphan_N = mkWN (k1A "orpo") ; --UNCHK
lin orphan_V2 = mkWV2 (k63 "jäädä") "orvoksi" ; --UNCHK
lin orphanage_N = mkWN (compoundN "orpo" (k5A "koti")) ; --UNCHK
lin orphenadrine_N = mkWN "orfenadiini" ; --UNCHK
lin orphrey_N = mkWN (compoundN "kulta" (k48 "päärme")) ; --UNCHK
lin orpiment_N = mkWN (compoundN "auri" (k5A "pigmentti")) ; --UNCHK
lin orpine_N = mkWN (k50 "isomaksaruoho") ; --UNCHK
lin orrery_N = mkWN (k3 "telluurio") ; --UNCHK
lin orrisroot_N = mkWN (k26 "orvokinjuuri") ; --UNCHK
lin orthicon_N = mkWN (compoundN "kamera" (k7 "putki")) ; --UNCHK
lin orthochorea_N = mkWN (k15 "ortokorea") ; --UNCHK
lin orthoclase_N = mkWN (compoundN "ortokl" (k5 "aasi")) ; --UNCHK
lin orthodontic_A = mkWA "ortodontinen" ; --UNCHK
lin orthodontics_N = mkWN (compoundN "hampaidenoikomis" (k5A "oppi")) ; --UNCHK
lin orthodontist_N = mkWN (compoundN "oik" (k10 "oja")) ; --UNCHK
lin orthodox_A = mkWA (compoundA "puhdas" (k38 "oppinen")) ; --UNCHK
lin orthodoxy_N = mkWN "puhdasoppisuus" ; --UNCHK
lin orthoepist_N = mkWN (k10 "harjoittaja") "ortoepian" ; --UNCHK
lin orthoepy_N = mkWN "ortoepia" ; --UNCHK
lin orthogonal_A = mkWA (compoundA "suorakul" (k38 "mainen")) ; --UNCHK
lin orthogonality_N = mkWN "ortogonaalisuus" ; --UNCHK
lin orthographic_A = mkWA "ortografinen" ; --UNCHK
lin orthography_N = mkWN (k12 "ortografia") ; --UNCHK
lin orthomolecular_A = mkWA (compoundA "orto" (k38 "molekulaarinen")) ; --UNCHK
lin orthomyxovirus_N = mkWN (compoundN "ortomykso" (k39 "virus")) ; --UNCHK
lin orthopaedic_A = mkWA (k38 "ortopedinen") ; --UNCHK
lin orthopaedics_N = mkWN (k12 "ortopedia") ; --UNCHK
lin orthopedist_N = mkWN (k5 "ortopedi") ; --UNCHK
lin orthopnea_N = mkWN "ortopnea" ; --UNCHK
lin orthoptic_A = mkWA "silmänoikaisu-" ; --UNCHK
lin orthoptics_N = mkWN (k1A "hoito") "ortoptinen" ; --UNCHK
lin orthoptist_N = mkWN "ortoptisti" ; --UNCHK
lin orthoscope_N = mkWN (compoundN "ortosko" (k5A "oppi")) ; --UNCHK
lin orthostatic_A = mkWA (compoundA "orto" (k38 "staattinen")) ; --UNCHK
lin orthotropous_A = mkWA (compoundA "orto" (k38 "trooppinen")) ; --UNCHK
lin ortolan_N = mkWN (compoundN "pelto" (k1A "sirkku")) ; --UNCHK
lin ortygan_N = mkWN "ortygan" ; --UNCHK
lin oryx_N = mkWN (compoundN "keihäs" (k5A "antilooppi")) ; --UNCHK
lin orzo_N = mkWN "orzo" ; --UNCHK
lin os_N = mkWN (k18 "luu") ; --UNCHK
lin oscar_N = mkWN (compoundN "Oscar-" (k1A "palkinto")) ; --UNCHK
lin oscar_PN = mkPN "Oscar" ;
lin oscheocele_N = mkWN (k39 "turvotus") "kivespussin" ; --UNCHK
lin oscillate_V = mkWV (k67A "värähdellä") ; --UNCHK
lin oscillate_V2 = mkWV2 (k67A "värähdellä") ; --UNCHK
lin oscillation_N = mkWN (k1A "kierto") ; --UNCHK
lin oscillator_N = mkWN (k6 "oskillaattori") ; --UNCHK
lin oscillatory_A = mkWA "värähtely-" ; --UNCHK
lin oscillogram_N = mkWN "oskillogrammi" ; --UNCHK
lin oscillograph_N = mkWN "oskillografi" ; --UNCHK
lin oscilloscope_N = mkWN (k5A "oskilloskooppi") ; --UNCHK
lin oscine_A = mkWA "laululintuihin" "liittyvä" ; --UNCHK
lin oscine_N = mkWN (compoundN "laulu" (k1A "lintu")) ; --UNCHK
lin oscitancy_N = mkWN (k39 "haukotus") ; --UNCHK
lin osculation_N = mkWN (k1A "suukko") ; --UNCHK
lin osier_N = mkWN (compoundN "kori" (k1 "paju")) ; --UNCHK
lin oslo_PN = foreignPN "Oslo" ;
lin osmiridium_N = mkWN (k5 "osmium") "iridiumpitoinen" ; --UNCHK
lin osmium_N = mkWN (k5 "osmium") ; --UNCHK
lin osmosis_N = mkWN (k5 "osmoosi") ; --UNCHK
lin osmotic_A = mkWA (k38 "osmoottinen") ; --UNCHK
lin osprey_N = mkWN (k7 "sääksi") ; --UNCHK
lin osseous_A = mkWA (k38 "luinen") ; --UNCHK
lin ossett_PN = foreignPN "Ossett" ;
lin ossicle_N = mkWN (compoundN "pikku" (k18 "luu")) ; --UNCHK
lin ossicular_A = mkWA "kuuloluu-" ; --UNCHK
lin ossiferous_A = mkWA "luita" "sisältävä" ; --UNCHK
lin ossification_N = mkWN "sopeutuminen" ; --UNCHK
lin ossify_V = mkWV (k53A "vakiinnuttaa") ; --UNCHK
lin ossify_V2 = mkWV2 (k53A "vakiinnuttaa") ; --UNCHK
lin ossuary_N = mkWN (compoundN "hauta" (k39 "syvennys")) ; --UNCHK
lin osteal_A = mkWA (k38 "luinen") ; --UNCHK
lin osteitis_N = mkWN (compoundN "luu" (k39 "tulehdus")) ; --UNCHK
lin ostensible_A = mkWA (k38 "näennäinen") ; --UNCHK
lin ostensive_A = mkWA (k38 "näennäinen") ; --UNCHK
lin ostentation_N = mkWN (k2 "mahtailu") ; --UNCHK
lin ostentatious_A = mkA "mahtaileva" ;
lin osteoarthritis_N = mkWN (compoundN "nivel" (k40 "sairaus")) "rappeuttava" ; --UNCHK
lin osteoblast_N = mkWN "luunemosolu" ; --UNCHK
lin osteoblastoma_N = mkWN (compoundN "osteoblasto" (k10 "oma")) ; --UNCHK
lin osteochondroma_N = mkWN (compoundN "osteokondro" (k10 "oma")) ; --UNCHK
lin osteoclasis_N = mkWN "luun" "murtaminen" ; --UNCHK
lin osteoclast_N = mkWN "luunsyöjäsolu" ; --UNCHK
lin osteocyte_N = mkWN (compoundN "luu" (k1 "solu")) ; --UNCHK
lin osteodystrophy_N = mkWN "osteodystrofia" ; --UNCHK
lin osteologist_N = mkWN "osteologi" ; --UNCHK
lin osteology_N = mkWN (compoundN "luu" (k5A "oppi")) ; --UNCHK
lin osteolysis_N = mkWN (compoundN "osteoly" (k5 "ysi")) ; --UNCHK
lin osteoma_N = mkWN (compoundN "luu" (k33 "kasvain")) ; --UNCHK
lin osteomalacia_N = mkWN (k12 "osteomalasia") ; --UNCHK
lin osteomyelitis_N = mkWN (compoundN "luu" (k10A "mätä")) ; --UNCHK
lin osteopath_N = mkWN (k5A "osteopaatti") ; --UNCHK
lin osteopetrosis_N = mkWN (k5A "tauti") "Albers-Schönbergin" ; --UNCHK
lin osteophyte_N = mkWN (compoundN "luu" (k5A "piikki")) ; --UNCHK
lin osteoporosis_N = mkWN (k5 "osteoporoosi") ; --UNCHK
lin osteosarcoma_N = mkWN (compoundN "luu" (k10A "syöpä")) ; --UNCHK
lin osteosclerosis_N = mkWN (compoundN "osteo" (k5 "skleroosi")) ; --UNCHK
lin osteostracan_N = mkWN (compoundN "kilpi" (k9 "kala")) ; --UNCHK
lin ostinato_N = mkWN (compoundN "osti" (k1A "nato")) ; --UNCHK
lin ostiole_N = mkWN (k38 "huokonen") ; --UNCHK
lin ostler_N = mkWN (compoundN "talli" (k5A "renki")) ; --UNCHK
lin ostomy_N = mkWN (k1A "teko") "avanteen" ; --UNCHK
lin ostracism_N = mkWN "sulkeminen" "ryhmästä" ; --UNCHK
lin ostracize_V2 = mkWV2 (k58A "sulkea") "ulkopuolelle" ; --UNCHK
lin ostracoderm_N = mkWN (compoundN "panssari" (k9 "kala")) ; --UNCHK
lin ostrich_N = mkWN (k5 "strutsi") ; --UNCHK
lin oswestry_PN = foreignPN "Oswestry" ;
lin otaniemi_PN = mkPN (mkN "Otaniemi" "Otaniemiä") ;
lin other_A = mkA "muu" ;
lin other_N = mkN "toinen" ;
lin otherness_N = mkWN (k40 "erillisyys") ; --UNCHK
lin otherwise_A = mkWA (k38 "erilainen") ; --UNCHK
lin otherwise_Adv = mkWAdv (k99 "muuten") ;
lin otherwise_PConj = S.otherwise_PConj ;
lin otherworld_N = mkWN (compoundN "henki" (k13 "maailma")) ; --UNCHK
lin otherworldly_A = mkWA (compoundA "tuon" (k38 "puoleinen")) ; --UNCHK
lin othonna_N = mkWN "otonna" ; --UNCHK
lin otic_A = mkWA "kuulo-" ; --UNCHK
lin otiose_A = mkWA (k1A "veltto") ; --UNCHK
lin otitis_N = mkWN (compoundN "korva" (k39 "tulehdus")) ; --UNCHK
lin otley_PN = foreignPN "Otley" ;
lin otology_N = mkWN (compoundN "korvatauti" (k5A "oppi")) ; --UNCHK
lin otoplasty_N = mkWN (compoundN "otopl" (k12 "astia")) ; --UNCHK
lin otorrhea_N = mkWN (compoundN "korva" (k1A "vuoto")) ; --UNCHK
lin otosclerosis_N = mkWN (compoundN "oto" (k5 "skleroosi")) ; --UNCHK
lin otoscope_N = mkWN (compoundN "korva" (k2 "suppilo")) ; --UNCHK
lin ototoxic_A = mkWA (compoundA "oto" (k38 "toksinen")) ; --UNCHK
lin ottawa_PN = foreignPN "Ottawa" ;
lin otter_N = mkWN (k1A "saukko") ; --UNCHK
lin otterhound_N = mkWN (compoundN "saukko" (k10 "koira")) ; --UNCHK
lin ottomanFem_N = mkWN (k5 "rahi") ; --UNCHK
lin ottomanMasc_N = mkWN (k5 "rahi") ; --UNCHK
lin oubliette_N = mkWN (compoundN "vanki" (k10 "tyrmä")) "maanalainen" ; --UNCHK
lin ouguiya_N = mkWN "ouguiya" ; --UNCHK
lin ouija_N = mkWN (compoundN "Ouija-" (k1 "taulu")) ; --UNCHK
lin ouija_board_N = mkWN (compoundN "Ouija-" (k1 "taulu")) ; --UNCHK
lin oulainen_PN = mkPN "Oulainen" ;
lin oulu_PN = mkPN "Oulu" ;
lin oulunsalo_PN = mkPN "Oulunsalo" ;
lin ounce_N = mkN "unssi" ; --f76
lin oust_V = mkV (mkV "tulla") "erotetuksi" ; --mkWV (k56A "antaa") "potkut" ;
lin oust_V2 = mkWV2 (k56A "antaa") "potkut" ; --UNCHK
lin ouster_N = mkWN (k39 "karkotus") ; --UNCHK
lin out_A = mkWA (k99 "ulkona") ; --UNCHK
lin out_Adv = mkWAdv (k99 "ulkona") ;
lin out_N = mkWN (k1 "palo") ; --UNCHK
lin out_Prep = mkPrep "ulos" elative ;
lin out_V2 = mkWV2 (k67 "tulla") "ilmi" ; --UNCHK
lin out_from_Prep = mkPrep "ulos" elative ;
lin out_of_Prep = mkPrep "ulkopuolella" ;
lin out_of_doors_Adv = mkWAdv (k99 "ulkosalla") ; --UNCHK
lin out_of_the_way_Adv = mkWAdv "pois" "tieltä" ; --UNCHK
lin out_of_work_A = mkWA (k34A "työtön") ; --UNCHK
lin out_trade_V2 = mkV2 (mkV (mkV "käydä") "kauppaa") ; ---- ? out trade: "A trade that cannot be settled by a clearing house because the counterparties have contradictory or otherwise inconsistent information on the trade"
lin outage_N = mkWN (k39 "katkos") ; --UNCHK
lin outback_A = mkWA (k38 "syrjäinen") ; --UNCHK
lin outback_N = mkWN (compoundN "taka" (k18 "maa")) ; --UNCHK
lin outbalance_V2 = mkWV2 (k56 "painaa") "enemmän" ; --UNCHK
lin outbid_V2 = mkV2 (mkV (mkV "tarjota") "enemmän kuin") nominative ;
lin outboard_A = mkWA (k16A "ulompi") ; --UNCHK
lin outbound_A = mkWA (compoundA "läht" (k10 "evä")) ; --UNCHK
lin outbreak_N = mkWN (k39 "purkaus") ; --UNCHK
lin outbred_A = mkWA "risteytetty" ; --UNCHK
lin outbuilding_N = mkWN (compoundN "ulko" (k39 "rakennus")) ; --UNCHK
lin outburst_N = mkWN (k3 "häiriö") "myrskyisä" ; --UNCHK
lin outcast_N = mkWN (k6 "kulkuri") ; --UNCHK
lin outcaste_A = mkWA "kastiton" ; --UNCHK
lin outcaste_N = mkWN "kastiton" ; --UNCHK
lin outclass_V2 = mkWV2 (k53A "voittaa") "vaivattomasti" ; --UNCHK
lin outcome_N = mkN "tulos" ;
lin outcrop_N = mkWN (k10 "paljastuma") ; --UNCHK
lin outcry_N = mkWN (k2 "karjaisu") ; --UNCHK
lin outdated_A = mkWA (compoundA "ikä" (k1A "loppu")) ; --UNCHK
lin outdistance_V2 = mkWV2 (k53A "jättää") "jälkeensä" ; --UNCHK
lin outdo_V2 = mkV2 "päihittää" ;
lin outdoor_A = mkWA "ulko-" ; --UNCHK
lin outdoors_Adv = mkWAdv (k99 "ulkosalla") ; --UNCHK
lin outdoors_N = mkWN (compoundN "ulko" (k9 "ilma")) ; --UNCHK
lin outdoorsman_N = mkWN (k12 "ulkoilija") ; --UNCHK
lin outdoorswoman_N = mkWN (k12 "ulkoilija") ; --UNCHK
lin outdoorsy_A = mkWA "ulkoilma-" ; --UNCHK
lin outer_A = mkWA (k16A "ulompi") ; --UNCHK
lin outercourse_N = mkWN (k5 "seksi") "yhdynnätön" ; --UNCHK
lin outermost_A = mkWA (k38 "ulommainen") ; --UNCHK
lin outface_V2 = mkWV2 (k53A "häkellyttää") "katseellaan" ; --UNCHK
lin outfall_N = mkWN (k10A "laskukohta") ; --UNCHK
lin outfield_N = mkWN (compoundN "taka" (k10A "kenttä")) ; --UNCHK
lin outfielder_N = mkWN (k10 "pelaaja") "takakentän" ; --UNCHK
lin outfight_V2 = mkWV2 (k53A "päihittää") ; --UNCHK
lin outfit_N = mkWN "-sarja" ; --UNCHK
lin outfit_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin outfitter_N = mkWN (compoundN "varuste" (k48A "liike")) ; --UNCHK
lin outfitting_N = mkWN (compoundN "varus" (k38 "taminen")) ; --UNCHK
lin outflank_V2 = mkV2 "harhauttaa" ;
lin outflow_N = mkN "ulosvirtaus" ; --WN (k1A "vuoto") ;
lin outfly_V2 = mkV2 "ylittää" ;
lin outfox_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin outgain_V2 = mkV2 "voittaa" ;
lin outgo_V = mkV "lähteä" ; --outgoing
lin outgrow_V2 = mkWV2 (k56 "kasvaa") "pois" ; --UNCHK
lin outgrowth_N = mkWN (k48A "uloke") ; --UNCHK
lin outhouse_N = mkWN (k50 "kuivakäymälä") ; --UNCHK
lin outing_N = mkWN (k9 "matka") ; --UNCHK
lin outlandish_A = mkWA (k38 "merkillinen") ; --UNCHK
lin outlandishness_N = mkWN (k40 "outous") ; --UNCHK
lin outlast_V2 = mkV2 (mkV (mkV "kestää") "kauemmin") (prePrep nominative "kuin") ;
lin outlaw_N = mkWN (k10 "konna") ; --UNCHK
lin outlaw_V2 = mkWV2 (k53 "julistaa") "laittomaksi" ;
lin outlawry_N = mkWN (compoundN "lain" (k40 "vastaisuus")) ; --UNCHK
lin outlay_N = mkWN (compoundN "rahan" (k1A "käyttö")) ; --UNCHK
lin outleap_V2 = mkV2 "ohittaa" ;
lin outlet_N = mkN "tehtaan" (mkN "myymälä") ; ---ARB mkWN (compoundN "purkautumis" (k19 "tie")) ;
lin outlier_N = mkWN (k1A "havainto") "vieras" ; --UNCHK
lin outline_N = mkWN (k39 "luonnos") ; --UNCHK
lin outline_V2 = mkWV2 (k53A "vetää") "yhteen" ; --UNCHK
lin outlook_N = mkN "suhtautumis" (mkN "tapa") ; --f60
lin outlying_A = mkWA (k38 "syrjäinen") ; --UNCHK
lin outmanoeuvre_V2 = mkWV2 (k53A "päihittää") "oveluudessa" ; --UNCHK
lin outmarch_V2 = mkWV2 (k61 "marssia") "pidemmälle" ; --UNCHK
lin outmoded_A = mkA "vanhentunut" ;
lin outmost_A = mkWA (k38 "ulommainen") ; --UNCHK
lin outnumber_V2 = mkWV2 (k67 "olla") "lukuisampi" ; --UNCHK
lin outokumpu_PN = mkPN "Outokumpu" ;
lin outpace_V2 = mkWV2 (k53A "ohittaa") ;
lin outpatient_N = mkWN (k41 "potilas") "avohoidon" ;
lin outperform_V2 = mkV2 "voittaa" ;
lin outplay_V2 = mkWV2 (k53A "voittaa") ; --UNCHK
lin outpoint_V2 = mkWV2 (k63 "saada") "pistevoitto" ; --UNCHK
lin outport_N = mkWN (compoundN "ulko" (k10 "satama")) ; --UNCHK
lin outpost_N = mkWN (compoundN "etuvartio" (k10 "asema")) ; --UNCHK
lin outpouring_N = mkWN (k10 "tulva") ; --UNCHK
lin output_N = mkN "tuotos" ; ---ARB mkN "tuloste" ;
lin outrage_N = mkWN (compoundN "ilki" (k19 "työ")) ; --UNCHK
lin outrage_V2 = mkWV2 (k53A "kauhistuttaa") ; --UNCHK
lin outrageous_A = mkWA (k10 "järkyttävä") ; --UNCHK
lin outrageousness_N = mkWN (k40 "hirvittävyys") ; --UNCHK
lin outrange_V2 = mkWV2 (k56A "kantaa") "pidemmälle" ; --UNCHK
lin outrank_V2 = mkWV2 (k52A "sijoittua") ; --UNCHK
lin outre_A = mkWA (k38 "merkillinen") ; --UNCHK
lin outreach_N = mkWN (compoundN "kurko" (k38 "ttaminen")) ; --UNCHK
lin outride_V2 = mkWV2 (k56 "ajaa") "paremmin" ; --UNCHK
lin outrider_N = mkWN (k12 "tunnustelija") ; --UNCHK
lin outrigged_A = mkWA (compoundA "varus" (k1 "tettu")) "tukipalkilla" ; --UNCHK
lin outrigger_N = mkWN (compoundN "tasapain" (k10 "ottaja")) ; --UNCHK
lin outright_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin outright_Adv = mkWAdv (k99 "viipymättä") ; --UNCHK
lin outrun_V2 = mkWV2 (k70 "juosta") "kovemmin" ; --UNCHK
lin outsail_V2 = mkWV2 (k61A "purjehtia") "paremmin" ; --UNCHK
lin outsell_V2 = mkWV2 (k63 "myydä") "enemmän" ; --UNCHK
lin outset_N = mkN "alku" ; --mkWN (k9A "alkamisaika") ;
lin outshine_V2 = mkWV2 (k53A "jättää") "varjoon" ; --UNCHK
lin outside_A = mkA (mkN "ulko" (mkN "puolinen")) ; --f53
lin outside_Adv = mkWAdv (k99 "ulkosalla") ; --UNCHK
lin outside_N = mkN "ulko" (mkN "puoli") ; --mkWN (compoundN "ulko" (k9A "pinta")) ;
lin outside_Prep = mkPrep "ulkopuolella" ;
lin outside_of_Prep = mkPrep "ulkopuolella" ;
lin outsider_N = mkWN (k41 "vieras") ; --UNCHK
lin outsize_A = mkWA (compoundA "yli" (k26 "suuri")) ; --UNCHK
lin outsize_N = mkWN (kH1 "koko") "normaalia" "suurempi" ; --UNCHK
lin outskirt_N = mkWN (k9A "laita") ; --UNCHK
lin outskirts_N = mkWN (compoundN "laita" (k5A "kaupunki")) ; --UNCHK
lin outsmart_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin outsole_N = mkWN (compoundN "ulko" (k10 "pohja")) ; --UNCHK
lin outspan_V = mkWV (k52 "riisua") "valjaista" ; --UNCHK
lin outspan_V2 = mkWV2 (k52 "riisua") "valjaista" ; --UNCHK
lin outspoken_A = mkWA (k38 "suorasanainen") ;
lin outspokenness_N = mkWN (k40 "suoruus") ; --UNCHK
lin outspread_A = mkWA (k99 "levällään") ; --UNCHK
lin outstanding_A = mkA "erinomainen" ;
lin outstation_N = mkWN (k10 "asema") "syrjäinen" ; --UNCHK
lin outstay_V2 = mkWV2 (k52A "viipyä") "kauemmin" ; --UNCHK
lin outstretched_A = mkWA "ojennettu" ; --UNCHK
lin outstrip_V2 = mkV2 "ylittää" ;
lin outstroke_N = mkWN (compoundN "pako" (k1 "isku")) ; --UNCHK
lin outtake_N = mkWN (k39 "otos") "pois" "jätetty" ; --UNCHK
lin outthrust_N = mkWN (compoundN "kallio" (k48A "kieleke")) ; --UNCHK
lin outvote_V2 = mkWV2 (k53 "äänestää") "kumoon" ; --UNCHK
lin outward_A = mkWA (k38 "ulkoinen") ; --UNCHK
lin outward_Adv = mkWAdv (k99 "ulos") ; --UNCHK
lin outwardness_N = mkWN (compoundN "ulko" (k40 "naisuus")) ; --UNCHK
lin outwards_Adv = mkWAdv (k99 "ulos") ; --UNCHK
lin outwear_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin outweigh_V2 = mkV2 "ylittää" ; --mkWV2 (k56 "painaa") "enemmän" ;
lin outwit_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin ouzel_N = mkWN (k50 "mustarastas") ; --UNCHK
lin ouzo_N = mkWN (k1 "ouzo") ; --UNCHK
lin oval_A = mkWA (k6 "ovaali") ; --UNCHK
lin oval_N = mkWN (k6 "ovaali") ; --UNCHK
lin ovarian_A = mkWA "munasarja-" ; --UNCHK
lin ovaritis_N = mkWN (compoundN "munasarja" (k39 "tulehdus")) ; --UNCHK
lin ovary_N = mkWN (compoundN "muna" (k9 "sarja")) ; --UNCHK
lin ovate_A = mkWA (k6 "ovaali") ; --UNCHK
lin ovation_N = mkN "suosionosoitus" ;
lin oven_N = mkWN (k5 "uuni") ; --UNCHK
lin ovenbird_N = mkWN (compoundN "uuni" (k1A "lintu")) ; --UNCHK
lin over_Adv = mkAdv "ohi" | mkAdv "yli" ; ---- split
lin over_N = mkWN (compoundN "puolen" (k1A "vaihto")) ; --UNCHK
lin over_Prep = postPrep genitive "yli" ;
lin over_magazine_V2 = mkV2 "ylivarastoida" ; ---- ?
lin over_abundance_N = mkWN (k40 "liiallisuus") ; --UNCHK
lin overabundant_A = mkWA (k10 "vallitseva") ; --UNCHK
lin overachievement_N = mkWN (compoundN "yli" (k39 "suoritus")) ; --UNCHK
lin overachiever_N = mkWN (compoundN "yli" (k10 "suorittaja")) ; --UNCHK
lin overact_V = mkWV (k67A "liioitella") ; --UNCHK
lin overact_V2 = mkWV2 (k67A "liioitella") ; --UNCHK
lin overactive_A = mkWA (compoundA "yli" (k38 "aktiivinen")) ; --UNCHK
lin overactivity_N = mkWN (compoundN "yli" (k40 "aktiivisuus")) ; --UNCHK
lin overage_A = mkWA (compoundA "ikä" (k1A "loppu")) ; --UNCHK
lin overage_N = mkWN (compoundN "yli" (k10 "jäämä")) ; --UNCHK
lin overall_A = mkA "totaalinen" ;
lin overall_Adv = variants {} ; --
lin overall_N = mkN "haalari" ; ---
lin overambitious_A = mkWA (compoundA "kunnianhi" (k38 "moinen")) "liian" ; --UNCHK
lin overanxiety_N = mkWN (k40 "levottomuus") "liiallinen" ; --UNCHK
lin overanxious_A = mkWA (k34A "levoton") "liian" ; --UNCHK
lin overarch_V = mkWV (k52A "kaartua") "yli" ; --UNCHK
lin overarch_V2 = mkWV2 (k52A "kaartua") "yli" ; --UNCHK
lin overarm_A = mkWA "yliolan" ; --UNCHK
lin overawe_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin overbear_V2 = mkWV2 (k53 "supistaa") ; --UNCHK
lin overbearing_A = mkWA (k10 "määräilevä") ; --UNCHK
lin overbid_N = mkWN (k39 "tarjous") "korkeampi" ; --UNCHK
lin overbid_V = mkWV (k74 "tarjota") "liikaa" ; --UNCHK
lin overbid_V2 = mkWV2 (k74 "tarjota") "liikaa" ; --UNCHK
lin overbite_N = mkWN (compoundN "yli" (k9A "purenta")) ; --UNCHK
lin overblown_A = mkWA (k10 "oleva") "lakastumassa" ; --UNCHK
lin overboard_Adv = mkWAdv (k99 "yli") "laidan" ; --UNCHK
lin overbold_A = mkWA (k10 "nokkava") ; --UNCHK
lin overburden_N = mkWN (compoundN "yli" (k10 "kuorma")) ; --UNCHK
lin overburden_V2 = mkWV2 (compoundV "yli" (k53A "kuormittaa")) ; --UNCHK
lin overbusy_A = mkWA (k38 "kiireinen") "liian" ; --UNCHK
lin overcapitalization_N = mkWN (compoundN "pää" (k38 "omittaminen")) "liika" ; --UNCHK
lin overcareful_A = mkWA (compoundA "yli" (k38 "varovainen")) ; --UNCHK
lin overcast_A = mkWA (k10A "synkkä") ; --UNCHK
lin overcast_N = mkWN (compoundN "yli" (k1A "peitto")) ; --UNCHK
lin overcautious_A = mkWA (compoundA "yli" (k38 "varovainen")) ; --UNCHK
lin overcharge_N = mkWN (compoundN "yli" (k9A "hinta")) ; --UNCHK
lin overclothe_V2 = mkWV2 (compoundV "yli" (k58A "pukea")) ; --UNCHK
lin overcloud_V = mkWV (k54A "pimentää") ; --UNCHK
lin overcloud_V2 = mkWV2 (k54A "pimentää") ; --UNCHK
lin overcoat_N = mkWN (k17 "palttoo") ; --UNCHK
lin overcome_V = mkWV (k52A "selviytyä") ; --UNCHK
lin overcome_V2 = mkV2 "voittaa" ;
lin overcommit_V2 = mkV2 (mkV (mkV "sitoutua") "liikaa") ; ---- ?
lin overcompensation_N = mkWN (compoundN "yli" (k3 "kompensaatio")) ; --UNCHK
lin overconfidence_N = mkWN (k40 "varmuus") "liiallinen" ; --UNCHK
lin overconfident_A = mkWA (k9 "varma") "aivan" ; --UNCHK
lin overcook_V2 = mkWV2 (compoundV "yli" (k53A "keittää")) ; --UNCHK
lin overcredulity_N = mkWN "liika" "herkkäuskoisuus" ; --UNCHK
lin overcredulous_A = mkWA (compoundA "herkkä" (k38 "uskoinen")) "liian" ; --UNCHK
lin overcritical_A = mkWA (k10 "arvosteleva") "ankarasti" ; --UNCHK
lin overcrowd_V2 = mkV2 "liikakansoittaa" ;
lin overcurious_A = mkWA (compoundA "yli" (k41 "utelias")) ; --UNCHK
lin overdelicate_A = mkWA (compoundA "yli" (k10A "herkkä")) ; --UNCHK
lin overdo_V2 = mkWV2 (k67A "liioitella") ; --UNCHK
lin overdose_V = mkWV (k67 "kuolla") "yliannostukseen" ; --UNCHK
lin overdraft_N = mkWN (compoundN "tilin" (k39 "ylitys")) ; --UNCHK
lin overdraw_V = mkWV (k52A "ampua") "yli" ; --UNCHK
lin overdraw_V2 = mkWV2 (k52A "ampua") "yli" ; --UNCHK
lin overdress_V = mkWV (k52A "pukeutua") ; --UNCHK
lin overdress_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin overdrive_N = mkWN (compoundN "yli" (k48A "vaihde")) ; --UNCHK
lin overdue_A = mkWA (k10 "oleva") "myöhässä" ;
lin overeager_A = mkWA (compoundA "yli-" (k41A "innokas")) ; --UNCHK
lin overeat_V = mkWV (k61 "hotkia") ; --UNCHK
lin overemotional_A = mkWA (compoundA "yli" (k38 "tunteellinen")) ; --UNCHK
lin overemphasis_N = mkWN (compoundN "yli" (k39 "painotus")) ; --UNCHK
lin overemphasize_V = mkWV (k53A "painottaa") "liikaa" ; --UNCHK
lin overemphasize_V2 = mkWV2 (k53A "painottaa") "liikaa" ; --UNCHK
lin overenthusiastic_A = mkWA (compoundA "yli-" (k47 "innostunut")) ; --UNCHK
lin overestimate_N = mkWN (compoundN "yli" (k5A "arviointi")) ; --UNCHK
lin overestimate_V2 = mkWV2 (compoundV "yli" (k62 "arvioida")) ; --UNCHK
lin overexcited_A = mkWA (k47 "ylikiihottunut") ; --UNCHK
lin overexert_V2 = mkWV2 (k53A "rasittaa") "liiaksi" ; --UNCHK
lin overexertion_N = mkWN (compoundN "yli" (k39 "rasitus")) ; --UNCHK
lin overexploitation_N = mkWN (compoundN "liika" (k1A "käyttö")) ; --UNCHK
lin overexpose_V2 = mkWV2 (k52 "altistua") "liikaa" ; --UNCHK
lin overexposure_N = mkWN (compoundN "yli" (k39 "altistus")) ; --UNCHK
lin overfamiliar_A = mkWA (k38 "tuttavallinen") "liian" ; --UNCHK
lin overfeed_V = mkWV (k61A "ruokkia") "liikaa" ; --UNCHK
lin overfeed_V2 = mkWV2 (k61A "ruokkia") "liikaa" ; --UNCHK
lin overfeeding_N = mkWN (compoundN "yli" (k9A "ruokinta")) ; --UNCHK
lin overflight_N = mkWN (k1A "ylilento") ; --UNCHK
lin overflow_N = mkWN (k10 "tulva") ; --UNCHK
lin overflow_V = mkWV (k74 "pursuta") ; --UNCHK
lin overflow_V2 = mkWV2 (k74 "pursuta") ; --UNCHK
lin overfly_V2 = mkWV2 (k54A "lentää") "yli" ; --UNCHK
lin overfond_A = mkWA (compoundA "yli" (k10 "hellä")) ; --UNCHK
lin overfull_A = mkWA (compoundA "liika" (k9A "tarjonta")) ; --UNCHK
lin overgenerous_A = mkWA (k41 "aulis") ; --UNCHK
lin overgreedy_A = mkWA (k48 "ahne") "liian" ; --UNCHK
lin overgrowth_N = mkWN (compoundN "liika" (k1 "kasvu")) ; --UNCHK
lin overhand_A = mkWA "yliolan" ; --UNCHK
lin overhang_N = mkWN (k48A "uloke") ; --UNCHK
lin overhang_V = mkWV (k52A "riippua") ; --UNCHK
lin overhang_V2 = mkWV2 (k52A "riippua") ; --UNCHK
lin overhasty_A = mkWA (k38 "hätäinen") ; --UNCHK
lin overhaul_N = mkWN (k39 "saneeraus") ; --UNCHK
lin overhaul_V2 = mkWV2 (k53 "kunnostaa") ; --UNCHK
lin overhead_A = mkWA (k10 "oleva") "yläpuolella" ; --UNCHK
lin overhead_Adv = mkWAdv (k99 "päällä") "pään" ; --UNCHK
lin overhead_N = mkWN (compoundN "isku" (k5A "lyönti")) ; --UNCHK
lin overhear_V2 = mkWV2 (k67 "kuulla") "vahingossa" ; --UNCHK
lin overheat_V2 = mkWV2 (compoundV "yli" (k72 "kuumeta")) ; --UNCHK
lin overheating_N = mkWN (compoundN "liika" (k38 "kuumeneminen")) ; --UNCHK
lin overindulge_V = mkWV (k61 "hotkia") ; --UNCHK
lin overindulge_V2 = mkWV2 (k61 "hotkia") ; --UNCHK
lin overindulgence_N = mkWN (k2 "hemmottelu") ; --UNCHK
lin overindulgent_A = mkWA "hemmotteleva" ; --UNCHK
lin overjealous_A = mkWA (k38 "mustasukkainen") ; --UNCHK
lin overjoyed_A = mkWA (compoundA "iki" (k38 "onnellinen")) ; --UNCHK
lin overkill_N = mkWN (compoundN "yli" (k38 "ampuminen")) ; --UNCHK
lin overladen_A = mkWA (compoundA "yli" (k47 "kuormittunut")) ; --UNCHK
lin overland_A = mkWA "maa-" ; --UNCHK
lin overlap_N = mkWN (k9 "helma") ; --UNCHK
lin overlap_V = mkV (mkV "osua") "päällekkäin" ;
lin overlarge_A = mkWA (compoundA "yli" (k26 "suuri")) ; --UNCHK
lin overlay_N = mkWN (k39 "päällys") ; --UNCHK
lin overlay_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin overleaf_Adv = mkWAdv "kääntöpuolella" ; --UNCHK
lin overleap_V2 = mkWV2 (k73 "missata") ; --UNCHK
lin overlie_V = mkWV (k53A "tukahduttaa") ; --UNCHK
lin overlip_N = mkWN (compoundN "ylä" (k24 "huuli")) ; --UNCHK
lin overload_N = mkWN (compoundN "yli" (k10 "kuorma")) ; --UNCHK
lin overload_V2 = mkWV2 (k53A "rasittaa") ; --UNCHK
lin overlook_N = mkWN (compoundN "näköala" (k9A "paikka")) ; --UNCHK
lin overlook_V2 = mkV2 "ylenkatsoa" ;
lin overlord_N = mkWN (k40 "ylhäisyys") ; --UNCHK
lin overlordship_N = mkWN (k40 "herruus") ; --UNCHK
lin overly_Adv = mkWAdv (k99 "liikaa") ;
lin overmantel_N = mkWN (compoundN "takan" (k48 "koriste")) ; --UNCHK
lin overmaster_V2 = mkWV2 (k73 "murskata") ; --UNCHK
lin overmodest_A = mkWA (k1 "kaino") ; --UNCHK
lin overmuch_A = mkWA (k38 "liiallinen") ; --UNCHK
lin overmuch_Adv = mkWAdv (k99 "liikaa") ; --UNCHK
lin overnight_A = mkA (mkN "yön" (mkN "kestävä")) ;
lin overnight_Adv = mkWAdv (k99 "yli") "yön" ; --UNCHK
lin overnighter_N = mkWN (compoundN "matka" (k1A "laukku")) "pieni" ; --UNCHK
lin overpass_N = mkWN (compoundN "ylikulku" (k9A "silta")) ; --UNCHK
lin overpay_V = mkWV (k56 "maksaa") "liikaa" ; --UNCHK
lin overpay_V2 = mkWV2 (k56 "maksaa") "liikaa" ; --UNCHK
lin overpayment_N = mkWN (compoundN "liika" (k1 "maksu")) ; --UNCHK
lin overplant_V2 = mkV2 "liikasijoittaa" ; ---- ?
lin overplay_V2 = mkWV2 (k67A "liioitella") ; --UNCHK
lin overplus_N = mkWN (k10 "määrä") "yletön" ; --UNCHK
lin overpopulation_N = mkWN (k39 "ylikansoitus") ; --UNCHK
lin overpower_V2 = mkWV2 (k73 "murskata") ; --UNCHK
lin overpowering_A = mkWA (k10 "musertava") ; --UNCHK
lin overpraise_V2 = mkWV2 (k53 "ylistää") "liiaksi" ; --UNCHK
lin overpressure_N = mkWN (compoundN "yli" (k48 "paine")) ; --UNCHK
lin overprice_V2 = mkWV2 (compoundV "yli" (k67A "hinnoitella")) ; --UNCHK
lin overprint_N = mkWN (compoundN "lisä" (k10 "painama")) ; --UNCHK
lin overprint_V2 = mkWV2 (k56 "painaa") "päälle" ; --UNCHK
lin overproduce_V = mkWV (k53A "tuottaa") "liikaa" ; --UNCHK
lin overproduce_V2 = mkWV2 (k53A "tuottaa") "liikaa" ; --UNCHK
lin overproduction_N = mkWN (compoundN "yli" (k1A "tuotanto")) ; --UNCHK
lin overprotective_A = mkWA "ylisuojeleva" ; --UNCHK
lin overproud_A = mkWA (compoundA "yli" (k15 "ylpeä")) ; --UNCHK
lin overrate_V2 = mkWV2 (compoundV "yli" (k62 "arvioida")) ; --UNCHK
lin overreach_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin overreaching_A = mkWA "pilviä" "hipova" ; --UNCHK
lin overreact_V = mkWV (compoundV "yli" (k62 "reagoida")) ; --UNCHK
lin overreaction_N = mkWN (compoundN "yli" (k5A "reagointi")) ; --UNCHK
lin overrefined_A = mkWA (compoundA "yli" (k47 "hienostunut")) ; --UNCHK
lin override_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin override_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin overriding_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin over_ripe_A = mkWA (compoundA "yli" (k10 "kypsä")) ; --UNCHK
lin overrule_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin oversea_A = mkWA "valtamerentakainen" ; --UNCHK
lin oversea_Adv = mkWAdv (k99 "takana") "meren" ; --UNCHK
lin overseas_A = mkWA (k38 "ulkomainen") ; --f62
lin overseas_Adv = mkWAdv (k99 "takana") "meren" ;
lin oversee_V2 = mkV2 "tarkistaa" ;
lin overseer_N = mkWN (k10 "johtaja") ; --UNCHK
lin oversell_V2 = mkV2 "ylimainostaa" ;
lin oversensitive_A = mkWA (compoundA "yli" (k10A "herkkä")) ; --UNCHK
lin oversensitiveness_N = mkWN (compoundN "yli" (k40 "herkkyys")) ; --UNCHK
lin overserious_A = mkWA (k10 "vakava") "liian" ; --UNCHK
lin oversew_V2 = mkWV2 (k67A "luotella") "yhteen" ; --UNCHK
lin oversewn_A = mkWA "luotos-" ; --UNCHK
lin oversexed_A = mkWA (k38 "seksuaalinen") "erittäin" ; --UNCHK
lin overshadow_V2 = mkWV2 (k53 "varjostaa") ; --UNCHK
lin overshoe_N = mkWN (k5 "kalossi") ; --UNCHK
lin overshoot_N = mkWN (compoundN "yli" (k1 "lasku")) ; --UNCHK
lin overshoot_V2 = mkWV2 (k52A "ampua") "yli" ; --UNCHK
lin overside_Adv = mkWAdv (k99 "yli") "laidan" ; --UNCHK
lin oversight_N = mkWN (k39 "erehdys") ; --UNCHK
lin oversimplification_N = mkWN (compoundN "yks" (k38 "inkertaistaminen")) ; --UNCHK
lin oversimplify_V = mkV "yliyksinkertaistaa" ;
lin oversize_A = mkWA (compoundA "yli" (k26 "suuri")) ; --UNCHK
lin overskirt_N = mkWN (compoundN "päällys" (k48 "hame")) ; --UNCHK
lin oversolicitous_A = mkWA (compoundA "yli" (k38 "huolehtivainen")) ; --UNCHK
lin overspill_N = mkWN (k1A "vuoto") ; --UNCHK
lin overstate_V2 = mkV2 "liioitella" ;
lin overstatement_N = mkWN (k2 "liioittelu") ; --UNCHK
lin overstay_V2 = mkWV2 (k52A "viipyä") "kauemmin" ; --UNCHK
lin overstep_V2 = mkWV2 (k52A "tunkeutua") ; --UNCHK
lin overstock_V2 = mkWV2 (k62 "varastoida") "liikaa" ; --UNCHK
lin overstrain_N = mkWN (compoundN "liika" (k39 "rasitus")) ; --UNCHK
lin overstrain_V2 = mkV2 "ylirasittaa" ;
lin overstrung_A = mkWA (k10 "oleva") "kireällä" ; --UNCHK
lin overstuffed_A = mkWA (compoundA "pehmuste" (k1 "ttu")) "kokonaan" ; --UNCHK
lin oversubscribe_V2 = mkV2 "ylibuukata" ;
lin oversuspicious_A = mkWA (compoundA "epäluu" (k38 "loinen")) "tarpeettoman" ; --UNCHK
lin overt_A = mkWA (k38 "julkinen") ; --UNCHK
lin overtake_V2 = mkWV2 (k53A "tavoittaa") ; --UNCHK
lin overtax_V2 = mkWV2 (k53A "verottaa") "liikaa" ; --UNCHK
lin overthrow_N = mkWN "kaatuminen" ; --UNCHK
lin overthrow_V2 = mkV2 "kukistaa" ; --mkWV2 (k53A "peruuttaa") ;
lin overtime_Adv = mkWAdv "ylitöissä" ; --UNCHK
lin overtime_N = mkN "yliaika" ;
lin overtolerance_N = mkWN (k40 "suvaitsevaisuus") "liika" ; --UNCHK
lin overtone_N = mkWN (k39 "äänes") ; --UNCHK
lin overtop_V2 = mkWV2 (k66 "nousta") "yläpuolelle" ; --UNCHK
lin overture_N = mkWN (compoundN "alku" (k1A "soitto")) ; --UNCHK
lin overturn_N = mkWN (k39 "kumous") ; --UNCHK
lin overturn_V = mkWV (k53 "mullistaa") ; --UNCHK
lin overturn_V2 = mkWV2 (k53 "mullistaa") ;
lin overvaliant_A = mkWA (compoundA "yli" (k38 "urhoollinen")) ; --UNCHK
lin overvaluation_N = mkWN (compoundN "yli" (k39 "arvostus")) ; --UNCHK
lin overvalue_V2 = mkWV2 (compoundV "yli" (k62 "arvioida")) ; --UNCHK
lin overview_N = mkWN (compoundN "yleis" (k10 "kuva")) ; --UNCHK
lin overweening_A = mkWA (compoundA "yli" (k38 "mielinen")) ; --UNCHK
lin overweight_A = mkWA (k10 "pulska") ; --UNCHK
lin overweight_N = mkWN (k40 "paksuus") ; --UNCHK
lin overwhelm_V2 = mkV2 (mkV "pursuta") (mkPrep "yli") ;
lin overwhelming_A = mkA "ylitsevuotava" ;
lin overwork_N = mkWN (k19 "työ") "liika" ; --UNCHK
lin overwork_V2 = mkV2 (mkV (mkV "antaa") "liikaa töitä") (casePrep allative) ;
lin overwrought_A = mkWA (k99 "sekaisin") ; --UNCHK
lin overzealous_A = mkWA (k41A "raivokas") ; --UNCHK
lin oviduct_N = mkWN (compoundN "muna" (k7 "torvi")) ; --UNCHK
lin oviedo_PN = foreignPN "Oviedo" ;
lin ovine_A = mkWA "lammas-" ; --UNCHK
lin oviparous_A = mkWA (k38 "ovipaarinen") ; --UNCHK
lin ovipositor_N = mkWN (compoundN "munan" (k33A "asetin")) ; --UNCHK
lin oviraptorid_N = mkWN "oviraptor" ; --UNCHK
lin ovoid_A = mkWA (k6 "ovaali") ; --UNCHK
lin ovoid_N = mkWN (k48 "esine") "munanmuotoinen" ; --UNCHK
lin ovolo_N = mkWN (compoundN "pyörö" (k9 "lista")) ; --UNCHK
lin ovotestis_N = mkWN "ovotestis" ; --UNCHK
lin ovoviviparous_A = mkWA (compoundA "ovo" (k38 "vivipaarinen")) ; --UNCHK
lin ovular_A = mkWA "muna-" ; --UNCHK
lin ovulation_N = mkWN (k3 "ovulaatio") ; --UNCHK
lin ovule_N = mkWN (k10 "muna") "pieni" ; --UNCHK
lin ovum_N = mkWN (k10 "muna") ; --UNCHK
lin owe_V = mkWV (k67 "olla") "auki" ; --UNCHK
lin owe_V2 = mkV2 (mkV olla_V "velkaa") allative ;
lin owing_to_Prep = mkPrep "ansiosta" ;
lin owl_N = mkWN (k1 "pöllö") "Minervan" ; --UNCHK
lin owlet_N = mkWN (k1 "pöllö") "nuori" ; --UNCHK
lin owlish_A = mkWA (compoundA "pöllö" (k38 "mäinen")) ; --UNCHK
lin own_A = mkWA (k10 "oma") ;
lin own_V2 = mkV2 "omistaa" ;
lin own_up_V = mkWV (k53 "kakistaa") "ulos" ; --UNCHK
lin owner_N = mkN (lin NK {s = d10 "omistaja"}) ;
lin ownerless_A = mkWA (compoundA "omist" (k34A "ajaton")) ; --UNCHK
lin ownership_N = mkWN (k39 "omistus") ;
lin ox_N = mkWN (k10A "härkä") ; --UNCHK
lin oxacillin_N = mkWN "oksasilliini" ; --UNCHK
lin oxalacetate_N = mkWN (compoundN "oksalo" (k5A "asetaatti")) ; --UNCHK
lin oxalate_N = mkWN "oksalaatti" ; --UNCHK
lin oxalis_N = mkWN (compoundN "ketun" (k10A "leipä")) ; --UNCHK
lin oxazepam_N = mkWN "Serax" ; --UNCHK
lin oxbow_N = mkWN (k26 "härkäkaari") ; --UNCHK
lin oxeye_N = mkWN (compoundN "härän" (k10 "silmä")) ; --UNCHK
lin oxford_N = mkWN (compoundN "oxford-" (k10A "kenkä")) ; --UNCHK
lin oxford_PN = foreignPN "Oxford" ;
lin oxidant_N = mkWN (k33A "hapetin") ; --UNCHK
lin oxidase_N = mkWN (compoundN "oksid" (k5 "aasi")) ; --UNCHK
lin oxidation_N = mkWN (k39 "hapetus") ; --UNCHK
lin oxidative_A = mkWA "hapettava" ; --UNCHK
lin oxide_N = mkWN (k5 "oksidi") ; --UNCHK
lin oxidizable_A = mkWA "hapettuva" ; --UNCHK
lin oxidization_N = mkWN (k39 "hapetus") ; --UNCHK
lin oxidize_V = mkWV (k53A "hapettaa") ; --UNCHK
lin oxidize_V2 = mkWV2 (k53A "hapettaa") ; --UNCHK
lin oxime_N = mkWN "oksiimi" ; --UNCHK
lin oximeter_N = mkWN (compoundN "oksi" (k5 "metri")) ; --UNCHK
lin oxlip_N = mkWN "etelänkevätesikko" ; --UNCHK
lin oxonian_A = mkWA (compoundA "oxfordi" (k38 "lainen")) ; --UNCHK
lin oxonian_N = mkWN (compoundN "oxfordi" (k38 "lainen")) ; --UNCHK
lin oxtail_N = mkWN (compoundN "härän" (k10A "häntä")) ; --UNCHK
lin oxtant_N = mkWN "oktantti" ; --UNCHK
lin oxted_PN = foreignPN "Oxted" ;
lin oxtongue_N = mkWN (compoundN "keltano" (k2 "kitkerö")) ; --UNCHK
lin oxyacetylene_N = mkWN (compoundN "happi-" (k5 "asetyleeni")) ; --UNCHK
lin oxyacid_N = mkWN (compoundN "happi" (k1A "happo")) ; --UNCHK
lin oxycephaly_N = mkWN (compoundN "torni" (k1 "kallo")) ; --UNCHK
lin oxygen_N = mkWN (k7A "happi") ; --UNCHK
lin oxygenase_N = mkWN (compoundN "oksygen" (k5 "aasi")) ; --UNCHK
lin oxygenate_V2 = mkWV2 (k53 "ilmastaa") ; --UNCHK
lin oxygenation_N = mkWN (k39 "hapetus") ; --UNCHK
lin oxygenize_V2 = mkWV2 (k53 "ilmastaa") ; --UNCHK
lin oxyopia_N = mkWN "oksyopia" ; --UNCHK
lin oxyphenbutazone_N = mkWN "Tandearil" ; --UNCHK
lin oxyphencyclimine_N = mkWN "Daricon" ; --UNCHK
lin oxytetracycline_N = mkWN (compoundN "hydroksi" (k5 "tetrasykliini")) ; --UNCHK
lin oxytocic_N = mkWN (k48A "lääke") "synnytystä" "edistävä" ; --UNCHK
lin oxytocin_N = mkWN "Pitocin" ; --UNCHK
lin oxytone_N = mkWN (k9 "sana") "loppupainoinen" ; --UNCHK
lin oyabun_N = mkWN "oyabun" ; --UNCHK
lin oyster_N = mkWN (k6 "osteri") ; --UNCHK
lin oyster_bank_N = mkWN (compoundN "osteri" (k4A "matalikko")) ; --UNCHK
lin oyster_bar_N = mkWN (compoundN "osteri" (k12 "ravintola")) ; --UNCHK
lin oyster_bed_N = mkWN (compoundN "osteri" (k4A "matalikko")) ; --UNCHK
lin oyster_catcher_N = mkWN (compoundN "meri" (k14A "harakka")) ; --UNCHK
lin ozena_N = mkWN (compoundN "haju" (k10 "nenä")) ; --UNCHK
lin ozone_N = mkWN (k5 "otsoni") ; --UNCHK
lin ozonide_N = mkWN "otsonidi" ; --UNCHK
lin pa_N = mkWN (compoundN "kuulutus" (k1 "laitteisto")) ; --UNCHK
lin pabulum_N = mkWN (k1A "ravinto") ; --UNCHK
lin paca_N = mkWN "Cuniculus" "paca" ; --UNCHK
lin pace_N = mkN "tahti" ; --f62
lin pace_Prep = mkPrep elative "huolimatta" ;
lin pace_V = mkWV (k65 "käydä") "tasakäyntiä" ; --UNCHK
lin pace_V2 = mkWV2 (k65 "käydä") "tasakäyntiä" ; --UNCHK
lin pacemaker_N = mkWN (k10 "vetäjä") ; --UNCHK
lin pacer_N = mkWN (compoundN "tasa-" (k10 "astuja")) ; --UNCHK
lin pacesetter_N = mkWN (k10 "vetäjä") ; --UNCHK
lin pachinko_N = mkWN "pachinko" ; --UNCHK
lin pachisi_N = mkWN (compoundN "pach" (k5 "isi")) ; --UNCHK
lin pachuco_N = mkWN "pachuco" ; --UNCHK
lin pachycephalosaur_N = mkWN "pachycephalosaurus" ; --UNCHK
lin pachycheilia_N = mkWN "paksuhuulisuus" ; --UNCHK
lin pachyderm_N = mkWN (compoundN "paksu" (k9 "nahka")) ; --UNCHK
lin pachydermatous_A = mkWA (compoundA "paksu" (k38 "nahkainen")) ; --UNCHK
lin pachysandra_N = mkWN (compoundN "varjo" (k5A "yrtti")) ; --UNCHK
lin pachytene_N = mkWN (compoundN "nelirihma" (k48 "vaihe")) ; --UNCHK
lin pacific_A = mkA (separateN "Tyyneenmereen" (mkN "kuuluva")) ; --mkWA "Tyynenmeren" ;
lin pacific_PN = mkPN (mkN (mkN "tyyni" "tyyniä") L.sea_N) ;
lin pacification_N = mkWN (k9A "toiminta") "vastakumouksellinen" ; --UNCHK
lin pacifier_N = mkWN (k5A "huvitutti") ; --UNCHK
lin pacifism_N = mkWN (k5 "pasifismi") ; --UNCHK
lin pacifistFem_N = mkWN (k5 "pasifisti") ; --UNCHK
lin pacifistMasc_N = mkWN (k5 "pasifisti") ; --UNCHK
lin pacifistically_Adv = mkWAdv (k99 "pasifistisesti") ; --UNCHK
lin pacify_V2 = mkWV2 (k53A "rauhoittaa") ; --UNCHK
lin pacing_N = mkWN (k39 "askellus") ; --UNCHK
lin pack_N = mkWN (k5A "paketti") ; --UNCHK
lin pack_V = mkV "täyttyä" ; --mkWV (k61 "kääriä") ;
lin pack_V2 = mkV2 "pakata" partitive ; --mkWV2 (k61 "kääriä") ;
lin pack_animal_N = mkWN (compoundN "kuorma" (k10A "juhta")) ; --UNCHK
lin pack_away_V2 = mkV2 (advV OP_pack_V OP_away_Adv ) ; -- guess-p-verb
lin pack_in_V = advV OP_pack_V OP_in_Adv ; -- guess-p-verb
lin pack_in_V2 = prepV2 OP_pack_V OP_in_Prep ; -- guess-p-verb
lin pack_it_in_V = variants {} ; -- guess-p-verb
lin pack_off_V2 = prepV2 OP_pack_V OP_off_Prep ; -- guess-p-verb
lin pack_out_V2 = prepV2 OP_pack_V OP_out_Prep ; -- guess-p-verb
lin pack_up_V = advV OP_pack_V OP_up_Adv ; -- guess-p-verb
lin pack_up_V2 = prepV2 OP_pack_V OP_up_Prep ; -- guess-p-verb
lin packable_A = mkWA "pakattava" ; --UNCHK
lin package_N = mkN "pakkaus" "pakkauksen" "pakkauksia" ;
lin package_V2 = mkV2 "pakata" ;
lin packaging_N = mkWN (k39 "pakkaus") ; --UNCHK
lin packer_N = mkWN (k10 "vaeltaja") ; --UNCHK
lin packet_N = mkWN (compoundN "posti" (k48 "vene")) ; --UNCHK
lin packet_boat_N = mkWN (compoundN "posti" (k48 "vene")) ; --UNCHK
lin packhorse_N = mkWN (compoundN "kuorma" (k38 "hevonen")) ; --UNCHK
lin packing_N = mkWN (k10 "selässä") "kuljetus" ; --UNCHK
lin packing_case_N = mkWN (compoundN "pakki" (k4A "laatikko")) ; --UNCHK
lin packing_needle_N = mkWN (compoundN "säkki" (k9 "neula")) ; --UNCHK
lin packinghouse_N = mkWN (compoundN "lihan" (k2 "jalostamo")) ; --UNCHK
lin packrat_N = mkWN (compoundN "kauppias" (k10A "rotta")) ; --UNCHK
lin pack_saddle_N = mkWN (compoundN "kuorma" (k12 "satula")) ; --UNCHK
lin pack_thread_N = mkWN (compoundN "paketti" (k1 "naru")) ; --UNCHK
lin pact_N = mkWN (k39 "sopimus") ;
lin pad_N = mkWN (k12 "antura") ; --UNCHK
lin pad_V = mkWV (k53 "pehmustaa") ; --UNCHK
lin pad_V2 = mkWV2 (k53 "pehmustaa") ; --UNCHK
lin padasjoki_PN = mkPN (mkN "Padasjoki" "Padasjokia") ;
lin padauk_N = mkWN "Pterocarpus" "indicus" ; --UNCHK
lin padding_N = mkWN (k48A "pehmike") ; --UNCHK
lin paddle_N = mkWN (k9 "mela") ; --UNCHK
lin paddle_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin paddle_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin paddle_box_N = mkWN (k39 "suojus") "siipirattaan" ; --UNCHK
lin paddle_steamer_N = mkWN (compoundN "siipiratas" (k39 "alus")) ; --UNCHK
lin paddle_wheel_N = mkWN (compoundN "siipi" (k41A "ratas")) ; --UNCHK
lin paddlefish_N = mkWN (compoundN "lapa" (k7A "sampi")) ; --UNCHK
lin paddock_N = mkWN (compoundN "jaloittelu" (k48 "alue")) ; --UNCHK
lin paddy_N = mkWN (kH1 "riisi") ; --UNCHK
lin paddy_field_N = mkWN (compoundN "riisi" (k1A "pelto")) ; --UNCHK
lin paddy_wagon_N = mkWN (k51 "mustamaija") ; --UNCHK
lin pademelon_N = mkWN (compoundN "pikkuvall" (k5 "abi")) ; --UNCHK
lin padlock_N = mkWN (compoundN "muna" (k1A "lukko")) ; --UNCHK
lin padlock_V2 = mkWV2 (k58A "sulkea") "riippulukolla" ; --UNCHK
lin padova_PN = foreignPN "Padova" ;
lin padre_N = mkWN (k10 "isä") ; --UNCHK
lin padrone_N = mkWN (compoundN "työn" (k10 "välittäjä")) "italialaisten" "siirtolaisten" ; --UNCHK
lin paean_N = mkWN (k39 "ylistys") ; --UNCHK
lin paederasty_N = mkWN (k12 "pederastia") ; --UNCHK
lin paediatrics_N = mkWN (k12 "pediatria") ; --UNCHK
lin paella_N = mkWN (k13 "paella") ; --UNCHK
lin paeony_N = mkWN (kH1 "pioni") ; --UNCHK
lin pagan_A = mkWA (k38 "etninen") ; --UNCHK
lin pagan_N = mkWN (k12 "pakana") ; --UNCHK
lin paganism_N = mkWN (k40 "pakanuus") ; --UNCHK
lin page_N = mkN "sivu" ;
lin page_V2 = mkWV2 (k53A "kuuluttaa") ; --UNCHK
lin pageant_N = mkWN (k10 "näytelmä") "loistava" ; --UNCHK
lin pageantry_N = mkWN (k10 "näytelmä") "loistava" ; --UNCHK
lin pageboy_N = mkWN (compoundN "paaši" (k39 "kampaus")) ; --UNCHK
lin pagination_N = mkWN (k5A "numerointi") ; --UNCHK
lin paging_N = mkWN (k5A "numerointi") ; --UNCHK
lin pagoda_N = mkWN (k5 "pagodi") ; --UNCHK
lin pahautea_N = mkWN (compoundN "vuori" (k1A "mänty")) ; --UNCHK
lin pahoehoe_N = mkWN (compoundN "köysi" (k9 "laava")) ; --UNCHK
lin paid_A = variants {} ; --
lin pail_N = mkWN (k1A "sanko") ; --UNCHK
lin pailful_N = mkWN (k38 "ämpärillinen") ; --UNCHK
lin paillasse_N = mkWN (compoundN "olki" (k9 "patja")) ; --UNCHK
lin paimio_PN = mkPN "Paimio" ;
lin pain_N = mkWN (k1A "särky") | mkN "kipu" ;
lin pain_V2 = mkWV2 (k53A "satuttaa") ; --UNCHK
lin painful_A = mkWA (k10 "rasittava") ; --UNCHK
lin painfulness_N = mkWN (k40 "tuskallisuus") ; --UNCHK
lin painkiller_N = mkWN (k5A "analgeetti") ; --UNCHK
lin painless_A = mkWA (k34A "kivuton") ; --UNCHK
lin painstaking_A = mkWA (k38 "huolellinen") ; --UNCHK
lin paint_N = mkWN (k5A "pigmentti") ; --UNCHK
lin paint_V = mkV "maalata" ;
lin paint_V2 = mkV2 "maalata" ;
lin paint_V2A = L.paint_V2A ;
lin paintable_A = mkWA (compoundA "maalaus" (k38 "kelpoinen")) ; --UNCHK
lin paintball_N = mkWN (compoundN "värikuula" (k5 "peli")) ; --UNCHK
lin paintbox_N = mkWN (compoundN "väri" (k4A "laatikko")) ; --UNCHK
lin paintbrush_N = mkWN (k33A "sivellin") ; --UNCHK
lin painter_N = mkWN (k10 "puuma") ; --UNCHK
lin painterly_A = mkWA (k38 "maalauksellinen") ; --UNCHK
lin painting_N = mkN "maalaus" ;
lin pair_N = mkWN (kH1 "pari") ;
lin pair_V = mkWV (k53 "yhdistää") ; --UNCHK
lin pair_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin pair_off_V = mkWV (k52A "pariutua") ; --UNCHK
lin pair_off_V2 = mkWV2 (k52A "pariutua") ; --UNCHK
lin pairing_N = mkWN "parien" "muodostaminen" ; --UNCHK
lin paisa_N = mkWN "paisa" ; --UNCHK
lin paisley_N = mkWN (k9 "kašmirvilla") ; --UNCHK
lin paisley_PN = foreignPN "Paisley" ;
lin pajama_N = mkWN (k10 "pyjama") ; --UNCHK
lin pakistan_PN = foreignPN "Pakistan" ;
lin pakistaniFem_N = mkWN (compoundN "pakistani" (k38 "lainen")) ; --UNCHK
lin pakistaniMasc_N = mkWN (compoundN "pakistani" (k38 "lainen")) ; --UNCHK
lin pakistani_A = mkWA (compoundA "pakistani" (k38 "lainen")) ; --UNCHK
lin pal_N = mkWN (k10 "tuttava") ; --UNCHK
lin palace_N = mkWN (k5 "palatsi") ; --UNCHK
lin paladin_N = mkWN (k6 "sankari") ; --UNCHK
lin palaeolithic_A = mkWA "paleoliittinen" ; --UNCHK
lin palaeontologist_N = mkWN (compoundN "fossiili" (k12 "tutkija")) ; --UNCHK
lin palaeontology_N = mkWN (k12 "paleontologia") ; --UNCHK
lin palankeen_N = mkWN (compoundN "kanto" (k5 "tuoli")) ; --UNCHK
lin palanquin_N = mkWN (compoundN "kanto" (k5 "tuoli")) ; --UNCHK
lin palatability_N = mkWN (k40 "hyväksyttävyys") ; --UNCHK
lin palatable_A = mkWA (k41A "maukas") ; --UNCHK
lin palatal_A = mkWA "suulaki-" ; --UNCHK
lin palate_N = mkWN (k7A "kitalaki") ; --UNCHK
lin palatial_A = mkWA (k15 "upea") ; --UNCHK
lin palatinate_N = mkWN (compoundN "pfalzi" (k38 "lainen")) ; --UNCHK
lin palatine_A = mkWA "palatsin" ; --UNCHK
lin palatine_N = mkWN (compoundN "suulaen" (k18 "luu")) ; --UNCHK
lin palatoglossal_A = mkWA "suulaki-kieli-" ; --UNCHK
lin palatopharyngoplasty_N = mkWN (compoundN "uvulopalatofaryngopl" (k12 "astia")) ; --UNCHK
lin palaver_N = mkWN (k48 "puhe") "turha" ; --UNCHK
lin palaver_V = mkWV (k67A "neuvotella") ; --UNCHK
lin pale_A = mkWA (k15 "kelmeä") ; --UNCHK
lin pale_N = mkWN (k48 "säle") ; --UNCHK
lin pale_V = mkWV (k72 "vaaleta") ; --UNCHK
lin paleface_N = mkWN (k50 "kalpeanaama") ; --UNCHK
lin palembang_PN = foreignPN "Palembang" ;
lin paleness_N = mkWN (k40 "värittömyys") ; --UNCHK
lin paleoanthropological_A = mkWA (compoundA "paleo" (k38 "antropologinen")) ; --UNCHK
lin paleoanthropology_N = mkWN (compoundN "paleo" (k12 "antropologia")) ; --UNCHK
lin paleobiology_N = mkWN (compoundN "paleo" (k12 "biologia")) ; --UNCHK
lin paleobotany_N = mkWN (compoundN "paleo" (k9A "botaniikka")) ; --UNCHK
lin paleocerebellum_N = mkWN "paleoserebellum" ; --UNCHK
lin paleoclimatology_N = mkWN (compoundN "paleo" (k12 "klimatologia")) ; --UNCHK
lin paleocortical_A = mkWA "paleokorteksiin" "liittyvä" ; --UNCHK
lin paleodendrology_N = mkWN "paleodendrologia" ; --UNCHK
lin paleoecology_N = mkWN (compoundN "paleo" (k12 "ekologia")) ; --UNCHK
lin paleoethnography_N = mkWN (compoundN "paleo" (k12 "etnografia")) ; --UNCHK
lin paleogeography_N = mkWN (compoundN "paleomaan" (k48A "tiede")) ; --UNCHK
lin paleogeology_N = mkWN (compoundN "paleo" (k12 "geologia")) ; --UNCHK
lin paleographer_N = mkWN (compoundN "asian" (k12 "tuntija")) "paleografian" ; --UNCHK
lin paleography_N = mkWN "paleografia" ; --UNCHK
lin paleolith_N = mkWN (compoundN "kivi" (k48 "esine")) "paleoliittinen" ; --UNCHK
lin paleolithic_A = mkWA "paleoliittinen" ; --UNCHK
lin paleology_N = mkWN "paleologia" ; --UNCHK
lin paleomammalogy_N = mkWN (compoundN "pale" (k12 "zoologia")) ; --UNCHK
lin paleontological_A = mkWA (k38 "paleontologinen") ; --UNCHK
lin paleontologist_N = mkWN (compoundN "fossiili" (k12 "tutkija")) ; --UNCHK
lin paleontology_N = mkWN (k12 "paleontologia") ; --UNCHK
lin paleopathology_N = mkWN (compoundN "paleo" (k12 "patologia")) ; --UNCHK
lin paleornithology_N = mkWN (compoundN "pale" (k12 "ornitologia")) ; --UNCHK
lin paleozoology_N = mkWN (compoundN "paleo" (k12 "zoologia")) ; --UNCHK
lin palermo_PN = foreignPN "Palermo" ;
lin palestine_PN = foreignPN "Palestine" ;
lin palestinian_A = mkA "palestiinalainen" ;
lin palestinian_N = mkWN (k5 "arabi") "palestiinalainen" ; --UNCHK
lin palestra_N = mkWN "palaestra" ; --UNCHK
lin paletiology_N = mkWN (k12 "arkeologia") ; --UNCHK
lin palette_N = mkWN (k5A "paletti") ; --UNCHK
lin palette_knife_N = mkWN (compoundN "paletti" (k30 "veitsi")) ; --UNCHK
lin palfrey_N = mkWN (compoundN "ratsu" (k38 "hevonen")) ; --UNCHK
lin palilalia_N = mkWN "palilalia" ; --UNCHK
lin palimony_N = mkWN (compoundN "elatus" (k1A "apu")) "avopuolison" ; --UNCHK
lin palimpsest_N = mkWN "palimpsesti" ; --UNCHK
lin palindrome_N = mkWN (k5 "palindromi") ; --UNCHK
lin paling_N = mkWN (compoundN "säle" (k9A "aita")) ; --UNCHK
lin palingenesis_N = mkWN "rekapitulaatio" ; --UNCHK
lin palingenetic_A = mkWA (compoundA "palin" (k38 "geneettinen")) ; --UNCHK
lin palisade_N = mkWN (compoundN "paalu" (k9A "aita")) ; --UNCHK
lin palisade_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin palish_A = mkWA "kalpeahko" ; --UNCHK
lin pall_N = mkN "paariliina" ;
lin pall_V = mkWV (k52 "väsyä") ; --UNCHK
lin palladium_N = mkWN (k5 "palladium") ; --UNCHK
lin pallasite_N = mkWN "pallasiitti" ; --UNCHK
lin pallbearer_N = mkWN (k10 "kantaja") ; --UNCHK
lin pallet_N = mkWN (k5A "paletti") ; --UNCHK
lin pallette_N = mkWN (compoundN "kainalo" (k39 "suojus")) ; --UNCHK
lin palliasse_N = mkWN (compoundN "olki" (k9 "patja")) ; --UNCHK
lin palliate_V2 = mkWV2 (k53A "lievittää") ; --UNCHK
lin palliation_N = mkWN (compoundN "lie" (k38 "ventäminen")) ; --UNCHK
lin palliative_A = mkWA (k38 "palliatiivinen") ; --UNCHK
lin palliative_N = mkWN "lievittäjä" ; --UNCHK
lin pallid_A = mkWA (k15 "kelmeä") ; --UNCHK
lin pallidness_N = mkWN (k40 "hailakkuus") ; --UNCHK
lin pallium_N = mkWN "pallium" ; --UNCHK
lin pallone_N = mkWN "pallone" ; --UNCHK
lin pallor_N = mkWN (k40 "hailakkuus") ; --UNCHK
lin pally_A = mkWA (k99 "keskenään") "kamuja" ; --UNCHK
lin palm_1_N = mkWN (k12 "päkiä") ; --UNCHK
lin palm_2_N = mkWN (k12 "päkiä") ; --UNCHK
lin palm_3_N = mkWN (k12 "päkiä") ; --UNCHK
lin palm_V2 = mkWV2 (k53A "pitää") "kämmenellä" ; --UNCHK
lin palm_off_V = mkWV (k63 "myydä") "väkisin" ; --UNCHK
lin palm_off_V2 = mkWV2 (k63 "myydä") "väkisin" ; --UNCHK
lin palm_oil_N = mkWN (compoundN "palmu" (k1 "öljy")) ; --UNCHK
lin palmar_A = mkWA "jalkapohja-" ; --UNCHK
lin palmate_A = mkWA (compoundA "sormi" (k38 "halkoinen")) ; --UNCHK
lin palmatifid_A = mkWA (compoundA "sormi" (k38 "osainen")) ; --UNCHK
lin palmature_N = mkWN (compoundN "räpylämä" (k40 "isyys")) ; --UNCHK
lin palmetto_N = mkWN (compoundN "palmetto" (k1 "palmu")) ; --UNCHK
lin palmist_N = mkWN (compoundN "kädestä" (k10 "ennustaja")) ; --UNCHK
lin palmistry_N = mkWN "kädestä" "ennustaminen" ; --UNCHK
lin palmitin_N = mkWN "palmitiini" ; --UNCHK
lin palmlike_A = mkWA (compoundA "palmu" (k38 "mainen")) ; --UNCHK
lin palmy_A = mkWA (k10 "tuottoisa") ; --UNCHK
lin palmyra_N = mkWN (compoundN "viini" (k1 "palmu")) ; --UNCHK
lin palometa_N = mkWN (compoundN "perho" (k9 "kala")) ; --UNCHK
lin palomino_N = mkWN (compoundN "palomino-" (k38 "hevonen")) ; --UNCHK
lin paloverde_N = mkWN "Cercidium" ; --UNCHK
lin palpable_A = mkWA (k10 "selvä") ; --UNCHK
lin palpation_N = mkWN (k2 "tunnustelu") ; --UNCHK
lin palpatory_A = mkWA "palpaatioon" "liittyvä" ; --UNCHK
lin palpebrate_A = mkWA (compoundA "luo" (k38 "mellinen")) ; --UNCHK
lin palpebration_N = mkWN "räpyttely" ; --UNCHK
lin palpitant_A = mkWA (compoundA "väris" (k10 "evä")) ; --UNCHK
lin palpitate_V = mkWV (k53A "lepattaa") ; --UNCHK
lin palpitation_N = mkWN (k12 "vapina") ; --UNCHK
lin palsy_N = mkWN (k12 "tärinä") ; --UNCHK
lin palsy_V2 = mkWV2 (k53A "halvaannuttaa") ; --UNCHK
lin paltamo_PN = mkPN "Paltamo" ;
lin palter_V = mkWV (k53 "väistää") ; --UNCHK
lin paltriness_N = mkWN (k40 "surkeus") ; --UNCHK
lin paltry_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin pampas_N = mkWN (k9 "pampa") ; --UNCHK
lin pampas_grass_N = mkWN (compoundN "pampa" (k10 "heinä")) ; --UNCHK
lin pamper_V2 = mkWV2 (k61 "helliä") ; --UNCHK
lin pamperer_N = mkWN (compoundN "hemm" (k12 "ottelija")) ; --UNCHK
lin pamphlet_N = mkWN (k5A "pamfletti") ; --UNCHK
lin pamphleteerFem_N = mkWN "pamfletisti" ; --UNCHK ---- sense to be split
lin pamphleteerMasc_N = mkWN "pamfletisti" ; --UNCHK ---- sense to be split
lin pamphleteer_N = mkWN "pamfletisti" ; --UNCHK
lin pamplona_PN = foreignPN "Pamplona" ;
lin pan_N = mkWN (compoundN "Pan-" (k1A "suku")) ; --UNCHK
lin pan_V = mkWV (k53A "löylyttää") ; --UNCHK
lin pan_V2 = mkWV2 (k53A "löylyttää") ; --UNCHK
lin pan_out_V = mkWV (k52A "huuhtoa") ; --UNCHK
lin panacea_N = mkWN (compoundN "patentti" (k48A "lääke")) ; --UNCHK
lin panache_N = mkWN (k1A "töyhtö") ; --UNCHK
lin panama_N = mkWN (compoundN "panama" (k1A "hattu")) ; --UNCHK
lin panama_PN = foreignPN "Panama" ;
lin panamanian_A = mkWA (compoundA "panama" (k38 "lainen")) ; --UNCHK
lin panamanian_N = mkWN (compoundN "panama" (k38 "lainen")) ; --UNCHK
lin pancake_N = mkWN (k1A "lettu") ; --UNCHK
lin pancarditis_N = mkWN "pankardiitti" ; --UNCHK
lin pancreas_N = mkWN (k9 "haima") ; --UNCHK
lin pancreatic_A = mkWA "haima-" ; --UNCHK
lin pancreatin_N = mkWN "pankreatiini" ; --UNCHK
lin pancreatitis_N = mkWN (compoundN "haima" (k39 "tulehdus")) ; --UNCHK
lin pancytopenia_N = mkWN "pansytopenia" ; --UNCHK
lin panda_N = mkWN (k9 "panda") "red" ; --UNCHK
lin pandanus_N = mkWN (compoundN "kaira" (k1 "palmu")) ; --UNCHK
lin pandemic_A = mkWA (k38 "pandeeminen") ; --UNCHK
lin pandemic_N = mkWN (k12 "pandemia") ; --UNCHK
lin pandemonium_N = mkWN (k14A "mylläkkä") ; --UNCHK
lin pander_N = mkWN (k5 "sutenööri") ; --UNCHK
lin pander_V = mkWV (k61 "toimia") "sutenöörinä" ; --UNCHK
lin panderer_N = mkWN (k10 "parittaja") ; --UNCHK
lin pandiculation_N = mkWN (k2 "kiskottelu") ; --UNCHK
lin pandurate_A = mkWA "kaareutuva" ; --UNCHK
lin pane_N = mkWN (k1A "lappu") ; --UNCHK
lin panegyric_N = mkWN (k39 "ylistys") ; --UNCHK
lin panel_N = mkWN (compoundN "ohjaus" (k6 "paneeli")) ; --f90
lin panel_V2 = mkWV2 (k75 "nimetä") ; --UNCHK
lin paneled_A = mkWA (compoundA "panelo" (k1A "itu")) ; --UNCHK
lin paneling_N = mkWN (k1 "levy") ; --UNCHK
lin panelist_N = mkWN (k5 "panelisti") ; --UNCHK
lin panelling_N = mkWN (k1 "levy") ; --UNCHK
lin panencephalitis_N = mkWN (compoundN "yleis" (k39 "tulehdus")) "aivojen" ; --UNCHK
lin panfish_N = mkWN (compoundN "paistin" (k9 "kala")) ; --UNCHK
lin pang_N = mkWN (k1 "pisto") ; --UNCHK
lin panga_N = mkWN (compoundN "viidakko" (k30 "veitsi")) ; --UNCHK
lin pangolin_N = mkWN (compoundN "muurahais" (k1A "käpy")) ; --UNCHK
lin panhandle_N = mkWN (k28 "varsi") "paistinpannun" ; --UNCHK
lin panhandle_V = mkWV (k73 "pummata") ; --UNCHK
lin panhandler_N = mkWN (k38 "kerjäläinen") ; --UNCHK
lin panic_N = mkWN (k5A "paniikki") ; --f54
lin panic_V = mkV (mkV "joutua") "paniikkiin" ;
lin panic_V2 = mkV2 (mkV "hätääntyä") (casePrep elative) ;
lin panicky_A = mkWA (k10 "oleva") "peloissaan" ; --UNCHK
lin panicle_N = mkWN (k1 "röyhy") ; --UNCHK
lin panicled_A = mkWA (compoundA "röyhy" (k38 "mäinen")) ; --UNCHK
lin paniculate_A = mkWA (compoundA "röyhy" (k38 "mäinen")) ; --UNCHK
lin panjandrum_N = mkWN (k9 "herra") "suuri" ; --UNCHK
lin pannier_N = mkWN (compoundN "pönkkä" (k48 "hame")) ; --UNCHK
lin pannikin_N = mkWN (compoundN "pelti" (k5A "kuppi")) ; --UNCHK
lin panoplied_A = mkWA (compoundA "kori" (k47 "stautunut")) ; --UNCHK
lin panoply_N = mkWN (k40 "komeus") ; --UNCHK
lin panoptic_A = mkWA (k15 "leveä") ; --UNCHK
lin panopticon_N = mkWN "panoptikon" ; --UNCHK
lin panorama_N = mkWN (k9 "panoraama") ; --UNCHK
lin panoramic_A = mkWA "panoraama-" ; --UNCHK
lin panpipe_N = mkWN (compoundN "pan" (k1 "huilu")) ; --UNCHK
lin pansinusitis_N = mkWN (compoundN "pans" (k5A "inuiitti")) ; --UNCHK
lin pansy_N = mkWN (k6 "hinttari") ; --UNCHK
lin pant_N = mkWN (k1A "hengenveto") "nopea" ; --UNCHK
lin pant_V = mkWV (k53A "läähättää") ; --UNCHK
lin pant_V2 = mkWV2 (k53A "läähättää") ; --UNCHK
lin pantechnicon_N = mkWN (compoundN "muutto" (k1 "auto")) ; --UNCHK
lin pantheism_N = mkWN (k5 "panteismi") ; --UNCHK
lin pantheist_A = mkWA (k38 "panteistinen") ; --UNCHK
lin pantheist_N = mkWN (k5 "panteisti") ; --UNCHK
lin pantheistic_A = mkWA (k38 "panteistinen") ; --UNCHK
lin pantheon_N = mkWN (k6 "temppeli") "kaikkien" "jumalien" ; --UNCHK
lin panther_N = mkWN (k10 "puuma") ; --UNCHK
lin pantile_N = mkWN (compoundN "katto" (k23 "tiili")) "S-profiilinen" ; --UNCHK
lin panting_N = mkWN (k39 "huohotus") ; --UNCHK
lin panto_N = mkWN (k5 "pantomiimi") ; --UNCHK
lin pantograph_N = mkWN (compoundN "suhde" (k33A "piirrin")) ; --UNCHK
lin pantomime_N = mkWN (k5 "pantomiimi") ; --UNCHK
lin pantropical_A = mkWA (compoundA "pan" (k38 "trooppinen")) ; --UNCHK
lin pantry_N = mkWN (k6 "pentteri") ; --UNCHK
lin pantryman_N = mkWN (compoundN "hovi" (k6 "mestari")) ; --UNCHK
lin panzer_N = mkWN (compoundN "panssari" (k1 "vaunu")) ; --UNCHK
lin pap_N = mkWN (k5 "tissi") ; --UNCHK
lin papa_N = mkWN (k9A "pappa") ; --UNCHK
lin papacy_N = mkWN (k40 "paavius") ; --UNCHK
lin papain_N = mkWN "papaiini" ; --UNCHK
lin papal_A = mkWA (k38 "paavillinen") ; --UNCHK
lin paparazzo_N = mkWN "paparazzo" ; --UNCHK
lin papaverine_N = mkWN "Kavrin" ; --UNCHK
lin papaw_N = mkWN "papavi" ; --UNCHK
lin papaya_N = mkWN (k13 "papaija") ; --UNCHK
lin paper_N = L.paper_N ;
lin paper_V2 = mkWV2 (k62 "paperoida") ; --UNCHK
lin paper_chase_N = mkWN (compoundN "takaa-ajo" (k5 "peli")) ; --UNCHK
lin paperback_A = mkWA (compoundA "pehmeä" (k38 "kantinen")) ; --UNCHK
lin paperback_N = mkWN (k9 "kirja") "pehmeäkantinen" ; --UNCHK
lin paperbacked_A = mkWA (compoundA "pehmeä" (k38 "kantinen")) ; --UNCHK
lin paperboard_N = mkWN (k5 "pahvi") ; --UNCHK
lin paperboy_N = mkWN (compoundN "lehdenmyyjä" (k10A "poika")) ; --UNCHK
lin paperclip_N = mkWN (k6 "klemmari") ; --UNCHK
lin paperhanger_N = mkWN "tapetoija" ; --UNCHK
lin papering_N = mkWN (k5A "tapetointi") ; --UNCHK
lin paperknife_N = mkWN (compoundN "paperi" (k30 "veitsi")) ; --UNCHK
lin papermaking_N = mkWN (compoundN "paperin" (k39 "valmistus")) ; --UNCHK
lin paperweight_N = mkWN (compoundN "paperi" (k1 "paino")) ; --UNCHK
lin paperwork_N = mkWN (compoundN "paperi" (k10A "sota")) ; --UNCHK
lin papery_A = mkWA (k38 "paperinen") ; --UNCHK
lin papilla_N = mkWN (k5 "papilli") ; --UNCHK
lin papillary_A = mkWA (compoundA "nysty" (k38 "inen")) ; --UNCHK
lin papillate_A = mkWA (compoundA "nysty" (k38 "inen")) ; --UNCHK
lin papilledema_N = mkWN "papilledeema" ; --UNCHK
lin papilliform_A = mkWA (compoundA "nysty" (k38 "mäinen")) ; --UNCHK
lin papilloma_N = mkWN (k10 "papillooma") ; --UNCHK
lin papillon_N = mkWN (compoundN "perhos" (k10 "koira")) ; --UNCHK
lin papist_A = mkWA (k38 "katolilainen") ; --UNCHK
lin papist_N = mkWN "papisti" ; --UNCHK
lin papoose_N = mkWN (compoundN "intiaani" (k29 "lapsi")) ; --UNCHK
lin papovavirus_N = mkWN (compoundN "papova" (k39 "virus")) ; --UNCHK
lin pappose_A = mkWA (compoundA "sulka" (k38 "haiveninen")) ; --UNCHK
lin paprika_N = mkWN (compoundN "paprika" (k48 "jauhe")) ; --UNCHK
lin papuan_A = mkWA (compoundA "papu" (k38 "alainen")) ; --UNCHK
lin papuan_N = mkN "papualainen" ;
lin papule_N = mkWN (k12 "näppylä") ; --UNCHK
lin papulovesicle_N = mkWN (compoundN "vesi" (k12 "rakkula")) ; --UNCHK
lin papyrus_N = mkWN (compoundN "papyrus" (k1 "käärö")) ; --UNCHK
lin par_N = mkWN (k5 "par") ; --f60
lin par_excellence_Adv = mkWAdv (k99 "nimenomaan") ; --UNCHK
lin para_N = mkWN "Parán" "Belém" ; --UNCHK
lin parable_N = mkWN (k1A "satu") "opettavainen" ; --UNCHK
lin parabola_N = mkWN (k5 "paraabeli") ; --UNCHK
lin parabolic_A = mkWA (k38 "parabolinen") ; --UNCHK
lin parabolical_A = mkWA (k38 "parabolinen") ; --UNCHK
lin paraboloid_N = mkWN (k5 "paraboloidi") ; --UNCHK
lin paraboloidal_A = mkWA (compoundA "par" (k38 "aboloidinen")) ; --UNCHK
lin parachute_N = mkWN (compoundN "lasku" (k1 "varjo")) ; --UNCHK
lin parachute_V = mkWV (k73A "hypätä") "laskuvarjolla" ; --UNCHK
lin parachute_V2 = mkWV2 (k73A "hypätä") "laskuvarjolla" ; --UNCHK
lin parachutist_N = mkWN (compoundN "laskuvarjo" (k10 "hyppääjä")) ; --UNCHK
lin paracosm_N = mkWN (compoundN "mielikuvitus" (k13 "maailma")) ; --UNCHK
lin parade_N = mkWN (k39 "esitys") ;
lin parade_V = mkWV (k67 "kävellä") ; --UNCHK
lin parade_V2 = mkWV2 (k67 "kävellä") ; --UNCHK
lin parade_ground_N = mkWN (compoundN "paraati" (k10A "kenttä")) ; --UNCHK
lin paradiddle_N = mkWN (k12 "pärinä") ; --UNCHK
lin paradigm_N = mkWN (k10 "ruumiillistuma") ; --UNCHK
lin paradigmatic_A = mkWA (compoundA "par" (k38 "adigmaattinen")) ; --UNCHK
lin paradise_N = mkWN (k5 "paratiisi") ; --UNCHK
lin paradisiac_A = mkWA (compoundA "paratiisi" (k38 "mainen")) ; --UNCHK
lin paradisiacal_A = mkWA (compoundA "paratiisi" (k38 "mainen")) ; --UNCHK
lin paradox_N = mkWN (k5 "paradoksi") ; --UNCHK
lin paradoxical_A = mkWA (k38 "paradoksaalinen") ; --UNCHK
lin paraffin_N = mkWN (k5 "kerosiini") ; --UNCHK
lin parafovea_N = mkWN "parafovea" ; --UNCHK
lin paragon_N = mkWN (k48A "ihanne") ; --UNCHK
lin paragonite_N = mkWN (compoundN "parago" (k5A "niitti")) ; --UNCHK
lin paragraph_N = mkWN (k5 "paragrafi") ; --UNCHK
lin paragraph_V2 = mkWV2 (k53A "kirjoittaa") "artikkeleita" ; --UNCHK
lin paragrapher_N = mkWN (k10 "toimittaja") ; --UNCHK
lin paraguay_PN = foreignPN "Paraguay" ;
lin paraguayan_A = mkWA (compoundA "paraguay" (k38 "lainen")) ; --UNCHK
lin paraguayan_N = mkWN (compoundN "paraguay" (k38 "lainen")) ; --UNCHK
lin parakeet_N = mkWN (k9 "papukaija") ; --UNCHK
lin paralanguage_N = mkWN (k9A "viestintä") "paralingvistinen" ; --UNCHK
lin paraldehyde_N = mkWN "paraldehydi" ; --UNCHK
lin paralegal_N = mkWN (compoundN "asianajo" (k6 "sihteeri")) ; --UNCHK
lin paralepsis_N = mkWN (compoundN "ohi" (k38 "ttaminen")) ; --UNCHK
lin parallax_N = mkWN (k5 "parallaksi") ; --UNCHK
lin parallel_A = mkWA (compoundA "saman" (k38 "suuntainen")) ; --UNCHK
lin parallel_N = mkWN (k12 "analogia") ;
lin parallel_V2 = mkWV2 (k53 "yhdensuuntaistaa") ; --UNCHK
lin parallelepiped_N = mkWN (compoundN "suuntais" (k3 "särmiö")) ; --UNCHK
lin parallelism_N = mkWN (k1A "kerto") ; --UNCHK
lin parallelogram_N = mkWN (k41A "suunnikas") ; --UNCHK
lin paralogism_N = mkWN (compoundN "virhe" (k10 "päätelmä")) ; --UNCHK
lin paralyse_V2 = mkWV2 (k53A "halvauttaa") ; --UNCHK
lin paralysis_N = mkWN (k39 "halvaus") ; --UNCHK
lin paralytic_A = mkWA "halvaus-" ; --UNCHK
lin paralytic_N = mkWN (compoundN "halvaus" (k41 "potilas")) ; --UNCHK
lin paralyze_V2 = mkWV2 (k53A "halvauttaa") ; --UNCHK
lin paramagnet_N = mkWN (compoundN "para" (k5A "magneetti")) ; --UNCHK
lin paramagnetic_A = mkWA (compoundA "para" (k38 "magneettinen")) ; --UNCHK
lin paramagnetism_N = mkWN (compoundN "para" (k5 "magnetismi")) ; --UNCHK
lin paramedic_N = mkWN (k10 "hoitaja") ; --UNCHK
lin paramedical_A = mkWA "hoito-" ; --UNCHK
lin parameter_N = mkWN (k5 "parametri") ; --UNCHK
lin parametric_A = mkWA (compoundA "para" (k38 "metrinen")) ; --UNCHK
lin paramilitary_A = mkWA (compoundA "puoli" (k38 "sotilaallinen")) ; --UNCHK
lin paramilitary_N = mkWN (k4A "yksikkö") "puolisotilaallinen" ; --UNCHK
lin paramnesia_N = mkWN (compoundN "muisti" (k9 "harha")) ; --UNCHK
lin paramount_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin paramountcy_N = mkWN (k9A "valta") "ylin" ; --UNCHK
lin paramour_N = mkWN (k32A "rakastajatar") ; --UNCHK
lin paramyxovirus_N = mkWN (compoundN "paramykso" (k39 "virus")) ; --UNCHK
lin paranasal_A = mkWA (compoundA "paranasa" (k38 "alinen")) ; --UNCHK
lin parang_N = mkWN "parang" ; --UNCHK
lin paranoia_N = mkWN (k40 "vainoharhaisuus") ; --UNCHK
lin paranoiac_N = mkWN (k38 "ihminen") "vainoharhainen" ; --UNCHK
lin paranoid_A = mkWA (k38 "paranoidinen") ; --UNCHK
lin paranoid_N = mkWN (k38 "ihminen") "vainoharhainen" ; --UNCHK
lin paranormal_A = mkWA (compoundA "yli" (k38 "luonnollinen")) ; --UNCHK
lin paraparesis_N = mkWN "parapareesi" ; --UNCHK
lin parapet_N = mkWN (k48A "kaide") ; --UNCHK
lin paraph_N = mkWN (k2 "koukero") ; --UNCHK
lin paraphilia_N = mkWN "parafilia" ; --UNCHK
lin paraphrase_N = mkWN (k10 "muunnelma") ; --UNCHK
lin paraphrase_V2 = mkWV2 (k67 "muotoilla") "toisin" ; --UNCHK
lin paraphrastic_A = mkWA "mukaileva" ; --UNCHK
lin paraphysis_N = mkWN (compoundN "neste" (k9 "rihma")) ; --UNCHK
lin paraplegia_N = mkWN (compoundN "alaraaja" (k39 "halvaus")) ; --UNCHK
lin paraplegic_A = mkWA (compoundA "par" (k38 "apleginen")) ; --UNCHK
lin paraplegic_N = mkWN (compoundN "alaraajahalvaus" (k41 "potilas")) ; --UNCHK
lin parapodium_N = mkWN (k48A "jalake") ; --UNCHK
lin paraprofessional_N = mkWN (k10 "avustaja") ; --UNCHK
lin parapsychological_A = mkWA (compoundA "para" (k38 "psykologinen")) ; --UNCHK
lin parapsychologist_N = mkWN (compoundN "para" (k5 "psykologi")) ; --UNCHK
lin paraquat_N = mkWN (compoundN "parak" (k5A "vatti")) ; --UNCHK
lin parasail_N = mkWN (compoundN "veto" (k1 "varjo")) ; --UNCHK
lin parasailing_N = mkWN (compoundN "varjo" (k1A "liito")) ; --UNCHK
lin parasite_N = mkWN (k5A "parasiitti") ; --UNCHK
lin parasitemia_N = mkWN "parasitemia" ; --UNCHK
lin parasitic_A = mkWA (compoundA "epent" (k38 "eettinen")) ; --UNCHK
lin parasitical_A = mkWA "parasiittien" "aiheuttama" ; --UNCHK
lin parasitism_N = mkWN (compoundN "lois" (k10 "elämä")) ; --UNCHK
lin parasol_N = mkWN (compoundN "auringon" (k1 "varjo")) ; --UNCHK
lin parasympathetic_A = mkWA (compoundA "para" (k38 "sympaattinen")) ; --UNCHK
lin parasympathomimetic_A = mkWA (compoundA "parasympatomim" (k38 "eettinen")) ; --UNCHK
lin paratrooper_N = mkWN (compoundN "laskuvarjo" (k6 "jääkäri")) ; --UNCHK
lin paratyphoid_N = mkWN "pikkulavantauti" ; --UNCHK
lin parboil_V2 = mkWV2 (k53A "kiehauttaa") ; --UNCHK
lin parcel_N = mkWN (k40 "osuus") ; --UNCHK
lin parcel_V2 = mkWV2 (k61 "kääriä") ; --UNCHK
lin parcel_out_V = mkWV (k56A "jakaa") ; --UNCHK
lin parcellation_N = mkWN (compoundN "lohko" (k38 "minen")) ; --UNCHK
lin parch_V2 = mkWV2 (k53A "polttaa") ; --UNCHK
lin parchment_N = mkWN (k5A "pergamentti") ; --UNCHK
lin pardon_N = mkWN (compoundN "anteeksi" (k1A "anto")) ; --UNCHK
lin pardon_V2 = mkWV2 (k53A "armahtaa") ; --UNCHK
lin pardonable_A = mkWA (k10 "anteeksiannettava") ; --UNCHK
lin pardoner_N = mkWN (compoundN "ane" (k41 "kauppias")) ; --UNCHK
lin pare_V2 = mkV2 "leikata" partitive ;
lin pare_down_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin paregmenon_N = mkWN (k39 "rinnastus") ; --UNCHK
lin paregoric_N = mkWN (compoundN "ripuli" (k48A "lääke")) ; --UNCHK
lin parenchyma_N = mkWN (compoundN "perus" (k39 "kudos")) ; --UNCHK
lin parent_N = mkN "vanhempi" "vanhemman" "vanhempia" ;
lin parentage_N = mkWN (k26 "sukujuuri") ; --UNCHK
lin parental_A = mkA (separateN "vanhemmuuteen" (mkN "liittyvä")) ; --mkWA (k38 "isällinen") ;
lin parented_A = mkWA "vanhempien" "huoltama" ; --UNCHK
lin parenteral_A = mkWA (compoundA "ulko" (k38 "puolinen")) "ruoansulatuskanavan" ; --UNCHK
lin parenthesis_N = mkWN (compoundN "reuna" (k39 "huomautus")) ; --UNCHK
lin parenthetic_A = mkWA "lisä-" ; --UNCHK
lin parenthetical_A = mkWA "lisä-" ; --UNCHK
lin parenthood_N = mkWN (k40 "vanhemmuus") ; --UNCHK
lin parer_N = mkWN (compoundN "kuorima" (k30 "veitsi")) ; --UNCHK
lin paresis_N = mkWN (k39 "halvaus") "osittainen" ; --UNCHK
lin paresthesia_N = mkWN (compoundN "harha" (k39 "tuntemus")) ; --UNCHK
lin paretic_N = mkWN (k2 "henkilö") "pareettinen" ; --UNCHK
lin pareve_A = mkWA "parve" ; --UNCHK
lin parfait_N = mkWN (k48A "jäädyke") ; --UNCHK
lin pargas_PN = mkPN "Parainen" ;
lin parget_N = mkWN (k5 "laasti") ; --UNCHK
lin pargeting_N = mkWN (compoundN "stukki" (k39 "rappaus")) ; --UNCHK
lin parhelic_A = mkWA "sivuauringon" ; --UNCHK
lin parhelion_N = mkWN (compoundN "auringon" (k7A "sappi")) ; --UNCHK
lin pari_passu_Adv = mkWAdv "suhteessa" ; --UNCHK
lin pariah_N = mkWN (k6 "kulkuri") ; --UNCHK
lin pariah_dog_N = mkWN (compoundN "kulku" (k10 "koira")) ; --UNCHK
lin parietal_A = mkWA "päälaki-" ; --UNCHK
lin parikkala_PN = mkPN "Parikkala" ;
lin pari_mutuel_N = mkWN (k1 "toto") ; --UNCHK
lin paring_N = mkWN (kH1 "kuori") ; --UNCHK
lin paris_1_PN = mkPN "Pariisi" ;
lin paris_2_PN = foreignPN "Paris" ;
lin paris_PN = L.paris_PN ;
lin parish_N = mkWN (compoundN "seura" (k10A "kunta")) ; --UNCHK
lin parishioner_N = mkWN (compoundN "seura" (k38 "kuntalainen")) ; --UNCHK
lin parisian_A = mkWA (compoundA "pariisi" (k38 "lainen")) ; --UNCHK
lin parisian_N = mkWN (compoundN "pariisi" (k38 "lainen")) ; --UNCHK
lin parisology_N = mkWN (compoundN "moniselitte" (k40 "isyys")) ; --UNCHK
lin parity_N = mkWN (k40 "yhtäläisyys") ; --UNCHK
lin park_N = mkN "puisto" ;
lin park_V = mkWV (k62 "pysäköidä") ; --UNCHK
lin park_V2 = mkWV2 (k62 "pysäköidä") ; --UNCHK
lin parka_N = mkWN (k5A "anorakki") ; --UNCHK
lin parkano_PN = mkPN "Parkano" ;
lin parking_N = mkWN (k5A "pysäköinti") ; --UNCHK
lin parlance_N = mkWN (k26 "kieli") ; --UNCHK
lin parlay_N = mkWN (kH1 "veto") "uusi" ; --UNCHK
lin parley_N = mkWN (compoundN "sovinnon" (k9A "hieronta")) ; --UNCHK
lin parley_V = mkWV (k67A "neuvotella") ; --UNCHK
lin parliament_N = mkN "parlamentti" | mkN "edus" (mkN "kunta") ;
lin parliamentarian_N = mkWN (k4A "parlamentaarikko") ; --UNCHK
lin parliamentary_A = mkWA (k38 "parlamentaarinen") ; --UNCHK
lin parlor_N = mkWN (k5 "sali") ; --UNCHK
lin parlormaid_N = mkWN (k4A "sisäkkö") ; --UNCHK
lin parlour_N = mkWN (k5 "sali") ; --UNCHK
lin parlour_car_N = mkWN (compoundN "salonki" (k1 "vaunu")) ; --UNCHK
lin parlous_A = mkWA (k38 "vaarallinen") ; --UNCHK
lin parma_PN = foreignPN "Parma" ;
lin parmesan_N = mkWN "Parmesan" ; --UNCHK
lin parnassia_N = mkWN (k4A "vilukko") ; --UNCHK
lin parochial_A = mkWA "seurakunnan" ; --UNCHK
lin parochialism_N = mkWN (k40 "nurkkakuntaisuus") ; --UNCHK
lin parodist_N = mkWN "parodikko" ; --UNCHK
lin parody_N = mkWN (k5 "karikatyyri") ; --UNCHK
lin parody_V2 = mkWV2 (k62 "parodioida") ; --UNCHK
lin paroicous_A = mkWA (compoundA "yksi" (k38 "sukuinen")) ; --UNCHK
lin parola_PN = mkPN "Parola" ;
lin parole_N = mkWN (k40 "vapaus") "ehdonalainen" ; --UNCHK
lin paronychia_N = mkWN (compoundN "Paronychia-" (k1A "suku")) ; --UNCHK
lin paroquet_N = mkWN (k9 "papukaija") ; --UNCHK
lin parotid_A = mkWA "korvasylkirauhas-" ; --UNCHK
lin parotitis_N = mkWN (k39 "tulehdus") "korvasylkirauhasen" ; --UNCHK
lin paroxetime_N = mkWN "Paxil" ; --UNCHK
lin paroxysm_N = mkWN (k39 "kouristus") ; --UNCHK
lin paroxysmal_A = mkWA (k38 "kohtauksittainen") ; --UNCHK
lin paroxytone_N = mkWN (k9 "sana") ; --UNCHK
lin parquet_N = mkWN (compoundN "etu" (k1A "permanto")) ; --UNCHK
lin parquetry_N = mkWN (k5A "parketti") ; --UNCHK
lin parr_N = mkWN (k38 "poikanen") ; --UNCHK
lin parricide_N = mkWN (compoundN "isän" (k10 "murha")) ; --UNCHK
lin parrot_N = mkWN (k9 "papukaija") ; --UNCHK
lin parrotfish_N = mkWN (compoundN "papukaija" (k9 "kala")) ; --UNCHK
lin parrotlike_A = mkWA (compoundA "papukaija" (k38 "mainen")) ; --UNCHK
lin parry_N = mkWN (compoundN "vasta" (k1 "isku")) ; --UNCHK
lin parry_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin parse_V2 = mkWV2 (k54A "jäsentää") ; --UNCHK
lin parsec_N = mkWN (k5 "parsek") ; --UNCHK
lin parsee_N = mkWN (k28 "parsi") ; --UNCHK
lin parsimonious_A = mkWA (k5 "pihi") ; --UNCHK
lin parsimony_N = mkWN (k2 "kitsastelu") ; --UNCHK
lin parsley_N = mkWN (k12 "persilja") ; --UNCHK
lin parsnip_N = mkWN (k9A "palsternakka") ; --UNCHK
lin parson_N = mkWN (k6 "pastori") ; --UNCHK
lin parsonage_N = mkWN (k12 "pappila") ; --UNCHK
lin part_Adv = mkWAdv (k99 "osaksi") ; --UNCHK
lin part_N = mkN "osa" ;
lin part_Prep = S.part_Prep ;
lin part_V = mkWV (k56A "jakaa") ; --UNCHK
lin part_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin part_of_N2 = mkN2 (mkN "osa") (mkPrep elative) ;
lin part_time_A = mkA "osa-aikainen" ;
lin part_time_Adv = mkAdv "osa-aikaisesti" ;
lin partake_V = mkWV (k58 "koskea") ; --UNCHK
lin partake_V2 = mkWV2 (k58 "koskea") ; --UNCHK
lin partaker_N = mkWN (k10 "jakaja") ; --UNCHK
lin parterre_N = mkWN (k1A "permanto") ; --UNCHK
lin parthenocarpy_N = mkWN "partenokarpia" ; --UNCHK
lin parthenogenesis_N = mkWN (k5 "partenogeneesi") ; --UNCHK
lin parthenote_N = mkWN (k1 "solu") "partenogeneesin" ; --UNCHK
lin parthian_A = mkWA "parthian" ; --UNCHK
lin partial_A = mkWA (k38 "puolueellinen") ; ----ARB osittainen
lin partiality_N = mkWN (k40 "uskollisuus") ; --UNCHK
lin partialness_N = mkWN "osittaisuus" ; --UNCHK
lin partible_A = mkWA (k10 "jaettava") ; --UNCHK
lin participant_N = mkWN (k10 "osallistuja") ; --f59
lin participate_V = mkWV (k53A "ottaa") "osaa" ; --f59
lin participate_V2 = mkWV2 (k53A "ottaa") "osaa" ; --UNCHK
lin participation_N = mkWN (compoundN "osan" (k1A "otto")) ;
lin participatory_A = mkWA (k33 "avoin") "osallistumiselle" ; --UNCHK
lin participial_A = mkWA "partisiippi-" ; --UNCHK
lin participle_N = mkWN (k5A "partisiippi") ; --UNCHK
lin particle_N = mkWN (k6 "partikkeli") ; --UNCHK
lin particular_A = mkA "yksittäinen" ;
lin particular_N = mkWN (k10A "yksityiskohta") ; --UNCHK
lin particularism_N = mkWN (compoundN "partikular" (k5 "ismi")) ; --UNCHK
lin particularistic_A = mkWA (compoundA "par" (k38 "tikularistinen")) ; --UNCHK
lin particularity_N = mkWN (k40 "yksilöllisyys") ; --UNCHK
lin particularization_N = mkWN (k39 "kuvaus") "seikkaperäinen" ; --UNCHK
lin particularize_V = mkWV (k54A "tarkentaa") ; --UNCHK
lin particularize_V2 = mkWV2 (k54A "tarkentaa") ; --UNCHK
lin particulate_A = mkWA "hiukkas-" ; --UNCHK
lin particulate_N = mkWN (k38 "hiukkanen") ; --UNCHK
lin parting_N = mkWN (k2 "hyvästely") ; --UNCHK
lin partisan_A = mkWA "puolue-" ; --UNCHK
lin partisan_N = mkWN (compoundN "per" (k10 "tuska")) ; --UNCHK
lin partisanship_N = mkWN (k40 "uskollisuus") ; --UNCHK
lin partita_N = mkWN "partita" ; --UNCHK
lin partition_N = mkWN (k39 "ositus") ; --UNCHK
lin partition_V2 = mkWV2 (k56A "jakaa") "osiin" ; --UNCHK
lin partitionist_N = mkWN (k10 "kannattaja") "jaon" ; --UNCHK
lin partitive_A = mkWA "erottava" ; --UNCHK
lin partitive_N = mkWN (k5 "partitiivi") ; --UNCHK
lin partly_Adv = mkWAdv (k99 "osaksi") ;
lin partner_N = mkWN (k6 "partneri") | mkN "kumppani" ;
lin partner_V2 = mkWV2 (k53 "muodostaa") "kumppanuus" ; --UNCHK
lin partnership_N = mkN (lin NK {s = d40 "kumppanuus"}) ;
lin partridge_N = mkWN (compoundN "röyhelö" (k18 "pyy")) ; --UNCHK
lin partridgeberry_N = mkWN (compoundN "pyyn" (k9 "marja")) ; --UNCHK
lin parts_N = mkWN (k48 "alue") ; --UNCHK
lin part_song_N = mkWN (k1 "laulu") "moniääninen" ; --UNCHK
lin parturiency_N = mkWN (k39 "synnytys") ; --UNCHK
lin parturient_A = mkWA "synnytys-" ; --UNCHK
lin parturition_N = mkWN (k39 "synnytys") ; --UNCHK
lin party_1_N = mkN "juhla" ;
lin party_2_N = mkN "puolue" ;
lin party_spirit_N = mkWN (compoundN "puolue" (k7A "henki")) ; --UNCHK
lin party_wall_N = mkWN (compoundN "väli" (k10 "seinä")) ; --UNCHK
lin partygoer_N = mkWN (k12 "juhlija") ; --UNCHK
lin parvenu_A = mkWA (k38 "nousukasmainen") ; --UNCHK
lin parvenu_N = mkWN (k6 "pyrkyri") ; --UNCHK
lin parvis_N = mkWN (k4A "pylväikkö") ; --UNCHK
lin parvovirus_N = mkWN (compoundN "parvo" (k39 "virus")) ; --UNCHK
lin pas_N = mkWN (k99 "pas") ; --UNCHK
lin pascal_N = mkWN "Pascal" ; --UNCHK
lin paschal_A = mkWA "pääsiäis-" ; --UNCHK
lin pasha_N = mkWN "pašša" ; --UNCHK
lin pashto_N = mkWN (k5 "afgaani") ; --UNCHK
lin pasqueflower_N = mkWN (compoundN "kylmän" (k10A "kukka")) ; --UNCHK
lin pass_N = mkN "passi" ;
lin pass_V = mkV (mkV "päästä") "läpi" ;
lin pass_around_V2 = mkWV2 (k74 "juoruta") ; --UNCHK
lin pass_as_V2 = prepV2 OP_pass_V OP_as_Prep ; -- guess-p-verb
lin pass_away_V = mkWV (k75 "hävitä") ; --UNCHK
lin pass_back_V2 = mkV2 (advV OP_pass_V OP_back_Adv ) ; -- guess-p-verb
lin pass_by_V = mkWV (k53A "sivuuttaa") ; --UNCHK
lin pass_by_V2 = mkWV2 (k53A "sivuuttaa") ; --UNCHK
lin pass_down_V2 = prepV2 OP_pass_V OP_down_Prep ; -- guess-p-verb
lin pass_for_V2 = prepV2 OP_pass_V OP_for_Prep ; -- guess-p-verb
lin pass_off_V = mkWV (k53 "poistaa") ; --UNCHK
lin pass_off_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin pass_on_V = mkWV (k66 "ilmaista") ; --UNCHK
lin pass_on_V2 = mkWV2 (k66 "ilmaista") ; --UNCHK
lin pass_on_to_V2 = prepV2 (advV OP_pass_V OP_on_Adv ) OP_to_Prep ; -- guess-p-verb
lin pass_out_V = mkWV (k53A "menettää") "tajuntansa" ; --UNCHK
lin pass_out_V2 = mkWV2 (k53A "menettää") "tajuntansa" ; --UNCHK
lin pass_over_V = mkWV (k53A "jättää") "väliin" ; --UNCHK
lin pass_over_V2 = mkWV2 (k53A "jättää") "väliin" ; --UNCHK
lin pass_round_V2 = prepV2 OP_pass_V OP_round_Prep ; -- guess-p-verb
lin pass_through_V2 = mkWV2 (k67 "mennä") "läpi" ; --UNCHK
lin pass_to_V2 = prepV2 OP_pass_V OP_to_Prep ; -- guess-p-verb
lin pass_up_V2 = mkWV2 (k67 "olla") "välittämättä" ; --UNCHK
lin passable_A = mkWA (compoundA "kulku" (k38 "kelpoinen")) ; --UNCHK
lin passage_N = mkWN (k10 "siirtymä") ; --UNCHK
lin passageway_N = mkWN (k10 "käytävä") ; --UNCHK
lin passbook_N = mkWN (compoundN "pankki" (k9 "kirja")) ; --UNCHK
lin passenger_N = mkWN (k10 "matkustaja") ;
lin passer_N = mkWN (compoundN "Passer-" (k1A "suku")) | mkWN (compoundN "ohi" (k12 "kulkija")) ; --UNCHK
lin passerine_A = mkWA "varpuslintu-" ; --UNCHK
lin passerine_N = mkWN (compoundN "varpus" (k1A "lintu")) ; --UNCHK
lin passim_Adv = mkWAdv "eri" "kohdissa" "teosta" ; --UNCHK
lin passing_Adv = mkWAdv "pitkällisesti" ; --UNCHK
lin passing_N = mkN "päättyminen" ;
lin passion_N = mkN "intohimo" ;
lin passionate_A = mkWA (k38 "tulinen") ; --UNCHK
lin passion_flower_N = mkWN (compoundN "kärsimys" (k10A "kukka")) ; --UNCHK
lin passionless_A = mkWA (k34A "intohimoton") ; --UNCHK
lin passive_A = mkWA (k34A "toimeton") ; --UNCHK
lin passive_N = mkWN (k5 "passiivi") ; --UNCHK
lin passiveness_N = mkWN (k40 "passiivisuus") ; --UNCHK
lin passivity_N = mkWN (k40 "passiivisuus") ; --UNCHK
lin passkey_N = mkWN (compoundN "yleis" (k33 "avain")) ; --UNCHK
lin passover_N = mkWN (k10 "juhla") "happamattoman" "leivän" ; --UNCHK
lin passport_N = mkWN (k33 "avain") ; --UNCHK
lin password_N = mkN "salasana" ;
lin past_A = mkA "entinen" ;
lin past_Adv = mkWAdv (k99 "ohi") ; --UNCHK
lin past_N = mkN "menneisyys" ;
lin past_Prep = mkPrep "ohi" ;
lin pasta_N = mkWN (k9 "pasta") ;
lin paste_N = mkWN (k9 "tahna") ; --UNCHK
lin paste_V2 = mkWV2 (k62 "liisteröidä") ; --UNCHK
lin pasteboard_N = mkWN (k5A "kartonki") ; --UNCHK
lin pastel_A = mkWA "pastellin-" ; --UNCHK
lin pastel_N = mkWN (compoundN "pastelli" (k5 "väri")) ; --UNCHK
lin paster_N = mkWN (k9 "tarra") ; --UNCHK
lin pastern_N = mkWN (k38 "vuohinen") ; --UNCHK
lin pasteurization_N = mkWN (k5A "pastörointi") ; --UNCHK
lin pasteurize_V2 = mkWV2 (k62 "pastöroida") ; --UNCHK
lin pastiche_N = mkWN (k5 "pastissi") ; --UNCHK
lin pastille_N = mkWN (k5 "pastilli") ; --UNCHK
lin pastime_N = mkWN (k5 "huvi") ; --UNCHK
lin pastis_N = mkWN "pastis" ; --UNCHK
lin pastness_N = mkWN (k40 "menneisyys") ; --UNCHK
lin pastor_N = mkWN (compoundN "Pastor-ala" (k1A "suku")) ; --UNCHK
lin pastoral_A = mkWA (k38 "pastoraalinen") ; --UNCHK
lin pastoral_N = mkWN (k5 "pastoraali") ; --UNCHK
lin pastorale_N = mkWN (k5 "pastoraali") ; --UNCHK
lin pastorate_N = mkWN (k9A "virka") "kirkkoherran" ; --UNCHK
lin pastorship_N = mkWN (k9A "virka") "kirkkoherran" ; --UNCHK
lin pastrami_N = mkWN (compoundN "savu" (k9 "liha")) ; --UNCHK
lin pastry_N = mkWN (k38 "leivonnainen") ; --UNCHK
lin pastry_cook_N = mkWN (k6 "kondiittori") ; --UNCHK
lin pasturage_N = mkWN (k4A "nurmikko") ; --UNCHK
lin pasture_N = mkWN (k4A "nurmikko") ; --UNCHK
lin pasture_V = mkWV (k54A "vaeltaa") ; --UNCHK
lin pasture_V2 = mkWV2 (k54A "vaeltaa") ; --UNCHK
lin pasty_A = mkWA (k15 "tahmea") ; --UNCHK
lin pasty_N = mkWN (compoundN "nännin" (k39 "suojus")) ; --UNCHK
lin pat_A = mkWA (k10 "sopiva") ; --UNCHK
lin pat_Adv = mkWAdv (k99 "täydellisesti") ; --UNCHK
lin pat_N = mkN "taputus" ;
lin pat_V = mkWV (k53A "taputtaa") ; --UNCHK
lin pat_V2 = mkWV2 (k53A "taputtaa") ; --UNCHK
lin pataca_N = mkWN "pataca" ; --UNCHK
lin patas_N = mkWN (compoundN "husaari" (k12 "apina")) ; --UNCHK
lin patch_N = mkWN (k6 "laastari") ; --UNCHK
lin patch_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin patch_pocket_N = mkWN (compoundN "paikka" (k1 "tasku")) ; --UNCHK
lin patch_up_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin patchcord_N = mkWN (compoundN "kytkentä" (k1A "johto")) ; --UNCHK
lin patchiness_N = mkWN (compoundN "epä" (k40 "tasaisuus")) ; --UNCHK
lin patching_N = mkWN (k39 "paikkaus") ; --UNCHK
lin patchouli_N = mkWN "patsuli" ; --UNCHK
lin patchwork_N = mkWN (compoundN "tilkku" (k19 "työ")) ; --UNCHK
lin patchy_A = mkWA (k38 "hajanainen") ; --UNCHK
lin pate_1_N = mkWN (k7A "päälaki") ; --UNCHK ---- sense to be split
lin pate_2_N = mkWN (k7A "päälaki") ; --UNCHK ---- sense to be split
lin pate_N = mkWN (k7A "päälaki") ; --UNCHK
lin pate_de_foie_gras_N = mkWN (compoundN "hanhenmaksa" (k12 "pasteija")) ; --UNCHK
lin patella_N = mkWN (compoundN "Patella-" (k1A "suku")) ; --UNCHK
lin patellar_A = mkWA "polvilumpio-" ; --UNCHK
lin patency_N = mkWN (k40 "havaittavuus") ; --UNCHK
lin patent_A = mkWA (k10 "selvä") ; --UNCHK
lin patent_N = mkN "patentti" ;
lin patent_V2 = mkWV2 (k64 "tuoda") "esiin" ; --UNCHK
lin patentee_N = mkWN (compoundN "patentin" (k12 "haltija")) ; --UNCHK
lin pater_N = mkWN (compoundN "isä" (k1A "ukko")) ; --UNCHK
lin paterfamilias_N = mkWN (k9A "patriarkka") ; --UNCHK
lin paternal_A = mkWA (k38 "isällinen") ; --UNCHK
lin paternalism_N = mkWN (compoundN "paternal" (k5 "ismi")) ; --UNCHK
lin paternalistic_A = mkWA "holhoava" ; --UNCHK
lin paternity_N = mkWN (k40 "henkilöllisyys") "kirjoittajan" ; --UNCHK
lin paternoster_N = mkWN (compoundN "paternoster" (k5 "hissi")) ; --UNCHK
lin path_N = mkN "polku" ;
lin pathetic_A = mkWA (k1 "hupsu") ; --UNCHK
lin pathless_A = mkWA (k34A "koskematon") ; --UNCHK
lin pathogen_N = mkWN (compoundN "pato" (k5 "geeni")) ; --UNCHK
lin pathogenesis_N = mkWN (k1A "synty") "taudin" ; --UNCHK
lin pathogenically_Adv = mkWAdv "patogeenisesti" ; --UNCHK
lin pathological_A = mkWA (k38 "patologinen") ; --UNCHK
lin pathologist_N = mkWN (k5 "patologi") ; --UNCHK
lin pathology_N = mkWN (k12 "patologia") ; --UNCHK
lin pathos_N = mkWN (k40 "järkyttävyys") ; --UNCHK
lin pathway_N = mkWN (k1A "polku") ; --UNCHK
lin patience_N = mkN "kärsivällisyys" ;
lin patient_A = mkWA (k38 "kärsivällinen") ; --UNCHK
lin patient_N = mkWN "potilas" ;
lin patina_N = mkWN (k12 "patina") ; --UNCHK
lin patio_N = mkWN (k5 "terassi") ; --UNCHK
lin patisserie_N = mkWN (k12 "konditoria") ; --UNCHK
lin patka_N = mkWN "patka" ; --UNCHK
lin patois_N = mkWN (compoundN "paikallis" (k48A "murre")) ; --UNCHK
lin patrial_N = mkWN (k2 "henkilö") "kansalaisoikeuksia" "nauttiva" ; --UNCHK
lin patriarch_N = mkWN (k9A "patriarkka") ; --UNCHK
lin patriarchal_A = mkWA (k38 "patriarkaalinen") ; --UNCHK
lin patriarchate_N = mkWN (k5A "patriarkaatti") ; --UNCHK
lin patriarchic_A = mkWA (k38 "patriarkaalinen") ; --UNCHK
lin patriarchy_N = mkWN (k5A "patriarkaatti") ; --UNCHK
lin patricentric_A = mkWA (compoundA "isä" (k38 "keskeinen")) ; --UNCHK
lin patrician_A = mkWA (k39 "ylimys") ; --UNCHK
lin patrician_N = mkWN (k5 "patriisi") ; --UNCHK
lin patricide_N = mkWN (compoundN "isän" (k10 "murha")) ; --UNCHK
lin patrilineage_N = mkWN (k40 "sukulaisuus") "isänpuoleinen" ; --UNCHK
lin patrilineal_A = mkWA (compoundA "patrilinea" (k38 "alinen")) ; --UNCHK
lin patrimonial_A = mkWA (k10 "oleva") "siirrettävissä" ; --UNCHK
lin patrimony_N = mkWN (k1A "perintö") ; --UNCHK
lin patriot_N = mkWN (k5A "patriootti") ; --UNCHK
lin patriotic_A = mkWA (compoundA "isän" (k38 "maallinen")) ; --UNCHK
lin patriotism_N = mkWN (compoundN "kansallis" (k48A "tunne")) ; --UNCHK
lin patristic_A = mkWA (compoundA "kirkkois" (k32A "ien")) ; --UNCHK
lin patrol_N = mkN "partio" ; --mkWN (k5A "partiointi") ;
lin patrol_V = mkWV (k52 "valvoa") ; --UNCHK
lin patrol_V2 = mkWV2 (k52 "valvoa") ; --UNCHK
lin patroller_N = mkWN (k12 "vartija") ; --UNCHK
lin patrolman_N = mkWN (k6 "poliisi") ; --UNCHK
lin patron_N = mkN "omistaja" ; ---ARB --mkWN (compoundN "kanta-" (k41A "asiakas")) ;
lin patronage_N = mkWN (compoundN "asiakas" (k10A "kunta")) ; --UNCHK
lin patroness_N = mkWN (k10 "omistaja") ; --UNCHK
lin patronize_V2 = mkWV2 (k67 "olla") "asiakkaana" ; --UNCHK
lin patronizing_A = mkWA (k10 "alentuva") ; --UNCHK
lin patronymic_A = mkWA (compoundA "muodoste" (k1 "ttu")) "isännimestä" ; --UNCHK
lin patronymic_N = mkWN (k5 "patronyymi") ; --UNCHK
lin patten_N = mkWN (k41A "hollannikas") ; --UNCHK
lin patter_N = mkWN (k12 "pulina") ; --UNCHK
lin patter_V = mkWV (k53A "tepsuttaa") ; --UNCHK
lin patter_V2 = mkWV2 (k53A "tepsuttaa") ; --UNCHK
lin pattern_N = mkN "kuvio" ;
lin pattern_V2 = mkV2 "mallintaa" ; ---ARB ; kuvioida
lin patternmaker_N = mkWN (compoundN "malli" (k10A "seppä")) ; --UNCHK
lin patty_N = mkWN (k38 "makeinen") ; --UNCHK
lin patzer_N = mkWN (k10 "pelaaja") "huono" ; --UNCHK
lin paucity_N = mkWN (k40 "niukkuus") ; --UNCHK
lin paul_PN = foreignPN "Paul" ;
lin paunch_N = mkWN (k5 "pötsi") ; --UNCHK
lin paunchiness_N = mkWN (k40 "vatsakkuus") ; --UNCHK
lin paunchy_A = mkWA (k41A "vatsakas") ; --UNCHK
lin pauper_N = mkWN (k10 "köyhä") ; --UNCHK
lin pauperism_N = mkWN (k40 "köyhyys") ; --UNCHK
lin pauperization_N = mkWN "köyhdyttäminen" ; --UNCHK
lin pause_N = mkWN (k1A "tauko") ; --UNCHK
lin pause_V = mkWV (k53A "pitää") "tauko" ; --UNCHK
lin pause_V2V = mkWV2V (k53A "pitää") "tauko" ; --UNCHK
lin pause_VS = mkWVS (k53A "pitää") "tauko" ; --UNCHK
lin pavage_N = mkWN (compoundN "pää" (k38 "llystäminen")) ; --UNCHK
lin pavane_N = mkWN "pavana" ; --UNCHK
lin pave_N = mkWN (k39 "päällystys") ; --UNCHK
lin pave_V2 = mkWV2 (k53 "päällystää") ;
lin pavement_N = mkWN (k39 "kiveys") ; --UNCHK
lin pavilion_N = mkWN (k5A "paviljonki") ; --UNCHK
lin paving_N = mkWN (compoundN "pää" (k38 "llystäminen")) ; --UNCHK
lin paving_stone_N = mkWN (compoundN "kivi" (k9A "laatta")) ; --UNCHK
lin pavior_N = mkWN (kH1 "juntta") ; --UNCHK
lin pavis_N = mkWN (k7A "kilpi") ; --UNCHK
lin pavlova_N = mkWN (compoundN "marenki" (k39 "leivos")) ; --UNCHK
lin pavonia_N = mkWN "Pavonia" ; --UNCHK
lin paw_N = mkWN (k11 "käpälä") ; --UNCHK
lin paw_V = mkWV (k68 "käpälöidä") ; --UNCHK
lin paw_V2 = mkWV2 (k68 "käpälöidä") ; --UNCHK
lin pawer_N = mkWN "käpälöijä" ; --UNCHK
lin pawky_A = mkWA (k10 "ovela") ; --UNCHK
lin pawl_N = mkWN (k48A "pidäke") ; --UNCHK
lin pawn_N = mkWN (k39 "panttaus") ;
lin pawn_V2 = mkWV2 (k53A "kanittaa") ; --UNCHK
lin pawn_ticket_N = mkWN (compoundN "pantti" (k5A "kuitti")) ; --UNCHK
lin pawnbroker_N = mkWN (k10 "pitäjä") "panttilainaamon" ; --UNCHK
lin pawnshop_N = mkWN (kH1 "kani") ; --UNCHK
lin pawpaw_N = mkWN "papavi" ; --UNCHK
lin pax_N = mkWN (k9 "rauha") "Herran" ; --UNCHK
lin pax_romana_N = mkWN "Pax" "Romana" ; --UNCHK
lin pay_N = mkN "palkka" ;
lin pay_V = mkV "kannattaa" ;
lin pay_V2 = mkV2 "maksaa" ;
lin pay_V2V = mkV2V (mkV "maksaa") accusative infIllat ; ---- subcat ("maksan hänet laulamaan"? if you have better ideas go ahead and change!)
lin pay_V3 = mkV3 (mkV "osoittaa") (mkPrep partitive) (mkPrep allative) ; --osoittaa huomiota hänelle
lin pay_as_you_earn_N = mkWN (compoundN "ennakon" (k39 "pidätys")) ; --UNCHK
lin pay_back_V = mkWV (k56 "maksaa") ; --UNCHK
lin pay_back_V2 = mkWV2 (k56 "maksaa") ; --UNCHK
lin pay_claim_N = mkWN (compoundN "palkka" (k39 "vaatimus")) ; --UNCHK
lin pay_down_V2 = prepV2 OP_pay_V OP_down_Prep ; -- guess-p-verb
lin pay_for_V3 = mkWV3 (k54A "kustantaa") ; --UNCHK
lin pay_into_V3 = variants {} ; -- guess-p-verb
lin pay_off_V = mkV (mkV "tuottaa") "tulosta" ;
lin pay_off_V2 = prepV2 OP_pay_V OP_off_Prep ; -- guess-p-verb
lin pay_out_V = mkWV (k53A "suorittaa") "maksu" ; --UNCHK
lin pay_packet_N = mkWN (compoundN "palkka" (k5 "pussi")) ; --UNCHK
lin pay_up_V = mkWV (k56 "maksaa") "osuutensa" ; --UNCHK
lin payable_A = mkWA "maksettava" ;
lin payback_N = mkWN (k1 "kosto") ; --UNCHK
lin paycheck_N = mkWN (compoundN "palkka" (k5A "sekki")) ; --UNCHK
lin payday_N = mkWN (compoundN "palkka" (k10 "päivä")) ; --UNCHK
lin payee_N = mkWN (k10 "saaja") "maksun" ; --UNCHK
lin payer_N = mkWN (k10 "maksaja") ; --UNCHK
lin payload_N = mkWN (k39 "lähetys") ; --UNCHK
lin paymaster_N = mkWN (compoundN "kassan" (k10 "hoitaja")) ; --UNCHK
lin payment_N = mkN "maksu" ;
lin paynim_N = mkWN (k12 "pakana") ; --UNCHK
lin payoff_N = mkWN (k1A "palkinto") ; --UNCHK
lin payola_N = mkWN (k39 "lahjus") ; --UNCHK
lin payroll_N = mkWN "palkkakirjanpito" ; --UNCHK
lin paysheet_N = mkWN (compoundN "palkka" (k9 "lista")) ; --UNCHK
lin payslip_N = mkWN (compoundN "tili" (k9 "nauha")) ; --UNCHK
lin pe_N = mkWN "pe" ; --UNCHK
lin pea_N = mkWN (k48 "herne") ; --UNCHK
lin pea_flour_N = mkWN (compoundN "herne" (k1 "jauho")) ; --UNCHK
lin pea_green_N = mkWN (compoundN "kelta" (k15 "vihreä")) "kirkkaan" ; --UNCHK
lin pea_jacket_N = mkWN (compoundN "merimies" (k5A "takki")) ; --UNCHK
lin pea_soup_N = mkWN (compoundN "herne" (k1A "keitto")) ; --UNCHK
lin peace_N = L.peace_N ;
lin peace_offering_N = mkWN (k48 "ele") "sovinnon" ; --UNCHK
lin peaceable_A = mkWA (k38 "rauhallinen") ; --UNCHK
lin peaceableness_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin peaceful_A = mkWA (k38 "rauhallinen") ;
lin peacefulness_N = mkWN (k40 "tyyneys") ; --UNCHK
lin peacehaven_PN = foreignPN "Peacehaven" ;
lin peacekeeper_N = mkN "rauhanturvaaja" ;
lin peacekeeping_A = mkWA "rauhanturva-" ; --UNCHK
lin peacekeeping_N = mkWN (compoundN "rauhanturva" (k10 "tehtävä")) ; --UNCHK
lin peacemaker_N = mkWN (compoundN "Browning-konekiv" (k26 "ääri")) ; --UNCHK
lin peacetime_N = mkWN (kH1 "aika") "rauhan" ; --UNCHK
lin peach_N = mkWN (k5 "aprikoosi") ; --UNCHK
lin peach_V = mkWV (k62 "vasikoida") ; --UNCHK
lin peach_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin peachick_N = mkWN (compoundN "riikinkukon" (k38 "poikanen")) ; --UNCHK
lin peachy_A = mkWA (compoundA "persikan" (k38 "värinen")) ; --UNCHK
lin peacock_N = mkWN (compoundN "riikin" (k1A "kukko")) ; --UNCHK
lin peacock_blue_N = mkWN (k6 "turkoosi") ; --UNCHK
lin peafowl_N = mkWN (k1A "lintu") "Junon" ; --UNCHK
lin peahen_N = mkWN (compoundN "riikinkukko" (k41 "naaras")) ; --UNCHK
lin peak_N = mkN "huippu" ;
lin peak_V = mkWV (k53A "saavuttaa") "huippunsa" ;
lin peak_V2 = mkWV2 (k53A "saavuttaa") "huippunsa" ; --UNCHK
lin peaky_A = mkWA (k10 "terävä") ; --UNCHK
lin peal_N = mkWN (kH1 "kumina") ; --UNCHK
lin peal_V = mkWV (k66 "helistä") ; --UNCHK
lin peal_V2 = mkWV2 (k66 "helistä") ; --UNCHK
lin peanut_N = mkWN (compoundN "maa" (k12 "pähkinä")) ; --UNCHK
lin pear_N = mkWN (k12 "päärynä") ; --UNCHK
lin pearl_N = mkWN (compoundN "luun" (k38 "valkoinen")) ; --UNCHK
lin pearl_PN = foreignPN "Pearl" ;
lin pearl_V = mkWV (k54A "pyytää") "helmiä" ; --UNCHK
lin pearl_diver_N = mkWN (compoundN "helmen" (k10 "pyytäjä")) ; --UNCHK
lin pearl_fishery_N = mkWN (compoundN "helmisimpukka" (k10A "särkkä")) ; --UNCHK
lin pearl_oyster_N = mkWN (compoundN "helmi" (k14A "simpukka")) ; --UNCHK
lin pearl_sago_N = mkWN (k1 "saago") ; --UNCHK
lin pearlfish_N = mkWN (compoundN "neula" (k9 "kala")) ; --UNCHK
lin pearlite_N = mkWN "perliitti" ; --UNCHK
lin pearlwort_N = mkWN (k4A "haarikko") ; --UNCHK
lin pearly_A = mkWA (compoundA "helmen" (k38 "valkoinen")) ; --UNCHK
lin peasantFem_N = mkWN (k38 "maalainen") ;
lin peasantMasc_N = variants {} ; --
lin peasanthood_N = mkWN "talonpoikaisuus" ; --UNCHK
lin pease_pudding_N = mkWN (compoundN "herne" (k39 "muhennos")) ; --UNCHK
lin peat_N = mkWN (k48A "turve") ; --UNCHK
lin peaty_A = mkWA (compoundA "turvepi" (k38 "toinen")) ; --UNCHK
lin peavey_N = mkWN (k9A "kääntöhaka") ; --UNCHK
lin peba_N = mkWN (compoundN "yhdeksänvyö" (k38 "vyötiäinen")) ; --UNCHK
lin pebble_N = mkWN (compoundN "pikku" (k7 "kivi")) ; --UNCHK
lin pebibit_N = mkWN (compoundN "pebi" (k5A "bitti")) ; --UNCHK
lin peccadillo_N = mkWN (k39 "hairahdus") ; --UNCHK
lin peccary_N = mkWN (k6 "pekari") ; --UNCHK
lin peck_N = mkWN "peck" ; --UNCHK
lin peck_V = mkWV (k53A "jäkättää") ; --UNCHK
lin peck_V2 = mkWV2 (k53A "jäkättää") ; --UNCHK
lin peck_at_V2 = mkWV2 (k61A "näykkiä") ; --UNCHK
lin pecker_N = mkWN (k1 "kuono") ; --UNCHK
lin peckish_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin pecopteris_N = mkWN "pecopteris" ; --UNCHK
lin pectic_A = mkWA "pektiini-" ; --UNCHK
lin pectin_N = mkWN "pektiini" ; --UNCHK
lin pectinate_A = mkWA (compoundA "kampa" (k38 "mainen")) ; --UNCHK
lin pectineal_A = mkWA "häpyluun" ; --UNCHK
lin pectoral_A = mkWA "rinta-" ; --UNCHK
lin pectoral_N = mkWN (compoundN "rinta" (k1 "levy")) ; --UNCHK
lin peculate_V = mkWV (k71 "tehdä") "virkarikos" ; --UNCHK
lin peculate_V2 = mkWV2 (k71 "tehdä") "virkarikos" ; --UNCHK
lin peculation_N = mkWN (k39 "anastus") ; --UNCHK
lin peculiar_A = mkWA (k38 "poikkeuksellinen") ; --UNCHK
lin peculiarity_N = mkWN (k40 "erikoisuus") ; --UNCHK
lin pecuniary_A = mkWA (k38 "monetaarinen") ; --UNCHK
lin pedagogic_A = mkWA (k38 "pedagoginen") ; --UNCHK
lin pedagogical_A = mkWA (k38 "pedagoginen") ; --UNCHK
lin pedagogueFem_N = mkWN (k5 "pedagogi") ; --UNCHK
lin pedagogueMasc_N = mkWN (k5 "pedagogi") ; --UNCHK
lin pedagogy_N = mkWN (k9A "didaktiikka") ; --UNCHK
lin pedal_A = mkWA "jalka-" ; --UNCHK
lin pedal_N = mkWN (k5 "pedaali") ; --UNCHK
lin pedal_V = mkWV (k58A "polkea") ; --UNCHK
lin pedal_V2 = mkWV2 (k58A "polkea") ; --UNCHK
lin pedaler_N = mkWN (k12 "pyöräilijä") ; --UNCHK
lin pedant_N = mkWN (k12 "viisastelija") ; --UNCHK
lin pedantic_A = mkWA (k38 "pikkumainen") ; --UNCHK
lin pedantry_N = mkWN (k2 "viisastelu") ; --UNCHK
lin pedate_A = mkWA (k38 "jalallinen") ; --UNCHK
lin peddle_V = mkWV (k63 "myydä") ; --UNCHK
lin peddle_V2 = mkV2 "kaupitella" partitive ;
lin peddler_N = mkWN (k5A "helppoheikki") ; --UNCHK
lin pederast_N = mkWN (k5 "pederasti") ; --UNCHK
lin pederastic_A = mkWA (k38 "pederastinen") ; --UNCHK
lin pederasty_N = mkWN (k12 "pederastia") ; --UNCHK
lin pedersöre_PN = mkPN "Pedersöre" ;
lin pedestal_N = mkWN (k13 "jalusta") ; --UNCHK
lin pedestrian_A = mkWA (k15 "lattea") ; --UNCHK
lin pedestrian_N = mkWN (k12 "kävelijä") ; --UNCHK
lin pediatric_A = mkWA (compoundA "pediatri" (k38 "nen")) ; --UNCHK
lin pediatrician_N = mkWN (k5 "pediatri") ; --UNCHK
lin pediatrics_N = mkWN (k12 "pediatria") ; --UNCHK
lin pedicab_N = mkWN (k9 "rikša") ; --UNCHK
lin pedicel_N = mkWN (k28 "varsi") ; --UNCHK
lin pediculicide_N = mkWN (compoundN "täi" (k1A "myrkky")) ; --UNCHK
lin pedicure_N = mkWN (k5 "pedikyyri") ; --UNCHK
lin pedigree_N = mkWN (compoundN "suku" (k18 "puu")) ; --UNCHK
lin pediment_N = mkWN (k1A "pääty") ; --UNCHK
lin pedlar_N = mkWN (k5A "helppoheikki") ; --UNCHK
lin pedodontist_N = mkWN (compoundN "hammas" (k6 "lääkäri")) "lasten" ; --UNCHK
lin pedometer_N = mkWN (compoundN "askel" (k6 "mittari")) ; --UNCHK
lin pedophile_N = mkWN (k5 "pedofiili") ; --UNCHK
lin pedophilia_N = mkWN (k12 "pedofilia") ; --UNCHK
lin peduncle_N = mkWN (compoundN "johtorata" (k1A "kimppu")) ; --UNCHK
lin pedunculate_A = mkWA (k38 "varrellinen") ; --UNCHK
lin pee_N = mkWN (compoundN "pis" (k38 "saaminen")) ; --UNCHK
lin pee_V = mkWV (k53A "heittää") "vettä" ; --UNCHK
lin peebles_PN = foreignPN "Peebles" ;
lin peeing_N = mkWN (compoundN "pis" (k38 "saaminen")) ; --UNCHK
lin peek_N = mkWN (k39 "kurkistus") ; --UNCHK
lin peek_V = mkWV (k61A "kurkkia") ; --UNCHK
lin peekaboo_N = mkWN (compoundN "kurkistus" (k5A "leikki")) ; --UNCHK
lin peel_N = mkWN (kH1 "kuori") ; --UNCHK
lin peel_V = mkWV (k52A "riisuuntua") ; --UNCHK
lin peel_V2 = mkWV2 (k52A "riisuuntua") ; --UNCHK
lin peel_off_V = mkWV (k61 "kesiä") ; --UNCHK
lin peeler_N = mkWN (compoundN "kuorima" (k30 "veitsi")) ; --UNCHK
lin peen_N = mkWN (k10A "sorkka") ; --UNCHK
lin peep_N = mkWN (k39 "kurkistus") ; --UNCHK
lin peep_V = mkWV (k53 "kurkistaa") ; --UNCHK
lin peeper_N = mkWN "piipittäjä" ; --UNCHK
lin peephole_N = mkWN (compoundN "silmä" (k1A "aukko")) ; --UNCHK
lin peepshow_N = mkWN (compoundN "tirkistys" (k39 "esitys")) ; --UNCHK
lin peepul_N = mkWN "pyhäviikunapuu" ; --UNCHK
lin peer_N = mkWN (k38 "vertainen") ; --UNCHK
lin peer_V = mkWV (k67 "tähyillä") ; --UNCHK
lin peerage_N = mkWN (compoundN "paroni" (k10A "kunta")) ; --UNCHK
lin peeress_N = mkWN (k1 "lady") ; --UNCHK
lin peerless_A = mkA "verraton" ;
lin peeve_N = mkWN (k26 "tuuli") "paha" ; --UNCHK
lin peeve_V2 = mkWV2 (k61 "pänniä") ; --UNCHK
lin peevish_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin peevishness_N = mkWN (k40 "äreys") ; --UNCHK
lin peewit_N = mkWN "Contopus" "virens" ; --UNCHK
lin peg_N = mkWN (k9 "vaarna") ; --UNCHK
lin peg_V = mkWV (k53A "kiinnittää") ; --UNCHK
lin peg_V2 = mkWV2 (k53A "kiinnittää") ; --UNCHK
lin peg_away_V = mkWV (k61 "paiskia") "töitä" ; --UNCHK
lin peg_down_V2 = mkWV2 (k73 "rajata") ; --UNCHK
lin pegboard_N = mkWN (compoundN "reikä" (k1 "levy")) ; --UNCHK
lin pegmatite_N = mkWN (k5A "pegmatiitti") ; --UNCHK
lin peignoir_N = mkWN (compoundN "aamu" (k5A "takki")) ; --UNCHK
lin pejorative_A = mkWA (k10 "alentava") ; --UNCHK
lin peke_N = mkWN (compoundN "Kiinanpalatsi" (k10 "koira")) ; --UNCHK
lin pekinese_N = mkWN (compoundN "Kiinanpalatsi" (k10 "koira")) ; --UNCHK
lin pekoe_N = mkWN "pekoe" ; --UNCHK
lin pelf_N = mkWN (k9 "raha") ; --UNCHK
lin pelican_N = mkWN (k5 "pelikaani") ; --UNCHK
lin pelisse_N = mkWN (kH1 "viitta") "turkisreunainen" ; --UNCHK
lin pelkosenniemi_PN = mkPN (mkN "Pelkosenniemi" "Pelkosenniemiä") ;
lin pellagra_N = mkWN "pellagra" ; --UNCHK
lin pellet_N = mkWN (k5 "hauli") ; --UNCHK
lin pellicle_N = mkWN (k1 "kalvo") ; --UNCHK
lin pellitory_N = mkWN (k26 "bertramjuuri") ; --UNCHK
lin pello_PN = mkPN "Pello" ;
lin pellucid_A = mkWA (k10 "selvä") ; --UNCHK
lin pellucidness_N = mkWN (k40 "kirkkaus") ; --UNCHK
lin pelmet_N = mkWN (kH1 "kappa") ; --UNCHK
lin pelota_N = mkWN "jai" "alai" ; --UNCHK
lin pelt_N = mkWN (k9 "nahka") ; --UNCHK
lin pelt_V = mkWV (k53A "pommittaa") ; --UNCHK
lin pelt_V2 = mkWV2 (k53A "pommittaa") ; --UNCHK
lin peltate_A = mkWA (compoundA "kilpi" (k38 "mäinen")) ; --UNCHK
lin pelter_N = mkWN (k10 "pommittaja") ; --UNCHK
lin pelton_PN = foreignPN "Pelton" ;
lin peludo_N = mkWN (compoundN "kuusivyö" (k38 "vyötiäinen")) ; --UNCHK
lin pelvic_A = mkWA "lantio-" ; --UNCHK
lin pelvimeter_N = mkWN (compoundN "lantio" (k6 "mittari")) ; --UNCHK
lin pelvimetry_N = mkWN (k39 "mittaus") "lantion" ; --UNCHK
lin pelvis_N = mkWN (compoundN "munuais" (k41A "allas")) ; --UNCHK
lin pelycosaur_N = mkWN "synapsidi" ; --UNCHK
lin pembroke_PN = foreignPN "Pembroke" ;
lin pemphigous_A = mkWA "rakkulaihottuma-" ; --UNCHK
lin pemphigus_N = mkWN (compoundN "rakkula" (k10 "ihottuma")) ; --UNCHK
lin pen_1_N = L.pen_N ;
lin pen_2_N = L.pen_N ;
lin pen_V2 = mkWV2 (k67 "kynäillä") ; --UNCHK
lin pen_name_N = mkWN (k5 "pseudonyymi") ; --UNCHK
lin penal_A = mkWA "rangaistus-" ; --UNCHK
lin penalization_N = mkWN (k39 "rangaistus") ; --UNCHK
lin penalize_V2 = mkWV2 (k54A "ojentaa") ; --UNCHK
lin penalty_N = mkWN (k39 "rangaistus") ;
lin penance_N = mkWN (k39 "parannus") ; --UNCHK
lin penarth_PN = foreignPN "Penarth" ;
lin penchant_N = mkWN (k39 "mieltymys") "voimakas" ; --UNCHK
lin pencil_N = mkWN (k10 "kynä") ; --UNCHK
lin pencil_V2 = mkWV2 (k54A "piirtää") "lyijykynällä" ; --UNCHK
lin pend_V = mkV "riippua" ;
lin pend_V2 = mkV2 (mkV (mkV "pitää") "vireillä") ; ----?
lin pendent_A = mkWA (k10 "riippuva") ; --UNCHK
lin pending_Prep = mkPrep "odottaessa" partitive ;
lin pendragon_N = mkWN (compoundN "yli" (k4A "päällikkö")) ; --UNCHK
lin pendulous_A = mkWA (k10 "riippuva") ; --UNCHK
lin pendulum_N = mkWN (k6 "heiluri") ; --UNCHK
lin peneplain_N = mkWN (compoundN "puoli" (k1A "tasanko")) ; --UNCHK
lin penetrability_N = mkWN "läpäistävyys" ; --UNCHK
lin penetrable_A = mkWA (compoundA "läpäis" (k10 "evä")) ; --UNCHK
lin penetralia_N = mkWN (k36 "sisin") ; --UNCHK
lin penetrate_V = mkWV (k52 "paljastua") ; --UNCHK
lin penetrate_V2 = mkV2 "läpäistä" ; --mkWV2 (k52 "paljastua") ;
lin penetratingly_Adv = mkWAdv (k99 "syvällisesti") ; --UNCHK
lin penetration_N = mkWN (k1 "pääsy") ; --UNCHK
lin penetrative_A = mkWA (k10 "läpitunkeva") ; --UNCHK
lin penetrator_N = mkWN (k10 "tunkeutuja") ; --UNCHK
lin pengo_N = mkWN "pengo" ; --UNCHK
lin penguin_N = mkWN (k6 "pingviini") ; --UNCHK
lin penicillamine_N = mkWN "Cuprimine" ; --UNCHK
lin penicillin_N = mkWN (k5 "penisilliini") ; --UNCHK
lin penicillinase_N = mkWN (compoundN "beetalaktam" (k5 "aasi")) ; --UNCHK
lin penicuik_PN = foreignPN "Penicuik" ;
lin penile_A = mkWA "siittimen" ; --UNCHK
lin peninsula_N = mkWN (k25 "niemi") ; --UNCHK
lin peninsular_A = mkWA "niemi-" ; --UNCHK
lin penis_N = mkWN (k33 "elin") ; --UNCHK
lin penitence_N = mkWN (k39 "katumus") ; --UNCHK
lin penitent_A = mkWA "katuva" ; --UNCHK
lin penitent_N = mkWN (compoundN "katumuksen" (k12 "tekijä")) ; --UNCHK
lin penitential_A = mkWA (k38 "katuvainen") ; --UNCHK
lin penitentiary_A = mkWA (k38 "katuvainen") ; --UNCHK
lin penitentiary_N = mkWN (k9 "linna") ; --UNCHK
lin penknife_N = mkWN (compoundN "kynä" (k30 "veitsi")) ; --UNCHK
lin penlight_N = mkWN (compoundN "kynä" (k1A "lamppu")) ; --UNCHK
lin penmanship_N = mkWN (compoundN "kauno" (k39 "kirjoitus")) ; --UNCHK
lin penn'orth_N = mkWN (k99 "edestä") "pennyn" ; --UNCHK
lin pennant_N = mkWN (k5 "viiri") ; --UNCHK
lin pennate_A = mkWA (compoundA "sula" (k38 "llinen")) ; --UNCHK
lin penne_N = mkWN (k8 "penne") ; --UNCHK
lin penni_N = mkWN (k5 "penni") ; --UNCHK
lin penniless_A = mkWA (k99 "kovilla") ; --UNCHK
lin pennon_N = mkWN (k7A "siipi") ; --UNCHK
lin pennoncel_N = mkWN (k5 "viiri") ; --UNCHK
lin pennsylvania_PN = mkPN "Pennsylvania" ;
lin penny_N = mkN "penni" ;
lin pennycress_N = mkWN (compoundN "tasku" (k1 "ruoho")) ; --UNCHK
lin pennyroyal_N = mkWN (k1A "minttu") ; --UNCHK
lin pennyweight_N = mkWN "1/20" "unssia" ; --UNCHK
lin pennywhistle_N = mkWN (k5 "pilli") ; --UNCHK
lin pennyworth_N = mkWN (k99 "edestä") "pennyn" ; --UNCHK
lin penologist_N = mkWN (compoundN "asian" (k12 "tuntija")) "rangaistusopin" ; --UNCHK
lin penology_N = mkWN (compoundN "rangaistus" (k5A "oppi")) ; --UNCHK
lin pen_pusher_N = mkWN (compoundN "konttori" (k10A "rotta")) ; --UNCHK
lin penrith_PN = foreignPN "Penrith" ;
lin penryn_PN = foreignPN "Penryn" ;
lin pension_N = mkWN (k48A "eläke") ; --f95
lin pension_V2 = mkWV2 (k54A "siirtää") "eläkkeelle" ; --UNCHK
lin pensionable_A = mkWA (k1A "oikeutettu") "eläkkeeseen" ; --UNCHK
lin pensioner_N = mkWN (k38 "eläkeläinen") ; --UNCHK
lin pensive_A = mkWA (k15 "haikea") ; --UNCHK
lin pensiveness_N = mkWN (k40 "mietteliäisyys") ; --UNCHK
lin penstock_N = mkWN (k10 "kanava") ; --UNCHK
lin pent_A = mkWA (compoundA "sulje" (k1 "ttu")) ; --UNCHK
lin pent_up_A = mkA "patoutunut" ;
lin pentacle_N = mkWN (k5 "pentagrammi") ; --UNCHK
lin pentaerythritol_N = mkWN "Peritrate" ; --UNCHK
lin pentagon_N = mkWN "Pentagon" ; --UNCHK
lin pentagonal_A = mkWA (compoundA "viisikul" (k38 "mainen")) ; --UNCHK
lin pentahedron_N = mkWN (k5 "pentaedri") ; --UNCHK
lin pentail_N = mkWN (compoundN "puu" (k38 "päästäinen")) ; --UNCHK
lin pentamerous_A = mkWA (compoundA "viisi" (k38 "lohkoinen")) ; --UNCHK
lin pentameter_N = mkWN (k5 "pentametri") ; --UNCHK
lin pentasyllabic_A = mkWA (compoundA "viis" (k38 "itavuinen")) ; --UNCHK
lin pentateuch_N = mkWN (kH1 "laki") ; --UNCHK
lin pentathlete_N = mkWN (compoundN "viisi" (k12 "ottelija")) ; --UNCHK
lin pentathlon_N = mkWN (compoundN "viisi" (k2 "ottelu")) "nykyaikainen" ; --UNCHK
lin pentavalent_A = mkWA (compoundA "viis" (k38 "ivalenssinen")) ; --UNCHK
lin pentazocine_N = mkWN "Talwin" ; --UNCHK
lin pentecost_N = mkWN (k10 "juhla") "viikkojen" ; --UNCHK
lin pentecostal_A = mkWA "helluntai-" ; --UNCHK
lin pentecostalism_N = mkWN (k40 "helluntailaisuus") ; --UNCHK
lin penthouse_N = mkWN (compoundN "katto" (k2 "huoneisto")) ; --UNCHK
lin pentimento_N = mkWN (kH1 "maalaus") ; --UNCHK
lin pentlandite_N = mkWN "pentlandiitti" ; --UNCHK
lin pentode_N = mkWN "pentodi" ; --UNCHK
lin pentose_N = mkWN "pentoosi" ; --UNCHK
lin pentoxifylline_N = mkWN "Trental" ; --UNCHK
lin pentylenetetrazol_N = mkWN "Metrazol" ; --UNCHK
lin penuche_N = mkWN (compoundN "kerma" (k5 "karamelli")) ; --UNCHK
lin penult_N = mkWN (k1 "tavu") "toiseksi" "viimeinen" ; --UNCHK
lin penultimate_A = mkWA (k38 "viimeinen") "toiseksi" ; --UNCHK
lin penultimate_N = mkWN (k1 "tavu") "toiseksi" "viimeinen" ; --UNCHK
lin penumbra_N = mkWN (compoundN "puoli" (k1 "varjo")) ; --UNCHK
lin penumbral_A = mkWA "puolivarjon" ; --UNCHK
lin penurious_A = mkWA (k5 "pihi") ; --UNCHK
lin penuriousness_N = mkWN (k40 "saituus") ; --UNCHK
lin penury_N = mkWN (k40 "köyhyys") ; --UNCHK
lin penzance_PN = foreignPN "Penzance" ;
lin peon_N = mkWN (kH1 "peoni") ; --UNCHK
lin peonage_N = mkWN (compoundN "velka" (k40 "orjuus")) ; --UNCHK
lin peony_N = mkWN (kH1 "pioni") ; --UNCHK
lin people_N = mkN "kansa" ;
lin people_V2 = mkWV2 (k53A "kansoittaa") ; --UNCHK
lin pep_N = mkWN (k1 "tarmo") ; --UNCHK
lin pep_up_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin peperomia_N = mkWN (compoundN "muorin" (k10A "kukka")) ; --UNCHK
lin peplos_N = mkWN (compoundN "vaippa" (k48 "hame")) ; --UNCHK
lin peplum_N = mkWN (compoundN "vaippa" (k48 "hame")) ; --UNCHK
lin pepper_N = mkWN (k6 "pippuri") ; --UNCHK
lin pepper_V2 = mkWV2 (k53A "pommittaa") ; --UNCHK
lin pepper_mill_N = mkWN (compoundN "pippuri" (k1 "mylly")) ; --UNCHK
lin pepper_pot_N = mkWN (compoundN "pippuri" (k33A "sirotin")) ; --UNCHK
lin peppercorn_N = mkWN (k6 "pippuri") ; --UNCHK
lin peppermint_N = mkWN (compoundN "piparminttu" (k5 "karamelli")) ; --UNCHK
lin pepperoni_N = mkWN "pepperoni" ; --UNCHK
lin peppery_A = mkWA (k38 "tulinen") ; --UNCHK
lin pepsin_N = mkWN (k5 "pepsiini") ; --UNCHK
lin pepsinogen_N = mkWN (compoundN "pepsino" (k5 "geeni")) ; --UNCHK
lin peptic_A = mkWA "ruoansulatusta" "edistävä" ; --UNCHK
lin peptide_N = mkWN (k5 "peptidi") ; --UNCHK
lin peptization_N = mkWN "peptisaatio" ; --UNCHK
lin peptone_N = mkWN "peptoni" ; --UNCHK
lin per_Prep = mkPrep "per" nominative ;
lin peradventure_N = mkWN (k39 "epäilys") ; --UNCHK
lin perambulate_V = mkWV (k65 "käydä") "tarkastamassa" ; --UNCHK
lin perambulate_V2 = mkWV2 (k65 "käydä") "tarkastamassa" ; --UNCHK
lin perambulation_N = mkWN (k2 "vaeltelu") ; --UNCHK
lin percale_N = mkWN (compoundN "per" (k5 "kaali")) ; --UNCHK
lin perceivable_A = mkWA (k10 "ymmärrettävä") ; --UNCHK
lin perceive_V2 = mkWV2 (k54A "oivaltaa") ; --UNCHK
lin perceive_V2V = mkWV2V (k54A "oivaltaa") ; --UNCHK
lin perceive_VS = mkWVS (k54A "oivaltaa") ; --UNCHK
lin perceived_A = variants {} ; --
lin perceiver_N = mkWN (k10 "havainnoija") ; --UNCHK
lin percent_N = mkWN (k5A "prosentti") ;
lin percentage_N = mkN "prosenttiosuus" ;
lin percentile_N = mkWN (compoundN "persen" (k23 "tiili")) ; --UNCHK
lin percept_N = mkWN (k1A "havainto") ; --UNCHK
lin perceptibility_N = mkWN (k40 "havaittavuus") ; --UNCHK
lin perceptible_A = mkWA "havaittava" ; --UNCHK
lin perception_N = mkWN (k39 "aistimus") ;
lin perceptive_A = mkWA (k10 "terävä") ; --UNCHK
lin perceptiveness_N = mkWN "herkkävaistoisuus" ; --UNCHK
lin perceptual_A = mkWA "aisti-" ; --UNCHK
lin perch_N = mkWN (k32 "ahven") ; --UNCHK
lin perch_V = mkWV (k53A "kyyhöttää") ; --UNCHK
lin perch_V2 = mkWV2 (k53A "kyyhöttää") ; --UNCHK
lin percher_N = mkWN (compoundN "varpus" (k1A "lintu")) ; --UNCHK
lin perchlorate_N = mkWN "perkloraatti" ; --UNCHK
lin perchloride_N = mkWN "perkloridi" ; --UNCHK
lin percipient_A = mkWA (k10 "terävä") ; --UNCHK
lin percolate_N = mkWN "perkolaatti" ; --UNCHK
lin percolate_V = mkWV (k52 "piristyä") ; --UNCHK
lin percolate_V2 = mkWV2 (k52 "piristyä") ; --UNCHK
lin percolation_N = mkWN (k39 "suodatus") ; --UNCHK
lin percolator_N = mkWN (compoundN "aromi" (k33A "keitin")) ; --UNCHK
lin percussion_N = mkWN (k5A "lyönti") ; --UNCHK
lin percussionist_N = mkWN (k5 "perkussionisti") ; --UNCHK
lin percussive_A = mkWA "lyömäsoitin-" ; --UNCHK
lin percy_PN = foreignPN "Percy" ;
lin perdition_N = mkWN (k1 "kuilu") "hornan" ; --UNCHK
lin perdurability_N = mkWN (k40 "kestävyys") ; --UNCHK
lin peregrination_N = mkWN (k39 "vaellus") ; --UNCHK
lin peregrine_N = mkWN (compoundN "muutto" (k9A "haukka")) ; --UNCHK
lin peremptory_A = mkWA (k34A "ehdoton") ; --UNCHK
lin perennation_N = mkWN (compoundN "per" (k38 "ennoiminen")) ; --UNCHK
lin perennial_A = mkWA (compoundA "moni" (k38 "vuotinen")) ; --UNCHK
lin perennial_N = mkWN (k13 "perenna") ; --UNCHK
lin perestroika_N = mkWN (k10 "perestroika") ; --UNCHK
lin perfect_A = mkWA (k38 "täydellinen") ;
lin perfect_V2 = mkWV2 (k71 "tehdä") "täydelliseksi" ; --UNCHK
lin perfecter_N = mkWN "viimeistelijä" ; --UNCHK
lin perfectibility_N = mkWN (compoundN "kehitys" (k40 "kelpoisuus")) ; --UNCHK
lin perfectible_A = mkWA (compoundA "kehitys" (k38 "kelpoinen")) ; --UNCHK
lin perfection_N = mkWN (k2 "viimeistely") ;
lin perfectionism_N = mkWN (k2 "tavoittelu") "täydellisyyden" ; --UNCHK
lin perfectionist_N = mkWN (k12 "tavoittelija") "täydellisyyden" ; --UNCHK
lin perfective_N = mkWN (k5 "aspekti") "perfektiivinen" ; --UNCHK
lin perfervid_A = mkWA (k10 "kuuma") ; --UNCHK
lin perfidious_A = mkWA (k10 "kavala") ; --UNCHK
lin perfidiousness_N = mkWN (k40 "petollisuus") ; --UNCHK
lin perfidy_N = mkWN (k39 "petos") ; --UNCHK
lin perfluorocarbon_N = mkWN (compoundN "perfluorihiili" (k1A "vety")) ; --UNCHK
lin perfoliate_A = mkWA (k10 "sepivä") ; --UNCHK
lin perforate_V2 = mkWV2 (k52A "työntyä") ; --UNCHK
lin perforation_N = mkWN "lävistäminen" ; --UNCHK
lin perforce_Adv = mkWAdv (k99 "välttämättä") ; --UNCHK
lin perform_V = mkV "esittää" ;
lin perform_V2 = mkV2 "suorittaa" ;
lin performance_1_N = mkN "suoritus" (mkN "kyky") ;
lin performance_2_N = mkN "esitys" ;
lin performance_N = mkN "suoritus" ;
lin performer_N = mkWN (k12 "taiteilija") "esiintyvä" ; --UNCHK
lin perfume_N = mkWN (k1 "tuoksu") ; --UNCHK
lin perfume_V2 = mkWV2 (k53A "käyttää") "hajuvettä" ; --UNCHK
lin perfumerFem_N = variants {} ; ---- sense to be split
lin perfumerMasc_N = mkWN (compoundN "hajuvesi" (k12 "tehtailija")) ; --UNCHK
lin perfumery_N = mkWN (k39 "valmistus") "hajuvesien" ; --UNCHK
lin perfunctory_A = mkWA (k38 "kursorinen") ; --UNCHK
lin perfusion_N = mkWN (k39 "valutus") "läpi" ; --UNCHK
lin pergola_N = mkWN (k12 "pergola") ; --UNCHK
lin perhaps_Adv = mkAdv "ehkä" ;
lin perho_PN = mkPN "Perho" ;
lin peri_N = mkWN "peri" ; --UNCHK
lin perianal_A = mkWA (compoundA "peri" (k38 "anaalinen")) ; --UNCHK
lin perianth_N = mkWN (k10 "kehä") ; --UNCHK
lin periapsis_N = mkWN "periapsis" ; --UNCHK
lin periarteritis_N = mkWN (compoundN "valtimonympärys" (k39 "tulehdus")) ; --UNCHK
lin pericardial_A = mkWA (compoundA "perikardia" (k38 "alinen")) ; --UNCHK
lin pericarditis_N = mkWN (k39 "tulehdus") "sydänpussin" ; --UNCHK
lin pericardium_N = mkWN (compoundN "sydän" (k5 "pussi")) ; --UNCHK
lin pericarp_N = mkWN (compoundN "hedelmän" (k10 "seinä")) ; --UNCHK
lin pericementoclasia_N = mkWN (k39 "tulehdus") "hammassementin" ; --UNCHK
lin periclase_N = mkWN (compoundN "magnesium" (k5 "oksidi")) ; --UNCHK
lin peridinian_N = mkWN (compoundN "panssari" (k10 "levä")) ; --UNCHK
lin peridium_N = mkWN "peridio" ; --UNCHK
lin peridot_N = mkWN "peridootti" ; --UNCHK
lin peridotite_N = mkWN (k5A "peridotiitti") ; --UNCHK
lin perigee_N = mkWN "perigeum" ; --UNCHK
lin perigon_N = mkWN (compoundN "täys" (k10 "kulma")) ; --UNCHK
lin perigonal_A = mkWA "täyskulma-" ; --UNCHK
lin perijove_N = mkWN "perijove" ; --UNCHK
lin peril_N = mkWN (kH1 "vaara") ; --UNCHK
lin peril_V2 = mkWV2 (k53 "altistaa") ; --UNCHK
lin perilous_A = mkWA (k38 "vaarallinen") ; --UNCHK
lin perilymph_N = mkWN (compoundN "ulko" (k48 "neste")) ; --UNCHK
lin perimeter_N = mkWN (k10 "kehä") ; --UNCHK
lin perimysium_N = mkWN (compoundN "lihas" (k7A "tuki")) ; --UNCHK
lin perinasal_A = mkWA "nenää" "ympäröivä" ; --UNCHK
lin perinatal_A = mkWA (k38 "perinataalinen") ; --UNCHK
lin perinatologist_N = mkWN "perinatologi" ; --UNCHK
lin perinatology_N = mkWN (k12 "perinatologia") ; --UNCHK
lin perineotomy_N = mkWN (k39 "leikkaus") "välilihan" ; --UNCHK
lin perineum_N = mkWN (compoundN "väli" (k9 "liha")) ; --UNCHK
lin perineurium_N = mkWN (compoundN "sisä" (k7A "tuppi")) "hermon" ; --UNCHK
lin period_1_N = mkN "ajanjakso" ;
lin period_2_N = mkN "piste" ;
lin period_3_N = mkN "kuukautinen" ; ---- plural only
lin period_N = mkN "ajanjakso" ;
lin periodic_A = mkWA (k38 "kausittainen") ;
lin periodical_A = mkWA (k38 "ajoittainen") ; --UNCHK
lin periodical_N = mkWN (compoundN "aikakaus" (k2 "julkaisu")) ; --UNCHK
lin periodontic_A = mkWA (compoundA "periodonta" (k38 "alinen")) ; --UNCHK
lin periodontics_N = mkWN "periodontia" ; --UNCHK
lin periodontist_N = mkWN (compoundN "asian" (k12 "tuntija")) "periodontian" ; --UNCHK
lin periosteum_N = mkWN (compoundN "luu" (k1 "kalvo")) ; --UNCHK
lin peripatetic_A = mkWA (compoundA "aristoteli" (k38 "lainen")) ; --UNCHK
lin peripatetic_N = mkWN (k10 "kannattaja") "Aristoteleen" ; --UNCHK
lin peripeteia_N = mkWN (k48A "käänne") "yllättävä" ; --UNCHK
lin peripheral_A = mkWA (k38 "perifeerinen") ; --UNCHK
lin peripheral_N = mkWN (compoundN "lisä" (k48A "laite")) ; --UNCHK
lin periphery_N = mkWN (k9 "reuna") ; --UNCHK
lin periphrasis_N = mkWN (k1A "käyttö") "kiertoilmausten" ; --UNCHK
lin periphrastic_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin peripteral_A = mkWA "pylväiden" "ympäröimä" ; --UNCHK
lin periscope_N = mkWN (k5A "periskooppi") ; --UNCHK
lin periselene_N = mkWN (compoundN "peril" (k24 "uni")) ; --UNCHK
lin perish_V = mkWV (k67 "kuolla") "äkillisesti" ; --UNCHK
lin perish_V2 = mkWV2 (k67 "kuolla") "äkillisesti" ; --UNCHK
lin perishability_N = mkWN "pilaantuvuus" ; --UNCHK
lin perishable_A = mkWA (k38 "kuolevainen") ; --UNCHK
lin perishable_N = mkWN (k12 "tavara") "pilaantuva" ; --UNCHK
lin perisher_N = mkWN (k3 "riiviö") ; --UNCHK
lin perisperm_N = mkWN (compoundN "ulko" (k38 "valkuainen")) ; --UNCHK
lin peristalsis_N = mkWN (k9A "peristaltiikka") ; --UNCHK
lin peristome_N = mkWN (compoundN "suunympärys" (k48A "jaoke")) ; --UNCHK
lin peristylar_A = mkWA "pylväiden" "ympäröimä" ; --UNCHK
lin peristyle_N = mkWN (k4A "pylväikkö") ; --UNCHK
lin perithecium_N = mkWN (compoundN "kotelo" (k1 "pullo")) ; --UNCHK
lin perithelial_A = mkWA "sidekudos-" ; --UNCHK
lin perithelium_N = mkWN (compoundN "side" (k39 "kudos")) ; --UNCHK
lin peritoneal_A = mkWA "vatsakalvon" ; --UNCHK
lin peritoneum_N = mkWN (compoundN "vatsa" (k1 "kalvo")) ; --UNCHK
lin peritonitis_N = mkWN (compoundN "vatsakalvon" (k39 "tulehdus")) ; --UNCHK
lin periwig_N = mkWN (k5A "peruukki") ; --UNCHK
lin periwinkle_N = mkWN (k3 "talvio") ; --UNCHK
lin perjurer_N = mkWN (k1A "valapatto") ; --UNCHK
lin perjury_N = separateN "väärä" (mkN "vala") ; --mkWN (k40 "valapattoisuus") ;
lin perk_N = mkWN (k40 "etuus") ; --UNCHK
lin perk_V = mkWV (k52 "piristyä") ; --UNCHK
lin perk_V2 = mkWV2 (k52 "piristyä") ; --UNCHK
lin perk_up_V2 = mkWV2 (k62 "stimuloida") ; --UNCHK
lin perkiness_N = mkWN (k40 "nokkavuus") ; --UNCHK
lin perky_A = mkWA (k15 "virkeä") ; --UNCHK
lin perm_N = mkWN (k5A "permanentti") ; --UNCHK
lin perm_PN = foreignPN "Perm" ;
lin perm_V2 = mkWV2 (k73A "permanentata") ; --UNCHK
lin permafrost_N = mkWN (compoundN "iki" (k10A "routa")) ; --UNCHK
lin permanence_N = mkWN (k40 "pysyvyys") ; --UNCHK
lin permanency_N = mkWN (k40 "pysyvyys") ; --UNCHK
lin permanent_A = mkA "pysyvä" ;
lin permanganate_N = mkWN (compoundN "permanga" (k5A "naatti")) ; --UNCHK
lin permeability_N = mkWN (k5A "permeabiliteetti") ; --UNCHK
lin permeable_A = mkWA (compoundA "läpäis" (k10 "evä")) ; --UNCHK
lin permeant_A = mkWA (k10 "pistävä") ; --UNCHK
lin permeate_V = mkWV (k52A "tunkeutua") "läpi" ; --UNCHK
lin permeate_V2 = mkWV2 (k52A "tunkeutua") "läpi" ; --UNCHK
lin permeation_N = mkWN (k2 "läpäisy") ; --UNCHK
lin permissibility_N = mkWN (k40 "luvallisuus") ; --UNCHK
lin permissible_A = mkWA (k38 "luvallinen") ; --UNCHK
lin permission_N = mkWN (k10A "lupa") ;
lin permissive_A = mkWA (k38 "suvaitsevainen") ; --UNCHK
lin permissiveness_N = mkWN (k40 "suvaitsevaisuus") ; --UNCHK
lin permit_N = mkWN (k10A "lupa") ; --UNCHK
lin permit_V = mkWV (k53 "päästää") ; --UNCHK
lin permit_V2 = mkV2 "sallia" ; ---ARB mkWV2 (k53 "päästää") ;
lin permit_V2V = mkV2Vf (mkV "sallia") (casePrep genitive) infFirst ;
lin permutability_N = mkWN (k40 "vaihdettavuus") ; --UNCHK
lin permutation_N = mkWN (k3 "permutaatio") ; --UNCHK
lin permute_V2 = mkWV2 (k53A "sekoittaa") "keskenään" ; --UNCHK
lin pernicious_A = mkWA (k38 "haitallinen") ; --UNCHK
lin perniciousness_N = mkWN (k40 "myrkyllisyys") ; --UNCHK
lin pernickety_A = mkWA (k38 "pikkumainen") ; --UNCHK
lin perniö_PN = mkPN "Perniö" ;
lin pernå_PN = mkPN "Pernaja" ;
lin peroneal_A = mkWA "pohjeluu-" ; --UNCHK
lin peroneus_N = mkWN (compoundN "pohje" (k39 "lihas")) ; --UNCHK
lin peroration_N = mkWN (k1A "yhteenveto") ; --UNCHK
lin peroxidase_N = mkWN (k5 "peroksidaasi") ; --UNCHK
lin peroxide_N = mkWN (k5 "peroksidi") ; --UNCHK
lin perpendicular_A = mkWA (k38 "vertikaalinen") ; --UNCHK
lin perpendicular_N = mkWN (compoundN "vertikaali" (k1 "taso")) ; --UNCHK
lin perpendicularity_N = mkWN (compoundN "kohti" (k40 "suoruus")) ; --UNCHK
lin perpetrate_V2 = mkWV2 (k52 "syyllistyä") ; --UNCHK
lin perpetration_N = mkWN (k1A "teko") "rikollinen" ; --UNCHK
lin perpetrator_N = mkWN (k12 "tekijä") ; --UNCHK
lin perpetual_A = mkWA (k38 "alituinen") ;
lin perpetuate_V2 = mkWV2 (k53A "säilyttää") ; --UNCHK
lin perpetuation_N = mkWN (k1 "jatko") ; --UNCHK
lin perpetuity_N = mkWN (k40 "iankaikkisuus") ; --UNCHK
lin perphenazine_N = mkWN "Triavil" ; --UNCHK
lin perplex_V2 = mkWV2 (k53A "vaikeuttaa") ; --UNCHK
lin perplexedly_Adv = mkWAdv (k99 "ymmällään") ; --UNCHK
lin perplexity_N = mkWN (k39 "hämmennys") ; --UNCHK
lin perquisite_N = mkWN (k40 "etuus") ; --UNCHK
lin perry_N = mkWN (k5 "päärynäviini") ; --UNCHK
lin persecute_V2 = mkWV2 (k53A "sortaa") ; --UNCHK
lin persecution_N = mkWN (k1 "vaino") ; --UNCHK
lin persecutor_N = mkWN (k10 "kiduttaja") ; --UNCHK
lin perseverance_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin perseveration_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin persevere_V = mkWV (k56 "jatkaa") ; --UNCHK
lin perseveringly_Adv = mkWAdv (k99 "sinnikkäästi") ; --UNCHK
lin pershore_PN = foreignPN "Pershore" ;
lin persianFem_N = variants {} ; ---- sense to be split
lin persianMasc_N = variants {} ; ---- sense to be split
lin persian_A = mkWA (k38 "persialainen") ; --UNCHK
lin persiflage_N = mkWN (k2 "naljailu") ; --UNCHK
lin persimmon_N = mkWN (k5 "persimoni") ; --UNCHK
lin persist_V = mkWV (k52 "pysyä") "järkähtämättömänä" ; --UNCHK
lin persistence_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin persistent_A = mkWA (k10 "pysyvä") ; --UNCHK
lin person_N = L.person_N ;
lin persona_N = mkWN (k10 "kuva") ; --UNCHK
lin persona_grata_N = mkWN (k2 "henkilö") "suosiossa" "oleva" ; --UNCHK
lin persona_non_grata_N = mkWN (k2 "henkilö") "epätoivottu" ; --UNCHK
lin personable_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin personableness_N = mkWN (k40 "miellyttävyys") ; --UNCHK
lin personage_N = mkWN (k2 "henkilö") "vaikutusvaltainen" ; --UNCHK
lin personal_A = mkA "henkilökohtainen" ;
lin personal_N = mkWN (compoundN "henkilö" (k6 "artikkeli")) ; --UNCHK
lin personality_N = mkWN (k40 "persoonallisuus") ; --UNCHK
lin personalize_V2 = mkWV2 (k53 "yksilöllistää") ; --UNCHK
lin personalty_N = mkWN (k1 "irtaimisto") ; --UNCHK
lin personate_V2 = mkWV2 (k53 "elollistaa") ; --UNCHK
lin personation_N = mkWN (k9A "tulkinta") ; --UNCHK
lin personhood_N = mkWN (k40 "yksilöllisyys") ; --UNCHK
lin personification_N = mkWN (k3 "personifikaatio") ; --UNCHK
lin personify_V2 = mkWV2 (k53 "elollistaa") ; --UNCHK
lin personnel_N = mkWN (compoundN "henkilöstö" (k2 "osasto")) ; --UNCHK
lin perspective_N = mkWN (k5 "perspektiivi") "lineaarinen" ; --UNCHK
lin perspex_N = mkWN "Perspex" ; --UNCHK
lin perspicacious_A = mkWA (k10 "terävä") ; --UNCHK
lin perspicacity_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin perspicuity_N = mkWN (k40 "selvyys") ; --UNCHK
lin perspicuous_A = mkWA (k10 "selvä") ; --UNCHK
lin perspicuousness_N = mkWN (k40 "selvyys") ; --UNCHK
lin perspiration_N = mkWN (k7A "hiki") ; --UNCHK
lin perspire_V = mkWV (k67 "hikoilla") ; --UNCHK
lin perspirer_N = mkWN "hikoilija" ; --UNCHK
lin persuadable_A = mkWA (k38 "vastaanottavainen") ; --UNCHK
lin persuade_V2 = mkWV2 (k53A "taivuttaa") ;
lin persuade_V2V = mkV2V (mkV "taivutella") accusative infIllat ;
lin persuader_N = mkWN "suostuttelija" ; --UNCHK
lin persuasion_N = mkWN (k48A "mielipide") ; --UNCHK
lin persuasive_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin persuasiveness_N = mkWN (k10 "voima") ; --UNCHK
lin pert_A = mkWA (k14A "räväkkä") ; --UNCHK
lin pertain_V = mkWV (k58 "koskea") "jtk" ; --UNCHK
lin pertainym_N = mkWN (k5 "adjektiivi") ; --UNCHK
lin perth_PN = foreignPN "Perth" ;
lin pertinacious_A = mkWA (k41A "sinnikäs") ; --UNCHK
lin pertinacity_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin pertinence_N = mkWN (k5 "relevanssi") ; --UNCHK
lin pertinent_A = mkWA (k38 "olennainen") ; --UNCHK
lin pertness_N = mkWN (k40 "pirteys") ; --UNCHK
lin pertteli_PN = mkPN "Pertteli" ;
lin pertunmaa_PN = mkPN "Pertunmaa" ;
lin perturb_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin perturbation_N = mkWN (k9A "häirintä") ; --UNCHK
lin peru_PN = foreignPN "Peru" ;
lin perugia_PN = foreignPN "Perugia" ;
lin peruke_N = mkWN (k5A "peruukki") ; --UNCHK
lin peruked_A = mkWA (k10 "pitävä") "peruukkia" ; --UNCHK
lin perusal_N = mkWN (k2 "opiskelu") ; --UNCHK
lin peruse_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin peruvian_A = mkWA (compoundA "peru" (k38 "lainen")) ; --UNCHK
lin peruvian_N = mkWN (compoundN "peru" (k38 "lainen")) ; --UNCHK
lin pervade_V2 = mkWV2 (k53A "täyttää") ; --UNCHK
lin pervaporation_N = mkWN (kH1 "läpi") "höyrystäminen" "välikalvon" ; --UNCHK
lin pervasion_N = mkWN "tunkeutuminen" ; --UNCHK
lin pervasive_A = mkA (mkN "läpi" (mkN "tunkeva")) ; --mkWA (k10 "pistävä") ;
lin pervasiveness_N = mkWN "läpitunkevuus" ; --UNCHK
lin perverse_A = mkWA (k47 "paatunut") ; --UNCHK
lin perverseness_N = mkWN (k40 "perverssiys") ; --UNCHK
lin perversion_N = mkWN (k2 "vääristely") ; --UNCHK
lin perversity_N = mkWN (k40 "perverssiys") ; --UNCHK
lin pervert_N = mkWN (k1 "pervo") ; --UNCHK
lin pervert_V2 = mkWV2 (k53A "käyttää") "väärin" ; --UNCHK
lin pervious_A = mkWA (compoundA "läpäis" (k10 "evä")) ; --UNCHK
lin pesantran_N = mkWN "pesantren" ; --UNCHK
lin pescara_PN = foreignPN "Pescara" ;
lin peseta_N = mkWN (k13 "peseta") "Espanjan" ; --UNCHK
lin pesewa_N = mkWN "pesewa" ; --UNCHK
lin peshmerga_N = mkWN "peshmerga" ; --UNCHK
lin pesky_A = mkWA (k10 "rasittava") ; --UNCHK
lin peso_N = mkWN (k1 "peso") ; --UNCHK
lin pessary_N = mkWN (k6 "pessaari") ; --UNCHK
lin pessimal_A = mkWA (compoundA "pessima" (k38 "alinen")) ; --UNCHK
lin pessimism_N = mkWN (k5 "pessimismi") ; --UNCHK
lin pessimistFem_N = mkWN (k5 "pessimisti") ; --UNCHK
lin pessimistMasc_N = mkWN (k5 "pessimisti") ; --UNCHK
lin pessimistic_A = mkWA (k38 "pessimistinen") ; --UNCHK
lin pest_N = mkWN (k38 "tuholainen") ; --UNCHK
lin pester_V2 = mkWV2 (k69 "häiritä") ; --UNCHK
lin pesthole_N = mkWN (compoundN "rutto" (k10 "pesä")) ; --UNCHK
lin pesticide_N = mkWN (compoundN "torjunta-" (k48 "aine")) ; --UNCHK
lin pestiferous_A = mkWA (k10 "rasittava") ; --UNCHK
lin pestilence_N = mkWN (k10A "syöpä") ; --UNCHK
lin pestilent_A = mkWA "leviävä" ; --UNCHK
lin pestilential_A = mkWA "leviävä" ; --UNCHK
lin pestle_N = mkWN (k33 "survin") ; --UNCHK
lin pestle_V2 = mkWV2 (k52 "survoa") ; --UNCHK
lin pesto_N = mkWN (k1 "pesto") ; --UNCHK
lin pet_N = mkN "lemmikki" ; --mkWN (compoundN "PET-" (k39 "kuvaus")) ;
lin pet_V2 = mkWV2 (k67 "sivellä") ; --UNCHK
lin petabit_N = mkWN (compoundN "peta" (k5A "bitti")) ; --UNCHK
lin petabyte_N = mkWN (compoundN "peta" (k1 "tavu")) ; --UNCHK
lin petal_N = mkWN (compoundN "terä" (k7A "lehti")) ; --UNCHK
lin petaled_A = mkWA (compoundA "teriö" (k38 "llinen")) ; --UNCHK
lin petalled_A = mkWA (compoundA "teriö" (k38 "llinen")) ; --UNCHK
lin petallike_A = mkWA (compoundA "terä" (k38 "lehtimäinen")) ; --UNCHK
lin petaloid_A = mkWA (compoundA "terä" (k38 "lehtimäinen")) ; --UNCHK
lin petalous_A = mkWA (compoundA "teriö" (k38 "llinen")) ; --UNCHK
lin petard_N = mkWN (compoundN "ruuti" (k9 "miina")) ; --UNCHK
lin petcock_N = mkWN (k6 "venttiili") ; --UNCHK
lin petechia_N = mkWN (compoundN "hiussuoni" (k10 "purkauma")) ; --UNCHK
lin peter_out_V = mkWV (k52 "väsyä") ; --UNCHK
lin peterborough_PN = foreignPN "Peterborough" ;
lin peterhead_PN = foreignPN "Peterhead" ;
lin peterlee_PN = foreignPN "Peterlee" ;
lin petersfield_PN = foreignPN "Petersfield" ;
lin petfood_N = mkWN (k10A "ruoka") "lemmikin" ; --UNCHK
lin petiole_N = mkWN (compoundN "lehti" (k5A "ruoti")) ; --UNCHK
lin petiolule_N = mkWN (k5A "ruoti") "lehdykän" ; --UNCHK
lin petit_bourgeois_N = mkWN (compoundN "pikku" (k1 "porvaristo")) ; --UNCHK
lin petite_A = mkWA (k10 "sorja") ; --UNCHK
lin petite_N = mkWN "petite" ; --UNCHK
lin petition_N = mkWN (k5 "adressi") ;
lin petition_V = mkWV (k58A "hakea") ; --UNCHK
lin petition_V2 = mkWV2 (k58A "hakea") ; --UNCHK
lin petitionary_A = mkWA "anomus-" ; --UNCHK
lin petitioner_N = mkWN (k10 "anoja") ; --UNCHK
lin petrel_N = mkWN (compoundN "myrsky" (k1A "lintu")) ; --UNCHK
lin petrifaction_N = mkWN (k10 "kivettymä") ; --UNCHK
lin petrify_V = mkWV (k53A "vakiinnuttaa") ; --UNCHK
lin petrify_V2 = mkWV2 (k53A "vakiinnuttaa") ; --UNCHK
lin petrissage_N = mkWN "pusertelu" ; --UNCHK
lin petrochemical_N = mkWN (compoundN "petro" (k5 "kemikaali")) ; --UNCHK
lin petroglyph_N = mkWN (compoundN "kallio" (k39 "piirros")) ; --UNCHK
lin petrol_N = mkWN (k9 "bensa") ; --UNCHK
lin petrolatum_N = mkWN (k5 "vaseliini") ; --UNCHK
lin petroleum_N = mkWN (k1 "öljy") ;
lin petrology_N = mkWN (k12 "petrologia") ; --UNCHK
lin petrous_A = mkWA (compoundA "kivi" (k38 "mäinen")) ; --UNCHK
lin petter_N = mkWN "koskettelija" ; --UNCHK
lin petticoat_N = mkWN (compoundN "alus" (k48 "hame")) ; --UNCHK
lin petticoated_A = mkWA (k10 "pitävä") "alushametta" ; --UNCHK
lin pettiness_N = mkWN (k40 "halpamaisuus") ; --UNCHK
lin pettish_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin pettishness_N = mkWN (k40 "äreys") ; --UNCHK
lin petty_A = mkWA (k38 "pikkumainen") ; --UNCHK
lin petulance_N = mkWN (k40 "äreys") ; --UNCHK
lin petulant_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin petunia_N = mkWN "Petunia" ; --UNCHK
lin petäjävesi_PN = mkPN (mkN "Petäjävesi" "Petäjäveden" "Petäjävesiä") ;
lin pew_N = mkWN (compoundN "kirkon" (k5A "penkki")) ; --UNCHK
lin pewee_N = mkWN "Contopus" "virens" ; --UNCHK
lin pewit_N = mkWN "Contopus" "virens" ; --UNCHK
lin pewter_N = mkWN (k9 "tina") ; --UNCHK
lin peyote_N = mkWN (k5 "meskaliini") ; --UNCHK
lin pfannkuchen_N = mkWN (compoundN "pannu" (k1A "kakku")) ; --UNCHK
lin pfennig_N = mkWN "pfennig" ; --UNCHK
lin ph_N = mkWN (k99 "pH") ; --UNCHK
lin phacoemulsification_N = mkWN "fakoemulsifikaatio" ; --UNCHK
lin phaeton_N = mkWN (compoundN "avo" (k1 "auto")) ; --UNCHK
lin phagocyte_N = mkWN (k5A "fagosyytti") ; --UNCHK
lin phagocytic_A = mkWA (compoundA "fagosyytti" (k38 "nen")) ; --UNCHK
lin phagocytosis_N = mkWN "fagosytoosi" ; --UNCHK
lin phaius_N = mkWN (k13 "orkidea") ; --UNCHK
lin phalangeal_A = mkWA "varvasjäsen-" ; --UNCHK
lin phalanger_N = mkWN (k5 "kuskus") ; --UNCHK
lin phalangitis_N = mkWN (compoundN "varvas" (k39 "tulehdus")) ; --UNCHK
lin phalanx_N = mkWN (k5 "falangi") ; --UNCHK
lin phalarope_N = mkWN (compoundN "vesi" (k1 "pääsky")) ; --UNCHK
lin phallic_A = mkWA (k38 "fallinen") ; --UNCHK
lin phalloplasty_N = mkWN (compoundN "fallopl" (k12 "astia")) ; --UNCHK
lin phallus_N = mkWN (k33 "elin") ; --UNCHK
lin phalsa_N = mkWN "Grewia" "asiatica" ; --UNCHK
lin phaneromania_N = mkWN (compoundN "fane" (k12 "romania")) ; --UNCHK
lin phantasm_N = mkWN (k39 "häivähdys") ; --UNCHK
lin phantasmagoria_N = mkWN (k9 "sarja") "harhanäkyjen" ; --UNCHK
lin phantasmagoric_A = mkWA (compoundA "epä" (k38 "todellinen")) ; --UNCHK
lin phantasmal_A = mkWA (k38 "henkinen") ; --UNCHK
lin phantasy_N = mkWN (k12 "fantasia") ; --UNCHK
lin phantom_A = mkWA "haamu-" ; --UNCHK
lin phantom_N = mkWN (k39 "häivähdys") ; --UNCHK
lin pharaoh_N = mkWN (k3 "faarao") "Egyptin" ; --UNCHK
lin pharisaic_A = mkWA (k38 "kaltainen") "fariseuksen" ; --UNCHK
lin pharisaical_A = mkWA (k38 "kaltainen") "fariseuksen" ; --UNCHK
lin pharisee_N = mkWN (k39 "fariseus") ; --UNCHK
lin pharmaceutical_A = mkA "farmakologinen" ;
lin pharmaceutical_N = mkWN (k48A "lääke") ; --UNCHK
lin pharmacist_N = mkWN (k6 "proviisori") ; --UNCHK
lin pharmacogenetics_N = mkWN (compoundN "farmakogen" (k14A "etiikka")) ; --UNCHK
lin pharmacokinetics_N = mkWN (compoundN "farmakokin" (k14A "etiikka")) ; --UNCHK
lin pharmacological_A = mkWA (k38 "farmakologinen") ; --UNCHK
lin pharmacologist_N = mkWN (k6 "proviisori") ; --UNCHK
lin pharmacology_N = mkWN (k12 "farmakologia") ; --UNCHK
lin pharmacopoeia_N = mkWN (compoundN "farma" (k15 "kopea")) ; --UNCHK
lin pharmacy_1_N = mkWN (k5A "apteekki") ;
lin pharmacy_2_N = mkWN (k5A "apteekki") ;
lin pharos_N = mkWN (k14A "majakka") ; --UNCHK
lin pharyngeal_A = mkWA (compoundA "farynga" (k38 "alinen")) ; --UNCHK
lin pharyngitis_N = mkWN (kH1 "kurkku") "arka" ; --UNCHK
lin pharynx_N = mkWN (kH1 "kurkku") ; --UNCHK
lin phase_N = mkWN (k48 "vaihe") ;
lin phase_V2 = mkWV2 (k53 "tahdistaa") ; --UNCHK
lin phase_out_V2 = mkWV2 (k53A "lopettaa") "vaiheittain" ; --UNCHK
lin phasianid_N = mkWN (compoundN "aito" (k9 "kana")) ; --UNCHK
lin phasmid_N = mkWN (k9A "kummitussirkka") ; --UNCHK
lin phd_N = mkWN "PhD" ; --UNCHK
lin pheasant_N = mkWN (k6 "fasaani") ; --UNCHK
lin phellem_N = mkWN (k5A "korkki") ; --UNCHK
lin phenazopyridine_N = mkWN "Pyridium" ; --UNCHK
lin phencyclidine_N = mkWN (k5 "heroiini") "synteettinen" ; --UNCHK
lin phenelzine_N = mkWN "Nardil" ; --UNCHK
lin pheniramine_N = mkWN "feniramiini" ; --UNCHK
lin phenol_N = mkWN (k5 "fenoli") ; --UNCHK
lin phenolphthalein_N = mkWN "fenoliftaleiini" ; --UNCHK
lin phenomenal_A = mkWA "ilmiötä" "koskeva" ; --UNCHK
lin phenomenology_N = mkWN (k12 "fenomenologia") ; --UNCHK
lin phenomenon_N = mkWN (k3 "ilmiö") ; --UNCHK
lin phenothiazine_N = mkWN "fentiatsiini" ; --UNCHK
lin phenotype_N = mkWN (compoundN "ilmi" (k1 "asu")) ; --UNCHK
lin phenotypical_A = mkWA (compoundA "feno" (k38 "tyyppinen")) ; --UNCHK
lin phensuximide_N = mkWN (k5 "fensuksimidi") ; --UNCHK
lin phentolamine_N = mkWN "Vasomax" ; --UNCHK
lin phenylalanine_N = mkWN (compoundN "fenyyliala" (k26 "niini")) ; --UNCHK
lin phenylephrine_N = mkWN "fenyyliefriini" ; --UNCHK
lin phenylketonuria_N = mkWN "PKU" ; --UNCHK
lin phenylpropanolamine_N = mkWN "fenyylipropanolamiini" ; --UNCHK
lin phenyltoloxamine_N = mkWN "fenyylitoloksamiini" ; --UNCHK
lin pheochromocytoma_N = mkWN (compoundN "feokromosyto" (k10 "oma")) ; --UNCHK
lin pheromone_N = mkWN (compoundN "fero" (k23 "moni")) ; --UNCHK
lin phi_N = mkWN "fii" ; --UNCHK
lin phial_N = mkWN (k5 "ampulli") ; --UNCHK
lin philadelphia_PN = foreignPN "Philadelphia" ;
lin philadelphus_N = mkWN (k48A "jasmike") ; --UNCHK
lin philander_V = mkWV (k73A "flirtata") ; --UNCHK
lin philanderer_N = mkWN (k12 "elostelija") ; --UNCHK
lin philanthropic_A = mkWA "hyväntekeväisyys-" ; --UNCHK
lin philanthropist_N = mkWN (k5A "filantrooppi") ; --UNCHK
lin philanthropy_N = mkWN (k12 "filantropia") ; --UNCHK
lin philatelic_A = mkWA (k38 "filateelinen") ; --UNCHK
lin philatelist_N = mkWN (k12 "postimerkkeilijä") ; --UNCHK
lin philately_N = mkWN (k2 "postimerkkeily") ; --UNCHK
lin philharmonic_A = mkWA (k38 "filharmoninen") ; --UNCHK
lin philhellene_A = mkWA (compoundA "kreikkalais" (k38 "ystävällinen")) ; --UNCHK
lin philhellene_N = mkWN (compoundN "fil" (k6 "helleeni")) ; --UNCHK
lin philhellenic_A = mkWA (compoundA "kreikkalais" (k38 "ystävällinen")) ; --UNCHK
lin philhellenism_N = mkWN (compoundN "fil" (k5 "hellenismi")) ; --UNCHK
lin philip_PN = foreignPN "Philip" ;
lin philippine_A = mkA "filippiiniläinen" ;
lin philippine_N = mkWN (compoundN "fili" (k1 "pino")) ; --UNCHK
lin philippines_PN = mkPN "Filippiini" ; ---- plural
lin philistine_N = mkWN (k38 "filistealainen") ; --UNCHK
lin philistinism_N = mkWN (k5 "materialismi") ; --UNCHK
lin phillipsite_N = mkWN "zeoliitti" ; --UNCHK
lin philodendron_N = mkWN (compoundN "liuska" (k9 "vehka")) ; --UNCHK
lin philogyny_N = mkWN (k2 "ihailu") "naisten" ; --UNCHK
lin philological_A = mkWA (k38 "filologinen") ; --UNCHK
lin philologist_N = mkWN (k5 "filologi") ; --UNCHK
lin philology_N = mkWN (k9A "lingvistiikka") ; --UNCHK
lin philomath_N = mkWN (k12 "tutkija") ; --UNCHK
lin philosopher_N = mkWN (k5 "filosofi") ;
lin philosophic_A = mkWA (k38 "filosofinen") ; --UNCHK
lin philosophical_A = mkWA (k38 "filosofinen") ; --UNCHK
lin philosophize_V = mkWV (k62 "filosofoida") ; --UNCHK
lin philosophizer_N = mkWN "filosofoija" ; --UNCHK
lin philosophizing_N = mkWN (k5A "filosofointi") ; --UNCHK
lin philosophy_N = mkWN (k5A "oppi") ; --UNCHK
lin philtre_N = mkWN (compoundN "taika" (k10 "juoma")) ; --UNCHK
lin phimosis_N = mkWN (kH1 "ahtaus") "esinahan" ; --UNCHK
lin phlebectomy_N = mkWN (compoundN "laskimonpoisto" (k39 "leikkaus")) ; --UNCHK
lin phlebitis_N = mkWN (compoundN "laskimo" (k39 "tulehdus")) ; --UNCHK
lin phlebothrombosis_N = mkWN "venous" "thrombosis" ; --UNCHK
lin phlebotomist_N = mkWN (compoundN "suonen" (k12 "iskijä")) ; --UNCHK
lin phlegm_N = mkWN (k40 "latteus") ; --UNCHK
lin phlegmatic_A = mkWA (k38 "flegmaattinen") ; --UNCHK
lin phlegmy_A = mkWA (k38 "limainen") ; --UNCHK
lin phloem_N = mkWN (k26 "niini") ; --UNCHK
lin phlogiston_N = mkWN "flogiston" ; --UNCHK
lin phlogopite_N = mkWN "flogopiitti" ; --UNCHK
lin phobia_N = mkWN (k6 "neuroosi") "foobinen" ; --UNCHK
lin phobic_A = mkWA "foobinen" ; --UNCHK
lin phobophobia_N = mkWN (compoundN "fobo" (k12 "fobia")) ; --UNCHK
lin phocine_A = mkWA (compoundA "hylje" (k38 "mäinen")) ; --UNCHK
lin phocomelia_N = mkWN "hyljeraajaisuus" ; --UNCHK
lin phoebe_N = mkWN "Sayornis" "phoebe" ; --UNCHK
lin phoenicophorium_N = mkWN (compoundN "Phoenicophorium-" (k1A "suku")) ; --UNCHK
lin phoenix_N = mkWN (compoundN "pää" (k5A "kaupunki")) "Arizonan" ; --UNCHK
lin phoenix_PN = foreignPN "Phoenix" ;
lin phon_N = mkWN "foni" ; --UNCHK
lin phone_N = mkN "puhelin" ;
lin phone_V = mkWV (k53A "soittaa") ; --UNCHK
lin phone_V2 = mkWV2 (k53A "soittaa") ; --UNCHK
lin phonebook_N = mkWN (compoundN "puhelin" (k2 "luettelo")) ; --UNCHK
lin phoneme_N = mkWN (k6 "foneemi") ; --UNCHK
lin phonemic_A = mkWA "foneemi-" ; --UNCHK
lin phonemic_Adv = mkWAdv "foneemisesti" ; --UNCHK
lin phonemics_N = mkWN (k12 "fonologia") ; --UNCHK
lin phonetic_A = mkWA (k38 "äänteellinen") ; --UNCHK
lin phonetician_N = mkWN (k4A "foneetikko") ; --UNCHK
lin phonetics_N = mkWN (k9A "fonetiikka") ; --UNCHK
lin phoney_A = mkWA (k10 "väärä") ; --UNCHK
lin phoney_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin phonic_A = mkWA (k38 "äänteellinen") ; --UNCHK
lin phonics_N = mkWN (compoundN "fon" (k9A "iikka")) ; --UNCHK
lin phonogram_N = mkWN (compoundN "äänne" (k6 "symboli")) ; --UNCHK
lin phonogramic_A = mkWA "äännesymboli-" ; --UNCHK
lin phonograph_N = mkWN (k5 "gramofoni") ; --UNCHK
lin phonological_A = mkWA (k38 "fonologinen") ; --UNCHK
lin phonologist_N = mkWN "fonologi" ; --UNCHK
lin phonology_N = mkWN (k12 "fonologia") ; --UNCHK
lin phonophobia_N = mkWN (k1A "pelko") "äänien" ; --UNCHK
lin phony_A = mkA "teeskentelevä" ; --mkWA (k10 "väärä") ;
lin phony_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin phoronid_N = mkWN (compoundN "tupsu" (k1A "mato")) ; --UNCHK
lin phosgene_N = mkWN (compoundN "fos" (k5 "geeni")) ; --UNCHK
lin phosphate_N = mkWN (k5A "fosfaatti") ; --UNCHK
lin phosphine_N = mkWN (compoundN "fos" (k5 "fiini")) ; --UNCHK
lin phosphocreatine_N = mkWN (compoundN "kreatiini" (k5A "fosfaatti")) ; --UNCHK
lin phospholipid_N = mkWN (compoundN "fosfo" (k5 "lipidi")) ; --UNCHK
lin phosphoprotein_N = mkWN (compoundN "fosfo" (k5 "proteiini")) ; --UNCHK
lin phosphor_N = mkWN (k5 "fosfori") ; --UNCHK
lin phosphorescence_N = mkWN (k5 "fosforesenssi") ; --UNCHK
lin phosphorescent_A = mkWA (compoundA "fosfor" (k10 "oiva")) ; --UNCHK
lin phosphoric_A = mkWA (compoundA "fosforipi" (k38 "toinen")) ; --UNCHK
lin phosphorous_A = mkWA (compoundA "fosforipi" (k38 "toinen")) ; --UNCHK
lin phosphorus_N = mkWN (compoundN "koin" (k7A "tähti")) ; --UNCHK
lin photalgia_N = mkWN (compoundN "valon" (k40 "arkuus")) ; --UNCHK
lin photic_A = mkWA "valo-" ; --UNCHK
lin photo_N = mkN "valokuva" ; --WN (k1 "foto") ;
lin photocathode_N = mkWN (compoundN "foto" (k5 "katodi")) ; --UNCHK
lin photochemical_A = mkWA (compoundA "valo" (k38 "kemiallinen")) ; --UNCHK
lin photochemistry_N = mkWN (compoundN "valo" (k12 "kemia")) ; --UNCHK
lin photocoagulation_N = mkWN (compoundN "foto" (k3 "koagulaatio")) ; --UNCHK
lin photoconductive_A = mkWA (compoundA "valo" (k10 "johtava")) ; --UNCHK
lin photoconductivity_N = mkWN (compoundN "valo" (k40 "johtavuus")) ; --UNCHK
lin photocopier_N = mkWN (compoundN "kopio" (k48 "kone")) ; --UNCHK
lin photocopy_N = mkWN (compoundN "valo" (k3 "kopio")) ; --UNCHK
lin photocopy_V2 = mkWV2 (k62 "kopioida") ; --UNCHK
lin photoelectric_A = mkWA "valosähkö-" ; --UNCHK
lin photoelectricity_N = mkWN (compoundN "valosähkö" (k40 "isyys")) ; --UNCHK
lin photoelectron_N = mkWN (compoundN "foto" (k5 "elektroni")) ; --UNCHK
lin photoemission_N = mkWN (compoundN "valo" (k3 "emissio")) ; --UNCHK
lin photoemissive_A = mkWA "valoemissio-" ; --UNCHK
lin photoflash_N = mkWN (k12 "salama") ; --UNCHK
lin photogenic_A = mkWA (compoundA "valo" (k38 "kuvauksellinen")) ; --UNCHK
lin photograph_N = mkN "valokuva" ;
lin photograph_V2 = mkWV2 (k53A "ottaa") "valokuva" ; --UNCHK
lin photographer_N = mkWN (k10 "kuvaaja") ; --UNCHK
lin photographic_A = mkWA "valokuvaus-" ; --UNCHK
lin photography_N = mkWN (k39 "kuvaus") ; --UNCHK
lin photogravure_N = mkWN (k50 "syväpaino") ; --UNCHK
lin photojournalism_N = mkWN (compoundN "kuva" (k5 "journalismi")) ; --UNCHK
lin photojournalist_N = mkWN (compoundN "valokuva" (k5 "journalisti")) ; --UNCHK
lin photolithograph_N = mkWN (compoundN "valo" (k12 "litografia")) ; --UNCHK
lin photolithography_N = mkWN (k12 "litografia") "optinen" ; --UNCHK
lin photomechanical_A = mkWA (compoundA "valo" (k38 "mekaaninen")) ; --UNCHK
lin photomechanics_N = mkWN (k10 "menetelmä") "fotomekaaninen" ; --UNCHK
lin photometer_N = mkWN (compoundN "valotus" (k6 "mittari")) ; --UNCHK
lin photometric_A = mkWA (compoundA "foto" (k38 "metrinen")) ; --UNCHK
lin photometrist_N = mkWN (compoundN "asian" (k12 "tuntija")) "fotometrian" ; --UNCHK
lin photometry_N = mkWN "fotometria" ; --UNCHK
lin photomicrograph_N = mkWN "mikrovalokuva" ; --UNCHK
lin photomontage_N = mkWN (compoundN "valokuva" (k5 "montaasi")) ; --UNCHK
lin photon_N = mkWN (k6 "fotoni") ; --UNCHK
lin photophobia_N = mkWN (compoundN "valon" (k40 "arkuus")) ; --UNCHK
lin photopigment_N = mkWN (compoundN "foto" (k5A "pigmentti")) ; --UNCHK
lin photoretinitis_N = mkWN (compoundN "verkkokalvo" (k39 "tulehdus")) ; --UNCHK
lin photosensitivity_N = mkWN (compoundN "säde" (k40 "herkkyys")) ; --UNCHK
lin photosensitize_V2 = mkWV2 (k53 "herkistää") "valolle" ; --UNCHK
lin photosphere_N = mkWN (compoundN "foto" (k5 "sfääri")) ; --UNCHK
lin photostat_N = mkWN (compoundN "Photostat-" (k48A "laite")) ; --UNCHK
lin photostat_V2 = mkWV2 (k71 "tehdä") "fotostaatti" ; --UNCHK
lin photosynthesis_N = mkWN (compoundN "foto" (k5 "synteesi")) ; --UNCHK
lin photosynthetic_A = mkWA (compoundA "foto" (k38 "synteettinen")) ; --UNCHK
lin phototherapy_N = mkWN (compoundN "valo" (k1A "hoito")) ; --UNCHK
lin phototropism_N = mkWN (compoundN "foto" (k5 "tropismi")) ; --UNCHK
lin photovoltaic_A = mkWA (compoundA "valo" (k38 "sähköinen")) ; --UNCHK
lin phragmocone_N = mkWN (kH1 "kuori") "lokerorakenteinen" ; --UNCHK
lin phrasal_A = mkWA "fraasi-" ; --UNCHK
lin phrase_N = mkWN (k5 "fraasi") ; --UNCHK
lin phrase_V2 = mkWV2 (k73 "fraseerata") ; --UNCHK
lin phrase_book_N = mkWN "tulkkisanakirja" ; --UNCHK
lin phraseology_N = mkWN (k12 "fraseologia") ; --UNCHK
lin phrasing_N = mkWN (k39 "fraseeraus") ; --UNCHK
lin phreatic_A = mkWA "pohjavesi-" ; --UNCHK
lin phrenetic_A = mkWA (k10 "raivoisa") ; --UNCHK
lin phrenic_A = mkWA "pallea-" ; --UNCHK
lin phrenological_A = mkWA "frenologinen" ; --UNCHK
lin phrenologist_N = mkWN "kraniologi" ; --UNCHK
lin phrenology_N = mkWN "frenologia" ; --UNCHK
lin phrontistery_N = mkWN (k39 "laitos") ; --UNCHK
lin phthisis_N = mkWN (compoundN "keuhko" (k5 "tuberkuloosi")) ; --UNCHK
lin phycobilin_N = mkWN "fykobiliini" ; --UNCHK
lin phycoerythrin_N = mkWN "fykoerytriini" ; --UNCHK
lin phycology_N = mkWN (compoundN "levä" (k39 "tutkimus")) ; --UNCHK
lin phycomycosis_N = mkWN "fykomykoosi" ; --UNCHK
lin phylactery_N = mkWN (compoundN "raamatunlause" (k2 "kotelo")) ; --UNCHK
lin phyle_N = mkWN "fyle" ; --UNCHK
lin phylliform_A = mkWA (k38 "muotoinen") "lehden" ; --UNCHK
lin phyllo_N = mkWN (compoundN "filo-" (k12 "taikina")) ; --UNCHK
lin phyllode_N = mkWN (compoundN "laaka" (k5A "ruoti")) ; --UNCHK
lin phyllodial_A = mkWA (compoundA "laaka" (k38 "ruodillinen")) ; --UNCHK
lin phylogenetic_A = mkWA (compoundA "fylo" (k38 "geneettinen")) ; --UNCHK
lin phylum_N = mkWN (compoundN "pää" (k1 "jakso")) ; --UNCHK
lin physa_N = mkWN (k2 "kotilo") ; --UNCHK
lin physic_N = mkWN (k5 "laksatiivi") ; --UNCHK
lin physical_A = mkA "fyysinen" | mkA "fysikaalinen" | mkWA (k38 "ruumiillinen") ; ---- split
lin physician_N = mkWN (k6 "tohtori") ; --UNCHK
lin physicist_N = mkWN (k4A "fyysikko") ; --UNCHK
lin physicochemical_A = mkWA (compoundA "fysiko" (k38 "kemiallinen")) ; --UNCHK
lin physics_N = mkWN (k14A "fysiikka") ;
lin physiognomy_N = mkWN (kH1 "turpa") ; --UNCHK
lin physiologic_A = mkWA (k38 "fysiologinen") ; --UNCHK
lin physiological_A = mkWA (k38 "fysiologinen") ; --UNCHK
lin physiologist_N = mkWN (k5 "fysiologi") ; --UNCHK
lin physiology_N = mkWN (k12 "fysiologia") ; --UNCHK
lin physiotherapeutic_A = mkWA (compoundA "fysio" (k38 "terapeuttinen")) ; --UNCHK
lin physiotherapist_N = mkWN (compoundN "lääkintä" (k12 "voimistelija")) ; --UNCHK
lin physiotherapy_N = mkWN (k1A "hoito") "fysikaalinen" ; --UNCHK
lin physique_N = mkWN (k48A "rakenne") ; --UNCHK
lin physostegia_N = mkWN (compoundN "kello" (k5A "peippi")) ; --UNCHK
lin physostigmine_N = mkWN "fysostigmiini" ; --UNCHK
lin phytelephas_N = mkWN (compoundN "Phytelephas-" (k1A "suku")) ; --UNCHK
lin phytochemical_N = mkWN (compoundN "fyto" (k5 "kemikaali")) ; --UNCHK
lin phytochemist_N = mkWN (compoundN "asian" (k12 "tuntija")) "fytokemian" ; --UNCHK
lin phytochemistry_N = mkWN (compoundN "fyto" (k12 "kemia")) ; --UNCHK
lin phytohormone_N = mkWN (k48 "aine") "kasvua" "säätelevä" ; --UNCHK
lin phytoplankton_N = mkWN (compoundN "kasvi" (k5 "plankton")) ; --UNCHK
lin phytotherapy_N = mkWN (compoundN "kasvi" (k9A "lääkintä")) ; --UNCHK
lin pi_N = mkWN (k10 "estäjä") "proteaasin" ; --UNCHK
lin pia_N = mkWN "Tacca" "pinnatifida" ; --UNCHK
lin piacenza_PN = foreignPN "Piacenza" ;
lin piaffe_N = mkWN (k99 "paikallaan") "liitoravi" ; --UNCHK
lin pianism_N = mkWN (compoundN "piano" (k48A "taide")) ; --UNCHK
lin pianissimo_A = mkWA "pianissimo" ; --UNCHK
lin pianissimo_Adv = mkWAdv (k99 "hiljaa") "hyvin" ; --UNCHK
lin pianistFem_N = mkWN (k5 "pianisti") ;
lin pianistMasc_N = mkWN (k5 "pianisti") ;
lin pianistic_A = mkWA "pianonsoitto-" ; --UNCHK
lin piano_A = mkWA (k38 "hiljainen") ; --UNCHK
lin piano_Adv = mkWAdv (k99 "hiljaa") ; --UNCHK
lin piano_N = mkWN (k1 "piano") ;
lin pianoforte_N = mkWN (k1 "piano") ; --UNCHK
lin pianola_N = mkWN (k1 "piano") "mekaaninen" ; --UNCHK
lin piazza_N = mkWN (k5 "tori") ; --UNCHK
lin pibroch_N = mkWN (compoundN "säkkipilli" (k10 "sävelmä")) ; --UNCHK
lin pica_N = mkWN (compoundN "Pica-" (k1A "suku")) ; --UNCHK
lin picador_N = mkWN (compoundN "pikad" (k48 "ori")) ; --UNCHK
lin picaresque_A = mkWA "veijari-" ; --UNCHK
lin piccalilli_N = mkWN "pikkelsi" ; --UNCHK
lin piccaninny_N = mkWN (compoundN "neekeri" (k12 "kakara")) ; --UNCHK
lin piccolo_N = mkWN (compoundN "pikkolo" (k1 "huilu")) ; --UNCHK
lin pichi_N = mkWN "Fabiana" "imbricata" ; --UNCHK
lin pichiciago_N = mkWN (compoundN "pikkukaivaja" (k38 "vyötiäinen")) ; --UNCHK
lin pick_N = mkWN (k9A "valinta") ;
lin pick_V = mkV "poimia" | mkV "kerätä" | mkV "valita" | mkV "nyppiä" ;
lin pick_V2 = mkV2 "poimia" partitive | mkV2 "kerätä" partitive ;
lin pick_at_V2 = mkWV2 (k54A "halventaa") ; --UNCHK
lin pick_away_V = advV OP_pick_V OP_away_Adv ; -- guess-p-verb
lin pick_off_V2 = mkWV2 (k66 "kiskaista") ; --UNCHK
lin pick_on_V2 = prepV2 OP_pick_V OP_on_Prep ; -- guess-p-verb
lin pick_out_V2 = mkWV2 (k61 "poimia") ; --UNCHK
lin pick_through_V2 = prepV2 OP_pick_V OP_through_Prep ; -- guess-p-verb
lin pick_up_V = mkWV (k52 "piristyä") ; --UNCHK
lin pick_up_V2 = mkWV2 (k52 "piristyä") ; --UNCHK
lin pick_up_after_V2 = prepV2 (advV OP_pick_V OP_up_Adv ) OP_after_Prep ; -- guess-p-verb
lin pick_up_on_V2 = prepV2 (advV OP_pick_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin pick_yourself_up_V = variants {} ; -- guess-p-verb
lin pickaback_Adv = mkWAdv (k10 "reppuselässä") ; --UNCHK
lin pickaxe_N = mkWN (k1A "hakku") ; --UNCHK
lin pickelhaube_N = mkWN (compoundN "piikki" (k10 "kypärä")) ; --UNCHK
lin picker_N = mkN "valitsija" ; --mkWN (k12 "poimija") ;
lin pickerel_N = mkWN (k7A "hauki") ; --UNCHK
lin pickerelweed_N = mkWN (compoundN "cor" (k9 "data")) "Pontederia" ; --UNCHK
lin picket_N = mkWN (k39 "rangaistus") ; --UNCHK
lin picket_V = mkWV (k52A "sitoa") "paaluun" ; --UNCHK
lin picket_V2 = mkWV2 (k52A "sitoa") "paaluun" ; --UNCHK
lin picking_N = mkWN (k9A "poiminta") ; --UNCHK
lin pickings_N = mkWN (k1A "otto") ; --UNCHK
lin pickle_N = mkWN (k1A "suolakurkku") ; --UNCHK
lin pickle_V2 = mkWV2 (k52 "säilöä") ; --UNCHK
lin pickpocket_N = mkWN (compoundN "tasku" (k41A "varas")) ; --UNCHK
lin pick_up_N = mkWN (compoundN "kyytiin" (k1A "otto")) ; --UNCHK
lin picnic_N = mkN "piknik" ;
lin picnic_V = mkWV (k65 "käydä") "piknikillä" ; --UNCHK
lin picnicker_N = mkWN (compoundN "huvi" (k38 "retkeläinen")) ; --UNCHK
lin picofarad_N = mkWN (compoundN "piko" (k5 "faradi")) ; --UNCHK
lin picometer_N = mkWN "mikromillimetri" ; --UNCHK
lin picornavirus_N = mkWN (compoundN "pikorna" (k39 "virus")) ; --UNCHK
lin picosecond_N = mkWN (compoundN "piko" (k5A "sekunti")) ; --UNCHK
lin picot_N = mkWN (k1A "nirkko") ; --UNCHK
lin picovolt_N = mkWN (k5A "pikovoltti") ; --UNCHK
lin pictograph_N = mkWN (compoundN "kuvakirjoitus" (k5A "merkki")) ; --UNCHK
lin pictographic_A = mkWA "piktografinen" ; --UNCHK
lin pictorial_A = mkWA (k38 "kuvallinen") ; --UNCHK
lin pictorial_N = mkWN (compoundN "vakokuva" (k5A "raportti")) ; --UNCHK
lin picture_N = mkN "kuva" ;
lin picture_V2 = mkWV2 (k62 "visioida") ; --UNCHK
lin picture_book_N = mkWN (compoundN "kuva" (k9 "kirja")) ; --UNCHK
lin picture_card_N = mkWN (compoundN "kuva" (k5A "kortti")) ; --UNCHK
lin picture_gallery_N = mkWN (k12 "galleria") ; --UNCHK
lin picturesque_A = mkWA (k5 "pittoreski") ; --UNCHK
lin picturesqueness_N = mkWN (k40 "elävyys") ; --UNCHK
lin picturing_N = mkWN (k39 "esitys") "kuvallinen" ; --UNCHK
lin picul_N = mkWN "pikul" ; --UNCHK
lin piculet_N = mkWN (compoundN "tikka" (k38 "nen")) ; --UNCHK
lin piddle_N = mkWN (k5 "pissi") ; --UNCHK
lin piddle_V = mkWV (k53A "heittää") "vettä" ; --UNCHK
lin piddock_N = mkWN (compoundN "nävertäjä" (k14A "simpukka")) ; --UNCHK
lin pidgin_N = mkWN (compoundN "seka" (k26 "kieli")) ; --UNCHK
lin pie_N = mkN "piirakka" ; --mkWN (compoundN "kanta" (k26 "kieli")) "indoeurooppalainen" ;
lin pie_crust_N = mkWN (compoundN "piirakka" (k12 "taikina")) ; --UNCHK
lin piebald_A = mkWA (k41A "laikukas") ; --UNCHK
lin piece_N = mkN "pala" | mkN "palanen" ;
lin piece_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin piecemeal_A = mkWA (k38 "vähittäinen") ; --UNCHK
lin piecemeal_Adv = mkWAdv (k99 "asteittain") ; --UNCHK
lin piecework_N = mkWN (compoundN "urakka" (k19 "työ")) ; --UNCHK
lin pied_A = mkWA (k41A "laikukas") ; --UNCHK
lin piedmont_N = mkWN "Piemonte" ; --UNCHK
lin pieksämäki_PN = mkPN (mkN "Pieksämäki" "Pieksämäkiä") ;
lin pielavesi_PN = mkPN (mkN "Pielavesi" "Pielaveden" "Pielavesiä") ;
lin pieplant_N = mkWN (k5 "raparperi") ; --UNCHK
lin pier_N = mkWN (k10 "satama") ; --UNCHK
lin pier_glass_N = mkWN (compoundN "seinä" (k5 "peili")) ; --UNCHK
lin pierce_V = mkWV (k66 "puhkaista") ; --UNCHK
lin pierce_V2 = mkWV2 (k66 "puhkaista") ; --UNCHK
lin piercingly_Adv = mkWAdv (k99 "läpitunkevasti") ; --UNCHK
lin pierid_N = mkWN (compoundN "kaali" (k38 "perhonen")) ; --UNCHK
lin pietistic_A = mkWA (k38 "pietistinen") ; --UNCHK
lin piety_N = mkWN (k40 "hurskaus") ; --UNCHK
lin piezoelectric_A = mkWA (compoundA "pietso" (k38 "sähköinen")) ; --UNCHK
lin piezoelectricity_N = mkWN (k3 "ilmiö") "pietsosähköinen" ; --UNCHK
lin piezometer_N = mkWN (compoundN "pietso" (k5 "metri")) ; --UNCHK
lin piffle_N = mkWN (k99 "soopa") ; --UNCHK
lin piffle_V = mkWV (k67 "hölmöillä") ; --UNCHK
lin pig_N = mkN "sika" ;
lin pig_V = mkWV (k61 "porsia") ; --UNCHK
lin pig_iron_N = mkWN (k50 "raakarauta") ; --UNCHK
lin pig_out_V = mkWV (k61 "hotkia") ; --UNCHK
lin pigboat_N = mkWN (compoundN "sukellus" (k48 "vene")) ; --UNCHK
lin pigeon_N = mkWN (k1 "pulu") ; --UNCHK
lin pigeonhole_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin pigfish_N = mkWN (compoundN "porsasmuri" (k9 "sija")) ; --UNCHK
lin piggery_N = mkWN (k13 "sikala") ; --UNCHK
lin piggish_A = mkWA (k38 "sottainen") ; --UNCHK
lin piggishness_N = mkWN (k2 "sikailu") ; --UNCHK
lin piggy_A = mkWA (k38 "sottainen") ; --UNCHK
lin piggy_N = mkWN (k1 "possu") ; --UNCHK
lin piggyback_Adv = mkWAdv (k10 "reppuselässä") ; --UNCHK
lin piggyback_N = mkWN (compoundN "kanta" (k38 "minen")) "reppuselässä" ; --UNCHK
lin piggyback_V = mkWV (k53A "liittää") ; --UNCHK
lin piglet_N = mkWN (k1 "possu") ; --UNCHK
lin pigment_N = mkWN (k5A "pigmentti") ; --UNCHK
lin pigmentation_N = mkWN (k39 "väritys") ; --UNCHK
lin pigmy_N = mkWN "Pygmi" ; --UNCHK
lin pignut_N = mkWN (k6 "hikkori") ; --UNCHK
lin pigskin_N = mkWN (compoundN "sian" (k9 "nahka")) ; --UNCHK
lin pig_sticking_N = mkWN (compoundN "villisian" (k39 "metsästys")) ; --UNCHK
lin pigsty_N = mkWN (k5A "sikolätti") ; --UNCHK
lin pigswill_N = mkWN (k1 "litku") ; --UNCHK
lin pigtail_N = mkWN (k2 "saparo") ; --UNCHK
lin pigwash_N = mkWN (k1 "litku") ; --UNCHK
lin pigweed_N = mkWN (compoundN "villi" (k5A "pinaatti")) ; --UNCHK
lin pihtipudas_PN = mkPN "Pihtipudas" ;
lin piikkiö_PN = mkPN "Piikkiö" ;
lin piippola_PN = mkPN "Piippola" ;
lin pika_N = mkWN (compoundN "piisku" (k39 "jänis")) ; --UNCHK
lin pike_N = mkWN (k7A "hauki") ; --UNCHK
lin pikeblenny_N = mkWN (compoundN "lima" (k9 "kala")) ; --UNCHK
lin pikestaff_N = mkWN (compoundN "keihään" (k28 "varsi")) ; --UNCHK
lin pilaff_N = mkWN (k5 "pilahvi") ; --UNCHK
lin pilar_A = mkWA "karva-" ; --UNCHK
lin pilaster_N = mkWN (k6 "pilasteri") ; --UNCHK
lin pilchard_N = mkWN (k6 "sardiini") ; --UNCHK
lin pile_N = mkWN (k6 "reaktori") ; --UNCHK
lin pile_V = mkWV (k73 "kasata") ; --UNCHK
lin pile_V2 = mkWV2 (k73 "kasata") ; --UNCHK
lin pile_driver_N = mkWN (k10A "paalujuntta") ; --UNCHK
lin pile_dwelling_N = mkWN (compoundN "paalu" (k9 "maja")) ; --UNCHK
lin pile_up_V = mkWV (k52A "kertyä") ; --UNCHK
lin pile_up_V2 = mkWV2 (k52A "kertyä") ; --UNCHK
lin piles_N = mkWN (k99 "roppakaupalla") ; --UNCHK
lin pile_up_N = mkWN (compoundN "ketju" (k6 "kolari")) ; --UNCHK
lin pilfer_V = mkWV (k67 "näpistellä") ; --UNCHK
lin pilfer_V2 = mkWV2 (k67 "näpistellä") ; --UNCHK
lin pilferage_N = mkWN (k2 "näpistely") ; --UNCHK
lin pilferer_N = mkWN (k12 "näpistelijä") ; --UNCHK
lin pilgrim_N = mkWN (k10 "vaeltaja") ; --UNCHK
lin pilgrimage_N = mkWN (compoundN "pyhiinvaellus" (k9 "matka")) ; --UNCHK
lin pill_N = mkN "pilleri" ;
lin pill_PN = foreignPN "Pill" ;
lin pillage_N = mkWN (k1 "ryöstö") ; --UNCHK
lin pillage_V2 = mkWV2 (k53 "anastaa") ; --UNCHK
lin pillager_N = mkWN (k10 "ryöstäjä") ; --UNCHK
lin pillar_N = mkWN (k6 "pilari") ;
lin pillar_box_N = mkWN (compoundN "posti" (k4A "laatikko")) "pylvään" "muotoinen" ; --UNCHK
lin pillared_A = mkWA "pylväs-" ; --UNCHK
lin pillbox_N = mkWN (k6 "bunkkeri") ; --UNCHK
lin pillion_N = mkWN (compoundN "taka" (k12 "satula")) ; --UNCHK
lin pillory_N = mkWN (compoundN "häpeä" (k1 "paalu")) ; --UNCHK
lin pillory_V2 = mkWV2 (k61A "sättiä") ; --UNCHK
lin pillow_N = mkWN (k1 "tyyny") ; --UNCHK
lin pillow_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin pillow_fight_N = mkWN (compoundN "tyyny" (k10A "sota")) ; --UNCHK
lin pillowcase_N = mkWN (compoundN "tyyny" (k9 "liina")) ; --UNCHK
lin pillwort_N = mkWN "Pilularia" "globulifera" ; --UNCHK
lin pilocarpine_N = mkWN "pilokarpiini" ; --UNCHK
lin pilot_N = mkN "lentäjä" ;
lin pilot_V2 = mkWV2 (k73 "luotsata") ; --UNCHK
lin pilot_boat_N = mkWN (compoundN "luotsi" (k48 "vene")) ; --UNCHK
lin pilot_burner_N = mkWN (compoundN "sytytys" (k5A "liekki")) ; --UNCHK
lin pilot_cloth_N = mkWN (k41A "villakangas") "tummansininen" ; --UNCHK
lin pilot_engine_N = mkWN (compoundN "apu" (k6 "veturi")) ; --UNCHK
lin pilot_light_N = mkWN (compoundN "sytytys" (k5A "liekki")) ; --UNCHK
lin pilot_fish_N = mkWN (compoundN "luotsi" (k9 "kala")) ; --UNCHK
lin pilothouse_N = mkWN (compoundN "ohjaus" (k5A "hytti")) ; --UNCHK
lin pilotless_A = mkWA (k34A "miehittämätön") ; --UNCHK
lin pilous_A = mkWA (k38 "nukkainen") ; --UNCHK
lin pilus_N = mkWN (k10A "nukka") ; --UNCHK
lin pimento_N = mkWN (k12 "paprika") ; --UNCHK
lin pimozide_N = mkWN "pimotsidi" ; --UNCHK
lin pimp_N = mkWN (k5 "sutenööri") ; --UNCHK
lin pimp_V = mkWV (k61 "toimia") "sutenöörinä" ; --UNCHK
lin pimpernel_N = mkWN (compoundN "puna-" (k7A "alpi")) ; --UNCHK
lin pimple_N = mkWN (k1A "näppy") ; --UNCHK
lin pimpled_A = mkWA (k38 "näppyläinen") ; --UNCHK
lin pimply_A = mkWA (k38 "näppyläinen") ; --UNCHK
lin pin_N = mkWN (k9 "keila") ; --UNCHK
lin pin_V2 = mkWV2 (k53A "kiinnittää") ;
lin pin_down_V2 = mkWV2 (k73 "rajata") ; --UNCHK
lin pin_money_N = mkWN (compoundN "tasku" (k9 "raha")) ; --UNCHK
lin pin_point_V2 = mkV2 "paikantaa" | mkWV2 (k53A "selvittää") ; --UNCHK
lin pin_table_N = mkWN (k6 "flipperi") ; --UNCHK
lin pin_up_V2 = mkWV2 (k53A "kiinnittää") "neulalla" ; --UNCHK
lin pinafore_N = mkWN (k1 "essu") ; --UNCHK
lin pinata_N = mkWN "piñata" ; --UNCHK
lin pinball_N = mkWN (k6 "flipperi") ; --UNCHK
lin pincer_N = mkWN "saksi" ; --UNCHK
lin pinch_N = mkWN (k99 "kiinni") "saada" ; --UNCHK
lin pinch_V = mkWV (k52 "vihloa") ; --UNCHK
lin pinch_V2 = mkWV2 (k52 "vihloa") ; --UNCHK
lin pinchbeck_A = mkWA "vale-" ; --UNCHK
lin pinchbeck_N = mkWN (k5A "pinspakki") ; --UNCHK
lin pinchgut_N = mkWN (k6 "saituri") ; --UNCHK
lin pincushion_N = mkWN (compoundN "neula" (k1 "tyyny")) ; --UNCHK
lin pine_N = mkWN (k1A "mänty") ; --UNCHK
lin pine_V = mkWV (k52A "riutua") "ikävästä" ; --UNCHK
lin pine_away_V = mkWV (k52A "kuihtua") ; --UNCHK
lin pineal_A = mkWA "käpylisäkkeen" ; --UNCHK
lin pinealoma_N = mkWN (compoundN "käpylisäke" (k33 "kasvain")) ; --UNCHK
lin pineapple_N = mkWN (k39 "ananas") ; --UNCHK
lin pinecone_N = mkWN (compoundN "männyn" (k1A "käpy")) ; --UNCHK
lin pinesap_N = mkWN (compoundN "mänty" (k10A "kukka")) ; --UNCHK
lin pinetum_N = mkWN (compoundN "havupuu" (k10 "viljelmä")) ; --UNCHK
lin pinfish_N = mkWN "Lagodon" "rhomboides" ; --UNCHK
lin pinfold_N = mkWN (k9 "tarha") ; --UNCHK
lin ping_N = mkWN (k39 "kilahdus") ; --UNCHK
lin ping_V = mkWV (k53A "lähettää") "ping-komento" ; --UNCHK
lin pinguecula_N = mkWN (compoundN "rasvakudos" (k10 "täplä")) ; --UNCHK
lin pinhead_N = mkWN (k18 "pää") "nuppineulan" ; --UNCHK
lin pinhole_N = mkWN (compoundN "neulan" (k10A "reikä")) ; --UNCHK
lin pining_N = mkWN (k5A "ikävöinti") ; --UNCHK
lin pinion_N = mkWN (k7A "siipi") ; --UNCHK
lin pinion_V2 = mkWV2 (k73A "leikata") "siivet" ; --UNCHK
lin pinite_N = mkWN "piniitti" ; --UNCHK
lin pink_A = mkWA (compoundA "vaalean" (k38 "punainen")) ; --UNCHK
lin pink_N = mkWN (compoundN "vaalean" (k38 "punainen")) ; --UNCHK
lin pink_V = mkWV (k73A "leikata") "siksak-saksilla" ; --UNCHK
lin pink_V2 = mkWV2 (k73A "leikata") "siksak-saksilla" ; --UNCHK
lin pinkish_A = mkWA (compoundA "vaalean" (k38 "punainen")) ; --UNCHK
lin pinkness_N = mkWN (compoundN "vaalean" (k40 "punaisuus")) ; --UNCHK
lin pinko_N = mkWN (k38 "vasemmistolainen") ; --UNCHK
lin pinkroot_N = mkWN (compoundN "sieni" (k5A "tauti")) ; --UNCHK
lin pinna_N = mkWN (compoundN "ulko" (k10 "korva")) ; --UNCHK
lin pinnace_N = mkWN (kH1 "kutteri") ; --UNCHK
lin pinnacle_N = mkWN (compoundN "pienois" (k5 "torni")) ; --UNCHK
lin pinnacle_V2 = mkWV2 (k53A "asettaa") "huipulle" ; --UNCHK
lin pinnate_A = mkWA (compoundA "pari" (k38 "lehtinen")) ; --UNCHK
lin pinnatifid_A = mkWA (compoundA "par" (k38 "ijakoinen")) ; --UNCHK
lin pinnatisect_A = mkWA (compoundA "par" (k38 "iosainen")) ; --UNCHK
lin pinner_N = mkWN (k48 "päähine") ; --UNCHK
lin pinning_N = mkWN (compoundN "uskollisuus" (k39 "lupaus")) ; --UNCHK
lin pinny_N = mkWN (k1 "essu") ; --UNCHK
lin pinochle_N = mkWN "bezique" ; --UNCHK
lin pinocytosis_N = mkWN "pinosytoosi" ; --UNCHK
lin pinole_N = mkWN "pinole" ; --UNCHK
lin pinon_N = mkWN (compoundN "pähkinä" (k1A "mänty")) ; --UNCHK
lin pinpoint_N = mkWN (compoundN "neulan" (k7A "kärki")) ; --UNCHK
lin pinprick_N = mkWN (compoundN "neulan" (k1 "pisto")) ; --UNCHK
lin pinscher_N = mkWN (k6 "pinseri") ; --UNCHK
lin pinstripe_N = mkWN (k9A "liituraita") ; --UNCHK
lin pinstriped_A = mkWA "liituraita-" ; --UNCHK
lin pint_N = mkWN "0,47" "l" ; --UNCHK
lin pintail_N = mkWN (compoundN "jouhi" (k10 "sorsa")) ; --UNCHK
lin pintle_N = mkWN (compoundN "sarana" (k5A "tappi")) ; --UNCHK
lin pinto_N = mkWN (k5 "poni") "kirjava" ; --UNCHK
lin pinwheel_N = mkWN (k12 "väkkärä") ; --UNCHK
lin pinworm_N = mkWN (compoundN "kiho" (k1A "mato")) ; --UNCHK
lin pion_N = mkWN (kH1 "pioni") ; --UNCHK
lin pioneer_N = mkN "pioneeri" ; --mkWN (compoundN "uudis" (k41A "asukas")) ;
lin pioneer_V = mkWV (k67 "olla") "uranuurtaja" ; --UNCHK
lin pioneer_V2 = mkWV2 (k67 "olla") "uranuurtaja" ; --UNCHK
lin pious_A = mkWA (k41 "hurskas") ; --UNCHK
lin pip_N = mkWN (kH1 "maali") "tutkan" ; --UNCHK
lin pip_V2 = mkWV2 (k73 "kerätä") "voitto" ; --UNCHK
lin pipage_N = mkWN (k1 "letku") ; --UNCHK
lin pipe_1_N = mkWN (k1 "pillistö") ; --UNCHK
lin pipe_2_N = mkWN (k1 "pillistö") ; --UNCHK
lin pipe_V = mkWV (k66 "rääkäistä") ; --UNCHK
lin pipe_V2 = mkWV2 (k66 "rääkäistä") ; --UNCHK
lin pipe_down_V = mkWV (k52A "rauhoittua") ; --UNCHK
lin pipe_rack_N = mkWN (compoundN "piippu" (k1 "hylly")) ; --UNCHK
lin pipe_up_V = mkWV (k66 "rääkäistä") ; --UNCHK
lin pipeclay_N = mkWN (k5 "kaoliini") ; --UNCHK
lin pipefish_N = mkWN (compoundN "meri" (k9 "neula")) ; --UNCHK
lin pipefitting_N = mkWN (compoundN "putki" (k33A "liitin")) ; --UNCHK
lin pipeful_N = mkWN (k38 "piipullinen") ; --UNCHK
lin pipeline_N = mkWN (k7 "putki") ; --f53
lin piper_N = mkWN (compoundN "säkkipillin" (k10 "soittaja")) ; --UNCHK
lin piperacillin_N = mkWN "Pipracil" ; --UNCHK
lin piperazine_N = mkWN "piperatsiini" ; --UNCHK
lin piperin_N = mkWN "piperiini" ; --UNCHK
lin piperocaine_N = mkWN (compoundN "Metyc" (k48 "aine")) ; --UNCHK
lin pipet_N = mkWN (k5A "pipetti") ; --UNCHK
lin pipette_N = mkWN (k5A "pipetti") ; --UNCHK
lin pipework_N = mkWN (k1 "pillistö") ; --UNCHK
lin pipewort_N = mkWN "Eriocaulon" "aquaticum" ; --UNCHK
lin piping_Adv = mkWAdv "tuli-" ; --UNCHK
lin piping_N = mkWN (compoundN "säkkipillin" (k1A "soitto")) ; --UNCHK
lin pipistrelle_N = mkWN (compoundN "kääpiö" (k4A "lepakko")) ; --UNCHK
lin pipit_N = mkWN (k38 "kirvinen") ; --UNCHK
lin pippin_N = mkWN "Pippin" ; --UNCHK
lin pipsissewa_N = mkWN (compoundN "sarja" (k5A "talvikki")) ; --UNCHK
lin pipsqueak_N = mkN "merkityksetön" ;
lin piquancy_N = mkWN (k40 "kiehtovuus") ; --UNCHK
lin piquant_A = mkWA (k10 "viehättävä") ; --UNCHK
lin pique_N = mkWN (k20 "pikee") ; --UNCHK
lin pique_V2 = mkWV2 (k73A "loukata") ; --UNCHK
lin piquet_N = mkWN (k39 "rangaistus") ; --UNCHK
lin piracy_N = mkWN (k5 "piratismi") ; --UNCHK
lin piraeus_PN = foreignPN "Pireus" ;
lin piranha_N = mkWN (k12 "piraija") ; --UNCHK
lin pirate_N = mkWN (compoundN "merirosvo" (k9 "laiva")) ; --UNCHK
lin pirate_V2 = mkWV2 (k53 "ryöstää") ; --UNCHK
lin piratical_A = mkWA (compoundA "rosvo" (k38 "mainen")) ; --UNCHK
lin pirkkala_PN = mkPN "Pirkkala" ;
lin pirogi_N = mkWN (k14A "piirakka") ; --UNCHK
lin piroplasm_N = mkWN (compoundN "piro" (k9 "plasma")) ; --UNCHK
lin pirouette_N = mkWN (k5A "piruetti") ; --UNCHK
lin pirouette_V = mkWV (k71 "tehdä") "piruetteja" ; --UNCHK
lin piroxicam_N = mkWN "Feldene" ; --UNCHK
lin pis_aller_N = mkWN (k1 "keino") "viimeinen" ; --UNCHK
lin pisa_PN = foreignPN "Pisa" ;
lin pisanosaur_N = mkWN "pisanosaurus" ; --UNCHK
lin piscatorial_A = mkWA "kalastus-" ; --UNCHK
lin piscine_A = mkWA "kala-" ; --UNCHK
lin piscivorous_A = mkWA "kaloja" "syövä" ; --UNCHK
lin pisiform_N = mkWN (compoundN "herne" (k18 "luu")) ; --UNCHK
lin piss_N = mkN "kusi" "kusia" ;
lin piss_V = mkV "kusta" ; ---WV (k53A "heittää") "vettä" ;
lin piss_V2 = mkV2 "kusta" ;
lin pisser_N = mkWN (k48A "tilanne") "paskamainen" ; --UNCHK
lin pistachio_N = mkWN (k5 "pistaasi") ; --UNCHK
lin piste_N = mkWN (k9A "rata") ; --UNCHK
lin pistia_N = mkWN (compoundN "vesi" (k5A "salaatti")) ; --UNCHK
lin pistil_N = mkWN (k5 "emi") ; --UNCHK
lin pistillate_A = mkWA "emi-" ; --UNCHK
lin pistillode_N = mkWN (k5 "emi") ; --UNCHK
lin pistol_N = mkWN (k6 "pistooli") ; --UNCHK
lin pistoleer_N = mkWN (compoundN "pistooli" (k42 "mies")) ; --UNCHK
lin piston_N = mkWN (k10A "mäntä") ; --UNCHK
lin pit_N = mkWN (k39 "kaivos") ; --UNCHK
lin pit_V2 = mkV2 (mkV (mkV "panna") "vastakkain") ; ---ARB --mkWV2 (k53 "poistaa") "kivet" ;
lin pita_N = mkWN (compoundN "tasku" (k10A "leipä")) ; --UNCHK
lin pitahaya_N = mkWN "pitaija" ; --UNCHK
lin pitch_N = mkWN (k1A "syöttö") ; --UNCHK
lin pitch_V = mkWV (k53 "kohdistaa") ; --UNCHK
lin pitch_V2 = mkWV2 (k53 "kohdistaa") ; --UNCHK
lin pitch_into_V2 = mkWV2 (k65 "käydä") "käsiksi" ; --UNCHK
lin pitchblende_N = mkWN (compoundN "piki" (k48A "välke")) ; --UNCHK
lin pitcher_N = mkWN (k10 "syöttäjä") ;
lin pitchfork_N = mkWN (k4A "talikko") ; --UNCHK
lin pitchfork_V2 = mkWV2 (k74A "hangota") ; --UNCHK
lin pitching_N = mkWN "syöttäminen" ; --UNCHK
lin pitchman_N = mkWN (k5A "helppoheikki") ; --UNCHK
lin pitchstone_N = mkWN (k5 "lasi") "musta" "vulkaaninen" ; --UNCHK
lin pitchy_A = mkWA (k38 "pihkainen") ; --UNCHK
lin piteous_A = mkWA (k38 "poloinen") ; --UNCHK
lin pitfall_N = mkWN (k9 "ansa") ; --UNCHK
lin pith_N = mkWN (k48A "piirre") "tärkeä" ; --UNCHK
lin pithead_N = mkWN (compoundN "kaivo" (k1A "saukko")) ; --UNCHK
lin pithy_A = mkWA (k41 "tiivis") ; --UNCHK
lin pitiable_A = mkWA (k10 "kurja") ; --UNCHK
lin pitiful_A = mkWA (k10 "kurja") ; --UNCHK
lin pitiless_A = mkWA (k1 "tyly") ; --UNCHK
lin pitilessness_N = mkWN (k40 "häikäilemättömyys") ; --UNCHK
lin pitman_N = mkWN (compoundN "kaivos" (k38 "työläinen")) ; --UNCHK
lin piton_N = mkWN (k5A "piikki") ; --UNCHK
lin pit_prop_N = mkWN (k5 "propsi") ; --UNCHK
lin pitsaw_N = mkWN (compoundN "lankku" (k9 "saha")) ; --UNCHK
lin pitta_N = mkWN "pitta" ; --UNCHK
lin pittance_N = mkWN (k10 "summa") "mitätön" ; --UNCHK
lin pitting_N = mkWN (k40 "huokoisuus") ; --UNCHK
lin pittsburgh_PN = foreignPN "Pittsburgh" ;
lin pituitary_A = mkWA "aivolisäke-" ; --UNCHK
lin pituitary_N = mkWN (compoundN "aivo" (k48A "lisäke")) ; --UNCHK
lin pity_N = mkWN (k5 "sääli") ; --UNCHK
lin pityriasis_N = mkWN (compoundN "hilsetys" (k5A "tauti")) ; --UNCHK
lin pivot_N = mkWN (compoundN "kierto" (k48A "liike")) ; --UNCHK
lin pivot_V = mkWV (k52A "kääntyä") ; --UNCHK
lin pivot_V2 = mkWV2 (k52A "kääntyä") ; --UNCHK
lin pivotal_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin pixel_N = mkWN (compoundN "kuva-" (k3 "alkio")) ; --UNCHK
lin pixie_N = mkWN (k38 "maahinen") ; --UNCHK
lin pixilated_A = mkWA (k10 "oleva") "tillin-tallin" ; --UNCHK
lin pixy_N = mkWN (k38 "maahinen") ; --UNCHK
lin pizza_N = mkN "pizza" ;
lin pizzeria_N = mkWN (k12 "pitseria") ; --UNCHK
lin pizzicato_A = mkWA "pizzicato" ; --UNCHK
lin pizzicato_Adv = mkWAdv "pizzicato" ; --UNCHK
lin pizzicato_N = mkWN "pizzicato" ; --UNCHK
lin placable_A = mkWA (k15 "lauhkea") ; --UNCHK
lin placard_N = mkWN (k5A "plakaatti") ; --UNCHK
lin placard_V2 = mkWV2 (k53 "mainostaa") "julisteilla" ; --UNCHK
lin placate_V2 = mkWV2 (k53A "kesyttää") ; --UNCHK
lin placatingly_Adv = mkWAdv (compoundAdv "rauhoittav" (k99 "asti")) ; --UNCHK
lin placation_N = mkWN (k2 "sovittelu") ; --UNCHK
lin place_N = mkN "paikka" ;
lin place_V2 = mkV2 "sijoittaa" ;
lin place_bet_N = mkWN (compoundN "vedon" (k5A "lyönti")) ; --UNCHK
lin place_name_N = mkWN (compoundN "paikan" (k7 "nimi")) ; --UNCHK
lin placebo_N = mkN "lume" (mkN "lääke") ;
lin placeholder_N = mkWN (compoundN "paikka" (k5A "merkki")) ; --UNCHK
lin placeman_N = mkWN (k39 "nimitys") "poliittinen" ; --UNCHK
lin placement_N = mkWN (k5A "rekrytointi") ; --UNCHK
lin placenta_N = mkWN (k14A "istukka") ; --UNCHK
lin placental_A = mkWA (k38 "istukallinen") ; --UNCHK
lin placental_N = mkWN (k41A "nisäkäs") "istukallinen" ; --UNCHK
lin placentation_N = mkWN (compoundN "istukan" (k39 "muodostus")) ; --UNCHK
lin placer_N = mkWN (k9A "hiekka") "kultapitoinen" ; --UNCHK
lin placeseeker_N = mkWN (k39 "nimitys") "poliittinen" ; --UNCHK
lin placid_A = mkWA (k26 "tyyni") ; --UNCHK
lin placidity_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin placing_N = mkN "sijoitus" ;
lin placket_N = mkWN (compoundN "napitus" (k9 "lista")) ; --UNCHK
lin placoderm_N = mkWN (compoundN "panssari" (k9 "kala")) ; --UNCHK
lin placoid_A = mkWA "panssari-" ; --UNCHK
lin plage_N = mkWN (compoundN "uima" (k9A "ranta")) ; --UNCHK
lin plagiarism_N = mkWN (k5 "piratismi") ; --UNCHK
lin plagiarist_N = mkWN (k5A "piraatti") ; --UNCHK
lin plagiaristic_A = mkWA (compoundA "plagio" (k1A "itu")) ; --UNCHK
lin plagiarize_V2 = mkWV2 (k53 "varastaa") ; --UNCHK
lin plagiocephaly_N = mkWN "vinokalloisuus" ; --UNCHK
lin plagioclase_N = mkWN (compoundN "oligokl" (k5 "aasi")) ; --UNCHK
lin plagioclastic_A = mkWA "plagioklaasi-" ; --UNCHK
lin plague_N = mkWN (k9 "riesa") ; --UNCHK
lin plague_V2 = mkWV2 (k53A "hätyyttää") ; --UNCHK
lin plague_spot_N = mkWN (compoundN "rutto" (k10 "täplä")) ; --UNCHK
lin plaguey_Adv = mkWAdv (compoundAdv "hitonmoi" (k99 "sen")) ; --UNCHK
lin plaguy_A = mkWA (k10 "rasittava") ; --UNCHK
lin plaice_N = mkWN (compoundN "puna" (k13 "kampela")) ; --UNCHK
lin plaid_N = mkWN (k6 "tartaani") ; --UNCHK
lin plain_A = mkWA (compoundA "yks" (k38 "inkertainen")) ; --UNCHK
lin plain_Adv = mkWAdv (k99 "yksinkertaisesti") ; --UNCHK
lin plain_N = mkWN (k14A "silmukka") ; --UNCHK
lin plain_V = mkWV (k66 "nurista") ; --UNCHK
lin plain_V2 = mkWV2 (k66 "nurista") ; --UNCHK
lin plainclothesman_N = mkWN (k6 "poliisi") "siviiliasuinen" ; --UNCHK
lin plainness_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin plainsman_N = mkWN (compoundN "tasanko" (k38 "lainen")) ; --UNCHK
lin plainsong_N = mkWN (compoundN "kirkko" (k1 "laulu")) "frankoroomalainen" ; --UNCHK
lin plain_spoken_A = mkWA (k34A "kursailematon") ; --UNCHK
lin plaint_N = mkWN (k12 "ulina") ; --UNCHK
lin plaintiff_N = mkWN (k10 "kantaja") ;
lin plaintive_A = mkWA (k38 "murheellinen") ; --UNCHK
lin plaintiveness_N = mkWN (compoundN "surumiel" (k40 "isyys")) ; --UNCHK
lin plait_N = mkWN (k48A "taite") ; --UNCHK
lin plait_V2 = mkWV2 (k62 "palmikoida") ; --UNCHK
lin plaiter_N = mkWN "palmikoija" ; --UNCHK
lin plan_N = mkN "suunnitelma" ;
lin plan_V = mkV "suunnitella" ;
lin plan_V2 = mkV2 "suunnitella" partitive ;
lin plan_V2V = mkV2V (mkV "suunnitella") genitive infPresPart ;
lin plan_VS = mkVS (mkV "suunnitella") ;
lin plan_VV = mkVV (mkV "suunnitella") infPresPartAgr | mkVV "aikoa" ;
lin planar_A = mkWA (compoundA "kaks" (k38 "iulotteinen")) ; --UNCHK
lin planarian_N = mkWN (compoundN "värys" (k1A "mato")) ; --UNCHK
lin planate_A = mkWA (compoundA "taso" (k1 "itettu")) ; --UNCHK
lin planation_N = mkWN (compoundN "taso" (k38 "ittuminen")) ; --UNCHK
lin planchet_N = mkWN (k3 "aihio") ; --UNCHK
lin planchette_N = mkWN "psykografi" ; --UNCHK
lin plane_N = mkWN (compoundN "lento" (k48 "kone")) ; --f63
lin plane_V = mkWV (k73 "höylätä") ; --UNCHK
lin plane_V2 = mkWV2 (k73 "höylätä") ; --UNCHK
lin plane_tree_N = mkWN (k6 "plataani") ; --UNCHK
lin planet_N = L.planet_N ;
lin planetal_A = mkWA (k38 "planetaarinen") ; --UNCHK
lin planetarium_N = mkWN (k3 "planetaario") ; --UNCHK
lin planetary_A = mkWA (k38 "planetaarinen") ; --UNCHK
lin plangency_N = mkWN "sonorisuus" ; --UNCHK
lin plangent_A = mkWA (compoundA "jylis" (k10 "evä")) ; --UNCHK
lin plank_N = mkWN (k10A "ohjelmakohta") ; --UNCHK
lin planking_N = mkWN (k39 "lankutus") ; --UNCHK
lin plankton_N = mkWN (k2 "keijusto") ; --UNCHK
lin planktonic_A = mkWA "plankton-" ; --UNCHK
lin planless_A = mkWA (k34A "päämäärätön") ; --UNCHK
lin planned_A = mkA "suunniteltu" ;
lin planner_N = mkN "suunnittelija" ; --f55
lin planning_N = mkWN (k2 "suunnittelu") ;
lin planoconcave_A = mkWA (compoundA "taso" (k10 "kovera")) ; --UNCHK
lin planoconvex_A = mkWA (compoundA "taso" (k10 "kupera")) ; --UNCHK
lin planographic_A = mkWA "laakapaino-" ; --UNCHK
lin plant_1_N = mkN "laitos" ;
lin plant_2_N = mkN "kasvi" ;
lin plant_V2 = mkWV2 (k53A "juurruttaa") ; --UNCHK
lin plant_louse_N = mkWN (k9 "kirva") ; --UNCHK
lin plant_out_V2 = prepV2 (lin V OP_plant_V2) OP_out_Prep ; -- guess-p-verb
lin plantain_N = mkWN "pisanki" ; --UNCHK
lin plantal_A = mkWA "kasvi-" ; --UNCHK
lin plantar_A = mkWA "jalkapohjan" ; --UNCHK
lin plantation_N = mkWN (k4A "metsikkö") ; --UNCHK
lin planter_N = mkWN (compoundN "kukka" (k4A "laatikko")) ; --UNCHK
lin plantigrade_A = mkWA (compoundA "kanta-" (k10 "astuja")) ; --UNCHK
lin planting_N = mkWN (k1 "kylvö") ; --UNCHK
lin plantlet_N = mkWN (k25 "taimi") ; --UNCHK
lin planula_N = mkWN (compoundN "plan" (k10 "ula")) ; --UNCHK
lin plaque_N = mkWN (k9A "laatta") ; --UNCHK
lin plash_N = mkWN (k39 "loiskaus") ; --UNCHK
lin plash_V = mkWV (k53A "pirskottaa") ; --UNCHK
lin plash_V2 = mkWV2 (k53A "pirskottaa") ; --UNCHK
lin plasm_N = mkWN (k9 "plasma") ; --UNCHK
lin plasma_N = mkWN (k9 "plasma") ; --UNCHK
lin plasmablast_N = mkWN (compoundN "plasma" (k1 "solu")) ; --UNCHK
lin plasmacytoma_N = mkWN (compoundN "plasmasyto" (k10 "oma")) ; --UNCHK
lin plasmapheresis_N = mkWN "plasmafereesi" ; --UNCHK
lin plasmid_N = mkWN (k5 "plasmidi") ; --UNCHK
lin plasmin_N = mkWN "fibrinolysiini" ; --UNCHK
lin plasminogen_N = mkWN (compoundN "plasmino" (k5 "geeni")) ; --UNCHK
lin plasmodium_N = mkWN (compoundN "malaria" (k38 "loinen")) ; --UNCHK
lin plaster_N = mkWN (k6 "laastari") ; --UNCHK
lin plaster_V2 = mkWV2 (k52A "hautoa") ; --UNCHK
lin plasterboard_N = mkWN (compoundN "kipsi" (k1 "levy")) ; --UNCHK
lin plasterer_N = mkWN (k10 "rappaaja") ; --UNCHK
lin plastering_N = mkWN (k39 "rappaus") ; --UNCHK
lin plastic_A = mkWA (compoundA "muov" (k9 "aava")) ; --UNCHK
lin plastic_N = L.plastic_N ;
lin plastic_bomb_N = mkWN (k5 "muovipommi") ; --UNCHK
lin plasticine_N = mkWN (compoundN "muovailu" (k9 "vaha")) ; --UNCHK
lin plasticity_N = mkWN (k40 "plastisuus") ; --UNCHK
lin plasticizer_N = mkWN (k33A "pehmitin") ; --UNCHK
lin plastics_N = mkN "muovi" ;
lin plastid_N = mkWN (k5 "plastidi") ; --UNCHK
lin plastination_N = mkWN "plastinointi" ; --UNCHK
lin plastron_N = mkWN (compoundN "vatsa" (k7A "kilpi")) ; --UNCHK
lin plat_N = mkWN (compoundN "tontti" (k9A "kartta")) ; --UNCHK
lin plate_N = mkN "levy" ;
lin plate_V2 = mkWV2 (k53 "päällystää") ; --UNCHK
lin plate_glass_N = mkWN (compoundN "lasi" (k1 "levy")) ; --UNCHK
lin plate_rack_N = mkWN (compoundN "kuivaus" (k48 "teline")) ; --UNCHK
lin plateau_N = mkWN (k1A "ylänkö") ; --UNCHK
lin plateful_N = mkWN (k38 "lautasellinen") ; --UNCHK
lin platelayer_N = mkWN "ratatyömies" ; --UNCHK
lin platelet_N = mkWN (k5A "trombosyytti") ; --UNCHK
lin plateletpheresis_N = mkWN "fereesi" ; --UNCHK
lin platen_N = mkWN (k9 "tela") ; --UNCHK
lin plater_N = mkWN "silaaja" ; --UNCHK
lin platform_N = mkWN (k10A "kenkä") "korokepohjainen" ; --UNCHK
lin plating_N = mkWN (k39 "päällystys") ; --UNCHK
lin platinum_N = mkWN (k12 "platina") ; --UNCHK
lin platitude_N = mkWN (k5A "trivialiteetti") ; --UNCHK
lin platitudinarian_N = mkWN (k10 "puhuja") "latteuksia" "viljelevä" ; --UNCHK
lin platitudinous_A = mkWA (k15 "lattea") ; --UNCHK
lin platonic_A = mkWA (k38 "platoninen") ; --UNCHK
lin platoon_N = mkWN (k48 "joukkue") ; --UNCHK
lin platter_N = mkWN (k6 "vinyyli") ; --UNCHK
lin platy_N = mkWN (k1 "platy") ; --UNCHK
lin platyctenean_N = mkWN (compoundN "kampa" (k5A "maneetti")) ; --UNCHK
lin platypus_N = mkWN (compoundN "vesinokka" (k33 "eläin")) ; --UNCHK
lin platyrrhine_A = mkWA (compoundA "leveä" (k38 "nenäinen")) ; --UNCHK
lin platysma_N = mkWN (compoundN "iho" (k39 "lihas")) "kaulan" ; --UNCHK
lin plaudit_N = mkWN (k39 "menestys") "suuri" ; --UNCHK
lin plausibility_N = mkWN (k40 "vakuuttavuus") ; --UNCHK
lin plausible_A = mkWA (k10 "uskottava") ; --UNCHK
lin play_1_V = mkV "pelata" ;
lin play_1_V2 = mkV2 "pelata" partitive ;
lin play_2_V = mkV "leikkiä" ;
lin play_2_V2 = mkV2 "leikkiä" partitive ;
lin play_3_V = mkV "soittaa" ;
lin play_3_V2 = mkV2 "soittaa" partitive ;
lin play_N = mkN "näytelmä" ;
lin play_V = L.play_V ;
lin play_V2 = L.play_V2 ;
lin play_along_V = mkWV (k73 "seurata") ; --UNCHK
lin play_around_V = mkWV (k67A "näperrellä") ; --UNCHK
lin play_at_V2 = prepV2 OP_play_V OP_at_Prep ; -- guess-p-verb
lin play_away_V = advV OP_play_V OP_away_Adv ; -- guess-p-verb
lin play_back_V2 = mkWV2 (k53 "toistaa") ; --UNCHK
lin play_down_V2 = mkWV2 (k52 "väheksyä") ; --UNCHK
lin play_off_V = advV OP_play_V OP_off_Adv ; -- guess-p-verb
lin play_off_V2 = prepV2 OP_play_V OP_off_Prep ; -- guess-p-verb
lin play_on_V = advV OP_play_V OP_on_Adv ; -- guess-p-verb
lin play_on_V2 = prepV2 OP_play_V OP_on_Prep ; -- guess-p-verb
lin play_out_V = mkWV (k52 "kulua") "loppuun" ; --UNCHK
lin play_out_V2 = mkWV2 (k52 "kulua") "loppuun" ; --UNCHK
lin play_reading_N = mkWN (k9A "luenta") "näytelmän" ; --UNCHK
lin play_up_V = mkWV (k54A "tähdentää") ; --UNCHK
lin play_up_V2 = mkWV2 (k54A "tähdentää") ; --UNCHK
lin play_up_to_V2 = prepV2 (advV OP_play_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin play_upon_V2 = prepV2 OP_play_V OP_upon_Prep ; -- guess-p-verb
lin play_with_V2 = prepV2 OP_play_V OP_with_Prep ; -- guess-p-verb
lin playable_A = mkWA (k10 "oleva") "soitettavissa" ; --UNCHK
lin playback_N = mkWN (k1 "toisto") ; --UNCHK
lin playbill_N = mkWN (k10 "ohjelma") ; --UNCHK
lin playbook_N = mkWN (k10 "suunnitelma") ; --UNCHK
lin playbox_N = mkWN (compoundN "lelu" (k4A "laatikko")) ; --UNCHK
lin playboy_N = mkWN (k12 "hurjastelija") ; --UNCHK
lin player_N = mkN "pelaaja" ;
lin player_piano_N = mkWN (k1 "piano") "mekaaninen" ; --UNCHK
lin playfellow_N = mkWN (compoundN "leikki" (k6 "kaveri")) ; --UNCHK
lin playful_A = mkWA (k10 "leikkisä") ; --UNCHK
lin playfulness_N = mkWN (k40 "hauskuus") ; --UNCHK
lin playgoer_N = mkWN (k12 "kävijä") "teatterissa" ; --UNCHK
lin playground_N = mkWN (compoundN "leikki" (k9A "paikka")) ; --UNCHK
lin playhouse_N = mkWN (compoundN "leikki" (k5A "mökki")) ; --UNCHK
lin playing_N = mkWN "pelaaminen" ; --UNCHK
lin playing_card_N = mkWN (compoundN "peli" (k5A "kortti")) ; --UNCHK
lin playing_field_N = mkWN (k10A "kenttä") ; --UNCHK
lin playlet_N = mkWN (compoundN "pienois" (k10 "näytelmä")) ; --UNCHK
lin playlist_N = mkWN (compoundN "soitto" (k9 "lista")) ; --UNCHK
lin playmaker_N = mkWN (compoundN "pelin" (k10 "rakentaja")) ; --UNCHK
lin playmate_N = mkWN (compoundN "leikki" (k6 "kaveri")) ; --UNCHK
lin play_off_N = mkWN (compoundN "loppu" (k2 "ottelu")) ; --UNCHK
lin playpen_N = mkWN (compoundN "leikki" (k10 "kehä")) ; --UNCHK
lin playroom_N = mkWN (compoundN "peli" (k48 "huone")) ; --UNCHK
lin playschool_N = mkWN (compoundN "lasten" (k9 "tarha")) ; --UNCHK
lin playsuit_N = mkWN (compoundN "potku" (k1A "puku")) ; --UNCHK
lin plaything_N = mkWN (k1 "lelu") ; --UNCHK
lin playtime_N = mkWN (compoundN "urheilu" (k10 "päivä")) ; --UNCHK
lin playwright_N = mkN "näytelmä" (mkN "kirjailija") ; --mkWN (k5 "dramaturgi") ;
lin plaza_N = mkWN (k6 "ostari") ; --UNCHK
lin plea_N = mkWN (k39 "vetoomus") ;
lin pleach_V2 = mkWV2 (k52A "kietoa") ; --UNCHK
lin plead_V = mkWV (k74A "vedota") ;
lin plead_V2 = mkWV2 (k74A "vedota") ; --UNCHK
lin plead_VS = mkWVS (k74A "vedota") ; --UNCHK
lin pleading_N = mkWN (k1A "lausunto") ; --UNCHK
lin pleadingly_Adv = mkWAdv (k99 "itsepintaisesti") ; --UNCHK
lin pleasance_N = mkWN (k1A "nautinto") ; --UNCHK
lin pleasant_A = mkWA (k10 "mukava") ; --UNCHK
lin pleasantness_N = mkWN (k40 "herttaisuus") ; --UNCHK
lin pleasantry_N = mkWN (k40 "kohteliaisuus") ; --UNCHK
lin please_Adv = mkAdv "ole hyvä" ;
lin please_V = mkWV (k53A "riemastuttaa") ; --UNCHK
lin please_V2 = mkV2 "miellyttää" partitive ;
lin please_V2V = mkWV2V (k53A "riemastuttaa") ; --UNCHK
lin please_VV = mkWVV (k53A "riemastuttaa") ; --UNCHK
lin please_Voc = ss "kiitos" ;
lin pleased_A = variants {} ; --
lin pleaser_N = mkWN "hauskuuttaja" ; --UNCHK
lin pleasing_N = mkWN "miellyttäminen" ; --UNCHK
lin pleasingly_Adv = mkWAdv "miellyttävän" ; --UNCHK
lin pleasingness_N = mkWN (k40 "miellyttävyys") ; --UNCHK
lin pleasurable_A = mkWA (k10 "miellyttävä") ; --UNCHK
lin pleasure_N = mkWN (k1A "nautinto") ;
lin pleasure_boat_N = mkWN (compoundN "huvi" (k28 "pursi")) ; --UNCHK
lin pleasure_craft_N = mkWN (compoundN "huvi" (k28 "pursi")) ; --UNCHK
lin pleasure_ground_N = mkWN (k6 "tivoli") ; --UNCHK
lin pleat_N = mkWN (k48A "taite") ; --UNCHK
lin pleat_V2 = mkWV2 (k73 "pliseerata") ; --UNCHK
lin pleb_N = mkWN (k41 "rahvas") ; --UNCHK
lin plebeian_A = mkWA (k41 "rahvas") ; --UNCHK
lin plebeian_N = mkWN (k41 "rahvas") ; --UNCHK
lin plebiscite_N = mkWN (compoundN "kansan" (k39 "äänestys")) ; --UNCHK
lin plectognath_N = mkWN (compoundN "jäykkäleuka" (k9 "kala")) ; --UNCHK
lin plectranthus_N = mkWN (k14A "liisukka") ; --UNCHK
lin plectrum_N = mkWN (k9 "plektra") ; --UNCHK
lin pledge_N = mkWN (k39 "lupaus") ; --UNCHK
lin pledge_V2 = mkWV2 (k53A "vakuuttaa") ;
lin pledge_V2V = mkWV2V (k53A "vakuuttaa") ; --UNCHK
lin pledge_VS = mkWVS (k53A "vakuuttaa") ; --UNCHK
lin pledgee_N = mkWN (compoundN "pantin" (k10 "saaja")) ; --UNCHK
lin pledger_N = mkWN (compoundN "pantin" (k10 "antaja")) ; --UNCHK
lin plenary_A = mkWA (k38 "täydellinen") ; --UNCHK
lin plenipotentiary_N = mkWN (k10 "edustaja") "täysivaltainen" ; --UNCHK
lin plenitude_N = mkWN (k40 "runsaus") ; --UNCHK
lin plenteous_A = mkWA (k99 "paljon") ; --UNCHK
lin plentiful_A = mkWA (k99 "paljon") ; --UNCHK
lin plenty_Adv = mkWAdv (k99 "kyllin") ;
lin plenty_N = mkWN (k40 "runsaus") ;
lin plenty_NP = Syntax.mkNP (exceptNomN (mkN "paljo") "paljon") ; --
lin plenum_N = mkWN (k9 "tila") "täysi" ; --UNCHK
lin pleochroic_A = mkWA "pleokroinen" ; --UNCHK
lin pleochroism_N = mkWN (compoundN "pleokro" (k5 "ismi")) ; --UNCHK
lin pleomorphic_A = mkWA (compoundA "moni" (k38 "muotoinen")) ; --UNCHK
lin pleomorphism_N = mkWN (compoundN "moni" (k40 "muotoisuus")) ; --UNCHK
lin pleonasm_N = mkWN (k5 "pleonasmi") ; --UNCHK
lin pleonastic_A = mkWA (k38 "tautologinen") ; --UNCHK
lin plesiosaur_N = mkWN (k1 "joutsenlisko") ; --UNCHK
lin plethora_N = mkWN (k10 "määrä") "yletön" ; --UNCHK
lin plethysmograph_N = mkWN "pletysmografi" ; --UNCHK
lin pleura_N = mkWN (compoundN "keuhko" (k5 "pussi")) ; --UNCHK
lin pleural_A = mkWA "keuhkopussin-" ; --UNCHK
lin pleurisy_N = mkWN (compoundN "keuhkopussin" (k39 "tulehdus")) ; --UNCHK
lin pleurocarp_N = mkWN (compoundN "lehti" (k49 "sammal")) "kylkipesäkkeinen" ; --UNCHK
lin pleurocarpous_A = mkWA (compoundA "kylki" (k38 "pesäkkeinen")) ; --UNCHK
lin pleurodont_N = mkWN (k38 "hampaallinen") ; --UNCHK
lin pleurodynia_N = mkWN (compoundN "kylki" (k1A "kipu")) ; --UNCHK
lin pleurothallis_N = mkWN "pleurothallis" ; --UNCHK
lin pleximeter_N = mkWN (compoundN "koputus" (k1 "levy")) ; --UNCHK
lin plexor_N = mkWN (compoundN "refleksi" (k12 "vasara")) ; --UNCHK
lin plexus_N = mkWN (k1A "verkko") ; --UNCHK
lin pliability_N = mkWN (k40 "sopeutuvuus") ; --UNCHK
lin pliable_A = mkWA (k15 "notkea") ; --UNCHK
lin pliancy_N = mkWN (k40 "sopeutuvuus") ; --UNCHK
lin pliant_A = mkWA (k15 "notkea") ; --UNCHK
lin plication_N = mkWN (k39 "laskostus") ; --UNCHK
lin plier_N = mkWN (compoundN "ammatin" (k10 "harjoittaja")) ; --UNCHK
lin plight_N = mkN "ahdinko" ; --mkWN (compoundN "uskollisuuden" (k9 "vala")) ;
lin plight_V2 = mkWV2 (k53A "vakuuttaa") ; --UNCHK
lin plimsoll_N = mkWN (compoundN "kumi" (k1 "tossu")) ; --UNCHK
lin plinth_N = mkWN (k13 "jalusta") ; --UNCHK
lin ploce_N = mkWN (k1 "toisto") ; --UNCHK
lin plod_V = mkWV (k53 "laahustaa") ; --UNCHK
lin plod_V2 = mkWV2 (k53 "laahustaa") ; --UNCHK
lin plodder_N = mkWN (k12 "kuhnailija") ; --UNCHK
lin plodding_N = mkWN "raahustus" ; --UNCHK
lin ploddingly_Adv = mkWAdv (k99 "työläästi") ; --UNCHK
lin plonk_N = mkWN (k39 "läiskähdys") ; --UNCHK
lin plonk_V = mkWV (k53A "mäjäyttää") ; --UNCHK
lin plop_Adv = mkWAdv "muksahtaen" ; --UNCHK
lin plop_N = mkWN (k39 "molskaus") ; --UNCHK
lin plop_V = mkWV (k53A "mäjäyttää") ; --UNCHK
lin plosion_N = mkWN (compoundN "purkauma" (k48 "vaihe")) ; --UNCHK
lin plosive_N = mkWN (k5 "klusiili") ; --UNCHK
lin plot_N = mkWN (k26 "juoni") ; --UNCHK
lin plot_V = mkWV (k61 "juonia") ; --UNCHK
lin plot_V2 = mkWV2 (k61 "juonia") ; --UNCHK
lin plotter_N = mkWN (k6 "piirturi") ; --UNCHK
lin plough_N = mkWN (k1A "kyntö") ; --UNCHK
lin plough_V = mkWV (k54A "kääntää") ; --UNCHK
lin plough_V2 = mkWV2 (k54A "kääntää") ; --UNCHK
lin plough_on_V = mkWV (k54A "rientää") "eteenpäin" ; --UNCHK
lin ploughboy_N = mkWN (compoundN "renki" (k10A "poika")) ; --UNCHK
lin ploughman_N = mkWN (k10 "kyntäjä") ; --UNCHK
lin ploughshare_N = mkWN (k41A "vannas") ; --UNCHK
lin plover_N = mkWN (k13 "kurmitsa") ; --UNCHK
lin plow_N = mkWN (k1A "kyntö") ; --UNCHK
lin plow_V = mkWV (k67A "käsitellä") ; --UNCHK
lin plow_V2 = mkWV2 (k67A "käsitellä") ; --UNCHK
lin plowboy_N = mkWN (compoundN "renki" (k10A "poika")) ; --UNCHK
lin plowing_N = mkWN (k1A "kyntö") ; --UNCHK
lin plowman_N = mkWN (k10 "kyntäjä") ; --UNCHK
lin plowshare_N = mkWN (k41A "vannas") ; --UNCHK
lin plowwright_N = mkWN (compoundN "aura" (k10A "seppä")) ; --UNCHK
lin ploy_N = mkWN (compoundN "sota" (k26 "juoni")) ;
lin pluck_N = mkWN (k2 "näppäily") ; --UNCHK
lin pluck_V = mkWV (k61 "poimia") ; --UNCHK
lin pluck_V2 = mkWV2 (k61 "poimia") ; --UNCHK
lin pluck_at_V2 = mkWV2 (k53A "nyhtää") ; --UNCHK
lin plucky_A = mkWA (k15 "rohkea") ; --UNCHK
lin plug_N = mkWN (k10 "luuska") ; --UNCHK
lin plug_V = mkWV (k58 "kytkeä") ; --UNCHK
lin plug_V2 = mkWV2 (k58 "kytkeä") ;
lin plughole_N = mkWN (k10A "reikä") "tulpan" ; --UNCHK
lin plum_N = mkWN (compoundN "huippu" (k9A "paikka")) ; --UNCHK
lin plum_pudding_N = mkWN (compoundN "luumu" (k41A "vanukas")) ; --UNCHK
lin plumage_N = mkWN (k10A "sulka") ; --UNCHK
lin plumaged_A = mkWA (compoundA "höyhen" (k38 "peitteinen")) ; --UNCHK
lin plumate_A = mkWA (compoundA "höyhen" (k38 "koristeinen")) ; --UNCHK
lin plumb_A = mkWA (compoundA "kohti" (k10 "suora")) ; --UNCHK
lin plumb_Adv = mkWAdv (k99 "täysin") ; --UNCHK
lin plumb_N = mkWN (k5A "luoti") ; --UNCHK
lin plumbaginaceous_A = mkWA (k10 "kuuluva") "lyijykukkakasveihin" ; --UNCHK
lin plumbago_N = mkWN (compoundN "lyijy" (k10A "kukka")) ; --UNCHK
lin plumber_N = mkWN (compoundN "putki" (k10 "asentaja")) ; --UNCHK
lin plumbic_A = mkWA "lyijy-" ; --UNCHK
lin plumbing_N = mkN "notkahdus" ;
lin plumcot_N = mkWN "luumukoosi" ; --UNCHK
lin plume_N = mkWN (k10A "sulka") ; --UNCHK
lin plume_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin plumelike_A = mkWA (compoundA "sulka" (k38 "mainen")) ; --UNCHK
lin plumlike_A = mkWA (compoundA "luumu" (k38 "mainen")) ; --UNCHK
lin plummet_N = mkWN (k5A "luoti") ; --UNCHK
lin plummet_V = mkWV (k54A "sukeltaa") ;
lin plummet_V2 = mkWV2 (k54A "sukeltaa") ; --UNCHK
lin plump_A = mkWA (k10 "pulska") ; --UNCHK
lin plump_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin plump_N = mkWN (k39 "mätkähdys") ; --UNCHK
lin plump_V = mkWV (k52A "päätyä") "jhk" ; --UNCHK
lin plump_V2 = mkWV2 (k52A "päätyä") "jhk" ; --UNCHK
lin plump_down_V = mkWV (k53A "mäjäyttää") ; --UNCHK
lin plump_for_V2 = mkWV2 (k54A "puoltaa") ; --UNCHK
lin plump_up_V2 = mkWV2 (k61 "pöyhiä") ; --UNCHK
lin plumpness_N = mkWN (k40 "pyöreys") ; --UNCHK
lin plumule_N = mkWN (k10 "untuva") ; --UNCHK
lin plunder_N = mkWN (k41 "saalis") ; --UNCHK
lin plunder_V = mkWV (k73 "ryövätä") ; --UNCHK
lin plunder_V2 = mkWV2 (k73 "ryövätä") ; --UNCHK
lin plunderage_N = mkWN (k39 "rosvous") ; --UNCHK
lin plunderer_N = mkWN (k10 "ryöstäjä") ; --UNCHK
lin plundering_N = mkWN (k1 "ryöstö") ; --UNCHK
lin plunge_N = mkN "lasku" ;
lin plunge_V = mkWV (k52 "syöksyä") ; --f62
lin plunge_V2 = mkWV2 (k52A "hyytyä") ;
lin plunger_N = mkWN (k10A "mäntä") ; --UNCHK
lin plunk_N = mkWN (k39 "näpäytys") ; --UNCHK
lin pluperfect_A = mkWA "täydellistäkin" "täydellisempi" ; --UNCHK
lin pluperfect_N = mkWN (k5 "pluskvamperfekti") ; --UNCHK
lin plural_A = mkWA (k38 "monikollinen") ; --UNCHK
lin plural_N = mkWN (k4A "monikko") ; --UNCHK
lin pluralism_N = mkWN "monivirkaisuus" ; --UNCHK
lin pluralist_N = mkWN (k5 "pluralisti") ; --UNCHK
lin pluralistic_A = mkWA (k38 "pluralistinen") ; --UNCHK
lin plurality_N = mkWN (k1 "enemmistö") "suhteellinen" ; --UNCHK
lin pluralization_N = mkWN (k38 "tekeminen") "monikkomuodon" ; --UNCHK
lin plus_A = mkWA (k99 "plus") ; --UNCHK
lin plus_Conj = mkConj "plus" ;
lin plus_N = mkWN (k99 "plus") ;
lin plus_Prep = mkPrep "plus" nominative ; ----
lin plush_A = mkWA (k38 "ylellinen") ; --UNCHK
lin plush_N = mkWN (k41A "plyysikangas") ; --UNCHK
lin plushy_A = mkWA (k38 "ylellinen") ; --UNCHK
lin plutocracy_N = mkWN (compoundN "raha" (k9A "valta")) ; --UNCHK
lin plutocrat_N = mkWN (compoundN "raha" (k41 "ruhtinas")) ; --UNCHK
lin plutocratic_A = mkWA (compoundA "raha" (k38 "valtainen")) ; --UNCHK
lin plutonium_N = mkWN (k5 "plutonium") ; --UNCHK
lin ply_N = mkWN (k39 "kerros") ; --UNCHK
lin ply_V = mkWV (k53A "käyttää") ; --UNCHK
lin ply_V2 = mkWV2 (k53A "käyttää") ; --UNCHK
lin ply_VS = mkWVS (k53A "käyttää") ; --UNCHK
lin plymouth_PN = foreignPN "Plymouth" ;
lin plywood_N = mkWN (k6 "vaneri") ; --UNCHK
lin pneumatic_A = mkWA (k38 "pneumaattinen") ; --UNCHK
lin pneumatics_N = mkWN (k9A "pneumatiikka") ; --UNCHK
lin pneumatophore_N = mkWN (k26 "hengitysjuuri") ; --UNCHK
lin pneumococcal_A = mkWA "pneumokokki-" ; --UNCHK
lin pneumococcus_N = mkWN (k5A "pneumokokki") ; --UNCHK
lin pneumoconiosis_N = mkWN (compoundN "pöly" (k1 "keuhko")) ; --UNCHK
lin pneumocytosis_N = mkWN (k12 "pneumonia") "pneumocystis" "carinii" ; --UNCHK
lin pneumonectomy_N = mkWN (compoundN "keuhkonpoisto" (k39 "leikkaus")) ; --UNCHK
lin pneumonia_N = mkWN (compoundN "keuhko" (k48 "kuume")) ; --UNCHK
lin pneumonic_A = mkWA (compoundA "pulmona" (k38 "alinen")) ; --UNCHK
lin pneumonitis_N = mkWN (compoundN "keuhko" (k39 "tulehdus")) ; --UNCHK
lin pneumothorax_N = mkWN (compoundN "ilma" (k9A "rinta")) ; --UNCHK
lin po_N = mkWN (compoundN "posti" (k1 "virasto")) ; --UNCHK
lin poach_V = mkWV (k53A "hauduttaa") ; --UNCHK
lin poach_V2 = mkWV2 (k53A "hauduttaa") ; --UNCHK
lin poacher_N = mkWN (compoundN "parta" (k1A "simppu")) ; --UNCHK
lin pochard_N = mkWN (k10 "sotka") ; --UNCHK
lin pock_N = mkWN (compoundN "rokko" (k12 "näppylä")) ; --UNCHK
lin pocked_A = mkWA (compoundA "rokon" (k38 "arpinen")) ; --UNCHK
lin pocket_N = mkWN (k1 "tasku") ; --UNCHK
lin pocket_V2 = mkWV2 (k53 "pistää") "taskuunsa" ; --UNCHK
lin pocket_book_N = mkWN (k6 "pokkari") | mkWN (k2 "kukkaro") ; --UNCHK
lin pocket_knife_N = mkWN (compoundN "linkku" (k30 "veitsi")) ; --UNCHK
lin pocket_money_N = mkWN (compoundN "tasku" (k9 "raha")) ; --UNCHK
lin pocketcomb_N = mkWN (compoundN "tasku" (k9A "kampa")) ; --UNCHK
lin pocketful_N = mkWN (compoundN "taskun" (k27 "täysi")) ; --UNCHK
lin pockmark_N = mkWN (compoundN "rokon" (k7A "arpi")) ; --UNCHK
lin pockmarked_A = mkWA (compoundA "rokon" (k38 "arpinen")) ; --UNCHK
lin pod_N = mkWN (k3 "säiliö") ; --UNCHK
lin pod_V = mkWV (k53 "muodostaa") "palkoja" ; --UNCHK
lin pod_V2 = mkWV2 (k53 "muodostaa") "palkoja" ; --UNCHK
lin podalgia_N = mkWN (compoundN "jalka" (k1A "särky")) ; --UNCHK
lin podetium_N = mkWN (k28 "varsi") ; --UNCHK
lin podgy_A = mkWA (k10 "pulska") ; --UNCHK
lin podiatry_N = mkWN (compoundN "jalkojen" (k1A "hoito")) ; --UNCHK
lin podium_N = mkWN (k48A "koroke") ; --UNCHK
lin podlike_A = mkWA (compoundA "palko" (k38 "mainen")) ; --UNCHK
lin podzol_N = mkWN (k5 "podsoli") ; --UNCHK
lin poem_N = mkWN (k1 "runo") ; --UNCHK
lin poesy_N = mkWN (k14A "lyriikka") ; --UNCHK
lin poet_N = mkWN (k12 "runoilija") ; --UNCHK
lin poetess_N = mkWN "runoilijatar" ; --UNCHK
lin poetic_A = mkWA (k38 "runollinen") ; --UNCHK
lin poetical_A = mkWA (k38 "runollinen") ; --UNCHK
lin poetics_N = mkWN (k9A "poetiikka") ; --UNCHK
lin poetry_N = mkWN (k14A "lyriikka") ; --UNCHK
lin pogge_N = mkWN (compoundN "parta" (k1A "simppu")) ; --UNCHK
lin pogonia_N = mkWN "pogonia" ; --UNCHK
lin pogonion_N = mkWN (compoundN "leuka" (k48 "piste")) ; --UNCHK
lin pogrom_N = mkWN (k1 "vaino") ; --UNCHK
lin pohja_PN = mkPN "Pohja" ;
lin poi_N = mkWN "poi" ; --UNCHK
lin poignance_N = mkWN (k40 "kipeys") ; --UNCHK
lin poignancy_N = mkWN (k40 "järkyttävyys") ; --UNCHK
lin poignant_A = mkWA (k10 "liikuttava") ; --UNCHK
lin poikilotherm_N = mkWN (k33 "eläin") "vaihtolämpöinen" ; --UNCHK
lin poilu_N = mkWN (compoundN "kana" (k39 "muhennos")) ; --UNCHK
lin poinsettia_N = mkWN (compoundN "joulu" (k7A "tähti")) ; --UNCHK
lin point_1_N = mkN "piste" ;
lin point_2_N = mkN "pointti" ;
lin point_N = mkN "piste" ;
lin point_V = mkV "osoittaa" ;
lin point_V2 = mkV2 "osoittaa" partitive ;
lin point_duty_N = mkWN (k10 "tehtävä") "liikennepoliisin" ; --UNCHK
lin point_out_V2 = prepV2 OP_point_V OP_out_Prep ; -- guess-p-verb
lin point_out_VS = mkVS "osoittaa" ;
lin point_up_V = mkWV (k54A "tähdentää") ; --UNCHK
lin pointedly_AdV = mkAdV "kärkevästi" ;
lin pointedness_N = mkWN (k40 "terävyys") ; --UNCHK
lin pointer_N = mkWN (k6 "pointteri") ; --UNCHK
lin pointillism_N = mkWN (k5 "pointillismi") ; --UNCHK
lin pointillist_A = mkWA (k38 "pointillistinen") ; --UNCHK
lin pointillist_N = mkWN (k5 "pointillisti") ; --UNCHK
lin pointless_A = mkWA (k10 "tylsä") ; --UNCHK
lin pointsman_N = mkWN (compoundN "liikenne" (k6 "poliisi")) ; --UNCHK
lin poise_N = mkWN (k40 "viileys") ; --UNCHK
lin poise_V = mkWV (k53A "pitää") "tasapainossa" ; --UNCHK
lin poise_V2 = mkWV2 (k53A "pitää") "tasapainossa" ; --UNCHK
lin poison_N = mkWN (k1A "myrkky") ;
lin poison_V2 = mkWV2 (k53A "myrkyttää") ; --UNCHK
lin poison_gas_N = mkWN (compoundN "myrkky" (k1 "kaasu")) ; --UNCHK
lin poison_ivy_N = mkWN (compoundN "myrkky" (k5A "muratti")) ; --UNCHK
lin poisoner_N = mkWN "myrkyttäjä" ; --UNCHK
lin poisoning_N = mkN "myrkytys" ;
lin poisonous_A = mkWA (k10 "katkera") ; --UNCHK
lin poke_N = mkWN (k5 "tälli") ; --UNCHK
lin poke_V = mkWV (k66 "tökkäistä") ; --UNCHK
lin poke_V2 = mkWV2 (k66 "tökkäistä") ; --UNCHK
lin poke_bonnet_N = mkWN (k9A "hilkka") ; --UNCHK
lin poker_N = mkWN (k6 "pokeri") ; --UNCHK
lin poker_face_N = mkWN (k10A "pokka") ; --UNCHK
lin pokeweed_N = mkWN (compoundN "kermes" (k9 "marja")) ; --UNCHK
lin poky_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin polack_N = mkWN (k38 "puolalainen") ; --UNCHK
lin poland_PN = foreignPN "Puola" ;
lin polar_A = mkWA "napa-" ; --UNCHK
lin polarimeter_N = mkWN (compoundN "polarisko" (k5A "oppi")) ; --UNCHK
lin polaris_N = mkWN (compoundN "napa" (k7A "tähti")) ; --UNCHK
lin polarity_N = mkWN (compoundN "kaksi" (k40 "naisuus")) ; --UNCHK
lin polarization_N = mkWN (k3 "polarisaatio") ; --UNCHK
lin polarize_V2 = mkWV2 (k52 "kärjistyä") ; --UNCHK
lin polarographic_A = mkWA (compoundA "pola" (k38 "rografinen")) ; --UNCHK
lin polarography_N = mkWN "polarografia" ; --UNCHK
lin polaroid_N = mkWN "Polaroid" ; --UNCHK
lin polder_N = mkWN (compoundN "marski" (k18 "maa")) ; --UNCHK
lin pole_N = mkWN (k1A "salko") ; --UNCHK
lin pole_jumping_N = mkWN (compoundN "seiväs" (k1A "hyppy")) ; --UNCHK
lin pole_star_N = mkWN (compoundN "napa" (k7A "tähti")) ; --UNCHK
lin pole_vault_N = mkWN (compoundN "seiväs" (k1A "hyppy")) ; --UNCHK
lin poleax_N = mkWN (k12 "tappara") ; --UNCHK
lin poleax_V2 = mkWV2 (k56A "tappaa") "kirveellä" ; --UNCHK
lin poleaxe_N = mkWN (k12 "tappara") ; --UNCHK
lin poleaxe_V2 = mkWV2 (k56A "tappaa") "kirveellä" ; --UNCHK
lin polecat_N = mkWN (k6 "hilleri") ; --UNCHK
lin polemic_A = mkWA (k38 "poleeminen") ; --UNCHK
lin polemic_N = mkWN (k5A "polemiikki") ; --UNCHK
lin polemicist_N = mkWN (k1A "poleemikko") ; --UNCHK
lin polemics_N = mkWN (compoundN "pole" (k9A "miikka")) ; --UNCHK
lin polemoniaceous_A = mkWA "sinilatvaskasveihin" "liittyvä" ; --UNCHK
lin polemonium_N = mkWN (compoundN "sini" (k9 "latva")) ; --UNCHK
lin polenta_N = mkWN "polenta" ; --UNCHK
lin police_N = mkN "poliisi" ;
lin police_V2 = mkWV2 (k52 "valvoa") ; --UNCHK
lin police_officer_N = mkWN (k6 "konstaapeli") ; --UNCHK
lin police_station_N = mkWN (compoundN "poliisi" (k10 "asema")) ; --UNCHK
lin policeman_N = L.policeman_N ;
lin policewoman_N = mkWN (compoundN "nais" (k6 "poliisi")) ; --UNCHK
lin policy_N = mkN "politiikka" ;
lin policyholder_N = mkWN (k10 "ottaja") "vakuutuksen" ; --UNCHK
lin polio_N = mkWN (k3 "polio") ; --UNCHK
lin poliomyelitis_N = mkWN (k3 "polio") ; --UNCHK
lin poliosis_N = mkWN "harmaatukkaisuus" ; --UNCHK
lin poliovirus_N = mkWN (compoundN "polio" (k39 "virus")) ; --UNCHK
lin polishFem_N = variants {} ; ---- sense to be split
lin polishMasc_N = mkWN (k1 "loisto") ; --UNCHK
lin polish_A = mkWA (k38 "puolalainen") ; --UNCHK
lin polish_V = mkWV (k53A "kehittää") ; --UNCHK
lin polish_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin polish_off_V2 = mkWV2 (k63 "saada") "valmiiksi" ; --UNCHK
lin polish_up_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin polisher_N = mkWN (k33A "kiillotin") ; --UNCHK
lin politburo_N = mkWN (k20 "politbyroo") ; --UNCHK
lin polite_A = mkWA (k41 "kohtelias") ; --UNCHK
lin politeness_N = mkWN (k40 "kohteliaisuus") ; --UNCHK
lin politic_A = mkWA (k38 "diplomaattinen") ; --UNCHK
lin political_A = mkA "poliittinen" ;
lin politician_N = mkWN (k1A "poliitikko") ;
lin politicize_V = mkWV (k62 "politisoida") ; --UNCHK
lin politicize_V2 = mkWV2 (k62 "politisoida") ; --UNCHK
lin politick_V = mkWV (k62 "laskelmoida") ; --UNCHK
lin politics_N = mkN "politiikka" ;
lin polity_N = mkWN (k2 "kieroilu") ; --UNCHK
lin polka_N = mkWN (k10A "polkka") ; --UNCHK
lin poll_N = mkN "äänestys" ;
lin poll_V = mkWV (k52 "latvoa") ; --UNCHK
lin poll_V2 = mkV2 (mkV (mkV "kysyä") "mielipidetutkimuksessa") elative ; --mkWV2 (k52 "latvoa") ;
lin poll_tax_N = mkWN (compoundN "kunnallis" (k1 "vero")) "henkilökohtainen" ; --UNCHK
lin pollack_N = mkWN (compoundN "lyyra" (k10 "turska")) ; --UNCHK
lin pollard_N = mkWN (compoundN "nuti" (k18 "pää")) ; --UNCHK
lin pollard_V2 = mkWV2 (k52 "latvoa") ; --UNCHK
lin pollen_N = mkWN (compoundN "siite" (k1 "pöly")) ; --UNCHK
lin pollinate_V2 = mkWV2 (k53A "pölyttää") ; --UNCHK
lin pollination_N = mkWN (k39 "pölytys") ; --UNCHK
lin pollinator_N = mkWN "pölyttäjä" ; --UNCHK
lin polling_booth_N = mkWN (k5A "äänestyskoppi") ; --UNCHK
lin polling_day_N = mkWN (compoundN "vaali" (k10 "päivä")) ; --UNCHK
lin polling_station_N = mkWN (compoundN "äänestys" (k9A "paikka")) ; --UNCHK
lin pollinium_N = mkWN (compoundN "siitepöly" (k1 "myhky")) ; --UNCHK
lin pollster_N = mkWN (k12 "tekijä") "mielipidetutkimuksen" ; --UNCHK
lin pollucite_N = mkWN "pollusiitti" ; --UNCHK
lin pollutant_N = mkWN (k48 "saaste") ; --UNCHK
lin pollute_V2 = mkWV2 (k53A "saastuttaa") ; --UNCHK
lin polluter_N = mkWN (k10 "likaaja") ; --UNCHK
lin pollution_N = mkN "saaste" ;
lin polo_N = mkWN (k1 "poolo") ; --UNCHK
lin polonaise_N = mkWN (k5 "poloneesi") ; --UNCHK
lin polonium_N = mkWN (k5 "polonium") ; --UNCHK
lin polony_N = mkWN (k5 "meetvursti") ; --UNCHK
lin poltergeist_N = mkN "poltergeist" ;
lin poltroon_A = mkWA (k38 "raukkamainen") ; --UNCHK
lin poltroon_N = mkWN (k9A "raukka") ; --UNCHK
lin poltroonery_N = mkWN (k40 "raukkamaisuus") ; --UNCHK
lin polvijärvi_PN = mkPN (mkN "Polvijärvi" "Polvijärviä") ;
lin polyamide_N = mkWN (k5 "polyamidi") ; --UNCHK
lin polyandrist_N = mkWN (k38 "nainen") "polyandrinen" ; --UNCHK
lin polyandrous_A = mkWA (compoundA "moni" (k38 "miehinen")) ; --UNCHK
lin polyandry_N = mkWN (compoundN "moni" (k40 "miehisyys")) ; --UNCHK
lin polyanthus_N = mkWN (k4A "esikko") ; --UNCHK
lin polyarteritis_N = mkWN (k39 "tulehdus") "valtimoiden" ; --UNCHK
lin polyatomic_A = mkWA (compoundA "moni" (k38 "atominen")) ; --UNCHK
lin polybutylene_N = mkWN "polybuteeni" ; --UNCHK
lin polychaete_N = mkWN (compoundN "monisukas" (k1A "mato")) ; --UNCHK
lin polychromatic_A = mkWA (compoundA "moni" (k38 "värinen")) ; --UNCHK
lin polychrome_N = mkWN (k39 "teos") "monivärinen" ; --UNCHK
lin polycrystalline_A = mkWA (compoundA "moni" (k38 "kiteinen")) ; --UNCHK
lin polycythemia_N = mkWN "polysytemia" ; --UNCHK
lin polydactyl_A = mkWA (compoundA "moni" (k38 "varpainen")) ; --UNCHK
lin polydactyly_N = mkWN "polydaktylia" ; --UNCHK
lin polydipsia_N = mkWN (compoundN "vesi" (k40 "juoppous")) ; --UNCHK
lin polyelectrolyte_N = mkWN (compoundN "poly" (k5A "elektrolyytti")) ; --UNCHK
lin polyester_N = mkWN (k6 "polyesteri") ; --UNCHK
lin polyestrous_A = mkWA "polyestrinen" ; --UNCHK
lin polyethylene_N = mkWN (k5 "polyeteeni") ; --UNCHK
lin polyfoam_N = mkWN (compoundN "solu" (k5 "muovi")) ; --UNCHK
lin polygamist_N = mkWN (k2 "henkilö") "moniavioinen" ; --UNCHK
lin polygamous_A = mkWA (k38 "polygaaminen") ; --UNCHK
lin polygamy_N = mkWN (k12 "polygamia") ; --UNCHK
lin polygene_N = mkWN (compoundN "poly" (k5 "geeni")) ; --UNCHK
lin polygenic_A = mkWA (compoundA "moni" (k38 "geeninen")) ; --UNCHK
lin polyglotFem_N = mkWN (k38 "ihminen") "monikielinen" ; --UNCHK
lin polyglotMasc_N = mkWN (k38 "ihminen") "monikielinen" ; --UNCHK
lin polyglot_A = mkWA (compoundA "moni" (k38 "kielinen")) ; --UNCHK
lin polygon_N = mkWN (k5 "polygoni") ; --UNCHK
lin polygonal_A = mkWA (compoundA "monikul" (k38 "mainen")) ; --UNCHK
lin polygraph_N = mkWN "polygrafi" ; --UNCHK
lin polygynist_N = mkWN (k42 "mies") "monivaimoinen" ; --UNCHK
lin polygynous_A = mkWA (compoundA "monivai" (k38 "moinen")) ; --UNCHK
lin polygyny_N = mkWN (k40 "monivaimoisuus") ; --UNCHK
lin polyhedral_A = mkWA (compoundA "moni" (k38 "tahkoinen")) ; --UNCHK
lin polyhedron_N = mkWN (compoundN "moni" (k41A "tahokas")) ; --UNCHK
lin polymastigote_N = mkWN (compoundN "siima" (k33 "eläin")) "monisiimainen" ; --UNCHK
lin polymath_N = mkWN (compoundN "yleis" (k1 "nero")) ; --UNCHK
lin polymer_N = mkWN (k5 "polymeeri") ; --UNCHK
lin polymerase_N = mkWN (compoundN "polymer" (k5 "aasi")) ; --UNCHK
lin polymeric_A = mkWA (compoundA "polymeeri" (k38 "nen")) ; --UNCHK
lin polymerization_N = mkWN (k3 "polymerisaatio") ; --UNCHK
lin polymorph_N = mkWN "polymorfi" ; --UNCHK
lin polymorphemic_A = mkWA "polymorfinen" ; --UNCHK
lin polymorphic_A = mkWA (compoundA "moni" (k38 "muotoinen")) ; --UNCHK
lin polymorphism_N = mkWN (k12 "polymorfia") ; --UNCHK
lin polymorphous_A = mkWA (compoundA "moni" (k38 "muotoinen")) ; --UNCHK
lin polymyositis_N = mkWN (compoundN "monilihas" (k39 "tulehdus")) ; --UNCHK
lin polymyxin_N = mkWN "polymyksiini" ; --UNCHK
lin polyneuritis_N = mkWN "monihermotulehdus" ; --UNCHK
lin polynomial_A = mkWA "multinomi-" ; --UNCHK
lin polynomial_N = mkWN (k5 "polynomi") ; --UNCHK
lin polynya_N = mkWN (compoundN "avo" (k9A "paikka")) ; --UNCHK
lin polyoma_N = mkWN (compoundN "polyooma" (k39 "virus")) ; --UNCHK
lin polyp_N = mkWN (k5A "polyyppi") ; --UNCHK
lin polypectomy_N = mkWN (k1 "poisto") "polyypin" ; --UNCHK
lin polypeptide_N = mkWN (compoundN "poly" (k5 "peptidi")) ; --UNCHK
lin polypetalous_A = mkWA (compoundA "eri" (k38 "lehtinen")) ; --UNCHK
lin polyphone_N = mkWN (k33 "kirjain") "polyfoninen" ; --UNCHK
lin polyphonic_A = mkWA (k38 "kontrapunktinen") ; --UNCHK
lin polyphony_N = mkWN (k5A "musiikki") "moniääninen" ; --UNCHK
lin polyphosphate_N = mkWN (compoundN "poly" (k5A "fosfaatti")) ; --UNCHK
lin polyploid_A = mkWA "polyploidinen" ; --UNCHK
lin polyploid_N = mkWN "polyploidi" ; --UNCHK
lin polyploidy_N = mkWN (compoundN "polyploi" (k9 "dia")) ; --UNCHK
lin polypody_N = mkWN (compoundN "kallio" (k48A "imarre")) ; --UNCHK
lin polypore_N = mkWN (compoundN "pilli" (k26 "sieni")) ; --UNCHK
lin polypropylene_N = mkWN (k5 "polypropeeni") ; --UNCHK
lin polyptoton_N = mkWN (k1 "toisto") ; --UNCHK
lin polypus_N = mkWN (k5A "polyyppi") ; --UNCHK
lin polysaccharide_N = mkWN (compoundN "poly" (k5 "sakkaridi")) ; --UNCHK
lin polysemant_N = mkWN (k9 "sana") "monimerkityksinen" ; --UNCHK
lin polysemous_A = mkWA (compoundA "moni" (k38 "merkityksinen")) ; --UNCHK
lin polysemy_N = mkWN (compoundN "monimerkityks" (k40 "isyys")) ; --UNCHK
lin polysomy_N = mkWN (compoundN "polys" (k61 "omia")) ; --UNCHK
lin polystyrene_N = mkWN (k5 "polystyreeni") ; --UNCHK
lin polysyllabic_A = mkWA (k15 "vaikea") ; --UNCHK
lin polysyllable_N = mkWN (k9 "sana") "monitavuinen" ; --UNCHK
lin polysyndeton_N = mkWN (compoundN "monisite" (k40 "isyys")) ; --UNCHK
lin polytechnic_N = mkWN (k2 "opisto") "polytekninen" ; --UNCHK
lin polytheism_N = mkWN (k5 "polyteismi") ; --UNCHK
lin polytheist_N = mkWN (k5 "polyteisti") ; --UNCHK
lin polytheistic_A = mkWA (k38 "polyteistinen") ; --UNCHK
lin polythene_N = mkWN (k5 "polyeteeni") ; --UNCHK
lin polytonal_A = mkWA (compoundA "poly" (k38 "tonaalinen")) ; --UNCHK
lin polytonality_N = mkWN (compoundN "poly" (k40 "tonaalisuus")) ; --UNCHK
lin polyunsaturated_A = mkWA (compoundA "moni" (k34A "tyydyttymätön")) ; --UNCHK
lin polyurethane_N = mkWN (k5 "polyuretaani") ; --UNCHK
lin polyuria_N = mkWN "runsasvirtsaisuus" ; --UNCHK
lin polyvalence_N = mkWN (compoundN "moni" (k40 "tehoisuus")) ; --UNCHK
lin polyvalent_A = mkWA (compoundA "moni" (k38 "valenssinen")) ; --UNCHK
lin pom_N = mkWN (k5 "engelsmanni") ; --UNCHK
lin pomade_N = mkWN (k10 "pomada") ; --UNCHK
lin pomarkku_PN = mkPN "Pomarkku" ;
lin pome_N = mkWN (compoundN "siemen" (k10 "hedelmä")) ; --UNCHK
lin pomegranate_N = mkWN (compoundN "granaatti" (k11 "omena")) ; --UNCHK
lin pomelo_N = mkWN (k2 "pomelo") ; --UNCHK
lin pomfret_N = mkWN (compoundN "meri" (k9 "lahna")) ; --UNCHK
lin pommel_N = mkWN (k5A "nuppi") ; --UNCHK
lin pommel_V2 = mkWV2 (k73A "hakata") ; --UNCHK
lin pommy_N = mkWN (k5 "engelsmanni") ; --UNCHK
lin pomologist_N = mkWN "pomologi" ; --UNCHK
lin pomology_N = mkWN (compoundN "hedelmä" (k48A "tiede")) ; --UNCHK
lin pomp_N = mkWN (k1 "loisto") ; --UNCHK
lin pompadour_N = mkWN (compoundN "tukka" (k48A "laite")) "nostettu" ; --UNCHK
lin pompano_N = mkWN (compoundN "pom" (k1 "pano")) ; --UNCHK
lin pompon_N = mkWN "Anisotremus" "surinamensis" ; --UNCHK
lin pomposity_N = mkWN (k40 "pöyhkeys") ; --UNCHK
lin pompous_A = mkWA (k38 "juhlallinen") ; --UNCHK
lin ponce_N = mkWN (k5 "sutenööri") ; --UNCHK
lin poncho_N = mkWN (k1 "poncho") ; --UNCHK
lin pond_N = mkWN (k4A "lammikko") ; --UNCHK
lin ponder_V = mkWV (k61 "tuumia") ; --UNCHK
lin ponder_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin ponder_VS = mkWVS (k61 "tuumia") ; --UNCHK
lin ponderable_A = mkWA (k38 "arvoinen") "harkitsemisen" ; --UNCHK
lin ponderosa_N = mkWN (compoundN "kelta" (k1A "mänty")) ; --UNCHK
lin ponderous_A = mkWA (k10 "painava") ; --UNCHK
lin ponderousness_N = mkWN (k40 "raskaus") ; --UNCHK
lin pondweed_N = mkWN (compoundN "vesi" (k10 "heinä")) ; --UNCHK
lin pone_N = mkWN (compoundN "maissi" (k10A "leipä")) ; --UNCHK
lin pongee_N = mkWN "pongee" ; --UNCHK
lin poniard_N = mkWN (k6 "tikari") ; --UNCHK
lin poniard_V2 = mkWV2 (k58 "iskeä") "tikarilla" ; --UNCHK
lin pons_N = mkWN (compoundN "aivo" (k9A "silta")) ; --UNCHK
lin pontardulais_PN = foreignPN "Pontardulais" ;
lin pontefract_PN = foreignPN "Pontefract" ;
lin pontifex_N = mkWN "pontifex" ; --UNCHK
lin pontiff_N = mkWN (k5 "paavi") "Rooman" ; --UNCHK
lin pontifical_A = mkWA (k38 "papillinen") ; --UNCHK
lin pontificate_N = mkWN (k40 "paavius") ; --UNCHK
lin pontificate_V = mkWV (k73 "saarnata") ; --UNCHK
lin pontoon_N = mkWN (k6 "ponttoni") ; --UNCHK
lin pontypool_PN = foreignPN "Pontypool" ;
lin pony_N = mkWN (k5 "poni") ; --UNCHK
lin pony_up_V2 = mkWV2 (k53A "pulittaa") ; --UNCHK
lin ponytail_N = mkWN (compoundN "ponin" (k10A "häntä")) ; --UNCHK
lin pooch_N = mkWN (k5A "rakki") ; --UNCHK
lin pood_N = mkWN "puuta" ; --UNCHK
lin poodle_N = mkWN (k6 "puudeli") ; --UNCHK
lin poof_N = mkWN (k6 "hinttari") ; --UNCHK
lin pool_N = mkN "allas" ;
lin pool_V2 = mkWV2 (k52A "liittyä") "porukkaan" ; --UNCHK
lin poole_PN = foreignPN "Poole" ;
lin pooler_N = mkWN (k32 "jäsen") "porukan" ; --UNCHK
lin poolroom_N = mkWN (compoundN "biljardi" (k5 "sali")) ; --UNCHK
lin poon_N = mkWN (compoundN "intianruusu" (k18 "puu")) ; --UNCHK
lin poop_N = mkWN (k6 "ahteri") ; --UNCHK
lin poop_out_V = mkWV (k52 "väsyä") ; --UNCHK
lin poor_1_A = mkA "köyhä" ;
lin poor_2_A = mkA "säälittävä" | mkA "raukka" | mkA "parka" ; ---- position
lin poor_3_A = mkA "kehno" | mkA "surkea" ;
lin poor_A = mkA "köyhä" ;
lin poor_box_N = mkWN (compoundN "almu" (k4A "laatikko")) ; --UNCHK
lin poorhouse_N = mkWN (compoundN "köyhäin" (k1 "talo")) ; --UNCHK
lin poorly_A = mkWA (k99 "kunnossa") "surkeassa" ; --UNCHK
lin poorness_N = mkWN (k40 "kehnous") ; --UNCHK
lin poorwill_N = mkWN (compoundN "horros" (k10 "kehrääjä")) ; --UNCHK
lin pop_A = mkWA "pop-" ; --UNCHK
lin pop_Adv = mkWAdv "poksahtaen" ; --UNCHK
lin pop_N = mkN "pop-" (mkN "musiikki") ;
lin pop_V2 = mkWV2 (k53A "poksahtaa") ; --UNCHK
lin pop_in_V = mkWV (k53A "piipahtaa") ; --UNCHK
lin pop_off_V = mkWV (k67 "kuolla") "äkillisesti" ; --UNCHK
lin pop_out_V = mkWV (k67 "tulla") "esiin" ; --UNCHK
lin pop_up_V = mkWV (k53A "putkahtaa") ; --UNCHK
lin popcorn_N = mkWN (k5 "popcorn") ; --UNCHK
lin pope_N = mkWN (k5 "paavi") "Rooman" ; --UNCHK
lin popery_N = mkWN (compoundN "paavin" (k1 "usko")) ; --UNCHK
lin popeyed_A = mkWA (compoundA "mulkosilmä" (k38 "inen")) ; --UNCHK
lin popgun_N = mkWN (compoundN "korkki" (k1 "pyssy")) ; --UNCHK
lin popinjay_N = mkWN (k9 "papukaija") ; --UNCHK
lin popish_A = mkWA (k38 "katolilainen") ; --UNCHK
lin poplar_N = mkWN (k6 "poppeli") ; --UNCHK
lin poplin_N = mkWN (k6 "popliini") ; --UNCHK
lin popliteal_A = mkWA "polvitaive-" ; --UNCHK
lin popover_N = mkWN (compoundN "pannu" (k1A "kakku")) ; --UNCHK
lin popper_N = mkWN (compoundN "popcorninpaahto" (k1 "pannu")) ; --UNCHK
lin poppet_N = mkWN (compoundN "lautas" (k6 "venttiili")) ; --UNCHK
lin poppy_N = mkWN (k4A "unikko") ; --UNCHK
lin poppycock_N = mkWN (k99 "soopa") ; --UNCHK
lin populace_N = mkWN (k13 "maailma") ; --UNCHK
lin popular_A = mkWA (k1A "suosittu") ;
lin popularism_N = mkWN (compoundN "populaari" (k5A "musiikki")) ; --UNCHK
lin popularity_N = mkWN (k3 "suosio") ; --UNCHK
lin popularization_N = mkWN (compoundN "populari" (k5A "sointi")) ; --UNCHK
lin popularize_V2 = mkWV2 (k53 "helppotajuistaa") ; --UNCHK
lin popularizer_N = mkWN (compoundN "populari" (k10 "soija")) ; --UNCHK
lin populate_V2 = mkWV2 (k53A "asuttaa") ;
lin population_N = mkN "populaatio" | mkN "väestö" | mkN "kanta" ;
lin populism_N = mkWN (k5 "populismi") ; --UNCHK
lin populist_N = mkWN (k5 "populisti") ; --UNCHK
lin populous_A = mkWA (compoundA "väki" (k41A "rikas")) ; --UNCHK
lin porbeagle_N = mkWN (compoundN "silli" (k18 "hai")) ; --UNCHK
lin porcelain_N = mkWN (k6 "posliini") ; --UNCHK
lin porch_N = mkWN (k12 "porstua") ; --UNCHK
lin porcine_A = mkWA "sikojen" ; --UNCHK
lin porcupine_N = mkWN (compoundN "piikki" (k9A "sika")) ; --UNCHK
lin porcupinefish_N = mkWN (compoundN "siili" (k9 "kala")) ; --UNCHK
lin pore_N = mkWN (k38 "huokonen") ; --UNCHK
lin pore_V = mkWV (k53 "kohdistaa") "huomionsa" ; --UNCHK
lin porgy_N = mkWN (compoundN "hammas" (k32 "ahven")) ; --UNCHK
lin pori_PN = mkPN "Pori" ;
lin pork_N = mkWN (k9A "sika") ; --UNCHK
lin pork_barrel_N = mkWN (k38 "tukiainen") ; --UNCHK
lin pork_butcher_N = mkWN (compoundN "leikkele" (k12 "myymälä")) ; --UNCHK
lin porkchop_N = mkWN (compoundN "porsaan" (k39 "kyljys")) ; --UNCHK
lin porker_N = mkWN (compoundN "syöttö" (k41 "porsas")) ; --UNCHK
lin porkfish_N = mkWN (compoundN "röhkijä" (k9 "kala")) ; --UNCHK
lin porkholt_N = mkWN (k5 "gulassi") ; --UNCHK
lin porkpie_N = mkWN (compoundN "lieri" (k1A "hattu")) "matala" ; --UNCHK
lin porn_N = mkWN (k40 "kirjallisuus") "eroottinen" ; --UNCHK
lin pornainen_PN = mkPN "Pornainen" ;
lin pornographer_N = mkWN (compoundN "porno" (k41 "kauppias")) ; --UNCHK
lin pornographic_A = mkWA (k38 "pornografinen") ; --UNCHK
lin pornography_N = mkWN (k40 "kirjallisuus") "eroottinen" ; --UNCHK
lin porose_A = mkWA (k38 "huokoinen") ; --UNCHK
lin porosity_N = mkWN (k40 "huokoisuus") ; --UNCHK
lin porous_A = mkWA (k38 "huokoinen") ; --UNCHK
lin porousness_N = mkWN (k40 "huokoisuus") ; --UNCHK
lin porphyria_N = mkWN "porfyria" ; --UNCHK
lin porphyrin_N = mkWN (k5 "porfyriini") ; --UNCHK
lin porphyritic_A = mkWA (k38 "porfyyrinen") ; --UNCHK
lin porphyry_N = mkWN (k5 "porfyyri") ; --UNCHK
lin porpoise_N = mkWN (k38 "pyöriäinen") ; --UNCHK
lin porridge_N = mkWN (k1 "puuro") ; --UNCHK
lin porringer_N = mkWN (k5A "kuppi") ; --UNCHK
lin port_A = mkWA (k5 "paapuuri") ; --UNCHK
lin port_N = mkWN (k5A "portti") ; --UNCHK
lin port_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin port_glasgow_PN = foreignPN "Port Glasgow" ;
lin port_talbot_PN = foreignPN "Port Talbot" ;
lin portability_N = mkWN "siirrettävyys" ; --UNCHK
lin portable_A = mkWA "matka-" ; --UNCHK
lin portable_N = mkWN "matkakirjoituskone" ; --UNCHK
lin portage_N = mkWN (compoundN "maa" (k39 "kuljetus")) ; --UNCHK
lin portal_N = mkWN (k5A "portti") ; --UNCHK
lin portcullis_N = mkWN (compoundN "lasku" (k5A "portti")) ; --UNCHK
lin portend_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin portent_N = mkWN (k39 "ennustus") ; --UNCHK
lin portentous_A = mkWA (k38 "suurellinen") ; --UNCHK
lin porter_N = mkWN (k6 "portteri") ; --UNCHK
lin porterage_N = mkWN (compoundN "kanta" (k38 "minen")) ; --UNCHK
lin porterhouse_N = mkWN (compoundN "härän" (k39 "kyljys")) ; --UNCHK
lin portfolio_N = mkWN (k1A "salkku") ; --f219
lin porthcawl_PN = foreignPN "Porthcawl" ;
lin porthmadog_PN = foreignPN "Porthmadog" ;
lin porthole_N = mkWN (compoundN "ampuma-" (k1A "aukko")) ; --UNCHK
lin portico_N = mkWN (k5 "pylväshalli") ; --UNCHK
lin portiere_N = mkWN (compoundN "ovi" (k1 "verho")) ; --UNCHK
lin portion_N = mkWN (k40 "osuus") ; --f80
lin portion_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin portishead_PN = foreignPN "Portishead" ;
lin portland_PN = foreignPN "Portland" ;
lin portly_A = mkWA (k14A "tanakka") ; --UNCHK
lin portmanteau_N = mkWN (compoundN "matka" (k1A "laukku")) ; --UNCHK
lin portrait_N = mkWN (k5A "potretti") ; --UNCHK
lin portraitist_N = mkWN (kH1 "maalari") ; --UNCHK
lin portraiture_N = mkWN (k39 "muotokuvamaalaus") ; --UNCHK
lin portray_V2 = mkWV2 (k73 "kuvata") ; --UNCHK
lin portrayal_N = mkWN (k9A "tulkinta") ;
lin portsmouth_PN = foreignPN "Portsmouth" ;
lin portugal_PN = foreignPN "Portugali" ;
lin portuguese_A = mkWA (k38 "portugalilainen") ; --UNCHK
lin portuguese_N = mkWN (k5 "portugali") ; --UNCHK
lin portulaca_N = mkWN (compoundN "portul" (k9A "akka")) ; --UNCHK
lin portwatcher_N = mkWN (compoundN "satama" (k5A "vahti")) ; --UNCHK
lin porvoo_PN = mkPN "Porvoo" ;
lin pose_N = mkWN (k40 "teennäisyys") ; --UNCHK
lin pose_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin pose_V2 = mkWV2 (k53A "sekoittaa") ;
lin poser_N = mkWN (k12 "pähkinä") "kuva" ; --UNCHK
lin poseur_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin poseuse_N = mkWN "diivailija" ; --UNCHK
lin posh_A = mkWA (k47 "hienostunut") ; --UNCHK
lin posio_PN = mkPN "Posio" ;
lin posit_V2 = mkWV2 (k53A "ottaa") "lähtökohdaksi" ; --UNCHK
lin position_N = mkN "asema" | mkN "positio" ;
lin position_V2 = mkV2 "asettaa" ;
lin positionable_A = mkWA "sijoitettava" ; --UNCHK
lin positional_A = mkWA "positio-" ; --UNCHK
lin positive_A = mkA "positiivinen" | mkA "myönteinen" ; ---- split
lin positive_N = mkWN (k5 "positiivi") ; --UNCHK
lin positiveness_N = mkWN (k40 "luotettavuus") ; --UNCHK
lin positivism_N = mkWN (k40 "varmuus") ; --UNCHK
lin positivist_A = mkWA (k38 "positivistinen") ; --UNCHK
lin positivist_N = mkWN (k5 "rationalisti") ; --UNCHK
lin positivity_N = mkWN (k40 "luotettavuus") ; --UNCHK
lin positron_N = mkWN (k5 "positroni") ; --UNCHK
lin posology_N = mkWN (compoundN "annostus" (k5A "oppi")) ; --UNCHK
lin posse_N = mkWN (compoundN "järjestys" (k3 "partio")) ; --UNCHK
lin posseman_N = mkWN (k32 "jäsen") "järjestyspartion" ; --UNCHK
lin possess_Prep = S.possess_Prep ;
lin possess_V2 = mkWV2 (k67 "olla") "oma" ; --UNCHK
lin possession_N = mkWN (k40 "omaisuus") ; --UNCHK
lin possessive_A = mkWA "genetiivi-" ; --UNCHK
lin possessiveness_N = mkWN (k40 "mustasukkaisuus") ; --UNCHK
lin possessor_N = mkWN (k12 "haltija") ; --UNCHK
lin possibility_N = mkN (lin NK {s = d40 "mahdollisuus"}) ;
lin possible_A = mkWA (k38 "mahdollinen") ;
lin possible_N = mkWN (k38 "mahdollinen") ; --UNCHK
lin possum_N = mkWN (k5 "opossumi") ; --UNCHK
lin post_N = mkWN (kH1 "posti") ;
lin post_Prep = mkPrep "jälkeen" ;
lin post_V = mkWV (k53A "ilmoittaa") ; --f58
lin post_V2 = mkV2 "postittaa" ;
lin post_horse_N = mkWN (compoundN "kyyti" (k38 "hevonen")) ; --UNCHK
lin post_meridiem_Adv = mkWAdv (k99 "jälkeen") "puolenpäivän" ; --UNCHK
lin post_war_A = mkWA (k38 "jälkeinen") "sodan" ; --UNCHK
lin postage_N = mkWN (compoundN "posti" (k5A "merkki")) ; --UNCHK
lin postage_stamp_N = mkWN (compoundN "posti" (k5A "merkki")) ; --UNCHK
lin postal_A = mkA (separateN "postiin" (mkN "kuuluva")) ;
lin postbag_N = mkWN (compoundN "posti" (k1A "laukku")) ; --UNCHK
lin postbox_N = mkWN (compoundN "kirje" (k4A "laatikko")) ; --UNCHK
lin postcard_N = mkWN (compoundN "posti" (k5A "kortti")) ; --UNCHK
lin postcode_N = mkWN (compoundN "posti" (k2 "numero")) ; --UNCHK
lin postdiluvian_A = mkWA (k38 "jälkeinen") "vedenpaisumuksen" ; --UNCHK
lin postdiluvian_N = mkWN (k3 "eliö") "vedenpaisumuksen" "jälkeinen" ; --UNCHK
lin postdoctoral_A = mkWA (k38 "jälkeinen") "väitöskirjan" ; --UNCHK
lin poste_restante_N = mkWN "poste" "restante" ; --UNCHK
lin poster_N = mkN "juliste" ; ---ARB --mkWN (compoundN "kyyti" (k38 "hevonen")) ;
lin posterior_A = mkWA "taka-" ; --UNCHK
lin posterior_N = mkWN (k41A "hammas") "takimmainen" ; --UNCHK
lin posteriority_N = mkWN "myöhemmyys" ; --UNCHK
lin posterity_N = mkWN (compoundN "jälki" (k13 "maailma")) ; --UNCHK
lin postern_N = mkWN (compoundN "taka" (k5A "portti")) ; --UNCHK
lin postganglionic_A = mkWA (k38 "takainen") "hermosolun" ; --UNCHK
lin postglacial_A = mkWA (k38 "jälkeinen") "jääkauden" ; --UNCHK
lin postgraduate_A = mkWA "jatko-opinto-" ; --UNCHK
lin postgraduate_N = mkWN (compoundN "jatko-" (k12 "opiskelija")) ; --UNCHK
lin posthitis_N = mkWN (k39 "tulehdus") "esinahan" ; --UNCHK
lin posthole_N = mkWN (k10A "kuoppa") "pylvään" ; --UNCHK
lin posthouse_N = mkWN (compoundN "kyyti" (k9A "paikka")) ; --UNCHK
lin posthumous_A = mkWA (k6 "postuumi") ; --UNCHK
lin postictal_A = mkWA (k38 "jälkeinen") "kohtauksen" ; --UNCHK
lin postilion_N = mkWN (compoundN "esi" (k10 "ratsastaja")) ; --UNCHK
lin postillion_N = mkWN (compoundN "esi" (k10 "ratsastaja")) ; --UNCHK
lin postindustrial_A = mkWA (compoundA "jälki" (k38 "teollinen")) ; --UNCHK
lin posting_N = mkWN (k39 "postitus") ; --UNCHK
lin postlude_N = mkWN (compoundN "loppu" (k1A "soitto")) ; --UNCHK
lin postman_N = mkWN (compoundN "postin" (k10 "jakaja")) ; --UNCHK
lin postmark_N = mkWN (compoundN "posti" (k9 "leima")) ; --UNCHK
lin postmark_V2 = mkWV2 (k73 "leimata") ; --UNCHK
lin postmaster_N = mkWN (compoundN "postin" (k10 "hoitaja")) ; --UNCHK
lin postmenopausal_A = mkWA (k38 "jälkeinen") "menopaussin" ; --UNCHK
lin postmeridian_A = mkWA "iltapäivän" ; --UNCHK
lin postmistress_N = mkWN (compoundN "postin" (k10 "hoitaja")) ; --UNCHK
lin postmodernist_A = mkWA (compoundA "post" (k38 "modernistinen")) ; --UNCHK
lin postmortem_A = mkWA (k38 "jälkeinen") "kuoleman" ; --UNCHK
lin postmortem_N = mkWN (compoundN "ruumiin" (k39 "avaus")) ; --UNCHK
lin postnatal_A = mkWA (k38 "jälkeinen") "synnytyksen" ; --UNCHK
lin postnuptial_A = mkWA (k38 "jälkeinen") "häiden" ; --UNCHK
lin postoperative_A = mkWA (k38 "jälkeinen") "leikkauksen" ; --UNCHK
lin postpaid_A = mkWA "ennalta" "maksettu" ; --UNCHK
lin postpone_V2 = mkWV2 (k54A "siirtää") "myöhemmäksi" ;
lin postponement_N = mkWN (k39 "lykkäys") ; --UNCHK
lin postposition_N = mkWN (compoundN "ase" (k38 "ttaminen")) "pääsanan" "perään" ; --UNCHK
lin postpositive_A = mkWA (compoundA "ase" (k1 "tettu")) "perään" ; --UNCHK
lin postprandial_A = mkWA (k38 "jälkeinen") "päivällisen" ; --UNCHK
lin postscript_N = mkWN (k48A "liite") ; --UNCHK
lin postulant_N = mkWN (compoundN "postu" (k5A "lantti")) ; --UNCHK
lin postulate_N = mkWN (k39 "oletus") ; --UNCHK
lin postulate_V2 = mkWV2 (k53A "ottaa") "lähtökohdaksi" ; --UNCHK
lin postulation_N = mkWN (k5 "adressi") ; --UNCHK
lin postulator_N = mkWN (k10 "esittäjä") "väitteen" ; --UNCHK
lin postural_A = mkWA "ryhti-" ; --UNCHK
lin posture_N = mkWN (k5A "ryhti") ; --UNCHK
lin posture_V = mkWV (k73 "poseerata") ; --UNCHK
lin posture_V2 = mkWV2 (k73 "poseerata") ; --UNCHK
lin posturer_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin posturing_N = mkWN (k39 "poseeraus") ; --UNCHK
lin posy_N = mkWN (compoundN "kukka" (k1 "vihko")) ; --UNCHK
lin pot_N = mkWN (k12 "kattila") ;
lin pot_V = mkWV (k53A "istuttaa") "ruukkuun" ; --UNCHK
lin pot_V2 = mkWV2 (k53A "istuttaa") "ruukkuun" ; --UNCHK
lin potable_A = mkWA (k10 "juotava") ; --UNCHK
lin potage_N = mkWN (k10A "rokka") ; --UNCHK
lin potash_N = mkWN (k5 "kali") "kaustinen" ; --UNCHK
lin potassium_N = mkWN (k5 "kalium") ; --UNCHK
lin potation_N = mkWN (k38 "juominen") ; --UNCHK
lin potato_N = mkWN (k5A "potaatti") ; --UNCHK
lin potbellied_A = mkWA (k41A "vatsakas") ; --UNCHK
lin potbelly_N = mkWN (k13 "kamiina") ; --UNCHK
lin potboiler_N = mkWN (compoundN "tusina" (k48A "tuote")) ; --UNCHK
lin potboy_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin poteen_N = mkWN (k5 "viski") "kotipolttoinen" ; --UNCHK
lin potency_N = mkWN (k1 "teho") ; --UNCHK
lin potent_A = mkWA (k10 "terävä") ; --UNCHK
lin potentate_N = mkWN (k5 "tyranni") ; --UNCHK
lin potential_A = mkA "potentiaalinen" ;
lin potential_N = mkN "potentiaali" ;
lin potentiality_N = mkWN (k39 "taipumus") ; --UNCHK
lin potentiation_N = mkWN "potentiaatio" ; --UNCHK
lin potentiometer_N = mkWN (k5 "potentiometri") ; --UNCHK
lin pothead_N = mkWN (k10 "polttaja") "marihuanan" ; --UNCHK
lin pother_N = mkWN (k39 "kiihtymys") ; --UNCHK
lin potherb_N = mkWN (compoundN "mauste" (k5 "kasvi")) ; --UNCHK
lin potholder_N = mkWN (compoundN "pata" (k1A "lappu")) ; --UNCHK
lin pothole_N = mkWN (k10A "kuoppa") ; --UNCHK
lin potholer_N = mkWN (compoundN "luolan" (k12 "tutkija")) ; --UNCHK
lin pothook_N = mkWN (compoundN "pata" (k1A "koukku")) ; --UNCHK
lin pothos_N = mkWN (compoundN "kulta" (k39 "köynnös")) ; --UNCHK
lin pothouse_N = mkWN (k5 "pub") ; --UNCHK
lin pothunter_N = mkWN (k10 "metsästäjä") ; --UNCHK
lin potion_N = mkWN (k1A "rohto") ; --UNCHK
lin potlatch_N = mkWN (compoundN "lahjojenvaihto" (k12 "seremonia")) ; --UNCHK
lin potman_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin potoroo_N = mkWN (compoundN "kenguru" (k10A "rotta")) ; --UNCHK
lin potpie_N = mkWN (compoundN "liha" (k14A "piirakka")) ; --UNCHK
lin potpourri_N = mkWN (compoundN "hajuste" (k39 "sekoitus")) ; --UNCHK
lin potsdam_PN = foreignPN "Potsdam" ;
lin potsherd_N = mkWN (compoundN "ruukun" (k48 "sirpale")) ; --UNCHK
lin pot_shot_N = mkWN (compoundN "lähi" (k39 "laukaus")) ; --UNCHK
lin pottage_N = mkWN (k10A "rokka") ; --UNCHK
lin potter_N = mkWN (k4A "keraamikko") ; --UNCHK
lin potter_V = mkWV (k67 "puuhailla") ; --UNCHK
lin potter_around_V = mkWV (k67 "puuhailla") ; --UNCHK
lin potterer_N = mkWN (k12 "puuhailija") ; --UNCHK
lin pottery_N = mkWN (compoundN "saven" (k9A "valanta")) ; --UNCHK
lin pottle_N = mkWN (k12 "astia") "1/2" "gallonan" ; --UNCHK
lin potto_N = mkWN "Perodicticus" "potto" ; --UNCHK
lin potty_A = mkWA (k99 "juovuksissa") ; --UNCHK
lin potty_N = mkWN (k10A "potta") ; --UNCHK
lin pouch_N = mkWN (k5 "pussi") ; --UNCHK
lin pouch_V2 = mkWV2 (k53A "pullottaa") ; --UNCHK
lin pouf_N = mkWN (k5 "rahi") ; --UNCHK
lin pouffe_N = mkWN (k5 "rahi") ; --UNCHK
lin poulette_N = mkWN "poulette" ; --UNCHK
lin poulterer_N = mkWN (compoundN "siipikarjan" (k10 "myyjä")) ; --UNCHK
lin poultice_N = mkWN (k48A "haude") ; --UNCHK
lin poultice_V2 = mkWV2 (k52A "hautoa") ; --UNCHK
lin poultry_N = mkWN (compoundN "kana" (k1A "lintu")) ; --UNCHK
lin poultryman_N = mkWN (compoundN "siipikarjan" (k10 "myyjä")) ; --UNCHK
lin pounce_N = mkWN (k39 "loikkaus") ; --UNCHK
lin pounce_V = mkWV (k52 "syöksyä") ; --UNCHK
lin pound_1_N = mkN "punta" ;
lin pound_2_N = mkN "punta" ;
lin pound_V = mkWV (k73 "murskata") ; --UNCHK
lin pound_V2 = mkWV2 (k73 "murskata") ; --UNCHK
lin poundage_N = mkWN (k5A "internointi") ; --UNCHK
lin pounder_N = mkWN (k33 "survin") ; --UNCHK
lin pounding_N = mkWN (k39 "jyskytys") ; --UNCHK
lin pour_V = mkWV (k67 "parveilla") ; --UNCHK
lin pour_V2 = mkWV2 (k67 "parveilla") ; --UNCHK
lin pour_down_V = mkWV (k73A "nakata") "naamaan" ; --UNCHK
lin pour_forth_V = mkWV (k67 "pulppuilla") ; --UNCHK
lin pour_in_V2 = mkV2 (mkV "syytää") (casePrep illative) ;
lin pour_out_V = mkWV (k53A "vuodattaa") ; --UNCHK
lin pout_N = mkWN (compoundN "mustapiikkim" (k7 "onni")) ; --UNCHK
lin pout_V = mkWV (k53 "mutristaa") ; --UNCHK
lin pout_V2 = mkWV2 (k53 "mutristaa") ; --UNCHK
lin poutingly_Adv = mkWAdv "mutristaen" ; --UNCHK
lin poverty_N = mkN "köyhyys" ;
lin pow_N = mkWN (compoundN "sota" (k5A "vanki")) ; --UNCHK
lin powder_N = mkWN (k6 "puuteri") ; --UNCHK
lin powder_V = mkWV (k62 "puuteroida") ; --UNCHK
lin powder_V2 = mkWV2 (k62 "puuteroida") ; --UNCHK
lin powder_flask_N = mkWN (compoundN "ruuti" (k1 "pullo")) ; --UNCHK
lin powder_horn_N = mkWN (compoundN "ruuti" (k1 "pullo")) ; --UNCHK
lin powder_magazine_N = mkWN (compoundN "ammus" (k2 "varasto")) ; --UNCHK
lin powder_room_N = mkWN (k99 "WC") "naisten" ; --UNCHK
lin powderer_N = mkWN "puuteroija" ; --UNCHK
lin powderpuff_N = mkWN (compoundN "puuteri" (k1 "huisku")) ; --UNCHK
lin powdery_A = mkWA "harmaan-" ; --UNCHK
lin power_N = mkN "teho" ;
lin power_V2 = mkWV2 (k56A "antaa") "virtaa" ; --UNCHK
lin power_dive_N = mkWN (k1 "syöksy") ; --UNCHK
lin power_point_N = mkWN (compoundN "pisto" (k12 "rasia")) ; --UNCHK
lin power_station_N = mkWN (k12 "voimala") ; --UNCHK
lin powerboat_N = mkWN (compoundN "pika" (k48 "vene")) ; --UNCHK
lin powerful_A = mkA (lin AK {s = d41A "voimakas"}) ;
lin powerhouse_N = mkWN (k12 "voimala") ;
lin powerless_A = mkWA (k1A "heikko") ; --UNCHK
lin powerlessness_N = mkWN (k40 "kyvyttömyys") ; --UNCHK
lin powwow_N = mkWN (k5 "palaveri") ; --UNCHK
lin powwow_V = mkWV (k53A "pitää") "kokous" ; --UNCHK
lin pox_N = mkWN (k1A "rokko") ; --UNCHK
lin poxvirus_N = mkWN (compoundN "rokko" (k39 "virus")) ; --UNCHK
lin poynton_PN = foreignPN "Poynton" ;
lin pp_N = mkN "PP" ; ---- no idea which abbreviation this is, but should not matter
lin pr_N = mkWN (k99 "PR") ; --UNCHK
lin practicability_N = mkWN (compoundN "käyttö" (k40 "kelpoisuus")) ; --UNCHK
lin practicable_A = mkWA (k38 "mahdollinen") ; --UNCHK
lin practical_A = mkWA (k38 "käytännöllinen") ; --UNCHK
lin practicality_N = mkWN (k40 "käytännöllisyys") ; --UNCHK
lin practice_N = mkN "käytäntö" ;
lin practice_V = mkV "harjoitella" ;
lin practice_V2 = mkWV2 (k73 "treenata") ; --UNCHK
lin practician_N = mkWN (compoundN "ammatin" (k10 "harjoittaja")) ; --UNCHK
lin practise_V = mkWV (k73 "treenata") ; --UNCHK
lin practise_V2 = mkWV2 (k73 "treenata") ; --UNCHK
lin practitionerFem_N = mkWN (compoundN "ammatin" (k10 "harjoittaja")) ;
lin practitionerMasc_N = mkWN (compoundN "ammatin" (k10 "harjoittaja")) ;
lin praenomen_N = mkWN (compoundN "etu" (k7 "nimi")) ; --UNCHK
lin praesidium_N = mkWN (k5 "presidiumi") ; --UNCHK
lin praetorian_A = mkWA "pretoriaani-" ; --UNCHK
lin praetorium_N = mkWN (k9A "teltta") "päällikön" ; --UNCHK
lin praetorship_N = mkWN (k9A "virka") "preetorin" ; --UNCHK
lin pragmatic_A = mkWA (k38 "pragmaattinen") ; --UNCHK
lin pragmatics_N = mkWN (k9A "pragmatiikka") ; --UNCHK
lin pragmatism_N = mkWN (k5 "pragmatismi") ; --UNCHK
lin pragmatist_N = mkWN (k5 "pragmatisti") ; --UNCHK
lin prague_PN = foreignPN "Praha" ;
lin prairie_N = mkWN (k12 "preeria") ; --UNCHK
lin praise_N = mkWN (k12 "kunnia") ; --UNCHK
lin praise_V2 = mkWV2 (k53 "ylistää") ; --UNCHK
lin praiseworthiness_N = mkWN (k40 "ansiokkuus") ; --UNCHK
lin praiseworthy_A = mkWA (k10 "kunnioitettava") ; --UNCHK
lin praisworthiness_N = mkWN (k40 "kiitettävyys") ; --UNCHK
lin praline_N = mkWN (k6 "praliini") ; --UNCHK
lin prance_N = mkWN (k2 "rehvastelu") ; --UNCHK
lin prance_V = mkWV (k67 "ylvästellä") ; --UNCHK
lin prancer_N = mkWN (k38 "hevonen") "vauhko" ; --UNCHK
lin prandial_A = mkWA "ateria-" ; --UNCHK
lin prang_N = mkWN (k6 "kolari") ; --UNCHK
lin prank_N = mkWN (k2 "pelleily") ; --UNCHK
lin prankishness_N = mkWN (k40 "veitikkamaisuus") ; --UNCHK
lin prankster_N = mkWN (k12 "kujeilija") ; --UNCHK
lin praseodymium_N = mkWN "järjestysluku" "59" ; --UNCHK
lin prate_N = mkWN (k12 "höpinä") ; --UNCHK
lin prate_V = mkWV (k53A "pälättää") ; --UNCHK
lin pratfall_N = mkWN (k48 "virhe") ; --UNCHK
lin pratincole_N = mkWN (compoundN "pääsky" (k10 "kahlaaja")) ; --UNCHK
lin prato_PN = foreignPN "Prato" ;
lin prattle_N = mkWN (k12 "höpinä") ; --UNCHK
lin prattle_V = mkWV (k53A "pälättää") ; --UNCHK
lin prattler_N = mkWN "jaarittelija" ; --UNCHK
lin pravastatin_N = mkWN (compoundN "prav" (k5 "astatiini")) ; --UNCHK
lin prawn_N = mkWN (compoundN "katka" (k1A "rapu")) "iso" ; --UNCHK
lin prawn_V = mkWV (k53 "kalastaa") "katkarapuja" ; --UNCHK
lin pray_V = mkWV (k54A "pyytää") ; --UNCHK
lin pray_V2 = mkWV2 (k54A "pyytää") ; --UNCHK
lin praya_N = mkWN "praya" ; --UNCHK
lin prayer_N = mkWN (k39 "rukous") ; --UNCHK
lin prayer_book_N = mkWN (compoundN "rukous" (k9 "kirja")) ; --UNCHK
lin prayer_mat_N = mkWN (compoundN "rukous" (k1A "matto")) ; --UNCHK
lin prayer_meeting_N = mkWN (compoundN "hartaus" (k7 "hetki")) ; --UNCHK
lin prayer_rug_N = mkWN (compoundN "rukous" (k1A "matto")) ; --UNCHK
lin prayer_wheel_N = mkWN (compoundN "rukous" (k10 "pyörä")) ; --UNCHK
lin prayerful_A = mkWA "rukoileva" ; --UNCHK
lin prazosin_N = mkWN "Minipress" ; --UNCHK
lin pre_approve_V2 = mkV2 (mkV (mkV "hyväksyä") "ennakkoon") ;
lin pre_eminent_A = mkA "erinomainen" ;
lin pre_empt_V2 = mkV2 "estää" ;
lin pre_emptive_A = mkA (mkN "ennalta" (mkN "ehkäisevä")) ;
lin pre_register_V2 = mkV2 (mkV (mkV "ilmoittautua") "ennakkoon") ;
lin pre_sign_V2 = mkV2 (mkV (mkV "allekirjoittaa") "etukäteen") ;
lin pre_test_V2 = mkV2 (mkV (mkV "testata") "etukäteen") ;
lin preach_V = mkWV (k53A "kannattaa") ; --UNCHK
lin preach_V2 = mkWV2 (k53A "kannattaa") ; --UNCHK
lin preacher_N = mkWN (k10 "julistaja") ; --UNCHK
lin preachification_N = mkWN (k9 "saarna") ; --UNCHK
lin preachify_V = mkWV (k62 "moralisoida") ; --UNCHK
lin preachy_A = mkWA (compoundA "saar" (k9 "naava")) ; --UNCHK
lin preamble_N = mkWN (k1A "johdanto") ;
lin preanal_A = mkWA "preanaali-" ; --UNCHK
lin prearrange_V2 = mkWV2 (k53 "järjestää") "ennalta" ; --UNCHK
lin prearrangement_N = mkWN (compoundN "ennakko" (k2 "järjestely")) ; --UNCHK
lin prebend_N = mkWN "prebendi" ; --UNCHK
lin prebendary_N = mkWN "prebendiaatti" ; --UNCHK
lin precancerous_A = mkWA "prekanseroosinen" ; --UNCHK
lin precarious_A = mkWA (compoundA "epä" (k17 "vakaa")) ; --UNCHK
lin precariousness_N = mkWN (compoundN "sattumanva" (k40 "raisuus")) ; --UNCHK
lin precast_A = mkWA (compoundA "esiva" (k1A "lettu")) ; --UNCHK
lin precatory_A = mkWA (k34A "sitomaton") ; --UNCHK
lin precaution_N = mkWN (kH1 "suoja") ; --UNCHK
lin precautionary_A = mkWA (compoundA "ennaltaehkäis" (k10 "evä")) ; --UNCHK
lin precede_V2 = mkV2 "edeltää" partitive ; --mkWV2 (k53 "perustaa") ;
lin precedence_N = mkWN (compoundN "etu" (k9 "sija")) ; --UNCHK
lin precedent_A = mkWA "edeltävä" ; --UNCHK
lin precedent_N = mkWN (compoundN "ennakko" (k39 "tapaus")) ; --UNCHK
lin precedented_A = mkWA "ennakkopäätökseen" "perustuva" ; --UNCHK
lin precedential_A = mkWA (compoundA "etu" (k1A "oikeutettu")) ; --UNCHK
lin preceding_A = mkWA "edeltävä" ; --UNCHK
lin precentor_N = mkWN (k6 "kanttori") ; --UNCHK
lin precentorship_N = mkWN (k10 "asema") "esilaulajan" ; --UNCHK
lin precept_N = mkWN (k5A "oppi") ; --UNCHK
lin preceptor_N = mkWN (k10 "opettaja") ; --UNCHK
lin preceptorship_N = mkWN (k9A "virka") "lehtorin" ; --UNCHK
lin precession_N = mkWN (compoundN "etu" (k9 "sija")) ; --UNCHK
lin prechlorination_N = mkWN "preklorinointi" ; --UNCHK
lin precinct_N = mkWN (k5 "piiri") ; --UNCHK
lin preciosity_N = mkWN (compoundN "pikku" (k40 "tarkkuus")) ; --UNCHK
lin precious_A = mkA "arvokas" ;
lin preciousness_N = mkWN (compoundN "pikku" (k40 "tarkkuus")) ; --UNCHK
lin precipice_N = mkWN (k48A "jyrkänne") ; --UNCHK
lin precipitant_N = mkWN (k33 "saostin") ; --UNCHK
lin precipitate_A = mkWA (k38 "hätäinen") ; --UNCHK
lin precipitate_N = mkWN (k39 "saos") ; --UNCHK
lin precipitate_V2 = mkWV2 (k53 "saostaa") ; --UNCHK
lin precipitation_N = mkWN (kH1 "kiire") ; --UNCHK
lin precipitator_N = mkWN (compoundN "sähkö" (k33A "suodatin")) ; --UNCHK
lin precipitin_N = mkWN "presipitiini" ; --UNCHK
lin precipitous_A = mkA "äkillinen" ; --mkWA (k10A "jyrkkä") ;
lin precis_N = mkWN (k10 "lyhennelmä") ; --UNCHK
lin precis_V2 = mkWV2 (k53 "koostaa") ; --UNCHK
lin precise_A = mkWA (k38 "täsmällinen") ; --UNCHK
lin preciseness_N = mkWN (k40 "tarkkuus") ; --UNCHK
lin precision_N = mkWN (k40 "tarkkuus") ;
lin preclinical_A = mkWA (compoundA "pre" (k38 "symptomaattinen")) ; --UNCHK
lin preclude_V2 = mkWV2 (k52 "torjua") ; --UNCHK
lin preclusion_N = mkWN (k2 "ehkäisy") ; --UNCHK
lin preclusive_A = mkWA (compoundA "este" (k1 "tty")) ; --UNCHK
lin precocial_A = mkWA "poikas-" ; --UNCHK
lin precocious_A = mkWA (compoundA "varhais" (k10 "kypsä")) ; --UNCHK
lin precociousness_N = mkWN (compoundN "varhais" (k40 "kypsyys")) ; --UNCHK
lin precocity_N = mkWN (compoundN "varhais" (k40 "kypsyys")) ; --UNCHK
lin precognition_N = mkWN (compoundN "ennakko" (k1A "tieto")) ; --UNCHK
lin preconceive_V2 = mkWV2 (k53A "käsittää") "ennakkoon" ; --UNCHK
lin preconception_N = mkWN (k39 "mieltymys") ; --UNCHK
lin preconcerted_A = mkWA "ennalta" "suunniteltu" ; --UNCHK
lin precondition_N = mkWN (k1A "ehto") ; --UNCHK
lin preconditioned_A = mkWA "esikäsitelty" ; --UNCHK
lin precooked_A = mkWA (compoundA "esi" (k1 "valmistettu")) ; --UNCHK
lin precooled_A = mkWA (compoundA "esi" (k1 "viilennetty")) ; --UNCHK
lin precordial_A = mkWA (compoundA "prekordia" (k38 "alinen")) ; --UNCHK
lin precordium_N = mkWN (compoundN "sydän" (k9 "ala")) ; --UNCHK
lin precursor_N = mkWN (k10 "edeltäjä") ; --UNCHK
lin precursory_A = mkWA (compoundA "ennak" (k10 "oiva")) ; --UNCHK
lin predaceous_A = mkWA (k41 "ahnas") ; --UNCHK
lin predacious_A = mkWA (k41 "ahnas") ; --UNCHK
lin predate_V2 = mkWV2 (k54A "edeltää") ; --UNCHK
lin predation_N = mkWN (k39 "saalistus") ; --UNCHK
lin predator_N = mkWN (k10 "saalistaja") ; --UNCHK
lin predatory_A = mkWA (k41 "ahnas") ; --UNCHK
lin predecease_V2 = mkWV2 (k67 "kuolla") "ennen" ; --UNCHK
lin predecessor_N = mkWN (k10 "edeltäjä") ;
lin predestinarian_A = mkWA "predestinaatio-" ; --UNCHK
lin predestinarianism_N = mkWN (compoundN "predestinaatio-" (k5A "oppi")) ; --UNCHK
lin predestinate_A = mkWA (k1A "määrätty") "ennalta" ; --UNCHK
lin predestinate_V2 = mkWV2 (k62 "predestinoida") ; --UNCHK
lin predestination_N = mkWN (k3 "predestinaatio") ; --UNCHK
lin predestine_V2 = mkWV2 (k73 "määrätä") "ennalta" ; --UNCHK
lin predetermination_N = mkWN "predeterminaatio" ; --UNCHK
lin predetermine_V2 = mkWV2 (k73 "määrätä") "ennakolta" ; --UNCHK
lin predicament_N = mkWN (k1A "ahdinko") ; --UNCHK
lin predicate_N = mkWN (k5A "predikaatti") ; --UNCHK
lin predicate_V2 = mkWV2 (k62 "implikoida") ; --UNCHK
lin predicative_A = mkWA (compoundA "predikatiivi" (k38 "nen")) ; --UNCHK
lin predicator_N = mkWN (k5A "predikaatti") ; --UNCHK
lin predict_V2 = mkV2 "ennustaa" ;
lin predict_VS = mkVS (mkV "ennustaa") ;
lin predictability_N = mkWN "ennakoitavuus" ; --UNCHK
lin predictable_A = mkWA (compoundA "odotuksen" (k38 "mukainen")) ; --UNCHK
lin prediction_N = mkWN (k39 "povaus") ; --UNCHK
lin predictive_A = mkWA (k38 "prognostinen") ; --UNCHK
lin predictor_N = mkWN (compoundN "ilmatorjunta" (k10 "järjestelmä")) ; --UNCHK
lin predigest_V2 = mkWV2 (compoundV "esi" (k53A "sulattaa")) ; --UNCHK
lin predilection_N = mkWN (k5 "preferenssi") ; --UNCHK
lin predispose_V2 = mkWV2 (k56A "saattaa") ; --UNCHK
lin predisposition_N = mkWN (k39 "taipumus") ; --UNCHK
lin prednisolone_N = mkWN "Prelone" ; --UNCHK
lin prednisone_N = mkWN "Meticorten" ; --UNCHK
lin predominance_N = mkWN "voittopuolisuus" ; --UNCHK
lin predominant_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin predominate_V = mkWV (k67 "olla") "vallitseva" ; --UNCHK
lin predomination_N = mkWN "voittopuolisuus" ; --UNCHK
lin preeclampsia_N = mkWN (compoundN "raskaus" (k39 "myrkytys")) ; --UNCHK
lin preemption_N = mkWN (compoundN "etuosto-" (k40 "oikeus")) ; --UNCHK
lin preemptive_A = mkWA (compoundA "ennaltaehkäis" (k10 "evä")) ; --UNCHK
lin preemptor_N = mkWN (k10 "tarjoaja") "ehkäisytarjouksen" ; --UNCHK
lin preen_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin pre_existence_N = mkWN (compoundN "olemassa" (k1 "olo")) "aiempi" ; --UNCHK
lin preexistent_A = mkWA (k10 "oleva") "olemassa" ; --UNCHK
lin prefab_A = mkWA "elementti-" ; --UNCHK
lin prefab_N = mkWN (k5A "elementti") ; --UNCHK
lin prefabricate_V2 = mkWV2 (compoundV "esi" (k53 "valmistaa")) ; --UNCHK
lin prefabrication_N = mkWN (compoundN "esi" (k38 "valmistaminen")) ; --UNCHK
lin preface_N = mkWN (k1A "johdanto") ; --UNCHK
lin preface_V2 = mkWV2 (k53 "perustaa") ; --UNCHK
lin prefaded_A = mkWA (compoundA "haa" (k1 "listettu")) ; --UNCHK
lin prefatory_A = mkWA (k10 "alustava") ; --UNCHK
lin prefect_N = mkWN (k5 "prefekti") ; --UNCHK
lin prefectural_A = mkWA "prefektin" ; --UNCHK
lin prefecture_N = mkWN (compoundN "prefektin" (k1 "virasto")) ; --UNCHK
lin prefer_V2 = mkV2 (mkWV (k53A "pitää") "parempana") partitive ;
lin prefer_VV = mkWVV (k53A "pitää") "parempana" ; --UNCHK
lin preferable_A = mkWA (k16A "parempi") ; --UNCHK
lin preference_N = mkWN (compoundN "etu" (k40 "oikeus")) ; --UNCHK
lin preferential_A = mkA "ensisijainen" ;
lin preferment_N = mkWN (k39 "ylennys") ; --UNCHK
lin preferred_A = variants {} ; --
lin prefiguration_N = mkWN (k5A "ennakointi") ; --UNCHK
lin prefigure_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin prefix_N = mkWN (k5 "prefiksi") ; --UNCHK
lin prefix_V2 = mkWV2 (k53A "liittää") "prefiksi" ; --UNCHK
lin prefixation_N = mkWN (compoundN "pre" (k3 "fiksaatio")) ; --UNCHK
lin preformation_N = mkWN (compoundN "preformaatio-" (k5A "oppi")) ; --UNCHK
lin prefrontal_A = mkWA (compoundA "pre" (k38 "frontaalinen")) ; --UNCHK
lin pregnancy_N = mkWN (k9A "raskausaika") ; --UNCHK
lin pregnanediol_N = mkWN "pregnaanidioli" ; --UNCHK
lin pregnant_A = mkWA (k10 "oleva") "raskaana" ; --UNCHK
lin preheat_V2 = mkWV2 (compoundV "esi" (k53A "lämmittää")) ; --UNCHK
lin prehistoric_A = mkWA (compoundA "esi" (k38 "historiallinen")) ; --UNCHK
lin prehistorical_A = mkWA (compoundA "esi" (k38 "historiallinen")) ; --UNCHK
lin prehistory_N = mkWN (k6 "kulttuuri") "esihistoriallinen" ; --UNCHK
lin prejudge_V2 = mkWV2 (k69 "tuomita") "ennakolta" ; --UNCHK
lin prejudgement_N = mkWN (compoundN "ennakko" (k39 "päätös")) ; --UNCHK
lin prejudgment_N = mkWN (compoundN "ennakko" (k39 "päätös")) ; --UNCHK
lin prejudice_N = mkWN (compoundN "ennakko" (k39 "käsitys")) ; --UNCHK
lin prejudice_V2 = mkWV2 (k53A "vaikuttaa") ; --UNCHK
lin prejudicial_A = mkWA (k38 "asenteellinen") ; --UNCHK
lin prelacy_N = mkWN (compoundN "prela" (k5 "tuuri")) ; --UNCHK
lin prelapsarian_A = mkWA (compoundA "supralap" (k38 "saarinen")) ; --UNCHK
lin prelate_N = mkWN (k39 "priimas") ; --UNCHK
lin prelim_N = mkWN (compoundN "ennakko" (k39 "tarkastus")) ; --UNCHK
lin preliminary_A = mkWA (k10 "alustava") ; --f56
lin preliminary_N = mkWN (k1A "johdanto") ; --UNCHK
lin preliterate_A = mkWA "esikirjoitustaitoinen" ; --UNCHK
lin prelude_N = mkN "johdanto" ; --mkWN (k5 "preludi") ;
lin prelude_V2 = mkWV2 (k53A "soittaa") "alkusoittona" ; --UNCHK
lin premature_A = mkWA (compoundA "ennen" (k38 "aikainen")) ;
lin prematureness_N = mkWN (compoundN "ennen" (k40 "aikaisuus")) ; --UNCHK
lin premedical_A = mkWA (compoundA "pre" (k38 "kliininen")) ; --UNCHK
lin premeditate_V2 = mkWV2 (k69 "harkita") ; --UNCHK
lin premeditation_N = mkWN (k40 "tahallisuus") ; --UNCHK
lin premenopausal_A = mkWA (compoundA "premenopausa" (k38 "alinen")) ; --UNCHK
lin premenstrual_A = mkWA (compoundA "premenstrua" (k38 "alinen")) ; --UNCHK
lin premier_A = mkWA "kanta-" ; --UNCHK
lin premier_N = mkWN (compoundN "pää" (k6 "ministeri")) "osavaltion" ; --UNCHK
lin premiere_N = mkWN (compoundN "ensi" (k39 "esitys")) ; --UNCHK
lin premiere_V = mkWV (compoundV "ensi" (k53A "esittää")) ; --UNCHK
lin premiere_V2 = mkWV2 (compoundV "ensi" (k53A "esittää")) ; --UNCHK
lin premiership_N = mkWN (k9A "virka") "pääministerin" ; --UNCHK
lin premise_N = mkN "tila" ;
lin premise_V2 = mkWV2 (k53A "olettaa") ; --UNCHK
lin premises_N = mkWN (k48 "alue") ; --UNCHK
lin premiss_V2 = mkWV2 (k53A "olettaa") ; --UNCHK
lin premium_A = mkWA (compoundA "korkea" (k38 "luokkainen")) ; --UNCHK
lin premium_N = mkWN (k3 "palkkio") ; --f122
lin premolar_N = mkWN (compoundN "väli" (k41A "hammas")) ; --UNCHK
lin premonition_N = mkWN (k48A "enne") ; --UNCHK
lin premonitory_A = mkWA (compoundA "ennak" (k10 "oiva")) ; --UNCHK
lin prenatal_A = mkWA (k38 "prenataalinen") ; --UNCHK
lin prentice_N = mkWN (k41 "oppilas") ; --UNCHK
lin preoccupancy_N = mkWN (k39 "valtaus") ; --UNCHK
lin preoccupation_N = mkN "keskittyminen" ; --WN (k39 "valtaus") ;
lin preoccupy_V2 = mkWV2 (k53A "askarruttaa") ; --UNCHK
lin preoperative_A = mkWA (compoundA "pre" (k38 "operatiivinen")) ; --UNCHK
lin preordain_V2 = mkWV2 (k73 "määrätä") "ennalta" ; --UNCHK
lin prep_N = mkWN (compoundN "valmis" (k38 "tautuminen")) ; --UNCHK
lin pre_packaged_A = mkWA (compoundA "esi" (k1 "pakattu")) ; --UNCHK
lin prepacked_A = mkWA (compoundA "esi" (k1 "pakattu")) ; --UNCHK
lin preparation_N = mkWN (compoundN "ruuan" (k39 "valmistus")) ; --UNCHK
lin preparatory_A = mkWA (k10 "valmistava") ; --UNCHK
lin prepare_V = mkV "valmistautua" ;
lin prepare_V2 = mkV2 "valmistaa" ;
lin prepare_V2V = mkWV2V (k52A "varautua") ;
lin prepare_VV = mkVV (mkV "varautua") infIllat ;
lin preparedness_N = mkWN (k40 "valmius") ; --UNCHK
lin prepay_V2 = mkWV2 (k56 "maksaa") "ennakkoon" ;
lin prepayment_N = mkWN (k4A "ennakko") ; --UNCHK
lin preponderance_N = mkWN (k40 "enemmyys") ; --UNCHK
lin preponderant_A = mkWA (k10 "ratkaiseva") ; --UNCHK
lin preponderate_V = mkWV (k56 "painaa") "enemmän" ; --UNCHK
lin preposition_N = mkWN (k3 "prepositio") ; --UNCHK
lin prepositional_A = mkWA "prepositio-" ; --UNCHK
lin prepossess_V2 = mkWV2 (k53A "vaikuttaa") ; --UNCHK
lin prepossession_N = mkWN (k39 "mieltymys") ; --UNCHK
lin preposterous_A = mkWA (k34A "posketon") ; --UNCHK
lin preprandial_A = mkWA "ateriaa" "edeltävä" ; --UNCHK
lin prepuberty_N = mkWN (compoundN "esi" (k5A "puberteetti")) ; --UNCHK
lin prepubescent_A = mkWA (compoundA "esipubert" (k38 "eettinen")) ; --UNCHK
lin prepuce_N = mkWN (compoundN "esi" (k9 "nahka")) ; --UNCHK
lin prepupal_A = mkWA "esikotelo-" ; --UNCHK
lin prerecord_V2 = mkWV2 (k53A "äänittää") "ennalta" ; --UNCHK
lin prerequisite_A = mkWA (k10 "oleva") "ennakkoehtona" ; --UNCHK
lin prerequisite_N = mkWN (k39 "edellytys") ; --UNCHK
lin prerogative_N = mkWN (k40 "etuus") ;
lin presage_N = mkWN (k39 "ennustus") ; --UNCHK
lin presage_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin presbyope_N = mkWN (compoundN "presbyo" (k5A "oppi")) ; --UNCHK
lin presbyopia_N = mkWN (compoundN "ikä" (k1A "näkö")) ; --UNCHK
lin presbyter_N = mkWN (k5 "presbyteeri") ; --UNCHK
lin presbyterian_N = mkWN (k5 "presbyteeri") ; --UNCHK
lin presbyterianism_N = mkWN (compoundN "presbyteerilä" (k40 "isyys")) ; --UNCHK
lin presbytery_N = mkWN "presbyteerio" ; --UNCHK
lin preschool_N = mkWN (compoundN "esi" (k1 "koulu")) ; --UNCHK
lin preschooler_N = mkWN (compoundN "esi" (k38 "koululainen")) ; --UNCHK
lin prescience_N = mkWN (compoundN "ennakko" (k39 "näkemys")) ; --UNCHK
lin prescient_A = mkWA (k38 "enteellinen") ; --UNCHK
lin prescot_PN = foreignPN "Prescot" ;
lin prescribe_V = mkWV (k58 "käskeä") ; --UNCHK
lin prescribe_V2 = mkV2 "määrätä" partitive ; --mkWV2 (k58 "käskeä") ;
lin prescript_N = mkWN (k48 "ohje") ; --UNCHK
lin prescription_N = mkWN (compoundN "resepti" (k48A "lääke")) ; --UNCHK
lin prescriptive_A = mkWA "ohjaileva" ; --UNCHK
lin prescriptivism_N = mkWN (compoundN "preskriptiv" (k5 "ismi")) ; --UNCHK
lin preseason_N = mkWN (compoundN "esi" (k27 "kausi")) ; --UNCHK
lin presence_N = mkN "läsnäolo" ;
lin present_A = mkA "nykyinen" | mkA "läsnäoleva" ; ---- split
lin present_N = mkN "lahja" | mkN "nyky" (mkN "hetki" "hetkiä") | mkWN (k5 "preesens") ; ---- split
lin present_V2 = mkV2 "esittää" ;
lin present_day_A = mkA "tämänhetkinen" ;
lin presentable_A = mkWA (k5 "siisti") ; --UNCHK
lin presentation_N = mkWN (k10 "esitelmä") ; --UNCHK
lin presentational_A = mkWA (compoundA "presentationa" (k38 "alinen")) ; --UNCHK
lin presenter_N = mkWN (k10 "antaja") ; --UNCHK
lin presentiment_N = mkWN (k39 "aavistus") ; --UNCHK
lin presentist_N = mkWN "presentisti" ; --UNCHK
lin presentment_N = mkWN (k10 "esitelmä") ; --UNCHK
lin presentness_N = mkWN (k40 "nykyisyys") ; --UNCHK
lin preservable_A = mkWA "säilytettävä" ; --UNCHK
lin preservation_N = mkWN (k2 "varjelu") ; --UNCHK
lin preservationist_N = mkWN (k12 "suojelija") ; --UNCHK
lin preservative_A = mkWA "säilövä" ; --UNCHK
lin preservative_N = mkWN (compoundN "säilöntä" (k48 "aine")) ; --UNCHK
lin preserve_N = mkWN (k48A "hilloke") ; --UNCHK
lin preserve_V2 = mkV2 "säilyttää" ; ---ARB mkWV2 (k52 "säilöä") ;
lin preserver_N = mkWN (k5 "pelastusliivi") ; --UNCHK
lin preset_A = mkWA (compoundA "määrite" (k1 "tty")) "ennalta" ; --UNCHK
lin preside_V = mkWV (k61 "toimia") "puheenjohtajana" ; --UNCHK
lin presidency_N = mkWN (compoundN "presidentti" (k27 "kausi")) ; --UNCHK
lin presidentFem_N = mkN "presidentti" ;
lin presidentMasc_N = mkN "presidentti" ;
lin presidential_A = mkWA "presidentillinen" ;
lin presidio_N = mkWN "presidio" ; --UNCHK
lin presidium_N = mkWN (k5 "presidiumi") ; --UNCHK
lin presocratic_A = mkWA (compoundA "esi" (k38 "sokraattinen")) ; --UNCHK
lin press_N = mkN "lehdistö" | mkWN (k39 "painallus") ; ---- split
lin press_V = mkV "painostaa" ;
lin press_V2 = mkWV2 (k74A "vedota") ; --UNCHK
lin press_V2V = mkWV2V (k74A "vedota") ; --UNCHK
lin press_agency_N = mkWN (compoundN "uutis" (k2 "palvelu")) ; --UNCHK
lin press_agent_N = mkWN (k10 "tiedottaja") ; --UNCHK
lin press_ahead_V = advV OP_press_V OP_ahead_Adv ; -- guess-p-verb
lin press_box_N = mkWN (compoundN "lehdistö" (k3 "aitio")) ; --UNCHK
lin press_clipping_N = mkWN (k48A "leike") ; --UNCHK
lin press_cutting_N = mkWN (k48A "leike") ; --UNCHK
lin press_for_V2 = prepV2 OP_press_V OP_for_Prep ; -- guess-p-verb
lin press_forward_with_V2 = prepV2 (advV OP_press_V OP_forward_Adv ) OP_with_Prep ; -- guess-p-verb
lin press_gallery_N = mkWN (compoundN "lehdistö" (k48A "parveke")) ; --UNCHK
lin press_gang_N = mkWN (compoundN "värväys" (k1A "joukko")) ; --UNCHK
lin press_into_V2 = prepV2 OP_press_V OP_into_Prep ; -- guess-p-verb
lin press_lord_N = mkWN (compoundN "sanomalehti" (k41A "kuningas")) ; --UNCHK
lin press_on_V = mkWV (k54A "rientää") "eteenpäin" ; --UNCHK
lin press_photographer_N = mkWN (compoundN "lehti" (k10 "kuvaaja")) ; --UNCHK
lin press_stud_N = mkWN (k6 "neppari") ; --UNCHK
lin press_upon_V2 = prepV2 OP_press_V OP_upon_Prep ; -- guess-p-verb
lin pressing_A = mkWA (k10 "pakottava") ; --UNCHK
lin pressing_N = mkWN (k39 "painallus") ; --UNCHK
lin pressman_N = mkWN (compoundN "lehti" (k42 "mies")) ; --UNCHK
lin pressmark_N = mkWN (k10A "hyllyluokka") ; --UNCHK
lin pressor_A = mkWA "verenpainetta" "nostava" ; --UNCHK
lin pressure_N = mkN "paine" ;
lin pressure_V2 = mkWV2 (k53 "painostaa") partitive ;
lin pressure_V2V = mkWV2V (k53 "painostaa") ; --UNCHK
lin pressure_cooker_N = mkWN (compoundN "paine" (k12 "kattila")) ; --UNCHK
lin pressure_gauge_N = mkWN (compoundN "paine" (k6 "mittari")) ; --UNCHK
lin pressurized_A = mkA "paineistettu" ;
lin prestatyn_PN = foreignPN "Prestatyn" ;
lin prestidigitation_N = mkWN (k40 "näppäryys") ; --UNCHK
lin prestidigitator_N = mkWN (k4A "maagikko") ; --UNCHK
lin prestige_N = mkWN (k40 "arvovaltaisuus") ;
lin prestigious_A = mkWA (compoundA "arvo" (k38 "valtainen")) ; --UNCHK
lin prestissimo_A = mkWA "prestissimo" ; --UNCHK
lin prestissimo_Adv = mkWAdv (k99 "nopeasti") "erittäin" ; --UNCHK
lin presto_A = mkWA (k99 "presto") ; --UNCHK
lin presto_Adv = mkWAdv (k99 "nopeasti") ; --UNCHK
lin preston_PN = foreignPN "Preston" ;
lin prestonpans_PN = foreignPN "Prestonpans" ;
lin prestwich_PN = foreignPN "Prestwich" ;
lin prestwick_PN = foreignPN "Prestwick" ;
lin presumable_A = mkWA (k10 "luultava") ;
lin presumably_Adv = adjAdv presumable_A ; -- -- derived
lin presume_V = mkWV (k61A "tohtia") ; --UNCHK
lin presume_V2 = mkWV2 (k61A "tohtia") ; --UNCHK
lin presume_VS = mkWVS (k61A "tohtia") ; --UNCHK
lin presumption_N = mkWN (k39 "oletus") ; --UNCHK
lin presumptive_A = mkWA "presumptiivinen" ; --UNCHK
lin presumptuous_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin presuppose_V2 = mkWV2 (k61A "vaatia") ; --UNCHK
lin presupposition_N = mkWN (compoundN "ennakko-" (k10 "otaksuma")) ; --UNCHK
lin preteen_A = mkWA "esiteini-ikäisten" ; --UNCHK
lin preteen_N = mkWN "esiteini-ikäinen" ; --UNCHK
lin pretence_N = mkWN (k2 "teeskentely") ; --UNCHK
lin pretend_V = mkWV (k67A "uskotella") ; --UNCHK
lin pretend_V2 = mkWV2 (k67A "uskotella") ; --UNCHK
lin pretend_VS = mkWVS (k67A "uskotella") ; --UNCHK
lin pretender_N = mkWN (k10 "petkuttaja") ; --UNCHK
lin pretense_N = mkWN (k2 "teeskentely") ; --UNCHK
lin pretension_N = mkWN (k2 "mahtailu") ; --UNCHK
lin pretentiousness_N = mkWN (k40 "suurellisuus") ; --UNCHK
lin preterist_N = mkWN (compoundN "prete" (k5 "risti")) ; --UNCHK
lin preterit_N = mkWN (k5 "preteriti") ; --UNCHK
lin preterite_N = mkWN (k5 "preteriti") ; --UNCHK
lin pretermission_N = mkWN (compoundN "laimin" (k5A "lyönti")) ; --UNCHK
lin preternatural_A = mkWA (compoundA "tuon" (k38 "puoleinen")) ; --UNCHK
lin pretext_N = mkWN (k48A "veruke") ; --UNCHK
lin pretoria_PN = foreignPN "Pretoria" ;
lin pretrial_N = mkWN (k2 "valmistelu") "suullinen" ; --UNCHK
lin prettify_V2 = mkWV2 (k67 "kaunistella") ; --UNCHK
lin prettily_Adv = mkWAdv (k99 "viehättävästi") ; --UNCHK
lin prettiness_N = mkWN (k40 "sievyys") ; --UNCHK
lin pretty_A = mkA "sievä" ;
lin pretty_AdA = mkAdA "melkoisen" ;
lin pretzel_N = mkWN (k6 "rinkeli") ; --UNCHK
lin prevail_V = mkWV (k52 "pysyä") "järkähtämättömänä" ;
lin prevalence_N = mkWN (k40 "yleisyys") ; --UNCHK
lin prevalent_A = mkWA (k10 "hallitseva") ; --UNCHK
lin prevaricate_V = mkWV (k53 "väistää") ; --UNCHK
lin prevarication_N = mkWN (k2 "valehtelu") ; --UNCHK
lin prevent_V2 = mkV2 "estää" partitive ;
lin preventable_A = mkWA (k10 "oleva") "ehkäistävissä" ; --UNCHK
lin preventative_N = mkWN (compoundN "ehkäisy" (k48 "väline")) ; --UNCHK
lin prevention_N = mkWN (k9A "torjunta") ; --UNCHK
lin preventive_A = mkWA (compoundA "suoj" (k9 "aava")) ; --UNCHK
lin preventive_N = mkWN (compoundN "ehkäisy" (k48 "väline")) ; --UNCHK
lin preview_N = mkWN (compoundN "ennakko" (k39 "esitys")) ; --UNCHK
lin preview_V2 = mkWV2 (k71 "nähdä") "etukäteen" ; --UNCHK
lin previous_A = mkA "edellinen" ;
lin prevision_N = mkWN (k39 "povaus") ; --UNCHK
lin prewar_A = mkWA "sotaa" "edeltävä" ; --UNCHK
lin prey_N = mkWN (k41 "saalis") ; --UNCHK
lin prey_V = mkWV (k53 "riistää") ; --UNCHK
lin priapic_A = mkWA (k38 "fallinen") ; --UNCHK
lin priapism_N = mkWN (compoundN "priap" (k5 "ismi")) ; --UNCHK
lin price_N = mkN "hinta" ;
lin price_V = mkV (lin VK {s = c67A "hinnoitella"}) ;
lin price_V2 = mkV2 "hinnoitella" ;
lin price_V2V = variants {} ; -- mkV2 "hinnoitella" ;
lin price_control_N = mkWN (compoundN "hinta" (k2 "säännöstely")) ; --UNCHK
lin priceless_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin pricey_A = mkWA (k10 "hintava") ; --UNCHK
lin pricing_N = mkWN (k2 "hinnoittelu") ; --UNCHK
lin prick_N = mkWN (k39 "pistos") ; --UNCHK
lin prick_V = mkWV (k53 "pistää") ; --UNCHK
lin prick_V2 = mkWV2 (k53 "pistää") ; --UNCHK
lin pricker_N = mkWN (k33 "purasin") ; --UNCHK
lin pricket_N = mkWN (compoundN "peura" (k39 "uros")) ; --UNCHK
lin pricking_N = mkWN (k39 "pistos") ; --UNCHK
lin prickle_N = mkWN (k12 "tähkylä") ; --UNCHK
lin prickle_V = mkWV (k53 "pistää") ; --UNCHK
lin prickle_V2 = mkWV2 (k53 "pistää") ; --UNCHK
lin prickleback_N = mkWN (compoundN "ahven" (k9 "kala")) ; --UNCHK
lin prickliness_N = mkWN (k40 "piikikkyys") ; --UNCHK
lin prickling_N = mkWN (k48A "polte") ; --UNCHK
lin prickly_A = mkWA (k38 "piikkinen") ; --UNCHK
lin pride_N = mkWN (k40 "kopeus") ; --UNCHK
lin pride_V2 = mkWV2 (k67 "olla") "ylpeä" ; --UNCHK
lin priest_N = L.priest_N ;
lin priestcraft_N = mkWN (compoundN "papin" (k19 "työ")) ; --UNCHK
lin priestess_N = mkWN (k32A "papitar") ; --UNCHK
lin priesthood_N = mkWN (k2 "papisto") ; --UNCHK
lin priestlike_A = mkWA (k38 "papillinen") ; --UNCHK
lin priestly_A = mkWA (k38 "papillinen") ; --UNCHK
lin prig_N = mkWN (k5 "snobi") ; --UNCHK
lin priggish_A = mkWA (k38 "viktoriaaninen") ; --UNCHK
lin priggishness_N = mkWN (k40 "muodollisuus") ; --UNCHK
lin prim_A = mkWA (k38 "viktoriaaninen") ; --UNCHK
lin prim_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin prima_A = mkWA "pää-" ; --UNCHK
lin prima_ballerina_N = mkWN (compoundN "prima" (k9 "ballerina")) ; --UNCHK
lin prima_donna_N = mkWN (k9 "diiva") ; --UNCHK
lin prima_facie_A = mkWA "prima" "facie" ; --UNCHK
lin prima_facie_Adv = mkWAdv "ensinäkemältä" ; --UNCHK
lin primacy_N = mkWN (compoundN "etu" (k9 "sija")) ; --UNCHK
lin primaeval_A = mkWA (k38 "muinainen") ; --UNCHK
lin primal_A = mkWA (k38 "muinainen") ; --UNCHK
lin primality_N = mkWN (compoundN "alku" (k1A "luku")) ; --UNCHK
lin primaquine_N = mkWN "primakiini" ; --UNCHK
lin primary_A = mkWA (compoundA "ensi" (k38 "sijainen")) ;
lin primary_N = mkN "esi" (mkN "vaali") ;
lin primate_N = mkWN (k38 "kädellinen") ; --UNCHK
lin primateship_N = mkWN (k9A "virka") "arkkipiispan" ; --UNCHK
lin primatology_N = mkWN (compoundN "kädellis" (k39 "tutkimus")) ; --UNCHK
lin prime_A = mkA (mkN "ensi" (mkN "sijainen")) ;
lin prime_N = mkN "huippu" ; ---ARB --mkN "alkuluku" ;
lin prime_V2 = mkWV2 (k53A "virittää") ; --UNCHK
lin primer_N = mkWN (k39 "pohjustus") ; --UNCHK
lin primeval_A = mkWA (k38 "muinainen") ; --UNCHK
lin primidone_N = mkWN "Mysoline" ; --UNCHK
lin primigravida_N = mkWN (compoundN "ensi" (k10 "synnyttäjä")) ; --UNCHK
lin priming_N = mkWN (k39 "pohjustus") ; --UNCHK
lin primipara_N = mkWN (compoundN "primi" (k9 "para")) ; --UNCHK
lin primitive_A = mkA "primitiivinen" ;
lin primitive_N = mkWN (compoundN "kanta" (k9 "sana")) ; --UNCHK
lin primitiveness_N = mkWN (k40 "alkeellisuus") ; --UNCHK
lin primitivism_N = mkWN (k5 "primitivismi") ; --UNCHK
lin primness_N = mkWN (k40 "muodollisuus") ; --UNCHK
lin primo_A = mkWA (k9 "priima") ; --UNCHK
lin primo_N = mkWN "primo" ; --UNCHK
lin primogeniture_N = mkWN (compoundN "esikois" (k40 "oikeus")) ; --UNCHK
lin primordial_A = mkWA (k38 "muinainen") ; --UNCHK
lin primordium_N = mkWN "primordium" ; --UNCHK
lin primp_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin primping_N = mkWN "tälläytyminen" ; --UNCHK
lin primrose_N = mkWN (k4A "esikko") ; --UNCHK
lin primula_N = mkWN (k4A "esikko") ; --UNCHK
lin primus_N = mkWN (compoundN "Primus-" (k33A "keitin")) ; --UNCHK
lin prince_N = mkWN (k5 "prinssi") ; --UNCHK
lin princedom_N = mkWN (compoundN "ruhtinas" (k10A "kunta")) ; --UNCHK
lin princeling_N = mkWN (k5 "prinssi") "nuori" ; --UNCHK
lin princely_A = mkWA (k38 "ruhtinaallinen") ; --UNCHK
lin princess_N = mkWN (k13 "prinsessa") ; --UNCHK
lin princewood_N = mkWN (compoundN "alliod" (k10 "ora")) "Cordia" ; --UNCHK
lin principal_A = mkWA (compoundA "pää" (k38 "asiallinen")) ;
lin principal_N = mkN "rehtori" ;
lin principality_N = mkWN (compoundN "ruhtinas" (k10A "kunta")) ; --UNCHK
lin principalship_N = mkWN (k9A "virka") "rehtorin" ; --UNCHK
lin principle_N = mkN "periaate" ;
lin principled_A = mkWA (compoundA "peri" (k38 "aatteellinen")) ; --UNCHK
lin prink_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin print_N = mkWN (k39 "vedos") ; --UNCHK
lin print_V = mkWV (k66 "julkaista") ;
lin print_V2 = mkWV2 (k66 "julkaista") ; --UNCHK
lin print_out_V2 = prepV2 OP_print_V OP_out_Prep ; -- guess-p-verb
lin print_seller_N = mkWN (compoundN "painotuote" (k10 "myyjä")) ; --UNCHK
lin print_shop_N = mkWN (k1 "paino") ; --UNCHK
lin printable_A = mkWA (compoundA "paino" (k38 "kelpoinen")) ; --UNCHK
lin printed_A = mkA "painettu" ;
lin printer_N = mkWN (k33 "tulostin") ;
lin printing_N = mkWN (compoundN "kustannus" (k9A "toiminta")) ;
lin printing_ink_N = mkWN (compoundN "paino" (k48 "muste")) ; --UNCHK
lin printing_press_N = mkWN (k1 "paino") ; --UNCHK
lin printmaker_N = mkWN (k4A "graafikko") ; --UNCHK
lin printmaking_N = mkWN (k14A "grafiikka") ; --UNCHK
lin printout_N = mkN (lin NK {s = d48 "tuloste"}) ;
lin prion_N = mkWN "prioni" ; --UNCHK
lin prior_A = mkA (mkN "aiempi" "aiemman" "aiempia") ;
lin prior_N = mkWN (compoundN "pri" (k48 "ori")) ; --UNCHK
lin prior_to_Prep = mkPrep "ennen" partitive ;
lin prioress_N = mkWN (k9 "abbedissa") ; --UNCHK
lin priority_N = mkN (lin NK {s = d05A "prioriteetti"}) ;
lin priorship_N = mkWN (k9A "virka") "priorin" ; --UNCHK
lin priory_N = mkWN (k6 "luostari") ; --UNCHK
lin prise_V2 = mkWV2 (k53A "pitää") "arvossa" ; --UNCHK
lin prism_N = mkWN (k9 "prisma") "optinen" ; --UNCHK
lin prismatic_A = mkWA (compoundA "prisma" (k38 "attinen")) ; --UNCHK
lin prismatoid_N = mkWN (compoundN "moni" (k41A "tahokas")) ; --UNCHK
lin prismoid_N = mkWN (compoundN "moni" (k41A "tahokas")) ; --UNCHK
lin prison_N = mkN "vankila" ;
lin prisoner_N = mkWN (k5A "vanki") ; --UNCHK
lin prisonlike_A = mkWA (compoundA "vankila" (k38 "mainen")) ; --UNCHK
lin pristine_A = mkWA (k34A "turmeltumaton") ; --UNCHK
lin privacy_N = mkN "yksityisyys" ; --mkWN (k9 "rauha") "oma" ;
lin private_A = mkA "yksityinen" ;
lin private_N = mkN "yksityinen" ;
lin privateer_N = mkWN (compoundN "kaappari" (k9 "laiva")) ; --UNCHK
lin privation_N = mkWN (k48A "puute") ; --UNCHK
lin privatisation_N = variants {} ; --
lin privatization_N = mkWN (compoundN "yks" (k38 "ityistäminen")) ; --UNCHK
lin privatize_V2 = mkWV2 (k53 "yksityistää") ; --UNCHK
lin privet_N = mkWN (k6 "likusteri") ; --UNCHK
lin privilege_N = mkWN (compoundN "etu" (k40 "oikeus")) ; --UNCHK
lin privileged_A = mkWA (compoundA "etu" (k1A "oikeutettu")) ; --UNCHK
lin privy_A = mkWA (k38 "tietoinen") ; --UNCHK
lin privy_N = mkWN (k50 "kuivakäymälä") ; --UNCHK
lin prize_N = mkWN (k1A "palkinto") ; --UNCHK
lin prize_V2 = mkWV2 (k53A "pitää") "arvossa" ; --UNCHK
lin prize_fight_N = mkWN (compoundN "ammattilais" (k2 "ottelu")) ; --UNCHK
lin prize_money_N = mkWN (compoundN "palkinto" (k9 "raha")) ; --UNCHK
lin prize_ring_N = mkWN (compoundN "nyrkkeily" (k10 "kehä")) ; --UNCHK
lin prizefighter_N = mkWN (compoundN "ammattilais" (k12 "ottelija")) ; --UNCHK
lin pro_A = mkWA (k99 "puolesta") ; --UNCHK
lin pro_Adv = mkWAdv (k99 "puolesta") ; --UNCHK
lin pro_N = mkWN (k26 "puoli") "hyvä" ; --UNCHK
lin pro_Prep = mkPrep "puolesta" | mkPrep "pro" nominative ;
lin pro_forma_A = mkWA (kH1 "vuoksi") "muodon" ;
lin pro_rata_Adv = mkWAdv (k99 "suhteellisesti") ; --UNCHK
lin pro_tem_Adv = mkWAdv (k99 "väliaikaisesti") ; --UNCHK
lin pro_tempore_Adv = mkWAdv (k99 "väliaikaisesti") ; --UNCHK
lin proaccelerin_N = mkWN "faktori" "V" ; --UNCHK
lin proactive_A = mkWA (compoundA "pro" (k38 "aktiivinen")) ; --UNCHK
lin probabilism_N = mkWN (compoundN "probabil" (k5 "ismi")) ; --UNCHK
lin probabilistic_A = mkWA (compoundA "toden" (k38 "näköinen")) ; --UNCHK
lin probability_N = mkWN (compoundN "toden" (k40 "näköisyys")) ;
lin probable_A = mkA (mkN "toden" (mkN "näköinen")) ;
lin probable_AS = L.probable_AS ;
lin probable_N = mkWN (k9A "valinta") "todennäköinen" ; --UNCHK
lin probate_N = mkWN (k9A "valvonta") "testamentin" ; --UNCHK
lin probate_V2 = mkWV2 (k52 "valvoa") ; --UNCHK
lin probation_N = mkWN (k9A "koeaika") ; --UNCHK
lin probationary_A = mkWA (k38 "tilapäinen") ; --UNCHK
lin probationer_N = mkWN (k10 "oleva") "koetusajalla" ; --UNCHK
lin probative_A = mkWA (compoundA "todistusvoi" (k38 "mainen")) ; --UNCHK
lin probe_N = mkN "koe" "kokeen" "koetta" "kokeita" ; ---ARB mkWN (k39 "tähystys") ;
lin probe_V = mkWV (k67 "tarkastella") ; --UNCHK
lin probe_V2 = mkWV2 (k67 "tarkastella") ; --UNCHK
lin probenecid_N = mkWN "probenesidi" ; --UNCHK
lin probiotic_N = mkWN (k10 "floora") "probioottinen" ; --UNCHK
lin probity_N = mkWN (k40 "nuhteettomuus") ; --UNCHK
lin problem_N = mkN "ongelma" ;
lin problematic_A = mkWA (k10 "hankala") ;
lin proboscidean_N = mkWN (compoundN "norsu" (k33 "eläin")) ; --UNCHK
lin proboscis_N = mkWN (k10 "kärsä") ; --UNCHK
lin procaine_N = mkWN (compoundN "Ethoc" (k48 "aine")) ; --UNCHK
lin procarbazine_N = mkWN "prokarbatsiini" ; --UNCHK
lin procedural_A = mkA "proseduraalinen" ;
lin procedure_N = mkWN (k2 "menettely") ;
lin proceed_N = variants {} ; --
lin proceed_V = mkWV (k52 "edistyä") ;
lin proceeding_N = mkWN (k5 "prosessi") ; --f59
lin process_N = mkN "prosessi" ;
lin process_V = mkWV (k67A "käsitellä") ;
lin process_V2 = mkWV2 (k67A "käsitellä") ; --UNCHK
lin processing_N = mkWN (k5A "prosessointi") ; --UNCHK
lin procession_N = mkWN (compoundN "eteenpäin" (k1 "meno")) ; --UNCHK
lin processional_A = mkWA "kulkue-" ; --UNCHK
lin processional_N = mkWN (compoundN "saatto" (k5A "musiikki")) ; --UNCHK
lin processor_N = mkWN (k6 "prosessori") ; --UNCHK
lin prochlorperazine_N = mkWN "proklooriperatsiini" ; --UNCHK
lin proclaim_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin proclaim_VS = mkWVS (k53 "julistaa") ;
lin proclamation_N = mkWN (k39 "julistus") ; --UNCHK
lin proclivity_N = mkWN (k39 "viettymys") ; --UNCHK
lin proconsul_N = mkWN (compoundN "Poconsul-ihmis" (k12 "apina")) ; --UNCHK
lin proconsular_A = mkWA "prokonsulin" ; --UNCHK
lin proconsulate_N = mkWN (k9A "virka") "prokonsulin" ; --UNCHK
lin proconsulship_N = mkWN (k9A "virka") "prokonsulin" ; --UNCHK
lin proconvertin_N = mkWN "faktori" "VII" ; --UNCHK
lin procrastinate_V = mkWV (k73A "lykätä") ; --UNCHK
lin procrastination_N = mkWN (k39 "lykkäys") ; --UNCHK
lin procrastinator_N = mkWN (k6 "kuhnuri") ; --UNCHK
lin procreate_V2 = mkWV2 (k56 "jatkaa") "sukua" ; --UNCHK
lin procreation_N = mkWN (compoundN "lisä" (k38 "äntyminen")) ; --UNCHK
lin proctalgia_N = mkWN "proktalgia" ; --UNCHK
lin proctitis_N = mkWN (compoundN "peräsuoli" (k39 "tulehdus")) ; --UNCHK
lin proctologist_N = mkWN "proktologi" ; --UNCHK
lin proctology_N = mkWN (compoundN "peräsuoli" (k5A "oppi")) ; --UNCHK
lin proctoplasty_N = mkWN (compoundN "rektopl" (k12 "astia")) ; --UNCHK
lin proctor_N = mkWN (k10 "valvoja") ; --UNCHK
lin proctorship_N = mkWN (k9A "virka") "järjestyksenvalvojan" ; --UNCHK
lin proctoscope_N = mkWN (compoundN "proktosko" (k5A "oppi")) ; --UNCHK
lin proctoscopy_N = mkWN "proktoskopia" ; --UNCHK
lin procumbent_A = mkWA "pintajuuri-" ; --UNCHK
lin procurable_A = mkWA (k10 "oleva") "hankittavissa" ; --UNCHK
lin procurator_N = mkWN (k6 "prokuraattori") ; --UNCHK
lin procure_V2 = mkWV2 (k61 "toimia") "sutenöörinä" ; --UNCHK
lin procurement_N = mkWN (k9A "hankinta") ; --UNCHK
lin procurer_N = mkWN (k5 "sutenööri") ; --UNCHK
lin procuress_N = mkWN (k10 "parittaja") ; --UNCHK
lin procyclidine_N = mkWN "Kemadrin" ; --UNCHK
lin procyonid_N = mkWN (compoundN "supi" (k33 "eläin")) ; --UNCHK
lin prod_N = mkWN (k33 "pistin") ; --UNCHK
lin prod_V = mkWV (k66 "tökkäistä") ; --UNCHK
lin prod_V2 = mkWV2 (k66 "tökkäistä") ; --UNCHK
lin prod_V2V = mkV2V "yllyttää" ; --mkWV2V (k66 "tökkäistä") ;
lin prodigal_A = mkWA (k38 "tuhlaavainen") "hillittömän" ; --UNCHK
lin prodigal_N = mkWN (k10 "tuhlaaja") ; --UNCHK
lin prodigality_N = mkWN (k40 "ylenpalttisuus") ; --UNCHK
lin prodigious_A = mkWA (k38 "jättiläismäinen") ; --UNCHK
lin prodigy_N = mkWN (k48 "ihme") ; --UNCHK
lin prodromal_A = mkWA (compoundA "prodroma" (k38 "alinen")) ; --UNCHK
lin prodrome_N = mkWN (compoundN "esi" (k48 "oire")) ; --UNCHK
lin produce_N = mkWN (k1A "sato") ; --UNCHK
lin produce_V = mkV "tuottaa" ;
lin produce_V2 = mkV2 "tuottaa" partitive ;
lin producer_N = mkN (lin NK {s = d10 "tuottaja"}) ;
lin product_N = mkN "tuote" ;
lin production_N = mkN "tuotanto" ;
lin productive_A = mkWA (k10 "tuottoisa") ;
lin productiveness_N = mkWN (k40 "tuottavuus") ; --UNCHK
lin productivity_N = mkWN (k40 "tuottavuus") ; --UNCHK
lin proenzyme_N = mkWN (compoundN "pro" (k6 "entsyymi")) ; --UNCHK
lin profanation_N = mkWN (k2 "häpäisy") ; --UNCHK
lin profanatory_A = mkWA (compoundA "profan" (k10 "oiva")) ; --UNCHK
lin profane_A = mkWA (k38 "maallinen") ; --UNCHK
lin profane_V2 = mkWV2 (k73 "rienata") ; --UNCHK
lin profaneness_N = mkWN (k9 "riena") ; --UNCHK
lin profanity_N = mkWN (k39 "rienaus") ; --UNCHK
lin profess_V = mkWV (k53A "opettaa") ; --UNCHK
lin profess_V2 = mkWV2 (k53A "opettaa") ; --UNCHK
lin profess_V2V = mkWV2V (k53A "opettaa") ; --UNCHK
lin professedly_Adv = mkWAdv (compoundAdv "teeskennel" (k5 "lysti")) ; --UNCHK
lin profession_N = mkWN (k19 "työ") ; --UNCHK
lin professional_A = mkA "ammattimainen" ;
lin professional_N = mkWN (k38 "ammattilainen") ;
lin professionalism_N = mkWN (k40 "ammattimaisuus") ; --UNCHK
lin professionalization_N = mkWN (compoundN "ammatti" (k38 "laistaminen")) ; --UNCHK
lin professor_N = mkWN (k6 "professori") ;
lin professorial_A = mkWA "opettajan" ; --UNCHK
lin professorship_N = mkWN (k5 "professuuri") ; --UNCHK
lin proffer_N = mkWN (k39 "ehdotus") ; --UNCHK
lin proffer_V2 = mkWV2 (k52A "tarjoutua") ; --UNCHK
lin proficiency_N = mkWN (k40 "pätevyys") ; --UNCHK
lin proficient_A = mkWA (k10 "taitava") ; --UNCHK
lin profile_N = mkWN (compoundN "henkilö" (k10 "kuva")) ; --UNCHK
lin profile_V2 = mkWV2 (k62 "profiloida") ; --UNCHK
lin profiling_N = mkWN (k5A "profilointi") ; --UNCHK
lin profit_N = mkN "voitto" ;
lin profit_V = mkWV (k63 "saada") "voittoa" ; --UNCHK
lin profit_V2 = mkWV2 (k63 "saada") "voittoa" ; --UNCHK
lin profit_margin_N = mkWN (compoundN "käyttö" (k48A "kate")) ; --UNCHK
lin profit_sharing_N = mkWN (compoundN "tulos" (k39 "palkkaus")) ; --UNCHK
lin profitability_N = variants {} ; --
lin profitable_A = mkWA (k10 "tuottoisa") ; --f81
lin profitableness_N = mkWN (k40 "tuottoisuus") ; --UNCHK
lin profiteer_N = mkWN (k6 "kiskuri") ; --UNCHK
lin profiteer_V = mkWV (k67A "keinotella") ; --UNCHK
lin profiterole_N = mkWN (compoundN "tuuli" (k1A "hattu")) ; --UNCHK
lin profitless_A = mkWA (k34A "kannattamaton") ; --UNCHK
lin profligacy_N = mkWN (k40 "rivous") ; --UNCHK
lin profligate_A = mkA (lin AK {s = d38 "paheellinen"}) ;
lin profligate_N = mkWN (k10 "tuhlaaja") ; --UNCHK
lin profound_A = mkWA (compoundA "syvä" (k38 "henkinen")) ; --UNCHK
lin profoundness_N = mkWN (k40 "syvällisyys") ; --UNCHK
lin profundity_N = mkWN (k40 "syvällisyys") ; --UNCHK
lin profuse_A = mkWA (k5 "villi") ; --UNCHK
lin profuseness_N = mkWN (k40 "runsaus") ; --UNCHK
lin profusion_N = mkWN (k40 "runsaus") ; --UNCHK
lin progenitor_N = mkWN (compoundN "esi-" (k10 "isä")) ; --UNCHK
lin progeria_N = mkWN "progeria" ; --UNCHK
lin progestational_A = mkWA (compoundA "progestationa" (k38 "alinen")) ; --UNCHK
lin progesterone_N = mkWN (k5 "progesteroni") ; --UNCHK
lin progestin_N = mkWN (k5 "progestiini") ; --UNCHK
lin prognathism_N = mkWN "prognatia" ; --UNCHK
lin prognathous_A = mkWA "esiintyöntyvä" ; --UNCHK
lin prognosis_N = mkWN (k48 "ennuste") ; --UNCHK
lin prognostic_A = mkWA (k38 "prognostinen") ; --UNCHK
lin prognostic_N = mkWN (k39 "ennustus") ; --UNCHK
lin prognosticate_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin prognostication_N = mkWN (k48 "ennuste") ; --UNCHK
lin program_N = mkWN (k10 "ohjelma") ;
lin program_V2 = mkWV2 (k67A "suunnitella") "ohjelma" ; --UNCHK
lin program_V2V = mkWV2V (k67A "suunnitella") "ohjelma" ; --UNCHK
lin programma_N = mkWN (k10 "ohjelma") ; --UNCHK
lin programme_N = mkN "ohjelma" ;
lin programme_V2 = mkWV2 (k67A "suunnitella") "ohjelma" ; --UNCHK
lin programmerFem_N = mkWN (k10 "ohjelmoija") ;
lin programmerMasc_N = mkWN (k10 "ohjelmoija") ;
lin programming_N = mkWN (k5A "ohjelmointi") ; --UNCHK
lin progress_N = mkN "edistys" ;
lin progress_V = mkWV (k52A "kehittyä") ; --UNCHK
lin progress_V2 = mkWV2 (k52A "kehittyä") ; --UNCHK
lin progression_N = mkWN (compoundN "eteenpäin" (k1 "meno")) ; --UNCHK
lin progressive_A = mkWA (compoundA "edistys" (k38 "mielinen")) ;
lin progressive_N = mkWN (k5 "liberalisti") ; --UNCHK
lin progressiveness_N = mkWN (compoundN "edistysmiel" (k40 "isyys")) ; --UNCHK
lin progressivism_N = mkWN (compoundN "progressiv" (k5 "ismi")) ; --UNCHK
lin prohibit_V = mkWV (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin prohibit_V2 = mkV2 "kieltää" ;
lin prohibit_VS = mkWVS (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin prohibition_N = mkWN (k1A "kielto") ;
lin prohibitionist_N = mkWN (k10 "kannattaja") "kieltolain" ; --UNCHK
lin prohibitive_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin prohibitory_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin proinflammatory_A = mkWA (k38 "tulehduksellinen") ; --UNCHK
lin project_N = mkN "projekti" "projektin" "projekteja" ;
lin project_V = mkV "heijastua" ; --mkWV (k53A "esittää") ;
lin project_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin project_V2V = mkWV2V (k53A "esittää") ; --UNCHK
lin project_VS = mkWVS (k53A "esittää") ; --UNCHK
lin projectile_A = mkWA "heitettävä" ; --UNCHK
lin projectile_N = mkWN (k39 "ohjus") ; --UNCHK
lin projection_N = mkN "projektio" ;
lin projectionist_N = mkWN (compoundN "koneen" (k10 "käyttäjä")) ; --UNCHK
lin projector_N = mkWN (k6 "projektori") ; --UNCHK
lin prokaryote_N = mkWN "prokaryootti" ; --UNCHK
lin prokaryotic_A = mkWA (compoundA "pro" (k38 "karyoottinen")) ; --UNCHK
lin prolactin_N = mkWN (k5 "prolaktiini") ; --UNCHK
lin prolamine_N = mkWN "prolamiini" ; --UNCHK
lin prolapse_N = mkWN (compoundN "esiin" (k39 "luiskahdus")) ; --UNCHK
lin prolapse_V = mkWV (k53A "luiskahtaa") ; --UNCHK
lin prolate_A = mkWA (compoundA "vesimelonin" (k38 "muotoinen")) ; --UNCHK
lin prole_N = mkWN (k10 "kuuluva") "työväenluokkaan" ; --UNCHK
lin prolegomenon_N = mkWN (k1A "johdanto") ; --UNCHK
lin prolepsis_N = mkWN (k5A "ennakointi") ; --UNCHK
lin proletarian_A = mkWA (k38 "proletaarinen") ; --UNCHK
lin proletarian_N = mkWN (k10 "kuuluva") "työväenluokkaan" ; --UNCHK
lin proletariat_N = mkWN (k5A "proletariaatti") ; --UNCHK
lin proliferate_V = mkWV (k52A "lisääntyä") ; --UNCHK
lin proliferate_V2 = mkWV2 (k52A "lisääntyä") ; --UNCHK
lin proliferation_N = mkWN (compoundN "lisä" (k1 "kasvu")) ;
lin prolific_A = mkWA (k38 "hedelmällinen") ; --UNCHK
lin proline_N = mkWN "proliini" ; --UNCHK
lin prolix_A = mkWA (k38 "vaikeaselkoinen") ; --UNCHK
lin prolixity_N = mkWN (k40 "pitkäpiimäisyys") ; --UNCHK
lin prologue_N = mkWN (k5 "prologi") ; --UNCHK
lin prolong_V2 = mkV2 "pidentää" ;
lin prolongation_N = mkWN (k1 "jatko") ; --UNCHK
lin prolonge_N = mkWN (k27 "köysi") ; --UNCHK
lin prolonged_A = variants {} ; --
lin prolusory_A = mkWA "johdannollinen" ; --UNCHK
lin promenade_N = mkWN (k2 "vaeltelu") ; --UNCHK
lin promenade_V = mkWV (k67 "kävellä") ; --UNCHK
lin promenade_V2 = mkWV2 (k67 "kävellä") ; --UNCHK
lin promethazine_N = mkWN "Phenergan" ; --UNCHK
lin promethium_N = mkWN "järjestysluku" "61" ; --UNCHK
lin prominence_N = mkWN "huomattavuus" ;
lin prominent_A = mkWA (k10 "huomattava") ; --UNCHK
lin promiscuity_N = mkWN (k40 "siveettömyys") ; --UNCHK
lin promiscuous_A = mkWA (k41A "rietas") ; --UNCHK
lin promise_N = mkN "lupaus" ;
lin promise_V = mkWV (k53A "vakuuttaa") ; --UNCHK
lin promise_V2 = mkV2 "luvata" ;
lin promise_VS = mkWVS (k53A "vakuuttaa") ;
lin promise_VV = mkWVV (k53A "vakuuttaa") ; --UNCHK
lin promisee_N = mkWN (compoundN "lupauksen" (k10 "saaja")) ; --UNCHK
lin promiser_N = mkWN (compoundN "lupauksen" (k10 "antaja")) ; --UNCHK
lin promisingly_Adv = mkWAdv (k99 "lupaavasti") ; --UNCHK
lin promissory_A = mkWA "sitoumus-" ; --UNCHK
lin promontory_N = mkWN (k48A "niemeke") ; --UNCHK
lin promote_V = mkWV (k53 "edistää") ; --UNCHK
lin promote_V2 = mkV2 (mkV "edistää") partitive ;
lin promoter_N = mkWN (k6 "promoottori") ;
lin promotion_N = mkWN (k39 "ylennys") ;
lin promotional_A = mkWA "mainos-" ; --UNCHK
lin promotive_A = mkWA (compoundA "promov" (k10 "oiva")) ; --UNCHK
lin prompt_A = mkWA (k10 "sukkela") ; --UNCHK
lin prompt_N = mkWN (compoundN "komentokeh" (k48A "ote")) ; --UNCHK
lin prompt_V2 = mkWV2 (k53A "yllyttää") ;
lin prompt_V2V = mkWV2V (k53A "yllyttää") ; --UNCHK
lin prompt_box_N = mkWN (kH1 "koppi") "kuiskaajan" ; --UNCHK
lin prompt_copy_N = mkWN (k3 "kopio") "kuiskaajan" ; --UNCHK
lin promptbook_N = mkWN (k3 "kopio") "kuiskaajan" ; --UNCHK
lin prompter_N = mkWN (compoundN "luku" (k48A "laite")) ; --UNCHK
lin prompting_N = mkWN (k39 "kuiskaus") ; --UNCHK
lin promptitude_N = mkWN (k40 "täsmällisyys") ; --UNCHK
lin promptness_N = mkWN (k40 "säntillisyys") ; --UNCHK
lin promulgate_V2 = mkWV2 (k56A "saattaa") "voimaan" ; --UNCHK
lin promulgation_N = mkWN (k39 "julistus") ; --UNCHK
lin promulgator_N = mkWN (k12 "julkaisija") ; --UNCHK
lin promycelium_N = mkWN "promycelium" ; --UNCHK
lin pronation_N = mkWN (compoundN "sisään" (k1A "kierto")) ; --UNCHK
lin pronator_N = mkWN (compoundN "sisäänkiertäjä" (k39 "lihas")) ; --UNCHK
lin prone_A = mkWA (k99 "rähmällään") ; --UNCHK
lin proneness_N = mkWN (k40 "alttius") ; --UNCHK
lin prong_N = mkWN (k7A "kärki") ; --UNCHK
lin pronged_A = mkWA (k38 "haarainen") ; --UNCHK
lin pronghorn_N = mkWN (compoundN "hanka-" (k5A "antilooppi")) ; --UNCHK
lin pronominal_A = mkWA (k38 "pronominaalinen") ; --UNCHK
lin pronoun_N = mkWN (k2 "asemo") ; --UNCHK
lin pronounce_V = mkWV (k69 "tuomita") ; --UNCHK
lin pronounce_V2 = mkWV2 (k69 "tuomita") ; --UNCHK
lin pronounceable_A = mkWA "äännettävä" ; --UNCHK
lin pronounced_A = mkWA (k10 "merkittävä") ; --UNCHK
lin pronouncement_N = mkWN (k10A "lupa") ; --UNCHK
lin pronto_Adv = mkWAdv (k99 "pikaisesti") ; --UNCHK
lin pronucleus_N = mkWN (compoundN "esi" (k10 "tuma")) ; --UNCHK
lin pronunciamento_N = mkWN (k5 "manifesti") ; --UNCHK
lin pronunciation_N = mkWN "ortoepia" ; --UNCHK
lin proof_A = mkWA "-pitävä" ; --UNCHK
lin proof_N = mkWN (k39 "todistus") ; --UNCHK
lin proof_V2 = mkWV2 (k71 "tehdä") "kestäväksi" ; --UNCHK
lin proofread_V = mkWV (compoundV "korjaus" (k58A "lukea")) ; --UNCHK
lin proofread_V2 = mkWV2 (compoundV "korjaus" (k58A "lukea")) ; --UNCHK
lin proofreader_N = mkWN (compoundN "oiko" (k12 "lukija")) ; --UNCHK
lin prop_N = mkWN (k6 "potkuri") ; --UNCHK
lin prop_V2 = mkWV2 (k53A "pönkittää") partitive ;
lin prop_up_V2 = mkWV2 (k53A "pönkittää") ; --UNCHK
lin propaedeutic_N = mkWN (k5 "kurssi") "propedeuttinen" ; --UNCHK
lin propaganda_N = mkWN (k9 "propaganda") ;
lin propagandist_A = mkWA (k38 "propagandistinen") ; --UNCHK
lin propagandist_N = mkWN (k5 "propagandisti") ; --UNCHK
lin propagandize_V = mkWV (k62 "propagoida") ; --UNCHK
lin propagandize_V2 = mkWV2 (k62 "propagoida") partitive ;
lin propagate_V = mkWV (k52A "lisääntyä") ; --UNCHK
lin propagate_V2 = mkWV2 (k52A "lisääntyä") ; --UNCHK
lin propagation_N = mkWN (compoundN "lisä" (k38 "äntyminen")) ; --UNCHK
lin propagative_A = mkWA (compoundA "propag" (k10 "oiva")) ; --UNCHK
lin propagator_N = mkWN (compoundN "viestin" (k10 "välittäjä")) ; --UNCHK
lin propanal_N = mkWN (compoundN "propa" (k5 "naali")) ; --UNCHK
lin propane_N = mkWN (k5 "propaani") ;
lin propanol_N = mkWN (k5 "propanoli") ; --UNCHK
lin propanolol_N = mkWN "Inderal" ; --UNCHK
lin proparoxytone_N = mkWN "proparoksitooni" ; --UNCHK
lin propel_V2 = mkWV2 (k53A "liikuttaa") ; --UNCHK
lin propellant_A = mkWA "työntävä" ; --UNCHK
lin propellant_N = mkWN (compoundN "poltto" (k48 "aine")) ; --UNCHK
lin propellent_A = mkWA "työntävä" ; --UNCHK
lin propellent_N = mkWN (compoundN "poltto" (k48 "aine")) ; --UNCHK
lin propeller_N = mkWN (k5 "propelli") ; --UNCHK
lin propenal_N = mkWN (compoundN "pro" (k6 "penaali")) ; --UNCHK
lin propenoate_N = mkWN "akrylaatti" ; --UNCHK
lin propenonitrile_N = mkWN (compoundN "vinyyli" (k5 "syanidi")) ; --UNCHK
lin propensity_N = mkWN (k40 "alttius") ; --UNCHK
lin proper_A = mkWA (k38 "kunnollinen") ;
lin propertied_A = mkWA "omistava" ; --UNCHK
lin property_1_N = mkN "omaisuus" ;
lin property_2_N = mkN "ominaisuus" ;
lin property_N = mkN "omaisuus" ; ---- already split
lin property_man_N = mkWN (k10 "lavastaja") ; --UNCHK
lin property_master_N = mkWN (k10 "lavastaja") ; --UNCHK
lin propertyless_A = mkWA (compoundA "palkans" (k9 "aava")) ; --UNCHK
lin prophase_N = mkWN (compoundN "pro" (k5 "faasi")) ; --UNCHK
lin prophecy_N = mkWN (k48 "ennuste") ; --UNCHK
lin prophesy_V = mkWV (k62 "profetoida") ; --UNCHK
lin prophesy_V2 = mkWV2 (k62 "profetoida") ; --UNCHK
lin prophet_N = mkWN (k12 "näkijä") ; --UNCHK
lin prophetess_N = mkWN (k9A "profeetta") ; --UNCHK
lin prophetic_A = mkWA (k38 "enteellinen") ; --UNCHK
lin prophetical_A = mkWA (k38 "enteellinen") ; --UNCHK
lin prophylactic_A = mkWA (k38 "profylaktinen") ; --UNCHK
lin prophylactic_N = mkWN (k5A "kortonki") ; --UNCHK
lin prophylaxis_N = mkWN (k5 "profylaksi") ; --UNCHK
lin prophyll_N = mkWN (compoundN "pro" (k5 "fylli")) ; --UNCHK
lin propinquity_N = mkWN (k40 "läheisyys") ; --UNCHK
lin propitiate_V2 = mkWV2 (k53A "tyynnyttää") ; --UNCHK
lin propitiation_N = mkWN (k39 "sovitus") ; --UNCHK
lin propitiative_A = mkWA "sovittava" ; --UNCHK
lin propitiatory_A = mkWA "sovitus-" ; --UNCHK
lin propitious_A = mkWA (k10 "suotuisa") ; --UNCHK
lin propjet_N = mkWN "turbopotkurikone" ; --UNCHK
lin proponent_N = mkWN (k10 "edustaja") ; --UNCHK
lin proportion_N = mkWN (k40 "suhteellisuus") ; --UNCHK
lin proportion_V2 = mkWV2 (k53A "suhteuttaa") ; --UNCHK
lin proportionable_A = mkWA (k38 "verrannollinen") ; --UNCHK
lin proportional_A = mkWA (k38 "suhteellinen") ; --UNCHK
lin proportional_N = mkWN (k48 "suure") ; --UNCHK
lin proportionality_N = mkWN (k40 "suhteellisuus") ; --UNCHK
lin proportionate_A = mkWA (k38 "suhteellinen") ; --UNCHK
lin proposal_N = mkN "ehdotus" ;
lin propose_V = mkWV (k53A "esittää") ;
lin propose_V2 = mkV2 "ehdottaa" partitive ;
lin propose_VS = mkWVS (k53A "esittää") ; --UNCHK
lin propose_VV = mkVV "ehdottaa" infPresPartAgr ;
lin proposed_A = mkA "ehdotettu" ;
lin proposer_N = mkWN (k10 "esittäjä") ; --UNCHK
lin proposition_N = mkN "ehdotus" ; ---ARB --mkWN (k48A "hanke") ;
lin proposition_V2 = mkWV2 (k53A "ehdottaa") "säädyttömiä" ; --UNCHK
lin propositus_N = mkN "propositus" ; --UNCHK
lin propound_V2 = mkWV2 (k53A "ehdottaa") ; --UNCHK
lin propoxyphene_N = mkWN "Darvon" ; --UNCHK
lin proprietary_A = mkWA (compoundA "patento" (k1A "itu")) ; --UNCHK
lin proprietor_N = mkWN (k10 "omistaja") ; --UNCHK
lin proprietorship_N = mkWN (compoundN "toi" (k5 "minimi")) ; --UNCHK
lin proprietress_N = mkWN "omistajatar" ; --UNCHK
lin propriety_N = mkWN (k40 "säädyllisyys") ; --UNCHK
lin proprioception_N = mkWN (compoundN "asento" (k5 "aisti")) ; --UNCHK
lin proprioceptive_A = mkWA (compoundA "proprio" (k38 "septinen")) ; --UNCHK
lin proprionamide_N = mkWN (k5 "propanamidi") ; --UNCHK
lin props_N = mkWN (k39 "kunnioitus") ; --UNCHK
lin propulsion_N = mkWN (k1A "työntö") ; --UNCHK
lin propulsive_A = mkWA "työntävä" ; --UNCHK
lin propyl_N = mkWN (compoundN "propyyli" (k5 "radikaali")) ; --UNCHK
lin propylene_N = mkWN "propeeni" ; --UNCHK
lin propylthiouracil_N = mkWN (k5 "propyylitiourasiili") ; --UNCHK
lin proration_N = mkWN (k1A "jako") "suhteellinen" ; --UNCHK
lin prorogation_N = mkWN "prorogaatio" ; --UNCHK
lin prorogue_V2 = mkWV2 (k53A "keskeyttää") ; --UNCHK
lin prosaic_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin proscenium_N = mkWN (compoundN "proscenium-" (k10 "seinä")) ; --UNCHK
lin prosciutto_N = mkWN (k1A "kinkku") "ilmakuivattu" ; --UNCHK
lin proscribe_V2 = mkWV2 (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin proscription_N = mkWN (k3 "tuomio") ; --UNCHK
lin prose_N = mkWN (k10 "proosa") ; --UNCHK
lin prosecute_V2 = mkWV2 (k53A "harjoittaa") ; --UNCHK
lin prosecution_N = mkN "syyte" ; --WN "tavoitteleminen" ;
lin prosecutorFem_N = mkN "syyttäjä" ;
lin prosecutorMasc_N = mkN "syyttäjä" ;
lin proselyte_N = mkWN (k38 "käännynnäinen") ; --UNCHK
lin proselytize_V = mkWV (k53A "käännyttää") ; --UNCHK
lin proselytize_V2 = mkWV2 (k53A "käännyttää") ; --UNCHK
lin prosimian_N = mkWN (compoundN "puoli" (k12 "apina")) ; --UNCHK
lin prosiness_N = mkWN (k40 "arkipäiväisyys") ; --UNCHK
lin prosodic_A = mkWA (compoundA "pro" (k38 "sodinen")) ; --UNCHK
lin prosody_N = mkWN (k14A "metriikka") ; --UNCHK
lin prospect_N = mkWN (k48 "ennuste") ; --f87
lin prospect_V = mkWV (k61 "etsiä") ; --UNCHK
lin prospective_A = mkWA (k10 "tuleva") ; --UNCHK
lin prospector_N = mkWN (compoundN "malmin" (k12 "etsijä")) ; --UNCHK
lin prospectus_N = mkWN (k48A "esite") ; --UNCHK
lin prosper_V = mkWV (k52 "menestyä") ;
lin prosper_V2 = mkWV2 (k52 "menestyä") ; --UNCHK
lin prosperity_N = mkWN (k39 "menestys") ;
lin prosperous_A = mkWA (k41A "onnekas") ; --UNCHK
lin prostaglandin_N = mkWN (k6 "prostaglandiini") ; --UNCHK
lin prostate_A = mkWA "eturauhas-" ; --UNCHK
lin prostate_N = mkWN (k9 "prostata") ; --UNCHK
lin prostatitis_N = mkWN (k39 "tulehdus") "eturauhasen" ; --UNCHK
lin prosthesis_N = mkWN (k6 "proteesi") ; --UNCHK
lin prosthetic_A = mkWA "teko-" ; --UNCHK
lin prosthetics_N = mkWN (compoundN "proteesi" (k5A "oppi")) ; --UNCHK
lin prosthetist_N = mkWN (compoundN "proteesin" (k12 "tekijä")) ; --UNCHK
lin prosthion_N = mkWN "prostion" ; --UNCHK
lin prosthodontic_A = mkWA "hammasproteiikka-" ; --UNCHK
lin prosthodontics_N = mkWN (compoundN "hammasprote" (k9A "iikka")) ; --UNCHK
lin prosthodontist_N = mkWN (compoundN "hammasproteesi" (k5 "spesialisti")) ; --UNCHK
lin prostitute_N = mkN "prostituoitu" ; --mkWN (k1A "lumppu") ;
lin prostitute_V2 = mkWV2 (k73 "huorata") ; --UNCHK
lin prostitution_N = mkWN (k3 "prostituutio") ; --UNCHK
lin prostrate_A = mkWA (k99 "pitkällään") ; --UNCHK
lin prostrate_V2 = mkWV2 (k53A "lamauttaa") ; --UNCHK
lin prostration_N = mkWN (compoundN "hei" (k38 "ttäytyminen")) ; --UNCHK
lin prostyle_A = mkWA (compoundA "pseudopros" (k5 "tyyli")) ; --UNCHK
lin prosy_A = mkWA (k15 "lattea") ; --UNCHK
lin protactinium_N = mkWN "järjestysluku" "91" ; --UNCHK
lin protagonist_N = mkWN (compoundN "pää" (k2 "henkilö")) ; --UNCHK
lin protamine_N = mkWN "protamiini" ; --UNCHK
lin protanopia_N = mkWN (compoundN "puna" (k40 "sokeus")) ; --UNCHK
lin protanopic_A = mkWA (compoundA "puna" (k15 "sokea")) ; --UNCHK
lin protea_N = mkWN "protea" ; --UNCHK
lin protease_N = mkWN (k6 "entsyymi") "proteolyyttinen" ; --UNCHK
lin protect_V = mkWV (k67 "suojella") ;
lin protect_V2 = mkV2 "suojella" partitive ;
lin protection_N = mkN "suojelu" ;
lin protectionism_N = mkWN (k5 "protektionismi") ; --UNCHK
lin protectionistFem_N = mkWN (k5 "protektionisti") ; --UNCHK
lin protectionistMasc_N = mkWN (k5 "protektionisti") ; --UNCHK
lin protective_A = mkWA (compoundA "turv" (k9 "aava")) ; --UNCHK
lin protectiveness_N = mkWN "suojelevuus" ; --UNCHK
lin protector_N = mkWN (k5A "vahti") ; --UNCHK
lin protectorate_N = mkWN (k5A "protektoraatti") ; --UNCHK
lin protectorship_N = mkWN (k9A "virka") "protektorin" ; --UNCHK
lin protege_N = mkWN (k5A "suojatti") ; --UNCHK
lin protegee_N = mkWN (k5A "suojatti") ; --UNCHK
lin protein_N = mkWN (k5 "proteiini") ; --UNCHK
lin proteinaceous_A = mkWA (compoundA "proteiini" (k38 "mainen")) ; --UNCHK
lin proteolysis_N = mkWN (compoundN "proteoly" (k5 "ysi")) ; --UNCHK
lin proteolytic_A = mkWA (compoundA "pro" (k38 "teolyyttinen")) ; --UNCHK
lin proteome_N = mkWN "proteomi" ; --UNCHK
lin proteomics_N = mkWN (compoundN "proteo" (k9A "miikka")) ; --UNCHK
lin proterozoic_A = mkWA (compoundA "pro" (k38 "terotsooinen")) ; --UNCHK
lin protest_N = mkN "protesti" ;
lin protest_V = mkWV (k53A "esittää") "vastalause" ; --UNCHK
lin protest_V2 = mkV2 "vastustaa" partitive ; --mkWV2 (k53A "esittää") "vastalause" ;
lin protestant_A = mkWA (k38 "protestanttinen") ; --UNCHK
lin protestant_N = mkWN (k40 "protestanttisuus") ; --UNCHK
lin protestantism_N = mkWN (k5 "protestantismi") ; --UNCHK
lin protestation_N = mkWN (k5 "protesti") ; --UNCHK
lin protester_N = mkWN (compoundN "mielen" (k10 "osoittaja")) ;
lin prothalamion_N = mkWN (compoundN "hää" (k1 "laulu")) ; --UNCHK
lin prothorax_N = mkWN (compoundN "protoo" (k5 "raksi")) ; --UNCHK
lin prothrombin_N = mkWN "hyytymistekijä" "II" ; --UNCHK
lin prothrombinase_N = mkWN (compoundN "protrombin" (k5 "aasi")) ; --UNCHK
lin protist_N = mkWN (compoundN "alku" (k3 "eliö")) ; --UNCHK
lin protoarcheology_N = mkWN (k12 "arkeologia") ; --UNCHK
lin protoavis_N = mkWN "protoavis" ; --UNCHK
lin protoceratops_N = mkWN "protoceratops" ; --UNCHK
lin protocol_N = mkWN (k10 "protokolla") ; --UNCHK
lin protoctist_N = mkWN "protoktisti" ; --UNCHK
lin protogeometric_A = mkWA (compoundA "proto" (k38 "geometrinen")) ; --UNCHK
lin protohistory_N = mkWN (compoundN "varhais" (k12 "historia")) ; --UNCHK
lin protology_N = mkWN "protologia" ; --UNCHK
lin proton_N = mkWN (k5 "protoni") ; --UNCHK
lin protoplasm_N = mkWN (compoundN "alku" (k9 "lima")) ; --UNCHK
lin prototype_N = mkN "proto" (mkN "tyyppi") ; --mkWN (k10 "ruumiillistuma") ;
lin protozoal_A = mkWA "alkueläimen" ; --UNCHK
lin protozoan_N = mkWN (compoundN "alku" (k33 "eläin")) ; --UNCHK
lin protozoological_A = mkWA (compoundA "proto" (k38 "zoologinen")) ; --UNCHK
lin protozoologist_N = mkWN (compoundN "proto" (k5 "zoologi")) ; --UNCHK
lin protozoology_N = mkWN (compoundN "proto" (k12 "zoologia")) ; --UNCHK
lin protract_V2 = mkWV2 (k53A "venyttää") ; --UNCHK
lin protractile_A = mkWA "pidentyvä" ; --UNCHK
lin protraction_N = mkWN (k1 "jatko") ; --UNCHK
lin protractor_N = mkWN (compoundN "aste" (k1 "levy")) ; --UNCHK
lin protriptyline_N = mkWN "protriptyliini" ; --UNCHK
lin protrude_V = mkWV (k53A "pullottaa") ; --UNCHK
lin protrude_V2 = mkWV2 (k53A "pullottaa") ; --UNCHK
lin protrusile_A = mkWA "esiintyöntyvä" ; --UNCHK
lin protrusion_N = mkWN (k39 "törrötys") ; --UNCHK
lin protrusive_A = mkWA "ulostyöntyvä" ; --UNCHK
lin protuberance_N = mkWN (k48A "uloke") ; --UNCHK
lin protuberant_A = mkWA (compoundA "kupu" (k38 "mainen")) ; --UNCHK
lin proturan_N = mkWN (compoundN "esi" (k38 "hyönteinen")) ; --UNCHK
lin proud_A = mkWA (k15 "ylpeä") ; --UNCHK
lin provable_A = mkWA (k10 "oleva") "todistettavissa" ; --UNCHK
lin prove_V = mkV "todistaa" ;
lin prove_V2 = mkV2 "todistaa" ;
lin prove_VA = mkVA (mkV "osoittautua") (mkPrep translative) ;
lin prove_VS = mkVS "todistaa" ;
lin provenance_N = mkWN (k1A "kehto") ; --UNCHK
lin provencal_A = mkWA (compoundA "provence" (k38 "lainen")) ; --UNCHK
lin provender_N = mkWN (k10A "ruoka") ; --UNCHK
lin proverb_N = mkWN (k9A "sanonta") ; --UNCHK
lin proverbial_A = mkWA (compoundA "sananlasku" (k38 "mainen")) ; --UNCHK
lin provide_V = mkWV (k52A "varautua") ;
lin provide_V2 = mkV2 "tarjota" partitive ;
lin provided_Subj = mkSubj "mikäli" ; --
lin providence_N = mkWN (k39 "sallimus") ; --UNCHK
lin providence_PN = foreignPN "Providence" ;
lin provident_A = mkWA (compoundA "kauko" (k38 "näköinen")) ; --UNCHK
lin providential_A = mkWA (k38 "huolehtivainen") ; --UNCHK
lin provider_N = mkWN (k10 "elättäjä") ; --UNCHK
lin providing_Subj = variants {} ; --
lin province_N = mkWN (compoundN "maa" (k10A "kunta")) ; --UNCHK
lin provincial_A = mkWA (k38 "provinsiaalinen") ; --UNCHK
lin provincial_N = mkWN (k38 "maalainen") ; --UNCHK
lin provincialism_N = mkWN (k5 "provinsialismi") ; --UNCHK
lin provirus_N = mkWN (compoundN "pro" (k39 "virus")) ; --UNCHK
lin provision_N = mkWN (k9A "hankinta") ;
lin provision_V2 = mkWV2 (k74 "tarjota") ; --UNCHK
lin provisional_A = mkWA (k38 "tilapäinen") ; --UNCHK
lin proviso_N = mkWN (k39 "varaus") ; --UNCHK
lin provisory_A = mkWA (k38 "ehdollinen") ; --UNCHK
lin provitamin_N = mkWN (compoundN "pro" (k5 "vitamiini")) ; --UNCHK
lin provocation_N = mkWN (k3 "provokaatio") ; --UNCHK
lin provocative_A = mkWA (compoundA "provos" (k10 "oiva")) ; --UNCHK
lin provoke_V2 = mkWV2 (k62 "stimuloida") ; --UNCHK
lin provoking_A = mkWA (k34A "sietämätön") ; --UNCHK
lin provost_N = mkWN (k6 "rehtori") ; --UNCHK
lin prow_N = mkWN (k10A "kokka") ; --UNCHK
lin prowess_N = mkWN (k40 "kyvykkyys") ; --UNCHK
lin prowl_N = mkWN (k2 "hiiviskely") ; --UNCHK
lin prowl_V = mkWV (k52 "väijyä") ; --UNCHK
lin prowl_V2 = mkWV2 (k52 "väijyä") ; --UNCHK
lin prowler_N = mkWN (k12 "ahdistelija") ; --UNCHK
lin proxemics_N = mkWN (compoundN "prokse" (k9A "miikka")) ; --UNCHK
lin proximal_A = mkWA (k38 "läheinen") ; --UNCHK
lin proximate_A = mkWA (k38 "läheinen") ; --UNCHK
lin proximity_N = mkWN (k40 "läheisyys") ; --UNCHK
lin proximo_A = mkWA "tulevan" "kuun" ; --UNCHK
lin proxy_N = mkWN (k39 "valtuutus") ; --mkN "valtuutettu" ;
lin prude_N = mkWN (k5 "puritaani") ; --UNCHK
lin prudence_N = mkWN (k40 "varovaisuus") ; --UNCHK
lin prudent_A = mkWA (k41 "viisas") ; --UNCHK
lin prudential_A = mkWA (k38 "harkitsevainen") ; --UNCHK
lin prudery_N = mkWN (k2 "hienostelu") ; --UNCHK
lin prudhoe_PN = foreignPN "Prudhoe" ;
lin prudish_A = mkWA (k38 "viktoriaaninen") ; --UNCHK
lin prune_N = mkWN (k1 "luumu") "kuivattu" ; --UNCHK
lin prune_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin pruner_N = mkWN (k6 "vesuri") ; --UNCHK
lin pruning_N = mkWN (compoundN "karsi" (k38 "minen")) ; --UNCHK
lin pruning_hook_N = mkWN (k6 "vesuri") ; --UNCHK
lin pruning_saw_N = mkWN (compoundN "oksa" (k9 "saha")) ; --UNCHK
lin pruno_N = mkWN (k1 "kilju") ; --UNCHK
lin prurience_N = mkWN (k40 "riettaus") ; --UNCHK
lin pruriency_N = mkWN (k40 "riettaus") ; --UNCHK
lin prurient_A = mkWA (k41A "rietas") ; --UNCHK
lin prurigo_N = mkWN "syyhymä" ; --UNCHK
lin pruritus_N = mkWN (k12 "kutina") ; --UNCHK
lin prussian_A = mkWA (k38 "preussilainen") ; --UNCHK
lin prussian_N = mkWN (k38 "preussilainen") ; --UNCHK
lin pry_V = mkWV (k61A "urkkia") ; --UNCHK
lin pry_V2 = mkWV2 (k61A "urkkia") ; --UNCHK
lin pryingly_Adv = mkWAdv (compoundAdv "urk" (k99 "kivasti")) ; --UNCHK
lin psalm_N = mkWN (k5 "psalmi") ; --UNCHK
lin psalmist_N = mkWN "psalmista" ; --UNCHK
lin psalmody_N = mkWN (compoundN "psalmi" (k1 "laulu")) ; --UNCHK
lin psalter_N = mkWN (k9 "kirja") "Psalmien" ; --UNCHK
lin psalterium_N = mkWN (compoundN "sata" (k9A "kerta")) ; --UNCHK
lin psaltery_N = mkWN (k6 "psalttari") ; --UNCHK
lin psammoma_N = mkWN (compoundN "hiekka" (k33 "kasvain")) ; --UNCHK
lin psephologist_N = mkWN (compoundN "vaali" (k12 "tutkija")) ; --UNCHK
lin psephology_N = mkWN (compoundN "vaali" (k39 "tutkimus")) ; --UNCHK
lin pseud_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin pseudo_A = mkWA "vale-" ; --UNCHK
lin pseudo_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin pseudobulb_N = mkWN (compoundN "varsi" (k12 "mukula")) ; --UNCHK
lin pseudoephedrine_N = mkWN "pseudoefedriini" ; --UNCHK
lin pseudohallucination_N = mkWN (compoundN "pseudo" (k3 "hallusinaatio")) ; --UNCHK
lin pseudohermaphrodite_N = mkWN (compoundN "pseudo" (k5A "hermafrodiitti")) ; --UNCHK
lin pseudohermaphroditic_A = mkWA (compoundA "pseudo" (k38 "hermafrodiittinen")) ; --UNCHK
lin pseudohermaphroditism_N = mkWN (compoundN "vale" (k40 "kaksineuvoisuus")) ; --UNCHK
lin pseudomonad_N = mkWN "pseudomonas" ; --UNCHK
lin pseudonym_N = mkWN (k5 "pseudonyymi") ; --UNCHK
lin pseudonymous_A = mkWA (compoundA "kirjo" (k1 "itettu")) "salanimellä" ; --UNCHK
lin pseudophloem_N = mkWN (compoundN "vale" (k9 "nila")) ; --UNCHK
lin pseudopod_N = mkWN (compoundN "vale" (k9A "jalka")) ; --UNCHK
lin pseudoscience_N = mkWN (compoundN "pseudo" (k48A "tiede")) ; --UNCHK
lin pseudoscientific_A = mkWA (compoundA "pseudo" (k38 "tieteellinen")) ; --UNCHK
lin psi_N = mkWN "psii" ; --UNCHK
lin psilocybin_N = mkWN "psilosiini" ; --UNCHK
lin psilophyte_N = mkWN "psilofyytti" ; --UNCHK
lin psilophyton_N = mkWN "psilofytoni" ; --UNCHK
lin psilosis_N = mkWN (compoundN "hiusten" (k1A "lähtö")) ; --UNCHK
lin psittacosaur_N = mkWN "psittacosaurus" ; --UNCHK
lin psittacosis_N = mkWN (compoundN "papukaija" (k48 "kuume")) ; --UNCHK
lin psoas_N = mkWN "psoas" ; --UNCHK
lin psoriasis_N = mkWN (k39 "psoriasis") ; --UNCHK
lin psych_up_V2 = mkWV2 (k52A "kiihtyä") ; --UNCHK
lin psyche_N = mkWN (k5 "älli") ; --UNCHK
lin psychedelia_N = mkWN "psykedelia" ; --UNCHK
lin psychedelic_A = mkWA (k38 "psykedeelinen") ; --UNCHK
lin psychiatric_A = mkWA (k38 "psykiatrinen") ;
lin psychiatrist_N = mkWN (k10 "kallonkutistaja") ; --UNCHK
lin psychiatry_N = mkWN (k12 "psykopatologia") ; --UNCHK
lin psychic_A = mkWA (k38 "psyykkinen") ; --UNCHK
lin psychic_N = mkWN (k3 "meedio") ; --UNCHK
lin psychical_A = mkWA (k38 "psyykkinen") ; --UNCHK
lin psychoactive_A = mkWA (compoundA "psyko" (k38 "aktiivinen")) ; --UNCHK
lin psychoanalyse_V2 = mkWV2 (k62 "analysoida") ; --UNCHK
lin psychoanalysis_N = mkWN (compoundN "syvyys" (k12 "psykologia")) ; --UNCHK
lin psychoanalyst_N = mkWN (compoundN "psyko" (k4A "analyytikko")) ; --UNCHK
lin psychoanalytic_A = mkWA (compoundA "psyko" (k38 "analyyttinen")) ; --UNCHK
lin psychoanalytical_A = mkWA (compoundA "psyko" (k38 "analyyttinen")) ; --UNCHK
lin psychoanalyze_V2 = mkWV2 (k62 "analysoida") ; --UNCHK
lin psychobabble_N = mkWN (k26 "kieli") "psykologian" ; --UNCHK
lin psychodid_N = mkWN (compoundN "perhos" (k7 "sääski")) ; --UNCHK
lin psychodynamics_N = mkWN (compoundN "psyko" (k9A "dynamiikka")) ; --UNCHK
lin psychogenesis_N = mkWN "psykogeneesi" ; --UNCHK
lin psychogenetic_A = mkWA (k38 "psykogeeninen") ; --UNCHK
lin psychogenic_A = mkWA (k38 "psykogeeninen") ; --UNCHK
lin psychokinetic_A = mkWA (compoundA "psyko" (k38 "kineettinen")) ; --UNCHK
lin psycholinguist_N = mkWN (compoundN "psyko" (k5 "lingvisti")) ; --UNCHK
lin psycholinguistic_A = mkWA (compoundA "psyko" (k38 "lingvistinen")) ; --UNCHK
lin psycholinguistics_N = mkWN (compoundN "psyko" (k9A "lingvistiikka")) ; --UNCHK
lin psychological_A = mkWA (k38 "psykologinen") ; --UNCHK
lin psychologist_N = mkWN (k5 "psykologi") ;
lin psychology_N = mkWN (k48A "tiede") "psykologinen" ; --UNCHK
lin psychometric_A = mkWA (k38 "psykometrinen") ; --UNCHK
lin psychometry_N = mkWN (k14A "psykometriikka") ; --UNCHK
lin psychomotor_A = mkWA (compoundA "psyko" (k38 "motorinen")) ; --UNCHK
lin psychopath_N = mkWN (k5A "psykopaatti") ; --UNCHK
lin psychopathic_A = mkWA (k38 "psykopaattinen") ; --UNCHK
lin psychopharmacological_A = mkWA (compoundA "psyko" (k38 "farmakologinen")) ; --UNCHK
lin psychopharmacology_N = mkWN (compoundN "psyko" (k12 "farmakologia")) ; --UNCHK
lin psychophysicist_N = mkWN (compoundN "psyko" (k4A "fyysikko")) ; --UNCHK
lin psychophysics_N = mkWN (compoundN "psyko" (k14A "fysiikka")) ; --UNCHK
lin psychopomp_N = mkWN "psykopompos" ; --UNCHK
lin psychosexual_A = mkWA (compoundA "psyko" (k38 "seksuaalinen")) ; --UNCHK
lin psychosexuality_N = mkWN (compoundN "psyko" (k40 "seksuaalisuus")) ; --UNCHK
lin psychosis_N = mkWN (k5 "psykoosi") ; --UNCHK
lin psychosomatic_A = mkWA (k38 "psykosomaattinen") ; --UNCHK
lin psychosurgery_N = mkWN (compoundN "psyko" (k12 "kirurgia")) ; --UNCHK
lin psychotherapeutic_A = mkWA (compoundA "psyko" (k38 "terapeuttinen")) ; --UNCHK
lin psychotherapist_N = mkWN (k5 "psykologi") "kliininen" ; --UNCHK
lin psychotherapy_N = mkWN (compoundN "psyko" (k12 "terapia")) ; --UNCHK
lin psychotic_A = mkWA (k38 "psykoottinen") ; --UNCHK
lin psychotic_N = mkWN (k2 "henkilö") "psykoottinen" ; --UNCHK
lin psychrometer_N = mkWN (compoundN "kosteus" (k6 "mittari")) ; --UNCHK
lin pt_N = mkWN (k12 "platina") ; --UNCHK
lin ptarmigan_N = mkWN (k12 "kiiruna") ; --UNCHK
lin pteridological_A = mkWA "pteridologinen" ; --UNCHK
lin pteridologist_N = mkWN "pteridologi" ; --UNCHK
lin pteridology_N = mkWN "pteridologia" ; --UNCHK
lin pteridophyte_N = mkWN (k38 "sanikkainen") ; --UNCHK
lin pterion_N = mkWN (compoundN "siipilisäke" (k48 "piste")) ; --UNCHK
lin pteropogon_N = mkWN "Pteropogon" "humboltianum" ; --UNCHK
lin pterosaur_N = mkWN (k1 "lentolisko") ; --UNCHK
lin pterygium_N = mkWN (compoundN "siipi" (k1 "kalvo")) ; --UNCHK
lin ptomaine_N = mkWN (compoundN "ruoka" (k39 "myrkytys")) ; --UNCHK
lin ptosis_N = mkWN (k25 "riippuluomi") ; --UNCHK
lin ptyalin_N = mkWN "ptyaliini" ; --UNCHK
lin ptyalism_N = mkWN (compoundN "syljen" (k1A "vuoto")) ; --UNCHK
lin ptyalith_N = mkWN (compoundN "sylki" (k7 "kivi")) ; --UNCHK
lin pub_N = mkN "pub" ;
lin pub_crawl_N = mkWN (compoundN "kapakka" (k39 "kierros")) ; --UNCHK
lin pubertal_A = mkWA (compoundA "puberta" (k38 "alinen")) ; --UNCHK
lin puberty_N = mkWN (k5A "puberteetti") ; --UNCHK
lin pubes_N = mkWN (compoundN "häpy" (k48 "alue")) ; --UNCHK
lin pubescent_A = mkWA (k38 "silkkinen") ; --UNCHK
lin pubic_A = mkWA "häpy-" ; --UNCHK
lin pubis_N = mkWN (compoundN "häpy" (k18 "luu")) ; --UNCHK
lin public_A = mkA "julkinen" ;
lin public_N = mkWN (k2 "yleisö") ;
lin publican_N = mkWN (k12 "kapakoitsija") ; --UNCHK
lin publication_N = mkN "julkaisu" ;
lin publicist_N = mkWN (k10 "toimittaja") ; --UNCHK
lin publicity_N = mkWN (k40 "julkisuus") ; --UNCHK
lin publicize_V2 = mkV2 "mainostaa" partitive ; --mkWV2 (k53 "päästää") "ilmoille" ;
lin publish_V = mkWV (k66 "julkaista") ;
lin publish_V2 = mkWV2 (k66 "julkaista") ;
lin publishable_A = mkWA (compoundA "julkaisu" (k38 "kelpoinen")) ; --UNCHK
lin publisher_N = mkN (lin NK {s = d10 "kustantaja"}) ;
lin publishing_A = mkA "julkaiseva" ;
lin publishing_N = variants {} ; --
lin puccoon_N = mkWN (k26 "verijuuri") ; --UNCHK
lin puce_N = mkWN (compoundN "punaisen" (k15 "ruskea")) ; --UNCHK
lin puck_N = mkWN (k10 "lätkä") ; --UNCHK
lin pucker_N = mkWN (k1A "kurttu") ; --UNCHK
lin pucker_V = mkWV (k53 "mutristaa") ; --UNCHK
lin pucker_V2 = mkWV2 (k53 "mutristaa") ; --UNCHK
lin puckish_A = mkWA (k10 "tuhma") ; --UNCHK
lin pud_N = mkWN (compoundN "jälki" (k10A "ruoka")) ; --UNCHK
lin pudasjärvi_PN = mkPN (mkN "Pudasjärvi" "Pudasjärviä") ;
lin pudding_N = mkWN (k41A "vanukas") ; --UNCHK
lin pudding_face_N = mkWN (compoundN "palli" (k9 "naama")) ; --UNCHK
lin puddingwife_N = mkWN "Halicoeres" "radiatus" ; --UNCHK
lin puddle_N = mkWN (k9 "sekamelska") ; --UNCHK
lin puddle_V2 = mkWV2 (k53A "heittää") "vettä" ; --UNCHK
lin puddler_N = mkWN (k5 "putlari") ; --UNCHK
lin pudendal_A = mkWA "häpy-" ; --UNCHK
lin pudendum_N = mkWN (compoundN "sukupuoli" (k33 "elin")) ; --UNCHK
lin pudge_N = mkWN (k2 "tyllerö") ; --UNCHK
lin pudgy_A = mkWA (k10 "pulska") ; --UNCHK
lin pudsey_PN = foreignPN "Pudsey" ;
lin pueblo_N = mkWN (compoundN "pueblo" (k10 "kylä")) ; --UNCHK
lin puerile_A = mkWA (k38 "lapsellinen") ; --UNCHK
lin puerility_N = mkWN (k40 "lapsellisuus") ; --UNCHK
lin puerperal_A = mkWA (k38 "jälkeinen") "synnytyksen" ; --UNCHK
lin puerperium_N = mkWN (k9A "lapsivuodeaika") ; --UNCHK
lin puff_A = mkWA "pussi-" ; --UNCHK
lin puff_N = mkWN (k7A "henki") ; --UNCHK
lin puff_V = mkWV (k53A "läähättää") ; --UNCHK
lin puff_V2 = mkWV2 (k53A "läähättää") ; --UNCHK
lin puffball_N = mkWN (k2 "tuhkelo") ; --UNCHK
lin puffbird_N = mkWN (compoundN "laiskuri" (k1A "lintu")) ; --UNCHK
lin puffer_N = mkWN (compoundN "pallo" (k9 "kala")) ; --UNCHK
lin puffery_N = mkWN (k1 "kehu") ; --UNCHK
lin puffin_N = mkWN (k5 "lunni") ; --UNCHK
lin puffiness_N = mkWN (k40 "pöyhkeys") ; --UNCHK
lin puffing_N = mkWN (compoundN "puh" (k38 "kuminen")) ; --UNCHK
lin puffy_A = mkWA (k38 "puuskittainen") ; --UNCHK
lin pug_N = mkWN (k5 "mopsi") ; --UNCHK
lin pug_nose_N = mkWN (compoundN "nykerö" (k10 "nenä")) ; --UNCHK
lin pug_nosed_A = mkA (mkN "nykerö" (mkN "nenäinen")) ;
lin pugilism_N = mkWN (k5 "pugilismi") ; --UNCHK
lin pugilist_N = mkWN (k5 "pugilisti") ; --UNCHK
lin pugilistic_A = mkWA (compoundA "pugilisti" (k38 "nen")) ; --UNCHK
lin pugnacious_A = mkWA (k10 "kova") ; --UNCHK
lin pugnacity_N = mkWN (k40 "sotaisuus") ; --UNCHK
lin puissance_N = mkWN (k9A "valta") ; --UNCHK
lin puissant_A = mkWA (k10 "väkevä") ; --UNCHK
lin puka_N = mkWN "Meryta" "sinclairii" ; --UNCHK
lin puke_N = mkWN (k3 "heittiö") ; --UNCHK
lin puke_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin puke_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin pukka_A = mkWA (k1A "aito") ; --UNCHK
lin pukkila_PN = mkPN "Pukkila" ;
lin puku_N = mkWN (k1A "puku") ; --UNCHK
lin pul_N = mkWN "pul" ; --UNCHK
lin pula_N = mkWN (k10 "pula") ; --UNCHK
lin pulasan_N = mkWN "pulasan" ; --UNCHK
lin pulchritude_N = mkWN (k40 "kauneus") ; --UNCHK
lin pulchritudinous_A = mkWA (k41 "kaunis") ; --UNCHK
lin pule_V = mkWV (k66 "vikistä") ; --UNCHK
lin pulkkila_PN = mkPN "Pulkkila" ;
lin pull_N = mkN "vetovoima" ; ---ARB ; nykäisy, kiskaisu, houkutin
lin pull_V = mkV "vetää" ;
lin pull_V2 = L.pull_V2 ;
lin pull_ahead_V = mkWV (k63 "saada") "jalansijaa" ; --UNCHK
lin pull_apart_V2 = mkV2 (advV OP_pull_V OP_apart_Adv ) ; -- guess-p-verb
lin pull_away_V = mkWV (k52A "etääntyä") ; --UNCHK
lin pull_back_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin pull_back_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin pull_down_V = mkWV (k53A "vetää") "maahan" ; --UNCHK
lin pull_down_V2 = mkWV2 (k53A "vetää") "maahan" ; --UNCHK
lin pull_for_V2 = prepV2 OP_pull_V OP_for_Prep ; -- guess-p-verb
lin pull_in_V = mkWV (k73 "kerätä") ; --UNCHK
lin pull_in_V2 = mkWV2 (k73 "kerätä") ; --UNCHK
lin pull_off_V = mkWV (k66 "kiskaista") ; --UNCHK
lin pull_off_V2 = mkWV2 (k66 "kiskaista") ; --UNCHK
lin pull_on_V2 = prepV2 OP_pull_V OP_on_Prep ; -- guess-p-verb
lin pull_out_V = mkWV (k53A "vetää") "ulos" ; --UNCHK
lin pull_out_V2 = mkWV2 (k53A "vetää") "ulos" ; --UNCHK
lin pull_over_V2 = mkWV2 (k52A "pysähtyä") ; --UNCHK
lin pull_through_V = mkWV (k56A "auttaa") ; --UNCHK
lin pull_to_V2 = prepV2 OP_pull_V OP_to_Prep ; -- guess-p-verb
lin pull_together_V = mkWV (k53 "yhdistää") ; --UNCHK
lin pull_up_V = mkWV (k53A "vetää") "ulos" ; --UNCHK
lin pull_up_V2 = mkWV2 (k53A "vetää") "ulos" ; --UNCHK
lin pull_yourself_together_V = variants {} ; -- guess-p-verb
lin pullback_N = mkWN "vetäytyminen" ; --UNCHK
lin puller_N = mkWN (k10 "kiskoja") ; --UNCHK
lin pullet_N = mkWN (k9 "kana") "nuori" ; --UNCHK
lin pulley_N = mkWN (k12 "pylpyrä") ; --UNCHK
lin pulley_block_N = mkWN (k12 "pylpyrä") ; --UNCHK
lin pullman_N = mkWN (compoundN "makuu" (k1 "vaunu")) ; --UNCHK
lin pullover_N = mkWN (k2 "pusero") ; --UNCHK
lin pullulate_V = mkWV (k52 "versoa") ; --UNCHK
lin pullulation_N = mkWN (k9A "versonta") ; --UNCHK
lin pulmonary_A = mkWA (compoundA "pulmona" (k38 "alinen")) ; --UNCHK
lin pulp_N = mkN "selluloosa" ;
lin pulp_V = mkWV (k56 "jauhaa") "massaksi" ; --UNCHK
lin pulp_V2 = mkWV2 (k56 "jauhaa") "massaksi" ; --UNCHK
lin pulpit_N = mkWN (k48A "koroke") ; --UNCHK
lin pulpwood_N = mkWN (compoundN "paperi" (k18 "puu")) ; --UNCHK
lin pulpy_A = mkWA (k15 "möyheä") ; --UNCHK
lin pulque_N = mkWN "pulque" ; --UNCHK
lin pulsar_N = mkWN (k6 "pulsari") ; --UNCHK
lin pulsate_V = mkWV (k67A "värähdellä") ; --UNCHK
lin pulsate_V2 = mkWV2 (k67A "värähdellä") ; --UNCHK
lin pulsation_N = mkWN (k48A "syke") ; --UNCHK
lin pulse_N = mkWN (k48A "syke") ; --UNCHK
lin pulse_V = mkWV (k67A "värähdellä") ; --UNCHK
lin pulverization_N = mkWN (compoundN "jauhe" (k38 "ntaminen")) ; --UNCHK
lin pulverize_V = mkWV (k54A "jauhentaa") ; --UNCHK
lin pulverize_V2 = mkWV2 (k54A "jauhentaa") ; --UNCHK
lin puma_N = mkWN (k10 "puuma") ; --UNCHK
lin pumice_N = mkWN (compoundN "hohka" (k7 "kivi")) ; --UNCHK
lin pumice_stone_N = mkWN (compoundN "hohka" (k7 "kivi")) ; --UNCHK
lin pummel_V2 = mkWV2 (k73A "hakata") ; --UNCHK
lin pump_N = mkWN (k1A "pumppu") ; --UNCHK
lin pump_V = mkWV (k54 "lypsää") ; --UNCHK
lin pump_V2 = mkV2 "pumpata" partitive ; --WV2 (k54 "lypsää") ;
lin pump_room_N = mkWN (compoundN "kaivo" (k48 "huone")) ; --UNCHK
lin pumpernickel_N = mkWN (compoundN "ruis" (k10A "leipä")) ; --UNCHK
lin pumpkin_N = mkWN (k13 "kurpitsa") ; --UNCHK
lin pumpkinseed_N = mkWN (compoundN "aurinko" (k32 "ahven")) ; --UNCHK
lin pun_N = mkWN (k39 "sutkaus") ; --UNCHK
lin pun_V = mkWV (compoundV "sutk" (k67A "autella")) ; --UNCHK
lin punch_N = mkWN (k5 "tälli") ; --UNCHK
lin punch_V2 = mkWV2 (k64 "lyödä") "nyrkillä" ; --UNCHK
lin punchball_N = mkWN (compoundN "nyrkkeily" (k5A "säkki")) ; --UNCHK
lin punchboard_N = mkWN (compoundN "arpa" (k5 "peli")) ; --UNCHK
lin puncher_N = mkWN (k10 "tuurna") ; --UNCHK
lin punching_ball_N = mkWN (compoundN "nyrkkeily" (k5A "säkki")) ; --UNCHK
lin punctilio_N = mkWN (k40 "muodollisuus") ; --UNCHK
lin punctilious_A = mkWA (k38 "huolellinen") ; --UNCHK
lin punctiliousness_N = mkWN (k40 "perusteellisuus") ; --UNCHK
lin punctual_A = mkWA (k99 "ajoissa") ; --UNCHK
lin punctuality_N = mkWN (k40 "säntillisyys") ; --UNCHK
lin punctuate_V2 = mkWV2 (k53A "pilkuttaa") ; --UNCHK
lin punctuation_N = mkWN (k39 "pilkutus") ; --UNCHK
lin punctum_N = mkWN (k48 "piste") ; --UNCHK
lin puncturable_A = mkWA "puhkaistava" ; --UNCHK
lin puncture_N = mkWN (k2 "puhkaisu") ; --UNCHK
lin puncture_V = mkWV (k74A "puhjeta") ; --UNCHK
lin puncture_V2 = mkWV2 (k74A "puhjeta") ; --UNCHK
lin punctureless_A = mkWA "reiätön" ; --UNCHK
lin pundit_N = mkN "asian" (mkN "tuntija") ;
lin pung_N = mkWN (k7A "reki") ; --UNCHK
lin pungapung_N = mkWN "Amorphophallus" "campanulatus" ; --UNCHK
lin pungency_N = mkWN (k40 "kirpeys") ; --UNCHK
lin pungent_A = mkWA (k10 "naseva") ; --UNCHK
lin punic_A = mkWA (k38 "puunilainen") ; --UNCHK
lin puniness_N = mkWN (k40 "mitättömyys") ; --UNCHK
lin punish_V2 = mkWV2 (k54A "ojentaa") ; --UNCHK
lin punishable_A = mkWA (k10 "rangaistava") ;
lin punishing_A = mkWA "rankaiseva" ; --UNCHK
lin punishment_N = mkWN (k39 "rangaistus") ; --UNCHK
lin punitive_A = mkWA "rangaistus-" ; --UNCHK
lin punk_N = mkWN (k5 "punk") ; --UNCHK
lin punkah_N = mkWN "punkah" ; --UNCHK
lin punkaharju_PN = mkPN "Punkaharju" ;
lin punkalaidun_PN = mkPN "Punkalaidun" ;
lin punkie_N = mkWN (k38 "polttiainen") ; --UNCHK
lin punnet_N = mkWN (k38 "tuokkonen") ; --UNCHK
lin punster_N = mkWN "sanailija" ; --UNCHK
lin punt_N = mkN "joki" (mkN "vene") ; ---ARB separateN "Irlannin" (mkN "punta") --mkWN (compoundN "lento" (k2 "potkaisu")) ;
lin punt_V = mkWV (k73 "riskeerata") ; --UNCHK
lin punt_V2 = mkWV2 (k73 "riskeerata") ; --UNCHK
lin punter_N = mkWN (k10 "pelaaja") ; --UNCHK
lin puny_A = mkWA (k34A "mitätön") ; --UNCHK
lin puolanka_PN = mkPN "Puolanka" ;
lin pup_N = mkWN (k14A "penikka") ; --UNCHK
lin pupa_N = mkWN (k2 "kotelo") ; --UNCHK
lin pupal_A = mkWA (compoundA "koti" (k38 "loasteinen")) ; --UNCHK
lin pupil_N = mkN "oppilas" | mkWN (k5 "pupilli") ; ---- split
lin pupillary_A = mkWA "pupillaarinen" ; --UNCHK
lin puppet_N = mkWN (compoundN "käsi" (k8A "nukke")) ; --UNCHK
lin puppeteer_N = mkWN (k10 "esittäjä") "nukketeatterin" ; --UNCHK
lin puppetry_N = mkWN (compoundN "nukke-" (k39 "esitys")) ; --UNCHK
lin puppy_N = mkWN (k14A "penikka") ; --UNCHK
lin puppyish_A = mkWA (k38 "pentumainen") ; --UNCHK
lin purblind_A = mkWA (k10 "tylsä") ; --UNCHK
lin purchasable_A = mkWA (k10 "oleva") "myynnissä" ; --UNCHK
lin purchase_N = mkWN (k1 "osto") ; --f272
lin purchase_V2 = mkWV2 (k53 "ostaa") ; --f177
lin purchaser_N = mkWN (k10 "ostaja") ; --UNCHK
lin purdah_N = mkWN "purdah" ; --UNCHK
lin pure_A = mkWA (k38 "intensiivinen") ; --UNCHK
lin purebred_A = mkWA (compoundA "puhdas" (k38 "rotuinen")) ; --UNCHK
lin puree_N = mkWN (k48 "sose") ; --UNCHK
lin pureness_N = mkWN (k40 "koskemattomuus") ; --UNCHK
lin purgation_N = mkWN (k39 "puhdistus") ; --UNCHK
lin purgative_A = mkWA (k10 "aikaansaava") "ulostuksen" ; --UNCHK
lin purgative_N = mkWN (k5 "laksatiivi") ; --UNCHK
lin purgatorial_A = mkWA "puhdistava" ; --UNCHK
lin purgatory_N = mkWN (compoundN "kiiras" (k23 "tuli")) ; --UNCHK
lin purge_N = mkWN (k39 "puhdistus") ; --UNCHK
lin purge_V2 = mkWV2 (k54A "tyhjentää") "suoli" ; --UNCHK
lin purification_N = mkWN (k39 "puhdistus") ; --UNCHK
lin purifier_N = mkWN (compoundN "puhdistus" (k48 "väline")) ; --UNCHK
lin purify_V2 = mkWV2 (k62 "sublimoida") ; --UNCHK
lin purifying_A = mkWA "puhdistava" ; --UNCHK
lin purine_N = mkWN "puriini" ; --UNCHK
lin purism_N = mkWN (k5 "purismi") ; --UNCHK
lin purist_N = mkWN (k5 "puristi") ; --UNCHK
lin puritan_N = mkWN (k5 "puritaani") ; --UNCHK
lin puritanical_A = mkWA (k38 "puritaaninen") ; --UNCHK
lin puritanism_N = mkWN (k5 "puritanismi") ; --UNCHK
lin purity_N = mkWN (k40 "koskemattomuus") ; --UNCHK
lin purl_N = mkWN (k14A "silmukka") "nurja" ; --UNCHK
lin purl_V = mkWV (k66 "kohista") ; --UNCHK
lin purl_V2 = mkWV2 (k66 "kohista") ; --UNCHK
lin purloin_V2 = mkWV2 (k67 "näpistellä") ; --UNCHK
lin purloo_N = mkWN (compoundN "kana" (k39 "muhennos")) ; --UNCHK
lin purple_A = mkWA (k12 "purppura") ; --UNCHK
lin purple_N = mkWN (k5A "violetti") ; --UNCHK
lin purplish_A = mkWA (k12 "purppura") ; --UNCHK
lin purport_N = mkWN (k39 "tarkoitus") ; --UNCHK
lin purport_V2 = mkWV2 (k53A "tarkoittaa") ; --UNCHK
lin purport_V2V = mkWV2V (k53A "tarkoittaa") ; --UNCHK
lin purportedly_Adv = mkWAdv (k99 "muka") ; --UNCHK
lin purpose_N = mkN "tarkoitus" ;
lin purpose_V2 = mkWV2 (k53A "päättää") ; --UNCHK
lin purposeful_A = mkWA (k38 "tarkoituksellinen") ; --UNCHK
lin purposefulness_N = mkWN (k1 "taju") "merkityksen" ; --UNCHK
lin purposeless_A = mkWA (k34A "tarkoitukseton") ; --UNCHK
lin purposelessness_N = mkWN (k40 "tarpeettomuus") ; --UNCHK
lin purposely_Adv = mkWAdv (k99 "vasten") "varta" ; --UNCHK
lin purposive_A = mkWA (k38 "päättäväinen") ; --UNCHK
lin purpura_N = mkWN "peliosis" ; --UNCHK
lin purr_N = mkWN (k39 "kehräys") ; --UNCHK
lin purr_V = mkWV (k73 "hyrrätä") ; --UNCHK
lin purr_V2 = mkWV2 (k73 "hyrrätä") ; --UNCHK
lin purr_VS = mkWVS (k73 "hyrrätä") ; --UNCHK
lin purse_N = mkWN (k2 "kukkaro") ;
lin purse_V2 = mkWV2 (k53 "suipistaa") ; --UNCHK
lin purser_N = mkWN (k6 "purseri") ; --UNCHK
lin purslane_N = mkWN (compoundN "portul" (k9A "akka")) ; --UNCHK
lin pursuance_N = mkWN "tavoitteleminen" ; --UNCHK
lin pursuant_A = mkWA (k99 "mukaan") ; --UNCHK
lin pursuant_to_Prep = mkPrep illative "tähdäten" ;
lin pursue_V = mkWV (k67A "tavoitella") ; --UNCHK
lin pursue_V2 = mkV2 (mkV "tavoitella") partitive ;
lin pursued_N = mkWN (compoundN "taka" (k1 "a-ajettu")) ; --UNCHK
lin pursuer_N = mkWN (compoundN "takaa-" (k10 "ajaja")) ; --UNCHK
lin pursuit_N = mkWN (kH1 "jahti") ; --UNCHK
lin pursy_A = mkWA (compoundA "huoh" (k10 "ottava")) ; --UNCHK
lin purulence_N = mkWN (k9 "visva") ; --UNCHK
lin purulent_A = mkWA (k38 "märkäinen") ; --UNCHK
lin purvey_V = mkWV (k74 "tarjota") ; --UNCHK
lin purvey_V2 = mkWV2 (k74 "tarjota") ; --UNCHK
lin purveyance_N = mkWN (k9A "hankinta") ; --UNCHK
lin purveyor_N = mkWN (k12 "hankkija") ; --UNCHK
lin purview_N = mkWN (k10 "näkymä") ; --UNCHK
lin pus_N = mkWN (k9 "visva") ; --UNCHK
lin push_N = mkWN (k2 "tönäisy") ; --UNCHK
lin push_V = mkV "työntää" ;
lin push_V2 = L.push_V2 ;
lin push_V2V = mkWV2V (k53 "patistaa") ;
lin push_VS = mkWVS (k53 "patistaa") ;
lin push_ahead_V = advV OP_push_V OP_ahead_Adv ; -- guess-p-verb
lin push_around_V = mkWV (k67A "komennella") ; --UNCHK
lin push_back_V = mkWV (k53A "tukahduttaa") ; --UNCHK
lin push_in_V2 = prepV2 OP_push_V OP_in_Prep ; -- guess-p-verb
lin push_through_V = mkWV (k74A "puhjeta") ; --UNCHK
lin push_up_V = mkWV (k54A "työntää") "ylös" ; --UNCHK
lin push_up_V2 = prepV2 OP_push_V OP_up_Prep ; -- guess-p-verb
lin pushball_N = mkWN (compoundN "työntö" (k1 "pallo")) ; --UNCHK
lin pushcart_N = mkWN (k1 "vaunu") ; --UNCHK
lin pusher_N = mkN "pyrkyri" ;
lin pushful_A = mkWA (k10 "tunkeileva") ; --UNCHK
lin pushover_N = mkN "läpihuuto" (mkN "juttu") ;
lin pushup_N = mkWN (k39 "punnerrus") ; --UNCHK
lin pusillanimity_N = mkWN (k40 "pelokkuus") ; --UNCHK
lin pusillanimous_A = mkWA (k38 "pelkurimainen") ; --UNCHK
lin puss_N = mkWN (k1 "kisu") ; --UNCHK
lin pussy_N = mkWN (k1 "kisu") ; --UNCHK
lin pussycat_N = mkWN (k1 "kisu") ; --UNCHK
lin pussyfoot_V = mkWV (k67A "hipsutella") ; --UNCHK
lin pustule_N = mkWN (k12 "pustula") ; --UNCHK
lin put_N = mkWN (compoundN "myynti" (k3 "optio")) ;
lin put_V2 = L.put_V2 ;
lin put_across_V = mkWV (k66 "ilmaista") ; --UNCHK
lin put_across_V2 = mkWV2 (k66 "ilmaista") ; --UNCHK
lin put_aside_V = advV (lin V OP_put_V2) OP_aside_Adv ; -- guess-p-verb
lin put_away_V = advV (lin V OP_put_V2) OP_away_Adv ; -- guess-p-verb
lin put_away_V2 = mkV2 (advV (lin V OP_put_V2) OP_away_Adv ) ; -- guess-p-verb
lin put_back_V2 = mkWV2 (k53A "asettaa") "takaisin" ; --UNCHK
lin put_by_V2 = prepV2 (lin V OP_put_V2) OP_by_Prep ; -- guess-p-verb
lin put_down_V = mkWV (k69 "merkitä") ; --UNCHK
lin put_down_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin put_down_for_V3 = variants {} ; -- guess-p-verb
lin put_down_to_V3 = variants {} ; -- guess-p-verb
lin put_forth_V = advV (lin V OP_put_V2) OP_forth_Adv ; -- guess-p-verb
lin put_in_V = mkWV (k56A "laittaa") "käyttökuntoon" ; --UNCHK
lin put_in_V2 = mkWV2 (k56A "laittaa") "käyttökuntoon" ; --UNCHK
lin put_in_for_V2 = prepV2 (advV (lin V OP_put_V2) OP_in_Adv ) OP_for_Prep ; -- guess-p-verb
lin put_off_V = mkWV (k67A "luikerrella") ; --UNCHK
lin put_off_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin put_on_V = mkWV (k52 "lihoa") ; --UNCHK
lin put_on_V2 = mkWV2 (k52 "lihoa") ; --UNCHK
lin put_out_V = mkWV (k53A "puuduttaa") ; --UNCHK
lin put_out_V2 = mkWV2 (k53A "puuduttaa") ; --UNCHK
lin put_over_V2 = mkWV2 (k66 "ilmaista") "selkeästi" ; --UNCHK
lin put_through_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin put_together_V2 = mkWV2 (k61 "kursia") ; --UNCHK
lin put_towards_V2 = prepV2 (lin V OP_put_V2) OP_towards_Prep ; -- guess-p-verb
lin put_up_V = mkWV (k53A "purkittaa") ; --UNCHK
lin put_up_V2 = mkWV2 (k53A "purkittaa") ; --UNCHK
lin put_up_V2V = mkWV2V (k53A "purkittaa") ; --UNCHK
lin put_up_with_V2 = mkV2 "sietää" partitive ;
lin put_upon_V = variants {} ; -- guess-p-verb
lin putamen_N = mkWN (compoundN "aivo" (k14A "kuorukka")) ; --UNCHK
lin putative_A = mkWA "putatiivinen" ; --UNCHK
lin putdownable_A = mkWA (compoundA "epä" (k10 "kiinnostava")) ; --UNCHK
lin putoff_N = mkWN (k39 "viivytys") ; --UNCHK
lin putout_N = mkWN (k1A "poltto") ; --UNCHK
lin putrefaction_N = mkWN (k39 "turmelus") ; --UNCHK
lin putrefactive_A = mkWA "mädättävä" ; --UNCHK
lin putrefy_V = mkWV (k72A "mädätä") ; --UNCHK
lin putrefy_V2 = mkWV2 (k72A "mädätä") ; --UNCHK
lin putrescence_N = mkWN "mädäntyvyys" ; --UNCHK
lin putrescent_A = mkWA (compoundA "mätän" (k10 "evä")) ; --UNCHK
lin putrescine_N = mkWN "putreskiini" ; --UNCHK
lin putridity_N = mkWN (compoundN "mätä" (k40 "isyys")) ; --UNCHK
lin putsch_N = mkWN (compoundN "vallan" (k39 "kaappaus")) ; --UNCHK
lin putt_N = mkWN (k5A "putti") ; --UNCHK
lin putt_V = mkV (lin VK {s = c73A "putata"}) ;
lin putt_V2 = mkWV2 (k73A "putata") ;
lin puttee_N = mkWN (k33 "säärystin") ; --UNCHK
lin putter_N = mkWN (compoundN "puttaus" (k9 "maila")) ; --UNCHK
lin putter_V = mkWV (k67 "puuhailla") ; --UNCHK
lin putter_V2 = mkWV2 (k67 "puuhailla") ; --UNCHK
lin putterer_N = mkWN (k12 "puuhailija") ; --UNCHK
lin putting_green_N = mkWN (k3 "viheriö") ; --UNCHK
lin putting_iron_N = mkWN (compoundN "puttaus" (k9 "maila")) ; --UNCHK
lin putty_N = mkWN (k48A "silote") ; --UNCHK
lin putty_V2 = mkWV2 (k73A "kitata") ; --UNCHK
lin puttyroot_N = mkWN (k8 "hyemale") "Aplectrum" ; --UNCHK
lin putz_N = mkWN (k10 "muna") ; --UNCHK
lin puumala_PN = mkPN "Puumala" ;
lin puzzle_N = mkWN (k12 "pähkinä") ; --UNCHK
lin puzzle_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin puzzlement_N = mkWN (k1 "olo") "ymmällään" ; --UNCHK
lin puzzler_N = mkWN (k12 "pähkinä") ; --UNCHK
lin pwllheli_PN = foreignPN "Pwllheli" ;
lin pya_N = mkWN "pya" ; --UNCHK
lin pycnidium_N = mkWN "pycnidium" ; --UNCHK
lin pycnodysostosis_N = mkWN "pyknodysostoosi" ; --UNCHK
lin pycnosis_N = mkWN "puknoosi" ; --UNCHK
lin pyelitis_N = mkWN (compoundN "munuaisallas" (k39 "tulehdus")) ; --UNCHK
lin pyelogram_N = mkWN "pyelogrammi" ; --UNCHK
lin pyelography_N = mkWN "pyelografia" ; --UNCHK
lin pyelonephritis_N = mkWN (compoundN "pyelonef" (k5A "riitti")) ; --UNCHK
lin pyemia_N = mkWN (compoundN "märkä" (k40 "verisyys")) ; --UNCHK
lin pyemic_A = mkWA "pyeminen" ; --UNCHK
lin pygmy_N = mkWN "Pygmi" ; --UNCHK
lin pyhtää_PN = mkPN "Pyhtää" ;
lin pyhäjoki_PN = mkPN (mkN "Pyhäjoki" "Pyhäjokia") ;
lin pyhäjärvi_PN = mkPN (mkN "Pyhäjärvi" "Pyhäjärviä") ;
lin pyhäntä_PN = mkPN "Pyhäntä" ;
lin pyhäranta_PN = mkPN "Pyhäranta" ;
lin pyhäsalmi_PN = mkPN (mkN "Pyhäsalmi" "Pyhäsalmia") ;
lin pyhäselkä_PN = mkPN "Pyhäselkä" ;
lin pyinma_N = mkWN "pyinma" ; --UNCHK
lin pyknotic_A = mkWA "pyknoottinen" ; --UNCHK
lin pyle_PN = foreignPN "Pyle" ;
lin pylkönmäki_PN = mkPN (mkN "Pylkönmäki" "Pylkönmäkiä") ;
lin pylon_N = mkWN (compoundN "sähkö" (k10A "tolppa")) ; --UNCHK
lin pyloric_A = mkWA "mahanportti-" ; --UNCHK
lin pylorus_N = mkWN (compoundN "mahan" (k5A "portti")) ; --UNCHK
lin pyocyanase_N = mkWN (compoundN "pyocyan" (k48 "ase")) ; --UNCHK
lin pyocyanin_N = mkWN (compoundN "prosya" (k26 "niini")) ; --UNCHK
lin pyogenic_A = mkWA "pyogeeninen" ; --UNCHK
lin pyongyang_PN = foreignPN "Pjongjang" ;
lin pyorrhea_N = mkWN (k5A "tauti") "Riggsin" ; --UNCHK
lin pyorrhoea_N = mkWN (k5A "tauti") "Riggsin" ; --UNCHK
lin pyralid_N = mkWN (k10 "koisa") ; --UNCHK
lin pyramid_N = mkWN (k5 "pyramidi") "suuri" ; --UNCHK
lin pyramidal_A = mkWA (k38 "muotoinen") "pyramidin" ; --UNCHK
lin pyramidically_Adv = mkWAdv "pyramidimaisesti" ; --UNCHK
lin pyramiding_N = mkWN "pyramidointi" ; --UNCHK
lin pyre_N = mkWN (k3 "rovio") ; --UNCHK
lin pyrectic_A = mkWA (compoundA "pyr" (k38 "eettinen")) ; --UNCHK
lin pyrene_N = mkWN (k32 "siemen") ; --UNCHK
lin pyrethrum_N = mkWN (compoundN "Pyrethrum-" (k1A "suku")) ; --UNCHK
lin pyretic_A = mkWA (compoundA "pyr" (k38 "eettinen")) ; --UNCHK
lin pyridine_N = mkWN "pyridiini" ; --UNCHK
lin pyrilamine_N = mkWN "pyrilamiini" ; --UNCHK
lin pyrimidine_N = mkWN "pyrimidiini" ; --UNCHK
lin pyrite_N = mkWN (k5A "pyriitti") ; --UNCHK
lin pyrocellulose_N = mkWN (compoundN "pyro" (k10 "selluloosa")) ; --UNCHK
lin pyrochemical_A = mkWA (compoundA "pyro" (k38 "kemiallinen")) ; --UNCHK
lin pyroelectric_A = mkWA (compoundA "pyro" (k38 "sähköinen")) ; --UNCHK
lin pyroelectricity_N = mkWN (compoundN "pyrosähkö" (k40 "isyys")) ; --UNCHK
lin pyrogallic_A = mkWA "pyrogallinen" ; --UNCHK
lin pyrogallol_N = mkWN (compoundN "pyrogallus" (k1A "happo")) ; --UNCHK
lin pyrogen_N = mkWN (compoundN "pyro" (k5 "geeni")) ; --UNCHK
lin pyrogenic_A = mkWA "pyrogeeninen" ; --UNCHK
lin pyrograph_N = mkWN (compoundN "poltto" (k39 "piirustus")) ; --UNCHK
lin pyrographer_N = mkWN (compoundN "poltto" (k10 "piirtäjä")) ; --UNCHK
lin pyrographic_A = mkWA "polttopiirustus-" ; --UNCHK
lin pyrography_N = mkWN (compoundN "poltto" (k39 "piirustus")) ; --UNCHK
lin pyrolatry_N = mkWN (compoundN "tulen" (k9A "palvonta")) ; --UNCHK
lin pyroligneous_A = mkWA "poltto-" ; --UNCHK
lin pyrolusite_N = mkWN "pyrolusiitti" ; --UNCHK
lin pyrolysis_N = mkWN (compoundN "pyroly" (k5 "ysi")) ; --UNCHK
lin pyrolytic_A = mkWA "pyrolyyttinen" ; --UNCHK
lin pyromancer_N = mkWN "pyromantikko" ; --UNCHK
lin pyromancy_N = mkWN "pyromantia" ; --UNCHK
lin pyromania_N = mkWN (k12 "pyromania") ; --UNCHK
lin pyromaniac_N = mkWN (k5 "pyromaani") ; --UNCHK
lin pyrometer_N = mkWN (compoundN "pyro" (k5 "metri")) ; --UNCHK
lin pyromorphite_N = mkWN "pyromorfiitti" ; --UNCHK
lin pyrope_N = mkWN (compoundN "pyro" (k5A "oppi")) ; --UNCHK
lin pyrophobia_N = mkWN (compoundN "pyro" (k12 "fobia")) ; --UNCHK
lin pyrophosphate_N = mkWN (compoundN "pyro" (k5A "fosfaatti")) ; --UNCHK
lin pyrophyllite_N = mkWN "pyrofylliitti" ; --UNCHK
lin pyrostat_N = mkWN "pyrostaatti" ; --UNCHK
lin pyrotechnic_A = mkWA (compoundA "pyro" (k38 "tekninen")) ; --UNCHK
lin pyrotechnics_N = mkWN (compoundN "pyro" (k14A "tekniikka")) ; --UNCHK
lin pyroxene_N = mkWN "pyrokseeni" ; --UNCHK
lin pyroxylin_N = mkWN "pyroksyliini" ; --UNCHK
lin pyrrhic_A = mkWA "pyrrhinen" ; --UNCHK
lin pyrrhic_N = mkWN (compoundN "sota" (k5 "tanssi")) ; --UNCHK
lin pyrrhotite_N = mkWN (compoundN "magneetti" (k1 "kiisu")) ; --UNCHK
lin pyrrhuloxia_N = mkWN (compoundN "veri" (k5 "kardinaali")) ; --UNCHK
lin pythium_N = mkWN (compoundN "pythium-" (k26 "sieni")) ; --UNCHK
lin python_N = mkWN (compoundN "pyton" (k48 "käärme")) ; --UNCHK
lin pythoness_N = mkWN "Pythia" ; --UNCHK
lin pyuria_N = mkWN "pyuria" ; --UNCHK
lin pyx_N = mkWN (compoundN "öylätti" (k12 "rasia")) ; --UNCHK
lin pyxidium_N = mkWN (k10A "kota") "kansiluomainen" ; --UNCHK
lin pyxie_N = mkWN (compoundN "barbu" (k9A "lata")) "Pyxidanthera" ; --UNCHK
lin pyxis_N = mkWN (compoundN "lääke" (k12 "rasia")) ; --UNCHK
lin pälkäne_PN = mkPN "Pälkäne" ;
lin pöytyä_PN = mkPN "Pöytyä" ;
lin qadi_N = mkWN "qadi" ; --UNCHK
lin qatar_PN = foreignPN "Qatar" ;
lin qatari_A = mkWA (compoundA "qatari" (k38 "lainen")) ; --UNCHK
lin qatari_N = mkWN (compoundN "qatari" (k38 "lainen")) ; --UNCHK
lin qepiq_N = mkWN "qepiq" ; --UNCHK
lin qi_N = mkWN "ki" ; --UNCHK
lin qibla_N = mkWN "Qibla" ; --UNCHK
lin qindarka_N = mkWN (compoundN "qind" (k9A "arka")) ; --UNCHK
lin qoph_N = mkWN "qof" ; --UNCHK
lin qua_Prep = mkPrep elative | mkPrep "qua" nominative ;
lin quack_Interj = mkInterj "kvaak" ;
lin quack_N = mkWN (k39 "kaakatus") ; --UNCHK
lin quack_V = mkWV (k62 "puoskaroida") ; --UNCHK
lin quackery_N = mkWN (k5 "empirismi") ; --UNCHK
lin quad_N = mkWN (compoundN "sisä" (k9 "piha")) ; --UNCHK
lin quadrangle_N = mkWN (compoundN "sisä" (k9 "piha")) ; --UNCHK
lin quadrangular_A = mkWA "nelikulmio-" ; --UNCHK
lin quadrant_N = mkWN "kvadrantti" ; --UNCHK
lin quadrantanopia_N = mkWN (compoundN "neljännesnäkökenttä" (k40 "sokeus")) ; --UNCHK
lin quadraphonic_A = mkWA (k38 "nelikanavainen") ; --UNCHK
lin quadraphony_N = mkWN (k12 "kvadrofonia") ; --UNCHK
lin quadrate_A = mkWA (compoundA "nelikul" (k38 "mainen")) ; --UNCHK
lin quadrate_N = mkWN "nelikulmio" ; --UNCHK
lin quadratic_A = mkWA "kvadraattinen" ; --UNCHK
lin quadratic_N = mkWN (k5 "polynomi") "toisen" "asteen" ; --UNCHK
lin quadrature_N = mkWN (compoundN "kvadra" (k5 "tuuri")) ; --UNCHK
lin quadrennium_N = mkWN (compoundN "nelivuotis" (k27 "kausi")) ; --UNCHK
lin quadric_N = mkWN (k9A "pinta") "toisen" "asteen" ; --UNCHK
lin quadriceps_N = mkWN (compoundN "reisi" (k39 "lihas")) ; --UNCHK
lin quadrilateral_A = mkWA (compoundA "neli" (k38 "tahoinen")) ; --UNCHK
lin quadrilateral_N = mkWN "nelikulmio" ; --UNCHK
lin quadrille_N = mkWN (k5 "katrilli") ; --UNCHK
lin quadrillion_N = mkWN (k10 "kvadriljoona") ; --UNCHK
lin quadrillionth_A = mkWA "kvadriljoonas" ; --UNCHK
lin quadripara_N = mkWN (k10 "synnyttäjä") "neljäskertainen" ; --UNCHK
lin quadripartite_A = mkWA (compoundA "neli" (k38 "osainen")) ; --UNCHK
lin quadriplegia_N = mkWN (compoundN "neliraaja" (k39 "halvaus")) ; --UNCHK
lin quadrivium_N = mkWN "quadrivium" ; --UNCHK
lin quadroon_N = mkWN "kvarteroni" ; --UNCHK
lin quadrumvirate_N = mkWN (k1A "joukko") "neljän" "miehen" ; --UNCHK
lin quadruped_N = mkWN (compoundN "neli" (k38 "jalkainen")) ; --UNCHK
lin quadrupedal_A = mkWA (compoundA "neli" (k38 "jalkainen")) ; --UNCHK
lin quadruple_A = mkWA (compoundA "neli" (k38 "nkertainen")) ; --UNCHK
lin quadruple_N = mkWN (k10 "määrä") "nelinkertainen" ; --UNCHK
lin quadruple_V = mkWV (k52 "nelinkertaistua") ; --UNCHK
lin quadruple_V2 = mkWV2 (k52 "nelinkertaistua") ; --UNCHK
lin quadruplet_N = mkWN (k4A "nelikkö") ; --UNCHK
lin quadruplicate_A = mkWA (compoundA "neli" (k38 "nkertainen")) ; --UNCHK
lin quadruplicate_N = mkWN "neljänä" "kappaleena" ; --UNCHK
lin quadruplicate_V2 = mkWV2 (k53 "nelinkertaistaa") ; --UNCHK
lin quadrupling_N = mkWN "nelinkertaistus" ; --UNCHK
lin quaff_N = mkWN (k1A "ryyppy") ; --UNCHK
lin quaff_V = mkWV (k73A "hörpätä") ; --UNCHK
lin quaff_V2 = mkWV2 (k73A "hörpätä") ; --UNCHK
lin quaffer_N = mkWN "ryyppääjä" ; --UNCHK
lin quagga_N = mkWN "Equus" "quagga" ; --UNCHK
lin quagmire_N = mkWN (k1A "letto") ; --UNCHK
lin quahaug_N = mkWN (compoundN "kauppavenus" (k14A "simpukka")) ; --UNCHK
lin quai_d'orsay_N = mkWN (compoundN "ulko" (k3 "ministeriö")) "Ranskan" ; --UNCHK
lin quail_N = mkWN (k38 "viiriäinen") ; --UNCHK
lin quail_V = mkWV (k53A "säpsähtää") ; --UNCHK
lin quaint_A = mkWA (k10 "viehättävä") ; --UNCHK
lin quaintness_N = mkWN "omalaatuisuus" ; --UNCHK
lin quake_N = mkWN (compoundN "maan" (k39 "järistys")) ; --f106
lin quake_V = mkWV (k67A "värähdellä") ; --UNCHK
lin quaker_N = mkWN (k6 "kveekari") ; --UNCHK
lin qualification_N = mkWN (compoundN "muu" (k38 "ttaminen")) ; --UNCHK
lin qualified_A = variants {} ; --
lin qualifier_N = mkWN (k48A "määrite") ; --UNCHK
lin qualify_V = mkWV (k53A "määrittää") ; --UNCHK
lin qualify_V2 = mkWV2 (k53A "määrittää") ; --UNCHK
lin qualitative_A = mkWA (k38 "laadullinen") ; --UNCHK
lin quality_A = mkWA "hienosto-" ; --UNCHK
lin quality_N = mkN "laatu" ;
lin qualm_N = mkWN (k48A "tunne") "epävarmuuden" ; --UNCHK
lin quandary_N = mkWN (k10 "pulma") ; --UNCHK
lin quandong_N = mkWN (compoundN "villi" (k14A "persikka")) ; --UNCHK
lin quango_N = mkWN (k12 "komitea") ; --UNCHK
lin quantal_A = mkWA (compoundA "kvanta" (k38 "alinen")) ; --UNCHK
lin quantic_N = mkWN (k1A "muoto") ; --UNCHK
lin quantifiability_N = mkWN "mitattavuus" ; --UNCHK
lin quantifiable_A = mkWA "laskettava" ; --UNCHK
lin quantification_N = mkWN "kvantifikaatio" ; --UNCHK
lin quantify_V2 = mkWV2 (k73A "mitata") ; --UNCHK
lin quantitative_A = mkA "kvantitatiivinen" ;
lin quantity_N = mkWN (k10 "summa") ; --UNCHK
lin quantum_N = mkWN (k5A "kvantti") ; --UNCHK
lin quarantine_N = mkWN (k5 "karanteeni") ; --UNCHK
lin quark_N = mkWN (k9 "rahka") ; --UNCHK
lin quarrel_N = mkWN (k26 "nuoli") "tylppä" ; --UNCHK
lin quarrel_V = mkWV (k67A "väitellä") ; --UNCHK
lin quarreler_N = mkWN (k12 "riitelijä") ; --UNCHK
lin quarrelsome_A = mkWA (k10 "riitaisa") ; --UNCHK
lin quarrelsomeness_N = mkWN "riidanhaluisuus" ; --UNCHK
lin quarry_N = mkWN (k41 "saalis") ; --UNCHK
lin quarry_V = mkWV (k61 "louhia") ; --UNCHK
lin quarry_V2 = mkWV2 (k61 "louhia") ; --UNCHK
lin quarrying_N = mkWN "louhiminen" ; --UNCHK
lin quarryman_N = mkWN (compoundN "louhos" (k42 "mies")) ; --UNCHK
lin quart_N = mkWN (compoundN "neljännes" (k10 "gallona")) ; --UNCHK
lin quartan_A = mkWA (compoundA "neljä" (k38 "späiväinen")) ; --UNCHK
lin quartan_N = mkWN (compoundN "kvartaana" (k48 "kuume")) ; --UNCHK
lin quarter_N = mkN "neljännes" | mkN "neljäs" (mkN "osa") | mkN "vartti" ;
lin quarter_day_N = mkWN (compoundN "palkka" (k10 "päivä")) "neljännesvuosittainen" ; --UNCHK
lin quarter_plate_N = mkWN (compoundN "neljännes" (k1 "levy")) ; --UNCHK
lin quarterback_N = mkWN (compoundN "pelin" (k10 "rakentaja")) ; --UNCHK
lin quarter_deck_N = mkWN (compoundN "puoli" (k28 "kansi")) ; --UNCHK
lin quarterfinal_N = mkWN (compoundN "puoliväli" (k10 "erä")) ; --UNCHK
lin quarterlight_N = mkWN (compoundN "pikku" (k12 "ikkuna")) ; --UNCHK
lin quarterly_A = mkWA (compoundA "neljännes" (k38 "vuosittainen")) ;
lin quarterly_Adv = mkWAdv (k99 "vuosineljänneksittäin") ; --UNCHK
lin quarterly_N = mkWN "neljännesvuosijulkaisu" ;
lin quartermaster_N = mkWN (compoundN "huolto" (k4A "päällikkö")) ; --UNCHK
lin quartermaster_general_N = mkWN (compoundN "päämajoitus" (k6 "mestari")) ; --UNCHK
lin quarterstaff_N = mkWN (compoundN "taistelu" (k9 "sauva")) ; --UNCHK
lin quartet_N = mkWN (k1A "kvartetto") ; --UNCHK
lin quartile_N = mkWN (compoundN "kvar" (k23 "tiili")) ; --UNCHK
lin quarto_N = mkWN (k1A "neljänneskoko") ; --UNCHK
lin quartz_N = mkWN (k5 "kvartsi") ; --UNCHK
lin quartzite_N = mkWN (k5A "kvartsiitti") ; --UNCHK
lin quartzose_A = mkWA "kvartsi-" ; --UNCHK
lin quasar_N = mkWN (k5 "objekti") "kvasistellaarinen" ; --UNCHK
lin quash_V2 = mkWV2 (k53 "kukistaa") ; --UNCHK
lin quasiparticle_N = mkWN (compoundN "kvasi" (k38 "hiukkanen")) ; --UNCHK
lin quassia_N = mkWN "Quassia" "amara" ; --UNCHK
lin quatercentenary_N = mkWN (compoundN "400-vuotis" (k10 "juhla")) ; --UNCHK
lin quatercentennial_N = mkWN (compoundN "400-vuotis" (k10 "juhla")) ; --UNCHK
lin quaternate_A = mkWA (compoundA "neli" (k38 "osainen")) ; --UNCHK
lin quatrain_N = mkWN (compoundN "neli" (k48A "säe")) ; --UNCHK
lin quattrocento_N = mkWN (compoundN "1400-" (k1A "luku")) ; --UNCHK
lin quaver_N = mkWN (compoundN "kahdeksasosa" (k5A "nuotti")) ; --UNCHK
lin quaveringly_Adv = mkWAdv (compoundAdv "vapisev" (k99 "asti")) ; --UNCHK
lin quay_N = mkWN (k6 "laivalaituri") ; --UNCHK
lin queasiness_N = mkWN (k40 "hermostuneisuus") ; --UNCHK
lin queasy_A = mkWA (k47 "ahdistunut") ; --UNCHK
lin queen_N = L.queen_N ;
lin queen_V2 = mkWV2 (k67 "tulla") "kuningattareksi" ; --UNCHK
lin queenly_A = mkWA (compoundA "kuningatar" (k38 "mainen")) ; --UNCHK
lin queensbury_PN = foreignPN "Queensbury" ;
lin queensferry_PN = foreignPN "Queensferry" ;
lin queer_A = mkWA (k38 "poikkeuksellinen") ; --UNCHK
lin queer_N = mkWN (k6 "hinttari") ; --UNCHK
lin queer_V2 = mkWV2 (k53 "altistaa") ; --UNCHK
lin queerness_N = mkWN (k40 "lesbous") ; --UNCHK
lin quell_V2 = mkWV2 (k53 "kukistaa") ; --UNCHK
lin quellung_N = mkWN (compoundN "quellung-" (k3 "reaktio")) ; --UNCHK
lin quench_V2 = mkWV2 (k66 "karkaista") ; --UNCHK
lin quenchless_A = mkWA (k34A "sammumaton") ; --UNCHK
lin quercitron_N = mkWN (k7 "mustatammi") ; --UNCHK
lin querulous_A = mkWA "valitteleva" ; --UNCHK
lin querulousness_N = mkWN "ruikuttavuus" ; --UNCHK
lin query_N = mkWN (k2 "kuulustelu") ; --UNCHK
lin query_V = mkWV (k67 "kysellä") ; --UNCHK
lin query_V2 = mkWV2 (k67 "kysellä") ; --UNCHK
lin quesadilla_N = mkWN "quesadilla" ; --UNCHK
lin quest_N = mkWN (k9A "etsintä") ; --UNCHK
lin quest_V = mkWV (k52 "anoa") ; --UNCHK
lin question_N = L.question_N ;
lin question_V2 = mkV2 (mkV (mkV "asettaa") "kyseenalaiseksi") ;
lin question_mark_N = mkWN (compoundN "kysymys" (k5A "merkki")) ; --UNCHK
lin question_master_N = mkWN (compoundN "tietokilpailun" (k10 "vetäjä")) ; --UNCHK
lin questionable_A = mkWA (compoundA "kyseen" (k38 "alainen")) ; --UNCHK
lin questioner_N = mkWN (k10 "kysyjä") ; --UNCHK
lin questioning_A = mkWA (k41 "utelias") ; --UNCHK
lin questioning_N = mkWN (k2 "kysely") ; --UNCHK
lin questionnaire_N = mkWN (compoundN "kysely" (k48A "kaavake")) ; --UNCHK
lin quetzal_N = mkWN (compoundN "kve" (k5 "saali")) ; --UNCHK
lin queue_N = mkWN (k5A "letti") ; --UNCHK
lin queue_V = mkWV (k53A "jonottaa") ; --UNCHK
lin qui_vive_N = mkWN (compoundN "hälytys" (k9 "tila")) ; --UNCHK
lin quibble_N = mkWN (k38 "hiustenhalkominen") ; --UNCHK
lin quibble_V = mkWV (k66 "kitistä") ; --UNCHK
lin quibbler_N = mkWN (k10 "hiustenhalkoja") ; --UNCHK
lin quiche_N = mkWN (k8 "quiche") ; --UNCHK
lin quick_A = mkA "nopea" ;
lin quick_Adv = mkWAdv (k99 "äkkiä") ; --UNCHK
lin quick_N = mkWN (k1 "hermo") ; --UNCHK
lin quicken_V = mkWV (k53 "virkistää") ; --UNCHK
lin quicken_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin quickener_N = mkWN "elvyttäjä" ; --UNCHK
lin quickening_N = mkWN (k39 "kiihdytys") ; --UNCHK
lin quicker_Adv = mkWAdv "nopeammin" ; --UNCHK
lin quickest_Adv = mkWAdv "nopeimmin" ; --UNCHK
lin quickie_N = mkWN (k10 "kyhäelmä") ; --UNCHK
lin quicklime_N = mkWN (kH1 "kalkki") "sammuttamaton" ; --UNCHK
lin quickness_N = mkWN (k40 "ripeys") ; --UNCHK
lin quicksand_N = mkWN (compoundN "juoksu" (k9A "hiekka")) ; --UNCHK
lin quickset_A = mkWA (k41A "pistokas") ; --UNCHK
lin quickset_N = mkWN (compoundN "aita" (k41 "pensas")) ; --UNCHK
lin quicksilver_N = mkWN (compoundN "elo" (k15 "hopea")) ; --UNCHK
lin quickstep_N = mkWN (k5 "quickstep") ; --UNCHK
lin quid_N = mkWN (kH1 "mälli") ; --UNCHK
lin quid_pro_quo_N = mkWN (k39 "hyvitys") ; --UNCHK
lin quiddity_N = mkWN (k39 "olemus") ; --UNCHK
lin quiescence_N = mkWN (k40 "liikkumattomuus") ; --UNCHK
lin quiescent_A = mkWA "uinuva" ; --UNCHK
lin quiet_A = mkWA (k38 "hiljainen") ;
lin quiet_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin quiet_V = mkWV (k67A "tyynnytellä") ; --UNCHK
lin quiet_V2 = mkWV2 (k67A "tyynnytellä") ; --UNCHK
lin quiet_down_V2 = mkWV2 (k52A "rauhoittua") ; --UNCHK
lin quieten_V = mkWV (k71 "tehdä") "hiljaiseksi" ; --UNCHK
lin quieten_V2 = mkWV2 (k71 "tehdä") "hiljaiseksi" ; --UNCHK
lin quietist_N = mkWN "kvietisti" ; --UNCHK
lin quietly_Adv = adjAdv quiet_A ; -- -- derived
lin quietness_N = mkWN (k40 "äänettömyys") ; --UNCHK
lin quietude_N = mkWN (k40 "hiljaisuus") ; --UNCHK
lin quietus_N = mkWN (k9 "rauha") ; --UNCHK
lin quiff_N = mkWN (compoundN "otsa" (k12 "kiehkura")) ; --UNCHK
lin quill_N = mkWN (k5A "piikki") ; --UNCHK
lin quill_feather_N = mkWN (k10A "sulka") ; --UNCHK
lin quillwort_N = mkWN (compoundN "lahna" (k1 "ruoho")) ; --UNCHK
lin quilt_N = mkWN (kH1 "täkki") ; --UNCHK
lin quilt_V2 = mkWV2 (k67A "ommella") ; --UNCHK
lin quilting_N = mkWN (k41A "tikkikangas") ; --UNCHK
lin quin_N = mkWN (k38 "viitonen") ; --UNCHK
lin quinacrine_N = mkWN "Atabrine" ; --UNCHK
lin quince_N = mkWN (k6 "kvitteni") ; --UNCHK
lin quincentenary_A = mkWA "500-vuotisjuhla-" ; --UNCHK
lin quincentenary_N = mkWN (compoundN "500-vuotis" (k10 "juhla")) ; --UNCHK
lin quincentennial_A = mkWA "500-vuotisjuhla-" ; --UNCHK
lin quincentennial_N = mkWN (compoundN "500-vuotis" (k10 "juhla")) ; --UNCHK
lin quinidine_N = mkWN (compoundN "Quin" (k10 "ora")) ; --UNCHK
lin quinine_N = mkWN (k5 "kiniini") ; --UNCHK
lin quinone_N = mkWN "bentsokinoni" ; --UNCHK
lin quinquagesima_N = mkWN (compoundN "laskiais" (k18 "sunnuntai")) ; --UNCHK
lin quinquefoliate_A = mkWA (compoundA "viis" (k38 "ilehdykkäinen")) ; --UNCHK
lin quinquennium_N = mkWN (compoundN "viisivuotis" (k27 "kausi")) ; --UNCHK
lin quinsy_N = mkWN (compoundN "kurkku" (k39 "tulehdus")) ; --UNCHK
lin quintessence_N = mkWN (compoundN "peri" (k10 "kuva")) ; --UNCHK
lin quintessential_A = mkWA (k38 "tyypillinen") ; --UNCHK
lin quintet_N = mkWN (k1A "kvintetto") ; --UNCHK
lin quintillion_N = mkWN (k10 "triljoona") ; --UNCHK
lin quintillionth_A = mkWA "triljoonas" ; --UNCHK
lin quintuple_A = mkWA (compoundA "viis" (k38 "inkertainen")) ; --UNCHK
lin quintuplet_N = mkWN (k1A "joukko") "viiden" ; --UNCHK
lin quintupling_N = mkWN (compoundN "viis" (k38 "inkertaistaminen")) ; --UNCHK
lin quip_N = mkWN (k2 "lohkaisu") ; --UNCHK
lin quip_V = mkWV (k53A "sutkauttaa") ; --UNCHK
lin quip_VS = mkWVS (k53A "sutkauttaa") ; --UNCHK
lin quipu_N = mkWN (compoundN "solmunuora" (k1A "kimppu")) ; --UNCHK
lin quira_N = mkWN "quira" ; --UNCHK
lin quire_N = mkWN (k9 "kirja") ; --UNCHK
lin quirk_N = mkWN (k48A "uurre") ; --UNCHK
lin quirt_N = mkWN (compoundN "ratsu" (k9 "piiska")) ; --UNCHK
lin quisling_N = mkWN (k5 "quisling") ; --UNCHK
lin quit_V = mkWV (k53A "keskeyttää") ; --UNCHK
lin quit_V2 = mkWV2 (k53A "keskeyttää") ; --UNCHK
lin quitclaim_N = mkWN (k1A "siirto") ; --UNCHK
lin quite_AdA = mkAdA "melko" ;
lin quite_Adv = S.quite_Adv ;
lin quite_Predet = mkPredet "aika" ;
lin quito_PN = foreignPN "Quito" ;
lin quits_A = mkWA (k99 "tasoissa") ; --UNCHK
lin quittance_N = mkWN (k39 "hyvitys") ; --UNCHK
lin quitter_N = mkWN (k10 "luovuttaja") ; --UNCHK
lin quiver_N = mkWN (k39 "värähdys") ; --UNCHK
lin quiver_V = mkWV (k66 "väristä") ; --UNCHK
lin quiver_V2 = mkWV2 (k66 "väristä") ; --UNCHK
lin quixotic_A = mkWA (k38 "idealistinen") ; --UNCHK
lin quiz_N = mkWN (k9 "visa") ; --UNCHK
lin quiz_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin quizmaster_N = mkWN (compoundN "tietokilpailun" (k10 "vetäjä")) ; --UNCHK
lin quizzical_A = mkWA (compoundA "kyse" (k10 "levä")) ; --UNCHK
lin quodlibet_N = mkWN (k5A "argumentti") ; --UNCHK
lin quoin_N = mkWN (k10A "nurkka") ; --UNCHK
lin quoit_N = mkWN (compoundN "heitto" (k41A "rengas")) ; --UNCHK
lin quoits_N = mkWN (compoundN "renkaan" (k1A "heitto")) ; --UNCHK
lin quorum_N = mkWN (compoundN "päätös" (k40 "valtaisuus")) ; --UNCHK
lin quota_N = mkWN (k3 "kiintiö") ;
lin quotability_N = mkWN (compoundN "julkaisu" (k40 "kelpoisuus")) ; --UNCHK
lin quotable_A = mkWA (k38 "arvoinen") "siteeraamisen" ; --UNCHK
lin quotation_N = mkN "lainaus" ;
lin quote_N = mkWN (k5A "sitaatti") ; --UNCHK
lin quote_V = mkWV (k73 "lainata") ;
lin quote_V2 = mkWV2 (k73 "lainata") ; --f70
lin quoter_N = mkWN (compoundN "sitee" (k9 "raaja")) ; --UNCHK
lin quotidian_A = mkWA (k38 "päivittäinen") ; --UNCHK
lin quotient_N = mkWN (compoundN "osa" (k10 "määrä")) ; --UNCHK
lin qurush_N = mkWN "qurush" ; --UNCHK
lin ra_N = mkWN (compoundN "pituus" (k5 "piiri")) "tähtitieteellinen" ; --UNCHK
lin raahe_PN = mkPN "Raahe" ;
lin rabato_N = mkWN "rebato" ; --UNCHK
lin rabbet_N = mkWN (k10 "ura") ; --UNCHK
lin rabbi_N = mkWN (k5 "rabbi") ; --UNCHK
lin rabbinate_N = mkWN (compoundN "rabbi" (k5A "naatti")) ; --UNCHK
lin rabbinical_A = mkWA (compoundA "rabbi" (k38 "ininen")) ; --UNCHK
lin rabbit_N = mkWN (kH1 "kani") ; --UNCHK
lin rabbit_V = mkWV (k67 "olla") "kanijahdissa" ; --UNCHK
lin rabbit_burrow_N = mkWN (k1 "kolo") "jäniksen" ; --UNCHK
lin rabbit_hole_N = mkWN (k1 "kolo") "jäniksen" ; --UNCHK
lin rabbit_hutch_N = mkWN (k5A "kaninkoppi") ; --UNCHK
lin rabbit_punch_N = mkWN (compoundN "niska" (k5A "lyönti")) ; --UNCHK
lin rabbit_warren_N = mkWN (compoundN "pesimä" (k48 "alue")) "kaniinien" ; --UNCHK
lin rabbitfish_N = mkWN (compoundN "silli" (k41A "kuningas")) ; --UNCHK
lin rabbitweed_N = mkWN (compoundN "saroth" (k48A "rae")) "Gutierrezia" ; --UNCHK
lin rabbitwood_N = mkWN "Pyrularia" "pubera" ; --UNCHK
lin rabble_N = mkWN (compoundN "ihmis" (k1A "joukko")) ; --UNCHK
lin rabelaisian_A = mkWA "Rabelais'n" ; --UNCHK
lin rabid_A = mkWA (k38 "vesikauhuinen") ; --UNCHK
lin rabies_N = mkWN (compoundN "raivo" (k5A "tauti")) ; --UNCHK
lin raccoon_N = mkWN (k5 "supi") ; --UNCHK
lin race_1_N = mkN "kilpailu" ;
lin race_2_N = mkN "rotu" ;
lin race_N = mkN "kilpailu" ;
lin race_V = mkWV (k70 "juosta") ; --UNCHK
lin race_V2 = mkWV2 (k70 "juosta") ; --UNCHK
lin race_V2V = mkWV2V (k70 "juosta") ; --UNCHK
lin race_VV = mkVV "rynnätä" infIllat ;
lin race_off_V = advV OP_race_V OP_off_Adv ; -- guess-p-verb
lin raceabout_N = mkWN (k5A "kilpajahti") ; --UNCHK
lin racecard_N = mkWN (compoundN "ratsastuskilpailu" (k10 "ohjelma")) ; --UNCHK
lin racecourse_N = mkWN (k9A "rata") ; --UNCHK
lin racehorse_N = mkWN (k6 "ravuri") ;
lin raceme_N = mkWN (k1A "terttu") ; --UNCHK
lin racemose_A = mkWA (compoundA "terttu" (k38 "mainen")) ; --UNCHK
lin racer_N = mkWN (compoundN "nuoli" (k48 "käärme")) ; --UNCHK
lin racerunner_N = mkWN (k1 "juoksijalisko") ; --UNCHK
lin racetrack_N = mkWN (k9A "rata") ; --UNCHK
lin raceway_N = mkWN (k9A "rata") ; --UNCHK
lin rachis_N = mkWN (compoundN "selkä" (k9A "ranka")) ; --UNCHK
lin rachitis_N = mkWN (compoundN "riisi" (k5A "tauti")) ; --UNCHK
lin racial_A = mkWA (k38 "rodullinen") ;
lin racialism_N = mkWN (k5 "rasismi") ; --UNCHK
lin racialist_N = mkWN (k5 "rasisti") ; --UNCHK
lin raciness_N = mkWN (k40 "ruokottomuus") ; --UNCHK
lin racing_N = mkN "kilpailu" ;
lin racism_N = mkWN (k5 "rasismi") ; --UNCHK
lin racistFem_N = mkWN (k5 "rasisti") ; --UNCHK
lin racistMasc_N = mkWN (k5 "rasisti") ; --UNCHK
lin rack_N = mkWN (compoundN "tasa" (k5A "käynti")) ; --UNCHK
lin rack_V2 = mkV2 "piinata" partitive ; --mkWV2 (k53A "kiduttaa") ;
lin rack_railway_N = mkWN (compoundN "hammas" (k9A "rata")) ; --UNCHK
lin rack_rent_N = mkWN (compoundN "nylky" (k10 "vuokra")) ; --UNCHK
lin rack_up_V2 = mkWV2 (k61A "ruokkia") ; --UNCHK
lin racker_N = mkWN (k10 "avustaja") ; --UNCHK
lin racket_N = mkN "meteli" ; --WN (k9A "toiminta") "laiton" ; ---ARB
lin racket_V = mkWV (k64 "lyödä") ; --UNCHK
lin racketeer_N = mkWN (k6 "gangsteri") ; --UNCHK
lin racketeering_N = mkWN (compoundN "gangsteri" (k9A "toiminta")) ; --UNCHK
lin rackety_A = mkWA (k10 "meluisa") ; --UNCHK
lin raconteur_N = mkWN (k10 "kertoja") ; --UNCHK
lin racoon_N = mkWN (k5 "supi") ; --UNCHK
lin racquet_N = mkWN (k9 "maila") ; --UNCHK
lin racquetball_N = mkWN (k5 "squash") ; --UNCHK
lin racy_A = mkWA (compoundA "kilpa" (k38 "kelpoinen")) ; --UNCHK
lin rad_N = mkWN (k5 "radiaani") ; --UNCHK
lin radar_N = mkWN (k10 "tutka") ; --UNCHK
lin radcliffe_PN = foreignPN "Radcliffe" ;
lin raddled_A = mkWA (k38 "näköinen") "sairaalloisen" ; --UNCHK
lin radial_A = mkWA (k38 "säteittäinen") ; --UNCHK
lin radial_N = mkWN (compoundN "vyö" (k41A "rengas")) ; --UNCHK
lin radian_N = mkWN (k5 "radiaani") ; --UNCHK
lin radiance_N = mkWN (k48 "loiste") ; --UNCHK
lin radiant_A = mkWA (k41A "kirkas") ; --UNCHK
lin radiate_A = mkWA (k38 "säteittäinen") ; --UNCHK
lin radiate_V = mkWV (k67 "säteillä") ; --UNCHK
lin radiate_V2 = mkWV2 (k67 "säteillä") ; --UNCHK
lin radiation_N = mkWN (compoundN "säde" (k1A "hoito")) ; --UNCHK
lin radiator_N = mkWN (k33A "jäähdytin") ; --UNCHK
lin radical_A = mkA "radikaali" ; --WA "tyvi-" ;
lin radical_N = mkWN (k2 "vartalo") ; --UNCHK
lin radicalism_N = mkWN (k5 "radikalismi") ; --UNCHK
lin radicchio_N = mkWN (compoundN "puna" (k6 "sikuri")) ; --UNCHK
lin radicle_N = mkWN (k26 "sirkkajuuri") ; --UNCHK
lin radiculitis_N = mkWN (compoundN "hermojuuri" (k39 "tulehdus")) ; --UNCHK
lin radio_A = mkWA "radio-" ; --UNCHK
lin radio_N = L.radio_N ;
lin radio_V2 = mkWV2 (k62 "radioida") ; --UNCHK
lin radio_set_N = mkWN (k3 "radio") ; --UNCHK
lin radio_telescope_N = mkWN (compoundN "radio" (k5A "teleskooppi")) ; --UNCHK
lin radioactive_A = mkWA (compoundA "radio" (k38 "aktiivinen")) ; --UNCHK
lin radioactivity_N = mkWN (k2 "säteily") ; --UNCHK
lin radiobiologist_N = mkWN (compoundN "radio" (k5 "biologi")) ; --UNCHK
lin radiobiology_N = mkWN (compoundN "radio" (k12 "biologia")) ; --UNCHK
lin radiocarbon_N = mkWN (k24 "hiili") "radioaktiivinen" ; --UNCHK
lin radiochemistry_N = mkWN (compoundN "ydin" (k12 "kemia")) ; --UNCHK
lin radiochlorine_N = mkWN (compoundN "radio" (k5 "kloori")) ; --UNCHK
lin radiogram_N = mkWN (compoundN "varjo" (k10 "kuva")) ; --UNCHK
lin radiograph_N = mkWN (compoundN "varjo" (k10 "kuva")) ; --UNCHK
lin radiographer_N = mkWN (compoundN "röntgen" (k10 "kuvaaja")) ; --UNCHK
lin radiographic_A = mkWA "röntgen-" ; --UNCHK
lin radiography_N = mkWN "radografia" ; --UNCHK
lin radioimmunoassay_N = mkWN (compoundN "radioimmuno" (k5 "analyysi")) ; --UNCHK
lin radioisotope_N = mkWN (compoundN "radio" (k5A "isotooppi")) ; --UNCHK
lin radiolarian_N = mkWN (compoundN "säde-" (k33 "eläin")) ; --UNCHK
lin radiological_A = mkWA (compoundA "radio" (k38 "loginen")) ; --UNCHK
lin radiologist_N = mkWN (k5 "radiologi") ; --UNCHK
lin radiology_N = mkWN (k12 "radiologia") ; --UNCHK
lin radiolucent_A = mkWA (compoundA "läpäis" (k10 "evä")) "säteilyä" ; --UNCHK
lin radiolysis_N = mkWN (k5 "radiolyysi") ; --UNCHK
lin radiometer_N = mkWN (compoundN "radio" (k5 "metri")) ; --UNCHK
lin radiomicrometer_N = mkWN "radiomikrometri" ; --UNCHK
lin radiopacity_N = mkWN "radio-opasiteetti" ; --UNCHK
lin radiopaque_A = mkWA (k10 "näkyvä") "läpivalaisussa" ; --UNCHK
lin radiopharmaceutical_N = mkWN (k48 "valmiste") "radiofarmaseuttinen" ; --UNCHK
lin radiophotograph_N = mkWN (compoundN "radio" (k10 "kuva")) ; --UNCHK
lin radiophotography_N = mkWN "radiografia" ; --UNCHK
lin radioprotection_N = mkWN (compoundN "säteily" (k2 "suojelu")) ; --UNCHK
lin radioscopy_N = mkWN (k12 "radiologia") ; --UNCHK
lin radiosensitive_A = mkWA (compoundA "säteily" (k9A "arka")) ; --UNCHK
lin radiotelegraph_N = mkWN (compoundN "radio" (k10 "sanoma")) ; --UNCHK
lin radiotelephone_N = mkWN (k33 "puhelin") "langaton" ; --UNCHK
lin radiotelephonic_A = mkWA "radiopuhelin-" ; --UNCHK
lin radiotherapist_N = mkWN (k5 "radiologi") ; --UNCHK
lin radiotherapy_N = mkWN (compoundN "säde" (k1A "hoito")) ; --UNCHK
lin radish_N = mkWN (k5 "retiisi") ; --UNCHK
lin radium_N = mkWN (k5 "radium") ; --UNCHK
lin radius_N = mkWN (kH1 "puola") "pyörän" ; --UNCHK
lin radlett_PN = foreignPN "Radlett" ;
lin radome_N = mkWN (compoundN "tutka" (k1A "kupu")) ; --UNCHK
lin radon_N = mkWN (k5 "radon") ; --UNCHK
lin radstock_PN = foreignPN "Radstock" ;
lin raf_N = mkWN (compoundN "armeija" (k10A "kunta")) "Punainen" ; --UNCHK
lin raffia_N = mkWN (compoundN "Raphia-" (k1A "suku")) ; --UNCHK
lin raffinose_N = mkWN "raffinoosi" ; --UNCHK
lin raffish_A = mkWA (k15 "rempseä") ; --UNCHK
lin raffle_V2 = mkWV2 (k52A "arpoa") ; --UNCHK
lin raft_N = mkWN (k9A "lautta") ; --UNCHK
lin raft_V = mkWV (k71 "tehdä") "lautta" ; --UNCHK
lin raft_V2 = mkWV2 (k71 "tehdä") "lautta" ; --UNCHK
lin rafter_N = mkWN (compoundN "selkä" (k18 "puu")) ; --UNCHK
lin raftered_A = mkWA (compoundA "par" (k1 "rutettu")) ; --UNCHK
lin raftsman_N = mkWN (k6 "lautturi") ; --UNCHK
lin rag_N = mkWN (k2 "vinoilu") ; --UNCHK
lin rag_V2 = mkWV2 (k54A "murentaa") ; --UNCHK
lin rag_day_N = mkWN (compoundN "hyväntekeväisyys" (k39 "tempaus")) ; --UNCHK
lin ragamuffin_N = mkWN (k38 "ryysyläinen") ; --UNCHK
lin ragbag_N = mkWN (compoundN "räsy" (k1A "laukku")) ; --UNCHK
lin rage_N = mkN "raivo" ; ---ARB --mkWN (k5A "muoti") ;
lin rage_V = mkWV (k74 "raivota") ; --UNCHK
lin raggedly_Adv = mkWAdv (compoundAdv "epä" (k99 "tasaisesti")) ; --UNCHK
lin raggedness_N = mkWN "resuisuus" ; --UNCHK
lin raglan_N = mkWN (compoundN "olkahiha" (k5A "takki")) ; --UNCHK
lin ragpicker_N = mkWN (compoundN "romun" (k10 "kerääjä")) ; --UNCHK
lin ragsorter_N = mkWN "lumppuri" ; --UNCHK
lin ragtag_N = mkWN (k41 "rahvas") ; --UNCHK
lin ragtime_N = mkWN (k8 "ragtime") ; --UNCHK
lin ragweed_N = mkWN (compoundN "tuoks" (k5A "ukki")) ; --UNCHK
lin ragwort_N = mkWN (k4A "villakko") ; --UNCHK
lin raid_N = mkN "hyökkäys" ;
lin raid_V = mkWV (k54A "tyhjentää") ; --UNCHK
lin raid_V2 = mkWV2 (k54A "tyhjentää") ; --UNCHK
lin raider_N = mkWN (k10 "valtaaja") ; --UNCHK
lin rail_N = mkWN (compoundN "ranta" (k9 "kana")) ; --UNCHK
lin rail_V = mkWV (k53A "valittaa") ; --UNCHK
lin rail_V2 = mkWV2 (k53A "valittaa") ; --UNCHK
lin railbird_N = mkWN (compoundN "hevoskilpailu" (k1 "hullu")) ; --UNCHK
lin railcar_N = mkWN (k1 "vaunu") ; --UNCHK
lin railhead_N = mkWN (compoundN "pääte" (k10 "asema")) ; --UNCHK
lin railing_N = mkWN (k48A "kaide") ;
lin raillery_N = mkWN (k2 "pilailu") ; --UNCHK
lin railroad_N = mkN "rautatie" ;
lin railroad_V2 = mkWV2 (k53A "kuljettaa") "rautateitse" ; --UNCHK
lin railway_N = mkN "rautatie" | mkWN (k9A "rata") ;
lin railwayman_N = mkWN (compoundN "jarru" (k42 "mies")) ; --UNCHK
lin raiment_N = mkWN (k39 "vaatetus") ; --UNCHK
lin rain_N = L.rain_N ;
lin rain_V = mkWV (k56A "sataa") ; --UNCHK
lin rain_V0 = L.rain_V0 ;
lin rain_V2 = mkWV2 (k56A "sataa") ; --UNCHK
lin rain_gauge_N = mkWN (compoundN "sade" (k6 "mittari")) ; --UNCHK
lin rain_out_V = mkWV (k53A "keskeyttää") ; --UNCHK
lin rainbow_N = mkWN (compoundN "sateenk" (k5 "aari")) ; --UNCHK
lin raincoat_N = mkWN (compoundN "sade" (k5A "takki")) ; --UNCHK
lin raindrop_N = mkWN (compoundN "sade" (k12 "pisara")) ; --UNCHK
lin rainfall_N = mkWN (k48A "sade") ; --UNCHK
lin rainford_PN = foreignPN "Rainford" ;
lin rainless_A = mkWA "sateeton" ; --UNCHK
lin rainmaker_N = mkWN (compoundN "sateen" (k12 "tekijä")) ; --UNCHK
lin rainmaking_N = mkWN (compoundN "sateen" (k1A "teko")) ; --UNCHK
lin rainstorm_N = mkWN (k50 "rankkasade") ; --UNCHK
lin rainwater_N = mkN "sade" L.water_N ;
lin rainy_A = mkWA (k38 "sateinen") ; --UNCHK
lin raisable_A = mkWA "kohotettava" ; --UNCHK
lin raise_N = mkN "korotus" ;
lin raise_V2 = mkV2 "nostaa" ;
lin raised_A = mkA "kohotettu" ;
lin raiser_N = mkWN (k10 "tuottaja") ;
lin raisin_N = mkWN (k12 "rusina") ; --UNCHK
lin raising_A = mkWA (compoundA "kor" (k10 "ottava")) ; --UNCHK
lin raising_N = mkWN (k39 "kasvatus") ; --UNCHK
lin raisio_PN = mkPN "Raisio" ;
lin raison_d'etre_N = mkWN (k39 "tarkoitus") "olemassaolon" ; --UNCHK
lin raita_N = mkWN (compoundN "raita" (k48A "kastike")) ; --UNCHK
lin raj_N = mkWN (compoundN "britti" (k1A "hallinto")) ; --UNCHK
lin raja_N = mkWN (compoundN "Raja-" (k1A "suku")) ; --UNCHK
lin rajah_N = mkWN (k9 "radža") ; --UNCHK
lin rajanya_N = mkWN "rajanya" ; --UNCHK
lin rake_N = mkWN (k11 "harava") ; ---ARB --mkN "kallistuma" ;
lin rake_V = mkWV (k61A "sukia") ; --UNCHK
lin rake_V2 = mkWV2 (k61A "sukia") ; --UNCHK
lin rake_in_V2 = mkWV2 (k73 "tienata") ; --UNCHK
lin rake_off_V2 = mkWV2 (k61 "kahmia") ; --UNCHK
lin rake_up_V2 = mkWV2 (k61A "tonkia") ; --UNCHK
lin rakish_A = mkWA (k15 "rempseä") ; --UNCHK
lin rakishness_N = mkWN (k40 "tyylikkyys") ; --UNCHK
lin rallentando_A = mkWA "rit." ; --UNCHK
lin rallentando_Adv = mkWAdv "rallentando" ; --UNCHK
lin rally_N = mkN "ralli" ;
lin rally_V = mkV "kilpailla" ; ---ARB WV (k52A "toipua") ;
lin rally_V2 = mkV2 "koota" ; --mkWV2 (k52A "toipua") ;
lin rally_V2V = mkWV2V (k52A "toipua") ; --UNCHK
lin rallying_N = mkWN "elpyminen" ; --UNCHK
lin ram_N = mkWN (k5 "pässi") ; --UNCHK
lin ram_V2 = mkWV2 (k53A "taivuttaa") ; --UNCHK
lin ramadan_N = mkWN "Ramadan" ; --UNCHK
lin ramble_N = mkWN (k2 "harhailu") ; --UNCHK
lin ramble_V = mkWV (k67 "harhailla") ; --UNCHK
lin ramble_on_V = mkWV (k67A "jaaritella") ; --UNCHK
lin rambler_N = mkWN "jaarittelija" ; --UNCHK
lin rambunctious_A = mkWA (k34A "vallaton") ; --UNCHK
lin rambutan_N = mkWN (compoundN "ram" (k5 "butaani")) ; --UNCHK
lin ramekin_N = mkWN (compoundN "annos" (k10A "vuoka")) ; --UNCHK
lin ramie_N = mkWN (compoundN "kiinan" (k1 "ruoho")) ; --UNCHK
lin ramification_N = mkWN (compoundN "haa" (k38 "roittuminen")) ; --UNCHK
lin ramify_V = mkWV (k52A "erkaantua") ; --UNCHK
lin ramify_V2 = mkWV2 (k52A "erkaantua") ; --UNCHK
lin ramipril_N = mkWN "Altace" ; --UNCHK
lin rammer_N = mkWN "sulloin" ; --UNCHK
lin ramp_N = mkWN (k10 "luiska") ; --UNCHK
lin ramp_V2 = mkWV2 (k66 "nousta") "takajaloilleen" ; --UNCHK
lin ramp_up_V2 = mkWV2 (k64 "luoda") ; --UNCHK
lin rampage_N = mkWN (compoundN "raivo" (k38 "aminen")) ; --UNCHK
lin rampage_V = mkWV (k52 "riehua") ; --UNCHK
lin rampageous_A = mkWA (compoundA "säntäi" (k10 "levä")) ; --UNCHK
lin rampant_A = mkWA (compoundA "reh" (k10 "ottava")) ; --UNCHK
lin rampart_N = mkWN (compoundN "suoja" (k5 "muuri")) ; --UNCHK
lin rampion_N = mkWN (compoundN "kauriin" (k1 "kello")) ; --UNCHK
lin ramrod_N = mkWN (compoundN "lataus" (k1A "puikko")) ; --UNCHK
lin ramsbottom_PN = foreignPN "Ramsbottom" ;
lin ramsgate_PN = foreignPN "Ramsgate" ;
lin ramshackle_A = mkWA (k38 "rähjäinen") ; --UNCHK
lin ramus_N = mkWN (k9 "haara") "alaleuanluun" ; --UNCHK
lin ranch_N = mkWN (k5 "farmi") ;
lin rancher_N = mkWN (compoundN "karja" (k38 "tilallinen")) ; --UNCHK
lin ranching_N = mkWN (compoundN "karjan" (k39 "kasvatus")) ; --UNCHK
lin rancid_A = mkWA (k33A "hapan") ; --UNCHK
lin rancidity_N = mkWN "eltaantuneisuus" ; --UNCHK
lin rancidness_N = mkWN "eltaantuneisuus" ; --UNCHK
lin rancorous_A = mkWA (k38 "kaunainen") ; --UNCHK
lin rancour_N = mkN "kauna" ; --mkWN (k9 "viha") ;
lin rand_N = mkWN "Reef" ; --UNCHK
lin randolph_PN = foreignPN "Randolph" ;
lin random_A = mkWA (k38 "satunnainen") ; --UNCHK
lin randomization_N = mkWN (compoundN "satu" (k38 "nnaistaminen")) ; --UNCHK
lin randomized_A = mkWA (compoundA "satu" (k1 "nnaistettu")) ; --UNCHK
lin randomness_N = mkWN (k40 "umpimähkäisyys") ; --UNCHK
lin randy_A = mkWA (k38 "eroottinen") ; --UNCHK
lin ranee_N = mkWN (k32A "ruhtinatar") ; --UNCHK
lin range_N = mkN "valikoima" | mkN "vuorijono" | mkN "arvojoukko" | mkN "kantama" ; ---- split
lin range_V = mkV "luokitella" ; --f79
lin rangefinder_N = mkWN (compoundN "etäisyys" (k6 "mittari")) ; --UNCHK
lin rangeland_N = mkWN (compoundN "laidun" (k18 "maa")) ; --UNCHK
lin ranger_N = mkWN (k5 "sissi") ; --UNCHK
lin rangpur_N = mkWN (compoundN "rangpurin" (k5A "limetti")) ; --UNCHK
lin rangy_A = mkWA (k10 "avara") ; --UNCHK
lin rani_N = mkWN (k32A "ruhtinatar") ; --UNCHK
lin ranitidine_N = mkWN "Zantac" ; --UNCHK
lin rank_A = mkA "silkka" ; ---ARB ; löyhkäävä
lin rank_N = mkN "arvoaste" ;
lin rank_V = mkWV (k67A "luokitella") ; --UNCHK
lin rank_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin ranker_N = mkWN (compoundN "rivi" (k42 "mies")) ; --UNCHK
lin ranking_N = mkWN (k39 "sijoitus") ; --UNCHK
lin rankle_V = mkWV (k53A "jäytää") ; --UNCHK
lin rankness_N = mkWN (k10 "löyhkä") ; --UNCHK
lin ransack_V2 = mkWV2 (k68 "haravoida") ; --UNCHK
lin ransacking_N = mkWN (k9A "pengonta") ; --UNCHK
lin ransom_N = mkWN (compoundN "vapa" (k38 "uttaminen")) ; --UNCHK
lin ransom_V2 = mkWV2 (k53 "lunastaa") "vapaaksi" ; --UNCHK
lin rant_N = mkWN (k5 "humpuuki") ; --UNCHK
lin rant_V = mkWV (k73 "pauhata") ; --UNCHK
lin rant_V2 = mkWV2 (k73 "pauhata") ; --UNCHK
lin rantasalmi_PN = mkPN (mkN "Rantasalmi" "Rantasalmia") ;
lin ranter_N = mkWN (compoundN "paa" (k10 "saaja")) ; --UNCHK
lin rantsila_PN = mkPN "Rantsila" ;
lin ranua_PN = mkPN "Ranua" ;
lin ranula_N = mkWN (compoundN "ran" (k10 "ula")) ; --UNCHK
lin rap_N = mkWN (k39 "läimäys") ; --UNCHK
lin rap_V = mkWV (k61A "moittia") ; --UNCHK
lin rap_V2 = mkWV2 (k61A "moittia") ; --UNCHK
lin rapacious_A = mkWA (k34A "kyltymätön") ; --UNCHK
lin rapacity_N = mkWN (k40 "kyltymättömyys") ; --UNCHK
lin rape_N = mkN "raiskaus" | mkWN (k38 "väkisinmakaaminen") ;
lin rape_V2 = mkV2 "raiskata" ; --mkWV2 (k73 "ryövätä") ;
lin raper_N = mkWN (k10 "raiskaaja") ; --UNCHK
lin rapeseed_N = mkWN (compoundN "rapsin" (k32 "siemen")) ; --UNCHK
lin raphe_N = mkWN (k9 "sauma") ; --UNCHK
lin rapid_A = mkWA (k15 "ripeä") ; --f84
lin rapid_N = mkWN (k7 "koski") ; --UNCHK
lin rapidity_N = mkWN (k40 "ripeys") ; --UNCHK
lin rapier_N = mkWN (compoundN "pisto" (k9A "miekka")) ; --UNCHK
lin rapine_N = mkWN (k39 "raiskaus") ; --UNCHK
lin rapist_N = mkWN (k10 "raiskaaja") ; --UNCHK
lin rappee_N = mkWN (k10 "nuuska") ; --UNCHK
lin rappel_N = mkWN "laskeutuminen" ; --UNCHK
lin rapper_N = mkWN (k33A "kolkutin") ; --UNCHK
lin rapport_N = mkWN (k48A "suhde") "hyvä" ; --UNCHK
lin rapporteur_N = mkWN (k12 "esittelijä") ; --UNCHK
lin rapprochement_N = mkWN (k1A "sovinto") ; --UNCHK
lin rapscallion_N = mkWN (k5 "hulivili") ; --UNCHK
lin rapt_A = mkWA (compoundA "hurmio" (k47 "itunut")) ; --UNCHK
lin raptorial_A = mkWA "peto-" ; --UNCHK
lin rapture_N = mkWN (k39 "hurmos") ; --UNCHK
lin rapturous_A = mkWA (compoundA "hurmio" (k47 "itunut")) ; --UNCHK
lin rare_A = mkWA (k38 "harvinainen") ;
lin rarebit_N = mkWN (compoundN "voi" (k10A "leipä")) "englantilaistyyppinen" "lämmin" ; --UNCHK
lin rarefaction_N = mkWN "ohentuminen" ; --UNCHK
lin rarefy_V = mkWV (k54A "laimentaa") ; --UNCHK
lin rarefy_V2 = mkWV2 (k54A "laimentaa") ; --UNCHK
lin rareness_N = mkWN (k40 "harvinaisuus") ; --UNCHK
lin raring_A = mkWA (k41A "innokas") ; --UNCHK
lin rariora_N = mkWN (compoundN "keräily" (k48 "esine")) ; --UNCHK
lin rarity_N = mkWN (k40 "erikoisuus") ; --UNCHK
lin rascal_N = mkWN (k5 "hulivili") ; --UNCHK
lin rascality_N = mkWN (k10 "jäynä") ; --UNCHK
lin rascally_A = mkWA (k38 "konnamainen") ; --UNCHK
lin rash_A = mkWA (k34A "holtiton") ; --UNCHK
lin rash_N = mkWN (k1 "vyöry") ; ---ARB --mkN "ihottuma" ;
lin rasher_N = mkWN "Sebastodes" "miniatus" ; --UNCHK
lin rashness_N = mkWN (k40 "rämäpäisyys") ; --UNCHK
lin rasp_N = mkWN (k5 "raspi") ; --UNCHK
lin rasp_V = mkWV (k66 "rahista") ; --UNCHK
lin rasp_V2 = mkWV2 (k66 "rahista") ; --UNCHK
lin raspberry_N = mkWN (k39 "tuhahdus") ; --UNCHK
lin raspingly_Adv = mkWAdv (k99 "ankarasti") ; --UNCHK
lin raster_N = mkWN (k6 "rasteri") ; --UNCHK
lin rat_N = mkWN (k10A "rotta") ; --UNCHK
lin rat_V = mkWV (k62 "vasikoida") ; --UNCHK
lin rat_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin ratability_N = mkWN "arvioitavuus" ; --UNCHK
lin ratable_A = mkWA "verotettava" ; --UNCHK
lin ratables_N = mkWN (k40 "omaisuus") "verotettava" ; --UNCHK
lin ratafia_N = mkWN (compoundN "manteli" (k39 "leivos")) ; --UNCHK
lin ratan_N = mkWN (k5A "rottinki") ; --UNCHK
lin ratatouille_N = mkWN (k8 "ratatouille") ; --UNCHK
lin ratch_N = mkWN (k10A "räikkä") ; --UNCHK
lin ratchet_N = mkWN (k10A "räikkä") ; --UNCHK
lin rate_N = mkN "kurssi" ;
lin rate_V = mkWV (k67A "luokitella") ; --UNCHK
lin rate_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin rateability_N = mkWN (k40 "alaisuus") "verotuksen" ; --UNCHK
lin rateable_A = mkWA "verotettava" ; --UNCHK
lin ratel_N = mkWN (compoundN "mesi" (k10 "mäyrä")) ; --UNCHK
lin ratepayer_N = mkWN (compoundN "veron" (k10 "maksaja")) ; --UNCHK
lin rates_N = mkWN (compoundN "kiinteistö" (k1 "vero")) "kunnallinen" ; --UNCHK
lin rather_Adv = mkAdv "mieluummin" ;
lin rather_than_Conj = mkConj "pikemmin kuin" ;
lin rather_than_Prep = mkPrep "ennemmin kuin" nominative ;
lin rathole_N = mkWN (compoundN "rotan" (k1 "kolo")) ; --UNCHK
lin rathskeller_N = mkWN (compoundN "kellari" (k12 "ravintola")) ; --UNCHK
lin ratification_N = mkWN (k39 "vahvistus") ; --UNCHK
lin ratify_V2 = mkWV2 (k62 "ratifioida") ;
lin rating_N = mkN "hinta-arvio" ;
lin ratio_N = mkWN (k48A "suhde") ; --f53
lin ratiocination_N = mkWN (k2 "päättely") ; --UNCHK
lin ratiocinative_A = mkWA "päättely-" ; --UNCHK
lin ration_N = mkWN (k39 "annos") ; --UNCHK
lin ration_V2 = mkWV2 (k67 "annostella") ; --UNCHK
lin rational_A = mkA "rationaalinen" ; --WA (k38 "järjellinen") ;
lin rationale_N = mkN "perustelu" ; --mkWN (k39 "selvitys") "periaatteiden" ;
lin rationalism_N = mkWN (k50 "vapaa-ajattelu") ; --UNCHK
lin rationalistFem_N = mkWN (k5 "rationalisti") ; --UNCHK
lin rationalistMasc_N = mkWN (k5 "rationalisti") ; --UNCHK
lin rationalist_A = mkWA (k38 "rationalistinen") ; --UNCHK
lin rationalistic_A = mkWA (k38 "rationalistinen") ; --UNCHK
lin rationality_N = mkWN (k40 "järjellisyys") ; --UNCHK
lin rationalization_N = mkWN (k5A "rationalisointi") ; --UNCHK
lin rationalize_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin rationing_N = mkWN (k2 "säännöstely") ; --UNCHK
lin ratite_N = mkWN (k1A "lintu") "lentokyvytön" ; --UNCHK
lin ratlike_A = mkWA (k38 "rottamainen") ; --UNCHK
lin ratlin_N = mkWN "väylinki" ; --UNCHK
lin ratline_N = mkWN "väylinki" ; --UNCHK
lin rattan_N = mkWN (k5A "rottinki") ; --UNCHK
lin ratter_N = mkWN (compoundN "rotta" (k5 "terrieri")) ; --UNCHK
lin rattle_V = mkWV (k73A "leikata") ; --UNCHK
lin rattle_V2 = mkV2 "helisyttää" partitive ; --mkWV2 (k73A "leikata") ;
lin rattle_off_V2 = mkWV2 (k67A "luritella") ; --UNCHK
lin rattlebrained_A = mkWA (k10A "hömppä") ; --UNCHK
lin rattlepated_A = mkWA (k10A "hömppä") ; --UNCHK
lin rattler_N = mkWN (compoundN "kalkkaro" (k48 "käärme")) ; --UNCHK
lin rattlesnake_N = mkWN (compoundN "kalkkaro" (k48 "käärme")) ; --UNCHK
lin rattling_Adv = mkWAdv (k99 "oikein") ; --UNCHK
lin rattrap_N = mkWN (compoundN "rotan" (k1A "loukku")) ; --UNCHK
lin ratty_A = mkWA (k38 "rottamainen") ; --UNCHK
lin raucous_A = mkWA (k15 "räikeä") ; --UNCHK
lin rauma_PN = mkPN "Rauma" ;
lin raunchy_A = mkWA (k34A "siivoton") ; --UNCHK
lin rautalampi_PN = mkPN "Rautalampi" ;
lin rautavaara_PN = mkPN "Rautavaara" ;
lin rautjärvi_PN = mkPN (mkN "Rautjärvi" "Rautjärviä") ;
lin rauwolfia_N = mkWN (compoundN "pirun" (k6 "pippuri")) ; --UNCHK
lin ravage_N = mkWN (k1 "tuho") ; --UNCHK
lin ravage_V = mkWV (k53 "kylvää") "tuhoa" ; --UNCHK
lin ravage_V2 = mkWV2 (k53 "kylvää") "tuhoa" ; --UNCHK
lin ravaging_N = mkWN (k1 "tuho") ; --UNCHK
lin rave_N = mkWN (k39 "ylistys") ; --UNCHK
lin rave_V = mkWV (k52 "kehua") "voimakkaasti" ; --UNCHK
lin rave_V2 = mkWV2 (k52 "kehua") "voimakkaasti" ; --UNCHK
lin ravehook_N = mkWN (compoundN "tilkintä" (k1A "koukku")) ; --UNCHK
lin ravel_V = mkWV (k61 "solmia") ; --UNCHK
lin ravel_V2 = mkWV2 (k61 "solmia") ; --UNCHK
lin raveling_N = mkWN (k1 "ripsu") ; --UNCHK
lin raven_N = mkWN (kH1 "korppi") ; --UNCHK
lin ravening_A = mkWA (k34A "kyltymätön") ; --UNCHK
lin ravenna_PN = foreignPN "Ravenna" ;
lin ravenous_A = mkWA (k34A "kyltymätön") ; --UNCHK
lin raver_N = mkWN (compoundN "paa" (k10 "saaja")) ; --UNCHK
lin ravigote_N = mkWN (compoundN "ravigote" (k48A "kastike")) ; --UNCHK
lin ravine_N = mkWN (k1 "rotko") ; --UNCHK
lin raving_Adv = mkWAdv (compoundAdv "vaahtoav" (k99 "asti")) ; --UNCHK
lin raving_N = mkWN (k2 "hourailu") ; --UNCHK
lin ravioli_N = mkWN (k5 "ravioli") ; --UNCHK
lin ravish_V2 = mkWV2 (k61 "loitsia") ; --UNCHK
lin ravishing_A = mkWA (k10 "lumoava") ; --UNCHK
lin ravishment_N = mkWN (k38 "väkisinmakaaminen") ; --UNCHK
lin raw_A = mkWA (kH1 "raaka") ;
lin raw_N = mkWN (k1 "naku") ; --UNCHK
lin rawboned_A = mkWA (k10 "luiseva") ; --UNCHK
lin rawhide_N = mkWN (k50 "raakanahka") ; --UNCHK
lin rawness_N = mkWN (k40 "raakuus") ; --UNCHK
lin rawtenstall_PN = foreignPN "Rawtenstall" ;
lin ray_N = mkWN (k1 "rausku") ;
lin ray_V = mkWV (k67 "säteillä") ; --UNCHK
lin ray_V2 = mkWV2 (k67 "säteillä") ; --UNCHK
lin rayless_A = mkWA "laitakukaton" ; --UNCHK
lin raymond_PN = foreignPN "Raymond" ;
lin rayon_N = mkWN (k6 "viskoosi") ; --UNCHK
lin razbliuto_N = mkWN (k17 "kaipuu") ; --UNCHK
lin raze_V2 = mkV2 "hävittää" ;
lin razing_N = mkWN (compoundN "tuho" (k38 "aminen")) ; --UNCHK
lin razor_N = mkWN (compoundN "parta" (k30 "veitsi")) ; --UNCHK
lin razor_V2 = mkWV2 (k56 "ajaa") "parta" ; --UNCHK
lin razor_edge_N = mkWN (k10 "terä") ; --UNCHK
lin razorback_A = mkWA (compoundA "terä" (k38 "väselkäinen")) ; --UNCHK
lin razorback_N = mkWN (compoundN "uurteis" (k41 "valas")) ; --UNCHK
lin razorbill_N = mkWN (k5A "ruokki") ; --UNCHK
lin razorblade_N = mkWN (compoundN "parta" (k10 "terä")) ; --UNCHK
lin razzle_N = mkWN "harhauttelu" ; --UNCHK
lin re_N = mkWN "re" ; --UNCHK
lin re_Prep = mkPrep "uudestaan" nominative ;
lin re_create_V2 = mkV2 (mkV (mkV "luoda") "uudelleen") ;
lin re_elect_V2 = mkV2 (mkV (mkV "valita") "uudelleen") ;
lin re_emerge_V = mkV (mkV "ilmestyä") "uudelleen" ;
lin re_emphasize_V2 = mkV2 (mkV (mkV "korostaa") "uudelleen") ;
lin re_enter_V = mkV "jatkaa" ;
lin re_enter_V2 = mkV2 (mkV "palata") (casePrep allative) ;
lin re_establish_V2 = mkV2 (mkV (mkV "vakiinnuttaa") "uudelleen") ;
lin re_evaluate_V2 = mkV2 (mkV (mkV "arvioida") "uudelleen") ;
lin re_examine_V2 = mkV2 (mkV (mkV "tarkastaa") "uudelleen") ;
lin re_supply_V2 = mkV2 (mkV (mkV "toimittaa") "uudelleen") ;
lin reach_N = mkWN "venyttäminen" ; --UNCHK
lin reach_V = mkV "saavuttaa" ;
lin reach_V2 = mkV2 "saavuttaa" ;
lin reach_out_V = mkWV (k53A "tavoittaa") ; --UNCHK
lin reach_out_for_V2 = prepV2 (advV OP_reach_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin reach_out_to_V2 = prepV2 (advV OP_reach_V OP_out_Adv ) OP_to_Prep ; -- guess-p-verb
lin react_V = mkWV (k62 "reagoida") ;
lin reactance_N = mkWN (compoundN "lois" (k39 "vastus")) ; --UNCHK
lin reactant_N = mkWN (compoundN "reak" (k5A "tantti")) ; --UNCHK
lin reaction_N = mkN "reaktio" "reaktioita" ;
lin reactionary_A = mkWA (k38 "taantumuksellinen") ; --UNCHK
lin reactionary_N = mkWN (k38 "taantumuksellinen") ; --UNCHK
lin reactionism_N = mkWN (k39 "taantumus") ; --UNCHK
lin reactivate_V2 = mkWV2 (k62 "aktivoida") "uudestaan" ; --UNCHK
lin reactive_A = mkWA (compoundA "reaktioky" (k38 "kyinen")) ; --UNCHK
lin reactivity_N = mkWN "reaktiivisuus" ; --UNCHK
lin reactor_N = mkWN (k6 "reaktori") ;
lin read_N = mkWN (k38 "lukeminen") ; --UNCHK
lin read_V = mkV "lukea" ;
lin read_V2 = L.read_V2 ;
lin read_VS = mkVS "kuulua" ; --käsky kuuluu, että XYZ ?
lin read_off_V2 = prepV2 OP_read_V OP_off_Prep ; -- guess-p-verb
lin read_out_V2 = prepV2 OP_read_V OP_out_Prep ; -- guess-p-verb
lin read_up_on_V2 = prepV2 (advV OP_read_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin readability_N = mkWN (k40 "helppolukuisuus") ; --UNCHK
lin readable_A = mkWA (k10 "luettava") ; --UNCHK
lin reader_N = mkN "lukija" | mkN "lukemisto" ; ---- split
lin readership_N = mkWN (compoundN "lukija" (k10A "kunta")) ; --UNCHK
lin readiness_N = mkWN (k40 "uskaliaisuus") ; --UNCHK
lin reading_N = mkN "lukeminen" ; ---- split mkN "lukema" "lukemia" ;
lin reading_PN = foreignPN "Reading" ;
lin reading_lamp_N = mkWN (compoundN "luku" (k1A "lamppu")) ; --UNCHK
lin reading_room_N = mkWN (compoundN "luku" (k5 "sali")) ; --UNCHK
lin readjust_V2 = mkWV2 (k52A "sopeutua") ; --UNCHK
lin readjustment_N = mkWN "sopeutuminen" ; --UNCHK
lin readmission_N = mkWN (compoundN "uudelleen" (k5A "käynti")) ; --UNCHK
lin readmit_V2 = mkWV2 (k52 "hyväksyä") "uudelleen" ; --UNCHK
lin readout_N = mkWN (k10 "näyttämä") ; --UNCHK
lin ready_A = L.ready_A ;
lin ready_N = mkWN (k99 "ulottuvilla") "käden" ; --UNCHK
lin ready_V2 = mkWV2 (k52A "varautua") ; --UNCHK
lin reaffiliation_N = mkWN (compoundN "jälleen" (k38 "liittyminen")) ; --UNCHK
lin reaffirm_V2 = mkWV2 (k53A "vakuuttaa") "uudestaan" ; --UNCHK
lin reagent_N = mkWN (k5 "reagenssi") ; --UNCHK
lin reagin_N = mkWN "reagiini" ; --UNCHK
lin real_A = mkA "todellinen" ;
lin real_1_N = mkN "todellinen" ; ---ARB mkN "tosi" "tosia" ;
lin real_2_N = mkN "todellinen" ; ---ARB mkN "tosi" "tosia" ;
lin realgar_N = mkWN (compoundN "realg" (k5 "aari")) ; --UNCHK
lin realign_V2 = mkWV2 (k67 "järjestellä") ; --UNCHK
lin realism_N = mkWN (k5 "pragmatismi") ; --UNCHK
lin realist_N = mkWN (k5 "realisti") ; --UNCHK
lin realistic_A = mkWA (k38 "realistinen") ; --UNCHK
lin reality_N = mkWN (k40 "todellisuus") ;
lin realizable_A = mkWA (k10 "oleva") "toteutettavissa" ; --UNCHK
lin realization_N = mkWN (k10 "toteutuma") ; --UNCHK
lin realize_V2 = mkV2 "toteuttaa" ;
lin realize_VS = mkWVS (k74 "älytä") ;
lin reallocation_N = mkWN (compoundN "uudelleen" (k1A "jako")) ; --UNCHK
lin reallotment_N = mkWN (compoundN "uudelleen" (k1A "jako")) ; --UNCHK
lin realm_N = mkWN (k5 "piiri") ; --UNCHK
lin realpolitik_N = mkWN (compoundN "reaali" (k9A "politiikka")) ; --UNCHK
lin realtor_N = mkWN "Realtor" ; --UNCHK
lin realty_N = mkWN (k2 "kiinteistö") ; --UNCHK
lin ream_N = mkWN (kH1 "riisi") ; --UNCHK
lin reamer_N = mkWN (k33 "kalvin") ; --UNCHK
lin reanimate_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin reap_V = mkWV (k53A "niittää") ; --UNCHK
lin reap_V2 = mkV2 "niittää" partitive ;
lin reaper_N = mkWN (compoundN "niitto" (k48 "kone")) ; --UNCHK
lin reaping_hook_N = mkWN (k5A "sirppi") "elonkorjuu" ; --UNCHK
lin reappear_V = mkWV (k73 "palata") ; --UNCHK
lin reappearance_N = mkWN (k17 "paluu") ; --UNCHK
lin reappoint_V = mkV (mkV "tulla") "nimitetyksi uudelleen" ;
lin reappoint_V2 = mkV2 (mkV (mkV "nimittää") "uudelleen") ;
lin reappraisal_N = mkWN (k39 "tarkastus") ; --UNCHK
lin reappraise_V2 = mkWV2 (k62 "arvioida") "uudelleen" ; --UNCHK
lin rear_A = variants {} ; --
lin rear_N = mkWN (k13 "selusta") ; --UNCHK
lin rear_V = mkWV (k53A "pystyttää") ; --UNCHK
lin rear_V2 = mkWV2 (k53A "pystyttää") ; --UNCHK
lin rear_admiral_N = mkWN (compoundN "kontra-" (k5 "amiraali")) ; --UNCHK
lin rearguard_N = mkWN (compoundN "jälki" (k1A "joukko")) ; --UNCHK
lin rearm_V = mkWV (k53 "varustaa") "uudelleen" ; --UNCHK
lin rearm_V2 = mkWV2 (k53 "varustaa") "uudelleen" ; --UNCHK
lin rearmament_N = mkWN (compoundN "varus" (k38 "tautuminen")) ; --UNCHK
lin rearmost_A = mkWA (k38 "viimeinen") ; --UNCHK
lin rearrange_V2 = mkWV2 (k53 "järjestää") "uudelleen" ; --UNCHK
lin rearrangement_N = mkWN (compoundN "uudelleen" (k2 "järjestely")) ; --UNCHK
lin rearward_A = mkWA (k38 "takimmainen") ; --UNCHK
lin rearward_N = mkWN (k13 "selusta") ; --UNCHK
lin rearwards_Adv = mkWAdv (k99 "taemmaksi") ; --UNCHK
lin reason_N = L.reason_N ;
lin reason_V = mkWV (k67A "päätellä") ; --UNCHK
lin reason_V2 = mkWV2 (k67A "päätellä") ; --UNCHK
lin reason_VS = mkWVS (k67A "päätellä") ; --UNCHK
lin reason_out_V2 = mkWV2 (k67A "päätellä") ; --UNCHK
lin reasonable_A = mkWA (k38 "järjellinen") ; --f56
lin reasonableness_N = mkWN (k40 "hyväksyttävyys") ; --UNCHK
lin reasoner_N = mkWN "pohtija" ; --UNCHK
lin reasoning_N = mkWN (k2 "päättely") ; --UNCHK
lin reasonless_A = mkWA (k34A "perusteeton") ; --UNCHK
lin reassemble_V = mkWV (k74A "koota") "uudelleen" ; --UNCHK
lin reassemble_V2 = mkWV2 (k74A "koota") "uudelleen" ; --UNCHK
lin reassembly_N = mkWN (compoundN "koko" (k38 "aminen")) ; --UNCHK
lin reassert_V2 = mkWV2 (k53 "varmistaa") ; --UNCHK
lin reassertion_N = mkWN "vakuuttaminen" ; --UNCHK
lin reassess_V2 = mkWV2 (k62 "arvioida") "uudelleen" ; --UNCHK
lin reassessment_N = mkWN (k39 "tarkastus") ; --UNCHK
lin reassign_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin reassignment_N = mkWN "siirtäminen" ; --UNCHK
lin reassume_V2 = mkV2 (mkV (mkV "omaksua") "uudelleen") ;
lin reassurance_N = mkWN (k40 "varmuus") ; --UNCHK
lin reassure_V2 = mkV2 "tyynnytellä" partitive ;
lin reassure_V2S = mkWV2S (k67A "tyynnytellä") ; --UNCHK
lin reassuring_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin reattribute_V2 = mkWV2 (k53A "syyttää") "edelleen" ; --UNCHK
lin rebarbative_A = mkWA (k10 "luotaantyöntävä") ; --UNCHK
lin rebate_N = mkWN (k10 "ura") ; --UNCHK
lin rebel_N = mkWN (k38 "kapinallinen") ;
lin rebel_V = mkWV (k66 "nousta") "vastaan" ; --UNCHK
lin rebellion_N = mkWN (k5A "kapinointi") ; --UNCHK
lin rebellious_A = mkWA (k38 "kapinallinen") ; --UNCHK
lin rebelliousness_N = mkWN (k2 "niskoittelu") ; --UNCHK
lin rebirth_N = mkWN (k38 "uudestisyntyminen") ; --UNCHK
lin reborn_A = mkWA (k47 "uudestisyntynyt") ; --UNCHK
lin rebound_N = mkN "kimmoke" ;
lin rebound_V = mkWV (k52A "toipua") ;
lin rebound_V2 = mkV2 "elvyttää" ; --mkWV2 (k52A "toipua") ;
lin rebound_V2V = mkWV2V (k52A "toipua") ; --UNCHK
lin reboxetine_N = mkWN "Edronax" ; --UNCHK
lin rebozo_N = mkWN (compoundN "hartia" (k5 "huivi")) ; --UNCHK
lin rebroadcast_N = mkWN (compoundN "uusinta" (k39 "lähetys")) ; --UNCHK
lin rebuff_N = mkWN (k39 "loukkaus") ; --UNCHK
lin rebuff_V = mkWV (k53 "kiistää") ; --UNCHK
lin rebuff_V2 = mkWV2 (k53 "kiistää") ;
lin rebuild_V2 = mkV2 "uudelleenrakentaa" ;
lin rebuilding_N = mkWN (compoundN "jälleen" (k39 "rakennus")) ; --UNCHK
lin rebuke_N = mkWN (k39 "ojennus") ; --UNCHK
lin rebuke_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin rebukingly_Adv = mkWAdv "sättivästi" ; --UNCHK
lin reburying_N = mkWN (compoundN "uudelleen" (k39 "hautaus")) ; --UNCHK
lin rebus_N = mkWN (compoundN "kuva-" (k39 "arvoitus")) ; --UNCHK
lin rebut_V2 = mkWV2 (k53A "osoittaa") ; --UNCHK
lin rebuttal_N = mkWN (compoundN "vasta" (k48A "väite")) ; --UNCHK
lin rebutter_N = mkWN (compoundN "vasta" (k48A "väite")) ; --UNCHK
lin recalcitrance_N = mkWN (k2 "vastaanhangoittelu") ; --UNCHK
lin recalcitrancy_N = mkWN (k2 "vastaanhangoittelu") ; --UNCHK
lin recalcitrant_A = mkWA (k38 "vastahankainen") ; --UNCHK
lin recalculate_V2 = mkWV2 (k58 "laskea") "uudelleen" ; --UNCHK
lin recalculation_N = mkWN (compoundN "uudelleen" (k9A "laskenta")) ; --UNCHK
lin recall_N = mkWN (compoundN "takaisin" (k1 "kutsu")) ; ---ARB
lin recall_V2 = mkWV2 (k64 "tuoda") "mieleen" ; --UNCHK
lin recall_VS = mkVS "muistaa" ;
lin recant_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin recant_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin recantation_N = mkWN (compoundN "per" (k38 "uminen")) ; --UNCHK
lin recap_N = mkWN (k41A "rengas") "uudelleen" "pinnoitettu" ; --UNCHK
lin recap_V = mkWV (k65 "käydä") "läpi" ; --UNCHK
lin recap_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin recapitulate_V = mkWV (k65 "käydä") "läpi" ; --UNCHK
lin recapitulate_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin recapitulation_N = mkWN (compoundN "kerta" (k38 "aminen")) "pääkohtien" ; --UNCHK
lin recapture_N = mkWN (compoundN "takaisin" (k5A "saanti")) ; --UNCHK
lin recapture_V2 = mkWV2 (k53A "ottaa") "uudelleen" ; --UNCHK
lin recast_V2 = mkWV2 (k73A "muokata") "uudestaan" ; --UNCHK
lin recce_N = mkWN (k2 "tiedustelu") ; --UNCHK
lin recede_V = mkWV (k52 "väistyä") ; --UNCHK
lin receding_N = mkWN (compoundN "etä" (k38 "äntyminen")) ; --UNCHK
lin receipt_N = mkN (lin NK {s = d05A "kuitti"}) ;
lin receipt_V2 = mkWV2 (k73A "kuitata") ; --UNCHK
lin receivable_A = mkWA (k10 "saatava") ; --UNCHK
lin receive_V = mkWV (compoundV "vastaan" (k53A "ottaa")) ;
lin receive_V2 = mkWV2 (compoundV "vastaan" (k53A "ottaa")) ;
lin receiver_N = mkWN (compoundN "vastaan" (k33A "otin")) ;
lin receivership_N = mkWN (k25 "toimi") "pesänhoitajan" ; --UNCHK
lin receiving_set_N = mkWN (k3 "radio") ; --UNCHK
lin recency_N = mkWN (k40 "uutuus") ; --UNCHK
lin recent_A = mkA "viimeaikainen" ;
lin recentralize_V2 = mkV2 (mkV (mkV "keskittää") "uudelleen") ;
lin receptacle_N = mkWN (k3 "säiliö") ; --UNCHK
lin reception_N = mkWN (compoundN "vastaan" (k1A "otto")) ;
lin reception_desk_N = mkWN (compoundN "vastaan" (k1A "otto")) ; --UNCHK
lin receptionist_N = mkWN (k5 "reseptionisti") ; --UNCHK
lin receptive_A = mkWA (k33 "avoin") ; --UNCHK
lin receptiveness_N = mkWN (k40 "avoimuus") ; --UNCHK
lin receptivity_N = mkWN (k40 "avoimuus") ; --UNCHK
lin receptor_N = mkWN (k5 "reseptori") ; --UNCHK
lin recess_N = mkWN (k5 "paussi") ; --UNCHK
lin recess_V2 = mkWV2 (k53A "päättää") ; --UNCHK
lin recession_N = mkN "lama" ;
lin recessional_A = mkWA (k10 "väistyvä") ; --UNCHK
lin recessional_N = mkWN (compoundN "loppu" (k28 "virsi")) ; --UNCHK
lin recessionary_A = mkWA "taantumaa" "aiheuttava" ; --UNCHK
lin recessive_A = mkWA "peittyvä" ; --UNCHK
lin rechargeable_A = mkWA "uudelleenladattava" ; --UNCHK
lin rechauffe_N = mkWN (k10A "ruoka") "uudelleen" "lämmitetty" ; --UNCHK
lin recherche_A = mkWA (k10 "ihastuttava") ; --UNCHK
lin recidivism_N = mkWN (compoundN "uusinta" (k40 "rikollisuus")) ; --UNCHK
lin recidivist_N = mkWN (k5A "vanki") "tapojensa" ; --UNCHK
lin recife_PN = foreignPN "Recife" ;
lin recipe_N = mkWN (k5 "resepti") ;
lin recipient_N = mkWN (compoundN "vastaan" (k10 "ottaja")) ;
lin reciprocal_A = mkWA (k38 "keskinäinen") ; --UNCHK
lin reciprocal_N = mkWN (k39 "risteytys") "vastavuoroinen" ; --UNCHK
lin reciprocality_N = mkWN (k40 "vastavuoroisuus") ; --UNCHK
lin reciprocate_V = mkWV (k53A "liikuttaa") "edestakaisin" ; --UNCHK
lin reciprocate_V2 = mkWV2 (k53A "liikuttaa") "edestakaisin" ; --UNCHK
lin reciprocation_N = mkWN (k40 "molemminpuolisuus") ; --UNCHK
lin reciprocative_A = mkWA (k10 "liikkuva") "edestakaisin" ; --UNCHK
lin reciprocity_N = mkWN (k40 "vastavuoroisuus") ; --UNCHK
lin recirculation_N = mkWN (compoundN "uudelleen" (k1A "kierto")) ; --UNCHK
lin recission_N = mkWN (k39 "peruutus") ; --UNCHK
lin recital_N = mkWN (k5 "resitaali") ; --UNCHK
lin recitalist_N = mkWN (k5 "solisti") ; --UNCHK
lin recitation_N = mkWN (k48A "harjoite") ; --UNCHK
lin recitative_N = mkWN (k5 "resitatiivi") ; --UNCHK
lin recite_V = mkWV (k52 "lausua") ; --UNCHK
lin recite_V2 = mkWV2 (k52 "lausua") ; --UNCHK
lin reciter_N = mkWN (k10 "lausuja") ; --UNCHK
lin reckless_A = mkWA (k34A "holtiton") ; --UNCHK
lin recklessness_N = mkWN (k40 "rämäpäisyys") ; --UNCHK
lin recklinghausen_PN = foreignPN "Recklinghausen" ;
lin reckon_VS = mkWVS (k73 "arvata") ;
lin reckoner_N = mkWN (compoundN "laskenta" (k4A "taulukko")) ; --UNCHK
lin reckoning_N = mkWN (k38 "lukeminen") "numeroiden" ; --UNCHK
lin reclaim_V2 = mkV2 (mkV (mkV "hankkia") "takaisin") ; --mkWV2 (k53A "kesyttää") ;
lin reclaimable_A = mkWA "uudelleenkäytettävä" ; --UNCHK
lin reclamation_N = mkWN (compoundN "talteen" (k1A "otto")) ; --UNCHK
lin reclassification_N = mkWN (compoundN "uudelleen" (k39 "luokitus")) ; --UNCHK
lin reclassify_V2 = mkWV2 (k67A "luokitella") "uudestaan" ; --UNCHK
lin recline_V = mkWV (k52A "loikoa") ; --UNCHK
lin recline_V2 = mkWV2 (k52A "loikoa") ; --UNCHK
lin recliner_N = mkWN (compoundN "aurinko" (k5 "tuoli")) ; --UNCHK
lin reclining_N = mkWN (compoundN "noja" (k38 "aminen")) ; --UNCHK
lin recluse_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin recluse_N = mkWN (k4A "erakko") ; --UNCHK
lin reclusiveness_N = mkWN (k40 "eristyneisyys") ; --UNCHK
lin recoding_N = mkWN (compoundN "uudelleen" (k39 "koodaus")) ; --UNCHK
lin recognition_N = mkN "tunnustus" ;
lin recognizable_A = mkWA (k10 "oleva") "tunnistettavissa" ; --UNCHK
lin recognizance_N = mkWN (compoundN "ase" (k38 "ttaminen")) "takauksen" ; --UNCHK
lin recognize_1_V2 = mkV2 "tuntea" ; ---- sense ?
lin recognize_4_V2 = mkV2 "tunnistaa" ; ---- sense ?
lin recognize_V2 = mkV2 "tunnistaa" ;
lin recognize_VS = mkWVS (k54A "myöntää") ;
lin recoil_N = mkWN (k2 "potkaisu") ; --UNCHK
lin recoil_V = mkWV (k66 "potkaista") ; --UNCHK
lin recoilless_A = mkWA (k34A "rekyylitön") ; --UNCHK
lin recollect_V = mkWV (k64 "tuoda") "mieleen" ; --UNCHK
lin recollect_V2 = mkWV2 (k64 "tuoda") "mieleen" ; --UNCHK
lin recollection_N = mkWN "muistaminen" ; --UNCHK
lin recombinant_A = mkWA "yhdistelmä-" ; --UNCHK
lin recombinant_N = mkWN (compoundN "rekombi" (k5A "naatti")) ; --UNCHK
lin recombination_N = mkWN "rekombinaatio" ; --UNCHK
lin recommend_V2 = mkV2 "suositella" ; --f53
lin recommend_V2V = mkV2V (mkV "suositella") partitive infIllat ;
lin recommend_VS = mkVS "suositella" ; --WVS (k52 "puhua") "puolestaan" ;
lin recommendation_N = mkN "suositus" ;
lin recommit_V2 = mkWV2 (k53A "palauttaa") "valiokuntaan" ; --UNCHK
lin recompense_N = mkWN (k3 "palkkio") ; --UNCHK
lin recompense_V2 = mkWV2 (k62 "kompensoida") ; --UNCHK
lin reconcilable_A = mkWA (compoundA "yhteen" (k10 "sopiva")) ; --UNCHK
lin reconcile_V2 = mkWV2 (k53A "sovittaa") ; --UNCHK
lin reconciliation_N = mkWN (k1A "sovinto") ; --UNCHK
lin recondite_A = mkWA (k38 "vaikeaselkoinen") ; --UNCHK
lin reconditeness_N = mkWN (compoundN "vaikea" (k40 "tajuisuus")) ; --UNCHK
lin recondition_V2 = mkWV2 (k53 "kunnostaa") ; --UNCHK
lin reconnaissance_N = mkWN (k2 "tiedustelu") ; --UNCHK
lin reconnoitre_V = mkWV (k67 "tiedustella") ; --UNCHK
lin reconnoitre_V2 = mkWV2 (k67 "tiedustella") ; --UNCHK
lin reconsecrate_V2 = mkWV2 (k53A "pyhittää") "uudelleen" ; --UNCHK
lin reconsider_V2 = mkV2 (mkV (mkV "harkita") "uudelleen") partitive ;
lin reconsider_VS = mkWVS (k69 "harkita") "uudelleen" ; --UNCHK
lin reconsideration_N = mkWN (compoundN "uudelleen" (k9A "harkinta")) ; --UNCHK
lin reconstruct_V2 = mkWV2 (compoundV "uudelleen" (k53A "kouluttaa")) ; --UNCHK
lin reconstruction_N = mkWN (k5A "rekonstruointi") ; --UNCHK
lin reconstructive_A = mkWA "kuntouttava" ; --UNCHK
lin reconvict_V2 = mkWV2 (k69 "tuomita") "uudelleen" ; --UNCHK
lin record_1_N = mkN "ennätys" ;
lin record_2_N = mkN "levy" | mkN "äänilevy" ;
lin record_3_N = mkN "kirjanpito" ;
lin record_N = mkN "ennätys" ;
lin record_V2 = mkV2 "tallentaa" | mkV2 "äänittää" ;
lin record_breaking_A = mkA (mkN "ennätyksiä" (mkN "rikkova")) ; ----sanaliitto
lin record_player_N = mkWN (k5 "gramofoni") ; --UNCHK
lin recorder_N = mkWN (compoundN "nokka" (k1 "huilu")) ; --UNCHK
lin recording_N = mkWN (k39 "tallennus") ; --UNCHK
lin re_count_N = mkWN (compoundN "tarkistus" (k9A "laskenta")) ; --UNCHK
lin re_count_V2 = mkWV2 (k58 "laskea") "uudelleen" ; --UNCHK
lin recount_VS = mkWVS (k58 "laskea") "uudelleen" ; --UNCHK
lin recoup_V2 = mkWV2 (k53A "pidättää") ; ---ARB ; maksaa takaisin
lin recourse_N = mkWN (compoundN "turva" (k38 "utuminen")) ; --UNCHK
lin recover_V = mkWV (k52A "tervehtyä") ;
lin recoverable_A = mkWA (k10 "saatava") "takaisin" ; --UNCHK
lin recovery_N = mkN "toipuminen" ;
lin recreant_A = mkWA (k38 "raukkamainen") ; --UNCHK
lin recreant_N = mkWN (k6 "petturi") ; --UNCHK
lin recreate_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin recreation_N = mkWN (k39 "virkistys") ;
lin recreational_A = mkWA (k38 "ajanvietteellinen") ;
lin recriminate_V = mkWV (k53A "esittää") "vastasyytös" ; --UNCHK
lin recrimination_N = mkWN (compoundN "vasta" (k39 "syytös")) ; --UNCHK
lin recriminative_A = mkWA "syyttävä" ; --UNCHK
lin recriminatory_A = mkWA "syyttävä" ; --UNCHK
lin recrudescence_N = mkWN "uudelleen" "puhkeaminen" ; --UNCHK
lin recrudescent_A = mkWA "uudelleen" "puhkeava" ; --UNCHK
lin recruit_N = mkWN (k41A "tulokas") ; --UNCHK
lin recruit_V = mkWV (k53A "ottaa") "sotaväkeen" ; --UNCHK
lin recruit_V2 = mkWV2 (k53A "ottaa") "sotaväkeen" ; --UNCHK
lin recruiter_N = mkWN (k10 "värvääjä") ; --UNCHK
lin recruitment_N = mkWN (k5A "rekrytointi") ; --UNCHK
lin rectal_A = mkWA "peräsuoli-" ; --UNCHK
lin rectangle_N = mkWN (k50 "suorakaide") ; --UNCHK
lin rectangular_A = mkWA (compoundA "suorakul" (k38 "mainen")) ; --UNCHK
lin rectangularity_N = mkWN "suorakulmaisuus" ; --UNCHK
lin rectification_N = mkWN "rektifiointi" ; --UNCHK
lin rectifier_N = mkWN (k10 "tasasuuntaaja") ; --UNCHK
lin rectify_V2 = mkWV2 (compoundV "tasa" (k73A "suunnata")) ; --UNCHK
lin rectilinear_A = mkA (mkN "suora" (mkN "viivainen")) ;
lin rectitude_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin recto_N = mkWN (k1 "sivu") "oikeanpuoleinen" ; --UNCHK
lin rectocele_N = mkWN (compoundN "proktose" (k48 "ele")) ; --UNCHK
lin rector_N = mkWN (k6 "pastori") ; --UNCHK
lin rectorship_N = mkWN (k9A "virka") "rehtorin" ; --UNCHK
lin rectory_N = mkWN (k12 "pappila") ; --UNCHK
lin rectosigmoid_A = mkWA "rektosigmoido-" ; --UNCHK
lin rectum_N = mkWN (compoundN "perä" (k26 "suoli")) ; --UNCHK
lin rectus_N = mkWN (k39 "lihas") "suora" ; --UNCHK
lin recumbent_A = mkWA (compoundA "mak" (k9 "aava")) ; --UNCHK
lin recuperate_V = mkWV (k52A "tervehtyä") ; --UNCHK
lin recuperate_V2 = mkWV2 (k52A "tervehtyä") ; --UNCHK
lin recuperation_N = mkWN (compoundN "pala" (k38 "utuminen")) ; --UNCHK
lin recuperative_A = mkWA "parantava" ; --UNCHK
lin recur_V = mkWV (k52 "toistua") ; --UNCHK
lin recurrence_N = mkWN (compoundN "uusi" (k38 "utuminen")) ; --UNCHK
lin recurrent_A = mkWA (k10 "jatkuva") ; --UNCHK
lin recursion_N = mkWN (k1 "toisto") ; --UNCHK
lin recursive_A = mkWA "rekursiivinen" ; --UNCHK
lin recurve_V = mkWV (k52A "kääntyä") "takaisin" ; --UNCHK
lin recurve_V2 = mkWV2 (k52A "kääntyä") "takaisin" ; --UNCHK
lin recusancy_N = mkWN (k2 "vastaanhangoittelu") ; --UNCHK
lin recusant_A = mkWA "vastaanhangoitteleva" ; --UNCHK
lin recusant_N = mkWN (compoundN "toisin" (k12 "ajattelija")) ; --UNCHK
lin recusation_N = mkWN (compoundN "jää" (k38 "vääminen")) ; --UNCHK
lin recycle_V2 = mkWV2 (k53A "käyttää") "uudelleen" ; --UNCHK
lin recycling_N = mkWN (k39 "kierrätys") ; --UNCHK
lin red_A = L.red_A ;
lin red_N = mkWN (k40 "punaisuus") ; --UNCHK
lin redact_N = mkWN (k10 "toimittaja") ; --UNCHK
lin redact_V2 = mkWV2 (k62 "editoida") ; --UNCHK
lin redaction_N = mkWN (compoundN "toi" (k38 "mittaminen")) ; --UNCHK
lin redberry_N = mkWN (compoundN "lännenkonnan" (k9 "marja")) ; --UNCHK
lin redbone_N = mkWN (compoundN "pesukarhu" (k10 "koira")) "punainen" ; --UNCHK
lin redbreast_N = mkWN (compoundN "puna" (k9A "rinta")) "Euroopan" ; --UNCHK
lin redbrick_A = mkWA (compoundA "puna" (k38 "tiilinen")) ; --UNCHK
lin redbud_N = mkWN (compoundN "juudaksen" (k18 "puu")) ; --UNCHK
lin redcap_N = mkWN (k10 "kantaja") ; --UNCHK
lin redcoat_N = mkWN (compoundN "puna" (k5A "takki")) ; --UNCHK
lin redden_V = mkWV (k52 "punastua") ; --UNCHK
lin redden_V2 = mkWV2 (k52 "punastua") ; --UNCHK
lin reddish_A = mkWA (k10 "punertava") ; --UNCHK
lin redditch_PN = foreignPN "Redditch" ;
lin redecorate_V2 = mkWV2 (k53 "kunnostaa") ; --UNCHK
lin rededication_N = mkWN (compoundN "vihki" (k38 "minen")) "uudelleen" ; --UNCHK
lin redeem_V2 = mkWV2 (k53 "lunastaa") ;
lin redeemable_A = mkWA "lunastettava" ; --UNCHK
lin redeemer_N = mkWN (k10 "lunastaja") ; --UNCHK
lin redefine_V2 = mkWV2 (k67A "määritellä") "uudelleen" ; --UNCHK
lin redefinition_N = mkWN (compoundN "uudelleen" (k39 "määritys")) ; --UNCHK
lin redemption_N = mkN "lunastus" ;
lin redemptive_A = mkWA "pelastava" ; --UNCHK
lin redeploy_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin redeployment_N = mkWN (k1A "siirto") ; --UNCHK
lin redeposition_N = mkWN (compoundN "uudelleen" (k39 "talletus")) ; --UNCHK
lin redesign_V2 = mkWV2 (k67A "suunnitella") "uudelleen" ;
lin redetermination_N = mkWN (compoundN "pää" (k38 "ttäminen")) "uudelleen" ; --UNCHK
lin redevelop_V2 = mkWV2 (k73 "saneerata") ; --UNCHK
lin redevelopment_N = mkWN (k39 "saneeraus") ; --UNCHK
lin redeye_N = mkWN (k1A "yölento") ; --UNCHK
lin redfish_N = mkWN (compoundN "koiras" (k23 "lohi")) ; --UNCHK
lin redhead_N = mkWN (compoundN "punapää" (k9A "tikka")) ; --UNCHK
lin redheaded_A = mkWA (compoundA "puna" (k38 "tukkainen")) ; --UNCHK
lin redhorse_N = mkWN "Moxostoma" "aureouim" ; --UNCHK
lin rediffusion_N = mkWN (compoundN "uusinta" (k39 "lähetys")) ; --UNCHK
lin rediscover_V2 = mkWV2 (k54A "löytää") "uudelleen" ; --UNCHK
lin rediscovery_N = mkWN "uudelleen" "löytäminen" ; --UNCHK
lin redisposition_N = mkWN (k1A "siirto") ; --UNCHK
lin redistribute_V2 = mkV2 "uudelleenjakaa" ;
lin redistribution_N = mkWN (k1A "jako") "uudelleen" ;
lin redline_V2 = mkWV2 (k61 "syrjiä") ; --UNCHK
lin redneck_N = mkWN (k5A "juntti") ; --UNCHK
lin redness_N = mkWN (k40 "punaisuus") ; --UNCHK
lin redo_V2 = mkWV2 (k73A "rempata") ; --UNCHK
lin redolence_N = mkWN (k39 "tuulahdus") ; --UNCHK
lin redolent_A = mkWA (k41A "aromikas") ; --UNCHK
lin redouble_V = mkWV (k52A "kiihtyä") ; --UNCHK
lin redouble_V2 = mkWV2 (k52A "kiihtyä") ; --UNCHK
lin redoubt_N = mkWN (k39 "varustus") ; --UNCHK
lin redoubtable_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin redound_V = mkWV (k53A "vaikuttaa") ; --UNCHK
lin redpoll_N = mkWN (k38 "urpiainen") ; --UNCHK
lin redraft_N = mkWN (compoundN "takautumis" (k6 "vekseli")) ; --UNCHK
lin redraw_V2 = mkV2 (mkV (mkV "määritellä") "uudelleen") ;
lin redress_N = mkWN (k39 "parannus") ; --UNCHK
lin redress_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin redruth_PN = foreignPN "Redruth" ;
lin redshank_N = mkWN (compoundN "punajalka" (k1 "viklo")) ; --UNCHK
lin redskin_N = mkWN (k6 "inkkari") ; --UNCHK
lin redstart_N = mkWN (compoundN "leppä" (k1A "lintu")) ; --UNCHK
lin redtail_N = mkWN (compoundN "leppä" (k1A "lintu")) ; --UNCHK
lin reduce_V = mkV "vähentää" | mkV "vähentyä" ;
lin reduce_V2 = mkV2 "vähentää" partitive ;
lin reduced_A = variants {} ; --
lin reducer_N = mkWN (compoundN "supistus" (k5 "muhvi")) ; --UNCHK
lin reducible_A = mkWA (k10 "vähennettävä") ; --UNCHK
lin reducing_N = mkWN "laihduttaminen" ; --UNCHK
lin reductio_ad_absurdum_N = mkWN (k3 "reduktio") ; --UNCHK
lin reduction_N = mkN "vähennys" ;
lin reductionism_N = mkWN (compoundN "reduktion" (k5 "ismi")) ; --UNCHK
lin reductionist_A = mkWA (compoundA "reduktio" (k38 "nistinen")) ; --UNCHK
lin reductive_A = mkWA (k10 "alentava") ; --UNCHK
lin redundance_N = mkWN (k40 "tarpeettomuus") ; --UNCHK
lin redundancy_N = mkWN (k40 "liiallisuus") ; --UNCHK
lin redundant_A = mkWA (k38 "tautologinen") ; --UNCHK
lin reduplicate_V2 = mkWV2 (k53 "toistaa") ; --UNCHK
lin reduplication_N = mkWN (compoundN "toi" (k38 "staminen")) ; --UNCHK
lin redwing_N = mkWN (compoundN "punakylki" (k41 "rastas")) ; --UNCHK
lin redwood_N = mkWN "jättiläispunapuu" ; --UNCHK
lin reed_N = mkWN (compoundN "ruoko" (k7A "lehti")) ; --UNCHK
lin reedy_A = mkWA (compoundA "kaisla" (k38 "mainen")) ; --UNCHK
lin reef_N = mkWN (k5 "reivi") ; --UNCHK
lin reef_V2 = mkWV2 (k73 "reivata") ; --UNCHK
lin reef_knot_N = mkWN (compoundN "merimies" (k1 "solmu")) ; --UNCHK
lin reefer_N = mkWN (compoundN "kannabis" (k48A "savuke")) ; --UNCHK
lin reefy_A = mkWA (k38 "kielekkeinen") ; --UNCHK
lin reek_N = mkWN (k1 "haju") "myrkyllinen" ; --UNCHK
lin reek_V = mkWV (k74 "höyrytä") ; --UNCHK
lin reel_V = mkV "horjua" ; --mkWV (k73 "rullata") ;
lin reel_V2 = mkWV2 (k73 "rullata") ; --UNCHK
lin reel_off_V2 = mkWV2 (k67A "luritella") ; --UNCHK
lin reelection_N = mkWN (compoundN "uudelleen" (k9A "valinta")) ; --UNCHK
lin reeler_N = mkWN (compoundN "reel-" (k12 "tanssija")) ; --UNCHK
lin reenactment_N = mkWN (compoundN "uudelleen" (k39 "esitys")) ; --UNCHK
lin reenactor_N = mkWN (compoundN "uudelleen" (k12 "näyttelijä")) ; --UNCHK
lin reenlistment_N = mkWN (compoundN "uudelleen" (k39 "värväys")) ; --UNCHK
lin re_entry_N = mkWN (k17 "paluu") ; --UNCHK
lin reevaluation_N = mkWN (compoundN "uudelleen" (k5A "arviointi")) ; --UNCHK
lin reeve_N = mkWN (compoundN "suokukko" (k41 "naaras")) ; --UNCHK
lin reexamine_V = mkWV (k53 "tarkistaa") ; --UNCHK
lin ref_N = mkWN (k6 "tuomari") ; --UNCHK
lin reface_V2 = mkWV2 (k53 "päällystää") "uudelleen" ; --UNCHK
lin refashion_V2 = mkV2 (mkV (mkV "muotoilla") "uudelleen") ;
lin refection_N = mkWN (k48A "virvoke") ; --UNCHK
lin refectory_N = mkWN (compoundN "ruoka" (k5 "sali")) ; --UNCHK
lin refer_V = mkV "viitata" ;
lin refer_V2 = mkV2 (mkV "viitata") illative ;
lin referable_A = mkWA (k99 "takia") "jnk" ; --UNCHK
lin referee_N = mkWN (k6 "tuomari") ; --UNCHK
lin referee_V = mkWV (k67 "arvostella") ; --UNCHK
lin referee_V2 = mkWV2 (k67 "arvostella") ; --UNCHK
lin reference_N = mkN "viite" | mkN "referenssi" ;
lin referenced_A = mkWA (compoundA "varus" (k1 "tettu")) "viittauksilla" ; --UNCHK
lin referendum_N = mkWN (compoundN "kansan" (k39 "äänestys")) ; --UNCHK
lin referent_A = mkWA (compoundA "viitt" (k9 "aava")) ; --UNCHK
lin referent_N = mkWN (k48A "tarkoite") ; --UNCHK
lin referential_A = mkWA (compoundA "viitt" (k9 "aava")) ; --UNCHK
lin referral_N = mkWN (compoundN "viitta" (k38 "aminen")) ; --UNCHK
lin refile_V2 = mkV2 (mkV (mkV "arkistoida") "uudelleen") ; ---ARB ; "nostaa kanne uudelleen"
lin refill_N = mkWN (k48A "täyte") ; --UNCHK
lin refill_V2 = mkWV2 (k53A "täyttää") "uudelleen" ; --UNCHK
lin refilling_N = mkWN (k39 "täydennys") ; --UNCHK
lin refinance_V = mkWV (k53A "rahoittaa") "uudelleen" ; --UNCHK
lin refinance_V2 = mkWV2 (k53A "rahoittaa") "uudelleen" ;
lin refine_V = mkWV (k53A "kehittää") ; --UNCHK
lin refine_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin refinement_N = mkWN (k40 "sivistyneisyys") ; --UNCHK
lin refiner_N = mkWN (k10 "jalostaja") ;
lin refinery_N = mkWN (k2 "jalostamo") ;
lin refining_N = mkWN (k39 "puhdistus") ; --UNCHK
lin refinisher_N = mkWN (compoundN "kun" (k10 "nostaja")) ; --UNCHK
lin refit_N = mkWN (k39 "kunnostus") ; --UNCHK
lin refit_V = mkWV (k53 "kunnostaa") ; --UNCHK
lin refit_V2 = mkWV2 (k53 "kunnostaa") ; --UNCHK
lin reflate_V2 = mkWV2 (k53A "täyttää") "uudelleen" ; --UNCHK
lin reflation_N = mkWN (k3 "reflaatio") ; --UNCHK
lin reflect_V = mkV "pohtia" | mkWV (k61 "tuumia") ;
lin reflect_V2 = mkV2 "harkita" partitive ;
lin reflection_N = mkWN (k39 "heijastus") ;
lin reflective_A = mkWA "heijastava" ; --UNCHK
lin reflectiveness_N = mkWN (k40 "mietteliäisyys") ; --UNCHK
lin reflectometer_N = mkWN (compoundN "reflekto" (k5 "metri")) ; --UNCHK
lin reflector_N = mkWN "peilikaukoputki" ; --UNCHK
lin reflex_A = mkWA (k34A "tahaton") ; --UNCHK
lin reflex_N = mkWN (k3 "reaktio") "psykologinen" ; --UNCHK
lin reflexed_A = mkWA (k10 "kupera") ; --UNCHK
lin reflexion_N = mkWN (k39 "heijastus") ; --UNCHK
lin reflexive_A = mkWA (k38 "refleksiivinen") ; --UNCHK
lin reflexive_N = mkWN (compoundN "refleksiivi" (k5 "pronomini")) ; --UNCHK
lin reflexivity_N = mkWN (compoundN "refleksiiv" (k40 "isyys")) ; --UNCHK
lin reflexology_N = mkWN (compoundN "vyöhyke" (k12 "terapia")) ; --UNCHK
lin refloat_V = mkWV (k53A "asettaa") "kellumaan" ; --UNCHK
lin refloat_V2 = mkWV2 (k53A "asettaa") "kellumaan" ; --UNCHK
lin reflux_N = mkWN (kH1 "luode") ; --UNCHK
lin refocus_V = mkWV (k54A "tarkentaa") "uudelleen" ;
lin refocus_V2 = mkWV2 (k54A "tarkentaa") "uudelleen" ; --UNCHK
lin refocus_V2V = mkWV2V (k54A "tarkentaa") "uudelleen" ; --UNCHK
lin refocusing_N = mkWN (compoundN "tarke" (k38 "ntaminen")) "uudelleen" ; --UNCHK
lin reforest_V2 = mkWV2 (k53A "metsittää") "uudelleen" ; --UNCHK
lin reforestation_N = mkWN (compoundN "uudelleen" (k39 "metsitys")) ; --UNCHK
lin reform_N = mkN (lin NK {s = d39 "uudistus"}) ;
lin re_form_V = mkWV (k52 "valaistua") ; --UNCHK
lin re_form_V2 = mkV2 "uudistaa" ; --mkWV2 (k52 "valaistua") ;
lin reformation_N = mkWN (compoundN "par" (k38 "antaminen")) "tapojen" ; --UNCHK
lin reformative_A = mkWA "kasvattava" ; --UNCHK
lin reformatory_A = mkWA "kasvattava" ; --UNCHK
lin reformatory_N = mkWN (compoundN "koulu" (k5A "koti")) ; --UNCHK
lin reformer_N = mkWN "uudistin" ; --UNCHK
lin reformism_N = mkWN (k5 "reformismi") ; --UNCHK
lin reformulate_V2 = mkWV2 (k67 "muotoilla") "uudelleen" ; --UNCHK
lin refract_V2 = mkWV2 (k76A "taitaa") ; --UNCHK
lin refraction_N = mkWN (k10 "taipuma") ; --UNCHK
lin refractive_A = mkWA "taittava" ; --UNCHK
lin refractivity_N = mkWN "taittuvuus" ; --UNCHK
lin refractometer_N = mkWN (compoundN "refrakto" (k5 "metri")) ; --UNCHK
lin refractoriness_N = mkWN (k2 "vastaanhangoittelu") ; --UNCHK
lin refractory_A = mkA "vastahakoinen" ; --WA (k38 "vastahankainen") ;
lin refrain_N = mkWN (compoundN "kerto" (k48A "säe")) ; --UNCHK
lin refrain_V = mkWV (k52A "pidättäytyä") ; --UNCHK
lin refresh_V2 = mkWV2 (k53A "elävöittää") ; --UNCHK
lin refresher_N = mkWN (compoundN "jatkokoulutus" (k5 "kurssi")) ; --UNCHK
lin refreshing_A = mkWA (k41A "puhdas") ; --UNCHK
lin refreshment_N = mkWN (k39 "piristys") ; --UNCHK
lin refrigerant_A = mkWA "jäähdyttävä" ; --UNCHK
lin refrigerant_N = mkWN (compoundN "jäähdytys" (k48 "aine")) ; --UNCHK
lin refrigerate_V2 = mkWV2 (k53 "pakastaa") ; --UNCHK
lin refrigeration_N = mkWN (k39 "jäähdytys") ; --UNCHK
lin refrigerator_N = mkWN (compoundN "jää" (k5A "kaappi")) ;
lin refuge_N = mkN "turva" ; --mkWN (compoundN "turva" (k38 "utuminen")) ;
lin refugee_N = mkWN (k38 "pakolainen") ; --UNCHK
lin refulgence_N = mkWN (k48 "loiste") ; --UNCHK
lin refulgent_A = mkWA (k41A "kirkas") ; --UNCHK
lin refund_N = mkWN (k39 "hyvitys") ;
lin refund_V2 = mkV2 "hyvittää" ;
lin refurbish_V2 = mkWV2 (k53 "uudistaa") ; --UNCHK
lin refurnish_V2 = mkWV2 (k53 "kalustaa") "uudelleen" ; --UNCHK
lin refusal_N = mkWN "kieltäytyminen" ; --UNCHK
lin refuse_N = mkWN (k48A "jäte") ; --UNCHK
lin refuse_V = mkV "kieltäytyä" ;
lin refuse_V2 = mkWV2 (k52 "torjua") ;
lin refuse_VV = mkVV "kieltäytyä" infElat ;
lin refuse_collector_N = mkWN (compoundN "roska" (k5 "kuski")) ; --UNCHK
lin refutable_A = mkWA (compoundA "kyseen" (k38 "alainen")) ; --UNCHK
lin refutation_N = mkWN "vääräksi" "osoittaminen" ; --UNCHK
lin refute_V2 = mkWV2 (k53A "osoittaa") ; --UNCHK
lin regain_V2 = mkWV2 (k53A "saavuttaa") ; --UNCHK
lin regal_A = mkWA (k38 "ruhtinaallinen") ; --UNCHK
lin regale_V2 = mkWV2 (k74 "tarjota") ; --UNCHK
lin regalia_N = mkWN (k39 "vaatetus") ; --UNCHK
lin regard_N = mkN "arvostus" ; --mkWN (k48 "katse") ;
lin regard_V = mkWV (k62 "arvioida") ;
lin regard_V2 = mkWV2 (k62 "arvioida") ;
lin regard_VS = mkWVS (k62 "arvioida") ; --UNCHK
lin regardful_A = mkWA (k38 "huomaavainen") ; --UNCHK
lin regarding_Prep = mkPrep partitive "ajatellen" ; --
lin regardless_A = mkWA (k99 "riippumatta") ; --UNCHK
lin regardless_Adv = mkWAdv (k99 "huolimatta") "siitä" ; --UNCHK
lin regardless_of_Prep = mkPrep elative "huolimatta" ;
lin regatta_N = mkWN (k9A "regatta") ; --UNCHK
lin regency_N = mkWN (k10 "asema") "sijaishallitsijan" ; --UNCHK
lin regenerate_A = mkWA (k47 "uudestisyntynyt") ; --UNCHK
lin regenerate_V = mkWV (k53A "kehittää") ; --UNCHK
lin regenerate_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin regeneration_N = mkWN (compoundN "uudis" (k38 "taminen")) ; --UNCHK
lin regensburg_PN = foreignPN "Regensburg" ;
lin regent_A = mkWA (k10 "hallitseva") ; --UNCHK
lin regent_N = mkWN (compoundN "valtion" (k10 "hoitaja")) ; --UNCHK
lin reggae_N = mkWN (k21 "reggae") ; --UNCHK
lin regicide_N = mkWN (compoundN "kuninkaan" (k10 "murha")) ; --UNCHK
lin regime_1_N = mkN "hallinto" ;
lin regime_2_N = variants {} ; --
lin regime_N = variants {} ; --
lin regimen_N = mkWN (compoundN "hoito-" (k10 "ohjelma")) ; --UNCHK
lin regiment_N = mkWN (k5A "rykmentti") ; --UNCHK
lin regiment_V2 = mkWV2 (k73 "määrätä") "rykmenttiin" ; --UNCHK
lin regimental_A = mkWA "rykmentti-" ; --UNCHK
lin regimentals_N = mkWN (compoundN "uni" (k1 "formu")) ; --UNCHK
lin regimentation_N = mkWN (compoundN "kurissa" (k1A "pito")) ; --UNCHK
lin regina_PN = foreignPN "Regina" ;
lin region_N = mkN "alue" ;
lin regional_A = mkWA (k38 "alueellinen") ; --f88
lin regionalism_N = mkWN (k5 "regionalismi") ; --UNCHK
lin register_N = mkWN (k9 "kassa") ; --UNCHK
lin register_V = mkV "kirjoittautua" ; ---ARB --mkWV (k67 "tulla") "ymmärretyksi" ;
lin register_V2 = mkV2 "rekisteröidä" ;
lin registered_A = mkA "rekisteröity" ;
lin registrant_N = mkWN "rekisteröijä" ; --UNCHK
lin registrar_N = mkWN (compoundN "pöytäkirjan" (k10 "pitäjä")) ; --UNCHK
lin registration_N = mkWN (compoundN "kirjo" (k38 "ittautuminen")) ; --UNCHK
lin registry_N = mkWN (k2 "kortisto") ; --UNCHK
lin regnant_A = mkWA (k10 "hallitseva") ; --UNCHK
lin regnellidium_N = mkWN "Regnellidium" "diphyllum" ; --UNCHK
lin regosol_N = mkWN "regosoli" ; --UNCHK
lin regress_N = mkWN (k17 "paluu") ; --UNCHK
lin regress_V = mkWV (k74A "langeta") ; --UNCHK
lin regression_N = mkWN (k17 "paluu") ; --UNCHK
lin regressive_A = mkWA "taantuva" ; --UNCHK
lin regret_N = mkWN (k39 "katumus") ;
lin regret_V2 = mkV2 "katua" partitive ; --mkWV2 vOlla "pahoillaan" ;
lin regret_VS = mkWVS (k67 "olla") "pahoillaan" ; --UNCHK
lin regretful_A = mkWA (k10 "oleva") "pahoillaan" ; --UNCHK
lin regrettable_A = mkWA (k1 "huono") ; --UNCHK
lin regroup_V = mkWV (k53A "ryhmittää") "uudelleen" ; --UNCHK
lin regroup_V2 = mkWV2 (k53A "ryhmittää") "uudelleen" ; --UNCHK
lin regular_A = mkA "säännöllinen" ;
lin regular_N = mkWN (kH1 "koko") "tavallinen" ; --UNCHK
lin regularity_N = mkWN (k40 "säännöllisyys") ; --UNCHK
lin regularization_N = mkWN (k2 "säännöstely") ; --UNCHK
lin regularize_V2 = mkWV2 (k53 "vakinaistaa") ; --UNCHK
lin regulate_V2 = mkV2 (mkV "säädellä") partitive ;
lin regulation_A = mkWA (k38 "mukainen") "sääntöjen" ; --UNCHK
lin regulation_N = mkWN (k2 "säännöstely") ; --f87
lin regulative_A = mkWA (compoundA "sääte" (k10 "levä")) ; --UNCHK
lin regulator_N = mkWN (k33 "tasain") ; --f160 ---ARB
lin regulatory_A = variants {} ; --
lin regum_V2 = mkV2 "regumata" ; ---- typo or parse error? there is a company called "Regumed", maybe it is analyzed as a verb "regum"
lin regur_N = mkWN (compoundN "savi" (k18 "maa")) ; --UNCHK
lin regurgitate_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin regurgitate_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin regurgitation_N = mkWN (compoundN "yrjö" (k38 "äminen")) ; --UNCHK
lin rehabilitate_V2 = mkWV2 (k53A "kuntouttaa") ; --UNCHK
lin rehabilitation_N = mkWN (k39 "kunnostus") ; --UNCHK
lin rehabilitative_A = mkWA "kuntouttava" ; --UNCHK
lin reharmonization_N = mkWN (compoundN "uudelleen" (k39 "sovitus")) ; --UNCHK
lin rehash_N = mkWN (compoundN "toi" (k38 "staminen")) ; --UNCHK
lin rehash_V2 = mkWV2 (k53 "toistaa") ; --UNCHK
lin rehear_V2 = mkWV2 (k67A "käsitellä") "uudelleen" ; --UNCHK
lin rehearing_N = mkWN (compoundN "uudelleen" (k2 "käsittely")) ; --UNCHK
lin rehearsal_N = mkWN (k39 "harjoitus") ; --UNCHK
lin rehearse_V = mkWV (k73A "kerrata") ; --UNCHK
lin rehearse_V2 = mkWV2 (k73A "kerrata") ; --UNCHK
lin rehouse_V2 = mkWV2 (k62 "ympäröidä") "uudelleen" ; --UNCHK
lin reich_N = mkWN "Reich" ; --UNCHK
lin reigate_PN = foreignPN "Reigate" ;
lin reign_N = mkWN (k9A "valta") ; --UNCHK
lin reign_V = mkWV (k69 "hallita") ;
lin reignite_V2 = mkWV2 (k53A "sytyttää") "uudelleen" ; --UNCHK
lin reimburse_V2 = mkWV2 (k73 "korvata") ; --UNCHK
lin reimbursement_N = mkWN (k39 "korvaus") ;
lin reimpose_V2 = mkWV2 (k73 "määrätä") "uudelleen" ; --UNCHK
lin reimposition_N = mkWN (compoundN "uudelleen" (k39 "määräys")) ; --UNCHK
lin rein_N = mkWN (k10 "ohja") ;
lin rein_V2 = mkV2 "hallita" partitive ;
lin rein_in_V2 = mkWV2 (k69 "hillitä") ; --UNCHK
lin reincarnate_V2 = mkWV2 (k53 "uudistaa") ; --UNCHK
lin reincarnation_N = mkWN (compoundN "sielunvaellus" (k5A "oppi")) ; --UNCHK
lin reincarnationism_N = mkWN (compoundN "sielunvaellus" (k5A "oppi")) ; --UNCHK
lin reindeer_N = mkWN (kH1 "poro") ; --UNCHK
lin reindict_V2 = mkV2 (mkV (mkV "syyttää") "uudelleen") ;
lin reinforce_V2 = mkWV2 (k53A "lujittaa") ; --UNCHK
lin reinforcement_N = mkWN (k39 "vahvistus") ; --UNCHK
lin reinstall_V2 = mkWV2 (k54A "asentaa") "uudelleen" ; --UNCHK
lin reinstate_V2 = mkV2 (mkV (mkV "asettaa") "uudelleen") ;
lin reinstatement_N = mkWN (compoundN "pala" (k38 "uttaminen")) ; --UNCHK
lin reinstitute_V2 = mkV2 (mkV (mkV "perustaa") "uudelleen") ;
lin reinsurance_N = mkWN (compoundN "jälleen" (k39 "vakuutus")) ;
lin reinsure_V2 = mkWV2 (compoundV "jälleen" (k53A "vakuuttaa")) ; --UNCHK
lin reintegrate_V2 = mkWV2 (k53 "yhdistää") "uudelleen" ; --UNCHK
lin reinterpret_V2 = mkWV2 (k69 "tulkita") "uudelleen" ; --UNCHK
lin reinterpretation_N = mkWN (compoundN "uudelleen" (k9A "tulkinta")) ; --UNCHK
lin reintroduce_V2 = mkWV2 (k67A "esitellä") "uudestaan" ; --UNCHK
lin reintroduction_N = mkWN (compoundN "uudelleen" (k2 "esittely")) ; --UNCHK
lin reinvent_V2 = mkWV2 (k64 "luoda") "uudelleen" ; --UNCHK
lin reinvest_V2 = mkV2 (mkV (mkV "investoida") "uudelleen") elative ;
lin reinvigorate_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin reisjärvi_PN = mkPN (mkN "Reisjärvi" "Reisjärviä") ;
lin reissue_N = mkWN (compoundN "uusinta" (k39 "painos")) ; --UNCHK
lin reissue_V2 = mkWV2 (k66 "julkaista") "uudelleen" ; --UNCHK
lin reiterate_V2 = mkV2 "toistaa" ;
lin reiterate_VS = mkWVS (k52A "kertoa") "uudelleen" ; --UNCHK
lin reiteration_N = mkWN (compoundN "toi" (k38 "staminen")) ; --UNCHK
lin reject_N = mkWN (k1A "hylky") ; --UNCHK
lin reject_V2 = mkV2 (mkV "hylätä" "hylkäsi") ;
lin rejection_N = mkWN "hylkääminen" ;
lin rejective_A = mkWA (k10 "torjuva") ; --UNCHK
lin rejig_V2 = mkWV2 (k53 "pistää") "uusiksi" ; --UNCHK
lin rejoice_V = mkWV (k53 "juhlistaa") ; --UNCHK
lin rejoice_V2 = mkWV2 (k53 "juhlistaa") ; --UNCHK
lin rejoicing_N = mkWN (compoundN "ilo" (k38 "itseminen")) ; --UNCHK
lin rejoin_V = mkWV (k54A "sivaltaa") ; --UNCHK
lin re_join_V2 = mkWV2 (k54A "sivaltaa") ; --UNCHK
lin rejoinder_N = mkWN (k39 "vastaus") ; --UNCHK
lin rejuvenate_V = mkWV (k52A "nuorentua") ; --UNCHK
lin rejuvenate_V2 = mkWV2 (k52A "nuorentua") ; --UNCHK
lin rejuvenation_N = mkWN (compoundN "nuo" (k38 "rentuminen")) ; --UNCHK
lin rekindle_V = mkWV (k53A "sytyttää") "uudestaan" ; --UNCHK
lin rekindle_V2 = mkWV2 (k53A "sytyttää") "uudestaan" ; --UNCHK
lin relapse_N = mkWN (k99 "uudelleen") "sortuminen" ; --UNCHK
lin relapse_V = mkWV (k52A "pahentua") ; --UNCHK
lin relate_N = variants {} ; --
lin relate_V = mkV "liittyä" | mkV vOlla "yhteydessä" ;
lin relate_V2 = mkV2 "liittää" | mkV2 "suhteuttaa" ;
lin related_A = mkA "liittyvä" ;
lin relatedness_N = mkWN (k40 "sukulaisuus") ; --UNCHK
lin relation_N = mkWN (k48A "suhde") ;
lin relational_A = mkWA (k38 "suhteellinen") ; --UNCHK
lin relations_N = mkWN (k38 "kanssakäyminen") ; --UNCHK
lin relationship_N = mkWN (k48A "suhde") ;
lin relative_A = mkA "suhteellinen" ;
lin relative_N = mkWN (k38 "sukulainen") ; --UNCHK
lin relativism_N = mkWN (k5 "relativismi") ; --UNCHK
lin relativistic_A = mkWA (k38 "relativistinen") ; --UNCHK
lin relativity_N = mkWN (k40 "suhteellisuus") ; --UNCHK
lin relatum_N = mkWN (k3 "olio") ; --UNCHK
lin relax_V = mkV "rentoutua" ;
lin relax_V2 = mkWV2 (k71 "tehdä") "rentoutuneeksi" ; --UNCHK
lin relaxant_A = mkWA "rentouttava" ; --UNCHK
lin relaxant_N = mkWN (k5A "relaksantti") ; --UNCHK
lin relaxation_N = mkWN (k39 "höllennys") "sääntöjen" ; --UNCHK
lin relaxer_N = mkWN "rentouttaja" ; --UNCHK
lin relaxin_N = mkWN "relaksiini" ; --UNCHK
lin relay_N = mkWN (k5 "viesti") ; --UNCHK
lin relay_V2 = mkWV2 (k52A "kertoa") "eteenpäin" ; --UNCHK
lin release_N = mkN "päästäminen" ;
lin release_V2 = mkV2 "julkistaa" ;
lin relegate_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin relegation_N = mkWN (k39 "alennus") ; --UNCHK
lin relent_V = mkWV (k52A "heltyä") ; --UNCHK
lin relentless_A = mkWA (k34A "säälimätön") ; --UNCHK
lin relentlessness_N = mkWN (k40 "taipumattomuus") ; --UNCHK
lin relevance_N = mkWN (k5 "relevanssi") ; --UNCHK
lin relevancy_N = mkWN (k5 "relevanssi") ; --UNCHK
lin relevant_A = mkWA (k38 "merkityksellinen") ; --UNCHK
lin reliability_N = mkWN (k40 "luotettavuus") ; --UNCHK
lin reliable_A = mkWA (k10 "luotettava") ;
lin reliance_N = mkWN (k39 "luottamus") ;
lin reliant_A = mkWA (k38 "riippuvainen") ; --UNCHK
lin relic_N = mkWN (k1 "muisto") ; --UNCHK
lin relict_N = mkWN (k5 "relikti") ; --UNCHK
lin relief_N = mkWN (k39 "helpotus") ; --f66
lin relieve_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin reliever_N = mkWN (k10 "syöttäjä") "toinen" ; --UNCHK
lin religion_N = L.religion_N ;
lin religionism_N = mkWN (k5 "pietismi") ; --UNCHK
lin religionist_N = mkWN (k4A "fanaatikko") ; --UNCHK
lin religiosity_N = mkWN (k5 "pietismi") ; --UNCHK
lin religious_A = mkWA (k38 "kirkollinen") ; --UNCHK
lin religious_N = mkWN (k38 "uskovainen") ; --UNCHK
lin religiousness_N = mkWN (k40 "hengellisyys") ; --UNCHK
lin reline_V2 = mkWV2 (k53 "reunustaa") "uudelleen" ; --UNCHK
lin relinquish_V2 = mkV2 "luopua" elative ; --mkWV2 (k53 "päästää") ;
lin relinquishment_N = mkWN (compoundN "luo" (k38 "puminen")) ; --UNCHK
lin reliquary_N = mkWN (compoundN "pyhäinjäännös" (k41A "lipas")) ; --UNCHK
lin relish_N = mkWN (k1A "maku") "vahva" ; --UNCHK
lin relish_V2 = mkWV2 (k61A "nauttia") ; --UNCHK
lin relish_VS = mkWVS (k61A "nauttia") ; --UNCHK
lin relistening_N = mkWN (compoundN "uudelleen" (k2 "käsittely")) ; --UNCHK
lin relive_V2 = mkWV2 (k53 "elää") "uudelleen" ; --UNCHK
lin reliving_N = mkWN (compoundN "läpi" (k38 "käyminen")) "uudelleen" ; --UNCHK
lin relocate_V = mkWV (k54A "siirtää") ; --UNCHK
lin relocate_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin relocation_N = mkWN (compoundN "sijoi" (k38 "ttaminen")) "uudelleen" ;
lin reluctance_N = mkWN (k40 "innottomuus") ; --UNCHK
lin reluctant_A = mkWA (k34A "haluton") ;
lin reluctivity_N = mkWN (compoundN "ominais" (k39 "vastus")) "magneettinen" ; --UNCHK
lin rely_V = mkWV (k53A "luottaa") ; --f52
lin rely_V2 = variants {} ; -- mkWV (k53A "luottaa") ; --f52
lin rely_on_V = mkWV (k67 "olla") "riippuvainen" ; --UNCHK
lin rely_on_V2V = mkWV2V (k67 "olla") "riippuvainen" ; --UNCHK
lin remain_N = mkN "jäännös" ;
lin remain_V = mkV "jäädä" ;
lin remain_V2 = mkV2 (mkV "pysyä") (mkPrep essive) ;
lin remain_VA = mkVA (mkV "pysyä") (mkPrep essive) ;
lin remain_VV = mkVV "jäädä" infIllat ;
lin remainder_N = mkWN (compoundN "jäännös" (k9 "pala")) ; --UNCHK
lin remaining_A = variants {} ; --
lin remains_N = mkWN (k1A "raato") ; --UNCHK
lin remake_N = mkWN (k5A "filmatisointi") "uusi" ; --UNCHK
lin remake_V2 = mkV2 (mkV (mkV "tehdä") "uudelleen") ;
lin remand_N = mkWN (compoundN "pala" (k38 "uttaminen")) "tutkintavankeuteen" ; --UNCHK
lin remand_V2 = mkWV2 (k53A "palauttaa") ; --UNCHK
lin remark_N = mkN "huomautus" ;
lin remark_V = mkWV (k73 "huomata") ; --UNCHK
lin remark_VS = mkWVS (k73 "huomata") ; --UNCHK
lin remarkable_A = mkA "huomattava" ;
lin remarriage_N = mkWN (compoundN "avio" (k38 "ituminen")) "uudelleen" ; --UNCHK
lin remarry_V = mkWV (k52A "avioitua") "uudelleen" ; --UNCHK
lin remarry_V2 = mkWV2 (k52A "avioitua") "uudelleen" ; --UNCHK
lin remediable_A = mkWA (compoundA "korjaus" (k38 "kelpoinen")) ; --UNCHK
lin remedial_A = mkWA (compoundA "korj" (k9 "aava")) ; --UNCHK
lin remedy_N = mkWN (k39 "parannus") ; --UNCHK
lin remedy_V2 = mkWV2 (k54A "parantaa") ; --UNCHK
lin remember_V = mkV "muistaa" ;
lin remember_V2 = mkV2 "muistaa" ;
lin remember_VS = mkVS "muistaa" ;
lin remembrance_N = mkWN "muistaminen" ; --UNCHK
lin remilitarization_N = mkWN (compoundN "uudelleenmilitari" (k5A "sointi")) ; --UNCHK
lin remilitarize_V2 = mkWV2 (k62 "militarisoida") "uudelleen" ; --UNCHK
lin remind_V2 = mkV2 "muistuttaa" partitive ;
lin reminder_N = mkWN (k39 "muistutus") ;
lin reminisce_V = mkWV (k67 "muistella") ; --UNCHK
lin reminiscence_N = mkWN "muistaminen" ; --UNCHK
lin reminiscent_A = mkWA (compoundA "muis" (k10 "tuttava")) "jstk" ; --UNCHK
lin remise_N = mkWN (compoundN "jatko" (k1 "pisto")) ; --UNCHK
lin remiss_A = mkWA (k34A "huolimaton") ; --UNCHK
lin remission_N = mkWN (compoundN "anteeksi" (k1A "anto")) "synnin" ; --UNCHK
lin remissness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin remit_N = mkWN (k39 "palautus") ; --UNCHK
lin remit_V = mkWV (k52A "lieventyä") ; --UNCHK
lin remit_V2 = mkWV2 (k52A "lieventyä") ; --UNCHK
lin remittance_N = mkWN (k39 "suoritus") ; --UNCHK
lin remittent_A = mkWA "vaihteleva" ; --UNCHK
lin remnant_N = mkWN (compoundN "jäännös" (k9 "pala")) ; --UNCHK
lin remodel_V = mkWV (k73A "rempata") ; --UNCHK
lin remodel_V2 = mkWV2 (k73A "rempata") ; --UNCHK
lin remonstrance_N = mkWN (k39 "vastustus") ; --UNCHK
lin remonstrate_V = mkWV (k73 "saarnata") ; --UNCHK
lin remora_N = mkWN (compoundN "rem" (k10 "ora")) ; --UNCHK
lin remorse_N = mkWN (k39 "katumus") ; --UNCHK
lin remorseful_A = mkWA (k15 "surkea") ; --UNCHK
lin remorseless_A = mkWA (k34A "häikäilemätön") ; --UNCHK
lin remote_A = mkWA (k38 "etäinen") ; --UNCHK
lin remoteness_N = mkWN (k40 "sulkeutuneisuus") ; --UNCHK
lin remould_V2 = mkWV2 (k53A "pinnoittaa") ; --UNCHK
lin remount_N = mkWN (k1 "ratsu") "uusi" ; --UNCHK
lin remount_V = mkWV (k53 "järjestää") "ratsu" ; --UNCHK
lin remount_V2 = mkWV2 (k53 "järjestää") "ratsu" ; --UNCHK
lin removable_A = mkWA "irrotettava" ; --UNCHK
lin removal_N = mkWN (compoundN "ero" (k38 "ttaminen")) ; --UNCHK
lin remove_N = mkWN (k49 "askel") ; --UNCHK
lin remove_V = mkV "poistua" ;
lin remove_V2 = mkV2 "poistaa" ;
lin remover_N = mkWN (compoundN "muutto" (k42 "mies")) ; --UNCHK
lin remscheid_PN = foreignPN "Remscheid" ;
lin remuda_N = mkWN (k9 "lauma") ; --UNCHK
lin remunerate_V2 = mkWV2 (k62 "kompensoida") ; --UNCHK
lin remuneration_N = mkWN (k3 "kompensaatio") ; --UNCHK
lin remunerative_A = mkWA (k10 "tuottoisa") ; --UNCHK
lin renaissance_N = mkWN (k5 "renessanssi") ; --UNCHK
lin renal_A = mkWA (compoundA "rena" (k38 "alinen")) ; --UNCHK
lin rename_V2 = mkWV2 (k75 "nimetä") "uudelleen" ; --UNCHK
lin rename_V3 = mkV3 (mkV (mkV "nimetä") "uudelleen") accusative (mkPrep translative) ;
lin renascence_N = mkWN (k5 "renessanssi") ; --UNCHK
lin renascent_A = mkWA "uudelleen" "voimistuva" ; --UNCHK
lin rend_V2 = mkWV2 (k53A "revähdyttää") ; --UNCHK
lin render_N = mkWN (compoundN "rappaus" (k5 "laasti")) ; --UNCHK
lin render_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin render_VS = mkWVS (k53A "sulattaa") ; --UNCHK
lin rendering_N = mkWN (k9A "tulkinta") ; --UNCHK
lin rendezvous_N = mkWN (k38 "tapaaminen") ; --UNCHK
lin rendezvous_V = mkWV (k73A "kohdata") ; --UNCHK
lin rendezvouse_V = mkV "kohdata" ;
lin rending_A = mkWA (k10 "riipaiseva") ; --UNCHK
lin rendition_N = mkWN (k9A "tulkinta") ; --UNCHK
lin renegadeFem_N = mkWN (k6 "petturi") ; --UNCHK
lin renegadeMasc_N = mkWN (k6 "petturi") ; --UNCHK
lin renegade_V = mkWV (k68 "kapinoida") ; --UNCHK
lin renege_V = mkWV (k52A "rikkoa") "lupaus" ; --UNCHK
lin renegotiate_V2 = mkWV2 (k67 "järjestellä") "uudelleen" ;
lin renew_V2 = mkWV2 (k53 "uudistaa") ; --f60
lin renewable_A = mkWA (compoundA "uusinta" (k38 "kelpoinen")) ; --UNCHK
lin renewal_N = mkWN (k39 "kunnostus") ;
lin renewed_A = variants {} ; --
lin renewing_A = mkWA (compoundA "pal" (k10 "auttava")) ; --UNCHK
lin renfrew_PN = foreignPN "Renfrew" ;
lin reniform_A = mkWA (k38 "munuaismainen") ; --UNCHK
lin renin_N = mkWN "reniini" ; --UNCHK
lin renko_PN = mkPN "Renko" ;
lin rennes_PN = foreignPN "Rennes" ;
lin rennet_N = mkWN (k48A "juoksute") ; --UNCHK
lin rennin_N = mkWN (compoundN "ren" (k26 "niini")) ; --UNCHK
lin renounce_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin renovate_V2 = mkWV2 (k53 "uudistaa") ;
lin renovation_N = mkWN (k39 "saneeraus") ; --UNCHK
lin renovator_N = mkWN (compoundN "kun" (k10 "nostaja")) ; --UNCHK
lin renown_N = mkWN (k40 "julkisuus") ; --UNCHK
lin renowned_A = mkWA (k41A "nimekäs") ; --UNCHK
lin rensselaerite_N = mkWN (k5A "talkki") ; --UNCHK
lin rent_N = mkN "vuokra" ; ---ARB mkWN (k2 "halkaisu") ;
lin rent_V = mkWV (k53A "ottaa") "vuokralle" ; --UNCHK
lin rent_V2 = mkWV2 (k53A "ottaa") "vuokralle" ; --UNCHK
lin rent_collector_N = mkWN (k12 "perijä") "vuokran" ; --UNCHK
lin rent_out_V2 = mkWV2 (k53A "teettää") "alihankintana" ; --UNCHK
lin rentable_A = mkWA "vuokrattava" ; --UNCHK
lin rental_A = mkWA "vuokra-" ; --UNCHK
lin rental_N = mkWN (k10 "vuokra") ;
lin renter_N = mkWN (compoundN "vuokran" (k10 "antaja")) ; --UNCHK
lin rentier_N = mkWN (compoundN "koroilla" (k10 "eläjä")) ; --UNCHK
lin renunciant_A = mkWA (k38 "uhrautuvainen") ; --UNCHK
lin renunciation_N = mkWN (compoundN "luo" (k38 "puminen")) ; --UNCHK
lin reopen_V = mkWV (k73 "avata") "uudelleen" ; --UNCHK
lin reopen_V2 = mkWV2 (k73 "avata") "uudelleen" ; --UNCHK
lin reorder_N = mkWN (compoundN "uudelleen" (k39 "tilaus")) ; --UNCHK
lin reordering_N = mkWN (compoundN "uudelleen" (k2 "järjestely")) ; --UNCHK
lin reorganization_N = mkWN (compoundN "uudelleen" (k2 "järjestely")) ; --f79
lin reorganize_V = mkV (mkV "järjestää") "uudelleen" ;
lin reorganize_V2 = mkV2 "uudelleenorganisoida" ;
lin reorient_V = mkWV (k73A "suunnata") "uudelleen" ; --UNCHK
lin reorient_V2 = mkWV2 (k73A "suunnata") "uudelleen" ; --UNCHK
lin reorientate_V = mkWV (k53 "suunnistaa") "uudelleen" ; --UNCHK
lin reorientate_V2 = mkWV2 (k53 "suunnistaa") "uudelleen" ; --UNCHK
lin reorientation_N = mkWN (compoundN "suunnan" (k39 "muutos")) ; --UNCHK
lin reovirus_N = mkWN (compoundN "reo" (k39 "virus")) ; --UNCHK
lin rep_N = mkWN (k41A "repp-kangas") ; --UNCHK
lin repackage_V2 = mkV2 (mkV (mkV "paketoida") "uudelleen") ;
lin repaint_V2 = mkV2 (mkV (mkV "maalata") "uudelleen") ;
lin repair_N = mkN "korjaus" ;
lin repair_V = mkWV (k53 "virkistää") ; --UNCHK
lin repair_V2 = mkV2 "korjata" ;
lin repairer_N = mkWN (k10 "korjaaja") ; --UNCHK
lin repairman_N = mkWN (k10 "korjaaja") ; --UNCHK
lin repand_A = mkWA (compoundA "aaltoilevareu" (k38 "nainen")) ; --UNCHK
lin reparable_A = mkWA (k10 "oleva") "korjattavissa" ; --UNCHK
lin reparation_N = mkWN (k39 "hyvitys") ; --UNCHK
lin repartee_N = mkWN (compoundN "sana" (k40 "valmius")) ; --UNCHK
lin repass_V2 = mkV2 (mkV (mkV "hyväksyä") "uudelleen") ; ---ARB
lin repast_N = mkWN (k12 "ateria") ; --UNCHK
lin repatriate_V2 = mkWV2 (k53A "kotiuttaa") ; --UNCHK
lin repatriation_N = mkWN (compoundN "pala" (k38 "aminen")) ; --UNCHK
lin repay_V = mkWV (k56 "maksaa") ; --UNCHK
lin repay_V2 = mkWV2 (k56 "maksaa") ; --UNCHK
lin repayable_A = mkWA "takaisin" "maksettava" ; --UNCHK
lin repayment_N = mkN "takaisin" (mkN "maksu") ;
lin repeal_N = mkN "poistaminen" ;
lin repeal_V2 = mkWV2 (k74 "kumota") ;
lin repeat_N = mkWN (k1A "toisinto") ; --UNCHK
lin repeat_V = mkWV (k52 "toistua") ;
lin repeat_V2 = mkV2 "toistaa" ;
lin repeat_VS = mkVS (mkV "toistaa") ;
lin repeatable_A = mkWA (k38 "arvoinen") "siteeraamisen" ; --UNCHK
lin repeated_A = mkA "toistuva" ;
lin repeater_N = mkWN "toistin" ; --UNCHK
lin repechage_N = mkWN (compoundN "repechage-" (k10 "erä")) ; --UNCHK
lin repel_V2 = mkWV2 (k53 "kiistää") ; --UNCHK
lin repellent_A = mkWA (k10 "kestävä") ; --UNCHK
lin repellent_N = mkWN (k48A "karkote") ; --UNCHK
lin repent_V = mkWV (k71 "tehdä") "parannus" ; --UNCHK
lin repent_V2 = mkWV2 (k71 "tehdä") "parannus" ; --UNCHK
lin repentance_N = mkWN (k39 "katumus") ; --UNCHK
lin repentant_A = mkWA "katuva" ; --UNCHK
lin repercussion_N = mkWN (k2 "potkaisu") ; --UNCHK
lin repertoire_N = mkWN (k1 "ohjelmisto") ; --UNCHK
lin repertory_N = mkWN (compoundN "säilytys" (k9A "paikka")) ; --UNCHK
lin repetition_N = mkWN (k39 "kertaus") ; --UNCHK
lin repetitious_A = mkWA "itseään" "toistava" ; --UNCHK
lin repetitive_A = mkWA "itseään" "toistava" ; --UNCHK
lin repetitiveness_N = mkWN (k40 "yksitoikkoisuus") ; --UNCHK
lin repine_V = mkWV (k53A "valittaa") ; --UNCHK
lin replace_V2 = mkV2 "korvata" ;
lin replaceability_N = mkWN (k40 "vaihdettavuus") ; --UNCHK
lin replaceable_A = mkWA (k10 "oleva") "vaihdettavissa" ; --UNCHK
lin replacement_N = mkN "korvaaminen" ;
lin replant_V2 = mkWV2 (k53A "istuttaa") "uudelleen" ; --UNCHK
lin replaster_V2 = mkV2 (mkV (mkV "peittää") "uudelleen") ; ---ARB
lin replay_N = mkWN (k9A "uusinta") ; --UNCHK
lin replay_V2 = mkWV2 (k73 "pelata") "uudelleen" ; --UNCHK
lin replenish_V2 = mkWV2 (k53A "täyttää") "uudelleen" ; --UNCHK
lin replenishment_N = mkWN (k39 "täydennys") ; --UNCHK
lin replete_A = mkA "täynnä" ;
lin repletion_N = mkWN (k2 "mässäily") ; --UNCHK
lin replica_N = mkWN (k13 "replika") ; --UNCHK
lin replicate_V2 = mkWV2 (k53 "toistaa") ; --UNCHK
lin replication_N = mkWN (compoundN "kop" (k38 "ioiminen")) ; --UNCHK
lin replot_PN = mkPN "Raippaluoto" ;
lin reply_N = mkWN (k48 "vastine") ; --UNCHK
lin reply_V = mkWV (k73 "vastata") ; --UNCHK
lin reply_VS = mkWVS (k73 "vastata") ;
lin repoint_V2 = mkWV2 (k73 "saumata") ; --UNCHK
lin repond_V = mkV "vastata" ;
lin report_N = mkN "raportti" ;
lin report_V = mkV "raportoida" ;
lin report_V2 = mkV2 "raportoida" elative ;
lin report_VS = mkVS "raportoida" ;
lin report_in_V = advV OP_report_V OP_in_Adv ; -- guess-p-verb
lin reportable_A = mkWA "ilmoitettava" ; --UNCHK
lin reportage_N = mkWN (compoundN "uuti" (k5A "sointi")) ; --UNCHK
lin reportedly_Adv = mkWAdv (k99 "mukaan") "saatujen" "tietojen" ; --UNCHK
lin reporterFem_N = mkWN (k10 "toimittaja") ; --f73
lin reporterMasc_N = mkN "reportteri" ;
lin repose_N = mkWN (k1A "lepo") ; --UNCHK
lin repose_V = mkWV (k56A "laittaa") ; --UNCHK
lin repose_V2 = mkWV2 (k56A "laittaa") ; --UNCHK
lin reposeful_A = mkWA (k38 "levollinen") ; --UNCHK
lin repositing_N = mkWN (k5A "varastointi") ; --UNCHK
lin reposition_V2 = mkV2 (mkV (mkV "asettaa") "paikalleen") ;
lin repositioning_N = mkN "uudelleensijoittaminen" ;
lin repository_N = mkWN (k1 "säilö") ; --UNCHK
lin repossess_V2 = mkV2 (mkV (mkV "omistaa") "uudelleen") ;
lin repossession_N = mkWN (compoundN "haltuun" (k1A "otto")) ; --UNCHK
lin repot_V2 = mkWV2 (k53A "istuttaa") ; --UNCHK
lin repp_N = mkWN (k41A "repp-kangas") ; --UNCHK
lin reprehend_V2 = mkWV2 (k61A "moittia") ; --UNCHK
lin reprehensibility_N = mkWN (compoundN "tuo" (k40 "mittavuus")) ; --UNCHK
lin reprehensible_A = mkWA (k38 "paheellinen") ; --UNCHK
lin represent_V = mkV "edustaa" | mkV "merkitä" ;
lin represent_V2 = mkV2 "edustaa" partitive ;
lin representable_A = mkWA "edustettava" ; --UNCHK
lin representation_N = mkWN (compoundN "edus" (k38 "taminen")) ;
lin representational_A = mkWA (k10 "kuvaava") ; --UNCHK
lin representativeFem_N = variants {} ; ---- sense to be split
lin representativeMasc_N = mkN "edustaja" ;
lin representative_A = mkWA (k10 "edustava") ; --UNCHK
lin repress_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin repression_N = mkWN "tukahduttaminen" ;
lin repressive_A = mkWA (compoundA "ehkäis" (k10 "evä")) ; --UNCHK
lin repressor_N = mkWN "alistaja" ; --UNCHK
lin reprieve_N = mkWN (k9A "armonaika") ; --UNCHK
lin reprieve_V2 = mkWV2 (k53A "armahtaa") ; --UNCHK
lin reprimand_N = mkWN (k39 "ojennus") ; --UNCHK
lin reprimand_V2 = mkWV2 (k67 "arvostella") ; --UNCHK
lin reprint_N = mkWN (compoundN "eri" (k39 "painos")) ; --UNCHK
lin reprint_V2 = mkWV2 (k66 "julkaista") "uudelleen" ; --UNCHK
lin reprisal_N = mkWN (k1 "kosto") ; --UNCHK
lin reproach_N = mkWN (k48A "moite") ; --UNCHK
lin reproach_V2 = mkWV2 (k67A "nuhdella") ; --UNCHK
lin reproachful_A = mkWA (k10 "arvosteleva") ; --UNCHK
lin reprobate_N = mkWN (k39 "lurjus") ; --UNCHK
lin reprobate_V2 = mkWV2 (k73A "hylätä") ; --UNCHK
lin reprobation_N = mkWN (k9A "paheksunta") ; --UNCHK
lin reproduce_V = mkWV (k56 "jatkaa") "sukua" ; --UNCHK
lin reproduce_V2 = mkWV2 (k56 "jatkaa") "sukua" ; --UNCHK
lin reproducer_N = mkWN (compoundN "toisto" (k10 "järjestelmä")) ; --UNCHK
lin reproducibility_N = mkWN "uusittavuus" ; --UNCHK
lin reproducible_A = mkWA (compoundA "yhden" (k38 "mukainen")) ; --UNCHK
lin reproduction_N = mkWN (compoundN "lisä" (k38 "äntyminen")) ; --UNCHK
lin reproductive_A = mkWA (compoundA "lisääntymisky" (k38 "kyinen")) ; --UNCHK
lin reproof_N = mkWN (k39 "ojennus") ; --UNCHK
lin reproof_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin reprove_V2 = mkWV2 (k61A "moittia") ; --UNCHK
lin reprovingly_Adv = mkWAdv (k99 "moittivasti") ; --UNCHK
lin reptile_N = mkWN (k12 "matelija") ; --UNCHK
lin reptilian_A = mkWA "matelija-" ; --UNCHK
lin reptilian_N = mkWN (k12 "matelija") ; --UNCHK
lin republic_N = mkWN (k2 "yhteisö") ; --UNCHK
lin republican_A = mkWA (k38 "republikaaninen") ;
lin republican_N = mkWN "Republican" "River" ; --UNCHK
lin republication_N = mkWN (compoundN "uudelleen" (k2 "julkaisu")) ; --UNCHK
lin repudiate_V2 = mkWV2 (k52 "torjua") ; --UNCHK
lin repudiation_N = mkWN (compoundN "paljas" (k38 "taminen")) "valheellisuuden" ; --UNCHK
lin repudiative_A = mkWA (k10 "torjuva") ; --UNCHK
lin repugnance_N = mkWN (k1 "kammo") ; --UNCHK
lin repugnant_A = mkWA (k10 "luotaantyöntävä") ; --UNCHK
lin repulse_N = mkWN (k9A "torjunta") ; --UNCHK
lin repulse_V2 = mkWV2 (k52 "torjua") ; --UNCHK
lin repulsion_N = mkWN (k9A "torjunta") ; --UNCHK
lin repulsive_A = mkWA "hylkivä" ; --UNCHK
lin repurchase_V2 = mkWV2 (k53 "lunastaa") ;
lin reputable_A = mkWA (compoundA "hyvä" (k38 "maineinen")) ;
lin reputation_N = mkWN (k48 "maine") ;
lin repute_N = mkWN (k48 "maine") ; --UNCHK
lin repute_V2 = mkWV2 (k52 "katsoa") ; --UNCHK
lin repute_V2V = mkWV2V (k52 "katsoa") ; --UNCHK
lin reputed_A = variants {} ;
lin request_N = mkN "pyyntö" ;
lin request_V2 = mkV2 (mkV "pyytää") partitive ;
lin request_VS = mkWVS (k52 "anoa") ; --UNCHK
lin requiem_N = mkWN "Requiem" ; --UNCHK
lin requiescat_N = mkWN (k39 "rukous") ; --UNCHK
lin require_V = mkV vOlla "vaatimuksena" ;
lin require_V2 = mkV2 "vaatia" ;
lin require_V2V = mkV2V (mkV "vaatia") ;
lin require_VS = mkVS (mkV "vaatia") ;
lin required_A = variants {} ; --
lin requirement_N = mkN "vaatimus" ;
lin requisite_A = mkWA (k34A "välttämätön") ; --UNCHK
lin requisite_N = mkWN (k48A "tarve") ; --UNCHK
lin requisiteness_N = mkWN (k40 "pakollisuus") ; --UNCHK
lin requisition_N = mkWN (compoundN "pakko" (k39 "luovutus")) ; --UNCHK
lin requisition_V2 = mkWV2 (k73 "määrätä") ; --UNCHK
lin requital_N = mkWN (k9A "palkka") ; --UNCHK
lin requite_V2 = mkWV2 (k56 "maksaa") "takaisin" ; --UNCHK
lin reread_V2 = mkWV2 (k58A "lukea") "uudelleen" ; --UNCHK
lin rerebrace_N = mkWN (k13 "haarniska") ; --UNCHK
lin reredos_N = mkWN (compoundN "alttari" (k1 "taulu")) ; --UNCHK
lin reroute_V2 = mkV2 (mkV (mkV "ohjata") "kiertotielle") ;
lin rerun_N = mkWN (k9A "uusinta") ; --UNCHK
lin res_N = mkWN (compoundN "retikuloendoteliaali" (k10 "järjestelmä")) ; --UNCHK
lin resale_N = mkWN (compoundN "jälleen" (k5A "myynti")) ; --UNCHK
lin reschedule_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin rescind_V2 = mkWV2 (k74 "kumota") ;
lin rescindable_A = mkWA (compoundA "kum" (k10 "ottava")) ; --UNCHK
lin rescript_N = mkWN (k3 "versio") "paranneltu" ; --UNCHK
lin rescue_N = mkWN (k39 "vapahdus") ; --UNCHK
lin rescue_V2 = mkWV2 (k53 "pelastaa") ;
lin rescuerFem_N = mkWN (k10 "pelastaja") ; --UNCHK
lin rescuerMasc_N = mkWN (k10 "pelastaja") ; --UNCHK
lin research_N = mkN "tutkimus" ;
lin research_V = mkWV (k58A "hakea") ; --UNCHK
lin research_V2 = mkWV2 (k58A "hakea") ; --UNCHK
lin researcherFem_N = variants {} ; ---- sense to be split
lin researcherMasc_N = mkN "tutkija" ;
lin reseau_N = mkWN (compoundN "värimosaiikkiruud" (k1A "ukko")) ; --UNCHK
lin resection_N = mkWN "resektio" ; --UNCHK
lin reseda_N = mkWN "mignonette" ; --UNCHK
lin reseed_V2 = mkWV2 (k54A "siementää") ; --UNCHK
lin resell_V2 = mkWV2 (compoundV "jälleen" (k63 "myydä")) ;
lin resemblance_N = mkWN (k40 "yhtäläisyys") ;
lin resemble_V2 = mkWV2 (k53A "muistuttaa") ; --UNCHK
lin resent_V2 = mkWV2 (k67 "olla") "katkera" ; --UNCHK
lin resent_VS = mkWVS (k67 "olla") "katkera" ; --UNCHK
lin resentful_A = mkWA (k38 "kaunainen") ; --UNCHK
lin resentment_N = mkWN (k9 "viha") ; --UNCHK
lin reserpine_N = mkWN "Serpasil" ; --UNCHK
lin reservation_N = mkWN (k39 "varaus") ; --UNCHK
lin reserve_N = mkN "reservi" ;
lin reserve_V = mkV (mkV "esittää") "varaus" ;
lin reserve_V2 = mkV2 "varata" ;
lin reservedly_Adv = mkWAdv (k99 "pidättyväisesti") ; --UNCHK
lin reservist_N = mkWN (k38 "reserviläinen") ; --UNCHK
lin reservoir_N = mkWN (k3 "säiliö") ; --UNCHK
lin reset_N = mkWN (compoundN "nol" (k9 "laaja")) ; --UNCHK
lin reset_V = mkWV (k53A "asettaa") "uudelleen" ; --UNCHK
lin reset_V2 = mkWV2 (k53A "asettaa") "alkutilaan" ;
lin resettle_V = mkWV (k53A "muuttaa") ; --UNCHK
lin resettle_V2 = mkWV2 (k53A "muuttaa") ; --UNCHK
lin resettlement_N = mkWN (compoundN "asu" (k38 "ttaminen")) "uudelleen" ; --UNCHK
lin resh_N = mkWN "reš" ; --UNCHK
lin reshape_V2 = mkWV2 (k53 "uudistaa") ;
lin reshipment_N = mkWN (compoundN "uudelleen" (k39 "lähetys")) ; --UNCHK
lin reshuffle_N = mkWN (k39 "sekoitus") "uusi" ; --UNCHK
lin reshuffle_V2 = mkWV2 (k53 "järjestää") "uudelleen" ; --UNCHK
lin reside_V = mkWV (k67 "majailla") ; --UNCHK
lin residence_N = mkN "koti" (mkN "paikka") ; --mkWN (k2 "oleskelu") ;
lin residency_N = mkWN (compoundN "erikoistumis" (k1 "jakso")) ; --UNCHK
lin resident_A = mkWA "vakituisesti" "asuva" ; --UNCHK
lin resident_N = mkN "asukas" ;
lin residential_A = mkWA "asuin-" ; --UNCHK
lin residual_A = mkWA "jäljelle" "jäävä" ; --UNCHK
lin residual_N = mkWN (compoundN "uusinta" (k3 "palkkio")) ; --UNCHK
lin residuary_A = mkWA "jäljelle" "jäävä" ; --UNCHK
lin residue_N = mkWN (k39 "jäännös") ; --UNCHK
lin resign_V = mkV "luopua" ;
lin resign_V2 = mkV2 "luopua" elative ;
lin resignation_N = mkN "irtisanoutuminen" ;
lin resilience_N = mkWN (k40 "kimmoisuus") ; --UNCHK
lin resiliency_N = mkWN (k40 "kimmoisuus") ; --UNCHK
lin resilient_A = mkWA (k10 "jäntevä") ; --UNCHK
lin resin_N = mkWN (k5 "hartsi") ; --UNCHK
lin resinated_A = mkWA "hartsattu" ; --UNCHK
lin resinlike_A = mkWA (compoundA "hartsi" (k38 "mainen")) ; --UNCHK
lin resinoid_N = mkWN "resinoidi" ; --UNCHK
lin resinous_A = mkWA (k38 "pihkainen") ; --UNCHK
lin resist_V = mkWV (k53 "vastustaa") ; --UNCHK
lin resist_V2 = mkWV2 (k53 "vastustaa") ; --UNCHK
lin resist_VV = mkWVV (k53 "vastustaa") ; ---???
lin resistance_N = mkWN (k39 "vastustus") ;
lin resistant_A = mkWA (k10 "kestävä") ; --UNCHK
lin resister_N = mkWN (k38 "vihollinen") ; --UNCHK
lin resistible_A = mkWA (k10 "siedettävä") ; --UNCHK
lin resistive_A = mkWA "vastustava" ; --UNCHK
lin resistivity_N = mkWN (k5 "impedanssi") ; --UNCHK
lin resistless_A = mkWA (k34A "vastustamaton") ; --UNCHK
lin resistor_N = mkWN (k39 "vastus") ; --UNCHK
lin resold_V2 = mkV2 "jälleenmyydä" ;
lin resole_V2 = mkWV2 (compoundV "puoli" (k73 "pohjata")) ; --UNCHK
lin resolute_A = mkWA (k34A "peräänantamaton") ; --UNCHK
lin resoluteness_N = mkWN (k40 "lujuus") ; --UNCHK
lin resolution_N = mkWN (k2 "ratkaisu") ;
lin resolvable_A = mkWA "ratkaistava" ; --UNCHK
lin resolve_N = mkWN (k40 "lujuus") ; --UNCHK
lin resolve_V = mkV "selvitä" ; --mkWV (k53A "liuottaa") ;
lin resolve_V2 = mkV2 "ratkaista" ;
lin resonance_N = mkWN "sointuvuus" ; --UNCHK
lin resonant_A = mkWA (compoundA "muis" (k10 "tuttava")) "jstk" ; --UNCHK
lin resonate_V = mkWV (k63 "saada") "vastakaikua" ; --UNCHK
lin resonate_V2 = mkWV2 (k63 "saada") "vastakaikua" ; --UNCHK
lin resonator_N = mkWN (k6 "resonaattori") ; --UNCHK
lin resorcinol_N = mkWN "resorsinoli" ; --UNCHK
lin resorption_N = mkWN "imeytyminen" ; --UNCHK
lin resort_N = mkN "turvautuminen" ; ---ARB mkN "resortti"
lin resort_V = mkWV (k52A "siirtyä") ; --UNCHK
lin resound_V = mkWV (k68 "metelöidä") ; --UNCHK
lin resound_V2 = mkWV2 (k68 "metelöidä") ; --UNCHK
lin resoundingly_Adv = mkWAdv (compoundAdv "raikuv" (k99 "asti")) ; --UNCHK
lin resource_N = mkWN (k9 "vara") ;
lin resourceful_A = mkWA (k41 "kekseliäs") ; --UNCHK
lin resourcefulness_N = mkWN (k40 "neuvokkuus") ; --UNCHK
lin resourceless_A = mkWA (k10 "köyhä") ; --UNCHK
lin respect_N = mkWN (k39 "kunnioitus") ;
lin respect_V2 = mkWV2 (k53A "pitää") "arvossa" ; --UNCHK
lin respectability_N = mkWN (k40 "kunniallisuus") ; --UNCHK
lin respectable_A = mkWA (k38 "kunniallinen") ; --UNCHK
lin respecter_N = mkWN (compoundN "arv" (k10 "ostaja")) ; --UNCHK
lin respectful_A = mkWA (k10 "kunnioittava") ; --UNCHK
lin respective_A = mkA "vastaava" ;
lin respiration_N = mkWN (k39 "hengitys") "sisäinen" ; --UNCHK
lin respirator_N = mkWN (compoundN "hengitys" (k33 "suojain")) ; --UNCHK
lin respiratory_A = mkWA "hengitys-" ; --UNCHK
lin respire_V = mkWV (k66 "henkäistä") ; --UNCHK
lin respite_N = mkWN (k5 "paussi") ; --UNCHK
lin respite_V2 = mkWV2 (k73A "lykätä") ; --UNCHK
lin resplendence_N = mkWN (k40 "upeus") ; --UNCHK
lin resplendency_N = mkWN (k40 "upeus") ; --UNCHK
lin resplendent_A = mkWA (k10 "mahtava") ; --UNCHK
lin respond_V = mkWV (k73 "vastata") ;
lin respond_VS = mkWVS (k73 "vastata") ;
lin respondent_N = mkWN (k10 "vastaaja") ; --UNCHK
lin response_N = mkN "vastaus" ;
lin responsibility_N = mkN (lin NK {s = d17 "vastuu"}) ;
lin responsible_A = mkWA (k38 "vastuullinen") ;
lin responsive_A = mkWA (k38 "vastaanottavainen") ;
lin responsiveness_N = mkWN (k40 "vastaanottavaisuus") ; --UNCHK
lin rest_N = mkWN (k1A "lepo") ;
lin rest_V2 = mkWV2 (k73A "levätä") ; --UNCHK
lin rest_VS = mkWVS (k73A "levätä") ; --UNCHK
lin rest_day_N = mkWN (compoundN "lepo" (k10 "päivä")) ; --UNCHK
lin rest_home_N = mkWN (k12 "hoitola") ; --UNCHK
lin rest_house_N = mkWN (compoundN "lepo" (k5A "koti")) ; --UNCHK
lin restart_V = mkWV (k53 "käynnistää") "uudelleen" ; --UNCHK
lin restart_V2 = mkWV2 (k53 "käynnistää") "uudelleen" ; --UNCHK
lin restate_V2 = mkWV2 (k52A "kertoa") "uudelleen" ; --UNCHK
lin restate_V2V = mkWV2V (k52A "kertoa") "uudelleen" ; --UNCHK
lin restatement_N = mkWN (k1A "lausunto") "korjattu" ; --UNCHK
lin restaurant_N = L.restaurant_N ;
lin restaurateur_N = mkWN (k12 "ravintoloitsija") ; --UNCHK
lin rester_N = mkWN "lepääjä" ; --UNCHK
lin restful_A = mkWA (k38 "levollinen") ; --UNCHK
lin restfulness_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin restharrow_N = mkWN (compoundN "rento-o" (k1A "rakko")) ; --UNCHK
lin restitution_N = mkWN (k39 "palautus") ; --UNCHK
lin restive_A = mkWA (k34A "levoton") ; --UNCHK
lin restiveness_N = mkWN (k40 "levottomuus") ; --UNCHK
lin restless_A = mkWA (k34A "rauhaton") ; --UNCHK
lin restlessness_N = mkWN (k40 "hermostuneisuus") ; --UNCHK
lin restock_V2 = mkWV2 (k61A "hankkia") "täydennystä" ; --UNCHK
lin restoration_N = mkWN (k39 "palautus") ;
lin restorative_A = mkWA "parantava" ; --UNCHK
lin restorative_N = mkWN (compoundN "parannus" (k1 "keino")) ; --UNCHK
lin restore_V2 = mkWV2 (k53A "elävöittää") ; --f52
lin restorer_N = mkWN (compoundN "kun" (k10 "nostaja")) ; --UNCHK
lin restrain_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin restrainer_N = mkWN (k10 "johtaja") ; --UNCHK
lin restraint_N = mkWN (k39 "rajoitus") ; --UNCHK
lin restrict_V = mkWV (k54A "tarkentaa") ; --UNCHK
lin restrict_V2 = mkV2 "rajoittaa" ;
lin restricted_A = variants {} ; --
lin restriction_N = mkN "rajoitus" ;
lin restrictive_A = mkWA "rajoittava" ;
lin restrictiveness_N = mkWN (k40 "tiukkuus") ; --UNCHK
lin restructure_V = mkV (mkV "järjestyä") "uudelleen" ;
lin restructure_V2 = mkWV2 (k53 "muodostaa") "uudelleen" ; --UNCHK
lin restructure_V2V = mkWV2V (k53 "muodostaa") "uudelleen" ; --UNCHK
lin result_N = mkN "tulos" ;
lin result_V = mkV "seurata" ; ---- subcat
lin resultant_N = mkWN (k5A "resultantti") ; --UNCHK
lin resulting_A = mkA "tuloksenaoleva" ;
lin resume_N = mkWN (compoundN "ansio" (k2 "luettelo")) ; --UNCHK
lin resume_V = mkWV (k53 "käynnistää") "uudelleen" ; --UNCHK
lin resume_V2 = mkWV2 (k53 "käynnistää") "uudelleen" ;
lin resumption_N = mkWN "uudelleen" "aloittaminen" ; --UNCHK
lin resurface_V = mkWV (k52 "ilmestyä") "takaisin" ; --UNCHK
lin resurface_V2 = mkWV2 (k52 "ilmestyä") "takaisin" ; --UNCHK
lin resurgence_N = mkWN (k1 "nousu") "uusi" ; --UNCHK
lin resurgent_A = mkWA "uudelleen" "voimistuva" ; --UNCHK
lin resurrect_V = mkWV (k73 "herätä") "henkiin" ; --UNCHK
lin resurrect_V2 = mkWV2 (k73 "herätä") "henkiin" ; --UNCHK
lin resurrection_N = mkWN "henkiin" "herättäminen" ; --UNCHK
lin resurvey_N = mkWN (compoundN "uudelleen" (k39 "selvitys")) ; --UNCHK
lin resuscitate_V = mkWV (k67 "tulla") "tajuihinsa" ; --UNCHK
lin resuscitate_V2 = mkWV2 (k67 "tulla") "tajuihinsa" ; --UNCHK
lin resuscitation_N = mkWN (k39 "elvytys") ; --UNCHK
lin resuscitator_N = mkWN (compoundN "hengitys" (k48 "kone")) ; --UNCHK
lin resuspension_N = mkWN "uudelleen" "keskeyttäminen" ; --UNCHK
lin ret_V2 = mkWV2 (k53A "liottaa") ; --UNCHK
lin retail_A = variants {} ; --
lin retail_N = mkWN (k5A "myynti") ; --UNCHK
lin retail_V = mkV vOlla "myytävänä" ; --f56
lin retail_V2 = mkWV2 (k52A "asettua") ; --UNCHK
lin retailer_N = mkWN (compoundN "jälleen" (k10 "myyjä")) ; --f98
lin retailing_N = mkWN (compoundN "vähittäis" (k9A "kauppa")) ; --UNCHK
lin retain_V2 = mkV2 "pitää" ;
lin retainer_N = mkWN (compoundN "hammas" (k7A "tuki")) ; --UNCHK
lin retake_N = mkWN (compoundN "uusinta" (k1A "otto")) ; --UNCHK
lin retake_V2 = mkWV2 (k61 "uusia") ; --UNCHK
lin retaliate_V = mkV (mkV "vastata") "samalla mitalla" ;
lin retaliation_N = mkWN (k1 "kosto") ; --UNCHK
lin retaliatory_A = mkWA "rankaiseva" ; --UNCHK
lin retard_V2 = mkWV2 (k53A "jarruttaa") ; --UNCHK
lin retardant_N = mkWN "retardaatio" ; --UNCHK
lin retardation_N = mkWN (k48 "viive") ; --UNCHK
lin retch_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin retell_V2 = mkWV2 (k53A "kirjoittaa") "uudelleen" ; --UNCHK
lin retem_N = mkWN (k10 "kataja") ; --UNCHK
lin retention_N = mkWN "pitäminen" ; --UNCHK
lin retentive_A = mkWA (k10 "kestävä") ; --UNCHK
lin retentiveness_N = mkWN (k40 "pitävyys") ; --UNCHK
lin retford_PN = foreignPN "Retford" ;
lin rethink_N = mkWN (compoundN "uudelleen" (k9A "harkinta")) ; --UNCHK
lin rethink_V = mkWV (k53A "muuttaa") "mieltään" ; --UNCHK
lin rethink_V2 = mkWV2 (k53A "muuttaa") "mieltään" ; --UNCHK
lin reticence_N = mkWN (k40 "vaiteliaisuus") ; --UNCHK
lin reticent_A = mkWA (k38 "pidättyväinen") ; --UNCHK
lin reticle_N = mkWN (compoundN "hius" (k5 "risti")) ; --UNCHK
lin reticulate_A = mkWA (compoundA "verkko" (k38 "mainen")) ; --UNCHK
lin reticulation_N = mkWN (compoundN "verkko" (k38 "kuvioituminen")) ; --UNCHK
lin reticule_N = mkWN (compoundN "hius" (k5 "risti")) ; --UNCHK
lin reticulocyte_N = mkWN "retikulosyytti" ; --UNCHK
lin reticulum_N = mkWN (compoundN "verkko" (k9 "maha")) ; --UNCHK
lin retina_N = mkWN (compoundN "verkko" (k1 "kalvo")) ; --UNCHK
lin retinal_A = mkWA "verkkokalvo-" ; --UNCHK
lin retinene_N = mkWN (k5A "pigmentti") ; --UNCHK
lin retinitis_N = mkWN (compoundN "verkkokalvo" (k39 "tulehdus")) ; --UNCHK
lin retinoblastoma_N = mkWN (compoundN "retinoblasto" (k10 "oma")) ; --UNCHK
lin retinopathy_N = mkWN (compoundN "verkkokalvo" (k40 "sairaus")) ; --UNCHK
lin retinue_N = mkWN (k48 "seurue") ; --UNCHK
lin retire_V = mkV "vetäytyä" ;
lin retire_V2 = mkV2 (mkV (mkV "vetää") "pois") ;
lin retired_A = mkA "eläkkeelläoleva" ;
lin retiree_N = mkWN (k38 "eläkeläinen") ; --UNCHK
lin retirement_N = mkWN "vetäytyminen" ;
lin retool_V2 = mkWV2 (k61 "uusia") "kalusto" ; --UNCHK
lin retort_N = mkWN (compoundN "tislaus" (k1 "pullo")) ; --UNCHK
lin retort_V2 = mkWV2 (k54A "sivaltaa") ; --UNCHK
lin retort_VS = mkWVS (k54A "sivaltaa") ; --UNCHK
lin retouch_V2 = mkWV2 (k62 "retusoida") ; --UNCHK
lin retrace_V2 = mkWV2 (k54A "jäljentää") ; --UNCHK
lin retract_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin retract_V2 = mkWV2 (k53A "peruuttaa") ; --UNCHK
lin retractable_A = mkWA "sisäänvedettävä" ; --UNCHK
lin retractile_A = mkWA "sisäänvedettävä" ; --UNCHK
lin retraction_N = mkWN "sisään" "vetäminen" ; --UNCHK
lin retractor_N = mkWN (compoundN "haavan" (k33A "levitin")) ; --UNCHK
lin retraining_N = mkWN (compoundN "uudelleen" (k39 "koulutus")) ; --UNCHK
lin retral_A = mkWA "taaksepäin" "suuntautuva" ; --UNCHK
lin retransmit_V2 = mkWV2 (k53A "lähettää") "uudelleen" ; --UNCHK
lin retread_N = mkWN (k41A "rengas") "uudelleen" "pinnoitettu" ; --UNCHK
lin retread_V2 = mkWV2 (k53A "pinnoittaa") ; --UNCHK
lin retreat_N = mkWN "vetäytyminen" ; --UNCHK
lin retreat_V = mkWV (k53A "peruuttaa") ; --UNCHK
lin retreatant_N = mkWN "vetäytyjä" ; --UNCHK
lin retrench_V = mkWV (k73A "leikata") ; --UNCHK
lin retrench_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin retrenchment_N = mkWN (compoundN "säästö" (k25 "toimi")) ; --UNCHK
lin retrial_N = mkN "uudelleen" (mkN "käsittely") ;
lin retribution_N = mkWN (k39 "rangaistus") ; --UNCHK
lin retributive_A = mkWA "rankaiseva" ; --UNCHK
lin retrievable_A = mkWA (k10 "oleva") "haettavissa" ; --UNCHK
lin retrieval_N = mkWN (k38 "saaminen") "takaisin" ; --UNCHK
lin retrieve_V = mkWV (k64 "tuoda") "mieleen" ; --UNCHK
lin retrieve_V2 = mkWV2 (k64 "tuoda") "mieleen" ; --UNCHK
lin retriever_N = mkWN (k10 "noutaja") ; --UNCHK
lin retro_N = mkWN "retro" ; --UNCHK
lin retroactive_A = mkWA "takautuva" ; --UNCHK
lin retrofit_N = mkWN (compoundN "jälkikäteis" (k39 "asennus")) ; --UNCHK
lin retrofit_V2 = mkWV2 (k54A "asentaa") "jälkikäteen" ; --UNCHK
lin retroflection_N = mkWN (compoundN "taakse" (k39 "taivutus")) ; --UNCHK
lin retroflex_A = mkWA (compoundA "kakumina" (k38 "alinen")) ; --UNCHK
lin retrograde_A = mkWA "retrogradinen" ; --UNCHK
lin retrograde_V = mkWV (k72A "heiketä") ; --UNCHK
lin retrogress_V = mkWV (k74A "langeta") ; --UNCHK
lin retrogression_N = mkWN (k17 "paluu") ; --UNCHK
lin retrogressive_A = mkWA "taantuva" ; --UNCHK
lin retronym_N = mkWN "retronyymi" ; --UNCHK
lin retrorocket_N = mkWN (compoundN "raketti" (k6 "moottori")) ; --UNCHK
lin retrorse_A = mkWA "taakse" "kääntyvä" ; --UNCHK
lin retrospect_N = mkWN (k2 "tarkastelu") "jälkikäteen" ; --UNCHK
lin retrospection_N = mkWN (k2 "muistelu") "menneiden" ; --UNCHK
lin retrospective_A = mkWA (k38 "retrospektiivinen") ; --UNCHK
lin retrospective_N = mkWN (k2 "näyttely") "retrospektiivinen" ; --UNCHK
lin retrousse_A = mkWA (k1 "pysty") ; --UNCHK
lin retroversion_N = mkWN (k17 "paluu") ; --UNCHK
lin retrovirus_N = mkWN (compoundN "retro" (k39 "virus")) ; --UNCHK
lin retrovision_N = mkWN "katsaus" "menneisyyteen" ; --UNCHK
lin retsina_N = mkWN (k13 "retsina") ; --UNCHK
lin return_N = mkWN (k17 "paluu") ;
lin return_V = mkV "palata" ;
lin return_V2 = mkV2 "palauttaa" ;
lin returnable_A = mkWA "palautettava" ; --UNCHK
lin reunification_N = mkWN (compoundN "uudelleen" (k38 "yhdistyminen")) ; --UNCHK
lin reunion_N = mkWN (compoundN "uudelleen" (k38 "yhdistyminen")) ; --UNCHK
lin reunite_V = mkWV (k52 "yhdistyä") "uudelleen" ; --UNCHK
lin reunite_V2 = mkWV2 (k52 "yhdistyä") "uudelleen" ; --UNCHK
lin reuptake_N = mkWN (compoundN "kulu" (k38 "ttaminen")) "uudelleen" ; --UNCHK
lin rev_N = mkWN (compoundN "pyörimis" (k40 "nopeus")) ; --UNCHK
lin rev_V = mkWV (k53A "revittää") ; --UNCHK
lin rev_V2 = mkWV2 (k53A "revittää") ; --UNCHK
lin revaluation_N = mkWN (k39 "tarkastus") ; --UNCHK
lin revalue_V2 = mkWV2 (k62 "revalvoida") ; --UNCHK
lin revamp_V2 = mkWV2 (k73A "rukata") ; --UNCHK
lin reveal_V2 = mkV2 (mkV "paljastaa") ;
lin reveal_VS = mkVS (mkV "paljastaa") ;
lin reveille_N = mkWN (k39 "herätys") ; --UNCHK
lin revel_N = mkWN (k9A "juhlinta") ; --UNCHK
lin revel_V = mkV "hurvitella" ;
lin revelation_N = mkWN (k39 "paljastus") ; --UNCHK
lin reveler_N = mkWN (k12 "juhlija") ; --UNCHK
lin reveller_N = mkWN (k12 "juhlija") ; --UNCHK
lin revelry_N = mkWN (k9A "juhlinta") ; --UNCHK
lin revenant_A = mkWA (compoundA "haamu" (k38 "mainen")) ; --UNCHK
lin revenant_N = mkWN (k1 "haamu") ; --UNCHK
lin revenge_N = mkWN (k1 "kosto") ; --UNCHK
lin revenge_V2 = mkWV2 (k53 "kostaa") ; --UNCHK
lin revengeful_A = mkWA (compoundA "koston" (k38 "haluinen")) ; --UNCHK
lin revenue_N = mkN "tulo" ;
lin revenuer_N = mkWN "veroviranomainen" ; --UNCHK
lin reverberant_A = mkWA "kajahteleva" ; --UNCHK
lin reverberate_V = mkWV (k54A "kuumentaa") ; --UNCHK
lin reverberate_V2 = mkWV2 (k54A "kuumentaa") ; --UNCHK
lin reverberation_N = mkWN (k9A "kaiunta") ; --UNCHK
lin revere_V2 = mkWV2 (k67 "ihailla") ; --UNCHK
lin reverence_N = mkWN (k39 "kunnioitus") "syvä" ; --UNCHK
lin reverence_V2 = mkWV2 (k53A "kunnioittaa") "syvästi" ; --UNCHK
lin reverend_A = mkWA (k10 "valtava") ; --UNCHK
lin reverend_N = mkWN (k6 "pastori") ; --UNCHK
lin reverent_A = mkWA (k10 "kunnioittava") ; --UNCHK
lin reverential_A = mkWA (k10 "kunnioittava") ; --UNCHK
lin reverie_N = mkWN (k5A "unelmointi") ; --UNCHK
lin revers_N = mkWN (k48A "käänne") ; --UNCHK
lin reversal_N = mkN "kääntö" ;
lin reverse_A = mkWA "peruutus-" ; --UNCHK
lin reverse_N = mkWN (k39 "käännös") ; --UNCHK
lin reverse_V = mkV (mkV "vaihtua") "päinvastaiseksi" ; --mkWV (k56A "vaihtaa") "päinvastaiseksi" ;
lin reverse_V2 = mkWV2 (k56A "vaihtaa") "päinvastaiseksi" ; --UNCHK
lin reversibility_N = mkWN "käännettävyys" ; --UNCHK
lin reversible_A = mkWA "palautettava" ; --UNCHK
lin reversible_N = mkWN (compoundN "kääntö" (k5A "takki")) ; --UNCHK
lin reversion_N = mkWN (k99 "uudelleen") "sortuminen" ; --UNCHK
lin reversionary_A = mkWA (compoundA "tois" (k38 "sijainen")) ; --UNCHK
lin reversioner_N = mkWN (compoundN "selkä" (k38 "perillinen")) ; --UNCHK
lin revert_V = mkWV (k52A "palautua") ; --UNCHK
lin revertible_A = mkWA "palautuva" ; --UNCHK
lin revetment_N = mkWN (k39 "kivetys") ; --UNCHK
lin review_N = mkWN (k39 "tarkastus") ; --f61
lin review_V = mkWV (k53 "tarkistaa") ; --UNCHK
lin review_V2 = mkV2 "arvioida" ;
lin reviewer_N = mkWN (k12 "arvostelija") ; --UNCHK
lin revile_V = mkWV (k67A "panetella") ; --UNCHK
lin revile_V2 = mkWV2 (k67A "panetella") ; --UNCHK
lin revise_N = mkWN (compoundN "kirjo" (k38 "ittaminen")) "uudelleen" ; --UNCHK
lin revise_V = mkV "tarkistaa" ;
lin revise_V2 = mkV2 "tarkistaa" ;
lin revised_A = variants {} ; --
lin reviser_N = mkWN (k10 "toimittaja") ; --UNCHK
lin revision_N = mkWN (k39 "tarkistus") ; --UNCHK
lin revisionism_N = mkWN (k5 "revisionismi") ; --UNCHK
lin revisionistFem_N = mkWN (k5 "revisionisti") ; --UNCHK
lin revisionistMasc_N = mkWN (k5 "revisionisti") ; --UNCHK
lin revisit_V2 = mkWV2 (k65 "käydä") "taas" ; --UNCHK
lin revitalization_N = mkWN (k1 "nousu") "uusi" ; --UNCHK
lin revitalize_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin revival_N = mkWN (k1 "nousu") "uusi" ; --UNCHK
lin revivalism_N = mkWN (compoundN "herätys" (k48A "liike")) ; --UNCHK
lin revivalist_N = mkWN (k12 "lukija") "evankeliumitekstin" ; --UNCHK
lin revivalistic_A = mkWA "herätys-" ; --UNCHK
lin revive_V = mkWV (k73 "herätä") "henkiin" ;
lin revive_V2 = mkV2 (mkV (mkV "herättää") "henkiin") ;
lin revivify_V2 = mkWV2 (k53 "virkistää") ; --UNCHK
lin revocable_A = mkWA (compoundA "kum" (k10 "ottava")) ; --UNCHK
lin revocation_N = mkWN "kumoaminen" ; --UNCHK
lin revoke_N = mkWN (k39 "rikkomus") ; --UNCHK
lin revoke_V = mkWV (k74 "kumota") ; --UNCHK
lin revoke_V2 = mkWV2 (k74 "kumota") ;
lin revolt_N = mkWN (k5A "kapinointi") ; --UNCHK
lin revolt_V = mkWV (k53A "kuvottaa") ; --UNCHK
lin revolt_V2 = mkWV2 (k53A "kuvottaa") ; --UNCHK
lin revolution_N = mkWN (compoundN "vallan" (k39 "kumous")) ; --UNCHK
lin revolutionary_A = mkWA (compoundA "vallan" (k38 "kumouksellinen")) ; --UNCHK
lin revolutionary_N = mkWN (k38 "kumouksellinen") ; --UNCHK
lin revolutionism_N = mkWN (compoundN "vallan" (k40 "kumouksellisuus")) ; --UNCHK
lin revolutionist_N = mkWN (k38 "kumouksellinen") ; --UNCHK
lin revolutionize_V2 = mkWV2 (k53 "mullistaa") ; --UNCHK
lin revolve_V = mkV "pyöriä" ; --mkWV (k53A "pyörittää") ;
lin revolve_V2 = mkWV2 (k53A "pyörittää") ; --UNCHK
lin revolver_N = mkWN (k10 "kuudestilaukeava") ; --UNCHK
lin revue_N = mkWN (k20 "revyy") ; --UNCHK
lin revulsion_N = mkWN (k1 "kammo") ; --UNCHK
lin reward_N = mkWN (k39 "vahvistus") ; --UNCHK
lin reward_V2 = mkWV2 (k56 "maksaa") ; --UNCHK
lin rewardful_A = mkWA "palkitseva" ; --UNCHK
lin rewarding_A = mkWA (k10 "antoisa") ; --UNCHK
lin rewire_V2 = mkWV2 (k61 "uusia") "sähköjohdot" ; --UNCHK
lin reword_V2 = mkWV2 (k67 "muotoilla") "toisin" ; --UNCHK
lin rewording_N = mkWN (k2 "ilmaisu") "toisin" ; --UNCHK
lin rework_V2 = mkWV2 (k53 "uudistaa") ; --UNCHK
lin rewrite_N = mkWN (k3 "versio") "paranneltu" ; --UNCHK
lin rewrite_V2 = mkWV2 (k73A "muokata") ;
lin rewriting_N = mkWN (compoundN "muu" (k38 "ttaminen")) ; --UNCHK
lin rhabdomyoma_N = mkWN (compoundN "rabdo" (k10 "myooma")) ; --UNCHK
lin rhabdomyosarcoma_N = mkWN (compoundN "rabdomyo" (k10 "sarkooma")) ; --UNCHK
lin rhabdovirus_N = mkWN (compoundN "rabdo" (k39 "virus")) ; --UNCHK
lin rhapsodize_V = mkWV (k52 "puhua") "haltioituneesti" ; --UNCHK
lin rhapsody_N = mkWN (k12 "rapsodia") ; --UNCHK
lin rhea_N = mkWN (compoundN "nandu" (k1A "lintu")) ; --UNCHK
lin rhenish_A = mkWA "Reinin" ; --UNCHK
lin rhenium_N = mkWN "järjestysluku" "75" ; --UNCHK
lin rheologic_A = mkWA "reologinen" ; --UNCHK
lin rheology_N = mkWN (compoundN "aineenjuoksevuus" (k5A "oppi")) ; --UNCHK
lin rheometer_N = mkWN (compoundN "reo" (k5 "metri")) ; --UNCHK
lin rheostat_N = mkWN (compoundN "säätö" (k39 "vastus")) ; --UNCHK
lin rhesus_N = mkWN (k39 "reesus") ; --UNCHK
lin rhetoric_N = mkN (lin NK {s = d09A "retoriikka"}) ;
lin rhetorical_A = mkA "retorinen" ;
lin rhetorician_N = mkWN (k10 "puhuja") "julkinen" ; --UNCHK
lin rheum_N = mkWN (compoundN "Rheum-" (k1A "suku")) ; --UNCHK
lin rheumatic_A = mkWA (k38 "reumaattinen") ; --UNCHK
lin rheumatic_N = mkWN (k4A "reumaatikko") ; --UNCHK
lin rheumatism_N = mkWN (k9 "reuma") ; --UNCHK
lin rheumatoid_A = mkWA (k38 "reumaattinen") ; --UNCHK
lin rheumatologist_N = mkWN "reumatologi" ; --UNCHK
lin rheumatology_N = mkWN (k12 "reumatologia") ; --UNCHK
lin rheumy_A = mkWA (k38 "reumaattinen") ; --UNCHK
lin rhinal_A = mkWA "nenä-" ; --UNCHK
lin rhinestone_N = mkWN (k5 "strassi") ; --UNCHK
lin rhinion_N = mkWN "rhinion" ; --UNCHK
lin rhinitis_N = mkWN (k10 "nuha") ; --UNCHK
lin rhino_N = mkWN (compoundN "sarvi" (k1 "kuono")) ; --UNCHK
lin rhinoceros_N = mkWN (compoundN "sarvi" (k1 "kuono")) ; --UNCHK
lin rhinolaryngology_N = mkWN (compoundN "kurkkutauti" (k5A "oppi")) "korva-" "ja" ; --UNCHK
lin rhinopathy_N = mkWN (compoundN "nenä" (k40 "sairaus")) ; --UNCHK
lin rhinophyma_N = mkWN (compoundN "muhkura" (k10 "nenä")) ; --UNCHK
lin rhinorrhea_N = mkWN (k10 "nuha") "voimakas" ; --UNCHK
lin rhinoscope_N = mkWN (compoundN "nenän" (k33 "tähystin")) ; --UNCHK
lin rhinoscopy_N = mkWN (compoundN "nenän" (k39 "tähystys")) ; --UNCHK
lin rhinosporidiosis_N = mkWN "rinosporidioosi" ; --UNCHK
lin rhinostenosis_N = mkWN (k10 "ahtauma") "nenän" ; --UNCHK
lin rhinotomy_N = mkWN (compoundN "nenä" (k39 "leikkaus")) ; --UNCHK
lin rhinotracheitis_N = mkWN "rhinotracheitis" ; --UNCHK
lin rhinovirus_N = mkWN (compoundN "nuha" (k39 "virus")) ; --UNCHK
lin rhizoctinia_N = mkWN "rhizoctinia" ; --UNCHK
lin rhizoid_N = mkWN (k9 "rihma") ; --UNCHK
lin rhizoidal_A = mkWA (compoundA "rih" (k38 "mainen")) ; --UNCHK
lin rhizomatous_A = mkWA "juurakoituva" ; --UNCHK
lin rhizome_N = mkWN (compoundN "maa" (k28 "varsi")) ; --UNCHK
lin rhizomorph_N = mkWN (k4A "juurakko") ; --UNCHK
lin rhizopod_N = mkWN (compoundN "juu" (k38 "rijalkainen")) ; --UNCHK
lin rhizopus_N = mkWN (k48 "home") ; --UNCHK
lin rho_N = mkWN "rhoo" ; --UNCHK
lin rhodium_N = mkWN (k5 "rodium") ; --UNCHK
lin rhodochrosite_N = mkWN "rodokrosiitti" ; --UNCHK
lin rhododendron_N = mkWN (compoundN "alppi" (k1 "ruusu")) ; --UNCHK
lin rhodolite_N = mkWN (k5A "granaatti") "ruusunpunainen" ; --UNCHK
lin rhodonite_N = mkWN (compoundN "rodo" (k5A "niitti")) ; --UNCHK
lin rhomb_N = mkWN (k50 "vinoneliö") ; --UNCHK
lin rhombic_A = mkWA (k38 "rombinen") ; --UNCHK
lin rhombohedral_A = mkWA (compoundA "triagona" (k38 "alinen")) ; --UNCHK
lin rhombohedron_N = mkWN "romboedri" ; --UNCHK
lin rhomboid_A = mkWA (k38 "muotoinen") "vinokaiteen" ; --UNCHK
lin rhomboid_N = mkWN (compoundN "suunnikas" (k39 "lihas")) ; --UNCHK
lin rhombus_N = mkWN (k50 "vinoneliö") ; --UNCHK
lin rhonchus_N = mkWN (k12 "rohina") ; --UNCHK
lin rhondda_PN = foreignPN "Rhondda" ;
lin rhosllanerchrugog_PN = foreignPN "Rhosllanerchrugog" ;
lin rhubarb_N = mkWN (k5 "raparperi") ; --UNCHK
lin rhyl_PN = foreignPN "Rhyl" ;
lin rhyme_N = mkWN (k5 "riimi") ; --UNCHK
lin rhyme_V = mkWV (k67A "riimitellä") ; --UNCHK
lin rhyme_V2 = mkWV2 (k67A "riimitellä") ; --UNCHK
lin rhymer_N = mkWN (k12 "runoilija") ; --UNCHK
lin rhymester_N = mkWN (k12 "runoilija") ; --UNCHK
lin rhymney_PN = foreignPN "Rhymney" ;
lin rhyolite_N = mkWN "ryoliitti" ; --UNCHK
lin rhythm_N = mkWN (compoundN "rytmi" (k10 "menetelmä")) ; --UNCHK
lin rhythmic_A = mkWA (k38 "rytminen") ; --UNCHK
lin rhythmical_A = mkWA (k38 "rytminen") ; --UNCHK
lin rhythmicity_N = mkWN (k40 "rytmikkyys") ; --UNCHK
lin rib_N = mkWN (k26 "vahvistuskaari") ; --UNCHK
lin rib_V2 = mkWV2 (k73 "ivata") ; --UNCHK
lin ribald_A = mkWA (k34A "ruokoton") ; --UNCHK
lin ribald_N = mkWN (k38 "ihminen") "härski" ; --UNCHK
lin ribaldry_N = mkWN (k40 "ruokottomuus") ; --UNCHK
lin riband_N = mkWN (compoundN "ruusuke" (k9 "nauha")) ; --UNCHK
lin ribavirin_N = mkWN "Virazole" ; --UNCHK
lin ribbing_N = mkWN (k39 "härnäys") ; --UNCHK
lin ribbon_N = mkWN (compoundN "koriste" (k9 "nauha")) ; --UNCHK
lin ribbonfish_N = mkWN "Trachipterus" "trachypterus" ; --UNCHK
lin ribbonlike_A = mkWA (compoundA "nauha" (k38 "mainen")) ; --UNCHK
lin ribier_N = mkWN "ribier" ; --UNCHK
lin ribless_A = mkWA "ruoteeton" ; --UNCHK
lin riblike_A = mkWA (compoundA "ruode" (k38 "mainen")) ; --UNCHK
lin riboflavin_N = mkWN (k5 "riboflaviini") ; --UNCHK
lin ribonuclease_N = mkWN (compoundN "ribonukle" (k5 "aasi")) ; --UNCHK
lin ribose_N = mkWN "riboosi" ; --UNCHK
lin ribosome_N = mkWN "ribosomi" ; --UNCHK
lin rice_N = mkWN (kH1 "riisi") ; --UNCHK
lin rice_paper_N = mkWN (compoundN "riisi" (k6 "paperi")) ; --UNCHK
lin ricegrass_N = mkWN "Oryzopsis" ; --UNCHK
lin ricer_N = mkWN (k33A "puserrin") ; --UNCHK
lin rich_A = mkA "rikas" ;
lin richmond_PN = foreignPN "Richmond" ;
lin richness_N = mkWN (k40 "suurenmoisuus") ; --UNCHK
lin richweed_N = mkWN "Pilea" "pumilla" ; --UNCHK
lin ricin_N = mkWN (k5 "risiini") ; --UNCHK
lin rick_N = mkWN (k10 "suova") ; --UNCHK
lin rick_V2 = mkWV2 (k53A "niksauttaa") ; --UNCHK
lin rickets_N = mkWN (compoundN "riisi" (k5A "tauti")) ; --UNCHK
lin rickettsia_N = mkWN "riketsia" ; --UNCHK
lin rickettsial_A = mkWA "riketsioihin" "liittyvä" ; --UNCHK
lin rickettsialpox_N = mkWN (compoundN "riketsia" (k1A "rokko")) ; --UNCHK
lin rickety_A = mkWA (k41 "hauras") ; --UNCHK
lin rickey_N = mkWN "rickey" ; --UNCHK
lin rickmansworth_PN = foreignPN "Rickmansworth" ;
lin rickrack_N = mkWN (compoundN "ricrac-" (k9 "nauha")) ; --UNCHK
lin rickshaw_N = mkWN (k9 "rikša") ; --UNCHK
lin ricochet_N = mkWN (k48A "kimmoke") ; --UNCHK
lin ricochet_V = mkWV (k73A "pompata") ; --UNCHK
lin ricochet_V2 = mkWV2 (k73A "pompata") ; --UNCHK
lin ricotta_N = mkWN "ricotta" ; --UNCHK
lin rictus_N = mkWN (k2 "töllistely") ; --UNCHK
lin rid_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin riddance_N = mkWN (k39 "karkotus") ; --UNCHK
lin riddle_N = mkWN (k9 "seula") ; --UNCHK
lin riddle_V2 = mkWV2 (k54A "hämmentää") ; --UNCHK
lin ride_N = mkWN (k1 "ajo") ; --UNCHK
lin ride_V = mkWV (k53A "ärsyttää") ; --UNCHK
lin ride_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin ride_off_V = mkWV (k53 "ratsastaa") "pois" ; --UNCHK
lin ride_on_V2 = prepV2 OP_ride_V OP_on_Prep ; -- guess-p-verb
lin ride_out_V2 = mkWV2 (k52A "selviytyä") ; --UNCHK
lin ride_up_V = advV OP_ride_V OP_up_Adv ; -- guess-p-verb
lin riderFem_N = mkWN (k48A "liite") ; --UNCHK
lin riderMasc_N = variants {} ; --
lin ridge_N = mkWN (k9A "malka") ; --UNCHK
lin ridge_V2 = mkWV2 (k61 "louhia") "harjanteeksi" ; --UNCHK
lin ridge_tile_N = mkWN (compoundN "harja" (k23 "tiili")) ; --UNCHK
lin ridgeling_N = mkWN (k9 "varsa") ; --UNCHK
lin ridgepole_N = mkWN (k9A "malka") ; --UNCHK
lin ridicule_N = mkWN (kH1 "pilkka") ; --UNCHK
lin ridicule_V2 = mkWV2 (k73 "ivata") ; --UNCHK
lin ridiculous_A = mkWA (k1 "hupsu") ; --UNCHK
lin riding_N = mkWN (k39 "ratsastus") ; --UNCHK
lin riding_habit_N = mkWN (compoundN "kilpailu" (k1 "asu")) ; --UNCHK
lin riding_lamp_N = mkWN (compoundN "ankkuri" (k1 "valo")) ; --UNCHK
lin riding_light_N = mkWN (compoundN "ankkuri" (k1 "valo")) ; --UNCHK
lin riding_master_N = mkWN (compoundN "ratsastus" (k6 "mestari")) ; --UNCHK
lin riding_school_N = mkWN (compoundN "ratsastus" (k1 "koulu")) ; --UNCHK
lin ridley_N = mkWN "bastardikilpikonna" ; --UNCHK
lin riel_N = mkWN "riel" ; --UNCHK
lin riesling_N = mkWN "Riesling" ; --UNCHK
lin rife_A = mkWA (k10 "vallitseva") ; --UNCHK
lin riff_N = mkWN "riffi" ; --UNCHK
lin riffle_N = mkWN (k39 "sekoitus") "korttipakan" ; --UNCHK
lin riffle_V = mkWV (k53A "sekoittaa") "korttipakka" ; --UNCHK
lin riffle_V2 = mkWV2 (k53A "sekoittaa") "korttipakka" ; --UNCHK
lin rifle_N = mkWN (k6 "kivääri") ; --UNCHK
lin rifle_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin rifle_range_N = mkWN (compoundN "ampuma" (k9A "rata")) ; --UNCHK
lin rifle_shot_N = mkWN (compoundN "ampuma" (k9 "matka")) ; --UNCHK
lin riflebird_N = mkWN (compoundN "viuhka" (k7A "siipi")) ; --UNCHK
lin rifleman_N = mkWN (compoundN "kivääri" (k42 "mies")) ; --UNCHK
lin rift_N = mkWN (k1 "särö") ; --UNCHK
lin rift_valley_N = mkWN (compoundN "hauta" (k10 "laskeuma")) ; --UNCHK
lin rig_N = mkWN (k39 "huiputus") ; --UNCHK
lin rig_V = mkWV (k62 "takiloida") ; --UNCHK
lin rig_V2 = mkWV2 (k62 "takiloida") ; --UNCHK
lin riga_PN = mkPN "Riika" ;
lin rigatoni_N = mkWN "rigatoni" ; --UNCHK
lin rigging_N = mkWN (k5 "riki") ; --UNCHK
lin right_1_A = mkA "oikea" ;
lin right_1_Adv = mkAdv "oikeassa" ;
lin right_2_A = mkA "oikea" ;
lin right_2_Adv = mkAdv "oikealle" | mkAdv "oikealla" ; --- split
lin right_3_A = mkA "oikea" ;
lin right_Interj = variants {} ; --
lin right_N = mkN "oikeus" | mkN "oikea" ; ---- split
lin right_Ord = L.right_Ord ;
lin right_V2 = mkWV2 (k66 "oikaista") ; --UNCHK
lin right_hand_A = mkA (mkN "oikean" (mkN "puoleinen")) ;
lin right_hander_N = mkWN (compoundN "oikea" (k38 "kätinen")) ; --UNCHK
lin right_of_Prep = mkPrep elative "oikealla" ;
lin right_wing_N = mkWN (k1 "oikeisto") ; --UNCHK
lin righteous_A = mkWA (k41 "vanhurskas") ; --UNCHK
lin righteousness_N = mkWN (k40 "vanhurskaus") ; --UNCHK
lin rightful_A = mkWA (k38 "laillinen") ; --UNCHK
lin rightfulness_N = mkWN (k40 "laillisuus") ; --UNCHK
lin rightish_A = mkWA "oikeistoon" "suuntautuva" ; --UNCHK
lin rightism_N = mkWN (k40 "oikeistolaisuus") ; --UNCHK
lin rightist_A = mkWA (k38 "oikeistolainen") ; --UNCHK
lin rightist_N = mkWN (k38 "oikeistolainen") ; --UNCHK
lin rightmost_A = mkWA "oikeanpuoleisin" ; --UNCHK
lin rightness_N = mkWN (k40 "hienous") ; --UNCHK
lin rigid_A = mkWA (k10A "jäykkä") ; --UNCHK
lin rigidity_N = mkWN (k40 "ankaruus") ; --UNCHK
lin rigmarole_N = mkWN (k5 "ruljanssi") ; --UNCHK
lin rigor_mortis_N = mkWN (compoundN "kuolon" (k40 "kankeus")) ; --UNCHK
lin rigorous_A = mkWA (k9A "tiukka") ; --UNCHK
lin rigour_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin rigout_N = mkWN (k1 "asu") ; --UNCHK
lin riihimäki_PN = mkPN (mkN "Riihimäki" "Riihimäkiä") ;
lin rijeka_PN = foreignPN "Rijeka" ;
lin rijsttaffel_N = mkWN "rijstafel" ; --UNCHK
lin rile_V2 = mkWV2 (k54A "samentaa") ; --UNCHK
lin rill_N = mkWN (k1 "noro") ; --UNCHK
lin rim_N = mkWN (k9A "laita") ; --UNCHK
lin rim_V2 = mkWV2 (k61 "pyöriä") "reunalla" ; --UNCHK
lin rima_N = mkWN (k1A "aukko") ; --UNCHK
lin rime_N = mkWN (k5 "riimi") ; --UNCHK
lin rime_V2 = mkWV2 (k67A "riimitellä") ; --UNCHK
lin rimini_PN = foreignPN "Rimini" ;
lin rimless_A = mkWA "kehyksettömät" ; --UNCHK
lin rimose_A = mkWA (k38 "rosoinen") ; --UNCHK
lin rimu_N = mkWN "Dacrydium" "cupressinum" ; --UNCHK
lin rind_N = mkWN (k9 "nahka") ; --UNCHK
lin rinderpest_N = mkWN (compoundN "karja" (k1A "rutto")) ; --UNCHK
lin ring_4_V2 = mkV2 (mkV "soittaa") allative ;
lin ring_6_V2 = mkV2 "rengastaa" ;
lin ring_N = mkWN (k41A "rengas") ; ---ARB ; sormus ; kilinä ; sävy
lin ring_V = mkV "soida" ;
lin ring_armour_N = mkWN (compoundN "silmukka" (k6 "panssari")) ; --UNCHK
lin ring_back_V2 = mkV2 (advV OP_ring_V OP_back_Adv ) ; -- guess-p-verb
lin ring_finger_N = mkWN (k34A "nimetön") ; --UNCHK
lin ring_in_V = advV OP_ring_V OP_in_Adv ; -- guess-p-verb
lin ring_mail_N = mkWN (compoundN "silmukka" (k6 "panssari")) ; --UNCHK
lin ring_off_V = advV OP_ring_V OP_off_Adv ; -- guess-p-verb
lin ring_out_V = mkWV (k53A "kajahtaa") ; --UNCHK
lin ring_road_N = mkWN (compoundN "ohikulku" (k19 "tie")) ; --UNCHK
lin ring_round_V = advV OP_ring_V OP_round_Adv ; -- guess-p-verb
lin ring_up_V = mkWV (k64 "lyödä") "kassakoneeseen" ; --UNCHK
lin ring_up_V2 = mkWV2 (k64 "lyödä") "kassakoneeseen" ; --UNCHK
lin ring_with_V2 = prepV2 OP_ring_V OP_with_Prep ; -- guess-p-verb
lin ringdove_N = mkWN (compoundN "sepel" (k1 "kyyhky")) ; --UNCHK
lin ringer_N = mkN "soittaja" ;
lin ringhals_N = mkWN "Hemachatus" "haemachatus" ; --UNCHK
lin ringing_N = mkWN "sonorisuus" ; --UNCHK
lin ringleader_N = mkWN (compoundN "pää" (k12 "tekijä")) ; --UNCHK
lin ringlet_N = mkWN (compoundN "heinä" (k38 "perhonen")) ; --UNCHK
lin ringleted_A = mkWA (compoundA "kiharo" (k1A "itu")) ; --UNCHK
lin ringlike_A = mkWA (compoundA "rengas" (k38 "mainen")) ; --UNCHK
lin ringmaster_N = mkWN (k5 "tirehtööri") ; --UNCHK
lin ringside_N = mkWN (k9A "paikka") "eturivin" ; --UNCHK
lin ringtail_N = mkWN (k38 "poikanen") "kotkan" ; --UNCHK
lin ringwood_PN = foreignPN "Ringwood" ;
lin ringworm_N = mkWN (k9 "silsa") ; --UNCHK
lin rink_N = mkWN (k9A "rata") ; --UNCHK
lin rinse_N = mkWN (k2 "huuhtelu") ; --UNCHK
lin rinse_V2 = mkWV2 (k67A "huuhdella") ; --UNCHK
lin riot_N = mkN "mellakka" ;
lin riot_V = mkWV (k73A "ryypätä") ; --UNCHK
lin rioter_N = mkWN (k12 "mellakoitsija") ; --UNCHK
lin rioting_N = mkWN (k14A "mellakka") ; --UNCHK
lin riotous_A = mkWA (k5 "villi") ; --UNCHK
lin rip_N = mkWN (k2 "halkaisu") ; --UNCHK
lin rip_V = mkWV (k65 "käydä") "kimppuun" ; --UNCHK
lin rip_V2 = mkWV2 (k65 "käydä") "kimppuun" ; --UNCHK
lin rip_off_V2 = mkWV2 (k53A "naruttaa") ; --UNCHK
lin rip_out_V = mkWV (k53A "kajauttaa") ; --UNCHK
lin rip_roaring_A = mkA "riehakas" ;
lin riparian_A = mkWA "jokivarsi-" ; --UNCHK
lin ripcord_N = mkWN (compoundN "laukaisu" (k1 "naru")) ; --UNCHK
lin ripe_A = mkWA (k10 "kypsä") ; --UNCHK
lin ripen_V = mkWV (k52A "tuleentua") ; --UNCHK
lin ripen_V2 = mkWV2 (k52A "tuleentua") ; --UNCHK
lin ripeness_N = mkWN (k40 "kypsyys") ; --UNCHK
lin ripening_N = mkWN "kypsyminen" ; --UNCHK
lin ripley_PN = foreignPN "Ripley" ;
lin ripon_PN = foreignPN "Ripon" ;
lin riposte_N = mkWN (compoundN "vasta" (k1 "pisto")) ; --UNCHK
lin riposte_V = mkWV (k54A "sivaltaa") ; --UNCHK
lin ripper_N = mkWN "viiltäjä" ; --UNCHK
lin ripple_N = mkWN (k48 "väre") ;
lin ripple_V = mkV "väreillä" ;
lin ripple_V2 = mkWV2 (k53A "värisyttää") ; --UNCHK
lin ripsaw_N = mkWN (compoundN "halkaisu" (k9 "saha")) ; --UNCHK
lin riptide_N = mkWN (compoundN "risti" (k4A "aallokko")) ; --UNCHK
lin risca_PN = foreignPN "Risca" ;
lin rise_N = mkWN (k1 "nousu") ;
lin rise_V = mkV "nousta" ;
lin rise_V2 = mkV2 "nousta" elative ;
lin riser_N = mkWN (compoundN "varvas" (k9A "lauta")) ; --UNCHK
lin rishton_PN = foreignPN "Rishton" ;
lin risibility_N = mkWN (compoundN "naura" (k40 "vaisuus")) ; --UNCHK
lin risible_A = mkWA (k1 "hassu") ; --UNCHK
lin rising_A = mkA "nouseva" ;
lin rising_N = mkWN (k5A "kapinointi") ; --UNCHK
lin risk_N = mkN "riski" ;
lin risk_V2 = mkWV2 (k53A "ottaa") "riski" ; --UNCHK
lin risk_VV = mkWVV (k53A "ottaa") "riski" ; --UNCHK
lin riskiness_N = mkWN (kH1 "vaara") ; --UNCHK
lin risklessness_N = mkWN (k40 "vaarattomuus") ; --UNCHK
lin risky_A = mkA "riskaabeli" ;
lin risotto_N = mkWN (k1A "risotto") ; --UNCHK
lin risque_A = mkWA (k10 "pornahtava") ; --UNCHK
lin rissole_N = mkWN "rissole" ; --UNCHK
lin ristiina_PN = mkPN "Ristiina" ;
lin ristijärvi_PN = mkPN (mkN "Ristijärvi" "Ristijärviä") ;
lin ristinummi_PN = mkPN (mkN "Ristinummi" "Ristinummia") ;
lin rite_N = mkWN (k5A "riitti") ; --UNCHK
lin ritonavir_N = mkWN (compoundN "ritona" (k5 "viiri")) ; --UNCHK
lin ritual_A = mkWA (k38 "rituaalinen") ; --UNCHK
lin ritual_N = mkWN (k5 "rituaali") ; --UNCHK
lin ritualism_N = mkWN (compoundN "ritual" (k5 "ismi")) ; --UNCHK
lin ritualist_N = mkWN (k12 "tutkija") "rituaalien" ; --UNCHK
lin ritualistic_A = mkWA "ritualistinen" ; --UNCHK
lin ritz_N = mkWN "Ritz" ; --UNCHK
lin ritzy_A = mkWA (k15 "pramea") ; --UNCHK
lin rival_A = variants {} ; --
lin rival_N = mkN (lin NK {s = d12 "kilpailija"}) ;
lin rival_V2 = mkWV2 (k67 "kilpailla") ; --UNCHK
lin rivalry_N = mkWN (k2 "kilpailu") ; --UNCHK
lin rive_V = mkWV (k66 "lohkaista") ; --UNCHK
lin rive_V2 = mkWV2 (k66 "lohkaista") ; --UNCHK
lin river_N = L.river_N ;
lin river_basin_N = mkWN (k41A "allas") ; --UNCHK
lin riverbank_N = mkWN (k9A "ranta") "joen" ; --UNCHK
lin river_bed_N = mkWN (compoundN "joki" (k10 "uoma")) ; --UNCHK
lin riverside_N = mkWN (compoundN "River" (k48A "side")) ; --UNCHK
lin rivet_N = mkWN (k5A "niitti") ; --UNCHK
lin rivet_V = mkWV (k53 "kohdistaa") "huomionsa" ; --UNCHK
lin rivet_V2 = mkWV2 (k53 "kohdistaa") "huomionsa" ; --UNCHK
lin riveter_N = mkWN (compoundN "niittaus" (k48 "kone")) ; --UNCHK
lin rivulet_N = mkWN (k1 "puro") ; --UNCHK
lin rivulus_N = mkWN "rivulus" ; --UNCHK
lin rn_N = mkWN (compoundN "sairaan" (k10 "hoitaja")) "laillistettu" ; --UNCHK
lin roach_N = mkWN (k7A "särki") ; --UNCHK
lin road_N = L.road_N ;
lin road_hog_N = mkWN (k10 "ajaja") "keskellä" "tietä" ; --UNCHK
lin road_metal_N = mkWN (k6 "sepeli") ; --UNCHK
lin road_sense_N = mkWN (compoundN "liikenne" (k7A "järki")) ; --UNCHK
lin roadbed_N = mkWN (compoundN "alus" (k39 "kerros")) "tien" ; --UNCHK
lin roadblock_N = mkWN (compoundN "tie" (k1A "sulku")) ; --UNCHK
lin road_book_N = mkWN (compoundN "kartta" (k9 "kirja")) ; --UNCHK
lin roadhouse_N = mkWN (compoundN "maja" (k1 "talo")) ; --UNCHK
lin roadkill_N = mkWN (k1A "raato") ; --UNCHK
lin roadless_A = mkWA (k34A "koskematon") ; --UNCHK
lin roadman_N = mkWN (compoundN "tietyö" (k42 "mies")) ; --UNCHK
lin roadrunner_N = mkWN (compoundN "kalifornianjuoksu" (k7A "käki")) ; --UNCHK
lin roads_N = mkWN (compoundN "ankkurointi" (k9A "paikka")) ; --UNCHK
lin roadside_N = mkWN (compoundN "tien" (k9A "laita")) ; --UNCHK
lin roadstead_N = mkWN (compoundN "ankkurointi" (k9A "paikka")) ; --UNCHK
lin roadway_N = mkWN (k19 "tie") ; --UNCHK
lin roadworthiness_N = mkWN (compoundN "liikenne" (k40 "kelpoisuus")) ; --UNCHK
lin roam_V = mkWV (k67 "harhailla") ; --UNCHK
lin roam_V2 = mkWV2 (k67 "harhailla") ; --UNCHK
lin roan_A = mkWA "kimo-" ; --UNCHK
lin roan_N = mkWN (k1 "kimo") ; --UNCHK
lin roar_N = mkWN (k9A "ärjyntä") ; --UNCHK
lin roar_V = mkWV (k52 "ulvoa") ; --UNCHK
lin roar_V2 = mkWV2 (k52 "ulvoa") ; --UNCHK
lin roarer_N = mkWN (k10 "huutaja") ; --UNCHK
lin roaring_Adv = mkWAdv (k99 "täysin") ; --UNCHK
lin roast_A = mkWA (compoundA "paahde" (k1 "ttu")) ; --UNCHK
lin roast_N = mkWN (k48A "moite") ; --UNCHK
lin roast_V = mkWV (k56 "paistaa") ; --UNCHK
lin roast_V2 = mkWV2 (k56 "paistaa") ; --UNCHK
lin roaster_N = mkWN (compoundN "pasutus" (k1 "pannu")) ; --UNCHK
lin roasting_N = mkWN (compoundN "pai" (k38 "staminen")) ; --UNCHK
lin rob_V2 = mkV2 "ryöstää" ; --mkWV2 (k73 "ryövätä") ;
lin robalo_N = mkWN "robalo" ; --UNCHK
lin robber_N = mkWN (k6 "ryöväri") ; --UNCHK
lin robbery_N = mkWN (k1 "ryöstö") ;
lin robe_N = mkWN (k1A "kaapu") ; --UNCHK
lin robe_V = mkWV (k52A "pukeutua") "kaapuun" ; --UNCHK
lin robe_V2 = mkWV2 (k52A "pukeutua") "kaapuun" ; --UNCHK
lin robin_N = mkWN (compoundN "punarinta" (k41 "rastas")) ; --UNCHK
lin robot_N = mkWN (k5A "robotti") ; --UNCHK
lin robotic_A = mkWA "robootti-" ; --UNCHK
lin robotics_N = mkWN (k9A "robotiikka") ; --UNCHK
lin robust_A = mkA "kestävä" ; ---ARB mkWA (k9 "vahva") ;
lin robustness_N = mkWN (k40 "vankkuus") ; --UNCHK
lin roc_N = mkWN (compoundN "rok-" (k1A "lintu")) ; --UNCHK
lin roccella_N = mkWN "Roccella" "tinctoria" ; --UNCHK
lin rochdale_PN = foreignPN "Rochdale" ;
lin rochester_PN = foreignPN "Rochester" ;
lin rock_1_N = L.rock_N ;
lin rock_2_N = L.rock_N ;
lin rock_V = mkWV (k52A "keikkua") ; --UNCHK
lin rock_V2 = mkWV2 (k52A "keikkua") ; --UNCHK
lin rock_bottom_N = mkWN (k10 "pohja") ; --UNCHK
lin rock_cake_N = mkWN "rock" "cake" ; --UNCHK
lin rock_climbing_N = mkWN (compoundN "kallio" (k2 "kiipeily")) ; --UNCHK
lin rock_crystal_N = mkWN (compoundN "vuori" (k5 "kristalli")) ; --UNCHK
lin rock_garden_N = mkWN "kivikkopuutarha" ; --UNCHK
lin rock_plant_N = mkWN (compoundN "kivikko" (k5 "kasvi")) ; --UNCHK
lin rock_salmon_N = mkWN (compoundN "kivikko" (k9 "kala")) ; --UNCHK
lin rock_salt_N = mkWN (compoundN "vuori" (k9 "suola")) ; --UNCHK
lin rockabilly_N = mkWN "rockabilly" ; --UNCHK
lin rocker_N = mkWN (k39 "jalas") ; --UNCHK
lin rockery_N = mkWN "kivikkopuutarha" ; --UNCHK
lin rocket_1_N = mkWN (k5A "raketti") ; ---ARB
lin rocket_2_N = mkWN (k5A "raketti") ; ---ARB
lin rocket_V = mkWV (k52A "ampua") ; --UNCHK
lin rocket_base_N = mkWN (k10A "ohjustukikohta") ; --UNCHK
lin rocket_range_N = mkWN (compoundN "kanto" (k9 "matka")) "raketin" ; --UNCHK
lin rocketry_N = mkWN (compoundN "raketti" (k14A "tekniikka")) ; --UNCHK
lin rockfish_N = mkWN (k32 "ahven") ; --UNCHK
lin rockiness_N = mkWN (k40 "kivikkoisuus") ; --UNCHK
lin rocking_chair_N = mkWN (compoundN "kiikku" (k5 "tuoli")) ; --UNCHK
lin rocking_horse_N = mkWN (compoundN "keinu" (k38 "hevonen")) ; --UNCHK
lin rockrose_N = mkWN (compoundN "päivän" (k1A "nouto")) ; --UNCHK
lin rockslide_N = mkWN (compoundN "kivi" (k1 "vyöry")) ; --UNCHK
lin rockweed_N = mkWN (compoundN "rakko" (k10 "levä")) ; --UNCHK
lin rocky_A = mkWA (k38 "kuoppainen") ; --UNCHK
lin rococo_A = mkWA (compoundA "rokokoo" (k38 "tyylinen")) ; --UNCHK
lin rococo_N = mkWN (k18 "rokokoo") ; --UNCHK
lin rod_N = mkN "sauva" ; --mkWN (compoundN "sauva" (k6 "bakteeri")) ;
lin rodent_N = mkWN (k12 "jyrsijä") ; --UNCHK
lin rodeo_N = mkWN (k3 "rodeo") ; --UNCHK
lin rodomontade_N = mkWN (k2 "mahtailu") ; --UNCHK
lin roe_N = mkWN (k5A "mäti") ; --UNCHK
lin roebuck_N = mkWN (compoundN "uros" (k41 "kauris")) ; --UNCHK
lin roentgenium_N = mkWN "järjestysluku" "111" ; --UNCHK
lin roentgenogram_N = mkWN (compoundN "röntgen" (k10 "kuva")) ; --UNCHK
lin roentgenographic_A = mkWA (compoundA "röntgen" (k38 "ografinen")) ; --UNCHK
lin roentgenography_N = mkWN (compoundN "röntgen" (k39 "kuvaus")) ; --UNCHK
lin rofecoxib_N = mkWN "Vioxx" ; --UNCHK
lin rogation_N = mkWN (k39 "rukous") ; --UNCHK
lin rogue_N = mkWN (k6 "hamppari") ; --UNCHK
lin rogue_elephant_N = mkWN (compoundN "erakko" (k1 "norsu")) ; --UNCHK
lin roguery_N = mkWN (k10 "jäynä") ; --UNCHK
lin roguish_A = mkWA (k38 "konnamainen") ; --UNCHK
lin roguishness_N = mkWN (k10 "jäynä") ; --UNCHK
lin roil_V2 = mkWV2 (k54A "samentaa") ; --UNCHK
lin roisterer_N = mkWN (compoundN "rell" (k10 "estäjä")) ; --UNCHK
lin role_N = mkN "rooli" ;
lin roleplaying_N = mkWN (compoundN "rooli" (k5A "leikki")) ; --UNCHK
lin roll_N = mkN "rulla" ; ---ARB mkWN (k39 "vieritys") ;
lin roll_V = mkWV (k61 "kieriä") ;
lin roll_V2 = mkWV2 (k61 "kääriä") ;
lin roll_back_V = advV OP_roll_V OP_back_Adv ; -- guess-p-verb
lin roll_back_V2 = mkV2 (advV OP_roll_V OP_back_Adv ) ; -- guess-p-verb
lin roll_by_V = advV OP_roll_V OP_by_Adv ; -- guess-p-verb
lin roll_call_N = mkWN (compoundN "nimen" (k1A "huuto")) ; --UNCHK
lin roll_down_V = mkWV (k52 "vyöryä") ; --UNCHK
lin roll_in_V = mkWV (k52A "saapua") ; --UNCHK
lin roll_on_V = advV OP_roll_V OP_on_Adv ; -- guess-p-verb
lin roll_on_V2 = prepV2 OP_roll_V OP_on_Prep ; -- guess-p-verb
lin roll_out_V2 = mkWV2 (k53A "levittää") ; --UNCHK
lin roll_over_V = mkWV (k53A "pyörähtää") ; --UNCHK
lin roll_up_V = mkWV (k61 "kääriä") ; --UNCHK
lin rollback_N = mkWN (compoundN "ale" (k38 "neminen")) ; --UNCHK
lin roller_N = mkWN (k5A "lyönti") "matala" ;
lin roller_skate_N = mkWN (compoundN "rulla" (k33 "luistin")) ; --UNCHK
lin rollerblader_N = mkWN (compoundN "rulla" (k12 "luistelija")) ; --UNCHK
lin rollerblading_N = mkWN (compoundN "rulla" (k2 "luistelu")) ; --UNCHK
lin rollicking_A = mkWA (k10 "leikkisä") ; --UNCHK
lin rolling_N = mkWN (compoundN "työ" (k38 "ntäminen")) "pyörillä" ; --UNCHK
lin rolling_mill_N = mkWN (k2 "valssaamo") ; --UNCHK
lin rolling_pin_N = mkWN (k33 "kaulin") ; --UNCHK
lin rolling_stock_N = mkWN (k1 "kalusto") "liikkuva" ; --UNCHK
lin rollmops_N = mkWN (compoundN "silli" (k10 "rulla")) ; --UNCHK
lin rollover_N = mkWN "rollover" ; --UNCHK
lin romaic_A = mkWA (k38 "kreikkalainen") ; --UNCHK
lin romaic_N = mkWN "dimotiki" ; --UNCHK
lin roman_A = mkWA (k38 "romaaninen") ; --UNCHK
lin roman_N = mkWN (k33 "kirjain") "latinalainen" ; --UNCHK
lin romance_A = mkWA (k38 "latinalainen") ; --UNCHK
lin romance_N = mkWN (k9A "romantiikka") ; --UNCHK
lin romance_V = mkWV (k62 "romantisoida") ; --UNCHK
lin romance_V2 = mkWV2 (k62 "romantisoida") ; --UNCHK
lin romanesque_N = mkWN (k5 "arkkitehtuuri") "romaaninen" ; --UNCHK
lin romania_PN = foreignPN "Romania" ;
lin romanianFem_N = mkWN (k12 "romania") ; --UNCHK
lin romanianMasc_N = mkWN (k12 "romania") ; --UNCHK
lin romanian_A = mkWA (k38 "romanialainen") ; --UNCHK
lin romantic_A = mkWA (k38 "romanttinen") ;
lin romantic_N = mkWN (k1A "romantikko") ; --UNCHK
lin romanticism_N = mkWN (k9A "romantiikka") ; --UNCHK
lin romanticist_N = mkWN (k1A "romantikko") ; --UNCHK
lin romanticize_V = mkWV (k62 "romantisoida") ; --UNCHK
lin romanticize_V2 = mkWV2 (k62 "romantisoida") ; --UNCHK
lin romany_A = mkWA "romani-" ; --UNCHK
lin romany_N = mkWN (k6 "romani") ; --UNCHK
lin rome_PN = foreignPN "Rooma" ;
lin romish_A = mkWA (k38 "katolilainen") ; --UNCHK
lin romp_N = mkWN (k2 "hulluttelu") ; --UNCHK
lin romp_V = mkWV (k53A "voittaa") "helposti" ; --UNCHK
lin romper_N = mkWN (compoundN "potku" (k1A "puku")) ; --UNCHK
lin romsey_PN = foreignPN "Romsey" ;
lin ron_PN = foreignPN "Ron" ;
lin rondeau_N = mkWN "rondel" ; --UNCHK
lin rondel_N = mkWN "rondel" ; --UNCHK
lin rondo_N = mkWN (k1 "rondo") ; --UNCHK
lin roneo_N = mkWN "vahamonistuskone" ; --UNCHK
lin roneo_V2 = mkV2 (mkV (mkV "käyttää") "vahamonistuskonetta") ;
lin rood_N = mkWN (k5 "krusifiksi") ; --UNCHK
lin roof_N = L.roof_N ;
lin roof_V2 = mkWV2 (k56A "kattaa") ; --UNCHK
lin roof_garden_N = mkWN "kattopuutarha" ; --UNCHK
lin roofer_N = mkWN (compoundN "katon" (k12 "tekijä")) ; --UNCHK
lin roofing_N = mkWN (compoundN "katon" (k1A "teko")) ; --UNCHK
lin roofless_A = mkWA "katoton" ; --UNCHK
lin rooftop_N = mkWN (k1A "katto") ; --UNCHK
lin rooibos_N = mkWN "Aspalathus" "cedcarbergensis" ; --UNCHK
lin rook_N = mkWN (k50 "mustavaris") ; --UNCHK
lin rook_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin rookery_N = mkWN (compoundN "pesiytymis" (k48 "alue")) ; --UNCHK
lin rookie_N = mkWN (k5 "noviisi") ; --UNCHK
lin room_1_N = mkN "huone" ;
lin room_2_N = mkN "tila" ;
lin room_N = mkWN (k48 "huone") ;
lin room_V = mkWV (k52 "asua") ; --UNCHK
lin roomer_N = mkWN (k38 "vuokralainen") ; --UNCHK
lin roomette_N = mkWN (compoundN "makuu" (k9 "tila")) ; --UNCHK
lin roomful_N = mkWN (compoundN "huone" (k38 "ellinen")) ; --UNCHK
lin room_mate_N = mkWN (compoundN "kämppä" (k6 "kaveri")) ; --UNCHK
lin roomy_A = mkWA (k10 "avara") ; --UNCHK
lin roost_N = mkWN "yöpuu" ; --UNCHK
lin roost_V = mkWV (k52A "asettua") "aloilleen" ; --UNCHK
lin rooster_N = mkWN (k1A "kukko") ; --UNCHK
lin root_N = L.root_N ;
lin root_V = mkWV (k52A "juurtua") ; --UNCHK
lin root_V2 = mkWV2 (k52A "juurtua") ; --UNCHK
lin root_for_V2 = mkWV2 (k53 "kannustaa") ; --UNCHK
lin root_out_V2 = mkWV2 (k58 "kitkeä") ; --UNCHK
lin rootage_N = mkWN (k48A "lähde") ; --UNCHK
lin rootbound_A = mkWA (k38 "juurakkoinen") ; --UNCHK
lin rooting_N = mkWN (compoundN "juu" (k38 "rtuminen")) ; --UNCHK
lin rootle_V = mkWV (k56 "kaivaa") "esiin" ; --UNCHK
lin rootless_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin rootlet_N = mkWN (kH1 "juuri") "pieni" ; --UNCHK
lin rootstock_N = mkWN (k4A "juurakko") ; --UNCHK
lin rope_N = L.rope_N ;
lin rope_in_V2 = mkWV2 (k67A "houkutella") ; --UNCHK
lin rope_off_V2 = mkWV2 (k58A "sulkea") "köysiaidalla" ; --UNCHK
lin rope_yard_N = mkWN (compoundN "köydenpunonta" (k9A "rata")) ; --UNCHK
lin rope_yarn_N = mkWN (k9A "lanka") "köyden" ; --UNCHK
lin ropemaker_N = mkWN (compoundN "köyden" (k10 "punoja")) ; --UNCHK
lin roper_N = mkWN (compoundN "köyden" (k10 "punoja")) ; --UNCHK
lin ropewalk_N = mkWN (compoundN "köydenpunonta" (k9A "rata")) ; --UNCHK
lin ropewalker_N = mkWN (compoundN "nuoralla" (k12 "tanssija")) ; --UNCHK
lin ropeway_N = mkWN (compoundN "köysi" (k9A "rata")) ; --UNCHK
lin ropey_A = mkWA (k10 "pitkä") ; --UNCHK
lin roping_N = mkWN (compoundN "lasso" (k38 "aminen")) ; --UNCHK
lin ropy_A = mkWA (k10 "pitkä") ; --UNCHK
lin roridula_N = mkWN (compoundN "rorid" (k10 "ula")) ; --UNCHK
lin rorqual_N = mkWN (compoundN "uurteis" (k41 "valas")) ; --UNCHK
lin rosaceous_A = mkWA (k38 "ruusumainen") ; --UNCHK
lin rosalie_PN = foreignPN "Rosalie" ;
lin rosario_PN = foreignPN "Rosario" ;
lin rosary_N = mkWN (compoundN "rukous" (k9 "nauha")) ; --UNCHK
lin roscommon_PN = foreignPN "Roscommon" ;
lin rose_A = mkWA (k10 "roosa") ; --UNCHK
lin rose_N = mkWN (k10 "roosa") ; --UNCHK
lin rose_PN = foreignPN "Rose" ;
lin rose_V = mkV "punata" ;
lin rose_bed_N = mkWN (compoundN "ruusu" (k5A "penkki")) ; --UNCHK
lin rose_water_N = mkWN (compoundN "ruusu" (k27 "vesi")) ; --UNCHK
lin roseate_A = mkWA (k10 "roosa") ; --UNCHK
lin rosebay_N = mkWN "Rhododendron" "maxima" ; --UNCHK
lin rosebud_N = mkWN (k38 "kaunokainen") ; --UNCHK
lin rosefish_N = mkWN (compoundN "puna-" (k32 "ahven")) ; --UNCHK
lin roselle_N = mkWN (compoundN "tee" (k39 "hibiskus")) ; --UNCHK
lin rosemaling_N = mkWN (k5A "kuviointi") ; --UNCHK
lin rosemary_N = mkWN (k5 "rosmariini") ; --UNCHK
lin rosette_N = mkWN (k48A "ruusuke") ; --UNCHK
lin rosewood_N = mkWN (compoundN "ruusu" (k18 "puu")) ; --UNCHK
lin rosilla_N = mkWN "Helenium" "puberulum" ; --UNCHK
lin rosin_N = mkWN (k5 "hartsi") ; --UNCHK
lin rosin_V2 = mkWV2 (k73A "hangata") ; --UNCHK
lin rosinweed_N = mkWN (k5 "kasvi") "Grindelia-suvun" ; --UNCHK
lin rosita_N = mkWN "Centaurium" "calycosum" ; --UNCHK
lin roslyn_PN = foreignPN "Roslyn" ;
lin rossington_PN = foreignPN "Rossington" ;
lin rosslare_PN = foreignPN "Rosslare" ;
lin roster_N = mkWN (k2 "luettelo") ; --UNCHK
lin rostock_PN = foreignPN "Rostock" ;
lin rostrate_A = mkWA "nokka-" ; --UNCHK
lin rostrum_N = mkWN (k10 "kärsä") ; --UNCHK
lin rosy_A = mkWA (k38 "ruusuinen") ; --UNCHK
lin rot_N = mkWN (k99 "soopa") ; --UNCHK
lin rot_V = mkWV (k52 "virua") ; --UNCHK
lin rot_V2 = mkWV2 (k52 "virua") ; --UNCHK
lin rota_N = mkWN (compoundN "työvuoro" (k9 "lista")) ; --UNCHK
lin rotarian_N = mkWN (k6 "rotari") ; --UNCHK
lin rotary_A = mkWA "pyörivä" ; --UNCHK
lin rotary_N = mkWN (k6 "roottori") ; --UNCHK
lin rotatable_A = mkWA "pyöritettävä" ; --UNCHK
lin rotate_V = mkWV (k67 "viljellä") "vuoroviljelynä" ; --UNCHK
lin rotate_V2 = mkWV2 (k67 "viljellä") "vuoroviljelynä" ; --UNCHK
lin rotation_N = mkWN (k48A "liike") "pyörivä" ; --UNCHK
lin rotational_A = mkWA "pyörimis-" ; --UNCHK
lin rotatory_A = mkWA "pyörivä" ; --UNCHK
lin rotavirus_N = mkWN (compoundN "rota" (k39 "virus")) ; --UNCHK
lin rote_N = mkWN (compoundN "ulko" (k1A "luku")) ; --UNCHK
lin rotenone_N = mkWN (compoundN "hyönteis" (k1A "myrkky")) ; --UNCHK
lin rotgut_N = mkWN (k14A "pontikka") ; --UNCHK
lin rotherham_PN = foreignPN "Rotherham" ;
lin rothesay_PN = foreignPN "Rothesay" ;
lin rothwell_PN = foreignPN "Rothwell" ;
lin rotifer_N = mkWN (compoundN "ratas" (k33 "eläin")) ; --UNCHK
lin rotisserie_N = mkWN (compoundN "grilli" (k12 "ravintola")) ; --UNCHK
lin rotl_N = mkWN "rotl" ; --UNCHK
lin rotogravure_N = mkWN (k50 "syväpaino") ; --UNCHK
lin rotor_N = mkWN (k6 "roottori") ; --UNCHK
lin rotten_A = L.rotten_A ;
lin rottenness_N = mkWN "mädäntyvyys" ; --UNCHK
lin rottenstone_N = mkWN (compoundN "kalkki" (k7 "kivi")) ; --UNCHK
lin rotter_N = mkWN (k3 "heittiö") ; --UNCHK
lin rotterdam_PN = foreignPN "Rotterdam" ;
lin rotund_A = mkWA (k15 "pullea") ; --UNCHK
lin rotunda_N = mkWN (compoundN "pyörö" (k48 "huone")) ; --UNCHK
lin rotundity_N = mkWN (k40 "pyöreys") ; --UNCHK
lin roubaix_PN = foreignPN "Roubaix" ;
lin rouble_N = mkWN (k10 "rupla") ; --UNCHK
lin roue_N = mkWN (k42 "mies") "näyttävä" ; --UNCHK
lin rouen_PN = foreignPN "Rouen" ;
lin rouge_N = mkWN (k5A "meikki") ; --UNCHK
lin rouge_V = mkWV (k56A "laittaa") "poskipunaa" ; --UNCHK
lin rouge_V2 = mkWV2 (k56A "laittaa") "poskipunaa" ; --UNCHK
lin rough_A = mkWA (k15 "karkea") ; --f95
lin rough_Adv = mkWAdv (k99 "kovasti") ; --UNCHK
lin rough_N = mkWN (k4A "karheikko") ; --UNCHK
lin rough_V2 = mkWV2 (k67 "luonnostella") ; --UNCHK
lin rough_and_tumble_A = mkA "häikäilemätön" ;
lin rough_up_V2 = mkWV2 (k62 "mukiloida") ; --UNCHK
lin roughage_N = mkWN (k1A "kuitu") ; --UNCHK
lin roughcast_N = mkWN (compoundN "raaka" (k39 "luonnos")) ; --UNCHK
lin roughdried_A = mkWA (compoundA "raakakui" (k1A "vattu")) ; --UNCHK
lin roughen_V = mkWV (k54A "karhentaa") ; --UNCHK
lin roughen_V2 = mkWV2 (k54A "karhentaa") ; --UNCHK
lin rough_hewn_A = mkWA (compoundA "haka" (k1 "ttu")) "karkeasti" ; --UNCHK
lin roughish_A = mkWA (k15 "karkea") "hiukan" ; --UNCHK
lin roughly_AdV = mkAdV "suunnilleen" ;
lin roughneck_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin roughness_N = mkWN (k40 "karkeus") ; --UNCHK
lin roughrider_N = mkWN (compoundN "hevosen" (k10 "kesyttäjä")) ; --UNCHK
lin roughshod_A = mkWA (compoundA "luja" (k38 "otteinen")) ; --UNCHK
lin roulade_N = mkWN "roulade" ; --UNCHK
lin rouleau_N = mkWN (compoundN "kolikko" (k1 "pötkö")) ; --UNCHK
lin roulette_N = mkWN (k5A "ruletti") ; --UNCHK
lin round_A = L.round_A ;
lin round_Adv = mkAdv "ympäri" ;
lin round_N = mkN "kierros" ;
lin round_Prep = mkPrep "ympärillä" ;
lin round_V = mkWV (k52A "tukevoitua") ; --UNCHK
lin round_V2 = mkWV2 (k52A "tukevoitua") ; --UNCHK
lin round_hand_N = mkWN (compoundN "pyörö" (k39 "kirjoitus")) ; --UNCHK
lin round_off_V2 = mkWV2 (k53 "pyöristää") ; --UNCHK
lin round_out_V = mkWV (k53 "pyöristää") ; --UNCHK
lin round_shot_N = mkWN (k10 "kuula") ; --UNCHK
lin round_the_clock_A = mkA (mkN "ympäri" (mkN "vuorokautinen")) ;
lin round_the_clock_Adv = mkWAdv (k99 "ympäri") "vuorokauden" ; --UNCHK
lin round_up_V = mkWV (k74A "koota") ; --UNCHK
lin roundabout_A = mkWA (k10 "poikkeava") ; --UNCHK
lin roundabout_N = mkWN (k5 "karuselli") ; --UNCHK
lin roundedness_N = mkWN (k40 "pyöreys") ; --UNCHK
lin roundel_N = mkWN (k7A "kilpi") "pieni" ; --UNCHK
lin roundelay_N = mkWN "roundelay" ; --UNCHK
lin rounder_N = mkWN (compoundN "pyöristys" (k48 "kone")) ; --UNCHK
lin rounders_N = mkWN (compoundN "pesäpallo" (k5 "peli")) ; --UNCHK
lin roundhead_N = mkWN "Roundhead" ; --UNCHK
lin roundhouse_N = mkWN (compoundN "ylä" (k1A "koukku")) ; --UNCHK
lin rounding_N = mkWN (compoundN "pyöristys" (k48 "virhe")) ; --UNCHK
lin roundish_A = mkWA "pyöreähkö" ; --UNCHK
lin roundness_N = mkWN (k40 "pyöreys") ; --UNCHK
lin roundsman_N = mkWN (compoundN "työ" (k42 "mies")) ; --UNCHK
lin roundup_N = mkWN (compoundN "koko" (k38 "aminen")) ; --UNCHK
lin rouse_V = mkWV (k53A "herättää") ; --UNCHK
lin rouse_V2 = mkWV2 (k53A "herättää") ; --UNCHK
lin rout_N = mkWN (compoundN "rökäle" (k3 "tappio")) ; --UNCHK
lin rout_V2 = mkWV2 (k53A "löylyttää") ; --UNCHK
lin route_N = mkWN (k5A "reitti") ;
lin route_V2 = mkWV2 (k73 "ohjata") ; --UNCHK
lin routemarch_N = mkWN (k5 "marssi") ; --UNCHK
lin router_N = mkWN (k33 "jyrsin") ; --UNCHK
lin routine_A = mkA "rutiininomainen" ;
lin routine_N = mkWN (k5 "rutiini") ; --UNCHK
lin roux_N = mkWN "roux" ; --UNCHK
lin rovaniemi_PN = mkPN (mkN "Rovaniemi" "Rovaniemiä") ;
lin rove_V = mkWV (k67 "harhailla") ; --UNCHK
lin rove_V2 = mkWV2 (k67 "harhailla") ; --UNCHK
lin rover_N = mkWN (k38 "partiolainen") ; --UNCHK
lin row_N = mkN "rivi" ; ---ARB mkWN (k1A "soutu") ;
lin row_V = mkWV (k55A "soutaa") ; --UNCHK
lin row_V2 = mkWV2 (k55A "soutaa") ; --UNCHK
lin rowan_N = mkWN (compoundN "koti" (k10 "pihlaja")) ; --UNCHK
lin rowan_tree_N = mkWN (compoundN "koti" (k10 "pihlaja")) ; --UNCHK
lin rowan_berry_N = mkWN (compoundN "pihlajan" (k9 "marja")) ; --UNCHK
lin rowboat_N = mkWN (k48 "vene") ; --UNCHK
lin rowdiness_N = mkWN (k40 "riehakkuus") ; --UNCHK
lin rowdy_A = mkWA (k10 "remuisa") ; --UNCHK
lin rowdy_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin rowdyism_N = mkWN (k40 "riehakkuus") ; --UNCHK
lin rowel_N = mkWN (k10 "pyörä") "kannuksen" ; --UNCHK
lin rower_N = mkWN (k10 "soutaja") ; --UNCHK
lin rowing_N = mkWN (k1A "soutu") ; --UNCHK
lin rowing_boat_N = mkWN (compoundN "soutu" (k48 "vene")) ; --UNCHK
lin rowing_club_N = mkWN (compoundN "soutu" (k1 "kerho")) ; --UNCHK
lin rowlock_N = mkWN (k33 "hankain") ; --UNCHK
lin roy_PN = foreignPN "Roy" ;
lin royal_A = mkWA (k38 "kuninkaallinen") ;
lin royal_N = mkWN (compoundN "uros" (k7 "hirvi")) ; --UNCHK
lin royalism_N = mkWN (k5 "rojalismi") ; --UNCHK
lin royalist_N = mkWN (k5 "rojalisti") ; --UNCHK
lin royalty_N = mkN "kuningas" (mkN "perhe") ;
lin royston_PN = foreignPN "Royston" ;
lin rpm_N = mkWN (compoundN "pyörimis" (k40 "nopeus")) ; --UNCHK
lin rub_N = mkWN (k2 "pyyhkäisy") ; --UNCHK
lin rub_V = mkWV (k73A "hinkata") ; --UNCHK
lin rub_V2 = L.rub_V2 ;
lin rub_along_V = mkWV (k67 "pärjäillä") ; --UNCHK
lin rub_down_V2 = mkWV2 (k52 "hieroa") ; --UNCHK
lin rub_out_V2 = mkWV2 (k61A "pyyhkiä") ; --UNCHK
lin rub_up_N = mkWN (k39 "verestys") ; --UNCHK
lin rubato_N = mkWN (k1 "rubato") ; --UNCHK
lin rubber_A = mkWA (k1A "epäkelpo") ; --UNCHK
lin rubber_N = L.rubber_N ;
lin rubber_V2 = mkWV2 (k53A "kumittaa") ; --UNCHK
lin rubber_stamp_V2 = mkV2 "hyväksyä" ;
lin rubberize_V2 = mkWV2 (k53A "kumittaa") ; --UNCHK
lin rubberneck_N = mkWN (k12 "töllistelijä") ; --UNCHK
lin rubberneck_V = mkWV (k67 "töllistellä") ; --UNCHK
lin rubbery_A = mkWA (compoundA "kumi" (k38 "mainen")) ; --UNCHK
lin rubbing_N = mkWN (k39 "hankaus") ; --UNCHK
lin rubbish_N = mkWN (k6 "liirumlaarum") ; --UNCHK
lin rubbish_V2 = mkWV2 (k73 "teilata") ; --UNCHK
lin rubbishy_A = mkWA (k34A "arvoton") ; --UNCHK
lin rubble_N = mkWN (k1 "romu") ; --UNCHK
lin rub_down_N = mkWN (k9A "hieronta") ; --UNCHK
lin rubefacient_N = mkWN (k48 "aine") "punerruttava" ; --UNCHK
lin rubel_N = mkWN (k10 "rupla") ; --UNCHK
lin rubicelle_N = mkWN (k6 "rubiini") "oranssi" ; --UNCHK
lin rubicon_N = mkWN (k49 "askel") "ratkaiseva" ; --UNCHK
lin rubicund_A = mkWA (k14A "helakka") ; --UNCHK
lin rubidium_N = mkWN "järjestysluku" "37" ; --UNCHK
lin ruble_N = mkWN (k10 "rupla") ; --UNCHK
lin rubric_N = mkWN (k12 "kategoria") ; --UNCHK
lin ruby_A = mkWA (k10 "punertava") ; --UNCHK
lin ruby_N = mkWN (compoundN "rubiinin" (k38 "punainen")) ; --UNCHK
lin ruck_N = mkWN (k41 "rahvas") ; --UNCHK
lin ruck_V = mkWV (k67 "mennä") "kurttuun" ; --UNCHK
lin ruck_V2 = mkWV2 (k67 "mennä") "kurttuun" ; --UNCHK
lin rucksack_N = mkWN (k9A "rinkka") ; --UNCHK
lin ruckus_N = mkWN (k12 "rähinä") ; --UNCHK
lin rudd_N = mkWN (k10 "sorva") ; --UNCHK
lin rudder_N = mkWN (k33 "peräsin") ; --UNCHK
lin rudderfish_N = mkWN "Seriola" "zonata" ; --UNCHK
lin rudderless_A = mkWA (k34A "päämäärätön") ; --UNCHK
lin rudderpost_N = mkWN (k9A "sanka") "peräsimen" ; --UNCHK
lin ruddiness_N = mkWN (k39 "punerrus") ; --UNCHK
lin ruddington_PN = foreignPN "Ruddington" ;
lin ruddle_N = mkWN (compoundN "puna" (k1A "liitu")) ; --UNCHK
lin ruddle_V2 = mkWV2 (k52 "punastua") ; --UNCHK
lin ruddy_A = mkWA (k10 "punertava") ; --UNCHK
lin rude_A = mkWA (k15 "töykeä") ; --UNCHK
lin rudeness_N = mkWN (k40 "töykeys") ; --UNCHK
lin rudiment_N = mkWN (k10 "surkastuma") ; --UNCHK
lin rudimentary_A = mkWA (k10 "alustava") ; --UNCHK
lin rudy_PN = foreignPN "Rudy" ;
lin rue_N = mkWN (k1A "katu") ; --UNCHK
lin rue_V2 = mkWV2 (k52A "katua") ; --UNCHK
lin rueful_A = mkWA (k15 "surkea") ; --UNCHK
lin ruff_N = mkWN "valtilla" "kaataminen" ; --UNCHK
lin ruff_V = mkWV (k58 "iskeä") ; --UNCHK
lin ruff_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin ruffian_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin ruffianism_N = mkWN (k5A "rettelöinti") ; --UNCHK
lin ruffianly_A = mkWA (k10 "kova") ; --UNCHK
lin ruffle_N = mkWN (k9A "riita") ; --UNCHK
lin ruffle_V = mkWV (k53 "laskostaa") ; --UNCHK
lin ruffle_V2 = mkWV2 (k53 "laskostaa") ; --UNCHK
lin rug_N = mkWN (k1 "ryijy") ; --UNCHK
lin ruga_N = mkWN (k1 "poimu") ; --UNCHK
lin rugby_N = mkWN (k1 "rugby") ; --UNCHK
lin rugby_PN = foreignPN "Rugby" ;
lin rugeley_PN = foreignPN "Rugeley" ;
lin rugged_A = mkWA (k9A "vankka") ; --UNCHK
lin ruggedization_N = mkWN "lujittaminen" ; --UNCHK
lin ruggedness_N = mkWN (k40 "vaativuus") ; --UNCHK
lin rugger_N = mkWN (k1 "rugby") ; --UNCHK
lin rugose_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin rugulah_N = mkWN "ruggelach" ; --UNCHK
lin ruin_N = mkWN (k3 "turmio") ; --UNCHK
lin ruin_V2 = mkV2 "pilata" ; --mkV2 "raunioittaa" ;
lin ruin_VS = mkWVS (k52A "raunioitua") ; --UNCHK
lin ruination_N = mkWN (k3 "turmio") ; --UNCHK
lin ruinous_A = mkA "tuhoisa" ;
lin rule_N = L.rule_N ;
lin rule_V = mkWV (k69 "hallita") ; --f54
lin rule_V2 = mkWV2 (k69 "hillitä") ; --UNCHK
lin rule_VS = mkVS (mkV "säätää") ;
lin rule_out_V2 = mkWV2 (k61 "karsia") ; --UNCHK
lin ruler_N = mkWN (k33A "viivoitin") ; --UNCHK
lin rulership_N = mkWN (k9A "valta") ; --UNCHK
lin ruling_A = variants {} ; --
lin ruling_N = mkN "hallinto" ;
lin ruly_A = mkWA (k5 "siisti") ; --UNCHK
lin rum_N = mkWN (kH1 "rommi") ; --UNCHK
lin rumba_N = mkWN (k10 "rumba") ; --UNCHK
lin rumble_N = mkWN (compoundN "jengi" (k2 "tappelu")) ; --UNCHK
lin rumble_V = mkWV (k66 "murista") ; --UNCHK
lin rumble_V2 = mkWV2 (k66 "murista") ; --UNCHK
lin rumbling_N = mkWN (k9A "mylvintä") ; --UNCHK
lin rumbustious_A = mkWA (k34A "vallaton") ; --UNCHK
lin rumen_N = mkWN (k5 "pötsi") ; --UNCHK
lin ruminant_A = mkWA "märehtijä-" ; --UNCHK
lin ruminant_N = mkWN (k12 "märehtijä") ; --UNCHK
lin ruminate_V = mkWV (k61 "tuumia") ; --UNCHK
lin rumination_N = mkWN (compoundN "pulauttelu" (k3 "häiriö")) ; --UNCHK
lin ruminative_A = mkWA (k10 "harkitseva") ; --UNCHK
lin rummage_N = mkWN (k9A "pengonta") ; --UNCHK
lin rummage_V = mkWV (k73 "myllätä") ; --UNCHK
lin rummage_V2 = mkWV2 (k73 "myllätä") ; --UNCHK
lin rummer_N = mkWN (compoundN "juoma" (k5 "lasi")) ; --UNCHK
lin rummy_A = mkWA (k38 "poikkeuksellinen") ; --UNCHK
lin rummy_N = mkWN (kH1 "rommi") ; --UNCHK
lin rumour_N = mkWN (k1 "juoru") ; --UNCHK
lin rumour_V2 = mkWV2 (k74 "juoruta") ; --UNCHK
lin rumour_V3 = mkWV3 (k74 "juoruta") ; --UNCHK
lin rump_N = mkWN (k10 "perä") ; --UNCHK
lin rump_steak_N = mkWN (compoundN "taka" (k5 "paisti")) ; --UNCHK
lin rumple_V2 = mkWV2 (k52A "poimuttua") ; --UNCHK
lin rumpus_N = mkWN (k12 "rähinä") ; --UNCHK
lin rum_runner_N = mkWN (compoundN "sala" (k10 "kuljettaja")) ; --UNCHK
lin run_N = mkN "juoksu" ;
lin run_V = L.run_V ;
lin run_V2 = mkV2 (mkV "suorittaa") accusative | mkV2 "pitää" ; --- split
lin run_across_V2 = mkWV2 (k71 "nähdä") ; --UNCHK
lin run_after_V2 = prepV2 OP_run_V OP_after_Prep ; -- guess-p-verb
lin run_against_V2 = prepV2 OP_run_V OP_against_Prep ; -- guess-p-verb
lin run_along_V = mkWV (k53 "reunustaa") ; --UNCHK
lin run_around_V = mkWV (k68 "karkeloida") ; --UNCHK
lin run_away_V = mkWV (k52A "häipyä") ; --UNCHK
lin run_away_from_V2 = prepV2 (advV OP_run_V OP_away_Adv ) OP_from_Prep ; -- guess-p-verb
lin run_down_V = mkWV (k52 "väsyä") ; --UNCHK
lin run_down_V2 = mkWV2 (k52 "väsyä") ; --UNCHK
lin run_for_V2 = mkWV2 (k53 "kestää") ; --UNCHK
lin run_in_V = advV OP_run_V OP_in_Adv ; -- guess-p-verb
lin run_in_V2 = prepV2 OP_run_V OP_in_Prep ; -- guess-p-verb
lin run_into_V2 = mkWV2 (k52 "osua") "yhteen" ; --UNCHK
lin run_off_V = mkWV (k53 "järjestää") "uusintakierros" ; --UNCHK
lin run_off_V2 = mkWV2 (k53 "järjestää") "uusintakierros" ; --UNCHK
lin run_on_V2 = mkWV2 (k52 "vatvoa") ; --UNCHK
lin run_out_V = mkV "loppua" ; --WV (k52 "väsyä") ;
lin run_out_of_V2 = prepV2 (advV OP_run_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin run_over_V = mkWV (k56 "ajaa") "yli" ; --UNCHK
lin run_over_V2 = mkWV2 (k56 "ajaa") "yli" ; --UNCHK
lin run_through_V2 = mkWV2 (k53A "kuluttaa") "loppuun" ; --UNCHK
lin run_to_V2 = prepV2 OP_run_V OP_to_Prep ; -- guess-p-verb
lin run_up_N = mkN "nousu" ;
lin run_up_V = mkWV (k73 "lisätä") ; --UNCHK
lin run_up_V2 = mkWV2 (k73 "lisätä") ; --UNCHK
lin run_up_against_V2 = prepV2 (advV OP_run_V OP_up_Adv ) OP_against_Prep ; -- guess-p-verb
lin run_up_on_V2 = prepV2 (advV OP_run_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin run_with_V2 = prepV2 OP_run_V OP_with_Prep ; -- guess-p-verb
lin runaway_A = mkWA (k34A "holtiton") ;
lin runaway_N = mkWN (k1A "voitto") "helppo" ; --UNCHK
lin runcinate_A = mkWA (compoundA "terä" (k38 "laitainen")) ; --UNCHK
lin runcorn_PN = foreignPN "Runcorn" ;
lin rundle_N = mkWN (k9 "piena") ; --UNCHK
lin rundown_N = mkWN (k1A "yhteenveto") ; --UNCHK
lin rune_N = mkWN (kH1 "riimu") ; --UNCHK
lin rung_N = mkWN (k9 "piena") ; --UNCHK
lin runic_A = mkWA "riimu-" ; --UNCHK
lin runnel_N = mkWN (k1 "puro") ; --UNCHK
lin runner_N = mkWN "Caranx" "crysos" ; --UNCHK
lin running_A = mkA "juokseva" ;
lin running_N = mkWN (k1 "juoksu") ; --UNCHK
lin running_board_N = mkWN (compoundN "astin" (k9A "lauta")) ; --UNCHK
lin runny_A = mkWA (k10 "juokseva") ; --UNCHK
lin run_off_N = mkWN (k39 "äänestys") "toinen" ; --UNCHK
lin runproof_A = mkWA "purkautumaton" ; --UNCHK
lin runt_N = mkWN (k13 "ipana") ; --UNCHK
lin runup_N = mkWN (k1 "nousu") ; --UNCHK
lin runway_N = mkWN (compoundN "kiito" (k19 "tie")) ;
lin ruokolahti_PN = mkPN (mkN "Ruokolahti" "Ruokolahtia") ;
lin ruotsinpyhtää_PN = mkPN "Ruotsinpyhtää" ;
lin ruovesi_PN = mkPN (mkN "Ruovesi" "Ruovesiä") ;
lin rupee_N = mkWN (k12 "rupia") ; --UNCHK
lin rupert_PN = foreignPN "Rupert" ;
lin rupestral_A = mkWA "kallio-" ; --UNCHK
lin rupiah_N = mkWN (k12 "rupia") ; --UNCHK
lin rupture_N = mkWN "repeäminen" ; --UNCHK
lin rupture_V = mkWV (k52A "rikkoutua") ; --UNCHK
lin rupture_V2 = mkWV2 (k52A "rikkoutua") ; --UNCHK
lin rupturewort_N = mkWN "Herniaria" "glabra" ; --UNCHK
lin rural_A = mkWA (k38 "maalaismainen") ; --UNCHK
lin ruralism_N = mkWN (k40 "maalaismaisuus") ; --UNCHK
lin ruralist_N = mkWN (k38 "maalainen") ; --UNCHK
lin rurality_N = mkWN (k40 "maalaismaisuus") ; --UNCHK
lin ruritanian_A = mkWA (compoundA "ruritani" (k38 "alainen")) ; --UNCHK
lin ruse_N = mkWN (k1A "temppu") ; --UNCHK
lin rush_N = mkWN (k1 "syöksy") ; --UNCHK
lin rush_V = mkV "kiirehtiä" ; --WV (k53A "hoputtaa") ;
lin rush_V2 = mkWV2 (k53A "hoputtaa") ; --UNCHK
lin rush_VS = mkWVS (k53A "hoputtaa") ; --UNCHK
lin rush_VV = variants {} ; -- mkWV2V (k53A "hoputtaa") ; --UNCHK
lin rush_away_V = mkWV (k61A "kiirehtiä") "pois" ; --UNCHK
lin rush_into_V2 = prepV2 OP_rush_V OP_into_Prep ; -- guess-p-verb
lin rush_off_V = mkWV (k61A "kiirehtiä") "pois" ; --UNCHK
lin rush_out_V2 = mkWV2 (k52 "syöksyä") "esiin" ; --UNCHK
lin rusher_N = mkWN "hätäilijä" ; --UNCHK
lin rushlight_N = mkWN (compoundN "kaisla" (k12 "kynttilä")) ; --UNCHK
lin rushlike_A = mkWA (compoundA "sara" (k38 "mainen")) ; --UNCHK
lin rushy_A = mkWA (compoundA "kais" (k38 "lainen")) ; --UNCHK
lin rusk_N = mkWN (k1A "korppu") ; --UNCHK
lin rusko_PN = mkPN "Rusko" ;
lin russet_A = mkWA (compoundA "puna" (k15 "ruskea")) ; --UNCHK
lin russet_N = mkWN (kH1 "kangas") "kotikutoinen" ; --UNCHK
lin russia_PN = foreignPN "Venäjä" ;
lin russianFem_N = mkWN (k10 "venäjä") ; --UNCHK
lin russianMasc_N = mkWN (k10 "venäjä") ; --UNCHK
lin russian_A = mkWA (k38 "venäläinen") ;
lin rust_A = mkWA (compoundA "ruosteen" (k38 "värinen")) ; --UNCHK
lin rust_N = mkWN (compoundN "ruoste" (k26 "sieni")) ; --UNCHK
lin rust_V = mkWV (k52 "ruostua") ; --UNCHK
lin rust_V2 = mkWV2 (k52 "ruostua") ; --UNCHK
lin rustic_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin rustic_N = mkWN (k38 "maalainen") ; --UNCHK
lin rusticate_V = mkWV (compoundV "maa" (k56 "laistaa")) ; --UNCHK
lin rusticate_V2 = mkWV2 (compoundV "maa" (k56 "laistaa")) ; --UNCHK
lin rusticity_N = mkWN (k40 "kömpelyys") ; --UNCHK
lin rustiness_N = mkWN (k40 "ruosteisuus") ; --UNCHK
lin rustle_N = mkWN (k39 "kuiskutus") ; --UNCHK
lin rustle_V = mkWV (k66 "kahista") ; --UNCHK
lin rustle_V2 = mkWV2 (k66 "kahista") ; --UNCHK
lin rustler_N = mkWN (k41A "varas") ; --UNCHK
lin rustless_A = mkWA "ruosteeton" ; --UNCHK
lin rustling_N = mkWN (compoundN "karja" (k40 "varkaus")) ; --UNCHK
lin rustproof_A = mkWA (k34A "ruostumaton") ; --UNCHK
lin rusty_A = mkWA (compoundA "ruosteen" (k38 "värinen")) ; --UNCHK
lin rut_N = mkWN (k10 "uoma") ; --UNCHK
lin rut_V2 = mkWV2 (k71 "tehdä") "uurre" ; --UNCHK
lin rutabaga_N = mkWN (k1A "lanttu") ; --UNCHK
lin ruthenium_N = mkWN (k5 "rutenium") ; --UNCHK
lin rutherfordium_N = mkWN "järjestysluku" "104" ; --UNCHK
lin rutherglen_PN = foreignPN "Rutherglen" ;
lin ruthless_A = mkWA (k34A "häikäilemätön") ; --UNCHK
lin ruthlessness_N = mkWN (k40 "häikäilemättömyys") ; --UNCHK
lin rutile_N = mkWN "rutiili" ; --UNCHK
lin rutland_PN = foreignPN "Rutland" ;
lin ruukki_PN = mkPN (mkN "Ruukki" "Ruukkia") ;
lin rwanda_PN = foreignPN "Ruanda" ;
lin rwandan_A = mkWA (compoundA "ruand" (k38 "alainen")) ; --UNCHK
lin rwandan_N = mkWN (compoundN "ruand" (k38 "alainen")) ; --UNCHK
lin rya_N = mkWN (k1 "ryijy") ; --UNCHK
lin rydberg_N = mkWN (k4A "yksikkö") "Rydbergin" ; --UNCHK
lin ryde_PN = foreignPN "Ryde" ;
lin rye_N = mkWN (compoundN "ruis" (k5 "viski")) ; --UNCHK
lin rye_bread_N = mkWN (compoundN "ruis" (k10A "leipä")) ; --UNCHK
lin rymättylä_PN = mkPN "Rymättylä" ;
lin rääkkylä_PN = mkPN "Rääkkylä" ;
lin saari_PN = mkPN (mkN "Saari" "Saaria") ;
lin saarijärvi_PN = mkPN (mkN "Saarijärvi" "Saarijärviä") ;
lin sabahan_A = mkWA (compoundA "Sabahi" (k38 "lainen")) ; --UNCHK
lin sabahan_N = mkWN (compoundN "Sabahi" (k38 "lainen")) ; --UNCHK
lin sabbat_N = mkWN (compoundN "noita" (k5A "sapatti")) ; --UNCHK
lin sabbatarian_A = mkWA (compoundA "sapatti" (k38 "lainen")) ; --UNCHK
lin sabbatarian_N = mkWN (compoundN "sapatti" (k38 "lainen")) ; --UNCHK
lin sabbath_N = mkWN "Sapatti" ; --UNCHK
lin sabbatia_N = mkWN "sabbatia" ; --UNCHK
lin sabbatical_A = mkWA "sapatti-" ; --UNCHK
lin sabbatical_N = mkWN (compoundN "sapatti" (k27 "vuosi")) ; --UNCHK
lin saber_N = mkWN (k6 "sapeli") ; --UNCHK
lin sabicu_N = mkWN "Lysiloma" "sabicu" ; --UNCHK
lin sable_A = mkWA (k10A "synkkä") ; --UNCHK
lin sable_N = mkWN (k6 "soopeli") ; --UNCHK
lin sabot_N = mkWN (k41A "hollannikas") ; --UNCHK
lin sabotage_N = mkWN (k5 "sabotaasi") ; --UNCHK
lin sabotage_V2 = mkWV2 (k62 "sabotoida") ; --UNCHK
lin saboteurFem_N = mkWN (k5 "sabotööri") ; --UNCHK
lin saboteurMasc_N = mkWN (k5 "sabotööri") ; --UNCHK
lin sabra_N = mkWN (k9 "sabra") ; --UNCHK
lin sabre_N = mkWN (k6 "sapeli") ; --UNCHK
lin sabre_V2 = mkWV2 (k56A "tappaa") "sapelilla" ; --UNCHK
lin sabre_rattling_N = mkWN (k2 "sapelinkalistelu") ; --UNCHK
lin sac_N = mkWN (k5 "pussi") ; --UNCHK
lin saccade_N = mkWN (k39 "nytkähdys") ; --UNCHK
lin saccadic_A = mkWA "nykivä" ; --UNCHK
lin saccharin_N = mkWN (k5 "sakariini") ; --UNCHK
lin saccharine_A = mkWA (k10 "imelä") ; --UNCHK
lin saccharinity_N = mkWN "sakariinisuus" ; --UNCHK
lin sacculated_A = mkWA (compoundA "pussi" (k38 "mainen")) ; --UNCHK
lin saccule_N = mkWN (k5 "pussi") ; --UNCHK
lin sacerdotal_A = mkWA (k38 "papillinen") ; --UNCHK
lin sacerdotalism_N = mkWN (k40 "papillisuus") ; --UNCHK
lin sachem_N = mkWN "sagamore" ; --UNCHK
lin sachet_N = mkWN (k5 "pussi") "pieni" ; --UNCHK
lin sack_N = mkN "säkki" ; --WN (k39 "vapautus") ; ----ARB
lin sack_V2 = mkWV2 (k53A "pussittaa") ; --UNCHK
lin sack_race_N = mkWN (compoundN "pussi" (k1 "juoksu")) ; --UNCHK
lin sackbut_N = mkWN (k13 "pasuuna") ; --UNCHK
lin sackcloth_N = mkWN (k41A "säkkikangas") ; --UNCHK
lin sacking_N = mkWN (k39 "vapautus") ; --UNCHK
lin sacral_A = mkWA "ristiluu-" ; --UNCHK
lin sacrament_N = mkWN (k5A "sakramentti") ; --UNCHK
lin sacramental_A = mkWA "sakramentti-" ; --UNCHK
lin sacramento_PN = foreignPN "Sacramento" ;
lin sacred_A = mkWA (k10 "pyhä") ; --UNCHK
lin sacredness_N = mkWN (k40 "pyhyys") ; --UNCHK
lin sacrifice_N = mkWN (k39 "uhraus") ; --UNCHK
lin sacrifice_V = mkV "uhrautua" ; --mkWV (k73 "uhrata") ;
lin sacrifice_V2 = mkWV2 (k73 "uhrata") ; --UNCHK
lin sacrificeable_A = mkWA "uhrattava" ; --UNCHK
lin sacrificer_N = mkWN "uhraaja" ; --UNCHK
lin sacrificial_A = mkWA "uhri-" ; --UNCHK
lin sacrilege_N = mkWN (k39 "häväistys") ; --UNCHK
lin sacrilegious_A = mkWA (k34A "jumalaton") ; --UNCHK
lin sacrilegiousness_N = mkWN "jumalattomuus" ; --UNCHK
lin sacristan_N = mkWN (k3 "suntio") ; --UNCHK
lin sacristy_N = mkWN (k1 "sakaristo") ; --UNCHK
lin sacrosanct_A = mkWA (k34A "loukkaamaton") ; --UNCHK
lin sacrum_N = mkWN (compoundN "risti" (k18 "luu")) ; --UNCHK
lin sad_A = mkA (lin AK {s = d38 "surullinen"}) ;
lin sadden_V = mkWV (k71 "tehdä") "surulliseksi" ; --UNCHK
lin sadden_V2 = mkWV2 (k71 "tehdä") "surulliseksi" ; --UNCHK
lin saddle_N = mkWN (k10A "selkä") ; --UNCHK
lin saddle_V = mkWV (k53A "sälyttää") ; --UNCHK
lin saddle_V2 = mkWV2 (k53A "sälyttää") ; --UNCHK
lin saddleback_N = mkWN (compoundN "satula" (k1A "katto")) ; --UNCHK
lin saddlebag_N = mkWN (compoundN "satula" (k1A "laukku")) ; --UNCHK
lin saddlebill_N = mkWN (compoundN "afrikansatula" (k12 "haikara")) ; --UNCHK
lin saddler_N = mkWN (compoundN "satula" (k10A "seppä")) ; --UNCHK
lin saddlery_N = mkWN (compoundN "satula" (k9 "paja")) ; --UNCHK
lin sadhe_N = mkWN "tsade" ; --UNCHK
lin sadhu_N = mkWN "saddhu" ; --UNCHK
lin sadism_N = mkWN (k5 "sadismi") ; --UNCHK
lin sadist_N = mkWN (k5 "sadisti") ; --UNCHK
lin sadistic_A = mkWA (k38 "sadistinen") ; --UNCHK
lin sadness_N = mkWN (k40 "surullisuus") ; --UNCHK
lin sadomasochism_N = mkWN (compoundN "sado" (k5 "masokismi")) ; --UNCHK
lin sadomasochistFem_N = mkWN (compoundN "sado" (k5 "masokisti")) ; --UNCHK
lin sadomasochistMasc_N = mkWN (compoundN "sado" (k5 "masokisti")) ; --UNCHK
lin sadomasochistic_A = mkWA (compoundA "sado" (k38 "masokistinen")) ; --UNCHK
lin safari_N = mkWN (k6 "safari") ; --UNCHK
lin safe_A = mkWA (k38 "turvallinen") ; --f70
lin safe_N = mkWN (k5A "kortonki") ; --UNCHK
lin safe_deposit_A = mkA "turvattu" ; ---?? different POS ; turva-, talle-
lin safebreaker_N = mkWN (k10 "murtautuja") ; --UNCHK
lin safecracker_N = mkWN (k10 "murtautuja") ; --UNCHK
lin safeguard_N = mkWN (kH1 "suoja") ; --UNCHK
lin safeguard_V2 = mkWV2 (k73 "turvata") ; --UNCHK
lin safehold_N = mkWN (compoundN "turva" (k9A "paikka")) ; --UNCHK
lin safekeeping_N = mkWN (k10 "turva") ; --UNCHK
lin safeness_N = mkWN (k10 "turva") ; --UNCHK
lin safety_N = mkN "turvallisuus" ;
lin safety_belt_N = mkWN (compoundN "turva" (k19 "vyö")) ; --UNCHK
lin safety_bolt_N = mkWN (k7A "telki") ; --UNCHK
lin safety_catch_N = mkWN (k33 "varmistin") ; --UNCHK
lin safety_curtain_N = mkWN (compoundN "palo" (k1A "esirippu")) ; --UNCHK
lin safety_factor_N = mkWN (k33A "turvallisuuskerroin") ; --UNCHK
lin safety_lamp_N = mkWN (compoundN "varmuus" (k1A "lamppu")) ; --UNCHK
lin safety_lock_N = mkWN (k7A "telki") ; --UNCHK
lin safety_match_N = mkWN "varmuustulitikku" ; --UNCHK
lin safety_pin_N = mkWN (compoundN "haka" (k9 "neula")) ; --UNCHK
lin safety_razor_N = mkWN (compoundN "parta" (k10 "höylä")) ; --UNCHK
lin safety_valve_N = mkWN (compoundN "vara" (k6 "venttiili")) ; --UNCHK
lin safflower_N = mkWN (k6 "saflori") ; --UNCHK
lin saffron_N = mkWN (compoundN "oranssin" (k38 "keltainen")) ; --UNCHK
lin safranine_N = mkWN (compoundN "safra" (k26 "niini")) ; --UNCHK
lin sag_N = mkWN (k10 "painauma") ; --UNCHK
lin sag_V = mkWV (k52A "riippua") ; --UNCHK
lin saga_N = mkWN (k9 "saaga") ; --UNCHK
lin sagacious_A = mkWA (k41 "viisas") ; --UNCHK
lin sagacity_N = mkWN (k40 "viisaus") ; --UNCHK
lin sage_A = mkWA (compoundA "harmaan" (k15 "vihreä")) ; --UNCHK
lin sage_N = mkWN (k12 "salvia") ; --UNCHK
lin sage_green_N = mkWN (compoundN "harmaan" (k15 "vihreä")) ; --UNCHK
lin sagebrush_N = mkWN (k11 "maruna") ; --UNCHK
lin sagitta_N = mkWN (compoundN "nuoli" (k1A "mato")) ; --UNCHK
lin sagittal_A = mkWA (compoundA "sagitta" (k38 "alinen")) ; --UNCHK
lin sagittate_A = mkWA (k38 "nuolimainen") ; --UNCHK
lin sago_N = mkWN (k1 "saago") ; --UNCHK
lin saguaro_N = mkWN "Carnegiea" "gigantea" ; --UNCHK
lin sahalahti_PN = mkPN (mkN "Sahalahti" "Sahalahtia") ;
lin sahib_N = mkWN "sahib" ; --UNCHK
lin said_Quant = mkQuant (mkN "mainittu") ;
lin saiga_N = mkWN (compoundN "Saiga-" (k5A "antilooppi")) ; --UNCHK
lin sail_N = mkWN (k39 "purjehdus") ; --UNCHK
lin sail_V = mkWV (k73 "seilata") ; --UNCHK
lin sail_into_V2 = prepV2 OP_sail_V OP_into_Prep ; -- guess-p-verb
lin sail_through_V2 = prepV2 OP_sail_V OP_through_Prep ; -- guess-p-verb
lin sailboat_N = mkWN (compoundN "purje" (k48 "vene")) ; --UNCHK
lin sailcloth_N = mkWN (k41A "purjekangas") ; --UNCHK
lin sailfish_N = mkWN (compoundN "purje" (k9 "kala")) ; --UNCHK
lin sailing_N = mkWN (k1A "lähtö") ; --UNCHK
lin sailing_boat_N = mkWN (compoundN "purje" (k48 "vene")) ; --UNCHK
lin sailing_master_N = mkWN (k6 "navigaattori") ; --UNCHK
lin sailing_ship_N = mkWN (compoundN "purje" (k39 "alus")) ; --UNCHK
lin sailing_vessel_N = mkWN (compoundN "purje" (k39 "alus")) ; --UNCHK
lin sailmaker_N = mkWN (compoundN "purjeen" (k12 "tekijä")) ; --UNCHK
lin sailor_N = mkWN (compoundN "panama" (k1A "hattu")) ; --UNCHK
lin sainfoin_N = mkWN "Onobrychis" "viciaefolia" ; --UNCHK
lin saint's_day_N = mkWN (k10 "päivä") "pyhimyksen" ; --UNCHK
lin saint_N = mkWN (k5 "ideaali") ; --UNCHK
lin sainted_A = mkWA (k10 "pyhä") ; --UNCHK
lin sainthood_N = mkWN (k40 "pyhyys") ; --UNCHK
lin saintlike_A = mkWA (k10 "pyhä") ; --UNCHK
lin saintliness_N = mkWN (k40 "pyhyys") ; --UNCHK
lin saintly_A = mkWA (k10 "pyhä") ; --UNCHK
lin sake_1_N = variants {} ; --
lin sake_2_N = variants {} ; --
lin sake_N = mkWN (k1A "hyöty") ; --UNCHK
lin saki_N = mkWN (compoundN "piru" (k12 "apina")) ; --UNCHK
lin sal_volatile_N = mkWN (compoundN "haju" (k9 "suola")) ; --UNCHK
lin salaam_N = mkWN "salaam" ; --UNCHK
lin salability_N = mkWN (compoundN "myynti" (k40 "kelpoisuus")) ; --UNCHK
lin salable_A = mkWA (compoundA "myynti" (k38 "kelpoinen")) ; --UNCHK
lin salacious_A = mkWA (k34A "moraaliton") ; --UNCHK
lin salaciousness_N = mkWN (k40 "riettaus") ; --UNCHK
lin salacity_N = mkWN (k40 "riettaus") ; --UNCHK
lin salad_N = mkWN (k5A "salaatti") ; --UNCHK
lin salad_dressing_N = mkWN (k48A "kastike") ; --UNCHK
lin salad_oil_N = mkWN (compoundN "salaatti" (k1 "öljy")) ; --UNCHK
lin salai_N = mkWN (compoundN "ser" (k9A "rata")) "Boswellia" ; --UNCHK
lin salal_N = mkWN "Gaultheria" "shallon" ; --UNCHK
lin salamanca_PN = foreignPN "Salamanca" ;
lin salamander_N = mkWN (k6 "salamanteri") ; --UNCHK
lin salamandriform_A = mkWA (compoundA "salamanteri" (k38 "mainen")) ; --UNCHK
lin salami_N = mkWN (k5 "salami") ; --UNCHK
lin salaried_A = mkWA (k38 "palkallinen") ; --UNCHK
lin salary_N = mkN "palkka" ;
lin salat_N = mkWN (compoundN "rukous" (k7 "hetki")) ; --UNCHK
lin sale_N = mkN "myynti" ;
lin sale_PN = foreignPN "Sale" ;
lin saleable_A = mkWA (compoundA "myynti" (k38 "kelpoinen")) ; --UNCHK
lin salerno_PN = foreignPN "Salerno" ;
lin saleroom_N = mkWN (k12 "myymälä") ; --UNCHK
lin salesclerk_N = mkWN (compoundN "myymälä" (k38 "apulainen")) ; --UNCHK
lin salesgirl_N = mkWN (k10 "myyjä") ; --UNCHK
lin salesman_N = mkWN (compoundN "myynti" (k42 "mies")) ;
lin salesmanship_N = mkWN (compoundN "myynti" (k1A "taito")) ; --UNCHK
lin salesperson_N = mkWN (k10 "myyjä") ; --UNCHK
lin saleswoman_N = mkWN (k10 "myyjä") ; --UNCHK
lin salford_PN = foreignPN "Salford" ;
lin salicylate_N = mkWN (k5A "salisylaatti") ; --UNCHK
lin salience_N = mkWN (k40 "silmiinpistävyys") ; --UNCHK
lin salient_A = mkWA (k10 "ulkoneva") ; --UNCHK
lin salient_N = mkWN (compoundN "rintama" (k9 "kiila")) ; --UNCHK
lin saliferous_A = mkWA (compoundA "suolapi" (k38 "toinen")) ; --UNCHK
lin saline_A = mkWA (compoundA "suolapi" (k38 "toinen")) ; --UNCHK
lin saline_N = mkWN (compoundN "suola" (k39 "liuos")) ; --UNCHK
lin salinity_N = mkWN (k40 "suolaisuus") ; --UNCHK
lin salinometer_N = mkWN (k6 "mittari") "suolapitoisuuden" ; --UNCHK
lin salisbury_PN = foreignPN "Salisbury" ;
lin saliva_N = mkWN (k7A "sylki") ; --UNCHK
lin salivary_A = mkWA "sylki-" ; --UNCHK
lin salivate_V = mkWV (k73 "kuolata") ; --UNCHK
lin salivation_N = mkWN (compoundN "syljen" (k39 "eritys")) ; --UNCHK
lin salla_PN = mkPN "Salla" ;
lin sallet_N = mkWN (k10 "kypärä") ; --UNCHK
lin sallow_A = mkWA (k15 "kelmeä") ; --UNCHK
lin sallow_N = mkWN (k1 "paju") ; --UNCHK
lin sallow_V = mkWV (k54A "kalventaa") ; --UNCHK
lin sallow_V2 = mkWV2 (k54A "kalventaa") ; --UNCHK
lin sallowness_N = mkWN (k40 "kelmeys") ; --UNCHK
lin sally_N = mkWN (k39 "poikkeus") ; --UNCHK
lin sally_forth_V = mkWV (k60A "lähteä") "matkaan" ; --UNCHK
lin sally_out_V = mkWV (k52 "syöksyä") "esiin" ; --UNCHK
lin salmagundi_N = mkWN "salmagundi" ; --UNCHK
lin salmi_N = mkWN (k1 "höystö") ; --UNCHK
lin salmon_N = mkWN (k23 "lohi") ; --UNCHK
lin salmonberry_N = mkWN "Rubus" "spectabilis" ; --UNCHK
lin salmonella_N = mkWN (k9 "salmonella") ; --UNCHK
lin salmonellosis_N = mkWN (k5 "salmonelloosi") ; --UNCHK
lin salmonid_N = mkWN (compoundN "lohi" (k9 "kala")) ; --UNCHK
lin salo_PN = mkPN "Salo" ;
lin salol_N = mkWN (compoundN "fenyyli" (k5A "salisylaatti")) ; --UNCHK
lin salon_N = mkWN (k5A "salonki") ; --UNCHK
lin saloon_N = mkWN (k13 "saluuna") ; --UNCHK
lin salp_N = mkWN "Salpidae" ; --UNCHK
lin salpiglossis_N = mkWN "salpiglossis" ; --UNCHK
lin salpingectomy_N = mkWN (k1 "poisto") "munanjohtimen" ; --UNCHK
lin salpingitis_N = mkWN (k39 "tulehdus") "munanjohtimen" ; --UNCHK
lin salpinx_N = mkWN (k33A "johdin") ; --UNCHK
lin salsa_N = mkWN (k9 "salsa") ; --UNCHK
lin salsify_N = mkWN (k26 "kaurajuuri") ; --UNCHK
lin salsilla_N = mkWN "Bomarea" "edulis" ; --UNCHK
lin salt_A = mkWA (k38 "suolainen") ; --UNCHK
lin salt_N = L.salt_N ;
lin salt_PN = foreignPN "Salt" ;
lin salt_V2 = mkWV2 (k73 "suolata") ; --UNCHK
lin salt_away_V2 = mkWV2 (k62 "varastoida") ; --UNCHK
lin salt_lick_N = mkWN (compoundN "nuolu" (k7 "kivi")) ; --UNCHK
lin saltash_PN = foreignPN "Saltash" ;
lin saltation_N = mkWN (k39 "hyppäys") ; --UNCHK
lin saltbox_N = mkWN (compoundN "talo" (k5 "malli")) ; --UNCHK
lin saltbush_N = mkWN "atriplex" ; --UNCHK
lin salt_cellar_N = mkWN (compoundN "suola" (k33A "sirotin")) ; --UNCHK
lin saltcoats_PN = foreignPN "Saltcoats" ;
lin salter_N = mkWN (compoundN "suola" (k41 "kauppias")) ; --UNCHK
lin saltine_N = mkWN (k5 "suolakeksi") ; --UNCHK
lin saltiness_N = mkWN (compoundN "suola" (k40 "pitoisuus")) ; --UNCHK
lin salting_N = mkWN (k39 "suolaus") ; --UNCHK
lin saltish_A = mkWA (k38 "suolainen") "hieman" ; --UNCHK
lin saltlike_A = mkWA (compoundA "suola" (k38 "mainen")) ; --UNCHK
lin saltpan_N = mkWN (compoundN "suola" (k10A "kuoppa")) ; --UNCHK
lin saltpetre_N = mkWN (k6 "salpietari") ; --UNCHK
lin saltshaker_N = mkWN (compoundN "suola" (k33A "sirotin")) ; --UNCHK
lin saltwater_N = mkWN (compoundN "suola" (k27 "vesi")) ; --UNCHK
lin saltworks_N = mkWN (compoundN "suola" (k41A "tehdas")) ; --UNCHK
lin saltwort_N = mkWN "Batis" "maritima" ; --UNCHK
lin salty_A = mkWA (k38 "suolainen") ; --UNCHK
lin salubrious_A = mkWA (k10 "tekevä") "hyvää" ; --UNCHK
lin salubrity_N = mkWN (k40 "terveellisyys") ; --UNCHK
lin salutary_A = mkWA (k38 "terveellinen") ; --UNCHK
lin salutation_N = mkWN (k39 "tervehdys") ; --UNCHK
lin salutatorian_N = mkWN "salutatory" "speaker" ; --UNCHK
lin salute_N = mkWN (k39 "tervehdys") ; --UNCHK
lin salute_V = mkWV (k71 "tehdä") "kunniaa" ; --UNCHK
lin salute_V2 = mkWV2 (k71 "tehdä") "kunniaa" ; --UNCHK
lin salvador_PN = foreignPN "Salvador" ;
lin salvadorean_A = mkWA (compoundA "salvadori" (k38 "lainen")) ; --UNCHK
lin salvadorean_N = mkWN (compoundN "salvadori" (k38 "lainen")) ; --UNCHK
lin salvage_N = mkWN (k39 "pelastus") ; --UNCHK
lin salvage_V2 = mkV2 "pelastaa" ; --mkWV2 (k53A "ottaa") "talteen" ;
lin salvageable_A = mkWA (k10 "oleva") "pelastettavissa" ; --UNCHK
lin salvager_N = mkWN (k10 "pelastaja") ; --UNCHK
lin salvation_N = mkWN (k39 "lunastus") ; --UNCHK
lin salve_N = mkWN (k6 "balsami") ; --UNCHK
lin salve_V2 = mkWV2 (k67A "voidella") "salvalla" ; --UNCHK
lin salver_N = mkWN (k33A "tarjotin") ; --UNCHK
lin salverform_A = mkWA (compoundA "sahramin" (k38 "muotoinen")) ; --UNCHK
lin salvia_N = mkWN (k12 "salvia") ; --UNCHK
lin salvific_A = mkWA "pelastava" ; --UNCHK
lin salvinorin_N = mkWN "salvinoriini" ; --UNCHK
lin salvo_N = mkWN (k39 "tulitus") ; --UNCHK
lin salwar_N = mkWN "shalwar" ; --UNCHK
lin salzburg_PN = foreignPN "Salzburg" ;
lin sam_PN = mkPN "Sam" ;
lin samara_N = mkWN (k1A "palko") ; --UNCHK
lin samaritan_N = mkN "samarialainen" ;
lin samarium_N = mkN "samarium" ;
lin samba_N = mkWN (k9 "samba") ; --UNCHK
lin sambar_N = mkWN "Cervus" "unicolor" ; --UNCHK
lin sambuca_N = mkWN "sambuca" ; --UNCHK
lin same_A = mkWA (k9 "sama") ; --f381
lin samekh_N = mkWN "sameḥ" ; --UNCHK
lin sameness_N = mkWN (k40 "samanlaisuus") ; --UNCHK
lin samite_N = mkWN (k41A "silkkikangas") ; --UNCHK
lin samizdat_N = mkWN (k13 "media") "maanalainen" ; --UNCHK
lin sammatti_PN = mkPN (mkN "Sammatti") ;
lin samoa_PN = foreignPN "Samoa" ;
lin samoan_A = mkWA (compoundA "samo" (k38 "alainen")) ; --UNCHK
lin samoan_N = mkWN (compoundN "samo" (k38 "alainen")) ; --UNCHK
lin samosa_N = mkWN (compoundN "sam" (k10 "osa")) ; --UNCHK
lin samovar_N = mkWN (k5 "samovaari") ; --UNCHK
lin sampan_N = mkWN (k5 "sampaani") ; --UNCHK
lin sample_N = mkWN (k39 "otos") ; --UNCHK
lin sample_V2 = mkWV2 (k67 "kokeilla") ; --UNCHK
lin sampler_N = mkWN (compoundN "brodeeraus" (k48A "näyte")) ; --UNCHK
lin sampling_N = mkWN (k9A "otanta") ; --UNCHK
lin samsara_N = mkWN (compoundN "sam" (k9 "sara")) ; --UNCHK
lin samurai_N = mkWN (k18 "samurai") ; --UNCHK
lin san_antonio_PN = foreignPN "San Antonio" ;
lin san_bernardino_PN = foreignPN "San Bernardino" ;
lin san_diego_PN = foreignPN "San Diego" ;
lin san_francisco_PN = foreignPN "San Francisco" ;
lin san_jose_PN = foreignPN "San José" ;
lin san_juan_PN = foreignPN "San Juan" ;
lin san_marinese_A = mkWA (compoundA "sanmarino" (k38 "lainen")) ; --UNCHK
lin san_marinese_N = mkWN (compoundN "sanmarino" (k38 "lainen")) ; --UNCHK
lin san_marino_PN = foreignPN "San Marino" ;
lin san_sebastian_PN = foreignPN "San Sebastian" ;
lin sanatorium_N = mkWN (k3 "sanatorio") ; --UNCHK
lin sanctification_N = mkWN (k39 "pyhitys") ; --UNCHK
lin sanctify_V2 = mkWV2 (k53A "pyhittää") ; --UNCHK
lin sanctimonious_A = mkWA (k38 "kaltainen") "fariseuksen" ; --UNCHK
lin sanctimoniousness_N = mkWN (k2 "hurskastelu") ; --UNCHK
lin sanction_N = mkN "sanktio" ;
lin sanction_V2 = mkWV2 (k56A "antaa") "suostumus" ; --UNCHK
lin sanctionative_A = mkWA "valtuuttava" ; --UNCHK
lin sanctity_N = mkWN (k40 "pyhyys") ; --UNCHK
lin sanctuary_N = mkWN (kH1 "kuori") ; --UNCHK
lin sanctum_N = mkWN (k9A "paikka") "pyhä" ; --UNCHK
lin sand_N = L.sand_N ;
lin sand_V2 = mkWV2 (k52 "hioa") ; --UNCHK
lin sand_bar_N = mkWN (k10A "särkkä") ; --UNCHK
lin sandal_N = mkWN (k6 "sandaali") ; --UNCHK
lin sandaled_A = mkWA (k10 "pitävä") "sandaaleita" ; --UNCHK
lin sandalled_A = mkWA (k10 "pitävä") "sandaaleita" ; --UNCHK
lin sandalwood_N = mkWN (compoundN "santeli" (k18 "puu")) ; --UNCHK
lin sandarac_N = mkWN (compoundN "articu" (k9A "lata")) "Tetraclinis" ; --UNCHK
lin sandbach_PN = foreignPN "Sandbach" ;
lin sandbag_N = mkWN (compoundN "hiekka" (k5A "säkki")) ; --UNCHK
lin sandbagger_N = mkWN (k6 "huijari") ; --UNCHK
lin sandbank_N = mkWN (k10A "särkkä") ; --UNCHK
lin sandblast_N = mkWN (compoundN "hiekka" (k39 "puhallus")) ; --UNCHK
lin sandblast_V2 = mkWV2 (compoundV "hiekka" (k54A "puhaltaa")) ; --UNCHK
lin sandblaster_N = mkWN (compoundN "hiekka" (k33A "puhallin")) ; --UNCHK
lin sandbox_N = mkWN (compoundN "hiekka" (k10A "kuoppa")) ; --UNCHK
lin sandboy_N = mkWN (compoundN "hiekanmyyjä" (k10A "poika")) ; --UNCHK
lin sandbur_N = mkWN "Cenchrus" "tribuloides" ; --UNCHK
lin sanderling_N = mkWN (k9 "alba") "Crocethia" ; --UNCHK
lin sandfish_N = mkWN (compoundN "lohi" (k9 "kala")) ; --UNCHK
lin sandfly_N = mkWN "Phlebotomus" "papatasii" ; --UNCHK
lin sandglass_N = mkWN (compoundN "tiima" (k5 "lasi")) ; --UNCHK
lin sandgrouse_N = mkWN (compoundN "hieta" (k9 "kana")) ; --UNCHK
lin sandhi_N = mkWN (compoundN "sandhi-" (k3 "ilmiö")) ; --UNCHK
lin sandiness_N = mkWN (k40 "rakeisuus") ; --UNCHK
lin sandlot_N = mkWN (k5A "tontti") "tyhjä" ; --UNCHK
lin sandman_N = mkWN (k5A "nukkumatti") ; --UNCHK
lin sandown_PN = foreignPN "Sandown" ;
lin sandpaper_N = mkWN (compoundN "hiekka" (k6 "paperi")) ; --UNCHK
lin sandpaper_V2 = mkWV2 (k52 "hioa") ; --UNCHK
lin sandpapery_A = mkWA (compoundA "hiekkapaperi" (k38 "mainen")) ; --UNCHK
lin sandpiper_N = mkWN (k10A "kurppa") ; --UNCHK
lin sandpit_N = mkWN (compoundN "hiekka" (k10A "kuoppa")) ; --UNCHK
lin sandstone_N = mkWN (compoundN "hiekka" (k7 "kivi")) ; --UNCHK
lin sandstorm_N = mkWN (compoundN "hiekka" (k1 "myrsky")) ; --UNCHK
lin sandwich_N = mkWN (compoundN "voi" (k10A "leipä")) ; --UNCHK
lin sandwich_V = mkV vOlla "litistyksissä" ;
lin sandwich_V2 = mkV2 (mkV "laittaa") (mkPrep "väliin") ; ---- ? dir obj missing now ; although I imagine it's used more in passive.
lin sandwich_board_N = mkWN (k5A "kyltti") "kaksinkertainen" ; --UNCHK
lin sandwichman_N = mkWN (k10 "mainostaja") ; --UNCHK
lin sandwort_N = mkWN "Moehringia" ; --UNCHK
lin sandy_A = mkWA (k38 "hiekkainen") ; --UNCHK
lin sandy_PN = foreignPN "Sandy" ;
lin sane_A = mkWA (k48 "terve") ; --UNCHK
lin sangapenum_N = mkWN "sangapenum" ; --UNCHK
lin sangaree_N = mkWN (k12 "sangria") ; --UNCHK
lin sango_N = mkWN "sango" ; --UNCHK
lin sangoma_N = mkWN (compoundN "sang" (k10 "oma")) ; --UNCHK
lin sanguinary_A = mkWA (k38 "verinen") ; --UNCHK
lin sanguine_A = mkWA (k14A "helakka") ; --UNCHK
lin sanguine_N = mkWN (compoundN "veren" (k38 "punainen")) ; --UNCHK
lin sanguinity_N = mkWN (k5 "optimismi") ; --UNCHK
lin sanicle_N = mkWN (compoundN "haava" (k5A "yrtti")) ; --UNCHK
lin sanitariness_N = mkWN (k40 "hygieenisyys") ; --UNCHK
lin sanitary_A = mkWA (k38 "terveellinen") ; --UNCHK
lin sanitation_N = mkWN (k39 "puhdistus") ; --UNCHK
lin sanitize_V2 = mkWV2 (k61 "siistiä") ; --UNCHK
lin sanity_N = mkWN (compoundN "mielen" (k40 "terveys")) ; --UNCHK
lin sannup_N = mkWN "sannup" ; --UNCHK
lin sannyasi_N = mkWN "sanyasi" ; --UNCHK
lin sans_Prep = mkPrep "ilman" partitive ;
lin sansevieria_N = mkWN (compoundN "anopin" (k26 "kieli")) ; --UNCHK
lin sanskrit_N = mkWN (compoundN "Sanskrit-" (k26 "kieli")) ; --UNCHK
lin santa_claus_N = mkWN (compoundN "joulu-" (k1A "ukko")) ; --UNCHK
lin santander_PN = foreignPN "Santander" ;
lin santiago_PN = foreignPN "Santiago de Chile" ;
lin santims_N = mkWN "santims" ; --UNCHK
lin santos_PN = foreignPN "Santos" ;
lin sap_N = mkWN (k14A "pulikka") ; --UNCHK
lin sap_V = mkWV (k56 "kaivaa") ; --UNCHK
lin sap_V2 = mkWV2 (k56 "kaivaa") ; --UNCHK
lin saphead_N = mkWN (k1 "pöllö") ; --UNCHK
lin sapidity_N = mkWN (k40 "maukkaus") ; --UNCHK
lin sapience_N = mkWN (k39 "tietämys") ; --UNCHK
lin sapiens_A = mkWA "sapiens" ; --UNCHK
lin sapient_A = mkWA (k41A "älykäs") ; --UNCHK
lin sapiential_A = mkWA (k41 "viisas") ; --UNCHK
lin sapless_A = mkWA (k34A "eloton") ; --UNCHK
lin sapling_N = mkWN (k25 "taimi") ; --UNCHK
lin sapodilla_N = mkWN "sapodilla" ; --UNCHK
lin saponaceous_A = mkWA (compoundA "saippua" (k38 "mainen")) ; --UNCHK
lin saponification_N = mkWN "saippuoiminen" ; --UNCHK
lin saponified_A = mkWA (compoundA "saippuo" (k1A "itu")) ; --UNCHK
lin saponin_N = mkWN (compoundN "sapo" (k26 "niini")) ; --UNCHK
lin sapote_N = mkWN (compoundN "sap" (k48A "ote")) ; --UNCHK
lin sapper_N = mkWN "juoksuhaudankaivaja" ; --UNCHK
lin sapphic_A = mkWA "lesbo-" ; --UNCHK
lin sapphire_A = mkWA "safiiri-" ; --UNCHK
lin sapphire_N = mkWN (k38 "sininen") ; --UNCHK
lin sapphirine_A = mkWA (compoundA "safiiri" (k38 "nen")) ; --UNCHK
lin sapphirine_N = mkWN "safiriini" ; --UNCHK
lin sapporo_PN = foreignPN "Sapporo" ;
lin sappy_A = mkWA (k38 "mahlainen") ; --UNCHK
lin sapremia_N = mkWN (compoundN "veren" (k39 "myrkytys")) ; --UNCHK
lin saprobe_N = mkWN "saprobi" ; --UNCHK
lin saprobic_A = mkWA "saprobinen" ; --UNCHK
lin saprolite_N = mkWN "saproliitti" ; --UNCHK
lin saprophagous_A = mkWA "saprotrofinen" ; --UNCHK
lin saprophyte_N = mkWN (compoundN "marras" (k3 "eliö")) ; --UNCHK
lin saprophytic_A = mkWA "saprofyyttinen" ; --UNCHK
lin sapsago_N = mkWN "sapsago" ; --UNCHK
lin sapsucker_N = mkWN (compoundN "mahla" (k9A "tikka")) ; --UNCHK
lin sapwood_N = mkWN (compoundN "pinta" (k18 "puu")) ; --UNCHK
lin saquinavir_N = mkWN (compoundN "Invir" (k48 "ase")) ; --UNCHK
lin sara_PN = foreignPN "Sara" ;
lin saraband_N = mkWN "sarabande" ; --UNCHK
lin saracen_N = mkWN "saraseeni" ; --UNCHK
lin sarajevo_PN = foreignPN "Sarajevo" ;
lin saran_N = mkWN (k5 "muovi") ; --UNCHK
lin saratov_PN = foreignPN "Saratov" ;
lin sarawakian_A = mkWA (compoundA "sarawaki" (k38 "lainen")) ; --UNCHK
lin sarawakian_N = mkWN (compoundN "sarawaki" (k38 "lainen")) ; --UNCHK
lin sarcasm_N = mkWN (k12 "ironia") ; --UNCHK
lin sarcastic_A = mkWA (k38 "sarkastinen") ; --UNCHK
lin sarcenet_N = mkWN (k5A "silkki") ; --UNCHK
lin sarcodinian_N = mkWN (compoundN "juuri" (k33 "eläin")) ; --UNCHK
lin sarcoidosis_N = mkWN "sarkoidoosi" ; --UNCHK
lin sarcolemma_N = mkWN "sarkolemma" ; --UNCHK
lin sarcolemmal_A = mkWA "sarkolemma-" ; --UNCHK
lin sarcolemmic_A = mkWA "sarkolemmaan" "liittyvä" ; --UNCHK
lin sarcoma_N = mkWN (k10 "sarkooma") ;
lin sarcophagus_N = mkWN (k5 "sarkofagi") ; --UNCHK
lin sarcoplasm_N = mkWN (compoundN "solu" (k9 "lima")) "lihassolun" ; --UNCHK
lin sarcosine_N = mkWN "sarkosiini" ; --UNCHK
lin sarcosomal_A = mkWA "sarkosominen" ; --UNCHK
lin sarcosome_N = mkWN (compoundN "sarco" (k10 "soma")) ; --UNCHK
lin sarcosporidian_N = mkWN "sporotsoiitti" ; --UNCHK
lin sardine_N = mkWN (k6 "sardiini") ; --UNCHK
lin sardonic_A = mkWA (k38 "ivallinen") ; --UNCHK
lin sardonyx_N = mkWN (compoundN "sardon" (k31 "yksi")) ; --UNCHK
lin sari_N = mkWN (k5 "sari") ; --UNCHK
lin sarin_N = mkWN "GB" ; --UNCHK
lin sarong_N = mkWN "sarong" ; --UNCHK
lin sarsaparilla_N = mkWN "sarsaparilla" ; --UNCHK
lin sartorial_A = mkWA "vaatetukseen" "kohdistuva" ; --UNCHK
lin sartorius_N = mkWN (compoundN "räätälin" (k39 "lihas")) ; --UNCHK
lin sash_N = mkWN (k19 "vyö") ; --UNCHK
lin sash_cord_N = mkWN (k6 "vaijeri") "liukuikkunan" ; --UNCHK
lin sash_line_N = mkWN (k6 "vaijeri") "liukuikkunan" ; --UNCHK
lin sashay_N = mkWN (k9 "matka") ; --UNCHK
lin sashimi_N = mkWN "sashimi" ; --UNCHK
lin saskatoon_N = mkWN (compoundN "pihlajan" (k9 "marja")) ; --UNCHK
lin sass_N = mkWN (k9A "suunpieksentä") ; --UNCHK
lin sassaby_N = mkWN (compoundN "sassabian" (k5A "antilooppi")) ; --UNCHK
lin sassafras_N = mkWN "sassafras" ; --UNCHK
lin sassari_PN = foreignPN "Sassari" ;
lin sassenach_N = mkWN "Sassenach" ; --UNCHK
lin satan_N = mkWN (k10 "riivaaja") ; --UNCHK
lin satang_N = mkWN "satang" ; --UNCHK
lin satanic_A = mkWA (k38 "saatanallinen") ; --UNCHK
lin satanophobia_N = mkWN (compoundN "satano" (k12 "fobia")) ; --UNCHK
lin satchel_N = mkWN (compoundN "olka" (k1A "laukku")) ; --UNCHK
lin sate_V2 = mkWV2 (k53A "tyydyttää") ; --UNCHK
lin sateen_N = mkWN (k6 "satiini") ; --UNCHK
lin satellite_A = mkWA "periferia-" ; --UNCHK
lin satellite_N = mkWN (k5A "satelliitti") ; --UNCHK
lin satiable_A = mkWA (k10 "oleva") "tyydytettävissä" ; --UNCHK
lin satiate_A = mkWA (k38 "kylläinen") ; --UNCHK
lin satiate_V2 = mkWV2 (k61 "hotkia") ; --UNCHK
lin satiation_N = mkWN (k39 "tyydytys") ; --UNCHK
lin satiety_N = mkWN (k40 "kylläisyys") ; --UNCHK
lin satin_N = mkWN (k6 "satiini") ; --UNCHK
lin satinet_N = mkWN (kH1 "kangas") "satiinimainen" ; --UNCHK
lin satinleaf_N = mkWN "Chrysophyllum" "oliviforme" ; --UNCHK
lin satinwood_N = mkWN (compoundN "satiini" (k18 "puu")) ; --UNCHK
lin satiny_A = mkWA (k38 "silkkinen") ; --UNCHK
lin satire_N = mkWN (k12 "ironia") ; --UNCHK
lin satirical_A = mkWA (k38 "satiirinen") ; --UNCHK
lin satirist_N = mkWN (k10 "pilkkaaja") ; --UNCHK
lin satirize_V2 = mkWV2 (k73A "pilkata") ; --UNCHK
lin satisfaction_N = mkN "tyytyväisyys" ;
lin satisfactoriness_N = mkWN (k40 "hyväksyttävyys") ; --UNCHK
lin satisfactory_A = mkWA (k10 "tyydyttävä") ; --UNCHK
lin satisfied_A = variants {} ; --
lin satisfier_N = mkWN (k10 "tyydyttäjä") ; --UNCHK
lin satisfy_V2 = mkWV2 (k53A "toteuttaa") ; --UNCHK
lin satrap_N = mkWN (k5A "satraappi") ; --UNCHK
lin satsuma_N = mkWN (k10 "satsuma") ; --UNCHK
lin saturate_V2 = mkWV2 (k53 "kyllästää") ; --UNCHK
lin saturation_N = mkWN (compoundN "kyllä" (k38 "stäminen")) ; --UNCHK
lin saturniid_N = mkWN (compoundN "riikinkukko" (k10 "kehrääjä")) ; --UNCHK
lin saturnine_A = mkWA (k15 "äreä") ; --UNCHK
lin satyr_N = mkWN (k10 "jumala") "metsän" ; --UNCHK
lin satyriasis_N = mkWN (compoundN "satyri" (k5 "aasi")) ; --UNCHK
lin satyric_A = mkWA (compoundA "satyyri" (k38 "nen")) ; --UNCHK
lin sauce_N = mkWN (k48A "kastike") ; --UNCHK
lin sauce_V2 = mkWV2 (k73 "lisätä") "kastiketta" ; --UNCHK
lin saucepan_N = mkWN (k12 "kattila") ; --UNCHK
lin saucepot_N = mkWN (k12 "kattila") ; --UNCHK
lin saucer_N = mkWN (k1A "kiekko") ; --UNCHK
lin sauciness_N = mkWN (k40 "nokkavuus") ; --UNCHK
lin saucy_A = mkWA (k10 "nokkava") ; --UNCHK
lin saudi_arabia_PN = mkPN "Saudi-Arabia" ;
lin saudi_arabian_A = mkA "saudi-arabialainen" ;
lin saudi_arabian_N = mkWN (k5 "saudi") ; --UNCHK
lin sauerbraten_N = mkWN "sauerbraten" ; --UNCHK
lin sauerkraut_N = mkWN (k50 "hapankaali") ; --UNCHK
lin saukkola_PN = mkPN "Saukkola" ;
lin sauna_N = mkWN (k9 "sauna") ; --UNCHK
lin saunter_N = mkWN (k2 "vaeltelu") ; --UNCHK
lin saunter_V = mkWV (k67 "käveleskellä") ; --UNCHK
lin saunterer_N = mkWN (k12 "kävelijä") ; --UNCHK
lin saurian_A = mkWA "lisko-" ; --UNCHK
lin saurian_N = mkWN (kH1 "lisko") ; --UNCHK
lin saurischian_N = mkWN (k39 "dinosaurus") "linnunlantioinen" ; --UNCHK
lin sauropod_N = mkWN "sauropodi" ; --UNCHK
lin saury_N = mkWN "Scomberesox" "saurus" ; --UNCHK
lin sausage_N = mkWN (compoundN "ilma" (k9 "laiva")) ; --UNCHK
lin sausage_dog_N = mkWN (k5A "maastonakki") ; --UNCHK
lin sausage_meat_N = mkWN (compoundN "makkara" (k9 "liha")) ; --UNCHK
lin sausage_roll_N = mkWN (compoundN "makkara" (k12 "pasteija")) ; --UNCHK
lin saute_A = mkWA (compoundA "pai" (k1 "stettu")) "kevyesti" ; --UNCHK
lin saute_N = mkWN (k39 "paistos") ; --UNCHK
lin saute_V2 = mkWV2 (k53 "ruskistaa") ; --UNCHK
lin sauvo_PN = mkPN "Sauvo" ;
lin savage_A = mkWA (k5 "villi") ; --UNCHK
lin savage_N = mkWN (k1A "peto") ; --UNCHK
lin savage_V2 = mkWV2 (k61A "sättiä") ; --UNCHK
lin savageness_N = mkWN (k40 "villiys") ; --UNCHK
lin savagery_N = mkWN (k40 "brutaalius") ; --UNCHK
lin savanna_N = mkWN (k5 "savanni") ; --UNCHK
lin savannah_N = mkWN (k5 "savanni") ; --UNCHK
lin savarin_N = mkWN (compoundN "rommi" (k1A "kakku")) ; --UNCHK
lin save_N = mkWN (k9A "torjunta") ; --UNCHK
lin save_V = mkV "säästää" ;
lin save_V2 = mkV2 "pelastaa" ;
lin save_on_V2 = prepV2 OP_save_V OP_on_Prep ; -- guess-p-verb
lin save_up_V2 = mkWV2 (k56A "laittaa") "sivuun" ; --UNCHK
lin saveloy_N = mkWN "saveloy" ; --UNCHK
lin saver_N = mkWN (k10 "pelastaja") ; --UNCHK
lin saving_N = mkN "säästö" ; --f79
lin savings_N = mkWN (compoundN "pesä" (k10 "muna")) ; --UNCHK
lin savings_bank_N = mkWN (compoundN "säästö" (k41A "lipas")) ; --UNCHK
lin savior_N = mkWN (k10 "pelastaja") ; --UNCHK
lin saviour_N = mkWN (k10 "pelastaja") ; --UNCHK
lin savitaipale_PN = mkPN "Savitaipale" ;
lin savonlinna_PN = mkPN "Savonlinna" ;
lin savonranta_PN = mkPN "Savonranta" ;
lin savore_V2 = mkV2 (mkV "nauttia") (casePrep elative) ; ---ARB
lin savour_N = mkWN (k1A "maku") "vahva" ; --UNCHK
lin savour_V = mkWV (k61A "nauttia") ; --UNCHK
lin savour_V2 = mkWV2 (k61A "nauttia") ; --UNCHK
lin savoury_A = mkWA (k34A "turmeltumaton") ; --UNCHK
lin savoury_N = mkWN (compoundN "suola" (k9 "pala")) ; --UNCHK
lin savoy_N = mkWN (compoundN "kurttu" (k5 "kaali")) ; --UNCHK
lin savukoski_PN = mkPN (mkN "Savukoski" "Savukoskia") ;
lin savvy_N = mkWN (k39 "ymmärtämys") ; --UNCHK
lin savvy_V = mkWV (k74 "tajuta") ; --UNCHK
lin saw_N = mkWN (compoundN "moottori" (k9 "saha")) ; --UNCHK
lin saw_V = mkWV (k73 "sahata") ; --UNCHK
lin saw_V2 = mkWV2 (k73 "sahata") ; --UNCHK
lin sawbridgeworth_PN = foreignPN "Sawbridgeworth" ;
lin sawdust_N = mkWN (k1 "puru") ; --UNCHK
lin sawfish_N = mkWN (compoundN "saha" (k1 "rausku")) ; --UNCHK
lin sawfly_N = mkWN (compoundN "saha" (k38 "pistiäinen")) ; --UNCHK
lin sawhorse_N = mkWN (kH1 "pukki") ; --UNCHK
lin sawm_N = mkWN (k1 "paasto") ; --UNCHK
lin sawmill_N = mkWN (k9 "saha") ; --UNCHK
lin saw_pit_N = mkWN (compoundN "sahaus" (k10A "kuoppa")) ; --UNCHK
lin sawtooth_N = mkWN (k41A "hammas") "sahan" ; --UNCHK
lin sawwort_N = mkWN "Serratula" "tinctoria" ; --UNCHK
lin sawyer_N = mkWN (k6 "räätäli") ; --UNCHK
lin sax_N = mkWN (k5 "saksofoni") ; --UNCHK
lin saxhorn_N = mkWN (k7 "torvi") ; --UNCHK
lin saxicolous_A = mkWA (k10 "elävä") "kivikossa" ; --UNCHK
lin saxifrage_N = mkWN (k1A "rikko") ; --UNCHK
lin saxitoxin_N = mkWN (compoundN "saksi" (k5 "toksiini")) ; --UNCHK
lin saxon_A = mkWA (compoundA "saksi" (k38 "lainen")) ; --UNCHK
lin saxon_N = mkWN "saksi" ; --UNCHK
lin saxophone_N = mkWN (k5 "saksofoni") ; --UNCHK
lin saxophonist_N = mkWN (k5 "saksofonisti") ; --UNCHK
lin say_N = mkWN (compoundN "puheen" (k1 "vuoro")) ; --UNCHK
lin say_V = mkV "sanoa" ;
lin say_V2 = mkV2 "sanoa" ;
lin say_VS = L.say_VS ;
lin saying_N = mkWN (k2 "ilmaisu") ; --UNCHK
lin scab_N = mkWN (k7A "rupi") ; --UNCHK
lin scabbard_N = mkWN (k7A "tuppi") ; --UNCHK
lin scabby_A = mkWA (k38 "rupinen") ; --UNCHK
lin scabicide_N = mkWN (compoundN "täi" (k1A "myrkky")) ; --UNCHK
lin scabies_N = mkWN (k1 "syyhy") ; --UNCHK
lin scabious_N = mkWN (compoundN "törmä" (k10A "kukka")) ; --UNCHK
lin scablands_N = mkWN (compoundN "erä" (k18 "maa")) ; --UNCHK
lin scabrous_A = mkWA (k34A "ruokoton") ; --UNCHK
lin scad_N = mkWN "Selar" ; --UNCHK
lin scalability_N = mkWN "skaalautuvuus" ; --UNCHK
lin scalable_A = mkWA (k10 "oleva") "kiivettävissä" ; --UNCHK
lin scalage_N = mkWN (k39 "mittaus") ; --UNCHK
lin scalar_A = mkWA "skalaari-" ; --UNCHK
lin scalar_N = mkWN (compoundN "ska" (k5 "laari")) ; --UNCHK
lin scalawag_N = mkWN (k5 "hulivili") ; --UNCHK
lin scald_N = mkWN (k39 "kalttaus") ; --UNCHK
lin scale_N = mkN "mittakaava" | mkWN (k1 "suomu") ; ---- split
lin scale_V = mkWV (k53A "muuttaa") "mittakaavaa" ; --UNCHK
lin scale_V2 = mkWV2 (k53A "muuttaa") "mittakaavaa" ; --UNCHK
lin scale_down_V2 = mkWV2 (k54A "pienentää") ; --UNCHK
lin scale_up_V2 = mkWV2 (k54A "suurentaa") ; --UNCHK
lin scaleless_A = mkWA "suomuton" ; --UNCHK
lin scalelike_A = mkWA (compoundA "suomu" (k38 "mainen")) ; --UNCHK
lin scalenus_N = mkWN (compoundN "kylkiluun" (k10 "kannattaja")) ; --UNCHK
lin scaler_N = mkWN (k6 "laskuri") ; --UNCHK
lin scalic_A = mkWA "asteikko-" ; --UNCHK
lin scaliness_N = mkWN "suomuisuus" ; --UNCHK
lin scaling_N = mkWN (compoundN "kii" (k38 "peäminen")) ; --UNCHK
lin scallop_N = mkWN (compoundN "kampa" (k14A "simpukka")) ; --UNCHK
lin scallop_V2 = mkWV2 (k54A "pyältää") ; --UNCHK
lin scallop_shell_N = mkWN (k26 "simpukankuori") ; --UNCHK
lin scallopine_N = mkWN "scaloppini" ; --UNCHK
lin scallywag_N = mkWN (k5 "hulivili") ; --UNCHK
lin scalp_N = mkWN (compoundN "pää" (k9 "nahka")) ; --UNCHK
lin scalp_V2 = mkWV2 (k64 "viedä") "päänahka" ; --UNCHK
lin scalpel_N = mkWN (k5 "skalpelli") ; --UNCHK
lin scalper_N = mkWN (k6 "trokari") ; --UNCHK
lin scaly_A = mkWA (k38 "suomuinen") ; --UNCHK
lin scam_N = mkWN (k39 "huijaus") ; --UNCHK
lin scam_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin scammony_N = mkWN "Convolvulus" "scammonia" ; --UNCHK
lin scamp_N = mkWN (k5 "hulivili") ; --UNCHK
lin scamper_N = mkWN (k2 "säntäily") ; --UNCHK
lin scamper_V = mkWV (k53A "kipittää") ; --UNCHK
lin scampi_N = mkWN "scampi" ; --UNCHK
lin scan_N = mkWN (k2 "silmäily") ; --UNCHK
lin scan_V = mkWV (k61 "tutkia") ; --UNCHK
lin scan_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin scandal_N = mkWN (k1A "törky") ; --f71
lin scandalization_N = mkWN "sokeeraus" ; --UNCHK
lin scandalize_V2 = mkWV2 (k53A "kauhistuttaa") ; --UNCHK
lin scandalmonger_N = mkWN (compoundN "juoru" (k1 "kello")) ; --UNCHK
lin scandalmongering_A = mkWA (k38 "sensaatiomainen") ; --UNCHK
lin scandalmongering_N = mkWN (compoundN "juoru" (k38 "aminen")) ; --UNCHK
lin scandalous_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin scandalousness_N = mkWN (k40 "hävyttömyys") ; --UNCHK
lin scandent_A = mkWA "kiipeävä" ; --UNCHK
lin scandinavian_A = mkWA (k38 "skandinaavinen") ; --UNCHK
lin scandinavian_N = mkN "skandinaavi" ;
lin scandium_N = mkWN "järjestysluku" "21" ; --UNCHK
lin scanner_N = mkWN (k33 "tutkain") "elektroninen" ; --UNCHK
lin scanning_N = mkWN (k39 "skannaus") ; --UNCHK
lin scansion_N = mkWN (compoundN "mittaus" (k9A "tapa")) ; --UNCHK
lin scant_A = mkWA (k17 "vajaa") ; --UNCHK
lin scant_V2 = mkWV2 (k73A "pihdata") ; --UNCHK
lin scantiness_N = mkWN (k40 "vajavaisuus") ; --UNCHK
lin scantling_N = mkWN (k1 "soiro") ; --UNCHK
lin scanty_A = mkWA (k34A "koruton") ; --UNCHK
lin scape_N = mkWN (k9 "vana") ; --UNCHK
lin scapegoat_N = mkWN (compoundN "sijais" (k12 "kärsijä")) ; --UNCHK
lin scapegrace_N = mkWN (k41A "lammas") "musta" ; --UNCHK
lin scaphocephaly_N = mkWN "venekalloisuus" ; --UNCHK
lin scaphopod_N = mkWN (compoundN "hammas" (k2 "kotilo")) ; --UNCHK
lin scapose_A = mkWA (compoundA "varsi" (k38 "mainen")) ; --UNCHK
lin scapula_N = mkWN (compoundN "lapa" (k18 "luu")) ; --UNCHK
lin scapular_A = mkWA "lapaluu-" ; --UNCHK
lin scapular_N = mkWN (compoundN "lapaluu" (k32 "höyhen")) ; --UNCHK
lin scar_N = mkN (lin NK {s = d07A "arpi"}) ;
lin scar_V = mkWV (k53A "jättää") "arpi" ; --UNCHK
lin scar_V2 = mkWV2 (k53A "jättää") "arpi" ; --UNCHK
lin scarab_N = mkWN (k10 "pillerinpyörittäjä") ; --UNCHK
lin scarborough_PN = foreignPN "Scarborough" ;
lin scarce_A = mkWA (k9A "niukka") ; --UNCHK
lin scarcity_N = mkWN (k40 "vähyys") ; --UNCHK
lin scare_N = mkWN (k39 "säikähdys") ; --UNCHK
lin scare_V = mkWV (k67A "pelotella") ; --UNCHK
lin scare_V2 = mkWV2 (k67A "pelotella") ; --UNCHK
lin scare_away_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin scare_off_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin scarecrow_N = mkWN (k33A "pelätin") ; --UNCHK
lin scarecrowish_A = mkWA (compoundA "muis" (k10 "tuttava")) "variksenpelätintä" ; --UNCHK
lin scared_A = variants {} ; --
lin scaremonger_N = mkWN (k10 "lietsoja") "kauhun" ; --UNCHK
lin scarf_N = mkWN (k5 "huivi") ; --UNCHK
lin scarify_V2 = mkWV2 (k53A "arpeuttaa") ; --UNCHK
lin scarlet_A = mkWA (k10 "punertava") ; --UNCHK
lin scarlet_N = mkWN (k5 "sinooperi") ; --UNCHK
lin scarp_N = mkWN (k10 "luiska") "kaivannon" ; --UNCHK
lin scarper_V = mkWV (k52A "häipyä") ; --UNCHK
lin scary_A = mkA "pelottava" ;
lin scat_N = mkWN (compoundN "scat-" (k1 "laulu")) ; --UNCHK
lin scathing_A = mkWA (k10 "musertava") ; --UNCHK
lin scatological_A = mkWA "skatologinen" ; --UNCHK
lin scatology_N = mkWN "skatologia" ; --UNCHK
lin scatophagy_N = mkWN (compoundN "ulosteen" (k5A "syönti")) ; --UNCHK
lin scatter_N = mkWN (k2 "sirottelu") ; --UNCHK
lin scatter_V = mkWV (k53A "hajottaa") ; --UNCHK
lin scatter_V2 = mkWV2 (k53A "hajottaa") ; --UNCHK
lin scatterbrain_N = mkWN (k2 "henkilö") "unohtelevainen" ; --UNCHK
lin scatterbrained_A = mkWA (k10A "hömppä") ; --UNCHK
lin scattering_N = mkWN (k2 "sirottelu") ; --UNCHK
lin scattershot_A = mkWA (k38 "hajanainen") ; --UNCHK
lin scatty_A = mkWA (k34A "tarkkaamaton") ; --UNCHK
lin scaup_N = mkWN (k10 "sotka") ; --UNCHK
lin scauper_N = mkWN (k33A "kaiverrin") ; --UNCHK
lin scavenge_V = mkWV (k53 "puhdistaa") ; --UNCHK
lin scavenger_N = mkWN (compoundN "haaska" (k33 "eläin")) ; --UNCHK
lin scenario_N = mkN "skenaario" ;
lin scenarist_N = mkWN (compoundN "käsi" (k10 "kirjoittaja")) ; --UNCHK
lin scene_N = mkN "näkymä" ;
lin scene_painter_N = mkWN (k6 "kulissimaalari") ; --UNCHK
lin scenery_N = mkN "näkymä" ;
lin scene_shifter_N = mkWN (compoundN "kulissi" (k42 "mies")) ; --UNCHK
lin scenic_A = mkWA (k38 "näyttämöllinen") ; --UNCHK
lin scent_N = mkWN (k1 "tuoksu") ; --UNCHK
lin scent_V2 = mkWV2 (k53A "käyttää") "hajuvettä" ; --UNCHK
lin scentless_A = mkWA "hajuaistiton" ; --UNCHK
lin scepter_N = mkWN (k9 "sauva") ; --UNCHK
lin sceptered_A = mkWA (k99 "vallassa") ; --UNCHK
lin sceptic_N = mkWN (k4A "skeptikko") ; --UNCHK
lin sceptical_A = mkWA (k38 "epäileväinen") ; --UNCHK
lin scepticism_N = mkWN (k40 "epäileväisyys") ; --UNCHK
lin sceptre_N = mkWN (k9 "sauva") ; --UNCHK
lin sceptred_A = mkWA (k99 "vallassa") ; --UNCHK
lin schedule_N = mkN "aikataulu" ; --WN (k10 "ohjelma") ;
lin schedule_V = mkWV (k67A "suunnitella") ;
lin schedule_V2 = mkV2 "määrätä" ;
lin schedule_V2V = mkWV2V (k67A "suunnitella") ;
lin scheduler_N = mkWN (compoundN "vuor" (k33A "otin")) ; --UNCHK
lin scheduling_N = mkWN (k2 "suunnittelu") ; --UNCHK
lin scheelite_N = mkWN (compoundN "sche" (k5A "eliitti")) ; --UNCHK
lin schema_N = mkWN (k39 "luonnos") ; --UNCHK
lin schematic_A = mkWA (k38 "kaavamainen") ; --UNCHK
lin schematic_N = mkWN (k9 "kaava") ; --UNCHK
lin schematization_N = mkWN (compoundN "kaava" (k38 "maistaminen")) ; --UNCHK
lin scheme_N = mkN "luonnos" ;
lin scheme_V = mkWV (k67A "suunnitella") ; --UNCHK
lin scheme_V2 = mkWV2 (k67A "suunnitella") ; --UNCHK
lin schemer_N = mkWN (k12 "vehkeilijä") ; --UNCHK
lin schemozzle_N = mkWN "shemozzle" ; --UNCHK
lin scherzo_N = mkWN (k1 "scherzo") ; --UNCHK
lin schilling_N = mkWN (k5A "šillinki") "Itävallan" ; --UNCHK
lin schipperke_N = mkWN "schipperke" ; --UNCHK
lin schism_N = mkWN (k10 "eripura") ; --UNCHK
lin schismatic_A = mkWA "hajaannuttava" ; --UNCHK
lin schist_N = mkWN (k48 "liuske") ; --UNCHK
lin schistosome_N = mkWN (compoundN "halkio" (k1A "mato")) ; --UNCHK
lin schistosomiasis_N = mkWN (k5A "tauti") "bilhartsia-madon" "aiheuttama" ; --UNCHK
lin schizocarp_N = mkWN (compoundN "lohko" (k10 "hedelmä")) ; --UNCHK
lin schizogony_N = mkWN "skitsogonia" ; --UNCHK
lin schizoid_A = mkWA (k38 "skitsofreeninen") ; --UNCHK
lin schizophrenia_N = mkWN (k5 "psykoosi") "skitsofreenistyyppinen" ; --UNCHK
lin schizophrenic_A = mkWA (k38 "skitsofreeninen") ; --UNCHK
lin schizophrenic_N = mkWN (k4A "skitsofreenikko") ; --UNCHK
lin schizothymia_N = mkWN (k3 "häiriö") "skitsoaffektiivinen" ; --UNCHK
lin schlemiel_N = mkWN "shlemiel" ; --UNCHK
lin schlep_N = mkWN (k9 "matka") "raskas" ; --UNCHK
lin schlepper_N = mkWN (k39 "typerys") ; --UNCHK
lin schlimazel_N = mkWN "shlimazel" ; --UNCHK
lin schlock_N = mkWN (k1 "roju") ; --UNCHK
lin schlockmeister_N = mkWN (compoundN "roju" (k41 "kauppias")) ; --UNCHK
lin schmaltz_N = mkWN "siirappisuus" ; --UNCHK
lin schmaltzy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin schmalzy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin schmeer_N = mkWN "shmear" ; --UNCHK
lin schmuck_N = mkWN (kH1 "mäntti") ; --UNCHK
lin schnapps_N = mkWN (k5 "snapsi") ; --UNCHK
lin schnauzer_N = mkWN (k6 "snautseri") ; --UNCHK
lin schnitzel_N = mkWN (k48A "leike") ; --UNCHK
lin schnook_N = mkWN (k6 "tomppeli") ; --UNCHK
lin schnorkel_N = mkWN (k6 "snorkkeli") ; --UNCHK
lin schnorrer_N = mkWN "pummaaja" ; --UNCHK
lin scholar_N = mkWN (k12 "opiskelija") ; --UNCHK
lin scholarly_A = mkWA (k38 "tieteellinen") ; --UNCHK
lin scholarship_N = mkN "stipendi" ; --mkWN (k39 "tietämys") ;
lin scholastic_A = mkWA (k38 "akateeminen") ; --UNCHK
lin scholasticism_N = mkWN (k40 "akateemisuus") ; --UNCHK
lin scholium_N = mkWN (compoundN "ala" (k48A "viite")) ; --UNCHK
lin school_1_N = L.school_N ;
lin school_2_N = L.school_N ;
lin school_V2 = mkWV2 (k62 "uida") "parvessa" ; --UNCHK
lin school_board_N = mkWN "opetuslautakunta" ; --UNCHK
lin schoolbag_N = mkWN (compoundN "koulu" (k1A "laukku")) ; --UNCHK
lin schoolbook_N = mkWN (k9 "kirja") ; --UNCHK
lin schoolboy_N = mkWN (compoundN "koulu" (k10A "poika")) ; --UNCHK
lin schoolchild_N = mkWN (k38 "koululainen") ; --UNCHK
lin schooldays_N = mkWN (k9A "kouluaika") ; --UNCHK
lin schoolfellow_N = mkWN (compoundN "luokka" (k6 "toveri")) ; --UNCHK
lin schoolfriend_N = mkWN (compoundN "koulu" (k6 "kaveri")) ; --UNCHK
lin schoolgirl_N = mkWN (compoundN "koulu" (k1A "tyttö")) ; --UNCHK
lin schoolhouse_N = mkWN (k1 "koulu") ; --UNCHK
lin schooling_N = mkWN (k39 "opetus") ; --UNCHK
lin schoolman_N = mkWN (k10 "kasvattaja") ; --UNCHK
lin schoolmarm_N = mkWN (k32A "opettajatar") ; --UNCHK
lin schoolmaster_N = mkWN "Lutjanus" "apodus" ; --UNCHK
lin schoolmate_N = mkWN (compoundN "luokka" (k6 "toveri")) ; --UNCHK
lin schoolmistress_N = mkWN (k32A "opettajatar") ; --UNCHK
lin schoolroom_N = mkWN (kH1 "luokka") ; --UNCHK
lin schoolteacher_N = mkWN (compoundN "luokan" (k10 "opettaja")) ; --UNCHK
lin schooltime_N = mkWN (k9A "kouluaika") ; --UNCHK
lin schoolwide_A = mkWA (compoundA "koulun" (k38 "laajuinen")) ; --UNCHK
lin schoolyard_N = mkWN (k9 "piha") "koulun" ; --UNCHK
lin schooner_N = mkWN (k6 "kuunari") ; --UNCHK
lin schorl_N = mkWN (k5 "turmaliini") "musta" ; --UNCHK
lin schottische_N = mkWN (k6 "sottiisi") ; --UNCHK
lin schrod_N = mkWN (k10 "turska") ; --UNCHK
lin schwa_N = mkWN "švaa" ; --UNCHK
lin schwerin_PN = foreignPN "Schwerin" ;
lin sciatic_A = mkWA (compoundA "iskia" (k38 "alinen")) ; --UNCHK
lin sciatica_N = mkWN (k39 "iskias") ; --UNCHK
lin science_N = L.science_N ;
lin scienter_Adv = mkWAdv (k99 "tahallisesti") ; --UNCHK
lin scientific_A = mkWA (k38 "tieteellinen") ;
lin scientist_N = mkN "tiede" L.man_N ;
lin scilla_N = mkWN (compoundN "sini" (k9 "lilja")) ; --UNCHK
lin scimitar_N = mkWN (k6 "sapeli") ; --UNCHK
lin scintilla_N = mkWN (k38 "hitunen") ; --UNCHK
lin scintillate_V = mkWV (k52 "säihkyä") ; --UNCHK
lin scintillation_N = mkWN "välkehdintä" ; --UNCHK
lin sciolism_N = mkWN (compoundN "teko" (k40 "tieteellisyys")) ; --UNCHK
lin scion_N = mkWN (k9 "vesa") ; --UNCHK
lin scission_N = mkWN (k1A "viilto") ; --UNCHK
lin scissortail_N = mkWN "Muscivora-forficata" ; --UNCHK
lin sclaff_N = mkWN (compoundN "lyönti" (k48 "virhe")) ; --UNCHK
lin sclera_N = mkWN (k50 "kovakalvo") ; --UNCHK
lin scleredema_N = mkWN "skleredeema" ; --UNCHK
lin sclerite_N = mkWN (compoundN "skle" (k5A "riitti")) ; --UNCHK
lin scleritis_N = mkWN (k39 "tulehdus") "silmän" "kovakalvon" ; --UNCHK
lin scleroderma_N = mkWN (compoundN "Scleroderma-" (k1A "suku")) ; --UNCHK
lin sclerometer_N = mkWN (compoundN "sklero" (k5 "metri")) ; --UNCHK
lin scleroprotein_N = mkWN (k5 "proteiini") "eläinluuston" ; --UNCHK
lin sclerosis_N = mkWN (k10 "kovettuma") ; --UNCHK
lin sclerotic_A = mkWA "kalkkeutunut" ; --UNCHK
lin sclerotinia_N = mkWN (compoundN "varsi" (k3 "kuolio")) ; --UNCHK
lin sclerotium_N = mkWN "sclerotium" ; --UNCHK
lin scoff_N = mkWN (k9 "iva") ; --UNCHK
lin scoff_V = mkWV (k61 "halveksia") ; --UNCHK
lin scoff_V2 = mkWV2 (k61 "halveksia") ; --UNCHK
lin scoffer_N = mkWN (k10 "pilkkaaja") ; --UNCHK
lin scoffingly_Adv = mkWAdv (k99 "pisteliäästi") ; --UNCHK
lin scofflaw_N = mkWN (k38 "rikollinen") ; --UNCHK
lin scold_N = mkWN (compoundN "äkä" (k5 "pussi")) ; --UNCHK
lin scold_V = mkWV (k73 "saarnata") ; --UNCHK
lin scold_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin scolding_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin scolion_N = mkWN (compoundN "juhla" (k1 "laulu")) ; --UNCHK
lin scoliosis_N = mkWN (k5 "skolioosi") ; --UNCHK
lin scollop_V2 = mkWV2 (k54A "pyältää") ; --UNCHK
lin scolopendrium_N = mkWN "scolopendrium" ; --UNCHK
lin scombroid_N = mkWN (k5 "makrilli") ; --UNCHK
lin sconce_N = mkWN (compoundN "kynttilän" (k33A "pidin")) ; --UNCHK
lin scone_N = mkWN (k5 "skonssi") ; --UNCHK
lin scoop_N = mkWN (k9 "kauha") ; --UNCHK
lin scoop_V = mkV (mkV "julkaista") "skuuppi" ;
lin scoop_up_V = mkWV (k61A "kaapia") ; --UNCHK
lin scoopful_N = mkWN (k38 "kauhallinen") ; --UNCHK
lin scoot_V = mkWV (k52A "sinkoutua") ; --UNCHK
lin scoot_V2 = mkWV2 (k52A "sinkoutua") ; --UNCHK
lin scooter_N = mkWN (k50 "mustalintu") ; --UNCHK
lin scopal_A = mkWA "laajuuteen" "liittyvä" ; --UNCHK
lin scope_N = mkN "laajuus" ; --mkWN (k5A "oskilloskooppi") ;
lin scopolamine_N = mkWN "hyoskiini" ; --UNCHK
lin scorbutic_A = mkWA "skorbuuttinen" ; --UNCHK
lin scorch_N = mkWN (compoundN "palo" (k7A "jälki")) ; --UNCHK
lin scorch_V = mkWV (k52A "paahtua") ; --UNCHK
lin scorch_V2 = mkWV2 (k52A "paahtua") ; --UNCHK
lin scorcher_N = mkWN (k1A "paukku") ; --UNCHK
lin scorching_Adv = mkWAdv "polttavan" ; --UNCHK
lin score_N = mkN "piste" (mkN "määrä") ; --WN (k5A "saanti") ;
lin score_V = mkWV (k73 "korjata") ; --UNCHK
lin score_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin scoreboard_N = mkWN (compoundN "piste" (k1 "taulu")) ; --UNCHK
lin scorecard_N = mkWN (compoundN "tulos" (k5A "kortti")) ; --UNCHK
lin scorekeeper_N = mkWN (compoundN "pisteen" (k12 "laskija")) ; --UNCHK
lin scoreless_A = mkWA (kH1 "maaliton") ; --UNCHK
lin scorer_N = mkWN (compoundN "pisteen" (k12 "laskija")) ; --UNCHK
lin scorn_N = mkWN (kH1 "pilkka") ; --UNCHK
lin scorn_V2 = mkWV2 (k67 "olla") "hyväksymättä" ; --UNCHK
lin scornful_A = mkWA (k38 "ylenkatseellinen") ; --UNCHK
lin scorpaenid_N = mkWN (compoundN "skorpioni" (k9 "kala")) ; --UNCHK
lin scorpaenoid_N = mkWN (compoundN "skorpioni" (k9 "kala")) ; --UNCHK
lin scorpion_N = mkWN (k5 "skorpioni") ; --UNCHK
lin scorpionfish_N = mkWN (compoundN "skorpioni" (k9 "kala")) ; --UNCHK
lin scorpionweed_N = mkWN "Phacelia" ; --UNCHK
lin scorzonera_N = mkWN (k26 "mustajuuri") ; --UNCHK
lin scot_N = mkWN (k38 "skotlantilainen") ; --UNCHK
lin scot_free_Adv = mkWAdv (k99 "pälkähästä") "päästä" ; --UNCHK
lin scotch_A = mkWA (k38 "skotlantilainen") ; --UNCHK
lin scotch_N = mkWN (k5 "viski") "skotlantilainen" ; --UNCHK
lin scotch_V2 = mkWV2 (k71 "tehdä") "viilto" ; --UNCHK
lin scotchman_N = mkWN (k38 "skotlantilainen") ; --UNCHK
lin scotchwoman_N = mkWN (k5A "skotti") ; --UNCHK
lin scoter_N = mkWN (k50 "mustalintu") ; --UNCHK
lin scotland_PN = mkPN "Skotlanti" ;
lin scotoma_N = mkWN (compoundN "pälvi" (k40 "sokeus")) ; --UNCHK
lin scotomatous_A = mkWA "pälvisokeuteen" "liittyvä" ; --UNCHK
lin scots_A = mkWA (k38 "skotlantilainen") ; --UNCHK
lin scotsman_N = mkWN (k38 "skotlantilainen") ; --UNCHK
lin scotswoman_N = mkWN (k5A "skotti") ; --UNCHK
lin scottish_A = mkWA (k38 "skotlantilainen") ; --UNCHK
lin scoundrel_N = mkWN (k5A "hunsvotti") ; --UNCHK
lin scoundrelly_A = mkWA (k38 "konnamainen") ; --UNCHK
lin scour_N = mkWN (k10 "ura") ; --UNCHK
lin scour_V = mkWV (k53 "puhdistaa") ; --UNCHK
lin scour_V2 = mkWV2 (k53 "puhdistaa") ; --UNCHK
lin scourer_N = mkWN (k10 "matkaaja") ; --UNCHK
lin scourge_N = mkWN (k10 "ruoska") ; --UNCHK
lin scourge_V2 = mkWV2 (k53 "kylvää") "tuhoa" ; --UNCHK
lin scouring_N = mkWN (k39 "jynssäys") ; --UNCHK
lin scours_N = mkWN (k6 "ripuli") ; --UNCHK
lin scout_N = mkWN (k12 "vartija") ; --UNCHK
lin scout_V = mkWV (k67 "tiedustella") ; --UNCHK
lin scout_V2 = mkWV2 (k67 "tiedustella") ; --UNCHK
lin scouting_N = mkWN (k2 "tiedustelu") ; --UNCHK
lin scoutmaster_N = mkWN (compoundN "partio" (k10 "johtaja")) ; --UNCHK
lin scow_N = mkWN (k10 "lotja") ; --UNCHK
lin scowl_N = mkWN (k48 "katse") "vihainen" ; --UNCHK
lin scowl_V = mkWV (k52 "katsoa") "vihaisesti" ; --UNCHK
lin scrabble_N = mkWN (compoundN "sana" (k5 "peli")) ; --UNCHK
lin scrabble_V = mkWV (k73 "rustata") ; --UNCHK
lin scrabbly_A = mkWA (k38 "pensaikkoinen") ; --UNCHK
lin scrag_N = mkWN (compoundN "vasikan" (k48A "leike")) ; --UNCHK
lin scrag_end_N = mkWN (compoundN "vasikan" (k48A "leike")) ; --UNCHK
lin scraggly_A = mkWA (compoundA "epä" (k5 "siisti")) ; --UNCHK
lin scraggy_A = mkWA (k41A "särmikäs") ; --UNCHK
lin scram_V = mkWV (k53A "ottaa") "hatkat" ; --UNCHK
lin scramble_N = mkWN (k2 "säntäily") ; --UNCHK
lin scramble_V = mkWV (k53 "vääristää") ; --UNCHK
lin scramble_V2 = mkWV2 (k53 "vääristää") ; --UNCHK
lin scrambler_N = mkWN (compoundN "salaus" (k48A "laite")) ; --UNCHK
lin scrap_N = mkWN (k2 "kamppailu") ; --UNCHK
lin scrap_V = mkWV (k53A "romuttaa") ; --UNCHK
lin scrap_V2 = mkWV2 (k53A "romuttaa") ; --UNCHK
lin scrap_iron_N = mkWN (compoundN "romu" (k9A "rauta")) ; --UNCHK
lin scrapbook_N = mkWN (compoundN "leike" (k9 "kirja")) ; --UNCHK
lin scrape_N = mkWN (k7A "jälki") ; --UNCHK
lin scrape_V = mkWV (k61A "raapia") ; --UNCHK
lin scrape_V2 = mkWV2 (k61A "raapia") ; --UNCHK
lin scrape_along_V = mkWV (k67 "pärjäillä") ; --UNCHK
lin scrape_by_V = mkWV (k67 "pärjäillä") ; --UNCHK
lin scrape_up_V2 = mkWV2 (k74A "koota") ; --UNCHK
lin scraper_N = mkWN (k33A "raaputin") ; --UNCHK
lin scrapheap_N = mkWN (compoundN "roju" (k9 "kasa")) ; --UNCHK
lin scrapie_N = mkWN (compoundN "kutka" (k5A "tauti")) "lampaan" ; --UNCHK
lin scraping_N = mkWN (k39 "kumarrus") "syvä" ; --UNCHK
lin scrappiness_N = mkWN (k40 "aggressiivisuus") ; --UNCHK
lin scrapple_N = mkWN (k48 "höyste") ; --UNCHK
lin scrappy_A = mkWA (compoundA "taistelu" (k38 "henkinen")) ; --UNCHK
lin scratch_N = mkN "naarmu" ; --mkWN (k7A "jälki") ; --UNCHK
lin scratch_V = mkWV (k73A "hangata") ; --UNCHK
lin scratch_V2 = L.scratch_V2 ;
lin scratch_out_V = mkWV (k53 "poistaa") ; --UNCHK
lin scratch_pad_N = mkWN (k3 "muistio") | mkWN (compoundN "työ" (k5 "muisti")) ; --UNCHK
lin scratch_race_N = mkWN (k9 "kisa") "alusta" "alkava" ; --UNCHK
lin scratcher_N = mkWN (k33A "raaputin") ; --UNCHK
lin scratchy_A = mkWA (compoundA "raap" (k9 "iva")) ; --UNCHK
lin scrawl_N = mkWN (k39 "tuherrus") ; --UNCHK
lin scrawl_V = mkWV (k53 "riipustaa") ; --UNCHK
lin scrawl_V2 = mkWV2 (k53 "riipustaa") ; --UNCHK
lin scrawler_N = mkWN "tuhertelija" ; --UNCHK
lin scrawniness_N = mkWN "kitukasvuisuus" ; --UNCHK
lin scrawny_A = mkWA (k10 "hintelä") ; --UNCHK
lin screaky_A = mkWA (k10 "kirkuva") ; --UNCHK
lin scream_N = mkWN (k1A "juttu") "hauska" ; --UNCHK
lin scream_V = mkWV (k52A "kirkua") ;
lin scream_V2 = mkWV2 (k52A "kirkua") ; --UNCHK
lin scream_VS = mkWVS (k52A "kirkua") ;
lin screamer_N = mkWN (k1A "paukku") ; --UNCHK
lin screamingly_Adv = mkWAdv "äärettömän" ; --UNCHK
lin scree_N = mkWN (k4A "kivikko") ; --UNCHK
lin screech_N = mkWN (k9A "kiljunta") ; --UNCHK
lin screech_V = mkWV (k66 "kiljaista") ; --UNCHK
lin screech_V2 = mkWV2 (k66 "kiljaista") ; --UNCHK
lin screech_owl_N = mkWN (compoundN "sieppo" (k1 "pöllö")) ; --UNCHK
lin screed_N = mkWN (k48A "tasoite") ; --UNCHK
lin screen_N = mkN "näyttöruutu" ;
lin screen_V = mkV "siivilöityä" ; --mkWV (k61 "tutkia") ;
lin screen_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin screen_off_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin screen_out_V2 = mkWV2 (k53A "selvittää") ; --UNCHK
lin screener_N = mkWN (k12 "vartija") ; --UNCHK
lin screening_N = mkWN (k9A "seulonta") ; --UNCHK
lin screenplay_N = mkWN (compoundN "käsi" (k39 "kirjoitus")) ; --UNCHK
lin screenwriter_N = mkWN (compoundN "käsi" (k10 "kirjoittaja")) ; --UNCHK
lin screw_N = mkWN (k5 "seksi") ; --UNCHK
lin screw_V = mkWV (k73 "huijata") ; --UNCHK
lin screw_V2 = mkWV2 (k73 "huijata") ; --UNCHK
lin screw_up_V2 = mkWV2 (k54A "vääntää") ; --UNCHK
lin screwball_A = mkWA (k1 "hoopo") ; --UNCHK
lin screwball_N = mkWN (compoundN "kierre" (k1A "syöttö")) ; --UNCHK
lin screwballer_N = mkWN (compoundN "kierre" (k10 "syöttäjä")) ; --UNCHK
lin screwdriver_N = mkWN (compoundN "ruuvi" (k6 "meisseli")) ; --UNCHK
lin screwtop_N = mkWN (compoundN "kierre" (k28 "kansi")) ; --UNCHK
lin screwup_N = mkWN (k10 "moka") ; --UNCHK
lin screwy_A = mkWA (k99 "sekaisin") ; --UNCHK
lin scribble_N = mkWN (k39 "tuherrus") ; --UNCHK
lin scribble_V = mkWV (k73 "rustata") ; --UNCHK
lin scribble_V2 = mkWV2 (k73 "rustata") ; --UNCHK
lin scribbler_N = mkWN "tuhertelija" ; --UNCHK
lin scribbling_block_N = mkWN (k3 "muistio") ; --UNCHK
lin scribe_N = mkWN (compoundN "piirto" (k1A "puikko")) ; --UNCHK
lin scriber_N = mkWN (compoundN "piirto" (k1A "puikko")) ; --UNCHK
lin scrim_N = mkWN (kH1 "kangas") ; --UNCHK
lin scrimmage_N = mkN "joukko" (mkN "tappelu") ;
lin scrimmage_V = mkWV (k67A "harjoitella") ; --UNCHK
lin scrimmage_V2 = mkWV2 (k67A "harjoitella") ; --UNCHK
lin scrimp_V = mkWV (k67 "kitsastella") ; --UNCHK
lin scrimp_V2 = mkWV2 (k67 "kitsastella") ; --UNCHK
lin scrimshanker_N = mkWN (compoundN "vemppam" (k41A "ies")) ; --UNCHK
lin scrimshaw_N = mkWN (compoundN "norsunluu" (k39 "kaiverrus")) ; --UNCHK
lin scrimy_A = mkWA (k9A "saita") ; --UNCHK
lin scrip_N = mkWN (compoundN "osake" (k9 "kirja")) "väliaikainen" ; --UNCHK
lin script_1_N = mkWN (k39 "kirjoitus") ; --UNCHK
lin script_2_N = mkWN (k39 "kirjoitus") ; --UNCHK
lin script_3_N = mkWN (k39 "kirjoitus") ; --UNCHK
lin scripted_A = mkWA (compoundA "käsi" (k1 "kirjoitettu")) ; --UNCHK
lin scriptorium_N = mkWN (compoundN "kirjoitus" (k48 "huone")) ; --UNCHK
lin scriptural_A = mkWA (k38 "raamatullinen") ; --UNCHK
lin scripture_N = mkWN (k9 "kirja") "pyhä" ; --UNCHK
lin scriptwriter_N = mkWN (compoundN "käsi" (k10 "kirjoittaja")) ; --UNCHK
lin scrivened_A = mkWA (compoundA "kopio" (k1A "itu")) "käsin" ; --UNCHK
lin scrivener_N = mkWN (k6 "kirjuri") ; --UNCHK
lin scrod_N = mkWN (k10 "turska") ; --UNCHK
lin scrofula_N = mkWN (k10 "struuma") ; --UNCHK
lin scrofulous_A = mkWA (compoundA "huonokun" (k38 "toinen")) ; --UNCHK
lin scroll_N = mkWN (k1 "käärö") ; --UNCHK
lin scrooge_N = mkWN (k5A "kitupiikki") ; --UNCHK
lin scrotal_A = mkWA (compoundA "skrota" (k38 "alinen")) ; --UNCHK
lin scrotum_N = mkWN (compoundN "kives" (k5 "pussi")) ; --UNCHK
lin scrounge_V = mkWV (k67 "haeskella") ; --UNCHK
lin scrounge_V2 = mkWV2 (k67 "haeskella") ; --UNCHK
lin scrounger_N = mkWN (k12 "siipeilijä") ; --UNCHK
lin scrub_A = mkWA (compoundA "seka" (k38 "rotuinen")) ; --UNCHK
lin scrub_N = mkWN (k39 "jynssäys") ; --UNCHK
lin scrub_V = mkWV (k66 "pestä") ; --UNCHK
lin scrub_V2 = mkWV2 (k66 "pestä") ; --UNCHK
lin scrubber_N = mkWN (k10 "puhdistaja") ; --UNCHK
lin scrubbing_brush_N = mkWN (k9 "harja") ; --UNCHK
lin scrubbird_N = mkWN (compoundN "tiheikkö" (k10 "laulaja")) ; --UNCHK
lin scrubby_A = mkWA (k10 "luiseva") ; --UNCHK
lin scrubland_N = mkWN (compoundN "pensas" (k18 "maa")) ; --UNCHK
lin scruff_N = mkWN (k9 "niska") ; --UNCHK
lin scruffy_A = mkWA (k38 "suttuinen") ; --UNCHK
lin scrum_N = mkWN (k39 "aloitus") ; --UNCHK
lin scrummage_N = mkWN (k39 "aloitus") ; --UNCHK
lin scrumptious_A = mkWA (k9 "nanna") ; --UNCHK
lin scrumpy_N = mkWN (k6 "siideri") "vahva" ; --UNCHK
lin scrunch_N = mkWN (k12 "rapina") ; --UNCHK
lin scrunch_V2 = mkWV2 (k56A "taittaa") ; --UNCHK
lin scruple_N = mkWN (compoundN "tunnon" (k10 "tuska")) ; --UNCHK
lin scruple_V = mkWV (k62 "epäröidä") ; --UNCHK
lin scrupulous_A = mkWA (compoundA "omantunnon" (k9A "arka")) ; --UNCHK
lin scrupulousness_N = mkWN (k40 "perusteellisuus") ; --UNCHK
lin scrutineer_N = mkWN (k12 "tarkkailija") ; --UNCHK
lin scrutinize_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin scrutinizer_N = mkWN (k12 "tutkija") ; --UNCHK
lin scrutiny_N = mkWN (k2 "tarkastelu") ; --UNCHK
lin scud_N = mkWN (compoundN "kii" (k38 "täminen")) ; --UNCHK
lin scud_V = mkWV (k61A "purjehtia") ; --UNCHK
lin scuff_1_N = mkWN "laahaaminen" ; --UNCHK
lin scuff_2_N = mkWN "laahaaminen" ; --UNCHK
lin scuff_V = mkWV (k61 "potkia") ; --UNCHK
lin scuff_V2 = mkWV2 (k61 "potkia") ; --UNCHK
lin scuffer_N = mkWN (k6 "sandaali") ; --UNCHK
lin scuffle_N = mkWN (k14A "kahakka") ; --UNCHK
lin scuffle_V = mkWV (k62 "kahakoida") ; --UNCHK
lin scull_N = mkWN (k1A "runko") ; --UNCHK
lin scull_V = mkWV (k55A "soutaa") ; --UNCHK
lin scull_V2 = mkWV2 (k55A "soutaa") ; --UNCHK
lin sculler_N = mkWN (compoundN "airo" (k42 "mies")) ; --UNCHK
lin scullery_N = mkWN (compoundN "apu" (k3 "keittiö")) ; --UNCHK
lin sculling_N = mkWN "soutaminen" ; --UNCHK
lin scullion_N = mkWN (compoundN "keittiö" (k38 "apulainen")) ; --UNCHK
lin sculpin_N = mkWN (compoundN "skorpioni" (k9 "kala")) ; --UNCHK
lin sculpt_V = mkWV (k73 "muovata") ; --UNCHK
lin sculpt_V2 = mkWV2 (k73 "muovata") ; --UNCHK
lin sculptor_N = mkWN "Kuvanveistäjä" ; --UNCHK
lin sculptress_N = mkWN (k10 "kuvanveistäjä") ; --UNCHK
lin sculptural_A = mkWA (k38 "veistoksellinen") ; --UNCHK
lin sculpture_N = mkWN (compoundN "kuvanveisto" (k48A "taide")) ; --UNCHK
lin sculpture_V = mkWV (k73 "muovata") ; --UNCHK
lin sculpture_V2 = mkWV2 (k73 "muovata") ; --UNCHK
lin scum_N = mkWN (k10 "kuona") ; --UNCHK
lin scumble_N = mkWN (compoundN "maa" (k38 "laaminen")) ; --UNCHK
lin scummy_A = mkWA (compoundA "kuo" (k38 "nainen")) ; --UNCHK
lin scunner_N = mkWN (k9 "viha") ; --UNCHK
lin scunthorpe_PN = foreignPN "Scunthorpe" ;
lin scup_N = mkWN "Stenotomus" "chrysops" ; --UNCHK
lin scupper_N = mkWN (compoundN "nielu" (k1A "aukko")) ; --UNCHK
lin scupper_V2 = mkWV2 (k53 "altistaa") ; --UNCHK
lin scuppernong_N = mkWN (k48 "rypäle") ; --UNCHK
lin scurf_N = mkWN (k48 "hilse") ; --UNCHK
lin scurfy_A = mkWA (k38 "hilseinen") ; --UNCHK
lin scurrility_N = mkWN (k39 "solvaus") ; --UNCHK
lin scurrilous_A = mkWA (k34A "ruokoton") ; --UNCHK
lin scurry_N = mkWN (k2 "säntäily") ; --UNCHK
lin scurry_V = mkWV (k53A "kipittää") ; --UNCHK
lin scurvy_A = mkWA (k38 "halpamainen") ; --UNCHK
lin scurvy_N = mkWN (k5A "keripukki") ; --UNCHK
lin scut_N = mkWN (k10A "häntä") ; --UNCHK
lin scutcheon_N = mkWN (compoundN "vaakuna" (k7A "kilpi")) ; --UNCHK
lin scute_N = mkWN (k7A "kilpi") ; --UNCHK
lin scuttle_N = mkWN (k1A "luukku") ; --UNCHK
lin scuttle_V = mkWV (k53A "kipittää") ; --UNCHK
lin scuttle_V2 = mkWV2 (k53A "kipittää") ; --UNCHK
lin scylla_N = mkWN "Skylla" ; --UNCHK
lin scyphozoan_N = mkWN (compoundN "ontelo" (k33 "eläin")) ; --UNCHK
lin scyphus_N = mkWN (k5A "kuppi") ; --UNCHK
lin scythe_N = mkWN (k48A "viikate") ; --UNCHK
lin scythe_V2 = mkWV2 (k53A "niittää") ; --UNCHK
lin sea_N = L.sea_N ;
lin sea_anemone_N = mkWN (compoundN "meri" (k1A "vuokko")) ; --UNCHK
lin sea_animal_N = mkWN (compoundN "vesi" (k33 "eläin")) ; --UNCHK
lin sea_bathing_N = mkWN "meressä" "kylpeminen" ; --UNCHK
lin sea_boat_N = mkWN (compoundN "meri" (k39 "alus")) ; --UNCHK
lin sea_bream_N = mkWN (k9 "lahna") ; --UNCHK
lin sea_breeze_N = mkWN (compoundN "meri" (k26 "tuuli")) ; --UNCHK
lin sea_coal_N = mkWN (compoundN "meri" (k24 "hiili")) ; --UNCHK
lin sea_cow_N = mkWN (compoundN "meri" (k10 "lehmä")) ; --UNCHK
lin sea_dog_N = mkWN (k14A "silakka") ; --UNCHK
lin sea_god_N = mkWN (compoundN "meri" (k10 "jumala")) ; --UNCHK
lin sea_green_N = mkWN (compoundN "harmaan" (k15 "vihreä")) ; --UNCHK
lin sea_horse_N = mkWN (compoundN "meri" (k38 "hevonen")) ; --UNCHK
lin sea_level_N = mkWN (k1 "taso") "merenpinnan" ; --UNCHK
lin sea_lion_N = mkWN (compoundN "meri" (k10 "leijona")) ; --UNCHK
lin sea_rover_N = mkWN (k5A "piraatti") ; --UNCHK
lin sea_snake_N = mkWN (compoundN "meri" (k48 "käärme")) ; --UNCHK
lin sea_urchin_N = mkWN (k5 "merisiili") ; --UNCHK
lin seabag_N = mkWN (compoundN "merimies" (k5A "säkki")) ; --UNCHK
lin seabed_N = mkWN "valtamerenpohja" ; --UNCHK
lin seabird_N = mkWN (compoundN "meri" (k1A "lintu")) ; --UNCHK
lin seaboard_N = mkWN (k4A "rannikko") ; --UNCHK
lin seaborgium_N = mkWN "järjestysluku" "106" ; --UNCHK
lin seaborne_A = mkWA "meriteitse" "tapahtuva" ; --UNCHK
lin seafarer_N = mkWN (k14A "silakka") ; --UNCHK
lin seafaring_A = mkWA "valtameri-" ; --UNCHK
lin seafaring_N = mkWN (compoundN "meren" (k1A "kulku")) ; --UNCHK
lin seafood_N = mkWN (compoundN "kala" (k10A "ruoka")) ; --UNCHK
lin seaford_PN = foreignPN "Seaford" ;
lin sea_girt_A = mkWA "meren" "ympäröimä" ; --UNCHK
lin seagoing_A = mkWA "valtameri-" ; --UNCHK
lin seagrass_N = mkWN (compoundN "meri" (k1 "ruoho")) ; --UNCHK
lin seagull_N = mkWN (k5A "lokki") ; --UNCHK
lin seaham_PN = foreignPN "Seaham" ;
lin seal_N = mkWN (k48A "hylje") ;
lin seal_V = mkWV (k62 "sinetöidä") ; --UNCHK
lin seal_V2 = mkWV2 (k62 "sinetöidä") ; --UNCHK
lin seal_VS = mkWVS (k62 "sinetöidä") ; --UNCHK
lin seal_ring_N = mkWN (compoundN "sinetti" (k39 "sormus")) ; --UNCHK
lin sealant_N = mkWN (k48 "tiiviste") ; --UNCHK
lin sealer_N = mkWN (k10 "leimaaja") ; --UNCHK
lin sealing_wax_N = mkWN (k5A "sinetti") ; --UNCHK
lin sealskin_N = mkWN (k48A "vaate") "hylkeennahkainen" ; --UNCHK
lin sealyham_N = mkWN (compoundN "sealyhamin" (k5 "terrieri")) ; --UNCHK
lin seam_N = mkWN (k9 "sauma") ; --UNCHK
lin seam_V2 = mkWV2 (k73 "saumata") ; --UNCHK
lin seaman_N = mkWN (k14A "silakka") ; --UNCHK
lin seamanlike_A = mkWA (compoundA "meri" (k41A "miehekäs")) ; --UNCHK
lin seamanship_N = mkWN (compoundN "merenkulku" (k1A "taito")) ; --UNCHK
lin seamless_A = mkWA (k34A "saumaton") ; --UNCHK
lin seamount_N = mkWN (kH1 "vuori") "merenalainen" ; --UNCHK
lin seamstress_N = mkWN (k5 "modisti") ; --UNCHK
lin seamy_A = mkWA (k38 "likainen") ; --UNCHK
lin seance_N = mkWN (k1A "istunto") ; --UNCHK
lin seaplane_N = mkWN "vesilentokone" ; --UNCHK
lin seaport_N = mkWN (k10 "satama") ; --UNCHK
lin seaquake_N = mkWN (compoundN "maan" (k39 "järistys")) "merenalainen" ; --UNCHK
lin sear_A = mkWA (k41 "kitulias") ; --UNCHK
lin sear_V2 = mkWV2 (k53A "polttaa") ; --UNCHK
lin search_N = mkN "haku" | mkWN (k9A "etsintä") ;
lin search_V = mkWV (k58A "hakea") ; --UNCHK
lin search_V2 = mkWV2 (k58A "hakea") ; --UNCHK
lin search_party_N = mkWN (compoundN "etsintä" (k3 "partio")) ; --UNCHK
lin search_warrant_N = mkWN (compoundN "kotietsintä" (k10A "lupa")) ; --UNCHK
lin searcher_N = mkWN "Calosoma" "scrutator" ; --UNCHK
lin searchingly_Adv = mkWAdv (k99 "tutkivasti") ; --UNCHK
lin searchlight_N = mkWN (compoundN "valon" (k33A "heitin")) ; --UNCHK
lin searing_A = mkWA (k10 "ankara") ; --UNCHK
lin searing_iron_N = mkWN (compoundN "poltto" (k9A "rauta")) ; --UNCHK
lin seascape_N = mkWN (k39 "merimaalaus") ; --UNCHK
lin seashell_N = mkWN (k26 "simpukankuori") ; --UNCHK
lin seashore_N = mkWN (k4A "rannikko") ; --UNCHK
lin seasick_A = mkWA (compoundA "meri" (k41 "sairas")) ; --UNCHK
lin seasickness_N = mkWN (compoundN "meri" (k40 "sairaus")) ; --UNCHK
lin seaside_N = mkWN (k4A "rannikko") ; --UNCHK
lin season_N = mkWN (k9A "vuodenaika") ;
lin season_V = mkWV (k54A "pehmentää") ; --UNCHK
lin season_V2 = mkWV2 (k54A "pehmentää") ; --UNCHK
lin season_ticket_N = mkWN (compoundN "kausi" (k1A "lippu")) ; --UNCHK
lin seasonable_A = mkWA (k10 "sopiva") "vuodenaikaan" ; --UNCHK
lin seasonableness_N = mkWN (k39 "ajoitus") ; --UNCHK
lin seasonal_A = mkWA (k38 "kausittainen") ; --f53
lin seasoner_N = mkWN (k48 "mauste") ; --UNCHK
lin seasoning_N = mkWN (compoundN "mau" (k38 "staminen")) ; --UNCHK
lin seat_N = mkWN (k33 "istuin") ;
lin seat_belt_N = mkWN (compoundN "turva" (k19 "vyö")) ; --UNCHK
lin seating_N = mkWN (compoundN "ohja" (k38 "aminen")) "paikalle" ; --UNCHK
lin seattle_PN = foreignPN "Seattle" ;
lin seaward_A = mkWA (compoundA "rannan" (k38 "puoleinen")) ; --UNCHK
lin seaward_Adv = mkWAdv (k99 "päin") "merelle" ; --UNCHK
lin seaward_N = mkWN (k99 "kohti") "merta" ; --UNCHK
lin seawards_Adv = mkWAdv (k99 "päin") "merelle" ; --UNCHK
lin sea_water_N = mkWN (compoundN "suola" (k27 "vesi")) ; --UNCHK
lin seaway_N = mkWN (k10 "väylä") ; --UNCHK
lin seaweed_N = mkWN (compoundN "meri" (k10 "levä")) ; --UNCHK
lin seaworthiness_N = mkWN (k40 "kuntoisuus") ; --UNCHK
lin seaworthy_A = mkWA (compoundA "meri" (k38 "kelpoinen")) ; --UNCHK
lin seborrhea_N = mkWN (k12 "seborrea") ; --UNCHK
lin sebum_N = mkWN (k5 "tali") ; --UNCHK
lin sec_A = mkWA (compoundA "puoli" (k10 "kuiva")) ; --UNCHK
lin sec_N = mkWN "SEC" ; --UNCHK
lin secant_N = mkWN (k5A "sekantti") ; --UNCHK
lin secede_V = mkWV (k52A "irtautua") ; --UNCHK
lin secession_N = mkWN (compoundN "ero" (k38 "aminen")) ; --UNCHK
lin secessionism_N = mkWN (k5 "separatismi") ; --UNCHK
lin secessionist_N = mkWN (k5 "separatisti") ; --UNCHK
lin seckel_N = mkWN (k12 "päärynä") ; --UNCHK
lin seclude_V2 = mkWV2 (k52A "vetäytyä") ; --UNCHK
lin seclusion_N = mkWN (compoundN "eri" (k38 "stäytyminen")) ; --UNCHK
lin second_N = mkN "sekunti" | mkN "kakkonen" ; ---- split
lin second_V2 = mkWV2 (k54A "komentaa") ; --UNCHK
lin second_best_N = mkWN (k38 "kakkonen") ; --UNCHK
lin second_class_Adv = mkWAdv (compoundAdv "luo" (k9 "kassa")) "toisessa" ; --UNCHK
lin second_class_N = mkWN (k10A "turistiluokka") ; --UNCHK
lin second_guess_V2 = mkV2 "veikata" ; ---ARB
lin second_hand_N = mkWN (compoundN "sekunti" (k33A "osoitin")) ; --UNCHK
lin second_rate_A = mkA "toisluokkainen" ;
lin secondary_A = mkWA (compoundA "tois" (k38 "sijainen")) ;
lin secondary_N = mkWN (compoundN "sekundaari" (k5 "käämi")) ; --UNCHK
lin seconder_N = mkWN (k10 "kannattaja") ; --UNCHK
lin second_hand_A = mkWA (k1A "käytetty") ; --UNCHK
lin secondly_Adv = variants {} ; --
lin secondment_N = mkWN (k39 "komennus") ; --UNCHK
lin secondo_N = mkWN "secondo" ; --UNCHK
lin secrecy_N = mkWN (k40 "salamyhkäisyys") ; --UNCHK
lin secret_A = mkWA (k38 "salainen") ;
lin secret_N = mkWN (k12 "asia") "tuntematon" ; --UNCHK
lin secretarial_A = mkWA "sihteerin" ; --UNCHK
lin secretary_N = mkWN (compoundN "kirjoitus" (k10A "pöytä")) ;
lin secretary_general_N = mkWN (compoundN "pää" (k6 "sihteeri")) ; --UNCHK
lin secretaryship_N = mkWN (k40 "ministeriys") ; --UNCHK
lin secrete_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin secretin_N = mkWN "sekretiini" ; --UNCHK
lin secretion_N = mkWN (k48A "erite") ; --UNCHK
lin secretive_A = mkWA (k38 "salamyhkäinen") ; --UNCHK
lin secretiveness_N = mkWN (k40 "salamyhkäisyys") ; --UNCHK
lin secretory_A = mkWA "eritys-" ; --UNCHK
lin sect_N = mkWN (k1 "lahko") "uskonnollinen" ; --UNCHK
lin sectarian_A = mkWA (k38 "lahkolainen") ; --UNCHK
lin sectarian_N = mkWN (k12 "kiihkoilija") ; --UNCHK
lin sectarianism_N = mkWN (k40 "lahkolaisuus") ; --UNCHK
lin section_N = mkN "osasto" | mkN "sektio" | mkN "leikkaus" ; ---- split
lin sectional_A = mkWA "läpileikkaus-" ; --UNCHK
lin sectional_N = mkWN (compoundN "huone" (k1 "kalu")) "koottava" ; --UNCHK
lin sectionalism_N = mkWN (k5 "provinsialismi") ; --UNCHK
lin sector_N = mkN (lin NK {s = d06 "sektori"}) ;
lin sectorial_A = mkWA "sektori-" ; --UNCHK
lin secular_A = mkWA (k38 "sekulaarinen") ; --UNCHK
lin secularism_N = mkWN (k5 "sekularismi") ; --UNCHK
lin secularist_N = mkWN (k5 "sekularisti") ; --UNCHK
lin secularization_N = mkWN (compoundN "sekulaari" (k38 "staminen")) ; --UNCHK
lin secundigravida_N = mkWN "sekundigravida" ; --UNCHK
lin secure_A = mkWA (k34A "huoleton") ; --UNCHK
lin secure_V2 = mkV2 "turvata" ;
lin secureness_N = mkWN (k40 "pysyvyys") ; --UNCHK
lin security_N = mkWN (k40 "turvallisuus") ;
lin sedan_N = mkWN (compoundN "perhe" (k1 "auto")) ; --UNCHK
lin sedan_chair_N = mkWN (compoundN "kanto" (k5 "tuoli")) ; --UNCHK
lin sedate_A = mkWA (k17 "vakaa") ; --UNCHK
lin sedate_V2 = mkWV2 (k56A "antaa") "rauhoittavia" ; --UNCHK
lin sedateness_N = mkWN (k40 "juhlavuus") ; --UNCHK
lin sedation_N = mkWN "sedaatio" ; --UNCHK
lin sedative_A = mkWA (compoundA "sedatiivi" (k38 "nen")) ; --UNCHK
lin sedative_N = mkWN (k5 "sedatiivi") ; --UNCHK
lin sedentary_A = mkWA (k10 "liikkuva") "vähän" ; --UNCHK
lin sedge_N = mkWN (k9 "sara") ; --UNCHK
lin sedgy_A = mkWA (compoundA "sara" (k38 "inen")) ; --UNCHK
lin sediment_N = mkWN (k10 "esiintymä") ; --UNCHK
lin sedition_N = mkWN (compoundN "kansan" (k39 "kiihotus")) ; --UNCHK
lin seduce_V2 = mkWV2 (k67A "vietellä") ; --UNCHK
lin seducer_N = mkWN (k12 "viettelijä") ; --UNCHK
lin seduction_N = mkWN (k2 "viettely") ; --UNCHK
lin seductive_A = mkWA (k10 "viettelevä") ; --UNCHK
lin seductress_N = mkWN (k32A "viettelijätär") ; --UNCHK
lin sedulity_N = mkWN (k40 "ahkeruus") ; --UNCHK
lin sedulous_A = mkWA (k10 "uuttera") ; --UNCHK
lin sedum_N = mkWN (compoundN "maksa" (k1 "ruoho")) ; --UNCHK
lin see_N = mkWN (compoundN "piispan" (k33 "istuin")) ; --UNCHK
lin see_V = nahda_V ;
lin see_V2 = L.see_V2 ;
lin see_V2V = mkV2V nahda_V (mkPrep genitive) infPresPart ;
lin see_VQ = mkVQ nahda_V ;
lin see_VS = mkVS (mkV (mkV "pitää") "huolta") ;
lin see_about_V2 = prepV2 OP_see_V OP_about_Prep ; -- guess-p-verb
lin see_into_V3 = variants {} ; -- guess-p-verb
lin see_off_V2 = prepV2 OP_see_V OP_off_Prep ; -- guess-p-verb
lin see_out_V2 = prepV2 OP_see_V OP_out_Prep ; -- guess-p-verb
lin see_through_A = mkA (mkN "läpi" (mkN "näkyvä")) ;
lin see_through_V2 = mkWV2 (k53A "suorittaa") "loppuun" ; --UNCHK
lin see_to_V2 = prepV2 OP_see_V OP_to_Prep ; -- guess-p-verb
lin seed_N = L.seed_N ;
lin seed_V = mkWV (k53 "poistaa") "siemenet" ; --UNCHK
lin seed_V2 = mkWV2 (k53 "poistaa") "siemenet" ; --UNCHK
lin seed_corn_N = mkWN (compoundN "siemen" (k9 "vilja")) ; --UNCHK
lin seedbed_N = mkWN (compoundN "kylvö" (k13 "alusta")) ; --UNCHK
lin seedcake_N = mkWN (k39 "leivos") ; --UNCHK
lin seeder_N = mkWN (compoundN "kuorima" (k48 "väline")) ; --UNCHK
lin seediness_N = mkWN (k40 "saastaisuus") ; --UNCHK
lin seedless_A = mkWA (k34A "siemenetön") ; --UNCHK
lin seedling_N = mkWN (compoundN "kylvö" (k25 "taimi")) ; --UNCHK
lin seedsman_N = mkWN (compoundN "siemen" (k41 "kauppias")) ; --UNCHK
lin seedtime_N = mkWN (k9A "kylvöaika") ; --UNCHK
lin seedy_A = mkA "likainen" ;
lin seek_N = mkWN (compoundN "hake" (k38 "minen")) ; --UNCHK
lin seek_V2 = L.seek_V2 ;
lin seek_VV = mkVV (mkV "pyytää") infIllat ;
lin seek_out_V = mkWV (k58A "hakea") ; --UNCHK
lin seek_out_V2 = prepV2 (lin V OP_seek_V2) OP_out_Prep ; -- guess-p-verb
lin seeker_N = mkWN (k39 "ohjus") "itseohjautuva" ; --UNCHK
lin seeking_N = mkWN (k39 "yritys") ; --UNCHK
lin seem_VA = mkVA (mkV "näyttää") (casePrep ablative) ;
lin seem_VS = mkVS (mkV "vaikuttaa") ;
lin seem_VV = mkVV (mkV "vaikuttaa") infPresPart ;
lin seeming_A = mkWA (k38 "näennäinen") ;
lin seemliness_N = mkWN (k40 "suosiollisuus") ; --UNCHK
lin seemly_A = mkWA (k38 "säädyllinen") ; --UNCHK
lin seep_V = mkWV (k53A "vuotaa") ; --UNCHK
lin seepage_N = mkWN (k1A "vuoto") ; --UNCHK
lin seer_N = mkWN (k12 "näkijä") ; --UNCHK
lin seersucker_N = mkWN "seersucker" ; --UNCHK
lin seesaw_N = mkWN (compoundN "kiikku" (k9A "lauta")) ; --UNCHK
lin seesaw_V = mkWV (k52 "horjua") ; --UNCHK
lin seethe_V = mkWV (k52 "kuohua") ; --UNCHK
lin seethe_V2 = mkWV2 (k52 "kuohua") ; --UNCHK
lin segment_N = mkN "segmentti" ;
lin segment_V = mkWV (k56A "jakaa") "osiin" ; --UNCHK
lin segment_V2 = mkWV2 (k56A "jakaa") "osiin" ; --UNCHK
lin segmental_A = mkWA (k38 "jaokkeinen") ; --UNCHK
lin segmentation_N = mkWN (k39 "ositus") ; --UNCHK
lin segno_N = mkWN "segno" ; --UNCHK
lin segregate_N = mkWN (k2 "henkilö") "syrjitty" ; --UNCHK
lin segregate_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin segregation_N = mkWN (k39 "eristys") ; --UNCHK
lin segregationism_N = mkWN (compoundN "rotu" (k2 "erottelu")) ; --UNCHK
lin segregator_N = mkWN (k10 "kannattaja") "rotuerottelun" ; --UNCHK
lin segue_N = mkWN (k10 "siirtymä") ; --UNCHK
lin seiche_N = mkWN (k1A "aalto") ; --UNCHK
lin seigneury_N = mkWN (compoundN "maa" (k40 "herruus")) ; --UNCHK
lin seignior_N = mkWN (compoundN "läänin" (k9 "herra")) ; --UNCHK
lin seigniorage_N = mkWN (k1 "maksu") ; --UNCHK
lin seigniory_N = mkWN (compoundN "maa" (k40 "herruus")) ; --UNCHK
lin seine_N = mkWN (k10A "nuotta") ; --UNCHK
lin seine_V = mkWV (k73 "troolata") ; --UNCHK
lin seine_V2 = mkWV2 (k73 "troolata") ; --UNCHK
lin seinäjoki_PN = mkPN (mkN "Seinäjoki" "Seinäjokia") ;
lin seismic_A = mkWA (k38 "seisminen") ; --UNCHK
lin seismogram_N = mkWN (k5 "seismogrammi") ; --UNCHK
lin seismograph_N = mkWN (k5 "seismografi") ; --UNCHK
lin seismography_N = mkWN "seismografia" ; --UNCHK
lin seismological_A = mkWA (k38 "seismologinen") ; --UNCHK
lin seismologist_N = mkWN "seismologi" ; --UNCHK
lin seismology_N = mkWN (k12 "seismologia") ; --UNCHK
lin seize_V = mkWV (k53A "valloittaa") ; --UNCHK
lin seize_V2 = mkWV2 (k53A "valloittaa") ; --UNCHK
lin seize_up_V = advV OP_seize_V OP_up_Adv ; -- guess-p-verb
lin seizing_N = mkWN (compoundN "tarra" (k38 "aminen")) ; --UNCHK
lin seizure_N = mkWN (compoundN "haltuun" (k1A "otto")) ; --UNCHK
lin selby_PN = foreignPN "Selby" ;
lin seldom_Adv = mkWAdv (k99 "harvoin") ;
lin select_A = mkWA (compoundA "valiko" (k1A "itu")) ; --UNCHK
lin select_V = mkV "valikoitua" ;
lin select_V2 = mkV2 "valita" ; ---ARB mkWV2 (k61 "poimia") ;
lin select_V2V = mkWV2V (k61 "poimia") ; --UNCHK
lin select_VV = mkWVV (k61 "poimia") ; --UNCHK
lin selected_A = mkA "valikoitu" ; 
lin selection_N = mkWN (k9A "valinta") ; --UNCHK
lin selective_A = mkWA (compoundA "valik" (k10 "oiva")) ; --UNCHK
lin selectivity_N = mkWN "valikoivuus" ; --UNCHK
lin selectman_N = mkWN (compoundN "virka" (k42 "mies")) "valittu" ; --UNCHK
lin selector_N = mkWN (k33 "valitsin") ; --UNCHK
lin selectwoman_N = mkWN (compoundN "virka" (k38 "nainen")) "valittu" ; --UNCHK
lin selenium_N = mkWN (k6 "seleeni") ; --UNCHK
lin selenology_N = mkWN (compoundN "kuun" (k39 "tutkimus")) ; --UNCHK
lin self_A = mkWA "itse-" ; --UNCHK
lin self_N = mkWN (k101 "minä") ; --UNCHK
lin self_confessed_A = mkA "tunnustautunut" ;
lin self_confidence_N = mkN "itseluottamus" ;
lin self_conscious_A = mkA "itsetietoinen" ;
lin self_defence_N = mkN "itsepuolustus" ;
lin self_destruct_V = mkV (mkV "tuhota") "itsensä" ;
lin self_employed_A = mkA "itsensätyöllistävä" ;
lin self_explanatory_A = mkA (mkN "itsestään" (mkN "selvä")) ;
lin self_important_A = mkA (mkN "itse" (mkN "riittoinen")) ;
lin self_imposed_A = mkA "itseaiheutettu" ;
lin self_indulgent_A = mkA (mkN "nautinnon" (mkN "haluinen")) ;
lin self_insure_V = mkV (mkV "vakuuttaa") "itsensä" ;
lin self_righteous_A = mkA (mkN "oma" (mkN "hyväinen")) ;
lin self_starter_N = mkN "aloitteen" (mkN "tekijä") ;
lin self_styled_A = mkA "tekaistu" ;
lin self_sufficient_A = mkA "omavarainen" ;
lin selfish_A = mkWA (k41A "itsekäs") ; --UNCHK
lin selfishness_N = mkWN (k40 "itsekkyys") ; --UNCHK
lin selflessness_N = mkWN (compoundN "uhrautu" (k40 "vaisuus")) ; --UNCHK
lin selfsameness_N = mkWN "samaisuus" ; --UNCHK
lin selkirk_PN = foreignPN "Selkirk" ;
lin sell_N = mkN "myynti" ;
lin sell_V = mkV "myydä" ;
lin sell_V2 = mkV2 (mkV "myydä") ;
lin sell_V3 = L.sell_V3 ;
lin sell_back_V = advV OP_sell_V OP_back_Adv ; -- guess-p-verb
lin sell_off_V2 = mkWV2 (k63 "myydä") "pois" ; --UNCHK
lin sell_on_V2 = prepV2 OP_sell_V OP_on_Prep ; -- guess-p-verb
lin sell_out_V = mkWV (k53A "pettää") ; --UNCHK
lin sell_out_V2 = mkWV2 (k53A "pettää") ; --UNCHK
lin sell_up_V2 = mkWV2 (k63 "myydä") ; --UNCHK
lin sellerFem_N = mkWN (k12 "kaupittelija") ; --f66
lin sellerMasc_N = mkN "myyjä" ; --
lin selling_N = mkN "myynti" ;
lin selloff_N = mkWN (k5A "myynti") ; --UNCHK
lin sellout_N = mkWN (k39 "petos") ; --UNCHK
lin selsey_PN = foreignPN "Selsey" ;
lin selsyn_N = mkWN "synkro" ; --UNCHK
lin seltzer_N = mkWN (k27 "vesi") "kupliva" ; --UNCHK
lin selvage_N = mkWN (k3 "hulpio") ; --UNCHK
lin selvedge_N = mkWN (k3 "hulpio") ; --UNCHK
lin semantic_A = mkWA (k38 "semanttinen") ; --UNCHK
lin semanticist_N = mkWN (compoundN "kieli" (k12 "tieteilijä")) ; --UNCHK
lin semantics_N = mkWN (k39 "merkitys") ; --UNCHK
lin semaphore_N = mkWN (k5 "semafori") ; --UNCHK
lin semaphore_V = mkWV (k53 "opastaa") ; --UNCHK
lin semaphore_V2 = mkWV2 (k53 "opastaa") ; --UNCHK
lin semarang_PN = foreignPN "Semarang" ;
lin semblance_N = mkWN (compoundN "ulko" (k1A "muoto")) ; --UNCHK
lin semen_N = mkWN (kH1 "mälli") ; --UNCHK
lin semester_N = mkWN (compoundN "puolivuotis" (k27 "kausi")) ; --UNCHK
lin semestral_A = mkWA (compoundA "puoli" (k38 "vuosittainen")) ; --UNCHK
lin semi_final_N = mkN "semifinaali" ;
lin semiabstract_A = mkWA (compoundA "puoli" (k5 "abstrakti")) ; --UNCHK
lin semiannual_A = mkWA (compoundA "puoli" (k38 "vuosittainen")) ; --UNCHK
lin semiaquatic_A = mkWA (compoundA "semi" (k38 "akvaattinen")) ; --UNCHK
lin semiarid_A = mkWA (k34A "vedetön") "melkein" ; --UNCHK
lin semiautobiographical_A = mkWA "puolielämäkerrallinen" ; --UNCHK
lin semiautomatic_A = mkWA (compoundA "puoli" (k38 "automaattinen")) ; --UNCHK
lin semibreve_N = mkWN (compoundN "koko" (k5A "nuotti")) ; --UNCHK
lin semicentennial_A = mkWA "puolivuosisatais-" ; --UNCHK
lin semicentennial_N = mkWN "puolivuosisatainen" ; --UNCHK
lin semicircle_N = mkWN (compoundN "puoli" (k12 "ympyrä")) ; --UNCHK
lin semicircular_A = mkWA (compoundA "puoli" (k15 "pyöreä")) ; --UNCHK
lin semicolon_N = mkWN (compoundN "puoli" (k48 "piste")) ; --UNCHK
lin semicoma_N = mkWN (compoundN "semi" (k10 "kooma")) ; --UNCHK
lin semicomatose_A = mkWA (compoundA "koo" (k9 "massa")) "osittaisessa" ; --UNCHK
lin semiconducting_A = mkWA (compoundA "puoli" (k10 "johtava")) ; --UNCHK
lin semiconductor_N = mkWN (compoundN "puoli" (k48A "johde")) ;
lin semiconscious_A = mkWA (k10 "sekava") ; --UNCHK
lin semidark_A = mkWA (k15 "pimeä") "osittain" ; --UNCHK
lin semidarkness_N = mkWN (k40 "pimeys") "osittainen" ; --UNCHK
lin semidesert_N = mkWN (compoundN "puoli" (k4A "aavikko")) ; --UNCHK
lin semidetached_A = mkWA "osittain" "kytketty" ; --UNCHK
lin semidiameter_N = mkWN (k48A "säde") ; --UNCHK
lin semiempirical_A = mkWA (compoundA "puoli" (k38 "empiirinen")) ; --UNCHK
lin semifinalist_N = mkWN (k5 "semifinalisti") ; --UNCHK
lin semifluidity_N = mkWN (compoundN "puoli" (k40 "juoksevuus")) ; --UNCHK
lin semiformal_A = mkWA (compoundA "puoli" (k38 "virallinen")) ; --UNCHK
lin semigloss_N = mkWN (kH1 "maali") "puolihimmeä" ; --UNCHK
lin semihard_A = mkWA (compoundA "puoli" (k10 "kova")) ; --UNCHK
lin semiliquid_A = mkWA (compoundA "puoli" (k10 "juokseva")) ; --UNCHK
lin semimonthly_A = mkWA (compoundA "puoli" (k38 "kuukausittainen")) ; --UNCHK
lin semimonthly_Adv = mkWAdv (compoundAdv "puoli" (k38 "kuukausittainen")) ; --UNCHK
lin semimonthly_N = mkWN (k2 "julkaisu") "puolikuukausittainen" ; --UNCHK
lin seminal_A = mkWA "siemen-" ; --UNCHK
lin seminar_N = mkWN (k5 "seminaari") ;
lin seminarian_N = mkWN (k41 "oppilas") ; --UNCHK
lin seminarist_N = mkWN (k41 "oppilas") ; --UNCHK
lin seminary_N = mkWN (compoundN "yksityis" (k1 "koulu")) ; --UNCHK
lin seminiferous_A = mkWA (k10 "tuottava") "siemennestettä" ; --UNCHK
lin seminoma_N = mkWN (compoundN "kives" (k10A "syöpä")) ; --UNCHK
lin seminude_A = mkWA (compoundA "puoli" (k34 "alaston")) ; --UNCHK
lin semiofficial_A = mkWA (compoundA "puoli" (k38 "virallinen")) ; --UNCHK
lin semiopaque_A = mkWA (k10 "läpikuultava") ; --UNCHK
lin semiotic_A = mkWA (k38 "semioottinen") ; --UNCHK
lin semiotics_N = mkWN (k9A "semiotiikka") ; --UNCHK
lin semiparasitic_A = mkWA "puolilois-" ; --UNCHK
lin semipermeable_A = mkWA (k10 "puoliläpäisevä") ; --UNCHK
lin semipolitical_A = mkWA (compoundA "puoli" (k38 "poliittinen")) ; --UNCHK
lin semiprivate_A = mkWA (compoundA "jae" (k1 "ttu")) ; --UNCHK
lin semiprofessional_N = mkWN (compoundN "puoli" (k38 "ammattilainen")) ; --UNCHK
lin semipublic_A = mkWA (compoundA "puoli" (k38 "julkinen")) ; --UNCHK
lin semiquaver_N = mkWN (compoundN "kuudestoistaosa" (k5A "nuotti")) ; --UNCHK
lin semirigid_A = mkWA (compoundA "puoli" (k10A "jäykkä")) ; --UNCHK
lin semisolid_A = mkWA (compoundA "puoli" (k15 "jähmeä")) ; --UNCHK
lin semite_A = mkWA (k38 "seemiläinen") ; --UNCHK
lin semite_N = mkWN (k38 "seemiläinen") ; --UNCHK
lin semiterrestrial_A = mkWA (compoundA "maan" (k38 "päällinen")) "puoliksi" ; --UNCHK
lin semitic_A = mkWA (k38 "seemiläinen") ; --UNCHK
lin semitone_N = mkWN (compoundN "puoli" (k49 "askel")) ; --UNCHK
lin semitrailer_N = mkWN "puoliperävaunu" ; --UNCHK
lin semitrance_N = mkWN (compoundN "puoli" (k5 "transsi")) ; --UNCHK
lin semitropical_A = mkWA (k38 "subtrooppinen") ; --UNCHK
lin semivowel_N = mkWN (compoundN "puoli" (k6 "vokaali")) ; --UNCHK
lin semiweekly_Adv = mkWAdv "kahdesti" "viikossa" ; --UNCHK
lin semiweekly_N = mkWN "semiweekly" ; --UNCHK
lin semolina_N = mkWN "semolina" ; --UNCHK
lin sempstress_N = mkWN (k5 "modisti") ; --UNCHK
lin sen_N = mkWN (k99 "sen") ; --UNCHK
lin senate_N = mkWN (k5A "senaatti") ; --UNCHK
lin senator_N = mkWN (k6 "senaattori") ; --f67
lin senatorial_A = mkWA (compoundA "senaattor" (k32A "ien")) ; --UNCHK
lin senatorship_N = mkWN (k9A "virka") "senaattorin" ; --UNCHK
lin send_V = mkV "lähettää" ;
lin send_V2 = mkV2 "lähettää" ;
lin send_V2V = mkV2V (mkV "lähettää") accusative infIllat ;
lin send_V3 = L.send_V3 ;
lin send_back_V2 = mkWV2 (k53A "palauttaa") ; --UNCHK
lin send_for_V2 = mkWV2 (k52 "kutsua") ; --UNCHK
lin send_in_V = mkWV (k53A "postittaa") ; --UNCHK
lin send_in_V2 = mkWV2 (k53A "postittaa") ; --UNCHK
lin send_off_V2 = mkWV2 (k53A "toimittaa") ; --UNCHK
lin send_off_for_V2 = prepV2 (advV OP_send_V OP_off_Adv ) OP_for_Prep ; -- guess-p-verb
lin send_out_V2 = mkWV2 (k53A "toimittaa") ; --UNCHK
lin send_out_for_V2 = prepV2 (advV OP_send_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin send_up_V2 = prepV2 OP_send_V OP_up_Prep ; -- guess-p-verb
lin sendee_N = mkWN (k10 "saaja") ; --UNCHK
lin sender_N = mkWN (k33A "lähetin") ; --UNCHK
lin sending_N = mkWN "lähetys-" ; --UNCHK
lin sene_N = mkWN "sene" ; --UNCHK
lin senega_N = mkWN (k9 "alba") "Polygala" ; --UNCHK
lin senegal_PN = foreignPN "Senegal" ;
lin senegalese_A = mkWA (compoundA "senegali" (k38 "lainen")) ; --UNCHK
lin senegalese_N = mkWN (compoundN "senegali" (k38 "lainen")) ; --UNCHK
lin senescence_N = mkWN (k40 "vanhuus") ; --UNCHK
lin senescent_A = mkWA (compoundA "vanhe" (k9 "neva")) ; --UNCHK
lin seneschal_N = mkWN (compoundN "hovi" (k6 "mestari")) ; --UNCHK
lin senile_A = mkWA (k6 "seniili") ; --UNCHK
lin senility_N = mkWN (compoundN "vanhuuden" (k40 "heikkous")) ; --UNCHK
lin senior_A = mkWA (k16A "vanhempi") ; --f286
lin senior_N = mkN "seniori" ; --mkWN (k2 "henkilö") "vanhempi" ;
lin seniority_N = mkN "virka" (mkN "ikä") ; --mkWN (k40 "vanhemmuus") ;
lin seniti_N = mkWN "seniti" ; --UNCHK
lin senna_N = mkWN "senna" ; --UNCHK
lin sennit_N = mkWN (compoundN "köysi" (k4A "palmikko")) ; --UNCHK
lin senor_N = mkWN "Senor" ; --UNCHK
lin senora_N = mkWN (compoundN "Sen" (k10 "ora")) ; --UNCHK
lin senorita_N = mkWN (compoundN "Seno" (k9A "rita")) ; --UNCHK
lin sensate_A = mkWA (compoundA "aist" (k9 "iva")) ; --UNCHK
lin sensation_N = mkWN (k1A "kyky") ; --UNCHK
lin sensational_A = mkWA (k38 "sensaatiomainen") ; --UNCHK
lin sensationalism_N = mkWN (k5 "sensualismi") ; --UNCHK
lin sensationalist_N = mkWN (compoundN "kohu" (k12 "näyttelijä")) ; --UNCHK
lin sense_N = mkN "aisti" | mkN "järki" | mkN "mieli" ; ---- split
lin sense_V2 = mkV2 "aistia" partitive ; --mkWV2 (k54A "ymmärtää") ;
lin sense_VS = mkWVS (k54A "ymmärtää") ; --UNCHK
lin sense_organ_N = mkWN (k5 "reseptori") ; --UNCHK
lin senseless_A = mkWA (k34A "älytön") ; --UNCHK
lin senselessness_N = mkWN (k40 "tarkoituksettomuus") ; --UNCHK
lin sensibility_N = mkWN (k40 "vastaanottavuus") ; --UNCHK
lin sensible_A = mkWA (k38 "järjellinen") ; --UNCHK
lin sensibleness_N = mkWN (k40 "vastuullisuus") ; --UNCHK
lin sensing_N = mkWN (k39 "aistimus") ; --UNCHK
lin sensitive_A = mkWA (k10A "herkkä") ;
lin sensitivity_N = mkWN (k40 "herkkyys") ; --UNCHK
lin sensitization_N = mkWN "sensitisaatio" ; --UNCHK
lin sensitize_V2 = mkWV2 (k53 "herkistää") ; --UNCHK
lin sensitizer_N = mkWN "herkistin" ; --UNCHK
lin sensitizing_A = mkWA "herkistävä" ; --UNCHK
lin sensitizing_N = mkWN "sensitisaatio" ; --UNCHK
lin sensitometer_N = mkWN (compoundN "valonherkkyys" (k6 "mittari")) ; --UNCHK
lin sensorimotor_A = mkWA (compoundA "senso" (k38 "motorinen")) ; --UNCHK
lin sensorineural_A = mkWA (compoundA "sensorineura" (k38 "alinen")) ; --UNCHK
lin sensorium_N = mkWN "sensorium" ; --UNCHK
lin sensory_A = mkWA (compoundA "sensoria" (k38 "alinen")) ; --UNCHK
lin sensual_A = mkA "aistillinen" ;
lin sensualism_N = mkWN (k5 "sensualismi") ; --UNCHK
lin sensualist_N = mkWN "sensualisti" ; --UNCHK
lin sensuality_N = mkWN (k5 "sensualismi") ; --UNCHK
lin sensuous_A = mkWA (k38 "nautinnollinen") ; --UNCHK
lin sensuousness_N = mkWN (k40 "nautinnollisuus") ; --UNCHK
lin sent_N = mkWN (k5A "sentti") ; --UNCHK
lin sente_N = mkWN "sente" ; --UNCHK
lin sentence_N = mkN "lause" | mkWN (k3 "tuomio") ; --- split
lin sentence_V = mkWV (k69 "tuomita") ; --UNCHK
lin sentence_V2 = mkWV2 (k69 "tuomita") ; --UNCHK
lin sentential_A = mkWA "lause-" ; --UNCHK
lin sententious_A = mkWA (k41 "tiivis") ; --UNCHK
lin sentience_N = mkWN (compoundN "tuntemis" (k1A "kyky")) ; --UNCHK
lin sentient_A = mkWA (k10 "elävä") ; --UNCHK
lin sentiment_N = mkWN (k48A "mielipide") ; --UNCHK
lin sentimental_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin sentimentalism_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin sentimentalist_N = mkWN (k1A "romantikko") ; --UNCHK
lin sentimentality_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin sentimentalization_N = mkWN (k5A "tunnelmointi") ; --UNCHK
lin sentimentalize_V = mkWV (k67 "tunteilla") ; --UNCHK
lin sentimentalize_V2 = mkWV2 (k67 "tunteilla") ; --UNCHK
lin sentinel_N = mkWN (k12 "vartija") ; --UNCHK
lin sentry_N = mkWN (k12 "vartija") ; --UNCHK
lin sentry_box_N = mkWN (k5A "vartiokoppi") ; --UNCHK
lin sentry_go_N = mkWN (k3 "vartio") ; --UNCHK
lin seoul_PN = foreignPN "Soul" ;
lin sepal_N = mkWN (compoundN "verho" (k7A "lehti")) ; --UNCHK
lin sepaloid_A = mkWA "verholehden" ; --UNCHK
lin separability_N = mkWN "eroteltavuus" ; --UNCHK
lin separable_A = mkWA (k10 "oleva") "erotettavissa" ; --UNCHK
lin separate_A = mkWA (k38 "erillinen") ; --f183
lin separate_N = mkWN (k10 "osa") "yhdistelmäasun" ; --UNCHK
lin separate_V = mkWV (k52A "erkaantua") ;
lin separate_V2 = mkV2 "erottaa" ; --mkWV2 (k52A "erkaantua") ;
lin separateness_N = mkWN (k40 "erillisyys") ; --UNCHK
lin separation_N = mkWN (compoundN "ero" (k38 "ttaminen")) ; --UNCHK
lin separatism_N = mkWN (k1 "ero") ; --UNCHK
lin separatist_N = mkWN (k5 "separatisti") ; --UNCHK
lin separative_A = mkWA "erotteleva" ; --UNCHK
lin separator_N = mkWN (k33A "erotin") ; --UNCHK
lin sepia_N = mkWN (k12 "seepia") ; --UNCHK
lin sepsis_N = mkWN (k39 "sepsis") ; --UNCHK
lin septal_A = mkWA (compoundA "septa" (k38 "alinen")) ; --UNCHK
lin septation_N = mkWN (compoundN "väli" (k10 "seinä")) ; --UNCHK
lin septectomy_N = mkWN (k1 "poisto") "väliseinän" ; --UNCHK
lin septet_N = mkWN (k1A "septetto") ; --UNCHK
lin septic_A = mkWA (k38 "septinen") ; --UNCHK
lin septicaemia_N = mkWN (compoundN "veren" (k39 "myrkytys")) ; --UNCHK
lin septicemia_N = mkWN (compoundN "veren" (k39 "myrkytys")) ; --UNCHK
lin septicemic_A = mkWA "verenmyrkytystä" "aiheuttava" ; --UNCHK
lin septillion_N = mkWN (k10 "kvadriljoona") ; --UNCHK
lin septrional_A = mkWA (k38 "pohjoinen") ; --UNCHK
lin septuagenarian_N = mkWN "seitsenkymmenvuotias" ; --UNCHK
lin septuagint_N = mkWN "septuaginta" ; --UNCHK
lin septum_N = mkWN (compoundN "väli" (k10 "seinä")) ; --UNCHK
lin septuple_A = mkWA (compoundA "sei" (k38 "tsenkertainen")) ; --UNCHK
lin sepulchral_A = mkWA "hauta-" ; --UNCHK
lin sepulchre_N = mkWN (compoundN "hauta" (k9A "paikka")) ; --UNCHK
lin sepulture_N = mkWN (compoundN "hauta" (k9A "paikka")) ; --UNCHK
lin sequel_N = mkWN (k1 "jatko") ; --UNCHK
lin sequela_N = mkWN (compoundN "jälki" (k5A "tauti")) ; --UNCHK
lin sequella_N = mkWN (k39 "seuraus") ; --UNCHK
lin sequence_N = mkN "jono" ;
lin sequential_A = mkWA (k38 "perättäinen") ; --UNCHK
lin sequester_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin sequestrate_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin sequestration_N = mkWN (compoundN "pakko" (k39 "luovutus")) ; --UNCHK
lin sequin_N = mkWN (k1 "hely") ; --UNCHK
lin sequoia_N = mkWN "jättiläispunapuu" ; --UNCHK
lin seraglio_N = mkWN (k6 "haaremi") ; --UNCHK
lin serape_N = mkWN (compoundN "sar" (k48A "ape")) ; --UNCHK
lin seraph_N = mkWN "serafi" ; --UNCHK
lin seraphic_A = mkWA (compoundA "enkeli" (k38 "mäinen")) ; --UNCHK
lin sere_A = mkWA (k41 "kitulias") ; --UNCHK
lin serenade_N = mkWN (k5 "serenadi") ; --UNCHK
lin serendipitous_A = mkWA (k41A "onnekas") ; --UNCHK
lin serendipity_N = mkWN (k10 "sattuma") "onnekas" ; --UNCHK
lin serene_A = mkWA (k34A "pilvetön") ; --UNCHK
lin sereness_N = mkWN (k40 "tyyneys") ; --UNCHK
lin serenity_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin serf_N = mkWN (compoundN "maa" (k10 "orja")) ; --UNCHK
lin serfdom_N = mkWN (k40 "vasallius") ; --UNCHK
lin serflike_A = mkWA (k38 "orjamainen") ; --UNCHK
lin serge_N = mkWN "sarssi" ; --UNCHK
lin sergeant_N = mkWN (compoundN "yli" (k6 "konstaapeli")) ; --UNCHK
lin sergeant_major_N = mkWN (compoundN "ylikersantti" (k9 "kala")) ; --UNCHK
lin serger_N = mkWN (k6 "saumuri") ; --UNCHK
lin serial_A = mkWA (k38 "sarjallinen") ; --UNCHK
lin serial_N = mkWN (k9 "sarja") ; --UNCHK
lin serialism_N = mkWN (k5A "musiikki") "sarjallinen" ; --UNCHK
lin serialization_N = mkWN "jatkokertomuksena" "julkaiseminen" ; --UNCHK
lin serialize_V2 = mkWV2 (k66 "julkaista") "sarjana" ; --UNCHK
lin seriatim_Adv = mkWAdv (k99 "yksittäin") ; --UNCHK
lin sericulture_N = mkWN (compoundN "silkin" (k2 "viljely")) ; --UNCHK
lin sericulturist_N = mkWN (compoundN "silkin" (k12 "viljelijä")) ; --UNCHK
lin series_N = mkWN (k9 "sarja") ;
lin serif_N = mkWN (compoundN "pääte" (k9 "viiva")) ; --UNCHK
lin serigraphy_N = mkWN (compoundN "silkki" (k1 "paino")) ; --UNCHK
lin serin_N = mkWN (compoundN "kelta" (k1A "hemppo")) ; --UNCHK
lin serine_N = mkWN "seriini" ; --UNCHK
lin seriocomedy_N = mkWN (k12 "komedia") "vakava" ; --UNCHK
lin seriocomic_A = mkWA (compoundA "vakavan" (k38 "koominen")) ; --UNCHK
lin serious_A = mkWA (k10 "vakava") ;
lin seriousness_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin serjeant_N = mkWN (compoundN "asian" (k10 "ajaja")) ; --UNCHK
lin sermon_N = mkWN "saarnaus" ; --UNCHK
lin sermonize_V = mkWV (k62 "moralisoida") ; --UNCHK
lin sermonize_V2 = mkWV2 (k62 "moralisoida") ; --UNCHK
lin serologic_A = mkWA (k38 "serologinen") ; --UNCHK
lin serologist_N = mkWN (k5 "serologi") ; --UNCHK
lin serology_N = mkWN (k12 "serologia") ; --UNCHK
lin serotine_N = mkWN (k4A "lepakko") "eurooppalainen" "ruskea" ; --UNCHK
lin serotonin_N = mkWN (k5 "serotoniini") ; --UNCHK
lin serous_A = mkWA (compoundA "hera" (k38 "inen")) ; --UNCHK
lin serow_N = mkWN (compoundN "ser" (k7 "ovi")) ; --UNCHK
lin serpent_N = mkWN (k48 "käärme") ; --UNCHK
lin serpentine_A = mkWA (k41A "mutkikas") ; --UNCHK
lin serrated_A = mkWA (compoundA "saha" (k38 "laitainen")) ; --UNCHK
lin serration_N = mkWN (k41A "hammas") ; --UNCHK
lin serratus_N = mkWN "serratus" "muscles" ; --UNCHK
lin serried_A = mkWA (k41 "tiivis") ; --UNCHK
lin serrulate_A = mkWA (compoundA "saha" (k38 "laitainen")) ; --UNCHK
lin sertularian_N = mkWN "sertularian" ; --UNCHK
lin serum_N = mkWN (k6 "seerumi") ; --UNCHK
lin serval_N = mkWN (compoundN "ser" (k5 "vaali")) ; --UNCHK
lin servantFem_N = mkN "virka" (mkN "mies" "miehen" "miestä" "miehenä" "mieheen" "miesten" "miehiä" "miehinä" "miehissä" "miehiin") ; ---ARB --mkWN (k12 "palvelija") ; --k42 produces genitive stem as "miesen"
lin servantMasc_N = mkWN (k12 "palvelija") ;
lin serve_N = mkWN (k1A "syöttö") ; --UNCHK
lin serve_V = mkV "palvella" ;
lin serve_V2 = mkV2 "palvella" partitive ;
lin server_N = mkWN (k33A "otin") ; --UNCHK
lin service_N = mkWN (k2 "palvelu") ;
lin service_V2 = mkWV2 (k54A "huoltaa") ; --UNCHK
lin serviceability_N = mkWN (k40 "käytettävyys") ; --UNCHK
lin serviceable_A = mkWA (k10 "kestävä") "kulutusta" ; --UNCHK
lin serviceman_N = mkWN (k41 "sotilas") ; --UNCHK
lin servicing_N = mkWN (k39 "astutus") ; --UNCHK
lin serviette_N = mkWN (k5A "servietti") ; --UNCHK
lin servile_A = mkA "nöyristelevä" ;
lin servility_N = mkWN (k40 "nöyryys") ; --UNCHK
lin serving_N = mkWN (k48 "haaste") ; --UNCHK
lin servitor_N = mkWN (k12 "palvelija") ; --UNCHK
lin servitude_N = mkWN (k40 "orjuus") ; --UNCHK
lin servo_N = mkWN (k1 "servo") ; --UNCHK
lin servomechanical_A = mkWA (compoundA "servo" (k38 "mekaaninen")) ; --UNCHK
lin sesame_N = mkWN (k6 "seesami") ; --UNCHK
lin sesbania_N = mkWN "sesbania" ; --UNCHK
lin sesotho_N = mkWN "basuto" ; --UNCHK
lin sesquicentennial_N = mkWN (compoundN "sataviisikymmentävuotis" (k10 "juhla")) ; --UNCHK
lin sesquipedalian_A = mkWA (k15 "vaikea") ; --UNCHK
lin sesquipedalian_N = mkWN (k9 "sana") "monitavuinen" ; --UNCHK
lin sesquipedality_N = mkWN (compoundN "pitkäsa" (k40 "naisuus")) ; --UNCHK
lin sessile_A = mkWA "varreton" ; --UNCHK
lin session_N = mkN "istunto" ;
lin sestet_N = mkWN (k5A "sekstetti") ; --UNCHK
lin set_1_N = mkN "setti" | mkN "sarja" ;
lin set_2_N = mkN "joukko" ;
lin set_N = mkWN (k9 "sarja") ;
lin set_V2 = mkV2 "asettaa" ;
lin set_about_V2 = prepV2 (lin V OP_set_V2) OP_about_Prep ; -- guess-p-verb
lin set_apart_V2 = mkWV2 (k53A "erottaa") ; --UNCHK
lin set_aside_V2 = mkWV2 (k73 "varata") ; --UNCHK
lin set_back_V = mkWV (k53A "viivästyttää") ; --UNCHK
lin set_back_V2 = mkWV2 (k53A "viivästyttää") ; --UNCHK
lin set_forth_V = mkWV (k53 "paljastaa") ; --UNCHK
lin set_forth_V2 = mkWV2 (k53 "paljastaa") ; --UNCHK
lin set_in_V = mkWV (k67 "tulla") ; --UNCHK
lin set_off_V = mkWV (k66 "laukaista") ; --UNCHK
lin set_off_V2 = mkWV2 (k66 "laukaista") ; --UNCHK
lin set_on_V2 = mkWV2 (k65 "käydä") "kimppuun" ; --UNCHK
lin set_out_V = advV (lin V OP_set_V2) OP_out_Adv ; -- guess-p-verb
lin set_out_V2 = prepV2 (lin V OP_set_V2) OP_out_Prep ; -- guess-p-verb
lin set_square_N = mkWN (compoundN "kulma" (k33 "viivain")) ; --UNCHK
lin set_to_V = advV (lin V OP_set_V2) OP_to_Adv ; -- guess-p-verb
lin set_up_V = mkWV (k56A "laittaa") "käyttökuntoon" ; --UNCHK
lin set_up_V2 = mkWV2 (k56A "laittaa") "käyttökuntoon" ; --UNCHK
lin set_upon_V2 = prepV2 (lin V OP_set_V2) OP_upon_Prep ; -- guess-p-verb
lin seta_N = mkWN (k39 "harjas") ; --UNCHK
lin setback_N = mkWN (k10 "silmä") "musta" ;
lin setscrew_N = mkWN (compoundN "kiristys" (k5 "ruuvi")) ; --UNCHK
lin setswana_N = mkWN "sechuana" ; --UNCHK
lin sett_N = mkWN (compoundN "mukula" (k7 "kivi")) ; --UNCHK
lin settee_N = mkWN (k10 "sohva") ; --UNCHK
lin setter_N = mkWN (k6 "setteri") ; --UNCHK
lin setting_N = mkN "asetelma" ;
lin settle_N = mkWN (k10 "sohva") ; --UNCHK
lin settle_V = mkWV (k52A "laskeutua") ; --f87
lin settle_V2 = mkV2 (mkV (mkV "asettaa") "aloilleen") ; --f60
lin settle_VS = mkWVS (k52A "laskeutua") ; --UNCHK
lin settle_back_V = advV OP_settle_V OP_back_Adv ; -- guess-p-verb
lin settle_down_V = mkWV (k52A "asettua") ; --UNCHK
lin settle_for_V2 = prepV2 OP_settle_V OP_for_Prep ; -- guess-p-verb
lin settle_in_V = advV OP_settle_V OP_in_Adv ; -- guess-p-verb
lin settle_on_V2 = mkWV2 (k53A "kiinnittää") "katseensa" ; --UNCHK
lin settle_up_V = advV OP_settle_V OP_up_Adv ; -- guess-p-verb
lin settlement_N = mkN "asutus" ;
lin settler_N = mkWN (compoundN "uudis" (k10 "raivaaja")) ; --UNCHK
lin settling_N = mkWN "vajoaminen" ; --UNCHK
lin settlor_N = mkWN (k10 "lahjoittaja") ; --UNCHK
lin set_up_N = mkWN (k39 "lavastus") ; --UNCHK
lin sevenfold_A = mkWA (compoundA "sei" (k38 "tsenkertainen")) ; --UNCHK
lin sevenfold_Adv = mkWAdv "seitsenkertaisesti" ; --UNCHK
lin sevenoaks_PN = foreignPN "Sevenoaks" ;
lin sever_V = mkWV (k53A "irrottaa") ; --UNCHK
lin sever_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin several_Det = mkDet Pl (mkN "usea") ;
lin several_Num = {s = \\n,c => (snoun2nounBind (mkN "usea")).s ! NCase n c ; n = Sg ; isNum = True} ; --suspect
lin severally_Adv = mkWAdv (k99 "erikseen") ;
lin severalty_N = mkWN "severalty" ; --UNCHK
lin severance_N = mkN "katkaiseminen" ; --mkWN (k39 "irrotus") ;
lin severe_A = mkWA (k10 "ankara") ;
lin severity_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin sevilla_PN = foreignPN "Sevilla" ;
lin seville_PN = foreignPN "Seville" ;
lin sew_V = L.sew_V ;
lin sew_V2 = mkWV2 (k61 "kursia") ; --UNCHK
lin sewage_N = mkWN (compoundN "lika" (k27 "vesi")) ; --UNCHK
lin sewage_farm_N = mkWN (compoundN "puhdistus" (k39 "laitos")) "jäteveden" ; --UNCHK
lin sewage_works_N = mkWN (k2 "puhdistamo") "jäteveden" ; --UNCHK
lin sewer_N = mkWN (k5A "kloaakki") ; --UNCHK
lin sewer_gas_N = mkWN (compoundN "viemäri" (k1 "kaasu")) ; --UNCHK
lin sewer_rat_N = mkWN (compoundN "viemäri" (k10A "rotta")) ; --UNCHK
lin sewerage_N = mkWN (k5A "kloaakki") ; --UNCHK
lin sewing_N = mkWN (k9A "harsinta") ; --UNCHK
lin sewing_machine_N = mkWN (compoundN "ompelu" (k48 "kone")) ; --UNCHK
lin sex_1_N = mkN "seksi" ;
lin sex_2_N = mkN "sukupuoli" "sukupuolia" ;
lin sex_V2 = mkWV2 (k53A "määrittää") "sukupuoli" ; --UNCHK
lin sex_up_V2 = mkWV2 (k62 "erotisoida") ; --UNCHK
lin sexagenarian_A = mkWA (compoundA "kuusi" (k38 "kymppinen")) ; --UNCHK
lin sexagenarian_N = mkWN "kuusikymmenvuotias" ; --UNCHK
lin sexagesimal_A = mkWA "kuusikymmenjärjestelmäpohjainen" ; --UNCHK
lin sexcapade_N = mkWN (compoundN "syrjä" (k1A "hyppy")) ; --UNCHK
lin sexism_N = mkWN (k5 "seksismi") ; --UNCHK
lin sexist_A = mkWA (k38 "seksistinen") ; --UNCHK
lin sexist_N = mkWN (k5 "sovinisti") ; --UNCHK
lin sexless_A = mkWA "seksitön" ; --UNCHK
lin sexploitation_N = mkWN (compoundN "hyväksi" (k1A "käyttö")) "seksuaalinen" ; --UNCHK
lin sext_N = mkWN (k7 "hetki") "kuudes" ; --UNCHK
lin sextant_N = mkWN (k5A "sekstantti") ; --UNCHK
lin sextet_N = mkWN (k1A "sekstetto") ; --UNCHK
lin sextette_N = mkWN (k1A "sekstetto") ; --UNCHK
lin sexton_N = mkWN (k3 "suntio") ; --UNCHK
lin sextuple_A = mkWA (compoundA "kuu" (k38 "sinkertainen")) ; --UNCHK
lin sexual_A = mkWA (k38 "seksuaalinen") ;
lin sexuality_N = mkWN (k40 "sukupuolisuus") ; --UNCHK
lin sexy_A = mkWA (k41A "seksikäs") ; --UNCHK
lin seychelles_PN = mkPN "Seychelli" ; ---- plural
lin seychellois_A = mkWA (compoundA "Seychell" (k32A "ien")) ; --UNCHK
lin seychellois_N = mkWN "seychelliläinen" ; --UNCHK
lin sforzando_N = mkWN "sforzando" ; --UNCHK
lin sgraffito_N = mkWN (compoundN "raaputus" (k14A "tekniikka")) ; --UNCHK
lin shabbiness_N = mkWN (k40 "vääryys") ; --UNCHK
lin shabby_A = mkWA (k15 "ilkeä") ; --UNCHK
lin shack_N = mkWN (k5A "mökki") ; --UNCHK
lin shack_V = mkWV (k52A "laahautua") ; --UNCHK
lin shackle_N = mkWN (k9 "ansa") ; --UNCHK
lin shackle_V2 = mkWV2 (k69 "kahlita") ; --UNCHK
lin shad_N = mkWN "shad" ; --UNCHK
lin shaddock_N = mkWN (k2 "pomelo") ; --UNCHK
lin shade_N = mkWN (k33 "varjostin") ; --UNCHK
lin shade_V = mkWV (k52A "vaihtua") "vähitellen" ; --UNCHK
lin shade_V2 = mkWV2 (k52A "vaihtua") "vähitellen" ; --UNCHK
lin shade_tree_N = mkWN (k18 "puu") "varjostava" ; --UNCHK
lin shadiness_N = mkWN (compoundN "kyseen" (k40 "alaisuus")) ; --UNCHK
lin shading_N = mkWN (k39 "varjostus") ; --UNCHK
lin shadow_N = mkWN (k1 "varjo") ; --UNCHK
lin shadow_V2 = mkWV2 (k53 "varjostaa") ; --UNCHK
lin shadow_boxing_N = mkWN (compoundN "varjo" (k2 "nyrkkeily")) ; --UNCHK
lin shadowing_N = mkWN (compoundN "seura" (k38 "aminen")) ; --UNCHK
lin shadowy_A = mkWA (k10 "hämärä") ; --UNCHK
lin shady_A = mkWA (k10 "hämärä") ; --UNCHK
lin shaft_N = mkWN (k1A "ruoto") ; --UNCHK
lin shag_N = mkWN "shag" ; --UNCHK
lin shag_V2 = mkV2 (mkV (mkV "saada") "kiinni") ; ---ARB ; naida ; jahdata
lin shagbark_N = mkWN (compoundN "valkohikk" (k48 "ori")) ; --UNCHK
lin shagginess_N = mkWN (k40 "karkeus") ; --UNCHK
lin shaggy_A = mkWA (k38 "nuhruinen") ; --UNCHK
lin shaggymane_N = mkWN "suomumustesieni" ; --UNCHK
lin shah_N = mkWN (k5 "šaahi") ;
lin shahadah_N = mkWN "shahadah" ; --UNCHK
lin shaheed_N = mkWN "shaheed" ; --UNCHK
lin shaitan_N = mkWN "shaytan" ; --UNCHK
lin shakable_A = mkWA (k10 "oleva") "järkytettävissä" ; --UNCHK
lin shake_N = mkWN (k39 "pudistus") ; --UNCHK
lin shake_V = mkV "vavista" ;
lin shake_V2 = mkV2 "ravistaa" ;
lin shake_down_V2 = prepV2 OP_shake_V OP_down_Prep ; -- guess-p-verb
lin shake_off_V2 = mkWV2 (k52A "hankkiutua") "eroon" ; --UNCHK
lin shake_out_V2 = prepV2 OP_shake_V OP_out_Prep ; -- guess-p-verb
lin shake_up_V2 = mkWV2 (k61 "pöyhiä") ; --UNCHK
lin shakedown_A = mkWA (compoundA "koe" (k1 "ajo")) ; --UNCHK
lin shakedown_N = mkWN (k39 "kiristys") ; --UNCHK
lin shakeout_N = mkWN (compoundN "pörssi" (k5 "kriisi")) ; --UNCHK
lin shaker_N = mkWN (k10 "sekoittaja") ; --UNCHK
lin shakespearian_A = mkWA "Shakespearen" ; --UNCHK
lin shakiness_N = mkWN (k40 "horjuvuus") ; --UNCHK
lin shaking_N = mkWN (k39 "täristys") ; --UNCHK
lin shaky_A = mkWA (k10 "arveluttava") ; --UNCHK
lin shale_N = mkWN (compoundN "savi" (k7 "kivi")) ; --UNCHK
lin shale_oil_N = mkWN (compoundN "kiviliuske" (k1 "öljy")) ; --UNCHK
lin shall_VV = mkVV (caseV genitive (mkV "pitää")) ;
lin shallot_N = mkWN (compoundN "ryväs" (k6 "sipuli")) ; --UNCHK
lin shallow_A = mkWA (k10 "matala") ; --UNCHK
lin shallow_N = mkWN (k4A "matalikko") ; --UNCHK
lin shallow_V = mkWV (k52A "mataloitua") ; --UNCHK
lin shallowness_N = mkWN (k40 "pintapuolisuus") ; --UNCHK
lin shallu_N = mkWN (k10 "durra") ; --UNCHK
lin sham_A = mkWA (k38 "valheellinen") ; --UNCHK
lin sham_N = mkWN (k39 "petos") ; --UNCHK
lin sham_V = mkWV (k53A "esittää") ; --UNCHK
lin sham_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin shaman_N = mkWN (k5 "šamaani") ; --UNCHK
lin shamanism_N = mkWN (k5 "šamanismi") "Aasian" ; --UNCHK
lin shamanist_A = mkWA (k38 "šamanistinen") ; --UNCHK
lin shamble_N = mkWN "laahaaminen" ; --UNCHK
lin shamble_V = mkWV (k53 "raahustaa") ; --UNCHK
lin shambles_N = mkWN (k2 "teurastamo") ; --UNCHK
lin shambolic_A = mkWA (k38 "sekasortoinen") ; --UNCHK
lin shame_N = mkN "häpeä" ; --mkWN (k10 "ikävä") ;
lin shame_V2 = mkWV2 (k56A "saattaa") "häpeään" ; --UNCHK
lin shamefaced_A = mkWA (k15 "surkea") ; --UNCHK
lin shamefacedness_N = mkWN (k40 "nolous") ; --UNCHK
lin shameful_A = mkWA (k34A "kunniaton") ; --UNCHK
lin shamefulness_N = mkWN (compoundN "häpeäll" (k40 "isyys")) ; --UNCHK
lin shameless_A = mkWA (k34A "ujostelematon") ; --UNCHK
lin shamelessness_N = mkWN (k40 "röyhkeys") ; --UNCHK
lin shammy_N = mkWN (k13 "säämiskä") ; --UNCHK
lin shampoo_N = mkWN (k1 "pesu") "hiusten" ; --UNCHK
lin shamrock_N = mkWN (k13 "apila") "keltakukkainen" ; --UNCHK
lin shandy_N = mkWN "shandy" ; --UNCHK
lin shandygaff_N = mkWN "shandy" ; --UNCHK
lin shanghai_PN = foreignPN "Shanghai" ;
lin shanghai_V2 = mkWV2 (k73 "värvätä") "väkisin" ; --UNCHK
lin shanghaier_N = mkWN (compoundN "sei" (k5 "sari")) ; --UNCHK
lin shank_N = mkWN "soketti" ; --UNCHK
lin shanklin_PN = foreignPN "Shanklin" ;
lin shanny_N = mkWN (compoundN "lima" (k9 "kala")) ; --UNCHK
lin shantung_N = mkWN (k50 "raakasilkki") ; --UNCHK
lin shanty_N = mkWN (k5A "mökki") ; --UNCHK
lin shantytown_N = mkWN (compoundN "hökkeli" (k5A "kaupunki")) ; --UNCHK
lin shape_N = mkWN (k1A "muoto") ; --UNCHK
lin shape_V = mkV "muovautua" ;
lin shape_V2 = mkWV2 (k73 "muovata") partitive ;
lin shape_VV = mkWVV (k73 "muovata") ; --UNCHK
lin shape_up_V = mkWV (k52A "kehittyä") ; --UNCHK
lin shapeless_A = mkWA (k34A "muodoton") ; --UNCHK
lin shapelessness_N = mkWN (k40 "muodottomuus") ; --UNCHK
lin shapely_A = mkWA (k41A "kurvikas") ; --UNCHK
lin shaper_N = mkWN (compoundN "jyrsin" (k48 "kone")) ; --UNCHK
lin shaping_N = mkWN (k2 "muotoilu") ; --UNCHK
lin shard_N = mkWN (k38 "osanen") ; --UNCHK
lin share_N = mkN "osuus" ;
lin share_V = mkWV (k56A "jakaa") ;
lin share_V2 = mkWV2 (k56A "jakaa") ;
lin share_out_V = advV OP_share_V OP_out_Adv ; -- guess-p-verb
lin sharecropper_N = mkWN (compoundN "maan" (k10 "vuokraaja")) ; --UNCHK
lin shared_A = mkA "jaettu" ;
lin shareholder_N = mkN "osakkeenomistaja" ;
lin shareholding_N = mkWN (compoundN "osakkeen" (k39 "omistus")) ;
lin shareware_N = mkWN (compoundN "julkis" (k10 "ohjelma")) ; --UNCHK
lin shariah_N = mkWN (kH1 "laki") "islamin" ; --UNCHK
lin sharing_N = mkWN "jakaminen" ; --UNCHK
lin shark_N = mkWN (k18 "hai") ; --UNCHK
lin sharkskin_N = mkWN (compoundN "hain" (k9 "nahka")) ; --UNCHK
lin sharksucker_N = mkWN (compoundN "isorem" (k10 "ora")) ; --UNCHK
lin sharon_PN = foreignPN "Sharon" ;
lin sharp_A = L.sharp_A ;
lin sharp_Adv = mkWAdv (k99 "terävästi") ; --UNCHK
lin sharp_N = mkWN (compoundN "silmä" (k9 "neula")) ; --UNCHK
lin sharp_witted_A = mkA (mkN "terävä-" (mkN "älyinen")) ;
lin sharpen_V = mkWV (k54A "tarkentaa") ; --UNCHK
lin sharpen_V2 = mkWV2 (k54A "tarkentaa") ; --UNCHK
lin sharpener_N = mkWN (k33A "teroitin") ; --UNCHK
lin sharper_N = mkWN (k6 "huijari") ; --UNCHK
lin sharpie_N = mkWN "sharpie" ; --UNCHK
lin sharpness_N = mkWN (k40 "purevuus") ; --UNCHK
lin sharpshooter_N = mkWN "sharpshooter" ; --UNCHK
lin shatter_V = mkWV (k52A "särkyä") ; --UNCHK
lin shatter_V2 = mkV2 "särkeä" ;
lin shatterproof_A = mkWA (compoundA "sirpaleen" (k10 "kestävä")) ; --UNCHK
lin shave_N = mkWN (compoundN "parran" (k1 "ajo")) ; --UNCHK
lin shave_V = mkWV (k67 "ajella") ; --UNCHK
lin shave_V2 = mkWV2 (k67 "ajella") ; --UNCHK
lin shaven_A = mkWA (compoundA "parturo" (k1A "itu")) ; --UNCHK
lin shaver_N = mkWN (compoundN "parta" (k48 "kone")) ; --UNCHK
lin shavian_A = mkWA "Shavian" ; --UNCHK
lin shavian_N = mkWN "Shavian" ; --UNCHK
lin shaving_brush_N = mkWN (compoundN "parta" (k5A "suti")) ; --UNCHK
lin shawl_N = mkWN (k5 "saali") ; --UNCHK
lin shawm_N = mkWN "skalmeija" ; --UNCHK
lin she_Pron = S.she_Pron ;
lin sheaf_N = mkWN (k1A "kimppu") ; --UNCHK
lin shear_N = mkWN (k6 "leikkuri") ; --UNCHK
lin shear_V2 = mkWV2 (k52A "murtua") ; --UNCHK
lin shearer_N = mkWN "keritsijä" ; --UNCHK
lin shearing_N = mkWN (compoundN "lei" (k38 "kkaaminen")) ; --UNCHK
lin shearwater_N = mkWN "meriliitäjä" ; --UNCHK
lin sheath_N = mkWN (k5A "leninki") "vartalonmyötäinen" ; --UNCHK
lin sheath_knife_N = mkWN (compoundN "tuppi" (k1A "puukko")) ; --UNCHK
lin sheathe_V2 = mkWV2 (k53A "upottaa") ; --UNCHK
lin sheathing_N = mkWN (k48 "päällyste") ; --UNCHK
lin shebang_N = mkWN (k10 "höskä") "koko" ; --UNCHK
lin shebeen_N = mkWN (compoundN "sala" (k14A "kapakka")) ; --UNCHK
lin shed_N = mkWN (k9 "vaja") ; --UNCHK
lin shed_V2 = mkWV2 (k64 "luoda") "nahkansa" ; --UNCHK
lin shedder_N = mkWN (k10 "kaataja") ; --UNCHK
lin shedding_N = mkWN (k2 "hilseily") ; --UNCHK
lin sheen_N = mkWN (k1A "hohto") ; --UNCHK
lin sheep_N = L.sheep_N ;
lin sheepdog_N = mkWN (compoundN "paimen" (k10 "koira")) ; --UNCHK
lin sheepfold_N = mkWN (k12 "karsina") ; --UNCHK
lin sheepherder_N = mkWN (k32 "paimen") ; --UNCHK
lin sheepish_A = mkWA (k10 "oleva") "hämillään" ; --UNCHK
lin sheepishness_N = mkWN (k40 "nolous") ; --UNCHK
lin sheeplike_A = mkWA (k1 "ujo") ; --UNCHK
lin sheepman_N = mkWN (k32 "paimen") ; --UNCHK
lin sheeprun_N = mkWN (compoundN "lammas" (k33A "laidun")) ; --UNCHK
lin sheepshank_N = mkWN (compoundN "lyhennys" (k1 "solmu")) ; --UNCHK
lin sheepshead_N = mkWN (compoundN "probatoceph" (k39 "alus")) "Archosargus" ; --UNCHK
lin sheepshearing_N = mkWN "keritseminen" ; --UNCHK
lin sheepskin_N = mkWN (k5 "diplomi") ; --UNCHK
lin sheepwalk_N = mkWN (compoundN "lammas" (k33A "laidun")) ; --UNCHK
lin sheer_A = mkWA (k9A "silkka") ; --UNCHK
lin sheer_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin sheer_V = mkWV (k67A "mutkitella") ; --UNCHK
lin sheerness_PN = foreignPN "Sheerness" ;
lin sheet_N = mkN "arkki" ;
lin sheet_anchor_N = mkWN (compoundN "hätä" (k6 "ankkuri")) ; --UNCHK
lin sheeting_N = mkWN (k41A "lakanakangas") ; --UNCHK
lin sheetlike_A = mkWA (compoundA "lakana" (k38 "mainen")) ; --UNCHK
lin sheffield_PN = foreignPN "Sheffield" ;
lin shegetz_N = mkWN "shegetz" ; --UNCHK
lin sheik_N = mkWN (k12 "hienostelija") ; --UNCHK
lin sheika_N = mkWN "sheikha" ; --UNCHK
lin sheikdom_N = mkWN (compoundN "šeikki" (k10A "kunta")) ; --UNCHK
lin sheikh_N = mkWN (k4A "päällikkö") "arabi" ; --UNCHK
lin sheikhdom_N = mkWN (compoundN "šeikki" (k10A "kunta")) ; --UNCHK
lin shekel_N = mkWN (k6 "sekeli") ; --UNCHK
lin sheldrake_N = mkWN "sheldrake" ; --UNCHK
lin shelduck_N = mkWN (compoundN "ristisorsa" (k41 "naaras")) ; --UNCHK
lin shelf_N = mkWN (k1 "hylly") ;
lin shelfful_N = mkWN (k38 "hyllyllinen") ; --UNCHK
lin shelflike_A = mkWA (compoundA "hylly" (k38 "mäinen")) ; --UNCHK
lin shell_N = mkN "kuori" ;
lin shell_V = mkWV (k73A "virrata") ; --UNCHK
lin shell_V2 = mkWV2 (k73A "virrata") ; --UNCHK
lin shell_out_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin shell_shock_N = mkWN (compoundN "sota" (k5 "psykoosi")) ; --UNCHK
lin shellac_N = mkWN (k14A "sellakka") ; --UNCHK
lin sheller_N = mkWN "kuorija" ; --UNCHK
lin shellfire_N = mkWN (compoundN "kranaatti" (k23 "tuli")) ; --UNCHK
lin shellfish_N = mkWN (k38 "nilviäinen") ; --UNCHK
lin shellflower_N = mkWN (compoundN "konnan" (k5A "yrtti")) ; --UNCHK
lin shellproof_A = mkWA (compoundA "pommin" (k10 "kestävä")) ; --UNCHK
lin shelter_N = mkWN (k10 "turva") ; --UNCHK
lin shelter_V = mkWV (compoundV "vero" (k67A "suunnitella")) ; --UNCHK
lin shelter_V2 = mkWV2 (compoundV "vero" (k67A "suunnitella")) ; --UNCHK
lin shelve_V2 = mkV2 "hyllyttää" ;
lin shelver_N = mkWN (compoundN "hyllyn" (k10 "täyttäjä")) ; --UNCHK
lin shepherd_N = mkWN (k32 "paimen") ; --UNCHK
lin shepherd_V2 = mkWV2 (k54A "paimentaa") ; --UNCHK
lin shepherdess_N = mkWN (k32 "paimen") ; --UNCHK
lin shepshed_PN = foreignPN "Shepshed" ;
lin sheraton_N = mkWN "Sheraton" ; --UNCHK
lin sherbert_N = mkWN (k5A "sorbetti") ; --UNCHK
lin sherbet_N = mkWN (k5A "sorbetti") ; --UNCHK
lin sheriff_N = mkWN (k5 "seriffi") ; --UNCHK
lin sheringham_PN = foreignPN "Sheringham" ;
lin sherry_N = mkWN (k1 "sherry") ; --UNCHK
lin shetland_PN = foreignPN "Shetland" ;
lin shevington_PN = foreignPN "Shevington" ;
lin shew_V = mkWV (k53 "vahvistaa") ; --UNCHK
lin shew_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin shibboleth_N = mkWN "shibboleth" ; --UNCHK
lin shield_N = mkN "kilpi" ;
lin shield_V2 = mkV2 "suojata" partitive ; --mkWV2 (k73A "virrata") ;
lin shielding_N = mkWN (k2 "suojelu") ; --UNCHK
lin shift_N = mkWN (k39 "muutos") ;
lin shift_V = mkWV (k56A "vaihtaa") ; --UNCHK
lin shift_V2 = mkWV2 (k56A "vaihtaa") ; --UNCHK
lin shiftiness_N = mkWN (compoundN "vaihtu" (k40 "vaisuus")) ; --UNCHK
lin shiftless_A = mkWA (k1A "veltto") ; --UNCHK
lin shiftlessness_N = mkWN (k40 "velttous") ; --UNCHK
lin shifty_A = mkWA (k10 "liikkuva") ; --UNCHK
lin shigella_N = mkWN "shigella" ; --UNCHK
lin shigellosis_N = mkWN "bacillary" "dysentery" ; --UNCHK
lin shiitake_N = mkWN (k48A "siitake") ; --UNCHK
lin shiksa_N = mkWN "shikse" ; --UNCHK
lin shildon_PN = foreignPN "Shildon" ;
lin shill_N = mkWN (k6 "apuri") "maksettu" ; --UNCHK
lin shillelagh_N = mkWN (k10 "nuija") ; --UNCHK
lin shilling_N = mkWN (k5A "šillinki") ; --UNCHK
lin shillyshally_N = mkWN (k39 "lykkäys") ; --UNCHK
lin shillyshally_V = mkWV (k73A "lykätä") ; --UNCHK
lin shim_N = mkWN (k9 "kiila") ; --UNCHK
lin shimmer_N = mkWN (k2 "leikittely") ; --UNCHK
lin shimmer_V = mkWV (k54A "kimmeltää") ; --UNCHK
lin shimmery_A = mkWA "kimmeltävä" ; --UNCHK
lin shimmy_N = mkWN "shimmy" ; --UNCHK
lin shin_N = mkWN (k26 "sääri") ; --UNCHK
lin shin_V = mkWV (k74 "könytä") ; --UNCHK
lin shinbone_N = mkWN (compoundN "sääri" (k18 "luu")) ; --UNCHK
lin shine_N = mkWN (k48 "loiste") ; --UNCHK
lin shine_V = mkV (lin VK {s = c53 "loistaa"}) ;
lin shine_V2 = mkWV2 (k53A "kiillottaa") ; --UNCHK
lin shiner_N = mkWN (compoundN "särki" (k9 "kala")) ; --UNCHK
lin shingle_N = mkWN (k7A "kilpi") ; --UNCHK
lin shingle_V2 = mkWV2 (k56A "kattaa") "päreillä" ; --UNCHK
lin shingler_N = mkWN (k12 "tekijä") "pärekaton" ; --UNCHK
lin shingles_N = mkWN (compoundN "vyö" (k1 "ruusu")) ; --UNCHK
lin shingling_N = mkWN (k1 "pano") "päreiden" ; --UNCHK
lin shininess_N = mkWN (k1A "hohto") ; --UNCHK
lin shining_N = mkWN (k39 "kiillotus") ; --UNCHK
lin shinny_N = mkWN "shinney" ; --UNCHK
lin shinplaster_N = mkWN (compoundN "paperi" (k9 "raha")) "arvoton" ; --UNCHK
lin shiny_A = mkWA (k10 "kiiltävä") ; --UNCHK
lin ship's_chandler_N = mkWN (compoundN "laivan" (k10 "selvittäjä")) ; --UNCHK
lin ship_N = L.ship_N ;
lin ship_V = mkWV (k53A "toimittaa") ; --UNCHK
lin ship_V2 = mkWV2 (k53A "toimittaa") ;
lin ship_canal_N = mkWN (compoundN "laiva" (k5A "reitti")) ; --UNCHK
lin shipboard_A = mkWA "meri-" ; --UNCHK
lin shipbuilder_N = mkWN (compoundN "laivan" (k39 "rakennus")) ; --UNCHK
lin shipbuilding_N = mkWN (compoundN "laivan" (k39 "rakennus")) ;
lin shipload_N = mkWN (compoundN "vaunu" (k5 "lasti")) ; --UNCHK
lin shipmate_N = mkWN (compoundN "merimies" (k6 "toveri")) ; --UNCHK
lin shipment_N = mkWN (k39 "perilletoimitus") ;
lin shipowner_N = mkWN (compoundN "laivan" (k10 "varustaja")) ; --UNCHK
lin shipper_N = mkWN (k10 "rahtaaja") ; --UNCHK
lin shipping_N = mkN (lin NK {s = d39 "kuljetus"}) ;
lin shipping_agent_N = mkWN (compoundN "laivan" (k10 "selvittäjä")) ; --UNCHK
lin shipping_office_N = mkWN (k6 "konttori") "varustamon" ; --UNCHK
lin shipshape_A = mkWA (k5 "siisti") ; --UNCHK
lin shipside_N = mkWN (kH1 "laituri") "laivanpuoleinen" ; --UNCHK
lin shipway_N = mkWN (compoundN "laiva" (k5A "reitti")) ; --UNCHK
lin shipworm_N = mkWN (compoundN "laiva" (k1A "mato")) ; --UNCHK
lin shipwreck_N = mkWN (k1A "hylky") ; --UNCHK
lin shipwreck_V = mkWV (k74 "tuhota") ; --UNCHK
lin shipwright_N = mkWN (compoundN "laivan" (k10 "rakentaja")) ; --UNCHK
lin shipyard_N = mkWN (k14A "telakka") ; --UNCHK
lin shire_N = mkWN (compoundN "shire" (k38 "hevonen")) ; --UNCHK
lin shirebrook_PN = foreignPN "Shirebrook" ;
lin shiremoor_PN = foreignPN "Shiremoor" ;
lin shirk_V = mkWV (k53A "välttää") ; --UNCHK
lin shirk_V2 = mkWV2 (k53A "välttää") ; --UNCHK
lin shirker_N = mkWN (k6 "pinnari") ; --UNCHK
lin shirking_N = mkWN (k39 "lintsaus") ; --UNCHK
lin shirley_PN = foreignPN "Shirley" ;
lin shirring_N = mkWN (compoundN "pai" (k38 "staminen")) ; --UNCHK
lin shirt_N = L.shirt_N ;
lin shirtdress_N = mkWN (compoundN "paita" (k1A "puku")) ; --UNCHK
lin shirt_front_N = mkWN (compoundN "irto" (k39 "etumus")) ; --UNCHK
lin shirting_N = mkWN (k41A "paitakangas") ; --UNCHK
lin shirtmaker_N = mkWN (compoundN "paidan" (k10 "valmistaja")) ; --UNCHK
lin shirtsleeve_N = mkWN (compoundN "paidan" (k9 "hiha")) ; --UNCHK
lin shirttail_N = mkWN (compoundN "paidan" (k9 "helma")) ; --UNCHK
lin shirtwaist_N = mkWN (compoundN "paita" (k2 "pusero")) ; --UNCHK
lin shirtwaister_N = mkWN (compoundN "paita" (k2 "pusero")) ; --UNCHK
lin shirty_A = mkWA (k38 "kiukkuinen") ; --UNCHK
lin shish_kebab_N = mkWN (k5 "kebab") ; --UNCHK
lin shit_N = mkN "paska" ;
lin shit_V = mkV "paskantaa" ;
lin shittah_N = mkWN (compoundN "akaasia" (k18 "puu")) ; --UNCHK
lin shittimwood_N = mkWN (compoundN "akaasia" (k18 "puu")) ; --UNCHK
lin shiv_N = mkWN (k1A "puukko") ; --UNCHK
lin shiva_N = mkWN "Shiva" ; --UNCHK
lin shivaree_N = mkWN (k5 "charivari") ; --UNCHK
lin shiver_N = mkWN (k12 "hytinä") ; --UNCHK
lin shiver_V = mkWV (k66A "vavista") ; --UNCHK
lin shivery_A = mkWA (k15 "karmea") ; --UNCHK
lin shmegegge_N = mkWN "schmegegge" ; --UNCHK
lin shmooze_N = mkWN (k2 "rupattelu") ; --UNCHK
lin shoal_N = mkWN (kH1 "parvi") ; --UNCHK
lin shoal_V = mkWV (k52A "mataloitua") ; --UNCHK
lin shock_N = mkWN (compoundN "sähkö" (k1 "isku")) ; --UNCHK
lin shock_V2 = mkV2 "järkyttää" partitive ;
lin shockable_A = mkWA (k34A "suvaitsematon") ; --UNCHK
lin shocked_A = mkA "järkyttynyt" ;
lin shocker_N = mkWN (compoundN "sensaatio" (k1A "juttu")) ; --UNCHK
lin shocking_A = mkWA (k15 "röyhkeä") ; --UNCHK
lin shod_A = mkWA (compoundA "ken" (k1 "gitetty")) ; --UNCHK
lin shoddiness_N = mkWN (k40 "hataruus") ; --UNCHK
lin shoddy_A = mkWA (k38 "petollinen") ; --UNCHK
lin shoddy_N = mkWN (k9 "lumppuvilla") ; --UNCHK
lin shoe_N = L.shoe_N ;
lin shoe_V2 = mkWV2 (k53A "kengittää") ; --UNCHK
lin shoe_leather_N = mkWN (compoundN "kenkä" (k9 "nahka")) ; --UNCHK
lin shoebill_N = mkWN (compoundN "kenkä" (k10A "nokka")) ; --UNCHK
lin shoeblack_N = mkWN (k10 "kengänkiillottaja") ; --UNCHK
lin shoebox_N = mkWN (compoundN "kenkä" (k4A "laatikko")) ; --UNCHK
lin shoeful_N = mkWN (compoundN "kengän" (k27 "täysi")) ; --UNCHK
lin shoehorn_N = mkWN (compoundN "kenkä" (k14A "lusikka")) ; --UNCHK
lin shoehorn_V2 = mkWV2 (k58A "tunkea") "kenkälusikalla" ; --UNCHK
lin shoelace_N = mkWN (compoundN "kengän" (k9 "nauha")) ; --UNCHK
lin shoemaker_N = mkWN (k6 "suutari") ;
lin shoemaking_N = mkWN (k39 "paikkaus") "kenkien" ; --UNCHK
lin shoeshine_N = mkWN (k39 "kiillotus") "kenkien" ; --UNCHK
lin shoestring_N = mkWN (compoundN "kengän" (k9 "nauha")) ; --UNCHK
lin shoetree_N = mkWN (k5 "lesti") ; --UNCHK
lin shofar_N = mkWN "šofar" ; --UNCHK
lin shogi_N = mkWN "shōgi" ; --UNCHK
lin shogun_N = mkWN "shōgun" ; --UNCHK
lin shoji_N = mkWN "shoji" ; --UNCHK
lin shoo_V = mkWV (k55A "häätää") ; --UNCHK
lin shoo_V2 = mkWV2 (k55A "häätää") ; --UNCHK
lin shoofly_N = mkWN (compoundN "keinu" (k5 "tuoli")) ; --UNCHK
lin shoot_N = mkWN (k39 "metsästys") ; --UNCHK
lin shoot_V = mkWV (k53 "pistää") ; --UNCHK
lin shoot_V2 = mkV2 "ampua" ; --mkWV2 (k53 "pistää") ;
lin shoot_away_V = advV OP_shoot_V OP_away_Adv ; -- guess-p-verb
lin shoot_back_V = advV OP_shoot_V OP_back_Adv ; -- guess-p-verb
lin shoot_for_V2 = mkWV2 (k73A "tähdätä") "jhk" ; --UNCHK
lin shoot_off_V = advV OP_shoot_V OP_off_Adv ; -- guess-p-verb
lin shoot_out_V = advV OP_shoot_V OP_out_Adv ; -- guess-p-verb
lin shoot_up_V = mkWV (k66 "nousta") "huimasti" ; --UNCHK
lin shoot_up_V2 = mkWV2 (k66 "nousta") "huimasti" ; --UNCHK
lin shooter_N = mkWN "shooter" ; --UNCHK
lin shooting_N = mkWN (k39 "laukaus") ; --UNCHK
lin shooting_box_N = mkWN (compoundN "metsästys" (k9 "maja")) ; --UNCHK
lin shooting_brake_N = mkWN (compoundN "farmari" (k1 "auto")) ; --UNCHK
lin shooting_gallery_N = mkWN (compoundN "ampuma" (k9A "rata")) ; --UNCHK
lin shooting_range_N = mkWN (compoundN "ampuma" (k9A "rata")) ; --UNCHK
lin shooting_stick_N = mkWN (k5 "tuoli") "ohjaajan" ; --UNCHK
lin shop_N = L.shop_N ;
lin shop_V = mkV (mkV "käydä") "ostoksilla" ; --mkWV (k62 "vasikoida") ;
lin shop_assistant_N = mkWN (compoundN "myymälä" (k38 "apulainen")) ; --UNCHK
lin shop_bell_N = mkWN (k1 "kello") "kaupan" ; --UNCHK
lin shop_boy_N = mkWN (k10 "myyjä") ; --UNCHK
lin shop_girl_N = mkWN (k32A "myyjätär") ; --UNCHK
lin shop_steward_N = mkWN (compoundN "luottamus" (k2 "henkilö")) ; --UNCHK
lin shopaholic_N = mkWN "himoshoppailija" ; --UNCHK
lin shop_front_N = mkWN (compoundN "julki" (k1 "sivu")) "kaupan" ; --UNCHK
lin shopkeeper_N = mkWN (k41 "kauppias") ; --UNCHK
lin shoplift_V = mkWV (k53 "näpistää") ; --UNCHK
lin shoplift_V2 = mkWV2 (k53 "näpistää") ; --UNCHK
lin shoplifter_N = mkWN (compoundN "myymälä" (k41A "varas")) ; --UNCHK
lin shoplifting_N = mkWN (k39 "näpistys") ; --UNCHK
lin shopperFem_N = mkWN (k12 "kävijä") "ostoksilla" ; --UNCHK
lin shopperMasc_N = mkWN (k12 "kävijä") "ostoksilla" ; --UNCHK
lin shopping_N = mkWN "ostaminen" ;
lin shopsoiled_A = mkWA (compoundA "lika" (k47 "antunut")) "varastossa" ; --UNCHK
lin shopwalker_N = mkWN (compoundN "myymälä" (k10A "emäntä")) ; --UNCHK
lin shopwindow_N = mkWN (k12 "ikkuna") "kaupan" ; --UNCHK
lin shopworn_A = mkWA (k38 "tavallinen") ; --UNCHK
lin shore_N = mkWN (k10A "pönkkä") ; --UNCHK
lin shore_V2 = mkWV2 (k53 "reunustaa") partitive ;
lin shore_up_V2 = mkWV2 (k53A "pönkittää") ; --UNCHK
lin shorebird_N = mkWN (compoundN "ranta" (k1A "lintu")) ; --UNCHK
lin shoreline_N = mkWN (compoundN "ranta" (k9 "viiva")) ; --UNCHK
lin shoring_N = mkWN (compoundN "tuke" (k38 "minen")) ; --UNCHK
lin shorn_V2 = mkV2 "murtaa" ; ---ARB ; leikata
lin short_A = L.short_A ;
lin short_Adv = mkWAdv (k99 "äkillisesti") ; --UNCHK
lin short_N = mkN "lyhyt" "lyhyitä" ; ----TODO "one who operates on the short side of the market"
lin short_V = mkWV (k67 "mennä") "oikosulkuun" ; --UNCHK
lin short_V2 = mkWV2 (k67 "mennä") "oikosulkuun" ; --UNCHK
lin short_circuit_N = mkWN (compoundN "oiko" (k1A "sulku")) ; --UNCHK
lin short_circuit_V = mkV (mkV "mennä") "oikosulkuun" ;
lin short_dated_A = mkA (mkN "lyhyt" (mkN "kestoinen")) ;
lin short_lived_A = mkA "lyhytikäinen" ;
lin short_range_A = mkA "lyhytkestoinen" ; ---?? different POS
lin short_term_A = mkA "lyhytaikainen" ;
lin shortage_N = mkWN (k48 "vaje") ;
lin shortbread_N = mkWN (k5 "murokeksi") ; --UNCHK
lin shortcake_N = mkWN (compoundN "muro" (k39 "leivos")) ; --UNCHK
lin shortcoming_N = mkWN (kH1 "vika") ; --UNCHK
lin shortcut_N = mkWN (k2 "oikaisu") ; --UNCHK
lin shorten_V = mkWV (k54A "lyhentää") ; --UNCHK
lin shorten_V2 = mkWV2 (k54A "lyhentää") ; --UNCHK
lin shortener_N = mkWN "lyhentäjä" ; --UNCHK
lin shortening_N = mkWN (k39 "lyhennys") ; --UNCHK
lin shortfall_N = mkWN (k48 "vaje") ;
lin shortgrass_N = mkWN (k1 "ruoho") ; --UNCHK
lin shorthand_A = mkWA (compoundA "pika" (k1 "kirjoitettu")) ; --UNCHK
lin shorthand_N = mkWN (compoundN "pika" (k39 "kirjoitus")) ; --UNCHK
lin shorthorn_N = mkWN (compoundN "lyhytsarvi" (k1A "rotu")) ; --UNCHK
lin shortia_N = mkWN "shortia" ; --UNCHK
lin shortish_A = mkWA "lyhyehkö" ; --UNCHK
lin shortlist_N = mkWN (k2 "luettelo") "suppeampi" ; --UNCHK
lin shortlist_V2 = mkWV2 (k69 "valita") "listalle" ; --UNCHK
lin shortness_N = mkWN (k40 "karkeus") ; --UNCHK
lin shot_N = mkN "laukaus" ; ---ARB mkWN (k1A "lähtö") ;
lin shot_put_N = mkWN (compoundN "kuulan" (k1A "työntö")) ; --UNCHK
lin shot_tower_N = mkWN (compoundN "haulinvalu" (k5 "torni")) ; --UNCHK
lin shotgun_N = mkWN (k4A "haulikko") ; --UNCHK
lin shotton_PN = foreignPN "Shotton" ;
lin shotts_PN = foreignPN "Shotts" ;
lin should_VV = mkVV (caseV genitive (mkV "pitää")) ; ----
lin shoulder_N = mkN "olka" (mkN "pää") | mkN "hartia" | mkWN (k49A "piennar") ; ---- split
lin shoulder_V2 = mkV2 (mkV (mkV "ottaa") "harteille") ;
lin shoulder_blade_N = mkWN (compoundN "lapa" (k18 "luu")) ; --UNCHK
lin shoulder_flash_N = mkWN (compoundN "olka" (k5A "merkki")) ; --UNCHK
lin shoulder_strap_N = mkWN (k5 "remmi") ; --UNCHK
lin shout_N = mkWN (k2 "karjaisu") ; --UNCHK
lin shout_V = mkWV (k73A "loukata") ; --UNCHK
lin shout_V2 = mkWV2 (k73A "loukata") ; --UNCHK
lin shout_down_V2 = mkWV2 (k54A "vaientaa") ; --UNCHK
lin shout_out_V2 = mkWV2 (k52A "kirkua") ; --UNCHK
lin shouting_N = mkN "huuto" ;
lin shove_N = mkWN (k2 "tönäisy") ; --UNCHK
lin shove_V = mkWV (k61 "töniä") ; --UNCHK
lin shove_V2 = mkWV2 (k61 "töniä") ; --UNCHK
lin shovel_N = mkWN (k6 "kaivuri") ; --UNCHK
lin shovel_V2 = mkWV2 (k62 "lapioida") ; --UNCHK
lin shovel_board_N = mkWN (compoundN "shove-ha'" (k1 "penny")) ; --UNCHK
lin shoveler_N = mkWN (compoundN "lapa" (k10 "sorsa")) ; --UNCHK
lin shovelful_N = mkWN (compoundN "lapio" (k38 "llinen")) ; --UNCHK
lin shovelhead_N = mkWN (compoundN "vasara" (k18 "hai")) ; --UNCHK
lin show_N = mkN "näytös" ;
lin show_V = mkV "näyttää" ;
lin show_V2 = mkV2 "näyttää" ;
lin show_VQ = mkVQ (mkV "vahvistaa") ; ---- subcat
lin show_VS = mkVS (mkV "osoittaa") ;
lin show_around_V2 = prepV2 OP_show_V OP_around_Prep ; -- guess-p-verb
lin show_business_N = mkWN (compoundN "viihde" (k9 "ala")) ; --UNCHK
lin show_in_V2 = prepV2 OP_show_V OP_in_Prep ; -- guess-p-verb
lin show_off_V = mkWV (k67 "ylpeillä") ; --UNCHK
lin show_off_V2 = mkWV2 (k67 "ylpeillä") ; --UNCHK
lin show_out_V2 = prepV2 OP_show_V OP_out_Prep ; -- guess-p-verb
lin show_over_V3 = variants {} ; -- guess-p-verb
lin show_round_V2 = prepV2 OP_show_V OP_round_Prep ; -- guess-p-verb
lin show_through_V = advV OP_show_V OP_through_Adv ; -- guess-p-verb
lin show_up_V = mkWV (k52A "näyttäytyä") ; --UNCHK
lin show_up_V2 = mkWV2 (k52A "näyttäytyä") ; --UNCHK
lin show_window_N = mkWN (k12 "ikkuna") "kaupan" ; --UNCHK
lin showboat_N = mkWN (compoundN "teatteri" (k9 "laiva")) ; --UNCHK
lin showcase_N = mkWN (k4A "lasikko") ; --UNCHK
lin showdown_N = mkWN (k9 "kiista") ; --UNCHK
lin shower_N = mkWN (k1 "suihku") ;
lin shower_V = mkWV (k65 "käydä") "suihkussa" ; --UNCHK
lin shower_V2 = mkWV2 (k65 "käydä") "suihkussa" ; --UNCHK
lin shower_bath_N = mkWN (k1 "suihku") ; --UNCHK
lin showerhead_N = mkWN (k1 "suihku") ; --UNCHK
lin showery_A = mkWA (k38 "sateinen") ; --UNCHK
lin showgirl_N = mkWN (compoundN "tanssi" (k1A "tyttö")) ; --UNCHK
lin showiness_N = mkWN (k40 "koristeellisuus") ; --UNCHK
lin showing_N = mkWN (k2 "näyttely") ;
lin showjumping_N = mkWN (compoundN "este" (k39 "ratsastus")) ; --UNCHK
lin showman_N = mkWN (k6 "promoottori") ; --UNCHK
lin showmanship_N = mkWN (compoundN "esiintymis" (k1A "taito")) ; --UNCHK
lin showplace_N = mkWN (k40 "nähtävyys") ; --UNCHK
lin showroom_N = mkWN (k12 "myymälä") ; --UNCHK
lin showy_A = mkWA (k15 "pramea") ; --UNCHK
lin shred_N = mkWN (k48 "suikale") ; --UNCHK
lin shred_V2 = mkWV2 (k62 "suikaloida") ; --UNCHK
lin shredder_N = mkWN (k6 "silppuri") ; --UNCHK
lin shrew_N = mkWN (k38 "päästäinen") ; --UNCHK
lin shrewd_A = mkWA (k10 "näppärä") ; --UNCHK
lin shrewdness_N = mkWN (k40 "terävyys") ; --UNCHK
lin shrewish_A = mkWA (k10 "toraisa") ; --UNCHK
lin shrewishness_N = mkWN "toraisuus" ; --UNCHK
lin shrewsbury_PN = foreignPN "Shrewsbury" ;
lin shriek_N = mkWN (k9A "kiljunta") ; --UNCHK
lin shriek_V = mkWV (k66 "rääkäistä") ; --UNCHK
lin shriek_V2 = mkWV2 (k66 "rääkäistä") ; --UNCHK
lin shrift_N = mkWN (k5A "rippi") ; --UNCHK
lin shrike_N = mkWN (k38 "lepinkäinen") ; --UNCHK
lin shrill_A = mkWA (k10 "kirkuva") ; --UNCHK
lin shrill_V = mkWV (k66 "rääkäistä") ; --UNCHK
lin shrill_V2 = mkWV2 (k66 "rääkäistä") ; --UNCHK
lin shrilling_N = mkWN (k12 "pärinä") ; --UNCHK
lin shrillness_N = mkWN (k40 "kimakkuus") ; --UNCHK
lin shrimp_N = mkWN (compoundN "katka" (k1A "rapu")) ; --UNCHK
lin shrimp_V = mkWV (k53 "pyydystää") "katkarapuja" ; --UNCHK
lin shrimper_N = mkWN (compoundN "katkaravunpyynti" (k39 "alus")) ; --UNCHK
lin shrimpfish_N = mkWN (compoundN "katkarapu" (k9 "kala")) ; --UNCHK
lin shrine_N = mkWN (k1A "pyhättö") ; --UNCHK
lin shrine_V2 = mkWV2 (k53A "säilyttää") ; --UNCHK
lin shrink_N = mkWN (k10 "kallonkutistaja") ; --UNCHK
lin shrink_V = mkV "kutistua" ;
lin shrink_V2 = mkWV2 (k52A "kuihtua") ; --UNCHK
lin shrinkable_A = mkWA "kutistuva" ; --UNCHK
lin shrinkage_N = mkWN (k39 "näpistys") ; --UNCHK
lin shrinking_N = mkWN (compoundN "kuti" (k38 "stuminen")) ; --UNCHK
lin shrivel_V = mkWV (k52A "kuihtua") ; --UNCHK
lin shrivel_V2 = mkWV2 (k52A "kuihtua") ; --UNCHK
lin shriveled_A = mkWA (compoundA "supi" (k47 "stunut")) ; --UNCHK
lin shroud_N = mkWN (compoundN "käärin" (k9 "liina")) ; --UNCHK
lin shroud_V2 = mkWV2 (k52A "kietoa") "käärinliinaan" ; --UNCHK
lin shrove_tuesday_N = mkWN (k38 "laskiainen") ; --UNCHK
lin shrub_N = mkWN (k1A "varpu") ; --UNCHK
lin shrubbery_N = mkWN (compoundN "pensas" (k10 "ryhmä")) ; --UNCHK
lin shrubby_A = mkWA (k38 "pensasmainen") ; --UNCHK
lin shrublet_N = mkWN (compoundN "kääpiö" (k41 "pensas")) ; --UNCHK
lin shrug_N = mkWN (compoundN "olan" (k39 "kohautus")) ; --UNCHK
lin shrug_V2 = mkV2 "kohauttaa" ;
lin shrug_off_V2 = mkWV2 (k53A "sivuuttaa") "olankohautuksella" ; --UNCHK
lin shtik_N = mkWN "schtick" ; --UNCHK
lin shtikl_N = mkWN "schtickl" ; --UNCHK
lin shuck_N = mkWN (k7A "olki") ; --UNCHK
lin shuck_V2 = mkWV2 (k61 "kuoria") ; --UNCHK
lin shudder_N = mkWN (k12 "vapina") ; --UNCHK
lin shudder_V = mkWV (k66A "vavista") ; --UNCHK
lin shudderingly_Adv = mkWAdv "puistattaen" ; --UNCHK
lin shuffle_N = mkWN "laahaaminen" ; --UNCHK
lin shuffle_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin shuffle_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin shuffleboard_N = mkWN "shovelboard" ; --UNCHK
lin shuffler_N = mkWN "laahaaja" ; --UNCHK
lin shufti_N = mkWN (k2 "tiedustelu") ; --UNCHK
lin shun_V2 = mkV2 "välttää" partitive ;
lin shunt_N = mkWN (k5A "suntti") ; --UNCHK
lin shunt_V = mkWV (k56A "vaihtaa") ; --UNCHK
lin shunt_V2 = mkWV2 (k56A "vaihtaa") ; --UNCHK
lin shunter_N = mkWN (compoundN "järjestely" (k6 "veturi")) ; --UNCHK
lin shush_V = mkWV (k67A "hyssytellä") ; --UNCHK
lin shush_V2 = mkWV2 (k67A "hyssytellä") ; --UNCHK
lin shut_V2 = mkWV2 (k52A "sulkeutua") ; --UNCHK
lin shut_away_V2 = mkWV2 (k69 "lukita") "sisään" ; --UNCHK
lin shut_down_V2 = mkV2 "sulkea" ;
lin shut_in_V2 = mkWV2 (k58A "sulkea") "sisään" ; --UNCHK
lin shut_off_V = mkWV (k58A "sulkea") ; --UNCHK
lin shut_off_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin shut_out_V2 = mkWV2 (k53 "estää") ; --UNCHK
lin shut_out_of_V2 = prepV2 (advV (lin V OP_shut_V2) OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin shut_up_V2 = mkWV2 (k71 "tehdä") "hiljaiseksi" ; --UNCHK
lin shut_yourself_away_V = variants {} ; -- guess-p-verb
lin shutdown_N = mkWN (compoundN "lakka" (k38 "uttaminen")) ; --UNCHK
lin shutout_N = mkWN (k39 "rökitys") ; --UNCHK
lin shutter_N = mkWN (compoundN "säle" (k33A "kaihdin")) ; --UNCHK
lin shutter_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin shutterbug_N = mkWN (compoundN "kamera" (k1 "hullu")) ; --UNCHK
lin shutting_N = mkWN "sulkeminen" ; --UNCHK
lin shuttle_N = mkWN (k12 "sukkula") ; --UNCHK
lin shuttle_V = mkWV (k62 "sukkuloida") ; --UNCHK
lin shuttle_V2 = mkWV2 (k62 "sukkuloida") ; --UNCHK
lin shuttlecock_N = mkWN (compoundN "sulka" (k1 "pallo")) ; --UNCHK
lin shy_A = mkWA (k41A "pelokas") ; --UNCHK
lin shy_N = mkWN (k1A "heitto") ; --UNCHK
lin shy_V = mkV "kavahtaa" ; --mkWV (k53A "heittää") ;
lin shy_V2 = mkWV2 (k53A "heittää") ; --UNCHK
lin shy_away_from_V2 = mkWV2 (k67A "vältellä") ; --UNCHK
lin shyness_N = mkWN (k40 "ujous") ; --UNCHK
lin shyster_N = mkWN (compoundN "asian" (k10 "ajaja")) "huonomaineinen" ; --UNCHK
lin sial_N = mkWN (k5 "sial") ; --UNCHK
lin sialadenitis_N = mkWN (compoundN "sylkirauhas" (k39 "tulehdus")) ; --UNCHK
lin siamang_N = mkWN "Symphalangus" "syndactylus" ; --UNCHK
lin siamese_A = mkWA (k38 "siamilainen") ; --UNCHK
lin siamese_N = mkWN (k38 "siamilainen") ; --UNCHK
lin sibbo_PN = mkPN "Sipoo" ;
lin siberian_A = mkWA (compoundA "siperi" (k38 "alainen")) ; --UNCHK
lin sibilant_A = mkWA "suhiseva" ; --UNCHK
lin sibilant_N = mkWN (k5A "konsonantti") "sibilantti" ; --UNCHK
lin sibilation_N = mkWN "suhauttaminen" ; --UNCHK
lin sibling_N = mkWN (k39 "sisarus") ; --UNCHK
lin sibyl_N = mkWN "sibylla" ; --UNCHK
lin sibylline_A = mkWA (k38 "arvoituksellinen") ; --UNCHK
lin sic_Adv = mkWAdv (k99 "näin") "tosiaan" ; --UNCHK
lin sicilian_A = mkWA (compoundA "sisili" (k38 "alainen")) ; --UNCHK
lin sicilian_N = mkWN (compoundN "sisili" (k38 "alainen")) ; --UNCHK
lin sick_A = mkWA (k41 "sairas") ;
lin sick_N = mkN "sairastava" | mkN "sairas" ;
lin sick_V2 = mkV2 (mkV "oksentaa") ; ----SUBCAT
lin sick_benefit_N = mkWN (compoundN "sairauspäivä" (k9 "raha")) ; --UNCHK
lin sick_berth_N = mkWN (compoundN "sairas" (k5A "hytti")) ; --UNCHK
lin sick_headache_N = mkWN (k5 "migreeni") ; --UNCHK
lin sick_leave_N = mkWN (compoundN "sairaus" (k10 "loma")) ; --UNCHK
lin sick_list_N = mkWN (compoundN "sairas" (k2 "luettelo")) ; --UNCHK
lin sick_parade_N = mkWN (compoundN "sairas" (k1 "jono")) ; --UNCHK
lin sick_pay_N = mkWN (k9A "palkka") "sairausajan" ; --UNCHK
lin sickbay_N = mkWN (compoundN "sairas" (k5A "hytti")) ; --UNCHK
lin sickbed_N = mkWN (compoundN "sairas" (k48A "vuode")) ; --UNCHK
lin sicken_V = mkWV (k52 "sairastua") ; --UNCHK
lin sicken_V2 = mkWV2 (k52 "sairastua") ; --UNCHK
lin sickish_A = mkWA (k10 "pahoinvoiva") ; --UNCHK
lin sickle_N = mkWN (k5A "sirppi") "elonkorjuu" ; --UNCHK
lin sicklepod_N = mkWN "Arabis" "Canadensis" ; --UNCHK
lin sickly_A = mkWA (k15 "kelmeä") ; --UNCHK
lin sickness_N = mkWN (k5A "tauti") ; --UNCHK
lin sick_room_N = mkWN (compoundN "sairas" (k48 "huone")) ; --UNCHK
lin side_N = mkWN (k26 "puoli") ;
lin side_V = mkV "puolustaa" ;
lin side_chapel_N = mkWN (compoundN "sivu" (k6 "kappeli")) ; --UNCHK
lin side_dish_N = mkWN (k48A "lisuke") ; --UNCHK
lin side_drum_N = mkWN (kH1 "virveli") ; --UNCHK
lin side_road_N = mkWN (compoundN "sivu" (k19 "tie")) ; --UNCHK
lin side_view_N = mkWN (compoundN "sivu" (k10 "kuva")) ; --UNCHK
lin sidearm_A = mkWA "sivu-" ; --UNCHK
lin sidearm_Adv = mkWAdv (k99 "tyylisesti") "sidearm-syötön" ; --UNCHK
lin sidebar_N = mkWN (compoundN "sivu" (k5A "palkki")) ; --UNCHK
lin sideboard_N = mkWN (k5A "senkki") ; --UNCHK
lin sideburn_N = mkWN (k5A "pulisonki") ; --UNCHK
lin sidecar_N = mkWN (compoundN "sivu" (k1 "vaunu")) ; --UNCHK
lin sideline_N = mkN "sivuartikkeli" ;
lin sideline_V = mkV (mkV "pysyä") "poissa pelistä" ;
lin sideline_V2 = mkV2 (mkV (mkV "pitää") "poissa pelistä") ;
lin sidelong_A = mkWA (k99 "sirrillään") ; --UNCHK
lin sidelong_Adv = mkWAdv (k99 "vinottain") ; --UNCHK
lin sidereal_A = mkWA "tähti-" ; --UNCHK
lin siderite_N = mkWN (compoundN "rauta" (k5A "meteoriitti")) ; --UNCHK
lin sideroblast_N = mkWN (compoundN "siderob" (k5 "lasti")) ; --UNCHK
lin siderocyte_N = mkWN "siderosyytti" ; --UNCHK
lin sideropenia_N = mkWN "sideropenia" ; --UNCHK
lin siderosis_N = mkWN "siderosis" ; --UNCHK
lin side_saddle_Adv = mkWAdv (compoundAdv "naistensatul" (k99 "alla")) ; --UNCHK
lin sideshow_N = mkWN (compoundN "sivu" (k39 "näytös")) ; --UNCHK
lin sidesman_N = mkWN (k38 "apulainen") "kirkkoväärtin" ; --UNCHK
lin sidestep_N = mkWN (compoundN "sivu" (k49 "askel")) ; --UNCHK
lin sidestep_V = mkWV (k67A "luikerrella") ; --UNCHK
lin sidestep_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin side_stroke_N = mkWN (k1A "kylkiuintiveto") ; --UNCHK
lin sideswipe_N = mkWN (k2 "tönäisy") ; --UNCHK
lin sidetrack_N = mkWN (compoundN "sivu" (k48A "raide")) ; --UNCHK
lin sidetrack_V2 = mkWV2 (k74A "poiketa") ; --UNCHK
lin sidewalk_N = mkN "jalka" (mkN "käytävä") ;
lin sidewall_N = mkWN (compoundN "sivu" (k10 "seinä")) ; --UNCHK
lin sideward_Adv = mkWAdv (k99 "sivulle") ; --UNCHK
lin sidewards_Adv = mkWAdv (k99 "sivulle") ; --UNCHK
lin sideway_Adv = mkWAdv (k99 "sivuttain") ; --UNCHK
lin sideways_Adv = mkWAdv (k99 "vinottain") ; --UNCHK
lin sidewinder_N = mkWN (compoundN "kalkkaro" (k48 "käärme")) ; --UNCHK
lin siding_N = mkWN (compoundN "sivu" (k48A "raide")) ; --UNCHK
lin sidle_V = mkWV (k67 "astella") ; --UNCHK
lin sidmouth_PN = foreignPN "Sidmouth" ;
lin sidney_PN = foreignPN "Sidney" ;
lin siege_N = mkWN (k1A "saarto") ; --UNCHK
lin sienna_N = mkWN "siena" ; --UNCHK
lin sierra_N = mkWN (compoundN "perun" (k5 "makrilli")) ; --UNCHK
lin siesta_N = mkWN (k9 "siesta") ; --UNCHK
lin sieve_N = mkWN (k9 "seula") ; --UNCHK
lin sieve_V2 = mkWV2 (k52 "seuloa") ; --UNCHK
lin sievi_PN = mkPN "Sievi" ;
lin sift_V = mkWV (k52 "seuloa") ; --UNCHK
lin sift_V2 = mkWV2 (k52 "seuloa") ; --UNCHK
lin sifter_N = mkWN (k13 "siivilä") ; --UNCHK
lin sigeh_N = mkWN "sigeh" ; --UNCHK
lin sigh_N = mkWN (k39 "huokaus") ;
lin sigh_V = mkWV (k73A "huoata") ; --UNCHK
lin sigh_V2 = mkWV2 (k73A "huoata") ; --UNCHK
lin sigh_VS = mkWVS (k73A "huoata") ; --UNCHK
lin sight_N = mkWN (k10 "näkymä") ; --UNCHK
lin sight_V2 = mkWV2 (k63 "saada") "näkyviinsä" ; --UNCHK
lin sighting_N = mkWN (k1A "havainto") ; --UNCHK
lin sightless_A = mkWA (k15 "sokea") ; --UNCHK
lin sightreader_N = mkWN (k10 "soittaja") ; --UNCHK
lin sights_N = mkWN (k33 "tähtäin") ; --UNCHK
lin sightseeing_N = mkWN (k2 "töllistely") ; --UNCHK
lin sightseer_N = mkWN (k12 "töllistelijä") ; --UNCHK
lin sigma_N = mkWN (k9 "sigma") ; --UNCHK
lin sigmoid_A = mkWA "vemmelsuolen" ; --UNCHK
lin sigmoidectomy_N = mkWN (compoundN "poisto" (k39 "leikkaus")) "sigmasuolen" ; --UNCHK
lin sigmoidoscope_N = mkWN (compoundN "sigmoidosko" (k5A "oppi")) "taipuisa" ; --UNCHK
lin sigmoidoscopy_N = mkWN "taipuisa" "sigmoidoskopia" ; --UNCHK
lin sign_N = mkN "merkki" ;
lin sign_V = mkV "allekirjoittaa" ;
lin sign_V2 = mkV2 "allekirjoittaa" ;
lin sign_away_V2 = mkWV2 (k53A "luovuttaa") ; --UNCHK
lin sign_for_V3 = variants {} ; -- guess-p-verb
lin sign_in_V = mkWV (k71 "tehdä") "lähtöselvitys" ; --UNCHK
lin sign_in_V2 = mkWV2 (k71 "tehdä") "lähtöselvitys" ; --UNCHK
lin sign_into_V2 = prepV2 OP_sign_V OP_into_Prep ; -- guess-p-verb
lin sign_off_V = mkWV (k53A "lopettaa") ; --UNCHK
lin sign_off_V2 = mkWV2 (k53A "lopettaa") ; --UNCHK
lin sign_off_on_V2 = prepV2 (advV OP_sign_V OP_off_Adv ) OP_on_Prep ; -- guess-p-verb
lin sign_on_V = mkWV (k62 "rekrytoida") ; --UNCHK
lin sign_on_V2 = mkWV2 (k62 "rekrytoida") ; --UNCHK
lin sign_on_with_V2 = prepV2 (advV OP_sign_V OP_on_Adv ) OP_with_Prep ; -- guess-p-verb
lin sign_out_V = advV OP_sign_V OP_out_Adv ; -- guess-p-verb
lin sign_out_V2 = prepV2 OP_sign_V OP_out_Prep ; -- guess-p-verb
lin sign_out_of_V2 = prepV2 (advV OP_sign_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin sign_painter_N = mkWN (k6 "kilpimaalari") ; --UNCHK
lin sign_up_V = mkWV (k52A "ilmoittautua") ;
lin sign_with_V2 = prepV2 OP_sign_V OP_with_Prep ; -- guess-p-verb
lin signage_N = mkWN "kyltitys" ; --UNCHK
lin signal_A = mkWA (k10 "huomattava") ; --UNCHK
lin signal_N = mkN "signaali" ;
lin signal_V2 = mkWV2 (k73A "viitata") ; --UNCHK
lin signal_VS = mkWVS (k73A "viitata") ; --UNCHK
lin signal_box_N = mkWN (compoundN "ohjaus" (k39 "keskus")) ; --UNCHK
lin signale_V2 = mkV2 "viestittää" ;
lin signale_VS = mkVS "viestittää" ;
lin signaler_N = mkWN (k10 "viestittäjä") ; --UNCHK
lin signalization_N = mkWN (compoundN "tähde" (k38 "ntäminen")) ; --UNCHK
lin signalize_V2 = mkWV2 (k52A "erottua") ; --UNCHK
lin signaller_N = mkWN (k10 "viestittäjä") ; --UNCHK
lin signalman_N = mkWN (k10 "hoitaja") "opasteiden" ; --UNCHK
lin signatory_N = mkWN (compoundN "alle" (k10 "kirjoittaja")) "sopimuksen" ; --UNCHK
lin signature_N = mkN "alle" (mkN "kirjoitus") ; --mkWN (k39 "kosketus") ;
lin signboard_N = mkWN (k7A "kilpi") ; --UNCHK
lin signer_N = mkWN (compoundN "alle" (k10 "kirjoittaja")) "sopimuksen" ; --UNCHK
lin signet_N = mkWN (k5A "sinetti") ; --UNCHK
lin signet_ring_N = mkWN (compoundN "sinetti" (k39 "sormus")) ; --UNCHK
lin significance_N = mkWN (k40 "tärkeys") ; --UNCHK
lin significant_A = mkA "merkittävä" ;
lin signification_N = mkWN (k39 "sisällys") ; --UNCHK
lin significative_A = mkWA (k10 "merkitsevä") "jotakin" ; --UNCHK
lin signify_V = mkWV (k53 "edustaa") ; --UNCHK
lin signify_V2 = mkWV2 (k53 "edustaa") ; --UNCHK
lin signor_N = mkWN "signior" ; --UNCHK
lin signora_N = mkWN (compoundN "Sign" (k10 "ora")) ; --UNCHK
lin signore_N = mkWN "signore" ; --UNCHK
lin signorina_N = mkWN "Signorina" ; --UNCHK
lin signpost_N = mkWN (k9A "tienviitta") ; --UNCHK
lin signpost_V2 = mkWV2 (k53A "viitoittaa") ; --UNCHK
lin siikainen_PN = mkPN "Siikainen" ;
lin siikajoki_PN = mkPN (mkN "Siikajoki" "Siikajokia") ;
lin siilinjärvi_PN = mkPN (mkN "Siilinjärvi" "Siilinjärviä") ;
lin sikh_N = mkWN (k5 "sikhi") ; --UNCHK
lin silage_N = mkWN (compoundN "säilö" (k1 "rehu")) ; --UNCHK
lin sild_N = mkWN "sild" ; --UNCHK
lin sildenafil_N = mkWN "Viagra" ; --UNCHK
lin sileby_PN = foreignPN "Sileby" ;
lin silence_N = mkN "hiljaisuus" ;
lin silence_V2 = mkWV2 (k71 "tehdä") "hiljaiseksi" ; --UNCHK
lin silencer_N = mkWN (compoundN "äänen" (k33A "vaimennin")) ; --UNCHK
lin silene_N = mkWN (k5A "kohokki") ; --UNCHK
lin silent_A = mkA "hiljainen" ; --mkWA (k10A "mykkä") ;
lin silenus_N = mkWN "Silenos" ; --UNCHK
lin silesia_N = mkWN "silesia" ; --UNCHK
lin silex_N = mkWN "Silex" ; --UNCHK
lin silhouette_N = mkWN (k5A "siluetti") ; --UNCHK
lin silhouette_V2 = mkWV2 (k52A "piirtyä") ; --UNCHK
lin silica_N = mkWN (k5 "piidioksidi") ; --UNCHK
lin silicate_N = mkWN (k5A "silikaatti") ; --UNCHK
lin siliceous_A = mkWA "silikaatti-" ; --UNCHK
lin silicide_N = mkWN "silisidi" ; --UNCHK
lin silicle_N = mkWN (k1A "litu") ; --UNCHK
lin silicon_N = mkWN (kH1 "pii") ; --UNCHK
lin silicone_N = mkWN (k5 "silikoni") ; --UNCHK
lin silicosis_N = mkWN (k5 "silikoosi") ; --UNCHK
lin silique_N = mkWN (k1A "litu") ; --UNCHK
lin silk_N = mkWN (k5A "silkki") ; --UNCHK
lin silken_A = mkWA (k38 "silkkinen") ; --UNCHK
lin silkiness_N = mkWN (k40 "kiiltävyys") ; --UNCHK
lin silks_N = mkWN (compoundN "silkki" (k1 "asu")) ; --UNCHK
lin silkscreen_N = mkWN (compoundN "silkkipaino" (k10 "kuva")) ; --UNCHK
lin silkworm_N = mkWN (compoundN "silkkiäis" (k10A "toukka")) ; --UNCHK
lin silky_A = mkWA (k38 "silkkinen") ; --UNCHK
lin sill_N = mkWN (compoundN "alus" (k28 "hirsi")) ; --UNCHK
lin sillabub_N = mkWN "sillabub" ; --UNCHK
lin silliness_N = mkWN (k40 "huimaavuus") ; --UNCHK
lin silly_A = mkWA (k10 "sekava") ;
lin silly_N = mkWN (k5 "tyhmeliini") ; --UNCHK
lin silo_N = mkWN (k1 "siilo") ; --UNCHK
lin silsden_PN = foreignPN "Silsden" ;
lin silt_N = mkWN (k1 "lieju") ; --UNCHK
lin silt_V = mkWV (k52A "madaltua") ; --UNCHK
lin silt_V2 = mkWV2 (k52A "madaltua") ; --UNCHK
lin silt_up_V = mkWV (k52A "madaltua") ; --UNCHK
lin siltstone_N = mkWN (compoundN "hieta" (k7 "kivi")) ; --UNCHK
lin silty_A = mkWA (k38 "liejuinen") ; --UNCHK
lin silurid_N = mkWN "silurid" "fish" ; --UNCHK
lin silva_N = mkWN (k10 "metsä") ; --UNCHK
lin silvan_A = mkWA "metsän-" ; --UNCHK
lin silver_A = mkWA (k10 "puhuva") "miellyttävästi" ; --UNCHK
lin silver_N = L.silver_N ;
lin silver_V = mkWV (k52A "hopeoitua") ; --UNCHK
lin silver_V2 = mkWV2 (k52A "hopeoitua") ; --UNCHK
lin silverback_N = mkWN (compoundN "hopea" (k10A "selkä")) ; --UNCHK
lin silverberry_N = mkWN (compoundN "hopea" (k41 "pensas")) "aito" ; --UNCHK
lin silver_fish_N = mkWN (compoundN "kulta" (k9 "kala")) ; --UNCHK
lin silvern_A = mkWA (k38 "hopeainen") ; --UNCHK
lin silverpoint_N = mkWN "hopeakynäpiirros" ; --UNCHK
lin silverrod_N = mkWN (k1 "piisku") ; --UNCHK
lin silverside_N = mkWN (compoundN "hopea" (k7A "kylki")) ; --UNCHK
lin silversides_N = mkWN "Notropis" "cornutus" ; --UNCHK
lin silversmith_N = mkWN (compoundN "hopea" (k10A "seppä")) ; --UNCHK
lin silversword_N = mkWN "Argyroxiphium" "sandwicense" ; --UNCHK
lin silvervine_N = mkWN (compoundN "mantšurianlaikku" (k39 "köynnös")) ; --UNCHK
lin silverweed_N = mkWN (compoundN "keto" (k5A "hanhikki")) ; --UNCHK
lin silvery_A = mkWA (k38 "hopeainen") ; --UNCHK
lin silvex_N = mkWN "silvex" ; --UNCHK
lin silvia_PN = foreignPN "Silvia" ;
lin silviculture_N = mkWN (compoundN "metsä" (k48A "tiede")) ; --UNCHK
lin sima_N = mkWN (k9 "sima") ; --UNCHK
lin simazine_N = mkWN "simatsiini" ; --UNCHK
lin simian_A = mkWA (compoundA "apina" (k38 "mainen")) ; --UNCHK
lin simian_N = mkWN (k12 "apina") ; --UNCHK
lin similar_A = mkA "samanlainen" ;
lin similarity_N = mkWN (k40 "samanlaisuus") ;
lin simile_N = mkWN (k39 "vertaus") ; --UNCHK
lin similitude_N = mkWN (k39 "jäljennös") ; --UNCHK
lin simmer_N = mkWN (k2 "poreilu") ; --UNCHK
lin simmer_V = mkWV (k52A "hautua") ;
lin simmer_V2 = mkWV2 (k52A "hautua") ; --UNCHK
lin simmer_down_V = mkWV (k52A "rentoutua") ; --UNCHK
lin simnel_N = mkWN "simnel" ; --UNCHK
lin simo_PN = mkPN "Simo" ;
lin simony_N = mkWN "simonia" ; --UNCHK
lin simoom_N = mkWN (k5 "samum") ; --UNCHK
lin simoon_N = mkWN (k5 "samum") ; --UNCHK
lin simpele_PN = mkPN "Simpele" ;
lin simper_N = mkWN (k1 "hymy") "mairea" ; --UNCHK
lin simper_V = mkWV (k67 "hymyillä") "teennäisesti" ; --UNCHK
lin simperer_N = mkWN (k12 "teeskentelijä") ; --UNCHK
lin simperingly_Adv = mkWAdv (k99 "arasti") ; --UNCHK
lin simple_A = mkA "yksinkertainen" ;
lin simple_N = mkWN (k6 "tyhmyri") ; --UNCHK
lin simple_minded_A = mkA (mkN "yksin" (mkN "kertainen")) ;
lin simpleton_N = mkWN (k6 "tyhmyri") ; --UNCHK
lin simplex_A = mkWA "simplex" ; --UNCHK
lin simplicity_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin simplification_N = mkWN (k39 "pelkistys") ; --UNCHK
lin simplify_V = mkWV (k53 "pelkistää") ; --UNCHK
lin simplify_V2 = mkWV2 (k53 "yksinkertaistaa") ;
lin simplistic_A = mkWA (compoundA "yli" (k1 "yksinkertaistettu")) ; --UNCHK
lin simulacrum_N = mkWN (k10 "kuva") ; --UNCHK
lin simulate_V2 = mkWV2 (k67A "teeskennellä") ; --UNCHK
lin simulation_N = mkWN (k2 "teeskentely") ; --UNCHK
lin simulator_N = mkWN (k6 "simulaattori") ; --UNCHK
lin simulcast_N = mkWN (compoundN "yhteis" (k39 "lähetys")) ; --UNCHK
lin simultaneity_N = mkWN (k40 "simultaanisuus") ; --UNCHK
lin simultaneous_A = mkWA (k38 "rinnakkainen") ; --UNCHK
lin simultaneousness_N = mkWN (k40 "simultaanisuus") ; --UNCHK
lin simvastatin_N = mkWN "Zocor" ; --UNCHK
lin sin_N = mkWN (k5A "synti") ;
lin sin_V = mkWV (k73A "loukata") ; --UNCHK
lin since_Adv = mkAdv "siitä lähtien" ;
lin since_Prep = postPrep elative "lähtien" ;
lin since_Subj = mkSubj "siitä lähtien kun" ;
lin since_then_Adv = mkAdv "siitä lähtien" ;
lin sincere_A = mkA "vilpitön" ;
lin sincerity_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin sinciput_N = mkWN (compoundN "otsan" (k1A "seutu")) ; --UNCHK
lin sine_N = mkWN (kH1 "sini") ; --UNCHK
lin sine_die_Adv = mkWAdv "epämääräiseksi" "ajaksi" ; --UNCHK
lin sine_qua_non_N = mkWN (k39 "edellytys") "välttämätön" ;
lin sinecure_N = mkWN (compoundN "laiskan" (k9A "virka")) ; --UNCHK
lin sinew_N = mkWN (k10 "voima") ; --UNCHK
lin sinewy_A = mkWA (k38 "jänteinen") ; --UNCHK
lin sinful_A = mkWA (k38 "syntinen") ; --UNCHK
lin sinfulness_N = mkWN (k40 "pahuus") ; --UNCHK
lin sing_V = L.sing_V ;
lin sing_V2 = mkV2 "laulaa" ; --mkWV2 (k62 "vasikoida") ;
lin sing_along_V = mkWV (k56 "laulaa") "mukana" ; --UNCHK
lin sing_out_V = advV OP_sing_V OP_out_Adv ; -- guess-p-verb
lin sing_up_V = advV OP_sing_V OP_up_Adv ; -- guess-p-verb
lin singable_A = mkWA (k38 "melodinen") ; --UNCHK
lin singalong_N = mkWN (compoundN "yhteislaulu" (k40 "tilaisuus")) ; --UNCHK
lin singapore_PN = foreignPN "Singapore" ;
lin singaporeanFem_N = mkWN (compoundN "singapore" (k38 "lainen")) ; --UNCHK
lin singaporeanMasc_N = mkWN (compoundN "singapore" (k38 "lainen")) ; --UNCHK
lin singaporean_A = mkWA (compoundA "singapore" (k38 "lainen")) ; --UNCHK
lin singe_N = mkWN (compoundN "palo" (k7A "jälki")) ; --UNCHK
lin singe_V = mkWV (k54A "kärventää") ; --UNCHK
lin singe_V2 = mkWV2 (k54A "kärventää") ; --UNCHK
lin singer_N = mkWN (k5 "vokalisti") ; --UNCHK
lin singhalese_A = mkWA (compoundA "singalees" (k32A "ien")) ; --UNCHK
lin singing_N = mkWN (k1 "laulu") ; --UNCHK
lin single_1_A = mkA "yksittäinen" ;
lin single_2_A = mkA "naimaton" | mkA "sinkku" ;
lin single_A = mkA "yksittäinen" ;
lin single_N = mkWN (compoundN "ykköspesä" (k5A "lyönti")) ; --UNCHK
lin single_V2 = mkWV2 (k64 "lyödä") "ykköselle" ; --UNCHK
lin single_handed_A = mkA "yksinäinen" ;
lin single_out_V2 = mkWV2 (k69 "valita") ; --UNCHK
lin singleness_N = mkWN (compoundN "määrä" (k40 "tietoisuus")) ; --UNCHK
lin singles_N = mkWN (compoundN "kaksin" (k5 "peli")) ; --UNCHK
lin singlestick_N = mkWN (compoundN "harjoitus" (k9A "miekka")) ; --UNCHK
lin singlet_N = mkWN (compoundN "alus" (k9A "paita")) ; --UNCHK
lin singleton_N = mkWN (k5A "kortti") "ainoa" ; --UNCHK
lin singly_Adv = mkWAdv (k99 "yksittäin") ; --UNCHK
lin singsong_N = mkWN (compoundN "yhteislaulu" (k40 "tilaisuus")) ; --UNCHK
lin singular_A = mkWA (k38 "yksityinen") ; --UNCHK
lin singular_N = mkWN (k4A "yksikkö") ; --UNCHK
lin singularity_N = mkWN "ainutlaatuisuus" ; --UNCHK
lin singularize_V2 = mkWV2 (k53A "erottaa") "muista" ; --UNCHK
lin sinhala_N = mkWN (compoundN "sinh" (k9 "ala")) ; --UNCHK
lin sinhalese_A = mkWA (compoundA "singalees" (k32A "ien")) ; --UNCHK
lin sinhalese_N = mkWN (compoundN "sinh" (k9 "ala")) ; --UNCHK
lin sinister_A = mkWA (k10 "uhkaava") ; --UNCHK
lin sinistral_A = mkWA (compoundA "vasemman" (k38 "puolinen")) ; --UNCHK
lin sinistrorse_A = mkWA "vasemmalle" "kiertyvä" ; --UNCHK
lin sink_N = mkN "allas" ; ---ARB ; likakaivo ; nielu (technical term)
lin sink_V = mkWV (k52A "vaipua") ; --UNCHK
lin sink_V2 = mkWV2 (k52A "vaipua") ; --UNCHK
lin sink_in_V = mkWV (k52 "paljastua") ; --UNCHK
lin sinkable_A = mkWA "upotettava" ; --UNCHK
lin sinker_N = mkWN "sinker" ; --UNCHK
lin sinkhole_N = mkWN (k10 "vajoama") ; --UNCHK
lin sinking_N = mkWN (compoundN "hei" (k38 "kkeneminen")) ; --UNCHK
lin sinking_fund_N = mkWN (compoundN "kuoletus" (k2 "rahasto")) ; --UNCHK
lin sinless_A = mkWA (k34A "synnitön") ; --UNCHK
lin sinlessness_N = mkWN (k40 "viattomuus") ; --UNCHK
lin sinner_N = mkWN (k38 "syntinen") ; --UNCHK
lin sinologist_N = mkWN (k5 "sinologi") ; --UNCHK
lin sinology_N = mkWN (k12 "sinologia") ; --UNCHK
lin sinopis_N = mkWN (k5 "sinooperi") ; --UNCHK
lin sintered_A = mkWA "sintrattu" ; --UNCHK
lin sinuate_A = mkWA "mutkitteleva" ; --UNCHK
lin sinuosity_N = mkWN "mutkittelevuus" ; --UNCHK
lin sinuous_A = mkWA (k38 "kiemurainen") ; --UNCHK
lin sinus_N = mkWN (k2 "ontelo") ; --UNCHK
lin sinusitis_N = mkWN (k39 "tulehdus") "sivuontelon" ; --UNCHK
lin sinusoid_N = mkWN "sinusoidi" ; --UNCHK
lin sinusoidal_A = mkWA (compoundA "sini" (k38 "muotoinen")) ; --UNCHK
lin sioux_N = mkWN (k5 "sioux") ; --UNCHK
lin sip_N = mkWN (k39 "siemaus") ; --UNCHK
lin sip_V = mkWV "siemailla" ; --UNCHK
lin sip_V2 = mkWV2 "siemailla" ; --UNCHK
lin siphon_N = mkWN (compoundN "ilma" (k7 "putki")) ; --UNCHK
lin siphon_V = mkWV (k53A "juoksuttaa") "lapolla" ; --UNCHK
lin siphon_V2 = mkWV2 (k53A "juoksuttaa") "lapolla" ; --UNCHK
lin siphonophore_N = mkWN (compoundN "uima" (k5A "polyyppi")) ; --UNCHK
lin sipper_N = mkWN "siemailija" ; --UNCHK
lin sir_N = mkWN (k9 "herra") ; --UNCHK
lin siracusa_PN = foreignPN "Syrakusa" ;
lin sirdar_N = mkWN "sirdar" ; --UNCHK
lin sire_N = mkWN (k41 "koiras") ; --UNCHK
lin sire_V2 = mkWV2 (k53A "siittää") ; --UNCHK
lin siren_N = mkWN (k1 "mutalisko") ; --UNCHK
lin siris_N = mkWN "Albizzia" "lebbeck" ; --UNCHK
lin sirloin_N = mkWN (compoundN "ulko" (k20 "filee")) ; --UNCHK
lin sirocco_N = mkWN (compoundN "hiekka" (k1 "myrsky")) ; --UNCHK
lin sirrah_N = mkWN (k14A "nulikka") ; --UNCHK
lin sirup_N = mkWN (k5A "siirappi") ; --UNCHK
lin sisal_N = mkWN (compoundN "sisal" (k8 "agaave")) ; --UNCHK
lin siskin_N = mkWN (compoundN "viher" (k38 "varpunen")) ; --UNCHK
lin sissified_A = mkWA (k38 "feminiininen") ; --UNCHK
lin sissoo_N = mkWN "Dalbergia" "sissoo" ; --UNCHK
lin sissy_N = mkWN (k2 "nyhverö") ; --UNCHK
lin sister_N = L.sister_N ;
lin sisterhood_N = mkWN (compoundN "sisar" (k10A "kunta")) ; --UNCHK
lin sisterly_A = mkWA (k38 "sisarellinen") ; --UNCHK
lin sit_V = L.sit_V ;
lin sit_V2 = mkV2 (mkV "istua") ;
lin sit_about_V = advV OP_sit_V OP_about_Adv ; -- guess-p-verb
lin sit_around_V = mkV "istuskella" ;
lin sit_back_V = mkWV (k52A "rentoutua") ; --UNCHK
lin sit_by_V = advV OP_sit_V OP_by_Adv ; -- guess-p-verb
lin sit_down_V2 = mkWV2 (k52A "istuutua") ; --UNCHK
lin sit_for_V2 = prepV2 OP_sit_V OP_for_Prep ; -- guess-p-verb
lin sit_in_N = mkN "istunto" ;
lin sit_in_V2 = mkWV2 (k68 "pullikoida") ; --UNCHK
lin sit_in_for_V2 = prepV2 (advV OP_sit_V OP_in_Adv ) OP_for_Prep ; -- guess-p-verb
lin sit_in_on_V2 = prepV2 (advV OP_sit_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin sit_on_V2 = prepV2 OP_sit_V OP_on_Prep ; -- guess-p-verb
lin sit_out_V2 = mkWV2 (k52 "istua") "loppuun" ; --UNCHK
lin sit_over_V2 = prepV2 OP_sit_V OP_over_Prep ; -- guess-p-verb
lin sit_through_V2 = prepV2 OP_sit_V OP_through_Prep ; -- guess-p-verb
lin sit_up_V = mkWV (k52 "valvoa") ; --UNCHK
lin sit_with_V2 = prepV2 OP_sit_V OP_with_Prep ; -- guess-p-verb
lin sitar_N = mkWN (k6 "sitar") ; --UNCHK
lin site_N = mkN "sijaintipaikka" ;
lin site_V = mkWV (k53A "sijoittaa") ; --UNCHK
lin sitter_N = mkWN (k9 "kana") "hautomahaluinen" ; --UNCHK
lin sitting_N = mkWN (k9A "istunta") ; --UNCHK
lin sitting_room_N = mkWN (k5 "sali") ; --UNCHK
lin sittingbourne_PN = foreignPN "Sittingbourne" ;
lin situate_V2 = mkWV2 (k53A "asettaa") ; --UNCHK
lin situation_N = mkN (lin NK {s = d48A "tilanne"}) ;
lin siuntio_PN = mkPN "Siuntio" ;
lin sixfold_A = mkWA (compoundA "kuu" (k38 "sinkertainen")) ; --UNCHK
lin sixfold_Adv = mkWAdv (compoundAdv "ker" (k99 "taa")) "kuusi" ; --UNCHK
lin sixpence_N = mkWN (k5A "lantti") "kuuden" "pennyn" ; --UNCHK
lin sixpenny_A = mkWA (k34A "arvoton") ; --UNCHK
lin sizable_A = mkA (lin AK {s = d38 "melkoinen"}) ;
lin size_A = mkWA "-kokoinen" ; --UNCHK
lin size_N = mkN "koko" ;
lin size_V2 = mkV2 "mitoittaa" ;
lin size_up_V2 = mkWV2 (k61 "tutkia") "tarkasti" ; --UNCHK
lin sizeable_A = mkWA (k1 "reilu") ; --UNCHK
lin sizzle_N = mkWN (k12 "pihinä") ; --UNCHK
lin sizzle_V = mkWV (k66 "sihistä") ; --UNCHK
lin skank_N = mkWN "skank" ; --UNCHK
lin skate_N = mkWN (k1 "rausku") ; --UNCHK
lin skate_V = mkWV (k67 "luistella") ; --UNCHK
lin skateboard_N = mkWN (k5A "skeitti") ; --UNCHK
lin skateboarder_N = mkWN (k10 "skeittaaja") ; --UNCHK
lin skateboarding_N = mkWN (k39 "skeittaus") ; --UNCHK
lin skater_N = mkWN (k12 "luistelija") ; --UNCHK
lin skating_N = mkWN (k2 "luistelu") ; --UNCHK
lin skating_rink_N = mkWN (k9A "rata") ; --UNCHK
lin skedaddle_N = mkWN "livistäminen" ; --UNCHK
lin skedaddle_V = mkWV (k70 "juosta") "karkuun" ; --UNCHK
lin skeet_N = mkWN (k9A "skeet-ammunta") ; --UNCHK
lin skeg_N = mkWN (k9A "kanta") "kölin" ; --UNCHK
lin skegness_PN = foreignPN "Skegness" ;
lin skein_N = mkWN (k7A "vyyhti") ; --UNCHK
lin skeletal_A = mkWA "runko-" ; --UNCHK
lin skeleton_N = mkWN (k4A "kehikko") ; --UNCHK
lin skelmersdale_PN = foreignPN "Skelmersdale" ;
lin skep_N = mkWN (compoundN "mehiläis" (k10 "pesä")) ; --UNCHK
lin skepful_N = mkWN (k38 "kopallinen") ; --UNCHK
lin skeptic_N = mkWN (k4A "skeptikko") ; --UNCHK
lin skeptical_A = mkWA (k38 "epäileväinen") ; --UNCHK
lin skepticism_N = mkN "skeptismi" ; --mkWN (k39 "epäilys") ;
lin sketch_N = mkWN (k5 "skitsi") ; --UNCHK
lin sketch_V = mkWV (k53A "vetää") "yhteen" ; --UNCHK
lin sketch_V2 = mkWV2 (k53A "vetää") "yhteen" ; --UNCHK
lin sketch_block_N = mkWN (compoundN "luonnos" (k3 "lehtiö")) ; --UNCHK
lin sketch_map_N = mkWN (compoundN "kaavio" (k9A "kartta")) ; --UNCHK
lin sketch_book_N = mkWN (compoundN "luonnos" (k3 "lehtiö")) ; --UNCHK
lin sketcher_N = mkWN (compoundN "luonnosteluvälineluonnos" (k3 "lehtiö")) ; --UNCHK
lin sketchiness_N = mkWN (k40 "summittaisuus") ; --UNCHK
lin sketchy_A = mkWA (k38 "summittainen") ; --UNCHK
lin skew_A = mkWA (k1 "vino") ; --UNCHK
lin skew_V2 = mkWV2 (k58A "kulkea") "vinoon" ; --UNCHK
lin skewer_N = mkWN (k41A "varras") ; --UNCHK
lin skewer_V2 = mkWV2 (k56 "paistaa") "vartaassa" ; --UNCHK
lin ski_N = mkWN (k7 "suksi") ; --UNCHK
lin ski_V = mkWV (k67A "lasketella") ; --UNCHK
lin ski_jump_N = mkWN (compoundN "mäki" (k1A "hyppy")) ; --UNCHK
lin ski_lift_N = mkWN (k5 "hissi") ; --UNCHK
lin ski_bob_N = mkWN (compoundN "lumi" (k9A "kelkka")) ; --UNCHK
lin skid_N = mkWN (k1A "liuku") ; --UNCHK
lin skid_V = mkWV (k52 "luisua") ;
lin skid_V2 = mkV2 (mkV (mkV "panna") "sivuluisuun") ; --mkWV2 (k52 "lipsua") ;
lin skidder_N = mkWN (compoundN "juonto" (k6 "traktori")) ; --UNCHK
lin skidpan_N = mkWN (compoundN "ajoharjoittelu" (k9A "rata")) "liukkaan" "kelin" ; --UNCHK
lin skier_N = mkWN (k10 "hiihtäjä") ;
lin skiff_N = mkWN (k10 "jolla") ; --UNCHK
lin skiffle_N = mkWN "skiffle" ; --UNCHK
lin skiffle_group_N = mkWN (compoundN "skiffle-soitin" (k10 "ryhmä")) ; --UNCHK
lin skiing_N = mkWN (k1A "hiihto") ; --UNCHK
lin skilful_A = mkWA (k41A "taidokas") ; --UNCHK
lin skill_N = mkN "taito" | mkN "kyky" ;
lin skill_V = variants {} ; --
lin skilled_A = mkWA (k10 "taitava") ;
lin skillet_N = mkWN (compoundN "paistin" (k1 "pannu")) ; --UNCHK
lin skillful_A = mkA "taitava" ;
lin skillfulness_N = mkWN (k40 "taitavuus") ;
lin skilly_N = mkWN "kauralihaliemi" ; --UNCHK
lin skim_A = mkA "kuorittu" ;
lin skim_N = mkN "läpiluku" ;
lin skim_V = mkWV (k58A "lukea") "pintapuolisesti" ; --UNCHK
lin skim_V2 = mkWV2 (k58A "lukea") "pintapuolisesti" ; --UNCHK
lin skimmed_milk_N = mkWN (k1A "maito") "rasvaton" ; --UNCHK
lin skimmer_N = mkWN (compoundN "saksi" (k10A "nokka")) ; --UNCHK
lin skimming_N = mkWN (k39 "suhahdus") ; --UNCHK
lin skimp_V = mkWV (k73A "pihdata") ; --UNCHK
lin skimp_V2 = mkWV2 (k73A "pihdata") ; --UNCHK
lin skimpy_A = mkWA (k34A "riittämätön") ; --UNCHK
lin skin_N = L.skin_N ;
lin skin_V = mkWV (k61 "kuoria") ; --UNCHK
lin skin_V2 = mkWV2 (k61 "kuoria") ; --UNCHK
lin skin_diving_N = mkWN (compoundN "pinta" (k39 "sukellus")) ; --UNCHK
lin skin_graft_N = mkWN (compoundN "ihon" (k1A "siirto")) ; --UNCHK
lin skinflint_N = mkWN (k5A "kitupiikki") ; --UNCHK
lin skinful_N = mkWN (k99 "liikaa") "kuppi" ; --UNCHK
lin skinhead_N = mkWN (k5 "skini") ; --UNCHK
lin skink_N = mkWN "skinkki" ; --UNCHK
lin skinless_A = mkWA "nahaton" ; --UNCHK
lin skinner_N = mkWN (k6 "ajuri") ; --UNCHK
lin skinniness_N = mkWN (k40 "laihuus") ; --UNCHK
lin skinny_A = mkWA (compoundA "iho" (k38 "mainen")) ; --UNCHK
lin skint_A = mkWA (k38 "persaukinen") ; --UNCHK
lin skintight_A = mkWA (k9A "tiukka") ; --UNCHK
lin skip_N = mkWN "väliin" "jättäminen" ; --UNCHK
lin skip_V = mkWV (k53A "jättää") "väliin" ; --UNCHK
lin skip_V2 = mkWV2 (k53A "jättää") "väliin" ; --UNCHK
lin skipjack_N = mkWN (k10A "seppä") ; --UNCHK
lin skipper_N = mkWN (k6 "kapteeni") ; --UNCHK
lin skipper_V2 = mkWV2 (k62 "kipparoida") ; --UNCHK
lin skipping_rope_N = mkWN (compoundN "hyppy" (k1 "naru")) ; --UNCHK
lin skipton_PN = foreignPN "Skipton" ;
lin skirl_N = mkWN (k26 "ääni") "säkkipillin" ; --UNCHK
lin skirmish_N = mkWN (k1A "suukopu") ; --UNCHK
lin skirmish_V = mkWV (k67 "nahistella") ; --UNCHK
lin skirret_N = mkWN (k26 "sokerijuuri") ; --UNCHK
lin skirt_N = mkWN (k48 "hame") ; --UNCHK
lin skirt_V = mkWV (k67A "luikerrella") ; --UNCHK
lin skirt_V2 = mkWV2 (k67A "luikerrella") ; --UNCHK
lin skirting_board_N = mkWN (compoundN "jalka" (k9 "lista")) ; --UNCHK
lin skit_N = mkWN (kH1 "speksi") ; --UNCHK
lin skittish_A = mkWA (k34A "levoton") ; --UNCHK
lin skittishness_N = mkWN (k40 "levottomuus") ; --UNCHK
lin skittle_N = mkWN (k9 "keila") ; --UNCHK
lin skittle_V2 = mkWV2 (k73 "keilata") ; --UNCHK
lin skittle_pin_N = mkWN (k9 "keila") ; --UNCHK
lin skittles_N = mkWN (compoundN "keila" (k5 "peli")) ; --UNCHK
lin skivvy_N = mkWN (k9A "piika") ; --UNCHK
lin skopje_PN = foreignPN "Skopje" ;
lin skua_N = mkWN (compoundN "iso" (k1 "kihu")) ; --UNCHK
lin skulk_V = mkWV (k67 "hiiviskellä") ; --UNCHK
lin skulker_N = mkWN (k12 "vaanija") ; --UNCHK
lin skull_N = mkWN (k1 "kallo") ; --UNCHK
lin skullcap_N = mkWN (k5A "kalotti") ; --UNCHK
lin skullduggery_N = mkWN (k39 "hämäys") ; --UNCHK
lin skunk_N = mkWN (k6 "hilleri") ; --UNCHK
lin skunkweed_N = mkWN "Polemonium" "viscosum" ; --UNCHK
lin sky_N = L.sky_N ;
lin sky_V2 = mkWV2 (k73 "viskata") ; --UNCHK
lin skybox_N = mkWN (k41A "laajakangas") ; --UNCHK
lin skycap_N = mkWN (k10 "kantaja") "lentoaseman" ; --UNCHK
lin skydiver_N = mkWN (compoundN "laskuvarjo" (k10 "hyppääjä")) ; --UNCHK
lin skydiving_N = mkWN (compoundN "lasku" (k38 "varjohyppääminen")) ; --UNCHK
lin skyhook_N = mkWN (compoundN "taivas" (k1A "koukku")) ; --UNCHK
lin skylark_N = mkWN (k1 "leivo") ; --UNCHK
lin skylark_V = mkWV (k68 "karkeloida") ; --UNCHK
lin skylight_N = mkWN (compoundN "katto" (k12 "ikkuna")) ; --UNCHK
lin skyline_N = mkWN (k5A "horisontti") "näennäinen" ; --UNCHK
lin skyrocket_N = mkWN (k5A "raketti") ; --UNCHK
lin skyrocket_V = mkWV (k66 "nousta") "pilviin" ;
lin skyrocket_V2 = mkWV2 (k66 "nousta") "pilviin" ; --UNCHK
lin skysail_N = mkWN (compoundN "pilvi" (k48 "purje")) ; --UNCHK
lin skyscraper_N = mkWN (compoundN "pilven" (k10 "piirtäjä")) ; --UNCHK
lin skywalk_N = mkWN (k9A "silta") ; --UNCHK
lin skyward_A = mkWA "taivaaseen" ; --UNCHK
lin skyward_Adv = mkWAdv (k99 "kohti") "taivasta" ; --UNCHK
lin skywards_Adv = mkWAdv (k99 "kohti") "taivasta" ; --UNCHK
lin skywriting_N = mkWN (compoundN "ilma" (k39 "kirjoitus")) ; --UNCHK
lin slab_N = mkWN (k1 "levy") ; --UNCHK
lin slack_A = mkWA (k10 "löyhä") ; --UNCHK
lin slack_N = mkN "velttous" ; ---ARB --mkWN (k27 "köysi") "höllä" ;
lin slack_V = mkWV (k53A "sammuttaa") "kalkki" ; --UNCHK
lin slack_off_V = mkWV (k52A "vähentyä") ; --UNCHK
lin slacken_V = mkWV (k53A "palauttaa") ; --UNCHK
lin slacken_V2 = mkWV2 (k53A "palauttaa") ; --UNCHK
lin slacken_off_V = mkWV (k52A "helpottua") ; --UNCHK
lin slacker_N = mkWN (k6 "pinnari") ; --UNCHK
lin slackness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin slag_N = mkWN (k10 "kuona") ; --UNCHK
lin slag_heap_N = mkWN (compoundN "kuona" (k9 "kasa")) ; --UNCHK
lin slake_V2 = mkWV2 (k53A "sammuttaa") "kalkki" ; --UNCHK
lin slalom_N = mkWN (k5 "slalom") ; --UNCHK
lin slam_N = mkWN (k39 "sivallus") ; --UNCHK
lin slam_V = mkWV (k53A "läimäyttää") ; --UNCHK
lin slam_V2 = mkWV2 (k53A "läimäyttää") ; --UNCHK
lin slam_dunk_V2 = mkV2 "donkata" ;
lin slammer_N = mkWN (k10 "putka") ; --UNCHK
lin slander_N = mkWN (k39 "mustamaalaus") ; --UNCHK
lin slander_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin slanderer_N = mkWN (k10 "parjaaja") ; --UNCHK
lin slanderous_A = mkWA (compoundA "must" (k9 "aava")) ; --UNCHK
lin slang_N = mkWN (k48A "murre") ; --UNCHK
lin slang_V2 = mkWV2 (k52A "haukkua") "karkeasti" ; --UNCHK
lin slanginess_N = mkWN "slangimaisuus" ; --UNCHK
lin slanguage_N = mkWN (k5 "slangi") ; --UNCHK
lin slangy_A = mkWA "slangi-" ; --UNCHK
lin slant_N = mkWN (k39 "kallistus") ; --UNCHK
lin slant_V = mkWV (k53A "painottaa") ; --UNCHK
lin slant_V2 = mkWV2 (k53A "painottaa") ; --UNCHK
lin slantingly_Adv = mkWAdv (compoundAdv "kallistun" (k5 "eesti")) ; --UNCHK
lin slantwise_Adv = mkWAdv (k99 "kallellaan") ; --UNCHK
lin slap_Adv = mkWAdv (k99 "päistikkaa") ; --UNCHK
lin slap_N = mkWN (k39 "läpsäytys") ; --UNCHK
lin slap_V2 = mkWV2 (k53A "läpsäyttää") ; --UNCHK
lin slapdash_A = mkWA (k34A "holtiton") ; --UNCHK
lin slapdash_Adv = mkWAdv (k99 "päistikkaa") ; --UNCHK
lin slapper_N = mkWN "läimijä" ; --UNCHK
lin slapshot_N = mkWN (k6 "lämäri") ; --UNCHK
lin slapstick_A = mkWA (compoundA "farssi" (k38 "mainen")) ; --UNCHK
lin slapstick_N = mkWN (compoundN "paukku" (k48A "laite")) ; --UNCHK
lin slash_N = mkN "viilto" ; ---ARB ; kauttaviiva
lin slash_V = mkWV (k53 "yksilöllistää") ; --UNCHK
lin slash_V2 = mkWV2 (k53 "yksilöllistää") ; --UNCHK
lin slasher_N = mkWN (compoundN "viilto" (k30 "veitsi")) ; --UNCHK
lin slat_N = mkWN (k9 "kiila") ; --UNCHK
lin slate_N = mkWN (compoundN "kivi" (k1 "taulu")) ; --UNCHK
lin slate_V2 = mkV2 "määrätä" ; ---??
lin slate_club_N = mkWN (compoundN "säästö" (k9 "kassa")) ; --UNCHK
lin slate_pencil_N = mkWN (compoundN "kivi" (k10 "kynä")) ; --UNCHK
lin slating_N = mkWN (compoundN "katon" (k1A "teko")) ; --UNCHK
lin slattern_N = mkWN (k1A "narttu") ; --UNCHK
lin slatternliness_N = mkWN "lutkamaisuus" ; --UNCHK
lin slatternly_A = mkWA (k14A "pönäkkä") ; --UNCHK
lin slaughter_N = mkWN (kH1 "lahti") ; --UNCHK
lin slaughter_V2 = mkWV2 (k73A "lahdata") ; --UNCHK
lin slaughterer_N = mkWN (k10 "teurastaja") ; --UNCHK
lin slaughterhouse_N = mkWN (k2 "teurastamo") ; --UNCHK
lin slav_A = mkWA (k38 "slaavilainen") ; --UNCHK
lin slav_N = mkWN (k5 "slaavi") ; --UNCHK
lin slave_N = mkWN (k10 "orja") ; --UNCHK
lin slave_V = mkWV (k67 "ponnistella") ; --UNCHK
lin slave_driver_N = mkWN (compoundN "orja" (k6 "piiskuri")) ; --UNCHK
lin slave_trade_N = mkWN (compoundN "orja" (k9A "kauppa")) ; --UNCHK
lin slave_traffic_N = mkWN (compoundN "orja" (k9A "kauppa")) ; --UNCHK
lin slaveholder_N = mkWN (compoundN "orjan" (k10 "omistaja")) ; --UNCHK
lin slaveholding_A = mkWA "orjia" "omistava" ; --UNCHK
lin slavelike_A = mkWA (k38 "orjamainen") ; --UNCHK
lin slaver_N = mkWN (compoundN "orjan" (k10 "omistaja")) ; --UNCHK
lin slaver_V = mkWV (k73 "kuolata") ; --UNCHK
lin slavery_N = mkWN (k40 "orjuus") ;
lin slavey_N = mkWN (k9A "piika") ; --UNCHK
lin slavish_A = mkWA (k10 "myöntyvä") "nöyrästi" ; --UNCHK
lin slavonic_A = mkWA (k38 "slaavilainen") ; --UNCHK
lin slaw_N = mkWN (compoundN "kaali" (k5A "salaatti")) ; --UNCHK
lin slay_V2 = mkWV2 (k73 "raivata") "tieltään" ; --UNCHK
lin slayer_N = mkWN (k10 "tappaja") ; --UNCHK
lin sleaford_PN = foreignPN "Sleaford" ;
lin sleaziness_N = mkWN (k40 "saastaisuus") ; --UNCHK
lin sleazy_A = mkWA (k38 "likainen") ; --UNCHK
lin sled_N = mkWN (k3 "ahkio") ; --UNCHK
lin sledder_N = mkWN (k12 "kelkkailija") ; --UNCHK
lin sledding_N = mkWN (k1 "meno") ; --UNCHK
lin sledge_N = mkWN (k10A "pulkka") | mkWN (k9A "kelkka") ;
lin sledge_V = mkWV (k58 "iskeä") "moukarilla" ; --UNCHK
lin sledge_V2 = mkWV2 (k58 "iskeä") "moukarilla" ; --UNCHK
lin sledgehammer_N = mkWN (k9 "leka") ; --UNCHK
lin sleek_A = mkWA (k38 "silkkinen") ; --UNCHK
lin sleek_V2 = mkWV2 (k53A "silittää") ; --UNCHK
lin sleekness_N = mkWN (k40 "kiiltävyys") ; --UNCHK
lin sleep_N = mkWN (k9 "rauha") ; --UNCHK
lin sleep_V = L.sleep_V ;
lin sleep_in_V = advV OP_sleep_V OP_in_Adv ; -- guess-p-verb
lin sleep_off_V2 = prepV2 OP_sleep_V OP_off_Prep ; -- guess-p-verb
lin sleep_on_V2 = prepV2 OP_sleep_V OP_on_Prep ; -- guess-p-verb
lin sleep_over_V = mkWV (k63 "jäädä") "yöksi" ; --UNCHK
lin sleep_through_V2 = prepV2 OP_sleep_V OP_through_Prep ; -- guess-p-verb
lin sleeper_N = mkWN (k39 "menestys") ; --UNCHK
lin sleepiness_N = mkWN (k40 "raukeus") ; --UNCHK
lin sleeping_A = mkA "nukkuva" ;
lin sleeping_N = mkWN (compoundN "nuk" (k38 "kuminen")) ; --UNCHK
lin sleeping_bag_N = mkWN (compoundN "makuu" (k5 "pussi")) ; --UNCHK
lin sleeping_car_N = mkWN (compoundN "makuu" (k1 "vaunu")) ; --UNCHK
lin sleeping_draught_N = mkWN (compoundN "uni" (k48A "lääke")) ; --UNCHK
lin sleeping_pill_N = mkWN (compoundN "uni" (k48A "lääke")) ; --UNCHK
lin sleeping_sickness_N = mkWN (k5A "tauti") "Von" "Economon" ; --UNCHK
lin sleepless_A = mkWA (k34A "väsymätön") ; --UNCHK
lin sleeplessness_N = mkWN (k40 "unettomuus") ; --UNCHK
lin sleepover_N = mkWN "yökyläily" ; --UNCHK
lin sleepwalker_N = mkWN (compoundN "unissa" (k12 "kävelijä")) ; --UNCHK
lin sleepwalking_N = mkWN (compoundN "unissa" (k2 "kävely")) ; --UNCHK
lin sleepy_A = mkWA (k41 "unelias") ; --UNCHK
lin sleepy_head_N = mkWN (compoundN "uni" (k1A "keko")) ; --UNCHK
lin sleet_N = mkWN (k48A "sade") "jäätävä" ; --UNCHK
lin sleet_V = mkWV (k56A "sataa") "räntää" ; --UNCHK
lin sleeve_N = mkWN (k9 "hiha") ; --UNCHK
lin sleeved_A = mkWA (k38 "hihallinen") ; --UNCHK
lin sleeveless_A = mkWA (k34A "hihaton") ; --UNCHK
lin sleigh_N = mkN "reki" "rekiä" ;
lin sleigh_V = mkWV (k56 "ajaa") "reellä" ; --UNCHK
lin sleigh_V2 = mkWV2 (k56 "ajaa") "reellä" ; --UNCHK
lin sleigh_bell_N = mkWN (k38 "kulkunen") ; --UNCHK
lin sleight_N = mkWN (k40 "taitavuus") ; --UNCHK
lin slender_A = mkWA (k9 "laiha") ; --UNCHK
lin slenderize_V = mkWV (k53A "laihduttaa") ; --UNCHK
lin slenderize_V2 = mkWV2 (k53A "laihduttaa") ; --UNCHK
lin slenderness_N = mkWN (k40 "solakkuus") ; --UNCHK
lin sleuth_N = mkWN (k10 "etsivä") ; --UNCHK
lin slew_V = mkWV (k52 "lipsua") ; --UNCHK
lin slew_V2 = mkWV2 (k52 "lipsua") ; --UNCHK
lin slice_N = mkWN "slicing" ; --UNCHK
lin slice_V = mkWV (k64 "lyödä") "kierteellä" ; --UNCHK
lin slice_V2 = mkWV2 (k64 "lyödä") "kierteellä" ; --UNCHK
lin slice_up_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin slicer_N = mkWN (compoundN "juusto" (k10 "höylä")) ; --UNCHK
lin slicing_N = mkWN (k5A "viipalointi") ; --UNCHK
lin slick_A = mkWA (k10 "näppärä") ; --UNCHK
lin slick_N = mkWN (k33A "hierrin") ; --UNCHK
lin slicker_N = mkWN (compoundN "öljykangas" (k5A "takki")) ; --UNCHK
lin slickness_N = mkWN (k40 "liukkaus") ; --UNCHK
lin slide_N = mkN "liukuminen" ; --f60
lin slide_V = mkV "liukua" ;
lin slide_V2 = mkWV2 (k52 "lipsua") ; --UNCHK
lin slide_rule_N = mkWN (compoundN "lasku" (k1A "tikku")) ; --UNCHK
lin slider_N = mkWN "slider" ; --UNCHK
lin slight_A = mkWA (k38 "vähäinen") ;
lin slight_N = mkWN (k39 "loukkaus") ; --UNCHK
lin slight_V2 = mkWV2 (k67A "kohdella") "kylmästi" ; --UNCHK
lin slightingly_Adv = mkWAdv (k99 "halventavasti") ; --UNCHK
lin slightness_N = mkWN (k40 "solakkuus") ; --UNCHK
lin sligo_PN = foreignPN "Sligo" ;
lin slim_A = mkWA (k9 "laiha") ;
lin slim_V = mkWV (k53A "laihduttaa") ; --UNCHK
lin slim_V2 = mkWV2 (k53A "laihduttaa") ; --UNCHK
lin slime_N = mkWN (k1A "törky") ; --UNCHK
lin slimed_A = mkWA (k41A "niljakas") ; --UNCHK
lin sliminess_N = mkWN (k40 "häijyys") ; --UNCHK
lin slimness_N = mkWN (k40 "solakkuus") ; --UNCHK
lin slimy_A = mkWA (k10 "katala") ; --UNCHK
lin sling_1_N = mkWN (compoundN "kolmio" (k9 "liina")) ; --UNCHK
lin sling_2_N = mkWN (compoundN "kolmio" (k9 "liina")) ; --UNCHK
lin sling_V = mkWV (k53A "sinkauttaa") ; --UNCHK
lin sling_V2 = mkWV2 (k53A "sinkauttaa") ; --UNCHK
lin slinger_N = mkWN (compoundN "linko" (k42 "mies")) ; --UNCHK
lin slinging_N = mkWN (compoundN "sinko" (k38 "aminen")) ; --UNCHK
lin slingshot_N = mkWN (k9 "ritsa") ; --UNCHK
lin slink_V = mkWV (k61A "hiipiä") ; --UNCHK
lin slip_N = mkN "erehdys" ;
lin slip_V = mkV "luisua" ; --f52
lin slip_V2 = mkV2 "luiskahtaa" ; ----
lin slip_away_V = mkWV (k53A "hurahtaa") ; --UNCHK
lin slip_by_V = mkWV (k53A "hurahtaa") ; --UNCHK
lin slip_carriage_N = mkWN "slip" "carriage" ; --UNCHK
lin slip_coach_N = mkWN "slip" "carriage" ; --UNCHK
lin slip_down_V = advV OP_slip_V OP_down_Adv ; -- guess-p-verb
lin slip_in_V2 = mkWV2 (k73 "lisätä") "väliin" ; --UNCHK
lin slip_into_V2 = prepV2 OP_slip_V OP_into_Prep ; -- guess-p-verb
lin slip_off_V = mkWV (k52A "riisuutua") ; --UNCHK
lin slip_off_V2 = mkWV2 (k52A "riisuutua") ; --UNCHK
lin slip_off_to_V2 = prepV2 (advV OP_slip_V OP_off_Adv ) OP_to_Prep ; -- guess-p-verb
lin slip_on_V2 = mkWV2 (k53A "pujahtaa") ; --UNCHK
lin slip_out_V = advV OP_slip_V OP_out_Adv ; -- guess-p-verb
lin slip_road_N = mkWN (compoundN "sisääntulo" (k19 "tie")) ; --UNCHK
lin slip_up_V = mkWV (k53A "kömmähtää") ; --UNCHK
lin slipcover_N = mkWN (compoundN "irto" (k38 "päällinen")) ; --UNCHK
lin slipknot_N = mkWN (compoundN "veto" (k1 "solmu")) ; --UNCHK
lin slipover_N = mkWN (k2 "pusero") ; --UNCHK
lin slippage_N = mkWN (compoundN "luisu" (k3 "häviö")) ; --UNCHK
lin slipper_N = mkWN (k1 "tossu") ; --UNCHK
lin slipperiness_N = mkWN (k40 "kierous") ; --UNCHK
lin slippery_A = mkWA (k38 "iljanteinen") ; --UNCHK
lin slippy_A = mkWA (k38 "iljanteinen") ; --UNCHK
lin slipshod_A = mkWA (k34A "holtiton") ; --UNCHK
lin slipstream_N = mkWN (k9A "virta") "voimakas" ; --UNCHK
lin slipway_N = mkWN (compoundN "vesillelasku" (k5A "ramppi")) ; --UNCHK
lin slit_N = mkWN (k1A "rako") ; --UNCHK
lin slit_V2 = mkWV2 (k54A "viiltää") ; --UNCHK
lin slither_V = mkWV (k53A "pujahtaa") ; --UNCHK
lin slithery_A = mkWA (k41A "niljakas") ; --UNCHK
lin sliver_N = mkWN (k1 "lastu") ; --UNCHK
lin sliver_V = mkWV (k52 "pirstoa") ; --UNCHK
lin sliver_V2 = mkWV2 (k52 "pirstoa") ; --UNCHK
lin slivovitz_N = mkWN (k5 "slivovits") ; --UNCHK
lin slob_N = mkWN (k6 "laiskuri") ; --UNCHK
lin slobber_N = mkWN (k7A "sylki") ; --UNCHK
lin slobber_V = mkWV (k73 "kuolata") ; --UNCHK
lin slobber_V2 = mkWV2 (k73 "kuolata") ; --UNCHK
lin sloe_N = mkWN (k9 "marja") "oratuomen" ; --UNCHK
lin sloe_gin_N = mkWN (compoundN "luumu" (k6 "likööri")) ; --UNCHK
lin slog_V = mkWV (k58 "iskeä") ; --UNCHK
lin slog_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin slogan_N = mkN "isku" (mkN "lause") ; --mkWN (k5 "fraasi") ;
lin sloganeer_N = mkWN (compoundN "iskulause" (k12 "tehtailija")) ; --UNCHK
lin sloganeering_N = mkWN (k1A "käyttö") "iskulauseiden" ; --UNCHK
lin slogger_N = mkWN "slogger" ; --UNCHK
lin sloop_N = mkWN "sluuppi" ; --UNCHK
lin slop_N = mkWN (k5A "siirappi") ; --UNCHK
lin slop_V = mkWV (k61A "ruokkia") "sikoja" ; --UNCHK
lin slop_V2 = mkWV2 (k61A "ruokkia") "sikoja" ; --UNCHK
lin slop_basin_N = mkWN (compoundN "huuhtelu" (k12 "astia")) ; --UNCHK
lin slop_pail_N = mkWN (compoundN "lika" (k1A "sanko")) ; --UNCHK
lin slope_N = mkN "luiska" ; --mkWN (k40 "kaltevuus") ;
lin slope_V = mkV "viettää" ;
lin slopingly_Adv = mkWAdv (compoundAdv "kallistun" (k5 "eesti")) ; --UNCHK
lin sloppiness_N = mkWN (k40 "tunteellisuus") ; --UNCHK
lin sloppy_A = mkWA (k34A "holtiton") ; --UNCHK
lin slopseller_N = mkWN (compoundN "valmisvaate" (k10 "myyjä")) ; --UNCHK
lin slop_shop_N = mkWN (compoundN "vaatetus" (k48A "liike")) "halpa" ; --UNCHK
lin slosh_V = mkWV (k61 "loiskia") ; --UNCHK
lin slosh_V2 = mkWV2 (k61 "loiskia") ; --UNCHK
lin slot_N = mkN "kolo" ;
lin slot_V2 = mkWV2 (k53A "asettaa") "paikalleen" ; --UNCHK
lin slot_machine_N = mkWN (compoundN "myynti" (k5A "automaatti")) ; --UNCHK
lin sloth_N = mkWN (k40 "velttous") ; --UNCHK
lin slothful_A = mkWA (k1A "veltto") ; --UNCHK
lin slouch_N = mkWN (k5A "ryhti") "kumara" ; --UNCHK
lin slouch_V = mkWV (k53 "rahjustaa") ; --UNCHK
lin slouch_hat_N = mkWN (k1A "hattu") "lerppalierinen" ; --UNCHK
lin sloucher_N = mkWN (k10 "kumara") ; --UNCHK
lin slouchingly_Adv = mkWAdv "retkottaen" ; --UNCHK
lin slouchy_A = mkWA "lerpattava" ; --UNCHK
lin slough_N = mkWN (kH1 "kuori") "vanha" ; --UNCHK
lin slough_PN = foreignPN "Slough" ;
lin slough_V = mkWV (k64 "luoda") "nahkansa" ; --UNCHK
lin slough_V2 = mkWV2 (k64 "luoda") "nahkansa" ; --UNCHK
lin slough_off_V2 = mkWV2 (k64 "luoda") "nahkansa" ; --UNCHK
lin slovak_N = mkWN "slovakia" ; --UNCHK
lin sloven_N = mkWN (k6 "laiskuri") ; --UNCHK
lin slovenian_A = mkWA (k38 "slovenialainen") ; --UNCHK
lin slovenian_N = mkWN (k6 "sloveeni") ; --UNCHK
lin slovenliness_N = mkWN (compoundN "epä" (k40 "siisteys")) ; --UNCHK
lin slovenly_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin slow_A = mkWA (k41A "hidas") ; --f115
lin slow_Adv = mkWAdv (k99 "hitaasti") ; --UNCHK
lin slow_V = mkV "hidastaa" ;
lin slow_V2 = mkWV2 (k53A "jarruttaa") ; --UNCHK
lin slow_down_V = mkWV (k52A "rauhoittua") ; --UNCHK
lin slow_down_V2 = mkWV2 (k52A "rauhoittua") ; --UNCHK
lin slow_up_V2 = mkWV2 (k53A "jarruttaa") ; --UNCHK
lin slowcoach_N = mkWN (k12 "kuhnailija") ; --UNCHK
lin slowdown_N = mkWN (k48 "viive") ; --f67
lin slower_Adv = mkWAdv "hitaammin" ; --UNCHK
lin slowest_Adv = mkWAdv "hitaimmin" ; --UNCHK
lin slowgoing_A = mkWA (k34A "tarmoton") ; --UNCHK
lin slowness_N = mkWN (k40 "kiireettömyys") ; --UNCHK
lin slub_N = mkWN (k1A "nyppy") ; --UNCHK
lin sludge_N = mkWN (k48A "liete") ; --UNCHK
lin slug_N = mkWN (k5 "tälli") ; --UNCHK
lin slug_V = mkWV (k58 "iskeä") ; --UNCHK
lin slug_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin sluggard_N = mkWN (k39 "laiskimus") ; --UNCHK
lin slugger_N = mkWN (k10 "lyöjä") ; --UNCHK
lin sluggish_A = mkWA (k1A "veltto") ;
lin sluggishness_N = mkWN (k40 "latteus") ; --UNCHK
lin sluice_N = mkWN (k10 "kanava") ; --UNCHK
lin sluice_V = mkWV (k52A "huuhtoutua") ; --UNCHK
lin sluice_V2 = mkWV2 (k52A "huuhtoutua") ; --UNCHK
lin sluice_valve_N = mkWN (k1A "sulku") ; --UNCHK
lin sluicegate_N = mkWN (k1A "sulku") ; --UNCHK
lin slum_N = mkWN (k5 "slummi") ; --UNCHK
lin slum_V = mkWV (k67 "köyhäillä") ; --UNCHK
lin slumber_N = mkWN (k24 "uni") ; --UNCHK
lin slumber_V = mkWV (k52A "torkkua") ; --UNCHK
lin slumber_V2 = mkWV2 (k52A "torkkua") ; --UNCHK
lin slumberer_N = mkWN (k10 "nukkuja") ; --UNCHK
lin slumberous_A = mkWA (k15 "raukea") ; --UNCHK
lin slumgullion_N = mkWN (k1 "litku") ; --UNCHK
lin slummy_A = mkWA (compoundA "slummi" (k38 "mainen")) ; --UNCHK
lin slump_N = mkN "romahdus" ; --WN (k39 "pudotus") ;
lin slump_V = mkWV (k72 "vähetä") ; --UNCHK
lin slump_V2 = mkWV2 (k72 "vähetä") ; --UNCHK
lin slur_N = mkWN (k7A "jälki") ; --UNCHK
lin slur_V = mkWV (k52A "hämärtyä") ; --UNCHK
lin slur_V2 = mkWV2 (k52A "hämärtyä") ; --UNCHK
lin slurry_N = mkWN (k48A "liete") ; --UNCHK
lin slush_N = mkWN (k1 "sohjo") ; --UNCHK
lin slushy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin slut_N = mkWN (k1A "narttu") ; --UNCHK
lin sluttish_A = mkWA (k41A "rietas") ; --UNCHK
lin sly_A = mkWA (k10 "näppärä") ; --UNCHK
lin slyness_N = mkWN (k40 "kierous") ; --UNCHK
lin smack_Adv = mkWAdv (k99 "päistikkaa") ; --UNCHK
lin smack_N = mkWN (k39 "läpsäytys") ; --UNCHK
lin smack_V = mkWV (k53A "mässyttää") ; --UNCHK
lin smack_V2 = mkWV2 (k53A "mässyttää") ; --UNCHK
lin smacker_N = mkWN (k39 "täräys") ; --UNCHK
lin smacking_N = mkWN (k39 "läpsäytys") ; --UNCHK
lin small_A = L.small_A ;
lin small_Adv = mkWAdv (k99 "vaatimattomasti") ; --UNCHK
lin small_N = mkWN (kH1 "koko") "pieni" ; --UNCHK
lin smaller_A = mkWA "pienempi" ; --UNCHK
lin smallholder_N = mkWN (compoundN "pientalon" (k10A "poika")) ; --UNCHK
lin smallholding_N = mkWN (compoundN "pien" (k9 "tila")) ; --UNCHK
lin smallish_A = mkWA "pienehkö" ; --UNCHK
lin smallmouth_N = mkWN "Micropterus" "dolomieu" ; --UNCHK
lin smallness_N = mkWN (k40 "halpamaisuus") ; --UNCHK
lin smallpox_N = mkWN (k51 "isorokko") ; --UNCHK
lin smaltite_N = mkWN "smaltiitti" ; --UNCHK
lin smarmy_A = mkWA (k15 "mairea") ; --UNCHK
lin smart_A = mkWA (k10 "terävä") ; --UNCHK
lin smart_N = mkWN (k10 "tuska") ; --UNCHK
lin smart_V = mkWV (k52A "sattua") ; --UNCHK
lin smarta_N = mkWN "smarta" ; --UNCHK
lin smartness_N = mkWN (k1A "into") ; --UNCHK
lin smash_Adv = mkWAdv "räsähtävästi" ; --UNCHK
lin smash_N = mkN "törmäys" ; ---ARB
lin smash_V = mkWV (k71 "tehdä") "loppu" ; --UNCHK
lin smash_V2 = mkWV2 (k71 "tehdä") "loppu" ; --UNCHK
lin smash_up_V2 = mkWV2 (k58A "särkeä") ; --UNCHK
lin smasher_N = mkWN (k39 "menestys") ; --UNCHK
lin smashing_N = mkWN (compoundN "murska" (k38 "aminen")) ; --UNCHK
lin smattering_N = mkN "hitunen" ;
lin smear_N = mkWN (k10A "läikkä") ; --UNCHK
lin smear_V = mkWV (k73A "liata") ; --UNCHK
lin smear_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin smear_word_N = mkWN (k2 "panettelu") ; --UNCHK
lin smedsby_PN = mkPN "Sepänkylä" ;
lin smegma_N = mkWN (compoundN "esinahka" (k5 "tali")) ; --UNCHK
lin smell_N = mkWN (compoundN "hai" (k38 "staminen")) ; --UNCHK
lin smell_V = L.smell_V ;
lin smell_V2 = mkWV2 (k69 "havaita") ; --UNCHK
lin smell_VA = mkWVA (k69 "havaita") ; --UNCHK
lin smelling_bottle_N = mkWN (compoundN "haju" (k1 "pullo")) ; --UNCHK
lin smelly_A = mkWA (k38 "tunkkainen") ; --UNCHK
lin smelt_N = mkWN (k48 "kuore") ; --UNCHK
lin smelt_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin smelter_N = mkWN (k1A "sulatto") ; --UNCHK
lin smew_N = mkWN (k2 "uivelo") ; --UNCHK
lin smilax_N = mkWN "Asparagus" "asparagoides" ; --UNCHK
lin smile_N = mkWN (k39 "virnistys") ; --UNCHK
lin smile_V = mkWV (k67 "hymyillä") ;
lin smiler_N = mkWN (kH1 "turpa") ; --UNCHK
lin smiley_N = mkWN (k3 "hymiö") "hymyilevä" ; --UNCHK
lin smilingly_Adv = mkWAdv "hymyilevästi" ; --UNCHK
lin smilo_N = mkWN "Oryzopsis" "miliacea" ; --UNCHK
lin smirch_N = mkWN (k10A "läikkä") ; --UNCHK
lin smirch_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin smirk_N = mkWN (k39 "virnistys") ; --UNCHK
lin smirk_V = mkWV (k67 "hymyillä") "teennäisesti" ; --UNCHK
lin smirker_N = mkWN (compoundN "hymyi" (k10 "levä")) "omahyväisesti" ; --UNCHK
lin smite_V = mkWV (k73 "vaivata") ; --UNCHK
lin smite_V2 = mkWV2 (k73 "vaivata") ; --UNCHK
lin smith_N = mkWN (k10A "seppä") ; --UNCHK
lin smithereens_N = mkWN (k10 "murska") ; --UNCHK
lin smithy_N = mkWN (k2 "takomo") ; --UNCHK
lin smock_N = mkWN (k12 "kauhtana") ; --UNCHK
lin smocking_N = mkWN (k39 "rypytys") ; --UNCHK
lin smog_N = mkWN (compoundN "savu" (k1 "sumu")) ; --UNCHK
lin smoggy_A = mkWA (k38 "sumuinen") ; --UNCHK
lin smoke_N = L.smoke_N ;
lin smoke_V = mkWV (k68 "tupakoida") ;
lin smoke_V2 = mkV2 "savustaa" | mkV2 "polttaa" ; --- split -- | smoke fish -- | smoke a cigarette
lin smoke_bomb_N = mkWN (compoundN "savu" (k5A "kranaatti")) ; --UNCHK
lin smoke_out_V2 = mkWV2 (k53 "savustaa") ; --UNCHK
lin smoke_screen_N = mkWN (compoundN "savu" (k1 "verho")) ; --UNCHK
lin smokehouse_N = mkWN (k2 "savustamo") ; --UNCHK
lin smokeless_A = mkWA (k34A "savuton") ; --UNCHK
lin smoker_N = mkN "tupakoitsija" ; --mkWN (compoundN "tupakka" (k1 "vaunu")) ;
lin smokestack_N = mkWN (compoundN "savu" (k7 "torvi")) ; --UNCHK
lin smoking_N = mkWN (k5A "tupakointi") ; --UNCHK
lin smoking_car_N = mkWN (compoundN "tupakka" (k1 "vaunu")) ; --UNCHK
lin smoking_carriage_N = mkWN (compoundN "tupakka" (k1 "vaunu")) ; --UNCHK
lin smoking_compartment_N = mkWN (compoundN "tupakka" (k1 "vaunu")) ; --UNCHK
lin smoking_mixture_N = mkWN (compoundN "piipputupakka" (k39 "sekoitus")) ; --UNCHK
lin smoking_room_N = mkWN (compoundN "tupakka" (k48 "huone")) ; --UNCHK
lin smoky_A = mkWA (k38 "savuinen") ; --UNCHK
lin smoldering_A = mkWA (compoundA "kyt" (k10 "evä")) ; --UNCHK
lin smooth_A = L.smooth_A ;
lin smooth_N = mkWN (compoundN "sil" (k2 "ottelu")) ; --UNCHK
lin smooth_V = mkWV (k53A "kiillottaa") ; --UNCHK
lin smooth_V2 = mkWV2 (k53A "kiillottaa") ; --UNCHK
lin smooth_out_V = mkWV (k53A "selvittää") ; --UNCHK
lin smoothbark_N = mkWN "smoothbark" ; --UNCHK
lin smoothbore_N = mkWN (k48 "ase") "sileäputkinen" ; --UNCHK
lin smoothhound_N = mkWN (k18 "hai") ; --UNCHK
lin smoothing_iron_N = mkWN (compoundN "silitys" (k9A "rauta")) ; --UNCHK
lin smoothing_plane_N = mkWN (compoundN "silotus" (k10 "höylä")) ; --UNCHK
lin smoothness_N = mkWN (k40 "tasaisuus") ; --UNCHK
lin smorgasbord_N = mkWN (compoundN "voileipä" (k10A "pöytä")) ; --UNCHK
lin smother_N = mkWN (k1 "savu") "tukehduttava" ; --UNCHK
lin smother_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin smothering_A = mkWA "tukehduttava" ; --UNCHK
lin smoulder_N = mkWN (k23 "tuli") "kytevä" ; --UNCHK
lin smoulder_V = mkWV (k58A "kyteä") ; --UNCHK
lin smudge_N = mkWN (k7A "jälki") ; --UNCHK
lin smudge_V = mkWV (k73 "tahrata") ; --UNCHK
lin smudge_V2 = mkWV2 (k73 "tahrata") ; --UNCHK
lin smudgy_A = mkWA (k38 "tuhruinen") ; --UNCHK
lin smug_A = mkWA (k38 "itseriittoinen") ; --UNCHK
lin smuggle_V2 = mkWV2 (compoundV "sala" (k53A "kuljettaa")) ; --UNCHK
lin smuggler_N = mkWN (compoundN "sala" (k10 "kuljettaja")) ; --UNCHK
lin smuggling_N = mkWN (compoundN "sala" (k39 "kuljetus")) ; --UNCHK
lin smugness_N = mkWN (k40 "omahyväisyys") ; --UNCHK
lin smut_N = mkWN (k40 "kirjallisuus") "eroottinen" ; --UNCHK
lin smut_V2 = mkWV2 (k74A "noeta") ; --UNCHK
lin smuttiness_N = mkWN (k40 "hävyttömyys") ; --UNCHK
lin smutty_A = mkWA (k38 "nokinen") ; --UNCHK
lin snack_N = mkN "välipala" ;
lin snack_bar_N = mkWN (compoundN "asema" (k12 "ravintola")) ; --UNCHK
lin snack_counter_N = mkWN (compoundN "asema" (k12 "ravintola")) ; --UNCHK
lin snaffle_V2 = mkWV2 (k53A "käyttää") "nivelkuolaimia" ; --UNCHK
lin snafu_N = mkWN "snafu" ; --UNCHK
lin snag_N = mkN "ongelma" ; ---ARB --mkWN (k2 "koukero") ;
lin snag_V = mkWV (k73 "törmätä") ; --UNCHK
lin snag_V2 = mkWV2 (k73 "törmätä") ; --UNCHK
lin snail_N = mkWN (k12 "etana") ; --UNCHK
lin snailfish_N = mkWN (compoundN "imu" (k9 "kala")) ; --UNCHK
lin snake_N = L.snake_N ;
lin snake_V = mkWV (k67A "pujotella") ; --UNCHK
lin snake_charmer_N = mkWN (compoundN "käärmeen" (k10 "lumooja")) ; --UNCHK
lin snakebird_N = mkWN (compoundN "käärme" (k9 "kaula")) ; --UNCHK
lin snakebite_N = mkWN (compoundN "käärmeen" (k10 "purema")) ; --UNCHK
lin snakeblenny_N = mkWN "Lumpenus" "lumpretaeformis" ; --UNCHK
lin snakefly_N = mkWN (compoundN "käärme" (k1A "korento")) ; --UNCHK
lin snakewood_N = mkWN (compoundN "serpen" (k9 "tina")) "Rauwolfia" ; --UNCHK
lin snaky_A = mkWA (k41A "mutkikas") ; --UNCHK
lin snap_N = mkWN (compoundN "aloitus" (k1A "syöttö")) ; --UNCHK
lin snap_V = mkWV (k67 "rakoilla") ; --UNCHK
lin snap_V2 = mkWV2 (k67 "rakoilla") ; --UNCHK
lin snap_back_V = mkWV (k52A "parantua") ; --UNCHK
lin snap_fastener_N = mkWN (k6 "neppari") ; --UNCHK
lin snap_off_V2 = mkWV2 (k54A "murtaa") ; --UNCHK
lin snap_out_of_V2 = prepV2 (advV OP_snap_V OP_out_Adv ) OP_of_Prep ; -- guess-p-verb
lin snap_to_it_V2 = variants {} ; -- guess-p-verb
lin snap_up_V2 = mkWV2 (k73A "siepata") ; --UNCHK
lin snapdragon_N = mkWN (compoundN "leijonan" (k9A "kita")) ; --UNCHK
lin snapper_N = mkWN (compoundN "serpen" (k9 "tina")) "Chelydra" ; --UNCHK
lin snappish_A = mkWA (k10 "ärtyisä") ; --UNCHK
lin snappishness_N = mkWN (k40 "äreys") ; --UNCHK
lin snappy_A = mkWA (k15 "nopea") ; --UNCHK
lin snapshot_N = mkWN (k39 "näpäys") ; --UNCHK
lin snare_N = mkWN (k33A "sadin") ; --UNCHK
lin snare_V2 = mkWV2 (k63 "saada") "koukkuun" ; --UNCHK
lin snare_drum_N = mkWN (kH1 "virveli") ; --UNCHK
lin snarer_N = mkWN "ansastaja" ; --UNCHK
lin snarl_N = mkWN (k7A "vyyhti") ; --UNCHK
lin snarl_V = mkWV (k52A "sotkeutua") ; --UNCHK
lin snarl_V2 = mkWV2 (k52A "sotkeutua") ; --UNCHK
lin snarl_up_V2 = mkWV2 (k52A "sotkeutua") ; --UNCHK
lin snatch_N = mkWN (k2 "kouraisu") ; --UNCHK
lin snatch_V = mkWV (k73A "siepata") ; --UNCHK
lin snatch_V2 = mkWV2 (k73A "siepata") ; --UNCHK
lin snatcher_N = mkWN (k10 "kidnappaaja") ; --UNCHK
lin snazzy_A = mkWA (k15 "upea") ; --UNCHK
lin sneak_N = mkWN (k10 "visertäjä") ; --UNCHK
lin sneak_V = mkWV (k67A "hipsutella") ; --UNCHK
lin sneak_V2 = mkWV2 (k67A "hipsutella") ; --UNCHK
lin sneak_out_V = mkWV (k67 "hiippailla") "ulos" ; --UNCHK
lin sneak_thief_N = mkWN (k12 "näpistelijä") ; --UNCHK
lin sneakingly_Adv = mkWAdv (k99 "salaisesti") ; --UNCHK
lin sneaky_A = mkWA (k38 "vaivihkainen") ; --UNCHK
lin sneer_N = mkWN (k39 "silmäys") ; --UNCHK
lin sneer_V = mkWV (k67 "virnuilla") ; --UNCHK
lin sneerer_N = mkWN (k10 "pilkkaaja") ; --UNCHK
lin sneeringly_Adv = mkWAdv (k99 "ylimielisesti") ; --UNCHK
lin sneeze_N = mkWN (k39 "aivastus") ; --UNCHK
lin sneeze_V = mkWV (k53 "aivastaa") ; --UNCHK
lin sneezer_N = mkWN "aivastelija" ; --UNCHK
lin sneezeweed_N = mkWN (compoundN "hohde" (k10A "kukka")) ; --UNCHK
lin snick_N = mkWN (k39 "näpäytys") ; --UNCHK
lin snick_V = mkWV (k66 "nirhaista") ; --UNCHK
lin snick_V2 = mkWV2 (k66 "nirhaista") ; --UNCHK
lin snicker_N = mkWN (k39 "tirskahdus") ; --UNCHK
lin snicker_V = mkWV (k52 "tirskua") ; --UNCHK
lin snide_A = mkWA (k38 "pilkallinen") ; --UNCHK
lin sniff_N = mkWN (k2 "haistelu") ; --UNCHK
lin sniff_V = mkWV (k66 "tuhista") ; --UNCHK
lin sniff_V2 = mkWV2 (k66 "tuhista") ; --UNCHK
lin sniff_out_V2 = mkWV2 (k74 "vaistota") ; --UNCHK
lin sniffer_N = mkWN "niiskuttaja" ; --UNCHK
lin sniffle_V = mkWV (k66 "tuhista") ; --UNCHK
lin sniffler_N = mkWN (compoundN "tuhi" (k9 "sija")) ; --UNCHK
lin sniffly_A = mkWA (compoundA "nuuh" (k9 "kiva")) ; --UNCHK
lin sniffy_A = mkWA (k15 "ylpeä") ; --UNCHK
lin snifter_N = mkWN (compoundN "aromi" (k5 "lasi")) ; --UNCHK
lin snigger_N = mkWN (k39 "tirskahdus") ; --UNCHK
lin snigger_V = mkWV (k52 "tirskua") ; --UNCHK
lin snip_N = mkWN (compoundN "lei" (k38 "kkaaminen")) ; --UNCHK
lin snip_V = mkWV (k61 "oksia") ; --UNCHK
lin snip_V2 = mkWV2 (k61 "oksia") ; --UNCHK
lin snipe_N = mkWN (k39 "laukaus") "sala-ampujan" ; --UNCHK
lin snipe_V = mkWV (k67A "piikitellä") ; --UNCHK
lin snipe_V2 = mkWV2 (k67A "piikitellä") ; --UNCHK
lin snipefish_N = mkWN (compoundN "torvi" (k9 "kala")) ; --UNCHK
lin sniper_N = mkWN (k50 "tarkka-ampuja") ; --UNCHK
lin snippet_N = mkWN (k10 "pätkä") ; --UNCHK
lin snipping_N = mkWN (k10 "pätkä") ; --UNCHK
lin snit_N = mkWN (compoundN "kiukun" (k10 "puuska")) ; --UNCHK
lin snitch_V = mkWV (k62 "vasikoida") ; --UNCHK
lin snitch_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin snivel_N = mkWN (k12 "tuhina") ; --UNCHK
lin snivel_V = mkWV (k61 "nyyhkiä") ; --UNCHK
lin sniveller_N = mkWN (k12 "marisija") ; --UNCHK
lin snob_N = mkWN (k5 "snobi") ; --UNCHK
lin snobbery_N = mkWN (k5A "keikarointi") ; --UNCHK
lin snobbish_A = mkWA (k38 "nurkkakuntainen") ; --UNCHK
lin snobbishness_N = mkWN (k5A "keikarointi") ; --UNCHK
lin snog_V = mkWV (k73 "pussata") ; --UNCHK
lin snogging_N = mkWN (k2 "pussailu") ; --UNCHK
lin snood_N = mkWN (compoundN "hius" (k1A "verkko")) ; --UNCHK
lin snook_N = mkWN "snook" ; --UNCHK
lin snooker_N = mkWN (k6 "biljardi") ; --UNCHK
lin snoop_N = mkWN (k12 "urkkija") ; --UNCHK
lin snoop_V = mkWV (k61A "urkkia") ; --UNCHK
lin snooper_N = mkWN (k12 "urkkija") ; --UNCHK
lin snootiness_N = mkWN (k40 "nokkavuus") ; --UNCHK
lin snooty_A = mkA (mkN "yli" (mkN "mielinen")) ;
lin snooze_V = mkWV (k52A "nuokkua") ; --UNCHK
lin snore_N = mkWN (k12 "korina") ; --UNCHK
lin snore_V = mkWV (k67A "vedellä") "hirsiä" ; --UNCHK
lin snorer_N = mkWN (compoundN "kuor" (k10 "saaja")) ; --UNCHK
lin snorkel_N = mkWN (k6 "snorkkeli") ; --UNCHK
lin snort_N = mkWN (k39 "tuhahdus") ; --UNCHK
lin snort_V = mkWV (k53A "tuhahtaa") ; --UNCHK
lin snort_V2 = mkWV2 (k53A "tuhahtaa") ; --UNCHK
lin snort_VS = mkWVS (k53A "tuhahtaa") ; --UNCHK
lin snorter_N = mkWN "pläjäys" ; --UNCHK
lin snorty_A = mkWA (k38 "kiukkuinen") ; --UNCHK
lin snot_N = mkWN (k10A "räkä") ; --UNCHK
lin snotty_A = mkWA (k38 "räkäinen") ; --UNCHK
lin snout_N = mkWN (k10A "nokka") ; --UNCHK
lin snow_N = L.snow_N ;
lin snow_V = mkWV (k73 "puliveivata") ; --UNCHK
lin snow_V2 = mkWV2 (k73 "puliveivata") ; --UNCHK
lin snow_line_N = mkWN (k9 "lumiraja") ; --UNCHK
lin snowball_N = mkWN (compoundN "lumi" (k1 "pallo")) ; --UNCHK
lin snowball_V = mkWV (k52 "paisua") ; --UNCHK
lin snowball_V2 = mkWV2 (k52 "paisua") ; --UNCHK
lin snowbank_N = mkWN (k39 "kinos") ; --UNCHK
lin snowbell_N = mkWN "Styrax" "obassia" ; --UNCHK
lin snowberry_N = mkWN (k9 "alba") "Symphoricarpos" ; --UNCHK
lin snowblindness_N = mkWN (compoundN "lumi" (k40 "sokeus")) ; --UNCHK
lin snowboard_N = mkWN (compoundN "lumi" (k9A "lauta")) ; --UNCHK
lin snowboarder_N = mkWN (compoundN "lumi" (k12 "lautailija")) ; --UNCHK
lin snowboarding_N = mkWN (compoundN "lumi" (k2 "lautailu")) ; --UNCHK
lin snowbound_A = mkWA (compoundA "juu" (k47 "ttunut")) "kinoksiin" ; --UNCHK
lin snowcap_N = mkWN (kH1 "laki") "luminen" ; --UNCHK
lin snowdrift_N = mkWN (k39 "nietos") ; --UNCHK
lin snowdrop_N = mkWN (compoundN "balkanin" (k1A "vuokko")) ; --UNCHK
lin snowfall_N = mkWN (k25 "lumi") ; --UNCHK
lin snowfield_N = mkWN (compoundN "lumi" (k40 "lakeus")) ; --UNCHK
lin snowflake_N = mkWN (k38 "pulmunen") ; --UNCHK
lin snowman_N = mkWN (compoundN "lumi" (k1A "ukko")) ; --UNCHK
lin snowmobile_N = mkWN (compoundN "moottori" (k9A "kelkka")) ; --UNCHK
lin snowplough_N = mkWN (kH1 "aura") ; --UNCHK
lin snowplow_N = mkWN (kH1 "aura") ; --UNCHK
lin snowshoe_N = mkWN (compoundN "lumi" (k10A "kenkä")) ; --UNCHK
lin snowstorm_N = mkWN (k14A "myräkkä") ; --UNCHK
lin snowsuit_N = mkWN (compoundN "talvi" (k6 "haalari")) ; --UNCHK
lin snub_A = mkWA "pysty-" ; --UNCHK
lin snub_N = mkWN (k2 "kohtelu") "kylmä" ; --UNCHK
lin snub_V2 = mkWV2 (k53 "kiistää") ; --UNCHK
lin snuff_A = mkWA (compoundA "nuuskan" (k15 "ruskea")) ; --UNCHK
lin snuff_N = mkWN (k2 "haistelu") ; --UNCHK
lin snuff_V = mkWV (k61 "nuuskia") ; --UNCHK
lin snuff_V2 = mkWV2 (k61 "nuuskia") ; --UNCHK
lin snuff_out_V2 = mkWV2 (k71 "tehdä") "loppu" ; --UNCHK
lin snuffbox_N = mkWN (compoundN "nuuska" (k12 "rasia")) ; --UNCHK
lin snuffer_N = mkWN (compoundN "kynttilän" (k10 "sammuttaja")) ; --UNCHK
lin snuffle_N = mkWN (k12 "tuhina") ; --UNCHK
lin snuffle_V = mkWV (k61 "nyyhkiä") ; --UNCHK
lin snuffler_N = mkWN (compoundN "tuhi" (k9 "sija")) ; --UNCHK
lin snug_A = mkWA (k10 "kotoisa") ; --UNCHK
lin snug_N = mkWN (k9A "paikka") "mukava" ; --UNCHK
lin snuggery_N = mkWN (k9A "paikka") "mukava" ; --UNCHK
lin snugness_N = mkWN (k40 "mukavuus") ; --UNCHK
lin so_AdA = S.so_AdA ;
lin so_Adv = mkAdv "niin" ;
lin so_N = mkWN "sol" ;
lin so_PConj = mkPConj "niinpä" ;
lin so_Subj = mkSubj "niin että" ;
lin so_called_A = mkA "niinsanottu" ;
lin so_so_A = mkA "kohtalainen" ;
lin soak_N = mkWN (k39 "liotus") ; --UNCHK
lin soak_V = mkWV (k56 "kastaa") ; --UNCHK
lin soak_V2 = mkWV2 (k56 "kastaa") ; --UNCHK
lin soak_up_V = mkWV (k52A "hautautua") ; --UNCHK
lin soaker_N = mkWN (k6 "juomari") ; --UNCHK
lin soaking_Adv = mkWAdv (compoundAdv "valu" (k9 "vana")) "vettä" ; --UNCHK
lin soap_N = mkWN (k12 "saippua") ;
lin soap_V2 = mkWV2 (k53A "vaahdottaa") ; --UNCHK
lin soap_bubble_N = mkWN (compoundN "saippua" (k10 "kupla")) ; --UNCHK
lin soap_opera_N = mkWN (compoundN "saippua" (k9 "sarja")) ; --UNCHK
lin soapberry_N = mkWN (compoundN "saippua" (k9 "marja")) ; --UNCHK
lin soapbox_N = mkWN (k48A "koroke") ; --UNCHK
lin soapfish_N = mkWN "soapfish" ; --UNCHK
lin soapiness_N = mkWN (k12 "saippua") ; --UNCHK
lin soapstone_N = mkWN (k5A "talkki") ; --UNCHK
lin soapsuds_N = mkWN (k1A "vaahto") ; --UNCHK
lin soapweed_N = mkWN "Yucca" "elata" ; --UNCHK
lin soapwort_N = mkWN (compoundN "suopa" (k5A "yrtti")) ; --UNCHK
lin soapy_A = mkWA (compoundA "saippua" (k38 "mainen")) ; --UNCHK
lin soar_N = mkWN (k1 "nousu") ; --UNCHK
lin soar_V = mkV "ampaista" ;
lin soar_V2 = mkWV2 (k66 "nousta") ; --UNCHK
lin sob_N = mkWN (k39 "nyyhkytys") ; --UNCHK
lin sob_V = mkWV (k53A "nyyhkyttää") ; --UNCHK
lin sob_V2 = mkWV2 (k53A "nyyhkyttää") ; --UNCHK
lin sob_stuff_N = mkWN (compoundN "nyyhky" (k12 "tarina")) ; --UNCHK
lin sobbingly_Adv = mkWAdv "nyyhkyttäen" ; --UNCHK
lin sober_A = mkWA (k10 "selvä") ; --UNCHK
lin sober_V = mkWV (k75 "selvitä") ; --UNCHK
lin sober_V2 = mkWV2 (k75 "selvitä") ; --UNCHK
lin sober_up_V2 = mkWV2 (k75 "selvitä") ; --UNCHK
lin soberness_N = mkWN (k40 "synkkyys") ; --UNCHK
lin sobersided_A = mkWA (k38 "tosikkomainen") ; --UNCHK
lin sober_sides_N = mkWN (k4A "tosikko") ; --UNCHK
lin sobralia_N = mkWN (k13 "orkidea") ; --UNCHK
lin sobriety_N = mkWN (k40 "kohtuus") ; --UNCHK
lin sobriquet_N = mkWN (compoundN "liika" (k7 "nimi")) ; --UNCHK
lin socage_N = mkWN (compoundN "torppari" (k10 "järjestelmä")) ; --UNCHK
lin socalled_A = variants { mkA "niinkutsuttu" ; mkA "niin kutsuttu" } ;
lin soccer_N = mkWN (compoundN "jalka" (k1 "pallo")) ; --UNCHK
lin sociability_N = mkWN (k40 "sosiaalisuus") ; --UNCHK
lin sociable_A = mkWA (k38 "sosiaalinen") ; --UNCHK
lin sociable_N = mkWN (compoundN "illan" (k1A "vietto")) ; --UNCHK
lin social_A = mkWA (k38 "sosiaalinen") ;
lin social_N = mkWN (compoundN "illan" (k1A "vietto")) ; --UNCHK
lin social_work_N = mkWN (compoundN "sosiaali" (k19 "työ")) ; --UNCHK
lin socialism_N = mkWN (k5 "sosialismi") ; --UNCHK
lin socialist_A = mkWA (k38 "sosialistinen") ; --UNCHK
lin socialist_N = mkWN (k5 "sosialisti") ; --UNCHK
lin socialistic_A = mkWA (k38 "sosialistinen") ; --UNCHK
lin socialite_N = mkWN (compoundN "seurapiiri" (k39 "julkkis")) ; --UNCHK
lin sociality_N = mkWN (k48A "tarve") "sosiaalinen" ; --UNCHK
lin socialization_N = mkWN (k3 "sosialisaatio") ; --UNCHK
lin socialize_V2 = mkWV2 (k62 "sosialisoida") ; --UNCHK
lin socializer_N = mkWN (compoundN "seura" (k42 "mies")) ; --UNCHK
lin society_N = mkN "yhteis" (mkN "kunta") ;
lin sociobiologic_A = mkWA (compoundA "sosio" (k38 "biologinen")) ; --UNCHK
lin sociobiologically_Adv = mkWAdv (compoundAdv "sosio" (k99 "biologisesti")) ; --UNCHK
lin sociobiologist_N = mkWN (compoundN "sosio" (k5 "biologi")) ; --UNCHK
lin sociobiology_N = mkWN (compoundN "sosio" (k12 "biologia")) ; --UNCHK
lin sociocultural_A = mkWA (compoundA "sosio" (k38 "kulttuurinen")) ; --UNCHK
lin socioeconomic_A = mkWA (compoundA "sosio" (k38 "ekonominen")) ; --UNCHK
lin sociolinguist_N = mkWN (compoundN "sosio" (k5 "lingvisti")) ; --UNCHK
lin sociolinguistic_A = mkWA (compoundA "sosio" (k38 "lingvistinen")) ; --UNCHK
lin sociolinguistics_N = mkWN (compoundN "sosio" (k9A "lingvistiikka")) ; --UNCHK
lin sociological_A = mkWA (k38 "sosiologinen") ; --UNCHK
lin sociologist_N = mkWN (k5 "sosiologi") ;
lin sociology_N = mkWN (k12 "sosiologia") ; --UNCHK
lin sociometry_N = mkWN "sosiometria" ; --UNCHK
lin sociopath_N = mkWN (k5A "psykopaatti") ; --UNCHK
lin sociopathic_A = mkWA "sosiopaattinen" ; --UNCHK
lin sock_N = L.sock_N ;
lin sock_V2 = mkWV2 (k64 "lyödä") ; --UNCHK
lin socket_N = mkWN (compoundN "pisto" (k12 "rasia")) ; --UNCHK
lin sockeye_N = mkWN (compoundN "puna" (k23 "lohi")) ; --UNCHK
lin socle_N = mkWN (k6 "sokkeli") ; --UNCHK
lin socratic_A = mkWA "Sokrateen" ; --UNCHK
lin sod_N = mkWN (k4A "nurmikko") ; --UNCHK
lin sod_V = mkWV (k53A "peittää") "turpeella" ; --UNCHK
lin soda_N = mkN "virvoitus" (mkN "juoma") ; ---ARB --mkN "sooda" ; --mkWN (k1 "limu") ;
lin soda_biscuit_N = mkWN (compoundN "piimä" (k10A "leipä")) ; --UNCHK
lin soda_cracker_N = mkWN (k5 "voileipäkeksi") ; --UNCHK
lin soda_fountain_N = mkWN (compoundN "soodavesi" (k1A "pumppu")) ; --UNCHK
lin soda_water_N = mkWN (k1 "limu") ; --UNCHK
lin sodalist_N = mkWN (k32 "jäsen") "veljeskunnan" ; --UNCHK
lin sodalite_N = mkWN "sodaliitti" ; --UNCHK
lin sodankylä_PN = mkPN "Sodankylä" ;
lin sodden_A = mkWA (compoundA "läpi" (k10A "märkä")) ; --UNCHK
lin sodium_N = mkWN (k5 "natrium") ; --UNCHK
lin sodoku_N = mkWN (compoundN "spirillum-" (k48 "kuume")) ; --UNCHK
lin sodom_N = mkWN (compoundN "Sod" (k10 "oma")) ; --UNCHK
lin sodomite_N = mkWN (k1 "homo") ; --UNCHK
lin sodomy_N = mkWN (k12 "sodomia") ; --UNCHK
lin sofa_N = mkWN (k5A "seslonki") ; --UNCHK
lin soffit_N = mkWN (k12 "kamana") ; --UNCHK
lin sofia_PN = foreignPN "Sofia" ;
lin soft_A = mkA "pehmeä" ;
lin soft_solder_N = mkWN (k48A "juote") "pehmeä" ; --UNCHK
lin soft_spoken_A = mkA (mkN "pehmeä-" (mkN "ääninen")) ;
lin softball_N = mkWN (compoundN "softball-" (k5 "peli")) ; --UNCHK
lin soften_V = mkWV (k52A "pehmentyä") ; --UNCHK
lin soften_V2 = mkWV2 (k52A "pehmentyä") ; --UNCHK
lin softener_N = mkWN (k33A "pehmitin") ; --UNCHK
lin softening_N = mkWN "pehmentyminen" ; --UNCHK
lin soft_hearted_A = mkWA (compoundA "hellä" (k38 "sydäminen")) ; --UNCHK
lin softheartedness_N = mkWN (k40 "hellyys") ; --UNCHK
lin softie_N = mkWN (k14A "tallukka") ; --UNCHK
lin softish_A = mkWA (compoundA "puoli" (k15 "pehmeä")) ; --UNCHK
lin softness_N = mkWN (k40 "pehmeys") ; --UNCHK
lin software_N = mkN "ohjelmisto" ;
lin softwood_N = mkWN (k18 "puu") "pehmeä" ; --UNCHK
lin softy_N = mkWN (k14A "tallukka") ; --UNCHK
lin sogginess_N = mkWN (compoundN "läpi" (k40 "märkyys")) ; --UNCHK
lin soggy_A = mkWA (k1A "veltto") ; --UNCHK
lin soh_N = mkWN "sol" ; --UNCHK
lin soho_PN = foreignPN "Soho" ;
lin soigne_A = mkWA (k41A "tyylikäs") ; --UNCHK
lin soignee_A = mkWA (k41A "tyylikäs") ; --UNCHK
lin soil_N = mkWN (k48 "alue") ; --UNCHK
lin soil_V = mkWV (k73 "kurata") ; --UNCHK
lin soil_V2 = mkWV2 (k73 "kurata") ; --UNCHK
lin soil_pipe_N = mkWN (compoundN "viemäri" (k7 "putki")) ; --UNCHK
lin soiling_N = mkWN (compoundN "lika" (k38 "antuminen")) ; --UNCHK
lin soini_PN = mkPN "Soini" ;
lin soiree_N = mkWN (compoundN "illan" (k1A "vietto")) ; --UNCHK
lin sojourn_N = mkWN (k2 "oleskelu") ; --UNCHK
lin sojourn_V = mkWV (k67 "vierailla") ; --UNCHK
lin sojourner_N = mkWN (k12 "vierailija") ; --UNCHK
lin sol_N = mkWN "sol" ; --UNCHK
lin solace_N = mkWN (k39 "helpotus") ; --UNCHK
lin solace_V2 = mkWV2 (k53A "lievittää") ; --UNCHK
lin solan_N = mkWN (k10 "suula") ; --UNCHK
lin solanaceous_A = mkWA "solanaceous" ; --UNCHK
lin solar_A = mkWA "aurinkoon" "liittyvä" ;
lin solar_plexus_N = mkWN (compoundN "hermo" (k39 "punos")) "vatsan" ; --UNCHK
lin solarium_N = mkWN (compoundN "lasi" (k5 "kuisti")) ; --UNCHK
lin solarization_N = mkWN "solarisaatio" ; --UNCHK
lin solder_N = mkWN (k48A "juote") ; --UNCHK
lin solder_V2 = mkWV2 (k53A "juottaa") ; --UNCHK
lin solderer_N = mkWN "juottaja" ; --UNCHK
lin soldering_iron_N = mkWN (k5 "kolvi") ; --UNCHK
lin soldier_N = mkN "sotilas" ;
lin soldier_V = mkWV (k67 "palvella") ; --UNCHK
lin soldierfish_N = mkWN (compoundN "juovaorava" (k9 "kala")) ; --UNCHK
lin soldiering_N = mkWN (k39 "lintsaus") ; --UNCHK
lin soldierly_A = mkWA (k10 "sotaisa") ; --UNCHK
lin sole_A = mkA "ainoa" ;
lin sole_N = mkWN (compoundN "meri" (k12 "antura")) ; --UNCHK
lin sole_V2 = mkWV2 (compoundV "puoli" (k73 "pohjata")) ; --UNCHK
lin solecism_N = mkWN (k40 "karkeus") ; --UNCHK
lin soleless_A = mkWA (k34A "pohjaton") ; --UNCHK
lin solemn_A = mkWA (k10 "vakava") ; --UNCHK
lin solemnity_N = mkWN (k40 "juhlavuus") ; --UNCHK
lin solemnization_N = mkWN (k1A "vietto") ; --UNCHK
lin solemnize_V2 = mkWV2 (k53 "juhlistaa") ; --UNCHK
lin solenogaster_N = mkWN "aplacophoran" ; --UNCHK
lin solenoid_N = mkWN (k5 "solenoidi") ; --UNCHK
lin soleus_N = mkWN (compoundN "soleus-" (k39 "lihas")) ; --UNCHK
lin solfege_N = mkWN "solfeggio" ; --UNCHK
lin solferino_N = mkWN (k2 "taistelu") "Solferinon" ; --UNCHK
lin solicit_V = mkWV (k54A "pyytää") ; --UNCHK
lin solicit_V2 = mkWV2 (k54A "pyytää") ; --UNCHK
lin solicitation_N = mkWN (k39 "houkutus") ; --UNCHK
lin solicitorFem_N = mkWN (compoundN "laki" (k42 "mies")) ; --UNCHK
lin solicitorMasc_N = mkN "laki" L.man_N ; ---- sense
lin solicitor_general_N = mkWN "varaoikeuskansleri" ; --UNCHK
lin solicitorship_N = mkWN "asianajovaltakirja" ; --UNCHK
lin solicitous_A = mkWA (k41A "kärkäs") ; --UNCHK
lin solicitude_N = mkWN (k26 "huoli") ; --UNCHK
lin solid_A = mkWA (k15 "kiinteä") ;
lin solid_N = mkWN (k48 "kappale") "kolmiulotteinen" ; --UNCHK
lin solid_state_A = mkA "kiinteä" ; ---ARB ; "elektroninen (ei liikkuvia osia sisältävä)"
lin solidarity_N = mkWN (k40 "solidaarisuus") ; --UNCHK
lin solidification_N = mkWN (compoundN "kii" (k38 "nteytyminen")) ; --UNCHK
lin solidify_V = mkWV (k52A "jähmettyä") ; --UNCHK
lin solidify_V2 = mkWV2 (k52A "jähmettyä") ; --UNCHK
lin solidity_N = mkWN (k40 "lujuus") ; --UNCHK
lin solidness_N = mkWN (k40 "lujuus") ; --UNCHK
lin solidus_N = mkWN (k50 "vinoviiva") ; --UNCHK
lin solihull_PN = foreignPN "Solihull" ;
lin soliloquize_V = mkWV (k52 "puhua") "itsekseen" ; --UNCHK
lin soliloquy_N = mkWN (compoundN "yksin" (k2 "puhelu")) ; --UNCHK
lin solingen_PN = foreignPN "Solingen" ;
lin solipsism_N = mkWN (compoundN "solips" (k5 "ismi")) ; --UNCHK
lin solitary_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin soliton_N = mkWN (compoundN "solitoni" (k1A "aalto")) ; --UNCHK
lin solitude_N = mkWN (k1A "seutu") "yksinäinen" ; --UNCHK
lin solleret_N = mkWN "sabaton" ; --UNCHK
lin solmization_N = mkWN (compoundN "solfa" (k5 "treeni")) ; --UNCHK
lin solo_A = mkWA "soolo-" ; --UNCHK
lin solo_N = mkN (lin NK {s = d01 "soolo"}) ;
lin soloist_N = mkWN (k5 "solisti") ; --UNCHK
lin solon_PN = foreignPN "Solon" ;
lin solstice_N = mkWN (compoundN "päivän" (k39 "seisaus")) ; --UNCHK
lin solubility_N = mkWN (k40 "liukoisuus") ; --UNCHK
lin soluble_A = mkWA (compoundA "liuke" (k9 "neva")) ; --UNCHK
lin solution_1_N = mkN "liuos" ;
lin solution_2_N = mkWN (k2 "ratkaisu") ;
lin solvability_N = mkWN "ratkeavuus" ; --UNCHK
lin solvable_A = mkWA (k10 "oleva") "ratkaistavissa" ; --UNCHK
lin solvate_N = mkWN "solvaatti" ; --UNCHK
lin solvation_N = mkWN "solvaatio" ; --UNCHK
lin solve_V2 = mkV2 "ratkaista" ;
lin solvency_N = mkWN (k5A "likviditeetti") ; --UNCHK
lin solvent_A = mkWA (compoundA "vaka" (k38 "varainen")) ; --UNCHK
lin solvent_N = mkWN (k39 "vastaus") ; --UNCHK
lin som_N = mkWN "som" ; --UNCHK
lin soma_N = mkWN (k41 "ruumis") ; --UNCHK
lin somaliFem_N = mkWN (k6 "somali") ; --UNCHK
lin somaliMasc_N = mkWN (k6 "somali") ; --UNCHK
lin somali_A = mkWA (k38 "somalialainen") ; --UNCHK
lin somalia_PN = foreignPN "Somalia" ;
lin somalianFem_N = mkWN (k6 "somali") ; --UNCHK
lin somalianMasc_N = mkWN (k6 "somali") ; --UNCHK
lin somalian_A = mkWA (k38 "somalialainen") ; --UNCHK
lin somatic_A = mkWA (k38 "somaattinen") ; --UNCHK
lin somatogenic_A = mkWA (compoundA "soma" (k38 "togeeninen")) ; --UNCHK
lin somatosense_N = mkWN (compoundN "keho" (k5 "aisti")) ; --UNCHK
lin somatosensory_A = mkWA "kehoaisti-" ; --UNCHK
lin somatotropin_N = mkWN (k5 "hormoni") "somatotrooppinen" ; --UNCHK
lin somber_A = mkWA (k10 "vakava") ; --UNCHK
lin sombre_A = mkWA (k10 "vakava") ; --UNCHK
lin sombreness_N = mkWN (k40 "synkkyys") ; --UNCHK
lin sombrero_N = mkWN (k1 "sombrero") ; --UNCHK
lin some_Det = mkDet False Sg (exceptNomN (mkN "vähä") "vähän") partitive | mkDet False Sg (exceptNomN (mkN "hiukka") "hiukan") partitive ;
lin some_Quant = heavyQuant {s1 = S.jokinPron ; s2 = \\_ => [] ; isNum,isPoss,isNeg,isDef = False} ; ---- vähän, hiukan
lin somebody_NP = S.somebody_NP ;
lin someday_Adv = mkWAdv (k99 "joskus") ;
lin somehow_AdV = mkAdV "jotenkin" ;
lin somehow_Adv = mkWAdv (k99 "lailla") "jollain" ; --UNCHK
lin someone_NP = S.somebody_NP ;
lin someplace_Adv = mkWAdv (k99 "päin") "jossakin" ; --UNCHK
lin somero_PN = mkPN "Somero" ;
lin somersault_N = mkWN (k39 "pyörähdys") ; --UNCHK
lin somersault_V = mkWV (k71 "tehdä") "voltti" ; --UNCHK
lin somerset_PN = foreignPN "Somerset" ;
lin somesthesia_N = mkWN (k5 "aisti") "somaattinen" ; --UNCHK
lin something_NP = S.something_NP ;
lin sometime_Adv = mkWAdv (k99 "joskus") ; --UNCHK
lin sometimes_Adv = mkAdv "joskus" | mkWAdv (k99 "ajoittain") ;
lin someway_Adv = mkWAdv (k99 "lailla") "jollain" ; --UNCHK
lin somewhat_Adv = mkAdv "jossain määrin" ;
lin somewhere_Adv = S.somewhere_Adv ;
lin somewhere_N = mkWN (k99 "jossakin") ; --UNCHK
lin sommelier_N = mkWN (k6 "viinuri") ; --UNCHK
lin somnambulism_N = mkWN (compoundN "unissa" (k2 "kävely")) ; --UNCHK
lin somnambulist_N = mkWN (compoundN "unissa" (k12 "kävelijä")) ; --UNCHK
lin somniloquist_N = mkWN (compoundN "unissa" (k10 "puhuja")) ; --UNCHK
lin somnolence_N = mkWN (k40 "raukeus") ; --UNCHK
lin somnolent_A = mkWA (k15 "raukea") ; --UNCHK
lin son_N = mkN "poika" "pojan" "poikia" ;
lin sonant_N = mkWN (k48A "äänne") "soinnillinen" ; --UNCHK
lin sonar_N = mkWN (compoundN "kaiku" (k33 "luotain")) ; --UNCHK
lin sonata_N = mkWN (k5A "sonaatti") ; --UNCHK
lin sonatina_N = mkWN (k5 "sonatiini") ; --UNCHK
lin sone_N = mkWN (k5 "sooni") ; --UNCHK
lin song_N = L.song_N ;
lin songbird_N = mkWN (k10 "laulaja") ; --UNCHK
lin songbook_N = mkWN (compoundN "laulu" (k9 "kirja")) ; --UNCHK
lin songster_N = mkWN (k10 "laulaja") ; --UNCHK
lin songstress_N = mkWN (k32A "laulajatar") ; --UNCHK
lin songwriter_N = mkWN (k10 "sanoittaja") ; --UNCHK
lin sonic_A = mkWA "yliääni-" ; --UNCHK
lin sonkajärvi_PN = mkPN (mkN "Sonkajärvi" "Sonkajärviä") ;
lin sonnet_N = mkWN (k5A "sonetti") ; --UNCHK
lin sonneteer_N = mkWN (compoundN "sonetti" (k12 "runoilija")) ; --UNCHK
lin sonny_N = mkWN (k1 "poju") ; --UNCHK
lin sonogram_N = mkWN (compoundN "ultraääni" (k10 "kuva")) ; --UNCHK
lin sonograph_N = mkWN (compoundN "ultra" (k26 "ääni")) ; --UNCHK
lin sonography_N = mkWN (compoundN "ultra" (k26 "ääni")) ; --UNCHK
lin sonority_N = mkWN "sonorisuus" ; --UNCHK
lin sonorous_A = mkWA (k41A "soinnikas") ; --UNCHK
lin sonsy_A = mkWA (k38 "täyteläinen") ; --UNCHK
lin soon_AdV = mkAdV "pian" ;
lin soon_Adv = mkAdv "pian" ;
lin sooner_Adv = mkWAdv (k99 "mieluiten") ; --UNCHK
lin soonest_Adv = mkWAdv (k99 "aikaisintaan") ; --UNCHK
lin soot_N = mkWN (k7A "noki") ; --UNCHK
lin soot_V2 = mkWV2 (k74A "noeta") ; --UNCHK
lin sooth_N = mkWN (k40 "totuus") ; --UNCHK
lin soothe_V2 = mkWV2 (k53A "tyynnyttää") ; --UNCHK
lin soothing_A = mkWA (compoundA "help" (k10 "ottava")) ; --UNCHK
lin soothsayer_N = mkWN (k10 "ennustaja") ; --UNCHK
lin sooty_A = mkWA (compoundA "sysi" (k10 "musta")) ; --UNCHK
lin sop_N = mkWN (k1A "käytäntö") "pysyvä" ; --UNCHK
lin sop_V2 = mkWV2 (k56 "kastaa") ; --UNCHK
lin sophia_PN = foreignPN "Sophia" ;
lin sophism_N = mkWN (k40 "teennäisyys") ; --UNCHK
lin sophistFem_N = mkWN (k5 "sofisti") ; --UNCHK
lin sophistMasc_N = mkWN (k5 "sofisti") ; --UNCHK
lin sophistic_A = mkWA "viisastelijan" ; --UNCHK
lin sophisticate_N = mkWN (k12 "hienostelija") ; --UNCHK
lin sophisticated_A = mkA "sofistikoitu" ;
lin sophistication_N = mkWN (k2 "vääristely") ; --UNCHK
lin sophistry_N = mkWN (k40 "teennäisyys") ; --UNCHK
lin sophomore_N = mkWN (k12 "opiskelija") "toisen" "vuoden" ; --UNCHK
lin soporific_A = mkWA (k38 "uninen") ; --UNCHK
lin soporific_N = mkWN (compoundN "uni" (k48A "lääke")) ; --UNCHK
lin sopping_Adv = mkWAdv (compoundAdv "valu" (k9 "vana")) "vettä" ; --UNCHK
lin soppy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin sopranino_A = mkWA "sopranino" ; --UNCHK
lin soprano_A = mkWA (k15 "korkea") ; --UNCHK
lin soprano_N = mkWN (k2 "sopraano") ; --UNCHK
lin sorb_N = mkWN (k10 "pihlaja") ; --UNCHK
lin sorbate_N = mkWN "sorbentti" ; --UNCHK
lin sorbent_N = mkWN (compoundN "sorbentti" (k48 "aine")) ; --UNCHK
lin sorbet_N = mkWN (k48A "jäädyke") ; --UNCHK
lin sorcerer_N = mkWN (k10 "manaaja") ; --UNCHK
lin sorceress_N = mkWN (k1 "velho") ; --UNCHK
lin sorcery_N = mkWN (k39 "manaus") ; --UNCHK
lin sordid_A = mkWA (k41A "itsekäs") ; --UNCHK
lin sordidness_N = mkWN (k40 "kurjuus") ; --UNCHK
lin sore_A = mkWA (k38 "vihainen") ; --UNCHK
lin sore_N = mkWN (k39 "tulehdus") ; --UNCHK
lin sorehead_N = mkWN (k10 "ärtyisä") ; --UNCHK
lin soreness_N = mkWN (k1A "ahdinko") ; --UNCHK
lin sorghum_N = mkWN (k10 "durra") ; --UNCHK
lin sorgo_N = mkWN (compoundN "sokeri" (k10 "durra")) ; --UNCHK
lin sorority_N = mkWN (k39 "yhdistys") "naisopiskelijain" ; --UNCHK
lin sorption_N = mkWN "sorptio" ; --UNCHK
lin sorrel_A = mkWA (compoundA "puna" (k15 "ruskea")) ; --UNCHK
lin sorrel_N = mkWN (k41 "rautias") ; --UNCHK
lin sorrow_N = mkWN (k1 "suru") ; --UNCHK
lin sorrow_V = mkWV (k61A "murehtia") ; --UNCHK
lin sorry_A = mkWA (k10 "oleva") "pahoillaan" ;
lin sorry_Interj = mkInterj "anteeksi" ;
lin sort_N = mkWN (k5 "laji") ;
lin sort_V = mkV "ryhmittyä" ; --mkWV (k53A "ryhmittää") ;
lin sort_V2 = mkWV2 (k53A "ryhmittää") ; --UNCHK
lin sort_out_V2 = mkWV2 (k53 "havainnollistaa") ; --UNCHK
lin sorter_N = mkWN (compoundN "lajittelu" (k48 "kone")) ; --UNCHK
lin sortie_N = mkWN (kH1 "lento") ; --UNCHK
lin sorting_N = mkWN (k2 "lajittelu") ; --UNCHK
lin sorus_N = mkWN (compoundN "itiöpesäke" (k10 "ryhmä")) ; --UNCHK
lin sos_N = mkWN "SOS" ; --UNCHK
lin sot_N = mkWN (k38 "humalainen") ; --UNCHK
lin soteriological_A = mkWA "soteriologinen" ; --UNCHK
lin soteriology_N = mkWN (k5 "pluralismi") ; --UNCHK
lin sotho_A = mkWA "sothon" ; --UNCHK
lin sotho_N = mkWN "sotho" ; --UNCHK
lin sotkamo_PN = mkPN "Sotkamo" ;
lin sottish_A = mkWA (k38 "humalainen") ; --UNCHK
lin sottishness_N = mkWN (k40 "juoppous") ; --UNCHK
lin sotto_voce_Adv = mkWAdv (k99 "hiljaa") ; --UNCHK
lin sou_N = mkWN "ei" "penniäkään" ; --UNCHK
lin souari_N = mkWN "Caryocar" "nuciferum" ; --UNCHK
lin soubrette_N = mkWN (k5A "subretti") ; --UNCHK
lin soubriquet_N = mkWN (compoundN "liika" (k7 "nimi")) ; --UNCHK
lin souchong_N = mkWN "soochong" ; --UNCHK
lin souffle_N = mkWN (k41A "kohokas") ; --UNCHK
lin sough_V = mkWV (k66 "kohista") ; --UNCHK
lin soughingly_Adv = mkWAdv "humisten" ; --UNCHK
lin souk_N = mkWN "souk" ; --UNCHK
lin soul_N = mkWN (k1 "sielu") ;
lin soulful_A = mkWA (k41A "sielukas") ; --UNCHK
lin soulless_A = mkWA (k34A "sieluton") ; --UNCHK
lin sound_A = mkWA (compoundA "vaka" (k38 "varainen")) ; --UNCHK
lin sound_N = mkWN (k26 "ääni") ;
lin sound_V = mkV "soida" ;
lin sound_V2 = mkV2 (mkV "kuulostaa") ablative ;
lin sound_VA = mkVA (mkV "kuulostaa") (mkPrep ablative) ;
lin sound_VS = mkVS (mkV "kuulostaa") ;
lin sound_film_N = mkWN "äänielokuva" ; --UNCHK
lin sound_off_V = mkWV (k66 "nurista") ; --UNCHK
lin sound_out_V2 = mkWV2 (k67 "tunnustella") ; --UNCHK
lin sound_recording_N = mkWN (compoundN "ääni" (k48A "tallenne")) ; --UNCHK
lin sound_wave_N = mkWN (k1A "aalto") "akustinen" ; --UNCHK
lin soundbox_N = mkWN (compoundN "ääni" (k12 "rasia")) ; --UNCHK
lin sounder_N = mkWN (k33 "luotain") ; --UNCHK
lin sounding_N = mkWN (k39 "luotaus") ; --UNCHK
lin sounding_board_N = mkWN (compoundN "kaiku" (k10 "pohja")) ; --UNCHK
lin soundless_A = mkWA (k34A "äänetön") ; --UNCHK
lin soundman_N = mkWN (k10 "järjestäjä") "äänitehosteiden" ; --UNCHK
lin soundness_N = mkWN (k40 "kiinteys") ; --UNCHK
lin soundproof_A = mkWA (compoundA "ääni" (k41 "tiivis")) ; --UNCHK
lin soundproof_V2 = mkWV2 (compoundV "ääni" (k53 "eristää")) ; --UNCHK
lin soundtrack_N = mkWN (k9A "ääniraita") ; --UNCHK
lin soup_N = mkWN (k25 "liemi") ; --UNCHK
lin soup_V2 = mkWV2 (k73A "doupata") ; --UNCHK
lin soup_kitchen_N = mkWN (compoundN "soppa" (k1 "jono")) ; --UNCHK
lin soupcon_N = mkWN (k39 "aavistus") ; --UNCHK
lin soupspoon_N = mkWN (compoundN "liemi" (k14A "lusikka")) ; --UNCHK
lin soupy_A = mkWA (k38 "tunteellinen") ; --UNCHK
lin sour_A = mkWA (k15 "kirpeä") ; --UNCHK
lin sour_N = mkWN (k40 "happamuus") ; --UNCHK
lin sour_V = mkWV (k65 "käydä") ; --UNCHK
lin sour_V2 = mkWV2 (k65 "käydä") ; --UNCHK
lin sourball_N = mkWN (k5 "karamelli") "kirpeä" ; --UNCHK
lin source_N = mkN "lähde" ;
lin sourdine_N = mkWN (k2 "sordiino") ; --UNCHK
lin sourdough_N = mkWN (compoundN "uudis" (k10 "raivaaja")) ; --UNCHK
lin souring_N = mkWN (compoundN "hapan" (k38 "tuminen")) ; --UNCHK
lin sourness_N = mkWN (k40 "happamuus") ; --UNCHK
lin sourpuss_N = mkWN (k50 "hapannaama") ; --UNCHK
lin soursop_N = mkWN "guanabana" ; --UNCHK
lin souse_N = mkWN (k39 "upotus") ; --UNCHK
lin souse_V2 = mkWV2 (k56 "kastaa") ; --UNCHK
lin soutache_N = mkWN (compoundN "soutache-" (k9 "nauha")) ; --UNCHK
lin south_A = mkA "eteläinen" ;
lin south_Adv = mkAdv "etelään" ;
lin south_N = mkWN (k10 "etelä") ;
lin south_ockendon_PN = foreignPN "South Ockendon" ;
lin south_shields_PN = foreignPN "South Shields" ;
lin south_southeast_N = mkWN (compoundN "etelä" (k1A "kaakko")) ; --UNCHK
lin south_southwest_N = mkWN (compoundN "etelä" (k41 "lounas")) ; --UNCHK
lin southampton_PN = foreignPN "Southampton" ;
lin southeast_A = mkWA (k38 "kaakkoinen") ; --UNCHK
lin southeast_Adv = mkWAdv "kaakossa" ; --UNCHK
lin southeast_N = mkWN (k1A "kaakko") ; --UNCHK
lin southeaster_N = mkWN (compoundN "kaakkois" (k1 "myrsky")) ; --UNCHK
lin southeasterly_A = mkWA (k38 "kaakkoinen") ; --UNCHK
lin southeastern_A = mkWA (k38 "kaakkoinen") ; --UNCHK
lin southeastward_A = mkWA (k99 "päin") "kaakkoon" ; --UNCHK
lin southeastward_Adv = mkWAdv (k99 "päin") "kaakkoon" ; --UNCHK
lin southerly_A = mkWA (k38 "eteläinen") ; --UNCHK
lin southerly_Adv = mkWAdv (k38 "eteläinen") | adjAdv southerly_A ; --UNCHK -- derived
lin southern_A = mkWA (k38 "eteläinen") ;
lin southerner_N = mkWN (compoundN "etelävaltio" (k38 "lainen")) ; --UNCHK
lin southernism_N = mkWN (compoundN "etelämiel" (k40 "isyys")) ; --UNCHK
lin southernmost_A = mkWA "eteläisin" ; --UNCHK
lin southernness_N = mkWN "etelä-" ; --UNCHK
lin southernwood_N = mkWN (k5A "aaprotti") ; --UNCHK
lin southland_N = mkWN (compoundN "etelä" (k18 "maa")) ; --UNCHK
lin southpaw_N = mkWN (k10 "pelaaja") "vasenkätinen" ; --UNCHK
lin southport_PN = foreignPN "Southport" ;
lin southward_Adv = mkWAdv "etelään" ; --UNCHK
lin southwards_Adv = mkWAdv "etelään" ; --UNCHK
lin southwest_A = mkWA (k38 "lounainen") ; --UNCHK
lin southwest_Adv = mkWAdv "lounaassa" ; --UNCHK
lin southwest_N = mkWN "lounais-" ; --UNCHK
lin southwester_N = mkWN (compoundN "lounais" (k26 "tuuli")) ; --UNCHK
lin southwesterly_A = mkWA (k38 "lounainen") ; --UNCHK
lin southwestern_A = mkWA (k38 "lounainen") ; --UNCHK
lin southwestward_A = mkWA "lounaaseen" ; --UNCHK
lin southwestward_Adv = mkWAdv "lounaassa" ; --UNCHK
lin souvenir_N = mkWN (k1 "muisto") ; --UNCHK
lin souvlaki_N = mkWN (k5A "souvlaki") ; --UNCHK
lin sovereign_A = mkWA (k36 "ylin") ; --UNCHK
lin sovereign_N = mkWN (k41 "valtias") ; --UNCHK
lin sovereignty_N = mkWN (k5A "suvereniteetti") ;
lin soviet_A = mkWA (compoundA "neuvosto" (k38 "liittolainen")) ; --f164
lin soviet_N = mkWN (k2 "neuvosto") ; --UNCHK
lin sovietize_V2 = mkV2 "neuvostoliittolaistaa" ;
lin sow_N = mkWN (k4A "emakko") ; --UNCHK
lin sow_V = mkWV (k53 "kylvää") ; --UNCHK
lin sow_V2 = mkWV2 (k53 "kylvää") ; --UNCHK
lin sowbane_N = mkWN (compoundN "puna" (k14A "savikka")) ; --UNCHK
lin sowbelly_N = mkWN (compoundN "sian" (k9 "liha")) "suolattu" ; --UNCHK
lin sowbread_N = mkWN (k6 "syklaami") "villi" ; --UNCHK
lin sower_N = mkWN (k10 "kylväjä") ; --UNCHK
lin soy_N = mkWN (k10 "soija") ; --UNCHK
lin sozzled_A = mkWA (k10 "oleva") "tillin-tallin" ; --UNCHK
lin spa_N = mkWN (k12 "kylpylä") ; --UNCHK
lin space_1_N = mkN "avaruus" ;
lin space_2_N = mkN "avaruus" ;
lin space_V2 = mkWV2 (k53A "jättää") "tilaa" ; --UNCHK
lin space_bar_N = mkWN (compoundN "väli" (k5A "lyönti")) ; --UNCHK
lin space_capsule_N = mkWN (compoundN "avaruus" (k6 "kapseli")) ; --UNCHK
lin space_heater_N = mkWN (k33A "lämmitin") ; --UNCHK
lin space_helmet_N = mkWN (compoundN "avaruus" (k10 "kypärä")) ; --UNCHK
lin space_rocket_N = mkWN (compoundN "avaruus" (k5A "raketti")) ; --UNCHK
lin space_vehicle_N = mkWN (compoundN "avaruus" (k39 "alus")) ; --UNCHK
lin spacecraft_N = mkWN (compoundN "avaruus" (k39 "alus")) ;
lin spaceflight_N = mkWN (k1A "avaruuslento") ; --UNCHK
lin spaceship_N = mkWN (compoundN "avaruus" (k39 "alus")) ; --UNCHK
lin spacesuit_N = mkWN (compoundN "avaruus" (k1A "puku")) ; --UNCHK
lin spacewalker_N = mkWN (compoundN "avaruus" (k12 "kävelijä")) ; --UNCHK
lin spaceward_Adv = mkWAdv "avaruuteen" ; --UNCHK
lin spacious_A = mkWA (k10 "avara") ; --UNCHK
lin spaciousness_N = mkWN (k40 "avaruus") ; --UNCHK
lin spackle_N = mkWN (k6 "pakkeli") ; --UNCHK
lin spade_N = mkWN (k3 "lapio") ; --UNCHK
lin spade_V2 = mkWV2 (k62 "lapioida") ; --UNCHK
lin spadefish_N = mkWN (compoundN "enkeli" (k9 "kala")) ; --UNCHK
lin spadefoot_N = mkWN (compoundN "lapio" (k10 "konna")) ; --UNCHK
lin spadeful_N = mkWN (compoundN "lapio" (k38 "llinen")) ; --UNCHK
lin spadework_N = mkWN (compoundN "esi" (k19 "työ")) "ikävä" ; --UNCHK
lin spadix_N = mkWN (compoundN "pui" (k1 "kelo")) ; --UNCHK
lin spaghetti_N = mkWN (k5A "spagetti") ; --UNCHK
lin spaghettini_N = mkWN "spagettini" ; --UNCHK
lin spain_PN = foreignPN "Espanja" ;
lin spalding_PN = foreignPN "Spalding" ;
lin spall_N = mkWN (k1 "siru") ; --UNCHK
lin spallation_N = mkWN "spallaatio" ; --UNCHK
lin spam_N = mkWN (k5 "roskaposti") ; --UNCHK
lin spammer_N = mkWN (k10 "lähettäjä") "roskapostin" ; --UNCHK
lin span_N = mkN "ajan" (mkN "jakso") ; ---ARB ; mkN "alue" ;
lin span_V2 = mkWV2 (k53A "ylittää") ; --UNCHK
lin spandex_N = mkWN "spandex" ; --UNCHK
lin spandrel_N = mkWN (compoundN "span" (k5 "drilli")) ; --UNCHK
lin spangle_N = mkWN (k1 "hely") ; --UNCHK
lin spangle_V2 = mkWV2 (k67 "koristella") "paljetein" ; --UNCHK
lin spaniard_N = mkWN (k38 "espanjalainen") ; --UNCHK
lin spaniel_N = mkWN (k5 "spanieli") ; --UNCHK
lin spanishFem_N = mkWN (k12 "espanja") ; --UNCHK
lin spanishMasc_N = mkWN (k12 "espanja") ; --UNCHK
lin spanish_A = mkWA (k38 "espanjalainen") ; --UNCHK
lin spank_N = mkWN (k39 "läimäys") ; --UNCHK
lin spank_V = mkWV (k70 "piestä") ; --UNCHK
lin spank_V2 = mkWV2 (k70 "piestä") ; --UNCHK
lin spanking_A = mkWA (k15 "nopea") ; --UNCHK
lin spanking_N = mkWN (k39 "piiskaus") ; --UNCHK
lin spanner_N = mkWN (compoundN "kiinto" (k33 "avain")) ; --UNCHK
lin spar_N = mkWN (k39 "sparraus") ; --UNCHK
lin spar_V = mkWV (k67A "riidellä") ; --UNCHK
lin spare_A = mkA "ylijäänyt" ;
lin spare_N = mkWN (compoundN "kylä" (k38 "pöllönen")) ; --UNCHK
lin spare_V = mkWV (k53 "säästää") ; --UNCHK
lin spare_V2 = mkV2 "säästää" ;
lin spareness_N = mkWN (k40 "hoikkuus") ; --UNCHK
lin sparer_N = mkWN (k10 "säästäjä") ; --UNCHK
lin spare_rib_N = mkWN (compoundN "kylki" (k5 "paisti")) ; --UNCHK
lin spareribs_N = mkWN (compoundN "kylki" (k5 "paisti")) ; --UNCHK
lin sparid_N = mkWN (compoundN "hammas" (k32 "ahven")) ; --UNCHK
lin sparing_A = mkWA (k38 "taloudellinen") ; --UNCHK
lin spark_N = mkWN (k48A "välke") ; --UNCHK
lin spark_V = mkWV (k53A "aiheuttaa") ; --UNCHK
lin spark_V2 = mkWV2 (k53A "aiheuttaa") ;
lin spark_off_V2 = mkWV2 (k53A "aiheuttaa") ; --UNCHK
lin spark_plug_N = mkWN (k10A "tulppa") ; --UNCHK
lin sparking_plug_N = mkWN (k10A "tulppa") ; --UNCHK
lin sparkle_N = mkWN (k48 "säihke") ; --UNCHK
lin sparkle_V = mkWV (k52 "säihkyä") ; --UNCHK
lin sparkler_N = mkWN (k38 "sähikäinen") ; --UNCHK
lin sparling_N = mkWN (kH1 "norssi") ; --UNCHK
lin sparring_N = mkWN (k39 "sparraus") ; --UNCHK
lin sparring_match_N = mkWN (compoundN "harjoitus" (k2 "nyrkkeily")) ; --UNCHK
lin sparring_partner_N = mkWN (compoundN "harjoitus" (k10 "vastustaja")) ; --UNCHK
lin sparrow_N = mkWN (k38 "rautiainen") ; --UNCHK
lin sparse_A = mkWA (k43 "ohut") ; --UNCHK
lin sparseness_N = mkWN (k40 "ohuus") ; --UNCHK
lin sparsity_N = mkWN (k40 "ohuus") ; --UNCHK
lin spartanFem_N = mkWN (k38 "spartalainen") ; --UNCHK
lin spartanMasc_N = mkWN (k38 "spartalainen") ; --UNCHK
lin spartan_A = mkWA (k38 "spartalainen") ; --UNCHK
lin spasm_N = mkWN (k5 "spasmi") ; --UNCHK
lin spasmodic_A = mkWA (k38 "puuskittainen") ; --UNCHK
lin spasmolysis_N = mkWN (compoundN "spasmoly" (k5 "ysi")) ; --UNCHK
lin spastic_A = mkWA (k38 "spastinen") ; --UNCHK
lin spastic_N = mkWN (k4A "spastikko") ; --UNCHK
lin spasticity_N = mkWN (k40 "spastisuus") ; --UNCHK
lin spat_N = mkWN (k6 "osteri") "nuori" ; --UNCHK
lin spat_V = mkWV (k53A "läimäyttää") ; --UNCHK
lin spat_V2 = mkWV2 (k53A "läimäyttää") ; --UNCHK
lin spatchcock_N = mkWN (k9 "kana") "paistettu" ; --UNCHK
lin spatchcock_V2 = mkWV2 (k53 "pistää") "väliin" ; --UNCHK
lin spate_N = mkN2 (mkWN (k1A "ryöppy")) (mkPrep elative) ;
lin spathe_N = mkWN (compoundN "suojus" (k7A "lehti")) "puikelon" ; --UNCHK
lin spathiphyllum_N = mkWN (compoundN "viiri" (k9 "vehka")) ; --UNCHK
lin spatial_A = mkWA (k38 "spatiaalinen") ; --UNCHK
lin spatiotemporal_A = mkWA (compoundA "aika-" (k38 "avaruudellinen")) ; --UNCHK
lin spatter_N = mkWN (k39 "roiskutus") ; --UNCHK
lin spatter_V = mkWV (k53A "pirskottaa") ; --UNCHK
lin spatter_V2 = mkWV2 (k53A "pirskottaa") ; --UNCHK
lin spatterdock_N = mkWN (k14A "ulpukka") ; --UNCHK
lin spatula_N = mkWN (k9 "lasta") ; --UNCHK
lin spatulate_A = mkWA (compoundA "lapion" (k38 "muotoinen")) ; --UNCHK
lin spavin_N = mkWN (kH1 "patti") ; --UNCHK
lin spavined_A = mkWA (compoundA "patti" (k38 "jalkainen")) ; --UNCHK
lin spawn_N = mkWN (k5A "mäti") ; --UNCHK
lin spawn_V = mkWV (k58 "laskea") "mätimunia" ; --UNCHK
lin spawn_V2 = mkV2 "aiheuttaa" partitive ; --mkWV2 (k58 "laskea") "mätimunia" ;
lin spawner_N = mkWN (compoundN "kutu" (k9 "kala")) ; --UNCHK
lin spay_V2 = mkWV2 (k62 "steriloida") ; --UNCHK
lin spaying_N = mkWN (compoundN "munasarjan" (k1 "poisto")) ; --UNCHK
lin speak_V = mkV "puhua" ;
lin speak_V2 = L.speak_V2 ;
lin speak_out_V = mkWV (k53A "ottaa") "kantaa" ; --UNCHK
lin speak_up_V = mkWV (k52 "puhua") "kovempaa" ; --UNCHK
lin speakable_A = mkWA "lausuttava" ; --UNCHK
lin speakeasy_N = mkWN (compoundN "sala" (k14A "kapakka")) ; --UNCHK
lin speaker_N = mkN "puhuja" | mkWN (k33A "kaiutin") ; ---- split
lin speakerphone_N = mkWN (compoundN "kaiutin" (k33 "puhelin")) ; --UNCHK
lin speakership_N = mkWN (k9A "virka") "puhemiehen" ; --UNCHK
lin speaking_N = mkWN (compoundN "puheen" (k1A "tuotto")) ; --UNCHK
lin speaking_trumpet_N = mkWN (compoundN "puhe" (k7 "torvi")) ; --UNCHK
lin speaking_tube_N = mkWN (compoundN "puhelu" (k7 "putki")) ; --UNCHK
lin spear_N = mkWN (k26 "nuoli") ; --UNCHK
lin spear_V2 = mkWV2 (k53 "keihästää") ; --UNCHK
lin spearfish_N = mkWN (compoundN "miekka" (k9 "kala")) ; --UNCHK
lin spearhead_N = mkWN (compoundN "keihään" (k7A "kärki")) ; --UNCHK
lin spearhead_V2 = mkWV2 (k61 "toimia") "keihäänkärkenä" ; --UNCHK
lin spearmint_N = mkWN (compoundN "viher" (k1A "minttu")) ; --UNCHK
lin spec_N = mkWN (k3 "spesifikaatio") ; --UNCHK
lin special_A = mkA "erityinen" ;
lin special_N = mkN "erikois" (mkN "tarjous") ; --mkWN (compoundN "erikois" (k1 "jakso")) ;
lin specialism_N = mkWN (compoundN "erikois" (k9 "ala")) ; --UNCHK
lin specialist_A = mkA "erikoistunut" ;
lin specialist_N = mkWN (k5 "spesialisti") ; --f108
lin specialistic_A = mkWA "erikoistumis-" ; --UNCHK
lin speciality_N = mkWN (compoundN "erikois" (k9 "ala")) ; --UNCHK
lin specialization_N = mkWN (compoundN "erikois" (k9 "ala")) ; --UNCHK
lin specialize_V = mkWV (k52 "erikoistua") ;
lin specialize_V2 = mkV2 "erikoistaa" ; --mkWV2 (k52 "erikoistua") ;
lin specialty_N = mkWN (compoundN "erikois" (k9 "ala")) ;
lin speciation_N = mkWN (compoundN "laji" (k38 "utuminen")) ; --UNCHK
lin specie_N = mkWN (k9 "raha") "kova" ; --UNCHK
lin species_N = mkWN (k5 "laji") ;
lin specifiable_A = mkWA "määritettävä" ; --UNCHK
lin specific_A = mkA "erityinen" ;
lin specific_N = mkWN (compoundN "erikois" (k48A "lääke")) ; --UNCHK
lin specification_N = mkWN (k1A "ehto") ;
lin specificity_N = mkWN (compoundN "erity" (k40 "isyys")) ; --UNCHK
lin specified_A = variants {} ; --
lin specifier_N = mkWN (compoundN "asian" (k12 "tuntija")) ; --UNCHK
lin specify_V = mkWV (k73 "varata") ; --UNCHK
lin specify_V2 = mkV2 "spesifioida" ; --WV2 (k73 "varata") ;
lin specify_VS = mkVS "täsmentää" ; --mkWVS (k73 "varata") ;
lin specimen_N = mkWN (k48A "näyte") ; --UNCHK
lin specious_A = mkWA (k38 "näennäinen") ; --UNCHK
lin speciousness_N = mkWN (k40 "valheellisuus") ; --UNCHK
lin speck_N = mkWN (k48 "piste") ; --UNCHK
lin specked_A = mkWA (k38 "pilkullinen") ; --UNCHK
lin speckle_N = mkWN (k1A "pilkku") ; --UNCHK
lin speckled_A = mkWA (k38 "pilkullinen") ; --UNCHK
lin speckless_A = mkWA (k34A "tahriintumaton") ; --UNCHK
lin spectacle_N = mkWN (k38 "naurunalainen") ; --UNCHK
lin spectacled_A = mkWA (compoundA "silmä" (k38 "lasipäinen")) ; --UNCHK
lin spectacular_A = mkWA (k38 "keskeinen") ; --UNCHK
lin spectacular_N = mkWN (k39 "näytös") ; --UNCHK
lin spectatorFem_N = mkN "katsoja" ;
lin spectatorMasc_N = mkN "katsoja" ;
lin spectinomycin_N = mkWN "spektinomysiini" ; --UNCHK
lin spectral_A = mkWA "spektri-" ; --UNCHK
lin spectre_N = mkWN (k1 "haamu") ; --UNCHK
lin spectrogram_N = mkWN "spektrografi" ; --UNCHK
lin spectrograph_N = mkWN "spektrografi" ; --UNCHK
lin spectrographic_A = mkWA "spektrografinen" ; --UNCHK
lin spectrometric_A = mkWA (compoundA "spektro" (k38 "metrinen")) ; --UNCHK
lin spectrophotometer_N = mkWN (compoundN "spektrofoto" (k5 "metri")) ; --UNCHK
lin spectroscope_N = mkWN (compoundN "spektrosko" (k5A "oppi")) ; --UNCHK
lin spectroscopic_A = mkWA "spektroskooppinen" ; --UNCHK
lin spectroscopy_N = mkWN (k5 "analyysi") "spektrografinen" ; --UNCHK
lin spectrum_N = mkWN (k1 "kirjo") ; --UNCHK
lin speculate_V = mkWV (k61 "tuumia") ; --UNCHK
lin speculate_VS = mkVS "spekuloida" ;
lin speculation_N = mkN "spekulaatio" ;
lin speculative_A = mkWA (k41 "utelias") ; --UNCHK
lin speculativeness_N = mkWN "pohdiskelevuus" ; --UNCHK
lin speculatorFem_N = mkWN (k12 "keinottelija") ;
lin speculatorMasc_N = mkWN (k12 "keinottelija") ;
lin speculum_N = mkWN (k33 "tähystin") ; --UNCHK
lin speech_N = mkN "puhe" ;
lin speech_day_N = mkWN (compoundN "päättäjäis" (k10 "päivä")) ; --UNCHK
lin speechify_V = mkWV (k73 "paasata") ; --UNCHK
lin speechless_A = mkWA (k10A "mykkä") ; --UNCHK
lin speechlessness_N = mkWN (k40 "puhumattomuus") ; --UNCHK
lin speechwriter_N = mkWN (compoundN "puheen" (k10 "kirjoittaja")) ; --UNCHK
lin speed_N = mkWN (k5A "vauhti") ;
lin speed_V = mkWV (k73 "lisätä") "vauhtia" ; --UNCHK
lin speed_V2 = mkWV2 (k73 "lisätä") "vauhtia" ; --UNCHK
lin speed_cop_N = mkWN (compoundN "moottoripyörä" (k6 "poliisi")) ; --UNCHK
lin speed_indicator_N = mkWN (compoundN "nopeus" (k6 "mittari")) ; --UNCHK
lin speed_limit_N = mkWN (compoundN "nopeus" (k39 "rajoitus")) ; --UNCHK
lin speed_up_V2 = mkV2 "vauhdittaa" partitive ;
lin speedboat_N = mkWN (compoundN "pika" (k48 "vene")) ; --UNCHK
lin speeder_N = mkWN (k10 "ajaja") "ylinopeuden" ; --UNCHK
lin speeding_N = mkWN (k5A "vauhti") ; --UNCHK
lin speedometer_N = mkWN (compoundN "nopeus" (k6 "mittari")) ; --UNCHK
lin speedskater_N = mkWN (compoundN "pika" (k12 "luistelija")) ; --UNCHK
lin speedway_N = mkWN (compoundN "kilpa" (k9A "rata")) ; --UNCHK
lin speedwell_N = mkWN (k48A "tädyke") ; --UNCHK
lin speedy_A = mkWA (k41A "vauhdikas") ; --UNCHK
lin spelaeologist_N = mkWN (compoundN "luolan" (k12 "tutkija")) ; --UNCHK
lin spelaeology_N = mkWN (compoundN "luolan" (k39 "tutkimus")) ; --UNCHK
lin speleologist_N = mkWN (compoundN "luolan" (k12 "tutkija")) ; --UNCHK
lin speleology_N = mkWN (compoundN "luolan" (k39 "tutkimus")) ; --UNCHK
lin spell_N = mkWN (k1 "loitsu") ; --UNCHK
lin spell_V = mkWV (k53A "vuorottaa") ; --UNCHK
lin spell_V2 = mkWV2 (k53A "vuorottaa") ; --UNCHK
lin spellbinder_N = mkWN (k10 "puhuja") "loistava" ; --UNCHK
lin spellbound_A = mkWA (k99 "haltioissaan") ; --UNCHK
lin speller_N = mkWN (compoundN "oikeinkirjoitus" (k41A "opas")) ; --UNCHK
lin spelling_N = mkWN (k12 "ortografia") ; --UNCHK
lin spelt_N = mkWN (k5A "speltti") ; --UNCHK
lin spelter_N = mkWN (k5A "sinkki") ; --UNCHK
lin spend_V = mkV "kuluttaa" | mkV "kulua" ;
lin spend_V2 = mkV2 "kuluttaa" ;
lin spend_ing_V2V = mkV2V "kuluttaa" ; ---- ?
lin spend_to_V2V = mkV2V "kuluttaa" ; ---- ?
lin spender_N = mkWN (k10 "maksaja") ; --UNCHK
lin spending_N = mkWN (compoundN "rahan" (k1A "käyttö")) ; --UNCHK
lin spendthrift_N = mkWN (k6 "tuhlari") ; --UNCHK
lin spennymoor_PN = foreignPN "Spennymoor" ;
lin sperm_N = mkWN (k3 "siittiö") ; --UNCHK
lin sperm_whale_N = mkWN (k5A "kaskelotti") ; --UNCHK
lin spermaceti_N = mkWN (compoundN "valaanpää" (k9 "vaha")) ; --UNCHK
lin spermatid_N = mkWN "spermatidi" ; --UNCHK
lin spermatocele_N = mkWN (compoundN "spermatose" (k48 "ele")) ; --UNCHK
lin spermatocyte_N = mkWN "spermatosyytti" ; --UNCHK
lin spermatogenesis_N = mkWN "spermatogeneesi" ; --UNCHK
lin spermatophyte_N = mkWN (compoundN "siemen" (k5 "kasvi")) ; --UNCHK
lin spermatozoon_N = mkWN (k3 "siittiö") ; --UNCHK
lin spermicidal_A = mkWA (compoundA "spermisidi" (k38 "nen")) ; --UNCHK
lin spermicide_N = mkWN (k5 "spermisidi") ; --UNCHK
lin spermous_A = mkWA "siittiö-" ; --UNCHK
lin spew_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin spew_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin spew_out_V2 = mkWV2 (k75A "ryöpytä") ; --UNCHK
lin sphagnum_N = mkWN (compoundN "rahka" (k49 "sammal")) ; --UNCHK
lin sphenion_N = mkWN "sphenion" ; --UNCHK
lin sphere_N = mkWN (k1 "pallo") ; --UNCHK
lin spherical_A = mkWA (compoundA "pallon" (k38 "muotoinen")) ; --UNCHK
lin sphericity_N = mkWN (k40 "pyöreys") ; --UNCHK
lin spherocyte_N = mkWN "pallopunasolu" ; --UNCHK
lin spheroid_N = mkWN "pyörähdysellipsoidi" ; --UNCHK
lin spherometer_N = mkWN (compoundN "sfero" (k5 "metri")) ; --UNCHK
lin spherule_N = mkWN (k1 "pallo") "pieni" ; --UNCHK
lin sphincter_N = mkWN (k12 "sulkija") ; --UNCHK
lin sphingine_A = mkWA (compoundA "sfinksi" (k38 "mäinen")) ; --UNCHK
lin sphinx_N = mkWN (k5 "sfinksi") ; --UNCHK
lin sphygmomanometer_N = mkWN (compoundN "verenpaine" (k6 "mittari")) ; --UNCHK
lin spic_N = mkWN (k6 "lattari") ; --UNCHK
lin spicate_A = mkWA (compoundA "tähkä" (k38 "mäinen")) ; --UNCHK
lin spiccato_N = mkWN (k2 "spiccato") ; --UNCHK
lin spice_N = mkWN (k40 "väkevyys") ; --UNCHK
lin spice_V2 = mkWV2 (k53 "höystää") ; --UNCHK
lin spicebush_N = mkWN (compoundN "kalukki" (k41 "pensas")) ; --UNCHK
lin spicemill_N = mkWN (compoundN "mauste" (k1 "mylly")) ; --UNCHK
lin spiciness_N = mkWN (k40 "ruokottomuus") ; --UNCHK
lin spick_A = mkWA (k34A "tahriintumaton") ; --UNCHK
lin spicule_N = mkWN (compoundN "luu" (k5A "piikki")) ; --UNCHK
lin spicy_A = mkWA (k10 "pornahtava") ; --UNCHK
lin spider_N = mkWN (k5A "lukki") ; --UNCHK
lin spiderflower_N = mkWN (compoundN "hämähäkki" (k10A "kukka")) ; --UNCHK
lin spiderwort_N = mkWN (compoundN "soljo" (k5 "kasvi")) ; --UNCHK
lin spidery_A = mkWA (compoundA "hämähäkki" (k38 "mäinen")) ; --UNCHK
lin spiegeleisen_N = mkWN (compoundN "peili" (k9A "rauta")) ; --UNCHK
lin spiel_N = mkWN (k12 "pulina") ; --UNCHK
lin spiel_V = mkWV (k66 "pulista") ; --UNCHK
lin spiel_V2 = mkWV2 (k66 "pulista") ; --UNCHK
lin spiff_N = mkWN (k40 "tyylikkyys") ; --UNCHK
lin spigot_N = mkWN (k9 "hana") ; --UNCHK
lin spike_N = mkWN (k5A "piikki") ; --UNCHK
lin spike_V2 = mkWV2 (k66 "nousta") ; --UNCHK
lin spikelike_A = mkWA (compoundA "pii" (k38 "kkimäinen")) ; --UNCHK
lin spikemoss_N = mkWN (k10 "mähkä") ; --UNCHK
lin spikenard_N = mkWN (compoundN "nardus" (k1 "öljy")) ; --UNCHK
lin spiky_A = mkWA (k10 "terävä") ; --UNCHK
lin spill_N = mkWN "kaatuminen" ; --UNCHK
lin spill_V = mkWV (k75 "levitä") ; --mkWV (k53 "päästää") ;
lin spill_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin spill_out_V = mkWV (k52 "valua") ; --UNCHK
lin spill_over_V = mkWV (k74 "pursuta") ; --UNCHK
lin spillage_N = mkWN (k1A "vuoto") ; --UNCHK
lin spillover_N = mkWN (compoundN "sivu" (k39 "vaikutus")) ; --UNCHK
lin spillway_N = mkWN (compoundN "tulvavesi" (k1 "kouru")) ; --UNCHK
lin spin_N = mkWN (k1 "sävy") ; --UNCHK
lin spin_V = mkWV (k53A "pitkittää") ; --UNCHK
lin spin_V2 = mkWV2 (k53A "pitkittää") ; --UNCHK
lin spin_drier_N = mkWN (k1A "linko") ; --UNCHK
lin spin_off_V2 = mkWV2 (k53A "tuottaa") "ohessa" ; --UNCHK
lin spin_out_V = mkWV (k53A "pitkittää") ; --UNCHK
lin spin_out_V2 = mkWV2 (k53A "pitkittää") ; --UNCHK
lin spinach_N = mkWN (k5A "pinaatti") ; --UNCHK
lin spinal_A = mkWA "selkäydin-" ; --UNCHK
lin spindle_N = mkWN (k12 "värttinä") ; --UNCHK
lin spindle_tree_N = mkWN (compoundN "sorvarin" (k41 "pensas")) ; --UNCHK
lin spindrift_N = mkWN (kH1 "vihma") ; --UNCHK
lin spine_N = mkWN (k5A "piikki") ; --UNCHK
lin spinel_N = mkWN "spinelli" ; --UNCHK
lin spineless_A = mkWA (k34A "selkärangaton") ; --UNCHK
lin spinelessness_N = mkWN (k40 "selkärangattomuus") ; --UNCHK
lin spinet_N = mkWN (k5A "spinetti") ; --UNCHK
lin spinnability_N = mkWN "kehrättävyys" ; --UNCHK
lin spinnable_A = mkWA "kehrättävä" ; --UNCHK
lin spinnaker_N = mkWN (k6 "spinaakkeri") ; --UNCHK
lin spinnbarkeit_N = mkWN (k40 "venyvyys") ; --UNCHK
lin spinner_N = mkWN (k9A "lippa") ; --UNCHK
lin spinney_N = mkWN (k4A "metsikkö") ; --UNCHK
lin spinning_N = mkWN (k17 "kehruu") ; --UNCHK
lin spinning_wheel_N = mkWN (kH1 "rukki") ; --UNCHK
lin spinose_A = mkWA (k38 "piikkinen") ; --UNCHK
lin spinous_A = mkWA (k38 "okainen") ; --UNCHK
lin spinster_N = mkWN (k10 "kehrääjä") ; --UNCHK
lin spinsterhood_N = mkWN (k40 "naimattomuus") ; --UNCHK
lin spiny_A = mkWA (k38 "okainen") ; --UNCHK
lin spiracle_N = mkWN (compoundN "sierain" (k1A "aukko")) ; --UNCHK
lin spiral_A = mkWA (k38 "kierteinen") ; --UNCHK
lin spiral_N = mkN (lin NK {s = d48A "kierre"}) ;
lin spiral_V = mkWV (k52A "kiertyä") ; --UNCHK
lin spire_N = mkWN (k1A "huippu") "tornin" ; --UNCHK
lin spirea_N = mkWN (compoundN "pensas" (k2 "angervo")) ; --UNCHK
lin spirillum_N = mkWN "spirilla" ; --UNCHK
lin spirit_N = mkN "henki" ;
lin spirit_V2 = mkV2 (lin VK {s = c66 "rohkaista"}) ;
lin spirit_lamp_N = mkWN (compoundN "sprii" (k1A "lamppu")) ; --UNCHK
lin spirit_level_N = mkWN (k5 "vatupassi") ; --UNCHK
lin spirit_rapper_N = mkWN (compoundN "henkien" (k10 "kutsuja")) ; --UNCHK
lin spirit_stove_N = mkWN (compoundN "sprii" (k33A "keitin")) ; --UNCHK
lin spiritedly_Adv = mkWAdv (k99 "eloisasti") ; --UNCHK
lin spiritless_A = mkWA (k34A "hengetön") ; --UNCHK
lin spiritual_A = mkWA (k38 "hengellinen") ; --UNCHK
lin spiritual_N = mkWN (k5 "negrospirituaali") ; --UNCHK
lin spiritualism_N = mkWN (k5 "spiritismi") ; --UNCHK
lin spiritualistFem_N = mkWN (k5 "spiritisti") ; --UNCHK
lin spiritualistMasc_N = mkWN (k5 "spiritisti") ; --UNCHK
lin spiritualistic_A = mkWA (k38 "spiritualistinen") ; --UNCHK
lin spirituality_N = mkWN (k5 "spiritismi") ; --UNCHK
lin spiritualization_N = mkWN (compoundN "hen" (k38 "kistäminen")) ; --UNCHK
lin spiritualize_V2 = mkWV2 (k53 "henkistää") ; --UNCHK
lin spirituous_A = mkWA (k10 "väkevä") ; --UNCHK
lin spirochete_N = mkWN "spirokeetta" ; --UNCHK
lin spirogram_N = mkWN (compoundN "hengitys" (k10 "käyrä")) ; --UNCHK
lin spirograph_N = mkWN (k6 "piirturi") "hengityskäyrän" ; --UNCHK
lin spirogyra_N = mkWN "spirogyra" ; --UNCHK
lin spirometer_N = mkWN (compoundN "hengitys" (k6 "mittari")) ; --UNCHK
lin spirometry_N = mkWN (compoundN "hengitys" (k39 "mittaus")) ; --UNCHK
lin spironolactone_N = mkWN "Aldactone" ; --UNCHK
lin spirt_N = mkWN (k39 "purskaus") ; --UNCHK
lin spirt_V = mkWV (k61 "kiriä") ; --UNCHK
lin spirula_N = mkWN (compoundN "spir" (k10 "ula")) ; --UNCHK
lin spit_N = mkWN "yskiminen" ; --UNCHK
lin spit_V = L.spit_V ;
lin spit_V2 = mkWV2 (k67 "syljeskellä") ; --UNCHK
lin spit_out_V2 = mkWV2 (k58A "sylkeä") ; --UNCHK
lin spitball_N = mkWN "spitter" ; --UNCHK
lin spite_N = mkWN (k9 "kauna") ; --UNCHK
lin spite_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin spiteful_A = mkWA (k15 "ilkeä") ; --UNCHK
lin spitefulness_N = mkWN (k9 "kauna") ; --UNCHK
lin spitfire_N = mkWN (compoundN "äkä" (k5 "pussi")) ; --UNCHK
lin spitter_N = mkWN "spitter" ; --UNCHK
lin spitting_N = mkWN "yskiminen" ; --UNCHK
lin spittle_N = mkWN (k7A "sylki") ; --UNCHK
lin spittoon_N = mkWN (compoundN "sylky" (k5A "kuppi")) ; --UNCHK
lin spitz_N = mkWN (compoundN "pysty" (k10 "korva")) ; --UNCHK
lin spiv_N = mkWN (k6 "huijari") ; --UNCHK
lin splash_N = mkWN (k39 "roiskaus") ; --UNCHK
lin splash_V = mkWV (k53A "täplittää") ; --UNCHK
lin splash_V2 = mkWV2 (k53A "täplittää") ; --UNCHK
lin splashboard_N = mkWN (k10 "roiskesuoja") ; --UNCHK
lin splashdown_N = mkWN "laskeutuminen" "veteen" ; --UNCHK
lin splasher_N = mkWN (k10 "roiskesuoja") ; --UNCHK
lin splashy_A = mkWA (k10 "räiskyvä") ; --UNCHK
lin splat_N = mkWN (compoundN "keskus" (k9A "lauta")) "tuolin" "selän" ; --UNCHK
lin splay_A = mkWA "länki-" ; --UNCHK
lin splay_N = mkWN (k39 "levennys") ; --UNCHK
lin splay_V = mkWV (k53A "nyrjäyttää") ; --UNCHK
lin splay_V2 = mkWV2 (k53A "nyrjäyttää") ; --UNCHK
lin splayfoot_N = mkWN (compoundN "latuska" (k9A "jalka")) ; --UNCHK
lin splayfooted_A = mkWA (compoundA "latu" (k38 "skajalkainen")) ; --UNCHK
lin spleen_N = mkWN (k9 "perna") ; --UNCHK
lin spleenwort_N = mkWN (k38 "raunioinen") ; --UNCHK
lin splendid_A = mkWA (k10 "mahtava") ; --UNCHK
lin splendiferous_A = mkWA (k10 "mahtava") ; --UNCHK
lin splendour_N = mkWN (k40 "suuruus") ; --UNCHK
lin splenectomy_N = mkWN (compoundN "pernanpoisto" (k39 "leikkaus")) ; --UNCHK
lin splenetic_A = mkWA "perna-" ; --UNCHK
lin splenic_A = mkWA "perna-" ; --UNCHK
lin splenitis_N = mkWN (compoundN "perna" (k39 "tulehdus")) ; --UNCHK
lin splenius_N = mkWN (compoundN "ohjas" (k39 "lihas")) "pään" ; --UNCHK
lin splenomegaly_N = mkWN (compoundN "suu" (k38 "rentuminen")) "pernan" ; --UNCHK
lin splice_N = mkWN (compoundN "päällekkäis" (k39 "liitos")) ; --UNCHK
lin splice_V2 = mkWV2 (k52 "pujoa") ; --UNCHK
lin splicer_N = mkWN (compoundN "filmi" (k6 "leikkuri")) ; --UNCHK
lin spline_N = mkWN (k9 "kiila") ; --UNCHK
lin splint_N = mkWN (k9 "lasta") ; --UNCHK
lin splinter_N = mkWN (k48 "pirstale") ; --UNCHK
lin splinter_V = mkWV (k74 "hajota") ; --UNCHK
lin splinter_V2 = mkWV2 (k74 "hajota") ; --UNCHK
lin split_N = mkWN (k10 "eripura") ;
lin split_PN = foreignPN "Split" ;
lin split_V = mkWV (k52A "rikkoutua") ; --UNCHK
lin split_V2 = L.split_V2 ;
lin split_up_V = mkWV (k67 "mennä") "rikki" ; --UNCHK
lin split_up_V2 = mkWV2 (k67 "mennä") "rikki" ; --UNCHK
lin splitsville_N = mkWN (compoundN "avio" (k1 "ero")) ; --UNCHK
lin splitter_N = mkWN (compoundN "lankun" (k12 "tekijä")) ; --UNCHK
lin splodge_N = mkWN (k10A "läikkä") ; --UNCHK
lin splosh_V2 = mkWV2 (k53A "pirskottaa") ; --UNCHK
lin splotch_N = mkWN (k10A "läikkä") ; --UNCHK
lin splurge_N = mkWN (k39 "villitys") ; --UNCHK
lin splurge_V = mkWV (k67 "mahtailla") ; --UNCHK
lin splutter_N = mkWN (k39 "soperrus") ; --UNCHK
lin splutter_V = mkWV (k61 "roiskia") "sylkeä" ; --UNCHK
lin splutter_V2 = mkWV2 (k61 "roiskia") "sylkeä" ; --UNCHK
lin spode_N = mkWN "Spode" ; --UNCHK
lin spodumene_N = mkWN "spodumeeni" ; --UNCHK
lin spoil_N = mkWN (k1 "ryöstö") ; --UNCHK
lin spoil_V = mkWV (k73 "pilata") ; --UNCHK
lin spoil_V2 = mkWV2 (k73 "pilata") ; --UNCHK
lin spoilage_N = mkWN (k2 "turmelu") ; --UNCHK
lin spoiler_N = mkWN (k6 "spoileri") ; --UNCHK
lin spoilsport_N = mkWN (k50 "hapannaama") ; --UNCHK
lin spoke_N = mkWN (k9 "piena") ; --UNCHK
lin spoken_A = variants {} ; --
lin spokeshave_N = mkWN (compoundN "kaavin" (k9A "rauta")) ; --UNCHK
lin spokesman_N = mkWN (k10 "edustaja") ; --f420
lin spokesperson_N = mkWN (k10 "edustaja") ; --UNCHK
lin spokeswoman_N = mkWN (k10 "edustaja") ;
lin spoliation_N = mkWN (k1 "ryöstö") ; --UNCHK
lin spondaic_A = mkWA "spondee-" ; --UNCHK
lin spondee_N = mkWN (k20 "spondee") ; --UNCHK
lin spondylarthritis_N = mkWN (compoundN "nivel" (k39 "tulehdus")) "selkärangan" ; --UNCHK
lin spondylitis_N = mkWN (compoundN "nikama" (k39 "tulehdus")) ; --UNCHK
lin spondylolisthesis_N = mkWN (compoundN "nikaman" (k10 "siirtymä")) ; --UNCHK
lin sponge_N = mkWN (compoundN "sieni" (k33 "eläin")) ; --UNCHK
lin sponge_V = mkWV (k73 "kerätä") "pesusieniä" ; --UNCHK
lin sponge_V2 = mkWV2 (k73 "kerätä") "pesusieniä" ; --UNCHK
lin sponge_cake_N = mkWN (compoundN "sieni" (k1A "kakku")) ; --UNCHK
lin sponge_down_V2 = mkWV2 (k66 "pestä") "sienellä" ; --UNCHK
lin sponge_off_V2 = mkWV2 (k73 "kuivata") "sienellä" ; --UNCHK
lin sponge_on_V2 = mkWV2 (k53A "levittää") "sienellä" ; --UNCHK
lin spongefly_N = mkWN (compoundN "harso" (k1A "korento")) ; --UNCHK
lin sponger_N = mkWN (k12 "siipeilijä") ; --UNCHK
lin sponginess_N = mkWN (k40 "huokoisuus") ; --UNCHK
lin spongioblast_N = mkWN (compoundN "varhaishermotuki" (k1 "solu")) ; --UNCHK
lin spongy_A = mkWA (k38 "sienimäinen") ; --UNCHK
lin sponsor_N = mkWN (k12 "tukija") ; --UNCHK
lin sponsor_V2 = mkWV2 (k54A "kustantaa") ; --UNCHK
lin sponsorship_N = mkWN (k5A "sponsorointi") ; --UNCHK
lin spontaneity_N = mkWN (k40 "välittömyys") ; --UNCHK
lin spontaneous_A = mkWA (k34A "välitön") ; --UNCHK
lin spontaneousness_N = mkWN (k40 "välittömyys") ; --UNCHK
lin spoof_N = mkWN (k39 "huijaus") ; --UNCHK
lin spoof_V2 = mkWV2 (k62 "parodioida") ; --UNCHK
lin spook_N = mkWN (k1 "haamu") ; --UNCHK
lin spook_V2 = mkWV2 (k67A "pelotella") ; --UNCHK
lin spooky_A = mkWA (k34A "levoton") ; --UNCHK
lin spool_N = mkWN (k10 "rulla") ; --UNCHK
lin spoon_N = mkWN (k14A "lusikka") ; --UNCHK
lin spoon_V = mkWV (k67A "suudella") ; --UNCHK
lin spoon_V2 = mkWV2 (k67A "suudella") ; --UNCHK
lin spoonbill_N = mkWN (compoundN "kapusta" (k12 "haikara")) ; --UNCHK
lin spoonerism_N = mkWN (compoundN "sanan" (k39 "muunnos")) ; --UNCHK
lin spoonfeed_V2 = mkWV2 (k53 "päästää") "helpolla" ; --UNCHK
lin spoonfeeding_N = mkWN (compoundN "ope" (k38 "ttaminen")) "valmiiksi" "pureskellun" ; --UNCHK
lin spoonful_N = mkWN (k38 "lusikallinen") ; --UNCHK
lin spoor_N = mkWN (k7A "jälki") ; --UNCHK
lin sporadic_A = mkWA (k38 "sporadinen") ; --UNCHK
lin sporangiophore_N = mkWN (k33A "kannatin") "itiöpesäkkeen" ; --UNCHK
lin sporangium_N = mkWN (compoundN "itiö" (k48A "pesäke")) ; --UNCHK
lin spore_N = mkWN (k3 "itiö") ; --UNCHK
lin sporocarp_N = mkWN (k2 "kotelo") "itiöpesäkkeen" ; --UNCHK
lin sporogenous_A = mkWA "itiöitä" "muodostava" ; --UNCHK
lin sporophore_N = mkWN (compoundN "itiön" (k9A "kanta")) ; --UNCHK
lin sporophyll_N = mkWN (compoundN "pesäke" (k7A "lehti")) ; --UNCHK
lin sporophyte_N = mkWN (compoundN "itiö" (k7 "polvi")) ; --UNCHK
lin sporotrichosis_N = mkWN "sporotrikoosi" ; --UNCHK
lin sporozoan_N = mkWN (compoundN "itiö" (k33 "eläin")) ; --UNCHK
lin sporozoite_N = mkWN "sporotsoiitti" ; --UNCHK
lin sporran_N = mkWN (k2 "kukkaro") ; --UNCHK
lin sport_N = mkN "urheilu" ;
lin sport_V = mkWV (k68 "karkeloida") ; --UNCHK
lin sport_V2 = mkWV2 (k68 "karkeloida") ; --UNCHK
lin sportingly_Adv = mkWAdv "urheilullisesti" ; --UNCHK
lin sportive_A = mkWA (k38 "urheilullinen") ; --UNCHK
lin sportiveness_N = mkWN (k40 "vallattomuus") ; --UNCHK
lin sports_car_N = mkWN (compoundN "urheilu" (k1 "auto")) ; --UNCHK
lin sports_coat_N = mkWN (k6 "bleiseri") ; --UNCHK
lin sports_editor_N = mkWN (compoundN "urheilu" (k10 "toimittaja")) ; --UNCHK
lin sports_jacket_N = mkWN (k6 "bleiseri") ; --UNCHK
lin sportscast_N = mkWN (compoundN "urheilu" (k39 "selostus")) ; --UNCHK
lin sportsman_N = mkWN (k12 "urheilija") ; --UNCHK
lin sportsmanlike_A = mkWA (k1 "reilu") ; --UNCHK
lin sportsmanship_N = mkWN (k5 "peli") "reilu" ; --UNCHK
lin sporty_A = mkWA (k38 "urheilullinen") ; --UNCHK
lin spot_N = mkN "kohta" ; --WN (k10A "läikkä") ; --f62 ---ARB
lin spot_V = mkWV (k69 "merkitä") ; --UNCHK
lin spot_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin spot_VS = mkWVS (k69 "merkitä") ; --UNCHK
lin spotless_A = mkWA (k34A "tahriintumaton") ; --UNCHK
lin spotlessness_N = mkWN "saastattomuus" ; --UNCHK
lin spotlight_N = mkWN (k5A "spotti") ; --UNCHK
lin spotlight_V2 = mkWV2 (k53A "asettaa") "valokiilaan" ; --UNCHK
lin spotter_N = mkWN (k12 "tarkkailija") ; --UNCHK
lin spotty_A = mkWA (k38 "rosoinen") ; --UNCHK
lin spousal_A = mkA (mkN "puolisoiden" (mkN "välinen")) ; 
lin spouseFem_N = mkN "puoliso" ;
lin spouseMasc_N = mkN "puoliso" ;
lin spout_N = mkWN (k33A "suutin") ; --UNCHK
lin spout_V = mkWV (k73 "pauhata") ; --UNCHK
lin spout_V2 = mkWV2 (k73 "pauhata") ; --UNCHK
lin spouter_N = mkWN "spouter" ; --UNCHK
lin sprachgefuhl_N = mkWN (compoundN "kieli" (k1 "taju")) ; --UNCHK
lin sprag_N = mkWN (k5 "propsi") ; --UNCHK
lin sprain_N = mkWN (k39 "venähdys") ; --UNCHK
lin sprain_V2 = mkWV2 (k53A "niksauttaa") ; --UNCHK
lin sprat_N = mkWN (compoundN "kiho" (k5 "haili")) ; --UNCHK
lin sprawl_N = mkWN (compoundN "retk" (k39 "otus")) ; --UNCHK
lin sprawl_V = mkV "levittäytyä" ;
lin sprawl_V2 = mkWV2 (k61 "kelliä") ; --UNCHK
lin sprawler_N = mkWN "levittäytyjä" ; --UNCHK
lin sprawly_A = mkWA (compoundA "rönsyi" (k10 "levä")) ; --UNCHK
lin spray_N = mkWN (k33A "suutin") ; --UNCHK
lin spray_V2 = mkWV2 (k53A "suihkuttaa") ; --UNCHK
lin spray_gun_N = mkWN (compoundN "ruisku" (k6 "pistooli")) ; --UNCHK
lin sprayer_N = mkWN (k33A "suutin") ; --UNCHK
lin spraying_N = mkWN (k39 "sumutus") ; --UNCHK
lin spread_N = mkN "levinneisyys" ;
lin spread_V = mkWV (k75 "levitä") ;
lin spread_V2 = mkV2 "levittää" ;
lin spread_out_V = mkWV (k52A "levittäytyä") ; --UNCHK
lin spread_out_V2 = prepV2 OP_spread_V OP_out_Prep ; -- guess-p-verb
lin spreadeagle_V2 = mkWV2 (k53A "löylyttää") ; --UNCHK
lin spreader_N = mkWN (k33A "lähetin") ; --UNCHK
lin spreadsheet_N = mkWN (compoundN "taulukkolaskenta" (k10 "ohjelma")) ; --UNCHK
lin sprechgesang_N = mkWN (k3 "resitaatio") ; --UNCHK
lin spree_N = mkWN (k2 "seikkailu") ; --UNCHK
lin sprig_N = mkWN (k10 "lehvä") ; --UNCHK
lin sprigged_A = mkWA (compoundA "lehvä" (k38 "kuvioinen")) ; --UNCHK
lin sprightliness_N = mkWN (k40 "reippaus") ; --UNCHK
lin sprightly_A = mkWA (k15 "vireä") ; --UNCHK
lin spring_1_N = mkN "kevät" "kevään" "keväitä" ; ---AR mkWN (k39 "hyppäys") ; --f97
lin spring_2_N = variants {} ; ---- sense to be split
lin spring_3_N = variants {} ; ---- sense to be split
lin spring_4_N = variants {} ; ---- sense to be split
lin spring_V = mkV "syöksyä" ; --mkWV (k63 "saada") ;
lin spring_V2 = mkV2 "laukaista" ; --mkWV2 (k63 "saada") ;
lin spring_balance_N = mkWN (compoundN "jousi" (k9A "vaaka")) ; --UNCHK
lin spring_gun_N = mkWN (k39 "viritys") ; --UNCHK
lin spring_mattress_N = mkWN (compoundN "jousi" (k9 "patja")) ; --UNCHK
lin spring_up_V = mkWV (k67 "tulla") ; --UNCHK
lin springboard_N = mkWN (k10A "lähtökohta") ; --UNCHK
lin springbok_N = mkWN (compoundN "hyppy" (k5A "antilooppi")) ; --UNCHK
lin springer_N = mkWN (compoundN "springer" (k5 "spanieli")) ; --UNCHK
lin springfield_PN = foreignPN "Springfield" ;
lin springless_A = mkWA (k34A "ponneton") ; --UNCHK
lin springlike_A = mkWA (compoundA "jousi" (k38 "mainen")) ; --UNCHK
lin springtide_N = mkWN (kH1 "vuoksi") "korkea" ; --UNCHK
lin springtime_N = mkN "kevätaika" "kevätajan" "kevätaikoja" ;
lin springy_A = mkWA (k10 "kimmoisa") ; --UNCHK
lin sprinkle_N = mkWN (k39 "pirskotus") ; --UNCHK
lin sprinkle_V2 = mkWV2 (k53A "ripottaa") ; --UNCHK
lin sprinkler_N = mkWN (k33A "suihkutin") ; --UNCHK
lin sprinkling_N = mkWN (k39 "pirskotus") ; --UNCHK
lin sprint_N = mkWN (k5A "spurtti") ; --UNCHK
lin sprint_V = mkWV (k53A "pyrähtää") ; --UNCHK
lin sprinter_N = mkWN (k6 "sprintteri") ; --UNCHK
lin sprit_N = mkWN "prii" ; --UNCHK
lin sprite_N = mkWN (k1A "tonttu") ; --UNCHK
lin sprites_N = mkWN (compoundN "ylä" (k12 "salama")) ; --UNCHK
lin spritsail_N = mkWN (compoundN "prii" (k48 "purje")) ; --UNCHK
lin spritz_N = mkWN (k39 "suihkaus") ; --UNCHK
lin spritzer_N = mkWN "spritzer" ; --UNCHK
lin sprocket_N = mkWN (k41A "hammas") ; --UNCHK
lin sprocket_wheel_N = mkWN (k41A "ratas") ; --UNCHK
lin sprog_N = mkWN (k10A "toukka") ; --UNCHK
lin sprout_N = mkWN (k9 "vesa") ; --UNCHK
lin sprout_V = mkWV (k52 "versoa") ; --UNCHK
lin sprout_V2 = mkWV2 (k52 "versoa") ; --UNCHK
lin sprout_up_V = mkV "ilmestyä" ;
lin spruce_A = mkWA (k15 "upea") ; --UNCHK
lin spruce_N = mkN "kuusi" "kuusia" ;
lin spruce_V = mkWV (k52A "kaunistautua") ; --UNCHK
lin spruce_V2 = mkWV2 (k52A "kaunistautua") ; --UNCHK
lin spruce_up_V2 = mkWV2 (k52A "kaunistautua") ; --UNCHK
lin spruceness_N = mkWN (k40 "siisteys") ; --UNCHK
lin sprue_N = mkWN (k12 "keliakia") ; --UNCHK
lin spry_A = mkWA (k10 "sukkela") ; --UNCHK
lin spud_N = mkWN (compoundN "puutarha" (k3 "lapio")) ; --UNCHK
lin spue_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin spue_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin spume_N = mkWN (k1A "vaahto") ; --UNCHK
lin spunk_N = mkWN (k1 "sisu") ; --UNCHK
lin spunky_A = mkWA (k15 "rohkea") ; --UNCHK
lin spur_N = mkWN (compoundN "sivu" (k48A "raide")) ; --UNCHK
lin spur_V = mkWV (k53 "kannustaa") ; --UNCHK
lin spur_V2 = mkWV2 (k53 "kannustaa") ;
lin spurge_N = mkWN (k5A "tyräkki") ; --UNCHK
lin spurious_A = mkWA (compoundA "epä" (k1A "aito")) ; --UNCHK
lin spuriousness_N = mkWN (k40 "vääryys") ; --UNCHK
lin spurn_V2 = mkV2 "torjua" ; --mkWV2 (k67 "olla") "hyväksymättä" ;
lin spurner_N = mkWN (compoundN "halvek" (k9 "sija")) ; --UNCHK
lin spurre_V2V = mkV2V "vauhdittaa" ;
lin spurt_N = mkWN (k39 "pyrähdys") ;
lin spurt_V = mkWV (k61 "kiriä") ; --UNCHK
lin sputnik_N = mkWN "sputnik" ; --UNCHK
lin sputter_N = mkWN (k39 "soperrus") ; --UNCHK
lin sputter_V = mkWV (k61 "roiskia") "sylkeä" ; --UNCHK
lin sputter_V2 = mkWV2 (k61 "roiskia") "sylkeä" ; --UNCHK
lin sputum_N = mkWN (k39 "yskös") ; --UNCHK
lin spy_N = mkWN (k5A "agentti") "salainen" ; --UNCHK
lin spy_V = mkWV (k67 "vakoilla") ; --UNCHK
lin spy_V2 = mkWV2 (k67 "vakoilla") ; --UNCHK
lin spyglass_N = mkWN (k6 "kiikari") ; --UNCHK
lin spying_N = mkWN "löytäminen" ; --UNCHK
lin spymaster_N = mkWN (compoundN "tiedustelu" (k4A "päällikkö")) ; --UNCHK
lin spyware_N = mkWN (compoundN "vakoilu" (k10 "ohjelma")) ; --UNCHK
lin squab_N = mkWN (compoundN "kyyhkysen" (k38 "poikanen")) ; --UNCHK
lin squabble_N = mkWN (k13 "kahina") ; --UNCHK
lin squabble_V = mkWV (k66 "kitistä") ; --UNCHK
lin squabbler_N = mkWN "kinastelija" ; --UNCHK
lin squad_N = mkWN (k2 "osasto") ;
lin squadron_N = mkWN (k6 "eskaaderi") ; --UNCHK
lin squalid_A = mkWA (k15 "surkea") ; --UNCHK
lin squall_N = mkWN (k1 "myrsky") ; --UNCHK
lin squall_V = mkWV (k52A "kirkua") ; --UNCHK
lin squalor_N = mkN (lin NK {s = d40 "kurjuus"}) ;
lin squama_N = mkWN (k1 "suomu") ; --UNCHK
lin squamule_N = mkWN (k1 "suomu") ; --UNCHK
lin squamulose_A = mkWA (compoundA "suomu" (k38 "peitteinen")) ; --UNCHK
lin squander_V2 = mkWV2 (k73 "haaskata") ; --UNCHK
lin squandering_N = mkWN (compoundN "tuhlaa" (k40 "vaisuus")) ; --UNCHK
lin squandermania_N = mkWN (compoundN "kulutus" (k12 "hysteria")) ; --UNCHK
lin square_A = mkWA (compoundA "nelikul" (k38 "mainen")) ; --UNCHK
lin square_Adv = mkWAdv (k99 "suoraan") ; --UNCHK
lin square_N = mkWN (k50 "suorakulma") ; --UNCHK
lin square_V = mkWV (k62 "neliöidä") ; --UNCHK
lin square_V2 = mkWV2 (k62 "neliöidä") ; --UNCHK
lin square_away_V2 = mkWV2 (k53 "järjestää") ; --UNCHK
lin square_off_V = mkWV (k66 "ratkaista") ; --UNCHK
lin square_off_against_V3 = mkV3 (mkV "taistella") (casePrep elative) (mkPrep "vastaan" partitive) ;
lin square_toes_N = mkWN (k5 "konservatiivi") ; --UNCHK
lin square_up_V = mkWV (k62 "neliöidä") ; --UNCHK
lin squareness_N = mkWN (compoundN "neliömä" (k40 "isyys")) ; --UNCHK
lin squaretail_N = mkWN (compoundN "luu" (k9 "kala")) "varsieväinen" ; --UNCHK
lin squarish_A = mkWA (compoundA "neli" (k38 "ömäinen")) ; --UNCHK
lin squash_N = mkWN (k5 "squash") ; --UNCHK
lin squash_V = mkWV (k53A "soseuttaa") ; --UNCHK
lin squash_V2 = mkWV2 (k53A "soseuttaa") ; --UNCHK
lin squashy_A = mkWA (k15 "kuohkea") ; --UNCHK
lin squat_A = mkWA (k10 "matala") ; --UNCHK
lin squat_N = mkWN (k39 "kyykistys") ; --UNCHK
lin squat_V = mkWV (k52 "kyykistyä") ; --UNCHK
lin squatness_N = mkWN (k40 "tanakkuus") ; --UNCHK
lin squatter_N = mkWN (compoundN "maan" (k10 "valtaaja")) ; --UNCHK
lin squaw_N = mkWN "squaw" ; --UNCHK
lin squawbush_N = mkWN (compoundN "tri" (k73 "lobata")) "Rhus" ; --UNCHK
lin squawk_N = mkWN (k39 "ruikutus") ; --UNCHK
lin squawk_V = mkWV (k53A "valittaa") ; --UNCHK
lin squawker_N = mkWN (compoundN "kova" (k38 "ääninen")) ; --UNCHK
lin squeak_N = mkWN (k99 "varassa") "hiuskarvan" ; --UNCHK
lin squeak_V = mkWV (k66 "natista") ; --UNCHK
lin squeak_V2 = mkWV2 (k66 "natista") ; --UNCHK
lin squeaker_N = mkWN (k99 "varassa") "hiuskarvan" ; --UNCHK
lin squeaky_A = mkWA (k10 "kirkuva") ; --UNCHK
lin squeal_N = mkWN (compoundN "vin" (k38 "kuminen")) ; --UNCHK
lin squeal_V = mkWV (k54A "myöntää") ; --UNCHK
lin squeal_V2 = mkWV2 (k54A "myöntää") ; --UNCHK
lin squealer_N = mkWN (k1 "possu") ; --UNCHK
lin squeamish_A = mkWA (k1 "nirso") ; --UNCHK
lin squeamishness_N = mkWN "herkkätunteisuus" ; --UNCHK
lin squeegee_N = mkWN (compoundN "ikkuna" (k9 "lasta")) ; --UNCHK
lin squeegee_V2 = mkWV2 (k61A "pyyhkiä") ; --UNCHK
lin squeeze_N = mkWN "tunkeutuminen" ; --UNCHK
lin squeeze_V = mkWV (k56A "ahtaa") ; --UNCHK
lin squeeze_V2 = L.squeeze_V2 ;
lin squeeze_in_V2 = mkV2 "mahduttaa" ;
lin squeeze_out_V2 = mkWV2 (k54A "pusertaa") ; --UNCHK
lin squeezer_N = mkWN (k33 "puristin") ; --UNCHK
lin squelch_N = mkWN (compoundN "kohina" (k9A "salpa")) ; --UNCHK
lin squelch_V = mkWV (k53A "maiskauttaa") ; --UNCHK
lin squelch_V2 = mkWV2 (k53A "maiskauttaa") ; --UNCHK
lin squib_N = mkWN (k38 "sähikäinen") ; --UNCHK
lin squid_N = mkWN (k6 "kalmari") ; --UNCHK
lin squiffy_A = mkWA (k10 "oleva") "tillin-tallin" ; --UNCHK
lin squiggle_N = mkWN (k39 "töherrys") ; --UNCHK
lin squiggly_A = mkWA (k38 "kiemurainen") ; --UNCHK
lin squill_N = mkWN (compoundN "sini" (k9 "lilja")) ; --UNCHK
lin squilla_N = mkWN (compoundN "meri" (k6 "sipuli")) ; --UNCHK
lin squinch_N = mkWN (compoundN "tuki" (k5 "holvi")) ; --UNCHK
lin squinched_A = mkWA (k99 "sirrillään") ; --UNCHK
lin squint_N = mkWN (k39 "siristys") "silmien" ; --UNCHK
lin squint_V = mkWV (k52 "katsoa") "kieroon" ; --UNCHK
lin squinter_N = mkWN "karsastaja" ; --UNCHK
lin squinty_A = mkWA (k1 "kiero") ; --UNCHK
lin squire_N = mkWN (compoundN "kartanon" (k9 "herra")) ; --UNCHK
lin squire_V2 = mkWV2 (k56A "saattaa") ; --UNCHK
lin squirearchy_N = mkWN (compoundN "maa-" (k1 "aatelisto")) ; --UNCHK
lin squirm_N = mkWN (k2 "kiemurtelu") ; --UNCHK
lin squirm_V = mkWV (k61A "vääntelehtiä") ; --UNCHK
lin squirrel_N = mkWN (k10 "orava") ; --UNCHK
lin squirrelfish_N = mkWN (compoundN "orava" (k9 "kala")) ; --UNCHK
lin squirt_N = mkWN (k39 "purskaus") ; --UNCHK
lin squirt_V = mkWV (k53A "ruiskuttaa") ; --UNCHK
lin squirt_V2 = mkWV2 (k53A "ruiskuttaa") ; --UNCHK
lin squish_N = mkWN (k12 "lotina") ; --UNCHK
lin sri_lankan_A = mkWA (compoundA "ceyloni" (k38 "lainen")) ; --UNCHK
lin sri_lankan_N = mkWN (compoundN "srilan" (k38 "kalainen")) ; --UNCHK
lin ss_N = mkWN "SS" ; --UNCHK
lin st_petersburg_PN = mkPN "Pietari" ;
lin stab_N = mkWN (k39 "yritys") ; --UNCHK
lin stab_V = mkWV (k66 "tökkäistä") ; --UNCHK
lin stab_V2 = L.stab_V2 ;
lin stabber_N = mkWN (k10 "puukottaja") ; --UNCHK
lin stabile_A = mkWA (k34A "järkähtämätön") ; --UNCHK
lin stabile_N = mkWN (k39 "veistos") ; --UNCHK
lin stability_N = mkN "vakaus" ;
lin stabilization_N = mkWN (k5A "stabilointi") ; --UNCHK
lin stabilize_V = mkV "vakiinnuttaa" ;
lin stabilize_V2 = mkV2 "vakiinnuttaa" ;
lin stabilizer_N = mkWN (k33 "vakain") ; --UNCHK
lin stable_A = mkWA (k17 "vakaa") ;
lin stable_N = mkWN (k5 "talli") ; --UNCHK
lin stable_V2 = mkWV2 (k53A "pitää") "tallissa" ; --UNCHK
lin stable_companion_N = mkWN (k38 "hevonen") ; --UNCHK
lin stableboy_N = mkWN (compoundN "talli" (k5A "renki")) ; --UNCHK
lin stableman_N = mkWN (compoundN "talli" (k5A "renki")) ; --UNCHK
lin stablemate_N = mkWN (k38 "hevonen") ; --UNCHK
lin staccato_A = mkWA (k38 "katkonainen") ; --UNCHK
lin staccato_Adv = mkWAdv "staccato" ; --UNCHK
lin stachyose_N = mkWN (compoundN "tetra" (k5 "sakkaridi")) ; --UNCHK
lin stack_N = mkWN (compoundN "pino" (k5 "muisti")) ; --UNCHK
lin stack_V2 = mkV2 "pinota" partitive ; --mkWV2 (k62 "peukaloida") ;
lin stack_up_V = mkWV (k74 "pinota") ; --UNCHK
lin stack_up_V2 = mkWV2 (k74 "pinota") ; --UNCHK
lin stacker_N = mkWN "pinoaja" ; --UNCHK
lin stacks_N = mkWN (compoundN "kirja" (k2 "varasto")) ; --UNCHK
lin stacte_N = mkWN (compoundN "mastiksi" (k9 "pihka")) ; --UNCHK
lin staddle_N = mkWN (k13 "alusta") ; --UNCHK
lin stadium_N = mkN (lin NK {s = d06 "stadion"}) ;
lin staff_1_N = mkN "henkilökunta" ;
lin staff_2_N = mkN "sauva" ;
lin staff_N = mkN "henkilökunta" ;
lin staff_V2 = mkWV2 (k53A "miehittää") ; --UNCHK
lin staff_office_N = mkWN (compoundN "henkilöstö" (k2 "osasto")) ; --UNCHK
lin stafford_PN = foreignPN "Stafford" ;
lin stag_N = mkWN (compoundN "uros" (k7 "hirvi")) ; --UNCHK
lin stag_V = variants {} ; --
lin stage_N = mkN "vaihe" | mkN "näyttämö" ; --- split
lin stage_V = mkWV (k71 "tehdä") ; --UNCHK
lin stage_V2 = mkWV2 (k71 "tehdä") ; --UNCHK
lin stage_whisper_N = mkWN (compoundN "teatteri" (k39 "kuiskaus")) ; --UNCHK
lin stagecraft_N = mkWN (compoundN "näyttämö" (k48A "taide")) ; --UNCHK
lin stagehand_N = mkWN (compoundN "näyttämö" (k10 "avustaja")) ; --UNCHK
lin stager_N = mkWN (compoundN "näyttämö" (k6 "mestari")) ; --UNCHK
lin stagflation_N = mkWN (k3 "stagflaatio") ; --UNCHK
lin stagflationary_A = mkWA "stagflaation" ; --UNCHK
lin stagger_N = mkWN (k2 "horjahtelu") ; --UNCHK
lin stagger_V = mkV "horjua" ; --mkWV (k53 "järjestää") ;
lin staggerbush_N = mkWN (k41 "pensas") "putoava" ; --UNCHK
lin staggerer_N = mkWN "hoipertelija" ; --UNCHK
lin staggeringly_Adv = mkWAdv (k99 "suunnattomasti") ; --UNCHK
lin staggers_N = mkWN "hypomagnesemia" ; --UNCHK
lin staghound_N = mkWN (compoundN "hirvi" (k10 "koira")) ; --UNCHK
lin staginess_N = mkWN (k40 "teatraalisuus") ; --UNCHK
lin staging_N = mkWN (compoundN "pois" (k38 "taminen")) ; --UNCHK
lin stagnancy_N = mkWN (k40 "lamaantuneisuus") ; --UNCHK
lin stagnant_A = mkWA (k47 "kuollut") "pystyyn" ; --UNCHK
lin stagnate_V = mkWV (k67 "olla") "vapaalla" ; --UNCHK
lin stagnation_N = mkWN (k40 "lamaantuneisuus") ; --UNCHK
lin stagy_A = mkWA (k38 "teennäinen") ; --UNCHK
lin staid_A = mkWA (k17 "vakaa") ; --UNCHK
lin staidness_N = mkWN (k40 "juhlavuus") ; --UNCHK
lin stain_N = mkWN (k10A "läikkä") ; --UNCHK
lin stain_V = mkWV (k73 "värjätä") ; --UNCHK
lin stain_V2 = mkWV2 (k73 "värjätä") ; --UNCHK
lin stainability_N = mkWN "värjäytyvyys" ; --UNCHK
lin stainable_A = mkWA "värjäytyvä" ; --UNCHK
lin stainer_N = mkWN (k10 "värjääjä") ; --UNCHK
lin staining_N = mkWN "värjääminen" ; --UNCHK
lin stainless_1_A = mkWA (k41A "puhdas") ; --UNCHK
lin stainless_2_A = mkWA (k41A "puhdas") ; --UNCHK
lin stair_N = mkWN (k10 "askelma") ; --UNCHK
lin staircase_N = mkWN (k4A "portaikko") ; --UNCHK
lin stairhead_N = mkWN (compoundN "ylä" (k18 "pää")) "portaiden" ; --UNCHK
lin stairway_N = mkWN (k4A "portaikko") ; --UNCHK
lin stairwell_N = mkWN (compoundN "porras" (k10 "käytävä")) ; --UNCHK
lin stake_N = mkN "osallisuus" ;
lin stake_V2 = mkWV2 (k73 "riskeerata") ; ---ARB
lin stake_holder_N = mkWN (compoundN "pantin" (k10 "pitäjä")) ; --UNCHK
lin stakeout_N = mkWN (compoundN "silmällä" (k1A "pito")) ; --UNCHK
lin stalactite_N = mkWN (compoundN "tippukivi" (k1A "puikko")) ; --UNCHK
lin stalagmite_N = mkWN (compoundN "tippukivi" (k41 "pylväs")) ; --UNCHK
lin stale_A = mkA "ummehtunut" ; ---ARB
lin stale_V = mkWV (k53A "lorottaa") ; --UNCHK
lin stalemate_N = mkWN (kH1 "patti") ; --UNCHK
lin stalemate_V2 = mkWV2 (k56 "ajaa") "pattitilanteeseen" ; --UNCHK
lin stalk_N = mkWN (k5A "käynti") ; --UNCHK
lin stalk_V = mkWV (k53A "köpittää") ; --UNCHK
lin stalk_V2 = mkWV2 (k53A "köpittää") ; --UNCHK
lin stalker_N = mkWN (k12 "ahdistelija") ; --UNCHK
lin stall_N = mkWN (k39 "viivytys") ; --UNCHK
lin stall_V = mkWV (k67 "väistellä") ; --UNCHK
lin stall_V2 = mkV2 "viivyttää" partitive ; --mkWV2 (k67 "väistellä") ;
lin stallion_N = mkWN (k48 "ori") ; --UNCHK
lin stalwart_A = mkWA (k15 "urhea") ; --UNCHK
lin stalwart_N = mkWN (k10 "kannattaja") "uskollinen" ; --UNCHK
lin stalybridge_PN = foreignPN "Stalybridge" ;
lin stamen_N = mkWN (k48A "hede") ; --UNCHK
lin stamford_PN = foreignPN "Stamford" ;
lin stamina_N = mkWN (k40 "kestävyys") ; --UNCHK
lin stammel_N = mkWN (k41A "villakangas") ; --UNCHK
lin stammer_N = mkWN (k39 "änkytys") ; --UNCHK
lin stammer_V = mkWV (k67A "takellella") ; --UNCHK
lin stammer_V2 = mkWV2 (k67A "takellella") ; --UNCHK
lin stammerer_N = mkWN (k10 "änkyttäjä") ; --UNCHK
lin stamp_1_N = mkN "leima" ;
lin stamp_2_N = mkN "leima" ;
lin stamp_V = mkWV (k67A "luokitella") ; --UNCHK
lin stamp_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin stamp_album_N = mkWN (compoundN "postimerkki" (k3 "kansio")) ; --UNCHK
lin stamp_collector_N = mkWN (k12 "postimerkkeilijä") ; --UNCHK
lin stamp_dealer_N = mkWN (compoundN "postimerkki" (k41 "kauppias")) ; --UNCHK
lin stamp_duty_N = mkWN (compoundN "leima" (k1 "vero")) ; --UNCHK
lin stamp_out_V2 = mkWV2 (k64 "lyödä") ; --UNCHK
lin stampede_N = mkWN (k39 "ryntäys") ; --UNCHK
lin stampede_V = mkWV (k73A "rynnätä") "pakoon" ; --UNCHK
lin stampede_V2 = mkWV2 (k73A "rynnätä") "pakoon" ; --UNCHK
lin stamper_N = mkWN (k33 "murskain") ; --UNCHK
lin stamping_ground_N = mkWN (compoundN "vaki" (k9A "paikka")) ; --UNCHK
lin stance_N = mkWN (k1A "asento") ; --UNCHK
lin stanch_V2 = mkWV2 (k53A "tyrehdyttää") ; --UNCHK
lin stanchion_N = mkWN (k10A "tolppa") ; --UNCHK
lin stand_N = mkWN (compoundN "puolustus" (k10 "asema")) ; --UNCHK
lin stand_V = L.stand_V ;
lin stand_V2 = mkV2 (mkV "kestää") ;
lin stand_about_V = advV OP_stand_V OP_about_Adv ; -- guess-p-verb
lin stand_around_V = advV OP_stand_V OP_around_Adv ; -- guess-p-verb
lin stand_aside_V = advV OP_stand_V OP_aside_Adv ; -- guess-p-verb
lin stand_back_V = mkWV (k52A "siirtyä") ; --UNCHK
lin stand_by_V = mkWV (k67 "olla") "valmiina" ; --UNCHK
lin stand_by_V2 = mkWV2 (k67 "olla") "valmiina" ; --UNCHK
lin stand_down_V = advV OP_stand_V OP_down_Adv ; -- guess-p-verb
lin stand_for_V2 = mkWV2 (k53A "sietää") ; --UNCHK
lin stand_in_for_V2 = prepV2 (advV OP_stand_V OP_in_Adv ) OP_for_Prep ; -- guess-p-verb
lin stand_out_V = mkWV (k53 "vastustaa") ; --UNCHK
lin stand_up_V = mkWV (k53 "puolustaa") ; --UNCHK
lin stand_up_V2 = mkWV2 (k53 "puolustaa") ; --UNCHK
lin stand_up_for_V2 = prepV2 (advV OP_stand_V OP_up_Adv ) OP_for_Prep ; -- guess-p-verb
lin stand_up_to_V2 = prepV2 (advV OP_stand_V OP_up_Adv ) OP_to_Prep ; -- guess-p-verb
lin standard_A = mkA "vakiintunut" ; --f65
lin standard_N = mkN "standardi" ;
lin standardization_N = mkWN (k39 "normitus") ; --UNCHK
lin standardize_V2 = mkWV2 (k62 "standardisoida") ; --UNCHK
lin standardizer_N = mkWN (compoundN "standardi" (k10 "soija")) ; --UNCHK
lin standby_A = mkWA "vara-" ; --UNCHK
lin standby_N = mkWN (compoundN "hätä" (k9 "vara")) ; --UNCHK
lin standdown_N = mkWN "tilapäinen" "vetäytyminen" ; --UNCHK
lin standee_N = mkWN (compoundN "pahvi" (k10 "kuva")) ; --UNCHK
lin stander_N = mkWN (k10 "seisova") ; --UNCHK
lin standing_N = mkWN (compoundN "sei" (k38 "sominen")) ; --UNCHK
lin standoffish_A = mkWA (k38 "etäinen") ; --UNCHK
lin standoffishness_N = mkWN (k40 "sulkeutuneisuus") ; --UNCHK
lin standpipe_N = mkWN (compoundN "pysty" (k7 "putki")) ; --UNCHK
lin standpoint_N = mkWN (compoundN "näkö" (k9A "kanta")) ;
lin standstill_N = mkWN (k39 "pysähdys") ; --UNCHK
lin stanford_PN = foreignPN "Stanford" ;
lin stanhopea_N = mkWN (k13 "orkidea") ; --UNCHK
lin stanley_PN = foreignPN "Port Stanley" ;
lin stannic_A = mkWA "tina-" ; --UNCHK
lin stannite_N = mkWN (compoundN "stan" (k5A "niitti")) ; --UNCHK
lin stanza_N = mkWN (k2 "säkeistö") ; --UNCHK
lin stapelia_N = mkWN (compoundN "raato" (k10A "kukka")) ; --UNCHK
lin stapes_N = mkWN (k33 "jalustin") ; --UNCHK
lin staphylococcal_A = mkWA "stafylokokin" ; --UNCHK
lin staphylococcus_N = mkWN (k5A "stafylokokki") ; --UNCHK
lin staple_A = mkWA "pää-" ; --UNCHK
lin staple_N = mkWN "peruselintarvike" ; --UNCHK
lin staple_V2 = mkWV2 (k52A "nitoa") ; --UNCHK
lin stapler_N = mkWN (k10 "nitoja") ; --UNCHK
lin stapling_machine_N = mkWN (k10 "nitoja") ; --UNCHK
lin star_N = L.star_N ;
lin star_V2 = mkV2 "esiintyä" inessive ; ---- sense
lin starboard_A = mkWA (k38 "puoleinen") "tyyrpuurin" ; --UNCHK
lin starboard_N = mkWN (k5 "tyyrpuuri") ; --UNCHK
lin starboard_V2 = mkWV2 (k73 "ohjata") ; --UNCHK
lin starch_N = mkWN (k5A "tärkki") ; --UNCHK
lin starch_V2 = mkWV2 (k73A "tärkätä") ; --UNCHK
lin starchless_A = mkWA "tärkkelyksetön" ; --UNCHK
lin starchlike_A = mkWA (compoundA "tärkkelyspi" (k38 "toinen")) ; --UNCHK
lin starchy_A = mkWA (compoundA "tärkkelyspi" (k38 "toinen")) ; --UNCHK
lin stardom_N = mkWN (k40 "tähteys") ; --UNCHK
lin stardust_N = mkWN (k9A "romantiikka") ; --UNCHK
lin stare_N = mkWN (compoundN "tuij" (k39 "otus")) ; --UNCHK
lin stare_V = mkWV (k53A "tuijottaa") ; --UNCHK
lin stare_V2 = mkWV2 (k53A "tuijottaa") ; --UNCHK
lin stare_down_V2 = mkWV2 (k53A "häkellyttää") "katseellaan" ; --UNCHK
lin starer_N = mkWN (compoundN "tuij" (k12 "ottelija")) ; --UNCHK
lin starets_N = mkWN (compoundN "ohjaaja" (k39 "vanhus")) ; --UNCHK
lin starfish_N = mkWN (compoundN "meri" (k7A "tähti")) ; --UNCHK
lin starflower_N = mkWN (compoundN "sarja" (k5A "tähdikki")) ; --UNCHK
lin stargazer_N = mkWN (compoundN "taivaan" (k10 "tähystäjä")) ; --UNCHK
lin stargazing_N = mkWN (k2 "tarkkailu") "tähtien" ; --UNCHK
lin stark_A = mkWA (k1 "karu") ;
lin stark_Adv = mkWAdv (k99 "täysin") ; --UNCHK
lin starkers_A = mkWA (k10 "oleva") "munasillaan" ; --UNCHK
lin starkness_N = mkWN (k40 "koruttomuus") ; --UNCHK
lin starless_A = mkWA (k34A "tähdetön") ; --UNCHK
lin starlet_N = mkWN (k38 "tähtönen") ; --UNCHK
lin starlight_N = mkWN (k1 "valo") "tähtien" ; --UNCHK
lin starlike_A = mkWA (compoundA "tähden" (k38 "muotoinen")) ; --UNCHK
lin starling_N = mkWN (k38 "kottarainen") ; --UNCHK
lin starlit_A = mkWA (compoundA "tähti" (k41A "kirkas")) ; --UNCHK
lin starry_A = mkWA (k41A "kirkas") ; --UNCHK
lin starship_N = mkWN (compoundN "avaruus" (k39 "alus")) ; --UNCHK
lin start_N = mkN "alku" ;
lin start_V = mkV "aloittaa" ;
lin start_V2 = mkV2 "aloittaa" ;
lin start_ing_VV = mkVV (mkV "alkaa" "alkoi") ;
lin start_off_V = advV OP_start_V OP_off_Adv ; -- guess-p-verb
lin start_off_V2 = prepV2 OP_start_V OP_off_Prep ; -- guess-p-verb
lin start_off_on_V2 = prepV2 (advV OP_start_V OP_off_Adv ) OP_on_Prep ; -- guess-p-verb
lin start_on_V2 = prepV2 OP_start_V OP_on_Prep ; -- guess-p-verb
lin start_on_at_V2 = prepV2 (advV OP_start_V OP_on_Adv ) OP_at_Prep ; -- guess-p-verb
lin start_out_V = advV OP_start_V OP_out_Adv ; -- guess-p-verb
lin start_out_as_V2 = prepV2 (advV OP_start_V OP_out_Adv ) OP_as_Prep ; -- guess-p-verb
lin start_out_to_V2 = prepV2 (advV OP_start_V OP_out_Adv ) OP_to_Prep ; -- guess-p-verb
lin start_over_V = advV OP_start_V OP_over_Adv ; -- guess-p-verb
lin start_to_VV = mkVV (mkV "alkaa" "alkoi") ;
lin start_up_V = mkWV (k53 "perustaa") ; --UNCHK
lin start_up_V2 = mkWV2 (k53 "perustaa") ; --UNCHK
lin starter_1_N = mkN "alkupala" ;
lin starter_2_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK ---- sense to be split
lin starter_3_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK ---- sense to be split
lin starter_4_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK ---- sense to be split
lin starter_5_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK ---- sense to be split
lin starter_6_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK ---- sense to be split
lin starter_7_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK ---- sense to be split
lin starter_N = mkWN (compoundN "käymis" (k48 "aine")) ; --UNCHK
lin starting_gate_N = mkWN (compoundN "lähtö" (k5A "portti")) ; --UNCHK
lin starting_point_N = mkWN (compoundN "aloitus" (k48 "piste")) ; --UNCHK
lin starting_post_N = mkWN (k1A "lähtö") ; --UNCHK
lin startle_N = mkWN (k39 "hätkähdys") ; --UNCHK
lin startle_V2 = mkWV2 (k53A "säikäyttää") ; --UNCHK
lin startling_A = mkWA (k10 "pelottava") ; --UNCHK
lin startup_N = mkWN (compoundN "per" (k38 "ustaminen")) ; --UNCHK
lin starvation_N = mkWN "nälkiinnyttäminen" ; --UNCHK
lin starve_V = mkWV (k52A "nääntyä") ; --UNCHK
lin starve_V2 = mkWV2 (k52A "nääntyä") ; --UNCHK
lin starveling_N = mkWN (compoundN "nälkä" (k7A "kurki")) ; --UNCHK
lin stash_V2 = mkWV2 (k62 "varastoida") ; --UNCHK
lin stash_away_V2 = mkWV2 (k62 "varastoida") ; --UNCHK
lin stasis_N = mkWN (k39 "salpaus") ; --UNCHK
lin state_1_N = mkN "valtio" ;
lin state_2_N = mkN "tila" ;
lin state_N = mkN "valtio" ;
lin state_V2 = mkWV2 (k74A "todeta") ;
lin state_VS = mkWVS (k74A "todeta") | mkVS "lausua" ;
lin statecraft_N = mkWN (k12 "diplomatia") ; --UNCHK
lin statehood_N = mkN "valtiollisuus" ;
lin statehouse_N = mkWN (compoundN "valtiopäivä" (k1 "talo")) ; --UNCHK
lin stateless_A = mkWA (k34A "kansalaisuudeton") ; --UNCHK
lin stateliness_N = mkWN (k40 "ylevyys") ; --UNCHK
lin stately_A = mkWA (k41A "arvokas") ; --UNCHK
lin statement_N = mkN "lausunto" ;
lin stater_N = mkWN (k41A "asukas") ; --UNCHK
lin stateroom_N = mkWN (compoundN "juhla" (k5 "sali")) ; --UNCHK
lin statesman_N = mkWN (compoundN "valtio" (k42 "mies")) ; --UNCHK
lin statesmanlike_A = mkWA (compoundA "valtio" (k38 "miesmäinen")) ; --UNCHK
lin statesmanship_N = mkWN (k12 "diplomatia") ; --UNCHK
lin stateswoman_N = mkWN (compoundN "valtio" (k42 "mies")) "naispuolinen" ; --UNCHK
lin statewide_A = mkWA (compoundA "maan" (k38 "laajuinen")) ; --UNCHK
lin static_A = mkWA (k38 "staattinen") ; --UNCHK
lin statics_N = mkWN (k14A "statiikka") ; --UNCHK
lin station_1_N = mkWN (k10 "asema") ;
lin station_2_N = mkWN (k10 "asema") ;
lin station_V2 = mkWV2 (k54A "löytää") "sijoituspaikka" ; --UNCHK
lin station_waggon_N = mkWN (k6 "farmari") ; --UNCHK
lin stationariness_N = mkWN (k40 "pysyvyys") "paikallaan" ; --UNCHK
lin stationary_A = mkWA (k10 "oleva") "paikallaan" ; --UNCHK
lin stationer_N = mkWN (compoundN "paperi" (k41 "kauppias")) ; --UNCHK
lin stationery_N = mkWN (compoundN "kirje" (k6 "paperi")) ; --UNCHK
lin stationmaster_N = mkWN (compoundN "asema" (k4A "päällikkö")) ; --UNCHK
lin statistic_N = mkWN (k2 "tilasto") ; --UNCHK
lin statistical_A = mkWA (k38 "tilastollinen") ;
lin statisticianFem_N = mkWN (compoundN "tilasto" (k4A "matemaatikko")) ; --UNCHK
lin statisticianMasc_N = mkWN (compoundN "tilasto" (k4A "matemaatikko")) ; --UNCHK
lin statistics_N = mkN "tilasto" ; ---ARB mkWN (compoundN "tilasto" (k48A "tiede")) ;
lin stative_A = mkWA (compoundA "statiivi" (k38 "nen")) ; --UNCHK
lin stator_N = mkWN (k6 "staattori") ; --UNCHK
lin statuary_A = mkWA "kuvanveiston" ; --UNCHK
lin statue_N = mkN "patsas" ; --mkWN (k39 "veistos") ;
lin statuesque_A = mkWA (k38 "veistoksellinen") ; --UNCHK
lin statuette_N = mkWN (compoundN "pienois" (k39 "veistos")) ; --UNCHK
lin stature_N = mkN "koko" ; --WN (k40 "pituus") ;
lin status_N = mkN "asema" ;
lin status_quo_N = mkWN (k9 "tila") "vallitseva" ; --UNCHK
lin statute_N = mkWN (kH1 "laki") ; --UNCHK
lin statute_book_N = mkWN (compoundN "laki" (k9 "kirja")) ; --UNCHK
lin statutory_A = mkWA (compoundA "laki" (k38 "sääteinen")) ;
lin staunch_A = mkWA (k38 "uskollinen") ; --UNCHK
lin staunch_V2 = mkWV2 (k53A "tyrehdyttää") ; --UNCHK
lin staunchness_N = mkWN (k40 "uskollisuus") ; --UNCHK
lin staurikosaur_N = mkWN "staurikosaurus" ; --UNCHK
lin stave_N = mkWN (kH1 "puola") ; --UNCHK
lin stave_V = mkWV (k52A "rikkoa") ; --UNCHK
lin stave_V2 = mkWV2 (k52A "rikkoa") ; --UNCHK
lin stave_in_V2 = mkWV2 (k52A "rikkoa") ; --UNCHK
lin stave_off_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin stay_N = mkWN (k2 "oleskelu") ;
lin stay_V = mkV "jäädä" | mkV "pysyä" ;
lin stay_VA = mkVA (mkV "pysyä") (mkPrep essive) ;
lin stay_away_V = mkWV (k52 "pysyä") "erossa" ; --UNCHK
lin stay_away_from_V2 = prepV2 (advV OP_stay_V OP_away_Adv ) OP_from_Prep ; -- guess-p-verb
lin stay_in_V = advV OP_stay_V OP_in_Adv ; -- guess-p-verb
lin stay_on_V = mkWV (k67A "pysytellä") ; --UNCHK
lin stay_out_V = advV OP_stay_V OP_out_Adv ; -- guess-p-verb
lin stay_over_V = mkWV (k63 "jäädä") "yöksi" ; --UNCHK
lin stay_up_V = mkWV (k52 "valvoa") ; --UNCHK
lin stayer_N = mkWN (k40 "kestävyys") ; --UNCHK
lin staysail_N = mkWN (compoundN "harus" (k48 "purje")) ; --UNCHK
lin stead_N = mkWN (k9 "sija") ; --UNCHK
lin steadfast_A = mkWA (k38 "uskollinen") ; --UNCHK
lin steadfastness_N = mkWN (k40 "järkkymättömyys") ; --UNCHK
lin steadiness_N = mkWN (kH1 "vakaus") ; --UNCHK
lin steady_A = mkWA (k17 "vakaa") ; --f69
lin steady_Adv = mkWAdv (k99 "vakaasti") ; --UNCHK
lin steady_N = mkWN (k41A "rakas") ; --UNCHK
lin steady_V = mkWV (k52A "rauhoittua") ; --UNCHK
lin steady_V2 = mkWV2 (k52A "rauhoittua") ; --UNCHK
lin steak_N = mkWN (k5 "pihvi") ; --UNCHK
lin steakhouse_N = mkWN (compoundN "pihvi" (k12 "ravintola")) ; --UNCHK
lin steal_N = mkWN "steal" ; --UNCHK
lin steal_V = mkWV (k53A "ottaa") "varaslähtö" ; --UNCHK
lin steal_V2 = mkV2 "varastaa" ; ---ARB mkWV2 (k53A "ottaa") "varaslähtö" ;
lin steal_away_V = mkWV (k67 "hiippailla") "ulos" ; --UNCHK
lin steal_out_V = advV OP_steal_V OP_out_Adv ; -- guess-p-verb
lin steal_over_V2 = prepV2 OP_steal_V OP_over_Prep ; -- guess-p-verb
lin steal_up_V = advV OP_steal_V OP_up_Adv ; -- guess-p-verb
lin steal_up_on_V2 = prepV2 (advV OP_steal_V OP_up_Adv ) OP_on_Prep ; -- guess-p-verb
lin stealth_N = mkWN (k40 "salamyhkäisyys") ; --UNCHK
lin stealthy_A = mkWA (k38 "vaivihkainen") ; --UNCHK
lin steam_N = mkWN (k1 "höyry") ; --UNCHK
lin steam_V = mkWV (k53A "höyryttää") ; --UNCHK
lin steam_V2 = mkWV2 (k53A "höyryttää") ; --UNCHK
lin steam_boiler_N = mkWN (compoundN "höyry" (k12 "kattila")) ; --UNCHK
lin steam_coal_N = mkWN (k24 "hiili") ; --UNCHK
lin steam_engine_N = mkWN "mäntähöyrykone" ; --UNCHK
lin steam_heat_N = mkWN (compoundN "höyry" (k39 "lämmitys")) ; --UNCHK
lin steamboat_N = mkWN (compoundN "höyry" (k39 "alus")) ; --UNCHK
lin steamer_N = mkWN (compoundN "hieta" (k14A "simpukka")) ; --UNCHK
lin steamfitter_N = mkWN (k10 "asentaja") "höyrykoneen" ; --UNCHK
lin steamroller_N = mkWN (compoundN "tie" (k10 "jyrä")) ; --UNCHK
lin steamroller_V2 = mkWV2 (k73 "jyrätä") ; --UNCHK
lin steamship_N = mkWN (compoundN "höyry" (k9 "laiva")) ; --UNCHK
lin steamy_A = mkWA (k38 "eroottinen") ; --UNCHK
lin stearic_A = mkWA "steariini-" ; --UNCHK
lin stearin_N = mkWN (k5 "steariini") ; --UNCHK
lin steatopygia_N = mkWN (compoundN "rasvapaka" (k40 "raisuus")) ; --UNCHK
lin steatorrhea_N = mkWN (compoundN "rasva" (k6 "ripuli")) ; --UNCHK
lin steed_N = mkWN (k1 "ratsu") ; --UNCHK
lin steel_N = L.steel_N ;
lin steel_V2 = mkWV2 (k53A "pinnoittaa") ; --UNCHK
lin steelmaker_N = mkWN (compoundN "teräs" (k38 "työläinen")) ; --UNCHK
lin steelworks_N = mkWN (compoundN "teräs" (k41A "tehdas")) ; --UNCHK
lin steely_A = mkWA (compoundA "teräksen" (k10 "luja")) ; --UNCHK
lin steelyard_N = mkWN (compoundN "käsi" (k6 "puntari")) ; --UNCHK
lin steenbok_N = mkWN (compoundN "puna-" (k5A "antilooppi")) ; --UNCHK
lin steep_A = mkWA (k10A "jyrkkä") ;
lin steep_N = mkWN (k48A "jyrkänne") ; --UNCHK
lin steep_V = mkWV (k53A "uuttaa") ; --UNCHK
lin steep_V2 = mkWV2 (k53A "uuttaa") ; --UNCHK
lin steepen_V = mkWV (k54A "jyrkentää") ; --UNCHK
lin steepen_V2 = mkWV2 (k54A "jyrkentää") ; --UNCHK
lin steeper_N = mkWN (compoundN "liotus" (k12 "astia")) ; --UNCHK
lin steepish_A = mkWA "jyrkähkö" ; --UNCHK
lin steeple_N = mkWN (k1A "huippu") "tornin" ; --UNCHK
lin steeplechase_N = mkWN (compoundN "este" (k39 "ratsastus")) ; --UNCHK
lin steeplechaser_N = mkWN (compoundN "esteratsastus" (k38 "hevonen")) ; --UNCHK
lin steeplejack_N = mkWN (compoundN "tornin" (k10 "rakentaja")) ; --UNCHK
lin steepness_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin steer_N = mkWN (k10A "härkä") ; --UNCHK
lin steer_V = mkWV (k67 "ohjailla") ; --UNCHK
lin steer_V2 = mkWV2 (k67 "ohjailla") ; --UNCHK
lin steerable_A = mkWA (k10 "ohjattava") ; --UNCHK
lin steerage_N = mkWN (k39 "ohjaus") ; --UNCHK
lin steerageway_N = mkWN (compoundN "ohjailu" (k40 "nopeus")) ; --UNCHK
lin steering_N = mkWN (k39 "ohjaus") ; --UNCHK
lin steering_gear_N = mkWN (compoundN "ohjaus" (k48A "laite")) ; --UNCHK
lin steering_wheel_N = mkWN (kH1 "ratti") ; --UNCHK
lin steersman_N = mkWN (k10 "ohjaaja") ; --UNCHK
lin stegosaur_N = mkWN (k1 "kattolisko") ; --UNCHK
lin stele_N = mkWN (compoundN "kivi" (k27 "paasi")) ; --UNCHK
lin stelis_N = mkWN (k13 "orkidea") ; --UNCHK
lin stella_PN = foreignPN "Stella" ;
lin stellar_A = mkWA "astraali-" ; --UNCHK
lin stem_N = mkWN (k39 "auraus") ; --UNCHK
lin stem_V = mkV olla_V "peräisin" ;
lin stem_V2 = mkV2 (mkV (mkV "poistaa") "kanta") elative ;
lin stemless_A = mkWA "varreton" ; --UNCHK
lin stemma_N = mkWN (k9 "stemma") ; --UNCHK
lin stemmatic_A = mkWA "puudiagrammin" ; --UNCHK
lin stemmatology_N = mkWN "stemmatologia" ; --UNCHK
lin stemmer_N = mkWN (compoundN "työ" (k1 "kalu")) ; --UNCHK
lin stench_N = mkWN (k1 "haju") "myrkyllinen" ; --UNCHK
lin stencil_N = mkWN (k48 "malline") ; --UNCHK
lin stencil_V2 = mkWV2 (k73 "kaavata") ; --UNCHK
lin stenograph_N = mkWN (compoundN "pikakirjoitus" (k48 "kone")) ; --UNCHK
lin stenographer_N = mkWN (compoundN "pika" (k10 "kirjoittaja")) ; --UNCHK
lin stenography_N = mkWN (compoundN "pika" (k39 "kirjoitus")) ; --UNCHK
lin stenopterygius_N = mkWN (k1 "kalalisko") ; --UNCHK
lin stenosed_A = mkWA "ahtautunut" ; --UNCHK
lin stenosis_N = mkWN (k10 "ahtauma") ; --UNCHK
lin stent_N = mkWN "stentti" ; --UNCHK
lin stentor_N = mkWN (compoundN "ripsi" (k33 "eläin")) ; --UNCHK
lin stentorian_A = mkWA (compoundA "pauh" (k9 "aava")) ; --UNCHK
lin step_N = mkN "askel" ;
lin step_V = mkV (lin VK {s = c52 "astua"}) ;
lin step_V2 = mkV2 "astua" ; ---ARB ; porrastaa ; pengertää
lin step_aside_V = advV OP_step_V OP_aside_Adv ; -- guess-p-verb
lin step_back_V = advV OP_step_V OP_back_Adv ; -- guess-p-verb
lin step_down_V = mkWV (k54A "muuntaa") "pienemmäksi" ; --UNCHK
lin step_down_V2 = mkWV2 (k54A "muuntaa") "pienemmäksi" ; --UNCHK
lin step_forward_V = mkWV (k67 "tulla") "julkisuuteen" ; --UNCHK
lin step_in_V = mkWV (k52 "astua") "tilalle" ; --UNCHK
lin step_on_it_V2 = mkWV2 (k53A "kiirehtää") ; --UNCHK
lin step_out_V = mkWV (k52A "pistäytyä") ; --UNCHK
lin step_to_V2 = prepV2 OP_step_V OP_to_Prep ; -- guess-p-verb
lin step_up_V2 = mkWV2 (k52A "eskaloitua") ; --UNCHK
lin stepbrother_N = mkWN (compoundN "veli" (k26 "puoli")) ; --UNCHK
lin stepchild_N = mkWN (compoundN "lapsi" (k26 "puoli")) ; --UNCHK
lin stepdaughter_N = mkWN (compoundN "tytär" (k26 "puoli")) ; --UNCHK
lin stepfather_N = mkWN (compoundN "isä" (k26 "puoli")) ; --UNCHK
lin stephanion_N = mkWN (compoundN "kallonmittaus" (k48 "piste")) ; --UNCHK
lin stephanotis_N = mkWN (compoundN "tuoksu" (k39 "köynnös")) ; --UNCHK
lin stepmother_N = mkWN (compoundN "äiti" (k26 "puoli")) ; --UNCHK
lin stepparent_N = mkWN (compoundN "äiti" (k26 "puoli")) ; --UNCHK
lin steppe_N = mkWN (k1 "aro") ; --UNCHK
lin stepper_N = mkWN (k38 "hevonen") ; --UNCHK
lin stepping_stone_N = mkWN (compoundN "ponnahdus" (k9A "lauta")) ; --UNCHK
lin steprelationship_N = mkWN (compoundN "uus" (k48 "perhe")) ; --UNCHK
lin stepsister_N = mkWN (compoundN "sisar" (k26 "puoli")) ; --UNCHK
lin stepson_N = mkWN (compoundN "poika" (k26 "puoli")) ; --UNCHK
lin stepwise_Adv = mkWAdv (k99 "askelittain") ; --UNCHK
lin steradian_N = mkWN (compoundN "ste" (k5 "radiaani")) ; --UNCHK
lin sterculia_N = mkWN (k18 "puu") ; --UNCHK
lin stereo_N = mkWN (k12 "stereofonia") ; --UNCHK
lin stereophonic_A = mkWA (k38 "stereofoninen") ; --UNCHK
lin stereoscope_N = mkWN (k5A "stereoskooppi") ; --UNCHK
lin stereoscopic_A = mkWA (k38 "stereoskooppinen") ; --UNCHK
lin stereotype_N = mkN "stereotyyppi" ;
lin stereotype_V2 = mkWV2 (k67A "luokitella") ; --UNCHK
lin stereotypical_A = variants {} ;
lin sterile_A = mkWA (k1 "maho") ; --UNCHK
lin sterility_N = mkWN (k5A "steriliteetti") ; --UNCHK
lin sterilization_N = mkWN (k5A "sterilointi") ; --UNCHK
lin sterilize_V = mkWV (k73A "leikata") ; --UNCHK
lin sterilize_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin sterling_A = mkWA (k41 "paras") ; --UNCHK
lin sterling_N = mkN "punta" ;
lin stern_A = mkWA (k10 "ankara") ; --UNCHK
lin stern_N = mkWN (k6 "ahteri") ; --UNCHK
lin sternal_A = mkWA (compoundA "sterna" (k38 "alinen")) ; --UNCHK
lin sternness_N = mkWN (k40 "ankaruus") ; --UNCHK
lin sternocleidomastoid_N = mkWN (compoundN "päännyökkääjä" (k39 "lihas")) ; --UNCHK
lin sternpost_N = mkWN (compoundN "perä" (k41A "vannas")) ; --UNCHK
lin sternum_N = mkWN (compoundN "rinta" (k9 "lasta")) ; --UNCHK
lin sternutator_N = mkWN (compoundN "kyynel" (k1 "kaasu")) ; --UNCHK
lin sternutatory_A = mkWA (compoundA "aivas" (k10 "tuttava")) ; --UNCHK
lin sternwheeler_N = mkWN (compoundN "siipiratas" (k39 "alus")) ; --UNCHK
lin steroid_N = mkWN (k5 "steroidi") ; --UNCHK
lin steroidal_A = mkWA (compoundA "steroidi" (k38 "nen")) ; --UNCHK
lin sterol_N = mkWN (k5 "alkoholi") ; --UNCHK
lin stertorous_A = mkWA "korahteleva" ; --UNCHK
lin stethoscope_N = mkWN (k5A "stetoskooppi") ; --UNCHK
lin stetson_N = mkWN (compoundN "huopa" (k1A "hattu")) ; --UNCHK
lin stevedore_N = mkWN (k10 "lastaaja") ; --UNCHK
lin stevenage_PN = foreignPN "Stevenage" ;
lin stevenston_PN = foreignPN "Stevenston" ;
lin stew_N = mkWN (k39 "muhennos") ; --UNCHK
lin stew_V = mkWV (k53A "hauduttaa") ; --UNCHK
lin stew_V2 = mkWV2 (k53A "hauduttaa") ; --UNCHK
lin steward_N = mkWN (k6 "pehtori") ; --UNCHK
lin stewardess_N = mkWN (compoundN "lento" (k1 "emo")) ; --UNCHK
lin stewardship_N = mkWN (k40 "edustajuus") ; --UNCHK
lin stewart_PN = mkPN "Stewart" ;
lin stewing_N = mkWN (k1A "keitto") ; --UNCHK
lin steyning_PN = foreignPN "Steyning" ;
lin sthene_N = mkWN (compoundN "tuki" (k10 "voima")) ; --UNCHK
lin stibnite_N = mkWN (compoundN "stib" (k5A "niitti")) ; --UNCHK
lin stick_N = L.stick_N ;
lin stick_V = mkV "pistää" ; ----mkWV (k53A "sekoittaa") ;
lin stick_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin stick_around_V = mkWV (k52 "pysyä") "paikoillaan" ; --UNCHK
lin stick_at_V2 = prepV2 OP_stick_V OP_at_Prep ; -- guess-p-verb
lin stick_by_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin stick_down_V2 = prepV2 OP_stick_V OP_down_Prep ; -- guess-p-verb
lin stick_it_to_V2 = variants {} ; -- guess-p-verb
lin stick_out_V = mkWV (k69 "suvaita") ; --UNCHK
lin stick_out_V2 = mkWV2 (k69 "suvaita") ; --UNCHK
lin stick_out_for_V2 = prepV2 (advV OP_stick_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin stick_to_V2 = mkWV2 (k52 "pysyä") ; --UNCHK
lin stick_together_V = mkWV (k52 "pysyä") "yhdessä" ; --UNCHK
lin stick_up_V = mkWV (k53 "puolustaa") ; --UNCHK
lin stick_up_V2 = mkWV2 (k53 "puolustaa") ; --UNCHK
lin stick_up_for_V2 = prepV2 (advV OP_stick_V OP_up_Adv ) OP_for_Prep ; -- guess-p-verb
lin stick_with_V2 = mkWV2 (k52 "pysyä") ; --UNCHK
lin stickball_N = mkWN (compoundN "katu" (k5 "baseball")) ; --UNCHK
lin sticker_N = mkWN (k1A "puukko") ; --UNCHK
lin stickiness_N = mkWN (k40 "tahmeus") ; --UNCHK
lin sticking_plaster_N = mkWN (k6 "laastari") ; --UNCHK
lin stickleback_N = mkWN (compoundN "ahven" (k9 "kala")) ; --UNCHK
lin stickler_N = mkWN (k12 "intoilija") ; --UNCHK
lin stickpin_N = mkWN (compoundN "solmio" (k9 "neula")) ; --UNCHK
lin sticktight_N = mkWN (k1A "kirppu") ; --UNCHK
lin stickweed_N = mkWN (k38 "takiainen") ; --UNCHK
lin sticky_A = mkWA (k15 "tahmea") ; --UNCHK
lin stiff_A = mkWA (k10 "terävä") ; --UNCHK
lin stiff_Adv = mkWAdv (k99 "jäykästi") ; --UNCHK
lin stiff_N = mkWN (k1A "raato") ; --UNCHK
lin stiffen_V = mkWV (k53 "kangistaa") ; --UNCHK
lin stiffen_V2 = mkWV2 (k53 "kangistaa") ; --UNCHK
lin stiffener_N = mkWN (k48A "kovike") ; --UNCHK
lin stiffening_N = mkWN "jäykistyminen" ; --UNCHK
lin stiffness_N = mkWN (k40 "jyrkkyys") ; --UNCHK
lin stifle_N = mkWN (k7 "polvi") ; --UNCHK
lin stifle_V = mkWV (k52A "tukehtua") ; --UNCHK
lin stifle_V2 = mkWV2 (k52A "tukehtua") ; --UNCHK
lin stifler_N = mkWN (k2 "henkilö") "pitkästyttävä" ; --UNCHK
lin stigma_N = mkWN (k9 "stigma") ; --UNCHK
lin stigmata_N = mkWN "stigmata" ; --UNCHK
lin stigmatic_A = mkWA (compoundA "stigma" (k38 "attinen")) ; --UNCHK
lin stigmatic_N = mkWN (k2 "henkilö") "stigmaattinen" ; --UNCHK
lin stigmatism_N = mkWN (compoundN "näkö" (k1A "kyky")) ; --UNCHK
lin stigmatization_N = mkWN (compoundN "lei" (k38 "maaminen")) ; --UNCHK
lin stigmatize_V2 = mkWV2 (k69 "merkitä") ; --UNCHK
lin stile_N = mkWN (k26 "pieli") ; --UNCHK
lin stiletto_N = mkWN (k5A "stiletti") ; --UNCHK
lin still_A = mkWA "asetelma-" ; --UNCHK
lin still_AdA = mkAdA "yhä" ;
lin still_AdV = lin AdV (ss "yhä") ;
lin still_Adv = mkAdv "yhä" ;
lin still_N = mkWN (k2 "tislaamo") ; --UNCHK
lin still_V2 = mkWV2 (k71 "tehdä") "hiljaiseksi" ; --UNCHK
lin still_life_N = mkWN (k10 "asetelma") ; --UNCHK
lin still_room_N = mkWN (compoundN "apu" (k3 "keittiö")) ; --UNCHK
lin stillbirth_N = mkWN (k5A "abortti") "spontaani" ; --UNCHK
lin stillness_N = mkWN (k40 "hiljaisuus") ; --UNCHK
lin stilly_A = mkWA (k38 "hiljainen") ; --UNCHK
lin stilt_N = mkWN (compoundN "meri" (k14A "harakka")) ; --UNCHK
lin stilted_A = mkWA (k10A "jäykkä") ; --UNCHK
lin stilton_N = mkWN "stilton" ; --UNCHK
lin stimulant_A = mkWA "piristävä" ; --UNCHK
lin stimulant_N = mkWN (k5A "stimulantti") ; --UNCHK
lin stimulate_V2 = mkWV2 (k62 "stimuloida") ; --UNCHK
lin stimulating_A = mkWA "piristävä" ; --UNCHK
lin stimulation_N = mkWN (k39 "kiihotus") ; --UNCHK
lin stimulative_A = mkWA (compoundA "stimu" (k10 "loiva")) ; --UNCHK
lin stimulus_N = mkWN (k48A "ärsyke") ; --UNCHK
lin sting_N = mkWN (k39 "huijaus") ; --UNCHK
lin sting_V = mkWV (k53A "pakottaa") ; --UNCHK
lin sting_V2 = mkWV2 (k53A "pakottaa") ; --UNCHK
lin stinger_N = mkWN (k1 "isku") ; --UNCHK
lin stinginess_N = mkWN (k40 "saituus") ; --UNCHK
lin stingless_A = mkWA "poltinkarvaton" ; --UNCHK
lin stingray_N = mkWN (compoundN "keihäs" (k1 "rausku")) ; --UNCHK
lin stingy_A = mkWA (k34A "riittämätön") ; --UNCHK
lin stink_N = mkWN (k1 "haju") "myrkyllinen" ; --UNCHK
lin stink_V = mkWV (k74 "lemuta") ; --UNCHK
lin stink_V2 = mkWV2 (k74 "lemuta") ; --UNCHK
lin stinker_N = mkWN (k27 "susi") ; --UNCHK
lin stinkhorn_N = mkWN (compoundN "haju" (k26 "sieni")) ; --UNCHK
lin stint_N = mkWN (k19 "työ") ; --UNCHK
lin stint_V = mkWV (k73A "pihdata") ; --UNCHK
lin stint_V2 = mkWV2 (k73A "pihdata") ; --UNCHK
lin stinter_N = mkWN (k5A "kitupiikki") ; --UNCHK
lin stipe_N = mkWN (k28 "varsi") ; --UNCHK
lin stipend_N = mkWN (k5 "stipendi") ; --UNCHK
lin stipendiary_A = mkWA "stipendi-" ; --UNCHK
lin stipendiary_N = mkWN (compoundN "poliisi" (k6 "tuomari")) ; --UNCHK
lin stipple_V2 = mkWV2 (k53A "täplittää") ; --UNCHK
lin stippler_N = mkWN (compoundN "kuva" (k12 "taiteilija")) ; --UNCHK
lin stipulate_V = mkWV (k61A "vaatia") ; --UNCHK
lin stipulate_V2 = mkWV2 (k61A "vaatia") ; --UNCHK
lin stipulate_VS = mkWVS (k61A "vaatia") ; --UNCHK
lin stipulation_N = mkWN (k1A "ehto") ; --UNCHK
lin stipule_N = mkWN (k48A "korvake") ; --UNCHK
lin stir_N = mkWN (k39 "touhotus") ; --UNCHK
lin stir_V = mkWV (k73 "vatkata") ; --UNCHK
lin stir_V2 = mkV2 "sekoittaa" partitive ;
lin stir_up_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin stirk_N = mkWN (k1 "hieho") ; --UNCHK
lin stirling_PN = foreignPN "Stirling" ;
lin stirrer_N = mkWN (k12 "vispilä") ; --UNCHK
lin stirring_N = mkWN "vispaaminen" ; --UNCHK
lin stirringly_Adv = mkWAdv (k99 "liikuttavasti") ; --UNCHK
lin stirrup_N = mkWN (k33 "jalustin") ; --UNCHK
lin stirrup_cup_N = mkWN (compoundN "lähtö" (k9 "malja")) ; --UNCHK
lin stitch_N = mkWN (k1 "pisto") ; --UNCHK
lin stitch_V = mkWV (k61 "kursia") ; --UNCHK
lin stitch_V2 = mkWV2 (k61 "kursia") ; --UNCHK
lin stitcher_N = mkWN "viimeistelijä" ; --UNCHK
lin stoat_N = mkWN (k10A "kärppä") ; --UNCHK
lin stob_N = mkWN (k1A "tikku") ; --UNCHK
lin stochastic_A = mkWA "stokastinen" ; --UNCHK
lin stock_A = mkWA (k38 "tavallinen") ; --UNCHK
lin stock_N = mkN (lin NK {s = d48A "osake"}) | mkN "liemi" ; ---- split
lin stock_V2 = mkWV2 (k52 "versoa") ; --UNCHK
lin stock_cube_N = mkWN (compoundN "liemi" (k3 "kuutio")) ; --UNCHK
lin stock_farmer_N = mkWN (compoundN "karjan" (k10 "kasvattaja")) ; --UNCHK
lin stock_list_N = mkWN (k2 "luettelo") ; --UNCHK
lin stock_up_V = mkWV (k61A "hankkia") "varastoon" ; --UNCHK
lin stockade_N = mkWN (compoundN "vanki" (k5 "leiri")) ; --UNCHK
lin stockade_V2 = mkWV2 (k53A "paaluttaa") ; --UNCHK
lin stockbroker_N = mkWN (compoundN "pörssi" (k6 "meklari")) ; --UNCHK
lin stockcar_N = mkWN (compoundN "karja" (k1 "vaunu")) ; --UNCHK
lin stocker_N = mkWN (compoundN "koti" (k33 "eläin")) ; --UNCHK
lin stockfish_N = mkWN (compoundN "kapa" (k9 "kala")) ; --UNCHK
lin stockholder_N = mkWN (compoundN "osakkeen" (k10 "omistaja")) ;
lin stockholding_N = mkWN (compoundN "osakkeen" (k39 "omistus")) ; --UNCHK
lin stockholm_PN = foreignPN "Tukholma" ;
lin stockinet_N = mkWN (k20 "trikoo") ; --UNCHK
lin stockinette_N = mkWN (k20 "trikoo") ; --UNCHK
lin stocking_N = mkWN (compoundN "varus" (k38 "taminen")) ; --UNCHK
lin stockinged_A = mkWA (k99 "sukkasillaan") ; --UNCHK
lin stockist_N = mkWN (k41 "kauppias") ; --UNCHK
lin stockjobber_N = mkWN (compoundN "pörssi" (k12 "keinottelija")) ; --UNCHK
lin stockman_N = mkWN (compoundN "karjan" (k10 "kasvattaja")) ; --UNCHK
lin stockpile_N = mkN "varastopino" ;
lin stockpile_V2 = mkWV2 (k53A "pitää") "varastossa" ; --UNCHK
lin stockpiling_N = mkWN (compoundN "vara" (k38 "stoiminen")) ; --UNCHK
lin stockport_PN = foreignPN "Stockport" ;
lin stockpot_N = mkWN (k9A "keittopata") ; --UNCHK
lin stockroom_N = mkWN (k2 "varasto") ; --UNCHK
lin stocks_N = mkWN (compoundN "jalka" (k18 "puu")) ; --UNCHK
lin stocksbridge_PN = foreignPN "Stocksbridge" ;
lin stocktake_N = mkWN (k3 "inventaario") ; --UNCHK
lin stocktaker_N = mkWN "inventoija" ; --UNCHK
lin stocktaking_N = mkWN (k3 "inventaario") ; --UNCHK
lin stocky_A = mkWA (k11 "vanttera") ; --UNCHK
lin stockyard_N = mkWN (compoundN "karja" (k9 "piha")) ; --UNCHK
lin stodge_N = mkWN (k10A "ruoka") "raskas" ; --UNCHK
lin stodginess_N = mkWN (k40 "pikkumaisuus") ; --UNCHK
lin stodgy_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin stoep_N = mkWN (k5 "kuisti") ; --UNCHK
lin stogy_N = mkWN (k6 "sikari") "halpa" ; --UNCHK
lin stoic_A = mkWA (k38 "stoalainen") ; --UNCHK
lin stoic_N = mkWN (k38 "stoalainen") ; --UNCHK
lin stoical_A = mkWA (k10 "luja") ; --UNCHK
lin stoichiometric_A = mkWA (compoundA "stoikio" (k38 "metrinen")) ; --UNCHK
lin stoichiometry_N = mkWN "stökiometria" ; --UNCHK
lin stoicism_N = mkWN (k40 "tyyneys") ; --UNCHK
lin stoke_V = mkWV (k54A "kohentaa") ; --UNCHK
lin stoke_V2 = mkWV2 (k54A "kohentaa") ; --UNCHK
lin stokehold_N = mkWN (compoundN "kattila" (k48 "huone")) ; --UNCHK
lin stokehole_N = mkWN (compoundN "kattila" (k48 "huone")) ; --UNCHK
lin stole_N = mkWN (k10 "stoola") ; --UNCHK
lin stolen_A = mkA "varastettu" ;
lin stolid_A = mkWA (k34A "ilmeetön") ; --UNCHK
lin stolidity_N = mkWN (k40 "tyyneys") ; --UNCHK
lin stolidness_N = mkWN (k40 "tyyneys") ; --UNCHK
lin stolon_N = mkWN (k1 "rönsy") ; --UNCHK
lin stoloniferous_A = mkWA "rönsyävä" ; --UNCHK
lin stoma_N = mkWN (compoundN "ilma" (k1A "rako")) ; --UNCHK
lin stomach_N = mkWN (k1 "masu") ; --UNCHK
lin stomach_V2 = mkWV2 (k69 "suvaita") ; --UNCHK
lin stomach_ache_N = mkWN (compoundN "vatsa" (k1A "kipu")) ; --UNCHK
lin stomach_pump_N = mkWN (compoundN "vatsa" (k1A "pumppu")) ; --UNCHK
lin stomacher_N = mkWN (k13 "miehusta") ; --UNCHK
lin stomatal_A = mkWA "ilmaraon" ; --UNCHK
lin stomatitis_N = mkWN (compoundN "suu" (k39 "tulehdus")) ; --UNCHK
lin stomatopod_N = mkWN (compoundN "sirkka" (k38 "äyriäinen")) ; --UNCHK
lin stomatous_A = mkWA (compoundA "suu" (k38 "mainen")) ; --UNCHK
lin stomp_N = mkWN "stomp" ; --UNCHK
lin stomp_V = mkWV (k53 "tömistää") ; --UNCHK
lin stomp_V2 = mkWV2 (k53 "tömistää") ; --UNCHK
lin stone_A = mkWA (compoundA "kiven" (k38 "värinen")) ; --UNCHK
lin stone_1_N = L.stone_N ;
lin stone_2_N = L.stone_N ;
lin stone_PN = foreignPN "Stone" ;
lin stone_V2 = mkWV2 (k53 "poistaa") "kivet" ; --UNCHK
lin stone_fruit_N = mkWN (compoundN "luu" (k9 "marja")) ; --UNCHK
lin stone_pit_N = mkWN (k2 "louhimo") ; --UNCHK
lin stonechat_N = mkWN (compoundN "mustapää" (k1 "tasku")) ; --UNCHK
lin stonecress_N = mkWN (compoundN "kivi" (k1A "rikko")) ; --UNCHK
lin stonecrop_N = mkWN (compoundN "maksa" (k1 "ruoho")) ; --UNCHK
lin stonecutter_N = mkWN (compoundN "kiven" (k10 "hakkaaja")) ; --UNCHK
lin stonefish_N = mkWN (compoundN "kivi" (k9 "kala")) ; --UNCHK
lin stonefly_N = mkWN (compoundN "koski" (k1A "korento")) ; --UNCHK
lin stonehouse_PN = foreignPN "Stonehouse" ;
lin stoneless_A = mkWA "kivetön" ; --UNCHK
lin stonemason_N = mkWN (k6 "muurari") ; --UNCHK
lin stoner_N = mkWN "kivittäjä" ; --UNCHK
lin stonewall_V2 = mkWV2 (k52 "pysyä") "puolustuskannalla" ; --UNCHK
lin stonewaller_N = mkWN "jarruttaja" ; --UNCHK
lin stonewalling_N = mkWN (compoundN "jarru" (k38 "ttaminen")) ; --UNCHK
lin stoneware_N = mkWN (compoundN "kivi" (k12 "tavara")) ; --UNCHK
lin stonework_N = mkWN (compoundN "kivi" (k19 "työ")) ; --UNCHK
lin stonewort_N = mkWN (k10 "levä") ; --UNCHK
lin stoning_N = mkWN (k39 "kivitys") ; --UNCHK
lin stony_A = mkWA (k38 "graniittinen") ; --UNCHK
lin stooge_N = mkWN (k48A "kohde") ; --UNCHK
lin stooge_V = mkWV (k73A "pilkata") ; --UNCHK
lin stool_N = mkWN (kH1 "palli") ; --UNCHK
lin stoop_N = mkWN (k10 "kumara") ; --UNCHK
lin stoop_V = mkWV (k58A "kulkea") "köyryssä" ; --UNCHK
lin stoop_V2 = mkWV2 (k58A "kulkea") "köyryssä" ; --UNCHK
lin stooper_N = mkWN (k12 "kulkija") "köyryssä" ; --UNCHK
lin stop_N = mkWN (k39 "pysähdys") ;
lin stop_V = L.stop_V ;
lin stop_V2 = mkV2 "lopettaa" ;
lin stop_VV = mkVV "lakata" infElat ;
lin stop_around_V = advV OP_stop_V OP_around_Adv ; -- guess-p-verb
lin stop_back_V = advV OP_stop_V OP_back_Adv ; -- guess-p-verb
lin stop_behind_V = advV OP_stop_V OP_behind_Adv ; -- guess-p-verb
lin stop_by_V2 = prepV2 OP_stop_V OP_by_Prep ; -- guess-p-verb
lin stop_in_V = advV OP_stop_V OP_in_Adv ; -- guess-p-verb
lin stop_off_V = advV OP_stop_V OP_off_Adv ; -- guess-p-verb
lin stop_out_V = advV OP_stop_V OP_out_Adv ; -- guess-p-verb
lin stop_over_V = mkWV (k52A "pysähtyä") ; --UNCHK
lin stop_up_V = mkWV (k58A "sulkea") ; --UNCHK
lin stop_up_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin stopcock_N = mkWN (compoundN "sulku" (k6 "venttiili")) ; --UNCHK
lin stopgap_N = mkWN (k48A "korvike") ; --UNCHK
lin stoplight_N = mkWN (compoundN "liikenne" (k5A "merkki")) ; --UNCHK
lin stopover_N = mkWN (k39 "pysähdys") ; --UNCHK
lin stoppable_A = mkWA (k10 "oleva") "pysäytettävissä" ; --UNCHK
lin stoppage_N = mkWN (k1 "esto") ; --UNCHK
lin stopper_N = mkWN (k5A "tappi") ; --UNCHK
lin stoppered_A = mkWA "tulpattu" ; --UNCHK
lin stopping_N = mkWN (k48A "ote") ; --UNCHK
lin stopwatch_N = mkWN (k33 "ajastin") ; --UNCHK
lin storage_N = mkWN (k5A "varastointi") ;
lin storax_N = mkWN (k6 "balsami") "ambrapuun" ; --UNCHK
lin store_N = mkN "varasto" ;
lin store_V2 = mkWV2 (k62 "varastoida") ; --UNCHK
lin storehouse_N = mkWN (k2 "varasto") ; --UNCHK
lin storeroom_N = mkWN (compoundN "varasto" (k9 "tila")) ; --UNCHK
lin storey_N = mkWN (k39 "kerros") ; --UNCHK
lin storeyed_A = mkWA (k38 "kerroksinen") ; --UNCHK
lin storied_A = mkWA (k41A "värikäs") ; --UNCHK
lin stork_N = mkWN (k12 "haikara") ; --UNCHK
lin storksbill_N = mkWN (k5A "pielikki") ; --UNCHK
lin storm_N = mkN "myrsky" ; ---ARB mkWN (k4A "rynnäkkö") ;
lin storm_V = mkWV (k73A "rynnätä") ; --UNCHK
lin storm_V2 = mkWV2 (k73A "rynnätä") ; --UNCHK
lin storm_centre_N = mkWN (compoundN "myrsky" (k39 "keskus")) ; --UNCHK
lin storm_cloud_N = mkWN (compoundN "myrsky" (k7 "pilvi")) ; --UNCHK
lin storm_cone_N = mkWN (compoundN "myrskyvaroitus" (k5A "merkki")) ; --UNCHK
lin storm_lantern_N = mkWN (compoundN "myrsky" (k1A "lyhty")) ; --UNCHK
lin storm_signal_N = mkWN (compoundN "myrsky" (k39 "varoitus")) ; --UNCHK
lin storminess_N = mkWN (k40 "intohimoisuus") ; --UNCHK
lin stormproof_A = mkWA (compoundA "myrskyn" (k10 "kestävä")) ; --UNCHK
lin stormy_A = mkWA (k10 "myrskyisä") ; --UNCHK
lin stornoway_PN = foreignPN "Stornoway" ;
lin story_N = mkN "tarina" | mkN "kerros" ; ---- split
lin storybook_N = mkWN (compoundN "satu" (k9 "kirja")) ; --UNCHK
lin storyline_N = mkWN (k26 "juoni") ; --UNCHK
lin storyteller_N = mkWN (k10 "kertoja") ; --UNCHK
lin stotfold_PN = foreignPN "Stotfold" ;
lin stoup_N = mkWN (k1 "kannu") ; --UNCHK
lin stourbridge_PN = foreignPN "Stourbridge" ;
lin stout_A = mkWA (k14A "tanakka") ; --UNCHK
lin stout_N = mkWN (kH1 "iso") ; --UNCHK
lin stouthearted_A = mkWA (k15 "urhea") ; --UNCHK
lin stoutheartedness_N = mkWN (k40 "rohkeus") ; --UNCHK
lin stoutness_N = mkWN (k40 "paksuus") ; --UNCHK
lin stove_N = L.stove_N ;
lin stovepipe_N = mkWN (k6 "silinteri") ; --UNCHK
lin stovepiped_A = mkWA (compoundA "haja" (k1 "utettu")) ; --UNCHK
lin stovepiping_N = mkWN (compoundN "takaisin" (k5A "saanti")) ; --UNCHK
lin stover_N = mkWN (compoundN "talvi" (k1 "rehu")) ; --UNCHK
lin stow_V2 = mkWV2 (k52 "sulloa") ; --UNCHK
lin stow_away_V = mkWV (k53 "matkustaa") "salaa" ; --UNCHK
lin stowage_N = mkWN (k5A "varastointi") ; --UNCHK
lin stowaway_N = mkWN (compoundN "sala" (k10 "matkustaja")) ; --UNCHK
lin stowmarket_PN = foreignPN "Stowmarket" ;
lin strabismus_N = mkWN (k39 "karsastus") ; --UNCHK
lin strabotomy_N = mkWN (compoundN "karsastus" (k39 "leikkaus")) ; --UNCHK
lin straddle_N = mkWN (k3 "optio") ; --UNCHK
lin straddle_V = mkWV (k52 "jatkua") ; --UNCHK
lin straddle_V2 = mkWV2 (k52 "jatkua") ; --UNCHK
lin strafe_N = mkWN (k39 "hyökkäys") ; --UNCHK
lin strafe_V2 = mkWV2 (k73A "hyökätä") ; --UNCHK
lin strafer_N = mkWN (compoundN "taistelu" (k10 "lentäjä")) ; --UNCHK
lin straggle_N = mkWN (k10 "rykelmä") ; --UNCHK
lin straggle_V = mkWV (k53A "rehottaa") ; --UNCHK
lin straggler_N = mkWN "harhailija" ; --UNCHK
lin straggly_A = mkWA "harittava" ; --UNCHK
lin straight_A = L.straight_A ;
lin straight_Adv = mkWAdv (k99 "suoraan") ;
lin straight_N = mkWN (k10 "suora") ; --UNCHK
lin straightaway_N = mkWN (k10 "suora") ; --UNCHK
lin straightedge_N = mkWN (k33 "viivain") ; --UNCHK
lin straighten_V = mkWV (k53 "järjestää") ; --UNCHK
lin straighten_V2 = mkWV2 (k53 "järjestää") ; --UNCHK
lin straighten_out_V2 = mkWV2 (k52 "valaistua") ; --UNCHK
lin straighten_up_V = mkWV (k74A "koota") ; --UNCHK
lin straighten_up_V2 = mkWV2 (k74A "koota") ; --UNCHK
lin straightener_N = mkWN (compoundN "suoristus" (k9A "rauta")) ; --UNCHK
lin straightforward_A = mkWA (compoundA "kohti" (k10 "suora")) ; --UNCHK
lin straightness_N = mkWN (compoundN "hetero" (k40 "seksuaalisuus")) ; --UNCHK
lin straightway_Adv = mkWAdv "suoraa" "päätä" ; --UNCHK
lin strain_N = mkWN (k10 "sävelmä") ; --UNCHK
lin strain_V2 = mkV2 "koetella" partitive ; --mkWV2 (k52A "jännittyä") ;
lin strainer_N = mkWN (k13 "siivilä") ; --UNCHK
lin strait_A = mkWA (k41A "ahdas") ; --UNCHK
lin strait_N = mkWN (k7 "salmi") ; --UNCHK
lin strait_laced_A = mkA (mkN "ahdas" (mkN "mielinen")) ;
lin straiten_V2 = mkWV2 (k53 "kiristää") ; --UNCHK
lin straitjacket_N = mkWN (compoundN "pakko" (k9A "paita")) ; --UNCHK
lin strand_N = mkWN (k9 "nauha") ; --UNCHK
lin strand_V = mkWV (k56 "ajaa") "rantaan" ; --UNCHK
lin strand_V2 = mkWV2 (k56 "ajaa") "rantaan" ; --UNCHK
lin strange_A = mkWA (k38 "merkillinen") ;
lin strangeness_N = mkWN (k40 "outous") ; --UNCHK
lin stranger_N = mkN "vieras" ; --mkWN (k38 "muukalainen") ;
lin strangle_V2 = mkWV2 (k52A "pakahtua") ; --UNCHK
lin stranglehold_N = mkWN (compoundN "kuristajan" (k48A "ote")) ; --UNCHK
lin strangler_N = mkWN (k10 "kuristaja") ; --UNCHK
lin strangulation_N = mkWN (compoundN "kuri" (k38 "staminen")) ; --UNCHK
lin stranraer_PN = foreignPN "Stranraer" ;
lin strap_N = mkWN (k9 "piiska") ; --UNCHK
lin strap_V2 = mkV2 "sitoa" ; --mkWV2 (k52A "sitoa") ;
lin straphanger_N = mkWN (k10 "seisoja") ; --UNCHK
lin strapless_A = mkWA "olkaimeton" ; --UNCHK
lin strapless_N = mkWN (k48A "vaate") "olkaimeton" ; --UNCHK
lin straplike_A = mkWA (compoundA "liuska" (k38 "mainen")) ; --UNCHK
lin strappado_N = mkWN "vipuhirsipuu" ; --UNCHK
lin strapping_A = mkWA (k9 "vahva") ; --UNCHK
lin strasbourg_PN = foreignPN "Strasbourg" ;
lin stratagem_N = mkWN (compoundN "sota" (k26 "juoni")) ; --UNCHK
lin strategic_A = mkWA (k38 "strateginen") ; --f54
lin strategical_A = mkWA (k38 "strateginen") ; --UNCHK
lin strategics_N = mkWN (k12 "strategia") ; --UNCHK
lin strategist_N = mkWN (k5 "strategi") ;
lin strategy_N = mkN (lin NK {s = d12 "strategia"}) ;
lin strathaven_PN = foreignPN "Strathaven" ;
lin stratification_N = mkWN "kylväminen" ; --UNCHK
lin stratify_V = mkWV (k53A "idättää") ; --UNCHK
lin stratify_V2 = mkWV2 (k53A "idättää") ; --UNCHK
lin stratigraphy_N = mkWN "stratigrafia" ; --UNCHK
lin stratosphere_N = mkWN (k5 "stratosfääri") ; --UNCHK
lin stratum_N = mkWN (k39 "kerros") ; --UNCHK
lin stratus_N = mkWN (compoundN "sumu" (k7 "pilvi")) ; --UNCHK
lin straw_A = mkWA (compoundA "oljen" (k38 "keltainen")) ; --UNCHK
lin straw_N = mkWN (k5 "pilli") ; --UNCHK
lin straw_V2 = mkWV2 (k67A "sirotella") ; --UNCHK
lin strawberry_N = mkWN (compoundN "syntymä" (k5A "merkki")) ; --UNCHK
lin strawboard_N = mkWN (compoundN "olki" (k5A "kartonki")) ; --UNCHK
lin strawflower_N = mkWN (compoundN "olki" (k10A "kukka")) ; --UNCHK
lin strawworm_N = mkWN (compoundN "olki" (k1A "mato")) ; --UNCHK
lin stray_N = mkWN (k38 "karkulainen") ; --UNCHK
lin stray_V = mkWV (k74A "poiketa") ; --UNCHK
lin streak_N = mkN "sarja" ; --mkWN (k1 "viiru") ;
lin streak_V = mkWV (k53A "laikuttaa") ; --UNCHK
lin streak_V2 = mkWV2 (k53A "laikuttaa") ; --UNCHK
lin streaker_N = mkWN "viuhahtaja" ; --UNCHK
lin streaky_A = mkWA (k38 "raidallinen") ; --UNCHK
lin stream_N = mkWN (k39 "virtaus") ; --UNCHK
lin stream_V = mkWV (k53A "vuotaa") ; --UNCHK
lin streambed_N = mkWN (k10 "uoma") "joen" ; --UNCHK
lin streamer_N = mkWN (k5 "viiri") ; --UNCHK
lin streamlet_N = mkWN (k1 "puro") ; --UNCHK
lin streamline_V = mkWV (k53 "tehostaa") ; --UNCHK
lin streamline_V2 = mkWV2 (k53 "tehostaa") ; --UNCHK
lin streamliner_N = mkWN (compoundN "luoti" (k10 "juna")) ; --UNCHK
lin street_N = mkWN (k1A "katu") ;
lin street_PN = foreignPN "Street" ;
lin street_girl_N = mkWN (k1A "prostituoitu") ; --UNCHK
lin street_urchin_N = mkWN (compoundN "katu" (k10A "poika")) ; --UNCHK
lin streetcar_N = mkWN (compoundN "johdin" (k5 "bussi")) ; --UNCHK
lin streetlight_N = mkWN (compoundN "katu" (k1 "valo")) ; --UNCHK
lin streetwalker_N = mkWN (k1A "prostituoitu") ; --UNCHK
lin streetwise_A = mkWA (k6 "urbaani") ; --UNCHK
lin strength_N = mkN "vahvuus" ;
lin strengthen_V2 = mkV2 (mkV "vahvistaa") partitive ;
lin strengthener_N = mkWN (k48A "lujike") ; --UNCHK
lin strengthening_N = mkWN (compoundN "voi" (k38 "mistaminen")) ; --UNCHK
lin strenuous_A = mkWA (k10 "vaativa") ; --UNCHK
lin strenuousness_N = mkWN (k40 "vaativuus") ; --UNCHK
lin streptobacillus_N = mkWN "streptobacillus" ; --UNCHK
lin streptococcal_A = mkWA "streptokokin" ; --UNCHK
lin streptococcus_N = mkWN (k5A "streptokokki") ; --UNCHK
lin streptodornase_N = mkWN (compoundN "streptodorn" (k5 "aasi")) ; --UNCHK
lin streptokinase_N = mkWN (compoundN "streptokin" (k5 "aasi")) ; --UNCHK
lin streptolysin_N = mkWN "streptolysiini" ; --UNCHK
lin streptomyces_N = mkWN "streptomyces" ; --UNCHK
lin streptomycin_N = mkWN "streptomysiini" ; --UNCHK
lin streptothricin_N = mkWN "streptotsosiini" ; --UNCHK
lin stress_N = mkWN (k5A "aksentti") ; --UNCHK
lin stress_V2 = mkWV2 (k53A "painottaa") ; --UNCHK
lin stress_VS = mkWVS (k53A "painottaa") ; --UNCHK
lin stress_mark_N = mkWN (k5A "aksentti") ; --UNCHK
lin stressor_N = mkWN "kuormittaja" ; --UNCHK
lin stretch_A = mkWA (k10 "joustava") ; --UNCHK
lin stretch_N = mkN "pätkä" ;
lin stretch_V = mkWV (k67A "venytellä") ; --UNCHK
lin stretch_V2 = mkV2 "venyttää" ;
lin stretch_out_V = mkWV (k54A "ojentaa") ; --UNCHK
lin stretchable_A = mkWA (k10 "joustava") ; --UNCHK
lin stretcher_N = mkWN (compoundN "kansi" (k7 "kivi")) ; --UNCHK
lin stretching_N = mkWN "venyttäminen" ; --UNCHK
lin stretford_PN = foreignPN "Stretford" ;
lin streusel_N = mkWN (k6 "strösseli") ; --UNCHK
lin strew_V2 = mkWV2 (k53A "peittää") ; --UNCHK
lin stria_N = mkWN (k1 "viiru") ; --UNCHK
lin striate_A = mkWA "striate" ; --UNCHK
lin stricken_A = mkWA (k47 "ahdistunut") ; --UNCHK
lin strict_A = mkA "tiukka" ;
lin strictness_N = mkWN (k40 "ankaruus") ; --UNCHK
lin stricture_N = mkWN (k2 "arvostelu") "ankara" ; --UNCHK
lin stride_N = mkWN (k39 "harppaus") ; --UNCHK
lin stride_V = mkWV (k52A "harppoa") ; --UNCHK
lin strident_A = mkWA (k15 "räikeä") ; --UNCHK
lin strider_N = mkWN (compoundN "harpp" (k10 "oja")) ; --UNCHK
lin stridor_N = mkWN (k26 "ääni") "viheltävä" ; --UNCHK
lin stridulate_V = mkWV (k53A "sirittää") ; --UNCHK
lin stridulation_N = mkWN (k39 "siritys") ; --UNCHK
lin strife_N = mkWN (k39 "selkkaus") ; --UNCHK
lin strike_1_N = variants {} ; --
lin strike_2_N = variants {} ; --
lin strike_N = mkN "lakko" ;
lin strike_V = mkV "iskeä" ;
lin strike_V2 = mkV2 "iskeä" allative ;
lin strike_back_V = advV OP_strike_V OP_back_Adv ; -- guess-p-verb
lin strike_down_V = mkWV (k64 "lyödä") "maahan" ; --UNCHK
lin strike_down_V2 = mkWV2 (k64 "lyödä") "maahan" ; --UNCHK
lin strike_leader_N = mkWN (compoundN "lakon" (k10 "johtaja")) ; --UNCHK
lin strike_off_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin strike_on_V2 = prepV2 OP_strike_V OP_on_Prep ; -- guess-p-verb
lin strike_out_V = mkWV (k52A "ryhtyä") ; --UNCHK
lin strike_out_V2 = mkWV2 (k52A "ryhtyä") ; --UNCHK
lin strike_pay_N = mkWN (compoundN "lakko" (k39 "avustus")) ; --UNCHK
lin strike_up_V = mkWV (k67A "viritellä") ; --UNCHK
lin strike_up_V2 = mkWV2 (k67A "viritellä") ; --UNCHK
lin strike_upon_V2 = prepV2 OP_strike_V OP_upon_Prep ; -- guess-p-verb
lin strikebound_A = mkWA (compoundA "lakon" (k38 "alainen")) ; --UNCHK
lin strikebreaker_N = mkWN (k10A "rotta") ; --UNCHK
lin strikeout_N = mkWN (compoundN "suora" (k1 "palo")) ; --UNCHK
lin striker_N = mkWN (k6 "iskuri") ; --UNCHK
lin striking_A = mkA "vaikuttava" ; --mkWA (k38 "keskeinen") ;
lin string_1_N = mkWN (compoundN "kieli" (k33A "soitin")) ; --UNCHK
lin string_2_N = mkWN (compoundN "kieli" (k33A "soitin")) ; --UNCHK
lin string_3_N = mkWN (compoundN "kieli" (k33A "soitin")) ; --UNCHK
lin string_V = mkWV (k53 "järjestää") ; --UNCHK
lin string_V2 = mkWV2 (k53 "järjestää") ; --UNCHK
lin string_along_V = mkWV (k52A "liittyä") ; --UNCHK
lin string_along_V2 = mkWV2 (k52A "liittyä") ; --UNCHK
lin string_out_V2 = mkWV2 (k52A "levittäytyä") ; --UNCHK
lin string_up_V2 = mkWV2 (k53A "liittää") ; --UNCHK
lin stringency_N = mkWN (k40 "tiukkuus") ; --UNCHK
lin stringent_A = mkA "jyrkkä" ; --mkWA (k9A "tiukka") ;
lin stringer_N = mkWN (compoundN "poikki" (k18 "puu")) ; --UNCHK
lin stringy_A = mkWA "jousten" ; --UNCHK
lin stringybark_N = mkWN (k39 "eukalyptus") ; --UNCHK
lin strip_N = mkWN "strippaus" ; --UNCHK
lin strip_V = mkWV (k52A "riisuuntua") ; --UNCHK
lin strip_V2 = mkWV2 (k52A "riisuuntua") ; --UNCHK
lin strip_lighting_N = mkWN (compoundN "loiste" (k7 "putki")) ; --UNCHK
lin strip_poker_N = mkWN (compoundN "räsy" (k10A "pokka")) ; --UNCHK
lin strip_show_N = mkWN "strippaus" ; --UNCHK
lin stripe_N = mkWN (kH1 "raita") ;
lin striped_A = mkWA (k38 "raidallinen") ; --UNCHK
lin striper_N = mkWN (k32 "ahven") ; --UNCHK
lin striping_N = mkWN (k39 "raidoitus") ; --UNCHK
lin stripling_N = mkWN (k38 "nuorukainen") ; --UNCHK
lin stripper_N = mkWN (compoundN "öljy" (k48A "lähde")) ; --UNCHK
lin striptease_N = mkWN "strippaus" ; --UNCHK
lin stripy_A = mkWA (k38 "raidallinen") ; --UNCHK
lin strive_V = mkWV (k67 "pinnistellä") ; --UNCHK
lin strive_VV = mkWVV (k67 "pinnistellä") ; --UNCHK
lin striver_N = mkWN (k6 "pyrkyri") ; --UNCHK
lin striving_N = mkWN (k39 "rasitus") ; --UNCHK
lin stroboscope_N = mkWN (compoundN "strobo" (k1 "valo")) ; --UNCHK
lin stroke_N = mkN "veto" ; ---ARB --mkN "infarkti"
lin stroke_V2 = mkWV2 (k67A "imarrella") ; --UNCHK
lin stroll_N = mkWN (k2 "vaeltelu") ; --UNCHK
lin stroll_V = mkWV (k67 "käveleskellä") ; --UNCHK
lin stroma_N = mkWN (compoundN "str" (k10 "oma")) ; --UNCHK
lin strong_A = mkA "vahva" ;
lin strong_arm_A = mkA "väkivaltainen" ;
lin strongbox_N = mkWN (compoundN "kassa" (k5A "kaappi")) ; --UNCHK
lin stronghold_N = mkWN (k48A "linnake") ; --UNCHK
lin strongman_N = mkWN (compoundN "voima" (k1 "hahmo")) ; --UNCHK
lin strongroom_N = mkWN (compoundN "kassa" (k5 "holvi")) ; --UNCHK
lin strontianite_N = mkWN (compoundN "stronti" (k5A "aniitti")) ; --UNCHK
lin strontium_N = mkWN (k5 "strontium") ; --UNCHK
lin strop_N = mkWN (compoundN "hioma" (k9 "hihna")) ; --UNCHK
lin strop_V2 = mkWV2 (k53A "teroittaa") ; --UNCHK
lin strophanthin_N = mkWN "strofantiini" ; --UNCHK
lin strophanthus_N = mkWN (k6 "oleanteri") ; --UNCHK
lin strophe_N = mkWN (k2 "säkeistö") ; --UNCHK
lin stroppy_A = mkWA (k10 "hankala") ; --UNCHK
lin stroud_PN = foreignPN "Stroud" ;
lin structural_A = mkA "rakenteellinen" ;
lin structuralism_N = mkWN (k12 "sosiologia") "strukturalistinen" ; --UNCHK
lin structure_N = mkN "rakenne" | mkN "rakennelma" ;
lin structure_V2 = mkWV2 (k54A "jäsentää") ; --UNCHK
lin strudel_N = mkWN (k6 "struudeli") ; --UNCHK
lin struggle_N = mkWN (k2 "ponnistelu") ; --UNCHK
lin struggle_V = mkWV (k67 "taistella") ; --UNCHK
lin struggle_VV = mkVV "ponnistella" infIllat ;
lin struggle_back_V = advV OP_struggle_V OP_back_Adv ; -- guess-p-verb
lin struggler_N = mkWN (k12 "taistelija") ; --UNCHK
lin strum_N = mkWN (k39 "rämpytys") ; --UNCHK
lin strum_V = mkWV (k53A "rämpyttää") ; --UNCHK
lin strum_V2 = mkWV2 (k53A "rämpyttää") ; --UNCHK
lin strumpet_N = mkWN (k1A "narttu") ; --UNCHK
lin strut_N = mkWN (k2 "rehvastelu") ; --UNCHK
lin strut_V = mkWV (k67 "ylvästellä") ; --UNCHK
lin struthiomimus_N = mkWN (compoundN "strutsin" (k12 "matkija")) ; --UNCHK
lin strychnine_N = mkWN (k5 "strykniini") ; --UNCHK
lin stuart_PN = foreignPN "Stuart" ;
lin stub_N = mkWN (k5A "tumppi") ; --UNCHK
lin stub_V2 = mkWV2 (k64 "lyödä") "varpaansa" ; --UNCHK
lin stub_out_V2 = mkWV2 (k53A "sammuttaa") ; --UNCHK
lin stubble_N = mkWN (k7A "sänki") ; --UNCHK
lin stubbly_A = mkWA (compoundA "sän" (k38 "kinen")) ; --UNCHK
lin stubborn_A = mkWA (compoundA "itse" (k38 "päinen")) ;
lin stubbornness_N = mkWN (k40 "omapäisyys") ; --UNCHK
lin stubby_A = mkWA (k43 "lyhyt") ; --UNCHK
lin stucco_N = mkWN (k1A "stukko") ; --UNCHK
lin stuck_V2 = mkV2 "kiinnittää" ; ---- ?
lin stud_N = mkWN (compoundN "avo" (k6 "pokeri")) ; --UNCHK
lin stud_V2 = mkWV2 (k53A "pönkittää") ; --UNCHK
lin stud_farm_N = mkWN (compoundN "hevos" (k9 "tila")) ; --UNCHK
lin stud_mare_N = mkWN (compoundN "siitos" (k9 "tamma")) ; --UNCHK
lin studbook_N = mkWN (compoundN "kanta" (k9 "kirja")) ; --UNCHK
lin studentFem_N = L.student_N ;
lin studentMasc_N = mkN "opiskelija" ;
lin studentship_N = mkWN (k10 "asema") ; --UNCHK
lin studio_N = mkWN (k3 "studio") ;
lin studious_A = mkWA (k38 "huolellinen") ; --UNCHK
lin studiousness_N = mkWN (k40 "huolellisuus") ; --UNCHK
lin studley_PN = foreignPN "Studley" ;
lin study_N = mkN "opiskelu" | mkN "tutkimus" ; ---- split
lin study_V = mkWV (k67 "opiskella") ;
lin study_V2 = mkWV2 (k67 "opiskella") partitive ;
lin stuff_N = mkN "kama" ;
lin stuff_V2 = mkWV2 (k53A "täyttää") ; --UNCHK
lin stuffer_N = mkWN (compoundN "mainos" (k38 "lehtinen")) ; --UNCHK
lin stuffiness_N = mkWN (k40 "pikkumaisuus") ; --UNCHK
lin stuffing_N = mkWN (k48 "pehmuste") ; --UNCHK
lin stuffy_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin stultification_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin stultify_V2 = mkWV2 (k74 "tuhota") ; --UNCHK
lin stumble_N = mkWN (k48 "virhe") ; --UNCHK
lin stumble_V = mkWV (k53A "kömmähtää") ; --UNCHK
lin stumblebum_N = mkWN (k2 "tohelo") ; --UNCHK
lin stumbler_N = mkWN (k10 "hutiloija") ; --UNCHK
lin stumbling_block_N = mkWN (compoundN "kompastus" (k7 "kivi")) ; --UNCHK
lin stump_N = mkWN (k48A "koroke") ; --UNCHK
lin stump_V = mkWV (k73 "raivata") ; --UNCHK
lin stump_V2 = mkWV2 (k73 "raivata") ; --UNCHK
lin stumper_N = mkWN (k12 "pähkinä") "kuva" ; --UNCHK
lin stumping_N = mkWN (compoundN "puhe" (k12 "kampanja")) ; --UNCHK
lin stumpy_A = mkWA (k10A "lyhyenläntä") ; --UNCHK
lin stun_V2 = mkV2 "ällistyttää" partitive ; ---ARB --mkWV2 (k73 "tyrmätä") ;
lin stun_V2S = mkWV2S (k73 "tyrmätä") ; --UNCHK
lin stunner_N = mkWN (k39 "yllätys") ; --UNCHK
lin stunning_A = mkA "mykistävä" ;
lin stunt_N = mkWN (k1A "temppu") ; --UNCHK
lin stunt_V2 = mkWV2 (k67 "temppuilla") ; --UNCHK
lin stupa_N = mkWN "stupa" ; --UNCHK
lin stupefaction_N = mkWN (compoundN "pitkä" (k38 "styttäminen")) ; --UNCHK
lin stupefy_V2 = mkWV2 (k73 "tyrmätä") ; --UNCHK
lin stupefying_A = mkWA "ällistyttävä" ; --UNCHK
lin stupendous_A = mkWA (k38 "jättiläismäinen") ; --UNCHK
lin stupid_A = L.stupid_A ;
lin stupid_N = mkWN (k5 "pahvi") ; --UNCHK
lin stupidity_N = mkWN (k39 "möhläys") ; --UNCHK
lin stupor_N = mkWN (k12 "tokkura") ; --UNCHK
lin sturdiness_N = mkWN "periksiantamattomuus" ; --UNCHK
lin sturdy_A = mkWA (k34A "taipumaton") ; --UNCHK
lin sturgeon_N = mkWN (k7A "sampi") ; --UNCHK
lin stutter_N = mkWN (k39 "änkytys") ; --UNCHK
lin stutter_V = mkWV (k67A "takellella") ; --UNCHK
lin stutter_V2 = mkWV2 (k67A "takellella") ; --UNCHK
lin stutterer_N = mkWN (k10 "änkyttäjä") ; --UNCHK
lin stuttgart_PN = foreignPN "Stuttgart" ;
lin sty_N = mkWN (k5A "sikolätti") ; --UNCHK
lin stye_N = mkWN (compoundN "silmä" (k39 "tulehdus")) ; --UNCHK
lin stygian_A = mkWA (k10A "synkkä") ; --UNCHK
lin style_N = mkN "tyyli" ;
lin style_V2 = mkWV2 (k62 "editoida") ; --UNCHK
lin styleless_A = mkWA (k34A "tyylitön") ; --UNCHK
lin stylet_N = mkWN (k33A "koetin") ; --UNCHK
lin stylish_A = mkWA (k41A "tyylikäs") ; --UNCHK
lin stylishness_N = mkWN (k40 "upeus") ; --UNCHK
lin stylist_N = mkWN (k10 "kampaaja") ; --UNCHK
lin stylistic_A = mkWA (k38 "tyylillinen") ; --UNCHK
lin stylite_N = mkWN (compoundN "pylväs" (k39 "pyhimys")) ; --UNCHK
lin stylization_N = mkWN (k2 "muotoilu") ; --UNCHK
lin stylize_V2 = mkWV2 (k67A "tyylitellä") ; --UNCHK
lin stylopodium_N = mkWN "stylopodium" ; --UNCHK
lin stylus_N = mkWN (k33A "piirrin") ; --UNCHK
lin stymie_N = mkWN (k40 "vaikeus") ; --UNCHK
lin stymy_V2 = mkV2 (mkV "vaikeuttaa") partitive ;
lin styptic_A = mkWA "tyrehdyttävä" ; --UNCHK
lin styptic_N = mkWN (k48A "lääke") "verenvuodon" "lakkauttava" ; --UNCHK
lin styracosaur_N = mkWN (k1 "piikkilisko") ; --UNCHK
lin styrax_N = mkWN "japaninlumikello" ; --UNCHK
lin styrene_N = mkWN "styreeni" ; --UNCHK
lin suasion_N = mkWN (k2 "suostuttelu") ; --UNCHK
lin suave_A = mkWA (compoundA "sula" (k38 "vakäytöksinen")) ; --UNCHK
lin suavity_N = mkWN (k40 "sulavuus") ; --UNCHK
lin sub_N = mkWN (compoundN "sukellus" (k48 "vene")) ; --UNCHK
lin sub_V = mkWV (k61 "toimia") "sijaisena" ; --UNCHK
lin sub_V2 = mkWV2 (k61 "toimia") "sijaisena" ; --UNCHK
lin sub_judice_A = mkWA (k10 "oleva") "ratkaisematta" ; --UNCHK
lin sub_rosa_Adv = mkWAdv (k99 "vaivihkaa") ; --UNCHK
lin sub_underwrite_V2 = mkV2 (mkV (mkV "sitoutua") "ostamaan") ;
lin subacid_A = mkWA "hapahko" ; --UNCHK
lin subacute_A = mkWA (k34A "oireeton") ; --UNCHK
lin subaltern_N = mkWN (k5A "vänrikki") ; --UNCHK
lin subaqueous_A = mkWA (k99 "alla") "veden" ; --UNCHK
lin subarctic_A = mkWA (k38 "subarktinen") ; --UNCHK
lin subartesian_A = mkWA (k38 "arteesinen") ; --UNCHK
lin subatomic_A = mkWA "subatominen" ; --UNCHK
lin subbase_N = mkWN (compoundN "ala" (k10 "osa")) "jalustan" ; --UNCHK
lin subbing_N = mkWN (compoundN "sija" (k38 "istaminen")) ; --UNCHK
lin subclass_N = mkWN (k10A "alaluokka") ; --UNCHK
lin subclavian_A = mkWA (k38 "alinen") "solisluun" ; --UNCHK
lin subclinical_A = mkWA (k34A "oireeton") ; --UNCHK
lin subcommittee_N = mkWN (compoundN "ala" (k12 "komitea")) ;
lin subcompact_N = mkWN (k1 "auto") ; --UNCHK
lin subconscious_A = mkWA (k34A "tiedostamaton") ; --UNCHK
lin subconscious_N = mkWN (compoundN "piilo" (k9A "tajunta")) ; --UNCHK
lin subconsciousness_N = mkWN (compoundN "ali" (k9A "tajunta")) ; --UNCHK
lin subcontinent_N = mkWN "subkontinentti" ; --UNCHK
lin subcontract_N = mkWN (compoundN "lisä" (k39 "sopimus")) ; --UNCHK
lin subcontract_V = mkWV (compoundV "ali" (k68 "urakoida")) ; --UNCHK
lin subcontract_V2 = mkWV2 (compoundV "ali" (k68 "urakoida")) ; --UNCHK
lin subcontractor_N = mkWN (compoundN "ali" (k12 "hankkija")) ;
lin subcortical_A = mkWA (compoundA "aivokuoren" (k38 "alainen")) ; --UNCHK
lin subculture_N = mkWN (compoundN "ala" (k6 "kulttuuri")) ; --UNCHK
lin subcutaneous_A = mkWA (compoundA "ihon" (k38 "alainen")) ; --UNCHK
lin subdeacon_N = mkWN (compoundN "ali" (k6 "diakoni")) ; --UNCHK
lin subdirectory_N = mkWN (compoundN "ali" (k1 "hakemisto")) ; --UNCHK
lin subdivide_V = mkWV (k56A "jakaa") ; --UNCHK
lin subdivide_V2 = mkWV2 (k56A "jakaa") ; --UNCHK
lin subdivider_N = mkWN "palstoittaja" ; --UNCHK
lin subdivision_N = mkWN (compoundN "uudelleen" (k38 "jakaminen")) ; --UNCHK
lin subdominant_N = mkWN (compoundN "ala" (k5A "dominantti")) ; --UNCHK
lin subduable_A = mkWA (k10 "oleva") "valloitettavissa" ; --UNCHK
lin subduction_N = mkWN (k10 "siirtymä") ; --UNCHK
lin subdue_V2 = mkV2 "hillitä" ; --mkWV2 (k53 "kukistaa") ;
lin subduer_N = mkWN (k10 "valloittaja") ; --UNCHK
lin subdural_A = mkWA (k38 "alainen") "kovakalvon" ; --UNCHK
lin subeditor_N = mkWN (compoundN "toimitus" (k6 "sihteeri")) ; --UNCHK
lin subfamily_N = mkWN (compoundN "ala" (k1 "heimo")) ; --UNCHK
lin subfigure_N = mkWN (compoundN "ala" (k3 "kuvio")) ; --UNCHK
lin subfusc_A = mkWA (k34A "mitätön") ; --UNCHK
lin subgenus_N = mkWN (compoundN "ala" (k5 "laji")) ; --UNCHK
lin subgross_A = mkWA (k34A "näkymätön") ; --UNCHK
lin subgroup_N = mkWN (compoundN "ala" (k1A "joukko")) ; --UNCHK
lin subheading_N = mkWN (compoundN "väli" (k4A "otsikko")) ; --UNCHK
lin subhuman_A = mkWA (compoundA "epä" (k38 "inhimillinen")) ; --UNCHK
lin subjacent_A = mkWA (compoundA "ala" (k38 "puolinen")) ; --UNCHK
lin subject_1_N = mkN "aihe" ;
lin subject_2_N = mkN "subjekti" ;
lin subject_A = mkWA (k41A "altis") ; --UNCHK
lin subject_to_A2 = mkA2 (mkWA (k41A "altis")) (casePrep allative) ;
lin subject_N = mkWN (k48 "aihe") ;
lin subject_V2 = mkV2 "altistaa" ; ---ARB --mkWV2 (k56A "antaa") "arvioitavaksi" ;
lin subject_to_Prep = mkPrep "alttiina" allative ; ---- sense
lin subjection_N = mkWN (compoundN "ali" (k38 "staminen")) ; --UNCHK
lin subjective_A = mkWA (k38 "subjektiivinen") ; --UNCHK
lin subjectivism_N = mkWN (k40 "yksipuolisuus") ; --UNCHK
lin subjectivist_N = mkWN (k5 "subjektivisti") ; --UNCHK
lin subjectivity_N = mkWN (k40 "subjektiivisuus") ; --UNCHK
lin subjoin_V2 = mkWV2 (k53A "liittää") ; --UNCHK
lin subjugate_V2 = mkWV2 (k53 "kukistaa") ; --UNCHK
lin subjugation_N = mkWN (compoundN "ali" (k38 "staminen")) ; --UNCHK
lin subjugator_N = mkWN (k10 "valloittaja") ; --UNCHK
lin subjunctive_A = mkWA "subjunktiivi-" ; --UNCHK
lin subjunctive_N = mkWN "konjunktiivi" ; --UNCHK
lin subkingdom_N = mkWN (k10 "ryhmä") "taksonominen" ; --UNCHK
lin sublease_N = mkWN (compoundN "edelleen" (k39 "vuokraus")) ; --UNCHK
lin sublease_V = mkWV (compoundV "jälleen" (k73 "vuokrata")) ; --UNCHK
lin sublease_V2 = mkWV2 (compoundV "jälleen" (k73 "vuokrata")) ; --UNCHK
lin sublet_V = mkWV (compoundV "jälleen" (k73 "vuokrata")) ; --UNCHK
lin sublet_V2 = mkWV2 (compoundV "jälleen" (k73 "vuokrata")) ; --UNCHK
lin sublieutenant_N = mkWN (compoundN "ali" (k5A "luutnantti")) ; --UNCHK
lin sublimate_N = mkWN "sublimaatti" ; --UNCHK
lin sublimate_V2 = mkWV2 (k52A "sublimoitua") ; --UNCHK
lin sublimation_N = mkWN (k3 "sublimaatio") ; --UNCHK
lin sublime_A = mkA "hämmästyttävä" ; ---ARB
lin sublimed_A = mkWA (compoundA "sublimo" (k1A "itu")) ; --UNCHK
lin subliminal_A = mkWA (k34A "tiedostamaton") ; --UNCHK
lin sublimity_N = mkWN (k40 "ylevyys") ; --UNCHK
lin subliterary_A = mkWA "oheistekstit" ; --UNCHK
lin sublittoral_A = mkWA (compoundA "sublit" (k38 "oraalinen")) ; --UNCHK
lin sublunar_A = mkWA "sublunaarinen" ; --UNCHK
lin subluxation_N = mkWN (compoundN "sijoiltaan" (k1 "meno")) ; --UNCHK
lin submarine_A = mkWA (compoundA "veden" (k38 "alainen")) ; --UNCHK
lin submarine_N = mkWN (compoundN "sukellus" (k48 "vene")) ; --UNCHK
lin submariner_N = mkWN (k32 "jäsen") "sukellusveneen" "miehistön" ; --UNCHK
lin submediant_N = mkWN "mediantti" ; --UNCHK
lin submerge_V = mkWV (k53A "hukuttaa") ; --UNCHK
lin submerge_V2 = mkWV2 (k53A "hukuttaa") ; --UNCHK
lin submergence_N = mkWN "uppoaminen" ; --UNCHK
lin submersible_A = mkWA "uppo-" ; --UNCHK
lin submersible_N = mkWN (compoundN "sukellus" (k48 "vene")) ; --UNCHK
lin submersion_N = mkWN (compoundN "kas" (k38 "taminen")) ; --UNCHK
lin submission_N = mkWN (compoundN "ali" (k38 "stuminen")) ; --UNCHK
lin submissiveness_N = mkWN (k40 "tottelevaisuus") ; --UNCHK
lin submit_V = mkWV (k53A "sietää") ; --UNCHK
lin submit_V2 = mkV2 (mkV (mkV "lähettää") "arvioitavaksi") ;
lin submitter_N = mkWN (k10 "anoja") ; --UNCHK
lin submucosa_N = mkWN (compoundN "lima" (k1 "kalvo")) ; --UNCHK
lin subnormal_A = mkWA (compoundA "ala" (k38 "puolinen")) "normaalin" ; --UNCHK
lin subnormal_N = mkWN (k38 "ihminen") "heikkolahjainen" ; --UNCHK
lin subnormality_N = mkWN (k40 "takaperoisuus") ; --UNCHK
lin suboceanic_A = mkWA (compoundA "meren" (k38 "alainen")) ; --UNCHK
lin suborbital_A = mkWA (compoundA "suborbita" (k38 "alinen")) ; --UNCHK
lin suborder_N = mkWN (compoundN "ala" (k5 "laji")) ; --UNCHK
lin subordinate_A = mkWA (k38 "alisteinen") ;
lin subordinate_N = mkN "alainen" ; --mkWN (compoundN "ala" (k48A "käsite")) ;
lin subordinate_V2 = mkWV2 (k53 "alistaa") ; --f75
lin subordinateness_N = mkWN (k10 "asema") "alisteinen" ; --UNCHK
lin subordination_N = mkWN (k40 "herruus") ; --UNCHK
lin subordinative_A = mkWA "alistava" ; --UNCHK
lin suborn_V2 = mkWV2 (k67A "vietellä") "laittomuuteen" ; --UNCHK
lin subornation_N = mkWN (k39 "todistus") ; --UNCHK
lin subpart_N = mkWN (k10 "osa") ; --UNCHK
lin subphylum_N = mkWN (compoundN "ala" (k1 "jakso")) ; --UNCHK
lin subpoena_N = mkWN (k48 "haaste") "todistajan" ;
lin subpoena_V2 = mkWV2 (k56 "haastaa") ; --UNCHK
lin subpopulation_N = mkWN (compoundN "ala" (k3 "populaatio")) ; --UNCHK
lin subrogation_N = mkWN "subrogaatio" ; --UNCHK
lin subscribe_V = mkWV (k54A "puoltaa") ; --UNCHK
lin subscribe_V2 = mkWV2 (k54A "puoltaa") ; --UNCHK
lin subscriber_N = mkN "tilaaja" ;
lin subscript_A = mkWA (compoundA "ala" (k5 "indeksi")) ; --UNCHK
lin subscript_N = mkWN (k5 "indeksi") ; --UNCHK
lin subscription_N = mkWN (compoundN "alle" (k38 "kirjoittaminen")) ; --UNCHK
lin subsection_N = mkWN (compoundN "ala" (k2 "osasto")) ; --UNCHK
lin subsequent_A = mkWA (k10 "seuraava") ;
lin subserve_V2 = mkWV2 (k67 "palvella") ; --UNCHK
lin subservience_N = mkWN (k40 "nöyryys") ; --UNCHK
lin subservient_A = mkWA (k10 "myöntyvä") "nöyrästi" ; --UNCHK
lin subset_N = mkWN (compoundN "osa" (k1A "joukko")) ; --UNCHK
lin subshrub_N = mkWN (k1A "varpu") ; --UNCHK
lin subside_V = mkWV (k52 "painua") ; --UNCHK
lin subsidence_N = mkWN "romahtaminen" ; --UNCHK
lin subsidiary_A = mkWA "täydentävä" ; --UNCHK
lin subsidiary_N = mkWN (compoundN "tytär" (k3 "yhtiö")) ; --f223
lin subsidization_N = mkWN (k99 "rahallisesti") "tukeminen" ; --UNCHK
lin subsidize_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin subsidizer_N = mkWN (k12 "tukija") ; --UNCHK
lin subsidy_N = mkWN (k38 "tukiainen") ; --f52
lin subsist_V = mkWV (k75 "selvitä") ; --UNCHK
lin subsistence_N = mkWN (compoundN "olemassa" (k1 "olo")) ;
lin subsoil_N = mkWN (k1A "jankko") ; --UNCHK
lin subsonic_A = mkWA (compoundA "yli" (k38 "äänen")) ; --UNCHK
lin subspace_N = mkWN (compoundN "ali" (k40 "avaruus")) ; --UNCHK
lin subspecies_N = mkWN (compoundN "ala" (k5 "laji")) ; --UNCHK
lin substance_N = mkWN (k12 "materia") ; --UNCHK
lin substandard_A = mkA (mkN "ala" (mkN "arvoinen")) ;
lin substantial_A = mkA "merkittävä" ;
lin substantiality_N = mkWN (k40 "aineellisuus") ; --UNCHK
lin substantiate_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin substantiation_N = mkWN (k39 "todistus") ; --UNCHK
lin substantival_A = mkWA (k38 "substantiivinen") ; --UNCHK
lin substantive_A = mkA "huomattava" ;
lin substantive_N = mkWN (k5 "substantiivi") ; --UNCHK
lin substation_N = mkWN (compoundN "ala-" (k10 "asema")) ; --UNCHK
lin substitutable_A = mkWA (k10 "oleva") "korvattavissa" ; --UNCHK
lin substitute_N = mkWN (k38 "sijainen") ; --UNCHK
lin substitute_V = mkWV (k56A "vaihtaa") ; --UNCHK
lin substitute_V2 = mkV2 "korvata" partitive ; --mkWV2 (k56A "vaihtaa") ;
lin substitution_N = mkWN (k1A "vaihto") ; --UNCHK
lin substrate_N = mkWN "substraatti" ; --UNCHK
lin substratum_N = mkWN "substraatti" ; --UNCHK
lin substring_N = mkWN (k26 "jousi") ; --UNCHK
lin substructure_N = mkWN (k7 "tyvi") ; --UNCHK
lin subsume_V2 = mkWV2 (k53A "sisällyttää") ; --UNCHK
lin subsumption_N = mkWN (k2 "luokittelu") ; --UNCHK
lin subsurface_A = mkWA (compoundA "pinnan" (k38 "alainen")) ; --UNCHK
lin subsystem_N = mkWN (compoundN "ala" (k10 "järjestelmä")) ; --UNCHK
lin subtend_V2 = mkWV2 (k67 "olla") "vastapäätä" ; --UNCHK
lin subterfuge_N = mkWN (k1A "temppu") ; --UNCHK
lin subterminal_A = mkWA (k10 "oleva") "häntäpäässä" ; --UNCHK
lin subterranean_A = mkWA (k38 "etäinen") ; --UNCHK
lin subthalamus_N = mkWN (compoundN "sub" (k39 "talamus")) ; --UNCHK
lin subtilin_N = mkWN "subtuliini" ; --UNCHK
lin subtitle_N = mkWN (compoundN "ala" (k4A "otsikko")) ; --UNCHK
lin subtitle_VS = mkWVS (k53A "tekstittää") ; --UNCHK
lin subtle_A = mkA "hienovarainen" ; --mkWA (k38 "haitallinen") ;
lin subtlety_N = mkWN (k40 "herkkyys") ; --UNCHK
lin subtonic_N = mkWN (compoundN "johto" (k32 "sävel")) ; --UNCHK
lin subtopia_N = mkWN (compoundN "nukkuma" (k3 "lähiö")) ; --UNCHK
lin subtotal_N = mkWN (compoundN "väli" (k10 "summa")) ; --UNCHK
lin subtract_V2 = mkWV2 (k54A "vähentää") ;
lin subtracter_N = mkWN (k33 "laskin") ; --UNCHK
lin subtraction_N = mkWN (k39 "vähennys") ; --UNCHK
lin subtractive_A = mkWA "vähennys-" ; --UNCHK
lin subtrahend_N = mkWN (k10 "vähentäjä") ; --UNCHK
lin subtreasury_N = mkWN (compoundN "vara" (k2 "rahasto")) ; --UNCHK
lin subtropical_A = mkWA (k38 "subtrooppinen") ; --UNCHK
lin subtropics_N = mkWN (k2 "ilmasto") "subtrooppinen" ; --UNCHK
lin suburb_N = mkWN (k3 "lähiö") ; --UNCHK
lin suburban_A = mkA "lähiöläinen" ;
lin suburbanite_N = mkWN (compoundN "lähiö" (k41A "asukas")) ; --UNCHK
lin suburbanized_A = mkWA "lähiöiden" "ympäröimä" ; --UNCHK
lin suburbia_N = mkWN "suburbia" ; --UNCHK
lin subvention_N = mkWN (k7A "tuki") ; --UNCHK
lin subversion_N = mkWN (k9A "toiminta") "valtionvastainen" ; --UNCHK
lin subversive_N = mkWN (k38 "kumouksellinen") ; --UNCHK
lin subvert_V2 = mkWV2 (k74 "tuhota") ; --UNCHK
lin subvocalizer_N = mkWN (k10 "puhuja") ; --UNCHK
lin subway_N = mkWN (k1 "metro") ;
lin subwoofer_N = mkWN "subwoofer" ; --UNCHK
lin succedaneum_N = mkWN "succedaneum" ; --UNCHK
lin succeed_V = mkV "onnistua" ;
lin succeed_V2 = mkWV2 (k73 "seurata") partitive ;
lin success_N = mkN "menestys" ;
lin successful_A = mkWA (k47 "onnistunut") ;
lin succession_N = mkN "sarja" ; --mkWN (compoundN "per" (k38 "iminen")) ;
lin successive_A = mkWA (k38 "perättäinen") ; --UNCHK
lin successor_N = mkWN (k10 "seuraaja") ;
lin succinct_A = mkWA (k5 "kompakti") ; --UNCHK
lin succinctness_N = mkWN (k40 "ytimekkyys") ; --UNCHK
lin succinic_A = mkWA "meripihka-" ; --UNCHK
lin succinylcholine_N = mkWN "suksametoni" ; --UNCHK
lin succorer_N = mkWN (k10 "pelastaja") ; --UNCHK
lin succotash_N = mkWN (compoundN "maissi" (k9A "papupata")) ; --UNCHK
lin succour_N = mkWN (k39 "avustus") ; --UNCHK
lin succour_V2 = mkWV2 (k56A "auttaa") ; --UNCHK
lin succubus_N = mkWN (compoundN "nais" (k38 "paholainen")) ; --UNCHK
lin succulence_N = mkWN (k40 "mehukkuus") ; --UNCHK
lin succulent_A = mkWA (k41A "mehukas") ; --UNCHK
lin succulent_N = mkWN (compoundN "mehi" (k5 "kasvi")) ; --UNCHK
lin succumb_V = mkWV (k53A "luovuttaa") ; --UNCHK
lin succussion_N = mkWN (k2 "ravistelu") ; --UNCHK
lin such_Adv = mkWAdv (k99 "ylen") ; --UNCHK
lin such_Predet = lin Predet {s = \\n,c => (snoun2nounBind (mkN "sellainen")).s ! NCase n (npform2case n c)} ;
lin such_as_Prep = mkPrep "kuten" nominative ;
lin suchlike_A = mkWA (k10 "vastaava") ; --UNCHK
lin suck_N = mkWN "imeminen" ; --UNCHK
lin suck_V = mkWV (k53A "lutkuttaa") ; --UNCHK
lin suck_V2 = L.suck_V2 ;
lin suck_in_V2 = mkWV2 (k58 "imeä") ; --UNCHK
lin suck_up_V = mkWV (k68 "pokkuroida") ; --UNCHK
lin suckerFem_N = mkWN (compoundN "imu" (k5A "karppi")) ; --UNCHK
lin suckerMasc_N = mkWN (compoundN "imu" (k5A "karppi")) ; --UNCHK
lin sucking_N = mkWN "imeminen" ; --UNCHK
lin sucking_pig_N = mkWN (compoundN "juotto" (k41 "porsas")) ; --UNCHK
lin suckle_V2 = mkWV2 (k53A "imettää") ; --UNCHK
lin suckling_N = mkWN (k39 "imetys") ; --UNCHK
lin sucralfate_N = mkWN "Carafate" ; --UNCHK
lin sucre_N = mkWN "Sucre" ; --UNCHK
lin sucrose_N = mkWN (k5 "sakkaroosi") ; --UNCHK
lin suction_N = mkWN "imeminen" ; --UNCHK
lin suctorial_A = mkWA "imu-" ; --UNCHK
lin sudan_PN = foreignPN "Sudan" ;
lin sudanese_A = mkWA (compoundA "sudani" (k38 "lainen")) ; --UNCHK
lin sudanese_N = mkWN (compoundN "sudani" (k38 "lainen")) ; --UNCHK
lin sudatorium_N = mkWN (compoundN "höyry" (k12 "kylpylä")) ; --UNCHK
lin sudbury_PN = foreignPN "Sudbury" ;
lin sudden_A = mkWA (k38 "yhtäkkinen") ;
lin suddenness_N = mkWN (k40 "yllättävyys") ; --UNCHK
lin sudoku_N = mkWN "sudoku" ; --UNCHK
lin sudorific_N = mkWN (k48A "lääke") "hikoilua" "edistävä" ; --UNCHK
lin sudra_N = mkWN (kH1 "kasti") "alin" ; --UNCHK
lin suds_N = mkWN (k9 "kalja") ; --UNCHK
lin sue_PN = foreignPN "Sue" ;
lin sue_V = mkWV (k56 "haastaa") ; --UNCHK
lin sue_V2 = mkWV2 (k56 "haastaa") ; --UNCHK
lin sue_V2V = mkWV2V (k56 "haastaa") ; --UNCHK
lin suede_N = mkWN (k41A "mokkakangas") ; --UNCHK
lin suer_N = mkWN (k10 "kantaja") ; --UNCHK
lin suet_N = mkWN (k9 "ihra") ; --UNCHK
lin suety_A = mkWA (k38 "rasvainen") ; --UNCHK
lin suffer_V = mkV "kärsiä" ;
lin suffer_V2 = mkV2 (mkV "kärsiä") partitive ;
lin sufferable_A = mkWA (k10 "siedettävä") ; --UNCHK
lin sufferance_N = mkWN (k40 "suvaitsevuus") ; --UNCHK
lin sufferer_N = mkWN (k12 "kärsijä") ; --UNCHK
lin suffering_N = mkWN (k39 "kärsimys") ;
lin suffice_V = mkWV (k67A "menetellä") ; --UNCHK
lin suffice_V2 = mkWV2 (k67A "menetellä") ; --UNCHK
lin suffice_V2V = mkWV2V (k67A "menetellä") ; --UNCHK
lin sufficiency_N = mkWN (k40 "tyhjentävyys") ; --UNCHK
lin sufficient_A = mkWA (k10 "riittävä") ;
lin suffix_N = mkWN (k48A "pääte") ; --UNCHK
lin suffixation_N = mkWN "liittäminen" ; --UNCHK
lin suffocate_V = mkWV (k52A "pakahtua") ; --UNCHK
lin suffocate_V2 = mkWV2 (k52A "pakahtua") ; --UNCHK
lin suffocation_N = mkWN (compoundN "tuke" (k38 "hduttaminen")) ; --UNCHK
lin suffolk_PN = foreignPN "Suffolk" ;
lin suffragan_N = mkWN (k9 "piispa") "alempi" ; --UNCHK
lin suffrage_N = mkWN (compoundN "vaali" (k40 "oikeus")) ; --UNCHK
lin suffragette_N = mkWN (k5A "suffragetti") ; --UNCHK
lin suffragist_N = mkWN "suffragisti" ; --UNCHK
lin suffrutescent_A = mkWA (compoundA "varpu" (k38 "mainen")) ; --UNCHK
lin suffuse_V2 = mkWV2 (k75 "levitä") ; --UNCHK
lin suffusion_N = mkWN "tunkeutuminen" ; --UNCHK
lin suffusive_A = mkWA "leviävä" ; --UNCHK
lin sugar_N = mkN "sokeri" ; --f52
lin sugar_V2 = mkWV2 (k62 "sokeroida") ; --UNCHK
lin sugar_beet_N = mkWN (compoundN "sokeri" (k41A "juurikas")) ; --UNCHK
lin sugar_candy_N = mkWN (k5 "karamelli") ; --UNCHK
lin sugar_cane_N = mkWN (compoundN "sokeri" (k1A "ruoko")) ; --UNCHK
lin sugar_daddy_N = mkWN (compoundN "namu" (k10A "setä")) ; --UNCHK
lin sugar_loaf_N = mkWN (compoundN "toppa" (k6 "sokeri")) ; --UNCHK
lin sugar_refinery_N = mkWN (compoundN "sokerin" (k2 "jalostamo")) ; --UNCHK
lin sugarberry_N = mkWN (k25 "tuomi") ; --UNCHK
lin sugariness_N = mkWN (k40 "makeus") ; --UNCHK
lin sugarless_A = mkWA (k34A "sokeriton") ; --UNCHK
lin sugarplum_N = mkWN (compoundN "sokeri" (k1 "luumu")) ; --UNCHK
lin sugary_A = mkWA (k38 "sokerinen") ; --UNCHK
lin suggest_V = mkV "ehdottaa" ;
lin suggest_V2 = mkV2 (mkV "ehdottaa") ;
lin suggest_VS = mkVS (mkV "ehdottaa") ;
lin suggester_N = mkWN "alullepanija" ; --UNCHK
lin suggestibility_N = mkWN (k40 "vastaanottavuus") ; --UNCHK
lin suggestible_A = mkWA (k41A "altis") ; --UNCHK
lin suggestion_N = mkWN (k3 "suggestio") ; --UNCHK
lin suggestive_A = mkWA (compoundA "uskal" (k1A "lettu")) ; --UNCHK
lin suicidal_A = mkWA (k38 "itsetuhoinen") ; --UNCHK
lin suicide_N = mkWN (compoundN "itse" (k10 "murha")) ; --UNCHK
lin suit_N = mkWN (k48A "kanne") ; --f239 ---ARB mkN "puku"
lin suit_V = mkWV (k58A "pukea") ; --UNCHK
lin suit_V2 = mkV2 "sopia" allative ; --mkWV2 (k58A "pukea") ;
lin suit_up_V = advV OP_suit_V OP_up_Adv ; -- guess-p-verb
lin suitability_N = mkWN (k40 "sopivuus") ; --UNCHK
lin suitable_A = mkWA (k10 "sopiva") ;
lin suitableness_N = mkWN (k40 "sopivuus") ; --UNCHK
lin suitcase_N = mkWN (compoundN "matka" (k1A "laukku")) ; --UNCHK
lin suite_N = mkWN (k5A "sviitti") ; ---ARB ; seurue ; sarja
lin suiting_N = mkWN (k41A "pukukangas") ; --UNCHK
lin suitor_N = mkN "kantaja" ; --mkWN (k12 "kosija") ----ARB
lin sukiyaki_N = mkWN "sukiyaki" ; --UNCHK
lin suksdorfia_N = mkWN (k5 "kasvi") ; --UNCHK
lin sulcate_A = mkWA (k38 "uurteinen") ; --UNCHK
lin sulcus_N = mkWN (k1 "poimu") ; --UNCHK
lin sulfacetamide_N = mkWN (k5 "sulfasetamidi") ; --UNCHK
lin sulfadiazine_N = mkWN "sulfadiatsiini" ; --UNCHK
lin sulfamethazine_N = mkWN "sulfametatsiini" ; --UNCHK
lin sulfamethoxazole_N = mkWN "Gantanol" ; --UNCHK
lin sulfanilamide_N = mkWN (k5 "sulfanilamidi") ; --UNCHK
lin sulfapyridine_N = mkWN "sulfapyridiini" ; --UNCHK
lin sulfate_N = mkWN (k5A "sulfaatti") ; --UNCHK
lin sulfide_N = mkWN (k5 "sulfidi") ; --UNCHK
lin sulfisoxazole_N = mkWN "Gantrisin" ; --UNCHK
lin sulfonate_N = mkWN (compoundN "sulfo" (k5A "naatti")) ; --UNCHK
lin sulfonylurea_N = mkWN (compoundN "sulfonil" (k12 "urea")) ; --UNCHK
lin sulfur_N = mkWN (kH1 "rikki") ; --UNCHK
lin sulfurous_A = mkWA (compoundA "rikkipi" (k38 "toinen")) ; --UNCHK
lin sulindac_N = mkWN "Clinoril" ; --UNCHK
lin sulk_N = mkWN (k39 "mökötys") ; --UNCHK
lin sulk_V = mkWV (k53A "mököttää") ; --UNCHK
lin sulkava_PN = mkPN "Sulkava" ;
lin sulkiness_N = mkWN (k40 "happamuus") ; --UNCHK
lin sulky_A = mkWA (k15 "synkeä") ; --UNCHK
lin sullen_A = mkWA (k15 "synkeä") ; --UNCHK
lin sullenness_N = mkWN (k40 "happamuus") ; --UNCHK
lin sully_V2 = mkWV2 (k73A "liata") ; --UNCHK
lin sulpha_N = mkWN (k5 "sulfonamidi") ; --UNCHK
lin sulphate_N = mkWN (k5A "sulfaatti") ; --UNCHK
lin sulphide_N = mkWN (k5 "sulfidi") ; --UNCHK
lin sulphur_N = mkWN (kH1 "rikki") ; --UNCHK
lin sulphuretted_A = mkWA (compoundA "riki" (k1 "tetty")) ; --UNCHK
lin sulphuric_A = mkWA "rikki-" ; --UNCHK
lin sulphurous_A = mkWA (compoundA "rikkipi" (k38 "toinen")) ; --UNCHK
lin sultan_N = mkWN (k6 "sulttaani") ; --UNCHK
lin sultana_N = mkWN (k12 "rusina") "siemenetön" ; --UNCHK
lin sultanate_N = mkWN (compoundN "sulttaani" (k10A "kunta")) ; --UNCHK
lin sultriness_N = mkWN (k40 "hekumallisuus") ; --UNCHK
lin sum_N = mkN "summa" ;
lin sum_V = mkWV (k73 "summata") ;
lin sum_V2 = mkWV2 (k73 "ynnätä") ; --UNCHK
lin sum_up_V2 = mkWV2 (k73 "ynnätä") ; --UNCHK
lin sumac_N = mkWN "sumakki" ; --UNCHK
lin sumach_N = mkWN "sumakki" ; --UNCHK
lin sumatran_A = mkWA (compoundA "sumatr" (k38 "alainen")) ; --UNCHK
lin sumatran_N = mkWN (compoundN "sumatr" (k38 "alainen")) ; --UNCHK
lin sumiainen_PN = mkPN "Sumiainen" ;
lin summarization_N = mkWN (k1A "yhteenveto") "tehdä" ; --UNCHK
lin summarize_V2 = mkWV2 (k71 "tehdä") "yhteenveto" ; --UNCHK
lin summary_A = mkWA (k5 "kompakti") ; --UNCHK
lin summary_N = mkWN (k10 "lyhennelmä") ;
lin summation_N = mkWN (k99 "plus") ; --UNCHK
lin summer_N = mkN "kesä" ;
lin summer_V = mkWV (k53A "viettää") "kesää" ; --UNCHK
lin summerhouse_N = mkWN (compoundN "huvi" (k9 "maja")) ; --UNCHK
lin summertime_N = mkWN (k7 "suvi") ; --UNCHK
lin summery_A = mkWA (k38 "suvinen") ; --UNCHK
lin summing_up_N = mkWN (k1A "yhteenveto") ; --UNCHK
lin summit_N = mkN "huippu" ;
lin summon_V2 = mkV2 (mkV (mkV "kutsua") "koolle") ; --mkWV2 (k73 "kerätä") ;
lin summons_N = mkWN (k48 "haaste") ; --UNCHK
lin summons_V2 = mkWV2 (k56 "haastaa") ; --UNCHK
lin sumo_N = mkWN (compoundN "sumo" (k5 "paini")) ; --UNCHK
lin sump_N = mkWN (compoundN "saostus" (k1 "kaivo")) ; --UNCHK
lin sumpsimus_N = mkWN (k6 "liirumlaarum") ; --UNCHK
lin sumpter_N = mkWN (compoundN "kuorma" (k10A "juhta")) ; --UNCHK
lin sumptuary_A = mkWA (compoundA "sääte" (k10 "levä")) "kulutusta" ; --UNCHK
lin sumptuous_A = mkWA (k38 "ruhtinaallinen") ; --UNCHK
lin sumptuousness_N = mkWN (k40 "ruhtinaallisuus") ; --UNCHK
lin sun_N = L.sun_N ;
lin sun_V2 = mkWV2 (k67A "paistatella") "päivää" ; --UNCHK
lin sun_drenched_A = mkA "paahteinen" ;
lin sun_god_N = mkWN (compoundN "auringon" (k10 "jumala")) ; --UNCHK
lin sun_helmet_N = mkWN (compoundN "helle" (k10 "kypärä")) ; --UNCHK
lin sun_lounge_N = mkWN (compoundN "lasi" (k5 "kuisti")) ; --UNCHK
lin sun_parlour_N = mkWN (compoundN "lasi" (k5 "kuisti")) ; --UNCHK
lin sun_porch_N = mkWN (compoundN "lasi" (k5 "kuisti")) ; --UNCHK
lin sun_visor_N = mkWN (compoundN "häikäisy" (k39 "suojus")) ; --UNCHK
lin sunbaked_A = mkWA "auringon" "paahtama" ; --UNCHK
lin sunbathe_V = mkWV (k67A "paistatella") "päivää" ; --UNCHK
lin sunbather_N = mkWN (compoundN "auringon" (k10 "ottaja")) ; --UNCHK
lin sunbeam_N = mkWN (compoundN "auringon" (k48A "säde")) ; --UNCHK
lin sunblind_N = mkWN (k5 "markiisi") ; --UNCHK
lin sunbonnet_N = mkWN (compoundN "aurinko" (k1A "hattu")) ; --UNCHK
lin sunburn_N = mkWN (compoundN "auringonpaahde" (k39 "punoitus")) ; --UNCHK
lin sunburned_A = mkWA (k10 "polttama") "auringon" ; --UNCHK
lin sunburnt_A = mkWA (k10 "polttama") "auringon" ; --UNCHK
lin sunburst_N = mkWN (compoundN "säde" (k1A "kimppu")) ; --UNCHK
lin sundae_N = mkWN (k2 "jäätelö") "kuorrutettu" ; --UNCHK
lin sunder_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin sunderland_PN = foreignPN "Sunderland" ;
lin sundew_N = mkWN (k5A "kihokki") ; --UNCHK
lin sundial_N = mkWN (compoundN "aurinko" (k1 "kello")) ; --UNCHK
lin sundown_N = mkWN (compoundN "illan" (k18 "suu")) ; --UNCHK
lin sundowner_N = mkWN (compoundN "ilta" (k1A "ryyppy")) ; --UNCHK
lin sundress_N = mkWN (compoundN "helle" (k1A "mekko")) ; --UNCHK
lin sundrops_N = mkWN (k5A "helokki") ; --UNCHK
lin sundry_A = mkWA (k38 "sekalainen") ; --UNCHK
lin sunfish_N = mkWN (compoundN "aurinko" (k32 "ahven")) ; --UNCHK
lin sunflower_N = mkWN (compoundN "auringon" (k10A "kukka")) ; --UNCHK
lin sunglass_N = mkWN (compoundN "poltto" (k5 "lasi")) ; --UNCHK
lin sunhat_N = mkWN (compoundN "helle" (k1A "hattu")) ; --UNCHK
lin sunlamp_N = mkWN (compoundN "aurinko" (k1A "lamppu")) ; --UNCHK
lin sunless_A = mkWA (k10A "synkkä") ; --UNCHK
lin sunlight_N = mkWN (k1A "aurinko") ; --UNCHK
lin sunlit_A = mkWA (k38 "aurinkoinen") ; --UNCHK
lin sunniness_N = mkWN (k40 "hilpeys") ; --UNCHK
lin sunny_A = mkWA (k38 "aurinkoinen") ; --UNCHK
lin sunray_N = mkWN (compoundN "auringon" (k48A "säde")) ; --UNCHK
lin sunrise_N = mkWN (compoundN "päivän" (k1 "nousu")) ; --UNCHK
lin sunroof_N = mkWN (compoundN "katto" (k1A "luukku")) ; --UNCHK
lin sunscreen_N = mkWN (k10 "aurinkosuoja") ; --UNCHK
lin sunset_A = mkWA "raukeamis-" ; --UNCHK
lin sunset_N = mkWN (compoundN "auringon" (k1 "lasku")) ; --UNCHK
lin sunshade_N = mkWN (k5 "markiisi") ; --UNCHK
lin sunshine_N = mkWN (k40 "hilpeys") ; --UNCHK
lin sunspot_N = mkWN (k10 "täplä") ; --UNCHK
lin sunstone_N = mkWN (compoundN "aventuriini" (k5 "kvartsi")) ; --UNCHK
lin sunstroke_N = mkWN (compoundN "lämpö" (k39 "halvaus")) ; --UNCHK
lin sunsuit_N = mkWN (compoundN "helle" (k1A "puku")) ; --UNCHK
lin suntan_N = mkWN (k39 "päivetys") ; --UNCHK
lin suntrap_N = mkWN (k3 "patio") ; --UNCHK
lin suodenniemi_PN = mkPN (mkN "Suodenniemi" "Suodenniemiä") ;
lin suolahti_PN = mkPN (mkN "Suolahti" "Suolahtia") ;
lin suomusjärvi_PN = mkPN (mkN "Suomusjärvi" "Suomusjärviä") ;
lin suomussalmi_PN = mkPN (mkN "Suomussalmi" "Suomussalmia") ;
lin suonenjoki_PN = mkPN (mkN "Suonenjoki" "Suonenjokia") ;
lin sup_N = mkWN (k39 "kulaus") ; --UNCHK
lin sup_V = mkWV (k66 "siemaista") ; --UNCHK
lin sup_V2 = mkWV2 (k66 "siemaista") ; --UNCHK
lin super_A = mkWA (compoundA "huippu" (k1 "hieno")) ; --UNCHK
lin super_N = mkWN (k12 "isännöitsijä") ; --UNCHK
lin superabundance_N = mkWN (k40 "liiallisuus") ; --UNCHK
lin superabundant_A = mkWA (k10 "ylitsevuotava") ; --UNCHK
lin superannuate_V2 = mkWV2 (k63 "jäädä") "eläkkeelle" ; --UNCHK
lin superannuation_N = mkWN (k1 "pano") "eläkkeelle" ; --UNCHK
lin superb_A = mkWA (k38 "suurenmoinen") ; --UNCHK
lin superbug_N = mkWN (k38 "jauhiainen") ; --UNCHK
lin supercargo_N = mkWN "lastiperämies" ; --UNCHK
lin supercede_V2 = mkV2 "syrjäyttää" ;
lin supercharged_A = mkWA (compoundA "lata" (k47 "utunut")) ; --UNCHK
lin supercharger_N = mkWN (k33A "ahdin") ; --UNCHK
lin supercilious_A = mkWA (k38 "pilkallinen") ; --UNCHK
lin superciliousness_N = mkWN (k10A "halveksunta") ; --UNCHK
lin superclass_N = mkWN (k10A "yläluokka") ; --UNCHK
lin supercomputer_N = mkWN "supertietokone" ; --UNCHK
lin superconductivity_N = mkWN (compoundN "supra" (k40 "johtavuus")) ; --UNCHK
lin supercritical_A = mkWA (compoundA "yli" (k38 "kriittinen")) ; --UNCHK
lin superego_N = mkWN (k10 "yliminä") ; --UNCHK
lin supererogation_N = mkWN "supererogaatio" ; --UNCHK
lin superfamily_N = mkWN (compoundN "ylä" (k1 "heimo")) ; --UNCHK
lin superfatted_A = mkWA (compoundA "yli" (k1 "rasvoitettu")) ; --UNCHK
lin superfecta_N = mkWN (compoundN "iso" (k38 "nelonen")) ; --UNCHK
lin superfecundation_N = mkWN (compoundN "yli" (k39 "hedelmöitys")) ; --UNCHK
lin superfetation_N = mkWN (compoundN "lisä" (k39 "hedelmöitys")) ; --UNCHK
lin superficial_A = mkWA (k38 "pinnallinen") ; --UNCHK
lin superficiality_N = mkWN (k40 "pintapuolisuus") ; --UNCHK
lin superficies_N = mkWN (k26 "ulkokuori") ; --UNCHK
lin superfine_A = mkWA (compoundA "huippu" (k1 "hieno")) ; --UNCHK
lin superfluity_N = mkWN (k10 "määrä") "yletön" ; --UNCHK
lin superfluous_A = mkWA (k38 "liiallinen") ; --UNCHK
lin supergiant_N = mkWN (compoundN "yli" (k38 "jättiläinen")) ; --UNCHK
lin supergrass_N = mkWN (k14A "vasikka") ; --UNCHK
lin superhighway_N = mkWN (compoundN "valta" (k19 "tie")) ; --UNCHK
lin superhuman_A = mkWA (compoundA "yli-" (k38 "inhimillinen")) ; --UNCHK
lin superimpose_V2 = mkWV2 (k56A "laittaa") "päälle" ; --UNCHK
lin superincumbent_A = mkWA "päällä" "lepäävä" ; --UNCHK
lin superinfection_N = mkWN (compoundN "super" (k3 "infektio")) ; --UNCHK
lin superintend_V = mkWV (k53A "johtaa") ; --UNCHK
lin superintend_V2 = mkWV2 (k53A "johtaa") ; --UNCHK
lin superintendence_N = mkWN (k39 "ohjaus") ; --UNCHK
lin superintendent_N = mkWN (k10 "johtaja") ; --UNCHK
lin superior_A = mkWA (k16A "ylempi") ; --UNCHK
lin superior_N = mkWN (compoundN "ylä" (k5 "indeksi")) | mkWN (compoundN "esi" (k42 "mies")) ; --UNCHK
lin superiority_N = mkWN (k40 "ylemmyys") ; --UNCHK
lin superjacent_A = mkWA (k10 "oleva") "yläpuolella" ; --UNCHK
lin superlative_A = mkWA (k41 "paras") ; --UNCHK
lin superlative_N = mkWN (k5 "superlatiivi") "vertailuaste" ; --UNCHK
lin superman_N = mkWN (k1A "lappu") ; --UNCHK
lin supermarket_N = mkN "supermarket" ;
lin supermarketer_N = mkWN (k41 "kauppias") ; --UNCHK
lin supermodel_N = mkWN (compoundN "super" (k5 "malli")) ; --UNCHK
lin supermom_N = mkWN (compoundN "super" (k5A "äiti")) ; --UNCHK
lin supernal_A = mkWA (compoundA "yli" (k38 "maallinen")) ; --UNCHK
lin supernatant_A = mkWA "kelluva" ; --UNCHK
lin supernatant_N = mkWN (k48 "neste") "kelluva" ; --UNCHK
lin supernatural_A = mkWA (compoundA "yli" (k38 "luonnollinen")) ; --UNCHK
lin supernatural_N = mkWN (k5 "okkultismi") ; --UNCHK
lin supernaturalism_N = mkWN (compoundN "yli" (k40 "luonnollisuus")) ; --UNCHK
lin supernaturalist_A = mkWA (compoundA "yli" (k38 "luonnollinen")) ; --UNCHK
lin supernormal_A = mkWA "normaalia" "suurempi" ; --UNCHK
lin supernova_N = mkWN (compoundN "super" (k10 "nova")) ; --UNCHK
lin supernumerary_N = mkWN (k5 "statisti") ; --UNCHK
lin superorder_N = mkWN (compoundN "ylä" (k1 "lahko")) ; --UNCHK
lin superordinate_A = mkWA (k16A "ylempi") ; --UNCHK
lin superoxide_N = mkWN (k5 "peroksidi") ; --UNCHK
lin superphylum_N = mkWN (compoundN "ylä" (k1 "heimo")) ; --UNCHK
lin superposition_N = mkWN (compoundN "super" (k3 "positio")) ; --UNCHK
lin supersaturated_A = mkWA (compoundA "yli" (k1 "kyllästetty")) ; --UNCHK
lin superscript_A = mkWA (compoundA "ylä" (k5 "indeksi")) ; --UNCHK
lin superscript_N = mkWN (compoundN "ylä" (k5 "indeksi")) ; --UNCHK
lin superscription_N = mkWN (compoundN "päälle" (k39 "kirjoitus")) ; --UNCHK
lin supersede_V2 = mkV2 "syrjäyttää" ;
lin supersedure_N = mkWN (compoundN "korva" (k38 "aminen")) ; --UNCHK
lin supersession_N = mkWN (compoundN "korva" (k38 "aminen")) ; --UNCHK
lin supersonic_A = mkWA "ääntä" "nopeampi" ; --UNCHK
lin superstition_N = mkWN (compoundN "taika" (k1 "usko")) ; --UNCHK
lin superstitious_A = mkWA (compoundA "tai" (k38 "kauskoinen")) ; --UNCHK
lin superstrate_N = mkWN "superstraatti" ; --UNCHK
lin superstring_N = mkWN (k48A "säie") "supersymmetrinen" ; --UNCHK
lin superstructure_N = mkWN (compoundN "kansi" (k48A "rakenne")) ; --UNCHK
lin supersymmetry_N = mkWN (compoundN "super" (k12 "symmetria")) ; --UNCHK
lin supertanker_N = mkWN (compoundN "jätti" (k6 "tankkeri")) ; --UNCHK
lin supertax_N = mkWN (compoundN "lisä" (k1 "vero")) ; --UNCHK
lin supertitle_N = mkWN (k39 "tekstitys") ; --UNCHK
lin supertonic_N = mkWN (compoundN "super" (k13 "toonika")) ; --UNCHK
lin supertwister_N = mkWN (k2 "tornado") ; --UNCHK
lin supervene_V = mkWV (k52A "sattua") ; --UNCHK
lin supervention_N = mkWN (k10 "sattuma") ; --UNCHK
lin supervise_V = mkWV (k61A "vahtia") ; --UNCHK
lin supervise_V2 = mkWV2 (k61A "vahtia") ; --UNCHK
lin supervision_N = mkWN (k39 "ohjaus") ;
lin supervisor_N = mkWN (compoundN "valvonta" (k10 "ohjelma")) ; --UNCHK
lin supervisory_A = mkWA "valvova" ; --UNCHK
lin supination_N = mkWN (compoundN "ulos" (k1A "kierto")) ; --UNCHK
lin supinator_N = mkWN (compoundN "ulos" (k10 "kiertäjä")) ; --UNCHK
lin supine_A = mkWA (k38 "passiivinen") ; --UNCHK
lin supper_N = mkWN (k38 "illallinen") ; --UNCHK
lin supperless_A = mkWA (compoundA "illal" (k9 "lista")) "ilman" ; --UNCHK
lin supping_N = mkWN (k38 "syöminen") "keiton" ; --UNCHK
lin supplanter_N = mkWN (k6 "kaappari") ; --UNCHK
lin supplanting_N = mkWN (compoundN "syrjä" (k38 "yttäminen")) ; --UNCHK
lin supple_A = mkWA (k10 "taipuisa") ; --UNCHK
lin supplejack_N = mkWN (compoundN "kävely" (k5A "keppi")) ; --UNCHK
lin supplement_N = mkN "täydennys" ; --mkWN (k48 "varuste") ;
lin supplement_V2 = mkWV2 (k53A "liittää") "loppuun" ; --UNCHK
lin supplementary_A = mkWA "täydennetty" ; --UNCHK
lin supplementation_N = mkWN "täydentäminen" ; --UNCHK
lin suppleness_N = mkWN (k40 "sopeutuvuus") ; --UNCHK
lin suppliant_A = mkWA (k10 "nöyrä") ; --UNCHK
lin suppliant_N = mkWN (k10 "anoja") ; --UNCHK
lin supplicant_N = mkWN (k10 "anoja") ; --UNCHK
lin supplicate_V = mkWV (k54A "pyytää") "nöyrästi" ; --UNCHK
lin supplicate_V2 = mkWV2 (k54A "pyytää") "nöyrästi" ; --UNCHK
lin supplication_N = mkWN (k39 "rukous") ; --UNCHK
lin supplier_N = mkN "tavarantoimittaja" ;
lin supply_N = mkN "tarjonta" ;
lin supply_V2 = mkV2 "tarjota" partitive ;
lin support_N = mkN (lin NK {s = d07A "tuki"}) ;
lin support_V2 = mkV2 "kannattaa" partitive ;
lin supportable_A = mkWA (k10 "siedettävä") ; --UNCHK
lin supporter_N = mkN "kannattaja" ;
lin supporting_A = variants {} ; --
lin supportive_A = mkWA "tukea" "antava" ; --UNCHK
lin suppose_V2 = mkV2 "arvata" ;
lin suppose_VS = mkVS "olettaa" ;
lin supposed_A = mkWA (k38 "hypoteettinen") ; --UNCHK
lin supposition_N = mkWN (k10 "otaksuma") ; --UNCHK
lin suppository_N = mkWN (kH1 "suppo") ; --UNCHK
lin suppress_V2 = mkWV2 (k53A "tukahduttaa") ; --UNCHK
lin suppressant_N = mkWN (k48A "lääke") "ruokahalua" "hillitsevä" ; --UNCHK
lin suppression_N = mkWN (k1 "esto") ; --UNCHK
lin suppressive_A = mkWA "tukahduttava" ; --UNCHK
lin suppressor_N = mkN "estäjä" ;
lin suppurate_V = mkWV (k61A "märkiä") ; --UNCHK
lin suppuration_N = mkWN (k9 "visva") ; --UNCHK
lin suppurative_A = mkWA "märkivä" ; --UNCHK
lin supra_Adv = mkWAdv (k99 "ylhäällä") ; --UNCHK
lin suprainfection_N = mkWN (compoundN "supra" (k3 "infektio")) ; --UNCHK
lin supranational_A = mkWA (compoundA "yli" (k38 "kansallinen")) ; --UNCHK
lin supraorbital_A = mkWA (compoundA "ylä" (k38 "puolinen")) "silmäkuopan" ; --UNCHK
lin suprasegmental_A = mkWA (compoundA "supraseg" (k38 "mentaalinen")) ; --UNCHK
lin supremacism_N = mkWN (compoundN "yli" (k40 "valtius")) ; --UNCHK
lin supremacist_N = mkWN (k10 "kannattaja") "ylivallan" ; --UNCHK
lin supremacy_N = mkWN (k40 "herruus") ; --UNCHK
lin suprematist_N = mkWN "suprematisti" ; --UNCHK
lin supreme_A = mkWA (k36 "ylin") ; --UNCHK
lin supremo_N = mkWN (k1 "pomo") ; --UNCHK
lin sura_N = mkWN (k48A "pohje") ; --UNCHK
lin surbase_N = mkWN (compoundN "kar" (k27 "niisi")) ; --UNCHK
lin surcharge_N = mkWN (compoundN "lisä" (k1 "maksu")) ; --UNCHK
lin surcoat_N = mkWN (compoundN "ase" (k5A "takki")) ; --UNCHK
lin surd_N = mkWN (k5A "konsonantti") "soinniton" ; --UNCHK
lin sure_A = mkA "varma" ;
lin sure_Adv = mkWAdv (k99 "tosiaan") "totta" ; --UNCHK
lin sureness_N = mkWN (k40 "varmuus") ; --UNCHK
lin surety_N = mkWN (k40 "varmuus") ; --UNCHK
lin surf_N = mkWN (k4A "aallokko") ; --UNCHK
lin surface_A = mkWA "pinta-" ; --UNCHK
lin surface_N = mkWN (k9A "pinta") ;
lin surface_V = mkWV (k52A "näyttäytyä") ; --UNCHK
lin surface_V2 = mkWV2 (k52A "näyttäytyä") ; --UNCHK
lin surface_V2V = mkWV2V (k52A "näyttäytyä") ; --UNCHK
lin surface_VS = mkWVS (k52A "näyttäytyä") ; --UNCHK
lin surface_to_air_A = mkA (mkN "maasta ilmaan" (mkN "ammuttava")) ; ----sanaliitto
lin surfacing_N = mkWN "pintaan" "nouseminen" ; --UNCHK
lin surfbird_N = mkWN (compoundN "tyrsky" (k10 "kahlaaja")) ; --UNCHK
lin surfboard_N = mkWN (compoundN "laine" (k9A "lauta")) ; --UNCHK
lin surfboat_N = mkWN (compoundN "tyrsky" (k48 "vene")) ; --UNCHK
lin surfeit_N = mkWN (k2 "mässäily") ; --UNCHK
lin surfeit_V2 = mkWV2 (k56A "ahtaa") "täyteen" ; --UNCHK
lin surfer_N = mkWN (compoundN "laine" (k12 "lautailija")) ; --UNCHK
lin surficial_A = mkWA "maaperäkerrostuman" ; --UNCHK
lin surfing_N = mkWN (k39 "surffaus") ; --UNCHK
lin surfperch_N = mkWN (compoundN "tyrsky" (k32 "ahven")) ; --UNCHK
lin surfriding_N = mkWN (k39 "surffaus") ; --UNCHK
lin surge_N = mkN (lin NK {s = d10 "tulva"}) ;
lin surge_V = mkWV (k73A "virrata") ;
lin surge_V2 = mkWV2 (k73A "virrata") ; --UNCHK
lin surgeon_N = mkWN (k6 "haavuri") ; --UNCHK
lin surgeonfish_N = mkWN (compoundN "välskäri" (k9 "kala")) ; --UNCHK
lin surgery_N = mkWN (k48A "toimenpide") "kirurginen" ; --UNCHK
lin surgical_A = mkA "kirurginen" ; --mkWA (k38 "operatiivinen") ;
lin suricate_N = mkWN "Suricata" "tetradactyla" ; --UNCHK
lin surliness_N = mkWN (k40 "äreys") ; --UNCHK
lin surly_A = mkWA (k15 "töykeä") ; --UNCHK
lin surmise_N = mkWN (k48A "väite") ; --UNCHK
lin surmise_V = mkWV (k53A "olettaa") ; --UNCHK
lin surmise_V2 = mkWV2 (k53A "olettaa") ; --UNCHK
lin surmount_V2 = mkV2 "ylittää" ;
lin surmountable_A = mkWA (k10 "oleva") "ylitettävissä" ; --UNCHK
lin surname_N = mkWN (compoundN "suku" (k7 "nimi")) ; --UNCHK
lin surpass_V2 = mkV2 "ylittää" ;
lin surpassing_A = mkWA (k34A "tavaton") ; --UNCHK
lin surplice_N = mkWN (compoundN "messu" (k14A "kasukka")) ; --UNCHK
lin surpliced_A = mkWA "messukasukkaan" "puettu" ; --UNCHK
lin surplus_A = variants {} ; --
lin surplus_N = mkN "ylimäärä" ;
lin surprise_N = mkN "yllätys" ;
lin surprise_V2 = mkWV2 (k53A "yllättää") ;
lin surprise_V2V = mkWV2V (k53A "yllättää") ; --UNCHK
lin surprised_A = variants {} ; --
lin surpriser_N = mkWN (k10 "yllättäjä") ; --UNCHK
lin surprising_A = mkWA (k10 "yllättävä") ; --f69
lin surrealism_N = mkWN (k5 "surrealismi") ; --UNCHK
lin surrealist_N = mkWN (k5 "surrealisti") ; --UNCHK
lin surrealistic_A = mkWA (compoundA "epä" (k38 "todellinen")) ; --UNCHK
lin surrebutter_N = mkWN (k39 "vastaus") "kantajan" ; --UNCHK
lin surrejoinder_N = mkWN (k39 "vastaus") "kantajan" ; --UNCHK
lin surrender_N = mkWN "antautuminen" ; --UNCHK
lin surrender_V = mkV "luovuttaa" ; --mkWV (k52A "luopua") ;
lin surrender_V2 = mkV2 "luovuttaa" ; --mkWV2 (k52A "luopua") ;
lin surrenderer_N = mkWN (compoundN "periksi" (k10 "antaja")) ; --UNCHK
lin surreptitious_A = mkWA (k38 "salainen") ; --UNCHK
lin surrey_N = mkWN "surrey" ; --UNCHK
lin surrey_PN = foreignPN "Surrey" ;
lin surrogate_A = mkWA "kasvatti-" ; --UNCHK
lin surrogate_N = mkWN (k38 "sijainen") ; --UNCHK
lin surround_N = mkWN (k1 "ympäristö") ; --UNCHK
lin surround_V2 = mkV2 "ympäröidä" ;
lin surrounding_A = mkWA "ympäröivä" ; --UNCHK
lin surrounding_N = variants {} ; --
lin surtax_N = mkWN (compoundN "lisä" (k1 "vero")) ; --UNCHK
lin surtax_V2 = mkWV2 (k53A "verottaa") "lisää" ; --UNCHK
lin surtout_N = mkWN (k5A "takki") "pitkä" ; --UNCHK
lin surveillance_N = mkWN (k9A "valvonta") ;
lin survey_N = mkWN (k39 "kartoitus") ;
lin survey_V2 = mkV2 "katsastaa" ; ---ARB mkWV2 (k62 "arvioida") ;
lin surveying_N = mkWN (compoundN "maan" (k39 "mittaus")) ; --UNCHK
lin surveyor_N = mkWN (compoundN "maanmittaus" (k5 "insinööri")) ; --UNCHK
lin survival_N = mkWN (compoundN "elo" (k38 "onjääminen")) ; --UNCHK
lin survivalist_N = mkWN "survivalisti" ; --UNCHK
lin survive_V = mkV (mkV "säilyä") "hengissä" ; ---ARB mkWV (k75 "selvitä") ;
lin survive_V2 = mkWV2 (k75 "selvitä") ; --UNCHK
lin survive_VS = mkWVS (k75 "selvitä") ; --UNCHK
lin survivor_N = mkN "selviytyjä" ;
lin susceptibility_N = mkWN (k40 "herkkyys") ; --UNCHK
lin susceptible_A = mkWA (k10A "herkkä") ;
lin sushi_N = mkWN "sushi" ; --UNCHK
lin suspect_A = mkWA (k10 "epäilyttävä") ; --UNCHK
lin suspect_N = mkN "epäilty" ; --mkWN (k1A "syytetty") ;
lin suspect_V2 = mkV2 "epäillä" partitive ;
lin suspect_VS = mkWVS (k67 "epäillä") ;
lin suspend_V = mkWV (compoundV "suspen" (k62 "soida")) ; --UNCHK
lin suspend_V2 = mkV2 (mkV (mkV "keskeyttää") "väliaikaisesti") ;
lin suspense_N = mkWN (compoundN "epä" (k40 "varmuus")) ; --UNCHK
lin suspension_N = mkN "erottaminen" ; --f60
lin suspensive_A = mkWA (compoundA "epä" (k38 "tietoinen")) ; --UNCHK
lin suspensory_N = mkWN (compoundN "kannatin" (k5 "pussi")) ; --UNCHK
lin suspicion_N = mkN "epäilys" ; --mkWN (compoundN "epä" (k1 "luulo")) ;
lin suspicious_A = mkWA (k10 "epäilyttävä") ; --UNCHK
lin suss_out_V2 = mkWV2 (k73A "tsekata") ; --UNCHK
lin sussex_PN = foreignPN "Sussex" ;
lin sustain_V2 = mkV2 "ylläpitää" ; --f54
lin sustainability_N = mkWN (kH1 "vakaus") ; --UNCHK
lin sustainable_A = mkWA (k10 "kestävä") ; --UNCHK
lin sustenance_N = mkWN (k1A "elanto") ; --UNCHK
lin sustentacular_A = mkWA "tuki-" ; --UNCHK
lin susurration_N = mkWN (k40 "äänettömyys") ; --UNCHK
lin sutler_N = mkWN (compoundN "kanttiinin" (k10 "pitäjä")) ; --UNCHK
lin sutra_N = mkWN "sutra" ; --UNCHK
lin sutton_PN = foreignPN "Sutton" ;
lin suture_N = mkWN (k49A "ommel") ; --UNCHK
lin suturing_N = mkWN (compoundN "ompele" (k38 "minen")) ; --UNCHK
lin suzerain_N = mkWN (compoundN "suojelija" (k3 "valtio")) ; --UNCHK
lin suzerainty_N = mkWN (compoundN "yli" (k40 "herruus")) ; --UNCHK
lin svelte_A = mkWA (k9 "laiha") ; --UNCHK
lin svoboda_N = mkWN "svoboda" ; --UNCHK
lin swab_N = mkWN (k5A "moppi") ; --UNCHK
lin swab_V2 = mkWV2 (k66 "sipaista") ; --UNCHK
lin swabbing_N = mkWN (compoundN "luu" (k38 "ttuaminen")) ; --UNCHK
lin swad_N = mkWN (k10 "rykelmä") ; --UNCHK
lin swaddle_V2 = mkWV2 (k61 "kääriä") ; --UNCHK
lin swadlincote_PN = foreignPN "Swadlincote" ;
lin swag_N = mkWN (k5A "nyytti") ; --UNCHK
lin swagger_A = mkWA (k41A "tyylikäs") ; --UNCHK
lin swagger_N = mkWN (k2 "rehvastelu") ; --UNCHK
lin swagger_V = mkWV (k67 "ylvästellä") ; --UNCHK
lin swaggerer_N = mkWN (k12 "rehvastelija") ; --UNCHK
lin swagman_N = mkWN (k6 "kulkuri") ; --UNCHK
lin swain_N = mkWN (k4A "nuorikko") ; --UNCHK
lin swale_N = mkWN (k10 "notkelma") ; --UNCHK
lin swallow_N = mkWN (k39 "nielaus") ; --UNCHK
lin swallow_V = mkWV (k52 "uskoa") ; --UNCHK
lin swallow_V2 = mkV2 "niellä" ; --mkWV2 (k52 "uskoa") ;
lin swallow_up_V = mkWV (k73A "haudata") ; --UNCHK
lin swami_N = mkWN "swami" ; --UNCHK
lin swamp_N = mkWN (k10A "luhta") ; --UNCHK
lin swamp_V2 = mkWV2 (k52A "peittää") ;
lin swampy_A = mkWA (k10 "vetelä") ; --UNCHK
lin swan's_down_N = mkWN (compoundN "joutsenen" (k10 "untuva")) ; --UNCHK
lin swan_N = mkWN (k32 "joutsen") ; --UNCHK
lin swan_V = mkWV (k52 "vannoa") ; --UNCHK
lin swan_song_N = mkWN (k39 "ponnistus") "viimeinen" ; --UNCHK
lin swanage_PN = foreignPN "Swanage" ;
lin swank_A = mkWA (k15 "pramea") ; --UNCHK
lin swank_N = mkWN (k40 "upeus") ; --UNCHK
lin swank_V = mkWV (k67 "ylpeillä") ; --UNCHK
lin swanky_A = mkWA (k15 "pramea") ; --UNCHK
lin swanley_PN = foreignPN "Swanley" ;
lin swansea_PN = foreignPN "Swansea" ;
lin swap_N = mkN "vaihdos" ;
lin swap_V = mkWV (k53A "sivuttaa") ; --UNCHK
lin swap_V2 = mkV2 (mkV (lin VK {s = c56A "vaihtaa"})) partitive ;
lin sward_N = mkWN (k4A "nurmikko") ; --UNCHK
lin swarm_N = mkWN (k7 "pilvi") ; --UNCHK
lin swarm_V = mkWV (k67 "parveilla") ; --UNCHK
lin swarm_V2 = mkWV2 (k67 "parveilla") ; --UNCHK
lin swarthy_A = mkWA (k10 "tumma") ; --UNCHK
lin swash_N = mkWN (k48 "loiske") ; --UNCHK
lin swashbuckler_N = mkWN (k1A "uskalikko") ; --UNCHK
lin swashbuckling_A = mkWA "kerskaileva" ; --UNCHK
lin swashbuckling_N = mkWN (k2 "kerskailu") ; --UNCHK
lin swastika_N = mkWN (compoundN "haka" (k5 "risti")) ; --UNCHK
lin swat_N = mkWN "läimäytys" ; --UNCHK
lin swat_V2 = mkWV2 (k66 "läiskäistä") ; --UNCHK
lin swatch_N = mkWN (k1A "tilkku") ; --UNCHK
lin swath_N = mkWN (k48 "kaistale") ; --UNCHK
lin swathe_N = mkWN (k48 "kääre") ; --UNCHK
lin swathe_V2 = mkWV2 (k61 "kääriä") ; --UNCHK
lin swathing_N = mkWN (k9A "vaippa") ; --UNCHK
lin swatter_N = mkWN (compoundN "kärpäs" (k10 "lätkä")) ; --UNCHK
lin sway_N = mkWN (k39 "kallistus") ; --UNCHK
lin sway_V = mkV "huojua" ; --mkWV (k52A "keikkua") ;
lin sway_V2 = mkV2 "huojuttaa" ; --WV2 (k52A "keikkua") ;
lin swazi_A = mkWA (compoundA "swaz" (k32A "ien")) ; --UNCHK
lin swazi_N = mkWN "swazi" ; --UNCHK
lin swaziland_PN = mkPN "Swazimaa" ;
lin swear_V = mkWV (k53A "luottaa") ; --UNCHK
lin swear_V2 = mkWV2 (k53A "luottaa") ; --UNCHK
lin swear_VV = mkVV "vannoa" infPresPartAgr ;
lin swear_off_V = mkWV (k73A "luvata") "jättää" ; --UNCHK
lin swearer_N = mkWN (compoundN "van" (k10 "noja")) "valan" ; --UNCHK
lin swearing_N = mkWN (k9 "vala") ; --UNCHK
lin swearword_N = mkWN (k2 "sadattelu") ; --UNCHK
lin sweat_N = mkN "hiki" "hikiä" ;
lin sweat_V = mkWV (k67 "hikoilla") ; --UNCHK
lin sweat_V2 = mkWV2 (k67 "hikoilla") ; --UNCHK
lin sweatband_N = mkWN (compoundN "hiki" (k9 "nauha")) ; --UNCHK
lin sweatbox_N = mkWN (compoundN "hiostus" (k4A "laatikko")) ; --UNCHK
lin sweater_N = mkN "villa" (mkN "paita") ; --mkWN (k6 "jumpperi") ;
lin sweatshirt_N = mkWN (compoundN "college" (k2 "pusero")) ; --UNCHK
lin sweatshop_N = mkWN (compoundN "hiki" (k9 "paja")) ; --UNCHK
lin sweaty_A = mkA "hiostava" ;
lin swedeFem_N = variants {} ; ---- sense to be split
lin swedeMasc_N = variants {} ; ---- sense to be split
lin sweden_PN = mkPN "Ruotsi" ;
lin swedishFem_N = mkWN (k5 "ruotsi") ; --UNCHK
lin swedishMasc_N = mkWN (k5 "ruotsi") ; --UNCHK
lin swedish_A = mkWA (k38 "ruotsalainen") ; --UNCHK
lin sweep_N = mkN "pyyhkäisy" ;
lin sweep_V = mkWV (k53A "voittaa") "ylivoimaisesti" ; --UNCHK
lin sweep_V2 = mkV2 "raivata" ;
lin sweep_through_V2 = prepV2 OP_sweep_V OP_through_Prep ; -- guess-p-verb
lin sweeper_N = mkWN "pyyhältäjä" ; --UNCHK
lin sweeping_A = mkWA (compoundA "laaja" (k38 "mittainen")) ; --UNCHK
lin sweeping_N = mkWN (k2 "lakaisu") ; --UNCHK
lin sweepstakes_N = mkWN (k9A "arvonta") ; --UNCHK
lin sweet_A = mkWA (k15 "makea") ; --UNCHK
lin sweet_N = mkWN (k40 "makeus") ; --UNCHK
lin sweetbread_N = mkWN (compoundN "kateen" (k10 "korva")) ; --UNCHK
lin sweetbriar_N = mkWN (compoundN "orjan" (k1 "ruusu")) ; --UNCHK
lin sweetbrier_N = mkWN (compoundN "orjan" (k1 "ruusu")) ; --UNCHK
lin sweeten_V = mkWV (k71 "tehdä") "miellyttävämmäksi" ; --UNCHK
lin sweeten_V2 = mkWV2 (k71 "tehdä") "miellyttävämmäksi" ; --UNCHK
lin sweetening_N = mkWN (k39 "makeutus") ; --UNCHK
lin sweetheart_A = mkWA (k1A "rakastettu") ; --UNCHK
lin sweetheart_N = mkWN (k38 "kaunokainen") ; --UNCHK
lin sweetie_N = mkWN (k41A "rakas") ; --UNCHK
lin sweetish_A = mkWA (k1 "makeahko") ; --UNCHK
lin sweetleaf_N = mkWN "Symplocus" "tinctoria" ; --UNCHK
lin sweetmeat_N = mkWN (k10 "hedelmä") "sokeroitu" ; --UNCHK
lin sweetness_N = mkWN (k40 "herttaisuus") ; --UNCHK
lin sweetsop_N = mkWN (k10 "annoona") ; --UNCHK
lin swell_A = mkWA (k3 "mainio") ; --UNCHK
lin swell_N = mkWN (k39 "paisutus") ; --UNCHK
lin swell_V = L.swell_V ;
lin swell_V2 = mkV2 "paisuttaa" partitive ; --mkWV2 (k52A "pöhöttyä") ;
lin swelling_N = mkWN (compoundN "pai" (k38 "suminen")) ; --UNCHK
lin swelter_V = mkWV (k52A "läkähtyä") ; --UNCHK
lin sweptwing_A = mkWA (compoundA "nuolen" (k38 "muotoinen")) ; --UNCHK
lin swerve_N = mkWN (compoundN "väistö" (k48A "liike")) ; --UNCHK
lin swerve_V = mkWV (k58A "kulkea") "poikki" ; --UNCHK
lin swerve_V2 = mkWV2 (k58A "kulkea") "poikki" ; --UNCHK
lin swift_A = mkWA (k10 "vikkelä") ; --UNCHK
lin swift_N = mkWN "Sceloporus" "occidentalis" ; --UNCHK
lin swiftness_N = mkWN (k40 "vauhdikkuus") ; --UNCHK
lin swig_N = mkWN (k10A "huikka") ; --UNCHK
lin swig_V = mkWV (k73A "hörpätä") ; --UNCHK
lin swig_V2 = mkWV2 (k73A "hörpätä") ; --UNCHK
lin swill_N = mkWN (k1 "litku") ; --UNCHK
lin swill_V = mkWV (k53A "kulauttaa") "kurkkuunsa" ; --UNCHK
lin swill_V2 = mkWV2 (k53A "kulauttaa") "kurkkuunsa" ; --UNCHK
lin swim_N = mkWN (k5A "uinti") ; --UNCHK
lin swim_V = L.swim_V ;
lin swim_V2 = mkWV2 (k52 "pysyä") "pinnalla" ; --UNCHK
lin swimmer_N = mkWN (k6 "uimari") ; --UNCHK
lin swimmeret_N = mkWN (compoundN "uima" (k9A "jalka")) ; --UNCHK
lin swimming_N = mkWN (k5A "uinti") ; --UNCHK
lin swimming_bath_N = mkWN (k41A "allas") ; --UNCHK
lin swimming_costume_N = mkWN (compoundN "uima" (k1A "puku")) ; --UNCHK
lin swimming_pool_N = mkWN (k41A "allas") ; --UNCHK
lin swimmingly_Adv = mkWAdv (k99 "hienosti") ; --UNCHK
lin swimsuit_N = mkWN (compoundN "uima" (k1A "puku")) ; --UNCHK
lin swindle_N = mkWN (k39 "huiputus") ; --UNCHK
lin swindle_V = mkWV (k53A "vedättää") ; --UNCHK
lin swindle_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin swindler_N = mkWN (k6 "petturi") ; --UNCHK
lin swindon_PN = foreignPN "Swindon" ;
lin swine_N = mkWN (k9A "sika") ; --UNCHK
lin swineherd_N = mkWN (compoundN "siko" (k32 "paimen")) ; --UNCHK
lin swing_N = mkWN (k39 "heilahdus") ; --f59
lin swing_V = mkWV (k67A "heilahdella") ; --UNCHK
lin swing_V2 = mkWV2 (k67A "heilahdella") ; --UNCHK
lin swing_around_V = mkWV (k52A "kääntyä") ; --UNCHK
lin swing_at_V2 = prepV2 OP_swing_V OP_at_Prep ; -- guess-p-verb
lin swing_by_V = advV OP_swing_V OP_by_Adv ; -- guess-p-verb
lin swing_round_V = advV OP_swing_V OP_round_Adv ; -- guess-p-verb
lin swinge_V2 = mkWV2 (k54A "kärventää") ; --UNCHK
lin swingeing_A = mkWA (k10 "valtava") ; --UNCHK
lin swinger_N = mkWN (kH1 "lunttu") ; --UNCHK
lin swinish_A = mkWA (k38 "sottainen") ; --UNCHK
lin swinton_PN = foreignPN "Swinton" ;
lin swipe_N = mkWN (k1 "huitaisu") ; --UNCHK
lin swipe_V2 = mkWV2 (k66 "huitaista") ; --UNCHK
lin swirl_N = mkWN (k12 "kiemura") ; --UNCHK
lin swirl_V = mkWV (k67A "pyörähdellä") ; --UNCHK
lin swirl_V2 = mkWV2 (k67A "pyörähdellä") ; --UNCHK
lin swish_A = mkWA (k47 "hienostunut") ; --UNCHK
lin swish_N = mkWN (k39 "suhahdus") ; --UNCHK
lin swish_V = mkWV (k66 "suhista") ; --UNCHK
lin swish_V2 = mkWV2 (k66 "suhista") ; --UNCHK
lin swishy_A = mkWA "suhiseva" ; --UNCHK
lin swiss_A = mkA "sveitsiläinen" ; --f59
lin swiss_N = mkN "sveitsiläinen" ;
lin switch8off_V2 = L.switch8off_V2 ;
lin switch8on_V2 = L.switch8on_V2 ;
lin switch_N = mkN "vaihdos" ; --WN (k39 "muutos") ;
lin switch_V = mkV "vaihtaa" ;
lin switch_V2 = mkWV2 (k54A "kääntää") "kelkkansa" ; --UNCHK
lin switch_off_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin switch_on_V2 = mkWV2 (k53 "käynnistää") ; --UNCHK
lin switchblade_N = mkWN (k5A "stiletti") ; --UNCHK
lin switchboard_N = mkWN (compoundN "puhelin" (k39 "keskus")) ; --UNCHK
lin switcher_N = mkWN (k6 "piiskuri") ; --UNCHK
lin switcheroo_N = mkWN (k39 "väännös") ; --UNCHK
lin switchman_N = mkWN (compoundN "vaihde" (k42 "mies")) ; --UNCHK
lin switzerland_PN = foreignPN "Sveitsi" ;
lin swivel_N = mkWN (k39 "liitos") "pyörivä" ; --UNCHK
lin swivel_V = mkWV (k52A "kääntyä") ; --UNCHK
lin swivel_V2 = mkWV2 (k52A "kääntyä") ; --UNCHK
lin swivet_N = mkWN (k5A "paniikki") ; --UNCHK
lin swiz_N = mkWN (k39 "huijaus") ; --UNCHK
lin swizzle_N = mkWN "swizzle" ; --UNCHK
lin swizzle_stick_N = mkWN (compoundN "cocktail" (k1A "tikku")) ; --UNCHK
lin swob_N = mkWN (k5A "moppi") ; --UNCHK
lin swob_V2 = mkWV2 (k66 "sipaista") ; --UNCHK
lin swoon_N = mkWN (k39 "menetys") "tajunnan" ; --UNCHK
lin swoon_V = mkWV (k53A "menettää") "tajuntansa" ; --UNCHK
lin swoop_N = mkWN (k1 "syöksy") ; --UNCHK
lin swoop_V = mkWV (k73A "siepata") ; --UNCHK
lin swoop_V2 = mkWV2 (k73A "siepata") ; --UNCHK
lin swoosh_N = mkWN (k39 "suhahdus") ; --UNCHK
lin swop_N = mkWN (k1A "vaihto") ; --UNCHK
lin swop_V = mkWV (k56A "vaihtaa") ; --UNCHK
lin swop_V2 = mkWV2 (k56A "vaihtaa") ; --UNCHK
lin sword_N = mkWN (k9A "kalpa") ; --UNCHK
lin sword_cane_N = mkWN (compoundN "miekka" (k5A "keppi")) ; --UNCHK
lin sword_dance_N = mkWN (compoundN "miekka" (k5 "tanssi")) ; --UNCHK
lin swordfish_N = mkWN (compoundN "miekka" (k9 "kala")) ; --UNCHK
lin swordplay_N = mkWN (k2 "miekkailu") ; --UNCHK
lin swordsman_N = mkWN (k12 "miekkailija") ; --UNCHK
lin swordsmanship_N = mkWN (compoundN "miekkailu" (k1A "taito")) ; --UNCHK
lin swordtail_N = mkWN (compoundN "miekka" (k1 "pyrstö")) ; --UNCHK
lin swot_N = mkWN (k1 "nössö") ; --UNCHK
lin swot_V = mkWV (k56A "ahtaa") "päähänsä" ; --UNCHK
lin swot_V2 = mkWV2 (k56A "ahtaa") "päähänsä" ; --UNCHK
lin sybarite_N = mkWN (k12 "nautiskelija") ; --UNCHK
lin sybaritic_A = mkWA (k38 "aistillinen") ; --UNCHK
lin sycamore_N = mkWN (compoundN "viikuna" (k18 "puu")) "egyptiläinen" ; --UNCHK
lin syconium_N = mkWN (k12 "viikuna") ; --UNCHK
lin sycophancy_N = mkWN (k2 "imartelu") ; --UNCHK
lin sycophant_N = mkWN (k12 "mielistelijä") ; --UNCHK
lin sycophantic_A = mkWA (compoundA "mieliste" (k10 "levä")) ; --UNCHK
lin sydney_PN = foreignPN "Sydney" ;
lin syllabary_N = mkWN (compoundN "tavu" (k39 "kirjoitus")) ; --UNCHK
lin syllabic_A = mkWA (k10 "kannattava") "tavua" ; --UNCHK
lin syllabicate_V2 = mkWV2 (k53A "tavuttaa") ; --UNCHK
lin syllabication_N = mkWN (k39 "tavutus") ; --UNCHK
lin syllabicity_N = mkWN (compoundN "tavun" (k39 "muodostus")) ; --UNCHK
lin syllabification_N = mkWN (k39 "tavutus") ; --UNCHK
lin syllabify_V2 = mkWV2 (k53A "tavuttaa") ; --UNCHK
lin syllabize_V2 = mkWV2 (k53A "tavuttaa") ; --UNCHK
lin syllable_N = mkWN (k1 "tavu") ; --UNCHK
lin syllabled_A = mkWA (compoundA "lau" (k1A "suttu")) "tavuittain" ; --UNCHK
lin syllabub_N = mkWN "sillabub" ; --UNCHK
lin syllabus_N = mkWN (compoundN "opetus" (k10 "suunnitelma")) ; --UNCHK
lin syllepsis_N = mkWN "syllepsis" ; --UNCHK
lin syllogism_N = mkWN (k5 "syllogismi") ; --UNCHK
lin syllogist_N = mkWN "syllogisti" ; --UNCHK
lin syllogistic_A = mkWA (k38 "syllogistinen") ; --UNCHK
lin sylph_N = mkWN (k38 "keijukainen") ; --UNCHK
lin sylvan_A = mkWA "metsän-" ; --UNCHK
lin sylvan_N = mkWN (k38 "metsäläinen") ; --UNCHK
lin sylvanite_N = mkWN (compoundN "sylv" (k5A "aniitti")) ; --UNCHK
lin sylvite_N = mkWN (k5 "sylviini") ; --UNCHK
lin symbiosis_N = mkWN (k5 "symbioosi") ; --UNCHK
lin symbiotic_A = mkWA (k38 "symbioottinen") ; --UNCHK
lin symbol_N = mkN "symboli" ;
lin symbolatry_N = mkWN (compoundN "symbolin" (k9A "palvonta")) ; --UNCHK
lin symbolic_A = mkWA (k38 "symbolinen") ; --UNCHK
lin symbolical_A = mkWA (k38 "symbolinen") ; --UNCHK
lin symbolism_N = mkWN (k5 "symbolismi") ; --UNCHK
lin symbolist_N = mkWN "symbolisti" ; --UNCHK
lin symbolization_N = mkWN (k5 "symbolismi") ; --UNCHK
lin symbolize_V2 = mkWV2 (k67 "olla") "vertauskuva" ; --UNCHK
lin symbolizing_N = mkWN (compoundN "symboli" (k5A "sointi")) ; --UNCHK
lin symbology_N = mkWN "symbologia" ; --UNCHK
lin symmetric_A = mkWA (k38 "symmetrinen") ; --UNCHK
lin symmetrical_A = mkWA (k38 "symmetrinen") ; --UNCHK
lin symmetry_N = mkWN (k12 "symmetria") ; --UNCHK
lin sympathetic_A = mkWA (k38 "sympaattinen") ; --UNCHK
lin sympathize_V = mkWV (k54A "ymmärtää") ; --UNCHK
lin sympathizer_N = mkWN (k10 "ystävä") ; --UNCHK
lin sympathy_N = mkN "sympatia" ; --mkWN (k39 "ymmärtämys") ;
lin sympatric_A = mkWA "sympatrinen" ; --UNCHK
lin sympatry_N = mkWN "sympatria" ; --UNCHK
lin symphonic_A = mkWA (k38 "sinfoninen") ; --UNCHK
lin symphonist_N = mkWN (k4A "sinfonikko") ; --UNCHK
lin symphony_N = mkWN (k5A "musiikki") "sinfoninen" ; --UNCHK
lin symphysion_N = mkWN (compoundN "häpy" (k39 "liitos")) ; --UNCHK
lin symphysis_N = mkWN (k39 "liitos") ; --UNCHK
lin symploce_N = mkWN "symplokee" ; --UNCHK
lin symposium_N = mkWN (k5 "symposiumi") ; --UNCHK
lin symptom_N = mkWN (k5 "symptomi") ; --UNCHK
lin symptomatic_A = mkWA (compoundA "oireen" (k38 "mukainen")) ; --UNCHK
lin symptomless_A = mkWA (k34A "oireeton") ; --UNCHK
lin synagogue_N = mkWN (k6 "temppeli") ; --UNCHK
lin synapse_N = mkWN (k5 "synapsi") ; --UNCHK
lin synapsid_N = mkWN (compoundN "synapsidi" (k12 "matelija")) ; --UNCHK
lin synapsis_N = mkWN (k5 "synapsi") ; --UNCHK
lin synaptic_A = mkWA "synaptinen" ; --UNCHK
lin syncarpous_A = mkWA "synkarppinen" ; --UNCHK
lin syncategorem_N = mkWN "synkategoreema" ; --UNCHK
lin syncategorematic_A = mkWA "synkategoremaattinen" ; --UNCHK
lin synchrocyclotron_N = mkWN "synkrosyklotroni" ; --UNCHK
lin synchroflash_N = mkWN (compoundN "synkroni" (k12 "salama")) ; --UNCHK
lin synchromesh_N = mkWN (compoundN "synkroni" (k1 "vaihteisto")) ; --UNCHK
lin synchronic_A = mkWA (k38 "synkroninen") ; --UNCHK
lin synchronism_N = mkWN (k5A "synkronisointi") ; --UNCHK
lin synchronization_N = mkWN (k39 "tahdistus") ; --UNCHK
lin synchronize_V = mkWV (k73A "synkata") ; --UNCHK
lin synchronize_V2 = mkWV2 (k73A "synkata") ; --UNCHK
lin synchronous_A = mkWA (k38 "synkroninen") ; --UNCHK
lin synchrony_N = mkWN (k5A "synkronisointi") ; --UNCHK
lin synchroscope_N = mkWN (k33 "tahdistin") ; --UNCHK
lin synchrotron_N = mkWN "synkrotroni" ; --UNCHK
lin synclinal_A = mkWA (compoundA "syn" (k38 "kliininen")) ; --UNCHK
lin syncopate_V2 = mkWV2 (k62 "synkopoida") ; --UNCHK
lin syncopation_N = mkWN (k5A "synkooppi") ; --UNCHK
lin syncopator_N = mkWN "synkopoija" ; --UNCHK
lin syncope_N = mkWN (compoundN "sisä" (k1A "heitto")) ; --UNCHK
lin syncretic_A = mkWA (k38 "synkretistinen") ; --UNCHK
lin syncretism_N = mkWN (compoundN "yhteen" (k38 "sulautuminen")) ; --UNCHK
lin syncytium_N = mkWN (k39 "solusitkos") ; --UNCHK
lin syndactyly_N = mkWN "yhdysvarpaisuus" ; --UNCHK
lin syndciate_V2 = mkV2 "myydä" ;
lin syndetic_A = mkWA (compoundA "synd" (k38 "eettinen")) ; --UNCHK
lin syndic_N = mkWN "syndikus" ; --UNCHK
lin syndicalism_N = mkWN (k5 "syndikalismi") ; --UNCHK
lin syndicalistFem_N = mkWN (k5 "syndikalisti") ; --UNCHK
lin syndicalistMasc_N = mkWN (k5 "syndikalisti") ; --UNCHK
lin syndicate_N = mkN "syndikaatti" ;
lin syndicate_V2 = mkV2 "myydä" partitive ; --mkWV2 (k53 "muodostaa") "syndikaatti" ;
lin syndication_N = mkN "myyminen" ;
lin syndrome_N = mkWN (k10 "syndrooma") ; --UNCHK
lin synecdoche_N = mkWN "synekdokee" ; --UNCHK
lin synecdochic_A = mkWA (compoundA "synekdok" (k38 "eettinen")) ; --UNCHK
lin synechia_N = mkWN "synekia" ; --UNCHK
lin syneresis_N = mkWN "synereesi" ; --UNCHK
lin synergetic_A = mkWA (k38 "synergeettinen") ; --UNCHK
lin synergism_N = mkWN (k5 "synergismi") ; --UNCHK
lin synergist_N = mkWN (k5 "synergisti") ; --UNCHK
lin synergistic_A = mkWA (k38 "synergistinen") ; --UNCHK
lin synergy_N = mkWN (k12 "synergia") ; --UNCHK
lin synesthesia_N = mkWN "aistien" "sekoittuminen" ; --UNCHK
lin synesthetic_A = mkWA (compoundA "syn" (k38 "esteettinen")) ; --UNCHK
lin synizesis_N = mkWN "synizesis" ; --UNCHK
lin synod_N = mkWN (k5 "synodi") ; --UNCHK
lin synoicous_A = mkWA (compoundA "kaksineu" (k38 "voinen")) ; --UNCHK
lin synonym_N = mkWN (k9 "sana") "vastaava" ; --UNCHK
lin synonymist_N = mkWN "synonymisti" ; --UNCHK
lin synonymous_A = mkWA (k38 "synonyyminen") ; --UNCHK
lin synonymy_N = mkWN (k12 "synonymia") ; --UNCHK
lin synopsis_N = mkWN (k10 "lyhennelmä") ; --UNCHK
lin synoptic_A = mkWA (compoundA "syn" (k38 "optinen")) ; --UNCHK
lin synovia_N = mkWN (compoundN "nivel" (k48A "voide")) ; --UNCHK
lin synovial_A = mkWA "nivelvoide-" ; --UNCHK
lin synovitis_N = mkWN (compoundN "nivel" (k39 "tulehdus")) ; --UNCHK
lin synsemantic_A = mkWA (compoundA "myötä" (k10 "merkitsevä")) ; --UNCHK
lin syntactic_A = mkWA (k38 "syntaktinen") ; --UNCHK
lin syntagma_N = mkWN (compoundN "sana" (k1A "liitto")) ; --UNCHK
lin syntagmatic_A = mkWA "syntagmaattinen" ; --UNCHK
lin syntax_N = mkWN (k5 "syntaksi") ; --UNCHK
lin synthesis_N = mkWN (k5 "synteesi") ; --UNCHK
lin synthesist_N = mkWN "synteetikko" ; --UNCHK
lin synthesize_V2 = mkWV2 (k62 "syntetisoida") ; --UNCHK
lin synthesizer_N = mkWN (k6 "syntetisaattori") ; --UNCHK
lin synthetic_A = mkWA (k38 "synteettinen") ;
lin synthetic_N = mkWN (k48 "yhdiste") "synteettinen" ; --UNCHK
lin syphilis_N = mkN "kuppa" | mkN "syfilis" ;
lin syphilitic_A = mkWA (k38 "kuppainen") ; --UNCHK
lin syphilitic_N = mkWN (compoundN "kuppatauti" (k41 "potilas")) ; --UNCHK
lin syphon_N = mkWN (compoundN "ilma" (k7 "putki")) ; --UNCHK
lin syphon_V = mkWV (k54A "tyhjentää") "lapolla" ; --UNCHK
lin syphon_V2 = mkWV2 (k54A "tyhjentää") "lapolla" ; --UNCHK
lin syracuse_PN = foreignPN "Syracuse" ;
lin syria_PN = foreignPN "Syyria" ;
lin syrian_A = mkWA (compoundA "syyri" (k38 "alainen")) ;
lin syrian_N = mkWN (compoundN "syyri" (k38 "alainen")) ; --UNCHK
lin syringa_N = mkWN (k6 "syreeni") ; --UNCHK
lin syringe_N = mkWN (k1 "ruisku") ; --UNCHK
lin syringe_V2 = mkWV2 (k53A "ruiskuttaa") ; --UNCHK
lin syrinx_N = mkWN "syrinx" ; --UNCHK
lin syrup_N = mkWN (k5A "siirappi") ; --UNCHK
lin syrupy_A = mkWA (k38 "hunajainen") ; --UNCHK
lin sysmä_PN = mkPN "Sysmä" ;
lin system_N = mkN "järjestelmä" | mkN "systeemi" ;
lin systematic_A = mkWA (k38 "systemaattinen") ; --UNCHK
lin systematics_N = mkWN (k9A "systematiikka") ; --UNCHK
lin systematism_N = mkWN (k40 "systemaattisuus") ; --UNCHK
lin systematization_N = mkWN (k5A "rationalisointi") ; --UNCHK
lin systematize_V2 = mkWV2 (k53 "järjestelmällistää") ; --UNCHK
lin systemic_A = mkWA (k38 "systeeminen") ; --UNCHK
lin systole_N = mkWN "systole" ; --UNCHK
lin syston_PN = foreignPN "Syston" ;
lin säkylä_PN = mkPN "Säkylä" ;
lin särkisalo_PN = mkPN "Särkisalo" ;
lin säynätsalo_PN = mkPN "Säynätsalo" ;
lin t_shirt_N = variants {} ; --
lin taavetti_PN = mkPN "Taavetti" ;
lin tab_N = mkN "kaistale" ; ---ARB ; välilehti ; tabloidi ; piikki ; tabletti
lin tabard_N = mkWN (kH1 "viitta") ; --UNCHK
lin tabasco_N = mkWN (compoundN "chili" (k6 "pippuri")) ; --UNCHK
lin tabbouleh_N = mkWN "tabooli" ; --UNCHK
lin tabby_A = mkWA (k41A "juovikas") ; --UNCHK
lin tabby_N = mkWN (k32A "kuningatar") ; --UNCHK
lin tabby_cat_N = mkWN (k9 "kissa") "juovikas" ; --UNCHK
lin tabernacle_N = mkWN (k6 "temppeli") ; --UNCHK
lin tabes_N = mkWN "tabes" ; --UNCHK
lin tabi_N = mkWN (compoundN "varvas" (k10A "sukka")) ; --UNCHK
lin tablature_N = mkWN (compoundN "tabula" (k5 "tuuri")) ; --UNCHK
lin table_1_N = L.table_N ;
lin table_2_N = L.table_N ;
lin table_V2 = mkWV2 (k62 "taulukoida") ; --UNCHK
lin table_d'hote_A = mkWA (k12 "ateria") "päivän" ; --UNCHK
lin table_knife_N = mkWN (compoundN "pöytä" (k30 "veitsi")) ; --UNCHK
lin table_lifting_N = mkWN (k2 "kallistelu") "pöydän" ; --UNCHK
lin table_rapping_N = mkWN (compoundN "kutsu" (k38 "minen")) "henkien" ; --UNCHK
lin table_talk_N = mkWN (compoundN "pöytä" (k2 "keskustelu")) ; --UNCHK
lin table_turning_N = mkWN (k2 "kallistelu") "pöydän" ; --UNCHK
lin tableau_N = mkWN (k10 "kuvaelma") ; --UNCHK
lin tableau_vivant_N = mkWN (k10 "kuvaelma") ; --UNCHK
lin tablecloth_N = mkWN (compoundN "pöytä" (k9 "liina")) ; --UNCHK
lin tablefork_N = mkWN (k14A "haarukka") ; --UNCHK
lin tableland_N = mkWN (k1A "ylänkö") ; --UNCHK
lin tablemate_N = mkWN (k38 "seuralainen") ; --UNCHK
lin tablespoon_N = mkWN (compoundN "ruoka" (k14A "lusikka")) ; --UNCHK
lin tablespoonful_N = mkWN (compoundN "ruoka" (k38 "lusikallinen")) ; --UNCHK
lin tablet_N = mkWN (kH1 "tabu") ; --UNCHK
lin tabletop_N = mkWN (compoundN "pöydän" (k9A "pinta")) ; --UNCHK
lin tableware_N = mkWN (k1 "astiasto") ; --UNCHK
lin tabloid_N = mkWN (k5 "tabloidi") ;
lin taboo_A = mkWA (kH1 "tabu") ; --UNCHK
lin taboo_N = mkWN (kH1 "tabu") ; --UNCHK
lin taboo_V2 = mkWV2 (k54A "kieltää") ; --UNCHK
lin tabor_N = mkWN "tabour" ; --UNCHK
lin taboret_N = mkWN (k12 "jakkara") ; --UNCHK
lin tabular_A = mkWA "tasapintainen" ; --UNCHK
lin tabulation_N = mkWN (k5A "taulukointi") ; --UNCHK
lin tabulator_N = mkWN (k6 "laskuri") ; --UNCHK
lin tabun_N = mkWN "GA" ; --UNCHK
lin tachistoscope_N = mkWN (compoundN "takistosko" (k5A "oppi")) ; --UNCHK
lin tachogram_N = mkWN "takogrammi" ; --UNCHK
lin tachograph_N = mkWN (compoundN "ajo" (k6 "piirturi")) ; --UNCHK
lin tachometer_N = mkWN (compoundN "kierrosluku" (k6 "mittari")) ; --UNCHK
lin tachycardia_N = mkWN (compoundN "takykar" (k9 "dia")) ; --UNCHK
lin tachylite_N = mkWN (k5 "lasi") "vulkaaninen" ; --UNCHK
lin tachymeter_N = mkWN (compoundN "taky" (k5 "metri")) ; --UNCHK
lin tacit_A = mkWA (k34A "äänetön") ;
lin taciturn_A = mkWA (k41 "vaitelias") ; --UNCHK
lin taciturnity_N = mkWN (k40 "vaiteliaisuus") ; --UNCHK
lin tack_N = mkWN "luovinta" ; --UNCHK
lin tack_V = mkV "kiinnittyä" ; ---ARB --mkWV (k54A "kääntää") "kelkkansa" ;
lin tack_V2 = mkWV2 (k54A "kääntää") "kelkkansa" ; --UNCHK
lin tack_on_V2 = mkWV2 (k53A "kiinnittää") ; --UNCHK
lin tacker_N = mkWN (compoundN "niitti" (k6 "pistooli")) ; --UNCHK
lin tackle_N = mkWN (k39 "taklaus") ; --UNCHK
lin tackle_V = mkWV (k73 "taklata") ; --UNCHK
lin tackle_V2 = mkWV2 (k73 "taklata") ; --UNCHK
lin tackler_N = mkWN (k10 "taklaaja") ; --UNCHK
lin tacky_A = mkWA (k15 "pramea") ; --UNCHK
lin taco_N = mkWN (k1 "taco") ; --UNCHK
lin taconite_N = mkWN (compoundN "tako" (k5A "niitti")) ; --UNCHK
lin tact_N = mkWN (k40 "tahdikkuus") ; --UNCHK
lin tactful_A = mkWA (k41A "tahdikas") ; --UNCHK
lin tactic_N = mkWN (k5 "manööveri") ; --UNCHK
lin tactical_A = mkWA (k38 "taktinen") ;
lin tactician_N = mkWN (k4A "taktikko") ; --UNCHK
lin tactics_N = mkWN (k5 "manööveri") ; --UNCHK
lin tactile_A = mkWA "tunto-" ; --UNCHK
lin tactless_A = mkWA (k2 "kömpelö") ; --UNCHK
lin tactlessness_N = mkWN (k40 "tahdittomuus") ; --UNCHK
lin tactual_A = mkWA "tunto-" ; --UNCHK
lin tad_N = mkWN (k99 "hieman") ; --UNCHK
lin tadalafil_N = mkWN "Cialis" ; --UNCHK
lin tadley_PN = foreignPN "Tadley" ;
lin tadpole_N = mkWN (compoundN "nuija" (k18 "pää")) ; --UNCHK
lin tael_N = mkWN "tael" ; --UNCHK
lin taenia_N = mkWN (compoundN "heisi" (k1A "mato")) ; --UNCHK
lin taffeta_N = mkWN (k5 "tafti") ; --UNCHK
lin taffrail_N = mkWN (compoundN "perä" (k41A "parras")) ; --UNCHK
lin taffy_N = mkWN (k20 "toffee") ; --UNCHK
lin tag_N = mkWN "polttaminen" ; --UNCHK
lin tag_V = mkWV (k53A "nimittää") ; --UNCHK
lin tag_V2 = mkWV2 (k53A "nimittää") ; --UNCHK
lin tag_VS = mkWVS (k53A "nimittää") ; --UNCHK
lin tag_along_V = mkWV (k73 "seurata") ; --UNCHK
lin tag_on_V2 = mkWV2 (k53A "kiinnittää") ; --UNCHK
lin tagalong_N = mkWN (compoundN "roik" (k10 "kuja")) ; --UNCHK
lin tagasaste_N = mkWN (compoundN "tagas" (k48 "aste")) ; --UNCHK
lin tagliatelle_N = mkWN (k8 "tagliatelle") ; --UNCHK
lin taguan_N = mkWN (compoundN "liito-" (k10 "orava")) ; --UNCHK
lin tahini_N = mkWN "tahini" ; --UNCHK
lin tahitian_A = mkWA (compoundA "tahiti" (k38 "lainen")) ; --UNCHK
lin tahitian_N = mkWN "tahiti" ; --UNCHK
lin tail_N = L.tail_N ;
lin tail_V = mkWV (k53 "poistaa") "kanta" ; --UNCHK
lin tail_V2 = mkWV2 (k53 "poistaa") "kanta" ; --UNCHK
lin tail_coat_N = mkWN (k5A "frakki") ; --UNCHK
lin tail_end_N = mkWN (k1 "takalisto") ; --UNCHK
lin tailback_N = mkWN "tailback" ; --UNCHK
lin tailboard_N = mkWN (compoundN "perä" (k9A "lauta")) ; --UNCHK
lin tailgate_N = mkWN (compoundN "perä" (k9A "lauta")) ; --UNCHK
lin tailgater_N = mkWN (compoundN "pee" (k10 "saaja")) ; --UNCHK
lin tailless_A = mkWA "pyrstötön" ; --UNCHK
lin tail_light_N = mkWN (compoundN "taka" (k1 "valo")) ; --UNCHK
lin tailor_N = mkWN (k12 "ompelija") ; --UNCHK
lin tailor_V2 = mkV2 "räätälöidä" ; --mkWV2 (k73A "suunnata") ;
lin tailor_made_A = mkA "räätälöity" ;
lin tailorbird_N = mkWN (compoundN "räätäli" (k1A "lintu")) ; --UNCHK
lin tailoring_N = mkWN (k5A "ammatti") "räätälin" ; --UNCHK
lin tailpiece_N = mkWN (compoundN "taka" (k48A "lisäke")) ; --UNCHK
lin tailpipe_N = mkWN (compoundN "pako" (k7 "putki")) ; --UNCHK
lin tailplane_N = mkWN (compoundN "korkeus" (k33 "vakain")) ; --UNCHK
lin tailrace_N = mkWN (compoundN "myllyn" (k5 "ränni")) ; --UNCHK
lin tailspin_N = mkWN (k48A "kierre") ;
lin tailstock_N = mkWN (compoundN "terä" (k9A "kelkka")) ; --UNCHK
lin tailwind_N = mkWN (compoundN "myötä" (k26 "tuuli")) ; --UNCHK
lin taint_N = mkWN "kontaminaatio" ; --UNCHK
lin taint_V = mkWV (k53A "saastuttaa") ; --UNCHK
lin taint_V2 = mkWV2 (k53A "saastuttaa") ; --UNCHK
lin taipalsaari_PN = mkPN (mkN "Taipalsaari" "Taipalsaaria") ;
lin taipei_PN = foreignPN "Taipei" ;
lin taivalkoski_PN = mkPN (mkN "Taivalkoski" "Taivalkoskia") ;
lin taivassalo_PN = mkPN "Taivassalo" ;
lin taiwan_PN = foreignPN "Taiwan" ;
lin taiwaneseFem_N = mkWN (k48A "murre") "Taiwanin" ; --UNCHK
lin taiwaneseMasc_N = mkWN (k48A "murre") "Taiwanin" ; --UNCHK
lin taiwanese_A = mkWA (k38 "kiinalainen") ; --UNCHK
lin taiyuan_PN = foreignPN "Taiyuan" ;
lin taka_N = mkWN (k9A "taka") ; --UNCHK
lin take_N = mkWN (k1A "otto") ; --UNCHK
lin take_V2 = mkV2 "ottaa" ;
lin take_after_V2 = prepV2 (lin V OP_take_V2) OP_after_Prep ; -- guess-p-verb
lin take_apart_V2 = mkWV2 (k52 "ratkoa") ; --UNCHK
lin take_aside_V2 = mkV2 (advV (lin V OP_take_V2) OP_aside_Adv ) ; -- guess-p-verb
lin take_away_V2 = mkV2 (advV (lin V OP_take_V2) OP_away_Adv ) ; -- guess-p-verb
lin take_back_V = advV (lin V OP_take_V2) OP_back_Adv ; -- guess-p-verb
lin take_back_V2 = mkV2 (advV (lin V OP_take_V2) OP_back_Adv ) ; -- guess-p-verb
lin take_down_V2 = mkWV2 (k69 "merkitä") "muistiin" ; --UNCHK
lin take_for_V2 = mkWV2 (k53A "olettaa") ; --UNCHK
lin take_in_V = mkWV (k54A "pienentää") ; --UNCHK
lin take_in_V2 = mkWV2 (k54A "pienentää") ; --UNCHK
lin take_it_V2 = variants {} ; -- guess-p-verb
lin take_it_out_on_V2 = variants {} ; -- guess-p-verb
lin take_it_upon_yourself_V = variants {} ; -- guess-p-verb
lin take_off_N = mkN "nousu" | mkWN (k1A "lähtö") ; --UNCHK
lin take_off_V = mkWV (k52 "riisua") ; --UNCHK
lin take_off_V2 = mkWV2 (k52 "riisua") ; --UNCHK
lin take_on_V = mkWV (k52 "omaksua") ; --UNCHK
lin take_on_V2 = mkWV2 (k52 "omaksua") ; --UNCHK
lin take_out_V = mkWV (k53A "vetää") "ulos" ; --UNCHK
lin take_out_V2 = mkWV2 (k53A "vetää") "ulos" ;
lin take_over_V = mkWV (k53A "ottaa") "hoitaakseen" ; --UNCHK
lin take_over_V2 = mkWV2 (k53A "ottaa") "hoitaakseen" ; --UNCHK
lin take_through_V2 = prepV2 (lin V OP_take_V2) OP_through_Prep ; -- guess-p-verb
lin take_to_V2 = mkWV2 (k71 "tehdä") "mieli" ; --UNCHK
lin take_up_V = mkWV (k53A "ottaa") "käsittelyyn" ; --UNCHK
lin take_up_V2 = mkWV2 (k53A "ottaa") "käsittelyyn" ; --UNCHK
lin takeaway_N = mkWN (compoundN "pallon" (k1 "ryöstö")) ; --UNCHK
lin takedown_N = mkWN (k39 "vaiennus") ; --UNCHK
lin takeout_A = mkWA "nouto-" ; --UNCHK
lin takeout_N = mkWN (compoundN "ilmaisu" (k39 "kahdennus")) ; --UNCHK
lin takeover_N = mkWN (k39 "valtaus") ; --f363
lin taker_N = mkWN (k10 "ottaja") ; --UNCHK
lin takin_N = mkWN "Budorcas" "taxicolor" ; --UNCHK
lin taking_N = mkN "otos" ;
lin tala_N = mkWN "tala" ; --UNCHK
lin talapoin_N = mkWN (compoundN "gabonin" (k5A "marakatti")) ; --UNCHK
lin talc_N = mkWN (k5A "talkki") ; --UNCHK
lin talcum_N = mkWN (k5A "talkki") ; --UNCHK
lin tale_N = mkWN (k1A "pöty") ; --UNCHK
lin talent_N = mkWN (k40 "lahjakkuus") ; --UNCHK
lin talented_A = mkWA (k10 "etevä") ; --UNCHK
lin talentlessness_N = mkWN (k40 "lahjattomuus") ; --UNCHK
lin talipot_N = mkWN (compoundN "viuhka" (k1 "palmu")) ; --UNCHK
lin talisman_N = mkWN (k5 "talismaani") ; --UNCHK
lin talismanic_A = mkWA (k10 "tuottava") "onnea" ; --UNCHK
lin talk_N = mkN "puhe" ;
lin talk_V = mkV "puhua" ;
lin talk_V2 = mkV2 "puhua" partitive ;
lin talk_V3 = L.talk_V3 ;
lin talk_VA = mkWVA (k68 "luennoida") ; --UNCHK
lin talk_around_V2 = prepV2 OP_talk_V OP_around_Prep ; -- guess-p-verb
lin talk_at_V2 = prepV2 OP_talk_V OP_at_Prep ; -- guess-p-verb
lin talk_back_V = advV OP_talk_V OP_back_Adv ; -- guess-p-verb
lin talk_back_to_V2 = prepV2 (advV OP_talk_V OP_back_Adv ) OP_to_Prep ; -- guess-p-verb
lin talk_down_V2 = mkWV2 (k56A "antaa") "laskeutumisohjeet" ; --UNCHK
lin talk_down_to_V2 = prepV2 (advV OP_talk_V OP_down_Adv ) OP_to_Prep ; -- guess-p-verb
lin talk_into_V3 = mkWV3 (k52 "puhua") "ympäri" ; --UNCHK
lin talk_out_V2 = prepV2 OP_talk_V OP_out_Prep ; -- guess-p-verb
lin talk_out_of_V3 = mkWV3 (k53A "taivuttaa") "luopumaan" ; --UNCHK
lin talk_over_V2 = mkWV2 (k61A "pohtia") ; --UNCHK
lin talk_round_V2 = prepV2 OP_talk_V OP_round_Prep ; -- guess-p-verb
lin talk_through_V3 = variants {} ; -- guess-p-verb
lin talk_up_V2 = prepV2 OP_talk_V OP_up_Prep ; -- guess-p-verb
lin talk_yourself_out_V = variants {} ; -- guess-p-verb
lin talkative_A = mkWA (k41 "puhelias") ; --UNCHK
lin talker_N = mkWN (k10 "lausuja") ; --UNCHK
lin talkie_N = mkWN "äänielokuva" ; --UNCHK
lin talking_N = mkN "puhuminen" ;
lin talking_point_N = mkWN (k10A "näkökohta") "huomionarvoinen" ; --UNCHK
lin talking_to_N = mkWN (k2 "nuhtelu") ; --UNCHK
lin tall_A = mkWA (k41A "kookas") ; --UNCHK
lin tall_N = mkWN "tall" ; --UNCHK
lin tallboy_N = mkWN (k5A "piironki") "korkea" ; --UNCHK
lin tallgrass_N = mkWN "tall-grass" ; --UNCHK
lin tallish_A = mkWA "pitkähkö" ; --UNCHK
lin tallness_N = mkWN (k40 "pituus") ; --UNCHK
lin tallow_N = mkWN (k5 "tali") ; --UNCHK
lin tally_N = mkN "tili" ; --WN (k48 "piste") ;
lin tally_V = mkWV (k73 "ynnätä") ; --UNCHK
lin tally_V2 = mkWV2 (k73 "ynnätä") ; --UNCHK
lin tally_clerk_N = mkWN (k12 "merkitsijä") ; --UNCHK
lin tallyman_N = mkWN (k12 "merkitsijä") ; --UNCHK
lin talmud_N = mkWN "Talmud" ; --UNCHK
lin talon_N = mkWN (k28 "kynsi") ; --UNCHK
lin talus_N = mkWN (compoundN "tela" (k18 "luu")) ; --UNCHK
lin tam_N = mkWN "tammy" ; --UNCHK
lin tamable_A = mkWA "kesyyntyvä" ; --UNCHK
lin tamale_N = mkWN (k8 "tamale") ; --UNCHK
lin tamandua_N = mkWN (compoundN "muurahais" (k1 "karhu")) ; --UNCHK
lin tamarau_N = mkWN "Anoa" "mindorensis" ; --UNCHK
lin tamarin_N = mkWN (compoundN "silkki" (k12 "apina")) ; --UNCHK
lin tamarind_N = mkWN (compoundN "tamarindi" (k1A "palko")) ; --UNCHK
lin tamarisk_N = mkWN (k5 "tamariski") ; --UNCHK
lin tambala_N = mkWN (compoundN "tamb" (k9 "ala")) ; --UNCHK
lin tambour_1_N = mkWN (k1A "rumpu") ; --UNCHK
lin tambour_2_N = mkWN (k1A "rumpu") ; --UNCHK
lin tambourine_N = mkWN (k5 "tamburiini") ; --UNCHK
lin tame_A = mkWA (k1 "kesy") ;
lin tame_V2 = mkWV2 (k53 "alistaa") ; --UNCHK
lin tameness_N = mkWN (k40 "kesyys") ; --UNCHK
lin tamer_N = mkWN (k10 "kesyttäjä") ; --UNCHK
lin tamil_A = mkWA (compoundA "tamil" (k32A "ien")) ; --UNCHK
lin tamil_N = mkWN "tamil" ; --UNCHK
lin tammany_N = mkWN "Tammany" ; --UNCHK
lin tammela_PN = mkPN "Tammela" ;
lin tammy_N = mkWN "tammy" ; --UNCHK
lin tamp_N = mkWN (kH1 "juntta") ; --UNCHK
lin tamp_V2 = mkWV2 (k56A "ahtaa") ; --UNCHK
lin tamper_V = mkWV (k71 "tehdä") "vilunkia" ; --UNCHK
lin tampere_PN = mkPN "Tampere" ;
lin tampion_N = mkWN (compoundN "tykin" (k10A "tulppa")) ; --UNCHK
lin tampon_N = mkWN (k1A "tuppo") ; --UNCHK
lin tamponade_N = mkWN (compoundN "tukki" (k38 "minen")) ; --UNCHK
lin tamworth_PN = foreignPN "Tamworth" ;
lin tan_A = mkWA (compoundA "kullan" (k15 "ruskea")) ; --UNCHK
lin tan_N = mkWN (k5 "topaasi") ; --UNCHK
lin tan_V = mkWV (k52A "päivettyä") ; --UNCHK
lin tan_V2 = mkWV2 (k52A "päivettyä") ; --UNCHK
lin tanager_N = mkWN "tangara" ; --UNCHK
lin tanbark_N = mkWN (kH1 "parkki") ; --UNCHK
lin tandem_Adv = mkWAdv (k99 "peräkkäin") ; --UNCHK
lin tandem_N = mkWN (k6 "tandem") ; --UNCHK
lin tandoor_N = mkWN (compoundN "tandooriu" (k24 "uni")) ; --UNCHK
lin tanekaha_N = mkWN "Phyllocladus" "trichomanoides" ; --UNCHK
lin tang_N = mkWN (compoundN "meri" (k9 "haura")) ; --UNCHK
lin tanga_N = mkWN "Tanga" ; --UNCHK
lin tangelo_N = mkWN (k5 "rumeliini") ; --UNCHK
lin tangency_N = mkWN (k9A "liitäntä") ; --UNCHK
lin tangent_1_N = mkWN (k5A "tangentti") ; --UNCHK
lin tangent_2_N = mkWN (k5A "tangentti") ; --UNCHK
lin tangential_A = mkWA (k38 "tangentiaalinen") ; --UNCHK
lin tangerine_A = mkWA (k5 "oranssi") "syvä" ; --UNCHK
lin tangerine_N = mkWN (k5 "oranssi") "syvä" ; --UNCHK
lin tangibility_N = mkWN (k40 "konkreettisuus") ; --UNCHK
lin tangible_A = mkA (mkN "kouraan" (mkN "tuntuva")) ; --mkWA (k10 "selvä") ;
lin tangle_N = mkWN (k7A "vyyhti") ; --UNCHK
lin tangle_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin tangle_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin tanglebush_N = mkWN "Forestiera" "neomexicana" ; --UNCHK
lin tango_N = mkWN (k1 "tango") ; --UNCHK
lin tango_V = mkWV (k61 "tanssia") "tangoa" ; --UNCHK
lin tangram_N = mkWN "tangram" ; --UNCHK
lin tangshan_PN = foreignPN "Tangshan" ;
lin tangy_A = mkWA (k15 "kirpeä") ; --UNCHK
lin tank_N = mkN "tankki" ; ---ARB mkN "panssarivaunu" ;
lin tank_V = mkWV (k53 "saostaa") "lietealtaassa" ; --UNCHK
lin tank_car_N = mkWN (compoundN "säiliö" (k1 "vaunu")) ; --UNCHK
lin tanka_N = mkWN (k9 "tanka") ; --UNCHK
lin tankage_N = mkWN (k5A "säiliöinti") ; --UNCHK
lin tankard_N = mkWN (k4A "kolpakko") ; --UNCHK
lin tanker_N = mkWN (k6 "tankkeri") ; --UNCHK
lin tanner_N = mkWN (k6 "nahkuri") ; --UNCHK
lin tannery_N = mkWN (compoundN "nahkurin" (k41 "verstas")) ; --UNCHK
lin tannic_A = mkWA (compoundA "parkki" (k38 "happoinen")) ; --UNCHK
lin tannin_N = mkWN (k5 "tanniini") ; --UNCHK
lin tanning_N = mkWN (k39 "parkitus") ; --UNCHK
lin tannish_A = mkWA "ruskeahko" ; --UNCHK
lin tannoy_N = mkWN (k33A "kaiutin") ; --UNCHK
lin tansy_N = mkWN (compoundN "pietar" (k5A "yrtti")) ; --UNCHK
lin tantalite_N = mkWN "tantaliitti" ; --UNCHK
lin tantalize_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin tantalizer_N = mkWN (k10 "kiusaaja") ; --UNCHK
lin tantalizing_A = mkWA (k10 "viehättävä") ; --UNCHK
lin tantalum_N = mkWN (k6 "tantaali") ; --UNCHK
lin tantamount_A = mkWA (k38 "samanlainen") ; --UNCHK
lin tantra_N = mkWN (compoundN "tantr" (k5 "ismi")) ; --UNCHK
lin tantrum_N = mkWN (k39 "kohtaus") "hysteerinen" ; --UNCHK
lin tanzania_PN = foreignPN "Tansania" ;
lin tanzanian_A = mkWA (compoundA "tansani" (k38 "alainen")) ; --UNCHK
lin tanzanian_N = mkWN (compoundN "tansani" (k38 "alainen")) ; --UNCHK
lin taoiseach_N = mkWN "taoiseach" ; --UNCHK
lin tap_N = mkN "tappi" ; ---ARB (koputus ; salakuuntelulaite ; hana)
lin tap_V = mkV (mkV "päästä") "käsiksi" ; ---ARB --mkWV (k73 "kerjätä") ;
lin tap_V2 = mkWV2 (k73 "kerjätä") ; --UNCHK
lin tap_dancing_N = mkWN (kH1 "steppi") ; --UNCHK
lin tap_for_V3 = variants {} ; -- guess-p-verb
lin tap_into_V2 = prepV2 OP_tap_V OP_into_Prep ; -- guess-p-verb
lin tap_off_with_V2 = prepV2 (advV OP_tap_V OP_off_Adv ) OP_with_Prep ; -- guess-p-verb
lin tap_out_V2 = mkWV2 (k67 "näppäillä") ; --UNCHK
lin tap_up_V2 = prepV2 OP_tap_V OP_up_Prep ; -- guess-p-verb
lin tapa_N = mkWN (k9A "tapa") ; --UNCHK
lin tape_N = mkN "teippi" ; ---- split nauha
lin tape_V = mkWV (k62 "taltioida") ; --UNCHK
lin tape_V2 = mkV2 "taltioida" partitive ;
lin tape_measure_N = mkWN (compoundN "mitta" (k9 "nauha")) ; --UNCHK
lin tape_recorder_N = mkWN (k5 "magnetofoni") ; --UNCHK
lin tapenade_N = mkWN (compoundN "oliivi" (k9 "tahna")) ; --UNCHK
lin taper_N = mkWN (k12 "kynttilä") ; --UNCHK
lin taper_V = mkWV (k54A "vähentää") ; --UNCHK
lin taper_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin taper_off_V = mkWV (k72A "heiketä") ; --UNCHK
lin tapering_N = mkWN "vähentäminen" ; --UNCHK
lin tapestried_A = mkWA "seinävaatteilla" "verhoiltu" ; --UNCHK
lin tapestry_N = mkWN (k5 "gobeliini") ; --UNCHK
lin tapeworm_N = mkWN (compoundN "lapa" (k1A "mato")) ; --UNCHK
lin taphephobia_N = mkWN (compoundN "tafo" (k12 "fobia")) ; --UNCHK
lin tapioca_N = mkWN (compoundN "tapi" (k10A "oka")) ; --UNCHK
lin tapir_N = mkWN (k6 "tapiiri") ; --UNCHK
lin tapotement_N = mkWN (compoundN "taputus" (k9A "hieronta")) ; --UNCHK
lin tapper_N = mkWN (k10 "steppaaja") ; --UNCHK
lin tappet_N = mkWN (k10A "nokka") ; --UNCHK
lin tapping_N = mkWN (k39 "koputus") ; --UNCHK
lin taproom_N = mkWN (k13 "saluuna") ; --UNCHK
lin taproot_N = mkWN (kH1 "juuri") "alku" "ja" ; --UNCHK
lin taps_N = mkWN (k40 "hiljaisuus") ; --UNCHK
lin tapster_N = mkWN (k6 "viinuri") ; --UNCHK
lin tar_N = mkWN (k14A "silakka") ; --UNCHK
lin tar_V2 = mkWV2 (k73 "tervata") ; --UNCHK
lin taradiddle_N = mkWN (k5 "humpuuki") ; --UNCHK
lin tarantella_N = mkWN (k9 "tarantella") ; --UNCHK
lin tarantelle_N = mkWN (k9 "tarantella") ; --UNCHK
lin taranto_PN = foreignPN "Taranto" ;
lin tarantula_N = mkWN (k9 "tarantella") ; --UNCHK
lin tarboosh_N = mkWN "fetsi" ; --UNCHK
lin tardigrade_N = mkWN (k38 "karhukainen") ; --UNCHK
lin tardiness_N = mkWN (compoundN "hidasliikke" (k40 "isyys")) ; --UNCHK
lin tardive_A = mkWA (compoundA "ilmen" (k10 "evä")) "myöhään" ; --UNCHK
lin tardy_A = mkWA (k99 "myöhässä") ; --UNCHK
lin tare_N = mkWN (k9 "taara") ; --UNCHK
lin target_N = mkN "maalitaulu" | mkN "kohde" ; ---- split concrete vs. abstract
lin target_V2 = mkWV2 (k73A "suunnata") ; --f53
lin target_V2V = mkWV2V (k73A "suunnata") ; --UNCHK
lin target_VS = mkWVS (k73A "suunnata") ; --UNCHK
lin tariff_N = mkWN (k5 "tariffi") ; --UNCHK
lin tarmac_N = mkWN (k5A "asfaltti") ; --UNCHK
lin tarmac_V2 = mkWV2 (k53 "päällystää") "asfaltilla" ; --UNCHK
lin tar_macadam_N = mkWN (k5A "asfaltti") ; --UNCHK
lin tarn_N = mkWN (compoundN "vuoristo" (k7A "lampi")) ; --UNCHK
lin tarnish_N = mkWN "tummuneisuus" ; --UNCHK
lin tarnish_V = mkWV (k52A "tummentua") ; --UNCHK
lin tarnish_V2 = mkV2 "tummentaa" ; --mkWV2 (k52A "tummentua") ;
lin taro_N = mkWN "edda" ; --UNCHK
lin tarpaulin_N = mkWN (kH1 "kangas") "kyllästetty" ; --UNCHK
lin tarpon_N = mkWN (compoundN "tar" (k5 "poni")) ; --UNCHK
lin tarradiddle_N = mkWN (k5 "humpuuki") ; --UNCHK
lin tarragon_N = mkWN (kH1 "rakuuna") ; --UNCHK
lin tarriance_N = mkWN "viipyilevyys" ; --UNCHK
lin tarry_A = mkWA (k38 "pihkainen") ; --UNCHK
lin tarry_V = mkWV (k67 "hidastella") ; --UNCHK
lin tarsal_A = mkWA (compoundA "tarsa" (k38 "alinen")) ; --UNCHK
lin tarsal_N = mkWN (compoundN "nilkka" (k18 "luu")) ; --UNCHK
lin tarsier_N = mkWN (compoundN "kummitus" (k33 "eläin")) ; --UNCHK
lin tarsitis_N = mkWN (k39 "tulehdus") "luomituen" ; --UNCHK
lin tart_A = mkWA (k10 "terävä") ; --UNCHK
lin tart_N = mkWN (k1A "torttu") ; --UNCHK
lin tartan_N = mkWN (k6 "tartaani") ; --UNCHK
lin tartar_N = mkWN (compoundN "hammas" (k7 "kivi")) ; --UNCHK
lin tartaric_A = mkWA (compoundA "viini" (k1A "happo")) ; --UNCHK
lin tartlet_N = mkWN (k38 "piiranen") ; --UNCHK
lin tartness_N = mkWN (k40 "piikikkyys") ; --UNCHK
lin tartrate_N = mkWN "tartraatti" ; --UNCHK
lin tarvasjoki_PN = mkPN (mkN "Tarvasjoki" "Tarvasjokia") ;
lin tarweed_N = mkWN (k5 "kasvi") "Grindelia-suvun" ; --UNCHK
lin tarwood_N = mkWN "Dacrydium" "colensoi" ; --UNCHK
lin tashkent_PN = foreignPN "Taškent" ;
lin task_N = mkN "tehtävä" | mkWN (k25 "toimi") ;
lin task_force_N = mkWN (compoundN "erikois" (k4A "yksikkö")) ; --UNCHK
lin taskmaster_N = mkWN (compoundN "orja" (k6 "piiskuri")) ; --UNCHK
lin taskmistress_N = mkWN (compoundN "orja" (k6 "piiskuri")) ; --UNCHK
lin tassel_N = mkWN (k1 "tupsu") ; --UNCHK
lin tasseled_A = mkWA (compoundA "tupsu" (k38 "koristeinen")) ; --UNCHK
lin tasselled_A = mkWA (compoundA "tupsu" (k38 "koristeinen")) ; --UNCHK
lin tasset_N = mkWN (compoundN "levy" (k6 "panssari")) "jalan" ; --UNCHK
lin taste_N = mkWN (compoundN "mais" (k38 "taminen")) ; --UNCHK
lin taste_V = mkWV (k58A "kokea") ; --UNCHK
lin taste_V2 = mkWV2 (k58A "kokea") ; --UNCHK
lin tastebud_N = mkWN (compoundN "maku" (k1 "silmu")) ; --UNCHK
lin tasteful_A = mkWA (k41A "aistikas") ; --UNCHK
lin tastefulness_N = mkWN (k40 "aistikkuus") ; --UNCHK
lin tasteless_A = mkWA (k34A "tyylitön") ; --UNCHK
lin tastelessness_N = mkWN (k40 "mauttomuus") ; --UNCHK
lin taster_N = mkWN (k10 "maistaja") ; --UNCHK
lin tasting_N = mkWN (compoundN "mais" (k38 "teleminen")) ; --UNCHK
lin tasty_A = mkWA (k38 "makuinen") "hyvän" ; --UNCHK
lin tat_N = mkWN "TAT" ; --UNCHK
lin tat_V = mkWV (k67A "pujotella") "sukkulapitsiä" ; --UNCHK
lin tat_V2 = mkWV2 (k67A "pujotella") "sukkulapitsiä" ; --UNCHK
lin tatouay_N = mkWN (compoundN "matogrosson" (k38 "vyötiäinen")) ; --UNCHK
lin tatter_N = mkWN (k48 "suikale") ; --UNCHK
lin tatterdemalion_N = mkWN (k38 "ryysyläinen") ; --UNCHK
lin tattered_A = mkWA "revitty" ; --UNCHK
lin tatting_N = mkWN (k39 "nypläys") ; --UNCHK
lin tattle_N = mkWN (k2 "juoruilu") ; --UNCHK
lin tattle_V = mkWV (k62 "vasikoida") ; --UNCHK
lin tattle_V2 = mkWV2 (k62 "vasikoida") ; --UNCHK
lin tattler_N = mkWN (k10A "kurppa") ; --UNCHK
lin tattletale_N = mkWN (k1A "lörppö") ; --UNCHK
lin tattoo_N = mkWN (k5A "tatuointi") ; --UNCHK
lin tattoo_V2 = mkWV2 (k62 "tatuoida") ; --UNCHK
lin tatty_A = mkWA (k15 "pramea") ; --UNCHK
lin tau_N = mkWN (k18 "tau") ; --UNCHK
lin taunt_N = mkWN (k9 "iva") ; --UNCHK
lin taunt_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin tauntingly_Adv = mkWAdv (compoundAdv "kiusoittelev" (k99 "asti")) ; --UNCHK
lin taunton_PN = foreignPN "Taunton" ;
lin tauon_N = mkWN (k5 "elektroni") "taun" ; --UNCHK
lin taupe_N = mkWN (compoundN "ruskean" (k17 "harmaa")) ; --UNCHK
lin taurine_A = mkWA (compoundA "härkä" (k38 "mäinen")) ; --UNCHK
lin taurine_N = mkWN "tauriini" ; --UNCHK
lin taut_A = mkWA (k15 "kireä") ; --UNCHK
lin tautness_N = mkWN (k40 "kireys") ; --UNCHK
lin tautog_N = mkWN (compoundN "tau" (k10 "toga")) ; --UNCHK
lin tautological_A = mkWA (k38 "tautologinen") ; --UNCHK
lin tautology_N = mkWN (k1 "toisto") ; --UNCHK
lin tavern_N = mkWN (kH1 "krouvi") ; --UNCHK
lin tavistock_PN = foreignPN "Tavistock" ;
lin taw_N = mkWN "shooter" ; --UNCHK
lin tawdriness_N = mkWN (k40 "mauttomuus") ; --UNCHK
lin tawdry_A = mkWA (k15 "surkea") ; --UNCHK
lin tawniness_N = mkWN (k39 "päivetys") ; --UNCHK
lin tawny_A = mkWA (compoundA "kellan" (k15 "ruskea")) ; --UNCHK
lin tawse_N = mkWN (k5 "remmi") ; --UNCHK
lin tax_N = mkN "vero" ;
lin tax_V2 = mkV2 "verottaa" partitive ;
lin tax_collector_N = mkWN (k10 "verottaja") ; --UNCHK
lin tax_free_A = mkA "verovapaa" ;
lin taxability_N = mkWN (compoundN "veron" (k40 "alaisuus")) ; --UNCHK
lin taxable_A = mkWA "veronalainen" ; --UNCHK
lin taxation_N = mkWN (k39 "verotus") ; --UNCHK
lin taxer_N = mkWN (k10 "verottaja") ; --UNCHK
lin taxi_N = mkWN (k5 "taksi") ;
lin taxi_V = mkWV (k73 "rullata") ; --UNCHK
lin taxi_V2 = mkWV2 (k73 "rullata") ; --UNCHK
lin taxicab_N = mkWN (k5 "pirssi") ; --UNCHK
lin taxidermist_N = mkWN (compoundN "eläinten" (k10 "täyttäjä")) ; --UNCHK
lin taxidermy_N = mkWN "eläinten" "täyttäminen" ; --UNCHK
lin taxidriver_N = mkWN (k14A "vossikka") ; --UNCHK
lin taximeter_N = mkWN (compoundN "taksa" (k6 "mittari")) ; --UNCHK
lin taxis_N = mkWN (kH1 "veto") ; --UNCHK
lin taxiway_N = mkWN (compoundN "rullaus" (k19 "tie")) ; --UNCHK
lin taxonomic_A = mkWA (k38 "systemaattinen") ; --UNCHK
lin taxonomist_N = mkWN (k4A "systemaatikko") ; --UNCHK
lin taxonomy_N = mkWN (k12 "taksonomia") ; --UNCHK
lin taxpayer_N = mkWN (compoundN "veron" (k10 "maksaja")) ;
lin taxpaying_A = mkWA "veroamaksava" ; --UNCHK
lin tayra_N = mkWN "Eira" "barbara" ; --UNCHK
lin tb_N = mkWN (compoundN "tera" (k1 "tavu")) ; --UNCHK
lin tbilisi_PN = foreignPN "Tbilisi" ;
lin te_deum_N = mkWN "Te" "Deum" ; --UNCHK
lin tea_N = mkN "tee" ;
lin tea_bag_N = mkWN (compoundN "tee" (k5 "pussi")) ; --UNCHK
lin tea_break_N = mkWN (compoundN "kahvi" (k1A "tauko")) ; --UNCHK
lin tea_caddy_N = mkWN (compoundN "teenlehti" (k12 "rasia")) ; --UNCHK
lin tea_chest_N = mkWN (compoundN "tee" (k4A "laatikko")) ; --UNCHK
lin tea_cloth_N = mkWN (k9 "liina") "teepöydän" ; --UNCHK
lin tea_cosy_N = mkWN (compoundN "tee" (k1 "myssy")) ; --UNCHK
lin tea_garden_N = mkWN (compoundN "ulko" (k2 "tarjoilu")) "teen" ; --UNCHK
lin tea_leaf_N = mkWN (k18 "tee") ; --UNCHK
lin tea_service_N = mkWN (compoundN "tee" (k1 "astiasto")) ; --UNCHK
lin tea_set_N = mkWN (compoundN "tee" (k1 "astiasto")) ; --UNCHK
lin tea_table_N = mkWN (compoundN "tee" (k10A "pöytä")) ; --UNCHK
lin tea_towel_N = mkWN (compoundN "astia" (k48A "pyyhe")) ; --UNCHK
lin tea_tray_N = mkWN (compoundN "tee" (k33A "tarjotin")) ; --UNCHK
lin tea_trolley_N = mkWN (compoundN "tarjoilu" (k10A "pöytä")) ; --UNCHK
lin tea_urn_N = mkWN (compoundN "teen" (k33A "keitin")) ; --UNCHK
lin tea_wagon_N = mkWN (compoundN "tarjoilu" (k10A "pöytä")) ; --UNCHK
lin teacake_N = mkWN (compoundN "pikku" (k10A "leipä")) ; --UNCHK
lin teach_V = mkWV (k53A "opettaa") ;
lin teach_V2 = L.teach_V2 ;
lin teach_V2V = mkWV2V (k53A "opettaa") ;
lin teach_VS = mkWVS (k53A "opettaa") ; --UNCHK
lin teachable_A = mkWA (k38 "oppivainen") ; --UNCHK
lin teacherFem_N = L.teacher_N ;
lin teacherMasc_N = mkN "opettaja" ;
lin teachership_N = mkWN "opettajuus" ; --UNCHK
lin teaching_N = mkN "opetus" ; --mkWN (k9A "didaktiikka") ;
lin teacup_N = mkWN (compoundN "tee" (k5A "kuppi")) ; --UNCHK
lin teahouse_N = mkWN (k12 "kahvila") ; --UNCHK
lin teak_N = mkWN (k5A "tiikki") ; --UNCHK
lin tea_kettle_N = mkWN (compoundN "tee" (k1 "pannu")) ; --UNCHK
lin teal_N = mkWN (k5 "tavi") ; --UNCHK
lin team_N = mkN "ryhmä" | mkN "joukkue" ;
lin team_V = mkWV (k52A "ryhtyä") "yhteistyöhön" ;
lin team_up_V = mkWV (k52A "ryhtyä") "yhteistyöhön" ; --UNCHK
lin teammate_N = mkWN (compoundN "työ" (k6 "toveri")) ; --UNCHK
lin teamster_N = mkWN (k10 "kuljettaja") "rekka-auton" ; --UNCHK
lin teamwork_N = mkWN (compoundN "yhteis" (k19 "työ")) ; --UNCHK
lin teapot_N = mkWN (compoundN "tee" (k1 "kannu")) ; --UNCHK
lin tear_N = mkWN "repiminen" ; --UNCHK
lin tear_V = mkV "repeytyä" ;
lin tear_V2 = mkWV2 (k61A "kyynelehtiä") ; --UNCHK
lin tear_apart_V2 = mkWV2 (k53A "löylyttää") ; --UNCHK
lin tear_at_V2 = prepV2 OP_tear_V OP_at_Prep ; -- guess-p-verb
lin tear_away_V2 = mkWV2 (k61A "repiä") "irti" ; --UNCHK
lin tear_down_V2 = prepV2 OP_tear_V OP_down_Prep ; -- guess-p-verb
lin tear_gas_N = mkWN (compoundN "kyynel" (k1 "kaasu")) ; --UNCHK
lin tear_into_V2 = mkWV2 (k65 "käydä") "käsiksi" ; --UNCHK
lin tear_off_V = mkWV (k61A "repiä") "irti" ; --UNCHK
lin tear_off_V2 = mkWV2 (k61A "repiä") "irti" ; --UNCHK
lin tear_out_V = advV OP_tear_V OP_out_Adv ; -- guess-p-verb
lin tear_up_V = mkWV (k62 "suikaloida") ; --UNCHK
lin tear_up_V2 = mkWV2 (k62 "suikaloida") ; --UNCHK
lin tearaway_A = mkWA (k38 "äkillinen") ; --UNCHK
lin tearaway_N = mkWN (k39 "hurjimus") ; --UNCHK
lin tear_drop_N = mkWN (k49 "kyynel") ; --UNCHK
lin tearful_A = mkWA (k38 "kyyneleinen") ; --UNCHK
lin tearing_N = mkWN (k2 "vetistely") ; --UNCHK
lin tearjerker_N = mkWN (compoundN "nyyhky" (k12 "tarina")) ; --UNCHK
lin tearless_A = mkWA (compoundA "kuiva" (k38 "silmäinen")) ; --UNCHK
lin tearoom_N = mkWN (k12 "kahvila") ; --UNCHK
lin teary_A = mkWA (k38 "kyyneleinen") ; --UNCHK
lin tease_V2 = mkWV2 (k67A "vietellä") ; --UNCHK
lin teasel_N = mkWN (compoundN "karsta" (k48A "ohdake")) ; --UNCHK
lin teaser_N = mkWN (kH1 "karsta") ; --UNCHK
lin teashop_N = mkWN (k12 "kahvila") ; --UNCHK
lin teasing_A = mkWA (k10 "rasittava") ; --UNCHK
lin teasing_N = mkWN (compoundN "kampa" (k38 "aminen")) "takkujen" ; --UNCHK
lin teaspoon_N = mkWN (compoundN "tee" (k14A "lusikka")) ; --UNCHK
lin teaspoonful_N = mkWN (compoundN "tee" (k38 "lusikallinen")) ; --UNCHK
lin teat_N = mkWN (k5 "tissi") ; --UNCHK
lin teazel_N = mkWN (compoundN "karsta" (k48A "ohdake")) ; --UNCHK
lin tec_N = mkWN (k10 "etsivä") ; --UNCHK
lin tech_N = mkWN (compoundN "oppi" (k39 "laitos")) "teknillinen" ; --UNCHK
lin techie_N = mkWN (k5A "nörtti") ; --UNCHK
lin technetium_N = mkWN (k5 "teknetium") ; --UNCHK
lin technical_A = mkWA (k38 "tekninen") ; --f78
lin technical_N = mkWN (k48 "virhe") "tekninen" ; --UNCHK
lin technicality_N = mkWN (k5A "trivialiteetti") ; --UNCHK
lin technician_N = mkWN (k4A "teknikko") ; --UNCHK
lin technicolor_N = mkWN "technicolor" ; --UNCHK
lin technique_N = mkN "tekniikka" ;
lin techno_N = mkWN (k1 "tekno") ; --UNCHK
lin technobabble_N = mkWN (k12 "teknopölinä") ; --UNCHK
lin technocracy_N = mkWN (k12 "teknokratia") ; --UNCHK
lin technocrat_N = mkWN (k5A "teknokraatti") ; --UNCHK
lin technological_A = mkWA (k38 "teknologinen") ; --UNCHK
lin technologist_N = mkWN (k5 "insinööri") ; --UNCHK
lin technology_N = mkN "tekniikka" | mkN "teknologia" ;
lin technophile_N = mkWN "teknofiili" ; --UNCHK
lin technophilia_N = mkWN (k12 "teknokratia") ; --UNCHK
lin technophilic_A = mkWA (compoundA "tekno" (k38 "fiilinen")) ; --UNCHK
lin technophobe_N = mkWN "teknofobi" ; --UNCHK
lin technophobia_N = mkWN (compoundN "tekno" (k12 "fobia")) ; --UNCHK
lin technophobic_A = mkWA (compoundA "tekno" (k38 "fobinen")) ; --UNCHK
lin techy_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin tectonic_1_A = mkWA (k38 "tektoninen") ; --UNCHK
lin tectonic_2_A = mkWA (k38 "tektoninen") ; --UNCHK
lin tectonics_N = mkWN (k9A "tektoniikka") ; --UNCHK
lin ted_N = mkWN (k39 "rasvis") ; --UNCHK
lin teddy_N = mkWN (compoundN "alus" (k9A "paita")) ; --UNCHK
lin teddy_boy_N = mkWN (k39 "rasvis") ; --UNCHK
lin tedious_A = mkWA (k10 "ikävystyttävä") ; --UNCHK
lin tediousness_N = mkWN (k40 "pitkäveteisyys") ; --UNCHK
lin tedium_N = mkWN (k40 "pitkäveteisyys") ; --UNCHK
lin tee_N = mkWN (k18 "tii") ; --UNCHK
lin tee_V = mkWV (k53 "yhdistää") ; --UNCHK
lin tee_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin tee_shirt_N = mkWN (compoundN "villa" (k2 "pusero")) ; --UNCHK
lin tee_up_V = mkWV "tiiata" ; --UNCHK
lin teekkarikylä_PN = mkPN "Teekkarikylä" ;
lin teem_V = mkWV (k67 "parveilla") ; --UNCHK
lin teenage_A = mkWA (compoundA "kasvu" (k38 "ikäinen")) ; --UNCHK
lin teenager_N = mkN "teini-ikäinen" ;
lin teens_N = mkWN (compoundN "kymmen" (k1A "luku")) ; --UNCHK
lin teeny_A = mkWA (k38 "pikkuriikkinen") ; --UNCHK
lin teeoff_N = mkWN "teeoff" ; --UNCHK
lin teeriniemi_PN = mkPN (mkN "Teeriniemi" "Teeriniemiä") ;
lin teeter_V = mkWV (k52 "horjua") ; --UNCHK
lin teethe_V = mkWV (k63 "saada") "hampaita" ; --UNCHK
lin teething_N = mkWN "hampaiden" "puhkeaminen" ; --UNCHK
lin teetotal_A = mkWA (k41A "raitis") ; --UNCHK
lin teetotaling_N = mkWN (k5 "absolutismi") ; --UNCHK
lin teetotaller_N = mkWN (k41A "raitis") ; --UNCHK
lin teetotum_N = mkWN (k10 "hyrrä") ; --UNCHK
lin teff_N = mkWN (compoundN "tef" (k10 "heinä")) ; --UNCHK
lin teg_N = mkWN (k41A "lammas") "kaksivuotinen" ; --UNCHK
lin tegular_A = mkWA (k38 "tiilinen") ; --UNCHK
lin tegument_N = mkWN (k1 "iho") ; --UNCHK
lin teignmouth_PN = foreignPN "Teignmouth" ;
lin teju_N = mkWN "teju" ; --UNCHK
lin tektite_N = mkWN "tektiitti" ; --UNCHK
lin telecast_N = mkWN (compoundN "televisio" (k39 "lähetys")) ; --UNCHK
lin telecast_V2 = mkWV2 (k62 "televisioida") ; --UNCHK
lin telecaster_N = mkWN (compoundN "televisio" (k3 "yhtiö")) ; --UNCHK
lin telecommunication_N = mkN "telekommunikaatio" ;
lin telecommuting_N = mkWN (k38 "tekeminen") "etätyön" ; --UNCHK
lin teleconference_N = mkWN (compoundN "tele" (k2 "neuvottelu")) ; --UNCHK
lin telefilm_N = mkWN "televisioelokuva" ; --UNCHK
lin telegnosis_N = mkWN (compoundN "etä" (k1A "tieto")) ; --UNCHK
lin telegnostic_A = mkWA (compoundA "tele" (k38 "gnostinen")) ; --UNCHK
lin telegram_N = mkWN (k48 "sähke") ; --UNCHK
lin telegraph_N = mkWN (k33A "lennätin") ; --UNCHK
lin telegraph_V = mkWV (k53A "sähköttää") ; --UNCHK
lin telegraph_V2 = mkWV2 (k53A "sähköttää") ; --UNCHK
lin telegraph_line_N = mkWN (compoundN "puhelin" (k9 "linja")) ; --UNCHK
lin telegraph_pole_N = mkWN (compoundN "puhelin" (k41 "pylväs")) ; --UNCHK
lin telegraph_post_N = mkWN (compoundN "puhelin" (k41 "pylväs")) ; --UNCHK
lin telegraph_wire_N = mkWN (compoundN "puhelin" (k9 "linja")) ; --UNCHK
lin telegrapher_N = mkWN (k10 "sähköttäjä") ; --UNCHK
lin telegraphese_N = mkWN (compoundN "sähkösanoma" (k26 "kieli")) ; --UNCHK
lin telegraphic_A = mkWA "sähke-" ; --UNCHK
lin telegraphist_N = mkWN (k10 "sähköttäjä") ; --UNCHK
lin telegraphy_N = mkWN (k33A "lennätin") ; --UNCHK
lin telekinesis_N = mkWN (k12 "psykokinesia") ; --UNCHK
lin telemark_N = mkWN (k5 "telemark") ; --UNCHK
lin telemarketing_N = mkWN (compoundN "puhelin" (k5A "myynti")) ; --UNCHK
lin telemeter_N = mkWN (compoundN "etäisyys" (k6 "mittari")) ; --UNCHK
lin telemetry_N = mkWN (k12 "telemetria") ; --UNCHK
lin teleological_A = mkWA (k38 "teleologinen") ; --UNCHK
lin teleologist_N = mkWN "teleologisti" ; --UNCHK
lin teleology_N = mkWN (k12 "teleologia") ; --UNCHK
lin telepathic_A = mkWA (k38 "telepaattinen") ; --UNCHK
lin telepathist_N = mkWN (compoundN "ajatusten" (k12 "lukija")) ; --UNCHK
lin telepathy_N = mkWN (k12 "telepatia") ; --UNCHK
lin telephone_N = mkWN (k33 "puhelin") ; --f132
lin telephone_V = mkWV (k53A "soittaa") ; --UNCHK
lin telephone_V2 = mkWV2 (k53A "soittaa") ; --UNCHK
lin telephonic_A = mkWA "puhelin-" ; --UNCHK
lin telephonistFem_N = mkWN (k39 "keskus") ; --UNCHK
lin telephonistMasc_N = mkWN (k39 "keskus") ; --UNCHK
lin telephony_N = mkWN (k33 "puhelin") ; --UNCHK
lin telephoto_N = mkWN (compoundN "kauko-objektiivi" (k10 "kuva")) ; --UNCHK
lin telephotograph_N = mkWN (compoundN "kauko-objektiivi" (k10 "kuva")) ; --UNCHK
lin telephotography_N = mkWN "kaukovalokuvaus" ; --UNCHK
lin teleportation_N = mkWN (compoundN "kauko" (k1A "siirto")) ; --UNCHK
lin teleprinter_N = mkWN (compoundN "tele" (k6 "printteri")) ; --UNCHK
lin teleprompter_N = mkWN "Teleprompter" ; --UNCHK
lin telerobotics_N = mkWN (compoundN "kauko-" (k39 "ohjaus")) ; --UNCHK
lin telescope_N = mkWN (k5A "teleskooppi") ; --UNCHK
lin telescope_V = mkWV (k53 "tiivistää") ; --UNCHK
lin telescope_V2 = mkWV2 (k53 "tiivistää") ; --UNCHK
lin telescopic_A = mkWA "teleskooppi-" ; --UNCHK
lin telescopy_N = mkWN "teleskopia" ; --UNCHK
lin telethermometer_N = mkWN (compoundN "kaukolämpö" (k6 "mittari")) ; --UNCHK
lin teletypewriter_N = mkWN (compoundN "tele" (k6 "printteri")) ; --UNCHK
lin televangelism_N = mkWN (compoundN "televisioevankel" (k5 "ismi")) ; --UNCHK
lin televangelist_N = mkWN (compoundN "televisio" (k10 "saarnaaja")) ; --UNCHK
lin televise_V2 = mkWV2 (k62 "televisioida") ;
lin television_N = L.television_N ;
lin telex_N = mkWN (compoundN "tele" (k6 "printteri")) ; --UNCHK
lin telfer_N = mkWN (k33 "nostin") ; --UNCHK
lin telford_PN = foreignPN "Telford" ;
lin teliospore_N = mkWN (compoundN "teliosp" (k48 "ori")) ; --UNCHK
lin tell_1_V3 = mkV3 (mkV "erottaa") accusative (casePrep elative) ;
lin tell_2_V3 = mkV3 (mkV "kertoa") accusative (casePrep allative) ;
lin tell_V = mkV "kertoa" ;
lin tell_V2 = mkV2 "kertoa" ;
lin tell_V2S = mkV2S (mkV "kertoa") (mkPrep allative) ;
lin tell_V2V = mkV2V (mkV "kertoa") genitive infPresPart ;
lin tell_V3 = mkV3 (mkV "kertoa") accusative (casePrep allative) ;
lin tell_VS = mkVS (mkV "kertoa") ;
lin tell_apart_V2 = mkWV2 (k73 "huomata") "ero" ; --UNCHK
lin tell_from_V3 = mkV3 (mkV "erottaa") accusative (mkPrep elative) ;
lin tell_off_V2 = mkWV2 (k67A "nuhdella") ; --UNCHK
lin tell_on_V2 = mkWV2 (k65 "käydä") "voimille" ; --UNCHK
lin teller_N = mkN "pankki" (mkN "virkailija") ; ---ARB --mkN "ääntenlaskija" ; --mkWN (k10 "kertoja") ;
lin telling_A = mkWA (k10 "vakuuttava") ; --UNCHK
lin telling_N = mkWN (k2 "juoruilu") ; --UNCHK
lin telltale_N = mkWN (k1A "lörppö") ; --UNCHK
lin tellurian_A = mkWA (compoundA "maan" (k38 "päällinen")) ; --UNCHK
lin tellurian_N = mkWN (k41A "asukas") "maan" ; --UNCHK
lin telluric_A = mkWA (compoundA "maan" (k38 "päällinen")) ; --UNCHK
lin telluride_N = mkWN "telluridi" ; --UNCHK
lin tellurium_N = mkWN (k6 "telluuri") ; --UNCHK
lin telly_N = mkWN (k20 "teevee") ; --UNCHK
lin telocentric_A = mkWA "telosentrinen" ; --UNCHK
lin telomerase_N = mkWN (compoundN "telomer" (k5 "aasi")) ; --UNCHK
lin telophase_N = mkWN (compoundN "telo" (k5 "faasi")) ; --UNCHK
lin telpher_N = mkWN (k33 "nostin") ; --UNCHK
lin telpherage_N = mkWN (compoundN "köysi" (k9A "rata")) ; --UNCHK
lin temazepam_N = mkWN "Restoril" ; --UNCHK
lin temerity_N = mkWN (k39 "uskallus") ; --UNCHK
lin temp_N = mkWN (k38 "sijainen") ; --UNCHK
lin temper_N = mkWN (k40 "äreys") ; --UNCHK
lin temper_V = mkWV (k53A "taltuttaa") ; --UNCHK
lin temper_V2 = mkWV2 (k53A "taltuttaa") ; --UNCHK
lin tempera_N = mkWN (k5 "liimamaali") ; --UNCHK
lin temperament_N = mkWN (k5 "temperatuuri") ; --UNCHK
lin temperamental_A = mkWA "temperamentti-" ; --UNCHK
lin temperance_N = mkWN "temperointi" ; --UNCHK
lin temperate_A = mkWA (k38 "maltillinen") ; --UNCHK
lin temperateness_N = mkWN (compoundN "itse" (k9A "hillintä")) ; --UNCHK
lin temperature_N = mkWN (compoundN "lämpö" (k9 "tila")) ;
lin tempest_N = mkWN (k50 "rajuilma") ; --UNCHK
lin tempestuous_A = mkWA (k34A "rauhaton") ; --UNCHK
lin tempestuousness_N = mkWN (k40 "myrskyisyys") ; --UNCHK
lin template_N = mkWN (k48 "malline") ; --UNCHK
lin temple_N = mkWN (k6 "temppeli") ; --UNCHK
lin templet_N = mkWN (k48 "malline") ; --UNCHK
lin tempo_N = mkWN (k5A "tahti") ; --UNCHK
lin temporal_A = mkWA (k38 "mainen") ; --UNCHK
lin temporality_N = mkWN (k40 "omaisuus") "maallinen" ; --UNCHK
lin temporariness_N = mkWN (k40 "tilapäisyys") ; --UNCHK
lin temporary_A = mkWA (k38 "tilapäinen") ; --f111
lin temporize_V = mkWV (k73 "pelata") "aikaa" ; --UNCHK
lin temporizer_N = mkWN "vetku" ; --UNCHK
lin tempt_V2 = mkWV2 (k67A "vietellä") ; --UNCHK
lin tempt_V2V = mkWV2V (k67A "vietellä") ; --UNCHK
lin temptable_A = mkWA (k10 "oleva") "vieteltävissä" ; --UNCHK
lin temptation_N = mkN "houkutus" ; --mkWN (k2 "viettely") ;
lin tempter_N = mkWN (k10 "kiusaaja") ; --UNCHK
lin temptingly_Adv = mkWAdv (k99 "viettelevästi") ; --UNCHK
lin temptress_N = mkWN (k38 "nainen") "kohtalokas" ; --UNCHK
lin tempura_N = mkWN (compoundN "temp" (k10 "ura")) ; --UNCHK
lin tenability_N = mkWN (k40 "hyväksyttävyys") ; --UNCHK
lin tenable_A = mkWA (k10 "pitävä") ; --UNCHK
lin tenacious_A = mkWA (k10 "kestävä") ; --UNCHK
lin tenaciousness_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin tenacity_N = mkWN (k40 "sinnikkyys") ; --UNCHK
lin tenancy_N = mkWN (compoundN "maanvuokra" (k39 "sopimus")) ; --UNCHK
lin tenant_N = mkWN (k38 "vuokralainen") ;
lin tenant_V2 = mkWV2 (k73 "vuokrata") ; --UNCHK
lin tenby_PN = foreignPN "Tenby" ;
lin tench_N = mkWN (k6 "suutari") ; --UNCHK
lin tend_V2 = mkV2 "pitää" partitive | mkV2 "hoitaa" partitive ;
lin tend_VV = mkVV (mkV "tavata") ;
lin tendency_N = mkWN (k39 "viettymys") ; --UNCHK
lin tendentious_A = mkWA (k38 "puolueellinen") ; --UNCHK
lin tendentiousness_N = mkWN (k40 "puolueellisuus") ; --UNCHK
lin tender_A = mkWA (k15 "murea") ; --UNCHK
lin tender_N = mkN "maksu" (mkN "väline") ; --f79
lin tender_V = mkV (mkV "esittää") "tarjous" ; --mkWV (k53A "riiputtaa") ;
lin tender_V2 = mkWV2 (k53A "riiputtaa") ; --UNCHK
lin tender_V2V = mkWV2V (k53A "riiputtaa") ; --UNCHK
lin tenderfoot_N = mkWN (compoundN "kelta" (k10A "nokka")) ; --UNCHK
lin tendergreen_N = mkWN (compoundN "vihannes" (k5A "sinappi")) ; --UNCHK
lin tenderhearted_A = mkWA (compoundA "hyvä" (k38 "sydäminen")) ; --UNCHK
lin tenderization_N = mkWN (k39 "pehmennys") ; --UNCHK
lin tenderized_A = mkWA "kypsennetty" ; --UNCHK
lin tenderizer_N = mkWN (k5 "marinadi") ; --UNCHK
lin tenderloin_N = mkWN (compoundN "sisä" (k20 "filee")) ; --UNCHK
lin tenderness_N = mkWN (k40 "hellyys") ; --UNCHK
lin tendinitis_N = mkWN (compoundN "jänne" (k39 "tulehdus")) ; --UNCHK
lin tendinous_A = mkWA (k38 "jänteinen") ; --UNCHK
lin tendon_N = mkWN (k48 "jäntere") ; --UNCHK
lin tendril_N = mkWN (k7 "kärhi") ; --UNCHK
lin tenebrous_A = mkWA (k15 "synkeä") ; --UNCHK
lin tenement_N = mkWN (compoundN "vuokra" (k1 "talo")) ; --UNCHK
lin tenement_house_N = mkWN (compoundN "vuokra" (k1 "talo")) ; --UNCHK
lin tenesmus_N = mkWN (compoundN "ulostus" (k1A "pakko")) ; --UNCHK
lin tenet_N = mkWN (k5 "dogmi") ; --UNCHK
lin tenfold_A = mkWA (compoundA "kymmen" (k38 "kertainen")) ; --UNCHK
lin tenfold_Adv = mkWAdv "kymmenkertaisesti" ;
lin tenge_N = mkWN "tenge" ; --UNCHK
lin tenner_N = mkWN (k6 "seteli") "kymmenen" "taalan" ; --UNCHK
lin tennessee_PN = mkPN "Tennessee" ;
lin tennis_N = mkWN (k39 "tennis") ;
lin tennis_court_N = mkWN (compoundN "tennis" (k10A "kenttä")) ; --UNCHK
lin tennis_elbow_N = mkWN "tenniskyynärpää" ; --UNCHK
lin tenon_N = mkWN (k5A "tappi") ; --UNCHK
lin tenor_A = mkWA "tenori-" ; --UNCHK
lin tenor_N = mkWN (k6 "tenori") ; --UNCHK
lin tenoroon_N = mkWN (compoundN "tenori" (k13 "pasuuna")) ; --UNCHK
lin tenosynovitis_N = mkWN (k39 "tulehdus") "jännetupen" ; --UNCHK
lin tenpence_N = mkWN (compoundN "kymmen" (k38 "penninen")) ; --UNCHK
lin tenpin_N = mkWN (compoundN "keila" (k5 "peli")) ; --UNCHK
lin tenpins_N = mkWN (compoundN "keila" (k38 "aminen")) ; --UNCHK
lin tenrec_N = mkWN (compoundN "tan" (k5A "rekki")) ; --UNCHK
lin tense_A = mkA "kireä" ;
lin tense_N = mkWN (k39 "tempus") ; --UNCHK
lin tense_V = mkWV (k53 "kiristää") ; --UNCHK
lin tense_V2 = mkWV2 (k53 "kiristää") ; --UNCHK
lin tenseness_N = mkWN (k40 "jännittyneisyys") ; --UNCHK
lin tensile_A = mkWA "veto-" ; --UNCHK
lin tensimeter_N = mkWN (compoundN "höyrynpaine" (k6 "mittari")) ; --UNCHK
lin tensiometer_N = mkWN (compoundN "tensio" (k5 "metri")) ; --UNCHK
lin tension_N = mkWN (k39 "kiristys") ; --UNCHK
lin tensional_A = mkWA (k38 "jännitteinen") ; --UNCHK
lin tensionless_A = mkWA (k1A "rento") ; --UNCHK
lin tensity_N = mkWN (k39 "jännitys") ; --UNCHK
lin tensor_N = mkWN (k10 "jännittäjä") ; --UNCHK
lin tent_N = mkWN (k9A "teltta") ; --UNCHK
lin tent_peg_N = mkWN (k9 "vaarna") "teltan" ; --UNCHK
lin tentacle_N = mkWN (kH1 "lonkero") ; --UNCHK
lin tentacled_A = mkWA (compoundA "tunto" (k38 "sarvellinen")) ; --UNCHK
lin tentacular_A = mkWA "tuntosarven" ; --UNCHK
lin tentative_A = mkA "alustava" ;
lin tenter_N = mkWN (compoundN "kuivaus" (k48 "teline")) ; --UNCHK
lin tenterden_PN = foreignPN "Tenterden" ;
lin tenterhook_N = mkWN (k1A "koukku") ; --UNCHK
lin tenth_N = mkWN (k39 "kymmenennes") ; --UNCHK
lin tentmaker_N = mkWN (compoundN "teltan" (k12 "tekijä")) ; --UNCHK
lin tentorium_N = mkWN (compoundN "ten" (k5 "torium")) ; --UNCHK
lin tenuity_N = mkWN (k40 "voimattomuus") ; --UNCHK
lin tenuous_A = mkWA (k38 "köykäinen") ; --UNCHK
lin tenure_N = mkWN (compoundN "hallinta" (k40 "oikeus")) ; --UNCHK
lin tenured_A = mkWA (compoundA "elin" (k38 "ikäinen")) ; --UNCHK
lin tepal_N = mkWN (compoundN "terä" (k7A "lehti")) ; --UNCHK
lin tepee_N = mkWN (k18 "tiipii") ; --UNCHK
lin tepid_A = mkWA (k15 "vaimea") ; --UNCHK
lin tepidity_N = mkWN (k40 "haaleus") ; --UNCHK
lin tepidness_N = mkWN (k40 "laimeus") ; --UNCHK
lin tequila_N = mkWN (k9 "tequila") ; --UNCHK
lin terabit_N = mkWN (compoundN "tera" (k5A "bitti")) ; --UNCHK
lin terabyte_N = mkWN (compoundN "tera" (k1 "tavu")) ; --UNCHK
lin teraflop_N = mkWN (compoundN "mitta" (k4A "yksikkö")) ; --UNCHK
lin terahertz_N = mkWN (compoundN "tera" (k5 "hertsi")) ; --UNCHK
lin teratogen_N = mkWN (k5 "teratogeeni") ; --UNCHK
lin teratogenesis_N = mkWN "teratogeneesi" ; --UNCHK
lin teratogenic_A = mkWA (k38 "teratogeeninen") ; --UNCHK
lin teratology_N = mkWN "teratologia" ; --UNCHK
lin teratoma_N = mkWN (compoundN "terato" (k10 "oma")) ; --UNCHK
lin terazosin_N = mkWN "Hytrin" ; --UNCHK
lin terbinafine_N = mkWN (compoundN "terbina" (k5 "fiini")) ; --UNCHK
lin terbium_N = mkWN "alkuainenumero" "65" ; --UNCHK
lin terce_N = mkWN (k7 "hetki") "kolmas" ; --UNCHK
lin tercentenary_N = mkWN (k5 "triennaali") ; --UNCHK
lin tercentennial_N = mkWN (k5 "triennaali") ; --UNCHK
lin terebinth_N = mkWN (compoundN "tärpätti" (k18 "puu")) ; --UNCHK
lin teredo_N = mkWN (compoundN "laiva" (k10A "toukka")) ; --UNCHK
lin teres_N = mkWN (compoundN "teres-" (k39 "lihas")) ; --UNCHK
lin teresa_PN = foreignPN "Teresa" ;
lin terete_A = mkWA (compoundA "suippe" (k9 "neva")) ; --UNCHK
lin tergiversate_V = mkWV (k52 "horjua") ; --UNCHK
lin tergiversation_N = mkWN (k40 "petturuus") ; --UNCHK
lin teriyaki_N = mkWN "teriyaki" ; --UNCHK
lin term_N = mkN "ehto" | mkN "termi" ; ---- split
lin term_V2 = mkWV2 (k67A "määritellä") ; --UNCHK
lin term_VS = mkWVS (k67A "määritellä") ;
lin termagant_N = mkWN (k32A "syöjätär") ; --UNCHK
lin terminable_A = mkWA (compoundA "määrä" (k38 "aikainen")) ; --UNCHK
lin terminal_A = mkWA (k38 "viimeinen") ; --UNCHK
lin terminal_N = mkWN (k10 "asema") ; --UNCHK
lin terminate_V = mkV "päättyä" ; --mkWV (k53A "päättää") ;
lin terminate_V2 = mkWV2 (k53A "päättää") ; --UNCHK
lin termination_N = mkWN (k39 "lopetus") ;
lin terminative_A = mkWA "päättyvä" ; --UNCHK
lin terminological_A = mkWA (k38 "terminologinen") ; --UNCHK
lin terminology_N = mkWN (k2 "sanasto") ; --UNCHK
lin terminus_N = mkWN (k10 "asema") ; --UNCHK
lin termite_N = mkWN (kH1 "termiitti") ; --UNCHK
lin terms_N = mkN "ehto" ;
lin tern_N = mkWN (k9 "tiira") ; --UNCHK
lin ternary_A = mkWA (compoundA "kolmi" (k38 "nkertainen")) ; --UNCHK
lin ternate_A = mkWA (compoundA "kolmi" (k38 "lehtinen")) ; --UNCHK
lin terpene_N = mkWN (k6 "terpeeni") ; --UNCHK
lin terpsichorean_A = mkWA (k38 "tanssillinen") ; --UNCHK
lin terra_cotta_N = mkWN "terra" "cotta" ; --UNCHK
lin terra_firma_N = mkWN (k18 "maa") "kuiva" ; --UNCHK
lin terra_incognita_N = mkWN (k18 "maa") "tuntematon" ; --UNCHK
lin terrace_N = mkWN (k5 "terassi") ; --UNCHK
lin terrace_V2 = mkWV2 (k53 "porrastaa") ; --UNCHK
lin terrain_N = mkWN (k1 "maasto") ; --UNCHK
lin terrapin_N = mkWN "maakilpikonna" ; --UNCHK
lin terrarium_N = mkWN (k3 "terraario") ; --UNCHK
lin terreplein_N = mkWN (compoundN "rinta" (k39 "varustus")) ; --UNCHK
lin terrestrial_A = mkWA (compoundA "maan" (k38 "päällinen")) ; --UNCHK
lin terrible_A = mkWA (k38 "hirmuinen") ; --UNCHK
lin terrier_N = mkWN (k5 "terrieri") ; --UNCHK
lin terrific_A = mkWA (k10 "pelottava") ; --UNCHK
lin terrify_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin terrine_N = mkWN (k6 "terriini") ; --UNCHK
lin territorial_A = mkWA (k38 "alueellinen") ; --UNCHK
lin territorial_N = mkWN (compoundN "territoriaali" (k12 "armeija")) ; --UNCHK
lin territoriality_N = mkWN (compoundN "reviiri" (k38 "käyttäytyminen")) ; --UNCHK
lin territorialization_N = mkWN "järjestäytyminen" ; --UNCHK
lin territory_N = mkWN (k48 "alue") ; --UNCHK
lin terror_N = mkWN (k6 "terrori") ; --UNCHK
lin terrorism_N = mkWN (k5 "terrorismi") ; --UNCHK
lin terrorist_N = mkWN (k5 "terroristi") ; --UNCHK
lin terrorization_N = mkWN (compoundN "terrori" (k1A "teko")) ; --UNCHK
lin terrorize_V2 = mkWV2 (k53A "pelottaa") ; --UNCHK
lin terry_N = mkWN (k20 "frotee") ; --UNCHK
lin terry_PN = foreignPN "Terry" ;
lin terse_A = mkWA (k15 "selkeä") ; --UNCHK
lin terseness_N = mkWN (k40 "ytimekkyys") ; --UNCHK
lin tertian_A = mkWA (compoundA "kolmi" (k38 "asteinen")) ; --UNCHK
lin tertiary_A = mkWA (k45 "kolmas") ; --UNCHK
lin tertigravida_N = mkWN (k38 "nainen") "raskaana" "oleva" ; --UNCHK
lin tervakoski_PN = mkPN (mkN "Tervakoski" "Tervakoskia") ;
lin tervo_PN = mkPN "Tervo" ;
lin tervola_PN = mkPN "Tervola" ;
lin terylene_N = mkWN "Terylene" ; --UNCHK
lin tesla_N = mkWN "Nikola" "Tesla" ; --UNCHK
lin tessella_N = mkWN (k5A "mosaiikki") ; --UNCHK
lin tessellated_A = mkWA (compoundA "pää" (k1 "llystetty")) "mosaiikilla" ; --UNCHK
lin tessellation_N = mkWN (k2 "koristelu") ; --UNCHK
lin tessera_N = mkWN (compoundN "mosaiikki" (k9A "laatta")) ; --UNCHK
lin tesseract_N = mkWN (compoundN "tesser" (k5 "akti")) ; --UNCHK
lin test_N = mkN "testi" ;
lin test_V2 = mkV2 "testata" ;
lin test_drive_N = mkWN (compoundN "koe" (k1 "ajo")) ; --UNCHK
lin test_drive_V2 = mkWV2 (compoundV "koe" (k56 "ajaa")) ; --UNCHK
lin test_tube_N = mkWN (compoundN "koe" (k7 "putki")) ; --UNCHK
lin testa_N = mkWN (k26 "siemenkuori") ; --UNCHK
lin testacean_N = mkWN (compoundN "kuore" (k38 "llinen")) ; --UNCHK
lin testaceous_A = mkWA (compoundA "kova" (k38 "kuorinen")) ; --UNCHK
lin testament_N = mkWN (k5A "testamentti") ; --UNCHK
lin testamentary_A = mkWA (k38 "mukainen") "testamentin" ; --UNCHK
lin testate_N = mkWN (k12 "tekijä") "testamentin" ; --UNCHK
lin testator_N = mkWN (k12 "tekijä") "testamentin" ; --UNCHK
lin testatrix_N = mkWN (k12 "tekijä") "testamentin" ; --UNCHK
lin testcross_N = mkWN (compoundN "risti" (k39 "siitos")) ; --UNCHK
lin testee_N = mkWN (k10 "kuulusteltava") ; --UNCHK
lin tester_N = mkWN (k39 "katos") ; --UNCHK
lin testicle_N = mkWN (k39 "kives") ; --UNCHK
lin testicular_A = mkWA "eturauhas-" ; --UNCHK
lin testifier_N = mkWN (k10 "todistaja") ; --UNCHK
lin testify_V = mkWV (k53 "todistaa") ; --UNCHK
lin testify_V2 = mkWV2 (k53 "todistaa") ; --UNCHK
lin testify_VS = mkWVS (k53 "todistaa") ; --UNCHK
lin testimonial_A = mkWA "todistus-" ; --UNCHK
lin testimonial_N = mkWN (k39 "todistus") ; --UNCHK
lin testimony_N = mkN "todistajanlausunto" ; --WN (k39 "todistus") ;
lin testiness_N = mkWN (k40 "ärtyisyys") ; --UNCHK
lin testing_N = mkWN (k5A "tentti") ; --UNCHK
lin testis_N = mkWN (k39 "kives") ; --UNCHK
lin testosterone_N = mkWN (k6 "testosteroni") ; --UNCHK
lin testudo_N = mkWN (k1A "suku") "maakilpikonnien" ; --UNCHK
lin testy_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin tetanus_N = mkWN (compoundN "jäykkä" (k39 "kouristus")) ; --UNCHK
lin tetany_N = mkWN (k2 "kouristelu") ; --UNCHK
lin tetartanopia_N = mkWN (compoundN "väri" (k40 "sokeus")) ; --UNCHK
lin tetchiness_N = mkWN (k40 "ärtyisyys") ; --UNCHK
lin tetchy_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin tete_a_tete_Adv = mkWAdv (k99 "kesken") "kahden" ; --UNCHK
lin tether_N = mkWN (k33A "talutin") ; --UNCHK
lin tether_V2 = mkV2 (mkV (mkV "panna") "liekaan") ;
lin tetherball_N = mkWN (compoundN "salko" (k1 "pallo")) ; --UNCHK
lin tetra_N = mkWN (k9 "tetra") ; --UNCHK
lin tetracaine_N = mkWN "tetrakaiini" ; --UNCHK
lin tetrachlorethylene_N = mkWN (compoundN "tetrakloori" (k5 "etyleeni")) ; --UNCHK
lin tetrachloride_N = mkWN "tetrakloridi" ; --UNCHK
lin tetracycline_N = mkWN (k5 "tetrasykliini") ; --UNCHK
lin tetrafluoroethylene_N = mkWN (compoundN "tetrafluori" (k5 "etyleeni")) ; --UNCHK
lin tetragonal_A = mkWA (compoundA "nelikul" (k38 "mainen")) ; --UNCHK
lin tetragram_N = mkWN "tetragrammi" ; --UNCHK
lin tetrahalide_N = mkWN "haloidi" ; --UNCHK
lin tetrahedron_N = mkWN (k5 "tetraedri") ; --UNCHK
lin tetrahydrocannabinol_N = mkWN "THC" ; --UNCHK
lin tetrahymena_N = mkWN "tetrahymena" ; --UNCHK
lin tetralogy_N = mkWN (k9 "sarja") "neliosainen" ; --UNCHK
lin tetramerous_A = mkWA (compoundA "neli" (k38 "osainen")) ; --UNCHK
lin tetrameter_N = mkWN (compoundN "tetra" (k5 "metri")) ; --UNCHK
lin tetrametric_A = mkWA (compoundA "neli" (k38 "polvinen")) ; --UNCHK
lin tetrapod_N = mkWN (compoundN "neli" (k38 "jalkainen")) ; --UNCHK
lin tetrasaccharide_N = mkWN (compoundN "tetra" (k5 "sakkaridi")) ; --UNCHK
lin tetraskelion_N = mkWN (compoundN "haka" (k5 "risti")) ; --UNCHK
lin tetrasporangium_N = mkWN (compoundN "itiö" (k48A "pesäke")) ; --UNCHK
lin tetraspore_N = mkWN (k3 "itiö") ; --UNCHK
lin tetravalent_A = mkWA (compoundA "neli" (k38 "tehoinen")) ; --UNCHK
lin tetri_N = mkWN "tetri" ; --UNCHK
lin tetrode_N = mkWN "tetri" ; --UNCHK
lin tetrodotoxin_N = mkWN (compoundN "tetrodo" (k5 "toksiini")) ; --UNCHK
lin tetrose_N = mkWN "tetroosi" ; --UNCHK
lin tetroxide_N = mkWN (compoundN "tetr" (k5 "oksidi")) ; --UNCHK
lin teuton_N = mkWN (k6 "teutoni") ; --UNCHK
lin teutonic_A = mkWA (k38 "germaaninen") ; --UNCHK
lin teuva_PN = mkPN "Teuva" ;
lin tewkesbury_PN = foreignPN "Tewkesbury" ;
lin texan_A = mkWA (k38 "teksasilainen") ; --UNCHK
lin texan_N = mkWN (k38 "texasilainen") ; --UNCHK
lin texas_PN = mkPN "Teksas" ;
lin text_N = mkWN (k5 "teksti") ;
lin textbook_N = mkWN (k9 "kirja") ; --UNCHK
lin textile_A = mkWA "lanka-" ; --UNCHK
lin textile_N = mkWN (k48A "vaate") ; --UNCHK
lin textual_A = mkWA (compoundA "tekstua" (k38 "alinen")) ; --UNCHK
lin texture_N = mkWN (k48A "rakenne") ; --UNCHK
lin textured_A = mkWA (compoundA "karkea" (k38 "rakenteinen")) ; --UNCHK
lin thaiFem_N = mkN "thaimaalainen" ;
lin thaiMasc_N = mkN "thaimaalainen" ;
lin thai_A = mkWA (k38 "siamilainen") ; --UNCHK
lin thailand_PN = mkPN "Thaimaa" ;
lin thalamocortical_A = mkWA (compoundA "talamokortika" (k38 "alinen")) ; --UNCHK
lin thalamus_N = mkWN (k39 "talamus") ; --UNCHK
lin thalassemia_N = mkWN "talassemia" ; --UNCHK
lin thalassic_A = mkWA (k38 "merellinen") ; --UNCHK
lin thalidomide_N = mkWN (k5 "talidomidi") ; --UNCHK
lin thallium_N = mkWN (k5 "tallium") ; --UNCHK
lin thalloid_A = mkWA "sekovartinen" ; --UNCHK
lin thallophyte_N = mkWN "sekovartinen" ; --UNCHK
lin thallophytic_A = mkWA "sekovartinen" ; --UNCHK
lin thallus_N = mkWN (compoundN "seko" (k28 "varsi")) ; --UNCHK
lin thalweg_N = mkWN (compoundN "ääri" (k9 "viiva")) ; --UNCHK
lin thame_PN = foreignPN "Thame" ;
lin than_Prep = prePrep nominative "kuin" ; ---
lin than_Subj = mkSubj "kuin" ;
lin thanatology_N = mkWN (k12 "tanatologia") ; --UNCHK
lin thanatophobia_N = mkWN (compoundN "kuoleman" (k1 "kammo")) ; --UNCHK
lin thanatopsis_N = mkWN (compoundN "kuoleman" (k39 "käsitys")) ; --UNCHK
lin thane_N = mkWN (compoundN "heimo" (k4A "päällikkö")) ; --UNCHK
lin thaneship_N = mkWN (k5 "vasalli") "kruunun" ; --UNCHK
lin thank_V2 = mkV2 "kiittää" partitive ;
lin thank_offering_N = mkWN (compoundN "kiitos" (k9 "lahja")) ; --UNCHK
lin thankful_A = mkWA (k38 "kiitollinen") ; --UNCHK
lin thankfulness_N = mkWN (k40 "huomaavaisuus") ; --UNCHK
lin thankless_A = mkWA (k34A "kiittämätön") ; --UNCHK
lin thanks_Interj = mkInterj "kiitos" ;
lin thanks_N = mkWN (k39 "kiitos") ;
lin thanks_to_Prep = mkPrep "ansiosta" ;
lin thanksgiving_N = mkWN (k39 "siunaus") "ruoan" ; --UNCHK
lin that_AdA = mkAdA "niin" ; --
lin that_Quant = S.that_Quant ;
lin that_Subj = S.that_Subj ;
lin thatch_N = mkWN (compoundN "olki" (k1A "katto")) ; --UNCHK
lin thatch_V2 = mkWV2 (k56A "kattaa") "oljilla" ; --UNCHK
lin thatcham_PN = foreignPN "Thatcham" ;
lin thatcher_N = mkWN (compoundN "olkikaton" (k12 "tekijä")) ; --UNCHK
lin thaumatolatry_N = mkWN (k39 "ihmetys") ; --UNCHK
lin thaw_N = mkWN (compoundN "suoja" (k18 "sää")) ; --UNCHK
lin thaw_V = mkWV (k53A "sulattaa") ; --UNCHK
lin thaw_V2 = mkWV2 (k53A "sulattaa") ; --UNCHK
lin the_hague_PN = mkPN "Haag" ;
lin theanthropism_N = mkWN (compoundN "tean" (k5 "tropismi")) ; --UNCHK
lin theatre_N = mkN "teatteri" ;
lin theatregoer_N = mkWN (k12 "kävijä") "teatterissa" ; --UNCHK
lin theatrical_A = mkWA (k38 "teatraalinen") ;
lin theatrical_N = mkWN (k39 "esitys") ; --UNCHK
lin thebe_N = mkWN "thebe" ; --UNCHK
lin theca_N = mkWN (k7A "tuppi") ; --UNCHK
lin thecodont_N = mkWN (k1 "hyppylisko") ; --UNCHK
lin theft_N = mkWN (k2 "varastelu") ; --UNCHK
lin theism_N = mkWN (k5 "teismi") ; --UNCHK
lin theist_A = mkWA (k38 "teistinen") ; --UNCHK
lin theist_N = mkWN (kH1 "teisti") ; --UNCHK
lin theistic_A = mkWA (k38 "teistinen") ; --UNCHK
lin theistical_A = mkWA (k38 "teistinen") ; --UNCHK
lin thelarche_N = mkWN "rintojen" "puhkeaminen" ; --UNCHK
lin thematic_A = mkWA (k38 "temaattinen") ; --UNCHK
lin theme_N = mkN "teema" ;
lin then_Adv = mkAdv "silloin" ; -- mkAdv "siinä tapauksessa"
lin then_N = mkWN (k99 "silloin") ; --UNCHK
lin then_Prep = mkPrep "sitten" nominative ; ---??
lin thenal_A = mkWA "lihasvallin" ; --UNCHK
lin thenar_N = mkWN (k12 "päkiä") ; --UNCHK
lin thenceforth_Adv = mkWAdv (k99 "jälkeen") "sen" ; --UNCHK
lin theocracy_N = mkWN (k12 "teokratia") ; --UNCHK
lin theocratic_A = mkWA (k38 "teokraattinen") ; --UNCHK
lin theodicy_N = mkWN (k10 "ongelma") "pahan" ; --UNCHK
lin theodolite_N = mkWN (k5A "teodoliitti") ; --UNCHK
lin theodore_PN = foreignPN "Theodore" ;
lin theogony_N = mkWN "teogonia" ; --UNCHK
lin theologian_N = mkWN (k5 "teologi") ; --UNCHK
lin theological_A = mkWA (k38 "teologinen") ; --UNCHK
lin theology_N = mkWN (k12 "teologia") ; --UNCHK
lin theophany_N = mkWN (k39 "ilmestys") ; --UNCHK
lin theophylline_N = mkWN (compoundN "astma" (k48A "lääke")) ; --UNCHK
lin theorem_N = mkWN (k9 "teoreema") ; --UNCHK
lin theoretic_A = mkWA (k38 "teoreettinen") ; --UNCHK
lin theoretical_A = mkWA (k38 "teoreettinen") ;
lin theoretician_N = mkWN (k12 "ideologia") ; --UNCHK
lin theorist_N = mkWN (k12 "ideologia") ; --UNCHK
lin theorization_N = mkWN (compoundN "teoreti" (k5A "sointi")) ; --UNCHK
lin theorize_V = mkWV (k62 "teoretisoida") ; --UNCHK
lin theorize_VS = mkWVS (k62 "teoretisoida") ; --UNCHK
lin theory_N = mkWN (k12 "teoria") ;
lin theosophical_A = mkWA (k38 "teosofinen") ; --UNCHK
lin theosophism_N = mkWN (k12 "teosofia") ; --UNCHK
lin theosophist_N = mkWN (k5 "teosofi") ; --UNCHK
lin theosophy_N = mkWN (k12 "teosofia") ; --UNCHK
lin theoterrorism_N = mkWN (compoundN "terrori" (k1A "teko")) "uskonnollinen" ; --UNCHK
lin therapeutic_A = mkWA (k38 "terapeuttinen") ; --UNCHK
lin therapeutical_A = mkWA (k38 "terapeuttinen") ; --UNCHK
lin therapeutics_N = mkWN (compoundN "hoito" (k48A "tiede")) ; --UNCHK
lin therapist_N = mkWN (k10 "parantaja") ; --UNCHK
lin therapsid_N = mkWN (compoundN "muinais" (k41A "nisäkäs")) ; --UNCHK
lin therapy_N = mkWN (k12 "terapia") ; --UNCHK
lin there7from_Adv = S.there7from_Adv ;
lin there7to_Adv = S.there7to_Adv ;
lin there_Adv = S.there_Adv ;
lin there_N = mkWN (k99 "siellä") ; --UNCHK
lin thereabout_Adv = mkWAdv (k99 "main") "niillä" ; --UNCHK
lin thereabouts_Adv = mkWAdv (k99 "main") "niillä" ; --UNCHK
lin thereafter_Adv = mkWAdv (k99 "jälkeen") "sen" ; --UNCHK
lin thereby_Adv = mkWAdv (k99 "siten") ; --UNCHK
lin therefor_Adv = mkWAdv (k99 "täten") ; --UNCHK
lin therefore_Adv = mkAdv "siksi" ;
lin therefore_PConj = S.therefore_PConj ;
lin therefrom_Adv = mkWAdv (k99 "sieltä") ; --UNCHK
lin therein_Adv = mkWAdv (k99 "täten") ; --UNCHK
lin thereinafter_Adv = mkWAdv (k99 "jäljempänä") ; --UNCHK
lin theremin_N = mkWN "theremin" ; --UNCHK
lin thereness_N = mkWN (compoundN "väli" (k9 "tila")) ; --UNCHK
lin thereof_Adv = mkAdv "siitä" ; ---??
lin thereon_Adv = mkWAdv (k99 "siinä") ; --UNCHK
lin theresa_PN = foreignPN "Theresa" ;
lin thereto_Adv = mkWAdv (k99 "siihen") ; --UNCHK
lin theretofore_Adv = mkWAdv (k99 "siksi") ; --UNCHK
lin thereunder_Adv = mkWAdv (k99 "mukaisesti") "sen" ; --UNCHK
lin therewith_Adv = mkWAdv (k99 "myöten") "sitä" ; --UNCHK
lin therewithal_Adv = mkWAdv (k99 "lisäksi") "sen" ; --UNCHK
lin therm_N = mkWN (compoundN "kilo" (k6 "kalori")) ; --UNCHK
lin thermal_A = mkWA "lämpö-" ; --UNCHK
lin thermal_N = mkWN (k5A "termiikki") ; --UNCHK
lin thermalgesia_N = mkWN "lämpöyliherkkyys" ; --UNCHK
lin thermion_N = mkWN (compoundN "term" (k5 "ioni")) ; --UNCHK
lin thermionic_A = mkWA "termionin" ; --UNCHK
lin thermionics_N = mkWN (compoundN "terminon" (k9A "iikka")) ; --UNCHK
lin thermistor_N = mkWN (k6 "termistori") ; --UNCHK
lin thermocautery_N = mkWN (compoundN "lämpö" (k39 "syövytys")) ; --UNCHK
lin thermochemistry_N = mkWN (compoundN "lämpö" (k12 "kemia")) ; --UNCHK
lin thermocoagulation_N = mkWN (compoundN "termo" (k3 "koagulaatio")) ; --UNCHK
lin thermocouple_N = mkWN (k5 "termopari") ; --UNCHK
lin thermodynamic_A = mkWA (compoundA "termo" (k38 "dynaaminen")) ; --UNCHK
lin thermodynamics_N = mkWN (compoundN "termo" (k9A "dynamiikka")) ; --UNCHK
lin thermoelectricity_N = mkWN (compoundN "lämpö" (k1 "sähkö")) ; --UNCHK
lin thermogram_N = mkWN "termogrammi" ; --UNCHK
lin thermograph_N = mkWN "termografi" ; --UNCHK
lin thermography_N = mkWN "termografia" ; --UNCHK
lin thermogravimetry_N = mkWN "termogravimetria" ; --UNCHK
lin thermohydrometer_N = mkWN "vesilämpömittari" ; --UNCHK
lin thermohydrometric_A = mkWA (compoundA "termogravi" (k38 "metrinen")) ; --UNCHK
lin thermojunction_N = mkWN (k5 "lämpöpari") ; --UNCHK
lin thermolabile_A = mkWA (compoundA "lämpö" (k5 "labiili")) ; --UNCHK
lin thermometer_N = mkWN (compoundN "kuume" (k6 "mittari")) ; --UNCHK
lin thermometric_A = mkWA "lämpötilan" ; --UNCHK
lin thermometry_N = mkWN (k39 "mittaus") "lämpötilan" ; --UNCHK
lin thermonuclear_A = mkWA "lämpöydin-" ; --UNCHK
lin thermoplastic_A = mkWA (compoundA "lämpö" (k38 "plastinen")) ; --UNCHK
lin thermoplastic_N = mkWN (k5 "muovi") "termoplastinen" ; --UNCHK
lin thermoreceptor_N = mkWN (compoundN "lämpö" (k5 "reseptori")) ; --UNCHK
lin thermos_N = mkWN (compoundN "termos" (k1 "pullo")) ; --UNCHK
lin thermosetting_A = mkWA "kuumassa" "kovettuva" ; --UNCHK
lin thermosphere_N = mkWN (compoundN "termos" (k5 "fääri")) ; --UNCHK
lin thermostat_N = mkWN (k5A "termostaatti") ; --UNCHK
lin thermostatic_A = mkWA (compoundA "termo" (k38 "staattinen")) ; --UNCHK
lin thermostatics_N = mkWN (compoundN "termo" (k9A "statistiikka")) ; --UNCHK
lin thermotherapy_N = mkWN (compoundN "lämpö" (k1A "hoito")) ; --UNCHK
lin thermotropism_N = mkWN (compoundN "lämpö" (k5 "tropismi")) ; --UNCHK
lin theropod_N = mkWN (compoundN "peto" (k39 "dinosaurus")) ; --UNCHK
lin thesaurus_N = mkWN (k39 "tesaurus") ; --UNCHK
lin thesis_N = mkWN (k10 "tutkielma") "tieteellinen" ; --UNCHK
lin thespian_A = mkWA (k38 "traaginen") ; --UNCHK
lin thespian_N = mkWN (k12 "näyttelijä") ; --UNCHK
lin theta_N = mkWN (k9 "theeta") ; --UNCHK
lin thetford_PN = foreignPN "Thetford" ;
lin theurgy_N = mkWN "teurgia" ; --UNCHK
lin theyFem_Pron = S.they_Pron ;
lin they_Pron = S.they_Pron ;
lin thiabendazole_N = mkWN "tiabendatsoli" ; --UNCHK
lin thiazide_N = mkWN (k5A "diureetti") ; --UNCHK
lin thiazine_N = mkWN (k5A "diureetti") ; --UNCHK
lin thick_A = L.thick_A ;
lin thick_Adv = mkWAdv (compoundAdv "perä" (k99 "jälkeen")) ; --UNCHK
lin thick_N = mkWN (k99 "keskellä") ; --UNCHK
lin thicken_V = mkWV (k52A "sakeutua") ; --UNCHK
lin thicken_V2 = mkWV2 (k52A "sakeutua") ; --UNCHK
lin thickening_N = mkWN (k39 "saostus") ; --UNCHK
lin thicket_N = mkWN (k4A "pöheikkö") ; --UNCHK
lin thickhead_N = mkWN (k10 "viheltäjä") ; --UNCHK
lin thickness_N = mkWN "sakeus" ; --UNCHK
lin thick_set_A = mkWA (compoundA "tiheä" (k38 "kasvuinen")) ; --UNCHK
lin thickspread_A = mkWA (k99 "paksulti") ; --UNCHK
lin thief_N = mkWN (k1 "rosvo") ; --UNCHK
lin thieve_V = mkWV (k61 "pölliä") ; --UNCHK
lin thieve_V2 = mkWV2 (k61 "pölliä") ; --UNCHK
lin thievery_N = mkWN (k2 "varastelu") ; --UNCHK
lin thievish_A = mkWA "varasteleva" ; --UNCHK
lin thievishness_N = mkWN (compoundN "epä" (k40 "rehellisyys")) ; --UNCHK
lin thigh_N = mkWN (k27 "reisi") ; --UNCHK
lin thighbone_N = mkWN (compoundN "reisi" (k39 "lihas")) ; --UNCHK
lin thill_N = mkWN (k9 "aisa") ; --UNCHK
lin thimble_N = mkWN (k33 "sormustin") ; --UNCHK
lin thimbleful_N = mkWN (k38 "sormustimellinen") ; --UNCHK
lin thimbleweed_N = mkWN (compoundN "sormustin" (k10A "kukka")) ; --UNCHK
lin thimerosal_N = mkWN (compoundN "tiomer" (k5 "saali")) ; --UNCHK
lin thin_A = L.thin_A ;
lin thin_Adv = mkWAdv "ohuena" ; --UNCHK
lin thin_V = mkWV (k53A "laihduttaa") ; --UNCHK
lin thin_V2 = mkWV2 (k53A "laihduttaa") ; --UNCHK
lin thing_N = mkN "asia" ;
lin thingumabob_N = mkWN (k33A "hilavitkutin") ; --UNCHK
lin thingumajig_N = mkWN (k33A "hilavitkutin") ; --UNCHK
lin thingummy_N = mkWN (k33A "hilavitkutin") ; --UNCHK
lin think_N = mkWN (k9A "pohdinta") ; --UNCHK
lin think_V = L.think_V ;
lin think_V2 = mkV2 (mkV "ajatella") partitive ;
lin think_VS = mkVS (mkV "ajatella") ;
lin think_over_V2 = mkWV2 (k61 "tuumia") ; --UNCHK
lin think_tank_N = mkWN (compoundN "aivo" (k23 "riihi")) ; --UNCHK
lin think_through_V2 = prepV2 OP_think_V OP_through_Prep ; -- guess-p-verb
lin think_up_V2 = mkWV2 (k53A "kehittää") ; --UNCHK
lin thinkable_A = mkWA (k38 "mahdollinen") ; --UNCHK
lin thinkerFem_N = mkWN (k12 "ajattelija") "luova" ; --UNCHK
lin thinkerMasc_N = mkWN (k12 "ajattelija") "luova" ; --UNCHK
lin thinking_A = variants {} ; --
lin thinking_N = mkWN (k2 "ajattelu") ;
lin thinness_N = mkWN (k40 "ohuus") ; --UNCHK
lin thiobacillus_N = mkWN "thiobacillus" ; --UNCHK
lin thiocyanate_N = mkWN (compoundN "tiosya" (k5A "naatti")) ; --UNCHK
lin thioguanine_N = mkWN (compoundN "tiogua" (k26 "niini")) ; --UNCHK
lin thionville_PN = foreignPN "Thionville" ;
lin thiopental_N = mkWN (compoundN "tiopentobarbituraatti" (k9 "suola")) ; --UNCHK
lin thioridazine_N = mkWN "Mellaril" ; --UNCHK
lin thiotepa_N = mkWN "thiotepa" ; --UNCHK
lin thiothixene_N = mkWN (compoundN "Nav" (k48 "ane")) ; --UNCHK
lin thiouracil_N = mkWN (k5 "tiourasiili") ; --UNCHK
lin thirdhand_A = mkWA "kolmannen" "käden" ; --UNCHK
lin thirdhand_Adv = mkWAdv "kolmannelta" "kädeltä" ; --UNCHK
lin thirsk_PN = foreignPN "Thirsk" ;
lin thirst_N = mkWN (k1 "himo") ; --UNCHK
lin thirsty_A = mkWA (k38 "janoinen") ; --UNCHK
lin this_Quant = S.this_Quant ;
lin thistle_N = mkWN (k48A "ohdake") ; --UNCHK
lin thistlelike_A = mkWA (compoundA "ohdake" (k38 "mainen")) ; --UNCHK
lin thither_Adv = mkWAdv (k99 "siihen") ; --UNCHK
lin thole_N = mkWN (k33 "hankain") ; --UNCHK
lin tholepin_N = mkWN (k33 "hankain") ; --UNCHK
lin thomas_PN = foreignPN "Thomas" ;
lin thong_N = mkWN (compoundN "varvas" (k6 "sandaali")) ; --UNCHK
lin thorax_N = mkWN (compoundN "keski" (k41 "ruumis")) ; --UNCHK
lin thoriated_A = mkWA (compoundA "hihitte" (k10 "levä")) ; --UNCHK
lin thorite_N = mkWN "toriitti" ; --UNCHK
lin thorium_N = mkWN (k5 "torium") ; --UNCHK
lin thorn_N = mkWN (k5A "piikki") ; --UNCHK
lin thornbill_N = mkWN "tiaismaluri" ; --UNCHK
lin thornbury_PN = foreignPN "Thornbury" ;
lin thornless_A = mkWA "piikitön" ; --UNCHK
lin thorny_A = mkWA (k38 "piikkinen") ; --UNCHK
lin thorough_A = mkWA (k38 "perusteellinen") ;
lin thoroughbred_A = mkWA (compoundA "täysi" (k38 "verinen")) ; --UNCHK
lin thoroughbred_N = mkWN (compoundN "puhdas" (k38 "verinen")) ; --UNCHK
lin thoroughfare_N = mkWN (compoundN "kulku" (k5A "reitti")) ; --UNCHK
lin thoroughgoing_A = mkWA (k38 "perusteellinen") ; --UNCHK
lin thoroughness_N = mkWN (k40 "perusteellisuus") ; --UNCHK
lin thortveitite_N = mkWN "thortveitiitti" ; --UNCHK
lin though_Adv = mkWAdv (k99 "kuitenkin") ;
lin though_Prep = mkPrep "vaikka" nominative ;
lin though_Subj = mkSubj "vaikka" ;
lin thought_N = mkN "ajatus" | mkN "ajattelu" ;
lin thoughtful_A = mkWA (k38 "huomaavainen") ; --UNCHK
lin thoughtfulness_N = mkWN (k40 "huomaavaisuus") ; --UNCHK
lin thoughtless_A = mkWA (compoundA "tyhjä" (k38 "npäiväinen")) ; --UNCHK
lin thoughtlessness_N = mkWN (k40 "ajattelemattomuus") ; --UNCHK
lin thraldom_N = mkWN (k40 "orjuus") ; --UNCHK
lin thrall_N = mkWN (k10 "orja") ; --UNCHK
lin thrash_N = mkWN "kroolipotkinta" ; --UNCHK
lin thrash_V = mkWV (k53A "rökittää") ; --UNCHK
lin thrash_V2 = mkWV2 (k53A "rökittää") ; --UNCHK
lin thrasher_N = mkWN (compoundN "matkija" (k1A "lintu")) ; --UNCHK
lin thrashing_N = mkWN (k39 "löylytys") ; --UNCHK
lin thread_N = mkWN (compoundN "ruuvi" (k48A "kierre")) ; --UNCHK
lin thread_V2 = mkWV2 (k53A "pujottaa") ; --UNCHK
lin threadbare_A = mkWA (k38 "tavallinen") ; --UNCHK
lin threadfin_N = mkWN "mullo" ; --UNCHK
lin threadfish_N = mkWN "Alectis" "ciliaris" ; --UNCHK
lin threadlike_A = mkWA (compoundA "rihma" (k38 "mainen")) ; --UNCHK
lin threat_N = mkN "uhka" ;
lin threaten_V = mkWV (k67 "uhkailla") ; --UNCHK
lin threaten_V2 = mkV2 "uhata" partitive ;
lin threaten_VS = mkWVS (k67 "uhkailla") ; --UNCHK
lin threaten_VV = mkVV "uhata" ;
lin threateningly_Adv = mkWAdv (k99 "uhkaavasti") ; --UNCHK
lin three_dimensional_A = mkA "kolmiulotteinen" ;
lin threefold_A = mkWA (k38 "kahdenlainen") ; --UNCHK
lin threefold_Adv = mkWAdv (k99 "kolminkertaisesti") ; --UNCHK
lin threepence_N = mkWN (compoundN "kolmi" (k38 "penninen")) ; --UNCHK
lin threepenny_A = mkWA (k34A "arvoton") ; --UNCHK
lin threesome_N = mkWN (k4A "kolmikko") ; --UNCHK
lin threnody_N = mkWN (compoundN "sielu" (k1 "messu")) ; --UNCHK
lin threonine_N = mkWN (compoundN "treo" (k26 "niini")) ; --UNCHK
lin thresh_V = mkWV (k54 "pieksää") ; --UNCHK
lin thresh_V2 = mkWV2 (k54 "pieksää") ; --UNCHK
lin thresher_N = mkWN (compoundN "matkija" (k1A "lintu")) ; --UNCHK
lin threshing_N = mkWN (k5A "puinti") ; --UNCHK
lin threshing_floor_N = mkWN (compoundN "puima" (k49A "tanner")) ; --UNCHK
lin threshing_machine_N = mkWN (compoundN "matkija" (k1A "lintu")) ; --UNCHK
lin threshold_N = mkWN (k39 "kynnys") ; --UNCHK
lin thrice_Adv = mkWAdv (k99 "kolmasti") ; --UNCHK
lin thrift_N = mkWN (k40 "säästäväisyys") ; --f202
lin thriftless_A = mkWA (k38 "tuhlaavainen") ; --UNCHK
lin thriftlessness_N = mkWN (compoundN "tuhlaa" (k40 "vaisuus")) ; --UNCHK
lin thriftshop_N = mkWN (k9A "kauppa") "käytettyjen" "tavaroiden" ; --UNCHK
lin thrifty_A = mkWA (k38 "säästäväinen") ; --UNCHK
lin thrill_N = mkWN "sävähdytys" ; --UNCHK
lin thrill_V = mkWV (k53A "värähtää") ; --UNCHK
lin thrill_V2 = mkWV2 (k53A "värähtää") ; --UNCHK
lin thriller_N = mkWN (k6 "trilleri") ; --UNCHK
lin thrillful_A = mkWA (k10 "jännittävä") ; --UNCHK
lin thrips_N = mkWN (k38 "ripsiäinen") ; --UNCHK
lin thrive_V = mkWV (k53 "kukoistaa") ; --UNCHK
lin throat_N = mkN "kurkku" ;
lin throated_A = mkWA (compoundA "kau" (k38 "lainen")) ; --UNCHK
lin throatwort_N = mkWN (compoundN "varsan" (k1 "kello")) ; --UNCHK
lin throaty_A = mkWA (k15 "käheä") ; --UNCHK
lin throb_N = mkWN (k9A "sykintä") ; --UNCHK
lin throb_V = mkWV (k61A "sykkiä") ; --UNCHK
lin throbbing_N = mkWN (k39 "jyskytys") ; --UNCHK
lin throe_N = mkWN (k39 "kouristus") ; --UNCHK
lin thrombasthenia_N = mkWN (compoundN "verenvuoto" (k5A "tauti")) ; --UNCHK
lin thrombectomy_N = mkWN (compoundN "poisto" (k39 "leikkaus")) "verisuonitukoksen" ; --UNCHK
lin thrombin_N = mkWN "trombiini" ; --UNCHK
lin thrombocytopenia_N = mkWN "trombosytopenia" ; --UNCHK
lin thrombocytosis_N = mkWN "trombosytoosi" ; --UNCHK
lin thromboembolism_N = mkWN (compoundN "verisuoni" (k39 "tukos")) ; --UNCHK
lin thrombolysis_N = mkWN (compoundN "liuotus" (k1A "hoito")) ; --UNCHK
lin thrombolytic_N = mkWN (k33A "liuotin") ; --UNCHK
lin thrombophlebitis_N = mkWN (compoundN "laskimontukko" (k39 "tulehdus")) ; --UNCHK
lin thromboplastin_N = mkWN (compoundN "trombokin" (k5 "aasi")) ; --UNCHK
lin thrombosed_A = mkWA "tukkeutunut" ; --UNCHK
lin thrombosis_N = mkWN (compoundN "veri" (k10A "tulppa")) ; --UNCHK
lin thrombus_N = mkWN (k10 "tukkeuma") ; --UNCHK
lin throne_N = mkWN (compoundN "valta" (k33 "istuin")) ; --UNCHK
lin throng_N = mkWN (k1A "joukko") ; --UNCHK
lin throng_V = mkWV (k58A "tunkea") ; --UNCHK
lin throng_V2 = mkWV2 (k58A "tunkea") ; --UNCHK
lin throstle_N = mkWN (compoundN "laulu" (k41 "rastas")) ; --UNCHK
lin throttle_N = mkWN (k6 "venttiili") "kaasuttimen" ; --UNCHK
lin throttle_V = mkWV (k53 "kuristaa") ; --UNCHK
lin throttle_V2 = mkWV2 (k53 "kuristaa") ; --UNCHK
lin throttle_valve_N = mkWN (k6 "venttiili") "kaasuttimen" ; --UNCHK
lin through_Adv = mkAdv "läpi" ;
lin through_Prep = S.through_Prep ;
lin throughout_Adv = mkWAdv (k99 "loppuun") "alusta" ; --UNCHK
lin throughout_Prep = mkPrep "läpi koko" genitive ;
lin throughput_N = mkWN (compoundN "lähetys" (k40 "nopeus")) ; --UNCHK
lin throughway_N = mkWN (compoundN "valta" (k19 "tie")) ; --UNCHK
lin throw_N = mkWN (k1A "heitto") ; --UNCHK
lin throw_V = mkV "heittää" ;
lin throw_V2 = L.throw_V2 ;
lin throw_VS = mkWVS (k53A "hämmästyttää") ; --UNCHK
lin throw_away_V2 = mkWV2 (k52A "hankkiutua") "eroon" ; --UNCHK
lin throw_in_V = mkWV (k73 "lisätä") "väliin" ; --UNCHK
lin throw_in_V2 = mkWV2 (k73 "lisätä") "väliin" ; --UNCHK
lin throw_off_V = mkWV (k52A "hankkiutua") "eroon" ; --UNCHK
lin throw_off_V2 = mkWV2 (k52A "hankkiutua") "eroon" ; --UNCHK
lin throw_on_V2 = prepV2 OP_throw_V OP_on_Prep ; -- guess-p-verb
lin throw_out_V2 = mkWV2 (k53A "jättää") "käsittelemättä" ; --UNCHK
lin throw_over_V2 = prepV2 OP_throw_V OP_over_Prep ; -- guess-p-verb
lin throw_together_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin throw_up_V = mkWV (k53A "heittää") "laattaa" ; --UNCHK
lin throw_up_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin throw_yourself_at_V2 = variants {} ; -- guess-p-verb
lin throw_yourself_into_V2 = variants {} ; -- guess-p-verb
lin throwaway_N = mkWN (k1A "heitto") ; --UNCHK
lin throwback_N = mkWN (k10 "takauma") ; --UNCHK
lin thrower_N = mkWN (k4A "keraamikko") ; --UNCHK
lin throwster_N = mkWN (k10 "kehrääjä") ; --UNCHK
lin thrum_N = mkWN (kH1 "kumina") ; --UNCHK
lin thrum_V = mkWV (k53A "paukuttaa") ; --UNCHK
lin thrum_V2 = mkWV2 (k53A "paukuttaa") ; --UNCHK
lin thrush_N = mkWN (k41 "rastas") ; --UNCHK
lin thrust_N = mkWN (compoundN "työntö" (k10 "voima")) ;
lin thrust_V = mkWV (k53A "tyrkyttää") ; --UNCHK
lin thrust_V2 = mkWV2 (k53A "tyrkyttää") ; --UNCHK
lin thrusterFem_N = mkWN (compoundN "raketti" (k6 "moottori")) ; --UNCHK
lin thrusterMasc_N = mkWN (compoundN "raketti" (k6 "moottori")) ; --UNCHK
lin thud_N = mkWN (k39 "mätkähdys") ; --UNCHK
lin thud_V = mkWV (k53A "mätkähtää") ; --UNCHK
lin thug_N = mkWN (k1 "rosvo") ; --UNCHK
lin thuggee_N = mkWN (compoundN "ryöstö" (k10 "murha")) ; --UNCHK
lin thuggery_N = mkWN (k5A "mukilointi") ; --UNCHK
lin thulium_N = mkWN "alkuainenumero" "69" ; --UNCHK
lin thumb_N = mkN "peukalo" ; --mkWN (compoundN "pyörö" (k9 "lista")) ;
lin thumb_V2 = mkWV2 (k67 "hivellä") ; --UNCHK
lin thumbhole_N = mkWN (compoundN "peukalon" (k10A "reikä")) ; --UNCHK
lin thumbnail_N = mkWN (compoundN "peukalon" (k28 "kynsi")) ; --UNCHK
lin thumbnut_N = mkWN (compoundN "siipi" (k12 "pähkinä")) ; --UNCHK
lin thumbprint_N = mkWN (compoundN "peukalon" (k7A "jälki")) ; --UNCHK
lin thumbscrew_N = mkWN (compoundN "peukalo" (k5 "ruuvi")) ; --UNCHK
lin thumbstall_N = mkWN (k10 "peukalosuoja") ; --UNCHK
lin thumbtack_N = mkWN (k9 "nasta") ; --UNCHK
lin thump_N = mkWN (kH1 "kumina") ; --UNCHK
lin thump_V = mkWV (k53A "tömäyttää") ; --UNCHK
lin thump_V2 = mkWV2 (k53A "tömäyttää") ; --UNCHK
lin thunder_N = mkWN (k8 "polle") ; --UNCHK
lin thunder_V = mkWV (k73 "pauhata") ; --UNCHK
lin thunder_V2 = mkWV2 (k73 "pauhata") ; --UNCHK
lin thunderbird_N = mkWN (compoundN "ukkos" (k1A "lintu")) ; --UNCHK
lin thunderbolt_N = mkWN (kH1 "pommi") ; --UNCHK
lin thunderclap_N = mkWN (kH1 "pommi") ; --UNCHK
lin thunderer_N = mkWN "jymistäjä" ; --UNCHK
lin thunderhead_N = mkWN (compoundN "kumpu" (k7 "pilvi")) "vallinharjamainen" ; --UNCHK
lin thunderous_A = mkWA "myrskyä" "ennustava" ; --UNCHK
lin thundershower_N = mkWN (k1 "ukkoskuuro") ; --UNCHK
lin thunderstorm_N = mkWN (k38 "ukkonen") ; --UNCHK
lin thunderstruck_A = mkWA (k99 "pökerryksissä") ; --UNCHK
lin thundery_A = mkWA (compoundA "jyris" (k10 "evä")) ; --UNCHK
lin thunk_N = mkWN (k39 "tömähdys") ; --UNCHK
lin thurible_N = mkWN (compoundN "suitsutus" (k12 "astia")) ; --UNCHK
lin thurifer_N = mkWN "suitsuttaja" ; --UNCHK
lin thurso_PN = foreignPN "Thurso" ;
lin thus_Adv = mkAdv "siten" ;
lin thwack_N = mkWN "kolautus" ; --UNCHK
lin thwack_V2 = mkWV2 (k53A "läimäyttää") ; --UNCHK
lin thwart_N = mkWN (k1A "tuhto") ; --UNCHK
lin thwart_V2 = mkWV2 (k53A "pysäyttää") ; --UNCHK
lin thylacine_N = mkWN (k6 "tiikeri") "Tasmanian" ; --UNCHK
lin thyme_N = mkWN (k6 "timjami") ; --UNCHK
lin thymine_N = mkWN "T" ; --UNCHK
lin thymol_N = mkWN (compoundN "timjami" (k6 "kamferi")) ; --UNCHK
lin thymosin_N = mkWN "tymosiini" ; --UNCHK
lin thyroglobulin_N = mkWN "tyreoglobuliini" ; --UNCHK
lin thyroid_A = mkWA "kilpirauhas-" ; --UNCHK
lin thyroid_N = mkWN (compoundN "kilpi" (k38 "rauhanen")) ; --UNCHK
lin thyroidectomy_N = mkWN (compoundN "kilpirauhas" (k39 "leikkaus")) ; --UNCHK
lin thyroiditis_N = mkWN (compoundN "kilpirauhas" (k39 "tulehdus")) ; --UNCHK
lin thyronine_N = mkWN (compoundN "tyro" (k26 "niini")) ; --UNCHK
lin thyroprotein_N = mkWN (compoundN "tyro" (k5 "proteiini")) ; --UNCHK
lin thyrotoxic_A = mkWA "kilpirauhasen" "liikatoiminnan" ; --UNCHK
lin thyrotropin_N = mkWN (compoundN "kilpirauhas" (k5 "hormoni")) ; --UNCHK
lin thyroxine_N = mkWN (compoundN "kilpirauhas" (k5 "hormoni")) ; --UNCHK
lin thyrse_N = mkWN (compoundN "kukka" (k41A "ryväs")) ; --UNCHK
lin thyrsopteris_N = mkWN (compoundN "havu" (k18 "puu")) ; --UNCHK
lin thysanopter_N = mkWN (k38 "hyönteinen") ; --UNCHK
lin ti_N = mkWN "si" ; --UNCHK
lin tiara_N = mkWN (k9 "tiaara") ; --UNCHK
lin tibetan_A = mkWA (k38 "tiibetiläinen") ; --UNCHK
lin tibia_N = mkWN (compoundN "sääri" (k18 "luu")) ; --UNCHK
lin tibial_A = mkWA "sääriluun" ; --UNCHK
lin tibialis_N = mkWN (compoundN "sääri" (k39 "lihas")) ; --UNCHK
lin tic_N = mkWN (compoundN "elo" (k24 "hiiri")) ; --UNCHK
lin tick_N = mkWN (kH1 "punkki") ; --UNCHK
lin tick_V = mkWV (k69 "merkitä") "rastilla" ; --UNCHK
lin tick_V2 = mkWV2 (k69 "merkitä") "rastilla" ; --UNCHK
lin tick_off_V = mkWV (k69 "merkitä") "rastilla" ; --UNCHK
lin tick_off_V2 = mkWV2 (k69 "merkitä") "rastilla" ; --UNCHK
lin tick_over_V = mkWV (k67 "olla") "joutokäynnillä" ; --UNCHK
lin ticker_N = mkWN (compoundN "tarra" (k33A "kirjoitin")) ; --UNCHK
lin ticker_tape_N = mkWN (compoundN "tarra" (k5A "teippi")) ; --UNCHK
lin ticket_N = mkN "lippu" ;
lin ticket_V2 = mkWV2 (k63 "myydä") "pääsylippuja" ; --UNCHK
lin ticket_collector_N = mkWN (compoundN "lipun" (k10 "tarkastaja")) ; --UNCHK
lin ticking_N = mkWN (k41A "tikkikangas") ; --UNCHK
lin tickle_N = mkWN (compoundN "kuti" (k38 "ttaminen")) ; --UNCHK
lin tickle_V = mkWV (k67A "kutitella") ; --UNCHK
lin tickle_V2 = mkWV2 (k67A "kutitella") ; --UNCHK
lin tickler_N = mkWN (k3 "muistio") ; --UNCHK
lin ticklish_A = mkWA (k10 "kiperä") ; --UNCHK
lin ticktack_N = mkWN (compoundN "käsi" (k5A "merkki")) ; --UNCHK
lin ticktacktoe_N = mkWN (compoundN "jätkän" (k5A "sakki")) ; --UNCHK
lin tick_tock_N = mkWN "tikitys" ; --UNCHK
lin tidal_A = mkWA "vuorovesi-" ; --UNCHK
lin tidbit_N = mkWN (compoundN "herkku" (k9 "pala")) ; --UNCHK
lin tiddler_N = mkWN (k38 "nuorukainen") ; --UNCHK
lin tiddlywinks_N = mkWN (compoundN "kirppu" (k5 "peli")) ; --UNCHK
lin tide_N = mkN "vuoro" L.water_N ;
lin tide_V2 = mkWV2 (k73A "virrata") ; --UNCHK
lin tideland_N = mkWN (compoundN "vuorovesi" (k48 "alue")) ; --UNCHK
lin tidemark_N = mkWN (compoundN "vuorovesi" (k5A "merkki")) ; --UNCHK
lin tidewater_N = mkWN (k48 "alue") "Tidewaterin" ; --UNCHK
lin tideway_N = mkWN (k10 "kanava") ; --UNCHK
lin tidiness_N = mkWN (k40 "siisteys") ; --UNCHK
lin tidworth_PN = foreignPN "Tidworth" ;
lin tidy_A = mkWA (k5 "siisti") ; --UNCHK
lin tidy_N = mkWN (compoundN "säilytys" (k4A "laatikko")) ; --UNCHK
lin tidy_V = mkWV (k53 "järjestää") ; --UNCHK
lin tidy_V2 = mkWV2 (k53 "järjestää") ; --UNCHK
lin tidy_up_V2 = mkWV2 (k53 "järjestää") ; --UNCHK
lin tidytips_N = mkWN (compoundN "kullankaivajan" (k10A "kukka")) ; --UNCHK
lin tie_N = mkN "tasa" (mkN "peli") ; --f54 ---ARB ; solmio ; kahle
lin tie_V = mkWV (k61 "solmia") ; --UNCHK
lin tie_V2 = L.tie_V2 ;
lin tie_back_V2 = mkV2 (advV OP_tie_V OP_back_Adv ) ; -- guess-p-verb
lin tie_down_V2 = mkWV2 (k52A "sitoutua") ; --UNCHK
lin tie_in_V = mkWV (k62 "assosioida") ; --UNCHK
lin tie_in_V2 = mkWV2 (k62 "assosioida") ; --UNCHK
lin tie_in_with_V2 = prepV2 (advV OP_tie_V OP_in_Adv ) OP_with_Prep ; -- guess-p-verb
lin tie_up_V2 = mkWV2 (k62 "silmukoida") ; --UNCHK
lin tiebreaker_N = mkWN (k9A "lisäaika") ; --UNCHK
lin tier_N = mkWN (k39 "kerros") ; --UNCHK
lin tiercel_N = mkWN (compoundN "koiras" (k9A "haukka")) ; --UNCHK
lin tiered_A = mkWA (compoundA "pino" (k1 "ttu")) ; --UNCHK
lin tiff_N = mkWN (k13 "kahina") ; --UNCHK
lin tiger_N = mkWN (k6 "tiikeri") ; --UNCHK
lin tiger_lily_N = mkWN (k9 "lilja") ; --UNCHK
lin tigerish_A = mkWA (compoundA "tii" (k38 "kerimäinen")) ; --UNCHK
lin tight_A = mkA "tiukka" ;
lin tight_Adv = mkWAdv (k99 "lujasti") ;
lin tight_lipped_A = mkA (mkN "vähä" (mkN "sanainen")) ;
lin tighten_V = mkWV (k53 "kiristää") ; --UNCHK
lin tighten_V2 = mkWV2 (k53 "kiristää") ;
lin tighten_up_V2 = mkWV2 (k53 "kiristää") ; --UNCHK
lin tightening_N = mkWN (compoundN "kiri" (k38 "stäminen")) ; --UNCHK
lin tightness_N = mkWN (k40 "kireys") ; --UNCHK
lin tightrope_N = mkWN (k10 "nuora") ; --UNCHK
lin tiglon_N = mkWN (compoundN "tii" (k5 "koni")) ; --UNCHK
lin tigress_N = mkWN (compoundN "naaras" (k6 "tiikeri")) ; --UNCHK
lin tike_N = mkWN (k38 "nuorukainen") ; --UNCHK
lin tilburg_PN = foreignPN "Tilburg" ;
lin tilbury_PN = foreignPN "Tilbury" ;
lin tilde_N = mkWN (k8 "tilde") ; --UNCHK
lin tile_N = mkWN (k9A "laatta") ;
lin tile_V2 = mkWV2 (k53A "laatoittaa") ; --UNCHK
lin tilefish_N = mkWN (compoundN "juovatorpedo" (k32 "ahven")) ; --UNCHK
lin tiler_N = mkWN (k6 "muurari") ; --UNCHK
lin tiling_N = mkWN (compoundN "muu" (k38 "raaminen")) ; --UNCHK
lin till_N = mkWN (k9 "kassa") ; --UNCHK
lin till_Prep = variants {} ; --
lin till_Subj = mkSubj "kunnes" ; --
lin till_V2 = mkWV2 (k53A "kyntää") ; --UNCHK
lin tillage_N = mkWN (compoundN "maan" (k39 "muokkaus")) ; --UNCHK
lin tiller_N = mkWN (k9 "hara") ; --UNCHK
lin tilling_N = mkWN (compoundN "maan" (k39 "muokkaus")) ; --UNCHK
lin tilt_N = mkWN (k39 "kallistus") ; --UNCHK
lin tilt_V = mkWV (k67 "taistella") ; --UNCHK
lin tilt_V2 = mkWV2 (k67 "taistella") ; --UNCHK
lin tilter_N = mkWN (k33A "suodatin") ; --UNCHK
lin tilth_N = mkWN (compoundN "viljelys" (k18 "maa")) ; --UNCHK
lin tiltyard_N = mkWN (compoundN "turnajais" (k10A "kenttä")) ; --UNCHK
lin tim_PN = foreignPN "Tim" ;
lin timbale_N = mkWN (k6 "timbaali") ; --UNCHK
lin timber_N = mkWN (k28 "hirsi") ; --UNCHK
lin timbered_A = mkWA "laudoitettu" ; --UNCHK
lin timberman_N = mkWN (compoundN "metsän" (k10 "omistaja")) ; --UNCHK
lin timbre_N = mkWN (k26 "ääni") ; --UNCHK
lin timbrel_N = mkWN (k5 "tamburiini") ; --UNCHK
lin time_1_N = mkN "aika" "ajan" "aikoja" ;
lin time_2_N = mkN "kerta" ;
lin time_N = mkN "aika" "ajan" "aikoja" ;
lin time_V2 = mkWV2 (k53A "ajoittaa") ;
lin time_bomb_N = mkWN (k5 "aikapommi") ; --UNCHK
lin time_exposure_N = mkWN (compoundN "aika" (k39 "valotus")) ; --UNCHK
lin time_lag_N = mkWN (k39 "viivästys") ; --UNCHK
lin time_limit_N = mkWN (k9A "määräaika") ; --UNCHK
lin time_sheet_N = mkWN (compoundN "työ" (k9 "lista")) ; --UNCHK
lin time_signal_N = mkWN (compoundN "aika" (k5A "merkki")) ; --UNCHK
lin timecard_N = mkWN (compoundN "kello" (k5A "kortti")) ; --UNCHK
lin timekeeper_N = mkWN (k1 "kello") ; --UNCHK
lin timekeeping_N = mkWN "ajanottaminen" ; --UNCHK
lin timeless_A = mkWA (k34A "ajaton") ; --UNCHK
lin timeline_N = mkWN (compoundN "aika" (k9 "jana")) ; --UNCHK
lin timeliness_N = mkWN (k40 "sattuvuus") ; --UNCHK
lin timely_A = mkWA (compoundA "oikea-" (k38 "aikainen")) ;
lin timepiece_N = mkWN (k1 "kello") ; --UNCHK
lin timer_N = mkWN (k33 "ajastin") ; --UNCHK
lin times_N = mkWN (compoundN "kerto" (k1 "lasku")) ; --UNCHK
lin times_Prep = mkPrep "kertaa" nominative ;
lin timeserver_N = mkWN (compoundN "myötä" (k12 "juoksija")) ; --UNCHK
lin timeserving_A = mkWA (k38 "opportunistinen") ; --UNCHK
lin timetable_N = mkWN (compoundN "aika" (k1 "taulu")) ; --UNCHK
lin timework_N = mkWN (compoundN "tunti" (k19 "työ")) ; --UNCHK
lin timid_A = mkWA (k41A "pelokas") ; --UNCHK
lin timidity_N = mkWN (k40 "pelokkuus") ; --UNCHK
lin timidness_N = mkWN (k40 "pelokkuus") ; --UNCHK
lin timing_N = mkN (lin NK {s = d39 "ajoitus"}) ;
lin timolol_N = mkWN "timololi" ; --UNCHK
lin timorous_A = mkWA (k9A "arka") ; --UNCHK
lin timothy_N = mkWN (k18 "timotei") ; --UNCHK
lin timpanist_N = mkWN (k6 "rumpali") ; --UNCHK
lin timucu_N = mkWN (compoundN "neula" (k9 "kala")) "Atlantin" ; --UNCHK
lin tin_N = mkWN (k5A "tölkki") ; --UNCHK
lin tin_V2 = mkWV2 (k73 "tinata") ; --UNCHK
lin tin_opener_N = mkWN (compoundN "purkin" (k10 "avaaja")) ; --UNCHK
lin tin_plate_N = mkWN (k39 "tinaus") ; --UNCHK
lin tinamou_N = mkWN (compoundN "pelto" (k18 "pyy")) ; --UNCHK
lin tincture_N = mkWN (k13 "tinktuura") ; --UNCHK
lin tincture_V2 = mkWV2 (k73 "värjätä") ; --UNCHK
lin tinder_N = mkWN (k9 "taula") ; --UNCHK
lin tine_N = mkWN (k5A "piikki") ; --UNCHK
lin tinea_N = mkWN (compoundN "Tinea-" (k5 "laji")) ; --UNCHK
lin tined_A = mkWA (k38 "piikkinen") ; --UNCHK
lin tineid_N = mkWN (k18 "vaatekoi") ; --UNCHK
lin tineoid_N = mkWN (k18 "vaatekoi") ; --UNCHK
lin tinfoil_N = mkWN (compoundN "tina" (k3 "folio")) ; --UNCHK
lin ting_N = mkWN (k39 "helähdys") ; --UNCHK
lin ting_V = mkWV (k53A "helähtää") ; --UNCHK
lin ting_V2 = mkWV2 (k53A "helähtää") ; --UNCHK
lin tinge_N = mkWN (k1 "sävy") ; --UNCHK
lin tinge_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin tingle_N = mkWN (k48A "polte") ; --UNCHK
lin tingle_V = mkWV (k67 "pistellä") ; --UNCHK
lin tinker_N = mkWN (compoundN "japanin" (k5 "makrilli")) ; --UNCHK
lin tinker_V = mkWV (k67 "korjailla") ; --UNCHK
lin tinkerer_N = mkWN "tinuri" ; --UNCHK
lin tinkle_N = mkWN (k39 "helähdys") ; --UNCHK
lin tinkle_V = mkWV (k53A "kilahtaa") ; --UNCHK
lin tinkle_V2 = mkWV2 (k53A "kilahtaa") ; --UNCHK
lin tinning_N = mkWN (compoundN "tina" (k38 "aminen")) ; --UNCHK
lin tinnitus_N = mkWN "tinnitus" ; --UNCHK
lin tinny_A = mkWA (k15 "kimeä") ; --UNCHK
lin tinsel_N = mkWN (compoundN "tina" (k9 "nauha")) ; --UNCHK
lin tinselly_A = mkWA (k10 "kiiltävä") ; --UNCHK
lin tinsmith_N = mkWN "tinuri" ; --UNCHK
lin tint_N = mkWN (k48A "vivahde") ; --UNCHK
lin tint_V2 = mkWV2 (k53A "värittää") ; --UNCHK
lin tintack_N = mkWN (k5 "nupi") ; --UNCHK
lin tinter_N = mkWN (k10 "kampaaja") ; --UNCHK
lin tinting_N = mkWN (k39 "värjäys") ; --UNCHK
lin tintinnabulation_N = mkWN (k12 "kilinä") ; --UNCHK
lin tiny_A = mkA "pikkuruinen" ;
lin tip_N = mkN "kärki" ;
lin tip_V = mkWV (k73 "sysätä") ; --UNCHK
lin tip_V2 = mkWV2 (k73 "sysätä") ; --UNCHK
lin tip_off_V2 = mkWV2 (k56A "antaa") "vihje" ; --UNCHK
lin tip_over_V2 = mkWV2 (k53A "kellahtaa") "kumoon" ; --UNCHK
lin tipper_N = mkWN (compoundN "kuorma-" (k1 "auto")) "kääntyvälavainen" ; --UNCHK
lin tipperary_PN = foreignPN "Tipperary" ;
lin tippet_N = mkWN (compoundN "turkis" (k10 "stoola")) ; --UNCHK
lin tipple_N = mkWN "hana-" ; --UNCHK
lin tipple_V = mkWV (k67A "tissutella") ; --UNCHK
lin tipple_V2 = mkWV2 (k67A "tissutella") ; --UNCHK
lin tippler_N = mkWN "lipittelijä" ; --UNCHK
lin tipstaff_N = mkWN "tipstaff" ; --UNCHK
lin tipster_N = mkWN (compoundN "vinkin" (k10 "antaja")) ; --UNCHK
lin tipsy_A = mkWA (k99 "juovuksissa") ; --UNCHK
lin tiptoe_A = mkWA (k10 "hiipivä") ; --UNCHK
lin tiptoe_Adv = mkWAdv (k99 "varpaisillaan") ; --UNCHK
lin tiptoe_N = mkWN (compoundN "varpaan" (k7A "kärki")) ; --UNCHK
lin tiptoe_V = mkWV (k61A "hiipiä") "varpaisillaan" ; --UNCHK
lin tiptop_N = mkWN (k1A "huippu") ; --UNCHK
lin tipu_N = mkWN (k40 "ylpeys") "Bolivian" ; --UNCHK
lin tirade_N = mkWN (k9 "saarna") ; --UNCHK
lin tiramisu_N = mkWN (compoundN "tira" (k1 "misu")) ; --UNCHK
lin tire_N = mkWN (k41A "rengas") ; --UNCHK
lin tire_V = mkWV (k52A "uupua") ; --UNCHK
lin tire_V2 = mkV2 "uuvuttaa" ; --mkWV2 (k52A "uupua") ;
lin tire_out_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin tired_A = mkA "väsynyt" ;
lin tiredness_N = mkWN (k39 "väsymys") ; --UNCHK
lin tireless_A = mkWA (k34A "uupumaton") ; --UNCHK
lin tiresome_A = mkWA (k10 "rasittava") ; --UNCHK
lin tiro_N = mkWN (k10 "aloittaja") ; --UNCHK
lin tisane_N = mkWN (compoundN "yrtti" (k10 "juoma")) ; --UNCHK
lin tissue_N = mkWN (k39 "kudos") ; --UNCHK
lin tit_N = mkWN (k5A "tintti") ; --UNCHK
lin titan_N = mkWN "Titan" ; --UNCHK
lin titanic_A = mkWA (compoundA "alkuvoi" (k38 "mainen")) ; --UNCHK
lin titanium_N = mkWN (k6 "titaani") ; --UNCHK
lin titanosaur_N = mkWN "titanosaurus" ; --UNCHK
lin titbit_N = mkWN (compoundN "herkku" (k9 "pala")) ; --UNCHK
lin titer_N = mkWN (k39 "titraus") ; --UNCHK
lin titfer_N = mkWN (k1A "hattu") ; --UNCHK
lin tithe_barn_N = mkWN (k1A "lato") ; --UNCHK
lin tither_N = mkWN (k10 "maksaja") "kymmenysten" ; --UNCHK
lin titi_N = mkWN (compoundN "titi-" (k12 "apina")) ; --UNCHK
lin titillate_V2 = mkWV2 (k53A "kiihottaa") ; --UNCHK
lin titillating_A = mkWA "kutkuttava" ; --UNCHK
lin titillation_N = mkWN (compoundN "kuti" (k38 "ttaminen")) ; --UNCHK
lin titivate_V = mkWV (k73 "tällätä") ; --UNCHK
lin titivate_V2 = mkWV2 (k73 "tällätä") ; --UNCHK
lin titivation_N = mkWN "pynttääminen" ; --UNCHK
lin titlark_N = mkWN (k38 "kirvinen") ; --UNCHK
lin title_N = mkN "titteli" ;
lin title_V3 = mkV3 (mkV "nimittää") accusative (mkPrep translative) ; --mkWV3 (k61A "luonnehtia") ;
lin title_deed_N = mkWN (compoundN "omistus" (k39 "todistus")) ; --UNCHK
lin title_page_N = mkWN (compoundN "nimiö" (k1 "sivu")) ; --UNCHK
lin title_role_N = mkWN (compoundN "nimi" (k5 "rooli")) ; --UNCHK
lin titled_A = mkWA (k38 "aatelinen") ; --UNCHK
lin titmouse_N = mkWN (k5A "tintti") ; --UNCHK
lin titration_N = mkWN (k39 "titraus") ; --UNCHK
lin titrator_N = mkWN (compoundN "mitta" (k48A "laite")) ; --UNCHK
lin titter_N = mkWN (k39 "hihitys") ; --UNCHK
lin titter_V = mkWV (k53A "hihittää") ; --UNCHK
lin titterer_N = mkWN "kikattaja" ; --UNCHK
lin tittivate_V = mkWV (k73 "tällätä") ; --UNCHK
lin tittivate_V2 = mkWV2 (k73 "tällätä") ; --UNCHK
lin tittle_N = mkWN (k32 "hiven") ; --UNCHK
lin titular_A = mkWA (k38 "aatelinen") ; --UNCHK
lin tiverton_PN = foreignPN "Tiverton" ;
lin tiyin_N = mkWN "tenge" ; --UNCHK
lin tizzy_N = mkWN (k39 "kiihtymys") ; --UNCHK
lin tl_PN = mkPN "Tl" ;
lin tnt_N = mkWN (k6 "trotyyli") ; --UNCHK
lin to_Adv = mkAdv "luo" ; ---- what is this?
lin to_Prep = mkPrep illative | mkPrep allative ;
lin to_date_Adv = mkAdv "tähän mennessä" ;
lin toad_N = mkWN (k10 "konna") ; --UNCHK
lin toadfish_N = mkWN (k18 "tau") "Opsanus" ; --UNCHK
lin toadflax_N = mkWN (compoundN "kannus" (k1 "ruoho")) ; --UNCHK
lin toadstool_N = mkWN (compoundN "myrkky" (k26 "sieni")) ; --UNCHK
lin toady_N = mkWN (k12 "mielistelijä") ; --UNCHK
lin toady_V = mkWV (k68 "pokkuroida") ; --UNCHK
lin toast_N = mkWN (compoundN "paahto" (k10A "leipä")) ; --UNCHK
lin toast_V = mkWV (k56A "paahtaa") ; --UNCHK
lin toast_V2 = mkWV2 (k56A "paahtaa") ; --UNCHK
lin toaster_N = mkWN (k33A "paahdin") ; --UNCHK
lin toasting_N = mkWN "ruskistaminen" ; --UNCHK
lin toasting_fork_N = mkWN (compoundN "grilli" (k14A "haarukka")) ; --UNCHK
lin toastmaster_N = mkWN (compoundN "juhla" (k10A "isäntä")) ; --UNCHK
lin toastrack_N = mkWN (compoundN "paahtoleipä" (k48 "teline")) ; --UNCHK
lin tobacco_N = mkWN (k14A "tupakka") ;
lin tobacconist_N = mkWN (compoundN "tupakka" (k9A "kauppa")) ; --UNCHK
lin tobagonian_A = mkWA (compoundA "tobago" (k38 "lainen")) ; --UNCHK
lin tobagonian_N = mkWN (compoundN "tobago" (k38 "lainen")) ; --UNCHK
lin toboggan_N = mkWN (k3 "ahkio") ; --UNCHK
lin toboggan_V = mkWV (k67 "kelkkailla") ; --UNCHK
lin tobogganing_N = mkWN "pulkkailu" ; --UNCHK
lin tobogganist_N = mkWN "pulkkailija" ; --UNCHK
lin tobramycin_N = mkWN "tobramysiini" ; --UNCHK
lin toby_N = mkWN (compoundN "keramiikka" (k5A "tuoppi")) ; --UNCHK
lin toby_jug_N = mkWN (compoundN "keramiikka" (k5A "tuoppi")) ; --UNCHK
lin tocainide_N = mkWN (compoundN "tocai" (k48A "nide")) ; --UNCHK
lin toccata_N = mkWN (k9 "toccata") ; --UNCHK
lin tocsin_N = mkWN (compoundN "hälytys" (k1 "kello")) ; --UNCHK
lin tod_A = mkWA (k99 "yksin") ; --UNCHK
lin tod_N = mkWN (compoundN "paino" (k9A "mitta")) ; --UNCHK
lin today_Adv = L.today_Adv ;
lin today_N = mkN "nykypäivä" ; ---
lin toddle_V = mkWV (k52A "vaappua") ; --UNCHK
lin toddler_N = mkWN (k2 "napero") ; --UNCHK
lin toddy_N = mkWN (k5 "toti") ; --UNCHK
lin todmorden_PN = foreignPN "Todmorden" ;
lin tody_N = mkWN "todi" ; --UNCHK
lin toe_N = mkWN (k7A "kärki") ; --UNCHK
lin toe_V2 = mkWV2 (k66 "hipaista") ; --UNCHK
lin toea_N = mkWN (kH1 "kina") ; --UNCHK
lin toecap_N = mkWN (k10 "kivisuoja") ; --UNCHK
lin toed_A = mkWA "kyntinen" ; --UNCHK
lin toehold_N = mkWN (compoundN "paini" (k48A "ote")) ; --UNCHK
lin toeless_A = mkWA "varpaaton" ; --UNCHK
lin toenail_N = mkWN (compoundN "varpaan" (k28 "kynsi")) ; --UNCHK
lin toetoe_N = mkWN (k1A "ruoko") ; --UNCHK
lin toff_N = mkWN (k1 "kiho") "iso" ; --UNCHK
lin toffee_N = mkWN (k20 "toffee") ; --UNCHK
lin tog_V2 = mkWV2 (k53 "varustaa") ; --UNCHK
lin toga_N = mkWN (k10 "tooga") ; --UNCHK
lin together_A = mkWA (compoundA "tasa" (k38 "painoinen")) ; --UNCHK
lin together_Adv = mkAdv "yhdessä" ;
lin togetherness_N = mkWN (k40 "läheisyys") ; --UNCHK
lin toggle_N = mkWN (compoundN "raksi" (k14A "pulikka")) ; --UNCHK
lin togo_PN = foreignPN "Togo" ;
lin togolese_A = mkWA (compoundA "togo" (k38 "lainen")) ; --UNCHK
lin togolese_N = mkWN (compoundN "togo" (k38 "lainen")) ; --UNCHK
lin tohmajärvi_PN = mkPN (mkN "Tohmajärvi" "Tohmajärviä") ;
lin toholampi_PN = mkPN (mkN "Toholampi" "Toholampia") ;
lin toijala_PN = mkPN "Toijala" ;
lin toil_N = mkWN (k5A "ahkerointi") ; --UNCHK
lin toil_V = mkWV (k53 "uurastaa") ; --UNCHK
lin toil_V2V = mkWV2V (k53 "uurastaa") ; --UNCHK
lin toil_VV = mkWVV (k53 "uurastaa") infIllat ; ---???
lin toiler_N = mkWN (k10 "ahertaja") ; --UNCHK
lin toilet_N = mkN "vessa" ;
lin toilet_paper_N = mkWN (compoundN "vessa" (k6 "paperi")) ; --UNCHK
lin toilet_powder_N = mkWN (compoundN "kylpy" (k5A "talkki")) ; --UNCHK
lin toilet_roll_N = mkWN (compoundN "vessapaperi" (k10 "rulla")) ; --UNCHK
lin toilet_table_N = mkWN (compoundN "pukeutumis" (k10A "pöytä")) ; --UNCHK
lin toilsome_A = mkWA (k10 "vaativa") ; --UNCHK
lin toivakka_PN = mkPN "Toivakka" ;
lin tokamak_N = mkWN "tokamak" ; --UNCHK
lin tokay_N = mkWN "Tokay" ; --UNCHK
lin toke_N = mkWN "hatsi" ; --UNCHK
lin token_N = mkWN (k1 "muisto") ; --UNCHK
lin tokyo_PN = foreignPN "Tokio" ;
lin tolazamide_N = mkWN (compoundN "Tolin" (k48 "ase")) ; --UNCHK
lin tolazoline_N = mkWN "tolatsoliini" ; --UNCHK
lin tolbutamide_N = mkWN (compoundN "Orin" (k48 "ase")) ; --UNCHK
lin tole_N = mkWN (compoundN "metalli" (k48 "esine")) ; --UNCHK
lin tolerable_A = mkWA (k10 "välttävä") ; --UNCHK
lin tolerance_N = mkWN (k40 "suvaitsevaisuus") ;
lin tolerant_A = mkWA (k38 "suvaitsevainen") ; --UNCHK
lin tolerate_V2 = mkWV2 (k69 "suvaita") ;
lin toleration_N = mkWN (k40 "suvaitsevuus") ; --UNCHK
lin toll_N = mkWN (k1 "maksu") ; --UNCHK
lin toll_V = mkWV (k62 "soida") ; --UNCHK
lin toll_V2 = mkWV2 (k62 "soida") ; --UNCHK
lin tollbar_N = mkWN (compoundN "tulli" (k5A "portti")) ; --UNCHK
lin tollbooth_N = mkWN (k5A "tullikoppi") ; --UNCHK
lin toller_N = mkWN (compoundN "tulli" (k12 "virkailija")) ; --UNCHK
lin tollgate_N = mkWN (compoundN "tulli" (k5A "portti")) ; --UNCHK
lin tollhouse_N = mkWN (k5A "tullikoppi") ; --UNCHK
lin tollkeeper_N = mkWN (compoundN "tulli" (k12 "virkailija")) ; --UNCHK
lin tolu_N = mkWN (k6 "balsami") ; --UNCHK
lin toluene_N = mkWN (k5 "tolueeni") ; --UNCHK
lin tom_N = mkWN (compoundN "kalkkuna" (k1A "kukko")) ; --UNCHK
lin tom_PN = mkPN "Tom" ;
lin tomahawk_N = mkWN (k5 "tomahawk") ; --UNCHK
lin tomahawk_V2 = mkWV2 (k73 "surmata") "tomahawkilla" ; --UNCHK
lin tomalley_N = mkWN (k9 "maksa") ; --UNCHK
lin tomatillo_N = mkWN (k5A "tomaatti") ; --UNCHK
lin tomato_N = mkWN (k5A "tomaatti") ; --UNCHK
lin tomb_N = mkWN (k9A "hauta") ; --UNCHK
lin tombac_N = mkWN (k5A "messinki") ; --UNCHK
lin tombola_N = mkWN (compoundN "onnen" (k10 "pyörä")) ; --UNCHK
lin tomboy_N = mkWN (compoundN "poika" (k1A "tyttö")) ; --UNCHK
lin tombstone_N = mkWN (compoundN "hauta" (k7 "kivi")) ; --UNCHK
lin tomcat_N = mkWN (kH1 "kolli") ; --UNCHK
lin tome_N = mkWN (k39 "opus") ; --UNCHK
lin tomentose_A = mkWA (k38 "nukkainen") ; --UNCHK
lin tomentum_N = mkWN "tomentum" "cerebri" ; --UNCHK
lin tomfool_N = mkWN (k1 "pöllö") ; --UNCHK
lin tomfoolery_N = mkWN (k39 "hullutus") ; --UNCHK
lin tommy_gun_N = mkWN (compoundN "kone" (k6 "pistooli")) "Thompsonin" ; --UNCHK
lin tomograph_N = mkWN (k12 "tomografia") ; --UNCHK
lin tomorrow_Adv = mkWAdv (k99 "huomenna") ;
lin tomorrow_N = mkWN (k38 "huominen") ; --f73
lin tomtate_N = mkWN (compoundN "muri" (k9 "sija")) ; --UNCHK
lin tomtit_N = mkWN (compoundN "sini" (k38 "tiainen")) ; --UNCHK
lin ton_N = mkWN (k5 "tonni") ; --f151
lin tonal_A = mkWA (k38 "tonaalinen") ; --UNCHK
lin tonality_N = mkWN (k40 "tonaalisuus") ; --UNCHK
lin tonbridge_PN = foreignPN "Tonbridge" ;
lin tone_N = mkN "sävy" | mkWN (k48A "vivahde") ;
lin tone_V = mkWV (k53A "jännittää") ; --UNCHK
lin tone_V2 = mkWV2 (k53A "jännittää") ; --UNCHK
lin tone_down_V2 = mkWV2 (k54A "miedontaa") ; --UNCHK
lin tone_poem_N = mkWN (k10 "runoelma") "sinfoninen" ; --UNCHK
lin toneless_A = mkWA (k34A "soinniton") ; --UNCHK
lin toner_N = mkWN (compoundN "kasvo" (k27 "vesi")) ; --UNCHK
lin tonga_PN = foreignPN "Tonga" ;
lin tongan_A = mkWA (compoundA "tong" (k38 "alainen")) ; --UNCHK
lin tongan_N = mkWN "tongan" ; --UNCHK
lin tongue_N = L.tongue_N ;
lin tongue_in_cheek_A = mkA "leikkimielinen" ;
lin tongue_in_cheek_Adv = mkAdv "leikillään" ;
lin tongue_twister_N = mkWN (compoundN "sana" (k5A "leikki")) ; --UNCHK
lin tongued_A = mkWA (k38 "kielimäinen") ; --UNCHK
lin tonguefish_N = mkWN (compoundN "kieli" (k9 "kala")) ; --UNCHK
lin tongueflower_N = mkWN (k13 "orkidea") ; --UNCHK
lin tongueless_A = mkWA "kieletön" ; --UNCHK
lin tonguelike_A = mkWA (k38 "kielimäinen") ; --UNCHK
lin tonic_A = mkWA (k38 "painollinen") ; --UNCHK
lin tonic_N = mkWN (compoundN "tooni" (k5 "kumi")) ; --UNCHK
lin tonic_sol_fa_N = mkN "solmisaatio" ;
lin tonicity_N = mkWN (k39 "tonus") ; --UNCHK
lin tonight_Adv = mkWAdv "tänä" "iltana" ; --UNCHK
lin tonight_N = mkWN (k9A "ilta") "tämä" ;
lin tonnage_N = mkWN (k1 "vero") ; --UNCHK
lin tonne_N = mkWN (k5 "tonni") ; --UNCHK
lin tonometer_N = mkWN (compoundN "paine" (k6 "mittari")) ; --UNCHK
lin tonometry_N = mkWN "tonometria" ; --UNCHK
lin tons_N = mkWN (k99 "roppakaupalla") ; --UNCHK
lin tonsil_N = mkWN (k9 "tonsilla") ; --UNCHK
lin tonsillectomy_N = mkWN (compoundN "nielurisa" (k39 "leikkaus")) ; --UNCHK
lin tonsillitis_N = mkWN (k13 "angiina") ; --UNCHK
lin tonsorial_A = mkWA "parturin" ; --UNCHK
lin tonsure_N = mkWN "tonsure" ; --UNCHK
lin tontine_N = mkWN "tontiini" ; --UNCHK
lin tonyrefail_PN = foreignPN "Tonyrefail" ;
lin too_AdA = S.too_AdA ;
lin too_Adv = mkAdv "myös" ;
lin tool_N = mkWN (k48 "väline") ; --f53
lin tool_V2 = mkWV2 (k53 "työstää") ; --UNCHK
lin toolbox_N = mkWN (k5A "työkalupakki") ; --UNCHK
lin toolmaker_N = mkWN (k10 "valmistaja") ; --UNCHK
lin toolshed_N = mkWN (compoundN "työkalu" (k9 "vaja")) ; --UNCHK
lin toot_V = mkWV (k52A "raikua") ; --UNCHK
lin toot_V2 = mkWV2 (k52A "raikua") ; --UNCHK
lin tooth_N = L.tooth_N ;
lin toothache_N = mkWN (k12 "odontologia") ; --UNCHK
lin toothbrush_N = mkWN (compoundN "hammas" (k9 "harja")) ; --UNCHK
lin toothed_A = mkWA (k38 "-hampainen") ; --UNCHK
lin toothless_A = mkWA (k34A "hampaaton") ; --UNCHK
lin toothlike_A = mkWA (compoundA "hammas" (k38 "mainen")) ; --UNCHK
lin toothpaste_N = mkWN (compoundN "hammas" (k9 "tahna")) ; --UNCHK
lin toothpick_N = mkWN (compoundN "hammas" (k1A "tikku")) ; --UNCHK
lin toothpowder_N = mkWN (compoundN "hammas" (k48 "jauhe")) ; --UNCHK
lin toothsome_A = mkWA (k41A "maukas") ; --UNCHK
lin toothy_A = mkWA (compoundA "iso" (k38 "hampainen")) ; --UNCHK
lin tootle_N = mkWN (k39 "toitotus") ; --UNCHK
lin tootle_V = mkWV (k73A "tuutata") ; --UNCHK
lin top_N = mkN "huippu" ;
lin top_V2 = mkWV2 (k54A "huipentaa") ;
lin top_boot_N = mkWN (compoundN "maihinnousu" (k10A "kenkä")) ; --UNCHK
lin top_dressing_N = mkWN (k39 "lannoitus") ; --UNCHK
lin top_flight_A = mkA "erinomainen" ;
lin top_heavy_A = mkA (mkN "etu" (mkN "painoinen")) ;
lin top_off_V2 = mkWV2 (k53A "täyttää") ; --UNCHK
lin top_out_V = mkWV (k53A "saavuttaa") "huippunsa" ; --UNCHK
lin topaz_N = mkWN (k5 "topaasi") ; --UNCHK
lin topcoat_N = mkWN (k17 "palttoo") ; --UNCHK
lin tope_V = mkWV (k73A "ryypätä") ; --UNCHK
lin tope_V2 = mkWV2 (k73A "ryypätä") ; --UNCHK
lin toper_N = mkWN (k1A "juoppo") ; --UNCHK
lin topgallant_N = mkWN (compoundN "prammi" (k1A "tanko")) ; --UNCHK
lin tophus_N = mkWN (compoundN "hammas" (k7 "kivi")) ; --UNCHK
lin topi_N = mkWN (compoundN "sassabian" (k5A "antilooppi")) ; --UNCHK
lin topiary_N = mkWN (compoundN "muoto" (k39 "leikkaus")) ; --UNCHK
lin topic_N = mkN "aihe" ;
lin topical_A = mkWA (compoundA "aiheen" (k38 "mukainen")) ; --UNCHK
lin topicality_N = mkWN "ajankohtaisuus" ; --UNCHK
lin topicalization_N = mkWN (k39 "painotus") ; --UNCHK
lin topknot_N = mkWN (k12 "nuttura") ; --UNCHK
lin topless_A = mkWA (compoundA "ylä" (k34A "osaton")) ; --UNCHK
lin topmast_N = mkWN (compoundN "märssy" (k1A "tanko")) ; --UNCHK
lin topminnow_N = mkWN (compoundN "miekka" (k1 "pyrstö")) ; --UNCHK
lin topmost_A = mkWA (k36 "ylin") ; --UNCHK
lin topnotch_A = mkWA (k38 "erinomainen") ; --UNCHK
lin topognosia_N = mkWN "topognosis" ; --UNCHK
lin topographical_A = mkWA (k38 "topografinen") ; --UNCHK
lin topography_N = mkWN (k12 "topografia") ; --UNCHK
lin topolatry_N = mkWN (k9A "palvonta") "paikan" ; --UNCHK
lin topological_A = mkWA (compoundA "top" (k38 "ologinen")) ; --UNCHK
lin topology_N = mkWN "verkkotopologia" ; --UNCHK
lin toponymy_N = mkWN (compoundN "topon" (k61 "omia")) ; --UNCHK
lin topos_N = mkWN (k10 "aihelma") ; --UNCHK
lin topper_N = mkWN (k6 "silinteri") ; --UNCHK
lin topping_N = mkWN (k48A "kastike") ; --UNCHK
lin topple_V = mkWV (k73 "sysätä") ; --UNCHK
lin topple_V2 = mkV2 "romahduttaa" ;
lin topsail_N = mkWN (compoundN "märssy" (k48 "purje")) ; --UNCHK
lin topside_N = mkWN (compoundN "ylä" (k28 "kansi")) ; --UNCHK
lin topsoil_N = mkWN (compoundN "pinta" (k18 "maa")) ; --UNCHK
lin topspin_N = mkWN (compoundN "ylä" (k48A "kierre")) ; --UNCHK
lin topsy_turvy_Adv = mkAdv "sikin sokin" ;
lin toque_N = mkWN (compoundN "pilleri" (k12 "rasia")) ; --UNCHK
lin tor_N = mkWN (k3 "kallio") ; --UNCHK
lin torbay_PN = foreignPN "Torbay" ;
lin torch_1_N = mkWN (compoundN "puhallus" (k1A "lamppu")) ; --UNCHK
lin torch_2_N = mkWN (compoundN "puhallus" (k1A "lamppu")) ; --UNCHK
lin torch_3_N = mkWN (compoundN "puhallus" (k1A "lamppu")) ; --UNCHK
lin torch_V2 = mkWV2 (k53A "sytyttää") "tuleen" ; --UNCHK
lin torch_race_N = mkWN (compoundN "soihdun" (k39 "kuljetus")) ; --UNCHK
lin torch_singer_N = mkWN (k10 "laulaja") ; --UNCHK
lin torchbearer_N = mkWN (compoundN "soihdun" (k10 "kantaja")) ; --UNCHK
lin torchlight_N = mkWN (k1 "valo") ; --UNCHK
lin toreador_N = mkWN (k5 "toreadori") ; --UNCHK
lin torero_N = mkWN (k2 "torero") ; --UNCHK
lin torment_N = mkWN (k9 "piina") ; --UNCHK
lin torment_V2 = mkWV2 (k53A "kiduttaa") ; --UNCHK
lin tormenter_N = mkWN (compoundN "väli" (k1 "verho")) ; --UNCHK
lin tormentor_N = mkWN (compoundN "väli" (k1 "verho")) ; --UNCHK
lin tornado_N = mkWN (k5 "crack") ; --UNCHK
lin tornio_PN = mkPN "Tornio" ;
lin toroid_N = mkWN (k12 "ympyrä") ; --UNCHK
lin toroidal_A = mkWA "toroidal" ; --UNCHK
lin toronto_PN = foreignPN "Toronto" ;
lin torpedo_N = mkWN (compoundN "sähkö" (k1 "rausku")) ; --UNCHK
lin torpedo_V2 = mkWV2 (k62 "torpedoida") ; --UNCHK
lin torpedo_boat_N = mkWN (compoundN "torpedo" (k48 "vene")) ; --UNCHK
lin torpedo_tube_N = mkWN (compoundN "torpedo" (k7 "putki")) ; --UNCHK
lin torpid_A = mkWA (k1A "veltto") ; --UNCHK
lin torpidity_N = mkWN (k39 "turtumus") ; --UNCHK
lin torpidness_N = mkWN (k39 "turtumus") ; --UNCHK
lin torpor_N = mkWN (k39 "turtumus") ; --UNCHK
lin torque_N = mkWN (k5A "momentti") "voiman" ; --UNCHK
lin torr_N = mkWN "elohopeamillimetri" ; --UNCHK
lin torrent_N = mkWN (k10 "tulva") ; --UNCHK
lin torrential_A = mkWA "tulvanaiheuttama" ; --UNCHK
lin torrid_A = mkWA (k10 "polttava") ; --UNCHK
lin torridity_N = mkWN (k40 "kuumuus") ; --UNCHK
lin torsion_N = mkWN (k5A "momentti") "voiman" ; --UNCHK
lin torso_N = mkWN (k1 "keho") ; --UNCHK
lin tort_N = mkWN (k39 "rikkomus") ; --UNCHK
lin torte_N = mkWN (compoundN "täyte" (k1A "kakku")) ; --UNCHK
lin tortellini_N = mkWN "tortellini" ; --UNCHK
lin torticollis_N = mkWN (compoundN "lihas" (k5A "kramppi")) ; --UNCHK
lin tortilla_N = mkWN (k13 "tortilla") ; --UNCHK
lin tortious_A = mkWA (k34A "laiton") ; --UNCHK
lin tortoise_N = mkWN (compoundN "kilpi" (k10 "konna")) ; --UNCHK
lin tortoiseshell_N = mkWN (k9 "kissa") "kilpikonnakuvioinen" ; --UNCHK
lin tortricid_N = mkWN (k38 "kääriäinen") ; --UNCHK
lin tortuosity_N = mkWN (k40 "käyryys") ; --UNCHK
lin tortuous_A = mkWA (k1 "kiero") ; --UNCHK
lin torture_N = mkWN (k39 "kidutus") ; --UNCHK
lin torture_V2 = mkWV2 (k53A "kiduttaa") ; --UNCHK
lin torturer_N = mkWN (k10 "kiduttaja") ; --UNCHK
lin torulose_A = mkWA (k38 "paisuvainen") ; --UNCHK
lin torus_N = mkWN (compoundN "tiili" (k39 "kerros")) ; --UNCHK
lin tory_N = mkWN "tory" ; --UNCHK
lin tosh_N = mkWN (k5 "humpuuki") ; --UNCHK
lin toss_N = mkWN (k1A "heitto") ; --UNCHK
lin toss_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin toss_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin toss_back_V2 = mkWV2 (compoundV "nyt" (k53A "käyttää")) ; --UNCHK
lin toss_off_V2 = mkWV2 (k73A "nakata") "naamaan" ; --UNCHK
lin toss_out_V = mkWV (k73A "hylätä") ; --UNCHK
lin tosser_N = mkWN (k10 "heittäjä") ; --UNCHK
lin tossup_N = mkWN (k10 "sattuma") ; --UNCHK
lin tostada_N = mkWN (k13 "tortilla") ; --UNCHK
lin tot_N = mkWN (k2 "napero") ; --UNCHK
lin tot_V = mkWV (k73 "ynnätä") ; --UNCHK
lin tot_V2 = mkWV2 (k73 "ynnätä") ; --UNCHK
lin tot_up_V = mkWV (k73 "ynnätä") ; --UNCHK
lin total_A = mkA "totaalinen" ;
lin total_N = mkWN (k40 "kokonaisuus") ; --f112
lin total_V = mkV "yltää" ; ----
lin total_V2 = mkV2 "yltää" illative ;
lin totalitarian_A = mkWA (k38 "totalitaristinen") ; --UNCHK
lin totalitarian_N = mkWN (compoundN "totalita" (k5 "risti")) ; --UNCHK
lin totalitarianism_N = mkWN (k5 "totalitarismi") ; --UNCHK
lin totality_N = mkWN (k40 "kokonaisuus") ; --UNCHK
lin totalizator_N = mkWN (k6 "totalisaattori") ; --UNCHK
lin totara_N = mkWN "Podocarpus" "totara" ; --UNCHK
lin tote_N = mkWN (k5 "kori") ; --UNCHK
lin tote_V2 = mkWV2 (k52 "kiskoa") ; --UNCHK
lin totem_N = mkWN (k6 "toteemi") ; --UNCHK
lin totem_pole_N = mkWN (compoundN "toteemi" (k1 "paalu")) ; --UNCHK
lin totemic_A = mkWA (k38 "totemistinen") ; --UNCHK
lin totemism_N = mkWN (k5 "totemismi") ; --UNCHK
lin totemist_N = mkWN "totemisti" ; --UNCHK
lin totipotency_N = mkWN "totipotentia" ; --UNCHK
lin totnes_PN = foreignPN "Totnes" ;
lin totter_V = mkWV (k52 "horjua") ; --UNCHK
lin tottery_A = mkWA (k10 "horjuva") ; --UNCHK
lin touch_N = mkWN (k39 "kosketus") ;
lin touch_V = mkWV (k52A "liittyä") ; --UNCHK
lin touch_V2 = mkV2 "koskea" partitive ; --mkWV2 (k52A "liittyä") ;
lin touch_down_V = mkWV (k52A "laskeutua") ; --UNCHK
lin touch_for_V3 = variants {} ; -- guess-p-verb
lin touch_off_V2 = mkWV2 (k53A "aiheuttaa") ; --UNCHK
lin touch_on_V2 = mkWV2 (k52A "liittyä") ; --UNCHK
lin touch_type_V = variants {} ; -- guess-p-verb
lin touch_up_V2 = mkWV2 (k62 "retusoida") ; --UNCHK
lin touch_upon_V2 = prepV2 OP_touch_V OP_upon_Prep ; -- guess-p-verb
lin touchable_A = mkWA (compoundA "silmiin" (k10 "pistävä")) ; --UNCHK
lin touchback_N = mkWN (k9 "sivuraja") ; --UNCHK
lin touchdown_N = mkWN (kH1 "maali") ; --UNCHK
lin toucher_N = mkWN "tönijä" ; --UNCHK
lin touchiness_N = mkWN (k40 "ärtyisyys") ; --UNCHK
lin touching_A = mkWA (k10 "liikuttava") ; --UNCHK
lin touchline_N = mkWN (k9 "sivuraja") ; --UNCHK
lin touchstone_N = mkWN (k6 "standardi") ; --UNCHK
lin touchy_A = mkWA (k10 "kiperä") ;
lin tough_A = mkA "tiukka" ;
lin tough_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin toughen_V = mkWV (k53 "vahvistaa") ; --UNCHK
lin toughen_V2 = mkWV2 (k53 "vahvistaa") ; --UNCHK
lin toughie_N = mkWN (k12 "pähkinä") "kuva" ; --UNCHK
lin toughness_N = mkWN (k40 "vaativuus") ; --UNCHK
lin toulon_PN = foreignPN "Toulon" ;
lin toulouse_PN = foreignPN "Toulouse" ;
lin toupee_N = mkWN (k20 "tupee") ; --UNCHK
lin toupeed_A = mkWA (compoundA "tupee" (k38 "päinen")) ; --UNCHK
lin tour_N = mkWN (k9 "matka") ; --UNCHK
lin tour_V = mkWV (k67A "kierrellä") ; --UNCHK
lin tour_V2 = mkWV2 (k67A "kierrellä") ; --UNCHK
lin tour_de_force_N = mkWN (compoundN "loisto" (k39 "suoritus")) ; --UNCHK
lin touraco_N = mkWN "turako" ; --UNCHK
lin touring_N = mkN "kiertoajelu" ;
lin tourism_N = mkWN (k2 "matkailu") ; --UNCHK
lin tourist_N = mkWN (k5 "turisti") ;
lin touristed_A = mkWA (k1A "suosittu") ; --UNCHK
lin tourmaline_N = mkWN (k5 "turmaliini") ; --UNCHK
lin tournament_N = mkWN (k39 "turnaus") ; --UNCHK
lin tournedos_N = mkWN (k22 "tournedos") ; --UNCHK
lin tourney_N = mkWN (k39 "turnaus") ; --UNCHK
lin tourniquet_N = mkWN (compoundN "kiristys" (k48A "side")) ; --UNCHK
lin tours_PN = foreignPN "Tours" ;
lin tourtiere_N = mkWN (compoundN "liha" (k10A "vuoka")) ; --UNCHK
lin tousle_V2 = mkWV2 (k58 "sotkea") ; --UNCHK
lin tout_N = mkWN (compoundN "vinkin" (k10 "antaja")) ; --UNCHK
lin tout_V = mkWV (k67A "rehennellä") ; --UNCHK
lin tout_V2 = mkWV2 (k67A "rehennellä") ; --UNCHK
lin tout_ensemble_Adv = mkWAdv (k99 "ylipäätään") ; --UNCHK
lin tout_ensemble_N = mkWN (k40 "kokonaisuus") ; --UNCHK
lin tovarich_N = mkWN (k6 "toveri") ; --UNCHK
lin tow_N = mkWN (kH1 "veto") ; --UNCHK
lin tow_V2 = mkWV2 (k53A "vetää") ; --UNCHK
lin toward_Prep = mkPrep partitive "kohti" ;
lin towards_Prep = mkPrep partitive "kohti" ;
lin towel_N = mkWN (k48A "pyyhe") ;
lin towel_V2 = mkWV2 (k61A "pyyhkiä") ; --UNCHK
lin towel_horse_N = mkWN (compoundN "pyyhe" (k48 "teline")) ; --UNCHK
lin towel_rack_N = mkWN (compoundN "pyyhe" (k48 "teline")) ; --UNCHK
lin towel_rail_N = mkWN (compoundN "pyyhe" (k1A "tanko")) ; --UNCHK
lin towelling_N = mkWN (k41A "pyyhekangas") ; --UNCHK
lin tower_N = mkWN (k5 "torni") ;
lin tower_V = mkWV (k74 "kohota") "korkealle" ; --UNCHK
lin tower_block_N = mkWN (compoundN "torni" (k1 "talo")) ; --UNCHK
lin towhead_N = mkWN (compoundN "pellava" (k18 "pää")) ; --UNCHK
lin towhee_N = mkWN (compoundN "pip" (k1 "ilo")) ; --UNCHK
lin towing_line_N = mkWN (compoundN "hinaus" (k27 "köysi")) ; --UNCHK
lin towing_path_N = mkWN (compoundN "hinaus" (k1A "polku")) ; --UNCHK
lin towing_rope_N = mkWN (compoundN "hinaus" (k27 "köysi")) ; --UNCHK
lin towline_N = mkWN (compoundN "hinaus" (k27 "köysi")) ; --UNCHK
lin town_N = mkN "kaupunki" ;
lin town_gas_N = mkWN (compoundN "kaupunki" (k1 "kaasu")) ; --UNCHK
lin townee_N = mkWN (k38 "kaupunkilainen") ; --UNCHK
lin townie_N = mkWN (k38 "kaupunkilainen") ; --UNCHK
lin township_N = mkWN (k5A "kaupunki") ;
lin townsman_N = mkWN (k38 "kaupunkilainen") ; --UNCHK
lin towpath_N = mkWN (compoundN "hinaus" (k1A "polku")) ; --UNCHK
lin towrope_N = mkWN (compoundN "hinaus" (k27 "köysi")) ; --UNCHK
lin toxaemia_N = mkWN (compoundN "veren" (k39 "myrkytys")) ; --UNCHK
lin toxemia_N = mkWN (compoundN "veren" (k39 "myrkytys")) ; --UNCHK
lin toxic_A = mkA "myrkyllinen" ; --mkWA (k38 "toksinen") ;
lin toxicity_N = mkWN (k40 "myrkyllisyys") ; --UNCHK
lin toxicognath_N = mkWN (compoundN "myrkky" (k41A "hammas")) ; --UNCHK
lin toxicological_A = mkWA "toksikologinen" ; --UNCHK
lin toxicologist_N = mkWN "toksikologi" ; --UNCHK
lin toxicology_N = mkWN (k12 "toksikologia") ; --UNCHK
lin toxin_N = mkWN (k5 "toksiini") ; --UNCHK
lin toxoplasmosis_N = mkWN "toksoplasmoosi" ; --UNCHK
lin toy_N = mkN "lelu" ;
lin toy_V = mkWV (k61A "leikkiä") ; --UNCHK
lin toy_with_V2 = mkWV2 (k69 "harkita") ; --UNCHK
lin toyon_N = mkWN (compoundN "piikki" (k11 "paatsama")) ; --UNCHK
lin toyshop_N = mkWN (compoundN "lelu" (k9A "kauppa")) ; --UNCHK
lin trabeated_A = mkWA (compoundA "palkkikat" (k38 "toinen")) ; --UNCHK
lin trabecula_N = mkWN (compoundN "trabec" (k10 "ula")) ; --UNCHK
lin trabecular_A = mkWA "trabekulaarinen" ; --UNCHK
lin trace_N = mkWN (k9 "aisa") ; --UNCHK
lin trace_V = variants {} ; -- mkV2 "jäljittää" ;
lin trace_V2 = mkV2 "jäljittää" ;
lin traceable_A = mkWA (k10 "näkyvä") ; --UNCHK
lin tracer_N = mkWN (compoundN "valojuova" (k5A "luoti")) ; --UNCHK
lin tracery_N = mkWN (compoundN "ristikko" (k3 "kuvio")) ; --UNCHK
lin trachea_N = mkWN (compoundN "henki" (k7 "torvi")) ; --UNCHK
lin tracheal_A = mkWA "henkitorven" ; --UNCHK
lin tracheid_N = mkWN (compoundN "putkilo" (k1 "solu")) ; --UNCHK
lin tracheitis_N = mkWN (k39 "tulehdus") "henkitorven" ; --UNCHK
lin tracheobronchitis_N = mkWN (k5A "bronkiitti") ; --UNCHK
lin trachodon_N = mkWN "tekodontti" ; --UNCHK
lin trachoma_N = mkWN (compoundN "tra" (k10 "kooma")) ; --UNCHK
lin tracing_N = mkWN "löytäminen" ; --UNCHK
lin tracing_paper_N = mkWN (compoundN "kuulto" (k6 "paperi")) ; --UNCHK
lin track_N = mkN "ura" ;
lin track_V = mkWV (k53A "jättää") "jäljet" ;
lin track_V2 = mkV2 "jäljittää" partitive ;
lin track_down_V2 = mkWV2 (k53 "pyydystää") ; --UNCHK
lin trackball_N = mkWN (compoundN "pallo" (k24 "hiiri")) ; --UNCHK
lin tracker_N = mkWN "jäljittäjä" ; --UNCHK
lin trackless_A = mkWA (k34A "koskematon") ; --UNCHK
lin tract_N = mkN "traktaatti" ; ---ARB --mkN "kanava" ; --mkWN (k9A "rata") ;
lin tractability_N = mkWN (k40 "alttius") ; --UNCHK
lin traction_N = mkWN (kH1 "veto") ; --UNCHK
lin traction_engine_N = mkWN (compoundN "veto" (k6 "moottori")) ; --UNCHK
lin tractive_A = mkWA "veto-" ; --UNCHK
lin tractor_N = mkWN (k6 "traktori") ;
lin tracy_PN = foreignPN "Tracy" ;
lin trad_N = mkWN (k5 "jazz") ; --UNCHK
lin trade_N = mkN "kauppa" ;
lin trade_V = mkV (lin VK {s = c73A "kaupata"}) ;
lin trade_V2 = mkWV2 (mkV "myydä") ; --f95
lin trade_away_V = advV OP_trade_V OP_away_Adv ; -- guess-p-verb
lin trade_down_V = advV OP_trade_V OP_down_Adv ; -- guess-p-verb
lin trade_in_V2 = mkWV2 (k71 "tehdä") "vaihtokauppa" ; --UNCHK
lin trade_off_V2 = prepV2 OP_trade_V OP_off_Prep ; -- guess-p-verb
lin trade_on_V2 = prepV2 OP_trade_V OP_on_Prep ; -- guess-p-verb
lin trade_union_N = mkWN (k1A "liitto") ; --UNCHK
lin trade_unionism_N = mkWN (compoundN "työväen" (k48A "liike")) ; --UNCHK
lin trade_unionist_N = mkWN (k32 "jäsen") "ammattiliiton" ; --UNCHK
lin trade_up_V = advV OP_trade_V OP_up_Adv ; -- guess-p-verb
lin trade_upon_V2 = prepV2 OP_trade_V OP_upon_Prep ; -- guess-p-verb
lin tradecraft_N = mkWN (compoundN "ammatti" (k1A "taito")) ; --UNCHK
lin trademark_N = mkWN (compoundN "korva" (k5A "merkki")) ;
lin trademarked_A = mkWA "tavaramerkin" ; --UNCHK
lin tradeoff_N = mkWN (k9A "valinta") ; --UNCHK
lin trader_N = mkN (lin NK {s = d41 "kauppias"}) ;
lin trades_union_N = mkWN (k1A "liitto") ; --UNCHK
lin tradesman_N = mkWN (k41 "kauppias") ; --UNCHK
lin trading_A = variants {} ; --
lin trading_N = mkWN (compoundN "kaupan" (k5A "käynti")) ; --UNCHK
lin tradition_N = mkWN (k48A "perinne") ; --UNCHK
lin traditional_A = mkWA (k38 "perinteinen") | mkA "traditionaalinen" ;
lin traditionalism_N = mkWN (compoundN "traditional" (k5 "ismi")) ; --UNCHK
lin traditionalist_N = mkWN (k5 "konservatiivi") ; --UNCHK
lin traditionalistic_A = mkWA "perinteitä" "noudattava" ; --UNCHK
lin traduce_V2 = mkWV2 (k52 "puhua") "pahaa" ; --UNCHK
lin traducer_N = mkWN (k10 "parjaaja") ; --UNCHK
lin traffic_N = mkN "liikenne" ; --f64
lin traffic_V = mkWV (k65 "käydä") "kauppaa" ; --UNCHK
lin trafficator_N = mkWN (compoundN "vilkku" (k1 "valo")) ; --UNCHK
lin trafficker_N = mkWN (k12 "kaupittelija") ;
lin tragacanth_N = mkWN (compoundN "arabi" (k5 "kumi")) ; --UNCHK
lin tragedian_N = mkWN (k8 "tragedienne") ; --UNCHK
lin tragedienne_N = mkWN (k8 "tragedienne") ; --UNCHK
lin tragedy_N = mkWN (k12 "tragedia") ;
lin tragic_A = mkWA (k38 "traaginen") ; --UNCHK
lin tragicomedy_N = mkWN (k12 "komedia") "vakava" ; --UNCHK
lin tragicomic_A = mkWA (compoundA "tragi" (k38 "koominen")) ; --UNCHK
lin tragopan_N = mkWN (k6 "fasaani") ; --UNCHK
lin tragus_N = mkWN (compoundN "korvan" (k14A "nipukka")) ; --UNCHK
lin trail_N = mkWN (k1A "polku") ; --UNCHK
lin trail_V = mkWV (k73 "laahata") ;
lin trail_V2 = mkWV2 (k73 "laahata") ; --UNCHK
lin trailblazer_N = mkWN (k10 "tiennäyttäjä") ; --UNCHK
lin trailer_N = mkWN (compoundN "matkailu" (k1 "vaunu")) ; ---ARB
lin trailing_N = mkWN "jäljittäminen" ; --UNCHK
lin train_N = L.train_N ;
lin train_V = mkWV (k67A "harjoitella") ;
lin train_V2 = mkWV2 (k67A "harjoitella") ;
lin train_V2V = mkV2V "valmentaa" | mkV2V "harjoittaa" ; --valmensin häntä taistelemaan
lin train_up_V2 = prepV2 OP_train_V OP_up_Prep ; -- guess-p-verb
lin trainband_N = mkWN (k12 "komppania") ; --UNCHK
lin trainbandsman_N = mkWN (k41 "sotilas") "parvariskaartin" ; --UNCHK
lin trained_A = mkA "treenattu" ;
lin traineeFem_N = mkWN (k12 "harjoittelija") ; --UNCHK
lin traineeMasc_N = mkWN (k12 "harjoittelija") ; --UNCHK
lin traineeship_N = mkWN (compoundN "harjoittelu" (k5 "stipendi")) ; --UNCHK
lin trainer_N = mkN "valmentaja" ;
lin training_N = mkN "harjoitus" ;
lin training_college_N = mkWN (k2 "opisto") ; --UNCHK
lin training_ship_N = mkWN (compoundN "koulu" (k9 "laiva")) ; --UNCHK
lin trainload_N = mkWN (compoundN "juna" (k5 "lasti")) ; --UNCHK
lin trainman_N = mkWN (compoundN "jarru" (k42 "mies")) ; --UNCHK
lin traipse_V = mkWV (k52A "tarpoa") ; --UNCHK
lin trait_N = mkWN (compoundN "luonteen" (k48A "piirre")) ; --UNCHK
lin traitor_N = mkWN (k10 "kavaltaja") ; --UNCHK
lin traitorous_A = mkWA (k34A "uskoton") ; --UNCHK
lin traitress_N = mkWN "pettäjätär" ; --UNCHK
lin trajectory_N = mkWN (k9A "rata") ; --UNCHK
lin tralee_PN = foreignPN "Tralee" ;
lin tram_N = mkWN (compoundN "johdin" (k5 "bussi")) ; --UNCHK
lin tram_car_N = mkWN (compoundN "johdin" (k5 "bussi")) ; --UNCHK
lin trammel_N = mkWN (k9 "ansa") ; --UNCHK
lin trammel_V2 = mkWV2 (k54A "vähentää") ; --UNCHK
lin tramontane_A = mkWA (compoundA "vuorten" (k38 "takainen")) ; --UNCHK
lin tramontane_N = mkWN (compoundN "pohjois" (k26 "tuuli")) ; --UNCHK
lin tramp_N = mkWN (k39 "vaellus") ; --UNCHK
lin tramp_V = mkWV (k67 "harhailla") ; --UNCHK
lin tramp_V2 = mkWV2 (k67 "harhailla") ; --UNCHK
lin tramp_steamer_N = mkWN (compoundN "höyry" (k9 "laiva")) ; --UNCHK
lin trample_N = mkWN (k12 "töminä") ; --UNCHK
lin trample_V = mkWV (k73 "tallata") ; --UNCHK
lin trample_V2 = mkWV2 (k73 "tallata") ; --UNCHK
lin trampler_N = mkWN "tömistelijä" ; --UNCHK
lin trampoline_N = mkWN (k5 "trampoliini") ; --UNCHK
lin trance_N = mkWN (k5 "transsi") ; --UNCHK
lin trancelike_A = mkWA (compoundA "transsin" (k38 "kaltainen")) ; --UNCHK
lin tranche_N = mkWN (k40 "osuus") ; --UNCHK
lin trandolapril_N = mkWN "Mavik" ; --UNCHK
lin tranent_PN = foreignPN "Tranent" ;
lin tranquil_A = mkWA (k26 "tyyni") ; --UNCHK
lin tranquillity_N = mkWN (k40 "rauhallisuus") ; --UNCHK
lin tranquillize_V2 = mkWV2 (k56A "antaa") "rauhoittavia" ; --UNCHK
lin tranquillizer_N = mkWN (k48A "lääke") "rauhoittava" ; --UNCHK
lin transact_V2 = mkWV2 (k53A "harjoittaa") ; --UNCHK
lin transactinide_A = mkWA (compoundA "transacti" (k48A "nide")) ; --UNCHK
lin transactinide_N = mkWN (compoundN "transacti" (k48A "nide")) ; --UNCHK
lin transaction_N = mkN "transaktio" ;
lin transactor_N = mkWN (k10 "välittäjä") ; --UNCHK
lin transalpine_A = mkWA (compoundA "trans" (k38 "alpiininen")) ; --UNCHK
lin transalpine_N = mkWN (compoundN "trans" (k38 "alpiininen")) ; --UNCHK
lin transaminase_N = mkWN (compoundN "transamin" (k5 "aasi")) ; --UNCHK
lin transamination_N = mkWN "transaminaatio" ; --UNCHK
lin transatlantic_A = mkWA (k38 "takainen") "Atlantin" ; --UNCHK
lin transcend_V2 = mkWV2 (k53A "päihittää") ; --UNCHK
lin transcendence_N = mkWN (compoundN "tuon" (k38 "puoleinen")) ; --UNCHK
lin transcendency_N = mkWN (compoundN "tuon" (k38 "puoleinen")) ; --UNCHK
lin transcendent_A = mkWA (compoundA "tuon" (k38 "puolinen")) ; --UNCHK
lin transcendental_A = mkWA (compoundA "tuon" (k38 "puoleinen")) ; --UNCHK
lin transcendentalism_N = mkWN (k12 "filosofia") "transsendentaalinen" ; --UNCHK
lin transcendentalist_N = mkWN "transsendalisti" ; --UNCHK
lin transcontinental_A = mkWA (compoundA "mannerten" (k38 "välinen")) ; --UNCHK
lin transcribe_V2 = mkWV2 (compoundV "tarke" (k53A "kirjoittaa")) ; --UNCHK
lin transcriber_N = mkWN (k10 "muokkaaja") ; --UNCHK
lin transcript_N = mkWN (k3 "transkriptio") ;
lin transcriptase_N = mkWN (compoundN "RNA-polymer" (k5 "aasi")) ; --UNCHK
lin transcription_N = mkWN (k39 "tallennus") ; --UNCHK
lin transcultural_A = mkWA (compoundA "kulttuurien" (k38 "välinen")) ; --UNCHK
lin transdermal_A = mkWA "imeytyvä" ; --UNCHK
lin transducer_N = mkWN (k10 "muuntaja") ; --UNCHK
lin transduction_N = mkWN (compoundN "muu" (k38 "ntaminen")) ; --UNCHK
lin transept_N = mkWN (compoundN "poikki" (k9 "laiva")) ; --UNCHK
lin transeunt_A = mkWA (compoundA "yli" (k38 "aistillinen")) ; --UNCHK
lin transfer_N = mkN "siirto" ;
lin transfer_V = mkWV (k54A "siirtää") ; --UNCHK
lin transferability_N = mkWN "muunnettavuus" ; --UNCHK
lin transferable_A = mkWA (k10 "vaihdettava") ; --UNCHK
lin transferase_N = mkWN (compoundN "transfer" (k5 "aasi")) ; --UNCHK
lin transferee_N = mkWN (k2 "henkilö") ; --UNCHK
lin transference_N = mkWN (k5 "transferenssi") ; --UNCHK
lin transferer_N = mkWN (k10 "siirtäjä") ; --UNCHK
lin transferor_N = mkWN (k10 "luovuttaja") ; --UNCHK
lin transferrin_N = mkWN "beetaglobuliini" ; --UNCHK
lin transfiguration_N = mkWN (k3 "transformaatio") ; --UNCHK
lin transfigure_V2 = mkWV2 (k52A "muuttua") ; --UNCHK
lin transfix_V2 = mkWV2 (k73 "naulata") ; --UNCHK
lin transform_V2 = mkWV2 (k52A "muuttua") ; --UNCHK
lin transformable_A = mkWA (k10 "oleva") "muutettavissa" ; --UNCHK
lin transformation_N = mkWN (compoundN "muu" (k38 "ntaminen")) ; --UNCHK
lin transformer_N = mkWN (k10 "muuntaja") ; --UNCHK
lin transfuse_V2 = mkWV2 (k54A "siirtää") ; --UNCHK
lin transfusion_N = mkWN "kaataminen" ; --UNCHK
lin transgender_A = mkWA (compoundA "transsuku" (k38 "puolinen")) ; --UNCHK
lin transgene_N = mkWN (compoundN "trans" (k5 "geeni")) ; --UNCHK
lin transgress_V = mkWV (k52A "tunkeutua") ; --UNCHK
lin transgress_V2 = mkWV2 (k52A "tunkeutua") ; --UNCHK
lin transgression_N = mkWN (k1 "nousu") ; --UNCHK
lin transgressor_N = mkWN (compoundN "rikkomuksen" (k12 "tekijä")) ; --UNCHK
lin transience_N = mkWN (k40 "suppeus") ; --UNCHK
lin transiency_N = mkWN (k40 "kuolevaisuus") ; --UNCHK
lin transient_A = mkWA (compoundA "yli" (k38 "aistillinen")) ; --UNCHK
lin transient_N = mkWN (k2 "värähtely") ; --UNCHK
lin transistor_N = mkWN (k6 "transistori") ; --UNCHK
lin transistorized_A = mkWA (compoundA "vahviste" (k1 "ttu")) ; --UNCHK
lin transit_N = mkWN (k9 "matka") ;
lin transition_N = mkWN (k10 "siirtymä") ; --UNCHK
lin transitional_A = mkWA "siirtymä-" ; --UNCHK
lin transitive_A = mkWA "transitiivi-" ; --UNCHK
lin transitivity_N = mkWN "transitiivisuus" ; --UNCHK
lin transitory_A = mkWA (k38 "katoavainen") ; --UNCHK
lin translatable_A = mkA "käännettävä" ;
lin translate_V = mkV "kääntää" ;
lin translate_V2 = mkV2 "kääntää" ;
lin translation_N = mkN "käännös" ;
lin translational_A = mkA "käännöksellinen" ;
lin translator_N = mkN "kääntäjä" ;
lin transliterate_V2 = mkWV2 (k62 "translitteroida") ; --UNCHK
lin transliteration_N = mkWN (k5A "translitterointi") ; --UNCHK
lin translocation_N = mkWN (k1A "siirto") ; --UNCHK
lin translucence_N = mkWN (k40 "läpikuultavuus") ; --UNCHK
lin translucency_N = mkWN (k40 "läpikuultavuus") ; --UNCHK
lin translucent_A = mkWA (k41A "kirkas") ; --UNCHK
lin translunar_A = mkWA "ulkoavaruuden" ; --UNCHK
lin transmigrante_N = mkWN (k10 "välittäjä") ; --UNCHK
lin transmigration_N = mkWN (compoundN "jälleen" (k10 "syntymä")) ; --UNCHK
lin transmission_N = mkWN (k39 "lähetys") ;
lin transmit_V2 = mkWV2 (k53A "välittää") ;
lin transmittance_N = mkWN (k10 "muuttuja") ; --UNCHK
lin transmitter_N = mkWN (k33A "lähetin") ; --UNCHK
lin transmogrification_N = mkWN (compoundN "muodon" (k39 "muutos")) ; --UNCHK
lin transmogrify_V2 = mkWV2 (k52A "muuttua") ; --UNCHK
lin transmundane_A = mkWA (compoundA "yli" (k38 "maallinen")) ; --UNCHK
lin transmutable_A = mkWA (k10 "oleva") "muutettavissa" ; --UNCHK
lin transmutation_N = mkWN (compoundN "trans" (k3 "mutaatio")) ; --UNCHK
lin transmute_V2 = mkWV2 (k52A "muuttua") ; --UNCHK
lin transnational_A = mkA "ylikansallinen" ;
lin transoceanic_A = mkWA "valtamerentakainen" ; --UNCHK
lin transom_N = mkWN (compoundN "poikki" (k18 "puu")) ; --UNCHK
lin transom_window_N = mkWN (compoundN "ovi-" (k12 "ikkuna")) ; --UNCHK
lin transparence_N = mkWN (compoundN "läpi" (k40 "näkyvyys")) ; --UNCHK
lin transparency_N = mkWN (k9 "dia") ; --UNCHK
lin transparent_A = mkWA (k10 "läpikuultava") ; --UNCHK
lin transpiration_N = mkWN "transpiraatio" ; --UNCHK
lin transpire_V = mkWV (k67 "hikoilla") ; --UNCHK
lin transpire_V2 = mkWV2 (k67 "hikoilla") ; --UNCHK
lin transplacental_A = mkWA (compoundA "läpäis" (k10 "evä")) ; --UNCHK
lin transplant_N = mkWN (k1A "siirto") ; --UNCHK
lin transplant_V = mkWV (k54A "muuntaa") ; --UNCHK
lin transplant_V2 = mkWV2 (k54A "muuntaa") ; --UNCHK
lin transplantable_A = mkWA "siirrettävä" ; --UNCHK
lin transplantation_N = mkWN (k1A "siirto") ; --UNCHK
lin transplanter_N = mkWN "istuttaja" ; --UNCHK
lin transpolar_A = mkWA "pohjoisnavan" "ylittävä" ; --UNCHK
lin transponder_N = mkWN (compoundN "toisiotutkavas" (k36 "tain")) ; --UNCHK
lin transport_N = mkWN (k1A "siirto") ; --UNCHK
lin transport_V2 = mkWV2 (k53A "lähettää") ; --UNCHK
lin transportable_A = mkWA (k10 "liikkuva") ; --UNCHK
lin transportation_N = mkN "kuljetus" ; --f92
lin transporter_N = mkWN (k33A "kuljetin") ; --UNCHK
lin transposable_A = mkWA "muunnettava" ; --UNCHK
lin transpose_N = mkWN "transpoosi" ; --UNCHK
lin transpose_V2 = mkWV2 (k73 "korvata") ; --UNCHK
lin transposition_N = mkWN (k5A "transponointi") ; --UNCHK
lin transposon_N = mkWN (k5 "geeni") "hyppivä" ; --UNCHK
lin transsexual_N = mkWN (k5 "transseksuaali") ; --UNCHK
lin transsexualism_N = mkWN (compoundN "trans" (k40 "seksuaalisuus")) ; --UNCHK
lin transship_V2 = mkWV2 (k73 "laivata") ; --UNCHK
lin transshipment_N = mkWN (compoundN "transito" (k48A "liikenne")) ; --UNCHK
lin transubstantiation_N = mkWN (compoundN "trans" (k3 "mutaatio")) ; --UNCHK
lin transudate_N = mkWN "transudaatti" ; --UNCHK
lin transuranic_A = mkWA (compoundA "transu" (k38 "raaninen")) ; --UNCHK
lin transverse_A = mkWA (k99 "poikittain") ; --UNCHK
lin transvestic_A = mkWA (compoundA "transvestiitti" (k38 "nen")) ; --UNCHK
lin transvestism_N = mkWN (k38 "ristiinpukeutuminen") ; --UNCHK
lin transvestite_N = mkWN (k5A "transvestiitti") ; --UNCHK
lin tranylcypromine_N = mkWN "tranyylisypromiini" ; --UNCHK
lin trap_N = mkWN (k9 "ansa") ;
lin trap_V = mkWV (k71 "tehdä") "liikkumattomaksi" ; --UNCHK
lin trap_V2 = mkWV2 (k71 "tehdä") "liikkumattomaksi" ; --UNCHK
lin trap_door_N = mkWN (k1A "luukku") ; --UNCHK
lin trapeze_N = mkWN (k6 "trapetsi") ; --UNCHK
lin trapezium_N = mkWN (compoundN "monikulma" (k18 "luu")) "iso" ; --UNCHK
lin trapezius_N = mkWN (k41A "epäkäs") ; --UNCHK
lin trapezohedron_N = mkWN (compoundN "moni" (k41A "tahokas")) ; --UNCHK
lin trapezoid_N = mkWN (compoundN "ranne" (k18 "luu")) ; --UNCHK
lin trapezoidal_A = mkWA (compoundA "moni" (k38 "tahokkainen")) ; --UNCHK
lin trapper_N = mkWN "ansastaja" ; --UNCHK
lin trappist_N = mkWN (k38 "sisterssiläinen") ; --UNCHK
lin trapshooter_N = mkWN (compoundN "savikiekko" (k10 "ampuja")) ; --UNCHK
lin trash_N = mkN "jäte" ; --mkWN (k18 "jää") ;
lin trash_V2 = mkWV2 (k53A "löylyttää") ; --UNCHK
lin trashy_A = mkWA (k15 "pramea") ; --UNCHK
lin trauma_N = mkWN (k9 "trauma") "psyykkinen" ; --UNCHK
lin traumatic_A = mkWA (k38 "traumaattinen") ; --UNCHK
lin traumatology_N = mkWN (compoundN "tapaturma" (k12 "kirurgia")) ; --UNCHK
lin traumatophobia_N = mkWN (compoundN "traumato" (k12 "fobia")) ; --UNCHK
lin travail_N = mkWN (k9 "vaiva") ; --UNCHK
lin trave_N = mkWN (compoundN "poikki" (k5A "palkki")) ; --UNCHK
lin travel_N = mkN "matka" ;
lin travel_V = L.travel_V ;
lin travel_V2 = mkV2 "matkustaa" illative ;
lin traveler_N = mkWN (k10 "matkustaja") ; --UNCHK
lin travelled_A = mkWA "matkustellut" ; --UNCHK
lin traveller_N = mkWN (k10 "matkustaja") ; --UNCHK
lin travelling_N = mkWN "matkustaminen" ; --UNCHK
lin travelogue_N = mkWN (compoundN "matka" (k39 "kertomus")) ; --UNCHK
lin traversable_A = mkWA (compoundA "kulku" (k38 "kelpoinen")) ; --UNCHK
lin traversal_N = mkWN (k39 "ylitys") ; --UNCHK
lin traverse_N = mkWN (k39 "ylitys") ; --UNCHK
lin traverse_V2 = mkWV2 (k73A "evätä") ; --UNCHK
lin traverser_N = mkWN (k10 "ylittäjä") ; --UNCHK
lin travesty_N = mkWN (k39 "huijaus") ; --UNCHK
lin travesty_V2 = mkWV2 (k67 "irvailla") ; --UNCHK
lin trawl_N = mkWN (k5 "trooli") ; --UNCHK
lin trawl_V = mkWV (k73 "troolata") ; --UNCHK
lin trawl_V2 = mkWV2 (k73 "troolata") ; --UNCHK
lin trawl_net_N = mkWN (k5 "trooli") ; --UNCHK
lin trawler_N = mkWN (k6 "troolari") ; --UNCHK
lin tray_N = mkWN (k9A "kelkka") ; --UNCHK
lin tray_cloth_N = mkWN (compoundN "tarjotin" (k9 "liina")) ; --UNCHK
lin trazodone_N = mkWN "tratsodoni" ; --UNCHK
lin treacherous_A = mkWA (k10 "kavala") ; --UNCHK
lin treachery_N = mkWN (k39 "petos") ; --UNCHK
lin treacle_N = mkWN (k5A "siirappi") ; --UNCHK
lin treacly_A = mkWA (k10 "imelä") ; --UNCHK
lin tread_N = mkWN (k49 "askel") ; --UNCHK
lin tread_V = mkWV (k53A "jännittää") ; --UNCHK
lin tread_V2 = mkWV2 (k53A "jännittää") ; --UNCHK
lin treadle_N = mkWN (k5 "pedaali") ; --UNCHK
lin treadle_V = mkWV (k58A "polkea") ; --UNCHK
lin treadmill_N = mkWN (compoundN "suola" (k39 "kaivos")) ; --UNCHK
lin treason_N = mkWN (k39 "petos") ; --UNCHK
lin treasonable_A = mkWA (k34A "uskoton") ; --UNCHK
lin treasonous_A = mkWA (k34A "uskoton") ; --UNCHK
lin treasure_N = mkWN (compoundN "taide" (k48A "aarre")) ; --UNCHK
lin treasure_V2 = mkWV2 (k61 "vaalia") ; --UNCHK
lin treasure_house_N = mkWN (compoundN "aarre" (k3 "kammio")) ; --UNCHK
lin treasure_trove_N = mkWN (compoundN "aarre" (k1A "löytö")) ; --UNCHK
lin treasurer_N = mkWN (k10 "johtaja") "rahatoimiston" ; --UNCHK
lin treasurership_N = mkWN (k10 "asema") ; --UNCHK
lin treasury_N = mkWN (compoundN "pankki" (k5 "holvi")) ;
lin treat_N = mkWN (k1A "nautinto") ; --UNCHK
lin treat_V = mkV "hoitua" ; --mkWV (k53A "hoitaa") ;
lin treat_V2 = mkWV2 (k53A "hoitaa") ;
lin treatise_N = mkWN (k10 "tutkielma") ; --UNCHK
lin treatment_N = mkWN (k2 "käsittely") ;
lin treaty_N = mkWN (k39 "sopimus") ;
lin treble_A = mkWA (k15 "korkea") ; --UNCHK
lin treble_N = mkWN (k2 "sopraano") ; --UNCHK
lin treble_V = mkWV (k53 "kolminkertaistaa") ; --UNCHK
lin treble_V2 = mkWV2 (k53 "kolminkertaistaa") ; --UNCHK
lin tredegar_PN = foreignPN "Tredegar" ;
lin tree_N = L.tree_N ;
lin tree_V2 = mkWV2 (k53A "venyttää") "lestillä" ; --UNCHK
lin tree_fern_N = mkWN (k38 "saniainen") ; --UNCHK
lin treehopper_N = mkWN (compoundN "sarvi" (k41 "kaskas")) ; --UNCHK
lin treeless_A = mkWA (k34A "puuton") ; --UNCHK
lin treelet_N = mkWN (k18 "puu") ; --UNCHK
lin treenail_N = mkWN (k9 "vaarna") ; --UNCHK
lin trefoil_N = mkWN (compoundN "kolmilehti" (k5A "ornamentti")) ; --UNCHK
lin trek_N = mkWN (k39 "vaellus") ; --UNCHK
lin trek_V = mkWV (k54A "vaeltaa") ; --UNCHK
lin trekker_N = mkWN (k10 "vaeltaja") ; --UNCHK
lin trellis_N = mkWN (k4A "säleikkö") ; --UNCHK
lin trellis_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin tremble_N = mkWN (k12 "hytinä") ; --UNCHK
lin tremble_V = mkWV (k66 "väristä") ; --UNCHK
lin trembles_N = mkWN (compoundN "eläin" (k5A "tauti")) ; --UNCHK
lin tremendous_A = mkWA (k26 "suuri") "suunnattoman" ; --UNCHK
lin tremolite_N = mkWN "tremoliitti" ; --UNCHK
lin tremolo_N = mkWN (k2 "tremolo") ; --UNCHK
lin tremor_N = mkWN (k12 "vapina") ; --UNCHK
lin tremulous_A = mkWA (compoundA "väris" (k10 "evä")) ; --UNCHK
lin trench_N = mkWN (k10 "oja") ; --UNCHK
lin trench_V2 = mkWV2 (k56 "kaivaa") ; --UNCHK
lin trenchancy_N = mkWN (k40 "purevuus") ; --UNCHK
lin trenchant_A = mkWA (k15 "selkeä") ; --UNCHK
lin trencher_N = mkWN (compoundN "leikkuu" (k9A "lauta")) ; --UNCHK
lin trencherman_N = mkWN (k6 "syömäri") ; --UNCHK
lin trend_N = mkN "trendi" ;
lin trend_V = mkWV (k58A "kulkea") "poikki" ; --UNCHK
lin trend_setting_N = mkWN (compoundN "suunnan" (k1A "näyttö")) ; --UNCHK
lin trendsetting_A = mkWA (k10 "luova") "muotisuuntausta" ; --UNCHK
lin trendy_A = mkWA (k41A "trendikäs") ;
lin trepan_N = mkWN (k10 "pora") ; --UNCHK
lin trepan_V2 = mkWV2 "trepanoida" ; --UNCHK
lin trepang_N = mkWN (compoundN "meri" (k12 "makkara")) ; --UNCHK
lin trephination_N = mkWN (compoundN "kallon" (k39 "poraus")) ; --UNCHK
lin trephine_N = mkWN (compoundN "luu" (k10 "pora")) ; --UNCHK
lin trepidation_N = mkWN (k40 "hermostuneisuus") ; --UNCHK
lin treponema_N = mkWN "treponema" ; --UNCHK
lin trespass_N = mkN "tunkeutuminen" ; --mkWN (k2 "häpäisy") ;
lin trespass_V = mkWV (k52A "tunkeutua") ; --UNCHK
lin trespasser_N = mkWN (k12 "tungettelija") ; --UNCHK
lin tress_N = mkWN (k4A "palmikko") ; --UNCHK
lin trestle_bridge_N = mkWN (compoundN "palkki" (k9A "silta")) ; --UNCHK
lin trestle_table_N = mkWN (compoundN "pukki" (k10A "pöytä")) ; --UNCHK
lin trestlework_N = mkWN (k2 "palkisto") ; --UNCHK
lin trey_N = mkWN (k38 "kolmonen") ; --UNCHK
lin triad_N = mkWN (k5 "akordi") ; --UNCHK
lin triage_N = mkWN (k2 "luokittelu") ; --UNCHK
lin trial_N = mkN "koetus" ;
lin triamcinolone_N = mkWN "Kenalog" ; --UNCHK
lin triangle_N = mkWN (k6 "triangeli") ; --UNCHK
lin triangular_A = mkWA (compoundA "kolmikul" (k38 "mainen")) ; --UNCHK
lin triangularity_N = mkWN (compoundN "kolmi" (k40 "omaisuus")) ; --UNCHK
lin triangulate_A = mkWA (compoundA "kolmi" (k38 "omainen")) ; --UNCHK
lin triangulation_N = mkWN (compoundN "kolmio" (k39 "mittaus")) ; --UNCHK
lin triazine_N = mkWN "triatsiini" ; --UNCHK
lin triazolam_N = mkWN "Halcion" ; --UNCHK
lin tribadism_N = mkWN (compoundN "tribad" (k5 "ismi")) ; --UNCHK
lin tribadistic_A = mkWA "triabistinen" ; --UNCHK
lin tribal_A = mkWA "heimon" ; --UNCHK
lin tribalism_N = mkWN (compoundN "tribal" (k5 "ismi")) ; --UNCHK
lin tribalization_N = mkWN (compoundN "heimo" (k39 "vihkimys")) ; --UNCHK
lin tribe_N = mkWN (k1 "heimo") ; --UNCHK
lin tribesman_N = mkWN (k32 "jäsen") "heimon" ; --UNCHK
lin tribologist_N = mkWN (compoundN "kone" (k4A "teknikko")) ; --UNCHK
lin tribology_N = mkWN (compoundN "kone" (k14A "tekniikka")) ; --UNCHK
lin tribromoethanol_N = mkWN (compoundN "tribromo" (k5 "etanoli")) ; --UNCHK
lin tribulation_N = mkWN (k39 "koettelemus") ; --UNCHK
lin tribunal_N = mkWN (k1A "istunto") ; --UNCHK
lin tribune_N = mkWN (compoundN "piispan" (k33 "istuin")) ; --UNCHK
lin tribuneship_N = mkWN (k10 "asema") ; --UNCHK
lin tributary_A = mkWA (compoundA "myötä" (k10 "vaikuttava")) ; --UNCHK
lin tributary_N = mkWN (compoundN "sivu" (k7A "joki")) ; --UNCHK
lin tribute_N = mkWN (compoundN "suojelu" (k9 "raha")) ; --UNCHK
lin tributyrin_N = mkWN "tributyriini" ; --UNCHK
lin trice_N = mkWN (k10 "kotva") ; --UNCHK
lin trice_V2 = mkWV2 (k53 "nostaa") ; --UNCHK
lin tricentenary_A = mkWA "kolmisatavuotinen" ; --UNCHK
lin triceps_N = mkWN (compoundN "olka" (k39 "lihas")) "kolmipäinen" ; --UNCHK
lin triceratops_N = mkWN (k1 "hirmulisko") ; --UNCHK
lin trichina_N = mkWN (k6 "trikiini") ; --UNCHK
lin trichinosis_N = mkWN (k5 "trikinoosi") ; --UNCHK
lin trichion_N = mkWN (k9 "hiusraja") ; --UNCHK
lin trichloride_N = mkWN "trikloridi" ; --UNCHK
lin trichlormethiazide_N = mkWN "Naqua" ; --UNCHK
lin trichloroethylene_N = mkWN (compoundN "trikloori" (k5 "etyleeni")) ; --UNCHK
lin trichodesmium_N = mkWN "trichodesmium" ; --UNCHK
lin trichomonad_N = mkWN (k6 "bakteeri") ; --UNCHK
lin trichomoniasis_N = mkWN (compoundN "trikomoni" (k5 "aasi")) ; --UNCHK
lin trichotillomania_N = mkWN (compoundN "trikotillo" (k12 "mania")) ; --UNCHK
lin trichotomy_N = mkWN (compoundN "kolmi" (k1A "jako")) ; --UNCHK
lin trichroism_N = mkWN (compoundN "tri" (k5 "kromi")) ; --UNCHK
lin trichromatic_A = mkWA (compoundA "kolmi" (k38 "värinen")) ; --UNCHK
lin trichuriasis_N = mkWN (compoundN "trikuri" (k5 "aasi")) ; --UNCHK
lin trick_N = mkWN (k3 "illuusio") ; --UNCHK
lin trick_V2 = mkWV2 (k53A "vedättää") ; --UNCHK
lin trickery_N = mkWN (k39 "petos") ; --UNCHK
lin trickiness_N = mkWN (k40 "mutkikkuus") ; --UNCHK
lin trickle_N = mkWN (k1A "vuoto") ; --UNCHK
lin trickle_V = mkWV (k53A "valuttaa") ; --UNCHK
lin trickle_V2 = mkWV2 (k53A "valuttaa") ; --UNCHK
lin trickster_N = mkWN (compoundN "haltia" (k1 "hahmo")) ; --UNCHK
lin tricksy_A = mkWA (k10 "näppärä") ; --UNCHK
lin tricky_A = mkA "hankala" ;
lin triclinic_A = mkWA (compoundA "tri" (k38 "kliininen")) ; --UNCHK
lin triclinium_N = mkWN "triclinium" ; --UNCHK
lin tricolor_N = mkWN (k6 "trikolori") ; --UNCHK
lin tricolour_N = mkWN (k6 "trikolori") ; --UNCHK
lin tricorn_N = mkWN (compoundN "kolmikolkka" (k1A "hattu")) ; --UNCHK
lin tricot_N = mkWN (k20 "trikoo") ; --UNCHK
lin tricuspid_A = mkWA (compoundA "trikuspida" (k38 "alinen")) ; --UNCHK
lin tricycle_N = mkWN (compoundN "kolmi" (k38 "pyöräinen")) ; --UNCHK
lin tricyclic_N = mkWN (compoundN "masennus" (k48A "lääke")) "trisyklinen" ; --UNCHK
lin trident_N = mkWN (k33 "atrain") ; --UNCHK
lin tridymite_N = mkWN "tridymiitti" ; --UNCHK
lin triennial_A = mkWA (compoundA "kolmi" (k38 "vuotinen")) ; --UNCHK
lin triennial_N = mkWN (k5 "triennaali") ; --UNCHK
lin trier_N = mkWN "kokeilija" ; --UNCHK
lin trieste_PN = foreignPN "Trieste" ;
lin trifid_A = mkWA (compoundA "kolmi" (k38 "osainen")) ; --UNCHK
lin trifle_V = mkWV (k61A "leikkiä") ; --UNCHK
lin trifle_V2 = mkWV2 (k61A "leikkiä") ; --UNCHK
lin trifler_N = mkWN (k6 "veijari") ; --UNCHK
lin trifoliate_A = mkWA (compoundA "kolmi" (k38 "lehtinen")) ; --UNCHK
lin trifurcation_N = mkWN "kolmeen" "jakautuminen" ; --UNCHK
lin trigeminal_N = mkWN (compoundN "kolmois" (k1 "hermo")) ; --UNCHK
lin trigger_N = mkWN (compoundN "alku" (k39 "sysäys")) ; ---ARB
lin trigger_V2 = mkV2 "laukaista" ;
lin triggerfish_N = mkWN (compoundN "pikkusäppi" (k9 "kala")) ; --UNCHK
lin triglyceride_N = mkWN "triglyseridi" ; --UNCHK
lin trigon_N = mkWN (k9 "lyyra") ; --UNCHK
lin trigonometric_A = mkWA (k38 "trigonometrinen") ; --UNCHK
lin trigonometrician_N = mkWN (k4A "matemaatikko") ; --UNCHK
lin trigonometry_N = mkWN (k12 "trigonometria") ; --UNCHK
lin trigram_N = mkWN (k9 "sana") "kolmikirjaiminen" ; --UNCHK
lin trihydroxy_A = mkWA (compoundA "trio" (k38 "ksiidinen")) ; --UNCHK
lin triiodothyronine_N = mkWN (compoundN "kilpirauhas" (k5 "hormoni")) ; --UNCHK
lin trilateral_A = mkWA (compoundA "kolmikul" (k38 "mainen")) ; --UNCHK
lin trilby_N = mkWN (compoundN "huopa" (k1A "hattu")) ; --UNCHK
lin trilingual_A = mkWA (compoundA "kolmi" (k38 "kielinen")) ; --UNCHK
lin trill_N = mkWN (k5 "trilli") ; --UNCHK
lin trillion_A = mkWA (k10 "biljoona") ; --UNCHK
lin trillion_N = mkWN (k10 "triljoona") ; --UNCHK
lin trillionth_A = mkWA "triljoonas" ; --UNCHK
lin trillionth_N = mkWN (compoundN "biljoonas" (k10 "osa")) ; --UNCHK
lin trillium_N = mkWN (k9 "lilja") ; --UNCHK
lin trilobate_A = mkWA (compoundA "kolmi" (k38 "lehtinen")) ; --UNCHK
lin trilobite_N = mkWN (compoundN "trilo" (k5A "biitti")) ; --UNCHK
lin trilogy_N = mkWN (k12 "trilogia") ; --UNCHK
lin trim_A = mkWA (k10 "jäntevä") ; --UNCHK
lin trim_N = mkWN (k39 "trimmaus") ; --UNCHK
lin trim_V = mkV "karsiutua" ;
lin trim_V2 = mkWV2 (k53A "säätää") ; --UNCHK
lin trimaran_N = mkWN (k5 "trimaraani") ; --UNCHK
lin trimer_N = mkWN (k5 "polymeeri") ; --UNCHK
lin trimester_N = mkWN (compoundN "luku" (k27 "kausi")) ; --UNCHK
lin trimipramine_N = mkWN "Surmontil" ; --UNCHK
lin trimmer_N = mkWN (k5A "palkki") ; --UNCHK
lin trimming_N = mkWN (k48 "koriste") ; --UNCHK
lin trimotored_A = mkWA (compoundA "kolmi" (k38 "moottorinen")) ; --UNCHK
lin tring_PN = foreignPN "Tring" ;
lin trinidad_PN = foreignPN "Trinidad" ;
lin trinidadian_A = mkWA (compoundA "trinidadi" (k38 "lainen")) ; --UNCHK
lin trinidadian_N = mkWN (compoundN "trinidadi" (k38 "lainen")) ; --UNCHK
lin trinitrotoluene_N = mkWN (k6 "trotyyli") ; --UNCHK
lin trinity_N = mkWN (k4A "kolmikko") ; --UNCHK
lin trinket_N = mkWN (k1 "koru") ; --UNCHK
lin trinucleate_A = mkWA (compoundA "kolmitu" (k38 "mainen")) ; --UNCHK
lin trio_N = mkWN (k1 "trio") ; --UNCHK
lin triode_N = mkWN "triodi" ; --UNCHK
lin triolein_N = mkWN "oleiini" ; --UNCHK
lin triose_N = mkWN "trioosi" ; --UNCHK
lin trioxide_N = mkWN (compoundN "tri" (k5 "oksidi")) ; --UNCHK
lin trip_N = mkN "matka" ;
lin trip_V = mkWV (k53A "vetää") "huumeita" ; --UNCHK
lin trip_out_V = mkWV (k53A "vetää") "huumeita" ; --UNCHK
lin trip_up_V = mkWV (k63 "saada") "kiikkiin" ; --UNCHK
lin tripalmitin_N = mkWN "tripalmitiini" ; --UNCHK
lin tripartite_A = mkWA (compoundA "kolmen" (k38 "keskinen")) ; --UNCHK
lin tripe_N = mkWN (k6 "liirumlaarum") ; --UNCHK
lin triphammer_N = mkWN (compoundN "pudotus" (k12 "vasara")) ; --UNCHK
lin triphosphopyridine_N = mkWN "trifosfopyridiini" ; --UNCHK
lin tripinnate_A = mkWA (compoundA "kolmi" (k38 "parinen")) ; --UNCHK
lin tripinnatifid_A = mkWA (compoundA "kolmi" (k38 "halkoinen")) ; --UNCHK
lin triple_A = mkWA (compoundA "kolmi" (k38 "nkertainen")) ;
lin triple_N = mkWN (compoundN "kolmoispesä" (k5A "lyönti")) ; --UNCHK
lin triple_V = mkWV (k53 "kolminkertaistaa") ; --UNCHK
lin triple_V2 = mkWV2 (k53 "kolminkertaistaa") ; --UNCHK
lin triplet_N = mkWN (k4A "kolmikko") ; --UNCHK
lin tripletail_N = mkWN (compoundN "kolmi" (k1 "pyrstö")) ; --UNCHK
lin triplex_A = mkWA (compoundA "kolmi" (k38 "nkertainen")) ; --UNCHK
lin triplicate_N = mkWN (k3 "kopio") ; --UNCHK
lin triplicity_N = mkWN (k40 "suuruus") ; --UNCHK
lin tripling_N = mkWN (compoundN "kerto" (k1 "lasku")) ; --UNCHK
lin triploid_A = mkWA "triploidinen" ; --UNCHK
lin tripod_N = mkWN (compoundN "kolmi" (k9A "jalka")) ; --UNCHK
lin tripos_N = mkWN (compoundN "loppu" (k1A "tutkinto")) ; --UNCHK
lin tripper_N = mkWN (k1A "sulku") ; --UNCHK
lin triptych_N = mkWN (k5A "triptyykki") ; --UNCHK
lin triquetral_N = mkWN (compoundN "kolmio" (k18 "luu")) ; --UNCHK
lin trireme_N = mkWN (compoundN "kolmi" (k1A "soutu")) ; --UNCHK
lin trisaccharide_N = mkWN (compoundN "tri" (k5 "sakkaridi")) ; --UNCHK
lin triskaidekaphobia_N = mkWN (compoundN "triskaideka" (k12 "fobia")) ; --UNCHK
lin triskaidekaphobic_A = mkWA (compoundA "kam" (k38 "moinen")) ; --UNCHK
lin triskelion_N = mkWN (k3 "kuvio") ; --UNCHK
lin trismus_N = mkWN (k39 "kouristus") ; --UNCHK
lin trisomy_N = mkWN (compoundN "kromosomi" (k3 "häiriö")) ; --UNCHK
lin tristearin_N = mkWN (compoundN "tri" (k5 "steariini")) ; --UNCHK
lin trisyllable_N = mkWN (k9 "sana") "kolmitavuinen" ; --UNCHK
lin tritanopia_N = mkWN (compoundN "keltasiniväri" (k40 "sokeus")) ; --UNCHK
lin tritanopic_A = mkWA "keltasinivärisokeuden" ; --UNCHK
lin trite_A = mkWA (k38 "tavallinen") ; --UNCHK
lin triteness_N = mkWN (k40 "latteus") ; --UNCHK
lin tritheism_N = mkWN (compoundN "tri" (k5 "teismi")) ; --UNCHK
lin tritheist_N = mkWN (k5 "triteisti") ; --UNCHK
lin tritium_N = mkWN "tritium" ; --UNCHK
lin triumph_N = mkWN (k39 "menestys") ; --UNCHK
lin triumph_V = mkWV (k53 "juhlistaa") ; --UNCHK
lin triumphal_A = mkWA (k10 "voittoisa") ; --UNCHK
lin triumphant_A = mkWA (k10 "voittoisa") ; --UNCHK
lin triumvir_N = mkWN (compoundN "trium" (k5 "viri")) ; --UNCHK
lin triumvirate_N = mkWN (k5A "triumviraatti") ; --UNCHK
lin trivalent_A = mkWA (compoundA "kolmi" (k38 "arvoinen")) ; --UNCHK
lin trivet_N = mkWN (compoundN "pannun" (k13 "alusta")) ; --UNCHK
lin trivial_A = mkWA (k5 "triviaali") ; --UNCHK
lin trivialize_V2 = mkV2 "väheksyä" ;
lin trivium_N = mkWN "trivium" ; --UNCHK
lin trochaic_A = mkWA "trokeinen" ; --UNCHK
lin trochee_N = mkWN (k20 "trokee") ; --UNCHK
lin trochlear_N = mkWN (compoundN "tela" (k1 "hermo")) ; --UNCHK
lin troglodyte_N = mkWN (compoundN "luola" (k38 "ihminen")) ; --UNCHK
lin trogon_N = mkWN (compoundN "trogoni" (k1A "lintu")) ; --UNCHK
lin troika_N = mkWN (k10A "troikka") ; --UNCHK
lin trojan_A = mkWA (compoundA "troij" (k38 "alainen")) ; --UNCHK
lin trojan_N = mkWN (compoundN "troijan" (k38 "hevonen")) ; --UNCHK
lin troll_N = mkWN (k2 "uistelu") ; --UNCHK
lin troll_V = mkWV (k53A "rallattaa") ; --UNCHK
lin troll_V2 = mkWV2 (k53A "rallattaa") ; --UNCHK
lin trolley_N = mkWN (compoundN "johdin" (k5 "bussi")) ; --UNCHK
lin trolley_car_N = mkWN (compoundN "johdin" (k5 "bussi")) ; --UNCHK
lin trolleybus_N = mkWN (compoundN "johdin" (k1 "auto")) ; --UNCHK
lin trollop_N = mkWN (k1A "narttu") ; --UNCHK
lin trombiculiasis_N = mkWN (compoundN "punkki" (k9A "tartunta")) ; --UNCHK
lin trombiculid_N = mkWN (kH1 "punkki") ; --UNCHK
lin trombidiid_N = mkWN (kH1 "punkki") ; --UNCHK
lin trombone_N = mkWN (compoundN "veto" (k13 "pasuuna")) ; --UNCHK
lin trombonist_N = mkWN (k5 "pasunisti") ; --UNCHK
lin trompillo_N = mkWN (k1 "koiso") ; --UNCHK
lin troon_PN = foreignPN "Troon" ;
lin troop_N = mkN "joukko" ;
lin troop_V = mkWV (k61 "tungeksia") ; --UNCHK
lin troop_V2 = mkWV2 (k61 "tungeksia") ; --UNCHK
lin troop_carrier_N = mkWN (compoundN "joukkojenkuljetus" (k48 "väline")) ; --UNCHK
lin trooper_N = mkWN (compoundN "ratsu" (k41 "sotilas")) ; --UNCHK
lin troopship_N = mkWN (compoundN "joukkojenkuljetus" (k39 "alus")) ; --UNCHK
lin trope_N = mkWN (compoundN "vertaus" (k10 "kuva")) ; --UNCHK
lin trophic_A = mkWA "troofinen" ; --UNCHK
lin trophobiosis_N = mkWN (k5 "symbioosi") ; --UNCHK
lin trophoblast_N = mkWN (compoundN "solu" (k39 "kerros")) "alkiorakkulan" "uloin" ; --UNCHK
lin trophoblastic_A = mkWA (compoundA "trofobl" (k33 "astin")) ; --UNCHK
lin trophotropic_A = mkWA (compoundA "trofobl" (k33 "astin")) ; --UNCHK
lin trophotropism_N = mkWN (k5 "tropismi") ; --UNCHK
lin trophozoite_N = mkWN (k3 "itiö") ; --UNCHK
lin trophy_N = mkWN (k1A "palkinto") ; --UNCHK
lin tropic_N = mkWN (compoundN "kääntö" (k5 "piiri")) ; --UNCHK
lin tropical_A = mkWA (k38 "trooppinen") ; --UNCHK
lin tropism_N = mkWN (k5 "tropismi") ; --UNCHK
lin troponym_N = mkWN "troponyymi" ; --UNCHK
lin troponymy_N = mkWN "troponyymi" ; --UNCHK
lin tropopause_N = mkWN (k5 "troposfääri") ; --UNCHK
lin troposphere_N = mkWN (k5 "troposfääri") ; --UNCHK
lin trot_N = mkWN (k5 "ravi") ; --UNCHK
lin trot_V = mkWV (k73A "hölkätä") ; --UNCHK
lin trot_V2 = mkWV2 (k73A "hölkätä") ; --UNCHK
lin trot_out_V2 = mkWV2 (k67A "esitellä") ; --UNCHK
lin troth_N = mkWN (compoundN "uskollisuuden" (k9 "vala")) ; --UNCHK
lin trotter_N = mkWN (k6 "ravuri") ; --UNCHK
lin troubadour_N = mkWN (k5 "trubaduuri") ; --UNCHK
lin trouble_N = mkN "hankaluus" | mkN "vaikeus" ;
lin trouble_V2 = mkV2 "vaivata" partitive ;
lin troublemaker_N = mkWN (k6 "öykkäri") ; --UNCHK
lin troubleshooter_N = mkWN (k10 "korjaaja") ; --UNCHK
lin troublesome_A = mkWA (k38 "vaivalloinen") ;
lin troublesomeness_N = mkWN (k9 "vaiva") ; --UNCHK
lin troublous_A = mkWA (k15 "vaikea") ; --UNCHK
lin trough_N = mkN "matala" (mkN "suhdanne") ; ---ARB --mkWN (k1 "kouru") ;
lin trough_V = mkV vOlla "aallonpohjassa" ;
lin trounce_V2 = mkWV2 (k73 "saarnata") ; --UNCHK
lin trouncing_N = mkWN (k39 "löylytys") ; --UNCHK
lin troupe_N = mkWN (k48 "seurue") ; --UNCHK
lin trouper_N = mkWN (k12 "näyttelijä") "kiertävä" ; --UNCHK
lin trouser_N = mkN "housu" ;
lin trousseau_N = mkWN (compoundN "kapio" (k1 "kirstu")) ; --UNCHK
lin trout_N = mkWN (k32 "taimen") ; --UNCHK
lin trove_N = mkWN (k48A "aarre") ; --UNCHK
lin trowbridge_PN = foreignPN "Trowbridge" ;
lin trowel_N = mkWN (k9 "lasta") ; --UNCHK
lin troy_N = mkWN "Ilios" ; --UNCHK
lin truancy_N = mkWN (k39 "pinnaus") ; --UNCHK
lin truant_A = mkWA (compoundA "pin" (k9 "naava")) ; --UNCHK
lin truant_N = mkWN (k6 "pinnari") ; --UNCHK
lin truce_N = mkWN (compoundN "väli" (k9 "rauha")) ;
lin truck_N = mkN "rekka" ;
lin truckage_N = mkWN (k39 "kuljetus") ; --UNCHK
lin truckle_N = mkWN (k48A "vuode") ; --UNCHK
lin truckle_V = mkWV (k68 "pokkuroida") ; --UNCHK
lin truckle_bed_N = mkWN (k48A "vuode") ; --UNCHK
lin truckling_N = mkWN "nöyrtyminen" ; --UNCHK
lin truculence_N = mkWN (k40 "hyökkäävyys") ; --UNCHK
lin truculency_N = mkWN (k40 "hyökkäävyys") ; --UNCHK
lin truculent_A = mkWA (k10 "hyökkäävä") ; --UNCHK
lin trudge_N = mkWN (k9 "matka") "vaivalloinen" ; --UNCHK
lin trudge_V = mkWV (k53 "laahustaa") ; --UNCHK
lin trudger_N = mkWN "laahustaja" ; --UNCHK
lin true_A = mkA (mkN "tosi" "toden" "tosia" "totta") "todempi" "tosin" ;
lin true_Adv = mkWAdv (k99 "tosiaan") ; --UNCHK
lin true_N = mkWN (k5 "rivi") ; --UNCHK
lin true_V2 = mkWV2 (k53 "suoristaa") ; --UNCHK
lin truelove_N = mkWN (k41A "rakas") ; --UNCHK
lin trueness_N = mkWN (k40 "totuudellisuus") ; --UNCHK
lin truffle_N = mkWN (compoundN "suklaa" (k6 "tryffeli")) ; --UNCHK
lin truism_N = mkWN (k5 "truismi") ; --UNCHK
lin trump_N = mkWN (k5A "trumpetti") ; --UNCHK
lin trump_V = mkWV (k53 "julistaa") ; --UNCHK
lin trump_V2 = mkWV2 (k53 "julistaa") ; --UNCHK
lin trump_up_V = mkWV (k53A "keittää") "kokoon" ; --UNCHK
lin trumpet_N = mkWN (k5A "trumpetti") ; --UNCHK
lin trumpet_V = mkWV (k53A "toitottaa") ; --UNCHK
lin trumpet_V2 = mkWV2 (k53A "toitottaa") ; --UNCHK
lin trumpeter_N = mkWN (compoundN "kyssä" (k7A "kurki")) ; --UNCHK
lin trumpetfish_N = mkWN (compoundN "trumpetti" (k9 "kala")) ; --UNCHK
lin trumpetwood_N = mkWN (compoundN "muurahais" (k18 "puu")) ; --UNCHK
lin truncate_A = mkWA (k10A "tylppä") ; --UNCHK
lin truncate_V2 = mkWV2 (k54A "lyhentää") ; --UNCHK
lin truncation_N = mkWN (k2 "katkaisu") ; --UNCHK
lin truncheon_N = mkWN (kH1 "pamppu") ; --UNCHK
lin trundle_N = mkWN (k9 "tela") ; --UNCHK
lin trundle_V = mkWV (k66 "jyristä") ; --UNCHK
lin trundle_V2 = mkWV2 (k66 "jyristä") ; --UNCHK
lin trunk_N = mkWN (k10 "kärsä") ; --UNCHK
lin trunk_call_N = mkWN (compoundN "kauko" (k2 "puhelu")) ; --UNCHK
lin trunk_line_N = mkWN (compoundN "puhelin" (k9 "linja")) ; --UNCHK
lin trunk_road_N = mkWN (compoundN "runko" (k19 "tie")) ; --UNCHK
lin truro_PN = foreignPN "Truro" ;
lin truss_N = mkWN (k41 "ansas") ; --UNCHK
lin truss_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin trust_N = mkN (lin NK {s = d39 "luottamus"}) ;
lin trust_V2 = mkV2 "luottaa" illative ;
lin trust_VS = mkWVS (k53A "luottaa") ; --UNCHK
lin trustbuster_N = mkWN (compoundN "virka" (k42 "mies")) ; --UNCHK
lin trustee_N = mkWN (k32 "jäsen") "johtokunnan" ; --UNCHK
lin trusteeship_N = mkWN (k10 "asema") ; --UNCHK
lin trustful_A = mkWA (k38 "luottavainen") ; --UNCHK
lin trustworthiness_N = mkWN (k40 "luotettavuus") ; --UNCHK
lin trustworthy_A = mkWA (k10 "luotettava") ; --UNCHK
lin trusty_A = mkWA (k10 "luotettava") ; --UNCHK
lin trusty_N = mkWN (compoundN "luotto" (k5A "vanki")) ; --UNCHK
lin truth_N = mkWN (k40 "totuus") ;
lin truthful_A = mkWA (k38 "rehellinen") ; --UNCHK
lin truthfulness_N = mkWN (k40 "rehellisyys") ; --UNCHK
lin try_N = mkN "yritys" ;
lin try_V = mkV "kokeilla" ;
lin try_V2 = mkV2 (mkV "syyttää") ;
lin try_VS = mkVS "yrittää" ; --mkWVS (k61 "tutkia") ;
lin try_VV = mkVV (mkV "yrittää") ;
lin try_back_V = advV OP_try_V OP_back_Adv ; -- guess-p-verb
lin try_for_V2 = mkWV2 (k67A "tavoitella") ; --UNCHK
lin try_it_on_V = variants {} ; -- guess-p-verb
lin try_on_V2 = mkWV2 (k67 "kokeilla") ; --UNCHK
lin try_out_V = mkWV (k61 "tutkia") ; --UNCHK
lin try_out_V2 = mkWV2 (k61 "tutkia") ; --UNCHK
lin try_out_for_V2 = prepV2 (advV OP_try_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin trypsin_N = mkWN "trypsiini" ; --UNCHK
lin trypsinogen_N = mkWN (compoundN "trypsino" (k5 "geeni")) ; --UNCHK
lin tryst_N = mkWN (k38 "tapaaminen") "rakastavaisten" "salainen" ; --UNCHK
lin tsar_N = mkWN (k5 "tsaari") ; --UNCHK
lin tsarina_N = mkWN (k32A "tsaaritar") ; --UNCHK
lin tsetse_N = mkWN (compoundN "tsetse" (k38 "kärpänen")) ; --UNCHK
lin tsetse_fly_N = mkWN (compoundN "tsetse" (k38 "kärpänen")) ; --UNCHK
lin tsoris_N = mkWN (k39 "kärsimys") ; --UNCHK
lin tsunami_N = mkWN (compoundN "hyöky" (k1A "aalto")) ; --UNCHK
lin tsuris_N = mkWN (k40 "vaikeus") ; --UNCHK
lin tswana_N = mkWN "sechuana" ; --UNCHK
lin tuatara_N = mkWN "Sphenodon" "punctatum" ; --UNCHK
lin tub_N = mkWN (k41A "allas") ; --UNCHK
lin tuba_N = mkWN (k10 "tuuba") ; --UNCHK
lin tubal_A = mkWA (compoundA "kohdun" (k38 "ulkoinen")) ; --UNCHK
lin tubby_A = mkWA (k10 "pulska") ; --UNCHK
lin tube_N = mkN "tuubi" ;
lin tube_well_N = mkWN (compoundN "putki" (k1 "kaivo")) ; --UNCHK
lin tubed_A = mkWA (compoundA "sisäku" (k38 "millinen")) ; --UNCHK
lin tubeless_A = mkWA (k34A "sisärenkaaton") ; --UNCHK
lin tubeless_N = mkWN (k41A "rengas") "sisäkumiton" ; --UNCHK
lin tuber_N = mkWN (compoundN "Tuber-" (k5 "laji")) ; --UNCHK
lin tubercle_N = mkWN (k12 "nystyrä") ; --UNCHK
lin tubercular_A = mkWA "tuberkuloosi-" ; --UNCHK
lin tuberculate_A = mkWA (k38 "pahkainen") ; --UNCHK
lin tuberculin_N = mkWN (k5 "tuberkuliini") ; --UNCHK
lin tuberculoid_A = mkWA (k38 "tuberkuloottinen") ; --UNCHK
lin tuberculosis_N = mkWN (k5 "tuberkuloosi") ; --UNCHK
lin tuberculous_A = mkWA (k38 "tuberkuloottinen") ; --UNCHK
lin tuberose_N = mkWN (compoundN "tuber" (k10 "osa")) "Polianthes" ; --UNCHK
lin tuberosity_N = mkWN (k12 "nystyrä") ; --UNCHK
lin tuberous_A = mkWA (compoundA "putki" (k38 "mainen")) ; --UNCHK
lin tubful_N = mkWN (k38 "saavillinen") ; --UNCHK
lin tubing_N = mkWN (k5 "tuubi") ; --UNCHK
lin tubocurarine_N = mkWN (k8 "kurare") ; --UNCHK
lin tubular_A = mkWA (compoundA "putki" (k38 "mainen")) ; --UNCHK
lin tubule_N = mkWN (k2 "putkilo") ; --UNCHK
lin tuck_N = mkWN (compoundN "pisto" (k9A "miekka")) ; --UNCHK
lin tuck_V = mkWV (k53A "taivuttaa") ; --UNCHK
lin tuck_V2 = mkWV2 (k53A "taivuttaa") ; --UNCHK
lin tuck_away_V2 = mkWV2 (k61 "ahmia") ; --UNCHK
lin tuck_in_V = mkWV (k61 "ahmia") ; --UNCHK
lin tuck_in_V2 = mkWV2 (k61 "ahmia") ; --UNCHK
lin tuck_shop_N = mkWN (compoundN "karkki" (k9A "kauppa")) ; --UNCHK
lin tucker_N = mkWN (k2 "röyhelö") ; --UNCHK
lin tudung_N = mkWN "tudung" ; --UNCHK
lin tuft_N = mkWN (k1A "töyhtö") ; --UNCHK
lin tufted_A = mkWA "tupsu-" ; --UNCHK
lin tug_N = mkWN (k2 "nykäisy") ; --UNCHK
lin tug_V = mkWV (k73 "hinata") ; --UNCHK
lin tug_V2 = mkWV2 (k73 "hinata") ; --UNCHK
lin tugboat_N = mkWN (k10 "hinaaja") ; --UNCHK
lin tugrik_N = mkWN "tugrug" ; --UNCHK
lin tuille_N = mkWN "tuille" ; --UNCHK
lin tuition_N = mkWN (k39 "opetus") ; --UNCHK
lin tularemia_N = mkWN (compoundN "jänis" (k1A "rutto")) ; --UNCHK
lin tulip_N = mkWN (k6 "tulppaani") ; --UNCHK
lin tulipwood_N = mkWN (compoundN "tulppaani" (k18 "puu")) ; --UNCHK
lin tulle_N = mkWN (kH1 "tylli") ; --UNCHK
lin tumble_N = mkN "romahdus" ;
lin tumble_V = mkV "pyöriä" ;
lin tumble_V2 = mkWV2 (k73 "sysätä") ; --UNCHK
lin tumblebug_N = mkWN (compoundN "lanta" (k38 "kuoriainen")) ; --UNCHK
lin tumbler_N = mkWN (k1 "pulu") ; --UNCHK
lin tumbleweed_N = mkWN (compoundN "revon" (k10A "häntä")) ; --UNCHK
lin tumefaction_N = mkWN (compoundN "pai" (k38 "suminen")) ; --UNCHK
lin tumescence_N = mkWN (compoundN "pai" (k38 "suminen")) ; --UNCHK
lin tumescent_A = mkWA (k15 "pullea") ; --UNCHK
lin tumid_A = mkWA (k99 "pystyssä") ; --UNCHK
lin tumidity_N = mkWN (k39 "turvotus") ; --UNCHK
lin tummy_N = mkWN (k1 "masu") ; --UNCHK
lin tumor_N = mkWN (k33 "kasvain") ; --UNCHK
lin tumour_N = mkWN (k33 "kasvain") ; --UNCHK
lin tumult_N = mkWN (k12 "rähinä") ; --UNCHK
lin tumultuous_A = mkWA (k15 "kiihkeä") ;
lin tumulus_N = mkWN (compoundN "hauta" (k1A "kumpu")) ; --UNCHK
lin tun_N = mkWN (k6 "tynnyri") ; --UNCHK
lin tuna_N = mkWN (k5 "makrilli") ; --UNCHK
lin tunaburger_N = mkWN (compoundN "tonnikala" (k38 "purilainen")) ; --UNCHK
lin tundra_N = mkWN (k10 "tundra") ; --UNCHK
lin tune_N = mkN "sävel" ;
lin tune_V = mkV "virittyä" ; --mkWV (k53A "säätää") ;
lin tune_V2 = mkWV2 (k53A "säätää") ; --UNCHK
lin tune_in_V = mkWV (k53A "virittää") ; --UNCHK
lin tune_up_V2 = mkWV2 (k53A "säätää") ; --UNCHK
lin tuneful_A = mkWA (k38 "melodinen") ; --UNCHK
lin tunefulness_N = mkWN (k40 "melodisuus") ; --UNCHK
lin tuneless_A = mkWA (compoundA "epä" (k38 "sointuinen")) ; --UNCHK
lin tuner_N = mkWN (k3 "radio") ; --UNCHK
lin tung_oil_N = mkWN (compoundN "kiinanpuu" (k1 "öljy")) ; --UNCHK
lin tungstate_N = mkWN (k9 "suola") ; --UNCHK
lin tungsten_N = mkWN (k6 "volframi") ; --UNCHK
lin tunic_N = mkWN (k13 "tunika") ; --UNCHK
lin tunicate_N = mkWN (compoundN "vaippa" (k33 "eläin")) ; --UNCHK
lin tuning_N = mkWN (k39 "viritys") ; --UNCHK
lin tuning_fork_N = mkWN (compoundN "ääni" (k9A "rauta")) ; --UNCHK
lin tunis_PN = foreignPN "Tunis" ;
lin tunisia_PN = foreignPN "Tunisia" ;
lin tunisian_A = mkWA (compoundA "tunisi" (k38 "alainen")) ; --UNCHK
lin tunisian_N = mkWN (compoundN "tunisi" (k38 "alainen")) ; --UNCHK
lin tunnel_N = mkWN (k6 "tunneli") ;
lin tunnel_V = mkWV (k52A "kaivautua") ; --UNCHK
lin tunnel_V2 = mkWV2 (k52A "kaivautua") ; --UNCHK
lin tunny_N = mkWN (compoundN "tonni" (k9 "kala")) ; --UNCHK
lin tup_N = mkWN (k5 "pässi") ; --UNCHK
lin tupelo_N = mkWN (compoundN "Tup" (k1 "elo")) ; --UNCHK
lin tupik_N = mkWN (k9A "teltta") ; --UNCHK
lin tuppence_N = mkWN (compoundN "kaks" (k38 "ipenninen")) ; --UNCHK
lin turban_N = mkWN (compoundN "pilleri" (k12 "rasia")) ; --UNCHK
lin turbaned_A = mkWA (compoundA "turbaani" (k38 "päinen")) ; --UNCHK
lin turbid_A = mkWA (k38 "savinen") ; --UNCHK
lin turbidity_N = mkWN (k40 "sameus") ; --UNCHK
lin turbidness_N = mkWN (k40 "sameus") ; --UNCHK
lin turbinate_A = mkWA "nenäkuorikon" ; --UNCHK
lin turbine_N = mkWN (k6 "turbiini") ;
lin turbogenerator_N = mkWN (compoundN "turbo" (k6 "generaattori")) ; --UNCHK
lin turbojet_N = mkWN (compoundN "turbiini" (k6 "moottori")) ; --UNCHK
lin turboprop_N = mkWN "turbopotkurikone" ; --UNCHK
lin turbot_N = mkWN (k13 "kampela") ; --UNCHK
lin turbulence_N = mkWN (k5 "turbulenssi") ;
lin turbulent_A = mkWA (compoundA "myl" (k10 "läävä")) ; --UNCHK
lin turd_N = mkWN (k10A "sonta") ; --UNCHK
lin tureen_N = mkWN (k6 "terriini") ; --UNCHK
lin turenki_PN = mkPN "Turenki" ;
lin turf_N = mkN (lin NK {s = d07 "nurmi"}) ;
lin turf_V2 = mkWV2 (k53A "nurmettaa") ; --UNCHK
lin turgid_A = mkWA (k15 "pullea") ; --UNCHK
lin turgidity_N = mkWN (k40 "mahtipontisuus") ; --UNCHK
lin turgor_N = mkWN (compoundN "neste" (k39 "jännitys")) ; --UNCHK
lin turin_PN = foreignPN "Torino" ;
lin turk_N = mkWN (k38 "turkkilainen") ; --UNCHK
lin turkey_N = mkWN (k12 "kalkkuna") ; --UNCHK
lin turkey_PN = mkPN "Turkki" ;
lin turkishFem_N = mkWN (kH1 "turkki") ; --UNCHK
lin turkishMasc_N = mkWN (kH1 "turkki") ; --UNCHK
lin turkish_A = mkWA (k38 "turkkilainen") ; --UNCHK
lin turku_PN = mkPN "Turku" ;
lin turmeric_N = mkWN (k10 "kurkuma") ; --UNCHK
lin turmoil_N = mkN "levottomuus" ;
lin turn_N = mkN "käänne" | mkN "vuoro" ; ---- split
lin turn_V = L.turn_V ;
lin turn_V2 = mkV2 "kääntää" partitive | mkV2 (mkV "kääntää") accusative ;
lin turn_VA = mkVA (mkV "muuttua") (mkPrep translative) ;
lin turn_against_V2 = prepV2 OP_turn_V OP_against_Prep ; -- guess-p-verb
lin turn_around_V2 = mkWV2 (k52A "parantua") ; --UNCHK
lin turn_away_V = mkWV (k52A "kääntyä") "selin" ; --UNCHK
lin turn_away_V2 = mkWV2 (k52A "kääntyä") "selin" ; --UNCHK
lin turn_back_V = advV OP_turn_V OP_back_Adv ; -- guess-p-verb
lin turn_down_V2 = mkWV2 (k58 "laskea") ; --UNCHK
lin turn_in_V = mkWV (k67 "mennä") "sänkyyn" ; --UNCHK
lin turn_in_V2 = mkWV2 (k67 "mennä") "sänkyyn" ; --UNCHK
lin turn_into_V2 = prepV2 OP_turn_V OP_into_Prep ; -- guess-p-verb
lin turn_off_N = mkWN (k10 "liittymä") ; --UNCHK
lin turn_off_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin turn_on_V = mkWV (k65 "käydä") "kimppuun" ; --UNCHK
lin turn_on_V2 = mkWV2 (k65 "käydä") "kimppuun" ; --UNCHK
lin turn_out_V = mkWV (k66 "nousta") "ylös" ; --UNCHK
lin turn_out_V2 = mkWV2 (k66 "nousta") "ylös" ; --UNCHK
lin turn_over_V = mkWV (k62 "puntaroida") ; --UNCHK
lin turn_over_V2 = mkWV2 (k62 "puntaroida") ; --UNCHK
lin turn_to_V2 = prepV2 OP_turn_V OP_to_Prep ; -- guess-p-verb
lin turn_up_V = mkWV (k52A "näyttäytyä") ; --UNCHK
lin turn_up_V2 = mkWV2 (k52A "näyttäytyä") ; --UNCHK
lin turnaround_N = mkWN (k39 "käännös") ; --UNCHK
lin turnbuckle_N = mkWN (compoundN "vantti" (k5 "ruuvi")) ; --UNCHK
lin turncoat_N = mkWN (k6 "petturi") ; --UNCHK
lin turncock_N = mkWN (compoundN "sulku" (k6 "venttiili")) ; --UNCHK
lin turner_N = mkWN (k9 "lasta") ; --UNCHK
lin turning_N = mkWN (k39 "muutos") ; --UNCHK
lin turning_point_N = mkWN (k10 "kulma") ; --UNCHK
lin turnip_N = mkWN (k5 "turnipsi") ; --UNCHK
lin turnkey_N = mkN "vanginvartija" "vanginvartijoita" ; --WN (kH1 "pamppu") ;
lin turn_out_N = mkWN (compoundN "auki" (k1A "kierto")) ; --UNCHK
lin turnover_N = mkN "liikevaihto" ; ---ARB mkWN "kumoaminen" ;
lin turnpike_N = mkWN (k19 "tie") "maksullinen" ; --UNCHK
lin turnspit_N = mkWN (compoundN "kääntö" (k41A "varras")) ; --UNCHK
lin turnstile_N = mkWN (compoundN "pyörö" (k7 "ovi")) ; --UNCHK
lin turnstone_N = mkWN (compoundN "kari" (k1A "kukko")) ; --UNCHK
lin turntable_N = mkWN (compoundN "levy" (k38 "lautanen")) ; --UNCHK
lin turnverein_N = mkWN (compoundN "taitovoimistelu" (k9 "seura")) ; --UNCHK
lin turpentine_N = mkWN (k5A "tärpätti") ; --UNCHK
lin turpitude_N = mkWN (k40 "halpamaisuus") ; --UNCHK
lin turps_N = mkWN (k5A "tärpätti") ; --UNCHK
lin turquoise_N = mkWN (k6 "turkoosi") ; --UNCHK
lin turreae_N = mkWN (k18 "puu") ; --UNCHK
lin turret_N = mkWN (compoundN "tykki" (k5 "torni")) ; --UNCHK
lin turtle_N = mkWN (compoundN "kilpi" (k10 "konna")) ; --UNCHK
lin turtledove_N = mkWN (compoundN "turturi" (k1 "kyyhky")) ; --UNCHK
lin turtleneck_N = mkWN (compoundN "poolo" (k39 "kaulus")) ; --UNCHK
lin turtler_N = mkWN (compoundN "kilpikonnan" (k10 "metsästäjä")) ; --UNCHK
lin tushery_N = mkWN (k10 "kyhäelmä") ; --UNCHK
lin tusk_N = mkWN (compoundN "syöksy" (k41A "hammas")) ; --UNCHK
lin tusked_A = mkWA (compoundA "tora" (k38 "hampainen")) ; --UNCHK
lin tusker_N = mkWN (compoundN "tora" (k38 "hampainen")) ; --UNCHK
lin tussah_N = mkWN (compoundN "tammi" (k10 "kehrääjä")) ; --UNCHK
lin tussle_N = mkWN (kH1 "kina") ; --UNCHK
lin tussle_V = mkWV (k53A "sekoittaa") ; --UNCHK
lin tussock_N = mkWN (k41A "tupas") ; --UNCHK
lin tut_V2 = mkWV2 (k52 "torua") ; --UNCHK
lin tutee_N = mkWN (k12 "opiskelija") ; --UNCHK
lin tutelage_N = mkWN (k9A "valvonta") ; --UNCHK
lin tutelary_A = mkWA "holhous-" ; --UNCHK
lin tutor_N = mkWN (k6 "tutor") ; --UNCHK
lin tutor_V2 = mkWV2 (k53A "opettaa") ; --UNCHK
lin tutorial_A = mkWA (compoundA "ohj" (k9 "aava")) ; --UNCHK
lin tutorial_N = mkWN (compoundN "intensiivi" (k39 "opetus")) ; --UNCHK
lin tutorship_N = mkWN (k39 "opetus") ; --UNCHK
lin tutu_N = mkWN (compoundN "baletti" (k48 "hame")) ; --UNCHK
lin tuulos_PN = mkPN "Tuulos" ;
lin tuupovaara_PN = mkPN "Tuupovaara" ;
lin tuusniemi_PN = mkPN (mkN "Tuusniemi" "Tuusniemiä") ;
lin tuusula_PN = mkPN "Tuusula" ;
lin tuxedo_N = mkWN (k5A "smokki") ; --UNCHK
lin tuxedoed_A = mkWA (compoundA "smokki" (k38 "asuinen")) ; --UNCHK
lin tv_N = mkN "TV" ;
lin twaddle_N = mkWN (k5 "humpuuki") ; --UNCHK
lin twaddle_V = mkWV (k53A "pälättää") ; --UNCHK
lin twaddler_N = mkWN "jaarittelija" ; --UNCHK
lin twain_N = mkWN (k1A "duetto") ; --UNCHK
lin twang_N = mkWN (k39 "honotus") ; --UNCHK
lin twang_V = mkWV (k53A "honottaa") ; --UNCHK
lin twang_V2 = mkWV2 (k53A "honottaa") ; --UNCHK
lin twayblade_N = mkWN (compoundN "soikko" (k4A "kaksikko")) ; --UNCHK
lin tweak_N = mkWN (k39 "nipistys") ; --UNCHK
lin tweak_V2 = mkWV2 (k53A "virittää") ; --UNCHK
lin twee_A = mkWA (k10 "imelä") ; --UNCHK
lin tweed_N = mkN "tweed" (mkN "kangas") ;
lin tweediness_N = mkWN (k40 "kotoisuus") ; --UNCHK
lin tweedy_A = mkWA "tweedy" ; --UNCHK
lin tweet_N = mkWN (k39 "piipitys") ; --UNCHK
lin tweet_V = mkWV (k54A "pusertaa") ; --UNCHK
lin tweeter_N = mkWN (compoundN "kova" (k38 "ääninen")) ; --UNCHK
lin twelfth_night_N = mkWN (k38 "loppiainen") ; --UNCHK
lin twelvemonth_N = mkWN (k27 "vuosi") ; --UNCHK
lin twerp_N = mkWN (k3 "ääliö") ; --UNCHK
lin twice_Adv = mkWAdv (k99 "kahdesti") ; --f56
lin twiddle_N = mkWN (k2 "kiemurtelu") ; --UNCHK
lin twiddle_V = mkWV (k73 "nyplätä") ; --UNCHK
lin twiddle_V2 = mkWV2 (k73 "nyplätä") ; --UNCHK
lin twiddler_N = mkWN "hypistelijä" ; --UNCHK
lin twig_N = mkWN (k1 "verso") ; --UNCHK
lin twig_V = mkWV (k53A "törröttää") ; --UNCHK
lin twig_V2 = mkWV2 (k53A "törröttää") ; --UNCHK
lin twiggy_A = mkWA (compoundA "tikku" (k38 "mainen")) ; --UNCHK
lin twilight_N = mkWN (k10 "hämärä") ; --UNCHK
lin twilit_A = mkWA (k10 "hämärä") ; --UNCHK
lin twill_N = mkWN (k41A "toimikas") ; --UNCHK
lin twilled_A = mkWA (compoundA "koho" (k38 "raitainen")) ; --UNCHK
lin twin_N = mkWN (k39 "jäljennös") ; --UNCHK
lin twin_V2 = mkWV2 (k53A "synnyttää") ; --UNCHK
lin twinberry_N = mkWN (compoundN "pyyn" (k9 "marja")) ; --UNCHK
lin twine_N = mkWN (k5 "nyöri") ; --UNCHK
lin twine_V = mkWV (k54A "kiertää") ; --UNCHK
lin twine_V2 = mkWV2 (k54A "kiertää") ; --UNCHK
lin twiner_N = mkWN (compoundN "köyden" (k10 "punoja")) ; --UNCHK
lin twinflower_N = mkWN (k2 "vanamo") ; --UNCHK
lin twinge_N = mkWN (k39 "pistos") ; --UNCHK
lin twinjet_N = mkWN (compoundN "suihku" (k48 "kone")) "kaksimoottorinen" ; --UNCHK
lin twinkle_N = mkWN (k48A "välke") ; --UNCHK
lin twinkle_V = mkWV (k61A "tuikkia") ; --UNCHK
lin twinkler_N = mkWN "tuikkija" ; --UNCHK
lin twinkling_N = mkWN (k10 "kotva") ; --UNCHK
lin twins_N = mkWN "Kaksonen" ; --UNCHK
lin twirl_N = mkWN (k9A "pyörintä") ; --UNCHK
lin twirl_V = mkWV (k53A "kieputtaa") ; --UNCHK
lin twirl_V2 = mkWV2 (k53A "kieputtaa") ; --UNCHK
lin twirlingly_Adv = mkWAdv "pökerryttävän" ; --UNCHK
lin twist_N = mkWN (k5 "konsti") ; --UNCHK
lin twist_V2 = mkV2 "vääntää" ; --mkWV2 (k53A "niksauttaa") ;
lin twister_N = mkWN (k12 "rinkilä") "rasvassa" "kypsennetty" ; --UNCHK
lin twisty_A = mkWA (k41 "runsas") ; --UNCHK
lin twit_N = mkWN (k9 "iva") ; --UNCHK
lin twit_V2 = mkWV2 (k53A "ärsyttää") ; --UNCHK
lin twitch_N = mkWN "nykiminen" ; --UNCHK
lin twitch_V = mkWV (k53A "nytkähtää") ; --UNCHK
lin twitch_V2 = mkWV2 (k53A "nytkähtää") ; --UNCHK
lin twitter_N = mkWN (k39 "sirkutus") ; --UNCHK
lin twitter_V = mkWV (k53A "sirkuttaa") ; --UNCHK
lin twitterer_N = mkWN "livertäjä" ; --UNCHK
lin two_way_A = mkA "kaksisuuntainen" ;
lin twofer_N = mkWN (k5A "kuponki") ; --UNCHK
lin twofold_A = mkWA (compoundA "kaks" (k38 "inkertainen")) ; --UNCHK
lin twofold_Adv = mkWAdv (k99 "kaksinkertaisesti") ; --UNCHK
lin twopence_N = mkWN (compoundN "kaks" (k38 "ipenninen")) ; --UNCHK
lin twopenny_A = mkWA (k34A "arvoton") ; --UNCHK
lin tycoon_N = mkWN (k5 "moguli") ; --UNCHK
lin tying_N = mkWN "sitominen" ; --UNCHK
lin tyiyn_N = mkWN "som" ; --UNCHK
lin tyke_N = mkWN (k38 "nuorukainen") ; --UNCHK
lin tympanic_A = mkWA "tärykalvon" ; --UNCHK
lin tympanist_N = mkWN (k6 "rumpali") ; --UNCHK
lin tympanitic_A = mkWA "tympaniittinen" ; --UNCHK
lin tympanitis_N = mkWN (compoundN "sisäkorvan" (k39 "tulehdus")) ; --UNCHK
lin tympanoplasty_N = mkWN (k39 "leikkaus") ; --UNCHK
lin tympanum_N = mkWN (kH1 "pata") ; --UNCHK
lin tynemouth_PN = foreignPN "Tynemouth" ;
lin type_N = mkN "tyyppi" ;
lin type_V = mkWV (k67A "tyypitellä") ; --UNCHK
lin type_V2 = mkWV2 (k67A "tyypitellä") ; --UNCHK
lin typecast_V2 = mkWV2 (k67A "tyypitellä") ; --UNCHK
lin typeface_N = mkWN (k33 "kirjasin") ; --UNCHK
lin typescript_N = mkWN (compoundN "kone" (k39 "kirjoitus")) ; --UNCHK
lin typesetter_N = mkWN (k10 "latoja") ; --UNCHK
lin typewriter_N = mkWN (compoundN "kirjoitus" (k48 "kone")) ; --UNCHK
lin typhoid_N = mkWN (compoundN "lavan" (k5A "tauti")) ; --UNCHK
lin typhoon_N = mkWN (k6 "taifuuni") ; --UNCHK
lin typhus_N = mkWN (compoundN "lavan" (k5A "tauti")) ; --UNCHK
lin typical_1_A = mkA "tyypillinen" ;
lin typical_2_A = variants {} ; --
lin typical_3_A = mkA "tyypillinen" ;
lin typical_A = mkA (lin AK {s = d38 "tyypillinen"}) ;
lin typicality_N = mkWN (k40 "tyypillisyys") ; --UNCHK
lin typification_N = mkWN (k2 "tyypittely") ; --UNCHK
lin typify_V2 = mkWV2 (k67 "olla") "vertauskuva" ; --UNCHK
lin typing_N = mkWN (compoundN "kone" (k39 "kirjoitus")) ; --UNCHK
lin typist_N = mkWN (compoundN "kone" (k10 "kirjoittaja")) ; --UNCHK
lin typographer_N = mkWN (k10 "latoja") ; --UNCHK
lin typographic_A = mkWA (k38 "typografinen") ; --UNCHK
lin typography_N = mkWN (k12 "typografia") ; --UNCHK
lin typology_N = mkWN (k12 "typologia") ; --UNCHK
lin tyramine_N = mkWN "tyramiini" ; --UNCHK
lin tyrannical_A = mkWA (k38 "tyrannimainen") ; --UNCHK
lin tyrannicide_N = mkWN (compoundN "tyrannin" (k10 "murha")) ; --UNCHK
lin tyrannid_N = mkWN "muura" ; --UNCHK
lin tyrannize_V = mkWV (k69 "hallita") "tyrannimaisesti" ; --UNCHK
lin tyrannize_V2 = mkWV2 (k69 "hallita") "tyrannimaisesti" ; --UNCHK
lin tyrannosaur_N = mkWN (k39 "tyrannosaurus") ; --UNCHK
lin tyrannous_A = mkWA (k38 "tyrannimainen") ; --UNCHK
lin tyranny_N = mkWN (k12 "tyrannia") ; --UNCHK
lin tyrant_N = mkWN (k5A "despootti") ; --UNCHK
lin tyre_N = mkWN (k41A "rengas") ; --UNCHK
lin tyrnävä_PN = mkPN "Tyrnävä" ;
lin tyro_N = mkWN (k10 "aloittaja") ; --UNCHK
lin tyrocidine_N = mkWN "tyrosiini" ; --UNCHK
lin tyrolean_N = mkWN (compoundN "tirolilais" (k1A "hattu")) ; --UNCHK
lin tyrone_PN = foreignPN "Tyrone" ;
lin tyrosine_N = mkWN "tyrosiini" ; --UNCHK
lin tyrosinemia_N = mkWN (compoundN "aineenvaihdunta" (k3 "häiriö")) "tyrosiinin" ; --UNCHK
lin tzar_N = mkWN (k5 "tsaari") ; --UNCHK
lin tzarina_N = mkWN (k32A "tsaaritar") ; --UNCHK
lin töysä_PN = mkPN "Töysä" ;
lin u_A = mkWA "yläluokan" ; --UNCHK
lin uakari_N = mkWN "uakari" ; --UNCHK
lin ubiety_N = mkWN (k40 "paikallisuus") ; --UNCHK
lin ubiquinone_N = mkWN "ubikonini" ; --UNCHK
lin ubiquitous_A = mkWA (k10 "oleva") "kaikkialla" ; --UNCHK
lin ubiquity_N = mkWN (k99 "kaikkialla") "läsnäolo" ; --UNCHK
lin uddingston_PN = foreignPN "Uddingston" ;
lin udi_PN = foreignPN "Udi" ;
lin udine_PN = foreignPN "Udine" ;
lin ufa_PN = foreignPN "Ufa" ;
lin ufo_N = mkWN (k38 "lautanen") "lentävä" ; --UNCHK
lin uganda_PN = foreignPN "Uganda" ;
lin ugandan_A = mkWA (compoundA "ugand" (k38 "alainen")) ; --UNCHK
lin ugandan_N = mkWN (compoundN "ugand" (k38 "alainen")) ; --UNCHK
lin uglify_V2 = mkWV2 (k54A "rumentaa") ; --UNCHK
lin ugliness_N = mkWN (k40 "rumuus") ; --UNCHK
lin ugly_A = L.ugly_A ;
lin uh_Interj = mkInterj "uh" ;
lin uh_huh_Interj = mkInterj "uhhuh" ;
lin uh_uh_Interj = mkInterj "uhhuh" ;
lin uk_PN = mkPN "YK" ;
lin ukase_N = mkWN (k6 "ukaasi") ; --UNCHK
lin uke_N = mkWN (k8 "ukulele") ; --UNCHK
lin ukraine_PN = mkPN "Ukraina" ;
lin ukulele_N = mkWN (k8 "ukulele") ; --UNCHK
lin ulalgia_N = mkWN (compoundN "ien" (k1A "kipu")) ; --UNCHK
lin ulatrophia_N = mkWN (compoundN "ien" (k10 "surkastuma")) ; --UNCHK
lin ulcer_N = mkWN (k10 "haavautuma") ; --UNCHK
lin ulcerate_V = mkWV (k52A "haavautua") ; --UNCHK
lin ulcerate_V2 = mkWV2 (k52A "haavautua") ; --UNCHK
lin ulceration_N = mkWN (compoundN "haa" (k38 "vautuminen")) ; --UNCHK
lin ulcerative_A = mkWA (k38 "haavainen") ; --UNCHK
lin ulcerous_A = mkWA (k38 "haavainen") ; --UNCHK
lin ulema_N = mkWN "ulama" ; --UNCHK
lin ulemorrhagia_N = mkWN "ienverenvuoto" ; --UNCHK
lin ulitis_N = mkWN (compoundN "ien" (k39 "tulehdus")) ; --UNCHK
lin ullage_N = mkWN (k48 "vaje") ; --UNCHK
lin ullava_PN = mkPN "Ullava" ;
lin ulna_N = mkWN (compoundN "kyynär" (k18 "luu")) ; --UNCHK
lin ulnar_A = mkWA "kyynärluun" ; --UNCHK
lin ulster_N = mkWN (k6 "ulsteri") ; --UNCHK
lin ulteriority_N = mkWN (k40 "etäisyys") ; --UNCHK
lin ultima_N = mkWN (k1 "tavu") "viimeinen" ; --UNCHK
lin ultimacy_N = mkWN (k40 "äärimmäisyys") ; --UNCHK
lin ultimate_A = mkWA (k38 "lopullinen") ; --f69
lin ultimate_N = mkWN (k1A "huippu") "jnk" ; --UNCHK
lin ultimatum_N = mkWN (k6 "ultimaatumi") ; --UNCHK
lin ultimo_A = mkWA (k38 "edellinen") ; --UNCHK
lin ultra_vires_A = mkWA "ultra" "vires" ; --UNCHK
lin ultra_vires_Adv = mkWAdv "ultra" "vires" ; --UNCHK
lin ultracentrifugation_N = mkWN (compoundN "linko" (k38 "aminen")) ; --UNCHK
lin ultracentrifuge_N = mkWN (k1A "linko") ; --UNCHK
lin ultraconservative_A = mkWA (compoundA "ääri" (k38 "konservatiivinen")) ; --UNCHK
lin ultramarine_A = mkWA (k5 "ultramariini") ; --UNCHK
lin ultramarine_N = mkWN (k5 "ultramariini") ; --UNCHK
lin ultramicroscope_N = mkWN (compoundN "ultra" (k5A "mikroskooppi")) ; --UNCHK
lin ultramicroscopic_A = mkWA (compoundA "ultra" (k38 "mikroskooppinen")) ; --UNCHK
lin ultramodern_A = mkWA (compoundA "ultra" (k5 "moderni")) ; --UNCHK
lin ultramontane_A = mkWA "ultramontanismin" ; --UNCHK
lin ultramontane_N = mkWN (compoundN "paavin" (k9A "valta")) ; --UNCHK
lin ultramontanism_N = mkWN (compoundN "paavin" (k9A "valta")) ; --UNCHK
lin ultrasonic_A = mkWA (compoundA "yli" (k38 "ääninen")) ; --UNCHK
lin ultrasound_N = mkWN (compoundN "ultra" (k26 "ääni")) ; --UNCHK
lin ultraviolet_A = mkWA (compoundA "ultra" (k5A "violetti")) ; --UNCHK
lin ultraviolet_N = mkWN (compoundN "ultra" (k5A "violetti")) ; --UNCHK
lin ululate_V = mkWV (k66 "ulista") ; --UNCHK
lin ululation_N = mkWN (k12 "ulina") ; --UNCHK
lin ulverston_PN = foreignPN "Ulverston" ;
lin ulvila_PN = mkPN "Ulvila" ;
lin umbel_N = mkWN (compoundN "sarja" (k38 "kukkainen")) ; --UNCHK
lin umbellate_A = mkWA (k38 "sarjallinen") ; --UNCHK
lin umbellifer_N = mkWN (compoundN "sarja" (k38 "kukkainen")) ; --UNCHK
lin umbelliferous_A = mkWA (compoundA "sarja" (k38 "kukkainen")) ; --UNCHK
lin umbelliform_A = mkWA (k38 "sarjallinen") ; --UNCHK
lin umber_A = mkWA (k10 "umbra") ; --UNCHK
lin umber_N = mkWN (k10 "umbra") "poltettu" ; --UNCHK
lin umbilical_A = mkWA (compoundA "napa" (k38 "mainen")) ; --UNCHK
lin umbilicate_A = mkWA (compoundA "napa" (k38 "mainen")) ; --UNCHK
lin umbo_N = mkWN "umbo" ; --UNCHK
lin umbra_N = mkWN (k1 "varjo") ; --UNCHK
lin umbrage_N = mkWN (k39 "suuttumus") ; --UNCHK
lin umbrella_A = mkWA "kaikenkattava" ; --UNCHK
lin umbrella_N = mkWN (k1A "katto") ; --UNCHK
lin umbrellalike_A = mkWA (compoundA "sateenvarjo" (k38 "mainen")) ; --UNCHK
lin umbrellawort_N = mkWN (k10A "kukka") ; --UNCHK
lin umlaut_N = mkWN (k9 "treema") ; --UNCHK
lin umpirage_N = mkWN "tuomarointi" ; --UNCHK
lin umpire_N = mkWN (k6 "tuomari") ; --UNCHK
lin umpire_V = mkWV (k61 "toimia") "tuomarina" ; --UNCHK
lin umpire_V2 = mkWV2 (k61 "toimia") "tuomarina" ; --UNCHK
lin umpteen_A = mkWA (k10 "seitsemän") "sen" ; --UNCHK
lin un_N = mkWN "YK" ; --UNCHK
lin unabashed_A = mkWA (k10 "luonteva") ; --UNCHK
lin unabated_A = mkWA (k34A "hellittämätön") ; --UNCHK
lin unable_A = mkWA (k34A "kyvytön") ;
lin unabridged_A = mkWA (k38 "täydellinen") ; --UNCHK
lin unabused_A = mkWA (k34A "koskematon") ; --UNCHK
lin unaccented_A = mkWA (k34A "painoton") ; --UNCHK
lin unacceptability_N = mkWN (k40 "epätyydyttävyys") ; --UNCHK
lin unacceptable_A = mkWA (k34A "sopimaton") ;
lin unaccommodating_A = mkWA (compoundA "epä" (k41 "kohtelias")) ; --UNCHK
lin unaccompanied_A = mkWA (k99 "yksin") ; --UNCHK
lin unaccountable_A = mkWA (k34A "selittämätön") ; --UNCHK
lin unaccounted_A = mkA "selittämätön" ; ---?? different POS
lin unaccredited_A = mkWA (k34A "luvaton") ; --UNCHK
lin unaccustomed_A = mkWA (k34A "tottumaton") ; --UNCHK
lin unachievable_A = mkWA (k34A "saavuttamaton") ; --UNCHK
lin unacknowledged_A = mkWA (k34A "tuntematon") ; --UNCHK
lin unacquainted_A = mkWA (k34A "tottumaton") ; --UNCHK
lin unacquisitive_A = mkWA (k34A "saamaton") ; --UNCHK
lin unactable_A = mkWA (compoundA "esittämis" (k34A "kelvoton")) ; --UNCHK
lin unadaptability_N = mkWN (compoundN "sovellus" (k40 "kelvottomuus")) ; --UNCHK
lin unadaptable_A = mkWA (compoundA "sovellus" (k34A "kelvoton")) ; --UNCHK
lin unadapted_A = mkWA (k34A "sopeutumaton") ; --UNCHK
lin unaddicted_A = mkWA (k34A "riippumaton") ; --UNCHK
lin unaddressed_A = mkWA (k34A "nimetön") ; --UNCHK
lin unadjustable_A = mkWA (compoundA "soveltamis" (k34A "kelvoton")) ; --UNCHK
lin unadjusted_A = mkWA "tarkentamaton" ; --UNCHK
lin unadoptable_A = mkWA (compoundA "adoptointi" (k34A "kelvoton")) ; --UNCHK
lin unadorned_A = mkWA "koristelematon" ; --UNCHK
lin unadulterated_A = mkWA (k10 "syvä") ; --UNCHK
lin unadventurous_A = mkWA (k9A "arka") ; --UNCHK
lin unadvised_A = mkWA (k34A "ajattelematon") ; --UNCHK
lin unaerated_A = mkWA "hapeton" ; --UNCHK
lin unaffected_A = mkWA "altistumaton" ; --UNCHK
lin unaffectedness_N = mkWN (k40 "luonnollisuus") ; --UNCHK
lin unaffecting_A = mkWA "vaikuttamaton" ; --UNCHK
lin unaffiliated_A = mkWA (k34A "sitoutumaton") ; --UNCHK
lin unaffixed_A = mkWA (k99 "irti") ; --UNCHK
lin unafraid_A = mkWA (k34A "peloton") ; --UNCHK
lin unaged_A = mkWA (k34A "ajaton") ; --UNCHK
lin unaggressive_A = mkWA (compoundA "epä" (k38 "aggressiivinen")) ; --UNCHK
lin unagitated_A = mkWA (k26 "tyyni") ; --UNCHK
lin unaided_A = mkWA (k38 "itsenäinen") ; --UNCHK
lin unairworthy_A = mkWA (compoundA "lento" (k34A "kyvytön")) ; --UNCHK
lin unalarming_A = mkWA "rauhoittava" ; --UNCHK
lin unalert_A = mkWA (k34A "varomaton") ; --UNCHK
lin unalienable_A = mkWA (k34A "luovuttamaton") ; --UNCHK
lin unalike_A = mkWA (k38 "erilainen") ; --UNCHK
lin unalloyed_A = mkWA (k41A "puhdas") ; --UNCHK
lin unalterability_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin unalterable_A = mkWA (k34A "muuttumaton") ; --UNCHK
lin unaltered_A = mkWA (k99 "entisellään") ; --UNCHK
lin unambiguity_N = mkWN (k40 "selvyys") ; --UNCHK
lin unambiguous_A = mkWA (k15 "selkeä") ; --UNCHK
lin unambitious_A = mkWA "kunnianhimoton" ; --UNCHK
lin unamended_A = mkWA "muuttamaton" ; --UNCHK
lin unanalyzable_A = mkWA (k34A "selittämätön") ; --UNCHK
lin unanalyzed_A = mkWA "analysoimaton" ; --UNCHK
lin unanimated_A = mkWA (k10 "tylsä") ; --UNCHK
lin unanimity_N = mkWN (compoundN "yksimiel" (k40 "isyys")) ; --UNCHK
lin unanimous_A = mkWA (compoundA "yks" (k38 "imielinen")) ; --UNCHK
lin unannounced_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unanswerable_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unanswered_A = mkWA (compoundA "yksi" (k38 "puolinen")) ; --UNCHK
lin unanticipated_A = mkWA (k10 "yllättävä") ;
lin unappareled_A = mkWA (k34 "alaston") ; --UNCHK
lin unapparent_A = mkWA (k34A "odottamaton") ; --UNCHK
lin unappealable_A = mkWA (k38 "lopullinen") ; --UNCHK
lin unappealing_A = mkWA (k10 "tylsä") ; --UNCHK
lin unappendaged_A = mkWA "lisäkkeetön" ; --UNCHK
lin unappetizing_A = mkWA (k15 "tympeä") ; --UNCHK
lin unappetizingness_N = mkWN (k40 "tympeys") ; --UNCHK
lin unappreciated_A = mkWA (compoundA "ali" (k1 "arvostettu")) ; --UNCHK
lin unappreciative_A = mkWA (k34A "kiittämätön") ; --UNCHK
lin unapprehensive_A = mkWA (k34A "tarkkaamaton") ; --UNCHK
lin unapproachability_N = mkWN "saavuttamattomuus" ; --UNCHK
lin unapproachable_A = mkWA (k47 "sulkeutunut") ; --UNCHK
lin unarguable_A = mkWA (k34A "kiistaton") ; --UNCHK
lin unargumentative_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unarmed_A = mkWA (k34A "aseeton") ; --UNCHK
lin unarmored_A = mkWA "haarniskaton" ; --UNCHK
lin unarticulated_A = mkWA (k38 "irtonainen") ; --UNCHK
lin unary_A = mkWA "unaarinen" ; --UNCHK
lin unascertainable_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin unashamed_A = mkWA (k34A "hävytön") ; --UNCHK
lin unasked_A = mkWA (k34A "tarpeeton") ; --UNCHK
lin unassailable_A = mkWA (k38 "täydellinen") ; --UNCHK
lin unassertive_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin unassertiveness_N = mkWN (compoundN "epä" (k40 "varmuus")) ; --UNCHK
lin unassigned_A = mkWA (k38 "tilapäinen") ; --UNCHK
lin unassisted_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin unassuming_A = mkWA (compoundA "vähä" (k38 "eleinen")) ; --UNCHK
lin unassured_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin unasterisked_A = mkWA "merkitsemätön" ; --UNCHK
lin unattainable_A = mkWA (k34A "saavuttamaton") ; --UNCHK
lin unattainableness_N = mkWN "saavuttamattomuus" ; --UNCHK
lin unattended_A = mkWA "hylätty" ; --UNCHK
lin unattractive_A = mkWA (k10 "ruma") ; --UNCHK
lin unattractiveness_N = mkWN (k40 "rumuus") ; --UNCHK
lin unattributable_A = mkWA "tunnistamaton" ; --UNCHK
lin unauthorized_A = mkWA (k34A "luvaton") ; --UNCHK
lin unavailable_A = mkWA (k99 "saatavilla") "ei" ; --UNCHK
lin unavailing_A = mkWA (k34A "toivoton") ; --UNCHK
lin unavenged_A = mkWA "rankaisematon" ; --UNCHK
lin unavoidable_A = mkWA (k34A "väistämätön") ; --UNCHK
lin unavowed_A = mkWA (k38 "salainen") ; --UNCHK
lin unaware_A = mkWA (k34A "tietämätön") ; --UNCHK
lin unaware_of_A2 = mkA2 (mkA "tietämätön") (casePrep elative) ;
lin unawares_Adv = mkWAdv "housut" "nilkoissa" ; --UNCHK
lin unawed_A = mkWA (k26 "tyyni") ; --UNCHK
lin unbacked_A = mkWA (k38 "itsenäinen") ; --UNCHK
lin unbaffled_A = mkWA (k26 "tyyni") ; --UNCHK
lin unbalance_V2 = mkWV2 (k71 "tehdä") "hulluksi" ; --UNCHK
lin unbalconied_A = mkWA "parvekkeeton" ; --UNCHK
lin unbanded_A = mkWA "rengastamaton" ; --UNCHK
lin unbaptized_A = mkWA "kastamaton" ; --UNCHK
lin unbar_V2 = mkWV2 (k73 "avata") ; --UNCHK
lin unbarreled_A = mkWA (k38 "avonainen") ; --UNCHK
lin unbearable_A = mkWA (k34A "kestämätön") ; --UNCHK
lin unbeatable_A = mkWA (k34A "lyömätön") ; --UNCHK
lin unbeaten_A = mkWA (k34A "voittamaton") ; --UNCHK
lin unbecoming_A = mkWA (k34A "mauton") ; --UNCHK
lin unbecomingness_N = mkWN (k40 "rumuus") ; --UNCHK
lin unbefitting_A = mkWA (k34A "sopimaton") ; --UNCHK
lin unbeknown_A = mkWA (k34A "tuntematon") ; --UNCHK
lin unbeknown_Adv = mkWAdv (k99 "takana") "selän" ; --UNCHK
lin unbeknownst_A = mkWA (k34A "tuntematon") ; --UNCHK
lin unbeknownst_Adv = mkWAdv (k99 "takana") "selän" ; --UNCHK
lin unbelief_N = mkWN "epäuskoisuus" ; --UNCHK
lin unbelievable_A = mkWA (k34A "uskomaton") ; --UNCHK
lin unbeliever_N = mkWN (k4A "skeptikko") ; --UNCHK
lin unbelieving_A = mkWA (k38 "epäileväinen") ; --UNCHK
lin unbeloved_A = mkWA (compoundA "rakas" (k47 "tunut")) "onnettomasti" ; --UNCHK
lin unbelted_A = mkWA (k34A "vyötön") ; --UNCHK
lin unbend_V = mkWV (k52A "vapautua") ; --UNCHK
lin unbend_V2 = mkWV2 (k52A "vapautua") ; --UNCHK
lin unbeneficed_A = mkWA (compoundA "epä" (k10 "suotuisa")) ; --UNCHK
lin unbent_A = mkWA (k10 "suora") ; --UNCHK
lin unbiased_A = mkWA (k34A "ennakkoluuloton") ; --UNCHK
lin unbiassed_A = mkWA (k34A "ennakkoluuloton") ; --UNCHK
lin unbigoted_A = mkWA (k10 "joustava") ; --UNCHK
lin unbind_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin unbitter_A = mkWA (k10 "anteeksiantava") ; --UNCHK
lin unbleached_A = mkWA (k34A "värjäämätön") ; --UNCHK
lin unblemished_A = mkWA (k34A "tahraton") ; --UNCHK
lin unblended_A = mkWA "sekoittamaton" ; --UNCHK
lin unblessed_A = mkWA (k38 "puutteellinen") ; --UNCHK
lin unblinking_A = mkWA (k15 "rohkea") ; --UNCHK
lin unblock_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin unblushing_A = mkWA (k34A "ujostelematon") ; --UNCHK
lin unbodied_A = mkWA (k34A "ruumiiton") ; --UNCHK
lin unbolt_V = mkWV (k73 "avata") ; --UNCHK
lin unbolt_V2 = mkWV2 (k73 "avata") ; --UNCHK
lin unbooked_A = mkWA "varaamaton" ; --UNCHK
lin unbordered_A = mkWA (k34A "rajaton") ; --UNCHK
lin unborn_A = mkWA (k34A "syntymätön") ; --UNCHK
lin unbosom_V2 = mkWV2 (k53A "purkaa") "sydäntään" ; --UNCHK
lin unbounded_A = mkWA (k34A "ääretön") ; --UNCHK
lin unbowed_A = mkWA (compoundA "pysty" (k38 "päinen")) ; --UNCHK
lin unbraced_A = mkWA (k38 "irtonainen") ; --UNCHK
lin unbrainwashed_A = mkWA (k10 "järkevä") ; --UNCHK
lin unbranched_A = mkWA "oksaton" ; --UNCHK
lin unbranded_A = mkWA "merkitsemätön" ; --UNCHK
lin unbreakable_A = mkWA (k10 "kestävä") ; --UNCHK
lin unbreakableness_N = mkWN (k40 "kestävyys") ; --UNCHK
lin unbridgeable_A = mkWA (compoundA "amm" (k10 "ottava")) ; --UNCHK
lin unbridled_A = mkWA (k34A "hillitön") ; --UNCHK
lin unbroken_A = mkWA (k38 "kokonainen") ; --UNCHK
lin unbrushed_A = mkWA "harjaamaton" ; --UNCHK
lin unbuckle_V2 = mkWV2 (k73 "avata") ; --UNCHK
lin unburden_V2 = mkWV2 (k53 "poistaa") ; --UNCHK
lin unburied_A = mkWA "hautaamaton" ; --UNCHK
lin unburnished_A = mkWA (k15 "himmeä") ; --UNCHK
lin unbutton_V2 = mkWV2 (k73 "avata") "napit" ; --UNCHK
lin uncamphorated_A = mkWA (compoundA "kamferi" (k17 "vapaa")) ; --UNCHK
lin uncanny_A = mkWA (k34A "selittämätön") ; --UNCHK
lin uncapped_A = mkWA "kuorittamaton" ; --UNCHK
lin uncarpeted_A = mkWA (k41 "paljas") ; --UNCHK
lin uncarved_A = mkWA "kaivertamaton" ; --UNCHK
lin uncastrated_A = mkWA "kastroimaton" ; --UNCHK
lin uncategorized_A = mkWA "lajittelematon" ; --UNCHK
lin uncaulked_A = mkWA "tiivistämätön" ; --UNCHK
lin unceasing_A = mkWA (k38 "alituinen") ; --UNCHK
lin uncensored_A = mkWA (k34A "sensuroimaton") ; --UNCHK
lin unceremonious_A = mkWA (compoundA "epä" (k38 "muodollinen")) ; --UNCHK
lin unceremoniousness_N = mkWN (compoundN "epä" (k40 "muodollisuus")) ; --UNCHK
lin uncertain_A = L.uncertain_A ;
lin uncertainty_N = mkN "epä" (mkN "varmuus") ; ----CHANGE "sattumanvaraisuus" ;
lin uncertified_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin unchain_V2 = mkWV2 (k53A "vapauttaa") ; --UNCHK
lin unchallengeable_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unchallenged_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unchangeable_A = mkWA (k34A "muuttumaton") ; --UNCHK
lin unchanged_A = mkA "muuttumaton" ;
lin unchanging_A = mkWA (k38 "tasainen") ; --UNCHK
lin uncharacteristic_A = mkWA (compoundA "epä" (k38 "tyypillinen")) ; --UNCHK
lin uncharged_A = mkWA (k34A "voimaton") ; --UNCHK
lin uncharitable_A = mkWA (k1 "tyly") ; --UNCHK
lin uncharted_A = mkWA "kartoittamaton" ; --UNCHK
lin unchartered_A = mkWA (k34A "esteetön") ; --UNCHK
lin unchaste_A = mkWA (k34A "siveetön") ; --UNCHK
lin uncheckable_A = mkWA "tarkistamaton" ; --UNCHK
lin unchecked_A = mkWA (k34A "hillitön") ; --UNCHK
lin uncheerfulness_N = mkWN (k40 "ilottomuus") ; --UNCHK
lin unchivalrously_Adv = mkWAdv (compoundAdv "epäherras" (k99 "miesmäisesti")) ; --UNCHK
lin unchristian_A = mkWA (compoundA "epä" (k38 "kristillinen")) ; --UNCHK
lin unchristianly_A = mkWA (compoundA "epä" (k38 "kristillinen")) ; --UNCHK
lin uncial_A = mkWA (compoundA "unsia" (k38 "alinen")) ; --UNCHK
lin uncivil_A = mkWA (k15 "töykeä") ; --UNCHK
lin uncivilized_A = mkWA (k5 "villi") ; --UNCHK
lin unclaimed_A = mkWA (compoundA "omist" (k34A "ajaton")) ; --UNCHK
lin unclassifiable_A = mkWA "luokittelematon" ; --UNCHK
lin unclassified_A = mkWA "luokittelematon" ; --UNCHK
lin uncle_N = mkWN (k10A "setä") ; --UNCHK
lin unclean_A = mkWA (k38 "törkyinen") ; --UNCHK
lin uncleanliness_N = mkWN (compoundN "epä" (k40 "siisteys")) ; --UNCHK
lin uncleanly_A = mkWA (compoundA "epä" (k5 "siisti")) ; --UNCHK
lin unclear_A = mkWA (compoundA "epä" (k10 "selvä")) ; --UNCHK
lin uncleared_A = mkWA (k38 "tukkoinen") ; --UNCHK
lin unclearness_N = mkWN (compoundN "epä" (k40 "selvyys")) ; --UNCHK
lin unclipped_A = mkWA "leikkaamaton" ; --UNCHK
lin unclogged_A = mkWA "avattu" ; --UNCHK
lin unclothed_A = mkWA "riisuutunut" ; --UNCHK
lin unclouded_A = mkWA (k34A "pilvetön") ; --UNCHK
lin uncluttered_A = mkWA (k5 "siisti") ; --UNCHK
lin uncoated_A = mkWA "päällystämätön" ; --UNCHK
lin uncoerced_A = mkWA (compoundA "vapaaeh" (k38 "toinen")) ; --UNCHK
lin uncoiled_A = mkWA (k10 "suora") ; --UNCHK
lin uncollected_A = mkWA (k38 "irtonainen") ; --UNCHK
lin uncolored_A = mkWA (k34A "väritön") ; --UNCHK
lin uncoloured_A = mkWA (k34A "väritön") ; --UNCHK
lin uncombable_A = mkWA (k38 "takkuinen") ; --UNCHK
lin uncombed_A = mkWA "kampaamaton" ; --UNCHK
lin uncombined_A = mkWA (k38 "irtonainen") ; --UNCHK
lin uncomfortable_A = mkWA (compoundA "epä" (k10 "mukava")) ;
lin uncommercial_A = mkWA (compoundA "epä" (k38 "kaupallinen")) ; --UNCHK
lin uncommercialized_A = mkWA (compoundA "ei-" (k38 "kaupallinen")) ; --UNCHK
lin uncommitted_A = mkWA (k34A "sitoutumaton") ; --UNCHK
lin uncommon_A = mkA (mkN "epä" (mkN "tyypillinen")) ; --mkWA (k38 "harvinainen") ;
lin uncommonness_N = mkWN (k40 "harvinaisuus") ; --UNCHK
lin uncommunicative_A = mkWA (k41 "vaitelias") ; --UNCHK
lin uncommunicativeness_N = mkWN (k40 "sulkeutuneisuus") ; --UNCHK
lin uncompartmented_A = mkWA (k38 "yhtenäinen") ; --UNCHK
lin uncompensated_A = mkWA (k34A "palkaton") ; --UNCHK
lin uncompetitive_A = mkWA (compoundA "kilpailu" (k34A "haluton")) ; --UNCHK
lin uncomplaining_A = mkWA "valittamaton" ; --UNCHK
lin uncompleted_A = mkWA "uncompleted" ; --UNCHK
lin uncomplicated_A = mkWA (k34A "ongelmaton") ; --UNCHK
lin uncomplimentary_A = mkWA "halventava" ; --UNCHK
lin uncompounded_A = mkWA "sekoittamaton" ; --UNCHK
lin uncomprehended_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin uncomprehending_A = mkWA (k34A "ymmärtämätön") ; --UNCHK
lin uncompromising_A = mkWA (k34A "taipumaton") ; --UNCHK
lin unconcealed_A = mkWA (k34A "peittelemätön") ; --UNCHK
lin unconcern_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin unconcerned_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unconditional_A = mkWA (k34A "ehdoton") ; --UNCHK
lin unconditioned_A = mkWA (k34A "ehdoton") ; --UNCHK
lin unconfessed_A = mkWA (k34A "tunnustamaton") ; --UNCHK
lin unconfined_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin unconfirmed_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin unconformable_A = mkWA (k34A "vastaamaton") ; --UNCHK
lin uncongenial_A = mkWA (k41 "vieras") ; --UNCHK
lin uncongeniality_N = mkWN (compoundN "epä" (k40 "ystävällisyys")) ; --UNCHK
lin unconnected_A = mkWA (k38 "irrallinen") ; --UNCHK
lin unconnectedness_N = mkWN (k40 "irrallisuus") ; --UNCHK
lin unconquerable_A = mkWA (k34A "ylikäymätön") ; --UNCHK
lin unconquered_A = mkWA (k34A "voittamaton") ; --UNCHK
lin unconscientious_A = mkWA (k34A "tiedoton") ; --UNCHK
lin unconscientiousness_N = mkWN (k40 "huolimattomuus") ; --UNCHK
lin unconscionable_A = mkWA (k10 "järkyttävä") ; --UNCHK
lin unconscious_A = mkWA (k34A "tiedoton") ; --UNCHK
lin unconscious_N = mkWN (compoundN "ali" (k9A "tajunta")) ; --UNCHK
lin unconsciousness_N = mkWN (k40 "tiedottomuus") ; --UNCHK
lin unconsidered_A = mkWA (k34A "harkitsematon") ; --UNCHK
lin unconsolidated_A = mkWA (k38 "irtonainen") ; --UNCHK
lin unconstipated_A = mkWA (k10 "toimiva") ; --UNCHK
lin unconstitutional_A = mkWA "perustuslainvastainen" ; --UNCHK
lin unconstrained_A = mkWA (k17 "vapaa") ; --UNCHK
lin unconstricted_A = mkWA (k48 "terve") ; --UNCHK
lin unconstructive_A = mkWA (k10 "turha") ; --UNCHK
lin unconsumed_A = mkWA "unconsumed" ; --UNCHK
lin unconsummated_A = mkWA "täytäntöönpanematon" ; --UNCHK
lin uncontaminated_A = mkWA (k34A "koskematon") ; --UNCHK
lin uncontested_A = mkWA (k38 "luontainen") ; --UNCHK
lin uncontrollable_A = mkWA (k34A "pitelemätön") ; --UNCHK
lin uncontrolled_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin uncontroversial_A = mkWA (compoundA "risti" (k34A "riidaton")) ; --UNCHK
lin unconventional_A = mkWA (compoundA "epä" (k38 "sovinnainen")) ; --UNCHK
lin unconventionality_N = mkWN (compoundN "epä" (k40 "sovinnaisuus")) ; --UNCHK
lin unconverted_A = mkWA "käännyttämätön" ; --UNCHK
lin unconvinced_A = mkWA (compoundA "epä" (k38 "uskoinen")) ; --UNCHK
lin unconvincing_A = mkWA (compoundA "epä" (k10 "uskottava")) ; --UNCHK
lin uncooked_A = mkWA (kH1 "raaka") ; --UNCHK
lin uncool_A = mkWA (k10 "tylsä") ; --UNCHK
lin unco_operative_A = mkWA (compoundA "yhteistyö" (k34A "haluton")) ; --UNCHK
lin unco_ordinated_A = mkWA (k10 "horjuva") ; --UNCHK
lin uncordial_A = mkWA (compoundA "epä" (k38 "ystävällinen")) ; --UNCHK
lin uncork_V2 = mkWV2 (k73A "korkata") ; --UNCHK
lin uncorrected_A = mkWA (k34A "korjaamaton") ; --UNCHK
lin uncorrelated_A = mkWA "korreloimaton" ; --UNCHK
lin uncorroborated_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin uncorrupted_A = mkWA (k34A "lahjomaton") ; --UNCHK
lin uncouple_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin uncousinly_A = mkWA (compoundA "epä" (k10 "sopiva")) ; --UNCHK
lin uncouth_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin uncouthness_N = mkWN (k40 "sivistymättömyys") ; --UNCHK
lin uncover_V2 = mkWV2 (k53 "paljastaa") ; --UNCHK
lin uncrannied_A = mkWA (k10 "sulava") ; --UNCHK
lin uncreative_A = mkWA (k38 "sovinnainen") ; --UNCHK
lin uncreativeness_N = mkWN (k40 "sovinnaisuus") ; --UNCHK
lin uncritical_A = mkWA (k34A "kritiikitön") ; --UNCHK
lin uncropped_A = mkWA (k34A "viljelemätön") ; --UNCHK
lin uncross_V2 = mkWV2 (k53 "suoristaa") ; --UNCHK
lin uncrowded_A = mkWA (k10 "tilava") ; --UNCHK
lin uncrowned_A = mkWA (k34A "kruunaamaton") ; --UNCHK
lin uncrystallized_A = mkWA "muotoutumaton" ; --UNCHK
lin unction_N = mkWN (k2 "voitelu") ; --UNCHK
lin unctuous_A = mkWA (k15 "mairea") ; --UNCHK
lin uncultivable_A = mkWA (compoundA "viljelys" (k34A "kelvoton")) ; --UNCHK
lin uncultivated_A = mkWA (k34A "viljelemätön") ; --UNCHK
lin uncultured_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin uncured_A = mkWA "pehmittämätön" ; --UNCHK
lin uncurl_V = mkWV (k53 "suoristaa") ; --UNCHK
lin uncurl_V2 = mkWV2 (k53 "suoristaa") ; --UNCHK
lin uncurved_A = mkWA (k10 "suora") ; --UNCHK
lin uncus_N = mkWN "uncus" ; --UNCHK
lin uncut_A = mkWA "leikkaamaton" ; --UNCHK
lin undamaged_A = mkWA (k34A "turmeltumaton") ; --UNCHK
lin undatable_A = mkWA (compoundA "vara" (k1 "ttu")) ; --UNCHK
lin undated_A = mkWA "päiväämätön" ; --UNCHK
lin undaunted_A = mkWA (k15 "urhea") ; --UNCHK
lin undecagon_N = mkWN "11-sivuinen" "monikulmio" ; --UNCHK
lin undeceive_V2 = mkWV2 (k53 "paljastaa") ; --UNCHK
lin undecided_A = mkWA (k34A "päättämätön") ; --UNCHK
lin undeciphered_A = mkWA (k34A "selvittämätön") ; --UNCHK
lin undeclared_A = mkWA "julistamaton" ; --UNCHK
lin undedicated_A = mkWA (k34A "vihkimätön") ; --UNCHK
lin undefeated_A = mkWA (k34A "voittamaton") ; --UNCHK
lin undefended_A = mkWA (k34A "suojaton") ; --UNCHK
lin undeferential_A = mkWA (k15 "karkea") ; --UNCHK
lin undefinable_A = mkWA (k34A "määrittelemätön") ; --UNCHK
lin undefined_A = mkWA (k34A "määrittelemätön") ; --UNCHK
lin undelineated_A = mkWA "hahmoton" ; --UNCHK
lin undemanding_A = mkWA (k1A "helppo") ; --UNCHK
lin undemocratic_A = mkWA (compoundA "epä" (k38 "demokraattinen")) ; --UNCHK
lin undemonstrative_A = mkWA (k38 "pidättyväinen") ; --UNCHK
lin undeniable_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin undenominational_A = mkWA (k34A "tunnustukseton") ; --UNCHK
lin undependability_N = mkWN (compoundN "epä" (k40 "luotettavuus")) ; --UNCHK
lin undependable_A = mkWA (compoundA "epä" (k10 "luotettava")) ; --UNCHK
lin undepicted_A = mkWA (k34A "kuvaamaton") ; --UNCHK
lin under_Adv = mkWAdv (k99 "tuonnempana") ; --UNCHK
lin under_Prep = S.under_Prep ;
lin underachievement_N = mkWN (compoundN "ali" (k39 "suoritus")) ; --UNCHK
lin underachiever_N = mkWN (compoundN "ali" (k10 "suorittaja")) ; --UNCHK
lin underact_V = mkWV (compoundV "yli" (k67A "näytellä")) ; --UNCHK
lin underact_V2 = mkWV2 (compoundV "yli" (k67A "näytellä")) ; --UNCHK
lin underage_A = mkWA (compoundA "ala" (k38 "ikäinen")) ; --UNCHK
lin underarm_Adv = mkWAdv (compoundAdv "ala" (k99 "kautta")) ; --UNCHK
lin underbelly_N = mkWN (k40 "heikkous") ; --UNCHK
lin underboss_N = mkWN (k6 "apuri") ; --UNCHK
lin underbred_A = mkWA (compoundA "seka" (k38 "rotuinen")) ; --UNCHK
lin underbrush_N = mkWN (compoundN "alus" (k40 "kasvillisuus")) ; --UNCHK
lin undercarriage_N = mkWN (k1A "runko") ; --UNCHK
lin undercharge_N = mkWN (compoundN "ali" (k39 "veloitus")) ; --UNCHK
lin undercharge_V2 = mkWV2 (compoundV "ali" (k53A "veloittaa")) ; --UNCHK
lin underclothing_N = mkWN (compoundN "alus" (k48A "vaate")) ; --UNCHK
lin undercoat_N = mkWN (k9 "pohjavilla") ; --UNCHK
lin undercoated_A = mkWA (compoundA "ruoste" (k1 "suojattu")) ; --UNCHK
lin undercover_A = mkWA (k38 "salainen") ; --UNCHK
lin undercurrent_N = mkWN (compoundN "pohja" (k9A "virta")) ; --UNCHK
lin undercut_N = mkWN (k7 "lovi") ; --UNCHK
lin undercut_V2 = mkV2 (mkV (mkV "myydä") "halvemmalla") partitive ; --mkWV2 (k74 "loveta") ;
lin underdeveloped_A = mkWA (compoundA "ali" (k47 "kehittynyt")) ; --UNCHK
lin underdevelopment_N = mkWN (compoundN "ali" (k39 "valotus")) ; --UNCHK
lin underdog_N = mkWN (k10 "häviäjä") ; --UNCHK
lin underdone_A = mkWA (kH1 "raaka") ; --UNCHK
lin underdressed_A = mkWA (compoundA "yli" (k47 "pukeutunut")) ; --UNCHK
lin undereducated_A = mkWA (compoundA "ali" (k1 "koulutettu")) ; --UNCHK
lin underemployed_A = mkWA (compoundA "vaja" (k1 "atyöllistetty")) ; --UNCHK
lin underestimate_N = mkWN (compoundN "ali" (k5A "arviointi")) ; --UNCHK
lin underestimate_V2 = mkWV2 (compoundV "ali" (k62 "arvioida")) partitive ;
lin underestimation_N = mkWN (compoundN "ali" (k5A "arviointi")) ; --UNCHK
lin underevaluation_N = mkWN (compoundN "ali" (k5A "arviointi")) ; --UNCHK
lin underexposure_N = mkWN (k1A "pimento") ; --UNCHK
lin underfed_A = mkWA (k1A "aliravittu") ; --UNCHK
lin underfelt_N = mkWN (compoundN "maton" (k13 "alusta")) ; --UNCHK
lin underfoot_Adv = mkWAdv (k99 "alla") "jalkojen" ; --UNCHK
lin underfund_V2 = mkV2 "alirahoittaa" ;
lin undergarment_N = mkWN (compoundN "alus" (k1 "asu")) ; --UNCHK
lin undergo_V2 = mkWV2 (k58A "kokea") ; --UNCHK
lin undergraduate_N = mkWN (k12 "opiskelija") ; --UNCHK
lin underground_A = mkWA (k38 "salainen") ;
lin underground_Adv = mkWAdv (k99 "alla") "maan" ; --UNCHK
lin underground_N = mkWN (k1 "metro") ; --UNCHK
lin undergrowth_N = mkWN (compoundN "alus" (k40 "kasvillisuus")) ; --UNCHK
lin underhand_Adv = mkWAdv (compoundAdv "ala" (k99 "kautta")) ; --UNCHK
lin underhung_A = mkWA (k10 "ulkoneva") ; --UNCHK
lin underivative_A = mkWA (k34A "jäljittelemätön") ; --UNCHK
lin underived_A = mkWA (compoundA "yks" (k38 "inkertainen")) ; --UNCHK
lin underlay_N = mkWN (compoundN "alus" (k1A "matto")) ; --UNCHK
lin underlie_V2 = mkV2 (mkV olla_V "perustana") allative ;
lin underline_N = mkWN (compoundN "alle" (k39 "viivaus")) ; --UNCHK
lin underline_V2 = mkWV2 (compoundV "alle" (k73 "viivata")) ; --UNCHK
lin underling_N = mkWN (k38 "käskyläinen") ; --UNCHK
lin underlip_N = mkWN (compoundN "ala" (k24 "huuli")) ; --UNCHK
lin underlying_A = mkWA "kätketty" ; --UNCHK
lin undermanned_A = mkWA (compoundA "vaja" (k1 "amiehitetty")) ; --UNCHK
lin undermentioned_A = mkWA "alla" "mainitut" ; --UNCHK
lin undermine_V2 = mkWV2 (k56 "kaivaa") "maata" ; --UNCHK
lin underneath_Adv = mkWAdv "alapuolella" ; --UNCHK
lin underneath_Prep = postPrep genitive "alapuolella" ;
lin undernourished_A = mkWA (k1A "aliravittu") ; --UNCHK
lin undernourishment_N = mkWN (compoundN "ali" (k39 "ravitsemus")) ; --UNCHK
lin underpart_N = mkWN (compoundN "vatsa" (k26 "puoli")) ; --UNCHK
lin underpass_N = mkWN (compoundN "alikulku" (k6 "tunneli")) ; --UNCHK
lin underpay_V2 = mkWV2 (compoundV "ali" (k73A "palkata")) ; --UNCHK
lin underpayment_N = mkWN (compoundN "ali" (k38 "palkkaaminen")) ; --UNCHK
lin underperform_V2 = mkWV2 (k53A "esittää") ; --UNCHK
lin underperformer_N = mkWN (compoundN "liike" (k25 "toimi")) ; --UNCHK
lin underpin_V2 = mkV2 "vahvistaa" partitive ; --mkWV2 (k58A "tukea") ;
lin underpopulated_A = mkWA (compoundA "vähäna" (k1A "suttu")) ; --UNCHK
lin underprivileged_A = mkWA (compoundA "vähä" (k38 "osainen")) ; --UNCHK
lin underproduction_N = mkWN (compoundN "ali" (k1A "tuotanto")) ; --UNCHK
lin underquote_V2 = mkWV2 (k74 "tarjota") ; --UNCHK
lin underrate_V2 = mkWV2 (k62 "arvioida") ; --UNCHK
lin underscore_N = mkWN (compoundN "alle" (k39 "viivaus")) ; --UNCHK
lin underscore_V2 = mkWV2 (compoundV "alle" (k73 "viivata")) ; --UNCHK
lin undersea_A = mkWA (compoundA "veden" (k38 "alainen")) ; --UNCHK
lin underseal_N = mkWN (k10 "ruostesuoja") ; --UNCHK
lin undersealed_A = mkWA (compoundA "ruoste" (k1 "suojattu")) ; --UNCHK
lin undersecretary_N = mkWN "alivaltiosihteeri" ; --UNCHK
lin undersell_V2 = mkWV2 (k63 "myydä") ; --UNCHK
lin underseller_N = mkWN (compoundN "ale" (k41 "kauppias")) ; --UNCHK
lin undersexed_A = mkWA (compoundA "ali" (k38 "seksuaalinen")) ; --UNCHK
lin undershoot_V2 = mkWV2 (k52A "ampua") "huti" ; --UNCHK
lin undershrub_N = mkWN (compoundN "alus" (k5 "kasvi")) ; --UNCHK
lin underside_N = mkWN (compoundN "ala" (k18 "pää")) ; --UNCHK
lin undersign_V2 = mkWV2 (compoundV "alle" (k53A "kirjoittaa")) ; --UNCHK
lin undersize_A = mkWA (compoundA "ali" (k38 "mittainen")) ; --UNCHK
lin undersized_A = mkWA (compoundA "ali" (k38 "mittainen")) ; --UNCHK
lin underskirt_N = mkWN (compoundN "alus" (k48 "hame")) ; --UNCHK
lin underslung_A = mkWA (k10 "matala") ; --UNCHK
lin underspend_V = mkWV (k53A "kuluttaa") ; --UNCHK
lin underspend_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin understaffed_A = mkWA (compoundA "vaja" (k1 "amiehitetty")) ; --UNCHK
lin understand_V = mkV "ymmärtää" ;
lin understand_V2 = L.understand_V2 ;
lin understand_VS = mkVS "ymmärtää" | mkWVS (k74 "älytä") ;
lin understandable_A = mkWA (k10 "ymmärrettävä") ;
lin understanding_N = mkWN (k1 "äly") ; --UNCHK
lin understate_V2 = mkV2 "vähätellä" partitive ;
lin understatement_N = mkN "vähättely" ;
lin understudyFem_N = mkWN (compoundN "vara" (k42 "mies")) ; --UNCHK ---- sense to be split
lin understudyMasc_N = mkWN (compoundN "vara" (k42 "mies")) ; --UNCHK ---- sense to be split
lin understudy_N = mkWN (compoundN "vara" (k42 "mies")) ; --UNCHK
lin understudy_V2 = mkWV2 (k67 "olla") "varalla" ; --UNCHK
lin undersurface_N = mkWN (compoundN "ala" (k18 "pää")) ; --UNCHK
lin undertake_V2 = mkWV2 (k52A "sitoutua") ; --UNCHK
lin undertaker_N = mkWN (compoundN "hautaus" (k12 "urakoitsija")) ; --UNCHK
lin undertaking_N = mkN "hanke" ; --mkWN (k19 "työ") ;
lin undertide_N = mkWN (compoundN "pohja" (k9A "virta")) ; --UNCHK
lin undertone_N = mkWN (k1 "sävy") ; --UNCHK
lin undertow_N = mkWN (k5A "maininki") ; --UNCHK
lin undervaluation_N = mkWN (compoundN "ali" (k5A "arviointi")) ; --UNCHK
lin undervalue_V2 = mkWV2 (compoundV "ali" (k53 "arvostaa")) partitive ;
lin underwater_A = mkWA (k99 "alla") "veden" ; --UNCHK
lin underwear_N = mkWN (compoundN "alus" (k48A "vaate")) ;
lin underweight_A = mkWA (k10 "hintelä") ; --UNCHK
lin underwhelm_V2 = mkV2 (mkV vOlla "vaikuttumatta") (casePrep elative) ;
lin underwing_N = mkWN "yöperhonen" ; --UNCHK
lin underworld_N = mkWN (k13 "maailma") "maanalainen" ; --UNCHK
lin underwrite_V = mkV "allekirjoittaa" ; --WV (k58A "tukea") ;
lin underwrite_V2 = mkWV2 (k58A "tukea") ; --UNCHK
lin underwriter_N = mkWN (compoundN "vakuutus" (k3 "yhtiö")) ; --f95
lin undescended_A = mkWA "laskeutumaton" ; --UNCHK
lin undescriptive_A = mkWA (compoundA "sanoin" (k34A "kuvaamaton")) ; --UNCHK
lin undeserved_A = mkWA (k34A "ansaitsematon") ; --UNCHK
lin undeserving_A = mkWA (k34A "arvoton") ; --UNCHK
lin undesigned_A = mkWA (k10 "yllättävä") ; --UNCHK
lin undesirability_N = mkWN (compoundN "vastenmiel" (k40 "isyys")) ; --UNCHK
lin undesirable_A = mkWA (compoundA "ei-" (k1A "toivottu")) ; --UNCHK
lin undesirable_N = mkWN (k2 "henkilö") "ei-toivottu" ; --UNCHK
lin undesired_A = mkWA (compoundA "epä" (k1A "toivottu")) ; --UNCHK
lin undesirous_A = mkWA (k34A "haluton") ; --UNCHK
lin undestroyable_A = mkWA "tuhoutumaton" ; --UNCHK
lin undetected_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin undetermined_A = mkWA (k34A "tuntematon") ; --UNCHK
lin undeterred_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin undeveloped_A = mkWA (k34A "kehittymätön") ;
lin undeviating_A = mkWA (k34A "horjumaton") ; --UNCHK
lin undiagnosable_A = mkWA (k34A "määrittelemätön") ; --UNCHK
lin undiagnosed_A = mkWA "diagnostisoimaton" ; --UNCHK
lin undifferentiated_A = mkWA (k38 "yhtenäinen") ; --UNCHK
lin undigested_A = mkWA "sulamaton" ; --UNCHK
lin undignified_A = mkWA (k38 "moukkamainen") ; --UNCHK
lin undiluted_A = mkWA "suodattamaton" ; --UNCHK
lin undiminished_A = mkWA (k34A "hellittämätön") ; --UNCHK
lin undimmed_A = mkWA (k41A "kirkas") ; --UNCHK
lin undine_N = mkWN (k32A "aallotar") ; --UNCHK
lin undiplomatic_A = mkWA (compoundA "epä" (k38 "diplomaattinen")) ; --UNCHK
lin undiscerning_A = mkWA (compoundA "arvostelu" (k34A "kyvytön")) ; --UNCHK
lin undischarged_A = mkWA "räjähtämätön" ; --UNCHK
lin undisciplined_A = mkWA (k34A "hillitön") ; --UNCHK
lin undisclosed_A = mkWA (k38 "salainen") ; --UNCHK
lin undiscovered_A = mkWA (k34A "tutkimaton") ; --UNCHK
lin undiscriminating_A = mkWA (compoundA "epä" (k38 "tyypillinen")) ; --UNCHK
lin undisguised_A = mkWA (k10 "selvä") ; --UNCHK
lin undismayed_A = mkWA "lannistumaton" ; --UNCHK
lin undisputed_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin undissolved_A = mkWA "sulamaton" ; --UNCHK
lin undistinguished_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin undistorted_A = mkWA (k34A "muuttumaton") ; --UNCHK
lin undistributed_A = mkWA (k34A "jakamaton") ; --UNCHK
lin undisturbed_A = mkWA "häiriintymätön" ; --UNCHK
lin undiversified_A = mkWA (k34A "jakamaton") ; --UNCHK
lin undividable_A = mkWA (k34A "jakamaton") ; --UNCHK
lin undivided_A = mkWA (k34A "jakamaton") ; --UNCHK
lin undo_V2 = mkV2 "kumota" ; ---ARB --mkWV2 (k73 "avata") ;
lin undock_V = mkWV (k58 "laskea") "vesille" ; --UNCHK
lin undock_V2 = mkWV2 (k58 "laskea") "vesille" ; --UNCHK
lin undocumented_A = mkWA (k34A "laiton") ; --UNCHK
lin undoer_N = mkWN (k10 "hävittäjä") ; --UNCHK
lin undogmatic_A = mkWA "vapaasti" "ajatteleva" ; --UNCHK
lin undoing_N = mkWN "avaaminen" ; --UNCHK
lin undomestic_A = mkWA (k2 "kömpelö") ; --UNCHK
lin undomesticated_A = mkWA (k34A "sopeutumaton") ; --UNCHK
lin undoubted_A = mkA "epäilemätön" ;
lin undrained_A = mkWA "ojittamaton" ; --UNCHK
lin undramatic_A = mkWA (compoundA "epä" (k38 "dramaattinen")) ; --UNCHK
lin undraped_A = mkWA (k41 "paljas") ; --UNCHK
lin undrawn_A = mkWA (k34A "kuvaamaton") ; --UNCHK
lin undreamed_A = mkWA (k34A "mahdoton") ; --UNCHK
lin undreamed_of_A = mkWA (k34A "mahdoton") ; --UNCHK
lin undreamt_A = mkWA (k34A "mahdoton") ; --UNCHK
lin undress_N = mkWN "riisuminen" ; --UNCHK
lin undress_V = mkWV (k52A "riisuuntua") ; --UNCHK
lin undress_V2 = mkWV2 (k52A "riisuuntua") ; --UNCHK
lin undried_A = mkWA (k15 "kostea") ; --UNCHK
lin undrinkable_A = mkWA (compoundA "juoma" (k34A "kelvoton")) ; --UNCHK
lin undue_A = mkWA "erääntymätön" ; --UNCHK
lin undulate_A = mkWA (compoundA "aaltoreu" (k38 "nainen")) ; --UNCHK
lin undulate_V = mkWV (k67 "väreillä") ; --UNCHK
lin undulation_N = mkWN (k2 "aaltoilu") ; --UNCHK
lin undulatory_A = mkWA (compoundA "aalto" (k38 "mainen")) ; --UNCHK
lin undutifulness_N = mkWN (k40 "itsekkyys") ; --UNCHK
lin undying_A = mkWA (k38 "ikuinen") ; --UNCHK
lin undynamic_A = mkWA (k34A "voimaton") ; --UNCHK
lin uneager_A = mkWA (k34A "haluton") ; --UNCHK
lin unearned_A = mkWA (k34A "ansaitsematon") ; --UNCHK
lin unearth_V2 = mkWV2 (k54A "löytää") ; --UNCHK
lin unearthly_A = mkWA (k34A "selittämätön") ; --UNCHK
lin unease_N = mkN (lin NK {s = d40 "rauhattomuus"}) ;
lin uneasiness_N = mkWN (k40 "hermostuneisuus") ; --UNCHK
lin uneasy_A = mkWA "huolestunut" ;
lin uneatable_A = mkWA (compoundA "syömä" (k34A "kelvoton")) ; --UNCHK
lin uneconomic_A = mkWA (k38 "tuhlaavainen") ; --UNCHK
lin uneconomical_A = mkWA (k38 "tuhlaavainen") ; --UNCHK
lin unedifying_A = mkWA "latistava" ; --UNCHK
lin unedited_A = mkWA "editoimaton" ; --UNCHK
lin uneducated_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin uneffective_A = mkWA (k34A "pystymätön") ; --UNCHK
lin unelaborated_A = mkWA (k38 "summittainen") ; --UNCHK
lin unemotional_A = mkWA (compoundA "epä" (k38 "tunteellinen")) ; --UNCHK
lin unemotionality_N = mkWN (k40 "tunteettomuus") ; --UNCHK
lin unemphatic_A = mkWA "korostamaton" ; --UNCHK
lin unemployable_A = mkWA "työllistymätön" ; --UNCHK
lin unemployed_A = mkWA (k34A "työtön") ; --UNCHK
lin unemployment_N = mkWN (k40 "työttömyys") ;
lin unenclosed_A = mkWA (k33 "avoin") ; --UNCHK
lin unencouraging_A = mkWA (k10 "masentava") ; --UNCHK
lin unencumbered_A = mkWA "rasitteeton" ; --UNCHK
lin unended_A = mkWA (k38 "keskeneräinen") ; --UNCHK
lin unending_A = mkWA (k34A "loputon") ; --UNCHK
lin unendowed_A = mkWA (k34A "lahjaton") ; --UNCHK
lin unendurable_A = mkWA (k34A "kestämätön") ; --UNCHK
lin unenforceable_A = mkWA (compoundA "ei-täytäntöönpano" (k38 "kelpoinen")) ; --UNCHK
lin unenforced_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin unengaged_A = mkWA (k17 "vapaa") ; --UNCHK
lin unenlightened_A = mkWA (k34A "oppimaton") ; --UNCHK
lin unenlightening_A = mkWA "latistava" ; --UNCHK
lin unenlightenment_N = mkWN (k40 "tietämättömyys") ; --UNCHK
lin unenlivened_A = mkWA (k10 "tylsä") ; --UNCHK
lin unenterprising_A = mkWA (k34A "saamaton") ; --UNCHK
lin unenthusiastic_A = mkWA (k34A "saamaton") ; --UNCHK
lin unentitled_A = mkWA (compoundA "epä" (k10 "pätevä")) ; --UNCHK
lin unenviable_A = mkWA (k10 "kurja") ; --UNCHK
lin unequal_A = mkWA (k34A "sopimaton") ; --UNCHK
lin unequalized_A = mkWA (compoundA "epä" (k38 "tasainen")) ; --UNCHK
lin unequipped_A = mkWA "varustamaton" ; --UNCHK
lin unequivocal_A = mkWA (k15 "selkeä") ; --UNCHK
lin unerect_A = mkWA (compoundA "vaaka" (k10 "suora")) ; --UNCHK
lin unerring_A = mkWA (k34A "erehtymätön") ; --UNCHK
lin unestablished_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin unethical_A = mkWA (compoundA "epä" (k38 "eettinen")) ; --UNCHK
lin uneven_1_A = mkWA (compoundA "epä" (k38 "tasainen")) ; --UNCHK
lin uneven_2_A = mkWA (compoundA "epä" (k38 "tasainen")) ; --UNCHK
lin unevenness_N = mkWN (compoundN "epä" (k40 "tasaisuus")) ; --UNCHK
lin uneventful_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin unexacting_A = mkWA (k10 "joustava") ; --UNCHK
lin unexampled_A = mkWA (k38 "uudenlainen") ; --UNCHK
lin unexceeded_A = mkWA (k34A "ylittämätön") ; --UNCHK
lin unexcelled_A = mkWA (k34A "ylittämätön") ; --UNCHK
lin unexceptionable_A = mkWA (k34A "moitteeton") ; --UNCHK
lin unexchangeability_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin unexchangeable_A = mkWA (compoundA "vaihto" (k34A "kelvoton")) ; --UNCHK
lin unexcitable_A = mkWA (k26 "tyyni") ; --UNCHK
lin unexcited_A = mkWA (k26 "tyyni") ; --UNCHK
lin unexciting_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin unexclusive_A = mkWA (k17 "vapaa") ; --UNCHK
lin unexcused_A = mkWA (k34A "selittämätön") ; --UNCHK
lin unexhausted_A = mkWA (k34A "ehtymätön") ; --UNCHK
lin unexpansive_A = mkWA "laajentumaton" ; --UNCHK
lin unexpected_A = mkWA (k34A "odottamaton") ;
lin unexpectedness_N = mkWN (k40 "yllätyksellisyys") ; --UNCHK
lin unexpendable_A = mkWA (compoundA "käyttö" (k34A "kelvoton")) ; --UNCHK
lin unexpired_A = mkWA (compoundA "voimassa" (k10 "oleva")) ; --UNCHK
lin unexplained_A = mkWA (k34A "selittämätön") ; --UNCHK
lin unexploited_A = mkWA "käyttämätön" ; --UNCHK
lin unexplored_A = mkWA (k34A "tutkimaton") ; --UNCHK
lin unexportable_A = mkWA (compoundA "vienti" (k34A "kelvoton")) ; --UNCHK
lin unexpressed_A = mkWA (k34A "sanomaton") ; --UNCHK
lin unexpurgated_A = mkWA (k38 "täydellinen") ; --UNCHK
lin unextended_A = mkWA "ojentumaton" ; --UNCHK
lin unfaceted_A = mkWA (k34A "hiomaton") ; --UNCHK
lin unfailing_A = mkWA (k34A "pettämätön") ; --UNCHK
lin unfair_A = mkA "epäreilu" ;
lin unfairness_N = mkWN (k40 "vääryys") ; --UNCHK
lin unfaithful_A = mkWA (k38 "petollinen") ; --UNCHK
lin unfaithfulness_N = mkWN (k40 "uskottomuus") ; --UNCHK
lin unfaltering_A = mkWA (k34A "horjumaton") ; --UNCHK
lin unfamiliar_A = mkWA (k34A "tuntematon") ; --UNCHK
lin unfamiliarity_N = mkWN (k40 "outous") ; --UNCHK
lin unfashionable_A = mkWA (compoundA "vanhan" (k38 "aikainen")) ; --UNCHK
lin unfasten_V = mkWV (k73 "avata") ; --UNCHK
lin unfasten_V2 = mkWV2 (k73 "avata") ; --UNCHK
lin unfastidious_A = mkWA (k38 "homssuinen") ; --UNCHK
lin unfathomable_A = mkWA (k34A "pohjaton") ; --UNCHK
lin unfathomed_A = mkWA (k34A "mittaamaton") ; --UNCHK
lin unfattened_A = mkWA (k9 "laiha") ; --UNCHK
lin unfavorable_A = mkWA (k38 "vastainen") ; --UNCHK
lin unfavorableness_N = mkWN (k40 "haitallisuus") ; --UNCHK
lin unfavourable_A = mkWA (k38 "vastainen") ; --UNCHK
lin unfeathered_A = mkWA "sulaton" ; --UNCHK
lin unfed_A = mkWA "ruokkimaton" ; --UNCHK
lin unfeeling_A = mkWA (k34A "tunteeton") ; --UNCHK
lin unfeelingness_N = mkWN (k40 "piittaamattomuus") ; --UNCHK
lin unfeigned_A = mkWA (k34A "väärentämätön") ; --UNCHK
lin unfeminine_A = mkWA (compoundA "epä" (k38 "naisellinen")) ; --UNCHK
lin unfenced_A = mkWA (k33 "avoin") ; --UNCHK
lin unfermented_A = mkWA (k48 "tuore") ; --UNCHK
lin unfertilized_A = mkWA "hedelmöittymätön" ; --UNCHK
lin unfettered_A = mkWA (k17 "vapaa") ; --UNCHK
lin unfilled_A = mkWA "toimittamaton" ; --UNCHK
lin unfilmed_A = mkWA "nauhoittamaton" ; --UNCHK
lin unfinished_A = mkWA (k38 "keskeneräinen") ; --UNCHK
lin unfirm_A = mkWA (k10 "liikkuva") ; --UNCHK
lin unfit_A = mkWA (compoundA "huonokun" (k38 "toinen")) ; --UNCHK
lin unfit_V2 = mkWV2 (k73 "jäävätä") ; --UNCHK
lin unfitness_N = mkWN "kelpaamattomuus" ; --UNCHK
lin unfixed_A = mkWA (k10 "löysä") ; --UNCHK
lin unflagging_A = mkWA (k34A "pettämätön") ; --UNCHK
lin unflappable_A = mkWA (k38 "rauhallinen") ; --UNCHK
lin unflattering_A = mkWA (compoundA "epä" (k38 "edullinen")) ; --UNCHK
lin unflavored_A = mkWA "maustamaton" ; --UNCHK
lin unfledged_A = mkWA "sulaton" ; --UNCHK
lin unflinching_A = mkWA (k15 "rohkea") ; --UNCHK
lin unflurried_A = mkWA (k1A "rento") ; --UNCHK
lin unfocused_A = mkWA (k38 "hajanainen") ; --UNCHK
lin unfold_V = mkV "kehittyä" ; --mkWV (k53 "kukoistaa") ;
lin unfold_V2 = mkWV2 (k53 "kukoistaa") ; --UNCHK
lin unfolding_N = mkWN (k39 "kehitys") ; --UNCHK
lin unforbearing_A = mkWA (k34A "kärsimätön") ; --UNCHK
lin unforced_A = mkWA (k38 "luonnollinen") ; --UNCHK
lin unforeseeable_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unforeseen_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unforested_A = mkWA (k34A "puuton") ; --UNCHK
lin unforethoughtful_A = mkWA (k34A "ajattelematon") ; --UNCHK
lin unforfeitable_A = mkWA (k34A "luovuttamaton") ; --UNCHK
lin unforgettable_A = mkWA (k10 "mieleenpainuva") ; --UNCHK
lin unforgivable_A = mkWA (k34A "anteeksiantamaton") ; --UNCHK
lin unforgiving_A = mkWA (k34A "leppymätön") ; --UNCHK
lin unformed_A = mkWA (k34A "muodoton") ; --UNCHK
lin unfortunate_A = mkA "epäonninen" ;
lin unfortunate_N = mkWN (k38 "ihminen") "kovaonninen" ; --UNCHK
lin unfortunately_Adv = mkAdv "valitettavasti" ;
lin unfounded_A = mkA "perusteeton" ;
lin unframed_A = mkWA (k34A "kehyksetön") ; --UNCHK
lin unfrequented_A = mkWA (k38 "yksinäinen") ; --UNCHK
lin unfretted_A = mkWA "nauhaton" ; --UNCHK
lin unfriendliness_N = mkWN (compoundN "epä" (k40 "ystävällisyys")) ; --UNCHK
lin unfriendly_A = mkWA (compoundA "epä" (k38 "ystävällinen")) ;
lin unfrightened_A = mkWA (k15 "rohkea") ; --UNCHK
lin unfrosted_A = mkWA (k41A "kirkas") ; --UNCHK
lin unfrozen_A = mkWA "jäätymätön" ; --UNCHK
lin unfruitful_A = mkWA (k34A "hedelmätön") ; --UNCHK
lin unfueled_A = mkWA (k10 "tyhjä") ; --UNCHK
lin unfulfilled_A = mkWA (k34A "tyytymätön") ; --UNCHK
lin unfunctional_A = mkWA (compoundA "epä" (k38 "käytännöllinen")) ; --UNCHK
lin unfunded_A = mkWA (k34A "rahaton") ; --UNCHK
lin unfunny_A = mkWA (k10 "tyhmä") ; --UNCHK
lin unfurl_V = mkWV (k53A "levittää") ; --UNCHK
lin unfurl_V2 = mkWV2 (k53A "levittää") ; --UNCHK
lin unfurnished_A = mkWA (k34A "kalustamaton") ; --UNCHK
lin unfurrowed_A = mkWA (k15 "sileä") ; --UNCHK
lin ungainly_A = mkWA (k34A "taipumaton") ; --UNCHK
lin ungeared_A = mkWA "vaihteeton" ; --UNCHK
lin ungenerous_A = mkWA (k10 "nuuka") ; --UNCHK
lin ungentle_A = mkWA (k38 "alhainen") ; --UNCHK
lin ungentlemanly_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin unglazed_A = mkWA "päällystämätön" ; --UNCHK
lin ungodliness_N = mkWN "jumalattomuus" ; --UNCHK
lin ungodly_A = mkWA (k34A "jumalaton") ; --UNCHK
lin ungovernable_A = mkWA (k34A "vallaton") ; --UNCHK
lin ungraceful_A = mkWA (k2 "tökerö") ; --UNCHK
lin ungracious_A = mkWA (k34A "suloton") ; --UNCHK
lin ungraciousness_N = mkWN (compoundN "epä" (k40 "kohteliaisuus")) ; --UNCHK
lin ungraded_A = mkWA "järjestäytymätön" ; --UNCHK
lin ungrammatical_A = mkWA (k10 "väärä") ; --UNCHK
lin ungrasped_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin ungrateful_A = mkWA (k34A "kiittämätön") ; --UNCHK
lin ungratefulness_N = mkWN (k40 "kiittämättömyys") ; --UNCHK
lin ungregarious_A = mkWA (compoundA "yksin" (k10 "elävä")) ; --UNCHK
lin ungroomed_A = mkWA "kampaamaton" ; --UNCHK
lin ungrudging_A = mkWA (k34A "vilpitön") ; --UNCHK
lin ungual_A = mkWA "sorkan" ; --UNCHK
lin unguaranteed_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin unguent_N = mkWN (k9 "salva") ; --UNCHK
lin unguiculate_A = mkWA (compoundA "sorkka" (k38 "mainen")) ; --UNCHK
lin unguiculate_N = mkWN (compoundN "sorkka" (k33 "eläin")) "kavio-" "ja" ; --UNCHK
lin unguided_A = mkWA "ohjaamaton" ; --UNCHK
lin ungulate_A = mkWA (compoundA "sorkka" (k38 "mainen")) ; --UNCHK
lin ungummed_A = mkWA "kumittamaton" ; --UNCHK
lin ungusseted_A = mkWA "vahvikkeeton" ; --UNCHK
lin unhallowed_A = mkWA (k34A "vihkimätön") ; --UNCHK
lin unhampered_A = mkWA (k17 "vapaa") ; --UNCHK
lin unhand_V2 = mkWV2 (k53 "päästää") ; --UNCHK
lin unhappiness_N = mkWN (k40 "ilottomuus") ; --UNCHK
lin unhappy_A = mkWA (k34A "onneton") ; --UNCHK
lin unharmed_A = mkWA (k34A "vahingoittumaton") ; --UNCHK
lin unhatched_A = mkWA "kuoriutumaton" ; --UNCHK
lin unheaded_A = mkWA "otsikoimaton" ; --UNCHK
lin unhealed_A = mkWA (k34A "parantumaton") ; --UNCHK
lin unhealthful_A = mkWA (compoundA "epä" (k38 "terveellinen")) ; --UNCHK
lin unhealthfulness_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin unhealthy_A = mkWA (k41 "sairas") ; --UNCHK
lin unheard_A = mkWA (k34A "kuulumaton") ; --UNCHK
lin unheard_of_A = mkA "ennenkuulumaton" ;
lin unhearing_A = mkWA (k1 "umpikuuro") ; --UNCHK
lin unheated_A = mkWA "lämmittämätön" ; --UNCHK
lin unhelpful_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unhelpfulness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin unheralded_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unhesitating_A = mkWA (k15 "ripeä") ; --UNCHK
lin unhewn_A = mkWA (k15 "karkea") ; --UNCHK
lin unhindered_A = mkWA (k17 "vapaa") ; --UNCHK
lin unhinge_V2 = mkWV2 (k53 "nostaa") "saranoilta" ; --UNCHK
lin unhitch_V = mkWV (k53A "irrottaa") ; --UNCHK
lin unhitch_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin unholiness_N = mkWN "jumalattomuus" ; --UNCHK
lin unholy_A = mkWA (k34A "vihkimätön") ; --UNCHK
lin unhomogenized_A = mkWA "homogenisoimaton" ; --UNCHK
lin unhook_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin unhoped_A = mkWA (k34A "odottamaton") ; --UNCHK
lin unhurried_A = mkWA (k38 "rauhallinen") ; --UNCHK
lin unhurt_A = mkWA (k34A "vahingoittumaton") ; --UNCHK
lin unhygienic_A = mkWA (compoundA "epä" (k38 "hygieeninen")) ; --UNCHK
lin unicameral_A = mkWA (compoundA "yks" (k38 "ikamarinen")) ; --UNCHK
lin unicellular_A = mkWA (compoundA "yksiso" (k38 "luinen")) ; --UNCHK
lin unicorn_N = mkWN (compoundN "yks" (k38 "isarvinen")) ; --UNCHK
lin unicuspid_A = mkWA (compoundA "yksi" (k38 "nystermäinen")) ; --UNCHK
lin unicycle_N = mkWN (compoundN "polku" (k10 "pyörä")) "yksipyöräinen" ; --UNCHK
lin unicyclist_N = mkWN (k12 "pyöräilijä") ; --UNCHK
lin unidentifiable_A = mkWA "tunnistamaton" ; --UNCHK
lin unidentified_A = mkWA (k34A "tunnistamaton") ;
lin unidimensional_A = mkWA (compoundA "yks" (k38 "iulotteinen")) ; --UNCHK
lin unidirectional_A = mkWA (compoundA "yksi" (k38 "suuntainen")) ; --UNCHK
lin unifacial_A = mkWA (compoundA "yks" (k38 "itahoinen")) ; --UNCHK
lin unification_N = mkWN (compoundN "liitto" (k38 "utuminen")) ; --UNCHK
lin unifilar_A = mkWA (compoundA "yksi" (k38 "säikeinen")) ; --UNCHK
lin unifoliate_A = mkWA (compoundA "yksi" (k38 "lehtinen")) ; --UNCHK
lin uniform_A = mkWA (k38 "yhtenäinen") ;
lin uniform_N = mkWN (k1 "univormu") ;
lin uniformed_A = mkWA (compoundA "virka" (k38 "-asuinen")) ; --UNCHK
lin uniformity_N = mkWN (k40 "yhtenäisyys") ; --UNCHK
lin unify_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin unilateral_A = mkWA (compoundA "yksi" (k38 "puolinen")) ; --UNCHK
lin unilateralism_N = mkWN (compoundN "unilateral" (k5 "ismi")) ; --UNCHK
lin unilateralist_N = mkWN "unilateralisti" ; --UNCHK
lin unimaginable_A = mkWA (k34A "uskomaton") ; --UNCHK
lin unimaginative_A = mkWA (k38 "sovinnainen") ; --UNCHK
lin unimodal_A = mkWA (compoundA "uni" (k38 "modaalinen")) ; --UNCHK
lin unimpaired_A = mkWA (k34A "vahingoittumaton") ; --UNCHK
lin unimpassioned_A = mkWA (k34A "kiihkoton") ; --UNCHK
lin unimpeachable_A = mkWA (k34A "moitteeton") ; --UNCHK
lin unimpeded_A = mkWA (k34A "keskeytymätön") ; --UNCHK
lin unimportance_N = mkWN (k40 "mitättömyys") ; --UNCHK
lin unimportant_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin unimposing_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin unimpressed_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unimpressionable_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unimpressive_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin unimproved_A = mkWA (k34A "viljelemätön") ; --UNCHK
lin unincorporated_A = mkWA "järjestäytymätön" ; --UNCHK
lin unindustrialized_A = mkWA "teollistamaton" ; --UNCHK
lin uninebriated_A = mkWA (k10 "selvä") ; --UNCHK
lin uninfected_A = mkWA (k41A "puhdas") ; --UNCHK
lin uninflected_A = mkWA (k38 "analyyttinen") ; --UNCHK
lin uninfluenced_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin uninfluential_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin uninformative_A = mkWA (k34A "sisällyksetön") ; --UNCHK
lin uninformed_A = mkWA (k34A "tietämätön") ; --UNCHK
lin uninhabitable_A = mkWA (compoundA "asumis" (k34A "kelvoton")) ; --UNCHK
lin uninhabited_A = mkWA (k34A "asumaton") ; --UNCHK
lin uninhibited_A = mkWA (k34A "estoton") ; --UNCHK
lin uninitiate_A = mkWA (k5 "naiivi") ; --UNCHK
lin uninitiated_A = mkWA (k5 "naiivi") ; --UNCHK
lin uninjectable_A = mkWA "ei-suonensisäinen" ; --UNCHK
lin uninjured_A = mkWA (k34A "vahingoittumaton") ; --UNCHK
lin uninominal_A = mkWA (compoundA "yks" (k38 "ijäseninen")) ; --UNCHK
lin uninquiring_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin uninspired_A = mkWA "mielikuvitukseton" ; --UNCHK
lin uninspiring_A = mkWA (k10 "masentava") ; --UNCHK
lin uninstructed_A = mkWA (k34A "oppimaton") ; --UNCHK
lin uninstructive_A = mkWA (compoundA "mitään" (k34A "sanomaton")) ; --UNCHK
lin uninsurability_N = mkWN (compoundN "vakuuttamis" (k40 "kelvottomuus")) ; --UNCHK
lin uninsurable_A = mkWA (compoundA "vakuuttamis" (k34A "kelvoton")) ; --UNCHK
lin uninsured_A = mkWA (k34A "vakuuttamaton") ;
lin unintelligent_A = mkWA (k10 "typerä") ; --UNCHK
lin unintelligibility_N = mkWN (k40 "käsittämättömyys") ; --UNCHK
lin unintelligible_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin unintended_A = mkWA (k34A "tahaton") ; --UNCHK
lin unintentional_A = mkWA (k34A "suunnittelematon") ; --UNCHK
lin uninterested_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin uninteresting_A = mkWA (k10 "tylsä") ; --UNCHK
lin uninterestingness_N = mkWN "pitkästyttävyys" ; --UNCHK
lin uninterrupted_A = mkWA (k34A "keskeytymätön") ; --UNCHK
lin unintrusive_A = mkWA (compoundA "hie" (k38 "notunteinen")) ; --UNCHK
lin uninucleate_A = mkWA "tumaton" ; --UNCHK
lin uninvited_A = mkWA (k34A "kutsumaton") ; --UNCHK
lin uninviting_A = mkWA (compoundA "vaste" (k38 "nmielinen")) ; --UNCHK
lin uninvolved_A = mkWA (compoundA "ulko" (k38 "puolinen")) ; --UNCHK
lin union_A = mkWA "ammattiliiton" ; --UNCHK
lin union_N = mkN (lin NK {s = d06 "unioni"}) ;
lin unionism_N = mkWN (compoundN "työväen" (k48A "liike")) ; --UNCHK
lin unionist_N = mkWN (k32 "jäsen") "ammattiliiton" ; --UNCHK
lin unionization_N = mkWN (compoundN "liitto" (k38 "utuminen")) "ammatillinen" ; --UNCHK
lin uniovular_A = mkWA (compoundA "yksimunaso" (k38 "luinen")) ; --UNCHK
lin unipolar_A = mkWA (compoundA "yks" (k38 "inapainen")) ; --UNCHK
lin unique_A = mkA "ainutlaatuinen" ;
lin uniqueness_N = mkWN "ainutlaatuisuus" ; --UNCHK
lin unironed_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin unisexual_A = mkWA "yksisukupuolinen" ; --UNCHK
lin unison_N = mkWN "unisono" ; --UNCHK
lin unit_1_N = mkN "yksikkö" ;
lin unit_2_N = mkN "yksikkö" ;
lin unit_3_N = mkN "yksikkö" ;
lin unit_4_N = mkN "yksikkö" ;
lin unit_5_N = mkN "yksikkö" ;
lin unit_6_N = mkN "yksikkö" ;
lin unit_N = mkN "yksikkö" ;
lin unitarian_A = mkWA (compoundA "uni" (k38 "taristinen")) ; --UNCHK
lin unitarian_N = mkWN (compoundN "unita" (k5 "risti")) ; --UNCHK
lin unitarianism_N = mkWN (compoundN "unitarian" (k5 "ismi")) ; --UNCHK
lin unitary_A = mkWA (compoundA "uni" (k38 "taarinen")) ; --UNCHK
lin unite_V = mkV "yhdistyä" ; --mkWV (k53 "yhdistää") ;
lin unite_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin united_A = variants {} ; --
lin unitization_N = mkWN "hyödyntäminen" ; --UNCHK
lin unity_N = mkWN (k40 "yhtenäisyys") ;
lin univalent_A = mkWA (compoundA "yhden" (k38 "arvoinen")) ; --UNCHK
lin univalve_A = mkWA (compoundA "yksi" (k38 "onteloinen")) ; --UNCHK
lin universal_A = mkWA (k5 "universaali") ; --UNCHK
lin universal_N = mkWN (k9A "kytkentä") ; --UNCHK
lin universalism_N = mkWN (compoundN "universal" (k5 "ismi")) ; --UNCHK
lin universalistic_A = mkWA (compoundA "uni" (k38 "versalistinen")) ; --UNCHK
lin universality_N = mkWN (compoundN "yleis" (k40 "maailmallisuus")) ; --UNCHK
lin universe_N = mkN "niversumi" ;
lin university_N = L.university_N ;
lin unjointed_A = mkWA "irronnut" ; --UNCHK
lin unjust_A = mkWA (k38 "vilpillinen") ; --UNCHK
lin unjustifiable_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin unjustified_A = mkWA (k34A "kohtuuton") ; --UNCHK
lin unkempt_A = mkWA (k34A "ruokkoamaton") ; --UNCHK
lin unkind_A = mkWA (k1 "tyly") ; --UNCHK
lin unkindled_A = mkWA "sytyttämätön" ; --UNCHK
lin unkindly_A = mkWA (k1 "tyly") ; --UNCHK
lin unkindness_N = mkWN (k40 "tylyys") ; --UNCHK
lin unknowable_A = mkWA (k34A "tuntematon") ; --UNCHK
lin unknowing_A = mkWA (k34A "oppimaton") ; --UNCHK
lin unknowingness_N = mkWN (k40 "tietämättömyys") ; --UNCHK
lin unknown_A = mkWA (k34A "tuntematon") ;
lin unknown_N = mkN "tuntematon" ; --mkWN (k12 "tekijä") "tuntematon" ;
lin unlabeled_A = mkWA "merkitsemätön" ; --UNCHK
lin unlabelled_A = mkWA "merkitsemätön" ; --UNCHK
lin unlaced_A = mkWA (compoundA "reps" (k10 "ottava")) ; --UNCHK
lin unladylike_A = mkWA (k34A "sopimaton") "naiselle" ; --UNCHK
lin unlamented_A = mkWA "unohdettu" ; --UNCHK
lin unlatched_A = mkWA "lukitsematon" ; --UNCHK
lin unlaureled_A = mkWA "unohdettu" ; --UNCHK
lin unlawful_A = mkWA (k34A "laiton") ;
lin unlawfulness_N = mkWN (k40 "laittomuus") ; --UNCHK
lin unleaded_A = mkWA (k34A "lyijytön") ; --UNCHK
lin unleash_V2 = mkWV2 (k53 "päästää") "ilmoille" ;
lin unleavened_A = mkWA (k34A "happamaton") ; --UNCHK
lin unless_Subj = mkSubj "ellei" ;
lin unlettered_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin unlicensed_A = mkWA (k34A "luvaton") ; --UNCHK
lin unlighted_A = mkWA "sytyttämätön" ; --UNCHK
lin unlikable_A = mkWA (k10 "tylsä") ; --UNCHK
lin unlike_A = mkWA (k38 "erilainen") ; --UNCHK
lin unlike_Prep = mkPrep "erilainen kuin" nominative ;
lin unlikelihood_N = mkWN "epätodennäköisyys" ; --UNCHK
lin unlikely_A = mkA ( mkN "epätoden" (mkN "näköinen")) ;
lin unlikeness_N = mkWN (k40 "erilaisuus") ; --UNCHK
lin unlimited_A = mkWA (k34A "ääretön") ; --UNCHK
lin unlined_A = mkWA "vuoreton" ; --UNCHK
lin unlisted_A = mkWA (k38 "salainen") ; --UNCHK
lin unlit_A = mkWA "sytyttämätön" ; --UNCHK
lin unliterary_A = mkWA (compoundA "suu" (k38 "rpiirteinen")) ; --UNCHK
lin unlivable_A = mkWA (compoundA "asumis" (k34A "kelvoton")) ; --UNCHK
lin unliveried_A = mkWA (compoundA "arki" (k38 "pukuinen")) ; --UNCHK
lin unload_V = mkWV (k53A "purkaa") "lasti" ; --UNCHK
lin unload_V2 = mkWV2 (k53A "purkaa") "lasti" ; --UNCHK
lin unloading_N = mkWN "purkaminen" ; --UNCHK
lin unlobed_A = mkWA "korvaton" ; --UNCHK
lin unlocated_A = mkWA "paikallistamaton" ; --UNCHK
lin unlock_V = mkWV (k52A "avautua") ; --UNCHK
lin unlock_V2 = mkWV2 (k52A "avautua") ; --UNCHK
lin unloose_V2 = mkWV2 (k73 "avata") ; --UNCHK
lin unlovable_A = mkWA (compoundA "yhden" (k10 "tekevä")) ; --UNCHK
lin unloved_A = mkWA (compoundA "yhden" (k10 "tekevä")) ; --UNCHK
lin unlovely_A = mkWA (k10 "ruma") ; --UNCHK
lin unloving_A = mkWA (k15 "ynseä") ; --UNCHK
lin unlubricated_A = mkWA "öljyämätön" ; --UNCHK
lin unlucky_A = mkWA (k34A "onneton") ; --UNCHK
lin unmade_A = mkWA "sijaamaton" ; --UNCHK
lin unmalicious_A = mkWA (kH1 "kiltti") ; --UNCHK
lin unmalleability_N = mkWN (k40 "jäykkyys") ; --UNCHK
lin unmalleable_A = mkWA (k34A "taipumaton") ; --UNCHK
lin unmalted_A = mkWA "käymätön" ; --UNCHK
lin unman_V2 = mkWV2 (k54A "musertaa") ; --UNCHK
lin unmanageable_A = mkWA (k15 "vaikea") ; --UNCHK
lin unmanfully_Adv = mkWAdv (compoundAdv "epä" (k99 "miehekkäästi")) ; --UNCHK
lin unmanly_A = mkWA (compoundA "epä" (k41A "miehekäs")) ; --UNCHK
lin unmannered_A = mkWA (k10 "luonteva") ; --UNCHK
lin unmannerly_A = mkWA (k15 "karkea") ; --UNCHK
lin unmarked_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin unmarketable_A = mkWA (compoundA "myynti" (k34A "kelvoton")) ; --UNCHK
lin unmarried_A = mkWA (k34A "avioton") ; --UNCHK
lin unmask_V = mkWV (k53 "paljastaa") ; --UNCHK
lin unmask_V2 = mkWV2 (k53 "paljastaa") ; --UNCHK
lin unmatched_A = mkA (mkN "ainut" (mkN "kertainen")) ;
lin unmated_A = mkWA (k34A "pariton") ; --UNCHK
lin unmeasured_A = mkWA (k34A "määrätön") ; --UNCHK
lin unmechanical_A = mkWA (compoundA "epä" (k38 "käytännöllinen")) ; --UNCHK
lin unmechanized_A = mkWA (compoundA "käsin" (k10 "tehtävä")) ; --UNCHK
lin unmedicinal_A = mkWA (compoundA "ei-" (k38 "lääkinnällinen")) ; --UNCHK
lin unmelodious_A = mkWA (compoundA "epä" (k10 "sointuisa")) ; --UNCHK
lin unmelted_A = mkWA "sulamaton" ; --UNCHK
lin unmemorable_A = mkWA (compoundA "yhden" (k10 "tekevä")) ; --UNCHK
lin unmentionable_A = mkWA (k34A "sopimaton") ; --UNCHK
lin unmercenary_A = mkWA "laskelmoimaton" ; --UNCHK
lin unmerciful_A = mkWA (k34A "säälimätön") ; --UNCHK
lin unmerited_A = mkWA (k34A "ansaitsematon") ; --UNCHK
lin unmeritorious_A = mkWA (k34A "ansaitsematon") ; --UNCHK
lin unmethodical_A = mkWA (compoundA "sattuman" (k38 "varainen")) ; --UNCHK
lin unmilitary_A = mkWA (compoundA "epä" (k38 "sotilaallinen")) ; --UNCHK
lin unmindful_A = mkWA (compoundA "haja" (k38 "mielinen")) ; --UNCHK
lin unmindfulness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin unmined_A = mkWA "hyödyntämätön" ; --UNCHK
lin unmingled_A = mkWA (k9A "silkka") ; --UNCHK
lin unmistakable_A = mkWA (k9 "varma") ; --UNCHK
lin unmitigable_A = mkWA "lieventymätön" ; --UNCHK
lin unmitigated_A = mkWA (k38 "täydellinen") ; --UNCHK
lin unmixed_A = mkWA "sekoittamaton" ; --UNCHK
lin unmoderated_A = mkWA "hallitsematon" ; --UNCHK
lin unmodernized_A = mkWA "nykyaikaistamaton" ; --UNCHK
lin unmodifiable_A = mkWA (k34A "muuttumaton") ; --UNCHK
lin unmodified_A = mkWA "muuttamaton" ; --UNCHK
lin unmodulated_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin unmolested_A = mkWA (k34A "vahingoittumaton") ; --UNCHK
lin unmotivated_A = mkWA "innostumaton" ; --UNCHK
lin unmourned_A = mkWA "unohdettu" ; --UNCHK
lin unmovable_A = mkWA (k34A "järkähtämätön") ; --UNCHK
lin unmoved_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unmoving_A = mkWA (compoundA "yhden" (k10 "tekevä")) ; --UNCHK
lin unmown_A = mkWA "ajamaton" ; --UNCHK
lin unmusical_A = mkWA (compoundA "epä" (k10 "sointuisa")) ; --UNCHK
lin unmyelinated_A = mkWA "myelinisoitumaton" ; --UNCHK
lin unnamed_A = mkWA (k34A "nimetön") ; --UNCHK
lin unnatural_A = mkWA (k34A "luonnoton") ; --UNCHK
lin unnaturalized_A = mkWA "vailla" "kansalaisuutta" ; --UNCHK
lin unnaturalness_N = mkWN "keinotekoisuus" ; --UNCHK
lin unnavigable_A = mkWA (compoundA "kulku" (k34A "kelvoton")) ; --UNCHK
lin unnecessary_A = mkWA (k10 "turha") ; --UNCHK
lin unneighborliness_N = mkWN (compoundN "epä" (k40 "ystävällisyys")) ; --UNCHK
lin unneighborly_A = mkWA (compoundA "epä" (k38 "ystävällinen")) ; --UNCHK
lin unnerve_V2 = mkWV2 (k54A "hämmentää") ; --UNCHK
lin unneurotic_A = mkWA (compoundA "epä" (k38 "neuroottinen")) ; --UNCHK
lin unnotched_A = mkWA "loveton" ; --UNCHK
lin unnoticeable_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin unnoticeableness_N = mkWN (k40 "huomaamattomuus") ; --UNCHK
lin unnoticed_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin unnourished_A = mkWA "ruokkimaton" ; --UNCHK
lin unnumbered_A = mkWA (k34A "rajaton") ; --UNCHK
lin unobjectionable_A = mkWA (k34A "moitteeton") ; --UNCHK
lin unobjective_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin unobligated_A = mkWA (compoundA "vel" (k34A "voittamaton")) ; --UNCHK
lin unobservable_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin unobservant_A = mkWA "keskittymätön" ; --UNCHK
lin unobserved_A = mkWA (k99 "huomaamattomasti") ; --UNCHK
lin unobstructed_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin unobtainable_A = mkWA (k99 "saatavilla") "ei" ; --UNCHK
lin unobtrusive_A = mkWA (k34A "vaatimaton") ; --UNCHK
lin unobtrusiveness_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin unobvious_A = mkWA (k34A "odottamaton") ; --UNCHK
lin unoccupied_A = mkWA (k10 "tyhjä") ; --UNCHK
lin unoffending_A = mkWA (k34A "vaaraton") ; --UNCHK
lin unofficial_A = mkWA (compoundA "epä" (k38 "virallinen")) ;
lin unoiled_A = mkWA "öljyämätön" ; --UNCHK
lin unopen_A = mkWA (k99 "kiinni") ; --UNCHK
lin unopened_A = mkWA "avaamaton" ; --UNCHK
lin unopposable_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unopposed_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unorganized_A = mkWA "järjestäytymätön" ; --UNCHK
lin unoriented_A = mkWA (k34A "päämäärätön") ; --UNCHK
lin unoriginal_A = mkWA (k38 "arkinen") ; --UNCHK
lin unoriginality_N = mkWN (k40 "arkisuus") ; --UNCHK
lin unorthodox_A = mkWA (compoundA "epä" (k38 "sovinnainen")) ; --UNCHK
lin unorthodoxy_N = mkWN (compoundN "epä" (k40 "sovinnaisuus")) ; --UNCHK
lin unostentatious_A = mkWA (k34A "vaatimaton") ; --UNCHK
lin unowned_A = mkWA (compoundA "omist" (k34A "ajaton")) ; --UNCHK
lin unpack_V = mkWV (k53A "purkaa") ; --UNCHK
lin unpack_V2 = mkWV2 (k53A "purkaa") ; --UNCHK
lin unpackaged_A = mkWA "pakkaamaton" ; --UNCHK
lin unpaid_A = mkWA (k34A "maksamaton") ;
lin unpaintable_A = mkWA (k34A "kuvaamaton") ; --UNCHK
lin unpainted_A = mkWA (k34A "maalaamaton") ; --UNCHK
lin unpalatability_N = mkWN (kH1 "karvaus") ; --UNCHK
lin unpalatable_A = mkWA (k41 "karvas") ; --UNCHK
lin unparallel_A = mkWA "ei-yhdensuuntainen" ; --UNCHK
lin unpardonable_A = mkWA (k34A "anteeksiantamaton") ; --UNCHK
lin unparented_A = mkWA (k1A "orpo") ; --UNCHK
lin unparliamentary_A = mkWA (compoundA "epä" (k38 "parlamentaarinen")) ; --UNCHK
lin unpartitioned_A = mkWA (k34A "jakamaton") ; --UNCHK
lin unpasteurized_A = mkWA "pastöroimaton" ; --UNCHK
lin unpatented_A = mkWA "patentoimaton" ; --UNCHK
lin unpatriotic_A = mkWA "epäisänmaallinen" ; --UNCHK
lin unpatronized_A = mkWA (compoundA "epä" (k1A "suosittu")) ; --UNCHK
lin unpaved_A = mkWA "kiveämätön" ; --UNCHK
lin unpeaceable_A = mkWA (k34A "rauhaton") ; --UNCHK
lin unpeaceful_A = mkWA (k34A "rauhaton") ; --UNCHK
lin unpeopled_A = mkWA (k34A "asumaton") ; --UNCHK
lin unperceived_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin unperceptive_A = mkWA (compoundA "paksu" (k38 "nahkainen")) ; --UNCHK
lin unperceptiveness_N = mkWN (compoundN "epä" (k40 "sensitiivisyys")) ; --UNCHK
lin unperformed_A = mkWA "esittämätön" ; --UNCHK
lin unpermed_A = mkWA "permanenttaamaton" ; --UNCHK
lin unpermissive_A = mkWA (k9A "tiukka") ; --UNCHK
lin unpermissiveness_N = mkWN (k40 "tiukkuus") ; --UNCHK
lin unperplexed_A = mkWA "hämmentymätön" ; --UNCHK
lin unpersuadable_A = mkWA (k34A "taipumaton") ; --UNCHK
lin unpersuaded_A = mkWA "käännyttämätön" ; --UNCHK
lin unpersuasive_A = mkWA (compoundA "suo" (k38 "rasukainen")) ; --UNCHK
lin unpersuasiveness_N = mkWN (k40 "suorasukaisuus") ; --UNCHK
lin unperturbed_A = mkWA (k1A "rento") ; --UNCHK
lin unpick_V = mkWV (k53A "purkaa") ; --UNCHK
lin unpick_V2 = mkWV2 (k53A "purkaa") ; --UNCHK
lin unpierced_A = mkWA "lävistämätön" ; --UNCHK
lin unpigmented_A = mkWA (k34A "väritön") ; --UNCHK
lin unpillared_A = mkWA "pylväätön" ; --UNCHK
lin unplaced_A = mkWA (compoundA "palkinto" (k34A "sijaton")) ; --UNCHK
lin unplanned_A = mkWA (k34A "suunnittelematon") ; --UNCHK
lin unplanted_A = mkWA "istuttamaton" ; --UNCHK
lin unplayable_A = mkWA (k34A "tavoittamaton") ; --UNCHK
lin unplayful_A = mkWA (k38 "totinen") ; --UNCHK
lin unpleasant_A = mkWA (compoundA "epä" (k10 "miellyttävä")) ; --UNCHK
lin unpleasantness_N = mkWN (compoundN "epä" (k40 "miellyttävyys")) ; --UNCHK
lin unpleasingness_N = mkWN (k40 "rumuus") ; --UNCHK
lin unplowed_A = mkWA "kyntämätön" ; --UNCHK
lin unplug_V = mkWV (k66 "katkaista") "virta" ; --UNCHK
lin unplug_V2 = mkWV2 (k66 "katkaista") "virta" ; --UNCHK
lin unplumbed_A = mkWA (k34A "mittaamaton") ; --UNCHK
lin unpointedness_N = mkWN (compoundN "tylppäpä" (k40 "isyys")) ; --UNCHK
lin unpolished_A = mkWA "kiillottamaton" ; --UNCHK
lin unpolluted_A = mkWA "saastumaton" ; --UNCHK
lin unpompous_A = mkWA (k34A "vaatimaton") ; --UNCHK
lin unpopular_A = mkWA (compoundA "epä" (k1A "suosittu")) ;
lin unpopularity_N = mkWN (compoundN "epä" (k3 "suosio")) ; --UNCHK
lin unportable_A = mkWA (k10 "painava") ; --UNCHK
lin unposed_A = mkWA (k38 "luonnollinen") ; --UNCHK
lin unpotted_A = mkWA "istuttamaton" ; --UNCHK
lin unpowered_A = mkWA "moottoroimaton" ; --UNCHK
lin unpracticed_A = mkWA (k34A "tottumaton") ; --UNCHK
lin unpractised_A = mkWA (k34A "tottumaton") ; --UNCHK
lin unprecedented_A = mkWA (k38 "uudenlainen") ; --UNCHK
lin unpredictability_N = mkWN (k40 "oikukkuus") ; --UNCHK
lin unpredictable_A = mkA "ennustamaton" ;
lin unpredicted_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unpredictive_A = mkWA "ennustamaton" ; --UNCHK
lin unprejudiced_A = mkWA (k34A "ennakkoluuloton") ; --UNCHK
lin unpremeditated_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unprepared_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unprepossessing_A = mkWA (k1 "huono") ; --UNCHK
lin unpresidential_A = mkWA (compoundA "epä" (k38 "presidentillinen")) ; --UNCHK
lin unpressed_A = mkWA "prässäämätön" ; --UNCHK
lin unpretentious_A = mkWA (k34A "vaatimaton") ; --UNCHK
lin unpretentiousness_N = mkWN (k40 "vaatimattomuus") ; --UNCHK
lin unpreventable_A = mkWA "hillitsemätön" ; --UNCHK
lin unpriestly_A = mkWA (compoundA "epä" (k38 "papillinen")) ; --UNCHK
lin unprincipled_A = mkWA (k34A "moraaliton") ; --UNCHK
lin unprintable_A = mkWA (compoundA "paino" (k34A "kelvoton")) ; --UNCHK
lin unprocessed_A = mkWA (k34A "käsittelemätön") ; --UNCHK
lin unproductive_A = mkWA (k34A "tuottamaton") ; --UNCHK
lin unproductiveness_N = mkWN (k40 "hedelmättömyys") ; --UNCHK
lin unprofessional_A = mkWA (compoundA "maallikko" (k38 "mainen")) ; --UNCHK
lin unprofitable_A = mkWA (k34A "tuottamaton") ;
lin unprofitableness_N = mkWN (k40 "tuottamattomuus") ; --UNCHK
lin unpromising_A = mkWA (k10 "arveluttava") ; --UNCHK
lin unprompted_A = mkWA (compoundA "oma" (k38 "-aloitteinen")) ; --UNCHK
lin unpronounceable_A = mkWA (k15 "vaikea") ; --UNCHK
lin unprophetic_A = mkWA "ennustamaton" ; --UNCHK
lin unpropitious_A = mkWA (compoundA "epä" (k10 "suotuisa")) ; --UNCHK
lin unprotected_A = mkWA (k34A "suojaamaton") ; --UNCHK
lin unprotective_A = mkWA (k34A "suojaamaton") ; --UNCHK
lin unprovable_A = mkWA "toteennäyttämätön" ; --UNCHK
lin unproved_A = mkWA (k34A "todistamaton") ; --UNCHK
lin unproven_A = mkWA (k34A "todistamaton") ; --UNCHK
lin unprovocative_A = mkWA (k26 "tyyni") ; --UNCHK
lin unprovoked_A = mkWA (compoundA "mieli" (k38 "valtainen")) ; --UNCHK
lin unpublishable_A = mkWA (compoundA "paino" (k34A "kelvoton")) ; --UNCHK
lin unpublished_A = mkWA (k34A "julkaisematon") ;
lin unpunctual_A = mkWA (compoundA "epä" (k38 "täsmällinen")) ; --UNCHK
lin unpunished_A = mkWA "rankaisematon" ; --UNCHK
lin unpurified_A = mkWA "puhdistamaton" ; --UNCHK
lin unqualified_A = mkWA (compoundA "vajaa" (k38 "valtainen")) ; --UNCHK
lin unquestionable_A = mkWA (k34A "kiistaton") ; --UNCHK
lin unquestioned_A = mkWA (compoundA "vastaan" (k34A "sanomaton")) ; --UNCHK
lin unquestioning_A = mkWA (k34A "ehdoton") ; --UNCHK
lin unquiet_A = mkWA (k34A "levoton") ; --UNCHK
lin unratable_A = mkWA "verottamaton" ; --UNCHK
lin unratified_A = mkWA (k34A "vahvistamaton") ; --UNCHK
lin unravel_V = mkWV (k52A "purkautua") ; --UNCHK
lin unravel_V2 = mkWV2 (k52A "purkautua") ; --UNCHK
lin unreached_A = mkWA (k34A "saavuttamaton") ; --UNCHK
lin unreactive_A = mkWA "vasteeton" ; --UNCHK
lin unread_A = mkWA (k34A "oppimaton") ; --UNCHK
lin unreadable_A = mkA (mkN "luku" (mkN "kelvoton")) ;
lin unready_A = mkWA (k2 "kömpelö") ; --UNCHK
lin unreal_A = mkWA (k34A "aineeton") ; --UNCHK
lin unrealistic_A = mkWA (compoundA "epä" (k38 "realistinen")) ;
lin unrealistically_Adv = mkAdv "epärealistisesti" ;
lin unreality_N = mkWN (k40 "aineettomuus") ; --UNCHK
lin unrealized_A = mkWA (k34A "tyytymätön") ; --UNCHK
lin unreasonable_A = mkA "kohtuuton" ; --mkWA (compoundA "arvostelu" (k34A "kyvytön")) ;
lin unreasoning_A = mkWA (k34A "mieletön") ; --UNCHK
lin unreassuring_A = mkWA (compoundA "huoles" (k10 "tuttava")) ; --UNCHK
lin unreceptive_A = mkWA "vastaanottamaton" ; --UNCHK
lin unreciprocated_A = mkWA (compoundA "yksi" (k38 "puolinen")) ; --UNCHK
lin unrecognizable_A = mkWA "tunnistamaton" ; --UNCHK
lin unrecognized_A = mkWA "tunnistamaton" ; --UNCHK
lin unreconciled_A = mkWA (k38 "irrallinen") ; --UNCHK
lin unreconstructed_A = mkWA (k38 "taantumuksellinen") ; --UNCHK
lin unrecorded_A = mkWA (k99 "edessä") "yleisön" ; --UNCHK
lin unrecoverable_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin unredeemable_A = mkWA (k10 "oleva") "parantumattomissa" ; --UNCHK
lin unreduced_A = mkWA "vähentämätön" ; --UNCHK
lin unrefined_A = mkWA (k15 "karkea") ; --UNCHK
lin unreflected_A = mkWA (k34A "soinniton") ; --UNCHK
lin unreflective_A = mkWA (k34A "harkitsematon") ; --UNCHK
lin unreformable_A = mkWA (k34A "parantumaton") ; --UNCHK
lin unreformed_A = mkWA "reformoimaton" ; --UNCHK
lin unrefreshed_A = mkWA (k47 "väsynyt") ; --UNCHK
lin unregenerate_A = mkWA (k47 "paatunut") ; --UNCHK
lin unregistered_A = mkWA "rekisteröimätön" ; --UNCHK
lin unregretful_A = mkWA "katumaton" ; --UNCHK
lin unregulated_A = mkWA (k5 "villi") ; --UNCHK
lin unrelated_A = mkA (separateN "asiaan" (mkN "liittymätön")) ; --WA "vieraat" ;
lin unrelatedness_N = mkWN (k40 "irrallisuus") ; --UNCHK
lin unrelaxed_A = mkWA "pingottunut" ; --UNCHK
lin unreleased_A = mkWA "pingottunut" ; --UNCHK
lin unrelenting_A = mkWA (k34A "säälimätön") ; --UNCHK
lin unreliable_A = mkWA (compoundA "epä" (k10 "luotettava")) ; --UNCHK
lin unrelieved_A = mkWA (k34A "hellittämätön") ; --UNCHK
lin unremarkable_A = mkWA (k38 "päivittäinen") ; --UNCHK
lin unremedied_A = mkWA (k34A "korjaamaton") ; --UNCHK
lin unremitting_A = mkWA (k38 "alituinen") ; --UNCHK
lin unremunerative_A = mkWA (k34A "tuottamaton") ; --UNCHK
lin unrenewable_A = mkWA (k34A "korvaamaton") ; --UNCHK
lin unrentable_A = mkWA (compoundA "vuokraus" (k34A "kelvoton")) ; --UNCHK
lin unrepaired_A = mkWA (k38 "rikkinäinen") ; --UNCHK
lin unrepentant_A = mkWA (k34A "tuntematon") "mielipahaa" ; --UNCHK
lin unreportable_A = mkWA "vailla" "ilmoitusvelvollisuutta" ; --UNCHK
lin unreported_A = mkWA (k34A "julkaisematon") ; --UNCHK
lin unrepresentative_A = mkWA (compoundA "epä" (k38 "tavallinen")) ; --UNCHK
lin unrepressed_A = mkWA "hillitsemätön" ; --UNCHK
lin unreproducible_A = mkWA (k34A "jäljittelemätön") ; --UNCHK
lin unrequested_A = mkWA "tilaamaton" ; --UNCHK
lin unrequited_A = mkWA (compoundA "yksi" (k38 "puolinen")) ; --UNCHK
lin unresentful_A = mkWA (k38 "suvaitsevainen") ; --UNCHK
lin unreserved_A = mkWA (k33 "avoin") ; --UNCHK
lin unresisting_A = mkWA (k38 "passiivinen") ; --UNCHK
lin unresolvable_A = mkWA (k34A "ratkaisematon") ; --UNCHK
lin unresolved_A = mkWA (k34A "ratkaisematon") ; --UNCHK
lin unrespectability_N = mkWN "huonomaineisuus" ; --UNCHK
lin unrespectable_A = mkWA (compoundA "epä" (k10 "kunnioitettava")) ; --UNCHK
lin unresponsive_A = mkWA "vasteeton" ; --UNCHK
lin unresponsiveness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin unrest_N = mkWN (k40 "levottomuus") ; --UNCHK
lin unrestrained_A = mkWA (compoundA "vapa" (k47 "utunut")) ; --UNCHK
lin unrestraint_N = mkWN (k40 "kurittomuus") ; --UNCHK
lin unrestricted_A = mkWA (k17 "vapaa") ; --UNCHK
lin unrestrictive_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin unretentive_A = mkWA (k43 "lyhyt") ; --UNCHK
lin unreverberant_A = mkWA (k34A "soinniton") ; --UNCHK
lin unrevised_A = mkWA (k34A "käsittelemätön") ; --UNCHK
lin unrevived_A = mkWA "uusimaton" ; --UNCHK
lin unrewarded_A = mkWA (k99 "käsin") "tyhjin" ; --UNCHK
lin unrewarding_A = mkWA (compoundA "epä" (k10 "tyydyttävä")) ; --UNCHK
lin unrhetorical_A = mkWA (compoundA "epä" (k38 "retorinen")) ; --UNCHK
lin unrhymed_A = mkWA (k34A "riimitön") ; --UNCHK
lin unrifled_A = mkWA "lataamaton" ; --UNCHK
lin unrigged_A = mkWA "lataamaton" ; --UNCHK
lin unrighteous_A = mkWA (k10 "väärä") ; --UNCHK
lin unrighteousness_N = mkWN (k40 "syntisyys") ; --UNCHK
lin unripe_A = mkWA (kH1 "raaka") ; --UNCHK
lin unripened_A = mkWA (kH1 "raaka") ; --UNCHK
lin unroll_V = mkWV (k53A "levittää") ; --UNCHK
lin unroll_V2 = mkWV2 (k53A "levittää") ; --UNCHK
lin unromantic_A = mkWA (compoundA "epä" (k38 "romanttinen")) ; --UNCHK
lin unromantically_Adv = mkWAdv (compoundAdv "epä" (k99 "romanttisesti")) ; --UNCHK
lin unroofed_A = mkWA "kattamaton" ; --UNCHK
lin unrouged_A = mkWA "punaamaton" ; --UNCHK
lin unruffled_A = mkWA (k26 "tyyni") ; --UNCHK
lin unruliness_N = mkWN (k40 "kurittomuus") ; --UNCHK
lin unruly_A = mkWA (k34A "vallaton") ; --UNCHK
lin unsaddle_V2 = mkWV2 (k52 "riisua") "satula" ; --UNCHK
lin unsafe_A = mkWA (k34A "turvaton") ; --UNCHK
lin unsalable_A = mkWA (compoundA "myynti" (k34A "kelvoton")) ; --UNCHK
lin unsaleable_A = mkWA (compoundA "myynti" (k34A "kelvoton")) ; --UNCHK
lin unsalted_A = mkWA (k34A "suolaton") ; --UNCHK
lin unsanctioned_A = mkWA (k34A "luvaton") ; --UNCHK
lin unsanitariness_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin unsanitary_A = mkWA (compoundA "epä" (k38 "terveellinen")) ; --UNCHK
lin unsaponified_A = mkWA "jalostamaton" ; --UNCHK
lin unsarcastic_A = mkWA (compoundA "ei-" (k38 "sarkastinen")) ; --UNCHK
lin unsated_A = mkWA (k34A "tyydyttämätön") ; --UNCHK
lin unsatisfactoriness_N = mkWN (k40 "epätyydyttävyys") ; --UNCHK
lin unsatisfactory_A = mkWA (compoundA "epä" (k10 "tyydyttävä")) ; --UNCHK
lin unsatisfiable_A = mkWA (k34A "tyydyttämätön") ; --UNCHK
lin unsatisfied_A = mkWA (k34A "levoton") ; --UNCHK
lin unsatisfying_A = mkWA (k10 "tuottava") "pettymyksen" ; --UNCHK
lin unsaturated_A = mkWA (k15 "himmeä") ; --UNCHK
lin unsavoury_A = mkWA (k34A "mauton") ; --UNCHK
lin unsay_V2 = mkWV2 (k52 "perua") "sanansa" ; --UNCHK
lin unscalable_A = mkWA (compoundA "vai" (k38 "keakulkuinen")) ; --UNCHK
lin unscathed_A = mkWA (k34A "vahingoittumaton") ; --UNCHK
lin unscheduled_A = mkWA (k38 "äkillinen") ; --UNCHK
lin unscholarly_A = mkWA (compoundA "epä" (k38 "tieteellinen")) ; --UNCHK
lin unschooled_A = mkWA (k34A "oppimaton") ; --UNCHK
lin unscientific_A = mkWA (compoundA "epä" (k38 "tieteellinen")) ; --UNCHK
lin unscramble_V2 = mkWV2 (k69 "tulkita") ; --UNCHK
lin unscrew_V = mkWV (k53A "irrottaa") ; --UNCHK
lin unscrew_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin unscripted_A = mkWA (compoundA "käsi" (k34A "kirjoittamaton")) ; --UNCHK
lin unscrupulous_A = mkWA (k34A "häikäilemätön") ;
lin unscrupulousness_N = mkWN (k40 "häikäilemättömyys") ; --UNCHK
lin unsealed_A = mkWA "sinetöimätön" ; --UNCHK
lin unseamanlike_A = mkWA (compoundA "maakrapu" (k38 "mainen")) ; --UNCHK
lin unseamed_A = mkWA (k15 "sileä") ; --UNCHK
lin unseasonable_A = mkWA (k38 "harvinainen") ; --UNCHK
lin unseasonableness_N = mkWN (k39 "ajoitus") ; --UNCHK
lin unseasoned_A = mkWA "jalostamaton" ; --UNCHK
lin unseat_V2 = mkWV2 (k74A "pudota") ; --UNCHK
lin unseaworthy_A = mkWA (compoundA "meri" (k34A "kelvoton")) ; --UNCHK
lin unsecured_A = mkA "varmistamaton" ;
lin unseductive_A = mkWA (compoundA "veto" (k34A "voimaton")) ; --UNCHK
lin unseeded_A = mkWA (k34A "taitamaton") ; --UNCHK
lin unseeing_A = mkWA "keskittymätön" ; --UNCHK
lin unseemliness_N = mkWN (k40 "välinpitämättömyys") ; --UNCHK
lin unseemly_A = mkWA (k34A "mauton") ; --UNCHK
lin unseen_A = mkWA (k34A "huomaamaton") ; --UNCHK
lin unseen_N = mkWN (k13 "maailma") "näkymätön" ; --UNCHK
lin unseeyn_A = mkWA (k34A "tuntematon") ; --UNCHK
lin unsegmented_A = mkWA (k34A "jaokkeeton") ; --UNCHK
lin unselected_A = mkWA (k34A "valikoimaton") ; --UNCHK
lin unselective_A = mkWA (compoundA "sattuman" (k38 "varainen")) ; --UNCHK
lin unselfconscious_A = mkWA (k34A "viaton") ; --UNCHK
lin unselfconsciousness_N = mkWN (k40 "viattomuus") ; --UNCHK
lin unselfish_A = mkWA (compoundA "epä" (k41A "itsekäs")) ; --UNCHK
lin unselfishness_N = mkWN (k40 "anteliaisuus") ; --UNCHK
lin unsensational_A = mkWA "huomiota" "herättämätön" ; --UNCHK
lin unsent_A = mkWA "lähettämätön" ; --UNCHK
lin unsentimentally_Adv = mkWAdv (k99 "tunteettomasti") ; --UNCHK
lin unserviceable_A = mkWA (compoundA "epäkun" (k38 "toinen")) ; --UNCHK
lin unservile_A = mkWA (compoundA "suo" (k38 "raselkäinen")) ; --UNCHK
lin unsettle_V2 = mkWV2 (k54A "hämmentää") ; --UNCHK
lin unsex_V2 = mkWV2 (k73A "leikata") ; --UNCHK
lin unsexy_A = mkWA (compoundA "epä" (k41A "seksikäs")) ; --UNCHK
lin unshaded_A = mkWA "varjoton" ; --UNCHK
lin unshadowed_A = mkWA (k41A "kirkas") ; --UNCHK
lin unshakable_A = mkWA (k38 "täydellinen") ; --UNCHK
lin unshaped_A = mkWA (k34A "muodoton") ; --UNCHK
lin unshapely_A = mkWA (k34A "muodoton") ; --UNCHK
lin unshared_A = mkWA (k34A "jakamaton") ; --UNCHK
lin unsharpened_A = mkWA "teroittamaton" ; --UNCHK
lin unshaved_A = mkWA "ajelematon" ; --UNCHK
lin unshaven_A = mkWA "ajelematon" ; --UNCHK
lin unsheared_A = mkWA (k34A "ruokkoamaton") ; --UNCHK
lin unsheathe_V2 = mkWV2 (k53A "vetää") "tupesta" ; --UNCHK
lin unshelled_A = mkWA "kuoreton" ; --UNCHK
lin unshielded_A = mkWA (k34A "suojaamaton") ; --UNCHK
lin unshockable_A = mkWA (k34A "järkkymätön") ; --UNCHK
lin unshod_A = mkWA "kengittämätön" ; --UNCHK
lin unshrinkable_A = mkWA "kutistumaton" ; --UNCHK
lin unshrinking_A = mkWA (k15 "rohkea") ; --UNCHK
lin unsighted_A = mkWA (k34A "varaukseton") ; --UNCHK
lin unsightliness_N = mkWN (k40 "rumuus") ; --UNCHK
lin unsightly_A = mkWA (k10 "ruma") ; --UNCHK
lin unsigned_A = mkWA (compoundA "alle" (k34A "kirjoittamaton")) ; --UNCHK
lin unsilenced_A = mkWA "hiljentämätön" ; --UNCHK
lin unsinkable_A = mkWA (k34A "uppoamaton") ; --UNCHK
lin unsized_A = mkWA "yhdenkoon" ; --UNCHK
lin unskilled_A = mkWA (k34A "taitamaton") ; --UNCHK
lin unskillfulness_N = mkWN "oppimattomuus" ; --UNCHK
lin unsleeping_A = mkWA (k41A "valpas") ; --UNCHK
lin unsmiling_A = mkWA "hymytön" ; --UNCHK
lin unsnarling_N = mkWN (compoundN "vapa" (k38 "uttaminen")) ; --UNCHK
lin unsociability_N = mkWN (compoundN "epä" (k40 "sosiaalisuus")) ; --UNCHK
lin unsociable_A = mkWA (compoundA "epä" (k38 "sosiaalinen")) ; --UNCHK
lin unsocial_A = mkWA (compoundA "epä" (k38 "sosiaalinen")) ; --UNCHK
lin unsoiled_A = mkWA (k34A "tahraton") ; --UNCHK
lin unsold_A = mkWA "myymätön" ; --UNCHK
lin unsoldierly_A = mkWA (compoundA "epä" (k38 "sotilaallinen")) ; --UNCHK
lin unsolicited_A = mkA "pyytämätön" ; --mkWA (k34A "tarpeeton") ;
lin unsolvability_N = mkWN "ratkeamattomuus" ; --UNCHK
lin unsolved_A = mkWA (k34A "ratkaisematon") ; --UNCHK
lin unsophisticated_A = mkWA (k34A "sivistymätön") ; --UNCHK
lin unsorted_A = mkWA "lajittelematon" ; --UNCHK
lin unsound_A = mkWA (compoundA "epä" (k41 "viisas")) ; --UNCHK
lin unsoundable_A = mkWA (k34A "mittaamaton") ; --UNCHK
lin unsoundness_N = mkWN (k40 "sairaalloisuus") ; --UNCHK
lin unsoured_A = mkWA (k48 "tuore") ; --UNCHK
lin unspaced_A = mkWA "välikkeetön" ; --UNCHK
lin unsparing_A = mkWA (k34A "armoton") ; --UNCHK
lin unspeakable_A = mkWA (k34A "sanomaton") ; --UNCHK
lin unspecialized_A = mkWA "erikoistumaton" ; --UNCHK
lin unspecific_A = mkWA (k38 "yleinen") ; --UNCHK
lin unspecified_A = mkWA (k34A "määrittelemätön") ; --UNCHK
lin unspectacular_A = mkWA (k38 "tavallinen") ; --UNCHK
lin unspent_A = mkWA "käyttämätön" ; --UNCHK
lin unspoiled_A = mkWA (k48 "terve") ; --UNCHK
lin unspoilt_A = mkWA (k48 "tuore") ; --UNCHK
lin unspoken_A = mkWA (k34A "äänetön") ; --UNCHK
lin unsporting_A = mkWA (k10 "ruma") ; --UNCHK
lin unsportsmanlike_A = mkWA (k10 "ruma") ; --UNCHK
lin unspotted_A = mkWA (k34A "tahraton") ; --UNCHK
lin unstable_A = mkWA (k10 "horjuva") ; --UNCHK
lin unstaged_A = mkWA "esittämätön" ; --UNCHK
lin unstained_A = mkWA (k34A "tahraton") ; --UNCHK
lin unstated_A = mkWA (k34A "sanomaton") ; --UNCHK
lin unstatesmanlike_A = mkWA (compoundA "epävaltio" (k38 "miesmäinen")) ; --UNCHK
lin unsteadiness_N = mkWN (k40 "epävakaus") ; --UNCHK
lin unsteady_A = mkWA (compoundA "epä" (k17 "vakaa")) ; --UNCHK
lin unsterilized_A = mkWA "steriloimaton" ; --UNCHK
lin unstilted_A = mkWA "soljuva" ; --UNCHK
lin unstimulating_A = mkWA (k38 "yksitoikkoinen") ; --UNCHK
lin unstintingly_Adv = mkWAdv (k99 "runsaasti") ; --UNCHK
lin unstirred_A = mkWA "sekoittamaton" ; --UNCHK
lin unstoppable_A = mkWA "pysäyttämätön" ; --UNCHK
lin unstoppered_A = mkWA (k38 "avonainen") ; --UNCHK
lin unstrained_A = mkWA (k38 "luonnollinen") ; --UNCHK
lin unstratified_A = mkWA "kerrostumaton" ; --UNCHK
lin unstressed_A = mkWA (k34A "painoton") ; --UNCHK
lin unstructured_A = mkWA (k34A "järjestymätön") ; --UNCHK
lin unstrung_A = mkWA "herpaantunut" ; --UNCHK
lin unstudied_A = mkWA (k34A "pakoton") ; --UNCHK
lin unstudious_A = mkWA (k9 "laiska") ; --UNCHK
lin unsubdued_A = mkWA (k34A "kesyttämätön") ; --UNCHK
lin unsubtle_A = mkWA (k38 "summittainen") ; --UNCHK
lin unsuccessful_A = mkA "epäonnistunut" ;
lin unsugared_A = mkWA (k34A "sokeriton") ; --UNCHK
lin unsuitability_N = mkWN (k40 "kelvottomuus") ; --UNCHK
lin unsuitable_A = mkWA (k34A "sopimaton") ; --UNCHK
lin unsuited_A = mkWA (compoundA "yhteen" (k34A "sopimaton")) ; --UNCHK
lin unsullied_A = mkWA (k41A "puhdas") ; --UNCHK
lin unsung_A = mkWA (compoundA "ali" (k1 "arvostettu")) ; --UNCHK
lin unsupervised_A = mkWA (k38 "itsenäinen") ; --UNCHK
lin unsupportable_A = mkWA (k34A "sietämätön") ; --UNCHK
lin unsupported_A = mkWA "tukematon" ; --UNCHK
lin unsupportive_A = mkWA (k1 "tyly") ; --UNCHK
lin unsuppressed_A = mkWA (k34A "kahlitsematon") ; --UNCHK
lin unsure_A = mkWA (compoundA "epä" (k9 "varma")) ; --UNCHK
lin unsurmountable_A = mkWA (compoundA "yli" (k34A "pääsemätön")) ; --UNCHK
lin unsurpassable_A = mkWA (k34A "ylittämätön") ; --UNCHK
lin unsurpassed_A = mkWA (k34A "ylittämätön") ; --UNCHK
lin unsurprised_A = mkWA (k34A "piittaamaton") ; --UNCHK
lin unsurprising_A = mkWA (k34A "yllätyksetön") ; --UNCHK
lin unsusceptibility_N = mkWN (k40 "kestävyys") ; --UNCHK
lin unsusceptible_A = mkWA (k15 "penseä") ; --UNCHK
lin unsuspected_A = mkWA (k10 "yllättävä") ; --UNCHK
lin unsuspecting_A = mkWA (k34A "tietämätön") ; --UNCHK
lin unsuspicious_A = mkWA (k34A "tietämätön") ; --UNCHK
lin unswayed_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unsweet_A = mkWA (k10 "ikävä") ; --UNCHK
lin unsweetened_A = mkWA "makeuttamaton" ; --UNCHK
lin unswerving_A = mkWA (k38 "uskollinen") ; --UNCHK
lin unsworn_A = mkWA (k34A "vahvistamaton") "valalla" ; --UNCHK
lin unsyllabic_A = mkWA (compoundA "epä" (k38 "syllaabinen")) ; --UNCHK
lin unsyllabled_A = mkWA "tavuttamaton" ; --UNCHK
lin unsymmetric_A = mkWA (compoundA "epä" (k38 "symmetrinen")) ; --UNCHK
lin unsympathetic_A = mkWA (k10 "torjuva") ; --UNCHK
lin unsympathizing_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin unsystematic_A = mkWA (compoundA "epä" (k38 "systemaattinen")) ; --UNCHK
lin untainted_A = mkWA (k41A "puhdas") ; --UNCHK
lin untalented_A = mkWA (k34A "lahjaton") ; --UNCHK
lin untamed_A = mkWA (k34A "kesyttämätön") ; --UNCHK
lin untangled_A = mkWA "sotkeentumaton" ; --UNCHK
lin untanned_A = mkWA "parkitsematon" ; --UNCHK
lin untapped_A = mkWA (k34A "koskematon") ; --UNCHK
lin untarnished_A = mkWA (k41A "puhdas") ; --UNCHK
lin untaxed_A = mkWA (k34A "veroton") ; --UNCHK
lin untempered_A = mkWA "hillitsemätön" ; --UNCHK
lin untenable_A = mkWA (k34A "kestämätön") ; --UNCHK
lin untenanted_A = mkWA (k10 "tyhjä") ; --UNCHK
lin untested_A = mkWA (k34A "kokematon") ; --UNCHK
lin untethered_A = mkWA (k17 "vapaa") ; --UNCHK
lin unthawed_A = mkWA "sulamaton" ; --UNCHK
lin untheatrical_A = mkWA (k34A "sopimaton") "lavalle" ; --UNCHK
lin unthematic_A = mkWA (compoundA "epä" (k38 "temaattinen")) ; --UNCHK
lin unthinkable_A = mkWA (k34A "mahdoton") ; --UNCHK
lin unthinking_A = mkWA (k34A "ajattelematon") ; --UNCHK
lin unthoughtfulness_N = mkWN (k40 "ajattelemattomuus") ; --UNCHK
lin untidiness_N = mkWN (k40 "sotkuisuus") ; --UNCHK
lin untidy_A = mkWA (k38 "sotkuinen") ; --UNCHK
lin untie_V = mkWV (k53A "irrottaa") ; --UNCHK
lin untie_V2 = mkWV2 (k53A "irrottaa") ; --UNCHK
lin untied_A = mkWA (compoundA "reps" (k10 "ottava")) ; --UNCHK
lin until_Prep = postPrep elative "asti" | postPrep illative "saakka" ;
lin until_Subj = lin Subj (ss "kunnes") ;
lin untilled_A = mkWA "muokkaamaton" ; --UNCHK
lin untimbered_A = mkWA (compoundA "kaari" (k34A "puuton")) ; --UNCHK
lin untimely_A = mkWA (compoundA "ennen" (k38 "aikainen")) ; --UNCHK
lin untipped_A = mkWA "filtteritön" ; --UNCHK
lin untired_A = mkWA (k34A "väsymätön") ; --UNCHK
lin untiring_A = mkWA (k34A "uupumaton") ; --UNCHK
lin untitled_A = mkWA (k38 "alhainen") ; --UNCHK
lin unto_Prep = mkPrep allative | luokse_Prep | mkPrep translative | luokse_Prep ** {s = luokse_Prep.s ** {p2 = "luo"}} | mkPrep "tykö" ; ---- put translative here to recognize it
lin untoasted_A = mkWA "paahtamaton" ; --UNCHK
lin untold_A = mkWA (compoundA "sanoin" (k34A "kuvaamaton")) ; --UNCHK
lin untouchable_A = mkWA (k99 "saatavilla") "ei" ; --UNCHK
lin untouchable_N = mkWN (k34A "koskematon") ; --UNCHK
lin untouched_A = mkWA (compoundA "välin" (k34A "pitämätön")) ; --UNCHK
lin untoward_A = mkWA (k38 "kiusallinen") ; --UNCHK
lin untraceable_A = mkWA "jäljittämätön" ; --UNCHK
lin untrained_A = mkWA (k34A "kouluttamaton") ; --UNCHK
lin untrammeled_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin untrammelled_A = mkWA (k34A "rajoittamaton") ; --UNCHK
lin untraveled_A = mkWA "käyttämätön" ; --UNCHK
lin untraversable_A = mkWA (compoundA "läpikulku" (k34A "kelvoton")) ; --UNCHK
lin untraversed_A = mkWA (k34A "koskematon") ; --UNCHK
lin untreated_A = mkWA (k34A "käsittelemätön") ; --UNCHK
lin untried_A = mkWA (k34A "kokematon") ; --UNCHK
lin untrimmed_A = mkWA "hoitamaton" ; --UNCHK
lin untroubled_A = mkWA (k34A "huoleton") ; --UNCHK
lin untrue_A = mkWA (k34A "uskoton") ; --UNCHK
lin untrustworthiness_N = mkWN (compoundN "epä" (k40 "luotettavuus")) ; --UNCHK
lin untrustworthy_A = mkWA (compoundA "epä" (k10 "luotettava")) ; --UNCHK
lin untruth_N = mkWN (k48 "vale") ; --UNCHK
lin untruthful_A = mkWA (k10 "väärä") ; --UNCHK
lin untruthfulness_N = mkWN (k40 "valheellisuus") ; --UNCHK
lin untucked_A = mkWA "laskostamaton" ; --UNCHK
lin untufted_A = mkWA "tupsuton" ; --UNCHK
lin unturned_A = mkWA "kääntämätön" ; --UNCHK
lin untutored_A = mkWA (k34A "oppimaton") ; --UNCHK
lin untwisted_A = mkWA (k10 "suora") ; --UNCHK
lin untying_N = mkWN "avaaminen" ; --UNCHK
lin untypical_A = mkWA (k10 "poikkeava") ; --UNCHK
lin ununbium_N = mkWN "alkuainenumero" "112" ; --UNCHK
lin ununderstood_A = mkWA (k34A "käsittämätön") ; --UNCHK
lin ununhexium_N = mkWN "alkuainenumero" "116" ; --UNCHK
lin ununpentium_N = mkWN "alkuainenumero" "115" ; --UNCHK
lin ununquadium_N = mkWN "järjestysluku" "114" ; --UNCHK
lin ununtrium_N = mkWN "alkuainenumero" "113" ; --UNCHK
lin unused_A = mkA "käyttämätön" ; --mkWA (k34A "tottumaton") ;
lin unusual_A = mkA "epätavallinen" ;
lin unusualness_N = mkWN (compoundN "epä" (k40 "tavallisuus")) ; --UNCHK
lin unutterable_A = mkWA (k15 "vaikea") ; --UNCHK
lin unvaccinated_A = mkWA "rokottamaton" ; --UNCHK
lin unvaried_A = mkWA (k34A "muuttumaton") ; --UNCHK
lin unvariedness_N = mkWN (k40 "muuttumattomuus") ; --UNCHK
lin unvarnished_A = mkWA (k34A "kaunistelematon") ; --UNCHK
lin unvarying_A = mkWA (k38 "samanlainen") ; --UNCHK
lin unveil_V = mkWV (k53 "paljastaa") "kasvot" ; --UNCHK
lin unveil_V2 = mkV2 "paljastaa" ;
lin unveiling_N = mkWN (k38 "ensiesiintyminen") ; --UNCHK
lin unvented_A = mkWA (k38 "umpinainen") ; --UNCHK
lin unventilated_A = mkWA "ummehtunut" ; --UNCHK
lin unversed_A = mkWA (k34A "tottumaton") ; --UNCHK
lin unvigilant_A = mkWA (k34A "varomaton") ; --UNCHK
lin unvindictive_A = mkWA "kostonhimoton" ; --UNCHK
lin unvitrified_A = mkWA "lasittamaton" ; --UNCHK
lin unvoiced_A = mkWA (k34A "soinniton") ; --UNCHK
lin unvulcanized_A = mkWA "vulkanisoimaton" ; --UNCHK
lin unwanted_A = mkWA (compoundA "ei-" (k1A "toivottu")) ;
lin unwariness_N = mkWN (k40 "varomattomuus") ; --UNCHK
lin unwarrantably_Adv = mkWAdv (k99 "kohtuuttomasti") ; --UNCHK
lin unwarranted_A = mkWA (k34A "kohtuuton") ;
lin unwary_A = mkWA (k34A "varomaton") ;
lin unwashed_A = mkWA "pesemätön" ; --UNCHK
lin unwavering_A = mkWA (k34A "horjumaton") ; --UNCHK
lin unwaxed_A = mkWA "vahaamaton" ; --UNCHK
lin unweaned_A = mkWA "vieroittamaton" ; --UNCHK
lin unwearable_A = mkWA (compoundA "käyttö" (k34A "kelvoton")) ; --UNCHK
lin unwearied_A = mkWA (k34A "väsymätön") ; --UNCHK
lin unweathered_A = mkWA (compoundA "sään" (k10 "kestävä")) ; --UNCHK
lin unwebbed_A = mkWA (k38 "sormellinen") ; --UNCHK
lin unwed_A = mkWA (k34A "naimaton") ; --UNCHK
lin unwelcome_A = mkA (mkN "epä" (mkN "mieluisa")) ;
lin unwell_A = mkWA (k99 "kunnossa") "surkeassa" ; --UNCHK
lin unwholesome_A = mkWA (compoundA "epä" (k38 "terveellinen")) ; --UNCHK
lin unwholesomeness_N = mkWN (compoundN "epä" (k40 "terveellisyys")) ; --UNCHK
lin unwieldiness_N = mkWN (k40 "vaivalloisuus") ; --UNCHK
lin unwieldy_A = mkWA (k10 "painava") ; --UNCHK
lin unwilled_A = mkWA (k34A "tahaton") ; --UNCHK
lin unwilling_A = mkWA (k38 "vastahakoinen") ; --UNCHK
lin unwillingness_N = mkWN (k40 "vastahakoisuus") ;
lin unwind_V = mkWV (k71 "tehdä") "rentoutuneeksi" ; --UNCHK
lin unwind_V2 = mkWV2 (k71 "tehdä") "rentoutuneeksi" ; --UNCHK
lin unwise_A = mkWA (compoundA "epä" (k41 "viisas")) ;
lin unwitting_A = mkWA (k34A "tahaton") ; --UNCHK
lin unwomanly_A = mkWA (compoundA "epä" (k38 "naisellinen")) ; --UNCHK
lin unwonted_A = mkWA (compoundA "epä" (k38 "tavallinen")) ; --UNCHK
lin unwooded_A = mkWA (k34A "puuton") ; --UNCHK
lin unworkable_A = mkA "toimimaton" ;
lin unworkmanlike_A = mkWA (compoundA "epä" (k38 "ammattimainen")) ; --UNCHK
lin unworried_A = mkWA (k34A "suruton") ; --UNCHK
lin unworthiness_N = mkWN (k40 "kelvottomuus") ; --UNCHK
lin unworthy_A = mkWA (k34A "arvoton") ; --UNCHK
lin unwounded_A = mkWA "purkautumaton" ; --UNCHK
lin unwoven_A = mkWA (compoundA "ei-" (k1 "kudottu")) ; --UNCHK
lin unwrap_V = mkWV (k52A "kertoa") ; --UNCHK
lin unwrap_V2 = mkWV2 (k52A "kertoa") ; --UNCHK
lin unwrinkled_A = mkWA "rypytön" ; --UNCHK
lin unwritten_A = mkWA (k34A "kirjoittamaton") ; --UNCHK
lin unyielding_A = mkWA (k10A "jäykkä") ; --UNCHK
lin unzip_V2 = mkWV2 (k73 "avata") "vetoketju" ; --UNCHK
lin up_A = mkWA (k99 "ylhäällä") ; --UNCHK
lin up_Adv = mkAdv "ylös" | mkAdv "ylhäällä" ;
lin up_Prep = mkPrep "ylös" partitive ;
lin up_V = mkWV (k53 "nostaa") ; --UNCHK
lin up_V2 = mkWV2 (k53 "nostaa") ; --UNCHK
lin up_and_coming_A = mkA "lupaava" ;
lin up_to_Prep = mkPrep elative "kiinni" ;
lin up_to_date_A = variants {} ; --
lin up_beat_N = mkWN (compoundN "koho" (k5A "tahti")) ; --UNCHK
lin upbound_A = mkWA "ylävirtaan" ; --UNCHK
lin upbraid_V2 = mkWV2 (k67A "nuhdella") ; --UNCHK
lin upbraider_N = mkWN (k12 "moittija") ; --UNCHK
lin upbraiding_N = mkWN (k39 "läksytys") ; --UNCHK
lin upbringing_N = mkWN (k39 "kasvatus") ; --UNCHK
lin upcast_N = mkWN (compoundN "tuuletus" (k1 "kuilu")) ; --UNCHK
lin upcoming_A = mkA "tuleva" ;
lin upcountry_A = mkWA "sisämaa-" ; --UNCHK
lin upcurved_A = mkWA "ylöspäin" "kaartuva" ; --UNCHK
lin update_N = mkWN (k39 "päivitys") ; --UNCHK
lin update_V2 = mkWV2 (k53 "ajantasaistaa") ; --UNCHK
lin updating_N = mkWN "päivittäminen" ; --UNCHK
lin upfield_A = mkWA "yläkenttä-" ; --UNCHK
lin upfront_A = mkWA (k33 "avoin") ; --UNCHK
lin upgrade_N = mkWN (k39 "parannus") ; --UNCHK
lin upgrade_V2 = mkWV2 (k53A "päivittää") ; --UNCHK
lin upheaval_N = mkWN (k6 "meteli") ; --UNCHK
lin uphill_A = mkWA "ylöspäin" "viettävä" ; --UNCHK
lin uphill_Adv = mkWAdv "ylämäkeen" ; --UNCHK
lin uphill_N = mkWN (compoundN "ylä" (k7A "mäki")) ; --UNCHK
lin uphold_V2 = mkWV2 (compoundV "yllä" (k53A "pitää")) ; --UNCHK
lin upholder_N = mkWN (compoundN "yllä" (k10 "pitäjä")) ; --UNCHK
lin upholster_V2 = mkWV2 (k67 "verhoilla") ; --UNCHK
lin upholsterer_N = mkWN (k12 "verhoilija") ; --UNCHK
lin upholstery_N = mkWN (compoundN "verhoilu" (k9 "ala")) ; --UNCHK
lin upkeep_N = mkWN (k1A "huolto") ; --UNCHK
lin upland_A = mkWA (compoundA "ylänk" (k38 "öinen")) ; --UNCHK
lin upland_N = mkWN (k1A "ylänkö") ; --UNCHK
lin uplift_V2 = mkWV2 (k53A "päihdyttää") ; --UNCHK
lin uplifting_N = mkWN (compoundN "koho" (k38 "aminen")) ; --UNCHK
lin uplink_N = mkWN "maasatelliittiyhteys" ; --UNCHK
lin up_market_A = mkWA (compoundA "tarkoite" (k1 "ttu")) "varakkaalle" "väestölle" ; --UNCHK
lin upmost_A = mkWA (k36 "ylin") ; --UNCHK
lin upon_Prep = mkPrep "päällä" ;
lin upper_A = mkWA (k16A "ylempi") ; --UNCHK
lin upper_N = mkWN (k5A "vauhti") ; --UNCHK
lin uppercase_A = mkWA (kH1 "iso") ; --UNCHK
lin uppercut_N = mkWN (k1A "koukku") ; --UNCHK
lin uppermost_A = mkWA (k36 "ylin") ; --UNCHK
lin uppermost_Adv = mkWAdv (k99 "ylimpänä") ; --UNCHK
lin uppishness_N = mkWN (k40 "koppavuus") ; --UNCHK
lin uppity_A = mkWA (compoundA "yli" (k38 "mielinen")) ; --UNCHK
lin uppityness_N = mkWN (k40 "koppavuus") ; --UNCHK
lin upraised_A = mkWA (compoundA "noste" (k1 "ttu")) ; --UNCHK
lin upright_A = mkWA (k10 "oleva") "pystyasennossa" ; --UNCHK
lin upright_N = mkWN (compoundN "pysty" (k1 "piano")) ; --UNCHK
lin uprightness_N = mkWN (k40 "vilpittömyys") ; --UNCHK
lin uprising_N = mkN (lin NK {s = d12 "kapina"}) ;
lin upriver_Adv = mkWAdv "ylävirtaan" ; --UNCHK
lin uproar_N = mkWN (k12 "mekkala") ; --UNCHK
lin uproarious_A = mkWA (k41A "riemukas") ; --UNCHK
lin uproot_V2 = mkWV2 (k58 "kitkeä") ; --UNCHK
lin upset_A = mkA "järkyttynyt" ;
lin upset_N = mkWN (k39 "kumous") ; --UNCHK
lin upset_V = mkV "järkkyä" ; --mkWV (k53A "sekoittaa") ;
lin upset_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin upsetter_N = mkWN (compoundN "yllätys" (k10 "voittaja")) ; --UNCHK
lin upshot_N = mkWN (k39 "tulos") ; --UNCHK
lin upside_N = mkN "yläpuoli" ;
lin upside_down_Adv = mkWAdv (k99 "ylösalaisin") ; --UNCHK
lin upsilon_N = mkWN "ypsilon" ; --UNCHK
lin upstage_A = mkWA "takanäyttämön" ; --UNCHK
lin upstage_Adv = mkWAdv (k99 "päin") "takanäyttämölle" ; --UNCHK
lin upstage_N = mkWN (compoundN "taka" (k2 "näyttämö")) ; --UNCHK
lin upstage_V2 = mkWV2 (k53A "jättää") "varjoonsa" ; --UNCHK
lin upstager_N = mkWN (k12 "näyttelijä") "itsekäs" ; --UNCHK
lin upstairs_A = mkA "yläkerroksinen" ; ---?? different POS
lin upstairs_Adv = mkWAdv "ylemmässä" "kerroksessa" ; --UNCHK
lin upstairs_N = mkWN (compoundN "ylä" (k9A "kerta")) ; --UNCHK
lin upstanding_A = mkWA (k10 "luotettava") ; --UNCHK
lin upstart_A = mkWA (k38 "nousukasmainen") ; --UNCHK
lin upstart_N = mkN "nousukas" ; --WN (k5A "kippi") ;
lin upstate_Adv = mkWAdv "osavaltion" "pohjoisosassa" ; --UNCHK
lin upstream_A = mkWA "ylävirtaan" ; --UNCHK
lin upstream_Adv = mkWAdv "ylävirtaan" ; --UNCHK
lin upstroke_N = mkWN (compoundN "nousu" (k1 "isku")) ; --UNCHK
lin upsurge_N = mkWN (k1 "kasvu") "äkillinen" ; --UNCHK
lin uptake_N = mkWN (k1A "otto") ; --UNCHK
lin uptick_N = mkWN (compoundN "uptick-" (k10 "tapahtuma")) ; --UNCHK
lin uptight_A = mkWA (k15 "kireä") ; --UNCHK
lin uptime_N = mkWN (compoundN "toiminta" (k9A "kelpoisuusaika")) ; --UNCHK
lin upton_PN = foreignPN "Upton" ;
lin uptown_A = mkWA "esikaupunki-" ; --UNCHK
lin uptown_Adv = mkWAdv "esikaupungissa" ; --UNCHK
lin uptown_N = mkWN (compoundN "esi" (k5A "kaupunki")) ; --UNCHK
lin upturn_N = mkWN (k1 "nousu") ; --UNCHK
lin upturned_A = mkWA (k1 "pysty") ; --UNCHK
lin upward_A = mkA "ylöspäinpyrkivä" ;
lin upward_Adv = mkWAdv (compoundAdv "ylös" (k99 "päin")) ; --UNCHK
lin upwards_Adv = mkWAdv (compoundAdv "ylös" (k99 "päin")) ; --UNCHK
lin upwind_A = mkWA "vastatuuleen" ; --UNCHK
lin upwind_Adv = mkWAdv "vastatuuleen" ; --UNCHK
lin uracil_N = mkWN (k5 "urasiili") ; --UNCHK
lin uraninite_N = mkWN (compoundN "piki" (k48A "välke")) ; --UNCHK
lin uranium_N = mkWN (k6 "uraani") ; --UNCHK
lin uranoplasty_N = mkWN (compoundN "korjaus" (k39 "leikkaus")) "suulaen" ; --UNCHK
lin urate_N = mkWN (k9 "suola") "virtsahapon" ; --UNCHK
lin uratemia_N = mkWN (compoundN "virtsa" (k39 "myrkytys")) ; --UNCHK
lin uraturia_N = mkWN "uraturia" ; --UNCHK
lin urban_A = mkWA (k6 "urbaani") ; --UNCHK
lin urbane_A = mkWA (k47 "sivistynyt") ; --UNCHK
lin urbanity_N = mkWN (compoundN "kaupunkilais" (k10 "elämä")) ; --UNCHK
lin urbanization_N = mkWN "kaupungistaminen" ; --UNCHK
lin urbanize_V2 = mkWV2 (k53 "kaupunkimaistaa") ; --UNCHK
lin urceolate_A = mkWA (compoundA "uurnan" (k38 "muotoinen")) ; --UNCHK
lin urceole_N = mkWN (k1A "ruukku") ; --UNCHK
lin urchin_N = mkWN (k3 "heittiö") ; --UNCHK
lin urea_N = mkWN (k12 "urea") ; --UNCHK
lin urease_N = mkWN (compoundN "ure" (k5 "aasi")) ; --UNCHK
lin uremia_N = mkWN (compoundN "virtsa" (k39 "myrkytys")) ; --UNCHK
lin ureter_N = mkWN (compoundN "virtsan" (k33A "johdin")) ; --UNCHK
lin ureteritis_N = mkWN (k39 "tulehdus") "virtsanjohtimen" ; --UNCHK
lin ureterocele_N = mkWN (compoundN "virtsanjohdin" (k10 "laajentuma")) ; --UNCHK
lin ureterostenosis_N = mkWN (k10 "ahtauma") "virtsanjohtimen" ; --UNCHK
lin urethane_N = mkWN (compoundN "etyyli" (k6 "esteri")) "karbamiinihapon" ; --UNCHK
lin urethra_N = mkWN (compoundN "virtsa" (k7 "putki")) ; --UNCHK
lin urethral_A = mkWA "virtsaputken-" ; --UNCHK
lin urethritis_N = mkWN (compoundN "virtsatie" (k3 "infektio")) ; --UNCHK
lin urethrocele_N = mkWN (k10 "ahtauma") "virtsaputken" ; --UNCHK
lin urge_N = mkWN (k5A "vietti") ; --UNCHK
lin urge_V2 = mkWV2 (k53 "ahdistaa") ; --f88
lin urge_V2V = mkWV2V (k53 "ahdistaa") ; --UNCHK
lin urge_VS = mkWVS (k53 "ahdistaa") ; --UNCHK
lin urge_on_V2 = mkWV2 (k53 "ahdistaa") ; --UNCHK
lin urge_upon_V2 = prepV2 (lin V OP_urge_V2) OP_upon_Prep ; -- guess-p-verb
lin urgency_N = mkWN (k40 "kiireellisyys") ;
lin urgent_A = mkWA (k10 "pakottava") ; --UNCHK
lin urging_N = mkWN (compoundN "kannu" (k38 "staminen")) ; --UNCHK
lin uric_A = mkWA "virtsa-" ; --UNCHK
lin uricaciduria_N = mkWN "hyperurikuria" ; --UNCHK
lin uricosuric_A = mkWA "urikosuurinen" ; --UNCHK
lin urinal_N = mkWN (k5 "pisoaari") ; --UNCHK
lin urinalysis_N = mkWN (compoundN "virtsa" (k39 "tutkimus")) ; --UNCHK
lin urinary_A = mkWA "virtsa-" ; --UNCHK
lin urinate_V = mkWV (k53A "heittää") "vettä" ; --UNCHK
lin urine_N = mkWN (k5 "pissi") ; --UNCHK
lin urjala_PN = mkPN "Urjala" ;
lin urn_N = mkWN (k10 "uurna") ; --UNCHK
lin urobilin_N = mkWN "urobiliini" ; --UNCHK
lin urobilinogen_N = mkWN (compoundN "sterkobilino" (k5 "geeni")) ; --UNCHK
lin urocele_N = mkWN "virtsan" "ekstravasaatio" ; --UNCHK
lin urochesia_N = mkWN (k39 "ulostus") ; --UNCHK
lin urochord_N = mkWN (compoundN "selkä" (k48A "jänne")) ; --UNCHK
lin urodele_N = mkWN (k38 "hännällinen") ; --UNCHK
lin urodynia_N = mkWN "kipu" "virtsatessa" ; --UNCHK
lin urogenital_A = mkWA (compoundA "uro" (k38 "genitaalinen")) ; --UNCHK
lin urolith_N = mkWN (compoundN "virtsa" (k7 "kivi")) ; --UNCHK
lin urologist_N = mkWN (k5 "urologi") ; --UNCHK
lin urology_N = mkWN (k12 "urologia") ; --UNCHK
lin uropathy_N = mkWN "uropatia" ; --UNCHK
lin uropygium_N = mkWN (k1 "pyrstö") ; --UNCHK
lin ursine_A = mkWA (k38 "karhumainen") ; --UNCHK
lin ursinia_N = mkWN (compoundN "neidon" (k10 "silmä")) ; --UNCHK
lin urtication_N = mkWN (compoundN "nokkos" (k39 "piiskaus")) ; --UNCHK
lin uruguay_PN = foreignPN "Uruguay" ;
lin uruguayan_A = mkWA (compoundA "uruguay" (k38 "lainen")) ; --UNCHK
lin uruguayan_N = mkWN (compoundN "uruguay" (k38 "lainen")) ; --UNCHK
lin us_PN = mkPN "USA" ;
lin usa_PN = mkPN "USA" ;
lin usable_A = mkWA (k17 "vapaa") ; --UNCHK
lin usage_N = mkN "käyttö" ; --mkWN (k1A "käytäntö") ;
lin usance_N = mkWN (k1A "käytäntö") ; --UNCHK
lin use_N = mkN "käyttö" ;
lin use_V = mkV "käyttää" ;
lin use_V2 = mkV2 "käyttää" partitive ;
lin use_VV = mkVV "tavata" ;
lin use_up_V = mkWV (k53A "kuluttaa") "loppuun" ; --UNCHK
lin use_up_V2 = mkWV2 (k53A "kuluttaa") "loppuun" ; --UNCHK
lin useable_A = mkWA (k17 "vapaa") ; --UNCHK
lin used_A = mkA "käytetty" ;
lin used_VV = mkVV (mkV "tavata") ; ----
lin useful_A = mkWA (k38 "hyödyllinen") ;
lin usefulness_N = mkWN (k40 "tarpeellisuus") ; --UNCHK
lin useless_A = mkWA (k10 "turha") ; --UNCHK
lin uselessness_N = mkWN (k40 "tarpeettomuus") ; --UNCHK
lin userFem_N = mkWN (k3 "manipulaatio") ; --UNCHK
lin userMasc_N = mkN "käyttäjä" ;
lin usher_N = mkWN (k41A "opas") ; --UNCHK
lin usher_V2 = mkV2 "opastaa" partitive ;
lin usher_in_V2 = mkWV2 (k56A "alkaa") ; --UNCHK
lin usherette_N = mkWN (k10 "paikannäyttäjä") "naispuolinen" ; --UNCHK
lin usn_N = mkWN (k2 "laivasto") ; --UNCHK
lin ussr_N = mkN "Neuvostoliitto" ; ---- cat N ??
lin usual_A = mkWA (k38 "tavallinen") ;
lin usualness_N = mkWN (k40 "tavallisuus") ; --UNCHK
lin usufruct_N = mkWN (compoundN "nautinta" (k40 "oikeus")) ; --UNCHK
lin usufructuary_A = mkWA (compoundA "käyttö" (k38 "oikeudellinen")) ; --UNCHK
lin usufructuary_N = mkWN (k12 "haltija") "käyttöoikeuden" ; --UNCHK
lin usurer_N = mkWN (compoundN "koron" (k10 "kiskoja")) ; --UNCHK
lin usurious_A = mkWA (k10 "järkyttävä") ; --UNCHK
lin usurp_V2 = mkWV2 (k53A "valloittaa") ; --UNCHK
lin usurpation_N = mkWN (k1 "riisto") ; --UNCHK
lin usurper_N = mkWN (k6 "kaappari") ; --UNCHK
lin usury_N = mkWN (compoundN "koron" (k9A "kiskonta")) ; --UNCHK
lin utahraptor_N = mkWN (k39 "dinosaurus") ; --UNCHK
lin utajärvi_PN = mkPN (mkN "Utajärvi" "Utajärviä") ;
lin utensil_N = mkWN (k48 "väline") ; --UNCHK
lin uterine_A = mkWA "kohtu-" ; --UNCHK
lin uterus_N = mkWN (k1A "kohtu") ; --UNCHK
lin utilitarian_A = mkWA (k38 "hyödyllinen") ; --UNCHK
lin utilitarian_N = mkWN (k5 "utilitaristi") ; --UNCHK
lin utilitarianism_N = mkWN (k5 "utilitarismi") ; --UNCHK
lin utility_N = mkWN (k48A "hyödyke") ;
lin utilizable_A = mkWA (k10 "oleva") "hyödynnettävissä" ; --UNCHK
lin utilization_N = mkWN (k1A "käyttö") ; --UNCHK
lin utilize_V2 = mkWV2 (k54A "hyödyntää") ; --UNCHK
lin utilizer_N = mkWN (k10 "käyttäjä") ; --UNCHK
lin utmost_A = mkWA (k36 "uloin") ; --UNCHK
lin utmost_N = mkWN (k1 "taso") "paras" ; --UNCHK
lin utopia_N = mkWN "Siion" ; --UNCHK
lin utopian_A = mkWA "maailmaa" "parantava" ; --UNCHK
lin utrecht_PN = foreignPN "Utrecht" ;
lin utricle_N = mkWN (k12 "rakkula") "soikea" ; --UNCHK
lin utsjoki_PN = mkPN (mkN "Utsjoki" "Utsjokia") ;
lin utter_A = mkWA (k10 "syvä") ; --UNCHK
lin utter_V2 = mkWV2 (k52 "sanoa") "ääneen" ; --UNCHK
lin utterance_N = mkWN (k2 "ääntely") ; --UNCHK
lin utterer_N = mkWN (k10 "lausuja") ; --UNCHK
lin uttermost_A = mkWA (k36 "uloin") ; --UNCHK
lin uttermost_N = mkWN (k1 "taso") "paras" ; --UNCHK
lin uttoxeter_PN = foreignPN "Uttoxeter" ;
lin uurainen_PN = mkPN "Uurainen" ;
lin uusikaupunki_PN = mkPN "Uusikaupunki" ;
lin uvea_N = mkWN (k2 "suonikalvosto") ; --UNCHK
lin uveal_A = mkWA "suonikalvostoon" "liittyvä" ; --UNCHK
lin uveitis_N = mkWN (k39 "tulehdus") "silmän" "keskikalvon" ; --UNCHK
lin uvula_N = mkWN (compoundN "kita" (k48A "kieleke")) ; --UNCHK
lin uvular_A = mkWA "kitakielekkeeseen" "liittyvä" ; --UNCHK
lin uvulitis_N = mkWN (k39 "tulehdus") "kitakielekkeen" ; --UNCHK
lin uxor_N = mkWN (k1 "vaimo") ; --UNCHK
lin uxoricide_N = mkWN (compoundN "vaimon" (k10 "murha")) ; --UNCHK
lin uxorious_A = mkWA (k10 "alistuva") "vaimolle" ; --UNCHK
lin v_and_a_N = mkN "Victoria & Albert" (mkN "-museo") ;
lin vaala_PN = mkPN "Vaala" ;
lin vaasa_PN = mkPN "Vaasa" ;
lin vac_N = mkWN (k10 "loma") ; --UNCHK
lin vacancy_N = mkWN (k3 "tyhjiö") ; --UNCHK
lin vacant_A = mkWA (k17 "vapaa") ;
lin vacate_V2 = mkV2 "tyhjentää" ; --WV2 (k74 "kumota") ;
lin vacation_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin vacation_V = mkWV (k53A "viettää") "lomaa" ; --UNCHK
lin vacationer_N = mkWN (k12 "lomailija") ; --UNCHK
lin vacationing_N = mkWN (k2 "lomailu") ; --UNCHK
lin vacationist_N = mkWN (k12 "lomailija") ; --UNCHK
lin vaccinate_V2 = mkWV2 (k71 "tehdä") "immuuniksi" ; --UNCHK
lin vaccination_N = mkWN (k48A "rokote") ; --UNCHK
lin vaccine_N = mkWN (k48A "rokote") ; --UNCHK
lin vaccinee_N = mkWN (compoundN "rokote" (k1 "ttu")) ; --UNCHK
lin vaccinia_N = mkWN (compoundN "lehmä" (k1A "rokko")) ; --UNCHK
lin vacillant_A = mkWA (k38 "häilyväinen") ; --UNCHK
lin vacillate_V = mkWV (k52 "huojua") ; --UNCHK
lin vacillation_N = mkWN (k39 "heilahdus") ; --UNCHK
lin vacuity_N = mkWN (k40 "tarkoituksettomuus") ; --UNCHK
lin vacuolate_A = mkWA "onteloista" "muodostunut" ; --UNCHK
lin vacuole_N = mkWN (compoundN "solu" (k12 "rakkula")) ; --UNCHK
lin vacuolization_N = mkWN "vakuolaatio" ; --UNCHK
lin vacuous_A = mkWA (k34A "ilmeetön") ; --UNCHK
lin vacuousness_N = mkWN (k40 "tyhjyys") ; --UNCHK
lin vacuum_N = mkWN (k6 "imuri") ; --UNCHK
lin vacuum_V2 = mkWV2 (k62 "imuroida") ; --UNCHK
lin vade_mecum_N = mkWN (k5 "manuaali") ; --UNCHK
lin vagabond_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin vagabond_N = mkWN (k6 "kulkuri") ; --UNCHK
lin vagal_A = mkWA "pneumogastrinen" ; --UNCHK
lin vagary_N = mkWN (k1A "oikku") ; --UNCHK
lin vagile_A = mkWA (k17 "vapaa") ; --UNCHK
lin vagina_N = mkWN (k13 "vagina") ; --UNCHK
lin vaginal_A = mkWA "emätin-" ; --UNCHK
lin vaginismus_N = mkWN (k5 "vaginismi") ; --UNCHK
lin vaginitis_N = mkWN (compoundN "emätin" (k39 "tulehdus")) ; --UNCHK
lin vagrancy_N = mkWN (k40 "kiertolaisuus") ; --UNCHK
lin vagrant_A = mkWA (k10 "kiertelevä") ; --UNCHK
lin vagrant_N = mkWN (k38 "irtolainen") ; --UNCHK
lin vague_A = mkWA (k34A "määrittelemätön") ; --UNCHK
lin vagueness_N = mkWN (compoundN "epä" (k40 "määräisyys")) ; --UNCHK
lin vagus_N = mkWN (k1 "hermo") "pneumogastrinen" ; --UNCHK
lin vahto_PN = mkPN "Vahto" ;
lin vain_A = mkWA (k10 "tyhjä") ; --UNCHK
lin vainglorious_A = mkWA (k38 "omahyväinen") ; --UNCHK
lin vainglory_N = mkWN (k40 "omahyväisyys") ; --UNCHK
lin valance_N = mkWN (kH1 "kappa") ; --UNCHK
lin valdecoxib_N = mkWN "Bextra" ; --UNCHK
lin vale_N = mkWN (k1 "laakso") ; --UNCHK
lin valedictorian_N = mkWN (k39 "priimus") ; --UNCHK
lin valedictory_A = mkWA "jäähyväis-" ; --UNCHK
lin valence_N = mkWN (k5 "valenssi") ; --UNCHK
lin valencia_PN = foreignPN "Valencia" ;
lin valenciennes_PN = foreignPN "Valenciennes" ;
lin valency_N = mkWN (k5 "valenssi") ; --UNCHK
lin valent_A = mkWA "valenssi-" ; --UNCHK
lin valentine_N = mkWN (compoundN "ystävänpäivä" (k5A "kortti")) ; --UNCHK
lin valerian_N = mkWN (k26 "virmajuuri") ; --UNCHK
lin valet_N = mkWN (k12 "palvelija") ; --UNCHK
lin valet_V2 = mkWV2 (k67 "palvella") partitive ;
lin valetudinarian_A = mkWA (k38 "sairaalloinen") ; --UNCHK
lin valetudinarian_N = mkWN (k2 "henkilö") "sairaalloinen" ; --UNCHK
lin valiant_A = mkWA (k15 "rohkea") ; --UNCHK
lin valid_A = mkWA (k5 "validi") ; --UNCHK
lin validate_V2 = mkWV2 (k56A "saattaa") "voimaan" ; --UNCHK
lin validation_N = mkWN (k39 "todistus") ; --UNCHK
lin validity_N = mkWN (k40 "oikeellisuus") ; --UNCHK
lin valine_N = mkWN "valiini" ; --UNCHK
lin valise_N = mkWN (compoundN "matka" (k1A "laukku")) "pieni" ; --UNCHK
lin valkeakoski_PN = mkPN (mkN "Valkeakoski" "Valkeakoskia") ;
lin valladolid_PN = foreignPN "Valladolid" ;
lin valley_N = mkWN (k1 "laakso") ; --UNCHK
lin valorous_A = mkWA (k15 "rohkea") ; --UNCHK
lin valour_N = mkWN (k40 "urheus") ; --UNCHK
lin valsartan_N = mkWN "Diovan" ; --UNCHK
lin valtimo_PN = mkPN "Valtimo" ;
lin valuable_A = mkWA (k41A "arvokas") ;
lin valuable_N = mkWN (compoundN "arvo" (k48 "esine")) ; --UNCHK
lin valuation_N = mkWN (k39 "luokitus") ; --UNCHK
lin value_N = mkN "arvo" ;
lin value_V = mkWV (k62 "arvioida") ; --UNCHK
lin value_V2 = mkV2 "arvostaa" ; --f104
lin value_added_A = mkA (mkN "arvon" (mkN "lisätty")) ; ---?? different POS
lin valueless_A = mkWA (k34A "arvoton") ; --UNCHK
lin valuelessness_N = mkWN (k40 "arvottomuus") ; --UNCHK
lin valuer_N = mkWN (k12 "arvioitsija") ; --UNCHK
lin valve_N = mkN "venttiili" ;
lin valved_A = mkWA (k38 "läpällinen") ; --UNCHK
lin valvotomy_N = mkWN (compoundN "laajennus" (k39 "leikkaus")) "läppäaukon" ; --UNCHK
lin valvular_A = mkWA (k38 "läpällinen") ; --UNCHK
lin valvule_N = mkWN (kH1 "läppä") "pieni" ; --UNCHK
lin valvulitis_N = mkWN "valvulitis" ; --UNCHK
lin vambrace_N = mkWN (compoundN "käsivarsi" (k13 "haarniska")) ; --UNCHK
lin vammala_PN = mkPN "Vammala" ;
lin vamoose_V = mkWV (k52A "häipyä") ; --UNCHK
lin vamp_N = mkWN (compoundN "päällis" (k9 "nahka")) "kengän" ; --UNCHK
lin vamp_V = mkWV (k73 "korjata") ; --UNCHK
lin vamp_V2 = mkWV2 (k73 "korjata") ; --UNCHK
lin vamp_up_V2 = mkWV2 (k73A "paikata") ; --UNCHK
lin vampire_N = mkWN (k12 "verenimijä") ; --UNCHK
lin vampirism_N = mkWN (compoundN "vampir" (k5 "ismi")) ; --UNCHK
lin vampula_PN = mkPN "Vampula" ;
lin van_N = mkWN (compoundN "paketti" (k1 "auto")) ; --UNCHK
lin vanadate_N = mkWN "vanadaatti" ; --UNCHK
lin vanadinite_N = mkWN (compoundN "vanadi" (k5A "niitti")) ; --UNCHK
lin vanadium_N = mkWN (k5 "vanadiini") ; --UNCHK
lin vancomycin_N = mkWN "Vancocin" ; --UNCHK
lin vancouver_PN = foreignPN "Vancouver" ;
lin vandal_N = mkWN (k6 "vandaali") ; --UNCHK
lin vandalism_N = mkWN (k5 "huliganismi") ; --UNCHK
lin vane_N = mkWN (k1A "verkko") ; --UNCHK
lin vanguard_N = mkWN (k10 "asema") "johtava" ; --UNCHK
lin vanilla_A = mkWA "vanilja-" ; --UNCHK
lin vanilla_N = mkWN (k13 "vanilja") ; --UNCHK
lin vanillin_N = mkWN (k5 "vanilliini") ; --UNCHK
lin vanish_V = mkWV (k52A "haihtua") ; --UNCHK
lin vanished_A = mkWA "kadonnut" ; --UNCHK
lin vanisher_N = mkWN "katoaja" ; --UNCHK
lin vanishing_N = mkWN (compoundN "kato" (k38 "aminen")) ; --UNCHK
lin vanishingly_Adv = mkWAdv "häviävän" ; --UNCHK
lin vanity_N = mkWN (compoundN "pukeutumis" (k10A "pöytä")) ; --UNCHK
lin vanquish_V2 = mkWV2 (k53A "päihittää") ; --UNCHK
lin vantaa_PN = mkPN "Vantaa" ;
lin vantage_N = mkWN (k10 "asema") "edullinen" ; --UNCHK
lin vantage_point_N = mkWN (compoundN "näköala" (k9A "paikka")) ; --UNCHK
lin vapid_A = mkWA (k15 "tympeä") ; --UNCHK
lin vapidity_N = mkWN (k40 "latteus") ; --UNCHK
lin vapidness_N = mkWN (k40 "latteus") ; --UNCHK
lin vapor_N = mkWN (k39 "höyrystys") ; --UNCHK
lin vaporific_A = mkWA (k38 "kaasumainen") ; --UNCHK
lin vaporization_N = mkWN (compoundN "höyry" (k38 "stäminen")) ; --UNCHK
lin vaporize_V = mkWV (k52A "haihtua") ; --UNCHK
lin vaporize_V2 = mkWV2 (k52A "haihtua") ; --UNCHK
lin vaporizer_N = mkWN (k33 "höyrystin") ; --UNCHK
lin vaporous_A = mkWA (k38 "höyryinen") ; --UNCHK
lin vapour_N = mkWN (k39 "höyrystys") ; --UNCHK
lin vapour_bath_N = mkWN (k9 "sauna") "turkkilainen" ; --UNCHK
lin vaquero_N = mkWN (compoundN "karja" (k32 "paimen")) ; --UNCHK
lin vaquita_N = mkWN (compoundN "kalifornian" (k38 "pyöriäinen")) ; --UNCHK
lin vara_N = mkWN (k9 "vara") ; --UNCHK
lin varanasi_PN = foreignPN "Varanasi" ;
lin vardenafil_N = mkWN "Levitra" ; --UNCHK
lin variability_N = mkWN (k2 "vaihtelu") ; --UNCHK
lin variable_A = mkWA "muuttuva" ; --UNCHK
lin variable_N = mkWN (k10 "muuttuja") ;
lin variableness_N = mkWN (k2 "vaihtelu") ; --UNCHK
lin variance_N = mkWN (k2 "vaihtelu") ; --UNCHK
lin variant_A = mkWA (k10 "poikkeava") ; --UNCHK
lin variant_N = mkWN (k39 "painos") ; --UNCHK
lin variation_N = mkWN (k2 "vaihtelu") ;
lin varicelliform_A = mkWA (compoundA "muis" (k10 "tuttava")) "vesirokkoa" ; --UNCHK
lin varicocele_N = mkWN (compoundN "varikose" (k48 "ele")) ; --UNCHK
lin varicolored_A = mkWA (k41A "laikukas") ; --UNCHK
lin varicoloured_A = mkWA (k41A "laikukas") ; --UNCHK
lin varicose_A = mkWA (compoundA "suo" (k38 "nikohjuinen")) ; --UNCHK
lin varicosis_N = mkWN "varikoosi" ; --UNCHK
lin varicosity_N = mkWN (compoundN "laskimo" (k10 "laajentuma")) ; --UNCHK
lin varied_A = variants {} ; --
lin variedness_N = mkWN "vaihtelevuus" ; --UNCHK
lin variegated_A = mkWA (k10 "kirjava") ; --UNCHK
lin variegation_N = mkWN (compoundN "moni" (k38 "puolistaminen")) ; --UNCHK
lin varietal_N = mkWN (k5 "varietal-viini") ; --UNCHK
lin variety_1_N = mkN "valikoima" | mkN "vaihtelu" | mkN "moninaisuus" ; ---- split
lin variety_2_N = mkN "laatu" ;
lin variety_N = mkWN (k40 "moninaisuus") ;
lin variform_A = mkWA (compoundA "moni" (k38 "muotoinen")) ; --UNCHK
lin variolar_A = mkWA "isorokkoon" "liittyvä" ; --UNCHK
lin variometer_N = mkWN (compoundN "vario" (k5 "metri")) ; --UNCHK
lin variorum_N = mkWN (compoundN "variorum-" (k39 "painos")) ; --UNCHK
lin various_A = mkA "erilainen" ; ---??
lin varix_N = mkWN (k1 "suonikohju") ; --UNCHK
lin varkaus_PN = mkPN "Varkaus" ;
lin varlet_N = mkWN (k5 "paaši") ; --UNCHK
lin varmint_N = mkWN (compoundN "haitta" (k33 "eläin")) ; --UNCHK
lin varnish_N = mkWN (kH1 "lakka") ; --UNCHK
lin varnisher_N = mkWN "viimeistelijä" ; --UNCHK
lin varpaisjärvi_PN = mkPN (mkN "Varpaisjärvi" "Varpaisjärviä") ;
lin varsity_N = mkWN (compoundN "yliopisto" (k48 "joukkue")) ; --UNCHK
lin varus_N = mkWN (k39 "varus") ; --UNCHK
lin vary_V = mkV "vaihdella" ;
lin vary_V2 = mkV2 "vaihdella" partitive ; --mkWV2 (k52A "muuttua") ;
lin varying_A = variants {} ; --
lin vascular_A = mkWA "suoni-" ; --UNCHK
lin vascularity_N = mkWN "suonisuus" ; --UNCHK
lin vascularization_N = mkWN "vaskularisaatio" ; --UNCHK
lin vasculitis_N = mkWN (compoundN "verisuoni" (k39 "tulehdus")) ; --UNCHK
lin vase_N = mkWN (k5 "vaasi") ; --UNCHK
lin vasectomy_N = mkWN (k2 "katkaisu") "siemenjohdinten" ; --UNCHK
lin vaseline_N = mkWN "Vaseline" ; --UNCHK
lin vasoconstriction_N = mkWN "vasokonstriktio" ; --UNCHK
lin vasoconstrictor_N = mkWN (k10 "supistaja") ; --UNCHK
lin vasodilation_N = mkWN "vasodilaatio" ; --UNCHK
lin vasodilator_N = mkWN "verisuonten" "laajentaja" ; --UNCHK
lin vasomotor_A = mkWA (k38 "vasomotorinen") ; --UNCHK
lin vasopressin_N = mkWN (k5 "hormoni") "antidiureettinen" ; --UNCHK
lin vasopressor_N = mkWN (compoundN "vasopress" (k48 "ori")) ; --UNCHK
lin vasovasostomy_N = mkWN (compoundN "korjaus" (k39 "leikkaus")) "vasektomian" ; --UNCHK
lin vasovesiculitis_N = mkWN "vasovesiculitis" ; --UNCHK
lin vassal_N = mkWN (k5 "vasalli") ; --UNCHK
lin vassalage_N = mkWN (k40 "vasallius") ; --UNCHK
lin vast_A = mkWA (k10 "valtava") ;
lin vastness_N = mkWN (k40 "laajuus") ; --UNCHK
lin vat_N = mkWN (k5A "vati") ; --UNCHK
lin vatican_N = mkWN (k5 "palatsi") "Vatikaanin" ; --UNCHK
lin vaudeville_N = mkWN (k8 "vaudeville") ; --UNCHK
lin vaudevillian_N = mkWN (compoundN "varietee-" (k10 "esiintyjä")) ; --UNCHK
lin vault_N = mkN "holvi" ; ---ARB --mkWN (k10A "loikka") ;
lin vault_V = mkWV (k73A "hypätä") ; --UNCHK
lin vault_V2 = mkWV2 (k73A "hypätä") ; --UNCHK
lin vaulter_N = mkWN (compoundN "seiväs" (k10 "hyppääjä")) ; --UNCHK
lin vaulting_N = mkWN (k1A "hyppy") ; --UNCHK
lin vaulting_horse_N = mkWN (kH1 "pukki") ; --UNCHK
lin vaunt_N = mkWN (k2 "mahtailu") ; --UNCHK
lin vaunt_V = mkWV (k67A "rehennellä") ; --UNCHK
lin vaunt_V2 = mkWV2 (k67A "rehennellä") ; --UNCHK
lin vaunter_N = mkWN (k6 "öykkäri") ; --UNCHK
lin vauntingly_Adv = mkWAdv (k99 "leveästi") ; --UNCHK
lin vd_N = mkWN (compoundN "sukupuoli" (k5A "tauti")) ; --UNCHK
lin veal_N = mkWN (k14A "vasikka") ; --UNCHK
lin vector_N = mkWN (k6 "vektori") ; --UNCHK
lin vedalia_N = mkWN "Rodolia" "cardinalis" ; --UNCHK
lin veer_V = mkWV (k52A "kääntyä") ; --UNCHK
lin veery_N = mkWN "Hylocichla" "fuscescens" ; --UNCHK
lin vegan_N = mkWN (k6 "vegaani") ; --UNCHK
lin vegetable_N = mkWN (k39 "kasvis") ;
lin vegetal_A = mkWA (k38 "vegetatiivinen") ; --UNCHK
lin vegetarianFem_N = mkWN (k5 "vegetaristi") ; --UNCHK
lin vegetarianMasc_N = mkWN (k5 "vegetaristi") ; --UNCHK
lin vegetarianism_N = mkWN (k5 "vegetarismi") ; --UNCHK
lin vegetate_V = mkWV (k67 "oleskella") ; --UNCHK
lin vegetation_N = mkWN (k2 "oleilu") "tylsistyneenä" ; --UNCHK
lin vegetative_A = mkWA (k38 "vegetatiivinen") ; --UNCHK
lin vehemence_N = mkWN (k39 "painotus") ; --UNCHK
lin vehement_A = mkWA (k10 "raivoisa") ;
lin vehicle_N = mkWN (compoundN "ajo" (k1 "neuvo")) ; --f130
lin vehicular_A = mkWA "ajoneuvo-" ; --UNCHK
lin vehmaa_PN = mkPN "Vehmaa" ;
lin vehmersalmi_PN = mkPN (mkN "Vehmersalmi" "Vehmersalmia") ;
lin veil_N = mkWN (k1A "huntu") ; --UNCHK
lin veil_V2 = mkWV2 (k74 "verhota") ; --UNCHK
lin veiling_N = mkWN (k1 "harso") ; --UNCHK
lin vein_N = mkWN (compoundN "siipi" (k26 "suoni")) ; --UNCHK
lin veinal_A = mkWA "suoni-" ; --UNCHK
lin veined_A = mkWA (k38 "suoninen") ; --UNCHK
lin velar_A = mkWA "velaarinen" ; --UNCHK
lin velar_N = mkWN (k5A "konsonantti") "velaarinen" ; --UNCHK
lin veld_N = mkWN (compoundN "ruoho" (k4A "aavikko")) ; --UNCHK
lin velkua_PN = mkPN "Velkua" ;
lin velleity_N = mkWN (k1A "tahto") ; --UNCHK
lin vellum_N = mkWN (k5A "pergamentti") ; --UNCHK
lin velocipede_N = mkWN (compoundN "kolmi" (k38 "pyöräinen")) ; --UNCHK
lin velociraptor_N = mkWN "velociraptor" ; --UNCHK
lin velocity_N = mkWN (k5A "vauhti") ; --UNCHK
lin velodrome_N = mkWN (k5 "velodromi") ; --UNCHK
lin velour_N = mkWN (k6 "veluuri") ; --UNCHK
lin veloute_N = mkWN (compoundN "perus" (k48A "kastike")) "vaalea" ; --UNCHK
lin velvet_A = mkWA (k38 "samettinen") ; --UNCHK
lin velvet_N = mkWN (k5A "sametti") ; --UNCHK
lin velveteen_N = mkWN (compoundN "puuvilla" (k5A "sametti")) ; --UNCHK
lin velvetleaf_N = mkWN (compoundN "kelta-" (k3 "aulio")) ; --UNCHK
lin velvety_A = mkWA (k38 "samettinen") ; --UNCHK
lin venal_A = mkWA (k10 "oleva") "ostettavissa" ; --UNCHK
lin venality_N = mkWN "korruptoituneisuus" ; --UNCHK
lin venation_N = mkWN (k2 "suonisto") ; --UNCHK
lin vend_V2 = mkWV2 (k63 "myydä") ; --UNCHK
lin vendee_N = mkWN (k10 "ostaja") ; --UNCHK
lin vender_N = mkWN (k12 "kaupittelija") ; --UNCHK
lin vendetta_N = mkWN (compoundN "veri" (k1 "kosto")) ; --UNCHK
lin vending_N = mkWN (k2 "kaupustelu") ; --UNCHK
lin vendor_N = mkWN (k12 "kaupittelija") ; --UNCHK
lin veneer_N = mkWN (k39 "päällystys") ; --UNCHK
lin veneer_V2 = mkWV2 (k53A "viiluttaa") ; --UNCHK
lin veneering_N = mkWN (k39 "viilutus") ; --UNCHK
lin venerability_N = mkWN (k40 "kunnioitettavuus") ; --UNCHK
lin venerable_A = mkWA (compoundA "kunnian" (k10 "arvoisa")) ;
lin venerate_V2 = mkWV2 (k53A "kunnioittaa") "syvästi" ; --UNCHK
lin veneration_N = mkWN (k40 "hartaus") ; --UNCHK
lin venerator_N = mkWN "kunnioittaja" ; --UNCHK
lin venereal_A = mkWA (k38 "veneerinen") ; --UNCHK
lin venereologistFem_N = variants {} ; ---- sense to be split
lin venereologistMasc_N = variants {} ; ---- sense to be split
lin venesection_N = mkWN (k3 "venesektio") ; --UNCHK
lin venetian_A = mkWA (compoundA "venetsi" (k38 "alainen")) ; --UNCHK
lin venezuela_PN = foreignPN "Venezuela" ;
lin venezuelan_A = mkWA (compoundA "venezuel" (k38 "alainen")) ; --UNCHK
lin venezuelan_N = mkWN (compoundN "venezuel" (k38 "alainen")) ; --UNCHK
lin vengeance_N = mkWN (k1 "kosto") ; --UNCHK
lin vengeful_A = mkWA (compoundA "koston" (k38 "haluinen")) ; --UNCHK
lin venial_A = mkWA (k38 "vähäpätöinen") ; --UNCHK
lin venice_PN = foreignPN "Venetsia" ;
lin venipuncture_N = mkWN (compoundN "veri" (k48A "koe")) ; --UNCHK
lin venison_N = mkWN (k7 "hirvi") ; --UNCHK
lin venogram_N = mkWN (compoundN "röntgen" (k48A "laite")) ; --UNCHK
lin venography_N = mkWN "laskimoiden" "varjoaineröntgenkuvaus" ; --UNCHK
lin venom_N = mkWN (k9 "kauna") ; --UNCHK
lin venomed_A = mkWA (k10 "katkera") ; --UNCHK
lin venomous_A = mkWA (k10 "katkera") ; --UNCHK
lin venous_A = mkWA "verisuoni-" ; --UNCHK
lin vent_N = mkWN (compoundN "purkautumis" (k19 "tie")) ; --UNCHK
lin vent_V2 = mkWV2 (k53A "tuulettaa") ; --UNCHK
lin venter_N = mkWN (compoundN "kehon" (k10 "osa")) "pullottava" ; --UNCHK
lin ventilate_V2 = mkWV2 (k53A "tuulettaa") ; --UNCHK
lin ventilation_N = mkWN (k39 "tuuletus") ; --UNCHK
lin ventilator_N = mkWN (k6 "ventilaattori") ; --UNCHK
lin ventilatory_A = mkWA (compoundA "varus" (k1 "tettu")) "tuulettimella" ; --UNCHK
lin ventnor_PN = foreignPN "Ventnor" ;
lin ventral_A = mkWA (compoundA "ventra" (k38 "alinen")) ; --UNCHK
lin ventricle_N = mkWN (k3 "kammio") ; --UNCHK
lin ventricose_A = mkWA "pullistunut" ; --UNCHK
lin ventricular_A = mkWA "kammio-" ; --UNCHK
lin ventriloquism_N = mkWN (k38 "vatsastapuhuminen") ; --UNCHK
lin ventriloquist_N = mkWN (compoundN "vatsasta" (k10 "puhuja")) ; --UNCHK
lin venture_N = mkN "yritys" ; ----CHANGE "vaarantaa" ;
lin venture_V = mkWV (k52A "uskaltautua") ; --UNCHK
lin venture_V2 = mkWV2 (k52A "uskaltautua") ; --UNCHK
lin venture_VS = mkWVS (k52A "uskaltautua") ; --UNCHK
lin venturer_N = mkWN (k1A "uskalikko") ; --UNCHK
lin venturesome_A = mkWA (k41 "uskalias") ; --UNCHK
lin venturi_N = mkWN "venturi" ; --UNCHK
lin venturous_A = mkWA (k41 "uskalias") ; --UNCHK
lin venue_N = mkWN (compoundN "oikeus" (k9A "paikka")) ; --UNCHK
lin venule_N = mkWN (compoundN "veri" (k26 "suoni")) "pienin" ; --UNCHK
lin venus_PN = foreignPN "Venus" ;
lin vera_PN = foreignPN "Vera" ;
lin veracious_A = mkWA (k15 "oikea") ; --UNCHK
lin veracity_N = mkWN (compoundN "toden" (k40 "mukaisuus")) ; --UNCHK
lin veranda_N = mkWN (k9A "veranta") ; --UNCHK
lin verandah_N = mkWN (k9A "veranta") ; --UNCHK
lin verapamil_N = mkWN "Isoptin" ; --UNCHK
lin verb_N = mkWN (k5 "verbi") ; --UNCHK
lin verbal_A = mkWA (k38 "verbaalinen") ; ---ARB --mkA "sanallinen" ;
lin verbalization_N = mkWN (k5A "verbalisointi") ; --UNCHK
lin verbalize_V2 = mkWV2 (k53A "muuttaa") "verbiksi" ; --UNCHK
lin verbatim_A = mkWA (k10 "suora") ; --UNCHK
lin verbatim_Adv = mkWAdv (k99 "kirjaimellisesti") ; --UNCHK
lin verbena_N = mkWN (compoundN "rauta" (k5A "yrtti")) ; --UNCHK
lin verbiage_N = mkWN (k12 "fraseologia") ; --UNCHK
lin verbolatry_N = mkWN (compoundN "sanojen" (k9A "palvonta")) ; --UNCHK
lin verbose_A = mkWA (k10 "ikävystyttävä") ; --UNCHK
lin verboseness_N = mkWN (compoundN "monisa" (k40 "naisuus")) ; --UNCHK
lin verbosity_N = mkWN (compoundN "monisa" (k40 "naisuus")) ; --UNCHK
lin verdancy_N = mkWN (k40 "vehmaus") ; --UNCHK
lin verdant_A = mkWA (k15 "vihreä") ; --UNCHK
lin verdict_N = mkWN (k39 "päätös") ; --UNCHK
lin verdigris_N = mkWN (k12 "patina") ; --UNCHK
lin verdin_N = mkWN (compoundN "amerikanpussi" (k38 "tiainen")) ; --UNCHK
lin verdure_N = mkWN (k40 "vehmaus") ; --UNCHK
lin verge_N = mkN "reuna" ; --mkWN (k49A "piennar") ;
lin verge_V = mkV "lähetä" "läheni" ;
lin verger_N = mkWN (k3 "suntio") ; --UNCHK
lin veridical_A = mkWA (k1A "aito") ; --UNCHK
lin verifiable_A = mkWA (k10 "oleva") "tarkistettavissa" ; --UNCHK
lin verification_N = mkWN (k39 "todistus") ; --UNCHK
lin verify_V2 = mkWV2 (k53 "varmistaa") ; --UNCHK
lin verisimilar_A = mkWA (compoundA "toden" (k38 "näköinen")) ; --UNCHK
lin verisimilitude_N = mkWN (compoundN "totuuden" (k40 "kaltaisuus")) ; --UNCHK
lin veritable_A = mkWA (k38 "varsinainen") ; --UNCHK
lin verity_N = mkWN (k40 "totuus") ; --UNCHK
lin vermicelli_N = mkWN (k5 "vermiselli") ; --UNCHK
lin vermicide_N = mkWN "vermisidi" ; --UNCHK
lin vermicular_A = mkWA "kiemurteleva" ; --UNCHK
lin vermiculate_A = mkWA "kiemurteleva" ; --UNCHK
lin vermiculation_N = mkWN (compoundN "kiemura" (k48 "koriste")) ; --UNCHK
lin vermiculite_N = mkWN "vermikuliitti" ; --UNCHK
lin vermiform_A = mkWA (k38 "muotoinen") "madon" ; --UNCHK
lin vermifuge_N = mkWN (compoundN "mato" (k48A "lääke")) ; --UNCHK
lin vermilion_A = mkWA (compoundA "tuli" (k38 "punainen")) ; --UNCHK
lin vermilion_N = mkWN (k5 "sinooperi") ; --UNCHK
lin vermin_N = mkWN (k38 "syöpäläinen") ; --UNCHK
lin verminous_A = mkWA (compoundA "vaste" (k38 "nmielinen")) ; --UNCHK
lin vermis_N = mkWN (compoundN "aivo" (k1A "mato")) ; --UNCHK
lin vermouth_N = mkWN (k5A "vermutti") ; --UNCHK
lin vernacular_A = mkWA (compoundA "kansan" (k38 "omainen")) ; --UNCHK
lin vernacular_N = mkWN (compoundN "arki" (k26 "kieli")) ; --UNCHK
lin vernal_A = mkWA (k38 "keväinen") ; --UNCHK
lin vernation_N = mkWN (compoundN "hiirenkorva" (k48 "vaihe")) ; --UNCHK
lin vernix_N = mkWN (compoundN "case" (k10 "osa")) "vernix" ; --UNCHK
lin vernon_PN = foreignPN "Vernon" ;
lin verona_PN = foreignPN "Verona" ;
lin veronica_N = mkWN (k48A "tädyke") ; --UNCHK
lin verruca_N = mkWN (k10 "syylä") ; --UNCHK
lin verrucose_A = mkWA (compoundA "syy" (k38 "lämäinen")) ; --UNCHK
lin versatile_A = mkWA (k10 "liikkuva") "edestakaisin" ; --UNCHK
lin versatility_N = mkWN (k40 "monipuolisuus") ; --UNCHK
lin verse_N = mkWN (k5 "riimi") ; --UNCHK
lin versed_A = mkWA (k10 "syvä") ; --UNCHK
lin versicle_N = mkWN (compoundN "johdanto-" (k10 "osa")) "liturgian" ; --UNCHK
lin versification_N = mkWN (compoundN "kirjo" (k38 "ittaminen")) "runomittaan" ; --UNCHK
lin versifier_N = mkWN (k12 "runoilija") ; --UNCHK
lin versify_V = mkWV (k53A "kirjoittaa") "runomittaan" ; --UNCHK
lin versify_V2 = mkWV2 (k53A "kirjoittaa") "runomittaan" ; --UNCHK
lin version_N = mkN "versio" ;
lin verso_N = mkWN (k9 "klaava") ; --UNCHK
lin verst_N = mkWN (k9 "virsta") ; --UNCHK
lin versus_Prep = prePrep nominative "vastaan" ;
lin vertebra_N = mkWN (k10 "nikama") ; --UNCHK
lin vertebral_A = mkWA "nikama-" ; --UNCHK
lin vertebrate_A = mkWA (k38 "selkärankainen") ; --UNCHK
lin vertebrate_N = mkWN (k38 "selkärankainen") ; --UNCHK
lin vertex_N = mkWN (compoundN "leikkaus" (k48 "piste")) ; --UNCHK
lin vertical_A = mkWA (k38 "vertikaalinen") ; --UNCHK
lin vertical_N = mkWN (compoundN "pysty" (k7A "tuki")) ; --UNCHK
lin verticality_N = mkWN (compoundN "pysty" (k40 "suoruus")) ; --UNCHK
lin verticil_N = mkWN (compoundN "lehti" (k12 "kiehkura")) ; --UNCHK
lin verticillate_A = mkWA (compoundA "lehtirypäsmuodostel" (k9 "massa")) ; --UNCHK
lin verticilliosis_N = mkWN (compoundN "näivetys" (k5A "tauti")) ; --UNCHK
lin verticillium_N = mkWN "verticillium" ; --UNCHK
lin vertiginous_A = mkWA (k10 "huimaava") ; --UNCHK
lin vertigo_N = mkWN (k39 "pyörrytys") ; --UNCHK
lin verve_N = mkWN (k39 "innostus") ; --UNCHK
lin vervet_N = mkWN (compoundN "tantalus" (k5A "marakatti")) ; --UNCHK
lin very_A = mkA "nimenomainen" ;
lin very_AdA = S.very_AdA ;
lin vesanto_PN = mkPN "Vesanto" ;
lin vesical_A = mkWA "rakkula-" ; --UNCHK
lin vesicant_N = mkWN (k48 "aine") "rakoille" "vetävä" ; --UNCHK
lin vesicatory_A = mkWA (k10 "vetävä") "rakoille" ; --UNCHK
lin vesicle_N = mkWN (k12 "rakkula") ; --UNCHK
lin vesicular_A = mkWA (compoundA "vesi" (k38 "kulaarinen")) ; --UNCHK
lin vesiculation_N = mkWN (k1 "nousu") "rakkuloille" ; --UNCHK
lin vesiculitis_N = mkWN (k39 "tulehdus") "rakkularauhasen" ; --UNCHK
lin vesiculovirus_N = mkWN (compoundN "vesiculo" (k39 "virus")) ; --UNCHK
lin vesilahti_PN = mkPN (mkN "Vesilahti" "Vesilahtia") ;
lin vesper_N = mkWN (compoundN "rukous" (k7 "hetki")) "illan" ; --UNCHK
lin vespers_N = mkWN (compoundN "ilta" (k40 "hartaus")) ; --UNCHK
lin vespid_N = mkWN (k38 "ampiainen") "yleinen" ; --UNCHK
lin vessel_N = mkWN (k39 "alus") ; --UNCHK
lin vest_N = mkWN (compoundN "alus" (k9A "paita")) ; --UNCHK
lin vest_V = mkWV (k52A "pukeutua") "kaapuun" ; --UNCHK
lin vest_V2 = mkV2 "uskoa" partitive ;
lin vestal_A = mkWA (k15 "siveä") ; --UNCHK
lin vestal_N = mkWN (k38 "nainen") "säädyllinen" ; --UNCHK
lin vestiary_A = mkWA "vaatetus-" ; --UNCHK
lin vestibular_A = mkWA "vestibulaarinen" ; --UNCHK
lin vestibule_N = mkWN (k3 "lämpiö") ; --UNCHK
lin vestige_N = mkWN (k7A "jälki") ; --UNCHK
lin vestigial_A = mkWA (k38 "rudimentaarinen") ; --UNCHK
lin vestiture_N = mkWN (k39 "vaatetus") ; --UNCHK
lin vestment_N = mkWN (compoundN "messu" (k1A "puku")) ; --UNCHK
lin vestmental_A = mkWA "messupuku-" ; --UNCHK
lin vestmented_A = mkWA "messupukuun" "pukeutunut" ; --UNCHK
lin vestry_N = mkWN (k1 "sakaristo") ; --UNCHK
lin vestryman_N = mkWN (k32 "jäsen") "kirkonkokouksen" ; --UNCHK
lin vestrywoman_N = mkWN (k32 "jäsen") "naispuolinen" "kirkonkokouksen" ; --UNCHK
lin vesture_N = mkWN (k1A "puku") ; --UNCHK
lin vesture_V2 = mkWV2 (k74 "verhota") ; --UNCHK
lin vesuvianite_N = mkWN (compoundN "idokr" (k5 "aasi")) ; --UNCHK
lin vet_N = mkWN (k5 "veteraani") ; --UNCHK
lin vet_V2 = mkWV2 (k53A "hoitaa") "eläimiä" ; --UNCHK
lin vetch_N = mkWN (k9 "virna") ; --UNCHK
lin vetchling_N = mkWN (k10 "nätkelmä") ; --UNCHK
lin veteli_PN = mkPN "Veteli" ;
lin veteran_N = mkWN (k12 "tekijä") "vanha" ; --UNCHK
lin veterinarian_N = mkWN (compoundN "eläin" (k6 "lääkäri")) ; --UNCHK
lin veterinary_A = mkWA (compoundA "eläinlääke" (k38 "tieteellinen")) ; --UNCHK
lin veto_N = mkN "veto" ;
lin veto_V = mkWV (k53A "käyttää") "veto-oikeuttaan" ;
lin veto_V2 = mkWV2 (k53A "käyttää") "veto-oikeuttaan" ; --UNCHK
lin vex_V2 = mkWV2 (k53A "sekoittaa") ; --UNCHK
lin vex_V2V = mkWV2V (k53A "sekoittaa") ; --UNCHK
lin vexation_N = mkWN (compoundN "kiusan" (k1A "teko")) ; --UNCHK
lin vexatious_A = mkWA (k10 "rasittava") ; --UNCHK
lin via_Prep = postPrep genitive "kautta" ;
lin via_media_N = mkWN (k5 "kompromissi") ; --UNCHK
lin viability_N = mkWN (compoundN "elin" (k40 "kykyisyys")) ;
lin viable_A = mkWA (compoundA "elin" (k38 "kelpoinen")) ; --UNCHK
lin viaduct_N = mkWN (compoundN "maa" (k9A "silta")) ; --UNCHK
lin vial_N = mkWN (k5 "ampulli") ; --UNCHK
lin viand_N = mkWN (k10A "ruoka") "herkullinen" ; --UNCHK
lin viatication_N = mkWN (k5A "realisointi") "henkivakuutuksen" ; --UNCHK
lin vibist_N = mkWN (k5 "vibrafonisti") ; --UNCHK
lin vibrant_A = mkWA (k41A "kirkas") ; --UNCHK
lin vibraphone_N = mkWN (k5 "vibrafoni") ; --UNCHK
lin vibrate_V = mkV "väristä" ;
lin vibrate_V2 = mkV2 "värisyttää" ;
lin vibration_N = mkN "värähtely" ;
lin vibrational_A = mkA "vibrationaalinen" ;
lin vibrato_N = mkN "vibraatto" ;
lin vibrator_N = mkWN (k6 "vibraattori") ; --UNCHK
lin vibratory_A = mkWA "heilahteleva" ; --UNCHK
lin vibrio_N = mkWN "vibrio" ; --UNCHK
lin vibrionic_A = mkWA "vibrio-bakteerin" "aiheuttama" ; --UNCHK
lin vic_PN = foreignPN "Vic" ;
lin vicar_N = mkN "pastori" ; --mkWN (compoundN "vik" (k5 "aari")) ;
lin vicarage_N = mkWN (k12 "pappila") ; --UNCHK
lin vicarial_A = mkA "papillinen" ;
lin vicariate_N = mkWN "vikariaatti" ; --UNCHK
lin vicarious_A = mkWA (compoundA "epä" (k10 "suora")) ; --UNCHK
lin vice_N = mkN (lin NK {s = d48 "pahe"}) ;
lin vice_Prep = mkPrep "vara" nominative ; ---- cat
lin vice_president_N = mkN "vara" (mkN "presidentti") ;
lin vice_versa_Adv = mkWAdv (k99 "päin") "toisin" ; --UNCHK
lin vicegerent_N = mkWN (compoundN "käskyn" (k12 "haltija")) ; --UNCHK
lin vicenza_PN = foreignPN "Vicenza" ;
lin viceregal_A = mkWA (compoundA "vara" (k38 "kuninkaallinen")) ; --UNCHK
lin vicereine_N = mkWN (k5 "kuvernööri") ; --UNCHK
lin viceroyalty_N = mkWN (compoundN "hallinto" (k48 "alue")) "kuvernöörin" ; --UNCHK
lin viceroyship_N = mkWN "kuvernööriys" ; --UNCHK
lin vichyssoise_N = mkWN (compoundN "purjo-perunasose" (k1A "keitto")) ; --UNCHK
lin vicinal_A = mkWA (k38 "vierekkäinen") ; --UNCHK
lin vicinity_N = mkWN (k40 "läheisyys") ; --UNCHK
lin vicious_A = mkA "häijy" ;
lin viciousness_N = mkWN (k40 "häijyys") ; --UNCHK
lin vicissitude_N = mkWN (k2 "vaihtelu") ; --UNCHK
lin victim_N = mkWN (k5 "uhri") ;
lin victimization_N = mkWN (k1 "riisto") ; --UNCHK
lin victimize_V2 = mkWV2 (k53A "sortaa") ; --UNCHK
lin victimizer_N = mkWN (k10 "sortaja") ; --UNCHK
lin victor_N = mkWN (k6 "mestari") ; --UNCHK
lin victor_PN = foreignPN "Victor" ;
lin victoria_N = mkWN "Victoria" ; --UNCHK
lin victoria_PN = foreignPN "Victoria" ;
lin victorian_A = mkWA (k38 "viktoriaaninen") ; --UNCHK
lin victorian_N = mkWN (k5 "viktoriaani") ; --UNCHK
lin victoriana_N = mkWN (k5A "antiikki") "viktoriaaninen" ; --UNCHK
lin victorious_A = mkWA (k10 "voittoisa") ; --UNCHK
lin victory_N = mkN "voitto" ;
lin victual_N = mkWN (k10 "muona") ; --CHECKED
lin victual_V = mkWV (k64 "syödä") ; --UNCHK
lin victual_V2 = mkV2 "muonittaa" ; --CHECKED
lin victualer_N = mkWN (compoundN "kanttiinin" (k10 "pitäjä")) ; --UNCHK
lin victualler_N = mkWN (compoundN "kanttiinin" (k10 "pitäjä")) ; --UNCHK
lin vicuna_N = mkWN "Vicugna" "vicugna" ; --UNCHK
lin videlicet_Adv = mkWAdv (k99 "näet") ; --UNCHK
lin video_N = mkN "video" ;
lin video_taped_A = variants {} ; --
lin videocassette_N = mkWN (compoundN "video" (k5A "kasetti")) ; --UNCHK
lin videodisk_N = mkWN (compoundN "kuva" (k1 "levy")) ; --UNCHK
lin videotape_N = mkWN (compoundN "video" (k9 "nauha")) ; --UNCHK
lin videotape_V2 = mkWV2 (k53A "nauhoittaa") "videolle" ; --UNCHK
lin vie_V = mkWV (k67A "kilvoitella") ; --UNCHK
lin vienna_PN = foreignPN "Wien" ;
lin vieremä_PN = mkPN "Vieremä" ;
lin vietnam_PN = foreignPN "Vietnam" ;
lin vietnamese_A = mkWA (compoundA "vietnami" (k38 "lainen")) ; --UNCHK
lin vietnamese_N = mkWN "Annamite" ; --UNCHK
lin view_1_N = mkN "näkymä" | mkN "näky" ;
lin view_2_N = mkN "mielipide" ;
lin view_N = mkWN (k10 "näkymä") ;
lin view_V2 = mkWV2 (k62 "arvioida") ; --f78
lin viewer_N = mkN (lin NK {s = d12 "katselija"}) ;
lin viewfinder_N = mkWN (k33 "tähtäin") ; --UNCHK
lin viewgraph_N = mkWN (compoundN "piirtoheitin" (k1 "kalvo")) ; --UNCHK
lin viewless_A = mkWA "mielipiteetön" ; --UNCHK
lin viewpoint_N = mkN "näkö" (mkN "kulma") ;
lin vigil_N = mkWN (k5A "vahti") ; --UNCHK
lin vigilance_N = mkWN (k40 "valppaus") ; --UNCHK
lin vigilant_A = mkWA (k99 "varuillaan") ; --UNCHK
lin vigilante_N = mkWN (k32 "jäsen") "järjestyspartion" ; --UNCHK
lin vignette_N = mkWN (k39 "kuvaus") ; --UNCHK
lin vigo_PN = foreignPN "Vigo" ;
lin vigor_N = mkWN (k40 "pontevuus") ; --UNCHK
lin vigorous_A = mkWA (k41A "tarmokas") ; --UNCHK
lin vigour_N = mkWN (k40 "pontevuus") ; --UNCHK
lin vihanti_PN = mkPN "Vihanti" ;
lin vihti_PN = mkPN "Vihti" ;
lin viiala_PN = mkPN "Viiala" ;
lin viitasaari_PN = mkPN (mkN "Viitasaari" "Viitasaaria") ;
lin viking_N = mkWN (k5A "viikinki") ; --UNCHK
lin vile_A = mkWA (k10 "katala") ; --UNCHK
lin vileness_N = mkWN (k40 "häijyys") ; --UNCHK
lin vilification_N = mkWN (k2 "panettelu") ; --UNCHK
lin vilify_V2 = mkWV2 (k67A "panetella") ; --UNCHK
lin viljakkala_PN = mkPN "Viljakkala" ;
lin villa_N = mkWN (kH1 "villa") ; --UNCHK
lin village_N = L.village_N ;
lin villager_N = mkWN (k38 "kyläläinen") ; --UNCHK
lin villain_N = mkWN (k5A "hunsvotti") ; --UNCHK
lin villainess_N = mkWN (compoundN "nais" (k38 "rikollinen")) ; --UNCHK
lin villainous_A = mkWA (k38 "roistomainen") ; --UNCHK
lin villainy_N = mkWN (compoundN "ilki" (k19 "työ")) ; --UNCHK
lin villein_N = mkWN (compoundN "maa" (k10 "orja")) ; --UNCHK
lin villeinage_N = mkWN (compoundN "hallussapito-" (k40 "oikeus")) ; --UNCHK
lin villus_N = mkWN (compoundN "nukka" (k48A "lisäke")) ; --UNCHK
lin vilppula_PN = mkPN "Vilppula" ;
lin vim_N = mkWN (k40 "pontevuus") ; --UNCHK
lin vimpeli_PN = mkPN (mkN "Vimpeli" "Vimpeliä") ;
lin vinaceous_A = mkWA "viiniin" "liittyvä" ; --UNCHK
lin vinaigrette_N = mkWN (k48A "kastike") "ranskalainen" ; --UNCHK
lin vinblastine_N = mkWN "Velban" ; --UNCHK
lin vincent_PN = foreignPN "Vincent" ;
lin vincristine_N = mkWN "Oncovin" ; --UNCHK
lin vindicate_V2 = mkWV2 (k53A "osoittaa") "oikeaksi" ; --UNCHK
lin vindication_N = mkWN (compoundN "vapa" (k38 "uttaminen")) "syytteistä" ; --UNCHK
lin vindictive_A = mkWA (k15 "ilkeä") ; --UNCHK
lin vindictiveness_N = mkWN "kostonhimoisuus" ; --UNCHK
lin vine_N = mkWN (k39 "köynnös") ; --UNCHK
lin vinegar_N = mkWN (k14A "etikka") ; --UNCHK
lin vinegariness_N = mkWN (k40 "happamuus") ; --UNCHK
lin vinegarroon_N = mkWN (compoundN "jättisiima" (k5 "skorpioni")) ; --UNCHK
lin vinegary_A = mkWA (k33A "hapan") ; --UNCHK
lin vinery_N = mkWN (compoundN "viini" (k10 "viljelmä")) ; --UNCHK
lin vineyard_N = mkWN (compoundN "viini" (k10 "viljelmä")) ; --UNCHK
lin vinifera_N = mkWN "aitoviiniköynnös" ; --UNCHK
lin vinification_N = mkWN "vinifikaatio" ; --UNCHK
lin vinkkilä_PN = mkPN "Vinkkilä" ;
lin vinous_A = mkWA "viiniin" "liittyvä" ; --UNCHK
lin vintage_N = mkWN (compoundN "vuosi" (k5 "malli")) ;
lin vintager_N = mkWN (compoundN "sadon" (k10 "korjaaja")) ; --UNCHK
lin vintner_N = mkWN (compoundN "viinin" (k12 "viljelijä")) ; --UNCHK
lin vinyl_N = mkWN (k6 "vinyyli") ; --UNCHK
lin viol_N = mkWN (k13 "viola") ; --UNCHK
lin viola_N = mkWN (compoundN "altto" (k1 "viulu")) ; --UNCHK
lin viola_PN = foreignPN "Viola" ;
lin violable_A = mkWA "rikkoutuva" ; --UNCHK
lin violate_V2 = mkWV2 (k52A "rikkoa") ; --f63
lin violation_N = mkN "rikkomus" ; --f63
lin violator_N = mkWN (k12 "irstailija") ; --UNCHK
lin violence_N = mkWN (compoundN "väki" (k9A "valta")) ; --UNCHK
lin violent_A = mkWA (k1 "raju") ; --UNCHK
lin violet_N = mkWN (k5A "violetti") ; --UNCHK
lin violet_PN = foreignPN "Violet" ;
lin violin_N = mkWN (k1 "viulu") ;
lin violinistFem_N = mkWN (k5 "viulisti") ; --UNCHK
lin violinistMasc_N = mkWN (k5 "viulisti") ; --UNCHK
lin violistFem_N = mkWN (k10 "soittaja") "violan" ; --UNCHK
lin violistMasc_N = mkWN (k10 "soittaja") "violan" ; --UNCHK
lin viomycin_N = mkWN "Viocin" ; --UNCHK
lin vip_N = mkWN (k9 "herra") "suuri" ; --UNCHK
lin viper_N = mkWN (k18 "kyy") ; --UNCHK
lin virago_N = mkWN (k5 "amatsoni") ; --UNCHK
lin viral_A = mkWA "virus-" ; --UNCHK
lin viremia_N = mkWN "viremia" ; --UNCHK
lin vireo_N = mkWN "vireo" ; --UNCHK
lin virga_N = mkWN (k9A "sakka") ; --UNCHK
lin virgin_A = mkWA (k15 "siveä") ; --UNCHK
lin virgin_N = mkN "neitsyt" ;
lin virginal_A = mkWA (k38 "neitseellinen") ; --UNCHK
lin virginal_N = mkWN (compoundN "virgi" (k5 "naali")) ; --UNCHK
lin virginia_N = mkWN "Virginia" ; --UNCHK
lin virginia_PN = foreignPN "Virginia" ;
lin virginity_N = mkWN (k40 "poikuus") ; --UNCHK
lin virgule_N = mkWN (k50 "vinoviiva") ; --UNCHK
lin viricidal_A = mkWA "viruksia" "tappava" ; --UNCHK
lin viricide_N = mkWN "virusidi" ; --UNCHK
lin virile_A = mkWA (k5 "viriili") ; --UNCHK
lin virilism_N = mkWN (compoundN "viril" (k5 "ismi")) ; --UNCHK
lin virility_N = mkWN (k40 "miehuullisuus") ; --UNCHK
lin virino_N = mkWN "virino" ; --UNCHK
lin virion_N = mkWN (compoundN "vir" (k5 "ioni")) ; --UNCHK
lin viroid_N = mkWN "virusoidi" ; --UNCHK
lin virojoki_PN = mkPN (mkN "Virojoki" "Virojokia") ;
lin virolahti_PN = mkPN (mkN "Virolahti" "Virolahtia") ;
lin virological_A = mkWA (k38 "virologinen") ; --UNCHK
lin virologist_N = mkWN (k12 "tutkija") "virusten" ; --UNCHK
lin virology_N = mkWN (k12 "virologia") ; --UNCHK
lin virrat_PN = mkPN "Virrat" ;
lin virtasalmi_PN = mkPN (mkN "Virtasalmi" "Virtasalmia") ;
lin virtu_N = mkWN "virtu" ; --UNCHK
lin virtual_A = mkWA (k38 "virtuaalinen") ; --f66
lin virtue_N = mkN "hyve" ; --mkWN (k40 "erinomaisuus") "moraalinen" ;
lin virtuosity_N = mkWN (k40 "taituruus") ; --UNCHK
lin virtuoso_N = mkWN (k5A "ekspertti") ; --UNCHK
lin virtuous_A = mkWA (k38 "hyveellinen") ; --UNCHK
lin virulence_N = mkWN (compoundN "vihamiel" (k40 "isyys")) ; --UNCHK
lin virus_N = mkWN (k39 "virus") ;
lin vis_a_vis_Prep = prePrep illative "suhteessa" ;
lin visa_N = mkWN (k6 "viisumi") ; --UNCHK
lin visa_V2 = mkWV2 (k52 "hyväksyä") "virallisesti" ; --UNCHK
lin visage_N = mkWN (k48 "ilme") ; --UNCHK
lin visaged_A = mkWA (k38 "-kasvoinen") ; --UNCHK
lin viscacha_N = mkWN (k9 "chinchilla") ; --UNCHK
lin visceral_A = mkWA "sisäelin-" ; --UNCHK
lin viscid_A = mkWA (k15 "tahmea") ; --UNCHK
lin viscoelastic_A = mkWA (compoundA "visko" (k38 "elastinen")) ; --UNCHK
lin viscometer_N = mkWN (compoundN "juoksevuus" (k6 "mittari")) ; --UNCHK
lin viscometric_A = mkWA (compoundA "viskosi" (k38 "metrinen")) ; --UNCHK
lin viscometry_N = mkWN "viskosimetria" ; --UNCHK
lin viscosity_N = mkWN (k40 "viskoosisuus") ; --UNCHK
lin viscount_N = mkWN (compoundN "vara" (k5 "kreivi")) ; --UNCHK
lin viscountcy_N = mkWN (k6 "titteli") "varakreivin" ; --UNCHK
lin viscountess_N = mkWN (compoundN "vara" (k32A "kreivitär")) ; --UNCHK
lin viscounty_N = mkWN (compoundN "hallinto" (k48 "alue")) "varakreivin" ; --UNCHK
lin viscous_A = mkWA (k15 "tahmea") ; --UNCHK
lin vise_N = mkWN (k5A "ruuvipihti") ; --UNCHK
lin viselike_A = mkWA (compoundA "puristuksen" (k38 "omainen")) ; --UNCHK
lin visibility_N = mkWN (k40 "näkyvyys") ; --UNCHK
lin visible_A = mkWA (k10 "näkyvä") ; --UNCHK
lin vision_N = mkWN (k2 "kuvittelu") ; --UNCHK
lin visionary_A = mkWA (k34A "mieletön") ; --UNCHK
lin visionary_N = mkWN (k10 "tietäjä") ; --UNCHK
lin visit_N = mkN "vierailu" ;
lin visit_V = mkV "vierailla" ;
lin visit_V2 = mkV2 (mkV "vierailla") (postGenPrep "luona") ; --- agreement to prep, "minun luonani"
lin visitant_N = mkWN (k41 "vieras") ; --UNCHK
lin visitation_N = mkWN (compoundN "tarkastus" (k5A "käynti")) ; --UNCHK
lin visiting_N = mkWN (k2 "vierailu") ; --UNCHK
lin visitor_N = mkN "vierailija" | mkWN (k41 "vieras") ;
lin visor_N = mkWN (k9A "lippa") ; --UNCHK
lin visored_A = mkWA (compoundA "silmiko" (k1A "itu")) ; --UNCHK
lin vista_N = mkWN (k10 "maisema") ; --UNCHK
lin visual_A = mkA "visuaalinen" ;
lin visualization_N = mkWN (compoundN "mieli" (k10 "kuva")) ; --UNCHK
lin visualize_V2 = mkWV2 (k71 "tehdä") "näkyväksi" ; --UNCHK
lin visualizer_N = mkWN (k10 "visualisoija") ; --UNCHK
lin vital_A = mkWA (compoundA "elinvoi" (k38 "mainen")) ; --UNCHK
lin vitalism_N = mkWN (k5 "vitalismi") ; --UNCHK
lin vitalist_N = mkWN "vitalisti" ; --UNCHK
lin vitality_N = mkWN (k39 "innostus") ; --UNCHK
lin vitalize_V2 = mkWV2 (k53A "elävöittää") ; --UNCHK
lin vitalness_N = mkWN (k40 "elintärkeys") ; --UNCHK
lin vitamin_N = mkWN (k5 "vitamiini") ; --UNCHK
lin vitiate_V2 = mkWV2 (k62 "mitätöidä") ; --UNCHK
lin vitiation_N = mkWN (k5A "mitätöinti") ; --UNCHK
lin viticulture_N = mkWN (compoundN "viinin" (k2 "viljely")) ; --UNCHK
lin viticulturist_N = mkWN (compoundN "viinin" (k12 "viljelijä")) ; --UNCHK
lin vitiliginous_A = mkWA "valkopälvi-" ; --UNCHK
lin vitiligo_N = mkWN (compoundN "valko" (k7 "pälvi")) ; --UNCHK
lin vitreous_A = mkWA (k38 "lasimainen") ; --UNCHK
lin vitrification_N = mkWN (compoundN "muu" (k38 "ttuminen")) "lasiksi" ; --UNCHK
lin vitrify_V = mkWV (k52A "lasittua") ; --UNCHK
lin vitrify_V2 = mkWV2 (k52A "lasittua") ; --UNCHK
lin vitriol_N = mkWN (k40 "katkeruus") ; --UNCHK
lin vitriolic_A = mkWA "erittäin" "syövyttävä" ; --UNCHK
lin vituperate_V2 = mkWV2 (k67A "panetella") ; --UNCHK
lin vituperation_N = mkWN (k40 "katkeruus") ; --UNCHK
lin vituperative_A = mkWA (k10 "musertava") ; --UNCHK
lin viva_N = mkWN (k5A "tentti") "suullinen" ; --UNCHK
lin viva_voce_Adv = mkWAdv (k99 "suullisesti") ; --UNCHK
lin viva_voce_N = mkWN (k5A "tentti") "suullinen" ; --UNCHK
lin vivace_A = mkWA (k10 "eloisa") ; --UNCHK
lin vivace_Adv = mkWAdv (k99 "vilkkaasti") ; --UNCHK
lin vivacious_A = mkWA (k15 "pirteä") ; --UNCHK
lin vivacity_N = mkWN (k40 "pirteys") ; --UNCHK
lin vivarium_N = mkWN (k3 "terraario") ; --UNCHK
lin vivian_PN = foreignPN "Vivian" ;
lin vivid_A = mkWA (k41A "kirkas") ; --UNCHK
lin vividness_N = mkWN (compoundN "väri" (k40 "kylläisyys")) ; --UNCHK
lin vivification_N = mkWN "virkistäminen" ; --UNCHK
lin viviparous_A = mkWA (k38 "vivipaarinen") ; --UNCHK
lin vivisect_V2 = mkWV2 (k53A "suorittaa") "vivisektio" ; --UNCHK
lin vivisection_N = mkWN (k3 "vivisektio") ; --UNCHK
lin vivisectionist_N = mkWN (k5 "biologi") "vivisektion" "suorittava" ; --UNCHK
lin vixen_N = mkWN (compoundN "naaras" (k1A "kettu")) ; --UNCHK
lin vixenish_A = mkWA (k38 "kiukkuinen") ; --UNCHK
lin vizier_N = mkWN (kH1 "visiiri") ; --UNCHK
lin viziership_N = mkWN (k10 "asema") "visiirin" ; --UNCHK
lin vizsla_N = mkWN "unkarinvizsla" ; --UNCHK
lin vocable_N = mkWN (k9 "sana") "puhuttu" ; --UNCHK
lin vocabulary_N = mkWN (k2 "sanasto") "mentaalinen" ; --UNCHK
lin vocal_A = mkWA "ääni-" ; --UNCHK
lin vocalic_A = mkWA (compoundA "voka" (k38 "alinen")) ; --UNCHK
lin vocalist_N = mkWN (k5 "vokalisti") ; --UNCHK
lin vocalize_V2 = mkWV2 (k54A "ääntää") ; --UNCHK
lin vocation_N = mkWN (k5A "ammatti") ; --UNCHK
lin vocational_A = mkWA (k38 "ammatillinen") ; --UNCHK
lin vocative_A = mkWA "vokatiivi-" ; --UNCHK
lin vocative_N = mkWN "vokatiivi" ; --UNCHK
lin vociferate_V = mkWV (k54A "huutaa") ; --UNCHK
lin vociferate_V2 = mkWV2 (k54A "huutaa") ; --UNCHK
lin vociferation_N = mkWN (k2 "karjaisu") ; --UNCHK
lin vociferator_N = mkWN (k10 "puhuja") "kovaääninen" ; --UNCHK
lin vociferous_A = mkWA (k10 "meluisa") ; --UNCHK
lin vodka_N = mkWN (k10 "votka") ; --UNCHK
lin vogue_N = mkWN (k39 "villitys") ; --UNCHK
lin voice_N = mkN "ääni" ;
lin voice_V2 = mkWV2 (k66 "ilmaista") ;
lin voiceless_A = mkWA (k34A "kansalaisuudeton") ; --UNCHK
lin voicelessness_N = mkWN (k40 "äänettömyys") ; --UNCHK
lin voiceprint_N = mkWN (compoundN "ääni" (k7A "jälki")) ; --UNCHK
lin voicer_N = mkWN (k10 "puhuja") ; --UNCHK
lin voicing_N = mkWN (k39 "viritys") "urkupillien" ; --UNCHK
lin void_A = mkWA (k10 "tyhjä") ; --UNCHK
lin void_N = mkWN (k3 "tyhjiö") ; --UNCHK
lin void_V2 = mkWV2 (k53A "erittää") ; --UNCHK
lin voider_N = mkWN (compoundN "pyykki" (k5 "kori")) ; --UNCHK
lin voile_N = mkWN (k20 "voilee") ; --UNCHK
lin volatile_A = mkA "liikkuva" ;
lin volatile_N = mkWN (k48 "aine") "haihtuva" ; --UNCHK
lin volatility_N = mkN "liikkuvuus" ;
lin volcanic_A = mkWA (k38 "vulkaaninen") ; --UNCHK
lin volcanism_N = mkWN (compoundN "vulkan" (k5 "ismi")) ; --UNCHK
lin volcano_N = mkWN (k10 "kanava") "tulivuoren" ; --UNCHK
lin volcanology_N = mkWN (k12 "vulkanologia") ; --UNCHK
lin vole_N = mkWN (compoundN "pelto" (k10 "myyrä")) ; --UNCHK
lin volgograd_PN = foreignPN "Volgograd" ;
lin volition_N = mkWN (k1A "tahto") ; --UNCHK
lin volitional_A = mkWA (compoundA "tahdon" (k38 "alainen")) ; --UNCHK
lin volley_N = mkWN (compoundN "lento" (k5A "lyönti")) ; --UNCHK
lin volley_V = mkWV (k53A "ryöpsäyttää") ; --UNCHK
lin volley_V2 = mkWV2 (k53A "ryöpsäyttää") ; --UNCHK
lin volleyball_N = mkWN (compoundN "lento" (k1 "pallo")) ; --UNCHK
lin volt_N = mkWN (kH1 "voltti") ; --UNCHK
lin voltage_N = mkWN (k48A "jännite") ; --UNCHK
lin voltaic_A = mkWA (k38 "galvaaninen") ; --UNCHK
lin voltmeter_N = mkWN (compoundN "voltti" (k6 "mittari")) ; --UNCHK
lin volubility_N = mkWN (k40 "sujuvuus") ; --UNCHK
lin voluble_A = mkWA (compoundA "vuolas" (k38 "sanainen")) ; --UNCHK
lin volume_N = mkN "volyymi" ;
lin volumed_A = mkWA (compoundA "osa" (k38 "inen")) ; --UNCHK
lin volumeter_N = mkWN (compoundN "tilavuus" (k6 "mittari")) ; --UNCHK
lin volumetric_A = mkWA (compoundA "voly" (k38 "metrinen")) ; --UNCHK
lin voluminous_A = mkWA (k10 "mittava") ; --UNCHK
lin voluntary_A = mkA "vapaaehtoinen" ;
lin voluntary_N = mkWN (compoundN "urku" (k1 "soolo")) ; --UNCHK
lin volunteerFem_N = mkWN (compoundN "ten" (k38 "nesseeläinen")) ; --UNCHK
lin volunteerMasc_N = variants {} ; --
lin volunteer_V = mkWV (k52A "kertoa") "vapaaehtoisesti" ; --UNCHK
lin volunteer_V2 = mkWV2 (k52A "kertoa") "vapaaehtoisesti" ; --UNCHK
lin voluptuary_N = mkWN (k12 "nautiskelija") ; --UNCHK
lin voluptuous_A = mkWA (k38 "aistillinen") ; --UNCHK
lin voluptuousness_N = mkWN (k40 "uhkeus") ; --UNCHK
lin volute_N = mkWN (k6 "spiraali") ; --UNCHK
lin voluted_A = mkWA (k38 "kierteinen") ; --UNCHK
lin volution_N = mkWN (k48A "kierre") ; --UNCHK
lin volva_N = mkWN "volva" ; --UNCHK
lin volvulus_N = mkWN (compoundN "suolen" (k10 "kiertymä")) ; --UNCHK
lin vomit_N = mkWN (compoundN "yrjö" (k38 "äminen")) ; --UNCHK
lin vomit_V = L.vomit_V ;
lin vomit_V2 = mkWV2 (k53A "heittää") "laattaa" ; --UNCHK
lin vomiter_N = mkWN "oksentaja" ; --UNCHK
lin vomitory_N = mkWN (compoundN "sisään" (k5A "käynti")) ; --UNCHK
lin voodoo_N = mkWN (k5 "fetissi") ; --UNCHK
lin voodooism_N = mkWN (k20 "voodoo") ; --UNCHK
lin voracious_A = mkWA (k34A "kyltymätön") ; --UNCHK
lin voracity_N = mkWN (k40 "ahnaus") ; --UNCHK
lin voronezh_PN = foreignPN "Voronež" ;
lin vortex_N = mkWN (k48A "pyörre") ; --UNCHK
lin vorticella_N = mkWN "vorticella" ; --UNCHK
lin votary_N = mkWN (k10 "seuraaja") ; --UNCHK
lin vote_N = mkWN (k39 "äänestys") ;
lin vote_V = mkWV (k53 "äänestää") ; --f109
lin vote_V2 = mkWV2 (k53 "äänestää") ; --UNCHK
lin vote_V3 = mkV3 (mkV "äänestää") accusative (mkPrep translative) ;
lin vote_VS = mkWVS (k53 "äänestää") ; --UNCHK
lin vote_VV = mkWVV (k53 "äänestää") ; ---???
lin vote_down_V = mkWV (k53 "äänestää") "kumoon" ; --UNCHK
lin voteless_A = mkWA (k34A "kansalaisuudeton") ; --UNCHK
lin voter_N = mkWN (k10 "äänestäjä") ; --f70
lin votive_A = mkWA "votiivi-" ; --UNCHK
lin vouch_V = mkWV (k53A "vakuuttaa") ; --UNCHK
lin vouchee_N = mkWN (k10 "todistaja") ; --UNCHK
lin voucher_1_N = mkWN (k5A "kuponki") ; --UNCHK
lin voucher_2_N = mkWN (k5A "kuponki") ; --UNCHK
lin vouchsafe_V2 = mkWV2 (k61 "sallia") ; --UNCHK
lin vouge_N = mkWN "vouge" ; --UNCHK
lin voussoir_N = mkWN (compoundN "holvi" (k7 "kivi")) ; --UNCHK
lin vow_N = mkWN (k39 "vakuutus") ; --UNCHK
lin vow_V2 = mkWV2 (k53A "vakuuttaa") ; --UNCHK
lin vow_VS = mkWVS (k53A "vakuuttaa") ; --UNCHK
lin vow_VV = mkWVV (k53A "vakuuttaa") ; ---???
lin vowel_N = mkWN (k6 "vokaali") ; --UNCHK
lin vowellike_A = mkWA (compoundA "vokaali" (k38 "mainen")) ; --UNCHK
lin vower_N = mkWN (compoundN "van" (k10 "noja")) ; --UNCHK
lin vox_N = mkWN (k1A "ääntö") ; --UNCHK
lin vox_populi_N = mkWN (k48A "mielipide") ; --UNCHK
lin voyage_N = mkWN (k9 "matka") ; --UNCHK
lin voyage_V = mkWV (k73 "seilata") ; --UNCHK
lin voyager_N = mkWN (k10 "matkaaja") ; --UNCHK
lin voyeur_N = mkWN (k5 "voyeuristi") ; --UNCHK
lin voyeurism_N = mkWN (k5 "voyeurismi") ; --UNCHK
lin voyeuristic_A = mkWA (compoundA "tirkiste" (k10 "levä")) ; --UNCHK
lin vroom_N = mkWN "vroom" ; --UNCHK
lin vs_Prep = mkPrep "vs" nominative ;
lin vulcanite_N = mkWN (k5A "eboniitti") ; --UNCHK
lin vulcanization_N = mkWN (k5A "vulkanointi") ; --UNCHK
lin vulcanize_V2 = mkWV2 (k52A "vulkanoitua") ; --UNCHK
lin vulcanizer_N = mkWN "vulkanoija" ; --UNCHK
lin vulgar_A = mkWA (kH1 "raaka") ; --UNCHK
lin vulgarian_N = mkWN (k38 "ihminen") "vulgaari" ; --UNCHK
lin vulgarism_N = mkWN (k40 "rivous") ; --UNCHK
lin vulgarity_N = mkWN (k40 "rivous") ; --UNCHK
lin vulgarization_N = mkWN (compoundN "populari" (k5A "sointi")) ; --UNCHK
lin vulgarize_V2 = mkWV2 (k52A "käyttäytyä") "vulgaaristi" ; --UNCHK
lin vulgarizer_N = mkWN (compoundN "populari" (k10 "soija")) ; --UNCHK
lin vulgate_N = mkWN "Vulgata" ; --UNCHK
lin vulnerability_N = mkWN (k40 "haavoittuvuus") ; --UNCHK
lin vulnerable_A = mkWA (k34A "suojaton") ;
lin vulpine_A = mkWA (k38 "kettumainen") ; --UNCHK
lin vulture_N = mkWN (compoundN "haaska" (k1A "lintu")) ; --UNCHK
lin vulva_N = mkWN (k1A "häpy") ; --UNCHK
lin vulvar_A = mkWA "häpy-" ; --UNCHK
lin vulvitis_N = mkWN (k39 "tulehdus") "ulkosynnyttimien" ; --UNCHK
lin vulvovaginitis_N = mkWN (compoundN "vulvovagi" (k5A "niitti")) ; --UNCHK
lin vuokatti_PN = mkPN (mkN "Vuokatti" "Vuokattia") ;
lin vuolijoki_PN = mkPN (mkN "Vuolijoki" "Vuolijokia") ;
lin vähäkyrö_PN = mkPN "Vähäkyrö" ;
lin västanfjärd_PN = mkPN "Västanfjärd" ;
lin vörå_PN = mkPN "Vöyri" ;
lin wad_N = mkWN (kH1 "mälli") ; --UNCHK
lin wad_V2 = mkWV2 (k53 "tiivistää") ; --UNCHK
lin wad_VS = mkWVS (k53 "tiivistää") ; --UNCHK
lin wadding_N = mkWN (k48 "pehmuste") ; --UNCHK
lin waddle_N = mkWN "taaperrus" ; --UNCHK
lin waddle_V = mkWV (k52A "vaappua") ; --UNCHK
lin waddler_N = mkWN "taapertaja" ; --UNCHK
lin wade_V = mkWV (k52A "tarpoa") ; --UNCHK
lin wade_V2 = mkWV2 (k52A "tarpoa") ; --UNCHK
lin wader_N = mkWN (k10 "kahlaaja") ; --UNCHK
lin wadi_N = mkWN (k5 "vadi") ; --UNCHK
lin wading_N = mkWN "kahlailu" ; --UNCHK
lin wafer_N = mkWN (k5A "öylätti") ; --UNCHK
lin waffle_N = mkWN (k6 "vohveli") ; --UNCHK
lin waffle_V = mkWV (k67 "aikailla") ; --UNCHK
lin waffle_V2 = mkWV2 (k67 "aikailla") ; --UNCHK
lin waffler_N = mkWN "jahkailija" ; --UNCHK
lin waft_N = mkWN (k5 "viiri") ; --UNCHK
lin waft_V2 = mkWV2 (k52 "leijua") ; --UNCHK
lin wag_N = mkWN (k39 "pudistus") ; --UNCHK
lin wag_V = mkWV (k53A "huiskuttaa") ; --UNCHK
lin wag_V2 = mkWV2 (k53A "huiskuttaa") ; --UNCHK
lin wage_N = mkN "palkka" ;
lin wage_V2 = mkWV2 (k52A "ryhtyä") ; --UNCHK
lin wage_claim_N = mkWN (compoundN "palkka" (k39 "vaatimus")) ; --UNCHK
lin wage_earner_N = mkWN (compoundN "palkan" (k10 "saaja")) ; --UNCHK
lin wage_freeze_N = mkWN (k39 "jäädytys") "palkkojen" ; --UNCHK
lin wager_N = mkWN (k39 "veikkaus") ; --UNCHK
lin wager_V = mkWV (k73A "veikata") ; --UNCHK
lin wager_V2 = mkWV2 (k73A "veikata") ; --UNCHK
lin wages_N = mkWN (k1A "palkinto") ; --UNCHK
lin waggery_N = mkWN (k9 "pila") ; --UNCHK
lin waggish_A = mkWA (k38 "veitikkamainen") ; --UNCHK
lin waggishness_N = mkWN (k40 "veitikkamaisuus") ; --UNCHK
lin waggle_V = mkWV (k53A "vipattaa") ; --UNCHK
lin waggle_V2 = mkWV2 (k53A "vipattaa") ; --UNCHK
lin waggon_N = mkWN (k6 "farmari") ; --UNCHK
lin waggoner_N = mkWN (k10 "ajaja") "rattaiden" ; --UNCHK
lin wagon_N = mkWN (k6 "farmari") ; --UNCHK
lin wagoner_N = mkWN (k10 "ajaja") "rattaiden" ; --UNCHK
lin wagonwright_N = mkWN (compoundN "kärryjen" (k12 "tekijä")) ; --UNCHK
lin wagtail_N = mkWN (k5A "västäräkki") ; --UNCHK
lin wahoo_N = mkWN (compoundN "raita" (k5 "makrilli")) ; --UNCHK
lin waif_N = mkWN (compoundN "katu" (k29 "lapsi")) ; --UNCHK
lin wail_N = mkWN (k12 "ulina") ; --UNCHK
lin wail_V = mkWV (k66 "vikistä") ; --UNCHK
lin wail_V2 = mkWV2 (k66 "vikistä") ; --UNCHK
lin wailer_N = mkWN "vaikertaja" ; --UNCHK
lin wailing_N = mkWN (k1A "huuto") ; --UNCHK
lin wainscot_N = mkWN (k5A "panelointi") ; --UNCHK
lin wainscoted_A = mkWA (compoundA "panelo" (k1A "itu")) ; --UNCHK
lin wainscoting_N = mkWN (k5A "panelointi") ; --UNCHK
lin waist_N = mkWN (k39 "kavennus") ; --UNCHK
lin waistband_N = mkWN (k19 "vyö") ; --UNCHK
lin waistcoat_N = mkWN (kH1 "liivi") ; --UNCHK
lin waistline_N = mkWN (k2 "vyötärö") ; --UNCHK
lin wait_N = mkWN (k39 "odotus") ; --UNCHK
lin wait_V = mkV "odottaa" ;
lin wait_V2 = L.wait_V2 ;
lin wait_VV = mkVV "valmistautua" infIllat ;
lin wait_about_V = advV OP_wait_V OP_about_Adv ; -- guess-p-verb
lin wait_around_V = advV OP_wait_V OP_around_Adv ; -- guess-p-verb
lin wait_behind_V = advV OP_wait_V OP_behind_Adv ; -- guess-p-verb
lin wait_in_V = advV OP_wait_V OP_in_Adv ; -- guess-p-verb
lin wait_on_V2 = mkWV2 (k53 "avustaa") ; --UNCHK
lin wait_out_V2 = prepV2 OP_wait_V OP_out_Prep ; -- guess-p-verb
lin wait_up_V = advV OP_wait_V OP_up_Adv ; -- guess-p-verb
lin wait_up_for_V2 = prepV2 (advV OP_wait_V OP_up_Adv ) OP_for_Prep ; -- guess-p-verb
lin wait_upon_V2 = prepV2 OP_wait_V OP_upon_Prep ; -- guess-p-verb
lin waiter_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin waiting_A = mkA "odottava" ;
lin waiting_N = mkN "odotus" ;
lin waiting_list_N = mkWN (compoundN "jonotus" (k9 "lista")) ; --UNCHK
lin waiting_room_N = mkWN (k9 "aula") ; --UNCHK
lin waitress_N = mkWN (k12 "tarjoilija") ; --UNCHK
lin waive_V2 = mkWV2 (k52A "pidättyä") ; --UNCHK
lin waiver_N = mkWN (k39 "luovutus") ; --UNCHK
lin wake_N = mkN "herääminen" ;
lin wake_V = mkV "herättää" ;
lin wake_V2 = mkWV2 (k52A "havahtua") ; --UNCHK
lin wake_up_V = mkWV (k52A "havahtua") ; --UNCHK
lin wake_up_V2 = mkWV2 (k52A "havahtua") ; --UNCHK
lin wakefield_PN = foreignPN "Wakefield" ;
lin wakeful_A = mkWA (k99 "varuillaan") ; --UNCHK
lin wakefulness_N = mkWN (compoundN "hereillä" (k1 "olo")) ; --UNCHK
lin waken_V = mkWV (k52A "havahtua") ; --UNCHK
lin waken_V2 = mkWV2 (k52A "havahtua") ; --UNCHK
lin waker_N = mkWN "herääjä" ; --UNCHK
lin waking_N = mkWN (compoundN "valveilla" (k1 "olo")) ; --UNCHK
lin wale_N = mkWN (k39 "laidoitus") ; --UNCHK
lin wales_PN = foreignPN "Wales" ;
lin walk_N = mkWN (k50 "vapaataival") ; --UNCHK
lin walk_V = L.walk_V ;
lin walk_V2 = mkV2 "kävelyttää" partitive ; --mkWV2 (k63 "saada") "piste" ;
lin walk_away_from_V2 = prepV2 (advV OP_walk_V OP_away_Adv ) OP_from_Prep ; -- guess-p-verb
lin walk_away_with_V2 = prepV2 (advV OP_walk_V OP_away_Adv ) OP_with_Prep ; -- guess-p-verb
lin walk_back_from_V2 = prepV2 (advV OP_walk_V OP_back_Adv ) OP_from_Prep ; -- guess-p-verb
lin walk_by_V = advV OP_walk_V OP_by_Adv ; -- guess-p-verb
lin walk_in_V = mkWV (k67 "kävellä") "sisään" ; --UNCHK
lin walk_in_on_V2 = prepV2 (advV OP_walk_V OP_in_Adv ) OP_on_Prep ; -- guess-p-verb
lin walk_into_V2 = prepV2 OP_walk_V OP_into_Prep ; -- guess-p-verb
lin walk_off_V2 = mkWV2 (k67 "kävellä") "pois" ; --UNCHK
lin walk_off_with_V2 = prepV2 (advV OP_walk_V OP_off_Adv ) OP_with_Prep ; -- guess-p-verb
lin walk_on_V = advV OP_walk_V OP_on_Adv ; -- guess-p-verb
lin walk_out_V = mkWV (k53A "jättää") ; --UNCHK
lin walk_out_on_V2 = prepV2 (advV OP_walk_V OP_out_Adv ) OP_on_Prep ; -- guess-p-verb
lin walk_through_V3 = mkWV3 (k65 "käydä") "läpi" ; --UNCHK
lin walk_up_V = advV OP_walk_V OP_up_Adv ; -- guess-p-verb
lin walkabout_N = mkWN (k39 "vaellus") ; --UNCHK
lin walkaway_N = mkWN (k1A "voitto") "helppo" ; --UNCHK
lin walker_N = mkWN (compoundN "kävely" (k1 "kärry")) ; --UNCHK
lin walking_A = mkA "kävelevä" ;
lin walking_N = mkWN (k2 "kävely") ; --UNCHK
lin walkout_N = mkWN (compoundN "ulos" (k5 "marssi")) ;
lin walkover_N = mkWN (compoundN "silta" (k1A "kaato")) ; --UNCHK
lin wall_N = mkN "seinä" | mkN "muuri" | mkN "valli" ; ---- split
lin wall_V2 = mkWV2 (k62 "ympäröidä") ; --UNCHK
lin wall_painting_N = mkWN (k39 "seinämaalaus") ; --UNCHK
lin wallaby_N = mkWN (compoundN "vall" (k5 "abi")) ; --UNCHK
lin wallace_PN = foreignPN "Wallace" ;
lin wallah_N = mkWN (compoundN "-työn" (k12 "tekijä")) ; --UNCHK
lin wallasey_PN = foreignPN "Wallasey" ;
lin wallboard_N = mkWN (compoundN "kipsi" (k1 "levy")) ; --UNCHK
lin wallet_N = mkWN (k4A "lompakko") ; --UNCHK
lin walleye_N = mkWN (compoundN "hieta" (k10 "kuha")) ; --UNCHK
lin wall_eyed_A = mkWA "karsastava" ; --UNCHK
lin wallflower_N = mkWN (compoundN "seinä" (k38 "kukkanen")) ; --UNCHK
lin wallingford_PN = foreignPN "Wallingford" ;
lin wallop_N = mkWN "kumautus" ; --UNCHK
lin walloper_N = mkWN (compoundN "emä" (k48 "valhe")) ; --UNCHK
lin walloping_A = mkWA (k38 "jättimäinen") ; --UNCHK
lin wallow_N = mkWN "kieriminen" ; --UNCHK
lin wallow_V = mkWV (k67A "paistatella") ; --UNCHK
lin wallpaper_N = mkWN (k5A "tapetti") ; --UNCHK
lin wallpaperer_N = mkWN "tapetoija" ; --UNCHK
lin wallsend_PN = foreignPN "Wallsend" ;
lin wally_N = mkWN (k39 "typerys") ; --UNCHK
lin walnut_N = mkWN (compoundN "saksan" (k12 "pähkinä")) ; --UNCHK
lin walrus_N = mkWN (k1 "mursu") ; --UNCHK
lin walsall_PN = foreignPN "Walsall" ;
lin walton_PN = foreignPN "Walton" ;
lin waltz_N = mkWN (kH1 "valssi") ; --UNCHK
lin waltzer_N = mkWN (compoundN "valssin" (k12 "tanssija")) ; --UNCHK
lin wampum_N = mkWN "wampum" ; --UNCHK
lin wan_A = mkWA (k1 "vaisu") ; --UNCHK
lin wand_N = mkWN (compoundN "tahti" (k1A "puikko")) ; --UNCHK
lin wander_V = mkWV (k74A "poiketa") ; --UNCHK
lin wander_off_V = advV OP_wander_V OP_off_Adv ; -- guess-p-verb
lin wanderer_N = mkWN (compoundN "haku" (k5A "robotti")) ; --UNCHK
lin wandering_N = mkWN (k39 "vaellus") ; --UNCHK
lin wanderlust_N = mkWN (compoundN "vaellus" (k1 "halu")) ; --UNCHK
lin wandflower_N = mkWN (compoundN "urceo" (k9A "lata")) "Galax" ; --UNCHK
lin wandsworth_PN = foreignPN "Wandsworth" ;
lin wane_N = mkWN (k1 "lasku") ; --UNCHK
lin wane_V = mkV "vähetä" "väheni" ; --mkWV (k72A "heiketä") ;
lin wangle_N = mkWN (k26 "juoni") ; --UNCHK
lin wangle_V2 = mkWV2 (k63 "saada") "aikaan" ; --UNCHK
lin waning_N = mkWN "väheneminen" ; --UNCHK
lin wank_N = mkWN (k39 "runkkaus") ; --UNCHK
lin wank_V = mkWV (k53A "tyydyttää") "itsensä" ; --UNCHK
lin wanness_N = mkWN (k40 "hailakkuus") ; --UNCHK
lin want_N = mkN "tarve" ;
lin want_V = mkWV (k75 "haluta") ;
lin want_V2 = mkWV2 (k75 "haluta") ;
lin want_V2V = mkWV2V (k75 "haluta") ;
lin want_VV = S.want_VV ;
lin want_ad_N = mkWN (k39 "ilmoitus") "luokiteltu" ; --UNCHK
lin want_in_V = advV OP_want_V OP_in_Adv ; -- guess-p-verb
lin want_out_V = advV OP_want_V OP_out_Adv ; -- guess-p-verb
lin wantage_PN = foreignPN "Wantage" ;
lin wanter_N = mkWN "haluaja" ; --UNCHK
lin wanton_A = mkWA (k41A "rietas") ; --UNCHK
lin wanton_N = mkWN (k38 "nainen") "kevytkenkäinen" ; --UNCHK
lin wanton_V = mkWV (k67A "huikennella") ; --UNCHK
lin wantonness_N = mkWN (k40 "rivous") ; --UNCHK
lin wapiti_N = mkWN (compoundN "saksan" (k7 "hirvi")) ; --UNCHK
lin war_N = L.war_N ;
lin war_V = mkWV (k61A "sotia") ; --UNCHK
lin war_baby_N = mkWN (compoundN "sota" (k29 "lapsi")) ; --UNCHK
lin war_bride_N = mkWN (compoundN "sota" (k33 "morsian")) ; --UNCHK
lin war_cloud_N = mkWN (k5A "merkki") "sodan" ; --UNCHK
lin war_cry_N = mkWN (compoundN "isku" (k48 "lause")) ; --UNCHK
lin war_dance_N = mkWN (compoundN "sota" (k5 "tanssi")) ; --UNCHK
lin war_god_N = mkWN (k10 "jumala") "sodan" ; --UNCHK
lin war_widow_N = mkWN (compoundN "sota" (k7 "leski")) ; --UNCHK
lin waratah_N = mkWN "Telopea" "Oreades" ; --UNCHK
lin warble_N = mkWN (compoundN "eläin" (k40 "sairaus")) "toukan" "aiheuttama" ; --UNCHK
lin warble_V = mkWV (k56 "laulaa") "diskantissa" ; --UNCHK
lin warble_V2 = mkWV2 (k56 "laulaa") "diskantissa" ; --UNCHK
lin warbler_N = mkWN (k1A "kerttu") ; --UNCHK
lin ward_N = mkWN (compoundN "vanki" (k2 "osasto")) ; --UNCHK
lin ward_V2 = mkWV2 (k73 "suojata") ; --UNCHK
lin ward_off_V = mkWV (k53 "vastustaa") ; --UNCHK
lin warden_N = mkWN (compoundN "vankilan" (k10 "johtaja")) ; --UNCHK
lin wardenship_N = mkWN (k10 "asema") "vankilanjohtajan" ; --UNCHK
lin warder_N = mkWN (compoundN "vangin" (k12 "vartija")) ; --UNCHK
lin wardership_N = mkWN (k10 "asema") "vanginvartijan" ; --UNCHK
lin wardress_N = mkWN (compoundN "vangin" (k12 "vartija")) "naispuolinen" ; --UNCHK
lin wardrobe_N = mkWN (k2 "komero") ; --UNCHK
lin wardroom_N = mkWN (k5 "messi") ; --UNCHK
lin ware_N = mkWN (k12 "tavara") ; --UNCHK
lin ware_PN = foreignPN "Ware" ;
lin ware_V2 = mkWV2 (k73 "haaskata") ; --UNCHK
lin warehouse_N = mkWN (k2 "varasto") ; --UNCHK
lin warehouser_N = mkWN (compoundN "varaston" (k10 "hoitaja")) ; --UNCHK
lin warehousing_N = mkWN (k5A "varastointi") ; --UNCHK
lin warfare_N = mkWN (k10A "sota") ; --UNCHK
lin warfarin_N = mkWN "Coumadin" ; --UNCHK
lin warhead_N = mkWN (k39 "lataus") ; --UNCHK
lin warhorse_N = mkWN (compoundN "sota" (k38 "hevonen")) ; --UNCHK
lin wariness_N = mkWN (k40 "varovaisuus") ; --UNCHK
lin warlike_A = mkWA (k38 "sotainen") ; --UNCHK
lin warlock_N = mkWN (k1 "velho") ; --UNCHK
lin warlord_N = mkWN (compoundN "sota" (k9 "herra")) ; --UNCHK
lin warm_A = L.warm_A ;
lin warm_V = mkWV (k53A "lämmittää") ; --UNCHK
lin warm_V2 = mkWV2 (k53A "lämmittää") ; --UNCHK
lin warm_up_V = mkWV (k67A "verrytellä") ; --UNCHK
lin warmer_N = mkWN (k6 "patteri") ; --UNCHK
lin warm_hearted_A = mkWA (compoundA "lämmin" (k38 "sydäminen")) ; --UNCHK
lin warmheartedness_N = mkWN (k1A "lämpö") ; --UNCHK
lin warming_pan_N = mkWN (compoundN "lämmitys" (k1 "pannu")) ; --UNCHK
lin warminster_PN = foreignPN "Warminster" ;
lin warmonger_N = mkWN (k5 "militaristi") ; --UNCHK
lin warmongering_N = mkWN (compoundN "sota" (k2 "intoilu")) ; --UNCHK
lin warmth_N = mkWN (k1A "lämpö") ; --UNCHK
lin warn_V = mkWV (k53A "varoittaa") ;
lin warn_V2 = mkV2 "varoittaa" partitive ;
lin warn_V2V = mkV2V (mkV "varoittaa") partitive infElat ;
lin warn_VS = mkWVS (k53A "varoittaa") ;
lin warner_N = mkWN "varoittaja" ; --UNCHK
lin warning_N = mkN "varoitus" ;
lin warp_N = mkWN (k25 "loimi") ; --UNCHK
lin warp_V = mkWV (k52A "vääntyä") ; --UNCHK
lin warp_V2 = mkWV2 (k52A "vääntyä") ; --UNCHK
lin warpath_N = mkWN (k1 "olo") "sotajalalla" ; --UNCHK
lin warplane_N = mkWN (compoundN "sota" (k48 "kone")) ; --UNCHK
lin warrant_N = mkWN (k39 "oikeutus") ; --f86
lin warrant_V2 = mkV2 "oikeuttaa" ; --mkWV2 (k53A "vakuuttaa") ;
lin warrant_VS = mkWVS (k53A "vakuuttaa") ; --UNCHK
lin warrantee_N = mkWN (k17 "takuu") ; --UNCHK
lin warrantor_N = mkWN (k10 "takaaja") ; --UNCHK
lin warranty_N = mkWN (k17 "takuu") ;
lin warren_N = mkWN "kaniiniyhdyskunta" ; --UNCHK
lin warrener_N = mkWN (compoundN "yllä" (k10 "pitäjä")) "kaniiniyhdyskunnan" ; --UNCHK
lin warrigal_N = mkWN (compoundN "villi" (k10 "koira")) ; --UNCHK
lin warrington_PN = foreignPN "Warrington" ;
lin warrior_N = mkWN (k12 "taistelija") ; --UNCHK
lin warsaw_PN = foreignPN "Varsova" ;
lin warship_N = mkWN (compoundN "taistelu" (k9 "laiva")) ; --UNCHK
lin warsop_PN = foreignPN "Warsop" ;
lin wart_N = mkWN (k10 "syylä") ; --UNCHK
lin warthog_N = mkWN (compoundN "pahka" (k9A "sika")) ; --UNCHK
lin wartime_N = mkWN (k9A "sota-aika") ; --UNCHK
lin warwick_PN = foreignPN "Warwick" ;
lin wary_A = mkWA (compoundA "epäluu" (k38 "loinen")) ; --UNCHK
lin wasabi_N = mkWN (compoundN "mauste" (k5 "krassi")) ; --UNCHK
lin wash_N = mkWN (k1 "pesu") ; --UNCHK
lin wash_V = mkWV (k53 "puhdistaa") "nuolemalla" ; --UNCHK
lin wash_V2 = L.wash_V2 ;
lin wash_away_V2 = mkWV2 (k52A "huuhtoa") "pois" ; --UNCHK
lin wash_down_V2 = mkWV2 (k52A "huuhtoutua") ; --UNCHK
lin wash_drawing_N = mkWN (k39 "vesivärimaalaus") ; --UNCHK
lin wash_leather_N = mkWN (k13 "säämiskä") ; --UNCHK
lin wash_out_V2 = prepV2 OP_wash_V OP_out_Prep ; -- guess-p-verb
lin wash_over_V2 = prepV2 OP_wash_V OP_over_Prep ; -- guess-p-verb
lin wash_up_V = mkWV (k66 "pestä") ; --UNCHK
lin wash_up_V2 = mkWV2 (k66 "pestä") ; --UNCHK
lin washable_A = mkWA "pestävä" ; --UNCHK
lin washbasin_N = mkWN (k5 "lavuaari") ; --UNCHK
lin washboard_N = mkWN (k10 "roiskesuoja") ; --UNCHK
lin washbowl_N = mkWN (k5 "lavuaari") ; --UNCHK
lin washcloth_N = mkWN (compoundN "pesu" (k1A "lappu")) ; --UNCHK
lin washday_N = mkWN (compoundN "pyykki" (k10 "päivä")) ; --UNCHK
lin washer_N = mkWN (k6 "pesuri") ; --UNCHK
lin washerman_N = mkWN (kH1 "pesijä") ; --UNCHK
lin washerwoman_N = mkWN (k12 "pyykinpesijä") ; --UNCHK
lin wash_house_N = mkWN (k12 "pesula") ; --UNCHK
lin washing_N = mkWN (k1 "pesu") ; --UNCHK
lin washing_day_N = mkWN (compoundN "pyykki" (k10 "päivä")) ; --UNCHK
lin washing_machine_N = mkWN (k6 "pesuri") ; --UNCHK
lin washington_PN = foreignPN "Washington" ;
lin washout_N = mkWN (k6 "tunari") ; --UNCHK
lin washroom_N = mkWN (k99 "WC") ; --UNCHK
lin washstand_N = mkWN (k41A "allas") ; --UNCHK
lin washtub_N = mkWN (compoundN "pesu" (k1A "soikko")) ; --UNCHK
lin washup_N = mkWN "peseytyminen" ; --UNCHK
lin washy_A = mkWA (k15 "haalea") ; --UNCHK
lin wasp_N = mkWN (k38 "ampiainen") ; --UNCHK
lin waspish_A = mkWA (k41 "pisteliäs") ; --UNCHK
lin wassail_N = mkWN (k5 "glögi") ; --UNCHK
lin wassailer_N = mkWN (compoundN "maljan" (k10 "kohottaja")) ; --UNCHK
lin wastage_N = mkWN (k5A "hävikki") ; --UNCHK
lin waste_A = mkA "hyödytön" ;
lin waste_N = mkWN (k10A "hukka") ;
lin waste_V = mkWV (k52 "virua") ; --UNCHK
lin waste_V2 = mkWV2 (k52 "virua") ; --UNCHK
lin waste_away_V = advV OP_waste_V OP_away_Adv ; -- guess-p-verb
lin waste_pipe_N = mkWN (k6 "viemäri") ; --UNCHK
lin wastebasket_N = mkWN (compoundN "roska" (k5 "kori")) ; --UNCHK
lin wastebin_N = mkWN (k39 "roskis") ; --UNCHK
lin wasteful_A = mkWA (compoundA "tuh" (k9 "laava")) ; --UNCHK
lin wasteland_N = mkWN (k18 "maa") "hedelmätön" ; --UNCHK
lin waster_N = mkWN (k10 "hävittäjä") ; --UNCHK
lin wastrel_N = mkWN (k6 "tuhlari") ; --UNCHK
lin watch_1_V2 = mkV2 "katsella" partitive | mkV2 "katsoa" partitive ;
lin watch_2_V2 = mkV2 "vartioida" partitive ;
lin watch_N = mkWN (k5A "vahti") ; --UNCHK
lin watch_V = mkV "katsella" ;
lin watch_V2 = L.watch_V2 ;
lin watch_V2V = mkV2V (mkV "katsoa") (mkPrep genitive) infPresPart | mkV2V (mkV "katsella") (mkPrep partitive) infIness ;
lin watch_VS = mkVS "katsoa" | mkVS "seurata" ;
lin watch_glass_N = mkWN (compoundN "kellon" (k5 "lasi")) ; --UNCHK
lin watch_key_N = mkWN (compoundN "veto" (k5A "nuppi")) "kellon" ; --UNCHK
lin watch_out_V = mkWV (k67 "olla") "varuillaan" ; --UNCHK
lin watch_out_for_V2 = prepV2 (advV OP_watch_V OP_out_Adv ) OP_for_Prep ; -- guess-p-verb
lin watch_over_V2 = mkWV2 (k52 "valvoa") ; --UNCHK
lin watchband_N = mkWN (k48A "ranneke") "kellon" ; --UNCHK
lin watchdog_N = mkWN (compoundN "vahti" (k10 "koira")) ; --UNCHK
lin watcherFem_N = mkWN (k12 "tarkkailija") ; --UNCHK
lin watcherMasc_N = mkWN (k12 "tarkkailija") ; --UNCHK
lin watchful_A = mkWA (k15 "virkeä") ; --UNCHK
lin watchfulness_N = mkWN (k40 "valppaus") ; --UNCHK
lin watchmaker_N = mkWN (compoundN "kello" (k10A "seppä")) ; --UNCHK
lin watchman_N = mkWN (k12 "vartija") ; --UNCHK
lin watchtower_N = mkWN (compoundN "vartio" (k5 "torni")) ; --UNCHK
lin watchword_N = mkWN (k9 "sana") ; --UNCHK
lin water_N = L.water_N ;
lin water_V = mkV (mkV "vuotaa") "vettä" ; ---ARB
lin water_V2 = mkV2 "kastella" ;
lin water_biscuit_N = mkWN (k5 "voileipäkeksi") ; --UNCHK
lin water_blister_N = mkWN (compoundN "vesi" (k1A "rakko")) ; --UNCHK
lin water_bottle_N = mkWN (compoundN "vesi" (k1 "pullo")) ; --UNCHK
lin water_buffalo_N = mkWN (compoundN "vesi" (k6 "puhveli")) ; --UNCHK
lin water_butt_N = mkWN (compoundN "sadevesi" (k6 "tynnyri")) ; --UNCHK
lin water_cart_N = mkWN (compoundN "vesi" (k1 "kärry")) ; --UNCHK
lin water_closet_N = mkWN (k5 "veski") ; --UNCHK
lin water_down_V2 = mkWV2 (k53A "vesittää") ; --UNCHK
lin water_finder_N = mkWN (compoundN "taika" (k1A "varpu")) ; --UNCHK
lin water_glass_N = mkWN (compoundN "vesi" (k1 "kello")) ; --UNCHK
lin water_hole_N = mkWN (k4A "lammikko") ; --UNCHK
lin water_ice_N = mkWN (k48A "jäädyke") ; --UNCHK
lin water_jacket_N = mkWN (compoundN "vesi" (k9A "vaippa")) ; --UNCHK
lin water_level_N = mkWN (compoundN "vesi" (k9A "vaaka")) ; --UNCHK
lin water_lily_N = mkWN (compoundN "lumme" (k5 "kasvi")) ; --UNCHK
lin water_line_N = mkWN (k9 "vesiraja") ; --UNCHK
lin water_main_N = mkWN "päävesijohto" ; --UNCHK
lin water_nymph_N = mkWN (k32A "aallotar") ; --UNCHK
lin water_polo_N = mkWN (compoundN "vesi" (k1 "pallo")) ; --UNCHK
lin water_rat_N = mkWN (compoundN "vesi" (k10A "rotta")) ; --UNCHK
lin water_skin_N = mkWN (k5 "leili") ; --UNCHK
lin water_softener_N = mkWN (compoundN "vedenpehmennys" (k48 "aine")) ; --UNCHK
lin water_spaniel_N = mkWN (compoundN "vesi" (k5 "spanieli")) ; --UNCHK
lin water_supply_N = mkWN (k2 "vesistö") ; --UNCHK
lin water_tower_N = mkWN (compoundN "vesi" (k5 "torni")) ; --UNCHK
lin water_vole_N = mkWN (compoundN "kalliovuortenpuro" (k10 "myyrä")) ; --UNCHK
lin water_wheel_N = mkWN (compoundN "vesi" (k41A "ratas")) ; --UNCHK
lin waterbird_N = mkWN (compoundN "vesi" (k1A "lintu")) ; --UNCHK
lin waterbuck_N = mkWN (compoundN "vesi" (k5A "antilooppi")) ; --UNCHK
lin watercannon_N = mkWN (k5A "vesitykki") ; --UNCHK
lin watercolour_N = mkWN (k39 "vesivärimaalaus") ; --UNCHK
lin watercolourist_N = mkWN (k6 "vesivärimaalari") ; --UNCHK
lin watercourse_N = mkWN (k2 "vesistö") ; --UNCHK
lin watercraft_N = mkWN (k39 "alus") ; --UNCHK
lin waterer_N = mkWN (compoundN "vesi" (k10A "poika")) ; --UNCHK
lin waterfall_N = mkWN (compoundN "vesi" (k39 "putous")) ; --UNCHK
lin waterford_PN = foreignPN "Waterford" ;
lin waterfowl_N = mkWN (compoundN "vesi" (k1A "lintu")) ; --UNCHK
lin waterfront_N = mkWN (compoundN "ranta-" (k48 "alue")) ; --UNCHK
lin wateriness_N = mkWN (compoundN "vesimä" (k40 "isyys")) ; --UNCHK
lin watering_N = mkWN (k2 "kastelu") ; --UNCHK
lin watering_can_N = mkWN (compoundN "kastelu" (k1 "kannu")) ; --UNCHK
lin watering_cart_N = mkWN (compoundN "kastelu" (k1 "vaunu")) ; --UNCHK
lin waterleaf_N = mkWN (compoundN "sievikki" (k5 "kasvi")) ; --UNCHK
lin waterless_A = mkWA (k34A "vedetön") ; --UNCHK
lin waterlogged_A = mkWA (k10 "vetelä") ; --UNCHK
lin waterloo_N = mkWN (k2 "taistelu") "Waterloon" ; --UNCHK
lin waterloo_PN = foreignPN "Waterloo" ;
lin waterman_N = mkWN (k12 "purjehtija") ; --UNCHK
lin watermark_N = mkWN (compoundN "vesi" (k9 "leima")) ; --UNCHK
lin watermeal_N = mkWN "Wolffia" "columbiana" ; --UNCHK
lin watermelon_N = mkWN (compoundN "vesi" (k6 "meloni")) ; --UNCHK
lin water_power_N = mkWN (compoundN "vesi" (k10 "voima")) ; --UNCHK
lin waterproof_N = mkWN (compoundN "d-kloro" (k5 "fylli")) ; --UNCHK
lin waterproof_V2 = mkWV2 (k67A "käsitellä") "vedenkestäväksi" ; --UNCHK
lin waterproofing_N = mkWN (compoundN "tii" (k38 "vistäminen")) ; --UNCHK
lin watershed_N = mkWN (k10A "käännekohta") ; --UNCHK
lin waterside_N = mkWN (k9A "ranta") ; --UNCHK
lin waterspout_N = mkWN (k5 "ränni") ; --UNCHK
lin watertight_A = mkWA (k38 "täydellinen") ; --UNCHK
lin waterway_N = mkWN (k2 "vesistö") ; --UNCHK
lin waterweed_N = mkWN (compoundN "vesi" (k1A "rutto")) ; --UNCHK
lin waterworks_N = mkWN (compoundN "vesi" (k39 "laitos")) ;
lin water_worn_A = mkWA "veden" "kuluttama" ; --UNCHK
lin watery_A = mkWA (k1A "heikko") ; --UNCHK
lin watford_PN = foreignPN "Watford" ;
lin watt_N = mkN "watti" ;
lin wattage_N = mkWN (compoundN "sähkö" (k1 "teho")) ; --UNCHK
lin wattle_N = mkWN (k39 "punos") ; --UNCHK
lin wattmeter_N = mkWN (compoundN "watti" (k6 "mittari")) ; --UNCHK
lin wave_N = mkN (lin NK {s = d01A "aalto"}) ;
lin wave_V = mkV "aaltoilla" ; --mkWV (k53A "taivuttaa") ;
lin wave_V2 = mkWV2 (k53A "taivuttaa") ; --UNCHK
lin wave_aside_V2 = mkV2 (advV OP_wave_V OP_aside_Adv ) ; -- guess-p-verb
lin wave_away_V = advV OP_wave_V OP_away_Adv ; -- guess-p-verb
lin wave_down_V2 = prepV2 OP_wave_V OP_down_Prep ; -- guess-p-verb
lin wave_off_V2 = mkWV2 (k53A "ohittaa") ; --UNCHK
lin wave_on_V2 = prepV2 OP_wave_V OP_on_Prep ; -- guess-p-verb
lin waveguide_N = mkWN (compoundN "aalto" (k1A "johto")) ; --UNCHK
lin wavelength_N = mkWN (compoundN "aallon" (k40 "pituus")) ; --UNCHK
lin waver_N = mkWN (k39 "lepatus") ; --UNCHK
lin waver_V = mkWV (k66 "väristä") ; --UNCHK
lin waverer_N = mkWN (k12 "olija") "kahden" "vaiheilla" ; --UNCHK
lin wavy_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin waw_N = mkWN "waw" ; --UNCHK
lin wax_N = mkWN (k9 "vaha") ; --UNCHK
lin wax_V = mkWV (k66 "nousta") ; --UNCHK
lin wax_V2 = mkWV2 (k66 "nousta") ; --UNCHK
lin wax_paper_N = mkWN (compoundN "vaha" (k6 "paperi")) ; --UNCHK
lin waxen_A = mkWA (compoundA "vaha" (k1 "ttu")) ; --UNCHK
lin waxflower_N = mkWN (compoundN "unifl" (k10 "ora")) "Monotropa" ; --UNCHK
lin waxiness_N = mkWN "vahamaisuus" ; --UNCHK
lin waxing_N = mkWN (k39 "vahaus") ; --UNCHK
lin waxmallow_N = mkWN (k5 "kasvi") "Malvaviscus-suvun" ; --UNCHK
lin waxwork_N = mkWN (compoundN "vaha" (k8A "nukke")) ; --UNCHK
lin waxy_A = mkWA (k41A "altis") "vaikutuksille" ; --UNCHK
lin waxycap_N = mkWN (k41A "vahakas") ; --UNCHK
lin way_1_N = mkN "tie" ;
lin way_2_N = mkN "tapa" ;
lin way_Adv = mkWAdv (k99 "paljon") ; --UNCHK
lin way_N = mkN "tie" ;
lin waybill_N = mkWN (k5A "konossementti") ; --UNCHK
lin wayfarer_N = mkWN (k38 "matkalainen") ; --UNCHK
lin wayfaring_A = mkWA "vaeltava" ; --UNCHK
lin wayfaring_N = mkWN (k39 "vaellus") ; --UNCHK
lin waylay_V2 = mkWV2 (k53A "odottaa") "makuulla" ; --UNCHK
lin wayne_PN = foreignPN "Wayne" ;
lin ways_N = mkWN (compoundN "vesillelasku" (k5A "ramppi")) ; --UNCHK
lin wayside_N = mkWN (compoundN "tien" (k9A "laita")) ; --UNCHK
lin wayward_A = mkWA (k34A "kuriton") ; --UNCHK
lin weFem_Pron = optProDrop S.we_Pron ;
lin we_Pron = optProDrop S.we_Pron ;
lin weak_A = mkWA (k1A "heikko") ; --f133
lin weak_kneed_A = mkA "pelokas" ;
lin weaken_V = mkWV (k72A "heiketä") ;
lin weaken_V2 = mkWV2 (k72A "heiketä") ; --UNCHK
lin weakener_N = mkWN "heikentäjä" ; --UNCHK
lin weakening_N = mkWN (compoundN "hei" (k38 "kentäminen")) ; --UNCHK
lin weakfish_N = mkWN (k1A "veltto") ; --UNCHK
lin weakling_N = mkWN (k6 "pelkuri") ; --UNCHK
lin weakly_A = mkWA (k41 "hauras") ; --UNCHK
lin weakness_N = mkWN (k40 "heikkous") ; --f77
lin weal_N = mkWN (k12 "nyppylä") ; --UNCHK
lin weald_N = mkWN (compoundN "metsä" (k18 "maa")) ; --UNCHK
lin wealth_N = mkN (lin NK {s = d40 "varallisuus"}) ;
lin wealthy_A = mkA "varakas" ;
lin wean_V2 = mkWV2 (k53A "vieroittaa") ; --UNCHK
lin weaning_N = mkWN (k39 "vieroitus") ; --UNCHK
lin weapon_N = mkWN (k48 "ase") ;
lin weaponless_A = mkWA (k34A "aseeton") ; --UNCHK
lin weaponry_N = mkWN (k39 "aseistus") ; --UNCHK
lin wear_N = mkN "kulutus" ;
lin wear_V = mkV "kulua" ;
lin wear_V2 = mkV2 "kuluttaa" | mkV2 (mkV (mkV "pitää") "päällä") partitive ; ---- split
lin wear_away_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin wear_down_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin wear_off_V = mkWV (k53A "kuluttaa") "vähiin" ; --UNCHK
lin wear_out_V = mkWV (k52A "uupua") ; --UNCHK
lin wear_out_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin wearable_A = mkWA "käytettävä" ; --UNCHK
lin wearer_N = mkWN (k10 "käyttäjä") ; --UNCHK
lin weariness_N = mkWN (k39 "väsymys") ;
lin wearisome_A = mkWA (k10 "rasittava") ; --UNCHK
lin weary_A = mkA "kulunut" ;
lin weary_V = mkWV (k52A "uupua") ; --UNCHK
lin weary_V2 = mkWV2 (k52A "uupua") ; --UNCHK
lin weasel_N = mkWN (compoundN "näätä" (k33 "eläin")) ; --UNCHK
lin weather_N = mkN "sää" ;
lin weather_V = mkWV (k61A "purjehtia") "vastatuuleen" ; --UNCHK
lin weather_V2 = mkWV2 (k61A "purjehtia") "vastatuuleen" ; --UNCHK
lin weather_bureau_N = mkWN (k39 "laitos") "Ilmatieteen" ; --UNCHK
lin weather_chart_N = mkWN (compoundN "sää" (k9A "kartta")) ; --UNCHK
lin weather_map_N = mkWN (compoundN "sää" (k9A "kartta")) ; --UNCHK
lin weather_ship_N = mkWN (compoundN "säähavainto" (k39 "alus")) ; --UNCHK
lin weather_station_N = mkWN (compoundN "sää" (k10 "asema")) ; --UNCHK
lin weather_vane_N = mkWN (compoundN "tuuli" (k5 "viiri")) ; --UNCHK
lin weatherboarding_N = mkWN (compoundN "ulko" (k9A "lauta")) ; --UNCHK
lin weathercock_N = mkWN (compoundN "tuuli" (k5 "viiri")) ; --UNCHK
lin weather_glass_N = mkWN (compoundN "ilma" (k6 "puntari")) ; --UNCHK
lin weatherliness_N = mkWN (k40 "käsiteltävyys") ; --UNCHK
lin weatherly_A = mkWA "käsiteltävä" ; --UNCHK
lin weatherman_N = mkWN (k5 "meteorologi") ; --UNCHK
lin weatherproof_A = mkWA (compoundA "sään" (k10 "kestävä")) ; --UNCHK
lin weave_N = mkWN (k39 "kudos") ; --UNCHK
lin weave_V = mkWV (k52A "kutoa") "yhteen" ; --UNCHK
lin weave_V2 = mkWV2 (k52A "kutoa") "yhteen" ; --UNCHK
lin weaverFem_N = mkWN (k10 "kutoja") ; --UNCHK ---- sense to be split
lin weaverMasc_N = mkWN (k10 "kutoja") ; --UNCHK ---- sense to be split
lin weaver_N = mkWN (k10 "kutoja") ; --UNCHK
lin weaverbird_N = mkWN (k10 "kutoja") ; --UNCHK
lin weaving_N = mkWN (k9A "kudonta") ; --UNCHK
lin web_1_N = mkN "verkko" ;
lin web_2_N = mkWN (k1A "verkko") ; --UNCHK ---- sense to be split
lin web_N = mkWN (k1A "verkko") ; --UNCHK
lin webbed_A = mkWA "räpylä-" ; --UNCHK
lin webbing_N = mkWN (compoundN "nauha" (k39 "kudos")) ; --UNCHK
lin webcam_N = mkWN (compoundN "verkko" (k12 "kamera")) ; --UNCHK
lin webfoot_N = mkWN (compoundN "räpylä" (k9A "jalka")) ; --UNCHK
lin webmaster_N = mkWN (compoundN "yllä" (k10 "pitäjä")) "sivuston" ; --UNCHK
lin webpage_N = mkN "verkkosivu" ;
lin website_N = mkN "verkkosivu" ;
lin webworm_N = mkWN (compoundN "perhosen" (k10A "toukka")) ; --UNCHK
lin wed_A = mkWA "naitu" ; --UNCHK
lin wed_V2 = mkV2 (mkV "avioitua") (mkPrep "kanssa") ;
lin wedding_N = mkN "vihkiminen" ;
lin wedding_cake_N = mkWN (compoundN "morsius" (k1A "kakku")) ; --UNCHK
lin wedding_ring_N = mkWN (compoundN "vihki" (k39 "sormus")) ; --UNCHK
lin wedge_N = mkWN (k9 "kiila") ; --UNCHK
lin wedge_V = mkWV (k52A "työntyä") ; --UNCHK
lin wedge_V2 = mkWV2 (k52A "työntyä") ; --UNCHK
lin wedgie_N = mkWN (compoundN "kiilakorko" (k10A "kenkä")) ; --UNCHK
lin wedlock_N = mkWN (k48A "suhde") "aviollinen" ; --UNCHK
lin wee_A = mkWA (k38 "pikkuinen") ;
lin wee_N = mkWN (k9 "pissa") ;
lin wee_V = mkWV (k73 "pissata") ;
lin weed_N = mkN "rikkaruoho" | mkWN (k7 "pilvi") ;
lin weed_V = mkWV (k58 "kitkeä") ;
lin weed_V2 = mkWV2 (k58 "kitkeä") ;
lin weed_out_V2 = mkV2 "karsia" ;
lin weeder_N = mkWN "kitkijä" ; --UNCHK
lin weedkiller_N = mkWN (compoundN "kasvi" (k1A "myrkky")) ; --UNCHK
lin weedless_A = mkWA "rikkaruohoton" ; --UNCHK
lin weeds_N = mkWN (compoundN "suru" (k1A "puku")) "lesken" ; --UNCHK
lin weedy_A = mkWA (compoundA "rikka" (k38 "ruohoinen")) ; --UNCHK
lin week_N = mkN "viikko" ;
lin weekday_N = mkWN (compoundN "arki" (k10 "päivä")) ; --UNCHK
lin weekend_N = mkN "viikonloppu" ;
lin weekend_V = mkWV (k53A "viettää") "viikonloppua" ; --UNCHK
lin weekender_N = mkWN (compoundN "viikonloppu" (k5 "kassi")) ; --UNCHK
lin weekly_A = mkWA (k38 "viikoittainen") ;
lin weekly_Adv = mkAdv "viikoittain" ;
lin weekly_N = mkWN (compoundN "viikko" (k7A "lehti")) ;
lin weeknight_N = mkWN "arkiyö" ; --UNCHK
lin weeny_A = mkWA (k38 "pikkuriikkinen") ; --UNCHK
lin weep_V = mkWV (k61A "kyynelehtiä") ; --UNCHK
lin weep_V2 = mkWV2 (k61A "kyynelehtiä") ; --UNCHK
lin weeper_N = mkWN "surija" ; --UNCHK
lin weepiness_N = mkWN (compoundN "itkun" (k40 "sekaisuus")) ; --UNCHK
lin weepy_A = mkWA (k38 "itkuinen") ; --UNCHK
lin weevil_N = mkWN (k41A "kärsäkäs") ; --UNCHK
lin weft_N = mkWN (k48A "täyte") ; --UNCHK
lin weigela_N = mkWN "tarhakotakuusama" ; --UNCHK
lin weigh_V = mkWV (k69 "punnita") ; --UNCHK
lin weigh_V2 = mkWV2 (k69 "punnita") ; --UNCHK
lin weigh_on_V2 = mkWV2 (k67 "olla") "painolastina" ; --UNCHK
lin weighbridge_N = mkWN (compoundN "ajoneuvo" (k9A "vaaka")) ; --UNCHK
lin weighing_machine_N = mkWN (k6 "puntari") ; --UNCHK
lin weight_N = mkWN (k1 "paino") ;
lin weight_V2 = mkWV2 (k53A "painottaa") ;
lin weightiness_N = mkWN (k40 "raskaus") ; --UNCHK
lin weightless_A = mkWA (k34A "painoton") ; --UNCHK
lin weightlessness_N = mkWN (k40 "painottomuus") ; --UNCHK
lin weightlift_N = mkWN (compoundN "painon" (k1 "nosto")) ; --UNCHK
lin weightlifter_N = mkWN (k10 "nostaja") ; --UNCHK
lin weightlifting_N = mkWN (compoundN "painon" (k1 "nosto")) ; --UNCHK
lin weighty_A = mkWA (k10 "painava") ; --UNCHK
lin weir_N = mkWN (k1A "pato") ; --UNCHK
lin weird_A = mkA "omituinen" ; --mkWA (k38 "merkillinen") ;
lin weirdie_N = mkWN (k5A "tyyppi") "outo" ; --UNCHK
lin weirdness_N = mkWN (k40 "outous") ; --UNCHK
lin welcher_N = mkWN (k6 "huijari") ; --UNCHK
lin welcome_A = mkWA (k47 "tervetullut") ;
lin welcome_N = mkWN (compoundN "vastaan" (k1A "otto")) ; --UNCHK
lin welcome_V2 = mkWV2 (mkV "toivottaa") "tervetulleeksi" ;
lin welcoming_A = mkWA (k38 "sydämellinen") ; --UNCHK
lin weld_N = mkWN (kH1 "hitsi") ; --UNCHK
lin weld_V = mkWV (k53 "yhdistää") ; --UNCHK
lin weld_V2 = mkWV2 (k53 "yhdistää") ; --UNCHK
lin welder_N = mkWN (k6 "hitsari") ; --UNCHK
lin welding_N = mkWN (k39 "hitsaus") ; --UNCHK
lin weldment_N = mkWN (k48A "rakenne") "hitsattu" ; --UNCHK
lin welfare_N = mkWN (compoundN "sosiaali" (k39 "avustus")) ;
lin welfarist_A = mkWA "hyvinvointivaltioon" "liittyvä" ; --UNCHK
lin welkin_N = mkWN (k40 "avaruus") ; --UNCHK
lin well_A = mkWA (k99 "kunnossa") "hyvässä" ; --UNCHK
lin well_Interj = mkInterj "no" ;
lin well_N = mkWN (k48A "lähde") ;
lin well_V = mkWV (k74A "kummuta") ; --UNCHK
lin well_balanced_A = mkA "tasapainoinen" ;
lin well_behaved_A = mkWA (compoundA "hyvä" (k38 "käytöksinen")) ; --UNCHK
lin well_born_A = mkA (mkN "jalo" (mkN "sukuinen")) | mkWA (compoundA "ylä" (k38 "luokkainen")) ; --UNCHK
lin well_connected_A = mkA "suhteita omaava" ;
lin well_heeled_A = mkA "varakas" ;
lin well_intentioned_A = mkA "hyväätarkoittava" ;
lin well_known_A = mkA "tunnettu" ;
lin well_meaning_A = mkA (mkN "hyvää" (mkN "tarkoittava")) ;
lin well_timed_A = mkWA (compoundA "oikea-" (k38 "aikainen")) ; --UNCHK
lin well_to_do_A = mkA "suurituloinen" ;
lin well_up_V = mkWV (k66 "nousta") ; --UNCHK
lin well_water_N = mkWN (compoundN "lähde" (k27 "vesi")) ; --UNCHK
lin wellbeing_N = mkWN (k40 "onnellisuus") ; --UNCHK
lin wellerism_N = mkWN (k5 "wellerismi") ; --UNCHK
lin wellhead_N = mkWN (compoundN "suihku" (k1 "kaivo")) ; --UNCHK
lin wellingborough_PN = foreignPN "Wellingborough" ;
lin wellington_N = mkWN (k41A "saapas") "hesseniläinen" ; --UNCHK
lin wellington_PN = foreignPN "Wellington" ;
lin wells_PN = foreignPN "Wells" ;
lin welsh_A = mkWA (compoundA "walesi" (k38 "lainen")) ; --UNCHK
lin welsh_N = mkWN "Welsh" "Black" ; --UNCHK
lin welsh_V = mkWV (k52A "rikkoa") "lupaus" ; --UNCHK
lin welsher_N = mkWN (k6 "huijari") ; --UNCHK
lin welshman_N = mkWN (compoundN "walesi" (k38 "lainen")) ; --UNCHK
lin welshpool_PN = foreignPN "Welshpool" ;
lin welt_N = mkWN (k39 "reunus") ; --UNCHK
lin welter_N = mkWN (k10 "määrä") "sankka" ; --UNCHK
lin welter_V = mkWV (k52A "uppoutua") ; --UNCHK
lin welterweight_N = mkWN (compoundN "ammattilais" (k12 "nyrkkeilijä")) "välisarjan" ; --UNCHK
lin welwitschia_N = mkWN "Welwitschia" "mirabilis" ; --UNCHK
lin welwyn_PN = foreignPN "Welwyn" ;
lin wen_N = mkWN (k9 "kysta") ; --UNCHK
lin wench_N = mkWN (k9 "kissa") ; --UNCHK
lin wencher_N = mkWN (k10 "parittaja") ; --UNCHK
lin wend_V2 = mkWV2 (k73A "suunnata") ; --UNCHK
lin wendover_PN = foreignPN "Wendover" ;
lin werewolf_N = mkWN (compoundN "ihmis" (k27 "susi")) ; --UNCHK
lin wesleyan_A = mkWA (k38 "metodistinen") ; --UNCHK
lin wesleyan_N = mkWN "wesleyläinen" ; --UNCHK
lin west_A = mkA "läntinen" ;
lin west_Adv = mkWAdv "länteen" ; --UNCHK
lin west_N = mkWN (k28 "länsi") ;
lin westbound_A = mkWA (k99 "päin") "länteen" ; --UNCHK
lin westbury_PN = foreignPN "Westbury" ;
lin westerly_A = mkWA (k99 "päin") "länteen" ; --UNCHK
lin westerly_Adv = mkWAdv "länsi-" | adjAdv westerly_A ; --UNCHK -- derived
lin western_A = mkA "läntinen" ;
lin western_N = mkWN (compoundN "hevos" (k12 "ooppera")) ; --UNCHK
lin westerner_N = mkWN (k41A "asukas") "lännen" ; --UNCHK
lin westernization_N = mkWN (compoundN "länsi" (k38 "maistuminen")) ; --UNCHK
lin westernize_V2 = mkWV2 (compoundV "länsi" (k56 "maistaa")) ; --UNCHK
lin westernmost_A = mkWA "läntisin" ; --UNCHK
lin westhoughton_PN = foreignPN "Westhoughton" ;
lin westminster_PN = foreignPN "Westminster" ;
lin westmoreland_PN = foreignPN "Westmoreland" ;
lin westside_A = mkWA (k10 "oleva") "länsipuolella" ; --UNCHK
lin westward_A = mkWA (k99 "päin") "länteen" ; --UNCHK
lin westward_Adv = mkWAdv (k99 "päin") "länteen" ; --UNCHK
lin westwards_Adv = mkWAdv (k99 "päin") "länteen" ; --UNCHK
lin wet_A = L.wet_A ;
lin wet_N = mkWN (k40 "märkyys") ; --UNCHK
lin wet_V2 = mkWV2 (k67 "kastella") ; --UNCHK
lin wet_nurse_N = mkWN (k10 "imettäjä") ; --UNCHK
lin wether_N = mkWN (k41 "oinas") ; --UNCHK
lin wetherby_PN = foreignPN "Wetherby" ;
lin wetland_N = mkWN (k4A "kosteikko") ; --UNCHK
lin wetness_N = mkWN (k40 "märkyys") ; --UNCHK
lin wetter_N = mkWN "yökastelija" ; --UNCHK
lin wetting_N = mkWN (k2 "kastelu") ; --UNCHK
lin weymouth_PN = foreignPN "Weymouth" ;
lin whack_N = mkWN (k39 "läimäys") ; --UNCHK
lin whack_V2 = mkWV2 (k53A "täräyttää") ;
lin whacker_N = mkWN (k38 "jättiläinen") ; --UNCHK
lin whacking_Adv = mkWAdv (compoundAdv "erityi" (k99 "sen")) ; --UNCHK
lin whacking_N = mkWN (k39 "löylytys") ; --UNCHK
lin whale_N = mkWN (k41 "valas") ; --UNCHK
lin whale_V = mkWV (k54A "pyytää") "valaita" ; --UNCHK
lin whaleboat_N = mkWN (compoundN "valaanpyynti" (k48 "vene")) ; --UNCHK
lin whalebone_N = mkWN (compoundN "valaan" (k18 "luu")) ; --UNCHK
lin whaler_N = mkWN (compoundN "valaanpyynti" (k39 "alus")) ; --UNCHK
lin whaling_gun_N = mkWN (compoundN "valaanpyynti" (k48 "ase")) ; --UNCHK
lin whammy_N = mkWN (k9A "taika") ; --UNCHK
lin whang_N = mkWN (k39 "läimäys") ; --UNCHK
lin whang_V2 = mkWV2 (k58 "iskeä") ; --UNCHK
lin wharf_N = mkWN (k10 "satama") ; --UNCHK
lin wharfage_N = mkWN (k10 "satama") ; --UNCHK
lin whatPl_IP = S.whatPl_IP ;
lin whatSg_IP = S.whatSg_IP ;
lin what_for_N = mkWN (k99 "tähden") "minkä" ; --UNCHK
lin whatever_A = mkWA (k38 "minkäänlainen") ; --UNCHK
lin whatever_Quant = heavyQuant {s1 = \\n,c => mika_NForms ! NCase n c ++ "tahansa" ; s2 = \\_ => [] ; isNum,isPoss,isNeg,isDef = False} ;
lin whatnot_N = mkWN (k10 "rihkama") ; --UNCHK
lin whatsoever_A = mkWA (k38 "minkäänlainen") ; --UNCHK
lin whatsoever_Adv = variants {} ; --
lin wheat_N = mkWN (k10 "vehnä") ;
lin wheatear_N = mkWN (compoundN "kivi" (k1 "tasku")) ; --UNCHK
lin wheaten_A = mkWA "täysjyvä-" ; --UNCHK
lin wheatfield_N = mkWN (compoundN "vehnä" (k1A "pelto")) ; --UNCHK
lin wheatflake_N = mkWN (compoundN "vehnä" (k1 "muro")) ; --UNCHK
lin wheatgrass_N = mkWN (compoundN "vehnän" (k41 "oras")) ; --UNCHK
lin wheatworm_N = mkWN (compoundN "sukkula" (k1A "mato")) ; --UNCHK
lin wheedle_V2 = mkWV2 (k67A "viekoitella") ; --UNCHK
lin wheedler_N = mkWN "suostuttelija" ; --UNCHK
lin wheel_N = mkWN (k10 "pyörä") ;
lin wheel_V = mkWV (k72A "edetä") ; --UNCHK
lin wheel_V2 = mkWV2 (k72A "edetä") ; --UNCHK
lin wheel_around_V = mkWV (k52A "kääntyä") ; --UNCHK
lin wheelbase_N = mkWN (compoundN "akseli" (k5 "väli")) ; --UNCHK
lin wheelchair_N = mkWN (compoundN "rulla" (k5 "tuoli")) ; --UNCHK
lin wheeler_N = mkWN (compoundN "veto" (k10A "juhta")) ; --UNCHK
lin wheelhouse_N = mkWN (compoundN "ohjaus" (k5A "hytti")) ; --UNCHK
lin wheeling_N = mkWN (compoundN "työ" (k38 "ntäminen")) "pyörillä" ; --UNCHK
lin wheelless_A = mkWA "renkaaton" ; --UNCHK
lin wheelwork_N = mkWN (k2 "pyörästö") ; --UNCHK
lin wheelwright_N = mkWN (compoundN "pyörän" (k12 "tekijä")) ; --UNCHK
lin wheeze_N = mkWN (k12 "pihinä") ; --UNCHK
lin wheeze_V = mkWV (k66 "pihistä") ; --UNCHK
lin wheeze_V2 = mkWV2 (k66 "pihistä") ; --UNCHK
lin wheeziness_N = mkWN (compoundN "vin" (k38 "kuminen")) ; --UNCHK
lin wheezy_A = mkWA (k38 "astmaattinen") ; --UNCHK
lin whelp_N = mkWN (k14A "penikka") ; --UNCHK
lin whelp_V = mkWV (k61A "poikia") ; --UNCHK
lin when_IAdv = S.when_IAdv ;
lin when_Subj = S.when_Subj ;
lin whence_Adv = mkWAdv (k99 "mistä") ; --UNCHK
lin whenever_Adv = variants {} ; --
lin where_IAdv = S.where_IAdv ;
lin where_Subj = mkSubj "missä" ;
lin where_as_Prep = mkPrep "kun taas" nominative ; ---- cat
lin whereabouts_N = mkWN (k5A "sijainti") ; --UNCHK
lin whereas_Prep = prePrep nominative "kun taas" ;
lin whereas_Subj = mkSubj "kun taas" ;
lin whereby_Adv = variants {} ; --
lin wherein_Subj = mkSubj "missä" ;
lin wheresoever_Adv = mkWAdv (k99 "ikinä") "missä" ; --UNCHK
lin wherever_Adv = mkWAdv (k99 "ikinä") "missä" ; --UNCHK
lin wherry_N = mkWN (compoundN "lautta" (k48 "vene")) ; --UNCHK
lin whet_V2 = mkWV2 (k53A "teroittaa") ; --UNCHK
lin whether_Prep = mkPrep "onko" nominative ;
lin whether_Subj = mkSubj "josko" ;
lin whetstone_N = mkWN (compoundN "hioma" (k7 "kivi")) ; --UNCHK
lin whey_N = mkWN (k9 "hera") ; --UNCHK
lin which_IQuant = S.which_IQuant ;
lin whichever_Quant = heavyQuant {s1 = \\n,c => mika_NForms ! NCase n c ++ "tahansa" ; s2 = \\_ => [] ; isNum,isPoss,isNeg,isDef = False} ;
lin whiff_N = mkWN (k1A "poltto") ; --UNCHK
lin whiffer_N = mkWN (k10 "lyöjä") ; --UNCHK
lin whiffletree_N = mkWN (compoundN "kääntö" (k5A "palkki")) ; --UNCHK
lin whig_N = mkWN "whig" ; --UNCHK
lin while_N = mkN "hetki" "hetkiä" ;
lin while_Subj = mkSubj "samalla kun" ;
lin while_V2 = mkV2 "viettää" ;
lin while_away_V2 = mkWV2 (k53A "kuluttaa") ; --UNCHK
lin whilst_Subj = variants {} ; --
lin whim_N = mkWN (k1A "oikku") ; --UNCHK
lin whimper_N = mkWN (k9A "ulvonta") ; --UNCHK
lin whimper_V = mkWV (k66 "vikistä") ; --UNCHK
lin whimper_V2 = mkWV2 (k66 "vikistä") ; --UNCHK
lin whimsey_N = mkWN (k2 "oikuttelu") ; --UNCHK
lin whimsical_A = mkWA (k38 "äkillinen") ; --UNCHK
lin whimsicality_N = mkWN (k40 "leikillisyys") ; --UNCHK
lin whimsy_N = mkWN (k2 "oikuttelu") ; --UNCHK
lin whin_N = mkWN (k5A "basaltti") ; --UNCHK
lin whinchat_N = mkWN (compoundN "pensas" (k1 "tasku")) ; --UNCHK
lin whine_N = mkWN (k9A "ulvonta") ; --UNCHK
lin whine_V = mkWV (k66 "kitistä") ; --UNCHK
lin whine_V2 = mkWV2 (k66 "kitistä") ; --UNCHK
lin whiner_N = mkWN (k12 "marisija") ; --UNCHK
lin whinny_N = mkWN (k12 "yninä") ; --UNCHK
lin whinny_V = mkWV (k53A "hirnahtaa") ; --UNCHK
lin whinstone_N = mkWN (k5A "basaltti") ; --UNCHK
lin whip_N = mkWN (k1 "isku") "piiskan" ; --UNCHK
lin whip_V = mkWV (k61 "suomia") ; --UNCHK
lin whip_V2 = mkWV2 (k61 "suomia") ; --UNCHK
lin whip_through_V2 = mkWV2 (k55A "kiitää") "läpi" ; --UNCHK
lin whip_up_V2 = mkWV2 (k73 "kyhätä") ; --UNCHK
lin whipcord_N = mkWN (k9 "siima") ; --UNCHK
lin whiplash_N = mkWN (k1 "isku") "piiskan" ; --UNCHK
lin whippersnapper_N = mkWN (k38 "ihminen") "vähäpätöinen" ; --UNCHK
lin whipping_N = mkWN (k39 "parkitus") ; --UNCHK
lin whipping_boy_N = mkWN (compoundN "sijais" (k12 "kärsijä")) ; --UNCHK
lin whipping_post_N = mkWN (compoundN "häpeä" (k1 "paalu")) ; --UNCHK
lin whipping_top_N = mkWN (k10 "hyrrä") ; --UNCHK
lin whippoorwill_N = mkWN (compoundN "amerikan" (k10 "kehrääjä")) ; --UNCHK
lin whippy_A = mkWA (k10 "taipuisa") ; --UNCHK
lin whipsaw_V2 = mkWV2 (k73 "sahata") "lehtisahalla" ; --UNCHK
lin whipstitch_N = mkWN (k49A "ommel") ; --UNCHK
lin whiptail_N = mkWN (k1 "piiskahäntälisko") ; --UNCHK
lin whir_N = mkWN (k12 "humina") ; --UNCHK
lin whir_V = mkWV (k73 "kehrätä") ; --UNCHK
lin whirl_N = mkWN (k9A "pyörintä") ; --UNCHK
lin whirl_V = mkWV (k52A "kieppua") ; --UNCHK
lin whirl_V2 = mkWV2 (k52A "kieppua") ; --UNCHK
lin whirler_N = mkWN (compoundN "pyörimis" (k5 "mekanismi")) ; --UNCHK
lin whirligig_N = mkWN (k5 "karuselli") ; --UNCHK
lin whirlpool_N = mkWN (k48A "pyörre") ; --UNCHK
lin whirlwind_N = mkWN (compoundN "pyörre" (k26 "tuuli")) ; --UNCHK
lin whirr_N = mkWN (k12 "humina") ; --UNCHK
lin whirr_V = mkWV (k66 "hyristä") ; --UNCHK
lin whisk_N = mkWN (k1 "huisku") ; --UNCHK
lin whisk_V = mkWV (k73 "vatkata") ; --UNCHK
lin whisk_V2 = mkWV2 (k73 "vatkata") ; --UNCHK
lin whisker_N = mkWN (compoundN "viiksi" (k9 "karva")) ; --UNCHK
lin whiskered_A = mkWA (k41A "viiksekäs") ; --UNCHK
lin whiskey_N = mkWN (k5 "viski") ;
lin whisper_N = mkWN (k40 "äänettömyys") ; --UNCHK
lin whisper_V = mkWV (k73 "kuiskata") ; --UNCHK
lin whisper_V2 = mkWV2 (k73 "kuiskata") ; --UNCHK
lin whisperer_N = mkWN (k10 "kuiskaaja") ; --UNCHK
lin whispering_N = mkWN (k40 "äänettömyys") ; --UNCHK
lin whispering_gallery_N = mkWN (k5 "holvi") "akustinen" ; --UNCHK
lin whist_drive_N = mkWN (compoundN "visti" (k39 "tempaus")) ; --UNCHK
lin whistle_N = mkWN (k5 "pilli") ; --UNCHK
lin whistle_V = mkWV (k54A "viheltää") ; --UNCHK
lin whistle_V2 = mkWV2 (k54A "viheltää") ; --UNCHK
lin whistle_stop_N = mkWN (k48A "seisake") ; --UNCHK
lin whistler_N = mkWN (k10 "viheltäjä") ; --UNCHK
lin whistling_N = mkWN "viheltely" ; --UNCHK
lin whit_N = mkWN (k32 "hiven") ; --UNCHK
lin whitburn_PN = foreignPN "Whitburn" ;
lin whitby_PN = foreignPN "Whitby" ;
lin whitchurch_PN = foreignPN "Whitchurch" ;
lin white_A = L.white_A ;
lin white_N = mkN "valkoinen" ;
lin white_collar_A = mkA "valkokauluksinen" ;
lin white_out_V2 = mkWV2 (k53A "levittää") ; --UNCHK
lin whitecap_N = mkWN (compoundN "vaahto" (k18 "pää")) ; --UNCHK
lin whitecup_N = mkWN "Nierembergia" "rivularis" ; --UNCHK
lin whiteface_N = mkWN "Hereford" ; --UNCHK
lin whitefish_N = mkWN (k9A "siika") ; --UNCHK
lin whitefly_N = mkWN (k38 "jauhiainen") ; --UNCHK
lin whitehall_PN = foreignPN "Whitehall" ;
lin whitehaven_PN = foreignPN "Whitehaven" ;
lin whitehead_N = mkWN "miliumi" ; --UNCHK
lin whitelash_N = mkWN (compoundN "vasta" (k1 "isku")) "valkoinen" ; --UNCHK
lin whiten_V = mkWV (k54A "vaalentaa") ; --UNCHK
lin whiten_V2 = mkWV2 (k54A "vaalentaa") ; --UNCHK
lin whiteness_N = mkWN (k15 "valkea") ; --UNCHK
lin whitening_N = mkWN "vaaleneminen" ; --UNCHK
lin whiteout_N = mkWN (k40 "valkoisuus") ; --UNCHK
lin whitethorn_N = mkWN (compoundN "ora" (k10 "pihlaja")) ; --UNCHK
lin whitewash_N = mkWN (k2 "valkaisu") ; --UNCHK
lin whitewash_V2 = mkWV2 (k73 "salata") ; --UNCHK
lin whitey_N = mkWN (k38 "valkolainen") ; --UNCHK
lin whiting_N = mkWN (compoundN "valko" (k10 "turska")) ; --UNCHK
lin whitish_A = mkWA (k38 "valkoinen") "taitettu" ; --UNCHK
lin whitlow_N = mkWN (compoundN "varvas" (k39 "ajos")) ; --UNCHK
lin whitlowwort_N = mkWN (compoundN "maanpeitto" (k5 "kasvi")) ; --UNCHK
lin whitstable_PN = foreignPN "Whitstable" ;
lin whitsun_N = mkWN (k18 "helluntai") ; --UNCHK
lin whitsuntide_N = mkWN (k18 "helluntai") ; --UNCHK
lin whittle_V = mkWV (k67 "vuolla") ; --UNCHK
lin whittle_V2 = mkWV2 (k67 "vuolla") ; --UNCHK
lin whittler_N = mkWN "nakertelija" ; --UNCHK
lin whittlesey_PN = foreignPN "Whittlesey" ;
lin whitworth_PN = foreignPN "Whitworth" ;
lin whiz_N = mkWN (k39 "sähähdys") ; --UNCHK
lin whiz_V = mkWV (k73 "kehrätä") ; --UNCHK
lin whizbang_N = mkWN (k38 "sähikäinen") ; --UNCHK
lin whoPl_IP = S.whoPl_IP ;
lin whoSg_IP = S.whoSg_IP ;
lin who_PN = foreignPN "WHO" ;
lin whodunit_N = mkWN (k6 "dekkari") ; --UNCHK
lin whoever_NP = {s = table {NPAcc => "kenet" ++ "tahansa" ; c => S.kukaInt ! Sg ! npform2case Sg c ++ "tahansa"} ; a = agrP3 Sg ; isPron, isNeg = False} ; --
lin whole_A = mkA "kokonainen" ;
lin whole_N = mkWN (k40 "kokonaisuus") ;
lin wholehearted_A = mkWA (k34A "varaukseton") ; --UNCHK
lin wholeheartedness_N = mkWN "varauksettomuus" ; --UNCHK
lin wholeness_N = mkWN (k40 "terveys") ; --UNCHK
lin wholesale_A = mkWA (compoundA "laaja" (k38 "mittainen")) ;
lin wholesale_Adv = mkWAdv (k99 "tukuittain") ; --UNCHK
lin wholesale_N = mkWN (k1A "tukku") ; --UNCHK
lin wholesale_V2 = mkWV2 (k63 "myydä") "tukuttain" ; --UNCHK
lin wholesaler_N = mkWN (k10 "välittäjä") ;
lin wholesome_A = mkWA (k38 "terveellinen") ; --UNCHK
lin wholesomeness_N = mkWN (k40 "terveellisyys") ; --UNCHK
lin whoop_N = mkWN (k39 "kiljahdus") ; --UNCHK
lin whoop_V = mkWV (k61 "köhiä") ; ---ARB ; --mkV "ulvoa" ;
lin whoop_V2 = mkWV2 (k61 "köhiä") ; --UNCHK
lin whoopee_Interj = mkInterj "jippii" ;
lin whoopee_N = mkWN (k39 "rellestys") ; --UNCHK
lin whooper_N = mkWN (compoundN "laulu" (k32 "joutsen")) ; --UNCHK
lin whooping_cough_N = mkWN (compoundN "hinku" (k10 "yskä")) ; --UNCHK
lin whop_V2 = mkWV2 (k64 "lyödä") ; --UNCHK
lin whopper_N = mkWN (k38 "jättiläinen") ; --UNCHK
lin whopping_A = mkWA (k38 "jättimäinen") ; --UNCHK
lin whopping_Adv = mkWAdv "huikean" ; --UNCHK
lin whore_N = mkWN (k1A "lumppu") ; --UNCHK
lin whorehouse_N = mkWN (k12 "porttola") ; --UNCHK
lin whoremaster_N = mkWN (k5 "sutenööri") ; --UNCHK
lin whoremonger_N = mkWN (k5 "sutenööri") ; --UNCHK
lin whorl_N = mkWN (k6 "spiraali") ; --UNCHK
lin whorled_A = mkWA (compoundA "lehtirypäsmuodostel" (k9 "massa")) ; --UNCHK
lin why_IAdv = S.why_IAdv ;
lin why_N = mkWN (kH1 "syy") ; --UNCHK
lin whydah_N = mkWN (k7 "leski") ; --UNCHK
lin wi_N = mkWN "WI" ; --UNCHK
lin wick_N = mkWN (k48A "sytyke") ; --UNCHK
lin wick_PN = foreignPN "Wick" ;
lin wicked_A = mkWA (k9 "paha") ; --UNCHK
lin wickedness_N = mkWN (k40 "häijyys") ; --UNCHK
lin wicker_N = mkWN (compoundN "kori" (k19 "työ")) ; --UNCHK
lin wickerwork_N = mkWN (compoundN "kori" (k19 "työ")) ; --UNCHK
lin wicket_N = mkWN (compoundN "ristikko" (k12 "ikkuna")) ; --UNCHK
lin wicket_door_N = mkWN (k1A "luukku") "portin" ; --UNCHK
lin wicket_gate_N = mkWN (k1A "luukku") "portin" ; --UNCHK
lin wickford_PN = foreignPN "Wickford" ;
lin wickiup_N = mkWN (compoundN "lehti" (k9 "maja")) ; --UNCHK
lin wicklow_PN = foreignPN "Wicklow" ;
lin wide_A = L.wide_A ;
lin wide_Adv = mkWAdv (k99 "paljon") ; --UNCHK
lin widen_V2 = mkWV2 (k52A "leventyä") ; --UNCHK
lin wideness_N = mkWN (k40 "laajuus") ; --UNCHK
lin widening_N = mkWN "leventäminen" ; --UNCHK
lin widespread_A = mkA (mkN "laajalle" (mkN "levinnyt")) ;
lin widgeon_N = mkWN (k12 "haapana") ; --UNCHK
lin widnes_PN = foreignPN "Widnes" ;
lin widow_N = mkWN (k7 "leski") ; --UNCHK
lin widowed_A = mkA "leski" ;
lin widower_N = mkWN (compoundN "leski" (k42 "mies")) ; --UNCHK
lin widowhood_N = mkWN (k40 "leskeys") ; --UNCHK
lin width_N = mkWN (k40 "laajuus") ; --UNCHK
lin wield_V2 = mkV2 "käyttää" partitive ; --mkWV2 (k69 "hallita") ;
lin wiesbaden_PN = foreignPN "Wiesbaden" ;
lin wiesenboden_N = mkWN (compoundN "maa-" (k39 "aines")) ; --UNCHK
lin wife_N = L.wife_N ;
lin wifelike_A = mkWA (k10 "sopiva") "naiselle" ; --UNCHK
lin wifely_A = mkWA (k10 "sopiva") "naiselle" ; --UNCHK
lin wig_N = mkWN (k5A "peruukki") ; --UNCHK
lin wigan_PN = foreignPN "Wigan" ;
lin wigging_N = mkWN (k39 "nalkutus") ; --UNCHK
lin wiggle_N = mkWN (k2 "kiemurtelu") ; --UNCHK
lin wiggle_V = mkWV (k53A "tutisuttaa") ; --UNCHK
lin wiggle_V2 = mkWV2 (k53A "tutisuttaa") ; --UNCHK
lin wiggler_N = mkWN (k1 "liero") ; --UNCHK
lin wiggliness_N = mkWN (k9A "huojunta") ; --UNCHK
lin wiggly_A = mkWA "kiemurteleva" ; --UNCHK
lin wight_N = mkWN (k26 "saari") "Wightin" ; --UNCHK
lin wigless_A = mkWA "peruukiton" ; --UNCHK
lin wigmaker_N = mkWN (compoundN "peruukin" (k12 "tekijä")) ; --UNCHK
lin wigwam_N = mkWN (k5 "wigwam") ; --UNCHK
lin wild_A = mkA "villi" ;
lin wild_Adv = mkWAdv (k99 "villisti") ; --UNCHK
lin wild_N = mkWN (k7A "korpi") ; --UNCHK
lin wildcat_A = mkWA (k39 "veikkaus") "villi" ; --UNCHK
lin wildcat_N = mkWN (k50 "villikissa") ; --UNCHK
lin wildcatter_N = mkWN (compoundN "öljyn" (k10 "poraaja")) "villi" ; --UNCHK
lin wildebeest_N = mkWN (k18 "gnuu") ; --UNCHK
lin wilderness_N = mkWN (k4A "ryteikkö") ; --UNCHK
lin wildfire_N = mkWN (compoundN "maasto" (k1 "palo")) ; --UNCHK
lin wildflower_N = mkWN (compoundN "luonnon" (k5 "kasvi")) ; --UNCHK
lin wilding_N = mkWN (k14A "mellakka") ; --UNCHK
lin wildlife_N = variants {} ; --
lin wildness_N = mkWN (compoundN "luonnonva" (k40 "raisuus")) ; --UNCHK
lin wile_N = mkWN (k39 "petos") ; --UNCHK
lin wilful_A = mkWA (k41A "sisukas") ; --UNCHK
lin wilfulness_N = mkWN (k40 "kurittomuus") ; --UNCHK
lin wilhelmshaven_PN = foreignPN "Wilhelmshaven" ;
lin will_N = mkWN (k1A "tahto") ; ---ARB mkN "testamentti" ;
lin will_V = mkWV (k75 "haluta") ;
lin will_V2 = mkWV2 (k75 "haluta") ; --UNCHK
lin willet_N = mkWN (compoundN "preeria" (k1 "viklo")) ; --UNCHK
lin willful_A = mkA "tahallinen" ; --WA (k41A "sisukas") ; ---ARB
lin willies_N = mkWN (k48A "tunne") "vaivaantuneisuuden" ; --UNCHK
lin willing_A = mkA "halukas" ;
lin willingness_N = mkWN (k40 "halukkuus") ; --UNCHK
lin willington_PN = foreignPN "Willington" ;
lin willow_N = mkWN (compoundN "villanmöyhennys" (k48 "kone")) ; --UNCHK
lin willow_tree_N = mkWN (k1 "paju") ; --UNCHK
lin willowherb_N = mkWN (k10 "horsma") ; --UNCHK
lin willowware_N = mkWN (compoundN "paju" (k5A "kuviointi")) ; --UNCHK
lin willowy_A = mkWA (k15 "sorea") ; --UNCHK
lin willpower_N = mkWN (k1A "tahto") "oma" ; --UNCHK
lin willy_nilly_Adv = mkAdv "väkisin" ;
lin wilmslow_PN = foreignPN "Wilmslow" ;
lin wilt_N = mkWN "nuuduttaminen" ; --UNCHK
lin wilt_V = mkWV (k53A "väsähtää") ; --UNCHK
lin wilt_V2 = mkWV2 (k53A "väsähtää") ; --UNCHK
lin wilton_N = mkWN (compoundN "Wilton-" (k1A "matto")) ; --UNCHK
lin wily_A = mkWA (k10 "näppärä") ; --UNCHK
lin wimp_N = mkWN (compoundN "rakenne" (k38 "osanen")) "pimeän" "aineen" ; --UNCHK
lin wimpish_A = mkWA (k39 "nahjus") ; --UNCHK
lin wimple_N = mkWN "wimple" ; --UNCHK
lin win_N = mkWN (k1A "voitto") ;
lin win_V = mkV "voittaa" ;
lin win_V2 = L.win_V2 ;
lin win_back_V = mkWV (k63 "saada") "takaisin" ; --UNCHK
lin win_down_V = advV OP_win_V OP_down_Adv ; -- guess-p-verb
lin win_over_V = mkWV (k53A "vakuuttaa") ; --UNCHK
lin win_up_V = advV OP_win_V OP_up_Adv ; -- guess-p-verb
lin wince_N = mkWN (k39 "hätkähdys") ; --UNCHK
lin wince_V2 = mkWV2 (k53A "säpsähtää") ; --UNCHK
lin wincey_N = mkWN "wincey" ; --UNCHK
lin winceyette_N = mkWN (compoundN "puuvilla" (k6 "flanelli")) ; --UNCHK
lin winch_N = mkWN (k6 "vintturi") ; --UNCHK
lin winch_V2 = mkWV2 (k73 "vinssata") ; --UNCHK
lin winchester_PN = foreignPN "Winchester" ;
lin wind_N = L.wind_N ;
lin wind_V = mkWV (k53 "nostaa") "ylös" ; --UNCHK
lin wind_down_V = advV OP_wind_V OP_down_Adv ; -- guess-p-verb
lin wind_down_V2 = prepV2 OP_wind_V OP_down_Prep ; -- guess-p-verb
lin wind_gauge_N = mkWN (compoundN "tuuli" (k6 "mittari")) ; --UNCHK
lin wind_on_V = advV OP_wind_V OP_on_Adv ; -- guess-p-verb
lin wind_tunnel_N = mkWN (compoundN "tuuli" (k6 "tunneli")) ; --UNCHK
lin wind_up_V = mkWV (k52A "joutua") ; --UNCHK
lin wind_up_V2 = mkWV2 (k52A "joutua") ; --UNCHK
lin windage_N = mkWN (compoundN "tuulen" (k39 "vastus")) ; --UNCHK
lin windbag_N = mkWN (k5A "suupaltti") ; --UNCHK
lin windblown_A = mkWA "tuulen" "muovaama" ; --UNCHK
lin windbreak_N = mkWN (k10 "tuulensuoja") ; --UNCHK
lin windbreaker_N = mkWN (k5A "anorakki") ; --UNCHK
lin windburn_N = mkWN (k1 "iho") "tuulen" "kuivattama" ; --UNCHK
lin windburned_A = mkWA "tuulen" "kuivattama" ; --UNCHK
lin windcheater_N = mkWN (k5A "anorakki") ; --UNCHK
lin winder_N = mkWN (compoundN "veto" (k5A "nuppi")) ; --UNCHK
lin windermere_PN = foreignPN "Windermere" ;
lin windfall_N = mkWN (k5A "jättipotti") ; --UNCHK
lin windflower_N = mkWN (k1A "vuokko") ; --UNCHK
lin windiness_N = mkWN (k40 "pitkäpiimäisyys") ; --UNCHK
lin windjammer_N = mkWN (compoundN "purje" (k9 "laiva")) ; --UNCHK
lin windlass_N = mkWN (k6 "vintturi") ; --UNCHK
lin windless_A = mkWA (k34A "tuuleton") ; --UNCHK
lin windmill_N = mkWN (compoundN "tuuli" (k6 "generaattori")) ; --UNCHK
lin window_N = L.window_N ;
lin window_box_N = mkWN (compoundN "parveke" (k4A "laatikko")) ; --UNCHK
lin window_dressing_N = mkWN (k39 "somistus") ; --UNCHK
lin windowpane_N = mkWN (compoundN "lehti" (k13 "kampela")) ; --UNCHK
lin windowsill_N = mkWN (compoundN "ikkuna" (k9A "lauta")) ; --UNCHK
lin windpipe_N = mkWN (compoundN "henki" (k7 "torvi")) ; --UNCHK
lin windscreen_N = mkWN (compoundN "tuuli" (k5 "lasi")) ; --UNCHK
lin windscreen_wiper_N = mkWN (k10A "sulka") "tuulilasinpyyhkimen" ; --UNCHK
lin windshield_N = mkWN (compoundN "tuuli" (k5 "lasi")) ; --UNCHK
lin windsock_N = mkWN (compoundN "tuuli" (k5 "pussi")) ; --UNCHK
lin windsor_PN = foreignPN "Windsor" ;
lin windstorm_N = mkWN (k1 "myrsky") ; --UNCHK
lin windswept_A = mkWA (k38 "tuulinen") ; --UNCHK
lin windward_A = mkWA (compoundA "tuulen" (k38 "puoleinen")) ; --UNCHK
lin windward_Adv = mkWAdv "myötätuuleen" ; --UNCHK
lin windward_N = mkWN (compoundN "tuulen" (k38 "puoleinen")) ; --UNCHK
lin windy_A = mkWA (k38 "tuulinen") ; --UNCHK
lin wine_N = L.wine_N ;
lin wine_V2 = mkWV2 (k74 "tarjota") "viiniä" ; --UNCHK
lin wineberry_N = mkWN (compoundN "racem" (k10 "osa")) "Aristotelia" ; --UNCHK
lin wineglass_N = mkWN (compoundN "viini" (k5 "lasi")) ; --UNCHK
lin winemaking_N = mkWN (compoundN "viinin" (k39 "valmistus")) ; --UNCHK
lin winepress_N = mkWN (compoundN "rypäleen" (k33A "puserrin")) ; --UNCHK
lin winery_N = mkWN (compoundN "viini" (k9 "tila")) ; --UNCHK
lin wineskin_N = mkWN (compoundN "viini" (k5 "leili")) ; --UNCHK
lin wing_N = L.wing_N ;
lin wing_V = mkWV (k54A "lentää") ; --UNCHK
lin wing_V2 = mkWV2 (k54A "lentää") ; --UNCHK
lin wing_commander_N = mkWN (compoundN "eversti" (k5A "luutnantti")) ; --UNCHK
lin wing_nut_N = mkWN (compoundN "siipi" (k12 "pähkinä")) ; --UNCHK
lin wing_screw_N = mkWN (compoundN "siipi" (k12 "pähkinä")) ; --UNCHK
lin wingate_PN = foreignPN "Wingate" ;
lin wingback_N = mkWN (k5A "laitapakki") ; --UNCHK
lin winger_N = mkWN (compoundN "laita" (k10 "hyökkääjä")) ; --UNCHK
lin wingless_A = mkWA (k34A "siivetön") ; --UNCHK
lin winglike_A = mkWA (compoundA "siiven" (k38 "mallinen")) ; --UNCHK
lin wingman_N = mkWN (compoundN "siipi" (k42 "mies")) ; --UNCHK
lin wingspan_N = mkWN (compoundN "kärki" (k5 "väli")) ; --UNCHK
lin wingspread_N = mkWN (compoundN "kärki" (k5 "väli")) ; --UNCHK
lin wingstem_N = mkWN "Actinomeris" "alternifolia" ; --UNCHK
lin wink_V = mkWV (k53A "räpyttää") ; --UNCHK
lin wink_V2 = mkWV2 (k53A "räpyttää") ; --UNCHK
lin winker_N = mkWN (compoundN "silmä" (k1A "lappu")) ; --UNCHK
lin winkle_N = mkWN (k3 "talvio") ; --UNCHK
lin winkle_V2 = mkWV2 (k53A "nyhtää") "irti" ; --UNCHK
lin winkle_out_V2 = mkWV2 (k53A "nyhtää") "irti" ; --UNCHK
lin winless_A = mkWA "voitoton" ; --UNCHK
lin winner_N = mkN "voittaja" ; ---ARB mkWN "menestyjä" ;
lin winnie_PN = foreignPN "Winnie" ;
lin winning_A = mkA "voittava" ;
lin winning_N = mkWN (compoundN "voi" (k38 "ttaminen")) ; --UNCHK
lin winning_post_N = mkWN (k9A "paikka") "voittajan" ; --UNCHK
lin winnings_N = mkWN (k1A "voitto") ; --UNCHK
lin winnipeg_PN = foreignPN "Winnipeg" ;
lin winnow_N = mkWN (k9A "seulonta") ; --UNCHK
lin winnow_V2 = mkWV2 (k54A "puhaltaa") ; --UNCHK
lin winsford_PN = foreignPN "Winsford" ;
lin winsome_A = mkWA (k10 "hurmaava") ; --UNCHK
lin winsomeness_N = mkWN "hurmaavuus" ; --UNCHK
lin winter_N = mkN "talvi" "talvia" ;
lin winter_V = mkWV (k61A "talvehtia") ; --UNCHK
lin winy_A = mkWA (compoundA "viinin" (k38 "makuinen")) ; --UNCHK
lin wipe_N = mkWN (k2 "pyyhkäisy") ; --UNCHK
lin wipe_V = mkWV (k66 "pyyhkäistä") ; --UNCHK
lin wipe_V2 = L.wipe_V2 ;
lin wipe_out_V = mkWV (k64 "viedä") "hautaan" ; --UNCHK
lin wipe_out_V2 = mkWV2 (k64 "viedä") "hautaan" ; --UNCHK
lin wipeout_N = mkWN "kaatuminen" ; --UNCHK
lin wiper_N = mkWN (k10A "sulka") "tuulilasinpyyhkimen" ; --UNCHK
lin wire_N = mkWN (compoundN "metalli" (k9A "lanka")) ;
lin wire_V = mkWV (k53 "sähköistää") ; --UNCHK
lin wire_V2 = mkWV2 (k53 "sähköistää") ; --UNCHK
lin wirehair_N = mkWN (k5 "terrieri") "karkeakarvainen" ; --UNCHK
lin wireless_A = mkWA (k34A "langaton") ; --UNCHK
lin wireless_N = mkWN (k3 "radio") ; --UNCHK
lin wireman_N = mkWN (compoundN "sähkö" (k10 "asentaja")) ; --UNCHK
lin wirer_N = mkWN (compoundN "sähkö" (k10 "asentaja")) ; --UNCHK
lin wiretap_N = mkWN (compoundN "sala" (k2 "kuuntelu")) ; --UNCHK
lin wirework_N = mkWN (compoundN "lanka" (k1A "verkko")) ; --UNCHK
lin wireworm_N = mkWN (compoundN "juuri" (k1A "mato")) ; --UNCHK
lin wiriness_N = mkWN (k40 "sitkeys") ; --UNCHK
lin wiring_N = mkWN (compoundN "ase" (k38 "ntaminen")) "sähköjohtojen" ; --UNCHK
lin wiry_A = mkWA "johto-" ; --UNCHK
lin wisbech_PN = foreignPN "Wisbech" ;
lin wisdom_N = mkWN (k40 "viisaus") ; --UNCHK
lin wisdom_tooth_N = mkWN (compoundN "viisauden" (k41A "hammas")) ; --UNCHK
lin wise_A = mkWA (k41 "viisas") ; --UNCHK
lin wise_N = mkWN "tapaan" ; --UNCHK
lin wise_up_V = mkWV (k61A "oppia") ; --UNCHK
lin wiseacre_N = mkWN (k5A "neropatti") ; --UNCHK
lin wisecrack_N = mkWN (k2 "lohkaisu") ; --UNCHK
lin wisecrack_V = mkWV "herjailla" ; --UNCHK
lin wish_N = mkWN (k48 "toive") ;
lin wish_V = mkV "toivoa" ;
lin wish_V2 = mkV2 "toivoa" | mkV2 "toivottaa" partitive ;
lin wish_V2V = mkV2V (mkV "toivoa") genitive infPresPart ;
lin wish_VS = mkVS "toivoa" ;
lin wish_VV = mkVV "toivoa" infPresPartAgr ;
lin wishbone_N = mkWN (compoundN "toivomus" (k18 "luu")) ; --UNCHK
lin wishful_A = mkWA (k41A "toiveikas") ; --UNCHK
lin wishfulness_N = mkWN (k40 "toiveikkuus") ; --UNCHK
lin wishing_cap_N = mkWN (compoundN "toivomus" (k1A "hattu")) ; --UNCHK
lin wisp_N = mkWN (kH1 "tukko") ; --UNCHK
lin wisplike_A = mkWA (k38 "pikkuinen") ; --UNCHK
lin wispy_A = mkWA (k11 "hatara") ; --UNCHK
lin wistful_A = mkWA (k15 "haikea") ; --UNCHK
lin wistfulness_N = mkWN (k40 "haikeus") ; --UNCHK
lin wit_N = mkWN (k40 "älykkyys") ; --UNCHK
lin witch_N = mkWN (k10A "noita") ;
lin witch_doctor_N = mkWN (compoundN "poppa" (k42 "mies")) ; --UNCHK
lin witch_elm_N = mkWN (compoundN "vuori" (k10 "jalava")) ; --UNCHK
lin witch_hazel_N = mkWN (compoundN "hamamelis-kosteus" (k3 "emulsio")) ; --UNCHK
lin witchcraft_N = mkWN (k40 "noituus") ; --UNCHK
lin witchery_N = mkWN (k40 "noituus") ; --UNCHK
lin witchgrass_N = mkWN (compoundN "juola" (k10 "vehnä")) ; --UNCHK
lin witching_A = mkWA (k10 "lumoava") ; --UNCHK
lin witching_N = mkWN "noituminen" ; --UNCHK
lin witchlike_A = mkWA (compoundA "noita" (k38 "mainen")) ; --UNCHK
lin with_Prep = mkPrep "kanssa" ; ---- | mkPrep "luona" | mkPrep "tykönä" ; ---- split
lin with_a_view_to_Prep = mkPrep genitive "huomioonottaen" ; ---- should be accusative
lin with_regard_to_Prep = mkPrep "kohtaan" partitive ;
lin with_respect_to_Prep = mkPrep "suhteessa" illative ;
lin witham_PN = foreignPN "Witham" ;
lin withdraw_V = mkV "luopua" ;
lin withdraw_V2 = mkV2 (mkV (mkV "vetää") "pois") ;
lin withdrawal_N = mkN "pois" (mkN "vetäminen") ;
lin withdrawer_N = mkWN (k10 "nostaja") "talletuksen" ; --UNCHK
lin withe_N = mkWN (compoundN "pajun" (k9 "vitsa")) ; --UNCHK
lin wither_V = mkWV (k52 "lakastua") ; --UNCHK
lin wither_V2 = mkWV2 (k52 "lakastua") ; --UNCHK
lin witheringly_Adv = mkWAdv (k99 "murskaavasti") ; --UNCHK
lin withernsea_PN = foreignPN "Withernsea" ;
lin withers_N = mkWN (kH1 "säkä") ; --UNCHK
lin withhold_V2 = mkWV2 (k53A "pitää") "itsellään" ; --UNCHK
lin withholder_N = mkWN "pidättyjä" ; --UNCHK
lin withholding_N = mkWN (k39 "pidätys") ; --UNCHK
lin within_Adv = variants {} ; -- postPrep genitive "sisällä" ;
lin within_Prep = postPrep genitive "sisällä" ;
lin without_Prep = S.without_Prep ;
lin withstand_V2 = mkWV2 (k53 "kestää") ; --UNCHK
lin withstander_N = mkWN (k10 "vastustaja") ; --UNCHK
lin withy_N = mkWN (k1A "varpu") ; --UNCHK
lin witless_A = mkWA (k34A "älytön") ; --UNCHK
lin witness_N = mkWN (k10 "todistaja") ;
lin witness_V = mkWV (k53 "todistaa") ; --UNCHK
lin witness_V2 = mkWV2 (k53 "todistaa") ;
lin witness_box_N = mkWN (compoundN "todistajan" (k3 "aitio")) ; --UNCHK
lin witness_stand_N = mkWN (compoundN "todistajan" (k3 "aitio")) ; --UNCHK
lin witney_PN = foreignPN "Witney" ;
lin wits_N = mkWN (k1 "äly") ; --UNCHK
lin witticism_N = mkWN (k9 "herja") ; --UNCHK
lin witting_A = mkWA (k38 "tietoinen") ; --UNCHK
lin wittol_N = mkWN (compoundN "avio" (k42 "mies")) "petetty" ; --UNCHK
lin witty_A = mkWA (k10 "naseva") ; --UNCHK
lin wive_V = mkWV (k53A "ottaa") "vaimokseen" ; --UNCHK
lin wive_V2 = mkWV2 (k53A "ottaa") "vaimokseen" ; --UNCHK
lin wizard_A = mkWA (k10 "lumoava") ; --UNCHK
lin wizard_N = mkWN (k5A "ekspertti") ; --UNCHK
lin wizardry_N = mkWN (k40 "nerokkuus") ; --UNCHK
lin wizened_A = mkWA (k38 "ryppyinen") ; --UNCHK
lin woad_N = mkWN (compoundN "mor" (k1A "sinko")) ; --UNCHK
lin wobble_N = mkWN (k9A "huojunta") ; --UNCHK
lin wobble_V = mkWV (k52 "horjua") ; --UNCHK
lin wobble_V2 = mkWV2 (k52 "horjua") ; --UNCHK
lin wobbler_N = mkWN "horjuja" ; --UNCHK
lin wobbly_A = mkWA (k11 "hatara") ; --UNCHK
lin woburn_PN = foreignPN "Woburn" ;
lin woe_N = mkWN (k40 "surullisuus") ;
lin woebegone_A = mkWA (k38 "surullinen") ; --UNCHK
lin woeful_A = mkWA (k38 "surullinen") ; --UNCHK
lin wog_N = mkWN (compoundN "muta" (k1 "kuono")) ; --UNCHK
lin wok_N = mkWN (compoundN "wokki" (k1 "pannu")) ; --UNCHK
lin wokingham_PN = foreignPN "Wokingham" ;
lin wold_N = mkWN (k7 "nummi") ; --UNCHK
lin wolf's_bane_N = mkWN "lehtoukonhattu" ; --UNCHK
lin wolf_N = mkWN (k10A "hukka") ; --UNCHK
lin wolf_V2 = mkWV2 (k61 "hotkia") ; --UNCHK
lin wolf_cub_N = mkWN (compoundN "suden" (k1A "pentu")) ; --UNCHK
lin wolfhound_N = mkWN (compoundN "susi" (k10 "koira")) ; --UNCHK
lin wolfish_A = mkWA (compoundA "susi" (k38 "mainen")) ; --UNCHK
lin wolflike_A = mkWA (compoundA "susi" (k38 "mainen")) ; --UNCHK
lin wolfram_N = mkWN (k6 "volframi") ; --UNCHK
lin wolframite_N = mkWN (compoundN "volframi" (k5 "mineraali")) ; --UNCHK
lin wolfsbane_N = mkWN "lehtoukonhattu" ; --UNCHK
lin wollastonite_N = mkWN (compoundN "wollasto" (k5A "niitti")) ; --UNCHK
lin wolverhampton_PN = foreignPN "Wolverhampton" ;
lin woman_N = L.woman_N ;
lin womanhood_N = mkWN (k40 "naiseus") ; --UNCHK
lin womanish_A = mkWA (k38 "naismainen") ; --UNCHK
lin womanize_V = mkWV (k71 "tehdä") "naismaiseksi" ; --UNCHK
lin womanizer_N = mkWN (k12 "elostelija") ; --UNCHK
lin womanlike_A = mkWA (compoundA "naisen" (k38 "kaltainen")) ; --UNCHK
lin womanliness_N = mkWN (k40 "naismaisuus") ; --UNCHK
lin womanly_A = mkWA (k38 "feminiininen") ; --UNCHK
lin womb_N = mkWN (k1A "kohtu") ; --UNCHK
lin wombat_N = mkWN (k5A "vompatti") ; --UNCHK
lin wonder_N = mkWN (k40 "uteliaisuus") ; --UNCHK
lin wonder_V = mkV "ihmetellä" ;
lin wonder_VQ = L.wonder_VQ ;
lin wonderer_N = mkWN (k12 "ihailija") ; --UNCHK
lin wonderful_A = mkWA (k38 "fantastinen") ; --UNCHK
lin wonderingly_Adv = mkWAdv (k99 "kysyvästi") ; --UNCHK
lin wonderland_N = mkWN (compoundN "ihme" (k18 "maa")) ; --UNCHK
lin wonderment_N = mkWN (k2 "ihmettely") ; --UNCHK
lin wonderworking_A = mkWA (k10 "tekevä") "ihmeitä" ; --UNCHK
lin wondrous_A = mkWA (k38 "fantastinen") ; --UNCHK
lin wondrous_Adv = mkWAdv (compoundAdv "ihmeelli" (k99 "sen")) ; --UNCHK
lin wonky_A = mkWA (k11 "hatara") ; --UNCHK
lin wont_N = mkWN (k9A "tapa") ; --UNCHK
lin wonted_A = mkWA (k38 "totunnainen") ; --UNCHK
lin woo_V2 = mkWV2 (k67A "vokotella") ; --UNCHK
lin wood_N = L.wood_N ;
lin wood_block_N = mkWN (compoundN "puu" (k39 "kaiverrus")) ; --UNCHK
lin wood_pulp_N = mkWN (compoundN "puu" (k9 "massa")) ; --UNCHK
lin woodbine_N = mkWN "ruotsinköynnöskuusama" ; --UNCHK
lin woodborer_N = mkWN (k34A "selkärangaton") ; --UNCHK
lin woodbridge_PN = foreignPN "Woodbridge" ;
lin woodcarver_N = mkWN (k10 "kaivertaja") ; --UNCHK
lin woodcarving_N = mkWN (k39 "kaiverrus") "puun" ; --UNCHK
lin woodcock_N = mkWN (compoundN "lehto" (k10A "kurppa")) ; --UNCHK
lin woodcraft_N = mkWN (compoundN "puun" (k1 "veisto")) ; --UNCHK
lin woodcut_N = mkWN (compoundN "puu" (k39 "kaiverrus")) ; --UNCHK
lin woodcutter_N = mkWN (k6 "metsuri") ; --UNCHK
lin wooded_A = mkWA (k38 "metsäinen") ; --UNCHK
lin wooden_A = mkA "puinen" ;
lin woodenness_N = mkWN (k40 "kankeus") ; --UNCHK
lin woodhewer_N = mkWN "kipuaja" ; --UNCHK
lin woodiness_N = mkWN (compoundN "puu" (k1A "kuitu")) ; --UNCHK
lin woodland_N = mkWN (k10 "metsä") ; --UNCHK
lin woodlouse_N = mkWN (compoundN "maa" (k9 "siira")) ; --UNCHK
lin woodman_N = mkWN (compoundN "puu" (k38 "työläinen")) ; --UNCHK
lin woodpecker_N = mkWN (k9A "tikka") ; --UNCHK
lin woodpile_N = mkWN (compoundN "halko" (k1 "pino")) ; --UNCHK
lin woodruff_N = mkWN (k5A "tuoksumaratti") ; --UNCHK
lin woodscrew_N = mkWN (compoundN "puu" (k5 "ruuvi")) ; --UNCHK
lin woodshed_N = mkWN (compoundN "puu" (k9 "vaja")) ; --UNCHK
lin woodsia_N = mkWN (compoundN "kivi" (k5A "yrtti")) ; --UNCHK
lin woodsman_N = mkWN (compoundN "puu" (k38 "työläinen")) ; --UNCHK
lin woodsy_A = mkWA (k38 "metsäinen") ; --UNCHK
lin woodwaxen_N = mkWN (compoundN "pensasväri" (k48 "herne")) ; --UNCHK
lin woodwind_N = mkWN (compoundN "puu" (k33A "puhallin")) ; --UNCHK
lin woodwork_N = mkWN (compoundN "puun" (k1 "työstö")) ; --UNCHK
lin woodworker_N = mkWN (compoundN "puu" (k38 "työläinen")) ; --UNCHK
lin woodworm_N = mkWN (compoundN "puun" (k38 "tuholainen")) ; --UNCHK
lin woody_A = mkWA (k38 "puinen") ; --UNCHK
lin wooer_N = mkWN (k12 "kosija") ; --UNCHK
lin woof_N = mkWN (k48A "täyte") ; --UNCHK
lin woofer_N = mkWN (compoundN "basso" (k33A "kaiutin")) ; --UNCHK
lin wool_N = mkN "villa" ; --WN (kH1 "turkki") ;
lin woolen_A = mkWA (k38 "villainen") ; --UNCHK
lin woolgathering_A = mkWA (compoundA "haaveks" (k9 "iva")) ; --UNCHK
lin woolgathering_N = mkWN (k10 "unelma") ; --UNCHK
lin woollen_A = mkWA (k38 "villainen") ; --UNCHK
lin woolly_A = mkWA (k38 "villainen") ; --UNCHK
lin wooly_A = mkWA (k38 "villainen") ; --UNCHK
lin wop_N = mkWN (k39 "ilmaus") "halventava" ; --UNCHK
lin worcester_PN = foreignPN "Worcester" ;
lin word_N = mkN "sana" ;
lin word_V2 = mkWV2 (k67 "muotoilla") ; --UNCHK
lin word_division_N = mkWN (k39 "tavutus") ; --UNCHK
lin word_picture_N = mkWN (k39 "esitys") ; --UNCHK
lin wordbook_N = mkWN (compoundN "sana" (k9 "kirja")) ; --UNCHK
lin wordiness_N = mkWN (k40 "pitkäpiimäisyys") ; --UNCHK
lin wording_N = mkWN (k12 "fraseologia") ; --UNCHK
lin wordless_A = mkWA (k34A "äänetön") ; --UNCHK
lin wordmonger_N = mkWN "jaarittelija" ; --UNCHK
lin words_N = mkN "sana" ; ---- plural mkWN (k26 "kieli") ; --UNCHK
lin wordsmith_N = mkWN (compoundN "sana" (k10A "seppä")) ; --UNCHK
lin wordy_A = mkWA (k10 "ikävystyttävä") ; --UNCHK
lin work_1_V = mkV "työskennellä" ;
lin work_2_V = mkV "toimia" ;
lin work_N = mkN "työ" ;
lin work_V = mkV "toimia" ;
lin work_V2 = mkV2 "työstää" ;
lin work_off_V2 = mkWV2 (k56 "maksaa") "työnteolla" ; --UNCHK
lin work_on_V2 = mkWV2 (k62 "prosessoida") ; --UNCHK
lin work_out_V = mkWV (k67 "kuntoilla") ; --UNCHK
lin work_out_V2 = mkWV2 (k67 "kuntoilla") ; --UNCHK
lin work_over_V2 = mkWV2 (k62 "mukiloida") ; --UNCHK
lin work_study_N = mkWN (compoundN "työteho" (k39 "tutkimus")) ; --UNCHK
lin work_through_V2 = mkWV2 (k65 "käydä") "läpi" ; --UNCHK
lin work_together_V = advV OP_work_V OP_together_Adv ; -- guess-p-verb
lin work_up_V = mkWV (k74A "koota") ; --UNCHK
lin workable_A = mkWA (k38 "mahdollinen") ; --UNCHK
lin workaday_A = mkWA (k38 "päivittäinen") ; --UNCHK
lin workaholic_N = mkWN (compoundN "työ" (k5 "narkomaani")) ; --UNCHK
lin workaholism_N = mkWN (compoundN "työ" (k12 "narkomania")) ; --UNCHK
lin workbag_N = mkWN (compoundN "työkalu" (k1A "laukku")) ; --UNCHK
lin workbasket_N = mkWN (compoundN "työkalu" (k1A "laukku")) ; --UNCHK
lin workbench_N = mkWN (k5A "penkki") ; --UNCHK
lin workboard_N = mkWN (compoundN "työ" (k1 "taso")) ; --UNCHK
lin workbook_N = mkWN (compoundN "työ" (k9 "kirja")) ; --UNCHK
lin workbox_N = mkWN (compoundN "työkalu" (k1A "laukku")) ; --UNCHK
lin workday_N = mkWN (compoundN "työ" (k10 "päivä")) ; --UNCHK
lin worker_N = mkN "työläinen" ;
lin workforce_N = mkN "työvoima" ;
lin workhorse_N = mkWN (compoundN "työ" (k38 "hevonen")) ; --UNCHK
lin workhouse_N = mkWN (compoundN "pakkotyö" (k39 "laitos")) ; --UNCHK
lin working_A = mkA "toimiva" | mkA "työtätekevä" ; ---- split
lin working_N = mkWN (k9A "louhinta") ; --UNCHK
lin working_class_A = mkA "työväenluokkainen" ;
lin working_out_N = mkWN (k9A "laadinta") "huolellinen" ; --UNCHK
lin workington_PN = foreignPN "Workington" ;
lin workload_N = mkWN (compoundN "työ" (k10 "määrä")) ; --UNCHK
lin workman_N = mkWN (k2 "henkilö") "työtä" "tekevä" ; --UNCHK
lin workmanlike_A = mkWA (k38 "ammattimainen") ; --UNCHK
lin workmanship_N = mkWN (compoundN "ammatti" (k1A "taito")) ; --UNCHK
lin workmate_N = mkWN (compoundN "työ" (k6 "kaveri")) ; --UNCHK
lin workpiece_N = mkWN (compoundN "työ" (k48 "kappale")) ; --UNCHK
lin workplace_N = mkWN (compoundN "työ" (k9A "paikka")) ; --UNCHK
lin workroom_N = mkWN (compoundN "työ" (k48 "huone")) ; --UNCHK
lin works_N = mkN "laitos" | mkWN (compoundN "suur" (k19 "työ")) ; ---- split: water works ; collected words
lin worksheet_N = mkWN (compoundN "laskenta" (k4A "taulukko")) ; --UNCHK
lin workshop_N = mkWN (k5 "seminaari") ; --UNCHK
lin worksop_PN = foreignPN "Worksop" ;
lin workspace_N = mkWN (compoundN "työ" (k9 "tila")) ; --UNCHK
lin workstation_N = mkWN (compoundN "työ" (k10 "asema")) ; --UNCHK
lin worktable_N = mkWN (compoundN "työ" (k10A "pöytä")) ; --UNCHK
lin workweek_N = mkWN (compoundN "työ" (k1A "viikko")) ;
lin world_N = mkWN (k13 "maailma") ;
lin world_weary_A = mkA (mkN "elämään" (mkN "kyllästynyt")) ; ----sanaliitto
lin worldliness_N = mkWN "ulkopuolisuus" ; --UNCHK
lin worldling_N = mkWN (k41A "asukas") "maan" ; --UNCHK
lin worldly_A = mkWA (k38 "mainen") ; --UNCHK
lin worldwide_A = mkWA (k5 "universaali") ; --UNCHK
lin worldwide_Adv = mkAdv "koko maailmassa" ;
lin worm_N = L.worm_N ;
lin worm_V2 = mkWV2 (k61A "vääntelehtiä") ; --UNCHK
lin worm_gear_N = mkWN (compoundN "kierukka" (k2 "pyörästö")) ; --UNCHK
lin wormcast_N = mkWN (k6 "fossiili") "madon" ; --UNCHK
lin wormhole_N = mkWN (compoundN "madon" (k10A "reikä")) ; --UNCHK
lin wormwood_N = mkWN (compoundN "koi" (k1 "ruoho")) ; --UNCHK
lin wormy_A = mkWA (k10 "mateleva") ; --UNCHK
lin worried_A = variants {} ; --
lin worrier_N = mkWN (k10 "valittaja") ; --UNCHK
lin worrisome_A = mkWA (compoundA "huoles" (k10 "tuttava")) ;
lin worry_N = mkWN (k9 "vaiva") ; --UNCHK
lin worry_V = mkV vOlla "huolissaan" ; --f58
lin worry_V2 = mkV2 "huolestuttaa" partitive ;
lin worry_VS = mkVS (caseV partitive (mkV "huolettaa")) ;
lin worrying_A = variants {} ; --
lin worrying_N = mkWN (k2 "liikuttelu") ; --UNCHK
lin worse_A = mkWA "pahempi" ; --UNCHK
lin worse_Adv = mkWAdv "huonommin" ; --UNCHK
lin worse_N = mkWN "pahempi" ; --UNCHK
lin worsen_V = mkWV (k52A "pahentua") ; --UNCHK
lin worsen_V2 = mkWV2 (k52A "pahentua") ; --UNCHK
lin worsening_N = mkWN (compoundN "huono" (k38 "neminen")) ; --UNCHK
lin worship_N = mkWN (k9A "palvonta") ; --UNCHK
lin worship_V = mkWV (k67 "ihailla") ; --UNCHK
lin worship_V2 = mkWV2 (k67 "ihailla") ; --UNCHK
lin worshiper_N = mkWN (k38 "uskovainen") ; --UNCHK
lin worshipful_A = mkWA (k10 "kunnioittava") ; --UNCHK
lin worshipper_N = mkWN (k38 "uskovainen") ; --UNCHK
lin worst_Adv = mkWAdv (k99 "pahimmin") ; --UNCHK
lin worst_V2 = mkWV2 (k73 "kerätä") "voitto" ; --UNCHK
lin worsted_N = mkWN (k41A "kampalankakangas") ; --UNCHK
lin wort_N = mkWN (k48A "vierre") ; --UNCHK
lin worth_A = mkWA (k5 "arvoinen") ; --f66
lin worth_N = mkWN (k1 "arvo") ;
lin worth_Prep = mkPrep "arvoinen" ; ---- cat
lin worthiness_N = mkWN (k40 "arvokkuus") ; --UNCHK
lin worthing_PN = foreignPN "Worthing" ;
lin worthless_A = mkWA (k34A "arvoton") ;
lin worthlessness_N = mkWN (k40 "taitamattomuus") ; --UNCHK
lin worthwhile_A = mkWA (k38 "arvoinen") "vaivan" ;
lin worthwhileness_N = mkWN (k40 "hyödyllisyys") ; --UNCHK
lin worthy_A = mkA (mkN "varteen" (mkN "otettava")) ;
lin worthy_N = mkWN (compoundN "arvo" (k2 "henkilö")) ; --UNCHK
lin would_be_A = mkA "haluava" ;
lin wound_N = mkWN (compoundN "haa" (k38 "voittaminen")) ;
lin wound_V2 = mkWV2 (k53A "satuttaa") ; --UNCHK
lin woven_A = mkWA "kudottu" ; --UNCHK
lin wow_Interj = mkInterj "vau" ;
lin wow_N = mkWN (k1A "juttu") "hauska" ; --UNCHK
lin wpm_N = mkWN "wpm" ; --UNCHK
lin wrack_N = mkWN (compoundN "meri" (k10 "levä")) "kuivatettu" ; --UNCHK
lin wrack_V2 = mkWV2 (k58A "särkeä") ; --UNCHK
lin wraith_N = mkWN (k1 "haamu") ; --UNCHK
lin wrangle_N = mkWN (k9A "riita") ; --UNCHK
lin wrangle_V = mkWV (k62 "nujakoida") ; --UNCHK
lin wrangler_N = mkWN (compoundN "karja" (k32 "paimen")) ; --UNCHK
lin wrap_N = mkWN (k5 "huivi") ; --UNCHK
lin wrap_V = mkV "paketoitua" ; --mkWV (k62 "paketoida") ;
lin wrap_V2 = mkWV2 (k62 "paketoida") ; --UNCHK
lin wrap_up_V = mkWV (k52A "pukeutua") ; --UNCHK
lin wrap_up_V2 = mkWV2 (k52A "pukeutua") ; --UNCHK
lin wraparound_N = mkWN "kietaisu-" ; --UNCHK
lin wrapper_N = mkWN (compoundN "aamu" (k5A "takki")) ; --UNCHK
lin wrapping_N = mkWN (k48 "kääre") ; --UNCHK
lin wrasse_N = mkWN (compoundN "huuli" (k9 "kala")) ; --UNCHK
lin wrath_N = mkWN (k39 "suuttumus") ; --UNCHK
lin wrathful_A = mkWA (k10 "raivoisa") ; --UNCHK
lin wreak_V2 = mkWV2 (k71 "tehdä") ; --UNCHK
lin wreath_N = mkWN (k5 "kranssi") ; --UNCHK
lin wreathe_V = mkWV (k52A "sitoa") "seppele" ; --UNCHK
lin wreathe_V2 = mkWV2 (k52A "sitoa") "seppele" ; --UNCHK
lin wreck_N = mkWN (k1A "hylky") ; --UNCHK
lin wreck_V2 = mkV2 "romuttaa" ; --mkWV2 (k58A "särkeä") ;
lin wreckage_N = mkN "romuttuminen" ;
lin wrecker_N = mkWN (compoundN "hinaus" (k1 "auto")) ; --UNCHK
lin wren_N = mkWN (k38 "peukaloinen") ; --UNCHK
lin wrench_N = mkWN (compoundN "kiinto" (k33 "avain")) ; --UNCHK
lin wrench_V2 = mkWV2 (k53A "niksauttaa") ; --UNCHK
lin wrest_V2 = mkWV2 (k66 "kiskaista") ; --UNCHK
lin wrester_N = mkWN (k10 "kiskoja") ; --UNCHK
lin wrestle_V = mkV "kamppailla" ; --mkWV (k67 "painiskella") ;
lin wrestle_V2 = mkWV2 (k67 "painiskella") ; --UNCHK
lin wrestler_N = mkWN (k12 "painija") ; --UNCHK
lin wrestling_N = mkWN (k50 "vapaapaini") ; --UNCHK
lin wretch_N = mkWN (k1 "raasu") ; --UNCHK
lin wretched_A = mkWA (k38 "viheliäinen") ; --UNCHK
lin wretchedness_N = mkWN (k40 "kelvottomuus") ; --UNCHK
lin wrexham_PN = foreignPN "Wrexham" ;
lin wrick_N = mkWN (k39 "venähdys") ; --UNCHK
lin wrick_V2 = mkWV2 (k53A "niksauttaa") ; --UNCHK
lin wriggle_N = mkWN (k2 "kiemurtelu") ; --UNCHK
lin wriggle_V = mkWV (k61A "vääntelehtiä") ; --UNCHK
lin wriggle_V2 = mkWV2 (k61A "vääntelehtiä") ; --UNCHK
lin wriggler_N = mkWN (k10A "toukka") "hyttysen" ; --UNCHK
lin wright_N = mkWN (k10A "seppä") ; --UNCHK
lin wring_N = mkWN (k1A "vääntö") ; --UNCHK
lin wring_V2 = mkWV2 (k67A "väännellä") ; --UNCHK
lin wringer_N = mkWN (k6 "mankeli") ; --UNCHK
lin wrinkle_N = mkWN (k10 "menetelmä") ; --UNCHK
lin wrinkle_V = mkWV (k52A "poimuttua") ; --UNCHK
lin wrinkle_V2 = mkWV2 (k52A "poimuttua") ; --UNCHK
lin wrinkly_A = mkWA (k38 "kurttuinen") ; --UNCHK
lin wrist_N = mkWN (k48A "ranne") ; --UNCHK
lin wristband_N = mkWN (k48A "ranneke") "kellon" ; --UNCHK
lin wristlet_N = mkWN (k48A "ranneke") ; --UNCHK
lin wristwatch_N = mkWN (compoundN "ranne" (k1 "kello")) ; --UNCHK
lin writ_N = mkWN (k39 "määräys") "oikeuden" ; --UNCHK
lin writ_large_A = mkWA (compoundA "ilmi" (k10 "selvä")) ; --UNCHK
lin write_V = mkWV (k53A "kirjoittaa") ;
lin write_V2 = L.write_V2 ;
lin write_VS = mkWVS (k53A "kirjoittaa") ;
lin write_down_V2 = mkWV2 (k53A "suorittaa") "poistoja" ; --UNCHK
lin write_in_V = mkWV (k53A "kirjoittaa") ; --UNCHK
lin write_off_V2 = mkWV2 (k53A "suorittaa") "poistoja" ; --UNCHK
lin write_out_V2 = mkWV2 (k53A "kirjoittaa") ; --UNCHK
lin write_up_N = mkWN (k39 "kertomus") ; --UNCHK
lin write_up_V2 = mkWV2 (k62 "raportoida") ; --UNCHK
lin writer_N = mkWN (k12 "kirjailija") ; --f55
lin writhe_V = mkWV (k61A "vääntelehtiä") ; --UNCHK
lin writing_N = mkWN (compoundN "kirjo" (k38 "ittaminen")) ;
lin writing_desk_N = mkWN (compoundN "kirjoitus" (k10A "pöytä")) ; --UNCHK
lin writing_ink_N = mkWN (compoundN "kirjoitus" (k48 "muste")) ; --UNCHK
lin writing_paper_N = mkWN (compoundN "kirjoitus" (k6 "paperi")) ; --UNCHK
lin written_A = variants {} ; --
lin writtle_PN = foreignPN "Writtle" ;
lin wrong_A = mkWA (k10 "väärä") ;
lin wrong_Adv = mkWAdv (k99 "virheellisesti") ; --UNCHK
lin wrong_N = mkWN (k1A "vahinko") ; --UNCHK
lin wrong_V2 = mkWV2 (k71 "tehdä") "vääryyttä" ; --UNCHK
lin wrongdoer_N = mkWN (k38 "rikollinen") ; --UNCHK
lin wrongdoing_N = mkWN (k1A "teko") "väärä" ; --UNCHK
lin wrongful_A = mkWA (k10 "väärä") ; --UNCHK
lin wrong_headed_A = mkWA (compoundA "jää" (k38 "räpäinen")) ; --UNCHK
lin wrongness_N = mkWN (k40 "vääryys") ; --UNCHK
lin wroth_A = mkWA (k10 "raivoisa") ; --UNCHK
lin wroughton_PN = foreignPN "Wroughton" ;
lin wry_A = mkWA (k38 "ironinen") ; --UNCHK
lin wrymouth_N = mkWN (compoundN "mutru" (k18 "suu")) ; --UNCHK
lin wryneck_N = mkWN (compoundN "käen" (k9A "piika")) ; --UNCHK
lin wuhan_PN = foreignPN "Wuhan" ;
lin wulfenite_N = mkWN (compoundN "wulfe" (k5A "niitti")) ; --UNCHK
lin wuppertal_PN = foreignPN "Wuppertal" ;
lin wurtzite_N = mkWN (compoundN "wurziittikide" (k9 "hila")) ; --UNCHK
lin wymondham_PN = foreignPN "Wymondham" ;
lin wyoming_PN = foreignPN "Wyoming" ;
lin wyvern_N = mkWN (compoundN "lohi" (k48 "käärme")) ; --UNCHK
lin x_ray_N = mkWN (compoundN "röntgen" (k10 "kuva")) ; --UNCHK
lin x_ray_V2 = mkWV2 (k73 "röntgenkuvata") partitive ;
lin xanthate_N = mkWN "ksantaatti" ; --UNCHK
lin xanthelasma_N = mkWN "ksantelasma" ; --UNCHK
lin xanthine_N = mkWN "ksantiini" ; --UNCHK
lin xanthoma_N = mkWN (compoundN "rasva" (k10 "kertymä")) "ihon" ; --UNCHK
lin xanthomonad_N = mkWN "xanthomonad" ; --UNCHK
lin xanthophyll_N = mkWN (compoundN "ksanto" (k5 "fylli")) ; --UNCHK
lin xanthopsia_N = mkWN "ksantopsia" ; --UNCHK
lin xanthosis_N = mkWN "xanthosis" ; --UNCHK
lin xenogeneic_A = mkWA "ksenogeeninen" ; --UNCHK
lin xenolith_N = mkWN (k10 "sulkeuma") ; --UNCHK
lin xenon_N = mkWN (k5 "ksenon") ; --UNCHK
lin xenophobia_N = mkWN (k1A "pelko") "muukalaisuuden" ; --UNCHK
lin xenophobic_A = mkWA "muukalaisvihamielinen" ; --UNCHK
lin xenotime_N = mkWN (compoundN "kseno" (k5 "tiimi")) ; --UNCHK
lin xenotransplant_N = mkWN (compoundN "vieraslaji" (k1A "siirto")) ; --UNCHK
lin xeranthemum_N = mkWN (k10A "kukka") "Xeranthemum-suvun" ; --UNCHK
lin xeric_A = mkWA "kseerinen" ; --UNCHK
lin xeroderma_N = mkWN "kserodermia" ; --UNCHK
lin xerographic_A = mkWA "kserografinen" ; --UNCHK
lin xerography_N = mkWN (k12 "kserografia") ; --UNCHK
lin xerophthalmia_N = mkWN "conjunctivitis" "arida" ; --UNCHK
lin xerophytic_A = mkWA "kserofyytti" ; --UNCHK
lin xeroradiography_N = mkWN "kseroradiografia" ; --UNCHK
lin xerostomia_N = mkWN (k10 "ongelma") "kuivan" "suun" ; --UNCHK
lin xerox_N = mkWN (compoundN "valokopio" (k48 "kone")) ; --UNCHK
lin xerox_V2 = mkWV2 (k62 "kopioida") ; --UNCHK
lin xi_N = mkWN "ksii" ; --UNCHK
lin xmas_N = mkWN (k1 "joulu") ; --UNCHK
lin xylem_N = mkWN (compoundN "puu" (k48 "aine")) ; --UNCHK
lin xylene_N = mkWN "ksyloli" ; --UNCHK
lin xylophone_N = mkWN (k5 "ksylofoni") ; --UNCHK
lin xylophonist_N = mkWN (compoundN "ksylofo" (k5 "nisti")) ; --UNCHK
lin xylosma_N = mkWN "Xylosma" "congestum" ; --UNCHK
lin yacca_N = mkWN "Podocarpus" "coriaceus" ; --UNCHK
lin yacht_N = mkWN (kH1 "jahti") ; --UNCHK
lin yacht_V = mkWV (k61A "purjehtia") ; --UNCHK
lin yacht_club_N = mkWN (compoundN "pursi" (k9 "seura")) ; --UNCHK
lin yachting_N = mkWN (k2 "veneily") ; --UNCHK
lin yachtsman_N = mkWN (k12 "purjehtija") ; --UNCHK
lin yagi_N = mkWN (k6 "antenni") "Yagin" ; --UNCHK
lin yahoo_N = mkWN "Yahoo" ; --UNCHK
lin yak_N = mkWN (kH1 "jakki") ; --UNCHK
lin yam_N = mkWN (k5 "jamssi") ; --UNCHK
lin yammer_V = mkWV (k66 "kitistä") ; --UNCHK
lin yang_N = mkWN "yang" ; --UNCHK
lin yank_N = mkWN (k5A "jenkki") ; --UNCHK
lin yank_V2 = mkWV2 (k66 "riuhtaista") ;
lin yankee_N = mkWN (k5A "jenkki") ; --UNCHK
lin yanker_N = mkWN (compoundN "kiskai" (k9 "sija")) ; --UNCHK
lin yap_N = mkWN (kH1 "turpa") ; --UNCHK
lin yap_V = mkWV (k52A "haukkua") ; --UNCHK
lin yard_N = mkWN (k39 "aitaus") ; --UNCHK
lin yard_measure_N = mkWN (compoundN "mitta" (k5A "keppi")) ; --UNCHK
lin yardage_N = mkWN (compoundN "väli" (k9 "matka")) ; --UNCHK
lin yardarm_N = mkWN (k18 "pää") ; --UNCHK
lin yarder_N = mkWN (k5 "vinssi") ; --UNCHK
lin yardgrass_N = mkWN (compoundN "kanajalka" (k10 "heinä")) ; --UNCHK
lin yardie_N = mkWN (k6 "gangsteri") ; --UNCHK
lin yardman_N = mkWN (compoundN "ulkotyö" (k42 "mies")) ; --UNCHK
lin yardmaster_N = mkWN (compoundN "työn" (k10 "johtaja")) "ratapihan" ; --UNCHK
lin yardstick_N = mkWN (compoundN "mitta" (k5A "keppi")) ; --UNCHK
lin yarmouth_PN = foreignPN "Yarmouth" ;
lin yarmulke_N = mkN "kipa" "kipan" "kipoja" ;
lin yarn_N = mkWN (k9 "rihma") ; --UNCHK
lin yarn_V = mkWV (k52A "kertoa") "juttu" ; --UNCHK
lin yarrow_N = mkWN (compoundN "sian" (k2 "kärsämö")) ; --UNCHK
lin yashmak_N = mkWN "niqab" ; --UNCHK
lin yataghan_N = mkWN "yatagan" ; --UNCHK
lin yate_PN = foreignPN "Yate" ;
lin yateley_PN = foreignPN "Yateley" ;
lin yautia_N = mkWN "Xanthosoma" "atrovirens" ; --UNCHK
lin yaw_N = mkWN (compoundN "äkki" (k39 "käännös")) ; --UNCHK
lin yaw_V = mkWV (k53A "muuttaa") "suuntaa" ; --UNCHK
lin yawl_N = mkWN (k5 "jooli") ; --UNCHK
lin yawn_N = mkWN (k39 "haukotus") ; --UNCHK
lin yawn_V = mkWV (k67A "haukotella") ; --UNCHK
lin yawner_N = mkWN (compoundN "hauk" (k12 "ottelija")) ; --UNCHK
lin yaws_N = mkWN (compoundN "vaapukkasyylä" (k5A "tauti")) ; --UNCHK
lin yea_Adv = mkWAdv (k99 "joo") ; --UNCHK
lin yea_N = mkWN (k99 "jaa") ; --UNCHK
lin yeah_Adv = mkWAdv (k99 "joo") ; --UNCHK
lin yeah_Interj = mkInterj "joo" ; --mkInterj "yess" ;
lin year_N = L.year_N | year_alt_N ;
lin yearbook_N = mkWN (compoundN "vuosi" (k9 "kirja")) ;
lin yearling_N = mkN "vuosikas" ;
lin yearlong_A = mkWA (k38 "mittainen") "vuoden" ; --UNCHK
lin yearly_A = mkWA (k38 "vuosittainen") ;
lin yearly_Adv = mkAdv "vuosittain" | adjAdv yearly_A ; -- derived
lin yearn_V = mkWV (k73A "kaivata") ; --UNCHK
lin yearning_N = mkWN (k17 "kaipuu") ; --UNCHK
lin yearningly_Adv = mkWAdv "kaivaten" ; --UNCHK
lin yeast_N = mkWN (k9 "hiiva") ;
lin yeasty_A = mkWA (compoundA "hiiva" (k38 "mainen")) ; --UNCHK
lin yell_N = mkWN (k2 "karjaisu") ; --UNCHK
lin yell_V = mkWV (k52A "kirkua") ; --UNCHK
lin yell_V2 = mkWV2 (k52A "kirkua") ; --UNCHK
lin yellow_A = L.yellow_A ;
lin yellow_N = mkWN (k40 "keltaisuus") ; --UNCHK
lin yellow_V = mkWV (k52 "kellastua") ; --UNCHK
lin yellow_V2 = mkWV2 (k52 "kellastua") ; --UNCHK
lin yellow_flag_N = mkWN "keltakurjenmiekka" ; --UNCHK
lin yellowcake_N = mkWN (compoundN "uraani" (k5 "malmi")) "rikastettu" ; --UNCHK
lin yellowfin_N = mkWN (compoundN "keltaevätonni" (k9 "kala")) ; --UNCHK
lin yellowhammer_N = mkWN (compoundN "kelta" (k1A "sirkku")) ; --UNCHK
lin yellowish_A = mkWA (k10 "kellertävä") ; --UNCHK
lin yellowlegs_N = mkWN (k1 "viklo") ; --UNCHK
lin yellowness_N = mkWN (k40 "keltaisuus") ; --UNCHK
lin yellowtail_N = mkWN "Seriola" "dorsalis" ; --UNCHK
lin yellowwood_N = mkWN (compoundN "yellowwood-" (k18 "puu")) ; --UNCHK
lin yelp_V = mkWV (k52A "haukkua") ; --UNCHK
lin yemen_PN = foreignPN "Jemen" ;
lin yemeni_A = mkWA (compoundA "Jem" (k36 "enin")) ; --UNCHK
lin yemeni_N = mkWN "jemeniläinen" ; --UNCHK
lin yen_N = mkN "jeni" ;
lin yen_V = mkWV (k52A "riutua") "ikävästä" ; --UNCHK
lin yenta_N = mkWN "juoruilija" ; --UNCHK
lin yeoman_N = mkWN (compoundN "talon" (k10A "poika")) ; --UNCHK
lin yeovil_PN = foreignPN "Yeovil" ;
lin yep_Interj = variants {} ; --
lin yerevan_PN = foreignPN "Jerevan" ;
lin yes_Interj = mkInterj "kyllä" ;
lin yes_N = mkWN (k99 "jaa") ; --UNCHK
lin yes_Utt = S.yes_Utt ;
lin yeshiva_N = mkWN (compoundN "Ješ" (k9 "iva")) ; --UNCHK
lin yesterday_Adv = mkAdv "eilen" ;
lin yesterday_N = mkN (lin NK {s = d38 "eilinen"}) ;
lin yet_1_Adv = mkAdv "vielä" ;
lin yet_2_Adv = mkAdv "kuitenkin" | mkAdv "kuitenkaan" ;
lin yet_AdV = mkAdV "yhä" ;
lin yet_Adv = mkAdv "vielä" ;
lin yeti_N = mkWN (compoundN "lumi" (k42 "mies")) ; --UNCHK
lin yew_N = mkWN (k24 "marjakuusi") ; --UNCHK
lin yiddish_N = mkWN "Jiddiš" ; --UNCHK
lin yield_N = mkN "tuotos" ;
lin yield_V2 = mkV2 "tuottaa" ;
lin yield_up_V = mkWV (k53A "luovuttaa") ; --UNCHK
lin yin_N = mkWN "yin" ; --UNCHK
lin yip_N = mkWN (k39 "ulvahdus") ; --UNCHK
lin yips_N = mkWN (k40 "jännittyneisyys") ; --UNCHK
lin ylem_N = mkWN "ylem" ; --UNCHK
lin yli_ii_PN = mkPN "Yli-Ii" ;
lin ylihärmä_PN = mkPN "Ylihärmä" ;
lin ylikiiminki_PN = mkPN "Ylikiiminki" ;
lin ylistaro_PN = mkPN "Ylistaro" ;
lin ylitornio_PN = mkPN "Ylitornio" ;
lin ylivieska_PN = mkPN "Ylivieska" ;
lin ylämaa_PN = mkPN "Ylämaa" ;
lin yläne_PN = mkPN "Yläne" ;
lin ylöjärvi_PN = mkPN (mkN "Ylöjärvi" "Ylöjärviä") ;
lin yob_N = mkWN (k10 "rettelöijä") ; --UNCHK
lin yobibit_N = mkWN (compoundN "yobi" (k5A "bitti")) ; --UNCHK
lin yodel_N = mkWN (k39 "jodlaus") ; --UNCHK
lin yodel_V = mkWV (k56 "laulaa") "diskantissa" ; --UNCHK
lin yodel_V2 = mkWV2 (k56 "laulaa") "diskantissa" ; --UNCHK
lin yodeling_N = mkWN (k39 "jodlaus") ; --UNCHK
lin yodeller_N = mkWN (compoundN "jod" (k9 "laaja")) ; --UNCHK
lin yodh_N = mkWN "jod" ; --UNCHK
lin yoga_N = mkWN (k10 "jooga") ; --UNCHK
lin yoghourt_N = mkWN (k5A "jogurtti") ; --UNCHK
lin yoghurt_N = mkWN (k5A "jogurtti") ; --UNCHK
lin yogi_N = mkWN (k5 "joogi") ; --UNCHK
lin yogistic_A = mkWA "jooga-" ; --UNCHK
lin yogurt_N = mkWN (k5A "jogurtti") ; --UNCHK
lin yoke_N = mkWN (k41A "ies") ; --UNCHK
lin yoke_V = mkWV (k53 "iestää") ; --UNCHK
lin yoke_V2 = mkWV2 (k53 "iestää") ; --UNCHK
lin yokel_N = mkWN (k6 "öykkäri") ; --UNCHK
lin yokohama_PN = foreignPN "Jokohama" ;
lin yolk_N = mkWN (k38 "keltuainen") ; --UNCHK
lin yon_A = mkWA (k101 "tuo") ; --UNCHK
lin yon_Adv = mkAdv "tuo" ;
lin yonder_A = mkWA (k101 "tuo") ; --UNCHK
lin yore_N = mkWN "ennen" "vanhaan" ; --UNCHK
lin york_PN = foreignPN "York" ;
lin yorkshire_PN = foreignPN "Yorkshire" ;
lin yottabit_N = mkWN (compoundN "jotta" (k5A "bitti")) ; --UNCHK
lin yottabyte_N = mkWN (compoundN "jotta" (k1 "tavu")) ; --UNCHK
lin youPlFem_Pron = optProDrop S.youPl_Pron ;
lin youPl_Pron = optProDrop S.youPl_Pron ;
lin youPolFem_Pron = optProDrop S.youPol_Pron ;
lin youPol_Pron = optProDrop S.youPol_Pron ;
lin youSgFem_Pron = optProDrop S.youSg_Pron ;
lin youSg_Pron = optProDrop S.youSg_Pron ;
lin young_A = L.young_A ;
lin young_N = mkWN (k38 "jälkeläinen") ; --UNCHK
lin younger_A = mkWA "nuorempi" ; --UNCHK
lin youngish_A = mkWA "nuorehko" ; --UNCHK
lin youngness_N = mkWN (k40 "nuoruus") ; --UNCHK
lin youngster_N = mkWN (k38 "nuorukainen") ;
lin youth_N = mkN "nuoruus" ;
lin youthful_A = mkWA (k41A "nuorekas") ; --UNCHK
lin youthfulness_N = mkWN (k40 "nuorekkuus") ; --UNCHK
lin yowl_V = mkWV (k52A "monkua") ; --UNCHK
lin ypäjä_PN = mkPN "Ypäjä" ;
lin yr_N = mkWN (k27 "vuosi") ; --UNCHK
lin ystradgynlais_PN = foreignPN "Ystradgynlais" ;
lin ytterbium_N = mkWN "atominumero" "70" ; --UNCHK
lin yttrium_N = mkWN "atominumero" "39" ; --UNCHK
lin yuan_N = mkN "yuan" ;
lin yucca_N = mkWN (k10A "jukka") ; --UNCHK
lin yugoslav_A = mkWA (k38 "jugoslavialainen") ; --UNCHK
lin yugoslav_N = mkWN (k5 "jugoslaavi") ; --UNCHK
lin yugoslavia_PN = foreignPN "Jugoslavia" ;
lin yugoslavian_A = mkWA (k38 "jugoslavialainen") ; --UNCHK
lin yugoslavian_N = mkWN (k5 "jugoslaavi") ; --UNCHK
lin yukon_PN = foreignPN "Yukon" ;
lin yule_N = mkWN (k9A "joulunaika") ; --UNCHK
lin yule_log_N = mkWN (compoundN "joulu" (k1A "halko")) ; --UNCHK
lin yuletide_N = mkWN (k9A "joulunaika") ; --UNCHK
lin yuppie_N = mkWN (k5A "juppi") ; --UNCHK
lin yurt_N = mkWN "jurtta" ; --UNCHK
lin zabaglione_N = mkWN "zabaione" ; --UNCHK
lin zagreb_PN = foreignPN "Zagreb" ;
lin zaire_PN = mkPN "Zaire" ;
lin zairean_A = mkWA "Zairen" ; --UNCHK
lin zairean_N = mkWN (compoundN "zaire" (k38 "lainen")) ; --UNCHK
lin zakat_N = mkWN (compoundN "almu" (k1 "vero")) ; --UNCHK
lin zambia_PN = foreignPN "Sambia" ;
lin zambian_A = mkWA (compoundA "sambi" (k38 "alainen")) ; --UNCHK
lin zambian_N = mkWN (compoundN "sambi" (k38 "alainen")) ; --UNCHK
lin zamia_N = mkWN (compoundN "käpy" (k1 "palmu")) ; --UNCHK
lin zany_A = mkWA (compoundA "klovni" (k38 "mainen")) ; --UNCHK
lin zany_N = mkWN (k5 "aasi") ; --UNCHK
lin zap_N = mkWN (k10 "tapahtuma") "yhtäkkinen" ; --UNCHK
lin zap_V2 = mkWV2 (k53A "lämmittää") "mikrossa" ; --UNCHK
lin zapper_N = mkWN (compoundN "kauko" (k33A "säädin")) ; --UNCHK
lin zaragoza_PN = foreignPN "Zaragoza" ;
lin zarf_N = mkWN (k48A "pidike") ; --UNCHK
lin zayin_N = mkWN "zajin" ; --UNCHK
lin zeal_N = mkWN (k40 "uskaliaisuus") ; --UNCHK
lin zealander_N = mkWN (compoundN "själlanti" (k38 "lainen")) ; --UNCHK
lin zealotFem_N = mkWN (k12 "intoilija") ; --UNCHK
lin zealotMasc_N = mkWN (k12 "intoilija") ; --UNCHK
lin zealotry_N = mkWN (k2 "kiihkoilu") ; --UNCHK
lin zealous_A = mkWA (k38 "intohimoinen") ; --UNCHK
lin zeaxanthin_N = mkWN "zeaksantiini" ; --UNCHK
lin zebibit_N = mkWN (compoundN "zebi" (k5A "bitti")) ; --UNCHK
lin zebra_N = mkWN (k9 "seepra") ; --UNCHK
lin zebrawood_N = mkWN (compoundN "seepra" (k18 "puu")) ; --UNCHK
lin zebu_N = mkWN (compoundN "ryhä" (k10A "härkä")) ; --UNCHK
lin zee_N = mkWN "z" ; --UNCHK
lin zen_N = mkWN (k1A "lappu") ; --UNCHK
lin zenith_N = mkWN (k5A "zeniitti") ; --UNCHK
lin zenithal_A = mkWA "lakipiste-" ; --UNCHK
lin zeolite_N = mkWN "zeoliitti" ; --UNCHK
lin zephyr_N = mkWN "Zefyros" ; --UNCHK
lin zeppelin_N = mkWN (k5 "zeppeliini") ; --UNCHK
lin zero_A = mkWA "nolla-" ; --UNCHK
lin zero_N = mkWN (compoundN "nolla" (k48 "piste")) ; --UNCHK
lin zero_V = mkWV (k53 "kohdistaa") ; --UNCHK
lin zero_in_V = mkWV (k53 "kohdistaa") ; --UNCHK
lin zero_in_on_V2 = mkWV2 (k53 "kohdistaa") illative ; --UNCHK
lin zeroth_A = mkWA (k45 "nollas") ; --UNCHK
lin zest_N = mkWN (k1A "maku") "ryydin" ; --UNCHK
lin zestful_A = mkWA (k34A "järjetön") ; --UNCHK
lin zeta_N = mkWN "zeeta" ; --UNCHK
lin zettabit_N = mkWN (compoundN "zetta" (k5A "bitti")) ; --UNCHK
lin zettabyte_N = mkWN (compoundN "zebi" (k1 "tavu")) ; --UNCHK
lin zeugma_N = mkWN "zeugma" ; --UNCHK
lin zidovudine_N = mkWN "atsidotymidiini" ; --UNCHK
lin ziggurat_N = mkWN (compoundN "zikurat-temp" (k5 "peli")) ; --UNCHK
lin zigzag_A = mkWA "siksakkia" ; --UNCHK
lin zigzag_Adv = mkWAdv "siksakkia" ; --UNCHK
lin zigzag_N = mkWN (k5A "siksakki") ; --UNCHK
lin zigzag_V = mkWV (k67A "mutkitella") ; --UNCHK
lin zillion_A = mkWA (k99 "paljon") "valtavan" ; --UNCHK
lin zimbabwe_PN = foreignPN "Zimbabwe" ;
lin zimbabwean_A = mkWA (compoundA "zimbabwe" (k38 "lainen")) ; --UNCHK
lin zimbabwean_N = mkWN (compoundN "zimbabwe" (k38 "lainen")) ; --UNCHK
lin zinc_N = mkWN (k5A "sinkki") ; --UNCHK
lin zinfandel_N = mkWN "zinfandel" ; --UNCHK
lin zing_N = mkWN (k1 "tarmo") ; --UNCHK
lin zinger_N = mkWN (k5A "kommentti") ; --UNCHK
lin zinkenite_N = mkWN (compoundN "zinke" (k5A "niitti")) ; --UNCHK
lin zinnia_N = mkWN (compoundN "oppineiden" (k10A "kukka")) ; --UNCHK
lin zinnwaldite_N = mkWN "zinnwaldiitti" ; --UNCHK
lin zion_N = mkWN "Siion" ; --UNCHK
lin zionism_N = mkWN (k5 "sionismi") ; --UNCHK
lin zionist_A = mkWA (k38 "sionistinen") ; --UNCHK
lin zionist_N = mkWN (k5 "sionisti") ; --UNCHK
lin zip_N = mkWN (compoundN "veto" (k1 "ketju")) ; --UNCHK
lin zip_V2 = mkWV2 (k58A "sulkea") ; --UNCHK
lin zip_by_V2 = mkWV2 (k53A "ohittaa") "nopeasti" ; --UNCHK
lin zip_code_N = mkN "postinumero" ;
lin zip_fastener_N = mkWN (compoundN "veto" (k1 "ketju")) ; --UNCHK
lin zip_up_V = mkWV (k58A "sulkea") ; --UNCHK
lin zipper_N = mkWN (compoundN "veto" (k1 "ketju")) ; --UNCHK
lin zircon_N = mkWN (k6 "zirkoni") ; --UNCHK
lin zirconium_N = mkWN (k5 "zirkonium") ; --UNCHK
lin zither_N = mkWN (k9 "sitra") ; --UNCHK
lin ziti_N = mkWN (compoundN "ziti-" (k9 "pasta")) ; --UNCHK
lin zloty_N = mkN "zloty" "zlotyja" ;
lin zoanthropy_N = mkWN (compoundN "harha" (k10 "kuvitelma")) ; --UNCHK
lin zodiac_N = mkWN (compoundN "eläin" (k9A "rata")) ; --UNCHK
lin zodiacal_A = mkWA "eläinrataan" "liittyvä" ; --UNCHK
lin zoe_PN = foreignPN "Zoe" ;
lin zoic_A = mkWA (compoundA "fossiilipi" (k38 "toinen")) ; --UNCHK
lin zombie_N = mkWN (k5 "zombi") ; --UNCHK
lin zonal_A = mkWA (k38 "vyöhykkeinen") ; --UNCHK
lin zone_N = mkWN (k48A "rakenne") ; --UNCHK
lin zone_V2 = mkWV2 (k56A "jakaa") "osiin" ; --UNCHK
lin zoning_N = mkWN (k39 "kaavoitus") ; --UNCHK
lin zonk_out_V = mkWV (k53A "nukahtaa") ; --UNCHK
lin zonule_N = mkWN (k48 "alue") ; --UNCHK
lin zoo_N = mkWN (compoundN "eläin" (k9 "tarha")) ;
lin zooid_N = mkWN (k5 "organismi") ; --UNCHK
lin zoolatry_N = mkWN (compoundN "eläinten" (k9A "palvonta")) ; --UNCHK
lin zoological_A = mkA "eläintieteellinen" ;
lin zoologist_N = mkWN (k5 "zoologi") ; --UNCHK
lin zoology_N = mkWN (k12 "zoologia") ; --UNCHK
lin zoom_N = mkWN (k1 "nousu") ; --UNCHK
lin zoom_V = mkWV (k66 "nousta") ; --UNCHK
lin zoom_in_V = mkWV (k54A "lähentää") "kuvaa" ;
lin zoom_in_on_V2 = mkV2 (mkWV (k54A "lähentää") "kuvaa") (mkPrep illative) ;
lin zoom_out_V = mkWV (k54A "loitontaa") "kuvaa" ;
lin zoomastigote_N = mkWN (compoundN "siima" (k3 "eliö")) ; --UNCHK
lin zoomorphism_N = mkWN (compoundN "zoomorf" (k5 "ismi")) ; --UNCHK
lin zoonosis_N = mkWN (k5A "tauti") "zoonoottinen" ; --UNCHK
lin zoonotic_A = mkWA "zoonoottinen" ; --UNCHK
lin zoophilia_N = mkWN "zoofilia" ; --UNCHK
lin zoophobia_N = mkWN (compoundN "zoo" (k12 "fobia")) ; --UNCHK
lin zoophyte_N = mkWN (k33 "eläin") "kasvia" "muistuttava" ; --UNCHK
lin zooplankton_N = mkWN (compoundN "eläin" (k5 "plankton")) ; --UNCHK
lin zoopsia_N = mkWN (compoundN "eläin" (k3 "hallusinaatio")) ; --UNCHK
lin zoospore_N = mkWN (compoundN "parveilu" (k3 "itiö")) ; --UNCHK
lin zoril_N = mkWN (compoundN "fre" (k9A "nata")) "Ictonyx" ; --UNCHK
lin zoysia_N = mkWN (compoundN "zoysia-" (k1 "ruoho")) ; --UNCHK
lin zucchini_N = mkWN (compoundN "kesä" (k13 "kurpitsa")) ; --UNCHK
lin zurich_PN = mkPN "Zürich" ;
lin zwieback_N = mkWN (k1A "korppu") ; --UNCHK
lin zydeco_N = mkWN (compoundN "zydeco" (k5A "musiikki")) ; --UNCHK
lin zygodactyl_A = mkWA "syndaktylia" ; --UNCHK
lin zygoma_N = mkWN (compoundN "poski" (k18 "luu")) ; --UNCHK
lin zygomatic_A = mkWA "poski-" ; --UNCHK
lin zygomorphic_A = mkWA (k38 "symmetrinen") "bilateraalisesti" ; --UNCHK
lin zygospore_N = mkWN (k3 "itiö") ; --UNCHK
lin zygote_N = mkWN (k5A "tsygootti") ; --UNCHK
lin zygotene_N = mkWN "tsygoteeni" ; --UNCHK
lin zygotic_A = mkWA (compoundA "tsygootti" (k38 "nen")) ; --UNCHK
lin zymase_N = mkWN (compoundN "tsym" (k5 "aasi")) ; --UNCHK
lin zymoid_A = mkWA (compoundA "muis" (k10 "tuttava")) "entsyymiä" ; --UNCHK
lin zymology_N = mkWN "tsymologia" ; --UNCHK
lin zymosis_N = mkWN "tsymoosi" ; --UNCHK
lin zymotic_A = mkWA "tsymoosiin" "liittyvä" ; --UNCHK
lin äetsä_PN = mkPN "Äetsä" ;
lin ähtäri_PN = mkPN (mkN "Ähtäri" "Ähtäriä") ;
lin äänekoski_PN = mkPN (mkN "Äänekoski" "Äänekoskia") ;
oper prepV2 : V -> Prep -> V2 = \v,p -> mkV2 v p ;
oper advV : V -> Adv -> V = \v,a -> mkV v a.s ;
oper OP_by_Prep : Prep = postPrep genitive "kautta" ;
oper OP_for_Prep : Prep = S.for_Prep ;
oper OP_on_Prep : Prep = mkPrep adessive | mkPrep "päällä" | mkPrep "päälle" ;
oper OP_out_Prep : Prep = mkPrep "ulos" elative ;
oper OP_upon_Prep : Prep = mkPrep "päällä" ;
oper OP_up_Prep : Prep = mkPrep "ylös" partitive ;
oper OP_to_Prep : Prep = mkPrep illative | mkPrep allative | mkPrep translative ; ---- | luokse_Prep | luokse_Prep ** {s = luokse_Prep.s ** {p2 = "luo"}} | mkPrep "tykö" ; ---- adding these makes the first variants, which is not good
oper OP_with_Prep : Prep = mkPrep "kanssa" | mkPrep "luona" | mkPrep "tykönä" ; ---- split
oper OP_at_Prep : Prep = casePrep adessive | casePrep inessive ; ---- | mkPrep "luona" | mkPrep "tykönä" ; ---- split
oper OP_of_Prep : Prep = casePrep genitive ; ---
oper OP_down_Prep : Prep = mkPrep "alas" partitive ;
oper OP_about_Prep : Prep = casePrep elative ;
oper OP_after_Prep : Prep = S.after_Prep ;
oper OP_around_Prep : Prep = mkPrep "ympärillä" ;
oper OP_in_Prep : Prep = S.in_Prep ;
oper OP_over_Prep : Prep = postPrep genitive "yli" ;
oper OP_round_Prep : Prep = mkPrep "ympärillä" ;
oper OP_off_Prep : Prep = mkPrep "ulkopuolella" ;
oper OP_into_Prep : Prep = casePrep illative | mkPrep "sisään" | mkPrep "sisälle" ;
oper OP_under_Prep : Prep = S.under_Prep ;
oper OP_through_Prep : Prep = S.through_Prep ;
oper OP_along_Prep : Prep = mkPrep "pitkin" ;
oper OP_across_Prep : Prep = mkPrep "poikki" ;
oper OP_before_Prep : Prep = S.before_Prep ;
oper OP_from_Prep : Prep = casePrep elative | casePrep ablative | mkPrep "luota" | mkPrep "tyköä" ; ---- split
oper OP_against_Prep : Prep = postPrep partitive "vastaan" ;
oper OP_among_Prep : Prep = postPrep genitive "joukossa" ;
oper OP_towards_Prep : Prep = mkPrep partitive "kohti" ;
oper OP_as_Prep : Prep = casePrep essive ;
oper OP_onto_Prep : Prep = mkPrep "päälle" ;
oper OP_above_Prep : Prep = S.above_Prep ;
oper OP_behind_Prep : Prep = S.behind_Prep ;
oper OP_past_Prep : Prep = mkPrep "ohi" ;
oper OP_without_Prep : Prep = S.without_Prep ;
oper OP_toward_Prep : Prep = mkPrep partitive "kohti" ;
oper OP_up_Adv : Adv = mkAdv "ylös" | mkAdv "ylhäällä" ;
oper OP_in_Adv : Adv = mkAdv "sisällä" ;
oper OP_on_Adv : Adv = mkAdv "päällä" ;
oper OP_back_Adv : Adv = mkAdv "takaisin" ;
oper OP_around_Adv : Adv = mkAdv "suunnilleen" | mkAdv "lähes" ;
oper OP_away_Adv : Adv = mkAdv "poissa" ;
oper OP_down_Adv : Adv = mkAdv "alhaalla" | mkAdv "alas" ;
oper OP_off_Adv : Adv = mkAdv "pois" ;
oper OP_out_Adv : Adv = mkWAdv (k99 "ulkona") ;
oper OP_about_Adv : Adv = mkAdv "suunnilleen" ;
oper OP_over_Adv : Adv = mkAdv "ohi" | mkAdv "yli" ; ---- split
oper OP_apart_Adv : Adv = mkAdv "erillään" | mkAdv "erikseen" | mkAdv "syrjässä" | mkAdv "syrjään" ; ---- split
oper OP_along_Adv : Adv = mkAdv "mukana" | mkAdv "mukaan" ; ---- split be along ; go along
oper OP_forth_Adv : Adv = mkWAdv (k99 "esiin") ;
oper OP_forward_Adv : Adv = mkAdv "eteenpäin" | mkAdv "edelleen" ;
oper OP_aside_Adv : Adv = mkWAdv (k99 "syrjään") ; --UNCHK
oper OP_under_Adv : Adv = mkWAdv (k99 "tuonnempana") ; --UNCHK
oper OP_round_Adv : Adv = mkAdv "ympäri" ;
oper OP_together_Adv : Adv = mkAdv "yhdessä" ;
oper OP_across_Adv : Adv = mkWAdv (k99 "ristiin") ; --UNCHK
oper OP_by_Adv : Adv = mkWAdv (k99 "talteen") ; --UNCHK
oper OP_through_Adv : Adv = mkAdv "läpi" ;
oper OP_to_Adv : Adv = mkAdv "luo" ; ---- what is this?
oper OP_even_Adv : Adv = mkAdv "jopa" ;
oper OP_clean_Adv : Adv = mkWAdv (k99 "täysin") ; --UNCHK
oper OP_behind_Adv : Adv = mkWAdv (k99 "takana") ; --UNCHK
oper OP_ahead_Adv : Adv = mkWAdv (k99 "edellä") ;
oper OP_way_Adv : Adv = mkWAdv (k99 "paljon") ; --UNCHK
oper OP_before_Adv : Adv = mkAdv "ennen" ;
oper OP_below_Adv : Adv = mkAdv "alapuolella" ;
oper OP_for_Adv : Adv = variants {} ; -- S.for_Prep ;
oper OP_open_Adv : Adv = variants {} ; --
oper OP_after_Adv : Adv = mkWAdv (k99 "sittemmin") ; --UNCHK
oper OP_clear_Adv : Adv = mkAdv "selvästi" ;
oper OP_account_V : V = mkWV (k73 "vastata") ; --f163
oper OP_act_V : V = mkV "toimia" | mkV "käyttäytyä" ;
oper OP_add_V : V = mkV "lisätä" ;
oper OP_agree_V : V = mkV olla_V "samaa mieltä" ;
oper OP_aim_V : V = mkV "tähdätä" ;
oper OP_answer_V : V = mkV "vastata" ;
oper OP_apply_V : V = mkV "soveltua" ;
oper OP_argue_V : V = mkV "riidellä" | mkV "kiistellä" ;
oper OP_ask_V : V = mkV "kysyä" ;
oper OP_back_V : V = mkWV (k52A "perääntyä") ;
oper OP_bear_V : V = mkV "kantaa" ;
oper OP_beat_V : V = mkWV (k52A "takoa") ;
oper OP_bend_V : V = mkWV (k54A "vääntää") "mutkalle" ; --UNCHK
oper OP_blow_V : V = L.blow_V ;
oper OP_break_V : V = mkV "murtua" ;
oper OP_build_V : V = mkV "rakentaa" ;
oper OP_burn_V : V = L.burn_V ;
oper OP_burst_V : V = mkWV (k53A "syöksähtää") ; --UNCHK
oper OP_buy_V : V = mkV "ostaa" ;
oper OP_call_V : V = mkV "soittaa" ; --mkV "kutsua" ;
oper OP_care_V : V = mkV "välittää" ;
oper OP_carry_V : V = mkV "kantaa" ;
oper OP_cast_V : V = mkV (mkV "saada") "rooli" ; ---ARB --mkV (mkV "antaa") "ääni") ; --mkWV (k53A "heittää") "laattaa" ;
oper OP_change_V : V = mkV "muuttua" ;
oper OP_charge_V : V = mkV "latautua" ;
oper OP_check_V : V = mkV "tarkastaa" ; ---- subcat
oper OP_clean_V : V = mkWV (k53 "puhdistaa") ; --UNCHK
oper OP_clear_V : V = mkV "selkeytyä" ;
oper OP_climb_V : V = mkWV (k74A "kiivetä") ; --f63
oper OP_close_V : V = mkV "sulkea" ;
oper OP_come_V : V = L.come_V ;
oper OP_continue_V : V = mkV "jatkua" ;
oper OP_cost_V : V = mkWV (k56 "maksaa") ;
oper OP_count_V : V = mkWV (k53A "ottaa") "lukuun" ;
oper OP_crash_V : V = mkWV (k52A "nukkua") ; --UNCHK
oper OP_cross_V : V = mkWV (k53A "risteyttää") ; --UNCHK
oper OP_cry_V : V = mkWV (k61A "kyynelehtiä") ; --UNCHK
oper OP_cut_V : V = mkV "leikata" ;
oper OP_decide_V : V = mkV "päättää" ;
oper OP_die_V : V = L.die_V ;
oper OP_dig_V : V = L.dig_V ;
oper OP_divide_V : V = mkV "jakautua" ; --WV (k56A "jakaa") ;
oper OP_double_V : V = mkWV (k52 "kaksinkertaistua") ;
oper OP_drag_V : V = mkWV (k52A "pitkittyä") ; --UNCHK
oper OP_draw_V : V = mkV "vetää" ;
oper OP_dream_V : V = mkWV (k67 "haaveilla") ;
oper OP_dress_V : V = mkV "pukeutua" ;
oper OP_drink_V : V = mkV "juoda" ;
oper OP_drive_V : V = mkV "ajaa" ;
oper OP_drop_V : V = mkV "pudota" ;
oper OP_dry_V : V = mkWV (k53A "kuivattaa") ; --UNCHK
oper OP_ease_V : V = mkV "lievittyä" ; --f55
oper OP_eat_V : V = mkV "syödä" ;
oper OP_end_V : V = mkV "loppua" ;
oper OP_enter_V : V = mkV L.go_V "sisään" ;
oper OP_face_V : V = mkV "kohdata" ;
oper OP_fall_V : V = mkV "pudota" ;
oper OP_feed_V : V = mkWV (k53A "syöttää") ; --UNCHK
oper OP_feel_V : V = mkV "tuntea" ;
oper OP_fight_V : V = mkWV (k67 "taistella") ;
oper OP_figure_V : V = mkV "kuvitella" ;
oper OP_file_V : V = mkV "arkistoida" ;
oper OP_fill_V : V = mkV "täyttyä" ;
oper OP_find_V : V = mkV "löytää" "löysi" ;
oper OP_finish_V : V = mkWV (k53A "lopettaa") ;
oper OP_fire_V : V = mkWV (k53A "polttaa") ; --UNCHK
oper OP_fit_V : V = mkV "sopia" | mkV "mahtua" ;
oper OP_fix_V : V = mkV "kiinnittää" ;
oper OP_fly_V : V = L.fly_V ;
oper OP_focus_V : V = mkV "keskittyä" ;
oper OP_follow_V : V = mkV "seurata" ;
oper OP_force_V : V = mkV "pakottaa" ;
oper OP_gain_V : V = mkV "voittaa" ;
oper OP_give_V : V = mkV "antaa" ;
oper OP_go_V : V = L.go_V ;
oper OP_grow_V : V = mkV "kasvaa" ;
oper OP_hang_V : V = mkV "riippua" | mkV "roikkua" ;
oper OP_have_V : V = lin V S.have_V2 ;
oper OP_head_V : V = mkV "johtaa" ; --f60
oper OP_hear_V : V = mkV "kuulla" ;
oper OP_help_V : V = mkV "auttaa" ;
oper OP_hide_V : V = mkV "piiloutua" ;
oper OP_hit_V : V = mkWV (k58 "iskeä") ;
oper OP_hold_V : V = mkV "pitää" ;
oper OP_issue_V : V = mkWV (k67 "tulla") "esiin" ; ---- sense
oper OP_join_V : V = mkV (mkV "tulla") "mukaan" ;
oper OP_jump_V : V = L.jump_V ;
oper OP_keep_V : V = mkV "pysyä" ;
oper OP_kick_V : V = mkV "potkia" ;
oper OP_kill_V : V = mkV "tappaa" ;
oper OP_knock_V : V = mkV "koputtaa" ; ---ARB mkWV (k61A "moittia") ;
oper OP_land_V : V = mkV "laskeutua" ;
oper OP_laugh_V : V = L.laugh_V ;
oper OP_lay_V : V = mkV "panna" ;
oper OP_lead_V : V = mkV "johtaa" ;
oper OP_lean_V : V = mkV "nojata" ;
oper OP_leave_V : V = mkV "lähteä" ;
oper OP_lie_V : V = L.lie_V ;
oper OP_lift_V : V = mkV "nostaa" ;
oper OP_light_V : V = mkWV (k66 "valaista") ; --UNCHK
oper OP_link_V : V = mkV "yhdistää" ;
oper OP_listen_V : V = mkWV (k67A "kuunnella") ;
oper OP_live_V : V = L.live_V ;
oper OP_lock_V : V = mkV "lukita" ;
oper OP_look_V : V = mkV "katsoa" ;
oper OP_lose_V : V = mkV "hävitä" ;
oper OP_make_V : V = tehda_V ;
oper OP_marry_V : V = mkV L.go_V "naimisiin" | mkV "avioitua" ;
oper OP_measure_V : V = mkWV (k73A "mitata") ; --UNCHK
oper OP_meet_V : V = mkV "kokoontua" ;
oper OP_miss_V : V = mkV "puuttua" ;
oper OP_mix_V : V = mkWV (k53A "sekoittaa") ; 
oper OP_mount_V : V = mkWV (k54A "asentaa") ; 
oper OP_move_V : V = mkV "liikkua" ;
oper OP_nod_V : V = mkV "nyökätä" ;
oper OP_note_V : V = mkWV (k73 "huomata") ; 
oper OP_occur_V : V = mkV "käydä" ;
oper OP_open_V : V = mkV "aueta" "aukesi" ;
oper OP_operate_V : V = mkV "operoida" | mkV "toimia" ;
oper OP_pack_V : V = mkV "täyttyä" ; --mkWV (k61 "kääriä") ;
oper OP_pass_V : V = mkV (mkV "päästä") "läpi" ;
oper OP_pay_V : V = mkV "kannattaa" ;
oper OP_pick_V : V = mkV "poimia" | mkV "kerätä" ;
oper OP_play_V : V = mkV "pelata" ;
oper OP_point_V : V = mkV "osoittaa" ;
oper OP_pour_V : V = mkV "kaataa" ;
oper OP_press_V : V = mkV "painostaa" ;
oper OP_print_V : V = mkWV (k66 "julkaista") ;
oper OP_pull_V : V = mkV "vetää" ;
oper OP_push_V : V = mkV "työntää" ;
oper OP_race_V : V = mkV "kilpailla" ;
oper OP_reach_V : V = mkV "saavuttaa" ;
oper OP_read_V : V = mkV "lukea" ;
oper OP_rely_V : V = mkWV (k53A "luottaa") ; --f52
oper OP_report_V : V = mkV "raportoida" ;
oper OP_ride_V : V = mkV "ratsastaa" ;
oper OP_ring_V : V = mkV "soida" ;
oper OP_roll_V : V = mkWV (k61 "kieriä") ;
oper OP_rule_V : V = mkWV (k69 "hallita") ; --f54
oper OP_run_V : V = L.run_V ;
oper OP_rush_V : V = mkV "kiirehtiä" ; --WV (k53A "hoputtaa") ;
oper OP_sail_V : V = mkV "purjehtia" ;
oper OP_save_V : V = mkV "säästää" ;
oper OP_see_V : V = nahda_V ;
oper OP_seize_V : V = mkV "siepata" ;
oper OP_sell_V : V = mkV "myydä" ;
oper OP_send_V : V = mkV "lähettää" ;
oper OP_settle_V : V = mkV "asettua" ;
oper OP_shake_V : V = mkV "vavista" ;
oper OP_shape_V : V = mkV "muovautua" ;
oper OP_share_V : V = mkWV (k56A "jakaa") ;
oper OP_shoot_V : V = mkV "ampua" ;
oper OP_shout_V : V = mkV "huutaa" ;
oper OP_show_V : V = mkV "näyttää" ;
oper OP_sign_V : V = mkV "allekirjoittaa" ;
oper OP_sing_V : V = L.sing_V ;
oper OP_sink_V : V = mkV "upota" ;
oper OP_sit_V : V = L.sit_V ;
oper OP_sleep_V : V = L.sleep_V ;
oper OP_slip_V : V = mkV "luisua" ; --f52
oper OP_smoke_V : V = mkWV (k68 "tupakoida") ;
oper OP_snap_V : V = mkWV (k67 "rakoilla") ; --UNCHK
oper OP_sort_V : V = mkV "ryhmittyä" ; --mkWV (k53A "ryhmittää") ;
oper OP_sound_V : V = mkV "soida" ;
oper OP_speak_V : V = mkV "puhua" ;
oper OP_split_V : V = mkV "haljeta" ;
oper OP_spread_V : V = mkWV (k75 "levitä") ;
oper OP_stand_V : V = L.stand_V ;
oper OP_start_V : V = mkV "aloittaa" ;
oper OP_stay_V : V = mkV "jäädä" | mkV "pysyä" ;
oper OP_steal_V : V = mkV "varastaa" ;
oper OP_step_V : V = mkV (lin VK {s = c52 "astua"}) ;
oper OP_stick_V : V = mkV "pistää" ; ----mkWV (k53A "sekoittaa") ;
oper OP_stir_V : V = mkV "sekoittaa" ;
oper OP_stop_V : V = L.stop_V ;
oper OP_stretch_V : V = mkWV (k67A "venytellä") ; 
oper OP_strike_V : V = mkV "iskeä" ;
oper OP_struggle_V : V = mkV "kamppailla" ;
oper OP_suit_V : V = mkV "sopia" ;
oper OP_sweep_V : V = mkV "pyyhkäistä" ;
oper OP_swing_V : V = mkV "keinua" ;
oper OP_switch_V : V = mkV "vaihtaa" ;
oper OP_talk_V : V = mkV "puhua" ;
oper OP_tap_V : V = mkV (mkV "päästä") "käsiksi" ; ---ARB --mkWV (k73 "kerjätä") ;
oper OP_tear_V : V = mkV "repeytyä" ;
oper OP_tell_V : V = mkV "kertoa" ;
oper OP_think_V : V = L.think_V ;
oper OP_throw_V : V = mkV "heittää" ;
oper OP_tie_V : V = mkWV (k61 "solmia") ;
oper OP_touch_V : V = mkV "koskea" ;
oper OP_trade_V : V = mkV (lin VK {s = c73A "kaupata"}) ;
oper OP_train_V : V = mkWV (k67A "harjoitella") ;
oper OP_try_V : V = mkV "kokeilla" ;
oper OP_turn_V : V = L.turn_V ;
oper OP_use_V : V = mkV "käyttää" ;
oper OP_vote_V : V = mkWV (k53 "äänestää") ; 
oper OP_wait_V : V = mkV "odottaa" ;
oper OP_wake_V : V = mkV "herättää" ;
oper OP_walk_V : V = L.walk_V ;
oper OP_wander_V : V = mkV "vaeltaa" ;
oper OP_want_V : V = mkWV (k75 "haluta") ;
oper OP_wash_V : V = mkV "peseytyä" ;
oper OP_waste_V : V = mkV "haaskata" ;
oper OP_watch_V : V = mkV "katsella" ;
oper OP_wave_V : V = mkV "aaltoilla" ; --mkWV (k53A "taivuttaa") ;
oper OP_wear_V : V = mkV "kulua" ;
oper OP_win_V : V = mkV "voittaa" ;
oper OP_wind_V : V = mkV "kiertää" ;
oper OP_wipe_V : V = mkWV (k66 "pyyhkäistä") ;
oper OP_work_V : V = mkV "työskennellä" ;
oper OP_write_V : V = mkWV (k53A "kirjoittaa") ;
oper OP_allow_V2 : V2 = mkV2 "hyväksyä" | mkV2 "sallia" ;
oper OP_block_V2 : V2 = mkV2 "salvata" ;
oper OP_bring_V2 : V2 = mkV2 "tuoda" ;
oper OP_catch_V2 : V2 = mkV2 (mkV (mkV "saada") "kiinni") | mkV2 (mkV (mkV "ottaa") "kiinni") ;
oper OP_choose_V2 : V2 = mkV2 "valita" ;
oper OP_cover_V2 : V2 = mkV2 "peittää" ;
oper OP_explain_V2 : V2 = mkV2 "selittää" ;
oper OP_free_V2 : V2 = mkWV2 (k53A "vapauttaa") ; 
oper OP_frighten_V2 : V2 = mkV2 "pelotella" partitive ;
oper OP_get_V2 : V2 = mkV2 (mkV "saada") ;
oper OP_hand_V2 : V2 = mkV2 "ojentaa" ;
oper OP_hate_V2 : V2 = L.hate_V2 ;
oper OP_invite_V2 : V2 = mkV2 "kutsua" ;
oper OP_kiss_V2 : V2 = mkV2 (mkV "suudella") partitive ;
oper OP_mark_V2 : V2 = mkWV2 (k53A "merkitä") ;
oper OP_match_V2 : V2 = mkV2 (mkV "vastata") (casePrep partitive) ;
oper OP_offer_V2 : V2 = mkV2 (mkV "tarjota") ;
oper OP_own_V2 : V2 = mkV2 "omistaa" ;
oper OP_plant_V2 : V2 = mkV2 "istuttaa" ;
oper OP_put_V2 : V2 = L.put_V2 ;
oper OP_seek_V2 : V2 = L.seek_V2 ;
oper OP_set_V2 : V2 = mkV2 "asettaa" ;
oper OP_shrug_V2 : V2 = mkV2 "kohauttaa" ;
oper OP_shut_V2 : V2 = mkV2 "sulkea" ;
oper OP_take_V2 : V2 = mkV2 "ottaa" ;
oper OP_urge_V2 : V2 = mkWV2 (k53 "ahdistaa") ;
}
